// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.7.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __NSECONTINUITY_H
#define __NSECONTINUITY_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace NSEContinuity {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm() : dolfin::BilinearForm(0)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_0_0 = det*(g00*g00 + g01*g01 + g02*g02);
    real G0_0_1 = det*(g00*g10 + g01*g11 + g02*g12);
    real G0_0_2 = det*(g00*g20 + g01*g21 + g02*g22);
    real G0_1_0 = det*(g10*g00 + g11*g01 + g12*g02);
    real G0_1_1 = det*(g10*g10 + g11*g11 + g12*g12);
    real G0_1_2 = det*(g10*g20 + g11*g21 + g12*g22);
    real G0_2_0 = det*(g20*g00 + g21*g01 + g22*g02);
    real G0_2_1 = det*(g20*g10 + g21*g11 + g22*g12);
    real G0_2_2 = det*(g20*g20 + g21*g21 + g22*g22);

    // Compute element tensor
    block[0] = 1.666666666666664e-01*G0_0_0 + 1.666666666666664e-01*G0_0_1 + 1.666666666666664e-01*G0_0_2 + 1.666666666666664e-01*G0_1_0 + 1.666666666666665e-01*G0_1_1 + 1.666666666666665e-01*G0_1_2 + 1.666666666666664e-01*G0_2_0 + 1.666666666666665e-01*G0_2_1 + 1.666666666666665e-01*G0_2_2;
    block[1] = -1.666666666666664e-01*G0_0_0 - 1.666666666666664e-01*G0_1_0 - 1.666666666666664e-01*G0_2_0;
    block[2] = -1.666666666666664e-01*G0_0_1 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_2_1;
    block[3] = -1.666666666666664e-01*G0_0_2 - 1.666666666666665e-01*G0_1_2 - 1.666666666666665e-01*G0_2_2;
    block[4] = -1.666666666666664e-01*G0_0_0 - 1.666666666666664e-01*G0_0_1 - 1.666666666666664e-01*G0_0_2;
    block[5] = 1.666666666666664e-01*G0_0_0;
    block[6] = 1.666666666666664e-01*G0_0_1;
    block[7] = 1.666666666666664e-01*G0_0_2;
    block[8] = -1.666666666666664e-01*G0_1_0 - 1.666666666666665e-01*G0_1_1 - 1.666666666666665e-01*G0_1_2;
    block[9] = 1.666666666666664e-01*G0_1_0;
    block[10] = 1.666666666666665e-01*G0_1_1;
    block[11] = 1.666666666666665e-01*G0_1_2;
    block[12] = -1.666666666666664e-01*G0_2_0 - 1.666666666666665e-01*G0_2_1 - 1.666666666666665e-01*G0_2_2;
    block[13] = 1.666666666666664e-01*G0_2_0;
    block[14] = 1.666666666666665e-01*G0_2_1;
    block[15] = 1.666666666666665e-01*G0_2_2;

    return true;
  }

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0, Function& w1, const real& c0) : dolfin::LinearForm(2), c0(c0)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_0_0_0 = det*w[1][0]*g00;
    real G0_0_0_1 = det*w[1][1]*g00;
    real G0_0_0_2 = det*w[1][2]*g00;
    real G0_0_0_3 = det*w[1][3]*g00;
    real G0_0_1_0 = det*w[1][0]*g10;
    real G0_0_1_1 = det*w[1][1]*g10;
    real G0_0_1_2 = det*w[1][2]*g10;
    real G0_0_1_3 = det*w[1][3]*g10;
    real G0_0_2_0 = det*w[1][0]*g20;
    real G0_0_2_1 = det*w[1][1]*g20;
    real G0_0_2_2 = det*w[1][2]*g20;
    real G0_0_2_3 = det*w[1][3]*g20;
    real G0_1_0_4 = det*w[1][4]*g01;
    real G0_1_0_5 = det*w[1][5]*g01;
    real G0_1_0_6 = det*w[1][6]*g01;
    real G0_1_0_7 = det*w[1][7]*g01;
    real G0_1_1_4 = det*w[1][4]*g11;
    real G0_1_1_5 = det*w[1][5]*g11;
    real G0_1_1_6 = det*w[1][6]*g11;
    real G0_1_1_7 = det*w[1][7]*g11;
    real G0_1_2_4 = det*w[1][4]*g21;
    real G0_1_2_5 = det*w[1][5]*g21;
    real G0_1_2_6 = det*w[1][6]*g21;
    real G0_1_2_7 = det*w[1][7]*g21;
    real G0_2_0_8 = det*w[1][8]*g02;
    real G0_2_0_9 = det*w[1][9]*g02;
    real G0_2_0_10 = det*w[1][10]*g02;
    real G0_2_0_11 = det*w[1][11]*g02;
    real G0_2_1_8 = det*w[1][8]*g12;
    real G0_2_1_9 = det*w[1][9]*g12;
    real G0_2_1_10 = det*w[1][10]*g12;
    real G0_2_1_11 = det*w[1][11]*g12;
    real G0_2_2_8 = det*w[1][8]*g22;
    real G0_2_2_9 = det*w[1][9]*g22;
    real G0_2_2_10 = det*w[1][10]*g22;
    real G0_2_2_11 = det*w[1][11]*g22;
    real G1_0_0_0_0_0_0 = det*w[0][0]*w[0][0]*g00*g00;
    real G1_0_0_0_0_0_1 = det*w[0][0]*w[0][0]*g00*g10;
    real G1_0_0_0_0_0_2 = det*w[0][0]*w[0][0]*g00*g20;
    real G1_0_0_0_0_1_0 = det*w[0][0]*w[0][1]*g00*g00;
    real G1_0_0_0_0_2_1 = det*w[0][0]*w[0][2]*g00*g10;
    real G1_0_0_0_0_3_2 = det*w[0][0]*w[0][3]*g00*g20;
    real G1_0_0_0_1_0_0 = det*w[0][1]*w[0][0]*g00*g00;
    real G1_0_0_0_1_0_1 = det*w[0][1]*w[0][0]*g00*g10;
    real G1_0_0_0_1_0_2 = det*w[0][1]*w[0][0]*g00*g20;
    real G1_0_0_0_1_1_0 = det*w[0][1]*w[0][1]*g00*g00;
    real G1_0_0_0_1_2_1 = det*w[0][1]*w[0][2]*g00*g10;
    real G1_0_0_0_1_3_2 = det*w[0][1]*w[0][3]*g00*g20;
    real G1_0_0_0_2_0_0 = det*w[0][2]*w[0][0]*g00*g00;
    real G1_0_0_0_2_0_1 = det*w[0][2]*w[0][0]*g00*g10;
    real G1_0_0_0_2_0_2 = det*w[0][2]*w[0][0]*g00*g20;
    real G1_0_0_0_2_1_0 = det*w[0][2]*w[0][1]*g00*g00;
    real G1_0_0_0_2_2_1 = det*w[0][2]*w[0][2]*g00*g10;
    real G1_0_0_0_2_3_2 = det*w[0][2]*w[0][3]*g00*g20;
    real G1_0_0_0_3_0_0 = det*w[0][3]*w[0][0]*g00*g00;
    real G1_0_0_0_3_0_1 = det*w[0][3]*w[0][0]*g00*g10;
    real G1_0_0_0_3_0_2 = det*w[0][3]*w[0][0]*g00*g20;
    real G1_0_0_0_3_1_0 = det*w[0][3]*w[0][1]*g00*g00;
    real G1_0_0_0_3_2_1 = det*w[0][3]*w[0][2]*g00*g10;
    real G1_0_0_0_3_3_2 = det*w[0][3]*w[0][3]*g00*g20;
    real G1_0_0_1_0_0_0 = det*w[0][0]*w[0][0]*g10*g00;
    real G1_0_0_1_0_0_1 = det*w[0][0]*w[0][0]*g10*g10;
    real G1_0_0_1_0_0_2 = det*w[0][0]*w[0][0]*g10*g20;
    real G1_0_0_1_0_1_0 = det*w[0][0]*w[0][1]*g10*g00;
    real G1_0_0_1_0_2_1 = det*w[0][0]*w[0][2]*g10*g10;
    real G1_0_0_1_0_3_2 = det*w[0][0]*w[0][3]*g10*g20;
    real G1_0_0_1_1_0_0 = det*w[0][1]*w[0][0]*g10*g00;
    real G1_0_0_1_1_0_1 = det*w[0][1]*w[0][0]*g10*g10;
    real G1_0_0_1_1_0_2 = det*w[0][1]*w[0][0]*g10*g20;
    real G1_0_0_1_1_1_0 = det*w[0][1]*w[0][1]*g10*g00;
    real G1_0_0_1_1_2_1 = det*w[0][1]*w[0][2]*g10*g10;
    real G1_0_0_1_1_3_2 = det*w[0][1]*w[0][3]*g10*g20;
    real G1_0_0_1_2_0_0 = det*w[0][2]*w[0][0]*g10*g00;
    real G1_0_0_1_2_0_1 = det*w[0][2]*w[0][0]*g10*g10;
    real G1_0_0_1_2_0_2 = det*w[0][2]*w[0][0]*g10*g20;
    real G1_0_0_1_2_1_0 = det*w[0][2]*w[0][1]*g10*g00;
    real G1_0_0_1_2_2_1 = det*w[0][2]*w[0][2]*g10*g10;
    real G1_0_0_1_2_3_2 = det*w[0][2]*w[0][3]*g10*g20;
    real G1_0_0_1_3_0_0 = det*w[0][3]*w[0][0]*g10*g00;
    real G1_0_0_1_3_0_1 = det*w[0][3]*w[0][0]*g10*g10;
    real G1_0_0_1_3_0_2 = det*w[0][3]*w[0][0]*g10*g20;
    real G1_0_0_1_3_1_0 = det*w[0][3]*w[0][1]*g10*g00;
    real G1_0_0_1_3_2_1 = det*w[0][3]*w[0][2]*g10*g10;
    real G1_0_0_1_3_3_2 = det*w[0][3]*w[0][3]*g10*g20;
    real G1_0_0_2_0_0_0 = det*w[0][0]*w[0][0]*g20*g00;
    real G1_0_0_2_0_0_1 = det*w[0][0]*w[0][0]*g20*g10;
    real G1_0_0_2_0_0_2 = det*w[0][0]*w[0][0]*g20*g20;
    real G1_0_0_2_0_1_0 = det*w[0][0]*w[0][1]*g20*g00;
    real G1_0_0_2_0_2_1 = det*w[0][0]*w[0][2]*g20*g10;
    real G1_0_0_2_0_3_2 = det*w[0][0]*w[0][3]*g20*g20;
    real G1_0_0_2_1_0_0 = det*w[0][1]*w[0][0]*g20*g00;
    real G1_0_0_2_1_0_1 = det*w[0][1]*w[0][0]*g20*g10;
    real G1_0_0_2_1_0_2 = det*w[0][1]*w[0][0]*g20*g20;
    real G1_0_0_2_1_1_0 = det*w[0][1]*w[0][1]*g20*g00;
    real G1_0_0_2_1_2_1 = det*w[0][1]*w[0][2]*g20*g10;
    real G1_0_0_2_1_3_2 = det*w[0][1]*w[0][3]*g20*g20;
    real G1_0_0_2_2_0_0 = det*w[0][2]*w[0][0]*g20*g00;
    real G1_0_0_2_2_0_1 = det*w[0][2]*w[0][0]*g20*g10;
    real G1_0_0_2_2_0_2 = det*w[0][2]*w[0][0]*g20*g20;
    real G1_0_0_2_2_1_0 = det*w[0][2]*w[0][1]*g20*g00;
    real G1_0_0_2_2_2_1 = det*w[0][2]*w[0][2]*g20*g10;
    real G1_0_0_2_2_3_2 = det*w[0][2]*w[0][3]*g20*g20;
    real G1_0_0_2_3_0_0 = det*w[0][3]*w[0][0]*g20*g00;
    real G1_0_0_2_3_0_1 = det*w[0][3]*w[0][0]*g20*g10;
    real G1_0_0_2_3_0_2 = det*w[0][3]*w[0][0]*g20*g20;
    real G1_0_0_2_3_1_0 = det*w[0][3]*w[0][1]*g20*g00;
    real G1_0_0_2_3_2_1 = det*w[0][3]*w[0][2]*g20*g10;
    real G1_0_0_2_3_3_2 = det*w[0][3]*w[0][3]*g20*g20;
    real G1_0_1_0_4_0_0 = det*w[0][4]*w[0][0]*g00*g01;
    real G1_0_1_0_4_0_1 = det*w[0][4]*w[0][0]*g00*g11;
    real G1_0_1_0_4_0_2 = det*w[0][4]*w[0][0]*g00*g21;
    real G1_0_1_0_4_1_0 = det*w[0][4]*w[0][1]*g00*g01;
    real G1_0_1_0_4_2_1 = det*w[0][4]*w[0][2]*g00*g11;
    real G1_0_1_0_4_3_2 = det*w[0][4]*w[0][3]*g00*g21;
    real G1_0_1_0_5_0_0 = det*w[0][5]*w[0][0]*g00*g01;
    real G1_0_1_0_5_0_1 = det*w[0][5]*w[0][0]*g00*g11;
    real G1_0_1_0_5_0_2 = det*w[0][5]*w[0][0]*g00*g21;
    real G1_0_1_0_5_1_0 = det*w[0][5]*w[0][1]*g00*g01;
    real G1_0_1_0_5_2_1 = det*w[0][5]*w[0][2]*g00*g11;
    real G1_0_1_0_5_3_2 = det*w[0][5]*w[0][3]*g00*g21;
    real G1_0_1_0_6_0_0 = det*w[0][6]*w[0][0]*g00*g01;
    real G1_0_1_0_6_0_1 = det*w[0][6]*w[0][0]*g00*g11;
    real G1_0_1_0_6_0_2 = det*w[0][6]*w[0][0]*g00*g21;
    real G1_0_1_0_6_1_0 = det*w[0][6]*w[0][1]*g00*g01;
    real G1_0_1_0_6_2_1 = det*w[0][6]*w[0][2]*g00*g11;
    real G1_0_1_0_6_3_2 = det*w[0][6]*w[0][3]*g00*g21;
    real G1_0_1_0_7_0_0 = det*w[0][7]*w[0][0]*g00*g01;
    real G1_0_1_0_7_0_1 = det*w[0][7]*w[0][0]*g00*g11;
    real G1_0_1_0_7_0_2 = det*w[0][7]*w[0][0]*g00*g21;
    real G1_0_1_0_7_1_0 = det*w[0][7]*w[0][1]*g00*g01;
    real G1_0_1_0_7_2_1 = det*w[0][7]*w[0][2]*g00*g11;
    real G1_0_1_0_7_3_2 = det*w[0][7]*w[0][3]*g00*g21;
    real G1_0_1_1_4_0_0 = det*w[0][4]*w[0][0]*g10*g01;
    real G1_0_1_1_4_0_1 = det*w[0][4]*w[0][0]*g10*g11;
    real G1_0_1_1_4_0_2 = det*w[0][4]*w[0][0]*g10*g21;
    real G1_0_1_1_4_1_0 = det*w[0][4]*w[0][1]*g10*g01;
    real G1_0_1_1_4_2_1 = det*w[0][4]*w[0][2]*g10*g11;
    real G1_0_1_1_4_3_2 = det*w[0][4]*w[0][3]*g10*g21;
    real G1_0_1_1_5_0_0 = det*w[0][5]*w[0][0]*g10*g01;
    real G1_0_1_1_5_0_1 = det*w[0][5]*w[0][0]*g10*g11;
    real G1_0_1_1_5_0_2 = det*w[0][5]*w[0][0]*g10*g21;
    real G1_0_1_1_5_1_0 = det*w[0][5]*w[0][1]*g10*g01;
    real G1_0_1_1_5_2_1 = det*w[0][5]*w[0][2]*g10*g11;
    real G1_0_1_1_5_3_2 = det*w[0][5]*w[0][3]*g10*g21;
    real G1_0_1_1_6_0_0 = det*w[0][6]*w[0][0]*g10*g01;
    real G1_0_1_1_6_0_1 = det*w[0][6]*w[0][0]*g10*g11;
    real G1_0_1_1_6_0_2 = det*w[0][6]*w[0][0]*g10*g21;
    real G1_0_1_1_6_1_0 = det*w[0][6]*w[0][1]*g10*g01;
    real G1_0_1_1_6_2_1 = det*w[0][6]*w[0][2]*g10*g11;
    real G1_0_1_1_6_3_2 = det*w[0][6]*w[0][3]*g10*g21;
    real G1_0_1_1_7_0_0 = det*w[0][7]*w[0][0]*g10*g01;
    real G1_0_1_1_7_0_1 = det*w[0][7]*w[0][0]*g10*g11;
    real G1_0_1_1_7_0_2 = det*w[0][7]*w[0][0]*g10*g21;
    real G1_0_1_1_7_1_0 = det*w[0][7]*w[0][1]*g10*g01;
    real G1_0_1_1_7_2_1 = det*w[0][7]*w[0][2]*g10*g11;
    real G1_0_1_1_7_3_2 = det*w[0][7]*w[0][3]*g10*g21;
    real G1_0_1_2_4_0_0 = det*w[0][4]*w[0][0]*g20*g01;
    real G1_0_1_2_4_0_1 = det*w[0][4]*w[0][0]*g20*g11;
    real G1_0_1_2_4_0_2 = det*w[0][4]*w[0][0]*g20*g21;
    real G1_0_1_2_4_1_0 = det*w[0][4]*w[0][1]*g20*g01;
    real G1_0_1_2_4_2_1 = det*w[0][4]*w[0][2]*g20*g11;
    real G1_0_1_2_4_3_2 = det*w[0][4]*w[0][3]*g20*g21;
    real G1_0_1_2_5_0_0 = det*w[0][5]*w[0][0]*g20*g01;
    real G1_0_1_2_5_0_1 = det*w[0][5]*w[0][0]*g20*g11;
    real G1_0_1_2_5_0_2 = det*w[0][5]*w[0][0]*g20*g21;
    real G1_0_1_2_5_1_0 = det*w[0][5]*w[0][1]*g20*g01;
    real G1_0_1_2_5_2_1 = det*w[0][5]*w[0][2]*g20*g11;
    real G1_0_1_2_5_3_2 = det*w[0][5]*w[0][3]*g20*g21;
    real G1_0_1_2_6_0_0 = det*w[0][6]*w[0][0]*g20*g01;
    real G1_0_1_2_6_0_1 = det*w[0][6]*w[0][0]*g20*g11;
    real G1_0_1_2_6_0_2 = det*w[0][6]*w[0][0]*g20*g21;
    real G1_0_1_2_6_1_0 = det*w[0][6]*w[0][1]*g20*g01;
    real G1_0_1_2_6_2_1 = det*w[0][6]*w[0][2]*g20*g11;
    real G1_0_1_2_6_3_2 = det*w[0][6]*w[0][3]*g20*g21;
    real G1_0_1_2_7_0_0 = det*w[0][7]*w[0][0]*g20*g01;
    real G1_0_1_2_7_0_1 = det*w[0][7]*w[0][0]*g20*g11;
    real G1_0_1_2_7_0_2 = det*w[0][7]*w[0][0]*g20*g21;
    real G1_0_1_2_7_1_0 = det*w[0][7]*w[0][1]*g20*g01;
    real G1_0_1_2_7_2_1 = det*w[0][7]*w[0][2]*g20*g11;
    real G1_0_1_2_7_3_2 = det*w[0][7]*w[0][3]*g20*g21;
    real G1_0_2_0_8_0_0 = det*w[0][8]*w[0][0]*g00*g02;
    real G1_0_2_0_8_0_1 = det*w[0][8]*w[0][0]*g00*g12;
    real G1_0_2_0_8_0_2 = det*w[0][8]*w[0][0]*g00*g22;
    real G1_0_2_0_8_1_0 = det*w[0][8]*w[0][1]*g00*g02;
    real G1_0_2_0_8_2_1 = det*w[0][8]*w[0][2]*g00*g12;
    real G1_0_2_0_8_3_2 = det*w[0][8]*w[0][3]*g00*g22;
    real G1_0_2_0_9_0_0 = det*w[0][9]*w[0][0]*g00*g02;
    real G1_0_2_0_9_0_1 = det*w[0][9]*w[0][0]*g00*g12;
    real G1_0_2_0_9_0_2 = det*w[0][9]*w[0][0]*g00*g22;
    real G1_0_2_0_9_1_0 = det*w[0][9]*w[0][1]*g00*g02;
    real G1_0_2_0_9_2_1 = det*w[0][9]*w[0][2]*g00*g12;
    real G1_0_2_0_9_3_2 = det*w[0][9]*w[0][3]*g00*g22;
    real G1_0_2_0_10_0_0 = det*w[0][10]*w[0][0]*g00*g02;
    real G1_0_2_0_10_0_1 = det*w[0][10]*w[0][0]*g00*g12;
    real G1_0_2_0_10_0_2 = det*w[0][10]*w[0][0]*g00*g22;
    real G1_0_2_0_10_1_0 = det*w[0][10]*w[0][1]*g00*g02;
    real G1_0_2_0_10_2_1 = det*w[0][10]*w[0][2]*g00*g12;
    real G1_0_2_0_10_3_2 = det*w[0][10]*w[0][3]*g00*g22;
    real G1_0_2_0_11_0_0 = det*w[0][11]*w[0][0]*g00*g02;
    real G1_0_2_0_11_0_1 = det*w[0][11]*w[0][0]*g00*g12;
    real G1_0_2_0_11_0_2 = det*w[0][11]*w[0][0]*g00*g22;
    real G1_0_2_0_11_1_0 = det*w[0][11]*w[0][1]*g00*g02;
    real G1_0_2_0_11_2_1 = det*w[0][11]*w[0][2]*g00*g12;
    real G1_0_2_0_11_3_2 = det*w[0][11]*w[0][3]*g00*g22;
    real G1_0_2_1_8_0_0 = det*w[0][8]*w[0][0]*g10*g02;
    real G1_0_2_1_8_0_1 = det*w[0][8]*w[0][0]*g10*g12;
    real G1_0_2_1_8_0_2 = det*w[0][8]*w[0][0]*g10*g22;
    real G1_0_2_1_8_1_0 = det*w[0][8]*w[0][1]*g10*g02;
    real G1_0_2_1_8_2_1 = det*w[0][8]*w[0][2]*g10*g12;
    real G1_0_2_1_8_3_2 = det*w[0][8]*w[0][3]*g10*g22;
    real G1_0_2_1_9_0_0 = det*w[0][9]*w[0][0]*g10*g02;
    real G1_0_2_1_9_0_1 = det*w[0][9]*w[0][0]*g10*g12;
    real G1_0_2_1_9_0_2 = det*w[0][9]*w[0][0]*g10*g22;
    real G1_0_2_1_9_1_0 = det*w[0][9]*w[0][1]*g10*g02;
    real G1_0_2_1_9_2_1 = det*w[0][9]*w[0][2]*g10*g12;
    real G1_0_2_1_9_3_2 = det*w[0][9]*w[0][3]*g10*g22;
    real G1_0_2_1_10_0_0 = det*w[0][10]*w[0][0]*g10*g02;
    real G1_0_2_1_10_0_1 = det*w[0][10]*w[0][0]*g10*g12;
    real G1_0_2_1_10_0_2 = det*w[0][10]*w[0][0]*g10*g22;
    real G1_0_2_1_10_1_0 = det*w[0][10]*w[0][1]*g10*g02;
    real G1_0_2_1_10_2_1 = det*w[0][10]*w[0][2]*g10*g12;
    real G1_0_2_1_10_3_2 = det*w[0][10]*w[0][3]*g10*g22;
    real G1_0_2_1_11_0_0 = det*w[0][11]*w[0][0]*g10*g02;
    real G1_0_2_1_11_0_1 = det*w[0][11]*w[0][0]*g10*g12;
    real G1_0_2_1_11_0_2 = det*w[0][11]*w[0][0]*g10*g22;
    real G1_0_2_1_11_1_0 = det*w[0][11]*w[0][1]*g10*g02;
    real G1_0_2_1_11_2_1 = det*w[0][11]*w[0][2]*g10*g12;
    real G1_0_2_1_11_3_2 = det*w[0][11]*w[0][3]*g10*g22;
    real G1_0_2_2_8_0_0 = det*w[0][8]*w[0][0]*g20*g02;
    real G1_0_2_2_8_0_1 = det*w[0][8]*w[0][0]*g20*g12;
    real G1_0_2_2_8_0_2 = det*w[0][8]*w[0][0]*g20*g22;
    real G1_0_2_2_8_1_0 = det*w[0][8]*w[0][1]*g20*g02;
    real G1_0_2_2_8_2_1 = det*w[0][8]*w[0][2]*g20*g12;
    real G1_0_2_2_8_3_2 = det*w[0][8]*w[0][3]*g20*g22;
    real G1_0_2_2_9_0_0 = det*w[0][9]*w[0][0]*g20*g02;
    real G1_0_2_2_9_0_1 = det*w[0][9]*w[0][0]*g20*g12;
    real G1_0_2_2_9_0_2 = det*w[0][9]*w[0][0]*g20*g22;
    real G1_0_2_2_9_1_0 = det*w[0][9]*w[0][1]*g20*g02;
    real G1_0_2_2_9_2_1 = det*w[0][9]*w[0][2]*g20*g12;
    real G1_0_2_2_9_3_2 = det*w[0][9]*w[0][3]*g20*g22;
    real G1_0_2_2_10_0_0 = det*w[0][10]*w[0][0]*g20*g02;
    real G1_0_2_2_10_0_1 = det*w[0][10]*w[0][0]*g20*g12;
    real G1_0_2_2_10_0_2 = det*w[0][10]*w[0][0]*g20*g22;
    real G1_0_2_2_10_1_0 = det*w[0][10]*w[0][1]*g20*g02;
    real G1_0_2_2_10_2_1 = det*w[0][10]*w[0][2]*g20*g12;
    real G1_0_2_2_10_3_2 = det*w[0][10]*w[0][3]*g20*g22;
    real G1_0_2_2_11_0_0 = det*w[0][11]*w[0][0]*g20*g02;
    real G1_0_2_2_11_0_1 = det*w[0][11]*w[0][0]*g20*g12;
    real G1_0_2_2_11_0_2 = det*w[0][11]*w[0][0]*g20*g22;
    real G1_0_2_2_11_1_0 = det*w[0][11]*w[0][1]*g20*g02;
    real G1_0_2_2_11_2_1 = det*w[0][11]*w[0][2]*g20*g12;
    real G1_0_2_2_11_3_2 = det*w[0][11]*w[0][3]*g20*g22;
    real G1_1_0_0_0_4_0 = det*w[0][0]*w[0][4]*g01*g00;
    real G1_1_0_0_0_4_1 = det*w[0][0]*w[0][4]*g01*g10;
    real G1_1_0_0_0_4_2 = det*w[0][0]*w[0][4]*g01*g20;
    real G1_1_0_0_0_5_0 = det*w[0][0]*w[0][5]*g01*g00;
    real G1_1_0_0_0_6_1 = det*w[0][0]*w[0][6]*g01*g10;
    real G1_1_0_0_0_7_2 = det*w[0][0]*w[0][7]*g01*g20;
    real G1_1_0_0_1_4_0 = det*w[0][1]*w[0][4]*g01*g00;
    real G1_1_0_0_1_4_1 = det*w[0][1]*w[0][4]*g01*g10;
    real G1_1_0_0_1_4_2 = det*w[0][1]*w[0][4]*g01*g20;
    real G1_1_0_0_1_5_0 = det*w[0][1]*w[0][5]*g01*g00;
    real G1_1_0_0_1_6_1 = det*w[0][1]*w[0][6]*g01*g10;
    real G1_1_0_0_1_7_2 = det*w[0][1]*w[0][7]*g01*g20;
    real G1_1_0_0_2_4_0 = det*w[0][2]*w[0][4]*g01*g00;
    real G1_1_0_0_2_4_1 = det*w[0][2]*w[0][4]*g01*g10;
    real G1_1_0_0_2_4_2 = det*w[0][2]*w[0][4]*g01*g20;
    real G1_1_0_0_2_5_0 = det*w[0][2]*w[0][5]*g01*g00;
    real G1_1_0_0_2_6_1 = det*w[0][2]*w[0][6]*g01*g10;
    real G1_1_0_0_2_7_2 = det*w[0][2]*w[0][7]*g01*g20;
    real G1_1_0_0_3_4_0 = det*w[0][3]*w[0][4]*g01*g00;
    real G1_1_0_0_3_4_1 = det*w[0][3]*w[0][4]*g01*g10;
    real G1_1_0_0_3_4_2 = det*w[0][3]*w[0][4]*g01*g20;
    real G1_1_0_0_3_5_0 = det*w[0][3]*w[0][5]*g01*g00;
    real G1_1_0_0_3_6_1 = det*w[0][3]*w[0][6]*g01*g10;
    real G1_1_0_0_3_7_2 = det*w[0][3]*w[0][7]*g01*g20;
    real G1_1_0_1_0_4_0 = det*w[0][0]*w[0][4]*g11*g00;
    real G1_1_0_1_0_4_1 = det*w[0][0]*w[0][4]*g11*g10;
    real G1_1_0_1_0_4_2 = det*w[0][0]*w[0][4]*g11*g20;
    real G1_1_0_1_0_5_0 = det*w[0][0]*w[0][5]*g11*g00;
    real G1_1_0_1_0_6_1 = det*w[0][0]*w[0][6]*g11*g10;
    real G1_1_0_1_0_7_2 = det*w[0][0]*w[0][7]*g11*g20;
    real G1_1_0_1_1_4_0 = det*w[0][1]*w[0][4]*g11*g00;
    real G1_1_0_1_1_4_1 = det*w[0][1]*w[0][4]*g11*g10;
    real G1_1_0_1_1_4_2 = det*w[0][1]*w[0][4]*g11*g20;
    real G1_1_0_1_1_5_0 = det*w[0][1]*w[0][5]*g11*g00;
    real G1_1_0_1_1_6_1 = det*w[0][1]*w[0][6]*g11*g10;
    real G1_1_0_1_1_7_2 = det*w[0][1]*w[0][7]*g11*g20;
    real G1_1_0_1_2_4_0 = det*w[0][2]*w[0][4]*g11*g00;
    real G1_1_0_1_2_4_1 = det*w[0][2]*w[0][4]*g11*g10;
    real G1_1_0_1_2_4_2 = det*w[0][2]*w[0][4]*g11*g20;
    real G1_1_0_1_2_5_0 = det*w[0][2]*w[0][5]*g11*g00;
    real G1_1_0_1_2_6_1 = det*w[0][2]*w[0][6]*g11*g10;
    real G1_1_0_1_2_7_2 = det*w[0][2]*w[0][7]*g11*g20;
    real G1_1_0_1_3_4_0 = det*w[0][3]*w[0][4]*g11*g00;
    real G1_1_0_1_3_4_1 = det*w[0][3]*w[0][4]*g11*g10;
    real G1_1_0_1_3_4_2 = det*w[0][3]*w[0][4]*g11*g20;
    real G1_1_0_1_3_5_0 = det*w[0][3]*w[0][5]*g11*g00;
    real G1_1_0_1_3_6_1 = det*w[0][3]*w[0][6]*g11*g10;
    real G1_1_0_1_3_7_2 = det*w[0][3]*w[0][7]*g11*g20;
    real G1_1_0_2_0_4_0 = det*w[0][0]*w[0][4]*g21*g00;
    real G1_1_0_2_0_4_1 = det*w[0][0]*w[0][4]*g21*g10;
    real G1_1_0_2_0_4_2 = det*w[0][0]*w[0][4]*g21*g20;
    real G1_1_0_2_0_5_0 = det*w[0][0]*w[0][5]*g21*g00;
    real G1_1_0_2_0_6_1 = det*w[0][0]*w[0][6]*g21*g10;
    real G1_1_0_2_0_7_2 = det*w[0][0]*w[0][7]*g21*g20;
    real G1_1_0_2_1_4_0 = det*w[0][1]*w[0][4]*g21*g00;
    real G1_1_0_2_1_4_1 = det*w[0][1]*w[0][4]*g21*g10;
    real G1_1_0_2_1_4_2 = det*w[0][1]*w[0][4]*g21*g20;
    real G1_1_0_2_1_5_0 = det*w[0][1]*w[0][5]*g21*g00;
    real G1_1_0_2_1_6_1 = det*w[0][1]*w[0][6]*g21*g10;
    real G1_1_0_2_1_7_2 = det*w[0][1]*w[0][7]*g21*g20;
    real G1_1_0_2_2_4_0 = det*w[0][2]*w[0][4]*g21*g00;
    real G1_1_0_2_2_4_1 = det*w[0][2]*w[0][4]*g21*g10;
    real G1_1_0_2_2_4_2 = det*w[0][2]*w[0][4]*g21*g20;
    real G1_1_0_2_2_5_0 = det*w[0][2]*w[0][5]*g21*g00;
    real G1_1_0_2_2_6_1 = det*w[0][2]*w[0][6]*g21*g10;
    real G1_1_0_2_2_7_2 = det*w[0][2]*w[0][7]*g21*g20;
    real G1_1_0_2_3_4_0 = det*w[0][3]*w[0][4]*g21*g00;
    real G1_1_0_2_3_4_1 = det*w[0][3]*w[0][4]*g21*g10;
    real G1_1_0_2_3_4_2 = det*w[0][3]*w[0][4]*g21*g20;
    real G1_1_0_2_3_5_0 = det*w[0][3]*w[0][5]*g21*g00;
    real G1_1_0_2_3_6_1 = det*w[0][3]*w[0][6]*g21*g10;
    real G1_1_0_2_3_7_2 = det*w[0][3]*w[0][7]*g21*g20;
    real G1_1_1_0_4_4_0 = det*w[0][4]*w[0][4]*g01*g01;
    real G1_1_1_0_4_4_1 = det*w[0][4]*w[0][4]*g01*g11;
    real G1_1_1_0_4_4_2 = det*w[0][4]*w[0][4]*g01*g21;
    real G1_1_1_0_4_5_0 = det*w[0][4]*w[0][5]*g01*g01;
    real G1_1_1_0_4_6_1 = det*w[0][4]*w[0][6]*g01*g11;
    real G1_1_1_0_4_7_2 = det*w[0][4]*w[0][7]*g01*g21;
    real G1_1_1_0_5_4_0 = det*w[0][5]*w[0][4]*g01*g01;
    real G1_1_1_0_5_4_1 = det*w[0][5]*w[0][4]*g01*g11;
    real G1_1_1_0_5_4_2 = det*w[0][5]*w[0][4]*g01*g21;
    real G1_1_1_0_5_5_0 = det*w[0][5]*w[0][5]*g01*g01;
    real G1_1_1_0_5_6_1 = det*w[0][5]*w[0][6]*g01*g11;
    real G1_1_1_0_5_7_2 = det*w[0][5]*w[0][7]*g01*g21;
    real G1_1_1_0_6_4_0 = det*w[0][6]*w[0][4]*g01*g01;
    real G1_1_1_0_6_4_1 = det*w[0][6]*w[0][4]*g01*g11;
    real G1_1_1_0_6_4_2 = det*w[0][6]*w[0][4]*g01*g21;
    real G1_1_1_0_6_5_0 = det*w[0][6]*w[0][5]*g01*g01;
    real G1_1_1_0_6_6_1 = det*w[0][6]*w[0][6]*g01*g11;
    real G1_1_1_0_6_7_2 = det*w[0][6]*w[0][7]*g01*g21;
    real G1_1_1_0_7_4_0 = det*w[0][7]*w[0][4]*g01*g01;
    real G1_1_1_0_7_4_1 = det*w[0][7]*w[0][4]*g01*g11;
    real G1_1_1_0_7_4_2 = det*w[0][7]*w[0][4]*g01*g21;
    real G1_1_1_0_7_5_0 = det*w[0][7]*w[0][5]*g01*g01;
    real G1_1_1_0_7_6_1 = det*w[0][7]*w[0][6]*g01*g11;
    real G1_1_1_0_7_7_2 = det*w[0][7]*w[0][7]*g01*g21;
    real G1_1_1_1_4_4_0 = det*w[0][4]*w[0][4]*g11*g01;
    real G1_1_1_1_4_4_1 = det*w[0][4]*w[0][4]*g11*g11;
    real G1_1_1_1_4_4_2 = det*w[0][4]*w[0][4]*g11*g21;
    real G1_1_1_1_4_5_0 = det*w[0][4]*w[0][5]*g11*g01;
    real G1_1_1_1_4_6_1 = det*w[0][4]*w[0][6]*g11*g11;
    real G1_1_1_1_4_7_2 = det*w[0][4]*w[0][7]*g11*g21;
    real G1_1_1_1_5_4_0 = det*w[0][5]*w[0][4]*g11*g01;
    real G1_1_1_1_5_4_1 = det*w[0][5]*w[0][4]*g11*g11;
    real G1_1_1_1_5_4_2 = det*w[0][5]*w[0][4]*g11*g21;
    real G1_1_1_1_5_5_0 = det*w[0][5]*w[0][5]*g11*g01;
    real G1_1_1_1_5_6_1 = det*w[0][5]*w[0][6]*g11*g11;
    real G1_1_1_1_5_7_2 = det*w[0][5]*w[0][7]*g11*g21;
    real G1_1_1_1_6_4_0 = det*w[0][6]*w[0][4]*g11*g01;
    real G1_1_1_1_6_4_1 = det*w[0][6]*w[0][4]*g11*g11;
    real G1_1_1_1_6_4_2 = det*w[0][6]*w[0][4]*g11*g21;
    real G1_1_1_1_6_5_0 = det*w[0][6]*w[0][5]*g11*g01;
    real G1_1_1_1_6_6_1 = det*w[0][6]*w[0][6]*g11*g11;
    real G1_1_1_1_6_7_2 = det*w[0][6]*w[0][7]*g11*g21;
    real G1_1_1_1_7_4_0 = det*w[0][7]*w[0][4]*g11*g01;
    real G1_1_1_1_7_4_1 = det*w[0][7]*w[0][4]*g11*g11;
    real G1_1_1_1_7_4_2 = det*w[0][7]*w[0][4]*g11*g21;
    real G1_1_1_1_7_5_0 = det*w[0][7]*w[0][5]*g11*g01;
    real G1_1_1_1_7_6_1 = det*w[0][7]*w[0][6]*g11*g11;
    real G1_1_1_1_7_7_2 = det*w[0][7]*w[0][7]*g11*g21;
    real G1_1_1_2_4_4_0 = det*w[0][4]*w[0][4]*g21*g01;
    real G1_1_1_2_4_4_1 = det*w[0][4]*w[0][4]*g21*g11;
    real G1_1_1_2_4_4_2 = det*w[0][4]*w[0][4]*g21*g21;
    real G1_1_1_2_4_5_0 = det*w[0][4]*w[0][5]*g21*g01;
    real G1_1_1_2_4_6_1 = det*w[0][4]*w[0][6]*g21*g11;
    real G1_1_1_2_4_7_2 = det*w[0][4]*w[0][7]*g21*g21;
    real G1_1_1_2_5_4_0 = det*w[0][5]*w[0][4]*g21*g01;
    real G1_1_1_2_5_4_1 = det*w[0][5]*w[0][4]*g21*g11;
    real G1_1_1_2_5_4_2 = det*w[0][5]*w[0][4]*g21*g21;
    real G1_1_1_2_5_5_0 = det*w[0][5]*w[0][5]*g21*g01;
    real G1_1_1_2_5_6_1 = det*w[0][5]*w[0][6]*g21*g11;
    real G1_1_1_2_5_7_2 = det*w[0][5]*w[0][7]*g21*g21;
    real G1_1_1_2_6_4_0 = det*w[0][6]*w[0][4]*g21*g01;
    real G1_1_1_2_6_4_1 = det*w[0][6]*w[0][4]*g21*g11;
    real G1_1_1_2_6_4_2 = det*w[0][6]*w[0][4]*g21*g21;
    real G1_1_1_2_6_5_0 = det*w[0][6]*w[0][5]*g21*g01;
    real G1_1_1_2_6_6_1 = det*w[0][6]*w[0][6]*g21*g11;
    real G1_1_1_2_6_7_2 = det*w[0][6]*w[0][7]*g21*g21;
    real G1_1_1_2_7_4_0 = det*w[0][7]*w[0][4]*g21*g01;
    real G1_1_1_2_7_4_1 = det*w[0][7]*w[0][4]*g21*g11;
    real G1_1_1_2_7_4_2 = det*w[0][7]*w[0][4]*g21*g21;
    real G1_1_1_2_7_5_0 = det*w[0][7]*w[0][5]*g21*g01;
    real G1_1_1_2_7_6_1 = det*w[0][7]*w[0][6]*g21*g11;
    real G1_1_1_2_7_7_2 = det*w[0][7]*w[0][7]*g21*g21;
    real G1_1_2_0_8_4_0 = det*w[0][8]*w[0][4]*g01*g02;
    real G1_1_2_0_8_4_1 = det*w[0][8]*w[0][4]*g01*g12;
    real G1_1_2_0_8_4_2 = det*w[0][8]*w[0][4]*g01*g22;
    real G1_1_2_0_8_5_0 = det*w[0][8]*w[0][5]*g01*g02;
    real G1_1_2_0_8_6_1 = det*w[0][8]*w[0][6]*g01*g12;
    real G1_1_2_0_8_7_2 = det*w[0][8]*w[0][7]*g01*g22;
    real G1_1_2_0_9_4_0 = det*w[0][9]*w[0][4]*g01*g02;
    real G1_1_2_0_9_4_1 = det*w[0][9]*w[0][4]*g01*g12;
    real G1_1_2_0_9_4_2 = det*w[0][9]*w[0][4]*g01*g22;
    real G1_1_2_0_9_5_0 = det*w[0][9]*w[0][5]*g01*g02;
    real G1_1_2_0_9_6_1 = det*w[0][9]*w[0][6]*g01*g12;
    real G1_1_2_0_9_7_2 = det*w[0][9]*w[0][7]*g01*g22;
    real G1_1_2_0_10_4_0 = det*w[0][10]*w[0][4]*g01*g02;
    real G1_1_2_0_10_4_1 = det*w[0][10]*w[0][4]*g01*g12;
    real G1_1_2_0_10_4_2 = det*w[0][10]*w[0][4]*g01*g22;
    real G1_1_2_0_10_5_0 = det*w[0][10]*w[0][5]*g01*g02;
    real G1_1_2_0_10_6_1 = det*w[0][10]*w[0][6]*g01*g12;
    real G1_1_2_0_10_7_2 = det*w[0][10]*w[0][7]*g01*g22;
    real G1_1_2_0_11_4_0 = det*w[0][11]*w[0][4]*g01*g02;
    real G1_1_2_0_11_4_1 = det*w[0][11]*w[0][4]*g01*g12;
    real G1_1_2_0_11_4_2 = det*w[0][11]*w[0][4]*g01*g22;
    real G1_1_2_0_11_5_0 = det*w[0][11]*w[0][5]*g01*g02;
    real G1_1_2_0_11_6_1 = det*w[0][11]*w[0][6]*g01*g12;
    real G1_1_2_0_11_7_2 = det*w[0][11]*w[0][7]*g01*g22;
    real G1_1_2_1_8_4_0 = det*w[0][8]*w[0][4]*g11*g02;
    real G1_1_2_1_8_4_1 = det*w[0][8]*w[0][4]*g11*g12;
    real G1_1_2_1_8_4_2 = det*w[0][8]*w[0][4]*g11*g22;
    real G1_1_2_1_8_5_0 = det*w[0][8]*w[0][5]*g11*g02;
    real G1_1_2_1_8_6_1 = det*w[0][8]*w[0][6]*g11*g12;
    real G1_1_2_1_8_7_2 = det*w[0][8]*w[0][7]*g11*g22;
    real G1_1_2_1_9_4_0 = det*w[0][9]*w[0][4]*g11*g02;
    real G1_1_2_1_9_4_1 = det*w[0][9]*w[0][4]*g11*g12;
    real G1_1_2_1_9_4_2 = det*w[0][9]*w[0][4]*g11*g22;
    real G1_1_2_1_9_5_0 = det*w[0][9]*w[0][5]*g11*g02;
    real G1_1_2_1_9_6_1 = det*w[0][9]*w[0][6]*g11*g12;
    real G1_1_2_1_9_7_2 = det*w[0][9]*w[0][7]*g11*g22;
    real G1_1_2_1_10_4_0 = det*w[0][10]*w[0][4]*g11*g02;
    real G1_1_2_1_10_4_1 = det*w[0][10]*w[0][4]*g11*g12;
    real G1_1_2_1_10_4_2 = det*w[0][10]*w[0][4]*g11*g22;
    real G1_1_2_1_10_5_0 = det*w[0][10]*w[0][5]*g11*g02;
    real G1_1_2_1_10_6_1 = det*w[0][10]*w[0][6]*g11*g12;
    real G1_1_2_1_10_7_2 = det*w[0][10]*w[0][7]*g11*g22;
    real G1_1_2_1_11_4_0 = det*w[0][11]*w[0][4]*g11*g02;
    real G1_1_2_1_11_4_1 = det*w[0][11]*w[0][4]*g11*g12;
    real G1_1_2_1_11_4_2 = det*w[0][11]*w[0][4]*g11*g22;
    real G1_1_2_1_11_5_0 = det*w[0][11]*w[0][5]*g11*g02;
    real G1_1_2_1_11_6_1 = det*w[0][11]*w[0][6]*g11*g12;
    real G1_1_2_1_11_7_2 = det*w[0][11]*w[0][7]*g11*g22;
    real G1_1_2_2_8_4_0 = det*w[0][8]*w[0][4]*g21*g02;
    real G1_1_2_2_8_4_1 = det*w[0][8]*w[0][4]*g21*g12;
    real G1_1_2_2_8_4_2 = det*w[0][8]*w[0][4]*g21*g22;
    real G1_1_2_2_8_5_0 = det*w[0][8]*w[0][5]*g21*g02;
    real G1_1_2_2_8_6_1 = det*w[0][8]*w[0][6]*g21*g12;
    real G1_1_2_2_8_7_2 = det*w[0][8]*w[0][7]*g21*g22;
    real G1_1_2_2_9_4_0 = det*w[0][9]*w[0][4]*g21*g02;
    real G1_1_2_2_9_4_1 = det*w[0][9]*w[0][4]*g21*g12;
    real G1_1_2_2_9_4_2 = det*w[0][9]*w[0][4]*g21*g22;
    real G1_1_2_2_9_5_0 = det*w[0][9]*w[0][5]*g21*g02;
    real G1_1_2_2_9_6_1 = det*w[0][9]*w[0][6]*g21*g12;
    real G1_1_2_2_9_7_2 = det*w[0][9]*w[0][7]*g21*g22;
    real G1_1_2_2_10_4_0 = det*w[0][10]*w[0][4]*g21*g02;
    real G1_1_2_2_10_4_1 = det*w[0][10]*w[0][4]*g21*g12;
    real G1_1_2_2_10_4_2 = det*w[0][10]*w[0][4]*g21*g22;
    real G1_1_2_2_10_5_0 = det*w[0][10]*w[0][5]*g21*g02;
    real G1_1_2_2_10_6_1 = det*w[0][10]*w[0][6]*g21*g12;
    real G1_1_2_2_10_7_2 = det*w[0][10]*w[0][7]*g21*g22;
    real G1_1_2_2_11_4_0 = det*w[0][11]*w[0][4]*g21*g02;
    real G1_1_2_2_11_4_1 = det*w[0][11]*w[0][4]*g21*g12;
    real G1_1_2_2_11_4_2 = det*w[0][11]*w[0][4]*g21*g22;
    real G1_1_2_2_11_5_0 = det*w[0][11]*w[0][5]*g21*g02;
    real G1_1_2_2_11_6_1 = det*w[0][11]*w[0][6]*g21*g12;
    real G1_1_2_2_11_7_2 = det*w[0][11]*w[0][7]*g21*g22;
    real G1_2_0_0_0_8_0 = det*w[0][0]*w[0][8]*g02*g00;
    real G1_2_0_0_0_8_1 = det*w[0][0]*w[0][8]*g02*g10;
    real G1_2_0_0_0_8_2 = det*w[0][0]*w[0][8]*g02*g20;
    real G1_2_0_0_0_9_0 = det*w[0][0]*w[0][9]*g02*g00;
    real G1_2_0_0_0_10_1 = det*w[0][0]*w[0][10]*g02*g10;
    real G1_2_0_0_0_11_2 = det*w[0][0]*w[0][11]*g02*g20;
    real G1_2_0_0_1_8_0 = det*w[0][1]*w[0][8]*g02*g00;
    real G1_2_0_0_1_8_1 = det*w[0][1]*w[0][8]*g02*g10;
    real G1_2_0_0_1_8_2 = det*w[0][1]*w[0][8]*g02*g20;
    real G1_2_0_0_1_9_0 = det*w[0][1]*w[0][9]*g02*g00;
    real G1_2_0_0_1_10_1 = det*w[0][1]*w[0][10]*g02*g10;
    real G1_2_0_0_1_11_2 = det*w[0][1]*w[0][11]*g02*g20;
    real G1_2_0_0_2_8_0 = det*w[0][2]*w[0][8]*g02*g00;
    real G1_2_0_0_2_8_1 = det*w[0][2]*w[0][8]*g02*g10;
    real G1_2_0_0_2_8_2 = det*w[0][2]*w[0][8]*g02*g20;
    real G1_2_0_0_2_9_0 = det*w[0][2]*w[0][9]*g02*g00;
    real G1_2_0_0_2_10_1 = det*w[0][2]*w[0][10]*g02*g10;
    real G1_2_0_0_2_11_2 = det*w[0][2]*w[0][11]*g02*g20;
    real G1_2_0_0_3_8_0 = det*w[0][3]*w[0][8]*g02*g00;
    real G1_2_0_0_3_8_1 = det*w[0][3]*w[0][8]*g02*g10;
    real G1_2_0_0_3_8_2 = det*w[0][3]*w[0][8]*g02*g20;
    real G1_2_0_0_3_9_0 = det*w[0][3]*w[0][9]*g02*g00;
    real G1_2_0_0_3_10_1 = det*w[0][3]*w[0][10]*g02*g10;
    real G1_2_0_0_3_11_2 = det*w[0][3]*w[0][11]*g02*g20;
    real G1_2_0_1_0_8_0 = det*w[0][0]*w[0][8]*g12*g00;
    real G1_2_0_1_0_8_1 = det*w[0][0]*w[0][8]*g12*g10;
    real G1_2_0_1_0_8_2 = det*w[0][0]*w[0][8]*g12*g20;
    real G1_2_0_1_0_9_0 = det*w[0][0]*w[0][9]*g12*g00;
    real G1_2_0_1_0_10_1 = det*w[0][0]*w[0][10]*g12*g10;
    real G1_2_0_1_0_11_2 = det*w[0][0]*w[0][11]*g12*g20;
    real G1_2_0_1_1_8_0 = det*w[0][1]*w[0][8]*g12*g00;
    real G1_2_0_1_1_8_1 = det*w[0][1]*w[0][8]*g12*g10;
    real G1_2_0_1_1_8_2 = det*w[0][1]*w[0][8]*g12*g20;
    real G1_2_0_1_1_9_0 = det*w[0][1]*w[0][9]*g12*g00;
    real G1_2_0_1_1_10_1 = det*w[0][1]*w[0][10]*g12*g10;
    real G1_2_0_1_1_11_2 = det*w[0][1]*w[0][11]*g12*g20;
    real G1_2_0_1_2_8_0 = det*w[0][2]*w[0][8]*g12*g00;
    real G1_2_0_1_2_8_1 = det*w[0][2]*w[0][8]*g12*g10;
    real G1_2_0_1_2_8_2 = det*w[0][2]*w[0][8]*g12*g20;
    real G1_2_0_1_2_9_0 = det*w[0][2]*w[0][9]*g12*g00;
    real G1_2_0_1_2_10_1 = det*w[0][2]*w[0][10]*g12*g10;
    real G1_2_0_1_2_11_2 = det*w[0][2]*w[0][11]*g12*g20;
    real G1_2_0_1_3_8_0 = det*w[0][3]*w[0][8]*g12*g00;
    real G1_2_0_1_3_8_1 = det*w[0][3]*w[0][8]*g12*g10;
    real G1_2_0_1_3_8_2 = det*w[0][3]*w[0][8]*g12*g20;
    real G1_2_0_1_3_9_0 = det*w[0][3]*w[0][9]*g12*g00;
    real G1_2_0_1_3_10_1 = det*w[0][3]*w[0][10]*g12*g10;
    real G1_2_0_1_3_11_2 = det*w[0][3]*w[0][11]*g12*g20;
    real G1_2_0_2_0_8_0 = det*w[0][0]*w[0][8]*g22*g00;
    real G1_2_0_2_0_8_1 = det*w[0][0]*w[0][8]*g22*g10;
    real G1_2_0_2_0_8_2 = det*w[0][0]*w[0][8]*g22*g20;
    real G1_2_0_2_0_9_0 = det*w[0][0]*w[0][9]*g22*g00;
    real G1_2_0_2_0_10_1 = det*w[0][0]*w[0][10]*g22*g10;
    real G1_2_0_2_0_11_2 = det*w[0][0]*w[0][11]*g22*g20;
    real G1_2_0_2_1_8_0 = det*w[0][1]*w[0][8]*g22*g00;
    real G1_2_0_2_1_8_1 = det*w[0][1]*w[0][8]*g22*g10;
    real G1_2_0_2_1_8_2 = det*w[0][1]*w[0][8]*g22*g20;
    real G1_2_0_2_1_9_0 = det*w[0][1]*w[0][9]*g22*g00;
    real G1_2_0_2_1_10_1 = det*w[0][1]*w[0][10]*g22*g10;
    real G1_2_0_2_1_11_2 = det*w[0][1]*w[0][11]*g22*g20;
    real G1_2_0_2_2_8_0 = det*w[0][2]*w[0][8]*g22*g00;
    real G1_2_0_2_2_8_1 = det*w[0][2]*w[0][8]*g22*g10;
    real G1_2_0_2_2_8_2 = det*w[0][2]*w[0][8]*g22*g20;
    real G1_2_0_2_2_9_0 = det*w[0][2]*w[0][9]*g22*g00;
    real G1_2_0_2_2_10_1 = det*w[0][2]*w[0][10]*g22*g10;
    real G1_2_0_2_2_11_2 = det*w[0][2]*w[0][11]*g22*g20;
    real G1_2_0_2_3_8_0 = det*w[0][3]*w[0][8]*g22*g00;
    real G1_2_0_2_3_8_1 = det*w[0][3]*w[0][8]*g22*g10;
    real G1_2_0_2_3_8_2 = det*w[0][3]*w[0][8]*g22*g20;
    real G1_2_0_2_3_9_0 = det*w[0][3]*w[0][9]*g22*g00;
    real G1_2_0_2_3_10_1 = det*w[0][3]*w[0][10]*g22*g10;
    real G1_2_0_2_3_11_2 = det*w[0][3]*w[0][11]*g22*g20;
    real G1_2_1_0_4_8_0 = det*w[0][4]*w[0][8]*g02*g01;
    real G1_2_1_0_4_8_1 = det*w[0][4]*w[0][8]*g02*g11;
    real G1_2_1_0_4_8_2 = det*w[0][4]*w[0][8]*g02*g21;
    real G1_2_1_0_4_9_0 = det*w[0][4]*w[0][9]*g02*g01;
    real G1_2_1_0_4_10_1 = det*w[0][4]*w[0][10]*g02*g11;
    real G1_2_1_0_4_11_2 = det*w[0][4]*w[0][11]*g02*g21;
    real G1_2_1_0_5_8_0 = det*w[0][5]*w[0][8]*g02*g01;
    real G1_2_1_0_5_8_1 = det*w[0][5]*w[0][8]*g02*g11;
    real G1_2_1_0_5_8_2 = det*w[0][5]*w[0][8]*g02*g21;
    real G1_2_1_0_5_9_0 = det*w[0][5]*w[0][9]*g02*g01;
    real G1_2_1_0_5_10_1 = det*w[0][5]*w[0][10]*g02*g11;
    real G1_2_1_0_5_11_2 = det*w[0][5]*w[0][11]*g02*g21;
    real G1_2_1_0_6_8_0 = det*w[0][6]*w[0][8]*g02*g01;
    real G1_2_1_0_6_8_1 = det*w[0][6]*w[0][8]*g02*g11;
    real G1_2_1_0_6_8_2 = det*w[0][6]*w[0][8]*g02*g21;
    real G1_2_1_0_6_9_0 = det*w[0][6]*w[0][9]*g02*g01;
    real G1_2_1_0_6_10_1 = det*w[0][6]*w[0][10]*g02*g11;
    real G1_2_1_0_6_11_2 = det*w[0][6]*w[0][11]*g02*g21;
    real G1_2_1_0_7_8_0 = det*w[0][7]*w[0][8]*g02*g01;
    real G1_2_1_0_7_8_1 = det*w[0][7]*w[0][8]*g02*g11;
    real G1_2_1_0_7_8_2 = det*w[0][7]*w[0][8]*g02*g21;
    real G1_2_1_0_7_9_0 = det*w[0][7]*w[0][9]*g02*g01;
    real G1_2_1_0_7_10_1 = det*w[0][7]*w[0][10]*g02*g11;
    real G1_2_1_0_7_11_2 = det*w[0][7]*w[0][11]*g02*g21;
    real G1_2_1_1_4_8_0 = det*w[0][4]*w[0][8]*g12*g01;
    real G1_2_1_1_4_8_1 = det*w[0][4]*w[0][8]*g12*g11;
    real G1_2_1_1_4_8_2 = det*w[0][4]*w[0][8]*g12*g21;
    real G1_2_1_1_4_9_0 = det*w[0][4]*w[0][9]*g12*g01;
    real G1_2_1_1_4_10_1 = det*w[0][4]*w[0][10]*g12*g11;
    real G1_2_1_1_4_11_2 = det*w[0][4]*w[0][11]*g12*g21;
    real G1_2_1_1_5_8_0 = det*w[0][5]*w[0][8]*g12*g01;
    real G1_2_1_1_5_8_1 = det*w[0][5]*w[0][8]*g12*g11;
    real G1_2_1_1_5_8_2 = det*w[0][5]*w[0][8]*g12*g21;
    real G1_2_1_1_5_9_0 = det*w[0][5]*w[0][9]*g12*g01;
    real G1_2_1_1_5_10_1 = det*w[0][5]*w[0][10]*g12*g11;
    real G1_2_1_1_5_11_2 = det*w[0][5]*w[0][11]*g12*g21;
    real G1_2_1_1_6_8_0 = det*w[0][6]*w[0][8]*g12*g01;
    real G1_2_1_1_6_8_1 = det*w[0][6]*w[0][8]*g12*g11;
    real G1_2_1_1_6_8_2 = det*w[0][6]*w[0][8]*g12*g21;
    real G1_2_1_1_6_9_0 = det*w[0][6]*w[0][9]*g12*g01;
    real G1_2_1_1_6_10_1 = det*w[0][6]*w[0][10]*g12*g11;
    real G1_2_1_1_6_11_2 = det*w[0][6]*w[0][11]*g12*g21;
    real G1_2_1_1_7_8_0 = det*w[0][7]*w[0][8]*g12*g01;
    real G1_2_1_1_7_8_1 = det*w[0][7]*w[0][8]*g12*g11;
    real G1_2_1_1_7_8_2 = det*w[0][7]*w[0][8]*g12*g21;
    real G1_2_1_1_7_9_0 = det*w[0][7]*w[0][9]*g12*g01;
    real G1_2_1_1_7_10_1 = det*w[0][7]*w[0][10]*g12*g11;
    real G1_2_1_1_7_11_2 = det*w[0][7]*w[0][11]*g12*g21;
    real G1_2_1_2_4_8_0 = det*w[0][4]*w[0][8]*g22*g01;
    real G1_2_1_2_4_8_1 = det*w[0][4]*w[0][8]*g22*g11;
    real G1_2_1_2_4_8_2 = det*w[0][4]*w[0][8]*g22*g21;
    real G1_2_1_2_4_9_0 = det*w[0][4]*w[0][9]*g22*g01;
    real G1_2_1_2_4_10_1 = det*w[0][4]*w[0][10]*g22*g11;
    real G1_2_1_2_4_11_2 = det*w[0][4]*w[0][11]*g22*g21;
    real G1_2_1_2_5_8_0 = det*w[0][5]*w[0][8]*g22*g01;
    real G1_2_1_2_5_8_1 = det*w[0][5]*w[0][8]*g22*g11;
    real G1_2_1_2_5_8_2 = det*w[0][5]*w[0][8]*g22*g21;
    real G1_2_1_2_5_9_0 = det*w[0][5]*w[0][9]*g22*g01;
    real G1_2_1_2_5_10_1 = det*w[0][5]*w[0][10]*g22*g11;
    real G1_2_1_2_5_11_2 = det*w[0][5]*w[0][11]*g22*g21;
    real G1_2_1_2_6_8_0 = det*w[0][6]*w[0][8]*g22*g01;
    real G1_2_1_2_6_8_1 = det*w[0][6]*w[0][8]*g22*g11;
    real G1_2_1_2_6_8_2 = det*w[0][6]*w[0][8]*g22*g21;
    real G1_2_1_2_6_9_0 = det*w[0][6]*w[0][9]*g22*g01;
    real G1_2_1_2_6_10_1 = det*w[0][6]*w[0][10]*g22*g11;
    real G1_2_1_2_6_11_2 = det*w[0][6]*w[0][11]*g22*g21;
    real G1_2_1_2_7_8_0 = det*w[0][7]*w[0][8]*g22*g01;
    real G1_2_1_2_7_8_1 = det*w[0][7]*w[0][8]*g22*g11;
    real G1_2_1_2_7_8_2 = det*w[0][7]*w[0][8]*g22*g21;
    real G1_2_1_2_7_9_0 = det*w[0][7]*w[0][9]*g22*g01;
    real G1_2_1_2_7_10_1 = det*w[0][7]*w[0][10]*g22*g11;
    real G1_2_1_2_7_11_2 = det*w[0][7]*w[0][11]*g22*g21;
    real G1_2_2_0_8_8_0 = det*w[0][8]*w[0][8]*g02*g02;
    real G1_2_2_0_8_8_1 = det*w[0][8]*w[0][8]*g02*g12;
    real G1_2_2_0_8_8_2 = det*w[0][8]*w[0][8]*g02*g22;
    real G1_2_2_0_8_9_0 = det*w[0][8]*w[0][9]*g02*g02;
    real G1_2_2_0_8_10_1 = det*w[0][8]*w[0][10]*g02*g12;
    real G1_2_2_0_8_11_2 = det*w[0][8]*w[0][11]*g02*g22;
    real G1_2_2_0_9_8_0 = det*w[0][9]*w[0][8]*g02*g02;
    real G1_2_2_0_9_8_1 = det*w[0][9]*w[0][8]*g02*g12;
    real G1_2_2_0_9_8_2 = det*w[0][9]*w[0][8]*g02*g22;
    real G1_2_2_0_9_9_0 = det*w[0][9]*w[0][9]*g02*g02;
    real G1_2_2_0_9_10_1 = det*w[0][9]*w[0][10]*g02*g12;
    real G1_2_2_0_9_11_2 = det*w[0][9]*w[0][11]*g02*g22;
    real G1_2_2_0_10_8_0 = det*w[0][10]*w[0][8]*g02*g02;
    real G1_2_2_0_10_8_1 = det*w[0][10]*w[0][8]*g02*g12;
    real G1_2_2_0_10_8_2 = det*w[0][10]*w[0][8]*g02*g22;
    real G1_2_2_0_10_9_0 = det*w[0][10]*w[0][9]*g02*g02;
    real G1_2_2_0_10_10_1 = det*w[0][10]*w[0][10]*g02*g12;
    real G1_2_2_0_10_11_2 = det*w[0][10]*w[0][11]*g02*g22;
    real G1_2_2_0_11_8_0 = det*w[0][11]*w[0][8]*g02*g02;
    real G1_2_2_0_11_8_1 = det*w[0][11]*w[0][8]*g02*g12;
    real G1_2_2_0_11_8_2 = det*w[0][11]*w[0][8]*g02*g22;
    real G1_2_2_0_11_9_0 = det*w[0][11]*w[0][9]*g02*g02;
    real G1_2_2_0_11_10_1 = det*w[0][11]*w[0][10]*g02*g12;
    real G1_2_2_0_11_11_2 = det*w[0][11]*w[0][11]*g02*g22;
    real G1_2_2_1_8_8_0 = det*w[0][8]*w[0][8]*g12*g02;
    real G1_2_2_1_8_8_1 = det*w[0][8]*w[0][8]*g12*g12;
    real G1_2_2_1_8_8_2 = det*w[0][8]*w[0][8]*g12*g22;
    real G1_2_2_1_8_9_0 = det*w[0][8]*w[0][9]*g12*g02;
    real G1_2_2_1_8_10_1 = det*w[0][8]*w[0][10]*g12*g12;
    real G1_2_2_1_8_11_2 = det*w[0][8]*w[0][11]*g12*g22;
    real G1_2_2_1_9_8_0 = det*w[0][9]*w[0][8]*g12*g02;
    real G1_2_2_1_9_8_1 = det*w[0][9]*w[0][8]*g12*g12;
    real G1_2_2_1_9_8_2 = det*w[0][9]*w[0][8]*g12*g22;
    real G1_2_2_1_9_9_0 = det*w[0][9]*w[0][9]*g12*g02;
    real G1_2_2_1_9_10_1 = det*w[0][9]*w[0][10]*g12*g12;
    real G1_2_2_1_9_11_2 = det*w[0][9]*w[0][11]*g12*g22;
    real G1_2_2_1_10_8_0 = det*w[0][10]*w[0][8]*g12*g02;
    real G1_2_2_1_10_8_1 = det*w[0][10]*w[0][8]*g12*g12;
    real G1_2_2_1_10_8_2 = det*w[0][10]*w[0][8]*g12*g22;
    real G1_2_2_1_10_9_0 = det*w[0][10]*w[0][9]*g12*g02;
    real G1_2_2_1_10_10_1 = det*w[0][10]*w[0][10]*g12*g12;
    real G1_2_2_1_10_11_2 = det*w[0][10]*w[0][11]*g12*g22;
    real G1_2_2_1_11_8_0 = det*w[0][11]*w[0][8]*g12*g02;
    real G1_2_2_1_11_8_1 = det*w[0][11]*w[0][8]*g12*g12;
    real G1_2_2_1_11_8_2 = det*w[0][11]*w[0][8]*g12*g22;
    real G1_2_2_1_11_9_0 = det*w[0][11]*w[0][9]*g12*g02;
    real G1_2_2_1_11_10_1 = det*w[0][11]*w[0][10]*g12*g12;
    real G1_2_2_1_11_11_2 = det*w[0][11]*w[0][11]*g12*g22;
    real G1_2_2_2_8_8_0 = det*w[0][8]*w[0][8]*g22*g02;
    real G1_2_2_2_8_8_1 = det*w[0][8]*w[0][8]*g22*g12;
    real G1_2_2_2_8_8_2 = det*w[0][8]*w[0][8]*g22*g22;
    real G1_2_2_2_8_9_0 = det*w[0][8]*w[0][9]*g22*g02;
    real G1_2_2_2_8_10_1 = det*w[0][8]*w[0][10]*g22*g12;
    real G1_2_2_2_8_11_2 = det*w[0][8]*w[0][11]*g22*g22;
    real G1_2_2_2_9_8_0 = det*w[0][9]*w[0][8]*g22*g02;
    real G1_2_2_2_9_8_1 = det*w[0][9]*w[0][8]*g22*g12;
    real G1_2_2_2_9_8_2 = det*w[0][9]*w[0][8]*g22*g22;
    real G1_2_2_2_9_9_0 = det*w[0][9]*w[0][9]*g22*g02;
    real G1_2_2_2_9_10_1 = det*w[0][9]*w[0][10]*g22*g12;
    real G1_2_2_2_9_11_2 = det*w[0][9]*w[0][11]*g22*g22;
    real G1_2_2_2_10_8_0 = det*w[0][10]*w[0][8]*g22*g02;
    real G1_2_2_2_10_8_1 = det*w[0][10]*w[0][8]*g22*g12;
    real G1_2_2_2_10_8_2 = det*w[0][10]*w[0][8]*g22*g22;
    real G1_2_2_2_10_9_0 = det*w[0][10]*w[0][9]*g22*g02;
    real G1_2_2_2_10_10_1 = det*w[0][10]*w[0][10]*g22*g12;
    real G1_2_2_2_10_11_2 = det*w[0][10]*w[0][11]*g22*g22;
    real G1_2_2_2_11_8_0 = det*w[0][11]*w[0][8]*g22*g02;
    real G1_2_2_2_11_8_1 = det*w[0][11]*w[0][8]*g22*g12;
    real G1_2_2_2_11_8_2 = det*w[0][11]*w[0][8]*g22*g22;
    real G1_2_2_2_11_9_0 = det*w[0][11]*w[0][9]*g22*g02;
    real G1_2_2_2_11_10_1 = det*w[0][11]*w[0][10]*g22*g12;
    real G1_2_2_2_11_11_2 = det*w[0][11]*w[0][11]*g22*g22;
    real G2_0_0_0 = det*(1.0/c0)*w[0][0]*g00;
    real G2_0_0_1 = det*(1.0/c0)*w[0][0]*g10;
    real G2_0_0_2 = det*(1.0/c0)*w[0][0]*g20;
    real G2_0_1_0 = det*(1.0/c0)*w[0][1]*g00;
    real G2_0_2_1 = det*(1.0/c0)*w[0][2]*g10;
    real G2_0_3_2 = det*(1.0/c0)*w[0][3]*g20;
    real G2_1_4_0 = det*(1.0/c0)*w[0][4]*g01;
    real G2_1_4_1 = det*(1.0/c0)*w[0][4]*g11;
    real G2_1_4_2 = det*(1.0/c0)*w[0][4]*g21;
    real G2_1_5_0 = det*(1.0/c0)*w[0][5]*g01;
    real G2_1_6_1 = det*(1.0/c0)*w[0][6]*g11;
    real G2_1_7_2 = det*(1.0/c0)*w[0][7]*g21;
    real G2_2_8_0 = det*(1.0/c0)*w[0][8]*g02;
    real G2_2_8_1 = det*(1.0/c0)*w[0][8]*g12;
    real G2_2_8_2 = det*(1.0/c0)*w[0][8]*g22;
    real G2_2_9_0 = det*(1.0/c0)*w[0][9]*g02;
    real G2_2_10_1 = det*(1.0/c0)*w[0][10]*g12;
    real G2_2_11_2 = det*(1.0/c0)*w[0][11]*g22;

    // Compute element tensor
    block[0] = -4.166666666666662e-02*G0_0_0_0 - 4.166666666666660e-02*G0_0_0_1 - 4.166666666666661e-02*G0_0_0_2 - 4.166666666666661e-02*G0_0_0_3 - 4.166666666666662e-02*G0_0_1_0 - 4.166666666666661e-02*G0_0_1_1 - 4.166666666666662e-02*G0_0_1_2 - 4.166666666666662e-02*G0_0_1_3 - 4.166666666666662e-02*G0_0_2_0 - 4.166666666666661e-02*G0_0_2_1 - 4.166666666666662e-02*G0_0_2_2 - 4.166666666666662e-02*G0_0_2_3 - 4.166666666666661e-02*G0_1_0_4 - 4.166666666666661e-02*G0_1_0_5 - 4.166666666666661e-02*G0_1_0_6 - 4.166666666666661e-02*G0_1_0_7 - 4.166666666666662e-02*G0_1_1_4 - 4.166666666666662e-02*G0_1_1_5 - 4.166666666666662e-02*G0_1_1_6 - 4.166666666666662e-02*G0_1_1_7 - 4.166666666666662e-02*G0_1_2_4 - 4.166666666666662e-02*G0_1_2_5 - 4.166666666666662e-02*G0_1_2_6 - 4.166666666666662e-02*G0_1_2_7 - 4.166666666666661e-02*G0_2_0_8 - 4.166666666666661e-02*G0_2_0_9 - 4.166666666666661e-02*G0_2_0_10 - 4.166666666666661e-02*G0_2_0_11 - 4.166666666666662e-02*G0_2_1_8 - 4.166666666666662e-02*G0_2_1_9 - 4.166666666666662e-02*G0_2_1_10 - 4.166666666666662e-02*G0_2_1_11 - 4.166666666666662e-02*G0_2_2_8 - 4.166666666666662e-02*G0_2_2_9 - 4.166666666666662e-02*G0_2_2_10 - 4.166666666666662e-02*G0_2_2_11 - 4.166666666666661e-02*G1_0_0_0_0_0_0 - 4.166666666666662e-02*G1_0_0_0_0_0_1 - 4.166666666666661e-02*G1_0_0_0_0_0_2 + 4.166666666666661e-02*G1_0_0_0_0_1_0 + 4.166666666666662e-02*G1_0_0_0_0_2_1 + 4.166666666666662e-02*G1_0_0_0_0_3_2 - 4.166666666666659e-02*G1_0_0_0_1_0_0 - 4.166666666666660e-02*G1_0_0_0_1_0_1 - 4.166666666666659e-02*G1_0_0_0_1_0_2 + 4.166666666666659e-02*G1_0_0_0_1_1_0 + 4.166666666666660e-02*G1_0_0_0_1_2_1 + 4.166666666666660e-02*G1_0_0_0_1_3_2 - 4.166666666666660e-02*G1_0_0_0_2_0_0 - 4.166666666666661e-02*G1_0_0_0_2_0_1 - 4.166666666666660e-02*G1_0_0_0_2_0_2 + 4.166666666666660e-02*G1_0_0_0_2_1_0 + 4.166666666666661e-02*G1_0_0_0_2_2_1 + 4.166666666666661e-02*G1_0_0_0_2_3_2 - 4.166666666666660e-02*G1_0_0_0_3_0_0 - 4.166666666666661e-02*G1_0_0_0_3_0_1 - 4.166666666666660e-02*G1_0_0_0_3_0_2 + 4.166666666666660e-02*G1_0_0_0_3_1_0 + 4.166666666666661e-02*G1_0_0_0_3_2_1 + 4.166666666666661e-02*G1_0_0_0_3_3_2 - 4.166666666666662e-02*G1_0_0_1_0_0_0 - 4.166666666666662e-02*G1_0_0_1_0_0_1 - 4.166666666666662e-02*G1_0_0_1_0_0_2 + 4.166666666666662e-02*G1_0_0_1_0_1_0 + 4.166666666666662e-02*G1_0_0_1_0_2_1 + 4.166666666666662e-02*G1_0_0_1_0_3_2 - 4.166666666666660e-02*G1_0_0_1_1_0_0 - 4.166666666666661e-02*G1_0_0_1_1_0_1 - 4.166666666666660e-02*G1_0_0_1_1_0_2 + 4.166666666666660e-02*G1_0_0_1_1_1_0 + 4.166666666666661e-02*G1_0_0_1_1_2_1 + 4.166666666666661e-02*G1_0_0_1_1_3_2 - 4.166666666666661e-02*G1_0_0_1_2_0_0 - 4.166666666666662e-02*G1_0_0_1_2_0_1 - 4.166666666666661e-02*G1_0_0_1_2_0_2 + 4.166666666666661e-02*G1_0_0_1_2_1_0 + 4.166666666666662e-02*G1_0_0_1_2_2_1 + 4.166666666666662e-02*G1_0_0_1_2_3_2 - 4.166666666666661e-02*G1_0_0_1_3_0_0 - 4.166666666666662e-02*G1_0_0_1_3_0_1 - 4.166666666666661e-02*G1_0_0_1_3_0_2 + 4.166666666666661e-02*G1_0_0_1_3_1_0 + 4.166666666666662e-02*G1_0_0_1_3_2_1 + 4.166666666666662e-02*G1_0_0_1_3_3_2 - 4.166666666666662e-02*G1_0_0_2_0_0_0 - 4.166666666666662e-02*G1_0_0_2_0_0_1 - 4.166666666666662e-02*G1_0_0_2_0_0_2 + 4.166666666666662e-02*G1_0_0_2_0_1_0 + 4.166666666666662e-02*G1_0_0_2_0_2_1 + 4.166666666666662e-02*G1_0_0_2_0_3_2 - 4.166666666666660e-02*G1_0_0_2_1_0_0 - 4.166666666666661e-02*G1_0_0_2_1_0_1 - 4.166666666666660e-02*G1_0_0_2_1_0_2 + 4.166666666666660e-02*G1_0_0_2_1_1_0 + 4.166666666666661e-02*G1_0_0_2_1_2_1 + 4.166666666666661e-02*G1_0_0_2_1_3_2 - 4.166666666666661e-02*G1_0_0_2_2_0_0 - 4.166666666666662e-02*G1_0_0_2_2_0_1 - 4.166666666666661e-02*G1_0_0_2_2_0_2 + 4.166666666666661e-02*G1_0_0_2_2_1_0 + 4.166666666666662e-02*G1_0_0_2_2_2_1 + 4.166666666666662e-02*G1_0_0_2_2_3_2 - 4.166666666666661e-02*G1_0_0_2_3_0_0 - 4.166666666666662e-02*G1_0_0_2_3_0_1 - 4.166666666666661e-02*G1_0_0_2_3_0_2 + 4.166666666666661e-02*G1_0_0_2_3_1_0 + 4.166666666666662e-02*G1_0_0_2_3_2_1 + 4.166666666666662e-02*G1_0_0_2_3_3_2 - 4.166666666666660e-02*G1_0_1_0_4_0_0 - 4.166666666666661e-02*G1_0_1_0_4_0_1 - 4.166666666666660e-02*G1_0_1_0_4_0_2 + 4.166666666666660e-02*G1_0_1_0_4_1_0 + 4.166666666666661e-02*G1_0_1_0_4_2_1 + 4.166666666666661e-02*G1_0_1_0_4_3_2 - 4.166666666666660e-02*G1_0_1_0_5_0_0 - 4.166666666666661e-02*G1_0_1_0_5_0_1 - 4.166666666666660e-02*G1_0_1_0_5_0_2 + 4.166666666666660e-02*G1_0_1_0_5_1_0 + 4.166666666666661e-02*G1_0_1_0_5_2_1 + 4.166666666666661e-02*G1_0_1_0_5_3_2 - 4.166666666666660e-02*G1_0_1_0_6_0_0 - 4.166666666666661e-02*G1_0_1_0_6_0_1 - 4.166666666666660e-02*G1_0_1_0_6_0_2 + 4.166666666666660e-02*G1_0_1_0_6_1_0 + 4.166666666666661e-02*G1_0_1_0_6_2_1 + 4.166666666666661e-02*G1_0_1_0_6_3_2 - 4.166666666666660e-02*G1_0_1_0_7_0_0 - 4.166666666666661e-02*G1_0_1_0_7_0_1 - 4.166666666666660e-02*G1_0_1_0_7_0_2 + 4.166666666666660e-02*G1_0_1_0_7_1_0 + 4.166666666666661e-02*G1_0_1_0_7_2_1 + 4.166666666666661e-02*G1_0_1_0_7_3_2 - 4.166666666666661e-02*G1_0_1_1_4_0_0 - 4.166666666666662e-02*G1_0_1_1_4_0_1 - 4.166666666666661e-02*G1_0_1_1_4_0_2 + 4.166666666666661e-02*G1_0_1_1_4_1_0 + 4.166666666666662e-02*G1_0_1_1_4_2_1 + 4.166666666666662e-02*G1_0_1_1_4_3_2 - 4.166666666666661e-02*G1_0_1_1_5_0_0 - 4.166666666666662e-02*G1_0_1_1_5_0_1 - 4.166666666666661e-02*G1_0_1_1_5_0_2 + 4.166666666666661e-02*G1_0_1_1_5_1_0 + 4.166666666666662e-02*G1_0_1_1_5_2_1 + 4.166666666666662e-02*G1_0_1_1_5_3_2 - 4.166666666666661e-02*G1_0_1_1_6_0_0 - 4.166666666666662e-02*G1_0_1_1_6_0_1 - 4.166666666666661e-02*G1_0_1_1_6_0_2 + 4.166666666666661e-02*G1_0_1_1_6_1_0 + 4.166666666666662e-02*G1_0_1_1_6_2_1 + 4.166666666666662e-02*G1_0_1_1_6_3_2 - 4.166666666666661e-02*G1_0_1_1_7_0_0 - 4.166666666666662e-02*G1_0_1_1_7_0_1 - 4.166666666666661e-02*G1_0_1_1_7_0_2 + 4.166666666666661e-02*G1_0_1_1_7_1_0 + 4.166666666666662e-02*G1_0_1_1_7_2_1 + 4.166666666666662e-02*G1_0_1_1_7_3_2 - 4.166666666666661e-02*G1_0_1_2_4_0_0 - 4.166666666666662e-02*G1_0_1_2_4_0_1 - 4.166666666666661e-02*G1_0_1_2_4_0_2 + 4.166666666666661e-02*G1_0_1_2_4_1_0 + 4.166666666666662e-02*G1_0_1_2_4_2_1 + 4.166666666666662e-02*G1_0_1_2_4_3_2 - 4.166666666666661e-02*G1_0_1_2_5_0_0 - 4.166666666666662e-02*G1_0_1_2_5_0_1 - 4.166666666666661e-02*G1_0_1_2_5_0_2 + 4.166666666666661e-02*G1_0_1_2_5_1_0 + 4.166666666666662e-02*G1_0_1_2_5_2_1 + 4.166666666666662e-02*G1_0_1_2_5_3_2 - 4.166666666666661e-02*G1_0_1_2_6_0_0 - 4.166666666666662e-02*G1_0_1_2_6_0_1 - 4.166666666666661e-02*G1_0_1_2_6_0_2 + 4.166666666666661e-02*G1_0_1_2_6_1_0 + 4.166666666666662e-02*G1_0_1_2_6_2_1 + 4.166666666666662e-02*G1_0_1_2_6_3_2 - 4.166666666666661e-02*G1_0_1_2_7_0_0 - 4.166666666666662e-02*G1_0_1_2_7_0_1 - 4.166666666666661e-02*G1_0_1_2_7_0_2 + 4.166666666666661e-02*G1_0_1_2_7_1_0 + 4.166666666666662e-02*G1_0_1_2_7_2_1 + 4.166666666666662e-02*G1_0_1_2_7_3_2 - 4.166666666666660e-02*G1_0_2_0_8_0_0 - 4.166666666666661e-02*G1_0_2_0_8_0_1 - 4.166666666666660e-02*G1_0_2_0_8_0_2 + 4.166666666666660e-02*G1_0_2_0_8_1_0 + 4.166666666666661e-02*G1_0_2_0_8_2_1 + 4.166666666666661e-02*G1_0_2_0_8_3_2 - 4.166666666666660e-02*G1_0_2_0_9_0_0 - 4.166666666666661e-02*G1_0_2_0_9_0_1 - 4.166666666666660e-02*G1_0_2_0_9_0_2 + 4.166666666666660e-02*G1_0_2_0_9_1_0 + 4.166666666666661e-02*G1_0_2_0_9_2_1 + 4.166666666666661e-02*G1_0_2_0_9_3_2 - 4.166666666666660e-02*G1_0_2_0_10_0_0 - 4.166666666666661e-02*G1_0_2_0_10_0_1 - 4.166666666666660e-02*G1_0_2_0_10_0_2 + 4.166666666666660e-02*G1_0_2_0_10_1_0 + 4.166666666666661e-02*G1_0_2_0_10_2_1 + 4.166666666666661e-02*G1_0_2_0_10_3_2 - 4.166666666666660e-02*G1_0_2_0_11_0_0 - 4.166666666666661e-02*G1_0_2_0_11_0_1 - 4.166666666666660e-02*G1_0_2_0_11_0_2 + 4.166666666666660e-02*G1_0_2_0_11_1_0 + 4.166666666666661e-02*G1_0_2_0_11_2_1 + 4.166666666666661e-02*G1_0_2_0_11_3_2 - 4.166666666666661e-02*G1_0_2_1_8_0_0 - 4.166666666666662e-02*G1_0_2_1_8_0_1 - 4.166666666666661e-02*G1_0_2_1_8_0_2 + 4.166666666666661e-02*G1_0_2_1_8_1_0 + 4.166666666666662e-02*G1_0_2_1_8_2_1 + 4.166666666666662e-02*G1_0_2_1_8_3_2 - 4.166666666666661e-02*G1_0_2_1_9_0_0 - 4.166666666666662e-02*G1_0_2_1_9_0_1 - 4.166666666666661e-02*G1_0_2_1_9_0_2 + 4.166666666666661e-02*G1_0_2_1_9_1_0 + 4.166666666666662e-02*G1_0_2_1_9_2_1 + 4.166666666666662e-02*G1_0_2_1_9_3_2 - 4.166666666666661e-02*G1_0_2_1_10_0_0 - 4.166666666666662e-02*G1_0_2_1_10_0_1 - 4.166666666666661e-02*G1_0_2_1_10_0_2 + 4.166666666666661e-02*G1_0_2_1_10_1_0 + 4.166666666666662e-02*G1_0_2_1_10_2_1 + 4.166666666666662e-02*G1_0_2_1_10_3_2 - 4.166666666666661e-02*G1_0_2_1_11_0_0 - 4.166666666666662e-02*G1_0_2_1_11_0_1 - 4.166666666666661e-02*G1_0_2_1_11_0_2 + 4.166666666666661e-02*G1_0_2_1_11_1_0 + 4.166666666666662e-02*G1_0_2_1_11_2_1 + 4.166666666666662e-02*G1_0_2_1_11_3_2 - 4.166666666666661e-02*G1_0_2_2_8_0_0 - 4.166666666666662e-02*G1_0_2_2_8_0_1 - 4.166666666666661e-02*G1_0_2_2_8_0_2 + 4.166666666666661e-02*G1_0_2_2_8_1_0 + 4.166666666666662e-02*G1_0_2_2_8_2_1 + 4.166666666666662e-02*G1_0_2_2_8_3_2 - 4.166666666666661e-02*G1_0_2_2_9_0_0 - 4.166666666666662e-02*G1_0_2_2_9_0_1 - 4.166666666666661e-02*G1_0_2_2_9_0_2 + 4.166666666666661e-02*G1_0_2_2_9_1_0 + 4.166666666666662e-02*G1_0_2_2_9_2_1 + 4.166666666666662e-02*G1_0_2_2_9_3_2 - 4.166666666666661e-02*G1_0_2_2_10_0_0 - 4.166666666666662e-02*G1_0_2_2_10_0_1 - 4.166666666666661e-02*G1_0_2_2_10_0_2 + 4.166666666666661e-02*G1_0_2_2_10_1_0 + 4.166666666666662e-02*G1_0_2_2_10_2_1 + 4.166666666666662e-02*G1_0_2_2_10_3_2 - 4.166666666666661e-02*G1_0_2_2_11_0_0 - 4.166666666666662e-02*G1_0_2_2_11_0_1 - 4.166666666666661e-02*G1_0_2_2_11_0_2 + 4.166666666666661e-02*G1_0_2_2_11_1_0 + 4.166666666666662e-02*G1_0_2_2_11_2_1 + 4.166666666666662e-02*G1_0_2_2_11_3_2 - 4.166666666666661e-02*G1_1_0_0_0_4_0 - 4.166666666666662e-02*G1_1_0_0_0_4_1 - 4.166666666666662e-02*G1_1_0_0_0_4_2 + 4.166666666666661e-02*G1_1_0_0_0_5_0 + 4.166666666666662e-02*G1_1_0_0_0_6_1 + 4.166666666666662e-02*G1_1_0_0_0_7_2 - 4.166666666666659e-02*G1_1_0_0_1_4_0 - 4.166666666666660e-02*G1_1_0_0_1_4_1 - 4.166666666666660e-02*G1_1_0_0_1_4_2 + 4.166666666666659e-02*G1_1_0_0_1_5_0 + 4.166666666666660e-02*G1_1_0_0_1_6_1 + 4.166666666666660e-02*G1_1_0_0_1_7_2 - 4.166666666666660e-02*G1_1_0_0_2_4_0 - 4.166666666666661e-02*G1_1_0_0_2_4_1 - 4.166666666666661e-02*G1_1_0_0_2_4_2 + 4.166666666666660e-02*G1_1_0_0_2_5_0 + 4.166666666666661e-02*G1_1_0_0_2_6_1 + 4.166666666666661e-02*G1_1_0_0_2_7_2 - 4.166666666666660e-02*G1_1_0_0_3_4_0 - 4.166666666666661e-02*G1_1_0_0_3_4_1 - 4.166666666666661e-02*G1_1_0_0_3_4_2 + 4.166666666666660e-02*G1_1_0_0_3_5_0 + 4.166666666666661e-02*G1_1_0_0_3_6_1 + 4.166666666666661e-02*G1_1_0_0_3_7_2 - 4.166666666666662e-02*G1_1_0_1_0_4_0 - 4.166666666666662e-02*G1_1_0_1_0_4_1 - 4.166666666666662e-02*G1_1_0_1_0_4_2 + 4.166666666666662e-02*G1_1_0_1_0_5_0 + 4.166666666666662e-02*G1_1_0_1_0_6_1 + 4.166666666666662e-02*G1_1_0_1_0_7_2 - 4.166666666666660e-02*G1_1_0_1_1_4_0 - 4.166666666666661e-02*G1_1_0_1_1_4_1 - 4.166666666666661e-02*G1_1_0_1_1_4_2 + 4.166666666666660e-02*G1_1_0_1_1_5_0 + 4.166666666666661e-02*G1_1_0_1_1_6_1 + 4.166666666666661e-02*G1_1_0_1_1_7_2 - 4.166666666666661e-02*G1_1_0_1_2_4_0 - 4.166666666666662e-02*G1_1_0_1_2_4_1 - 4.166666666666662e-02*G1_1_0_1_2_4_2 + 4.166666666666661e-02*G1_1_0_1_2_5_0 + 4.166666666666662e-02*G1_1_0_1_2_6_1 + 4.166666666666662e-02*G1_1_0_1_2_7_2 - 4.166666666666661e-02*G1_1_0_1_3_4_0 - 4.166666666666662e-02*G1_1_0_1_3_4_1 - 4.166666666666662e-02*G1_1_0_1_3_4_2 + 4.166666666666661e-02*G1_1_0_1_3_5_0 + 4.166666666666662e-02*G1_1_0_1_3_6_1 + 4.166666666666662e-02*G1_1_0_1_3_7_2 - 4.166666666666662e-02*G1_1_0_2_0_4_0 - 4.166666666666662e-02*G1_1_0_2_0_4_1 - 4.166666666666662e-02*G1_1_0_2_0_4_2 + 4.166666666666662e-02*G1_1_0_2_0_5_0 + 4.166666666666662e-02*G1_1_0_2_0_6_1 + 4.166666666666662e-02*G1_1_0_2_0_7_2 - 4.166666666666660e-02*G1_1_0_2_1_4_0 - 4.166666666666661e-02*G1_1_0_2_1_4_1 - 4.166666666666661e-02*G1_1_0_2_1_4_2 + 4.166666666666660e-02*G1_1_0_2_1_5_0 + 4.166666666666661e-02*G1_1_0_2_1_6_1 + 4.166666666666661e-02*G1_1_0_2_1_7_2 - 4.166666666666661e-02*G1_1_0_2_2_4_0 - 4.166666666666662e-02*G1_1_0_2_2_4_1 - 4.166666666666662e-02*G1_1_0_2_2_4_2 + 4.166666666666661e-02*G1_1_0_2_2_5_0 + 4.166666666666662e-02*G1_1_0_2_2_6_1 + 4.166666666666662e-02*G1_1_0_2_2_7_2 - 4.166666666666661e-02*G1_1_0_2_3_4_0 - 4.166666666666662e-02*G1_1_0_2_3_4_1 - 4.166666666666662e-02*G1_1_0_2_3_4_2 + 4.166666666666661e-02*G1_1_0_2_3_5_0 + 4.166666666666662e-02*G1_1_0_2_3_6_1 + 4.166666666666662e-02*G1_1_0_2_3_7_2 - 4.166666666666660e-02*G1_1_1_0_4_4_0 - 4.166666666666661e-02*G1_1_1_0_4_4_1 - 4.166666666666661e-02*G1_1_1_0_4_4_2 + 4.166666666666660e-02*G1_1_1_0_4_5_0 + 4.166666666666661e-02*G1_1_1_0_4_6_1 + 4.166666666666661e-02*G1_1_1_0_4_7_2 - 4.166666666666660e-02*G1_1_1_0_5_4_0 - 4.166666666666661e-02*G1_1_1_0_5_4_1 - 4.166666666666661e-02*G1_1_1_0_5_4_2 + 4.166666666666660e-02*G1_1_1_0_5_5_0 + 4.166666666666661e-02*G1_1_1_0_5_6_1 + 4.166666666666661e-02*G1_1_1_0_5_7_2 - 4.166666666666660e-02*G1_1_1_0_6_4_0 - 4.166666666666661e-02*G1_1_1_0_6_4_1 - 4.166666666666661e-02*G1_1_1_0_6_4_2 + 4.166666666666660e-02*G1_1_1_0_6_5_0 + 4.166666666666661e-02*G1_1_1_0_6_6_1 + 4.166666666666661e-02*G1_1_1_0_6_7_2 - 4.166666666666660e-02*G1_1_1_0_7_4_0 - 4.166666666666661e-02*G1_1_1_0_7_4_1 - 4.166666666666661e-02*G1_1_1_0_7_4_2 + 4.166666666666660e-02*G1_1_1_0_7_5_0 + 4.166666666666661e-02*G1_1_1_0_7_6_1 + 4.166666666666661e-02*G1_1_1_0_7_7_2 - 4.166666666666661e-02*G1_1_1_1_4_4_0 - 4.166666666666662e-02*G1_1_1_1_4_4_1 - 4.166666666666662e-02*G1_1_1_1_4_4_2 + 4.166666666666661e-02*G1_1_1_1_4_5_0 + 4.166666666666662e-02*G1_1_1_1_4_6_1 + 4.166666666666662e-02*G1_1_1_1_4_7_2 - 4.166666666666661e-02*G1_1_1_1_5_4_0 - 4.166666666666662e-02*G1_1_1_1_5_4_1 - 4.166666666666662e-02*G1_1_1_1_5_4_2 + 4.166666666666661e-02*G1_1_1_1_5_5_0 + 4.166666666666662e-02*G1_1_1_1_5_6_1 + 4.166666666666662e-02*G1_1_1_1_5_7_2 - 4.166666666666661e-02*G1_1_1_1_6_4_0 - 4.166666666666662e-02*G1_1_1_1_6_4_1 - 4.166666666666662e-02*G1_1_1_1_6_4_2 + 4.166666666666661e-02*G1_1_1_1_6_5_0 + 4.166666666666662e-02*G1_1_1_1_6_6_1 + 4.166666666666662e-02*G1_1_1_1_6_7_2 - 4.166666666666661e-02*G1_1_1_1_7_4_0 - 4.166666666666662e-02*G1_1_1_1_7_4_1 - 4.166666666666662e-02*G1_1_1_1_7_4_2 + 4.166666666666661e-02*G1_1_1_1_7_5_0 + 4.166666666666662e-02*G1_1_1_1_7_6_1 + 4.166666666666662e-02*G1_1_1_1_7_7_2 - 4.166666666666661e-02*G1_1_1_2_4_4_0 - 4.166666666666662e-02*G1_1_1_2_4_4_1 - 4.166666666666662e-02*G1_1_1_2_4_4_2 + 4.166666666666661e-02*G1_1_1_2_4_5_0 + 4.166666666666662e-02*G1_1_1_2_4_6_1 + 4.166666666666662e-02*G1_1_1_2_4_7_2 - 4.166666666666661e-02*G1_1_1_2_5_4_0 - 4.166666666666662e-02*G1_1_1_2_5_4_1 - 4.166666666666662e-02*G1_1_1_2_5_4_2 + 4.166666666666661e-02*G1_1_1_2_5_5_0 + 4.166666666666662e-02*G1_1_1_2_5_6_1 + 4.166666666666662e-02*G1_1_1_2_5_7_2 - 4.166666666666661e-02*G1_1_1_2_6_4_0 - 4.166666666666662e-02*G1_1_1_2_6_4_1 - 4.166666666666662e-02*G1_1_1_2_6_4_2 + 4.166666666666661e-02*G1_1_1_2_6_5_0 + 4.166666666666662e-02*G1_1_1_2_6_6_1 + 4.166666666666662e-02*G1_1_1_2_6_7_2 - 4.166666666666661e-02*G1_1_1_2_7_4_0 - 4.166666666666662e-02*G1_1_1_2_7_4_1 - 4.166666666666662e-02*G1_1_1_2_7_4_2 + 4.166666666666661e-02*G1_1_1_2_7_5_0 + 4.166666666666662e-02*G1_1_1_2_7_6_1 + 4.166666666666662e-02*G1_1_1_2_7_7_2 - 4.166666666666660e-02*G1_1_2_0_8_4_0 - 4.166666666666661e-02*G1_1_2_0_8_4_1 - 4.166666666666661e-02*G1_1_2_0_8_4_2 + 4.166666666666660e-02*G1_1_2_0_8_5_0 + 4.166666666666661e-02*G1_1_2_0_8_6_1 + 4.166666666666661e-02*G1_1_2_0_8_7_2 - 4.166666666666660e-02*G1_1_2_0_9_4_0 - 4.166666666666661e-02*G1_1_2_0_9_4_1 - 4.166666666666661e-02*G1_1_2_0_9_4_2 + 4.166666666666660e-02*G1_1_2_0_9_5_0 + 4.166666666666661e-02*G1_1_2_0_9_6_1 + 4.166666666666661e-02*G1_1_2_0_9_7_2 - 4.166666666666660e-02*G1_1_2_0_10_4_0 - 4.166666666666661e-02*G1_1_2_0_10_4_1 - 4.166666666666661e-02*G1_1_2_0_10_4_2 + 4.166666666666660e-02*G1_1_2_0_10_5_0 + 4.166666666666661e-02*G1_1_2_0_10_6_1 + 4.166666666666661e-02*G1_1_2_0_10_7_2 - 4.166666666666660e-02*G1_1_2_0_11_4_0 - 4.166666666666661e-02*G1_1_2_0_11_4_1 - 4.166666666666661e-02*G1_1_2_0_11_4_2 + 4.166666666666660e-02*G1_1_2_0_11_5_0 + 4.166666666666661e-02*G1_1_2_0_11_6_1 + 4.166666666666661e-02*G1_1_2_0_11_7_2 - 4.166666666666661e-02*G1_1_2_1_8_4_0 - 4.166666666666662e-02*G1_1_2_1_8_4_1 - 4.166666666666662e-02*G1_1_2_1_8_4_2 + 4.166666666666661e-02*G1_1_2_1_8_5_0 + 4.166666666666662e-02*G1_1_2_1_8_6_1 + 4.166666666666662e-02*G1_1_2_1_8_7_2 - 4.166666666666661e-02*G1_1_2_1_9_4_0 - 4.166666666666662e-02*G1_1_2_1_9_4_1 - 4.166666666666662e-02*G1_1_2_1_9_4_2 + 4.166666666666661e-02*G1_1_2_1_9_5_0 + 4.166666666666662e-02*G1_1_2_1_9_6_1 + 4.166666666666662e-02*G1_1_2_1_9_7_2 - 4.166666666666661e-02*G1_1_2_1_10_4_0 - 4.166666666666662e-02*G1_1_2_1_10_4_1 - 4.166666666666662e-02*G1_1_2_1_10_4_2 + 4.166666666666661e-02*G1_1_2_1_10_5_0 + 4.166666666666662e-02*G1_1_2_1_10_6_1 + 4.166666666666662e-02*G1_1_2_1_10_7_2 - 4.166666666666661e-02*G1_1_2_1_11_4_0 - 4.166666666666662e-02*G1_1_2_1_11_4_1 - 4.166666666666662e-02*G1_1_2_1_11_4_2 + 4.166666666666661e-02*G1_1_2_1_11_5_0 + 4.166666666666662e-02*G1_1_2_1_11_6_1 + 4.166666666666662e-02*G1_1_2_1_11_7_2 - 4.166666666666661e-02*G1_1_2_2_8_4_0 - 4.166666666666662e-02*G1_1_2_2_8_4_1 - 4.166666666666662e-02*G1_1_2_2_8_4_2 + 4.166666666666661e-02*G1_1_2_2_8_5_0 + 4.166666666666662e-02*G1_1_2_2_8_6_1 + 4.166666666666662e-02*G1_1_2_2_8_7_2 - 4.166666666666661e-02*G1_1_2_2_9_4_0 - 4.166666666666662e-02*G1_1_2_2_9_4_1 - 4.166666666666662e-02*G1_1_2_2_9_4_2 + 4.166666666666661e-02*G1_1_2_2_9_5_0 + 4.166666666666662e-02*G1_1_2_2_9_6_1 + 4.166666666666662e-02*G1_1_2_2_9_7_2 - 4.166666666666661e-02*G1_1_2_2_10_4_0 - 4.166666666666662e-02*G1_1_2_2_10_4_1 - 4.166666666666662e-02*G1_1_2_2_10_4_2 + 4.166666666666661e-02*G1_1_2_2_10_5_0 + 4.166666666666662e-02*G1_1_2_2_10_6_1 + 4.166666666666662e-02*G1_1_2_2_10_7_2 - 4.166666666666661e-02*G1_1_2_2_11_4_0 - 4.166666666666662e-02*G1_1_2_2_11_4_1 - 4.166666666666662e-02*G1_1_2_2_11_4_2 + 4.166666666666661e-02*G1_1_2_2_11_5_0 + 4.166666666666662e-02*G1_1_2_2_11_6_1 + 4.166666666666662e-02*G1_1_2_2_11_7_2 - 4.166666666666661e-02*G1_2_0_0_0_8_0 - 4.166666666666662e-02*G1_2_0_0_0_8_1 - 4.166666666666662e-02*G1_2_0_0_0_8_2 + 4.166666666666661e-02*G1_2_0_0_0_9_0 + 4.166666666666662e-02*G1_2_0_0_0_10_1 + 4.166666666666662e-02*G1_2_0_0_0_11_2 - 4.166666666666659e-02*G1_2_0_0_1_8_0 - 4.166666666666660e-02*G1_2_0_0_1_8_1 - 4.166666666666660e-02*G1_2_0_0_1_8_2 + 4.166666666666659e-02*G1_2_0_0_1_9_0 + 4.166666666666660e-02*G1_2_0_0_1_10_1 + 4.166666666666660e-02*G1_2_0_0_1_11_2 - 4.166666666666660e-02*G1_2_0_0_2_8_0 - 4.166666666666661e-02*G1_2_0_0_2_8_1 - 4.166666666666661e-02*G1_2_0_0_2_8_2 + 4.166666666666660e-02*G1_2_0_0_2_9_0 + 4.166666666666661e-02*G1_2_0_0_2_10_1 + 4.166666666666661e-02*G1_2_0_0_2_11_2 - 4.166666666666660e-02*G1_2_0_0_3_8_0 - 4.166666666666661e-02*G1_2_0_0_3_8_1 - 4.166666666666661e-02*G1_2_0_0_3_8_2 + 4.166666666666660e-02*G1_2_0_0_3_9_0 + 4.166666666666661e-02*G1_2_0_0_3_10_1 + 4.166666666666661e-02*G1_2_0_0_3_11_2 - 4.166666666666662e-02*G1_2_0_1_0_8_0 - 4.166666666666662e-02*G1_2_0_1_0_8_1 - 4.166666666666662e-02*G1_2_0_1_0_8_2 + 4.166666666666662e-02*G1_2_0_1_0_9_0 + 4.166666666666662e-02*G1_2_0_1_0_10_1 + 4.166666666666662e-02*G1_2_0_1_0_11_2 - 4.166666666666660e-02*G1_2_0_1_1_8_0 - 4.166666666666661e-02*G1_2_0_1_1_8_1 - 4.166666666666661e-02*G1_2_0_1_1_8_2 + 4.166666666666660e-02*G1_2_0_1_1_9_0 + 4.166666666666661e-02*G1_2_0_1_1_10_1 + 4.166666666666661e-02*G1_2_0_1_1_11_2 - 4.166666666666661e-02*G1_2_0_1_2_8_0 - 4.166666666666662e-02*G1_2_0_1_2_8_1 - 4.166666666666662e-02*G1_2_0_1_2_8_2 + 4.166666666666661e-02*G1_2_0_1_2_9_0 + 4.166666666666662e-02*G1_2_0_1_2_10_1 + 4.166666666666662e-02*G1_2_0_1_2_11_2 - 4.166666666666661e-02*G1_2_0_1_3_8_0 - 4.166666666666662e-02*G1_2_0_1_3_8_1 - 4.166666666666662e-02*G1_2_0_1_3_8_2 + 4.166666666666661e-02*G1_2_0_1_3_9_0 + 4.166666666666662e-02*G1_2_0_1_3_10_1 + 4.166666666666662e-02*G1_2_0_1_3_11_2 - 4.166666666666662e-02*G1_2_0_2_0_8_0 - 4.166666666666662e-02*G1_2_0_2_0_8_1 - 4.166666666666662e-02*G1_2_0_2_0_8_2 + 4.166666666666662e-02*G1_2_0_2_0_9_0 + 4.166666666666662e-02*G1_2_0_2_0_10_1 + 4.166666666666662e-02*G1_2_0_2_0_11_2 - 4.166666666666660e-02*G1_2_0_2_1_8_0 - 4.166666666666661e-02*G1_2_0_2_1_8_1 - 4.166666666666661e-02*G1_2_0_2_1_8_2 + 4.166666666666660e-02*G1_2_0_2_1_9_0 + 4.166666666666661e-02*G1_2_0_2_1_10_1 + 4.166666666666661e-02*G1_2_0_2_1_11_2 - 4.166666666666661e-02*G1_2_0_2_2_8_0 - 4.166666666666662e-02*G1_2_0_2_2_8_1 - 4.166666666666662e-02*G1_2_0_2_2_8_2 + 4.166666666666661e-02*G1_2_0_2_2_9_0 + 4.166666666666662e-02*G1_2_0_2_2_10_1 + 4.166666666666662e-02*G1_2_0_2_2_11_2 - 4.166666666666661e-02*G1_2_0_2_3_8_0 - 4.166666666666662e-02*G1_2_0_2_3_8_1 - 4.166666666666662e-02*G1_2_0_2_3_8_2 + 4.166666666666661e-02*G1_2_0_2_3_9_0 + 4.166666666666662e-02*G1_2_0_2_3_10_1 + 4.166666666666662e-02*G1_2_0_2_3_11_2 - 4.166666666666660e-02*G1_2_1_0_4_8_0 - 4.166666666666661e-02*G1_2_1_0_4_8_1 - 4.166666666666661e-02*G1_2_1_0_4_8_2 + 4.166666666666660e-02*G1_2_1_0_4_9_0 + 4.166666666666661e-02*G1_2_1_0_4_10_1 + 4.166666666666661e-02*G1_2_1_0_4_11_2 - 4.166666666666660e-02*G1_2_1_0_5_8_0 - 4.166666666666661e-02*G1_2_1_0_5_8_1 - 4.166666666666661e-02*G1_2_1_0_5_8_2 + 4.166666666666660e-02*G1_2_1_0_5_9_0 + 4.166666666666661e-02*G1_2_1_0_5_10_1 + 4.166666666666661e-02*G1_2_1_0_5_11_2 - 4.166666666666660e-02*G1_2_1_0_6_8_0 - 4.166666666666661e-02*G1_2_1_0_6_8_1 - 4.166666666666661e-02*G1_2_1_0_6_8_2 + 4.166666666666660e-02*G1_2_1_0_6_9_0 + 4.166666666666661e-02*G1_2_1_0_6_10_1 + 4.166666666666661e-02*G1_2_1_0_6_11_2 - 4.166666666666660e-02*G1_2_1_0_7_8_0 - 4.166666666666661e-02*G1_2_1_0_7_8_1 - 4.166666666666661e-02*G1_2_1_0_7_8_2 + 4.166666666666660e-02*G1_2_1_0_7_9_0 + 4.166666666666661e-02*G1_2_1_0_7_10_1 + 4.166666666666661e-02*G1_2_1_0_7_11_2 - 4.166666666666661e-02*G1_2_1_1_4_8_0 - 4.166666666666662e-02*G1_2_1_1_4_8_1 - 4.166666666666662e-02*G1_2_1_1_4_8_2 + 4.166666666666661e-02*G1_2_1_1_4_9_0 + 4.166666666666662e-02*G1_2_1_1_4_10_1 + 4.166666666666662e-02*G1_2_1_1_4_11_2 - 4.166666666666661e-02*G1_2_1_1_5_8_0 - 4.166666666666662e-02*G1_2_1_1_5_8_1 - 4.166666666666662e-02*G1_2_1_1_5_8_2 + 4.166666666666661e-02*G1_2_1_1_5_9_0 + 4.166666666666662e-02*G1_2_1_1_5_10_1 + 4.166666666666662e-02*G1_2_1_1_5_11_2 - 4.166666666666661e-02*G1_2_1_1_6_8_0 - 4.166666666666662e-02*G1_2_1_1_6_8_1 - 4.166666666666662e-02*G1_2_1_1_6_8_2 + 4.166666666666661e-02*G1_2_1_1_6_9_0 + 4.166666666666662e-02*G1_2_1_1_6_10_1 + 4.166666666666662e-02*G1_2_1_1_6_11_2 - 4.166666666666661e-02*G1_2_1_1_7_8_0 - 4.166666666666662e-02*G1_2_1_1_7_8_1 - 4.166666666666662e-02*G1_2_1_1_7_8_2 + 4.166666666666661e-02*G1_2_1_1_7_9_0 + 4.166666666666662e-02*G1_2_1_1_7_10_1 + 4.166666666666662e-02*G1_2_1_1_7_11_2 - 4.166666666666661e-02*G1_2_1_2_4_8_0 - 4.166666666666662e-02*G1_2_1_2_4_8_1 - 4.166666666666662e-02*G1_2_1_2_4_8_2 + 4.166666666666661e-02*G1_2_1_2_4_9_0 + 4.166666666666662e-02*G1_2_1_2_4_10_1 + 4.166666666666662e-02*G1_2_1_2_4_11_2 - 4.166666666666661e-02*G1_2_1_2_5_8_0 - 4.166666666666662e-02*G1_2_1_2_5_8_1 - 4.166666666666662e-02*G1_2_1_2_5_8_2 + 4.166666666666661e-02*G1_2_1_2_5_9_0 + 4.166666666666662e-02*G1_2_1_2_5_10_1 + 4.166666666666662e-02*G1_2_1_2_5_11_2 - 4.166666666666661e-02*G1_2_1_2_6_8_0 - 4.166666666666662e-02*G1_2_1_2_6_8_1 - 4.166666666666662e-02*G1_2_1_2_6_8_2 + 4.166666666666661e-02*G1_2_1_2_6_9_0 + 4.166666666666662e-02*G1_2_1_2_6_10_1 + 4.166666666666662e-02*G1_2_1_2_6_11_2 - 4.166666666666661e-02*G1_2_1_2_7_8_0 - 4.166666666666662e-02*G1_2_1_2_7_8_1 - 4.166666666666662e-02*G1_2_1_2_7_8_2 + 4.166666666666661e-02*G1_2_1_2_7_9_0 + 4.166666666666662e-02*G1_2_1_2_7_10_1 + 4.166666666666662e-02*G1_2_1_2_7_11_2 - 4.166666666666660e-02*G1_2_2_0_8_8_0 - 4.166666666666661e-02*G1_2_2_0_8_8_1 - 4.166666666666661e-02*G1_2_2_0_8_8_2 + 4.166666666666660e-02*G1_2_2_0_8_9_0 + 4.166666666666661e-02*G1_2_2_0_8_10_1 + 4.166666666666661e-02*G1_2_2_0_8_11_2 - 4.166666666666660e-02*G1_2_2_0_9_8_0 - 4.166666666666661e-02*G1_2_2_0_9_8_1 - 4.166666666666661e-02*G1_2_2_0_9_8_2 + 4.166666666666660e-02*G1_2_2_0_9_9_0 + 4.166666666666661e-02*G1_2_2_0_9_10_1 + 4.166666666666661e-02*G1_2_2_0_9_11_2 - 4.166666666666660e-02*G1_2_2_0_10_8_0 - 4.166666666666661e-02*G1_2_2_0_10_8_1 - 4.166666666666661e-02*G1_2_2_0_10_8_2 + 4.166666666666660e-02*G1_2_2_0_10_9_0 + 4.166666666666661e-02*G1_2_2_0_10_10_1 + 4.166666666666661e-02*G1_2_2_0_10_11_2 - 4.166666666666660e-02*G1_2_2_0_11_8_0 - 4.166666666666661e-02*G1_2_2_0_11_8_1 - 4.166666666666661e-02*G1_2_2_0_11_8_2 + 4.166666666666660e-02*G1_2_2_0_11_9_0 + 4.166666666666661e-02*G1_2_2_0_11_10_1 + 4.166666666666661e-02*G1_2_2_0_11_11_2 - 4.166666666666661e-02*G1_2_2_1_8_8_0 - 4.166666666666662e-02*G1_2_2_1_8_8_1 - 4.166666666666662e-02*G1_2_2_1_8_8_2 + 4.166666666666661e-02*G1_2_2_1_8_9_0 + 4.166666666666662e-02*G1_2_2_1_8_10_1 + 4.166666666666662e-02*G1_2_2_1_8_11_2 - 4.166666666666661e-02*G1_2_2_1_9_8_0 - 4.166666666666662e-02*G1_2_2_1_9_8_1 - 4.166666666666662e-02*G1_2_2_1_9_8_2 + 4.166666666666661e-02*G1_2_2_1_9_9_0 + 4.166666666666662e-02*G1_2_2_1_9_10_1 + 4.166666666666662e-02*G1_2_2_1_9_11_2 - 4.166666666666661e-02*G1_2_2_1_10_8_0 - 4.166666666666662e-02*G1_2_2_1_10_8_1 - 4.166666666666662e-02*G1_2_2_1_10_8_2 + 4.166666666666661e-02*G1_2_2_1_10_9_0 + 4.166666666666662e-02*G1_2_2_1_10_10_1 + 4.166666666666662e-02*G1_2_2_1_10_11_2 - 4.166666666666661e-02*G1_2_2_1_11_8_0 - 4.166666666666662e-02*G1_2_2_1_11_8_1 - 4.166666666666662e-02*G1_2_2_1_11_8_2 + 4.166666666666661e-02*G1_2_2_1_11_9_0 + 4.166666666666662e-02*G1_2_2_1_11_10_1 + 4.166666666666662e-02*G1_2_2_1_11_11_2 - 4.166666666666661e-02*G1_2_2_2_8_8_0 - 4.166666666666662e-02*G1_2_2_2_8_8_1 - 4.166666666666662e-02*G1_2_2_2_8_8_2 + 4.166666666666661e-02*G1_2_2_2_8_9_0 + 4.166666666666662e-02*G1_2_2_2_8_10_1 + 4.166666666666662e-02*G1_2_2_2_8_11_2 - 4.166666666666661e-02*G1_2_2_2_9_8_0 - 4.166666666666662e-02*G1_2_2_2_9_8_1 - 4.166666666666662e-02*G1_2_2_2_9_8_2 + 4.166666666666661e-02*G1_2_2_2_9_9_0 + 4.166666666666662e-02*G1_2_2_2_9_10_1 + 4.166666666666662e-02*G1_2_2_2_9_11_2 - 4.166666666666661e-02*G1_2_2_2_10_8_0 - 4.166666666666662e-02*G1_2_2_2_10_8_1 - 4.166666666666662e-02*G1_2_2_2_10_8_2 + 4.166666666666661e-02*G1_2_2_2_10_9_0 + 4.166666666666662e-02*G1_2_2_2_10_10_1 + 4.166666666666662e-02*G1_2_2_2_10_11_2 - 4.166666666666661e-02*G1_2_2_2_11_8_0 - 4.166666666666662e-02*G1_2_2_2_11_8_1 - 4.166666666666662e-02*G1_2_2_2_11_8_2 + 4.166666666666661e-02*G1_2_2_2_11_9_0 + 4.166666666666662e-02*G1_2_2_2_11_10_1 + 4.166666666666662e-02*G1_2_2_2_11_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;
    block[1] = 4.166666666666662e-02*G0_0_0_0 + 4.166666666666660e-02*G0_0_0_1 + 4.166666666666661e-02*G0_0_0_2 + 4.166666666666661e-02*G0_0_0_3 + 4.166666666666661e-02*G0_1_0_4 + 4.166666666666661e-02*G0_1_0_5 + 4.166666666666661e-02*G0_1_0_6 + 4.166666666666661e-02*G0_1_0_7 + 4.166666666666661e-02*G0_2_0_8 + 4.166666666666661e-02*G0_2_0_9 + 4.166666666666661e-02*G0_2_0_10 + 4.166666666666661e-02*G0_2_0_11 + 4.166666666666661e-02*G1_0_0_0_0_0_0 + 4.166666666666662e-02*G1_0_0_0_0_0_1 + 4.166666666666661e-02*G1_0_0_0_0_0_2 - 4.166666666666661e-02*G1_0_0_0_0_1_0 - 4.166666666666662e-02*G1_0_0_0_0_2_1 - 4.166666666666662e-02*G1_0_0_0_0_3_2 + 4.166666666666659e-02*G1_0_0_0_1_0_0 + 4.166666666666660e-02*G1_0_0_0_1_0_1 + 4.166666666666659e-02*G1_0_0_0_1_0_2 - 4.166666666666659e-02*G1_0_0_0_1_1_0 - 4.166666666666660e-02*G1_0_0_0_1_2_1 - 4.166666666666660e-02*G1_0_0_0_1_3_2 + 4.166666666666660e-02*G1_0_0_0_2_0_0 + 4.166666666666661e-02*G1_0_0_0_2_0_1 + 4.166666666666660e-02*G1_0_0_0_2_0_2 - 4.166666666666660e-02*G1_0_0_0_2_1_0 - 4.166666666666661e-02*G1_0_0_0_2_2_1 - 4.166666666666661e-02*G1_0_0_0_2_3_2 + 4.166666666666660e-02*G1_0_0_0_3_0_0 + 4.166666666666661e-02*G1_0_0_0_3_0_1 + 4.166666666666660e-02*G1_0_0_0_3_0_2 - 4.166666666666660e-02*G1_0_0_0_3_1_0 - 4.166666666666661e-02*G1_0_0_0_3_2_1 - 4.166666666666661e-02*G1_0_0_0_3_3_2 + 4.166666666666660e-02*G1_0_1_0_4_0_0 + 4.166666666666661e-02*G1_0_1_0_4_0_1 + 4.166666666666660e-02*G1_0_1_0_4_0_2 - 4.166666666666660e-02*G1_0_1_0_4_1_0 - 4.166666666666661e-02*G1_0_1_0_4_2_1 - 4.166666666666661e-02*G1_0_1_0_4_3_2 + 4.166666666666660e-02*G1_0_1_0_5_0_0 + 4.166666666666661e-02*G1_0_1_0_5_0_1 + 4.166666666666660e-02*G1_0_1_0_5_0_2 - 4.166666666666660e-02*G1_0_1_0_5_1_0 - 4.166666666666661e-02*G1_0_1_0_5_2_1 - 4.166666666666661e-02*G1_0_1_0_5_3_2 + 4.166666666666660e-02*G1_0_1_0_6_0_0 + 4.166666666666661e-02*G1_0_1_0_6_0_1 + 4.166666666666660e-02*G1_0_1_0_6_0_2 - 4.166666666666660e-02*G1_0_1_0_6_1_0 - 4.166666666666661e-02*G1_0_1_0_6_2_1 - 4.166666666666661e-02*G1_0_1_0_6_3_2 + 4.166666666666660e-02*G1_0_1_0_7_0_0 + 4.166666666666661e-02*G1_0_1_0_7_0_1 + 4.166666666666660e-02*G1_0_1_0_7_0_2 - 4.166666666666660e-02*G1_0_1_0_7_1_0 - 4.166666666666661e-02*G1_0_1_0_7_2_1 - 4.166666666666661e-02*G1_0_1_0_7_3_2 + 4.166666666666660e-02*G1_0_2_0_8_0_0 + 4.166666666666661e-02*G1_0_2_0_8_0_1 + 4.166666666666660e-02*G1_0_2_0_8_0_2 - 4.166666666666660e-02*G1_0_2_0_8_1_0 - 4.166666666666661e-02*G1_0_2_0_8_2_1 - 4.166666666666661e-02*G1_0_2_0_8_3_2 + 4.166666666666660e-02*G1_0_2_0_9_0_0 + 4.166666666666661e-02*G1_0_2_0_9_0_1 + 4.166666666666660e-02*G1_0_2_0_9_0_2 - 4.166666666666660e-02*G1_0_2_0_9_1_0 - 4.166666666666661e-02*G1_0_2_0_9_2_1 - 4.166666666666661e-02*G1_0_2_0_9_3_2 + 4.166666666666660e-02*G1_0_2_0_10_0_0 + 4.166666666666661e-02*G1_0_2_0_10_0_1 + 4.166666666666660e-02*G1_0_2_0_10_0_2 - 4.166666666666660e-02*G1_0_2_0_10_1_0 - 4.166666666666661e-02*G1_0_2_0_10_2_1 - 4.166666666666661e-02*G1_0_2_0_10_3_2 + 4.166666666666660e-02*G1_0_2_0_11_0_0 + 4.166666666666661e-02*G1_0_2_0_11_0_1 + 4.166666666666660e-02*G1_0_2_0_11_0_2 - 4.166666666666660e-02*G1_0_2_0_11_1_0 - 4.166666666666661e-02*G1_0_2_0_11_2_1 - 4.166666666666661e-02*G1_0_2_0_11_3_2 + 4.166666666666661e-02*G1_1_0_0_0_4_0 + 4.166666666666662e-02*G1_1_0_0_0_4_1 + 4.166666666666662e-02*G1_1_0_0_0_4_2 - 4.166666666666661e-02*G1_1_0_0_0_5_0 - 4.166666666666662e-02*G1_1_0_0_0_6_1 - 4.166666666666662e-02*G1_1_0_0_0_7_2 + 4.166666666666659e-02*G1_1_0_0_1_4_0 + 4.166666666666660e-02*G1_1_0_0_1_4_1 + 4.166666666666660e-02*G1_1_0_0_1_4_2 - 4.166666666666659e-02*G1_1_0_0_1_5_0 - 4.166666666666660e-02*G1_1_0_0_1_6_1 - 4.166666666666660e-02*G1_1_0_0_1_7_2 + 4.166666666666660e-02*G1_1_0_0_2_4_0 + 4.166666666666661e-02*G1_1_0_0_2_4_1 + 4.166666666666661e-02*G1_1_0_0_2_4_2 - 4.166666666666660e-02*G1_1_0_0_2_5_0 - 4.166666666666661e-02*G1_1_0_0_2_6_1 - 4.166666666666661e-02*G1_1_0_0_2_7_2 + 4.166666666666660e-02*G1_1_0_0_3_4_0 + 4.166666666666661e-02*G1_1_0_0_3_4_1 + 4.166666666666661e-02*G1_1_0_0_3_4_2 - 4.166666666666660e-02*G1_1_0_0_3_5_0 - 4.166666666666661e-02*G1_1_0_0_3_6_1 - 4.166666666666661e-02*G1_1_0_0_3_7_2 + 4.166666666666660e-02*G1_1_1_0_4_4_0 + 4.166666666666661e-02*G1_1_1_0_4_4_1 + 4.166666666666661e-02*G1_1_1_0_4_4_2 - 4.166666666666660e-02*G1_1_1_0_4_5_0 - 4.166666666666661e-02*G1_1_1_0_4_6_1 - 4.166666666666661e-02*G1_1_1_0_4_7_2 + 4.166666666666660e-02*G1_1_1_0_5_4_0 + 4.166666666666661e-02*G1_1_1_0_5_4_1 + 4.166666666666661e-02*G1_1_1_0_5_4_2 - 4.166666666666660e-02*G1_1_1_0_5_5_0 - 4.166666666666661e-02*G1_1_1_0_5_6_1 - 4.166666666666661e-02*G1_1_1_0_5_7_2 + 4.166666666666660e-02*G1_1_1_0_6_4_0 + 4.166666666666661e-02*G1_1_1_0_6_4_1 + 4.166666666666661e-02*G1_1_1_0_6_4_2 - 4.166666666666660e-02*G1_1_1_0_6_5_0 - 4.166666666666661e-02*G1_1_1_0_6_6_1 - 4.166666666666661e-02*G1_1_1_0_6_7_2 + 4.166666666666660e-02*G1_1_1_0_7_4_0 + 4.166666666666661e-02*G1_1_1_0_7_4_1 + 4.166666666666661e-02*G1_1_1_0_7_4_2 - 4.166666666666660e-02*G1_1_1_0_7_5_0 - 4.166666666666661e-02*G1_1_1_0_7_6_1 - 4.166666666666661e-02*G1_1_1_0_7_7_2 + 4.166666666666660e-02*G1_1_2_0_8_4_0 + 4.166666666666661e-02*G1_1_2_0_8_4_1 + 4.166666666666661e-02*G1_1_2_0_8_4_2 - 4.166666666666660e-02*G1_1_2_0_8_5_0 - 4.166666666666661e-02*G1_1_2_0_8_6_1 - 4.166666666666661e-02*G1_1_2_0_8_7_2 + 4.166666666666660e-02*G1_1_2_0_9_4_0 + 4.166666666666661e-02*G1_1_2_0_9_4_1 + 4.166666666666661e-02*G1_1_2_0_9_4_2 - 4.166666666666660e-02*G1_1_2_0_9_5_0 - 4.166666666666661e-02*G1_1_2_0_9_6_1 - 4.166666666666661e-02*G1_1_2_0_9_7_2 + 4.166666666666660e-02*G1_1_2_0_10_4_0 + 4.166666666666661e-02*G1_1_2_0_10_4_1 + 4.166666666666661e-02*G1_1_2_0_10_4_2 - 4.166666666666660e-02*G1_1_2_0_10_5_0 - 4.166666666666661e-02*G1_1_2_0_10_6_1 - 4.166666666666661e-02*G1_1_2_0_10_7_2 + 4.166666666666660e-02*G1_1_2_0_11_4_0 + 4.166666666666661e-02*G1_1_2_0_11_4_1 + 4.166666666666661e-02*G1_1_2_0_11_4_2 - 4.166666666666660e-02*G1_1_2_0_11_5_0 - 4.166666666666661e-02*G1_1_2_0_11_6_1 - 4.166666666666661e-02*G1_1_2_0_11_7_2 + 4.166666666666661e-02*G1_2_0_0_0_8_0 + 4.166666666666662e-02*G1_2_0_0_0_8_1 + 4.166666666666662e-02*G1_2_0_0_0_8_2 - 4.166666666666661e-02*G1_2_0_0_0_9_0 - 4.166666666666662e-02*G1_2_0_0_0_10_1 - 4.166666666666662e-02*G1_2_0_0_0_11_2 + 4.166666666666659e-02*G1_2_0_0_1_8_0 + 4.166666666666660e-02*G1_2_0_0_1_8_1 + 4.166666666666660e-02*G1_2_0_0_1_8_2 - 4.166666666666659e-02*G1_2_0_0_1_9_0 - 4.166666666666660e-02*G1_2_0_0_1_10_1 - 4.166666666666660e-02*G1_2_0_0_1_11_2 + 4.166666666666660e-02*G1_2_0_0_2_8_0 + 4.166666666666661e-02*G1_2_0_0_2_8_1 + 4.166666666666661e-02*G1_2_0_0_2_8_2 - 4.166666666666660e-02*G1_2_0_0_2_9_0 - 4.166666666666661e-02*G1_2_0_0_2_10_1 - 4.166666666666661e-02*G1_2_0_0_2_11_2 + 4.166666666666660e-02*G1_2_0_0_3_8_0 + 4.166666666666661e-02*G1_2_0_0_3_8_1 + 4.166666666666661e-02*G1_2_0_0_3_8_2 - 4.166666666666660e-02*G1_2_0_0_3_9_0 - 4.166666666666661e-02*G1_2_0_0_3_10_1 - 4.166666666666661e-02*G1_2_0_0_3_11_2 + 4.166666666666660e-02*G1_2_1_0_4_8_0 + 4.166666666666661e-02*G1_2_1_0_4_8_1 + 4.166666666666661e-02*G1_2_1_0_4_8_2 - 4.166666666666660e-02*G1_2_1_0_4_9_0 - 4.166666666666661e-02*G1_2_1_0_4_10_1 - 4.166666666666661e-02*G1_2_1_0_4_11_2 + 4.166666666666660e-02*G1_2_1_0_5_8_0 + 4.166666666666661e-02*G1_2_1_0_5_8_1 + 4.166666666666661e-02*G1_2_1_0_5_8_2 - 4.166666666666660e-02*G1_2_1_0_5_9_0 - 4.166666666666661e-02*G1_2_1_0_5_10_1 - 4.166666666666661e-02*G1_2_1_0_5_11_2 + 4.166666666666660e-02*G1_2_1_0_6_8_0 + 4.166666666666661e-02*G1_2_1_0_6_8_1 + 4.166666666666661e-02*G1_2_1_0_6_8_2 - 4.166666666666660e-02*G1_2_1_0_6_9_0 - 4.166666666666661e-02*G1_2_1_0_6_10_1 - 4.166666666666661e-02*G1_2_1_0_6_11_2 + 4.166666666666660e-02*G1_2_1_0_7_8_0 + 4.166666666666661e-02*G1_2_1_0_7_8_1 + 4.166666666666661e-02*G1_2_1_0_7_8_2 - 4.166666666666660e-02*G1_2_1_0_7_9_0 - 4.166666666666661e-02*G1_2_1_0_7_10_1 - 4.166666666666661e-02*G1_2_1_0_7_11_2 + 4.166666666666660e-02*G1_2_2_0_8_8_0 + 4.166666666666661e-02*G1_2_2_0_8_8_1 + 4.166666666666661e-02*G1_2_2_0_8_8_2 - 4.166666666666660e-02*G1_2_2_0_8_9_0 - 4.166666666666661e-02*G1_2_2_0_8_10_1 - 4.166666666666661e-02*G1_2_2_0_8_11_2 + 4.166666666666660e-02*G1_2_2_0_9_8_0 + 4.166666666666661e-02*G1_2_2_0_9_8_1 + 4.166666666666661e-02*G1_2_2_0_9_8_2 - 4.166666666666660e-02*G1_2_2_0_9_9_0 - 4.166666666666661e-02*G1_2_2_0_9_10_1 - 4.166666666666661e-02*G1_2_2_0_9_11_2 + 4.166666666666660e-02*G1_2_2_0_10_8_0 + 4.166666666666661e-02*G1_2_2_0_10_8_1 + 4.166666666666661e-02*G1_2_2_0_10_8_2 - 4.166666666666660e-02*G1_2_2_0_10_9_0 - 4.166666666666661e-02*G1_2_2_0_10_10_1 - 4.166666666666661e-02*G1_2_2_0_10_11_2 + 4.166666666666660e-02*G1_2_2_0_11_8_0 + 4.166666666666661e-02*G1_2_2_0_11_8_1 + 4.166666666666661e-02*G1_2_2_0_11_8_2 - 4.166666666666660e-02*G1_2_2_0_11_9_0 - 4.166666666666661e-02*G1_2_2_0_11_10_1 - 4.166666666666661e-02*G1_2_2_0_11_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;
    block[2] = 4.166666666666662e-02*G0_0_1_0 + 4.166666666666661e-02*G0_0_1_1 + 4.166666666666662e-02*G0_0_1_2 + 4.166666666666662e-02*G0_0_1_3 + 4.166666666666662e-02*G0_1_1_4 + 4.166666666666662e-02*G0_1_1_5 + 4.166666666666662e-02*G0_1_1_6 + 4.166666666666662e-02*G0_1_1_7 + 4.166666666666662e-02*G0_2_1_8 + 4.166666666666662e-02*G0_2_1_9 + 4.166666666666662e-02*G0_2_1_10 + 4.166666666666662e-02*G0_2_1_11 + 4.166666666666662e-02*G1_0_0_1_0_0_0 + 4.166666666666662e-02*G1_0_0_1_0_0_1 + 4.166666666666662e-02*G1_0_0_1_0_0_2 - 4.166666666666662e-02*G1_0_0_1_0_1_0 - 4.166666666666662e-02*G1_0_0_1_0_2_1 - 4.166666666666662e-02*G1_0_0_1_0_3_2 + 4.166666666666660e-02*G1_0_0_1_1_0_0 + 4.166666666666661e-02*G1_0_0_1_1_0_1 + 4.166666666666660e-02*G1_0_0_1_1_0_2 - 4.166666666666660e-02*G1_0_0_1_1_1_0 - 4.166666666666661e-02*G1_0_0_1_1_2_1 - 4.166666666666661e-02*G1_0_0_1_1_3_2 + 4.166666666666661e-02*G1_0_0_1_2_0_0 + 4.166666666666662e-02*G1_0_0_1_2_0_1 + 4.166666666666661e-02*G1_0_0_1_2_0_2 - 4.166666666666661e-02*G1_0_0_1_2_1_0 - 4.166666666666662e-02*G1_0_0_1_2_2_1 - 4.166666666666662e-02*G1_0_0_1_2_3_2 + 4.166666666666661e-02*G1_0_0_1_3_0_0 + 4.166666666666662e-02*G1_0_0_1_3_0_1 + 4.166666666666661e-02*G1_0_0_1_3_0_2 - 4.166666666666661e-02*G1_0_0_1_3_1_0 - 4.166666666666662e-02*G1_0_0_1_3_2_1 - 4.166666666666662e-02*G1_0_0_1_3_3_2 + 4.166666666666661e-02*G1_0_1_1_4_0_0 + 4.166666666666662e-02*G1_0_1_1_4_0_1 + 4.166666666666661e-02*G1_0_1_1_4_0_2 - 4.166666666666661e-02*G1_0_1_1_4_1_0 - 4.166666666666662e-02*G1_0_1_1_4_2_1 - 4.166666666666662e-02*G1_0_1_1_4_3_2 + 4.166666666666661e-02*G1_0_1_1_5_0_0 + 4.166666666666662e-02*G1_0_1_1_5_0_1 + 4.166666666666661e-02*G1_0_1_1_5_0_2 - 4.166666666666661e-02*G1_0_1_1_5_1_0 - 4.166666666666662e-02*G1_0_1_1_5_2_1 - 4.166666666666662e-02*G1_0_1_1_5_3_2 + 4.166666666666661e-02*G1_0_1_1_6_0_0 + 4.166666666666662e-02*G1_0_1_1_6_0_1 + 4.166666666666661e-02*G1_0_1_1_6_0_2 - 4.166666666666661e-02*G1_0_1_1_6_1_0 - 4.166666666666662e-02*G1_0_1_1_6_2_1 - 4.166666666666662e-02*G1_0_1_1_6_3_2 + 4.166666666666661e-02*G1_0_1_1_7_0_0 + 4.166666666666662e-02*G1_0_1_1_7_0_1 + 4.166666666666661e-02*G1_0_1_1_7_0_2 - 4.166666666666661e-02*G1_0_1_1_7_1_0 - 4.166666666666662e-02*G1_0_1_1_7_2_1 - 4.166666666666662e-02*G1_0_1_1_7_3_2 + 4.166666666666661e-02*G1_0_2_1_8_0_0 + 4.166666666666662e-02*G1_0_2_1_8_0_1 + 4.166666666666661e-02*G1_0_2_1_8_0_2 - 4.166666666666661e-02*G1_0_2_1_8_1_0 - 4.166666666666662e-02*G1_0_2_1_8_2_1 - 4.166666666666662e-02*G1_0_2_1_8_3_2 + 4.166666666666661e-02*G1_0_2_1_9_0_0 + 4.166666666666662e-02*G1_0_2_1_9_0_1 + 4.166666666666661e-02*G1_0_2_1_9_0_2 - 4.166666666666661e-02*G1_0_2_1_9_1_0 - 4.166666666666662e-02*G1_0_2_1_9_2_1 - 4.166666666666662e-02*G1_0_2_1_9_3_2 + 4.166666666666661e-02*G1_0_2_1_10_0_0 + 4.166666666666662e-02*G1_0_2_1_10_0_1 + 4.166666666666661e-02*G1_0_2_1_10_0_2 - 4.166666666666661e-02*G1_0_2_1_10_1_0 - 4.166666666666662e-02*G1_0_2_1_10_2_1 - 4.166666666666662e-02*G1_0_2_1_10_3_2 + 4.166666666666661e-02*G1_0_2_1_11_0_0 + 4.166666666666662e-02*G1_0_2_1_11_0_1 + 4.166666666666661e-02*G1_0_2_1_11_0_2 - 4.166666666666661e-02*G1_0_2_1_11_1_0 - 4.166666666666662e-02*G1_0_2_1_11_2_1 - 4.166666666666662e-02*G1_0_2_1_11_3_2 + 4.166666666666662e-02*G1_1_0_1_0_4_0 + 4.166666666666662e-02*G1_1_0_1_0_4_1 + 4.166666666666662e-02*G1_1_0_1_0_4_2 - 4.166666666666662e-02*G1_1_0_1_0_5_0 - 4.166666666666662e-02*G1_1_0_1_0_6_1 - 4.166666666666662e-02*G1_1_0_1_0_7_2 + 4.166666666666660e-02*G1_1_0_1_1_4_0 + 4.166666666666661e-02*G1_1_0_1_1_4_1 + 4.166666666666661e-02*G1_1_0_1_1_4_2 - 4.166666666666660e-02*G1_1_0_1_1_5_0 - 4.166666666666661e-02*G1_1_0_1_1_6_1 - 4.166666666666661e-02*G1_1_0_1_1_7_2 + 4.166666666666661e-02*G1_1_0_1_2_4_0 + 4.166666666666662e-02*G1_1_0_1_2_4_1 + 4.166666666666662e-02*G1_1_0_1_2_4_2 - 4.166666666666661e-02*G1_1_0_1_2_5_0 - 4.166666666666662e-02*G1_1_0_1_2_6_1 - 4.166666666666662e-02*G1_1_0_1_2_7_2 + 4.166666666666661e-02*G1_1_0_1_3_4_0 + 4.166666666666662e-02*G1_1_0_1_3_4_1 + 4.166666666666662e-02*G1_1_0_1_3_4_2 - 4.166666666666661e-02*G1_1_0_1_3_5_0 - 4.166666666666662e-02*G1_1_0_1_3_6_1 - 4.166666666666662e-02*G1_1_0_1_3_7_2 + 4.166666666666661e-02*G1_1_1_1_4_4_0 + 4.166666666666662e-02*G1_1_1_1_4_4_1 + 4.166666666666662e-02*G1_1_1_1_4_4_2 - 4.166666666666661e-02*G1_1_1_1_4_5_0 - 4.166666666666662e-02*G1_1_1_1_4_6_1 - 4.166666666666662e-02*G1_1_1_1_4_7_2 + 4.166666666666661e-02*G1_1_1_1_5_4_0 + 4.166666666666662e-02*G1_1_1_1_5_4_1 + 4.166666666666662e-02*G1_1_1_1_5_4_2 - 4.166666666666661e-02*G1_1_1_1_5_5_0 - 4.166666666666662e-02*G1_1_1_1_5_6_1 - 4.166666666666662e-02*G1_1_1_1_5_7_2 + 4.166666666666661e-02*G1_1_1_1_6_4_0 + 4.166666666666662e-02*G1_1_1_1_6_4_1 + 4.166666666666662e-02*G1_1_1_1_6_4_2 - 4.166666666666661e-02*G1_1_1_1_6_5_0 - 4.166666666666662e-02*G1_1_1_1_6_6_1 - 4.166666666666662e-02*G1_1_1_1_6_7_2 + 4.166666666666661e-02*G1_1_1_1_7_4_0 + 4.166666666666662e-02*G1_1_1_1_7_4_1 + 4.166666666666662e-02*G1_1_1_1_7_4_2 - 4.166666666666661e-02*G1_1_1_1_7_5_0 - 4.166666666666662e-02*G1_1_1_1_7_6_1 - 4.166666666666662e-02*G1_1_1_1_7_7_2 + 4.166666666666661e-02*G1_1_2_1_8_4_0 + 4.166666666666662e-02*G1_1_2_1_8_4_1 + 4.166666666666662e-02*G1_1_2_1_8_4_2 - 4.166666666666661e-02*G1_1_2_1_8_5_0 - 4.166666666666662e-02*G1_1_2_1_8_6_1 - 4.166666666666662e-02*G1_1_2_1_8_7_2 + 4.166666666666661e-02*G1_1_2_1_9_4_0 + 4.166666666666662e-02*G1_1_2_1_9_4_1 + 4.166666666666662e-02*G1_1_2_1_9_4_2 - 4.166666666666661e-02*G1_1_2_1_9_5_0 - 4.166666666666662e-02*G1_1_2_1_9_6_1 - 4.166666666666662e-02*G1_1_2_1_9_7_2 + 4.166666666666661e-02*G1_1_2_1_10_4_0 + 4.166666666666662e-02*G1_1_2_1_10_4_1 + 4.166666666666662e-02*G1_1_2_1_10_4_2 - 4.166666666666661e-02*G1_1_2_1_10_5_0 - 4.166666666666662e-02*G1_1_2_1_10_6_1 - 4.166666666666662e-02*G1_1_2_1_10_7_2 + 4.166666666666661e-02*G1_1_2_1_11_4_0 + 4.166666666666662e-02*G1_1_2_1_11_4_1 + 4.166666666666662e-02*G1_1_2_1_11_4_2 - 4.166666666666661e-02*G1_1_2_1_11_5_0 - 4.166666666666662e-02*G1_1_2_1_11_6_1 - 4.166666666666662e-02*G1_1_2_1_11_7_2 + 4.166666666666662e-02*G1_2_0_1_0_8_0 + 4.166666666666662e-02*G1_2_0_1_0_8_1 + 4.166666666666662e-02*G1_2_0_1_0_8_2 - 4.166666666666662e-02*G1_2_0_1_0_9_0 - 4.166666666666662e-02*G1_2_0_1_0_10_1 - 4.166666666666662e-02*G1_2_0_1_0_11_2 + 4.166666666666660e-02*G1_2_0_1_1_8_0 + 4.166666666666661e-02*G1_2_0_1_1_8_1 + 4.166666666666661e-02*G1_2_0_1_1_8_2 - 4.166666666666660e-02*G1_2_0_1_1_9_0 - 4.166666666666661e-02*G1_2_0_1_1_10_1 - 4.166666666666661e-02*G1_2_0_1_1_11_2 + 4.166666666666661e-02*G1_2_0_1_2_8_0 + 4.166666666666662e-02*G1_2_0_1_2_8_1 + 4.166666666666662e-02*G1_2_0_1_2_8_2 - 4.166666666666661e-02*G1_2_0_1_2_9_0 - 4.166666666666662e-02*G1_2_0_1_2_10_1 - 4.166666666666662e-02*G1_2_0_1_2_11_2 + 4.166666666666661e-02*G1_2_0_1_3_8_0 + 4.166666666666662e-02*G1_2_0_1_3_8_1 + 4.166666666666662e-02*G1_2_0_1_3_8_2 - 4.166666666666661e-02*G1_2_0_1_3_9_0 - 4.166666666666662e-02*G1_2_0_1_3_10_1 - 4.166666666666662e-02*G1_2_0_1_3_11_2 + 4.166666666666661e-02*G1_2_1_1_4_8_0 + 4.166666666666662e-02*G1_2_1_1_4_8_1 + 4.166666666666662e-02*G1_2_1_1_4_8_2 - 4.166666666666661e-02*G1_2_1_1_4_9_0 - 4.166666666666662e-02*G1_2_1_1_4_10_1 - 4.166666666666662e-02*G1_2_1_1_4_11_2 + 4.166666666666661e-02*G1_2_1_1_5_8_0 + 4.166666666666662e-02*G1_2_1_1_5_8_1 + 4.166666666666662e-02*G1_2_1_1_5_8_2 - 4.166666666666661e-02*G1_2_1_1_5_9_0 - 4.166666666666662e-02*G1_2_1_1_5_10_1 - 4.166666666666662e-02*G1_2_1_1_5_11_2 + 4.166666666666661e-02*G1_2_1_1_6_8_0 + 4.166666666666662e-02*G1_2_1_1_6_8_1 + 4.166666666666662e-02*G1_2_1_1_6_8_2 - 4.166666666666661e-02*G1_2_1_1_6_9_0 - 4.166666666666662e-02*G1_2_1_1_6_10_1 - 4.166666666666662e-02*G1_2_1_1_6_11_2 + 4.166666666666661e-02*G1_2_1_1_7_8_0 + 4.166666666666662e-02*G1_2_1_1_7_8_1 + 4.166666666666662e-02*G1_2_1_1_7_8_2 - 4.166666666666661e-02*G1_2_1_1_7_9_0 - 4.166666666666662e-02*G1_2_1_1_7_10_1 - 4.166666666666662e-02*G1_2_1_1_7_11_2 + 4.166666666666661e-02*G1_2_2_1_8_8_0 + 4.166666666666662e-02*G1_2_2_1_8_8_1 + 4.166666666666662e-02*G1_2_2_1_8_8_2 - 4.166666666666661e-02*G1_2_2_1_8_9_0 - 4.166666666666662e-02*G1_2_2_1_8_10_1 - 4.166666666666662e-02*G1_2_2_1_8_11_2 + 4.166666666666661e-02*G1_2_2_1_9_8_0 + 4.166666666666662e-02*G1_2_2_1_9_8_1 + 4.166666666666662e-02*G1_2_2_1_9_8_2 - 4.166666666666661e-02*G1_2_2_1_9_9_0 - 4.166666666666662e-02*G1_2_2_1_9_10_1 - 4.166666666666662e-02*G1_2_2_1_9_11_2 + 4.166666666666661e-02*G1_2_2_1_10_8_0 + 4.166666666666662e-02*G1_2_2_1_10_8_1 + 4.166666666666662e-02*G1_2_2_1_10_8_2 - 4.166666666666661e-02*G1_2_2_1_10_9_0 - 4.166666666666662e-02*G1_2_2_1_10_10_1 - 4.166666666666662e-02*G1_2_2_1_10_11_2 + 4.166666666666661e-02*G1_2_2_1_11_8_0 + 4.166666666666662e-02*G1_2_2_1_11_8_1 + 4.166666666666662e-02*G1_2_2_1_11_8_2 - 4.166666666666661e-02*G1_2_2_1_11_9_0 - 4.166666666666662e-02*G1_2_2_1_11_10_1 - 4.166666666666662e-02*G1_2_2_1_11_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;
    block[3] = 4.166666666666662e-02*G0_0_2_0 + 4.166666666666661e-02*G0_0_2_1 + 4.166666666666662e-02*G0_0_2_2 + 4.166666666666662e-02*G0_0_2_3 + 4.166666666666662e-02*G0_1_2_4 + 4.166666666666662e-02*G0_1_2_5 + 4.166666666666662e-02*G0_1_2_6 + 4.166666666666662e-02*G0_1_2_7 + 4.166666666666662e-02*G0_2_2_8 + 4.166666666666662e-02*G0_2_2_9 + 4.166666666666662e-02*G0_2_2_10 + 4.166666666666662e-02*G0_2_2_11 + 4.166666666666662e-02*G1_0_0_2_0_0_0 + 4.166666666666662e-02*G1_0_0_2_0_0_1 + 4.166666666666662e-02*G1_0_0_2_0_0_2 - 4.166666666666662e-02*G1_0_0_2_0_1_0 - 4.166666666666662e-02*G1_0_0_2_0_2_1 - 4.166666666666662e-02*G1_0_0_2_0_3_2 + 4.166666666666660e-02*G1_0_0_2_1_0_0 + 4.166666666666661e-02*G1_0_0_2_1_0_1 + 4.166666666666660e-02*G1_0_0_2_1_0_2 - 4.166666666666660e-02*G1_0_0_2_1_1_0 - 4.166666666666661e-02*G1_0_0_2_1_2_1 - 4.166666666666661e-02*G1_0_0_2_1_3_2 + 4.166666666666661e-02*G1_0_0_2_2_0_0 + 4.166666666666662e-02*G1_0_0_2_2_0_1 + 4.166666666666661e-02*G1_0_0_2_2_0_2 - 4.166666666666661e-02*G1_0_0_2_2_1_0 - 4.166666666666662e-02*G1_0_0_2_2_2_1 - 4.166666666666662e-02*G1_0_0_2_2_3_2 + 4.166666666666661e-02*G1_0_0_2_3_0_0 + 4.166666666666662e-02*G1_0_0_2_3_0_1 + 4.166666666666661e-02*G1_0_0_2_3_0_2 - 4.166666666666661e-02*G1_0_0_2_3_1_0 - 4.166666666666662e-02*G1_0_0_2_3_2_1 - 4.166666666666662e-02*G1_0_0_2_3_3_2 + 4.166666666666661e-02*G1_0_1_2_4_0_0 + 4.166666666666662e-02*G1_0_1_2_4_0_1 + 4.166666666666661e-02*G1_0_1_2_4_0_2 - 4.166666666666661e-02*G1_0_1_2_4_1_0 - 4.166666666666662e-02*G1_0_1_2_4_2_1 - 4.166666666666662e-02*G1_0_1_2_4_3_2 + 4.166666666666661e-02*G1_0_1_2_5_0_0 + 4.166666666666662e-02*G1_0_1_2_5_0_1 + 4.166666666666661e-02*G1_0_1_2_5_0_2 - 4.166666666666661e-02*G1_0_1_2_5_1_0 - 4.166666666666662e-02*G1_0_1_2_5_2_1 - 4.166666666666662e-02*G1_0_1_2_5_3_2 + 4.166666666666661e-02*G1_0_1_2_6_0_0 + 4.166666666666662e-02*G1_0_1_2_6_0_1 + 4.166666666666661e-02*G1_0_1_2_6_0_2 - 4.166666666666661e-02*G1_0_1_2_6_1_0 - 4.166666666666662e-02*G1_0_1_2_6_2_1 - 4.166666666666662e-02*G1_0_1_2_6_3_2 + 4.166666666666661e-02*G1_0_1_2_7_0_0 + 4.166666666666662e-02*G1_0_1_2_7_0_1 + 4.166666666666661e-02*G1_0_1_2_7_0_2 - 4.166666666666661e-02*G1_0_1_2_7_1_0 - 4.166666666666662e-02*G1_0_1_2_7_2_1 - 4.166666666666662e-02*G1_0_1_2_7_3_2 + 4.166666666666661e-02*G1_0_2_2_8_0_0 + 4.166666666666662e-02*G1_0_2_2_8_0_1 + 4.166666666666661e-02*G1_0_2_2_8_0_2 - 4.166666666666661e-02*G1_0_2_2_8_1_0 - 4.166666666666662e-02*G1_0_2_2_8_2_1 - 4.166666666666662e-02*G1_0_2_2_8_3_2 + 4.166666666666661e-02*G1_0_2_2_9_0_0 + 4.166666666666662e-02*G1_0_2_2_9_0_1 + 4.166666666666661e-02*G1_0_2_2_9_0_2 - 4.166666666666661e-02*G1_0_2_2_9_1_0 - 4.166666666666662e-02*G1_0_2_2_9_2_1 - 4.166666666666662e-02*G1_0_2_2_9_3_2 + 4.166666666666661e-02*G1_0_2_2_10_0_0 + 4.166666666666662e-02*G1_0_2_2_10_0_1 + 4.166666666666661e-02*G1_0_2_2_10_0_2 - 4.166666666666661e-02*G1_0_2_2_10_1_0 - 4.166666666666662e-02*G1_0_2_2_10_2_1 - 4.166666666666662e-02*G1_0_2_2_10_3_2 + 4.166666666666661e-02*G1_0_2_2_11_0_0 + 4.166666666666662e-02*G1_0_2_2_11_0_1 + 4.166666666666661e-02*G1_0_2_2_11_0_2 - 4.166666666666661e-02*G1_0_2_2_11_1_0 - 4.166666666666662e-02*G1_0_2_2_11_2_1 - 4.166666666666662e-02*G1_0_2_2_11_3_2 + 4.166666666666662e-02*G1_1_0_2_0_4_0 + 4.166666666666662e-02*G1_1_0_2_0_4_1 + 4.166666666666662e-02*G1_1_0_2_0_4_2 - 4.166666666666662e-02*G1_1_0_2_0_5_0 - 4.166666666666662e-02*G1_1_0_2_0_6_1 - 4.166666666666662e-02*G1_1_0_2_0_7_2 + 4.166666666666660e-02*G1_1_0_2_1_4_0 + 4.166666666666661e-02*G1_1_0_2_1_4_1 + 4.166666666666661e-02*G1_1_0_2_1_4_2 - 4.166666666666660e-02*G1_1_0_2_1_5_0 - 4.166666666666661e-02*G1_1_0_2_1_6_1 - 4.166666666666661e-02*G1_1_0_2_1_7_2 + 4.166666666666661e-02*G1_1_0_2_2_4_0 + 4.166666666666662e-02*G1_1_0_2_2_4_1 + 4.166666666666662e-02*G1_1_0_2_2_4_2 - 4.166666666666661e-02*G1_1_0_2_2_5_0 - 4.166666666666662e-02*G1_1_0_2_2_6_1 - 4.166666666666662e-02*G1_1_0_2_2_7_2 + 4.166666666666661e-02*G1_1_0_2_3_4_0 + 4.166666666666662e-02*G1_1_0_2_3_4_1 + 4.166666666666662e-02*G1_1_0_2_3_4_2 - 4.166666666666661e-02*G1_1_0_2_3_5_0 - 4.166666666666662e-02*G1_1_0_2_3_6_1 - 4.166666666666662e-02*G1_1_0_2_3_7_2 + 4.166666666666661e-02*G1_1_1_2_4_4_0 + 4.166666666666662e-02*G1_1_1_2_4_4_1 + 4.166666666666662e-02*G1_1_1_2_4_4_2 - 4.166666666666661e-02*G1_1_1_2_4_5_0 - 4.166666666666662e-02*G1_1_1_2_4_6_1 - 4.166666666666662e-02*G1_1_1_2_4_7_2 + 4.166666666666661e-02*G1_1_1_2_5_4_0 + 4.166666666666662e-02*G1_1_1_2_5_4_1 + 4.166666666666662e-02*G1_1_1_2_5_4_2 - 4.166666666666661e-02*G1_1_1_2_5_5_0 - 4.166666666666662e-02*G1_1_1_2_5_6_1 - 4.166666666666662e-02*G1_1_1_2_5_7_2 + 4.166666666666661e-02*G1_1_1_2_6_4_0 + 4.166666666666662e-02*G1_1_1_2_6_4_1 + 4.166666666666662e-02*G1_1_1_2_6_4_2 - 4.166666666666661e-02*G1_1_1_2_6_5_0 - 4.166666666666662e-02*G1_1_1_2_6_6_1 - 4.166666666666662e-02*G1_1_1_2_6_7_2 + 4.166666666666661e-02*G1_1_1_2_7_4_0 + 4.166666666666662e-02*G1_1_1_2_7_4_1 + 4.166666666666662e-02*G1_1_1_2_7_4_2 - 4.166666666666661e-02*G1_1_1_2_7_5_0 - 4.166666666666662e-02*G1_1_1_2_7_6_1 - 4.166666666666662e-02*G1_1_1_2_7_7_2 + 4.166666666666661e-02*G1_1_2_2_8_4_0 + 4.166666666666662e-02*G1_1_2_2_8_4_1 + 4.166666666666662e-02*G1_1_2_2_8_4_2 - 4.166666666666661e-02*G1_1_2_2_8_5_0 - 4.166666666666662e-02*G1_1_2_2_8_6_1 - 4.166666666666662e-02*G1_1_2_2_8_7_2 + 4.166666666666661e-02*G1_1_2_2_9_4_0 + 4.166666666666662e-02*G1_1_2_2_9_4_1 + 4.166666666666662e-02*G1_1_2_2_9_4_2 - 4.166666666666661e-02*G1_1_2_2_9_5_0 - 4.166666666666662e-02*G1_1_2_2_9_6_1 - 4.166666666666662e-02*G1_1_2_2_9_7_2 + 4.166666666666661e-02*G1_1_2_2_10_4_0 + 4.166666666666662e-02*G1_1_2_2_10_4_1 + 4.166666666666662e-02*G1_1_2_2_10_4_2 - 4.166666666666661e-02*G1_1_2_2_10_5_0 - 4.166666666666662e-02*G1_1_2_2_10_6_1 - 4.166666666666662e-02*G1_1_2_2_10_7_2 + 4.166666666666661e-02*G1_1_2_2_11_4_0 + 4.166666666666662e-02*G1_1_2_2_11_4_1 + 4.166666666666662e-02*G1_1_2_2_11_4_2 - 4.166666666666661e-02*G1_1_2_2_11_5_0 - 4.166666666666662e-02*G1_1_2_2_11_6_1 - 4.166666666666662e-02*G1_1_2_2_11_7_2 + 4.166666666666662e-02*G1_2_0_2_0_8_0 + 4.166666666666662e-02*G1_2_0_2_0_8_1 + 4.166666666666662e-02*G1_2_0_2_0_8_2 - 4.166666666666662e-02*G1_2_0_2_0_9_0 - 4.166666666666662e-02*G1_2_0_2_0_10_1 - 4.166666666666662e-02*G1_2_0_2_0_11_2 + 4.166666666666660e-02*G1_2_0_2_1_8_0 + 4.166666666666661e-02*G1_2_0_2_1_8_1 + 4.166666666666661e-02*G1_2_0_2_1_8_2 - 4.166666666666660e-02*G1_2_0_2_1_9_0 - 4.166666666666661e-02*G1_2_0_2_1_10_1 - 4.166666666666661e-02*G1_2_0_2_1_11_2 + 4.166666666666661e-02*G1_2_0_2_2_8_0 + 4.166666666666662e-02*G1_2_0_2_2_8_1 + 4.166666666666662e-02*G1_2_0_2_2_8_2 - 4.166666666666661e-02*G1_2_0_2_2_9_0 - 4.166666666666662e-02*G1_2_0_2_2_10_1 - 4.166666666666662e-02*G1_2_0_2_2_11_2 + 4.166666666666661e-02*G1_2_0_2_3_8_0 + 4.166666666666662e-02*G1_2_0_2_3_8_1 + 4.166666666666662e-02*G1_2_0_2_3_8_2 - 4.166666666666661e-02*G1_2_0_2_3_9_0 - 4.166666666666662e-02*G1_2_0_2_3_10_1 - 4.166666666666662e-02*G1_2_0_2_3_11_2 + 4.166666666666661e-02*G1_2_1_2_4_8_0 + 4.166666666666662e-02*G1_2_1_2_4_8_1 + 4.166666666666662e-02*G1_2_1_2_4_8_2 - 4.166666666666661e-02*G1_2_1_2_4_9_0 - 4.166666666666662e-02*G1_2_1_2_4_10_1 - 4.166666666666662e-02*G1_2_1_2_4_11_2 + 4.166666666666661e-02*G1_2_1_2_5_8_0 + 4.166666666666662e-02*G1_2_1_2_5_8_1 + 4.166666666666662e-02*G1_2_1_2_5_8_2 - 4.166666666666661e-02*G1_2_1_2_5_9_0 - 4.166666666666662e-02*G1_2_1_2_5_10_1 - 4.166666666666662e-02*G1_2_1_2_5_11_2 + 4.166666666666661e-02*G1_2_1_2_6_8_0 + 4.166666666666662e-02*G1_2_1_2_6_8_1 + 4.166666666666662e-02*G1_2_1_2_6_8_2 - 4.166666666666661e-02*G1_2_1_2_6_9_0 - 4.166666666666662e-02*G1_2_1_2_6_10_1 - 4.166666666666662e-02*G1_2_1_2_6_11_2 + 4.166666666666661e-02*G1_2_1_2_7_8_0 + 4.166666666666662e-02*G1_2_1_2_7_8_1 + 4.166666666666662e-02*G1_2_1_2_7_8_2 - 4.166666666666661e-02*G1_2_1_2_7_9_0 - 4.166666666666662e-02*G1_2_1_2_7_10_1 - 4.166666666666662e-02*G1_2_1_2_7_11_2 + 4.166666666666661e-02*G1_2_2_2_8_8_0 + 4.166666666666662e-02*G1_2_2_2_8_8_1 + 4.166666666666662e-02*G1_2_2_2_8_8_2 - 4.166666666666661e-02*G1_2_2_2_8_9_0 - 4.166666666666662e-02*G1_2_2_2_8_10_1 - 4.166666666666662e-02*G1_2_2_2_8_11_2 + 4.166666666666661e-02*G1_2_2_2_9_8_0 + 4.166666666666662e-02*G1_2_2_2_9_8_1 + 4.166666666666662e-02*G1_2_2_2_9_8_2 - 4.166666666666661e-02*G1_2_2_2_9_9_0 - 4.166666666666662e-02*G1_2_2_2_9_10_1 - 4.166666666666662e-02*G1_2_2_2_9_11_2 + 4.166666666666661e-02*G1_2_2_2_10_8_0 + 4.166666666666662e-02*G1_2_2_2_10_8_1 + 4.166666666666662e-02*G1_2_2_2_10_8_2 - 4.166666666666661e-02*G1_2_2_2_10_9_0 - 4.166666666666662e-02*G1_2_2_2_10_10_1 - 4.166666666666662e-02*G1_2_2_2_10_11_2 + 4.166666666666661e-02*G1_2_2_2_11_8_0 + 4.166666666666662e-02*G1_2_2_2_11_8_1 + 4.166666666666662e-02*G1_2_2_2_11_8_2 - 4.166666666666661e-02*G1_2_2_2_11_9_0 - 4.166666666666662e-02*G1_2_2_2_11_10_1 - 4.166666666666662e-02*G1_2_2_2_11_11_2 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666662e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_2_1 - 4.166666666666662e-02*G2_0_3_2 + 4.166666666666661e-02*G2_1_4_0 + 4.166666666666662e-02*G2_1_4_1 + 4.166666666666662e-02*G2_1_4_2 - 4.166666666666661e-02*G2_1_5_0 - 4.166666666666662e-02*G2_1_6_1 - 4.166666666666662e-02*G2_1_7_2 + 4.166666666666661e-02*G2_2_8_0 + 4.166666666666662e-02*G2_2_8_1 + 4.166666666666662e-02*G2_2_8_2 - 4.166666666666661e-02*G2_2_9_0 - 4.166666666666662e-02*G2_2_10_1 - 4.166666666666662e-02*G2_2_11_2;

    return true;
  }
        
private:

  const real& c0;

};

} }

#endif
