// Automatically generated by FFC, the FEniCS Form Compiler, version 0.1.7.
// For further information, go to http://www/fenics.org/ffc/.
// Licensed under the GNU GPL Version 2.

#ifndef __NSEMOMENTUM_H
#define __NSEMOMENTUM_H

#include <dolfin/FiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace NSEMomentum {

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class TrialElement : public dolfin::FiniteElement
  {
  public:

    TrialElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TrialElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  BilinearForm(Function& w0, const real& c0, const real& c1, const real& c2) : dolfin::BilinearForm(1), c0(c0), c1(c1), c2(c2)
  {
    // Create finite element for test space
    _test = new TestElement();

    // Create finite element for trial space
    _trial = new TrialElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_ = det;
    real G1_0_0 = det*c0*(g00*g00 + g01*g01 + g02*g02);
    real G1_0_1 = det*c0*(g00*g10 + g01*g11 + g02*g12);
    real G1_0_2 = det*c0*(g00*g20 + g01*g21 + g02*g22);
    real G1_1_0 = det*c0*(g10*g00 + g11*g01 + g12*g02);
    real G1_1_1 = det*c0*(g10*g10 + g11*g11 + g12*g12);
    real G1_1_2 = det*c0*(g10*g20 + g11*g21 + g12*g22);
    real G1_2_0 = det*c0*(g20*g00 + g21*g01 + g22*g02);
    real G1_2_1 = det*c0*(g20*g10 + g21*g11 + g22*g12);
    real G1_2_2 = det*c0*(g20*g20 + g21*g21 + g22*g22);
    real G2_0_0_0 = det*c0*w[0][0]*g00;
    real G2_0_0_1 = det*c0*w[0][0]*g10;
    real G2_0_0_2 = det*c0*w[0][0]*g20;
    real G2_0_1_0 = det*c0*w[0][1]*g00;
    real G2_0_1_1 = det*c0*w[0][1]*g10;
    real G2_0_1_2 = det*c0*w[0][1]*g20;
    real G2_0_2_0 = det*c0*w[0][2]*g00;
    real G2_0_2_1 = det*c0*w[0][2]*g10;
    real G2_0_2_2 = det*c0*w[0][2]*g20;
    real G2_0_3_0 = det*c0*w[0][3]*g00;
    real G2_0_3_1 = det*c0*w[0][3]*g10;
    real G2_0_3_2 = det*c0*w[0][3]*g20;
    real G2_1_4_0 = det*c0*w[0][4]*g01;
    real G2_1_4_1 = det*c0*w[0][4]*g11;
    real G2_1_4_2 = det*c0*w[0][4]*g21;
    real G2_1_5_0 = det*c0*w[0][5]*g01;
    real G2_1_5_1 = det*c0*w[0][5]*g11;
    real G2_1_5_2 = det*c0*w[0][5]*g21;
    real G2_1_6_0 = det*c0*w[0][6]*g01;
    real G2_1_6_1 = det*c0*w[0][6]*g11;
    real G2_1_6_2 = det*c0*w[0][6]*g21;
    real G2_1_7_0 = det*c0*w[0][7]*g01;
    real G2_1_7_1 = det*c0*w[0][7]*g11;
    real G2_1_7_2 = det*c0*w[0][7]*g21;
    real G2_2_8_0 = det*c0*w[0][8]*g02;
    real G2_2_8_1 = det*c0*w[0][8]*g12;
    real G2_2_8_2 = det*c0*w[0][8]*g22;
    real G2_2_9_0 = det*c0*w[0][9]*g02;
    real G2_2_9_1 = det*c0*w[0][9]*g12;
    real G2_2_9_2 = det*c0*w[0][9]*g22;
    real G2_2_10_0 = det*c0*w[0][10]*g02;
    real G2_2_10_1 = det*c0*w[0][10]*g12;
    real G2_2_10_2 = det*c0*w[0][10]*g22;
    real G2_2_11_0 = det*c0*w[0][11]*g02;
    real G2_2_11_1 = det*c0*w[0][11]*g12;
    real G2_2_11_2 = det*c0*w[0][11]*g22;
    real G3_0_0_0_0 = det*c2*c0*g00*g00;
    real G3_0_0_0_1 = det*c2*c0*g00*g10;
    real G3_0_0_0_2 = det*c2*c0*g00*g20;
    real G3_0_0_1_0 = det*c2*c0*g10*g00;
    real G3_0_0_1_1 = det*c2*c0*g10*g10;
    real G3_0_0_1_2 = det*c2*c0*g10*g20;
    real G3_0_0_2_0 = det*c2*c0*g20*g00;
    real G3_0_0_2_1 = det*c2*c0*g20*g10;
    real G3_0_0_2_2 = det*c2*c0*g20*g20;
    real G3_0_1_0_0 = det*c2*c0*g00*g01;
    real G3_0_1_0_1 = det*c2*c0*g00*g11;
    real G3_0_1_0_2 = det*c2*c0*g00*g21;
    real G3_0_1_1_0 = det*c2*c0*g10*g01;
    real G3_0_1_1_1 = det*c2*c0*g10*g11;
    real G3_0_1_1_2 = det*c2*c0*g10*g21;
    real G3_0_1_2_0 = det*c2*c0*g20*g01;
    real G3_0_1_2_1 = det*c2*c0*g20*g11;
    real G3_0_1_2_2 = det*c2*c0*g20*g21;
    real G3_0_2_0_0 = det*c2*c0*g00*g02;
    real G3_0_2_0_1 = det*c2*c0*g00*g12;
    real G3_0_2_0_2 = det*c2*c0*g00*g22;
    real G3_0_2_1_0 = det*c2*c0*g10*g02;
    real G3_0_2_1_1 = det*c2*c0*g10*g12;
    real G3_0_2_1_2 = det*c2*c0*g10*g22;
    real G3_0_2_2_0 = det*c2*c0*g20*g02;
    real G3_0_2_2_1 = det*c2*c0*g20*g12;
    real G3_0_2_2_2 = det*c2*c0*g20*g22;
    real G3_1_0_0_0 = det*c2*c0*g01*g00;
    real G3_1_0_0_1 = det*c2*c0*g01*g10;
    real G3_1_0_0_2 = det*c2*c0*g01*g20;
    real G3_1_0_1_0 = det*c2*c0*g11*g00;
    real G3_1_0_1_1 = det*c2*c0*g11*g10;
    real G3_1_0_1_2 = det*c2*c0*g11*g20;
    real G3_1_0_2_0 = det*c2*c0*g21*g00;
    real G3_1_0_2_1 = det*c2*c0*g21*g10;
    real G3_1_0_2_2 = det*c2*c0*g21*g20;
    real G3_1_1_0_0 = det*c2*c0*g01*g01;
    real G3_1_1_0_1 = det*c2*c0*g01*g11;
    real G3_1_1_0_2 = det*c2*c0*g01*g21;
    real G3_1_1_1_0 = det*c2*c0*g11*g01;
    real G3_1_1_1_1 = det*c2*c0*g11*g11;
    real G3_1_1_1_2 = det*c2*c0*g11*g21;
    real G3_1_1_2_0 = det*c2*c0*g21*g01;
    real G3_1_1_2_1 = det*c2*c0*g21*g11;
    real G3_1_1_2_2 = det*c2*c0*g21*g21;
    real G3_1_2_0_0 = det*c2*c0*g01*g02;
    real G3_1_2_0_1 = det*c2*c0*g01*g12;
    real G3_1_2_0_2 = det*c2*c0*g01*g22;
    real G3_1_2_1_0 = det*c2*c0*g11*g02;
    real G3_1_2_1_1 = det*c2*c0*g11*g12;
    real G3_1_2_1_2 = det*c2*c0*g11*g22;
    real G3_1_2_2_0 = det*c2*c0*g21*g02;
    real G3_1_2_2_1 = det*c2*c0*g21*g12;
    real G3_1_2_2_2 = det*c2*c0*g21*g22;
    real G3_2_0_0_0 = det*c2*c0*g02*g00;
    real G3_2_0_0_1 = det*c2*c0*g02*g10;
    real G3_2_0_0_2 = det*c2*c0*g02*g20;
    real G3_2_0_1_0 = det*c2*c0*g12*g00;
    real G3_2_0_1_1 = det*c2*c0*g12*g10;
    real G3_2_0_1_2 = det*c2*c0*g12*g20;
    real G3_2_0_2_0 = det*c2*c0*g22*g00;
    real G3_2_0_2_1 = det*c2*c0*g22*g10;
    real G3_2_0_2_2 = det*c2*c0*g22*g20;
    real G3_2_1_0_0 = det*c2*c0*g02*g01;
    real G3_2_1_0_1 = det*c2*c0*g02*g11;
    real G3_2_1_0_2 = det*c2*c0*g02*g21;
    real G3_2_1_1_0 = det*c2*c0*g12*g01;
    real G3_2_1_1_1 = det*c2*c0*g12*g11;
    real G3_2_1_1_2 = det*c2*c0*g12*g21;
    real G3_2_1_2_0 = det*c2*c0*g22*g01;
    real G3_2_1_2_1 = det*c2*c0*g22*g11;
    real G3_2_1_2_2 = det*c2*c0*g22*g21;
    real G3_2_2_0_0 = det*c2*c0*g02*g02;
    real G3_2_2_0_1 = det*c2*c0*g02*g12;
    real G3_2_2_0_2 = det*c2*c0*g02*g22;
    real G3_2_2_1_0 = det*c2*c0*g12*g02;
    real G3_2_2_1_1 = det*c2*c0*g12*g12;
    real G3_2_2_1_2 = det*c2*c0*g12*g22;
    real G3_2_2_2_0 = det*c2*c0*g22*g02;
    real G3_2_2_2_1 = det*c2*c0*g22*g12;
    real G3_2_2_2_2 = det*c2*c0*g22*g22;
    real G4_0_0_0_0_0_0 = det*c1*c0*w[0][0]*w[0][0]*g00*g00;
    real G4_0_0_0_0_0_1 = det*c1*c0*w[0][0]*w[0][0]*g00*g10;
    real G4_0_0_0_0_0_2 = det*c1*c0*w[0][0]*w[0][0]*g00*g20;
    real G4_0_0_0_0_1_0 = det*c1*c0*w[0][0]*w[0][1]*g00*g00;
    real G4_0_0_0_0_1_1 = det*c1*c0*w[0][0]*w[0][1]*g00*g10;
    real G4_0_0_0_0_1_2 = det*c1*c0*w[0][0]*w[0][1]*g00*g20;
    real G4_0_0_0_0_2_0 = det*c1*c0*w[0][0]*w[0][2]*g00*g00;
    real G4_0_0_0_0_2_1 = det*c1*c0*w[0][0]*w[0][2]*g00*g10;
    real G4_0_0_0_0_2_2 = det*c1*c0*w[0][0]*w[0][2]*g00*g20;
    real G4_0_0_0_0_3_0 = det*c1*c0*w[0][0]*w[0][3]*g00*g00;
    real G4_0_0_0_0_3_1 = det*c1*c0*w[0][0]*w[0][3]*g00*g10;
    real G4_0_0_0_0_3_2 = det*c1*c0*w[0][0]*w[0][3]*g00*g20;
    real G4_0_0_0_1_0_0 = det*c1*c0*w[0][0]*w[0][0]*g10*g00;
    real G4_0_0_0_1_0_1 = det*c1*c0*w[0][0]*w[0][0]*g10*g10;
    real G4_0_0_0_1_0_2 = det*c1*c0*w[0][0]*w[0][0]*g10*g20;
    real G4_0_0_0_1_1_0 = det*c1*c0*w[0][0]*w[0][1]*g10*g00;
    real G4_0_0_0_1_1_1 = det*c1*c0*w[0][0]*w[0][1]*g10*g10;
    real G4_0_0_0_1_1_2 = det*c1*c0*w[0][0]*w[0][1]*g10*g20;
    real G4_0_0_0_1_2_0 = det*c1*c0*w[0][0]*w[0][2]*g10*g00;
    real G4_0_0_0_1_2_1 = det*c1*c0*w[0][0]*w[0][2]*g10*g10;
    real G4_0_0_0_1_2_2 = det*c1*c0*w[0][0]*w[0][2]*g10*g20;
    real G4_0_0_0_1_3_0 = det*c1*c0*w[0][0]*w[0][3]*g10*g00;
    real G4_0_0_0_1_3_1 = det*c1*c0*w[0][0]*w[0][3]*g10*g10;
    real G4_0_0_0_1_3_2 = det*c1*c0*w[0][0]*w[0][3]*g10*g20;
    real G4_0_0_0_2_0_0 = det*c1*c0*w[0][0]*w[0][0]*g20*g00;
    real G4_0_0_0_2_0_1 = det*c1*c0*w[0][0]*w[0][0]*g20*g10;
    real G4_0_0_0_2_0_2 = det*c1*c0*w[0][0]*w[0][0]*g20*g20;
    real G4_0_0_0_2_1_0 = det*c1*c0*w[0][0]*w[0][1]*g20*g00;
    real G4_0_0_0_2_1_1 = det*c1*c0*w[0][0]*w[0][1]*g20*g10;
    real G4_0_0_0_2_1_2 = det*c1*c0*w[0][0]*w[0][1]*g20*g20;
    real G4_0_0_0_2_2_0 = det*c1*c0*w[0][0]*w[0][2]*g20*g00;
    real G4_0_0_0_2_2_1 = det*c1*c0*w[0][0]*w[0][2]*g20*g10;
    real G4_0_0_0_2_2_2 = det*c1*c0*w[0][0]*w[0][2]*g20*g20;
    real G4_0_0_0_2_3_0 = det*c1*c0*w[0][0]*w[0][3]*g20*g00;
    real G4_0_0_0_2_3_1 = det*c1*c0*w[0][0]*w[0][3]*g20*g10;
    real G4_0_0_0_2_3_2 = det*c1*c0*w[0][0]*w[0][3]*g20*g20;
    real G4_0_0_1_0_0_0 = det*c1*c0*w[0][1]*w[0][0]*g00*g00;
    real G4_0_0_1_0_0_1 = det*c1*c0*w[0][1]*w[0][0]*g00*g10;
    real G4_0_0_1_0_0_2 = det*c1*c0*w[0][1]*w[0][0]*g00*g20;
    real G4_0_0_1_0_1_0 = det*c1*c0*w[0][1]*w[0][1]*g00*g00;
    real G4_0_0_1_0_1_1 = det*c1*c0*w[0][1]*w[0][1]*g00*g10;
    real G4_0_0_1_0_1_2 = det*c1*c0*w[0][1]*w[0][1]*g00*g20;
    real G4_0_0_1_0_2_0 = det*c1*c0*w[0][1]*w[0][2]*g00*g00;
    real G4_0_0_1_0_2_1 = det*c1*c0*w[0][1]*w[0][2]*g00*g10;
    real G4_0_0_1_0_2_2 = det*c1*c0*w[0][1]*w[0][2]*g00*g20;
    real G4_0_0_1_0_3_0 = det*c1*c0*w[0][1]*w[0][3]*g00*g00;
    real G4_0_0_1_0_3_1 = det*c1*c0*w[0][1]*w[0][3]*g00*g10;
    real G4_0_0_1_0_3_2 = det*c1*c0*w[0][1]*w[0][3]*g00*g20;
    real G4_0_0_1_1_0_0 = det*c1*c0*w[0][1]*w[0][0]*g10*g00;
    real G4_0_0_1_1_0_1 = det*c1*c0*w[0][1]*w[0][0]*g10*g10;
    real G4_0_0_1_1_0_2 = det*c1*c0*w[0][1]*w[0][0]*g10*g20;
    real G4_0_0_1_1_1_0 = det*c1*c0*w[0][1]*w[0][1]*g10*g00;
    real G4_0_0_1_1_1_1 = det*c1*c0*w[0][1]*w[0][1]*g10*g10;
    real G4_0_0_1_1_1_2 = det*c1*c0*w[0][1]*w[0][1]*g10*g20;
    real G4_0_0_1_1_2_0 = det*c1*c0*w[0][1]*w[0][2]*g10*g00;
    real G4_0_0_1_1_2_1 = det*c1*c0*w[0][1]*w[0][2]*g10*g10;
    real G4_0_0_1_1_2_2 = det*c1*c0*w[0][1]*w[0][2]*g10*g20;
    real G4_0_0_1_1_3_0 = det*c1*c0*w[0][1]*w[0][3]*g10*g00;
    real G4_0_0_1_1_3_1 = det*c1*c0*w[0][1]*w[0][3]*g10*g10;
    real G4_0_0_1_1_3_2 = det*c1*c0*w[0][1]*w[0][3]*g10*g20;
    real G4_0_0_1_2_0_0 = det*c1*c0*w[0][1]*w[0][0]*g20*g00;
    real G4_0_0_1_2_0_1 = det*c1*c0*w[0][1]*w[0][0]*g20*g10;
    real G4_0_0_1_2_0_2 = det*c1*c0*w[0][1]*w[0][0]*g20*g20;
    real G4_0_0_1_2_1_0 = det*c1*c0*w[0][1]*w[0][1]*g20*g00;
    real G4_0_0_1_2_1_1 = det*c1*c0*w[0][1]*w[0][1]*g20*g10;
    real G4_0_0_1_2_1_2 = det*c1*c0*w[0][1]*w[0][1]*g20*g20;
    real G4_0_0_1_2_2_0 = det*c1*c0*w[0][1]*w[0][2]*g20*g00;
    real G4_0_0_1_2_2_1 = det*c1*c0*w[0][1]*w[0][2]*g20*g10;
    real G4_0_0_1_2_2_2 = det*c1*c0*w[0][1]*w[0][2]*g20*g20;
    real G4_0_0_1_2_3_0 = det*c1*c0*w[0][1]*w[0][3]*g20*g00;
    real G4_0_0_1_2_3_1 = det*c1*c0*w[0][1]*w[0][3]*g20*g10;
    real G4_0_0_1_2_3_2 = det*c1*c0*w[0][1]*w[0][3]*g20*g20;
    real G4_0_0_2_0_0_0 = det*c1*c0*w[0][2]*w[0][0]*g00*g00;
    real G4_0_0_2_0_0_1 = det*c1*c0*w[0][2]*w[0][0]*g00*g10;
    real G4_0_0_2_0_0_2 = det*c1*c0*w[0][2]*w[0][0]*g00*g20;
    real G4_0_0_2_0_1_0 = det*c1*c0*w[0][2]*w[0][1]*g00*g00;
    real G4_0_0_2_0_1_1 = det*c1*c0*w[0][2]*w[0][1]*g00*g10;
    real G4_0_0_2_0_1_2 = det*c1*c0*w[0][2]*w[0][1]*g00*g20;
    real G4_0_0_2_0_2_0 = det*c1*c0*w[0][2]*w[0][2]*g00*g00;
    real G4_0_0_2_0_2_1 = det*c1*c0*w[0][2]*w[0][2]*g00*g10;
    real G4_0_0_2_0_2_2 = det*c1*c0*w[0][2]*w[0][2]*g00*g20;
    real G4_0_0_2_0_3_0 = det*c1*c0*w[0][2]*w[0][3]*g00*g00;
    real G4_0_0_2_0_3_1 = det*c1*c0*w[0][2]*w[0][3]*g00*g10;
    real G4_0_0_2_0_3_2 = det*c1*c0*w[0][2]*w[0][3]*g00*g20;
    real G4_0_0_2_1_0_0 = det*c1*c0*w[0][2]*w[0][0]*g10*g00;
    real G4_0_0_2_1_0_1 = det*c1*c0*w[0][2]*w[0][0]*g10*g10;
    real G4_0_0_2_1_0_2 = det*c1*c0*w[0][2]*w[0][0]*g10*g20;
    real G4_0_0_2_1_1_0 = det*c1*c0*w[0][2]*w[0][1]*g10*g00;
    real G4_0_0_2_1_1_1 = det*c1*c0*w[0][2]*w[0][1]*g10*g10;
    real G4_0_0_2_1_1_2 = det*c1*c0*w[0][2]*w[0][1]*g10*g20;
    real G4_0_0_2_1_2_0 = det*c1*c0*w[0][2]*w[0][2]*g10*g00;
    real G4_0_0_2_1_2_1 = det*c1*c0*w[0][2]*w[0][2]*g10*g10;
    real G4_0_0_2_1_2_2 = det*c1*c0*w[0][2]*w[0][2]*g10*g20;
    real G4_0_0_2_1_3_0 = det*c1*c0*w[0][2]*w[0][3]*g10*g00;
    real G4_0_0_2_1_3_1 = det*c1*c0*w[0][2]*w[0][3]*g10*g10;
    real G4_0_0_2_1_3_2 = det*c1*c0*w[0][2]*w[0][3]*g10*g20;
    real G4_0_0_2_2_0_0 = det*c1*c0*w[0][2]*w[0][0]*g20*g00;
    real G4_0_0_2_2_0_1 = det*c1*c0*w[0][2]*w[0][0]*g20*g10;
    real G4_0_0_2_2_0_2 = det*c1*c0*w[0][2]*w[0][0]*g20*g20;
    real G4_0_0_2_2_1_0 = det*c1*c0*w[0][2]*w[0][1]*g20*g00;
    real G4_0_0_2_2_1_1 = det*c1*c0*w[0][2]*w[0][1]*g20*g10;
    real G4_0_0_2_2_1_2 = det*c1*c0*w[0][2]*w[0][1]*g20*g20;
    real G4_0_0_2_2_2_0 = det*c1*c0*w[0][2]*w[0][2]*g20*g00;
    real G4_0_0_2_2_2_1 = det*c1*c0*w[0][2]*w[0][2]*g20*g10;
    real G4_0_0_2_2_2_2 = det*c1*c0*w[0][2]*w[0][2]*g20*g20;
    real G4_0_0_2_2_3_0 = det*c1*c0*w[0][2]*w[0][3]*g20*g00;
    real G4_0_0_2_2_3_1 = det*c1*c0*w[0][2]*w[0][3]*g20*g10;
    real G4_0_0_2_2_3_2 = det*c1*c0*w[0][2]*w[0][3]*g20*g20;
    real G4_0_0_3_0_0_0 = det*c1*c0*w[0][3]*w[0][0]*g00*g00;
    real G4_0_0_3_0_0_1 = det*c1*c0*w[0][3]*w[0][0]*g00*g10;
    real G4_0_0_3_0_0_2 = det*c1*c0*w[0][3]*w[0][0]*g00*g20;
    real G4_0_0_3_0_1_0 = det*c1*c0*w[0][3]*w[0][1]*g00*g00;
    real G4_0_0_3_0_1_1 = det*c1*c0*w[0][3]*w[0][1]*g00*g10;
    real G4_0_0_3_0_1_2 = det*c1*c0*w[0][3]*w[0][1]*g00*g20;
    real G4_0_0_3_0_2_0 = det*c1*c0*w[0][3]*w[0][2]*g00*g00;
    real G4_0_0_3_0_2_1 = det*c1*c0*w[0][3]*w[0][2]*g00*g10;
    real G4_0_0_3_0_2_2 = det*c1*c0*w[0][3]*w[0][2]*g00*g20;
    real G4_0_0_3_0_3_0 = det*c1*c0*w[0][3]*w[0][3]*g00*g00;
    real G4_0_0_3_0_3_1 = det*c1*c0*w[0][3]*w[0][3]*g00*g10;
    real G4_0_0_3_0_3_2 = det*c1*c0*w[0][3]*w[0][3]*g00*g20;
    real G4_0_0_3_1_0_0 = det*c1*c0*w[0][3]*w[0][0]*g10*g00;
    real G4_0_0_3_1_0_1 = det*c1*c0*w[0][3]*w[0][0]*g10*g10;
    real G4_0_0_3_1_0_2 = det*c1*c0*w[0][3]*w[0][0]*g10*g20;
    real G4_0_0_3_1_1_0 = det*c1*c0*w[0][3]*w[0][1]*g10*g00;
    real G4_0_0_3_1_1_1 = det*c1*c0*w[0][3]*w[0][1]*g10*g10;
    real G4_0_0_3_1_1_2 = det*c1*c0*w[0][3]*w[0][1]*g10*g20;
    real G4_0_0_3_1_2_0 = det*c1*c0*w[0][3]*w[0][2]*g10*g00;
    real G4_0_0_3_1_2_1 = det*c1*c0*w[0][3]*w[0][2]*g10*g10;
    real G4_0_0_3_1_2_2 = det*c1*c0*w[0][3]*w[0][2]*g10*g20;
    real G4_0_0_3_1_3_0 = det*c1*c0*w[0][3]*w[0][3]*g10*g00;
    real G4_0_0_3_1_3_1 = det*c1*c0*w[0][3]*w[0][3]*g10*g10;
    real G4_0_0_3_1_3_2 = det*c1*c0*w[0][3]*w[0][3]*g10*g20;
    real G4_0_0_3_2_0_0 = det*c1*c0*w[0][3]*w[0][0]*g20*g00;
    real G4_0_0_3_2_0_1 = det*c1*c0*w[0][3]*w[0][0]*g20*g10;
    real G4_0_0_3_2_0_2 = det*c1*c0*w[0][3]*w[0][0]*g20*g20;
    real G4_0_0_3_2_1_0 = det*c1*c0*w[0][3]*w[0][1]*g20*g00;
    real G4_0_0_3_2_1_1 = det*c1*c0*w[0][3]*w[0][1]*g20*g10;
    real G4_0_0_3_2_1_2 = det*c1*c0*w[0][3]*w[0][1]*g20*g20;
    real G4_0_0_3_2_2_0 = det*c1*c0*w[0][3]*w[0][2]*g20*g00;
    real G4_0_0_3_2_2_1 = det*c1*c0*w[0][3]*w[0][2]*g20*g10;
    real G4_0_0_3_2_2_2 = det*c1*c0*w[0][3]*w[0][2]*g20*g20;
    real G4_0_0_3_2_3_0 = det*c1*c0*w[0][3]*w[0][3]*g20*g00;
    real G4_0_0_3_2_3_1 = det*c1*c0*w[0][3]*w[0][3]*g20*g10;
    real G4_0_0_3_2_3_2 = det*c1*c0*w[0][3]*w[0][3]*g20*g20;
    real G4_0_1_0_0_4_0 = det*c1*c0*w[0][0]*w[0][4]*g00*g01;
    real G4_0_1_0_0_4_1 = det*c1*c0*w[0][0]*w[0][4]*g00*g11;
    real G4_0_1_0_0_4_2 = det*c1*c0*w[0][0]*w[0][4]*g00*g21;
    real G4_0_1_0_0_5_0 = det*c1*c0*w[0][0]*w[0][5]*g00*g01;
    real G4_0_1_0_0_5_1 = det*c1*c0*w[0][0]*w[0][5]*g00*g11;
    real G4_0_1_0_0_5_2 = det*c1*c0*w[0][0]*w[0][5]*g00*g21;
    real G4_0_1_0_0_6_0 = det*c1*c0*w[0][0]*w[0][6]*g00*g01;
    real G4_0_1_0_0_6_1 = det*c1*c0*w[0][0]*w[0][6]*g00*g11;
    real G4_0_1_0_0_6_2 = det*c1*c0*w[0][0]*w[0][6]*g00*g21;
    real G4_0_1_0_0_7_0 = det*c1*c0*w[0][0]*w[0][7]*g00*g01;
    real G4_0_1_0_0_7_1 = det*c1*c0*w[0][0]*w[0][7]*g00*g11;
    real G4_0_1_0_0_7_2 = det*c1*c0*w[0][0]*w[0][7]*g00*g21;
    real G4_0_1_0_1_4_0 = det*c1*c0*w[0][0]*w[0][4]*g10*g01;
    real G4_0_1_0_1_4_1 = det*c1*c0*w[0][0]*w[0][4]*g10*g11;
    real G4_0_1_0_1_4_2 = det*c1*c0*w[0][0]*w[0][4]*g10*g21;
    real G4_0_1_0_1_5_0 = det*c1*c0*w[0][0]*w[0][5]*g10*g01;
    real G4_0_1_0_1_5_1 = det*c1*c0*w[0][0]*w[0][5]*g10*g11;
    real G4_0_1_0_1_5_2 = det*c1*c0*w[0][0]*w[0][5]*g10*g21;
    real G4_0_1_0_1_6_0 = det*c1*c0*w[0][0]*w[0][6]*g10*g01;
    real G4_0_1_0_1_6_1 = det*c1*c0*w[0][0]*w[0][6]*g10*g11;
    real G4_0_1_0_1_6_2 = det*c1*c0*w[0][0]*w[0][6]*g10*g21;
    real G4_0_1_0_1_7_0 = det*c1*c0*w[0][0]*w[0][7]*g10*g01;
    real G4_0_1_0_1_7_1 = det*c1*c0*w[0][0]*w[0][7]*g10*g11;
    real G4_0_1_0_1_7_2 = det*c1*c0*w[0][0]*w[0][7]*g10*g21;
    real G4_0_1_0_2_4_0 = det*c1*c0*w[0][0]*w[0][4]*g20*g01;
    real G4_0_1_0_2_4_1 = det*c1*c0*w[0][0]*w[0][4]*g20*g11;
    real G4_0_1_0_2_4_2 = det*c1*c0*w[0][0]*w[0][4]*g20*g21;
    real G4_0_1_0_2_5_0 = det*c1*c0*w[0][0]*w[0][5]*g20*g01;
    real G4_0_1_0_2_5_1 = det*c1*c0*w[0][0]*w[0][5]*g20*g11;
    real G4_0_1_0_2_5_2 = det*c1*c0*w[0][0]*w[0][5]*g20*g21;
    real G4_0_1_0_2_6_0 = det*c1*c0*w[0][0]*w[0][6]*g20*g01;
    real G4_0_1_0_2_6_1 = det*c1*c0*w[0][0]*w[0][6]*g20*g11;
    real G4_0_1_0_2_6_2 = det*c1*c0*w[0][0]*w[0][6]*g20*g21;
    real G4_0_1_0_2_7_0 = det*c1*c0*w[0][0]*w[0][7]*g20*g01;
    real G4_0_1_0_2_7_1 = det*c1*c0*w[0][0]*w[0][7]*g20*g11;
    real G4_0_1_0_2_7_2 = det*c1*c0*w[0][0]*w[0][7]*g20*g21;
    real G4_0_1_1_0_4_0 = det*c1*c0*w[0][1]*w[0][4]*g00*g01;
    real G4_0_1_1_0_4_1 = det*c1*c0*w[0][1]*w[0][4]*g00*g11;
    real G4_0_1_1_0_4_2 = det*c1*c0*w[0][1]*w[0][4]*g00*g21;
    real G4_0_1_1_0_5_0 = det*c1*c0*w[0][1]*w[0][5]*g00*g01;
    real G4_0_1_1_0_5_1 = det*c1*c0*w[0][1]*w[0][5]*g00*g11;
    real G4_0_1_1_0_5_2 = det*c1*c0*w[0][1]*w[0][5]*g00*g21;
    real G4_0_1_1_0_6_0 = det*c1*c0*w[0][1]*w[0][6]*g00*g01;
    real G4_0_1_1_0_6_1 = det*c1*c0*w[0][1]*w[0][6]*g00*g11;
    real G4_0_1_1_0_6_2 = det*c1*c0*w[0][1]*w[0][6]*g00*g21;
    real G4_0_1_1_0_7_0 = det*c1*c0*w[0][1]*w[0][7]*g00*g01;
    real G4_0_1_1_0_7_1 = det*c1*c0*w[0][1]*w[0][7]*g00*g11;
    real G4_0_1_1_0_7_2 = det*c1*c0*w[0][1]*w[0][7]*g00*g21;
    real G4_0_1_1_1_4_0 = det*c1*c0*w[0][1]*w[0][4]*g10*g01;
    real G4_0_1_1_1_4_1 = det*c1*c0*w[0][1]*w[0][4]*g10*g11;
    real G4_0_1_1_1_4_2 = det*c1*c0*w[0][1]*w[0][4]*g10*g21;
    real G4_0_1_1_1_5_0 = det*c1*c0*w[0][1]*w[0][5]*g10*g01;
    real G4_0_1_1_1_5_1 = det*c1*c0*w[0][1]*w[0][5]*g10*g11;
    real G4_0_1_1_1_5_2 = det*c1*c0*w[0][1]*w[0][5]*g10*g21;
    real G4_0_1_1_1_6_0 = det*c1*c0*w[0][1]*w[0][6]*g10*g01;
    real G4_0_1_1_1_6_1 = det*c1*c0*w[0][1]*w[0][6]*g10*g11;
    real G4_0_1_1_1_6_2 = det*c1*c0*w[0][1]*w[0][6]*g10*g21;
    real G4_0_1_1_1_7_0 = det*c1*c0*w[0][1]*w[0][7]*g10*g01;
    real G4_0_1_1_1_7_1 = det*c1*c0*w[0][1]*w[0][7]*g10*g11;
    real G4_0_1_1_1_7_2 = det*c1*c0*w[0][1]*w[0][7]*g10*g21;
    real G4_0_1_1_2_4_0 = det*c1*c0*w[0][1]*w[0][4]*g20*g01;
    real G4_0_1_1_2_4_1 = det*c1*c0*w[0][1]*w[0][4]*g20*g11;
    real G4_0_1_1_2_4_2 = det*c1*c0*w[0][1]*w[0][4]*g20*g21;
    real G4_0_1_1_2_5_0 = det*c1*c0*w[0][1]*w[0][5]*g20*g01;
    real G4_0_1_1_2_5_1 = det*c1*c0*w[0][1]*w[0][5]*g20*g11;
    real G4_0_1_1_2_5_2 = det*c1*c0*w[0][1]*w[0][5]*g20*g21;
    real G4_0_1_1_2_6_0 = det*c1*c0*w[0][1]*w[0][6]*g20*g01;
    real G4_0_1_1_2_6_1 = det*c1*c0*w[0][1]*w[0][6]*g20*g11;
    real G4_0_1_1_2_6_2 = det*c1*c0*w[0][1]*w[0][6]*g20*g21;
    real G4_0_1_1_2_7_0 = det*c1*c0*w[0][1]*w[0][7]*g20*g01;
    real G4_0_1_1_2_7_1 = det*c1*c0*w[0][1]*w[0][7]*g20*g11;
    real G4_0_1_1_2_7_2 = det*c1*c0*w[0][1]*w[0][7]*g20*g21;
    real G4_0_1_2_0_4_0 = det*c1*c0*w[0][2]*w[0][4]*g00*g01;
    real G4_0_1_2_0_4_1 = det*c1*c0*w[0][2]*w[0][4]*g00*g11;
    real G4_0_1_2_0_4_2 = det*c1*c0*w[0][2]*w[0][4]*g00*g21;
    real G4_0_1_2_0_5_0 = det*c1*c0*w[0][2]*w[0][5]*g00*g01;
    real G4_0_1_2_0_5_1 = det*c1*c0*w[0][2]*w[0][5]*g00*g11;
    real G4_0_1_2_0_5_2 = det*c1*c0*w[0][2]*w[0][5]*g00*g21;
    real G4_0_1_2_0_6_0 = det*c1*c0*w[0][2]*w[0][6]*g00*g01;
    real G4_0_1_2_0_6_1 = det*c1*c0*w[0][2]*w[0][6]*g00*g11;
    real G4_0_1_2_0_6_2 = det*c1*c0*w[0][2]*w[0][6]*g00*g21;
    real G4_0_1_2_0_7_0 = det*c1*c0*w[0][2]*w[0][7]*g00*g01;
    real G4_0_1_2_0_7_1 = det*c1*c0*w[0][2]*w[0][7]*g00*g11;
    real G4_0_1_2_0_7_2 = det*c1*c0*w[0][2]*w[0][7]*g00*g21;
    real G4_0_1_2_1_4_0 = det*c1*c0*w[0][2]*w[0][4]*g10*g01;
    real G4_0_1_2_1_4_1 = det*c1*c0*w[0][2]*w[0][4]*g10*g11;
    real G4_0_1_2_1_4_2 = det*c1*c0*w[0][2]*w[0][4]*g10*g21;
    real G4_0_1_2_1_5_0 = det*c1*c0*w[0][2]*w[0][5]*g10*g01;
    real G4_0_1_2_1_5_1 = det*c1*c0*w[0][2]*w[0][5]*g10*g11;
    real G4_0_1_2_1_5_2 = det*c1*c0*w[0][2]*w[0][5]*g10*g21;
    real G4_0_1_2_1_6_0 = det*c1*c0*w[0][2]*w[0][6]*g10*g01;
    real G4_0_1_2_1_6_1 = det*c1*c0*w[0][2]*w[0][6]*g10*g11;
    real G4_0_1_2_1_6_2 = det*c1*c0*w[0][2]*w[0][6]*g10*g21;
    real G4_0_1_2_1_7_0 = det*c1*c0*w[0][2]*w[0][7]*g10*g01;
    real G4_0_1_2_1_7_1 = det*c1*c0*w[0][2]*w[0][7]*g10*g11;
    real G4_0_1_2_1_7_2 = det*c1*c0*w[0][2]*w[0][7]*g10*g21;
    real G4_0_1_2_2_4_0 = det*c1*c0*w[0][2]*w[0][4]*g20*g01;
    real G4_0_1_2_2_4_1 = det*c1*c0*w[0][2]*w[0][4]*g20*g11;
    real G4_0_1_2_2_4_2 = det*c1*c0*w[0][2]*w[0][4]*g20*g21;
    real G4_0_1_2_2_5_0 = det*c1*c0*w[0][2]*w[0][5]*g20*g01;
    real G4_0_1_2_2_5_1 = det*c1*c0*w[0][2]*w[0][5]*g20*g11;
    real G4_0_1_2_2_5_2 = det*c1*c0*w[0][2]*w[0][5]*g20*g21;
    real G4_0_1_2_2_6_0 = det*c1*c0*w[0][2]*w[0][6]*g20*g01;
    real G4_0_1_2_2_6_1 = det*c1*c0*w[0][2]*w[0][6]*g20*g11;
    real G4_0_1_2_2_6_2 = det*c1*c0*w[0][2]*w[0][6]*g20*g21;
    real G4_0_1_2_2_7_0 = det*c1*c0*w[0][2]*w[0][7]*g20*g01;
    real G4_0_1_2_2_7_1 = det*c1*c0*w[0][2]*w[0][7]*g20*g11;
    real G4_0_1_2_2_7_2 = det*c1*c0*w[0][2]*w[0][7]*g20*g21;
    real G4_0_1_3_0_4_0 = det*c1*c0*w[0][3]*w[0][4]*g00*g01;
    real G4_0_1_3_0_4_1 = det*c1*c0*w[0][3]*w[0][4]*g00*g11;
    real G4_0_1_3_0_4_2 = det*c1*c0*w[0][3]*w[0][4]*g00*g21;
    real G4_0_1_3_0_5_0 = det*c1*c0*w[0][3]*w[0][5]*g00*g01;
    real G4_0_1_3_0_5_1 = det*c1*c0*w[0][3]*w[0][5]*g00*g11;
    real G4_0_1_3_0_5_2 = det*c1*c0*w[0][3]*w[0][5]*g00*g21;
    real G4_0_1_3_0_6_0 = det*c1*c0*w[0][3]*w[0][6]*g00*g01;
    real G4_0_1_3_0_6_1 = det*c1*c0*w[0][3]*w[0][6]*g00*g11;
    real G4_0_1_3_0_6_2 = det*c1*c0*w[0][3]*w[0][6]*g00*g21;
    real G4_0_1_3_0_7_0 = det*c1*c0*w[0][3]*w[0][7]*g00*g01;
    real G4_0_1_3_0_7_1 = det*c1*c0*w[0][3]*w[0][7]*g00*g11;
    real G4_0_1_3_0_7_2 = det*c1*c0*w[0][3]*w[0][7]*g00*g21;
    real G4_0_1_3_1_4_0 = det*c1*c0*w[0][3]*w[0][4]*g10*g01;
    real G4_0_1_3_1_4_1 = det*c1*c0*w[0][3]*w[0][4]*g10*g11;
    real G4_0_1_3_1_4_2 = det*c1*c0*w[0][3]*w[0][4]*g10*g21;
    real G4_0_1_3_1_5_0 = det*c1*c0*w[0][3]*w[0][5]*g10*g01;
    real G4_0_1_3_1_5_1 = det*c1*c0*w[0][3]*w[0][5]*g10*g11;
    real G4_0_1_3_1_5_2 = det*c1*c0*w[0][3]*w[0][5]*g10*g21;
    real G4_0_1_3_1_6_0 = det*c1*c0*w[0][3]*w[0][6]*g10*g01;
    real G4_0_1_3_1_6_1 = det*c1*c0*w[0][3]*w[0][6]*g10*g11;
    real G4_0_1_3_1_6_2 = det*c1*c0*w[0][3]*w[0][6]*g10*g21;
    real G4_0_1_3_1_7_0 = det*c1*c0*w[0][3]*w[0][7]*g10*g01;
    real G4_0_1_3_1_7_1 = det*c1*c0*w[0][3]*w[0][7]*g10*g11;
    real G4_0_1_3_1_7_2 = det*c1*c0*w[0][3]*w[0][7]*g10*g21;
    real G4_0_1_3_2_4_0 = det*c1*c0*w[0][3]*w[0][4]*g20*g01;
    real G4_0_1_3_2_4_1 = det*c1*c0*w[0][3]*w[0][4]*g20*g11;
    real G4_0_1_3_2_4_2 = det*c1*c0*w[0][3]*w[0][4]*g20*g21;
    real G4_0_1_3_2_5_0 = det*c1*c0*w[0][3]*w[0][5]*g20*g01;
    real G4_0_1_3_2_5_1 = det*c1*c0*w[0][3]*w[0][5]*g20*g11;
    real G4_0_1_3_2_5_2 = det*c1*c0*w[0][3]*w[0][5]*g20*g21;
    real G4_0_1_3_2_6_0 = det*c1*c0*w[0][3]*w[0][6]*g20*g01;
    real G4_0_1_3_2_6_1 = det*c1*c0*w[0][3]*w[0][6]*g20*g11;
    real G4_0_1_3_2_6_2 = det*c1*c0*w[0][3]*w[0][6]*g20*g21;
    real G4_0_1_3_2_7_0 = det*c1*c0*w[0][3]*w[0][7]*g20*g01;
    real G4_0_1_3_2_7_1 = det*c1*c0*w[0][3]*w[0][7]*g20*g11;
    real G4_0_1_3_2_7_2 = det*c1*c0*w[0][3]*w[0][7]*g20*g21;
    real G4_0_2_0_0_8_0 = det*c1*c0*w[0][0]*w[0][8]*g00*g02;
    real G4_0_2_0_0_8_1 = det*c1*c0*w[0][0]*w[0][8]*g00*g12;
    real G4_0_2_0_0_8_2 = det*c1*c0*w[0][0]*w[0][8]*g00*g22;
    real G4_0_2_0_0_9_0 = det*c1*c0*w[0][0]*w[0][9]*g00*g02;
    real G4_0_2_0_0_9_1 = det*c1*c0*w[0][0]*w[0][9]*g00*g12;
    real G4_0_2_0_0_9_2 = det*c1*c0*w[0][0]*w[0][9]*g00*g22;
    real G4_0_2_0_0_10_0 = det*c1*c0*w[0][0]*w[0][10]*g00*g02;
    real G4_0_2_0_0_10_1 = det*c1*c0*w[0][0]*w[0][10]*g00*g12;
    real G4_0_2_0_0_10_2 = det*c1*c0*w[0][0]*w[0][10]*g00*g22;
    real G4_0_2_0_0_11_0 = det*c1*c0*w[0][0]*w[0][11]*g00*g02;
    real G4_0_2_0_0_11_1 = det*c1*c0*w[0][0]*w[0][11]*g00*g12;
    real G4_0_2_0_0_11_2 = det*c1*c0*w[0][0]*w[0][11]*g00*g22;
    real G4_0_2_0_1_8_0 = det*c1*c0*w[0][0]*w[0][8]*g10*g02;
    real G4_0_2_0_1_8_1 = det*c1*c0*w[0][0]*w[0][8]*g10*g12;
    real G4_0_2_0_1_8_2 = det*c1*c0*w[0][0]*w[0][8]*g10*g22;
    real G4_0_2_0_1_9_0 = det*c1*c0*w[0][0]*w[0][9]*g10*g02;
    real G4_0_2_0_1_9_1 = det*c1*c0*w[0][0]*w[0][9]*g10*g12;
    real G4_0_2_0_1_9_2 = det*c1*c0*w[0][0]*w[0][9]*g10*g22;
    real G4_0_2_0_1_10_0 = det*c1*c0*w[0][0]*w[0][10]*g10*g02;
    real G4_0_2_0_1_10_1 = det*c1*c0*w[0][0]*w[0][10]*g10*g12;
    real G4_0_2_0_1_10_2 = det*c1*c0*w[0][0]*w[0][10]*g10*g22;
    real G4_0_2_0_1_11_0 = det*c1*c0*w[0][0]*w[0][11]*g10*g02;
    real G4_0_2_0_1_11_1 = det*c1*c0*w[0][0]*w[0][11]*g10*g12;
    real G4_0_2_0_1_11_2 = det*c1*c0*w[0][0]*w[0][11]*g10*g22;
    real G4_0_2_0_2_8_0 = det*c1*c0*w[0][0]*w[0][8]*g20*g02;
    real G4_0_2_0_2_8_1 = det*c1*c0*w[0][0]*w[0][8]*g20*g12;
    real G4_0_2_0_2_8_2 = det*c1*c0*w[0][0]*w[0][8]*g20*g22;
    real G4_0_2_0_2_9_0 = det*c1*c0*w[0][0]*w[0][9]*g20*g02;
    real G4_0_2_0_2_9_1 = det*c1*c0*w[0][0]*w[0][9]*g20*g12;
    real G4_0_2_0_2_9_2 = det*c1*c0*w[0][0]*w[0][9]*g20*g22;
    real G4_0_2_0_2_10_0 = det*c1*c0*w[0][0]*w[0][10]*g20*g02;
    real G4_0_2_0_2_10_1 = det*c1*c0*w[0][0]*w[0][10]*g20*g12;
    real G4_0_2_0_2_10_2 = det*c1*c0*w[0][0]*w[0][10]*g20*g22;
    real G4_0_2_0_2_11_0 = det*c1*c0*w[0][0]*w[0][11]*g20*g02;
    real G4_0_2_0_2_11_1 = det*c1*c0*w[0][0]*w[0][11]*g20*g12;
    real G4_0_2_0_2_11_2 = det*c1*c0*w[0][0]*w[0][11]*g20*g22;
    real G4_0_2_1_0_8_0 = det*c1*c0*w[0][1]*w[0][8]*g00*g02;
    real G4_0_2_1_0_8_1 = det*c1*c0*w[0][1]*w[0][8]*g00*g12;
    real G4_0_2_1_0_8_2 = det*c1*c0*w[0][1]*w[0][8]*g00*g22;
    real G4_0_2_1_0_9_0 = det*c1*c0*w[0][1]*w[0][9]*g00*g02;
    real G4_0_2_1_0_9_1 = det*c1*c0*w[0][1]*w[0][9]*g00*g12;
    real G4_0_2_1_0_9_2 = det*c1*c0*w[0][1]*w[0][9]*g00*g22;
    real G4_0_2_1_0_10_0 = det*c1*c0*w[0][1]*w[0][10]*g00*g02;
    real G4_0_2_1_0_10_1 = det*c1*c0*w[0][1]*w[0][10]*g00*g12;
    real G4_0_2_1_0_10_2 = det*c1*c0*w[0][1]*w[0][10]*g00*g22;
    real G4_0_2_1_0_11_0 = det*c1*c0*w[0][1]*w[0][11]*g00*g02;
    real G4_0_2_1_0_11_1 = det*c1*c0*w[0][1]*w[0][11]*g00*g12;
    real G4_0_2_1_0_11_2 = det*c1*c0*w[0][1]*w[0][11]*g00*g22;
    real G4_0_2_1_1_8_0 = det*c1*c0*w[0][1]*w[0][8]*g10*g02;
    real G4_0_2_1_1_8_1 = det*c1*c0*w[0][1]*w[0][8]*g10*g12;
    real G4_0_2_1_1_8_2 = det*c1*c0*w[0][1]*w[0][8]*g10*g22;
    real G4_0_2_1_1_9_0 = det*c1*c0*w[0][1]*w[0][9]*g10*g02;
    real G4_0_2_1_1_9_1 = det*c1*c0*w[0][1]*w[0][9]*g10*g12;
    real G4_0_2_1_1_9_2 = det*c1*c0*w[0][1]*w[0][9]*g10*g22;
    real G4_0_2_1_1_10_0 = det*c1*c0*w[0][1]*w[0][10]*g10*g02;
    real G4_0_2_1_1_10_1 = det*c1*c0*w[0][1]*w[0][10]*g10*g12;
    real G4_0_2_1_1_10_2 = det*c1*c0*w[0][1]*w[0][10]*g10*g22;
    real G4_0_2_1_1_11_0 = det*c1*c0*w[0][1]*w[0][11]*g10*g02;
    real G4_0_2_1_1_11_1 = det*c1*c0*w[0][1]*w[0][11]*g10*g12;
    real G4_0_2_1_1_11_2 = det*c1*c0*w[0][1]*w[0][11]*g10*g22;
    real G4_0_2_1_2_8_0 = det*c1*c0*w[0][1]*w[0][8]*g20*g02;
    real G4_0_2_1_2_8_1 = det*c1*c0*w[0][1]*w[0][8]*g20*g12;
    real G4_0_2_1_2_8_2 = det*c1*c0*w[0][1]*w[0][8]*g20*g22;
    real G4_0_2_1_2_9_0 = det*c1*c0*w[0][1]*w[0][9]*g20*g02;
    real G4_0_2_1_2_9_1 = det*c1*c0*w[0][1]*w[0][9]*g20*g12;
    real G4_0_2_1_2_9_2 = det*c1*c0*w[0][1]*w[0][9]*g20*g22;
    real G4_0_2_1_2_10_0 = det*c1*c0*w[0][1]*w[0][10]*g20*g02;
    real G4_0_2_1_2_10_1 = det*c1*c0*w[0][1]*w[0][10]*g20*g12;
    real G4_0_2_1_2_10_2 = det*c1*c0*w[0][1]*w[0][10]*g20*g22;
    real G4_0_2_1_2_11_0 = det*c1*c0*w[0][1]*w[0][11]*g20*g02;
    real G4_0_2_1_2_11_1 = det*c1*c0*w[0][1]*w[0][11]*g20*g12;
    real G4_0_2_1_2_11_2 = det*c1*c0*w[0][1]*w[0][11]*g20*g22;
    real G4_0_2_2_0_8_0 = det*c1*c0*w[0][2]*w[0][8]*g00*g02;
    real G4_0_2_2_0_8_1 = det*c1*c0*w[0][2]*w[0][8]*g00*g12;
    real G4_0_2_2_0_8_2 = det*c1*c0*w[0][2]*w[0][8]*g00*g22;
    real G4_0_2_2_0_9_0 = det*c1*c0*w[0][2]*w[0][9]*g00*g02;
    real G4_0_2_2_0_9_1 = det*c1*c0*w[0][2]*w[0][9]*g00*g12;
    real G4_0_2_2_0_9_2 = det*c1*c0*w[0][2]*w[0][9]*g00*g22;
    real G4_0_2_2_0_10_0 = det*c1*c0*w[0][2]*w[0][10]*g00*g02;
    real G4_0_2_2_0_10_1 = det*c1*c0*w[0][2]*w[0][10]*g00*g12;
    real G4_0_2_2_0_10_2 = det*c1*c0*w[0][2]*w[0][10]*g00*g22;
    real G4_0_2_2_0_11_0 = det*c1*c0*w[0][2]*w[0][11]*g00*g02;
    real G4_0_2_2_0_11_1 = det*c1*c0*w[0][2]*w[0][11]*g00*g12;
    real G4_0_2_2_0_11_2 = det*c1*c0*w[0][2]*w[0][11]*g00*g22;
    real G4_0_2_2_1_8_0 = det*c1*c0*w[0][2]*w[0][8]*g10*g02;
    real G4_0_2_2_1_8_1 = det*c1*c0*w[0][2]*w[0][8]*g10*g12;
    real G4_0_2_2_1_8_2 = det*c1*c0*w[0][2]*w[0][8]*g10*g22;
    real G4_0_2_2_1_9_0 = det*c1*c0*w[0][2]*w[0][9]*g10*g02;
    real G4_0_2_2_1_9_1 = det*c1*c0*w[0][2]*w[0][9]*g10*g12;
    real G4_0_2_2_1_9_2 = det*c1*c0*w[0][2]*w[0][9]*g10*g22;
    real G4_0_2_2_1_10_0 = det*c1*c0*w[0][2]*w[0][10]*g10*g02;
    real G4_0_2_2_1_10_1 = det*c1*c0*w[0][2]*w[0][10]*g10*g12;
    real G4_0_2_2_1_10_2 = det*c1*c0*w[0][2]*w[0][10]*g10*g22;
    real G4_0_2_2_1_11_0 = det*c1*c0*w[0][2]*w[0][11]*g10*g02;
    real G4_0_2_2_1_11_1 = det*c1*c0*w[0][2]*w[0][11]*g10*g12;
    real G4_0_2_2_1_11_2 = det*c1*c0*w[0][2]*w[0][11]*g10*g22;
    real G4_0_2_2_2_8_0 = det*c1*c0*w[0][2]*w[0][8]*g20*g02;
    real G4_0_2_2_2_8_1 = det*c1*c0*w[0][2]*w[0][8]*g20*g12;
    real G4_0_2_2_2_8_2 = det*c1*c0*w[0][2]*w[0][8]*g20*g22;
    real G4_0_2_2_2_9_0 = det*c1*c0*w[0][2]*w[0][9]*g20*g02;
    real G4_0_2_2_2_9_1 = det*c1*c0*w[0][2]*w[0][9]*g20*g12;
    real G4_0_2_2_2_9_2 = det*c1*c0*w[0][2]*w[0][9]*g20*g22;
    real G4_0_2_2_2_10_0 = det*c1*c0*w[0][2]*w[0][10]*g20*g02;
    real G4_0_2_2_2_10_1 = det*c1*c0*w[0][2]*w[0][10]*g20*g12;
    real G4_0_2_2_2_10_2 = det*c1*c0*w[0][2]*w[0][10]*g20*g22;
    real G4_0_2_2_2_11_0 = det*c1*c0*w[0][2]*w[0][11]*g20*g02;
    real G4_0_2_2_2_11_1 = det*c1*c0*w[0][2]*w[0][11]*g20*g12;
    real G4_0_2_2_2_11_2 = det*c1*c0*w[0][2]*w[0][11]*g20*g22;
    real G4_0_2_3_0_8_0 = det*c1*c0*w[0][3]*w[0][8]*g00*g02;
    real G4_0_2_3_0_8_1 = det*c1*c0*w[0][3]*w[0][8]*g00*g12;
    real G4_0_2_3_0_8_2 = det*c1*c0*w[0][3]*w[0][8]*g00*g22;
    real G4_0_2_3_0_9_0 = det*c1*c0*w[0][3]*w[0][9]*g00*g02;
    real G4_0_2_3_0_9_1 = det*c1*c0*w[0][3]*w[0][9]*g00*g12;
    real G4_0_2_3_0_9_2 = det*c1*c0*w[0][3]*w[0][9]*g00*g22;
    real G4_0_2_3_0_10_0 = det*c1*c0*w[0][3]*w[0][10]*g00*g02;
    real G4_0_2_3_0_10_1 = det*c1*c0*w[0][3]*w[0][10]*g00*g12;
    real G4_0_2_3_0_10_2 = det*c1*c0*w[0][3]*w[0][10]*g00*g22;
    real G4_0_2_3_0_11_0 = det*c1*c0*w[0][3]*w[0][11]*g00*g02;
    real G4_0_2_3_0_11_1 = det*c1*c0*w[0][3]*w[0][11]*g00*g12;
    real G4_0_2_3_0_11_2 = det*c1*c0*w[0][3]*w[0][11]*g00*g22;
    real G4_0_2_3_1_8_0 = det*c1*c0*w[0][3]*w[0][8]*g10*g02;
    real G4_0_2_3_1_8_1 = det*c1*c0*w[0][3]*w[0][8]*g10*g12;
    real G4_0_2_3_1_8_2 = det*c1*c0*w[0][3]*w[0][8]*g10*g22;
    real G4_0_2_3_1_9_0 = det*c1*c0*w[0][3]*w[0][9]*g10*g02;
    real G4_0_2_3_1_9_1 = det*c1*c0*w[0][3]*w[0][9]*g10*g12;
    real G4_0_2_3_1_9_2 = det*c1*c0*w[0][3]*w[0][9]*g10*g22;
    real G4_0_2_3_1_10_0 = det*c1*c0*w[0][3]*w[0][10]*g10*g02;
    real G4_0_2_3_1_10_1 = det*c1*c0*w[0][3]*w[0][10]*g10*g12;
    real G4_0_2_3_1_10_2 = det*c1*c0*w[0][3]*w[0][10]*g10*g22;
    real G4_0_2_3_1_11_0 = det*c1*c0*w[0][3]*w[0][11]*g10*g02;
    real G4_0_2_3_1_11_1 = det*c1*c0*w[0][3]*w[0][11]*g10*g12;
    real G4_0_2_3_1_11_2 = det*c1*c0*w[0][3]*w[0][11]*g10*g22;
    real G4_0_2_3_2_8_0 = det*c1*c0*w[0][3]*w[0][8]*g20*g02;
    real G4_0_2_3_2_8_1 = det*c1*c0*w[0][3]*w[0][8]*g20*g12;
    real G4_0_2_3_2_8_2 = det*c1*c0*w[0][3]*w[0][8]*g20*g22;
    real G4_0_2_3_2_9_0 = det*c1*c0*w[0][3]*w[0][9]*g20*g02;
    real G4_0_2_3_2_9_1 = det*c1*c0*w[0][3]*w[0][9]*g20*g12;
    real G4_0_2_3_2_9_2 = det*c1*c0*w[0][3]*w[0][9]*g20*g22;
    real G4_0_2_3_2_10_0 = det*c1*c0*w[0][3]*w[0][10]*g20*g02;
    real G4_0_2_3_2_10_1 = det*c1*c0*w[0][3]*w[0][10]*g20*g12;
    real G4_0_2_3_2_10_2 = det*c1*c0*w[0][3]*w[0][10]*g20*g22;
    real G4_0_2_3_2_11_0 = det*c1*c0*w[0][3]*w[0][11]*g20*g02;
    real G4_0_2_3_2_11_1 = det*c1*c0*w[0][3]*w[0][11]*g20*g12;
    real G4_0_2_3_2_11_2 = det*c1*c0*w[0][3]*w[0][11]*g20*g22;
    real G4_1_0_4_0_0_0 = det*c1*c0*w[0][4]*w[0][0]*g01*g00;
    real G4_1_0_4_0_0_1 = det*c1*c0*w[0][4]*w[0][0]*g01*g10;
    real G4_1_0_4_0_0_2 = det*c1*c0*w[0][4]*w[0][0]*g01*g20;
    real G4_1_0_4_0_1_0 = det*c1*c0*w[0][4]*w[0][1]*g01*g00;
    real G4_1_0_4_0_1_1 = det*c1*c0*w[0][4]*w[0][1]*g01*g10;
    real G4_1_0_4_0_1_2 = det*c1*c0*w[0][4]*w[0][1]*g01*g20;
    real G4_1_0_4_0_2_0 = det*c1*c0*w[0][4]*w[0][2]*g01*g00;
    real G4_1_0_4_0_2_1 = det*c1*c0*w[0][4]*w[0][2]*g01*g10;
    real G4_1_0_4_0_2_2 = det*c1*c0*w[0][4]*w[0][2]*g01*g20;
    real G4_1_0_4_0_3_0 = det*c1*c0*w[0][4]*w[0][3]*g01*g00;
    real G4_1_0_4_0_3_1 = det*c1*c0*w[0][4]*w[0][3]*g01*g10;
    real G4_1_0_4_0_3_2 = det*c1*c0*w[0][4]*w[0][3]*g01*g20;
    real G4_1_0_4_1_0_0 = det*c1*c0*w[0][4]*w[0][0]*g11*g00;
    real G4_1_0_4_1_0_1 = det*c1*c0*w[0][4]*w[0][0]*g11*g10;
    real G4_1_0_4_1_0_2 = det*c1*c0*w[0][4]*w[0][0]*g11*g20;
    real G4_1_0_4_1_1_0 = det*c1*c0*w[0][4]*w[0][1]*g11*g00;
    real G4_1_0_4_1_1_1 = det*c1*c0*w[0][4]*w[0][1]*g11*g10;
    real G4_1_0_4_1_1_2 = det*c1*c0*w[0][4]*w[0][1]*g11*g20;
    real G4_1_0_4_1_2_0 = det*c1*c0*w[0][4]*w[0][2]*g11*g00;
    real G4_1_0_4_1_2_1 = det*c1*c0*w[0][4]*w[0][2]*g11*g10;
    real G4_1_0_4_1_2_2 = det*c1*c0*w[0][4]*w[0][2]*g11*g20;
    real G4_1_0_4_1_3_0 = det*c1*c0*w[0][4]*w[0][3]*g11*g00;
    real G4_1_0_4_1_3_1 = det*c1*c0*w[0][4]*w[0][3]*g11*g10;
    real G4_1_0_4_1_3_2 = det*c1*c0*w[0][4]*w[0][3]*g11*g20;
    real G4_1_0_4_2_0_0 = det*c1*c0*w[0][4]*w[0][0]*g21*g00;
    real G4_1_0_4_2_0_1 = det*c1*c0*w[0][4]*w[0][0]*g21*g10;
    real G4_1_0_4_2_0_2 = det*c1*c0*w[0][4]*w[0][0]*g21*g20;
    real G4_1_0_4_2_1_0 = det*c1*c0*w[0][4]*w[0][1]*g21*g00;
    real G4_1_0_4_2_1_1 = det*c1*c0*w[0][4]*w[0][1]*g21*g10;
    real G4_1_0_4_2_1_2 = det*c1*c0*w[0][4]*w[0][1]*g21*g20;
    real G4_1_0_4_2_2_0 = det*c1*c0*w[0][4]*w[0][2]*g21*g00;
    real G4_1_0_4_2_2_1 = det*c1*c0*w[0][4]*w[0][2]*g21*g10;
    real G4_1_0_4_2_2_2 = det*c1*c0*w[0][4]*w[0][2]*g21*g20;
    real G4_1_0_4_2_3_0 = det*c1*c0*w[0][4]*w[0][3]*g21*g00;
    real G4_1_0_4_2_3_1 = det*c1*c0*w[0][4]*w[0][3]*g21*g10;
    real G4_1_0_4_2_3_2 = det*c1*c0*w[0][4]*w[0][3]*g21*g20;
    real G4_1_0_5_0_0_0 = det*c1*c0*w[0][5]*w[0][0]*g01*g00;
    real G4_1_0_5_0_0_1 = det*c1*c0*w[0][5]*w[0][0]*g01*g10;
    real G4_1_0_5_0_0_2 = det*c1*c0*w[0][5]*w[0][0]*g01*g20;
    real G4_1_0_5_0_1_0 = det*c1*c0*w[0][5]*w[0][1]*g01*g00;
    real G4_1_0_5_0_1_1 = det*c1*c0*w[0][5]*w[0][1]*g01*g10;
    real G4_1_0_5_0_1_2 = det*c1*c0*w[0][5]*w[0][1]*g01*g20;
    real G4_1_0_5_0_2_0 = det*c1*c0*w[0][5]*w[0][2]*g01*g00;
    real G4_1_0_5_0_2_1 = det*c1*c0*w[0][5]*w[0][2]*g01*g10;
    real G4_1_0_5_0_2_2 = det*c1*c0*w[0][5]*w[0][2]*g01*g20;
    real G4_1_0_5_0_3_0 = det*c1*c0*w[0][5]*w[0][3]*g01*g00;
    real G4_1_0_5_0_3_1 = det*c1*c0*w[0][5]*w[0][3]*g01*g10;
    real G4_1_0_5_0_3_2 = det*c1*c0*w[0][5]*w[0][3]*g01*g20;
    real G4_1_0_5_1_0_0 = det*c1*c0*w[0][5]*w[0][0]*g11*g00;
    real G4_1_0_5_1_0_1 = det*c1*c0*w[0][5]*w[0][0]*g11*g10;
    real G4_1_0_5_1_0_2 = det*c1*c0*w[0][5]*w[0][0]*g11*g20;
    real G4_1_0_5_1_1_0 = det*c1*c0*w[0][5]*w[0][1]*g11*g00;
    real G4_1_0_5_1_1_1 = det*c1*c0*w[0][5]*w[0][1]*g11*g10;
    real G4_1_0_5_1_1_2 = det*c1*c0*w[0][5]*w[0][1]*g11*g20;
    real G4_1_0_5_1_2_0 = det*c1*c0*w[0][5]*w[0][2]*g11*g00;
    real G4_1_0_5_1_2_1 = det*c1*c0*w[0][5]*w[0][2]*g11*g10;
    real G4_1_0_5_1_2_2 = det*c1*c0*w[0][5]*w[0][2]*g11*g20;
    real G4_1_0_5_1_3_0 = det*c1*c0*w[0][5]*w[0][3]*g11*g00;
    real G4_1_0_5_1_3_1 = det*c1*c0*w[0][5]*w[0][3]*g11*g10;
    real G4_1_0_5_1_3_2 = det*c1*c0*w[0][5]*w[0][3]*g11*g20;
    real G4_1_0_5_2_0_0 = det*c1*c0*w[0][5]*w[0][0]*g21*g00;
    real G4_1_0_5_2_0_1 = det*c1*c0*w[0][5]*w[0][0]*g21*g10;
    real G4_1_0_5_2_0_2 = det*c1*c0*w[0][5]*w[0][0]*g21*g20;
    real G4_1_0_5_2_1_0 = det*c1*c0*w[0][5]*w[0][1]*g21*g00;
    real G4_1_0_5_2_1_1 = det*c1*c0*w[0][5]*w[0][1]*g21*g10;
    real G4_1_0_5_2_1_2 = det*c1*c0*w[0][5]*w[0][1]*g21*g20;
    real G4_1_0_5_2_2_0 = det*c1*c0*w[0][5]*w[0][2]*g21*g00;
    real G4_1_0_5_2_2_1 = det*c1*c0*w[0][5]*w[0][2]*g21*g10;
    real G4_1_0_5_2_2_2 = det*c1*c0*w[0][5]*w[0][2]*g21*g20;
    real G4_1_0_5_2_3_0 = det*c1*c0*w[0][5]*w[0][3]*g21*g00;
    real G4_1_0_5_2_3_1 = det*c1*c0*w[0][5]*w[0][3]*g21*g10;
    real G4_1_0_5_2_3_2 = det*c1*c0*w[0][5]*w[0][3]*g21*g20;
    real G4_1_0_6_0_0_0 = det*c1*c0*w[0][6]*w[0][0]*g01*g00;
    real G4_1_0_6_0_0_1 = det*c1*c0*w[0][6]*w[0][0]*g01*g10;
    real G4_1_0_6_0_0_2 = det*c1*c0*w[0][6]*w[0][0]*g01*g20;
    real G4_1_0_6_0_1_0 = det*c1*c0*w[0][6]*w[0][1]*g01*g00;
    real G4_1_0_6_0_1_1 = det*c1*c0*w[0][6]*w[0][1]*g01*g10;
    real G4_1_0_6_0_1_2 = det*c1*c0*w[0][6]*w[0][1]*g01*g20;
    real G4_1_0_6_0_2_0 = det*c1*c0*w[0][6]*w[0][2]*g01*g00;
    real G4_1_0_6_0_2_1 = det*c1*c0*w[0][6]*w[0][2]*g01*g10;
    real G4_1_0_6_0_2_2 = det*c1*c0*w[0][6]*w[0][2]*g01*g20;
    real G4_1_0_6_0_3_0 = det*c1*c0*w[0][6]*w[0][3]*g01*g00;
    real G4_1_0_6_0_3_1 = det*c1*c0*w[0][6]*w[0][3]*g01*g10;
    real G4_1_0_6_0_3_2 = det*c1*c0*w[0][6]*w[0][3]*g01*g20;
    real G4_1_0_6_1_0_0 = det*c1*c0*w[0][6]*w[0][0]*g11*g00;
    real G4_1_0_6_1_0_1 = det*c1*c0*w[0][6]*w[0][0]*g11*g10;
    real G4_1_0_6_1_0_2 = det*c1*c0*w[0][6]*w[0][0]*g11*g20;
    real G4_1_0_6_1_1_0 = det*c1*c0*w[0][6]*w[0][1]*g11*g00;
    real G4_1_0_6_1_1_1 = det*c1*c0*w[0][6]*w[0][1]*g11*g10;
    real G4_1_0_6_1_1_2 = det*c1*c0*w[0][6]*w[0][1]*g11*g20;
    real G4_1_0_6_1_2_0 = det*c1*c0*w[0][6]*w[0][2]*g11*g00;
    real G4_1_0_6_1_2_1 = det*c1*c0*w[0][6]*w[0][2]*g11*g10;
    real G4_1_0_6_1_2_2 = det*c1*c0*w[0][6]*w[0][2]*g11*g20;
    real G4_1_0_6_1_3_0 = det*c1*c0*w[0][6]*w[0][3]*g11*g00;
    real G4_1_0_6_1_3_1 = det*c1*c0*w[0][6]*w[0][3]*g11*g10;
    real G4_1_0_6_1_3_2 = det*c1*c0*w[0][6]*w[0][3]*g11*g20;
    real G4_1_0_6_2_0_0 = det*c1*c0*w[0][6]*w[0][0]*g21*g00;
    real G4_1_0_6_2_0_1 = det*c1*c0*w[0][6]*w[0][0]*g21*g10;
    real G4_1_0_6_2_0_2 = det*c1*c0*w[0][6]*w[0][0]*g21*g20;
    real G4_1_0_6_2_1_0 = det*c1*c0*w[0][6]*w[0][1]*g21*g00;
    real G4_1_0_6_2_1_1 = det*c1*c0*w[0][6]*w[0][1]*g21*g10;
    real G4_1_0_6_2_1_2 = det*c1*c0*w[0][6]*w[0][1]*g21*g20;
    real G4_1_0_6_2_2_0 = det*c1*c0*w[0][6]*w[0][2]*g21*g00;
    real G4_1_0_6_2_2_1 = det*c1*c0*w[0][6]*w[0][2]*g21*g10;
    real G4_1_0_6_2_2_2 = det*c1*c0*w[0][6]*w[0][2]*g21*g20;
    real G4_1_0_6_2_3_0 = det*c1*c0*w[0][6]*w[0][3]*g21*g00;
    real G4_1_0_6_2_3_1 = det*c1*c0*w[0][6]*w[0][3]*g21*g10;
    real G4_1_0_6_2_3_2 = det*c1*c0*w[0][6]*w[0][3]*g21*g20;
    real G4_1_0_7_0_0_0 = det*c1*c0*w[0][7]*w[0][0]*g01*g00;
    real G4_1_0_7_0_0_1 = det*c1*c0*w[0][7]*w[0][0]*g01*g10;
    real G4_1_0_7_0_0_2 = det*c1*c0*w[0][7]*w[0][0]*g01*g20;
    real G4_1_0_7_0_1_0 = det*c1*c0*w[0][7]*w[0][1]*g01*g00;
    real G4_1_0_7_0_1_1 = det*c1*c0*w[0][7]*w[0][1]*g01*g10;
    real G4_1_0_7_0_1_2 = det*c1*c0*w[0][7]*w[0][1]*g01*g20;
    real G4_1_0_7_0_2_0 = det*c1*c0*w[0][7]*w[0][2]*g01*g00;
    real G4_1_0_7_0_2_1 = det*c1*c0*w[0][7]*w[0][2]*g01*g10;
    real G4_1_0_7_0_2_2 = det*c1*c0*w[0][7]*w[0][2]*g01*g20;
    real G4_1_0_7_0_3_0 = det*c1*c0*w[0][7]*w[0][3]*g01*g00;
    real G4_1_0_7_0_3_1 = det*c1*c0*w[0][7]*w[0][3]*g01*g10;
    real G4_1_0_7_0_3_2 = det*c1*c0*w[0][7]*w[0][3]*g01*g20;
    real G4_1_0_7_1_0_0 = det*c1*c0*w[0][7]*w[0][0]*g11*g00;
    real G4_1_0_7_1_0_1 = det*c1*c0*w[0][7]*w[0][0]*g11*g10;
    real G4_1_0_7_1_0_2 = det*c1*c0*w[0][7]*w[0][0]*g11*g20;
    real G4_1_0_7_1_1_0 = det*c1*c0*w[0][7]*w[0][1]*g11*g00;
    real G4_1_0_7_1_1_1 = det*c1*c0*w[0][7]*w[0][1]*g11*g10;
    real G4_1_0_7_1_1_2 = det*c1*c0*w[0][7]*w[0][1]*g11*g20;
    real G4_1_0_7_1_2_0 = det*c1*c0*w[0][7]*w[0][2]*g11*g00;
    real G4_1_0_7_1_2_1 = det*c1*c0*w[0][7]*w[0][2]*g11*g10;
    real G4_1_0_7_1_2_2 = det*c1*c0*w[0][7]*w[0][2]*g11*g20;
    real G4_1_0_7_1_3_0 = det*c1*c0*w[0][7]*w[0][3]*g11*g00;
    real G4_1_0_7_1_3_1 = det*c1*c0*w[0][7]*w[0][3]*g11*g10;
    real G4_1_0_7_1_3_2 = det*c1*c0*w[0][7]*w[0][3]*g11*g20;
    real G4_1_0_7_2_0_0 = det*c1*c0*w[0][7]*w[0][0]*g21*g00;
    real G4_1_0_7_2_0_1 = det*c1*c0*w[0][7]*w[0][0]*g21*g10;
    real G4_1_0_7_2_0_2 = det*c1*c0*w[0][7]*w[0][0]*g21*g20;
    real G4_1_0_7_2_1_0 = det*c1*c0*w[0][7]*w[0][1]*g21*g00;
    real G4_1_0_7_2_1_1 = det*c1*c0*w[0][7]*w[0][1]*g21*g10;
    real G4_1_0_7_2_1_2 = det*c1*c0*w[0][7]*w[0][1]*g21*g20;
    real G4_1_0_7_2_2_0 = det*c1*c0*w[0][7]*w[0][2]*g21*g00;
    real G4_1_0_7_2_2_1 = det*c1*c0*w[0][7]*w[0][2]*g21*g10;
    real G4_1_0_7_2_2_2 = det*c1*c0*w[0][7]*w[0][2]*g21*g20;
    real G4_1_0_7_2_3_0 = det*c1*c0*w[0][7]*w[0][3]*g21*g00;
    real G4_1_0_7_2_3_1 = det*c1*c0*w[0][7]*w[0][3]*g21*g10;
    real G4_1_0_7_2_3_2 = det*c1*c0*w[0][7]*w[0][3]*g21*g20;
    real G4_1_1_4_0_4_0 = det*c1*c0*w[0][4]*w[0][4]*g01*g01;
    real G4_1_1_4_0_4_1 = det*c1*c0*w[0][4]*w[0][4]*g01*g11;
    real G4_1_1_4_0_4_2 = det*c1*c0*w[0][4]*w[0][4]*g01*g21;
    real G4_1_1_4_0_5_0 = det*c1*c0*w[0][4]*w[0][5]*g01*g01;
    real G4_1_1_4_0_5_1 = det*c1*c0*w[0][4]*w[0][5]*g01*g11;
    real G4_1_1_4_0_5_2 = det*c1*c0*w[0][4]*w[0][5]*g01*g21;
    real G4_1_1_4_0_6_0 = det*c1*c0*w[0][4]*w[0][6]*g01*g01;
    real G4_1_1_4_0_6_1 = det*c1*c0*w[0][4]*w[0][6]*g01*g11;
    real G4_1_1_4_0_6_2 = det*c1*c0*w[0][4]*w[0][6]*g01*g21;
    real G4_1_1_4_0_7_0 = det*c1*c0*w[0][4]*w[0][7]*g01*g01;
    real G4_1_1_4_0_7_1 = det*c1*c0*w[0][4]*w[0][7]*g01*g11;
    real G4_1_1_4_0_7_2 = det*c1*c0*w[0][4]*w[0][7]*g01*g21;
    real G4_1_1_4_1_4_0 = det*c1*c0*w[0][4]*w[0][4]*g11*g01;
    real G4_1_1_4_1_4_1 = det*c1*c0*w[0][4]*w[0][4]*g11*g11;
    real G4_1_1_4_1_4_2 = det*c1*c0*w[0][4]*w[0][4]*g11*g21;
    real G4_1_1_4_1_5_0 = det*c1*c0*w[0][4]*w[0][5]*g11*g01;
    real G4_1_1_4_1_5_1 = det*c1*c0*w[0][4]*w[0][5]*g11*g11;
    real G4_1_1_4_1_5_2 = det*c1*c0*w[0][4]*w[0][5]*g11*g21;
    real G4_1_1_4_1_6_0 = det*c1*c0*w[0][4]*w[0][6]*g11*g01;
    real G4_1_1_4_1_6_1 = det*c1*c0*w[0][4]*w[0][6]*g11*g11;
    real G4_1_1_4_1_6_2 = det*c1*c0*w[0][4]*w[0][6]*g11*g21;
    real G4_1_1_4_1_7_0 = det*c1*c0*w[0][4]*w[0][7]*g11*g01;
    real G4_1_1_4_1_7_1 = det*c1*c0*w[0][4]*w[0][7]*g11*g11;
    real G4_1_1_4_1_7_2 = det*c1*c0*w[0][4]*w[0][7]*g11*g21;
    real G4_1_1_4_2_4_0 = det*c1*c0*w[0][4]*w[0][4]*g21*g01;
    real G4_1_1_4_2_4_1 = det*c1*c0*w[0][4]*w[0][4]*g21*g11;
    real G4_1_1_4_2_4_2 = det*c1*c0*w[0][4]*w[0][4]*g21*g21;
    real G4_1_1_4_2_5_0 = det*c1*c0*w[0][4]*w[0][5]*g21*g01;
    real G4_1_1_4_2_5_1 = det*c1*c0*w[0][4]*w[0][5]*g21*g11;
    real G4_1_1_4_2_5_2 = det*c1*c0*w[0][4]*w[0][5]*g21*g21;
    real G4_1_1_4_2_6_0 = det*c1*c0*w[0][4]*w[0][6]*g21*g01;
    real G4_1_1_4_2_6_1 = det*c1*c0*w[0][4]*w[0][6]*g21*g11;
    real G4_1_1_4_2_6_2 = det*c1*c0*w[0][4]*w[0][6]*g21*g21;
    real G4_1_1_4_2_7_0 = det*c1*c0*w[0][4]*w[0][7]*g21*g01;
    real G4_1_1_4_2_7_1 = det*c1*c0*w[0][4]*w[0][7]*g21*g11;
    real G4_1_1_4_2_7_2 = det*c1*c0*w[0][4]*w[0][7]*g21*g21;
    real G4_1_1_5_0_4_0 = det*c1*c0*w[0][5]*w[0][4]*g01*g01;
    real G4_1_1_5_0_4_1 = det*c1*c0*w[0][5]*w[0][4]*g01*g11;
    real G4_1_1_5_0_4_2 = det*c1*c0*w[0][5]*w[0][4]*g01*g21;
    real G4_1_1_5_0_5_0 = det*c1*c0*w[0][5]*w[0][5]*g01*g01;
    real G4_1_1_5_0_5_1 = det*c1*c0*w[0][5]*w[0][5]*g01*g11;
    real G4_1_1_5_0_5_2 = det*c1*c0*w[0][5]*w[0][5]*g01*g21;
    real G4_1_1_5_0_6_0 = det*c1*c0*w[0][5]*w[0][6]*g01*g01;
    real G4_1_1_5_0_6_1 = det*c1*c0*w[0][5]*w[0][6]*g01*g11;
    real G4_1_1_5_0_6_2 = det*c1*c0*w[0][5]*w[0][6]*g01*g21;
    real G4_1_1_5_0_7_0 = det*c1*c0*w[0][5]*w[0][7]*g01*g01;
    real G4_1_1_5_0_7_1 = det*c1*c0*w[0][5]*w[0][7]*g01*g11;
    real G4_1_1_5_0_7_2 = det*c1*c0*w[0][5]*w[0][7]*g01*g21;
    real G4_1_1_5_1_4_0 = det*c1*c0*w[0][5]*w[0][4]*g11*g01;
    real G4_1_1_5_1_4_1 = det*c1*c0*w[0][5]*w[0][4]*g11*g11;
    real G4_1_1_5_1_4_2 = det*c1*c0*w[0][5]*w[0][4]*g11*g21;
    real G4_1_1_5_1_5_0 = det*c1*c0*w[0][5]*w[0][5]*g11*g01;
    real G4_1_1_5_1_5_1 = det*c1*c0*w[0][5]*w[0][5]*g11*g11;
    real G4_1_1_5_1_5_2 = det*c1*c0*w[0][5]*w[0][5]*g11*g21;
    real G4_1_1_5_1_6_0 = det*c1*c0*w[0][5]*w[0][6]*g11*g01;
    real G4_1_1_5_1_6_1 = det*c1*c0*w[0][5]*w[0][6]*g11*g11;
    real G4_1_1_5_1_6_2 = det*c1*c0*w[0][5]*w[0][6]*g11*g21;
    real G4_1_1_5_1_7_0 = det*c1*c0*w[0][5]*w[0][7]*g11*g01;
    real G4_1_1_5_1_7_1 = det*c1*c0*w[0][5]*w[0][7]*g11*g11;
    real G4_1_1_5_1_7_2 = det*c1*c0*w[0][5]*w[0][7]*g11*g21;
    real G4_1_1_5_2_4_0 = det*c1*c0*w[0][5]*w[0][4]*g21*g01;
    real G4_1_1_5_2_4_1 = det*c1*c0*w[0][5]*w[0][4]*g21*g11;
    real G4_1_1_5_2_4_2 = det*c1*c0*w[0][5]*w[0][4]*g21*g21;
    real G4_1_1_5_2_5_0 = det*c1*c0*w[0][5]*w[0][5]*g21*g01;
    real G4_1_1_5_2_5_1 = det*c1*c0*w[0][5]*w[0][5]*g21*g11;
    real G4_1_1_5_2_5_2 = det*c1*c0*w[0][5]*w[0][5]*g21*g21;
    real G4_1_1_5_2_6_0 = det*c1*c0*w[0][5]*w[0][6]*g21*g01;
    real G4_1_1_5_2_6_1 = det*c1*c0*w[0][5]*w[0][6]*g21*g11;
    real G4_1_1_5_2_6_2 = det*c1*c0*w[0][5]*w[0][6]*g21*g21;
    real G4_1_1_5_2_7_0 = det*c1*c0*w[0][5]*w[0][7]*g21*g01;
    real G4_1_1_5_2_7_1 = det*c1*c0*w[0][5]*w[0][7]*g21*g11;
    real G4_1_1_5_2_7_2 = det*c1*c0*w[0][5]*w[0][7]*g21*g21;
    real G4_1_1_6_0_4_0 = det*c1*c0*w[0][6]*w[0][4]*g01*g01;
    real G4_1_1_6_0_4_1 = det*c1*c0*w[0][6]*w[0][4]*g01*g11;
    real G4_1_1_6_0_4_2 = det*c1*c0*w[0][6]*w[0][4]*g01*g21;
    real G4_1_1_6_0_5_0 = det*c1*c0*w[0][6]*w[0][5]*g01*g01;
    real G4_1_1_6_0_5_1 = det*c1*c0*w[0][6]*w[0][5]*g01*g11;
    real G4_1_1_6_0_5_2 = det*c1*c0*w[0][6]*w[0][5]*g01*g21;
    real G4_1_1_6_0_6_0 = det*c1*c0*w[0][6]*w[0][6]*g01*g01;
    real G4_1_1_6_0_6_1 = det*c1*c0*w[0][6]*w[0][6]*g01*g11;
    real G4_1_1_6_0_6_2 = det*c1*c0*w[0][6]*w[0][6]*g01*g21;
    real G4_1_1_6_0_7_0 = det*c1*c0*w[0][6]*w[0][7]*g01*g01;
    real G4_1_1_6_0_7_1 = det*c1*c0*w[0][6]*w[0][7]*g01*g11;
    real G4_1_1_6_0_7_2 = det*c1*c0*w[0][6]*w[0][7]*g01*g21;
    real G4_1_1_6_1_4_0 = det*c1*c0*w[0][6]*w[0][4]*g11*g01;
    real G4_1_1_6_1_4_1 = det*c1*c0*w[0][6]*w[0][4]*g11*g11;
    real G4_1_1_6_1_4_2 = det*c1*c0*w[0][6]*w[0][4]*g11*g21;
    real G4_1_1_6_1_5_0 = det*c1*c0*w[0][6]*w[0][5]*g11*g01;
    real G4_1_1_6_1_5_1 = det*c1*c0*w[0][6]*w[0][5]*g11*g11;
    real G4_1_1_6_1_5_2 = det*c1*c0*w[0][6]*w[0][5]*g11*g21;
    real G4_1_1_6_1_6_0 = det*c1*c0*w[0][6]*w[0][6]*g11*g01;
    real G4_1_1_6_1_6_1 = det*c1*c0*w[0][6]*w[0][6]*g11*g11;
    real G4_1_1_6_1_6_2 = det*c1*c0*w[0][6]*w[0][6]*g11*g21;
    real G4_1_1_6_1_7_0 = det*c1*c0*w[0][6]*w[0][7]*g11*g01;
    real G4_1_1_6_1_7_1 = det*c1*c0*w[0][6]*w[0][7]*g11*g11;
    real G4_1_1_6_1_7_2 = det*c1*c0*w[0][6]*w[0][7]*g11*g21;
    real G4_1_1_6_2_4_0 = det*c1*c0*w[0][6]*w[0][4]*g21*g01;
    real G4_1_1_6_2_4_1 = det*c1*c0*w[0][6]*w[0][4]*g21*g11;
    real G4_1_1_6_2_4_2 = det*c1*c0*w[0][6]*w[0][4]*g21*g21;
    real G4_1_1_6_2_5_0 = det*c1*c0*w[0][6]*w[0][5]*g21*g01;
    real G4_1_1_6_2_5_1 = det*c1*c0*w[0][6]*w[0][5]*g21*g11;
    real G4_1_1_6_2_5_2 = det*c1*c0*w[0][6]*w[0][5]*g21*g21;
    real G4_1_1_6_2_6_0 = det*c1*c0*w[0][6]*w[0][6]*g21*g01;
    real G4_1_1_6_2_6_1 = det*c1*c0*w[0][6]*w[0][6]*g21*g11;
    real G4_1_1_6_2_6_2 = det*c1*c0*w[0][6]*w[0][6]*g21*g21;
    real G4_1_1_6_2_7_0 = det*c1*c0*w[0][6]*w[0][7]*g21*g01;
    real G4_1_1_6_2_7_1 = det*c1*c0*w[0][6]*w[0][7]*g21*g11;
    real G4_1_1_6_2_7_2 = det*c1*c0*w[0][6]*w[0][7]*g21*g21;
    real G4_1_1_7_0_4_0 = det*c1*c0*w[0][7]*w[0][4]*g01*g01;
    real G4_1_1_7_0_4_1 = det*c1*c0*w[0][7]*w[0][4]*g01*g11;
    real G4_1_1_7_0_4_2 = det*c1*c0*w[0][7]*w[0][4]*g01*g21;
    real G4_1_1_7_0_5_0 = det*c1*c0*w[0][7]*w[0][5]*g01*g01;
    real G4_1_1_7_0_5_1 = det*c1*c0*w[0][7]*w[0][5]*g01*g11;
    real G4_1_1_7_0_5_2 = det*c1*c0*w[0][7]*w[0][5]*g01*g21;
    real G4_1_1_7_0_6_0 = det*c1*c0*w[0][7]*w[0][6]*g01*g01;
    real G4_1_1_7_0_6_1 = det*c1*c0*w[0][7]*w[0][6]*g01*g11;
    real G4_1_1_7_0_6_2 = det*c1*c0*w[0][7]*w[0][6]*g01*g21;
    real G4_1_1_7_0_7_0 = det*c1*c0*w[0][7]*w[0][7]*g01*g01;
    real G4_1_1_7_0_7_1 = det*c1*c0*w[0][7]*w[0][7]*g01*g11;
    real G4_1_1_7_0_7_2 = det*c1*c0*w[0][7]*w[0][7]*g01*g21;
    real G4_1_1_7_1_4_0 = det*c1*c0*w[0][7]*w[0][4]*g11*g01;
    real G4_1_1_7_1_4_1 = det*c1*c0*w[0][7]*w[0][4]*g11*g11;
    real G4_1_1_7_1_4_2 = det*c1*c0*w[0][7]*w[0][4]*g11*g21;
    real G4_1_1_7_1_5_0 = det*c1*c0*w[0][7]*w[0][5]*g11*g01;
    real G4_1_1_7_1_5_1 = det*c1*c0*w[0][7]*w[0][5]*g11*g11;
    real G4_1_1_7_1_5_2 = det*c1*c0*w[0][7]*w[0][5]*g11*g21;
    real G4_1_1_7_1_6_0 = det*c1*c0*w[0][7]*w[0][6]*g11*g01;
    real G4_1_1_7_1_6_1 = det*c1*c0*w[0][7]*w[0][6]*g11*g11;
    real G4_1_1_7_1_6_2 = det*c1*c0*w[0][7]*w[0][6]*g11*g21;
    real G4_1_1_7_1_7_0 = det*c1*c0*w[0][7]*w[0][7]*g11*g01;
    real G4_1_1_7_1_7_1 = det*c1*c0*w[0][7]*w[0][7]*g11*g11;
    real G4_1_1_7_1_7_2 = det*c1*c0*w[0][7]*w[0][7]*g11*g21;
    real G4_1_1_7_2_4_0 = det*c1*c0*w[0][7]*w[0][4]*g21*g01;
    real G4_1_1_7_2_4_1 = det*c1*c0*w[0][7]*w[0][4]*g21*g11;
    real G4_1_1_7_2_4_2 = det*c1*c0*w[0][7]*w[0][4]*g21*g21;
    real G4_1_1_7_2_5_0 = det*c1*c0*w[0][7]*w[0][5]*g21*g01;
    real G4_1_1_7_2_5_1 = det*c1*c0*w[0][7]*w[0][5]*g21*g11;
    real G4_1_1_7_2_5_2 = det*c1*c0*w[0][7]*w[0][5]*g21*g21;
    real G4_1_1_7_2_6_0 = det*c1*c0*w[0][7]*w[0][6]*g21*g01;
    real G4_1_1_7_2_6_1 = det*c1*c0*w[0][7]*w[0][6]*g21*g11;
    real G4_1_1_7_2_6_2 = det*c1*c0*w[0][7]*w[0][6]*g21*g21;
    real G4_1_1_7_2_7_0 = det*c1*c0*w[0][7]*w[0][7]*g21*g01;
    real G4_1_1_7_2_7_1 = det*c1*c0*w[0][7]*w[0][7]*g21*g11;
    real G4_1_1_7_2_7_2 = det*c1*c0*w[0][7]*w[0][7]*g21*g21;
    real G4_1_2_4_0_8_0 = det*c1*c0*w[0][4]*w[0][8]*g01*g02;
    real G4_1_2_4_0_8_1 = det*c1*c0*w[0][4]*w[0][8]*g01*g12;
    real G4_1_2_4_0_8_2 = det*c1*c0*w[0][4]*w[0][8]*g01*g22;
    real G4_1_2_4_0_9_0 = det*c1*c0*w[0][4]*w[0][9]*g01*g02;
    real G4_1_2_4_0_9_1 = det*c1*c0*w[0][4]*w[0][9]*g01*g12;
    real G4_1_2_4_0_9_2 = det*c1*c0*w[0][4]*w[0][9]*g01*g22;
    real G4_1_2_4_0_10_0 = det*c1*c0*w[0][4]*w[0][10]*g01*g02;
    real G4_1_2_4_0_10_1 = det*c1*c0*w[0][4]*w[0][10]*g01*g12;
    real G4_1_2_4_0_10_2 = det*c1*c0*w[0][4]*w[0][10]*g01*g22;
    real G4_1_2_4_0_11_0 = det*c1*c0*w[0][4]*w[0][11]*g01*g02;
    real G4_1_2_4_0_11_1 = det*c1*c0*w[0][4]*w[0][11]*g01*g12;
    real G4_1_2_4_0_11_2 = det*c1*c0*w[0][4]*w[0][11]*g01*g22;
    real G4_1_2_4_1_8_0 = det*c1*c0*w[0][4]*w[0][8]*g11*g02;
    real G4_1_2_4_1_8_1 = det*c1*c0*w[0][4]*w[0][8]*g11*g12;
    real G4_1_2_4_1_8_2 = det*c1*c0*w[0][4]*w[0][8]*g11*g22;
    real G4_1_2_4_1_9_0 = det*c1*c0*w[0][4]*w[0][9]*g11*g02;
    real G4_1_2_4_1_9_1 = det*c1*c0*w[0][4]*w[0][9]*g11*g12;
    real G4_1_2_4_1_9_2 = det*c1*c0*w[0][4]*w[0][9]*g11*g22;
    real G4_1_2_4_1_10_0 = det*c1*c0*w[0][4]*w[0][10]*g11*g02;
    real G4_1_2_4_1_10_1 = det*c1*c0*w[0][4]*w[0][10]*g11*g12;
    real G4_1_2_4_1_10_2 = det*c1*c0*w[0][4]*w[0][10]*g11*g22;
    real G4_1_2_4_1_11_0 = det*c1*c0*w[0][4]*w[0][11]*g11*g02;
    real G4_1_2_4_1_11_1 = det*c1*c0*w[0][4]*w[0][11]*g11*g12;
    real G4_1_2_4_1_11_2 = det*c1*c0*w[0][4]*w[0][11]*g11*g22;
    real G4_1_2_4_2_8_0 = det*c1*c0*w[0][4]*w[0][8]*g21*g02;
    real G4_1_2_4_2_8_1 = det*c1*c0*w[0][4]*w[0][8]*g21*g12;
    real G4_1_2_4_2_8_2 = det*c1*c0*w[0][4]*w[0][8]*g21*g22;
    real G4_1_2_4_2_9_0 = det*c1*c0*w[0][4]*w[0][9]*g21*g02;
    real G4_1_2_4_2_9_1 = det*c1*c0*w[0][4]*w[0][9]*g21*g12;
    real G4_1_2_4_2_9_2 = det*c1*c0*w[0][4]*w[0][9]*g21*g22;
    real G4_1_2_4_2_10_0 = det*c1*c0*w[0][4]*w[0][10]*g21*g02;
    real G4_1_2_4_2_10_1 = det*c1*c0*w[0][4]*w[0][10]*g21*g12;
    real G4_1_2_4_2_10_2 = det*c1*c0*w[0][4]*w[0][10]*g21*g22;
    real G4_1_2_4_2_11_0 = det*c1*c0*w[0][4]*w[0][11]*g21*g02;
    real G4_1_2_4_2_11_1 = det*c1*c0*w[0][4]*w[0][11]*g21*g12;
    real G4_1_2_4_2_11_2 = det*c1*c0*w[0][4]*w[0][11]*g21*g22;
    real G4_1_2_5_0_8_0 = det*c1*c0*w[0][5]*w[0][8]*g01*g02;
    real G4_1_2_5_0_8_1 = det*c1*c0*w[0][5]*w[0][8]*g01*g12;
    real G4_1_2_5_0_8_2 = det*c1*c0*w[0][5]*w[0][8]*g01*g22;
    real G4_1_2_5_0_9_0 = det*c1*c0*w[0][5]*w[0][9]*g01*g02;
    real G4_1_2_5_0_9_1 = det*c1*c0*w[0][5]*w[0][9]*g01*g12;
    real G4_1_2_5_0_9_2 = det*c1*c0*w[0][5]*w[0][9]*g01*g22;
    real G4_1_2_5_0_10_0 = det*c1*c0*w[0][5]*w[0][10]*g01*g02;
    real G4_1_2_5_0_10_1 = det*c1*c0*w[0][5]*w[0][10]*g01*g12;
    real G4_1_2_5_0_10_2 = det*c1*c0*w[0][5]*w[0][10]*g01*g22;
    real G4_1_2_5_0_11_0 = det*c1*c0*w[0][5]*w[0][11]*g01*g02;
    real G4_1_2_5_0_11_1 = det*c1*c0*w[0][5]*w[0][11]*g01*g12;
    real G4_1_2_5_0_11_2 = det*c1*c0*w[0][5]*w[0][11]*g01*g22;
    real G4_1_2_5_1_8_0 = det*c1*c0*w[0][5]*w[0][8]*g11*g02;
    real G4_1_2_5_1_8_1 = det*c1*c0*w[0][5]*w[0][8]*g11*g12;
    real G4_1_2_5_1_8_2 = det*c1*c0*w[0][5]*w[0][8]*g11*g22;
    real G4_1_2_5_1_9_0 = det*c1*c0*w[0][5]*w[0][9]*g11*g02;
    real G4_1_2_5_1_9_1 = det*c1*c0*w[0][5]*w[0][9]*g11*g12;
    real G4_1_2_5_1_9_2 = det*c1*c0*w[0][5]*w[0][9]*g11*g22;
    real G4_1_2_5_1_10_0 = det*c1*c0*w[0][5]*w[0][10]*g11*g02;
    real G4_1_2_5_1_10_1 = det*c1*c0*w[0][5]*w[0][10]*g11*g12;
    real G4_1_2_5_1_10_2 = det*c1*c0*w[0][5]*w[0][10]*g11*g22;
    real G4_1_2_5_1_11_0 = det*c1*c0*w[0][5]*w[0][11]*g11*g02;
    real G4_1_2_5_1_11_1 = det*c1*c0*w[0][5]*w[0][11]*g11*g12;
    real G4_1_2_5_1_11_2 = det*c1*c0*w[0][5]*w[0][11]*g11*g22;
    real G4_1_2_5_2_8_0 = det*c1*c0*w[0][5]*w[0][8]*g21*g02;
    real G4_1_2_5_2_8_1 = det*c1*c0*w[0][5]*w[0][8]*g21*g12;
    real G4_1_2_5_2_8_2 = det*c1*c0*w[0][5]*w[0][8]*g21*g22;
    real G4_1_2_5_2_9_0 = det*c1*c0*w[0][5]*w[0][9]*g21*g02;
    real G4_1_2_5_2_9_1 = det*c1*c0*w[0][5]*w[0][9]*g21*g12;
    real G4_1_2_5_2_9_2 = det*c1*c0*w[0][5]*w[0][9]*g21*g22;
    real G4_1_2_5_2_10_0 = det*c1*c0*w[0][5]*w[0][10]*g21*g02;
    real G4_1_2_5_2_10_1 = det*c1*c0*w[0][5]*w[0][10]*g21*g12;
    real G4_1_2_5_2_10_2 = det*c1*c0*w[0][5]*w[0][10]*g21*g22;
    real G4_1_2_5_2_11_0 = det*c1*c0*w[0][5]*w[0][11]*g21*g02;
    real G4_1_2_5_2_11_1 = det*c1*c0*w[0][5]*w[0][11]*g21*g12;
    real G4_1_2_5_2_11_2 = det*c1*c0*w[0][5]*w[0][11]*g21*g22;
    real G4_1_2_6_0_8_0 = det*c1*c0*w[0][6]*w[0][8]*g01*g02;
    real G4_1_2_6_0_8_1 = det*c1*c0*w[0][6]*w[0][8]*g01*g12;
    real G4_1_2_6_0_8_2 = det*c1*c0*w[0][6]*w[0][8]*g01*g22;
    real G4_1_2_6_0_9_0 = det*c1*c0*w[0][6]*w[0][9]*g01*g02;
    real G4_1_2_6_0_9_1 = det*c1*c0*w[0][6]*w[0][9]*g01*g12;
    real G4_1_2_6_0_9_2 = det*c1*c0*w[0][6]*w[0][9]*g01*g22;
    real G4_1_2_6_0_10_0 = det*c1*c0*w[0][6]*w[0][10]*g01*g02;
    real G4_1_2_6_0_10_1 = det*c1*c0*w[0][6]*w[0][10]*g01*g12;
    real G4_1_2_6_0_10_2 = det*c1*c0*w[0][6]*w[0][10]*g01*g22;
    real G4_1_2_6_0_11_0 = det*c1*c0*w[0][6]*w[0][11]*g01*g02;
    real G4_1_2_6_0_11_1 = det*c1*c0*w[0][6]*w[0][11]*g01*g12;
    real G4_1_2_6_0_11_2 = det*c1*c0*w[0][6]*w[0][11]*g01*g22;
    real G4_1_2_6_1_8_0 = det*c1*c0*w[0][6]*w[0][8]*g11*g02;
    real G4_1_2_6_1_8_1 = det*c1*c0*w[0][6]*w[0][8]*g11*g12;
    real G4_1_2_6_1_8_2 = det*c1*c0*w[0][6]*w[0][8]*g11*g22;
    real G4_1_2_6_1_9_0 = det*c1*c0*w[0][6]*w[0][9]*g11*g02;
    real G4_1_2_6_1_9_1 = det*c1*c0*w[0][6]*w[0][9]*g11*g12;
    real G4_1_2_6_1_9_2 = det*c1*c0*w[0][6]*w[0][9]*g11*g22;
    real G4_1_2_6_1_10_0 = det*c1*c0*w[0][6]*w[0][10]*g11*g02;
    real G4_1_2_6_1_10_1 = det*c1*c0*w[0][6]*w[0][10]*g11*g12;
    real G4_1_2_6_1_10_2 = det*c1*c0*w[0][6]*w[0][10]*g11*g22;
    real G4_1_2_6_1_11_0 = det*c1*c0*w[0][6]*w[0][11]*g11*g02;
    real G4_1_2_6_1_11_1 = det*c1*c0*w[0][6]*w[0][11]*g11*g12;
    real G4_1_2_6_1_11_2 = det*c1*c0*w[0][6]*w[0][11]*g11*g22;
    real G4_1_2_6_2_8_0 = det*c1*c0*w[0][6]*w[0][8]*g21*g02;
    real G4_1_2_6_2_8_1 = det*c1*c0*w[0][6]*w[0][8]*g21*g12;
    real G4_1_2_6_2_8_2 = det*c1*c0*w[0][6]*w[0][8]*g21*g22;
    real G4_1_2_6_2_9_0 = det*c1*c0*w[0][6]*w[0][9]*g21*g02;
    real G4_1_2_6_2_9_1 = det*c1*c0*w[0][6]*w[0][9]*g21*g12;
    real G4_1_2_6_2_9_2 = det*c1*c0*w[0][6]*w[0][9]*g21*g22;
    real G4_1_2_6_2_10_0 = det*c1*c0*w[0][6]*w[0][10]*g21*g02;
    real G4_1_2_6_2_10_1 = det*c1*c0*w[0][6]*w[0][10]*g21*g12;
    real G4_1_2_6_2_10_2 = det*c1*c0*w[0][6]*w[0][10]*g21*g22;
    real G4_1_2_6_2_11_0 = det*c1*c0*w[0][6]*w[0][11]*g21*g02;
    real G4_1_2_6_2_11_1 = det*c1*c0*w[0][6]*w[0][11]*g21*g12;
    real G4_1_2_6_2_11_2 = det*c1*c0*w[0][6]*w[0][11]*g21*g22;
    real G4_1_2_7_0_8_0 = det*c1*c0*w[0][7]*w[0][8]*g01*g02;
    real G4_1_2_7_0_8_1 = det*c1*c0*w[0][7]*w[0][8]*g01*g12;
    real G4_1_2_7_0_8_2 = det*c1*c0*w[0][7]*w[0][8]*g01*g22;
    real G4_1_2_7_0_9_0 = det*c1*c0*w[0][7]*w[0][9]*g01*g02;
    real G4_1_2_7_0_9_1 = det*c1*c0*w[0][7]*w[0][9]*g01*g12;
    real G4_1_2_7_0_9_2 = det*c1*c0*w[0][7]*w[0][9]*g01*g22;
    real G4_1_2_7_0_10_0 = det*c1*c0*w[0][7]*w[0][10]*g01*g02;
    real G4_1_2_7_0_10_1 = det*c1*c0*w[0][7]*w[0][10]*g01*g12;
    real G4_1_2_7_0_10_2 = det*c1*c0*w[0][7]*w[0][10]*g01*g22;
    real G4_1_2_7_0_11_0 = det*c1*c0*w[0][7]*w[0][11]*g01*g02;
    real G4_1_2_7_0_11_1 = det*c1*c0*w[0][7]*w[0][11]*g01*g12;
    real G4_1_2_7_0_11_2 = det*c1*c0*w[0][7]*w[0][11]*g01*g22;
    real G4_1_2_7_1_8_0 = det*c1*c0*w[0][7]*w[0][8]*g11*g02;
    real G4_1_2_7_1_8_1 = det*c1*c0*w[0][7]*w[0][8]*g11*g12;
    real G4_1_2_7_1_8_2 = det*c1*c0*w[0][7]*w[0][8]*g11*g22;
    real G4_1_2_7_1_9_0 = det*c1*c0*w[0][7]*w[0][9]*g11*g02;
    real G4_1_2_7_1_9_1 = det*c1*c0*w[0][7]*w[0][9]*g11*g12;
    real G4_1_2_7_1_9_2 = det*c1*c0*w[0][7]*w[0][9]*g11*g22;
    real G4_1_2_7_1_10_0 = det*c1*c0*w[0][7]*w[0][10]*g11*g02;
    real G4_1_2_7_1_10_1 = det*c1*c0*w[0][7]*w[0][10]*g11*g12;
    real G4_1_2_7_1_10_2 = det*c1*c0*w[0][7]*w[0][10]*g11*g22;
    real G4_1_2_7_1_11_0 = det*c1*c0*w[0][7]*w[0][11]*g11*g02;
    real G4_1_2_7_1_11_1 = det*c1*c0*w[0][7]*w[0][11]*g11*g12;
    real G4_1_2_7_1_11_2 = det*c1*c0*w[0][7]*w[0][11]*g11*g22;
    real G4_1_2_7_2_8_0 = det*c1*c0*w[0][7]*w[0][8]*g21*g02;
    real G4_1_2_7_2_8_1 = det*c1*c0*w[0][7]*w[0][8]*g21*g12;
    real G4_1_2_7_2_8_2 = det*c1*c0*w[0][7]*w[0][8]*g21*g22;
    real G4_1_2_7_2_9_0 = det*c1*c0*w[0][7]*w[0][9]*g21*g02;
    real G4_1_2_7_2_9_1 = det*c1*c0*w[0][7]*w[0][9]*g21*g12;
    real G4_1_2_7_2_9_2 = det*c1*c0*w[0][7]*w[0][9]*g21*g22;
    real G4_1_2_7_2_10_0 = det*c1*c0*w[0][7]*w[0][10]*g21*g02;
    real G4_1_2_7_2_10_1 = det*c1*c0*w[0][7]*w[0][10]*g21*g12;
    real G4_1_2_7_2_10_2 = det*c1*c0*w[0][7]*w[0][10]*g21*g22;
    real G4_1_2_7_2_11_0 = det*c1*c0*w[0][7]*w[0][11]*g21*g02;
    real G4_1_2_7_2_11_1 = det*c1*c0*w[0][7]*w[0][11]*g21*g12;
    real G4_1_2_7_2_11_2 = det*c1*c0*w[0][7]*w[0][11]*g21*g22;
    real G4_2_0_8_0_0_0 = det*c1*c0*w[0][8]*w[0][0]*g02*g00;
    real G4_2_0_8_0_0_1 = det*c1*c0*w[0][8]*w[0][0]*g02*g10;
    real G4_2_0_8_0_0_2 = det*c1*c0*w[0][8]*w[0][0]*g02*g20;
    real G4_2_0_8_0_1_0 = det*c1*c0*w[0][8]*w[0][1]*g02*g00;
    real G4_2_0_8_0_1_1 = det*c1*c0*w[0][8]*w[0][1]*g02*g10;
    real G4_2_0_8_0_1_2 = det*c1*c0*w[0][8]*w[0][1]*g02*g20;
    real G4_2_0_8_0_2_0 = det*c1*c0*w[0][8]*w[0][2]*g02*g00;
    real G4_2_0_8_0_2_1 = det*c1*c0*w[0][8]*w[0][2]*g02*g10;
    real G4_2_0_8_0_2_2 = det*c1*c0*w[0][8]*w[0][2]*g02*g20;
    real G4_2_0_8_0_3_0 = det*c1*c0*w[0][8]*w[0][3]*g02*g00;
    real G4_2_0_8_0_3_1 = det*c1*c0*w[0][8]*w[0][3]*g02*g10;
    real G4_2_0_8_0_3_2 = det*c1*c0*w[0][8]*w[0][3]*g02*g20;
    real G4_2_0_8_1_0_0 = det*c1*c0*w[0][8]*w[0][0]*g12*g00;
    real G4_2_0_8_1_0_1 = det*c1*c0*w[0][8]*w[0][0]*g12*g10;
    real G4_2_0_8_1_0_2 = det*c1*c0*w[0][8]*w[0][0]*g12*g20;
    real G4_2_0_8_1_1_0 = det*c1*c0*w[0][8]*w[0][1]*g12*g00;
    real G4_2_0_8_1_1_1 = det*c1*c0*w[0][8]*w[0][1]*g12*g10;
    real G4_2_0_8_1_1_2 = det*c1*c0*w[0][8]*w[0][1]*g12*g20;
    real G4_2_0_8_1_2_0 = det*c1*c0*w[0][8]*w[0][2]*g12*g00;
    real G4_2_0_8_1_2_1 = det*c1*c0*w[0][8]*w[0][2]*g12*g10;
    real G4_2_0_8_1_2_2 = det*c1*c0*w[0][8]*w[0][2]*g12*g20;
    real G4_2_0_8_1_3_0 = det*c1*c0*w[0][8]*w[0][3]*g12*g00;
    real G4_2_0_8_1_3_1 = det*c1*c0*w[0][8]*w[0][3]*g12*g10;
    real G4_2_0_8_1_3_2 = det*c1*c0*w[0][8]*w[0][3]*g12*g20;
    real G4_2_0_8_2_0_0 = det*c1*c0*w[0][8]*w[0][0]*g22*g00;
    real G4_2_0_8_2_0_1 = det*c1*c0*w[0][8]*w[0][0]*g22*g10;
    real G4_2_0_8_2_0_2 = det*c1*c0*w[0][8]*w[0][0]*g22*g20;
    real G4_2_0_8_2_1_0 = det*c1*c0*w[0][8]*w[0][1]*g22*g00;
    real G4_2_0_8_2_1_1 = det*c1*c0*w[0][8]*w[0][1]*g22*g10;
    real G4_2_0_8_2_1_2 = det*c1*c0*w[0][8]*w[0][1]*g22*g20;
    real G4_2_0_8_2_2_0 = det*c1*c0*w[0][8]*w[0][2]*g22*g00;
    real G4_2_0_8_2_2_1 = det*c1*c0*w[0][8]*w[0][2]*g22*g10;
    real G4_2_0_8_2_2_2 = det*c1*c0*w[0][8]*w[0][2]*g22*g20;
    real G4_2_0_8_2_3_0 = det*c1*c0*w[0][8]*w[0][3]*g22*g00;
    real G4_2_0_8_2_3_1 = det*c1*c0*w[0][8]*w[0][3]*g22*g10;
    real G4_2_0_8_2_3_2 = det*c1*c0*w[0][8]*w[0][3]*g22*g20;
    real G4_2_0_9_0_0_0 = det*c1*c0*w[0][9]*w[0][0]*g02*g00;
    real G4_2_0_9_0_0_1 = det*c1*c0*w[0][9]*w[0][0]*g02*g10;
    real G4_2_0_9_0_0_2 = det*c1*c0*w[0][9]*w[0][0]*g02*g20;
    real G4_2_0_9_0_1_0 = det*c1*c0*w[0][9]*w[0][1]*g02*g00;
    real G4_2_0_9_0_1_1 = det*c1*c0*w[0][9]*w[0][1]*g02*g10;
    real G4_2_0_9_0_1_2 = det*c1*c0*w[0][9]*w[0][1]*g02*g20;
    real G4_2_0_9_0_2_0 = det*c1*c0*w[0][9]*w[0][2]*g02*g00;
    real G4_2_0_9_0_2_1 = det*c1*c0*w[0][9]*w[0][2]*g02*g10;
    real G4_2_0_9_0_2_2 = det*c1*c0*w[0][9]*w[0][2]*g02*g20;
    real G4_2_0_9_0_3_0 = det*c1*c0*w[0][9]*w[0][3]*g02*g00;
    real G4_2_0_9_0_3_1 = det*c1*c0*w[0][9]*w[0][3]*g02*g10;
    real G4_2_0_9_0_3_2 = det*c1*c0*w[0][9]*w[0][3]*g02*g20;
    real G4_2_0_9_1_0_0 = det*c1*c0*w[0][9]*w[0][0]*g12*g00;
    real G4_2_0_9_1_0_1 = det*c1*c0*w[0][9]*w[0][0]*g12*g10;
    real G4_2_0_9_1_0_2 = det*c1*c0*w[0][9]*w[0][0]*g12*g20;
    real G4_2_0_9_1_1_0 = det*c1*c0*w[0][9]*w[0][1]*g12*g00;
    real G4_2_0_9_1_1_1 = det*c1*c0*w[0][9]*w[0][1]*g12*g10;
    real G4_2_0_9_1_1_2 = det*c1*c0*w[0][9]*w[0][1]*g12*g20;
    real G4_2_0_9_1_2_0 = det*c1*c0*w[0][9]*w[0][2]*g12*g00;
    real G4_2_0_9_1_2_1 = det*c1*c0*w[0][9]*w[0][2]*g12*g10;
    real G4_2_0_9_1_2_2 = det*c1*c0*w[0][9]*w[0][2]*g12*g20;
    real G4_2_0_9_1_3_0 = det*c1*c0*w[0][9]*w[0][3]*g12*g00;
    real G4_2_0_9_1_3_1 = det*c1*c0*w[0][9]*w[0][3]*g12*g10;
    real G4_2_0_9_1_3_2 = det*c1*c0*w[0][9]*w[0][3]*g12*g20;
    real G4_2_0_9_2_0_0 = det*c1*c0*w[0][9]*w[0][0]*g22*g00;
    real G4_2_0_9_2_0_1 = det*c1*c0*w[0][9]*w[0][0]*g22*g10;
    real G4_2_0_9_2_0_2 = det*c1*c0*w[0][9]*w[0][0]*g22*g20;
    real G4_2_0_9_2_1_0 = det*c1*c0*w[0][9]*w[0][1]*g22*g00;
    real G4_2_0_9_2_1_1 = det*c1*c0*w[0][9]*w[0][1]*g22*g10;
    real G4_2_0_9_2_1_2 = det*c1*c0*w[0][9]*w[0][1]*g22*g20;
    real G4_2_0_9_2_2_0 = det*c1*c0*w[0][9]*w[0][2]*g22*g00;
    real G4_2_0_9_2_2_1 = det*c1*c0*w[0][9]*w[0][2]*g22*g10;
    real G4_2_0_9_2_2_2 = det*c1*c0*w[0][9]*w[0][2]*g22*g20;
    real G4_2_0_9_2_3_0 = det*c1*c0*w[0][9]*w[0][3]*g22*g00;
    real G4_2_0_9_2_3_1 = det*c1*c0*w[0][9]*w[0][3]*g22*g10;
    real G4_2_0_9_2_3_2 = det*c1*c0*w[0][9]*w[0][3]*g22*g20;
    real G4_2_0_10_0_0_0 = det*c1*c0*w[0][10]*w[0][0]*g02*g00;
    real G4_2_0_10_0_0_1 = det*c1*c0*w[0][10]*w[0][0]*g02*g10;
    real G4_2_0_10_0_0_2 = det*c1*c0*w[0][10]*w[0][0]*g02*g20;
    real G4_2_0_10_0_1_0 = det*c1*c0*w[0][10]*w[0][1]*g02*g00;
    real G4_2_0_10_0_1_1 = det*c1*c0*w[0][10]*w[0][1]*g02*g10;
    real G4_2_0_10_0_1_2 = det*c1*c0*w[0][10]*w[0][1]*g02*g20;
    real G4_2_0_10_0_2_0 = det*c1*c0*w[0][10]*w[0][2]*g02*g00;
    real G4_2_0_10_0_2_1 = det*c1*c0*w[0][10]*w[0][2]*g02*g10;
    real G4_2_0_10_0_2_2 = det*c1*c0*w[0][10]*w[0][2]*g02*g20;
    real G4_2_0_10_0_3_0 = det*c1*c0*w[0][10]*w[0][3]*g02*g00;
    real G4_2_0_10_0_3_1 = det*c1*c0*w[0][10]*w[0][3]*g02*g10;
    real G4_2_0_10_0_3_2 = det*c1*c0*w[0][10]*w[0][3]*g02*g20;
    real G4_2_0_10_1_0_0 = det*c1*c0*w[0][10]*w[0][0]*g12*g00;
    real G4_2_0_10_1_0_1 = det*c1*c0*w[0][10]*w[0][0]*g12*g10;
    real G4_2_0_10_1_0_2 = det*c1*c0*w[0][10]*w[0][0]*g12*g20;
    real G4_2_0_10_1_1_0 = det*c1*c0*w[0][10]*w[0][1]*g12*g00;
    real G4_2_0_10_1_1_1 = det*c1*c0*w[0][10]*w[0][1]*g12*g10;
    real G4_2_0_10_1_1_2 = det*c1*c0*w[0][10]*w[0][1]*g12*g20;
    real G4_2_0_10_1_2_0 = det*c1*c0*w[0][10]*w[0][2]*g12*g00;
    real G4_2_0_10_1_2_1 = det*c1*c0*w[0][10]*w[0][2]*g12*g10;
    real G4_2_0_10_1_2_2 = det*c1*c0*w[0][10]*w[0][2]*g12*g20;
    real G4_2_0_10_1_3_0 = det*c1*c0*w[0][10]*w[0][3]*g12*g00;
    real G4_2_0_10_1_3_1 = det*c1*c0*w[0][10]*w[0][3]*g12*g10;
    real G4_2_0_10_1_3_2 = det*c1*c0*w[0][10]*w[0][3]*g12*g20;
    real G4_2_0_10_2_0_0 = det*c1*c0*w[0][10]*w[0][0]*g22*g00;
    real G4_2_0_10_2_0_1 = det*c1*c0*w[0][10]*w[0][0]*g22*g10;
    real G4_2_0_10_2_0_2 = det*c1*c0*w[0][10]*w[0][0]*g22*g20;
    real G4_2_0_10_2_1_0 = det*c1*c0*w[0][10]*w[0][1]*g22*g00;
    real G4_2_0_10_2_1_1 = det*c1*c0*w[0][10]*w[0][1]*g22*g10;
    real G4_2_0_10_2_1_2 = det*c1*c0*w[0][10]*w[0][1]*g22*g20;
    real G4_2_0_10_2_2_0 = det*c1*c0*w[0][10]*w[0][2]*g22*g00;
    real G4_2_0_10_2_2_1 = det*c1*c0*w[0][10]*w[0][2]*g22*g10;
    real G4_2_0_10_2_2_2 = det*c1*c0*w[0][10]*w[0][2]*g22*g20;
    real G4_2_0_10_2_3_0 = det*c1*c0*w[0][10]*w[0][3]*g22*g00;
    real G4_2_0_10_2_3_1 = det*c1*c0*w[0][10]*w[0][3]*g22*g10;
    real G4_2_0_10_2_3_2 = det*c1*c0*w[0][10]*w[0][3]*g22*g20;
    real G4_2_0_11_0_0_0 = det*c1*c0*w[0][11]*w[0][0]*g02*g00;
    real G4_2_0_11_0_0_1 = det*c1*c0*w[0][11]*w[0][0]*g02*g10;
    real G4_2_0_11_0_0_2 = det*c1*c0*w[0][11]*w[0][0]*g02*g20;
    real G4_2_0_11_0_1_0 = det*c1*c0*w[0][11]*w[0][1]*g02*g00;
    real G4_2_0_11_0_1_1 = det*c1*c0*w[0][11]*w[0][1]*g02*g10;
    real G4_2_0_11_0_1_2 = det*c1*c0*w[0][11]*w[0][1]*g02*g20;
    real G4_2_0_11_0_2_0 = det*c1*c0*w[0][11]*w[0][2]*g02*g00;
    real G4_2_0_11_0_2_1 = det*c1*c0*w[0][11]*w[0][2]*g02*g10;
    real G4_2_0_11_0_2_2 = det*c1*c0*w[0][11]*w[0][2]*g02*g20;
    real G4_2_0_11_0_3_0 = det*c1*c0*w[0][11]*w[0][3]*g02*g00;
    real G4_2_0_11_0_3_1 = det*c1*c0*w[0][11]*w[0][3]*g02*g10;
    real G4_2_0_11_0_3_2 = det*c1*c0*w[0][11]*w[0][3]*g02*g20;
    real G4_2_0_11_1_0_0 = det*c1*c0*w[0][11]*w[0][0]*g12*g00;
    real G4_2_0_11_1_0_1 = det*c1*c0*w[0][11]*w[0][0]*g12*g10;
    real G4_2_0_11_1_0_2 = det*c1*c0*w[0][11]*w[0][0]*g12*g20;
    real G4_2_0_11_1_1_0 = det*c1*c0*w[0][11]*w[0][1]*g12*g00;
    real G4_2_0_11_1_1_1 = det*c1*c0*w[0][11]*w[0][1]*g12*g10;
    real G4_2_0_11_1_1_2 = det*c1*c0*w[0][11]*w[0][1]*g12*g20;
    real G4_2_0_11_1_2_0 = det*c1*c0*w[0][11]*w[0][2]*g12*g00;
    real G4_2_0_11_1_2_1 = det*c1*c0*w[0][11]*w[0][2]*g12*g10;
    real G4_2_0_11_1_2_2 = det*c1*c0*w[0][11]*w[0][2]*g12*g20;
    real G4_2_0_11_1_3_0 = det*c1*c0*w[0][11]*w[0][3]*g12*g00;
    real G4_2_0_11_1_3_1 = det*c1*c0*w[0][11]*w[0][3]*g12*g10;
    real G4_2_0_11_1_3_2 = det*c1*c0*w[0][11]*w[0][3]*g12*g20;
    real G4_2_0_11_2_0_0 = det*c1*c0*w[0][11]*w[0][0]*g22*g00;
    real G4_2_0_11_2_0_1 = det*c1*c0*w[0][11]*w[0][0]*g22*g10;
    real G4_2_0_11_2_0_2 = det*c1*c0*w[0][11]*w[0][0]*g22*g20;
    real G4_2_0_11_2_1_0 = det*c1*c0*w[0][11]*w[0][1]*g22*g00;
    real G4_2_0_11_2_1_1 = det*c1*c0*w[0][11]*w[0][1]*g22*g10;
    real G4_2_0_11_2_1_2 = det*c1*c0*w[0][11]*w[0][1]*g22*g20;
    real G4_2_0_11_2_2_0 = det*c1*c0*w[0][11]*w[0][2]*g22*g00;
    real G4_2_0_11_2_2_1 = det*c1*c0*w[0][11]*w[0][2]*g22*g10;
    real G4_2_0_11_2_2_2 = det*c1*c0*w[0][11]*w[0][2]*g22*g20;
    real G4_2_0_11_2_3_0 = det*c1*c0*w[0][11]*w[0][3]*g22*g00;
    real G4_2_0_11_2_3_1 = det*c1*c0*w[0][11]*w[0][3]*g22*g10;
    real G4_2_0_11_2_3_2 = det*c1*c0*w[0][11]*w[0][3]*g22*g20;
    real G4_2_1_8_0_4_0 = det*c1*c0*w[0][8]*w[0][4]*g02*g01;
    real G4_2_1_8_0_4_1 = det*c1*c0*w[0][8]*w[0][4]*g02*g11;
    real G4_2_1_8_0_4_2 = det*c1*c0*w[0][8]*w[0][4]*g02*g21;
    real G4_2_1_8_0_5_0 = det*c1*c0*w[0][8]*w[0][5]*g02*g01;
    real G4_2_1_8_0_5_1 = det*c1*c0*w[0][8]*w[0][5]*g02*g11;
    real G4_2_1_8_0_5_2 = det*c1*c0*w[0][8]*w[0][5]*g02*g21;
    real G4_2_1_8_0_6_0 = det*c1*c0*w[0][8]*w[0][6]*g02*g01;
    real G4_2_1_8_0_6_1 = det*c1*c0*w[0][8]*w[0][6]*g02*g11;
    real G4_2_1_8_0_6_2 = det*c1*c0*w[0][8]*w[0][6]*g02*g21;
    real G4_2_1_8_0_7_0 = det*c1*c0*w[0][8]*w[0][7]*g02*g01;
    real G4_2_1_8_0_7_1 = det*c1*c0*w[0][8]*w[0][7]*g02*g11;
    real G4_2_1_8_0_7_2 = det*c1*c0*w[0][8]*w[0][7]*g02*g21;
    real G4_2_1_8_1_4_0 = det*c1*c0*w[0][8]*w[0][4]*g12*g01;
    real G4_2_1_8_1_4_1 = det*c1*c0*w[0][8]*w[0][4]*g12*g11;
    real G4_2_1_8_1_4_2 = det*c1*c0*w[0][8]*w[0][4]*g12*g21;
    real G4_2_1_8_1_5_0 = det*c1*c0*w[0][8]*w[0][5]*g12*g01;
    real G4_2_1_8_1_5_1 = det*c1*c0*w[0][8]*w[0][5]*g12*g11;
    real G4_2_1_8_1_5_2 = det*c1*c0*w[0][8]*w[0][5]*g12*g21;
    real G4_2_1_8_1_6_0 = det*c1*c0*w[0][8]*w[0][6]*g12*g01;
    real G4_2_1_8_1_6_1 = det*c1*c0*w[0][8]*w[0][6]*g12*g11;
    real G4_2_1_8_1_6_2 = det*c1*c0*w[0][8]*w[0][6]*g12*g21;
    real G4_2_1_8_1_7_0 = det*c1*c0*w[0][8]*w[0][7]*g12*g01;
    real G4_2_1_8_1_7_1 = det*c1*c0*w[0][8]*w[0][7]*g12*g11;
    real G4_2_1_8_1_7_2 = det*c1*c0*w[0][8]*w[0][7]*g12*g21;
    real G4_2_1_8_2_4_0 = det*c1*c0*w[0][8]*w[0][4]*g22*g01;
    real G4_2_1_8_2_4_1 = det*c1*c0*w[0][8]*w[0][4]*g22*g11;
    real G4_2_1_8_2_4_2 = det*c1*c0*w[0][8]*w[0][4]*g22*g21;
    real G4_2_1_8_2_5_0 = det*c1*c0*w[0][8]*w[0][5]*g22*g01;
    real G4_2_1_8_2_5_1 = det*c1*c0*w[0][8]*w[0][5]*g22*g11;
    real G4_2_1_8_2_5_2 = det*c1*c0*w[0][8]*w[0][5]*g22*g21;
    real G4_2_1_8_2_6_0 = det*c1*c0*w[0][8]*w[0][6]*g22*g01;
    real G4_2_1_8_2_6_1 = det*c1*c0*w[0][8]*w[0][6]*g22*g11;
    real G4_2_1_8_2_6_2 = det*c1*c0*w[0][8]*w[0][6]*g22*g21;
    real G4_2_1_8_2_7_0 = det*c1*c0*w[0][8]*w[0][7]*g22*g01;
    real G4_2_1_8_2_7_1 = det*c1*c0*w[0][8]*w[0][7]*g22*g11;
    real G4_2_1_8_2_7_2 = det*c1*c0*w[0][8]*w[0][7]*g22*g21;
    real G4_2_1_9_0_4_0 = det*c1*c0*w[0][9]*w[0][4]*g02*g01;
    real G4_2_1_9_0_4_1 = det*c1*c0*w[0][9]*w[0][4]*g02*g11;
    real G4_2_1_9_0_4_2 = det*c1*c0*w[0][9]*w[0][4]*g02*g21;
    real G4_2_1_9_0_5_0 = det*c1*c0*w[0][9]*w[0][5]*g02*g01;
    real G4_2_1_9_0_5_1 = det*c1*c0*w[0][9]*w[0][5]*g02*g11;
    real G4_2_1_9_0_5_2 = det*c1*c0*w[0][9]*w[0][5]*g02*g21;
    real G4_2_1_9_0_6_0 = det*c1*c0*w[0][9]*w[0][6]*g02*g01;
    real G4_2_1_9_0_6_1 = det*c1*c0*w[0][9]*w[0][6]*g02*g11;
    real G4_2_1_9_0_6_2 = det*c1*c0*w[0][9]*w[0][6]*g02*g21;
    real G4_2_1_9_0_7_0 = det*c1*c0*w[0][9]*w[0][7]*g02*g01;
    real G4_2_1_9_0_7_1 = det*c1*c0*w[0][9]*w[0][7]*g02*g11;
    real G4_2_1_9_0_7_2 = det*c1*c0*w[0][9]*w[0][7]*g02*g21;
    real G4_2_1_9_1_4_0 = det*c1*c0*w[0][9]*w[0][4]*g12*g01;
    real G4_2_1_9_1_4_1 = det*c1*c0*w[0][9]*w[0][4]*g12*g11;
    real G4_2_1_9_1_4_2 = det*c1*c0*w[0][9]*w[0][4]*g12*g21;
    real G4_2_1_9_1_5_0 = det*c1*c0*w[0][9]*w[0][5]*g12*g01;
    real G4_2_1_9_1_5_1 = det*c1*c0*w[0][9]*w[0][5]*g12*g11;
    real G4_2_1_9_1_5_2 = det*c1*c0*w[0][9]*w[0][5]*g12*g21;
    real G4_2_1_9_1_6_0 = det*c1*c0*w[0][9]*w[0][6]*g12*g01;
    real G4_2_1_9_1_6_1 = det*c1*c0*w[0][9]*w[0][6]*g12*g11;
    real G4_2_1_9_1_6_2 = det*c1*c0*w[0][9]*w[0][6]*g12*g21;
    real G4_2_1_9_1_7_0 = det*c1*c0*w[0][9]*w[0][7]*g12*g01;
    real G4_2_1_9_1_7_1 = det*c1*c0*w[0][9]*w[0][7]*g12*g11;
    real G4_2_1_9_1_7_2 = det*c1*c0*w[0][9]*w[0][7]*g12*g21;
    real G4_2_1_9_2_4_0 = det*c1*c0*w[0][9]*w[0][4]*g22*g01;
    real G4_2_1_9_2_4_1 = det*c1*c0*w[0][9]*w[0][4]*g22*g11;
    real G4_2_1_9_2_4_2 = det*c1*c0*w[0][9]*w[0][4]*g22*g21;
    real G4_2_1_9_2_5_0 = det*c1*c0*w[0][9]*w[0][5]*g22*g01;
    real G4_2_1_9_2_5_1 = det*c1*c0*w[0][9]*w[0][5]*g22*g11;
    real G4_2_1_9_2_5_2 = det*c1*c0*w[0][9]*w[0][5]*g22*g21;
    real G4_2_1_9_2_6_0 = det*c1*c0*w[0][9]*w[0][6]*g22*g01;
    real G4_2_1_9_2_6_1 = det*c1*c0*w[0][9]*w[0][6]*g22*g11;
    real G4_2_1_9_2_6_2 = det*c1*c0*w[0][9]*w[0][6]*g22*g21;
    real G4_2_1_9_2_7_0 = det*c1*c0*w[0][9]*w[0][7]*g22*g01;
    real G4_2_1_9_2_7_1 = det*c1*c0*w[0][9]*w[0][7]*g22*g11;
    real G4_2_1_9_2_7_2 = det*c1*c0*w[0][9]*w[0][7]*g22*g21;
    real G4_2_1_10_0_4_0 = det*c1*c0*w[0][10]*w[0][4]*g02*g01;
    real G4_2_1_10_0_4_1 = det*c1*c0*w[0][10]*w[0][4]*g02*g11;
    real G4_2_1_10_0_4_2 = det*c1*c0*w[0][10]*w[0][4]*g02*g21;
    real G4_2_1_10_0_5_0 = det*c1*c0*w[0][10]*w[0][5]*g02*g01;
    real G4_2_1_10_0_5_1 = det*c1*c0*w[0][10]*w[0][5]*g02*g11;
    real G4_2_1_10_0_5_2 = det*c1*c0*w[0][10]*w[0][5]*g02*g21;
    real G4_2_1_10_0_6_0 = det*c1*c0*w[0][10]*w[0][6]*g02*g01;
    real G4_2_1_10_0_6_1 = det*c1*c0*w[0][10]*w[0][6]*g02*g11;
    real G4_2_1_10_0_6_2 = det*c1*c0*w[0][10]*w[0][6]*g02*g21;
    real G4_2_1_10_0_7_0 = det*c1*c0*w[0][10]*w[0][7]*g02*g01;
    real G4_2_1_10_0_7_1 = det*c1*c0*w[0][10]*w[0][7]*g02*g11;
    real G4_2_1_10_0_7_2 = det*c1*c0*w[0][10]*w[0][7]*g02*g21;
    real G4_2_1_10_1_4_0 = det*c1*c0*w[0][10]*w[0][4]*g12*g01;
    real G4_2_1_10_1_4_1 = det*c1*c0*w[0][10]*w[0][4]*g12*g11;
    real G4_2_1_10_1_4_2 = det*c1*c0*w[0][10]*w[0][4]*g12*g21;
    real G4_2_1_10_1_5_0 = det*c1*c0*w[0][10]*w[0][5]*g12*g01;
    real G4_2_1_10_1_5_1 = det*c1*c0*w[0][10]*w[0][5]*g12*g11;
    real G4_2_1_10_1_5_2 = det*c1*c0*w[0][10]*w[0][5]*g12*g21;
    real G4_2_1_10_1_6_0 = det*c1*c0*w[0][10]*w[0][6]*g12*g01;
    real G4_2_1_10_1_6_1 = det*c1*c0*w[0][10]*w[0][6]*g12*g11;
    real G4_2_1_10_1_6_2 = det*c1*c0*w[0][10]*w[0][6]*g12*g21;
    real G4_2_1_10_1_7_0 = det*c1*c0*w[0][10]*w[0][7]*g12*g01;
    real G4_2_1_10_1_7_1 = det*c1*c0*w[0][10]*w[0][7]*g12*g11;
    real G4_2_1_10_1_7_2 = det*c1*c0*w[0][10]*w[0][7]*g12*g21;
    real G4_2_1_10_2_4_0 = det*c1*c0*w[0][10]*w[0][4]*g22*g01;
    real G4_2_1_10_2_4_1 = det*c1*c0*w[0][10]*w[0][4]*g22*g11;
    real G4_2_1_10_2_4_2 = det*c1*c0*w[0][10]*w[0][4]*g22*g21;
    real G4_2_1_10_2_5_0 = det*c1*c0*w[0][10]*w[0][5]*g22*g01;
    real G4_2_1_10_2_5_1 = det*c1*c0*w[0][10]*w[0][5]*g22*g11;
    real G4_2_1_10_2_5_2 = det*c1*c0*w[0][10]*w[0][5]*g22*g21;
    real G4_2_1_10_2_6_0 = det*c1*c0*w[0][10]*w[0][6]*g22*g01;
    real G4_2_1_10_2_6_1 = det*c1*c0*w[0][10]*w[0][6]*g22*g11;
    real G4_2_1_10_2_6_2 = det*c1*c0*w[0][10]*w[0][6]*g22*g21;
    real G4_2_1_10_2_7_0 = det*c1*c0*w[0][10]*w[0][7]*g22*g01;
    real G4_2_1_10_2_7_1 = det*c1*c0*w[0][10]*w[0][7]*g22*g11;
    real G4_2_1_10_2_7_2 = det*c1*c0*w[0][10]*w[0][7]*g22*g21;
    real G4_2_1_11_0_4_0 = det*c1*c0*w[0][11]*w[0][4]*g02*g01;
    real G4_2_1_11_0_4_1 = det*c1*c0*w[0][11]*w[0][4]*g02*g11;
    real G4_2_1_11_0_4_2 = det*c1*c0*w[0][11]*w[0][4]*g02*g21;
    real G4_2_1_11_0_5_0 = det*c1*c0*w[0][11]*w[0][5]*g02*g01;
    real G4_2_1_11_0_5_1 = det*c1*c0*w[0][11]*w[0][5]*g02*g11;
    real G4_2_1_11_0_5_2 = det*c1*c0*w[0][11]*w[0][5]*g02*g21;
    real G4_2_1_11_0_6_0 = det*c1*c0*w[0][11]*w[0][6]*g02*g01;
    real G4_2_1_11_0_6_1 = det*c1*c0*w[0][11]*w[0][6]*g02*g11;
    real G4_2_1_11_0_6_2 = det*c1*c0*w[0][11]*w[0][6]*g02*g21;
    real G4_2_1_11_0_7_0 = det*c1*c0*w[0][11]*w[0][7]*g02*g01;
    real G4_2_1_11_0_7_1 = det*c1*c0*w[0][11]*w[0][7]*g02*g11;
    real G4_2_1_11_0_7_2 = det*c1*c0*w[0][11]*w[0][7]*g02*g21;
    real G4_2_1_11_1_4_0 = det*c1*c0*w[0][11]*w[0][4]*g12*g01;
    real G4_2_1_11_1_4_1 = det*c1*c0*w[0][11]*w[0][4]*g12*g11;
    real G4_2_1_11_1_4_2 = det*c1*c0*w[0][11]*w[0][4]*g12*g21;
    real G4_2_1_11_1_5_0 = det*c1*c0*w[0][11]*w[0][5]*g12*g01;
    real G4_2_1_11_1_5_1 = det*c1*c0*w[0][11]*w[0][5]*g12*g11;
    real G4_2_1_11_1_5_2 = det*c1*c0*w[0][11]*w[0][5]*g12*g21;
    real G4_2_1_11_1_6_0 = det*c1*c0*w[0][11]*w[0][6]*g12*g01;
    real G4_2_1_11_1_6_1 = det*c1*c0*w[0][11]*w[0][6]*g12*g11;
    real G4_2_1_11_1_6_2 = det*c1*c0*w[0][11]*w[0][6]*g12*g21;
    real G4_2_1_11_1_7_0 = det*c1*c0*w[0][11]*w[0][7]*g12*g01;
    real G4_2_1_11_1_7_1 = det*c1*c0*w[0][11]*w[0][7]*g12*g11;
    real G4_2_1_11_1_7_2 = det*c1*c0*w[0][11]*w[0][7]*g12*g21;
    real G4_2_1_11_2_4_0 = det*c1*c0*w[0][11]*w[0][4]*g22*g01;
    real G4_2_1_11_2_4_1 = det*c1*c0*w[0][11]*w[0][4]*g22*g11;
    real G4_2_1_11_2_4_2 = det*c1*c0*w[0][11]*w[0][4]*g22*g21;
    real G4_2_1_11_2_5_0 = det*c1*c0*w[0][11]*w[0][5]*g22*g01;
    real G4_2_1_11_2_5_1 = det*c1*c0*w[0][11]*w[0][5]*g22*g11;
    real G4_2_1_11_2_5_2 = det*c1*c0*w[0][11]*w[0][5]*g22*g21;
    real G4_2_1_11_2_6_0 = det*c1*c0*w[0][11]*w[0][6]*g22*g01;
    real G4_2_1_11_2_6_1 = det*c1*c0*w[0][11]*w[0][6]*g22*g11;
    real G4_2_1_11_2_6_2 = det*c1*c0*w[0][11]*w[0][6]*g22*g21;
    real G4_2_1_11_2_7_0 = det*c1*c0*w[0][11]*w[0][7]*g22*g01;
    real G4_2_1_11_2_7_1 = det*c1*c0*w[0][11]*w[0][7]*g22*g11;
    real G4_2_1_11_2_7_2 = det*c1*c0*w[0][11]*w[0][7]*g22*g21;
    real G4_2_2_8_0_8_0 = det*c1*c0*w[0][8]*w[0][8]*g02*g02;
    real G4_2_2_8_0_8_1 = det*c1*c0*w[0][8]*w[0][8]*g02*g12;
    real G4_2_2_8_0_8_2 = det*c1*c0*w[0][8]*w[0][8]*g02*g22;
    real G4_2_2_8_0_9_0 = det*c1*c0*w[0][8]*w[0][9]*g02*g02;
    real G4_2_2_8_0_9_1 = det*c1*c0*w[0][8]*w[0][9]*g02*g12;
    real G4_2_2_8_0_9_2 = det*c1*c0*w[0][8]*w[0][9]*g02*g22;
    real G4_2_2_8_0_10_0 = det*c1*c0*w[0][8]*w[0][10]*g02*g02;
    real G4_2_2_8_0_10_1 = det*c1*c0*w[0][8]*w[0][10]*g02*g12;
    real G4_2_2_8_0_10_2 = det*c1*c0*w[0][8]*w[0][10]*g02*g22;
    real G4_2_2_8_0_11_0 = det*c1*c0*w[0][8]*w[0][11]*g02*g02;
    real G4_2_2_8_0_11_1 = det*c1*c0*w[0][8]*w[0][11]*g02*g12;
    real G4_2_2_8_0_11_2 = det*c1*c0*w[0][8]*w[0][11]*g02*g22;
    real G4_2_2_8_1_8_0 = det*c1*c0*w[0][8]*w[0][8]*g12*g02;
    real G4_2_2_8_1_8_1 = det*c1*c0*w[0][8]*w[0][8]*g12*g12;
    real G4_2_2_8_1_8_2 = det*c1*c0*w[0][8]*w[0][8]*g12*g22;
    real G4_2_2_8_1_9_0 = det*c1*c0*w[0][8]*w[0][9]*g12*g02;
    real G4_2_2_8_1_9_1 = det*c1*c0*w[0][8]*w[0][9]*g12*g12;
    real G4_2_2_8_1_9_2 = det*c1*c0*w[0][8]*w[0][9]*g12*g22;
    real G4_2_2_8_1_10_0 = det*c1*c0*w[0][8]*w[0][10]*g12*g02;
    real G4_2_2_8_1_10_1 = det*c1*c0*w[0][8]*w[0][10]*g12*g12;
    real G4_2_2_8_1_10_2 = det*c1*c0*w[0][8]*w[0][10]*g12*g22;
    real G4_2_2_8_1_11_0 = det*c1*c0*w[0][8]*w[0][11]*g12*g02;
    real G4_2_2_8_1_11_1 = det*c1*c0*w[0][8]*w[0][11]*g12*g12;
    real G4_2_2_8_1_11_2 = det*c1*c0*w[0][8]*w[0][11]*g12*g22;
    real G4_2_2_8_2_8_0 = det*c1*c0*w[0][8]*w[0][8]*g22*g02;
    real G4_2_2_8_2_8_1 = det*c1*c0*w[0][8]*w[0][8]*g22*g12;
    real G4_2_2_8_2_8_2 = det*c1*c0*w[0][8]*w[0][8]*g22*g22;
    real G4_2_2_8_2_9_0 = det*c1*c0*w[0][8]*w[0][9]*g22*g02;
    real G4_2_2_8_2_9_1 = det*c1*c0*w[0][8]*w[0][9]*g22*g12;
    real G4_2_2_8_2_9_2 = det*c1*c0*w[0][8]*w[0][9]*g22*g22;
    real G4_2_2_8_2_10_0 = det*c1*c0*w[0][8]*w[0][10]*g22*g02;
    real G4_2_2_8_2_10_1 = det*c1*c0*w[0][8]*w[0][10]*g22*g12;
    real G4_2_2_8_2_10_2 = det*c1*c0*w[0][8]*w[0][10]*g22*g22;
    real G4_2_2_8_2_11_0 = det*c1*c0*w[0][8]*w[0][11]*g22*g02;
    real G4_2_2_8_2_11_1 = det*c1*c0*w[0][8]*w[0][11]*g22*g12;
    real G4_2_2_8_2_11_2 = det*c1*c0*w[0][8]*w[0][11]*g22*g22;
    real G4_2_2_9_0_8_0 = det*c1*c0*w[0][9]*w[0][8]*g02*g02;
    real G4_2_2_9_0_8_1 = det*c1*c0*w[0][9]*w[0][8]*g02*g12;
    real G4_2_2_9_0_8_2 = det*c1*c0*w[0][9]*w[0][8]*g02*g22;
    real G4_2_2_9_0_9_0 = det*c1*c0*w[0][9]*w[0][9]*g02*g02;
    real G4_2_2_9_0_9_1 = det*c1*c0*w[0][9]*w[0][9]*g02*g12;
    real G4_2_2_9_0_9_2 = det*c1*c0*w[0][9]*w[0][9]*g02*g22;
    real G4_2_2_9_0_10_0 = det*c1*c0*w[0][9]*w[0][10]*g02*g02;
    real G4_2_2_9_0_10_1 = det*c1*c0*w[0][9]*w[0][10]*g02*g12;
    real G4_2_2_9_0_10_2 = det*c1*c0*w[0][9]*w[0][10]*g02*g22;
    real G4_2_2_9_0_11_0 = det*c1*c0*w[0][9]*w[0][11]*g02*g02;
    real G4_2_2_9_0_11_1 = det*c1*c0*w[0][9]*w[0][11]*g02*g12;
    real G4_2_2_9_0_11_2 = det*c1*c0*w[0][9]*w[0][11]*g02*g22;
    real G4_2_2_9_1_8_0 = det*c1*c0*w[0][9]*w[0][8]*g12*g02;
    real G4_2_2_9_1_8_1 = det*c1*c0*w[0][9]*w[0][8]*g12*g12;
    real G4_2_2_9_1_8_2 = det*c1*c0*w[0][9]*w[0][8]*g12*g22;
    real G4_2_2_9_1_9_0 = det*c1*c0*w[0][9]*w[0][9]*g12*g02;
    real G4_2_2_9_1_9_1 = det*c1*c0*w[0][9]*w[0][9]*g12*g12;
    real G4_2_2_9_1_9_2 = det*c1*c0*w[0][9]*w[0][9]*g12*g22;
    real G4_2_2_9_1_10_0 = det*c1*c0*w[0][9]*w[0][10]*g12*g02;
    real G4_2_2_9_1_10_1 = det*c1*c0*w[0][9]*w[0][10]*g12*g12;
    real G4_2_2_9_1_10_2 = det*c1*c0*w[0][9]*w[0][10]*g12*g22;
    real G4_2_2_9_1_11_0 = det*c1*c0*w[0][9]*w[0][11]*g12*g02;
    real G4_2_2_9_1_11_1 = det*c1*c0*w[0][9]*w[0][11]*g12*g12;
    real G4_2_2_9_1_11_2 = det*c1*c0*w[0][9]*w[0][11]*g12*g22;
    real G4_2_2_9_2_8_0 = det*c1*c0*w[0][9]*w[0][8]*g22*g02;
    real G4_2_2_9_2_8_1 = det*c1*c0*w[0][9]*w[0][8]*g22*g12;
    real G4_2_2_9_2_8_2 = det*c1*c0*w[0][9]*w[0][8]*g22*g22;
    real G4_2_2_9_2_9_0 = det*c1*c0*w[0][9]*w[0][9]*g22*g02;
    real G4_2_2_9_2_9_1 = det*c1*c0*w[0][9]*w[0][9]*g22*g12;
    real G4_2_2_9_2_9_2 = det*c1*c0*w[0][9]*w[0][9]*g22*g22;
    real G4_2_2_9_2_10_0 = det*c1*c0*w[0][9]*w[0][10]*g22*g02;
    real G4_2_2_9_2_10_1 = det*c1*c0*w[0][9]*w[0][10]*g22*g12;
    real G4_2_2_9_2_10_2 = det*c1*c0*w[0][9]*w[0][10]*g22*g22;
    real G4_2_2_9_2_11_0 = det*c1*c0*w[0][9]*w[0][11]*g22*g02;
    real G4_2_2_9_2_11_1 = det*c1*c0*w[0][9]*w[0][11]*g22*g12;
    real G4_2_2_9_2_11_2 = det*c1*c0*w[0][9]*w[0][11]*g22*g22;
    real G4_2_2_10_0_8_0 = det*c1*c0*w[0][10]*w[0][8]*g02*g02;
    real G4_2_2_10_0_8_1 = det*c1*c0*w[0][10]*w[0][8]*g02*g12;
    real G4_2_2_10_0_8_2 = det*c1*c0*w[0][10]*w[0][8]*g02*g22;
    real G4_2_2_10_0_9_0 = det*c1*c0*w[0][10]*w[0][9]*g02*g02;
    real G4_2_2_10_0_9_1 = det*c1*c0*w[0][10]*w[0][9]*g02*g12;
    real G4_2_2_10_0_9_2 = det*c1*c0*w[0][10]*w[0][9]*g02*g22;
    real G4_2_2_10_0_10_0 = det*c1*c0*w[0][10]*w[0][10]*g02*g02;
    real G4_2_2_10_0_10_1 = det*c1*c0*w[0][10]*w[0][10]*g02*g12;
    real G4_2_2_10_0_10_2 = det*c1*c0*w[0][10]*w[0][10]*g02*g22;
    real G4_2_2_10_0_11_0 = det*c1*c0*w[0][10]*w[0][11]*g02*g02;
    real G4_2_2_10_0_11_1 = det*c1*c0*w[0][10]*w[0][11]*g02*g12;
    real G4_2_2_10_0_11_2 = det*c1*c0*w[0][10]*w[0][11]*g02*g22;
    real G4_2_2_10_1_8_0 = det*c1*c0*w[0][10]*w[0][8]*g12*g02;
    real G4_2_2_10_1_8_1 = det*c1*c0*w[0][10]*w[0][8]*g12*g12;
    real G4_2_2_10_1_8_2 = det*c1*c0*w[0][10]*w[0][8]*g12*g22;
    real G4_2_2_10_1_9_0 = det*c1*c0*w[0][10]*w[0][9]*g12*g02;
    real G4_2_2_10_1_9_1 = det*c1*c0*w[0][10]*w[0][9]*g12*g12;
    real G4_2_2_10_1_9_2 = det*c1*c0*w[0][10]*w[0][9]*g12*g22;
    real G4_2_2_10_1_10_0 = det*c1*c0*w[0][10]*w[0][10]*g12*g02;
    real G4_2_2_10_1_10_1 = det*c1*c0*w[0][10]*w[0][10]*g12*g12;
    real G4_2_2_10_1_10_2 = det*c1*c0*w[0][10]*w[0][10]*g12*g22;
    real G4_2_2_10_1_11_0 = det*c1*c0*w[0][10]*w[0][11]*g12*g02;
    real G4_2_2_10_1_11_1 = det*c1*c0*w[0][10]*w[0][11]*g12*g12;
    real G4_2_2_10_1_11_2 = det*c1*c0*w[0][10]*w[0][11]*g12*g22;
    real G4_2_2_10_2_8_0 = det*c1*c0*w[0][10]*w[0][8]*g22*g02;
    real G4_2_2_10_2_8_1 = det*c1*c0*w[0][10]*w[0][8]*g22*g12;
    real G4_2_2_10_2_8_2 = det*c1*c0*w[0][10]*w[0][8]*g22*g22;
    real G4_2_2_10_2_9_0 = det*c1*c0*w[0][10]*w[0][9]*g22*g02;
    real G4_2_2_10_2_9_1 = det*c1*c0*w[0][10]*w[0][9]*g22*g12;
    real G4_2_2_10_2_9_2 = det*c1*c0*w[0][10]*w[0][9]*g22*g22;
    real G4_2_2_10_2_10_0 = det*c1*c0*w[0][10]*w[0][10]*g22*g02;
    real G4_2_2_10_2_10_1 = det*c1*c0*w[0][10]*w[0][10]*g22*g12;
    real G4_2_2_10_2_10_2 = det*c1*c0*w[0][10]*w[0][10]*g22*g22;
    real G4_2_2_10_2_11_0 = det*c1*c0*w[0][10]*w[0][11]*g22*g02;
    real G4_2_2_10_2_11_1 = det*c1*c0*w[0][10]*w[0][11]*g22*g12;
    real G4_2_2_10_2_11_2 = det*c1*c0*w[0][10]*w[0][11]*g22*g22;
    real G4_2_2_11_0_8_0 = det*c1*c0*w[0][11]*w[0][8]*g02*g02;
    real G4_2_2_11_0_8_1 = det*c1*c0*w[0][11]*w[0][8]*g02*g12;
    real G4_2_2_11_0_8_2 = det*c1*c0*w[0][11]*w[0][8]*g02*g22;
    real G4_2_2_11_0_9_0 = det*c1*c0*w[0][11]*w[0][9]*g02*g02;
    real G4_2_2_11_0_9_1 = det*c1*c0*w[0][11]*w[0][9]*g02*g12;
    real G4_2_2_11_0_9_2 = det*c1*c0*w[0][11]*w[0][9]*g02*g22;
    real G4_2_2_11_0_10_0 = det*c1*c0*w[0][11]*w[0][10]*g02*g02;
    real G4_2_2_11_0_10_1 = det*c1*c0*w[0][11]*w[0][10]*g02*g12;
    real G4_2_2_11_0_10_2 = det*c1*c0*w[0][11]*w[0][10]*g02*g22;
    real G4_2_2_11_0_11_0 = det*c1*c0*w[0][11]*w[0][11]*g02*g02;
    real G4_2_2_11_0_11_1 = det*c1*c0*w[0][11]*w[0][11]*g02*g12;
    real G4_2_2_11_0_11_2 = det*c1*c0*w[0][11]*w[0][11]*g02*g22;
    real G4_2_2_11_1_8_0 = det*c1*c0*w[0][11]*w[0][8]*g12*g02;
    real G4_2_2_11_1_8_1 = det*c1*c0*w[0][11]*w[0][8]*g12*g12;
    real G4_2_2_11_1_8_2 = det*c1*c0*w[0][11]*w[0][8]*g12*g22;
    real G4_2_2_11_1_9_0 = det*c1*c0*w[0][11]*w[0][9]*g12*g02;
    real G4_2_2_11_1_9_1 = det*c1*c0*w[0][11]*w[0][9]*g12*g12;
    real G4_2_2_11_1_9_2 = det*c1*c0*w[0][11]*w[0][9]*g12*g22;
    real G4_2_2_11_1_10_0 = det*c1*c0*w[0][11]*w[0][10]*g12*g02;
    real G4_2_2_11_1_10_1 = det*c1*c0*w[0][11]*w[0][10]*g12*g12;
    real G4_2_2_11_1_10_2 = det*c1*c0*w[0][11]*w[0][10]*g12*g22;
    real G4_2_2_11_1_11_0 = det*c1*c0*w[0][11]*w[0][11]*g12*g02;
    real G4_2_2_11_1_11_1 = det*c1*c0*w[0][11]*w[0][11]*g12*g12;
    real G4_2_2_11_1_11_2 = det*c1*c0*w[0][11]*w[0][11]*g12*g22;
    real G4_2_2_11_2_8_0 = det*c1*c0*w[0][11]*w[0][8]*g22*g02;
    real G4_2_2_11_2_8_1 = det*c1*c0*w[0][11]*w[0][8]*g22*g12;
    real G4_2_2_11_2_8_2 = det*c1*c0*w[0][11]*w[0][8]*g22*g22;
    real G4_2_2_11_2_9_0 = det*c1*c0*w[0][11]*w[0][9]*g22*g02;
    real G4_2_2_11_2_9_1 = det*c1*c0*w[0][11]*w[0][9]*g22*g12;
    real G4_2_2_11_2_9_2 = det*c1*c0*w[0][11]*w[0][9]*g22*g22;
    real G4_2_2_11_2_10_0 = det*c1*c0*w[0][11]*w[0][10]*g22*g02;
    real G4_2_2_11_2_10_1 = det*c1*c0*w[0][11]*w[0][10]*g22*g12;
    real G4_2_2_11_2_10_2 = det*c1*c0*w[0][11]*w[0][10]*g22*g22;
    real G4_2_2_11_2_11_0 = det*c1*c0*w[0][11]*w[0][11]*g22*g02;
    real G4_2_2_11_2_11_1 = det*c1*c0*w[0][11]*w[0][11]*g22*g12;
    real G4_2_2_11_2_11_2 = det*c1*c0*w[0][11]*w[0][11]*g22*g22;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 8.333333333333322e-02*G1_0_1 + 8.333333333333320e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_1_1 + 8.333333333333322e-02*G1_1_2 + 8.333333333333320e-02*G1_2_0 + 8.333333333333322e-02*G1_2_1 + 8.333333333333320e-02*G1_2_2 - 8.333333333333309e-03*G2_0_0_0 - 8.333333333333311e-03*G2_0_0_1 - 8.333333333333311e-03*G2_0_0_2 - 4.166666666666654e-03*G2_0_1_0 - 4.166666666666655e-03*G2_0_1_1 - 4.166666666666654e-03*G2_0_1_2 - 4.166666666666654e-03*G2_0_2_0 - 4.166666666666656e-03*G2_0_2_1 - 4.166666666666655e-03*G2_0_2_2 - 4.166666666666656e-03*G2_0_3_0 - 4.166666666666657e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 8.333333333333309e-03*G2_1_4_0 - 8.333333333333311e-03*G2_1_4_1 - 8.333333333333311e-03*G2_1_4_2 - 4.166666666666655e-03*G2_1_5_0 - 4.166666666666655e-03*G2_1_5_1 - 4.166666666666655e-03*G2_1_5_2 - 4.166666666666654e-03*G2_1_6_0 - 4.166666666666656e-03*G2_1_6_1 - 4.166666666666655e-03*G2_1_6_2 - 4.166666666666656e-03*G2_1_7_0 - 4.166666666666657e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 8.333333333333309e-03*G2_2_8_0 - 8.333333333333311e-03*G2_2_8_1 - 8.333333333333311e-03*G2_2_8_2 - 4.166666666666655e-03*G2_2_9_0 - 4.166666666666655e-03*G2_2_9_1 - 4.166666666666655e-03*G2_2_9_2 - 4.166666666666654e-03*G2_2_10_0 - 4.166666666666656e-03*G2_2_10_1 - 4.166666666666655e-03*G2_2_10_2 - 4.166666666666656e-03*G2_2_11_0 - 4.166666666666657e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 + 8.333333333333320e-02*G3_0_0_0_0 + 8.333333333333322e-02*G3_0_0_0_1 + 8.333333333333320e-02*G3_0_0_0_2 + 8.333333333333322e-02*G3_0_0_1_0 + 8.333333333333323e-02*G3_0_0_1_1 + 8.333333333333322e-02*G3_0_0_1_2 + 8.333333333333320e-02*G3_0_0_2_0 + 8.333333333333322e-02*G3_0_0_2_1 + 8.333333333333320e-02*G3_0_0_2_2 + 8.333333333333309e-03*G4_0_0_0_0_0_0 + 8.333333333333309e-03*G4_0_0_0_0_0_1 + 8.333333333333309e-03*G4_0_0_0_0_0_2 + 4.166666666666654e-03*G4_0_0_0_0_1_0 + 4.166666666666654e-03*G4_0_0_0_0_1_1 + 4.166666666666654e-03*G4_0_0_0_0_1_2 + 4.166666666666654e-03*G4_0_0_0_0_2_0 + 4.166666666666654e-03*G4_0_0_0_0_2_1 + 4.166666666666654e-03*G4_0_0_0_0_2_2 + 4.166666666666656e-03*G4_0_0_0_0_3_0 + 4.166666666666656e-03*G4_0_0_0_0_3_1 + 4.166666666666656e-03*G4_0_0_0_0_3_2 + 8.333333333333309e-03*G4_0_0_0_1_0_0 + 8.333333333333311e-03*G4_0_0_0_1_0_1 + 8.333333333333311e-03*G4_0_0_0_1_0_2 + 4.166666666666654e-03*G4_0_0_0_1_1_0 + 4.166666666666655e-03*G4_0_0_0_1_1_1 + 4.166666666666654e-03*G4_0_0_0_1_1_2 + 4.166666666666654e-03*G4_0_0_0_1_2_0 + 4.166666666666656e-03*G4_0_0_0_1_2_1 + 4.166666666666655e-03*G4_0_0_0_1_2_2 + 4.166666666666656e-03*G4_0_0_0_1_3_0 + 4.166666666666657e-03*G4_0_0_0_1_3_1 + 4.166666666666657e-03*G4_0_0_0_1_3_2 + 8.333333333333309e-03*G4_0_0_0_2_0_0 + 8.333333333333311e-03*G4_0_0_0_2_0_1 + 8.333333333333311e-03*G4_0_0_0_2_0_2 + 4.166666666666654e-03*G4_0_0_0_2_1_0 + 4.166666666666654e-03*G4_0_0_0_2_1_1 + 4.166666666666654e-03*G4_0_0_0_2_1_2 + 4.166666666666654e-03*G4_0_0_0_2_2_0 + 4.166666666666655e-03*G4_0_0_0_2_2_1 + 4.166666666666654e-03*G4_0_0_0_2_2_2 + 4.166666666666656e-03*G4_0_0_0_2_3_0 + 4.166666666666657e-03*G4_0_0_0_2_3_1 + 4.166666666666657e-03*G4_0_0_0_2_3_2 + 4.166666666666654e-03*G4_0_0_1_0_0_0 + 4.166666666666654e-03*G4_0_0_1_0_0_1 + 4.166666666666654e-03*G4_0_0_1_0_0_2 + 8.333333333333307e-03*G4_0_0_1_0_1_0 + 8.333333333333307e-03*G4_0_0_1_0_1_1 + 8.333333333333305e-03*G4_0_0_1_0_1_2 + 4.166666666666654e-03*G4_0_0_1_0_2_0 + 4.166666666666654e-03*G4_0_0_1_0_2_1 + 4.166666666666653e-03*G4_0_0_1_0_2_2 + 4.166666666666654e-03*G4_0_0_1_0_3_0 + 4.166666666666655e-03*G4_0_0_1_0_3_1 + 4.166666666666655e-03*G4_0_0_1_0_3_2 + 4.166666666666654e-03*G4_0_0_1_1_0_0 + 4.166666666666655e-03*G4_0_0_1_1_0_1 + 4.166666666666654e-03*G4_0_0_1_1_0_2 + 8.333333333333307e-03*G4_0_0_1_1_1_0 + 8.333333333333309e-03*G4_0_0_1_1_1_1 + 8.333333333333307e-03*G4_0_0_1_1_1_2 + 4.166666666666654e-03*G4_0_0_1_1_2_0 + 4.166666666666654e-03*G4_0_0_1_1_2_1 + 4.166666666666654e-03*G4_0_0_1_1_2_2 + 4.166666666666655e-03*G4_0_0_1_1_3_0 + 4.166666666666655e-03*G4_0_0_1_1_3_1 + 4.166666666666655e-03*G4_0_0_1_1_3_2 + 4.166666666666654e-03*G4_0_0_1_2_0_0 + 4.166666666666654e-03*G4_0_0_1_2_0_1 + 4.166666666666654e-03*G4_0_0_1_2_0_2 + 8.333333333333307e-03*G4_0_0_1_2_1_0 + 8.333333333333307e-03*G4_0_0_1_2_1_1 + 8.333333333333305e-03*G4_0_0_1_2_1_2 + 4.166666666666654e-03*G4_0_0_1_2_2_0 + 4.166666666666654e-03*G4_0_0_1_2_2_1 + 4.166666666666653e-03*G4_0_0_1_2_2_2 + 4.166666666666655e-03*G4_0_0_1_2_3_0 + 4.166666666666655e-03*G4_0_0_1_2_3_1 + 4.166666666666655e-03*G4_0_0_1_2_3_2 + 4.166666666666654e-03*G4_0_0_2_0_0_0 + 4.166666666666654e-03*G4_0_0_2_0_0_1 + 4.166666666666654e-03*G4_0_0_2_0_0_2 + 4.166666666666654e-03*G4_0_0_2_0_1_0 + 4.166666666666654e-03*G4_0_0_2_0_1_1 + 4.166666666666653e-03*G4_0_0_2_0_1_2 + 8.333333333333309e-03*G4_0_0_2_0_2_0 + 8.333333333333309e-03*G4_0_0_2_0_2_1 + 8.333333333333309e-03*G4_0_0_2_0_2_2 + 4.166666666666654e-03*G4_0_0_2_0_3_0 + 4.166666666666655e-03*G4_0_0_2_0_3_1 + 4.166666666666654e-03*G4_0_0_2_0_3_2 + 4.166666666666654e-03*G4_0_0_2_1_0_0 + 4.166666666666656e-03*G4_0_0_2_1_0_1 + 4.166666666666655e-03*G4_0_0_2_1_0_2 + 4.166666666666654e-03*G4_0_0_2_1_1_0 + 4.166666666666654e-03*G4_0_0_2_1_1_1 + 4.166666666666654e-03*G4_0_0_2_1_1_2 + 8.333333333333311e-03*G4_0_0_2_1_2_0 + 8.333333333333311e-03*G4_0_0_2_1_2_1 + 8.333333333333311e-03*G4_0_0_2_1_2_2 + 4.166666666666655e-03*G4_0_0_2_1_3_0 + 4.166666666666656e-03*G4_0_0_2_1_3_1 + 4.166666666666655e-03*G4_0_0_2_1_3_2 + 4.166666666666654e-03*G4_0_0_2_2_0_0 + 4.166666666666655e-03*G4_0_0_2_2_0_1 + 4.166666666666654e-03*G4_0_0_2_2_0_2 + 4.166666666666654e-03*G4_0_0_2_2_1_0 + 4.166666666666654e-03*G4_0_0_2_2_1_1 + 4.166666666666653e-03*G4_0_0_2_2_1_2 + 8.333333333333309e-03*G4_0_0_2_2_2_0 + 8.333333333333309e-03*G4_0_0_2_2_2_1 + 8.333333333333309e-03*G4_0_0_2_2_2_2 + 4.166666666666654e-03*G4_0_0_2_2_3_0 + 4.166666666666655e-03*G4_0_0_2_2_3_1 + 4.166666666666654e-03*G4_0_0_2_2_3_2 + 4.166666666666656e-03*G4_0_0_3_0_0_0 + 4.166666666666656e-03*G4_0_0_3_0_0_1 + 4.166666666666656e-03*G4_0_0_3_0_0_2 + 4.166666666666654e-03*G4_0_0_3_0_1_0 + 4.166666666666655e-03*G4_0_0_3_0_1_1 + 4.166666666666654e-03*G4_0_0_3_0_1_2 + 4.166666666666655e-03*G4_0_0_3_0_2_0 + 4.166666666666655e-03*G4_0_0_3_0_2_1 + 4.166666666666654e-03*G4_0_0_3_0_2_2 + 8.333333333333309e-03*G4_0_0_3_0_3_0 + 8.333333333333311e-03*G4_0_0_3_0_3_1 + 8.333333333333309e-03*G4_0_0_3_0_3_2 + 4.166666666666656e-03*G4_0_0_3_1_0_0 + 4.166666666666657e-03*G4_0_0_3_1_0_1 + 4.166666666666657e-03*G4_0_0_3_1_0_2 + 4.166666666666655e-03*G4_0_0_3_1_1_0 + 4.166666666666655e-03*G4_0_0_3_1_1_1 + 4.166666666666655e-03*G4_0_0_3_1_1_2 + 4.166666666666655e-03*G4_0_0_3_1_2_0 + 4.166666666666656e-03*G4_0_0_3_1_2_1 + 4.166666666666655e-03*G4_0_0_3_1_2_2 + 8.333333333333311e-03*G4_0_0_3_1_3_0 + 8.333333333333311e-03*G4_0_0_3_1_3_1 + 8.333333333333311e-03*G4_0_0_3_1_3_2 + 4.166666666666656e-03*G4_0_0_3_2_0_0 + 4.166666666666657e-03*G4_0_0_3_2_0_1 + 4.166666666666657e-03*G4_0_0_3_2_0_2 + 4.166666666666655e-03*G4_0_0_3_2_1_0 + 4.166666666666655e-03*G4_0_0_3_2_1_1 + 4.166666666666655e-03*G4_0_0_3_2_1_2 + 4.166666666666655e-03*G4_0_0_3_2_2_0 + 4.166666666666655e-03*G4_0_0_3_2_2_1 + 4.166666666666654e-03*G4_0_0_3_2_2_2 + 8.333333333333309e-03*G4_0_0_3_2_3_0 + 8.333333333333311e-03*G4_0_0_3_2_3_1 + 8.333333333333309e-03*G4_0_0_3_2_3_2 + 8.333333333333309e-03*G4_0_1_0_0_4_0 + 8.333333333333309e-03*G4_0_1_0_0_4_1 + 8.333333333333309e-03*G4_0_1_0_0_4_2 + 4.166666666666654e-03*G4_0_1_0_0_5_0 + 4.166666666666655e-03*G4_0_1_0_0_5_1 + 4.166666666666654e-03*G4_0_1_0_0_5_2 + 4.166666666666654e-03*G4_0_1_0_0_6_0 + 4.166666666666654e-03*G4_0_1_0_0_6_1 + 4.166666666666654e-03*G4_0_1_0_0_6_2 + 4.166666666666656e-03*G4_0_1_0_0_7_0 + 4.166666666666656e-03*G4_0_1_0_0_7_1 + 4.166666666666656e-03*G4_0_1_0_0_7_2 + 8.333333333333309e-03*G4_0_1_0_1_4_0 + 8.333333333333311e-03*G4_0_1_0_1_4_1 + 8.333333333333311e-03*G4_0_1_0_1_4_2 + 4.166666666666655e-03*G4_0_1_0_1_5_0 + 4.166666666666655e-03*G4_0_1_0_1_5_1 + 4.166666666666655e-03*G4_0_1_0_1_5_2 + 4.166666666666654e-03*G4_0_1_0_1_6_0 + 4.166666666666656e-03*G4_0_1_0_1_6_1 + 4.166666666666655e-03*G4_0_1_0_1_6_2 + 4.166666666666656e-03*G4_0_1_0_1_7_0 + 4.166666666666657e-03*G4_0_1_0_1_7_1 + 4.166666666666657e-03*G4_0_1_0_1_7_2 + 8.333333333333309e-03*G4_0_1_0_2_4_0 + 8.333333333333311e-03*G4_0_1_0_2_4_1 + 8.333333333333311e-03*G4_0_1_0_2_4_2 + 4.166666666666655e-03*G4_0_1_0_2_5_0 + 4.166666666666655e-03*G4_0_1_0_2_5_1 + 4.166666666666654e-03*G4_0_1_0_2_5_2 + 4.166666666666654e-03*G4_0_1_0_2_6_0 + 4.166666666666655e-03*G4_0_1_0_2_6_1 + 4.166666666666654e-03*G4_0_1_0_2_6_2 + 4.166666666666656e-03*G4_0_1_0_2_7_0 + 4.166666666666657e-03*G4_0_1_0_2_7_1 + 4.166666666666657e-03*G4_0_1_0_2_7_2 + 4.166666666666654e-03*G4_0_1_1_0_4_0 + 4.166666666666654e-03*G4_0_1_1_0_4_1 + 4.166666666666653e-03*G4_0_1_1_0_4_2 + 8.333333333333307e-03*G4_0_1_1_0_5_0 + 8.333333333333309e-03*G4_0_1_1_0_5_1 + 8.333333333333307e-03*G4_0_1_1_0_5_2 + 4.166666666666654e-03*G4_0_1_1_0_6_0 + 4.166666666666654e-03*G4_0_1_1_0_6_1 + 4.166666666666653e-03*G4_0_1_1_0_6_2 + 4.166666666666654e-03*G4_0_1_1_0_7_0 + 4.166666666666655e-03*G4_0_1_1_0_7_1 + 4.166666666666655e-03*G4_0_1_1_0_7_2 + 4.166666666666654e-03*G4_0_1_1_1_4_0 + 4.166666666666654e-03*G4_0_1_1_1_4_1 + 4.166666666666654e-03*G4_0_1_1_1_4_2 + 8.333333333333309e-03*G4_0_1_1_1_5_0 + 8.333333333333309e-03*G4_0_1_1_1_5_1 + 8.333333333333307e-03*G4_0_1_1_1_5_2 + 4.166666666666654e-03*G4_0_1_1_1_6_0 + 4.166666666666654e-03*G4_0_1_1_1_6_1 + 4.166666666666654e-03*G4_0_1_1_1_6_2 + 4.166666666666655e-03*G4_0_1_1_1_7_0 + 4.166666666666655e-03*G4_0_1_1_1_7_1 + 4.166666666666655e-03*G4_0_1_1_1_7_2 + 4.166666666666654e-03*G4_0_1_1_2_4_0 + 4.166666666666654e-03*G4_0_1_1_2_4_1 + 4.166666666666654e-03*G4_0_1_1_2_4_2 + 8.333333333333307e-03*G4_0_1_1_2_5_0 + 8.333333333333309e-03*G4_0_1_1_2_5_1 + 8.333333333333307e-03*G4_0_1_1_2_5_2 + 4.166666666666654e-03*G4_0_1_1_2_6_0 + 4.166666666666654e-03*G4_0_1_1_2_6_1 + 4.166666666666653e-03*G4_0_1_1_2_6_2 + 4.166666666666655e-03*G4_0_1_1_2_7_0 + 4.166666666666655e-03*G4_0_1_1_2_7_1 + 4.166666666666655e-03*G4_0_1_1_2_7_2 + 4.166666666666653e-03*G4_0_1_2_0_4_0 + 4.166666666666654e-03*G4_0_1_2_0_4_1 + 4.166666666666653e-03*G4_0_1_2_0_4_2 + 4.166666666666654e-03*G4_0_1_2_0_5_0 + 4.166666666666655e-03*G4_0_1_2_0_5_1 + 4.166666666666654e-03*G4_0_1_2_0_5_2 + 8.333333333333309e-03*G4_0_1_2_0_6_0 + 8.333333333333309e-03*G4_0_1_2_0_6_1 + 8.333333333333309e-03*G4_0_1_2_0_6_2 + 4.166666666666654e-03*G4_0_1_2_0_7_0 + 4.166666666666655e-03*G4_0_1_2_0_7_1 + 4.166666666666654e-03*G4_0_1_2_0_7_2 + 4.166666666666654e-03*G4_0_1_2_1_4_0 + 4.166666666666654e-03*G4_0_1_2_1_4_1 + 4.166666666666654e-03*G4_0_1_2_1_4_2 + 4.166666666666655e-03*G4_0_1_2_1_5_0 + 4.166666666666656e-03*G4_0_1_2_1_5_1 + 4.166666666666654e-03*G4_0_1_2_1_5_2 + 8.333333333333311e-03*G4_0_1_2_1_6_0 + 8.333333333333311e-03*G4_0_1_2_1_6_1 + 8.333333333333311e-03*G4_0_1_2_1_6_2 + 4.166666666666655e-03*G4_0_1_2_1_7_0 + 4.166666666666656e-03*G4_0_1_2_1_7_1 + 4.166666666666655e-03*G4_0_1_2_1_7_2 + 4.166666666666653e-03*G4_0_1_2_2_4_0 + 4.166666666666654e-03*G4_0_1_2_2_4_1 + 4.166666666666654e-03*G4_0_1_2_2_4_2 + 4.166666666666654e-03*G4_0_1_2_2_5_0 + 4.166666666666654e-03*G4_0_1_2_2_5_1 + 4.166666666666654e-03*G4_0_1_2_2_5_2 + 8.333333333333309e-03*G4_0_1_2_2_6_0 + 8.333333333333309e-03*G4_0_1_2_2_6_1 + 8.333333333333309e-03*G4_0_1_2_2_6_2 + 4.166666666666654e-03*G4_0_1_2_2_7_0 + 4.166666666666655e-03*G4_0_1_2_2_7_1 + 4.166666666666654e-03*G4_0_1_2_2_7_2 + 4.166666666666655e-03*G4_0_1_3_0_4_0 + 4.166666666666656e-03*G4_0_1_3_0_4_1 + 4.166666666666655e-03*G4_0_1_3_0_4_2 + 4.166666666666655e-03*G4_0_1_3_0_5_0 + 4.166666666666656e-03*G4_0_1_3_0_5_1 + 4.166666666666656e-03*G4_0_1_3_0_5_2 + 4.166666666666655e-03*G4_0_1_3_0_6_0 + 4.166666666666655e-03*G4_0_1_3_0_6_1 + 4.166666666666654e-03*G4_0_1_3_0_6_2 + 8.333333333333309e-03*G4_0_1_3_0_7_0 + 8.333333333333311e-03*G4_0_1_3_0_7_1 + 8.333333333333309e-03*G4_0_1_3_0_7_2 + 4.166666666666656e-03*G4_0_1_3_1_4_0 + 4.166666666666657e-03*G4_0_1_3_1_4_1 + 4.166666666666657e-03*G4_0_1_3_1_4_2 + 4.166666666666656e-03*G4_0_1_3_1_5_0 + 4.166666666666657e-03*G4_0_1_3_1_5_1 + 4.166666666666656e-03*G4_0_1_3_1_5_2 + 4.166666666666655e-03*G4_0_1_3_1_6_0 + 4.166666666666656e-03*G4_0_1_3_1_6_1 + 4.166666666666655e-03*G4_0_1_3_1_6_2 + 8.333333333333311e-03*G4_0_1_3_1_7_0 + 8.333333333333311e-03*G4_0_1_3_1_7_1 + 8.333333333333311e-03*G4_0_1_3_1_7_2 + 4.166666666666655e-03*G4_0_1_3_2_4_0 + 4.166666666666657e-03*G4_0_1_3_2_4_1 + 4.166666666666656e-03*G4_0_1_3_2_4_2 + 4.166666666666656e-03*G4_0_1_3_2_5_0 + 4.166666666666656e-03*G4_0_1_3_2_5_1 + 4.166666666666656e-03*G4_0_1_3_2_5_2 + 4.166666666666655e-03*G4_0_1_3_2_6_0 + 4.166666666666655e-03*G4_0_1_3_2_6_1 + 4.166666666666654e-03*G4_0_1_3_2_6_2 + 8.333333333333309e-03*G4_0_1_3_2_7_0 + 8.333333333333311e-03*G4_0_1_3_2_7_1 + 8.333333333333309e-03*G4_0_1_3_2_7_2 + 8.333333333333309e-03*G4_0_2_0_0_8_0 + 8.333333333333309e-03*G4_0_2_0_0_8_1 + 8.333333333333309e-03*G4_0_2_0_0_8_2 + 4.166666666666654e-03*G4_0_2_0_0_9_0 + 4.166666666666655e-03*G4_0_2_0_0_9_1 + 4.166666666666654e-03*G4_0_2_0_0_9_2 + 4.166666666666654e-03*G4_0_2_0_0_10_0 + 4.166666666666654e-03*G4_0_2_0_0_10_1 + 4.166666666666654e-03*G4_0_2_0_0_10_2 + 4.166666666666656e-03*G4_0_2_0_0_11_0 + 4.166666666666656e-03*G4_0_2_0_0_11_1 + 4.166666666666656e-03*G4_0_2_0_0_11_2 + 8.333333333333309e-03*G4_0_2_0_1_8_0 + 8.333333333333311e-03*G4_0_2_0_1_8_1 + 8.333333333333311e-03*G4_0_2_0_1_8_2 + 4.166666666666655e-03*G4_0_2_0_1_9_0 + 4.166666666666655e-03*G4_0_2_0_1_9_1 + 4.166666666666655e-03*G4_0_2_0_1_9_2 + 4.166666666666654e-03*G4_0_2_0_1_10_0 + 4.166666666666656e-03*G4_0_2_0_1_10_1 + 4.166666666666655e-03*G4_0_2_0_1_10_2 + 4.166666666666656e-03*G4_0_2_0_1_11_0 + 4.166666666666657e-03*G4_0_2_0_1_11_1 + 4.166666666666657e-03*G4_0_2_0_1_11_2 + 8.333333333333309e-03*G4_0_2_0_2_8_0 + 8.333333333333311e-03*G4_0_2_0_2_8_1 + 8.333333333333311e-03*G4_0_2_0_2_8_2 + 4.166666666666655e-03*G4_0_2_0_2_9_0 + 4.166666666666655e-03*G4_0_2_0_2_9_1 + 4.166666666666654e-03*G4_0_2_0_2_9_2 + 4.166666666666654e-03*G4_0_2_0_2_10_0 + 4.166666666666655e-03*G4_0_2_0_2_10_1 + 4.166666666666654e-03*G4_0_2_0_2_10_2 + 4.166666666666656e-03*G4_0_2_0_2_11_0 + 4.166666666666657e-03*G4_0_2_0_2_11_1 + 4.166666666666657e-03*G4_0_2_0_2_11_2 + 4.166666666666654e-03*G4_0_2_1_0_8_0 + 4.166666666666654e-03*G4_0_2_1_0_8_1 + 4.166666666666653e-03*G4_0_2_1_0_8_2 + 8.333333333333307e-03*G4_0_2_1_0_9_0 + 8.333333333333309e-03*G4_0_2_1_0_9_1 + 8.333333333333307e-03*G4_0_2_1_0_9_2 + 4.166666666666654e-03*G4_0_2_1_0_10_0 + 4.166666666666654e-03*G4_0_2_1_0_10_1 + 4.166666666666653e-03*G4_0_2_1_0_10_2 + 4.166666666666654e-03*G4_0_2_1_0_11_0 + 4.166666666666655e-03*G4_0_2_1_0_11_1 + 4.166666666666655e-03*G4_0_2_1_0_11_2 + 4.166666666666654e-03*G4_0_2_1_1_8_0 + 4.166666666666654e-03*G4_0_2_1_1_8_1 + 4.166666666666654e-03*G4_0_2_1_1_8_2 + 8.333333333333309e-03*G4_0_2_1_1_9_0 + 8.333333333333309e-03*G4_0_2_1_1_9_1 + 8.333333333333307e-03*G4_0_2_1_1_9_2 + 4.166666666666654e-03*G4_0_2_1_1_10_0 + 4.166666666666654e-03*G4_0_2_1_1_10_1 + 4.166666666666654e-03*G4_0_2_1_1_10_2 + 4.166666666666655e-03*G4_0_2_1_1_11_0 + 4.166666666666655e-03*G4_0_2_1_1_11_1 + 4.166666666666655e-03*G4_0_2_1_1_11_2 + 4.166666666666654e-03*G4_0_2_1_2_8_0 + 4.166666666666654e-03*G4_0_2_1_2_8_1 + 4.166666666666654e-03*G4_0_2_1_2_8_2 + 8.333333333333307e-03*G4_0_2_1_2_9_0 + 8.333333333333309e-03*G4_0_2_1_2_9_1 + 8.333333333333307e-03*G4_0_2_1_2_9_2 + 4.166666666666654e-03*G4_0_2_1_2_10_0 + 4.166666666666654e-03*G4_0_2_1_2_10_1 + 4.166666666666653e-03*G4_0_2_1_2_10_2 + 4.166666666666655e-03*G4_0_2_1_2_11_0 + 4.166666666666655e-03*G4_0_2_1_2_11_1 + 4.166666666666655e-03*G4_0_2_1_2_11_2 + 4.166666666666653e-03*G4_0_2_2_0_8_0 + 4.166666666666654e-03*G4_0_2_2_0_8_1 + 4.166666666666653e-03*G4_0_2_2_0_8_2 + 4.166666666666654e-03*G4_0_2_2_0_9_0 + 4.166666666666655e-03*G4_0_2_2_0_9_1 + 4.166666666666654e-03*G4_0_2_2_0_9_2 + 8.333333333333309e-03*G4_0_2_2_0_10_0 + 8.333333333333309e-03*G4_0_2_2_0_10_1 + 8.333333333333309e-03*G4_0_2_2_0_10_2 + 4.166666666666654e-03*G4_0_2_2_0_11_0 + 4.166666666666655e-03*G4_0_2_2_0_11_1 + 4.166666666666654e-03*G4_0_2_2_0_11_2 + 4.166666666666654e-03*G4_0_2_2_1_8_0 + 4.166666666666654e-03*G4_0_2_2_1_8_1 + 4.166666666666654e-03*G4_0_2_2_1_8_2 + 4.166666666666655e-03*G4_0_2_2_1_9_0 + 4.166666666666656e-03*G4_0_2_2_1_9_1 + 4.166666666666654e-03*G4_0_2_2_1_9_2 + 8.333333333333311e-03*G4_0_2_2_1_10_0 + 8.333333333333311e-03*G4_0_2_2_1_10_1 + 8.333333333333311e-03*G4_0_2_2_1_10_2 + 4.166666666666655e-03*G4_0_2_2_1_11_0 + 4.166666666666656e-03*G4_0_2_2_1_11_1 + 4.166666666666655e-03*G4_0_2_2_1_11_2 + 4.166666666666653e-03*G4_0_2_2_2_8_0 + 4.166666666666654e-03*G4_0_2_2_2_8_1 + 4.166666666666654e-03*G4_0_2_2_2_8_2 + 4.166666666666654e-03*G4_0_2_2_2_9_0 + 4.166666666666654e-03*G4_0_2_2_2_9_1 + 4.166666666666654e-03*G4_0_2_2_2_9_2 + 8.333333333333309e-03*G4_0_2_2_2_10_0 + 8.333333333333309e-03*G4_0_2_2_2_10_1 + 8.333333333333309e-03*G4_0_2_2_2_10_2 + 4.166666666666654e-03*G4_0_2_2_2_11_0 + 4.166666666666655e-03*G4_0_2_2_2_11_1 + 4.166666666666654e-03*G4_0_2_2_2_11_2 + 4.166666666666655e-03*G4_0_2_3_0_8_0 + 4.166666666666656e-03*G4_0_2_3_0_8_1 + 4.166666666666655e-03*G4_0_2_3_0_8_2 + 4.166666666666655e-03*G4_0_2_3_0_9_0 + 4.166666666666656e-03*G4_0_2_3_0_9_1 + 4.166666666666656e-03*G4_0_2_3_0_9_2 + 4.166666666666655e-03*G4_0_2_3_0_10_0 + 4.166666666666655e-03*G4_0_2_3_0_10_1 + 4.166666666666654e-03*G4_0_2_3_0_10_2 + 8.333333333333309e-03*G4_0_2_3_0_11_0 + 8.333333333333311e-03*G4_0_2_3_0_11_1 + 8.333333333333309e-03*G4_0_2_3_0_11_2 + 4.166666666666656e-03*G4_0_2_3_1_8_0 + 4.166666666666657e-03*G4_0_2_3_1_8_1 + 4.166666666666657e-03*G4_0_2_3_1_8_2 + 4.166666666666656e-03*G4_0_2_3_1_9_0 + 4.166666666666657e-03*G4_0_2_3_1_9_1 + 4.166666666666656e-03*G4_0_2_3_1_9_2 + 4.166666666666655e-03*G4_0_2_3_1_10_0 + 4.166666666666656e-03*G4_0_2_3_1_10_1 + 4.166666666666655e-03*G4_0_2_3_1_10_2 + 8.333333333333311e-03*G4_0_2_3_1_11_0 + 8.333333333333311e-03*G4_0_2_3_1_11_1 + 8.333333333333311e-03*G4_0_2_3_1_11_2 + 4.166666666666655e-03*G4_0_2_3_2_8_0 + 4.166666666666657e-03*G4_0_2_3_2_8_1 + 4.166666666666656e-03*G4_0_2_3_2_8_2 + 4.166666666666656e-03*G4_0_2_3_2_9_0 + 4.166666666666656e-03*G4_0_2_3_2_9_1 + 4.166666666666656e-03*G4_0_2_3_2_9_2 + 4.166666666666655e-03*G4_0_2_3_2_10_0 + 4.166666666666655e-03*G4_0_2_3_2_10_1 + 4.166666666666654e-03*G4_0_2_3_2_10_2 + 8.333333333333309e-03*G4_0_2_3_2_11_0 + 8.333333333333311e-03*G4_0_2_3_2_11_1 + 8.333333333333309e-03*G4_0_2_3_2_11_2 + 8.333333333333309e-03*G4_1_0_4_0_0_0 + 8.333333333333309e-03*G4_1_0_4_0_0_1 + 8.333333333333309e-03*G4_1_0_4_0_0_2 + 4.166666666666654e-03*G4_1_0_4_0_1_0 + 4.166666666666654e-03*G4_1_0_4_0_1_1 + 4.166666666666653e-03*G4_1_0_4_0_1_2 + 4.166666666666653e-03*G4_1_0_4_0_2_0 + 4.166666666666654e-03*G4_1_0_4_0_2_1 + 4.166666666666654e-03*G4_1_0_4_0_2_2 + 4.166666666666654e-03*G4_1_0_4_0_3_0 + 4.166666666666656e-03*G4_1_0_4_0_3_1 + 4.166666666666654e-03*G4_1_0_4_0_3_2 + 8.333333333333309e-03*G4_1_0_4_1_0_0 + 8.333333333333311e-03*G4_1_0_4_1_0_1 + 8.333333333333311e-03*G4_1_0_4_1_0_2 + 4.166666666666654e-03*G4_1_0_4_1_1_0 + 4.166666666666654e-03*G4_1_0_4_1_1_1 + 4.166666666666654e-03*G4_1_0_4_1_1_2 + 4.166666666666654e-03*G4_1_0_4_1_2_0 + 4.166666666666654e-03*G4_1_0_4_1_2_1 + 4.166666666666654e-03*G4_1_0_4_1_2_2 + 4.166666666666656e-03*G4_1_0_4_1_3_0 + 4.166666666666657e-03*G4_1_0_4_1_3_1 + 4.166666666666657e-03*G4_1_0_4_1_3_2 + 8.333333333333309e-03*G4_1_0_4_2_0_0 + 8.333333333333311e-03*G4_1_0_4_2_0_1 + 8.333333333333311e-03*G4_1_0_4_2_0_2 + 4.166666666666654e-03*G4_1_0_4_2_1_0 + 4.166666666666654e-03*G4_1_0_4_2_1_1 + 4.166666666666654e-03*G4_1_0_4_2_1_2 + 4.166666666666654e-03*G4_1_0_4_2_2_0 + 4.166666666666654e-03*G4_1_0_4_2_2_1 + 4.166666666666654e-03*G4_1_0_4_2_2_2 + 4.166666666666654e-03*G4_1_0_4_2_3_0 + 4.166666666666657e-03*G4_1_0_4_2_3_1 + 4.166666666666656e-03*G4_1_0_4_2_3_2 + 4.166666666666654e-03*G4_1_0_5_0_0_0 + 4.166666666666655e-03*G4_1_0_5_0_0_1 + 4.166666666666654e-03*G4_1_0_5_0_0_2 + 8.333333333333307e-03*G4_1_0_5_0_1_0 + 8.333333333333309e-03*G4_1_0_5_0_1_1 + 8.333333333333307e-03*G4_1_0_5_0_1_2 + 4.166666666666654e-03*G4_1_0_5_0_2_0 + 4.166666666666655e-03*G4_1_0_5_0_2_1 + 4.166666666666654e-03*G4_1_0_5_0_2_2 + 4.166666666666655e-03*G4_1_0_5_0_3_0 + 4.166666666666656e-03*G4_1_0_5_0_3_1 + 4.166666666666656e-03*G4_1_0_5_0_3_2 + 4.166666666666655e-03*G4_1_0_5_1_0_0 + 4.166666666666655e-03*G4_1_0_5_1_0_1 + 4.166666666666655e-03*G4_1_0_5_1_0_2 + 8.333333333333309e-03*G4_1_0_5_1_1_0 + 8.333333333333309e-03*G4_1_0_5_1_1_1 + 8.333333333333307e-03*G4_1_0_5_1_1_2 + 4.166666666666655e-03*G4_1_0_5_1_2_0 + 4.166666666666656e-03*G4_1_0_5_1_2_1 + 4.166666666666654e-03*G4_1_0_5_1_2_2 + 4.166666666666656e-03*G4_1_0_5_1_3_0 + 4.166666666666657e-03*G4_1_0_5_1_3_1 + 4.166666666666656e-03*G4_1_0_5_1_3_2 + 4.166666666666655e-03*G4_1_0_5_2_0_0 + 4.166666666666655e-03*G4_1_0_5_2_0_1 + 4.166666666666654e-03*G4_1_0_5_2_0_2 + 8.333333333333307e-03*G4_1_0_5_2_1_0 + 8.333333333333309e-03*G4_1_0_5_2_1_1 + 8.333333333333307e-03*G4_1_0_5_2_1_2 + 4.166666666666654e-03*G4_1_0_5_2_2_0 + 4.166666666666655e-03*G4_1_0_5_2_2_1 + 4.166666666666654e-03*G4_1_0_5_2_2_2 + 4.166666666666656e-03*G4_1_0_5_2_3_0 + 4.166666666666656e-03*G4_1_0_5_2_3_1 + 4.166666666666656e-03*G4_1_0_5_2_3_2 + 4.166666666666654e-03*G4_1_0_6_0_0_0 + 4.166666666666654e-03*G4_1_0_6_0_0_1 + 4.166666666666654e-03*G4_1_0_6_0_0_2 + 4.166666666666654e-03*G4_1_0_6_0_1_0 + 4.166666666666654e-03*G4_1_0_6_0_1_1 + 4.166666666666653e-03*G4_1_0_6_0_1_2 + 8.333333333333309e-03*G4_1_0_6_0_2_0 + 8.333333333333309e-03*G4_1_0_6_0_2_1 + 8.333333333333309e-03*G4_1_0_6_0_2_2 + 4.166666666666654e-03*G4_1_0_6_0_3_0 + 4.166666666666655e-03*G4_1_0_6_0_3_1 + 4.166666666666654e-03*G4_1_0_6_0_3_2 + 4.166666666666654e-03*G4_1_0_6_1_0_0 + 4.166666666666656e-03*G4_1_0_6_1_0_1 + 4.166666666666655e-03*G4_1_0_6_1_0_2 + 4.166666666666654e-03*G4_1_0_6_1_1_0 + 4.166666666666654e-03*G4_1_0_6_1_1_1 + 4.166666666666654e-03*G4_1_0_6_1_1_2 + 8.333333333333311e-03*G4_1_0_6_1_2_0 + 8.333333333333311e-03*G4_1_0_6_1_2_1 + 8.333333333333311e-03*G4_1_0_6_1_2_2 + 4.166666666666655e-03*G4_1_0_6_1_3_0 + 4.166666666666656e-03*G4_1_0_6_1_3_1 + 4.166666666666655e-03*G4_1_0_6_1_3_2 + 4.166666666666654e-03*G4_1_0_6_2_0_0 + 4.166666666666655e-03*G4_1_0_6_2_0_1 + 4.166666666666654e-03*G4_1_0_6_2_0_2 + 4.166666666666654e-03*G4_1_0_6_2_1_0 + 4.166666666666654e-03*G4_1_0_6_2_1_1 + 4.166666666666653e-03*G4_1_0_6_2_1_2 + 8.333333333333309e-03*G4_1_0_6_2_2_0 + 8.333333333333309e-03*G4_1_0_6_2_2_1 + 8.333333333333309e-03*G4_1_0_6_2_2_2 + 4.166666666666654e-03*G4_1_0_6_2_3_0 + 4.166666666666655e-03*G4_1_0_6_2_3_1 + 4.166666666666654e-03*G4_1_0_6_2_3_2 + 4.166666666666656e-03*G4_1_0_7_0_0_0 + 4.166666666666656e-03*G4_1_0_7_0_0_1 + 4.166666666666656e-03*G4_1_0_7_0_0_2 + 4.166666666666654e-03*G4_1_0_7_0_1_0 + 4.166666666666655e-03*G4_1_0_7_0_1_1 + 4.166666666666654e-03*G4_1_0_7_0_1_2 + 4.166666666666655e-03*G4_1_0_7_0_2_0 + 4.166666666666655e-03*G4_1_0_7_0_2_1 + 4.166666666666654e-03*G4_1_0_7_0_2_2 + 8.333333333333309e-03*G4_1_0_7_0_3_0 + 8.333333333333311e-03*G4_1_0_7_0_3_1 + 8.333333333333309e-03*G4_1_0_7_0_3_2 + 4.166666666666656e-03*G4_1_0_7_1_0_0 + 4.166666666666657e-03*G4_1_0_7_1_0_1 + 4.166666666666657e-03*G4_1_0_7_1_0_2 + 4.166666666666655e-03*G4_1_0_7_1_1_0 + 4.166666666666655e-03*G4_1_0_7_1_1_1 + 4.166666666666655e-03*G4_1_0_7_1_1_2 + 4.166666666666655e-03*G4_1_0_7_1_2_0 + 4.166666666666656e-03*G4_1_0_7_1_2_1 + 4.166666666666655e-03*G4_1_0_7_1_2_2 + 8.333333333333311e-03*G4_1_0_7_1_3_0 + 8.333333333333311e-03*G4_1_0_7_1_3_1 + 8.333333333333311e-03*G4_1_0_7_1_3_2 + 4.166666666666656e-03*G4_1_0_7_2_0_0 + 4.166666666666657e-03*G4_1_0_7_2_0_1 + 4.166666666666657e-03*G4_1_0_7_2_0_2 + 4.166666666666655e-03*G4_1_0_7_2_1_0 + 4.166666666666655e-03*G4_1_0_7_2_1_1 + 4.166666666666655e-03*G4_1_0_7_2_1_2 + 4.166666666666655e-03*G4_1_0_7_2_2_0 + 4.166666666666655e-03*G4_1_0_7_2_2_1 + 4.166666666666654e-03*G4_1_0_7_2_2_2 + 8.333333333333309e-03*G4_1_0_7_2_3_0 + 8.333333333333311e-03*G4_1_0_7_2_3_1 + 8.333333333333309e-03*G4_1_0_7_2_3_2 + 8.333333333333309e-03*G4_1_1_4_0_4_0 + 8.333333333333309e-03*G4_1_1_4_0_4_1 + 8.333333333333309e-03*G4_1_1_4_0_4_2 + 4.166666666666654e-03*G4_1_1_4_0_5_0 + 4.166666666666654e-03*G4_1_1_4_0_5_1 + 4.166666666666654e-03*G4_1_1_4_0_5_2 + 4.166666666666653e-03*G4_1_1_4_0_6_0 + 4.166666666666654e-03*G4_1_1_4_0_6_1 + 4.166666666666654e-03*G4_1_1_4_0_6_2 + 4.166666666666654e-03*G4_1_1_4_0_7_0 + 4.166666666666656e-03*G4_1_1_4_0_7_1 + 4.166666666666654e-03*G4_1_1_4_0_7_2 + 8.333333333333309e-03*G4_1_1_4_1_4_0 + 8.333333333333311e-03*G4_1_1_4_1_4_1 + 8.333333333333311e-03*G4_1_1_4_1_4_2 + 4.166666666666654e-03*G4_1_1_4_1_5_0 + 4.166666666666654e-03*G4_1_1_4_1_5_1 + 4.166666666666654e-03*G4_1_1_4_1_5_2 + 4.166666666666654e-03*G4_1_1_4_1_6_0 + 4.166666666666654e-03*G4_1_1_4_1_6_1 + 4.166666666666654e-03*G4_1_1_4_1_6_2 + 4.166666666666656e-03*G4_1_1_4_1_7_0 + 4.166666666666657e-03*G4_1_1_4_1_7_1 + 4.166666666666657e-03*G4_1_1_4_1_7_2 + 8.333333333333309e-03*G4_1_1_4_2_4_0 + 8.333333333333311e-03*G4_1_1_4_2_4_1 + 8.333333333333311e-03*G4_1_1_4_2_4_2 + 4.166666666666654e-03*G4_1_1_4_2_5_0 + 4.166666666666654e-03*G4_1_1_4_2_5_1 + 4.166666666666654e-03*G4_1_1_4_2_5_2 + 4.166666666666654e-03*G4_1_1_4_2_6_0 + 4.166666666666654e-03*G4_1_1_4_2_6_1 + 4.166666666666654e-03*G4_1_1_4_2_6_2 + 4.166666666666654e-03*G4_1_1_4_2_7_0 + 4.166666666666657e-03*G4_1_1_4_2_7_1 + 4.166666666666656e-03*G4_1_1_4_2_7_2 + 4.166666666666654e-03*G4_1_1_5_0_4_0 + 4.166666666666654e-03*G4_1_1_5_0_4_1 + 4.166666666666654e-03*G4_1_1_5_0_4_2 + 8.333333333333307e-03*G4_1_1_5_0_5_0 + 8.333333333333309e-03*G4_1_1_5_0_5_1 + 8.333333333333307e-03*G4_1_1_5_0_5_2 + 4.166666666666654e-03*G4_1_1_5_0_6_0 + 4.166666666666655e-03*G4_1_1_5_0_6_1 + 4.166666666666654e-03*G4_1_1_5_0_6_2 + 4.166666666666655e-03*G4_1_1_5_0_7_0 + 4.166666666666656e-03*G4_1_1_5_0_7_1 + 4.166666666666656e-03*G4_1_1_5_0_7_2 + 4.166666666666654e-03*G4_1_1_5_1_4_0 + 4.166666666666654e-03*G4_1_1_5_1_4_1 + 4.166666666666654e-03*G4_1_1_5_1_4_2 + 8.333333333333309e-03*G4_1_1_5_1_5_0 + 8.333333333333309e-03*G4_1_1_5_1_5_1 + 8.333333333333307e-03*G4_1_1_5_1_5_2 + 4.166666666666655e-03*G4_1_1_5_1_6_0 + 4.166666666666656e-03*G4_1_1_5_1_6_1 + 4.166666666666654e-03*G4_1_1_5_1_6_2 + 4.166666666666656e-03*G4_1_1_5_1_7_0 + 4.166666666666657e-03*G4_1_1_5_1_7_1 + 4.166666666666656e-03*G4_1_1_5_1_7_2 + 4.166666666666654e-03*G4_1_1_5_2_4_0 + 4.166666666666654e-03*G4_1_1_5_2_4_1 + 4.166666666666654e-03*G4_1_1_5_2_4_2 + 8.333333333333307e-03*G4_1_1_5_2_5_0 + 8.333333333333309e-03*G4_1_1_5_2_5_1 + 8.333333333333307e-03*G4_1_1_5_2_5_2 + 4.166666666666654e-03*G4_1_1_5_2_6_0 + 4.166666666666655e-03*G4_1_1_5_2_6_1 + 4.166666666666654e-03*G4_1_1_5_2_6_2 + 4.166666666666656e-03*G4_1_1_5_2_7_0 + 4.166666666666656e-03*G4_1_1_5_2_7_1 + 4.166666666666656e-03*G4_1_1_5_2_7_2 + 4.166666666666653e-03*G4_1_1_6_0_4_0 + 4.166666666666654e-03*G4_1_1_6_0_4_1 + 4.166666666666653e-03*G4_1_1_6_0_4_2 + 4.166666666666654e-03*G4_1_1_6_0_5_0 + 4.166666666666655e-03*G4_1_1_6_0_5_1 + 4.166666666666654e-03*G4_1_1_6_0_5_2 + 8.333333333333309e-03*G4_1_1_6_0_6_0 + 8.333333333333309e-03*G4_1_1_6_0_6_1 + 8.333333333333309e-03*G4_1_1_6_0_6_2 + 4.166666666666654e-03*G4_1_1_6_0_7_0 + 4.166666666666655e-03*G4_1_1_6_0_7_1 + 4.166666666666654e-03*G4_1_1_6_0_7_2 + 4.166666666666654e-03*G4_1_1_6_1_4_0 + 4.166666666666654e-03*G4_1_1_6_1_4_1 + 4.166666666666654e-03*G4_1_1_6_1_4_2 + 4.166666666666655e-03*G4_1_1_6_1_5_0 + 4.166666666666656e-03*G4_1_1_6_1_5_1 + 4.166666666666654e-03*G4_1_1_6_1_5_2 + 8.333333333333311e-03*G4_1_1_6_1_6_0 + 8.333333333333311e-03*G4_1_1_6_1_6_1 + 8.333333333333311e-03*G4_1_1_6_1_6_2 + 4.166666666666655e-03*G4_1_1_6_1_7_0 + 4.166666666666656e-03*G4_1_1_6_1_7_1 + 4.166666666666655e-03*G4_1_1_6_1_7_2 + 4.166666666666653e-03*G4_1_1_6_2_4_0 + 4.166666666666654e-03*G4_1_1_6_2_4_1 + 4.166666666666654e-03*G4_1_1_6_2_4_2 + 4.166666666666654e-03*G4_1_1_6_2_5_0 + 4.166666666666654e-03*G4_1_1_6_2_5_1 + 4.166666666666654e-03*G4_1_1_6_2_5_2 + 8.333333333333309e-03*G4_1_1_6_2_6_0 + 8.333333333333309e-03*G4_1_1_6_2_6_1 + 8.333333333333309e-03*G4_1_1_6_2_6_2 + 4.166666666666654e-03*G4_1_1_6_2_7_0 + 4.166666666666655e-03*G4_1_1_6_2_7_1 + 4.166666666666654e-03*G4_1_1_6_2_7_2 + 4.166666666666655e-03*G4_1_1_7_0_4_0 + 4.166666666666656e-03*G4_1_1_7_0_4_1 + 4.166666666666655e-03*G4_1_1_7_0_4_2 + 4.166666666666655e-03*G4_1_1_7_0_5_0 + 4.166666666666656e-03*G4_1_1_7_0_5_1 + 4.166666666666656e-03*G4_1_1_7_0_5_2 + 4.166666666666655e-03*G4_1_1_7_0_6_0 + 4.166666666666655e-03*G4_1_1_7_0_6_1 + 4.166666666666654e-03*G4_1_1_7_0_6_2 + 8.333333333333309e-03*G4_1_1_7_0_7_0 + 8.333333333333311e-03*G4_1_1_7_0_7_1 + 8.333333333333309e-03*G4_1_1_7_0_7_2 + 4.166666666666656e-03*G4_1_1_7_1_4_0 + 4.166666666666657e-03*G4_1_1_7_1_4_1 + 4.166666666666657e-03*G4_1_1_7_1_4_2 + 4.166666666666656e-03*G4_1_1_7_1_5_0 + 4.166666666666657e-03*G4_1_1_7_1_5_1 + 4.166666666666656e-03*G4_1_1_7_1_5_2 + 4.166666666666655e-03*G4_1_1_7_1_6_0 + 4.166666666666656e-03*G4_1_1_7_1_6_1 + 4.166666666666655e-03*G4_1_1_7_1_6_2 + 8.333333333333311e-03*G4_1_1_7_1_7_0 + 8.333333333333311e-03*G4_1_1_7_1_7_1 + 8.333333333333311e-03*G4_1_1_7_1_7_2 + 4.166666666666655e-03*G4_1_1_7_2_4_0 + 4.166666666666657e-03*G4_1_1_7_2_4_1 + 4.166666666666656e-03*G4_1_1_7_2_4_2 + 4.166666666666656e-03*G4_1_1_7_2_5_0 + 4.166666666666656e-03*G4_1_1_7_2_5_1 + 4.166666666666656e-03*G4_1_1_7_2_5_2 + 4.166666666666655e-03*G4_1_1_7_2_6_0 + 4.166666666666655e-03*G4_1_1_7_2_6_1 + 4.166666666666654e-03*G4_1_1_7_2_6_2 + 8.333333333333309e-03*G4_1_1_7_2_7_0 + 8.333333333333311e-03*G4_1_1_7_2_7_1 + 8.333333333333309e-03*G4_1_1_7_2_7_2 + 8.333333333333309e-03*G4_1_2_4_0_8_0 + 8.333333333333309e-03*G4_1_2_4_0_8_1 + 8.333333333333309e-03*G4_1_2_4_0_8_2 + 4.166666666666654e-03*G4_1_2_4_0_9_0 + 4.166666666666654e-03*G4_1_2_4_0_9_1 + 4.166666666666654e-03*G4_1_2_4_0_9_2 + 4.166666666666653e-03*G4_1_2_4_0_10_0 + 4.166666666666654e-03*G4_1_2_4_0_10_1 + 4.166666666666654e-03*G4_1_2_4_0_10_2 + 4.166666666666654e-03*G4_1_2_4_0_11_0 + 4.166666666666656e-03*G4_1_2_4_0_11_1 + 4.166666666666654e-03*G4_1_2_4_0_11_2 + 8.333333333333309e-03*G4_1_2_4_1_8_0 + 8.333333333333311e-03*G4_1_2_4_1_8_1 + 8.333333333333311e-03*G4_1_2_4_1_8_2 + 4.166666666666654e-03*G4_1_2_4_1_9_0 + 4.166666666666654e-03*G4_1_2_4_1_9_1 + 4.166666666666654e-03*G4_1_2_4_1_9_2 + 4.166666666666654e-03*G4_1_2_4_1_10_0 + 4.166666666666654e-03*G4_1_2_4_1_10_1 + 4.166666666666654e-03*G4_1_2_4_1_10_2 + 4.166666666666656e-03*G4_1_2_4_1_11_0 + 4.166666666666657e-03*G4_1_2_4_1_11_1 + 4.166666666666657e-03*G4_1_2_4_1_11_2 + 8.333333333333309e-03*G4_1_2_4_2_8_0 + 8.333333333333311e-03*G4_1_2_4_2_8_1 + 8.333333333333311e-03*G4_1_2_4_2_8_2 + 4.166666666666654e-03*G4_1_2_4_2_9_0 + 4.166666666666654e-03*G4_1_2_4_2_9_1 + 4.166666666666654e-03*G4_1_2_4_2_9_2 + 4.166666666666654e-03*G4_1_2_4_2_10_0 + 4.166666666666654e-03*G4_1_2_4_2_10_1 + 4.166666666666654e-03*G4_1_2_4_2_10_2 + 4.166666666666654e-03*G4_1_2_4_2_11_0 + 4.166666666666657e-03*G4_1_2_4_2_11_1 + 4.166666666666656e-03*G4_1_2_4_2_11_2 + 4.166666666666654e-03*G4_1_2_5_0_8_0 + 4.166666666666654e-03*G4_1_2_5_0_8_1 + 4.166666666666654e-03*G4_1_2_5_0_8_2 + 8.333333333333307e-03*G4_1_2_5_0_9_0 + 8.333333333333309e-03*G4_1_2_5_0_9_1 + 8.333333333333307e-03*G4_1_2_5_0_9_2 + 4.166666666666654e-03*G4_1_2_5_0_10_0 + 4.166666666666655e-03*G4_1_2_5_0_10_1 + 4.166666666666654e-03*G4_1_2_5_0_10_2 + 4.166666666666655e-03*G4_1_2_5_0_11_0 + 4.166666666666656e-03*G4_1_2_5_0_11_1 + 4.166666666666656e-03*G4_1_2_5_0_11_2 + 4.166666666666654e-03*G4_1_2_5_1_8_0 + 4.166666666666654e-03*G4_1_2_5_1_8_1 + 4.166666666666654e-03*G4_1_2_5_1_8_2 + 8.333333333333309e-03*G4_1_2_5_1_9_0 + 8.333333333333309e-03*G4_1_2_5_1_9_1 + 8.333333333333307e-03*G4_1_2_5_1_9_2 + 4.166666666666655e-03*G4_1_2_5_1_10_0 + 4.166666666666656e-03*G4_1_2_5_1_10_1 + 4.166666666666654e-03*G4_1_2_5_1_10_2 + 4.166666666666656e-03*G4_1_2_5_1_11_0 + 4.166666666666657e-03*G4_1_2_5_1_11_1 + 4.166666666666656e-03*G4_1_2_5_1_11_2 + 4.166666666666654e-03*G4_1_2_5_2_8_0 + 4.166666666666654e-03*G4_1_2_5_2_8_1 + 4.166666666666654e-03*G4_1_2_5_2_8_2 + 8.333333333333307e-03*G4_1_2_5_2_9_0 + 8.333333333333309e-03*G4_1_2_5_2_9_1 + 8.333333333333307e-03*G4_1_2_5_2_9_2 + 4.166666666666654e-03*G4_1_2_5_2_10_0 + 4.166666666666655e-03*G4_1_2_5_2_10_1 + 4.166666666666654e-03*G4_1_2_5_2_10_2 + 4.166666666666656e-03*G4_1_2_5_2_11_0 + 4.166666666666656e-03*G4_1_2_5_2_11_1 + 4.166666666666656e-03*G4_1_2_5_2_11_2 + 4.166666666666653e-03*G4_1_2_6_0_8_0 + 4.166666666666654e-03*G4_1_2_6_0_8_1 + 4.166666666666653e-03*G4_1_2_6_0_8_2 + 4.166666666666654e-03*G4_1_2_6_0_9_0 + 4.166666666666655e-03*G4_1_2_6_0_9_1 + 4.166666666666654e-03*G4_1_2_6_0_9_2 + 8.333333333333309e-03*G4_1_2_6_0_10_0 + 8.333333333333309e-03*G4_1_2_6_0_10_1 + 8.333333333333309e-03*G4_1_2_6_0_10_2 + 4.166666666666654e-03*G4_1_2_6_0_11_0 + 4.166666666666655e-03*G4_1_2_6_0_11_1 + 4.166666666666654e-03*G4_1_2_6_0_11_2 + 4.166666666666654e-03*G4_1_2_6_1_8_0 + 4.166666666666654e-03*G4_1_2_6_1_8_1 + 4.166666666666654e-03*G4_1_2_6_1_8_2 + 4.166666666666655e-03*G4_1_2_6_1_9_0 + 4.166666666666656e-03*G4_1_2_6_1_9_1 + 4.166666666666654e-03*G4_1_2_6_1_9_2 + 8.333333333333311e-03*G4_1_2_6_1_10_0 + 8.333333333333311e-03*G4_1_2_6_1_10_1 + 8.333333333333311e-03*G4_1_2_6_1_10_2 + 4.166666666666655e-03*G4_1_2_6_1_11_0 + 4.166666666666656e-03*G4_1_2_6_1_11_1 + 4.166666666666655e-03*G4_1_2_6_1_11_2 + 4.166666666666653e-03*G4_1_2_6_2_8_0 + 4.166666666666654e-03*G4_1_2_6_2_8_1 + 4.166666666666654e-03*G4_1_2_6_2_8_2 + 4.166666666666654e-03*G4_1_2_6_2_9_0 + 4.166666666666654e-03*G4_1_2_6_2_9_1 + 4.166666666666654e-03*G4_1_2_6_2_9_2 + 8.333333333333309e-03*G4_1_2_6_2_10_0 + 8.333333333333309e-03*G4_1_2_6_2_10_1 + 8.333333333333309e-03*G4_1_2_6_2_10_2 + 4.166666666666654e-03*G4_1_2_6_2_11_0 + 4.166666666666655e-03*G4_1_2_6_2_11_1 + 4.166666666666654e-03*G4_1_2_6_2_11_2 + 4.166666666666655e-03*G4_1_2_7_0_8_0 + 4.166666666666656e-03*G4_1_2_7_0_8_1 + 4.166666666666655e-03*G4_1_2_7_0_8_2 + 4.166666666666655e-03*G4_1_2_7_0_9_0 + 4.166666666666656e-03*G4_1_2_7_0_9_1 + 4.166666666666656e-03*G4_1_2_7_0_9_2 + 4.166666666666655e-03*G4_1_2_7_0_10_0 + 4.166666666666655e-03*G4_1_2_7_0_10_1 + 4.166666666666654e-03*G4_1_2_7_0_10_2 + 8.333333333333309e-03*G4_1_2_7_0_11_0 + 8.333333333333311e-03*G4_1_2_7_0_11_1 + 8.333333333333309e-03*G4_1_2_7_0_11_2 + 4.166666666666656e-03*G4_1_2_7_1_8_0 + 4.166666666666657e-03*G4_1_2_7_1_8_1 + 4.166666666666657e-03*G4_1_2_7_1_8_2 + 4.166666666666656e-03*G4_1_2_7_1_9_0 + 4.166666666666657e-03*G4_1_2_7_1_9_1 + 4.166666666666656e-03*G4_1_2_7_1_9_2 + 4.166666666666655e-03*G4_1_2_7_1_10_0 + 4.166666666666656e-03*G4_1_2_7_1_10_1 + 4.166666666666655e-03*G4_1_2_7_1_10_2 + 8.333333333333311e-03*G4_1_2_7_1_11_0 + 8.333333333333311e-03*G4_1_2_7_1_11_1 + 8.333333333333311e-03*G4_1_2_7_1_11_2 + 4.166666666666655e-03*G4_1_2_7_2_8_0 + 4.166666666666657e-03*G4_1_2_7_2_8_1 + 4.166666666666656e-03*G4_1_2_7_2_8_2 + 4.166666666666656e-03*G4_1_2_7_2_9_0 + 4.166666666666656e-03*G4_1_2_7_2_9_1 + 4.166666666666656e-03*G4_1_2_7_2_9_2 + 4.166666666666655e-03*G4_1_2_7_2_10_0 + 4.166666666666655e-03*G4_1_2_7_2_10_1 + 4.166666666666654e-03*G4_1_2_7_2_10_2 + 8.333333333333309e-03*G4_1_2_7_2_11_0 + 8.333333333333311e-03*G4_1_2_7_2_11_1 + 8.333333333333309e-03*G4_1_2_7_2_11_2 + 8.333333333333309e-03*G4_2_0_8_0_0_0 + 8.333333333333309e-03*G4_2_0_8_0_0_1 + 8.333333333333309e-03*G4_2_0_8_0_0_2 + 4.166666666666654e-03*G4_2_0_8_0_1_0 + 4.166666666666654e-03*G4_2_0_8_0_1_1 + 4.166666666666653e-03*G4_2_0_8_0_1_2 + 4.166666666666653e-03*G4_2_0_8_0_2_0 + 4.166666666666654e-03*G4_2_0_8_0_2_1 + 4.166666666666654e-03*G4_2_0_8_0_2_2 + 4.166666666666654e-03*G4_2_0_8_0_3_0 + 4.166666666666656e-03*G4_2_0_8_0_3_1 + 4.166666666666654e-03*G4_2_0_8_0_3_2 + 8.333333333333309e-03*G4_2_0_8_1_0_0 + 8.333333333333311e-03*G4_2_0_8_1_0_1 + 8.333333333333311e-03*G4_2_0_8_1_0_2 + 4.166666666666654e-03*G4_2_0_8_1_1_0 + 4.166666666666654e-03*G4_2_0_8_1_1_1 + 4.166666666666654e-03*G4_2_0_8_1_1_2 + 4.166666666666654e-03*G4_2_0_8_1_2_0 + 4.166666666666654e-03*G4_2_0_8_1_2_1 + 4.166666666666654e-03*G4_2_0_8_1_2_2 + 4.166666666666656e-03*G4_2_0_8_1_3_0 + 4.166666666666657e-03*G4_2_0_8_1_3_1 + 4.166666666666657e-03*G4_2_0_8_1_3_2 + 8.333333333333309e-03*G4_2_0_8_2_0_0 + 8.333333333333311e-03*G4_2_0_8_2_0_1 + 8.333333333333311e-03*G4_2_0_8_2_0_2 + 4.166666666666654e-03*G4_2_0_8_2_1_0 + 4.166666666666654e-03*G4_2_0_8_2_1_1 + 4.166666666666654e-03*G4_2_0_8_2_1_2 + 4.166666666666654e-03*G4_2_0_8_2_2_0 + 4.166666666666654e-03*G4_2_0_8_2_2_1 + 4.166666666666654e-03*G4_2_0_8_2_2_2 + 4.166666666666654e-03*G4_2_0_8_2_3_0 + 4.166666666666657e-03*G4_2_0_8_2_3_1 + 4.166666666666656e-03*G4_2_0_8_2_3_2 + 4.166666666666654e-03*G4_2_0_9_0_0_0 + 4.166666666666655e-03*G4_2_0_9_0_0_1 + 4.166666666666654e-03*G4_2_0_9_0_0_2 + 8.333333333333307e-03*G4_2_0_9_0_1_0 + 8.333333333333309e-03*G4_2_0_9_0_1_1 + 8.333333333333307e-03*G4_2_0_9_0_1_2 + 4.166666666666654e-03*G4_2_0_9_0_2_0 + 4.166666666666655e-03*G4_2_0_9_0_2_1 + 4.166666666666654e-03*G4_2_0_9_0_2_2 + 4.166666666666655e-03*G4_2_0_9_0_3_0 + 4.166666666666656e-03*G4_2_0_9_0_3_1 + 4.166666666666656e-03*G4_2_0_9_0_3_2 + 4.166666666666655e-03*G4_2_0_9_1_0_0 + 4.166666666666655e-03*G4_2_0_9_1_0_1 + 4.166666666666655e-03*G4_2_0_9_1_0_2 + 8.333333333333309e-03*G4_2_0_9_1_1_0 + 8.333333333333309e-03*G4_2_0_9_1_1_1 + 8.333333333333307e-03*G4_2_0_9_1_1_2 + 4.166666666666655e-03*G4_2_0_9_1_2_0 + 4.166666666666656e-03*G4_2_0_9_1_2_1 + 4.166666666666654e-03*G4_2_0_9_1_2_2 + 4.166666666666656e-03*G4_2_0_9_1_3_0 + 4.166666666666657e-03*G4_2_0_9_1_3_1 + 4.166666666666656e-03*G4_2_0_9_1_3_2 + 4.166666666666655e-03*G4_2_0_9_2_0_0 + 4.166666666666655e-03*G4_2_0_9_2_0_1 + 4.166666666666654e-03*G4_2_0_9_2_0_2 + 8.333333333333307e-03*G4_2_0_9_2_1_0 + 8.333333333333309e-03*G4_2_0_9_2_1_1 + 8.333333333333307e-03*G4_2_0_9_2_1_2 + 4.166666666666654e-03*G4_2_0_9_2_2_0 + 4.166666666666655e-03*G4_2_0_9_2_2_1 + 4.166666666666654e-03*G4_2_0_9_2_2_2 + 4.166666666666656e-03*G4_2_0_9_2_3_0 + 4.166666666666656e-03*G4_2_0_9_2_3_1 + 4.166666666666656e-03*G4_2_0_9_2_3_2 + 4.166666666666654e-03*G4_2_0_10_0_0_0 + 4.166666666666654e-03*G4_2_0_10_0_0_1 + 4.166666666666654e-03*G4_2_0_10_0_0_2 + 4.166666666666654e-03*G4_2_0_10_0_1_0 + 4.166666666666654e-03*G4_2_0_10_0_1_1 + 4.166666666666653e-03*G4_2_0_10_0_1_2 + 8.333333333333309e-03*G4_2_0_10_0_2_0 + 8.333333333333309e-03*G4_2_0_10_0_2_1 + 8.333333333333309e-03*G4_2_0_10_0_2_2 + 4.166666666666654e-03*G4_2_0_10_0_3_0 + 4.166666666666655e-03*G4_2_0_10_0_3_1 + 4.166666666666654e-03*G4_2_0_10_0_3_2 + 4.166666666666654e-03*G4_2_0_10_1_0_0 + 4.166666666666656e-03*G4_2_0_10_1_0_1 + 4.166666666666655e-03*G4_2_0_10_1_0_2 + 4.166666666666654e-03*G4_2_0_10_1_1_0 + 4.166666666666654e-03*G4_2_0_10_1_1_1 + 4.166666666666654e-03*G4_2_0_10_1_1_2 + 8.333333333333311e-03*G4_2_0_10_1_2_0 + 8.333333333333311e-03*G4_2_0_10_1_2_1 + 8.333333333333311e-03*G4_2_0_10_1_2_2 + 4.166666666666655e-03*G4_2_0_10_1_3_0 + 4.166666666666656e-03*G4_2_0_10_1_3_1 + 4.166666666666655e-03*G4_2_0_10_1_3_2 + 4.166666666666654e-03*G4_2_0_10_2_0_0 + 4.166666666666655e-03*G4_2_0_10_2_0_1 + 4.166666666666654e-03*G4_2_0_10_2_0_2 + 4.166666666666654e-03*G4_2_0_10_2_1_0 + 4.166666666666654e-03*G4_2_0_10_2_1_1 + 4.166666666666653e-03*G4_2_0_10_2_1_2 + 8.333333333333309e-03*G4_2_0_10_2_2_0 + 8.333333333333309e-03*G4_2_0_10_2_2_1 + 8.333333333333309e-03*G4_2_0_10_2_2_2 + 4.166666666666654e-03*G4_2_0_10_2_3_0 + 4.166666666666655e-03*G4_2_0_10_2_3_1 + 4.166666666666654e-03*G4_2_0_10_2_3_2 + 4.166666666666656e-03*G4_2_0_11_0_0_0 + 4.166666666666656e-03*G4_2_0_11_0_0_1 + 4.166666666666656e-03*G4_2_0_11_0_0_2 + 4.166666666666654e-03*G4_2_0_11_0_1_0 + 4.166666666666655e-03*G4_2_0_11_0_1_1 + 4.166666666666654e-03*G4_2_0_11_0_1_2 + 4.166666666666655e-03*G4_2_0_11_0_2_0 + 4.166666666666655e-03*G4_2_0_11_0_2_1 + 4.166666666666654e-03*G4_2_0_11_0_2_2 + 8.333333333333309e-03*G4_2_0_11_0_3_0 + 8.333333333333311e-03*G4_2_0_11_0_3_1 + 8.333333333333309e-03*G4_2_0_11_0_3_2 + 4.166666666666656e-03*G4_2_0_11_1_0_0 + 4.166666666666657e-03*G4_2_0_11_1_0_1 + 4.166666666666657e-03*G4_2_0_11_1_0_2 + 4.166666666666655e-03*G4_2_0_11_1_1_0 + 4.166666666666655e-03*G4_2_0_11_1_1_1 + 4.166666666666655e-03*G4_2_0_11_1_1_2 + 4.166666666666655e-03*G4_2_0_11_1_2_0 + 4.166666666666656e-03*G4_2_0_11_1_2_1 + 4.166666666666655e-03*G4_2_0_11_1_2_2 + 8.333333333333311e-03*G4_2_0_11_1_3_0 + 8.333333333333311e-03*G4_2_0_11_1_3_1 + 8.333333333333311e-03*G4_2_0_11_1_3_2 + 4.166666666666656e-03*G4_2_0_11_2_0_0 + 4.166666666666657e-03*G4_2_0_11_2_0_1 + 4.166666666666657e-03*G4_2_0_11_2_0_2 + 4.166666666666655e-03*G4_2_0_11_2_1_0 + 4.166666666666655e-03*G4_2_0_11_2_1_1 + 4.166666666666655e-03*G4_2_0_11_2_1_2 + 4.166666666666655e-03*G4_2_0_11_2_2_0 + 4.166666666666655e-03*G4_2_0_11_2_2_1 + 4.166666666666654e-03*G4_2_0_11_2_2_2 + 8.333333333333309e-03*G4_2_0_11_2_3_0 + 8.333333333333311e-03*G4_2_0_11_2_3_1 + 8.333333333333309e-03*G4_2_0_11_2_3_2 + 8.333333333333309e-03*G4_2_1_8_0_4_0 + 8.333333333333309e-03*G4_2_1_8_0_4_1 + 8.333333333333309e-03*G4_2_1_8_0_4_2 + 4.166666666666654e-03*G4_2_1_8_0_5_0 + 4.166666666666654e-03*G4_2_1_8_0_5_1 + 4.166666666666654e-03*G4_2_1_8_0_5_2 + 4.166666666666653e-03*G4_2_1_8_0_6_0 + 4.166666666666654e-03*G4_2_1_8_0_6_1 + 4.166666666666654e-03*G4_2_1_8_0_6_2 + 4.166666666666654e-03*G4_2_1_8_0_7_0 + 4.166666666666656e-03*G4_2_1_8_0_7_1 + 4.166666666666654e-03*G4_2_1_8_0_7_2 + 8.333333333333309e-03*G4_2_1_8_1_4_0 + 8.333333333333311e-03*G4_2_1_8_1_4_1 + 8.333333333333311e-03*G4_2_1_8_1_4_2 + 4.166666666666654e-03*G4_2_1_8_1_5_0 + 4.166666666666654e-03*G4_2_1_8_1_5_1 + 4.166666666666654e-03*G4_2_1_8_1_5_2 + 4.166666666666654e-03*G4_2_1_8_1_6_0 + 4.166666666666654e-03*G4_2_1_8_1_6_1 + 4.166666666666654e-03*G4_2_1_8_1_6_2 + 4.166666666666656e-03*G4_2_1_8_1_7_0 + 4.166666666666657e-03*G4_2_1_8_1_7_1 + 4.166666666666657e-03*G4_2_1_8_1_7_2 + 8.333333333333309e-03*G4_2_1_8_2_4_0 + 8.333333333333311e-03*G4_2_1_8_2_4_1 + 8.333333333333311e-03*G4_2_1_8_2_4_2 + 4.166666666666654e-03*G4_2_1_8_2_5_0 + 4.166666666666654e-03*G4_2_1_8_2_5_1 + 4.166666666666654e-03*G4_2_1_8_2_5_2 + 4.166666666666654e-03*G4_2_1_8_2_6_0 + 4.166666666666654e-03*G4_2_1_8_2_6_1 + 4.166666666666654e-03*G4_2_1_8_2_6_2 + 4.166666666666654e-03*G4_2_1_8_2_7_0 + 4.166666666666657e-03*G4_2_1_8_2_7_1 + 4.166666666666656e-03*G4_2_1_8_2_7_2 + 4.166666666666654e-03*G4_2_1_9_0_4_0 + 4.166666666666654e-03*G4_2_1_9_0_4_1 + 4.166666666666654e-03*G4_2_1_9_0_4_2 + 8.333333333333307e-03*G4_2_1_9_0_5_0 + 8.333333333333309e-03*G4_2_1_9_0_5_1 + 8.333333333333307e-03*G4_2_1_9_0_5_2 + 4.166666666666654e-03*G4_2_1_9_0_6_0 + 4.166666666666655e-03*G4_2_1_9_0_6_1 + 4.166666666666654e-03*G4_2_1_9_0_6_2 + 4.166666666666655e-03*G4_2_1_9_0_7_0 + 4.166666666666656e-03*G4_2_1_9_0_7_1 + 4.166666666666656e-03*G4_2_1_9_0_7_2 + 4.166666666666654e-03*G4_2_1_9_1_4_0 + 4.166666666666654e-03*G4_2_1_9_1_4_1 + 4.166666666666654e-03*G4_2_1_9_1_4_2 + 8.333333333333309e-03*G4_2_1_9_1_5_0 + 8.333333333333309e-03*G4_2_1_9_1_5_1 + 8.333333333333307e-03*G4_2_1_9_1_5_2 + 4.166666666666655e-03*G4_2_1_9_1_6_0 + 4.166666666666656e-03*G4_2_1_9_1_6_1 + 4.166666666666654e-03*G4_2_1_9_1_6_2 + 4.166666666666656e-03*G4_2_1_9_1_7_0 + 4.166666666666657e-03*G4_2_1_9_1_7_1 + 4.166666666666656e-03*G4_2_1_9_1_7_2 + 4.166666666666654e-03*G4_2_1_9_2_4_0 + 4.166666666666654e-03*G4_2_1_9_2_4_1 + 4.166666666666654e-03*G4_2_1_9_2_4_2 + 8.333333333333307e-03*G4_2_1_9_2_5_0 + 8.333333333333309e-03*G4_2_1_9_2_5_1 + 8.333333333333307e-03*G4_2_1_9_2_5_2 + 4.166666666666654e-03*G4_2_1_9_2_6_0 + 4.166666666666655e-03*G4_2_1_9_2_6_1 + 4.166666666666654e-03*G4_2_1_9_2_6_2 + 4.166666666666656e-03*G4_2_1_9_2_7_0 + 4.166666666666656e-03*G4_2_1_9_2_7_1 + 4.166666666666656e-03*G4_2_1_9_2_7_2 + 4.166666666666653e-03*G4_2_1_10_0_4_0 + 4.166666666666654e-03*G4_2_1_10_0_4_1 + 4.166666666666653e-03*G4_2_1_10_0_4_2 + 4.166666666666654e-03*G4_2_1_10_0_5_0 + 4.166666666666655e-03*G4_2_1_10_0_5_1 + 4.166666666666654e-03*G4_2_1_10_0_5_2 + 8.333333333333309e-03*G4_2_1_10_0_6_0 + 8.333333333333309e-03*G4_2_1_10_0_6_1 + 8.333333333333309e-03*G4_2_1_10_0_6_2 + 4.166666666666654e-03*G4_2_1_10_0_7_0 + 4.166666666666655e-03*G4_2_1_10_0_7_1 + 4.166666666666654e-03*G4_2_1_10_0_7_2 + 4.166666666666654e-03*G4_2_1_10_1_4_0 + 4.166666666666654e-03*G4_2_1_10_1_4_1 + 4.166666666666654e-03*G4_2_1_10_1_4_2 + 4.166666666666655e-03*G4_2_1_10_1_5_0 + 4.166666666666656e-03*G4_2_1_10_1_5_1 + 4.166666666666654e-03*G4_2_1_10_1_5_2 + 8.333333333333311e-03*G4_2_1_10_1_6_0 + 8.333333333333311e-03*G4_2_1_10_1_6_1 + 8.333333333333311e-03*G4_2_1_10_1_6_2 + 4.166666666666655e-03*G4_2_1_10_1_7_0 + 4.166666666666656e-03*G4_2_1_10_1_7_1 + 4.166666666666655e-03*G4_2_1_10_1_7_2 + 4.166666666666653e-03*G4_2_1_10_2_4_0 + 4.166666666666654e-03*G4_2_1_10_2_4_1 + 4.166666666666654e-03*G4_2_1_10_2_4_2 + 4.166666666666654e-03*G4_2_1_10_2_5_0 + 4.166666666666654e-03*G4_2_1_10_2_5_1 + 4.166666666666654e-03*G4_2_1_10_2_5_2 + 8.333333333333309e-03*G4_2_1_10_2_6_0 + 8.333333333333309e-03*G4_2_1_10_2_6_1 + 8.333333333333309e-03*G4_2_1_10_2_6_2 + 4.166666666666654e-03*G4_2_1_10_2_7_0 + 4.166666666666655e-03*G4_2_1_10_2_7_1 + 4.166666666666654e-03*G4_2_1_10_2_7_2 + 4.166666666666655e-03*G4_2_1_11_0_4_0 + 4.166666666666656e-03*G4_2_1_11_0_4_1 + 4.166666666666655e-03*G4_2_1_11_0_4_2 + 4.166666666666655e-03*G4_2_1_11_0_5_0 + 4.166666666666656e-03*G4_2_1_11_0_5_1 + 4.166666666666656e-03*G4_2_1_11_0_5_2 + 4.166666666666655e-03*G4_2_1_11_0_6_0 + 4.166666666666655e-03*G4_2_1_11_0_6_1 + 4.166666666666654e-03*G4_2_1_11_0_6_2 + 8.333333333333309e-03*G4_2_1_11_0_7_0 + 8.333333333333311e-03*G4_2_1_11_0_7_1 + 8.333333333333309e-03*G4_2_1_11_0_7_2 + 4.166666666666656e-03*G4_2_1_11_1_4_0 + 4.166666666666657e-03*G4_2_1_11_1_4_1 + 4.166666666666657e-03*G4_2_1_11_1_4_2 + 4.166666666666656e-03*G4_2_1_11_1_5_0 + 4.166666666666657e-03*G4_2_1_11_1_5_1 + 4.166666666666656e-03*G4_2_1_11_1_5_2 + 4.166666666666655e-03*G4_2_1_11_1_6_0 + 4.166666666666656e-03*G4_2_1_11_1_6_1 + 4.166666666666655e-03*G4_2_1_11_1_6_2 + 8.333333333333311e-03*G4_2_1_11_1_7_0 + 8.333333333333311e-03*G4_2_1_11_1_7_1 + 8.333333333333311e-03*G4_2_1_11_1_7_2 + 4.166666666666655e-03*G4_2_1_11_2_4_0 + 4.166666666666657e-03*G4_2_1_11_2_4_1 + 4.166666666666656e-03*G4_2_1_11_2_4_2 + 4.166666666666656e-03*G4_2_1_11_2_5_0 + 4.166666666666656e-03*G4_2_1_11_2_5_1 + 4.166666666666656e-03*G4_2_1_11_2_5_2 + 4.166666666666655e-03*G4_2_1_11_2_6_0 + 4.166666666666655e-03*G4_2_1_11_2_6_1 + 4.166666666666654e-03*G4_2_1_11_2_6_2 + 8.333333333333309e-03*G4_2_1_11_2_7_0 + 8.333333333333311e-03*G4_2_1_11_2_7_1 + 8.333333333333309e-03*G4_2_1_11_2_7_2 + 8.333333333333309e-03*G4_2_2_8_0_8_0 + 8.333333333333309e-03*G4_2_2_8_0_8_1 + 8.333333333333309e-03*G4_2_2_8_0_8_2 + 4.166666666666654e-03*G4_2_2_8_0_9_0 + 4.166666666666654e-03*G4_2_2_8_0_9_1 + 4.166666666666654e-03*G4_2_2_8_0_9_2 + 4.166666666666653e-03*G4_2_2_8_0_10_0 + 4.166666666666654e-03*G4_2_2_8_0_10_1 + 4.166666666666654e-03*G4_2_2_8_0_10_2 + 4.166666666666654e-03*G4_2_2_8_0_11_0 + 4.166666666666656e-03*G4_2_2_8_0_11_1 + 4.166666666666654e-03*G4_2_2_8_0_11_2 + 8.333333333333309e-03*G4_2_2_8_1_8_0 + 8.333333333333311e-03*G4_2_2_8_1_8_1 + 8.333333333333311e-03*G4_2_2_8_1_8_2 + 4.166666666666654e-03*G4_2_2_8_1_9_0 + 4.166666666666654e-03*G4_2_2_8_1_9_1 + 4.166666666666654e-03*G4_2_2_8_1_9_2 + 4.166666666666654e-03*G4_2_2_8_1_10_0 + 4.166666666666654e-03*G4_2_2_8_1_10_1 + 4.166666666666654e-03*G4_2_2_8_1_10_2 + 4.166666666666656e-03*G4_2_2_8_1_11_0 + 4.166666666666657e-03*G4_2_2_8_1_11_1 + 4.166666666666657e-03*G4_2_2_8_1_11_2 + 8.333333333333309e-03*G4_2_2_8_2_8_0 + 8.333333333333311e-03*G4_2_2_8_2_8_1 + 8.333333333333311e-03*G4_2_2_8_2_8_2 + 4.166666666666654e-03*G4_2_2_8_2_9_0 + 4.166666666666654e-03*G4_2_2_8_2_9_1 + 4.166666666666654e-03*G4_2_2_8_2_9_2 + 4.166666666666654e-03*G4_2_2_8_2_10_0 + 4.166666666666654e-03*G4_2_2_8_2_10_1 + 4.166666666666654e-03*G4_2_2_8_2_10_2 + 4.166666666666654e-03*G4_2_2_8_2_11_0 + 4.166666666666657e-03*G4_2_2_8_2_11_1 + 4.166666666666656e-03*G4_2_2_8_2_11_2 + 4.166666666666654e-03*G4_2_2_9_0_8_0 + 4.166666666666654e-03*G4_2_2_9_0_8_1 + 4.166666666666654e-03*G4_2_2_9_0_8_2 + 8.333333333333307e-03*G4_2_2_9_0_9_0 + 8.333333333333309e-03*G4_2_2_9_0_9_1 + 8.333333333333307e-03*G4_2_2_9_0_9_2 + 4.166666666666654e-03*G4_2_2_9_0_10_0 + 4.166666666666655e-03*G4_2_2_9_0_10_1 + 4.166666666666654e-03*G4_2_2_9_0_10_2 + 4.166666666666655e-03*G4_2_2_9_0_11_0 + 4.166666666666656e-03*G4_2_2_9_0_11_1 + 4.166666666666656e-03*G4_2_2_9_0_11_2 + 4.166666666666654e-03*G4_2_2_9_1_8_0 + 4.166666666666654e-03*G4_2_2_9_1_8_1 + 4.166666666666654e-03*G4_2_2_9_1_8_2 + 8.333333333333309e-03*G4_2_2_9_1_9_0 + 8.333333333333309e-03*G4_2_2_9_1_9_1 + 8.333333333333307e-03*G4_2_2_9_1_9_2 + 4.166666666666655e-03*G4_2_2_9_1_10_0 + 4.166666666666656e-03*G4_2_2_9_1_10_1 + 4.166666666666654e-03*G4_2_2_9_1_10_2 + 4.166666666666656e-03*G4_2_2_9_1_11_0 + 4.166666666666657e-03*G4_2_2_9_1_11_1 + 4.166666666666656e-03*G4_2_2_9_1_11_2 + 4.166666666666654e-03*G4_2_2_9_2_8_0 + 4.166666666666654e-03*G4_2_2_9_2_8_1 + 4.166666666666654e-03*G4_2_2_9_2_8_2 + 8.333333333333307e-03*G4_2_2_9_2_9_0 + 8.333333333333309e-03*G4_2_2_9_2_9_1 + 8.333333333333307e-03*G4_2_2_9_2_9_2 + 4.166666666666654e-03*G4_2_2_9_2_10_0 + 4.166666666666655e-03*G4_2_2_9_2_10_1 + 4.166666666666654e-03*G4_2_2_9_2_10_2 + 4.166666666666656e-03*G4_2_2_9_2_11_0 + 4.166666666666656e-03*G4_2_2_9_2_11_1 + 4.166666666666656e-03*G4_2_2_9_2_11_2 + 4.166666666666653e-03*G4_2_2_10_0_8_0 + 4.166666666666654e-03*G4_2_2_10_0_8_1 + 4.166666666666653e-03*G4_2_2_10_0_8_2 + 4.166666666666654e-03*G4_2_2_10_0_9_0 + 4.166666666666655e-03*G4_2_2_10_0_9_1 + 4.166666666666654e-03*G4_2_2_10_0_9_2 + 8.333333333333309e-03*G4_2_2_10_0_10_0 + 8.333333333333309e-03*G4_2_2_10_0_10_1 + 8.333333333333309e-03*G4_2_2_10_0_10_2 + 4.166666666666654e-03*G4_2_2_10_0_11_0 + 4.166666666666655e-03*G4_2_2_10_0_11_1 + 4.166666666666654e-03*G4_2_2_10_0_11_2 + 4.166666666666654e-03*G4_2_2_10_1_8_0 + 4.166666666666654e-03*G4_2_2_10_1_8_1 + 4.166666666666654e-03*G4_2_2_10_1_8_2 + 4.166666666666655e-03*G4_2_2_10_1_9_0 + 4.166666666666656e-03*G4_2_2_10_1_9_1 + 4.166666666666654e-03*G4_2_2_10_1_9_2 + 8.333333333333311e-03*G4_2_2_10_1_10_0 + 8.333333333333311e-03*G4_2_2_10_1_10_1 + 8.333333333333311e-03*G4_2_2_10_1_10_2 + 4.166666666666655e-03*G4_2_2_10_1_11_0 + 4.166666666666656e-03*G4_2_2_10_1_11_1 + 4.166666666666655e-03*G4_2_2_10_1_11_2 + 4.166666666666653e-03*G4_2_2_10_2_8_0 + 4.166666666666654e-03*G4_2_2_10_2_8_1 + 4.166666666666654e-03*G4_2_2_10_2_8_2 + 4.166666666666654e-03*G4_2_2_10_2_9_0 + 4.166666666666654e-03*G4_2_2_10_2_9_1 + 4.166666666666654e-03*G4_2_2_10_2_9_2 + 8.333333333333309e-03*G4_2_2_10_2_10_0 + 8.333333333333309e-03*G4_2_2_10_2_10_1 + 8.333333333333309e-03*G4_2_2_10_2_10_2 + 4.166666666666654e-03*G4_2_2_10_2_11_0 + 4.166666666666655e-03*G4_2_2_10_2_11_1 + 4.166666666666654e-03*G4_2_2_10_2_11_2 + 4.166666666666655e-03*G4_2_2_11_0_8_0 + 4.166666666666656e-03*G4_2_2_11_0_8_1 + 4.166666666666655e-03*G4_2_2_11_0_8_2 + 4.166666666666655e-03*G4_2_2_11_0_9_0 + 4.166666666666656e-03*G4_2_2_11_0_9_1 + 4.166666666666656e-03*G4_2_2_11_0_9_2 + 4.166666666666655e-03*G4_2_2_11_0_10_0 + 4.166666666666655e-03*G4_2_2_11_0_10_1 + 4.166666666666654e-03*G4_2_2_11_0_10_2 + 8.333333333333309e-03*G4_2_2_11_0_11_0 + 8.333333333333311e-03*G4_2_2_11_0_11_1 + 8.333333333333309e-03*G4_2_2_11_0_11_2 + 4.166666666666656e-03*G4_2_2_11_1_8_0 + 4.166666666666657e-03*G4_2_2_11_1_8_1 + 4.166666666666657e-03*G4_2_2_11_1_8_2 + 4.166666666666656e-03*G4_2_2_11_1_9_0 + 4.166666666666657e-03*G4_2_2_11_1_9_1 + 4.166666666666656e-03*G4_2_2_11_1_9_2 + 4.166666666666655e-03*G4_2_2_11_1_10_0 + 4.166666666666656e-03*G4_2_2_11_1_10_1 + 4.166666666666655e-03*G4_2_2_11_1_10_2 + 8.333333333333311e-03*G4_2_2_11_1_11_0 + 8.333333333333311e-03*G4_2_2_11_1_11_1 + 8.333333333333311e-03*G4_2_2_11_1_11_2 + 4.166666666666655e-03*G4_2_2_11_2_8_0 + 4.166666666666657e-03*G4_2_2_11_2_8_1 + 4.166666666666656e-03*G4_2_2_11_2_8_2 + 4.166666666666656e-03*G4_2_2_11_2_9_0 + 4.166666666666656e-03*G4_2_2_11_2_9_1 + 4.166666666666656e-03*G4_2_2_11_2_9_2 + 4.166666666666655e-03*G4_2_2_11_2_10_0 + 4.166666666666655e-03*G4_2_2_11_2_10_1 + 4.166666666666654e-03*G4_2_2_11_2_10_2 + 8.333333333333309e-03*G4_2_2_11_2_11_0 + 8.333333333333311e-03*G4_2_2_11_2_11_1 + 8.333333333333309e-03*G4_2_2_11_2_11_2;
    block[1] = 8.333333333333311e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_1_0 - 8.333333333333320e-02*G1_2_0 + 8.333333333333309e-03*G2_0_0_0 + 4.166666666666654e-03*G2_0_1_0 + 4.166666666666654e-03*G2_0_2_0 + 4.166666666666656e-03*G2_0_3_0 + 8.333333333333309e-03*G2_1_4_0 + 4.166666666666655e-03*G2_1_5_0 + 4.166666666666654e-03*G2_1_6_0 + 4.166666666666656e-03*G2_1_7_0 + 8.333333333333309e-03*G2_2_8_0 + 4.166666666666655e-03*G2_2_9_0 + 4.166666666666654e-03*G2_2_10_0 + 4.166666666666656e-03*G2_2_11_0 - 8.333333333333320e-02*G3_0_0_0_0 - 8.333333333333322e-02*G3_0_0_1_0 - 8.333333333333320e-02*G3_0_0_2_0 - 8.333333333333309e-03*G4_0_0_0_0_0_0 - 4.166666666666654e-03*G4_0_0_0_0_1_0 - 4.166666666666654e-03*G4_0_0_0_0_2_0 - 4.166666666666656e-03*G4_0_0_0_0_3_0 - 8.333333333333309e-03*G4_0_0_0_1_0_0 - 4.166666666666654e-03*G4_0_0_0_1_1_0 - 4.166666666666654e-03*G4_0_0_0_1_2_0 - 4.166666666666656e-03*G4_0_0_0_1_3_0 - 8.333333333333309e-03*G4_0_0_0_2_0_0 - 4.166666666666654e-03*G4_0_0_0_2_1_0 - 4.166666666666654e-03*G4_0_0_0_2_2_0 - 4.166666666666656e-03*G4_0_0_0_2_3_0 - 4.166666666666654e-03*G4_0_0_1_0_0_0 - 8.333333333333307e-03*G4_0_0_1_0_1_0 - 4.166666666666654e-03*G4_0_0_1_0_2_0 - 4.166666666666654e-03*G4_0_0_1_0_3_0 - 4.166666666666654e-03*G4_0_0_1_1_0_0 - 8.333333333333307e-03*G4_0_0_1_1_1_0 - 4.166666666666654e-03*G4_0_0_1_1_2_0 - 4.166666666666655e-03*G4_0_0_1_1_3_0 - 4.166666666666654e-03*G4_0_0_1_2_0_0 - 8.333333333333307e-03*G4_0_0_1_2_1_0 - 4.166666666666654e-03*G4_0_0_1_2_2_0 - 4.166666666666655e-03*G4_0_0_1_2_3_0 - 4.166666666666654e-03*G4_0_0_2_0_0_0 - 4.166666666666654e-03*G4_0_0_2_0_1_0 - 8.333333333333309e-03*G4_0_0_2_0_2_0 - 4.166666666666654e-03*G4_0_0_2_0_3_0 - 4.166666666666654e-03*G4_0_0_2_1_0_0 - 4.166666666666654e-03*G4_0_0_2_1_1_0 - 8.333333333333311e-03*G4_0_0_2_1_2_0 - 4.166666666666655e-03*G4_0_0_2_1_3_0 - 4.166666666666654e-03*G4_0_0_2_2_0_0 - 4.166666666666654e-03*G4_0_0_2_2_1_0 - 8.333333333333309e-03*G4_0_0_2_2_2_0 - 4.166666666666654e-03*G4_0_0_2_2_3_0 - 4.166666666666656e-03*G4_0_0_3_0_0_0 - 4.166666666666654e-03*G4_0_0_3_0_1_0 - 4.166666666666655e-03*G4_0_0_3_0_2_0 - 8.333333333333309e-03*G4_0_0_3_0_3_0 - 4.166666666666656e-03*G4_0_0_3_1_0_0 - 4.166666666666655e-03*G4_0_0_3_1_1_0 - 4.166666666666655e-03*G4_0_0_3_1_2_0 - 8.333333333333311e-03*G4_0_0_3_1_3_0 - 4.166666666666656e-03*G4_0_0_3_2_0_0 - 4.166666666666655e-03*G4_0_0_3_2_1_0 - 4.166666666666655e-03*G4_0_0_3_2_2_0 - 8.333333333333309e-03*G4_0_0_3_2_3_0 - 8.333333333333309e-03*G4_0_1_0_0_4_0 - 4.166666666666654e-03*G4_0_1_0_0_5_0 - 4.166666666666654e-03*G4_0_1_0_0_6_0 - 4.166666666666656e-03*G4_0_1_0_0_7_0 - 8.333333333333309e-03*G4_0_1_0_1_4_0 - 4.166666666666655e-03*G4_0_1_0_1_5_0 - 4.166666666666654e-03*G4_0_1_0_1_6_0 - 4.166666666666656e-03*G4_0_1_0_1_7_0 - 8.333333333333309e-03*G4_0_1_0_2_4_0 - 4.166666666666655e-03*G4_0_1_0_2_5_0 - 4.166666666666654e-03*G4_0_1_0_2_6_0 - 4.166666666666656e-03*G4_0_1_0_2_7_0 - 4.166666666666654e-03*G4_0_1_1_0_4_0 - 8.333333333333307e-03*G4_0_1_1_0_5_0 - 4.166666666666654e-03*G4_0_1_1_0_6_0 - 4.166666666666654e-03*G4_0_1_1_0_7_0 - 4.166666666666654e-03*G4_0_1_1_1_4_0 - 8.333333333333309e-03*G4_0_1_1_1_5_0 - 4.166666666666654e-03*G4_0_1_1_1_6_0 - 4.166666666666655e-03*G4_0_1_1_1_7_0 - 4.166666666666654e-03*G4_0_1_1_2_4_0 - 8.333333333333307e-03*G4_0_1_1_2_5_0 - 4.166666666666654e-03*G4_0_1_1_2_6_0 - 4.166666666666655e-03*G4_0_1_1_2_7_0 - 4.166666666666653e-03*G4_0_1_2_0_4_0 - 4.166666666666654e-03*G4_0_1_2_0_5_0 - 8.333333333333309e-03*G4_0_1_2_0_6_0 - 4.166666666666654e-03*G4_0_1_2_0_7_0 - 4.166666666666654e-03*G4_0_1_2_1_4_0 - 4.166666666666655e-03*G4_0_1_2_1_5_0 - 8.333333333333311e-03*G4_0_1_2_1_6_0 - 4.166666666666655e-03*G4_0_1_2_1_7_0 - 4.166666666666653e-03*G4_0_1_2_2_4_0 - 4.166666666666654e-03*G4_0_1_2_2_5_0 - 8.333333333333309e-03*G4_0_1_2_2_6_0 - 4.166666666666654e-03*G4_0_1_2_2_7_0 - 4.166666666666655e-03*G4_0_1_3_0_4_0 - 4.166666666666655e-03*G4_0_1_3_0_5_0 - 4.166666666666655e-03*G4_0_1_3_0_6_0 - 8.333333333333309e-03*G4_0_1_3_0_7_0 - 4.166666666666656e-03*G4_0_1_3_1_4_0 - 4.166666666666656e-03*G4_0_1_3_1_5_0 - 4.166666666666655e-03*G4_0_1_3_1_6_0 - 8.333333333333311e-03*G4_0_1_3_1_7_0 - 4.166666666666655e-03*G4_0_1_3_2_4_0 - 4.166666666666656e-03*G4_0_1_3_2_5_0 - 4.166666666666655e-03*G4_0_1_3_2_6_0 - 8.333333333333309e-03*G4_0_1_3_2_7_0 - 8.333333333333309e-03*G4_0_2_0_0_8_0 - 4.166666666666654e-03*G4_0_2_0_0_9_0 - 4.166666666666654e-03*G4_0_2_0_0_10_0 - 4.166666666666656e-03*G4_0_2_0_0_11_0 - 8.333333333333309e-03*G4_0_2_0_1_8_0 - 4.166666666666655e-03*G4_0_2_0_1_9_0 - 4.166666666666654e-03*G4_0_2_0_1_10_0 - 4.166666666666656e-03*G4_0_2_0_1_11_0 - 8.333333333333309e-03*G4_0_2_0_2_8_0 - 4.166666666666655e-03*G4_0_2_0_2_9_0 - 4.166666666666654e-03*G4_0_2_0_2_10_0 - 4.166666666666656e-03*G4_0_2_0_2_11_0 - 4.166666666666654e-03*G4_0_2_1_0_8_0 - 8.333333333333307e-03*G4_0_2_1_0_9_0 - 4.166666666666654e-03*G4_0_2_1_0_10_0 - 4.166666666666654e-03*G4_0_2_1_0_11_0 - 4.166666666666654e-03*G4_0_2_1_1_8_0 - 8.333333333333309e-03*G4_0_2_1_1_9_0 - 4.166666666666654e-03*G4_0_2_1_1_10_0 - 4.166666666666655e-03*G4_0_2_1_1_11_0 - 4.166666666666654e-03*G4_0_2_1_2_8_0 - 8.333333333333307e-03*G4_0_2_1_2_9_0 - 4.166666666666654e-03*G4_0_2_1_2_10_0 - 4.166666666666655e-03*G4_0_2_1_2_11_0 - 4.166666666666653e-03*G4_0_2_2_0_8_0 - 4.166666666666654e-03*G4_0_2_2_0_9_0 - 8.333333333333309e-03*G4_0_2_2_0_10_0 - 4.166666666666654e-03*G4_0_2_2_0_11_0 - 4.166666666666654e-03*G4_0_2_2_1_8_0 - 4.166666666666655e-03*G4_0_2_2_1_9_0 - 8.333333333333311e-03*G4_0_2_2_1_10_0 - 4.166666666666655e-03*G4_0_2_2_1_11_0 - 4.166666666666653e-03*G4_0_2_2_2_8_0 - 4.166666666666654e-03*G4_0_2_2_2_9_0 - 8.333333333333309e-03*G4_0_2_2_2_10_0 - 4.166666666666654e-03*G4_0_2_2_2_11_0 - 4.166666666666655e-03*G4_0_2_3_0_8_0 - 4.166666666666655e-03*G4_0_2_3_0_9_0 - 4.166666666666655e-03*G4_0_2_3_0_10_0 - 8.333333333333309e-03*G4_0_2_3_0_11_0 - 4.166666666666656e-03*G4_0_2_3_1_8_0 - 4.166666666666656e-03*G4_0_2_3_1_9_0 - 4.166666666666655e-03*G4_0_2_3_1_10_0 - 8.333333333333311e-03*G4_0_2_3_1_11_0 - 4.166666666666655e-03*G4_0_2_3_2_8_0 - 4.166666666666656e-03*G4_0_2_3_2_9_0 - 4.166666666666655e-03*G4_0_2_3_2_10_0 - 8.333333333333309e-03*G4_0_2_3_2_11_0 - 8.333333333333309e-03*G4_1_0_4_0_0_0 - 4.166666666666654e-03*G4_1_0_4_0_1_0 - 4.166666666666653e-03*G4_1_0_4_0_2_0 - 4.166666666666654e-03*G4_1_0_4_0_3_0 - 8.333333333333309e-03*G4_1_0_4_1_0_0 - 4.166666666666654e-03*G4_1_0_4_1_1_0 - 4.166666666666654e-03*G4_1_0_4_1_2_0 - 4.166666666666656e-03*G4_1_0_4_1_3_0 - 8.333333333333309e-03*G4_1_0_4_2_0_0 - 4.166666666666654e-03*G4_1_0_4_2_1_0 - 4.166666666666654e-03*G4_1_0_4_2_2_0 - 4.166666666666654e-03*G4_1_0_4_2_3_0 - 4.166666666666654e-03*G4_1_0_5_0_0_0 - 8.333333333333307e-03*G4_1_0_5_0_1_0 - 4.166666666666654e-03*G4_1_0_5_0_2_0 - 4.166666666666655e-03*G4_1_0_5_0_3_0 - 4.166666666666655e-03*G4_1_0_5_1_0_0 - 8.333333333333309e-03*G4_1_0_5_1_1_0 - 4.166666666666655e-03*G4_1_0_5_1_2_0 - 4.166666666666656e-03*G4_1_0_5_1_3_0 - 4.166666666666655e-03*G4_1_0_5_2_0_0 - 8.333333333333307e-03*G4_1_0_5_2_1_0 - 4.166666666666654e-03*G4_1_0_5_2_2_0 - 4.166666666666656e-03*G4_1_0_5_2_3_0 - 4.166666666666654e-03*G4_1_0_6_0_0_0 - 4.166666666666654e-03*G4_1_0_6_0_1_0 - 8.333333333333309e-03*G4_1_0_6_0_2_0 - 4.166666666666654e-03*G4_1_0_6_0_3_0 - 4.166666666666654e-03*G4_1_0_6_1_0_0 - 4.166666666666654e-03*G4_1_0_6_1_1_0 - 8.333333333333311e-03*G4_1_0_6_1_2_0 - 4.166666666666655e-03*G4_1_0_6_1_3_0 - 4.166666666666654e-03*G4_1_0_6_2_0_0 - 4.166666666666654e-03*G4_1_0_6_2_1_0 - 8.333333333333309e-03*G4_1_0_6_2_2_0 - 4.166666666666654e-03*G4_1_0_6_2_3_0 - 4.166666666666656e-03*G4_1_0_7_0_0_0 - 4.166666666666654e-03*G4_1_0_7_0_1_0 - 4.166666666666655e-03*G4_1_0_7_0_2_0 - 8.333333333333309e-03*G4_1_0_7_0_3_0 - 4.166666666666656e-03*G4_1_0_7_1_0_0 - 4.166666666666655e-03*G4_1_0_7_1_1_0 - 4.166666666666655e-03*G4_1_0_7_1_2_0 - 8.333333333333311e-03*G4_1_0_7_1_3_0 - 4.166666666666656e-03*G4_1_0_7_2_0_0 - 4.166666666666655e-03*G4_1_0_7_2_1_0 - 4.166666666666655e-03*G4_1_0_7_2_2_0 - 8.333333333333309e-03*G4_1_0_7_2_3_0 - 8.333333333333309e-03*G4_1_1_4_0_4_0 - 4.166666666666654e-03*G4_1_1_4_0_5_0 - 4.166666666666653e-03*G4_1_1_4_0_6_0 - 4.166666666666654e-03*G4_1_1_4_0_7_0 - 8.333333333333309e-03*G4_1_1_4_1_4_0 - 4.166666666666654e-03*G4_1_1_4_1_5_0 - 4.166666666666654e-03*G4_1_1_4_1_6_0 - 4.166666666666656e-03*G4_1_1_4_1_7_0 - 8.333333333333309e-03*G4_1_1_4_2_4_0 - 4.166666666666654e-03*G4_1_1_4_2_5_0 - 4.166666666666654e-03*G4_1_1_4_2_6_0 - 4.166666666666654e-03*G4_1_1_4_2_7_0 - 4.166666666666654e-03*G4_1_1_5_0_4_0 - 8.333333333333307e-03*G4_1_1_5_0_5_0 - 4.166666666666654e-03*G4_1_1_5_0_6_0 - 4.166666666666655e-03*G4_1_1_5_0_7_0 - 4.166666666666654e-03*G4_1_1_5_1_4_0 - 8.333333333333309e-03*G4_1_1_5_1_5_0 - 4.166666666666655e-03*G4_1_1_5_1_6_0 - 4.166666666666656e-03*G4_1_1_5_1_7_0 - 4.166666666666654e-03*G4_1_1_5_2_4_0 - 8.333333333333307e-03*G4_1_1_5_2_5_0 - 4.166666666666654e-03*G4_1_1_5_2_6_0 - 4.166666666666656e-03*G4_1_1_5_2_7_0 - 4.166666666666653e-03*G4_1_1_6_0_4_0 - 4.166666666666654e-03*G4_1_1_6_0_5_0 - 8.333333333333309e-03*G4_1_1_6_0_6_0 - 4.166666666666654e-03*G4_1_1_6_0_7_0 - 4.166666666666654e-03*G4_1_1_6_1_4_0 - 4.166666666666655e-03*G4_1_1_6_1_5_0 - 8.333333333333311e-03*G4_1_1_6_1_6_0 - 4.166666666666655e-03*G4_1_1_6_1_7_0 - 4.166666666666653e-03*G4_1_1_6_2_4_0 - 4.166666666666654e-03*G4_1_1_6_2_5_0 - 8.333333333333309e-03*G4_1_1_6_2_6_0 - 4.166666666666654e-03*G4_1_1_6_2_7_0 - 4.166666666666655e-03*G4_1_1_7_0_4_0 - 4.166666666666655e-03*G4_1_1_7_0_5_0 - 4.166666666666655e-03*G4_1_1_7_0_6_0 - 8.333333333333309e-03*G4_1_1_7_0_7_0 - 4.166666666666656e-03*G4_1_1_7_1_4_0 - 4.166666666666656e-03*G4_1_1_7_1_5_0 - 4.166666666666655e-03*G4_1_1_7_1_6_0 - 8.333333333333311e-03*G4_1_1_7_1_7_0 - 4.166666666666655e-03*G4_1_1_7_2_4_0 - 4.166666666666656e-03*G4_1_1_7_2_5_0 - 4.166666666666655e-03*G4_1_1_7_2_6_0 - 8.333333333333309e-03*G4_1_1_7_2_7_0 - 8.333333333333309e-03*G4_1_2_4_0_8_0 - 4.166666666666654e-03*G4_1_2_4_0_9_0 - 4.166666666666653e-03*G4_1_2_4_0_10_0 - 4.166666666666654e-03*G4_1_2_4_0_11_0 - 8.333333333333309e-03*G4_1_2_4_1_8_0 - 4.166666666666654e-03*G4_1_2_4_1_9_0 - 4.166666666666654e-03*G4_1_2_4_1_10_0 - 4.166666666666656e-03*G4_1_2_4_1_11_0 - 8.333333333333309e-03*G4_1_2_4_2_8_0 - 4.166666666666654e-03*G4_1_2_4_2_9_0 - 4.166666666666654e-03*G4_1_2_4_2_10_0 - 4.166666666666654e-03*G4_1_2_4_2_11_0 - 4.166666666666654e-03*G4_1_2_5_0_8_0 - 8.333333333333307e-03*G4_1_2_5_0_9_0 - 4.166666666666654e-03*G4_1_2_5_0_10_0 - 4.166666666666655e-03*G4_1_2_5_0_11_0 - 4.166666666666654e-03*G4_1_2_5_1_8_0 - 8.333333333333309e-03*G4_1_2_5_1_9_0 - 4.166666666666655e-03*G4_1_2_5_1_10_0 - 4.166666666666656e-03*G4_1_2_5_1_11_0 - 4.166666666666654e-03*G4_1_2_5_2_8_0 - 8.333333333333307e-03*G4_1_2_5_2_9_0 - 4.166666666666654e-03*G4_1_2_5_2_10_0 - 4.166666666666656e-03*G4_1_2_5_2_11_0 - 4.166666666666653e-03*G4_1_2_6_0_8_0 - 4.166666666666654e-03*G4_1_2_6_0_9_0 - 8.333333333333309e-03*G4_1_2_6_0_10_0 - 4.166666666666654e-03*G4_1_2_6_0_11_0 - 4.166666666666654e-03*G4_1_2_6_1_8_0 - 4.166666666666655e-03*G4_1_2_6_1_9_0 - 8.333333333333311e-03*G4_1_2_6_1_10_0 - 4.166666666666655e-03*G4_1_2_6_1_11_0 - 4.166666666666653e-03*G4_1_2_6_2_8_0 - 4.166666666666654e-03*G4_1_2_6_2_9_0 - 8.333333333333309e-03*G4_1_2_6_2_10_0 - 4.166666666666654e-03*G4_1_2_6_2_11_0 - 4.166666666666655e-03*G4_1_2_7_0_8_0 - 4.166666666666655e-03*G4_1_2_7_0_9_0 - 4.166666666666655e-03*G4_1_2_7_0_10_0 - 8.333333333333309e-03*G4_1_2_7_0_11_0 - 4.166666666666656e-03*G4_1_2_7_1_8_0 - 4.166666666666656e-03*G4_1_2_7_1_9_0 - 4.166666666666655e-03*G4_1_2_7_1_10_0 - 8.333333333333311e-03*G4_1_2_7_1_11_0 - 4.166666666666655e-03*G4_1_2_7_2_8_0 - 4.166666666666656e-03*G4_1_2_7_2_9_0 - 4.166666666666655e-03*G4_1_2_7_2_10_0 - 8.333333333333309e-03*G4_1_2_7_2_11_0 - 8.333333333333309e-03*G4_2_0_8_0_0_0 - 4.166666666666654e-03*G4_2_0_8_0_1_0 - 4.166666666666653e-03*G4_2_0_8_0_2_0 - 4.166666666666654e-03*G4_2_0_8_0_3_0 - 8.333333333333309e-03*G4_2_0_8_1_0_0 - 4.166666666666654e-03*G4_2_0_8_1_1_0 - 4.166666666666654e-03*G4_2_0_8_1_2_0 - 4.166666666666656e-03*G4_2_0_8_1_3_0 - 8.333333333333309e-03*G4_2_0_8_2_0_0 - 4.166666666666654e-03*G4_2_0_8_2_1_0 - 4.166666666666654e-03*G4_2_0_8_2_2_0 - 4.166666666666654e-03*G4_2_0_8_2_3_0 - 4.166666666666654e-03*G4_2_0_9_0_0_0 - 8.333333333333307e-03*G4_2_0_9_0_1_0 - 4.166666666666654e-03*G4_2_0_9_0_2_0 - 4.166666666666655e-03*G4_2_0_9_0_3_0 - 4.166666666666655e-03*G4_2_0_9_1_0_0 - 8.333333333333309e-03*G4_2_0_9_1_1_0 - 4.166666666666655e-03*G4_2_0_9_1_2_0 - 4.166666666666656e-03*G4_2_0_9_1_3_0 - 4.166666666666655e-03*G4_2_0_9_2_0_0 - 8.333333333333307e-03*G4_2_0_9_2_1_0 - 4.166666666666654e-03*G4_2_0_9_2_2_0 - 4.166666666666656e-03*G4_2_0_9_2_3_0 - 4.166666666666654e-03*G4_2_0_10_0_0_0 - 4.166666666666654e-03*G4_2_0_10_0_1_0 - 8.333333333333309e-03*G4_2_0_10_0_2_0 - 4.166666666666654e-03*G4_2_0_10_0_3_0 - 4.166666666666654e-03*G4_2_0_10_1_0_0 - 4.166666666666654e-03*G4_2_0_10_1_1_0 - 8.333333333333311e-03*G4_2_0_10_1_2_0 - 4.166666666666655e-03*G4_2_0_10_1_3_0 - 4.166666666666654e-03*G4_2_0_10_2_0_0 - 4.166666666666654e-03*G4_2_0_10_2_1_0 - 8.333333333333309e-03*G4_2_0_10_2_2_0 - 4.166666666666654e-03*G4_2_0_10_2_3_0 - 4.166666666666656e-03*G4_2_0_11_0_0_0 - 4.166666666666654e-03*G4_2_0_11_0_1_0 - 4.166666666666655e-03*G4_2_0_11_0_2_0 - 8.333333333333309e-03*G4_2_0_11_0_3_0 - 4.166666666666656e-03*G4_2_0_11_1_0_0 - 4.166666666666655e-03*G4_2_0_11_1_1_0 - 4.166666666666655e-03*G4_2_0_11_1_2_0 - 8.333333333333311e-03*G4_2_0_11_1_3_0 - 4.166666666666656e-03*G4_2_0_11_2_0_0 - 4.166666666666655e-03*G4_2_0_11_2_1_0 - 4.166666666666655e-03*G4_2_0_11_2_2_0 - 8.333333333333309e-03*G4_2_0_11_2_3_0 - 8.333333333333309e-03*G4_2_1_8_0_4_0 - 4.166666666666654e-03*G4_2_1_8_0_5_0 - 4.166666666666653e-03*G4_2_1_8_0_6_0 - 4.166666666666654e-03*G4_2_1_8_0_7_0 - 8.333333333333309e-03*G4_2_1_8_1_4_0 - 4.166666666666654e-03*G4_2_1_8_1_5_0 - 4.166666666666654e-03*G4_2_1_8_1_6_0 - 4.166666666666656e-03*G4_2_1_8_1_7_0 - 8.333333333333309e-03*G4_2_1_8_2_4_0 - 4.166666666666654e-03*G4_2_1_8_2_5_0 - 4.166666666666654e-03*G4_2_1_8_2_6_0 - 4.166666666666654e-03*G4_2_1_8_2_7_0 - 4.166666666666654e-03*G4_2_1_9_0_4_0 - 8.333333333333307e-03*G4_2_1_9_0_5_0 - 4.166666666666654e-03*G4_2_1_9_0_6_0 - 4.166666666666655e-03*G4_2_1_9_0_7_0 - 4.166666666666654e-03*G4_2_1_9_1_4_0 - 8.333333333333309e-03*G4_2_1_9_1_5_0 - 4.166666666666655e-03*G4_2_1_9_1_6_0 - 4.166666666666656e-03*G4_2_1_9_1_7_0 - 4.166666666666654e-03*G4_2_1_9_2_4_0 - 8.333333333333307e-03*G4_2_1_9_2_5_0 - 4.166666666666654e-03*G4_2_1_9_2_6_0 - 4.166666666666656e-03*G4_2_1_9_2_7_0 - 4.166666666666653e-03*G4_2_1_10_0_4_0 - 4.166666666666654e-03*G4_2_1_10_0_5_0 - 8.333333333333309e-03*G4_2_1_10_0_6_0 - 4.166666666666654e-03*G4_2_1_10_0_7_0 - 4.166666666666654e-03*G4_2_1_10_1_4_0 - 4.166666666666655e-03*G4_2_1_10_1_5_0 - 8.333333333333311e-03*G4_2_1_10_1_6_0 - 4.166666666666655e-03*G4_2_1_10_1_7_0 - 4.166666666666653e-03*G4_2_1_10_2_4_0 - 4.166666666666654e-03*G4_2_1_10_2_5_0 - 8.333333333333309e-03*G4_2_1_10_2_6_0 - 4.166666666666654e-03*G4_2_1_10_2_7_0 - 4.166666666666655e-03*G4_2_1_11_0_4_0 - 4.166666666666655e-03*G4_2_1_11_0_5_0 - 4.166666666666655e-03*G4_2_1_11_0_6_0 - 8.333333333333309e-03*G4_2_1_11_0_7_0 - 4.166666666666656e-03*G4_2_1_11_1_4_0 - 4.166666666666656e-03*G4_2_1_11_1_5_0 - 4.166666666666655e-03*G4_2_1_11_1_6_0 - 8.333333333333311e-03*G4_2_1_11_1_7_0 - 4.166666666666655e-03*G4_2_1_11_2_4_0 - 4.166666666666656e-03*G4_2_1_11_2_5_0 - 4.166666666666655e-03*G4_2_1_11_2_6_0 - 8.333333333333309e-03*G4_2_1_11_2_7_0 - 8.333333333333309e-03*G4_2_2_8_0_8_0 - 4.166666666666654e-03*G4_2_2_8_0_9_0 - 4.166666666666653e-03*G4_2_2_8_0_10_0 - 4.166666666666654e-03*G4_2_2_8_0_11_0 - 8.333333333333309e-03*G4_2_2_8_1_8_0 - 4.166666666666654e-03*G4_2_2_8_1_9_0 - 4.166666666666654e-03*G4_2_2_8_1_10_0 - 4.166666666666656e-03*G4_2_2_8_1_11_0 - 8.333333333333309e-03*G4_2_2_8_2_8_0 - 4.166666666666654e-03*G4_2_2_8_2_9_0 - 4.166666666666654e-03*G4_2_2_8_2_10_0 - 4.166666666666654e-03*G4_2_2_8_2_11_0 - 4.166666666666654e-03*G4_2_2_9_0_8_0 - 8.333333333333307e-03*G4_2_2_9_0_9_0 - 4.166666666666654e-03*G4_2_2_9_0_10_0 - 4.166666666666655e-03*G4_2_2_9_0_11_0 - 4.166666666666654e-03*G4_2_2_9_1_8_0 - 8.333333333333309e-03*G4_2_2_9_1_9_0 - 4.166666666666655e-03*G4_2_2_9_1_10_0 - 4.166666666666656e-03*G4_2_2_9_1_11_0 - 4.166666666666654e-03*G4_2_2_9_2_8_0 - 8.333333333333307e-03*G4_2_2_9_2_9_0 - 4.166666666666654e-03*G4_2_2_9_2_10_0 - 4.166666666666656e-03*G4_2_2_9_2_11_0 - 4.166666666666653e-03*G4_2_2_10_0_8_0 - 4.166666666666654e-03*G4_2_2_10_0_9_0 - 8.333333333333309e-03*G4_2_2_10_0_10_0 - 4.166666666666654e-03*G4_2_2_10_0_11_0 - 4.166666666666654e-03*G4_2_2_10_1_8_0 - 4.166666666666655e-03*G4_2_2_10_1_9_0 - 8.333333333333311e-03*G4_2_2_10_1_10_0 - 4.166666666666655e-03*G4_2_2_10_1_11_0 - 4.166666666666653e-03*G4_2_2_10_2_8_0 - 4.166666666666654e-03*G4_2_2_10_2_9_0 - 8.333333333333309e-03*G4_2_2_10_2_10_0 - 4.166666666666654e-03*G4_2_2_10_2_11_0 - 4.166666666666655e-03*G4_2_2_11_0_8_0 - 4.166666666666655e-03*G4_2_2_11_0_9_0 - 4.166666666666655e-03*G4_2_2_11_0_10_0 - 8.333333333333309e-03*G4_2_2_11_0_11_0 - 4.166666666666656e-03*G4_2_2_11_1_8_0 - 4.166666666666656e-03*G4_2_2_11_1_9_0 - 4.166666666666655e-03*G4_2_2_11_1_10_0 - 8.333333333333311e-03*G4_2_2_11_1_11_0 - 4.166666666666655e-03*G4_2_2_11_2_8_0 - 4.166666666666656e-03*G4_2_2_11_2_9_0 - 4.166666666666655e-03*G4_2_2_11_2_10_0 - 8.333333333333309e-03*G4_2_2_11_2_11_0;
    block[2] = 8.333333333333312e-03*G0_ - 8.333333333333322e-02*G1_0_1 - 8.333333333333323e-02*G1_1_1 - 8.333333333333322e-02*G1_2_1 + 8.333333333333311e-03*G2_0_0_1 + 4.166666666666655e-03*G2_0_1_1 + 4.166666666666656e-03*G2_0_2_1 + 4.166666666666657e-03*G2_0_3_1 + 8.333333333333311e-03*G2_1_4_1 + 4.166666666666655e-03*G2_1_5_1 + 4.166666666666656e-03*G2_1_6_1 + 4.166666666666657e-03*G2_1_7_1 + 8.333333333333311e-03*G2_2_8_1 + 4.166666666666655e-03*G2_2_9_1 + 4.166666666666656e-03*G2_2_10_1 + 4.166666666666657e-03*G2_2_11_1 - 8.333333333333322e-02*G3_0_0_0_1 - 8.333333333333323e-02*G3_0_0_1_1 - 8.333333333333322e-02*G3_0_0_2_1 - 8.333333333333309e-03*G4_0_0_0_0_0_1 - 4.166666666666654e-03*G4_0_0_0_0_1_1 - 4.166666666666654e-03*G4_0_0_0_0_2_1 - 4.166666666666656e-03*G4_0_0_0_0_3_1 - 8.333333333333311e-03*G4_0_0_0_1_0_1 - 4.166666666666655e-03*G4_0_0_0_1_1_1 - 4.166666666666656e-03*G4_0_0_0_1_2_1 - 4.166666666666657e-03*G4_0_0_0_1_3_1 - 8.333333333333311e-03*G4_0_0_0_2_0_1 - 4.166666666666654e-03*G4_0_0_0_2_1_1 - 4.166666666666655e-03*G4_0_0_0_2_2_1 - 4.166666666666657e-03*G4_0_0_0_2_3_1 - 4.166666666666654e-03*G4_0_0_1_0_0_1 - 8.333333333333307e-03*G4_0_0_1_0_1_1 - 4.166666666666654e-03*G4_0_0_1_0_2_1 - 4.166666666666655e-03*G4_0_0_1_0_3_1 - 4.166666666666655e-03*G4_0_0_1_1_0_1 - 8.333333333333309e-03*G4_0_0_1_1_1_1 - 4.166666666666654e-03*G4_0_0_1_1_2_1 - 4.166666666666655e-03*G4_0_0_1_1_3_1 - 4.166666666666654e-03*G4_0_0_1_2_0_1 - 8.333333333333307e-03*G4_0_0_1_2_1_1 - 4.166666666666654e-03*G4_0_0_1_2_2_1 - 4.166666666666655e-03*G4_0_0_1_2_3_1 - 4.166666666666654e-03*G4_0_0_2_0_0_1 - 4.166666666666654e-03*G4_0_0_2_0_1_1 - 8.333333333333309e-03*G4_0_0_2_0_2_1 - 4.166666666666655e-03*G4_0_0_2_0_3_1 - 4.166666666666656e-03*G4_0_0_2_1_0_1 - 4.166666666666654e-03*G4_0_0_2_1_1_1 - 8.333333333333311e-03*G4_0_0_2_1_2_1 - 4.166666666666656e-03*G4_0_0_2_1_3_1 - 4.166666666666655e-03*G4_0_0_2_2_0_1 - 4.166666666666654e-03*G4_0_0_2_2_1_1 - 8.333333333333309e-03*G4_0_0_2_2_2_1 - 4.166666666666655e-03*G4_0_0_2_2_3_1 - 4.166666666666656e-03*G4_0_0_3_0_0_1 - 4.166666666666655e-03*G4_0_0_3_0_1_1 - 4.166666666666655e-03*G4_0_0_3_0_2_1 - 8.333333333333311e-03*G4_0_0_3_0_3_1 - 4.166666666666657e-03*G4_0_0_3_1_0_1 - 4.166666666666655e-03*G4_0_0_3_1_1_1 - 4.166666666666656e-03*G4_0_0_3_1_2_1 - 8.333333333333311e-03*G4_0_0_3_1_3_1 - 4.166666666666657e-03*G4_0_0_3_2_0_1 - 4.166666666666655e-03*G4_0_0_3_2_1_1 - 4.166666666666655e-03*G4_0_0_3_2_2_1 - 8.333333333333311e-03*G4_0_0_3_2_3_1 - 8.333333333333309e-03*G4_0_1_0_0_4_1 - 4.166666666666655e-03*G4_0_1_0_0_5_1 - 4.166666666666654e-03*G4_0_1_0_0_6_1 - 4.166666666666656e-03*G4_0_1_0_0_7_1 - 8.333333333333311e-03*G4_0_1_0_1_4_1 - 4.166666666666655e-03*G4_0_1_0_1_5_1 - 4.166666666666656e-03*G4_0_1_0_1_6_1 - 4.166666666666657e-03*G4_0_1_0_1_7_1 - 8.333333333333311e-03*G4_0_1_0_2_4_1 - 4.166666666666655e-03*G4_0_1_0_2_5_1 - 4.166666666666655e-03*G4_0_1_0_2_6_1 - 4.166666666666657e-03*G4_0_1_0_2_7_1 - 4.166666666666654e-03*G4_0_1_1_0_4_1 - 8.333333333333309e-03*G4_0_1_1_0_5_1 - 4.166666666666654e-03*G4_0_1_1_0_6_1 - 4.166666666666655e-03*G4_0_1_1_0_7_1 - 4.166666666666654e-03*G4_0_1_1_1_4_1 - 8.333333333333309e-03*G4_0_1_1_1_5_1 - 4.166666666666654e-03*G4_0_1_1_1_6_1 - 4.166666666666655e-03*G4_0_1_1_1_7_1 - 4.166666666666654e-03*G4_0_1_1_2_4_1 - 8.333333333333309e-03*G4_0_1_1_2_5_1 - 4.166666666666654e-03*G4_0_1_1_2_6_1 - 4.166666666666655e-03*G4_0_1_1_2_7_1 - 4.166666666666654e-03*G4_0_1_2_0_4_1 - 4.166666666666655e-03*G4_0_1_2_0_5_1 - 8.333333333333309e-03*G4_0_1_2_0_6_1 - 4.166666666666655e-03*G4_0_1_2_0_7_1 - 4.166666666666654e-03*G4_0_1_2_1_4_1 - 4.166666666666656e-03*G4_0_1_2_1_5_1 - 8.333333333333311e-03*G4_0_1_2_1_6_1 - 4.166666666666656e-03*G4_0_1_2_1_7_1 - 4.166666666666654e-03*G4_0_1_2_2_4_1 - 4.166666666666654e-03*G4_0_1_2_2_5_1 - 8.333333333333309e-03*G4_0_1_2_2_6_1 - 4.166666666666655e-03*G4_0_1_2_2_7_1 - 4.166666666666656e-03*G4_0_1_3_0_4_1 - 4.166666666666656e-03*G4_0_1_3_0_5_1 - 4.166666666666655e-03*G4_0_1_3_0_6_1 - 8.333333333333311e-03*G4_0_1_3_0_7_1 - 4.166666666666657e-03*G4_0_1_3_1_4_1 - 4.166666666666657e-03*G4_0_1_3_1_5_1 - 4.166666666666656e-03*G4_0_1_3_1_6_1 - 8.333333333333311e-03*G4_0_1_3_1_7_1 - 4.166666666666657e-03*G4_0_1_3_2_4_1 - 4.166666666666656e-03*G4_0_1_3_2_5_1 - 4.166666666666655e-03*G4_0_1_3_2_6_1 - 8.333333333333311e-03*G4_0_1_3_2_7_1 - 8.333333333333309e-03*G4_0_2_0_0_8_1 - 4.166666666666655e-03*G4_0_2_0_0_9_1 - 4.166666666666654e-03*G4_0_2_0_0_10_1 - 4.166666666666656e-03*G4_0_2_0_0_11_1 - 8.333333333333311e-03*G4_0_2_0_1_8_1 - 4.166666666666655e-03*G4_0_2_0_1_9_1 - 4.166666666666656e-03*G4_0_2_0_1_10_1 - 4.166666666666657e-03*G4_0_2_0_1_11_1 - 8.333333333333311e-03*G4_0_2_0_2_8_1 - 4.166666666666655e-03*G4_0_2_0_2_9_1 - 4.166666666666655e-03*G4_0_2_0_2_10_1 - 4.166666666666657e-03*G4_0_2_0_2_11_1 - 4.166666666666654e-03*G4_0_2_1_0_8_1 - 8.333333333333309e-03*G4_0_2_1_0_9_1 - 4.166666666666654e-03*G4_0_2_1_0_10_1 - 4.166666666666655e-03*G4_0_2_1_0_11_1 - 4.166666666666654e-03*G4_0_2_1_1_8_1 - 8.333333333333309e-03*G4_0_2_1_1_9_1 - 4.166666666666654e-03*G4_0_2_1_1_10_1 - 4.166666666666655e-03*G4_0_2_1_1_11_1 - 4.166666666666654e-03*G4_0_2_1_2_8_1 - 8.333333333333309e-03*G4_0_2_1_2_9_1 - 4.166666666666654e-03*G4_0_2_1_2_10_1 - 4.166666666666655e-03*G4_0_2_1_2_11_1 - 4.166666666666654e-03*G4_0_2_2_0_8_1 - 4.166666666666655e-03*G4_0_2_2_0_9_1 - 8.333333333333309e-03*G4_0_2_2_0_10_1 - 4.166666666666655e-03*G4_0_2_2_0_11_1 - 4.166666666666654e-03*G4_0_2_2_1_8_1 - 4.166666666666656e-03*G4_0_2_2_1_9_1 - 8.333333333333311e-03*G4_0_2_2_1_10_1 - 4.166666666666656e-03*G4_0_2_2_1_11_1 - 4.166666666666654e-03*G4_0_2_2_2_8_1 - 4.166666666666654e-03*G4_0_2_2_2_9_1 - 8.333333333333309e-03*G4_0_2_2_2_10_1 - 4.166666666666655e-03*G4_0_2_2_2_11_1 - 4.166666666666656e-03*G4_0_2_3_0_8_1 - 4.166666666666656e-03*G4_0_2_3_0_9_1 - 4.166666666666655e-03*G4_0_2_3_0_10_1 - 8.333333333333311e-03*G4_0_2_3_0_11_1 - 4.166666666666657e-03*G4_0_2_3_1_8_1 - 4.166666666666657e-03*G4_0_2_3_1_9_1 - 4.166666666666656e-03*G4_0_2_3_1_10_1 - 8.333333333333311e-03*G4_0_2_3_1_11_1 - 4.166666666666657e-03*G4_0_2_3_2_8_1 - 4.166666666666656e-03*G4_0_2_3_2_9_1 - 4.166666666666655e-03*G4_0_2_3_2_10_1 - 8.333333333333311e-03*G4_0_2_3_2_11_1 - 8.333333333333309e-03*G4_1_0_4_0_0_1 - 4.166666666666654e-03*G4_1_0_4_0_1_1 - 4.166666666666654e-03*G4_1_0_4_0_2_1 - 4.166666666666656e-03*G4_1_0_4_0_3_1 - 8.333333333333311e-03*G4_1_0_4_1_0_1 - 4.166666666666654e-03*G4_1_0_4_1_1_1 - 4.166666666666654e-03*G4_1_0_4_1_2_1 - 4.166666666666657e-03*G4_1_0_4_1_3_1 - 8.333333333333311e-03*G4_1_0_4_2_0_1 - 4.166666666666654e-03*G4_1_0_4_2_1_1 - 4.166666666666654e-03*G4_1_0_4_2_2_1 - 4.166666666666657e-03*G4_1_0_4_2_3_1 - 4.166666666666655e-03*G4_1_0_5_0_0_1 - 8.333333333333309e-03*G4_1_0_5_0_1_1 - 4.166666666666655e-03*G4_1_0_5_0_2_1 - 4.166666666666656e-03*G4_1_0_5_0_3_1 - 4.166666666666655e-03*G4_1_0_5_1_0_1 - 8.333333333333309e-03*G4_1_0_5_1_1_1 - 4.166666666666656e-03*G4_1_0_5_1_2_1 - 4.166666666666657e-03*G4_1_0_5_1_3_1 - 4.166666666666655e-03*G4_1_0_5_2_0_1 - 8.333333333333309e-03*G4_1_0_5_2_1_1 - 4.166666666666655e-03*G4_1_0_5_2_2_1 - 4.166666666666656e-03*G4_1_0_5_2_3_1 - 4.166666666666654e-03*G4_1_0_6_0_0_1 - 4.166666666666654e-03*G4_1_0_6_0_1_1 - 8.333333333333309e-03*G4_1_0_6_0_2_1 - 4.166666666666655e-03*G4_1_0_6_0_3_1 - 4.166666666666656e-03*G4_1_0_6_1_0_1 - 4.166666666666654e-03*G4_1_0_6_1_1_1 - 8.333333333333311e-03*G4_1_0_6_1_2_1 - 4.166666666666656e-03*G4_1_0_6_1_3_1 - 4.166666666666655e-03*G4_1_0_6_2_0_1 - 4.166666666666654e-03*G4_1_0_6_2_1_1 - 8.333333333333309e-03*G4_1_0_6_2_2_1 - 4.166666666666655e-03*G4_1_0_6_2_3_1 - 4.166666666666656e-03*G4_1_0_7_0_0_1 - 4.166666666666655e-03*G4_1_0_7_0_1_1 - 4.166666666666655e-03*G4_1_0_7_0_2_1 - 8.333333333333311e-03*G4_1_0_7_0_3_1 - 4.166666666666657e-03*G4_1_0_7_1_0_1 - 4.166666666666655e-03*G4_1_0_7_1_1_1 - 4.166666666666656e-03*G4_1_0_7_1_2_1 - 8.333333333333311e-03*G4_1_0_7_1_3_1 - 4.166666666666657e-03*G4_1_0_7_2_0_1 - 4.166666666666655e-03*G4_1_0_7_2_1_1 - 4.166666666666655e-03*G4_1_0_7_2_2_1 - 8.333333333333311e-03*G4_1_0_7_2_3_1 - 8.333333333333309e-03*G4_1_1_4_0_4_1 - 4.166666666666654e-03*G4_1_1_4_0_5_1 - 4.166666666666654e-03*G4_1_1_4_0_6_1 - 4.166666666666656e-03*G4_1_1_4_0_7_1 - 8.333333333333311e-03*G4_1_1_4_1_4_1 - 4.166666666666654e-03*G4_1_1_4_1_5_1 - 4.166666666666654e-03*G4_1_1_4_1_6_1 - 4.166666666666657e-03*G4_1_1_4_1_7_1 - 8.333333333333311e-03*G4_1_1_4_2_4_1 - 4.166666666666654e-03*G4_1_1_4_2_5_1 - 4.166666666666654e-03*G4_1_1_4_2_6_1 - 4.166666666666657e-03*G4_1_1_4_2_7_1 - 4.166666666666654e-03*G4_1_1_5_0_4_1 - 8.333333333333309e-03*G4_1_1_5_0_5_1 - 4.166666666666655e-03*G4_1_1_5_0_6_1 - 4.166666666666656e-03*G4_1_1_5_0_7_1 - 4.166666666666654e-03*G4_1_1_5_1_4_1 - 8.333333333333309e-03*G4_1_1_5_1_5_1 - 4.166666666666656e-03*G4_1_1_5_1_6_1 - 4.166666666666657e-03*G4_1_1_5_1_7_1 - 4.166666666666654e-03*G4_1_1_5_2_4_1 - 8.333333333333309e-03*G4_1_1_5_2_5_1 - 4.166666666666655e-03*G4_1_1_5_2_6_1 - 4.166666666666656e-03*G4_1_1_5_2_7_1 - 4.166666666666654e-03*G4_1_1_6_0_4_1 - 4.166666666666655e-03*G4_1_1_6_0_5_1 - 8.333333333333309e-03*G4_1_1_6_0_6_1 - 4.166666666666655e-03*G4_1_1_6_0_7_1 - 4.166666666666654e-03*G4_1_1_6_1_4_1 - 4.166666666666656e-03*G4_1_1_6_1_5_1 - 8.333333333333311e-03*G4_1_1_6_1_6_1 - 4.166666666666656e-03*G4_1_1_6_1_7_1 - 4.166666666666654e-03*G4_1_1_6_2_4_1 - 4.166666666666654e-03*G4_1_1_6_2_5_1 - 8.333333333333309e-03*G4_1_1_6_2_6_1 - 4.166666666666655e-03*G4_1_1_6_2_7_1 - 4.166666666666656e-03*G4_1_1_7_0_4_1 - 4.166666666666656e-03*G4_1_1_7_0_5_1 - 4.166666666666655e-03*G4_1_1_7_0_6_1 - 8.333333333333311e-03*G4_1_1_7_0_7_1 - 4.166666666666657e-03*G4_1_1_7_1_4_1 - 4.166666666666657e-03*G4_1_1_7_1_5_1 - 4.166666666666656e-03*G4_1_1_7_1_6_1 - 8.333333333333311e-03*G4_1_1_7_1_7_1 - 4.166666666666657e-03*G4_1_1_7_2_4_1 - 4.166666666666656e-03*G4_1_1_7_2_5_1 - 4.166666666666655e-03*G4_1_1_7_2_6_1 - 8.333333333333311e-03*G4_1_1_7_2_7_1 - 8.333333333333309e-03*G4_1_2_4_0_8_1 - 4.166666666666654e-03*G4_1_2_4_0_9_1 - 4.166666666666654e-03*G4_1_2_4_0_10_1 - 4.166666666666656e-03*G4_1_2_4_0_11_1 - 8.333333333333311e-03*G4_1_2_4_1_8_1 - 4.166666666666654e-03*G4_1_2_4_1_9_1 - 4.166666666666654e-03*G4_1_2_4_1_10_1 - 4.166666666666657e-03*G4_1_2_4_1_11_1 - 8.333333333333311e-03*G4_1_2_4_2_8_1 - 4.166666666666654e-03*G4_1_2_4_2_9_1 - 4.166666666666654e-03*G4_1_2_4_2_10_1 - 4.166666666666657e-03*G4_1_2_4_2_11_1 - 4.166666666666654e-03*G4_1_2_5_0_8_1 - 8.333333333333309e-03*G4_1_2_5_0_9_1 - 4.166666666666655e-03*G4_1_2_5_0_10_1 - 4.166666666666656e-03*G4_1_2_5_0_11_1 - 4.166666666666654e-03*G4_1_2_5_1_8_1 - 8.333333333333309e-03*G4_1_2_5_1_9_1 - 4.166666666666656e-03*G4_1_2_5_1_10_1 - 4.166666666666657e-03*G4_1_2_5_1_11_1 - 4.166666666666654e-03*G4_1_2_5_2_8_1 - 8.333333333333309e-03*G4_1_2_5_2_9_1 - 4.166666666666655e-03*G4_1_2_5_2_10_1 - 4.166666666666656e-03*G4_1_2_5_2_11_1 - 4.166666666666654e-03*G4_1_2_6_0_8_1 - 4.166666666666655e-03*G4_1_2_6_0_9_1 - 8.333333333333309e-03*G4_1_2_6_0_10_1 - 4.166666666666655e-03*G4_1_2_6_0_11_1 - 4.166666666666654e-03*G4_1_2_6_1_8_1 - 4.166666666666656e-03*G4_1_2_6_1_9_1 - 8.333333333333311e-03*G4_1_2_6_1_10_1 - 4.166666666666656e-03*G4_1_2_6_1_11_1 - 4.166666666666654e-03*G4_1_2_6_2_8_1 - 4.166666666666654e-03*G4_1_2_6_2_9_1 - 8.333333333333309e-03*G4_1_2_6_2_10_1 - 4.166666666666655e-03*G4_1_2_6_2_11_1 - 4.166666666666656e-03*G4_1_2_7_0_8_1 - 4.166666666666656e-03*G4_1_2_7_0_9_1 - 4.166666666666655e-03*G4_1_2_7_0_10_1 - 8.333333333333311e-03*G4_1_2_7_0_11_1 - 4.166666666666657e-03*G4_1_2_7_1_8_1 - 4.166666666666657e-03*G4_1_2_7_1_9_1 - 4.166666666666656e-03*G4_1_2_7_1_10_1 - 8.333333333333311e-03*G4_1_2_7_1_11_1 - 4.166666666666657e-03*G4_1_2_7_2_8_1 - 4.166666666666656e-03*G4_1_2_7_2_9_1 - 4.166666666666655e-03*G4_1_2_7_2_10_1 - 8.333333333333311e-03*G4_1_2_7_2_11_1 - 8.333333333333309e-03*G4_2_0_8_0_0_1 - 4.166666666666654e-03*G4_2_0_8_0_1_1 - 4.166666666666654e-03*G4_2_0_8_0_2_1 - 4.166666666666656e-03*G4_2_0_8_0_3_1 - 8.333333333333311e-03*G4_2_0_8_1_0_1 - 4.166666666666654e-03*G4_2_0_8_1_1_1 - 4.166666666666654e-03*G4_2_0_8_1_2_1 - 4.166666666666657e-03*G4_2_0_8_1_3_1 - 8.333333333333311e-03*G4_2_0_8_2_0_1 - 4.166666666666654e-03*G4_2_0_8_2_1_1 - 4.166666666666654e-03*G4_2_0_8_2_2_1 - 4.166666666666657e-03*G4_2_0_8_2_3_1 - 4.166666666666655e-03*G4_2_0_9_0_0_1 - 8.333333333333309e-03*G4_2_0_9_0_1_1 - 4.166666666666655e-03*G4_2_0_9_0_2_1 - 4.166666666666656e-03*G4_2_0_9_0_3_1 - 4.166666666666655e-03*G4_2_0_9_1_0_1 - 8.333333333333309e-03*G4_2_0_9_1_1_1 - 4.166666666666656e-03*G4_2_0_9_1_2_1 - 4.166666666666657e-03*G4_2_0_9_1_3_1 - 4.166666666666655e-03*G4_2_0_9_2_0_1 - 8.333333333333309e-03*G4_2_0_9_2_1_1 - 4.166666666666655e-03*G4_2_0_9_2_2_1 - 4.166666666666656e-03*G4_2_0_9_2_3_1 - 4.166666666666654e-03*G4_2_0_10_0_0_1 - 4.166666666666654e-03*G4_2_0_10_0_1_1 - 8.333333333333309e-03*G4_2_0_10_0_2_1 - 4.166666666666655e-03*G4_2_0_10_0_3_1 - 4.166666666666656e-03*G4_2_0_10_1_0_1 - 4.166666666666654e-03*G4_2_0_10_1_1_1 - 8.333333333333311e-03*G4_2_0_10_1_2_1 - 4.166666666666656e-03*G4_2_0_10_1_3_1 - 4.166666666666655e-03*G4_2_0_10_2_0_1 - 4.166666666666654e-03*G4_2_0_10_2_1_1 - 8.333333333333309e-03*G4_2_0_10_2_2_1 - 4.166666666666655e-03*G4_2_0_10_2_3_1 - 4.166666666666656e-03*G4_2_0_11_0_0_1 - 4.166666666666655e-03*G4_2_0_11_0_1_1 - 4.166666666666655e-03*G4_2_0_11_0_2_1 - 8.333333333333311e-03*G4_2_0_11_0_3_1 - 4.166666666666657e-03*G4_2_0_11_1_0_1 - 4.166666666666655e-03*G4_2_0_11_1_1_1 - 4.166666666666656e-03*G4_2_0_11_1_2_1 - 8.333333333333311e-03*G4_2_0_11_1_3_1 - 4.166666666666657e-03*G4_2_0_11_2_0_1 - 4.166666666666655e-03*G4_2_0_11_2_1_1 - 4.166666666666655e-03*G4_2_0_11_2_2_1 - 8.333333333333311e-03*G4_2_0_11_2_3_1 - 8.333333333333309e-03*G4_2_1_8_0_4_1 - 4.166666666666654e-03*G4_2_1_8_0_5_1 - 4.166666666666654e-03*G4_2_1_8_0_6_1 - 4.166666666666656e-03*G4_2_1_8_0_7_1 - 8.333333333333311e-03*G4_2_1_8_1_4_1 - 4.166666666666654e-03*G4_2_1_8_1_5_1 - 4.166666666666654e-03*G4_2_1_8_1_6_1 - 4.166666666666657e-03*G4_2_1_8_1_7_1 - 8.333333333333311e-03*G4_2_1_8_2_4_1 - 4.166666666666654e-03*G4_2_1_8_2_5_1 - 4.166666666666654e-03*G4_2_1_8_2_6_1 - 4.166666666666657e-03*G4_2_1_8_2_7_1 - 4.166666666666654e-03*G4_2_1_9_0_4_1 - 8.333333333333309e-03*G4_2_1_9_0_5_1 - 4.166666666666655e-03*G4_2_1_9_0_6_1 - 4.166666666666656e-03*G4_2_1_9_0_7_1 - 4.166666666666654e-03*G4_2_1_9_1_4_1 - 8.333333333333309e-03*G4_2_1_9_1_5_1 - 4.166666666666656e-03*G4_2_1_9_1_6_1 - 4.166666666666657e-03*G4_2_1_9_1_7_1 - 4.166666666666654e-03*G4_2_1_9_2_4_1 - 8.333333333333309e-03*G4_2_1_9_2_5_1 - 4.166666666666655e-03*G4_2_1_9_2_6_1 - 4.166666666666656e-03*G4_2_1_9_2_7_1 - 4.166666666666654e-03*G4_2_1_10_0_4_1 - 4.166666666666655e-03*G4_2_1_10_0_5_1 - 8.333333333333309e-03*G4_2_1_10_0_6_1 - 4.166666666666655e-03*G4_2_1_10_0_7_1 - 4.166666666666654e-03*G4_2_1_10_1_4_1 - 4.166666666666656e-03*G4_2_1_10_1_5_1 - 8.333333333333311e-03*G4_2_1_10_1_6_1 - 4.166666666666656e-03*G4_2_1_10_1_7_1 - 4.166666666666654e-03*G4_2_1_10_2_4_1 - 4.166666666666654e-03*G4_2_1_10_2_5_1 - 8.333333333333309e-03*G4_2_1_10_2_6_1 - 4.166666666666655e-03*G4_2_1_10_2_7_1 - 4.166666666666656e-03*G4_2_1_11_0_4_1 - 4.166666666666656e-03*G4_2_1_11_0_5_1 - 4.166666666666655e-03*G4_2_1_11_0_6_1 - 8.333333333333311e-03*G4_2_1_11_0_7_1 - 4.166666666666657e-03*G4_2_1_11_1_4_1 - 4.166666666666657e-03*G4_2_1_11_1_5_1 - 4.166666666666656e-03*G4_2_1_11_1_6_1 - 8.333333333333311e-03*G4_2_1_11_1_7_1 - 4.166666666666657e-03*G4_2_1_11_2_4_1 - 4.166666666666656e-03*G4_2_1_11_2_5_1 - 4.166666666666655e-03*G4_2_1_11_2_6_1 - 8.333333333333311e-03*G4_2_1_11_2_7_1 - 8.333333333333309e-03*G4_2_2_8_0_8_1 - 4.166666666666654e-03*G4_2_2_8_0_9_1 - 4.166666666666654e-03*G4_2_2_8_0_10_1 - 4.166666666666656e-03*G4_2_2_8_0_11_1 - 8.333333333333311e-03*G4_2_2_8_1_8_1 - 4.166666666666654e-03*G4_2_2_8_1_9_1 - 4.166666666666654e-03*G4_2_2_8_1_10_1 - 4.166666666666657e-03*G4_2_2_8_1_11_1 - 8.333333333333311e-03*G4_2_2_8_2_8_1 - 4.166666666666654e-03*G4_2_2_8_2_9_1 - 4.166666666666654e-03*G4_2_2_8_2_10_1 - 4.166666666666657e-03*G4_2_2_8_2_11_1 - 4.166666666666654e-03*G4_2_2_9_0_8_1 - 8.333333333333309e-03*G4_2_2_9_0_9_1 - 4.166666666666655e-03*G4_2_2_9_0_10_1 - 4.166666666666656e-03*G4_2_2_9_0_11_1 - 4.166666666666654e-03*G4_2_2_9_1_8_1 - 8.333333333333309e-03*G4_2_2_9_1_9_1 - 4.166666666666656e-03*G4_2_2_9_1_10_1 - 4.166666666666657e-03*G4_2_2_9_1_11_1 - 4.166666666666654e-03*G4_2_2_9_2_8_1 - 8.333333333333309e-03*G4_2_2_9_2_9_1 - 4.166666666666655e-03*G4_2_2_9_2_10_1 - 4.166666666666656e-03*G4_2_2_9_2_11_1 - 4.166666666666654e-03*G4_2_2_10_0_8_1 - 4.166666666666655e-03*G4_2_2_10_0_9_1 - 8.333333333333309e-03*G4_2_2_10_0_10_1 - 4.166666666666655e-03*G4_2_2_10_0_11_1 - 4.166666666666654e-03*G4_2_2_10_1_8_1 - 4.166666666666656e-03*G4_2_2_10_1_9_1 - 8.333333333333311e-03*G4_2_2_10_1_10_1 - 4.166666666666656e-03*G4_2_2_10_1_11_1 - 4.166666666666654e-03*G4_2_2_10_2_8_1 - 4.166666666666654e-03*G4_2_2_10_2_9_1 - 8.333333333333309e-03*G4_2_2_10_2_10_1 - 4.166666666666655e-03*G4_2_2_10_2_11_1 - 4.166666666666656e-03*G4_2_2_11_0_8_1 - 4.166666666666656e-03*G4_2_2_11_0_9_1 - 4.166666666666655e-03*G4_2_2_11_0_10_1 - 8.333333333333311e-03*G4_2_2_11_0_11_1 - 4.166666666666657e-03*G4_2_2_11_1_8_1 - 4.166666666666657e-03*G4_2_2_11_1_9_1 - 4.166666666666656e-03*G4_2_2_11_1_10_1 - 8.333333333333311e-03*G4_2_2_11_1_11_1 - 4.166666666666657e-03*G4_2_2_11_2_8_1 - 4.166666666666656e-03*G4_2_2_11_2_9_1 - 4.166666666666655e-03*G4_2_2_11_2_10_1 - 8.333333333333311e-03*G4_2_2_11_2_11_1;
    block[3] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_0_2 - 8.333333333333323e-02*G1_1_2 - 8.333333333333322e-02*G1_2_2 + 8.333333333333311e-03*G2_0_0_2 + 4.166666666666655e-03*G2_0_1_2 + 4.166666666666656e-03*G2_0_2_2 + 4.166666666666657e-03*G2_0_3_2 + 8.333333333333311e-03*G2_1_4_2 + 4.166666666666655e-03*G2_1_5_2 + 4.166666666666656e-03*G2_1_6_2 + 4.166666666666657e-03*G2_1_7_2 + 8.333333333333311e-03*G2_2_8_2 + 4.166666666666655e-03*G2_2_9_2 + 4.166666666666656e-03*G2_2_10_2 + 4.166666666666657e-03*G2_2_11_2 - 8.333333333333322e-02*G3_0_0_0_2 - 8.333333333333323e-02*G3_0_0_1_2 - 8.333333333333322e-02*G3_0_0_2_2 - 8.333333333333309e-03*G4_0_0_0_0_0_2 - 4.166666666666654e-03*G4_0_0_0_0_1_2 - 4.166666666666654e-03*G4_0_0_0_0_2_2 - 4.166666666666656e-03*G4_0_0_0_0_3_2 - 8.333333333333311e-03*G4_0_0_0_1_0_2 - 4.166666666666655e-03*G4_0_0_0_1_1_2 - 4.166666666666656e-03*G4_0_0_0_1_2_2 - 4.166666666666657e-03*G4_0_0_0_1_3_2 - 8.333333333333311e-03*G4_0_0_0_2_0_2 - 4.166666666666654e-03*G4_0_0_0_2_1_2 - 4.166666666666655e-03*G4_0_0_0_2_2_2 - 4.166666666666657e-03*G4_0_0_0_2_3_2 - 4.166666666666654e-03*G4_0_0_1_0_0_2 - 8.333333333333307e-03*G4_0_0_1_0_1_2 - 4.166666666666654e-03*G4_0_0_1_0_2_2 - 4.166666666666655e-03*G4_0_0_1_0_3_2 - 4.166666666666655e-03*G4_0_0_1_1_0_2 - 8.333333333333309e-03*G4_0_0_1_1_1_2 - 4.166666666666654e-03*G4_0_0_1_1_2_2 - 4.166666666666655e-03*G4_0_0_1_1_3_2 - 4.166666666666654e-03*G4_0_0_1_2_0_2 - 8.333333333333307e-03*G4_0_0_1_2_1_2 - 4.166666666666654e-03*G4_0_0_1_2_2_2 - 4.166666666666655e-03*G4_0_0_1_2_3_2 - 4.166666666666654e-03*G4_0_0_2_0_0_2 - 4.166666666666654e-03*G4_0_0_2_0_1_2 - 8.333333333333309e-03*G4_0_0_2_0_2_2 - 4.166666666666655e-03*G4_0_0_2_0_3_2 - 4.166666666666656e-03*G4_0_0_2_1_0_2 - 4.166666666666654e-03*G4_0_0_2_1_1_2 - 8.333333333333311e-03*G4_0_0_2_1_2_2 - 4.166666666666656e-03*G4_0_0_2_1_3_2 - 4.166666666666655e-03*G4_0_0_2_2_0_2 - 4.166666666666654e-03*G4_0_0_2_2_1_2 - 8.333333333333309e-03*G4_0_0_2_2_2_2 - 4.166666666666655e-03*G4_0_0_2_2_3_2 - 4.166666666666656e-03*G4_0_0_3_0_0_2 - 4.166666666666655e-03*G4_0_0_3_0_1_2 - 4.166666666666655e-03*G4_0_0_3_0_2_2 - 8.333333333333311e-03*G4_0_0_3_0_3_2 - 4.166666666666657e-03*G4_0_0_3_1_0_2 - 4.166666666666655e-03*G4_0_0_3_1_1_2 - 4.166666666666656e-03*G4_0_0_3_1_2_2 - 8.333333333333311e-03*G4_0_0_3_1_3_2 - 4.166666666666657e-03*G4_0_0_3_2_0_2 - 4.166666666666655e-03*G4_0_0_3_2_1_2 - 4.166666666666655e-03*G4_0_0_3_2_2_2 - 8.333333333333311e-03*G4_0_0_3_2_3_2 - 8.333333333333309e-03*G4_0_1_0_0_4_2 - 4.166666666666655e-03*G4_0_1_0_0_5_2 - 4.166666666666654e-03*G4_0_1_0_0_6_2 - 4.166666666666656e-03*G4_0_1_0_0_7_2 - 8.333333333333311e-03*G4_0_1_0_1_4_2 - 4.166666666666655e-03*G4_0_1_0_1_5_2 - 4.166666666666656e-03*G4_0_1_0_1_6_2 - 4.166666666666657e-03*G4_0_1_0_1_7_2 - 8.333333333333311e-03*G4_0_1_0_2_4_2 - 4.166666666666655e-03*G4_0_1_0_2_5_2 - 4.166666666666655e-03*G4_0_1_0_2_6_2 - 4.166666666666657e-03*G4_0_1_0_2_7_2 - 4.166666666666654e-03*G4_0_1_1_0_4_2 - 8.333333333333309e-03*G4_0_1_1_0_5_2 - 4.166666666666654e-03*G4_0_1_1_0_6_2 - 4.166666666666655e-03*G4_0_1_1_0_7_2 - 4.166666666666654e-03*G4_0_1_1_1_4_2 - 8.333333333333309e-03*G4_0_1_1_1_5_2 - 4.166666666666654e-03*G4_0_1_1_1_6_2 - 4.166666666666655e-03*G4_0_1_1_1_7_2 - 4.166666666666654e-03*G4_0_1_1_2_4_2 - 8.333333333333309e-03*G4_0_1_1_2_5_2 - 4.166666666666654e-03*G4_0_1_1_2_6_2 - 4.166666666666655e-03*G4_0_1_1_2_7_2 - 4.166666666666654e-03*G4_0_1_2_0_4_2 - 4.166666666666655e-03*G4_0_1_2_0_5_2 - 8.333333333333309e-03*G4_0_1_2_0_6_2 - 4.166666666666655e-03*G4_0_1_2_0_7_2 - 4.166666666666654e-03*G4_0_1_2_1_4_2 - 4.166666666666656e-03*G4_0_1_2_1_5_2 - 8.333333333333311e-03*G4_0_1_2_1_6_2 - 4.166666666666656e-03*G4_0_1_2_1_7_2 - 4.166666666666654e-03*G4_0_1_2_2_4_2 - 4.166666666666654e-03*G4_0_1_2_2_5_2 - 8.333333333333309e-03*G4_0_1_2_2_6_2 - 4.166666666666655e-03*G4_0_1_2_2_7_2 - 4.166666666666656e-03*G4_0_1_3_0_4_2 - 4.166666666666656e-03*G4_0_1_3_0_5_2 - 4.166666666666655e-03*G4_0_1_3_0_6_2 - 8.333333333333311e-03*G4_0_1_3_0_7_2 - 4.166666666666657e-03*G4_0_1_3_1_4_2 - 4.166666666666657e-03*G4_0_1_3_1_5_2 - 4.166666666666656e-03*G4_0_1_3_1_6_2 - 8.333333333333311e-03*G4_0_1_3_1_7_2 - 4.166666666666657e-03*G4_0_1_3_2_4_2 - 4.166666666666656e-03*G4_0_1_3_2_5_2 - 4.166666666666655e-03*G4_0_1_3_2_6_2 - 8.333333333333311e-03*G4_0_1_3_2_7_2 - 8.333333333333309e-03*G4_0_2_0_0_8_2 - 4.166666666666655e-03*G4_0_2_0_0_9_2 - 4.166666666666654e-03*G4_0_2_0_0_10_2 - 4.166666666666656e-03*G4_0_2_0_0_11_2 - 8.333333333333311e-03*G4_0_2_0_1_8_2 - 4.166666666666655e-03*G4_0_2_0_1_9_2 - 4.166666666666656e-03*G4_0_2_0_1_10_2 - 4.166666666666657e-03*G4_0_2_0_1_11_2 - 8.333333333333311e-03*G4_0_2_0_2_8_2 - 4.166666666666655e-03*G4_0_2_0_2_9_2 - 4.166666666666655e-03*G4_0_2_0_2_10_2 - 4.166666666666657e-03*G4_0_2_0_2_11_2 - 4.166666666666654e-03*G4_0_2_1_0_8_2 - 8.333333333333309e-03*G4_0_2_1_0_9_2 - 4.166666666666654e-03*G4_0_2_1_0_10_2 - 4.166666666666655e-03*G4_0_2_1_0_11_2 - 4.166666666666654e-03*G4_0_2_1_1_8_2 - 8.333333333333309e-03*G4_0_2_1_1_9_2 - 4.166666666666654e-03*G4_0_2_1_1_10_2 - 4.166666666666655e-03*G4_0_2_1_1_11_2 - 4.166666666666654e-03*G4_0_2_1_2_8_2 - 8.333333333333309e-03*G4_0_2_1_2_9_2 - 4.166666666666654e-03*G4_0_2_1_2_10_2 - 4.166666666666655e-03*G4_0_2_1_2_11_2 - 4.166666666666654e-03*G4_0_2_2_0_8_2 - 4.166666666666655e-03*G4_0_2_2_0_9_2 - 8.333333333333309e-03*G4_0_2_2_0_10_2 - 4.166666666666655e-03*G4_0_2_2_0_11_2 - 4.166666666666654e-03*G4_0_2_2_1_8_2 - 4.166666666666656e-03*G4_0_2_2_1_9_2 - 8.333333333333311e-03*G4_0_2_2_1_10_2 - 4.166666666666656e-03*G4_0_2_2_1_11_2 - 4.166666666666654e-03*G4_0_2_2_2_8_2 - 4.166666666666654e-03*G4_0_2_2_2_9_2 - 8.333333333333309e-03*G4_0_2_2_2_10_2 - 4.166666666666655e-03*G4_0_2_2_2_11_2 - 4.166666666666656e-03*G4_0_2_3_0_8_2 - 4.166666666666656e-03*G4_0_2_3_0_9_2 - 4.166666666666655e-03*G4_0_2_3_0_10_2 - 8.333333333333311e-03*G4_0_2_3_0_11_2 - 4.166666666666657e-03*G4_0_2_3_1_8_2 - 4.166666666666657e-03*G4_0_2_3_1_9_2 - 4.166666666666656e-03*G4_0_2_3_1_10_2 - 8.333333333333311e-03*G4_0_2_3_1_11_2 - 4.166666666666657e-03*G4_0_2_3_2_8_2 - 4.166666666666656e-03*G4_0_2_3_2_9_2 - 4.166666666666655e-03*G4_0_2_3_2_10_2 - 8.333333333333311e-03*G4_0_2_3_2_11_2 - 8.333333333333309e-03*G4_1_0_4_0_0_2 - 4.166666666666654e-03*G4_1_0_4_0_1_2 - 4.166666666666654e-03*G4_1_0_4_0_2_2 - 4.166666666666656e-03*G4_1_0_4_0_3_2 - 8.333333333333311e-03*G4_1_0_4_1_0_2 - 4.166666666666654e-03*G4_1_0_4_1_1_2 - 4.166666666666654e-03*G4_1_0_4_1_2_2 - 4.166666666666657e-03*G4_1_0_4_1_3_2 - 8.333333333333311e-03*G4_1_0_4_2_0_2 - 4.166666666666654e-03*G4_1_0_4_2_1_2 - 4.166666666666654e-03*G4_1_0_4_2_2_2 - 4.166666666666657e-03*G4_1_0_4_2_3_2 - 4.166666666666655e-03*G4_1_0_5_0_0_2 - 8.333333333333309e-03*G4_1_0_5_0_1_2 - 4.166666666666655e-03*G4_1_0_5_0_2_2 - 4.166666666666656e-03*G4_1_0_5_0_3_2 - 4.166666666666655e-03*G4_1_0_5_1_0_2 - 8.333333333333309e-03*G4_1_0_5_1_1_2 - 4.166666666666656e-03*G4_1_0_5_1_2_2 - 4.166666666666657e-03*G4_1_0_5_1_3_2 - 4.166666666666655e-03*G4_1_0_5_2_0_2 - 8.333333333333309e-03*G4_1_0_5_2_1_2 - 4.166666666666655e-03*G4_1_0_5_2_2_2 - 4.166666666666656e-03*G4_1_0_5_2_3_2 - 4.166666666666654e-03*G4_1_0_6_0_0_2 - 4.166666666666654e-03*G4_1_0_6_0_1_2 - 8.333333333333309e-03*G4_1_0_6_0_2_2 - 4.166666666666655e-03*G4_1_0_6_0_3_2 - 4.166666666666656e-03*G4_1_0_6_1_0_2 - 4.166666666666654e-03*G4_1_0_6_1_1_2 - 8.333333333333311e-03*G4_1_0_6_1_2_2 - 4.166666666666656e-03*G4_1_0_6_1_3_2 - 4.166666666666655e-03*G4_1_0_6_2_0_2 - 4.166666666666654e-03*G4_1_0_6_2_1_2 - 8.333333333333309e-03*G4_1_0_6_2_2_2 - 4.166666666666655e-03*G4_1_0_6_2_3_2 - 4.166666666666656e-03*G4_1_0_7_0_0_2 - 4.166666666666655e-03*G4_1_0_7_0_1_2 - 4.166666666666655e-03*G4_1_0_7_0_2_2 - 8.333333333333311e-03*G4_1_0_7_0_3_2 - 4.166666666666657e-03*G4_1_0_7_1_0_2 - 4.166666666666655e-03*G4_1_0_7_1_1_2 - 4.166666666666656e-03*G4_1_0_7_1_2_2 - 8.333333333333311e-03*G4_1_0_7_1_3_2 - 4.166666666666657e-03*G4_1_0_7_2_0_2 - 4.166666666666655e-03*G4_1_0_7_2_1_2 - 4.166666666666655e-03*G4_1_0_7_2_2_2 - 8.333333333333311e-03*G4_1_0_7_2_3_2 - 8.333333333333309e-03*G4_1_1_4_0_4_2 - 4.166666666666654e-03*G4_1_1_4_0_5_2 - 4.166666666666654e-03*G4_1_1_4_0_6_2 - 4.166666666666656e-03*G4_1_1_4_0_7_2 - 8.333333333333311e-03*G4_1_1_4_1_4_2 - 4.166666666666654e-03*G4_1_1_4_1_5_2 - 4.166666666666654e-03*G4_1_1_4_1_6_2 - 4.166666666666657e-03*G4_1_1_4_1_7_2 - 8.333333333333311e-03*G4_1_1_4_2_4_2 - 4.166666666666654e-03*G4_1_1_4_2_5_2 - 4.166666666666654e-03*G4_1_1_4_2_6_2 - 4.166666666666657e-03*G4_1_1_4_2_7_2 - 4.166666666666654e-03*G4_1_1_5_0_4_2 - 8.333333333333309e-03*G4_1_1_5_0_5_2 - 4.166666666666655e-03*G4_1_1_5_0_6_2 - 4.166666666666656e-03*G4_1_1_5_0_7_2 - 4.166666666666654e-03*G4_1_1_5_1_4_2 - 8.333333333333309e-03*G4_1_1_5_1_5_2 - 4.166666666666656e-03*G4_1_1_5_1_6_2 - 4.166666666666657e-03*G4_1_1_5_1_7_2 - 4.166666666666654e-03*G4_1_1_5_2_4_2 - 8.333333333333309e-03*G4_1_1_5_2_5_2 - 4.166666666666655e-03*G4_1_1_5_2_6_2 - 4.166666666666656e-03*G4_1_1_5_2_7_2 - 4.166666666666654e-03*G4_1_1_6_0_4_2 - 4.166666666666655e-03*G4_1_1_6_0_5_2 - 8.333333333333309e-03*G4_1_1_6_0_6_2 - 4.166666666666655e-03*G4_1_1_6_0_7_2 - 4.166666666666654e-03*G4_1_1_6_1_4_2 - 4.166666666666656e-03*G4_1_1_6_1_5_2 - 8.333333333333311e-03*G4_1_1_6_1_6_2 - 4.166666666666656e-03*G4_1_1_6_1_7_2 - 4.166666666666654e-03*G4_1_1_6_2_4_2 - 4.166666666666654e-03*G4_1_1_6_2_5_2 - 8.333333333333309e-03*G4_1_1_6_2_6_2 - 4.166666666666655e-03*G4_1_1_6_2_7_2 - 4.166666666666656e-03*G4_1_1_7_0_4_2 - 4.166666666666656e-03*G4_1_1_7_0_5_2 - 4.166666666666655e-03*G4_1_1_7_0_6_2 - 8.333333333333311e-03*G4_1_1_7_0_7_2 - 4.166666666666657e-03*G4_1_1_7_1_4_2 - 4.166666666666657e-03*G4_1_1_7_1_5_2 - 4.166666666666656e-03*G4_1_1_7_1_6_2 - 8.333333333333311e-03*G4_1_1_7_1_7_2 - 4.166666666666657e-03*G4_1_1_7_2_4_2 - 4.166666666666656e-03*G4_1_1_7_2_5_2 - 4.166666666666655e-03*G4_1_1_7_2_6_2 - 8.333333333333311e-03*G4_1_1_7_2_7_2 - 8.333333333333309e-03*G4_1_2_4_0_8_2 - 4.166666666666654e-03*G4_1_2_4_0_9_2 - 4.166666666666654e-03*G4_1_2_4_0_10_2 - 4.166666666666656e-03*G4_1_2_4_0_11_2 - 8.333333333333311e-03*G4_1_2_4_1_8_2 - 4.166666666666654e-03*G4_1_2_4_1_9_2 - 4.166666666666654e-03*G4_1_2_4_1_10_2 - 4.166666666666657e-03*G4_1_2_4_1_11_2 - 8.333333333333311e-03*G4_1_2_4_2_8_2 - 4.166666666666654e-03*G4_1_2_4_2_9_2 - 4.166666666666654e-03*G4_1_2_4_2_10_2 - 4.166666666666657e-03*G4_1_2_4_2_11_2 - 4.166666666666654e-03*G4_1_2_5_0_8_2 - 8.333333333333309e-03*G4_1_2_5_0_9_2 - 4.166666666666655e-03*G4_1_2_5_0_10_2 - 4.166666666666656e-03*G4_1_2_5_0_11_2 - 4.166666666666654e-03*G4_1_2_5_1_8_2 - 8.333333333333309e-03*G4_1_2_5_1_9_2 - 4.166666666666656e-03*G4_1_2_5_1_10_2 - 4.166666666666657e-03*G4_1_2_5_1_11_2 - 4.166666666666654e-03*G4_1_2_5_2_8_2 - 8.333333333333309e-03*G4_1_2_5_2_9_2 - 4.166666666666655e-03*G4_1_2_5_2_10_2 - 4.166666666666656e-03*G4_1_2_5_2_11_2 - 4.166666666666654e-03*G4_1_2_6_0_8_2 - 4.166666666666655e-03*G4_1_2_6_0_9_2 - 8.333333333333309e-03*G4_1_2_6_0_10_2 - 4.166666666666655e-03*G4_1_2_6_0_11_2 - 4.166666666666654e-03*G4_1_2_6_1_8_2 - 4.166666666666656e-03*G4_1_2_6_1_9_2 - 8.333333333333311e-03*G4_1_2_6_1_10_2 - 4.166666666666656e-03*G4_1_2_6_1_11_2 - 4.166666666666654e-03*G4_1_2_6_2_8_2 - 4.166666666666654e-03*G4_1_2_6_2_9_2 - 8.333333333333309e-03*G4_1_2_6_2_10_2 - 4.166666666666655e-03*G4_1_2_6_2_11_2 - 4.166666666666656e-03*G4_1_2_7_0_8_2 - 4.166666666666656e-03*G4_1_2_7_0_9_2 - 4.166666666666655e-03*G4_1_2_7_0_10_2 - 8.333333333333311e-03*G4_1_2_7_0_11_2 - 4.166666666666657e-03*G4_1_2_7_1_8_2 - 4.166666666666657e-03*G4_1_2_7_1_9_2 - 4.166666666666656e-03*G4_1_2_7_1_10_2 - 8.333333333333311e-03*G4_1_2_7_1_11_2 - 4.166666666666657e-03*G4_1_2_7_2_8_2 - 4.166666666666656e-03*G4_1_2_7_2_9_2 - 4.166666666666655e-03*G4_1_2_7_2_10_2 - 8.333333333333311e-03*G4_1_2_7_2_11_2 - 8.333333333333309e-03*G4_2_0_8_0_0_2 - 4.166666666666654e-03*G4_2_0_8_0_1_2 - 4.166666666666654e-03*G4_2_0_8_0_2_2 - 4.166666666666656e-03*G4_2_0_8_0_3_2 - 8.333333333333311e-03*G4_2_0_8_1_0_2 - 4.166666666666654e-03*G4_2_0_8_1_1_2 - 4.166666666666654e-03*G4_2_0_8_1_2_2 - 4.166666666666657e-03*G4_2_0_8_1_3_2 - 8.333333333333311e-03*G4_2_0_8_2_0_2 - 4.166666666666654e-03*G4_2_0_8_2_1_2 - 4.166666666666654e-03*G4_2_0_8_2_2_2 - 4.166666666666657e-03*G4_2_0_8_2_3_2 - 4.166666666666655e-03*G4_2_0_9_0_0_2 - 8.333333333333309e-03*G4_2_0_9_0_1_2 - 4.166666666666655e-03*G4_2_0_9_0_2_2 - 4.166666666666656e-03*G4_2_0_9_0_3_2 - 4.166666666666655e-03*G4_2_0_9_1_0_2 - 8.333333333333309e-03*G4_2_0_9_1_1_2 - 4.166666666666656e-03*G4_2_0_9_1_2_2 - 4.166666666666657e-03*G4_2_0_9_1_3_2 - 4.166666666666655e-03*G4_2_0_9_2_0_2 - 8.333333333333309e-03*G4_2_0_9_2_1_2 - 4.166666666666655e-03*G4_2_0_9_2_2_2 - 4.166666666666656e-03*G4_2_0_9_2_3_2 - 4.166666666666654e-03*G4_2_0_10_0_0_2 - 4.166666666666654e-03*G4_2_0_10_0_1_2 - 8.333333333333309e-03*G4_2_0_10_0_2_2 - 4.166666666666655e-03*G4_2_0_10_0_3_2 - 4.166666666666656e-03*G4_2_0_10_1_0_2 - 4.166666666666654e-03*G4_2_0_10_1_1_2 - 8.333333333333311e-03*G4_2_0_10_1_2_2 - 4.166666666666656e-03*G4_2_0_10_1_3_2 - 4.166666666666655e-03*G4_2_0_10_2_0_2 - 4.166666666666654e-03*G4_2_0_10_2_1_2 - 8.333333333333309e-03*G4_2_0_10_2_2_2 - 4.166666666666655e-03*G4_2_0_10_2_3_2 - 4.166666666666656e-03*G4_2_0_11_0_0_2 - 4.166666666666655e-03*G4_2_0_11_0_1_2 - 4.166666666666655e-03*G4_2_0_11_0_2_2 - 8.333333333333311e-03*G4_2_0_11_0_3_2 - 4.166666666666657e-03*G4_2_0_11_1_0_2 - 4.166666666666655e-03*G4_2_0_11_1_1_2 - 4.166666666666656e-03*G4_2_0_11_1_2_2 - 8.333333333333311e-03*G4_2_0_11_1_3_2 - 4.166666666666657e-03*G4_2_0_11_2_0_2 - 4.166666666666655e-03*G4_2_0_11_2_1_2 - 4.166666666666655e-03*G4_2_0_11_2_2_2 - 8.333333333333311e-03*G4_2_0_11_2_3_2 - 8.333333333333309e-03*G4_2_1_8_0_4_2 - 4.166666666666654e-03*G4_2_1_8_0_5_2 - 4.166666666666654e-03*G4_2_1_8_0_6_2 - 4.166666666666656e-03*G4_2_1_8_0_7_2 - 8.333333333333311e-03*G4_2_1_8_1_4_2 - 4.166666666666654e-03*G4_2_1_8_1_5_2 - 4.166666666666654e-03*G4_2_1_8_1_6_2 - 4.166666666666657e-03*G4_2_1_8_1_7_2 - 8.333333333333311e-03*G4_2_1_8_2_4_2 - 4.166666666666654e-03*G4_2_1_8_2_5_2 - 4.166666666666654e-03*G4_2_1_8_2_6_2 - 4.166666666666657e-03*G4_2_1_8_2_7_2 - 4.166666666666654e-03*G4_2_1_9_0_4_2 - 8.333333333333309e-03*G4_2_1_9_0_5_2 - 4.166666666666655e-03*G4_2_1_9_0_6_2 - 4.166666666666656e-03*G4_2_1_9_0_7_2 - 4.166666666666654e-03*G4_2_1_9_1_4_2 - 8.333333333333309e-03*G4_2_1_9_1_5_2 - 4.166666666666656e-03*G4_2_1_9_1_6_2 - 4.166666666666657e-03*G4_2_1_9_1_7_2 - 4.166666666666654e-03*G4_2_1_9_2_4_2 - 8.333333333333309e-03*G4_2_1_9_2_5_2 - 4.166666666666655e-03*G4_2_1_9_2_6_2 - 4.166666666666656e-03*G4_2_1_9_2_7_2 - 4.166666666666654e-03*G4_2_1_10_0_4_2 - 4.166666666666655e-03*G4_2_1_10_0_5_2 - 8.333333333333309e-03*G4_2_1_10_0_6_2 - 4.166666666666655e-03*G4_2_1_10_0_7_2 - 4.166666666666654e-03*G4_2_1_10_1_4_2 - 4.166666666666656e-03*G4_2_1_10_1_5_2 - 8.333333333333311e-03*G4_2_1_10_1_6_2 - 4.166666666666656e-03*G4_2_1_10_1_7_2 - 4.166666666666654e-03*G4_2_1_10_2_4_2 - 4.166666666666654e-03*G4_2_1_10_2_5_2 - 8.333333333333309e-03*G4_2_1_10_2_6_2 - 4.166666666666655e-03*G4_2_1_10_2_7_2 - 4.166666666666656e-03*G4_2_1_11_0_4_2 - 4.166666666666656e-03*G4_2_1_11_0_5_2 - 4.166666666666655e-03*G4_2_1_11_0_6_2 - 8.333333333333311e-03*G4_2_1_11_0_7_2 - 4.166666666666657e-03*G4_2_1_11_1_4_2 - 4.166666666666657e-03*G4_2_1_11_1_5_2 - 4.166666666666656e-03*G4_2_1_11_1_6_2 - 8.333333333333311e-03*G4_2_1_11_1_7_2 - 4.166666666666657e-03*G4_2_1_11_2_4_2 - 4.166666666666656e-03*G4_2_1_11_2_5_2 - 4.166666666666655e-03*G4_2_1_11_2_6_2 - 8.333333333333311e-03*G4_2_1_11_2_7_2 - 8.333333333333309e-03*G4_2_2_8_0_8_2 - 4.166666666666654e-03*G4_2_2_8_0_9_2 - 4.166666666666654e-03*G4_2_2_8_0_10_2 - 4.166666666666656e-03*G4_2_2_8_0_11_2 - 8.333333333333311e-03*G4_2_2_8_1_8_2 - 4.166666666666654e-03*G4_2_2_8_1_9_2 - 4.166666666666654e-03*G4_2_2_8_1_10_2 - 4.166666666666657e-03*G4_2_2_8_1_11_2 - 8.333333333333311e-03*G4_2_2_8_2_8_2 - 4.166666666666654e-03*G4_2_2_8_2_9_2 - 4.166666666666654e-03*G4_2_2_8_2_10_2 - 4.166666666666657e-03*G4_2_2_8_2_11_2 - 4.166666666666654e-03*G4_2_2_9_0_8_2 - 8.333333333333309e-03*G4_2_2_9_0_9_2 - 4.166666666666655e-03*G4_2_2_9_0_10_2 - 4.166666666666656e-03*G4_2_2_9_0_11_2 - 4.166666666666654e-03*G4_2_2_9_1_8_2 - 8.333333333333309e-03*G4_2_2_9_1_9_2 - 4.166666666666656e-03*G4_2_2_9_1_10_2 - 4.166666666666657e-03*G4_2_2_9_1_11_2 - 4.166666666666654e-03*G4_2_2_9_2_8_2 - 8.333333333333309e-03*G4_2_2_9_2_9_2 - 4.166666666666655e-03*G4_2_2_9_2_10_2 - 4.166666666666656e-03*G4_2_2_9_2_11_2 - 4.166666666666654e-03*G4_2_2_10_0_8_2 - 4.166666666666655e-03*G4_2_2_10_0_9_2 - 8.333333333333309e-03*G4_2_2_10_0_10_2 - 4.166666666666655e-03*G4_2_2_10_0_11_2 - 4.166666666666654e-03*G4_2_2_10_1_8_2 - 4.166666666666656e-03*G4_2_2_10_1_9_2 - 8.333333333333311e-03*G4_2_2_10_1_10_2 - 4.166666666666656e-03*G4_2_2_10_1_11_2 - 4.166666666666654e-03*G4_2_2_10_2_8_2 - 4.166666666666654e-03*G4_2_2_10_2_9_2 - 8.333333333333309e-03*G4_2_2_10_2_10_2 - 4.166666666666655e-03*G4_2_2_10_2_11_2 - 4.166666666666656e-03*G4_2_2_11_0_8_2 - 4.166666666666656e-03*G4_2_2_11_0_9_2 - 4.166666666666655e-03*G4_2_2_11_0_10_2 - 8.333333333333311e-03*G4_2_2_11_0_11_2 - 4.166666666666657e-03*G4_2_2_11_1_8_2 - 4.166666666666657e-03*G4_2_2_11_1_9_2 - 4.166666666666656e-03*G4_2_2_11_1_10_2 - 8.333333333333311e-03*G4_2_2_11_1_11_2 - 4.166666666666657e-03*G4_2_2_11_2_8_2 - 4.166666666666656e-03*G4_2_2_11_2_9_2 - 4.166666666666655e-03*G4_2_2_11_2_10_2 - 8.333333333333311e-03*G4_2_2_11_2_11_2;
    block[4] = 8.333333333333320e-02*G3_0_1_0_0 + 8.333333333333322e-02*G3_0_1_0_1 + 8.333333333333322e-02*G3_0_1_0_2 + 8.333333333333322e-02*G3_0_1_1_0 + 8.333333333333323e-02*G3_0_1_1_1 + 8.333333333333323e-02*G3_0_1_1_2 + 8.333333333333320e-02*G3_0_1_2_0 + 8.333333333333322e-02*G3_0_1_2_1 + 8.333333333333322e-02*G3_0_1_2_2;
    block[5] = -8.333333333333320e-02*G3_0_1_0_0 - 8.333333333333322e-02*G3_0_1_1_0 - 8.333333333333320e-02*G3_0_1_2_0;
    block[6] = -8.333333333333322e-02*G3_0_1_0_1 - 8.333333333333323e-02*G3_0_1_1_1 - 8.333333333333322e-02*G3_0_1_2_1;
    block[7] = -8.333333333333322e-02*G3_0_1_0_2 - 8.333333333333323e-02*G3_0_1_1_2 - 8.333333333333322e-02*G3_0_1_2_2;
    block[8] = 8.333333333333320e-02*G3_0_2_0_0 + 8.333333333333322e-02*G3_0_2_0_1 + 8.333333333333322e-02*G3_0_2_0_2 + 8.333333333333322e-02*G3_0_2_1_0 + 8.333333333333323e-02*G3_0_2_1_1 + 8.333333333333323e-02*G3_0_2_1_2 + 8.333333333333320e-02*G3_0_2_2_0 + 8.333333333333322e-02*G3_0_2_2_1 + 8.333333333333322e-02*G3_0_2_2_2;
    block[9] = -8.333333333333320e-02*G3_0_2_0_0 - 8.333333333333322e-02*G3_0_2_1_0 - 8.333333333333320e-02*G3_0_2_2_0;
    block[10] = -8.333333333333322e-02*G3_0_2_0_1 - 8.333333333333323e-02*G3_0_2_1_1 - 8.333333333333322e-02*G3_0_2_2_1;
    block[11] = -8.333333333333322e-02*G3_0_2_0_2 - 8.333333333333323e-02*G3_0_2_1_2 - 8.333333333333322e-02*G3_0_2_2_2;
    block[12] = 8.333333333333311e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_0_1 - 8.333333333333320e-02*G1_0_2 - 4.166666666666654e-03*G2_0_0_0 - 4.166666666666655e-03*G2_0_0_1 - 4.166666666666654e-03*G2_0_0_2 - 8.333333333333307e-03*G2_0_1_0 - 8.333333333333309e-03*G2_0_1_1 - 8.333333333333307e-03*G2_0_1_2 - 4.166666666666654e-03*G2_0_2_0 - 4.166666666666654e-03*G2_0_2_1 - 4.166666666666654e-03*G2_0_2_2 - 4.166666666666655e-03*G2_0_3_0 - 4.166666666666655e-03*G2_0_3_1 - 4.166666666666655e-03*G2_0_3_2 - 4.166666666666654e-03*G2_1_4_0 - 4.166666666666654e-03*G2_1_4_1 - 4.166666666666654e-03*G2_1_4_2 - 8.333333333333309e-03*G2_1_5_0 - 8.333333333333309e-03*G2_1_5_1 - 8.333333333333307e-03*G2_1_5_2 - 4.166666666666654e-03*G2_1_6_0 - 4.166666666666654e-03*G2_1_6_1 - 4.166666666666654e-03*G2_1_6_2 - 4.166666666666655e-03*G2_1_7_0 - 4.166666666666655e-03*G2_1_7_1 - 4.166666666666655e-03*G2_1_7_2 - 4.166666666666654e-03*G2_2_8_0 - 4.166666666666654e-03*G2_2_8_1 - 4.166666666666654e-03*G2_2_8_2 - 8.333333333333309e-03*G2_2_9_0 - 8.333333333333309e-03*G2_2_9_1 - 8.333333333333307e-03*G2_2_9_2 - 4.166666666666654e-03*G2_2_10_0 - 4.166666666666654e-03*G2_2_10_1 - 4.166666666666654e-03*G2_2_10_2 - 4.166666666666655e-03*G2_2_11_0 - 4.166666666666655e-03*G2_2_11_1 - 4.166666666666655e-03*G2_2_11_2 - 8.333333333333320e-02*G3_0_0_0_0 - 8.333333333333322e-02*G3_0_0_0_1 - 8.333333333333320e-02*G3_0_0_0_2 - 8.333333333333309e-03*G4_0_0_0_0_0_0 - 8.333333333333309e-03*G4_0_0_0_0_0_1 - 8.333333333333309e-03*G4_0_0_0_0_0_2 - 4.166666666666654e-03*G4_0_0_0_0_1_0 - 4.166666666666654e-03*G4_0_0_0_0_1_1 - 4.166666666666654e-03*G4_0_0_0_0_1_2 - 4.166666666666654e-03*G4_0_0_0_0_2_0 - 4.166666666666654e-03*G4_0_0_0_0_2_1 - 4.166666666666654e-03*G4_0_0_0_0_2_2 - 4.166666666666656e-03*G4_0_0_0_0_3_0 - 4.166666666666656e-03*G4_0_0_0_0_3_1 - 4.166666666666656e-03*G4_0_0_0_0_3_2 - 4.166666666666654e-03*G4_0_0_1_0_0_0 - 4.166666666666654e-03*G4_0_0_1_0_0_1 - 4.166666666666654e-03*G4_0_0_1_0_0_2 - 8.333333333333307e-03*G4_0_0_1_0_1_0 - 8.333333333333307e-03*G4_0_0_1_0_1_1 - 8.333333333333305e-03*G4_0_0_1_0_1_2 - 4.166666666666654e-03*G4_0_0_1_0_2_0 - 4.166666666666654e-03*G4_0_0_1_0_2_1 - 4.166666666666653e-03*G4_0_0_1_0_2_2 - 4.166666666666654e-03*G4_0_0_1_0_3_0 - 4.166666666666655e-03*G4_0_0_1_0_3_1 - 4.166666666666655e-03*G4_0_0_1_0_3_2 - 4.166666666666654e-03*G4_0_0_2_0_0_0 - 4.166666666666654e-03*G4_0_0_2_0_0_1 - 4.166666666666654e-03*G4_0_0_2_0_0_2 - 4.166666666666654e-03*G4_0_0_2_0_1_0 - 4.166666666666654e-03*G4_0_0_2_0_1_1 - 4.166666666666653e-03*G4_0_0_2_0_1_2 - 8.333333333333309e-03*G4_0_0_2_0_2_0 - 8.333333333333309e-03*G4_0_0_2_0_2_1 - 8.333333333333309e-03*G4_0_0_2_0_2_2 - 4.166666666666654e-03*G4_0_0_2_0_3_0 - 4.166666666666655e-03*G4_0_0_2_0_3_1 - 4.166666666666654e-03*G4_0_0_2_0_3_2 - 4.166666666666656e-03*G4_0_0_3_0_0_0 - 4.166666666666656e-03*G4_0_0_3_0_0_1 - 4.166666666666656e-03*G4_0_0_3_0_0_2 - 4.166666666666654e-03*G4_0_0_3_0_1_0 - 4.166666666666655e-03*G4_0_0_3_0_1_1 - 4.166666666666654e-03*G4_0_0_3_0_1_2 - 4.166666666666655e-03*G4_0_0_3_0_2_0 - 4.166666666666655e-03*G4_0_0_3_0_2_1 - 4.166666666666654e-03*G4_0_0_3_0_2_2 - 8.333333333333309e-03*G4_0_0_3_0_3_0 - 8.333333333333311e-03*G4_0_0_3_0_3_1 - 8.333333333333309e-03*G4_0_0_3_0_3_2 - 8.333333333333309e-03*G4_0_1_0_0_4_0 - 8.333333333333309e-03*G4_0_1_0_0_4_1 - 8.333333333333309e-03*G4_0_1_0_0_4_2 - 4.166666666666654e-03*G4_0_1_0_0_5_0 - 4.166666666666655e-03*G4_0_1_0_0_5_1 - 4.166666666666654e-03*G4_0_1_0_0_5_2 - 4.166666666666654e-03*G4_0_1_0_0_6_0 - 4.166666666666654e-03*G4_0_1_0_0_6_1 - 4.166666666666654e-03*G4_0_1_0_0_6_2 - 4.166666666666656e-03*G4_0_1_0_0_7_0 - 4.166666666666656e-03*G4_0_1_0_0_7_1 - 4.166666666666656e-03*G4_0_1_0_0_7_2 - 4.166666666666654e-03*G4_0_1_1_0_4_0 - 4.166666666666654e-03*G4_0_1_1_0_4_1 - 4.166666666666653e-03*G4_0_1_1_0_4_2 - 8.333333333333307e-03*G4_0_1_1_0_5_0 - 8.333333333333309e-03*G4_0_1_1_0_5_1 - 8.333333333333307e-03*G4_0_1_1_0_5_2 - 4.166666666666654e-03*G4_0_1_1_0_6_0 - 4.166666666666654e-03*G4_0_1_1_0_6_1 - 4.166666666666653e-03*G4_0_1_1_0_6_2 - 4.166666666666654e-03*G4_0_1_1_0_7_0 - 4.166666666666655e-03*G4_0_1_1_0_7_1 - 4.166666666666655e-03*G4_0_1_1_0_7_2 - 4.166666666666653e-03*G4_0_1_2_0_4_0 - 4.166666666666654e-03*G4_0_1_2_0_4_1 - 4.166666666666653e-03*G4_0_1_2_0_4_2 - 4.166666666666654e-03*G4_0_1_2_0_5_0 - 4.166666666666655e-03*G4_0_1_2_0_5_1 - 4.166666666666654e-03*G4_0_1_2_0_5_2 - 8.333333333333309e-03*G4_0_1_2_0_6_0 - 8.333333333333309e-03*G4_0_1_2_0_6_1 - 8.333333333333309e-03*G4_0_1_2_0_6_2 - 4.166666666666654e-03*G4_0_1_2_0_7_0 - 4.166666666666655e-03*G4_0_1_2_0_7_1 - 4.166666666666654e-03*G4_0_1_2_0_7_2 - 4.166666666666655e-03*G4_0_1_3_0_4_0 - 4.166666666666656e-03*G4_0_1_3_0_4_1 - 4.166666666666655e-03*G4_0_1_3_0_4_2 - 4.166666666666655e-03*G4_0_1_3_0_5_0 - 4.166666666666656e-03*G4_0_1_3_0_5_1 - 4.166666666666656e-03*G4_0_1_3_0_5_2 - 4.166666666666655e-03*G4_0_1_3_0_6_0 - 4.166666666666655e-03*G4_0_1_3_0_6_1 - 4.166666666666654e-03*G4_0_1_3_0_6_2 - 8.333333333333309e-03*G4_0_1_3_0_7_0 - 8.333333333333311e-03*G4_0_1_3_0_7_1 - 8.333333333333309e-03*G4_0_1_3_0_7_2 - 8.333333333333309e-03*G4_0_2_0_0_8_0 - 8.333333333333309e-03*G4_0_2_0_0_8_1 - 8.333333333333309e-03*G4_0_2_0_0_8_2 - 4.166666666666654e-03*G4_0_2_0_0_9_0 - 4.166666666666655e-03*G4_0_2_0_0_9_1 - 4.166666666666654e-03*G4_0_2_0_0_9_2 - 4.166666666666654e-03*G4_0_2_0_0_10_0 - 4.166666666666654e-03*G4_0_2_0_0_10_1 - 4.166666666666654e-03*G4_0_2_0_0_10_2 - 4.166666666666656e-03*G4_0_2_0_0_11_0 - 4.166666666666656e-03*G4_0_2_0_0_11_1 - 4.166666666666656e-03*G4_0_2_0_0_11_2 - 4.166666666666654e-03*G4_0_2_1_0_8_0 - 4.166666666666654e-03*G4_0_2_1_0_8_1 - 4.166666666666653e-03*G4_0_2_1_0_8_2 - 8.333333333333307e-03*G4_0_2_1_0_9_0 - 8.333333333333309e-03*G4_0_2_1_0_9_1 - 8.333333333333307e-03*G4_0_2_1_0_9_2 - 4.166666666666654e-03*G4_0_2_1_0_10_0 - 4.166666666666654e-03*G4_0_2_1_0_10_1 - 4.166666666666653e-03*G4_0_2_1_0_10_2 - 4.166666666666654e-03*G4_0_2_1_0_11_0 - 4.166666666666655e-03*G4_0_2_1_0_11_1 - 4.166666666666655e-03*G4_0_2_1_0_11_2 - 4.166666666666653e-03*G4_0_2_2_0_8_0 - 4.166666666666654e-03*G4_0_2_2_0_8_1 - 4.166666666666653e-03*G4_0_2_2_0_8_2 - 4.166666666666654e-03*G4_0_2_2_0_9_0 - 4.166666666666655e-03*G4_0_2_2_0_9_1 - 4.166666666666654e-03*G4_0_2_2_0_9_2 - 8.333333333333309e-03*G4_0_2_2_0_10_0 - 8.333333333333309e-03*G4_0_2_2_0_10_1 - 8.333333333333309e-03*G4_0_2_2_0_10_2 - 4.166666666666654e-03*G4_0_2_2_0_11_0 - 4.166666666666655e-03*G4_0_2_2_0_11_1 - 4.166666666666654e-03*G4_0_2_2_0_11_2 - 4.166666666666655e-03*G4_0_2_3_0_8_0 - 4.166666666666656e-03*G4_0_2_3_0_8_1 - 4.166666666666655e-03*G4_0_2_3_0_8_2 - 4.166666666666655e-03*G4_0_2_3_0_9_0 - 4.166666666666656e-03*G4_0_2_3_0_9_1 - 4.166666666666656e-03*G4_0_2_3_0_9_2 - 4.166666666666655e-03*G4_0_2_3_0_10_0 - 4.166666666666655e-03*G4_0_2_3_0_10_1 - 4.166666666666654e-03*G4_0_2_3_0_10_2 - 8.333333333333309e-03*G4_0_2_3_0_11_0 - 8.333333333333311e-03*G4_0_2_3_0_11_1 - 8.333333333333309e-03*G4_0_2_3_0_11_2 - 8.333333333333309e-03*G4_1_0_4_0_0_0 - 8.333333333333309e-03*G4_1_0_4_0_0_1 - 8.333333333333309e-03*G4_1_0_4_0_0_2 - 4.166666666666654e-03*G4_1_0_4_0_1_0 - 4.166666666666654e-03*G4_1_0_4_0_1_1 - 4.166666666666653e-03*G4_1_0_4_0_1_2 - 4.166666666666653e-03*G4_1_0_4_0_2_0 - 4.166666666666654e-03*G4_1_0_4_0_2_1 - 4.166666666666654e-03*G4_1_0_4_0_2_2 - 4.166666666666654e-03*G4_1_0_4_0_3_0 - 4.166666666666656e-03*G4_1_0_4_0_3_1 - 4.166666666666654e-03*G4_1_0_4_0_3_2 - 4.166666666666654e-03*G4_1_0_5_0_0_0 - 4.166666666666655e-03*G4_1_0_5_0_0_1 - 4.166666666666654e-03*G4_1_0_5_0_0_2 - 8.333333333333307e-03*G4_1_0_5_0_1_0 - 8.333333333333309e-03*G4_1_0_5_0_1_1 - 8.333333333333307e-03*G4_1_0_5_0_1_2 - 4.166666666666654e-03*G4_1_0_5_0_2_0 - 4.166666666666655e-03*G4_1_0_5_0_2_1 - 4.166666666666654e-03*G4_1_0_5_0_2_2 - 4.166666666666655e-03*G4_1_0_5_0_3_0 - 4.166666666666656e-03*G4_1_0_5_0_3_1 - 4.166666666666656e-03*G4_1_0_5_0_3_2 - 4.166666666666654e-03*G4_1_0_6_0_0_0 - 4.166666666666654e-03*G4_1_0_6_0_0_1 - 4.166666666666654e-03*G4_1_0_6_0_0_2 - 4.166666666666654e-03*G4_1_0_6_0_1_0 - 4.166666666666654e-03*G4_1_0_6_0_1_1 - 4.166666666666653e-03*G4_1_0_6_0_1_2 - 8.333333333333309e-03*G4_1_0_6_0_2_0 - 8.333333333333309e-03*G4_1_0_6_0_2_1 - 8.333333333333309e-03*G4_1_0_6_0_2_2 - 4.166666666666654e-03*G4_1_0_6_0_3_0 - 4.166666666666655e-03*G4_1_0_6_0_3_1 - 4.166666666666654e-03*G4_1_0_6_0_3_2 - 4.166666666666656e-03*G4_1_0_7_0_0_0 - 4.166666666666656e-03*G4_1_0_7_0_0_1 - 4.166666666666656e-03*G4_1_0_7_0_0_2 - 4.166666666666654e-03*G4_1_0_7_0_1_0 - 4.166666666666655e-03*G4_1_0_7_0_1_1 - 4.166666666666654e-03*G4_1_0_7_0_1_2 - 4.166666666666655e-03*G4_1_0_7_0_2_0 - 4.166666666666655e-03*G4_1_0_7_0_2_1 - 4.166666666666654e-03*G4_1_0_7_0_2_2 - 8.333333333333309e-03*G4_1_0_7_0_3_0 - 8.333333333333311e-03*G4_1_0_7_0_3_1 - 8.333333333333309e-03*G4_1_0_7_0_3_2 - 8.333333333333309e-03*G4_1_1_4_0_4_0 - 8.333333333333309e-03*G4_1_1_4_0_4_1 - 8.333333333333309e-03*G4_1_1_4_0_4_2 - 4.166666666666654e-03*G4_1_1_4_0_5_0 - 4.166666666666654e-03*G4_1_1_4_0_5_1 - 4.166666666666654e-03*G4_1_1_4_0_5_2 - 4.166666666666653e-03*G4_1_1_4_0_6_0 - 4.166666666666654e-03*G4_1_1_4_0_6_1 - 4.166666666666654e-03*G4_1_1_4_0_6_2 - 4.166666666666654e-03*G4_1_1_4_0_7_0 - 4.166666666666656e-03*G4_1_1_4_0_7_1 - 4.166666666666654e-03*G4_1_1_4_0_7_2 - 4.166666666666654e-03*G4_1_1_5_0_4_0 - 4.166666666666654e-03*G4_1_1_5_0_4_1 - 4.166666666666654e-03*G4_1_1_5_0_4_2 - 8.333333333333307e-03*G4_1_1_5_0_5_0 - 8.333333333333309e-03*G4_1_1_5_0_5_1 - 8.333333333333307e-03*G4_1_1_5_0_5_2 - 4.166666666666654e-03*G4_1_1_5_0_6_0 - 4.166666666666655e-03*G4_1_1_5_0_6_1 - 4.166666666666654e-03*G4_1_1_5_0_6_2 - 4.166666666666655e-03*G4_1_1_5_0_7_0 - 4.166666666666656e-03*G4_1_1_5_0_7_1 - 4.166666666666656e-03*G4_1_1_5_0_7_2 - 4.166666666666653e-03*G4_1_1_6_0_4_0 - 4.166666666666654e-03*G4_1_1_6_0_4_1 - 4.166666666666653e-03*G4_1_1_6_0_4_2 - 4.166666666666654e-03*G4_1_1_6_0_5_0 - 4.166666666666655e-03*G4_1_1_6_0_5_1 - 4.166666666666654e-03*G4_1_1_6_0_5_2 - 8.333333333333309e-03*G4_1_1_6_0_6_0 - 8.333333333333309e-03*G4_1_1_6_0_6_1 - 8.333333333333309e-03*G4_1_1_6_0_6_2 - 4.166666666666654e-03*G4_1_1_6_0_7_0 - 4.166666666666655e-03*G4_1_1_6_0_7_1 - 4.166666666666654e-03*G4_1_1_6_0_7_2 - 4.166666666666655e-03*G4_1_1_7_0_4_0 - 4.166666666666656e-03*G4_1_1_7_0_4_1 - 4.166666666666655e-03*G4_1_1_7_0_4_2 - 4.166666666666655e-03*G4_1_1_7_0_5_0 - 4.166666666666656e-03*G4_1_1_7_0_5_1 - 4.166666666666656e-03*G4_1_1_7_0_5_2 - 4.166666666666655e-03*G4_1_1_7_0_6_0 - 4.166666666666655e-03*G4_1_1_7_0_6_1 - 4.166666666666654e-03*G4_1_1_7_0_6_2 - 8.333333333333309e-03*G4_1_1_7_0_7_0 - 8.333333333333311e-03*G4_1_1_7_0_7_1 - 8.333333333333309e-03*G4_1_1_7_0_7_2 - 8.333333333333309e-03*G4_1_2_4_0_8_0 - 8.333333333333309e-03*G4_1_2_4_0_8_1 - 8.333333333333309e-03*G4_1_2_4_0_8_2 - 4.166666666666654e-03*G4_1_2_4_0_9_0 - 4.166666666666654e-03*G4_1_2_4_0_9_1 - 4.166666666666654e-03*G4_1_2_4_0_9_2 - 4.166666666666653e-03*G4_1_2_4_0_10_0 - 4.166666666666654e-03*G4_1_2_4_0_10_1 - 4.166666666666654e-03*G4_1_2_4_0_10_2 - 4.166666666666654e-03*G4_1_2_4_0_11_0 - 4.166666666666656e-03*G4_1_2_4_0_11_1 - 4.166666666666654e-03*G4_1_2_4_0_11_2 - 4.166666666666654e-03*G4_1_2_5_0_8_0 - 4.166666666666654e-03*G4_1_2_5_0_8_1 - 4.166666666666654e-03*G4_1_2_5_0_8_2 - 8.333333333333307e-03*G4_1_2_5_0_9_0 - 8.333333333333309e-03*G4_1_2_5_0_9_1 - 8.333333333333307e-03*G4_1_2_5_0_9_2 - 4.166666666666654e-03*G4_1_2_5_0_10_0 - 4.166666666666655e-03*G4_1_2_5_0_10_1 - 4.166666666666654e-03*G4_1_2_5_0_10_2 - 4.166666666666655e-03*G4_1_2_5_0_11_0 - 4.166666666666656e-03*G4_1_2_5_0_11_1 - 4.166666666666656e-03*G4_1_2_5_0_11_2 - 4.166666666666653e-03*G4_1_2_6_0_8_0 - 4.166666666666654e-03*G4_1_2_6_0_8_1 - 4.166666666666653e-03*G4_1_2_6_0_8_2 - 4.166666666666654e-03*G4_1_2_6_0_9_0 - 4.166666666666655e-03*G4_1_2_6_0_9_1 - 4.166666666666654e-03*G4_1_2_6_0_9_2 - 8.333333333333309e-03*G4_1_2_6_0_10_0 - 8.333333333333309e-03*G4_1_2_6_0_10_1 - 8.333333333333309e-03*G4_1_2_6_0_10_2 - 4.166666666666654e-03*G4_1_2_6_0_11_0 - 4.166666666666655e-03*G4_1_2_6_0_11_1 - 4.166666666666654e-03*G4_1_2_6_0_11_2 - 4.166666666666655e-03*G4_1_2_7_0_8_0 - 4.166666666666656e-03*G4_1_2_7_0_8_1 - 4.166666666666655e-03*G4_1_2_7_0_8_2 - 4.166666666666655e-03*G4_1_2_7_0_9_0 - 4.166666666666656e-03*G4_1_2_7_0_9_1 - 4.166666666666656e-03*G4_1_2_7_0_9_2 - 4.166666666666655e-03*G4_1_2_7_0_10_0 - 4.166666666666655e-03*G4_1_2_7_0_10_1 - 4.166666666666654e-03*G4_1_2_7_0_10_2 - 8.333333333333309e-03*G4_1_2_7_0_11_0 - 8.333333333333311e-03*G4_1_2_7_0_11_1 - 8.333333333333309e-03*G4_1_2_7_0_11_2 - 8.333333333333309e-03*G4_2_0_8_0_0_0 - 8.333333333333309e-03*G4_2_0_8_0_0_1 - 8.333333333333309e-03*G4_2_0_8_0_0_2 - 4.166666666666654e-03*G4_2_0_8_0_1_0 - 4.166666666666654e-03*G4_2_0_8_0_1_1 - 4.166666666666653e-03*G4_2_0_8_0_1_2 - 4.166666666666653e-03*G4_2_0_8_0_2_0 - 4.166666666666654e-03*G4_2_0_8_0_2_1 - 4.166666666666654e-03*G4_2_0_8_0_2_2 - 4.166666666666654e-03*G4_2_0_8_0_3_0 - 4.166666666666656e-03*G4_2_0_8_0_3_1 - 4.166666666666654e-03*G4_2_0_8_0_3_2 - 4.166666666666654e-03*G4_2_0_9_0_0_0 - 4.166666666666655e-03*G4_2_0_9_0_0_1 - 4.166666666666654e-03*G4_2_0_9_0_0_2 - 8.333333333333307e-03*G4_2_0_9_0_1_0 - 8.333333333333309e-03*G4_2_0_9_0_1_1 - 8.333333333333307e-03*G4_2_0_9_0_1_2 - 4.166666666666654e-03*G4_2_0_9_0_2_0 - 4.166666666666655e-03*G4_2_0_9_0_2_1 - 4.166666666666654e-03*G4_2_0_9_0_2_2 - 4.166666666666655e-03*G4_2_0_9_0_3_0 - 4.166666666666656e-03*G4_2_0_9_0_3_1 - 4.166666666666656e-03*G4_2_0_9_0_3_2 - 4.166666666666654e-03*G4_2_0_10_0_0_0 - 4.166666666666654e-03*G4_2_0_10_0_0_1 - 4.166666666666654e-03*G4_2_0_10_0_0_2 - 4.166666666666654e-03*G4_2_0_10_0_1_0 - 4.166666666666654e-03*G4_2_0_10_0_1_1 - 4.166666666666653e-03*G4_2_0_10_0_1_2 - 8.333333333333309e-03*G4_2_0_10_0_2_0 - 8.333333333333309e-03*G4_2_0_10_0_2_1 - 8.333333333333309e-03*G4_2_0_10_0_2_2 - 4.166666666666654e-03*G4_2_0_10_0_3_0 - 4.166666666666655e-03*G4_2_0_10_0_3_1 - 4.166666666666654e-03*G4_2_0_10_0_3_2 - 4.166666666666656e-03*G4_2_0_11_0_0_0 - 4.166666666666656e-03*G4_2_0_11_0_0_1 - 4.166666666666656e-03*G4_2_0_11_0_0_2 - 4.166666666666654e-03*G4_2_0_11_0_1_0 - 4.166666666666655e-03*G4_2_0_11_0_1_1 - 4.166666666666654e-03*G4_2_0_11_0_1_2 - 4.166666666666655e-03*G4_2_0_11_0_2_0 - 4.166666666666655e-03*G4_2_0_11_0_2_1 - 4.166666666666654e-03*G4_2_0_11_0_2_2 - 8.333333333333309e-03*G4_2_0_11_0_3_0 - 8.333333333333311e-03*G4_2_0_11_0_3_1 - 8.333333333333309e-03*G4_2_0_11_0_3_2 - 8.333333333333309e-03*G4_2_1_8_0_4_0 - 8.333333333333309e-03*G4_2_1_8_0_4_1 - 8.333333333333309e-03*G4_2_1_8_0_4_2 - 4.166666666666654e-03*G4_2_1_8_0_5_0 - 4.166666666666654e-03*G4_2_1_8_0_5_1 - 4.166666666666654e-03*G4_2_1_8_0_5_2 - 4.166666666666653e-03*G4_2_1_8_0_6_0 - 4.166666666666654e-03*G4_2_1_8_0_6_1 - 4.166666666666654e-03*G4_2_1_8_0_6_2 - 4.166666666666654e-03*G4_2_1_8_0_7_0 - 4.166666666666656e-03*G4_2_1_8_0_7_1 - 4.166666666666654e-03*G4_2_1_8_0_7_2 - 4.166666666666654e-03*G4_2_1_9_0_4_0 - 4.166666666666654e-03*G4_2_1_9_0_4_1 - 4.166666666666654e-03*G4_2_1_9_0_4_2 - 8.333333333333307e-03*G4_2_1_9_0_5_0 - 8.333333333333309e-03*G4_2_1_9_0_5_1 - 8.333333333333307e-03*G4_2_1_9_0_5_2 - 4.166666666666654e-03*G4_2_1_9_0_6_0 - 4.166666666666655e-03*G4_2_1_9_0_6_1 - 4.166666666666654e-03*G4_2_1_9_0_6_2 - 4.166666666666655e-03*G4_2_1_9_0_7_0 - 4.166666666666656e-03*G4_2_1_9_0_7_1 - 4.166666666666656e-03*G4_2_1_9_0_7_2 - 4.166666666666653e-03*G4_2_1_10_0_4_0 - 4.166666666666654e-03*G4_2_1_10_0_4_1 - 4.166666666666653e-03*G4_2_1_10_0_4_2 - 4.166666666666654e-03*G4_2_1_10_0_5_0 - 4.166666666666655e-03*G4_2_1_10_0_5_1 - 4.166666666666654e-03*G4_2_1_10_0_5_2 - 8.333333333333309e-03*G4_2_1_10_0_6_0 - 8.333333333333309e-03*G4_2_1_10_0_6_1 - 8.333333333333309e-03*G4_2_1_10_0_6_2 - 4.166666666666654e-03*G4_2_1_10_0_7_0 - 4.166666666666655e-03*G4_2_1_10_0_7_1 - 4.166666666666654e-03*G4_2_1_10_0_7_2 - 4.166666666666655e-03*G4_2_1_11_0_4_0 - 4.166666666666656e-03*G4_2_1_11_0_4_1 - 4.166666666666655e-03*G4_2_1_11_0_4_2 - 4.166666666666655e-03*G4_2_1_11_0_5_0 - 4.166666666666656e-03*G4_2_1_11_0_5_1 - 4.166666666666656e-03*G4_2_1_11_0_5_2 - 4.166666666666655e-03*G4_2_1_11_0_6_0 - 4.166666666666655e-03*G4_2_1_11_0_6_1 - 4.166666666666654e-03*G4_2_1_11_0_6_2 - 8.333333333333309e-03*G4_2_1_11_0_7_0 - 8.333333333333311e-03*G4_2_1_11_0_7_1 - 8.333333333333309e-03*G4_2_1_11_0_7_2 - 8.333333333333309e-03*G4_2_2_8_0_8_0 - 8.333333333333309e-03*G4_2_2_8_0_8_1 - 8.333333333333309e-03*G4_2_2_8_0_8_2 - 4.166666666666654e-03*G4_2_2_8_0_9_0 - 4.166666666666654e-03*G4_2_2_8_0_9_1 - 4.166666666666654e-03*G4_2_2_8_0_9_2 - 4.166666666666653e-03*G4_2_2_8_0_10_0 - 4.166666666666654e-03*G4_2_2_8_0_10_1 - 4.166666666666654e-03*G4_2_2_8_0_10_2 - 4.166666666666654e-03*G4_2_2_8_0_11_0 - 4.166666666666656e-03*G4_2_2_8_0_11_1 - 4.166666666666654e-03*G4_2_2_8_0_11_2 - 4.166666666666654e-03*G4_2_2_9_0_8_0 - 4.166666666666654e-03*G4_2_2_9_0_8_1 - 4.166666666666654e-03*G4_2_2_9_0_8_2 - 8.333333333333307e-03*G4_2_2_9_0_9_0 - 8.333333333333309e-03*G4_2_2_9_0_9_1 - 8.333333333333307e-03*G4_2_2_9_0_9_2 - 4.166666666666654e-03*G4_2_2_9_0_10_0 - 4.166666666666655e-03*G4_2_2_9_0_10_1 - 4.166666666666654e-03*G4_2_2_9_0_10_2 - 4.166666666666655e-03*G4_2_2_9_0_11_0 - 4.166666666666656e-03*G4_2_2_9_0_11_1 - 4.166666666666656e-03*G4_2_2_9_0_11_2 - 4.166666666666653e-03*G4_2_2_10_0_8_0 - 4.166666666666654e-03*G4_2_2_10_0_8_1 - 4.166666666666653e-03*G4_2_2_10_0_8_2 - 4.166666666666654e-03*G4_2_2_10_0_9_0 - 4.166666666666655e-03*G4_2_2_10_0_9_1 - 4.166666666666654e-03*G4_2_2_10_0_9_2 - 8.333333333333309e-03*G4_2_2_10_0_10_0 - 8.333333333333309e-03*G4_2_2_10_0_10_1 - 8.333333333333309e-03*G4_2_2_10_0_10_2 - 4.166666666666654e-03*G4_2_2_10_0_11_0 - 4.166666666666655e-03*G4_2_2_10_0_11_1 - 4.166666666666654e-03*G4_2_2_10_0_11_2 - 4.166666666666655e-03*G4_2_2_11_0_8_0 - 4.166666666666656e-03*G4_2_2_11_0_8_1 - 4.166666666666655e-03*G4_2_2_11_0_8_2 - 4.166666666666655e-03*G4_2_2_11_0_9_0 - 4.166666666666656e-03*G4_2_2_11_0_9_1 - 4.166666666666656e-03*G4_2_2_11_0_9_2 - 4.166666666666655e-03*G4_2_2_11_0_10_0 - 4.166666666666655e-03*G4_2_2_11_0_10_1 - 4.166666666666654e-03*G4_2_2_11_0_10_2 - 8.333333333333309e-03*G4_2_2_11_0_11_0 - 8.333333333333311e-03*G4_2_2_11_0_11_1 - 8.333333333333309e-03*G4_2_2_11_0_11_2;
    block[13] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 4.166666666666654e-03*G2_0_0_0 + 8.333333333333307e-03*G2_0_1_0 + 4.166666666666654e-03*G2_0_2_0 + 4.166666666666655e-03*G2_0_3_0 + 4.166666666666654e-03*G2_1_4_0 + 8.333333333333309e-03*G2_1_5_0 + 4.166666666666654e-03*G2_1_6_0 + 4.166666666666655e-03*G2_1_7_0 + 4.166666666666654e-03*G2_2_8_0 + 8.333333333333309e-03*G2_2_9_0 + 4.166666666666654e-03*G2_2_10_0 + 4.166666666666655e-03*G2_2_11_0 + 8.333333333333320e-02*G3_0_0_0_0 + 8.333333333333309e-03*G4_0_0_0_0_0_0 + 4.166666666666654e-03*G4_0_0_0_0_1_0 + 4.166666666666654e-03*G4_0_0_0_0_2_0 + 4.166666666666656e-03*G4_0_0_0_0_3_0 + 4.166666666666654e-03*G4_0_0_1_0_0_0 + 8.333333333333307e-03*G4_0_0_1_0_1_0 + 4.166666666666654e-03*G4_0_0_1_0_2_0 + 4.166666666666654e-03*G4_0_0_1_0_3_0 + 4.166666666666654e-03*G4_0_0_2_0_0_0 + 4.166666666666654e-03*G4_0_0_2_0_1_0 + 8.333333333333309e-03*G4_0_0_2_0_2_0 + 4.166666666666654e-03*G4_0_0_2_0_3_0 + 4.166666666666656e-03*G4_0_0_3_0_0_0 + 4.166666666666654e-03*G4_0_0_3_0_1_0 + 4.166666666666655e-03*G4_0_0_3_0_2_0 + 8.333333333333309e-03*G4_0_0_3_0_3_0 + 8.333333333333309e-03*G4_0_1_0_0_4_0 + 4.166666666666654e-03*G4_0_1_0_0_5_0 + 4.166666666666654e-03*G4_0_1_0_0_6_0 + 4.166666666666656e-03*G4_0_1_0_0_7_0 + 4.166666666666654e-03*G4_0_1_1_0_4_0 + 8.333333333333307e-03*G4_0_1_1_0_5_0 + 4.166666666666654e-03*G4_0_1_1_0_6_0 + 4.166666666666654e-03*G4_0_1_1_0_7_0 + 4.166666666666653e-03*G4_0_1_2_0_4_0 + 4.166666666666654e-03*G4_0_1_2_0_5_0 + 8.333333333333309e-03*G4_0_1_2_0_6_0 + 4.166666666666654e-03*G4_0_1_2_0_7_0 + 4.166666666666655e-03*G4_0_1_3_0_4_0 + 4.166666666666655e-03*G4_0_1_3_0_5_0 + 4.166666666666655e-03*G4_0_1_3_0_6_0 + 8.333333333333309e-03*G4_0_1_3_0_7_0 + 8.333333333333309e-03*G4_0_2_0_0_8_0 + 4.166666666666654e-03*G4_0_2_0_0_9_0 + 4.166666666666654e-03*G4_0_2_0_0_10_0 + 4.166666666666656e-03*G4_0_2_0_0_11_0 + 4.166666666666654e-03*G4_0_2_1_0_8_0 + 8.333333333333307e-03*G4_0_2_1_0_9_0 + 4.166666666666654e-03*G4_0_2_1_0_10_0 + 4.166666666666654e-03*G4_0_2_1_0_11_0 + 4.166666666666653e-03*G4_0_2_2_0_8_0 + 4.166666666666654e-03*G4_0_2_2_0_9_0 + 8.333333333333309e-03*G4_0_2_2_0_10_0 + 4.166666666666654e-03*G4_0_2_2_0_11_0 + 4.166666666666655e-03*G4_0_2_3_0_8_0 + 4.166666666666655e-03*G4_0_2_3_0_9_0 + 4.166666666666655e-03*G4_0_2_3_0_10_0 + 8.333333333333309e-03*G4_0_2_3_0_11_0 + 8.333333333333309e-03*G4_1_0_4_0_0_0 + 4.166666666666654e-03*G4_1_0_4_0_1_0 + 4.166666666666653e-03*G4_1_0_4_0_2_0 + 4.166666666666654e-03*G4_1_0_4_0_3_0 + 4.166666666666654e-03*G4_1_0_5_0_0_0 + 8.333333333333307e-03*G4_1_0_5_0_1_0 + 4.166666666666654e-03*G4_1_0_5_0_2_0 + 4.166666666666655e-03*G4_1_0_5_0_3_0 + 4.166666666666654e-03*G4_1_0_6_0_0_0 + 4.166666666666654e-03*G4_1_0_6_0_1_0 + 8.333333333333309e-03*G4_1_0_6_0_2_0 + 4.166666666666654e-03*G4_1_0_6_0_3_0 + 4.166666666666656e-03*G4_1_0_7_0_0_0 + 4.166666666666654e-03*G4_1_0_7_0_1_0 + 4.166666666666655e-03*G4_1_0_7_0_2_0 + 8.333333333333309e-03*G4_1_0_7_0_3_0 + 8.333333333333309e-03*G4_1_1_4_0_4_0 + 4.166666666666654e-03*G4_1_1_4_0_5_0 + 4.166666666666653e-03*G4_1_1_4_0_6_0 + 4.166666666666654e-03*G4_1_1_4_0_7_0 + 4.166666666666654e-03*G4_1_1_5_0_4_0 + 8.333333333333307e-03*G4_1_1_5_0_5_0 + 4.166666666666654e-03*G4_1_1_5_0_6_0 + 4.166666666666655e-03*G4_1_1_5_0_7_0 + 4.166666666666653e-03*G4_1_1_6_0_4_0 + 4.166666666666654e-03*G4_1_1_6_0_5_0 + 8.333333333333309e-03*G4_1_1_6_0_6_0 + 4.166666666666654e-03*G4_1_1_6_0_7_0 + 4.166666666666655e-03*G4_1_1_7_0_4_0 + 4.166666666666655e-03*G4_1_1_7_0_5_0 + 4.166666666666655e-03*G4_1_1_7_0_6_0 + 8.333333333333309e-03*G4_1_1_7_0_7_0 + 8.333333333333309e-03*G4_1_2_4_0_8_0 + 4.166666666666654e-03*G4_1_2_4_0_9_0 + 4.166666666666653e-03*G4_1_2_4_0_10_0 + 4.166666666666654e-03*G4_1_2_4_0_11_0 + 4.166666666666654e-03*G4_1_2_5_0_8_0 + 8.333333333333307e-03*G4_1_2_5_0_9_0 + 4.166666666666654e-03*G4_1_2_5_0_10_0 + 4.166666666666655e-03*G4_1_2_5_0_11_0 + 4.166666666666653e-03*G4_1_2_6_0_8_0 + 4.166666666666654e-03*G4_1_2_6_0_9_0 + 8.333333333333309e-03*G4_1_2_6_0_10_0 + 4.166666666666654e-03*G4_1_2_6_0_11_0 + 4.166666666666655e-03*G4_1_2_7_0_8_0 + 4.166666666666655e-03*G4_1_2_7_0_9_0 + 4.166666666666655e-03*G4_1_2_7_0_10_0 + 8.333333333333309e-03*G4_1_2_7_0_11_0 + 8.333333333333309e-03*G4_2_0_8_0_0_0 + 4.166666666666654e-03*G4_2_0_8_0_1_0 + 4.166666666666653e-03*G4_2_0_8_0_2_0 + 4.166666666666654e-03*G4_2_0_8_0_3_0 + 4.166666666666654e-03*G4_2_0_9_0_0_0 + 8.333333333333307e-03*G4_2_0_9_0_1_0 + 4.166666666666654e-03*G4_2_0_9_0_2_0 + 4.166666666666655e-03*G4_2_0_9_0_3_0 + 4.166666666666654e-03*G4_2_0_10_0_0_0 + 4.166666666666654e-03*G4_2_0_10_0_1_0 + 8.333333333333309e-03*G4_2_0_10_0_2_0 + 4.166666666666654e-03*G4_2_0_10_0_3_0 + 4.166666666666656e-03*G4_2_0_11_0_0_0 + 4.166666666666654e-03*G4_2_0_11_0_1_0 + 4.166666666666655e-03*G4_2_0_11_0_2_0 + 8.333333333333309e-03*G4_2_0_11_0_3_0 + 8.333333333333309e-03*G4_2_1_8_0_4_0 + 4.166666666666654e-03*G4_2_1_8_0_5_0 + 4.166666666666653e-03*G4_2_1_8_0_6_0 + 4.166666666666654e-03*G4_2_1_8_0_7_0 + 4.166666666666654e-03*G4_2_1_9_0_4_0 + 8.333333333333307e-03*G4_2_1_9_0_5_0 + 4.166666666666654e-03*G4_2_1_9_0_6_0 + 4.166666666666655e-03*G4_2_1_9_0_7_0 + 4.166666666666653e-03*G4_2_1_10_0_4_0 + 4.166666666666654e-03*G4_2_1_10_0_5_0 + 8.333333333333309e-03*G4_2_1_10_0_6_0 + 4.166666666666654e-03*G4_2_1_10_0_7_0 + 4.166666666666655e-03*G4_2_1_11_0_4_0 + 4.166666666666655e-03*G4_2_1_11_0_5_0 + 4.166666666666655e-03*G4_2_1_11_0_6_0 + 8.333333333333309e-03*G4_2_1_11_0_7_0 + 8.333333333333309e-03*G4_2_2_8_0_8_0 + 4.166666666666654e-03*G4_2_2_8_0_9_0 + 4.166666666666653e-03*G4_2_2_8_0_10_0 + 4.166666666666654e-03*G4_2_2_8_0_11_0 + 4.166666666666654e-03*G4_2_2_9_0_8_0 + 8.333333333333307e-03*G4_2_2_9_0_9_0 + 4.166666666666654e-03*G4_2_2_9_0_10_0 + 4.166666666666655e-03*G4_2_2_9_0_11_0 + 4.166666666666653e-03*G4_2_2_10_0_8_0 + 4.166666666666654e-03*G4_2_2_10_0_9_0 + 8.333333333333309e-03*G4_2_2_10_0_10_0 + 4.166666666666654e-03*G4_2_2_10_0_11_0 + 4.166666666666655e-03*G4_2_2_11_0_8_0 + 4.166666666666655e-03*G4_2_2_11_0_9_0 + 4.166666666666655e-03*G4_2_2_11_0_10_0 + 8.333333333333309e-03*G4_2_2_11_0_11_0;
    block[14] = 8.333333333333309e-03*G0_ + 8.333333333333322e-02*G1_0_1 + 4.166666666666655e-03*G2_0_0_1 + 8.333333333333309e-03*G2_0_1_1 + 4.166666666666654e-03*G2_0_2_1 + 4.166666666666655e-03*G2_0_3_1 + 4.166666666666654e-03*G2_1_4_1 + 8.333333333333309e-03*G2_1_5_1 + 4.166666666666654e-03*G2_1_6_1 + 4.166666666666655e-03*G2_1_7_1 + 4.166666666666654e-03*G2_2_8_1 + 8.333333333333309e-03*G2_2_9_1 + 4.166666666666654e-03*G2_2_10_1 + 4.166666666666655e-03*G2_2_11_1 + 8.333333333333322e-02*G3_0_0_0_1 + 8.333333333333309e-03*G4_0_0_0_0_0_1 + 4.166666666666654e-03*G4_0_0_0_0_1_1 + 4.166666666666654e-03*G4_0_0_0_0_2_1 + 4.166666666666656e-03*G4_0_0_0_0_3_1 + 4.166666666666654e-03*G4_0_0_1_0_0_1 + 8.333333333333307e-03*G4_0_0_1_0_1_1 + 4.166666666666654e-03*G4_0_0_1_0_2_1 + 4.166666666666655e-03*G4_0_0_1_0_3_1 + 4.166666666666654e-03*G4_0_0_2_0_0_1 + 4.166666666666654e-03*G4_0_0_2_0_1_1 + 8.333333333333309e-03*G4_0_0_2_0_2_1 + 4.166666666666655e-03*G4_0_0_2_0_3_1 + 4.166666666666656e-03*G4_0_0_3_0_0_1 + 4.166666666666655e-03*G4_0_0_3_0_1_1 + 4.166666666666655e-03*G4_0_0_3_0_2_1 + 8.333333333333311e-03*G4_0_0_3_0_3_1 + 8.333333333333309e-03*G4_0_1_0_0_4_1 + 4.166666666666655e-03*G4_0_1_0_0_5_1 + 4.166666666666654e-03*G4_0_1_0_0_6_1 + 4.166666666666656e-03*G4_0_1_0_0_7_1 + 4.166666666666654e-03*G4_0_1_1_0_4_1 + 8.333333333333309e-03*G4_0_1_1_0_5_1 + 4.166666666666654e-03*G4_0_1_1_0_6_1 + 4.166666666666655e-03*G4_0_1_1_0_7_1 + 4.166666666666654e-03*G4_0_1_2_0_4_1 + 4.166666666666655e-03*G4_0_1_2_0_5_1 + 8.333333333333309e-03*G4_0_1_2_0_6_1 + 4.166666666666655e-03*G4_0_1_2_0_7_1 + 4.166666666666656e-03*G4_0_1_3_0_4_1 + 4.166666666666656e-03*G4_0_1_3_0_5_1 + 4.166666666666655e-03*G4_0_1_3_0_6_1 + 8.333333333333311e-03*G4_0_1_3_0_7_1 + 8.333333333333309e-03*G4_0_2_0_0_8_1 + 4.166666666666655e-03*G4_0_2_0_0_9_1 + 4.166666666666654e-03*G4_0_2_0_0_10_1 + 4.166666666666656e-03*G4_0_2_0_0_11_1 + 4.166666666666654e-03*G4_0_2_1_0_8_1 + 8.333333333333309e-03*G4_0_2_1_0_9_1 + 4.166666666666654e-03*G4_0_2_1_0_10_1 + 4.166666666666655e-03*G4_0_2_1_0_11_1 + 4.166666666666654e-03*G4_0_2_2_0_8_1 + 4.166666666666655e-03*G4_0_2_2_0_9_1 + 8.333333333333309e-03*G4_0_2_2_0_10_1 + 4.166666666666655e-03*G4_0_2_2_0_11_1 + 4.166666666666656e-03*G4_0_2_3_0_8_1 + 4.166666666666656e-03*G4_0_2_3_0_9_1 + 4.166666666666655e-03*G4_0_2_3_0_10_1 + 8.333333333333311e-03*G4_0_2_3_0_11_1 + 8.333333333333309e-03*G4_1_0_4_0_0_1 + 4.166666666666654e-03*G4_1_0_4_0_1_1 + 4.166666666666654e-03*G4_1_0_4_0_2_1 + 4.166666666666656e-03*G4_1_0_4_0_3_1 + 4.166666666666655e-03*G4_1_0_5_0_0_1 + 8.333333333333309e-03*G4_1_0_5_0_1_1 + 4.166666666666655e-03*G4_1_0_5_0_2_1 + 4.166666666666656e-03*G4_1_0_5_0_3_1 + 4.166666666666654e-03*G4_1_0_6_0_0_1 + 4.166666666666654e-03*G4_1_0_6_0_1_1 + 8.333333333333309e-03*G4_1_0_6_0_2_1 + 4.166666666666655e-03*G4_1_0_6_0_3_1 + 4.166666666666656e-03*G4_1_0_7_0_0_1 + 4.166666666666655e-03*G4_1_0_7_0_1_1 + 4.166666666666655e-03*G4_1_0_7_0_2_1 + 8.333333333333311e-03*G4_1_0_7_0_3_1 + 8.333333333333309e-03*G4_1_1_4_0_4_1 + 4.166666666666654e-03*G4_1_1_4_0_5_1 + 4.166666666666654e-03*G4_1_1_4_0_6_1 + 4.166666666666656e-03*G4_1_1_4_0_7_1 + 4.166666666666654e-03*G4_1_1_5_0_4_1 + 8.333333333333309e-03*G4_1_1_5_0_5_1 + 4.166666666666655e-03*G4_1_1_5_0_6_1 + 4.166666666666656e-03*G4_1_1_5_0_7_1 + 4.166666666666654e-03*G4_1_1_6_0_4_1 + 4.166666666666655e-03*G4_1_1_6_0_5_1 + 8.333333333333309e-03*G4_1_1_6_0_6_1 + 4.166666666666655e-03*G4_1_1_6_0_7_1 + 4.166666666666656e-03*G4_1_1_7_0_4_1 + 4.166666666666656e-03*G4_1_1_7_0_5_1 + 4.166666666666655e-03*G4_1_1_7_0_6_1 + 8.333333333333311e-03*G4_1_1_7_0_7_1 + 8.333333333333309e-03*G4_1_2_4_0_8_1 + 4.166666666666654e-03*G4_1_2_4_0_9_1 + 4.166666666666654e-03*G4_1_2_4_0_10_1 + 4.166666666666656e-03*G4_1_2_4_0_11_1 + 4.166666666666654e-03*G4_1_2_5_0_8_1 + 8.333333333333309e-03*G4_1_2_5_0_9_1 + 4.166666666666655e-03*G4_1_2_5_0_10_1 + 4.166666666666656e-03*G4_1_2_5_0_11_1 + 4.166666666666654e-03*G4_1_2_6_0_8_1 + 4.166666666666655e-03*G4_1_2_6_0_9_1 + 8.333333333333309e-03*G4_1_2_6_0_10_1 + 4.166666666666655e-03*G4_1_2_6_0_11_1 + 4.166666666666656e-03*G4_1_2_7_0_8_1 + 4.166666666666656e-03*G4_1_2_7_0_9_1 + 4.166666666666655e-03*G4_1_2_7_0_10_1 + 8.333333333333311e-03*G4_1_2_7_0_11_1 + 8.333333333333309e-03*G4_2_0_8_0_0_1 + 4.166666666666654e-03*G4_2_0_8_0_1_1 + 4.166666666666654e-03*G4_2_0_8_0_2_1 + 4.166666666666656e-03*G4_2_0_8_0_3_1 + 4.166666666666655e-03*G4_2_0_9_0_0_1 + 8.333333333333309e-03*G4_2_0_9_0_1_1 + 4.166666666666655e-03*G4_2_0_9_0_2_1 + 4.166666666666656e-03*G4_2_0_9_0_3_1 + 4.166666666666654e-03*G4_2_0_10_0_0_1 + 4.166666666666654e-03*G4_2_0_10_0_1_1 + 8.333333333333309e-03*G4_2_0_10_0_2_1 + 4.166666666666655e-03*G4_2_0_10_0_3_1 + 4.166666666666656e-03*G4_2_0_11_0_0_1 + 4.166666666666655e-03*G4_2_0_11_0_1_1 + 4.166666666666655e-03*G4_2_0_11_0_2_1 + 8.333333333333311e-03*G4_2_0_11_0_3_1 + 8.333333333333309e-03*G4_2_1_8_0_4_1 + 4.166666666666654e-03*G4_2_1_8_0_5_1 + 4.166666666666654e-03*G4_2_1_8_0_6_1 + 4.166666666666656e-03*G4_2_1_8_0_7_1 + 4.166666666666654e-03*G4_2_1_9_0_4_1 + 8.333333333333309e-03*G4_2_1_9_0_5_1 + 4.166666666666655e-03*G4_2_1_9_0_6_1 + 4.166666666666656e-03*G4_2_1_9_0_7_1 + 4.166666666666654e-03*G4_2_1_10_0_4_1 + 4.166666666666655e-03*G4_2_1_10_0_5_1 + 8.333333333333309e-03*G4_2_1_10_0_6_1 + 4.166666666666655e-03*G4_2_1_10_0_7_1 + 4.166666666666656e-03*G4_2_1_11_0_4_1 + 4.166666666666656e-03*G4_2_1_11_0_5_1 + 4.166666666666655e-03*G4_2_1_11_0_6_1 + 8.333333333333311e-03*G4_2_1_11_0_7_1 + 8.333333333333309e-03*G4_2_2_8_0_8_1 + 4.166666666666654e-03*G4_2_2_8_0_9_1 + 4.166666666666654e-03*G4_2_2_8_0_10_1 + 4.166666666666656e-03*G4_2_2_8_0_11_1 + 4.166666666666654e-03*G4_2_2_9_0_8_1 + 8.333333333333309e-03*G4_2_2_9_0_9_1 + 4.166666666666655e-03*G4_2_2_9_0_10_1 + 4.166666666666656e-03*G4_2_2_9_0_11_1 + 4.166666666666654e-03*G4_2_2_10_0_8_1 + 4.166666666666655e-03*G4_2_2_10_0_9_1 + 8.333333333333309e-03*G4_2_2_10_0_10_1 + 4.166666666666655e-03*G4_2_2_10_0_11_1 + 4.166666666666656e-03*G4_2_2_11_0_8_1 + 4.166666666666656e-03*G4_2_2_11_0_9_1 + 4.166666666666655e-03*G4_2_2_11_0_10_1 + 8.333333333333311e-03*G4_2_2_11_0_11_1;
    block[15] = 8.333333333333311e-03*G0_ + 8.333333333333322e-02*G1_0_2 + 4.166666666666655e-03*G2_0_0_2 + 8.333333333333309e-03*G2_0_1_2 + 4.166666666666654e-03*G2_0_2_2 + 4.166666666666655e-03*G2_0_3_2 + 4.166666666666654e-03*G2_1_4_2 + 8.333333333333309e-03*G2_1_5_2 + 4.166666666666654e-03*G2_1_6_2 + 4.166666666666655e-03*G2_1_7_2 + 4.166666666666654e-03*G2_2_8_2 + 8.333333333333309e-03*G2_2_9_2 + 4.166666666666654e-03*G2_2_10_2 + 4.166666666666655e-03*G2_2_11_2 + 8.333333333333322e-02*G3_0_0_0_2 + 8.333333333333309e-03*G4_0_0_0_0_0_2 + 4.166666666666654e-03*G4_0_0_0_0_1_2 + 4.166666666666654e-03*G4_0_0_0_0_2_2 + 4.166666666666656e-03*G4_0_0_0_0_3_2 + 4.166666666666654e-03*G4_0_0_1_0_0_2 + 8.333333333333307e-03*G4_0_0_1_0_1_2 + 4.166666666666654e-03*G4_0_0_1_0_2_2 + 4.166666666666655e-03*G4_0_0_1_0_3_2 + 4.166666666666654e-03*G4_0_0_2_0_0_2 + 4.166666666666654e-03*G4_0_0_2_0_1_2 + 8.333333333333309e-03*G4_0_0_2_0_2_2 + 4.166666666666655e-03*G4_0_0_2_0_3_2 + 4.166666666666656e-03*G4_0_0_3_0_0_2 + 4.166666666666655e-03*G4_0_0_3_0_1_2 + 4.166666666666655e-03*G4_0_0_3_0_2_2 + 8.333333333333311e-03*G4_0_0_3_0_3_2 + 8.333333333333309e-03*G4_0_1_0_0_4_2 + 4.166666666666655e-03*G4_0_1_0_0_5_2 + 4.166666666666654e-03*G4_0_1_0_0_6_2 + 4.166666666666656e-03*G4_0_1_0_0_7_2 + 4.166666666666654e-03*G4_0_1_1_0_4_2 + 8.333333333333309e-03*G4_0_1_1_0_5_2 + 4.166666666666654e-03*G4_0_1_1_0_6_2 + 4.166666666666655e-03*G4_0_1_1_0_7_2 + 4.166666666666654e-03*G4_0_1_2_0_4_2 + 4.166666666666655e-03*G4_0_1_2_0_5_2 + 8.333333333333309e-03*G4_0_1_2_0_6_2 + 4.166666666666655e-03*G4_0_1_2_0_7_2 + 4.166666666666656e-03*G4_0_1_3_0_4_2 + 4.166666666666656e-03*G4_0_1_3_0_5_2 + 4.166666666666655e-03*G4_0_1_3_0_6_2 + 8.333333333333311e-03*G4_0_1_3_0_7_2 + 8.333333333333309e-03*G4_0_2_0_0_8_2 + 4.166666666666655e-03*G4_0_2_0_0_9_2 + 4.166666666666654e-03*G4_0_2_0_0_10_2 + 4.166666666666656e-03*G4_0_2_0_0_11_2 + 4.166666666666654e-03*G4_0_2_1_0_8_2 + 8.333333333333309e-03*G4_0_2_1_0_9_2 + 4.166666666666654e-03*G4_0_2_1_0_10_2 + 4.166666666666655e-03*G4_0_2_1_0_11_2 + 4.166666666666654e-03*G4_0_2_2_0_8_2 + 4.166666666666655e-03*G4_0_2_2_0_9_2 + 8.333333333333309e-03*G4_0_2_2_0_10_2 + 4.166666666666655e-03*G4_0_2_2_0_11_2 + 4.166666666666656e-03*G4_0_2_3_0_8_2 + 4.166666666666656e-03*G4_0_2_3_0_9_2 + 4.166666666666655e-03*G4_0_2_3_0_10_2 + 8.333333333333311e-03*G4_0_2_3_0_11_2 + 8.333333333333309e-03*G4_1_0_4_0_0_2 + 4.166666666666654e-03*G4_1_0_4_0_1_2 + 4.166666666666654e-03*G4_1_0_4_0_2_2 + 4.166666666666656e-03*G4_1_0_4_0_3_2 + 4.166666666666655e-03*G4_1_0_5_0_0_2 + 8.333333333333309e-03*G4_1_0_5_0_1_2 + 4.166666666666655e-03*G4_1_0_5_0_2_2 + 4.166666666666656e-03*G4_1_0_5_0_3_2 + 4.166666666666654e-03*G4_1_0_6_0_0_2 + 4.166666666666654e-03*G4_1_0_6_0_1_2 + 8.333333333333309e-03*G4_1_0_6_0_2_2 + 4.166666666666655e-03*G4_1_0_6_0_3_2 + 4.166666666666656e-03*G4_1_0_7_0_0_2 + 4.166666666666655e-03*G4_1_0_7_0_1_2 + 4.166666666666655e-03*G4_1_0_7_0_2_2 + 8.333333333333311e-03*G4_1_0_7_0_3_2 + 8.333333333333309e-03*G4_1_1_4_0_4_2 + 4.166666666666654e-03*G4_1_1_4_0_5_2 + 4.166666666666654e-03*G4_1_1_4_0_6_2 + 4.166666666666656e-03*G4_1_1_4_0_7_2 + 4.166666666666654e-03*G4_1_1_5_0_4_2 + 8.333333333333309e-03*G4_1_1_5_0_5_2 + 4.166666666666655e-03*G4_1_1_5_0_6_2 + 4.166666666666656e-03*G4_1_1_5_0_7_2 + 4.166666666666654e-03*G4_1_1_6_0_4_2 + 4.166666666666655e-03*G4_1_1_6_0_5_2 + 8.333333333333309e-03*G4_1_1_6_0_6_2 + 4.166666666666655e-03*G4_1_1_6_0_7_2 + 4.166666666666656e-03*G4_1_1_7_0_4_2 + 4.166666666666656e-03*G4_1_1_7_0_5_2 + 4.166666666666655e-03*G4_1_1_7_0_6_2 + 8.333333333333311e-03*G4_1_1_7_0_7_2 + 8.333333333333309e-03*G4_1_2_4_0_8_2 + 4.166666666666654e-03*G4_1_2_4_0_9_2 + 4.166666666666654e-03*G4_1_2_4_0_10_2 + 4.166666666666656e-03*G4_1_2_4_0_11_2 + 4.166666666666654e-03*G4_1_2_5_0_8_2 + 8.333333333333309e-03*G4_1_2_5_0_9_2 + 4.166666666666655e-03*G4_1_2_5_0_10_2 + 4.166666666666656e-03*G4_1_2_5_0_11_2 + 4.166666666666654e-03*G4_1_2_6_0_8_2 + 4.166666666666655e-03*G4_1_2_6_0_9_2 + 8.333333333333309e-03*G4_1_2_6_0_10_2 + 4.166666666666655e-03*G4_1_2_6_0_11_2 + 4.166666666666656e-03*G4_1_2_7_0_8_2 + 4.166666666666656e-03*G4_1_2_7_0_9_2 + 4.166666666666655e-03*G4_1_2_7_0_10_2 + 8.333333333333311e-03*G4_1_2_7_0_11_2 + 8.333333333333309e-03*G4_2_0_8_0_0_2 + 4.166666666666654e-03*G4_2_0_8_0_1_2 + 4.166666666666654e-03*G4_2_0_8_0_2_2 + 4.166666666666656e-03*G4_2_0_8_0_3_2 + 4.166666666666655e-03*G4_2_0_9_0_0_2 + 8.333333333333309e-03*G4_2_0_9_0_1_2 + 4.166666666666655e-03*G4_2_0_9_0_2_2 + 4.166666666666656e-03*G4_2_0_9_0_3_2 + 4.166666666666654e-03*G4_2_0_10_0_0_2 + 4.166666666666654e-03*G4_2_0_10_0_1_2 + 8.333333333333309e-03*G4_2_0_10_0_2_2 + 4.166666666666655e-03*G4_2_0_10_0_3_2 + 4.166666666666656e-03*G4_2_0_11_0_0_2 + 4.166666666666655e-03*G4_2_0_11_0_1_2 + 4.166666666666655e-03*G4_2_0_11_0_2_2 + 8.333333333333311e-03*G4_2_0_11_0_3_2 + 8.333333333333309e-03*G4_2_1_8_0_4_2 + 4.166666666666654e-03*G4_2_1_8_0_5_2 + 4.166666666666654e-03*G4_2_1_8_0_6_2 + 4.166666666666656e-03*G4_2_1_8_0_7_2 + 4.166666666666654e-03*G4_2_1_9_0_4_2 + 8.333333333333309e-03*G4_2_1_9_0_5_2 + 4.166666666666655e-03*G4_2_1_9_0_6_2 + 4.166666666666656e-03*G4_2_1_9_0_7_2 + 4.166666666666654e-03*G4_2_1_10_0_4_2 + 4.166666666666655e-03*G4_2_1_10_0_5_2 + 8.333333333333309e-03*G4_2_1_10_0_6_2 + 4.166666666666655e-03*G4_2_1_10_0_7_2 + 4.166666666666656e-03*G4_2_1_11_0_4_2 + 4.166666666666656e-03*G4_2_1_11_0_5_2 + 4.166666666666655e-03*G4_2_1_11_0_6_2 + 8.333333333333311e-03*G4_2_1_11_0_7_2 + 8.333333333333309e-03*G4_2_2_8_0_8_2 + 4.166666666666654e-03*G4_2_2_8_0_9_2 + 4.166666666666654e-03*G4_2_2_8_0_10_2 + 4.166666666666656e-03*G4_2_2_8_0_11_2 + 4.166666666666654e-03*G4_2_2_9_0_8_2 + 8.333333333333309e-03*G4_2_2_9_0_9_2 + 4.166666666666655e-03*G4_2_2_9_0_10_2 + 4.166666666666656e-03*G4_2_2_9_0_11_2 + 4.166666666666654e-03*G4_2_2_10_0_8_2 + 4.166666666666655e-03*G4_2_2_10_0_9_2 + 8.333333333333309e-03*G4_2_2_10_0_10_2 + 4.166666666666655e-03*G4_2_2_10_0_11_2 + 4.166666666666656e-03*G4_2_2_11_0_8_2 + 4.166666666666656e-03*G4_2_2_11_0_9_2 + 4.166666666666655e-03*G4_2_2_11_0_10_2 + 8.333333333333311e-03*G4_2_2_11_0_11_2;
    block[16] = -8.333333333333320e-02*G3_0_1_0_0 - 8.333333333333322e-02*G3_0_1_0_1 - 8.333333333333322e-02*G3_0_1_0_2;
    block[17] = 8.333333333333320e-02*G3_0_1_0_0;
    block[18] = 8.333333333333322e-02*G3_0_1_0_1;
    block[19] = 8.333333333333322e-02*G3_0_1_0_2;
    block[20] = -8.333333333333320e-02*G3_0_2_0_0 - 8.333333333333322e-02*G3_0_2_0_1 - 8.333333333333322e-02*G3_0_2_0_2;
    block[21] = 8.333333333333320e-02*G3_0_2_0_0;
    block[22] = 8.333333333333322e-02*G3_0_2_0_1;
    block[23] = 8.333333333333322e-02*G3_0_2_0_2;
    block[24] = 8.333333333333312e-03*G0_ - 8.333333333333322e-02*G1_1_0 - 8.333333333333323e-02*G1_1_1 - 8.333333333333322e-02*G1_1_2 - 4.166666666666654e-03*G2_0_0_0 - 4.166666666666656e-03*G2_0_0_1 - 4.166666666666655e-03*G2_0_0_2 - 4.166666666666654e-03*G2_0_1_0 - 4.166666666666654e-03*G2_0_1_1 - 4.166666666666654e-03*G2_0_1_2 - 8.333333333333311e-03*G2_0_2_0 - 8.333333333333311e-03*G2_0_2_1 - 8.333333333333311e-03*G2_0_2_2 - 4.166666666666655e-03*G2_0_3_0 - 4.166666666666656e-03*G2_0_3_1 - 4.166666666666655e-03*G2_0_3_2 - 4.166666666666654e-03*G2_1_4_0 - 4.166666666666654e-03*G2_1_4_1 - 4.166666666666654e-03*G2_1_4_2 - 4.166666666666655e-03*G2_1_5_0 - 4.166666666666656e-03*G2_1_5_1 - 4.166666666666654e-03*G2_1_5_2 - 8.333333333333311e-03*G2_1_6_0 - 8.333333333333311e-03*G2_1_6_1 - 8.333333333333311e-03*G2_1_6_2 - 4.166666666666655e-03*G2_1_7_0 - 4.166666666666656e-03*G2_1_7_1 - 4.166666666666655e-03*G2_1_7_2 - 4.166666666666654e-03*G2_2_8_0 - 4.166666666666654e-03*G2_2_8_1 - 4.166666666666654e-03*G2_2_8_2 - 4.166666666666655e-03*G2_2_9_0 - 4.166666666666656e-03*G2_2_9_1 - 4.166666666666654e-03*G2_2_9_2 - 8.333333333333311e-03*G2_2_10_0 - 8.333333333333311e-03*G2_2_10_1 - 8.333333333333311e-03*G2_2_10_2 - 4.166666666666655e-03*G2_2_11_0 - 4.166666666666656e-03*G2_2_11_1 - 4.166666666666655e-03*G2_2_11_2 - 8.333333333333322e-02*G3_0_0_1_0 - 8.333333333333323e-02*G3_0_0_1_1 - 8.333333333333322e-02*G3_0_0_1_2 - 8.333333333333309e-03*G4_0_0_0_1_0_0 - 8.333333333333311e-03*G4_0_0_0_1_0_1 - 8.333333333333311e-03*G4_0_0_0_1_0_2 - 4.166666666666654e-03*G4_0_0_0_1_1_0 - 4.166666666666655e-03*G4_0_0_0_1_1_1 - 4.166666666666654e-03*G4_0_0_0_1_1_2 - 4.166666666666654e-03*G4_0_0_0_1_2_0 - 4.166666666666656e-03*G4_0_0_0_1_2_1 - 4.166666666666655e-03*G4_0_0_0_1_2_2 - 4.166666666666656e-03*G4_0_0_0_1_3_0 - 4.166666666666657e-03*G4_0_0_0_1_3_1 - 4.166666666666657e-03*G4_0_0_0_1_3_2 - 4.166666666666654e-03*G4_0_0_1_1_0_0 - 4.166666666666655e-03*G4_0_0_1_1_0_1 - 4.166666666666654e-03*G4_0_0_1_1_0_2 - 8.333333333333307e-03*G4_0_0_1_1_1_0 - 8.333333333333309e-03*G4_0_0_1_1_1_1 - 8.333333333333307e-03*G4_0_0_1_1_1_2 - 4.166666666666654e-03*G4_0_0_1_1_2_0 - 4.166666666666654e-03*G4_0_0_1_1_2_1 - 4.166666666666654e-03*G4_0_0_1_1_2_2 - 4.166666666666655e-03*G4_0_0_1_1_3_0 - 4.166666666666655e-03*G4_0_0_1_1_3_1 - 4.166666666666655e-03*G4_0_0_1_1_3_2 - 4.166666666666654e-03*G4_0_0_2_1_0_0 - 4.166666666666656e-03*G4_0_0_2_1_0_1 - 4.166666666666655e-03*G4_0_0_2_1_0_2 - 4.166666666666654e-03*G4_0_0_2_1_1_0 - 4.166666666666654e-03*G4_0_0_2_1_1_1 - 4.166666666666654e-03*G4_0_0_2_1_1_2 - 8.333333333333311e-03*G4_0_0_2_1_2_0 - 8.333333333333311e-03*G4_0_0_2_1_2_1 - 8.333333333333311e-03*G4_0_0_2_1_2_2 - 4.166666666666655e-03*G4_0_0_2_1_3_0 - 4.166666666666656e-03*G4_0_0_2_1_3_1 - 4.166666666666655e-03*G4_0_0_2_1_3_2 - 4.166666666666656e-03*G4_0_0_3_1_0_0 - 4.166666666666657e-03*G4_0_0_3_1_0_1 - 4.166666666666657e-03*G4_0_0_3_1_0_2 - 4.166666666666655e-03*G4_0_0_3_1_1_0 - 4.166666666666655e-03*G4_0_0_3_1_1_1 - 4.166666666666655e-03*G4_0_0_3_1_1_2 - 4.166666666666655e-03*G4_0_0_3_1_2_0 - 4.166666666666656e-03*G4_0_0_3_1_2_1 - 4.166666666666655e-03*G4_0_0_3_1_2_2 - 8.333333333333311e-03*G4_0_0_3_1_3_0 - 8.333333333333311e-03*G4_0_0_3_1_3_1 - 8.333333333333311e-03*G4_0_0_3_1_3_2 - 8.333333333333309e-03*G4_0_1_0_1_4_0 - 8.333333333333311e-03*G4_0_1_0_1_4_1 - 8.333333333333311e-03*G4_0_1_0_1_4_2 - 4.166666666666655e-03*G4_0_1_0_1_5_0 - 4.166666666666655e-03*G4_0_1_0_1_5_1 - 4.166666666666655e-03*G4_0_1_0_1_5_2 - 4.166666666666654e-03*G4_0_1_0_1_6_0 - 4.166666666666656e-03*G4_0_1_0_1_6_1 - 4.166666666666655e-03*G4_0_1_0_1_6_2 - 4.166666666666656e-03*G4_0_1_0_1_7_0 - 4.166666666666657e-03*G4_0_1_0_1_7_1 - 4.166666666666657e-03*G4_0_1_0_1_7_2 - 4.166666666666654e-03*G4_0_1_1_1_4_0 - 4.166666666666654e-03*G4_0_1_1_1_4_1 - 4.166666666666654e-03*G4_0_1_1_1_4_2 - 8.333333333333309e-03*G4_0_1_1_1_5_0 - 8.333333333333309e-03*G4_0_1_1_1_5_1 - 8.333333333333307e-03*G4_0_1_1_1_5_2 - 4.166666666666654e-03*G4_0_1_1_1_6_0 - 4.166666666666654e-03*G4_0_1_1_1_6_1 - 4.166666666666654e-03*G4_0_1_1_1_6_2 - 4.166666666666655e-03*G4_0_1_1_1_7_0 - 4.166666666666655e-03*G4_0_1_1_1_7_1 - 4.166666666666655e-03*G4_0_1_1_1_7_2 - 4.166666666666654e-03*G4_0_1_2_1_4_0 - 4.166666666666654e-03*G4_0_1_2_1_4_1 - 4.166666666666654e-03*G4_0_1_2_1_4_2 - 4.166666666666655e-03*G4_0_1_2_1_5_0 - 4.166666666666656e-03*G4_0_1_2_1_5_1 - 4.166666666666654e-03*G4_0_1_2_1_5_2 - 8.333333333333311e-03*G4_0_1_2_1_6_0 - 8.333333333333311e-03*G4_0_1_2_1_6_1 - 8.333333333333311e-03*G4_0_1_2_1_6_2 - 4.166666666666655e-03*G4_0_1_2_1_7_0 - 4.166666666666656e-03*G4_0_1_2_1_7_1 - 4.166666666666655e-03*G4_0_1_2_1_7_2 - 4.166666666666656e-03*G4_0_1_3_1_4_0 - 4.166666666666657e-03*G4_0_1_3_1_4_1 - 4.166666666666657e-03*G4_0_1_3_1_4_2 - 4.166666666666656e-03*G4_0_1_3_1_5_0 - 4.166666666666657e-03*G4_0_1_3_1_5_1 - 4.166666666666656e-03*G4_0_1_3_1_5_2 - 4.166666666666655e-03*G4_0_1_3_1_6_0 - 4.166666666666656e-03*G4_0_1_3_1_6_1 - 4.166666666666655e-03*G4_0_1_3_1_6_2 - 8.333333333333311e-03*G4_0_1_3_1_7_0 - 8.333333333333311e-03*G4_0_1_3_1_7_1 - 8.333333333333311e-03*G4_0_1_3_1_7_2 - 8.333333333333309e-03*G4_0_2_0_1_8_0 - 8.333333333333311e-03*G4_0_2_0_1_8_1 - 8.333333333333311e-03*G4_0_2_0_1_8_2 - 4.166666666666655e-03*G4_0_2_0_1_9_0 - 4.166666666666655e-03*G4_0_2_0_1_9_1 - 4.166666666666655e-03*G4_0_2_0_1_9_2 - 4.166666666666654e-03*G4_0_2_0_1_10_0 - 4.166666666666656e-03*G4_0_2_0_1_10_1 - 4.166666666666655e-03*G4_0_2_0_1_10_2 - 4.166666666666656e-03*G4_0_2_0_1_11_0 - 4.166666666666657e-03*G4_0_2_0_1_11_1 - 4.166666666666657e-03*G4_0_2_0_1_11_2 - 4.166666666666654e-03*G4_0_2_1_1_8_0 - 4.166666666666654e-03*G4_0_2_1_1_8_1 - 4.166666666666654e-03*G4_0_2_1_1_8_2 - 8.333333333333309e-03*G4_0_2_1_1_9_0 - 8.333333333333309e-03*G4_0_2_1_1_9_1 - 8.333333333333307e-03*G4_0_2_1_1_9_2 - 4.166666666666654e-03*G4_0_2_1_1_10_0 - 4.166666666666654e-03*G4_0_2_1_1_10_1 - 4.166666666666654e-03*G4_0_2_1_1_10_2 - 4.166666666666655e-03*G4_0_2_1_1_11_0 - 4.166666666666655e-03*G4_0_2_1_1_11_1 - 4.166666666666655e-03*G4_0_2_1_1_11_2 - 4.166666666666654e-03*G4_0_2_2_1_8_0 - 4.166666666666654e-03*G4_0_2_2_1_8_1 - 4.166666666666654e-03*G4_0_2_2_1_8_2 - 4.166666666666655e-03*G4_0_2_2_1_9_0 - 4.166666666666656e-03*G4_0_2_2_1_9_1 - 4.166666666666654e-03*G4_0_2_2_1_9_2 - 8.333333333333311e-03*G4_0_2_2_1_10_0 - 8.333333333333311e-03*G4_0_2_2_1_10_1 - 8.333333333333311e-03*G4_0_2_2_1_10_2 - 4.166666666666655e-03*G4_0_2_2_1_11_0 - 4.166666666666656e-03*G4_0_2_2_1_11_1 - 4.166666666666655e-03*G4_0_2_2_1_11_2 - 4.166666666666656e-03*G4_0_2_3_1_8_0 - 4.166666666666657e-03*G4_0_2_3_1_8_1 - 4.166666666666657e-03*G4_0_2_3_1_8_2 - 4.166666666666656e-03*G4_0_2_3_1_9_0 - 4.166666666666657e-03*G4_0_2_3_1_9_1 - 4.166666666666656e-03*G4_0_2_3_1_9_2 - 4.166666666666655e-03*G4_0_2_3_1_10_0 - 4.166666666666656e-03*G4_0_2_3_1_10_1 - 4.166666666666655e-03*G4_0_2_3_1_10_2 - 8.333333333333311e-03*G4_0_2_3_1_11_0 - 8.333333333333311e-03*G4_0_2_3_1_11_1 - 8.333333333333311e-03*G4_0_2_3_1_11_2 - 8.333333333333309e-03*G4_1_0_4_1_0_0 - 8.333333333333311e-03*G4_1_0_4_1_0_1 - 8.333333333333311e-03*G4_1_0_4_1_0_2 - 4.166666666666654e-03*G4_1_0_4_1_1_0 - 4.166666666666654e-03*G4_1_0_4_1_1_1 - 4.166666666666654e-03*G4_1_0_4_1_1_2 - 4.166666666666654e-03*G4_1_0_4_1_2_0 - 4.166666666666654e-03*G4_1_0_4_1_2_1 - 4.166666666666654e-03*G4_1_0_4_1_2_2 - 4.166666666666656e-03*G4_1_0_4_1_3_0 - 4.166666666666657e-03*G4_1_0_4_1_3_1 - 4.166666666666657e-03*G4_1_0_4_1_3_2 - 4.166666666666655e-03*G4_1_0_5_1_0_0 - 4.166666666666655e-03*G4_1_0_5_1_0_1 - 4.166666666666655e-03*G4_1_0_5_1_0_2 - 8.333333333333309e-03*G4_1_0_5_1_1_0 - 8.333333333333309e-03*G4_1_0_5_1_1_1 - 8.333333333333307e-03*G4_1_0_5_1_1_2 - 4.166666666666655e-03*G4_1_0_5_1_2_0 - 4.166666666666656e-03*G4_1_0_5_1_2_1 - 4.166666666666654e-03*G4_1_0_5_1_2_2 - 4.166666666666656e-03*G4_1_0_5_1_3_0 - 4.166666666666657e-03*G4_1_0_5_1_3_1 - 4.166666666666656e-03*G4_1_0_5_1_3_2 - 4.166666666666654e-03*G4_1_0_6_1_0_0 - 4.166666666666656e-03*G4_1_0_6_1_0_1 - 4.166666666666655e-03*G4_1_0_6_1_0_2 - 4.166666666666654e-03*G4_1_0_6_1_1_0 - 4.166666666666654e-03*G4_1_0_6_1_1_1 - 4.166666666666654e-03*G4_1_0_6_1_1_2 - 8.333333333333311e-03*G4_1_0_6_1_2_0 - 8.333333333333311e-03*G4_1_0_6_1_2_1 - 8.333333333333311e-03*G4_1_0_6_1_2_2 - 4.166666666666655e-03*G4_1_0_6_1_3_0 - 4.166666666666656e-03*G4_1_0_6_1_3_1 - 4.166666666666655e-03*G4_1_0_6_1_3_2 - 4.166666666666656e-03*G4_1_0_7_1_0_0 - 4.166666666666657e-03*G4_1_0_7_1_0_1 - 4.166666666666657e-03*G4_1_0_7_1_0_2 - 4.166666666666655e-03*G4_1_0_7_1_1_0 - 4.166666666666655e-03*G4_1_0_7_1_1_1 - 4.166666666666655e-03*G4_1_0_7_1_1_2 - 4.166666666666655e-03*G4_1_0_7_1_2_0 - 4.166666666666656e-03*G4_1_0_7_1_2_1 - 4.166666666666655e-03*G4_1_0_7_1_2_2 - 8.333333333333311e-03*G4_1_0_7_1_3_0 - 8.333333333333311e-03*G4_1_0_7_1_3_1 - 8.333333333333311e-03*G4_1_0_7_1_3_2 - 8.333333333333309e-03*G4_1_1_4_1_4_0 - 8.333333333333311e-03*G4_1_1_4_1_4_1 - 8.333333333333311e-03*G4_1_1_4_1_4_2 - 4.166666666666654e-03*G4_1_1_4_1_5_0 - 4.166666666666654e-03*G4_1_1_4_1_5_1 - 4.166666666666654e-03*G4_1_1_4_1_5_2 - 4.166666666666654e-03*G4_1_1_4_1_6_0 - 4.166666666666654e-03*G4_1_1_4_1_6_1 - 4.166666666666654e-03*G4_1_1_4_1_6_2 - 4.166666666666656e-03*G4_1_1_4_1_7_0 - 4.166666666666657e-03*G4_1_1_4_1_7_1 - 4.166666666666657e-03*G4_1_1_4_1_7_2 - 4.166666666666654e-03*G4_1_1_5_1_4_0 - 4.166666666666654e-03*G4_1_1_5_1_4_1 - 4.166666666666654e-03*G4_1_1_5_1_4_2 - 8.333333333333309e-03*G4_1_1_5_1_5_0 - 8.333333333333309e-03*G4_1_1_5_1_5_1 - 8.333333333333307e-03*G4_1_1_5_1_5_2 - 4.166666666666655e-03*G4_1_1_5_1_6_0 - 4.166666666666656e-03*G4_1_1_5_1_6_1 - 4.166666666666654e-03*G4_1_1_5_1_6_2 - 4.166666666666656e-03*G4_1_1_5_1_7_0 - 4.166666666666657e-03*G4_1_1_5_1_7_1 - 4.166666666666656e-03*G4_1_1_5_1_7_2 - 4.166666666666654e-03*G4_1_1_6_1_4_0 - 4.166666666666654e-03*G4_1_1_6_1_4_1 - 4.166666666666654e-03*G4_1_1_6_1_4_2 - 4.166666666666655e-03*G4_1_1_6_1_5_0 - 4.166666666666656e-03*G4_1_1_6_1_5_1 - 4.166666666666654e-03*G4_1_1_6_1_5_2 - 8.333333333333311e-03*G4_1_1_6_1_6_0 - 8.333333333333311e-03*G4_1_1_6_1_6_1 - 8.333333333333311e-03*G4_1_1_6_1_6_2 - 4.166666666666655e-03*G4_1_1_6_1_7_0 - 4.166666666666656e-03*G4_1_1_6_1_7_1 - 4.166666666666655e-03*G4_1_1_6_1_7_2 - 4.166666666666656e-03*G4_1_1_7_1_4_0 - 4.166666666666657e-03*G4_1_1_7_1_4_1 - 4.166666666666657e-03*G4_1_1_7_1_4_2 - 4.166666666666656e-03*G4_1_1_7_1_5_0 - 4.166666666666657e-03*G4_1_1_7_1_5_1 - 4.166666666666656e-03*G4_1_1_7_1_5_2 - 4.166666666666655e-03*G4_1_1_7_1_6_0 - 4.166666666666656e-03*G4_1_1_7_1_6_1 - 4.166666666666655e-03*G4_1_1_7_1_6_2 - 8.333333333333311e-03*G4_1_1_7_1_7_0 - 8.333333333333311e-03*G4_1_1_7_1_7_1 - 8.333333333333311e-03*G4_1_1_7_1_7_2 - 8.333333333333309e-03*G4_1_2_4_1_8_0 - 8.333333333333311e-03*G4_1_2_4_1_8_1 - 8.333333333333311e-03*G4_1_2_4_1_8_2 - 4.166666666666654e-03*G4_1_2_4_1_9_0 - 4.166666666666654e-03*G4_1_2_4_1_9_1 - 4.166666666666654e-03*G4_1_2_4_1_9_2 - 4.166666666666654e-03*G4_1_2_4_1_10_0 - 4.166666666666654e-03*G4_1_2_4_1_10_1 - 4.166666666666654e-03*G4_1_2_4_1_10_2 - 4.166666666666656e-03*G4_1_2_4_1_11_0 - 4.166666666666657e-03*G4_1_2_4_1_11_1 - 4.166666666666657e-03*G4_1_2_4_1_11_2 - 4.166666666666654e-03*G4_1_2_5_1_8_0 - 4.166666666666654e-03*G4_1_2_5_1_8_1 - 4.166666666666654e-03*G4_1_2_5_1_8_2 - 8.333333333333309e-03*G4_1_2_5_1_9_0 - 8.333333333333309e-03*G4_1_2_5_1_9_1 - 8.333333333333307e-03*G4_1_2_5_1_9_2 - 4.166666666666655e-03*G4_1_2_5_1_10_0 - 4.166666666666656e-03*G4_1_2_5_1_10_1 - 4.166666666666654e-03*G4_1_2_5_1_10_2 - 4.166666666666656e-03*G4_1_2_5_1_11_0 - 4.166666666666657e-03*G4_1_2_5_1_11_1 - 4.166666666666656e-03*G4_1_2_5_1_11_2 - 4.166666666666654e-03*G4_1_2_6_1_8_0 - 4.166666666666654e-03*G4_1_2_6_1_8_1 - 4.166666666666654e-03*G4_1_2_6_1_8_2 - 4.166666666666655e-03*G4_1_2_6_1_9_0 - 4.166666666666656e-03*G4_1_2_6_1_9_1 - 4.166666666666654e-03*G4_1_2_6_1_9_2 - 8.333333333333311e-03*G4_1_2_6_1_10_0 - 8.333333333333311e-03*G4_1_2_6_1_10_1 - 8.333333333333311e-03*G4_1_2_6_1_10_2 - 4.166666666666655e-03*G4_1_2_6_1_11_0 - 4.166666666666656e-03*G4_1_2_6_1_11_1 - 4.166666666666655e-03*G4_1_2_6_1_11_2 - 4.166666666666656e-03*G4_1_2_7_1_8_0 - 4.166666666666657e-03*G4_1_2_7_1_8_1 - 4.166666666666657e-03*G4_1_2_7_1_8_2 - 4.166666666666656e-03*G4_1_2_7_1_9_0 - 4.166666666666657e-03*G4_1_2_7_1_9_1 - 4.166666666666656e-03*G4_1_2_7_1_9_2 - 4.166666666666655e-03*G4_1_2_7_1_10_0 - 4.166666666666656e-03*G4_1_2_7_1_10_1 - 4.166666666666655e-03*G4_1_2_7_1_10_2 - 8.333333333333311e-03*G4_1_2_7_1_11_0 - 8.333333333333311e-03*G4_1_2_7_1_11_1 - 8.333333333333311e-03*G4_1_2_7_1_11_2 - 8.333333333333309e-03*G4_2_0_8_1_0_0 - 8.333333333333311e-03*G4_2_0_8_1_0_1 - 8.333333333333311e-03*G4_2_0_8_1_0_2 - 4.166666666666654e-03*G4_2_0_8_1_1_0 - 4.166666666666654e-03*G4_2_0_8_1_1_1 - 4.166666666666654e-03*G4_2_0_8_1_1_2 - 4.166666666666654e-03*G4_2_0_8_1_2_0 - 4.166666666666654e-03*G4_2_0_8_1_2_1 - 4.166666666666654e-03*G4_2_0_8_1_2_2 - 4.166666666666656e-03*G4_2_0_8_1_3_0 - 4.166666666666657e-03*G4_2_0_8_1_3_1 - 4.166666666666657e-03*G4_2_0_8_1_3_2 - 4.166666666666655e-03*G4_2_0_9_1_0_0 - 4.166666666666655e-03*G4_2_0_9_1_0_1 - 4.166666666666655e-03*G4_2_0_9_1_0_2 - 8.333333333333309e-03*G4_2_0_9_1_1_0 - 8.333333333333309e-03*G4_2_0_9_1_1_1 - 8.333333333333307e-03*G4_2_0_9_1_1_2 - 4.166666666666655e-03*G4_2_0_9_1_2_0 - 4.166666666666656e-03*G4_2_0_9_1_2_1 - 4.166666666666654e-03*G4_2_0_9_1_2_2 - 4.166666666666656e-03*G4_2_0_9_1_3_0 - 4.166666666666657e-03*G4_2_0_9_1_3_1 - 4.166666666666656e-03*G4_2_0_9_1_3_2 - 4.166666666666654e-03*G4_2_0_10_1_0_0 - 4.166666666666656e-03*G4_2_0_10_1_0_1 - 4.166666666666655e-03*G4_2_0_10_1_0_2 - 4.166666666666654e-03*G4_2_0_10_1_1_0 - 4.166666666666654e-03*G4_2_0_10_1_1_1 - 4.166666666666654e-03*G4_2_0_10_1_1_2 - 8.333333333333311e-03*G4_2_0_10_1_2_0 - 8.333333333333311e-03*G4_2_0_10_1_2_1 - 8.333333333333311e-03*G4_2_0_10_1_2_2 - 4.166666666666655e-03*G4_2_0_10_1_3_0 - 4.166666666666656e-03*G4_2_0_10_1_3_1 - 4.166666666666655e-03*G4_2_0_10_1_3_2 - 4.166666666666656e-03*G4_2_0_11_1_0_0 - 4.166666666666657e-03*G4_2_0_11_1_0_1 - 4.166666666666657e-03*G4_2_0_11_1_0_2 - 4.166666666666655e-03*G4_2_0_11_1_1_0 - 4.166666666666655e-03*G4_2_0_11_1_1_1 - 4.166666666666655e-03*G4_2_0_11_1_1_2 - 4.166666666666655e-03*G4_2_0_11_1_2_0 - 4.166666666666656e-03*G4_2_0_11_1_2_1 - 4.166666666666655e-03*G4_2_0_11_1_2_2 - 8.333333333333311e-03*G4_2_0_11_1_3_0 - 8.333333333333311e-03*G4_2_0_11_1_3_1 - 8.333333333333311e-03*G4_2_0_11_1_3_2 - 8.333333333333309e-03*G4_2_1_8_1_4_0 - 8.333333333333311e-03*G4_2_1_8_1_4_1 - 8.333333333333311e-03*G4_2_1_8_1_4_2 - 4.166666666666654e-03*G4_2_1_8_1_5_0 - 4.166666666666654e-03*G4_2_1_8_1_5_1 - 4.166666666666654e-03*G4_2_1_8_1_5_2 - 4.166666666666654e-03*G4_2_1_8_1_6_0 - 4.166666666666654e-03*G4_2_1_8_1_6_1 - 4.166666666666654e-03*G4_2_1_8_1_6_2 - 4.166666666666656e-03*G4_2_1_8_1_7_0 - 4.166666666666657e-03*G4_2_1_8_1_7_1 - 4.166666666666657e-03*G4_2_1_8_1_7_2 - 4.166666666666654e-03*G4_2_1_9_1_4_0 - 4.166666666666654e-03*G4_2_1_9_1_4_1 - 4.166666666666654e-03*G4_2_1_9_1_4_2 - 8.333333333333309e-03*G4_2_1_9_1_5_0 - 8.333333333333309e-03*G4_2_1_9_1_5_1 - 8.333333333333307e-03*G4_2_1_9_1_5_2 - 4.166666666666655e-03*G4_2_1_9_1_6_0 - 4.166666666666656e-03*G4_2_1_9_1_6_1 - 4.166666666666654e-03*G4_2_1_9_1_6_2 - 4.166666666666656e-03*G4_2_1_9_1_7_0 - 4.166666666666657e-03*G4_2_1_9_1_7_1 - 4.166666666666656e-03*G4_2_1_9_1_7_2 - 4.166666666666654e-03*G4_2_1_10_1_4_0 - 4.166666666666654e-03*G4_2_1_10_1_4_1 - 4.166666666666654e-03*G4_2_1_10_1_4_2 - 4.166666666666655e-03*G4_2_1_10_1_5_0 - 4.166666666666656e-03*G4_2_1_10_1_5_1 - 4.166666666666654e-03*G4_2_1_10_1_5_2 - 8.333333333333311e-03*G4_2_1_10_1_6_0 - 8.333333333333311e-03*G4_2_1_10_1_6_1 - 8.333333333333311e-03*G4_2_1_10_1_6_2 - 4.166666666666655e-03*G4_2_1_10_1_7_0 - 4.166666666666656e-03*G4_2_1_10_1_7_1 - 4.166666666666655e-03*G4_2_1_10_1_7_2 - 4.166666666666656e-03*G4_2_1_11_1_4_0 - 4.166666666666657e-03*G4_2_1_11_1_4_1 - 4.166666666666657e-03*G4_2_1_11_1_4_2 - 4.166666666666656e-03*G4_2_1_11_1_5_0 - 4.166666666666657e-03*G4_2_1_11_1_5_1 - 4.166666666666656e-03*G4_2_1_11_1_5_2 - 4.166666666666655e-03*G4_2_1_11_1_6_0 - 4.166666666666656e-03*G4_2_1_11_1_6_1 - 4.166666666666655e-03*G4_2_1_11_1_6_2 - 8.333333333333311e-03*G4_2_1_11_1_7_0 - 8.333333333333311e-03*G4_2_1_11_1_7_1 - 8.333333333333311e-03*G4_2_1_11_1_7_2 - 8.333333333333309e-03*G4_2_2_8_1_8_0 - 8.333333333333311e-03*G4_2_2_8_1_8_1 - 8.333333333333311e-03*G4_2_2_8_1_8_2 - 4.166666666666654e-03*G4_2_2_8_1_9_0 - 4.166666666666654e-03*G4_2_2_8_1_9_1 - 4.166666666666654e-03*G4_2_2_8_1_9_2 - 4.166666666666654e-03*G4_2_2_8_1_10_0 - 4.166666666666654e-03*G4_2_2_8_1_10_1 - 4.166666666666654e-03*G4_2_2_8_1_10_2 - 4.166666666666656e-03*G4_2_2_8_1_11_0 - 4.166666666666657e-03*G4_2_2_8_1_11_1 - 4.166666666666657e-03*G4_2_2_8_1_11_2 - 4.166666666666654e-03*G4_2_2_9_1_8_0 - 4.166666666666654e-03*G4_2_2_9_1_8_1 - 4.166666666666654e-03*G4_2_2_9_1_8_2 - 8.333333333333309e-03*G4_2_2_9_1_9_0 - 8.333333333333309e-03*G4_2_2_9_1_9_1 - 8.333333333333307e-03*G4_2_2_9_1_9_2 - 4.166666666666655e-03*G4_2_2_9_1_10_0 - 4.166666666666656e-03*G4_2_2_9_1_10_1 - 4.166666666666654e-03*G4_2_2_9_1_10_2 - 4.166666666666656e-03*G4_2_2_9_1_11_0 - 4.166666666666657e-03*G4_2_2_9_1_11_1 - 4.166666666666656e-03*G4_2_2_9_1_11_2 - 4.166666666666654e-03*G4_2_2_10_1_8_0 - 4.166666666666654e-03*G4_2_2_10_1_8_1 - 4.166666666666654e-03*G4_2_2_10_1_8_2 - 4.166666666666655e-03*G4_2_2_10_1_9_0 - 4.166666666666656e-03*G4_2_2_10_1_9_1 - 4.166666666666654e-03*G4_2_2_10_1_9_2 - 8.333333333333311e-03*G4_2_2_10_1_10_0 - 8.333333333333311e-03*G4_2_2_10_1_10_1 - 8.333333333333311e-03*G4_2_2_10_1_10_2 - 4.166666666666655e-03*G4_2_2_10_1_11_0 - 4.166666666666656e-03*G4_2_2_10_1_11_1 - 4.166666666666655e-03*G4_2_2_10_1_11_2 - 4.166666666666656e-03*G4_2_2_11_1_8_0 - 4.166666666666657e-03*G4_2_2_11_1_8_1 - 4.166666666666657e-03*G4_2_2_11_1_8_2 - 4.166666666666656e-03*G4_2_2_11_1_9_0 - 4.166666666666657e-03*G4_2_2_11_1_9_1 - 4.166666666666656e-03*G4_2_2_11_1_9_2 - 4.166666666666655e-03*G4_2_2_11_1_10_0 - 4.166666666666656e-03*G4_2_2_11_1_10_1 - 4.166666666666655e-03*G4_2_2_11_1_10_2 - 8.333333333333311e-03*G4_2_2_11_1_11_0 - 8.333333333333311e-03*G4_2_2_11_1_11_1 - 8.333333333333311e-03*G4_2_2_11_1_11_2;
    block[25] = 8.333333333333309e-03*G0_ + 8.333333333333322e-02*G1_1_0 + 4.166666666666654e-03*G2_0_0_0 + 4.166666666666654e-03*G2_0_1_0 + 8.333333333333311e-03*G2_0_2_0 + 4.166666666666655e-03*G2_0_3_0 + 4.166666666666654e-03*G2_1_4_0 + 4.166666666666655e-03*G2_1_5_0 + 8.333333333333311e-03*G2_1_6_0 + 4.166666666666655e-03*G2_1_7_0 + 4.166666666666654e-03*G2_2_8_0 + 4.166666666666655e-03*G2_2_9_0 + 8.333333333333311e-03*G2_2_10_0 + 4.166666666666655e-03*G2_2_11_0 + 8.333333333333322e-02*G3_0_0_1_0 + 8.333333333333309e-03*G4_0_0_0_1_0_0 + 4.166666666666654e-03*G4_0_0_0_1_1_0 + 4.166666666666654e-03*G4_0_0_0_1_2_0 + 4.166666666666656e-03*G4_0_0_0_1_3_0 + 4.166666666666654e-03*G4_0_0_1_1_0_0 + 8.333333333333307e-03*G4_0_0_1_1_1_0 + 4.166666666666654e-03*G4_0_0_1_1_2_0 + 4.166666666666655e-03*G4_0_0_1_1_3_0 + 4.166666666666654e-03*G4_0_0_2_1_0_0 + 4.166666666666654e-03*G4_0_0_2_1_1_0 + 8.333333333333311e-03*G4_0_0_2_1_2_0 + 4.166666666666655e-03*G4_0_0_2_1_3_0 + 4.166666666666656e-03*G4_0_0_3_1_0_0 + 4.166666666666655e-03*G4_0_0_3_1_1_0 + 4.166666666666655e-03*G4_0_0_3_1_2_0 + 8.333333333333311e-03*G4_0_0_3_1_3_0 + 8.333333333333309e-03*G4_0_1_0_1_4_0 + 4.166666666666655e-03*G4_0_1_0_1_5_0 + 4.166666666666654e-03*G4_0_1_0_1_6_0 + 4.166666666666656e-03*G4_0_1_0_1_7_0 + 4.166666666666654e-03*G4_0_1_1_1_4_0 + 8.333333333333309e-03*G4_0_1_1_1_5_0 + 4.166666666666654e-03*G4_0_1_1_1_6_0 + 4.166666666666655e-03*G4_0_1_1_1_7_0 + 4.166666666666654e-03*G4_0_1_2_1_4_0 + 4.166666666666655e-03*G4_0_1_2_1_5_0 + 8.333333333333311e-03*G4_0_1_2_1_6_0 + 4.166666666666655e-03*G4_0_1_2_1_7_0 + 4.166666666666656e-03*G4_0_1_3_1_4_0 + 4.166666666666656e-03*G4_0_1_3_1_5_0 + 4.166666666666655e-03*G4_0_1_3_1_6_0 + 8.333333333333311e-03*G4_0_1_3_1_7_0 + 8.333333333333309e-03*G4_0_2_0_1_8_0 + 4.166666666666655e-03*G4_0_2_0_1_9_0 + 4.166666666666654e-03*G4_0_2_0_1_10_0 + 4.166666666666656e-03*G4_0_2_0_1_11_0 + 4.166666666666654e-03*G4_0_2_1_1_8_0 + 8.333333333333309e-03*G4_0_2_1_1_9_0 + 4.166666666666654e-03*G4_0_2_1_1_10_0 + 4.166666666666655e-03*G4_0_2_1_1_11_0 + 4.166666666666654e-03*G4_0_2_2_1_8_0 + 4.166666666666655e-03*G4_0_2_2_1_9_0 + 8.333333333333311e-03*G4_0_2_2_1_10_0 + 4.166666666666655e-03*G4_0_2_2_1_11_0 + 4.166666666666656e-03*G4_0_2_3_1_8_0 + 4.166666666666656e-03*G4_0_2_3_1_9_0 + 4.166666666666655e-03*G4_0_2_3_1_10_0 + 8.333333333333311e-03*G4_0_2_3_1_11_0 + 8.333333333333309e-03*G4_1_0_4_1_0_0 + 4.166666666666654e-03*G4_1_0_4_1_1_0 + 4.166666666666654e-03*G4_1_0_4_1_2_0 + 4.166666666666656e-03*G4_1_0_4_1_3_0 + 4.166666666666655e-03*G4_1_0_5_1_0_0 + 8.333333333333309e-03*G4_1_0_5_1_1_0 + 4.166666666666655e-03*G4_1_0_5_1_2_0 + 4.166666666666656e-03*G4_1_0_5_1_3_0 + 4.166666666666654e-03*G4_1_0_6_1_0_0 + 4.166666666666654e-03*G4_1_0_6_1_1_0 + 8.333333333333311e-03*G4_1_0_6_1_2_0 + 4.166666666666655e-03*G4_1_0_6_1_3_0 + 4.166666666666656e-03*G4_1_0_7_1_0_0 + 4.166666666666655e-03*G4_1_0_7_1_1_0 + 4.166666666666655e-03*G4_1_0_7_1_2_0 + 8.333333333333311e-03*G4_1_0_7_1_3_0 + 8.333333333333309e-03*G4_1_1_4_1_4_0 + 4.166666666666654e-03*G4_1_1_4_1_5_0 + 4.166666666666654e-03*G4_1_1_4_1_6_0 + 4.166666666666656e-03*G4_1_1_4_1_7_0 + 4.166666666666654e-03*G4_1_1_5_1_4_0 + 8.333333333333309e-03*G4_1_1_5_1_5_0 + 4.166666666666655e-03*G4_1_1_5_1_6_0 + 4.166666666666656e-03*G4_1_1_5_1_7_0 + 4.166666666666654e-03*G4_1_1_6_1_4_0 + 4.166666666666655e-03*G4_1_1_6_1_5_0 + 8.333333333333311e-03*G4_1_1_6_1_6_0 + 4.166666666666655e-03*G4_1_1_6_1_7_0 + 4.166666666666656e-03*G4_1_1_7_1_4_0 + 4.166666666666656e-03*G4_1_1_7_1_5_0 + 4.166666666666655e-03*G4_1_1_7_1_6_0 + 8.333333333333311e-03*G4_1_1_7_1_7_0 + 8.333333333333309e-03*G4_1_2_4_1_8_0 + 4.166666666666654e-03*G4_1_2_4_1_9_0 + 4.166666666666654e-03*G4_1_2_4_1_10_0 + 4.166666666666656e-03*G4_1_2_4_1_11_0 + 4.166666666666654e-03*G4_1_2_5_1_8_0 + 8.333333333333309e-03*G4_1_2_5_1_9_0 + 4.166666666666655e-03*G4_1_2_5_1_10_0 + 4.166666666666656e-03*G4_1_2_5_1_11_0 + 4.166666666666654e-03*G4_1_2_6_1_8_0 + 4.166666666666655e-03*G4_1_2_6_1_9_0 + 8.333333333333311e-03*G4_1_2_6_1_10_0 + 4.166666666666655e-03*G4_1_2_6_1_11_0 + 4.166666666666656e-03*G4_1_2_7_1_8_0 + 4.166666666666656e-03*G4_1_2_7_1_9_0 + 4.166666666666655e-03*G4_1_2_7_1_10_0 + 8.333333333333311e-03*G4_1_2_7_1_11_0 + 8.333333333333309e-03*G4_2_0_8_1_0_0 + 4.166666666666654e-03*G4_2_0_8_1_1_0 + 4.166666666666654e-03*G4_2_0_8_1_2_0 + 4.166666666666656e-03*G4_2_0_8_1_3_0 + 4.166666666666655e-03*G4_2_0_9_1_0_0 + 8.333333333333309e-03*G4_2_0_9_1_1_0 + 4.166666666666655e-03*G4_2_0_9_1_2_0 + 4.166666666666656e-03*G4_2_0_9_1_3_0 + 4.166666666666654e-03*G4_2_0_10_1_0_0 + 4.166666666666654e-03*G4_2_0_10_1_1_0 + 8.333333333333311e-03*G4_2_0_10_1_2_0 + 4.166666666666655e-03*G4_2_0_10_1_3_0 + 4.166666666666656e-03*G4_2_0_11_1_0_0 + 4.166666666666655e-03*G4_2_0_11_1_1_0 + 4.166666666666655e-03*G4_2_0_11_1_2_0 + 8.333333333333311e-03*G4_2_0_11_1_3_0 + 8.333333333333309e-03*G4_2_1_8_1_4_0 + 4.166666666666654e-03*G4_2_1_8_1_5_0 + 4.166666666666654e-03*G4_2_1_8_1_6_0 + 4.166666666666656e-03*G4_2_1_8_1_7_0 + 4.166666666666654e-03*G4_2_1_9_1_4_0 + 8.333333333333309e-03*G4_2_1_9_1_5_0 + 4.166666666666655e-03*G4_2_1_9_1_6_0 + 4.166666666666656e-03*G4_2_1_9_1_7_0 + 4.166666666666654e-03*G4_2_1_10_1_4_0 + 4.166666666666655e-03*G4_2_1_10_1_5_0 + 8.333333333333311e-03*G4_2_1_10_1_6_0 + 4.166666666666655e-03*G4_2_1_10_1_7_0 + 4.166666666666656e-03*G4_2_1_11_1_4_0 + 4.166666666666656e-03*G4_2_1_11_1_5_0 + 4.166666666666655e-03*G4_2_1_11_1_6_0 + 8.333333333333311e-03*G4_2_1_11_1_7_0 + 8.333333333333309e-03*G4_2_2_8_1_8_0 + 4.166666666666654e-03*G4_2_2_8_1_9_0 + 4.166666666666654e-03*G4_2_2_8_1_10_0 + 4.166666666666656e-03*G4_2_2_8_1_11_0 + 4.166666666666654e-03*G4_2_2_9_1_8_0 + 8.333333333333309e-03*G4_2_2_9_1_9_0 + 4.166666666666655e-03*G4_2_2_9_1_10_0 + 4.166666666666656e-03*G4_2_2_9_1_11_0 + 4.166666666666654e-03*G4_2_2_10_1_8_0 + 4.166666666666655e-03*G4_2_2_10_1_9_0 + 8.333333333333311e-03*G4_2_2_10_1_10_0 + 4.166666666666655e-03*G4_2_2_10_1_11_0 + 4.166666666666656e-03*G4_2_2_11_1_8_0 + 4.166666666666656e-03*G4_2_2_11_1_9_0 + 4.166666666666655e-03*G4_2_2_11_1_10_0 + 8.333333333333311e-03*G4_2_2_11_1_11_0;
    block[26] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_1_1 + 4.166666666666656e-03*G2_0_0_1 + 4.166666666666654e-03*G2_0_1_1 + 8.333333333333311e-03*G2_0_2_1 + 4.166666666666656e-03*G2_0_3_1 + 4.166666666666654e-03*G2_1_4_1 + 4.166666666666656e-03*G2_1_5_1 + 8.333333333333311e-03*G2_1_6_1 + 4.166666666666656e-03*G2_1_7_1 + 4.166666666666654e-03*G2_2_8_1 + 4.166666666666656e-03*G2_2_9_1 + 8.333333333333311e-03*G2_2_10_1 + 4.166666666666656e-03*G2_2_11_1 + 8.333333333333323e-02*G3_0_0_1_1 + 8.333333333333311e-03*G4_0_0_0_1_0_1 + 4.166666666666655e-03*G4_0_0_0_1_1_1 + 4.166666666666656e-03*G4_0_0_0_1_2_1 + 4.166666666666657e-03*G4_0_0_0_1_3_1 + 4.166666666666655e-03*G4_0_0_1_1_0_1 + 8.333333333333309e-03*G4_0_0_1_1_1_1 + 4.166666666666654e-03*G4_0_0_1_1_2_1 + 4.166666666666655e-03*G4_0_0_1_1_3_1 + 4.166666666666656e-03*G4_0_0_2_1_0_1 + 4.166666666666654e-03*G4_0_0_2_1_1_1 + 8.333333333333311e-03*G4_0_0_2_1_2_1 + 4.166666666666656e-03*G4_0_0_2_1_3_1 + 4.166666666666657e-03*G4_0_0_3_1_0_1 + 4.166666666666655e-03*G4_0_0_3_1_1_1 + 4.166666666666656e-03*G4_0_0_3_1_2_1 + 8.333333333333311e-03*G4_0_0_3_1_3_1 + 8.333333333333311e-03*G4_0_1_0_1_4_1 + 4.166666666666655e-03*G4_0_1_0_1_5_1 + 4.166666666666656e-03*G4_0_1_0_1_6_1 + 4.166666666666657e-03*G4_0_1_0_1_7_1 + 4.166666666666654e-03*G4_0_1_1_1_4_1 + 8.333333333333309e-03*G4_0_1_1_1_5_1 + 4.166666666666654e-03*G4_0_1_1_1_6_1 + 4.166666666666655e-03*G4_0_1_1_1_7_1 + 4.166666666666654e-03*G4_0_1_2_1_4_1 + 4.166666666666656e-03*G4_0_1_2_1_5_1 + 8.333333333333311e-03*G4_0_1_2_1_6_1 + 4.166666666666656e-03*G4_0_1_2_1_7_1 + 4.166666666666657e-03*G4_0_1_3_1_4_1 + 4.166666666666657e-03*G4_0_1_3_1_5_1 + 4.166666666666656e-03*G4_0_1_3_1_6_1 + 8.333333333333311e-03*G4_0_1_3_1_7_1 + 8.333333333333311e-03*G4_0_2_0_1_8_1 + 4.166666666666655e-03*G4_0_2_0_1_9_1 + 4.166666666666656e-03*G4_0_2_0_1_10_1 + 4.166666666666657e-03*G4_0_2_0_1_11_1 + 4.166666666666654e-03*G4_0_2_1_1_8_1 + 8.333333333333309e-03*G4_0_2_1_1_9_1 + 4.166666666666654e-03*G4_0_2_1_1_10_1 + 4.166666666666655e-03*G4_0_2_1_1_11_1 + 4.166666666666654e-03*G4_0_2_2_1_8_1 + 4.166666666666656e-03*G4_0_2_2_1_9_1 + 8.333333333333311e-03*G4_0_2_2_1_10_1 + 4.166666666666656e-03*G4_0_2_2_1_11_1 + 4.166666666666657e-03*G4_0_2_3_1_8_1 + 4.166666666666657e-03*G4_0_2_3_1_9_1 + 4.166666666666656e-03*G4_0_2_3_1_10_1 + 8.333333333333311e-03*G4_0_2_3_1_11_1 + 8.333333333333311e-03*G4_1_0_4_1_0_1 + 4.166666666666654e-03*G4_1_0_4_1_1_1 + 4.166666666666654e-03*G4_1_0_4_1_2_1 + 4.166666666666657e-03*G4_1_0_4_1_3_1 + 4.166666666666655e-03*G4_1_0_5_1_0_1 + 8.333333333333309e-03*G4_1_0_5_1_1_1 + 4.166666666666656e-03*G4_1_0_5_1_2_1 + 4.166666666666657e-03*G4_1_0_5_1_3_1 + 4.166666666666656e-03*G4_1_0_6_1_0_1 + 4.166666666666654e-03*G4_1_0_6_1_1_1 + 8.333333333333311e-03*G4_1_0_6_1_2_1 + 4.166666666666656e-03*G4_1_0_6_1_3_1 + 4.166666666666657e-03*G4_1_0_7_1_0_1 + 4.166666666666655e-03*G4_1_0_7_1_1_1 + 4.166666666666656e-03*G4_1_0_7_1_2_1 + 8.333333333333311e-03*G4_1_0_7_1_3_1 + 8.333333333333311e-03*G4_1_1_4_1_4_1 + 4.166666666666654e-03*G4_1_1_4_1_5_1 + 4.166666666666654e-03*G4_1_1_4_1_6_1 + 4.166666666666657e-03*G4_1_1_4_1_7_1 + 4.166666666666654e-03*G4_1_1_5_1_4_1 + 8.333333333333309e-03*G4_1_1_5_1_5_1 + 4.166666666666656e-03*G4_1_1_5_1_6_1 + 4.166666666666657e-03*G4_1_1_5_1_7_1 + 4.166666666666654e-03*G4_1_1_6_1_4_1 + 4.166666666666656e-03*G4_1_1_6_1_5_1 + 8.333333333333311e-03*G4_1_1_6_1_6_1 + 4.166666666666656e-03*G4_1_1_6_1_7_1 + 4.166666666666657e-03*G4_1_1_7_1_4_1 + 4.166666666666657e-03*G4_1_1_7_1_5_1 + 4.166666666666656e-03*G4_1_1_7_1_6_1 + 8.333333333333311e-03*G4_1_1_7_1_7_1 + 8.333333333333311e-03*G4_1_2_4_1_8_1 + 4.166666666666654e-03*G4_1_2_4_1_9_1 + 4.166666666666654e-03*G4_1_2_4_1_10_1 + 4.166666666666657e-03*G4_1_2_4_1_11_1 + 4.166666666666654e-03*G4_1_2_5_1_8_1 + 8.333333333333309e-03*G4_1_2_5_1_9_1 + 4.166666666666656e-03*G4_1_2_5_1_10_1 + 4.166666666666657e-03*G4_1_2_5_1_11_1 + 4.166666666666654e-03*G4_1_2_6_1_8_1 + 4.166666666666656e-03*G4_1_2_6_1_9_1 + 8.333333333333311e-03*G4_1_2_6_1_10_1 + 4.166666666666656e-03*G4_1_2_6_1_11_1 + 4.166666666666657e-03*G4_1_2_7_1_8_1 + 4.166666666666657e-03*G4_1_2_7_1_9_1 + 4.166666666666656e-03*G4_1_2_7_1_10_1 + 8.333333333333311e-03*G4_1_2_7_1_11_1 + 8.333333333333311e-03*G4_2_0_8_1_0_1 + 4.166666666666654e-03*G4_2_0_8_1_1_1 + 4.166666666666654e-03*G4_2_0_8_1_2_1 + 4.166666666666657e-03*G4_2_0_8_1_3_1 + 4.166666666666655e-03*G4_2_0_9_1_0_1 + 8.333333333333309e-03*G4_2_0_9_1_1_1 + 4.166666666666656e-03*G4_2_0_9_1_2_1 + 4.166666666666657e-03*G4_2_0_9_1_3_1 + 4.166666666666656e-03*G4_2_0_10_1_0_1 + 4.166666666666654e-03*G4_2_0_10_1_1_1 + 8.333333333333311e-03*G4_2_0_10_1_2_1 + 4.166666666666656e-03*G4_2_0_10_1_3_1 + 4.166666666666657e-03*G4_2_0_11_1_0_1 + 4.166666666666655e-03*G4_2_0_11_1_1_1 + 4.166666666666656e-03*G4_2_0_11_1_2_1 + 8.333333333333311e-03*G4_2_0_11_1_3_1 + 8.333333333333311e-03*G4_2_1_8_1_4_1 + 4.166666666666654e-03*G4_2_1_8_1_5_1 + 4.166666666666654e-03*G4_2_1_8_1_6_1 + 4.166666666666657e-03*G4_2_1_8_1_7_1 + 4.166666666666654e-03*G4_2_1_9_1_4_1 + 8.333333333333309e-03*G4_2_1_9_1_5_1 + 4.166666666666656e-03*G4_2_1_9_1_6_1 + 4.166666666666657e-03*G4_2_1_9_1_7_1 + 4.166666666666654e-03*G4_2_1_10_1_4_1 + 4.166666666666656e-03*G4_2_1_10_1_5_1 + 8.333333333333311e-03*G4_2_1_10_1_6_1 + 4.166666666666656e-03*G4_2_1_10_1_7_1 + 4.166666666666657e-03*G4_2_1_11_1_4_1 + 4.166666666666657e-03*G4_2_1_11_1_5_1 + 4.166666666666656e-03*G4_2_1_11_1_6_1 + 8.333333333333311e-03*G4_2_1_11_1_7_1 + 8.333333333333311e-03*G4_2_2_8_1_8_1 + 4.166666666666654e-03*G4_2_2_8_1_9_1 + 4.166666666666654e-03*G4_2_2_8_1_10_1 + 4.166666666666657e-03*G4_2_2_8_1_11_1 + 4.166666666666654e-03*G4_2_2_9_1_8_1 + 8.333333333333309e-03*G4_2_2_9_1_9_1 + 4.166666666666656e-03*G4_2_2_9_1_10_1 + 4.166666666666657e-03*G4_2_2_9_1_11_1 + 4.166666666666654e-03*G4_2_2_10_1_8_1 + 4.166666666666656e-03*G4_2_2_10_1_9_1 + 8.333333333333311e-03*G4_2_2_10_1_10_1 + 4.166666666666656e-03*G4_2_2_10_1_11_1 + 4.166666666666657e-03*G4_2_2_11_1_8_1 + 4.166666666666657e-03*G4_2_2_11_1_9_1 + 4.166666666666656e-03*G4_2_2_11_1_10_1 + 8.333333333333311e-03*G4_2_2_11_1_11_1;
    block[27] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_1_2 + 4.166666666666656e-03*G2_0_0_2 + 4.166666666666654e-03*G2_0_1_2 + 8.333333333333311e-03*G2_0_2_2 + 4.166666666666656e-03*G2_0_3_2 + 4.166666666666654e-03*G2_1_4_2 + 4.166666666666656e-03*G2_1_5_2 + 8.333333333333311e-03*G2_1_6_2 + 4.166666666666656e-03*G2_1_7_2 + 4.166666666666654e-03*G2_2_8_2 + 4.166666666666656e-03*G2_2_9_2 + 8.333333333333311e-03*G2_2_10_2 + 4.166666666666656e-03*G2_2_11_2 + 8.333333333333323e-02*G3_0_0_1_2 + 8.333333333333311e-03*G4_0_0_0_1_0_2 + 4.166666666666655e-03*G4_0_0_0_1_1_2 + 4.166666666666656e-03*G4_0_0_0_1_2_2 + 4.166666666666657e-03*G4_0_0_0_1_3_2 + 4.166666666666655e-03*G4_0_0_1_1_0_2 + 8.333333333333309e-03*G4_0_0_1_1_1_2 + 4.166666666666654e-03*G4_0_0_1_1_2_2 + 4.166666666666655e-03*G4_0_0_1_1_3_2 + 4.166666666666656e-03*G4_0_0_2_1_0_2 + 4.166666666666654e-03*G4_0_0_2_1_1_2 + 8.333333333333311e-03*G4_0_0_2_1_2_2 + 4.166666666666656e-03*G4_0_0_2_1_3_2 + 4.166666666666657e-03*G4_0_0_3_1_0_2 + 4.166666666666655e-03*G4_0_0_3_1_1_2 + 4.166666666666656e-03*G4_0_0_3_1_2_2 + 8.333333333333311e-03*G4_0_0_3_1_3_2 + 8.333333333333311e-03*G4_0_1_0_1_4_2 + 4.166666666666655e-03*G4_0_1_0_1_5_2 + 4.166666666666656e-03*G4_0_1_0_1_6_2 + 4.166666666666657e-03*G4_0_1_0_1_7_2 + 4.166666666666654e-03*G4_0_1_1_1_4_2 + 8.333333333333309e-03*G4_0_1_1_1_5_2 + 4.166666666666654e-03*G4_0_1_1_1_6_2 + 4.166666666666655e-03*G4_0_1_1_1_7_2 + 4.166666666666654e-03*G4_0_1_2_1_4_2 + 4.166666666666656e-03*G4_0_1_2_1_5_2 + 8.333333333333311e-03*G4_0_1_2_1_6_2 + 4.166666666666656e-03*G4_0_1_2_1_7_2 + 4.166666666666657e-03*G4_0_1_3_1_4_2 + 4.166666666666657e-03*G4_0_1_3_1_5_2 + 4.166666666666656e-03*G4_0_1_3_1_6_2 + 8.333333333333311e-03*G4_0_1_3_1_7_2 + 8.333333333333311e-03*G4_0_2_0_1_8_2 + 4.166666666666655e-03*G4_0_2_0_1_9_2 + 4.166666666666656e-03*G4_0_2_0_1_10_2 + 4.166666666666657e-03*G4_0_2_0_1_11_2 + 4.166666666666654e-03*G4_0_2_1_1_8_2 + 8.333333333333309e-03*G4_0_2_1_1_9_2 + 4.166666666666654e-03*G4_0_2_1_1_10_2 + 4.166666666666655e-03*G4_0_2_1_1_11_2 + 4.166666666666654e-03*G4_0_2_2_1_8_2 + 4.166666666666656e-03*G4_0_2_2_1_9_2 + 8.333333333333311e-03*G4_0_2_2_1_10_2 + 4.166666666666656e-03*G4_0_2_2_1_11_2 + 4.166666666666657e-03*G4_0_2_3_1_8_2 + 4.166666666666657e-03*G4_0_2_3_1_9_2 + 4.166666666666656e-03*G4_0_2_3_1_10_2 + 8.333333333333311e-03*G4_0_2_3_1_11_2 + 8.333333333333311e-03*G4_1_0_4_1_0_2 + 4.166666666666654e-03*G4_1_0_4_1_1_2 + 4.166666666666654e-03*G4_1_0_4_1_2_2 + 4.166666666666657e-03*G4_1_0_4_1_3_2 + 4.166666666666655e-03*G4_1_0_5_1_0_2 + 8.333333333333309e-03*G4_1_0_5_1_1_2 + 4.166666666666656e-03*G4_1_0_5_1_2_2 + 4.166666666666657e-03*G4_1_0_5_1_3_2 + 4.166666666666656e-03*G4_1_0_6_1_0_2 + 4.166666666666654e-03*G4_1_0_6_1_1_2 + 8.333333333333311e-03*G4_1_0_6_1_2_2 + 4.166666666666656e-03*G4_1_0_6_1_3_2 + 4.166666666666657e-03*G4_1_0_7_1_0_2 + 4.166666666666655e-03*G4_1_0_7_1_1_2 + 4.166666666666656e-03*G4_1_0_7_1_2_2 + 8.333333333333311e-03*G4_1_0_7_1_3_2 + 8.333333333333311e-03*G4_1_1_4_1_4_2 + 4.166666666666654e-03*G4_1_1_4_1_5_2 + 4.166666666666654e-03*G4_1_1_4_1_6_2 + 4.166666666666657e-03*G4_1_1_4_1_7_2 + 4.166666666666654e-03*G4_1_1_5_1_4_2 + 8.333333333333309e-03*G4_1_1_5_1_5_2 + 4.166666666666656e-03*G4_1_1_5_1_6_2 + 4.166666666666657e-03*G4_1_1_5_1_7_2 + 4.166666666666654e-03*G4_1_1_6_1_4_2 + 4.166666666666656e-03*G4_1_1_6_1_5_2 + 8.333333333333311e-03*G4_1_1_6_1_6_2 + 4.166666666666656e-03*G4_1_1_6_1_7_2 + 4.166666666666657e-03*G4_1_1_7_1_4_2 + 4.166666666666657e-03*G4_1_1_7_1_5_2 + 4.166666666666656e-03*G4_1_1_7_1_6_2 + 8.333333333333311e-03*G4_1_1_7_1_7_2 + 8.333333333333311e-03*G4_1_2_4_1_8_2 + 4.166666666666654e-03*G4_1_2_4_1_9_2 + 4.166666666666654e-03*G4_1_2_4_1_10_2 + 4.166666666666657e-03*G4_1_2_4_1_11_2 + 4.166666666666654e-03*G4_1_2_5_1_8_2 + 8.333333333333309e-03*G4_1_2_5_1_9_2 + 4.166666666666656e-03*G4_1_2_5_1_10_2 + 4.166666666666657e-03*G4_1_2_5_1_11_2 + 4.166666666666654e-03*G4_1_2_6_1_8_2 + 4.166666666666656e-03*G4_1_2_6_1_9_2 + 8.333333333333311e-03*G4_1_2_6_1_10_2 + 4.166666666666656e-03*G4_1_2_6_1_11_2 + 4.166666666666657e-03*G4_1_2_7_1_8_2 + 4.166666666666657e-03*G4_1_2_7_1_9_2 + 4.166666666666656e-03*G4_1_2_7_1_10_2 + 8.333333333333311e-03*G4_1_2_7_1_11_2 + 8.333333333333311e-03*G4_2_0_8_1_0_2 + 4.166666666666654e-03*G4_2_0_8_1_1_2 + 4.166666666666654e-03*G4_2_0_8_1_2_2 + 4.166666666666657e-03*G4_2_0_8_1_3_2 + 4.166666666666655e-03*G4_2_0_9_1_0_2 + 8.333333333333309e-03*G4_2_0_9_1_1_2 + 4.166666666666656e-03*G4_2_0_9_1_2_2 + 4.166666666666657e-03*G4_2_0_9_1_3_2 + 4.166666666666656e-03*G4_2_0_10_1_0_2 + 4.166666666666654e-03*G4_2_0_10_1_1_2 + 8.333333333333311e-03*G4_2_0_10_1_2_2 + 4.166666666666656e-03*G4_2_0_10_1_3_2 + 4.166666666666657e-03*G4_2_0_11_1_0_2 + 4.166666666666655e-03*G4_2_0_11_1_1_2 + 4.166666666666656e-03*G4_2_0_11_1_2_2 + 8.333333333333311e-03*G4_2_0_11_1_3_2 + 8.333333333333311e-03*G4_2_1_8_1_4_2 + 4.166666666666654e-03*G4_2_1_8_1_5_2 + 4.166666666666654e-03*G4_2_1_8_1_6_2 + 4.166666666666657e-03*G4_2_1_8_1_7_2 + 4.166666666666654e-03*G4_2_1_9_1_4_2 + 8.333333333333309e-03*G4_2_1_9_1_5_2 + 4.166666666666656e-03*G4_2_1_9_1_6_2 + 4.166666666666657e-03*G4_2_1_9_1_7_2 + 4.166666666666654e-03*G4_2_1_10_1_4_2 + 4.166666666666656e-03*G4_2_1_10_1_5_2 + 8.333333333333311e-03*G4_2_1_10_1_6_2 + 4.166666666666656e-03*G4_2_1_10_1_7_2 + 4.166666666666657e-03*G4_2_1_11_1_4_2 + 4.166666666666657e-03*G4_2_1_11_1_5_2 + 4.166666666666656e-03*G4_2_1_11_1_6_2 + 8.333333333333311e-03*G4_2_1_11_1_7_2 + 8.333333333333311e-03*G4_2_2_8_1_8_2 + 4.166666666666654e-03*G4_2_2_8_1_9_2 + 4.166666666666654e-03*G4_2_2_8_1_10_2 + 4.166666666666657e-03*G4_2_2_8_1_11_2 + 4.166666666666654e-03*G4_2_2_9_1_8_2 + 8.333333333333309e-03*G4_2_2_9_1_9_2 + 4.166666666666656e-03*G4_2_2_9_1_10_2 + 4.166666666666657e-03*G4_2_2_9_1_11_2 + 4.166666666666654e-03*G4_2_2_10_1_8_2 + 4.166666666666656e-03*G4_2_2_10_1_9_2 + 8.333333333333311e-03*G4_2_2_10_1_10_2 + 4.166666666666656e-03*G4_2_2_10_1_11_2 + 4.166666666666657e-03*G4_2_2_11_1_8_2 + 4.166666666666657e-03*G4_2_2_11_1_9_2 + 4.166666666666656e-03*G4_2_2_11_1_10_2 + 8.333333333333311e-03*G4_2_2_11_1_11_2;
    block[28] = -8.333333333333322e-02*G3_0_1_1_0 - 8.333333333333323e-02*G3_0_1_1_1 - 8.333333333333323e-02*G3_0_1_1_2;
    block[29] = 8.333333333333322e-02*G3_0_1_1_0;
    block[30] = 8.333333333333323e-02*G3_0_1_1_1;
    block[31] = 8.333333333333323e-02*G3_0_1_1_2;
    block[32] = -8.333333333333322e-02*G3_0_2_1_0 - 8.333333333333323e-02*G3_0_2_1_1 - 8.333333333333323e-02*G3_0_2_1_2;
    block[33] = 8.333333333333322e-02*G3_0_2_1_0;
    block[34] = 8.333333333333323e-02*G3_0_2_1_1;
    block[35] = 8.333333333333323e-02*G3_0_2_1_2;
    block[36] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_2_0 - 8.333333333333323e-02*G1_2_1 - 8.333333333333322e-02*G1_2_2 - 4.166666666666656e-03*G2_0_0_0 - 4.166666666666657e-03*G2_0_0_1 - 4.166666666666657e-03*G2_0_0_2 - 4.166666666666655e-03*G2_0_1_0 - 4.166666666666655e-03*G2_0_1_1 - 4.166666666666655e-03*G2_0_1_2 - 4.166666666666655e-03*G2_0_2_0 - 4.166666666666656e-03*G2_0_2_1 - 4.166666666666655e-03*G2_0_2_2 - 8.333333333333311e-03*G2_0_3_0 - 8.333333333333311e-03*G2_0_3_1 - 8.333333333333311e-03*G2_0_3_2 - 4.166666666666656e-03*G2_1_4_0 - 4.166666666666657e-03*G2_1_4_1 - 4.166666666666657e-03*G2_1_4_2 - 4.166666666666656e-03*G2_1_5_0 - 4.166666666666657e-03*G2_1_5_1 - 4.166666666666656e-03*G2_1_5_2 - 4.166666666666655e-03*G2_1_6_0 - 4.166666666666656e-03*G2_1_6_1 - 4.166666666666655e-03*G2_1_6_2 - 8.333333333333311e-03*G2_1_7_0 - 8.333333333333311e-03*G2_1_7_1 - 8.333333333333311e-03*G2_1_7_2 - 4.166666666666656e-03*G2_2_8_0 - 4.166666666666657e-03*G2_2_8_1 - 4.166666666666657e-03*G2_2_8_2 - 4.166666666666656e-03*G2_2_9_0 - 4.166666666666657e-03*G2_2_9_1 - 4.166666666666656e-03*G2_2_9_2 - 4.166666666666655e-03*G2_2_10_0 - 4.166666666666656e-03*G2_2_10_1 - 4.166666666666655e-03*G2_2_10_2 - 8.333333333333311e-03*G2_2_11_0 - 8.333333333333311e-03*G2_2_11_1 - 8.333333333333311e-03*G2_2_11_2 - 8.333333333333322e-02*G3_0_0_2_0 - 8.333333333333323e-02*G3_0_0_2_1 - 8.333333333333322e-02*G3_0_0_2_2 - 8.333333333333309e-03*G4_0_0_0_2_0_0 - 8.333333333333311e-03*G4_0_0_0_2_0_1 - 8.333333333333311e-03*G4_0_0_0_2_0_2 - 4.166666666666654e-03*G4_0_0_0_2_1_0 - 4.166666666666655e-03*G4_0_0_0_2_1_1 - 4.166666666666654e-03*G4_0_0_0_2_1_2 - 4.166666666666654e-03*G4_0_0_0_2_2_0 - 4.166666666666656e-03*G4_0_0_0_2_2_1 - 4.166666666666655e-03*G4_0_0_0_2_2_2 - 4.166666666666656e-03*G4_0_0_0_2_3_0 - 4.166666666666657e-03*G4_0_0_0_2_3_1 - 4.166666666666657e-03*G4_0_0_0_2_3_2 - 4.166666666666654e-03*G4_0_0_1_2_0_0 - 4.166666666666655e-03*G4_0_0_1_2_0_1 - 4.166666666666654e-03*G4_0_0_1_2_0_2 - 8.333333333333307e-03*G4_0_0_1_2_1_0 - 8.333333333333309e-03*G4_0_0_1_2_1_1 - 8.333333333333307e-03*G4_0_0_1_2_1_2 - 4.166666666666654e-03*G4_0_0_1_2_2_0 - 4.166666666666654e-03*G4_0_0_1_2_2_1 - 4.166666666666654e-03*G4_0_0_1_2_2_2 - 4.166666666666655e-03*G4_0_0_1_2_3_0 - 4.166666666666655e-03*G4_0_0_1_2_3_1 - 4.166666666666655e-03*G4_0_0_1_2_3_2 - 4.166666666666654e-03*G4_0_0_2_2_0_0 - 4.166666666666656e-03*G4_0_0_2_2_0_1 - 4.166666666666655e-03*G4_0_0_2_2_0_2 - 4.166666666666654e-03*G4_0_0_2_2_1_0 - 4.166666666666654e-03*G4_0_0_2_2_1_1 - 4.166666666666654e-03*G4_0_0_2_2_1_2 - 8.333333333333311e-03*G4_0_0_2_2_2_0 - 8.333333333333311e-03*G4_0_0_2_2_2_1 - 8.333333333333311e-03*G4_0_0_2_2_2_2 - 4.166666666666655e-03*G4_0_0_2_2_3_0 - 4.166666666666656e-03*G4_0_0_2_2_3_1 - 4.166666666666655e-03*G4_0_0_2_2_3_2 - 4.166666666666656e-03*G4_0_0_3_2_0_0 - 4.166666666666657e-03*G4_0_0_3_2_0_1 - 4.166666666666657e-03*G4_0_0_3_2_0_2 - 4.166666666666655e-03*G4_0_0_3_2_1_0 - 4.166666666666655e-03*G4_0_0_3_2_1_1 - 4.166666666666655e-03*G4_0_0_3_2_1_2 - 4.166666666666655e-03*G4_0_0_3_2_2_0 - 4.166666666666656e-03*G4_0_0_3_2_2_1 - 4.166666666666655e-03*G4_0_0_3_2_2_2 - 8.333333333333311e-03*G4_0_0_3_2_3_0 - 8.333333333333311e-03*G4_0_0_3_2_3_1 - 8.333333333333311e-03*G4_0_0_3_2_3_2 - 8.333333333333309e-03*G4_0_1_0_2_4_0 - 8.333333333333311e-03*G4_0_1_0_2_4_1 - 8.333333333333311e-03*G4_0_1_0_2_4_2 - 4.166666666666655e-03*G4_0_1_0_2_5_0 - 4.166666666666655e-03*G4_0_1_0_2_5_1 - 4.166666666666655e-03*G4_0_1_0_2_5_2 - 4.166666666666654e-03*G4_0_1_0_2_6_0 - 4.166666666666656e-03*G4_0_1_0_2_6_1 - 4.166666666666655e-03*G4_0_1_0_2_6_2 - 4.166666666666656e-03*G4_0_1_0_2_7_0 - 4.166666666666657e-03*G4_0_1_0_2_7_1 - 4.166666666666657e-03*G4_0_1_0_2_7_2 - 4.166666666666654e-03*G4_0_1_1_2_4_0 - 4.166666666666654e-03*G4_0_1_1_2_4_1 - 4.166666666666654e-03*G4_0_1_1_2_4_2 - 8.333333333333309e-03*G4_0_1_1_2_5_0 - 8.333333333333309e-03*G4_0_1_1_2_5_1 - 8.333333333333307e-03*G4_0_1_1_2_5_2 - 4.166666666666654e-03*G4_0_1_1_2_6_0 - 4.166666666666654e-03*G4_0_1_1_2_6_1 - 4.166666666666654e-03*G4_0_1_1_2_6_2 - 4.166666666666655e-03*G4_0_1_1_2_7_0 - 4.166666666666655e-03*G4_0_1_1_2_7_1 - 4.166666666666655e-03*G4_0_1_1_2_7_2 - 4.166666666666654e-03*G4_0_1_2_2_4_0 - 4.166666666666654e-03*G4_0_1_2_2_4_1 - 4.166666666666654e-03*G4_0_1_2_2_4_2 - 4.166666666666655e-03*G4_0_1_2_2_5_0 - 4.166666666666656e-03*G4_0_1_2_2_5_1 - 4.166666666666654e-03*G4_0_1_2_2_5_2 - 8.333333333333311e-03*G4_0_1_2_2_6_0 - 8.333333333333311e-03*G4_0_1_2_2_6_1 - 8.333333333333311e-03*G4_0_1_2_2_6_2 - 4.166666666666655e-03*G4_0_1_2_2_7_0 - 4.166666666666656e-03*G4_0_1_2_2_7_1 - 4.166666666666655e-03*G4_0_1_2_2_7_2 - 4.166666666666656e-03*G4_0_1_3_2_4_0 - 4.166666666666657e-03*G4_0_1_3_2_4_1 - 4.166666666666657e-03*G4_0_1_3_2_4_2 - 4.166666666666656e-03*G4_0_1_3_2_5_0 - 4.166666666666657e-03*G4_0_1_3_2_5_1 - 4.166666666666656e-03*G4_0_1_3_2_5_2 - 4.166666666666655e-03*G4_0_1_3_2_6_0 - 4.166666666666656e-03*G4_0_1_3_2_6_1 - 4.166666666666655e-03*G4_0_1_3_2_6_2 - 8.333333333333311e-03*G4_0_1_3_2_7_0 - 8.333333333333311e-03*G4_0_1_3_2_7_1 - 8.333333333333311e-03*G4_0_1_3_2_7_2 - 8.333333333333309e-03*G4_0_2_0_2_8_0 - 8.333333333333311e-03*G4_0_2_0_2_8_1 - 8.333333333333311e-03*G4_0_2_0_2_8_2 - 4.166666666666655e-03*G4_0_2_0_2_9_0 - 4.166666666666655e-03*G4_0_2_0_2_9_1 - 4.166666666666655e-03*G4_0_2_0_2_9_2 - 4.166666666666654e-03*G4_0_2_0_2_10_0 - 4.166666666666656e-03*G4_0_2_0_2_10_1 - 4.166666666666655e-03*G4_0_2_0_2_10_2 - 4.166666666666656e-03*G4_0_2_0_2_11_0 - 4.166666666666657e-03*G4_0_2_0_2_11_1 - 4.166666666666657e-03*G4_0_2_0_2_11_2 - 4.166666666666654e-03*G4_0_2_1_2_8_0 - 4.166666666666654e-03*G4_0_2_1_2_8_1 - 4.166666666666654e-03*G4_0_2_1_2_8_2 - 8.333333333333309e-03*G4_0_2_1_2_9_0 - 8.333333333333309e-03*G4_0_2_1_2_9_1 - 8.333333333333307e-03*G4_0_2_1_2_9_2 - 4.166666666666654e-03*G4_0_2_1_2_10_0 - 4.166666666666654e-03*G4_0_2_1_2_10_1 - 4.166666666666654e-03*G4_0_2_1_2_10_2 - 4.166666666666655e-03*G4_0_2_1_2_11_0 - 4.166666666666655e-03*G4_0_2_1_2_11_1 - 4.166666666666655e-03*G4_0_2_1_2_11_2 - 4.166666666666654e-03*G4_0_2_2_2_8_0 - 4.166666666666654e-03*G4_0_2_2_2_8_1 - 4.166666666666654e-03*G4_0_2_2_2_8_2 - 4.166666666666655e-03*G4_0_2_2_2_9_0 - 4.166666666666656e-03*G4_0_2_2_2_9_1 - 4.166666666666654e-03*G4_0_2_2_2_9_2 - 8.333333333333311e-03*G4_0_2_2_2_10_0 - 8.333333333333311e-03*G4_0_2_2_2_10_1 - 8.333333333333311e-03*G4_0_2_2_2_10_2 - 4.166666666666655e-03*G4_0_2_2_2_11_0 - 4.166666666666656e-03*G4_0_2_2_2_11_1 - 4.166666666666655e-03*G4_0_2_2_2_11_2 - 4.166666666666656e-03*G4_0_2_3_2_8_0 - 4.166666666666657e-03*G4_0_2_3_2_8_1 - 4.166666666666657e-03*G4_0_2_3_2_8_2 - 4.166666666666656e-03*G4_0_2_3_2_9_0 - 4.166666666666657e-03*G4_0_2_3_2_9_1 - 4.166666666666656e-03*G4_0_2_3_2_9_2 - 4.166666666666655e-03*G4_0_2_3_2_10_0 - 4.166666666666656e-03*G4_0_2_3_2_10_1 - 4.166666666666655e-03*G4_0_2_3_2_10_2 - 8.333333333333311e-03*G4_0_2_3_2_11_0 - 8.333333333333311e-03*G4_0_2_3_2_11_1 - 8.333333333333311e-03*G4_0_2_3_2_11_2 - 8.333333333333309e-03*G4_1_0_4_2_0_0 - 8.333333333333311e-03*G4_1_0_4_2_0_1 - 8.333333333333311e-03*G4_1_0_4_2_0_2 - 4.166666666666654e-03*G4_1_0_4_2_1_0 - 4.166666666666654e-03*G4_1_0_4_2_1_1 - 4.166666666666654e-03*G4_1_0_4_2_1_2 - 4.166666666666654e-03*G4_1_0_4_2_2_0 - 4.166666666666654e-03*G4_1_0_4_2_2_1 - 4.166666666666654e-03*G4_1_0_4_2_2_2 - 4.166666666666656e-03*G4_1_0_4_2_3_0 - 4.166666666666657e-03*G4_1_0_4_2_3_1 - 4.166666666666657e-03*G4_1_0_4_2_3_2 - 4.166666666666655e-03*G4_1_0_5_2_0_0 - 4.166666666666655e-03*G4_1_0_5_2_0_1 - 4.166666666666655e-03*G4_1_0_5_2_0_2 - 8.333333333333309e-03*G4_1_0_5_2_1_0 - 8.333333333333309e-03*G4_1_0_5_2_1_1 - 8.333333333333307e-03*G4_1_0_5_2_1_2 - 4.166666666666655e-03*G4_1_0_5_2_2_0 - 4.166666666666656e-03*G4_1_0_5_2_2_1 - 4.166666666666654e-03*G4_1_0_5_2_2_2 - 4.166666666666656e-03*G4_1_0_5_2_3_0 - 4.166666666666657e-03*G4_1_0_5_2_3_1 - 4.166666666666656e-03*G4_1_0_5_2_3_2 - 4.166666666666654e-03*G4_1_0_6_2_0_0 - 4.166666666666656e-03*G4_1_0_6_2_0_1 - 4.166666666666655e-03*G4_1_0_6_2_0_2 - 4.166666666666654e-03*G4_1_0_6_2_1_0 - 4.166666666666654e-03*G4_1_0_6_2_1_1 - 4.166666666666654e-03*G4_1_0_6_2_1_2 - 8.333333333333311e-03*G4_1_0_6_2_2_0 - 8.333333333333311e-03*G4_1_0_6_2_2_1 - 8.333333333333311e-03*G4_1_0_6_2_2_2 - 4.166666666666655e-03*G4_1_0_6_2_3_0 - 4.166666666666656e-03*G4_1_0_6_2_3_1 - 4.166666666666655e-03*G4_1_0_6_2_3_2 - 4.166666666666656e-03*G4_1_0_7_2_0_0 - 4.166666666666657e-03*G4_1_0_7_2_0_1 - 4.166666666666657e-03*G4_1_0_7_2_0_2 - 4.166666666666655e-03*G4_1_0_7_2_1_0 - 4.166666666666655e-03*G4_1_0_7_2_1_1 - 4.166666666666655e-03*G4_1_0_7_2_1_2 - 4.166666666666655e-03*G4_1_0_7_2_2_0 - 4.166666666666656e-03*G4_1_0_7_2_2_1 - 4.166666666666655e-03*G4_1_0_7_2_2_2 - 8.333333333333311e-03*G4_1_0_7_2_3_0 - 8.333333333333311e-03*G4_1_0_7_2_3_1 - 8.333333333333311e-03*G4_1_0_7_2_3_2 - 8.333333333333309e-03*G4_1_1_4_2_4_0 - 8.333333333333311e-03*G4_1_1_4_2_4_1 - 8.333333333333311e-03*G4_1_1_4_2_4_2 - 4.166666666666654e-03*G4_1_1_4_2_5_0 - 4.166666666666654e-03*G4_1_1_4_2_5_1 - 4.166666666666654e-03*G4_1_1_4_2_5_2 - 4.166666666666654e-03*G4_1_1_4_2_6_0 - 4.166666666666654e-03*G4_1_1_4_2_6_1 - 4.166666666666654e-03*G4_1_1_4_2_6_2 - 4.166666666666656e-03*G4_1_1_4_2_7_0 - 4.166666666666657e-03*G4_1_1_4_2_7_1 - 4.166666666666657e-03*G4_1_1_4_2_7_2 - 4.166666666666654e-03*G4_1_1_5_2_4_0 - 4.166666666666654e-03*G4_1_1_5_2_4_1 - 4.166666666666654e-03*G4_1_1_5_2_4_2 - 8.333333333333309e-03*G4_1_1_5_2_5_0 - 8.333333333333309e-03*G4_1_1_5_2_5_1 - 8.333333333333307e-03*G4_1_1_5_2_5_2 - 4.166666666666655e-03*G4_1_1_5_2_6_0 - 4.166666666666656e-03*G4_1_1_5_2_6_1 - 4.166666666666654e-03*G4_1_1_5_2_6_2 - 4.166666666666656e-03*G4_1_1_5_2_7_0 - 4.166666666666657e-03*G4_1_1_5_2_7_1 - 4.166666666666656e-03*G4_1_1_5_2_7_2 - 4.166666666666654e-03*G4_1_1_6_2_4_0 - 4.166666666666654e-03*G4_1_1_6_2_4_1 - 4.166666666666654e-03*G4_1_1_6_2_4_2 - 4.166666666666655e-03*G4_1_1_6_2_5_0 - 4.166666666666656e-03*G4_1_1_6_2_5_1 - 4.166666666666654e-03*G4_1_1_6_2_5_2 - 8.333333333333311e-03*G4_1_1_6_2_6_0 - 8.333333333333311e-03*G4_1_1_6_2_6_1 - 8.333333333333311e-03*G4_1_1_6_2_6_2 - 4.166666666666655e-03*G4_1_1_6_2_7_0 - 4.166666666666656e-03*G4_1_1_6_2_7_1 - 4.166666666666655e-03*G4_1_1_6_2_7_2 - 4.166666666666656e-03*G4_1_1_7_2_4_0 - 4.166666666666657e-03*G4_1_1_7_2_4_1 - 4.166666666666657e-03*G4_1_1_7_2_4_2 - 4.166666666666656e-03*G4_1_1_7_2_5_0 - 4.166666666666657e-03*G4_1_1_7_2_5_1 - 4.166666666666656e-03*G4_1_1_7_2_5_2 - 4.166666666666655e-03*G4_1_1_7_2_6_0 - 4.166666666666656e-03*G4_1_1_7_2_6_1 - 4.166666666666655e-03*G4_1_1_7_2_6_2 - 8.333333333333311e-03*G4_1_1_7_2_7_0 - 8.333333333333311e-03*G4_1_1_7_2_7_1 - 8.333333333333311e-03*G4_1_1_7_2_7_2 - 8.333333333333309e-03*G4_1_2_4_2_8_0 - 8.333333333333311e-03*G4_1_2_4_2_8_1 - 8.333333333333311e-03*G4_1_2_4_2_8_2 - 4.166666666666654e-03*G4_1_2_4_2_9_0 - 4.166666666666654e-03*G4_1_2_4_2_9_1 - 4.166666666666654e-03*G4_1_2_4_2_9_2 - 4.166666666666654e-03*G4_1_2_4_2_10_0 - 4.166666666666654e-03*G4_1_2_4_2_10_1 - 4.166666666666654e-03*G4_1_2_4_2_10_2 - 4.166666666666656e-03*G4_1_2_4_2_11_0 - 4.166666666666657e-03*G4_1_2_4_2_11_1 - 4.166666666666657e-03*G4_1_2_4_2_11_2 - 4.166666666666654e-03*G4_1_2_5_2_8_0 - 4.166666666666654e-03*G4_1_2_5_2_8_1 - 4.166666666666654e-03*G4_1_2_5_2_8_2 - 8.333333333333309e-03*G4_1_2_5_2_9_0 - 8.333333333333309e-03*G4_1_2_5_2_9_1 - 8.333333333333307e-03*G4_1_2_5_2_9_2 - 4.166666666666655e-03*G4_1_2_5_2_10_0 - 4.166666666666656e-03*G4_1_2_5_2_10_1 - 4.166666666666654e-03*G4_1_2_5_2_10_2 - 4.166666666666656e-03*G4_1_2_5_2_11_0 - 4.166666666666657e-03*G4_1_2_5_2_11_1 - 4.166666666666656e-03*G4_1_2_5_2_11_2 - 4.166666666666654e-03*G4_1_2_6_2_8_0 - 4.166666666666654e-03*G4_1_2_6_2_8_1 - 4.166666666666654e-03*G4_1_2_6_2_8_2 - 4.166666666666655e-03*G4_1_2_6_2_9_0 - 4.166666666666656e-03*G4_1_2_6_2_9_1 - 4.166666666666654e-03*G4_1_2_6_2_9_2 - 8.333333333333311e-03*G4_1_2_6_2_10_0 - 8.333333333333311e-03*G4_1_2_6_2_10_1 - 8.333333333333311e-03*G4_1_2_6_2_10_2 - 4.166666666666655e-03*G4_1_2_6_2_11_0 - 4.166666666666656e-03*G4_1_2_6_2_11_1 - 4.166666666666655e-03*G4_1_2_6_2_11_2 - 4.166666666666656e-03*G4_1_2_7_2_8_0 - 4.166666666666657e-03*G4_1_2_7_2_8_1 - 4.166666666666657e-03*G4_1_2_7_2_8_2 - 4.166666666666656e-03*G4_1_2_7_2_9_0 - 4.166666666666657e-03*G4_1_2_7_2_9_1 - 4.166666666666656e-03*G4_1_2_7_2_9_2 - 4.166666666666655e-03*G4_1_2_7_2_10_0 - 4.166666666666656e-03*G4_1_2_7_2_10_1 - 4.166666666666655e-03*G4_1_2_7_2_10_2 - 8.333333333333311e-03*G4_1_2_7_2_11_0 - 8.333333333333311e-03*G4_1_2_7_2_11_1 - 8.333333333333311e-03*G4_1_2_7_2_11_2 - 8.333333333333309e-03*G4_2_0_8_2_0_0 - 8.333333333333311e-03*G4_2_0_8_2_0_1 - 8.333333333333311e-03*G4_2_0_8_2_0_2 - 4.166666666666654e-03*G4_2_0_8_2_1_0 - 4.166666666666654e-03*G4_2_0_8_2_1_1 - 4.166666666666654e-03*G4_2_0_8_2_1_2 - 4.166666666666654e-03*G4_2_0_8_2_2_0 - 4.166666666666654e-03*G4_2_0_8_2_2_1 - 4.166666666666654e-03*G4_2_0_8_2_2_2 - 4.166666666666656e-03*G4_2_0_8_2_3_0 - 4.166666666666657e-03*G4_2_0_8_2_3_1 - 4.166666666666657e-03*G4_2_0_8_2_3_2 - 4.166666666666655e-03*G4_2_0_9_2_0_0 - 4.166666666666655e-03*G4_2_0_9_2_0_1 - 4.166666666666655e-03*G4_2_0_9_2_0_2 - 8.333333333333309e-03*G4_2_0_9_2_1_0 - 8.333333333333309e-03*G4_2_0_9_2_1_1 - 8.333333333333307e-03*G4_2_0_9_2_1_2 - 4.166666666666655e-03*G4_2_0_9_2_2_0 - 4.166666666666656e-03*G4_2_0_9_2_2_1 - 4.166666666666654e-03*G4_2_0_9_2_2_2 - 4.166666666666656e-03*G4_2_0_9_2_3_0 - 4.166666666666657e-03*G4_2_0_9_2_3_1 - 4.166666666666656e-03*G4_2_0_9_2_3_2 - 4.166666666666654e-03*G4_2_0_10_2_0_0 - 4.166666666666656e-03*G4_2_0_10_2_0_1 - 4.166666666666655e-03*G4_2_0_10_2_0_2 - 4.166666666666654e-03*G4_2_0_10_2_1_0 - 4.166666666666654e-03*G4_2_0_10_2_1_1 - 4.166666666666654e-03*G4_2_0_10_2_1_2 - 8.333333333333311e-03*G4_2_0_10_2_2_0 - 8.333333333333311e-03*G4_2_0_10_2_2_1 - 8.333333333333311e-03*G4_2_0_10_2_2_2 - 4.166666666666655e-03*G4_2_0_10_2_3_0 - 4.166666666666656e-03*G4_2_0_10_2_3_1 - 4.166666666666655e-03*G4_2_0_10_2_3_2 - 4.166666666666656e-03*G4_2_0_11_2_0_0 - 4.166666666666657e-03*G4_2_0_11_2_0_1 - 4.166666666666657e-03*G4_2_0_11_2_0_2 - 4.166666666666655e-03*G4_2_0_11_2_1_0 - 4.166666666666655e-03*G4_2_0_11_2_1_1 - 4.166666666666655e-03*G4_2_0_11_2_1_2 - 4.166666666666655e-03*G4_2_0_11_2_2_0 - 4.166666666666656e-03*G4_2_0_11_2_2_1 - 4.166666666666655e-03*G4_2_0_11_2_2_2 - 8.333333333333311e-03*G4_2_0_11_2_3_0 - 8.333333333333311e-03*G4_2_0_11_2_3_1 - 8.333333333333311e-03*G4_2_0_11_2_3_2 - 8.333333333333309e-03*G4_2_1_8_2_4_0 - 8.333333333333311e-03*G4_2_1_8_2_4_1 - 8.333333333333311e-03*G4_2_1_8_2_4_2 - 4.166666666666654e-03*G4_2_1_8_2_5_0 - 4.166666666666654e-03*G4_2_1_8_2_5_1 - 4.166666666666654e-03*G4_2_1_8_2_5_2 - 4.166666666666654e-03*G4_2_1_8_2_6_0 - 4.166666666666654e-03*G4_2_1_8_2_6_1 - 4.166666666666654e-03*G4_2_1_8_2_6_2 - 4.166666666666656e-03*G4_2_1_8_2_7_0 - 4.166666666666657e-03*G4_2_1_8_2_7_1 - 4.166666666666657e-03*G4_2_1_8_2_7_2 - 4.166666666666654e-03*G4_2_1_9_2_4_0 - 4.166666666666654e-03*G4_2_1_9_2_4_1 - 4.166666666666654e-03*G4_2_1_9_2_4_2 - 8.333333333333309e-03*G4_2_1_9_2_5_0 - 8.333333333333309e-03*G4_2_1_9_2_5_1 - 8.333333333333307e-03*G4_2_1_9_2_5_2 - 4.166666666666655e-03*G4_2_1_9_2_6_0 - 4.166666666666656e-03*G4_2_1_9_2_6_1 - 4.166666666666654e-03*G4_2_1_9_2_6_2 - 4.166666666666656e-03*G4_2_1_9_2_7_0 - 4.166666666666657e-03*G4_2_1_9_2_7_1 - 4.166666666666656e-03*G4_2_1_9_2_7_2 - 4.166666666666654e-03*G4_2_1_10_2_4_0 - 4.166666666666654e-03*G4_2_1_10_2_4_1 - 4.166666666666654e-03*G4_2_1_10_2_4_2 - 4.166666666666655e-03*G4_2_1_10_2_5_0 - 4.166666666666656e-03*G4_2_1_10_2_5_1 - 4.166666666666654e-03*G4_2_1_10_2_5_2 - 8.333333333333311e-03*G4_2_1_10_2_6_0 - 8.333333333333311e-03*G4_2_1_10_2_6_1 - 8.333333333333311e-03*G4_2_1_10_2_6_2 - 4.166666666666655e-03*G4_2_1_10_2_7_0 - 4.166666666666656e-03*G4_2_1_10_2_7_1 - 4.166666666666655e-03*G4_2_1_10_2_7_2 - 4.166666666666656e-03*G4_2_1_11_2_4_0 - 4.166666666666657e-03*G4_2_1_11_2_4_1 - 4.166666666666657e-03*G4_2_1_11_2_4_2 - 4.166666666666656e-03*G4_2_1_11_2_5_0 - 4.166666666666657e-03*G4_2_1_11_2_5_1 - 4.166666666666656e-03*G4_2_1_11_2_5_2 - 4.166666666666655e-03*G4_2_1_11_2_6_0 - 4.166666666666656e-03*G4_2_1_11_2_6_1 - 4.166666666666655e-03*G4_2_1_11_2_6_2 - 8.333333333333311e-03*G4_2_1_11_2_7_0 - 8.333333333333311e-03*G4_2_1_11_2_7_1 - 8.333333333333311e-03*G4_2_1_11_2_7_2 - 8.333333333333309e-03*G4_2_2_8_2_8_0 - 8.333333333333311e-03*G4_2_2_8_2_8_1 - 8.333333333333311e-03*G4_2_2_8_2_8_2 - 4.166666666666654e-03*G4_2_2_8_2_9_0 - 4.166666666666654e-03*G4_2_2_8_2_9_1 - 4.166666666666654e-03*G4_2_2_8_2_9_2 - 4.166666666666654e-03*G4_2_2_8_2_10_0 - 4.166666666666654e-03*G4_2_2_8_2_10_1 - 4.166666666666654e-03*G4_2_2_8_2_10_2 - 4.166666666666656e-03*G4_2_2_8_2_11_0 - 4.166666666666657e-03*G4_2_2_8_2_11_1 - 4.166666666666657e-03*G4_2_2_8_2_11_2 - 4.166666666666654e-03*G4_2_2_9_2_8_0 - 4.166666666666654e-03*G4_2_2_9_2_8_1 - 4.166666666666654e-03*G4_2_2_9_2_8_2 - 8.333333333333309e-03*G4_2_2_9_2_9_0 - 8.333333333333309e-03*G4_2_2_9_2_9_1 - 8.333333333333307e-03*G4_2_2_9_2_9_2 - 4.166666666666655e-03*G4_2_2_9_2_10_0 - 4.166666666666656e-03*G4_2_2_9_2_10_1 - 4.166666666666654e-03*G4_2_2_9_2_10_2 - 4.166666666666656e-03*G4_2_2_9_2_11_0 - 4.166666666666657e-03*G4_2_2_9_2_11_1 - 4.166666666666656e-03*G4_2_2_9_2_11_2 - 4.166666666666654e-03*G4_2_2_10_2_8_0 - 4.166666666666654e-03*G4_2_2_10_2_8_1 - 4.166666666666654e-03*G4_2_2_10_2_8_2 - 4.166666666666655e-03*G4_2_2_10_2_9_0 - 4.166666666666656e-03*G4_2_2_10_2_9_1 - 4.166666666666654e-03*G4_2_2_10_2_9_2 - 8.333333333333311e-03*G4_2_2_10_2_10_0 - 8.333333333333311e-03*G4_2_2_10_2_10_1 - 8.333333333333311e-03*G4_2_2_10_2_10_2 - 4.166666666666655e-03*G4_2_2_10_2_11_0 - 4.166666666666656e-03*G4_2_2_10_2_11_1 - 4.166666666666655e-03*G4_2_2_10_2_11_2 - 4.166666666666656e-03*G4_2_2_11_2_8_0 - 4.166666666666657e-03*G4_2_2_11_2_8_1 - 4.166666666666657e-03*G4_2_2_11_2_8_2 - 4.166666666666656e-03*G4_2_2_11_2_9_0 - 4.166666666666657e-03*G4_2_2_11_2_9_1 - 4.166666666666656e-03*G4_2_2_11_2_9_2 - 4.166666666666655e-03*G4_2_2_11_2_10_0 - 4.166666666666656e-03*G4_2_2_11_2_10_1 - 4.166666666666655e-03*G4_2_2_11_2_10_2 - 8.333333333333311e-03*G4_2_2_11_2_11_0 - 8.333333333333311e-03*G4_2_2_11_2_11_1 - 8.333333333333311e-03*G4_2_2_11_2_11_2;
    block[37] = 8.333333333333311e-03*G0_ + 8.333333333333322e-02*G1_2_0 + 4.166666666666656e-03*G2_0_0_0 + 4.166666666666655e-03*G2_0_1_0 + 4.166666666666655e-03*G2_0_2_0 + 8.333333333333311e-03*G2_0_3_0 + 4.166666666666656e-03*G2_1_4_0 + 4.166666666666656e-03*G2_1_5_0 + 4.166666666666655e-03*G2_1_6_0 + 8.333333333333311e-03*G2_1_7_0 + 4.166666666666656e-03*G2_2_8_0 + 4.166666666666656e-03*G2_2_9_0 + 4.166666666666655e-03*G2_2_10_0 + 8.333333333333311e-03*G2_2_11_0 + 8.333333333333322e-02*G3_0_0_2_0 + 8.333333333333309e-03*G4_0_0_0_2_0_0 + 4.166666666666654e-03*G4_0_0_0_2_1_0 + 4.166666666666654e-03*G4_0_0_0_2_2_0 + 4.166666666666656e-03*G4_0_0_0_2_3_0 + 4.166666666666654e-03*G4_0_0_1_2_0_0 + 8.333333333333307e-03*G4_0_0_1_2_1_0 + 4.166666666666654e-03*G4_0_0_1_2_2_0 + 4.166666666666655e-03*G4_0_0_1_2_3_0 + 4.166666666666654e-03*G4_0_0_2_2_0_0 + 4.166666666666654e-03*G4_0_0_2_2_1_0 + 8.333333333333311e-03*G4_0_0_2_2_2_0 + 4.166666666666655e-03*G4_0_0_2_2_3_0 + 4.166666666666656e-03*G4_0_0_3_2_0_0 + 4.166666666666655e-03*G4_0_0_3_2_1_0 + 4.166666666666655e-03*G4_0_0_3_2_2_0 + 8.333333333333311e-03*G4_0_0_3_2_3_0 + 8.333333333333309e-03*G4_0_1_0_2_4_0 + 4.166666666666655e-03*G4_0_1_0_2_5_0 + 4.166666666666654e-03*G4_0_1_0_2_6_0 + 4.166666666666656e-03*G4_0_1_0_2_7_0 + 4.166666666666654e-03*G4_0_1_1_2_4_0 + 8.333333333333309e-03*G4_0_1_1_2_5_0 + 4.166666666666654e-03*G4_0_1_1_2_6_0 + 4.166666666666655e-03*G4_0_1_1_2_7_0 + 4.166666666666654e-03*G4_0_1_2_2_4_0 + 4.166666666666655e-03*G4_0_1_2_2_5_0 + 8.333333333333311e-03*G4_0_1_2_2_6_0 + 4.166666666666655e-03*G4_0_1_2_2_7_0 + 4.166666666666656e-03*G4_0_1_3_2_4_0 + 4.166666666666656e-03*G4_0_1_3_2_5_0 + 4.166666666666655e-03*G4_0_1_3_2_6_0 + 8.333333333333311e-03*G4_0_1_3_2_7_0 + 8.333333333333309e-03*G4_0_2_0_2_8_0 + 4.166666666666655e-03*G4_0_2_0_2_9_0 + 4.166666666666654e-03*G4_0_2_0_2_10_0 + 4.166666666666656e-03*G4_0_2_0_2_11_0 + 4.166666666666654e-03*G4_0_2_1_2_8_0 + 8.333333333333309e-03*G4_0_2_1_2_9_0 + 4.166666666666654e-03*G4_0_2_1_2_10_0 + 4.166666666666655e-03*G4_0_2_1_2_11_0 + 4.166666666666654e-03*G4_0_2_2_2_8_0 + 4.166666666666655e-03*G4_0_2_2_2_9_0 + 8.333333333333311e-03*G4_0_2_2_2_10_0 + 4.166666666666655e-03*G4_0_2_2_2_11_0 + 4.166666666666656e-03*G4_0_2_3_2_8_0 + 4.166666666666656e-03*G4_0_2_3_2_9_0 + 4.166666666666655e-03*G4_0_2_3_2_10_0 + 8.333333333333311e-03*G4_0_2_3_2_11_0 + 8.333333333333309e-03*G4_1_0_4_2_0_0 + 4.166666666666654e-03*G4_1_0_4_2_1_0 + 4.166666666666654e-03*G4_1_0_4_2_2_0 + 4.166666666666656e-03*G4_1_0_4_2_3_0 + 4.166666666666655e-03*G4_1_0_5_2_0_0 + 8.333333333333309e-03*G4_1_0_5_2_1_0 + 4.166666666666655e-03*G4_1_0_5_2_2_0 + 4.166666666666656e-03*G4_1_0_5_2_3_0 + 4.166666666666654e-03*G4_1_0_6_2_0_0 + 4.166666666666654e-03*G4_1_0_6_2_1_0 + 8.333333333333311e-03*G4_1_0_6_2_2_0 + 4.166666666666655e-03*G4_1_0_6_2_3_0 + 4.166666666666656e-03*G4_1_0_7_2_0_0 + 4.166666666666655e-03*G4_1_0_7_2_1_0 + 4.166666666666655e-03*G4_1_0_7_2_2_0 + 8.333333333333311e-03*G4_1_0_7_2_3_0 + 8.333333333333309e-03*G4_1_1_4_2_4_0 + 4.166666666666654e-03*G4_1_1_4_2_5_0 + 4.166666666666654e-03*G4_1_1_4_2_6_0 + 4.166666666666656e-03*G4_1_1_4_2_7_0 + 4.166666666666654e-03*G4_1_1_5_2_4_0 + 8.333333333333309e-03*G4_1_1_5_2_5_0 + 4.166666666666655e-03*G4_1_1_5_2_6_0 + 4.166666666666656e-03*G4_1_1_5_2_7_0 + 4.166666666666654e-03*G4_1_1_6_2_4_0 + 4.166666666666655e-03*G4_1_1_6_2_5_0 + 8.333333333333311e-03*G4_1_1_6_2_6_0 + 4.166666666666655e-03*G4_1_1_6_2_7_0 + 4.166666666666656e-03*G4_1_1_7_2_4_0 + 4.166666666666656e-03*G4_1_1_7_2_5_0 + 4.166666666666655e-03*G4_1_1_7_2_6_0 + 8.333333333333311e-03*G4_1_1_7_2_7_0 + 8.333333333333309e-03*G4_1_2_4_2_8_0 + 4.166666666666654e-03*G4_1_2_4_2_9_0 + 4.166666666666654e-03*G4_1_2_4_2_10_0 + 4.166666666666656e-03*G4_1_2_4_2_11_0 + 4.166666666666654e-03*G4_1_2_5_2_8_0 + 8.333333333333309e-03*G4_1_2_5_2_9_0 + 4.166666666666655e-03*G4_1_2_5_2_10_0 + 4.166666666666656e-03*G4_1_2_5_2_11_0 + 4.166666666666654e-03*G4_1_2_6_2_8_0 + 4.166666666666655e-03*G4_1_2_6_2_9_0 + 8.333333333333311e-03*G4_1_2_6_2_10_0 + 4.166666666666655e-03*G4_1_2_6_2_11_0 + 4.166666666666656e-03*G4_1_2_7_2_8_0 + 4.166666666666656e-03*G4_1_2_7_2_9_0 + 4.166666666666655e-03*G4_1_2_7_2_10_0 + 8.333333333333311e-03*G4_1_2_7_2_11_0 + 8.333333333333309e-03*G4_2_0_8_2_0_0 + 4.166666666666654e-03*G4_2_0_8_2_1_0 + 4.166666666666654e-03*G4_2_0_8_2_2_0 + 4.166666666666656e-03*G4_2_0_8_2_3_0 + 4.166666666666655e-03*G4_2_0_9_2_0_0 + 8.333333333333309e-03*G4_2_0_9_2_1_0 + 4.166666666666655e-03*G4_2_0_9_2_2_0 + 4.166666666666656e-03*G4_2_0_9_2_3_0 + 4.166666666666654e-03*G4_2_0_10_2_0_0 + 4.166666666666654e-03*G4_2_0_10_2_1_0 + 8.333333333333311e-03*G4_2_0_10_2_2_0 + 4.166666666666655e-03*G4_2_0_10_2_3_0 + 4.166666666666656e-03*G4_2_0_11_2_0_0 + 4.166666666666655e-03*G4_2_0_11_2_1_0 + 4.166666666666655e-03*G4_2_0_11_2_2_0 + 8.333333333333311e-03*G4_2_0_11_2_3_0 + 8.333333333333309e-03*G4_2_1_8_2_4_0 + 4.166666666666654e-03*G4_2_1_8_2_5_0 + 4.166666666666654e-03*G4_2_1_8_2_6_0 + 4.166666666666656e-03*G4_2_1_8_2_7_0 + 4.166666666666654e-03*G4_2_1_9_2_4_0 + 8.333333333333309e-03*G4_2_1_9_2_5_0 + 4.166666666666655e-03*G4_2_1_9_2_6_0 + 4.166666666666656e-03*G4_2_1_9_2_7_0 + 4.166666666666654e-03*G4_2_1_10_2_4_0 + 4.166666666666655e-03*G4_2_1_10_2_5_0 + 8.333333333333311e-03*G4_2_1_10_2_6_0 + 4.166666666666655e-03*G4_2_1_10_2_7_0 + 4.166666666666656e-03*G4_2_1_11_2_4_0 + 4.166666666666656e-03*G4_2_1_11_2_5_0 + 4.166666666666655e-03*G4_2_1_11_2_6_0 + 8.333333333333311e-03*G4_2_1_11_2_7_0 + 8.333333333333309e-03*G4_2_2_8_2_8_0 + 4.166666666666654e-03*G4_2_2_8_2_9_0 + 4.166666666666654e-03*G4_2_2_8_2_10_0 + 4.166666666666656e-03*G4_2_2_8_2_11_0 + 4.166666666666654e-03*G4_2_2_9_2_8_0 + 8.333333333333309e-03*G4_2_2_9_2_9_0 + 4.166666666666655e-03*G4_2_2_9_2_10_0 + 4.166666666666656e-03*G4_2_2_9_2_11_0 + 4.166666666666654e-03*G4_2_2_10_2_8_0 + 4.166666666666655e-03*G4_2_2_10_2_9_0 + 8.333333333333311e-03*G4_2_2_10_2_10_0 + 4.166666666666655e-03*G4_2_2_10_2_11_0 + 4.166666666666656e-03*G4_2_2_11_2_8_0 + 4.166666666666656e-03*G4_2_2_11_2_9_0 + 4.166666666666655e-03*G4_2_2_11_2_10_0 + 8.333333333333311e-03*G4_2_2_11_2_11_0;
    block[38] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_2_1 + 4.166666666666657e-03*G2_0_0_1 + 4.166666666666655e-03*G2_0_1_1 + 4.166666666666656e-03*G2_0_2_1 + 8.333333333333311e-03*G2_0_3_1 + 4.166666666666657e-03*G2_1_4_1 + 4.166666666666657e-03*G2_1_5_1 + 4.166666666666656e-03*G2_1_6_1 + 8.333333333333311e-03*G2_1_7_1 + 4.166666666666657e-03*G2_2_8_1 + 4.166666666666657e-03*G2_2_9_1 + 4.166666666666656e-03*G2_2_10_1 + 8.333333333333311e-03*G2_2_11_1 + 8.333333333333323e-02*G3_0_0_2_1 + 8.333333333333311e-03*G4_0_0_0_2_0_1 + 4.166666666666655e-03*G4_0_0_0_2_1_1 + 4.166666666666656e-03*G4_0_0_0_2_2_1 + 4.166666666666657e-03*G4_0_0_0_2_3_1 + 4.166666666666655e-03*G4_0_0_1_2_0_1 + 8.333333333333309e-03*G4_0_0_1_2_1_1 + 4.166666666666654e-03*G4_0_0_1_2_2_1 + 4.166666666666655e-03*G4_0_0_1_2_3_1 + 4.166666666666656e-03*G4_0_0_2_2_0_1 + 4.166666666666654e-03*G4_0_0_2_2_1_1 + 8.333333333333311e-03*G4_0_0_2_2_2_1 + 4.166666666666656e-03*G4_0_0_2_2_3_1 + 4.166666666666657e-03*G4_0_0_3_2_0_1 + 4.166666666666655e-03*G4_0_0_3_2_1_1 + 4.166666666666656e-03*G4_0_0_3_2_2_1 + 8.333333333333311e-03*G4_0_0_3_2_3_1 + 8.333333333333311e-03*G4_0_1_0_2_4_1 + 4.166666666666655e-03*G4_0_1_0_2_5_1 + 4.166666666666656e-03*G4_0_1_0_2_6_1 + 4.166666666666657e-03*G4_0_1_0_2_7_1 + 4.166666666666654e-03*G4_0_1_1_2_4_1 + 8.333333333333309e-03*G4_0_1_1_2_5_1 + 4.166666666666654e-03*G4_0_1_1_2_6_1 + 4.166666666666655e-03*G4_0_1_1_2_7_1 + 4.166666666666654e-03*G4_0_1_2_2_4_1 + 4.166666666666656e-03*G4_0_1_2_2_5_1 + 8.333333333333311e-03*G4_0_1_2_2_6_1 + 4.166666666666656e-03*G4_0_1_2_2_7_1 + 4.166666666666657e-03*G4_0_1_3_2_4_1 + 4.166666666666657e-03*G4_0_1_3_2_5_1 + 4.166666666666656e-03*G4_0_1_3_2_6_1 + 8.333333333333311e-03*G4_0_1_3_2_7_1 + 8.333333333333311e-03*G4_0_2_0_2_8_1 + 4.166666666666655e-03*G4_0_2_0_2_9_1 + 4.166666666666656e-03*G4_0_2_0_2_10_1 + 4.166666666666657e-03*G4_0_2_0_2_11_1 + 4.166666666666654e-03*G4_0_2_1_2_8_1 + 8.333333333333309e-03*G4_0_2_1_2_9_1 + 4.166666666666654e-03*G4_0_2_1_2_10_1 + 4.166666666666655e-03*G4_0_2_1_2_11_1 + 4.166666666666654e-03*G4_0_2_2_2_8_1 + 4.166666666666656e-03*G4_0_2_2_2_9_1 + 8.333333333333311e-03*G4_0_2_2_2_10_1 + 4.166666666666656e-03*G4_0_2_2_2_11_1 + 4.166666666666657e-03*G4_0_2_3_2_8_1 + 4.166666666666657e-03*G4_0_2_3_2_9_1 + 4.166666666666656e-03*G4_0_2_3_2_10_1 + 8.333333333333311e-03*G4_0_2_3_2_11_1 + 8.333333333333311e-03*G4_1_0_4_2_0_1 + 4.166666666666654e-03*G4_1_0_4_2_1_1 + 4.166666666666654e-03*G4_1_0_4_2_2_1 + 4.166666666666657e-03*G4_1_0_4_2_3_1 + 4.166666666666655e-03*G4_1_0_5_2_0_1 + 8.333333333333309e-03*G4_1_0_5_2_1_1 + 4.166666666666656e-03*G4_1_0_5_2_2_1 + 4.166666666666657e-03*G4_1_0_5_2_3_1 + 4.166666666666656e-03*G4_1_0_6_2_0_1 + 4.166666666666654e-03*G4_1_0_6_2_1_1 + 8.333333333333311e-03*G4_1_0_6_2_2_1 + 4.166666666666656e-03*G4_1_0_6_2_3_1 + 4.166666666666657e-03*G4_1_0_7_2_0_1 + 4.166666666666655e-03*G4_1_0_7_2_1_1 + 4.166666666666656e-03*G4_1_0_7_2_2_1 + 8.333333333333311e-03*G4_1_0_7_2_3_1 + 8.333333333333311e-03*G4_1_1_4_2_4_1 + 4.166666666666654e-03*G4_1_1_4_2_5_1 + 4.166666666666654e-03*G4_1_1_4_2_6_1 + 4.166666666666657e-03*G4_1_1_4_2_7_1 + 4.166666666666654e-03*G4_1_1_5_2_4_1 + 8.333333333333309e-03*G4_1_1_5_2_5_1 + 4.166666666666656e-03*G4_1_1_5_2_6_1 + 4.166666666666657e-03*G4_1_1_5_2_7_1 + 4.166666666666654e-03*G4_1_1_6_2_4_1 + 4.166666666666656e-03*G4_1_1_6_2_5_1 + 8.333333333333311e-03*G4_1_1_6_2_6_1 + 4.166666666666656e-03*G4_1_1_6_2_7_1 + 4.166666666666657e-03*G4_1_1_7_2_4_1 + 4.166666666666657e-03*G4_1_1_7_2_5_1 + 4.166666666666656e-03*G4_1_1_7_2_6_1 + 8.333333333333311e-03*G4_1_1_7_2_7_1 + 8.333333333333311e-03*G4_1_2_4_2_8_1 + 4.166666666666654e-03*G4_1_2_4_2_9_1 + 4.166666666666654e-03*G4_1_2_4_2_10_1 + 4.166666666666657e-03*G4_1_2_4_2_11_1 + 4.166666666666654e-03*G4_1_2_5_2_8_1 + 8.333333333333309e-03*G4_1_2_5_2_9_1 + 4.166666666666656e-03*G4_1_2_5_2_10_1 + 4.166666666666657e-03*G4_1_2_5_2_11_1 + 4.166666666666654e-03*G4_1_2_6_2_8_1 + 4.166666666666656e-03*G4_1_2_6_2_9_1 + 8.333333333333311e-03*G4_1_2_6_2_10_1 + 4.166666666666656e-03*G4_1_2_6_2_11_1 + 4.166666666666657e-03*G4_1_2_7_2_8_1 + 4.166666666666657e-03*G4_1_2_7_2_9_1 + 4.166666666666656e-03*G4_1_2_7_2_10_1 + 8.333333333333311e-03*G4_1_2_7_2_11_1 + 8.333333333333311e-03*G4_2_0_8_2_0_1 + 4.166666666666654e-03*G4_2_0_8_2_1_1 + 4.166666666666654e-03*G4_2_0_8_2_2_1 + 4.166666666666657e-03*G4_2_0_8_2_3_1 + 4.166666666666655e-03*G4_2_0_9_2_0_1 + 8.333333333333309e-03*G4_2_0_9_2_1_1 + 4.166666666666656e-03*G4_2_0_9_2_2_1 + 4.166666666666657e-03*G4_2_0_9_2_3_1 + 4.166666666666656e-03*G4_2_0_10_2_0_1 + 4.166666666666654e-03*G4_2_0_10_2_1_1 + 8.333333333333311e-03*G4_2_0_10_2_2_1 + 4.166666666666656e-03*G4_2_0_10_2_3_1 + 4.166666666666657e-03*G4_2_0_11_2_0_1 + 4.166666666666655e-03*G4_2_0_11_2_1_1 + 4.166666666666656e-03*G4_2_0_11_2_2_1 + 8.333333333333311e-03*G4_2_0_11_2_3_1 + 8.333333333333311e-03*G4_2_1_8_2_4_1 + 4.166666666666654e-03*G4_2_1_8_2_5_1 + 4.166666666666654e-03*G4_2_1_8_2_6_1 + 4.166666666666657e-03*G4_2_1_8_2_7_1 + 4.166666666666654e-03*G4_2_1_9_2_4_1 + 8.333333333333309e-03*G4_2_1_9_2_5_1 + 4.166666666666656e-03*G4_2_1_9_2_6_1 + 4.166666666666657e-03*G4_2_1_9_2_7_1 + 4.166666666666654e-03*G4_2_1_10_2_4_1 + 4.166666666666656e-03*G4_2_1_10_2_5_1 + 8.333333333333311e-03*G4_2_1_10_2_6_1 + 4.166666666666656e-03*G4_2_1_10_2_7_1 + 4.166666666666657e-03*G4_2_1_11_2_4_1 + 4.166666666666657e-03*G4_2_1_11_2_5_1 + 4.166666666666656e-03*G4_2_1_11_2_6_1 + 8.333333333333311e-03*G4_2_1_11_2_7_1 + 8.333333333333311e-03*G4_2_2_8_2_8_1 + 4.166666666666654e-03*G4_2_2_8_2_9_1 + 4.166666666666654e-03*G4_2_2_8_2_10_1 + 4.166666666666657e-03*G4_2_2_8_2_11_1 + 4.166666666666654e-03*G4_2_2_9_2_8_1 + 8.333333333333309e-03*G4_2_2_9_2_9_1 + 4.166666666666656e-03*G4_2_2_9_2_10_1 + 4.166666666666657e-03*G4_2_2_9_2_11_1 + 4.166666666666654e-03*G4_2_2_10_2_8_1 + 4.166666666666656e-03*G4_2_2_10_2_9_1 + 8.333333333333311e-03*G4_2_2_10_2_10_1 + 4.166666666666656e-03*G4_2_2_10_2_11_1 + 4.166666666666657e-03*G4_2_2_11_2_8_1 + 4.166666666666657e-03*G4_2_2_11_2_9_1 + 4.166666666666656e-03*G4_2_2_11_2_10_1 + 8.333333333333311e-03*G4_2_2_11_2_11_1;
    block[39] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_2_2 + 4.166666666666657e-03*G2_0_0_2 + 4.166666666666655e-03*G2_0_1_2 + 4.166666666666656e-03*G2_0_2_2 + 8.333333333333311e-03*G2_0_3_2 + 4.166666666666657e-03*G2_1_4_2 + 4.166666666666657e-03*G2_1_5_2 + 4.166666666666656e-03*G2_1_6_2 + 8.333333333333311e-03*G2_1_7_2 + 4.166666666666657e-03*G2_2_8_2 + 4.166666666666657e-03*G2_2_9_2 + 4.166666666666656e-03*G2_2_10_2 + 8.333333333333311e-03*G2_2_11_2 + 8.333333333333323e-02*G3_0_0_2_2 + 8.333333333333311e-03*G4_0_0_0_2_0_2 + 4.166666666666655e-03*G4_0_0_0_2_1_2 + 4.166666666666656e-03*G4_0_0_0_2_2_2 + 4.166666666666657e-03*G4_0_0_0_2_3_2 + 4.166666666666655e-03*G4_0_0_1_2_0_2 + 8.333333333333309e-03*G4_0_0_1_2_1_2 + 4.166666666666654e-03*G4_0_0_1_2_2_2 + 4.166666666666655e-03*G4_0_0_1_2_3_2 + 4.166666666666656e-03*G4_0_0_2_2_0_2 + 4.166666666666654e-03*G4_0_0_2_2_1_2 + 8.333333333333311e-03*G4_0_0_2_2_2_2 + 4.166666666666656e-03*G4_0_0_2_2_3_2 + 4.166666666666657e-03*G4_0_0_3_2_0_2 + 4.166666666666655e-03*G4_0_0_3_2_1_2 + 4.166666666666656e-03*G4_0_0_3_2_2_2 + 8.333333333333311e-03*G4_0_0_3_2_3_2 + 8.333333333333311e-03*G4_0_1_0_2_4_2 + 4.166666666666655e-03*G4_0_1_0_2_5_2 + 4.166666666666656e-03*G4_0_1_0_2_6_2 + 4.166666666666657e-03*G4_0_1_0_2_7_2 + 4.166666666666654e-03*G4_0_1_1_2_4_2 + 8.333333333333309e-03*G4_0_1_1_2_5_2 + 4.166666666666654e-03*G4_0_1_1_2_6_2 + 4.166666666666655e-03*G4_0_1_1_2_7_2 + 4.166666666666654e-03*G4_0_1_2_2_4_2 + 4.166666666666656e-03*G4_0_1_2_2_5_2 + 8.333333333333311e-03*G4_0_1_2_2_6_2 + 4.166666666666656e-03*G4_0_1_2_2_7_2 + 4.166666666666657e-03*G4_0_1_3_2_4_2 + 4.166666666666657e-03*G4_0_1_3_2_5_2 + 4.166666666666656e-03*G4_0_1_3_2_6_2 + 8.333333333333311e-03*G4_0_1_3_2_7_2 + 8.333333333333311e-03*G4_0_2_0_2_8_2 + 4.166666666666655e-03*G4_0_2_0_2_9_2 + 4.166666666666656e-03*G4_0_2_0_2_10_2 + 4.166666666666657e-03*G4_0_2_0_2_11_2 + 4.166666666666654e-03*G4_0_2_1_2_8_2 + 8.333333333333309e-03*G4_0_2_1_2_9_2 + 4.166666666666654e-03*G4_0_2_1_2_10_2 + 4.166666666666655e-03*G4_0_2_1_2_11_2 + 4.166666666666654e-03*G4_0_2_2_2_8_2 + 4.166666666666656e-03*G4_0_2_2_2_9_2 + 8.333333333333311e-03*G4_0_2_2_2_10_2 + 4.166666666666656e-03*G4_0_2_2_2_11_2 + 4.166666666666657e-03*G4_0_2_3_2_8_2 + 4.166666666666657e-03*G4_0_2_3_2_9_2 + 4.166666666666656e-03*G4_0_2_3_2_10_2 + 8.333333333333311e-03*G4_0_2_3_2_11_2 + 8.333333333333311e-03*G4_1_0_4_2_0_2 + 4.166666666666654e-03*G4_1_0_4_2_1_2 + 4.166666666666654e-03*G4_1_0_4_2_2_2 + 4.166666666666657e-03*G4_1_0_4_2_3_2 + 4.166666666666655e-03*G4_1_0_5_2_0_2 + 8.333333333333309e-03*G4_1_0_5_2_1_2 + 4.166666666666656e-03*G4_1_0_5_2_2_2 + 4.166666666666657e-03*G4_1_0_5_2_3_2 + 4.166666666666656e-03*G4_1_0_6_2_0_2 + 4.166666666666654e-03*G4_1_0_6_2_1_2 + 8.333333333333311e-03*G4_1_0_6_2_2_2 + 4.166666666666656e-03*G4_1_0_6_2_3_2 + 4.166666666666657e-03*G4_1_0_7_2_0_2 + 4.166666666666655e-03*G4_1_0_7_2_1_2 + 4.166666666666656e-03*G4_1_0_7_2_2_2 + 8.333333333333311e-03*G4_1_0_7_2_3_2 + 8.333333333333311e-03*G4_1_1_4_2_4_2 + 4.166666666666654e-03*G4_1_1_4_2_5_2 + 4.166666666666654e-03*G4_1_1_4_2_6_2 + 4.166666666666657e-03*G4_1_1_4_2_7_2 + 4.166666666666654e-03*G4_1_1_5_2_4_2 + 8.333333333333309e-03*G4_1_1_5_2_5_2 + 4.166666666666656e-03*G4_1_1_5_2_6_2 + 4.166666666666657e-03*G4_1_1_5_2_7_2 + 4.166666666666654e-03*G4_1_1_6_2_4_2 + 4.166666666666656e-03*G4_1_1_6_2_5_2 + 8.333333333333311e-03*G4_1_1_6_2_6_2 + 4.166666666666656e-03*G4_1_1_6_2_7_2 + 4.166666666666657e-03*G4_1_1_7_2_4_2 + 4.166666666666657e-03*G4_1_1_7_2_5_2 + 4.166666666666656e-03*G4_1_1_7_2_6_2 + 8.333333333333311e-03*G4_1_1_7_2_7_2 + 8.333333333333311e-03*G4_1_2_4_2_8_2 + 4.166666666666654e-03*G4_1_2_4_2_9_2 + 4.166666666666654e-03*G4_1_2_4_2_10_2 + 4.166666666666657e-03*G4_1_2_4_2_11_2 + 4.166666666666654e-03*G4_1_2_5_2_8_2 + 8.333333333333309e-03*G4_1_2_5_2_9_2 + 4.166666666666656e-03*G4_1_2_5_2_10_2 + 4.166666666666657e-03*G4_1_2_5_2_11_2 + 4.166666666666654e-03*G4_1_2_6_2_8_2 + 4.166666666666656e-03*G4_1_2_6_2_9_2 + 8.333333333333311e-03*G4_1_2_6_2_10_2 + 4.166666666666656e-03*G4_1_2_6_2_11_2 + 4.166666666666657e-03*G4_1_2_7_2_8_2 + 4.166666666666657e-03*G4_1_2_7_2_9_2 + 4.166666666666656e-03*G4_1_2_7_2_10_2 + 8.333333333333311e-03*G4_1_2_7_2_11_2 + 8.333333333333311e-03*G4_2_0_8_2_0_2 + 4.166666666666654e-03*G4_2_0_8_2_1_2 + 4.166666666666654e-03*G4_2_0_8_2_2_2 + 4.166666666666657e-03*G4_2_0_8_2_3_2 + 4.166666666666655e-03*G4_2_0_9_2_0_2 + 8.333333333333309e-03*G4_2_0_9_2_1_2 + 4.166666666666656e-03*G4_2_0_9_2_2_2 + 4.166666666666657e-03*G4_2_0_9_2_3_2 + 4.166666666666656e-03*G4_2_0_10_2_0_2 + 4.166666666666654e-03*G4_2_0_10_2_1_2 + 8.333333333333311e-03*G4_2_0_10_2_2_2 + 4.166666666666656e-03*G4_2_0_10_2_3_2 + 4.166666666666657e-03*G4_2_0_11_2_0_2 + 4.166666666666655e-03*G4_2_0_11_2_1_2 + 4.166666666666656e-03*G4_2_0_11_2_2_2 + 8.333333333333311e-03*G4_2_0_11_2_3_2 + 8.333333333333311e-03*G4_2_1_8_2_4_2 + 4.166666666666654e-03*G4_2_1_8_2_5_2 + 4.166666666666654e-03*G4_2_1_8_2_6_2 + 4.166666666666657e-03*G4_2_1_8_2_7_2 + 4.166666666666654e-03*G4_2_1_9_2_4_2 + 8.333333333333309e-03*G4_2_1_9_2_5_2 + 4.166666666666656e-03*G4_2_1_9_2_6_2 + 4.166666666666657e-03*G4_2_1_9_2_7_2 + 4.166666666666654e-03*G4_2_1_10_2_4_2 + 4.166666666666656e-03*G4_2_1_10_2_5_2 + 8.333333333333311e-03*G4_2_1_10_2_6_2 + 4.166666666666656e-03*G4_2_1_10_2_7_2 + 4.166666666666657e-03*G4_2_1_11_2_4_2 + 4.166666666666657e-03*G4_2_1_11_2_5_2 + 4.166666666666656e-03*G4_2_1_11_2_6_2 + 8.333333333333311e-03*G4_2_1_11_2_7_2 + 8.333333333333311e-03*G4_2_2_8_2_8_2 + 4.166666666666654e-03*G4_2_2_8_2_9_2 + 4.166666666666654e-03*G4_2_2_8_2_10_2 + 4.166666666666657e-03*G4_2_2_8_2_11_2 + 4.166666666666654e-03*G4_2_2_9_2_8_2 + 8.333333333333309e-03*G4_2_2_9_2_9_2 + 4.166666666666656e-03*G4_2_2_9_2_10_2 + 4.166666666666657e-03*G4_2_2_9_2_11_2 + 4.166666666666654e-03*G4_2_2_10_2_8_2 + 4.166666666666656e-03*G4_2_2_10_2_9_2 + 8.333333333333311e-03*G4_2_2_10_2_10_2 + 4.166666666666656e-03*G4_2_2_10_2_11_2 + 4.166666666666657e-03*G4_2_2_11_2_8_2 + 4.166666666666657e-03*G4_2_2_11_2_9_2 + 4.166666666666656e-03*G4_2_2_11_2_10_2 + 8.333333333333311e-03*G4_2_2_11_2_11_2;
    block[40] = -8.333333333333322e-02*G3_0_1_2_0 - 8.333333333333323e-02*G3_0_1_2_1 - 8.333333333333323e-02*G3_0_1_2_2;
    block[41] = 8.333333333333322e-02*G3_0_1_2_0;
    block[42] = 8.333333333333323e-02*G3_0_1_2_1;
    block[43] = 8.333333333333323e-02*G3_0_1_2_2;
    block[44] = -8.333333333333322e-02*G3_0_2_2_0 - 8.333333333333323e-02*G3_0_2_2_1 - 8.333333333333323e-02*G3_0_2_2_2;
    block[45] = 8.333333333333322e-02*G3_0_2_2_0;
    block[46] = 8.333333333333323e-02*G3_0_2_2_1;
    block[47] = 8.333333333333323e-02*G3_0_2_2_2;
    block[48] = 8.333333333333320e-02*G3_1_0_0_0 + 8.333333333333322e-02*G3_1_0_0_1 + 8.333333333333320e-02*G3_1_0_0_2 + 8.333333333333322e-02*G3_1_0_1_0 + 8.333333333333323e-02*G3_1_0_1_1 + 8.333333333333322e-02*G3_1_0_1_2 + 8.333333333333322e-02*G3_1_0_2_0 + 8.333333333333323e-02*G3_1_0_2_1 + 8.333333333333322e-02*G3_1_0_2_2;
    block[49] = -8.333333333333320e-02*G3_1_0_0_0 - 8.333333333333322e-02*G3_1_0_1_0 - 8.333333333333322e-02*G3_1_0_2_0;
    block[50] = -8.333333333333322e-02*G3_1_0_0_1 - 8.333333333333323e-02*G3_1_0_1_1 - 8.333333333333323e-02*G3_1_0_2_1;
    block[51] = -8.333333333333322e-02*G3_1_0_0_2 - 8.333333333333323e-02*G3_1_0_1_2 - 8.333333333333323e-02*G3_1_0_2_2;
    block[52] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 8.333333333333322e-02*G1_0_1 + 8.333333333333322e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_1_1 + 8.333333333333323e-02*G1_1_2 + 8.333333333333322e-02*G1_2_0 + 8.333333333333323e-02*G1_2_1 + 8.333333333333323e-02*G1_2_2 - 8.333333333333309e-03*G2_0_0_0 - 8.333333333333311e-03*G2_0_0_1 - 8.333333333333312e-03*G2_0_0_2 - 4.166666666666654e-03*G2_0_1_0 - 4.166666666666654e-03*G2_0_1_1 - 4.166666666666654e-03*G2_0_1_2 - 4.166666666666654e-03*G2_0_2_0 - 4.166666666666654e-03*G2_0_2_1 - 4.166666666666654e-03*G2_0_2_2 - 4.166666666666656e-03*G2_0_3_0 - 4.166666666666657e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 8.333333333333309e-03*G2_1_4_0 - 8.333333333333311e-03*G2_1_4_1 - 8.333333333333312e-03*G2_1_4_2 - 4.166666666666654e-03*G2_1_5_0 - 4.166666666666654e-03*G2_1_5_1 - 4.166666666666655e-03*G2_1_5_2 - 4.166666666666654e-03*G2_1_6_0 - 4.166666666666654e-03*G2_1_6_1 - 4.166666666666654e-03*G2_1_6_2 - 4.166666666666656e-03*G2_1_7_0 - 4.166666666666657e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 8.333333333333309e-03*G2_2_8_0 - 8.333333333333311e-03*G2_2_8_1 - 8.333333333333312e-03*G2_2_8_2 - 4.166666666666654e-03*G2_2_9_0 - 4.166666666666654e-03*G2_2_9_1 - 4.166666666666655e-03*G2_2_9_2 - 4.166666666666654e-03*G2_2_10_0 - 4.166666666666654e-03*G2_2_10_1 - 4.166666666666654e-03*G2_2_10_2 - 4.166666666666656e-03*G2_2_11_0 - 4.166666666666657e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 + 8.333333333333320e-02*G3_1_1_0_0 + 8.333333333333322e-02*G3_1_1_0_1 + 8.333333333333322e-02*G3_1_1_0_2 + 8.333333333333322e-02*G3_1_1_1_0 + 8.333333333333323e-02*G3_1_1_1_1 + 8.333333333333323e-02*G3_1_1_1_2 + 8.333333333333322e-02*G3_1_1_2_0 + 8.333333333333323e-02*G3_1_1_2_1 + 8.333333333333323e-02*G3_1_1_2_2 + 8.333333333333309e-03*G4_0_0_0_0_0_0 + 8.333333333333309e-03*G4_0_0_0_0_0_1 + 8.333333333333312e-03*G4_0_0_0_0_0_2 + 4.166666666666654e-03*G4_0_0_0_0_1_0 + 4.166666666666654e-03*G4_0_0_0_0_1_1 + 4.166666666666655e-03*G4_0_0_0_0_1_2 + 4.166666666666654e-03*G4_0_0_0_0_2_0 + 4.166666666666654e-03*G4_0_0_0_0_2_1 + 4.166666666666656e-03*G4_0_0_0_0_2_2 + 4.166666666666656e-03*G4_0_0_0_0_3_0 + 4.166666666666656e-03*G4_0_0_0_0_3_1 + 4.166666666666657e-03*G4_0_0_0_0_3_2 + 8.333333333333309e-03*G4_0_0_0_1_0_0 + 8.333333333333311e-03*G4_0_0_0_1_0_1 + 8.333333333333312e-03*G4_0_0_0_1_0_2 + 4.166666666666654e-03*G4_0_0_0_1_1_0 + 4.166666666666655e-03*G4_0_0_0_1_1_1 + 4.166666666666655e-03*G4_0_0_0_1_1_2 + 4.166666666666654e-03*G4_0_0_0_1_2_0 + 4.166666666666656e-03*G4_0_0_0_1_2_1 + 4.166666666666656e-03*G4_0_0_0_1_2_2 + 4.166666666666656e-03*G4_0_0_0_1_3_0 + 4.166666666666657e-03*G4_0_0_0_1_3_1 + 4.166666666666658e-03*G4_0_0_0_1_3_2 + 8.333333333333311e-03*G4_0_0_0_2_0_0 + 8.333333333333312e-03*G4_0_0_0_2_0_1 + 8.333333333333314e-03*G4_0_0_0_2_0_2 + 4.166666666666654e-03*G4_0_0_0_2_1_0 + 4.166666666666655e-03*G4_0_0_0_2_1_1 + 4.166666666666656e-03*G4_0_0_0_2_1_2 + 4.166666666666655e-03*G4_0_0_0_2_2_0 + 4.166666666666656e-03*G4_0_0_0_2_2_1 + 4.166666666666656e-03*G4_0_0_0_2_2_2 + 4.166666666666657e-03*G4_0_0_0_2_3_0 + 4.166666666666658e-03*G4_0_0_0_2_3_1 + 4.166666666666659e-03*G4_0_0_0_2_3_2 + 4.166666666666654e-03*G4_0_0_1_0_0_0 + 4.166666666666654e-03*G4_0_0_1_0_0_1 + 4.166666666666655e-03*G4_0_0_1_0_0_2 + 8.333333333333307e-03*G4_0_0_1_0_1_0 + 8.333333333333307e-03*G4_0_0_1_0_1_1 + 8.333333333333307e-03*G4_0_0_1_0_1_2 + 4.166666666666654e-03*G4_0_0_1_0_2_0 + 4.166666666666654e-03*G4_0_0_1_0_2_1 + 4.166666666666654e-03*G4_0_0_1_0_2_2 + 4.166666666666654e-03*G4_0_0_1_0_3_0 + 4.166666666666655e-03*G4_0_0_1_0_3_1 + 4.166666666666655e-03*G4_0_0_1_0_3_2 + 4.166666666666654e-03*G4_0_0_1_1_0_0 + 4.166666666666655e-03*G4_0_0_1_1_0_1 + 4.166666666666655e-03*G4_0_0_1_1_0_2 + 8.333333333333307e-03*G4_0_0_1_1_1_0 + 8.333333333333309e-03*G4_0_0_1_1_1_1 + 8.333333333333309e-03*G4_0_0_1_1_1_2 + 4.166666666666654e-03*G4_0_0_1_1_2_0 + 4.166666666666654e-03*G4_0_0_1_1_2_1 + 4.166666666666655e-03*G4_0_0_1_1_2_2 + 4.166666666666655e-03*G4_0_0_1_1_3_0 + 4.166666666666655e-03*G4_0_0_1_1_3_1 + 4.166666666666656e-03*G4_0_0_1_1_3_2 + 4.166666666666654e-03*G4_0_0_1_2_0_0 + 4.166666666666655e-03*G4_0_0_1_2_0_1 + 4.166666666666656e-03*G4_0_0_1_2_0_2 + 8.333333333333307e-03*G4_0_0_1_2_1_0 + 8.333333333333309e-03*G4_0_0_1_2_1_1 + 8.333333333333309e-03*G4_0_0_1_2_1_2 + 4.166666666666654e-03*G4_0_0_1_2_2_0 + 4.166666666666655e-03*G4_0_0_1_2_2_1 + 4.166666666666655e-03*G4_0_0_1_2_2_2 + 4.166666666666655e-03*G4_0_0_1_2_3_0 + 4.166666666666656e-03*G4_0_0_1_2_3_1 + 4.166666666666656e-03*G4_0_0_1_2_3_2 + 4.166666666666654e-03*G4_0_0_2_0_0_0 + 4.166666666666654e-03*G4_0_0_2_0_0_1 + 4.166666666666655e-03*G4_0_0_2_0_0_2 + 4.166666666666654e-03*G4_0_0_2_0_1_0 + 4.166666666666654e-03*G4_0_0_2_0_1_1 + 4.166666666666654e-03*G4_0_0_2_0_1_2 + 8.333333333333309e-03*G4_0_0_2_0_2_0 + 8.333333333333309e-03*G4_0_0_2_0_2_1 + 8.333333333333311e-03*G4_0_0_2_0_2_2 + 4.166666666666654e-03*G4_0_0_2_0_3_0 + 4.166666666666655e-03*G4_0_0_2_0_3_1 + 4.166666666666655e-03*G4_0_0_2_0_3_2 + 4.166666666666654e-03*G4_0_0_2_1_0_0 + 4.166666666666656e-03*G4_0_0_2_1_0_1 + 4.166666666666656e-03*G4_0_0_2_1_0_2 + 4.166666666666654e-03*G4_0_0_2_1_1_0 + 4.166666666666654e-03*G4_0_0_2_1_1_1 + 4.166666666666654e-03*G4_0_0_2_1_1_2 + 8.333333333333311e-03*G4_0_0_2_1_2_0 + 8.333333333333311e-03*G4_0_0_2_1_2_1 + 8.333333333333312e-03*G4_0_0_2_1_2_2 + 4.166666666666655e-03*G4_0_0_2_1_3_0 + 4.166666666666656e-03*G4_0_0_2_1_3_1 + 4.166666666666657e-03*G4_0_0_2_1_3_2 + 4.166666666666655e-03*G4_0_0_2_2_0_0 + 4.166666666666656e-03*G4_0_0_2_2_0_1 + 4.166666666666656e-03*G4_0_0_2_2_0_2 + 4.166666666666654e-03*G4_0_0_2_2_1_0 + 4.166666666666654e-03*G4_0_0_2_2_1_1 + 4.166666666666655e-03*G4_0_0_2_2_1_2 + 8.333333333333311e-03*G4_0_0_2_2_2_0 + 8.333333333333312e-03*G4_0_0_2_2_2_1 + 8.333333333333312e-03*G4_0_0_2_2_2_2 + 4.166666666666655e-03*G4_0_0_2_2_3_0 + 4.166666666666657e-03*G4_0_0_2_2_3_1 + 4.166666666666657e-03*G4_0_0_2_2_3_2 + 4.166666666666656e-03*G4_0_0_3_0_0_0 + 4.166666666666656e-03*G4_0_0_3_0_0_1 + 4.166666666666657e-03*G4_0_0_3_0_0_2 + 4.166666666666654e-03*G4_0_0_3_0_1_0 + 4.166666666666655e-03*G4_0_0_3_0_1_1 + 4.166666666666655e-03*G4_0_0_3_0_1_2 + 4.166666666666655e-03*G4_0_0_3_0_2_0 + 4.166666666666655e-03*G4_0_0_3_0_2_1 + 4.166666666666655e-03*G4_0_0_3_0_2_2 + 8.333333333333309e-03*G4_0_0_3_0_3_0 + 8.333333333333311e-03*G4_0_0_3_0_3_1 + 8.333333333333311e-03*G4_0_0_3_0_3_2 + 4.166666666666656e-03*G4_0_0_3_1_0_0 + 4.166666666666657e-03*G4_0_0_3_1_0_1 + 4.166666666666658e-03*G4_0_0_3_1_0_2 + 4.166666666666655e-03*G4_0_0_3_1_1_0 + 4.166666666666655e-03*G4_0_0_3_1_1_1 + 4.166666666666656e-03*G4_0_0_3_1_1_2 + 4.166666666666655e-03*G4_0_0_3_1_2_0 + 4.166666666666656e-03*G4_0_0_3_1_2_1 + 4.166666666666657e-03*G4_0_0_3_1_2_2 + 8.333333333333311e-03*G4_0_0_3_1_3_0 + 8.333333333333311e-03*G4_0_0_3_1_3_1 + 8.333333333333312e-03*G4_0_0_3_1_3_2 + 4.166666666666657e-03*G4_0_0_3_2_0_0 + 4.166666666666658e-03*G4_0_0_3_2_0_1 + 4.166666666666659e-03*G4_0_0_3_2_0_2 + 4.166666666666655e-03*G4_0_0_3_2_1_0 + 4.166666666666656e-03*G4_0_0_3_2_1_1 + 4.166666666666656e-03*G4_0_0_3_2_1_2 + 4.166666666666655e-03*G4_0_0_3_2_2_0 + 4.166666666666657e-03*G4_0_0_3_2_2_1 + 4.166666666666657e-03*G4_0_0_3_2_2_2 + 8.333333333333311e-03*G4_0_0_3_2_3_0 + 8.333333333333312e-03*G4_0_0_3_2_3_1 + 8.333333333333312e-03*G4_0_0_3_2_3_2 + 8.333333333333309e-03*G4_0_1_0_0_4_0 + 8.333333333333309e-03*G4_0_1_0_0_4_1 + 8.333333333333311e-03*G4_0_1_0_0_4_2 + 4.166666666666654e-03*G4_0_1_0_0_5_0 + 4.166666666666655e-03*G4_0_1_0_0_5_1 + 4.166666666666655e-03*G4_0_1_0_0_5_2 + 4.166666666666654e-03*G4_0_1_0_0_6_0 + 4.166666666666654e-03*G4_0_1_0_0_6_1 + 4.166666666666656e-03*G4_0_1_0_0_6_2 + 4.166666666666656e-03*G4_0_1_0_0_7_0 + 4.166666666666656e-03*G4_0_1_0_0_7_1 + 4.166666666666657e-03*G4_0_1_0_0_7_2 + 8.333333333333309e-03*G4_0_1_0_1_4_0 + 8.333333333333311e-03*G4_0_1_0_1_4_1 + 8.333333333333312e-03*G4_0_1_0_1_4_2 + 4.166666666666655e-03*G4_0_1_0_1_5_0 + 4.166666666666655e-03*G4_0_1_0_1_5_1 + 4.166666666666656e-03*G4_0_1_0_1_5_2 + 4.166666666666654e-03*G4_0_1_0_1_6_0 + 4.166666666666656e-03*G4_0_1_0_1_6_1 + 4.166666666666656e-03*G4_0_1_0_1_6_2 + 4.166666666666656e-03*G4_0_1_0_1_7_0 + 4.166666666666657e-03*G4_0_1_0_1_7_1 + 4.166666666666658e-03*G4_0_1_0_1_7_2 + 8.333333333333311e-03*G4_0_1_0_2_4_0 + 8.333333333333312e-03*G4_0_1_0_2_4_1 + 8.333333333333314e-03*G4_0_1_0_2_4_2 + 4.166666666666655e-03*G4_0_1_0_2_5_0 + 4.166666666666656e-03*G4_0_1_0_2_5_1 + 4.166666666666657e-03*G4_0_1_0_2_5_2 + 4.166666666666655e-03*G4_0_1_0_2_6_0 + 4.166666666666656e-03*G4_0_1_0_2_6_1 + 4.166666666666656e-03*G4_0_1_0_2_6_2 + 4.166666666666657e-03*G4_0_1_0_2_7_0 + 4.166666666666658e-03*G4_0_1_0_2_7_1 + 4.166666666666659e-03*G4_0_1_0_2_7_2 + 4.166666666666654e-03*G4_0_1_1_0_4_0 + 4.166666666666654e-03*G4_0_1_1_0_4_1 + 4.166666666666654e-03*G4_0_1_1_0_4_2 + 8.333333333333307e-03*G4_0_1_1_0_5_0 + 8.333333333333309e-03*G4_0_1_1_0_5_1 + 8.333333333333309e-03*G4_0_1_1_0_5_2 + 4.166666666666654e-03*G4_0_1_1_0_6_0 + 4.166666666666654e-03*G4_0_1_1_0_6_1 + 4.166666666666654e-03*G4_0_1_1_0_6_2 + 4.166666666666654e-03*G4_0_1_1_0_7_0 + 4.166666666666655e-03*G4_0_1_1_0_7_1 + 4.166666666666655e-03*G4_0_1_1_0_7_2 + 4.166666666666654e-03*G4_0_1_1_1_4_0 + 4.166666666666654e-03*G4_0_1_1_1_4_1 + 4.166666666666654e-03*G4_0_1_1_1_4_2 + 8.333333333333309e-03*G4_0_1_1_1_5_0 + 8.333333333333309e-03*G4_0_1_1_1_5_1 + 8.333333333333309e-03*G4_0_1_1_1_5_2 + 4.166666666666654e-03*G4_0_1_1_1_6_0 + 4.166666666666654e-03*G4_0_1_1_1_6_1 + 4.166666666666655e-03*G4_0_1_1_1_6_2 + 4.166666666666655e-03*G4_0_1_1_1_7_0 + 4.166666666666655e-03*G4_0_1_1_1_7_1 + 4.166666666666656e-03*G4_0_1_1_1_7_2 + 4.166666666666654e-03*G4_0_1_1_2_4_0 + 4.166666666666654e-03*G4_0_1_1_2_4_1 + 4.166666666666655e-03*G4_0_1_1_2_4_2 + 8.333333333333309e-03*G4_0_1_1_2_5_0 + 8.333333333333309e-03*G4_0_1_1_2_5_1 + 8.333333333333309e-03*G4_0_1_1_2_5_2 + 4.166666666666654e-03*G4_0_1_1_2_6_0 + 4.166666666666655e-03*G4_0_1_1_2_6_1 + 4.166666666666655e-03*G4_0_1_1_2_6_2 + 4.166666666666655e-03*G4_0_1_1_2_7_0 + 4.166666666666656e-03*G4_0_1_1_2_7_1 + 4.166666666666656e-03*G4_0_1_1_2_7_2 + 4.166666666666653e-03*G4_0_1_2_0_4_0 + 4.166666666666654e-03*G4_0_1_2_0_4_1 + 4.166666666666654e-03*G4_0_1_2_0_4_2 + 4.166666666666654e-03*G4_0_1_2_0_5_0 + 4.166666666666655e-03*G4_0_1_2_0_5_1 + 4.166666666666655e-03*G4_0_1_2_0_5_2 + 8.333333333333309e-03*G4_0_1_2_0_6_0 + 8.333333333333309e-03*G4_0_1_2_0_6_1 + 8.333333333333311e-03*G4_0_1_2_0_6_2 + 4.166666666666654e-03*G4_0_1_2_0_7_0 + 4.166666666666655e-03*G4_0_1_2_0_7_1 + 4.166666666666655e-03*G4_0_1_2_0_7_2 + 4.166666666666654e-03*G4_0_1_2_1_4_0 + 4.166666666666654e-03*G4_0_1_2_1_4_1 + 4.166666666666654e-03*G4_0_1_2_1_4_2 + 4.166666666666655e-03*G4_0_1_2_1_5_0 + 4.166666666666656e-03*G4_0_1_2_1_5_1 + 4.166666666666656e-03*G4_0_1_2_1_5_2 + 8.333333333333311e-03*G4_0_1_2_1_6_0 + 8.333333333333311e-03*G4_0_1_2_1_6_1 + 8.333333333333312e-03*G4_0_1_2_1_6_2 + 4.166666666666655e-03*G4_0_1_2_1_7_0 + 4.166666666666656e-03*G4_0_1_2_1_7_1 + 4.166666666666657e-03*G4_0_1_2_1_7_2 + 4.166666666666654e-03*G4_0_1_2_2_4_0 + 4.166666666666654e-03*G4_0_1_2_2_4_1 + 4.166666666666654e-03*G4_0_1_2_2_4_2 + 4.166666666666655e-03*G4_0_1_2_2_5_0 + 4.166666666666656e-03*G4_0_1_2_2_5_1 + 4.166666666666656e-03*G4_0_1_2_2_5_2 + 8.333333333333311e-03*G4_0_1_2_2_6_0 + 8.333333333333312e-03*G4_0_1_2_2_6_1 + 8.333333333333312e-03*G4_0_1_2_2_6_2 + 4.166666666666655e-03*G4_0_1_2_2_7_0 + 4.166666666666657e-03*G4_0_1_2_2_7_1 + 4.166666666666657e-03*G4_0_1_2_2_7_2 + 4.166666666666655e-03*G4_0_1_3_0_4_0 + 4.166666666666656e-03*G4_0_1_3_0_4_1 + 4.166666666666657e-03*G4_0_1_3_0_4_2 + 4.166666666666655e-03*G4_0_1_3_0_5_0 + 4.166666666666656e-03*G4_0_1_3_0_5_1 + 4.166666666666656e-03*G4_0_1_3_0_5_2 + 4.166666666666655e-03*G4_0_1_3_0_6_0 + 4.166666666666655e-03*G4_0_1_3_0_6_1 + 4.166666666666655e-03*G4_0_1_3_0_6_2 + 8.333333333333309e-03*G4_0_1_3_0_7_0 + 8.333333333333311e-03*G4_0_1_3_0_7_1 + 8.333333333333311e-03*G4_0_1_3_0_7_2 + 4.166666666666656e-03*G4_0_1_3_1_4_0 + 4.166666666666657e-03*G4_0_1_3_1_4_1 + 4.166666666666657e-03*G4_0_1_3_1_4_2 + 4.166666666666656e-03*G4_0_1_3_1_5_0 + 4.166666666666657e-03*G4_0_1_3_1_5_1 + 4.166666666666657e-03*G4_0_1_3_1_5_2 + 4.166666666666655e-03*G4_0_1_3_1_6_0 + 4.166666666666656e-03*G4_0_1_3_1_6_1 + 4.166666666666657e-03*G4_0_1_3_1_6_2 + 8.333333333333311e-03*G4_0_1_3_1_7_0 + 8.333333333333311e-03*G4_0_1_3_1_7_1 + 8.333333333333312e-03*G4_0_1_3_1_7_2 + 4.166666666666657e-03*G4_0_1_3_2_4_0 + 4.166666666666657e-03*G4_0_1_3_2_4_1 + 4.166666666666658e-03*G4_0_1_3_2_4_2 + 4.166666666666656e-03*G4_0_1_3_2_5_0 + 4.166666666666657e-03*G4_0_1_3_2_5_1 + 4.166666666666657e-03*G4_0_1_3_2_5_2 + 4.166666666666655e-03*G4_0_1_3_2_6_0 + 4.166666666666657e-03*G4_0_1_3_2_6_1 + 4.166666666666657e-03*G4_0_1_3_2_6_2 + 8.333333333333311e-03*G4_0_1_3_2_7_0 + 8.333333333333312e-03*G4_0_1_3_2_7_1 + 8.333333333333312e-03*G4_0_1_3_2_7_2 + 8.333333333333309e-03*G4_0_2_0_0_8_0 + 8.333333333333309e-03*G4_0_2_0_0_8_1 + 8.333333333333311e-03*G4_0_2_0_0_8_2 + 4.166666666666654e-03*G4_0_2_0_0_9_0 + 4.166666666666655e-03*G4_0_2_0_0_9_1 + 4.166666666666655e-03*G4_0_2_0_0_9_2 + 4.166666666666654e-03*G4_0_2_0_0_10_0 + 4.166666666666654e-03*G4_0_2_0_0_10_1 + 4.166666666666656e-03*G4_0_2_0_0_10_2 + 4.166666666666656e-03*G4_0_2_0_0_11_0 + 4.166666666666656e-03*G4_0_2_0_0_11_1 + 4.166666666666657e-03*G4_0_2_0_0_11_2 + 8.333333333333309e-03*G4_0_2_0_1_8_0 + 8.333333333333311e-03*G4_0_2_0_1_8_1 + 8.333333333333312e-03*G4_0_2_0_1_8_2 + 4.166666666666655e-03*G4_0_2_0_1_9_0 + 4.166666666666655e-03*G4_0_2_0_1_9_1 + 4.166666666666656e-03*G4_0_2_0_1_9_2 + 4.166666666666654e-03*G4_0_2_0_1_10_0 + 4.166666666666656e-03*G4_0_2_0_1_10_1 + 4.166666666666656e-03*G4_0_2_0_1_10_2 + 4.166666666666656e-03*G4_0_2_0_1_11_0 + 4.166666666666657e-03*G4_0_2_0_1_11_1 + 4.166666666666658e-03*G4_0_2_0_1_11_2 + 8.333333333333311e-03*G4_0_2_0_2_8_0 + 8.333333333333312e-03*G4_0_2_0_2_8_1 + 8.333333333333314e-03*G4_0_2_0_2_8_2 + 4.166666666666655e-03*G4_0_2_0_2_9_0 + 4.166666666666656e-03*G4_0_2_0_2_9_1 + 4.166666666666657e-03*G4_0_2_0_2_9_2 + 4.166666666666655e-03*G4_0_2_0_2_10_0 + 4.166666666666656e-03*G4_0_2_0_2_10_1 + 4.166666666666656e-03*G4_0_2_0_2_10_2 + 4.166666666666657e-03*G4_0_2_0_2_11_0 + 4.166666666666658e-03*G4_0_2_0_2_11_1 + 4.166666666666659e-03*G4_0_2_0_2_11_2 + 4.166666666666654e-03*G4_0_2_1_0_8_0 + 4.166666666666654e-03*G4_0_2_1_0_8_1 + 4.166666666666654e-03*G4_0_2_1_0_8_2 + 8.333333333333307e-03*G4_0_2_1_0_9_0 + 8.333333333333309e-03*G4_0_2_1_0_9_1 + 8.333333333333309e-03*G4_0_2_1_0_9_2 + 4.166666666666654e-03*G4_0_2_1_0_10_0 + 4.166666666666654e-03*G4_0_2_1_0_10_1 + 4.166666666666654e-03*G4_0_2_1_0_10_2 + 4.166666666666654e-03*G4_0_2_1_0_11_0 + 4.166666666666655e-03*G4_0_2_1_0_11_1 + 4.166666666666655e-03*G4_0_2_1_0_11_2 + 4.166666666666654e-03*G4_0_2_1_1_8_0 + 4.166666666666654e-03*G4_0_2_1_1_8_1 + 4.166666666666654e-03*G4_0_2_1_1_8_2 + 8.333333333333309e-03*G4_0_2_1_1_9_0 + 8.333333333333309e-03*G4_0_2_1_1_9_1 + 8.333333333333309e-03*G4_0_2_1_1_9_2 + 4.166666666666654e-03*G4_0_2_1_1_10_0 + 4.166666666666654e-03*G4_0_2_1_1_10_1 + 4.166666666666655e-03*G4_0_2_1_1_10_2 + 4.166666666666655e-03*G4_0_2_1_1_11_0 + 4.166666666666655e-03*G4_0_2_1_1_11_1 + 4.166666666666656e-03*G4_0_2_1_1_11_2 + 4.166666666666654e-03*G4_0_2_1_2_8_0 + 4.166666666666654e-03*G4_0_2_1_2_8_1 + 4.166666666666655e-03*G4_0_2_1_2_8_2 + 8.333333333333309e-03*G4_0_2_1_2_9_0 + 8.333333333333309e-03*G4_0_2_1_2_9_1 + 8.333333333333309e-03*G4_0_2_1_2_9_2 + 4.166666666666654e-03*G4_0_2_1_2_10_0 + 4.166666666666655e-03*G4_0_2_1_2_10_1 + 4.166666666666655e-03*G4_0_2_1_2_10_2 + 4.166666666666655e-03*G4_0_2_1_2_11_0 + 4.166666666666656e-03*G4_0_2_1_2_11_1 + 4.166666666666656e-03*G4_0_2_1_2_11_2 + 4.166666666666653e-03*G4_0_2_2_0_8_0 + 4.166666666666654e-03*G4_0_2_2_0_8_1 + 4.166666666666654e-03*G4_0_2_2_0_8_2 + 4.166666666666654e-03*G4_0_2_2_0_9_0 + 4.166666666666655e-03*G4_0_2_2_0_9_1 + 4.166666666666655e-03*G4_0_2_2_0_9_2 + 8.333333333333309e-03*G4_0_2_2_0_10_0 + 8.333333333333309e-03*G4_0_2_2_0_10_1 + 8.333333333333311e-03*G4_0_2_2_0_10_2 + 4.166666666666654e-03*G4_0_2_2_0_11_0 + 4.166666666666655e-03*G4_0_2_2_0_11_1 + 4.166666666666655e-03*G4_0_2_2_0_11_2 + 4.166666666666654e-03*G4_0_2_2_1_8_0 + 4.166666666666654e-03*G4_0_2_2_1_8_1 + 4.166666666666654e-03*G4_0_2_2_1_8_2 + 4.166666666666655e-03*G4_0_2_2_1_9_0 + 4.166666666666656e-03*G4_0_2_2_1_9_1 + 4.166666666666656e-03*G4_0_2_2_1_9_2 + 8.333333333333311e-03*G4_0_2_2_1_10_0 + 8.333333333333311e-03*G4_0_2_2_1_10_1 + 8.333333333333312e-03*G4_0_2_2_1_10_2 + 4.166666666666655e-03*G4_0_2_2_1_11_0 + 4.166666666666656e-03*G4_0_2_2_1_11_1 + 4.166666666666657e-03*G4_0_2_2_1_11_2 + 4.166666666666654e-03*G4_0_2_2_2_8_0 + 4.166666666666654e-03*G4_0_2_2_2_8_1 + 4.166666666666654e-03*G4_0_2_2_2_8_2 + 4.166666666666655e-03*G4_0_2_2_2_9_0 + 4.166666666666656e-03*G4_0_2_2_2_9_1 + 4.166666666666656e-03*G4_0_2_2_2_9_2 + 8.333333333333311e-03*G4_0_2_2_2_10_0 + 8.333333333333312e-03*G4_0_2_2_2_10_1 + 8.333333333333312e-03*G4_0_2_2_2_10_2 + 4.166666666666655e-03*G4_0_2_2_2_11_0 + 4.166666666666657e-03*G4_0_2_2_2_11_1 + 4.166666666666657e-03*G4_0_2_2_2_11_2 + 4.166666666666655e-03*G4_0_2_3_0_8_0 + 4.166666666666656e-03*G4_0_2_3_0_8_1 + 4.166666666666657e-03*G4_0_2_3_0_8_2 + 4.166666666666655e-03*G4_0_2_3_0_9_0 + 4.166666666666656e-03*G4_0_2_3_0_9_1 + 4.166666666666656e-03*G4_0_2_3_0_9_2 + 4.166666666666655e-03*G4_0_2_3_0_10_0 + 4.166666666666655e-03*G4_0_2_3_0_10_1 + 4.166666666666655e-03*G4_0_2_3_0_10_2 + 8.333333333333309e-03*G4_0_2_3_0_11_0 + 8.333333333333311e-03*G4_0_2_3_0_11_1 + 8.333333333333311e-03*G4_0_2_3_0_11_2 + 4.166666666666656e-03*G4_0_2_3_1_8_0 + 4.166666666666657e-03*G4_0_2_3_1_8_1 + 4.166666666666657e-03*G4_0_2_3_1_8_2 + 4.166666666666656e-03*G4_0_2_3_1_9_0 + 4.166666666666657e-03*G4_0_2_3_1_9_1 + 4.166666666666657e-03*G4_0_2_3_1_9_2 + 4.166666666666655e-03*G4_0_2_3_1_10_0 + 4.166666666666656e-03*G4_0_2_3_1_10_1 + 4.166666666666657e-03*G4_0_2_3_1_10_2 + 8.333333333333311e-03*G4_0_2_3_1_11_0 + 8.333333333333311e-03*G4_0_2_3_1_11_1 + 8.333333333333312e-03*G4_0_2_3_1_11_2 + 4.166666666666657e-03*G4_0_2_3_2_8_0 + 4.166666666666657e-03*G4_0_2_3_2_8_1 + 4.166666666666658e-03*G4_0_2_3_2_8_2 + 4.166666666666656e-03*G4_0_2_3_2_9_0 + 4.166666666666657e-03*G4_0_2_3_2_9_1 + 4.166666666666657e-03*G4_0_2_3_2_9_2 + 4.166666666666655e-03*G4_0_2_3_2_10_0 + 4.166666666666657e-03*G4_0_2_3_2_10_1 + 4.166666666666657e-03*G4_0_2_3_2_10_2 + 8.333333333333311e-03*G4_0_2_3_2_11_0 + 8.333333333333312e-03*G4_0_2_3_2_11_1 + 8.333333333333312e-03*G4_0_2_3_2_11_2 + 8.333333333333309e-03*G4_1_0_4_0_0_0 + 8.333333333333309e-03*G4_1_0_4_0_0_1 + 8.333333333333311e-03*G4_1_0_4_0_0_2 + 4.166666666666654e-03*G4_1_0_4_0_1_0 + 4.166666666666654e-03*G4_1_0_4_0_1_1 + 4.166666666666654e-03*G4_1_0_4_0_1_2 + 4.166666666666653e-03*G4_1_0_4_0_2_0 + 4.166666666666654e-03*G4_1_0_4_0_2_1 + 4.166666666666654e-03*G4_1_0_4_0_2_2 + 4.166666666666654e-03*G4_1_0_4_0_3_0 + 4.166666666666656e-03*G4_1_0_4_0_3_1 + 4.166666666666657e-03*G4_1_0_4_0_3_2 + 8.333333333333309e-03*G4_1_0_4_1_0_0 + 8.333333333333311e-03*G4_1_0_4_1_0_1 + 8.333333333333312e-03*G4_1_0_4_1_0_2 + 4.166666666666654e-03*G4_1_0_4_1_1_0 + 4.166666666666654e-03*G4_1_0_4_1_1_1 + 4.166666666666654e-03*G4_1_0_4_1_1_2 + 4.166666666666654e-03*G4_1_0_4_1_2_0 + 4.166666666666654e-03*G4_1_0_4_1_2_1 + 4.166666666666654e-03*G4_1_0_4_1_2_2 + 4.166666666666656e-03*G4_1_0_4_1_3_0 + 4.166666666666657e-03*G4_1_0_4_1_3_1 + 4.166666666666657e-03*G4_1_0_4_1_3_2 + 8.333333333333311e-03*G4_1_0_4_2_0_0 + 8.333333333333312e-03*G4_1_0_4_2_0_1 + 8.333333333333314e-03*G4_1_0_4_2_0_2 + 4.166666666666654e-03*G4_1_0_4_2_1_0 + 4.166666666666654e-03*G4_1_0_4_2_1_1 + 4.166666666666655e-03*G4_1_0_4_2_1_2 + 4.166666666666654e-03*G4_1_0_4_2_2_0 + 4.166666666666654e-03*G4_1_0_4_2_2_1 + 4.166666666666654e-03*G4_1_0_4_2_2_2 + 4.166666666666657e-03*G4_1_0_4_2_3_0 + 4.166666666666657e-03*G4_1_0_4_2_3_1 + 4.166666666666658e-03*G4_1_0_4_2_3_2 + 4.166666666666654e-03*G4_1_0_5_0_0_0 + 4.166666666666655e-03*G4_1_0_5_0_0_1 + 4.166666666666655e-03*G4_1_0_5_0_0_2 + 8.333333333333307e-03*G4_1_0_5_0_1_0 + 8.333333333333309e-03*G4_1_0_5_0_1_1 + 8.333333333333309e-03*G4_1_0_5_0_1_2 + 4.166666666666654e-03*G4_1_0_5_0_2_0 + 4.166666666666655e-03*G4_1_0_5_0_2_1 + 4.166666666666655e-03*G4_1_0_5_0_2_2 + 4.166666666666655e-03*G4_1_0_5_0_3_0 + 4.166666666666656e-03*G4_1_0_5_0_3_1 + 4.166666666666656e-03*G4_1_0_5_0_3_2 + 4.166666666666655e-03*G4_1_0_5_1_0_0 + 4.166666666666655e-03*G4_1_0_5_1_0_1 + 4.166666666666656e-03*G4_1_0_5_1_0_2 + 8.333333333333309e-03*G4_1_0_5_1_1_0 + 8.333333333333309e-03*G4_1_0_5_1_1_1 + 8.333333333333309e-03*G4_1_0_5_1_1_2 + 4.166666666666655e-03*G4_1_0_5_1_2_0 + 4.166666666666656e-03*G4_1_0_5_1_2_1 + 4.166666666666656e-03*G4_1_0_5_1_2_2 + 4.166666666666656e-03*G4_1_0_5_1_3_0 + 4.166666666666657e-03*G4_1_0_5_1_3_1 + 4.166666666666657e-03*G4_1_0_5_1_3_2 + 4.166666666666655e-03*G4_1_0_5_2_0_0 + 4.166666666666656e-03*G4_1_0_5_2_0_1 + 4.166666666666657e-03*G4_1_0_5_2_0_2 + 8.333333333333309e-03*G4_1_0_5_2_1_0 + 8.333333333333309e-03*G4_1_0_5_2_1_1 + 8.333333333333309e-03*G4_1_0_5_2_1_2 + 4.166666666666655e-03*G4_1_0_5_2_2_0 + 4.166666666666656e-03*G4_1_0_5_2_2_1 + 4.166666666666656e-03*G4_1_0_5_2_2_2 + 4.166666666666656e-03*G4_1_0_5_2_3_0 + 4.166666666666657e-03*G4_1_0_5_2_3_1 + 4.166666666666657e-03*G4_1_0_5_2_3_2 + 4.166666666666654e-03*G4_1_0_6_0_0_0 + 4.166666666666654e-03*G4_1_0_6_0_0_1 + 4.166666666666655e-03*G4_1_0_6_0_0_2 + 4.166666666666654e-03*G4_1_0_6_0_1_0 + 4.166666666666654e-03*G4_1_0_6_0_1_1 + 4.166666666666654e-03*G4_1_0_6_0_1_2 + 8.333333333333309e-03*G4_1_0_6_0_2_0 + 8.333333333333309e-03*G4_1_0_6_0_2_1 + 8.333333333333311e-03*G4_1_0_6_0_2_2 + 4.166666666666654e-03*G4_1_0_6_0_3_0 + 4.166666666666655e-03*G4_1_0_6_0_3_1 + 4.166666666666655e-03*G4_1_0_6_0_3_2 + 4.166666666666654e-03*G4_1_0_6_1_0_0 + 4.166666666666656e-03*G4_1_0_6_1_0_1 + 4.166666666666656e-03*G4_1_0_6_1_0_2 + 4.166666666666654e-03*G4_1_0_6_1_1_0 + 4.166666666666654e-03*G4_1_0_6_1_1_1 + 4.166666666666654e-03*G4_1_0_6_1_1_2 + 8.333333333333311e-03*G4_1_0_6_1_2_0 + 8.333333333333311e-03*G4_1_0_6_1_2_1 + 8.333333333333312e-03*G4_1_0_6_1_2_2 + 4.166666666666655e-03*G4_1_0_6_1_3_0 + 4.166666666666656e-03*G4_1_0_6_1_3_1 + 4.166666666666657e-03*G4_1_0_6_1_3_2 + 4.166666666666655e-03*G4_1_0_6_2_0_0 + 4.166666666666656e-03*G4_1_0_6_2_0_1 + 4.166666666666656e-03*G4_1_0_6_2_0_2 + 4.166666666666654e-03*G4_1_0_6_2_1_0 + 4.166666666666654e-03*G4_1_0_6_2_1_1 + 4.166666666666655e-03*G4_1_0_6_2_1_2 + 8.333333333333311e-03*G4_1_0_6_2_2_0 + 8.333333333333312e-03*G4_1_0_6_2_2_1 + 8.333333333333312e-03*G4_1_0_6_2_2_2 + 4.166666666666655e-03*G4_1_0_6_2_3_0 + 4.166666666666657e-03*G4_1_0_6_2_3_1 + 4.166666666666657e-03*G4_1_0_6_2_3_2 + 4.166666666666656e-03*G4_1_0_7_0_0_0 + 4.166666666666656e-03*G4_1_0_7_0_0_1 + 4.166666666666657e-03*G4_1_0_7_0_0_2 + 4.166666666666654e-03*G4_1_0_7_0_1_0 + 4.166666666666655e-03*G4_1_0_7_0_1_1 + 4.166666666666655e-03*G4_1_0_7_0_1_2 + 4.166666666666655e-03*G4_1_0_7_0_2_0 + 4.166666666666655e-03*G4_1_0_7_0_2_1 + 4.166666666666655e-03*G4_1_0_7_0_2_2 + 8.333333333333309e-03*G4_1_0_7_0_3_0 + 8.333333333333311e-03*G4_1_0_7_0_3_1 + 8.333333333333311e-03*G4_1_0_7_0_3_2 + 4.166666666666656e-03*G4_1_0_7_1_0_0 + 4.166666666666657e-03*G4_1_0_7_1_0_1 + 4.166666666666658e-03*G4_1_0_7_1_0_2 + 4.166666666666655e-03*G4_1_0_7_1_1_0 + 4.166666666666655e-03*G4_1_0_7_1_1_1 + 4.166666666666656e-03*G4_1_0_7_1_1_2 + 4.166666666666655e-03*G4_1_0_7_1_2_0 + 4.166666666666656e-03*G4_1_0_7_1_2_1 + 4.166666666666657e-03*G4_1_0_7_1_2_2 + 8.333333333333311e-03*G4_1_0_7_1_3_0 + 8.333333333333311e-03*G4_1_0_7_1_3_1 + 8.333333333333312e-03*G4_1_0_7_1_3_2 + 4.166666666666657e-03*G4_1_0_7_2_0_0 + 4.166666666666658e-03*G4_1_0_7_2_0_1 + 4.166666666666659e-03*G4_1_0_7_2_0_2 + 4.166666666666655e-03*G4_1_0_7_2_1_0 + 4.166666666666656e-03*G4_1_0_7_2_1_1 + 4.166666666666656e-03*G4_1_0_7_2_1_2 + 4.166666666666655e-03*G4_1_0_7_2_2_0 + 4.166666666666657e-03*G4_1_0_7_2_2_1 + 4.166666666666657e-03*G4_1_0_7_2_2_2 + 8.333333333333311e-03*G4_1_0_7_2_3_0 + 8.333333333333312e-03*G4_1_0_7_2_3_1 + 8.333333333333312e-03*G4_1_0_7_2_3_2 + 8.333333333333309e-03*G4_1_1_4_0_4_0 + 8.333333333333309e-03*G4_1_1_4_0_4_1 + 8.333333333333311e-03*G4_1_1_4_0_4_2 + 4.166666666666654e-03*G4_1_1_4_0_5_0 + 4.166666666666654e-03*G4_1_1_4_0_5_1 + 4.166666666666654e-03*G4_1_1_4_0_5_2 + 4.166666666666653e-03*G4_1_1_4_0_6_0 + 4.166666666666654e-03*G4_1_1_4_0_6_1 + 4.166666666666654e-03*G4_1_1_4_0_6_2 + 4.166666666666654e-03*G4_1_1_4_0_7_0 + 4.166666666666656e-03*G4_1_1_4_0_7_1 + 4.166666666666657e-03*G4_1_1_4_0_7_2 + 8.333333333333309e-03*G4_1_1_4_1_4_0 + 8.333333333333311e-03*G4_1_1_4_1_4_1 + 8.333333333333312e-03*G4_1_1_4_1_4_2 + 4.166666666666654e-03*G4_1_1_4_1_5_0 + 4.166666666666654e-03*G4_1_1_4_1_5_1 + 4.166666666666655e-03*G4_1_1_4_1_5_2 + 4.166666666666654e-03*G4_1_1_4_1_6_0 + 4.166666666666654e-03*G4_1_1_4_1_6_1 + 4.166666666666654e-03*G4_1_1_4_1_6_2 + 4.166666666666656e-03*G4_1_1_4_1_7_0 + 4.166666666666657e-03*G4_1_1_4_1_7_1 + 4.166666666666657e-03*G4_1_1_4_1_7_2 + 8.333333333333311e-03*G4_1_1_4_2_4_0 + 8.333333333333312e-03*G4_1_1_4_2_4_1 + 8.333333333333314e-03*G4_1_1_4_2_4_2 + 4.166666666666654e-03*G4_1_1_4_2_5_0 + 4.166666666666655e-03*G4_1_1_4_2_5_1 + 4.166666666666655e-03*G4_1_1_4_2_5_2 + 4.166666666666654e-03*G4_1_1_4_2_6_0 + 4.166666666666654e-03*G4_1_1_4_2_6_1 + 4.166666666666654e-03*G4_1_1_4_2_6_2 + 4.166666666666657e-03*G4_1_1_4_2_7_0 + 4.166666666666657e-03*G4_1_1_4_2_7_1 + 4.166666666666658e-03*G4_1_1_4_2_7_2 + 4.166666666666654e-03*G4_1_1_5_0_4_0 + 4.166666666666654e-03*G4_1_1_5_0_4_1 + 4.166666666666654e-03*G4_1_1_5_0_4_2 + 8.333333333333307e-03*G4_1_1_5_0_5_0 + 8.333333333333309e-03*G4_1_1_5_0_5_1 + 8.333333333333309e-03*G4_1_1_5_0_5_2 + 4.166666666666654e-03*G4_1_1_5_0_6_0 + 4.166666666666655e-03*G4_1_1_5_0_6_1 + 4.166666666666655e-03*G4_1_1_5_0_6_2 + 4.166666666666655e-03*G4_1_1_5_0_7_0 + 4.166666666666656e-03*G4_1_1_5_0_7_1 + 4.166666666666656e-03*G4_1_1_5_0_7_2 + 4.166666666666654e-03*G4_1_1_5_1_4_0 + 4.166666666666654e-03*G4_1_1_5_1_4_1 + 4.166666666666655e-03*G4_1_1_5_1_4_2 + 8.333333333333309e-03*G4_1_1_5_1_5_0 + 8.333333333333309e-03*G4_1_1_5_1_5_1 + 8.333333333333309e-03*G4_1_1_5_1_5_2 + 4.166666666666655e-03*G4_1_1_5_1_6_0 + 4.166666666666656e-03*G4_1_1_5_1_6_1 + 4.166666666666656e-03*G4_1_1_5_1_6_2 + 4.166666666666656e-03*G4_1_1_5_1_7_0 + 4.166666666666657e-03*G4_1_1_5_1_7_1 + 4.166666666666657e-03*G4_1_1_5_1_7_2 + 4.166666666666654e-03*G4_1_1_5_2_4_0 + 4.166666666666655e-03*G4_1_1_5_2_4_1 + 4.166666666666655e-03*G4_1_1_5_2_4_2 + 8.333333333333309e-03*G4_1_1_5_2_5_0 + 8.333333333333309e-03*G4_1_1_5_2_5_1 + 8.333333333333309e-03*G4_1_1_5_2_5_2 + 4.166666666666655e-03*G4_1_1_5_2_6_0 + 4.166666666666656e-03*G4_1_1_5_2_6_1 + 4.166666666666656e-03*G4_1_1_5_2_6_2 + 4.166666666666656e-03*G4_1_1_5_2_7_0 + 4.166666666666657e-03*G4_1_1_5_2_7_1 + 4.166666666666657e-03*G4_1_1_5_2_7_2 + 4.166666666666653e-03*G4_1_1_6_0_4_0 + 4.166666666666654e-03*G4_1_1_6_0_4_1 + 4.166666666666654e-03*G4_1_1_6_0_4_2 + 4.166666666666654e-03*G4_1_1_6_0_5_0 + 4.166666666666655e-03*G4_1_1_6_0_5_1 + 4.166666666666655e-03*G4_1_1_6_0_5_2 + 8.333333333333309e-03*G4_1_1_6_0_6_0 + 8.333333333333309e-03*G4_1_1_6_0_6_1 + 8.333333333333311e-03*G4_1_1_6_0_6_2 + 4.166666666666654e-03*G4_1_1_6_0_7_0 + 4.166666666666655e-03*G4_1_1_6_0_7_1 + 4.166666666666655e-03*G4_1_1_6_0_7_2 + 4.166666666666654e-03*G4_1_1_6_1_4_0 + 4.166666666666654e-03*G4_1_1_6_1_4_1 + 4.166666666666654e-03*G4_1_1_6_1_4_2 + 4.166666666666655e-03*G4_1_1_6_1_5_0 + 4.166666666666656e-03*G4_1_1_6_1_5_1 + 4.166666666666656e-03*G4_1_1_6_1_5_2 + 8.333333333333311e-03*G4_1_1_6_1_6_0 + 8.333333333333311e-03*G4_1_1_6_1_6_1 + 8.333333333333312e-03*G4_1_1_6_1_6_2 + 4.166666666666655e-03*G4_1_1_6_1_7_0 + 4.166666666666656e-03*G4_1_1_6_1_7_1 + 4.166666666666657e-03*G4_1_1_6_1_7_2 + 4.166666666666654e-03*G4_1_1_6_2_4_0 + 4.166666666666654e-03*G4_1_1_6_2_4_1 + 4.166666666666654e-03*G4_1_1_6_2_4_2 + 4.166666666666655e-03*G4_1_1_6_2_5_0 + 4.166666666666656e-03*G4_1_1_6_2_5_1 + 4.166666666666656e-03*G4_1_1_6_2_5_2 + 8.333333333333311e-03*G4_1_1_6_2_6_0 + 8.333333333333312e-03*G4_1_1_6_2_6_1 + 8.333333333333312e-03*G4_1_1_6_2_6_2 + 4.166666666666655e-03*G4_1_1_6_2_7_0 + 4.166666666666657e-03*G4_1_1_6_2_7_1 + 4.166666666666657e-03*G4_1_1_6_2_7_2 + 4.166666666666655e-03*G4_1_1_7_0_4_0 + 4.166666666666656e-03*G4_1_1_7_0_4_1 + 4.166666666666657e-03*G4_1_1_7_0_4_2 + 4.166666666666655e-03*G4_1_1_7_0_5_0 + 4.166666666666656e-03*G4_1_1_7_0_5_1 + 4.166666666666656e-03*G4_1_1_7_0_5_2 + 4.166666666666655e-03*G4_1_1_7_0_6_0 + 4.166666666666655e-03*G4_1_1_7_0_6_1 + 4.166666666666655e-03*G4_1_1_7_0_6_2 + 8.333333333333309e-03*G4_1_1_7_0_7_0 + 8.333333333333311e-03*G4_1_1_7_0_7_1 + 8.333333333333311e-03*G4_1_1_7_0_7_2 + 4.166666666666656e-03*G4_1_1_7_1_4_0 + 4.166666666666657e-03*G4_1_1_7_1_4_1 + 4.166666666666657e-03*G4_1_1_7_1_4_2 + 4.166666666666656e-03*G4_1_1_7_1_5_0 + 4.166666666666657e-03*G4_1_1_7_1_5_1 + 4.166666666666657e-03*G4_1_1_7_1_5_2 + 4.166666666666655e-03*G4_1_1_7_1_6_0 + 4.166666666666656e-03*G4_1_1_7_1_6_1 + 4.166666666666657e-03*G4_1_1_7_1_6_2 + 8.333333333333311e-03*G4_1_1_7_1_7_0 + 8.333333333333311e-03*G4_1_1_7_1_7_1 + 8.333333333333312e-03*G4_1_1_7_1_7_2 + 4.166666666666657e-03*G4_1_1_7_2_4_0 + 4.166666666666657e-03*G4_1_1_7_2_4_1 + 4.166666666666658e-03*G4_1_1_7_2_4_2 + 4.166666666666656e-03*G4_1_1_7_2_5_0 + 4.166666666666657e-03*G4_1_1_7_2_5_1 + 4.166666666666657e-03*G4_1_1_7_2_5_2 + 4.166666666666655e-03*G4_1_1_7_2_6_0 + 4.166666666666657e-03*G4_1_1_7_2_6_1 + 4.166666666666657e-03*G4_1_1_7_2_6_2 + 8.333333333333311e-03*G4_1_1_7_2_7_0 + 8.333333333333312e-03*G4_1_1_7_2_7_1 + 8.333333333333312e-03*G4_1_1_7_2_7_2 + 8.333333333333309e-03*G4_1_2_4_0_8_0 + 8.333333333333309e-03*G4_1_2_4_0_8_1 + 8.333333333333311e-03*G4_1_2_4_0_8_2 + 4.166666666666654e-03*G4_1_2_4_0_9_0 + 4.166666666666654e-03*G4_1_2_4_0_9_1 + 4.166666666666654e-03*G4_1_2_4_0_9_2 + 4.166666666666653e-03*G4_1_2_4_0_10_0 + 4.166666666666654e-03*G4_1_2_4_0_10_1 + 4.166666666666654e-03*G4_1_2_4_0_10_2 + 4.166666666666654e-03*G4_1_2_4_0_11_0 + 4.166666666666656e-03*G4_1_2_4_0_11_1 + 4.166666666666657e-03*G4_1_2_4_0_11_2 + 8.333333333333309e-03*G4_1_2_4_1_8_0 + 8.333333333333311e-03*G4_1_2_4_1_8_1 + 8.333333333333312e-03*G4_1_2_4_1_8_2 + 4.166666666666654e-03*G4_1_2_4_1_9_0 + 4.166666666666654e-03*G4_1_2_4_1_9_1 + 4.166666666666655e-03*G4_1_2_4_1_9_2 + 4.166666666666654e-03*G4_1_2_4_1_10_0 + 4.166666666666654e-03*G4_1_2_4_1_10_1 + 4.166666666666654e-03*G4_1_2_4_1_10_2 + 4.166666666666656e-03*G4_1_2_4_1_11_0 + 4.166666666666657e-03*G4_1_2_4_1_11_1 + 4.166666666666657e-03*G4_1_2_4_1_11_2 + 8.333333333333311e-03*G4_1_2_4_2_8_0 + 8.333333333333312e-03*G4_1_2_4_2_8_1 + 8.333333333333314e-03*G4_1_2_4_2_8_2 + 4.166666666666654e-03*G4_1_2_4_2_9_0 + 4.166666666666655e-03*G4_1_2_4_2_9_1 + 4.166666666666655e-03*G4_1_2_4_2_9_2 + 4.166666666666654e-03*G4_1_2_4_2_10_0 + 4.166666666666654e-03*G4_1_2_4_2_10_1 + 4.166666666666654e-03*G4_1_2_4_2_10_2 + 4.166666666666657e-03*G4_1_2_4_2_11_0 + 4.166666666666657e-03*G4_1_2_4_2_11_1 + 4.166666666666658e-03*G4_1_2_4_2_11_2 + 4.166666666666654e-03*G4_1_2_5_0_8_0 + 4.166666666666654e-03*G4_1_2_5_0_8_1 + 4.166666666666654e-03*G4_1_2_5_0_8_2 + 8.333333333333307e-03*G4_1_2_5_0_9_0 + 8.333333333333309e-03*G4_1_2_5_0_9_1 + 8.333333333333309e-03*G4_1_2_5_0_9_2 + 4.166666666666654e-03*G4_1_2_5_0_10_0 + 4.166666666666655e-03*G4_1_2_5_0_10_1 + 4.166666666666655e-03*G4_1_2_5_0_10_2 + 4.166666666666655e-03*G4_1_2_5_0_11_0 + 4.166666666666656e-03*G4_1_2_5_0_11_1 + 4.166666666666656e-03*G4_1_2_5_0_11_2 + 4.166666666666654e-03*G4_1_2_5_1_8_0 + 4.166666666666654e-03*G4_1_2_5_1_8_1 + 4.166666666666655e-03*G4_1_2_5_1_8_2 + 8.333333333333309e-03*G4_1_2_5_1_9_0 + 8.333333333333309e-03*G4_1_2_5_1_9_1 + 8.333333333333309e-03*G4_1_2_5_1_9_2 + 4.166666666666655e-03*G4_1_2_5_1_10_0 + 4.166666666666656e-03*G4_1_2_5_1_10_1 + 4.166666666666656e-03*G4_1_2_5_1_10_2 + 4.166666666666656e-03*G4_1_2_5_1_11_0 + 4.166666666666657e-03*G4_1_2_5_1_11_1 + 4.166666666666657e-03*G4_1_2_5_1_11_2 + 4.166666666666654e-03*G4_1_2_5_2_8_0 + 4.166666666666655e-03*G4_1_2_5_2_8_1 + 4.166666666666655e-03*G4_1_2_5_2_8_2 + 8.333333333333309e-03*G4_1_2_5_2_9_0 + 8.333333333333309e-03*G4_1_2_5_2_9_1 + 8.333333333333309e-03*G4_1_2_5_2_9_2 + 4.166666666666655e-03*G4_1_2_5_2_10_0 + 4.166666666666656e-03*G4_1_2_5_2_10_1 + 4.166666666666656e-03*G4_1_2_5_2_10_2 + 4.166666666666656e-03*G4_1_2_5_2_11_0 + 4.166666666666657e-03*G4_1_2_5_2_11_1 + 4.166666666666657e-03*G4_1_2_5_2_11_2 + 4.166666666666653e-03*G4_1_2_6_0_8_0 + 4.166666666666654e-03*G4_1_2_6_0_8_1 + 4.166666666666654e-03*G4_1_2_6_0_8_2 + 4.166666666666654e-03*G4_1_2_6_0_9_0 + 4.166666666666655e-03*G4_1_2_6_0_9_1 + 4.166666666666655e-03*G4_1_2_6_0_9_2 + 8.333333333333309e-03*G4_1_2_6_0_10_0 + 8.333333333333309e-03*G4_1_2_6_0_10_1 + 8.333333333333311e-03*G4_1_2_6_0_10_2 + 4.166666666666654e-03*G4_1_2_6_0_11_0 + 4.166666666666655e-03*G4_1_2_6_0_11_1 + 4.166666666666655e-03*G4_1_2_6_0_11_2 + 4.166666666666654e-03*G4_1_2_6_1_8_0 + 4.166666666666654e-03*G4_1_2_6_1_8_1 + 4.166666666666654e-03*G4_1_2_6_1_8_2 + 4.166666666666655e-03*G4_1_2_6_1_9_0 + 4.166666666666656e-03*G4_1_2_6_1_9_1 + 4.166666666666656e-03*G4_1_2_6_1_9_2 + 8.333333333333311e-03*G4_1_2_6_1_10_0 + 8.333333333333311e-03*G4_1_2_6_1_10_1 + 8.333333333333312e-03*G4_1_2_6_1_10_2 + 4.166666666666655e-03*G4_1_2_6_1_11_0 + 4.166666666666656e-03*G4_1_2_6_1_11_1 + 4.166666666666657e-03*G4_1_2_6_1_11_2 + 4.166666666666654e-03*G4_1_2_6_2_8_0 + 4.166666666666654e-03*G4_1_2_6_2_8_1 + 4.166666666666654e-03*G4_1_2_6_2_8_2 + 4.166666666666655e-03*G4_1_2_6_2_9_0 + 4.166666666666656e-03*G4_1_2_6_2_9_1 + 4.166666666666656e-03*G4_1_2_6_2_9_2 + 8.333333333333311e-03*G4_1_2_6_2_10_0 + 8.333333333333312e-03*G4_1_2_6_2_10_1 + 8.333333333333312e-03*G4_1_2_6_2_10_2 + 4.166666666666655e-03*G4_1_2_6_2_11_0 + 4.166666666666657e-03*G4_1_2_6_2_11_1 + 4.166666666666657e-03*G4_1_2_6_2_11_2 + 4.166666666666655e-03*G4_1_2_7_0_8_0 + 4.166666666666656e-03*G4_1_2_7_0_8_1 + 4.166666666666657e-03*G4_1_2_7_0_8_2 + 4.166666666666655e-03*G4_1_2_7_0_9_0 + 4.166666666666656e-03*G4_1_2_7_0_9_1 + 4.166666666666656e-03*G4_1_2_7_0_9_2 + 4.166666666666655e-03*G4_1_2_7_0_10_0 + 4.166666666666655e-03*G4_1_2_7_0_10_1 + 4.166666666666655e-03*G4_1_2_7_0_10_2 + 8.333333333333309e-03*G4_1_2_7_0_11_0 + 8.333333333333311e-03*G4_1_2_7_0_11_1 + 8.333333333333311e-03*G4_1_2_7_0_11_2 + 4.166666666666656e-03*G4_1_2_7_1_8_0 + 4.166666666666657e-03*G4_1_2_7_1_8_1 + 4.166666666666657e-03*G4_1_2_7_1_8_2 + 4.166666666666656e-03*G4_1_2_7_1_9_0 + 4.166666666666657e-03*G4_1_2_7_1_9_1 + 4.166666666666657e-03*G4_1_2_7_1_9_2 + 4.166666666666655e-03*G4_1_2_7_1_10_0 + 4.166666666666656e-03*G4_1_2_7_1_10_1 + 4.166666666666657e-03*G4_1_2_7_1_10_2 + 8.333333333333311e-03*G4_1_2_7_1_11_0 + 8.333333333333311e-03*G4_1_2_7_1_11_1 + 8.333333333333312e-03*G4_1_2_7_1_11_2 + 4.166666666666657e-03*G4_1_2_7_2_8_0 + 4.166666666666657e-03*G4_1_2_7_2_8_1 + 4.166666666666658e-03*G4_1_2_7_2_8_2 + 4.166666666666656e-03*G4_1_2_7_2_9_0 + 4.166666666666657e-03*G4_1_2_7_2_9_1 + 4.166666666666657e-03*G4_1_2_7_2_9_2 + 4.166666666666655e-03*G4_1_2_7_2_10_0 + 4.166666666666657e-03*G4_1_2_7_2_10_1 + 4.166666666666657e-03*G4_1_2_7_2_10_2 + 8.333333333333311e-03*G4_1_2_7_2_11_0 + 8.333333333333312e-03*G4_1_2_7_2_11_1 + 8.333333333333312e-03*G4_1_2_7_2_11_2 + 8.333333333333309e-03*G4_2_0_8_0_0_0 + 8.333333333333309e-03*G4_2_0_8_0_0_1 + 8.333333333333311e-03*G4_2_0_8_0_0_2 + 4.166666666666654e-03*G4_2_0_8_0_1_0 + 4.166666666666654e-03*G4_2_0_8_0_1_1 + 4.166666666666654e-03*G4_2_0_8_0_1_2 + 4.166666666666653e-03*G4_2_0_8_0_2_0 + 4.166666666666654e-03*G4_2_0_8_0_2_1 + 4.166666666666654e-03*G4_2_0_8_0_2_2 + 4.166666666666654e-03*G4_2_0_8_0_3_0 + 4.166666666666656e-03*G4_2_0_8_0_3_1 + 4.166666666666657e-03*G4_2_0_8_0_3_2 + 8.333333333333309e-03*G4_2_0_8_1_0_0 + 8.333333333333311e-03*G4_2_0_8_1_0_1 + 8.333333333333312e-03*G4_2_0_8_1_0_2 + 4.166666666666654e-03*G4_2_0_8_1_1_0 + 4.166666666666654e-03*G4_2_0_8_1_1_1 + 4.166666666666654e-03*G4_2_0_8_1_1_2 + 4.166666666666654e-03*G4_2_0_8_1_2_0 + 4.166666666666654e-03*G4_2_0_8_1_2_1 + 4.166666666666654e-03*G4_2_0_8_1_2_2 + 4.166666666666656e-03*G4_2_0_8_1_3_0 + 4.166666666666657e-03*G4_2_0_8_1_3_1 + 4.166666666666657e-03*G4_2_0_8_1_3_2 + 8.333333333333311e-03*G4_2_0_8_2_0_0 + 8.333333333333312e-03*G4_2_0_8_2_0_1 + 8.333333333333314e-03*G4_2_0_8_2_0_2 + 4.166666666666654e-03*G4_2_0_8_2_1_0 + 4.166666666666654e-03*G4_2_0_8_2_1_1 + 4.166666666666655e-03*G4_2_0_8_2_1_2 + 4.166666666666654e-03*G4_2_0_8_2_2_0 + 4.166666666666654e-03*G4_2_0_8_2_2_1 + 4.166666666666654e-03*G4_2_0_8_2_2_2 + 4.166666666666657e-03*G4_2_0_8_2_3_0 + 4.166666666666657e-03*G4_2_0_8_2_3_1 + 4.166666666666658e-03*G4_2_0_8_2_3_2 + 4.166666666666654e-03*G4_2_0_9_0_0_0 + 4.166666666666655e-03*G4_2_0_9_0_0_1 + 4.166666666666655e-03*G4_2_0_9_0_0_2 + 8.333333333333307e-03*G4_2_0_9_0_1_0 + 8.333333333333309e-03*G4_2_0_9_0_1_1 + 8.333333333333309e-03*G4_2_0_9_0_1_2 + 4.166666666666654e-03*G4_2_0_9_0_2_0 + 4.166666666666655e-03*G4_2_0_9_0_2_1 + 4.166666666666655e-03*G4_2_0_9_0_2_2 + 4.166666666666655e-03*G4_2_0_9_0_3_0 + 4.166666666666656e-03*G4_2_0_9_0_3_1 + 4.166666666666656e-03*G4_2_0_9_0_3_2 + 4.166666666666655e-03*G4_2_0_9_1_0_0 + 4.166666666666655e-03*G4_2_0_9_1_0_1 + 4.166666666666656e-03*G4_2_0_9_1_0_2 + 8.333333333333309e-03*G4_2_0_9_1_1_0 + 8.333333333333309e-03*G4_2_0_9_1_1_1 + 8.333333333333309e-03*G4_2_0_9_1_1_2 + 4.166666666666655e-03*G4_2_0_9_1_2_0 + 4.166666666666656e-03*G4_2_0_9_1_2_1 + 4.166666666666656e-03*G4_2_0_9_1_2_2 + 4.166666666666656e-03*G4_2_0_9_1_3_0 + 4.166666666666657e-03*G4_2_0_9_1_3_1 + 4.166666666666657e-03*G4_2_0_9_1_3_2 + 4.166666666666655e-03*G4_2_0_9_2_0_0 + 4.166666666666656e-03*G4_2_0_9_2_0_1 + 4.166666666666657e-03*G4_2_0_9_2_0_2 + 8.333333333333309e-03*G4_2_0_9_2_1_0 + 8.333333333333309e-03*G4_2_0_9_2_1_1 + 8.333333333333309e-03*G4_2_0_9_2_1_2 + 4.166666666666655e-03*G4_2_0_9_2_2_0 + 4.166666666666656e-03*G4_2_0_9_2_2_1 + 4.166666666666656e-03*G4_2_0_9_2_2_2 + 4.166666666666656e-03*G4_2_0_9_2_3_0 + 4.166666666666657e-03*G4_2_0_9_2_3_1 + 4.166666666666657e-03*G4_2_0_9_2_3_2 + 4.166666666666654e-03*G4_2_0_10_0_0_0 + 4.166666666666654e-03*G4_2_0_10_0_0_1 + 4.166666666666655e-03*G4_2_0_10_0_0_2 + 4.166666666666654e-03*G4_2_0_10_0_1_0 + 4.166666666666654e-03*G4_2_0_10_0_1_1 + 4.166666666666654e-03*G4_2_0_10_0_1_2 + 8.333333333333309e-03*G4_2_0_10_0_2_0 + 8.333333333333309e-03*G4_2_0_10_0_2_1 + 8.333333333333311e-03*G4_2_0_10_0_2_2 + 4.166666666666654e-03*G4_2_0_10_0_3_0 + 4.166666666666655e-03*G4_2_0_10_0_3_1 + 4.166666666666655e-03*G4_2_0_10_0_3_2 + 4.166666666666654e-03*G4_2_0_10_1_0_0 + 4.166666666666656e-03*G4_2_0_10_1_0_1 + 4.166666666666656e-03*G4_2_0_10_1_0_2 + 4.166666666666654e-03*G4_2_0_10_1_1_0 + 4.166666666666654e-03*G4_2_0_10_1_1_1 + 4.166666666666654e-03*G4_2_0_10_1_1_2 + 8.333333333333311e-03*G4_2_0_10_1_2_0 + 8.333333333333311e-03*G4_2_0_10_1_2_1 + 8.333333333333312e-03*G4_2_0_10_1_2_2 + 4.166666666666655e-03*G4_2_0_10_1_3_0 + 4.166666666666656e-03*G4_2_0_10_1_3_1 + 4.166666666666657e-03*G4_2_0_10_1_3_2 + 4.166666666666655e-03*G4_2_0_10_2_0_0 + 4.166666666666656e-03*G4_2_0_10_2_0_1 + 4.166666666666656e-03*G4_2_0_10_2_0_2 + 4.166666666666654e-03*G4_2_0_10_2_1_0 + 4.166666666666654e-03*G4_2_0_10_2_1_1 + 4.166666666666655e-03*G4_2_0_10_2_1_2 + 8.333333333333311e-03*G4_2_0_10_2_2_0 + 8.333333333333312e-03*G4_2_0_10_2_2_1 + 8.333333333333312e-03*G4_2_0_10_2_2_2 + 4.166666666666655e-03*G4_2_0_10_2_3_0 + 4.166666666666657e-03*G4_2_0_10_2_3_1 + 4.166666666666657e-03*G4_2_0_10_2_3_2 + 4.166666666666656e-03*G4_2_0_11_0_0_0 + 4.166666666666656e-03*G4_2_0_11_0_0_1 + 4.166666666666657e-03*G4_2_0_11_0_0_2 + 4.166666666666654e-03*G4_2_0_11_0_1_0 + 4.166666666666655e-03*G4_2_0_11_0_1_1 + 4.166666666666655e-03*G4_2_0_11_0_1_2 + 4.166666666666655e-03*G4_2_0_11_0_2_0 + 4.166666666666655e-03*G4_2_0_11_0_2_1 + 4.166666666666655e-03*G4_2_0_11_0_2_2 + 8.333333333333309e-03*G4_2_0_11_0_3_0 + 8.333333333333311e-03*G4_2_0_11_0_3_1 + 8.333333333333311e-03*G4_2_0_11_0_3_2 + 4.166666666666656e-03*G4_2_0_11_1_0_0 + 4.166666666666657e-03*G4_2_0_11_1_0_1 + 4.166666666666658e-03*G4_2_0_11_1_0_2 + 4.166666666666655e-03*G4_2_0_11_1_1_0 + 4.166666666666655e-03*G4_2_0_11_1_1_1 + 4.166666666666656e-03*G4_2_0_11_1_1_2 + 4.166666666666655e-03*G4_2_0_11_1_2_0 + 4.166666666666656e-03*G4_2_0_11_1_2_1 + 4.166666666666657e-03*G4_2_0_11_1_2_2 + 8.333333333333311e-03*G4_2_0_11_1_3_0 + 8.333333333333311e-03*G4_2_0_11_1_3_1 + 8.333333333333312e-03*G4_2_0_11_1_3_2 + 4.166666666666657e-03*G4_2_0_11_2_0_0 + 4.166666666666658e-03*G4_2_0_11_2_0_1 + 4.166666666666659e-03*G4_2_0_11_2_0_2 + 4.166666666666655e-03*G4_2_0_11_2_1_0 + 4.166666666666656e-03*G4_2_0_11_2_1_1 + 4.166666666666656e-03*G4_2_0_11_2_1_2 + 4.166666666666655e-03*G4_2_0_11_2_2_0 + 4.166666666666657e-03*G4_2_0_11_2_2_1 + 4.166666666666657e-03*G4_2_0_11_2_2_2 + 8.333333333333311e-03*G4_2_0_11_2_3_0 + 8.333333333333312e-03*G4_2_0_11_2_3_1 + 8.333333333333312e-03*G4_2_0_11_2_3_2 + 8.333333333333309e-03*G4_2_1_8_0_4_0 + 8.333333333333309e-03*G4_2_1_8_0_4_1 + 8.333333333333311e-03*G4_2_1_8_0_4_2 + 4.166666666666654e-03*G4_2_1_8_0_5_0 + 4.166666666666654e-03*G4_2_1_8_0_5_1 + 4.166666666666654e-03*G4_2_1_8_0_5_2 + 4.166666666666653e-03*G4_2_1_8_0_6_0 + 4.166666666666654e-03*G4_2_1_8_0_6_1 + 4.166666666666654e-03*G4_2_1_8_0_6_2 + 4.166666666666654e-03*G4_2_1_8_0_7_0 + 4.166666666666656e-03*G4_2_1_8_0_7_1 + 4.166666666666657e-03*G4_2_1_8_0_7_2 + 8.333333333333309e-03*G4_2_1_8_1_4_0 + 8.333333333333311e-03*G4_2_1_8_1_4_1 + 8.333333333333312e-03*G4_2_1_8_1_4_2 + 4.166666666666654e-03*G4_2_1_8_1_5_0 + 4.166666666666654e-03*G4_2_1_8_1_5_1 + 4.166666666666655e-03*G4_2_1_8_1_5_2 + 4.166666666666654e-03*G4_2_1_8_1_6_0 + 4.166666666666654e-03*G4_2_1_8_1_6_1 + 4.166666666666654e-03*G4_2_1_8_1_6_2 + 4.166666666666656e-03*G4_2_1_8_1_7_0 + 4.166666666666657e-03*G4_2_1_8_1_7_1 + 4.166666666666657e-03*G4_2_1_8_1_7_2 + 8.333333333333311e-03*G4_2_1_8_2_4_0 + 8.333333333333312e-03*G4_2_1_8_2_4_1 + 8.333333333333314e-03*G4_2_1_8_2_4_2 + 4.166666666666654e-03*G4_2_1_8_2_5_0 + 4.166666666666655e-03*G4_2_1_8_2_5_1 + 4.166666666666655e-03*G4_2_1_8_2_5_2 + 4.166666666666654e-03*G4_2_1_8_2_6_0 + 4.166666666666654e-03*G4_2_1_8_2_6_1 + 4.166666666666654e-03*G4_2_1_8_2_6_2 + 4.166666666666657e-03*G4_2_1_8_2_7_0 + 4.166666666666657e-03*G4_2_1_8_2_7_1 + 4.166666666666658e-03*G4_2_1_8_2_7_2 + 4.166666666666654e-03*G4_2_1_9_0_4_0 + 4.166666666666654e-03*G4_2_1_9_0_4_1 + 4.166666666666654e-03*G4_2_1_9_0_4_2 + 8.333333333333307e-03*G4_2_1_9_0_5_0 + 8.333333333333309e-03*G4_2_1_9_0_5_1 + 8.333333333333309e-03*G4_2_1_9_0_5_2 + 4.166666666666654e-03*G4_2_1_9_0_6_0 + 4.166666666666655e-03*G4_2_1_9_0_6_1 + 4.166666666666655e-03*G4_2_1_9_0_6_2 + 4.166666666666655e-03*G4_2_1_9_0_7_0 + 4.166666666666656e-03*G4_2_1_9_0_7_1 + 4.166666666666656e-03*G4_2_1_9_0_7_2 + 4.166666666666654e-03*G4_2_1_9_1_4_0 + 4.166666666666654e-03*G4_2_1_9_1_4_1 + 4.166666666666655e-03*G4_2_1_9_1_4_2 + 8.333333333333309e-03*G4_2_1_9_1_5_0 + 8.333333333333309e-03*G4_2_1_9_1_5_1 + 8.333333333333309e-03*G4_2_1_9_1_5_2 + 4.166666666666655e-03*G4_2_1_9_1_6_0 + 4.166666666666656e-03*G4_2_1_9_1_6_1 + 4.166666666666656e-03*G4_2_1_9_1_6_2 + 4.166666666666656e-03*G4_2_1_9_1_7_0 + 4.166666666666657e-03*G4_2_1_9_1_7_1 + 4.166666666666657e-03*G4_2_1_9_1_7_2 + 4.166666666666654e-03*G4_2_1_9_2_4_0 + 4.166666666666655e-03*G4_2_1_9_2_4_1 + 4.166666666666655e-03*G4_2_1_9_2_4_2 + 8.333333333333309e-03*G4_2_1_9_2_5_0 + 8.333333333333309e-03*G4_2_1_9_2_5_1 + 8.333333333333309e-03*G4_2_1_9_2_5_2 + 4.166666666666655e-03*G4_2_1_9_2_6_0 + 4.166666666666656e-03*G4_2_1_9_2_6_1 + 4.166666666666656e-03*G4_2_1_9_2_6_2 + 4.166666666666656e-03*G4_2_1_9_2_7_0 + 4.166666666666657e-03*G4_2_1_9_2_7_1 + 4.166666666666657e-03*G4_2_1_9_2_7_2 + 4.166666666666653e-03*G4_2_1_10_0_4_0 + 4.166666666666654e-03*G4_2_1_10_0_4_1 + 4.166666666666654e-03*G4_2_1_10_0_4_2 + 4.166666666666654e-03*G4_2_1_10_0_5_0 + 4.166666666666655e-03*G4_2_1_10_0_5_1 + 4.166666666666655e-03*G4_2_1_10_0_5_2 + 8.333333333333309e-03*G4_2_1_10_0_6_0 + 8.333333333333309e-03*G4_2_1_10_0_6_1 + 8.333333333333311e-03*G4_2_1_10_0_6_2 + 4.166666666666654e-03*G4_2_1_10_0_7_0 + 4.166666666666655e-03*G4_2_1_10_0_7_1 + 4.166666666666655e-03*G4_2_1_10_0_7_2 + 4.166666666666654e-03*G4_2_1_10_1_4_0 + 4.166666666666654e-03*G4_2_1_10_1_4_1 + 4.166666666666654e-03*G4_2_1_10_1_4_2 + 4.166666666666655e-03*G4_2_1_10_1_5_0 + 4.166666666666656e-03*G4_2_1_10_1_5_1 + 4.166666666666656e-03*G4_2_1_10_1_5_2 + 8.333333333333311e-03*G4_2_1_10_1_6_0 + 8.333333333333311e-03*G4_2_1_10_1_6_1 + 8.333333333333312e-03*G4_2_1_10_1_6_2 + 4.166666666666655e-03*G4_2_1_10_1_7_0 + 4.166666666666656e-03*G4_2_1_10_1_7_1 + 4.166666666666657e-03*G4_2_1_10_1_7_2 + 4.166666666666654e-03*G4_2_1_10_2_4_0 + 4.166666666666654e-03*G4_2_1_10_2_4_1 + 4.166666666666654e-03*G4_2_1_10_2_4_2 + 4.166666666666655e-03*G4_2_1_10_2_5_0 + 4.166666666666656e-03*G4_2_1_10_2_5_1 + 4.166666666666656e-03*G4_2_1_10_2_5_2 + 8.333333333333311e-03*G4_2_1_10_2_6_0 + 8.333333333333312e-03*G4_2_1_10_2_6_1 + 8.333333333333312e-03*G4_2_1_10_2_6_2 + 4.166666666666655e-03*G4_2_1_10_2_7_0 + 4.166666666666657e-03*G4_2_1_10_2_7_1 + 4.166666666666657e-03*G4_2_1_10_2_7_2 + 4.166666666666655e-03*G4_2_1_11_0_4_0 + 4.166666666666656e-03*G4_2_1_11_0_4_1 + 4.166666666666657e-03*G4_2_1_11_0_4_2 + 4.166666666666655e-03*G4_2_1_11_0_5_0 + 4.166666666666656e-03*G4_2_1_11_0_5_1 + 4.166666666666656e-03*G4_2_1_11_0_5_2 + 4.166666666666655e-03*G4_2_1_11_0_6_0 + 4.166666666666655e-03*G4_2_1_11_0_6_1 + 4.166666666666655e-03*G4_2_1_11_0_6_2 + 8.333333333333309e-03*G4_2_1_11_0_7_0 + 8.333333333333311e-03*G4_2_1_11_0_7_1 + 8.333333333333311e-03*G4_2_1_11_0_7_2 + 4.166666666666656e-03*G4_2_1_11_1_4_0 + 4.166666666666657e-03*G4_2_1_11_1_4_1 + 4.166666666666657e-03*G4_2_1_11_1_4_2 + 4.166666666666656e-03*G4_2_1_11_1_5_0 + 4.166666666666657e-03*G4_2_1_11_1_5_1 + 4.166666666666657e-03*G4_2_1_11_1_5_2 + 4.166666666666655e-03*G4_2_1_11_1_6_0 + 4.166666666666656e-03*G4_2_1_11_1_6_1 + 4.166666666666657e-03*G4_2_1_11_1_6_2 + 8.333333333333311e-03*G4_2_1_11_1_7_0 + 8.333333333333311e-03*G4_2_1_11_1_7_1 + 8.333333333333312e-03*G4_2_1_11_1_7_2 + 4.166666666666657e-03*G4_2_1_11_2_4_0 + 4.166666666666657e-03*G4_2_1_11_2_4_1 + 4.166666666666658e-03*G4_2_1_11_2_4_2 + 4.166666666666656e-03*G4_2_1_11_2_5_0 + 4.166666666666657e-03*G4_2_1_11_2_5_1 + 4.166666666666657e-03*G4_2_1_11_2_5_2 + 4.166666666666655e-03*G4_2_1_11_2_6_0 + 4.166666666666657e-03*G4_2_1_11_2_6_1 + 4.166666666666657e-03*G4_2_1_11_2_6_2 + 8.333333333333311e-03*G4_2_1_11_2_7_0 + 8.333333333333312e-03*G4_2_1_11_2_7_1 + 8.333333333333312e-03*G4_2_1_11_2_7_2 + 8.333333333333309e-03*G4_2_2_8_0_8_0 + 8.333333333333309e-03*G4_2_2_8_0_8_1 + 8.333333333333311e-03*G4_2_2_8_0_8_2 + 4.166666666666654e-03*G4_2_2_8_0_9_0 + 4.166666666666654e-03*G4_2_2_8_0_9_1 + 4.166666666666654e-03*G4_2_2_8_0_9_2 + 4.166666666666653e-03*G4_2_2_8_0_10_0 + 4.166666666666654e-03*G4_2_2_8_0_10_1 + 4.166666666666654e-03*G4_2_2_8_0_10_2 + 4.166666666666654e-03*G4_2_2_8_0_11_0 + 4.166666666666656e-03*G4_2_2_8_0_11_1 + 4.166666666666657e-03*G4_2_2_8_0_11_2 + 8.333333333333309e-03*G4_2_2_8_1_8_0 + 8.333333333333311e-03*G4_2_2_8_1_8_1 + 8.333333333333312e-03*G4_2_2_8_1_8_2 + 4.166666666666654e-03*G4_2_2_8_1_9_0 + 4.166666666666654e-03*G4_2_2_8_1_9_1 + 4.166666666666655e-03*G4_2_2_8_1_9_2 + 4.166666666666654e-03*G4_2_2_8_1_10_0 + 4.166666666666654e-03*G4_2_2_8_1_10_1 + 4.166666666666654e-03*G4_2_2_8_1_10_2 + 4.166666666666656e-03*G4_2_2_8_1_11_0 + 4.166666666666657e-03*G4_2_2_8_1_11_1 + 4.166666666666657e-03*G4_2_2_8_1_11_2 + 8.333333333333311e-03*G4_2_2_8_2_8_0 + 8.333333333333312e-03*G4_2_2_8_2_8_1 + 8.333333333333314e-03*G4_2_2_8_2_8_2 + 4.166666666666654e-03*G4_2_2_8_2_9_0 + 4.166666666666655e-03*G4_2_2_8_2_9_1 + 4.166666666666655e-03*G4_2_2_8_2_9_2 + 4.166666666666654e-03*G4_2_2_8_2_10_0 + 4.166666666666654e-03*G4_2_2_8_2_10_1 + 4.166666666666654e-03*G4_2_2_8_2_10_2 + 4.166666666666657e-03*G4_2_2_8_2_11_0 + 4.166666666666657e-03*G4_2_2_8_2_11_1 + 4.166666666666658e-03*G4_2_2_8_2_11_2 + 4.166666666666654e-03*G4_2_2_9_0_8_0 + 4.166666666666654e-03*G4_2_2_9_0_8_1 + 4.166666666666654e-03*G4_2_2_9_0_8_2 + 8.333333333333307e-03*G4_2_2_9_0_9_0 + 8.333333333333309e-03*G4_2_2_9_0_9_1 + 8.333333333333309e-03*G4_2_2_9_0_9_2 + 4.166666666666654e-03*G4_2_2_9_0_10_0 + 4.166666666666655e-03*G4_2_2_9_0_10_1 + 4.166666666666655e-03*G4_2_2_9_0_10_2 + 4.166666666666655e-03*G4_2_2_9_0_11_0 + 4.166666666666656e-03*G4_2_2_9_0_11_1 + 4.166666666666656e-03*G4_2_2_9_0_11_2 + 4.166666666666654e-03*G4_2_2_9_1_8_0 + 4.166666666666654e-03*G4_2_2_9_1_8_1 + 4.166666666666655e-03*G4_2_2_9_1_8_2 + 8.333333333333309e-03*G4_2_2_9_1_9_0 + 8.333333333333309e-03*G4_2_2_9_1_9_1 + 8.333333333333309e-03*G4_2_2_9_1_9_2 + 4.166666666666655e-03*G4_2_2_9_1_10_0 + 4.166666666666656e-03*G4_2_2_9_1_10_1 + 4.166666666666656e-03*G4_2_2_9_1_10_2 + 4.166666666666656e-03*G4_2_2_9_1_11_0 + 4.166666666666657e-03*G4_2_2_9_1_11_1 + 4.166666666666657e-03*G4_2_2_9_1_11_2 + 4.166666666666654e-03*G4_2_2_9_2_8_0 + 4.166666666666655e-03*G4_2_2_9_2_8_1 + 4.166666666666655e-03*G4_2_2_9_2_8_2 + 8.333333333333309e-03*G4_2_2_9_2_9_0 + 8.333333333333309e-03*G4_2_2_9_2_9_1 + 8.333333333333309e-03*G4_2_2_9_2_9_2 + 4.166666666666655e-03*G4_2_2_9_2_10_0 + 4.166666666666656e-03*G4_2_2_9_2_10_1 + 4.166666666666656e-03*G4_2_2_9_2_10_2 + 4.166666666666656e-03*G4_2_2_9_2_11_0 + 4.166666666666657e-03*G4_2_2_9_2_11_1 + 4.166666666666657e-03*G4_2_2_9_2_11_2 + 4.166666666666653e-03*G4_2_2_10_0_8_0 + 4.166666666666654e-03*G4_2_2_10_0_8_1 + 4.166666666666654e-03*G4_2_2_10_0_8_2 + 4.166666666666654e-03*G4_2_2_10_0_9_0 + 4.166666666666655e-03*G4_2_2_10_0_9_1 + 4.166666666666655e-03*G4_2_2_10_0_9_2 + 8.333333333333309e-03*G4_2_2_10_0_10_0 + 8.333333333333309e-03*G4_2_2_10_0_10_1 + 8.333333333333311e-03*G4_2_2_10_0_10_2 + 4.166666666666654e-03*G4_2_2_10_0_11_0 + 4.166666666666655e-03*G4_2_2_10_0_11_1 + 4.166666666666655e-03*G4_2_2_10_0_11_2 + 4.166666666666654e-03*G4_2_2_10_1_8_0 + 4.166666666666654e-03*G4_2_2_10_1_8_1 + 4.166666666666654e-03*G4_2_2_10_1_8_2 + 4.166666666666655e-03*G4_2_2_10_1_9_0 + 4.166666666666656e-03*G4_2_2_10_1_9_1 + 4.166666666666656e-03*G4_2_2_10_1_9_2 + 8.333333333333311e-03*G4_2_2_10_1_10_0 + 8.333333333333311e-03*G4_2_2_10_1_10_1 + 8.333333333333312e-03*G4_2_2_10_1_10_2 + 4.166666666666655e-03*G4_2_2_10_1_11_0 + 4.166666666666656e-03*G4_2_2_10_1_11_1 + 4.166666666666657e-03*G4_2_2_10_1_11_2 + 4.166666666666654e-03*G4_2_2_10_2_8_0 + 4.166666666666654e-03*G4_2_2_10_2_8_1 + 4.166666666666654e-03*G4_2_2_10_2_8_2 + 4.166666666666655e-03*G4_2_2_10_2_9_0 + 4.166666666666656e-03*G4_2_2_10_2_9_1 + 4.166666666666656e-03*G4_2_2_10_2_9_2 + 8.333333333333311e-03*G4_2_2_10_2_10_0 + 8.333333333333312e-03*G4_2_2_10_2_10_1 + 8.333333333333312e-03*G4_2_2_10_2_10_2 + 4.166666666666655e-03*G4_2_2_10_2_11_0 + 4.166666666666657e-03*G4_2_2_10_2_11_1 + 4.166666666666657e-03*G4_2_2_10_2_11_2 + 4.166666666666655e-03*G4_2_2_11_0_8_0 + 4.166666666666656e-03*G4_2_2_11_0_8_1 + 4.166666666666657e-03*G4_2_2_11_0_8_2 + 4.166666666666655e-03*G4_2_2_11_0_9_0 + 4.166666666666656e-03*G4_2_2_11_0_9_1 + 4.166666666666656e-03*G4_2_2_11_0_9_2 + 4.166666666666655e-03*G4_2_2_11_0_10_0 + 4.166666666666655e-03*G4_2_2_11_0_10_1 + 4.166666666666655e-03*G4_2_2_11_0_10_2 + 8.333333333333309e-03*G4_2_2_11_0_11_0 + 8.333333333333311e-03*G4_2_2_11_0_11_1 + 8.333333333333311e-03*G4_2_2_11_0_11_2 + 4.166666666666656e-03*G4_2_2_11_1_8_0 + 4.166666666666657e-03*G4_2_2_11_1_8_1 + 4.166666666666657e-03*G4_2_2_11_1_8_2 + 4.166666666666656e-03*G4_2_2_11_1_9_0 + 4.166666666666657e-03*G4_2_2_11_1_9_1 + 4.166666666666657e-03*G4_2_2_11_1_9_2 + 4.166666666666655e-03*G4_2_2_11_1_10_0 + 4.166666666666656e-03*G4_2_2_11_1_10_1 + 4.166666666666657e-03*G4_2_2_11_1_10_2 + 8.333333333333311e-03*G4_2_2_11_1_11_0 + 8.333333333333311e-03*G4_2_2_11_1_11_1 + 8.333333333333312e-03*G4_2_2_11_1_11_2 + 4.166666666666657e-03*G4_2_2_11_2_8_0 + 4.166666666666657e-03*G4_2_2_11_2_8_1 + 4.166666666666658e-03*G4_2_2_11_2_8_2 + 4.166666666666656e-03*G4_2_2_11_2_9_0 + 4.166666666666657e-03*G4_2_2_11_2_9_1 + 4.166666666666657e-03*G4_2_2_11_2_9_2 + 4.166666666666655e-03*G4_2_2_11_2_10_0 + 4.166666666666657e-03*G4_2_2_11_2_10_1 + 4.166666666666657e-03*G4_2_2_11_2_10_2 + 8.333333333333311e-03*G4_2_2_11_2_11_0 + 8.333333333333312e-03*G4_2_2_11_2_11_1 + 8.333333333333312e-03*G4_2_2_11_2_11_2;
    block[53] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_1_0 - 8.333333333333322e-02*G1_2_0 + 8.333333333333309e-03*G2_0_0_0 + 4.166666666666654e-03*G2_0_1_0 + 4.166666666666654e-03*G2_0_2_0 + 4.166666666666656e-03*G2_0_3_0 + 8.333333333333309e-03*G2_1_4_0 + 4.166666666666654e-03*G2_1_5_0 + 4.166666666666654e-03*G2_1_6_0 + 4.166666666666656e-03*G2_1_7_0 + 8.333333333333309e-03*G2_2_8_0 + 4.166666666666654e-03*G2_2_9_0 + 4.166666666666654e-03*G2_2_10_0 + 4.166666666666656e-03*G2_2_11_0 - 8.333333333333320e-02*G3_1_1_0_0 - 8.333333333333322e-02*G3_1_1_1_0 - 8.333333333333322e-02*G3_1_1_2_0 - 8.333333333333309e-03*G4_0_0_0_0_0_0 - 4.166666666666654e-03*G4_0_0_0_0_1_0 - 4.166666666666654e-03*G4_0_0_0_0_2_0 - 4.166666666666656e-03*G4_0_0_0_0_3_0 - 8.333333333333309e-03*G4_0_0_0_1_0_0 - 4.166666666666654e-03*G4_0_0_0_1_1_0 - 4.166666666666654e-03*G4_0_0_0_1_2_0 - 4.166666666666656e-03*G4_0_0_0_1_3_0 - 8.333333333333311e-03*G4_0_0_0_2_0_0 - 4.166666666666654e-03*G4_0_0_0_2_1_0 - 4.166666666666655e-03*G4_0_0_0_2_2_0 - 4.166666666666657e-03*G4_0_0_0_2_3_0 - 4.166666666666654e-03*G4_0_0_1_0_0_0 - 8.333333333333307e-03*G4_0_0_1_0_1_0 - 4.166666666666654e-03*G4_0_0_1_0_2_0 - 4.166666666666654e-03*G4_0_0_1_0_3_0 - 4.166666666666654e-03*G4_0_0_1_1_0_0 - 8.333333333333307e-03*G4_0_0_1_1_1_0 - 4.166666666666654e-03*G4_0_0_1_1_2_0 - 4.166666666666655e-03*G4_0_0_1_1_3_0 - 4.166666666666654e-03*G4_0_0_1_2_0_0 - 8.333333333333307e-03*G4_0_0_1_2_1_0 - 4.166666666666654e-03*G4_0_0_1_2_2_0 - 4.166666666666655e-03*G4_0_0_1_2_3_0 - 4.166666666666654e-03*G4_0_0_2_0_0_0 - 4.166666666666654e-03*G4_0_0_2_0_1_0 - 8.333333333333309e-03*G4_0_0_2_0_2_0 - 4.166666666666654e-03*G4_0_0_2_0_3_0 - 4.166666666666654e-03*G4_0_0_2_1_0_0 - 4.166666666666654e-03*G4_0_0_2_1_1_0 - 8.333333333333311e-03*G4_0_0_2_1_2_0 - 4.166666666666655e-03*G4_0_0_2_1_3_0 - 4.166666666666655e-03*G4_0_0_2_2_0_0 - 4.166666666666654e-03*G4_0_0_2_2_1_0 - 8.333333333333311e-03*G4_0_0_2_2_2_0 - 4.166666666666655e-03*G4_0_0_2_2_3_0 - 4.166666666666656e-03*G4_0_0_3_0_0_0 - 4.166666666666654e-03*G4_0_0_3_0_1_0 - 4.166666666666655e-03*G4_0_0_3_0_2_0 - 8.333333333333309e-03*G4_0_0_3_0_3_0 - 4.166666666666656e-03*G4_0_0_3_1_0_0 - 4.166666666666655e-03*G4_0_0_3_1_1_0 - 4.166666666666655e-03*G4_0_0_3_1_2_0 - 8.333333333333311e-03*G4_0_0_3_1_3_0 - 4.166666666666657e-03*G4_0_0_3_2_0_0 - 4.166666666666655e-03*G4_0_0_3_2_1_0 - 4.166666666666655e-03*G4_0_0_3_2_2_0 - 8.333333333333311e-03*G4_0_0_3_2_3_0 - 8.333333333333309e-03*G4_0_1_0_0_4_0 - 4.166666666666654e-03*G4_0_1_0_0_5_0 - 4.166666666666654e-03*G4_0_1_0_0_6_0 - 4.166666666666656e-03*G4_0_1_0_0_7_0 - 8.333333333333309e-03*G4_0_1_0_1_4_0 - 4.166666666666655e-03*G4_0_1_0_1_5_0 - 4.166666666666654e-03*G4_0_1_0_1_6_0 - 4.166666666666656e-03*G4_0_1_0_1_7_0 - 8.333333333333311e-03*G4_0_1_0_2_4_0 - 4.166666666666655e-03*G4_0_1_0_2_5_0 - 4.166666666666655e-03*G4_0_1_0_2_6_0 - 4.166666666666657e-03*G4_0_1_0_2_7_0 - 4.166666666666654e-03*G4_0_1_1_0_4_0 - 8.333333333333307e-03*G4_0_1_1_0_5_0 - 4.166666666666654e-03*G4_0_1_1_0_6_0 - 4.166666666666654e-03*G4_0_1_1_0_7_0 - 4.166666666666654e-03*G4_0_1_1_1_4_0 - 8.333333333333309e-03*G4_0_1_1_1_5_0 - 4.166666666666654e-03*G4_0_1_1_1_6_0 - 4.166666666666655e-03*G4_0_1_1_1_7_0 - 4.166666666666654e-03*G4_0_1_1_2_4_0 - 8.333333333333309e-03*G4_0_1_1_2_5_0 - 4.166666666666654e-03*G4_0_1_1_2_6_0 - 4.166666666666655e-03*G4_0_1_1_2_7_0 - 4.166666666666653e-03*G4_0_1_2_0_4_0 - 4.166666666666654e-03*G4_0_1_2_0_5_0 - 8.333333333333309e-03*G4_0_1_2_0_6_0 - 4.166666666666654e-03*G4_0_1_2_0_7_0 - 4.166666666666654e-03*G4_0_1_2_1_4_0 - 4.166666666666655e-03*G4_0_1_2_1_5_0 - 8.333333333333311e-03*G4_0_1_2_1_6_0 - 4.166666666666655e-03*G4_0_1_2_1_7_0 - 4.166666666666654e-03*G4_0_1_2_2_4_0 - 4.166666666666655e-03*G4_0_1_2_2_5_0 - 8.333333333333311e-03*G4_0_1_2_2_6_0 - 4.166666666666655e-03*G4_0_1_2_2_7_0 - 4.166666666666655e-03*G4_0_1_3_0_4_0 - 4.166666666666655e-03*G4_0_1_3_0_5_0 - 4.166666666666655e-03*G4_0_1_3_0_6_0 - 8.333333333333309e-03*G4_0_1_3_0_7_0 - 4.166666666666656e-03*G4_0_1_3_1_4_0 - 4.166666666666656e-03*G4_0_1_3_1_5_0 - 4.166666666666655e-03*G4_0_1_3_1_6_0 - 8.333333333333311e-03*G4_0_1_3_1_7_0 - 4.166666666666657e-03*G4_0_1_3_2_4_0 - 4.166666666666656e-03*G4_0_1_3_2_5_0 - 4.166666666666655e-03*G4_0_1_3_2_6_0 - 8.333333333333311e-03*G4_0_1_3_2_7_0 - 8.333333333333309e-03*G4_0_2_0_0_8_0 - 4.166666666666654e-03*G4_0_2_0_0_9_0 - 4.166666666666654e-03*G4_0_2_0_0_10_0 - 4.166666666666656e-03*G4_0_2_0_0_11_0 - 8.333333333333309e-03*G4_0_2_0_1_8_0 - 4.166666666666655e-03*G4_0_2_0_1_9_0 - 4.166666666666654e-03*G4_0_2_0_1_10_0 - 4.166666666666656e-03*G4_0_2_0_1_11_0 - 8.333333333333311e-03*G4_0_2_0_2_8_0 - 4.166666666666655e-03*G4_0_2_0_2_9_0 - 4.166666666666655e-03*G4_0_2_0_2_10_0 - 4.166666666666657e-03*G4_0_2_0_2_11_0 - 4.166666666666654e-03*G4_0_2_1_0_8_0 - 8.333333333333307e-03*G4_0_2_1_0_9_0 - 4.166666666666654e-03*G4_0_2_1_0_10_0 - 4.166666666666654e-03*G4_0_2_1_0_11_0 - 4.166666666666654e-03*G4_0_2_1_1_8_0 - 8.333333333333309e-03*G4_0_2_1_1_9_0 - 4.166666666666654e-03*G4_0_2_1_1_10_0 - 4.166666666666655e-03*G4_0_2_1_1_11_0 - 4.166666666666654e-03*G4_0_2_1_2_8_0 - 8.333333333333309e-03*G4_0_2_1_2_9_0 - 4.166666666666654e-03*G4_0_2_1_2_10_0 - 4.166666666666655e-03*G4_0_2_1_2_11_0 - 4.166666666666653e-03*G4_0_2_2_0_8_0 - 4.166666666666654e-03*G4_0_2_2_0_9_0 - 8.333333333333309e-03*G4_0_2_2_0_10_0 - 4.166666666666654e-03*G4_0_2_2_0_11_0 - 4.166666666666654e-03*G4_0_2_2_1_8_0 - 4.166666666666655e-03*G4_0_2_2_1_9_0 - 8.333333333333311e-03*G4_0_2_2_1_10_0 - 4.166666666666655e-03*G4_0_2_2_1_11_0 - 4.166666666666654e-03*G4_0_2_2_2_8_0 - 4.166666666666655e-03*G4_0_2_2_2_9_0 - 8.333333333333311e-03*G4_0_2_2_2_10_0 - 4.166666666666655e-03*G4_0_2_2_2_11_0 - 4.166666666666655e-03*G4_0_2_3_0_8_0 - 4.166666666666655e-03*G4_0_2_3_0_9_0 - 4.166666666666655e-03*G4_0_2_3_0_10_0 - 8.333333333333309e-03*G4_0_2_3_0_11_0 - 4.166666666666656e-03*G4_0_2_3_1_8_0 - 4.166666666666656e-03*G4_0_2_3_1_9_0 - 4.166666666666655e-03*G4_0_2_3_1_10_0 - 8.333333333333311e-03*G4_0_2_3_1_11_0 - 4.166666666666657e-03*G4_0_2_3_2_8_0 - 4.166666666666656e-03*G4_0_2_3_2_9_0 - 4.166666666666655e-03*G4_0_2_3_2_10_0 - 8.333333333333311e-03*G4_0_2_3_2_11_0 - 8.333333333333309e-03*G4_1_0_4_0_0_0 - 4.166666666666654e-03*G4_1_0_4_0_1_0 - 4.166666666666653e-03*G4_1_0_4_0_2_0 - 4.166666666666654e-03*G4_1_0_4_0_3_0 - 8.333333333333309e-03*G4_1_0_4_1_0_0 - 4.166666666666654e-03*G4_1_0_4_1_1_0 - 4.166666666666654e-03*G4_1_0_4_1_2_0 - 4.166666666666656e-03*G4_1_0_4_1_3_0 - 8.333333333333311e-03*G4_1_0_4_2_0_0 - 4.166666666666654e-03*G4_1_0_4_2_1_0 - 4.166666666666654e-03*G4_1_0_4_2_2_0 - 4.166666666666657e-03*G4_1_0_4_2_3_0 - 4.166666666666654e-03*G4_1_0_5_0_0_0 - 8.333333333333307e-03*G4_1_0_5_0_1_0 - 4.166666666666654e-03*G4_1_0_5_0_2_0 - 4.166666666666655e-03*G4_1_0_5_0_3_0 - 4.166666666666655e-03*G4_1_0_5_1_0_0 - 8.333333333333309e-03*G4_1_0_5_1_1_0 - 4.166666666666655e-03*G4_1_0_5_1_2_0 - 4.166666666666656e-03*G4_1_0_5_1_3_0 - 4.166666666666655e-03*G4_1_0_5_2_0_0 - 8.333333333333309e-03*G4_1_0_5_2_1_0 - 4.166666666666655e-03*G4_1_0_5_2_2_0 - 4.166666666666656e-03*G4_1_0_5_2_3_0 - 4.166666666666654e-03*G4_1_0_6_0_0_0 - 4.166666666666654e-03*G4_1_0_6_0_1_0 - 8.333333333333309e-03*G4_1_0_6_0_2_0 - 4.166666666666654e-03*G4_1_0_6_0_3_0 - 4.166666666666654e-03*G4_1_0_6_1_0_0 - 4.166666666666654e-03*G4_1_0_6_1_1_0 - 8.333333333333311e-03*G4_1_0_6_1_2_0 - 4.166666666666655e-03*G4_1_0_6_1_3_0 - 4.166666666666655e-03*G4_1_0_6_2_0_0 - 4.166666666666654e-03*G4_1_0_6_2_1_0 - 8.333333333333311e-03*G4_1_0_6_2_2_0 - 4.166666666666655e-03*G4_1_0_6_2_3_0 - 4.166666666666656e-03*G4_1_0_7_0_0_0 - 4.166666666666654e-03*G4_1_0_7_0_1_0 - 4.166666666666655e-03*G4_1_0_7_0_2_0 - 8.333333333333309e-03*G4_1_0_7_0_3_0 - 4.166666666666656e-03*G4_1_0_7_1_0_0 - 4.166666666666655e-03*G4_1_0_7_1_1_0 - 4.166666666666655e-03*G4_1_0_7_1_2_0 - 8.333333333333311e-03*G4_1_0_7_1_3_0 - 4.166666666666657e-03*G4_1_0_7_2_0_0 - 4.166666666666655e-03*G4_1_0_7_2_1_0 - 4.166666666666655e-03*G4_1_0_7_2_2_0 - 8.333333333333311e-03*G4_1_0_7_2_3_0 - 8.333333333333309e-03*G4_1_1_4_0_4_0 - 4.166666666666654e-03*G4_1_1_4_0_5_0 - 4.166666666666653e-03*G4_1_1_4_0_6_0 - 4.166666666666654e-03*G4_1_1_4_0_7_0 - 8.333333333333309e-03*G4_1_1_4_1_4_0 - 4.166666666666654e-03*G4_1_1_4_1_5_0 - 4.166666666666654e-03*G4_1_1_4_1_6_0 - 4.166666666666656e-03*G4_1_1_4_1_7_0 - 8.333333333333311e-03*G4_1_1_4_2_4_0 - 4.166666666666654e-03*G4_1_1_4_2_5_0 - 4.166666666666654e-03*G4_1_1_4_2_6_0 - 4.166666666666657e-03*G4_1_1_4_2_7_0 - 4.166666666666654e-03*G4_1_1_5_0_4_0 - 8.333333333333307e-03*G4_1_1_5_0_5_0 - 4.166666666666654e-03*G4_1_1_5_0_6_0 - 4.166666666666655e-03*G4_1_1_5_0_7_0 - 4.166666666666654e-03*G4_1_1_5_1_4_0 - 8.333333333333309e-03*G4_1_1_5_1_5_0 - 4.166666666666655e-03*G4_1_1_5_1_6_0 - 4.166666666666656e-03*G4_1_1_5_1_7_0 - 4.166666666666654e-03*G4_1_1_5_2_4_0 - 8.333333333333309e-03*G4_1_1_5_2_5_0 - 4.166666666666655e-03*G4_1_1_5_2_6_0 - 4.166666666666656e-03*G4_1_1_5_2_7_0 - 4.166666666666653e-03*G4_1_1_6_0_4_0 - 4.166666666666654e-03*G4_1_1_6_0_5_0 - 8.333333333333309e-03*G4_1_1_6_0_6_0 - 4.166666666666654e-03*G4_1_1_6_0_7_0 - 4.166666666666654e-03*G4_1_1_6_1_4_0 - 4.166666666666655e-03*G4_1_1_6_1_5_0 - 8.333333333333311e-03*G4_1_1_6_1_6_0 - 4.166666666666655e-03*G4_1_1_6_1_7_0 - 4.166666666666654e-03*G4_1_1_6_2_4_0 - 4.166666666666655e-03*G4_1_1_6_2_5_0 - 8.333333333333311e-03*G4_1_1_6_2_6_0 - 4.166666666666655e-03*G4_1_1_6_2_7_0 - 4.166666666666655e-03*G4_1_1_7_0_4_0 - 4.166666666666655e-03*G4_1_1_7_0_5_0 - 4.166666666666655e-03*G4_1_1_7_0_6_0 - 8.333333333333309e-03*G4_1_1_7_0_7_0 - 4.166666666666656e-03*G4_1_1_7_1_4_0 - 4.166666666666656e-03*G4_1_1_7_1_5_0 - 4.166666666666655e-03*G4_1_1_7_1_6_0 - 8.333333333333311e-03*G4_1_1_7_1_7_0 - 4.166666666666657e-03*G4_1_1_7_2_4_0 - 4.166666666666656e-03*G4_1_1_7_2_5_0 - 4.166666666666655e-03*G4_1_1_7_2_6_0 - 8.333333333333311e-03*G4_1_1_7_2_7_0 - 8.333333333333309e-03*G4_1_2_4_0_8_0 - 4.166666666666654e-03*G4_1_2_4_0_9_0 - 4.166666666666653e-03*G4_1_2_4_0_10_0 - 4.166666666666654e-03*G4_1_2_4_0_11_0 - 8.333333333333309e-03*G4_1_2_4_1_8_0 - 4.166666666666654e-03*G4_1_2_4_1_9_0 - 4.166666666666654e-03*G4_1_2_4_1_10_0 - 4.166666666666656e-03*G4_1_2_4_1_11_0 - 8.333333333333311e-03*G4_1_2_4_2_8_0 - 4.166666666666654e-03*G4_1_2_4_2_9_0 - 4.166666666666654e-03*G4_1_2_4_2_10_0 - 4.166666666666657e-03*G4_1_2_4_2_11_0 - 4.166666666666654e-03*G4_1_2_5_0_8_0 - 8.333333333333307e-03*G4_1_2_5_0_9_0 - 4.166666666666654e-03*G4_1_2_5_0_10_0 - 4.166666666666655e-03*G4_1_2_5_0_11_0 - 4.166666666666654e-03*G4_1_2_5_1_8_0 - 8.333333333333309e-03*G4_1_2_5_1_9_0 - 4.166666666666655e-03*G4_1_2_5_1_10_0 - 4.166666666666656e-03*G4_1_2_5_1_11_0 - 4.166666666666654e-03*G4_1_2_5_2_8_0 - 8.333333333333309e-03*G4_1_2_5_2_9_0 - 4.166666666666655e-03*G4_1_2_5_2_10_0 - 4.166666666666656e-03*G4_1_2_5_2_11_0 - 4.166666666666653e-03*G4_1_2_6_0_8_0 - 4.166666666666654e-03*G4_1_2_6_0_9_0 - 8.333333333333309e-03*G4_1_2_6_0_10_0 - 4.166666666666654e-03*G4_1_2_6_0_11_0 - 4.166666666666654e-03*G4_1_2_6_1_8_0 - 4.166666666666655e-03*G4_1_2_6_1_9_0 - 8.333333333333311e-03*G4_1_2_6_1_10_0 - 4.166666666666655e-03*G4_1_2_6_1_11_0 - 4.166666666666654e-03*G4_1_2_6_2_8_0 - 4.166666666666655e-03*G4_1_2_6_2_9_0 - 8.333333333333311e-03*G4_1_2_6_2_10_0 - 4.166666666666655e-03*G4_1_2_6_2_11_0 - 4.166666666666655e-03*G4_1_2_7_0_8_0 - 4.166666666666655e-03*G4_1_2_7_0_9_0 - 4.166666666666655e-03*G4_1_2_7_0_10_0 - 8.333333333333309e-03*G4_1_2_7_0_11_0 - 4.166666666666656e-03*G4_1_2_7_1_8_0 - 4.166666666666656e-03*G4_1_2_7_1_9_0 - 4.166666666666655e-03*G4_1_2_7_1_10_0 - 8.333333333333311e-03*G4_1_2_7_1_11_0 - 4.166666666666657e-03*G4_1_2_7_2_8_0 - 4.166666666666656e-03*G4_1_2_7_2_9_0 - 4.166666666666655e-03*G4_1_2_7_2_10_0 - 8.333333333333311e-03*G4_1_2_7_2_11_0 - 8.333333333333309e-03*G4_2_0_8_0_0_0 - 4.166666666666654e-03*G4_2_0_8_0_1_0 - 4.166666666666653e-03*G4_2_0_8_0_2_0 - 4.166666666666654e-03*G4_2_0_8_0_3_0 - 8.333333333333309e-03*G4_2_0_8_1_0_0 - 4.166666666666654e-03*G4_2_0_8_1_1_0 - 4.166666666666654e-03*G4_2_0_8_1_2_0 - 4.166666666666656e-03*G4_2_0_8_1_3_0 - 8.333333333333311e-03*G4_2_0_8_2_0_0 - 4.166666666666654e-03*G4_2_0_8_2_1_0 - 4.166666666666654e-03*G4_2_0_8_2_2_0 - 4.166666666666657e-03*G4_2_0_8_2_3_0 - 4.166666666666654e-03*G4_2_0_9_0_0_0 - 8.333333333333307e-03*G4_2_0_9_0_1_0 - 4.166666666666654e-03*G4_2_0_9_0_2_0 - 4.166666666666655e-03*G4_2_0_9_0_3_0 - 4.166666666666655e-03*G4_2_0_9_1_0_0 - 8.333333333333309e-03*G4_2_0_9_1_1_0 - 4.166666666666655e-03*G4_2_0_9_1_2_0 - 4.166666666666656e-03*G4_2_0_9_1_3_0 - 4.166666666666655e-03*G4_2_0_9_2_0_0 - 8.333333333333309e-03*G4_2_0_9_2_1_0 - 4.166666666666655e-03*G4_2_0_9_2_2_0 - 4.166666666666656e-03*G4_2_0_9_2_3_0 - 4.166666666666654e-03*G4_2_0_10_0_0_0 - 4.166666666666654e-03*G4_2_0_10_0_1_0 - 8.333333333333309e-03*G4_2_0_10_0_2_0 - 4.166666666666654e-03*G4_2_0_10_0_3_0 - 4.166666666666654e-03*G4_2_0_10_1_0_0 - 4.166666666666654e-03*G4_2_0_10_1_1_0 - 8.333333333333311e-03*G4_2_0_10_1_2_0 - 4.166666666666655e-03*G4_2_0_10_1_3_0 - 4.166666666666655e-03*G4_2_0_10_2_0_0 - 4.166666666666654e-03*G4_2_0_10_2_1_0 - 8.333333333333311e-03*G4_2_0_10_2_2_0 - 4.166666666666655e-03*G4_2_0_10_2_3_0 - 4.166666666666656e-03*G4_2_0_11_0_0_0 - 4.166666666666654e-03*G4_2_0_11_0_1_0 - 4.166666666666655e-03*G4_2_0_11_0_2_0 - 8.333333333333309e-03*G4_2_0_11_0_3_0 - 4.166666666666656e-03*G4_2_0_11_1_0_0 - 4.166666666666655e-03*G4_2_0_11_1_1_0 - 4.166666666666655e-03*G4_2_0_11_1_2_0 - 8.333333333333311e-03*G4_2_0_11_1_3_0 - 4.166666666666657e-03*G4_2_0_11_2_0_0 - 4.166666666666655e-03*G4_2_0_11_2_1_0 - 4.166666666666655e-03*G4_2_0_11_2_2_0 - 8.333333333333311e-03*G4_2_0_11_2_3_0 - 8.333333333333309e-03*G4_2_1_8_0_4_0 - 4.166666666666654e-03*G4_2_1_8_0_5_0 - 4.166666666666653e-03*G4_2_1_8_0_6_0 - 4.166666666666654e-03*G4_2_1_8_0_7_0 - 8.333333333333309e-03*G4_2_1_8_1_4_0 - 4.166666666666654e-03*G4_2_1_8_1_5_0 - 4.166666666666654e-03*G4_2_1_8_1_6_0 - 4.166666666666656e-03*G4_2_1_8_1_7_0 - 8.333333333333311e-03*G4_2_1_8_2_4_0 - 4.166666666666654e-03*G4_2_1_8_2_5_0 - 4.166666666666654e-03*G4_2_1_8_2_6_0 - 4.166666666666657e-03*G4_2_1_8_2_7_0 - 4.166666666666654e-03*G4_2_1_9_0_4_0 - 8.333333333333307e-03*G4_2_1_9_0_5_0 - 4.166666666666654e-03*G4_2_1_9_0_6_0 - 4.166666666666655e-03*G4_2_1_9_0_7_0 - 4.166666666666654e-03*G4_2_1_9_1_4_0 - 8.333333333333309e-03*G4_2_1_9_1_5_0 - 4.166666666666655e-03*G4_2_1_9_1_6_0 - 4.166666666666656e-03*G4_2_1_9_1_7_0 - 4.166666666666654e-03*G4_2_1_9_2_4_0 - 8.333333333333309e-03*G4_2_1_9_2_5_0 - 4.166666666666655e-03*G4_2_1_9_2_6_0 - 4.166666666666656e-03*G4_2_1_9_2_7_0 - 4.166666666666653e-03*G4_2_1_10_0_4_0 - 4.166666666666654e-03*G4_2_1_10_0_5_0 - 8.333333333333309e-03*G4_2_1_10_0_6_0 - 4.166666666666654e-03*G4_2_1_10_0_7_0 - 4.166666666666654e-03*G4_2_1_10_1_4_0 - 4.166666666666655e-03*G4_2_1_10_1_5_0 - 8.333333333333311e-03*G4_2_1_10_1_6_0 - 4.166666666666655e-03*G4_2_1_10_1_7_0 - 4.166666666666654e-03*G4_2_1_10_2_4_0 - 4.166666666666655e-03*G4_2_1_10_2_5_0 - 8.333333333333311e-03*G4_2_1_10_2_6_0 - 4.166666666666655e-03*G4_2_1_10_2_7_0 - 4.166666666666655e-03*G4_2_1_11_0_4_0 - 4.166666666666655e-03*G4_2_1_11_0_5_0 - 4.166666666666655e-03*G4_2_1_11_0_6_0 - 8.333333333333309e-03*G4_2_1_11_0_7_0 - 4.166666666666656e-03*G4_2_1_11_1_4_0 - 4.166666666666656e-03*G4_2_1_11_1_5_0 - 4.166666666666655e-03*G4_2_1_11_1_6_0 - 8.333333333333311e-03*G4_2_1_11_1_7_0 - 4.166666666666657e-03*G4_2_1_11_2_4_0 - 4.166666666666656e-03*G4_2_1_11_2_5_0 - 4.166666666666655e-03*G4_2_1_11_2_6_0 - 8.333333333333311e-03*G4_2_1_11_2_7_0 - 8.333333333333309e-03*G4_2_2_8_0_8_0 - 4.166666666666654e-03*G4_2_2_8_0_9_0 - 4.166666666666653e-03*G4_2_2_8_0_10_0 - 4.166666666666654e-03*G4_2_2_8_0_11_0 - 8.333333333333309e-03*G4_2_2_8_1_8_0 - 4.166666666666654e-03*G4_2_2_8_1_9_0 - 4.166666666666654e-03*G4_2_2_8_1_10_0 - 4.166666666666656e-03*G4_2_2_8_1_11_0 - 8.333333333333311e-03*G4_2_2_8_2_8_0 - 4.166666666666654e-03*G4_2_2_8_2_9_0 - 4.166666666666654e-03*G4_2_2_8_2_10_0 - 4.166666666666657e-03*G4_2_2_8_2_11_0 - 4.166666666666654e-03*G4_2_2_9_0_8_0 - 8.333333333333307e-03*G4_2_2_9_0_9_0 - 4.166666666666654e-03*G4_2_2_9_0_10_0 - 4.166666666666655e-03*G4_2_2_9_0_11_0 - 4.166666666666654e-03*G4_2_2_9_1_8_0 - 8.333333333333309e-03*G4_2_2_9_1_9_0 - 4.166666666666655e-03*G4_2_2_9_1_10_0 - 4.166666666666656e-03*G4_2_2_9_1_11_0 - 4.166666666666654e-03*G4_2_2_9_2_8_0 - 8.333333333333309e-03*G4_2_2_9_2_9_0 - 4.166666666666655e-03*G4_2_2_9_2_10_0 - 4.166666666666656e-03*G4_2_2_9_2_11_0 - 4.166666666666653e-03*G4_2_2_10_0_8_0 - 4.166666666666654e-03*G4_2_2_10_0_9_0 - 8.333333333333309e-03*G4_2_2_10_0_10_0 - 4.166666666666654e-03*G4_2_2_10_0_11_0 - 4.166666666666654e-03*G4_2_2_10_1_8_0 - 4.166666666666655e-03*G4_2_2_10_1_9_0 - 8.333333333333311e-03*G4_2_2_10_1_10_0 - 4.166666666666655e-03*G4_2_2_10_1_11_0 - 4.166666666666654e-03*G4_2_2_10_2_8_0 - 4.166666666666655e-03*G4_2_2_10_2_9_0 - 8.333333333333311e-03*G4_2_2_10_2_10_0 - 4.166666666666655e-03*G4_2_2_10_2_11_0 - 4.166666666666655e-03*G4_2_2_11_0_8_0 - 4.166666666666655e-03*G4_2_2_11_0_9_0 - 4.166666666666655e-03*G4_2_2_11_0_10_0 - 8.333333333333309e-03*G4_2_2_11_0_11_0 - 4.166666666666656e-03*G4_2_2_11_1_8_0 - 4.166666666666656e-03*G4_2_2_11_1_9_0 - 4.166666666666655e-03*G4_2_2_11_1_10_0 - 8.333333333333311e-03*G4_2_2_11_1_11_0 - 4.166666666666657e-03*G4_2_2_11_2_8_0 - 4.166666666666656e-03*G4_2_2_11_2_9_0 - 4.166666666666655e-03*G4_2_2_11_2_10_0 - 8.333333333333311e-03*G4_2_2_11_2_11_0;
    block[54] = 8.333333333333309e-03*G0_ - 8.333333333333322e-02*G1_0_1 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_2_1 + 8.333333333333311e-03*G2_0_0_1 + 4.166666666666654e-03*G2_0_1_1 + 4.166666666666654e-03*G2_0_2_1 + 4.166666666666657e-03*G2_0_3_1 + 8.333333333333311e-03*G2_1_4_1 + 4.166666666666654e-03*G2_1_5_1 + 4.166666666666654e-03*G2_1_6_1 + 4.166666666666657e-03*G2_1_7_1 + 8.333333333333311e-03*G2_2_8_1 + 4.166666666666654e-03*G2_2_9_1 + 4.166666666666654e-03*G2_2_10_1 + 4.166666666666657e-03*G2_2_11_1 - 8.333333333333322e-02*G3_1_1_0_1 - 8.333333333333323e-02*G3_1_1_1_1 - 8.333333333333323e-02*G3_1_1_2_1 - 8.333333333333309e-03*G4_0_0_0_0_0_1 - 4.166666666666654e-03*G4_0_0_0_0_1_1 - 4.166666666666654e-03*G4_0_0_0_0_2_1 - 4.166666666666656e-03*G4_0_0_0_0_3_1 - 8.333333333333311e-03*G4_0_0_0_1_0_1 - 4.166666666666655e-03*G4_0_0_0_1_1_1 - 4.166666666666656e-03*G4_0_0_0_1_2_1 - 4.166666666666657e-03*G4_0_0_0_1_3_1 - 8.333333333333312e-03*G4_0_0_0_2_0_1 - 4.166666666666655e-03*G4_0_0_0_2_1_1 - 4.166666666666656e-03*G4_0_0_0_2_2_1 - 4.166666666666658e-03*G4_0_0_0_2_3_1 - 4.166666666666654e-03*G4_0_0_1_0_0_1 - 8.333333333333307e-03*G4_0_0_1_0_1_1 - 4.166666666666654e-03*G4_0_0_1_0_2_1 - 4.166666666666655e-03*G4_0_0_1_0_3_1 - 4.166666666666655e-03*G4_0_0_1_1_0_1 - 8.333333333333309e-03*G4_0_0_1_1_1_1 - 4.166666666666654e-03*G4_0_0_1_1_2_1 - 4.166666666666655e-03*G4_0_0_1_1_3_1 - 4.166666666666655e-03*G4_0_0_1_2_0_1 - 8.333333333333309e-03*G4_0_0_1_2_1_1 - 4.166666666666655e-03*G4_0_0_1_2_2_1 - 4.166666666666656e-03*G4_0_0_1_2_3_1 - 4.166666666666654e-03*G4_0_0_2_0_0_1 - 4.166666666666654e-03*G4_0_0_2_0_1_1 - 8.333333333333309e-03*G4_0_0_2_0_2_1 - 4.166666666666655e-03*G4_0_0_2_0_3_1 - 4.166666666666656e-03*G4_0_0_2_1_0_1 - 4.166666666666654e-03*G4_0_0_2_1_1_1 - 8.333333333333311e-03*G4_0_0_2_1_2_1 - 4.166666666666656e-03*G4_0_0_2_1_3_1 - 4.166666666666656e-03*G4_0_0_2_2_0_1 - 4.166666666666654e-03*G4_0_0_2_2_1_1 - 8.333333333333312e-03*G4_0_0_2_2_2_1 - 4.166666666666657e-03*G4_0_0_2_2_3_1 - 4.166666666666656e-03*G4_0_0_3_0_0_1 - 4.166666666666655e-03*G4_0_0_3_0_1_1 - 4.166666666666655e-03*G4_0_0_3_0_2_1 - 8.333333333333311e-03*G4_0_0_3_0_3_1 - 4.166666666666657e-03*G4_0_0_3_1_0_1 - 4.166666666666655e-03*G4_0_0_3_1_1_1 - 4.166666666666656e-03*G4_0_0_3_1_2_1 - 8.333333333333311e-03*G4_0_0_3_1_3_1 - 4.166666666666658e-03*G4_0_0_3_2_0_1 - 4.166666666666656e-03*G4_0_0_3_2_1_1 - 4.166666666666657e-03*G4_0_0_3_2_2_1 - 8.333333333333312e-03*G4_0_0_3_2_3_1 - 8.333333333333309e-03*G4_0_1_0_0_4_1 - 4.166666666666655e-03*G4_0_1_0_0_5_1 - 4.166666666666654e-03*G4_0_1_0_0_6_1 - 4.166666666666656e-03*G4_0_1_0_0_7_1 - 8.333333333333311e-03*G4_0_1_0_1_4_1 - 4.166666666666655e-03*G4_0_1_0_1_5_1 - 4.166666666666656e-03*G4_0_1_0_1_6_1 - 4.166666666666657e-03*G4_0_1_0_1_7_1 - 8.333333333333312e-03*G4_0_1_0_2_4_1 - 4.166666666666656e-03*G4_0_1_0_2_5_1 - 4.166666666666656e-03*G4_0_1_0_2_6_1 - 4.166666666666658e-03*G4_0_1_0_2_7_1 - 4.166666666666654e-03*G4_0_1_1_0_4_1 - 8.333333333333309e-03*G4_0_1_1_0_5_1 - 4.166666666666654e-03*G4_0_1_1_0_6_1 - 4.166666666666655e-03*G4_0_1_1_0_7_1 - 4.166666666666654e-03*G4_0_1_1_1_4_1 - 8.333333333333309e-03*G4_0_1_1_1_5_1 - 4.166666666666654e-03*G4_0_1_1_1_6_1 - 4.166666666666655e-03*G4_0_1_1_1_7_1 - 4.166666666666654e-03*G4_0_1_1_2_4_1 - 8.333333333333309e-03*G4_0_1_1_2_5_1 - 4.166666666666655e-03*G4_0_1_1_2_6_1 - 4.166666666666656e-03*G4_0_1_1_2_7_1 - 4.166666666666654e-03*G4_0_1_2_0_4_1 - 4.166666666666655e-03*G4_0_1_2_0_5_1 - 8.333333333333309e-03*G4_0_1_2_0_6_1 - 4.166666666666655e-03*G4_0_1_2_0_7_1 - 4.166666666666654e-03*G4_0_1_2_1_4_1 - 4.166666666666656e-03*G4_0_1_2_1_5_1 - 8.333333333333311e-03*G4_0_1_2_1_6_1 - 4.166666666666656e-03*G4_0_1_2_1_7_1 - 4.166666666666654e-03*G4_0_1_2_2_4_1 - 4.166666666666656e-03*G4_0_1_2_2_5_1 - 8.333333333333312e-03*G4_0_1_2_2_6_1 - 4.166666666666657e-03*G4_0_1_2_2_7_1 - 4.166666666666656e-03*G4_0_1_3_0_4_1 - 4.166666666666656e-03*G4_0_1_3_0_5_1 - 4.166666666666655e-03*G4_0_1_3_0_6_1 - 8.333333333333311e-03*G4_0_1_3_0_7_1 - 4.166666666666657e-03*G4_0_1_3_1_4_1 - 4.166666666666657e-03*G4_0_1_3_1_5_1 - 4.166666666666656e-03*G4_0_1_3_1_6_1 - 8.333333333333311e-03*G4_0_1_3_1_7_1 - 4.166666666666657e-03*G4_0_1_3_2_4_1 - 4.166666666666657e-03*G4_0_1_3_2_5_1 - 4.166666666666657e-03*G4_0_1_3_2_6_1 - 8.333333333333312e-03*G4_0_1_3_2_7_1 - 8.333333333333309e-03*G4_0_2_0_0_8_1 - 4.166666666666655e-03*G4_0_2_0_0_9_1 - 4.166666666666654e-03*G4_0_2_0_0_10_1 - 4.166666666666656e-03*G4_0_2_0_0_11_1 - 8.333333333333311e-03*G4_0_2_0_1_8_1 - 4.166666666666655e-03*G4_0_2_0_1_9_1 - 4.166666666666656e-03*G4_0_2_0_1_10_1 - 4.166666666666657e-03*G4_0_2_0_1_11_1 - 8.333333333333312e-03*G4_0_2_0_2_8_1 - 4.166666666666656e-03*G4_0_2_0_2_9_1 - 4.166666666666656e-03*G4_0_2_0_2_10_1 - 4.166666666666658e-03*G4_0_2_0_2_11_1 - 4.166666666666654e-03*G4_0_2_1_0_8_1 - 8.333333333333309e-03*G4_0_2_1_0_9_1 - 4.166666666666654e-03*G4_0_2_1_0_10_1 - 4.166666666666655e-03*G4_0_2_1_0_11_1 - 4.166666666666654e-03*G4_0_2_1_1_8_1 - 8.333333333333309e-03*G4_0_2_1_1_9_1 - 4.166666666666654e-03*G4_0_2_1_1_10_1 - 4.166666666666655e-03*G4_0_2_1_1_11_1 - 4.166666666666654e-03*G4_0_2_1_2_8_1 - 8.333333333333309e-03*G4_0_2_1_2_9_1 - 4.166666666666655e-03*G4_0_2_1_2_10_1 - 4.166666666666656e-03*G4_0_2_1_2_11_1 - 4.166666666666654e-03*G4_0_2_2_0_8_1 - 4.166666666666655e-03*G4_0_2_2_0_9_1 - 8.333333333333309e-03*G4_0_2_2_0_10_1 - 4.166666666666655e-03*G4_0_2_2_0_11_1 - 4.166666666666654e-03*G4_0_2_2_1_8_1 - 4.166666666666656e-03*G4_0_2_2_1_9_1 - 8.333333333333311e-03*G4_0_2_2_1_10_1 - 4.166666666666656e-03*G4_0_2_2_1_11_1 - 4.166666666666654e-03*G4_0_2_2_2_8_1 - 4.166666666666656e-03*G4_0_2_2_2_9_1 - 8.333333333333312e-03*G4_0_2_2_2_10_1 - 4.166666666666657e-03*G4_0_2_2_2_11_1 - 4.166666666666656e-03*G4_0_2_3_0_8_1 - 4.166666666666656e-03*G4_0_2_3_0_9_1 - 4.166666666666655e-03*G4_0_2_3_0_10_1 - 8.333333333333311e-03*G4_0_2_3_0_11_1 - 4.166666666666657e-03*G4_0_2_3_1_8_1 - 4.166666666666657e-03*G4_0_2_3_1_9_1 - 4.166666666666656e-03*G4_0_2_3_1_10_1 - 8.333333333333311e-03*G4_0_2_3_1_11_1 - 4.166666666666657e-03*G4_0_2_3_2_8_1 - 4.166666666666657e-03*G4_0_2_3_2_9_1 - 4.166666666666657e-03*G4_0_2_3_2_10_1 - 8.333333333333312e-03*G4_0_2_3_2_11_1 - 8.333333333333309e-03*G4_1_0_4_0_0_1 - 4.166666666666654e-03*G4_1_0_4_0_1_1 - 4.166666666666654e-03*G4_1_0_4_0_2_1 - 4.166666666666656e-03*G4_1_0_4_0_3_1 - 8.333333333333311e-03*G4_1_0_4_1_0_1 - 4.166666666666654e-03*G4_1_0_4_1_1_1 - 4.166666666666654e-03*G4_1_0_4_1_2_1 - 4.166666666666657e-03*G4_1_0_4_1_3_1 - 8.333333333333312e-03*G4_1_0_4_2_0_1 - 4.166666666666654e-03*G4_1_0_4_2_1_1 - 4.166666666666654e-03*G4_1_0_4_2_2_1 - 4.166666666666657e-03*G4_1_0_4_2_3_1 - 4.166666666666655e-03*G4_1_0_5_0_0_1 - 8.333333333333309e-03*G4_1_0_5_0_1_1 - 4.166666666666655e-03*G4_1_0_5_0_2_1 - 4.166666666666656e-03*G4_1_0_5_0_3_1 - 4.166666666666655e-03*G4_1_0_5_1_0_1 - 8.333333333333309e-03*G4_1_0_5_1_1_1 - 4.166666666666656e-03*G4_1_0_5_1_2_1 - 4.166666666666657e-03*G4_1_0_5_1_3_1 - 4.166666666666656e-03*G4_1_0_5_2_0_1 - 8.333333333333309e-03*G4_1_0_5_2_1_1 - 4.166666666666656e-03*G4_1_0_5_2_2_1 - 4.166666666666657e-03*G4_1_0_5_2_3_1 - 4.166666666666654e-03*G4_1_0_6_0_0_1 - 4.166666666666654e-03*G4_1_0_6_0_1_1 - 8.333333333333309e-03*G4_1_0_6_0_2_1 - 4.166666666666655e-03*G4_1_0_6_0_3_1 - 4.166666666666656e-03*G4_1_0_6_1_0_1 - 4.166666666666654e-03*G4_1_0_6_1_1_1 - 8.333333333333311e-03*G4_1_0_6_1_2_1 - 4.166666666666656e-03*G4_1_0_6_1_3_1 - 4.166666666666656e-03*G4_1_0_6_2_0_1 - 4.166666666666654e-03*G4_1_0_6_2_1_1 - 8.333333333333312e-03*G4_1_0_6_2_2_1 - 4.166666666666657e-03*G4_1_0_6_2_3_1 - 4.166666666666656e-03*G4_1_0_7_0_0_1 - 4.166666666666655e-03*G4_1_0_7_0_1_1 - 4.166666666666655e-03*G4_1_0_7_0_2_1 - 8.333333333333311e-03*G4_1_0_7_0_3_1 - 4.166666666666657e-03*G4_1_0_7_1_0_1 - 4.166666666666655e-03*G4_1_0_7_1_1_1 - 4.166666666666656e-03*G4_1_0_7_1_2_1 - 8.333333333333311e-03*G4_1_0_7_1_3_1 - 4.166666666666658e-03*G4_1_0_7_2_0_1 - 4.166666666666656e-03*G4_1_0_7_2_1_1 - 4.166666666666657e-03*G4_1_0_7_2_2_1 - 8.333333333333312e-03*G4_1_0_7_2_3_1 - 8.333333333333309e-03*G4_1_1_4_0_4_1 - 4.166666666666654e-03*G4_1_1_4_0_5_1 - 4.166666666666654e-03*G4_1_1_4_0_6_1 - 4.166666666666656e-03*G4_1_1_4_0_7_1 - 8.333333333333311e-03*G4_1_1_4_1_4_1 - 4.166666666666654e-03*G4_1_1_4_1_5_1 - 4.166666666666654e-03*G4_1_1_4_1_6_1 - 4.166666666666657e-03*G4_1_1_4_1_7_1 - 8.333333333333312e-03*G4_1_1_4_2_4_1 - 4.166666666666655e-03*G4_1_1_4_2_5_1 - 4.166666666666654e-03*G4_1_1_4_2_6_1 - 4.166666666666657e-03*G4_1_1_4_2_7_1 - 4.166666666666654e-03*G4_1_1_5_0_4_1 - 8.333333333333309e-03*G4_1_1_5_0_5_1 - 4.166666666666655e-03*G4_1_1_5_0_6_1 - 4.166666666666656e-03*G4_1_1_5_0_7_1 - 4.166666666666654e-03*G4_1_1_5_1_4_1 - 8.333333333333309e-03*G4_1_1_5_1_5_1 - 4.166666666666656e-03*G4_1_1_5_1_6_1 - 4.166666666666657e-03*G4_1_1_5_1_7_1 - 4.166666666666655e-03*G4_1_1_5_2_4_1 - 8.333333333333309e-03*G4_1_1_5_2_5_1 - 4.166666666666656e-03*G4_1_1_5_2_6_1 - 4.166666666666657e-03*G4_1_1_5_2_7_1 - 4.166666666666654e-03*G4_1_1_6_0_4_1 - 4.166666666666655e-03*G4_1_1_6_0_5_1 - 8.333333333333309e-03*G4_1_1_6_0_6_1 - 4.166666666666655e-03*G4_1_1_6_0_7_1 - 4.166666666666654e-03*G4_1_1_6_1_4_1 - 4.166666666666656e-03*G4_1_1_6_1_5_1 - 8.333333333333311e-03*G4_1_1_6_1_6_1 - 4.166666666666656e-03*G4_1_1_6_1_7_1 - 4.166666666666654e-03*G4_1_1_6_2_4_1 - 4.166666666666656e-03*G4_1_1_6_2_5_1 - 8.333333333333312e-03*G4_1_1_6_2_6_1 - 4.166666666666657e-03*G4_1_1_6_2_7_1 - 4.166666666666656e-03*G4_1_1_7_0_4_1 - 4.166666666666656e-03*G4_1_1_7_0_5_1 - 4.166666666666655e-03*G4_1_1_7_0_6_1 - 8.333333333333311e-03*G4_1_1_7_0_7_1 - 4.166666666666657e-03*G4_1_1_7_1_4_1 - 4.166666666666657e-03*G4_1_1_7_1_5_1 - 4.166666666666656e-03*G4_1_1_7_1_6_1 - 8.333333333333311e-03*G4_1_1_7_1_7_1 - 4.166666666666657e-03*G4_1_1_7_2_4_1 - 4.166666666666657e-03*G4_1_1_7_2_5_1 - 4.166666666666657e-03*G4_1_1_7_2_6_1 - 8.333333333333312e-03*G4_1_1_7_2_7_1 - 8.333333333333309e-03*G4_1_2_4_0_8_1 - 4.166666666666654e-03*G4_1_2_4_0_9_1 - 4.166666666666654e-03*G4_1_2_4_0_10_1 - 4.166666666666656e-03*G4_1_2_4_0_11_1 - 8.333333333333311e-03*G4_1_2_4_1_8_1 - 4.166666666666654e-03*G4_1_2_4_1_9_1 - 4.166666666666654e-03*G4_1_2_4_1_10_1 - 4.166666666666657e-03*G4_1_2_4_1_11_1 - 8.333333333333312e-03*G4_1_2_4_2_8_1 - 4.166666666666655e-03*G4_1_2_4_2_9_1 - 4.166666666666654e-03*G4_1_2_4_2_10_1 - 4.166666666666657e-03*G4_1_2_4_2_11_1 - 4.166666666666654e-03*G4_1_2_5_0_8_1 - 8.333333333333309e-03*G4_1_2_5_0_9_1 - 4.166666666666655e-03*G4_1_2_5_0_10_1 - 4.166666666666656e-03*G4_1_2_5_0_11_1 - 4.166666666666654e-03*G4_1_2_5_1_8_1 - 8.333333333333309e-03*G4_1_2_5_1_9_1 - 4.166666666666656e-03*G4_1_2_5_1_10_1 - 4.166666666666657e-03*G4_1_2_5_1_11_1 - 4.166666666666655e-03*G4_1_2_5_2_8_1 - 8.333333333333309e-03*G4_1_2_5_2_9_1 - 4.166666666666656e-03*G4_1_2_5_2_10_1 - 4.166666666666657e-03*G4_1_2_5_2_11_1 - 4.166666666666654e-03*G4_1_2_6_0_8_1 - 4.166666666666655e-03*G4_1_2_6_0_9_1 - 8.333333333333309e-03*G4_1_2_6_0_10_1 - 4.166666666666655e-03*G4_1_2_6_0_11_1 - 4.166666666666654e-03*G4_1_2_6_1_8_1 - 4.166666666666656e-03*G4_1_2_6_1_9_1 - 8.333333333333311e-03*G4_1_2_6_1_10_1 - 4.166666666666656e-03*G4_1_2_6_1_11_1 - 4.166666666666654e-03*G4_1_2_6_2_8_1 - 4.166666666666656e-03*G4_1_2_6_2_9_1 - 8.333333333333312e-03*G4_1_2_6_2_10_1 - 4.166666666666657e-03*G4_1_2_6_2_11_1 - 4.166666666666656e-03*G4_1_2_7_0_8_1 - 4.166666666666656e-03*G4_1_2_7_0_9_1 - 4.166666666666655e-03*G4_1_2_7_0_10_1 - 8.333333333333311e-03*G4_1_2_7_0_11_1 - 4.166666666666657e-03*G4_1_2_7_1_8_1 - 4.166666666666657e-03*G4_1_2_7_1_9_1 - 4.166666666666656e-03*G4_1_2_7_1_10_1 - 8.333333333333311e-03*G4_1_2_7_1_11_1 - 4.166666666666657e-03*G4_1_2_7_2_8_1 - 4.166666666666657e-03*G4_1_2_7_2_9_1 - 4.166666666666657e-03*G4_1_2_7_2_10_1 - 8.333333333333312e-03*G4_1_2_7_2_11_1 - 8.333333333333309e-03*G4_2_0_8_0_0_1 - 4.166666666666654e-03*G4_2_0_8_0_1_1 - 4.166666666666654e-03*G4_2_0_8_0_2_1 - 4.166666666666656e-03*G4_2_0_8_0_3_1 - 8.333333333333311e-03*G4_2_0_8_1_0_1 - 4.166666666666654e-03*G4_2_0_8_1_1_1 - 4.166666666666654e-03*G4_2_0_8_1_2_1 - 4.166666666666657e-03*G4_2_0_8_1_3_1 - 8.333333333333312e-03*G4_2_0_8_2_0_1 - 4.166666666666654e-03*G4_2_0_8_2_1_1 - 4.166666666666654e-03*G4_2_0_8_2_2_1 - 4.166666666666657e-03*G4_2_0_8_2_3_1 - 4.166666666666655e-03*G4_2_0_9_0_0_1 - 8.333333333333309e-03*G4_2_0_9_0_1_1 - 4.166666666666655e-03*G4_2_0_9_0_2_1 - 4.166666666666656e-03*G4_2_0_9_0_3_1 - 4.166666666666655e-03*G4_2_0_9_1_0_1 - 8.333333333333309e-03*G4_2_0_9_1_1_1 - 4.166666666666656e-03*G4_2_0_9_1_2_1 - 4.166666666666657e-03*G4_2_0_9_1_3_1 - 4.166666666666656e-03*G4_2_0_9_2_0_1 - 8.333333333333309e-03*G4_2_0_9_2_1_1 - 4.166666666666656e-03*G4_2_0_9_2_2_1 - 4.166666666666657e-03*G4_2_0_9_2_3_1 - 4.166666666666654e-03*G4_2_0_10_0_0_1 - 4.166666666666654e-03*G4_2_0_10_0_1_1 - 8.333333333333309e-03*G4_2_0_10_0_2_1 - 4.166666666666655e-03*G4_2_0_10_0_3_1 - 4.166666666666656e-03*G4_2_0_10_1_0_1 - 4.166666666666654e-03*G4_2_0_10_1_1_1 - 8.333333333333311e-03*G4_2_0_10_1_2_1 - 4.166666666666656e-03*G4_2_0_10_1_3_1 - 4.166666666666656e-03*G4_2_0_10_2_0_1 - 4.166666666666654e-03*G4_2_0_10_2_1_1 - 8.333333333333312e-03*G4_2_0_10_2_2_1 - 4.166666666666657e-03*G4_2_0_10_2_3_1 - 4.166666666666656e-03*G4_2_0_11_0_0_1 - 4.166666666666655e-03*G4_2_0_11_0_1_1 - 4.166666666666655e-03*G4_2_0_11_0_2_1 - 8.333333333333311e-03*G4_2_0_11_0_3_1 - 4.166666666666657e-03*G4_2_0_11_1_0_1 - 4.166666666666655e-03*G4_2_0_11_1_1_1 - 4.166666666666656e-03*G4_2_0_11_1_2_1 - 8.333333333333311e-03*G4_2_0_11_1_3_1 - 4.166666666666658e-03*G4_2_0_11_2_0_1 - 4.166666666666656e-03*G4_2_0_11_2_1_1 - 4.166666666666657e-03*G4_2_0_11_2_2_1 - 8.333333333333312e-03*G4_2_0_11_2_3_1 - 8.333333333333309e-03*G4_2_1_8_0_4_1 - 4.166666666666654e-03*G4_2_1_8_0_5_1 - 4.166666666666654e-03*G4_2_1_8_0_6_1 - 4.166666666666656e-03*G4_2_1_8_0_7_1 - 8.333333333333311e-03*G4_2_1_8_1_4_1 - 4.166666666666654e-03*G4_2_1_8_1_5_1 - 4.166666666666654e-03*G4_2_1_8_1_6_1 - 4.166666666666657e-03*G4_2_1_8_1_7_1 - 8.333333333333312e-03*G4_2_1_8_2_4_1 - 4.166666666666655e-03*G4_2_1_8_2_5_1 - 4.166666666666654e-03*G4_2_1_8_2_6_1 - 4.166666666666657e-03*G4_2_1_8_2_7_1 - 4.166666666666654e-03*G4_2_1_9_0_4_1 - 8.333333333333309e-03*G4_2_1_9_0_5_1 - 4.166666666666655e-03*G4_2_1_9_0_6_1 - 4.166666666666656e-03*G4_2_1_9_0_7_1 - 4.166666666666654e-03*G4_2_1_9_1_4_1 - 8.333333333333309e-03*G4_2_1_9_1_5_1 - 4.166666666666656e-03*G4_2_1_9_1_6_1 - 4.166666666666657e-03*G4_2_1_9_1_7_1 - 4.166666666666655e-03*G4_2_1_9_2_4_1 - 8.333333333333309e-03*G4_2_1_9_2_5_1 - 4.166666666666656e-03*G4_2_1_9_2_6_1 - 4.166666666666657e-03*G4_2_1_9_2_7_1 - 4.166666666666654e-03*G4_2_1_10_0_4_1 - 4.166666666666655e-03*G4_2_1_10_0_5_1 - 8.333333333333309e-03*G4_2_1_10_0_6_1 - 4.166666666666655e-03*G4_2_1_10_0_7_1 - 4.166666666666654e-03*G4_2_1_10_1_4_1 - 4.166666666666656e-03*G4_2_1_10_1_5_1 - 8.333333333333311e-03*G4_2_1_10_1_6_1 - 4.166666666666656e-03*G4_2_1_10_1_7_1 - 4.166666666666654e-03*G4_2_1_10_2_4_1 - 4.166666666666656e-03*G4_2_1_10_2_5_1 - 8.333333333333312e-03*G4_2_1_10_2_6_1 - 4.166666666666657e-03*G4_2_1_10_2_7_1 - 4.166666666666656e-03*G4_2_1_11_0_4_1 - 4.166666666666656e-03*G4_2_1_11_0_5_1 - 4.166666666666655e-03*G4_2_1_11_0_6_1 - 8.333333333333311e-03*G4_2_1_11_0_7_1 - 4.166666666666657e-03*G4_2_1_11_1_4_1 - 4.166666666666657e-03*G4_2_1_11_1_5_1 - 4.166666666666656e-03*G4_2_1_11_1_6_1 - 8.333333333333311e-03*G4_2_1_11_1_7_1 - 4.166666666666657e-03*G4_2_1_11_2_4_1 - 4.166666666666657e-03*G4_2_1_11_2_5_1 - 4.166666666666657e-03*G4_2_1_11_2_6_1 - 8.333333333333312e-03*G4_2_1_11_2_7_1 - 8.333333333333309e-03*G4_2_2_8_0_8_1 - 4.166666666666654e-03*G4_2_2_8_0_9_1 - 4.166666666666654e-03*G4_2_2_8_0_10_1 - 4.166666666666656e-03*G4_2_2_8_0_11_1 - 8.333333333333311e-03*G4_2_2_8_1_8_1 - 4.166666666666654e-03*G4_2_2_8_1_9_1 - 4.166666666666654e-03*G4_2_2_8_1_10_1 - 4.166666666666657e-03*G4_2_2_8_1_11_1 - 8.333333333333312e-03*G4_2_2_8_2_8_1 - 4.166666666666655e-03*G4_2_2_8_2_9_1 - 4.166666666666654e-03*G4_2_2_8_2_10_1 - 4.166666666666657e-03*G4_2_2_8_2_11_1 - 4.166666666666654e-03*G4_2_2_9_0_8_1 - 8.333333333333309e-03*G4_2_2_9_0_9_1 - 4.166666666666655e-03*G4_2_2_9_0_10_1 - 4.166666666666656e-03*G4_2_2_9_0_11_1 - 4.166666666666654e-03*G4_2_2_9_1_8_1 - 8.333333333333309e-03*G4_2_2_9_1_9_1 - 4.166666666666656e-03*G4_2_2_9_1_10_1 - 4.166666666666657e-03*G4_2_2_9_1_11_1 - 4.166666666666655e-03*G4_2_2_9_2_8_1 - 8.333333333333309e-03*G4_2_2_9_2_9_1 - 4.166666666666656e-03*G4_2_2_9_2_10_1 - 4.166666666666657e-03*G4_2_2_9_2_11_1 - 4.166666666666654e-03*G4_2_2_10_0_8_1 - 4.166666666666655e-03*G4_2_2_10_0_9_1 - 8.333333333333309e-03*G4_2_2_10_0_10_1 - 4.166666666666655e-03*G4_2_2_10_0_11_1 - 4.166666666666654e-03*G4_2_2_10_1_8_1 - 4.166666666666656e-03*G4_2_2_10_1_9_1 - 8.333333333333311e-03*G4_2_2_10_1_10_1 - 4.166666666666656e-03*G4_2_2_10_1_11_1 - 4.166666666666654e-03*G4_2_2_10_2_8_1 - 4.166666666666656e-03*G4_2_2_10_2_9_1 - 8.333333333333312e-03*G4_2_2_10_2_10_1 - 4.166666666666657e-03*G4_2_2_10_2_11_1 - 4.166666666666656e-03*G4_2_2_11_0_8_1 - 4.166666666666656e-03*G4_2_2_11_0_9_1 - 4.166666666666655e-03*G4_2_2_11_0_10_1 - 8.333333333333311e-03*G4_2_2_11_0_11_1 - 4.166666666666657e-03*G4_2_2_11_1_8_1 - 4.166666666666657e-03*G4_2_2_11_1_9_1 - 4.166666666666656e-03*G4_2_2_11_1_10_1 - 8.333333333333311e-03*G4_2_2_11_1_11_1 - 4.166666666666657e-03*G4_2_2_11_2_8_1 - 4.166666666666657e-03*G4_2_2_11_2_9_1 - 4.166666666666657e-03*G4_2_2_11_2_10_1 - 8.333333333333312e-03*G4_2_2_11_2_11_1;
    block[55] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_0_2 - 8.333333333333323e-02*G1_1_2 - 8.333333333333323e-02*G1_2_2 + 8.333333333333311e-03*G2_0_0_2 + 4.166666666666654e-03*G2_0_1_2 + 4.166666666666654e-03*G2_0_2_2 + 4.166666666666657e-03*G2_0_3_2 + 8.333333333333311e-03*G2_1_4_2 + 4.166666666666654e-03*G2_1_5_2 + 4.166666666666654e-03*G2_1_6_2 + 4.166666666666657e-03*G2_1_7_2 + 8.333333333333311e-03*G2_2_8_2 + 4.166666666666654e-03*G2_2_9_2 + 4.166666666666654e-03*G2_2_10_2 + 4.166666666666657e-03*G2_2_11_2 - 8.333333333333322e-02*G3_1_1_0_2 - 8.333333333333323e-02*G3_1_1_1_2 - 8.333333333333323e-02*G3_1_1_2_2 - 8.333333333333309e-03*G4_0_0_0_0_0_2 - 4.166666666666654e-03*G4_0_0_0_0_1_2 - 4.166666666666654e-03*G4_0_0_0_0_2_2 - 4.166666666666656e-03*G4_0_0_0_0_3_2 - 8.333333333333311e-03*G4_0_0_0_1_0_2 - 4.166666666666655e-03*G4_0_0_0_1_1_2 - 4.166666666666656e-03*G4_0_0_0_1_2_2 - 4.166666666666657e-03*G4_0_0_0_1_3_2 - 8.333333333333312e-03*G4_0_0_0_2_0_2 - 4.166666666666655e-03*G4_0_0_0_2_1_2 - 4.166666666666656e-03*G4_0_0_0_2_2_2 - 4.166666666666658e-03*G4_0_0_0_2_3_2 - 4.166666666666654e-03*G4_0_0_1_0_0_2 - 8.333333333333307e-03*G4_0_0_1_0_1_2 - 4.166666666666654e-03*G4_0_0_1_0_2_2 - 4.166666666666655e-03*G4_0_0_1_0_3_2 - 4.166666666666655e-03*G4_0_0_1_1_0_2 - 8.333333333333309e-03*G4_0_0_1_1_1_2 - 4.166666666666654e-03*G4_0_0_1_1_2_2 - 4.166666666666655e-03*G4_0_0_1_1_3_2 - 4.166666666666655e-03*G4_0_0_1_2_0_2 - 8.333333333333309e-03*G4_0_0_1_2_1_2 - 4.166666666666655e-03*G4_0_0_1_2_2_2 - 4.166666666666656e-03*G4_0_0_1_2_3_2 - 4.166666666666654e-03*G4_0_0_2_0_0_2 - 4.166666666666654e-03*G4_0_0_2_0_1_2 - 8.333333333333309e-03*G4_0_0_2_0_2_2 - 4.166666666666655e-03*G4_0_0_2_0_3_2 - 4.166666666666656e-03*G4_0_0_2_1_0_2 - 4.166666666666654e-03*G4_0_0_2_1_1_2 - 8.333333333333311e-03*G4_0_0_2_1_2_2 - 4.166666666666656e-03*G4_0_0_2_1_3_2 - 4.166666666666656e-03*G4_0_0_2_2_0_2 - 4.166666666666654e-03*G4_0_0_2_2_1_2 - 8.333333333333312e-03*G4_0_0_2_2_2_2 - 4.166666666666657e-03*G4_0_0_2_2_3_2 - 4.166666666666656e-03*G4_0_0_3_0_0_2 - 4.166666666666655e-03*G4_0_0_3_0_1_2 - 4.166666666666655e-03*G4_0_0_3_0_2_2 - 8.333333333333311e-03*G4_0_0_3_0_3_2 - 4.166666666666657e-03*G4_0_0_3_1_0_2 - 4.166666666666655e-03*G4_0_0_3_1_1_2 - 4.166666666666656e-03*G4_0_0_3_1_2_2 - 8.333333333333311e-03*G4_0_0_3_1_3_2 - 4.166666666666658e-03*G4_0_0_3_2_0_2 - 4.166666666666656e-03*G4_0_0_3_2_1_2 - 4.166666666666657e-03*G4_0_0_3_2_2_2 - 8.333333333333312e-03*G4_0_0_3_2_3_2 - 8.333333333333309e-03*G4_0_1_0_0_4_2 - 4.166666666666655e-03*G4_0_1_0_0_5_2 - 4.166666666666654e-03*G4_0_1_0_0_6_2 - 4.166666666666656e-03*G4_0_1_0_0_7_2 - 8.333333333333311e-03*G4_0_1_0_1_4_2 - 4.166666666666655e-03*G4_0_1_0_1_5_2 - 4.166666666666656e-03*G4_0_1_0_1_6_2 - 4.166666666666657e-03*G4_0_1_0_1_7_2 - 8.333333333333312e-03*G4_0_1_0_2_4_2 - 4.166666666666656e-03*G4_0_1_0_2_5_2 - 4.166666666666656e-03*G4_0_1_0_2_6_2 - 4.166666666666658e-03*G4_0_1_0_2_7_2 - 4.166666666666654e-03*G4_0_1_1_0_4_2 - 8.333333333333309e-03*G4_0_1_1_0_5_2 - 4.166666666666654e-03*G4_0_1_1_0_6_2 - 4.166666666666655e-03*G4_0_1_1_0_7_2 - 4.166666666666654e-03*G4_0_1_1_1_4_2 - 8.333333333333309e-03*G4_0_1_1_1_5_2 - 4.166666666666654e-03*G4_0_1_1_1_6_2 - 4.166666666666655e-03*G4_0_1_1_1_7_2 - 4.166666666666654e-03*G4_0_1_1_2_4_2 - 8.333333333333309e-03*G4_0_1_1_2_5_2 - 4.166666666666655e-03*G4_0_1_1_2_6_2 - 4.166666666666656e-03*G4_0_1_1_2_7_2 - 4.166666666666654e-03*G4_0_1_2_0_4_2 - 4.166666666666655e-03*G4_0_1_2_0_5_2 - 8.333333333333309e-03*G4_0_1_2_0_6_2 - 4.166666666666655e-03*G4_0_1_2_0_7_2 - 4.166666666666654e-03*G4_0_1_2_1_4_2 - 4.166666666666656e-03*G4_0_1_2_1_5_2 - 8.333333333333311e-03*G4_0_1_2_1_6_2 - 4.166666666666656e-03*G4_0_1_2_1_7_2 - 4.166666666666654e-03*G4_0_1_2_2_4_2 - 4.166666666666656e-03*G4_0_1_2_2_5_2 - 8.333333333333312e-03*G4_0_1_2_2_6_2 - 4.166666666666657e-03*G4_0_1_2_2_7_2 - 4.166666666666656e-03*G4_0_1_3_0_4_2 - 4.166666666666656e-03*G4_0_1_3_0_5_2 - 4.166666666666655e-03*G4_0_1_3_0_6_2 - 8.333333333333311e-03*G4_0_1_3_0_7_2 - 4.166666666666657e-03*G4_0_1_3_1_4_2 - 4.166666666666657e-03*G4_0_1_3_1_5_2 - 4.166666666666656e-03*G4_0_1_3_1_6_2 - 8.333333333333311e-03*G4_0_1_3_1_7_2 - 4.166666666666657e-03*G4_0_1_3_2_4_2 - 4.166666666666657e-03*G4_0_1_3_2_5_2 - 4.166666666666657e-03*G4_0_1_3_2_6_2 - 8.333333333333312e-03*G4_0_1_3_2_7_2 - 8.333333333333309e-03*G4_0_2_0_0_8_2 - 4.166666666666655e-03*G4_0_2_0_0_9_2 - 4.166666666666654e-03*G4_0_2_0_0_10_2 - 4.166666666666656e-03*G4_0_2_0_0_11_2 - 8.333333333333311e-03*G4_0_2_0_1_8_2 - 4.166666666666655e-03*G4_0_2_0_1_9_2 - 4.166666666666656e-03*G4_0_2_0_1_10_2 - 4.166666666666657e-03*G4_0_2_0_1_11_2 - 8.333333333333312e-03*G4_0_2_0_2_8_2 - 4.166666666666656e-03*G4_0_2_0_2_9_2 - 4.166666666666656e-03*G4_0_2_0_2_10_2 - 4.166666666666658e-03*G4_0_2_0_2_11_2 - 4.166666666666654e-03*G4_0_2_1_0_8_2 - 8.333333333333309e-03*G4_0_2_1_0_9_2 - 4.166666666666654e-03*G4_0_2_1_0_10_2 - 4.166666666666655e-03*G4_0_2_1_0_11_2 - 4.166666666666654e-03*G4_0_2_1_1_8_2 - 8.333333333333309e-03*G4_0_2_1_1_9_2 - 4.166666666666654e-03*G4_0_2_1_1_10_2 - 4.166666666666655e-03*G4_0_2_1_1_11_2 - 4.166666666666654e-03*G4_0_2_1_2_8_2 - 8.333333333333309e-03*G4_0_2_1_2_9_2 - 4.166666666666655e-03*G4_0_2_1_2_10_2 - 4.166666666666656e-03*G4_0_2_1_2_11_2 - 4.166666666666654e-03*G4_0_2_2_0_8_2 - 4.166666666666655e-03*G4_0_2_2_0_9_2 - 8.333333333333309e-03*G4_0_2_2_0_10_2 - 4.166666666666655e-03*G4_0_2_2_0_11_2 - 4.166666666666654e-03*G4_0_2_2_1_8_2 - 4.166666666666656e-03*G4_0_2_2_1_9_2 - 8.333333333333311e-03*G4_0_2_2_1_10_2 - 4.166666666666656e-03*G4_0_2_2_1_11_2 - 4.166666666666654e-03*G4_0_2_2_2_8_2 - 4.166666666666656e-03*G4_0_2_2_2_9_2 - 8.333333333333312e-03*G4_0_2_2_2_10_2 - 4.166666666666657e-03*G4_0_2_2_2_11_2 - 4.166666666666656e-03*G4_0_2_3_0_8_2 - 4.166666666666656e-03*G4_0_2_3_0_9_2 - 4.166666666666655e-03*G4_0_2_3_0_10_2 - 8.333333333333311e-03*G4_0_2_3_0_11_2 - 4.166666666666657e-03*G4_0_2_3_1_8_2 - 4.166666666666657e-03*G4_0_2_3_1_9_2 - 4.166666666666656e-03*G4_0_2_3_1_10_2 - 8.333333333333311e-03*G4_0_2_3_1_11_2 - 4.166666666666657e-03*G4_0_2_3_2_8_2 - 4.166666666666657e-03*G4_0_2_3_2_9_2 - 4.166666666666657e-03*G4_0_2_3_2_10_2 - 8.333333333333312e-03*G4_0_2_3_2_11_2 - 8.333333333333309e-03*G4_1_0_4_0_0_2 - 4.166666666666654e-03*G4_1_0_4_0_1_2 - 4.166666666666654e-03*G4_1_0_4_0_2_2 - 4.166666666666656e-03*G4_1_0_4_0_3_2 - 8.333333333333311e-03*G4_1_0_4_1_0_2 - 4.166666666666654e-03*G4_1_0_4_1_1_2 - 4.166666666666654e-03*G4_1_0_4_1_2_2 - 4.166666666666657e-03*G4_1_0_4_1_3_2 - 8.333333333333312e-03*G4_1_0_4_2_0_2 - 4.166666666666654e-03*G4_1_0_4_2_1_2 - 4.166666666666654e-03*G4_1_0_4_2_2_2 - 4.166666666666657e-03*G4_1_0_4_2_3_2 - 4.166666666666655e-03*G4_1_0_5_0_0_2 - 8.333333333333309e-03*G4_1_0_5_0_1_2 - 4.166666666666655e-03*G4_1_0_5_0_2_2 - 4.166666666666656e-03*G4_1_0_5_0_3_2 - 4.166666666666655e-03*G4_1_0_5_1_0_2 - 8.333333333333309e-03*G4_1_0_5_1_1_2 - 4.166666666666656e-03*G4_1_0_5_1_2_2 - 4.166666666666657e-03*G4_1_0_5_1_3_2 - 4.166666666666656e-03*G4_1_0_5_2_0_2 - 8.333333333333309e-03*G4_1_0_5_2_1_2 - 4.166666666666656e-03*G4_1_0_5_2_2_2 - 4.166666666666657e-03*G4_1_0_5_2_3_2 - 4.166666666666654e-03*G4_1_0_6_0_0_2 - 4.166666666666654e-03*G4_1_0_6_0_1_2 - 8.333333333333309e-03*G4_1_0_6_0_2_2 - 4.166666666666655e-03*G4_1_0_6_0_3_2 - 4.166666666666656e-03*G4_1_0_6_1_0_2 - 4.166666666666654e-03*G4_1_0_6_1_1_2 - 8.333333333333311e-03*G4_1_0_6_1_2_2 - 4.166666666666656e-03*G4_1_0_6_1_3_2 - 4.166666666666656e-03*G4_1_0_6_2_0_2 - 4.166666666666654e-03*G4_1_0_6_2_1_2 - 8.333333333333312e-03*G4_1_0_6_2_2_2 - 4.166666666666657e-03*G4_1_0_6_2_3_2 - 4.166666666666656e-03*G4_1_0_7_0_0_2 - 4.166666666666655e-03*G4_1_0_7_0_1_2 - 4.166666666666655e-03*G4_1_0_7_0_2_2 - 8.333333333333311e-03*G4_1_0_7_0_3_2 - 4.166666666666657e-03*G4_1_0_7_1_0_2 - 4.166666666666655e-03*G4_1_0_7_1_1_2 - 4.166666666666656e-03*G4_1_0_7_1_2_2 - 8.333333333333311e-03*G4_1_0_7_1_3_2 - 4.166666666666658e-03*G4_1_0_7_2_0_2 - 4.166666666666656e-03*G4_1_0_7_2_1_2 - 4.166666666666657e-03*G4_1_0_7_2_2_2 - 8.333333333333312e-03*G4_1_0_7_2_3_2 - 8.333333333333309e-03*G4_1_1_4_0_4_2 - 4.166666666666654e-03*G4_1_1_4_0_5_2 - 4.166666666666654e-03*G4_1_1_4_0_6_2 - 4.166666666666656e-03*G4_1_1_4_0_7_2 - 8.333333333333311e-03*G4_1_1_4_1_4_2 - 4.166666666666654e-03*G4_1_1_4_1_5_2 - 4.166666666666654e-03*G4_1_1_4_1_6_2 - 4.166666666666657e-03*G4_1_1_4_1_7_2 - 8.333333333333312e-03*G4_1_1_4_2_4_2 - 4.166666666666655e-03*G4_1_1_4_2_5_2 - 4.166666666666654e-03*G4_1_1_4_2_6_2 - 4.166666666666657e-03*G4_1_1_4_2_7_2 - 4.166666666666654e-03*G4_1_1_5_0_4_2 - 8.333333333333309e-03*G4_1_1_5_0_5_2 - 4.166666666666655e-03*G4_1_1_5_0_6_2 - 4.166666666666656e-03*G4_1_1_5_0_7_2 - 4.166666666666654e-03*G4_1_1_5_1_4_2 - 8.333333333333309e-03*G4_1_1_5_1_5_2 - 4.166666666666656e-03*G4_1_1_5_1_6_2 - 4.166666666666657e-03*G4_1_1_5_1_7_2 - 4.166666666666655e-03*G4_1_1_5_2_4_2 - 8.333333333333309e-03*G4_1_1_5_2_5_2 - 4.166666666666656e-03*G4_1_1_5_2_6_2 - 4.166666666666657e-03*G4_1_1_5_2_7_2 - 4.166666666666654e-03*G4_1_1_6_0_4_2 - 4.166666666666655e-03*G4_1_1_6_0_5_2 - 8.333333333333309e-03*G4_1_1_6_0_6_2 - 4.166666666666655e-03*G4_1_1_6_0_7_2 - 4.166666666666654e-03*G4_1_1_6_1_4_2 - 4.166666666666656e-03*G4_1_1_6_1_5_2 - 8.333333333333311e-03*G4_1_1_6_1_6_2 - 4.166666666666656e-03*G4_1_1_6_1_7_2 - 4.166666666666654e-03*G4_1_1_6_2_4_2 - 4.166666666666656e-03*G4_1_1_6_2_5_2 - 8.333333333333312e-03*G4_1_1_6_2_6_2 - 4.166666666666657e-03*G4_1_1_6_2_7_2 - 4.166666666666656e-03*G4_1_1_7_0_4_2 - 4.166666666666656e-03*G4_1_1_7_0_5_2 - 4.166666666666655e-03*G4_1_1_7_0_6_2 - 8.333333333333311e-03*G4_1_1_7_0_7_2 - 4.166666666666657e-03*G4_1_1_7_1_4_2 - 4.166666666666657e-03*G4_1_1_7_1_5_2 - 4.166666666666656e-03*G4_1_1_7_1_6_2 - 8.333333333333311e-03*G4_1_1_7_1_7_2 - 4.166666666666657e-03*G4_1_1_7_2_4_2 - 4.166666666666657e-03*G4_1_1_7_2_5_2 - 4.166666666666657e-03*G4_1_1_7_2_6_2 - 8.333333333333312e-03*G4_1_1_7_2_7_2 - 8.333333333333309e-03*G4_1_2_4_0_8_2 - 4.166666666666654e-03*G4_1_2_4_0_9_2 - 4.166666666666654e-03*G4_1_2_4_0_10_2 - 4.166666666666656e-03*G4_1_2_4_0_11_2 - 8.333333333333311e-03*G4_1_2_4_1_8_2 - 4.166666666666654e-03*G4_1_2_4_1_9_2 - 4.166666666666654e-03*G4_1_2_4_1_10_2 - 4.166666666666657e-03*G4_1_2_4_1_11_2 - 8.333333333333312e-03*G4_1_2_4_2_8_2 - 4.166666666666655e-03*G4_1_2_4_2_9_2 - 4.166666666666654e-03*G4_1_2_4_2_10_2 - 4.166666666666657e-03*G4_1_2_4_2_11_2 - 4.166666666666654e-03*G4_1_2_5_0_8_2 - 8.333333333333309e-03*G4_1_2_5_0_9_2 - 4.166666666666655e-03*G4_1_2_5_0_10_2 - 4.166666666666656e-03*G4_1_2_5_0_11_2 - 4.166666666666654e-03*G4_1_2_5_1_8_2 - 8.333333333333309e-03*G4_1_2_5_1_9_2 - 4.166666666666656e-03*G4_1_2_5_1_10_2 - 4.166666666666657e-03*G4_1_2_5_1_11_2 - 4.166666666666655e-03*G4_1_2_5_2_8_2 - 8.333333333333309e-03*G4_1_2_5_2_9_2 - 4.166666666666656e-03*G4_1_2_5_2_10_2 - 4.166666666666657e-03*G4_1_2_5_2_11_2 - 4.166666666666654e-03*G4_1_2_6_0_8_2 - 4.166666666666655e-03*G4_1_2_6_0_9_2 - 8.333333333333309e-03*G4_1_2_6_0_10_2 - 4.166666666666655e-03*G4_1_2_6_0_11_2 - 4.166666666666654e-03*G4_1_2_6_1_8_2 - 4.166666666666656e-03*G4_1_2_6_1_9_2 - 8.333333333333311e-03*G4_1_2_6_1_10_2 - 4.166666666666656e-03*G4_1_2_6_1_11_2 - 4.166666666666654e-03*G4_1_2_6_2_8_2 - 4.166666666666656e-03*G4_1_2_6_2_9_2 - 8.333333333333312e-03*G4_1_2_6_2_10_2 - 4.166666666666657e-03*G4_1_2_6_2_11_2 - 4.166666666666656e-03*G4_1_2_7_0_8_2 - 4.166666666666656e-03*G4_1_2_7_0_9_2 - 4.166666666666655e-03*G4_1_2_7_0_10_2 - 8.333333333333311e-03*G4_1_2_7_0_11_2 - 4.166666666666657e-03*G4_1_2_7_1_8_2 - 4.166666666666657e-03*G4_1_2_7_1_9_2 - 4.166666666666656e-03*G4_1_2_7_1_10_2 - 8.333333333333311e-03*G4_1_2_7_1_11_2 - 4.166666666666657e-03*G4_1_2_7_2_8_2 - 4.166666666666657e-03*G4_1_2_7_2_9_2 - 4.166666666666657e-03*G4_1_2_7_2_10_2 - 8.333333333333312e-03*G4_1_2_7_2_11_2 - 8.333333333333309e-03*G4_2_0_8_0_0_2 - 4.166666666666654e-03*G4_2_0_8_0_1_2 - 4.166666666666654e-03*G4_2_0_8_0_2_2 - 4.166666666666656e-03*G4_2_0_8_0_3_2 - 8.333333333333311e-03*G4_2_0_8_1_0_2 - 4.166666666666654e-03*G4_2_0_8_1_1_2 - 4.166666666666654e-03*G4_2_0_8_1_2_2 - 4.166666666666657e-03*G4_2_0_8_1_3_2 - 8.333333333333312e-03*G4_2_0_8_2_0_2 - 4.166666666666654e-03*G4_2_0_8_2_1_2 - 4.166666666666654e-03*G4_2_0_8_2_2_2 - 4.166666666666657e-03*G4_2_0_8_2_3_2 - 4.166666666666655e-03*G4_2_0_9_0_0_2 - 8.333333333333309e-03*G4_2_0_9_0_1_2 - 4.166666666666655e-03*G4_2_0_9_0_2_2 - 4.166666666666656e-03*G4_2_0_9_0_3_2 - 4.166666666666655e-03*G4_2_0_9_1_0_2 - 8.333333333333309e-03*G4_2_0_9_1_1_2 - 4.166666666666656e-03*G4_2_0_9_1_2_2 - 4.166666666666657e-03*G4_2_0_9_1_3_2 - 4.166666666666656e-03*G4_2_0_9_2_0_2 - 8.333333333333309e-03*G4_2_0_9_2_1_2 - 4.166666666666656e-03*G4_2_0_9_2_2_2 - 4.166666666666657e-03*G4_2_0_9_2_3_2 - 4.166666666666654e-03*G4_2_0_10_0_0_2 - 4.166666666666654e-03*G4_2_0_10_0_1_2 - 8.333333333333309e-03*G4_2_0_10_0_2_2 - 4.166666666666655e-03*G4_2_0_10_0_3_2 - 4.166666666666656e-03*G4_2_0_10_1_0_2 - 4.166666666666654e-03*G4_2_0_10_1_1_2 - 8.333333333333311e-03*G4_2_0_10_1_2_2 - 4.166666666666656e-03*G4_2_0_10_1_3_2 - 4.166666666666656e-03*G4_2_0_10_2_0_2 - 4.166666666666654e-03*G4_2_0_10_2_1_2 - 8.333333333333312e-03*G4_2_0_10_2_2_2 - 4.166666666666657e-03*G4_2_0_10_2_3_2 - 4.166666666666656e-03*G4_2_0_11_0_0_2 - 4.166666666666655e-03*G4_2_0_11_0_1_2 - 4.166666666666655e-03*G4_2_0_11_0_2_2 - 8.333333333333311e-03*G4_2_0_11_0_3_2 - 4.166666666666657e-03*G4_2_0_11_1_0_2 - 4.166666666666655e-03*G4_2_0_11_1_1_2 - 4.166666666666656e-03*G4_2_0_11_1_2_2 - 8.333333333333311e-03*G4_2_0_11_1_3_2 - 4.166666666666658e-03*G4_2_0_11_2_0_2 - 4.166666666666656e-03*G4_2_0_11_2_1_2 - 4.166666666666657e-03*G4_2_0_11_2_2_2 - 8.333333333333312e-03*G4_2_0_11_2_3_2 - 8.333333333333309e-03*G4_2_1_8_0_4_2 - 4.166666666666654e-03*G4_2_1_8_0_5_2 - 4.166666666666654e-03*G4_2_1_8_0_6_2 - 4.166666666666656e-03*G4_2_1_8_0_7_2 - 8.333333333333311e-03*G4_2_1_8_1_4_2 - 4.166666666666654e-03*G4_2_1_8_1_5_2 - 4.166666666666654e-03*G4_2_1_8_1_6_2 - 4.166666666666657e-03*G4_2_1_8_1_7_2 - 8.333333333333312e-03*G4_2_1_8_2_4_2 - 4.166666666666655e-03*G4_2_1_8_2_5_2 - 4.166666666666654e-03*G4_2_1_8_2_6_2 - 4.166666666666657e-03*G4_2_1_8_2_7_2 - 4.166666666666654e-03*G4_2_1_9_0_4_2 - 8.333333333333309e-03*G4_2_1_9_0_5_2 - 4.166666666666655e-03*G4_2_1_9_0_6_2 - 4.166666666666656e-03*G4_2_1_9_0_7_2 - 4.166666666666654e-03*G4_2_1_9_1_4_2 - 8.333333333333309e-03*G4_2_1_9_1_5_2 - 4.166666666666656e-03*G4_2_1_9_1_6_2 - 4.166666666666657e-03*G4_2_1_9_1_7_2 - 4.166666666666655e-03*G4_2_1_9_2_4_2 - 8.333333333333309e-03*G4_2_1_9_2_5_2 - 4.166666666666656e-03*G4_2_1_9_2_6_2 - 4.166666666666657e-03*G4_2_1_9_2_7_2 - 4.166666666666654e-03*G4_2_1_10_0_4_2 - 4.166666666666655e-03*G4_2_1_10_0_5_2 - 8.333333333333309e-03*G4_2_1_10_0_6_2 - 4.166666666666655e-03*G4_2_1_10_0_7_2 - 4.166666666666654e-03*G4_2_1_10_1_4_2 - 4.166666666666656e-03*G4_2_1_10_1_5_2 - 8.333333333333311e-03*G4_2_1_10_1_6_2 - 4.166666666666656e-03*G4_2_1_10_1_7_2 - 4.166666666666654e-03*G4_2_1_10_2_4_2 - 4.166666666666656e-03*G4_2_1_10_2_5_2 - 8.333333333333312e-03*G4_2_1_10_2_6_2 - 4.166666666666657e-03*G4_2_1_10_2_7_2 - 4.166666666666656e-03*G4_2_1_11_0_4_2 - 4.166666666666656e-03*G4_2_1_11_0_5_2 - 4.166666666666655e-03*G4_2_1_11_0_6_2 - 8.333333333333311e-03*G4_2_1_11_0_7_2 - 4.166666666666657e-03*G4_2_1_11_1_4_2 - 4.166666666666657e-03*G4_2_1_11_1_5_2 - 4.166666666666656e-03*G4_2_1_11_1_6_2 - 8.333333333333311e-03*G4_2_1_11_1_7_2 - 4.166666666666657e-03*G4_2_1_11_2_4_2 - 4.166666666666657e-03*G4_2_1_11_2_5_2 - 4.166666666666657e-03*G4_2_1_11_2_6_2 - 8.333333333333312e-03*G4_2_1_11_2_7_2 - 8.333333333333309e-03*G4_2_2_8_0_8_2 - 4.166666666666654e-03*G4_2_2_8_0_9_2 - 4.166666666666654e-03*G4_2_2_8_0_10_2 - 4.166666666666656e-03*G4_2_2_8_0_11_2 - 8.333333333333311e-03*G4_2_2_8_1_8_2 - 4.166666666666654e-03*G4_2_2_8_1_9_2 - 4.166666666666654e-03*G4_2_2_8_1_10_2 - 4.166666666666657e-03*G4_2_2_8_1_11_2 - 8.333333333333312e-03*G4_2_2_8_2_8_2 - 4.166666666666655e-03*G4_2_2_8_2_9_2 - 4.166666666666654e-03*G4_2_2_8_2_10_2 - 4.166666666666657e-03*G4_2_2_8_2_11_2 - 4.166666666666654e-03*G4_2_2_9_0_8_2 - 8.333333333333309e-03*G4_2_2_9_0_9_2 - 4.166666666666655e-03*G4_2_2_9_0_10_2 - 4.166666666666656e-03*G4_2_2_9_0_11_2 - 4.166666666666654e-03*G4_2_2_9_1_8_2 - 8.333333333333309e-03*G4_2_2_9_1_9_2 - 4.166666666666656e-03*G4_2_2_9_1_10_2 - 4.166666666666657e-03*G4_2_2_9_1_11_2 - 4.166666666666655e-03*G4_2_2_9_2_8_2 - 8.333333333333309e-03*G4_2_2_9_2_9_2 - 4.166666666666656e-03*G4_2_2_9_2_10_2 - 4.166666666666657e-03*G4_2_2_9_2_11_2 - 4.166666666666654e-03*G4_2_2_10_0_8_2 - 4.166666666666655e-03*G4_2_2_10_0_9_2 - 8.333333333333309e-03*G4_2_2_10_0_10_2 - 4.166666666666655e-03*G4_2_2_10_0_11_2 - 4.166666666666654e-03*G4_2_2_10_1_8_2 - 4.166666666666656e-03*G4_2_2_10_1_9_2 - 8.333333333333311e-03*G4_2_2_10_1_10_2 - 4.166666666666656e-03*G4_2_2_10_1_11_2 - 4.166666666666654e-03*G4_2_2_10_2_8_2 - 4.166666666666656e-03*G4_2_2_10_2_9_2 - 8.333333333333312e-03*G4_2_2_10_2_10_2 - 4.166666666666657e-03*G4_2_2_10_2_11_2 - 4.166666666666656e-03*G4_2_2_11_0_8_2 - 4.166666666666656e-03*G4_2_2_11_0_9_2 - 4.166666666666655e-03*G4_2_2_11_0_10_2 - 8.333333333333311e-03*G4_2_2_11_0_11_2 - 4.166666666666657e-03*G4_2_2_11_1_8_2 - 4.166666666666657e-03*G4_2_2_11_1_9_2 - 4.166666666666656e-03*G4_2_2_11_1_10_2 - 8.333333333333311e-03*G4_2_2_11_1_11_2 - 4.166666666666657e-03*G4_2_2_11_2_8_2 - 4.166666666666657e-03*G4_2_2_11_2_9_2 - 4.166666666666657e-03*G4_2_2_11_2_10_2 - 8.333333333333312e-03*G4_2_2_11_2_11_2;
    block[56] = 8.333333333333320e-02*G3_1_2_0_0 + 8.333333333333322e-02*G3_1_2_0_1 + 8.333333333333322e-02*G3_1_2_0_2 + 8.333333333333322e-02*G3_1_2_1_0 + 8.333333333333323e-02*G3_1_2_1_1 + 8.333333333333323e-02*G3_1_2_1_2 + 8.333333333333322e-02*G3_1_2_2_0 + 8.333333333333323e-02*G3_1_2_2_1 + 8.333333333333323e-02*G3_1_2_2_2;
    block[57] = -8.333333333333320e-02*G3_1_2_0_0 - 8.333333333333322e-02*G3_1_2_1_0 - 8.333333333333322e-02*G3_1_2_2_0;
    block[58] = -8.333333333333322e-02*G3_1_2_0_1 - 8.333333333333323e-02*G3_1_2_1_1 - 8.333333333333323e-02*G3_1_2_2_1;
    block[59] = -8.333333333333322e-02*G3_1_2_0_2 - 8.333333333333323e-02*G3_1_2_1_2 - 8.333333333333323e-02*G3_1_2_2_2;
    block[60] = -8.333333333333320e-02*G3_1_0_0_0 - 8.333333333333322e-02*G3_1_0_0_1 - 8.333333333333320e-02*G3_1_0_0_2;
    block[61] = 8.333333333333320e-02*G3_1_0_0_0;
    block[62] = 8.333333333333322e-02*G3_1_0_0_1;
    block[63] = 8.333333333333322e-02*G3_1_0_0_2;
    block[64] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_0_1 - 8.333333333333322e-02*G1_0_2 - 4.166666666666655e-03*G2_0_0_0 - 4.166666666666655e-03*G2_0_0_1 - 4.166666666666656e-03*G2_0_0_2 - 8.333333333333309e-03*G2_0_1_0 - 8.333333333333309e-03*G2_0_1_1 - 8.333333333333309e-03*G2_0_1_2 - 4.166666666666655e-03*G2_0_2_0 - 4.166666666666656e-03*G2_0_2_1 - 4.166666666666656e-03*G2_0_2_2 - 4.166666666666656e-03*G2_0_3_0 - 4.166666666666657e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 4.166666666666654e-03*G2_1_4_0 - 4.166666666666654e-03*G2_1_4_1 - 4.166666666666655e-03*G2_1_4_2 - 8.333333333333309e-03*G2_1_5_0 - 8.333333333333309e-03*G2_1_5_1 - 8.333333333333309e-03*G2_1_5_2 - 4.166666666666655e-03*G2_1_6_0 - 4.166666666666656e-03*G2_1_6_1 - 4.166666666666656e-03*G2_1_6_2 - 4.166666666666656e-03*G2_1_7_0 - 4.166666666666657e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 4.166666666666654e-03*G2_2_8_0 - 4.166666666666654e-03*G2_2_8_1 - 4.166666666666655e-03*G2_2_8_2 - 8.333333333333309e-03*G2_2_9_0 - 8.333333333333309e-03*G2_2_9_1 - 8.333333333333309e-03*G2_2_9_2 - 4.166666666666655e-03*G2_2_10_0 - 4.166666666666656e-03*G2_2_10_1 - 4.166666666666656e-03*G2_2_10_2 - 4.166666666666656e-03*G2_2_11_0 - 4.166666666666657e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 - 8.333333333333320e-02*G3_1_1_0_0 - 8.333333333333322e-02*G3_1_1_0_1 - 8.333333333333322e-02*G3_1_1_0_2 - 8.333333333333309e-03*G4_0_0_0_0_0_0 - 8.333333333333309e-03*G4_0_0_0_0_0_1 - 8.333333333333312e-03*G4_0_0_0_0_0_2 - 4.166666666666654e-03*G4_0_0_0_0_1_0 - 4.166666666666654e-03*G4_0_0_0_0_1_1 - 4.166666666666655e-03*G4_0_0_0_0_1_2 - 4.166666666666654e-03*G4_0_0_0_0_2_0 - 4.166666666666654e-03*G4_0_0_0_0_2_1 - 4.166666666666656e-03*G4_0_0_0_0_2_2 - 4.166666666666656e-03*G4_0_0_0_0_3_0 - 4.166666666666656e-03*G4_0_0_0_0_3_1 - 4.166666666666657e-03*G4_0_0_0_0_3_2 - 4.166666666666654e-03*G4_0_0_1_0_0_0 - 4.166666666666654e-03*G4_0_0_1_0_0_1 - 4.166666666666655e-03*G4_0_0_1_0_0_2 - 8.333333333333307e-03*G4_0_0_1_0_1_0 - 8.333333333333307e-03*G4_0_0_1_0_1_1 - 8.333333333333307e-03*G4_0_0_1_0_1_2 - 4.166666666666654e-03*G4_0_0_1_0_2_0 - 4.166666666666654e-03*G4_0_0_1_0_2_1 - 4.166666666666654e-03*G4_0_0_1_0_2_2 - 4.166666666666654e-03*G4_0_0_1_0_3_0 - 4.166666666666655e-03*G4_0_0_1_0_3_1 - 4.166666666666655e-03*G4_0_0_1_0_3_2 - 4.166666666666654e-03*G4_0_0_2_0_0_0 - 4.166666666666654e-03*G4_0_0_2_0_0_1 - 4.166666666666655e-03*G4_0_0_2_0_0_2 - 4.166666666666654e-03*G4_0_0_2_0_1_0 - 4.166666666666654e-03*G4_0_0_2_0_1_1 - 4.166666666666654e-03*G4_0_0_2_0_1_2 - 8.333333333333309e-03*G4_0_0_2_0_2_0 - 8.333333333333309e-03*G4_0_0_2_0_2_1 - 8.333333333333311e-03*G4_0_0_2_0_2_2 - 4.166666666666654e-03*G4_0_0_2_0_3_0 - 4.166666666666655e-03*G4_0_0_2_0_3_1 - 4.166666666666655e-03*G4_0_0_2_0_3_2 - 4.166666666666656e-03*G4_0_0_3_0_0_0 - 4.166666666666656e-03*G4_0_0_3_0_0_1 - 4.166666666666657e-03*G4_0_0_3_0_0_2 - 4.166666666666654e-03*G4_0_0_3_0_1_0 - 4.166666666666655e-03*G4_0_0_3_0_1_1 - 4.166666666666655e-03*G4_0_0_3_0_1_2 - 4.166666666666655e-03*G4_0_0_3_0_2_0 - 4.166666666666655e-03*G4_0_0_3_0_2_1 - 4.166666666666655e-03*G4_0_0_3_0_2_2 - 8.333333333333309e-03*G4_0_0_3_0_3_0 - 8.333333333333311e-03*G4_0_0_3_0_3_1 - 8.333333333333311e-03*G4_0_0_3_0_3_2 - 8.333333333333309e-03*G4_0_1_0_0_4_0 - 8.333333333333309e-03*G4_0_1_0_0_4_1 - 8.333333333333311e-03*G4_0_1_0_0_4_2 - 4.166666666666654e-03*G4_0_1_0_0_5_0 - 4.166666666666655e-03*G4_0_1_0_0_5_1 - 4.166666666666655e-03*G4_0_1_0_0_5_2 - 4.166666666666654e-03*G4_0_1_0_0_6_0 - 4.166666666666654e-03*G4_0_1_0_0_6_1 - 4.166666666666656e-03*G4_0_1_0_0_6_2 - 4.166666666666656e-03*G4_0_1_0_0_7_0 - 4.166666666666656e-03*G4_0_1_0_0_7_1 - 4.166666666666657e-03*G4_0_1_0_0_7_2 - 4.166666666666654e-03*G4_0_1_1_0_4_0 - 4.166666666666654e-03*G4_0_1_1_0_4_1 - 4.166666666666654e-03*G4_0_1_1_0_4_2 - 8.333333333333307e-03*G4_0_1_1_0_5_0 - 8.333333333333309e-03*G4_0_1_1_0_5_1 - 8.333333333333309e-03*G4_0_1_1_0_5_2 - 4.166666666666654e-03*G4_0_1_1_0_6_0 - 4.166666666666654e-03*G4_0_1_1_0_6_1 - 4.166666666666654e-03*G4_0_1_1_0_6_2 - 4.166666666666654e-03*G4_0_1_1_0_7_0 - 4.166666666666655e-03*G4_0_1_1_0_7_1 - 4.166666666666655e-03*G4_0_1_1_0_7_2 - 4.166666666666653e-03*G4_0_1_2_0_4_0 - 4.166666666666654e-03*G4_0_1_2_0_4_1 - 4.166666666666654e-03*G4_0_1_2_0_4_2 - 4.166666666666654e-03*G4_0_1_2_0_5_0 - 4.166666666666655e-03*G4_0_1_2_0_5_1 - 4.166666666666655e-03*G4_0_1_2_0_5_2 - 8.333333333333309e-03*G4_0_1_2_0_6_0 - 8.333333333333309e-03*G4_0_1_2_0_6_1 - 8.333333333333311e-03*G4_0_1_2_0_6_2 - 4.166666666666654e-03*G4_0_1_2_0_7_0 - 4.166666666666655e-03*G4_0_1_2_0_7_1 - 4.166666666666655e-03*G4_0_1_2_0_7_2 - 4.166666666666655e-03*G4_0_1_3_0_4_0 - 4.166666666666656e-03*G4_0_1_3_0_4_1 - 4.166666666666657e-03*G4_0_1_3_0_4_2 - 4.166666666666655e-03*G4_0_1_3_0_5_0 - 4.166666666666656e-03*G4_0_1_3_0_5_1 - 4.166666666666656e-03*G4_0_1_3_0_5_2 - 4.166666666666655e-03*G4_0_1_3_0_6_0 - 4.166666666666655e-03*G4_0_1_3_0_6_1 - 4.166666666666655e-03*G4_0_1_3_0_6_2 - 8.333333333333309e-03*G4_0_1_3_0_7_0 - 8.333333333333311e-03*G4_0_1_3_0_7_1 - 8.333333333333311e-03*G4_0_1_3_0_7_2 - 8.333333333333309e-03*G4_0_2_0_0_8_0 - 8.333333333333309e-03*G4_0_2_0_0_8_1 - 8.333333333333311e-03*G4_0_2_0_0_8_2 - 4.166666666666654e-03*G4_0_2_0_0_9_0 - 4.166666666666655e-03*G4_0_2_0_0_9_1 - 4.166666666666655e-03*G4_0_2_0_0_9_2 - 4.166666666666654e-03*G4_0_2_0_0_10_0 - 4.166666666666654e-03*G4_0_2_0_0_10_1 - 4.166666666666656e-03*G4_0_2_0_0_10_2 - 4.166666666666656e-03*G4_0_2_0_0_11_0 - 4.166666666666656e-03*G4_0_2_0_0_11_1 - 4.166666666666657e-03*G4_0_2_0_0_11_2 - 4.166666666666654e-03*G4_0_2_1_0_8_0 - 4.166666666666654e-03*G4_0_2_1_0_8_1 - 4.166666666666654e-03*G4_0_2_1_0_8_2 - 8.333333333333307e-03*G4_0_2_1_0_9_0 - 8.333333333333309e-03*G4_0_2_1_0_9_1 - 8.333333333333309e-03*G4_0_2_1_0_9_2 - 4.166666666666654e-03*G4_0_2_1_0_10_0 - 4.166666666666654e-03*G4_0_2_1_0_10_1 - 4.166666666666654e-03*G4_0_2_1_0_10_2 - 4.166666666666654e-03*G4_0_2_1_0_11_0 - 4.166666666666655e-03*G4_0_2_1_0_11_1 - 4.166666666666655e-03*G4_0_2_1_0_11_2 - 4.166666666666653e-03*G4_0_2_2_0_8_0 - 4.166666666666654e-03*G4_0_2_2_0_8_1 - 4.166666666666654e-03*G4_0_2_2_0_8_2 - 4.166666666666654e-03*G4_0_2_2_0_9_0 - 4.166666666666655e-03*G4_0_2_2_0_9_1 - 4.166666666666655e-03*G4_0_2_2_0_9_2 - 8.333333333333309e-03*G4_0_2_2_0_10_0 - 8.333333333333309e-03*G4_0_2_2_0_10_1 - 8.333333333333311e-03*G4_0_2_2_0_10_2 - 4.166666666666654e-03*G4_0_2_2_0_11_0 - 4.166666666666655e-03*G4_0_2_2_0_11_1 - 4.166666666666655e-03*G4_0_2_2_0_11_2 - 4.166666666666655e-03*G4_0_2_3_0_8_0 - 4.166666666666656e-03*G4_0_2_3_0_8_1 - 4.166666666666657e-03*G4_0_2_3_0_8_2 - 4.166666666666655e-03*G4_0_2_3_0_9_0 - 4.166666666666656e-03*G4_0_2_3_0_9_1 - 4.166666666666656e-03*G4_0_2_3_0_9_2 - 4.166666666666655e-03*G4_0_2_3_0_10_0 - 4.166666666666655e-03*G4_0_2_3_0_10_1 - 4.166666666666655e-03*G4_0_2_3_0_10_2 - 8.333333333333309e-03*G4_0_2_3_0_11_0 - 8.333333333333311e-03*G4_0_2_3_0_11_1 - 8.333333333333311e-03*G4_0_2_3_0_11_2 - 8.333333333333309e-03*G4_1_0_4_0_0_0 - 8.333333333333309e-03*G4_1_0_4_0_0_1 - 8.333333333333311e-03*G4_1_0_4_0_0_2 - 4.166666666666654e-03*G4_1_0_4_0_1_0 - 4.166666666666654e-03*G4_1_0_4_0_1_1 - 4.166666666666654e-03*G4_1_0_4_0_1_2 - 4.166666666666653e-03*G4_1_0_4_0_2_0 - 4.166666666666654e-03*G4_1_0_4_0_2_1 - 4.166666666666654e-03*G4_1_0_4_0_2_2 - 4.166666666666654e-03*G4_1_0_4_0_3_0 - 4.166666666666656e-03*G4_1_0_4_0_3_1 - 4.166666666666657e-03*G4_1_0_4_0_3_2 - 4.166666666666654e-03*G4_1_0_5_0_0_0 - 4.166666666666655e-03*G4_1_0_5_0_0_1 - 4.166666666666655e-03*G4_1_0_5_0_0_2 - 8.333333333333307e-03*G4_1_0_5_0_1_0 - 8.333333333333309e-03*G4_1_0_5_0_1_1 - 8.333333333333309e-03*G4_1_0_5_0_1_2 - 4.166666666666654e-03*G4_1_0_5_0_2_0 - 4.166666666666655e-03*G4_1_0_5_0_2_1 - 4.166666666666655e-03*G4_1_0_5_0_2_2 - 4.166666666666655e-03*G4_1_0_5_0_3_0 - 4.166666666666656e-03*G4_1_0_5_0_3_1 - 4.166666666666656e-03*G4_1_0_5_0_3_2 - 4.166666666666654e-03*G4_1_0_6_0_0_0 - 4.166666666666654e-03*G4_1_0_6_0_0_1 - 4.166666666666655e-03*G4_1_0_6_0_0_2 - 4.166666666666654e-03*G4_1_0_6_0_1_0 - 4.166666666666654e-03*G4_1_0_6_0_1_1 - 4.166666666666654e-03*G4_1_0_6_0_1_2 - 8.333333333333309e-03*G4_1_0_6_0_2_0 - 8.333333333333309e-03*G4_1_0_6_0_2_1 - 8.333333333333311e-03*G4_1_0_6_0_2_2 - 4.166666666666654e-03*G4_1_0_6_0_3_0 - 4.166666666666655e-03*G4_1_0_6_0_3_1 - 4.166666666666655e-03*G4_1_0_6_0_3_2 - 4.166666666666656e-03*G4_1_0_7_0_0_0 - 4.166666666666656e-03*G4_1_0_7_0_0_1 - 4.166666666666657e-03*G4_1_0_7_0_0_2 - 4.166666666666654e-03*G4_1_0_7_0_1_0 - 4.166666666666655e-03*G4_1_0_7_0_1_1 - 4.166666666666655e-03*G4_1_0_7_0_1_2 - 4.166666666666655e-03*G4_1_0_7_0_2_0 - 4.166666666666655e-03*G4_1_0_7_0_2_1 - 4.166666666666655e-03*G4_1_0_7_0_2_2 - 8.333333333333309e-03*G4_1_0_7_0_3_0 - 8.333333333333311e-03*G4_1_0_7_0_3_1 - 8.333333333333311e-03*G4_1_0_7_0_3_2 - 8.333333333333309e-03*G4_1_1_4_0_4_0 - 8.333333333333309e-03*G4_1_1_4_0_4_1 - 8.333333333333311e-03*G4_1_1_4_0_4_2 - 4.166666666666654e-03*G4_1_1_4_0_5_0 - 4.166666666666654e-03*G4_1_1_4_0_5_1 - 4.166666666666654e-03*G4_1_1_4_0_5_2 - 4.166666666666653e-03*G4_1_1_4_0_6_0 - 4.166666666666654e-03*G4_1_1_4_0_6_1 - 4.166666666666654e-03*G4_1_1_4_0_6_2 - 4.166666666666654e-03*G4_1_1_4_0_7_0 - 4.166666666666656e-03*G4_1_1_4_0_7_1 - 4.166666666666657e-03*G4_1_1_4_0_7_2 - 4.166666666666654e-03*G4_1_1_5_0_4_0 - 4.166666666666654e-03*G4_1_1_5_0_4_1 - 4.166666666666654e-03*G4_1_1_5_0_4_2 - 8.333333333333307e-03*G4_1_1_5_0_5_0 - 8.333333333333309e-03*G4_1_1_5_0_5_1 - 8.333333333333309e-03*G4_1_1_5_0_5_2 - 4.166666666666654e-03*G4_1_1_5_0_6_0 - 4.166666666666655e-03*G4_1_1_5_0_6_1 - 4.166666666666655e-03*G4_1_1_5_0_6_2 - 4.166666666666655e-03*G4_1_1_5_0_7_0 - 4.166666666666656e-03*G4_1_1_5_0_7_1 - 4.166666666666656e-03*G4_1_1_5_0_7_2 - 4.166666666666653e-03*G4_1_1_6_0_4_0 - 4.166666666666654e-03*G4_1_1_6_0_4_1 - 4.166666666666654e-03*G4_1_1_6_0_4_2 - 4.166666666666654e-03*G4_1_1_6_0_5_0 - 4.166666666666655e-03*G4_1_1_6_0_5_1 - 4.166666666666655e-03*G4_1_1_6_0_5_2 - 8.333333333333309e-03*G4_1_1_6_0_6_0 - 8.333333333333309e-03*G4_1_1_6_0_6_1 - 8.333333333333311e-03*G4_1_1_6_0_6_2 - 4.166666666666654e-03*G4_1_1_6_0_7_0 - 4.166666666666655e-03*G4_1_1_6_0_7_1 - 4.166666666666655e-03*G4_1_1_6_0_7_2 - 4.166666666666655e-03*G4_1_1_7_0_4_0 - 4.166666666666656e-03*G4_1_1_7_0_4_1 - 4.166666666666657e-03*G4_1_1_7_0_4_2 - 4.166666666666655e-03*G4_1_1_7_0_5_0 - 4.166666666666656e-03*G4_1_1_7_0_5_1 - 4.166666666666656e-03*G4_1_1_7_0_5_2 - 4.166666666666655e-03*G4_1_1_7_0_6_0 - 4.166666666666655e-03*G4_1_1_7_0_6_1 - 4.166666666666655e-03*G4_1_1_7_0_6_2 - 8.333333333333309e-03*G4_1_1_7_0_7_0 - 8.333333333333311e-03*G4_1_1_7_0_7_1 - 8.333333333333311e-03*G4_1_1_7_0_7_2 - 8.333333333333309e-03*G4_1_2_4_0_8_0 - 8.333333333333309e-03*G4_1_2_4_0_8_1 - 8.333333333333311e-03*G4_1_2_4_0_8_2 - 4.166666666666654e-03*G4_1_2_4_0_9_0 - 4.166666666666654e-03*G4_1_2_4_0_9_1 - 4.166666666666654e-03*G4_1_2_4_0_9_2 - 4.166666666666653e-03*G4_1_2_4_0_10_0 - 4.166666666666654e-03*G4_1_2_4_0_10_1 - 4.166666666666654e-03*G4_1_2_4_0_10_2 - 4.166666666666654e-03*G4_1_2_4_0_11_0 - 4.166666666666656e-03*G4_1_2_4_0_11_1 - 4.166666666666657e-03*G4_1_2_4_0_11_2 - 4.166666666666654e-03*G4_1_2_5_0_8_0 - 4.166666666666654e-03*G4_1_2_5_0_8_1 - 4.166666666666654e-03*G4_1_2_5_0_8_2 - 8.333333333333307e-03*G4_1_2_5_0_9_0 - 8.333333333333309e-03*G4_1_2_5_0_9_1 - 8.333333333333309e-03*G4_1_2_5_0_9_2 - 4.166666666666654e-03*G4_1_2_5_0_10_0 - 4.166666666666655e-03*G4_1_2_5_0_10_1 - 4.166666666666655e-03*G4_1_2_5_0_10_2 - 4.166666666666655e-03*G4_1_2_5_0_11_0 - 4.166666666666656e-03*G4_1_2_5_0_11_1 - 4.166666666666656e-03*G4_1_2_5_0_11_2 - 4.166666666666653e-03*G4_1_2_6_0_8_0 - 4.166666666666654e-03*G4_1_2_6_0_8_1 - 4.166666666666654e-03*G4_1_2_6_0_8_2 - 4.166666666666654e-03*G4_1_2_6_0_9_0 - 4.166666666666655e-03*G4_1_2_6_0_9_1 - 4.166666666666655e-03*G4_1_2_6_0_9_2 - 8.333333333333309e-03*G4_1_2_6_0_10_0 - 8.333333333333309e-03*G4_1_2_6_0_10_1 - 8.333333333333311e-03*G4_1_2_6_0_10_2 - 4.166666666666654e-03*G4_1_2_6_0_11_0 - 4.166666666666655e-03*G4_1_2_6_0_11_1 - 4.166666666666655e-03*G4_1_2_6_0_11_2 - 4.166666666666655e-03*G4_1_2_7_0_8_0 - 4.166666666666656e-03*G4_1_2_7_0_8_1 - 4.166666666666657e-03*G4_1_2_7_0_8_2 - 4.166666666666655e-03*G4_1_2_7_0_9_0 - 4.166666666666656e-03*G4_1_2_7_0_9_1 - 4.166666666666656e-03*G4_1_2_7_0_9_2 - 4.166666666666655e-03*G4_1_2_7_0_10_0 - 4.166666666666655e-03*G4_1_2_7_0_10_1 - 4.166666666666655e-03*G4_1_2_7_0_10_2 - 8.333333333333309e-03*G4_1_2_7_0_11_0 - 8.333333333333311e-03*G4_1_2_7_0_11_1 - 8.333333333333311e-03*G4_1_2_7_0_11_2 - 8.333333333333309e-03*G4_2_0_8_0_0_0 - 8.333333333333309e-03*G4_2_0_8_0_0_1 - 8.333333333333311e-03*G4_2_0_8_0_0_2 - 4.166666666666654e-03*G4_2_0_8_0_1_0 - 4.166666666666654e-03*G4_2_0_8_0_1_1 - 4.166666666666654e-03*G4_2_0_8_0_1_2 - 4.166666666666653e-03*G4_2_0_8_0_2_0 - 4.166666666666654e-03*G4_2_0_8_0_2_1 - 4.166666666666654e-03*G4_2_0_8_0_2_2 - 4.166666666666654e-03*G4_2_0_8_0_3_0 - 4.166666666666656e-03*G4_2_0_8_0_3_1 - 4.166666666666657e-03*G4_2_0_8_0_3_2 - 4.166666666666654e-03*G4_2_0_9_0_0_0 - 4.166666666666655e-03*G4_2_0_9_0_0_1 - 4.166666666666655e-03*G4_2_0_9_0_0_2 - 8.333333333333307e-03*G4_2_0_9_0_1_0 - 8.333333333333309e-03*G4_2_0_9_0_1_1 - 8.333333333333309e-03*G4_2_0_9_0_1_2 - 4.166666666666654e-03*G4_2_0_9_0_2_0 - 4.166666666666655e-03*G4_2_0_9_0_2_1 - 4.166666666666655e-03*G4_2_0_9_0_2_2 - 4.166666666666655e-03*G4_2_0_9_0_3_0 - 4.166666666666656e-03*G4_2_0_9_0_3_1 - 4.166666666666656e-03*G4_2_0_9_0_3_2 - 4.166666666666654e-03*G4_2_0_10_0_0_0 - 4.166666666666654e-03*G4_2_0_10_0_0_1 - 4.166666666666655e-03*G4_2_0_10_0_0_2 - 4.166666666666654e-03*G4_2_0_10_0_1_0 - 4.166666666666654e-03*G4_2_0_10_0_1_1 - 4.166666666666654e-03*G4_2_0_10_0_1_2 - 8.333333333333309e-03*G4_2_0_10_0_2_0 - 8.333333333333309e-03*G4_2_0_10_0_2_1 - 8.333333333333311e-03*G4_2_0_10_0_2_2 - 4.166666666666654e-03*G4_2_0_10_0_3_0 - 4.166666666666655e-03*G4_2_0_10_0_3_1 - 4.166666666666655e-03*G4_2_0_10_0_3_2 - 4.166666666666656e-03*G4_2_0_11_0_0_0 - 4.166666666666656e-03*G4_2_0_11_0_0_1 - 4.166666666666657e-03*G4_2_0_11_0_0_2 - 4.166666666666654e-03*G4_2_0_11_0_1_0 - 4.166666666666655e-03*G4_2_0_11_0_1_1 - 4.166666666666655e-03*G4_2_0_11_0_1_2 - 4.166666666666655e-03*G4_2_0_11_0_2_0 - 4.166666666666655e-03*G4_2_0_11_0_2_1 - 4.166666666666655e-03*G4_2_0_11_0_2_2 - 8.333333333333309e-03*G4_2_0_11_0_3_0 - 8.333333333333311e-03*G4_2_0_11_0_3_1 - 8.333333333333311e-03*G4_2_0_11_0_3_2 - 8.333333333333309e-03*G4_2_1_8_0_4_0 - 8.333333333333309e-03*G4_2_1_8_0_4_1 - 8.333333333333311e-03*G4_2_1_8_0_4_2 - 4.166666666666654e-03*G4_2_1_8_0_5_0 - 4.166666666666654e-03*G4_2_1_8_0_5_1 - 4.166666666666654e-03*G4_2_1_8_0_5_2 - 4.166666666666653e-03*G4_2_1_8_0_6_0 - 4.166666666666654e-03*G4_2_1_8_0_6_1 - 4.166666666666654e-03*G4_2_1_8_0_6_2 - 4.166666666666654e-03*G4_2_1_8_0_7_0 - 4.166666666666656e-03*G4_2_1_8_0_7_1 - 4.166666666666657e-03*G4_2_1_8_0_7_2 - 4.166666666666654e-03*G4_2_1_9_0_4_0 - 4.166666666666654e-03*G4_2_1_9_0_4_1 - 4.166666666666654e-03*G4_2_1_9_0_4_2 - 8.333333333333307e-03*G4_2_1_9_0_5_0 - 8.333333333333309e-03*G4_2_1_9_0_5_1 - 8.333333333333309e-03*G4_2_1_9_0_5_2 - 4.166666666666654e-03*G4_2_1_9_0_6_0 - 4.166666666666655e-03*G4_2_1_9_0_6_1 - 4.166666666666655e-03*G4_2_1_9_0_6_2 - 4.166666666666655e-03*G4_2_1_9_0_7_0 - 4.166666666666656e-03*G4_2_1_9_0_7_1 - 4.166666666666656e-03*G4_2_1_9_0_7_2 - 4.166666666666653e-03*G4_2_1_10_0_4_0 - 4.166666666666654e-03*G4_2_1_10_0_4_1 - 4.166666666666654e-03*G4_2_1_10_0_4_2 - 4.166666666666654e-03*G4_2_1_10_0_5_0 - 4.166666666666655e-03*G4_2_1_10_0_5_1 - 4.166666666666655e-03*G4_2_1_10_0_5_2 - 8.333333333333309e-03*G4_2_1_10_0_6_0 - 8.333333333333309e-03*G4_2_1_10_0_6_1 - 8.333333333333311e-03*G4_2_1_10_0_6_2 - 4.166666666666654e-03*G4_2_1_10_0_7_0 - 4.166666666666655e-03*G4_2_1_10_0_7_1 - 4.166666666666655e-03*G4_2_1_10_0_7_2 - 4.166666666666655e-03*G4_2_1_11_0_4_0 - 4.166666666666656e-03*G4_2_1_11_0_4_1 - 4.166666666666657e-03*G4_2_1_11_0_4_2 - 4.166666666666655e-03*G4_2_1_11_0_5_0 - 4.166666666666656e-03*G4_2_1_11_0_5_1 - 4.166666666666656e-03*G4_2_1_11_0_5_2 - 4.166666666666655e-03*G4_2_1_11_0_6_0 - 4.166666666666655e-03*G4_2_1_11_0_6_1 - 4.166666666666655e-03*G4_2_1_11_0_6_2 - 8.333333333333309e-03*G4_2_1_11_0_7_0 - 8.333333333333311e-03*G4_2_1_11_0_7_1 - 8.333333333333311e-03*G4_2_1_11_0_7_2 - 8.333333333333309e-03*G4_2_2_8_0_8_0 - 8.333333333333309e-03*G4_2_2_8_0_8_1 - 8.333333333333311e-03*G4_2_2_8_0_8_2 - 4.166666666666654e-03*G4_2_2_8_0_9_0 - 4.166666666666654e-03*G4_2_2_8_0_9_1 - 4.166666666666654e-03*G4_2_2_8_0_9_2 - 4.166666666666653e-03*G4_2_2_8_0_10_0 - 4.166666666666654e-03*G4_2_2_8_0_10_1 - 4.166666666666654e-03*G4_2_2_8_0_10_2 - 4.166666666666654e-03*G4_2_2_8_0_11_0 - 4.166666666666656e-03*G4_2_2_8_0_11_1 - 4.166666666666657e-03*G4_2_2_8_0_11_2 - 4.166666666666654e-03*G4_2_2_9_0_8_0 - 4.166666666666654e-03*G4_2_2_9_0_8_1 - 4.166666666666654e-03*G4_2_2_9_0_8_2 - 8.333333333333307e-03*G4_2_2_9_0_9_0 - 8.333333333333309e-03*G4_2_2_9_0_9_1 - 8.333333333333309e-03*G4_2_2_9_0_9_2 - 4.166666666666654e-03*G4_2_2_9_0_10_0 - 4.166666666666655e-03*G4_2_2_9_0_10_1 - 4.166666666666655e-03*G4_2_2_9_0_10_2 - 4.166666666666655e-03*G4_2_2_9_0_11_0 - 4.166666666666656e-03*G4_2_2_9_0_11_1 - 4.166666666666656e-03*G4_2_2_9_0_11_2 - 4.166666666666653e-03*G4_2_2_10_0_8_0 - 4.166666666666654e-03*G4_2_2_10_0_8_1 - 4.166666666666654e-03*G4_2_2_10_0_8_2 - 4.166666666666654e-03*G4_2_2_10_0_9_0 - 4.166666666666655e-03*G4_2_2_10_0_9_1 - 4.166666666666655e-03*G4_2_2_10_0_9_2 - 8.333333333333309e-03*G4_2_2_10_0_10_0 - 8.333333333333309e-03*G4_2_2_10_0_10_1 - 8.333333333333311e-03*G4_2_2_10_0_10_2 - 4.166666666666654e-03*G4_2_2_10_0_11_0 - 4.166666666666655e-03*G4_2_2_10_0_11_1 - 4.166666666666655e-03*G4_2_2_10_0_11_2 - 4.166666666666655e-03*G4_2_2_11_0_8_0 - 4.166666666666656e-03*G4_2_2_11_0_8_1 - 4.166666666666657e-03*G4_2_2_11_0_8_2 - 4.166666666666655e-03*G4_2_2_11_0_9_0 - 4.166666666666656e-03*G4_2_2_11_0_9_1 - 4.166666666666656e-03*G4_2_2_11_0_9_2 - 4.166666666666655e-03*G4_2_2_11_0_10_0 - 4.166666666666655e-03*G4_2_2_11_0_10_1 - 4.166666666666655e-03*G4_2_2_11_0_10_2 - 8.333333333333309e-03*G4_2_2_11_0_11_0 - 8.333333333333311e-03*G4_2_2_11_0_11_1 - 8.333333333333311e-03*G4_2_2_11_0_11_2;
    block[65] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 4.166666666666655e-03*G2_0_0_0 + 8.333333333333309e-03*G2_0_1_0 + 4.166666666666655e-03*G2_0_2_0 + 4.166666666666656e-03*G2_0_3_0 + 4.166666666666654e-03*G2_1_4_0 + 8.333333333333309e-03*G2_1_5_0 + 4.166666666666655e-03*G2_1_6_0 + 4.166666666666656e-03*G2_1_7_0 + 4.166666666666654e-03*G2_2_8_0 + 8.333333333333309e-03*G2_2_9_0 + 4.166666666666655e-03*G2_2_10_0 + 4.166666666666656e-03*G2_2_11_0 + 8.333333333333320e-02*G3_1_1_0_0 + 8.333333333333309e-03*G4_0_0_0_0_0_0 + 4.166666666666654e-03*G4_0_0_0_0_1_0 + 4.166666666666654e-03*G4_0_0_0_0_2_0 + 4.166666666666656e-03*G4_0_0_0_0_3_0 + 4.166666666666654e-03*G4_0_0_1_0_0_0 + 8.333333333333307e-03*G4_0_0_1_0_1_0 + 4.166666666666654e-03*G4_0_0_1_0_2_0 + 4.166666666666654e-03*G4_0_0_1_0_3_0 + 4.166666666666654e-03*G4_0_0_2_0_0_0 + 4.166666666666654e-03*G4_0_0_2_0_1_0 + 8.333333333333309e-03*G4_0_0_2_0_2_0 + 4.166666666666654e-03*G4_0_0_2_0_3_0 + 4.166666666666656e-03*G4_0_0_3_0_0_0 + 4.166666666666654e-03*G4_0_0_3_0_1_0 + 4.166666666666655e-03*G4_0_0_3_0_2_0 + 8.333333333333309e-03*G4_0_0_3_0_3_0 + 8.333333333333309e-03*G4_0_1_0_0_4_0 + 4.166666666666654e-03*G4_0_1_0_0_5_0 + 4.166666666666654e-03*G4_0_1_0_0_6_0 + 4.166666666666656e-03*G4_0_1_0_0_7_0 + 4.166666666666654e-03*G4_0_1_1_0_4_0 + 8.333333333333307e-03*G4_0_1_1_0_5_0 + 4.166666666666654e-03*G4_0_1_1_0_6_0 + 4.166666666666654e-03*G4_0_1_1_0_7_0 + 4.166666666666653e-03*G4_0_1_2_0_4_0 + 4.166666666666654e-03*G4_0_1_2_0_5_0 + 8.333333333333309e-03*G4_0_1_2_0_6_0 + 4.166666666666654e-03*G4_0_1_2_0_7_0 + 4.166666666666655e-03*G4_0_1_3_0_4_0 + 4.166666666666655e-03*G4_0_1_3_0_5_0 + 4.166666666666655e-03*G4_0_1_3_0_6_0 + 8.333333333333309e-03*G4_0_1_3_0_7_0 + 8.333333333333309e-03*G4_0_2_0_0_8_0 + 4.166666666666654e-03*G4_0_2_0_0_9_0 + 4.166666666666654e-03*G4_0_2_0_0_10_0 + 4.166666666666656e-03*G4_0_2_0_0_11_0 + 4.166666666666654e-03*G4_0_2_1_0_8_0 + 8.333333333333307e-03*G4_0_2_1_0_9_0 + 4.166666666666654e-03*G4_0_2_1_0_10_0 + 4.166666666666654e-03*G4_0_2_1_0_11_0 + 4.166666666666653e-03*G4_0_2_2_0_8_0 + 4.166666666666654e-03*G4_0_2_2_0_9_0 + 8.333333333333309e-03*G4_0_2_2_0_10_0 + 4.166666666666654e-03*G4_0_2_2_0_11_0 + 4.166666666666655e-03*G4_0_2_3_0_8_0 + 4.166666666666655e-03*G4_0_2_3_0_9_0 + 4.166666666666655e-03*G4_0_2_3_0_10_0 + 8.333333333333309e-03*G4_0_2_3_0_11_0 + 8.333333333333309e-03*G4_1_0_4_0_0_0 + 4.166666666666654e-03*G4_1_0_4_0_1_0 + 4.166666666666653e-03*G4_1_0_4_0_2_0 + 4.166666666666654e-03*G4_1_0_4_0_3_0 + 4.166666666666654e-03*G4_1_0_5_0_0_0 + 8.333333333333307e-03*G4_1_0_5_0_1_0 + 4.166666666666654e-03*G4_1_0_5_0_2_0 + 4.166666666666655e-03*G4_1_0_5_0_3_0 + 4.166666666666654e-03*G4_1_0_6_0_0_0 + 4.166666666666654e-03*G4_1_0_6_0_1_0 + 8.333333333333309e-03*G4_1_0_6_0_2_0 + 4.166666666666654e-03*G4_1_0_6_0_3_0 + 4.166666666666656e-03*G4_1_0_7_0_0_0 + 4.166666666666654e-03*G4_1_0_7_0_1_0 + 4.166666666666655e-03*G4_1_0_7_0_2_0 + 8.333333333333309e-03*G4_1_0_7_0_3_0 + 8.333333333333309e-03*G4_1_1_4_0_4_0 + 4.166666666666654e-03*G4_1_1_4_0_5_0 + 4.166666666666653e-03*G4_1_1_4_0_6_0 + 4.166666666666654e-03*G4_1_1_4_0_7_0 + 4.166666666666654e-03*G4_1_1_5_0_4_0 + 8.333333333333307e-03*G4_1_1_5_0_5_0 + 4.166666666666654e-03*G4_1_1_5_0_6_0 + 4.166666666666655e-03*G4_1_1_5_0_7_0 + 4.166666666666653e-03*G4_1_1_6_0_4_0 + 4.166666666666654e-03*G4_1_1_6_0_5_0 + 8.333333333333309e-03*G4_1_1_6_0_6_0 + 4.166666666666654e-03*G4_1_1_6_0_7_0 + 4.166666666666655e-03*G4_1_1_7_0_4_0 + 4.166666666666655e-03*G4_1_1_7_0_5_0 + 4.166666666666655e-03*G4_1_1_7_0_6_0 + 8.333333333333309e-03*G4_1_1_7_0_7_0 + 8.333333333333309e-03*G4_1_2_4_0_8_0 + 4.166666666666654e-03*G4_1_2_4_0_9_0 + 4.166666666666653e-03*G4_1_2_4_0_10_0 + 4.166666666666654e-03*G4_1_2_4_0_11_0 + 4.166666666666654e-03*G4_1_2_5_0_8_0 + 8.333333333333307e-03*G4_1_2_5_0_9_0 + 4.166666666666654e-03*G4_1_2_5_0_10_0 + 4.166666666666655e-03*G4_1_2_5_0_11_0 + 4.166666666666653e-03*G4_1_2_6_0_8_0 + 4.166666666666654e-03*G4_1_2_6_0_9_0 + 8.333333333333309e-03*G4_1_2_6_0_10_0 + 4.166666666666654e-03*G4_1_2_6_0_11_0 + 4.166666666666655e-03*G4_1_2_7_0_8_0 + 4.166666666666655e-03*G4_1_2_7_0_9_0 + 4.166666666666655e-03*G4_1_2_7_0_10_0 + 8.333333333333309e-03*G4_1_2_7_0_11_0 + 8.333333333333309e-03*G4_2_0_8_0_0_0 + 4.166666666666654e-03*G4_2_0_8_0_1_0 + 4.166666666666653e-03*G4_2_0_8_0_2_0 + 4.166666666666654e-03*G4_2_0_8_0_3_0 + 4.166666666666654e-03*G4_2_0_9_0_0_0 + 8.333333333333307e-03*G4_2_0_9_0_1_0 + 4.166666666666654e-03*G4_2_0_9_0_2_0 + 4.166666666666655e-03*G4_2_0_9_0_3_0 + 4.166666666666654e-03*G4_2_0_10_0_0_0 + 4.166666666666654e-03*G4_2_0_10_0_1_0 + 8.333333333333309e-03*G4_2_0_10_0_2_0 + 4.166666666666654e-03*G4_2_0_10_0_3_0 + 4.166666666666656e-03*G4_2_0_11_0_0_0 + 4.166666666666654e-03*G4_2_0_11_0_1_0 + 4.166666666666655e-03*G4_2_0_11_0_2_0 + 8.333333333333309e-03*G4_2_0_11_0_3_0 + 8.333333333333309e-03*G4_2_1_8_0_4_0 + 4.166666666666654e-03*G4_2_1_8_0_5_0 + 4.166666666666653e-03*G4_2_1_8_0_6_0 + 4.166666666666654e-03*G4_2_1_8_0_7_0 + 4.166666666666654e-03*G4_2_1_9_0_4_0 + 8.333333333333307e-03*G4_2_1_9_0_5_0 + 4.166666666666654e-03*G4_2_1_9_0_6_0 + 4.166666666666655e-03*G4_2_1_9_0_7_0 + 4.166666666666653e-03*G4_2_1_10_0_4_0 + 4.166666666666654e-03*G4_2_1_10_0_5_0 + 8.333333333333309e-03*G4_2_1_10_0_6_0 + 4.166666666666654e-03*G4_2_1_10_0_7_0 + 4.166666666666655e-03*G4_2_1_11_0_4_0 + 4.166666666666655e-03*G4_2_1_11_0_5_0 + 4.166666666666655e-03*G4_2_1_11_0_6_0 + 8.333333333333309e-03*G4_2_1_11_0_7_0 + 8.333333333333309e-03*G4_2_2_8_0_8_0 + 4.166666666666654e-03*G4_2_2_8_0_9_0 + 4.166666666666653e-03*G4_2_2_8_0_10_0 + 4.166666666666654e-03*G4_2_2_8_0_11_0 + 4.166666666666654e-03*G4_2_2_9_0_8_0 + 8.333333333333307e-03*G4_2_2_9_0_9_0 + 4.166666666666654e-03*G4_2_2_9_0_10_0 + 4.166666666666655e-03*G4_2_2_9_0_11_0 + 4.166666666666653e-03*G4_2_2_10_0_8_0 + 4.166666666666654e-03*G4_2_2_10_0_9_0 + 8.333333333333309e-03*G4_2_2_10_0_10_0 + 4.166666666666654e-03*G4_2_2_10_0_11_0 + 4.166666666666655e-03*G4_2_2_11_0_8_0 + 4.166666666666655e-03*G4_2_2_11_0_9_0 + 4.166666666666655e-03*G4_2_2_11_0_10_0 + 8.333333333333309e-03*G4_2_2_11_0_11_0;
    block[66] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_0_1 + 4.166666666666655e-03*G2_0_0_1 + 8.333333333333309e-03*G2_0_1_1 + 4.166666666666656e-03*G2_0_2_1 + 4.166666666666657e-03*G2_0_3_1 + 4.166666666666654e-03*G2_1_4_1 + 8.333333333333309e-03*G2_1_5_1 + 4.166666666666656e-03*G2_1_6_1 + 4.166666666666657e-03*G2_1_7_1 + 4.166666666666654e-03*G2_2_8_1 + 8.333333333333309e-03*G2_2_9_1 + 4.166666666666656e-03*G2_2_10_1 + 4.166666666666657e-03*G2_2_11_1 + 8.333333333333322e-02*G3_1_1_0_1 + 8.333333333333309e-03*G4_0_0_0_0_0_1 + 4.166666666666654e-03*G4_0_0_0_0_1_1 + 4.166666666666654e-03*G4_0_0_0_0_2_1 + 4.166666666666656e-03*G4_0_0_0_0_3_1 + 4.166666666666654e-03*G4_0_0_1_0_0_1 + 8.333333333333307e-03*G4_0_0_1_0_1_1 + 4.166666666666654e-03*G4_0_0_1_0_2_1 + 4.166666666666655e-03*G4_0_0_1_0_3_1 + 4.166666666666654e-03*G4_0_0_2_0_0_1 + 4.166666666666654e-03*G4_0_0_2_0_1_1 + 8.333333333333309e-03*G4_0_0_2_0_2_1 + 4.166666666666655e-03*G4_0_0_2_0_3_1 + 4.166666666666656e-03*G4_0_0_3_0_0_1 + 4.166666666666655e-03*G4_0_0_3_0_1_1 + 4.166666666666655e-03*G4_0_0_3_0_2_1 + 8.333333333333311e-03*G4_0_0_3_0_3_1 + 8.333333333333309e-03*G4_0_1_0_0_4_1 + 4.166666666666655e-03*G4_0_1_0_0_5_1 + 4.166666666666654e-03*G4_0_1_0_0_6_1 + 4.166666666666656e-03*G4_0_1_0_0_7_1 + 4.166666666666654e-03*G4_0_1_1_0_4_1 + 8.333333333333309e-03*G4_0_1_1_0_5_1 + 4.166666666666654e-03*G4_0_1_1_0_6_1 + 4.166666666666655e-03*G4_0_1_1_0_7_1 + 4.166666666666654e-03*G4_0_1_2_0_4_1 + 4.166666666666655e-03*G4_0_1_2_0_5_1 + 8.333333333333309e-03*G4_0_1_2_0_6_1 + 4.166666666666655e-03*G4_0_1_2_0_7_1 + 4.166666666666656e-03*G4_0_1_3_0_4_1 + 4.166666666666656e-03*G4_0_1_3_0_5_1 + 4.166666666666655e-03*G4_0_1_3_0_6_1 + 8.333333333333311e-03*G4_0_1_3_0_7_1 + 8.333333333333309e-03*G4_0_2_0_0_8_1 + 4.166666666666655e-03*G4_0_2_0_0_9_1 + 4.166666666666654e-03*G4_0_2_0_0_10_1 + 4.166666666666656e-03*G4_0_2_0_0_11_1 + 4.166666666666654e-03*G4_0_2_1_0_8_1 + 8.333333333333309e-03*G4_0_2_1_0_9_1 + 4.166666666666654e-03*G4_0_2_1_0_10_1 + 4.166666666666655e-03*G4_0_2_1_0_11_1 + 4.166666666666654e-03*G4_0_2_2_0_8_1 + 4.166666666666655e-03*G4_0_2_2_0_9_1 + 8.333333333333309e-03*G4_0_2_2_0_10_1 + 4.166666666666655e-03*G4_0_2_2_0_11_1 + 4.166666666666656e-03*G4_0_2_3_0_8_1 + 4.166666666666656e-03*G4_0_2_3_0_9_1 + 4.166666666666655e-03*G4_0_2_3_0_10_1 + 8.333333333333311e-03*G4_0_2_3_0_11_1 + 8.333333333333309e-03*G4_1_0_4_0_0_1 + 4.166666666666654e-03*G4_1_0_4_0_1_1 + 4.166666666666654e-03*G4_1_0_4_0_2_1 + 4.166666666666656e-03*G4_1_0_4_0_3_1 + 4.166666666666655e-03*G4_1_0_5_0_0_1 + 8.333333333333309e-03*G4_1_0_5_0_1_1 + 4.166666666666655e-03*G4_1_0_5_0_2_1 + 4.166666666666656e-03*G4_1_0_5_0_3_1 + 4.166666666666654e-03*G4_1_0_6_0_0_1 + 4.166666666666654e-03*G4_1_0_6_0_1_1 + 8.333333333333309e-03*G4_1_0_6_0_2_1 + 4.166666666666655e-03*G4_1_0_6_0_3_1 + 4.166666666666656e-03*G4_1_0_7_0_0_1 + 4.166666666666655e-03*G4_1_0_7_0_1_1 + 4.166666666666655e-03*G4_1_0_7_0_2_1 + 8.333333333333311e-03*G4_1_0_7_0_3_1 + 8.333333333333309e-03*G4_1_1_4_0_4_1 + 4.166666666666654e-03*G4_1_1_4_0_5_1 + 4.166666666666654e-03*G4_1_1_4_0_6_1 + 4.166666666666656e-03*G4_1_1_4_0_7_1 + 4.166666666666654e-03*G4_1_1_5_0_4_1 + 8.333333333333309e-03*G4_1_1_5_0_5_1 + 4.166666666666655e-03*G4_1_1_5_0_6_1 + 4.166666666666656e-03*G4_1_1_5_0_7_1 + 4.166666666666654e-03*G4_1_1_6_0_4_1 + 4.166666666666655e-03*G4_1_1_6_0_5_1 + 8.333333333333309e-03*G4_1_1_6_0_6_1 + 4.166666666666655e-03*G4_1_1_6_0_7_1 + 4.166666666666656e-03*G4_1_1_7_0_4_1 + 4.166666666666656e-03*G4_1_1_7_0_5_1 + 4.166666666666655e-03*G4_1_1_7_0_6_1 + 8.333333333333311e-03*G4_1_1_7_0_7_1 + 8.333333333333309e-03*G4_1_2_4_0_8_1 + 4.166666666666654e-03*G4_1_2_4_0_9_1 + 4.166666666666654e-03*G4_1_2_4_0_10_1 + 4.166666666666656e-03*G4_1_2_4_0_11_1 + 4.166666666666654e-03*G4_1_2_5_0_8_1 + 8.333333333333309e-03*G4_1_2_5_0_9_1 + 4.166666666666655e-03*G4_1_2_5_0_10_1 + 4.166666666666656e-03*G4_1_2_5_0_11_1 + 4.166666666666654e-03*G4_1_2_6_0_8_1 + 4.166666666666655e-03*G4_1_2_6_0_9_1 + 8.333333333333309e-03*G4_1_2_6_0_10_1 + 4.166666666666655e-03*G4_1_2_6_0_11_1 + 4.166666666666656e-03*G4_1_2_7_0_8_1 + 4.166666666666656e-03*G4_1_2_7_0_9_1 + 4.166666666666655e-03*G4_1_2_7_0_10_1 + 8.333333333333311e-03*G4_1_2_7_0_11_1 + 8.333333333333309e-03*G4_2_0_8_0_0_1 + 4.166666666666654e-03*G4_2_0_8_0_1_1 + 4.166666666666654e-03*G4_2_0_8_0_2_1 + 4.166666666666656e-03*G4_2_0_8_0_3_1 + 4.166666666666655e-03*G4_2_0_9_0_0_1 + 8.333333333333309e-03*G4_2_0_9_0_1_1 + 4.166666666666655e-03*G4_2_0_9_0_2_1 + 4.166666666666656e-03*G4_2_0_9_0_3_1 + 4.166666666666654e-03*G4_2_0_10_0_0_1 + 4.166666666666654e-03*G4_2_0_10_0_1_1 + 8.333333333333309e-03*G4_2_0_10_0_2_1 + 4.166666666666655e-03*G4_2_0_10_0_3_1 + 4.166666666666656e-03*G4_2_0_11_0_0_1 + 4.166666666666655e-03*G4_2_0_11_0_1_1 + 4.166666666666655e-03*G4_2_0_11_0_2_1 + 8.333333333333311e-03*G4_2_0_11_0_3_1 + 8.333333333333309e-03*G4_2_1_8_0_4_1 + 4.166666666666654e-03*G4_2_1_8_0_5_1 + 4.166666666666654e-03*G4_2_1_8_0_6_1 + 4.166666666666656e-03*G4_2_1_8_0_7_1 + 4.166666666666654e-03*G4_2_1_9_0_4_1 + 8.333333333333309e-03*G4_2_1_9_0_5_1 + 4.166666666666655e-03*G4_2_1_9_0_6_1 + 4.166666666666656e-03*G4_2_1_9_0_7_1 + 4.166666666666654e-03*G4_2_1_10_0_4_1 + 4.166666666666655e-03*G4_2_1_10_0_5_1 + 8.333333333333309e-03*G4_2_1_10_0_6_1 + 4.166666666666655e-03*G4_2_1_10_0_7_1 + 4.166666666666656e-03*G4_2_1_11_0_4_1 + 4.166666666666656e-03*G4_2_1_11_0_5_1 + 4.166666666666655e-03*G4_2_1_11_0_6_1 + 8.333333333333311e-03*G4_2_1_11_0_7_1 + 8.333333333333309e-03*G4_2_2_8_0_8_1 + 4.166666666666654e-03*G4_2_2_8_0_9_1 + 4.166666666666654e-03*G4_2_2_8_0_10_1 + 4.166666666666656e-03*G4_2_2_8_0_11_1 + 4.166666666666654e-03*G4_2_2_9_0_8_1 + 8.333333333333309e-03*G4_2_2_9_0_9_1 + 4.166666666666655e-03*G4_2_2_9_0_10_1 + 4.166666666666656e-03*G4_2_2_9_0_11_1 + 4.166666666666654e-03*G4_2_2_10_0_8_1 + 4.166666666666655e-03*G4_2_2_10_0_9_1 + 8.333333333333309e-03*G4_2_2_10_0_10_1 + 4.166666666666655e-03*G4_2_2_10_0_11_1 + 4.166666666666656e-03*G4_2_2_11_0_8_1 + 4.166666666666656e-03*G4_2_2_11_0_9_1 + 4.166666666666655e-03*G4_2_2_11_0_10_1 + 8.333333333333311e-03*G4_2_2_11_0_11_1;
    block[67] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_0_2 + 4.166666666666655e-03*G2_0_0_2 + 8.333333333333309e-03*G2_0_1_2 + 4.166666666666656e-03*G2_0_2_2 + 4.166666666666657e-03*G2_0_3_2 + 4.166666666666654e-03*G2_1_4_2 + 8.333333333333309e-03*G2_1_5_2 + 4.166666666666656e-03*G2_1_6_2 + 4.166666666666657e-03*G2_1_7_2 + 4.166666666666654e-03*G2_2_8_2 + 8.333333333333309e-03*G2_2_9_2 + 4.166666666666656e-03*G2_2_10_2 + 4.166666666666657e-03*G2_2_11_2 + 8.333333333333322e-02*G3_1_1_0_2 + 8.333333333333309e-03*G4_0_0_0_0_0_2 + 4.166666666666654e-03*G4_0_0_0_0_1_2 + 4.166666666666654e-03*G4_0_0_0_0_2_2 + 4.166666666666656e-03*G4_0_0_0_0_3_2 + 4.166666666666654e-03*G4_0_0_1_0_0_2 + 8.333333333333307e-03*G4_0_0_1_0_1_2 + 4.166666666666654e-03*G4_0_0_1_0_2_2 + 4.166666666666655e-03*G4_0_0_1_0_3_2 + 4.166666666666654e-03*G4_0_0_2_0_0_2 + 4.166666666666654e-03*G4_0_0_2_0_1_2 + 8.333333333333309e-03*G4_0_0_2_0_2_2 + 4.166666666666655e-03*G4_0_0_2_0_3_2 + 4.166666666666656e-03*G4_0_0_3_0_0_2 + 4.166666666666655e-03*G4_0_0_3_0_1_2 + 4.166666666666655e-03*G4_0_0_3_0_2_2 + 8.333333333333311e-03*G4_0_0_3_0_3_2 + 8.333333333333309e-03*G4_0_1_0_0_4_2 + 4.166666666666655e-03*G4_0_1_0_0_5_2 + 4.166666666666654e-03*G4_0_1_0_0_6_2 + 4.166666666666656e-03*G4_0_1_0_0_7_2 + 4.166666666666654e-03*G4_0_1_1_0_4_2 + 8.333333333333309e-03*G4_0_1_1_0_5_2 + 4.166666666666654e-03*G4_0_1_1_0_6_2 + 4.166666666666655e-03*G4_0_1_1_0_7_2 + 4.166666666666654e-03*G4_0_1_2_0_4_2 + 4.166666666666655e-03*G4_0_1_2_0_5_2 + 8.333333333333309e-03*G4_0_1_2_0_6_2 + 4.166666666666655e-03*G4_0_1_2_0_7_2 + 4.166666666666656e-03*G4_0_1_3_0_4_2 + 4.166666666666656e-03*G4_0_1_3_0_5_2 + 4.166666666666655e-03*G4_0_1_3_0_6_2 + 8.333333333333311e-03*G4_0_1_3_0_7_2 + 8.333333333333309e-03*G4_0_2_0_0_8_2 + 4.166666666666655e-03*G4_0_2_0_0_9_2 + 4.166666666666654e-03*G4_0_2_0_0_10_2 + 4.166666666666656e-03*G4_0_2_0_0_11_2 + 4.166666666666654e-03*G4_0_2_1_0_8_2 + 8.333333333333309e-03*G4_0_2_1_0_9_2 + 4.166666666666654e-03*G4_0_2_1_0_10_2 + 4.166666666666655e-03*G4_0_2_1_0_11_2 + 4.166666666666654e-03*G4_0_2_2_0_8_2 + 4.166666666666655e-03*G4_0_2_2_0_9_2 + 8.333333333333309e-03*G4_0_2_2_0_10_2 + 4.166666666666655e-03*G4_0_2_2_0_11_2 + 4.166666666666656e-03*G4_0_2_3_0_8_2 + 4.166666666666656e-03*G4_0_2_3_0_9_2 + 4.166666666666655e-03*G4_0_2_3_0_10_2 + 8.333333333333311e-03*G4_0_2_3_0_11_2 + 8.333333333333309e-03*G4_1_0_4_0_0_2 + 4.166666666666654e-03*G4_1_0_4_0_1_2 + 4.166666666666654e-03*G4_1_0_4_0_2_2 + 4.166666666666656e-03*G4_1_0_4_0_3_2 + 4.166666666666655e-03*G4_1_0_5_0_0_2 + 8.333333333333309e-03*G4_1_0_5_0_1_2 + 4.166666666666655e-03*G4_1_0_5_0_2_2 + 4.166666666666656e-03*G4_1_0_5_0_3_2 + 4.166666666666654e-03*G4_1_0_6_0_0_2 + 4.166666666666654e-03*G4_1_0_6_0_1_2 + 8.333333333333309e-03*G4_1_0_6_0_2_2 + 4.166666666666655e-03*G4_1_0_6_0_3_2 + 4.166666666666656e-03*G4_1_0_7_0_0_2 + 4.166666666666655e-03*G4_1_0_7_0_1_2 + 4.166666666666655e-03*G4_1_0_7_0_2_2 + 8.333333333333311e-03*G4_1_0_7_0_3_2 + 8.333333333333309e-03*G4_1_1_4_0_4_2 + 4.166666666666654e-03*G4_1_1_4_0_5_2 + 4.166666666666654e-03*G4_1_1_4_0_6_2 + 4.166666666666656e-03*G4_1_1_4_0_7_2 + 4.166666666666654e-03*G4_1_1_5_0_4_2 + 8.333333333333309e-03*G4_1_1_5_0_5_2 + 4.166666666666655e-03*G4_1_1_5_0_6_2 + 4.166666666666656e-03*G4_1_1_5_0_7_2 + 4.166666666666654e-03*G4_1_1_6_0_4_2 + 4.166666666666655e-03*G4_1_1_6_0_5_2 + 8.333333333333309e-03*G4_1_1_6_0_6_2 + 4.166666666666655e-03*G4_1_1_6_0_7_2 + 4.166666666666656e-03*G4_1_1_7_0_4_2 + 4.166666666666656e-03*G4_1_1_7_0_5_2 + 4.166666666666655e-03*G4_1_1_7_0_6_2 + 8.333333333333311e-03*G4_1_1_7_0_7_2 + 8.333333333333309e-03*G4_1_2_4_0_8_2 + 4.166666666666654e-03*G4_1_2_4_0_9_2 + 4.166666666666654e-03*G4_1_2_4_0_10_2 + 4.166666666666656e-03*G4_1_2_4_0_11_2 + 4.166666666666654e-03*G4_1_2_5_0_8_2 + 8.333333333333309e-03*G4_1_2_5_0_9_2 + 4.166666666666655e-03*G4_1_2_5_0_10_2 + 4.166666666666656e-03*G4_1_2_5_0_11_2 + 4.166666666666654e-03*G4_1_2_6_0_8_2 + 4.166666666666655e-03*G4_1_2_6_0_9_2 + 8.333333333333309e-03*G4_1_2_6_0_10_2 + 4.166666666666655e-03*G4_1_2_6_0_11_2 + 4.166666666666656e-03*G4_1_2_7_0_8_2 + 4.166666666666656e-03*G4_1_2_7_0_9_2 + 4.166666666666655e-03*G4_1_2_7_0_10_2 + 8.333333333333311e-03*G4_1_2_7_0_11_2 + 8.333333333333309e-03*G4_2_0_8_0_0_2 + 4.166666666666654e-03*G4_2_0_8_0_1_2 + 4.166666666666654e-03*G4_2_0_8_0_2_2 + 4.166666666666656e-03*G4_2_0_8_0_3_2 + 4.166666666666655e-03*G4_2_0_9_0_0_2 + 8.333333333333309e-03*G4_2_0_9_0_1_2 + 4.166666666666655e-03*G4_2_0_9_0_2_2 + 4.166666666666656e-03*G4_2_0_9_0_3_2 + 4.166666666666654e-03*G4_2_0_10_0_0_2 + 4.166666666666654e-03*G4_2_0_10_0_1_2 + 8.333333333333309e-03*G4_2_0_10_0_2_2 + 4.166666666666655e-03*G4_2_0_10_0_3_2 + 4.166666666666656e-03*G4_2_0_11_0_0_2 + 4.166666666666655e-03*G4_2_0_11_0_1_2 + 4.166666666666655e-03*G4_2_0_11_0_2_2 + 8.333333333333311e-03*G4_2_0_11_0_3_2 + 8.333333333333309e-03*G4_2_1_8_0_4_2 + 4.166666666666654e-03*G4_2_1_8_0_5_2 + 4.166666666666654e-03*G4_2_1_8_0_6_2 + 4.166666666666656e-03*G4_2_1_8_0_7_2 + 4.166666666666654e-03*G4_2_1_9_0_4_2 + 8.333333333333309e-03*G4_2_1_9_0_5_2 + 4.166666666666655e-03*G4_2_1_9_0_6_2 + 4.166666666666656e-03*G4_2_1_9_0_7_2 + 4.166666666666654e-03*G4_2_1_10_0_4_2 + 4.166666666666655e-03*G4_2_1_10_0_5_2 + 8.333333333333309e-03*G4_2_1_10_0_6_2 + 4.166666666666655e-03*G4_2_1_10_0_7_2 + 4.166666666666656e-03*G4_2_1_11_0_4_2 + 4.166666666666656e-03*G4_2_1_11_0_5_2 + 4.166666666666655e-03*G4_2_1_11_0_6_2 + 8.333333333333311e-03*G4_2_1_11_0_7_2 + 8.333333333333309e-03*G4_2_2_8_0_8_2 + 4.166666666666654e-03*G4_2_2_8_0_9_2 + 4.166666666666654e-03*G4_2_2_8_0_10_2 + 4.166666666666656e-03*G4_2_2_8_0_11_2 + 4.166666666666654e-03*G4_2_2_9_0_8_2 + 8.333333333333309e-03*G4_2_2_9_0_9_2 + 4.166666666666655e-03*G4_2_2_9_0_10_2 + 4.166666666666656e-03*G4_2_2_9_0_11_2 + 4.166666666666654e-03*G4_2_2_10_0_8_2 + 4.166666666666655e-03*G4_2_2_10_0_9_2 + 8.333333333333309e-03*G4_2_2_10_0_10_2 + 4.166666666666655e-03*G4_2_2_10_0_11_2 + 4.166666666666656e-03*G4_2_2_11_0_8_2 + 4.166666666666656e-03*G4_2_2_11_0_9_2 + 4.166666666666655e-03*G4_2_2_11_0_10_2 + 8.333333333333311e-03*G4_2_2_11_0_11_2;
    block[68] = -8.333333333333320e-02*G3_1_2_0_0 - 8.333333333333322e-02*G3_1_2_0_1 - 8.333333333333322e-02*G3_1_2_0_2;
    block[69] = 8.333333333333320e-02*G3_1_2_0_0;
    block[70] = 8.333333333333322e-02*G3_1_2_0_1;
    block[71] = 8.333333333333322e-02*G3_1_2_0_2;
    block[72] = -8.333333333333322e-02*G3_1_0_1_0 - 8.333333333333323e-02*G3_1_0_1_1 - 8.333333333333322e-02*G3_1_0_1_2;
    block[73] = 8.333333333333322e-02*G3_1_0_1_0;
    block[74] = 8.333333333333323e-02*G3_1_0_1_1;
    block[75] = 8.333333333333323e-02*G3_1_0_1_2;
    block[76] = 8.333333333333307e-03*G0_ - 8.333333333333322e-02*G1_1_0 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_1_2 - 4.166666666666654e-03*G2_0_0_0 - 4.166666666666656e-03*G2_0_0_1 - 4.166666666666656e-03*G2_0_0_2 - 4.166666666666654e-03*G2_0_1_0 - 4.166666666666654e-03*G2_0_1_1 - 4.166666666666654e-03*G2_0_1_2 - 8.333333333333311e-03*G2_0_2_0 - 8.333333333333311e-03*G2_0_2_1 - 8.333333333333312e-03*G2_0_2_2 - 4.166666666666655e-03*G2_0_3_0 - 4.166666666666656e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 4.166666666666654e-03*G2_1_4_0 - 4.166666666666654e-03*G2_1_4_1 - 4.166666666666654e-03*G2_1_4_2 - 4.166666666666655e-03*G2_1_5_0 - 4.166666666666656e-03*G2_1_5_1 - 4.166666666666656e-03*G2_1_5_2 - 8.333333333333311e-03*G2_1_6_0 - 8.333333333333311e-03*G2_1_6_1 - 8.333333333333312e-03*G2_1_6_2 - 4.166666666666655e-03*G2_1_7_0 - 4.166666666666656e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 4.166666666666654e-03*G2_2_8_0 - 4.166666666666654e-03*G2_2_8_1 - 4.166666666666654e-03*G2_2_8_2 - 4.166666666666655e-03*G2_2_9_0 - 4.166666666666656e-03*G2_2_9_1 - 4.166666666666656e-03*G2_2_9_2 - 8.333333333333311e-03*G2_2_10_0 - 8.333333333333311e-03*G2_2_10_1 - 8.333333333333312e-03*G2_2_10_2 - 4.166666666666655e-03*G2_2_11_0 - 4.166666666666656e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 - 8.333333333333322e-02*G3_1_1_1_0 - 8.333333333333323e-02*G3_1_1_1_1 - 8.333333333333323e-02*G3_1_1_1_2 - 8.333333333333309e-03*G4_0_0_0_1_0_0 - 8.333333333333311e-03*G4_0_0_0_1_0_1 - 8.333333333333312e-03*G4_0_0_0_1_0_2 - 4.166666666666654e-03*G4_0_0_0_1_1_0 - 4.166666666666655e-03*G4_0_0_0_1_1_1 - 4.166666666666655e-03*G4_0_0_0_1_1_2 - 4.166666666666654e-03*G4_0_0_0_1_2_0 - 4.166666666666656e-03*G4_0_0_0_1_2_1 - 4.166666666666656e-03*G4_0_0_0_1_2_2 - 4.166666666666656e-03*G4_0_0_0_1_3_0 - 4.166666666666657e-03*G4_0_0_0_1_3_1 - 4.166666666666658e-03*G4_0_0_0_1_3_2 - 4.166666666666654e-03*G4_0_0_1_1_0_0 - 4.166666666666655e-03*G4_0_0_1_1_0_1 - 4.166666666666655e-03*G4_0_0_1_1_0_2 - 8.333333333333307e-03*G4_0_0_1_1_1_0 - 8.333333333333309e-03*G4_0_0_1_1_1_1 - 8.333333333333309e-03*G4_0_0_1_1_1_2 - 4.166666666666654e-03*G4_0_0_1_1_2_0 - 4.166666666666654e-03*G4_0_0_1_1_2_1 - 4.166666666666655e-03*G4_0_0_1_1_2_2 - 4.166666666666655e-03*G4_0_0_1_1_3_0 - 4.166666666666655e-03*G4_0_0_1_1_3_1 - 4.166666666666656e-03*G4_0_0_1_1_3_2 - 4.166666666666654e-03*G4_0_0_2_1_0_0 - 4.166666666666656e-03*G4_0_0_2_1_0_1 - 4.166666666666656e-03*G4_0_0_2_1_0_2 - 4.166666666666654e-03*G4_0_0_2_1_1_0 - 4.166666666666654e-03*G4_0_0_2_1_1_1 - 4.166666666666654e-03*G4_0_0_2_1_1_2 - 8.333333333333311e-03*G4_0_0_2_1_2_0 - 8.333333333333311e-03*G4_0_0_2_1_2_1 - 8.333333333333312e-03*G4_0_0_2_1_2_2 - 4.166666666666655e-03*G4_0_0_2_1_3_0 - 4.166666666666656e-03*G4_0_0_2_1_3_1 - 4.166666666666657e-03*G4_0_0_2_1_3_2 - 4.166666666666656e-03*G4_0_0_3_1_0_0 - 4.166666666666657e-03*G4_0_0_3_1_0_1 - 4.166666666666658e-03*G4_0_0_3_1_0_2 - 4.166666666666655e-03*G4_0_0_3_1_1_0 - 4.166666666666655e-03*G4_0_0_3_1_1_1 - 4.166666666666656e-03*G4_0_0_3_1_1_2 - 4.166666666666655e-03*G4_0_0_3_1_2_0 - 4.166666666666656e-03*G4_0_0_3_1_2_1 - 4.166666666666657e-03*G4_0_0_3_1_2_2 - 8.333333333333311e-03*G4_0_0_3_1_3_0 - 8.333333333333311e-03*G4_0_0_3_1_3_1 - 8.333333333333312e-03*G4_0_0_3_1_3_2 - 8.333333333333309e-03*G4_0_1_0_1_4_0 - 8.333333333333311e-03*G4_0_1_0_1_4_1 - 8.333333333333312e-03*G4_0_1_0_1_4_2 - 4.166666666666655e-03*G4_0_1_0_1_5_0 - 4.166666666666655e-03*G4_0_1_0_1_5_1 - 4.166666666666656e-03*G4_0_1_0_1_5_2 - 4.166666666666654e-03*G4_0_1_0_1_6_0 - 4.166666666666656e-03*G4_0_1_0_1_6_1 - 4.166666666666656e-03*G4_0_1_0_1_6_2 - 4.166666666666656e-03*G4_0_1_0_1_7_0 - 4.166666666666657e-03*G4_0_1_0_1_7_1 - 4.166666666666658e-03*G4_0_1_0_1_7_2 - 4.166666666666654e-03*G4_0_1_1_1_4_0 - 4.166666666666654e-03*G4_0_1_1_1_4_1 - 4.166666666666654e-03*G4_0_1_1_1_4_2 - 8.333333333333309e-03*G4_0_1_1_1_5_0 - 8.333333333333309e-03*G4_0_1_1_1_5_1 - 8.333333333333309e-03*G4_0_1_1_1_5_2 - 4.166666666666654e-03*G4_0_1_1_1_6_0 - 4.166666666666654e-03*G4_0_1_1_1_6_1 - 4.166666666666655e-03*G4_0_1_1_1_6_2 - 4.166666666666655e-03*G4_0_1_1_1_7_0 - 4.166666666666655e-03*G4_0_1_1_1_7_1 - 4.166666666666656e-03*G4_0_1_1_1_7_2 - 4.166666666666654e-03*G4_0_1_2_1_4_0 - 4.166666666666654e-03*G4_0_1_2_1_4_1 - 4.166666666666654e-03*G4_0_1_2_1_4_2 - 4.166666666666655e-03*G4_0_1_2_1_5_0 - 4.166666666666656e-03*G4_0_1_2_1_5_1 - 4.166666666666656e-03*G4_0_1_2_1_5_2 - 8.333333333333311e-03*G4_0_1_2_1_6_0 - 8.333333333333311e-03*G4_0_1_2_1_6_1 - 8.333333333333312e-03*G4_0_1_2_1_6_2 - 4.166666666666655e-03*G4_0_1_2_1_7_0 - 4.166666666666656e-03*G4_0_1_2_1_7_1 - 4.166666666666657e-03*G4_0_1_2_1_7_2 - 4.166666666666656e-03*G4_0_1_3_1_4_0 - 4.166666666666657e-03*G4_0_1_3_1_4_1 - 4.166666666666657e-03*G4_0_1_3_1_4_2 - 4.166666666666656e-03*G4_0_1_3_1_5_0 - 4.166666666666657e-03*G4_0_1_3_1_5_1 - 4.166666666666657e-03*G4_0_1_3_1_5_2 - 4.166666666666655e-03*G4_0_1_3_1_6_0 - 4.166666666666656e-03*G4_0_1_3_1_6_1 - 4.166666666666657e-03*G4_0_1_3_1_6_2 - 8.333333333333311e-03*G4_0_1_3_1_7_0 - 8.333333333333311e-03*G4_0_1_3_1_7_1 - 8.333333333333312e-03*G4_0_1_3_1_7_2 - 8.333333333333309e-03*G4_0_2_0_1_8_0 - 8.333333333333311e-03*G4_0_2_0_1_8_1 - 8.333333333333312e-03*G4_0_2_0_1_8_2 - 4.166666666666655e-03*G4_0_2_0_1_9_0 - 4.166666666666655e-03*G4_0_2_0_1_9_1 - 4.166666666666656e-03*G4_0_2_0_1_9_2 - 4.166666666666654e-03*G4_0_2_0_1_10_0 - 4.166666666666656e-03*G4_0_2_0_1_10_1 - 4.166666666666656e-03*G4_0_2_0_1_10_2 - 4.166666666666656e-03*G4_0_2_0_1_11_0 - 4.166666666666657e-03*G4_0_2_0_1_11_1 - 4.166666666666658e-03*G4_0_2_0_1_11_2 - 4.166666666666654e-03*G4_0_2_1_1_8_0 - 4.166666666666654e-03*G4_0_2_1_1_8_1 - 4.166666666666654e-03*G4_0_2_1_1_8_2 - 8.333333333333309e-03*G4_0_2_1_1_9_0 - 8.333333333333309e-03*G4_0_2_1_1_9_1 - 8.333333333333309e-03*G4_0_2_1_1_9_2 - 4.166666666666654e-03*G4_0_2_1_1_10_0 - 4.166666666666654e-03*G4_0_2_1_1_10_1 - 4.166666666666655e-03*G4_0_2_1_1_10_2 - 4.166666666666655e-03*G4_0_2_1_1_11_0 - 4.166666666666655e-03*G4_0_2_1_1_11_1 - 4.166666666666656e-03*G4_0_2_1_1_11_2 - 4.166666666666654e-03*G4_0_2_2_1_8_0 - 4.166666666666654e-03*G4_0_2_2_1_8_1 - 4.166666666666654e-03*G4_0_2_2_1_8_2 - 4.166666666666655e-03*G4_0_2_2_1_9_0 - 4.166666666666656e-03*G4_0_2_2_1_9_1 - 4.166666666666656e-03*G4_0_2_2_1_9_2 - 8.333333333333311e-03*G4_0_2_2_1_10_0 - 8.333333333333311e-03*G4_0_2_2_1_10_1 - 8.333333333333312e-03*G4_0_2_2_1_10_2 - 4.166666666666655e-03*G4_0_2_2_1_11_0 - 4.166666666666656e-03*G4_0_2_2_1_11_1 - 4.166666666666657e-03*G4_0_2_2_1_11_2 - 4.166666666666656e-03*G4_0_2_3_1_8_0 - 4.166666666666657e-03*G4_0_2_3_1_8_1 - 4.166666666666657e-03*G4_0_2_3_1_8_2 - 4.166666666666656e-03*G4_0_2_3_1_9_0 - 4.166666666666657e-03*G4_0_2_3_1_9_1 - 4.166666666666657e-03*G4_0_2_3_1_9_2 - 4.166666666666655e-03*G4_0_2_3_1_10_0 - 4.166666666666656e-03*G4_0_2_3_1_10_1 - 4.166666666666657e-03*G4_0_2_3_1_10_2 - 8.333333333333311e-03*G4_0_2_3_1_11_0 - 8.333333333333311e-03*G4_0_2_3_1_11_1 - 8.333333333333312e-03*G4_0_2_3_1_11_2 - 8.333333333333309e-03*G4_1_0_4_1_0_0 - 8.333333333333311e-03*G4_1_0_4_1_0_1 - 8.333333333333312e-03*G4_1_0_4_1_0_2 - 4.166666666666654e-03*G4_1_0_4_1_1_0 - 4.166666666666654e-03*G4_1_0_4_1_1_1 - 4.166666666666654e-03*G4_1_0_4_1_1_2 - 4.166666666666654e-03*G4_1_0_4_1_2_0 - 4.166666666666654e-03*G4_1_0_4_1_2_1 - 4.166666666666654e-03*G4_1_0_4_1_2_2 - 4.166666666666656e-03*G4_1_0_4_1_3_0 - 4.166666666666657e-03*G4_1_0_4_1_3_1 - 4.166666666666657e-03*G4_1_0_4_1_3_2 - 4.166666666666655e-03*G4_1_0_5_1_0_0 - 4.166666666666655e-03*G4_1_0_5_1_0_1 - 4.166666666666656e-03*G4_1_0_5_1_0_2 - 8.333333333333309e-03*G4_1_0_5_1_1_0 - 8.333333333333309e-03*G4_1_0_5_1_1_1 - 8.333333333333309e-03*G4_1_0_5_1_1_2 - 4.166666666666655e-03*G4_1_0_5_1_2_0 - 4.166666666666656e-03*G4_1_0_5_1_2_1 - 4.166666666666656e-03*G4_1_0_5_1_2_2 - 4.166666666666656e-03*G4_1_0_5_1_3_0 - 4.166666666666657e-03*G4_1_0_5_1_3_1 - 4.166666666666657e-03*G4_1_0_5_1_3_2 - 4.166666666666654e-03*G4_1_0_6_1_0_0 - 4.166666666666656e-03*G4_1_0_6_1_0_1 - 4.166666666666656e-03*G4_1_0_6_1_0_2 - 4.166666666666654e-03*G4_1_0_6_1_1_0 - 4.166666666666654e-03*G4_1_0_6_1_1_1 - 4.166666666666654e-03*G4_1_0_6_1_1_2 - 8.333333333333311e-03*G4_1_0_6_1_2_0 - 8.333333333333311e-03*G4_1_0_6_1_2_1 - 8.333333333333312e-03*G4_1_0_6_1_2_2 - 4.166666666666655e-03*G4_1_0_6_1_3_0 - 4.166666666666656e-03*G4_1_0_6_1_3_1 - 4.166666666666657e-03*G4_1_0_6_1_3_2 - 4.166666666666656e-03*G4_1_0_7_1_0_0 - 4.166666666666657e-03*G4_1_0_7_1_0_1 - 4.166666666666658e-03*G4_1_0_7_1_0_2 - 4.166666666666655e-03*G4_1_0_7_1_1_0 - 4.166666666666655e-03*G4_1_0_7_1_1_1 - 4.166666666666656e-03*G4_1_0_7_1_1_2 - 4.166666666666655e-03*G4_1_0_7_1_2_0 - 4.166666666666656e-03*G4_1_0_7_1_2_1 - 4.166666666666657e-03*G4_1_0_7_1_2_2 - 8.333333333333311e-03*G4_1_0_7_1_3_0 - 8.333333333333311e-03*G4_1_0_7_1_3_1 - 8.333333333333312e-03*G4_1_0_7_1_3_2 - 8.333333333333309e-03*G4_1_1_4_1_4_0 - 8.333333333333311e-03*G4_1_1_4_1_4_1 - 8.333333333333312e-03*G4_1_1_4_1_4_2 - 4.166666666666654e-03*G4_1_1_4_1_5_0 - 4.166666666666654e-03*G4_1_1_4_1_5_1 - 4.166666666666655e-03*G4_1_1_4_1_5_2 - 4.166666666666654e-03*G4_1_1_4_1_6_0 - 4.166666666666654e-03*G4_1_1_4_1_6_1 - 4.166666666666654e-03*G4_1_1_4_1_6_2 - 4.166666666666656e-03*G4_1_1_4_1_7_0 - 4.166666666666657e-03*G4_1_1_4_1_7_1 - 4.166666666666657e-03*G4_1_1_4_1_7_2 - 4.166666666666654e-03*G4_1_1_5_1_4_0 - 4.166666666666654e-03*G4_1_1_5_1_4_1 - 4.166666666666655e-03*G4_1_1_5_1_4_2 - 8.333333333333309e-03*G4_1_1_5_1_5_0 - 8.333333333333309e-03*G4_1_1_5_1_5_1 - 8.333333333333309e-03*G4_1_1_5_1_5_2 - 4.166666666666655e-03*G4_1_1_5_1_6_0 - 4.166666666666656e-03*G4_1_1_5_1_6_1 - 4.166666666666656e-03*G4_1_1_5_1_6_2 - 4.166666666666656e-03*G4_1_1_5_1_7_0 - 4.166666666666657e-03*G4_1_1_5_1_7_1 - 4.166666666666657e-03*G4_1_1_5_1_7_2 - 4.166666666666654e-03*G4_1_1_6_1_4_0 - 4.166666666666654e-03*G4_1_1_6_1_4_1 - 4.166666666666654e-03*G4_1_1_6_1_4_2 - 4.166666666666655e-03*G4_1_1_6_1_5_0 - 4.166666666666656e-03*G4_1_1_6_1_5_1 - 4.166666666666656e-03*G4_1_1_6_1_5_2 - 8.333333333333311e-03*G4_1_1_6_1_6_0 - 8.333333333333311e-03*G4_1_1_6_1_6_1 - 8.333333333333312e-03*G4_1_1_6_1_6_2 - 4.166666666666655e-03*G4_1_1_6_1_7_0 - 4.166666666666656e-03*G4_1_1_6_1_7_1 - 4.166666666666657e-03*G4_1_1_6_1_7_2 - 4.166666666666656e-03*G4_1_1_7_1_4_0 - 4.166666666666657e-03*G4_1_1_7_1_4_1 - 4.166666666666657e-03*G4_1_1_7_1_4_2 - 4.166666666666656e-03*G4_1_1_7_1_5_0 - 4.166666666666657e-03*G4_1_1_7_1_5_1 - 4.166666666666657e-03*G4_1_1_7_1_5_2 - 4.166666666666655e-03*G4_1_1_7_1_6_0 - 4.166666666666656e-03*G4_1_1_7_1_6_1 - 4.166666666666657e-03*G4_1_1_7_1_6_2 - 8.333333333333311e-03*G4_1_1_7_1_7_0 - 8.333333333333311e-03*G4_1_1_7_1_7_1 - 8.333333333333312e-03*G4_1_1_7_1_7_2 - 8.333333333333309e-03*G4_1_2_4_1_8_0 - 8.333333333333311e-03*G4_1_2_4_1_8_1 - 8.333333333333312e-03*G4_1_2_4_1_8_2 - 4.166666666666654e-03*G4_1_2_4_1_9_0 - 4.166666666666654e-03*G4_1_2_4_1_9_1 - 4.166666666666655e-03*G4_1_2_4_1_9_2 - 4.166666666666654e-03*G4_1_2_4_1_10_0 - 4.166666666666654e-03*G4_1_2_4_1_10_1 - 4.166666666666654e-03*G4_1_2_4_1_10_2 - 4.166666666666656e-03*G4_1_2_4_1_11_0 - 4.166666666666657e-03*G4_1_2_4_1_11_1 - 4.166666666666657e-03*G4_1_2_4_1_11_2 - 4.166666666666654e-03*G4_1_2_5_1_8_0 - 4.166666666666654e-03*G4_1_2_5_1_8_1 - 4.166666666666655e-03*G4_1_2_5_1_8_2 - 8.333333333333309e-03*G4_1_2_5_1_9_0 - 8.333333333333309e-03*G4_1_2_5_1_9_1 - 8.333333333333309e-03*G4_1_2_5_1_9_2 - 4.166666666666655e-03*G4_1_2_5_1_10_0 - 4.166666666666656e-03*G4_1_2_5_1_10_1 - 4.166666666666656e-03*G4_1_2_5_1_10_2 - 4.166666666666656e-03*G4_1_2_5_1_11_0 - 4.166666666666657e-03*G4_1_2_5_1_11_1 - 4.166666666666657e-03*G4_1_2_5_1_11_2 - 4.166666666666654e-03*G4_1_2_6_1_8_0 - 4.166666666666654e-03*G4_1_2_6_1_8_1 - 4.166666666666654e-03*G4_1_2_6_1_8_2 - 4.166666666666655e-03*G4_1_2_6_1_9_0 - 4.166666666666656e-03*G4_1_2_6_1_9_1 - 4.166666666666656e-03*G4_1_2_6_1_9_2 - 8.333333333333311e-03*G4_1_2_6_1_10_0 - 8.333333333333311e-03*G4_1_2_6_1_10_1 - 8.333333333333312e-03*G4_1_2_6_1_10_2 - 4.166666666666655e-03*G4_1_2_6_1_11_0 - 4.166666666666656e-03*G4_1_2_6_1_11_1 - 4.166666666666657e-03*G4_1_2_6_1_11_2 - 4.166666666666656e-03*G4_1_2_7_1_8_0 - 4.166666666666657e-03*G4_1_2_7_1_8_1 - 4.166666666666657e-03*G4_1_2_7_1_8_2 - 4.166666666666656e-03*G4_1_2_7_1_9_0 - 4.166666666666657e-03*G4_1_2_7_1_9_1 - 4.166666666666657e-03*G4_1_2_7_1_9_2 - 4.166666666666655e-03*G4_1_2_7_1_10_0 - 4.166666666666656e-03*G4_1_2_7_1_10_1 - 4.166666666666657e-03*G4_1_2_7_1_10_2 - 8.333333333333311e-03*G4_1_2_7_1_11_0 - 8.333333333333311e-03*G4_1_2_7_1_11_1 - 8.333333333333312e-03*G4_1_2_7_1_11_2 - 8.333333333333309e-03*G4_2_0_8_1_0_0 - 8.333333333333311e-03*G4_2_0_8_1_0_1 - 8.333333333333312e-03*G4_2_0_8_1_0_2 - 4.166666666666654e-03*G4_2_0_8_1_1_0 - 4.166666666666654e-03*G4_2_0_8_1_1_1 - 4.166666666666654e-03*G4_2_0_8_1_1_2 - 4.166666666666654e-03*G4_2_0_8_1_2_0 - 4.166666666666654e-03*G4_2_0_8_1_2_1 - 4.166666666666654e-03*G4_2_0_8_1_2_2 - 4.166666666666656e-03*G4_2_0_8_1_3_0 - 4.166666666666657e-03*G4_2_0_8_1_3_1 - 4.166666666666657e-03*G4_2_0_8_1_3_2 - 4.166666666666655e-03*G4_2_0_9_1_0_0 - 4.166666666666655e-03*G4_2_0_9_1_0_1 - 4.166666666666656e-03*G4_2_0_9_1_0_2 - 8.333333333333309e-03*G4_2_0_9_1_1_0 - 8.333333333333309e-03*G4_2_0_9_1_1_1 - 8.333333333333309e-03*G4_2_0_9_1_1_2 - 4.166666666666655e-03*G4_2_0_9_1_2_0 - 4.166666666666656e-03*G4_2_0_9_1_2_1 - 4.166666666666656e-03*G4_2_0_9_1_2_2 - 4.166666666666656e-03*G4_2_0_9_1_3_0 - 4.166666666666657e-03*G4_2_0_9_1_3_1 - 4.166666666666657e-03*G4_2_0_9_1_3_2 - 4.166666666666654e-03*G4_2_0_10_1_0_0 - 4.166666666666656e-03*G4_2_0_10_1_0_1 - 4.166666666666656e-03*G4_2_0_10_1_0_2 - 4.166666666666654e-03*G4_2_0_10_1_1_0 - 4.166666666666654e-03*G4_2_0_10_1_1_1 - 4.166666666666654e-03*G4_2_0_10_1_1_2 - 8.333333333333311e-03*G4_2_0_10_1_2_0 - 8.333333333333311e-03*G4_2_0_10_1_2_1 - 8.333333333333312e-03*G4_2_0_10_1_2_2 - 4.166666666666655e-03*G4_2_0_10_1_3_0 - 4.166666666666656e-03*G4_2_0_10_1_3_1 - 4.166666666666657e-03*G4_2_0_10_1_3_2 - 4.166666666666656e-03*G4_2_0_11_1_0_0 - 4.166666666666657e-03*G4_2_0_11_1_0_1 - 4.166666666666658e-03*G4_2_0_11_1_0_2 - 4.166666666666655e-03*G4_2_0_11_1_1_0 - 4.166666666666655e-03*G4_2_0_11_1_1_1 - 4.166666666666656e-03*G4_2_0_11_1_1_2 - 4.166666666666655e-03*G4_2_0_11_1_2_0 - 4.166666666666656e-03*G4_2_0_11_1_2_1 - 4.166666666666657e-03*G4_2_0_11_1_2_2 - 8.333333333333311e-03*G4_2_0_11_1_3_0 - 8.333333333333311e-03*G4_2_0_11_1_3_1 - 8.333333333333312e-03*G4_2_0_11_1_3_2 - 8.333333333333309e-03*G4_2_1_8_1_4_0 - 8.333333333333311e-03*G4_2_1_8_1_4_1 - 8.333333333333312e-03*G4_2_1_8_1_4_2 - 4.166666666666654e-03*G4_2_1_8_1_5_0 - 4.166666666666654e-03*G4_2_1_8_1_5_1 - 4.166666666666655e-03*G4_2_1_8_1_5_2 - 4.166666666666654e-03*G4_2_1_8_1_6_0 - 4.166666666666654e-03*G4_2_1_8_1_6_1 - 4.166666666666654e-03*G4_2_1_8_1_6_2 - 4.166666666666656e-03*G4_2_1_8_1_7_0 - 4.166666666666657e-03*G4_2_1_8_1_7_1 - 4.166666666666657e-03*G4_2_1_8_1_7_2 - 4.166666666666654e-03*G4_2_1_9_1_4_0 - 4.166666666666654e-03*G4_2_1_9_1_4_1 - 4.166666666666655e-03*G4_2_1_9_1_4_2 - 8.333333333333309e-03*G4_2_1_9_1_5_0 - 8.333333333333309e-03*G4_2_1_9_1_5_1 - 8.333333333333309e-03*G4_2_1_9_1_5_2 - 4.166666666666655e-03*G4_2_1_9_1_6_0 - 4.166666666666656e-03*G4_2_1_9_1_6_1 - 4.166666666666656e-03*G4_2_1_9_1_6_2 - 4.166666666666656e-03*G4_2_1_9_1_7_0 - 4.166666666666657e-03*G4_2_1_9_1_7_1 - 4.166666666666657e-03*G4_2_1_9_1_7_2 - 4.166666666666654e-03*G4_2_1_10_1_4_0 - 4.166666666666654e-03*G4_2_1_10_1_4_1 - 4.166666666666654e-03*G4_2_1_10_1_4_2 - 4.166666666666655e-03*G4_2_1_10_1_5_0 - 4.166666666666656e-03*G4_2_1_10_1_5_1 - 4.166666666666656e-03*G4_2_1_10_1_5_2 - 8.333333333333311e-03*G4_2_1_10_1_6_0 - 8.333333333333311e-03*G4_2_1_10_1_6_1 - 8.333333333333312e-03*G4_2_1_10_1_6_2 - 4.166666666666655e-03*G4_2_1_10_1_7_0 - 4.166666666666656e-03*G4_2_1_10_1_7_1 - 4.166666666666657e-03*G4_2_1_10_1_7_2 - 4.166666666666656e-03*G4_2_1_11_1_4_0 - 4.166666666666657e-03*G4_2_1_11_1_4_1 - 4.166666666666657e-03*G4_2_1_11_1_4_2 - 4.166666666666656e-03*G4_2_1_11_1_5_0 - 4.166666666666657e-03*G4_2_1_11_1_5_1 - 4.166666666666657e-03*G4_2_1_11_1_5_2 - 4.166666666666655e-03*G4_2_1_11_1_6_0 - 4.166666666666656e-03*G4_2_1_11_1_6_1 - 4.166666666666657e-03*G4_2_1_11_1_6_2 - 8.333333333333311e-03*G4_2_1_11_1_7_0 - 8.333333333333311e-03*G4_2_1_11_1_7_1 - 8.333333333333312e-03*G4_2_1_11_1_7_2 - 8.333333333333309e-03*G4_2_2_8_1_8_0 - 8.333333333333311e-03*G4_2_2_8_1_8_1 - 8.333333333333312e-03*G4_2_2_8_1_8_2 - 4.166666666666654e-03*G4_2_2_8_1_9_0 - 4.166666666666654e-03*G4_2_2_8_1_9_1 - 4.166666666666655e-03*G4_2_2_8_1_9_2 - 4.166666666666654e-03*G4_2_2_8_1_10_0 - 4.166666666666654e-03*G4_2_2_8_1_10_1 - 4.166666666666654e-03*G4_2_2_8_1_10_2 - 4.166666666666656e-03*G4_2_2_8_1_11_0 - 4.166666666666657e-03*G4_2_2_8_1_11_1 - 4.166666666666657e-03*G4_2_2_8_1_11_2 - 4.166666666666654e-03*G4_2_2_9_1_8_0 - 4.166666666666654e-03*G4_2_2_9_1_8_1 - 4.166666666666655e-03*G4_2_2_9_1_8_2 - 8.333333333333309e-03*G4_2_2_9_1_9_0 - 8.333333333333309e-03*G4_2_2_9_1_9_1 - 8.333333333333309e-03*G4_2_2_9_1_9_2 - 4.166666666666655e-03*G4_2_2_9_1_10_0 - 4.166666666666656e-03*G4_2_2_9_1_10_1 - 4.166666666666656e-03*G4_2_2_9_1_10_2 - 4.166666666666656e-03*G4_2_2_9_1_11_0 - 4.166666666666657e-03*G4_2_2_9_1_11_1 - 4.166666666666657e-03*G4_2_2_9_1_11_2 - 4.166666666666654e-03*G4_2_2_10_1_8_0 - 4.166666666666654e-03*G4_2_2_10_1_8_1 - 4.166666666666654e-03*G4_2_2_10_1_8_2 - 4.166666666666655e-03*G4_2_2_10_1_9_0 - 4.166666666666656e-03*G4_2_2_10_1_9_1 - 4.166666666666656e-03*G4_2_2_10_1_9_2 - 8.333333333333311e-03*G4_2_2_10_1_10_0 - 8.333333333333311e-03*G4_2_2_10_1_10_1 - 8.333333333333312e-03*G4_2_2_10_1_10_2 - 4.166666666666655e-03*G4_2_2_10_1_11_0 - 4.166666666666656e-03*G4_2_2_10_1_11_1 - 4.166666666666657e-03*G4_2_2_10_1_11_2 - 4.166666666666656e-03*G4_2_2_11_1_8_0 - 4.166666666666657e-03*G4_2_2_11_1_8_1 - 4.166666666666657e-03*G4_2_2_11_1_8_2 - 4.166666666666656e-03*G4_2_2_11_1_9_0 - 4.166666666666657e-03*G4_2_2_11_1_9_1 - 4.166666666666657e-03*G4_2_2_11_1_9_2 - 4.166666666666655e-03*G4_2_2_11_1_10_0 - 4.166666666666656e-03*G4_2_2_11_1_10_1 - 4.166666666666657e-03*G4_2_2_11_1_10_2 - 8.333333333333311e-03*G4_2_2_11_1_11_0 - 8.333333333333311e-03*G4_2_2_11_1_11_1 - 8.333333333333312e-03*G4_2_2_11_1_11_2;
    block[77] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_1_0 + 4.166666666666654e-03*G2_0_0_0 + 4.166666666666654e-03*G2_0_1_0 + 8.333333333333311e-03*G2_0_2_0 + 4.166666666666655e-03*G2_0_3_0 + 4.166666666666654e-03*G2_1_4_0 + 4.166666666666655e-03*G2_1_5_0 + 8.333333333333311e-03*G2_1_6_0 + 4.166666666666655e-03*G2_1_7_0 + 4.166666666666654e-03*G2_2_8_0 + 4.166666666666655e-03*G2_2_9_0 + 8.333333333333311e-03*G2_2_10_0 + 4.166666666666655e-03*G2_2_11_0 + 8.333333333333322e-02*G3_1_1_1_0 + 8.333333333333309e-03*G4_0_0_0_1_0_0 + 4.166666666666654e-03*G4_0_0_0_1_1_0 + 4.166666666666654e-03*G4_0_0_0_1_2_0 + 4.166666666666656e-03*G4_0_0_0_1_3_0 + 4.166666666666654e-03*G4_0_0_1_1_0_0 + 8.333333333333307e-03*G4_0_0_1_1_1_0 + 4.166666666666654e-03*G4_0_0_1_1_2_0 + 4.166666666666655e-03*G4_0_0_1_1_3_0 + 4.166666666666654e-03*G4_0_0_2_1_0_0 + 4.166666666666654e-03*G4_0_0_2_1_1_0 + 8.333333333333311e-03*G4_0_0_2_1_2_0 + 4.166666666666655e-03*G4_0_0_2_1_3_0 + 4.166666666666656e-03*G4_0_0_3_1_0_0 + 4.166666666666655e-03*G4_0_0_3_1_1_0 + 4.166666666666655e-03*G4_0_0_3_1_2_0 + 8.333333333333311e-03*G4_0_0_3_1_3_0 + 8.333333333333309e-03*G4_0_1_0_1_4_0 + 4.166666666666655e-03*G4_0_1_0_1_5_0 + 4.166666666666654e-03*G4_0_1_0_1_6_0 + 4.166666666666656e-03*G4_0_1_0_1_7_0 + 4.166666666666654e-03*G4_0_1_1_1_4_0 + 8.333333333333309e-03*G4_0_1_1_1_5_0 + 4.166666666666654e-03*G4_0_1_1_1_6_0 + 4.166666666666655e-03*G4_0_1_1_1_7_0 + 4.166666666666654e-03*G4_0_1_2_1_4_0 + 4.166666666666655e-03*G4_0_1_2_1_5_0 + 8.333333333333311e-03*G4_0_1_2_1_6_0 + 4.166666666666655e-03*G4_0_1_2_1_7_0 + 4.166666666666656e-03*G4_0_1_3_1_4_0 + 4.166666666666656e-03*G4_0_1_3_1_5_0 + 4.166666666666655e-03*G4_0_1_3_1_6_0 + 8.333333333333311e-03*G4_0_1_3_1_7_0 + 8.333333333333309e-03*G4_0_2_0_1_8_0 + 4.166666666666655e-03*G4_0_2_0_1_9_0 + 4.166666666666654e-03*G4_0_2_0_1_10_0 + 4.166666666666656e-03*G4_0_2_0_1_11_0 + 4.166666666666654e-03*G4_0_2_1_1_8_0 + 8.333333333333309e-03*G4_0_2_1_1_9_0 + 4.166666666666654e-03*G4_0_2_1_1_10_0 + 4.166666666666655e-03*G4_0_2_1_1_11_0 + 4.166666666666654e-03*G4_0_2_2_1_8_0 + 4.166666666666655e-03*G4_0_2_2_1_9_0 + 8.333333333333311e-03*G4_0_2_2_1_10_0 + 4.166666666666655e-03*G4_0_2_2_1_11_0 + 4.166666666666656e-03*G4_0_2_3_1_8_0 + 4.166666666666656e-03*G4_0_2_3_1_9_0 + 4.166666666666655e-03*G4_0_2_3_1_10_0 + 8.333333333333311e-03*G4_0_2_3_1_11_0 + 8.333333333333309e-03*G4_1_0_4_1_0_0 + 4.166666666666654e-03*G4_1_0_4_1_1_0 + 4.166666666666654e-03*G4_1_0_4_1_2_0 + 4.166666666666656e-03*G4_1_0_4_1_3_0 + 4.166666666666655e-03*G4_1_0_5_1_0_0 + 8.333333333333309e-03*G4_1_0_5_1_1_0 + 4.166666666666655e-03*G4_1_0_5_1_2_0 + 4.166666666666656e-03*G4_1_0_5_1_3_0 + 4.166666666666654e-03*G4_1_0_6_1_0_0 + 4.166666666666654e-03*G4_1_0_6_1_1_0 + 8.333333333333311e-03*G4_1_0_6_1_2_0 + 4.166666666666655e-03*G4_1_0_6_1_3_0 + 4.166666666666656e-03*G4_1_0_7_1_0_0 + 4.166666666666655e-03*G4_1_0_7_1_1_0 + 4.166666666666655e-03*G4_1_0_7_1_2_0 + 8.333333333333311e-03*G4_1_0_7_1_3_0 + 8.333333333333309e-03*G4_1_1_4_1_4_0 + 4.166666666666654e-03*G4_1_1_4_1_5_0 + 4.166666666666654e-03*G4_1_1_4_1_6_0 + 4.166666666666656e-03*G4_1_1_4_1_7_0 + 4.166666666666654e-03*G4_1_1_5_1_4_0 + 8.333333333333309e-03*G4_1_1_5_1_5_0 + 4.166666666666655e-03*G4_1_1_5_1_6_0 + 4.166666666666656e-03*G4_1_1_5_1_7_0 + 4.166666666666654e-03*G4_1_1_6_1_4_0 + 4.166666666666655e-03*G4_1_1_6_1_5_0 + 8.333333333333311e-03*G4_1_1_6_1_6_0 + 4.166666666666655e-03*G4_1_1_6_1_7_0 + 4.166666666666656e-03*G4_1_1_7_1_4_0 + 4.166666666666656e-03*G4_1_1_7_1_5_0 + 4.166666666666655e-03*G4_1_1_7_1_6_0 + 8.333333333333311e-03*G4_1_1_7_1_7_0 + 8.333333333333309e-03*G4_1_2_4_1_8_0 + 4.166666666666654e-03*G4_1_2_4_1_9_0 + 4.166666666666654e-03*G4_1_2_4_1_10_0 + 4.166666666666656e-03*G4_1_2_4_1_11_0 + 4.166666666666654e-03*G4_1_2_5_1_8_0 + 8.333333333333309e-03*G4_1_2_5_1_9_0 + 4.166666666666655e-03*G4_1_2_5_1_10_0 + 4.166666666666656e-03*G4_1_2_5_1_11_0 + 4.166666666666654e-03*G4_1_2_6_1_8_0 + 4.166666666666655e-03*G4_1_2_6_1_9_0 + 8.333333333333311e-03*G4_1_2_6_1_10_0 + 4.166666666666655e-03*G4_1_2_6_1_11_0 + 4.166666666666656e-03*G4_1_2_7_1_8_0 + 4.166666666666656e-03*G4_1_2_7_1_9_0 + 4.166666666666655e-03*G4_1_2_7_1_10_0 + 8.333333333333311e-03*G4_1_2_7_1_11_0 + 8.333333333333309e-03*G4_2_0_8_1_0_0 + 4.166666666666654e-03*G4_2_0_8_1_1_0 + 4.166666666666654e-03*G4_2_0_8_1_2_0 + 4.166666666666656e-03*G4_2_0_8_1_3_0 + 4.166666666666655e-03*G4_2_0_9_1_0_0 + 8.333333333333309e-03*G4_2_0_9_1_1_0 + 4.166666666666655e-03*G4_2_0_9_1_2_0 + 4.166666666666656e-03*G4_2_0_9_1_3_0 + 4.166666666666654e-03*G4_2_0_10_1_0_0 + 4.166666666666654e-03*G4_2_0_10_1_1_0 + 8.333333333333311e-03*G4_2_0_10_1_2_0 + 4.166666666666655e-03*G4_2_0_10_1_3_0 + 4.166666666666656e-03*G4_2_0_11_1_0_0 + 4.166666666666655e-03*G4_2_0_11_1_1_0 + 4.166666666666655e-03*G4_2_0_11_1_2_0 + 8.333333333333311e-03*G4_2_0_11_1_3_0 + 8.333333333333309e-03*G4_2_1_8_1_4_0 + 4.166666666666654e-03*G4_2_1_8_1_5_0 + 4.166666666666654e-03*G4_2_1_8_1_6_0 + 4.166666666666656e-03*G4_2_1_8_1_7_0 + 4.166666666666654e-03*G4_2_1_9_1_4_0 + 8.333333333333309e-03*G4_2_1_9_1_5_0 + 4.166666666666655e-03*G4_2_1_9_1_6_0 + 4.166666666666656e-03*G4_2_1_9_1_7_0 + 4.166666666666654e-03*G4_2_1_10_1_4_0 + 4.166666666666655e-03*G4_2_1_10_1_5_0 + 8.333333333333311e-03*G4_2_1_10_1_6_0 + 4.166666666666655e-03*G4_2_1_10_1_7_0 + 4.166666666666656e-03*G4_2_1_11_1_4_0 + 4.166666666666656e-03*G4_2_1_11_1_5_0 + 4.166666666666655e-03*G4_2_1_11_1_6_0 + 8.333333333333311e-03*G4_2_1_11_1_7_0 + 8.333333333333309e-03*G4_2_2_8_1_8_0 + 4.166666666666654e-03*G4_2_2_8_1_9_0 + 4.166666666666654e-03*G4_2_2_8_1_10_0 + 4.166666666666656e-03*G4_2_2_8_1_11_0 + 4.166666666666654e-03*G4_2_2_9_1_8_0 + 8.333333333333309e-03*G4_2_2_9_1_9_0 + 4.166666666666655e-03*G4_2_2_9_1_10_0 + 4.166666666666656e-03*G4_2_2_9_1_11_0 + 4.166666666666654e-03*G4_2_2_10_1_8_0 + 4.166666666666655e-03*G4_2_2_10_1_9_0 + 8.333333333333311e-03*G4_2_2_10_1_10_0 + 4.166666666666655e-03*G4_2_2_10_1_11_0 + 4.166666666666656e-03*G4_2_2_11_1_8_0 + 4.166666666666656e-03*G4_2_2_11_1_9_0 + 4.166666666666655e-03*G4_2_2_11_1_10_0 + 8.333333333333311e-03*G4_2_2_11_1_11_0;
    block[78] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_1_1 + 4.166666666666656e-03*G2_0_0_1 + 4.166666666666654e-03*G2_0_1_1 + 8.333333333333311e-03*G2_0_2_1 + 4.166666666666656e-03*G2_0_3_1 + 4.166666666666654e-03*G2_1_4_1 + 4.166666666666656e-03*G2_1_5_1 + 8.333333333333311e-03*G2_1_6_1 + 4.166666666666656e-03*G2_1_7_1 + 4.166666666666654e-03*G2_2_8_1 + 4.166666666666656e-03*G2_2_9_1 + 8.333333333333311e-03*G2_2_10_1 + 4.166666666666656e-03*G2_2_11_1 + 8.333333333333323e-02*G3_1_1_1_1 + 8.333333333333311e-03*G4_0_0_0_1_0_1 + 4.166666666666655e-03*G4_0_0_0_1_1_1 + 4.166666666666656e-03*G4_0_0_0_1_2_1 + 4.166666666666657e-03*G4_0_0_0_1_3_1 + 4.166666666666655e-03*G4_0_0_1_1_0_1 + 8.333333333333309e-03*G4_0_0_1_1_1_1 + 4.166666666666654e-03*G4_0_0_1_1_2_1 + 4.166666666666655e-03*G4_0_0_1_1_3_1 + 4.166666666666656e-03*G4_0_0_2_1_0_1 + 4.166666666666654e-03*G4_0_0_2_1_1_1 + 8.333333333333311e-03*G4_0_0_2_1_2_1 + 4.166666666666656e-03*G4_0_0_2_1_3_1 + 4.166666666666657e-03*G4_0_0_3_1_0_1 + 4.166666666666655e-03*G4_0_0_3_1_1_1 + 4.166666666666656e-03*G4_0_0_3_1_2_1 + 8.333333333333311e-03*G4_0_0_3_1_3_1 + 8.333333333333311e-03*G4_0_1_0_1_4_1 + 4.166666666666655e-03*G4_0_1_0_1_5_1 + 4.166666666666656e-03*G4_0_1_0_1_6_1 + 4.166666666666657e-03*G4_0_1_0_1_7_1 + 4.166666666666654e-03*G4_0_1_1_1_4_1 + 8.333333333333309e-03*G4_0_1_1_1_5_1 + 4.166666666666654e-03*G4_0_1_1_1_6_1 + 4.166666666666655e-03*G4_0_1_1_1_7_1 + 4.166666666666654e-03*G4_0_1_2_1_4_1 + 4.166666666666656e-03*G4_0_1_2_1_5_1 + 8.333333333333311e-03*G4_0_1_2_1_6_1 + 4.166666666666656e-03*G4_0_1_2_1_7_1 + 4.166666666666657e-03*G4_0_1_3_1_4_1 + 4.166666666666657e-03*G4_0_1_3_1_5_1 + 4.166666666666656e-03*G4_0_1_3_1_6_1 + 8.333333333333311e-03*G4_0_1_3_1_7_1 + 8.333333333333311e-03*G4_0_2_0_1_8_1 + 4.166666666666655e-03*G4_0_2_0_1_9_1 + 4.166666666666656e-03*G4_0_2_0_1_10_1 + 4.166666666666657e-03*G4_0_2_0_1_11_1 + 4.166666666666654e-03*G4_0_2_1_1_8_1 + 8.333333333333309e-03*G4_0_2_1_1_9_1 + 4.166666666666654e-03*G4_0_2_1_1_10_1 + 4.166666666666655e-03*G4_0_2_1_1_11_1 + 4.166666666666654e-03*G4_0_2_2_1_8_1 + 4.166666666666656e-03*G4_0_2_2_1_9_1 + 8.333333333333311e-03*G4_0_2_2_1_10_1 + 4.166666666666656e-03*G4_0_2_2_1_11_1 + 4.166666666666657e-03*G4_0_2_3_1_8_1 + 4.166666666666657e-03*G4_0_2_3_1_9_1 + 4.166666666666656e-03*G4_0_2_3_1_10_1 + 8.333333333333311e-03*G4_0_2_3_1_11_1 + 8.333333333333311e-03*G4_1_0_4_1_0_1 + 4.166666666666654e-03*G4_1_0_4_1_1_1 + 4.166666666666654e-03*G4_1_0_4_1_2_1 + 4.166666666666657e-03*G4_1_0_4_1_3_1 + 4.166666666666655e-03*G4_1_0_5_1_0_1 + 8.333333333333309e-03*G4_1_0_5_1_1_1 + 4.166666666666656e-03*G4_1_0_5_1_2_1 + 4.166666666666657e-03*G4_1_0_5_1_3_1 + 4.166666666666656e-03*G4_1_0_6_1_0_1 + 4.166666666666654e-03*G4_1_0_6_1_1_1 + 8.333333333333311e-03*G4_1_0_6_1_2_1 + 4.166666666666656e-03*G4_1_0_6_1_3_1 + 4.166666666666657e-03*G4_1_0_7_1_0_1 + 4.166666666666655e-03*G4_1_0_7_1_1_1 + 4.166666666666656e-03*G4_1_0_7_1_2_1 + 8.333333333333311e-03*G4_1_0_7_1_3_1 + 8.333333333333311e-03*G4_1_1_4_1_4_1 + 4.166666666666654e-03*G4_1_1_4_1_5_1 + 4.166666666666654e-03*G4_1_1_4_1_6_1 + 4.166666666666657e-03*G4_1_1_4_1_7_1 + 4.166666666666654e-03*G4_1_1_5_1_4_1 + 8.333333333333309e-03*G4_1_1_5_1_5_1 + 4.166666666666656e-03*G4_1_1_5_1_6_1 + 4.166666666666657e-03*G4_1_1_5_1_7_1 + 4.166666666666654e-03*G4_1_1_6_1_4_1 + 4.166666666666656e-03*G4_1_1_6_1_5_1 + 8.333333333333311e-03*G4_1_1_6_1_6_1 + 4.166666666666656e-03*G4_1_1_6_1_7_1 + 4.166666666666657e-03*G4_1_1_7_1_4_1 + 4.166666666666657e-03*G4_1_1_7_1_5_1 + 4.166666666666656e-03*G4_1_1_7_1_6_1 + 8.333333333333311e-03*G4_1_1_7_1_7_1 + 8.333333333333311e-03*G4_1_2_4_1_8_1 + 4.166666666666654e-03*G4_1_2_4_1_9_1 + 4.166666666666654e-03*G4_1_2_4_1_10_1 + 4.166666666666657e-03*G4_1_2_4_1_11_1 + 4.166666666666654e-03*G4_1_2_5_1_8_1 + 8.333333333333309e-03*G4_1_2_5_1_9_1 + 4.166666666666656e-03*G4_1_2_5_1_10_1 + 4.166666666666657e-03*G4_1_2_5_1_11_1 + 4.166666666666654e-03*G4_1_2_6_1_8_1 + 4.166666666666656e-03*G4_1_2_6_1_9_1 + 8.333333333333311e-03*G4_1_2_6_1_10_1 + 4.166666666666656e-03*G4_1_2_6_1_11_1 + 4.166666666666657e-03*G4_1_2_7_1_8_1 + 4.166666666666657e-03*G4_1_2_7_1_9_1 + 4.166666666666656e-03*G4_1_2_7_1_10_1 + 8.333333333333311e-03*G4_1_2_7_1_11_1 + 8.333333333333311e-03*G4_2_0_8_1_0_1 + 4.166666666666654e-03*G4_2_0_8_1_1_1 + 4.166666666666654e-03*G4_2_0_8_1_2_1 + 4.166666666666657e-03*G4_2_0_8_1_3_1 + 4.166666666666655e-03*G4_2_0_9_1_0_1 + 8.333333333333309e-03*G4_2_0_9_1_1_1 + 4.166666666666656e-03*G4_2_0_9_1_2_1 + 4.166666666666657e-03*G4_2_0_9_1_3_1 + 4.166666666666656e-03*G4_2_0_10_1_0_1 + 4.166666666666654e-03*G4_2_0_10_1_1_1 + 8.333333333333311e-03*G4_2_0_10_1_2_1 + 4.166666666666656e-03*G4_2_0_10_1_3_1 + 4.166666666666657e-03*G4_2_0_11_1_0_1 + 4.166666666666655e-03*G4_2_0_11_1_1_1 + 4.166666666666656e-03*G4_2_0_11_1_2_1 + 8.333333333333311e-03*G4_2_0_11_1_3_1 + 8.333333333333311e-03*G4_2_1_8_1_4_1 + 4.166666666666654e-03*G4_2_1_8_1_5_1 + 4.166666666666654e-03*G4_2_1_8_1_6_1 + 4.166666666666657e-03*G4_2_1_8_1_7_1 + 4.166666666666654e-03*G4_2_1_9_1_4_1 + 8.333333333333309e-03*G4_2_1_9_1_5_1 + 4.166666666666656e-03*G4_2_1_9_1_6_1 + 4.166666666666657e-03*G4_2_1_9_1_7_1 + 4.166666666666654e-03*G4_2_1_10_1_4_1 + 4.166666666666656e-03*G4_2_1_10_1_5_1 + 8.333333333333311e-03*G4_2_1_10_1_6_1 + 4.166666666666656e-03*G4_2_1_10_1_7_1 + 4.166666666666657e-03*G4_2_1_11_1_4_1 + 4.166666666666657e-03*G4_2_1_11_1_5_1 + 4.166666666666656e-03*G4_2_1_11_1_6_1 + 8.333333333333311e-03*G4_2_1_11_1_7_1 + 8.333333333333311e-03*G4_2_2_8_1_8_1 + 4.166666666666654e-03*G4_2_2_8_1_9_1 + 4.166666666666654e-03*G4_2_2_8_1_10_1 + 4.166666666666657e-03*G4_2_2_8_1_11_1 + 4.166666666666654e-03*G4_2_2_9_1_8_1 + 8.333333333333309e-03*G4_2_2_9_1_9_1 + 4.166666666666656e-03*G4_2_2_9_1_10_1 + 4.166666666666657e-03*G4_2_2_9_1_11_1 + 4.166666666666654e-03*G4_2_2_10_1_8_1 + 4.166666666666656e-03*G4_2_2_10_1_9_1 + 8.333333333333311e-03*G4_2_2_10_1_10_1 + 4.166666666666656e-03*G4_2_2_10_1_11_1 + 4.166666666666657e-03*G4_2_2_11_1_8_1 + 4.166666666666657e-03*G4_2_2_11_1_9_1 + 4.166666666666656e-03*G4_2_2_11_1_10_1 + 8.333333333333311e-03*G4_2_2_11_1_11_1;
    block[79] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_1_2 + 4.166666666666656e-03*G2_0_0_2 + 4.166666666666654e-03*G2_0_1_2 + 8.333333333333311e-03*G2_0_2_2 + 4.166666666666656e-03*G2_0_3_2 + 4.166666666666654e-03*G2_1_4_2 + 4.166666666666656e-03*G2_1_5_2 + 8.333333333333311e-03*G2_1_6_2 + 4.166666666666656e-03*G2_1_7_2 + 4.166666666666654e-03*G2_2_8_2 + 4.166666666666656e-03*G2_2_9_2 + 8.333333333333311e-03*G2_2_10_2 + 4.166666666666656e-03*G2_2_11_2 + 8.333333333333323e-02*G3_1_1_1_2 + 8.333333333333311e-03*G4_0_0_0_1_0_2 + 4.166666666666655e-03*G4_0_0_0_1_1_2 + 4.166666666666656e-03*G4_0_0_0_1_2_2 + 4.166666666666657e-03*G4_0_0_0_1_3_2 + 4.166666666666655e-03*G4_0_0_1_1_0_2 + 8.333333333333309e-03*G4_0_0_1_1_1_2 + 4.166666666666654e-03*G4_0_0_1_1_2_2 + 4.166666666666655e-03*G4_0_0_1_1_3_2 + 4.166666666666656e-03*G4_0_0_2_1_0_2 + 4.166666666666654e-03*G4_0_0_2_1_1_2 + 8.333333333333311e-03*G4_0_0_2_1_2_2 + 4.166666666666656e-03*G4_0_0_2_1_3_2 + 4.166666666666657e-03*G4_0_0_3_1_0_2 + 4.166666666666655e-03*G4_0_0_3_1_1_2 + 4.166666666666656e-03*G4_0_0_3_1_2_2 + 8.333333333333311e-03*G4_0_0_3_1_3_2 + 8.333333333333311e-03*G4_0_1_0_1_4_2 + 4.166666666666655e-03*G4_0_1_0_1_5_2 + 4.166666666666656e-03*G4_0_1_0_1_6_2 + 4.166666666666657e-03*G4_0_1_0_1_7_2 + 4.166666666666654e-03*G4_0_1_1_1_4_2 + 8.333333333333309e-03*G4_0_1_1_1_5_2 + 4.166666666666654e-03*G4_0_1_1_1_6_2 + 4.166666666666655e-03*G4_0_1_1_1_7_2 + 4.166666666666654e-03*G4_0_1_2_1_4_2 + 4.166666666666656e-03*G4_0_1_2_1_5_2 + 8.333333333333311e-03*G4_0_1_2_1_6_2 + 4.166666666666656e-03*G4_0_1_2_1_7_2 + 4.166666666666657e-03*G4_0_1_3_1_4_2 + 4.166666666666657e-03*G4_0_1_3_1_5_2 + 4.166666666666656e-03*G4_0_1_3_1_6_2 + 8.333333333333311e-03*G4_0_1_3_1_7_2 + 8.333333333333311e-03*G4_0_2_0_1_8_2 + 4.166666666666655e-03*G4_0_2_0_1_9_2 + 4.166666666666656e-03*G4_0_2_0_1_10_2 + 4.166666666666657e-03*G4_0_2_0_1_11_2 + 4.166666666666654e-03*G4_0_2_1_1_8_2 + 8.333333333333309e-03*G4_0_2_1_1_9_2 + 4.166666666666654e-03*G4_0_2_1_1_10_2 + 4.166666666666655e-03*G4_0_2_1_1_11_2 + 4.166666666666654e-03*G4_0_2_2_1_8_2 + 4.166666666666656e-03*G4_0_2_2_1_9_2 + 8.333333333333311e-03*G4_0_2_2_1_10_2 + 4.166666666666656e-03*G4_0_2_2_1_11_2 + 4.166666666666657e-03*G4_0_2_3_1_8_2 + 4.166666666666657e-03*G4_0_2_3_1_9_2 + 4.166666666666656e-03*G4_0_2_3_1_10_2 + 8.333333333333311e-03*G4_0_2_3_1_11_2 + 8.333333333333311e-03*G4_1_0_4_1_0_2 + 4.166666666666654e-03*G4_1_0_4_1_1_2 + 4.166666666666654e-03*G4_1_0_4_1_2_2 + 4.166666666666657e-03*G4_1_0_4_1_3_2 + 4.166666666666655e-03*G4_1_0_5_1_0_2 + 8.333333333333309e-03*G4_1_0_5_1_1_2 + 4.166666666666656e-03*G4_1_0_5_1_2_2 + 4.166666666666657e-03*G4_1_0_5_1_3_2 + 4.166666666666656e-03*G4_1_0_6_1_0_2 + 4.166666666666654e-03*G4_1_0_6_1_1_2 + 8.333333333333311e-03*G4_1_0_6_1_2_2 + 4.166666666666656e-03*G4_1_0_6_1_3_2 + 4.166666666666657e-03*G4_1_0_7_1_0_2 + 4.166666666666655e-03*G4_1_0_7_1_1_2 + 4.166666666666656e-03*G4_1_0_7_1_2_2 + 8.333333333333311e-03*G4_1_0_7_1_3_2 + 8.333333333333311e-03*G4_1_1_4_1_4_2 + 4.166666666666654e-03*G4_1_1_4_1_5_2 + 4.166666666666654e-03*G4_1_1_4_1_6_2 + 4.166666666666657e-03*G4_1_1_4_1_7_2 + 4.166666666666654e-03*G4_1_1_5_1_4_2 + 8.333333333333309e-03*G4_1_1_5_1_5_2 + 4.166666666666656e-03*G4_1_1_5_1_6_2 + 4.166666666666657e-03*G4_1_1_5_1_7_2 + 4.166666666666654e-03*G4_1_1_6_1_4_2 + 4.166666666666656e-03*G4_1_1_6_1_5_2 + 8.333333333333311e-03*G4_1_1_6_1_6_2 + 4.166666666666656e-03*G4_1_1_6_1_7_2 + 4.166666666666657e-03*G4_1_1_7_1_4_2 + 4.166666666666657e-03*G4_1_1_7_1_5_2 + 4.166666666666656e-03*G4_1_1_7_1_6_2 + 8.333333333333311e-03*G4_1_1_7_1_7_2 + 8.333333333333311e-03*G4_1_2_4_1_8_2 + 4.166666666666654e-03*G4_1_2_4_1_9_2 + 4.166666666666654e-03*G4_1_2_4_1_10_2 + 4.166666666666657e-03*G4_1_2_4_1_11_2 + 4.166666666666654e-03*G4_1_2_5_1_8_2 + 8.333333333333309e-03*G4_1_2_5_1_9_2 + 4.166666666666656e-03*G4_1_2_5_1_10_2 + 4.166666666666657e-03*G4_1_2_5_1_11_2 + 4.166666666666654e-03*G4_1_2_6_1_8_2 + 4.166666666666656e-03*G4_1_2_6_1_9_2 + 8.333333333333311e-03*G4_1_2_6_1_10_2 + 4.166666666666656e-03*G4_1_2_6_1_11_2 + 4.166666666666657e-03*G4_1_2_7_1_8_2 + 4.166666666666657e-03*G4_1_2_7_1_9_2 + 4.166666666666656e-03*G4_1_2_7_1_10_2 + 8.333333333333311e-03*G4_1_2_7_1_11_2 + 8.333333333333311e-03*G4_2_0_8_1_0_2 + 4.166666666666654e-03*G4_2_0_8_1_1_2 + 4.166666666666654e-03*G4_2_0_8_1_2_2 + 4.166666666666657e-03*G4_2_0_8_1_3_2 + 4.166666666666655e-03*G4_2_0_9_1_0_2 + 8.333333333333309e-03*G4_2_0_9_1_1_2 + 4.166666666666656e-03*G4_2_0_9_1_2_2 + 4.166666666666657e-03*G4_2_0_9_1_3_2 + 4.166666666666656e-03*G4_2_0_10_1_0_2 + 4.166666666666654e-03*G4_2_0_10_1_1_2 + 8.333333333333311e-03*G4_2_0_10_1_2_2 + 4.166666666666656e-03*G4_2_0_10_1_3_2 + 4.166666666666657e-03*G4_2_0_11_1_0_2 + 4.166666666666655e-03*G4_2_0_11_1_1_2 + 4.166666666666656e-03*G4_2_0_11_1_2_2 + 8.333333333333311e-03*G4_2_0_11_1_3_2 + 8.333333333333311e-03*G4_2_1_8_1_4_2 + 4.166666666666654e-03*G4_2_1_8_1_5_2 + 4.166666666666654e-03*G4_2_1_8_1_6_2 + 4.166666666666657e-03*G4_2_1_8_1_7_2 + 4.166666666666654e-03*G4_2_1_9_1_4_2 + 8.333333333333309e-03*G4_2_1_9_1_5_2 + 4.166666666666656e-03*G4_2_1_9_1_6_2 + 4.166666666666657e-03*G4_2_1_9_1_7_2 + 4.166666666666654e-03*G4_2_1_10_1_4_2 + 4.166666666666656e-03*G4_2_1_10_1_5_2 + 8.333333333333311e-03*G4_2_1_10_1_6_2 + 4.166666666666656e-03*G4_2_1_10_1_7_2 + 4.166666666666657e-03*G4_2_1_11_1_4_2 + 4.166666666666657e-03*G4_2_1_11_1_5_2 + 4.166666666666656e-03*G4_2_1_11_1_6_2 + 8.333333333333311e-03*G4_2_1_11_1_7_2 + 8.333333333333311e-03*G4_2_2_8_1_8_2 + 4.166666666666654e-03*G4_2_2_8_1_9_2 + 4.166666666666654e-03*G4_2_2_8_1_10_2 + 4.166666666666657e-03*G4_2_2_8_1_11_2 + 4.166666666666654e-03*G4_2_2_9_1_8_2 + 8.333333333333309e-03*G4_2_2_9_1_9_2 + 4.166666666666656e-03*G4_2_2_9_1_10_2 + 4.166666666666657e-03*G4_2_2_9_1_11_2 + 4.166666666666654e-03*G4_2_2_10_1_8_2 + 4.166666666666656e-03*G4_2_2_10_1_9_2 + 8.333333333333311e-03*G4_2_2_10_1_10_2 + 4.166666666666656e-03*G4_2_2_10_1_11_2 + 4.166666666666657e-03*G4_2_2_11_1_8_2 + 4.166666666666657e-03*G4_2_2_11_1_9_2 + 4.166666666666656e-03*G4_2_2_11_1_10_2 + 8.333333333333311e-03*G4_2_2_11_1_11_2;
    block[80] = -8.333333333333322e-02*G3_1_2_1_0 - 8.333333333333323e-02*G3_1_2_1_1 - 8.333333333333323e-02*G3_1_2_1_2;
    block[81] = 8.333333333333322e-02*G3_1_2_1_0;
    block[82] = 8.333333333333323e-02*G3_1_2_1_1;
    block[83] = 8.333333333333323e-02*G3_1_2_1_2;
    block[84] = -8.333333333333322e-02*G3_1_0_2_0 - 8.333333333333323e-02*G3_1_0_2_1 - 8.333333333333322e-02*G3_1_0_2_2;
    block[85] = 8.333333333333322e-02*G3_1_0_2_0;
    block[86] = 8.333333333333323e-02*G3_1_0_2_1;
    block[87] = 8.333333333333323e-02*G3_1_0_2_2;
    block[88] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_2_0 - 8.333333333333323e-02*G1_2_1 - 8.333333333333323e-02*G1_2_2 - 4.166666666666656e-03*G2_0_0_0 - 4.166666666666657e-03*G2_0_0_1 - 4.166666666666658e-03*G2_0_0_2 - 4.166666666666655e-03*G2_0_1_0 - 4.166666666666655e-03*G2_0_1_1 - 4.166666666666656e-03*G2_0_1_2 - 4.166666666666655e-03*G2_0_2_0 - 4.166666666666656e-03*G2_0_2_1 - 4.166666666666657e-03*G2_0_2_2 - 8.333333333333311e-03*G2_0_3_0 - 8.333333333333311e-03*G2_0_3_1 - 8.333333333333312e-03*G2_0_3_2 - 4.166666666666656e-03*G2_1_4_0 - 4.166666666666657e-03*G2_1_4_1 - 4.166666666666657e-03*G2_1_4_2 - 4.166666666666656e-03*G2_1_5_0 - 4.166666666666657e-03*G2_1_5_1 - 4.166666666666657e-03*G2_1_5_2 - 4.166666666666655e-03*G2_1_6_0 - 4.166666666666656e-03*G2_1_6_1 - 4.166666666666657e-03*G2_1_6_2 - 8.333333333333311e-03*G2_1_7_0 - 8.333333333333311e-03*G2_1_7_1 - 8.333333333333312e-03*G2_1_7_2 - 4.166666666666656e-03*G2_2_8_0 - 4.166666666666657e-03*G2_2_8_1 - 4.166666666666657e-03*G2_2_8_2 - 4.166666666666656e-03*G2_2_9_0 - 4.166666666666657e-03*G2_2_9_1 - 4.166666666666657e-03*G2_2_9_2 - 4.166666666666655e-03*G2_2_10_0 - 4.166666666666656e-03*G2_2_10_1 - 4.166666666666657e-03*G2_2_10_2 - 8.333333333333311e-03*G2_2_11_0 - 8.333333333333311e-03*G2_2_11_1 - 8.333333333333312e-03*G2_2_11_2 - 8.333333333333322e-02*G3_1_1_2_0 - 8.333333333333323e-02*G3_1_1_2_1 - 8.333333333333323e-02*G3_1_1_2_2 - 8.333333333333309e-03*G4_0_0_0_2_0_0 - 8.333333333333311e-03*G4_0_0_0_2_0_1 - 8.333333333333312e-03*G4_0_0_0_2_0_2 - 4.166666666666654e-03*G4_0_0_0_2_1_0 - 4.166666666666655e-03*G4_0_0_0_2_1_1 - 4.166666666666655e-03*G4_0_0_0_2_1_2 - 4.166666666666654e-03*G4_0_0_0_2_2_0 - 4.166666666666656e-03*G4_0_0_0_2_2_1 - 4.166666666666656e-03*G4_0_0_0_2_2_2 - 4.166666666666656e-03*G4_0_0_0_2_3_0 - 4.166666666666657e-03*G4_0_0_0_2_3_1 - 4.166666666666658e-03*G4_0_0_0_2_3_2 - 4.166666666666654e-03*G4_0_0_1_2_0_0 - 4.166666666666655e-03*G4_0_0_1_2_0_1 - 4.166666666666655e-03*G4_0_0_1_2_0_2 - 8.333333333333307e-03*G4_0_0_1_2_1_0 - 8.333333333333309e-03*G4_0_0_1_2_1_1 - 8.333333333333309e-03*G4_0_0_1_2_1_2 - 4.166666666666654e-03*G4_0_0_1_2_2_0 - 4.166666666666654e-03*G4_0_0_1_2_2_1 - 4.166666666666655e-03*G4_0_0_1_2_2_2 - 4.166666666666655e-03*G4_0_0_1_2_3_0 - 4.166666666666655e-03*G4_0_0_1_2_3_1 - 4.166666666666656e-03*G4_0_0_1_2_3_2 - 4.166666666666654e-03*G4_0_0_2_2_0_0 - 4.166666666666656e-03*G4_0_0_2_2_0_1 - 4.166666666666656e-03*G4_0_0_2_2_0_2 - 4.166666666666654e-03*G4_0_0_2_2_1_0 - 4.166666666666654e-03*G4_0_0_2_2_1_1 - 4.166666666666654e-03*G4_0_0_2_2_1_2 - 8.333333333333311e-03*G4_0_0_2_2_2_0 - 8.333333333333311e-03*G4_0_0_2_2_2_1 - 8.333333333333312e-03*G4_0_0_2_2_2_2 - 4.166666666666655e-03*G4_0_0_2_2_3_0 - 4.166666666666656e-03*G4_0_0_2_2_3_1 - 4.166666666666657e-03*G4_0_0_2_2_3_2 - 4.166666666666656e-03*G4_0_0_3_2_0_0 - 4.166666666666657e-03*G4_0_0_3_2_0_1 - 4.166666666666658e-03*G4_0_0_3_2_0_2 - 4.166666666666655e-03*G4_0_0_3_2_1_0 - 4.166666666666655e-03*G4_0_0_3_2_1_1 - 4.166666666666656e-03*G4_0_0_3_2_1_2 - 4.166666666666655e-03*G4_0_0_3_2_2_0 - 4.166666666666656e-03*G4_0_0_3_2_2_1 - 4.166666666666657e-03*G4_0_0_3_2_2_2 - 8.333333333333311e-03*G4_0_0_3_2_3_0 - 8.333333333333311e-03*G4_0_0_3_2_3_1 - 8.333333333333312e-03*G4_0_0_3_2_3_2 - 8.333333333333309e-03*G4_0_1_0_2_4_0 - 8.333333333333311e-03*G4_0_1_0_2_4_1 - 8.333333333333312e-03*G4_0_1_0_2_4_2 - 4.166666666666655e-03*G4_0_1_0_2_5_0 - 4.166666666666655e-03*G4_0_1_0_2_5_1 - 4.166666666666656e-03*G4_0_1_0_2_5_2 - 4.166666666666654e-03*G4_0_1_0_2_6_0 - 4.166666666666656e-03*G4_0_1_0_2_6_1 - 4.166666666666656e-03*G4_0_1_0_2_6_2 - 4.166666666666656e-03*G4_0_1_0_2_7_0 - 4.166666666666657e-03*G4_0_1_0_2_7_1 - 4.166666666666658e-03*G4_0_1_0_2_7_2 - 4.166666666666654e-03*G4_0_1_1_2_4_0 - 4.166666666666654e-03*G4_0_1_1_2_4_1 - 4.166666666666654e-03*G4_0_1_1_2_4_2 - 8.333333333333309e-03*G4_0_1_1_2_5_0 - 8.333333333333309e-03*G4_0_1_1_2_5_1 - 8.333333333333309e-03*G4_0_1_1_2_5_2 - 4.166666666666654e-03*G4_0_1_1_2_6_0 - 4.166666666666654e-03*G4_0_1_1_2_6_1 - 4.166666666666655e-03*G4_0_1_1_2_6_2 - 4.166666666666655e-03*G4_0_1_1_2_7_0 - 4.166666666666655e-03*G4_0_1_1_2_7_1 - 4.166666666666656e-03*G4_0_1_1_2_7_2 - 4.166666666666654e-03*G4_0_1_2_2_4_0 - 4.166666666666654e-03*G4_0_1_2_2_4_1 - 4.166666666666654e-03*G4_0_1_2_2_4_2 - 4.166666666666655e-03*G4_0_1_2_2_5_0 - 4.166666666666656e-03*G4_0_1_2_2_5_1 - 4.166666666666656e-03*G4_0_1_2_2_5_2 - 8.333333333333311e-03*G4_0_1_2_2_6_0 - 8.333333333333311e-03*G4_0_1_2_2_6_1 - 8.333333333333312e-03*G4_0_1_2_2_6_2 - 4.166666666666655e-03*G4_0_1_2_2_7_0 - 4.166666666666656e-03*G4_0_1_2_2_7_1 - 4.166666666666657e-03*G4_0_1_2_2_7_2 - 4.166666666666656e-03*G4_0_1_3_2_4_0 - 4.166666666666657e-03*G4_0_1_3_2_4_1 - 4.166666666666657e-03*G4_0_1_3_2_4_2 - 4.166666666666656e-03*G4_0_1_3_2_5_0 - 4.166666666666657e-03*G4_0_1_3_2_5_1 - 4.166666666666657e-03*G4_0_1_3_2_5_2 - 4.166666666666655e-03*G4_0_1_3_2_6_0 - 4.166666666666656e-03*G4_0_1_3_2_6_1 - 4.166666666666657e-03*G4_0_1_3_2_6_2 - 8.333333333333311e-03*G4_0_1_3_2_7_0 - 8.333333333333311e-03*G4_0_1_3_2_7_1 - 8.333333333333312e-03*G4_0_1_3_2_7_2 - 8.333333333333309e-03*G4_0_2_0_2_8_0 - 8.333333333333311e-03*G4_0_2_0_2_8_1 - 8.333333333333312e-03*G4_0_2_0_2_8_2 - 4.166666666666655e-03*G4_0_2_0_2_9_0 - 4.166666666666655e-03*G4_0_2_0_2_9_1 - 4.166666666666656e-03*G4_0_2_0_2_9_2 - 4.166666666666654e-03*G4_0_2_0_2_10_0 - 4.166666666666656e-03*G4_0_2_0_2_10_1 - 4.166666666666656e-03*G4_0_2_0_2_10_2 - 4.166666666666656e-03*G4_0_2_0_2_11_0 - 4.166666666666657e-03*G4_0_2_0_2_11_1 - 4.166666666666658e-03*G4_0_2_0_2_11_2 - 4.166666666666654e-03*G4_0_2_1_2_8_0 - 4.166666666666654e-03*G4_0_2_1_2_8_1 - 4.166666666666654e-03*G4_0_2_1_2_8_2 - 8.333333333333309e-03*G4_0_2_1_2_9_0 - 8.333333333333309e-03*G4_0_2_1_2_9_1 - 8.333333333333309e-03*G4_0_2_1_2_9_2 - 4.166666666666654e-03*G4_0_2_1_2_10_0 - 4.166666666666654e-03*G4_0_2_1_2_10_1 - 4.166666666666655e-03*G4_0_2_1_2_10_2 - 4.166666666666655e-03*G4_0_2_1_2_11_0 - 4.166666666666655e-03*G4_0_2_1_2_11_1 - 4.166666666666656e-03*G4_0_2_1_2_11_2 - 4.166666666666654e-03*G4_0_2_2_2_8_0 - 4.166666666666654e-03*G4_0_2_2_2_8_1 - 4.166666666666654e-03*G4_0_2_2_2_8_2 - 4.166666666666655e-03*G4_0_2_2_2_9_0 - 4.166666666666656e-03*G4_0_2_2_2_9_1 - 4.166666666666656e-03*G4_0_2_2_2_9_2 - 8.333333333333311e-03*G4_0_2_2_2_10_0 - 8.333333333333311e-03*G4_0_2_2_2_10_1 - 8.333333333333312e-03*G4_0_2_2_2_10_2 - 4.166666666666655e-03*G4_0_2_2_2_11_0 - 4.166666666666656e-03*G4_0_2_2_2_11_1 - 4.166666666666657e-03*G4_0_2_2_2_11_2 - 4.166666666666656e-03*G4_0_2_3_2_8_0 - 4.166666666666657e-03*G4_0_2_3_2_8_1 - 4.166666666666657e-03*G4_0_2_3_2_8_2 - 4.166666666666656e-03*G4_0_2_3_2_9_0 - 4.166666666666657e-03*G4_0_2_3_2_9_1 - 4.166666666666657e-03*G4_0_2_3_2_9_2 - 4.166666666666655e-03*G4_0_2_3_2_10_0 - 4.166666666666656e-03*G4_0_2_3_2_10_1 - 4.166666666666657e-03*G4_0_2_3_2_10_2 - 8.333333333333311e-03*G4_0_2_3_2_11_0 - 8.333333333333311e-03*G4_0_2_3_2_11_1 - 8.333333333333312e-03*G4_0_2_3_2_11_2 - 8.333333333333309e-03*G4_1_0_4_2_0_0 - 8.333333333333311e-03*G4_1_0_4_2_0_1 - 8.333333333333312e-03*G4_1_0_4_2_0_2 - 4.166666666666654e-03*G4_1_0_4_2_1_0 - 4.166666666666654e-03*G4_1_0_4_2_1_1 - 4.166666666666654e-03*G4_1_0_4_2_1_2 - 4.166666666666654e-03*G4_1_0_4_2_2_0 - 4.166666666666654e-03*G4_1_0_4_2_2_1 - 4.166666666666654e-03*G4_1_0_4_2_2_2 - 4.166666666666656e-03*G4_1_0_4_2_3_0 - 4.166666666666657e-03*G4_1_0_4_2_3_1 - 4.166666666666657e-03*G4_1_0_4_2_3_2 - 4.166666666666655e-03*G4_1_0_5_2_0_0 - 4.166666666666655e-03*G4_1_0_5_2_0_1 - 4.166666666666656e-03*G4_1_0_5_2_0_2 - 8.333333333333309e-03*G4_1_0_5_2_1_0 - 8.333333333333309e-03*G4_1_0_5_2_1_1 - 8.333333333333309e-03*G4_1_0_5_2_1_2 - 4.166666666666655e-03*G4_1_0_5_2_2_0 - 4.166666666666656e-03*G4_1_0_5_2_2_1 - 4.166666666666656e-03*G4_1_0_5_2_2_2 - 4.166666666666656e-03*G4_1_0_5_2_3_0 - 4.166666666666657e-03*G4_1_0_5_2_3_1 - 4.166666666666657e-03*G4_1_0_5_2_3_2 - 4.166666666666654e-03*G4_1_0_6_2_0_0 - 4.166666666666656e-03*G4_1_0_6_2_0_1 - 4.166666666666656e-03*G4_1_0_6_2_0_2 - 4.166666666666654e-03*G4_1_0_6_2_1_0 - 4.166666666666654e-03*G4_1_0_6_2_1_1 - 4.166666666666654e-03*G4_1_0_6_2_1_2 - 8.333333333333311e-03*G4_1_0_6_2_2_0 - 8.333333333333311e-03*G4_1_0_6_2_2_1 - 8.333333333333312e-03*G4_1_0_6_2_2_2 - 4.166666666666655e-03*G4_1_0_6_2_3_0 - 4.166666666666656e-03*G4_1_0_6_2_3_1 - 4.166666666666657e-03*G4_1_0_6_2_3_2 - 4.166666666666656e-03*G4_1_0_7_2_0_0 - 4.166666666666657e-03*G4_1_0_7_2_0_1 - 4.166666666666658e-03*G4_1_0_7_2_0_2 - 4.166666666666655e-03*G4_1_0_7_2_1_0 - 4.166666666666655e-03*G4_1_0_7_2_1_1 - 4.166666666666656e-03*G4_1_0_7_2_1_2 - 4.166666666666655e-03*G4_1_0_7_2_2_0 - 4.166666666666656e-03*G4_1_0_7_2_2_1 - 4.166666666666657e-03*G4_1_0_7_2_2_2 - 8.333333333333311e-03*G4_1_0_7_2_3_0 - 8.333333333333311e-03*G4_1_0_7_2_3_1 - 8.333333333333312e-03*G4_1_0_7_2_3_2 - 8.333333333333309e-03*G4_1_1_4_2_4_0 - 8.333333333333311e-03*G4_1_1_4_2_4_1 - 8.333333333333312e-03*G4_1_1_4_2_4_2 - 4.166666666666654e-03*G4_1_1_4_2_5_0 - 4.166666666666654e-03*G4_1_1_4_2_5_1 - 4.166666666666655e-03*G4_1_1_4_2_5_2 - 4.166666666666654e-03*G4_1_1_4_2_6_0 - 4.166666666666654e-03*G4_1_1_4_2_6_1 - 4.166666666666654e-03*G4_1_1_4_2_6_2 - 4.166666666666656e-03*G4_1_1_4_2_7_0 - 4.166666666666657e-03*G4_1_1_4_2_7_1 - 4.166666666666657e-03*G4_1_1_4_2_7_2 - 4.166666666666654e-03*G4_1_1_5_2_4_0 - 4.166666666666654e-03*G4_1_1_5_2_4_1 - 4.166666666666655e-03*G4_1_1_5_2_4_2 - 8.333333333333309e-03*G4_1_1_5_2_5_0 - 8.333333333333309e-03*G4_1_1_5_2_5_1 - 8.333333333333309e-03*G4_1_1_5_2_5_2 - 4.166666666666655e-03*G4_1_1_5_2_6_0 - 4.166666666666656e-03*G4_1_1_5_2_6_1 - 4.166666666666656e-03*G4_1_1_5_2_6_2 - 4.166666666666656e-03*G4_1_1_5_2_7_0 - 4.166666666666657e-03*G4_1_1_5_2_7_1 - 4.166666666666657e-03*G4_1_1_5_2_7_2 - 4.166666666666654e-03*G4_1_1_6_2_4_0 - 4.166666666666654e-03*G4_1_1_6_2_4_1 - 4.166666666666654e-03*G4_1_1_6_2_4_2 - 4.166666666666655e-03*G4_1_1_6_2_5_0 - 4.166666666666656e-03*G4_1_1_6_2_5_1 - 4.166666666666656e-03*G4_1_1_6_2_5_2 - 8.333333333333311e-03*G4_1_1_6_2_6_0 - 8.333333333333311e-03*G4_1_1_6_2_6_1 - 8.333333333333312e-03*G4_1_1_6_2_6_2 - 4.166666666666655e-03*G4_1_1_6_2_7_0 - 4.166666666666656e-03*G4_1_1_6_2_7_1 - 4.166666666666657e-03*G4_1_1_6_2_7_2 - 4.166666666666656e-03*G4_1_1_7_2_4_0 - 4.166666666666657e-03*G4_1_1_7_2_4_1 - 4.166666666666657e-03*G4_1_1_7_2_4_2 - 4.166666666666656e-03*G4_1_1_7_2_5_0 - 4.166666666666657e-03*G4_1_1_7_2_5_1 - 4.166666666666657e-03*G4_1_1_7_2_5_2 - 4.166666666666655e-03*G4_1_1_7_2_6_0 - 4.166666666666656e-03*G4_1_1_7_2_6_1 - 4.166666666666657e-03*G4_1_1_7_2_6_2 - 8.333333333333311e-03*G4_1_1_7_2_7_0 - 8.333333333333311e-03*G4_1_1_7_2_7_1 - 8.333333333333312e-03*G4_1_1_7_2_7_2 - 8.333333333333309e-03*G4_1_2_4_2_8_0 - 8.333333333333311e-03*G4_1_2_4_2_8_1 - 8.333333333333312e-03*G4_1_2_4_2_8_2 - 4.166666666666654e-03*G4_1_2_4_2_9_0 - 4.166666666666654e-03*G4_1_2_4_2_9_1 - 4.166666666666655e-03*G4_1_2_4_2_9_2 - 4.166666666666654e-03*G4_1_2_4_2_10_0 - 4.166666666666654e-03*G4_1_2_4_2_10_1 - 4.166666666666654e-03*G4_1_2_4_2_10_2 - 4.166666666666656e-03*G4_1_2_4_2_11_0 - 4.166666666666657e-03*G4_1_2_4_2_11_1 - 4.166666666666657e-03*G4_1_2_4_2_11_2 - 4.166666666666654e-03*G4_1_2_5_2_8_0 - 4.166666666666654e-03*G4_1_2_5_2_8_1 - 4.166666666666655e-03*G4_1_2_5_2_8_2 - 8.333333333333309e-03*G4_1_2_5_2_9_0 - 8.333333333333309e-03*G4_1_2_5_2_9_1 - 8.333333333333309e-03*G4_1_2_5_2_9_2 - 4.166666666666655e-03*G4_1_2_5_2_10_0 - 4.166666666666656e-03*G4_1_2_5_2_10_1 - 4.166666666666656e-03*G4_1_2_5_2_10_2 - 4.166666666666656e-03*G4_1_2_5_2_11_0 - 4.166666666666657e-03*G4_1_2_5_2_11_1 - 4.166666666666657e-03*G4_1_2_5_2_11_2 - 4.166666666666654e-03*G4_1_2_6_2_8_0 - 4.166666666666654e-03*G4_1_2_6_2_8_1 - 4.166666666666654e-03*G4_1_2_6_2_8_2 - 4.166666666666655e-03*G4_1_2_6_2_9_0 - 4.166666666666656e-03*G4_1_2_6_2_9_1 - 4.166666666666656e-03*G4_1_2_6_2_9_2 - 8.333333333333311e-03*G4_1_2_6_2_10_0 - 8.333333333333311e-03*G4_1_2_6_2_10_1 - 8.333333333333312e-03*G4_1_2_6_2_10_2 - 4.166666666666655e-03*G4_1_2_6_2_11_0 - 4.166666666666656e-03*G4_1_2_6_2_11_1 - 4.166666666666657e-03*G4_1_2_6_2_11_2 - 4.166666666666656e-03*G4_1_2_7_2_8_0 - 4.166666666666657e-03*G4_1_2_7_2_8_1 - 4.166666666666657e-03*G4_1_2_7_2_8_2 - 4.166666666666656e-03*G4_1_2_7_2_9_0 - 4.166666666666657e-03*G4_1_2_7_2_9_1 - 4.166666666666657e-03*G4_1_2_7_2_9_2 - 4.166666666666655e-03*G4_1_2_7_2_10_0 - 4.166666666666656e-03*G4_1_2_7_2_10_1 - 4.166666666666657e-03*G4_1_2_7_2_10_2 - 8.333333333333311e-03*G4_1_2_7_2_11_0 - 8.333333333333311e-03*G4_1_2_7_2_11_1 - 8.333333333333312e-03*G4_1_2_7_2_11_2 - 8.333333333333309e-03*G4_2_0_8_2_0_0 - 8.333333333333311e-03*G4_2_0_8_2_0_1 - 8.333333333333312e-03*G4_2_0_8_2_0_2 - 4.166666666666654e-03*G4_2_0_8_2_1_0 - 4.166666666666654e-03*G4_2_0_8_2_1_1 - 4.166666666666654e-03*G4_2_0_8_2_1_2 - 4.166666666666654e-03*G4_2_0_8_2_2_0 - 4.166666666666654e-03*G4_2_0_8_2_2_1 - 4.166666666666654e-03*G4_2_0_8_2_2_2 - 4.166666666666656e-03*G4_2_0_8_2_3_0 - 4.166666666666657e-03*G4_2_0_8_2_3_1 - 4.166666666666657e-03*G4_2_0_8_2_3_2 - 4.166666666666655e-03*G4_2_0_9_2_0_0 - 4.166666666666655e-03*G4_2_0_9_2_0_1 - 4.166666666666656e-03*G4_2_0_9_2_0_2 - 8.333333333333309e-03*G4_2_0_9_2_1_0 - 8.333333333333309e-03*G4_2_0_9_2_1_1 - 8.333333333333309e-03*G4_2_0_9_2_1_2 - 4.166666666666655e-03*G4_2_0_9_2_2_0 - 4.166666666666656e-03*G4_2_0_9_2_2_1 - 4.166666666666656e-03*G4_2_0_9_2_2_2 - 4.166666666666656e-03*G4_2_0_9_2_3_0 - 4.166666666666657e-03*G4_2_0_9_2_3_1 - 4.166666666666657e-03*G4_2_0_9_2_3_2 - 4.166666666666654e-03*G4_2_0_10_2_0_0 - 4.166666666666656e-03*G4_2_0_10_2_0_1 - 4.166666666666656e-03*G4_2_0_10_2_0_2 - 4.166666666666654e-03*G4_2_0_10_2_1_0 - 4.166666666666654e-03*G4_2_0_10_2_1_1 - 4.166666666666654e-03*G4_2_0_10_2_1_2 - 8.333333333333311e-03*G4_2_0_10_2_2_0 - 8.333333333333311e-03*G4_2_0_10_2_2_1 - 8.333333333333312e-03*G4_2_0_10_2_2_2 - 4.166666666666655e-03*G4_2_0_10_2_3_0 - 4.166666666666656e-03*G4_2_0_10_2_3_1 - 4.166666666666657e-03*G4_2_0_10_2_3_2 - 4.166666666666656e-03*G4_2_0_11_2_0_0 - 4.166666666666657e-03*G4_2_0_11_2_0_1 - 4.166666666666658e-03*G4_2_0_11_2_0_2 - 4.166666666666655e-03*G4_2_0_11_2_1_0 - 4.166666666666655e-03*G4_2_0_11_2_1_1 - 4.166666666666656e-03*G4_2_0_11_2_1_2 - 4.166666666666655e-03*G4_2_0_11_2_2_0 - 4.166666666666656e-03*G4_2_0_11_2_2_1 - 4.166666666666657e-03*G4_2_0_11_2_2_2 - 8.333333333333311e-03*G4_2_0_11_2_3_0 - 8.333333333333311e-03*G4_2_0_11_2_3_1 - 8.333333333333312e-03*G4_2_0_11_2_3_2 - 8.333333333333309e-03*G4_2_1_8_2_4_0 - 8.333333333333311e-03*G4_2_1_8_2_4_1 - 8.333333333333312e-03*G4_2_1_8_2_4_2 - 4.166666666666654e-03*G4_2_1_8_2_5_0 - 4.166666666666654e-03*G4_2_1_8_2_5_1 - 4.166666666666655e-03*G4_2_1_8_2_5_2 - 4.166666666666654e-03*G4_2_1_8_2_6_0 - 4.166666666666654e-03*G4_2_1_8_2_6_1 - 4.166666666666654e-03*G4_2_1_8_2_6_2 - 4.166666666666656e-03*G4_2_1_8_2_7_0 - 4.166666666666657e-03*G4_2_1_8_2_7_1 - 4.166666666666657e-03*G4_2_1_8_2_7_2 - 4.166666666666654e-03*G4_2_1_9_2_4_0 - 4.166666666666654e-03*G4_2_1_9_2_4_1 - 4.166666666666655e-03*G4_2_1_9_2_4_2 - 8.333333333333309e-03*G4_2_1_9_2_5_0 - 8.333333333333309e-03*G4_2_1_9_2_5_1 - 8.333333333333309e-03*G4_2_1_9_2_5_2 - 4.166666666666655e-03*G4_2_1_9_2_6_0 - 4.166666666666656e-03*G4_2_1_9_2_6_1 - 4.166666666666656e-03*G4_2_1_9_2_6_2 - 4.166666666666656e-03*G4_2_1_9_2_7_0 - 4.166666666666657e-03*G4_2_1_9_2_7_1 - 4.166666666666657e-03*G4_2_1_9_2_7_2 - 4.166666666666654e-03*G4_2_1_10_2_4_0 - 4.166666666666654e-03*G4_2_1_10_2_4_1 - 4.166666666666654e-03*G4_2_1_10_2_4_2 - 4.166666666666655e-03*G4_2_1_10_2_5_0 - 4.166666666666656e-03*G4_2_1_10_2_5_1 - 4.166666666666656e-03*G4_2_1_10_2_5_2 - 8.333333333333311e-03*G4_2_1_10_2_6_0 - 8.333333333333311e-03*G4_2_1_10_2_6_1 - 8.333333333333312e-03*G4_2_1_10_2_6_2 - 4.166666666666655e-03*G4_2_1_10_2_7_0 - 4.166666666666656e-03*G4_2_1_10_2_7_1 - 4.166666666666657e-03*G4_2_1_10_2_7_2 - 4.166666666666656e-03*G4_2_1_11_2_4_0 - 4.166666666666657e-03*G4_2_1_11_2_4_1 - 4.166666666666657e-03*G4_2_1_11_2_4_2 - 4.166666666666656e-03*G4_2_1_11_2_5_0 - 4.166666666666657e-03*G4_2_1_11_2_5_1 - 4.166666666666657e-03*G4_2_1_11_2_5_2 - 4.166666666666655e-03*G4_2_1_11_2_6_0 - 4.166666666666656e-03*G4_2_1_11_2_6_1 - 4.166666666666657e-03*G4_2_1_11_2_6_2 - 8.333333333333311e-03*G4_2_1_11_2_7_0 - 8.333333333333311e-03*G4_2_1_11_2_7_1 - 8.333333333333312e-03*G4_2_1_11_2_7_2 - 8.333333333333309e-03*G4_2_2_8_2_8_0 - 8.333333333333311e-03*G4_2_2_8_2_8_1 - 8.333333333333312e-03*G4_2_2_8_2_8_2 - 4.166666666666654e-03*G4_2_2_8_2_9_0 - 4.166666666666654e-03*G4_2_2_8_2_9_1 - 4.166666666666655e-03*G4_2_2_8_2_9_2 - 4.166666666666654e-03*G4_2_2_8_2_10_0 - 4.166666666666654e-03*G4_2_2_8_2_10_1 - 4.166666666666654e-03*G4_2_2_8_2_10_2 - 4.166666666666656e-03*G4_2_2_8_2_11_0 - 4.166666666666657e-03*G4_2_2_8_2_11_1 - 4.166666666666657e-03*G4_2_2_8_2_11_2 - 4.166666666666654e-03*G4_2_2_9_2_8_0 - 4.166666666666654e-03*G4_2_2_9_2_8_1 - 4.166666666666655e-03*G4_2_2_9_2_8_2 - 8.333333333333309e-03*G4_2_2_9_2_9_0 - 8.333333333333309e-03*G4_2_2_9_2_9_1 - 8.333333333333309e-03*G4_2_2_9_2_9_2 - 4.166666666666655e-03*G4_2_2_9_2_10_0 - 4.166666666666656e-03*G4_2_2_9_2_10_1 - 4.166666666666656e-03*G4_2_2_9_2_10_2 - 4.166666666666656e-03*G4_2_2_9_2_11_0 - 4.166666666666657e-03*G4_2_2_9_2_11_1 - 4.166666666666657e-03*G4_2_2_9_2_11_2 - 4.166666666666654e-03*G4_2_2_10_2_8_0 - 4.166666666666654e-03*G4_2_2_10_2_8_1 - 4.166666666666654e-03*G4_2_2_10_2_8_2 - 4.166666666666655e-03*G4_2_2_10_2_9_0 - 4.166666666666656e-03*G4_2_2_10_2_9_1 - 4.166666666666656e-03*G4_2_2_10_2_9_2 - 8.333333333333311e-03*G4_2_2_10_2_10_0 - 8.333333333333311e-03*G4_2_2_10_2_10_1 - 8.333333333333312e-03*G4_2_2_10_2_10_2 - 4.166666666666655e-03*G4_2_2_10_2_11_0 - 4.166666666666656e-03*G4_2_2_10_2_11_1 - 4.166666666666657e-03*G4_2_2_10_2_11_2 - 4.166666666666656e-03*G4_2_2_11_2_8_0 - 4.166666666666657e-03*G4_2_2_11_2_8_1 - 4.166666666666657e-03*G4_2_2_11_2_8_2 - 4.166666666666656e-03*G4_2_2_11_2_9_0 - 4.166666666666657e-03*G4_2_2_11_2_9_1 - 4.166666666666657e-03*G4_2_2_11_2_9_2 - 4.166666666666655e-03*G4_2_2_11_2_10_0 - 4.166666666666656e-03*G4_2_2_11_2_10_1 - 4.166666666666657e-03*G4_2_2_11_2_10_2 - 8.333333333333311e-03*G4_2_2_11_2_11_0 - 8.333333333333311e-03*G4_2_2_11_2_11_1 - 8.333333333333312e-03*G4_2_2_11_2_11_2;
    block[89] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_2_0 + 4.166666666666656e-03*G2_0_0_0 + 4.166666666666655e-03*G2_0_1_0 + 4.166666666666655e-03*G2_0_2_0 + 8.333333333333311e-03*G2_0_3_0 + 4.166666666666656e-03*G2_1_4_0 + 4.166666666666656e-03*G2_1_5_0 + 4.166666666666655e-03*G2_1_6_0 + 8.333333333333311e-03*G2_1_7_0 + 4.166666666666656e-03*G2_2_8_0 + 4.166666666666656e-03*G2_2_9_0 + 4.166666666666655e-03*G2_2_10_0 + 8.333333333333311e-03*G2_2_11_0 + 8.333333333333322e-02*G3_1_1_2_0 + 8.333333333333309e-03*G4_0_0_0_2_0_0 + 4.166666666666654e-03*G4_0_0_0_2_1_0 + 4.166666666666654e-03*G4_0_0_0_2_2_0 + 4.166666666666656e-03*G4_0_0_0_2_3_0 + 4.166666666666654e-03*G4_0_0_1_2_0_0 + 8.333333333333307e-03*G4_0_0_1_2_1_0 + 4.166666666666654e-03*G4_0_0_1_2_2_0 + 4.166666666666655e-03*G4_0_0_1_2_3_0 + 4.166666666666654e-03*G4_0_0_2_2_0_0 + 4.166666666666654e-03*G4_0_0_2_2_1_0 + 8.333333333333311e-03*G4_0_0_2_2_2_0 + 4.166666666666655e-03*G4_0_0_2_2_3_0 + 4.166666666666656e-03*G4_0_0_3_2_0_0 + 4.166666666666655e-03*G4_0_0_3_2_1_0 + 4.166666666666655e-03*G4_0_0_3_2_2_0 + 8.333333333333311e-03*G4_0_0_3_2_3_0 + 8.333333333333309e-03*G4_0_1_0_2_4_0 + 4.166666666666655e-03*G4_0_1_0_2_5_0 + 4.166666666666654e-03*G4_0_1_0_2_6_0 + 4.166666666666656e-03*G4_0_1_0_2_7_0 + 4.166666666666654e-03*G4_0_1_1_2_4_0 + 8.333333333333309e-03*G4_0_1_1_2_5_0 + 4.166666666666654e-03*G4_0_1_1_2_6_0 + 4.166666666666655e-03*G4_0_1_1_2_7_0 + 4.166666666666654e-03*G4_0_1_2_2_4_0 + 4.166666666666655e-03*G4_0_1_2_2_5_0 + 8.333333333333311e-03*G4_0_1_2_2_6_0 + 4.166666666666655e-03*G4_0_1_2_2_7_0 + 4.166666666666656e-03*G4_0_1_3_2_4_0 + 4.166666666666656e-03*G4_0_1_3_2_5_0 + 4.166666666666655e-03*G4_0_1_3_2_6_0 + 8.333333333333311e-03*G4_0_1_3_2_7_0 + 8.333333333333309e-03*G4_0_2_0_2_8_0 + 4.166666666666655e-03*G4_0_2_0_2_9_0 + 4.166666666666654e-03*G4_0_2_0_2_10_0 + 4.166666666666656e-03*G4_0_2_0_2_11_0 + 4.166666666666654e-03*G4_0_2_1_2_8_0 + 8.333333333333309e-03*G4_0_2_1_2_9_0 + 4.166666666666654e-03*G4_0_2_1_2_10_0 + 4.166666666666655e-03*G4_0_2_1_2_11_0 + 4.166666666666654e-03*G4_0_2_2_2_8_0 + 4.166666666666655e-03*G4_0_2_2_2_9_0 + 8.333333333333311e-03*G4_0_2_2_2_10_0 + 4.166666666666655e-03*G4_0_2_2_2_11_0 + 4.166666666666656e-03*G4_0_2_3_2_8_0 + 4.166666666666656e-03*G4_0_2_3_2_9_0 + 4.166666666666655e-03*G4_0_2_3_2_10_0 + 8.333333333333311e-03*G4_0_2_3_2_11_0 + 8.333333333333309e-03*G4_1_0_4_2_0_0 + 4.166666666666654e-03*G4_1_0_4_2_1_0 + 4.166666666666654e-03*G4_1_0_4_2_2_0 + 4.166666666666656e-03*G4_1_0_4_2_3_0 + 4.166666666666655e-03*G4_1_0_5_2_0_0 + 8.333333333333309e-03*G4_1_0_5_2_1_0 + 4.166666666666655e-03*G4_1_0_5_2_2_0 + 4.166666666666656e-03*G4_1_0_5_2_3_0 + 4.166666666666654e-03*G4_1_0_6_2_0_0 + 4.166666666666654e-03*G4_1_0_6_2_1_0 + 8.333333333333311e-03*G4_1_0_6_2_2_0 + 4.166666666666655e-03*G4_1_0_6_2_3_0 + 4.166666666666656e-03*G4_1_0_7_2_0_0 + 4.166666666666655e-03*G4_1_0_7_2_1_0 + 4.166666666666655e-03*G4_1_0_7_2_2_0 + 8.333333333333311e-03*G4_1_0_7_2_3_0 + 8.333333333333309e-03*G4_1_1_4_2_4_0 + 4.166666666666654e-03*G4_1_1_4_2_5_0 + 4.166666666666654e-03*G4_1_1_4_2_6_0 + 4.166666666666656e-03*G4_1_1_4_2_7_0 + 4.166666666666654e-03*G4_1_1_5_2_4_0 + 8.333333333333309e-03*G4_1_1_5_2_5_0 + 4.166666666666655e-03*G4_1_1_5_2_6_0 + 4.166666666666656e-03*G4_1_1_5_2_7_0 + 4.166666666666654e-03*G4_1_1_6_2_4_0 + 4.166666666666655e-03*G4_1_1_6_2_5_0 + 8.333333333333311e-03*G4_1_1_6_2_6_0 + 4.166666666666655e-03*G4_1_1_6_2_7_0 + 4.166666666666656e-03*G4_1_1_7_2_4_0 + 4.166666666666656e-03*G4_1_1_7_2_5_0 + 4.166666666666655e-03*G4_1_1_7_2_6_0 + 8.333333333333311e-03*G4_1_1_7_2_7_0 + 8.333333333333309e-03*G4_1_2_4_2_8_0 + 4.166666666666654e-03*G4_1_2_4_2_9_0 + 4.166666666666654e-03*G4_1_2_4_2_10_0 + 4.166666666666656e-03*G4_1_2_4_2_11_0 + 4.166666666666654e-03*G4_1_2_5_2_8_0 + 8.333333333333309e-03*G4_1_2_5_2_9_0 + 4.166666666666655e-03*G4_1_2_5_2_10_0 + 4.166666666666656e-03*G4_1_2_5_2_11_0 + 4.166666666666654e-03*G4_1_2_6_2_8_0 + 4.166666666666655e-03*G4_1_2_6_2_9_0 + 8.333333333333311e-03*G4_1_2_6_2_10_0 + 4.166666666666655e-03*G4_1_2_6_2_11_0 + 4.166666666666656e-03*G4_1_2_7_2_8_0 + 4.166666666666656e-03*G4_1_2_7_2_9_0 + 4.166666666666655e-03*G4_1_2_7_2_10_0 + 8.333333333333311e-03*G4_1_2_7_2_11_0 + 8.333333333333309e-03*G4_2_0_8_2_0_0 + 4.166666666666654e-03*G4_2_0_8_2_1_0 + 4.166666666666654e-03*G4_2_0_8_2_2_0 + 4.166666666666656e-03*G4_2_0_8_2_3_0 + 4.166666666666655e-03*G4_2_0_9_2_0_0 + 8.333333333333309e-03*G4_2_0_9_2_1_0 + 4.166666666666655e-03*G4_2_0_9_2_2_0 + 4.166666666666656e-03*G4_2_0_9_2_3_0 + 4.166666666666654e-03*G4_2_0_10_2_0_0 + 4.166666666666654e-03*G4_2_0_10_2_1_0 + 8.333333333333311e-03*G4_2_0_10_2_2_0 + 4.166666666666655e-03*G4_2_0_10_2_3_0 + 4.166666666666656e-03*G4_2_0_11_2_0_0 + 4.166666666666655e-03*G4_2_0_11_2_1_0 + 4.166666666666655e-03*G4_2_0_11_2_2_0 + 8.333333333333311e-03*G4_2_0_11_2_3_0 + 8.333333333333309e-03*G4_2_1_8_2_4_0 + 4.166666666666654e-03*G4_2_1_8_2_5_0 + 4.166666666666654e-03*G4_2_1_8_2_6_0 + 4.166666666666656e-03*G4_2_1_8_2_7_0 + 4.166666666666654e-03*G4_2_1_9_2_4_0 + 8.333333333333309e-03*G4_2_1_9_2_5_0 + 4.166666666666655e-03*G4_2_1_9_2_6_0 + 4.166666666666656e-03*G4_2_1_9_2_7_0 + 4.166666666666654e-03*G4_2_1_10_2_4_0 + 4.166666666666655e-03*G4_2_1_10_2_5_0 + 8.333333333333311e-03*G4_2_1_10_2_6_0 + 4.166666666666655e-03*G4_2_1_10_2_7_0 + 4.166666666666656e-03*G4_2_1_11_2_4_0 + 4.166666666666656e-03*G4_2_1_11_2_5_0 + 4.166666666666655e-03*G4_2_1_11_2_6_0 + 8.333333333333311e-03*G4_2_1_11_2_7_0 + 8.333333333333309e-03*G4_2_2_8_2_8_0 + 4.166666666666654e-03*G4_2_2_8_2_9_0 + 4.166666666666654e-03*G4_2_2_8_2_10_0 + 4.166666666666656e-03*G4_2_2_8_2_11_0 + 4.166666666666654e-03*G4_2_2_9_2_8_0 + 8.333333333333309e-03*G4_2_2_9_2_9_0 + 4.166666666666655e-03*G4_2_2_9_2_10_0 + 4.166666666666656e-03*G4_2_2_9_2_11_0 + 4.166666666666654e-03*G4_2_2_10_2_8_0 + 4.166666666666655e-03*G4_2_2_10_2_9_0 + 8.333333333333311e-03*G4_2_2_10_2_10_0 + 4.166666666666655e-03*G4_2_2_10_2_11_0 + 4.166666666666656e-03*G4_2_2_11_2_8_0 + 4.166666666666656e-03*G4_2_2_11_2_9_0 + 4.166666666666655e-03*G4_2_2_11_2_10_0 + 8.333333333333311e-03*G4_2_2_11_2_11_0;
    block[90] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_2_1 + 4.166666666666657e-03*G2_0_0_1 + 4.166666666666655e-03*G2_0_1_1 + 4.166666666666656e-03*G2_0_2_1 + 8.333333333333311e-03*G2_0_3_1 + 4.166666666666657e-03*G2_1_4_1 + 4.166666666666657e-03*G2_1_5_1 + 4.166666666666656e-03*G2_1_6_1 + 8.333333333333311e-03*G2_1_7_1 + 4.166666666666657e-03*G2_2_8_1 + 4.166666666666657e-03*G2_2_9_1 + 4.166666666666656e-03*G2_2_10_1 + 8.333333333333311e-03*G2_2_11_1 + 8.333333333333323e-02*G3_1_1_2_1 + 8.333333333333311e-03*G4_0_0_0_2_0_1 + 4.166666666666655e-03*G4_0_0_0_2_1_1 + 4.166666666666656e-03*G4_0_0_0_2_2_1 + 4.166666666666657e-03*G4_0_0_0_2_3_1 + 4.166666666666655e-03*G4_0_0_1_2_0_1 + 8.333333333333309e-03*G4_0_0_1_2_1_1 + 4.166666666666654e-03*G4_0_0_1_2_2_1 + 4.166666666666655e-03*G4_0_0_1_2_3_1 + 4.166666666666656e-03*G4_0_0_2_2_0_1 + 4.166666666666654e-03*G4_0_0_2_2_1_1 + 8.333333333333311e-03*G4_0_0_2_2_2_1 + 4.166666666666656e-03*G4_0_0_2_2_3_1 + 4.166666666666657e-03*G4_0_0_3_2_0_1 + 4.166666666666655e-03*G4_0_0_3_2_1_1 + 4.166666666666656e-03*G4_0_0_3_2_2_1 + 8.333333333333311e-03*G4_0_0_3_2_3_1 + 8.333333333333311e-03*G4_0_1_0_2_4_1 + 4.166666666666655e-03*G4_0_1_0_2_5_1 + 4.166666666666656e-03*G4_0_1_0_2_6_1 + 4.166666666666657e-03*G4_0_1_0_2_7_1 + 4.166666666666654e-03*G4_0_1_1_2_4_1 + 8.333333333333309e-03*G4_0_1_1_2_5_1 + 4.166666666666654e-03*G4_0_1_1_2_6_1 + 4.166666666666655e-03*G4_0_1_1_2_7_1 + 4.166666666666654e-03*G4_0_1_2_2_4_1 + 4.166666666666656e-03*G4_0_1_2_2_5_1 + 8.333333333333311e-03*G4_0_1_2_2_6_1 + 4.166666666666656e-03*G4_0_1_2_2_7_1 + 4.166666666666657e-03*G4_0_1_3_2_4_1 + 4.166666666666657e-03*G4_0_1_3_2_5_1 + 4.166666666666656e-03*G4_0_1_3_2_6_1 + 8.333333333333311e-03*G4_0_1_3_2_7_1 + 8.333333333333311e-03*G4_0_2_0_2_8_1 + 4.166666666666655e-03*G4_0_2_0_2_9_1 + 4.166666666666656e-03*G4_0_2_0_2_10_1 + 4.166666666666657e-03*G4_0_2_0_2_11_1 + 4.166666666666654e-03*G4_0_2_1_2_8_1 + 8.333333333333309e-03*G4_0_2_1_2_9_1 + 4.166666666666654e-03*G4_0_2_1_2_10_1 + 4.166666666666655e-03*G4_0_2_1_2_11_1 + 4.166666666666654e-03*G4_0_2_2_2_8_1 + 4.166666666666656e-03*G4_0_2_2_2_9_1 + 8.333333333333311e-03*G4_0_2_2_2_10_1 + 4.166666666666656e-03*G4_0_2_2_2_11_1 + 4.166666666666657e-03*G4_0_2_3_2_8_1 + 4.166666666666657e-03*G4_0_2_3_2_9_1 + 4.166666666666656e-03*G4_0_2_3_2_10_1 + 8.333333333333311e-03*G4_0_2_3_2_11_1 + 8.333333333333311e-03*G4_1_0_4_2_0_1 + 4.166666666666654e-03*G4_1_0_4_2_1_1 + 4.166666666666654e-03*G4_1_0_4_2_2_1 + 4.166666666666657e-03*G4_1_0_4_2_3_1 + 4.166666666666655e-03*G4_1_0_5_2_0_1 + 8.333333333333309e-03*G4_1_0_5_2_1_1 + 4.166666666666656e-03*G4_1_0_5_2_2_1 + 4.166666666666657e-03*G4_1_0_5_2_3_1 + 4.166666666666656e-03*G4_1_0_6_2_0_1 + 4.166666666666654e-03*G4_1_0_6_2_1_1 + 8.333333333333311e-03*G4_1_0_6_2_2_1 + 4.166666666666656e-03*G4_1_0_6_2_3_1 + 4.166666666666657e-03*G4_1_0_7_2_0_1 + 4.166666666666655e-03*G4_1_0_7_2_1_1 + 4.166666666666656e-03*G4_1_0_7_2_2_1 + 8.333333333333311e-03*G4_1_0_7_2_3_1 + 8.333333333333311e-03*G4_1_1_4_2_4_1 + 4.166666666666654e-03*G4_1_1_4_2_5_1 + 4.166666666666654e-03*G4_1_1_4_2_6_1 + 4.166666666666657e-03*G4_1_1_4_2_7_1 + 4.166666666666654e-03*G4_1_1_5_2_4_1 + 8.333333333333309e-03*G4_1_1_5_2_5_1 + 4.166666666666656e-03*G4_1_1_5_2_6_1 + 4.166666666666657e-03*G4_1_1_5_2_7_1 + 4.166666666666654e-03*G4_1_1_6_2_4_1 + 4.166666666666656e-03*G4_1_1_6_2_5_1 + 8.333333333333311e-03*G4_1_1_6_2_6_1 + 4.166666666666656e-03*G4_1_1_6_2_7_1 + 4.166666666666657e-03*G4_1_1_7_2_4_1 + 4.166666666666657e-03*G4_1_1_7_2_5_1 + 4.166666666666656e-03*G4_1_1_7_2_6_1 + 8.333333333333311e-03*G4_1_1_7_2_7_1 + 8.333333333333311e-03*G4_1_2_4_2_8_1 + 4.166666666666654e-03*G4_1_2_4_2_9_1 + 4.166666666666654e-03*G4_1_2_4_2_10_1 + 4.166666666666657e-03*G4_1_2_4_2_11_1 + 4.166666666666654e-03*G4_1_2_5_2_8_1 + 8.333333333333309e-03*G4_1_2_5_2_9_1 + 4.166666666666656e-03*G4_1_2_5_2_10_1 + 4.166666666666657e-03*G4_1_2_5_2_11_1 + 4.166666666666654e-03*G4_1_2_6_2_8_1 + 4.166666666666656e-03*G4_1_2_6_2_9_1 + 8.333333333333311e-03*G4_1_2_6_2_10_1 + 4.166666666666656e-03*G4_1_2_6_2_11_1 + 4.166666666666657e-03*G4_1_2_7_2_8_1 + 4.166666666666657e-03*G4_1_2_7_2_9_1 + 4.166666666666656e-03*G4_1_2_7_2_10_1 + 8.333333333333311e-03*G4_1_2_7_2_11_1 + 8.333333333333311e-03*G4_2_0_8_2_0_1 + 4.166666666666654e-03*G4_2_0_8_2_1_1 + 4.166666666666654e-03*G4_2_0_8_2_2_1 + 4.166666666666657e-03*G4_2_0_8_2_3_1 + 4.166666666666655e-03*G4_2_0_9_2_0_1 + 8.333333333333309e-03*G4_2_0_9_2_1_1 + 4.166666666666656e-03*G4_2_0_9_2_2_1 + 4.166666666666657e-03*G4_2_0_9_2_3_1 + 4.166666666666656e-03*G4_2_0_10_2_0_1 + 4.166666666666654e-03*G4_2_0_10_2_1_1 + 8.333333333333311e-03*G4_2_0_10_2_2_1 + 4.166666666666656e-03*G4_2_0_10_2_3_1 + 4.166666666666657e-03*G4_2_0_11_2_0_1 + 4.166666666666655e-03*G4_2_0_11_2_1_1 + 4.166666666666656e-03*G4_2_0_11_2_2_1 + 8.333333333333311e-03*G4_2_0_11_2_3_1 + 8.333333333333311e-03*G4_2_1_8_2_4_1 + 4.166666666666654e-03*G4_2_1_8_2_5_1 + 4.166666666666654e-03*G4_2_1_8_2_6_1 + 4.166666666666657e-03*G4_2_1_8_2_7_1 + 4.166666666666654e-03*G4_2_1_9_2_4_1 + 8.333333333333309e-03*G4_2_1_9_2_5_1 + 4.166666666666656e-03*G4_2_1_9_2_6_1 + 4.166666666666657e-03*G4_2_1_9_2_7_1 + 4.166666666666654e-03*G4_2_1_10_2_4_1 + 4.166666666666656e-03*G4_2_1_10_2_5_1 + 8.333333333333311e-03*G4_2_1_10_2_6_1 + 4.166666666666656e-03*G4_2_1_10_2_7_1 + 4.166666666666657e-03*G4_2_1_11_2_4_1 + 4.166666666666657e-03*G4_2_1_11_2_5_1 + 4.166666666666656e-03*G4_2_1_11_2_6_1 + 8.333333333333311e-03*G4_2_1_11_2_7_1 + 8.333333333333311e-03*G4_2_2_8_2_8_1 + 4.166666666666654e-03*G4_2_2_8_2_9_1 + 4.166666666666654e-03*G4_2_2_8_2_10_1 + 4.166666666666657e-03*G4_2_2_8_2_11_1 + 4.166666666666654e-03*G4_2_2_9_2_8_1 + 8.333333333333309e-03*G4_2_2_9_2_9_1 + 4.166666666666656e-03*G4_2_2_9_2_10_1 + 4.166666666666657e-03*G4_2_2_9_2_11_1 + 4.166666666666654e-03*G4_2_2_10_2_8_1 + 4.166666666666656e-03*G4_2_2_10_2_9_1 + 8.333333333333311e-03*G4_2_2_10_2_10_1 + 4.166666666666656e-03*G4_2_2_10_2_11_1 + 4.166666666666657e-03*G4_2_2_11_2_8_1 + 4.166666666666657e-03*G4_2_2_11_2_9_1 + 4.166666666666656e-03*G4_2_2_11_2_10_1 + 8.333333333333311e-03*G4_2_2_11_2_11_1;
    block[91] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_2_2 + 4.166666666666657e-03*G2_0_0_2 + 4.166666666666655e-03*G2_0_1_2 + 4.166666666666656e-03*G2_0_2_2 + 8.333333333333311e-03*G2_0_3_2 + 4.166666666666657e-03*G2_1_4_2 + 4.166666666666657e-03*G2_1_5_2 + 4.166666666666656e-03*G2_1_6_2 + 8.333333333333311e-03*G2_1_7_2 + 4.166666666666657e-03*G2_2_8_2 + 4.166666666666657e-03*G2_2_9_2 + 4.166666666666656e-03*G2_2_10_2 + 8.333333333333311e-03*G2_2_11_2 + 8.333333333333323e-02*G3_1_1_2_2 + 8.333333333333311e-03*G4_0_0_0_2_0_2 + 4.166666666666655e-03*G4_0_0_0_2_1_2 + 4.166666666666656e-03*G4_0_0_0_2_2_2 + 4.166666666666657e-03*G4_0_0_0_2_3_2 + 4.166666666666655e-03*G4_0_0_1_2_0_2 + 8.333333333333309e-03*G4_0_0_1_2_1_2 + 4.166666666666654e-03*G4_0_0_1_2_2_2 + 4.166666666666655e-03*G4_0_0_1_2_3_2 + 4.166666666666656e-03*G4_0_0_2_2_0_2 + 4.166666666666654e-03*G4_0_0_2_2_1_2 + 8.333333333333311e-03*G4_0_0_2_2_2_2 + 4.166666666666656e-03*G4_0_0_2_2_3_2 + 4.166666666666657e-03*G4_0_0_3_2_0_2 + 4.166666666666655e-03*G4_0_0_3_2_1_2 + 4.166666666666656e-03*G4_0_0_3_2_2_2 + 8.333333333333311e-03*G4_0_0_3_2_3_2 + 8.333333333333311e-03*G4_0_1_0_2_4_2 + 4.166666666666655e-03*G4_0_1_0_2_5_2 + 4.166666666666656e-03*G4_0_1_0_2_6_2 + 4.166666666666657e-03*G4_0_1_0_2_7_2 + 4.166666666666654e-03*G4_0_1_1_2_4_2 + 8.333333333333309e-03*G4_0_1_1_2_5_2 + 4.166666666666654e-03*G4_0_1_1_2_6_2 + 4.166666666666655e-03*G4_0_1_1_2_7_2 + 4.166666666666654e-03*G4_0_1_2_2_4_2 + 4.166666666666656e-03*G4_0_1_2_2_5_2 + 8.333333333333311e-03*G4_0_1_2_2_6_2 + 4.166666666666656e-03*G4_0_1_2_2_7_2 + 4.166666666666657e-03*G4_0_1_3_2_4_2 + 4.166666666666657e-03*G4_0_1_3_2_5_2 + 4.166666666666656e-03*G4_0_1_3_2_6_2 + 8.333333333333311e-03*G4_0_1_3_2_7_2 + 8.333333333333311e-03*G4_0_2_0_2_8_2 + 4.166666666666655e-03*G4_0_2_0_2_9_2 + 4.166666666666656e-03*G4_0_2_0_2_10_2 + 4.166666666666657e-03*G4_0_2_0_2_11_2 + 4.166666666666654e-03*G4_0_2_1_2_8_2 + 8.333333333333309e-03*G4_0_2_1_2_9_2 + 4.166666666666654e-03*G4_0_2_1_2_10_2 + 4.166666666666655e-03*G4_0_2_1_2_11_2 + 4.166666666666654e-03*G4_0_2_2_2_8_2 + 4.166666666666656e-03*G4_0_2_2_2_9_2 + 8.333333333333311e-03*G4_0_2_2_2_10_2 + 4.166666666666656e-03*G4_0_2_2_2_11_2 + 4.166666666666657e-03*G4_0_2_3_2_8_2 + 4.166666666666657e-03*G4_0_2_3_2_9_2 + 4.166666666666656e-03*G4_0_2_3_2_10_2 + 8.333333333333311e-03*G4_0_2_3_2_11_2 + 8.333333333333311e-03*G4_1_0_4_2_0_2 + 4.166666666666654e-03*G4_1_0_4_2_1_2 + 4.166666666666654e-03*G4_1_0_4_2_2_2 + 4.166666666666657e-03*G4_1_0_4_2_3_2 + 4.166666666666655e-03*G4_1_0_5_2_0_2 + 8.333333333333309e-03*G4_1_0_5_2_1_2 + 4.166666666666656e-03*G4_1_0_5_2_2_2 + 4.166666666666657e-03*G4_1_0_5_2_3_2 + 4.166666666666656e-03*G4_1_0_6_2_0_2 + 4.166666666666654e-03*G4_1_0_6_2_1_2 + 8.333333333333311e-03*G4_1_0_6_2_2_2 + 4.166666666666656e-03*G4_1_0_6_2_3_2 + 4.166666666666657e-03*G4_1_0_7_2_0_2 + 4.166666666666655e-03*G4_1_0_7_2_1_2 + 4.166666666666656e-03*G4_1_0_7_2_2_2 + 8.333333333333311e-03*G4_1_0_7_2_3_2 + 8.333333333333311e-03*G4_1_1_4_2_4_2 + 4.166666666666654e-03*G4_1_1_4_2_5_2 + 4.166666666666654e-03*G4_1_1_4_2_6_2 + 4.166666666666657e-03*G4_1_1_4_2_7_2 + 4.166666666666654e-03*G4_1_1_5_2_4_2 + 8.333333333333309e-03*G4_1_1_5_2_5_2 + 4.166666666666656e-03*G4_1_1_5_2_6_2 + 4.166666666666657e-03*G4_1_1_5_2_7_2 + 4.166666666666654e-03*G4_1_1_6_2_4_2 + 4.166666666666656e-03*G4_1_1_6_2_5_2 + 8.333333333333311e-03*G4_1_1_6_2_6_2 + 4.166666666666656e-03*G4_1_1_6_2_7_2 + 4.166666666666657e-03*G4_1_1_7_2_4_2 + 4.166666666666657e-03*G4_1_1_7_2_5_2 + 4.166666666666656e-03*G4_1_1_7_2_6_2 + 8.333333333333311e-03*G4_1_1_7_2_7_2 + 8.333333333333311e-03*G4_1_2_4_2_8_2 + 4.166666666666654e-03*G4_1_2_4_2_9_2 + 4.166666666666654e-03*G4_1_2_4_2_10_2 + 4.166666666666657e-03*G4_1_2_4_2_11_2 + 4.166666666666654e-03*G4_1_2_5_2_8_2 + 8.333333333333309e-03*G4_1_2_5_2_9_2 + 4.166666666666656e-03*G4_1_2_5_2_10_2 + 4.166666666666657e-03*G4_1_2_5_2_11_2 + 4.166666666666654e-03*G4_1_2_6_2_8_2 + 4.166666666666656e-03*G4_1_2_6_2_9_2 + 8.333333333333311e-03*G4_1_2_6_2_10_2 + 4.166666666666656e-03*G4_1_2_6_2_11_2 + 4.166666666666657e-03*G4_1_2_7_2_8_2 + 4.166666666666657e-03*G4_1_2_7_2_9_2 + 4.166666666666656e-03*G4_1_2_7_2_10_2 + 8.333333333333311e-03*G4_1_2_7_2_11_2 + 8.333333333333311e-03*G4_2_0_8_2_0_2 + 4.166666666666654e-03*G4_2_0_8_2_1_2 + 4.166666666666654e-03*G4_2_0_8_2_2_2 + 4.166666666666657e-03*G4_2_0_8_2_3_2 + 4.166666666666655e-03*G4_2_0_9_2_0_2 + 8.333333333333309e-03*G4_2_0_9_2_1_2 + 4.166666666666656e-03*G4_2_0_9_2_2_2 + 4.166666666666657e-03*G4_2_0_9_2_3_2 + 4.166666666666656e-03*G4_2_0_10_2_0_2 + 4.166666666666654e-03*G4_2_0_10_2_1_2 + 8.333333333333311e-03*G4_2_0_10_2_2_2 + 4.166666666666656e-03*G4_2_0_10_2_3_2 + 4.166666666666657e-03*G4_2_0_11_2_0_2 + 4.166666666666655e-03*G4_2_0_11_2_1_2 + 4.166666666666656e-03*G4_2_0_11_2_2_2 + 8.333333333333311e-03*G4_2_0_11_2_3_2 + 8.333333333333311e-03*G4_2_1_8_2_4_2 + 4.166666666666654e-03*G4_2_1_8_2_5_2 + 4.166666666666654e-03*G4_2_1_8_2_6_2 + 4.166666666666657e-03*G4_2_1_8_2_7_2 + 4.166666666666654e-03*G4_2_1_9_2_4_2 + 8.333333333333309e-03*G4_2_1_9_2_5_2 + 4.166666666666656e-03*G4_2_1_9_2_6_2 + 4.166666666666657e-03*G4_2_1_9_2_7_2 + 4.166666666666654e-03*G4_2_1_10_2_4_2 + 4.166666666666656e-03*G4_2_1_10_2_5_2 + 8.333333333333311e-03*G4_2_1_10_2_6_2 + 4.166666666666656e-03*G4_2_1_10_2_7_2 + 4.166666666666657e-03*G4_2_1_11_2_4_2 + 4.166666666666657e-03*G4_2_1_11_2_5_2 + 4.166666666666656e-03*G4_2_1_11_2_6_2 + 8.333333333333311e-03*G4_2_1_11_2_7_2 + 8.333333333333311e-03*G4_2_2_8_2_8_2 + 4.166666666666654e-03*G4_2_2_8_2_9_2 + 4.166666666666654e-03*G4_2_2_8_2_10_2 + 4.166666666666657e-03*G4_2_2_8_2_11_2 + 4.166666666666654e-03*G4_2_2_9_2_8_2 + 8.333333333333309e-03*G4_2_2_9_2_9_2 + 4.166666666666656e-03*G4_2_2_9_2_10_2 + 4.166666666666657e-03*G4_2_2_9_2_11_2 + 4.166666666666654e-03*G4_2_2_10_2_8_2 + 4.166666666666656e-03*G4_2_2_10_2_9_2 + 8.333333333333311e-03*G4_2_2_10_2_10_2 + 4.166666666666656e-03*G4_2_2_10_2_11_2 + 4.166666666666657e-03*G4_2_2_11_2_8_2 + 4.166666666666657e-03*G4_2_2_11_2_9_2 + 4.166666666666656e-03*G4_2_2_11_2_10_2 + 8.333333333333311e-03*G4_2_2_11_2_11_2;
    block[92] = -8.333333333333322e-02*G3_1_2_2_0 - 8.333333333333323e-02*G3_1_2_2_1 - 8.333333333333323e-02*G3_1_2_2_2;
    block[93] = 8.333333333333322e-02*G3_1_2_2_0;
    block[94] = 8.333333333333323e-02*G3_1_2_2_1;
    block[95] = 8.333333333333323e-02*G3_1_2_2_2;
    block[96] = 8.333333333333320e-02*G3_2_0_0_0 + 8.333333333333322e-02*G3_2_0_0_1 + 8.333333333333320e-02*G3_2_0_0_2 + 8.333333333333322e-02*G3_2_0_1_0 + 8.333333333333323e-02*G3_2_0_1_1 + 8.333333333333322e-02*G3_2_0_1_2 + 8.333333333333322e-02*G3_2_0_2_0 + 8.333333333333323e-02*G3_2_0_2_1 + 8.333333333333322e-02*G3_2_0_2_2;
    block[97] = -8.333333333333320e-02*G3_2_0_0_0 - 8.333333333333322e-02*G3_2_0_1_0 - 8.333333333333322e-02*G3_2_0_2_0;
    block[98] = -8.333333333333322e-02*G3_2_0_0_1 - 8.333333333333323e-02*G3_2_0_1_1 - 8.333333333333323e-02*G3_2_0_2_1;
    block[99] = -8.333333333333322e-02*G3_2_0_0_2 - 8.333333333333323e-02*G3_2_0_1_2 - 8.333333333333323e-02*G3_2_0_2_2;
    block[100] = 8.333333333333320e-02*G3_2_1_0_0 + 8.333333333333322e-02*G3_2_1_0_1 + 8.333333333333322e-02*G3_2_1_0_2 + 8.333333333333322e-02*G3_2_1_1_0 + 8.333333333333323e-02*G3_2_1_1_1 + 8.333333333333323e-02*G3_2_1_1_2 + 8.333333333333322e-02*G3_2_1_2_0 + 8.333333333333323e-02*G3_2_1_2_1 + 8.333333333333323e-02*G3_2_1_2_2;
    block[101] = -8.333333333333320e-02*G3_2_1_0_0 - 8.333333333333322e-02*G3_2_1_1_0 - 8.333333333333322e-02*G3_2_1_2_0;
    block[102] = -8.333333333333322e-02*G3_2_1_0_1 - 8.333333333333323e-02*G3_2_1_1_1 - 8.333333333333323e-02*G3_2_1_2_1;
    block[103] = -8.333333333333322e-02*G3_2_1_0_2 - 8.333333333333323e-02*G3_2_1_1_2 - 8.333333333333323e-02*G3_2_1_2_2;
    block[104] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 8.333333333333322e-02*G1_0_1 + 8.333333333333322e-02*G1_0_2 + 8.333333333333322e-02*G1_1_0 + 8.333333333333323e-02*G1_1_1 + 8.333333333333323e-02*G1_1_2 + 8.333333333333322e-02*G1_2_0 + 8.333333333333323e-02*G1_2_1 + 8.333333333333323e-02*G1_2_2 - 8.333333333333309e-03*G2_0_0_0 - 8.333333333333311e-03*G2_0_0_1 - 8.333333333333312e-03*G2_0_0_2 - 4.166666666666654e-03*G2_0_1_0 - 4.166666666666654e-03*G2_0_1_1 - 4.166666666666654e-03*G2_0_1_2 - 4.166666666666654e-03*G2_0_2_0 - 4.166666666666654e-03*G2_0_2_1 - 4.166666666666654e-03*G2_0_2_2 - 4.166666666666656e-03*G2_0_3_0 - 4.166666666666657e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 8.333333333333309e-03*G2_1_4_0 - 8.333333333333311e-03*G2_1_4_1 - 8.333333333333312e-03*G2_1_4_2 - 4.166666666666654e-03*G2_1_5_0 - 4.166666666666654e-03*G2_1_5_1 - 4.166666666666655e-03*G2_1_5_2 - 4.166666666666654e-03*G2_1_6_0 - 4.166666666666654e-03*G2_1_6_1 - 4.166666666666654e-03*G2_1_6_2 - 4.166666666666656e-03*G2_1_7_0 - 4.166666666666657e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 8.333333333333309e-03*G2_2_8_0 - 8.333333333333311e-03*G2_2_8_1 - 8.333333333333312e-03*G2_2_8_2 - 4.166666666666654e-03*G2_2_9_0 - 4.166666666666654e-03*G2_2_9_1 - 4.166666666666655e-03*G2_2_9_2 - 4.166666666666654e-03*G2_2_10_0 - 4.166666666666654e-03*G2_2_10_1 - 4.166666666666654e-03*G2_2_10_2 - 4.166666666666656e-03*G2_2_11_0 - 4.166666666666657e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 + 8.333333333333320e-02*G3_2_2_0_0 + 8.333333333333322e-02*G3_2_2_0_1 + 8.333333333333322e-02*G3_2_2_0_2 + 8.333333333333322e-02*G3_2_2_1_0 + 8.333333333333323e-02*G3_2_2_1_1 + 8.333333333333323e-02*G3_2_2_1_2 + 8.333333333333322e-02*G3_2_2_2_0 + 8.333333333333323e-02*G3_2_2_2_1 + 8.333333333333323e-02*G3_2_2_2_2 + 8.333333333333309e-03*G4_0_0_0_0_0_0 + 8.333333333333309e-03*G4_0_0_0_0_0_1 + 8.333333333333312e-03*G4_0_0_0_0_0_2 + 4.166666666666654e-03*G4_0_0_0_0_1_0 + 4.166666666666654e-03*G4_0_0_0_0_1_1 + 4.166666666666655e-03*G4_0_0_0_0_1_2 + 4.166666666666654e-03*G4_0_0_0_0_2_0 + 4.166666666666654e-03*G4_0_0_0_0_2_1 + 4.166666666666656e-03*G4_0_0_0_0_2_2 + 4.166666666666656e-03*G4_0_0_0_0_3_0 + 4.166666666666656e-03*G4_0_0_0_0_3_1 + 4.166666666666657e-03*G4_0_0_0_0_3_2 + 8.333333333333309e-03*G4_0_0_0_1_0_0 + 8.333333333333311e-03*G4_0_0_0_1_0_1 + 8.333333333333312e-03*G4_0_0_0_1_0_2 + 4.166666666666654e-03*G4_0_0_0_1_1_0 + 4.166666666666655e-03*G4_0_0_0_1_1_1 + 4.166666666666655e-03*G4_0_0_0_1_1_2 + 4.166666666666654e-03*G4_0_0_0_1_2_0 + 4.166666666666656e-03*G4_0_0_0_1_2_1 + 4.166666666666656e-03*G4_0_0_0_1_2_2 + 4.166666666666656e-03*G4_0_0_0_1_3_0 + 4.166666666666657e-03*G4_0_0_0_1_3_1 + 4.166666666666658e-03*G4_0_0_0_1_3_2 + 8.333333333333311e-03*G4_0_0_0_2_0_0 + 8.333333333333312e-03*G4_0_0_0_2_0_1 + 8.333333333333314e-03*G4_0_0_0_2_0_2 + 4.166666666666654e-03*G4_0_0_0_2_1_0 + 4.166666666666655e-03*G4_0_0_0_2_1_1 + 4.166666666666656e-03*G4_0_0_0_2_1_2 + 4.166666666666655e-03*G4_0_0_0_2_2_0 + 4.166666666666656e-03*G4_0_0_0_2_2_1 + 4.166666666666656e-03*G4_0_0_0_2_2_2 + 4.166666666666657e-03*G4_0_0_0_2_3_0 + 4.166666666666658e-03*G4_0_0_0_2_3_1 + 4.166666666666659e-03*G4_0_0_0_2_3_2 + 4.166666666666654e-03*G4_0_0_1_0_0_0 + 4.166666666666654e-03*G4_0_0_1_0_0_1 + 4.166666666666655e-03*G4_0_0_1_0_0_2 + 8.333333333333307e-03*G4_0_0_1_0_1_0 + 8.333333333333307e-03*G4_0_0_1_0_1_1 + 8.333333333333307e-03*G4_0_0_1_0_1_2 + 4.166666666666654e-03*G4_0_0_1_0_2_0 + 4.166666666666654e-03*G4_0_0_1_0_2_1 + 4.166666666666654e-03*G4_0_0_1_0_2_2 + 4.166666666666654e-03*G4_0_0_1_0_3_0 + 4.166666666666655e-03*G4_0_0_1_0_3_1 + 4.166666666666655e-03*G4_0_0_1_0_3_2 + 4.166666666666654e-03*G4_0_0_1_1_0_0 + 4.166666666666655e-03*G4_0_0_1_1_0_1 + 4.166666666666655e-03*G4_0_0_1_1_0_2 + 8.333333333333307e-03*G4_0_0_1_1_1_0 + 8.333333333333309e-03*G4_0_0_1_1_1_1 + 8.333333333333309e-03*G4_0_0_1_1_1_2 + 4.166666666666654e-03*G4_0_0_1_1_2_0 + 4.166666666666654e-03*G4_0_0_1_1_2_1 + 4.166666666666655e-03*G4_0_0_1_1_2_2 + 4.166666666666655e-03*G4_0_0_1_1_3_0 + 4.166666666666655e-03*G4_0_0_1_1_3_1 + 4.166666666666656e-03*G4_0_0_1_1_3_2 + 4.166666666666654e-03*G4_0_0_1_2_0_0 + 4.166666666666655e-03*G4_0_0_1_2_0_1 + 4.166666666666656e-03*G4_0_0_1_2_0_2 + 8.333333333333307e-03*G4_0_0_1_2_1_0 + 8.333333333333309e-03*G4_0_0_1_2_1_1 + 8.333333333333309e-03*G4_0_0_1_2_1_2 + 4.166666666666654e-03*G4_0_0_1_2_2_0 + 4.166666666666655e-03*G4_0_0_1_2_2_1 + 4.166666666666655e-03*G4_0_0_1_2_2_2 + 4.166666666666655e-03*G4_0_0_1_2_3_0 + 4.166666666666656e-03*G4_0_0_1_2_3_1 + 4.166666666666656e-03*G4_0_0_1_2_3_2 + 4.166666666666654e-03*G4_0_0_2_0_0_0 + 4.166666666666654e-03*G4_0_0_2_0_0_1 + 4.166666666666655e-03*G4_0_0_2_0_0_2 + 4.166666666666654e-03*G4_0_0_2_0_1_0 + 4.166666666666654e-03*G4_0_0_2_0_1_1 + 4.166666666666654e-03*G4_0_0_2_0_1_2 + 8.333333333333309e-03*G4_0_0_2_0_2_0 + 8.333333333333309e-03*G4_0_0_2_0_2_1 + 8.333333333333311e-03*G4_0_0_2_0_2_2 + 4.166666666666654e-03*G4_0_0_2_0_3_0 + 4.166666666666655e-03*G4_0_0_2_0_3_1 + 4.166666666666655e-03*G4_0_0_2_0_3_2 + 4.166666666666654e-03*G4_0_0_2_1_0_0 + 4.166666666666656e-03*G4_0_0_2_1_0_1 + 4.166666666666656e-03*G4_0_0_2_1_0_2 + 4.166666666666654e-03*G4_0_0_2_1_1_0 + 4.166666666666654e-03*G4_0_0_2_1_1_1 + 4.166666666666654e-03*G4_0_0_2_1_1_2 + 8.333333333333311e-03*G4_0_0_2_1_2_0 + 8.333333333333311e-03*G4_0_0_2_1_2_1 + 8.333333333333312e-03*G4_0_0_2_1_2_2 + 4.166666666666655e-03*G4_0_0_2_1_3_0 + 4.166666666666656e-03*G4_0_0_2_1_3_1 + 4.166666666666657e-03*G4_0_0_2_1_3_2 + 4.166666666666655e-03*G4_0_0_2_2_0_0 + 4.166666666666656e-03*G4_0_0_2_2_0_1 + 4.166666666666656e-03*G4_0_0_2_2_0_2 + 4.166666666666654e-03*G4_0_0_2_2_1_0 + 4.166666666666654e-03*G4_0_0_2_2_1_1 + 4.166666666666655e-03*G4_0_0_2_2_1_2 + 8.333333333333311e-03*G4_0_0_2_2_2_0 + 8.333333333333312e-03*G4_0_0_2_2_2_1 + 8.333333333333312e-03*G4_0_0_2_2_2_2 + 4.166666666666655e-03*G4_0_0_2_2_3_0 + 4.166666666666657e-03*G4_0_0_2_2_3_1 + 4.166666666666657e-03*G4_0_0_2_2_3_2 + 4.166666666666656e-03*G4_0_0_3_0_0_0 + 4.166666666666656e-03*G4_0_0_3_0_0_1 + 4.166666666666657e-03*G4_0_0_3_0_0_2 + 4.166666666666654e-03*G4_0_0_3_0_1_0 + 4.166666666666655e-03*G4_0_0_3_0_1_1 + 4.166666666666655e-03*G4_0_0_3_0_1_2 + 4.166666666666655e-03*G4_0_0_3_0_2_0 + 4.166666666666655e-03*G4_0_0_3_0_2_1 + 4.166666666666655e-03*G4_0_0_3_0_2_2 + 8.333333333333309e-03*G4_0_0_3_0_3_0 + 8.333333333333311e-03*G4_0_0_3_0_3_1 + 8.333333333333311e-03*G4_0_0_3_0_3_2 + 4.166666666666656e-03*G4_0_0_3_1_0_0 + 4.166666666666657e-03*G4_0_0_3_1_0_1 + 4.166666666666658e-03*G4_0_0_3_1_0_2 + 4.166666666666655e-03*G4_0_0_3_1_1_0 + 4.166666666666655e-03*G4_0_0_3_1_1_1 + 4.166666666666656e-03*G4_0_0_3_1_1_2 + 4.166666666666655e-03*G4_0_0_3_1_2_0 + 4.166666666666656e-03*G4_0_0_3_1_2_1 + 4.166666666666657e-03*G4_0_0_3_1_2_2 + 8.333333333333311e-03*G4_0_0_3_1_3_0 + 8.333333333333311e-03*G4_0_0_3_1_3_1 + 8.333333333333312e-03*G4_0_0_3_1_3_2 + 4.166666666666657e-03*G4_0_0_3_2_0_0 + 4.166666666666658e-03*G4_0_0_3_2_0_1 + 4.166666666666659e-03*G4_0_0_3_2_0_2 + 4.166666666666655e-03*G4_0_0_3_2_1_0 + 4.166666666666656e-03*G4_0_0_3_2_1_1 + 4.166666666666656e-03*G4_0_0_3_2_1_2 + 4.166666666666655e-03*G4_0_0_3_2_2_0 + 4.166666666666657e-03*G4_0_0_3_2_2_1 + 4.166666666666657e-03*G4_0_0_3_2_2_2 + 8.333333333333311e-03*G4_0_0_3_2_3_0 + 8.333333333333312e-03*G4_0_0_3_2_3_1 + 8.333333333333312e-03*G4_0_0_3_2_3_2 + 8.333333333333309e-03*G4_0_1_0_0_4_0 + 8.333333333333309e-03*G4_0_1_0_0_4_1 + 8.333333333333311e-03*G4_0_1_0_0_4_2 + 4.166666666666654e-03*G4_0_1_0_0_5_0 + 4.166666666666655e-03*G4_0_1_0_0_5_1 + 4.166666666666655e-03*G4_0_1_0_0_5_2 + 4.166666666666654e-03*G4_0_1_0_0_6_0 + 4.166666666666654e-03*G4_0_1_0_0_6_1 + 4.166666666666656e-03*G4_0_1_0_0_6_2 + 4.166666666666656e-03*G4_0_1_0_0_7_0 + 4.166666666666656e-03*G4_0_1_0_0_7_1 + 4.166666666666657e-03*G4_0_1_0_0_7_2 + 8.333333333333309e-03*G4_0_1_0_1_4_0 + 8.333333333333311e-03*G4_0_1_0_1_4_1 + 8.333333333333312e-03*G4_0_1_0_1_4_2 + 4.166666666666655e-03*G4_0_1_0_1_5_0 + 4.166666666666655e-03*G4_0_1_0_1_5_1 + 4.166666666666656e-03*G4_0_1_0_1_5_2 + 4.166666666666654e-03*G4_0_1_0_1_6_0 + 4.166666666666656e-03*G4_0_1_0_1_6_1 + 4.166666666666656e-03*G4_0_1_0_1_6_2 + 4.166666666666656e-03*G4_0_1_0_1_7_0 + 4.166666666666657e-03*G4_0_1_0_1_7_1 + 4.166666666666658e-03*G4_0_1_0_1_7_2 + 8.333333333333311e-03*G4_0_1_0_2_4_0 + 8.333333333333312e-03*G4_0_1_0_2_4_1 + 8.333333333333314e-03*G4_0_1_0_2_4_2 + 4.166666666666655e-03*G4_0_1_0_2_5_0 + 4.166666666666656e-03*G4_0_1_0_2_5_1 + 4.166666666666657e-03*G4_0_1_0_2_5_2 + 4.166666666666655e-03*G4_0_1_0_2_6_0 + 4.166666666666656e-03*G4_0_1_0_2_6_1 + 4.166666666666656e-03*G4_0_1_0_2_6_2 + 4.166666666666657e-03*G4_0_1_0_2_7_0 + 4.166666666666658e-03*G4_0_1_0_2_7_1 + 4.166666666666659e-03*G4_0_1_0_2_7_2 + 4.166666666666654e-03*G4_0_1_1_0_4_0 + 4.166666666666654e-03*G4_0_1_1_0_4_1 + 4.166666666666654e-03*G4_0_1_1_0_4_2 + 8.333333333333307e-03*G4_0_1_1_0_5_0 + 8.333333333333309e-03*G4_0_1_1_0_5_1 + 8.333333333333309e-03*G4_0_1_1_0_5_2 + 4.166666666666654e-03*G4_0_1_1_0_6_0 + 4.166666666666654e-03*G4_0_1_1_0_6_1 + 4.166666666666654e-03*G4_0_1_1_0_6_2 + 4.166666666666654e-03*G4_0_1_1_0_7_0 + 4.166666666666655e-03*G4_0_1_1_0_7_1 + 4.166666666666655e-03*G4_0_1_1_0_7_2 + 4.166666666666654e-03*G4_0_1_1_1_4_0 + 4.166666666666654e-03*G4_0_1_1_1_4_1 + 4.166666666666654e-03*G4_0_1_1_1_4_2 + 8.333333333333309e-03*G4_0_1_1_1_5_0 + 8.333333333333309e-03*G4_0_1_1_1_5_1 + 8.333333333333309e-03*G4_0_1_1_1_5_2 + 4.166666666666654e-03*G4_0_1_1_1_6_0 + 4.166666666666654e-03*G4_0_1_1_1_6_1 + 4.166666666666655e-03*G4_0_1_1_1_6_2 + 4.166666666666655e-03*G4_0_1_1_1_7_0 + 4.166666666666655e-03*G4_0_1_1_1_7_1 + 4.166666666666656e-03*G4_0_1_1_1_7_2 + 4.166666666666654e-03*G4_0_1_1_2_4_0 + 4.166666666666654e-03*G4_0_1_1_2_4_1 + 4.166666666666655e-03*G4_0_1_1_2_4_2 + 8.333333333333309e-03*G4_0_1_1_2_5_0 + 8.333333333333309e-03*G4_0_1_1_2_5_1 + 8.333333333333309e-03*G4_0_1_1_2_5_2 + 4.166666666666654e-03*G4_0_1_1_2_6_0 + 4.166666666666655e-03*G4_0_1_1_2_6_1 + 4.166666666666655e-03*G4_0_1_1_2_6_2 + 4.166666666666655e-03*G4_0_1_1_2_7_0 + 4.166666666666656e-03*G4_0_1_1_2_7_1 + 4.166666666666656e-03*G4_0_1_1_2_7_2 + 4.166666666666653e-03*G4_0_1_2_0_4_0 + 4.166666666666654e-03*G4_0_1_2_0_4_1 + 4.166666666666654e-03*G4_0_1_2_0_4_2 + 4.166666666666654e-03*G4_0_1_2_0_5_0 + 4.166666666666655e-03*G4_0_1_2_0_5_1 + 4.166666666666655e-03*G4_0_1_2_0_5_2 + 8.333333333333309e-03*G4_0_1_2_0_6_0 + 8.333333333333309e-03*G4_0_1_2_0_6_1 + 8.333333333333311e-03*G4_0_1_2_0_6_2 + 4.166666666666654e-03*G4_0_1_2_0_7_0 + 4.166666666666655e-03*G4_0_1_2_0_7_1 + 4.166666666666655e-03*G4_0_1_2_0_7_2 + 4.166666666666654e-03*G4_0_1_2_1_4_0 + 4.166666666666654e-03*G4_0_1_2_1_4_1 + 4.166666666666654e-03*G4_0_1_2_1_4_2 + 4.166666666666655e-03*G4_0_1_2_1_5_0 + 4.166666666666656e-03*G4_0_1_2_1_5_1 + 4.166666666666656e-03*G4_0_1_2_1_5_2 + 8.333333333333311e-03*G4_0_1_2_1_6_0 + 8.333333333333311e-03*G4_0_1_2_1_6_1 + 8.333333333333312e-03*G4_0_1_2_1_6_2 + 4.166666666666655e-03*G4_0_1_2_1_7_0 + 4.166666666666656e-03*G4_0_1_2_1_7_1 + 4.166666666666657e-03*G4_0_1_2_1_7_2 + 4.166666666666654e-03*G4_0_1_2_2_4_0 + 4.166666666666654e-03*G4_0_1_2_2_4_1 + 4.166666666666654e-03*G4_0_1_2_2_4_2 + 4.166666666666655e-03*G4_0_1_2_2_5_0 + 4.166666666666656e-03*G4_0_1_2_2_5_1 + 4.166666666666656e-03*G4_0_1_2_2_5_2 + 8.333333333333311e-03*G4_0_1_2_2_6_0 + 8.333333333333312e-03*G4_0_1_2_2_6_1 + 8.333333333333312e-03*G4_0_1_2_2_6_2 + 4.166666666666655e-03*G4_0_1_2_2_7_0 + 4.166666666666657e-03*G4_0_1_2_2_7_1 + 4.166666666666657e-03*G4_0_1_2_2_7_2 + 4.166666666666655e-03*G4_0_1_3_0_4_0 + 4.166666666666656e-03*G4_0_1_3_0_4_1 + 4.166666666666657e-03*G4_0_1_3_0_4_2 + 4.166666666666655e-03*G4_0_1_3_0_5_0 + 4.166666666666656e-03*G4_0_1_3_0_5_1 + 4.166666666666656e-03*G4_0_1_3_0_5_2 + 4.166666666666655e-03*G4_0_1_3_0_6_0 + 4.166666666666655e-03*G4_0_1_3_0_6_1 + 4.166666666666655e-03*G4_0_1_3_0_6_2 + 8.333333333333309e-03*G4_0_1_3_0_7_0 + 8.333333333333311e-03*G4_0_1_3_0_7_1 + 8.333333333333311e-03*G4_0_1_3_0_7_2 + 4.166666666666656e-03*G4_0_1_3_1_4_0 + 4.166666666666657e-03*G4_0_1_3_1_4_1 + 4.166666666666657e-03*G4_0_1_3_1_4_2 + 4.166666666666656e-03*G4_0_1_3_1_5_0 + 4.166666666666657e-03*G4_0_1_3_1_5_1 + 4.166666666666657e-03*G4_0_1_3_1_5_2 + 4.166666666666655e-03*G4_0_1_3_1_6_0 + 4.166666666666656e-03*G4_0_1_3_1_6_1 + 4.166666666666657e-03*G4_0_1_3_1_6_2 + 8.333333333333311e-03*G4_0_1_3_1_7_0 + 8.333333333333311e-03*G4_0_1_3_1_7_1 + 8.333333333333312e-03*G4_0_1_3_1_7_2 + 4.166666666666657e-03*G4_0_1_3_2_4_0 + 4.166666666666657e-03*G4_0_1_3_2_4_1 + 4.166666666666658e-03*G4_0_1_3_2_4_2 + 4.166666666666656e-03*G4_0_1_3_2_5_0 + 4.166666666666657e-03*G4_0_1_3_2_5_1 + 4.166666666666657e-03*G4_0_1_3_2_5_2 + 4.166666666666655e-03*G4_0_1_3_2_6_0 + 4.166666666666657e-03*G4_0_1_3_2_6_1 + 4.166666666666657e-03*G4_0_1_3_2_6_2 + 8.333333333333311e-03*G4_0_1_3_2_7_0 + 8.333333333333312e-03*G4_0_1_3_2_7_1 + 8.333333333333312e-03*G4_0_1_3_2_7_2 + 8.333333333333309e-03*G4_0_2_0_0_8_0 + 8.333333333333309e-03*G4_0_2_0_0_8_1 + 8.333333333333311e-03*G4_0_2_0_0_8_2 + 4.166666666666654e-03*G4_0_2_0_0_9_0 + 4.166666666666655e-03*G4_0_2_0_0_9_1 + 4.166666666666655e-03*G4_0_2_0_0_9_2 + 4.166666666666654e-03*G4_0_2_0_0_10_0 + 4.166666666666654e-03*G4_0_2_0_0_10_1 + 4.166666666666656e-03*G4_0_2_0_0_10_2 + 4.166666666666656e-03*G4_0_2_0_0_11_0 + 4.166666666666656e-03*G4_0_2_0_0_11_1 + 4.166666666666657e-03*G4_0_2_0_0_11_2 + 8.333333333333309e-03*G4_0_2_0_1_8_0 + 8.333333333333311e-03*G4_0_2_0_1_8_1 + 8.333333333333312e-03*G4_0_2_0_1_8_2 + 4.166666666666655e-03*G4_0_2_0_1_9_0 + 4.166666666666655e-03*G4_0_2_0_1_9_1 + 4.166666666666656e-03*G4_0_2_0_1_9_2 + 4.166666666666654e-03*G4_0_2_0_1_10_0 + 4.166666666666656e-03*G4_0_2_0_1_10_1 + 4.166666666666656e-03*G4_0_2_0_1_10_2 + 4.166666666666656e-03*G4_0_2_0_1_11_0 + 4.166666666666657e-03*G4_0_2_0_1_11_1 + 4.166666666666658e-03*G4_0_2_0_1_11_2 + 8.333333333333311e-03*G4_0_2_0_2_8_0 + 8.333333333333312e-03*G4_0_2_0_2_8_1 + 8.333333333333314e-03*G4_0_2_0_2_8_2 + 4.166666666666655e-03*G4_0_2_0_2_9_0 + 4.166666666666656e-03*G4_0_2_0_2_9_1 + 4.166666666666657e-03*G4_0_2_0_2_9_2 + 4.166666666666655e-03*G4_0_2_0_2_10_0 + 4.166666666666656e-03*G4_0_2_0_2_10_1 + 4.166666666666656e-03*G4_0_2_0_2_10_2 + 4.166666666666657e-03*G4_0_2_0_2_11_0 + 4.166666666666658e-03*G4_0_2_0_2_11_1 + 4.166666666666659e-03*G4_0_2_0_2_11_2 + 4.166666666666654e-03*G4_0_2_1_0_8_0 + 4.166666666666654e-03*G4_0_2_1_0_8_1 + 4.166666666666654e-03*G4_0_2_1_0_8_2 + 8.333333333333307e-03*G4_0_2_1_0_9_0 + 8.333333333333309e-03*G4_0_2_1_0_9_1 + 8.333333333333309e-03*G4_0_2_1_0_9_2 + 4.166666666666654e-03*G4_0_2_1_0_10_0 + 4.166666666666654e-03*G4_0_2_1_0_10_1 + 4.166666666666654e-03*G4_0_2_1_0_10_2 + 4.166666666666654e-03*G4_0_2_1_0_11_0 + 4.166666666666655e-03*G4_0_2_1_0_11_1 + 4.166666666666655e-03*G4_0_2_1_0_11_2 + 4.166666666666654e-03*G4_0_2_1_1_8_0 + 4.166666666666654e-03*G4_0_2_1_1_8_1 + 4.166666666666654e-03*G4_0_2_1_1_8_2 + 8.333333333333309e-03*G4_0_2_1_1_9_0 + 8.333333333333309e-03*G4_0_2_1_1_9_1 + 8.333333333333309e-03*G4_0_2_1_1_9_2 + 4.166666666666654e-03*G4_0_2_1_1_10_0 + 4.166666666666654e-03*G4_0_2_1_1_10_1 + 4.166666666666655e-03*G4_0_2_1_1_10_2 + 4.166666666666655e-03*G4_0_2_1_1_11_0 + 4.166666666666655e-03*G4_0_2_1_1_11_1 + 4.166666666666656e-03*G4_0_2_1_1_11_2 + 4.166666666666654e-03*G4_0_2_1_2_8_0 + 4.166666666666654e-03*G4_0_2_1_2_8_1 + 4.166666666666655e-03*G4_0_2_1_2_8_2 + 8.333333333333309e-03*G4_0_2_1_2_9_0 + 8.333333333333309e-03*G4_0_2_1_2_9_1 + 8.333333333333309e-03*G4_0_2_1_2_9_2 + 4.166666666666654e-03*G4_0_2_1_2_10_0 + 4.166666666666655e-03*G4_0_2_1_2_10_1 + 4.166666666666655e-03*G4_0_2_1_2_10_2 + 4.166666666666655e-03*G4_0_2_1_2_11_0 + 4.166666666666656e-03*G4_0_2_1_2_11_1 + 4.166666666666656e-03*G4_0_2_1_2_11_2 + 4.166666666666653e-03*G4_0_2_2_0_8_0 + 4.166666666666654e-03*G4_0_2_2_0_8_1 + 4.166666666666654e-03*G4_0_2_2_0_8_2 + 4.166666666666654e-03*G4_0_2_2_0_9_0 + 4.166666666666655e-03*G4_0_2_2_0_9_1 + 4.166666666666655e-03*G4_0_2_2_0_9_2 + 8.333333333333309e-03*G4_0_2_2_0_10_0 + 8.333333333333309e-03*G4_0_2_2_0_10_1 + 8.333333333333311e-03*G4_0_2_2_0_10_2 + 4.166666666666654e-03*G4_0_2_2_0_11_0 + 4.166666666666655e-03*G4_0_2_2_0_11_1 + 4.166666666666655e-03*G4_0_2_2_0_11_2 + 4.166666666666654e-03*G4_0_2_2_1_8_0 + 4.166666666666654e-03*G4_0_2_2_1_8_1 + 4.166666666666654e-03*G4_0_2_2_1_8_2 + 4.166666666666655e-03*G4_0_2_2_1_9_0 + 4.166666666666656e-03*G4_0_2_2_1_9_1 + 4.166666666666656e-03*G4_0_2_2_1_9_2 + 8.333333333333311e-03*G4_0_2_2_1_10_0 + 8.333333333333311e-03*G4_0_2_2_1_10_1 + 8.333333333333312e-03*G4_0_2_2_1_10_2 + 4.166666666666655e-03*G4_0_2_2_1_11_0 + 4.166666666666656e-03*G4_0_2_2_1_11_1 + 4.166666666666657e-03*G4_0_2_2_1_11_2 + 4.166666666666654e-03*G4_0_2_2_2_8_0 + 4.166666666666654e-03*G4_0_2_2_2_8_1 + 4.166666666666654e-03*G4_0_2_2_2_8_2 + 4.166666666666655e-03*G4_0_2_2_2_9_0 + 4.166666666666656e-03*G4_0_2_2_2_9_1 + 4.166666666666656e-03*G4_0_2_2_2_9_2 + 8.333333333333311e-03*G4_0_2_2_2_10_0 + 8.333333333333312e-03*G4_0_2_2_2_10_1 + 8.333333333333312e-03*G4_0_2_2_2_10_2 + 4.166666666666655e-03*G4_0_2_2_2_11_0 + 4.166666666666657e-03*G4_0_2_2_2_11_1 + 4.166666666666657e-03*G4_0_2_2_2_11_2 + 4.166666666666655e-03*G4_0_2_3_0_8_0 + 4.166666666666656e-03*G4_0_2_3_0_8_1 + 4.166666666666657e-03*G4_0_2_3_0_8_2 + 4.166666666666655e-03*G4_0_2_3_0_9_0 + 4.166666666666656e-03*G4_0_2_3_0_9_1 + 4.166666666666656e-03*G4_0_2_3_0_9_2 + 4.166666666666655e-03*G4_0_2_3_0_10_0 + 4.166666666666655e-03*G4_0_2_3_0_10_1 + 4.166666666666655e-03*G4_0_2_3_0_10_2 + 8.333333333333309e-03*G4_0_2_3_0_11_0 + 8.333333333333311e-03*G4_0_2_3_0_11_1 + 8.333333333333311e-03*G4_0_2_3_0_11_2 + 4.166666666666656e-03*G4_0_2_3_1_8_0 + 4.166666666666657e-03*G4_0_2_3_1_8_1 + 4.166666666666657e-03*G4_0_2_3_1_8_2 + 4.166666666666656e-03*G4_0_2_3_1_9_0 + 4.166666666666657e-03*G4_0_2_3_1_9_1 + 4.166666666666657e-03*G4_0_2_3_1_9_2 + 4.166666666666655e-03*G4_0_2_3_1_10_0 + 4.166666666666656e-03*G4_0_2_3_1_10_1 + 4.166666666666657e-03*G4_0_2_3_1_10_2 + 8.333333333333311e-03*G4_0_2_3_1_11_0 + 8.333333333333311e-03*G4_0_2_3_1_11_1 + 8.333333333333312e-03*G4_0_2_3_1_11_2 + 4.166666666666657e-03*G4_0_2_3_2_8_0 + 4.166666666666657e-03*G4_0_2_3_2_8_1 + 4.166666666666658e-03*G4_0_2_3_2_8_2 + 4.166666666666656e-03*G4_0_2_3_2_9_0 + 4.166666666666657e-03*G4_0_2_3_2_9_1 + 4.166666666666657e-03*G4_0_2_3_2_9_2 + 4.166666666666655e-03*G4_0_2_3_2_10_0 + 4.166666666666657e-03*G4_0_2_3_2_10_1 + 4.166666666666657e-03*G4_0_2_3_2_10_2 + 8.333333333333311e-03*G4_0_2_3_2_11_0 + 8.333333333333312e-03*G4_0_2_3_2_11_1 + 8.333333333333312e-03*G4_0_2_3_2_11_2 + 8.333333333333309e-03*G4_1_0_4_0_0_0 + 8.333333333333309e-03*G4_1_0_4_0_0_1 + 8.333333333333311e-03*G4_1_0_4_0_0_2 + 4.166666666666654e-03*G4_1_0_4_0_1_0 + 4.166666666666654e-03*G4_1_0_4_0_1_1 + 4.166666666666654e-03*G4_1_0_4_0_1_2 + 4.166666666666653e-03*G4_1_0_4_0_2_0 + 4.166666666666654e-03*G4_1_0_4_0_2_1 + 4.166666666666654e-03*G4_1_0_4_0_2_2 + 4.166666666666654e-03*G4_1_0_4_0_3_0 + 4.166666666666656e-03*G4_1_0_4_0_3_1 + 4.166666666666657e-03*G4_1_0_4_0_3_2 + 8.333333333333309e-03*G4_1_0_4_1_0_0 + 8.333333333333311e-03*G4_1_0_4_1_0_1 + 8.333333333333312e-03*G4_1_0_4_1_0_2 + 4.166666666666654e-03*G4_1_0_4_1_1_0 + 4.166666666666654e-03*G4_1_0_4_1_1_1 + 4.166666666666654e-03*G4_1_0_4_1_1_2 + 4.166666666666654e-03*G4_1_0_4_1_2_0 + 4.166666666666654e-03*G4_1_0_4_1_2_1 + 4.166666666666654e-03*G4_1_0_4_1_2_2 + 4.166666666666656e-03*G4_1_0_4_1_3_0 + 4.166666666666657e-03*G4_1_0_4_1_3_1 + 4.166666666666657e-03*G4_1_0_4_1_3_2 + 8.333333333333311e-03*G4_1_0_4_2_0_0 + 8.333333333333312e-03*G4_1_0_4_2_0_1 + 8.333333333333314e-03*G4_1_0_4_2_0_2 + 4.166666666666654e-03*G4_1_0_4_2_1_0 + 4.166666666666654e-03*G4_1_0_4_2_1_1 + 4.166666666666655e-03*G4_1_0_4_2_1_2 + 4.166666666666654e-03*G4_1_0_4_2_2_0 + 4.166666666666654e-03*G4_1_0_4_2_2_1 + 4.166666666666654e-03*G4_1_0_4_2_2_2 + 4.166666666666657e-03*G4_1_0_4_2_3_0 + 4.166666666666657e-03*G4_1_0_4_2_3_1 + 4.166666666666658e-03*G4_1_0_4_2_3_2 + 4.166666666666654e-03*G4_1_0_5_0_0_0 + 4.166666666666655e-03*G4_1_0_5_0_0_1 + 4.166666666666655e-03*G4_1_0_5_0_0_2 + 8.333333333333307e-03*G4_1_0_5_0_1_0 + 8.333333333333309e-03*G4_1_0_5_0_1_1 + 8.333333333333309e-03*G4_1_0_5_0_1_2 + 4.166666666666654e-03*G4_1_0_5_0_2_0 + 4.166666666666655e-03*G4_1_0_5_0_2_1 + 4.166666666666655e-03*G4_1_0_5_0_2_2 + 4.166666666666655e-03*G4_1_0_5_0_3_0 + 4.166666666666656e-03*G4_1_0_5_0_3_1 + 4.166666666666656e-03*G4_1_0_5_0_3_2 + 4.166666666666655e-03*G4_1_0_5_1_0_0 + 4.166666666666655e-03*G4_1_0_5_1_0_1 + 4.166666666666656e-03*G4_1_0_5_1_0_2 + 8.333333333333309e-03*G4_1_0_5_1_1_0 + 8.333333333333309e-03*G4_1_0_5_1_1_1 + 8.333333333333309e-03*G4_1_0_5_1_1_2 + 4.166666666666655e-03*G4_1_0_5_1_2_0 + 4.166666666666656e-03*G4_1_0_5_1_2_1 + 4.166666666666656e-03*G4_1_0_5_1_2_2 + 4.166666666666656e-03*G4_1_0_5_1_3_0 + 4.166666666666657e-03*G4_1_0_5_1_3_1 + 4.166666666666657e-03*G4_1_0_5_1_3_2 + 4.166666666666655e-03*G4_1_0_5_2_0_0 + 4.166666666666656e-03*G4_1_0_5_2_0_1 + 4.166666666666657e-03*G4_1_0_5_2_0_2 + 8.333333333333309e-03*G4_1_0_5_2_1_0 + 8.333333333333309e-03*G4_1_0_5_2_1_1 + 8.333333333333309e-03*G4_1_0_5_2_1_2 + 4.166666666666655e-03*G4_1_0_5_2_2_0 + 4.166666666666656e-03*G4_1_0_5_2_2_1 + 4.166666666666656e-03*G4_1_0_5_2_2_2 + 4.166666666666656e-03*G4_1_0_5_2_3_0 + 4.166666666666657e-03*G4_1_0_5_2_3_1 + 4.166666666666657e-03*G4_1_0_5_2_3_2 + 4.166666666666654e-03*G4_1_0_6_0_0_0 + 4.166666666666654e-03*G4_1_0_6_0_0_1 + 4.166666666666655e-03*G4_1_0_6_0_0_2 + 4.166666666666654e-03*G4_1_0_6_0_1_0 + 4.166666666666654e-03*G4_1_0_6_0_1_1 + 4.166666666666654e-03*G4_1_0_6_0_1_2 + 8.333333333333309e-03*G4_1_0_6_0_2_0 + 8.333333333333309e-03*G4_1_0_6_0_2_1 + 8.333333333333311e-03*G4_1_0_6_0_2_2 + 4.166666666666654e-03*G4_1_0_6_0_3_0 + 4.166666666666655e-03*G4_1_0_6_0_3_1 + 4.166666666666655e-03*G4_1_0_6_0_3_2 + 4.166666666666654e-03*G4_1_0_6_1_0_0 + 4.166666666666656e-03*G4_1_0_6_1_0_1 + 4.166666666666656e-03*G4_1_0_6_1_0_2 + 4.166666666666654e-03*G4_1_0_6_1_1_0 + 4.166666666666654e-03*G4_1_0_6_1_1_1 + 4.166666666666654e-03*G4_1_0_6_1_1_2 + 8.333333333333311e-03*G4_1_0_6_1_2_0 + 8.333333333333311e-03*G4_1_0_6_1_2_1 + 8.333333333333312e-03*G4_1_0_6_1_2_2 + 4.166666666666655e-03*G4_1_0_6_1_3_0 + 4.166666666666656e-03*G4_1_0_6_1_3_1 + 4.166666666666657e-03*G4_1_0_6_1_3_2 + 4.166666666666655e-03*G4_1_0_6_2_0_0 + 4.166666666666656e-03*G4_1_0_6_2_0_1 + 4.166666666666656e-03*G4_1_0_6_2_0_2 + 4.166666666666654e-03*G4_1_0_6_2_1_0 + 4.166666666666654e-03*G4_1_0_6_2_1_1 + 4.166666666666655e-03*G4_1_0_6_2_1_2 + 8.333333333333311e-03*G4_1_0_6_2_2_0 + 8.333333333333312e-03*G4_1_0_6_2_2_1 + 8.333333333333312e-03*G4_1_0_6_2_2_2 + 4.166666666666655e-03*G4_1_0_6_2_3_0 + 4.166666666666657e-03*G4_1_0_6_2_3_1 + 4.166666666666657e-03*G4_1_0_6_2_3_2 + 4.166666666666656e-03*G4_1_0_7_0_0_0 + 4.166666666666656e-03*G4_1_0_7_0_0_1 + 4.166666666666657e-03*G4_1_0_7_0_0_2 + 4.166666666666654e-03*G4_1_0_7_0_1_0 + 4.166666666666655e-03*G4_1_0_7_0_1_1 + 4.166666666666655e-03*G4_1_0_7_0_1_2 + 4.166666666666655e-03*G4_1_0_7_0_2_0 + 4.166666666666655e-03*G4_1_0_7_0_2_1 + 4.166666666666655e-03*G4_1_0_7_0_2_2 + 8.333333333333309e-03*G4_1_0_7_0_3_0 + 8.333333333333311e-03*G4_1_0_7_0_3_1 + 8.333333333333311e-03*G4_1_0_7_0_3_2 + 4.166666666666656e-03*G4_1_0_7_1_0_0 + 4.166666666666657e-03*G4_1_0_7_1_0_1 + 4.166666666666658e-03*G4_1_0_7_1_0_2 + 4.166666666666655e-03*G4_1_0_7_1_1_0 + 4.166666666666655e-03*G4_1_0_7_1_1_1 + 4.166666666666656e-03*G4_1_0_7_1_1_2 + 4.166666666666655e-03*G4_1_0_7_1_2_0 + 4.166666666666656e-03*G4_1_0_7_1_2_1 + 4.166666666666657e-03*G4_1_0_7_1_2_2 + 8.333333333333311e-03*G4_1_0_7_1_3_0 + 8.333333333333311e-03*G4_1_0_7_1_3_1 + 8.333333333333312e-03*G4_1_0_7_1_3_2 + 4.166666666666657e-03*G4_1_0_7_2_0_0 + 4.166666666666658e-03*G4_1_0_7_2_0_1 + 4.166666666666659e-03*G4_1_0_7_2_0_2 + 4.166666666666655e-03*G4_1_0_7_2_1_0 + 4.166666666666656e-03*G4_1_0_7_2_1_1 + 4.166666666666656e-03*G4_1_0_7_2_1_2 + 4.166666666666655e-03*G4_1_0_7_2_2_0 + 4.166666666666657e-03*G4_1_0_7_2_2_1 + 4.166666666666657e-03*G4_1_0_7_2_2_2 + 8.333333333333311e-03*G4_1_0_7_2_3_0 + 8.333333333333312e-03*G4_1_0_7_2_3_1 + 8.333333333333312e-03*G4_1_0_7_2_3_2 + 8.333333333333309e-03*G4_1_1_4_0_4_0 + 8.333333333333309e-03*G4_1_1_4_0_4_1 + 8.333333333333311e-03*G4_1_1_4_0_4_2 + 4.166666666666654e-03*G4_1_1_4_0_5_0 + 4.166666666666654e-03*G4_1_1_4_0_5_1 + 4.166666666666654e-03*G4_1_1_4_0_5_2 + 4.166666666666653e-03*G4_1_1_4_0_6_0 + 4.166666666666654e-03*G4_1_1_4_0_6_1 + 4.166666666666654e-03*G4_1_1_4_0_6_2 + 4.166666666666654e-03*G4_1_1_4_0_7_0 + 4.166666666666656e-03*G4_1_1_4_0_7_1 + 4.166666666666657e-03*G4_1_1_4_0_7_2 + 8.333333333333309e-03*G4_1_1_4_1_4_0 + 8.333333333333311e-03*G4_1_1_4_1_4_1 + 8.333333333333312e-03*G4_1_1_4_1_4_2 + 4.166666666666654e-03*G4_1_1_4_1_5_0 + 4.166666666666654e-03*G4_1_1_4_1_5_1 + 4.166666666666655e-03*G4_1_1_4_1_5_2 + 4.166666666666654e-03*G4_1_1_4_1_6_0 + 4.166666666666654e-03*G4_1_1_4_1_6_1 + 4.166666666666654e-03*G4_1_1_4_1_6_2 + 4.166666666666656e-03*G4_1_1_4_1_7_0 + 4.166666666666657e-03*G4_1_1_4_1_7_1 + 4.166666666666657e-03*G4_1_1_4_1_7_2 + 8.333333333333311e-03*G4_1_1_4_2_4_0 + 8.333333333333312e-03*G4_1_1_4_2_4_1 + 8.333333333333314e-03*G4_1_1_4_2_4_2 + 4.166666666666654e-03*G4_1_1_4_2_5_0 + 4.166666666666655e-03*G4_1_1_4_2_5_1 + 4.166666666666655e-03*G4_1_1_4_2_5_2 + 4.166666666666654e-03*G4_1_1_4_2_6_0 + 4.166666666666654e-03*G4_1_1_4_2_6_1 + 4.166666666666654e-03*G4_1_1_4_2_6_2 + 4.166666666666657e-03*G4_1_1_4_2_7_0 + 4.166666666666657e-03*G4_1_1_4_2_7_1 + 4.166666666666658e-03*G4_1_1_4_2_7_2 + 4.166666666666654e-03*G4_1_1_5_0_4_0 + 4.166666666666654e-03*G4_1_1_5_0_4_1 + 4.166666666666654e-03*G4_1_1_5_0_4_2 + 8.333333333333307e-03*G4_1_1_5_0_5_0 + 8.333333333333309e-03*G4_1_1_5_0_5_1 + 8.333333333333309e-03*G4_1_1_5_0_5_2 + 4.166666666666654e-03*G4_1_1_5_0_6_0 + 4.166666666666655e-03*G4_1_1_5_0_6_1 + 4.166666666666655e-03*G4_1_1_5_0_6_2 + 4.166666666666655e-03*G4_1_1_5_0_7_0 + 4.166666666666656e-03*G4_1_1_5_0_7_1 + 4.166666666666656e-03*G4_1_1_5_0_7_2 + 4.166666666666654e-03*G4_1_1_5_1_4_0 + 4.166666666666654e-03*G4_1_1_5_1_4_1 + 4.166666666666655e-03*G4_1_1_5_1_4_2 + 8.333333333333309e-03*G4_1_1_5_1_5_0 + 8.333333333333309e-03*G4_1_1_5_1_5_1 + 8.333333333333309e-03*G4_1_1_5_1_5_2 + 4.166666666666655e-03*G4_1_1_5_1_6_0 + 4.166666666666656e-03*G4_1_1_5_1_6_1 + 4.166666666666656e-03*G4_1_1_5_1_6_2 + 4.166666666666656e-03*G4_1_1_5_1_7_0 + 4.166666666666657e-03*G4_1_1_5_1_7_1 + 4.166666666666657e-03*G4_1_1_5_1_7_2 + 4.166666666666654e-03*G4_1_1_5_2_4_0 + 4.166666666666655e-03*G4_1_1_5_2_4_1 + 4.166666666666655e-03*G4_1_1_5_2_4_2 + 8.333333333333309e-03*G4_1_1_5_2_5_0 + 8.333333333333309e-03*G4_1_1_5_2_5_1 + 8.333333333333309e-03*G4_1_1_5_2_5_2 + 4.166666666666655e-03*G4_1_1_5_2_6_0 + 4.166666666666656e-03*G4_1_1_5_2_6_1 + 4.166666666666656e-03*G4_1_1_5_2_6_2 + 4.166666666666656e-03*G4_1_1_5_2_7_0 + 4.166666666666657e-03*G4_1_1_5_2_7_1 + 4.166666666666657e-03*G4_1_1_5_2_7_2 + 4.166666666666653e-03*G4_1_1_6_0_4_0 + 4.166666666666654e-03*G4_1_1_6_0_4_1 + 4.166666666666654e-03*G4_1_1_6_0_4_2 + 4.166666666666654e-03*G4_1_1_6_0_5_0 + 4.166666666666655e-03*G4_1_1_6_0_5_1 + 4.166666666666655e-03*G4_1_1_6_0_5_2 + 8.333333333333309e-03*G4_1_1_6_0_6_0 + 8.333333333333309e-03*G4_1_1_6_0_6_1 + 8.333333333333311e-03*G4_1_1_6_0_6_2 + 4.166666666666654e-03*G4_1_1_6_0_7_0 + 4.166666666666655e-03*G4_1_1_6_0_7_1 + 4.166666666666655e-03*G4_1_1_6_0_7_2 + 4.166666666666654e-03*G4_1_1_6_1_4_0 + 4.166666666666654e-03*G4_1_1_6_1_4_1 + 4.166666666666654e-03*G4_1_1_6_1_4_2 + 4.166666666666655e-03*G4_1_1_6_1_5_0 + 4.166666666666656e-03*G4_1_1_6_1_5_1 + 4.166666666666656e-03*G4_1_1_6_1_5_2 + 8.333333333333311e-03*G4_1_1_6_1_6_0 + 8.333333333333311e-03*G4_1_1_6_1_6_1 + 8.333333333333312e-03*G4_1_1_6_1_6_2 + 4.166666666666655e-03*G4_1_1_6_1_7_0 + 4.166666666666656e-03*G4_1_1_6_1_7_1 + 4.166666666666657e-03*G4_1_1_6_1_7_2 + 4.166666666666654e-03*G4_1_1_6_2_4_0 + 4.166666666666654e-03*G4_1_1_6_2_4_1 + 4.166666666666654e-03*G4_1_1_6_2_4_2 + 4.166666666666655e-03*G4_1_1_6_2_5_0 + 4.166666666666656e-03*G4_1_1_6_2_5_1 + 4.166666666666656e-03*G4_1_1_6_2_5_2 + 8.333333333333311e-03*G4_1_1_6_2_6_0 + 8.333333333333312e-03*G4_1_1_6_2_6_1 + 8.333333333333312e-03*G4_1_1_6_2_6_2 + 4.166666666666655e-03*G4_1_1_6_2_7_0 + 4.166666666666657e-03*G4_1_1_6_2_7_1 + 4.166666666666657e-03*G4_1_1_6_2_7_2 + 4.166666666666655e-03*G4_1_1_7_0_4_0 + 4.166666666666656e-03*G4_1_1_7_0_4_1 + 4.166666666666657e-03*G4_1_1_7_0_4_2 + 4.166666666666655e-03*G4_1_1_7_0_5_0 + 4.166666666666656e-03*G4_1_1_7_0_5_1 + 4.166666666666656e-03*G4_1_1_7_0_5_2 + 4.166666666666655e-03*G4_1_1_7_0_6_0 + 4.166666666666655e-03*G4_1_1_7_0_6_1 + 4.166666666666655e-03*G4_1_1_7_0_6_2 + 8.333333333333309e-03*G4_1_1_7_0_7_0 + 8.333333333333311e-03*G4_1_1_7_0_7_1 + 8.333333333333311e-03*G4_1_1_7_0_7_2 + 4.166666666666656e-03*G4_1_1_7_1_4_0 + 4.166666666666657e-03*G4_1_1_7_1_4_1 + 4.166666666666657e-03*G4_1_1_7_1_4_2 + 4.166666666666656e-03*G4_1_1_7_1_5_0 + 4.166666666666657e-03*G4_1_1_7_1_5_1 + 4.166666666666657e-03*G4_1_1_7_1_5_2 + 4.166666666666655e-03*G4_1_1_7_1_6_0 + 4.166666666666656e-03*G4_1_1_7_1_6_1 + 4.166666666666657e-03*G4_1_1_7_1_6_2 + 8.333333333333311e-03*G4_1_1_7_1_7_0 + 8.333333333333311e-03*G4_1_1_7_1_7_1 + 8.333333333333312e-03*G4_1_1_7_1_7_2 + 4.166666666666657e-03*G4_1_1_7_2_4_0 + 4.166666666666657e-03*G4_1_1_7_2_4_1 + 4.166666666666658e-03*G4_1_1_7_2_4_2 + 4.166666666666656e-03*G4_1_1_7_2_5_0 + 4.166666666666657e-03*G4_1_1_7_2_5_1 + 4.166666666666657e-03*G4_1_1_7_2_5_2 + 4.166666666666655e-03*G4_1_1_7_2_6_0 + 4.166666666666657e-03*G4_1_1_7_2_6_1 + 4.166666666666657e-03*G4_1_1_7_2_6_2 + 8.333333333333311e-03*G4_1_1_7_2_7_0 + 8.333333333333312e-03*G4_1_1_7_2_7_1 + 8.333333333333312e-03*G4_1_1_7_2_7_2 + 8.333333333333309e-03*G4_1_2_4_0_8_0 + 8.333333333333309e-03*G4_1_2_4_0_8_1 + 8.333333333333311e-03*G4_1_2_4_0_8_2 + 4.166666666666654e-03*G4_1_2_4_0_9_0 + 4.166666666666654e-03*G4_1_2_4_0_9_1 + 4.166666666666654e-03*G4_1_2_4_0_9_2 + 4.166666666666653e-03*G4_1_2_4_0_10_0 + 4.166666666666654e-03*G4_1_2_4_0_10_1 + 4.166666666666654e-03*G4_1_2_4_0_10_2 + 4.166666666666654e-03*G4_1_2_4_0_11_0 + 4.166666666666656e-03*G4_1_2_4_0_11_1 + 4.166666666666657e-03*G4_1_2_4_0_11_2 + 8.333333333333309e-03*G4_1_2_4_1_8_0 + 8.333333333333311e-03*G4_1_2_4_1_8_1 + 8.333333333333312e-03*G4_1_2_4_1_8_2 + 4.166666666666654e-03*G4_1_2_4_1_9_0 + 4.166666666666654e-03*G4_1_2_4_1_9_1 + 4.166666666666655e-03*G4_1_2_4_1_9_2 + 4.166666666666654e-03*G4_1_2_4_1_10_0 + 4.166666666666654e-03*G4_1_2_4_1_10_1 + 4.166666666666654e-03*G4_1_2_4_1_10_2 + 4.166666666666656e-03*G4_1_2_4_1_11_0 + 4.166666666666657e-03*G4_1_2_4_1_11_1 + 4.166666666666657e-03*G4_1_2_4_1_11_2 + 8.333333333333311e-03*G4_1_2_4_2_8_0 + 8.333333333333312e-03*G4_1_2_4_2_8_1 + 8.333333333333314e-03*G4_1_2_4_2_8_2 + 4.166666666666654e-03*G4_1_2_4_2_9_0 + 4.166666666666655e-03*G4_1_2_4_2_9_1 + 4.166666666666655e-03*G4_1_2_4_2_9_2 + 4.166666666666654e-03*G4_1_2_4_2_10_0 + 4.166666666666654e-03*G4_1_2_4_2_10_1 + 4.166666666666654e-03*G4_1_2_4_2_10_2 + 4.166666666666657e-03*G4_1_2_4_2_11_0 + 4.166666666666657e-03*G4_1_2_4_2_11_1 + 4.166666666666658e-03*G4_1_2_4_2_11_2 + 4.166666666666654e-03*G4_1_2_5_0_8_0 + 4.166666666666654e-03*G4_1_2_5_0_8_1 + 4.166666666666654e-03*G4_1_2_5_0_8_2 + 8.333333333333307e-03*G4_1_2_5_0_9_0 + 8.333333333333309e-03*G4_1_2_5_0_9_1 + 8.333333333333309e-03*G4_1_2_5_0_9_2 + 4.166666666666654e-03*G4_1_2_5_0_10_0 + 4.166666666666655e-03*G4_1_2_5_0_10_1 + 4.166666666666655e-03*G4_1_2_5_0_10_2 + 4.166666666666655e-03*G4_1_2_5_0_11_0 + 4.166666666666656e-03*G4_1_2_5_0_11_1 + 4.166666666666656e-03*G4_1_2_5_0_11_2 + 4.166666666666654e-03*G4_1_2_5_1_8_0 + 4.166666666666654e-03*G4_1_2_5_1_8_1 + 4.166666666666655e-03*G4_1_2_5_1_8_2 + 8.333333333333309e-03*G4_1_2_5_1_9_0 + 8.333333333333309e-03*G4_1_2_5_1_9_1 + 8.333333333333309e-03*G4_1_2_5_1_9_2 + 4.166666666666655e-03*G4_1_2_5_1_10_0 + 4.166666666666656e-03*G4_1_2_5_1_10_1 + 4.166666666666656e-03*G4_1_2_5_1_10_2 + 4.166666666666656e-03*G4_1_2_5_1_11_0 + 4.166666666666657e-03*G4_1_2_5_1_11_1 + 4.166666666666657e-03*G4_1_2_5_1_11_2 + 4.166666666666654e-03*G4_1_2_5_2_8_0 + 4.166666666666655e-03*G4_1_2_5_2_8_1 + 4.166666666666655e-03*G4_1_2_5_2_8_2 + 8.333333333333309e-03*G4_1_2_5_2_9_0 + 8.333333333333309e-03*G4_1_2_5_2_9_1 + 8.333333333333309e-03*G4_1_2_5_2_9_2 + 4.166666666666655e-03*G4_1_2_5_2_10_0 + 4.166666666666656e-03*G4_1_2_5_2_10_1 + 4.166666666666656e-03*G4_1_2_5_2_10_2 + 4.166666666666656e-03*G4_1_2_5_2_11_0 + 4.166666666666657e-03*G4_1_2_5_2_11_1 + 4.166666666666657e-03*G4_1_2_5_2_11_2 + 4.166666666666653e-03*G4_1_2_6_0_8_0 + 4.166666666666654e-03*G4_1_2_6_0_8_1 + 4.166666666666654e-03*G4_1_2_6_0_8_2 + 4.166666666666654e-03*G4_1_2_6_0_9_0 + 4.166666666666655e-03*G4_1_2_6_0_9_1 + 4.166666666666655e-03*G4_1_2_6_0_9_2 + 8.333333333333309e-03*G4_1_2_6_0_10_0 + 8.333333333333309e-03*G4_1_2_6_0_10_1 + 8.333333333333311e-03*G4_1_2_6_0_10_2 + 4.166666666666654e-03*G4_1_2_6_0_11_0 + 4.166666666666655e-03*G4_1_2_6_0_11_1 + 4.166666666666655e-03*G4_1_2_6_0_11_2 + 4.166666666666654e-03*G4_1_2_6_1_8_0 + 4.166666666666654e-03*G4_1_2_6_1_8_1 + 4.166666666666654e-03*G4_1_2_6_1_8_2 + 4.166666666666655e-03*G4_1_2_6_1_9_0 + 4.166666666666656e-03*G4_1_2_6_1_9_1 + 4.166666666666656e-03*G4_1_2_6_1_9_2 + 8.333333333333311e-03*G4_1_2_6_1_10_0 + 8.333333333333311e-03*G4_1_2_6_1_10_1 + 8.333333333333312e-03*G4_1_2_6_1_10_2 + 4.166666666666655e-03*G4_1_2_6_1_11_0 + 4.166666666666656e-03*G4_1_2_6_1_11_1 + 4.166666666666657e-03*G4_1_2_6_1_11_2 + 4.166666666666654e-03*G4_1_2_6_2_8_0 + 4.166666666666654e-03*G4_1_2_6_2_8_1 + 4.166666666666654e-03*G4_1_2_6_2_8_2 + 4.166666666666655e-03*G4_1_2_6_2_9_0 + 4.166666666666656e-03*G4_1_2_6_2_9_1 + 4.166666666666656e-03*G4_1_2_6_2_9_2 + 8.333333333333311e-03*G4_1_2_6_2_10_0 + 8.333333333333312e-03*G4_1_2_6_2_10_1 + 8.333333333333312e-03*G4_1_2_6_2_10_2 + 4.166666666666655e-03*G4_1_2_6_2_11_0 + 4.166666666666657e-03*G4_1_2_6_2_11_1 + 4.166666666666657e-03*G4_1_2_6_2_11_2 + 4.166666666666655e-03*G4_1_2_7_0_8_0 + 4.166666666666656e-03*G4_1_2_7_0_8_1 + 4.166666666666657e-03*G4_1_2_7_0_8_2 + 4.166666666666655e-03*G4_1_2_7_0_9_0 + 4.166666666666656e-03*G4_1_2_7_0_9_1 + 4.166666666666656e-03*G4_1_2_7_0_9_2 + 4.166666666666655e-03*G4_1_2_7_0_10_0 + 4.166666666666655e-03*G4_1_2_7_0_10_1 + 4.166666666666655e-03*G4_1_2_7_0_10_2 + 8.333333333333309e-03*G4_1_2_7_0_11_0 + 8.333333333333311e-03*G4_1_2_7_0_11_1 + 8.333333333333311e-03*G4_1_2_7_0_11_2 + 4.166666666666656e-03*G4_1_2_7_1_8_0 + 4.166666666666657e-03*G4_1_2_7_1_8_1 + 4.166666666666657e-03*G4_1_2_7_1_8_2 + 4.166666666666656e-03*G4_1_2_7_1_9_0 + 4.166666666666657e-03*G4_1_2_7_1_9_1 + 4.166666666666657e-03*G4_1_2_7_1_9_2 + 4.166666666666655e-03*G4_1_2_7_1_10_0 + 4.166666666666656e-03*G4_1_2_7_1_10_1 + 4.166666666666657e-03*G4_1_2_7_1_10_2 + 8.333333333333311e-03*G4_1_2_7_1_11_0 + 8.333333333333311e-03*G4_1_2_7_1_11_1 + 8.333333333333312e-03*G4_1_2_7_1_11_2 + 4.166666666666657e-03*G4_1_2_7_2_8_0 + 4.166666666666657e-03*G4_1_2_7_2_8_1 + 4.166666666666658e-03*G4_1_2_7_2_8_2 + 4.166666666666656e-03*G4_1_2_7_2_9_0 + 4.166666666666657e-03*G4_1_2_7_2_9_1 + 4.166666666666657e-03*G4_1_2_7_2_9_2 + 4.166666666666655e-03*G4_1_2_7_2_10_0 + 4.166666666666657e-03*G4_1_2_7_2_10_1 + 4.166666666666657e-03*G4_1_2_7_2_10_2 + 8.333333333333311e-03*G4_1_2_7_2_11_0 + 8.333333333333312e-03*G4_1_2_7_2_11_1 + 8.333333333333312e-03*G4_1_2_7_2_11_2 + 8.333333333333309e-03*G4_2_0_8_0_0_0 + 8.333333333333309e-03*G4_2_0_8_0_0_1 + 8.333333333333311e-03*G4_2_0_8_0_0_2 + 4.166666666666654e-03*G4_2_0_8_0_1_0 + 4.166666666666654e-03*G4_2_0_8_0_1_1 + 4.166666666666654e-03*G4_2_0_8_0_1_2 + 4.166666666666653e-03*G4_2_0_8_0_2_0 + 4.166666666666654e-03*G4_2_0_8_0_2_1 + 4.166666666666654e-03*G4_2_0_8_0_2_2 + 4.166666666666654e-03*G4_2_0_8_0_3_0 + 4.166666666666656e-03*G4_2_0_8_0_3_1 + 4.166666666666657e-03*G4_2_0_8_0_3_2 + 8.333333333333309e-03*G4_2_0_8_1_0_0 + 8.333333333333311e-03*G4_2_0_8_1_0_1 + 8.333333333333312e-03*G4_2_0_8_1_0_2 + 4.166666666666654e-03*G4_2_0_8_1_1_0 + 4.166666666666654e-03*G4_2_0_8_1_1_1 + 4.166666666666654e-03*G4_2_0_8_1_1_2 + 4.166666666666654e-03*G4_2_0_8_1_2_0 + 4.166666666666654e-03*G4_2_0_8_1_2_1 + 4.166666666666654e-03*G4_2_0_8_1_2_2 + 4.166666666666656e-03*G4_2_0_8_1_3_0 + 4.166666666666657e-03*G4_2_0_8_1_3_1 + 4.166666666666657e-03*G4_2_0_8_1_3_2 + 8.333333333333311e-03*G4_2_0_8_2_0_0 + 8.333333333333312e-03*G4_2_0_8_2_0_1 + 8.333333333333314e-03*G4_2_0_8_2_0_2 + 4.166666666666654e-03*G4_2_0_8_2_1_0 + 4.166666666666654e-03*G4_2_0_8_2_1_1 + 4.166666666666655e-03*G4_2_0_8_2_1_2 + 4.166666666666654e-03*G4_2_0_8_2_2_0 + 4.166666666666654e-03*G4_2_0_8_2_2_1 + 4.166666666666654e-03*G4_2_0_8_2_2_2 + 4.166666666666657e-03*G4_2_0_8_2_3_0 + 4.166666666666657e-03*G4_2_0_8_2_3_1 + 4.166666666666658e-03*G4_2_0_8_2_3_2 + 4.166666666666654e-03*G4_2_0_9_0_0_0 + 4.166666666666655e-03*G4_2_0_9_0_0_1 + 4.166666666666655e-03*G4_2_0_9_0_0_2 + 8.333333333333307e-03*G4_2_0_9_0_1_0 + 8.333333333333309e-03*G4_2_0_9_0_1_1 + 8.333333333333309e-03*G4_2_0_9_0_1_2 + 4.166666666666654e-03*G4_2_0_9_0_2_0 + 4.166666666666655e-03*G4_2_0_9_0_2_1 + 4.166666666666655e-03*G4_2_0_9_0_2_2 + 4.166666666666655e-03*G4_2_0_9_0_3_0 + 4.166666666666656e-03*G4_2_0_9_0_3_1 + 4.166666666666656e-03*G4_2_0_9_0_3_2 + 4.166666666666655e-03*G4_2_0_9_1_0_0 + 4.166666666666655e-03*G4_2_0_9_1_0_1 + 4.166666666666656e-03*G4_2_0_9_1_0_2 + 8.333333333333309e-03*G4_2_0_9_1_1_0 + 8.333333333333309e-03*G4_2_0_9_1_1_1 + 8.333333333333309e-03*G4_2_0_9_1_1_2 + 4.166666666666655e-03*G4_2_0_9_1_2_0 + 4.166666666666656e-03*G4_2_0_9_1_2_1 + 4.166666666666656e-03*G4_2_0_9_1_2_2 + 4.166666666666656e-03*G4_2_0_9_1_3_0 + 4.166666666666657e-03*G4_2_0_9_1_3_1 + 4.166666666666657e-03*G4_2_0_9_1_3_2 + 4.166666666666655e-03*G4_2_0_9_2_0_0 + 4.166666666666656e-03*G4_2_0_9_2_0_1 + 4.166666666666657e-03*G4_2_0_9_2_0_2 + 8.333333333333309e-03*G4_2_0_9_2_1_0 + 8.333333333333309e-03*G4_2_0_9_2_1_1 + 8.333333333333309e-03*G4_2_0_9_2_1_2 + 4.166666666666655e-03*G4_2_0_9_2_2_0 + 4.166666666666656e-03*G4_2_0_9_2_2_1 + 4.166666666666656e-03*G4_2_0_9_2_2_2 + 4.166666666666656e-03*G4_2_0_9_2_3_0 + 4.166666666666657e-03*G4_2_0_9_2_3_1 + 4.166666666666657e-03*G4_2_0_9_2_3_2 + 4.166666666666654e-03*G4_2_0_10_0_0_0 + 4.166666666666654e-03*G4_2_0_10_0_0_1 + 4.166666666666655e-03*G4_2_0_10_0_0_2 + 4.166666666666654e-03*G4_2_0_10_0_1_0 + 4.166666666666654e-03*G4_2_0_10_0_1_1 + 4.166666666666654e-03*G4_2_0_10_0_1_2 + 8.333333333333309e-03*G4_2_0_10_0_2_0 + 8.333333333333309e-03*G4_2_0_10_0_2_1 + 8.333333333333311e-03*G4_2_0_10_0_2_2 + 4.166666666666654e-03*G4_2_0_10_0_3_0 + 4.166666666666655e-03*G4_2_0_10_0_3_1 + 4.166666666666655e-03*G4_2_0_10_0_3_2 + 4.166666666666654e-03*G4_2_0_10_1_0_0 + 4.166666666666656e-03*G4_2_0_10_1_0_1 + 4.166666666666656e-03*G4_2_0_10_1_0_2 + 4.166666666666654e-03*G4_2_0_10_1_1_0 + 4.166666666666654e-03*G4_2_0_10_1_1_1 + 4.166666666666654e-03*G4_2_0_10_1_1_2 + 8.333333333333311e-03*G4_2_0_10_1_2_0 + 8.333333333333311e-03*G4_2_0_10_1_2_1 + 8.333333333333312e-03*G4_2_0_10_1_2_2 + 4.166666666666655e-03*G4_2_0_10_1_3_0 + 4.166666666666656e-03*G4_2_0_10_1_3_1 + 4.166666666666657e-03*G4_2_0_10_1_3_2 + 4.166666666666655e-03*G4_2_0_10_2_0_0 + 4.166666666666656e-03*G4_2_0_10_2_0_1 + 4.166666666666656e-03*G4_2_0_10_2_0_2 + 4.166666666666654e-03*G4_2_0_10_2_1_0 + 4.166666666666654e-03*G4_2_0_10_2_1_1 + 4.166666666666655e-03*G4_2_0_10_2_1_2 + 8.333333333333311e-03*G4_2_0_10_2_2_0 + 8.333333333333312e-03*G4_2_0_10_2_2_1 + 8.333333333333312e-03*G4_2_0_10_2_2_2 + 4.166666666666655e-03*G4_2_0_10_2_3_0 + 4.166666666666657e-03*G4_2_0_10_2_3_1 + 4.166666666666657e-03*G4_2_0_10_2_3_2 + 4.166666666666656e-03*G4_2_0_11_0_0_0 + 4.166666666666656e-03*G4_2_0_11_0_0_1 + 4.166666666666657e-03*G4_2_0_11_0_0_2 + 4.166666666666654e-03*G4_2_0_11_0_1_0 + 4.166666666666655e-03*G4_2_0_11_0_1_1 + 4.166666666666655e-03*G4_2_0_11_0_1_2 + 4.166666666666655e-03*G4_2_0_11_0_2_0 + 4.166666666666655e-03*G4_2_0_11_0_2_1 + 4.166666666666655e-03*G4_2_0_11_0_2_2 + 8.333333333333309e-03*G4_2_0_11_0_3_0 + 8.333333333333311e-03*G4_2_0_11_0_3_1 + 8.333333333333311e-03*G4_2_0_11_0_3_2 + 4.166666666666656e-03*G4_2_0_11_1_0_0 + 4.166666666666657e-03*G4_2_0_11_1_0_1 + 4.166666666666658e-03*G4_2_0_11_1_0_2 + 4.166666666666655e-03*G4_2_0_11_1_1_0 + 4.166666666666655e-03*G4_2_0_11_1_1_1 + 4.166666666666656e-03*G4_2_0_11_1_1_2 + 4.166666666666655e-03*G4_2_0_11_1_2_0 + 4.166666666666656e-03*G4_2_0_11_1_2_1 + 4.166666666666657e-03*G4_2_0_11_1_2_2 + 8.333333333333311e-03*G4_2_0_11_1_3_0 + 8.333333333333311e-03*G4_2_0_11_1_3_1 + 8.333333333333312e-03*G4_2_0_11_1_3_2 + 4.166666666666657e-03*G4_2_0_11_2_0_0 + 4.166666666666658e-03*G4_2_0_11_2_0_1 + 4.166666666666659e-03*G4_2_0_11_2_0_2 + 4.166666666666655e-03*G4_2_0_11_2_1_0 + 4.166666666666656e-03*G4_2_0_11_2_1_1 + 4.166666666666656e-03*G4_2_0_11_2_1_2 + 4.166666666666655e-03*G4_2_0_11_2_2_0 + 4.166666666666657e-03*G4_2_0_11_2_2_1 + 4.166666666666657e-03*G4_2_0_11_2_2_2 + 8.333333333333311e-03*G4_2_0_11_2_3_0 + 8.333333333333312e-03*G4_2_0_11_2_3_1 + 8.333333333333312e-03*G4_2_0_11_2_3_2 + 8.333333333333309e-03*G4_2_1_8_0_4_0 + 8.333333333333309e-03*G4_2_1_8_0_4_1 + 8.333333333333311e-03*G4_2_1_8_0_4_2 + 4.166666666666654e-03*G4_2_1_8_0_5_0 + 4.166666666666654e-03*G4_2_1_8_0_5_1 + 4.166666666666654e-03*G4_2_1_8_0_5_2 + 4.166666666666653e-03*G4_2_1_8_0_6_0 + 4.166666666666654e-03*G4_2_1_8_0_6_1 + 4.166666666666654e-03*G4_2_1_8_0_6_2 + 4.166666666666654e-03*G4_2_1_8_0_7_0 + 4.166666666666656e-03*G4_2_1_8_0_7_1 + 4.166666666666657e-03*G4_2_1_8_0_7_2 + 8.333333333333309e-03*G4_2_1_8_1_4_0 + 8.333333333333311e-03*G4_2_1_8_1_4_1 + 8.333333333333312e-03*G4_2_1_8_1_4_2 + 4.166666666666654e-03*G4_2_1_8_1_5_0 + 4.166666666666654e-03*G4_2_1_8_1_5_1 + 4.166666666666655e-03*G4_2_1_8_1_5_2 + 4.166666666666654e-03*G4_2_1_8_1_6_0 + 4.166666666666654e-03*G4_2_1_8_1_6_1 + 4.166666666666654e-03*G4_2_1_8_1_6_2 + 4.166666666666656e-03*G4_2_1_8_1_7_0 + 4.166666666666657e-03*G4_2_1_8_1_7_1 + 4.166666666666657e-03*G4_2_1_8_1_7_2 + 8.333333333333311e-03*G4_2_1_8_2_4_0 + 8.333333333333312e-03*G4_2_1_8_2_4_1 + 8.333333333333314e-03*G4_2_1_8_2_4_2 + 4.166666666666654e-03*G4_2_1_8_2_5_0 + 4.166666666666655e-03*G4_2_1_8_2_5_1 + 4.166666666666655e-03*G4_2_1_8_2_5_2 + 4.166666666666654e-03*G4_2_1_8_2_6_0 + 4.166666666666654e-03*G4_2_1_8_2_6_1 + 4.166666666666654e-03*G4_2_1_8_2_6_2 + 4.166666666666657e-03*G4_2_1_8_2_7_0 + 4.166666666666657e-03*G4_2_1_8_2_7_1 + 4.166666666666658e-03*G4_2_1_8_2_7_2 + 4.166666666666654e-03*G4_2_1_9_0_4_0 + 4.166666666666654e-03*G4_2_1_9_0_4_1 + 4.166666666666654e-03*G4_2_1_9_0_4_2 + 8.333333333333307e-03*G4_2_1_9_0_5_0 + 8.333333333333309e-03*G4_2_1_9_0_5_1 + 8.333333333333309e-03*G4_2_1_9_0_5_2 + 4.166666666666654e-03*G4_2_1_9_0_6_0 + 4.166666666666655e-03*G4_2_1_9_0_6_1 + 4.166666666666655e-03*G4_2_1_9_0_6_2 + 4.166666666666655e-03*G4_2_1_9_0_7_0 + 4.166666666666656e-03*G4_2_1_9_0_7_1 + 4.166666666666656e-03*G4_2_1_9_0_7_2 + 4.166666666666654e-03*G4_2_1_9_1_4_0 + 4.166666666666654e-03*G4_2_1_9_1_4_1 + 4.166666666666655e-03*G4_2_1_9_1_4_2 + 8.333333333333309e-03*G4_2_1_9_1_5_0 + 8.333333333333309e-03*G4_2_1_9_1_5_1 + 8.333333333333309e-03*G4_2_1_9_1_5_2 + 4.166666666666655e-03*G4_2_1_9_1_6_0 + 4.166666666666656e-03*G4_2_1_9_1_6_1 + 4.166666666666656e-03*G4_2_1_9_1_6_2 + 4.166666666666656e-03*G4_2_1_9_1_7_0 + 4.166666666666657e-03*G4_2_1_9_1_7_1 + 4.166666666666657e-03*G4_2_1_9_1_7_2 + 4.166666666666654e-03*G4_2_1_9_2_4_0 + 4.166666666666655e-03*G4_2_1_9_2_4_1 + 4.166666666666655e-03*G4_2_1_9_2_4_2 + 8.333333333333309e-03*G4_2_1_9_2_5_0 + 8.333333333333309e-03*G4_2_1_9_2_5_1 + 8.333333333333309e-03*G4_2_1_9_2_5_2 + 4.166666666666655e-03*G4_2_1_9_2_6_0 + 4.166666666666656e-03*G4_2_1_9_2_6_1 + 4.166666666666656e-03*G4_2_1_9_2_6_2 + 4.166666666666656e-03*G4_2_1_9_2_7_0 + 4.166666666666657e-03*G4_2_1_9_2_7_1 + 4.166666666666657e-03*G4_2_1_9_2_7_2 + 4.166666666666653e-03*G4_2_1_10_0_4_0 + 4.166666666666654e-03*G4_2_1_10_0_4_1 + 4.166666666666654e-03*G4_2_1_10_0_4_2 + 4.166666666666654e-03*G4_2_1_10_0_5_0 + 4.166666666666655e-03*G4_2_1_10_0_5_1 + 4.166666666666655e-03*G4_2_1_10_0_5_2 + 8.333333333333309e-03*G4_2_1_10_0_6_0 + 8.333333333333309e-03*G4_2_1_10_0_6_1 + 8.333333333333311e-03*G4_2_1_10_0_6_2 + 4.166666666666654e-03*G4_2_1_10_0_7_0 + 4.166666666666655e-03*G4_2_1_10_0_7_1 + 4.166666666666655e-03*G4_2_1_10_0_7_2 + 4.166666666666654e-03*G4_2_1_10_1_4_0 + 4.166666666666654e-03*G4_2_1_10_1_4_1 + 4.166666666666654e-03*G4_2_1_10_1_4_2 + 4.166666666666655e-03*G4_2_1_10_1_5_0 + 4.166666666666656e-03*G4_2_1_10_1_5_1 + 4.166666666666656e-03*G4_2_1_10_1_5_2 + 8.333333333333311e-03*G4_2_1_10_1_6_0 + 8.333333333333311e-03*G4_2_1_10_1_6_1 + 8.333333333333312e-03*G4_2_1_10_1_6_2 + 4.166666666666655e-03*G4_2_1_10_1_7_0 + 4.166666666666656e-03*G4_2_1_10_1_7_1 + 4.166666666666657e-03*G4_2_1_10_1_7_2 + 4.166666666666654e-03*G4_2_1_10_2_4_0 + 4.166666666666654e-03*G4_2_1_10_2_4_1 + 4.166666666666654e-03*G4_2_1_10_2_4_2 + 4.166666666666655e-03*G4_2_1_10_2_5_0 + 4.166666666666656e-03*G4_2_1_10_2_5_1 + 4.166666666666656e-03*G4_2_1_10_2_5_2 + 8.333333333333311e-03*G4_2_1_10_2_6_0 + 8.333333333333312e-03*G4_2_1_10_2_6_1 + 8.333333333333312e-03*G4_2_1_10_2_6_2 + 4.166666666666655e-03*G4_2_1_10_2_7_0 + 4.166666666666657e-03*G4_2_1_10_2_7_1 + 4.166666666666657e-03*G4_2_1_10_2_7_2 + 4.166666666666655e-03*G4_2_1_11_0_4_0 + 4.166666666666656e-03*G4_2_1_11_0_4_1 + 4.166666666666657e-03*G4_2_1_11_0_4_2 + 4.166666666666655e-03*G4_2_1_11_0_5_0 + 4.166666666666656e-03*G4_2_1_11_0_5_1 + 4.166666666666656e-03*G4_2_1_11_0_5_2 + 4.166666666666655e-03*G4_2_1_11_0_6_0 + 4.166666666666655e-03*G4_2_1_11_0_6_1 + 4.166666666666655e-03*G4_2_1_11_0_6_2 + 8.333333333333309e-03*G4_2_1_11_0_7_0 + 8.333333333333311e-03*G4_2_1_11_0_7_1 + 8.333333333333311e-03*G4_2_1_11_0_7_2 + 4.166666666666656e-03*G4_2_1_11_1_4_0 + 4.166666666666657e-03*G4_2_1_11_1_4_1 + 4.166666666666657e-03*G4_2_1_11_1_4_2 + 4.166666666666656e-03*G4_2_1_11_1_5_0 + 4.166666666666657e-03*G4_2_1_11_1_5_1 + 4.166666666666657e-03*G4_2_1_11_1_5_2 + 4.166666666666655e-03*G4_2_1_11_1_6_0 + 4.166666666666656e-03*G4_2_1_11_1_6_1 + 4.166666666666657e-03*G4_2_1_11_1_6_2 + 8.333333333333311e-03*G4_2_1_11_1_7_0 + 8.333333333333311e-03*G4_2_1_11_1_7_1 + 8.333333333333312e-03*G4_2_1_11_1_7_2 + 4.166666666666657e-03*G4_2_1_11_2_4_0 + 4.166666666666657e-03*G4_2_1_11_2_4_1 + 4.166666666666658e-03*G4_2_1_11_2_4_2 + 4.166666666666656e-03*G4_2_1_11_2_5_0 + 4.166666666666657e-03*G4_2_1_11_2_5_1 + 4.166666666666657e-03*G4_2_1_11_2_5_2 + 4.166666666666655e-03*G4_2_1_11_2_6_0 + 4.166666666666657e-03*G4_2_1_11_2_6_1 + 4.166666666666657e-03*G4_2_1_11_2_6_2 + 8.333333333333311e-03*G4_2_1_11_2_7_0 + 8.333333333333312e-03*G4_2_1_11_2_7_1 + 8.333333333333312e-03*G4_2_1_11_2_7_2 + 8.333333333333309e-03*G4_2_2_8_0_8_0 + 8.333333333333309e-03*G4_2_2_8_0_8_1 + 8.333333333333311e-03*G4_2_2_8_0_8_2 + 4.166666666666654e-03*G4_2_2_8_0_9_0 + 4.166666666666654e-03*G4_2_2_8_0_9_1 + 4.166666666666654e-03*G4_2_2_8_0_9_2 + 4.166666666666653e-03*G4_2_2_8_0_10_0 + 4.166666666666654e-03*G4_2_2_8_0_10_1 + 4.166666666666654e-03*G4_2_2_8_0_10_2 + 4.166666666666654e-03*G4_2_2_8_0_11_0 + 4.166666666666656e-03*G4_2_2_8_0_11_1 + 4.166666666666657e-03*G4_2_2_8_0_11_2 + 8.333333333333309e-03*G4_2_2_8_1_8_0 + 8.333333333333311e-03*G4_2_2_8_1_8_1 + 8.333333333333312e-03*G4_2_2_8_1_8_2 + 4.166666666666654e-03*G4_2_2_8_1_9_0 + 4.166666666666654e-03*G4_2_2_8_1_9_1 + 4.166666666666655e-03*G4_2_2_8_1_9_2 + 4.166666666666654e-03*G4_2_2_8_1_10_0 + 4.166666666666654e-03*G4_2_2_8_1_10_1 + 4.166666666666654e-03*G4_2_2_8_1_10_2 + 4.166666666666656e-03*G4_2_2_8_1_11_0 + 4.166666666666657e-03*G4_2_2_8_1_11_1 + 4.166666666666657e-03*G4_2_2_8_1_11_2 + 8.333333333333311e-03*G4_2_2_8_2_8_0 + 8.333333333333312e-03*G4_2_2_8_2_8_1 + 8.333333333333314e-03*G4_2_2_8_2_8_2 + 4.166666666666654e-03*G4_2_2_8_2_9_0 + 4.166666666666655e-03*G4_2_2_8_2_9_1 + 4.166666666666655e-03*G4_2_2_8_2_9_2 + 4.166666666666654e-03*G4_2_2_8_2_10_0 + 4.166666666666654e-03*G4_2_2_8_2_10_1 + 4.166666666666654e-03*G4_2_2_8_2_10_2 + 4.166666666666657e-03*G4_2_2_8_2_11_0 + 4.166666666666657e-03*G4_2_2_8_2_11_1 + 4.166666666666658e-03*G4_2_2_8_2_11_2 + 4.166666666666654e-03*G4_2_2_9_0_8_0 + 4.166666666666654e-03*G4_2_2_9_0_8_1 + 4.166666666666654e-03*G4_2_2_9_0_8_2 + 8.333333333333307e-03*G4_2_2_9_0_9_0 + 8.333333333333309e-03*G4_2_2_9_0_9_1 + 8.333333333333309e-03*G4_2_2_9_0_9_2 + 4.166666666666654e-03*G4_2_2_9_0_10_0 + 4.166666666666655e-03*G4_2_2_9_0_10_1 + 4.166666666666655e-03*G4_2_2_9_0_10_2 + 4.166666666666655e-03*G4_2_2_9_0_11_0 + 4.166666666666656e-03*G4_2_2_9_0_11_1 + 4.166666666666656e-03*G4_2_2_9_0_11_2 + 4.166666666666654e-03*G4_2_2_9_1_8_0 + 4.166666666666654e-03*G4_2_2_9_1_8_1 + 4.166666666666655e-03*G4_2_2_9_1_8_2 + 8.333333333333309e-03*G4_2_2_9_1_9_0 + 8.333333333333309e-03*G4_2_2_9_1_9_1 + 8.333333333333309e-03*G4_2_2_9_1_9_2 + 4.166666666666655e-03*G4_2_2_9_1_10_0 + 4.166666666666656e-03*G4_2_2_9_1_10_1 + 4.166666666666656e-03*G4_2_2_9_1_10_2 + 4.166666666666656e-03*G4_2_2_9_1_11_0 + 4.166666666666657e-03*G4_2_2_9_1_11_1 + 4.166666666666657e-03*G4_2_2_9_1_11_2 + 4.166666666666654e-03*G4_2_2_9_2_8_0 + 4.166666666666655e-03*G4_2_2_9_2_8_1 + 4.166666666666655e-03*G4_2_2_9_2_8_2 + 8.333333333333309e-03*G4_2_2_9_2_9_0 + 8.333333333333309e-03*G4_2_2_9_2_9_1 + 8.333333333333309e-03*G4_2_2_9_2_9_2 + 4.166666666666655e-03*G4_2_2_9_2_10_0 + 4.166666666666656e-03*G4_2_2_9_2_10_1 + 4.166666666666656e-03*G4_2_2_9_2_10_2 + 4.166666666666656e-03*G4_2_2_9_2_11_0 + 4.166666666666657e-03*G4_2_2_9_2_11_1 + 4.166666666666657e-03*G4_2_2_9_2_11_2 + 4.166666666666653e-03*G4_2_2_10_0_8_0 + 4.166666666666654e-03*G4_2_2_10_0_8_1 + 4.166666666666654e-03*G4_2_2_10_0_8_2 + 4.166666666666654e-03*G4_2_2_10_0_9_0 + 4.166666666666655e-03*G4_2_2_10_0_9_1 + 4.166666666666655e-03*G4_2_2_10_0_9_2 + 8.333333333333309e-03*G4_2_2_10_0_10_0 + 8.333333333333309e-03*G4_2_2_10_0_10_1 + 8.333333333333311e-03*G4_2_2_10_0_10_2 + 4.166666666666654e-03*G4_2_2_10_0_11_0 + 4.166666666666655e-03*G4_2_2_10_0_11_1 + 4.166666666666655e-03*G4_2_2_10_0_11_2 + 4.166666666666654e-03*G4_2_2_10_1_8_0 + 4.166666666666654e-03*G4_2_2_10_1_8_1 + 4.166666666666654e-03*G4_2_2_10_1_8_2 + 4.166666666666655e-03*G4_2_2_10_1_9_0 + 4.166666666666656e-03*G4_2_2_10_1_9_1 + 4.166666666666656e-03*G4_2_2_10_1_9_2 + 8.333333333333311e-03*G4_2_2_10_1_10_0 + 8.333333333333311e-03*G4_2_2_10_1_10_1 + 8.333333333333312e-03*G4_2_2_10_1_10_2 + 4.166666666666655e-03*G4_2_2_10_1_11_0 + 4.166666666666656e-03*G4_2_2_10_1_11_1 + 4.166666666666657e-03*G4_2_2_10_1_11_2 + 4.166666666666654e-03*G4_2_2_10_2_8_0 + 4.166666666666654e-03*G4_2_2_10_2_8_1 + 4.166666666666654e-03*G4_2_2_10_2_8_2 + 4.166666666666655e-03*G4_2_2_10_2_9_0 + 4.166666666666656e-03*G4_2_2_10_2_9_1 + 4.166666666666656e-03*G4_2_2_10_2_9_2 + 8.333333333333311e-03*G4_2_2_10_2_10_0 + 8.333333333333312e-03*G4_2_2_10_2_10_1 + 8.333333333333312e-03*G4_2_2_10_2_10_2 + 4.166666666666655e-03*G4_2_2_10_2_11_0 + 4.166666666666657e-03*G4_2_2_10_2_11_1 + 4.166666666666657e-03*G4_2_2_10_2_11_2 + 4.166666666666655e-03*G4_2_2_11_0_8_0 + 4.166666666666656e-03*G4_2_2_11_0_8_1 + 4.166666666666657e-03*G4_2_2_11_0_8_2 + 4.166666666666655e-03*G4_2_2_11_0_9_0 + 4.166666666666656e-03*G4_2_2_11_0_9_1 + 4.166666666666656e-03*G4_2_2_11_0_9_2 + 4.166666666666655e-03*G4_2_2_11_0_10_0 + 4.166666666666655e-03*G4_2_2_11_0_10_1 + 4.166666666666655e-03*G4_2_2_11_0_10_2 + 8.333333333333309e-03*G4_2_2_11_0_11_0 + 8.333333333333311e-03*G4_2_2_11_0_11_1 + 8.333333333333311e-03*G4_2_2_11_0_11_2 + 4.166666666666656e-03*G4_2_2_11_1_8_0 + 4.166666666666657e-03*G4_2_2_11_1_8_1 + 4.166666666666657e-03*G4_2_2_11_1_8_2 + 4.166666666666656e-03*G4_2_2_11_1_9_0 + 4.166666666666657e-03*G4_2_2_11_1_9_1 + 4.166666666666657e-03*G4_2_2_11_1_9_2 + 4.166666666666655e-03*G4_2_2_11_1_10_0 + 4.166666666666656e-03*G4_2_2_11_1_10_1 + 4.166666666666657e-03*G4_2_2_11_1_10_2 + 8.333333333333311e-03*G4_2_2_11_1_11_0 + 8.333333333333311e-03*G4_2_2_11_1_11_1 + 8.333333333333312e-03*G4_2_2_11_1_11_2 + 4.166666666666657e-03*G4_2_2_11_2_8_0 + 4.166666666666657e-03*G4_2_2_11_2_8_1 + 4.166666666666658e-03*G4_2_2_11_2_8_2 + 4.166666666666656e-03*G4_2_2_11_2_9_0 + 4.166666666666657e-03*G4_2_2_11_2_9_1 + 4.166666666666657e-03*G4_2_2_11_2_9_2 + 4.166666666666655e-03*G4_2_2_11_2_10_0 + 4.166666666666657e-03*G4_2_2_11_2_10_1 + 4.166666666666657e-03*G4_2_2_11_2_10_2 + 8.333333333333311e-03*G4_2_2_11_2_11_0 + 8.333333333333312e-03*G4_2_2_11_2_11_1 + 8.333333333333312e-03*G4_2_2_11_2_11_2;
    block[105] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_1_0 - 8.333333333333322e-02*G1_2_0 + 8.333333333333309e-03*G2_0_0_0 + 4.166666666666654e-03*G2_0_1_0 + 4.166666666666654e-03*G2_0_2_0 + 4.166666666666656e-03*G2_0_3_0 + 8.333333333333309e-03*G2_1_4_0 + 4.166666666666654e-03*G2_1_5_0 + 4.166666666666654e-03*G2_1_6_0 + 4.166666666666656e-03*G2_1_7_0 + 8.333333333333309e-03*G2_2_8_0 + 4.166666666666654e-03*G2_2_9_0 + 4.166666666666654e-03*G2_2_10_0 + 4.166666666666656e-03*G2_2_11_0 - 8.333333333333320e-02*G3_2_2_0_0 - 8.333333333333322e-02*G3_2_2_1_0 - 8.333333333333322e-02*G3_2_2_2_0 - 8.333333333333309e-03*G4_0_0_0_0_0_0 - 4.166666666666654e-03*G4_0_0_0_0_1_0 - 4.166666666666654e-03*G4_0_0_0_0_2_0 - 4.166666666666656e-03*G4_0_0_0_0_3_0 - 8.333333333333309e-03*G4_0_0_0_1_0_0 - 4.166666666666654e-03*G4_0_0_0_1_1_0 - 4.166666666666654e-03*G4_0_0_0_1_2_0 - 4.166666666666656e-03*G4_0_0_0_1_3_0 - 8.333333333333311e-03*G4_0_0_0_2_0_0 - 4.166666666666654e-03*G4_0_0_0_2_1_0 - 4.166666666666655e-03*G4_0_0_0_2_2_0 - 4.166666666666657e-03*G4_0_0_0_2_3_0 - 4.166666666666654e-03*G4_0_0_1_0_0_0 - 8.333333333333307e-03*G4_0_0_1_0_1_0 - 4.166666666666654e-03*G4_0_0_1_0_2_0 - 4.166666666666654e-03*G4_0_0_1_0_3_0 - 4.166666666666654e-03*G4_0_0_1_1_0_0 - 8.333333333333307e-03*G4_0_0_1_1_1_0 - 4.166666666666654e-03*G4_0_0_1_1_2_0 - 4.166666666666655e-03*G4_0_0_1_1_3_0 - 4.166666666666654e-03*G4_0_0_1_2_0_0 - 8.333333333333307e-03*G4_0_0_1_2_1_0 - 4.166666666666654e-03*G4_0_0_1_2_2_0 - 4.166666666666655e-03*G4_0_0_1_2_3_0 - 4.166666666666654e-03*G4_0_0_2_0_0_0 - 4.166666666666654e-03*G4_0_0_2_0_1_0 - 8.333333333333309e-03*G4_0_0_2_0_2_0 - 4.166666666666654e-03*G4_0_0_2_0_3_0 - 4.166666666666654e-03*G4_0_0_2_1_0_0 - 4.166666666666654e-03*G4_0_0_2_1_1_0 - 8.333333333333311e-03*G4_0_0_2_1_2_0 - 4.166666666666655e-03*G4_0_0_2_1_3_0 - 4.166666666666655e-03*G4_0_0_2_2_0_0 - 4.166666666666654e-03*G4_0_0_2_2_1_0 - 8.333333333333311e-03*G4_0_0_2_2_2_0 - 4.166666666666655e-03*G4_0_0_2_2_3_0 - 4.166666666666656e-03*G4_0_0_3_0_0_0 - 4.166666666666654e-03*G4_0_0_3_0_1_0 - 4.166666666666655e-03*G4_0_0_3_0_2_0 - 8.333333333333309e-03*G4_0_0_3_0_3_0 - 4.166666666666656e-03*G4_0_0_3_1_0_0 - 4.166666666666655e-03*G4_0_0_3_1_1_0 - 4.166666666666655e-03*G4_0_0_3_1_2_0 - 8.333333333333311e-03*G4_0_0_3_1_3_0 - 4.166666666666657e-03*G4_0_0_3_2_0_0 - 4.166666666666655e-03*G4_0_0_3_2_1_0 - 4.166666666666655e-03*G4_0_0_3_2_2_0 - 8.333333333333311e-03*G4_0_0_3_2_3_0 - 8.333333333333309e-03*G4_0_1_0_0_4_0 - 4.166666666666654e-03*G4_0_1_0_0_5_0 - 4.166666666666654e-03*G4_0_1_0_0_6_0 - 4.166666666666656e-03*G4_0_1_0_0_7_0 - 8.333333333333309e-03*G4_0_1_0_1_4_0 - 4.166666666666655e-03*G4_0_1_0_1_5_0 - 4.166666666666654e-03*G4_0_1_0_1_6_0 - 4.166666666666656e-03*G4_0_1_0_1_7_0 - 8.333333333333311e-03*G4_0_1_0_2_4_0 - 4.166666666666655e-03*G4_0_1_0_2_5_0 - 4.166666666666655e-03*G4_0_1_0_2_6_0 - 4.166666666666657e-03*G4_0_1_0_2_7_0 - 4.166666666666654e-03*G4_0_1_1_0_4_0 - 8.333333333333307e-03*G4_0_1_1_0_5_0 - 4.166666666666654e-03*G4_0_1_1_0_6_0 - 4.166666666666654e-03*G4_0_1_1_0_7_0 - 4.166666666666654e-03*G4_0_1_1_1_4_0 - 8.333333333333309e-03*G4_0_1_1_1_5_0 - 4.166666666666654e-03*G4_0_1_1_1_6_0 - 4.166666666666655e-03*G4_0_1_1_1_7_0 - 4.166666666666654e-03*G4_0_1_1_2_4_0 - 8.333333333333309e-03*G4_0_1_1_2_5_0 - 4.166666666666654e-03*G4_0_1_1_2_6_0 - 4.166666666666655e-03*G4_0_1_1_2_7_0 - 4.166666666666653e-03*G4_0_1_2_0_4_0 - 4.166666666666654e-03*G4_0_1_2_0_5_0 - 8.333333333333309e-03*G4_0_1_2_0_6_0 - 4.166666666666654e-03*G4_0_1_2_0_7_0 - 4.166666666666654e-03*G4_0_1_2_1_4_0 - 4.166666666666655e-03*G4_0_1_2_1_5_0 - 8.333333333333311e-03*G4_0_1_2_1_6_0 - 4.166666666666655e-03*G4_0_1_2_1_7_0 - 4.166666666666654e-03*G4_0_1_2_2_4_0 - 4.166666666666655e-03*G4_0_1_2_2_5_0 - 8.333333333333311e-03*G4_0_1_2_2_6_0 - 4.166666666666655e-03*G4_0_1_2_2_7_0 - 4.166666666666655e-03*G4_0_1_3_0_4_0 - 4.166666666666655e-03*G4_0_1_3_0_5_0 - 4.166666666666655e-03*G4_0_1_3_0_6_0 - 8.333333333333309e-03*G4_0_1_3_0_7_0 - 4.166666666666656e-03*G4_0_1_3_1_4_0 - 4.166666666666656e-03*G4_0_1_3_1_5_0 - 4.166666666666655e-03*G4_0_1_3_1_6_0 - 8.333333333333311e-03*G4_0_1_3_1_7_0 - 4.166666666666657e-03*G4_0_1_3_2_4_0 - 4.166666666666656e-03*G4_0_1_3_2_5_0 - 4.166666666666655e-03*G4_0_1_3_2_6_0 - 8.333333333333311e-03*G4_0_1_3_2_7_0 - 8.333333333333309e-03*G4_0_2_0_0_8_0 - 4.166666666666654e-03*G4_0_2_0_0_9_0 - 4.166666666666654e-03*G4_0_2_0_0_10_0 - 4.166666666666656e-03*G4_0_2_0_0_11_0 - 8.333333333333309e-03*G4_0_2_0_1_8_0 - 4.166666666666655e-03*G4_0_2_0_1_9_0 - 4.166666666666654e-03*G4_0_2_0_1_10_0 - 4.166666666666656e-03*G4_0_2_0_1_11_0 - 8.333333333333311e-03*G4_0_2_0_2_8_0 - 4.166666666666655e-03*G4_0_2_0_2_9_0 - 4.166666666666655e-03*G4_0_2_0_2_10_0 - 4.166666666666657e-03*G4_0_2_0_2_11_0 - 4.166666666666654e-03*G4_0_2_1_0_8_0 - 8.333333333333307e-03*G4_0_2_1_0_9_0 - 4.166666666666654e-03*G4_0_2_1_0_10_0 - 4.166666666666654e-03*G4_0_2_1_0_11_0 - 4.166666666666654e-03*G4_0_2_1_1_8_0 - 8.333333333333309e-03*G4_0_2_1_1_9_0 - 4.166666666666654e-03*G4_0_2_1_1_10_0 - 4.166666666666655e-03*G4_0_2_1_1_11_0 - 4.166666666666654e-03*G4_0_2_1_2_8_0 - 8.333333333333309e-03*G4_0_2_1_2_9_0 - 4.166666666666654e-03*G4_0_2_1_2_10_0 - 4.166666666666655e-03*G4_0_2_1_2_11_0 - 4.166666666666653e-03*G4_0_2_2_0_8_0 - 4.166666666666654e-03*G4_0_2_2_0_9_0 - 8.333333333333309e-03*G4_0_2_2_0_10_0 - 4.166666666666654e-03*G4_0_2_2_0_11_0 - 4.166666666666654e-03*G4_0_2_2_1_8_0 - 4.166666666666655e-03*G4_0_2_2_1_9_0 - 8.333333333333311e-03*G4_0_2_2_1_10_0 - 4.166666666666655e-03*G4_0_2_2_1_11_0 - 4.166666666666654e-03*G4_0_2_2_2_8_0 - 4.166666666666655e-03*G4_0_2_2_2_9_0 - 8.333333333333311e-03*G4_0_2_2_2_10_0 - 4.166666666666655e-03*G4_0_2_2_2_11_0 - 4.166666666666655e-03*G4_0_2_3_0_8_0 - 4.166666666666655e-03*G4_0_2_3_0_9_0 - 4.166666666666655e-03*G4_0_2_3_0_10_0 - 8.333333333333309e-03*G4_0_2_3_0_11_0 - 4.166666666666656e-03*G4_0_2_3_1_8_0 - 4.166666666666656e-03*G4_0_2_3_1_9_0 - 4.166666666666655e-03*G4_0_2_3_1_10_0 - 8.333333333333311e-03*G4_0_2_3_1_11_0 - 4.166666666666657e-03*G4_0_2_3_2_8_0 - 4.166666666666656e-03*G4_0_2_3_2_9_0 - 4.166666666666655e-03*G4_0_2_3_2_10_0 - 8.333333333333311e-03*G4_0_2_3_2_11_0 - 8.333333333333309e-03*G4_1_0_4_0_0_0 - 4.166666666666654e-03*G4_1_0_4_0_1_0 - 4.166666666666653e-03*G4_1_0_4_0_2_0 - 4.166666666666654e-03*G4_1_0_4_0_3_0 - 8.333333333333309e-03*G4_1_0_4_1_0_0 - 4.166666666666654e-03*G4_1_0_4_1_1_0 - 4.166666666666654e-03*G4_1_0_4_1_2_0 - 4.166666666666656e-03*G4_1_0_4_1_3_0 - 8.333333333333311e-03*G4_1_0_4_2_0_0 - 4.166666666666654e-03*G4_1_0_4_2_1_0 - 4.166666666666654e-03*G4_1_0_4_2_2_0 - 4.166666666666657e-03*G4_1_0_4_2_3_0 - 4.166666666666654e-03*G4_1_0_5_0_0_0 - 8.333333333333307e-03*G4_1_0_5_0_1_0 - 4.166666666666654e-03*G4_1_0_5_0_2_0 - 4.166666666666655e-03*G4_1_0_5_0_3_0 - 4.166666666666655e-03*G4_1_0_5_1_0_0 - 8.333333333333309e-03*G4_1_0_5_1_1_0 - 4.166666666666655e-03*G4_1_0_5_1_2_0 - 4.166666666666656e-03*G4_1_0_5_1_3_0 - 4.166666666666655e-03*G4_1_0_5_2_0_0 - 8.333333333333309e-03*G4_1_0_5_2_1_0 - 4.166666666666655e-03*G4_1_0_5_2_2_0 - 4.166666666666656e-03*G4_1_0_5_2_3_0 - 4.166666666666654e-03*G4_1_0_6_0_0_0 - 4.166666666666654e-03*G4_1_0_6_0_1_0 - 8.333333333333309e-03*G4_1_0_6_0_2_0 - 4.166666666666654e-03*G4_1_0_6_0_3_0 - 4.166666666666654e-03*G4_1_0_6_1_0_0 - 4.166666666666654e-03*G4_1_0_6_1_1_0 - 8.333333333333311e-03*G4_1_0_6_1_2_0 - 4.166666666666655e-03*G4_1_0_6_1_3_0 - 4.166666666666655e-03*G4_1_0_6_2_0_0 - 4.166666666666654e-03*G4_1_0_6_2_1_0 - 8.333333333333311e-03*G4_1_0_6_2_2_0 - 4.166666666666655e-03*G4_1_0_6_2_3_0 - 4.166666666666656e-03*G4_1_0_7_0_0_0 - 4.166666666666654e-03*G4_1_0_7_0_1_0 - 4.166666666666655e-03*G4_1_0_7_0_2_0 - 8.333333333333309e-03*G4_1_0_7_0_3_0 - 4.166666666666656e-03*G4_1_0_7_1_0_0 - 4.166666666666655e-03*G4_1_0_7_1_1_0 - 4.166666666666655e-03*G4_1_0_7_1_2_0 - 8.333333333333311e-03*G4_1_0_7_1_3_0 - 4.166666666666657e-03*G4_1_0_7_2_0_0 - 4.166666666666655e-03*G4_1_0_7_2_1_0 - 4.166666666666655e-03*G4_1_0_7_2_2_0 - 8.333333333333311e-03*G4_1_0_7_2_3_0 - 8.333333333333309e-03*G4_1_1_4_0_4_0 - 4.166666666666654e-03*G4_1_1_4_0_5_0 - 4.166666666666653e-03*G4_1_1_4_0_6_0 - 4.166666666666654e-03*G4_1_1_4_0_7_0 - 8.333333333333309e-03*G4_1_1_4_1_4_0 - 4.166666666666654e-03*G4_1_1_4_1_5_0 - 4.166666666666654e-03*G4_1_1_4_1_6_0 - 4.166666666666656e-03*G4_1_1_4_1_7_0 - 8.333333333333311e-03*G4_1_1_4_2_4_0 - 4.166666666666654e-03*G4_1_1_4_2_5_0 - 4.166666666666654e-03*G4_1_1_4_2_6_0 - 4.166666666666657e-03*G4_1_1_4_2_7_0 - 4.166666666666654e-03*G4_1_1_5_0_4_0 - 8.333333333333307e-03*G4_1_1_5_0_5_0 - 4.166666666666654e-03*G4_1_1_5_0_6_0 - 4.166666666666655e-03*G4_1_1_5_0_7_0 - 4.166666666666654e-03*G4_1_1_5_1_4_0 - 8.333333333333309e-03*G4_1_1_5_1_5_0 - 4.166666666666655e-03*G4_1_1_5_1_6_0 - 4.166666666666656e-03*G4_1_1_5_1_7_0 - 4.166666666666654e-03*G4_1_1_5_2_4_0 - 8.333333333333309e-03*G4_1_1_5_2_5_0 - 4.166666666666655e-03*G4_1_1_5_2_6_0 - 4.166666666666656e-03*G4_1_1_5_2_7_0 - 4.166666666666653e-03*G4_1_1_6_0_4_0 - 4.166666666666654e-03*G4_1_1_6_0_5_0 - 8.333333333333309e-03*G4_1_1_6_0_6_0 - 4.166666666666654e-03*G4_1_1_6_0_7_0 - 4.166666666666654e-03*G4_1_1_6_1_4_0 - 4.166666666666655e-03*G4_1_1_6_1_5_0 - 8.333333333333311e-03*G4_1_1_6_1_6_0 - 4.166666666666655e-03*G4_1_1_6_1_7_0 - 4.166666666666654e-03*G4_1_1_6_2_4_0 - 4.166666666666655e-03*G4_1_1_6_2_5_0 - 8.333333333333311e-03*G4_1_1_6_2_6_0 - 4.166666666666655e-03*G4_1_1_6_2_7_0 - 4.166666666666655e-03*G4_1_1_7_0_4_0 - 4.166666666666655e-03*G4_1_1_7_0_5_0 - 4.166666666666655e-03*G4_1_1_7_0_6_0 - 8.333333333333309e-03*G4_1_1_7_0_7_0 - 4.166666666666656e-03*G4_1_1_7_1_4_0 - 4.166666666666656e-03*G4_1_1_7_1_5_0 - 4.166666666666655e-03*G4_1_1_7_1_6_0 - 8.333333333333311e-03*G4_1_1_7_1_7_0 - 4.166666666666657e-03*G4_1_1_7_2_4_0 - 4.166666666666656e-03*G4_1_1_7_2_5_0 - 4.166666666666655e-03*G4_1_1_7_2_6_0 - 8.333333333333311e-03*G4_1_1_7_2_7_0 - 8.333333333333309e-03*G4_1_2_4_0_8_0 - 4.166666666666654e-03*G4_1_2_4_0_9_0 - 4.166666666666653e-03*G4_1_2_4_0_10_0 - 4.166666666666654e-03*G4_1_2_4_0_11_0 - 8.333333333333309e-03*G4_1_2_4_1_8_0 - 4.166666666666654e-03*G4_1_2_4_1_9_0 - 4.166666666666654e-03*G4_1_2_4_1_10_0 - 4.166666666666656e-03*G4_1_2_4_1_11_0 - 8.333333333333311e-03*G4_1_2_4_2_8_0 - 4.166666666666654e-03*G4_1_2_4_2_9_0 - 4.166666666666654e-03*G4_1_2_4_2_10_0 - 4.166666666666657e-03*G4_1_2_4_2_11_0 - 4.166666666666654e-03*G4_1_2_5_0_8_0 - 8.333333333333307e-03*G4_1_2_5_0_9_0 - 4.166666666666654e-03*G4_1_2_5_0_10_0 - 4.166666666666655e-03*G4_1_2_5_0_11_0 - 4.166666666666654e-03*G4_1_2_5_1_8_0 - 8.333333333333309e-03*G4_1_2_5_1_9_0 - 4.166666666666655e-03*G4_1_2_5_1_10_0 - 4.166666666666656e-03*G4_1_2_5_1_11_0 - 4.166666666666654e-03*G4_1_2_5_2_8_0 - 8.333333333333309e-03*G4_1_2_5_2_9_0 - 4.166666666666655e-03*G4_1_2_5_2_10_0 - 4.166666666666656e-03*G4_1_2_5_2_11_0 - 4.166666666666653e-03*G4_1_2_6_0_8_0 - 4.166666666666654e-03*G4_1_2_6_0_9_0 - 8.333333333333309e-03*G4_1_2_6_0_10_0 - 4.166666666666654e-03*G4_1_2_6_0_11_0 - 4.166666666666654e-03*G4_1_2_6_1_8_0 - 4.166666666666655e-03*G4_1_2_6_1_9_0 - 8.333333333333311e-03*G4_1_2_6_1_10_0 - 4.166666666666655e-03*G4_1_2_6_1_11_0 - 4.166666666666654e-03*G4_1_2_6_2_8_0 - 4.166666666666655e-03*G4_1_2_6_2_9_0 - 8.333333333333311e-03*G4_1_2_6_2_10_0 - 4.166666666666655e-03*G4_1_2_6_2_11_0 - 4.166666666666655e-03*G4_1_2_7_0_8_0 - 4.166666666666655e-03*G4_1_2_7_0_9_0 - 4.166666666666655e-03*G4_1_2_7_0_10_0 - 8.333333333333309e-03*G4_1_2_7_0_11_0 - 4.166666666666656e-03*G4_1_2_7_1_8_0 - 4.166666666666656e-03*G4_1_2_7_1_9_0 - 4.166666666666655e-03*G4_1_2_7_1_10_0 - 8.333333333333311e-03*G4_1_2_7_1_11_0 - 4.166666666666657e-03*G4_1_2_7_2_8_0 - 4.166666666666656e-03*G4_1_2_7_2_9_0 - 4.166666666666655e-03*G4_1_2_7_2_10_0 - 8.333333333333311e-03*G4_1_2_7_2_11_0 - 8.333333333333309e-03*G4_2_0_8_0_0_0 - 4.166666666666654e-03*G4_2_0_8_0_1_0 - 4.166666666666653e-03*G4_2_0_8_0_2_0 - 4.166666666666654e-03*G4_2_0_8_0_3_0 - 8.333333333333309e-03*G4_2_0_8_1_0_0 - 4.166666666666654e-03*G4_2_0_8_1_1_0 - 4.166666666666654e-03*G4_2_0_8_1_2_0 - 4.166666666666656e-03*G4_2_0_8_1_3_0 - 8.333333333333311e-03*G4_2_0_8_2_0_0 - 4.166666666666654e-03*G4_2_0_8_2_1_0 - 4.166666666666654e-03*G4_2_0_8_2_2_0 - 4.166666666666657e-03*G4_2_0_8_2_3_0 - 4.166666666666654e-03*G4_2_0_9_0_0_0 - 8.333333333333307e-03*G4_2_0_9_0_1_0 - 4.166666666666654e-03*G4_2_0_9_0_2_0 - 4.166666666666655e-03*G4_2_0_9_0_3_0 - 4.166666666666655e-03*G4_2_0_9_1_0_0 - 8.333333333333309e-03*G4_2_0_9_1_1_0 - 4.166666666666655e-03*G4_2_0_9_1_2_0 - 4.166666666666656e-03*G4_2_0_9_1_3_0 - 4.166666666666655e-03*G4_2_0_9_2_0_0 - 8.333333333333309e-03*G4_2_0_9_2_1_0 - 4.166666666666655e-03*G4_2_0_9_2_2_0 - 4.166666666666656e-03*G4_2_0_9_2_3_0 - 4.166666666666654e-03*G4_2_0_10_0_0_0 - 4.166666666666654e-03*G4_2_0_10_0_1_0 - 8.333333333333309e-03*G4_2_0_10_0_2_0 - 4.166666666666654e-03*G4_2_0_10_0_3_0 - 4.166666666666654e-03*G4_2_0_10_1_0_0 - 4.166666666666654e-03*G4_2_0_10_1_1_0 - 8.333333333333311e-03*G4_2_0_10_1_2_0 - 4.166666666666655e-03*G4_2_0_10_1_3_0 - 4.166666666666655e-03*G4_2_0_10_2_0_0 - 4.166666666666654e-03*G4_2_0_10_2_1_0 - 8.333333333333311e-03*G4_2_0_10_2_2_0 - 4.166666666666655e-03*G4_2_0_10_2_3_0 - 4.166666666666656e-03*G4_2_0_11_0_0_0 - 4.166666666666654e-03*G4_2_0_11_0_1_0 - 4.166666666666655e-03*G4_2_0_11_0_2_0 - 8.333333333333309e-03*G4_2_0_11_0_3_0 - 4.166666666666656e-03*G4_2_0_11_1_0_0 - 4.166666666666655e-03*G4_2_0_11_1_1_0 - 4.166666666666655e-03*G4_2_0_11_1_2_0 - 8.333333333333311e-03*G4_2_0_11_1_3_0 - 4.166666666666657e-03*G4_2_0_11_2_0_0 - 4.166666666666655e-03*G4_2_0_11_2_1_0 - 4.166666666666655e-03*G4_2_0_11_2_2_0 - 8.333333333333311e-03*G4_2_0_11_2_3_0 - 8.333333333333309e-03*G4_2_1_8_0_4_0 - 4.166666666666654e-03*G4_2_1_8_0_5_0 - 4.166666666666653e-03*G4_2_1_8_0_6_0 - 4.166666666666654e-03*G4_2_1_8_0_7_0 - 8.333333333333309e-03*G4_2_1_8_1_4_0 - 4.166666666666654e-03*G4_2_1_8_1_5_0 - 4.166666666666654e-03*G4_2_1_8_1_6_0 - 4.166666666666656e-03*G4_2_1_8_1_7_0 - 8.333333333333311e-03*G4_2_1_8_2_4_0 - 4.166666666666654e-03*G4_2_1_8_2_5_0 - 4.166666666666654e-03*G4_2_1_8_2_6_0 - 4.166666666666657e-03*G4_2_1_8_2_7_0 - 4.166666666666654e-03*G4_2_1_9_0_4_0 - 8.333333333333307e-03*G4_2_1_9_0_5_0 - 4.166666666666654e-03*G4_2_1_9_0_6_0 - 4.166666666666655e-03*G4_2_1_9_0_7_0 - 4.166666666666654e-03*G4_2_1_9_1_4_0 - 8.333333333333309e-03*G4_2_1_9_1_5_0 - 4.166666666666655e-03*G4_2_1_9_1_6_0 - 4.166666666666656e-03*G4_2_1_9_1_7_0 - 4.166666666666654e-03*G4_2_1_9_2_4_0 - 8.333333333333309e-03*G4_2_1_9_2_5_0 - 4.166666666666655e-03*G4_2_1_9_2_6_0 - 4.166666666666656e-03*G4_2_1_9_2_7_0 - 4.166666666666653e-03*G4_2_1_10_0_4_0 - 4.166666666666654e-03*G4_2_1_10_0_5_0 - 8.333333333333309e-03*G4_2_1_10_0_6_0 - 4.166666666666654e-03*G4_2_1_10_0_7_0 - 4.166666666666654e-03*G4_2_1_10_1_4_0 - 4.166666666666655e-03*G4_2_1_10_1_5_0 - 8.333333333333311e-03*G4_2_1_10_1_6_0 - 4.166666666666655e-03*G4_2_1_10_1_7_0 - 4.166666666666654e-03*G4_2_1_10_2_4_0 - 4.166666666666655e-03*G4_2_1_10_2_5_0 - 8.333333333333311e-03*G4_2_1_10_2_6_0 - 4.166666666666655e-03*G4_2_1_10_2_7_0 - 4.166666666666655e-03*G4_2_1_11_0_4_0 - 4.166666666666655e-03*G4_2_1_11_0_5_0 - 4.166666666666655e-03*G4_2_1_11_0_6_0 - 8.333333333333309e-03*G4_2_1_11_0_7_0 - 4.166666666666656e-03*G4_2_1_11_1_4_0 - 4.166666666666656e-03*G4_2_1_11_1_5_0 - 4.166666666666655e-03*G4_2_1_11_1_6_0 - 8.333333333333311e-03*G4_2_1_11_1_7_0 - 4.166666666666657e-03*G4_2_1_11_2_4_0 - 4.166666666666656e-03*G4_2_1_11_2_5_0 - 4.166666666666655e-03*G4_2_1_11_2_6_0 - 8.333333333333311e-03*G4_2_1_11_2_7_0 - 8.333333333333309e-03*G4_2_2_8_0_8_0 - 4.166666666666654e-03*G4_2_2_8_0_9_0 - 4.166666666666653e-03*G4_2_2_8_0_10_0 - 4.166666666666654e-03*G4_2_2_8_0_11_0 - 8.333333333333309e-03*G4_2_2_8_1_8_0 - 4.166666666666654e-03*G4_2_2_8_1_9_0 - 4.166666666666654e-03*G4_2_2_8_1_10_0 - 4.166666666666656e-03*G4_2_2_8_1_11_0 - 8.333333333333311e-03*G4_2_2_8_2_8_0 - 4.166666666666654e-03*G4_2_2_8_2_9_0 - 4.166666666666654e-03*G4_2_2_8_2_10_0 - 4.166666666666657e-03*G4_2_2_8_2_11_0 - 4.166666666666654e-03*G4_2_2_9_0_8_0 - 8.333333333333307e-03*G4_2_2_9_0_9_0 - 4.166666666666654e-03*G4_2_2_9_0_10_0 - 4.166666666666655e-03*G4_2_2_9_0_11_0 - 4.166666666666654e-03*G4_2_2_9_1_8_0 - 8.333333333333309e-03*G4_2_2_9_1_9_0 - 4.166666666666655e-03*G4_2_2_9_1_10_0 - 4.166666666666656e-03*G4_2_2_9_1_11_0 - 4.166666666666654e-03*G4_2_2_9_2_8_0 - 8.333333333333309e-03*G4_2_2_9_2_9_0 - 4.166666666666655e-03*G4_2_2_9_2_10_0 - 4.166666666666656e-03*G4_2_2_9_2_11_0 - 4.166666666666653e-03*G4_2_2_10_0_8_0 - 4.166666666666654e-03*G4_2_2_10_0_9_0 - 8.333333333333309e-03*G4_2_2_10_0_10_0 - 4.166666666666654e-03*G4_2_2_10_0_11_0 - 4.166666666666654e-03*G4_2_2_10_1_8_0 - 4.166666666666655e-03*G4_2_2_10_1_9_0 - 8.333333333333311e-03*G4_2_2_10_1_10_0 - 4.166666666666655e-03*G4_2_2_10_1_11_0 - 4.166666666666654e-03*G4_2_2_10_2_8_0 - 4.166666666666655e-03*G4_2_2_10_2_9_0 - 8.333333333333311e-03*G4_2_2_10_2_10_0 - 4.166666666666655e-03*G4_2_2_10_2_11_0 - 4.166666666666655e-03*G4_2_2_11_0_8_0 - 4.166666666666655e-03*G4_2_2_11_0_9_0 - 4.166666666666655e-03*G4_2_2_11_0_10_0 - 8.333333333333309e-03*G4_2_2_11_0_11_0 - 4.166666666666656e-03*G4_2_2_11_1_8_0 - 4.166666666666656e-03*G4_2_2_11_1_9_0 - 4.166666666666655e-03*G4_2_2_11_1_10_0 - 8.333333333333311e-03*G4_2_2_11_1_11_0 - 4.166666666666657e-03*G4_2_2_11_2_8_0 - 4.166666666666656e-03*G4_2_2_11_2_9_0 - 4.166666666666655e-03*G4_2_2_11_2_10_0 - 8.333333333333311e-03*G4_2_2_11_2_11_0;
    block[106] = 8.333333333333309e-03*G0_ - 8.333333333333322e-02*G1_0_1 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_2_1 + 8.333333333333311e-03*G2_0_0_1 + 4.166666666666654e-03*G2_0_1_1 + 4.166666666666654e-03*G2_0_2_1 + 4.166666666666657e-03*G2_0_3_1 + 8.333333333333311e-03*G2_1_4_1 + 4.166666666666654e-03*G2_1_5_1 + 4.166666666666654e-03*G2_1_6_1 + 4.166666666666657e-03*G2_1_7_1 + 8.333333333333311e-03*G2_2_8_1 + 4.166666666666654e-03*G2_2_9_1 + 4.166666666666654e-03*G2_2_10_1 + 4.166666666666657e-03*G2_2_11_1 - 8.333333333333322e-02*G3_2_2_0_1 - 8.333333333333323e-02*G3_2_2_1_1 - 8.333333333333323e-02*G3_2_2_2_1 - 8.333333333333309e-03*G4_0_0_0_0_0_1 - 4.166666666666654e-03*G4_0_0_0_0_1_1 - 4.166666666666654e-03*G4_0_0_0_0_2_1 - 4.166666666666656e-03*G4_0_0_0_0_3_1 - 8.333333333333311e-03*G4_0_0_0_1_0_1 - 4.166666666666655e-03*G4_0_0_0_1_1_1 - 4.166666666666656e-03*G4_0_0_0_1_2_1 - 4.166666666666657e-03*G4_0_0_0_1_3_1 - 8.333333333333312e-03*G4_0_0_0_2_0_1 - 4.166666666666655e-03*G4_0_0_0_2_1_1 - 4.166666666666656e-03*G4_0_0_0_2_2_1 - 4.166666666666658e-03*G4_0_0_0_2_3_1 - 4.166666666666654e-03*G4_0_0_1_0_0_1 - 8.333333333333307e-03*G4_0_0_1_0_1_1 - 4.166666666666654e-03*G4_0_0_1_0_2_1 - 4.166666666666655e-03*G4_0_0_1_0_3_1 - 4.166666666666655e-03*G4_0_0_1_1_0_1 - 8.333333333333309e-03*G4_0_0_1_1_1_1 - 4.166666666666654e-03*G4_0_0_1_1_2_1 - 4.166666666666655e-03*G4_0_0_1_1_3_1 - 4.166666666666655e-03*G4_0_0_1_2_0_1 - 8.333333333333309e-03*G4_0_0_1_2_1_1 - 4.166666666666655e-03*G4_0_0_1_2_2_1 - 4.166666666666656e-03*G4_0_0_1_2_3_1 - 4.166666666666654e-03*G4_0_0_2_0_0_1 - 4.166666666666654e-03*G4_0_0_2_0_1_1 - 8.333333333333309e-03*G4_0_0_2_0_2_1 - 4.166666666666655e-03*G4_0_0_2_0_3_1 - 4.166666666666656e-03*G4_0_0_2_1_0_1 - 4.166666666666654e-03*G4_0_0_2_1_1_1 - 8.333333333333311e-03*G4_0_0_2_1_2_1 - 4.166666666666656e-03*G4_0_0_2_1_3_1 - 4.166666666666656e-03*G4_0_0_2_2_0_1 - 4.166666666666654e-03*G4_0_0_2_2_1_1 - 8.333333333333312e-03*G4_0_0_2_2_2_1 - 4.166666666666657e-03*G4_0_0_2_2_3_1 - 4.166666666666656e-03*G4_0_0_3_0_0_1 - 4.166666666666655e-03*G4_0_0_3_0_1_1 - 4.166666666666655e-03*G4_0_0_3_0_2_1 - 8.333333333333311e-03*G4_0_0_3_0_3_1 - 4.166666666666657e-03*G4_0_0_3_1_0_1 - 4.166666666666655e-03*G4_0_0_3_1_1_1 - 4.166666666666656e-03*G4_0_0_3_1_2_1 - 8.333333333333311e-03*G4_0_0_3_1_3_1 - 4.166666666666658e-03*G4_0_0_3_2_0_1 - 4.166666666666656e-03*G4_0_0_3_2_1_1 - 4.166666666666657e-03*G4_0_0_3_2_2_1 - 8.333333333333312e-03*G4_0_0_3_2_3_1 - 8.333333333333309e-03*G4_0_1_0_0_4_1 - 4.166666666666655e-03*G4_0_1_0_0_5_1 - 4.166666666666654e-03*G4_0_1_0_0_6_1 - 4.166666666666656e-03*G4_0_1_0_0_7_1 - 8.333333333333311e-03*G4_0_1_0_1_4_1 - 4.166666666666655e-03*G4_0_1_0_1_5_1 - 4.166666666666656e-03*G4_0_1_0_1_6_1 - 4.166666666666657e-03*G4_0_1_0_1_7_1 - 8.333333333333312e-03*G4_0_1_0_2_4_1 - 4.166666666666656e-03*G4_0_1_0_2_5_1 - 4.166666666666656e-03*G4_0_1_0_2_6_1 - 4.166666666666658e-03*G4_0_1_0_2_7_1 - 4.166666666666654e-03*G4_0_1_1_0_4_1 - 8.333333333333309e-03*G4_0_1_1_0_5_1 - 4.166666666666654e-03*G4_0_1_1_0_6_1 - 4.166666666666655e-03*G4_0_1_1_0_7_1 - 4.166666666666654e-03*G4_0_1_1_1_4_1 - 8.333333333333309e-03*G4_0_1_1_1_5_1 - 4.166666666666654e-03*G4_0_1_1_1_6_1 - 4.166666666666655e-03*G4_0_1_1_1_7_1 - 4.166666666666654e-03*G4_0_1_1_2_4_1 - 8.333333333333309e-03*G4_0_1_1_2_5_1 - 4.166666666666655e-03*G4_0_1_1_2_6_1 - 4.166666666666656e-03*G4_0_1_1_2_7_1 - 4.166666666666654e-03*G4_0_1_2_0_4_1 - 4.166666666666655e-03*G4_0_1_2_0_5_1 - 8.333333333333309e-03*G4_0_1_2_0_6_1 - 4.166666666666655e-03*G4_0_1_2_0_7_1 - 4.166666666666654e-03*G4_0_1_2_1_4_1 - 4.166666666666656e-03*G4_0_1_2_1_5_1 - 8.333333333333311e-03*G4_0_1_2_1_6_1 - 4.166666666666656e-03*G4_0_1_2_1_7_1 - 4.166666666666654e-03*G4_0_1_2_2_4_1 - 4.166666666666656e-03*G4_0_1_2_2_5_1 - 8.333333333333312e-03*G4_0_1_2_2_6_1 - 4.166666666666657e-03*G4_0_1_2_2_7_1 - 4.166666666666656e-03*G4_0_1_3_0_4_1 - 4.166666666666656e-03*G4_0_1_3_0_5_1 - 4.166666666666655e-03*G4_0_1_3_0_6_1 - 8.333333333333311e-03*G4_0_1_3_0_7_1 - 4.166666666666657e-03*G4_0_1_3_1_4_1 - 4.166666666666657e-03*G4_0_1_3_1_5_1 - 4.166666666666656e-03*G4_0_1_3_1_6_1 - 8.333333333333311e-03*G4_0_1_3_1_7_1 - 4.166666666666657e-03*G4_0_1_3_2_4_1 - 4.166666666666657e-03*G4_0_1_3_2_5_1 - 4.166666666666657e-03*G4_0_1_3_2_6_1 - 8.333333333333312e-03*G4_0_1_3_2_7_1 - 8.333333333333309e-03*G4_0_2_0_0_8_1 - 4.166666666666655e-03*G4_0_2_0_0_9_1 - 4.166666666666654e-03*G4_0_2_0_0_10_1 - 4.166666666666656e-03*G4_0_2_0_0_11_1 - 8.333333333333311e-03*G4_0_2_0_1_8_1 - 4.166666666666655e-03*G4_0_2_0_1_9_1 - 4.166666666666656e-03*G4_0_2_0_1_10_1 - 4.166666666666657e-03*G4_0_2_0_1_11_1 - 8.333333333333312e-03*G4_0_2_0_2_8_1 - 4.166666666666656e-03*G4_0_2_0_2_9_1 - 4.166666666666656e-03*G4_0_2_0_2_10_1 - 4.166666666666658e-03*G4_0_2_0_2_11_1 - 4.166666666666654e-03*G4_0_2_1_0_8_1 - 8.333333333333309e-03*G4_0_2_1_0_9_1 - 4.166666666666654e-03*G4_0_2_1_0_10_1 - 4.166666666666655e-03*G4_0_2_1_0_11_1 - 4.166666666666654e-03*G4_0_2_1_1_8_1 - 8.333333333333309e-03*G4_0_2_1_1_9_1 - 4.166666666666654e-03*G4_0_2_1_1_10_1 - 4.166666666666655e-03*G4_0_2_1_1_11_1 - 4.166666666666654e-03*G4_0_2_1_2_8_1 - 8.333333333333309e-03*G4_0_2_1_2_9_1 - 4.166666666666655e-03*G4_0_2_1_2_10_1 - 4.166666666666656e-03*G4_0_2_1_2_11_1 - 4.166666666666654e-03*G4_0_2_2_0_8_1 - 4.166666666666655e-03*G4_0_2_2_0_9_1 - 8.333333333333309e-03*G4_0_2_2_0_10_1 - 4.166666666666655e-03*G4_0_2_2_0_11_1 - 4.166666666666654e-03*G4_0_2_2_1_8_1 - 4.166666666666656e-03*G4_0_2_2_1_9_1 - 8.333333333333311e-03*G4_0_2_2_1_10_1 - 4.166666666666656e-03*G4_0_2_2_1_11_1 - 4.166666666666654e-03*G4_0_2_2_2_8_1 - 4.166666666666656e-03*G4_0_2_2_2_9_1 - 8.333333333333312e-03*G4_0_2_2_2_10_1 - 4.166666666666657e-03*G4_0_2_2_2_11_1 - 4.166666666666656e-03*G4_0_2_3_0_8_1 - 4.166666666666656e-03*G4_0_2_3_0_9_1 - 4.166666666666655e-03*G4_0_2_3_0_10_1 - 8.333333333333311e-03*G4_0_2_3_0_11_1 - 4.166666666666657e-03*G4_0_2_3_1_8_1 - 4.166666666666657e-03*G4_0_2_3_1_9_1 - 4.166666666666656e-03*G4_0_2_3_1_10_1 - 8.333333333333311e-03*G4_0_2_3_1_11_1 - 4.166666666666657e-03*G4_0_2_3_2_8_1 - 4.166666666666657e-03*G4_0_2_3_2_9_1 - 4.166666666666657e-03*G4_0_2_3_2_10_1 - 8.333333333333312e-03*G4_0_2_3_2_11_1 - 8.333333333333309e-03*G4_1_0_4_0_0_1 - 4.166666666666654e-03*G4_1_0_4_0_1_1 - 4.166666666666654e-03*G4_1_0_4_0_2_1 - 4.166666666666656e-03*G4_1_0_4_0_3_1 - 8.333333333333311e-03*G4_1_0_4_1_0_1 - 4.166666666666654e-03*G4_1_0_4_1_1_1 - 4.166666666666654e-03*G4_1_0_4_1_2_1 - 4.166666666666657e-03*G4_1_0_4_1_3_1 - 8.333333333333312e-03*G4_1_0_4_2_0_1 - 4.166666666666654e-03*G4_1_0_4_2_1_1 - 4.166666666666654e-03*G4_1_0_4_2_2_1 - 4.166666666666657e-03*G4_1_0_4_2_3_1 - 4.166666666666655e-03*G4_1_0_5_0_0_1 - 8.333333333333309e-03*G4_1_0_5_0_1_1 - 4.166666666666655e-03*G4_1_0_5_0_2_1 - 4.166666666666656e-03*G4_1_0_5_0_3_1 - 4.166666666666655e-03*G4_1_0_5_1_0_1 - 8.333333333333309e-03*G4_1_0_5_1_1_1 - 4.166666666666656e-03*G4_1_0_5_1_2_1 - 4.166666666666657e-03*G4_1_0_5_1_3_1 - 4.166666666666656e-03*G4_1_0_5_2_0_1 - 8.333333333333309e-03*G4_1_0_5_2_1_1 - 4.166666666666656e-03*G4_1_0_5_2_2_1 - 4.166666666666657e-03*G4_1_0_5_2_3_1 - 4.166666666666654e-03*G4_1_0_6_0_0_1 - 4.166666666666654e-03*G4_1_0_6_0_1_1 - 8.333333333333309e-03*G4_1_0_6_0_2_1 - 4.166666666666655e-03*G4_1_0_6_0_3_1 - 4.166666666666656e-03*G4_1_0_6_1_0_1 - 4.166666666666654e-03*G4_1_0_6_1_1_1 - 8.333333333333311e-03*G4_1_0_6_1_2_1 - 4.166666666666656e-03*G4_1_0_6_1_3_1 - 4.166666666666656e-03*G4_1_0_6_2_0_1 - 4.166666666666654e-03*G4_1_0_6_2_1_1 - 8.333333333333312e-03*G4_1_0_6_2_2_1 - 4.166666666666657e-03*G4_1_0_6_2_3_1 - 4.166666666666656e-03*G4_1_0_7_0_0_1 - 4.166666666666655e-03*G4_1_0_7_0_1_1 - 4.166666666666655e-03*G4_1_0_7_0_2_1 - 8.333333333333311e-03*G4_1_0_7_0_3_1 - 4.166666666666657e-03*G4_1_0_7_1_0_1 - 4.166666666666655e-03*G4_1_0_7_1_1_1 - 4.166666666666656e-03*G4_1_0_7_1_2_1 - 8.333333333333311e-03*G4_1_0_7_1_3_1 - 4.166666666666658e-03*G4_1_0_7_2_0_1 - 4.166666666666656e-03*G4_1_0_7_2_1_1 - 4.166666666666657e-03*G4_1_0_7_2_2_1 - 8.333333333333312e-03*G4_1_0_7_2_3_1 - 8.333333333333309e-03*G4_1_1_4_0_4_1 - 4.166666666666654e-03*G4_1_1_4_0_5_1 - 4.166666666666654e-03*G4_1_1_4_0_6_1 - 4.166666666666656e-03*G4_1_1_4_0_7_1 - 8.333333333333311e-03*G4_1_1_4_1_4_1 - 4.166666666666654e-03*G4_1_1_4_1_5_1 - 4.166666666666654e-03*G4_1_1_4_1_6_1 - 4.166666666666657e-03*G4_1_1_4_1_7_1 - 8.333333333333312e-03*G4_1_1_4_2_4_1 - 4.166666666666655e-03*G4_1_1_4_2_5_1 - 4.166666666666654e-03*G4_1_1_4_2_6_1 - 4.166666666666657e-03*G4_1_1_4_2_7_1 - 4.166666666666654e-03*G4_1_1_5_0_4_1 - 8.333333333333309e-03*G4_1_1_5_0_5_1 - 4.166666666666655e-03*G4_1_1_5_0_6_1 - 4.166666666666656e-03*G4_1_1_5_0_7_1 - 4.166666666666654e-03*G4_1_1_5_1_4_1 - 8.333333333333309e-03*G4_1_1_5_1_5_1 - 4.166666666666656e-03*G4_1_1_5_1_6_1 - 4.166666666666657e-03*G4_1_1_5_1_7_1 - 4.166666666666655e-03*G4_1_1_5_2_4_1 - 8.333333333333309e-03*G4_1_1_5_2_5_1 - 4.166666666666656e-03*G4_1_1_5_2_6_1 - 4.166666666666657e-03*G4_1_1_5_2_7_1 - 4.166666666666654e-03*G4_1_1_6_0_4_1 - 4.166666666666655e-03*G4_1_1_6_0_5_1 - 8.333333333333309e-03*G4_1_1_6_0_6_1 - 4.166666666666655e-03*G4_1_1_6_0_7_1 - 4.166666666666654e-03*G4_1_1_6_1_4_1 - 4.166666666666656e-03*G4_1_1_6_1_5_1 - 8.333333333333311e-03*G4_1_1_6_1_6_1 - 4.166666666666656e-03*G4_1_1_6_1_7_1 - 4.166666666666654e-03*G4_1_1_6_2_4_1 - 4.166666666666656e-03*G4_1_1_6_2_5_1 - 8.333333333333312e-03*G4_1_1_6_2_6_1 - 4.166666666666657e-03*G4_1_1_6_2_7_1 - 4.166666666666656e-03*G4_1_1_7_0_4_1 - 4.166666666666656e-03*G4_1_1_7_0_5_1 - 4.166666666666655e-03*G4_1_1_7_0_6_1 - 8.333333333333311e-03*G4_1_1_7_0_7_1 - 4.166666666666657e-03*G4_1_1_7_1_4_1 - 4.166666666666657e-03*G4_1_1_7_1_5_1 - 4.166666666666656e-03*G4_1_1_7_1_6_1 - 8.333333333333311e-03*G4_1_1_7_1_7_1 - 4.166666666666657e-03*G4_1_1_7_2_4_1 - 4.166666666666657e-03*G4_1_1_7_2_5_1 - 4.166666666666657e-03*G4_1_1_7_2_6_1 - 8.333333333333312e-03*G4_1_1_7_2_7_1 - 8.333333333333309e-03*G4_1_2_4_0_8_1 - 4.166666666666654e-03*G4_1_2_4_0_9_1 - 4.166666666666654e-03*G4_1_2_4_0_10_1 - 4.166666666666656e-03*G4_1_2_4_0_11_1 - 8.333333333333311e-03*G4_1_2_4_1_8_1 - 4.166666666666654e-03*G4_1_2_4_1_9_1 - 4.166666666666654e-03*G4_1_2_4_1_10_1 - 4.166666666666657e-03*G4_1_2_4_1_11_1 - 8.333333333333312e-03*G4_1_2_4_2_8_1 - 4.166666666666655e-03*G4_1_2_4_2_9_1 - 4.166666666666654e-03*G4_1_2_4_2_10_1 - 4.166666666666657e-03*G4_1_2_4_2_11_1 - 4.166666666666654e-03*G4_1_2_5_0_8_1 - 8.333333333333309e-03*G4_1_2_5_0_9_1 - 4.166666666666655e-03*G4_1_2_5_0_10_1 - 4.166666666666656e-03*G4_1_2_5_0_11_1 - 4.166666666666654e-03*G4_1_2_5_1_8_1 - 8.333333333333309e-03*G4_1_2_5_1_9_1 - 4.166666666666656e-03*G4_1_2_5_1_10_1 - 4.166666666666657e-03*G4_1_2_5_1_11_1 - 4.166666666666655e-03*G4_1_2_5_2_8_1 - 8.333333333333309e-03*G4_1_2_5_2_9_1 - 4.166666666666656e-03*G4_1_2_5_2_10_1 - 4.166666666666657e-03*G4_1_2_5_2_11_1 - 4.166666666666654e-03*G4_1_2_6_0_8_1 - 4.166666666666655e-03*G4_1_2_6_0_9_1 - 8.333333333333309e-03*G4_1_2_6_0_10_1 - 4.166666666666655e-03*G4_1_2_6_0_11_1 - 4.166666666666654e-03*G4_1_2_6_1_8_1 - 4.166666666666656e-03*G4_1_2_6_1_9_1 - 8.333333333333311e-03*G4_1_2_6_1_10_1 - 4.166666666666656e-03*G4_1_2_6_1_11_1 - 4.166666666666654e-03*G4_1_2_6_2_8_1 - 4.166666666666656e-03*G4_1_2_6_2_9_1 - 8.333333333333312e-03*G4_1_2_6_2_10_1 - 4.166666666666657e-03*G4_1_2_6_2_11_1 - 4.166666666666656e-03*G4_1_2_7_0_8_1 - 4.166666666666656e-03*G4_1_2_7_0_9_1 - 4.166666666666655e-03*G4_1_2_7_0_10_1 - 8.333333333333311e-03*G4_1_2_7_0_11_1 - 4.166666666666657e-03*G4_1_2_7_1_8_1 - 4.166666666666657e-03*G4_1_2_7_1_9_1 - 4.166666666666656e-03*G4_1_2_7_1_10_1 - 8.333333333333311e-03*G4_1_2_7_1_11_1 - 4.166666666666657e-03*G4_1_2_7_2_8_1 - 4.166666666666657e-03*G4_1_2_7_2_9_1 - 4.166666666666657e-03*G4_1_2_7_2_10_1 - 8.333333333333312e-03*G4_1_2_7_2_11_1 - 8.333333333333309e-03*G4_2_0_8_0_0_1 - 4.166666666666654e-03*G4_2_0_8_0_1_1 - 4.166666666666654e-03*G4_2_0_8_0_2_1 - 4.166666666666656e-03*G4_2_0_8_0_3_1 - 8.333333333333311e-03*G4_2_0_8_1_0_1 - 4.166666666666654e-03*G4_2_0_8_1_1_1 - 4.166666666666654e-03*G4_2_0_8_1_2_1 - 4.166666666666657e-03*G4_2_0_8_1_3_1 - 8.333333333333312e-03*G4_2_0_8_2_0_1 - 4.166666666666654e-03*G4_2_0_8_2_1_1 - 4.166666666666654e-03*G4_2_0_8_2_2_1 - 4.166666666666657e-03*G4_2_0_8_2_3_1 - 4.166666666666655e-03*G4_2_0_9_0_0_1 - 8.333333333333309e-03*G4_2_0_9_0_1_1 - 4.166666666666655e-03*G4_2_0_9_0_2_1 - 4.166666666666656e-03*G4_2_0_9_0_3_1 - 4.166666666666655e-03*G4_2_0_9_1_0_1 - 8.333333333333309e-03*G4_2_0_9_1_1_1 - 4.166666666666656e-03*G4_2_0_9_1_2_1 - 4.166666666666657e-03*G4_2_0_9_1_3_1 - 4.166666666666656e-03*G4_2_0_9_2_0_1 - 8.333333333333309e-03*G4_2_0_9_2_1_1 - 4.166666666666656e-03*G4_2_0_9_2_2_1 - 4.166666666666657e-03*G4_2_0_9_2_3_1 - 4.166666666666654e-03*G4_2_0_10_0_0_1 - 4.166666666666654e-03*G4_2_0_10_0_1_1 - 8.333333333333309e-03*G4_2_0_10_0_2_1 - 4.166666666666655e-03*G4_2_0_10_0_3_1 - 4.166666666666656e-03*G4_2_0_10_1_0_1 - 4.166666666666654e-03*G4_2_0_10_1_1_1 - 8.333333333333311e-03*G4_2_0_10_1_2_1 - 4.166666666666656e-03*G4_2_0_10_1_3_1 - 4.166666666666656e-03*G4_2_0_10_2_0_1 - 4.166666666666654e-03*G4_2_0_10_2_1_1 - 8.333333333333312e-03*G4_2_0_10_2_2_1 - 4.166666666666657e-03*G4_2_0_10_2_3_1 - 4.166666666666656e-03*G4_2_0_11_0_0_1 - 4.166666666666655e-03*G4_2_0_11_0_1_1 - 4.166666666666655e-03*G4_2_0_11_0_2_1 - 8.333333333333311e-03*G4_2_0_11_0_3_1 - 4.166666666666657e-03*G4_2_0_11_1_0_1 - 4.166666666666655e-03*G4_2_0_11_1_1_1 - 4.166666666666656e-03*G4_2_0_11_1_2_1 - 8.333333333333311e-03*G4_2_0_11_1_3_1 - 4.166666666666658e-03*G4_2_0_11_2_0_1 - 4.166666666666656e-03*G4_2_0_11_2_1_1 - 4.166666666666657e-03*G4_2_0_11_2_2_1 - 8.333333333333312e-03*G4_2_0_11_2_3_1 - 8.333333333333309e-03*G4_2_1_8_0_4_1 - 4.166666666666654e-03*G4_2_1_8_0_5_1 - 4.166666666666654e-03*G4_2_1_8_0_6_1 - 4.166666666666656e-03*G4_2_1_8_0_7_1 - 8.333333333333311e-03*G4_2_1_8_1_4_1 - 4.166666666666654e-03*G4_2_1_8_1_5_1 - 4.166666666666654e-03*G4_2_1_8_1_6_1 - 4.166666666666657e-03*G4_2_1_8_1_7_1 - 8.333333333333312e-03*G4_2_1_8_2_4_1 - 4.166666666666655e-03*G4_2_1_8_2_5_1 - 4.166666666666654e-03*G4_2_1_8_2_6_1 - 4.166666666666657e-03*G4_2_1_8_2_7_1 - 4.166666666666654e-03*G4_2_1_9_0_4_1 - 8.333333333333309e-03*G4_2_1_9_0_5_1 - 4.166666666666655e-03*G4_2_1_9_0_6_1 - 4.166666666666656e-03*G4_2_1_9_0_7_1 - 4.166666666666654e-03*G4_2_1_9_1_4_1 - 8.333333333333309e-03*G4_2_1_9_1_5_1 - 4.166666666666656e-03*G4_2_1_9_1_6_1 - 4.166666666666657e-03*G4_2_1_9_1_7_1 - 4.166666666666655e-03*G4_2_1_9_2_4_1 - 8.333333333333309e-03*G4_2_1_9_2_5_1 - 4.166666666666656e-03*G4_2_1_9_2_6_1 - 4.166666666666657e-03*G4_2_1_9_2_7_1 - 4.166666666666654e-03*G4_2_1_10_0_4_1 - 4.166666666666655e-03*G4_2_1_10_0_5_1 - 8.333333333333309e-03*G4_2_1_10_0_6_1 - 4.166666666666655e-03*G4_2_1_10_0_7_1 - 4.166666666666654e-03*G4_2_1_10_1_4_1 - 4.166666666666656e-03*G4_2_1_10_1_5_1 - 8.333333333333311e-03*G4_2_1_10_1_6_1 - 4.166666666666656e-03*G4_2_1_10_1_7_1 - 4.166666666666654e-03*G4_2_1_10_2_4_1 - 4.166666666666656e-03*G4_2_1_10_2_5_1 - 8.333333333333312e-03*G4_2_1_10_2_6_1 - 4.166666666666657e-03*G4_2_1_10_2_7_1 - 4.166666666666656e-03*G4_2_1_11_0_4_1 - 4.166666666666656e-03*G4_2_1_11_0_5_1 - 4.166666666666655e-03*G4_2_1_11_0_6_1 - 8.333333333333311e-03*G4_2_1_11_0_7_1 - 4.166666666666657e-03*G4_2_1_11_1_4_1 - 4.166666666666657e-03*G4_2_1_11_1_5_1 - 4.166666666666656e-03*G4_2_1_11_1_6_1 - 8.333333333333311e-03*G4_2_1_11_1_7_1 - 4.166666666666657e-03*G4_2_1_11_2_4_1 - 4.166666666666657e-03*G4_2_1_11_2_5_1 - 4.166666666666657e-03*G4_2_1_11_2_6_1 - 8.333333333333312e-03*G4_2_1_11_2_7_1 - 8.333333333333309e-03*G4_2_2_8_0_8_1 - 4.166666666666654e-03*G4_2_2_8_0_9_1 - 4.166666666666654e-03*G4_2_2_8_0_10_1 - 4.166666666666656e-03*G4_2_2_8_0_11_1 - 8.333333333333311e-03*G4_2_2_8_1_8_1 - 4.166666666666654e-03*G4_2_2_8_1_9_1 - 4.166666666666654e-03*G4_2_2_8_1_10_1 - 4.166666666666657e-03*G4_2_2_8_1_11_1 - 8.333333333333312e-03*G4_2_2_8_2_8_1 - 4.166666666666655e-03*G4_2_2_8_2_9_1 - 4.166666666666654e-03*G4_2_2_8_2_10_1 - 4.166666666666657e-03*G4_2_2_8_2_11_1 - 4.166666666666654e-03*G4_2_2_9_0_8_1 - 8.333333333333309e-03*G4_2_2_9_0_9_1 - 4.166666666666655e-03*G4_2_2_9_0_10_1 - 4.166666666666656e-03*G4_2_2_9_0_11_1 - 4.166666666666654e-03*G4_2_2_9_1_8_1 - 8.333333333333309e-03*G4_2_2_9_1_9_1 - 4.166666666666656e-03*G4_2_2_9_1_10_1 - 4.166666666666657e-03*G4_2_2_9_1_11_1 - 4.166666666666655e-03*G4_2_2_9_2_8_1 - 8.333333333333309e-03*G4_2_2_9_2_9_1 - 4.166666666666656e-03*G4_2_2_9_2_10_1 - 4.166666666666657e-03*G4_2_2_9_2_11_1 - 4.166666666666654e-03*G4_2_2_10_0_8_1 - 4.166666666666655e-03*G4_2_2_10_0_9_1 - 8.333333333333309e-03*G4_2_2_10_0_10_1 - 4.166666666666655e-03*G4_2_2_10_0_11_1 - 4.166666666666654e-03*G4_2_2_10_1_8_1 - 4.166666666666656e-03*G4_2_2_10_1_9_1 - 8.333333333333311e-03*G4_2_2_10_1_10_1 - 4.166666666666656e-03*G4_2_2_10_1_11_1 - 4.166666666666654e-03*G4_2_2_10_2_8_1 - 4.166666666666656e-03*G4_2_2_10_2_9_1 - 8.333333333333312e-03*G4_2_2_10_2_10_1 - 4.166666666666657e-03*G4_2_2_10_2_11_1 - 4.166666666666656e-03*G4_2_2_11_0_8_1 - 4.166666666666656e-03*G4_2_2_11_0_9_1 - 4.166666666666655e-03*G4_2_2_11_0_10_1 - 8.333333333333311e-03*G4_2_2_11_0_11_1 - 4.166666666666657e-03*G4_2_2_11_1_8_1 - 4.166666666666657e-03*G4_2_2_11_1_9_1 - 4.166666666666656e-03*G4_2_2_11_1_10_1 - 8.333333333333311e-03*G4_2_2_11_1_11_1 - 4.166666666666657e-03*G4_2_2_11_2_8_1 - 4.166666666666657e-03*G4_2_2_11_2_9_1 - 4.166666666666657e-03*G4_2_2_11_2_10_1 - 8.333333333333312e-03*G4_2_2_11_2_11_1;
    block[107] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_0_2 - 8.333333333333323e-02*G1_1_2 - 8.333333333333323e-02*G1_2_2 + 8.333333333333311e-03*G2_0_0_2 + 4.166666666666654e-03*G2_0_1_2 + 4.166666666666654e-03*G2_0_2_2 + 4.166666666666657e-03*G2_0_3_2 + 8.333333333333311e-03*G2_1_4_2 + 4.166666666666654e-03*G2_1_5_2 + 4.166666666666654e-03*G2_1_6_2 + 4.166666666666657e-03*G2_1_7_2 + 8.333333333333311e-03*G2_2_8_2 + 4.166666666666654e-03*G2_2_9_2 + 4.166666666666654e-03*G2_2_10_2 + 4.166666666666657e-03*G2_2_11_2 - 8.333333333333322e-02*G3_2_2_0_2 - 8.333333333333323e-02*G3_2_2_1_2 - 8.333333333333323e-02*G3_2_2_2_2 - 8.333333333333309e-03*G4_0_0_0_0_0_2 - 4.166666666666654e-03*G4_0_0_0_0_1_2 - 4.166666666666654e-03*G4_0_0_0_0_2_2 - 4.166666666666656e-03*G4_0_0_0_0_3_2 - 8.333333333333311e-03*G4_0_0_0_1_0_2 - 4.166666666666655e-03*G4_0_0_0_1_1_2 - 4.166666666666656e-03*G4_0_0_0_1_2_2 - 4.166666666666657e-03*G4_0_0_0_1_3_2 - 8.333333333333312e-03*G4_0_0_0_2_0_2 - 4.166666666666655e-03*G4_0_0_0_2_1_2 - 4.166666666666656e-03*G4_0_0_0_2_2_2 - 4.166666666666658e-03*G4_0_0_0_2_3_2 - 4.166666666666654e-03*G4_0_0_1_0_0_2 - 8.333333333333307e-03*G4_0_0_1_0_1_2 - 4.166666666666654e-03*G4_0_0_1_0_2_2 - 4.166666666666655e-03*G4_0_0_1_0_3_2 - 4.166666666666655e-03*G4_0_0_1_1_0_2 - 8.333333333333309e-03*G4_0_0_1_1_1_2 - 4.166666666666654e-03*G4_0_0_1_1_2_2 - 4.166666666666655e-03*G4_0_0_1_1_3_2 - 4.166666666666655e-03*G4_0_0_1_2_0_2 - 8.333333333333309e-03*G4_0_0_1_2_1_2 - 4.166666666666655e-03*G4_0_0_1_2_2_2 - 4.166666666666656e-03*G4_0_0_1_2_3_2 - 4.166666666666654e-03*G4_0_0_2_0_0_2 - 4.166666666666654e-03*G4_0_0_2_0_1_2 - 8.333333333333309e-03*G4_0_0_2_0_2_2 - 4.166666666666655e-03*G4_0_0_2_0_3_2 - 4.166666666666656e-03*G4_0_0_2_1_0_2 - 4.166666666666654e-03*G4_0_0_2_1_1_2 - 8.333333333333311e-03*G4_0_0_2_1_2_2 - 4.166666666666656e-03*G4_0_0_2_1_3_2 - 4.166666666666656e-03*G4_0_0_2_2_0_2 - 4.166666666666654e-03*G4_0_0_2_2_1_2 - 8.333333333333312e-03*G4_0_0_2_2_2_2 - 4.166666666666657e-03*G4_0_0_2_2_3_2 - 4.166666666666656e-03*G4_0_0_3_0_0_2 - 4.166666666666655e-03*G4_0_0_3_0_1_2 - 4.166666666666655e-03*G4_0_0_3_0_2_2 - 8.333333333333311e-03*G4_0_0_3_0_3_2 - 4.166666666666657e-03*G4_0_0_3_1_0_2 - 4.166666666666655e-03*G4_0_0_3_1_1_2 - 4.166666666666656e-03*G4_0_0_3_1_2_2 - 8.333333333333311e-03*G4_0_0_3_1_3_2 - 4.166666666666658e-03*G4_0_0_3_2_0_2 - 4.166666666666656e-03*G4_0_0_3_2_1_2 - 4.166666666666657e-03*G4_0_0_3_2_2_2 - 8.333333333333312e-03*G4_0_0_3_2_3_2 - 8.333333333333309e-03*G4_0_1_0_0_4_2 - 4.166666666666655e-03*G4_0_1_0_0_5_2 - 4.166666666666654e-03*G4_0_1_0_0_6_2 - 4.166666666666656e-03*G4_0_1_0_0_7_2 - 8.333333333333311e-03*G4_0_1_0_1_4_2 - 4.166666666666655e-03*G4_0_1_0_1_5_2 - 4.166666666666656e-03*G4_0_1_0_1_6_2 - 4.166666666666657e-03*G4_0_1_0_1_7_2 - 8.333333333333312e-03*G4_0_1_0_2_4_2 - 4.166666666666656e-03*G4_0_1_0_2_5_2 - 4.166666666666656e-03*G4_0_1_0_2_6_2 - 4.166666666666658e-03*G4_0_1_0_2_7_2 - 4.166666666666654e-03*G4_0_1_1_0_4_2 - 8.333333333333309e-03*G4_0_1_1_0_5_2 - 4.166666666666654e-03*G4_0_1_1_0_6_2 - 4.166666666666655e-03*G4_0_1_1_0_7_2 - 4.166666666666654e-03*G4_0_1_1_1_4_2 - 8.333333333333309e-03*G4_0_1_1_1_5_2 - 4.166666666666654e-03*G4_0_1_1_1_6_2 - 4.166666666666655e-03*G4_0_1_1_1_7_2 - 4.166666666666654e-03*G4_0_1_1_2_4_2 - 8.333333333333309e-03*G4_0_1_1_2_5_2 - 4.166666666666655e-03*G4_0_1_1_2_6_2 - 4.166666666666656e-03*G4_0_1_1_2_7_2 - 4.166666666666654e-03*G4_0_1_2_0_4_2 - 4.166666666666655e-03*G4_0_1_2_0_5_2 - 8.333333333333309e-03*G4_0_1_2_0_6_2 - 4.166666666666655e-03*G4_0_1_2_0_7_2 - 4.166666666666654e-03*G4_0_1_2_1_4_2 - 4.166666666666656e-03*G4_0_1_2_1_5_2 - 8.333333333333311e-03*G4_0_1_2_1_6_2 - 4.166666666666656e-03*G4_0_1_2_1_7_2 - 4.166666666666654e-03*G4_0_1_2_2_4_2 - 4.166666666666656e-03*G4_0_1_2_2_5_2 - 8.333333333333312e-03*G4_0_1_2_2_6_2 - 4.166666666666657e-03*G4_0_1_2_2_7_2 - 4.166666666666656e-03*G4_0_1_3_0_4_2 - 4.166666666666656e-03*G4_0_1_3_0_5_2 - 4.166666666666655e-03*G4_0_1_3_0_6_2 - 8.333333333333311e-03*G4_0_1_3_0_7_2 - 4.166666666666657e-03*G4_0_1_3_1_4_2 - 4.166666666666657e-03*G4_0_1_3_1_5_2 - 4.166666666666656e-03*G4_0_1_3_1_6_2 - 8.333333333333311e-03*G4_0_1_3_1_7_2 - 4.166666666666657e-03*G4_0_1_3_2_4_2 - 4.166666666666657e-03*G4_0_1_3_2_5_2 - 4.166666666666657e-03*G4_0_1_3_2_6_2 - 8.333333333333312e-03*G4_0_1_3_2_7_2 - 8.333333333333309e-03*G4_0_2_0_0_8_2 - 4.166666666666655e-03*G4_0_2_0_0_9_2 - 4.166666666666654e-03*G4_0_2_0_0_10_2 - 4.166666666666656e-03*G4_0_2_0_0_11_2 - 8.333333333333311e-03*G4_0_2_0_1_8_2 - 4.166666666666655e-03*G4_0_2_0_1_9_2 - 4.166666666666656e-03*G4_0_2_0_1_10_2 - 4.166666666666657e-03*G4_0_2_0_1_11_2 - 8.333333333333312e-03*G4_0_2_0_2_8_2 - 4.166666666666656e-03*G4_0_2_0_2_9_2 - 4.166666666666656e-03*G4_0_2_0_2_10_2 - 4.166666666666658e-03*G4_0_2_0_2_11_2 - 4.166666666666654e-03*G4_0_2_1_0_8_2 - 8.333333333333309e-03*G4_0_2_1_0_9_2 - 4.166666666666654e-03*G4_0_2_1_0_10_2 - 4.166666666666655e-03*G4_0_2_1_0_11_2 - 4.166666666666654e-03*G4_0_2_1_1_8_2 - 8.333333333333309e-03*G4_0_2_1_1_9_2 - 4.166666666666654e-03*G4_0_2_1_1_10_2 - 4.166666666666655e-03*G4_0_2_1_1_11_2 - 4.166666666666654e-03*G4_0_2_1_2_8_2 - 8.333333333333309e-03*G4_0_2_1_2_9_2 - 4.166666666666655e-03*G4_0_2_1_2_10_2 - 4.166666666666656e-03*G4_0_2_1_2_11_2 - 4.166666666666654e-03*G4_0_2_2_0_8_2 - 4.166666666666655e-03*G4_0_2_2_0_9_2 - 8.333333333333309e-03*G4_0_2_2_0_10_2 - 4.166666666666655e-03*G4_0_2_2_0_11_2 - 4.166666666666654e-03*G4_0_2_2_1_8_2 - 4.166666666666656e-03*G4_0_2_2_1_9_2 - 8.333333333333311e-03*G4_0_2_2_1_10_2 - 4.166666666666656e-03*G4_0_2_2_1_11_2 - 4.166666666666654e-03*G4_0_2_2_2_8_2 - 4.166666666666656e-03*G4_0_2_2_2_9_2 - 8.333333333333312e-03*G4_0_2_2_2_10_2 - 4.166666666666657e-03*G4_0_2_2_2_11_2 - 4.166666666666656e-03*G4_0_2_3_0_8_2 - 4.166666666666656e-03*G4_0_2_3_0_9_2 - 4.166666666666655e-03*G4_0_2_3_0_10_2 - 8.333333333333311e-03*G4_0_2_3_0_11_2 - 4.166666666666657e-03*G4_0_2_3_1_8_2 - 4.166666666666657e-03*G4_0_2_3_1_9_2 - 4.166666666666656e-03*G4_0_2_3_1_10_2 - 8.333333333333311e-03*G4_0_2_3_1_11_2 - 4.166666666666657e-03*G4_0_2_3_2_8_2 - 4.166666666666657e-03*G4_0_2_3_2_9_2 - 4.166666666666657e-03*G4_0_2_3_2_10_2 - 8.333333333333312e-03*G4_0_2_3_2_11_2 - 8.333333333333309e-03*G4_1_0_4_0_0_2 - 4.166666666666654e-03*G4_1_0_4_0_1_2 - 4.166666666666654e-03*G4_1_0_4_0_2_2 - 4.166666666666656e-03*G4_1_0_4_0_3_2 - 8.333333333333311e-03*G4_1_0_4_1_0_2 - 4.166666666666654e-03*G4_1_0_4_1_1_2 - 4.166666666666654e-03*G4_1_0_4_1_2_2 - 4.166666666666657e-03*G4_1_0_4_1_3_2 - 8.333333333333312e-03*G4_1_0_4_2_0_2 - 4.166666666666654e-03*G4_1_0_4_2_1_2 - 4.166666666666654e-03*G4_1_0_4_2_2_2 - 4.166666666666657e-03*G4_1_0_4_2_3_2 - 4.166666666666655e-03*G4_1_0_5_0_0_2 - 8.333333333333309e-03*G4_1_0_5_0_1_2 - 4.166666666666655e-03*G4_1_0_5_0_2_2 - 4.166666666666656e-03*G4_1_0_5_0_3_2 - 4.166666666666655e-03*G4_1_0_5_1_0_2 - 8.333333333333309e-03*G4_1_0_5_1_1_2 - 4.166666666666656e-03*G4_1_0_5_1_2_2 - 4.166666666666657e-03*G4_1_0_5_1_3_2 - 4.166666666666656e-03*G4_1_0_5_2_0_2 - 8.333333333333309e-03*G4_1_0_5_2_1_2 - 4.166666666666656e-03*G4_1_0_5_2_2_2 - 4.166666666666657e-03*G4_1_0_5_2_3_2 - 4.166666666666654e-03*G4_1_0_6_0_0_2 - 4.166666666666654e-03*G4_1_0_6_0_1_2 - 8.333333333333309e-03*G4_1_0_6_0_2_2 - 4.166666666666655e-03*G4_1_0_6_0_3_2 - 4.166666666666656e-03*G4_1_0_6_1_0_2 - 4.166666666666654e-03*G4_1_0_6_1_1_2 - 8.333333333333311e-03*G4_1_0_6_1_2_2 - 4.166666666666656e-03*G4_1_0_6_1_3_2 - 4.166666666666656e-03*G4_1_0_6_2_0_2 - 4.166666666666654e-03*G4_1_0_6_2_1_2 - 8.333333333333312e-03*G4_1_0_6_2_2_2 - 4.166666666666657e-03*G4_1_0_6_2_3_2 - 4.166666666666656e-03*G4_1_0_7_0_0_2 - 4.166666666666655e-03*G4_1_0_7_0_1_2 - 4.166666666666655e-03*G4_1_0_7_0_2_2 - 8.333333333333311e-03*G4_1_0_7_0_3_2 - 4.166666666666657e-03*G4_1_0_7_1_0_2 - 4.166666666666655e-03*G4_1_0_7_1_1_2 - 4.166666666666656e-03*G4_1_0_7_1_2_2 - 8.333333333333311e-03*G4_1_0_7_1_3_2 - 4.166666666666658e-03*G4_1_0_7_2_0_2 - 4.166666666666656e-03*G4_1_0_7_2_1_2 - 4.166666666666657e-03*G4_1_0_7_2_2_2 - 8.333333333333312e-03*G4_1_0_7_2_3_2 - 8.333333333333309e-03*G4_1_1_4_0_4_2 - 4.166666666666654e-03*G4_1_1_4_0_5_2 - 4.166666666666654e-03*G4_1_1_4_0_6_2 - 4.166666666666656e-03*G4_1_1_4_0_7_2 - 8.333333333333311e-03*G4_1_1_4_1_4_2 - 4.166666666666654e-03*G4_1_1_4_1_5_2 - 4.166666666666654e-03*G4_1_1_4_1_6_2 - 4.166666666666657e-03*G4_1_1_4_1_7_2 - 8.333333333333312e-03*G4_1_1_4_2_4_2 - 4.166666666666655e-03*G4_1_1_4_2_5_2 - 4.166666666666654e-03*G4_1_1_4_2_6_2 - 4.166666666666657e-03*G4_1_1_4_2_7_2 - 4.166666666666654e-03*G4_1_1_5_0_4_2 - 8.333333333333309e-03*G4_1_1_5_0_5_2 - 4.166666666666655e-03*G4_1_1_5_0_6_2 - 4.166666666666656e-03*G4_1_1_5_0_7_2 - 4.166666666666654e-03*G4_1_1_5_1_4_2 - 8.333333333333309e-03*G4_1_1_5_1_5_2 - 4.166666666666656e-03*G4_1_1_5_1_6_2 - 4.166666666666657e-03*G4_1_1_5_1_7_2 - 4.166666666666655e-03*G4_1_1_5_2_4_2 - 8.333333333333309e-03*G4_1_1_5_2_5_2 - 4.166666666666656e-03*G4_1_1_5_2_6_2 - 4.166666666666657e-03*G4_1_1_5_2_7_2 - 4.166666666666654e-03*G4_1_1_6_0_4_2 - 4.166666666666655e-03*G4_1_1_6_0_5_2 - 8.333333333333309e-03*G4_1_1_6_0_6_2 - 4.166666666666655e-03*G4_1_1_6_0_7_2 - 4.166666666666654e-03*G4_1_1_6_1_4_2 - 4.166666666666656e-03*G4_1_1_6_1_5_2 - 8.333333333333311e-03*G4_1_1_6_1_6_2 - 4.166666666666656e-03*G4_1_1_6_1_7_2 - 4.166666666666654e-03*G4_1_1_6_2_4_2 - 4.166666666666656e-03*G4_1_1_6_2_5_2 - 8.333333333333312e-03*G4_1_1_6_2_6_2 - 4.166666666666657e-03*G4_1_1_6_2_7_2 - 4.166666666666656e-03*G4_1_1_7_0_4_2 - 4.166666666666656e-03*G4_1_1_7_0_5_2 - 4.166666666666655e-03*G4_1_1_7_0_6_2 - 8.333333333333311e-03*G4_1_1_7_0_7_2 - 4.166666666666657e-03*G4_1_1_7_1_4_2 - 4.166666666666657e-03*G4_1_1_7_1_5_2 - 4.166666666666656e-03*G4_1_1_7_1_6_2 - 8.333333333333311e-03*G4_1_1_7_1_7_2 - 4.166666666666657e-03*G4_1_1_7_2_4_2 - 4.166666666666657e-03*G4_1_1_7_2_5_2 - 4.166666666666657e-03*G4_1_1_7_2_6_2 - 8.333333333333312e-03*G4_1_1_7_2_7_2 - 8.333333333333309e-03*G4_1_2_4_0_8_2 - 4.166666666666654e-03*G4_1_2_4_0_9_2 - 4.166666666666654e-03*G4_1_2_4_0_10_2 - 4.166666666666656e-03*G4_1_2_4_0_11_2 - 8.333333333333311e-03*G4_1_2_4_1_8_2 - 4.166666666666654e-03*G4_1_2_4_1_9_2 - 4.166666666666654e-03*G4_1_2_4_1_10_2 - 4.166666666666657e-03*G4_1_2_4_1_11_2 - 8.333333333333312e-03*G4_1_2_4_2_8_2 - 4.166666666666655e-03*G4_1_2_4_2_9_2 - 4.166666666666654e-03*G4_1_2_4_2_10_2 - 4.166666666666657e-03*G4_1_2_4_2_11_2 - 4.166666666666654e-03*G4_1_2_5_0_8_2 - 8.333333333333309e-03*G4_1_2_5_0_9_2 - 4.166666666666655e-03*G4_1_2_5_0_10_2 - 4.166666666666656e-03*G4_1_2_5_0_11_2 - 4.166666666666654e-03*G4_1_2_5_1_8_2 - 8.333333333333309e-03*G4_1_2_5_1_9_2 - 4.166666666666656e-03*G4_1_2_5_1_10_2 - 4.166666666666657e-03*G4_1_2_5_1_11_2 - 4.166666666666655e-03*G4_1_2_5_2_8_2 - 8.333333333333309e-03*G4_1_2_5_2_9_2 - 4.166666666666656e-03*G4_1_2_5_2_10_2 - 4.166666666666657e-03*G4_1_2_5_2_11_2 - 4.166666666666654e-03*G4_1_2_6_0_8_2 - 4.166666666666655e-03*G4_1_2_6_0_9_2 - 8.333333333333309e-03*G4_1_2_6_0_10_2 - 4.166666666666655e-03*G4_1_2_6_0_11_2 - 4.166666666666654e-03*G4_1_2_6_1_8_2 - 4.166666666666656e-03*G4_1_2_6_1_9_2 - 8.333333333333311e-03*G4_1_2_6_1_10_2 - 4.166666666666656e-03*G4_1_2_6_1_11_2 - 4.166666666666654e-03*G4_1_2_6_2_8_2 - 4.166666666666656e-03*G4_1_2_6_2_9_2 - 8.333333333333312e-03*G4_1_2_6_2_10_2 - 4.166666666666657e-03*G4_1_2_6_2_11_2 - 4.166666666666656e-03*G4_1_2_7_0_8_2 - 4.166666666666656e-03*G4_1_2_7_0_9_2 - 4.166666666666655e-03*G4_1_2_7_0_10_2 - 8.333333333333311e-03*G4_1_2_7_0_11_2 - 4.166666666666657e-03*G4_1_2_7_1_8_2 - 4.166666666666657e-03*G4_1_2_7_1_9_2 - 4.166666666666656e-03*G4_1_2_7_1_10_2 - 8.333333333333311e-03*G4_1_2_7_1_11_2 - 4.166666666666657e-03*G4_1_2_7_2_8_2 - 4.166666666666657e-03*G4_1_2_7_2_9_2 - 4.166666666666657e-03*G4_1_2_7_2_10_2 - 8.333333333333312e-03*G4_1_2_7_2_11_2 - 8.333333333333309e-03*G4_2_0_8_0_0_2 - 4.166666666666654e-03*G4_2_0_8_0_1_2 - 4.166666666666654e-03*G4_2_0_8_0_2_2 - 4.166666666666656e-03*G4_2_0_8_0_3_2 - 8.333333333333311e-03*G4_2_0_8_1_0_2 - 4.166666666666654e-03*G4_2_0_8_1_1_2 - 4.166666666666654e-03*G4_2_0_8_1_2_2 - 4.166666666666657e-03*G4_2_0_8_1_3_2 - 8.333333333333312e-03*G4_2_0_8_2_0_2 - 4.166666666666654e-03*G4_2_0_8_2_1_2 - 4.166666666666654e-03*G4_2_0_8_2_2_2 - 4.166666666666657e-03*G4_2_0_8_2_3_2 - 4.166666666666655e-03*G4_2_0_9_0_0_2 - 8.333333333333309e-03*G4_2_0_9_0_1_2 - 4.166666666666655e-03*G4_2_0_9_0_2_2 - 4.166666666666656e-03*G4_2_0_9_0_3_2 - 4.166666666666655e-03*G4_2_0_9_1_0_2 - 8.333333333333309e-03*G4_2_0_9_1_1_2 - 4.166666666666656e-03*G4_2_0_9_1_2_2 - 4.166666666666657e-03*G4_2_0_9_1_3_2 - 4.166666666666656e-03*G4_2_0_9_2_0_2 - 8.333333333333309e-03*G4_2_0_9_2_1_2 - 4.166666666666656e-03*G4_2_0_9_2_2_2 - 4.166666666666657e-03*G4_2_0_9_2_3_2 - 4.166666666666654e-03*G4_2_0_10_0_0_2 - 4.166666666666654e-03*G4_2_0_10_0_1_2 - 8.333333333333309e-03*G4_2_0_10_0_2_2 - 4.166666666666655e-03*G4_2_0_10_0_3_2 - 4.166666666666656e-03*G4_2_0_10_1_0_2 - 4.166666666666654e-03*G4_2_0_10_1_1_2 - 8.333333333333311e-03*G4_2_0_10_1_2_2 - 4.166666666666656e-03*G4_2_0_10_1_3_2 - 4.166666666666656e-03*G4_2_0_10_2_0_2 - 4.166666666666654e-03*G4_2_0_10_2_1_2 - 8.333333333333312e-03*G4_2_0_10_2_2_2 - 4.166666666666657e-03*G4_2_0_10_2_3_2 - 4.166666666666656e-03*G4_2_0_11_0_0_2 - 4.166666666666655e-03*G4_2_0_11_0_1_2 - 4.166666666666655e-03*G4_2_0_11_0_2_2 - 8.333333333333311e-03*G4_2_0_11_0_3_2 - 4.166666666666657e-03*G4_2_0_11_1_0_2 - 4.166666666666655e-03*G4_2_0_11_1_1_2 - 4.166666666666656e-03*G4_2_0_11_1_2_2 - 8.333333333333311e-03*G4_2_0_11_1_3_2 - 4.166666666666658e-03*G4_2_0_11_2_0_2 - 4.166666666666656e-03*G4_2_0_11_2_1_2 - 4.166666666666657e-03*G4_2_0_11_2_2_2 - 8.333333333333312e-03*G4_2_0_11_2_3_2 - 8.333333333333309e-03*G4_2_1_8_0_4_2 - 4.166666666666654e-03*G4_2_1_8_0_5_2 - 4.166666666666654e-03*G4_2_1_8_0_6_2 - 4.166666666666656e-03*G4_2_1_8_0_7_2 - 8.333333333333311e-03*G4_2_1_8_1_4_2 - 4.166666666666654e-03*G4_2_1_8_1_5_2 - 4.166666666666654e-03*G4_2_1_8_1_6_2 - 4.166666666666657e-03*G4_2_1_8_1_7_2 - 8.333333333333312e-03*G4_2_1_8_2_4_2 - 4.166666666666655e-03*G4_2_1_8_2_5_2 - 4.166666666666654e-03*G4_2_1_8_2_6_2 - 4.166666666666657e-03*G4_2_1_8_2_7_2 - 4.166666666666654e-03*G4_2_1_9_0_4_2 - 8.333333333333309e-03*G4_2_1_9_0_5_2 - 4.166666666666655e-03*G4_2_1_9_0_6_2 - 4.166666666666656e-03*G4_2_1_9_0_7_2 - 4.166666666666654e-03*G4_2_1_9_1_4_2 - 8.333333333333309e-03*G4_2_1_9_1_5_2 - 4.166666666666656e-03*G4_2_1_9_1_6_2 - 4.166666666666657e-03*G4_2_1_9_1_7_2 - 4.166666666666655e-03*G4_2_1_9_2_4_2 - 8.333333333333309e-03*G4_2_1_9_2_5_2 - 4.166666666666656e-03*G4_2_1_9_2_6_2 - 4.166666666666657e-03*G4_2_1_9_2_7_2 - 4.166666666666654e-03*G4_2_1_10_0_4_2 - 4.166666666666655e-03*G4_2_1_10_0_5_2 - 8.333333333333309e-03*G4_2_1_10_0_6_2 - 4.166666666666655e-03*G4_2_1_10_0_7_2 - 4.166666666666654e-03*G4_2_1_10_1_4_2 - 4.166666666666656e-03*G4_2_1_10_1_5_2 - 8.333333333333311e-03*G4_2_1_10_1_6_2 - 4.166666666666656e-03*G4_2_1_10_1_7_2 - 4.166666666666654e-03*G4_2_1_10_2_4_2 - 4.166666666666656e-03*G4_2_1_10_2_5_2 - 8.333333333333312e-03*G4_2_1_10_2_6_2 - 4.166666666666657e-03*G4_2_1_10_2_7_2 - 4.166666666666656e-03*G4_2_1_11_0_4_2 - 4.166666666666656e-03*G4_2_1_11_0_5_2 - 4.166666666666655e-03*G4_2_1_11_0_6_2 - 8.333333333333311e-03*G4_2_1_11_0_7_2 - 4.166666666666657e-03*G4_2_1_11_1_4_2 - 4.166666666666657e-03*G4_2_1_11_1_5_2 - 4.166666666666656e-03*G4_2_1_11_1_6_2 - 8.333333333333311e-03*G4_2_1_11_1_7_2 - 4.166666666666657e-03*G4_2_1_11_2_4_2 - 4.166666666666657e-03*G4_2_1_11_2_5_2 - 4.166666666666657e-03*G4_2_1_11_2_6_2 - 8.333333333333312e-03*G4_2_1_11_2_7_2 - 8.333333333333309e-03*G4_2_2_8_0_8_2 - 4.166666666666654e-03*G4_2_2_8_0_9_2 - 4.166666666666654e-03*G4_2_2_8_0_10_2 - 4.166666666666656e-03*G4_2_2_8_0_11_2 - 8.333333333333311e-03*G4_2_2_8_1_8_2 - 4.166666666666654e-03*G4_2_2_8_1_9_2 - 4.166666666666654e-03*G4_2_2_8_1_10_2 - 4.166666666666657e-03*G4_2_2_8_1_11_2 - 8.333333333333312e-03*G4_2_2_8_2_8_2 - 4.166666666666655e-03*G4_2_2_8_2_9_2 - 4.166666666666654e-03*G4_2_2_8_2_10_2 - 4.166666666666657e-03*G4_2_2_8_2_11_2 - 4.166666666666654e-03*G4_2_2_9_0_8_2 - 8.333333333333309e-03*G4_2_2_9_0_9_2 - 4.166666666666655e-03*G4_2_2_9_0_10_2 - 4.166666666666656e-03*G4_2_2_9_0_11_2 - 4.166666666666654e-03*G4_2_2_9_1_8_2 - 8.333333333333309e-03*G4_2_2_9_1_9_2 - 4.166666666666656e-03*G4_2_2_9_1_10_2 - 4.166666666666657e-03*G4_2_2_9_1_11_2 - 4.166666666666655e-03*G4_2_2_9_2_8_2 - 8.333333333333309e-03*G4_2_2_9_2_9_2 - 4.166666666666656e-03*G4_2_2_9_2_10_2 - 4.166666666666657e-03*G4_2_2_9_2_11_2 - 4.166666666666654e-03*G4_2_2_10_0_8_2 - 4.166666666666655e-03*G4_2_2_10_0_9_2 - 8.333333333333309e-03*G4_2_2_10_0_10_2 - 4.166666666666655e-03*G4_2_2_10_0_11_2 - 4.166666666666654e-03*G4_2_2_10_1_8_2 - 4.166666666666656e-03*G4_2_2_10_1_9_2 - 8.333333333333311e-03*G4_2_2_10_1_10_2 - 4.166666666666656e-03*G4_2_2_10_1_11_2 - 4.166666666666654e-03*G4_2_2_10_2_8_2 - 4.166666666666656e-03*G4_2_2_10_2_9_2 - 8.333333333333312e-03*G4_2_2_10_2_10_2 - 4.166666666666657e-03*G4_2_2_10_2_11_2 - 4.166666666666656e-03*G4_2_2_11_0_8_2 - 4.166666666666656e-03*G4_2_2_11_0_9_2 - 4.166666666666655e-03*G4_2_2_11_0_10_2 - 8.333333333333311e-03*G4_2_2_11_0_11_2 - 4.166666666666657e-03*G4_2_2_11_1_8_2 - 4.166666666666657e-03*G4_2_2_11_1_9_2 - 4.166666666666656e-03*G4_2_2_11_1_10_2 - 8.333333333333311e-03*G4_2_2_11_1_11_2 - 4.166666666666657e-03*G4_2_2_11_2_8_2 - 4.166666666666657e-03*G4_2_2_11_2_9_2 - 4.166666666666657e-03*G4_2_2_11_2_10_2 - 8.333333333333312e-03*G4_2_2_11_2_11_2;
    block[108] = -8.333333333333320e-02*G3_2_0_0_0 - 8.333333333333322e-02*G3_2_0_0_1 - 8.333333333333320e-02*G3_2_0_0_2;
    block[109] = 8.333333333333320e-02*G3_2_0_0_0;
    block[110] = 8.333333333333322e-02*G3_2_0_0_1;
    block[111] = 8.333333333333322e-02*G3_2_0_0_2;
    block[112] = -8.333333333333320e-02*G3_2_1_0_0 - 8.333333333333322e-02*G3_2_1_0_1 - 8.333333333333322e-02*G3_2_1_0_2;
    block[113] = 8.333333333333320e-02*G3_2_1_0_0;
    block[114] = 8.333333333333322e-02*G3_2_1_0_1;
    block[115] = 8.333333333333322e-02*G3_2_1_0_2;
    block[116] = 8.333333333333309e-03*G0_ - 8.333333333333320e-02*G1_0_0 - 8.333333333333322e-02*G1_0_1 - 8.333333333333322e-02*G1_0_2 - 4.166666666666655e-03*G2_0_0_0 - 4.166666666666655e-03*G2_0_0_1 - 4.166666666666656e-03*G2_0_0_2 - 8.333333333333309e-03*G2_0_1_0 - 8.333333333333309e-03*G2_0_1_1 - 8.333333333333309e-03*G2_0_1_2 - 4.166666666666655e-03*G2_0_2_0 - 4.166666666666656e-03*G2_0_2_1 - 4.166666666666656e-03*G2_0_2_2 - 4.166666666666656e-03*G2_0_3_0 - 4.166666666666657e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 4.166666666666654e-03*G2_1_4_0 - 4.166666666666654e-03*G2_1_4_1 - 4.166666666666655e-03*G2_1_4_2 - 8.333333333333309e-03*G2_1_5_0 - 8.333333333333309e-03*G2_1_5_1 - 8.333333333333309e-03*G2_1_5_2 - 4.166666666666655e-03*G2_1_6_0 - 4.166666666666656e-03*G2_1_6_1 - 4.166666666666656e-03*G2_1_6_2 - 4.166666666666656e-03*G2_1_7_0 - 4.166666666666657e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 4.166666666666654e-03*G2_2_8_0 - 4.166666666666654e-03*G2_2_8_1 - 4.166666666666655e-03*G2_2_8_2 - 8.333333333333309e-03*G2_2_9_0 - 8.333333333333309e-03*G2_2_9_1 - 8.333333333333309e-03*G2_2_9_2 - 4.166666666666655e-03*G2_2_10_0 - 4.166666666666656e-03*G2_2_10_1 - 4.166666666666656e-03*G2_2_10_2 - 4.166666666666656e-03*G2_2_11_0 - 4.166666666666657e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 - 8.333333333333320e-02*G3_2_2_0_0 - 8.333333333333322e-02*G3_2_2_0_1 - 8.333333333333322e-02*G3_2_2_0_2 - 8.333333333333309e-03*G4_0_0_0_0_0_0 - 8.333333333333309e-03*G4_0_0_0_0_0_1 - 8.333333333333312e-03*G4_0_0_0_0_0_2 - 4.166666666666654e-03*G4_0_0_0_0_1_0 - 4.166666666666654e-03*G4_0_0_0_0_1_1 - 4.166666666666655e-03*G4_0_0_0_0_1_2 - 4.166666666666654e-03*G4_0_0_0_0_2_0 - 4.166666666666654e-03*G4_0_0_0_0_2_1 - 4.166666666666656e-03*G4_0_0_0_0_2_2 - 4.166666666666656e-03*G4_0_0_0_0_3_0 - 4.166666666666656e-03*G4_0_0_0_0_3_1 - 4.166666666666657e-03*G4_0_0_0_0_3_2 - 4.166666666666654e-03*G4_0_0_1_0_0_0 - 4.166666666666654e-03*G4_0_0_1_0_0_1 - 4.166666666666655e-03*G4_0_0_1_0_0_2 - 8.333333333333307e-03*G4_0_0_1_0_1_0 - 8.333333333333307e-03*G4_0_0_1_0_1_1 - 8.333333333333307e-03*G4_0_0_1_0_1_2 - 4.166666666666654e-03*G4_0_0_1_0_2_0 - 4.166666666666654e-03*G4_0_0_1_0_2_1 - 4.166666666666654e-03*G4_0_0_1_0_2_2 - 4.166666666666654e-03*G4_0_0_1_0_3_0 - 4.166666666666655e-03*G4_0_0_1_0_3_1 - 4.166666666666655e-03*G4_0_0_1_0_3_2 - 4.166666666666654e-03*G4_0_0_2_0_0_0 - 4.166666666666654e-03*G4_0_0_2_0_0_1 - 4.166666666666655e-03*G4_0_0_2_0_0_2 - 4.166666666666654e-03*G4_0_0_2_0_1_0 - 4.166666666666654e-03*G4_0_0_2_0_1_1 - 4.166666666666654e-03*G4_0_0_2_0_1_2 - 8.333333333333309e-03*G4_0_0_2_0_2_0 - 8.333333333333309e-03*G4_0_0_2_0_2_1 - 8.333333333333311e-03*G4_0_0_2_0_2_2 - 4.166666666666654e-03*G4_0_0_2_0_3_0 - 4.166666666666655e-03*G4_0_0_2_0_3_1 - 4.166666666666655e-03*G4_0_0_2_0_3_2 - 4.166666666666656e-03*G4_0_0_3_0_0_0 - 4.166666666666656e-03*G4_0_0_3_0_0_1 - 4.166666666666657e-03*G4_0_0_3_0_0_2 - 4.166666666666654e-03*G4_0_0_3_0_1_0 - 4.166666666666655e-03*G4_0_0_3_0_1_1 - 4.166666666666655e-03*G4_0_0_3_0_1_2 - 4.166666666666655e-03*G4_0_0_3_0_2_0 - 4.166666666666655e-03*G4_0_0_3_0_2_1 - 4.166666666666655e-03*G4_0_0_3_0_2_2 - 8.333333333333309e-03*G4_0_0_3_0_3_0 - 8.333333333333311e-03*G4_0_0_3_0_3_1 - 8.333333333333311e-03*G4_0_0_3_0_3_2 - 8.333333333333309e-03*G4_0_1_0_0_4_0 - 8.333333333333309e-03*G4_0_1_0_0_4_1 - 8.333333333333311e-03*G4_0_1_0_0_4_2 - 4.166666666666654e-03*G4_0_1_0_0_5_0 - 4.166666666666655e-03*G4_0_1_0_0_5_1 - 4.166666666666655e-03*G4_0_1_0_0_5_2 - 4.166666666666654e-03*G4_0_1_0_0_6_0 - 4.166666666666654e-03*G4_0_1_0_0_6_1 - 4.166666666666656e-03*G4_0_1_0_0_6_2 - 4.166666666666656e-03*G4_0_1_0_0_7_0 - 4.166666666666656e-03*G4_0_1_0_0_7_1 - 4.166666666666657e-03*G4_0_1_0_0_7_2 - 4.166666666666654e-03*G4_0_1_1_0_4_0 - 4.166666666666654e-03*G4_0_1_1_0_4_1 - 4.166666666666654e-03*G4_0_1_1_0_4_2 - 8.333333333333307e-03*G4_0_1_1_0_5_0 - 8.333333333333309e-03*G4_0_1_1_0_5_1 - 8.333333333333309e-03*G4_0_1_1_0_5_2 - 4.166666666666654e-03*G4_0_1_1_0_6_0 - 4.166666666666654e-03*G4_0_1_1_0_6_1 - 4.166666666666654e-03*G4_0_1_1_0_6_2 - 4.166666666666654e-03*G4_0_1_1_0_7_0 - 4.166666666666655e-03*G4_0_1_1_0_7_1 - 4.166666666666655e-03*G4_0_1_1_0_7_2 - 4.166666666666653e-03*G4_0_1_2_0_4_0 - 4.166666666666654e-03*G4_0_1_2_0_4_1 - 4.166666666666654e-03*G4_0_1_2_0_4_2 - 4.166666666666654e-03*G4_0_1_2_0_5_0 - 4.166666666666655e-03*G4_0_1_2_0_5_1 - 4.166666666666655e-03*G4_0_1_2_0_5_2 - 8.333333333333309e-03*G4_0_1_2_0_6_0 - 8.333333333333309e-03*G4_0_1_2_0_6_1 - 8.333333333333311e-03*G4_0_1_2_0_6_2 - 4.166666666666654e-03*G4_0_1_2_0_7_0 - 4.166666666666655e-03*G4_0_1_2_0_7_1 - 4.166666666666655e-03*G4_0_1_2_0_7_2 - 4.166666666666655e-03*G4_0_1_3_0_4_0 - 4.166666666666656e-03*G4_0_1_3_0_4_1 - 4.166666666666657e-03*G4_0_1_3_0_4_2 - 4.166666666666655e-03*G4_0_1_3_0_5_0 - 4.166666666666656e-03*G4_0_1_3_0_5_1 - 4.166666666666656e-03*G4_0_1_3_0_5_2 - 4.166666666666655e-03*G4_0_1_3_0_6_0 - 4.166666666666655e-03*G4_0_1_3_0_6_1 - 4.166666666666655e-03*G4_0_1_3_0_6_2 - 8.333333333333309e-03*G4_0_1_3_0_7_0 - 8.333333333333311e-03*G4_0_1_3_0_7_1 - 8.333333333333311e-03*G4_0_1_3_0_7_2 - 8.333333333333309e-03*G4_0_2_0_0_8_0 - 8.333333333333309e-03*G4_0_2_0_0_8_1 - 8.333333333333311e-03*G4_0_2_0_0_8_2 - 4.166666666666654e-03*G4_0_2_0_0_9_0 - 4.166666666666655e-03*G4_0_2_0_0_9_1 - 4.166666666666655e-03*G4_0_2_0_0_9_2 - 4.166666666666654e-03*G4_0_2_0_0_10_0 - 4.166666666666654e-03*G4_0_2_0_0_10_1 - 4.166666666666656e-03*G4_0_2_0_0_10_2 - 4.166666666666656e-03*G4_0_2_0_0_11_0 - 4.166666666666656e-03*G4_0_2_0_0_11_1 - 4.166666666666657e-03*G4_0_2_0_0_11_2 - 4.166666666666654e-03*G4_0_2_1_0_8_0 - 4.166666666666654e-03*G4_0_2_1_0_8_1 - 4.166666666666654e-03*G4_0_2_1_0_8_2 - 8.333333333333307e-03*G4_0_2_1_0_9_0 - 8.333333333333309e-03*G4_0_2_1_0_9_1 - 8.333333333333309e-03*G4_0_2_1_0_9_2 - 4.166666666666654e-03*G4_0_2_1_0_10_0 - 4.166666666666654e-03*G4_0_2_1_0_10_1 - 4.166666666666654e-03*G4_0_2_1_0_10_2 - 4.166666666666654e-03*G4_0_2_1_0_11_0 - 4.166666666666655e-03*G4_0_2_1_0_11_1 - 4.166666666666655e-03*G4_0_2_1_0_11_2 - 4.166666666666653e-03*G4_0_2_2_0_8_0 - 4.166666666666654e-03*G4_0_2_2_0_8_1 - 4.166666666666654e-03*G4_0_2_2_0_8_2 - 4.166666666666654e-03*G4_0_2_2_0_9_0 - 4.166666666666655e-03*G4_0_2_2_0_9_1 - 4.166666666666655e-03*G4_0_2_2_0_9_2 - 8.333333333333309e-03*G4_0_2_2_0_10_0 - 8.333333333333309e-03*G4_0_2_2_0_10_1 - 8.333333333333311e-03*G4_0_2_2_0_10_2 - 4.166666666666654e-03*G4_0_2_2_0_11_0 - 4.166666666666655e-03*G4_0_2_2_0_11_1 - 4.166666666666655e-03*G4_0_2_2_0_11_2 - 4.166666666666655e-03*G4_0_2_3_0_8_0 - 4.166666666666656e-03*G4_0_2_3_0_8_1 - 4.166666666666657e-03*G4_0_2_3_0_8_2 - 4.166666666666655e-03*G4_0_2_3_0_9_0 - 4.166666666666656e-03*G4_0_2_3_0_9_1 - 4.166666666666656e-03*G4_0_2_3_0_9_2 - 4.166666666666655e-03*G4_0_2_3_0_10_0 - 4.166666666666655e-03*G4_0_2_3_0_10_1 - 4.166666666666655e-03*G4_0_2_3_0_10_2 - 8.333333333333309e-03*G4_0_2_3_0_11_0 - 8.333333333333311e-03*G4_0_2_3_0_11_1 - 8.333333333333311e-03*G4_0_2_3_0_11_2 - 8.333333333333309e-03*G4_1_0_4_0_0_0 - 8.333333333333309e-03*G4_1_0_4_0_0_1 - 8.333333333333311e-03*G4_1_0_4_0_0_2 - 4.166666666666654e-03*G4_1_0_4_0_1_0 - 4.166666666666654e-03*G4_1_0_4_0_1_1 - 4.166666666666654e-03*G4_1_0_4_0_1_2 - 4.166666666666653e-03*G4_1_0_4_0_2_0 - 4.166666666666654e-03*G4_1_0_4_0_2_1 - 4.166666666666654e-03*G4_1_0_4_0_2_2 - 4.166666666666654e-03*G4_1_0_4_0_3_0 - 4.166666666666656e-03*G4_1_0_4_0_3_1 - 4.166666666666657e-03*G4_1_0_4_0_3_2 - 4.166666666666654e-03*G4_1_0_5_0_0_0 - 4.166666666666655e-03*G4_1_0_5_0_0_1 - 4.166666666666655e-03*G4_1_0_5_0_0_2 - 8.333333333333307e-03*G4_1_0_5_0_1_0 - 8.333333333333309e-03*G4_1_0_5_0_1_1 - 8.333333333333309e-03*G4_1_0_5_0_1_2 - 4.166666666666654e-03*G4_1_0_5_0_2_0 - 4.166666666666655e-03*G4_1_0_5_0_2_1 - 4.166666666666655e-03*G4_1_0_5_0_2_2 - 4.166666666666655e-03*G4_1_0_5_0_3_0 - 4.166666666666656e-03*G4_1_0_5_0_3_1 - 4.166666666666656e-03*G4_1_0_5_0_3_2 - 4.166666666666654e-03*G4_1_0_6_0_0_0 - 4.166666666666654e-03*G4_1_0_6_0_0_1 - 4.166666666666655e-03*G4_1_0_6_0_0_2 - 4.166666666666654e-03*G4_1_0_6_0_1_0 - 4.166666666666654e-03*G4_1_0_6_0_1_1 - 4.166666666666654e-03*G4_1_0_6_0_1_2 - 8.333333333333309e-03*G4_1_0_6_0_2_0 - 8.333333333333309e-03*G4_1_0_6_0_2_1 - 8.333333333333311e-03*G4_1_0_6_0_2_2 - 4.166666666666654e-03*G4_1_0_6_0_3_0 - 4.166666666666655e-03*G4_1_0_6_0_3_1 - 4.166666666666655e-03*G4_1_0_6_0_3_2 - 4.166666666666656e-03*G4_1_0_7_0_0_0 - 4.166666666666656e-03*G4_1_0_7_0_0_1 - 4.166666666666657e-03*G4_1_0_7_0_0_2 - 4.166666666666654e-03*G4_1_0_7_0_1_0 - 4.166666666666655e-03*G4_1_0_7_0_1_1 - 4.166666666666655e-03*G4_1_0_7_0_1_2 - 4.166666666666655e-03*G4_1_0_7_0_2_0 - 4.166666666666655e-03*G4_1_0_7_0_2_1 - 4.166666666666655e-03*G4_1_0_7_0_2_2 - 8.333333333333309e-03*G4_1_0_7_0_3_0 - 8.333333333333311e-03*G4_1_0_7_0_3_1 - 8.333333333333311e-03*G4_1_0_7_0_3_2 - 8.333333333333309e-03*G4_1_1_4_0_4_0 - 8.333333333333309e-03*G4_1_1_4_0_4_1 - 8.333333333333311e-03*G4_1_1_4_0_4_2 - 4.166666666666654e-03*G4_1_1_4_0_5_0 - 4.166666666666654e-03*G4_1_1_4_0_5_1 - 4.166666666666654e-03*G4_1_1_4_0_5_2 - 4.166666666666653e-03*G4_1_1_4_0_6_0 - 4.166666666666654e-03*G4_1_1_4_0_6_1 - 4.166666666666654e-03*G4_1_1_4_0_6_2 - 4.166666666666654e-03*G4_1_1_4_0_7_0 - 4.166666666666656e-03*G4_1_1_4_0_7_1 - 4.166666666666657e-03*G4_1_1_4_0_7_2 - 4.166666666666654e-03*G4_1_1_5_0_4_0 - 4.166666666666654e-03*G4_1_1_5_0_4_1 - 4.166666666666654e-03*G4_1_1_5_0_4_2 - 8.333333333333307e-03*G4_1_1_5_0_5_0 - 8.333333333333309e-03*G4_1_1_5_0_5_1 - 8.333333333333309e-03*G4_1_1_5_0_5_2 - 4.166666666666654e-03*G4_1_1_5_0_6_0 - 4.166666666666655e-03*G4_1_1_5_0_6_1 - 4.166666666666655e-03*G4_1_1_5_0_6_2 - 4.166666666666655e-03*G4_1_1_5_0_7_0 - 4.166666666666656e-03*G4_1_1_5_0_7_1 - 4.166666666666656e-03*G4_1_1_5_0_7_2 - 4.166666666666653e-03*G4_1_1_6_0_4_0 - 4.166666666666654e-03*G4_1_1_6_0_4_1 - 4.166666666666654e-03*G4_1_1_6_0_4_2 - 4.166666666666654e-03*G4_1_1_6_0_5_0 - 4.166666666666655e-03*G4_1_1_6_0_5_1 - 4.166666666666655e-03*G4_1_1_6_0_5_2 - 8.333333333333309e-03*G4_1_1_6_0_6_0 - 8.333333333333309e-03*G4_1_1_6_0_6_1 - 8.333333333333311e-03*G4_1_1_6_0_6_2 - 4.166666666666654e-03*G4_1_1_6_0_7_0 - 4.166666666666655e-03*G4_1_1_6_0_7_1 - 4.166666666666655e-03*G4_1_1_6_0_7_2 - 4.166666666666655e-03*G4_1_1_7_0_4_0 - 4.166666666666656e-03*G4_1_1_7_0_4_1 - 4.166666666666657e-03*G4_1_1_7_0_4_2 - 4.166666666666655e-03*G4_1_1_7_0_5_0 - 4.166666666666656e-03*G4_1_1_7_0_5_1 - 4.166666666666656e-03*G4_1_1_7_0_5_2 - 4.166666666666655e-03*G4_1_1_7_0_6_0 - 4.166666666666655e-03*G4_1_1_7_0_6_1 - 4.166666666666655e-03*G4_1_1_7_0_6_2 - 8.333333333333309e-03*G4_1_1_7_0_7_0 - 8.333333333333311e-03*G4_1_1_7_0_7_1 - 8.333333333333311e-03*G4_1_1_7_0_7_2 - 8.333333333333309e-03*G4_1_2_4_0_8_0 - 8.333333333333309e-03*G4_1_2_4_0_8_1 - 8.333333333333311e-03*G4_1_2_4_0_8_2 - 4.166666666666654e-03*G4_1_2_4_0_9_0 - 4.166666666666654e-03*G4_1_2_4_0_9_1 - 4.166666666666654e-03*G4_1_2_4_0_9_2 - 4.166666666666653e-03*G4_1_2_4_0_10_0 - 4.166666666666654e-03*G4_1_2_4_0_10_1 - 4.166666666666654e-03*G4_1_2_4_0_10_2 - 4.166666666666654e-03*G4_1_2_4_0_11_0 - 4.166666666666656e-03*G4_1_2_4_0_11_1 - 4.166666666666657e-03*G4_1_2_4_0_11_2 - 4.166666666666654e-03*G4_1_2_5_0_8_0 - 4.166666666666654e-03*G4_1_2_5_0_8_1 - 4.166666666666654e-03*G4_1_2_5_0_8_2 - 8.333333333333307e-03*G4_1_2_5_0_9_0 - 8.333333333333309e-03*G4_1_2_5_0_9_1 - 8.333333333333309e-03*G4_1_2_5_0_9_2 - 4.166666666666654e-03*G4_1_2_5_0_10_0 - 4.166666666666655e-03*G4_1_2_5_0_10_1 - 4.166666666666655e-03*G4_1_2_5_0_10_2 - 4.166666666666655e-03*G4_1_2_5_0_11_0 - 4.166666666666656e-03*G4_1_2_5_0_11_1 - 4.166666666666656e-03*G4_1_2_5_0_11_2 - 4.166666666666653e-03*G4_1_2_6_0_8_0 - 4.166666666666654e-03*G4_1_2_6_0_8_1 - 4.166666666666654e-03*G4_1_2_6_0_8_2 - 4.166666666666654e-03*G4_1_2_6_0_9_0 - 4.166666666666655e-03*G4_1_2_6_0_9_1 - 4.166666666666655e-03*G4_1_2_6_0_9_2 - 8.333333333333309e-03*G4_1_2_6_0_10_0 - 8.333333333333309e-03*G4_1_2_6_0_10_1 - 8.333333333333311e-03*G4_1_2_6_0_10_2 - 4.166666666666654e-03*G4_1_2_6_0_11_0 - 4.166666666666655e-03*G4_1_2_6_0_11_1 - 4.166666666666655e-03*G4_1_2_6_0_11_2 - 4.166666666666655e-03*G4_1_2_7_0_8_0 - 4.166666666666656e-03*G4_1_2_7_0_8_1 - 4.166666666666657e-03*G4_1_2_7_0_8_2 - 4.166666666666655e-03*G4_1_2_7_0_9_0 - 4.166666666666656e-03*G4_1_2_7_0_9_1 - 4.166666666666656e-03*G4_1_2_7_0_9_2 - 4.166666666666655e-03*G4_1_2_7_0_10_0 - 4.166666666666655e-03*G4_1_2_7_0_10_1 - 4.166666666666655e-03*G4_1_2_7_0_10_2 - 8.333333333333309e-03*G4_1_2_7_0_11_0 - 8.333333333333311e-03*G4_1_2_7_0_11_1 - 8.333333333333311e-03*G4_1_2_7_0_11_2 - 8.333333333333309e-03*G4_2_0_8_0_0_0 - 8.333333333333309e-03*G4_2_0_8_0_0_1 - 8.333333333333311e-03*G4_2_0_8_0_0_2 - 4.166666666666654e-03*G4_2_0_8_0_1_0 - 4.166666666666654e-03*G4_2_0_8_0_1_1 - 4.166666666666654e-03*G4_2_0_8_0_1_2 - 4.166666666666653e-03*G4_2_0_8_0_2_0 - 4.166666666666654e-03*G4_2_0_8_0_2_1 - 4.166666666666654e-03*G4_2_0_8_0_2_2 - 4.166666666666654e-03*G4_2_0_8_0_3_0 - 4.166666666666656e-03*G4_2_0_8_0_3_1 - 4.166666666666657e-03*G4_2_0_8_0_3_2 - 4.166666666666654e-03*G4_2_0_9_0_0_0 - 4.166666666666655e-03*G4_2_0_9_0_0_1 - 4.166666666666655e-03*G4_2_0_9_0_0_2 - 8.333333333333307e-03*G4_2_0_9_0_1_0 - 8.333333333333309e-03*G4_2_0_9_0_1_1 - 8.333333333333309e-03*G4_2_0_9_0_1_2 - 4.166666666666654e-03*G4_2_0_9_0_2_0 - 4.166666666666655e-03*G4_2_0_9_0_2_1 - 4.166666666666655e-03*G4_2_0_9_0_2_2 - 4.166666666666655e-03*G4_2_0_9_0_3_0 - 4.166666666666656e-03*G4_2_0_9_0_3_1 - 4.166666666666656e-03*G4_2_0_9_0_3_2 - 4.166666666666654e-03*G4_2_0_10_0_0_0 - 4.166666666666654e-03*G4_2_0_10_0_0_1 - 4.166666666666655e-03*G4_2_0_10_0_0_2 - 4.166666666666654e-03*G4_2_0_10_0_1_0 - 4.166666666666654e-03*G4_2_0_10_0_1_1 - 4.166666666666654e-03*G4_2_0_10_0_1_2 - 8.333333333333309e-03*G4_2_0_10_0_2_0 - 8.333333333333309e-03*G4_2_0_10_0_2_1 - 8.333333333333311e-03*G4_2_0_10_0_2_2 - 4.166666666666654e-03*G4_2_0_10_0_3_0 - 4.166666666666655e-03*G4_2_0_10_0_3_1 - 4.166666666666655e-03*G4_2_0_10_0_3_2 - 4.166666666666656e-03*G4_2_0_11_0_0_0 - 4.166666666666656e-03*G4_2_0_11_0_0_1 - 4.166666666666657e-03*G4_2_0_11_0_0_2 - 4.166666666666654e-03*G4_2_0_11_0_1_0 - 4.166666666666655e-03*G4_2_0_11_0_1_1 - 4.166666666666655e-03*G4_2_0_11_0_1_2 - 4.166666666666655e-03*G4_2_0_11_0_2_0 - 4.166666666666655e-03*G4_2_0_11_0_2_1 - 4.166666666666655e-03*G4_2_0_11_0_2_2 - 8.333333333333309e-03*G4_2_0_11_0_3_0 - 8.333333333333311e-03*G4_2_0_11_0_3_1 - 8.333333333333311e-03*G4_2_0_11_0_3_2 - 8.333333333333309e-03*G4_2_1_8_0_4_0 - 8.333333333333309e-03*G4_2_1_8_0_4_1 - 8.333333333333311e-03*G4_2_1_8_0_4_2 - 4.166666666666654e-03*G4_2_1_8_0_5_0 - 4.166666666666654e-03*G4_2_1_8_0_5_1 - 4.166666666666654e-03*G4_2_1_8_0_5_2 - 4.166666666666653e-03*G4_2_1_8_0_6_0 - 4.166666666666654e-03*G4_2_1_8_0_6_1 - 4.166666666666654e-03*G4_2_1_8_0_6_2 - 4.166666666666654e-03*G4_2_1_8_0_7_0 - 4.166666666666656e-03*G4_2_1_8_0_7_1 - 4.166666666666657e-03*G4_2_1_8_0_7_2 - 4.166666666666654e-03*G4_2_1_9_0_4_0 - 4.166666666666654e-03*G4_2_1_9_0_4_1 - 4.166666666666654e-03*G4_2_1_9_0_4_2 - 8.333333333333307e-03*G4_2_1_9_0_5_0 - 8.333333333333309e-03*G4_2_1_9_0_5_1 - 8.333333333333309e-03*G4_2_1_9_0_5_2 - 4.166666666666654e-03*G4_2_1_9_0_6_0 - 4.166666666666655e-03*G4_2_1_9_0_6_1 - 4.166666666666655e-03*G4_2_1_9_0_6_2 - 4.166666666666655e-03*G4_2_1_9_0_7_0 - 4.166666666666656e-03*G4_2_1_9_0_7_1 - 4.166666666666656e-03*G4_2_1_9_0_7_2 - 4.166666666666653e-03*G4_2_1_10_0_4_0 - 4.166666666666654e-03*G4_2_1_10_0_4_1 - 4.166666666666654e-03*G4_2_1_10_0_4_2 - 4.166666666666654e-03*G4_2_1_10_0_5_0 - 4.166666666666655e-03*G4_2_1_10_0_5_1 - 4.166666666666655e-03*G4_2_1_10_0_5_2 - 8.333333333333309e-03*G4_2_1_10_0_6_0 - 8.333333333333309e-03*G4_2_1_10_0_6_1 - 8.333333333333311e-03*G4_2_1_10_0_6_2 - 4.166666666666654e-03*G4_2_1_10_0_7_0 - 4.166666666666655e-03*G4_2_1_10_0_7_1 - 4.166666666666655e-03*G4_2_1_10_0_7_2 - 4.166666666666655e-03*G4_2_1_11_0_4_0 - 4.166666666666656e-03*G4_2_1_11_0_4_1 - 4.166666666666657e-03*G4_2_1_11_0_4_2 - 4.166666666666655e-03*G4_2_1_11_0_5_0 - 4.166666666666656e-03*G4_2_1_11_0_5_1 - 4.166666666666656e-03*G4_2_1_11_0_5_2 - 4.166666666666655e-03*G4_2_1_11_0_6_0 - 4.166666666666655e-03*G4_2_1_11_0_6_1 - 4.166666666666655e-03*G4_2_1_11_0_6_2 - 8.333333333333309e-03*G4_2_1_11_0_7_0 - 8.333333333333311e-03*G4_2_1_11_0_7_1 - 8.333333333333311e-03*G4_2_1_11_0_7_2 - 8.333333333333309e-03*G4_2_2_8_0_8_0 - 8.333333333333309e-03*G4_2_2_8_0_8_1 - 8.333333333333311e-03*G4_2_2_8_0_8_2 - 4.166666666666654e-03*G4_2_2_8_0_9_0 - 4.166666666666654e-03*G4_2_2_8_0_9_1 - 4.166666666666654e-03*G4_2_2_8_0_9_2 - 4.166666666666653e-03*G4_2_2_8_0_10_0 - 4.166666666666654e-03*G4_2_2_8_0_10_1 - 4.166666666666654e-03*G4_2_2_8_0_10_2 - 4.166666666666654e-03*G4_2_2_8_0_11_0 - 4.166666666666656e-03*G4_2_2_8_0_11_1 - 4.166666666666657e-03*G4_2_2_8_0_11_2 - 4.166666666666654e-03*G4_2_2_9_0_8_0 - 4.166666666666654e-03*G4_2_2_9_0_8_1 - 4.166666666666654e-03*G4_2_2_9_0_8_2 - 8.333333333333307e-03*G4_2_2_9_0_9_0 - 8.333333333333309e-03*G4_2_2_9_0_9_1 - 8.333333333333309e-03*G4_2_2_9_0_9_2 - 4.166666666666654e-03*G4_2_2_9_0_10_0 - 4.166666666666655e-03*G4_2_2_9_0_10_1 - 4.166666666666655e-03*G4_2_2_9_0_10_2 - 4.166666666666655e-03*G4_2_2_9_0_11_0 - 4.166666666666656e-03*G4_2_2_9_0_11_1 - 4.166666666666656e-03*G4_2_2_9_0_11_2 - 4.166666666666653e-03*G4_2_2_10_0_8_0 - 4.166666666666654e-03*G4_2_2_10_0_8_1 - 4.166666666666654e-03*G4_2_2_10_0_8_2 - 4.166666666666654e-03*G4_2_2_10_0_9_0 - 4.166666666666655e-03*G4_2_2_10_0_9_1 - 4.166666666666655e-03*G4_2_2_10_0_9_2 - 8.333333333333309e-03*G4_2_2_10_0_10_0 - 8.333333333333309e-03*G4_2_2_10_0_10_1 - 8.333333333333311e-03*G4_2_2_10_0_10_2 - 4.166666666666654e-03*G4_2_2_10_0_11_0 - 4.166666666666655e-03*G4_2_2_10_0_11_1 - 4.166666666666655e-03*G4_2_2_10_0_11_2 - 4.166666666666655e-03*G4_2_2_11_0_8_0 - 4.166666666666656e-03*G4_2_2_11_0_8_1 - 4.166666666666657e-03*G4_2_2_11_0_8_2 - 4.166666666666655e-03*G4_2_2_11_0_9_0 - 4.166666666666656e-03*G4_2_2_11_0_9_1 - 4.166666666666656e-03*G4_2_2_11_0_9_2 - 4.166666666666655e-03*G4_2_2_11_0_10_0 - 4.166666666666655e-03*G4_2_2_11_0_10_1 - 4.166666666666655e-03*G4_2_2_11_0_10_2 - 8.333333333333309e-03*G4_2_2_11_0_11_0 - 8.333333333333311e-03*G4_2_2_11_0_11_1 - 8.333333333333311e-03*G4_2_2_11_0_11_2;
    block[117] = 1.666666666666662e-02*G0_ + 8.333333333333320e-02*G1_0_0 + 4.166666666666655e-03*G2_0_0_0 + 8.333333333333309e-03*G2_0_1_0 + 4.166666666666655e-03*G2_0_2_0 + 4.166666666666656e-03*G2_0_3_0 + 4.166666666666654e-03*G2_1_4_0 + 8.333333333333309e-03*G2_1_5_0 + 4.166666666666655e-03*G2_1_6_0 + 4.166666666666656e-03*G2_1_7_0 + 4.166666666666654e-03*G2_2_8_0 + 8.333333333333309e-03*G2_2_9_0 + 4.166666666666655e-03*G2_2_10_0 + 4.166666666666656e-03*G2_2_11_0 + 8.333333333333320e-02*G3_2_2_0_0 + 8.333333333333309e-03*G4_0_0_0_0_0_0 + 4.166666666666654e-03*G4_0_0_0_0_1_0 + 4.166666666666654e-03*G4_0_0_0_0_2_0 + 4.166666666666656e-03*G4_0_0_0_0_3_0 + 4.166666666666654e-03*G4_0_0_1_0_0_0 + 8.333333333333307e-03*G4_0_0_1_0_1_0 + 4.166666666666654e-03*G4_0_0_1_0_2_0 + 4.166666666666654e-03*G4_0_0_1_0_3_0 + 4.166666666666654e-03*G4_0_0_2_0_0_0 + 4.166666666666654e-03*G4_0_0_2_0_1_0 + 8.333333333333309e-03*G4_0_0_2_0_2_0 + 4.166666666666654e-03*G4_0_0_2_0_3_0 + 4.166666666666656e-03*G4_0_0_3_0_0_0 + 4.166666666666654e-03*G4_0_0_3_0_1_0 + 4.166666666666655e-03*G4_0_0_3_0_2_0 + 8.333333333333309e-03*G4_0_0_3_0_3_0 + 8.333333333333309e-03*G4_0_1_0_0_4_0 + 4.166666666666654e-03*G4_0_1_0_0_5_0 + 4.166666666666654e-03*G4_0_1_0_0_6_0 + 4.166666666666656e-03*G4_0_1_0_0_7_0 + 4.166666666666654e-03*G4_0_1_1_0_4_0 + 8.333333333333307e-03*G4_0_1_1_0_5_0 + 4.166666666666654e-03*G4_0_1_1_0_6_0 + 4.166666666666654e-03*G4_0_1_1_0_7_0 + 4.166666666666653e-03*G4_0_1_2_0_4_0 + 4.166666666666654e-03*G4_0_1_2_0_5_0 + 8.333333333333309e-03*G4_0_1_2_0_6_0 + 4.166666666666654e-03*G4_0_1_2_0_7_0 + 4.166666666666655e-03*G4_0_1_3_0_4_0 + 4.166666666666655e-03*G4_0_1_3_0_5_0 + 4.166666666666655e-03*G4_0_1_3_0_6_0 + 8.333333333333309e-03*G4_0_1_3_0_7_0 + 8.333333333333309e-03*G4_0_2_0_0_8_0 + 4.166666666666654e-03*G4_0_2_0_0_9_0 + 4.166666666666654e-03*G4_0_2_0_0_10_0 + 4.166666666666656e-03*G4_0_2_0_0_11_0 + 4.166666666666654e-03*G4_0_2_1_0_8_0 + 8.333333333333307e-03*G4_0_2_1_0_9_0 + 4.166666666666654e-03*G4_0_2_1_0_10_0 + 4.166666666666654e-03*G4_0_2_1_0_11_0 + 4.166666666666653e-03*G4_0_2_2_0_8_0 + 4.166666666666654e-03*G4_0_2_2_0_9_0 + 8.333333333333309e-03*G4_0_2_2_0_10_0 + 4.166666666666654e-03*G4_0_2_2_0_11_0 + 4.166666666666655e-03*G4_0_2_3_0_8_0 + 4.166666666666655e-03*G4_0_2_3_0_9_0 + 4.166666666666655e-03*G4_0_2_3_0_10_0 + 8.333333333333309e-03*G4_0_2_3_0_11_0 + 8.333333333333309e-03*G4_1_0_4_0_0_0 + 4.166666666666654e-03*G4_1_0_4_0_1_0 + 4.166666666666653e-03*G4_1_0_4_0_2_0 + 4.166666666666654e-03*G4_1_0_4_0_3_0 + 4.166666666666654e-03*G4_1_0_5_0_0_0 + 8.333333333333307e-03*G4_1_0_5_0_1_0 + 4.166666666666654e-03*G4_1_0_5_0_2_0 + 4.166666666666655e-03*G4_1_0_5_0_3_0 + 4.166666666666654e-03*G4_1_0_6_0_0_0 + 4.166666666666654e-03*G4_1_0_6_0_1_0 + 8.333333333333309e-03*G4_1_0_6_0_2_0 + 4.166666666666654e-03*G4_1_0_6_0_3_0 + 4.166666666666656e-03*G4_1_0_7_0_0_0 + 4.166666666666654e-03*G4_1_0_7_0_1_0 + 4.166666666666655e-03*G4_1_0_7_0_2_0 + 8.333333333333309e-03*G4_1_0_7_0_3_0 + 8.333333333333309e-03*G4_1_1_4_0_4_0 + 4.166666666666654e-03*G4_1_1_4_0_5_0 + 4.166666666666653e-03*G4_1_1_4_0_6_0 + 4.166666666666654e-03*G4_1_1_4_0_7_0 + 4.166666666666654e-03*G4_1_1_5_0_4_0 + 8.333333333333307e-03*G4_1_1_5_0_5_0 + 4.166666666666654e-03*G4_1_1_5_0_6_0 + 4.166666666666655e-03*G4_1_1_5_0_7_0 + 4.166666666666653e-03*G4_1_1_6_0_4_0 + 4.166666666666654e-03*G4_1_1_6_0_5_0 + 8.333333333333309e-03*G4_1_1_6_0_6_0 + 4.166666666666654e-03*G4_1_1_6_0_7_0 + 4.166666666666655e-03*G4_1_1_7_0_4_0 + 4.166666666666655e-03*G4_1_1_7_0_5_0 + 4.166666666666655e-03*G4_1_1_7_0_6_0 + 8.333333333333309e-03*G4_1_1_7_0_7_0 + 8.333333333333309e-03*G4_1_2_4_0_8_0 + 4.166666666666654e-03*G4_1_2_4_0_9_0 + 4.166666666666653e-03*G4_1_2_4_0_10_0 + 4.166666666666654e-03*G4_1_2_4_0_11_0 + 4.166666666666654e-03*G4_1_2_5_0_8_0 + 8.333333333333307e-03*G4_1_2_5_0_9_0 + 4.166666666666654e-03*G4_1_2_5_0_10_0 + 4.166666666666655e-03*G4_1_2_5_0_11_0 + 4.166666666666653e-03*G4_1_2_6_0_8_0 + 4.166666666666654e-03*G4_1_2_6_0_9_0 + 8.333333333333309e-03*G4_1_2_6_0_10_0 + 4.166666666666654e-03*G4_1_2_6_0_11_0 + 4.166666666666655e-03*G4_1_2_7_0_8_0 + 4.166666666666655e-03*G4_1_2_7_0_9_0 + 4.166666666666655e-03*G4_1_2_7_0_10_0 + 8.333333333333309e-03*G4_1_2_7_0_11_0 + 8.333333333333309e-03*G4_2_0_8_0_0_0 + 4.166666666666654e-03*G4_2_0_8_0_1_0 + 4.166666666666653e-03*G4_2_0_8_0_2_0 + 4.166666666666654e-03*G4_2_0_8_0_3_0 + 4.166666666666654e-03*G4_2_0_9_0_0_0 + 8.333333333333307e-03*G4_2_0_9_0_1_0 + 4.166666666666654e-03*G4_2_0_9_0_2_0 + 4.166666666666655e-03*G4_2_0_9_0_3_0 + 4.166666666666654e-03*G4_2_0_10_0_0_0 + 4.166666666666654e-03*G4_2_0_10_0_1_0 + 8.333333333333309e-03*G4_2_0_10_0_2_0 + 4.166666666666654e-03*G4_2_0_10_0_3_0 + 4.166666666666656e-03*G4_2_0_11_0_0_0 + 4.166666666666654e-03*G4_2_0_11_0_1_0 + 4.166666666666655e-03*G4_2_0_11_0_2_0 + 8.333333333333309e-03*G4_2_0_11_0_3_0 + 8.333333333333309e-03*G4_2_1_8_0_4_0 + 4.166666666666654e-03*G4_2_1_8_0_5_0 + 4.166666666666653e-03*G4_2_1_8_0_6_0 + 4.166666666666654e-03*G4_2_1_8_0_7_0 + 4.166666666666654e-03*G4_2_1_9_0_4_0 + 8.333333333333307e-03*G4_2_1_9_0_5_0 + 4.166666666666654e-03*G4_2_1_9_0_6_0 + 4.166666666666655e-03*G4_2_1_9_0_7_0 + 4.166666666666653e-03*G4_2_1_10_0_4_0 + 4.166666666666654e-03*G4_2_1_10_0_5_0 + 8.333333333333309e-03*G4_2_1_10_0_6_0 + 4.166666666666654e-03*G4_2_1_10_0_7_0 + 4.166666666666655e-03*G4_2_1_11_0_4_0 + 4.166666666666655e-03*G4_2_1_11_0_5_0 + 4.166666666666655e-03*G4_2_1_11_0_6_0 + 8.333333333333309e-03*G4_2_1_11_0_7_0 + 8.333333333333309e-03*G4_2_2_8_0_8_0 + 4.166666666666654e-03*G4_2_2_8_0_9_0 + 4.166666666666653e-03*G4_2_2_8_0_10_0 + 4.166666666666654e-03*G4_2_2_8_0_11_0 + 4.166666666666654e-03*G4_2_2_9_0_8_0 + 8.333333333333307e-03*G4_2_2_9_0_9_0 + 4.166666666666654e-03*G4_2_2_9_0_10_0 + 4.166666666666655e-03*G4_2_2_9_0_11_0 + 4.166666666666653e-03*G4_2_2_10_0_8_0 + 4.166666666666654e-03*G4_2_2_10_0_9_0 + 8.333333333333309e-03*G4_2_2_10_0_10_0 + 4.166666666666654e-03*G4_2_2_10_0_11_0 + 4.166666666666655e-03*G4_2_2_11_0_8_0 + 4.166666666666655e-03*G4_2_2_11_0_9_0 + 4.166666666666655e-03*G4_2_2_11_0_10_0 + 8.333333333333309e-03*G4_2_2_11_0_11_0;
    block[118] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_0_1 + 4.166666666666655e-03*G2_0_0_1 + 8.333333333333309e-03*G2_0_1_1 + 4.166666666666656e-03*G2_0_2_1 + 4.166666666666657e-03*G2_0_3_1 + 4.166666666666654e-03*G2_1_4_1 + 8.333333333333309e-03*G2_1_5_1 + 4.166666666666656e-03*G2_1_6_1 + 4.166666666666657e-03*G2_1_7_1 + 4.166666666666654e-03*G2_2_8_1 + 8.333333333333309e-03*G2_2_9_1 + 4.166666666666656e-03*G2_2_10_1 + 4.166666666666657e-03*G2_2_11_1 + 8.333333333333322e-02*G3_2_2_0_1 + 8.333333333333309e-03*G4_0_0_0_0_0_1 + 4.166666666666654e-03*G4_0_0_0_0_1_1 + 4.166666666666654e-03*G4_0_0_0_0_2_1 + 4.166666666666656e-03*G4_0_0_0_0_3_1 + 4.166666666666654e-03*G4_0_0_1_0_0_1 + 8.333333333333307e-03*G4_0_0_1_0_1_1 + 4.166666666666654e-03*G4_0_0_1_0_2_1 + 4.166666666666655e-03*G4_0_0_1_0_3_1 + 4.166666666666654e-03*G4_0_0_2_0_0_1 + 4.166666666666654e-03*G4_0_0_2_0_1_1 + 8.333333333333309e-03*G4_0_0_2_0_2_1 + 4.166666666666655e-03*G4_0_0_2_0_3_1 + 4.166666666666656e-03*G4_0_0_3_0_0_1 + 4.166666666666655e-03*G4_0_0_3_0_1_1 + 4.166666666666655e-03*G4_0_0_3_0_2_1 + 8.333333333333311e-03*G4_0_0_3_0_3_1 + 8.333333333333309e-03*G4_0_1_0_0_4_1 + 4.166666666666655e-03*G4_0_1_0_0_5_1 + 4.166666666666654e-03*G4_0_1_0_0_6_1 + 4.166666666666656e-03*G4_0_1_0_0_7_1 + 4.166666666666654e-03*G4_0_1_1_0_4_1 + 8.333333333333309e-03*G4_0_1_1_0_5_1 + 4.166666666666654e-03*G4_0_1_1_0_6_1 + 4.166666666666655e-03*G4_0_1_1_0_7_1 + 4.166666666666654e-03*G4_0_1_2_0_4_1 + 4.166666666666655e-03*G4_0_1_2_0_5_1 + 8.333333333333309e-03*G4_0_1_2_0_6_1 + 4.166666666666655e-03*G4_0_1_2_0_7_1 + 4.166666666666656e-03*G4_0_1_3_0_4_1 + 4.166666666666656e-03*G4_0_1_3_0_5_1 + 4.166666666666655e-03*G4_0_1_3_0_6_1 + 8.333333333333311e-03*G4_0_1_3_0_7_1 + 8.333333333333309e-03*G4_0_2_0_0_8_1 + 4.166666666666655e-03*G4_0_2_0_0_9_1 + 4.166666666666654e-03*G4_0_2_0_0_10_1 + 4.166666666666656e-03*G4_0_2_0_0_11_1 + 4.166666666666654e-03*G4_0_2_1_0_8_1 + 8.333333333333309e-03*G4_0_2_1_0_9_1 + 4.166666666666654e-03*G4_0_2_1_0_10_1 + 4.166666666666655e-03*G4_0_2_1_0_11_1 + 4.166666666666654e-03*G4_0_2_2_0_8_1 + 4.166666666666655e-03*G4_0_2_2_0_9_1 + 8.333333333333309e-03*G4_0_2_2_0_10_1 + 4.166666666666655e-03*G4_0_2_2_0_11_1 + 4.166666666666656e-03*G4_0_2_3_0_8_1 + 4.166666666666656e-03*G4_0_2_3_0_9_1 + 4.166666666666655e-03*G4_0_2_3_0_10_1 + 8.333333333333311e-03*G4_0_2_3_0_11_1 + 8.333333333333309e-03*G4_1_0_4_0_0_1 + 4.166666666666654e-03*G4_1_0_4_0_1_1 + 4.166666666666654e-03*G4_1_0_4_0_2_1 + 4.166666666666656e-03*G4_1_0_4_0_3_1 + 4.166666666666655e-03*G4_1_0_5_0_0_1 + 8.333333333333309e-03*G4_1_0_5_0_1_1 + 4.166666666666655e-03*G4_1_0_5_0_2_1 + 4.166666666666656e-03*G4_1_0_5_0_3_1 + 4.166666666666654e-03*G4_1_0_6_0_0_1 + 4.166666666666654e-03*G4_1_0_6_0_1_1 + 8.333333333333309e-03*G4_1_0_6_0_2_1 + 4.166666666666655e-03*G4_1_0_6_0_3_1 + 4.166666666666656e-03*G4_1_0_7_0_0_1 + 4.166666666666655e-03*G4_1_0_7_0_1_1 + 4.166666666666655e-03*G4_1_0_7_0_2_1 + 8.333333333333311e-03*G4_1_0_7_0_3_1 + 8.333333333333309e-03*G4_1_1_4_0_4_1 + 4.166666666666654e-03*G4_1_1_4_0_5_1 + 4.166666666666654e-03*G4_1_1_4_0_6_1 + 4.166666666666656e-03*G4_1_1_4_0_7_1 + 4.166666666666654e-03*G4_1_1_5_0_4_1 + 8.333333333333309e-03*G4_1_1_5_0_5_1 + 4.166666666666655e-03*G4_1_1_5_0_6_1 + 4.166666666666656e-03*G4_1_1_5_0_7_1 + 4.166666666666654e-03*G4_1_1_6_0_4_1 + 4.166666666666655e-03*G4_1_1_6_0_5_1 + 8.333333333333309e-03*G4_1_1_6_0_6_1 + 4.166666666666655e-03*G4_1_1_6_0_7_1 + 4.166666666666656e-03*G4_1_1_7_0_4_1 + 4.166666666666656e-03*G4_1_1_7_0_5_1 + 4.166666666666655e-03*G4_1_1_7_0_6_1 + 8.333333333333311e-03*G4_1_1_7_0_7_1 + 8.333333333333309e-03*G4_1_2_4_0_8_1 + 4.166666666666654e-03*G4_1_2_4_0_9_1 + 4.166666666666654e-03*G4_1_2_4_0_10_1 + 4.166666666666656e-03*G4_1_2_4_0_11_1 + 4.166666666666654e-03*G4_1_2_5_0_8_1 + 8.333333333333309e-03*G4_1_2_5_0_9_1 + 4.166666666666655e-03*G4_1_2_5_0_10_1 + 4.166666666666656e-03*G4_1_2_5_0_11_1 + 4.166666666666654e-03*G4_1_2_6_0_8_1 + 4.166666666666655e-03*G4_1_2_6_0_9_1 + 8.333333333333309e-03*G4_1_2_6_0_10_1 + 4.166666666666655e-03*G4_1_2_6_0_11_1 + 4.166666666666656e-03*G4_1_2_7_0_8_1 + 4.166666666666656e-03*G4_1_2_7_0_9_1 + 4.166666666666655e-03*G4_1_2_7_0_10_1 + 8.333333333333311e-03*G4_1_2_7_0_11_1 + 8.333333333333309e-03*G4_2_0_8_0_0_1 + 4.166666666666654e-03*G4_2_0_8_0_1_1 + 4.166666666666654e-03*G4_2_0_8_0_2_1 + 4.166666666666656e-03*G4_2_0_8_0_3_1 + 4.166666666666655e-03*G4_2_0_9_0_0_1 + 8.333333333333309e-03*G4_2_0_9_0_1_1 + 4.166666666666655e-03*G4_2_0_9_0_2_1 + 4.166666666666656e-03*G4_2_0_9_0_3_1 + 4.166666666666654e-03*G4_2_0_10_0_0_1 + 4.166666666666654e-03*G4_2_0_10_0_1_1 + 8.333333333333309e-03*G4_2_0_10_0_2_1 + 4.166666666666655e-03*G4_2_0_10_0_3_1 + 4.166666666666656e-03*G4_2_0_11_0_0_1 + 4.166666666666655e-03*G4_2_0_11_0_1_1 + 4.166666666666655e-03*G4_2_0_11_0_2_1 + 8.333333333333311e-03*G4_2_0_11_0_3_1 + 8.333333333333309e-03*G4_2_1_8_0_4_1 + 4.166666666666654e-03*G4_2_1_8_0_5_1 + 4.166666666666654e-03*G4_2_1_8_0_6_1 + 4.166666666666656e-03*G4_2_1_8_0_7_1 + 4.166666666666654e-03*G4_2_1_9_0_4_1 + 8.333333333333309e-03*G4_2_1_9_0_5_1 + 4.166666666666655e-03*G4_2_1_9_0_6_1 + 4.166666666666656e-03*G4_2_1_9_0_7_1 + 4.166666666666654e-03*G4_2_1_10_0_4_1 + 4.166666666666655e-03*G4_2_1_10_0_5_1 + 8.333333333333309e-03*G4_2_1_10_0_6_1 + 4.166666666666655e-03*G4_2_1_10_0_7_1 + 4.166666666666656e-03*G4_2_1_11_0_4_1 + 4.166666666666656e-03*G4_2_1_11_0_5_1 + 4.166666666666655e-03*G4_2_1_11_0_6_1 + 8.333333333333311e-03*G4_2_1_11_0_7_1 + 8.333333333333309e-03*G4_2_2_8_0_8_1 + 4.166666666666654e-03*G4_2_2_8_0_9_1 + 4.166666666666654e-03*G4_2_2_8_0_10_1 + 4.166666666666656e-03*G4_2_2_8_0_11_1 + 4.166666666666654e-03*G4_2_2_9_0_8_1 + 8.333333333333309e-03*G4_2_2_9_0_9_1 + 4.166666666666655e-03*G4_2_2_9_0_10_1 + 4.166666666666656e-03*G4_2_2_9_0_11_1 + 4.166666666666654e-03*G4_2_2_10_0_8_1 + 4.166666666666655e-03*G4_2_2_10_0_9_1 + 8.333333333333309e-03*G4_2_2_10_0_10_1 + 4.166666666666655e-03*G4_2_2_10_0_11_1 + 4.166666666666656e-03*G4_2_2_11_0_8_1 + 4.166666666666656e-03*G4_2_2_11_0_9_1 + 4.166666666666655e-03*G4_2_2_11_0_10_1 + 8.333333333333311e-03*G4_2_2_11_0_11_1;
    block[119] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_0_2 + 4.166666666666655e-03*G2_0_0_2 + 8.333333333333309e-03*G2_0_1_2 + 4.166666666666656e-03*G2_0_2_2 + 4.166666666666657e-03*G2_0_3_2 + 4.166666666666654e-03*G2_1_4_2 + 8.333333333333309e-03*G2_1_5_2 + 4.166666666666656e-03*G2_1_6_2 + 4.166666666666657e-03*G2_1_7_2 + 4.166666666666654e-03*G2_2_8_2 + 8.333333333333309e-03*G2_2_9_2 + 4.166666666666656e-03*G2_2_10_2 + 4.166666666666657e-03*G2_2_11_2 + 8.333333333333322e-02*G3_2_2_0_2 + 8.333333333333309e-03*G4_0_0_0_0_0_2 + 4.166666666666654e-03*G4_0_0_0_0_1_2 + 4.166666666666654e-03*G4_0_0_0_0_2_2 + 4.166666666666656e-03*G4_0_0_0_0_3_2 + 4.166666666666654e-03*G4_0_0_1_0_0_2 + 8.333333333333307e-03*G4_0_0_1_0_1_2 + 4.166666666666654e-03*G4_0_0_1_0_2_2 + 4.166666666666655e-03*G4_0_0_1_0_3_2 + 4.166666666666654e-03*G4_0_0_2_0_0_2 + 4.166666666666654e-03*G4_0_0_2_0_1_2 + 8.333333333333309e-03*G4_0_0_2_0_2_2 + 4.166666666666655e-03*G4_0_0_2_0_3_2 + 4.166666666666656e-03*G4_0_0_3_0_0_2 + 4.166666666666655e-03*G4_0_0_3_0_1_2 + 4.166666666666655e-03*G4_0_0_3_0_2_2 + 8.333333333333311e-03*G4_0_0_3_0_3_2 + 8.333333333333309e-03*G4_0_1_0_0_4_2 + 4.166666666666655e-03*G4_0_1_0_0_5_2 + 4.166666666666654e-03*G4_0_1_0_0_6_2 + 4.166666666666656e-03*G4_0_1_0_0_7_2 + 4.166666666666654e-03*G4_0_1_1_0_4_2 + 8.333333333333309e-03*G4_0_1_1_0_5_2 + 4.166666666666654e-03*G4_0_1_1_0_6_2 + 4.166666666666655e-03*G4_0_1_1_0_7_2 + 4.166666666666654e-03*G4_0_1_2_0_4_2 + 4.166666666666655e-03*G4_0_1_2_0_5_2 + 8.333333333333309e-03*G4_0_1_2_0_6_2 + 4.166666666666655e-03*G4_0_1_2_0_7_2 + 4.166666666666656e-03*G4_0_1_3_0_4_2 + 4.166666666666656e-03*G4_0_1_3_0_5_2 + 4.166666666666655e-03*G4_0_1_3_0_6_2 + 8.333333333333311e-03*G4_0_1_3_0_7_2 + 8.333333333333309e-03*G4_0_2_0_0_8_2 + 4.166666666666655e-03*G4_0_2_0_0_9_2 + 4.166666666666654e-03*G4_0_2_0_0_10_2 + 4.166666666666656e-03*G4_0_2_0_0_11_2 + 4.166666666666654e-03*G4_0_2_1_0_8_2 + 8.333333333333309e-03*G4_0_2_1_0_9_2 + 4.166666666666654e-03*G4_0_2_1_0_10_2 + 4.166666666666655e-03*G4_0_2_1_0_11_2 + 4.166666666666654e-03*G4_0_2_2_0_8_2 + 4.166666666666655e-03*G4_0_2_2_0_9_2 + 8.333333333333309e-03*G4_0_2_2_0_10_2 + 4.166666666666655e-03*G4_0_2_2_0_11_2 + 4.166666666666656e-03*G4_0_2_3_0_8_2 + 4.166666666666656e-03*G4_0_2_3_0_9_2 + 4.166666666666655e-03*G4_0_2_3_0_10_2 + 8.333333333333311e-03*G4_0_2_3_0_11_2 + 8.333333333333309e-03*G4_1_0_4_0_0_2 + 4.166666666666654e-03*G4_1_0_4_0_1_2 + 4.166666666666654e-03*G4_1_0_4_0_2_2 + 4.166666666666656e-03*G4_1_0_4_0_3_2 + 4.166666666666655e-03*G4_1_0_5_0_0_2 + 8.333333333333309e-03*G4_1_0_5_0_1_2 + 4.166666666666655e-03*G4_1_0_5_0_2_2 + 4.166666666666656e-03*G4_1_0_5_0_3_2 + 4.166666666666654e-03*G4_1_0_6_0_0_2 + 4.166666666666654e-03*G4_1_0_6_0_1_2 + 8.333333333333309e-03*G4_1_0_6_0_2_2 + 4.166666666666655e-03*G4_1_0_6_0_3_2 + 4.166666666666656e-03*G4_1_0_7_0_0_2 + 4.166666666666655e-03*G4_1_0_7_0_1_2 + 4.166666666666655e-03*G4_1_0_7_0_2_2 + 8.333333333333311e-03*G4_1_0_7_0_3_2 + 8.333333333333309e-03*G4_1_1_4_0_4_2 + 4.166666666666654e-03*G4_1_1_4_0_5_2 + 4.166666666666654e-03*G4_1_1_4_0_6_2 + 4.166666666666656e-03*G4_1_1_4_0_7_2 + 4.166666666666654e-03*G4_1_1_5_0_4_2 + 8.333333333333309e-03*G4_1_1_5_0_5_2 + 4.166666666666655e-03*G4_1_1_5_0_6_2 + 4.166666666666656e-03*G4_1_1_5_0_7_2 + 4.166666666666654e-03*G4_1_1_6_0_4_2 + 4.166666666666655e-03*G4_1_1_6_0_5_2 + 8.333333333333309e-03*G4_1_1_6_0_6_2 + 4.166666666666655e-03*G4_1_1_6_0_7_2 + 4.166666666666656e-03*G4_1_1_7_0_4_2 + 4.166666666666656e-03*G4_1_1_7_0_5_2 + 4.166666666666655e-03*G4_1_1_7_0_6_2 + 8.333333333333311e-03*G4_1_1_7_0_7_2 + 8.333333333333309e-03*G4_1_2_4_0_8_2 + 4.166666666666654e-03*G4_1_2_4_0_9_2 + 4.166666666666654e-03*G4_1_2_4_0_10_2 + 4.166666666666656e-03*G4_1_2_4_0_11_2 + 4.166666666666654e-03*G4_1_2_5_0_8_2 + 8.333333333333309e-03*G4_1_2_5_0_9_2 + 4.166666666666655e-03*G4_1_2_5_0_10_2 + 4.166666666666656e-03*G4_1_2_5_0_11_2 + 4.166666666666654e-03*G4_1_2_6_0_8_2 + 4.166666666666655e-03*G4_1_2_6_0_9_2 + 8.333333333333309e-03*G4_1_2_6_0_10_2 + 4.166666666666655e-03*G4_1_2_6_0_11_2 + 4.166666666666656e-03*G4_1_2_7_0_8_2 + 4.166666666666656e-03*G4_1_2_7_0_9_2 + 4.166666666666655e-03*G4_1_2_7_0_10_2 + 8.333333333333311e-03*G4_1_2_7_0_11_2 + 8.333333333333309e-03*G4_2_0_8_0_0_2 + 4.166666666666654e-03*G4_2_0_8_0_1_2 + 4.166666666666654e-03*G4_2_0_8_0_2_2 + 4.166666666666656e-03*G4_2_0_8_0_3_2 + 4.166666666666655e-03*G4_2_0_9_0_0_2 + 8.333333333333309e-03*G4_2_0_9_0_1_2 + 4.166666666666655e-03*G4_2_0_9_0_2_2 + 4.166666666666656e-03*G4_2_0_9_0_3_2 + 4.166666666666654e-03*G4_2_0_10_0_0_2 + 4.166666666666654e-03*G4_2_0_10_0_1_2 + 8.333333333333309e-03*G4_2_0_10_0_2_2 + 4.166666666666655e-03*G4_2_0_10_0_3_2 + 4.166666666666656e-03*G4_2_0_11_0_0_2 + 4.166666666666655e-03*G4_2_0_11_0_1_2 + 4.166666666666655e-03*G4_2_0_11_0_2_2 + 8.333333333333311e-03*G4_2_0_11_0_3_2 + 8.333333333333309e-03*G4_2_1_8_0_4_2 + 4.166666666666654e-03*G4_2_1_8_0_5_2 + 4.166666666666654e-03*G4_2_1_8_0_6_2 + 4.166666666666656e-03*G4_2_1_8_0_7_2 + 4.166666666666654e-03*G4_2_1_9_0_4_2 + 8.333333333333309e-03*G4_2_1_9_0_5_2 + 4.166666666666655e-03*G4_2_1_9_0_6_2 + 4.166666666666656e-03*G4_2_1_9_0_7_2 + 4.166666666666654e-03*G4_2_1_10_0_4_2 + 4.166666666666655e-03*G4_2_1_10_0_5_2 + 8.333333333333309e-03*G4_2_1_10_0_6_2 + 4.166666666666655e-03*G4_2_1_10_0_7_2 + 4.166666666666656e-03*G4_2_1_11_0_4_2 + 4.166666666666656e-03*G4_2_1_11_0_5_2 + 4.166666666666655e-03*G4_2_1_11_0_6_2 + 8.333333333333311e-03*G4_2_1_11_0_7_2 + 8.333333333333309e-03*G4_2_2_8_0_8_2 + 4.166666666666654e-03*G4_2_2_8_0_9_2 + 4.166666666666654e-03*G4_2_2_8_0_10_2 + 4.166666666666656e-03*G4_2_2_8_0_11_2 + 4.166666666666654e-03*G4_2_2_9_0_8_2 + 8.333333333333309e-03*G4_2_2_9_0_9_2 + 4.166666666666655e-03*G4_2_2_9_0_10_2 + 4.166666666666656e-03*G4_2_2_9_0_11_2 + 4.166666666666654e-03*G4_2_2_10_0_8_2 + 4.166666666666655e-03*G4_2_2_10_0_9_2 + 8.333333333333309e-03*G4_2_2_10_0_10_2 + 4.166666666666655e-03*G4_2_2_10_0_11_2 + 4.166666666666656e-03*G4_2_2_11_0_8_2 + 4.166666666666656e-03*G4_2_2_11_0_9_2 + 4.166666666666655e-03*G4_2_2_11_0_10_2 + 8.333333333333311e-03*G4_2_2_11_0_11_2;
    block[120] = -8.333333333333322e-02*G3_2_0_1_0 - 8.333333333333323e-02*G3_2_0_1_1 - 8.333333333333322e-02*G3_2_0_1_2;
    block[121] = 8.333333333333322e-02*G3_2_0_1_0;
    block[122] = 8.333333333333323e-02*G3_2_0_1_1;
    block[123] = 8.333333333333323e-02*G3_2_0_1_2;
    block[124] = -8.333333333333322e-02*G3_2_1_1_0 - 8.333333333333323e-02*G3_2_1_1_1 - 8.333333333333323e-02*G3_2_1_1_2;
    block[125] = 8.333333333333322e-02*G3_2_1_1_0;
    block[126] = 8.333333333333323e-02*G3_2_1_1_1;
    block[127] = 8.333333333333323e-02*G3_2_1_1_2;
    block[128] = 8.333333333333307e-03*G0_ - 8.333333333333322e-02*G1_1_0 - 8.333333333333323e-02*G1_1_1 - 8.333333333333323e-02*G1_1_2 - 4.166666666666654e-03*G2_0_0_0 - 4.166666666666656e-03*G2_0_0_1 - 4.166666666666656e-03*G2_0_0_2 - 4.166666666666654e-03*G2_0_1_0 - 4.166666666666654e-03*G2_0_1_1 - 4.166666666666654e-03*G2_0_1_2 - 8.333333333333311e-03*G2_0_2_0 - 8.333333333333311e-03*G2_0_2_1 - 8.333333333333312e-03*G2_0_2_2 - 4.166666666666655e-03*G2_0_3_0 - 4.166666666666656e-03*G2_0_3_1 - 4.166666666666657e-03*G2_0_3_2 - 4.166666666666654e-03*G2_1_4_0 - 4.166666666666654e-03*G2_1_4_1 - 4.166666666666654e-03*G2_1_4_2 - 4.166666666666655e-03*G2_1_5_0 - 4.166666666666656e-03*G2_1_5_1 - 4.166666666666656e-03*G2_1_5_2 - 8.333333333333311e-03*G2_1_6_0 - 8.333333333333311e-03*G2_1_6_1 - 8.333333333333312e-03*G2_1_6_2 - 4.166666666666655e-03*G2_1_7_0 - 4.166666666666656e-03*G2_1_7_1 - 4.166666666666657e-03*G2_1_7_2 - 4.166666666666654e-03*G2_2_8_0 - 4.166666666666654e-03*G2_2_8_1 - 4.166666666666654e-03*G2_2_8_2 - 4.166666666666655e-03*G2_2_9_0 - 4.166666666666656e-03*G2_2_9_1 - 4.166666666666656e-03*G2_2_9_2 - 8.333333333333311e-03*G2_2_10_0 - 8.333333333333311e-03*G2_2_10_1 - 8.333333333333312e-03*G2_2_10_2 - 4.166666666666655e-03*G2_2_11_0 - 4.166666666666656e-03*G2_2_11_1 - 4.166666666666657e-03*G2_2_11_2 - 8.333333333333322e-02*G3_2_2_1_0 - 8.333333333333323e-02*G3_2_2_1_1 - 8.333333333333323e-02*G3_2_2_1_2 - 8.333333333333309e-03*G4_0_0_0_1_0_0 - 8.333333333333311e-03*G4_0_0_0_1_0_1 - 8.333333333333312e-03*G4_0_0_0_1_0_2 - 4.166666666666654e-03*G4_0_0_0_1_1_0 - 4.166666666666655e-03*G4_0_0_0_1_1_1 - 4.166666666666655e-03*G4_0_0_0_1_1_2 - 4.166666666666654e-03*G4_0_0_0_1_2_0 - 4.166666666666656e-03*G4_0_0_0_1_2_1 - 4.166666666666656e-03*G4_0_0_0_1_2_2 - 4.166666666666656e-03*G4_0_0_0_1_3_0 - 4.166666666666657e-03*G4_0_0_0_1_3_1 - 4.166666666666658e-03*G4_0_0_0_1_3_2 - 4.166666666666654e-03*G4_0_0_1_1_0_0 - 4.166666666666655e-03*G4_0_0_1_1_0_1 - 4.166666666666655e-03*G4_0_0_1_1_0_2 - 8.333333333333307e-03*G4_0_0_1_1_1_0 - 8.333333333333309e-03*G4_0_0_1_1_1_1 - 8.333333333333309e-03*G4_0_0_1_1_1_2 - 4.166666666666654e-03*G4_0_0_1_1_2_0 - 4.166666666666654e-03*G4_0_0_1_1_2_1 - 4.166666666666655e-03*G4_0_0_1_1_2_2 - 4.166666666666655e-03*G4_0_0_1_1_3_0 - 4.166666666666655e-03*G4_0_0_1_1_3_1 - 4.166666666666656e-03*G4_0_0_1_1_3_2 - 4.166666666666654e-03*G4_0_0_2_1_0_0 - 4.166666666666656e-03*G4_0_0_2_1_0_1 - 4.166666666666656e-03*G4_0_0_2_1_0_2 - 4.166666666666654e-03*G4_0_0_2_1_1_0 - 4.166666666666654e-03*G4_0_0_2_1_1_1 - 4.166666666666654e-03*G4_0_0_2_1_1_2 - 8.333333333333311e-03*G4_0_0_2_1_2_0 - 8.333333333333311e-03*G4_0_0_2_1_2_1 - 8.333333333333312e-03*G4_0_0_2_1_2_2 - 4.166666666666655e-03*G4_0_0_2_1_3_0 - 4.166666666666656e-03*G4_0_0_2_1_3_1 - 4.166666666666657e-03*G4_0_0_2_1_3_2 - 4.166666666666656e-03*G4_0_0_3_1_0_0 - 4.166666666666657e-03*G4_0_0_3_1_0_1 - 4.166666666666658e-03*G4_0_0_3_1_0_2 - 4.166666666666655e-03*G4_0_0_3_1_1_0 - 4.166666666666655e-03*G4_0_0_3_1_1_1 - 4.166666666666656e-03*G4_0_0_3_1_1_2 - 4.166666666666655e-03*G4_0_0_3_1_2_0 - 4.166666666666656e-03*G4_0_0_3_1_2_1 - 4.166666666666657e-03*G4_0_0_3_1_2_2 - 8.333333333333311e-03*G4_0_0_3_1_3_0 - 8.333333333333311e-03*G4_0_0_3_1_3_1 - 8.333333333333312e-03*G4_0_0_3_1_3_2 - 8.333333333333309e-03*G4_0_1_0_1_4_0 - 8.333333333333311e-03*G4_0_1_0_1_4_1 - 8.333333333333312e-03*G4_0_1_0_1_4_2 - 4.166666666666655e-03*G4_0_1_0_1_5_0 - 4.166666666666655e-03*G4_0_1_0_1_5_1 - 4.166666666666656e-03*G4_0_1_0_1_5_2 - 4.166666666666654e-03*G4_0_1_0_1_6_0 - 4.166666666666656e-03*G4_0_1_0_1_6_1 - 4.166666666666656e-03*G4_0_1_0_1_6_2 - 4.166666666666656e-03*G4_0_1_0_1_7_0 - 4.166666666666657e-03*G4_0_1_0_1_7_1 - 4.166666666666658e-03*G4_0_1_0_1_7_2 - 4.166666666666654e-03*G4_0_1_1_1_4_0 - 4.166666666666654e-03*G4_0_1_1_1_4_1 - 4.166666666666654e-03*G4_0_1_1_1_4_2 - 8.333333333333309e-03*G4_0_1_1_1_5_0 - 8.333333333333309e-03*G4_0_1_1_1_5_1 - 8.333333333333309e-03*G4_0_1_1_1_5_2 - 4.166666666666654e-03*G4_0_1_1_1_6_0 - 4.166666666666654e-03*G4_0_1_1_1_6_1 - 4.166666666666655e-03*G4_0_1_1_1_6_2 - 4.166666666666655e-03*G4_0_1_1_1_7_0 - 4.166666666666655e-03*G4_0_1_1_1_7_1 - 4.166666666666656e-03*G4_0_1_1_1_7_2 - 4.166666666666654e-03*G4_0_1_2_1_4_0 - 4.166666666666654e-03*G4_0_1_2_1_4_1 - 4.166666666666654e-03*G4_0_1_2_1_4_2 - 4.166666666666655e-03*G4_0_1_2_1_5_0 - 4.166666666666656e-03*G4_0_1_2_1_5_1 - 4.166666666666656e-03*G4_0_1_2_1_5_2 - 8.333333333333311e-03*G4_0_1_2_1_6_0 - 8.333333333333311e-03*G4_0_1_2_1_6_1 - 8.333333333333312e-03*G4_0_1_2_1_6_2 - 4.166666666666655e-03*G4_0_1_2_1_7_0 - 4.166666666666656e-03*G4_0_1_2_1_7_1 - 4.166666666666657e-03*G4_0_1_2_1_7_2 - 4.166666666666656e-03*G4_0_1_3_1_4_0 - 4.166666666666657e-03*G4_0_1_3_1_4_1 - 4.166666666666657e-03*G4_0_1_3_1_4_2 - 4.166666666666656e-03*G4_0_1_3_1_5_0 - 4.166666666666657e-03*G4_0_1_3_1_5_1 - 4.166666666666657e-03*G4_0_1_3_1_5_2 - 4.166666666666655e-03*G4_0_1_3_1_6_0 - 4.166666666666656e-03*G4_0_1_3_1_6_1 - 4.166666666666657e-03*G4_0_1_3_1_6_2 - 8.333333333333311e-03*G4_0_1_3_1_7_0 - 8.333333333333311e-03*G4_0_1_3_1_7_1 - 8.333333333333312e-03*G4_0_1_3_1_7_2 - 8.333333333333309e-03*G4_0_2_0_1_8_0 - 8.333333333333311e-03*G4_0_2_0_1_8_1 - 8.333333333333312e-03*G4_0_2_0_1_8_2 - 4.166666666666655e-03*G4_0_2_0_1_9_0 - 4.166666666666655e-03*G4_0_2_0_1_9_1 - 4.166666666666656e-03*G4_0_2_0_1_9_2 - 4.166666666666654e-03*G4_0_2_0_1_10_0 - 4.166666666666656e-03*G4_0_2_0_1_10_1 - 4.166666666666656e-03*G4_0_2_0_1_10_2 - 4.166666666666656e-03*G4_0_2_0_1_11_0 - 4.166666666666657e-03*G4_0_2_0_1_11_1 - 4.166666666666658e-03*G4_0_2_0_1_11_2 - 4.166666666666654e-03*G4_0_2_1_1_8_0 - 4.166666666666654e-03*G4_0_2_1_1_8_1 - 4.166666666666654e-03*G4_0_2_1_1_8_2 - 8.333333333333309e-03*G4_0_2_1_1_9_0 - 8.333333333333309e-03*G4_0_2_1_1_9_1 - 8.333333333333309e-03*G4_0_2_1_1_9_2 - 4.166666666666654e-03*G4_0_2_1_1_10_0 - 4.166666666666654e-03*G4_0_2_1_1_10_1 - 4.166666666666655e-03*G4_0_2_1_1_10_2 - 4.166666666666655e-03*G4_0_2_1_1_11_0 - 4.166666666666655e-03*G4_0_2_1_1_11_1 - 4.166666666666656e-03*G4_0_2_1_1_11_2 - 4.166666666666654e-03*G4_0_2_2_1_8_0 - 4.166666666666654e-03*G4_0_2_2_1_8_1 - 4.166666666666654e-03*G4_0_2_2_1_8_2 - 4.166666666666655e-03*G4_0_2_2_1_9_0 - 4.166666666666656e-03*G4_0_2_2_1_9_1 - 4.166666666666656e-03*G4_0_2_2_1_9_2 - 8.333333333333311e-03*G4_0_2_2_1_10_0 - 8.333333333333311e-03*G4_0_2_2_1_10_1 - 8.333333333333312e-03*G4_0_2_2_1_10_2 - 4.166666666666655e-03*G4_0_2_2_1_11_0 - 4.166666666666656e-03*G4_0_2_2_1_11_1 - 4.166666666666657e-03*G4_0_2_2_1_11_2 - 4.166666666666656e-03*G4_0_2_3_1_8_0 - 4.166666666666657e-03*G4_0_2_3_1_8_1 - 4.166666666666657e-03*G4_0_2_3_1_8_2 - 4.166666666666656e-03*G4_0_2_3_1_9_0 - 4.166666666666657e-03*G4_0_2_3_1_9_1 - 4.166666666666657e-03*G4_0_2_3_1_9_2 - 4.166666666666655e-03*G4_0_2_3_1_10_0 - 4.166666666666656e-03*G4_0_2_3_1_10_1 - 4.166666666666657e-03*G4_0_2_3_1_10_2 - 8.333333333333311e-03*G4_0_2_3_1_11_0 - 8.333333333333311e-03*G4_0_2_3_1_11_1 - 8.333333333333312e-03*G4_0_2_3_1_11_2 - 8.333333333333309e-03*G4_1_0_4_1_0_0 - 8.333333333333311e-03*G4_1_0_4_1_0_1 - 8.333333333333312e-03*G4_1_0_4_1_0_2 - 4.166666666666654e-03*G4_1_0_4_1_1_0 - 4.166666666666654e-03*G4_1_0_4_1_1_1 - 4.166666666666654e-03*G4_1_0_4_1_1_2 - 4.166666666666654e-03*G4_1_0_4_1_2_0 - 4.166666666666654e-03*G4_1_0_4_1_2_1 - 4.166666666666654e-03*G4_1_0_4_1_2_2 - 4.166666666666656e-03*G4_1_0_4_1_3_0 - 4.166666666666657e-03*G4_1_0_4_1_3_1 - 4.166666666666657e-03*G4_1_0_4_1_3_2 - 4.166666666666655e-03*G4_1_0_5_1_0_0 - 4.166666666666655e-03*G4_1_0_5_1_0_1 - 4.166666666666656e-03*G4_1_0_5_1_0_2 - 8.333333333333309e-03*G4_1_0_5_1_1_0 - 8.333333333333309e-03*G4_1_0_5_1_1_1 - 8.333333333333309e-03*G4_1_0_5_1_1_2 - 4.166666666666655e-03*G4_1_0_5_1_2_0 - 4.166666666666656e-03*G4_1_0_5_1_2_1 - 4.166666666666656e-03*G4_1_0_5_1_2_2 - 4.166666666666656e-03*G4_1_0_5_1_3_0 - 4.166666666666657e-03*G4_1_0_5_1_3_1 - 4.166666666666657e-03*G4_1_0_5_1_3_2 - 4.166666666666654e-03*G4_1_0_6_1_0_0 - 4.166666666666656e-03*G4_1_0_6_1_0_1 - 4.166666666666656e-03*G4_1_0_6_1_0_2 - 4.166666666666654e-03*G4_1_0_6_1_1_0 - 4.166666666666654e-03*G4_1_0_6_1_1_1 - 4.166666666666654e-03*G4_1_0_6_1_1_2 - 8.333333333333311e-03*G4_1_0_6_1_2_0 - 8.333333333333311e-03*G4_1_0_6_1_2_1 - 8.333333333333312e-03*G4_1_0_6_1_2_2 - 4.166666666666655e-03*G4_1_0_6_1_3_0 - 4.166666666666656e-03*G4_1_0_6_1_3_1 - 4.166666666666657e-03*G4_1_0_6_1_3_2 - 4.166666666666656e-03*G4_1_0_7_1_0_0 - 4.166666666666657e-03*G4_1_0_7_1_0_1 - 4.166666666666658e-03*G4_1_0_7_1_0_2 - 4.166666666666655e-03*G4_1_0_7_1_1_0 - 4.166666666666655e-03*G4_1_0_7_1_1_1 - 4.166666666666656e-03*G4_1_0_7_1_1_2 - 4.166666666666655e-03*G4_1_0_7_1_2_0 - 4.166666666666656e-03*G4_1_0_7_1_2_1 - 4.166666666666657e-03*G4_1_0_7_1_2_2 - 8.333333333333311e-03*G4_1_0_7_1_3_0 - 8.333333333333311e-03*G4_1_0_7_1_3_1 - 8.333333333333312e-03*G4_1_0_7_1_3_2 - 8.333333333333309e-03*G4_1_1_4_1_4_0 - 8.333333333333311e-03*G4_1_1_4_1_4_1 - 8.333333333333312e-03*G4_1_1_4_1_4_2 - 4.166666666666654e-03*G4_1_1_4_1_5_0 - 4.166666666666654e-03*G4_1_1_4_1_5_1 - 4.166666666666655e-03*G4_1_1_4_1_5_2 - 4.166666666666654e-03*G4_1_1_4_1_6_0 - 4.166666666666654e-03*G4_1_1_4_1_6_1 - 4.166666666666654e-03*G4_1_1_4_1_6_2 - 4.166666666666656e-03*G4_1_1_4_1_7_0 - 4.166666666666657e-03*G4_1_1_4_1_7_1 - 4.166666666666657e-03*G4_1_1_4_1_7_2 - 4.166666666666654e-03*G4_1_1_5_1_4_0 - 4.166666666666654e-03*G4_1_1_5_1_4_1 - 4.166666666666655e-03*G4_1_1_5_1_4_2 - 8.333333333333309e-03*G4_1_1_5_1_5_0 - 8.333333333333309e-03*G4_1_1_5_1_5_1 - 8.333333333333309e-03*G4_1_1_5_1_5_2 - 4.166666666666655e-03*G4_1_1_5_1_6_0 - 4.166666666666656e-03*G4_1_1_5_1_6_1 - 4.166666666666656e-03*G4_1_1_5_1_6_2 - 4.166666666666656e-03*G4_1_1_5_1_7_0 - 4.166666666666657e-03*G4_1_1_5_1_7_1 - 4.166666666666657e-03*G4_1_1_5_1_7_2 - 4.166666666666654e-03*G4_1_1_6_1_4_0 - 4.166666666666654e-03*G4_1_1_6_1_4_1 - 4.166666666666654e-03*G4_1_1_6_1_4_2 - 4.166666666666655e-03*G4_1_1_6_1_5_0 - 4.166666666666656e-03*G4_1_1_6_1_5_1 - 4.166666666666656e-03*G4_1_1_6_1_5_2 - 8.333333333333311e-03*G4_1_1_6_1_6_0 - 8.333333333333311e-03*G4_1_1_6_1_6_1 - 8.333333333333312e-03*G4_1_1_6_1_6_2 - 4.166666666666655e-03*G4_1_1_6_1_7_0 - 4.166666666666656e-03*G4_1_1_6_1_7_1 - 4.166666666666657e-03*G4_1_1_6_1_7_2 - 4.166666666666656e-03*G4_1_1_7_1_4_0 - 4.166666666666657e-03*G4_1_1_7_1_4_1 - 4.166666666666657e-03*G4_1_1_7_1_4_2 - 4.166666666666656e-03*G4_1_1_7_1_5_0 - 4.166666666666657e-03*G4_1_1_7_1_5_1 - 4.166666666666657e-03*G4_1_1_7_1_5_2 - 4.166666666666655e-03*G4_1_1_7_1_6_0 - 4.166666666666656e-03*G4_1_1_7_1_6_1 - 4.166666666666657e-03*G4_1_1_7_1_6_2 - 8.333333333333311e-03*G4_1_1_7_1_7_0 - 8.333333333333311e-03*G4_1_1_7_1_7_1 - 8.333333333333312e-03*G4_1_1_7_1_7_2 - 8.333333333333309e-03*G4_1_2_4_1_8_0 - 8.333333333333311e-03*G4_1_2_4_1_8_1 - 8.333333333333312e-03*G4_1_2_4_1_8_2 - 4.166666666666654e-03*G4_1_2_4_1_9_0 - 4.166666666666654e-03*G4_1_2_4_1_9_1 - 4.166666666666655e-03*G4_1_2_4_1_9_2 - 4.166666666666654e-03*G4_1_2_4_1_10_0 - 4.166666666666654e-03*G4_1_2_4_1_10_1 - 4.166666666666654e-03*G4_1_2_4_1_10_2 - 4.166666666666656e-03*G4_1_2_4_1_11_0 - 4.166666666666657e-03*G4_1_2_4_1_11_1 - 4.166666666666657e-03*G4_1_2_4_1_11_2 - 4.166666666666654e-03*G4_1_2_5_1_8_0 - 4.166666666666654e-03*G4_1_2_5_1_8_1 - 4.166666666666655e-03*G4_1_2_5_1_8_2 - 8.333333333333309e-03*G4_1_2_5_1_9_0 - 8.333333333333309e-03*G4_1_2_5_1_9_1 - 8.333333333333309e-03*G4_1_2_5_1_9_2 - 4.166666666666655e-03*G4_1_2_5_1_10_0 - 4.166666666666656e-03*G4_1_2_5_1_10_1 - 4.166666666666656e-03*G4_1_2_5_1_10_2 - 4.166666666666656e-03*G4_1_2_5_1_11_0 - 4.166666666666657e-03*G4_1_2_5_1_11_1 - 4.166666666666657e-03*G4_1_2_5_1_11_2 - 4.166666666666654e-03*G4_1_2_6_1_8_0 - 4.166666666666654e-03*G4_1_2_6_1_8_1 - 4.166666666666654e-03*G4_1_2_6_1_8_2 - 4.166666666666655e-03*G4_1_2_6_1_9_0 - 4.166666666666656e-03*G4_1_2_6_1_9_1 - 4.166666666666656e-03*G4_1_2_6_1_9_2 - 8.333333333333311e-03*G4_1_2_6_1_10_0 - 8.333333333333311e-03*G4_1_2_6_1_10_1 - 8.333333333333312e-03*G4_1_2_6_1_10_2 - 4.166666666666655e-03*G4_1_2_6_1_11_0 - 4.166666666666656e-03*G4_1_2_6_1_11_1 - 4.166666666666657e-03*G4_1_2_6_1_11_2 - 4.166666666666656e-03*G4_1_2_7_1_8_0 - 4.166666666666657e-03*G4_1_2_7_1_8_1 - 4.166666666666657e-03*G4_1_2_7_1_8_2 - 4.166666666666656e-03*G4_1_2_7_1_9_0 - 4.166666666666657e-03*G4_1_2_7_1_9_1 - 4.166666666666657e-03*G4_1_2_7_1_9_2 - 4.166666666666655e-03*G4_1_2_7_1_10_0 - 4.166666666666656e-03*G4_1_2_7_1_10_1 - 4.166666666666657e-03*G4_1_2_7_1_10_2 - 8.333333333333311e-03*G4_1_2_7_1_11_0 - 8.333333333333311e-03*G4_1_2_7_1_11_1 - 8.333333333333312e-03*G4_1_2_7_1_11_2 - 8.333333333333309e-03*G4_2_0_8_1_0_0 - 8.333333333333311e-03*G4_2_0_8_1_0_1 - 8.333333333333312e-03*G4_2_0_8_1_0_2 - 4.166666666666654e-03*G4_2_0_8_1_1_0 - 4.166666666666654e-03*G4_2_0_8_1_1_1 - 4.166666666666654e-03*G4_2_0_8_1_1_2 - 4.166666666666654e-03*G4_2_0_8_1_2_0 - 4.166666666666654e-03*G4_2_0_8_1_2_1 - 4.166666666666654e-03*G4_2_0_8_1_2_2 - 4.166666666666656e-03*G4_2_0_8_1_3_0 - 4.166666666666657e-03*G4_2_0_8_1_3_1 - 4.166666666666657e-03*G4_2_0_8_1_3_2 - 4.166666666666655e-03*G4_2_0_9_1_0_0 - 4.166666666666655e-03*G4_2_0_9_1_0_1 - 4.166666666666656e-03*G4_2_0_9_1_0_2 - 8.333333333333309e-03*G4_2_0_9_1_1_0 - 8.333333333333309e-03*G4_2_0_9_1_1_1 - 8.333333333333309e-03*G4_2_0_9_1_1_2 - 4.166666666666655e-03*G4_2_0_9_1_2_0 - 4.166666666666656e-03*G4_2_0_9_1_2_1 - 4.166666666666656e-03*G4_2_0_9_1_2_2 - 4.166666666666656e-03*G4_2_0_9_1_3_0 - 4.166666666666657e-03*G4_2_0_9_1_3_1 - 4.166666666666657e-03*G4_2_0_9_1_3_2 - 4.166666666666654e-03*G4_2_0_10_1_0_0 - 4.166666666666656e-03*G4_2_0_10_1_0_1 - 4.166666666666656e-03*G4_2_0_10_1_0_2 - 4.166666666666654e-03*G4_2_0_10_1_1_0 - 4.166666666666654e-03*G4_2_0_10_1_1_1 - 4.166666666666654e-03*G4_2_0_10_1_1_2 - 8.333333333333311e-03*G4_2_0_10_1_2_0 - 8.333333333333311e-03*G4_2_0_10_1_2_1 - 8.333333333333312e-03*G4_2_0_10_1_2_2 - 4.166666666666655e-03*G4_2_0_10_1_3_0 - 4.166666666666656e-03*G4_2_0_10_1_3_1 - 4.166666666666657e-03*G4_2_0_10_1_3_2 - 4.166666666666656e-03*G4_2_0_11_1_0_0 - 4.166666666666657e-03*G4_2_0_11_1_0_1 - 4.166666666666658e-03*G4_2_0_11_1_0_2 - 4.166666666666655e-03*G4_2_0_11_1_1_0 - 4.166666666666655e-03*G4_2_0_11_1_1_1 - 4.166666666666656e-03*G4_2_0_11_1_1_2 - 4.166666666666655e-03*G4_2_0_11_1_2_0 - 4.166666666666656e-03*G4_2_0_11_1_2_1 - 4.166666666666657e-03*G4_2_0_11_1_2_2 - 8.333333333333311e-03*G4_2_0_11_1_3_0 - 8.333333333333311e-03*G4_2_0_11_1_3_1 - 8.333333333333312e-03*G4_2_0_11_1_3_2 - 8.333333333333309e-03*G4_2_1_8_1_4_0 - 8.333333333333311e-03*G4_2_1_8_1_4_1 - 8.333333333333312e-03*G4_2_1_8_1_4_2 - 4.166666666666654e-03*G4_2_1_8_1_5_0 - 4.166666666666654e-03*G4_2_1_8_1_5_1 - 4.166666666666655e-03*G4_2_1_8_1_5_2 - 4.166666666666654e-03*G4_2_1_8_1_6_0 - 4.166666666666654e-03*G4_2_1_8_1_6_1 - 4.166666666666654e-03*G4_2_1_8_1_6_2 - 4.166666666666656e-03*G4_2_1_8_1_7_0 - 4.166666666666657e-03*G4_2_1_8_1_7_1 - 4.166666666666657e-03*G4_2_1_8_1_7_2 - 4.166666666666654e-03*G4_2_1_9_1_4_0 - 4.166666666666654e-03*G4_2_1_9_1_4_1 - 4.166666666666655e-03*G4_2_1_9_1_4_2 - 8.333333333333309e-03*G4_2_1_9_1_5_0 - 8.333333333333309e-03*G4_2_1_9_1_5_1 - 8.333333333333309e-03*G4_2_1_9_1_5_2 - 4.166666666666655e-03*G4_2_1_9_1_6_0 - 4.166666666666656e-03*G4_2_1_9_1_6_1 - 4.166666666666656e-03*G4_2_1_9_1_6_2 - 4.166666666666656e-03*G4_2_1_9_1_7_0 - 4.166666666666657e-03*G4_2_1_9_1_7_1 - 4.166666666666657e-03*G4_2_1_9_1_7_2 - 4.166666666666654e-03*G4_2_1_10_1_4_0 - 4.166666666666654e-03*G4_2_1_10_1_4_1 - 4.166666666666654e-03*G4_2_1_10_1_4_2 - 4.166666666666655e-03*G4_2_1_10_1_5_0 - 4.166666666666656e-03*G4_2_1_10_1_5_1 - 4.166666666666656e-03*G4_2_1_10_1_5_2 - 8.333333333333311e-03*G4_2_1_10_1_6_0 - 8.333333333333311e-03*G4_2_1_10_1_6_1 - 8.333333333333312e-03*G4_2_1_10_1_6_2 - 4.166666666666655e-03*G4_2_1_10_1_7_0 - 4.166666666666656e-03*G4_2_1_10_1_7_1 - 4.166666666666657e-03*G4_2_1_10_1_7_2 - 4.166666666666656e-03*G4_2_1_11_1_4_0 - 4.166666666666657e-03*G4_2_1_11_1_4_1 - 4.166666666666657e-03*G4_2_1_11_1_4_2 - 4.166666666666656e-03*G4_2_1_11_1_5_0 - 4.166666666666657e-03*G4_2_1_11_1_5_1 - 4.166666666666657e-03*G4_2_1_11_1_5_2 - 4.166666666666655e-03*G4_2_1_11_1_6_0 - 4.166666666666656e-03*G4_2_1_11_1_6_1 - 4.166666666666657e-03*G4_2_1_11_1_6_2 - 8.333333333333311e-03*G4_2_1_11_1_7_0 - 8.333333333333311e-03*G4_2_1_11_1_7_1 - 8.333333333333312e-03*G4_2_1_11_1_7_2 - 8.333333333333309e-03*G4_2_2_8_1_8_0 - 8.333333333333311e-03*G4_2_2_8_1_8_1 - 8.333333333333312e-03*G4_2_2_8_1_8_2 - 4.166666666666654e-03*G4_2_2_8_1_9_0 - 4.166666666666654e-03*G4_2_2_8_1_9_1 - 4.166666666666655e-03*G4_2_2_8_1_9_2 - 4.166666666666654e-03*G4_2_2_8_1_10_0 - 4.166666666666654e-03*G4_2_2_8_1_10_1 - 4.166666666666654e-03*G4_2_2_8_1_10_2 - 4.166666666666656e-03*G4_2_2_8_1_11_0 - 4.166666666666657e-03*G4_2_2_8_1_11_1 - 4.166666666666657e-03*G4_2_2_8_1_11_2 - 4.166666666666654e-03*G4_2_2_9_1_8_0 - 4.166666666666654e-03*G4_2_2_9_1_8_1 - 4.166666666666655e-03*G4_2_2_9_1_8_2 - 8.333333333333309e-03*G4_2_2_9_1_9_0 - 8.333333333333309e-03*G4_2_2_9_1_9_1 - 8.333333333333309e-03*G4_2_2_9_1_9_2 - 4.166666666666655e-03*G4_2_2_9_1_10_0 - 4.166666666666656e-03*G4_2_2_9_1_10_1 - 4.166666666666656e-03*G4_2_2_9_1_10_2 - 4.166666666666656e-03*G4_2_2_9_1_11_0 - 4.166666666666657e-03*G4_2_2_9_1_11_1 - 4.166666666666657e-03*G4_2_2_9_1_11_2 - 4.166666666666654e-03*G4_2_2_10_1_8_0 - 4.166666666666654e-03*G4_2_2_10_1_8_1 - 4.166666666666654e-03*G4_2_2_10_1_8_2 - 4.166666666666655e-03*G4_2_2_10_1_9_0 - 4.166666666666656e-03*G4_2_2_10_1_9_1 - 4.166666666666656e-03*G4_2_2_10_1_9_2 - 8.333333333333311e-03*G4_2_2_10_1_10_0 - 8.333333333333311e-03*G4_2_2_10_1_10_1 - 8.333333333333312e-03*G4_2_2_10_1_10_2 - 4.166666666666655e-03*G4_2_2_10_1_11_0 - 4.166666666666656e-03*G4_2_2_10_1_11_1 - 4.166666666666657e-03*G4_2_2_10_1_11_2 - 4.166666666666656e-03*G4_2_2_11_1_8_0 - 4.166666666666657e-03*G4_2_2_11_1_8_1 - 4.166666666666657e-03*G4_2_2_11_1_8_2 - 4.166666666666656e-03*G4_2_2_11_1_9_0 - 4.166666666666657e-03*G4_2_2_11_1_9_1 - 4.166666666666657e-03*G4_2_2_11_1_9_2 - 4.166666666666655e-03*G4_2_2_11_1_10_0 - 4.166666666666656e-03*G4_2_2_11_1_10_1 - 4.166666666666657e-03*G4_2_2_11_1_10_2 - 8.333333333333311e-03*G4_2_2_11_1_11_0 - 8.333333333333311e-03*G4_2_2_11_1_11_1 - 8.333333333333312e-03*G4_2_2_11_1_11_2;
    block[129] = 8.333333333333312e-03*G0_ + 8.333333333333322e-02*G1_1_0 + 4.166666666666654e-03*G2_0_0_0 + 4.166666666666654e-03*G2_0_1_0 + 8.333333333333311e-03*G2_0_2_0 + 4.166666666666655e-03*G2_0_3_0 + 4.166666666666654e-03*G2_1_4_0 + 4.166666666666655e-03*G2_1_5_0 + 8.333333333333311e-03*G2_1_6_0 + 4.166666666666655e-03*G2_1_7_0 + 4.166666666666654e-03*G2_2_8_0 + 4.166666666666655e-03*G2_2_9_0 + 8.333333333333311e-03*G2_2_10_0 + 4.166666666666655e-03*G2_2_11_0 + 8.333333333333322e-02*G3_2_2_1_0 + 8.333333333333309e-03*G4_0_0_0_1_0_0 + 4.166666666666654e-03*G4_0_0_0_1_1_0 + 4.166666666666654e-03*G4_0_0_0_1_2_0 + 4.166666666666656e-03*G4_0_0_0_1_3_0 + 4.166666666666654e-03*G4_0_0_1_1_0_0 + 8.333333333333307e-03*G4_0_0_1_1_1_0 + 4.166666666666654e-03*G4_0_0_1_1_2_0 + 4.166666666666655e-03*G4_0_0_1_1_3_0 + 4.166666666666654e-03*G4_0_0_2_1_0_0 + 4.166666666666654e-03*G4_0_0_2_1_1_0 + 8.333333333333311e-03*G4_0_0_2_1_2_0 + 4.166666666666655e-03*G4_0_0_2_1_3_0 + 4.166666666666656e-03*G4_0_0_3_1_0_0 + 4.166666666666655e-03*G4_0_0_3_1_1_0 + 4.166666666666655e-03*G4_0_0_3_1_2_0 + 8.333333333333311e-03*G4_0_0_3_1_3_0 + 8.333333333333309e-03*G4_0_1_0_1_4_0 + 4.166666666666655e-03*G4_0_1_0_1_5_0 + 4.166666666666654e-03*G4_0_1_0_1_6_0 + 4.166666666666656e-03*G4_0_1_0_1_7_0 + 4.166666666666654e-03*G4_0_1_1_1_4_0 + 8.333333333333309e-03*G4_0_1_1_1_5_0 + 4.166666666666654e-03*G4_0_1_1_1_6_0 + 4.166666666666655e-03*G4_0_1_1_1_7_0 + 4.166666666666654e-03*G4_0_1_2_1_4_0 + 4.166666666666655e-03*G4_0_1_2_1_5_0 + 8.333333333333311e-03*G4_0_1_2_1_6_0 + 4.166666666666655e-03*G4_0_1_2_1_7_0 + 4.166666666666656e-03*G4_0_1_3_1_4_0 + 4.166666666666656e-03*G4_0_1_3_1_5_0 + 4.166666666666655e-03*G4_0_1_3_1_6_0 + 8.333333333333311e-03*G4_0_1_3_1_7_0 + 8.333333333333309e-03*G4_0_2_0_1_8_0 + 4.166666666666655e-03*G4_0_2_0_1_9_0 + 4.166666666666654e-03*G4_0_2_0_1_10_0 + 4.166666666666656e-03*G4_0_2_0_1_11_0 + 4.166666666666654e-03*G4_0_2_1_1_8_0 + 8.333333333333309e-03*G4_0_2_1_1_9_0 + 4.166666666666654e-03*G4_0_2_1_1_10_0 + 4.166666666666655e-03*G4_0_2_1_1_11_0 + 4.166666666666654e-03*G4_0_2_2_1_8_0 + 4.166666666666655e-03*G4_0_2_2_1_9_0 + 8.333333333333311e-03*G4_0_2_2_1_10_0 + 4.166666666666655e-03*G4_0_2_2_1_11_0 + 4.166666666666656e-03*G4_0_2_3_1_8_0 + 4.166666666666656e-03*G4_0_2_3_1_9_0 + 4.166666666666655e-03*G4_0_2_3_1_10_0 + 8.333333333333311e-03*G4_0_2_3_1_11_0 + 8.333333333333309e-03*G4_1_0_4_1_0_0 + 4.166666666666654e-03*G4_1_0_4_1_1_0 + 4.166666666666654e-03*G4_1_0_4_1_2_0 + 4.166666666666656e-03*G4_1_0_4_1_3_0 + 4.166666666666655e-03*G4_1_0_5_1_0_0 + 8.333333333333309e-03*G4_1_0_5_1_1_0 + 4.166666666666655e-03*G4_1_0_5_1_2_0 + 4.166666666666656e-03*G4_1_0_5_1_3_0 + 4.166666666666654e-03*G4_1_0_6_1_0_0 + 4.166666666666654e-03*G4_1_0_6_1_1_0 + 8.333333333333311e-03*G4_1_0_6_1_2_0 + 4.166666666666655e-03*G4_1_0_6_1_3_0 + 4.166666666666656e-03*G4_1_0_7_1_0_0 + 4.166666666666655e-03*G4_1_0_7_1_1_0 + 4.166666666666655e-03*G4_1_0_7_1_2_0 + 8.333333333333311e-03*G4_1_0_7_1_3_0 + 8.333333333333309e-03*G4_1_1_4_1_4_0 + 4.166666666666654e-03*G4_1_1_4_1_5_0 + 4.166666666666654e-03*G4_1_1_4_1_6_0 + 4.166666666666656e-03*G4_1_1_4_1_7_0 + 4.166666666666654e-03*G4_1_1_5_1_4_0 + 8.333333333333309e-03*G4_1_1_5_1_5_0 + 4.166666666666655e-03*G4_1_1_5_1_6_0 + 4.166666666666656e-03*G4_1_1_5_1_7_0 + 4.166666666666654e-03*G4_1_1_6_1_4_0 + 4.166666666666655e-03*G4_1_1_6_1_5_0 + 8.333333333333311e-03*G4_1_1_6_1_6_0 + 4.166666666666655e-03*G4_1_1_6_1_7_0 + 4.166666666666656e-03*G4_1_1_7_1_4_0 + 4.166666666666656e-03*G4_1_1_7_1_5_0 + 4.166666666666655e-03*G4_1_1_7_1_6_0 + 8.333333333333311e-03*G4_1_1_7_1_7_0 + 8.333333333333309e-03*G4_1_2_4_1_8_0 + 4.166666666666654e-03*G4_1_2_4_1_9_0 + 4.166666666666654e-03*G4_1_2_4_1_10_0 + 4.166666666666656e-03*G4_1_2_4_1_11_0 + 4.166666666666654e-03*G4_1_2_5_1_8_0 + 8.333333333333309e-03*G4_1_2_5_1_9_0 + 4.166666666666655e-03*G4_1_2_5_1_10_0 + 4.166666666666656e-03*G4_1_2_5_1_11_0 + 4.166666666666654e-03*G4_1_2_6_1_8_0 + 4.166666666666655e-03*G4_1_2_6_1_9_0 + 8.333333333333311e-03*G4_1_2_6_1_10_0 + 4.166666666666655e-03*G4_1_2_6_1_11_0 + 4.166666666666656e-03*G4_1_2_7_1_8_0 + 4.166666666666656e-03*G4_1_2_7_1_9_0 + 4.166666666666655e-03*G4_1_2_7_1_10_0 + 8.333333333333311e-03*G4_1_2_7_1_11_0 + 8.333333333333309e-03*G4_2_0_8_1_0_0 + 4.166666666666654e-03*G4_2_0_8_1_1_0 + 4.166666666666654e-03*G4_2_0_8_1_2_0 + 4.166666666666656e-03*G4_2_0_8_1_3_0 + 4.166666666666655e-03*G4_2_0_9_1_0_0 + 8.333333333333309e-03*G4_2_0_9_1_1_0 + 4.166666666666655e-03*G4_2_0_9_1_2_0 + 4.166666666666656e-03*G4_2_0_9_1_3_0 + 4.166666666666654e-03*G4_2_0_10_1_0_0 + 4.166666666666654e-03*G4_2_0_10_1_1_0 + 8.333333333333311e-03*G4_2_0_10_1_2_0 + 4.166666666666655e-03*G4_2_0_10_1_3_0 + 4.166666666666656e-03*G4_2_0_11_1_0_0 + 4.166666666666655e-03*G4_2_0_11_1_1_0 + 4.166666666666655e-03*G4_2_0_11_1_2_0 + 8.333333333333311e-03*G4_2_0_11_1_3_0 + 8.333333333333309e-03*G4_2_1_8_1_4_0 + 4.166666666666654e-03*G4_2_1_8_1_5_0 + 4.166666666666654e-03*G4_2_1_8_1_6_0 + 4.166666666666656e-03*G4_2_1_8_1_7_0 + 4.166666666666654e-03*G4_2_1_9_1_4_0 + 8.333333333333309e-03*G4_2_1_9_1_5_0 + 4.166666666666655e-03*G4_2_1_9_1_6_0 + 4.166666666666656e-03*G4_2_1_9_1_7_0 + 4.166666666666654e-03*G4_2_1_10_1_4_0 + 4.166666666666655e-03*G4_2_1_10_1_5_0 + 8.333333333333311e-03*G4_2_1_10_1_6_0 + 4.166666666666655e-03*G4_2_1_10_1_7_0 + 4.166666666666656e-03*G4_2_1_11_1_4_0 + 4.166666666666656e-03*G4_2_1_11_1_5_0 + 4.166666666666655e-03*G4_2_1_11_1_6_0 + 8.333333333333311e-03*G4_2_1_11_1_7_0 + 8.333333333333309e-03*G4_2_2_8_1_8_0 + 4.166666666666654e-03*G4_2_2_8_1_9_0 + 4.166666666666654e-03*G4_2_2_8_1_10_0 + 4.166666666666656e-03*G4_2_2_8_1_11_0 + 4.166666666666654e-03*G4_2_2_9_1_8_0 + 8.333333333333309e-03*G4_2_2_9_1_9_0 + 4.166666666666655e-03*G4_2_2_9_1_10_0 + 4.166666666666656e-03*G4_2_2_9_1_11_0 + 4.166666666666654e-03*G4_2_2_10_1_8_0 + 4.166666666666655e-03*G4_2_2_10_1_9_0 + 8.333333333333311e-03*G4_2_2_10_1_10_0 + 4.166666666666655e-03*G4_2_2_10_1_11_0 + 4.166666666666656e-03*G4_2_2_11_1_8_0 + 4.166666666666656e-03*G4_2_2_11_1_9_0 + 4.166666666666655e-03*G4_2_2_11_1_10_0 + 8.333333333333311e-03*G4_2_2_11_1_11_0;
    block[130] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_1_1 + 4.166666666666656e-03*G2_0_0_1 + 4.166666666666654e-03*G2_0_1_1 + 8.333333333333311e-03*G2_0_2_1 + 4.166666666666656e-03*G2_0_3_1 + 4.166666666666654e-03*G2_1_4_1 + 4.166666666666656e-03*G2_1_5_1 + 8.333333333333311e-03*G2_1_6_1 + 4.166666666666656e-03*G2_1_7_1 + 4.166666666666654e-03*G2_2_8_1 + 4.166666666666656e-03*G2_2_9_1 + 8.333333333333311e-03*G2_2_10_1 + 4.166666666666656e-03*G2_2_11_1 + 8.333333333333323e-02*G3_2_2_1_1 + 8.333333333333311e-03*G4_0_0_0_1_0_1 + 4.166666666666655e-03*G4_0_0_0_1_1_1 + 4.166666666666656e-03*G4_0_0_0_1_2_1 + 4.166666666666657e-03*G4_0_0_0_1_3_1 + 4.166666666666655e-03*G4_0_0_1_1_0_1 + 8.333333333333309e-03*G4_0_0_1_1_1_1 + 4.166666666666654e-03*G4_0_0_1_1_2_1 + 4.166666666666655e-03*G4_0_0_1_1_3_1 + 4.166666666666656e-03*G4_0_0_2_1_0_1 + 4.166666666666654e-03*G4_0_0_2_1_1_1 + 8.333333333333311e-03*G4_0_0_2_1_2_1 + 4.166666666666656e-03*G4_0_0_2_1_3_1 + 4.166666666666657e-03*G4_0_0_3_1_0_1 + 4.166666666666655e-03*G4_0_0_3_1_1_1 + 4.166666666666656e-03*G4_0_0_3_1_2_1 + 8.333333333333311e-03*G4_0_0_3_1_3_1 + 8.333333333333311e-03*G4_0_1_0_1_4_1 + 4.166666666666655e-03*G4_0_1_0_1_5_1 + 4.166666666666656e-03*G4_0_1_0_1_6_1 + 4.166666666666657e-03*G4_0_1_0_1_7_1 + 4.166666666666654e-03*G4_0_1_1_1_4_1 + 8.333333333333309e-03*G4_0_1_1_1_5_1 + 4.166666666666654e-03*G4_0_1_1_1_6_1 + 4.166666666666655e-03*G4_0_1_1_1_7_1 + 4.166666666666654e-03*G4_0_1_2_1_4_1 + 4.166666666666656e-03*G4_0_1_2_1_5_1 + 8.333333333333311e-03*G4_0_1_2_1_6_1 + 4.166666666666656e-03*G4_0_1_2_1_7_1 + 4.166666666666657e-03*G4_0_1_3_1_4_1 + 4.166666666666657e-03*G4_0_1_3_1_5_1 + 4.166666666666656e-03*G4_0_1_3_1_6_1 + 8.333333333333311e-03*G4_0_1_3_1_7_1 + 8.333333333333311e-03*G4_0_2_0_1_8_1 + 4.166666666666655e-03*G4_0_2_0_1_9_1 + 4.166666666666656e-03*G4_0_2_0_1_10_1 + 4.166666666666657e-03*G4_0_2_0_1_11_1 + 4.166666666666654e-03*G4_0_2_1_1_8_1 + 8.333333333333309e-03*G4_0_2_1_1_9_1 + 4.166666666666654e-03*G4_0_2_1_1_10_1 + 4.166666666666655e-03*G4_0_2_1_1_11_1 + 4.166666666666654e-03*G4_0_2_2_1_8_1 + 4.166666666666656e-03*G4_0_2_2_1_9_1 + 8.333333333333311e-03*G4_0_2_2_1_10_1 + 4.166666666666656e-03*G4_0_2_2_1_11_1 + 4.166666666666657e-03*G4_0_2_3_1_8_1 + 4.166666666666657e-03*G4_0_2_3_1_9_1 + 4.166666666666656e-03*G4_0_2_3_1_10_1 + 8.333333333333311e-03*G4_0_2_3_1_11_1 + 8.333333333333311e-03*G4_1_0_4_1_0_1 + 4.166666666666654e-03*G4_1_0_4_1_1_1 + 4.166666666666654e-03*G4_1_0_4_1_2_1 + 4.166666666666657e-03*G4_1_0_4_1_3_1 + 4.166666666666655e-03*G4_1_0_5_1_0_1 + 8.333333333333309e-03*G4_1_0_5_1_1_1 + 4.166666666666656e-03*G4_1_0_5_1_2_1 + 4.166666666666657e-03*G4_1_0_5_1_3_1 + 4.166666666666656e-03*G4_1_0_6_1_0_1 + 4.166666666666654e-03*G4_1_0_6_1_1_1 + 8.333333333333311e-03*G4_1_0_6_1_2_1 + 4.166666666666656e-03*G4_1_0_6_1_3_1 + 4.166666666666657e-03*G4_1_0_7_1_0_1 + 4.166666666666655e-03*G4_1_0_7_1_1_1 + 4.166666666666656e-03*G4_1_0_7_1_2_1 + 8.333333333333311e-03*G4_1_0_7_1_3_1 + 8.333333333333311e-03*G4_1_1_4_1_4_1 + 4.166666666666654e-03*G4_1_1_4_1_5_1 + 4.166666666666654e-03*G4_1_1_4_1_6_1 + 4.166666666666657e-03*G4_1_1_4_1_7_1 + 4.166666666666654e-03*G4_1_1_5_1_4_1 + 8.333333333333309e-03*G4_1_1_5_1_5_1 + 4.166666666666656e-03*G4_1_1_5_1_6_1 + 4.166666666666657e-03*G4_1_1_5_1_7_1 + 4.166666666666654e-03*G4_1_1_6_1_4_1 + 4.166666666666656e-03*G4_1_1_6_1_5_1 + 8.333333333333311e-03*G4_1_1_6_1_6_1 + 4.166666666666656e-03*G4_1_1_6_1_7_1 + 4.166666666666657e-03*G4_1_1_7_1_4_1 + 4.166666666666657e-03*G4_1_1_7_1_5_1 + 4.166666666666656e-03*G4_1_1_7_1_6_1 + 8.333333333333311e-03*G4_1_1_7_1_7_1 + 8.333333333333311e-03*G4_1_2_4_1_8_1 + 4.166666666666654e-03*G4_1_2_4_1_9_1 + 4.166666666666654e-03*G4_1_2_4_1_10_1 + 4.166666666666657e-03*G4_1_2_4_1_11_1 + 4.166666666666654e-03*G4_1_2_5_1_8_1 + 8.333333333333309e-03*G4_1_2_5_1_9_1 + 4.166666666666656e-03*G4_1_2_5_1_10_1 + 4.166666666666657e-03*G4_1_2_5_1_11_1 + 4.166666666666654e-03*G4_1_2_6_1_8_1 + 4.166666666666656e-03*G4_1_2_6_1_9_1 + 8.333333333333311e-03*G4_1_2_6_1_10_1 + 4.166666666666656e-03*G4_1_2_6_1_11_1 + 4.166666666666657e-03*G4_1_2_7_1_8_1 + 4.166666666666657e-03*G4_1_2_7_1_9_1 + 4.166666666666656e-03*G4_1_2_7_1_10_1 + 8.333333333333311e-03*G4_1_2_7_1_11_1 + 8.333333333333311e-03*G4_2_0_8_1_0_1 + 4.166666666666654e-03*G4_2_0_8_1_1_1 + 4.166666666666654e-03*G4_2_0_8_1_2_1 + 4.166666666666657e-03*G4_2_0_8_1_3_1 + 4.166666666666655e-03*G4_2_0_9_1_0_1 + 8.333333333333309e-03*G4_2_0_9_1_1_1 + 4.166666666666656e-03*G4_2_0_9_1_2_1 + 4.166666666666657e-03*G4_2_0_9_1_3_1 + 4.166666666666656e-03*G4_2_0_10_1_0_1 + 4.166666666666654e-03*G4_2_0_10_1_1_1 + 8.333333333333311e-03*G4_2_0_10_1_2_1 + 4.166666666666656e-03*G4_2_0_10_1_3_1 + 4.166666666666657e-03*G4_2_0_11_1_0_1 + 4.166666666666655e-03*G4_2_0_11_1_1_1 + 4.166666666666656e-03*G4_2_0_11_1_2_1 + 8.333333333333311e-03*G4_2_0_11_1_3_1 + 8.333333333333311e-03*G4_2_1_8_1_4_1 + 4.166666666666654e-03*G4_2_1_8_1_5_1 + 4.166666666666654e-03*G4_2_1_8_1_6_1 + 4.166666666666657e-03*G4_2_1_8_1_7_1 + 4.166666666666654e-03*G4_2_1_9_1_4_1 + 8.333333333333309e-03*G4_2_1_9_1_5_1 + 4.166666666666656e-03*G4_2_1_9_1_6_1 + 4.166666666666657e-03*G4_2_1_9_1_7_1 + 4.166666666666654e-03*G4_2_1_10_1_4_1 + 4.166666666666656e-03*G4_2_1_10_1_5_1 + 8.333333333333311e-03*G4_2_1_10_1_6_1 + 4.166666666666656e-03*G4_2_1_10_1_7_1 + 4.166666666666657e-03*G4_2_1_11_1_4_1 + 4.166666666666657e-03*G4_2_1_11_1_5_1 + 4.166666666666656e-03*G4_2_1_11_1_6_1 + 8.333333333333311e-03*G4_2_1_11_1_7_1 + 8.333333333333311e-03*G4_2_2_8_1_8_1 + 4.166666666666654e-03*G4_2_2_8_1_9_1 + 4.166666666666654e-03*G4_2_2_8_1_10_1 + 4.166666666666657e-03*G4_2_2_8_1_11_1 + 4.166666666666654e-03*G4_2_2_9_1_8_1 + 8.333333333333309e-03*G4_2_2_9_1_9_1 + 4.166666666666656e-03*G4_2_2_9_1_10_1 + 4.166666666666657e-03*G4_2_2_9_1_11_1 + 4.166666666666654e-03*G4_2_2_10_1_8_1 + 4.166666666666656e-03*G4_2_2_10_1_9_1 + 8.333333333333311e-03*G4_2_2_10_1_10_1 + 4.166666666666656e-03*G4_2_2_10_1_11_1 + 4.166666666666657e-03*G4_2_2_11_1_8_1 + 4.166666666666657e-03*G4_2_2_11_1_9_1 + 4.166666666666656e-03*G4_2_2_11_1_10_1 + 8.333333333333311e-03*G4_2_2_11_1_11_1;
    block[131] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_1_2 + 4.166666666666656e-03*G2_0_0_2 + 4.166666666666654e-03*G2_0_1_2 + 8.333333333333311e-03*G2_0_2_2 + 4.166666666666656e-03*G2_0_3_2 + 4.166666666666654e-03*G2_1_4_2 + 4.166666666666656e-03*G2_1_5_2 + 8.333333333333311e-03*G2_1_6_2 + 4.166666666666656e-03*G2_1_7_2 + 4.166666666666654e-03*G2_2_8_2 + 4.166666666666656e-03*G2_2_9_2 + 8.333333333333311e-03*G2_2_10_2 + 4.166666666666656e-03*G2_2_11_2 + 8.333333333333323e-02*G3_2_2_1_2 + 8.333333333333311e-03*G4_0_0_0_1_0_2 + 4.166666666666655e-03*G4_0_0_0_1_1_2 + 4.166666666666656e-03*G4_0_0_0_1_2_2 + 4.166666666666657e-03*G4_0_0_0_1_3_2 + 4.166666666666655e-03*G4_0_0_1_1_0_2 + 8.333333333333309e-03*G4_0_0_1_1_1_2 + 4.166666666666654e-03*G4_0_0_1_1_2_2 + 4.166666666666655e-03*G4_0_0_1_1_3_2 + 4.166666666666656e-03*G4_0_0_2_1_0_2 + 4.166666666666654e-03*G4_0_0_2_1_1_2 + 8.333333333333311e-03*G4_0_0_2_1_2_2 + 4.166666666666656e-03*G4_0_0_2_1_3_2 + 4.166666666666657e-03*G4_0_0_3_1_0_2 + 4.166666666666655e-03*G4_0_0_3_1_1_2 + 4.166666666666656e-03*G4_0_0_3_1_2_2 + 8.333333333333311e-03*G4_0_0_3_1_3_2 + 8.333333333333311e-03*G4_0_1_0_1_4_2 + 4.166666666666655e-03*G4_0_1_0_1_5_2 + 4.166666666666656e-03*G4_0_1_0_1_6_2 + 4.166666666666657e-03*G4_0_1_0_1_7_2 + 4.166666666666654e-03*G4_0_1_1_1_4_2 + 8.333333333333309e-03*G4_0_1_1_1_5_2 + 4.166666666666654e-03*G4_0_1_1_1_6_2 + 4.166666666666655e-03*G4_0_1_1_1_7_2 + 4.166666666666654e-03*G4_0_1_2_1_4_2 + 4.166666666666656e-03*G4_0_1_2_1_5_2 + 8.333333333333311e-03*G4_0_1_2_1_6_2 + 4.166666666666656e-03*G4_0_1_2_1_7_2 + 4.166666666666657e-03*G4_0_1_3_1_4_2 + 4.166666666666657e-03*G4_0_1_3_1_5_2 + 4.166666666666656e-03*G4_0_1_3_1_6_2 + 8.333333333333311e-03*G4_0_1_3_1_7_2 + 8.333333333333311e-03*G4_0_2_0_1_8_2 + 4.166666666666655e-03*G4_0_2_0_1_9_2 + 4.166666666666656e-03*G4_0_2_0_1_10_2 + 4.166666666666657e-03*G4_0_2_0_1_11_2 + 4.166666666666654e-03*G4_0_2_1_1_8_2 + 8.333333333333309e-03*G4_0_2_1_1_9_2 + 4.166666666666654e-03*G4_0_2_1_1_10_2 + 4.166666666666655e-03*G4_0_2_1_1_11_2 + 4.166666666666654e-03*G4_0_2_2_1_8_2 + 4.166666666666656e-03*G4_0_2_2_1_9_2 + 8.333333333333311e-03*G4_0_2_2_1_10_2 + 4.166666666666656e-03*G4_0_2_2_1_11_2 + 4.166666666666657e-03*G4_0_2_3_1_8_2 + 4.166666666666657e-03*G4_0_2_3_1_9_2 + 4.166666666666656e-03*G4_0_2_3_1_10_2 + 8.333333333333311e-03*G4_0_2_3_1_11_2 + 8.333333333333311e-03*G4_1_0_4_1_0_2 + 4.166666666666654e-03*G4_1_0_4_1_1_2 + 4.166666666666654e-03*G4_1_0_4_1_2_2 + 4.166666666666657e-03*G4_1_0_4_1_3_2 + 4.166666666666655e-03*G4_1_0_5_1_0_2 + 8.333333333333309e-03*G4_1_0_5_1_1_2 + 4.166666666666656e-03*G4_1_0_5_1_2_2 + 4.166666666666657e-03*G4_1_0_5_1_3_2 + 4.166666666666656e-03*G4_1_0_6_1_0_2 + 4.166666666666654e-03*G4_1_0_6_1_1_2 + 8.333333333333311e-03*G4_1_0_6_1_2_2 + 4.166666666666656e-03*G4_1_0_6_1_3_2 + 4.166666666666657e-03*G4_1_0_7_1_0_2 + 4.166666666666655e-03*G4_1_0_7_1_1_2 + 4.166666666666656e-03*G4_1_0_7_1_2_2 + 8.333333333333311e-03*G4_1_0_7_1_3_2 + 8.333333333333311e-03*G4_1_1_4_1_4_2 + 4.166666666666654e-03*G4_1_1_4_1_5_2 + 4.166666666666654e-03*G4_1_1_4_1_6_2 + 4.166666666666657e-03*G4_1_1_4_1_7_2 + 4.166666666666654e-03*G4_1_1_5_1_4_2 + 8.333333333333309e-03*G4_1_1_5_1_5_2 + 4.166666666666656e-03*G4_1_1_5_1_6_2 + 4.166666666666657e-03*G4_1_1_5_1_7_2 + 4.166666666666654e-03*G4_1_1_6_1_4_2 + 4.166666666666656e-03*G4_1_1_6_1_5_2 + 8.333333333333311e-03*G4_1_1_6_1_6_2 + 4.166666666666656e-03*G4_1_1_6_1_7_2 + 4.166666666666657e-03*G4_1_1_7_1_4_2 + 4.166666666666657e-03*G4_1_1_7_1_5_2 + 4.166666666666656e-03*G4_1_1_7_1_6_2 + 8.333333333333311e-03*G4_1_1_7_1_7_2 + 8.333333333333311e-03*G4_1_2_4_1_8_2 + 4.166666666666654e-03*G4_1_2_4_1_9_2 + 4.166666666666654e-03*G4_1_2_4_1_10_2 + 4.166666666666657e-03*G4_1_2_4_1_11_2 + 4.166666666666654e-03*G4_1_2_5_1_8_2 + 8.333333333333309e-03*G4_1_2_5_1_9_2 + 4.166666666666656e-03*G4_1_2_5_1_10_2 + 4.166666666666657e-03*G4_1_2_5_1_11_2 + 4.166666666666654e-03*G4_1_2_6_1_8_2 + 4.166666666666656e-03*G4_1_2_6_1_9_2 + 8.333333333333311e-03*G4_1_2_6_1_10_2 + 4.166666666666656e-03*G4_1_2_6_1_11_2 + 4.166666666666657e-03*G4_1_2_7_1_8_2 + 4.166666666666657e-03*G4_1_2_7_1_9_2 + 4.166666666666656e-03*G4_1_2_7_1_10_2 + 8.333333333333311e-03*G4_1_2_7_1_11_2 + 8.333333333333311e-03*G4_2_0_8_1_0_2 + 4.166666666666654e-03*G4_2_0_8_1_1_2 + 4.166666666666654e-03*G4_2_0_8_1_2_2 + 4.166666666666657e-03*G4_2_0_8_1_3_2 + 4.166666666666655e-03*G4_2_0_9_1_0_2 + 8.333333333333309e-03*G4_2_0_9_1_1_2 + 4.166666666666656e-03*G4_2_0_9_1_2_2 + 4.166666666666657e-03*G4_2_0_9_1_3_2 + 4.166666666666656e-03*G4_2_0_10_1_0_2 + 4.166666666666654e-03*G4_2_0_10_1_1_2 + 8.333333333333311e-03*G4_2_0_10_1_2_2 + 4.166666666666656e-03*G4_2_0_10_1_3_2 + 4.166666666666657e-03*G4_2_0_11_1_0_2 + 4.166666666666655e-03*G4_2_0_11_1_1_2 + 4.166666666666656e-03*G4_2_0_11_1_2_2 + 8.333333333333311e-03*G4_2_0_11_1_3_2 + 8.333333333333311e-03*G4_2_1_8_1_4_2 + 4.166666666666654e-03*G4_2_1_8_1_5_2 + 4.166666666666654e-03*G4_2_1_8_1_6_2 + 4.166666666666657e-03*G4_2_1_8_1_7_2 + 4.166666666666654e-03*G4_2_1_9_1_4_2 + 8.333333333333309e-03*G4_2_1_9_1_5_2 + 4.166666666666656e-03*G4_2_1_9_1_6_2 + 4.166666666666657e-03*G4_2_1_9_1_7_2 + 4.166666666666654e-03*G4_2_1_10_1_4_2 + 4.166666666666656e-03*G4_2_1_10_1_5_2 + 8.333333333333311e-03*G4_2_1_10_1_6_2 + 4.166666666666656e-03*G4_2_1_10_1_7_2 + 4.166666666666657e-03*G4_2_1_11_1_4_2 + 4.166666666666657e-03*G4_2_1_11_1_5_2 + 4.166666666666656e-03*G4_2_1_11_1_6_2 + 8.333333333333311e-03*G4_2_1_11_1_7_2 + 8.333333333333311e-03*G4_2_2_8_1_8_2 + 4.166666666666654e-03*G4_2_2_8_1_9_2 + 4.166666666666654e-03*G4_2_2_8_1_10_2 + 4.166666666666657e-03*G4_2_2_8_1_11_2 + 4.166666666666654e-03*G4_2_2_9_1_8_2 + 8.333333333333309e-03*G4_2_2_9_1_9_2 + 4.166666666666656e-03*G4_2_2_9_1_10_2 + 4.166666666666657e-03*G4_2_2_9_1_11_2 + 4.166666666666654e-03*G4_2_2_10_1_8_2 + 4.166666666666656e-03*G4_2_2_10_1_9_2 + 8.333333333333311e-03*G4_2_2_10_1_10_2 + 4.166666666666656e-03*G4_2_2_10_1_11_2 + 4.166666666666657e-03*G4_2_2_11_1_8_2 + 4.166666666666657e-03*G4_2_2_11_1_9_2 + 4.166666666666656e-03*G4_2_2_11_1_10_2 + 8.333333333333311e-03*G4_2_2_11_1_11_2;
    block[132] = -8.333333333333322e-02*G3_2_0_2_0 - 8.333333333333323e-02*G3_2_0_2_1 - 8.333333333333322e-02*G3_2_0_2_2;
    block[133] = 8.333333333333322e-02*G3_2_0_2_0;
    block[134] = 8.333333333333323e-02*G3_2_0_2_1;
    block[135] = 8.333333333333323e-02*G3_2_0_2_2;
    block[136] = -8.333333333333322e-02*G3_2_1_2_0 - 8.333333333333323e-02*G3_2_1_2_1 - 8.333333333333323e-02*G3_2_1_2_2;
    block[137] = 8.333333333333322e-02*G3_2_1_2_0;
    block[138] = 8.333333333333323e-02*G3_2_1_2_1;
    block[139] = 8.333333333333323e-02*G3_2_1_2_2;
    block[140] = 8.333333333333314e-03*G0_ - 8.333333333333322e-02*G1_2_0 - 8.333333333333323e-02*G1_2_1 - 8.333333333333323e-02*G1_2_2 - 4.166666666666656e-03*G2_0_0_0 - 4.166666666666657e-03*G2_0_0_1 - 4.166666666666658e-03*G2_0_0_2 - 4.166666666666655e-03*G2_0_1_0 - 4.166666666666655e-03*G2_0_1_1 - 4.166666666666656e-03*G2_0_1_2 - 4.166666666666655e-03*G2_0_2_0 - 4.166666666666656e-03*G2_0_2_1 - 4.166666666666657e-03*G2_0_2_2 - 8.333333333333311e-03*G2_0_3_0 - 8.333333333333311e-03*G2_0_3_1 - 8.333333333333312e-03*G2_0_3_2 - 4.166666666666656e-03*G2_1_4_0 - 4.166666666666657e-03*G2_1_4_1 - 4.166666666666657e-03*G2_1_4_2 - 4.166666666666656e-03*G2_1_5_0 - 4.166666666666657e-03*G2_1_5_1 - 4.166666666666657e-03*G2_1_5_2 - 4.166666666666655e-03*G2_1_6_0 - 4.166666666666656e-03*G2_1_6_1 - 4.166666666666657e-03*G2_1_6_2 - 8.333333333333311e-03*G2_1_7_0 - 8.333333333333311e-03*G2_1_7_1 - 8.333333333333312e-03*G2_1_7_2 - 4.166666666666656e-03*G2_2_8_0 - 4.166666666666657e-03*G2_2_8_1 - 4.166666666666657e-03*G2_2_8_2 - 4.166666666666656e-03*G2_2_9_0 - 4.166666666666657e-03*G2_2_9_1 - 4.166666666666657e-03*G2_2_9_2 - 4.166666666666655e-03*G2_2_10_0 - 4.166666666666656e-03*G2_2_10_1 - 4.166666666666657e-03*G2_2_10_2 - 8.333333333333311e-03*G2_2_11_0 - 8.333333333333311e-03*G2_2_11_1 - 8.333333333333312e-03*G2_2_11_2 - 8.333333333333322e-02*G3_2_2_2_0 - 8.333333333333323e-02*G3_2_2_2_1 - 8.333333333333323e-02*G3_2_2_2_2 - 8.333333333333309e-03*G4_0_0_0_2_0_0 - 8.333333333333311e-03*G4_0_0_0_2_0_1 - 8.333333333333312e-03*G4_0_0_0_2_0_2 - 4.166666666666654e-03*G4_0_0_0_2_1_0 - 4.166666666666655e-03*G4_0_0_0_2_1_1 - 4.166666666666655e-03*G4_0_0_0_2_1_2 - 4.166666666666654e-03*G4_0_0_0_2_2_0 - 4.166666666666656e-03*G4_0_0_0_2_2_1 - 4.166666666666656e-03*G4_0_0_0_2_2_2 - 4.166666666666656e-03*G4_0_0_0_2_3_0 - 4.166666666666657e-03*G4_0_0_0_2_3_1 - 4.166666666666658e-03*G4_0_0_0_2_3_2 - 4.166666666666654e-03*G4_0_0_1_2_0_0 - 4.166666666666655e-03*G4_0_0_1_2_0_1 - 4.166666666666655e-03*G4_0_0_1_2_0_2 - 8.333333333333307e-03*G4_0_0_1_2_1_0 - 8.333333333333309e-03*G4_0_0_1_2_1_1 - 8.333333333333309e-03*G4_0_0_1_2_1_2 - 4.166666666666654e-03*G4_0_0_1_2_2_0 - 4.166666666666654e-03*G4_0_0_1_2_2_1 - 4.166666666666655e-03*G4_0_0_1_2_2_2 - 4.166666666666655e-03*G4_0_0_1_2_3_0 - 4.166666666666655e-03*G4_0_0_1_2_3_1 - 4.166666666666656e-03*G4_0_0_1_2_3_2 - 4.166666666666654e-03*G4_0_0_2_2_0_0 - 4.166666666666656e-03*G4_0_0_2_2_0_1 - 4.166666666666656e-03*G4_0_0_2_2_0_2 - 4.166666666666654e-03*G4_0_0_2_2_1_0 - 4.166666666666654e-03*G4_0_0_2_2_1_1 - 4.166666666666654e-03*G4_0_0_2_2_1_2 - 8.333333333333311e-03*G4_0_0_2_2_2_0 - 8.333333333333311e-03*G4_0_0_2_2_2_1 - 8.333333333333312e-03*G4_0_0_2_2_2_2 - 4.166666666666655e-03*G4_0_0_2_2_3_0 - 4.166666666666656e-03*G4_0_0_2_2_3_1 - 4.166666666666657e-03*G4_0_0_2_2_3_2 - 4.166666666666656e-03*G4_0_0_3_2_0_0 - 4.166666666666657e-03*G4_0_0_3_2_0_1 - 4.166666666666658e-03*G4_0_0_3_2_0_2 - 4.166666666666655e-03*G4_0_0_3_2_1_0 - 4.166666666666655e-03*G4_0_0_3_2_1_1 - 4.166666666666656e-03*G4_0_0_3_2_1_2 - 4.166666666666655e-03*G4_0_0_3_2_2_0 - 4.166666666666656e-03*G4_0_0_3_2_2_1 - 4.166666666666657e-03*G4_0_0_3_2_2_2 - 8.333333333333311e-03*G4_0_0_3_2_3_0 - 8.333333333333311e-03*G4_0_0_3_2_3_1 - 8.333333333333312e-03*G4_0_0_3_2_3_2 - 8.333333333333309e-03*G4_0_1_0_2_4_0 - 8.333333333333311e-03*G4_0_1_0_2_4_1 - 8.333333333333312e-03*G4_0_1_0_2_4_2 - 4.166666666666655e-03*G4_0_1_0_2_5_0 - 4.166666666666655e-03*G4_0_1_0_2_5_1 - 4.166666666666656e-03*G4_0_1_0_2_5_2 - 4.166666666666654e-03*G4_0_1_0_2_6_0 - 4.166666666666656e-03*G4_0_1_0_2_6_1 - 4.166666666666656e-03*G4_0_1_0_2_6_2 - 4.166666666666656e-03*G4_0_1_0_2_7_0 - 4.166666666666657e-03*G4_0_1_0_2_7_1 - 4.166666666666658e-03*G4_0_1_0_2_7_2 - 4.166666666666654e-03*G4_0_1_1_2_4_0 - 4.166666666666654e-03*G4_0_1_1_2_4_1 - 4.166666666666654e-03*G4_0_1_1_2_4_2 - 8.333333333333309e-03*G4_0_1_1_2_5_0 - 8.333333333333309e-03*G4_0_1_1_2_5_1 - 8.333333333333309e-03*G4_0_1_1_2_5_2 - 4.166666666666654e-03*G4_0_1_1_2_6_0 - 4.166666666666654e-03*G4_0_1_1_2_6_1 - 4.166666666666655e-03*G4_0_1_1_2_6_2 - 4.166666666666655e-03*G4_0_1_1_2_7_0 - 4.166666666666655e-03*G4_0_1_1_2_7_1 - 4.166666666666656e-03*G4_0_1_1_2_7_2 - 4.166666666666654e-03*G4_0_1_2_2_4_0 - 4.166666666666654e-03*G4_0_1_2_2_4_1 - 4.166666666666654e-03*G4_0_1_2_2_4_2 - 4.166666666666655e-03*G4_0_1_2_2_5_0 - 4.166666666666656e-03*G4_0_1_2_2_5_1 - 4.166666666666656e-03*G4_0_1_2_2_5_2 - 8.333333333333311e-03*G4_0_1_2_2_6_0 - 8.333333333333311e-03*G4_0_1_2_2_6_1 - 8.333333333333312e-03*G4_0_1_2_2_6_2 - 4.166666666666655e-03*G4_0_1_2_2_7_0 - 4.166666666666656e-03*G4_0_1_2_2_7_1 - 4.166666666666657e-03*G4_0_1_2_2_7_2 - 4.166666666666656e-03*G4_0_1_3_2_4_0 - 4.166666666666657e-03*G4_0_1_3_2_4_1 - 4.166666666666657e-03*G4_0_1_3_2_4_2 - 4.166666666666656e-03*G4_0_1_3_2_5_0 - 4.166666666666657e-03*G4_0_1_3_2_5_1 - 4.166666666666657e-03*G4_0_1_3_2_5_2 - 4.166666666666655e-03*G4_0_1_3_2_6_0 - 4.166666666666656e-03*G4_0_1_3_2_6_1 - 4.166666666666657e-03*G4_0_1_3_2_6_2 - 8.333333333333311e-03*G4_0_1_3_2_7_0 - 8.333333333333311e-03*G4_0_1_3_2_7_1 - 8.333333333333312e-03*G4_0_1_3_2_7_2 - 8.333333333333309e-03*G4_0_2_0_2_8_0 - 8.333333333333311e-03*G4_0_2_0_2_8_1 - 8.333333333333312e-03*G4_0_2_0_2_8_2 - 4.166666666666655e-03*G4_0_2_0_2_9_0 - 4.166666666666655e-03*G4_0_2_0_2_9_1 - 4.166666666666656e-03*G4_0_2_0_2_9_2 - 4.166666666666654e-03*G4_0_2_0_2_10_0 - 4.166666666666656e-03*G4_0_2_0_2_10_1 - 4.166666666666656e-03*G4_0_2_0_2_10_2 - 4.166666666666656e-03*G4_0_2_0_2_11_0 - 4.166666666666657e-03*G4_0_2_0_2_11_1 - 4.166666666666658e-03*G4_0_2_0_2_11_2 - 4.166666666666654e-03*G4_0_2_1_2_8_0 - 4.166666666666654e-03*G4_0_2_1_2_8_1 - 4.166666666666654e-03*G4_0_2_1_2_8_2 - 8.333333333333309e-03*G4_0_2_1_2_9_0 - 8.333333333333309e-03*G4_0_2_1_2_9_1 - 8.333333333333309e-03*G4_0_2_1_2_9_2 - 4.166666666666654e-03*G4_0_2_1_2_10_0 - 4.166666666666654e-03*G4_0_2_1_2_10_1 - 4.166666666666655e-03*G4_0_2_1_2_10_2 - 4.166666666666655e-03*G4_0_2_1_2_11_0 - 4.166666666666655e-03*G4_0_2_1_2_11_1 - 4.166666666666656e-03*G4_0_2_1_2_11_2 - 4.166666666666654e-03*G4_0_2_2_2_8_0 - 4.166666666666654e-03*G4_0_2_2_2_8_1 - 4.166666666666654e-03*G4_0_2_2_2_8_2 - 4.166666666666655e-03*G4_0_2_2_2_9_0 - 4.166666666666656e-03*G4_0_2_2_2_9_1 - 4.166666666666656e-03*G4_0_2_2_2_9_2 - 8.333333333333311e-03*G4_0_2_2_2_10_0 - 8.333333333333311e-03*G4_0_2_2_2_10_1 - 8.333333333333312e-03*G4_0_2_2_2_10_2 - 4.166666666666655e-03*G4_0_2_2_2_11_0 - 4.166666666666656e-03*G4_0_2_2_2_11_1 - 4.166666666666657e-03*G4_0_2_2_2_11_2 - 4.166666666666656e-03*G4_0_2_3_2_8_0 - 4.166666666666657e-03*G4_0_2_3_2_8_1 - 4.166666666666657e-03*G4_0_2_3_2_8_2 - 4.166666666666656e-03*G4_0_2_3_2_9_0 - 4.166666666666657e-03*G4_0_2_3_2_9_1 - 4.166666666666657e-03*G4_0_2_3_2_9_2 - 4.166666666666655e-03*G4_0_2_3_2_10_0 - 4.166666666666656e-03*G4_0_2_3_2_10_1 - 4.166666666666657e-03*G4_0_2_3_2_10_2 - 8.333333333333311e-03*G4_0_2_3_2_11_0 - 8.333333333333311e-03*G4_0_2_3_2_11_1 - 8.333333333333312e-03*G4_0_2_3_2_11_2 - 8.333333333333309e-03*G4_1_0_4_2_0_0 - 8.333333333333311e-03*G4_1_0_4_2_0_1 - 8.333333333333312e-03*G4_1_0_4_2_0_2 - 4.166666666666654e-03*G4_1_0_4_2_1_0 - 4.166666666666654e-03*G4_1_0_4_2_1_1 - 4.166666666666654e-03*G4_1_0_4_2_1_2 - 4.166666666666654e-03*G4_1_0_4_2_2_0 - 4.166666666666654e-03*G4_1_0_4_2_2_1 - 4.166666666666654e-03*G4_1_0_4_2_2_2 - 4.166666666666656e-03*G4_1_0_4_2_3_0 - 4.166666666666657e-03*G4_1_0_4_2_3_1 - 4.166666666666657e-03*G4_1_0_4_2_3_2 - 4.166666666666655e-03*G4_1_0_5_2_0_0 - 4.166666666666655e-03*G4_1_0_5_2_0_1 - 4.166666666666656e-03*G4_1_0_5_2_0_2 - 8.333333333333309e-03*G4_1_0_5_2_1_0 - 8.333333333333309e-03*G4_1_0_5_2_1_1 - 8.333333333333309e-03*G4_1_0_5_2_1_2 - 4.166666666666655e-03*G4_1_0_5_2_2_0 - 4.166666666666656e-03*G4_1_0_5_2_2_1 - 4.166666666666656e-03*G4_1_0_5_2_2_2 - 4.166666666666656e-03*G4_1_0_5_2_3_0 - 4.166666666666657e-03*G4_1_0_5_2_3_1 - 4.166666666666657e-03*G4_1_0_5_2_3_2 - 4.166666666666654e-03*G4_1_0_6_2_0_0 - 4.166666666666656e-03*G4_1_0_6_2_0_1 - 4.166666666666656e-03*G4_1_0_6_2_0_2 - 4.166666666666654e-03*G4_1_0_6_2_1_0 - 4.166666666666654e-03*G4_1_0_6_2_1_1 - 4.166666666666654e-03*G4_1_0_6_2_1_2 - 8.333333333333311e-03*G4_1_0_6_2_2_0 - 8.333333333333311e-03*G4_1_0_6_2_2_1 - 8.333333333333312e-03*G4_1_0_6_2_2_2 - 4.166666666666655e-03*G4_1_0_6_2_3_0 - 4.166666666666656e-03*G4_1_0_6_2_3_1 - 4.166666666666657e-03*G4_1_0_6_2_3_2 - 4.166666666666656e-03*G4_1_0_7_2_0_0 - 4.166666666666657e-03*G4_1_0_7_2_0_1 - 4.166666666666658e-03*G4_1_0_7_2_0_2 - 4.166666666666655e-03*G4_1_0_7_2_1_0 - 4.166666666666655e-03*G4_1_0_7_2_1_1 - 4.166666666666656e-03*G4_1_0_7_2_1_2 - 4.166666666666655e-03*G4_1_0_7_2_2_0 - 4.166666666666656e-03*G4_1_0_7_2_2_1 - 4.166666666666657e-03*G4_1_0_7_2_2_2 - 8.333333333333311e-03*G4_1_0_7_2_3_0 - 8.333333333333311e-03*G4_1_0_7_2_3_1 - 8.333333333333312e-03*G4_1_0_7_2_3_2 - 8.333333333333309e-03*G4_1_1_4_2_4_0 - 8.333333333333311e-03*G4_1_1_4_2_4_1 - 8.333333333333312e-03*G4_1_1_4_2_4_2 - 4.166666666666654e-03*G4_1_1_4_2_5_0 - 4.166666666666654e-03*G4_1_1_4_2_5_1 - 4.166666666666655e-03*G4_1_1_4_2_5_2 - 4.166666666666654e-03*G4_1_1_4_2_6_0 - 4.166666666666654e-03*G4_1_1_4_2_6_1 - 4.166666666666654e-03*G4_1_1_4_2_6_2 - 4.166666666666656e-03*G4_1_1_4_2_7_0 - 4.166666666666657e-03*G4_1_1_4_2_7_1 - 4.166666666666657e-03*G4_1_1_4_2_7_2 - 4.166666666666654e-03*G4_1_1_5_2_4_0 - 4.166666666666654e-03*G4_1_1_5_2_4_1 - 4.166666666666655e-03*G4_1_1_5_2_4_2 - 8.333333333333309e-03*G4_1_1_5_2_5_0 - 8.333333333333309e-03*G4_1_1_5_2_5_1 - 8.333333333333309e-03*G4_1_1_5_2_5_2 - 4.166666666666655e-03*G4_1_1_5_2_6_0 - 4.166666666666656e-03*G4_1_1_5_2_6_1 - 4.166666666666656e-03*G4_1_1_5_2_6_2 - 4.166666666666656e-03*G4_1_1_5_2_7_0 - 4.166666666666657e-03*G4_1_1_5_2_7_1 - 4.166666666666657e-03*G4_1_1_5_2_7_2 - 4.166666666666654e-03*G4_1_1_6_2_4_0 - 4.166666666666654e-03*G4_1_1_6_2_4_1 - 4.166666666666654e-03*G4_1_1_6_2_4_2 - 4.166666666666655e-03*G4_1_1_6_2_5_0 - 4.166666666666656e-03*G4_1_1_6_2_5_1 - 4.166666666666656e-03*G4_1_1_6_2_5_2 - 8.333333333333311e-03*G4_1_1_6_2_6_0 - 8.333333333333311e-03*G4_1_1_6_2_6_1 - 8.333333333333312e-03*G4_1_1_6_2_6_2 - 4.166666666666655e-03*G4_1_1_6_2_7_0 - 4.166666666666656e-03*G4_1_1_6_2_7_1 - 4.166666666666657e-03*G4_1_1_6_2_7_2 - 4.166666666666656e-03*G4_1_1_7_2_4_0 - 4.166666666666657e-03*G4_1_1_7_2_4_1 - 4.166666666666657e-03*G4_1_1_7_2_4_2 - 4.166666666666656e-03*G4_1_1_7_2_5_0 - 4.166666666666657e-03*G4_1_1_7_2_5_1 - 4.166666666666657e-03*G4_1_1_7_2_5_2 - 4.166666666666655e-03*G4_1_1_7_2_6_0 - 4.166666666666656e-03*G4_1_1_7_2_6_1 - 4.166666666666657e-03*G4_1_1_7_2_6_2 - 8.333333333333311e-03*G4_1_1_7_2_7_0 - 8.333333333333311e-03*G4_1_1_7_2_7_1 - 8.333333333333312e-03*G4_1_1_7_2_7_2 - 8.333333333333309e-03*G4_1_2_4_2_8_0 - 8.333333333333311e-03*G4_1_2_4_2_8_1 - 8.333333333333312e-03*G4_1_2_4_2_8_2 - 4.166666666666654e-03*G4_1_2_4_2_9_0 - 4.166666666666654e-03*G4_1_2_4_2_9_1 - 4.166666666666655e-03*G4_1_2_4_2_9_2 - 4.166666666666654e-03*G4_1_2_4_2_10_0 - 4.166666666666654e-03*G4_1_2_4_2_10_1 - 4.166666666666654e-03*G4_1_2_4_2_10_2 - 4.166666666666656e-03*G4_1_2_4_2_11_0 - 4.166666666666657e-03*G4_1_2_4_2_11_1 - 4.166666666666657e-03*G4_1_2_4_2_11_2 - 4.166666666666654e-03*G4_1_2_5_2_8_0 - 4.166666666666654e-03*G4_1_2_5_2_8_1 - 4.166666666666655e-03*G4_1_2_5_2_8_2 - 8.333333333333309e-03*G4_1_2_5_2_9_0 - 8.333333333333309e-03*G4_1_2_5_2_9_1 - 8.333333333333309e-03*G4_1_2_5_2_9_2 - 4.166666666666655e-03*G4_1_2_5_2_10_0 - 4.166666666666656e-03*G4_1_2_5_2_10_1 - 4.166666666666656e-03*G4_1_2_5_2_10_2 - 4.166666666666656e-03*G4_1_2_5_2_11_0 - 4.166666666666657e-03*G4_1_2_5_2_11_1 - 4.166666666666657e-03*G4_1_2_5_2_11_2 - 4.166666666666654e-03*G4_1_2_6_2_8_0 - 4.166666666666654e-03*G4_1_2_6_2_8_1 - 4.166666666666654e-03*G4_1_2_6_2_8_2 - 4.166666666666655e-03*G4_1_2_6_2_9_0 - 4.166666666666656e-03*G4_1_2_6_2_9_1 - 4.166666666666656e-03*G4_1_2_6_2_9_2 - 8.333333333333311e-03*G4_1_2_6_2_10_0 - 8.333333333333311e-03*G4_1_2_6_2_10_1 - 8.333333333333312e-03*G4_1_2_6_2_10_2 - 4.166666666666655e-03*G4_1_2_6_2_11_0 - 4.166666666666656e-03*G4_1_2_6_2_11_1 - 4.166666666666657e-03*G4_1_2_6_2_11_2 - 4.166666666666656e-03*G4_1_2_7_2_8_0 - 4.166666666666657e-03*G4_1_2_7_2_8_1 - 4.166666666666657e-03*G4_1_2_7_2_8_2 - 4.166666666666656e-03*G4_1_2_7_2_9_0 - 4.166666666666657e-03*G4_1_2_7_2_9_1 - 4.166666666666657e-03*G4_1_2_7_2_9_2 - 4.166666666666655e-03*G4_1_2_7_2_10_0 - 4.166666666666656e-03*G4_1_2_7_2_10_1 - 4.166666666666657e-03*G4_1_2_7_2_10_2 - 8.333333333333311e-03*G4_1_2_7_2_11_0 - 8.333333333333311e-03*G4_1_2_7_2_11_1 - 8.333333333333312e-03*G4_1_2_7_2_11_2 - 8.333333333333309e-03*G4_2_0_8_2_0_0 - 8.333333333333311e-03*G4_2_0_8_2_0_1 - 8.333333333333312e-03*G4_2_0_8_2_0_2 - 4.166666666666654e-03*G4_2_0_8_2_1_0 - 4.166666666666654e-03*G4_2_0_8_2_1_1 - 4.166666666666654e-03*G4_2_0_8_2_1_2 - 4.166666666666654e-03*G4_2_0_8_2_2_0 - 4.166666666666654e-03*G4_2_0_8_2_2_1 - 4.166666666666654e-03*G4_2_0_8_2_2_2 - 4.166666666666656e-03*G4_2_0_8_2_3_0 - 4.166666666666657e-03*G4_2_0_8_2_3_1 - 4.166666666666657e-03*G4_2_0_8_2_3_2 - 4.166666666666655e-03*G4_2_0_9_2_0_0 - 4.166666666666655e-03*G4_2_0_9_2_0_1 - 4.166666666666656e-03*G4_2_0_9_2_0_2 - 8.333333333333309e-03*G4_2_0_9_2_1_0 - 8.333333333333309e-03*G4_2_0_9_2_1_1 - 8.333333333333309e-03*G4_2_0_9_2_1_2 - 4.166666666666655e-03*G4_2_0_9_2_2_0 - 4.166666666666656e-03*G4_2_0_9_2_2_1 - 4.166666666666656e-03*G4_2_0_9_2_2_2 - 4.166666666666656e-03*G4_2_0_9_2_3_0 - 4.166666666666657e-03*G4_2_0_9_2_3_1 - 4.166666666666657e-03*G4_2_0_9_2_3_2 - 4.166666666666654e-03*G4_2_0_10_2_0_0 - 4.166666666666656e-03*G4_2_0_10_2_0_1 - 4.166666666666656e-03*G4_2_0_10_2_0_2 - 4.166666666666654e-03*G4_2_0_10_2_1_0 - 4.166666666666654e-03*G4_2_0_10_2_1_1 - 4.166666666666654e-03*G4_2_0_10_2_1_2 - 8.333333333333311e-03*G4_2_0_10_2_2_0 - 8.333333333333311e-03*G4_2_0_10_2_2_1 - 8.333333333333312e-03*G4_2_0_10_2_2_2 - 4.166666666666655e-03*G4_2_0_10_2_3_0 - 4.166666666666656e-03*G4_2_0_10_2_3_1 - 4.166666666666657e-03*G4_2_0_10_2_3_2 - 4.166666666666656e-03*G4_2_0_11_2_0_0 - 4.166666666666657e-03*G4_2_0_11_2_0_1 - 4.166666666666658e-03*G4_2_0_11_2_0_2 - 4.166666666666655e-03*G4_2_0_11_2_1_0 - 4.166666666666655e-03*G4_2_0_11_2_1_1 - 4.166666666666656e-03*G4_2_0_11_2_1_2 - 4.166666666666655e-03*G4_2_0_11_2_2_0 - 4.166666666666656e-03*G4_2_0_11_2_2_1 - 4.166666666666657e-03*G4_2_0_11_2_2_2 - 8.333333333333311e-03*G4_2_0_11_2_3_0 - 8.333333333333311e-03*G4_2_0_11_2_3_1 - 8.333333333333312e-03*G4_2_0_11_2_3_2 - 8.333333333333309e-03*G4_2_1_8_2_4_0 - 8.333333333333311e-03*G4_2_1_8_2_4_1 - 8.333333333333312e-03*G4_2_1_8_2_4_2 - 4.166666666666654e-03*G4_2_1_8_2_5_0 - 4.166666666666654e-03*G4_2_1_8_2_5_1 - 4.166666666666655e-03*G4_2_1_8_2_5_2 - 4.166666666666654e-03*G4_2_1_8_2_6_0 - 4.166666666666654e-03*G4_2_1_8_2_6_1 - 4.166666666666654e-03*G4_2_1_8_2_6_2 - 4.166666666666656e-03*G4_2_1_8_2_7_0 - 4.166666666666657e-03*G4_2_1_8_2_7_1 - 4.166666666666657e-03*G4_2_1_8_2_7_2 - 4.166666666666654e-03*G4_2_1_9_2_4_0 - 4.166666666666654e-03*G4_2_1_9_2_4_1 - 4.166666666666655e-03*G4_2_1_9_2_4_2 - 8.333333333333309e-03*G4_2_1_9_2_5_0 - 8.333333333333309e-03*G4_2_1_9_2_5_1 - 8.333333333333309e-03*G4_2_1_9_2_5_2 - 4.166666666666655e-03*G4_2_1_9_2_6_0 - 4.166666666666656e-03*G4_2_1_9_2_6_1 - 4.166666666666656e-03*G4_2_1_9_2_6_2 - 4.166666666666656e-03*G4_2_1_9_2_7_0 - 4.166666666666657e-03*G4_2_1_9_2_7_1 - 4.166666666666657e-03*G4_2_1_9_2_7_2 - 4.166666666666654e-03*G4_2_1_10_2_4_0 - 4.166666666666654e-03*G4_2_1_10_2_4_1 - 4.166666666666654e-03*G4_2_1_10_2_4_2 - 4.166666666666655e-03*G4_2_1_10_2_5_0 - 4.166666666666656e-03*G4_2_1_10_2_5_1 - 4.166666666666656e-03*G4_2_1_10_2_5_2 - 8.333333333333311e-03*G4_2_1_10_2_6_0 - 8.333333333333311e-03*G4_2_1_10_2_6_1 - 8.333333333333312e-03*G4_2_1_10_2_6_2 - 4.166666666666655e-03*G4_2_1_10_2_7_0 - 4.166666666666656e-03*G4_2_1_10_2_7_1 - 4.166666666666657e-03*G4_2_1_10_2_7_2 - 4.166666666666656e-03*G4_2_1_11_2_4_0 - 4.166666666666657e-03*G4_2_1_11_2_4_1 - 4.166666666666657e-03*G4_2_1_11_2_4_2 - 4.166666666666656e-03*G4_2_1_11_2_5_0 - 4.166666666666657e-03*G4_2_1_11_2_5_1 - 4.166666666666657e-03*G4_2_1_11_2_5_2 - 4.166666666666655e-03*G4_2_1_11_2_6_0 - 4.166666666666656e-03*G4_2_1_11_2_6_1 - 4.166666666666657e-03*G4_2_1_11_2_6_2 - 8.333333333333311e-03*G4_2_1_11_2_7_0 - 8.333333333333311e-03*G4_2_1_11_2_7_1 - 8.333333333333312e-03*G4_2_1_11_2_7_2 - 8.333333333333309e-03*G4_2_2_8_2_8_0 - 8.333333333333311e-03*G4_2_2_8_2_8_1 - 8.333333333333312e-03*G4_2_2_8_2_8_2 - 4.166666666666654e-03*G4_2_2_8_2_9_0 - 4.166666666666654e-03*G4_2_2_8_2_9_1 - 4.166666666666655e-03*G4_2_2_8_2_9_2 - 4.166666666666654e-03*G4_2_2_8_2_10_0 - 4.166666666666654e-03*G4_2_2_8_2_10_1 - 4.166666666666654e-03*G4_2_2_8_2_10_2 - 4.166666666666656e-03*G4_2_2_8_2_11_0 - 4.166666666666657e-03*G4_2_2_8_2_11_1 - 4.166666666666657e-03*G4_2_2_8_2_11_2 - 4.166666666666654e-03*G4_2_2_9_2_8_0 - 4.166666666666654e-03*G4_2_2_9_2_8_1 - 4.166666666666655e-03*G4_2_2_9_2_8_2 - 8.333333333333309e-03*G4_2_2_9_2_9_0 - 8.333333333333309e-03*G4_2_2_9_2_9_1 - 8.333333333333309e-03*G4_2_2_9_2_9_2 - 4.166666666666655e-03*G4_2_2_9_2_10_0 - 4.166666666666656e-03*G4_2_2_9_2_10_1 - 4.166666666666656e-03*G4_2_2_9_2_10_2 - 4.166666666666656e-03*G4_2_2_9_2_11_0 - 4.166666666666657e-03*G4_2_2_9_2_11_1 - 4.166666666666657e-03*G4_2_2_9_2_11_2 - 4.166666666666654e-03*G4_2_2_10_2_8_0 - 4.166666666666654e-03*G4_2_2_10_2_8_1 - 4.166666666666654e-03*G4_2_2_10_2_8_2 - 4.166666666666655e-03*G4_2_2_10_2_9_0 - 4.166666666666656e-03*G4_2_2_10_2_9_1 - 4.166666666666656e-03*G4_2_2_10_2_9_2 - 8.333333333333311e-03*G4_2_2_10_2_10_0 - 8.333333333333311e-03*G4_2_2_10_2_10_1 - 8.333333333333312e-03*G4_2_2_10_2_10_2 - 4.166666666666655e-03*G4_2_2_10_2_11_0 - 4.166666666666656e-03*G4_2_2_10_2_11_1 - 4.166666666666657e-03*G4_2_2_10_2_11_2 - 4.166666666666656e-03*G4_2_2_11_2_8_0 - 4.166666666666657e-03*G4_2_2_11_2_8_1 - 4.166666666666657e-03*G4_2_2_11_2_8_2 - 4.166666666666656e-03*G4_2_2_11_2_9_0 - 4.166666666666657e-03*G4_2_2_11_2_9_1 - 4.166666666666657e-03*G4_2_2_11_2_9_2 - 4.166666666666655e-03*G4_2_2_11_2_10_0 - 4.166666666666656e-03*G4_2_2_11_2_10_1 - 4.166666666666657e-03*G4_2_2_11_2_10_2 - 8.333333333333311e-03*G4_2_2_11_2_11_0 - 8.333333333333311e-03*G4_2_2_11_2_11_1 - 8.333333333333312e-03*G4_2_2_11_2_11_2;
    block[141] = 8.333333333333314e-03*G0_ + 8.333333333333322e-02*G1_2_0 + 4.166666666666656e-03*G2_0_0_0 + 4.166666666666655e-03*G2_0_1_0 + 4.166666666666655e-03*G2_0_2_0 + 8.333333333333311e-03*G2_0_3_0 + 4.166666666666656e-03*G2_1_4_0 + 4.166666666666656e-03*G2_1_5_0 + 4.166666666666655e-03*G2_1_6_0 + 8.333333333333311e-03*G2_1_7_0 + 4.166666666666656e-03*G2_2_8_0 + 4.166666666666656e-03*G2_2_9_0 + 4.166666666666655e-03*G2_2_10_0 + 8.333333333333311e-03*G2_2_11_0 + 8.333333333333322e-02*G3_2_2_2_0 + 8.333333333333309e-03*G4_0_0_0_2_0_0 + 4.166666666666654e-03*G4_0_0_0_2_1_0 + 4.166666666666654e-03*G4_0_0_0_2_2_0 + 4.166666666666656e-03*G4_0_0_0_2_3_0 + 4.166666666666654e-03*G4_0_0_1_2_0_0 + 8.333333333333307e-03*G4_0_0_1_2_1_0 + 4.166666666666654e-03*G4_0_0_1_2_2_0 + 4.166666666666655e-03*G4_0_0_1_2_3_0 + 4.166666666666654e-03*G4_0_0_2_2_0_0 + 4.166666666666654e-03*G4_0_0_2_2_1_0 + 8.333333333333311e-03*G4_0_0_2_2_2_0 + 4.166666666666655e-03*G4_0_0_2_2_3_0 + 4.166666666666656e-03*G4_0_0_3_2_0_0 + 4.166666666666655e-03*G4_0_0_3_2_1_0 + 4.166666666666655e-03*G4_0_0_3_2_2_0 + 8.333333333333311e-03*G4_0_0_3_2_3_0 + 8.333333333333309e-03*G4_0_1_0_2_4_0 + 4.166666666666655e-03*G4_0_1_0_2_5_0 + 4.166666666666654e-03*G4_0_1_0_2_6_0 + 4.166666666666656e-03*G4_0_1_0_2_7_0 + 4.166666666666654e-03*G4_0_1_1_2_4_0 + 8.333333333333309e-03*G4_0_1_1_2_5_0 + 4.166666666666654e-03*G4_0_1_1_2_6_0 + 4.166666666666655e-03*G4_0_1_1_2_7_0 + 4.166666666666654e-03*G4_0_1_2_2_4_0 + 4.166666666666655e-03*G4_0_1_2_2_5_0 + 8.333333333333311e-03*G4_0_1_2_2_6_0 + 4.166666666666655e-03*G4_0_1_2_2_7_0 + 4.166666666666656e-03*G4_0_1_3_2_4_0 + 4.166666666666656e-03*G4_0_1_3_2_5_0 + 4.166666666666655e-03*G4_0_1_3_2_6_0 + 8.333333333333311e-03*G4_0_1_3_2_7_0 + 8.333333333333309e-03*G4_0_2_0_2_8_0 + 4.166666666666655e-03*G4_0_2_0_2_9_0 + 4.166666666666654e-03*G4_0_2_0_2_10_0 + 4.166666666666656e-03*G4_0_2_0_2_11_0 + 4.166666666666654e-03*G4_0_2_1_2_8_0 + 8.333333333333309e-03*G4_0_2_1_2_9_0 + 4.166666666666654e-03*G4_0_2_1_2_10_0 + 4.166666666666655e-03*G4_0_2_1_2_11_0 + 4.166666666666654e-03*G4_0_2_2_2_8_0 + 4.166666666666655e-03*G4_0_2_2_2_9_0 + 8.333333333333311e-03*G4_0_2_2_2_10_0 + 4.166666666666655e-03*G4_0_2_2_2_11_0 + 4.166666666666656e-03*G4_0_2_3_2_8_0 + 4.166666666666656e-03*G4_0_2_3_2_9_0 + 4.166666666666655e-03*G4_0_2_3_2_10_0 + 8.333333333333311e-03*G4_0_2_3_2_11_0 + 8.333333333333309e-03*G4_1_0_4_2_0_0 + 4.166666666666654e-03*G4_1_0_4_2_1_0 + 4.166666666666654e-03*G4_1_0_4_2_2_0 + 4.166666666666656e-03*G4_1_0_4_2_3_0 + 4.166666666666655e-03*G4_1_0_5_2_0_0 + 8.333333333333309e-03*G4_1_0_5_2_1_0 + 4.166666666666655e-03*G4_1_0_5_2_2_0 + 4.166666666666656e-03*G4_1_0_5_2_3_0 + 4.166666666666654e-03*G4_1_0_6_2_0_0 + 4.166666666666654e-03*G4_1_0_6_2_1_0 + 8.333333333333311e-03*G4_1_0_6_2_2_0 + 4.166666666666655e-03*G4_1_0_6_2_3_0 + 4.166666666666656e-03*G4_1_0_7_2_0_0 + 4.166666666666655e-03*G4_1_0_7_2_1_0 + 4.166666666666655e-03*G4_1_0_7_2_2_0 + 8.333333333333311e-03*G4_1_0_7_2_3_0 + 8.333333333333309e-03*G4_1_1_4_2_4_0 + 4.166666666666654e-03*G4_1_1_4_2_5_0 + 4.166666666666654e-03*G4_1_1_4_2_6_0 + 4.166666666666656e-03*G4_1_1_4_2_7_0 + 4.166666666666654e-03*G4_1_1_5_2_4_0 + 8.333333333333309e-03*G4_1_1_5_2_5_0 + 4.166666666666655e-03*G4_1_1_5_2_6_0 + 4.166666666666656e-03*G4_1_1_5_2_7_0 + 4.166666666666654e-03*G4_1_1_6_2_4_0 + 4.166666666666655e-03*G4_1_1_6_2_5_0 + 8.333333333333311e-03*G4_1_1_6_2_6_0 + 4.166666666666655e-03*G4_1_1_6_2_7_0 + 4.166666666666656e-03*G4_1_1_7_2_4_0 + 4.166666666666656e-03*G4_1_1_7_2_5_0 + 4.166666666666655e-03*G4_1_1_7_2_6_0 + 8.333333333333311e-03*G4_1_1_7_2_7_0 + 8.333333333333309e-03*G4_1_2_4_2_8_0 + 4.166666666666654e-03*G4_1_2_4_2_9_0 + 4.166666666666654e-03*G4_1_2_4_2_10_0 + 4.166666666666656e-03*G4_1_2_4_2_11_0 + 4.166666666666654e-03*G4_1_2_5_2_8_0 + 8.333333333333309e-03*G4_1_2_5_2_9_0 + 4.166666666666655e-03*G4_1_2_5_2_10_0 + 4.166666666666656e-03*G4_1_2_5_2_11_0 + 4.166666666666654e-03*G4_1_2_6_2_8_0 + 4.166666666666655e-03*G4_1_2_6_2_9_0 + 8.333333333333311e-03*G4_1_2_6_2_10_0 + 4.166666666666655e-03*G4_1_2_6_2_11_0 + 4.166666666666656e-03*G4_1_2_7_2_8_0 + 4.166666666666656e-03*G4_1_2_7_2_9_0 + 4.166666666666655e-03*G4_1_2_7_2_10_0 + 8.333333333333311e-03*G4_1_2_7_2_11_0 + 8.333333333333309e-03*G4_2_0_8_2_0_0 + 4.166666666666654e-03*G4_2_0_8_2_1_0 + 4.166666666666654e-03*G4_2_0_8_2_2_0 + 4.166666666666656e-03*G4_2_0_8_2_3_0 + 4.166666666666655e-03*G4_2_0_9_2_0_0 + 8.333333333333309e-03*G4_2_0_9_2_1_0 + 4.166666666666655e-03*G4_2_0_9_2_2_0 + 4.166666666666656e-03*G4_2_0_9_2_3_0 + 4.166666666666654e-03*G4_2_0_10_2_0_0 + 4.166666666666654e-03*G4_2_0_10_2_1_0 + 8.333333333333311e-03*G4_2_0_10_2_2_0 + 4.166666666666655e-03*G4_2_0_10_2_3_0 + 4.166666666666656e-03*G4_2_0_11_2_0_0 + 4.166666666666655e-03*G4_2_0_11_2_1_0 + 4.166666666666655e-03*G4_2_0_11_2_2_0 + 8.333333333333311e-03*G4_2_0_11_2_3_0 + 8.333333333333309e-03*G4_2_1_8_2_4_0 + 4.166666666666654e-03*G4_2_1_8_2_5_0 + 4.166666666666654e-03*G4_2_1_8_2_6_0 + 4.166666666666656e-03*G4_2_1_8_2_7_0 + 4.166666666666654e-03*G4_2_1_9_2_4_0 + 8.333333333333309e-03*G4_2_1_9_2_5_0 + 4.166666666666655e-03*G4_2_1_9_2_6_0 + 4.166666666666656e-03*G4_2_1_9_2_7_0 + 4.166666666666654e-03*G4_2_1_10_2_4_0 + 4.166666666666655e-03*G4_2_1_10_2_5_0 + 8.333333333333311e-03*G4_2_1_10_2_6_0 + 4.166666666666655e-03*G4_2_1_10_2_7_0 + 4.166666666666656e-03*G4_2_1_11_2_4_0 + 4.166666666666656e-03*G4_2_1_11_2_5_0 + 4.166666666666655e-03*G4_2_1_11_2_6_0 + 8.333333333333311e-03*G4_2_1_11_2_7_0 + 8.333333333333309e-03*G4_2_2_8_2_8_0 + 4.166666666666654e-03*G4_2_2_8_2_9_0 + 4.166666666666654e-03*G4_2_2_8_2_10_0 + 4.166666666666656e-03*G4_2_2_8_2_11_0 + 4.166666666666654e-03*G4_2_2_9_2_8_0 + 8.333333333333309e-03*G4_2_2_9_2_9_0 + 4.166666666666655e-03*G4_2_2_9_2_10_0 + 4.166666666666656e-03*G4_2_2_9_2_11_0 + 4.166666666666654e-03*G4_2_2_10_2_8_0 + 4.166666666666655e-03*G4_2_2_10_2_9_0 + 8.333333333333311e-03*G4_2_2_10_2_10_0 + 4.166666666666655e-03*G4_2_2_10_2_11_0 + 4.166666666666656e-03*G4_2_2_11_2_8_0 + 4.166666666666656e-03*G4_2_2_11_2_9_0 + 4.166666666666655e-03*G4_2_2_11_2_10_0 + 8.333333333333311e-03*G4_2_2_11_2_11_0;
    block[142] = 8.333333333333312e-03*G0_ + 8.333333333333323e-02*G1_2_1 + 4.166666666666657e-03*G2_0_0_1 + 4.166666666666655e-03*G2_0_1_1 + 4.166666666666656e-03*G2_0_2_1 + 8.333333333333311e-03*G2_0_3_1 + 4.166666666666657e-03*G2_1_4_1 + 4.166666666666657e-03*G2_1_5_1 + 4.166666666666656e-03*G2_1_6_1 + 8.333333333333311e-03*G2_1_7_1 + 4.166666666666657e-03*G2_2_8_1 + 4.166666666666657e-03*G2_2_9_1 + 4.166666666666656e-03*G2_2_10_1 + 8.333333333333311e-03*G2_2_11_1 + 8.333333333333323e-02*G3_2_2_2_1 + 8.333333333333311e-03*G4_0_0_0_2_0_1 + 4.166666666666655e-03*G4_0_0_0_2_1_1 + 4.166666666666656e-03*G4_0_0_0_2_2_1 + 4.166666666666657e-03*G4_0_0_0_2_3_1 + 4.166666666666655e-03*G4_0_0_1_2_0_1 + 8.333333333333309e-03*G4_0_0_1_2_1_1 + 4.166666666666654e-03*G4_0_0_1_2_2_1 + 4.166666666666655e-03*G4_0_0_1_2_3_1 + 4.166666666666656e-03*G4_0_0_2_2_0_1 + 4.166666666666654e-03*G4_0_0_2_2_1_1 + 8.333333333333311e-03*G4_0_0_2_2_2_1 + 4.166666666666656e-03*G4_0_0_2_2_3_1 + 4.166666666666657e-03*G4_0_0_3_2_0_1 + 4.166666666666655e-03*G4_0_0_3_2_1_1 + 4.166666666666656e-03*G4_0_0_3_2_2_1 + 8.333333333333311e-03*G4_0_0_3_2_3_1 + 8.333333333333311e-03*G4_0_1_0_2_4_1 + 4.166666666666655e-03*G4_0_1_0_2_5_1 + 4.166666666666656e-03*G4_0_1_0_2_6_1 + 4.166666666666657e-03*G4_0_1_0_2_7_1 + 4.166666666666654e-03*G4_0_1_1_2_4_1 + 8.333333333333309e-03*G4_0_1_1_2_5_1 + 4.166666666666654e-03*G4_0_1_1_2_6_1 + 4.166666666666655e-03*G4_0_1_1_2_7_1 + 4.166666666666654e-03*G4_0_1_2_2_4_1 + 4.166666666666656e-03*G4_0_1_2_2_5_1 + 8.333333333333311e-03*G4_0_1_2_2_6_1 + 4.166666666666656e-03*G4_0_1_2_2_7_1 + 4.166666666666657e-03*G4_0_1_3_2_4_1 + 4.166666666666657e-03*G4_0_1_3_2_5_1 + 4.166666666666656e-03*G4_0_1_3_2_6_1 + 8.333333333333311e-03*G4_0_1_3_2_7_1 + 8.333333333333311e-03*G4_0_2_0_2_8_1 + 4.166666666666655e-03*G4_0_2_0_2_9_1 + 4.166666666666656e-03*G4_0_2_0_2_10_1 + 4.166666666666657e-03*G4_0_2_0_2_11_1 + 4.166666666666654e-03*G4_0_2_1_2_8_1 + 8.333333333333309e-03*G4_0_2_1_2_9_1 + 4.166666666666654e-03*G4_0_2_1_2_10_1 + 4.166666666666655e-03*G4_0_2_1_2_11_1 + 4.166666666666654e-03*G4_0_2_2_2_8_1 + 4.166666666666656e-03*G4_0_2_2_2_9_1 + 8.333333333333311e-03*G4_0_2_2_2_10_1 + 4.166666666666656e-03*G4_0_2_2_2_11_1 + 4.166666666666657e-03*G4_0_2_3_2_8_1 + 4.166666666666657e-03*G4_0_2_3_2_9_1 + 4.166666666666656e-03*G4_0_2_3_2_10_1 + 8.333333333333311e-03*G4_0_2_3_2_11_1 + 8.333333333333311e-03*G4_1_0_4_2_0_1 + 4.166666666666654e-03*G4_1_0_4_2_1_1 + 4.166666666666654e-03*G4_1_0_4_2_2_1 + 4.166666666666657e-03*G4_1_0_4_2_3_1 + 4.166666666666655e-03*G4_1_0_5_2_0_1 + 8.333333333333309e-03*G4_1_0_5_2_1_1 + 4.166666666666656e-03*G4_1_0_5_2_2_1 + 4.166666666666657e-03*G4_1_0_5_2_3_1 + 4.166666666666656e-03*G4_1_0_6_2_0_1 + 4.166666666666654e-03*G4_1_0_6_2_1_1 + 8.333333333333311e-03*G4_1_0_6_2_2_1 + 4.166666666666656e-03*G4_1_0_6_2_3_1 + 4.166666666666657e-03*G4_1_0_7_2_0_1 + 4.166666666666655e-03*G4_1_0_7_2_1_1 + 4.166666666666656e-03*G4_1_0_7_2_2_1 + 8.333333333333311e-03*G4_1_0_7_2_3_1 + 8.333333333333311e-03*G4_1_1_4_2_4_1 + 4.166666666666654e-03*G4_1_1_4_2_5_1 + 4.166666666666654e-03*G4_1_1_4_2_6_1 + 4.166666666666657e-03*G4_1_1_4_2_7_1 + 4.166666666666654e-03*G4_1_1_5_2_4_1 + 8.333333333333309e-03*G4_1_1_5_2_5_1 + 4.166666666666656e-03*G4_1_1_5_2_6_1 + 4.166666666666657e-03*G4_1_1_5_2_7_1 + 4.166666666666654e-03*G4_1_1_6_2_4_1 + 4.166666666666656e-03*G4_1_1_6_2_5_1 + 8.333333333333311e-03*G4_1_1_6_2_6_1 + 4.166666666666656e-03*G4_1_1_6_2_7_1 + 4.166666666666657e-03*G4_1_1_7_2_4_1 + 4.166666666666657e-03*G4_1_1_7_2_5_1 + 4.166666666666656e-03*G4_1_1_7_2_6_1 + 8.333333333333311e-03*G4_1_1_7_2_7_1 + 8.333333333333311e-03*G4_1_2_4_2_8_1 + 4.166666666666654e-03*G4_1_2_4_2_9_1 + 4.166666666666654e-03*G4_1_2_4_2_10_1 + 4.166666666666657e-03*G4_1_2_4_2_11_1 + 4.166666666666654e-03*G4_1_2_5_2_8_1 + 8.333333333333309e-03*G4_1_2_5_2_9_1 + 4.166666666666656e-03*G4_1_2_5_2_10_1 + 4.166666666666657e-03*G4_1_2_5_2_11_1 + 4.166666666666654e-03*G4_1_2_6_2_8_1 + 4.166666666666656e-03*G4_1_2_6_2_9_1 + 8.333333333333311e-03*G4_1_2_6_2_10_1 + 4.166666666666656e-03*G4_1_2_6_2_11_1 + 4.166666666666657e-03*G4_1_2_7_2_8_1 + 4.166666666666657e-03*G4_1_2_7_2_9_1 + 4.166666666666656e-03*G4_1_2_7_2_10_1 + 8.333333333333311e-03*G4_1_2_7_2_11_1 + 8.333333333333311e-03*G4_2_0_8_2_0_1 + 4.166666666666654e-03*G4_2_0_8_2_1_1 + 4.166666666666654e-03*G4_2_0_8_2_2_1 + 4.166666666666657e-03*G4_2_0_8_2_3_1 + 4.166666666666655e-03*G4_2_0_9_2_0_1 + 8.333333333333309e-03*G4_2_0_9_2_1_1 + 4.166666666666656e-03*G4_2_0_9_2_2_1 + 4.166666666666657e-03*G4_2_0_9_2_3_1 + 4.166666666666656e-03*G4_2_0_10_2_0_1 + 4.166666666666654e-03*G4_2_0_10_2_1_1 + 8.333333333333311e-03*G4_2_0_10_2_2_1 + 4.166666666666656e-03*G4_2_0_10_2_3_1 + 4.166666666666657e-03*G4_2_0_11_2_0_1 + 4.166666666666655e-03*G4_2_0_11_2_1_1 + 4.166666666666656e-03*G4_2_0_11_2_2_1 + 8.333333333333311e-03*G4_2_0_11_2_3_1 + 8.333333333333311e-03*G4_2_1_8_2_4_1 + 4.166666666666654e-03*G4_2_1_8_2_5_1 + 4.166666666666654e-03*G4_2_1_8_2_6_1 + 4.166666666666657e-03*G4_2_1_8_2_7_1 + 4.166666666666654e-03*G4_2_1_9_2_4_1 + 8.333333333333309e-03*G4_2_1_9_2_5_1 + 4.166666666666656e-03*G4_2_1_9_2_6_1 + 4.166666666666657e-03*G4_2_1_9_2_7_1 + 4.166666666666654e-03*G4_2_1_10_2_4_1 + 4.166666666666656e-03*G4_2_1_10_2_5_1 + 8.333333333333311e-03*G4_2_1_10_2_6_1 + 4.166666666666656e-03*G4_2_1_10_2_7_1 + 4.166666666666657e-03*G4_2_1_11_2_4_1 + 4.166666666666657e-03*G4_2_1_11_2_5_1 + 4.166666666666656e-03*G4_2_1_11_2_6_1 + 8.333333333333311e-03*G4_2_1_11_2_7_1 + 8.333333333333311e-03*G4_2_2_8_2_8_1 + 4.166666666666654e-03*G4_2_2_8_2_9_1 + 4.166666666666654e-03*G4_2_2_8_2_10_1 + 4.166666666666657e-03*G4_2_2_8_2_11_1 + 4.166666666666654e-03*G4_2_2_9_2_8_1 + 8.333333333333309e-03*G4_2_2_9_2_9_1 + 4.166666666666656e-03*G4_2_2_9_2_10_1 + 4.166666666666657e-03*G4_2_2_9_2_11_1 + 4.166666666666654e-03*G4_2_2_10_2_8_1 + 4.166666666666656e-03*G4_2_2_10_2_9_1 + 8.333333333333311e-03*G4_2_2_10_2_10_1 + 4.166666666666656e-03*G4_2_2_10_2_11_1 + 4.166666666666657e-03*G4_2_2_11_2_8_1 + 4.166666666666657e-03*G4_2_2_11_2_9_1 + 4.166666666666656e-03*G4_2_2_11_2_10_1 + 8.333333333333311e-03*G4_2_2_11_2_11_1;
    block[143] = 1.666666666666662e-02*G0_ + 8.333333333333323e-02*G1_2_2 + 4.166666666666657e-03*G2_0_0_2 + 4.166666666666655e-03*G2_0_1_2 + 4.166666666666656e-03*G2_0_2_2 + 8.333333333333311e-03*G2_0_3_2 + 4.166666666666657e-03*G2_1_4_2 + 4.166666666666657e-03*G2_1_5_2 + 4.166666666666656e-03*G2_1_6_2 + 8.333333333333311e-03*G2_1_7_2 + 4.166666666666657e-03*G2_2_8_2 + 4.166666666666657e-03*G2_2_9_2 + 4.166666666666656e-03*G2_2_10_2 + 8.333333333333311e-03*G2_2_11_2 + 8.333333333333323e-02*G3_2_2_2_2 + 8.333333333333311e-03*G4_0_0_0_2_0_2 + 4.166666666666655e-03*G4_0_0_0_2_1_2 + 4.166666666666656e-03*G4_0_0_0_2_2_2 + 4.166666666666657e-03*G4_0_0_0_2_3_2 + 4.166666666666655e-03*G4_0_0_1_2_0_2 + 8.333333333333309e-03*G4_0_0_1_2_1_2 + 4.166666666666654e-03*G4_0_0_1_2_2_2 + 4.166666666666655e-03*G4_0_0_1_2_3_2 + 4.166666666666656e-03*G4_0_0_2_2_0_2 + 4.166666666666654e-03*G4_0_0_2_2_1_2 + 8.333333333333311e-03*G4_0_0_2_2_2_2 + 4.166666666666656e-03*G4_0_0_2_2_3_2 + 4.166666666666657e-03*G4_0_0_3_2_0_2 + 4.166666666666655e-03*G4_0_0_3_2_1_2 + 4.166666666666656e-03*G4_0_0_3_2_2_2 + 8.333333333333311e-03*G4_0_0_3_2_3_2 + 8.333333333333311e-03*G4_0_1_0_2_4_2 + 4.166666666666655e-03*G4_0_1_0_2_5_2 + 4.166666666666656e-03*G4_0_1_0_2_6_2 + 4.166666666666657e-03*G4_0_1_0_2_7_2 + 4.166666666666654e-03*G4_0_1_1_2_4_2 + 8.333333333333309e-03*G4_0_1_1_2_5_2 + 4.166666666666654e-03*G4_0_1_1_2_6_2 + 4.166666666666655e-03*G4_0_1_1_2_7_2 + 4.166666666666654e-03*G4_0_1_2_2_4_2 + 4.166666666666656e-03*G4_0_1_2_2_5_2 + 8.333333333333311e-03*G4_0_1_2_2_6_2 + 4.166666666666656e-03*G4_0_1_2_2_7_2 + 4.166666666666657e-03*G4_0_1_3_2_4_2 + 4.166666666666657e-03*G4_0_1_3_2_5_2 + 4.166666666666656e-03*G4_0_1_3_2_6_2 + 8.333333333333311e-03*G4_0_1_3_2_7_2 + 8.333333333333311e-03*G4_0_2_0_2_8_2 + 4.166666666666655e-03*G4_0_2_0_2_9_2 + 4.166666666666656e-03*G4_0_2_0_2_10_2 + 4.166666666666657e-03*G4_0_2_0_2_11_2 + 4.166666666666654e-03*G4_0_2_1_2_8_2 + 8.333333333333309e-03*G4_0_2_1_2_9_2 + 4.166666666666654e-03*G4_0_2_1_2_10_2 + 4.166666666666655e-03*G4_0_2_1_2_11_2 + 4.166666666666654e-03*G4_0_2_2_2_8_2 + 4.166666666666656e-03*G4_0_2_2_2_9_2 + 8.333333333333311e-03*G4_0_2_2_2_10_2 + 4.166666666666656e-03*G4_0_2_2_2_11_2 + 4.166666666666657e-03*G4_0_2_3_2_8_2 + 4.166666666666657e-03*G4_0_2_3_2_9_2 + 4.166666666666656e-03*G4_0_2_3_2_10_2 + 8.333333333333311e-03*G4_0_2_3_2_11_2 + 8.333333333333311e-03*G4_1_0_4_2_0_2 + 4.166666666666654e-03*G4_1_0_4_2_1_2 + 4.166666666666654e-03*G4_1_0_4_2_2_2 + 4.166666666666657e-03*G4_1_0_4_2_3_2 + 4.166666666666655e-03*G4_1_0_5_2_0_2 + 8.333333333333309e-03*G4_1_0_5_2_1_2 + 4.166666666666656e-03*G4_1_0_5_2_2_2 + 4.166666666666657e-03*G4_1_0_5_2_3_2 + 4.166666666666656e-03*G4_1_0_6_2_0_2 + 4.166666666666654e-03*G4_1_0_6_2_1_2 + 8.333333333333311e-03*G4_1_0_6_2_2_2 + 4.166666666666656e-03*G4_1_0_6_2_3_2 + 4.166666666666657e-03*G4_1_0_7_2_0_2 + 4.166666666666655e-03*G4_1_0_7_2_1_2 + 4.166666666666656e-03*G4_1_0_7_2_2_2 + 8.333333333333311e-03*G4_1_0_7_2_3_2 + 8.333333333333311e-03*G4_1_1_4_2_4_2 + 4.166666666666654e-03*G4_1_1_4_2_5_2 + 4.166666666666654e-03*G4_1_1_4_2_6_2 + 4.166666666666657e-03*G4_1_1_4_2_7_2 + 4.166666666666654e-03*G4_1_1_5_2_4_2 + 8.333333333333309e-03*G4_1_1_5_2_5_2 + 4.166666666666656e-03*G4_1_1_5_2_6_2 + 4.166666666666657e-03*G4_1_1_5_2_7_2 + 4.166666666666654e-03*G4_1_1_6_2_4_2 + 4.166666666666656e-03*G4_1_1_6_2_5_2 + 8.333333333333311e-03*G4_1_1_6_2_6_2 + 4.166666666666656e-03*G4_1_1_6_2_7_2 + 4.166666666666657e-03*G4_1_1_7_2_4_2 + 4.166666666666657e-03*G4_1_1_7_2_5_2 + 4.166666666666656e-03*G4_1_1_7_2_6_2 + 8.333333333333311e-03*G4_1_1_7_2_7_2 + 8.333333333333311e-03*G4_1_2_4_2_8_2 + 4.166666666666654e-03*G4_1_2_4_2_9_2 + 4.166666666666654e-03*G4_1_2_4_2_10_2 + 4.166666666666657e-03*G4_1_2_4_2_11_2 + 4.166666666666654e-03*G4_1_2_5_2_8_2 + 8.333333333333309e-03*G4_1_2_5_2_9_2 + 4.166666666666656e-03*G4_1_2_5_2_10_2 + 4.166666666666657e-03*G4_1_2_5_2_11_2 + 4.166666666666654e-03*G4_1_2_6_2_8_2 + 4.166666666666656e-03*G4_1_2_6_2_9_2 + 8.333333333333311e-03*G4_1_2_6_2_10_2 + 4.166666666666656e-03*G4_1_2_6_2_11_2 + 4.166666666666657e-03*G4_1_2_7_2_8_2 + 4.166666666666657e-03*G4_1_2_7_2_9_2 + 4.166666666666656e-03*G4_1_2_7_2_10_2 + 8.333333333333311e-03*G4_1_2_7_2_11_2 + 8.333333333333311e-03*G4_2_0_8_2_0_2 + 4.166666666666654e-03*G4_2_0_8_2_1_2 + 4.166666666666654e-03*G4_2_0_8_2_2_2 + 4.166666666666657e-03*G4_2_0_8_2_3_2 + 4.166666666666655e-03*G4_2_0_9_2_0_2 + 8.333333333333309e-03*G4_2_0_9_2_1_2 + 4.166666666666656e-03*G4_2_0_9_2_2_2 + 4.166666666666657e-03*G4_2_0_9_2_3_2 + 4.166666666666656e-03*G4_2_0_10_2_0_2 + 4.166666666666654e-03*G4_2_0_10_2_1_2 + 8.333333333333311e-03*G4_2_0_10_2_2_2 + 4.166666666666656e-03*G4_2_0_10_2_3_2 + 4.166666666666657e-03*G4_2_0_11_2_0_2 + 4.166666666666655e-03*G4_2_0_11_2_1_2 + 4.166666666666656e-03*G4_2_0_11_2_2_2 + 8.333333333333311e-03*G4_2_0_11_2_3_2 + 8.333333333333311e-03*G4_2_1_8_2_4_2 + 4.166666666666654e-03*G4_2_1_8_2_5_2 + 4.166666666666654e-03*G4_2_1_8_2_6_2 + 4.166666666666657e-03*G4_2_1_8_2_7_2 + 4.166666666666654e-03*G4_2_1_9_2_4_2 + 8.333333333333309e-03*G4_2_1_9_2_5_2 + 4.166666666666656e-03*G4_2_1_9_2_6_2 + 4.166666666666657e-03*G4_2_1_9_2_7_2 + 4.166666666666654e-03*G4_2_1_10_2_4_2 + 4.166666666666656e-03*G4_2_1_10_2_5_2 + 8.333333333333311e-03*G4_2_1_10_2_6_2 + 4.166666666666656e-03*G4_2_1_10_2_7_2 + 4.166666666666657e-03*G4_2_1_11_2_4_2 + 4.166666666666657e-03*G4_2_1_11_2_5_2 + 4.166666666666656e-03*G4_2_1_11_2_6_2 + 8.333333333333311e-03*G4_2_1_11_2_7_2 + 8.333333333333311e-03*G4_2_2_8_2_8_2 + 4.166666666666654e-03*G4_2_2_8_2_9_2 + 4.166666666666654e-03*G4_2_2_8_2_10_2 + 4.166666666666657e-03*G4_2_2_8_2_11_2 + 4.166666666666654e-03*G4_2_2_9_2_8_2 + 8.333333333333309e-03*G4_2_2_9_2_9_2 + 4.166666666666656e-03*G4_2_2_9_2_10_2 + 4.166666666666657e-03*G4_2_2_9_2_11_2 + 4.166666666666654e-03*G4_2_2_10_2_8_2 + 4.166666666666656e-03*G4_2_2_10_2_9_2 + 8.333333333333311e-03*G4_2_2_10_2_10_2 + 4.166666666666656e-03*G4_2_2_10_2_11_2 + 4.166666666666657e-03*G4_2_2_11_2_8_2 + 4.166666666666657e-03*G4_2_2_11_2_9_2 + 4.166666666666656e-03*G4_2_2_11_2_10_2 + 8.333333333333311e-03*G4_2_2_11_2_11_2;

    return true;
  }
        
private:

  const real& c0;  const real& c1;  const real& c2;

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class LinearForm : public dolfin::LinearForm
{
public:

  class TestElement : public dolfin::FiniteElement
  {
  public:

    TestElement() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~TestElement()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_0 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_0() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_0()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_1 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_1() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_1()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_2 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_2() : dolfin::FiniteElement(), tensordims(0)
    {
      tensordims = new unsigned int [1];
      tensordims[0] = 3;
    }

    ~FunctionElement_2()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 12;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_assert(i < 1);
      return tensordims[i];
    }

    inline unsigned int rank() const
    {
      return 1;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i % 4).coord();
    }

  private:

    unsigned int* tensordims;

  };

  class FunctionElement_3 : public dolfin::FiniteElement
  {
  public:

    FunctionElement_3() : dolfin::FiniteElement(), tensordims(0)
    {
      // Do nothing
    }

    ~FunctionElement_3()
    {
      if ( tensordims ) delete [] tensordims;
    }

    inline unsigned int spacedim() const
    {
      return 4;
    }

    inline unsigned int shapedim() const
    {
      return 3;
    }

    inline unsigned int tensordim(unsigned int i) const
    {
      dolfin_error("Element is scalar.");
      return 0;
    }

    inline unsigned int rank() const
    {
      return 0;
    }

    // FIXME: Only works for nodal basis
    inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.nodeID(i);
    }

    // FIXME: Only works for nodal basis
    inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
    {
      return cell.node(i).coord();
    }

  private:

    unsigned int* tensordims;

  };

  LinearForm(Function& w0, Function& w1, Function& w2, Function& w3, const real& c0, const real& c1, const real& c2) : dolfin::LinearForm(4), c0(c0), c1(c1), c2(c2)
  {
    // Create finite element for test space
    _test = new TestElement();
        
    // Add functions
    add(w0, new FunctionElement_0());
    add(w1, new FunctionElement_1());
    add(w2, new FunctionElement_2());
    add(w3, new FunctionElement_3());
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_0 = det*w[1][0];
    real G0_1 = det*w[1][1];
    real G0_2 = det*w[1][2];
    real G0_3 = det*w[1][3];
    real G0_4 = det*w[1][4];
    real G0_5 = det*w[1][5];
    real G0_6 = det*w[1][6];
    real G0_7 = det*w[1][7];
    real G0_8 = det*w[1][8];
    real G0_9 = det*w[1][9];
    real G0_10 = det*w[1][10];
    real G0_11 = det*w[1][11];
    real G1_0 = det*c0*w[2][0];
    real G1_1 = det*c0*w[2][1];
    real G1_2 = det*c0*w[2][2];
    real G1_3 = det*c0*w[2][3];
    real G1_4 = det*c0*w[2][4];
    real G1_5 = det*c0*w[2][5];
    real G1_6 = det*c0*w[2][6];
    real G1_7 = det*c0*w[2][7];
    real G1_8 = det*c0*w[2][8];
    real G1_9 = det*c0*w[2][9];
    real G1_10 = det*c0*w[2][10];
    real G1_11 = det*c0*w[2][11];
    real G2_0_0_0 = det*c0*w[3][0]*g00;
    real G2_0_0_1 = det*c0*w[3][1]*g00;
    real G2_0_0_2 = det*c0*w[3][2]*g00;
    real G2_0_0_3 = det*c0*w[3][3]*g00;
    real G2_0_1_0 = det*c0*w[3][0]*g10;
    real G2_0_1_1 = det*c0*w[3][1]*g10;
    real G2_0_1_2 = det*c0*w[3][2]*g10;
    real G2_0_1_3 = det*c0*w[3][3]*g10;
    real G2_0_2_0 = det*c0*w[3][0]*g20;
    real G2_0_2_1 = det*c0*w[3][1]*g20;
    real G2_0_2_2 = det*c0*w[3][2]*g20;
    real G2_0_2_3 = det*c0*w[3][3]*g20;
    real G2_1_0_0 = det*c0*w[3][0]*g01;
    real G2_1_0_1 = det*c0*w[3][1]*g01;
    real G2_1_0_2 = det*c0*w[3][2]*g01;
    real G2_1_0_3 = det*c0*w[3][3]*g01;
    real G2_1_1_0 = det*c0*w[3][0]*g11;
    real G2_1_1_1 = det*c0*w[3][1]*g11;
    real G2_1_1_2 = det*c0*w[3][2]*g11;
    real G2_1_1_3 = det*c0*w[3][3]*g11;
    real G2_1_2_0 = det*c0*w[3][0]*g21;
    real G2_1_2_1 = det*c0*w[3][1]*g21;
    real G2_1_2_2 = det*c0*w[3][2]*g21;
    real G2_1_2_3 = det*c0*w[3][3]*g21;
    real G2_2_0_0 = det*c0*w[3][0]*g02;
    real G2_2_0_1 = det*c0*w[3][1]*g02;
    real G2_2_0_2 = det*c0*w[3][2]*g02;
    real G2_2_0_3 = det*c0*w[3][3]*g02;
    real G2_2_1_0 = det*c0*w[3][0]*g12;
    real G2_2_1_1 = det*c0*w[3][1]*g12;
    real G2_2_1_2 = det*c0*w[3][2]*g12;
    real G2_2_1_3 = det*c0*w[3][3]*g12;
    real G2_2_2_0 = det*c0*w[3][0]*g22;
    real G2_2_2_1 = det*c0*w[3][1]*g22;
    real G2_2_2_2 = det*c0*w[3][2]*g22;
    real G2_2_2_3 = det*c0*w[3][3]*g22;
    real G3_0_0_0_0 = det*c1*c0*w[0][0]*w[2][0]*g00;
    real G3_0_0_0_1 = det*c1*c0*w[0][0]*w[2][1]*g00;
    real G3_0_0_0_2 = det*c1*c0*w[0][0]*w[2][2]*g00;
    real G3_0_0_0_3 = det*c1*c0*w[0][0]*w[2][3]*g00;
    real G3_0_0_0_4 = det*c1*c0*w[0][0]*w[2][4]*g00;
    real G3_0_0_0_5 = det*c1*c0*w[0][0]*w[2][5]*g00;
    real G3_0_0_0_6 = det*c1*c0*w[0][0]*w[2][6]*g00;
    real G3_0_0_0_7 = det*c1*c0*w[0][0]*w[2][7]*g00;
    real G3_0_0_0_8 = det*c1*c0*w[0][0]*w[2][8]*g00;
    real G3_0_0_0_9 = det*c1*c0*w[0][0]*w[2][9]*g00;
    real G3_0_0_0_10 = det*c1*c0*w[0][0]*w[2][10]*g00;
    real G3_0_0_0_11 = det*c1*c0*w[0][0]*w[2][11]*g00;
    real G3_0_0_1_0 = det*c1*c0*w[0][0]*w[2][0]*g10;
    real G3_0_0_1_1 = det*c1*c0*w[0][0]*w[2][1]*g10;
    real G3_0_0_1_2 = det*c1*c0*w[0][0]*w[2][2]*g10;
    real G3_0_0_1_3 = det*c1*c0*w[0][0]*w[2][3]*g10;
    real G3_0_0_1_4 = det*c1*c0*w[0][0]*w[2][4]*g10;
    real G3_0_0_1_5 = det*c1*c0*w[0][0]*w[2][5]*g10;
    real G3_0_0_1_6 = det*c1*c0*w[0][0]*w[2][6]*g10;
    real G3_0_0_1_7 = det*c1*c0*w[0][0]*w[2][7]*g10;
    real G3_0_0_1_8 = det*c1*c0*w[0][0]*w[2][8]*g10;
    real G3_0_0_1_9 = det*c1*c0*w[0][0]*w[2][9]*g10;
    real G3_0_0_1_10 = det*c1*c0*w[0][0]*w[2][10]*g10;
    real G3_0_0_1_11 = det*c1*c0*w[0][0]*w[2][11]*g10;
    real G3_0_0_2_0 = det*c1*c0*w[0][0]*w[2][0]*g20;
    real G3_0_0_2_1 = det*c1*c0*w[0][0]*w[2][1]*g20;
    real G3_0_0_2_2 = det*c1*c0*w[0][0]*w[2][2]*g20;
    real G3_0_0_2_3 = det*c1*c0*w[0][0]*w[2][3]*g20;
    real G3_0_0_2_4 = det*c1*c0*w[0][0]*w[2][4]*g20;
    real G3_0_0_2_5 = det*c1*c0*w[0][0]*w[2][5]*g20;
    real G3_0_0_2_6 = det*c1*c0*w[0][0]*w[2][6]*g20;
    real G3_0_0_2_7 = det*c1*c0*w[0][0]*w[2][7]*g20;
    real G3_0_0_2_8 = det*c1*c0*w[0][0]*w[2][8]*g20;
    real G3_0_0_2_9 = det*c1*c0*w[0][0]*w[2][9]*g20;
    real G3_0_0_2_10 = det*c1*c0*w[0][0]*w[2][10]*g20;
    real G3_0_0_2_11 = det*c1*c0*w[0][0]*w[2][11]*g20;
    real G3_0_1_0_0 = det*c1*c0*w[0][1]*w[2][0]*g00;
    real G3_0_1_0_1 = det*c1*c0*w[0][1]*w[2][1]*g00;
    real G3_0_1_0_2 = det*c1*c0*w[0][1]*w[2][2]*g00;
    real G3_0_1_0_3 = det*c1*c0*w[0][1]*w[2][3]*g00;
    real G3_0_1_0_4 = det*c1*c0*w[0][1]*w[2][4]*g00;
    real G3_0_1_0_5 = det*c1*c0*w[0][1]*w[2][5]*g00;
    real G3_0_1_0_6 = det*c1*c0*w[0][1]*w[2][6]*g00;
    real G3_0_1_0_7 = det*c1*c0*w[0][1]*w[2][7]*g00;
    real G3_0_1_0_8 = det*c1*c0*w[0][1]*w[2][8]*g00;
    real G3_0_1_0_9 = det*c1*c0*w[0][1]*w[2][9]*g00;
    real G3_0_1_0_10 = det*c1*c0*w[0][1]*w[2][10]*g00;
    real G3_0_1_0_11 = det*c1*c0*w[0][1]*w[2][11]*g00;
    real G3_0_1_1_0 = det*c1*c0*w[0][1]*w[2][0]*g10;
    real G3_0_1_1_1 = det*c1*c0*w[0][1]*w[2][1]*g10;
    real G3_0_1_1_2 = det*c1*c0*w[0][1]*w[2][2]*g10;
    real G3_0_1_1_3 = det*c1*c0*w[0][1]*w[2][3]*g10;
    real G3_0_1_1_4 = det*c1*c0*w[0][1]*w[2][4]*g10;
    real G3_0_1_1_5 = det*c1*c0*w[0][1]*w[2][5]*g10;
    real G3_0_1_1_6 = det*c1*c0*w[0][1]*w[2][6]*g10;
    real G3_0_1_1_7 = det*c1*c0*w[0][1]*w[2][7]*g10;
    real G3_0_1_1_8 = det*c1*c0*w[0][1]*w[2][8]*g10;
    real G3_0_1_1_9 = det*c1*c0*w[0][1]*w[2][9]*g10;
    real G3_0_1_1_10 = det*c1*c0*w[0][1]*w[2][10]*g10;
    real G3_0_1_1_11 = det*c1*c0*w[0][1]*w[2][11]*g10;
    real G3_0_1_2_0 = det*c1*c0*w[0][1]*w[2][0]*g20;
    real G3_0_1_2_1 = det*c1*c0*w[0][1]*w[2][1]*g20;
    real G3_0_1_2_2 = det*c1*c0*w[0][1]*w[2][2]*g20;
    real G3_0_1_2_3 = det*c1*c0*w[0][1]*w[2][3]*g20;
    real G3_0_1_2_4 = det*c1*c0*w[0][1]*w[2][4]*g20;
    real G3_0_1_2_5 = det*c1*c0*w[0][1]*w[2][5]*g20;
    real G3_0_1_2_6 = det*c1*c0*w[0][1]*w[2][6]*g20;
    real G3_0_1_2_7 = det*c1*c0*w[0][1]*w[2][7]*g20;
    real G3_0_1_2_8 = det*c1*c0*w[0][1]*w[2][8]*g20;
    real G3_0_1_2_9 = det*c1*c0*w[0][1]*w[2][9]*g20;
    real G3_0_1_2_10 = det*c1*c0*w[0][1]*w[2][10]*g20;
    real G3_0_1_2_11 = det*c1*c0*w[0][1]*w[2][11]*g20;
    real G3_0_2_0_0 = det*c1*c0*w[0][2]*w[2][0]*g00;
    real G3_0_2_0_1 = det*c1*c0*w[0][2]*w[2][1]*g00;
    real G3_0_2_0_2 = det*c1*c0*w[0][2]*w[2][2]*g00;
    real G3_0_2_0_3 = det*c1*c0*w[0][2]*w[2][3]*g00;
    real G3_0_2_0_4 = det*c1*c0*w[0][2]*w[2][4]*g00;
    real G3_0_2_0_5 = det*c1*c0*w[0][2]*w[2][5]*g00;
    real G3_0_2_0_6 = det*c1*c0*w[0][2]*w[2][6]*g00;
    real G3_0_2_0_7 = det*c1*c0*w[0][2]*w[2][7]*g00;
    real G3_0_2_0_8 = det*c1*c0*w[0][2]*w[2][8]*g00;
    real G3_0_2_0_9 = det*c1*c0*w[0][2]*w[2][9]*g00;
    real G3_0_2_0_10 = det*c1*c0*w[0][2]*w[2][10]*g00;
    real G3_0_2_0_11 = det*c1*c0*w[0][2]*w[2][11]*g00;
    real G3_0_2_1_0 = det*c1*c0*w[0][2]*w[2][0]*g10;
    real G3_0_2_1_1 = det*c1*c0*w[0][2]*w[2][1]*g10;
    real G3_0_2_1_2 = det*c1*c0*w[0][2]*w[2][2]*g10;
    real G3_0_2_1_3 = det*c1*c0*w[0][2]*w[2][3]*g10;
    real G3_0_2_1_4 = det*c1*c0*w[0][2]*w[2][4]*g10;
    real G3_0_2_1_5 = det*c1*c0*w[0][2]*w[2][5]*g10;
    real G3_0_2_1_6 = det*c1*c0*w[0][2]*w[2][6]*g10;
    real G3_0_2_1_7 = det*c1*c0*w[0][2]*w[2][7]*g10;
    real G3_0_2_1_8 = det*c1*c0*w[0][2]*w[2][8]*g10;
    real G3_0_2_1_9 = det*c1*c0*w[0][2]*w[2][9]*g10;
    real G3_0_2_1_10 = det*c1*c0*w[0][2]*w[2][10]*g10;
    real G3_0_2_1_11 = det*c1*c0*w[0][2]*w[2][11]*g10;
    real G3_0_2_2_0 = det*c1*c0*w[0][2]*w[2][0]*g20;
    real G3_0_2_2_1 = det*c1*c0*w[0][2]*w[2][1]*g20;
    real G3_0_2_2_2 = det*c1*c0*w[0][2]*w[2][2]*g20;
    real G3_0_2_2_3 = det*c1*c0*w[0][2]*w[2][3]*g20;
    real G3_0_2_2_4 = det*c1*c0*w[0][2]*w[2][4]*g20;
    real G3_0_2_2_5 = det*c1*c0*w[0][2]*w[2][5]*g20;
    real G3_0_2_2_6 = det*c1*c0*w[0][2]*w[2][6]*g20;
    real G3_0_2_2_7 = det*c1*c0*w[0][2]*w[2][7]*g20;
    real G3_0_2_2_8 = det*c1*c0*w[0][2]*w[2][8]*g20;
    real G3_0_2_2_9 = det*c1*c0*w[0][2]*w[2][9]*g20;
    real G3_0_2_2_10 = det*c1*c0*w[0][2]*w[2][10]*g20;
    real G3_0_2_2_11 = det*c1*c0*w[0][2]*w[2][11]*g20;
    real G3_0_3_0_0 = det*c1*c0*w[0][3]*w[2][0]*g00;
    real G3_0_3_0_1 = det*c1*c0*w[0][3]*w[2][1]*g00;
    real G3_0_3_0_2 = det*c1*c0*w[0][3]*w[2][2]*g00;
    real G3_0_3_0_3 = det*c1*c0*w[0][3]*w[2][3]*g00;
    real G3_0_3_0_4 = det*c1*c0*w[0][3]*w[2][4]*g00;
    real G3_0_3_0_5 = det*c1*c0*w[0][3]*w[2][5]*g00;
    real G3_0_3_0_6 = det*c1*c0*w[0][3]*w[2][6]*g00;
    real G3_0_3_0_7 = det*c1*c0*w[0][3]*w[2][7]*g00;
    real G3_0_3_0_8 = det*c1*c0*w[0][3]*w[2][8]*g00;
    real G3_0_3_0_9 = det*c1*c0*w[0][3]*w[2][9]*g00;
    real G3_0_3_0_10 = det*c1*c0*w[0][3]*w[2][10]*g00;
    real G3_0_3_0_11 = det*c1*c0*w[0][3]*w[2][11]*g00;
    real G3_0_3_1_0 = det*c1*c0*w[0][3]*w[2][0]*g10;
    real G3_0_3_1_1 = det*c1*c0*w[0][3]*w[2][1]*g10;
    real G3_0_3_1_2 = det*c1*c0*w[0][3]*w[2][2]*g10;
    real G3_0_3_1_3 = det*c1*c0*w[0][3]*w[2][3]*g10;
    real G3_0_3_1_4 = det*c1*c0*w[0][3]*w[2][4]*g10;
    real G3_0_3_1_5 = det*c1*c0*w[0][3]*w[2][5]*g10;
    real G3_0_3_1_6 = det*c1*c0*w[0][3]*w[2][6]*g10;
    real G3_0_3_1_7 = det*c1*c0*w[0][3]*w[2][7]*g10;
    real G3_0_3_1_8 = det*c1*c0*w[0][3]*w[2][8]*g10;
    real G3_0_3_1_9 = det*c1*c0*w[0][3]*w[2][9]*g10;
    real G3_0_3_1_10 = det*c1*c0*w[0][3]*w[2][10]*g10;
    real G3_0_3_1_11 = det*c1*c0*w[0][3]*w[2][11]*g10;
    real G3_0_3_2_0 = det*c1*c0*w[0][3]*w[2][0]*g20;
    real G3_0_3_2_1 = det*c1*c0*w[0][3]*w[2][1]*g20;
    real G3_0_3_2_2 = det*c1*c0*w[0][3]*w[2][2]*g20;
    real G3_0_3_2_3 = det*c1*c0*w[0][3]*w[2][3]*g20;
    real G3_0_3_2_4 = det*c1*c0*w[0][3]*w[2][4]*g20;
    real G3_0_3_2_5 = det*c1*c0*w[0][3]*w[2][5]*g20;
    real G3_0_3_2_6 = det*c1*c0*w[0][3]*w[2][6]*g20;
    real G3_0_3_2_7 = det*c1*c0*w[0][3]*w[2][7]*g20;
    real G3_0_3_2_8 = det*c1*c0*w[0][3]*w[2][8]*g20;
    real G3_0_3_2_9 = det*c1*c0*w[0][3]*w[2][9]*g20;
    real G3_0_3_2_10 = det*c1*c0*w[0][3]*w[2][10]*g20;
    real G3_0_3_2_11 = det*c1*c0*w[0][3]*w[2][11]*g20;
    real G3_1_4_0_0 = det*c1*c0*w[0][4]*w[2][0]*g01;
    real G3_1_4_0_1 = det*c1*c0*w[0][4]*w[2][1]*g01;
    real G3_1_4_0_2 = det*c1*c0*w[0][4]*w[2][2]*g01;
    real G3_1_4_0_3 = det*c1*c0*w[0][4]*w[2][3]*g01;
    real G3_1_4_0_4 = det*c1*c0*w[0][4]*w[2][4]*g01;
    real G3_1_4_0_5 = det*c1*c0*w[0][4]*w[2][5]*g01;
    real G3_1_4_0_6 = det*c1*c0*w[0][4]*w[2][6]*g01;
    real G3_1_4_0_7 = det*c1*c0*w[0][4]*w[2][7]*g01;
    real G3_1_4_0_8 = det*c1*c0*w[0][4]*w[2][8]*g01;
    real G3_1_4_0_9 = det*c1*c0*w[0][4]*w[2][9]*g01;
    real G3_1_4_0_10 = det*c1*c0*w[0][4]*w[2][10]*g01;
    real G3_1_4_0_11 = det*c1*c0*w[0][4]*w[2][11]*g01;
    real G3_1_4_1_0 = det*c1*c0*w[0][4]*w[2][0]*g11;
    real G3_1_4_1_1 = det*c1*c0*w[0][4]*w[2][1]*g11;
    real G3_1_4_1_2 = det*c1*c0*w[0][4]*w[2][2]*g11;
    real G3_1_4_1_3 = det*c1*c0*w[0][4]*w[2][3]*g11;
    real G3_1_4_1_4 = det*c1*c0*w[0][4]*w[2][4]*g11;
    real G3_1_4_1_5 = det*c1*c0*w[0][4]*w[2][5]*g11;
    real G3_1_4_1_6 = det*c1*c0*w[0][4]*w[2][6]*g11;
    real G3_1_4_1_7 = det*c1*c0*w[0][4]*w[2][7]*g11;
    real G3_1_4_1_8 = det*c1*c0*w[0][4]*w[2][8]*g11;
    real G3_1_4_1_9 = det*c1*c0*w[0][4]*w[2][9]*g11;
    real G3_1_4_1_10 = det*c1*c0*w[0][4]*w[2][10]*g11;
    real G3_1_4_1_11 = det*c1*c0*w[0][4]*w[2][11]*g11;
    real G3_1_4_2_0 = det*c1*c0*w[0][4]*w[2][0]*g21;
    real G3_1_4_2_1 = det*c1*c0*w[0][4]*w[2][1]*g21;
    real G3_1_4_2_2 = det*c1*c0*w[0][4]*w[2][2]*g21;
    real G3_1_4_2_3 = det*c1*c0*w[0][4]*w[2][3]*g21;
    real G3_1_4_2_4 = det*c1*c0*w[0][4]*w[2][4]*g21;
    real G3_1_4_2_5 = det*c1*c0*w[0][4]*w[2][5]*g21;
    real G3_1_4_2_6 = det*c1*c0*w[0][4]*w[2][6]*g21;
    real G3_1_4_2_7 = det*c1*c0*w[0][4]*w[2][7]*g21;
    real G3_1_4_2_8 = det*c1*c0*w[0][4]*w[2][8]*g21;
    real G3_1_4_2_9 = det*c1*c0*w[0][4]*w[2][9]*g21;
    real G3_1_4_2_10 = det*c1*c0*w[0][4]*w[2][10]*g21;
    real G3_1_4_2_11 = det*c1*c0*w[0][4]*w[2][11]*g21;
    real G3_1_5_0_0 = det*c1*c0*w[0][5]*w[2][0]*g01;
    real G3_1_5_0_1 = det*c1*c0*w[0][5]*w[2][1]*g01;
    real G3_1_5_0_2 = det*c1*c0*w[0][5]*w[2][2]*g01;
    real G3_1_5_0_3 = det*c1*c0*w[0][5]*w[2][3]*g01;
    real G3_1_5_0_4 = det*c1*c0*w[0][5]*w[2][4]*g01;
    real G3_1_5_0_5 = det*c1*c0*w[0][5]*w[2][5]*g01;
    real G3_1_5_0_6 = det*c1*c0*w[0][5]*w[2][6]*g01;
    real G3_1_5_0_7 = det*c1*c0*w[0][5]*w[2][7]*g01;
    real G3_1_5_0_8 = det*c1*c0*w[0][5]*w[2][8]*g01;
    real G3_1_5_0_9 = det*c1*c0*w[0][5]*w[2][9]*g01;
    real G3_1_5_0_10 = det*c1*c0*w[0][5]*w[2][10]*g01;
    real G3_1_5_0_11 = det*c1*c0*w[0][5]*w[2][11]*g01;
    real G3_1_5_1_0 = det*c1*c0*w[0][5]*w[2][0]*g11;
    real G3_1_5_1_1 = det*c1*c0*w[0][5]*w[2][1]*g11;
    real G3_1_5_1_2 = det*c1*c0*w[0][5]*w[2][2]*g11;
    real G3_1_5_1_3 = det*c1*c0*w[0][5]*w[2][3]*g11;
    real G3_1_5_1_4 = det*c1*c0*w[0][5]*w[2][4]*g11;
    real G3_1_5_1_5 = det*c1*c0*w[0][5]*w[2][5]*g11;
    real G3_1_5_1_6 = det*c1*c0*w[0][5]*w[2][6]*g11;
    real G3_1_5_1_7 = det*c1*c0*w[0][5]*w[2][7]*g11;
    real G3_1_5_1_8 = det*c1*c0*w[0][5]*w[2][8]*g11;
    real G3_1_5_1_9 = det*c1*c0*w[0][5]*w[2][9]*g11;
    real G3_1_5_1_10 = det*c1*c0*w[0][5]*w[2][10]*g11;
    real G3_1_5_1_11 = det*c1*c0*w[0][5]*w[2][11]*g11;
    real G3_1_5_2_0 = det*c1*c0*w[0][5]*w[2][0]*g21;
    real G3_1_5_2_1 = det*c1*c0*w[0][5]*w[2][1]*g21;
    real G3_1_5_2_2 = det*c1*c0*w[0][5]*w[2][2]*g21;
    real G3_1_5_2_3 = det*c1*c0*w[0][5]*w[2][3]*g21;
    real G3_1_5_2_4 = det*c1*c0*w[0][5]*w[2][4]*g21;
    real G3_1_5_2_5 = det*c1*c0*w[0][5]*w[2][5]*g21;
    real G3_1_5_2_6 = det*c1*c0*w[0][5]*w[2][6]*g21;
    real G3_1_5_2_7 = det*c1*c0*w[0][5]*w[2][7]*g21;
    real G3_1_5_2_8 = det*c1*c0*w[0][5]*w[2][8]*g21;
    real G3_1_5_2_9 = det*c1*c0*w[0][5]*w[2][9]*g21;
    real G3_1_5_2_10 = det*c1*c0*w[0][5]*w[2][10]*g21;
    real G3_1_5_2_11 = det*c1*c0*w[0][5]*w[2][11]*g21;
    real G3_1_6_0_0 = det*c1*c0*w[0][6]*w[2][0]*g01;
    real G3_1_6_0_1 = det*c1*c0*w[0][6]*w[2][1]*g01;
    real G3_1_6_0_2 = det*c1*c0*w[0][6]*w[2][2]*g01;
    real G3_1_6_0_3 = det*c1*c0*w[0][6]*w[2][3]*g01;
    real G3_1_6_0_4 = det*c1*c0*w[0][6]*w[2][4]*g01;
    real G3_1_6_0_5 = det*c1*c0*w[0][6]*w[2][5]*g01;
    real G3_1_6_0_6 = det*c1*c0*w[0][6]*w[2][6]*g01;
    real G3_1_6_0_7 = det*c1*c0*w[0][6]*w[2][7]*g01;
    real G3_1_6_0_8 = det*c1*c0*w[0][6]*w[2][8]*g01;
    real G3_1_6_0_9 = det*c1*c0*w[0][6]*w[2][9]*g01;
    real G3_1_6_0_10 = det*c1*c0*w[0][6]*w[2][10]*g01;
    real G3_1_6_0_11 = det*c1*c0*w[0][6]*w[2][11]*g01;
    real G3_1_6_1_0 = det*c1*c0*w[0][6]*w[2][0]*g11;
    real G3_1_6_1_1 = det*c1*c0*w[0][6]*w[2][1]*g11;
    real G3_1_6_1_2 = det*c1*c0*w[0][6]*w[2][2]*g11;
    real G3_1_6_1_3 = det*c1*c0*w[0][6]*w[2][3]*g11;
    real G3_1_6_1_4 = det*c1*c0*w[0][6]*w[2][4]*g11;
    real G3_1_6_1_5 = det*c1*c0*w[0][6]*w[2][5]*g11;
    real G3_1_6_1_6 = det*c1*c0*w[0][6]*w[2][6]*g11;
    real G3_1_6_1_7 = det*c1*c0*w[0][6]*w[2][7]*g11;
    real G3_1_6_1_8 = det*c1*c0*w[0][6]*w[2][8]*g11;
    real G3_1_6_1_9 = det*c1*c0*w[0][6]*w[2][9]*g11;
    real G3_1_6_1_10 = det*c1*c0*w[0][6]*w[2][10]*g11;
    real G3_1_6_1_11 = det*c1*c0*w[0][6]*w[2][11]*g11;
    real G3_1_6_2_0 = det*c1*c0*w[0][6]*w[2][0]*g21;
    real G3_1_6_2_1 = det*c1*c0*w[0][6]*w[2][1]*g21;
    real G3_1_6_2_2 = det*c1*c0*w[0][6]*w[2][2]*g21;
    real G3_1_6_2_3 = det*c1*c0*w[0][6]*w[2][3]*g21;
    real G3_1_6_2_4 = det*c1*c0*w[0][6]*w[2][4]*g21;
    real G3_1_6_2_5 = det*c1*c0*w[0][6]*w[2][5]*g21;
    real G3_1_6_2_6 = det*c1*c0*w[0][6]*w[2][6]*g21;
    real G3_1_6_2_7 = det*c1*c0*w[0][6]*w[2][7]*g21;
    real G3_1_6_2_8 = det*c1*c0*w[0][6]*w[2][8]*g21;
    real G3_1_6_2_9 = det*c1*c0*w[0][6]*w[2][9]*g21;
    real G3_1_6_2_10 = det*c1*c0*w[0][6]*w[2][10]*g21;
    real G3_1_6_2_11 = det*c1*c0*w[0][6]*w[2][11]*g21;
    real G3_1_7_0_0 = det*c1*c0*w[0][7]*w[2][0]*g01;
    real G3_1_7_0_1 = det*c1*c0*w[0][7]*w[2][1]*g01;
    real G3_1_7_0_2 = det*c1*c0*w[0][7]*w[2][2]*g01;
    real G3_1_7_0_3 = det*c1*c0*w[0][7]*w[2][3]*g01;
    real G3_1_7_0_4 = det*c1*c0*w[0][7]*w[2][4]*g01;
    real G3_1_7_0_5 = det*c1*c0*w[0][7]*w[2][5]*g01;
    real G3_1_7_0_6 = det*c1*c0*w[0][7]*w[2][6]*g01;
    real G3_1_7_0_7 = det*c1*c0*w[0][7]*w[2][7]*g01;
    real G3_1_7_0_8 = det*c1*c0*w[0][7]*w[2][8]*g01;
    real G3_1_7_0_9 = det*c1*c0*w[0][7]*w[2][9]*g01;
    real G3_1_7_0_10 = det*c1*c0*w[0][7]*w[2][10]*g01;
    real G3_1_7_0_11 = det*c1*c0*w[0][7]*w[2][11]*g01;
    real G3_1_7_1_0 = det*c1*c0*w[0][7]*w[2][0]*g11;
    real G3_1_7_1_1 = det*c1*c0*w[0][7]*w[2][1]*g11;
    real G3_1_7_1_2 = det*c1*c0*w[0][7]*w[2][2]*g11;
    real G3_1_7_1_3 = det*c1*c0*w[0][7]*w[2][3]*g11;
    real G3_1_7_1_4 = det*c1*c0*w[0][7]*w[2][4]*g11;
    real G3_1_7_1_5 = det*c1*c0*w[0][7]*w[2][5]*g11;
    real G3_1_7_1_6 = det*c1*c0*w[0][7]*w[2][6]*g11;
    real G3_1_7_1_7 = det*c1*c0*w[0][7]*w[2][7]*g11;
    real G3_1_7_1_8 = det*c1*c0*w[0][7]*w[2][8]*g11;
    real G3_1_7_1_9 = det*c1*c0*w[0][7]*w[2][9]*g11;
    real G3_1_7_1_10 = det*c1*c0*w[0][7]*w[2][10]*g11;
    real G3_1_7_1_11 = det*c1*c0*w[0][7]*w[2][11]*g11;
    real G3_1_7_2_0 = det*c1*c0*w[0][7]*w[2][0]*g21;
    real G3_1_7_2_1 = det*c1*c0*w[0][7]*w[2][1]*g21;
    real G3_1_7_2_2 = det*c1*c0*w[0][7]*w[2][2]*g21;
    real G3_1_7_2_3 = det*c1*c0*w[0][7]*w[2][3]*g21;
    real G3_1_7_2_4 = det*c1*c0*w[0][7]*w[2][4]*g21;
    real G3_1_7_2_5 = det*c1*c0*w[0][7]*w[2][5]*g21;
    real G3_1_7_2_6 = det*c1*c0*w[0][7]*w[2][6]*g21;
    real G3_1_7_2_7 = det*c1*c0*w[0][7]*w[2][7]*g21;
    real G3_1_7_2_8 = det*c1*c0*w[0][7]*w[2][8]*g21;
    real G3_1_7_2_9 = det*c1*c0*w[0][7]*w[2][9]*g21;
    real G3_1_7_2_10 = det*c1*c0*w[0][7]*w[2][10]*g21;
    real G3_1_7_2_11 = det*c1*c0*w[0][7]*w[2][11]*g21;
    real G3_2_8_0_0 = det*c1*c0*w[0][8]*w[2][0]*g02;
    real G3_2_8_0_1 = det*c1*c0*w[0][8]*w[2][1]*g02;
    real G3_2_8_0_2 = det*c1*c0*w[0][8]*w[2][2]*g02;
    real G3_2_8_0_3 = det*c1*c0*w[0][8]*w[2][3]*g02;
    real G3_2_8_0_4 = det*c1*c0*w[0][8]*w[2][4]*g02;
    real G3_2_8_0_5 = det*c1*c0*w[0][8]*w[2][5]*g02;
    real G3_2_8_0_6 = det*c1*c0*w[0][8]*w[2][6]*g02;
    real G3_2_8_0_7 = det*c1*c0*w[0][8]*w[2][7]*g02;
    real G3_2_8_0_8 = det*c1*c0*w[0][8]*w[2][8]*g02;
    real G3_2_8_0_9 = det*c1*c0*w[0][8]*w[2][9]*g02;
    real G3_2_8_0_10 = det*c1*c0*w[0][8]*w[2][10]*g02;
    real G3_2_8_0_11 = det*c1*c0*w[0][8]*w[2][11]*g02;
    real G3_2_8_1_0 = det*c1*c0*w[0][8]*w[2][0]*g12;
    real G3_2_8_1_1 = det*c1*c0*w[0][8]*w[2][1]*g12;
    real G3_2_8_1_2 = det*c1*c0*w[0][8]*w[2][2]*g12;
    real G3_2_8_1_3 = det*c1*c0*w[0][8]*w[2][3]*g12;
    real G3_2_8_1_4 = det*c1*c0*w[0][8]*w[2][4]*g12;
    real G3_2_8_1_5 = det*c1*c0*w[0][8]*w[2][5]*g12;
    real G3_2_8_1_6 = det*c1*c0*w[0][8]*w[2][6]*g12;
    real G3_2_8_1_7 = det*c1*c0*w[0][8]*w[2][7]*g12;
    real G3_2_8_1_8 = det*c1*c0*w[0][8]*w[2][8]*g12;
    real G3_2_8_1_9 = det*c1*c0*w[0][8]*w[2][9]*g12;
    real G3_2_8_1_10 = det*c1*c0*w[0][8]*w[2][10]*g12;
    real G3_2_8_1_11 = det*c1*c0*w[0][8]*w[2][11]*g12;
    real G3_2_8_2_0 = det*c1*c0*w[0][8]*w[2][0]*g22;
    real G3_2_8_2_1 = det*c1*c0*w[0][8]*w[2][1]*g22;
    real G3_2_8_2_2 = det*c1*c0*w[0][8]*w[2][2]*g22;
    real G3_2_8_2_3 = det*c1*c0*w[0][8]*w[2][3]*g22;
    real G3_2_8_2_4 = det*c1*c0*w[0][8]*w[2][4]*g22;
    real G3_2_8_2_5 = det*c1*c0*w[0][8]*w[2][5]*g22;
    real G3_2_8_2_6 = det*c1*c0*w[0][8]*w[2][6]*g22;
    real G3_2_8_2_7 = det*c1*c0*w[0][8]*w[2][7]*g22;
    real G3_2_8_2_8 = det*c1*c0*w[0][8]*w[2][8]*g22;
    real G3_2_8_2_9 = det*c1*c0*w[0][8]*w[2][9]*g22;
    real G3_2_8_2_10 = det*c1*c0*w[0][8]*w[2][10]*g22;
    real G3_2_8_2_11 = det*c1*c0*w[0][8]*w[2][11]*g22;
    real G3_2_9_0_0 = det*c1*c0*w[0][9]*w[2][0]*g02;
    real G3_2_9_0_1 = det*c1*c0*w[0][9]*w[2][1]*g02;
    real G3_2_9_0_2 = det*c1*c0*w[0][9]*w[2][2]*g02;
    real G3_2_9_0_3 = det*c1*c0*w[0][9]*w[2][3]*g02;
    real G3_2_9_0_4 = det*c1*c0*w[0][9]*w[2][4]*g02;
    real G3_2_9_0_5 = det*c1*c0*w[0][9]*w[2][5]*g02;
    real G3_2_9_0_6 = det*c1*c0*w[0][9]*w[2][6]*g02;
    real G3_2_9_0_7 = det*c1*c0*w[0][9]*w[2][7]*g02;
    real G3_2_9_0_8 = det*c1*c0*w[0][9]*w[2][8]*g02;
    real G3_2_9_0_9 = det*c1*c0*w[0][9]*w[2][9]*g02;
    real G3_2_9_0_10 = det*c1*c0*w[0][9]*w[2][10]*g02;
    real G3_2_9_0_11 = det*c1*c0*w[0][9]*w[2][11]*g02;
    real G3_2_9_1_0 = det*c1*c0*w[0][9]*w[2][0]*g12;
    real G3_2_9_1_1 = det*c1*c0*w[0][9]*w[2][1]*g12;
    real G3_2_9_1_2 = det*c1*c0*w[0][9]*w[2][2]*g12;
    real G3_2_9_1_3 = det*c1*c0*w[0][9]*w[2][3]*g12;
    real G3_2_9_1_4 = det*c1*c0*w[0][9]*w[2][4]*g12;
    real G3_2_9_1_5 = det*c1*c0*w[0][9]*w[2][5]*g12;
    real G3_2_9_1_6 = det*c1*c0*w[0][9]*w[2][6]*g12;
    real G3_2_9_1_7 = det*c1*c0*w[0][9]*w[2][7]*g12;
    real G3_2_9_1_8 = det*c1*c0*w[0][9]*w[2][8]*g12;
    real G3_2_9_1_9 = det*c1*c0*w[0][9]*w[2][9]*g12;
    real G3_2_9_1_10 = det*c1*c0*w[0][9]*w[2][10]*g12;
    real G3_2_9_1_11 = det*c1*c0*w[0][9]*w[2][11]*g12;
    real G3_2_9_2_0 = det*c1*c0*w[0][9]*w[2][0]*g22;
    real G3_2_9_2_1 = det*c1*c0*w[0][9]*w[2][1]*g22;
    real G3_2_9_2_2 = det*c1*c0*w[0][9]*w[2][2]*g22;
    real G3_2_9_2_3 = det*c1*c0*w[0][9]*w[2][3]*g22;
    real G3_2_9_2_4 = det*c1*c0*w[0][9]*w[2][4]*g22;
    real G3_2_9_2_5 = det*c1*c0*w[0][9]*w[2][5]*g22;
    real G3_2_9_2_6 = det*c1*c0*w[0][9]*w[2][6]*g22;
    real G3_2_9_2_7 = det*c1*c0*w[0][9]*w[2][7]*g22;
    real G3_2_9_2_8 = det*c1*c0*w[0][9]*w[2][8]*g22;
    real G3_2_9_2_9 = det*c1*c0*w[0][9]*w[2][9]*g22;
    real G3_2_9_2_10 = det*c1*c0*w[0][9]*w[2][10]*g22;
    real G3_2_9_2_11 = det*c1*c0*w[0][9]*w[2][11]*g22;
    real G3_2_10_0_0 = det*c1*c0*w[0][10]*w[2][0]*g02;
    real G3_2_10_0_1 = det*c1*c0*w[0][10]*w[2][1]*g02;
    real G3_2_10_0_2 = det*c1*c0*w[0][10]*w[2][2]*g02;
    real G3_2_10_0_3 = det*c1*c0*w[0][10]*w[2][3]*g02;
    real G3_2_10_0_4 = det*c1*c0*w[0][10]*w[2][4]*g02;
    real G3_2_10_0_5 = det*c1*c0*w[0][10]*w[2][5]*g02;
    real G3_2_10_0_6 = det*c1*c0*w[0][10]*w[2][6]*g02;
    real G3_2_10_0_7 = det*c1*c0*w[0][10]*w[2][7]*g02;
    real G3_2_10_0_8 = det*c1*c0*w[0][10]*w[2][8]*g02;
    real G3_2_10_0_9 = det*c1*c0*w[0][10]*w[2][9]*g02;
    real G3_2_10_0_10 = det*c1*c0*w[0][10]*w[2][10]*g02;
    real G3_2_10_0_11 = det*c1*c0*w[0][10]*w[2][11]*g02;
    real G3_2_10_1_0 = det*c1*c0*w[0][10]*w[2][0]*g12;
    real G3_2_10_1_1 = det*c1*c0*w[0][10]*w[2][1]*g12;
    real G3_2_10_1_2 = det*c1*c0*w[0][10]*w[2][2]*g12;
    real G3_2_10_1_3 = det*c1*c0*w[0][10]*w[2][3]*g12;
    real G3_2_10_1_4 = det*c1*c0*w[0][10]*w[2][4]*g12;
    real G3_2_10_1_5 = det*c1*c0*w[0][10]*w[2][5]*g12;
    real G3_2_10_1_6 = det*c1*c0*w[0][10]*w[2][6]*g12;
    real G3_2_10_1_7 = det*c1*c0*w[0][10]*w[2][7]*g12;
    real G3_2_10_1_8 = det*c1*c0*w[0][10]*w[2][8]*g12;
    real G3_2_10_1_9 = det*c1*c0*w[0][10]*w[2][9]*g12;
    real G3_2_10_1_10 = det*c1*c0*w[0][10]*w[2][10]*g12;
    real G3_2_10_1_11 = det*c1*c0*w[0][10]*w[2][11]*g12;
    real G3_2_10_2_0 = det*c1*c0*w[0][10]*w[2][0]*g22;
    real G3_2_10_2_1 = det*c1*c0*w[0][10]*w[2][1]*g22;
    real G3_2_10_2_2 = det*c1*c0*w[0][10]*w[2][2]*g22;
    real G3_2_10_2_3 = det*c1*c0*w[0][10]*w[2][3]*g22;
    real G3_2_10_2_4 = det*c1*c0*w[0][10]*w[2][4]*g22;
    real G3_2_10_2_5 = det*c1*c0*w[0][10]*w[2][5]*g22;
    real G3_2_10_2_6 = det*c1*c0*w[0][10]*w[2][6]*g22;
    real G3_2_10_2_7 = det*c1*c0*w[0][10]*w[2][7]*g22;
    real G3_2_10_2_8 = det*c1*c0*w[0][10]*w[2][8]*g22;
    real G3_2_10_2_9 = det*c1*c0*w[0][10]*w[2][9]*g22;
    real G3_2_10_2_10 = det*c1*c0*w[0][10]*w[2][10]*g22;
    real G3_2_10_2_11 = det*c1*c0*w[0][10]*w[2][11]*g22;
    real G3_2_11_0_0 = det*c1*c0*w[0][11]*w[2][0]*g02;
    real G3_2_11_0_1 = det*c1*c0*w[0][11]*w[2][1]*g02;
    real G3_2_11_0_2 = det*c1*c0*w[0][11]*w[2][2]*g02;
    real G3_2_11_0_3 = det*c1*c0*w[0][11]*w[2][3]*g02;
    real G3_2_11_0_4 = det*c1*c0*w[0][11]*w[2][4]*g02;
    real G3_2_11_0_5 = det*c1*c0*w[0][11]*w[2][5]*g02;
    real G3_2_11_0_6 = det*c1*c0*w[0][11]*w[2][6]*g02;
    real G3_2_11_0_7 = det*c1*c0*w[0][11]*w[2][7]*g02;
    real G3_2_11_0_8 = det*c1*c0*w[0][11]*w[2][8]*g02;
    real G3_2_11_0_9 = det*c1*c0*w[0][11]*w[2][9]*g02;
    real G3_2_11_0_10 = det*c1*c0*w[0][11]*w[2][10]*g02;
    real G3_2_11_0_11 = det*c1*c0*w[0][11]*w[2][11]*g02;
    real G3_2_11_1_0 = det*c1*c0*w[0][11]*w[2][0]*g12;
    real G3_2_11_1_1 = det*c1*c0*w[0][11]*w[2][1]*g12;
    real G3_2_11_1_2 = det*c1*c0*w[0][11]*w[2][2]*g12;
    real G3_2_11_1_3 = det*c1*c0*w[0][11]*w[2][3]*g12;
    real G3_2_11_1_4 = det*c1*c0*w[0][11]*w[2][4]*g12;
    real G3_2_11_1_5 = det*c1*c0*w[0][11]*w[2][5]*g12;
    real G3_2_11_1_6 = det*c1*c0*w[0][11]*w[2][6]*g12;
    real G3_2_11_1_7 = det*c1*c0*w[0][11]*w[2][7]*g12;
    real G3_2_11_1_8 = det*c1*c0*w[0][11]*w[2][8]*g12;
    real G3_2_11_1_9 = det*c1*c0*w[0][11]*w[2][9]*g12;
    real G3_2_11_1_10 = det*c1*c0*w[0][11]*w[2][10]*g12;
    real G3_2_11_1_11 = det*c1*c0*w[0][11]*w[2][11]*g12;
    real G3_2_11_2_0 = det*c1*c0*w[0][11]*w[2][0]*g22;
    real G3_2_11_2_1 = det*c1*c0*w[0][11]*w[2][1]*g22;
    real G3_2_11_2_2 = det*c1*c0*w[0][11]*w[2][2]*g22;
    real G3_2_11_2_3 = det*c1*c0*w[0][11]*w[2][3]*g22;
    real G3_2_11_2_4 = det*c1*c0*w[0][11]*w[2][4]*g22;
    real G3_2_11_2_5 = det*c1*c0*w[0][11]*w[2][5]*g22;
    real G3_2_11_2_6 = det*c1*c0*w[0][11]*w[2][6]*g22;
    real G3_2_11_2_7 = det*c1*c0*w[0][11]*w[2][7]*g22;
    real G3_2_11_2_8 = det*c1*c0*w[0][11]*w[2][8]*g22;
    real G3_2_11_2_9 = det*c1*c0*w[0][11]*w[2][9]*g22;
    real G3_2_11_2_10 = det*c1*c0*w[0][11]*w[2][10]*g22;
    real G3_2_11_2_11 = det*c1*c0*w[0][11]*w[2][11]*g22;
    real G4_0_0_0 = det*c0*w[1][0]*(g00*g00 + g01*g01 + g02*g02);
    real G4_0_0_1 = det*c0*w[1][0]*(g00*g10 + g01*g11 + g02*g12);
    real G4_0_0_2 = det*c0*w[1][0]*(g00*g20 + g01*g21 + g02*g22);
    real G4_0_1_0 = det*c0*w[1][1]*(g00*g00 + g01*g01 + g02*g02);
    real G4_0_2_1 = det*c0*w[1][2]*(g00*g10 + g01*g11 + g02*g12);
    real G4_0_3_2 = det*c0*w[1][3]*(g00*g20 + g01*g21 + g02*g22);
    real G4_0_4_0 = det*c0*w[1][4]*(g00*g00 + g01*g01 + g02*g02);
    real G4_0_4_1 = det*c0*w[1][4]*(g00*g10 + g01*g11 + g02*g12);
    real G4_0_4_2 = det*c0*w[1][4]*(g00*g20 + g01*g21 + g02*g22);
    real G4_0_5_0 = det*c0*w[1][5]*(g00*g00 + g01*g01 + g02*g02);
    real G4_0_6_1 = det*c0*w[1][6]*(g00*g10 + g01*g11 + g02*g12);
    real G4_0_7_2 = det*c0*w[1][7]*(g00*g20 + g01*g21 + g02*g22);
    real G4_0_8_0 = det*c0*w[1][8]*(g00*g00 + g01*g01 + g02*g02);
    real G4_0_8_1 = det*c0*w[1][8]*(g00*g10 + g01*g11 + g02*g12);
    real G4_0_8_2 = det*c0*w[1][8]*(g00*g20 + g01*g21 + g02*g22);
    real G4_0_9_0 = det*c0*w[1][9]*(g00*g00 + g01*g01 + g02*g02);
    real G4_0_10_1 = det*c0*w[1][10]*(g00*g10 + g01*g11 + g02*g12);
    real G4_0_11_2 = det*c0*w[1][11]*(g00*g20 + g01*g21 + g02*g22);
    real G4_1_0_0 = det*c0*w[1][0]*(g10*g00 + g11*g01 + g12*g02);
    real G4_1_0_1 = det*c0*w[1][0]*(g10*g10 + g11*g11 + g12*g12);
    real G4_1_0_2 = det*c0*w[1][0]*(g10*g20 + g11*g21 + g12*g22);
    real G4_1_1_0 = det*c0*w[1][1]*(g10*g00 + g11*g01 + g12*g02);
    real G4_1_2_1 = det*c0*w[1][2]*(g10*g10 + g11*g11 + g12*g12);
    real G4_1_3_2 = det*c0*w[1][3]*(g10*g20 + g11*g21 + g12*g22);
    real G4_1_4_0 = det*c0*w[1][4]*(g10*g00 + g11*g01 + g12*g02);
    real G4_1_4_1 = det*c0*w[1][4]*(g10*g10 + g11*g11 + g12*g12);
    real G4_1_4_2 = det*c0*w[1][4]*(g10*g20 + g11*g21 + g12*g22);
    real G4_1_5_0 = det*c0*w[1][5]*(g10*g00 + g11*g01 + g12*g02);
    real G4_1_6_1 = det*c0*w[1][6]*(g10*g10 + g11*g11 + g12*g12);
    real G4_1_7_2 = det*c0*w[1][7]*(g10*g20 + g11*g21 + g12*g22);
    real G4_1_8_0 = det*c0*w[1][8]*(g10*g00 + g11*g01 + g12*g02);
    real G4_1_8_1 = det*c0*w[1][8]*(g10*g10 + g11*g11 + g12*g12);
    real G4_1_8_2 = det*c0*w[1][8]*(g10*g20 + g11*g21 + g12*g22);
    real G4_1_9_0 = det*c0*w[1][9]*(g10*g00 + g11*g01 + g12*g02);
    real G4_1_10_1 = det*c0*w[1][10]*(g10*g10 + g11*g11 + g12*g12);
    real G4_1_11_2 = det*c0*w[1][11]*(g10*g20 + g11*g21 + g12*g22);
    real G4_2_0_0 = det*c0*w[1][0]*(g20*g00 + g21*g01 + g22*g02);
    real G4_2_0_1 = det*c0*w[1][0]*(g20*g10 + g21*g11 + g22*g12);
    real G4_2_0_2 = det*c0*w[1][0]*(g20*g20 + g21*g21 + g22*g22);
    real G4_2_1_0 = det*c0*w[1][1]*(g20*g00 + g21*g01 + g22*g02);
    real G4_2_2_1 = det*c0*w[1][2]*(g20*g10 + g21*g11 + g22*g12);
    real G4_2_3_2 = det*c0*w[1][3]*(g20*g20 + g21*g21 + g22*g22);
    real G4_2_4_0 = det*c0*w[1][4]*(g20*g00 + g21*g01 + g22*g02);
    real G4_2_4_1 = det*c0*w[1][4]*(g20*g10 + g21*g11 + g22*g12);
    real G4_2_4_2 = det*c0*w[1][4]*(g20*g20 + g21*g21 + g22*g22);
    real G4_2_5_0 = det*c0*w[1][5]*(g20*g00 + g21*g01 + g22*g02);
    real G4_2_6_1 = det*c0*w[1][6]*(g20*g10 + g21*g11 + g22*g12);
    real G4_2_7_2 = det*c0*w[1][7]*(g20*g20 + g21*g21 + g22*g22);
    real G4_2_8_0 = det*c0*w[1][8]*(g20*g00 + g21*g01 + g22*g02);
    real G4_2_8_1 = det*c0*w[1][8]*(g20*g10 + g21*g11 + g22*g12);
    real G4_2_8_2 = det*c0*w[1][8]*(g20*g20 + g21*g21 + g22*g22);
    real G4_2_9_0 = det*c0*w[1][9]*(g20*g00 + g21*g01 + g22*g02);
    real G4_2_10_1 = det*c0*w[1][10]*(g20*g10 + g21*g11 + g22*g12);
    real G4_2_11_2 = det*c0*w[1][11]*(g20*g20 + g21*g21 + g22*g22);
    real G5_0_0_0_0 = det*c0*w[0][0]*w[1][0]*g00;
    real G5_0_0_0_1 = det*c0*w[0][0]*w[1][0]*g10;
    real G5_0_0_0_2 = det*c0*w[0][0]*w[1][0]*g20;
    real G5_0_0_1_0 = det*c0*w[0][0]*w[1][1]*g00;
    real G5_0_0_2_1 = det*c0*w[0][0]*w[1][2]*g10;
    real G5_0_0_3_2 = det*c0*w[0][0]*w[1][3]*g20;
    real G5_0_0_4_0 = det*c0*w[0][0]*w[1][4]*g00;
    real G5_0_0_4_1 = det*c0*w[0][0]*w[1][4]*g10;
    real G5_0_0_4_2 = det*c0*w[0][0]*w[1][4]*g20;
    real G5_0_0_5_0 = det*c0*w[0][0]*w[1][5]*g00;
    real G5_0_0_6_1 = det*c0*w[0][0]*w[1][6]*g10;
    real G5_0_0_7_2 = det*c0*w[0][0]*w[1][7]*g20;
    real G5_0_0_8_0 = det*c0*w[0][0]*w[1][8]*g00;
    real G5_0_0_8_1 = det*c0*w[0][0]*w[1][8]*g10;
    real G5_0_0_8_2 = det*c0*w[0][0]*w[1][8]*g20;
    real G5_0_0_9_0 = det*c0*w[0][0]*w[1][9]*g00;
    real G5_0_0_10_1 = det*c0*w[0][0]*w[1][10]*g10;
    real G5_0_0_11_2 = det*c0*w[0][0]*w[1][11]*g20;
    real G5_0_1_0_0 = det*c0*w[0][1]*w[1][0]*g00;
    real G5_0_1_0_1 = det*c0*w[0][1]*w[1][0]*g10;
    real G5_0_1_0_2 = det*c0*w[0][1]*w[1][0]*g20;
    real G5_0_1_1_0 = det*c0*w[0][1]*w[1][1]*g00;
    real G5_0_1_2_1 = det*c0*w[0][1]*w[1][2]*g10;
    real G5_0_1_3_2 = det*c0*w[0][1]*w[1][3]*g20;
    real G5_0_1_4_0 = det*c0*w[0][1]*w[1][4]*g00;
    real G5_0_1_4_1 = det*c0*w[0][1]*w[1][4]*g10;
    real G5_0_1_4_2 = det*c0*w[0][1]*w[1][4]*g20;
    real G5_0_1_5_0 = det*c0*w[0][1]*w[1][5]*g00;
    real G5_0_1_6_1 = det*c0*w[0][1]*w[1][6]*g10;
    real G5_0_1_7_2 = det*c0*w[0][1]*w[1][7]*g20;
    real G5_0_1_8_0 = det*c0*w[0][1]*w[1][8]*g00;
    real G5_0_1_8_1 = det*c0*w[0][1]*w[1][8]*g10;
    real G5_0_1_8_2 = det*c0*w[0][1]*w[1][8]*g20;
    real G5_0_1_9_0 = det*c0*w[0][1]*w[1][9]*g00;
    real G5_0_1_10_1 = det*c0*w[0][1]*w[1][10]*g10;
    real G5_0_1_11_2 = det*c0*w[0][1]*w[1][11]*g20;
    real G5_0_2_0_0 = det*c0*w[0][2]*w[1][0]*g00;
    real G5_0_2_0_1 = det*c0*w[0][2]*w[1][0]*g10;
    real G5_0_2_0_2 = det*c0*w[0][2]*w[1][0]*g20;
    real G5_0_2_1_0 = det*c0*w[0][2]*w[1][1]*g00;
    real G5_0_2_2_1 = det*c0*w[0][2]*w[1][2]*g10;
    real G5_0_2_3_2 = det*c0*w[0][2]*w[1][3]*g20;
    real G5_0_2_4_0 = det*c0*w[0][2]*w[1][4]*g00;
    real G5_0_2_4_1 = det*c0*w[0][2]*w[1][4]*g10;
    real G5_0_2_4_2 = det*c0*w[0][2]*w[1][4]*g20;
    real G5_0_2_5_0 = det*c0*w[0][2]*w[1][5]*g00;
    real G5_0_2_6_1 = det*c0*w[0][2]*w[1][6]*g10;
    real G5_0_2_7_2 = det*c0*w[0][2]*w[1][7]*g20;
    real G5_0_2_8_0 = det*c0*w[0][2]*w[1][8]*g00;
    real G5_0_2_8_1 = det*c0*w[0][2]*w[1][8]*g10;
    real G5_0_2_8_2 = det*c0*w[0][2]*w[1][8]*g20;
    real G5_0_2_9_0 = det*c0*w[0][2]*w[1][9]*g00;
    real G5_0_2_10_1 = det*c0*w[0][2]*w[1][10]*g10;
    real G5_0_2_11_2 = det*c0*w[0][2]*w[1][11]*g20;
    real G5_0_3_0_0 = det*c0*w[0][3]*w[1][0]*g00;
    real G5_0_3_0_1 = det*c0*w[0][3]*w[1][0]*g10;
    real G5_0_3_0_2 = det*c0*w[0][3]*w[1][0]*g20;
    real G5_0_3_1_0 = det*c0*w[0][3]*w[1][1]*g00;
    real G5_0_3_2_1 = det*c0*w[0][3]*w[1][2]*g10;
    real G5_0_3_3_2 = det*c0*w[0][3]*w[1][3]*g20;
    real G5_0_3_4_0 = det*c0*w[0][3]*w[1][4]*g00;
    real G5_0_3_4_1 = det*c0*w[0][3]*w[1][4]*g10;
    real G5_0_3_4_2 = det*c0*w[0][3]*w[1][4]*g20;
    real G5_0_3_5_0 = det*c0*w[0][3]*w[1][5]*g00;
    real G5_0_3_6_1 = det*c0*w[0][3]*w[1][6]*g10;
    real G5_0_3_7_2 = det*c0*w[0][3]*w[1][7]*g20;
    real G5_0_3_8_0 = det*c0*w[0][3]*w[1][8]*g00;
    real G5_0_3_8_1 = det*c0*w[0][3]*w[1][8]*g10;
    real G5_0_3_8_2 = det*c0*w[0][3]*w[1][8]*g20;
    real G5_0_3_9_0 = det*c0*w[0][3]*w[1][9]*g00;
    real G5_0_3_10_1 = det*c0*w[0][3]*w[1][10]*g10;
    real G5_0_3_11_2 = det*c0*w[0][3]*w[1][11]*g20;
    real G5_1_4_0_0 = det*c0*w[0][4]*w[1][0]*g01;
    real G5_1_4_0_1 = det*c0*w[0][4]*w[1][0]*g11;
    real G5_1_4_0_2 = det*c0*w[0][4]*w[1][0]*g21;
    real G5_1_4_1_0 = det*c0*w[0][4]*w[1][1]*g01;
    real G5_1_4_2_1 = det*c0*w[0][4]*w[1][2]*g11;
    real G5_1_4_3_2 = det*c0*w[0][4]*w[1][3]*g21;
    real G5_1_4_4_0 = det*c0*w[0][4]*w[1][4]*g01;
    real G5_1_4_4_1 = det*c0*w[0][4]*w[1][4]*g11;
    real G5_1_4_4_2 = det*c0*w[0][4]*w[1][4]*g21;
    real G5_1_4_5_0 = det*c0*w[0][4]*w[1][5]*g01;
    real G5_1_4_6_1 = det*c0*w[0][4]*w[1][6]*g11;
    real G5_1_4_7_2 = det*c0*w[0][4]*w[1][7]*g21;
    real G5_1_4_8_0 = det*c0*w[0][4]*w[1][8]*g01;
    real G5_1_4_8_1 = det*c0*w[0][4]*w[1][8]*g11;
    real G5_1_4_8_2 = det*c0*w[0][4]*w[1][8]*g21;
    real G5_1_4_9_0 = det*c0*w[0][4]*w[1][9]*g01;
    real G5_1_4_10_1 = det*c0*w[0][4]*w[1][10]*g11;
    real G5_1_4_11_2 = det*c0*w[0][4]*w[1][11]*g21;
    real G5_1_5_0_0 = det*c0*w[0][5]*w[1][0]*g01;
    real G5_1_5_0_1 = det*c0*w[0][5]*w[1][0]*g11;
    real G5_1_5_0_2 = det*c0*w[0][5]*w[1][0]*g21;
    real G5_1_5_1_0 = det*c0*w[0][5]*w[1][1]*g01;
    real G5_1_5_2_1 = det*c0*w[0][5]*w[1][2]*g11;
    real G5_1_5_3_2 = det*c0*w[0][5]*w[1][3]*g21;
    real G5_1_5_4_0 = det*c0*w[0][5]*w[1][4]*g01;
    real G5_1_5_4_1 = det*c0*w[0][5]*w[1][4]*g11;
    real G5_1_5_4_2 = det*c0*w[0][5]*w[1][4]*g21;
    real G5_1_5_5_0 = det*c0*w[0][5]*w[1][5]*g01;
    real G5_1_5_6_1 = det*c0*w[0][5]*w[1][6]*g11;
    real G5_1_5_7_2 = det*c0*w[0][5]*w[1][7]*g21;
    real G5_1_5_8_0 = det*c0*w[0][5]*w[1][8]*g01;
    real G5_1_5_8_1 = det*c0*w[0][5]*w[1][8]*g11;
    real G5_1_5_8_2 = det*c0*w[0][5]*w[1][8]*g21;
    real G5_1_5_9_0 = det*c0*w[0][5]*w[1][9]*g01;
    real G5_1_5_10_1 = det*c0*w[0][5]*w[1][10]*g11;
    real G5_1_5_11_2 = det*c0*w[0][5]*w[1][11]*g21;
    real G5_1_6_0_0 = det*c0*w[0][6]*w[1][0]*g01;
    real G5_1_6_0_1 = det*c0*w[0][6]*w[1][0]*g11;
    real G5_1_6_0_2 = det*c0*w[0][6]*w[1][0]*g21;
    real G5_1_6_1_0 = det*c0*w[0][6]*w[1][1]*g01;
    real G5_1_6_2_1 = det*c0*w[0][6]*w[1][2]*g11;
    real G5_1_6_3_2 = det*c0*w[0][6]*w[1][3]*g21;
    real G5_1_6_4_0 = det*c0*w[0][6]*w[1][4]*g01;
    real G5_1_6_4_1 = det*c0*w[0][6]*w[1][4]*g11;
    real G5_1_6_4_2 = det*c0*w[0][6]*w[1][4]*g21;
    real G5_1_6_5_0 = det*c0*w[0][6]*w[1][5]*g01;
    real G5_1_6_6_1 = det*c0*w[0][6]*w[1][6]*g11;
    real G5_1_6_7_2 = det*c0*w[0][6]*w[1][7]*g21;
    real G5_1_6_8_0 = det*c0*w[0][6]*w[1][8]*g01;
    real G5_1_6_8_1 = det*c0*w[0][6]*w[1][8]*g11;
    real G5_1_6_8_2 = det*c0*w[0][6]*w[1][8]*g21;
    real G5_1_6_9_0 = det*c0*w[0][6]*w[1][9]*g01;
    real G5_1_6_10_1 = det*c0*w[0][6]*w[1][10]*g11;
    real G5_1_6_11_2 = det*c0*w[0][6]*w[1][11]*g21;
    real G5_1_7_0_0 = det*c0*w[0][7]*w[1][0]*g01;
    real G5_1_7_0_1 = det*c0*w[0][7]*w[1][0]*g11;
    real G5_1_7_0_2 = det*c0*w[0][7]*w[1][0]*g21;
    real G5_1_7_1_0 = det*c0*w[0][7]*w[1][1]*g01;
    real G5_1_7_2_1 = det*c0*w[0][7]*w[1][2]*g11;
    real G5_1_7_3_2 = det*c0*w[0][7]*w[1][3]*g21;
    real G5_1_7_4_0 = det*c0*w[0][7]*w[1][4]*g01;
    real G5_1_7_4_1 = det*c0*w[0][7]*w[1][4]*g11;
    real G5_1_7_4_2 = det*c0*w[0][7]*w[1][4]*g21;
    real G5_1_7_5_0 = det*c0*w[0][7]*w[1][5]*g01;
    real G5_1_7_6_1 = det*c0*w[0][7]*w[1][6]*g11;
    real G5_1_7_7_2 = det*c0*w[0][7]*w[1][7]*g21;
    real G5_1_7_8_0 = det*c0*w[0][7]*w[1][8]*g01;
    real G5_1_7_8_1 = det*c0*w[0][7]*w[1][8]*g11;
    real G5_1_7_8_2 = det*c0*w[0][7]*w[1][8]*g21;
    real G5_1_7_9_0 = det*c0*w[0][7]*w[1][9]*g01;
    real G5_1_7_10_1 = det*c0*w[0][7]*w[1][10]*g11;
    real G5_1_7_11_2 = det*c0*w[0][7]*w[1][11]*g21;
    real G5_2_8_0_0 = det*c0*w[0][8]*w[1][0]*g02;
    real G5_2_8_0_1 = det*c0*w[0][8]*w[1][0]*g12;
    real G5_2_8_0_2 = det*c0*w[0][8]*w[1][0]*g22;
    real G5_2_8_1_0 = det*c0*w[0][8]*w[1][1]*g02;
    real G5_2_8_2_1 = det*c0*w[0][8]*w[1][2]*g12;
    real G5_2_8_3_2 = det*c0*w[0][8]*w[1][3]*g22;
    real G5_2_8_4_0 = det*c0*w[0][8]*w[1][4]*g02;
    real G5_2_8_4_1 = det*c0*w[0][8]*w[1][4]*g12;
    real G5_2_8_4_2 = det*c0*w[0][8]*w[1][4]*g22;
    real G5_2_8_5_0 = det*c0*w[0][8]*w[1][5]*g02;
    real G5_2_8_6_1 = det*c0*w[0][8]*w[1][6]*g12;
    real G5_2_8_7_2 = det*c0*w[0][8]*w[1][7]*g22;
    real G5_2_8_8_0 = det*c0*w[0][8]*w[1][8]*g02;
    real G5_2_8_8_1 = det*c0*w[0][8]*w[1][8]*g12;
    real G5_2_8_8_2 = det*c0*w[0][8]*w[1][8]*g22;
    real G5_2_8_9_0 = det*c0*w[0][8]*w[1][9]*g02;
    real G5_2_8_10_1 = det*c0*w[0][8]*w[1][10]*g12;
    real G5_2_8_11_2 = det*c0*w[0][8]*w[1][11]*g22;
    real G5_2_9_0_0 = det*c0*w[0][9]*w[1][0]*g02;
    real G5_2_9_0_1 = det*c0*w[0][9]*w[1][0]*g12;
    real G5_2_9_0_2 = det*c0*w[0][9]*w[1][0]*g22;
    real G5_2_9_1_0 = det*c0*w[0][9]*w[1][1]*g02;
    real G5_2_9_2_1 = det*c0*w[0][9]*w[1][2]*g12;
    real G5_2_9_3_2 = det*c0*w[0][9]*w[1][3]*g22;
    real G5_2_9_4_0 = det*c0*w[0][9]*w[1][4]*g02;
    real G5_2_9_4_1 = det*c0*w[0][9]*w[1][4]*g12;
    real G5_2_9_4_2 = det*c0*w[0][9]*w[1][4]*g22;
    real G5_2_9_5_0 = det*c0*w[0][9]*w[1][5]*g02;
    real G5_2_9_6_1 = det*c0*w[0][9]*w[1][6]*g12;
    real G5_2_9_7_2 = det*c0*w[0][9]*w[1][7]*g22;
    real G5_2_9_8_0 = det*c0*w[0][9]*w[1][8]*g02;
    real G5_2_9_8_1 = det*c0*w[0][9]*w[1][8]*g12;
    real G5_2_9_8_2 = det*c0*w[0][9]*w[1][8]*g22;
    real G5_2_9_9_0 = det*c0*w[0][9]*w[1][9]*g02;
    real G5_2_9_10_1 = det*c0*w[0][9]*w[1][10]*g12;
    real G5_2_9_11_2 = det*c0*w[0][9]*w[1][11]*g22;
    real G5_2_10_0_0 = det*c0*w[0][10]*w[1][0]*g02;
    real G5_2_10_0_1 = det*c0*w[0][10]*w[1][0]*g12;
    real G5_2_10_0_2 = det*c0*w[0][10]*w[1][0]*g22;
    real G5_2_10_1_0 = det*c0*w[0][10]*w[1][1]*g02;
    real G5_2_10_2_1 = det*c0*w[0][10]*w[1][2]*g12;
    real G5_2_10_3_2 = det*c0*w[0][10]*w[1][3]*g22;
    real G5_2_10_4_0 = det*c0*w[0][10]*w[1][4]*g02;
    real G5_2_10_4_1 = det*c0*w[0][10]*w[1][4]*g12;
    real G5_2_10_4_2 = det*c0*w[0][10]*w[1][4]*g22;
    real G5_2_10_5_0 = det*c0*w[0][10]*w[1][5]*g02;
    real G5_2_10_6_1 = det*c0*w[0][10]*w[1][6]*g12;
    real G5_2_10_7_2 = det*c0*w[0][10]*w[1][7]*g22;
    real G5_2_10_8_0 = det*c0*w[0][10]*w[1][8]*g02;
    real G5_2_10_8_1 = det*c0*w[0][10]*w[1][8]*g12;
    real G5_2_10_8_2 = det*c0*w[0][10]*w[1][8]*g22;
    real G5_2_10_9_0 = det*c0*w[0][10]*w[1][9]*g02;
    real G5_2_10_10_1 = det*c0*w[0][10]*w[1][10]*g12;
    real G5_2_10_11_2 = det*c0*w[0][10]*w[1][11]*g22;
    real G5_2_11_0_0 = det*c0*w[0][11]*w[1][0]*g02;
    real G5_2_11_0_1 = det*c0*w[0][11]*w[1][0]*g12;
    real G5_2_11_0_2 = det*c0*w[0][11]*w[1][0]*g22;
    real G5_2_11_1_0 = det*c0*w[0][11]*w[1][1]*g02;
    real G5_2_11_2_1 = det*c0*w[0][11]*w[1][2]*g12;
    real G5_2_11_3_2 = det*c0*w[0][11]*w[1][3]*g22;
    real G5_2_11_4_0 = det*c0*w[0][11]*w[1][4]*g02;
    real G5_2_11_4_1 = det*c0*w[0][11]*w[1][4]*g12;
    real G5_2_11_4_2 = det*c0*w[0][11]*w[1][4]*g22;
    real G5_2_11_5_0 = det*c0*w[0][11]*w[1][5]*g02;
    real G5_2_11_6_1 = det*c0*w[0][11]*w[1][6]*g12;
    real G5_2_11_7_2 = det*c0*w[0][11]*w[1][7]*g22;
    real G5_2_11_8_0 = det*c0*w[0][11]*w[1][8]*g02;
    real G5_2_11_8_1 = det*c0*w[0][11]*w[1][8]*g12;
    real G5_2_11_8_2 = det*c0*w[0][11]*w[1][8]*g22;
    real G5_2_11_9_0 = det*c0*w[0][11]*w[1][9]*g02;
    real G5_2_11_10_1 = det*c0*w[0][11]*w[1][10]*g12;
    real G5_2_11_11_2 = det*c0*w[0][11]*w[1][11]*g22;
    real G6_0_0_0_0_0_0_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g00*g00;
    real G6_0_0_0_0_0_0_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g00*g10;
    real G6_0_0_0_0_0_0_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g00*g20;
    real G6_0_0_0_0_0_1_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][1]*g00*g00;
    real G6_0_0_0_0_0_2_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][2]*g00*g10;
    real G6_0_0_0_0_0_3_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][3]*g00*g20;
    real G6_0_0_0_0_0_4_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g00*g00;
    real G6_0_0_0_0_0_4_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g00*g10;
    real G6_0_0_0_0_0_4_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g00*g20;
    real G6_0_0_0_0_0_5_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][5]*g00*g00;
    real G6_0_0_0_0_0_6_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][6]*g00*g10;
    real G6_0_0_0_0_0_7_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][7]*g00*g20;
    real G6_0_0_0_0_0_8_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g00*g00;
    real G6_0_0_0_0_0_8_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g00*g10;
    real G6_0_0_0_0_0_8_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g00*g20;
    real G6_0_0_0_0_0_9_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][9]*g00*g00;
    real G6_0_0_0_0_0_10_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][10]*g00*g10;
    real G6_0_0_0_0_0_11_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][11]*g00*g20;
    real G6_0_0_0_0_1_0_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g00*g00;
    real G6_0_0_0_0_1_0_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g00*g10;
    real G6_0_0_0_0_1_0_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g00*g20;
    real G6_0_0_0_0_1_1_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][1]*g00*g00;
    real G6_0_0_0_0_1_2_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][2]*g00*g10;
    real G6_0_0_0_0_1_3_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][3]*g00*g20;
    real G6_0_0_0_0_1_4_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g00*g00;
    real G6_0_0_0_0_1_4_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g00*g10;
    real G6_0_0_0_0_1_4_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g00*g20;
    real G6_0_0_0_0_1_5_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][5]*g00*g00;
    real G6_0_0_0_0_1_6_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][6]*g00*g10;
    real G6_0_0_0_0_1_7_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][7]*g00*g20;
    real G6_0_0_0_0_1_8_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g00*g00;
    real G6_0_0_0_0_1_8_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g00*g10;
    real G6_0_0_0_0_1_8_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g00*g20;
    real G6_0_0_0_0_1_9_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][9]*g00*g00;
    real G6_0_0_0_0_1_10_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][10]*g00*g10;
    real G6_0_0_0_0_1_11_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][11]*g00*g20;
    real G6_0_0_0_0_2_0_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g00*g00;
    real G6_0_0_0_0_2_0_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g00*g10;
    real G6_0_0_0_0_2_0_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g00*g20;
    real G6_0_0_0_0_2_1_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][1]*g00*g00;
    real G6_0_0_0_0_2_2_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][2]*g00*g10;
    real G6_0_0_0_0_2_3_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][3]*g00*g20;
    real G6_0_0_0_0_2_4_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g00*g00;
    real G6_0_0_0_0_2_4_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g00*g10;
    real G6_0_0_0_0_2_4_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g00*g20;
    real G6_0_0_0_0_2_5_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][5]*g00*g00;
    real G6_0_0_0_0_2_6_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][6]*g00*g10;
    real G6_0_0_0_0_2_7_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][7]*g00*g20;
    real G6_0_0_0_0_2_8_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g00*g00;
    real G6_0_0_0_0_2_8_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g00*g10;
    real G6_0_0_0_0_2_8_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g00*g20;
    real G6_0_0_0_0_2_9_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][9]*g00*g00;
    real G6_0_0_0_0_2_10_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][10]*g00*g10;
    real G6_0_0_0_0_2_11_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][11]*g00*g20;
    real G6_0_0_0_0_3_0_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g00*g00;
    real G6_0_0_0_0_3_0_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g00*g10;
    real G6_0_0_0_0_3_0_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g00*g20;
    real G6_0_0_0_0_3_1_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][1]*g00*g00;
    real G6_0_0_0_0_3_2_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][2]*g00*g10;
    real G6_0_0_0_0_3_3_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][3]*g00*g20;
    real G6_0_0_0_0_3_4_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g00*g00;
    real G6_0_0_0_0_3_4_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g00*g10;
    real G6_0_0_0_0_3_4_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g00*g20;
    real G6_0_0_0_0_3_5_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][5]*g00*g00;
    real G6_0_0_0_0_3_6_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][6]*g00*g10;
    real G6_0_0_0_0_3_7_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][7]*g00*g20;
    real G6_0_0_0_0_3_8_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g00*g00;
    real G6_0_0_0_0_3_8_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g00*g10;
    real G6_0_0_0_0_3_8_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g00*g20;
    real G6_0_0_0_0_3_9_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][9]*g00*g00;
    real G6_0_0_0_0_3_10_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][10]*g00*g10;
    real G6_0_0_0_0_3_11_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][11]*g00*g20;
    real G6_0_0_0_1_0_0_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g10*g00;
    real G6_0_0_0_1_0_0_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g10*g10;
    real G6_0_0_0_1_0_0_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g10*g20;
    real G6_0_0_0_1_0_1_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][1]*g10*g00;
    real G6_0_0_0_1_0_2_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][2]*g10*g10;
    real G6_0_0_0_1_0_3_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][3]*g10*g20;
    real G6_0_0_0_1_0_4_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g10*g00;
    real G6_0_0_0_1_0_4_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g10*g10;
    real G6_0_0_0_1_0_4_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g10*g20;
    real G6_0_0_0_1_0_5_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][5]*g10*g00;
    real G6_0_0_0_1_0_6_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][6]*g10*g10;
    real G6_0_0_0_1_0_7_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][7]*g10*g20;
    real G6_0_0_0_1_0_8_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g10*g00;
    real G6_0_0_0_1_0_8_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g10*g10;
    real G6_0_0_0_1_0_8_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g10*g20;
    real G6_0_0_0_1_0_9_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][9]*g10*g00;
    real G6_0_0_0_1_0_10_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][10]*g10*g10;
    real G6_0_0_0_1_0_11_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][11]*g10*g20;
    real G6_0_0_0_1_1_0_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g10*g00;
    real G6_0_0_0_1_1_0_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g10*g10;
    real G6_0_0_0_1_1_0_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g10*g20;
    real G6_0_0_0_1_1_1_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][1]*g10*g00;
    real G6_0_0_0_1_1_2_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][2]*g10*g10;
    real G6_0_0_0_1_1_3_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][3]*g10*g20;
    real G6_0_0_0_1_1_4_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g10*g00;
    real G6_0_0_0_1_1_4_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g10*g10;
    real G6_0_0_0_1_1_4_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g10*g20;
    real G6_0_0_0_1_1_5_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][5]*g10*g00;
    real G6_0_0_0_1_1_6_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][6]*g10*g10;
    real G6_0_0_0_1_1_7_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][7]*g10*g20;
    real G6_0_0_0_1_1_8_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g10*g00;
    real G6_0_0_0_1_1_8_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g10*g10;
    real G6_0_0_0_1_1_8_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g10*g20;
    real G6_0_0_0_1_1_9_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][9]*g10*g00;
    real G6_0_0_0_1_1_10_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][10]*g10*g10;
    real G6_0_0_0_1_1_11_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][11]*g10*g20;
    real G6_0_0_0_1_2_0_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g10*g00;
    real G6_0_0_0_1_2_0_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g10*g10;
    real G6_0_0_0_1_2_0_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g10*g20;
    real G6_0_0_0_1_2_1_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][1]*g10*g00;
    real G6_0_0_0_1_2_2_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][2]*g10*g10;
    real G6_0_0_0_1_2_3_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][3]*g10*g20;
    real G6_0_0_0_1_2_4_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g10*g00;
    real G6_0_0_0_1_2_4_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g10*g10;
    real G6_0_0_0_1_2_4_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g10*g20;
    real G6_0_0_0_1_2_5_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][5]*g10*g00;
    real G6_0_0_0_1_2_6_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][6]*g10*g10;
    real G6_0_0_0_1_2_7_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][7]*g10*g20;
    real G6_0_0_0_1_2_8_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g10*g00;
    real G6_0_0_0_1_2_8_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g10*g10;
    real G6_0_0_0_1_2_8_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g10*g20;
    real G6_0_0_0_1_2_9_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][9]*g10*g00;
    real G6_0_0_0_1_2_10_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][10]*g10*g10;
    real G6_0_0_0_1_2_11_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][11]*g10*g20;
    real G6_0_0_0_1_3_0_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g10*g00;
    real G6_0_0_0_1_3_0_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g10*g10;
    real G6_0_0_0_1_3_0_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g10*g20;
    real G6_0_0_0_1_3_1_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][1]*g10*g00;
    real G6_0_0_0_1_3_2_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][2]*g10*g10;
    real G6_0_0_0_1_3_3_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][3]*g10*g20;
    real G6_0_0_0_1_3_4_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g10*g00;
    real G6_0_0_0_1_3_4_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g10*g10;
    real G6_0_0_0_1_3_4_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g10*g20;
    real G6_0_0_0_1_3_5_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][5]*g10*g00;
    real G6_0_0_0_1_3_6_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][6]*g10*g10;
    real G6_0_0_0_1_3_7_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][7]*g10*g20;
    real G6_0_0_0_1_3_8_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g10*g00;
    real G6_0_0_0_1_3_8_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g10*g10;
    real G6_0_0_0_1_3_8_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g10*g20;
    real G6_0_0_0_1_3_9_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][9]*g10*g00;
    real G6_0_0_0_1_3_10_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][10]*g10*g10;
    real G6_0_0_0_1_3_11_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][11]*g10*g20;
    real G6_0_0_0_2_0_0_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g20*g00;
    real G6_0_0_0_2_0_0_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g20*g10;
    real G6_0_0_0_2_0_0_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][0]*g20*g20;
    real G6_0_0_0_2_0_1_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][1]*g20*g00;
    real G6_0_0_0_2_0_2_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][2]*g20*g10;
    real G6_0_0_0_2_0_3_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][3]*g20*g20;
    real G6_0_0_0_2_0_4_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g20*g00;
    real G6_0_0_0_2_0_4_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g20*g10;
    real G6_0_0_0_2_0_4_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][4]*g20*g20;
    real G6_0_0_0_2_0_5_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][5]*g20*g00;
    real G6_0_0_0_2_0_6_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][6]*g20*g10;
    real G6_0_0_0_2_0_7_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][7]*g20*g20;
    real G6_0_0_0_2_0_8_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g20*g00;
    real G6_0_0_0_2_0_8_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g20*g10;
    real G6_0_0_0_2_0_8_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][8]*g20*g20;
    real G6_0_0_0_2_0_9_0 = det*c1*c0*w[0][0]*w[0][0]*w[1][9]*g20*g00;
    real G6_0_0_0_2_0_10_1 = det*c1*c0*w[0][0]*w[0][0]*w[1][10]*g20*g10;
    real G6_0_0_0_2_0_11_2 = det*c1*c0*w[0][0]*w[0][0]*w[1][11]*g20*g20;
    real G6_0_0_0_2_1_0_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g20*g00;
    real G6_0_0_0_2_1_0_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g20*g10;
    real G6_0_0_0_2_1_0_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][0]*g20*g20;
    real G6_0_0_0_2_1_1_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][1]*g20*g00;
    real G6_0_0_0_2_1_2_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][2]*g20*g10;
    real G6_0_0_0_2_1_3_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][3]*g20*g20;
    real G6_0_0_0_2_1_4_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g20*g00;
    real G6_0_0_0_2_1_4_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g20*g10;
    real G6_0_0_0_2_1_4_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][4]*g20*g20;
    real G6_0_0_0_2_1_5_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][5]*g20*g00;
    real G6_0_0_0_2_1_6_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][6]*g20*g10;
    real G6_0_0_0_2_1_7_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][7]*g20*g20;
    real G6_0_0_0_2_1_8_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g20*g00;
    real G6_0_0_0_2_1_8_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g20*g10;
    real G6_0_0_0_2_1_8_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][8]*g20*g20;
    real G6_0_0_0_2_1_9_0 = det*c1*c0*w[0][0]*w[0][1]*w[1][9]*g20*g00;
    real G6_0_0_0_2_1_10_1 = det*c1*c0*w[0][0]*w[0][1]*w[1][10]*g20*g10;
    real G6_0_0_0_2_1_11_2 = det*c1*c0*w[0][0]*w[0][1]*w[1][11]*g20*g20;
    real G6_0_0_0_2_2_0_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g20*g00;
    real G6_0_0_0_2_2_0_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g20*g10;
    real G6_0_0_0_2_2_0_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][0]*g20*g20;
    real G6_0_0_0_2_2_1_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][1]*g20*g00;
    real G6_0_0_0_2_2_2_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][2]*g20*g10;
    real G6_0_0_0_2_2_3_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][3]*g20*g20;
    real G6_0_0_0_2_2_4_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g20*g00;
    real G6_0_0_0_2_2_4_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g20*g10;
    real G6_0_0_0_2_2_4_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][4]*g20*g20;
    real G6_0_0_0_2_2_5_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][5]*g20*g00;
    real G6_0_0_0_2_2_6_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][6]*g20*g10;
    real G6_0_0_0_2_2_7_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][7]*g20*g20;
    real G6_0_0_0_2_2_8_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g20*g00;
    real G6_0_0_0_2_2_8_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g20*g10;
    real G6_0_0_0_2_2_8_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][8]*g20*g20;
    real G6_0_0_0_2_2_9_0 = det*c1*c0*w[0][0]*w[0][2]*w[1][9]*g20*g00;
    real G6_0_0_0_2_2_10_1 = det*c1*c0*w[0][0]*w[0][2]*w[1][10]*g20*g10;
    real G6_0_0_0_2_2_11_2 = det*c1*c0*w[0][0]*w[0][2]*w[1][11]*g20*g20;
    real G6_0_0_0_2_3_0_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g20*g00;
    real G6_0_0_0_2_3_0_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g20*g10;
    real G6_0_0_0_2_3_0_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][0]*g20*g20;
    real G6_0_0_0_2_3_1_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][1]*g20*g00;
    real G6_0_0_0_2_3_2_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][2]*g20*g10;
    real G6_0_0_0_2_3_3_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][3]*g20*g20;
    real G6_0_0_0_2_3_4_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g20*g00;
    real G6_0_0_0_2_3_4_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g20*g10;
    real G6_0_0_0_2_3_4_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][4]*g20*g20;
    real G6_0_0_0_2_3_5_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][5]*g20*g00;
    real G6_0_0_0_2_3_6_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][6]*g20*g10;
    real G6_0_0_0_2_3_7_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][7]*g20*g20;
    real G6_0_0_0_2_3_8_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g20*g00;
    real G6_0_0_0_2_3_8_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g20*g10;
    real G6_0_0_0_2_3_8_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][8]*g20*g20;
    real G6_0_0_0_2_3_9_0 = det*c1*c0*w[0][0]*w[0][3]*w[1][9]*g20*g00;
    real G6_0_0_0_2_3_10_1 = det*c1*c0*w[0][0]*w[0][3]*w[1][10]*g20*g10;
    real G6_0_0_0_2_3_11_2 = det*c1*c0*w[0][0]*w[0][3]*w[1][11]*g20*g20;
    real G6_0_0_1_0_0_0_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g00*g00;
    real G6_0_0_1_0_0_0_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g00*g10;
    real G6_0_0_1_0_0_0_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g00*g20;
    real G6_0_0_1_0_0_1_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][1]*g00*g00;
    real G6_0_0_1_0_0_2_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][2]*g00*g10;
    real G6_0_0_1_0_0_3_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][3]*g00*g20;
    real G6_0_0_1_0_0_4_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g00*g00;
    real G6_0_0_1_0_0_4_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g00*g10;
    real G6_0_0_1_0_0_4_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g00*g20;
    real G6_0_0_1_0_0_5_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][5]*g00*g00;
    real G6_0_0_1_0_0_6_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][6]*g00*g10;
    real G6_0_0_1_0_0_7_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][7]*g00*g20;
    real G6_0_0_1_0_0_8_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g00*g00;
    real G6_0_0_1_0_0_8_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g00*g10;
    real G6_0_0_1_0_0_8_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g00*g20;
    real G6_0_0_1_0_0_9_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][9]*g00*g00;
    real G6_0_0_1_0_0_10_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][10]*g00*g10;
    real G6_0_0_1_0_0_11_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][11]*g00*g20;
    real G6_0_0_1_0_1_0_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g00*g00;
    real G6_0_0_1_0_1_0_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g00*g10;
    real G6_0_0_1_0_1_0_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g00*g20;
    real G6_0_0_1_0_1_1_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][1]*g00*g00;
    real G6_0_0_1_0_1_2_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][2]*g00*g10;
    real G6_0_0_1_0_1_3_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][3]*g00*g20;
    real G6_0_0_1_0_1_4_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g00*g00;
    real G6_0_0_1_0_1_4_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g00*g10;
    real G6_0_0_1_0_1_4_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g00*g20;
    real G6_0_0_1_0_1_5_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][5]*g00*g00;
    real G6_0_0_1_0_1_6_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][6]*g00*g10;
    real G6_0_0_1_0_1_7_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][7]*g00*g20;
    real G6_0_0_1_0_1_8_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g00*g00;
    real G6_0_0_1_0_1_8_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g00*g10;
    real G6_0_0_1_0_1_8_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g00*g20;
    real G6_0_0_1_0_1_9_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][9]*g00*g00;
    real G6_0_0_1_0_1_10_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][10]*g00*g10;
    real G6_0_0_1_0_1_11_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][11]*g00*g20;
    real G6_0_0_1_0_2_0_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g00*g00;
    real G6_0_0_1_0_2_0_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g00*g10;
    real G6_0_0_1_0_2_0_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g00*g20;
    real G6_0_0_1_0_2_1_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][1]*g00*g00;
    real G6_0_0_1_0_2_2_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][2]*g00*g10;
    real G6_0_0_1_0_2_3_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][3]*g00*g20;
    real G6_0_0_1_0_2_4_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g00*g00;
    real G6_0_0_1_0_2_4_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g00*g10;
    real G6_0_0_1_0_2_4_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g00*g20;
    real G6_0_0_1_0_2_5_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][5]*g00*g00;
    real G6_0_0_1_0_2_6_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][6]*g00*g10;
    real G6_0_0_1_0_2_7_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][7]*g00*g20;
    real G6_0_0_1_0_2_8_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g00*g00;
    real G6_0_0_1_0_2_8_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g00*g10;
    real G6_0_0_1_0_2_8_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g00*g20;
    real G6_0_0_1_0_2_9_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][9]*g00*g00;
    real G6_0_0_1_0_2_10_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][10]*g00*g10;
    real G6_0_0_1_0_2_11_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][11]*g00*g20;
    real G6_0_0_1_0_3_0_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g00*g00;
    real G6_0_0_1_0_3_0_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g00*g10;
    real G6_0_0_1_0_3_0_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g00*g20;
    real G6_0_0_1_0_3_1_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][1]*g00*g00;
    real G6_0_0_1_0_3_2_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][2]*g00*g10;
    real G6_0_0_1_0_3_3_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][3]*g00*g20;
    real G6_0_0_1_0_3_4_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g00*g00;
    real G6_0_0_1_0_3_4_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g00*g10;
    real G6_0_0_1_0_3_4_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g00*g20;
    real G6_0_0_1_0_3_5_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][5]*g00*g00;
    real G6_0_0_1_0_3_6_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][6]*g00*g10;
    real G6_0_0_1_0_3_7_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][7]*g00*g20;
    real G6_0_0_1_0_3_8_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g00*g00;
    real G6_0_0_1_0_3_8_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g00*g10;
    real G6_0_0_1_0_3_8_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g00*g20;
    real G6_0_0_1_0_3_9_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][9]*g00*g00;
    real G6_0_0_1_0_3_10_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][10]*g00*g10;
    real G6_0_0_1_0_3_11_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][11]*g00*g20;
    real G6_0_0_1_1_0_0_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g10*g00;
    real G6_0_0_1_1_0_0_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g10*g10;
    real G6_0_0_1_1_0_0_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g10*g20;
    real G6_0_0_1_1_0_1_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][1]*g10*g00;
    real G6_0_0_1_1_0_2_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][2]*g10*g10;
    real G6_0_0_1_1_0_3_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][3]*g10*g20;
    real G6_0_0_1_1_0_4_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g10*g00;
    real G6_0_0_1_1_0_4_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g10*g10;
    real G6_0_0_1_1_0_4_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g10*g20;
    real G6_0_0_1_1_0_5_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][5]*g10*g00;
    real G6_0_0_1_1_0_6_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][6]*g10*g10;
    real G6_0_0_1_1_0_7_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][7]*g10*g20;
    real G6_0_0_1_1_0_8_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g10*g00;
    real G6_0_0_1_1_0_8_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g10*g10;
    real G6_0_0_1_1_0_8_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g10*g20;
    real G6_0_0_1_1_0_9_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][9]*g10*g00;
    real G6_0_0_1_1_0_10_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][10]*g10*g10;
    real G6_0_0_1_1_0_11_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][11]*g10*g20;
    real G6_0_0_1_1_1_0_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g10*g00;
    real G6_0_0_1_1_1_0_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g10*g10;
    real G6_0_0_1_1_1_0_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g10*g20;
    real G6_0_0_1_1_1_1_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][1]*g10*g00;
    real G6_0_0_1_1_1_2_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][2]*g10*g10;
    real G6_0_0_1_1_1_3_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][3]*g10*g20;
    real G6_0_0_1_1_1_4_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g10*g00;
    real G6_0_0_1_1_1_4_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g10*g10;
    real G6_0_0_1_1_1_4_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g10*g20;
    real G6_0_0_1_1_1_5_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][5]*g10*g00;
    real G6_0_0_1_1_1_6_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][6]*g10*g10;
    real G6_0_0_1_1_1_7_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][7]*g10*g20;
    real G6_0_0_1_1_1_8_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g10*g00;
    real G6_0_0_1_1_1_8_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g10*g10;
    real G6_0_0_1_1_1_8_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g10*g20;
    real G6_0_0_1_1_1_9_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][9]*g10*g00;
    real G6_0_0_1_1_1_10_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][10]*g10*g10;
    real G6_0_0_1_1_1_11_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][11]*g10*g20;
    real G6_0_0_1_1_2_0_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g10*g00;
    real G6_0_0_1_1_2_0_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g10*g10;
    real G6_0_0_1_1_2_0_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g10*g20;
    real G6_0_0_1_1_2_1_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][1]*g10*g00;
    real G6_0_0_1_1_2_2_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][2]*g10*g10;
    real G6_0_0_1_1_2_3_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][3]*g10*g20;
    real G6_0_0_1_1_2_4_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g10*g00;
    real G6_0_0_1_1_2_4_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g10*g10;
    real G6_0_0_1_1_2_4_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g10*g20;
    real G6_0_0_1_1_2_5_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][5]*g10*g00;
    real G6_0_0_1_1_2_6_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][6]*g10*g10;
    real G6_0_0_1_1_2_7_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][7]*g10*g20;
    real G6_0_0_1_1_2_8_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g10*g00;
    real G6_0_0_1_1_2_8_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g10*g10;
    real G6_0_0_1_1_2_8_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g10*g20;
    real G6_0_0_1_1_2_9_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][9]*g10*g00;
    real G6_0_0_1_1_2_10_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][10]*g10*g10;
    real G6_0_0_1_1_2_11_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][11]*g10*g20;
    real G6_0_0_1_1_3_0_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g10*g00;
    real G6_0_0_1_1_3_0_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g10*g10;
    real G6_0_0_1_1_3_0_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g10*g20;
    real G6_0_0_1_1_3_1_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][1]*g10*g00;
    real G6_0_0_1_1_3_2_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][2]*g10*g10;
    real G6_0_0_1_1_3_3_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][3]*g10*g20;
    real G6_0_0_1_1_3_4_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g10*g00;
    real G6_0_0_1_1_3_4_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g10*g10;
    real G6_0_0_1_1_3_4_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g10*g20;
    real G6_0_0_1_1_3_5_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][5]*g10*g00;
    real G6_0_0_1_1_3_6_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][6]*g10*g10;
    real G6_0_0_1_1_3_7_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][7]*g10*g20;
    real G6_0_0_1_1_3_8_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g10*g00;
    real G6_0_0_1_1_3_8_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g10*g10;
    real G6_0_0_1_1_3_8_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g10*g20;
    real G6_0_0_1_1_3_9_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][9]*g10*g00;
    real G6_0_0_1_1_3_10_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][10]*g10*g10;
    real G6_0_0_1_1_3_11_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][11]*g10*g20;
    real G6_0_0_1_2_0_0_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g20*g00;
    real G6_0_0_1_2_0_0_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g20*g10;
    real G6_0_0_1_2_0_0_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][0]*g20*g20;
    real G6_0_0_1_2_0_1_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][1]*g20*g00;
    real G6_0_0_1_2_0_2_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][2]*g20*g10;
    real G6_0_0_1_2_0_3_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][3]*g20*g20;
    real G6_0_0_1_2_0_4_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g20*g00;
    real G6_0_0_1_2_0_4_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g20*g10;
    real G6_0_0_1_2_0_4_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][4]*g20*g20;
    real G6_0_0_1_2_0_5_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][5]*g20*g00;
    real G6_0_0_1_2_0_6_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][6]*g20*g10;
    real G6_0_0_1_2_0_7_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][7]*g20*g20;
    real G6_0_0_1_2_0_8_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g20*g00;
    real G6_0_0_1_2_0_8_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g20*g10;
    real G6_0_0_1_2_0_8_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][8]*g20*g20;
    real G6_0_0_1_2_0_9_0 = det*c1*c0*w[0][1]*w[0][0]*w[1][9]*g20*g00;
    real G6_0_0_1_2_0_10_1 = det*c1*c0*w[0][1]*w[0][0]*w[1][10]*g20*g10;
    real G6_0_0_1_2_0_11_2 = det*c1*c0*w[0][1]*w[0][0]*w[1][11]*g20*g20;
    real G6_0_0_1_2_1_0_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g20*g00;
    real G6_0_0_1_2_1_0_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g20*g10;
    real G6_0_0_1_2_1_0_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][0]*g20*g20;
    real G6_0_0_1_2_1_1_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][1]*g20*g00;
    real G6_0_0_1_2_1_2_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][2]*g20*g10;
    real G6_0_0_1_2_1_3_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][3]*g20*g20;
    real G6_0_0_1_2_1_4_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g20*g00;
    real G6_0_0_1_2_1_4_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g20*g10;
    real G6_0_0_1_2_1_4_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][4]*g20*g20;
    real G6_0_0_1_2_1_5_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][5]*g20*g00;
    real G6_0_0_1_2_1_6_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][6]*g20*g10;
    real G6_0_0_1_2_1_7_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][7]*g20*g20;
    real G6_0_0_1_2_1_8_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g20*g00;
    real G6_0_0_1_2_1_8_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g20*g10;
    real G6_0_0_1_2_1_8_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][8]*g20*g20;
    real G6_0_0_1_2_1_9_0 = det*c1*c0*w[0][1]*w[0][1]*w[1][9]*g20*g00;
    real G6_0_0_1_2_1_10_1 = det*c1*c0*w[0][1]*w[0][1]*w[1][10]*g20*g10;
    real G6_0_0_1_2_1_11_2 = det*c1*c0*w[0][1]*w[0][1]*w[1][11]*g20*g20;
    real G6_0_0_1_2_2_0_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g20*g00;
    real G6_0_0_1_2_2_0_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g20*g10;
    real G6_0_0_1_2_2_0_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][0]*g20*g20;
    real G6_0_0_1_2_2_1_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][1]*g20*g00;
    real G6_0_0_1_2_2_2_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][2]*g20*g10;
    real G6_0_0_1_2_2_3_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][3]*g20*g20;
    real G6_0_0_1_2_2_4_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g20*g00;
    real G6_0_0_1_2_2_4_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g20*g10;
    real G6_0_0_1_2_2_4_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][4]*g20*g20;
    real G6_0_0_1_2_2_5_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][5]*g20*g00;
    real G6_0_0_1_2_2_6_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][6]*g20*g10;
    real G6_0_0_1_2_2_7_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][7]*g20*g20;
    real G6_0_0_1_2_2_8_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g20*g00;
    real G6_0_0_1_2_2_8_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g20*g10;
    real G6_0_0_1_2_2_8_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][8]*g20*g20;
    real G6_0_0_1_2_2_9_0 = det*c1*c0*w[0][1]*w[0][2]*w[1][9]*g20*g00;
    real G6_0_0_1_2_2_10_1 = det*c1*c0*w[0][1]*w[0][2]*w[1][10]*g20*g10;
    real G6_0_0_1_2_2_11_2 = det*c1*c0*w[0][1]*w[0][2]*w[1][11]*g20*g20;
    real G6_0_0_1_2_3_0_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g20*g00;
    real G6_0_0_1_2_3_0_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g20*g10;
    real G6_0_0_1_2_3_0_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][0]*g20*g20;
    real G6_0_0_1_2_3_1_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][1]*g20*g00;
    real G6_0_0_1_2_3_2_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][2]*g20*g10;
    real G6_0_0_1_2_3_3_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][3]*g20*g20;
    real G6_0_0_1_2_3_4_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g20*g00;
    real G6_0_0_1_2_3_4_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g20*g10;
    real G6_0_0_1_2_3_4_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][4]*g20*g20;
    real G6_0_0_1_2_3_5_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][5]*g20*g00;
    real G6_0_0_1_2_3_6_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][6]*g20*g10;
    real G6_0_0_1_2_3_7_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][7]*g20*g20;
    real G6_0_0_1_2_3_8_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g20*g00;
    real G6_0_0_1_2_3_8_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g20*g10;
    real G6_0_0_1_2_3_8_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][8]*g20*g20;
    real G6_0_0_1_2_3_9_0 = det*c1*c0*w[0][1]*w[0][3]*w[1][9]*g20*g00;
    real G6_0_0_1_2_3_10_1 = det*c1*c0*w[0][1]*w[0][3]*w[1][10]*g20*g10;
    real G6_0_0_1_2_3_11_2 = det*c1*c0*w[0][1]*w[0][3]*w[1][11]*g20*g20;
    real G6_0_0_2_0_0_0_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g00*g00;
    real G6_0_0_2_0_0_0_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g00*g10;
    real G6_0_0_2_0_0_0_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g00*g20;
    real G6_0_0_2_0_0_1_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][1]*g00*g00;
    real G6_0_0_2_0_0_2_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][2]*g00*g10;
    real G6_0_0_2_0_0_3_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][3]*g00*g20;
    real G6_0_0_2_0_0_4_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g00*g00;
    real G6_0_0_2_0_0_4_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g00*g10;
    real G6_0_0_2_0_0_4_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g00*g20;
    real G6_0_0_2_0_0_5_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][5]*g00*g00;
    real G6_0_0_2_0_0_6_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][6]*g00*g10;
    real G6_0_0_2_0_0_7_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][7]*g00*g20;
    real G6_0_0_2_0_0_8_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g00*g00;
    real G6_0_0_2_0_0_8_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g00*g10;
    real G6_0_0_2_0_0_8_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g00*g20;
    real G6_0_0_2_0_0_9_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][9]*g00*g00;
    real G6_0_0_2_0_0_10_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][10]*g00*g10;
    real G6_0_0_2_0_0_11_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][11]*g00*g20;
    real G6_0_0_2_0_1_0_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g00*g00;
    real G6_0_0_2_0_1_0_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g00*g10;
    real G6_0_0_2_0_1_0_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g00*g20;
    real G6_0_0_2_0_1_1_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][1]*g00*g00;
    real G6_0_0_2_0_1_2_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][2]*g00*g10;
    real G6_0_0_2_0_1_3_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][3]*g00*g20;
    real G6_0_0_2_0_1_4_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g00*g00;
    real G6_0_0_2_0_1_4_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g00*g10;
    real G6_0_0_2_0_1_4_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g00*g20;
    real G6_0_0_2_0_1_5_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][5]*g00*g00;
    real G6_0_0_2_0_1_6_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][6]*g00*g10;
    real G6_0_0_2_0_1_7_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][7]*g00*g20;
    real G6_0_0_2_0_1_8_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g00*g00;
    real G6_0_0_2_0_1_8_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g00*g10;
    real G6_0_0_2_0_1_8_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g00*g20;
    real G6_0_0_2_0_1_9_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][9]*g00*g00;
    real G6_0_0_2_0_1_10_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][10]*g00*g10;
    real G6_0_0_2_0_1_11_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][11]*g00*g20;
    real G6_0_0_2_0_2_0_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g00*g00;
    real G6_0_0_2_0_2_0_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g00*g10;
    real G6_0_0_2_0_2_0_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g00*g20;
    real G6_0_0_2_0_2_1_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][1]*g00*g00;
    real G6_0_0_2_0_2_2_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][2]*g00*g10;
    real G6_0_0_2_0_2_3_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][3]*g00*g20;
    real G6_0_0_2_0_2_4_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g00*g00;
    real G6_0_0_2_0_2_4_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g00*g10;
    real G6_0_0_2_0_2_4_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g00*g20;
    real G6_0_0_2_0_2_5_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][5]*g00*g00;
    real G6_0_0_2_0_2_6_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][6]*g00*g10;
    real G6_0_0_2_0_2_7_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][7]*g00*g20;
    real G6_0_0_2_0_2_8_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g00*g00;
    real G6_0_0_2_0_2_8_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g00*g10;
    real G6_0_0_2_0_2_8_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g00*g20;
    real G6_0_0_2_0_2_9_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][9]*g00*g00;
    real G6_0_0_2_0_2_10_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][10]*g00*g10;
    real G6_0_0_2_0_2_11_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][11]*g00*g20;
    real G6_0_0_2_0_3_0_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g00*g00;
    real G6_0_0_2_0_3_0_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g00*g10;
    real G6_0_0_2_0_3_0_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g00*g20;
    real G6_0_0_2_0_3_1_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][1]*g00*g00;
    real G6_0_0_2_0_3_2_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][2]*g00*g10;
    real G6_0_0_2_0_3_3_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][3]*g00*g20;
    real G6_0_0_2_0_3_4_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g00*g00;
    real G6_0_0_2_0_3_4_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g00*g10;
    real G6_0_0_2_0_3_4_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g00*g20;
    real G6_0_0_2_0_3_5_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][5]*g00*g00;
    real G6_0_0_2_0_3_6_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][6]*g00*g10;
    real G6_0_0_2_0_3_7_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][7]*g00*g20;
    real G6_0_0_2_0_3_8_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g00*g00;
    real G6_0_0_2_0_3_8_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g00*g10;
    real G6_0_0_2_0_3_8_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g00*g20;
    real G6_0_0_2_0_3_9_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][9]*g00*g00;
    real G6_0_0_2_0_3_10_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][10]*g00*g10;
    real G6_0_0_2_0_3_11_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][11]*g00*g20;
    real G6_0_0_2_1_0_0_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g10*g00;
    real G6_0_0_2_1_0_0_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g10*g10;
    real G6_0_0_2_1_0_0_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g10*g20;
    real G6_0_0_2_1_0_1_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][1]*g10*g00;
    real G6_0_0_2_1_0_2_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][2]*g10*g10;
    real G6_0_0_2_1_0_3_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][3]*g10*g20;
    real G6_0_0_2_1_0_4_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g10*g00;
    real G6_0_0_2_1_0_4_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g10*g10;
    real G6_0_0_2_1_0_4_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g10*g20;
    real G6_0_0_2_1_0_5_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][5]*g10*g00;
    real G6_0_0_2_1_0_6_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][6]*g10*g10;
    real G6_0_0_2_1_0_7_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][7]*g10*g20;
    real G6_0_0_2_1_0_8_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g10*g00;
    real G6_0_0_2_1_0_8_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g10*g10;
    real G6_0_0_2_1_0_8_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g10*g20;
    real G6_0_0_2_1_0_9_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][9]*g10*g00;
    real G6_0_0_2_1_0_10_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][10]*g10*g10;
    real G6_0_0_2_1_0_11_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][11]*g10*g20;
    real G6_0_0_2_1_1_0_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g10*g00;
    real G6_0_0_2_1_1_0_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g10*g10;
    real G6_0_0_2_1_1_0_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g10*g20;
    real G6_0_0_2_1_1_1_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][1]*g10*g00;
    real G6_0_0_2_1_1_2_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][2]*g10*g10;
    real G6_0_0_2_1_1_3_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][3]*g10*g20;
    real G6_0_0_2_1_1_4_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g10*g00;
    real G6_0_0_2_1_1_4_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g10*g10;
    real G6_0_0_2_1_1_4_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g10*g20;
    real G6_0_0_2_1_1_5_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][5]*g10*g00;
    real G6_0_0_2_1_1_6_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][6]*g10*g10;
    real G6_0_0_2_1_1_7_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][7]*g10*g20;
    real G6_0_0_2_1_1_8_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g10*g00;
    real G6_0_0_2_1_1_8_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g10*g10;
    real G6_0_0_2_1_1_8_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g10*g20;
    real G6_0_0_2_1_1_9_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][9]*g10*g00;
    real G6_0_0_2_1_1_10_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][10]*g10*g10;
    real G6_0_0_2_1_1_11_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][11]*g10*g20;
    real G6_0_0_2_1_2_0_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g10*g00;
    real G6_0_0_2_1_2_0_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g10*g10;
    real G6_0_0_2_1_2_0_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g10*g20;
    real G6_0_0_2_1_2_1_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][1]*g10*g00;
    real G6_0_0_2_1_2_2_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][2]*g10*g10;
    real G6_0_0_2_1_2_3_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][3]*g10*g20;
    real G6_0_0_2_1_2_4_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g10*g00;
    real G6_0_0_2_1_2_4_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g10*g10;
    real G6_0_0_2_1_2_4_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g10*g20;
    real G6_0_0_2_1_2_5_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][5]*g10*g00;
    real G6_0_0_2_1_2_6_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][6]*g10*g10;
    real G6_0_0_2_1_2_7_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][7]*g10*g20;
    real G6_0_0_2_1_2_8_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g10*g00;
    real G6_0_0_2_1_2_8_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g10*g10;
    real G6_0_0_2_1_2_8_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g10*g20;
    real G6_0_0_2_1_2_9_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][9]*g10*g00;
    real G6_0_0_2_1_2_10_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][10]*g10*g10;
    real G6_0_0_2_1_2_11_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][11]*g10*g20;
    real G6_0_0_2_1_3_0_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g10*g00;
    real G6_0_0_2_1_3_0_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g10*g10;
    real G6_0_0_2_1_3_0_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g10*g20;
    real G6_0_0_2_1_3_1_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][1]*g10*g00;
    real G6_0_0_2_1_3_2_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][2]*g10*g10;
    real G6_0_0_2_1_3_3_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][3]*g10*g20;
    real G6_0_0_2_1_3_4_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g10*g00;
    real G6_0_0_2_1_3_4_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g10*g10;
    real G6_0_0_2_1_3_4_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g10*g20;
    real G6_0_0_2_1_3_5_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][5]*g10*g00;
    real G6_0_0_2_1_3_6_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][6]*g10*g10;
    real G6_0_0_2_1_3_7_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][7]*g10*g20;
    real G6_0_0_2_1_3_8_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g10*g00;
    real G6_0_0_2_1_3_8_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g10*g10;
    real G6_0_0_2_1_3_8_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g10*g20;
    real G6_0_0_2_1_3_9_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][9]*g10*g00;
    real G6_0_0_2_1_3_10_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][10]*g10*g10;
    real G6_0_0_2_1_3_11_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][11]*g10*g20;
    real G6_0_0_2_2_0_0_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g20*g00;
    real G6_0_0_2_2_0_0_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g20*g10;
    real G6_0_0_2_2_0_0_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][0]*g20*g20;
    real G6_0_0_2_2_0_1_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][1]*g20*g00;
    real G6_0_0_2_2_0_2_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][2]*g20*g10;
    real G6_0_0_2_2_0_3_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][3]*g20*g20;
    real G6_0_0_2_2_0_4_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g20*g00;
    real G6_0_0_2_2_0_4_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g20*g10;
    real G6_0_0_2_2_0_4_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][4]*g20*g20;
    real G6_0_0_2_2_0_5_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][5]*g20*g00;
    real G6_0_0_2_2_0_6_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][6]*g20*g10;
    real G6_0_0_2_2_0_7_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][7]*g20*g20;
    real G6_0_0_2_2_0_8_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g20*g00;
    real G6_0_0_2_2_0_8_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g20*g10;
    real G6_0_0_2_2_0_8_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][8]*g20*g20;
    real G6_0_0_2_2_0_9_0 = det*c1*c0*w[0][2]*w[0][0]*w[1][9]*g20*g00;
    real G6_0_0_2_2_0_10_1 = det*c1*c0*w[0][2]*w[0][0]*w[1][10]*g20*g10;
    real G6_0_0_2_2_0_11_2 = det*c1*c0*w[0][2]*w[0][0]*w[1][11]*g20*g20;
    real G6_0_0_2_2_1_0_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g20*g00;
    real G6_0_0_2_2_1_0_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g20*g10;
    real G6_0_0_2_2_1_0_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][0]*g20*g20;
    real G6_0_0_2_2_1_1_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][1]*g20*g00;
    real G6_0_0_2_2_1_2_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][2]*g20*g10;
    real G6_0_0_2_2_1_3_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][3]*g20*g20;
    real G6_0_0_2_2_1_4_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g20*g00;
    real G6_0_0_2_2_1_4_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g20*g10;
    real G6_0_0_2_2_1_4_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][4]*g20*g20;
    real G6_0_0_2_2_1_5_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][5]*g20*g00;
    real G6_0_0_2_2_1_6_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][6]*g20*g10;
    real G6_0_0_2_2_1_7_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][7]*g20*g20;
    real G6_0_0_2_2_1_8_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g20*g00;
    real G6_0_0_2_2_1_8_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g20*g10;
    real G6_0_0_2_2_1_8_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][8]*g20*g20;
    real G6_0_0_2_2_1_9_0 = det*c1*c0*w[0][2]*w[0][1]*w[1][9]*g20*g00;
    real G6_0_0_2_2_1_10_1 = det*c1*c0*w[0][2]*w[0][1]*w[1][10]*g20*g10;
    real G6_0_0_2_2_1_11_2 = det*c1*c0*w[0][2]*w[0][1]*w[1][11]*g20*g20;
    real G6_0_0_2_2_2_0_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g20*g00;
    real G6_0_0_2_2_2_0_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g20*g10;
    real G6_0_0_2_2_2_0_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][0]*g20*g20;
    real G6_0_0_2_2_2_1_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][1]*g20*g00;
    real G6_0_0_2_2_2_2_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][2]*g20*g10;
    real G6_0_0_2_2_2_3_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][3]*g20*g20;
    real G6_0_0_2_2_2_4_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g20*g00;
    real G6_0_0_2_2_2_4_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g20*g10;
    real G6_0_0_2_2_2_4_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][4]*g20*g20;
    real G6_0_0_2_2_2_5_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][5]*g20*g00;
    real G6_0_0_2_2_2_6_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][6]*g20*g10;
    real G6_0_0_2_2_2_7_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][7]*g20*g20;
    real G6_0_0_2_2_2_8_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g20*g00;
    real G6_0_0_2_2_2_8_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g20*g10;
    real G6_0_0_2_2_2_8_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][8]*g20*g20;
    real G6_0_0_2_2_2_9_0 = det*c1*c0*w[0][2]*w[0][2]*w[1][9]*g20*g00;
    real G6_0_0_2_2_2_10_1 = det*c1*c0*w[0][2]*w[0][2]*w[1][10]*g20*g10;
    real G6_0_0_2_2_2_11_2 = det*c1*c0*w[0][2]*w[0][2]*w[1][11]*g20*g20;
    real G6_0_0_2_2_3_0_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g20*g00;
    real G6_0_0_2_2_3_0_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g20*g10;
    real G6_0_0_2_2_3_0_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][0]*g20*g20;
    real G6_0_0_2_2_3_1_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][1]*g20*g00;
    real G6_0_0_2_2_3_2_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][2]*g20*g10;
    real G6_0_0_2_2_3_3_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][3]*g20*g20;
    real G6_0_0_2_2_3_4_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g20*g00;
    real G6_0_0_2_2_3_4_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g20*g10;
    real G6_0_0_2_2_3_4_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][4]*g20*g20;
    real G6_0_0_2_2_3_5_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][5]*g20*g00;
    real G6_0_0_2_2_3_6_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][6]*g20*g10;
    real G6_0_0_2_2_3_7_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][7]*g20*g20;
    real G6_0_0_2_2_3_8_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g20*g00;
    real G6_0_0_2_2_3_8_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g20*g10;
    real G6_0_0_2_2_3_8_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][8]*g20*g20;
    real G6_0_0_2_2_3_9_0 = det*c1*c0*w[0][2]*w[0][3]*w[1][9]*g20*g00;
    real G6_0_0_2_2_3_10_1 = det*c1*c0*w[0][2]*w[0][3]*w[1][10]*g20*g10;
    real G6_0_0_2_2_3_11_2 = det*c1*c0*w[0][2]*w[0][3]*w[1][11]*g20*g20;
    real G6_0_0_3_0_0_0_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g00*g00;
    real G6_0_0_3_0_0_0_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g00*g10;
    real G6_0_0_3_0_0_0_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g00*g20;
    real G6_0_0_3_0_0_1_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][1]*g00*g00;
    real G6_0_0_3_0_0_2_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][2]*g00*g10;
    real G6_0_0_3_0_0_3_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][3]*g00*g20;
    real G6_0_0_3_0_0_4_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g00*g00;
    real G6_0_0_3_0_0_4_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g00*g10;
    real G6_0_0_3_0_0_4_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g00*g20;
    real G6_0_0_3_0_0_5_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][5]*g00*g00;
    real G6_0_0_3_0_0_6_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][6]*g00*g10;
    real G6_0_0_3_0_0_7_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][7]*g00*g20;
    real G6_0_0_3_0_0_8_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g00*g00;
    real G6_0_0_3_0_0_8_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g00*g10;
    real G6_0_0_3_0_0_8_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g00*g20;
    real G6_0_0_3_0_0_9_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][9]*g00*g00;
    real G6_0_0_3_0_0_10_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][10]*g00*g10;
    real G6_0_0_3_0_0_11_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][11]*g00*g20;
    real G6_0_0_3_0_1_0_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g00*g00;
    real G6_0_0_3_0_1_0_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g00*g10;
    real G6_0_0_3_0_1_0_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g00*g20;
    real G6_0_0_3_0_1_1_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][1]*g00*g00;
    real G6_0_0_3_0_1_2_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][2]*g00*g10;
    real G6_0_0_3_0_1_3_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][3]*g00*g20;
    real G6_0_0_3_0_1_4_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g00*g00;
    real G6_0_0_3_0_1_4_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g00*g10;
    real G6_0_0_3_0_1_4_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g00*g20;
    real G6_0_0_3_0_1_5_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][5]*g00*g00;
    real G6_0_0_3_0_1_6_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][6]*g00*g10;
    real G6_0_0_3_0_1_7_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][7]*g00*g20;
    real G6_0_0_3_0_1_8_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g00*g00;
    real G6_0_0_3_0_1_8_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g00*g10;
    real G6_0_0_3_0_1_8_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g00*g20;
    real G6_0_0_3_0_1_9_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][9]*g00*g00;
    real G6_0_0_3_0_1_10_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][10]*g00*g10;
    real G6_0_0_3_0_1_11_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][11]*g00*g20;
    real G6_0_0_3_0_2_0_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g00*g00;
    real G6_0_0_3_0_2_0_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g00*g10;
    real G6_0_0_3_0_2_0_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g00*g20;
    real G6_0_0_3_0_2_1_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][1]*g00*g00;
    real G6_0_0_3_0_2_2_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][2]*g00*g10;
    real G6_0_0_3_0_2_3_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][3]*g00*g20;
    real G6_0_0_3_0_2_4_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g00*g00;
    real G6_0_0_3_0_2_4_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g00*g10;
    real G6_0_0_3_0_2_4_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g00*g20;
    real G6_0_0_3_0_2_5_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][5]*g00*g00;
    real G6_0_0_3_0_2_6_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][6]*g00*g10;
    real G6_0_0_3_0_2_7_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][7]*g00*g20;
    real G6_0_0_3_0_2_8_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g00*g00;
    real G6_0_0_3_0_2_8_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g00*g10;
    real G6_0_0_3_0_2_8_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g00*g20;
    real G6_0_0_3_0_2_9_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][9]*g00*g00;
    real G6_0_0_3_0_2_10_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][10]*g00*g10;
    real G6_0_0_3_0_2_11_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][11]*g00*g20;
    real G6_0_0_3_0_3_0_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g00*g00;
    real G6_0_0_3_0_3_0_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g00*g10;
    real G6_0_0_3_0_3_0_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g00*g20;
    real G6_0_0_3_0_3_1_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][1]*g00*g00;
    real G6_0_0_3_0_3_2_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][2]*g00*g10;
    real G6_0_0_3_0_3_3_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][3]*g00*g20;
    real G6_0_0_3_0_3_4_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g00*g00;
    real G6_0_0_3_0_3_4_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g00*g10;
    real G6_0_0_3_0_3_4_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g00*g20;
    real G6_0_0_3_0_3_5_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][5]*g00*g00;
    real G6_0_0_3_0_3_6_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][6]*g00*g10;
    real G6_0_0_3_0_3_7_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][7]*g00*g20;
    real G6_0_0_3_0_3_8_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g00*g00;
    real G6_0_0_3_0_3_8_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g00*g10;
    real G6_0_0_3_0_3_8_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g00*g20;
    real G6_0_0_3_0_3_9_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][9]*g00*g00;
    real G6_0_0_3_0_3_10_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][10]*g00*g10;
    real G6_0_0_3_0_3_11_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][11]*g00*g20;
    real G6_0_0_3_1_0_0_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g10*g00;
    real G6_0_0_3_1_0_0_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g10*g10;
    real G6_0_0_3_1_0_0_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g10*g20;
    real G6_0_0_3_1_0_1_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][1]*g10*g00;
    real G6_0_0_3_1_0_2_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][2]*g10*g10;
    real G6_0_0_3_1_0_3_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][3]*g10*g20;
    real G6_0_0_3_1_0_4_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g10*g00;
    real G6_0_0_3_1_0_4_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g10*g10;
    real G6_0_0_3_1_0_4_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g10*g20;
    real G6_0_0_3_1_0_5_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][5]*g10*g00;
    real G6_0_0_3_1_0_6_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][6]*g10*g10;
    real G6_0_0_3_1_0_7_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][7]*g10*g20;
    real G6_0_0_3_1_0_8_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g10*g00;
    real G6_0_0_3_1_0_8_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g10*g10;
    real G6_0_0_3_1_0_8_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g10*g20;
    real G6_0_0_3_1_0_9_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][9]*g10*g00;
    real G6_0_0_3_1_0_10_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][10]*g10*g10;
    real G6_0_0_3_1_0_11_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][11]*g10*g20;
    real G6_0_0_3_1_1_0_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g10*g00;
    real G6_0_0_3_1_1_0_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g10*g10;
    real G6_0_0_3_1_1_0_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g10*g20;
    real G6_0_0_3_1_1_1_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][1]*g10*g00;
    real G6_0_0_3_1_1_2_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][2]*g10*g10;
    real G6_0_0_3_1_1_3_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][3]*g10*g20;
    real G6_0_0_3_1_1_4_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g10*g00;
    real G6_0_0_3_1_1_4_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g10*g10;
    real G6_0_0_3_1_1_4_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g10*g20;
    real G6_0_0_3_1_1_5_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][5]*g10*g00;
    real G6_0_0_3_1_1_6_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][6]*g10*g10;
    real G6_0_0_3_1_1_7_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][7]*g10*g20;
    real G6_0_0_3_1_1_8_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g10*g00;
    real G6_0_0_3_1_1_8_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g10*g10;
    real G6_0_0_3_1_1_8_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g10*g20;
    real G6_0_0_3_1_1_9_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][9]*g10*g00;
    real G6_0_0_3_1_1_10_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][10]*g10*g10;
    real G6_0_0_3_1_1_11_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][11]*g10*g20;
    real G6_0_0_3_1_2_0_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g10*g00;
    real G6_0_0_3_1_2_0_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g10*g10;
    real G6_0_0_3_1_2_0_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g10*g20;
    real G6_0_0_3_1_2_1_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][1]*g10*g00;
    real G6_0_0_3_1_2_2_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][2]*g10*g10;
    real G6_0_0_3_1_2_3_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][3]*g10*g20;
    real G6_0_0_3_1_2_4_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g10*g00;
    real G6_0_0_3_1_2_4_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g10*g10;
    real G6_0_0_3_1_2_4_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g10*g20;
    real G6_0_0_3_1_2_5_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][5]*g10*g00;
    real G6_0_0_3_1_2_6_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][6]*g10*g10;
    real G6_0_0_3_1_2_7_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][7]*g10*g20;
    real G6_0_0_3_1_2_8_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g10*g00;
    real G6_0_0_3_1_2_8_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g10*g10;
    real G6_0_0_3_1_2_8_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g10*g20;
    real G6_0_0_3_1_2_9_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][9]*g10*g00;
    real G6_0_0_3_1_2_10_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][10]*g10*g10;
    real G6_0_0_3_1_2_11_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][11]*g10*g20;
    real G6_0_0_3_1_3_0_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g10*g00;
    real G6_0_0_3_1_3_0_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g10*g10;
    real G6_0_0_3_1_3_0_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g10*g20;
    real G6_0_0_3_1_3_1_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][1]*g10*g00;
    real G6_0_0_3_1_3_2_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][2]*g10*g10;
    real G6_0_0_3_1_3_3_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][3]*g10*g20;
    real G6_0_0_3_1_3_4_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g10*g00;
    real G6_0_0_3_1_3_4_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g10*g10;
    real G6_0_0_3_1_3_4_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g10*g20;
    real G6_0_0_3_1_3_5_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][5]*g10*g00;
    real G6_0_0_3_1_3_6_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][6]*g10*g10;
    real G6_0_0_3_1_3_7_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][7]*g10*g20;
    real G6_0_0_3_1_3_8_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g10*g00;
    real G6_0_0_3_1_3_8_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g10*g10;
    real G6_0_0_3_1_3_8_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g10*g20;
    real G6_0_0_3_1_3_9_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][9]*g10*g00;
    real G6_0_0_3_1_3_10_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][10]*g10*g10;
    real G6_0_0_3_1_3_11_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][11]*g10*g20;
    real G6_0_0_3_2_0_0_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g20*g00;
    real G6_0_0_3_2_0_0_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g20*g10;
    real G6_0_0_3_2_0_0_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][0]*g20*g20;
    real G6_0_0_3_2_0_1_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][1]*g20*g00;
    real G6_0_0_3_2_0_2_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][2]*g20*g10;
    real G6_0_0_3_2_0_3_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][3]*g20*g20;
    real G6_0_0_3_2_0_4_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g20*g00;
    real G6_0_0_3_2_0_4_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g20*g10;
    real G6_0_0_3_2_0_4_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][4]*g20*g20;
    real G6_0_0_3_2_0_5_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][5]*g20*g00;
    real G6_0_0_3_2_0_6_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][6]*g20*g10;
    real G6_0_0_3_2_0_7_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][7]*g20*g20;
    real G6_0_0_3_2_0_8_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g20*g00;
    real G6_0_0_3_2_0_8_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g20*g10;
    real G6_0_0_3_2_0_8_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][8]*g20*g20;
    real G6_0_0_3_2_0_9_0 = det*c1*c0*w[0][3]*w[0][0]*w[1][9]*g20*g00;
    real G6_0_0_3_2_0_10_1 = det*c1*c0*w[0][3]*w[0][0]*w[1][10]*g20*g10;
    real G6_0_0_3_2_0_11_2 = det*c1*c0*w[0][3]*w[0][0]*w[1][11]*g20*g20;
    real G6_0_0_3_2_1_0_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g20*g00;
    real G6_0_0_3_2_1_0_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g20*g10;
    real G6_0_0_3_2_1_0_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][0]*g20*g20;
    real G6_0_0_3_2_1_1_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][1]*g20*g00;
    real G6_0_0_3_2_1_2_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][2]*g20*g10;
    real G6_0_0_3_2_1_3_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][3]*g20*g20;
    real G6_0_0_3_2_1_4_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g20*g00;
    real G6_0_0_3_2_1_4_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g20*g10;
    real G6_0_0_3_2_1_4_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][4]*g20*g20;
    real G6_0_0_3_2_1_5_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][5]*g20*g00;
    real G6_0_0_3_2_1_6_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][6]*g20*g10;
    real G6_0_0_3_2_1_7_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][7]*g20*g20;
    real G6_0_0_3_2_1_8_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g20*g00;
    real G6_0_0_3_2_1_8_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g20*g10;
    real G6_0_0_3_2_1_8_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][8]*g20*g20;
    real G6_0_0_3_2_1_9_0 = det*c1*c0*w[0][3]*w[0][1]*w[1][9]*g20*g00;
    real G6_0_0_3_2_1_10_1 = det*c1*c0*w[0][3]*w[0][1]*w[1][10]*g20*g10;
    real G6_0_0_3_2_1_11_2 = det*c1*c0*w[0][3]*w[0][1]*w[1][11]*g20*g20;
    real G6_0_0_3_2_2_0_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g20*g00;
    real G6_0_0_3_2_2_0_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g20*g10;
    real G6_0_0_3_2_2_0_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][0]*g20*g20;
    real G6_0_0_3_2_2_1_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][1]*g20*g00;
    real G6_0_0_3_2_2_2_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][2]*g20*g10;
    real G6_0_0_3_2_2_3_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][3]*g20*g20;
    real G6_0_0_3_2_2_4_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g20*g00;
    real G6_0_0_3_2_2_4_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g20*g10;
    real G6_0_0_3_2_2_4_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][4]*g20*g20;
    real G6_0_0_3_2_2_5_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][5]*g20*g00;
    real G6_0_0_3_2_2_6_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][6]*g20*g10;
    real G6_0_0_3_2_2_7_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][7]*g20*g20;
    real G6_0_0_3_2_2_8_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g20*g00;
    real G6_0_0_3_2_2_8_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g20*g10;
    real G6_0_0_3_2_2_8_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][8]*g20*g20;
    real G6_0_0_3_2_2_9_0 = det*c1*c0*w[0][3]*w[0][2]*w[1][9]*g20*g00;
    real G6_0_0_3_2_2_10_1 = det*c1*c0*w[0][3]*w[0][2]*w[1][10]*g20*g10;
    real G6_0_0_3_2_2_11_2 = det*c1*c0*w[0][3]*w[0][2]*w[1][11]*g20*g20;
    real G6_0_0_3_2_3_0_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g20*g00;
    real G6_0_0_3_2_3_0_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g20*g10;
    real G6_0_0_3_2_3_0_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][0]*g20*g20;
    real G6_0_0_3_2_3_1_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][1]*g20*g00;
    real G6_0_0_3_2_3_2_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][2]*g20*g10;
    real G6_0_0_3_2_3_3_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][3]*g20*g20;
    real G6_0_0_3_2_3_4_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g20*g00;
    real G6_0_0_3_2_3_4_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g20*g10;
    real G6_0_0_3_2_3_4_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][4]*g20*g20;
    real G6_0_0_3_2_3_5_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][5]*g20*g00;
    real G6_0_0_3_2_3_6_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][6]*g20*g10;
    real G6_0_0_3_2_3_7_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][7]*g20*g20;
    real G6_0_0_3_2_3_8_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g20*g00;
    real G6_0_0_3_2_3_8_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g20*g10;
    real G6_0_0_3_2_3_8_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][8]*g20*g20;
    real G6_0_0_3_2_3_9_0 = det*c1*c0*w[0][3]*w[0][3]*w[1][9]*g20*g00;
    real G6_0_0_3_2_3_10_1 = det*c1*c0*w[0][3]*w[0][3]*w[1][10]*g20*g10;
    real G6_0_0_3_2_3_11_2 = det*c1*c0*w[0][3]*w[0][3]*w[1][11]*g20*g20;
    real G6_0_1_0_0_4_0_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g00*g01;
    real G6_0_1_0_0_4_0_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g00*g11;
    real G6_0_1_0_0_4_0_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g00*g21;
    real G6_0_1_0_0_4_1_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][1]*g00*g01;
    real G6_0_1_0_0_4_2_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][2]*g00*g11;
    real G6_0_1_0_0_4_3_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][3]*g00*g21;
    real G6_0_1_0_0_4_4_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g00*g01;
    real G6_0_1_0_0_4_4_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g00*g11;
    real G6_0_1_0_0_4_4_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g00*g21;
    real G6_0_1_0_0_4_5_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][5]*g00*g01;
    real G6_0_1_0_0_4_6_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][6]*g00*g11;
    real G6_0_1_0_0_4_7_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][7]*g00*g21;
    real G6_0_1_0_0_4_8_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g00*g01;
    real G6_0_1_0_0_4_8_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g00*g11;
    real G6_0_1_0_0_4_8_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g00*g21;
    real G6_0_1_0_0_4_9_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][9]*g00*g01;
    real G6_0_1_0_0_4_10_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][10]*g00*g11;
    real G6_0_1_0_0_4_11_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][11]*g00*g21;
    real G6_0_1_0_0_5_0_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g00*g01;
    real G6_0_1_0_0_5_0_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g00*g11;
    real G6_0_1_0_0_5_0_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g00*g21;
    real G6_0_1_0_0_5_1_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][1]*g00*g01;
    real G6_0_1_0_0_5_2_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][2]*g00*g11;
    real G6_0_1_0_0_5_3_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][3]*g00*g21;
    real G6_0_1_0_0_5_4_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g00*g01;
    real G6_0_1_0_0_5_4_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g00*g11;
    real G6_0_1_0_0_5_4_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g00*g21;
    real G6_0_1_0_0_5_5_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][5]*g00*g01;
    real G6_0_1_0_0_5_6_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][6]*g00*g11;
    real G6_0_1_0_0_5_7_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][7]*g00*g21;
    real G6_0_1_0_0_5_8_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g00*g01;
    real G6_0_1_0_0_5_8_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g00*g11;
    real G6_0_1_0_0_5_8_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g00*g21;
    real G6_0_1_0_0_5_9_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][9]*g00*g01;
    real G6_0_1_0_0_5_10_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][10]*g00*g11;
    real G6_0_1_0_0_5_11_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][11]*g00*g21;
    real G6_0_1_0_0_6_0_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g00*g01;
    real G6_0_1_0_0_6_0_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g00*g11;
    real G6_0_1_0_0_6_0_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g00*g21;
    real G6_0_1_0_0_6_1_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][1]*g00*g01;
    real G6_0_1_0_0_6_2_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][2]*g00*g11;
    real G6_0_1_0_0_6_3_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][3]*g00*g21;
    real G6_0_1_0_0_6_4_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g00*g01;
    real G6_0_1_0_0_6_4_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g00*g11;
    real G6_0_1_0_0_6_4_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g00*g21;
    real G6_0_1_0_0_6_5_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][5]*g00*g01;
    real G6_0_1_0_0_6_6_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][6]*g00*g11;
    real G6_0_1_0_0_6_7_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][7]*g00*g21;
    real G6_0_1_0_0_6_8_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g00*g01;
    real G6_0_1_0_0_6_8_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g00*g11;
    real G6_0_1_0_0_6_8_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g00*g21;
    real G6_0_1_0_0_6_9_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][9]*g00*g01;
    real G6_0_1_0_0_6_10_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][10]*g00*g11;
    real G6_0_1_0_0_6_11_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][11]*g00*g21;
    real G6_0_1_0_0_7_0_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g00*g01;
    real G6_0_1_0_0_7_0_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g00*g11;
    real G6_0_1_0_0_7_0_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g00*g21;
    real G6_0_1_0_0_7_1_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][1]*g00*g01;
    real G6_0_1_0_0_7_2_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][2]*g00*g11;
    real G6_0_1_0_0_7_3_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][3]*g00*g21;
    real G6_0_1_0_0_7_4_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g00*g01;
    real G6_0_1_0_0_7_4_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g00*g11;
    real G6_0_1_0_0_7_4_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g00*g21;
    real G6_0_1_0_0_7_5_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][5]*g00*g01;
    real G6_0_1_0_0_7_6_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][6]*g00*g11;
    real G6_0_1_0_0_7_7_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][7]*g00*g21;
    real G6_0_1_0_0_7_8_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g00*g01;
    real G6_0_1_0_0_7_8_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g00*g11;
    real G6_0_1_0_0_7_8_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g00*g21;
    real G6_0_1_0_0_7_9_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][9]*g00*g01;
    real G6_0_1_0_0_7_10_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][10]*g00*g11;
    real G6_0_1_0_0_7_11_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][11]*g00*g21;
    real G6_0_1_0_1_4_0_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g10*g01;
    real G6_0_1_0_1_4_0_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g10*g11;
    real G6_0_1_0_1_4_0_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g10*g21;
    real G6_0_1_0_1_4_1_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][1]*g10*g01;
    real G6_0_1_0_1_4_2_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][2]*g10*g11;
    real G6_0_1_0_1_4_3_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][3]*g10*g21;
    real G6_0_1_0_1_4_4_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g10*g01;
    real G6_0_1_0_1_4_4_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g10*g11;
    real G6_0_1_0_1_4_4_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g10*g21;
    real G6_0_1_0_1_4_5_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][5]*g10*g01;
    real G6_0_1_0_1_4_6_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][6]*g10*g11;
    real G6_0_1_0_1_4_7_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][7]*g10*g21;
    real G6_0_1_0_1_4_8_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g10*g01;
    real G6_0_1_0_1_4_8_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g10*g11;
    real G6_0_1_0_1_4_8_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g10*g21;
    real G6_0_1_0_1_4_9_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][9]*g10*g01;
    real G6_0_1_0_1_4_10_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][10]*g10*g11;
    real G6_0_1_0_1_4_11_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][11]*g10*g21;
    real G6_0_1_0_1_5_0_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g10*g01;
    real G6_0_1_0_1_5_0_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g10*g11;
    real G6_0_1_0_1_5_0_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g10*g21;
    real G6_0_1_0_1_5_1_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][1]*g10*g01;
    real G6_0_1_0_1_5_2_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][2]*g10*g11;
    real G6_0_1_0_1_5_3_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][3]*g10*g21;
    real G6_0_1_0_1_5_4_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g10*g01;
    real G6_0_1_0_1_5_4_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g10*g11;
    real G6_0_1_0_1_5_4_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g10*g21;
    real G6_0_1_0_1_5_5_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][5]*g10*g01;
    real G6_0_1_0_1_5_6_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][6]*g10*g11;
    real G6_0_1_0_1_5_7_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][7]*g10*g21;
    real G6_0_1_0_1_5_8_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g10*g01;
    real G6_0_1_0_1_5_8_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g10*g11;
    real G6_0_1_0_1_5_8_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g10*g21;
    real G6_0_1_0_1_5_9_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][9]*g10*g01;
    real G6_0_1_0_1_5_10_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][10]*g10*g11;
    real G6_0_1_0_1_5_11_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][11]*g10*g21;
    real G6_0_1_0_1_6_0_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g10*g01;
    real G6_0_1_0_1_6_0_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g10*g11;
    real G6_0_1_0_1_6_0_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g10*g21;
    real G6_0_1_0_1_6_1_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][1]*g10*g01;
    real G6_0_1_0_1_6_2_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][2]*g10*g11;
    real G6_0_1_0_1_6_3_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][3]*g10*g21;
    real G6_0_1_0_1_6_4_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g10*g01;
    real G6_0_1_0_1_6_4_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g10*g11;
    real G6_0_1_0_1_6_4_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g10*g21;
    real G6_0_1_0_1_6_5_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][5]*g10*g01;
    real G6_0_1_0_1_6_6_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][6]*g10*g11;
    real G6_0_1_0_1_6_7_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][7]*g10*g21;
    real G6_0_1_0_1_6_8_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g10*g01;
    real G6_0_1_0_1_6_8_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g10*g11;
    real G6_0_1_0_1_6_8_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g10*g21;
    real G6_0_1_0_1_6_9_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][9]*g10*g01;
    real G6_0_1_0_1_6_10_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][10]*g10*g11;
    real G6_0_1_0_1_6_11_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][11]*g10*g21;
    real G6_0_1_0_1_7_0_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g10*g01;
    real G6_0_1_0_1_7_0_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g10*g11;
    real G6_0_1_0_1_7_0_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g10*g21;
    real G6_0_1_0_1_7_1_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][1]*g10*g01;
    real G6_0_1_0_1_7_2_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][2]*g10*g11;
    real G6_0_1_0_1_7_3_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][3]*g10*g21;
    real G6_0_1_0_1_7_4_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g10*g01;
    real G6_0_1_0_1_7_4_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g10*g11;
    real G6_0_1_0_1_7_4_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g10*g21;
    real G6_0_1_0_1_7_5_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][5]*g10*g01;
    real G6_0_1_0_1_7_6_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][6]*g10*g11;
    real G6_0_1_0_1_7_7_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][7]*g10*g21;
    real G6_0_1_0_1_7_8_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g10*g01;
    real G6_0_1_0_1_7_8_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g10*g11;
    real G6_0_1_0_1_7_8_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g10*g21;
    real G6_0_1_0_1_7_9_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][9]*g10*g01;
    real G6_0_1_0_1_7_10_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][10]*g10*g11;
    real G6_0_1_0_1_7_11_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][11]*g10*g21;
    real G6_0_1_0_2_4_0_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g20*g01;
    real G6_0_1_0_2_4_0_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g20*g11;
    real G6_0_1_0_2_4_0_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][0]*g20*g21;
    real G6_0_1_0_2_4_1_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][1]*g20*g01;
    real G6_0_1_0_2_4_2_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][2]*g20*g11;
    real G6_0_1_0_2_4_3_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][3]*g20*g21;
    real G6_0_1_0_2_4_4_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g20*g01;
    real G6_0_1_0_2_4_4_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g20*g11;
    real G6_0_1_0_2_4_4_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][4]*g20*g21;
    real G6_0_1_0_2_4_5_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][5]*g20*g01;
    real G6_0_1_0_2_4_6_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][6]*g20*g11;
    real G6_0_1_0_2_4_7_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][7]*g20*g21;
    real G6_0_1_0_2_4_8_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g20*g01;
    real G6_0_1_0_2_4_8_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g20*g11;
    real G6_0_1_0_2_4_8_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][8]*g20*g21;
    real G6_0_1_0_2_4_9_0 = det*c1*c0*w[0][0]*w[0][4]*w[1][9]*g20*g01;
    real G6_0_1_0_2_4_10_1 = det*c1*c0*w[0][0]*w[0][4]*w[1][10]*g20*g11;
    real G6_0_1_0_2_4_11_2 = det*c1*c0*w[0][0]*w[0][4]*w[1][11]*g20*g21;
    real G6_0_1_0_2_5_0_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g20*g01;
    real G6_0_1_0_2_5_0_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g20*g11;
    real G6_0_1_0_2_5_0_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][0]*g20*g21;
    real G6_0_1_0_2_5_1_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][1]*g20*g01;
    real G6_0_1_0_2_5_2_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][2]*g20*g11;
    real G6_0_1_0_2_5_3_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][3]*g20*g21;
    real G6_0_1_0_2_5_4_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g20*g01;
    real G6_0_1_0_2_5_4_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g20*g11;
    real G6_0_1_0_2_5_4_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][4]*g20*g21;
    real G6_0_1_0_2_5_5_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][5]*g20*g01;
    real G6_0_1_0_2_5_6_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][6]*g20*g11;
    real G6_0_1_0_2_5_7_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][7]*g20*g21;
    real G6_0_1_0_2_5_8_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g20*g01;
    real G6_0_1_0_2_5_8_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g20*g11;
    real G6_0_1_0_2_5_8_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][8]*g20*g21;
    real G6_0_1_0_2_5_9_0 = det*c1*c0*w[0][0]*w[0][5]*w[1][9]*g20*g01;
    real G6_0_1_0_2_5_10_1 = det*c1*c0*w[0][0]*w[0][5]*w[1][10]*g20*g11;
    real G6_0_1_0_2_5_11_2 = det*c1*c0*w[0][0]*w[0][5]*w[1][11]*g20*g21;
    real G6_0_1_0_2_6_0_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g20*g01;
    real G6_0_1_0_2_6_0_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g20*g11;
    real G6_0_1_0_2_6_0_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][0]*g20*g21;
    real G6_0_1_0_2_6_1_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][1]*g20*g01;
    real G6_0_1_0_2_6_2_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][2]*g20*g11;
    real G6_0_1_0_2_6_3_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][3]*g20*g21;
    real G6_0_1_0_2_6_4_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g20*g01;
    real G6_0_1_0_2_6_4_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g20*g11;
    real G6_0_1_0_2_6_4_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][4]*g20*g21;
    real G6_0_1_0_2_6_5_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][5]*g20*g01;
    real G6_0_1_0_2_6_6_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][6]*g20*g11;
    real G6_0_1_0_2_6_7_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][7]*g20*g21;
    real G6_0_1_0_2_6_8_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g20*g01;
    real G6_0_1_0_2_6_8_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g20*g11;
    real G6_0_1_0_2_6_8_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][8]*g20*g21;
    real G6_0_1_0_2_6_9_0 = det*c1*c0*w[0][0]*w[0][6]*w[1][9]*g20*g01;
    real G6_0_1_0_2_6_10_1 = det*c1*c0*w[0][0]*w[0][6]*w[1][10]*g20*g11;
    real G6_0_1_0_2_6_11_2 = det*c1*c0*w[0][0]*w[0][6]*w[1][11]*g20*g21;
    real G6_0_1_0_2_7_0_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g20*g01;
    real G6_0_1_0_2_7_0_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g20*g11;
    real G6_0_1_0_2_7_0_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][0]*g20*g21;
    real G6_0_1_0_2_7_1_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][1]*g20*g01;
    real G6_0_1_0_2_7_2_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][2]*g20*g11;
    real G6_0_1_0_2_7_3_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][3]*g20*g21;
    real G6_0_1_0_2_7_4_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g20*g01;
    real G6_0_1_0_2_7_4_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g20*g11;
    real G6_0_1_0_2_7_4_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][4]*g20*g21;
    real G6_0_1_0_2_7_5_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][5]*g20*g01;
    real G6_0_1_0_2_7_6_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][6]*g20*g11;
    real G6_0_1_0_2_7_7_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][7]*g20*g21;
    real G6_0_1_0_2_7_8_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g20*g01;
    real G6_0_1_0_2_7_8_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g20*g11;
    real G6_0_1_0_2_7_8_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][8]*g20*g21;
    real G6_0_1_0_2_7_9_0 = det*c1*c0*w[0][0]*w[0][7]*w[1][9]*g20*g01;
    real G6_0_1_0_2_7_10_1 = det*c1*c0*w[0][0]*w[0][7]*w[1][10]*g20*g11;
    real G6_0_1_0_2_7_11_2 = det*c1*c0*w[0][0]*w[0][7]*w[1][11]*g20*g21;
    real G6_0_1_1_0_4_0_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g00*g01;
    real G6_0_1_1_0_4_0_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g00*g11;
    real G6_0_1_1_0_4_0_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g00*g21;
    real G6_0_1_1_0_4_1_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][1]*g00*g01;
    real G6_0_1_1_0_4_2_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][2]*g00*g11;
    real G6_0_1_1_0_4_3_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][3]*g00*g21;
    real G6_0_1_1_0_4_4_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g00*g01;
    real G6_0_1_1_0_4_4_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g00*g11;
    real G6_0_1_1_0_4_4_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g00*g21;
    real G6_0_1_1_0_4_5_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][5]*g00*g01;
    real G6_0_1_1_0_4_6_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][6]*g00*g11;
    real G6_0_1_1_0_4_7_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][7]*g00*g21;
    real G6_0_1_1_0_4_8_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g00*g01;
    real G6_0_1_1_0_4_8_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g00*g11;
    real G6_0_1_1_0_4_8_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g00*g21;
    real G6_0_1_1_0_4_9_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][9]*g00*g01;
    real G6_0_1_1_0_4_10_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][10]*g00*g11;
    real G6_0_1_1_0_4_11_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][11]*g00*g21;
    real G6_0_1_1_0_5_0_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g00*g01;
    real G6_0_1_1_0_5_0_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g00*g11;
    real G6_0_1_1_0_5_0_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g00*g21;
    real G6_0_1_1_0_5_1_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][1]*g00*g01;
    real G6_0_1_1_0_5_2_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][2]*g00*g11;
    real G6_0_1_1_0_5_3_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][3]*g00*g21;
    real G6_0_1_1_0_5_4_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g00*g01;
    real G6_0_1_1_0_5_4_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g00*g11;
    real G6_0_1_1_0_5_4_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g00*g21;
    real G6_0_1_1_0_5_5_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][5]*g00*g01;
    real G6_0_1_1_0_5_6_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][6]*g00*g11;
    real G6_0_1_1_0_5_7_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][7]*g00*g21;
    real G6_0_1_1_0_5_8_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g00*g01;
    real G6_0_1_1_0_5_8_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g00*g11;
    real G6_0_1_1_0_5_8_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g00*g21;
    real G6_0_1_1_0_5_9_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][9]*g00*g01;
    real G6_0_1_1_0_5_10_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][10]*g00*g11;
    real G6_0_1_1_0_5_11_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][11]*g00*g21;
    real G6_0_1_1_0_6_0_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g00*g01;
    real G6_0_1_1_0_6_0_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g00*g11;
    real G6_0_1_1_0_6_0_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g00*g21;
    real G6_0_1_1_0_6_1_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][1]*g00*g01;
    real G6_0_1_1_0_6_2_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][2]*g00*g11;
    real G6_0_1_1_0_6_3_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][3]*g00*g21;
    real G6_0_1_1_0_6_4_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g00*g01;
    real G6_0_1_1_0_6_4_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g00*g11;
    real G6_0_1_1_0_6_4_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g00*g21;
    real G6_0_1_1_0_6_5_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][5]*g00*g01;
    real G6_0_1_1_0_6_6_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][6]*g00*g11;
    real G6_0_1_1_0_6_7_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][7]*g00*g21;
    real G6_0_1_1_0_6_8_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g00*g01;
    real G6_0_1_1_0_6_8_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g00*g11;
    real G6_0_1_1_0_6_8_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g00*g21;
    real G6_0_1_1_0_6_9_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][9]*g00*g01;
    real G6_0_1_1_0_6_10_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][10]*g00*g11;
    real G6_0_1_1_0_6_11_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][11]*g00*g21;
    real G6_0_1_1_0_7_0_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g00*g01;
    real G6_0_1_1_0_7_0_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g00*g11;
    real G6_0_1_1_0_7_0_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g00*g21;
    real G6_0_1_1_0_7_1_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][1]*g00*g01;
    real G6_0_1_1_0_7_2_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][2]*g00*g11;
    real G6_0_1_1_0_7_3_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][3]*g00*g21;
    real G6_0_1_1_0_7_4_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g00*g01;
    real G6_0_1_1_0_7_4_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g00*g11;
    real G6_0_1_1_0_7_4_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g00*g21;
    real G6_0_1_1_0_7_5_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][5]*g00*g01;
    real G6_0_1_1_0_7_6_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][6]*g00*g11;
    real G6_0_1_1_0_7_7_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][7]*g00*g21;
    real G6_0_1_1_0_7_8_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g00*g01;
    real G6_0_1_1_0_7_8_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g00*g11;
    real G6_0_1_1_0_7_8_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g00*g21;
    real G6_0_1_1_0_7_9_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][9]*g00*g01;
    real G6_0_1_1_0_7_10_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][10]*g00*g11;
    real G6_0_1_1_0_7_11_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][11]*g00*g21;
    real G6_0_1_1_1_4_0_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g10*g01;
    real G6_0_1_1_1_4_0_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g10*g11;
    real G6_0_1_1_1_4_0_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g10*g21;
    real G6_0_1_1_1_4_1_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][1]*g10*g01;
    real G6_0_1_1_1_4_2_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][2]*g10*g11;
    real G6_0_1_1_1_4_3_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][3]*g10*g21;
    real G6_0_1_1_1_4_4_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g10*g01;
    real G6_0_1_1_1_4_4_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g10*g11;
    real G6_0_1_1_1_4_4_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g10*g21;
    real G6_0_1_1_1_4_5_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][5]*g10*g01;
    real G6_0_1_1_1_4_6_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][6]*g10*g11;
    real G6_0_1_1_1_4_7_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][7]*g10*g21;
    real G6_0_1_1_1_4_8_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g10*g01;
    real G6_0_1_1_1_4_8_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g10*g11;
    real G6_0_1_1_1_4_8_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g10*g21;
    real G6_0_1_1_1_4_9_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][9]*g10*g01;
    real G6_0_1_1_1_4_10_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][10]*g10*g11;
    real G6_0_1_1_1_4_11_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][11]*g10*g21;
    real G6_0_1_1_1_5_0_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g10*g01;
    real G6_0_1_1_1_5_0_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g10*g11;
    real G6_0_1_1_1_5_0_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g10*g21;
    real G6_0_1_1_1_5_1_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][1]*g10*g01;
    real G6_0_1_1_1_5_2_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][2]*g10*g11;
    real G6_0_1_1_1_5_3_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][3]*g10*g21;
    real G6_0_1_1_1_5_4_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g10*g01;
    real G6_0_1_1_1_5_4_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g10*g11;
    real G6_0_1_1_1_5_4_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g10*g21;
    real G6_0_1_1_1_5_5_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][5]*g10*g01;
    real G6_0_1_1_1_5_6_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][6]*g10*g11;
    real G6_0_1_1_1_5_7_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][7]*g10*g21;
    real G6_0_1_1_1_5_8_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g10*g01;
    real G6_0_1_1_1_5_8_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g10*g11;
    real G6_0_1_1_1_5_8_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g10*g21;
    real G6_0_1_1_1_5_9_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][9]*g10*g01;
    real G6_0_1_1_1_5_10_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][10]*g10*g11;
    real G6_0_1_1_1_5_11_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][11]*g10*g21;
    real G6_0_1_1_1_6_0_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g10*g01;
    real G6_0_1_1_1_6_0_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g10*g11;
    real G6_0_1_1_1_6_0_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g10*g21;
    real G6_0_1_1_1_6_1_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][1]*g10*g01;
    real G6_0_1_1_1_6_2_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][2]*g10*g11;
    real G6_0_1_1_1_6_3_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][3]*g10*g21;
    real G6_0_1_1_1_6_4_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g10*g01;
    real G6_0_1_1_1_6_4_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g10*g11;
    real G6_0_1_1_1_6_4_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g10*g21;
    real G6_0_1_1_1_6_5_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][5]*g10*g01;
    real G6_0_1_1_1_6_6_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][6]*g10*g11;
    real G6_0_1_1_1_6_7_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][7]*g10*g21;
    real G6_0_1_1_1_6_8_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g10*g01;
    real G6_0_1_1_1_6_8_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g10*g11;
    real G6_0_1_1_1_6_8_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g10*g21;
    real G6_0_1_1_1_6_9_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][9]*g10*g01;
    real G6_0_1_1_1_6_10_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][10]*g10*g11;
    real G6_0_1_1_1_6_11_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][11]*g10*g21;
    real G6_0_1_1_1_7_0_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g10*g01;
    real G6_0_1_1_1_7_0_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g10*g11;
    real G6_0_1_1_1_7_0_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g10*g21;
    real G6_0_1_1_1_7_1_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][1]*g10*g01;
    real G6_0_1_1_1_7_2_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][2]*g10*g11;
    real G6_0_1_1_1_7_3_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][3]*g10*g21;
    real G6_0_1_1_1_7_4_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g10*g01;
    real G6_0_1_1_1_7_4_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g10*g11;
    real G6_0_1_1_1_7_4_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g10*g21;
    real G6_0_1_1_1_7_5_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][5]*g10*g01;
    real G6_0_1_1_1_7_6_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][6]*g10*g11;
    real G6_0_1_1_1_7_7_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][7]*g10*g21;
    real G6_0_1_1_1_7_8_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g10*g01;
    real G6_0_1_1_1_7_8_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g10*g11;
    real G6_0_1_1_1_7_8_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g10*g21;
    real G6_0_1_1_1_7_9_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][9]*g10*g01;
    real G6_0_1_1_1_7_10_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][10]*g10*g11;
    real G6_0_1_1_1_7_11_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][11]*g10*g21;
    real G6_0_1_1_2_4_0_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g20*g01;
    real G6_0_1_1_2_4_0_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g20*g11;
    real G6_0_1_1_2_4_0_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][0]*g20*g21;
    real G6_0_1_1_2_4_1_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][1]*g20*g01;
    real G6_0_1_1_2_4_2_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][2]*g20*g11;
    real G6_0_1_1_2_4_3_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][3]*g20*g21;
    real G6_0_1_1_2_4_4_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g20*g01;
    real G6_0_1_1_2_4_4_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g20*g11;
    real G6_0_1_1_2_4_4_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][4]*g20*g21;
    real G6_0_1_1_2_4_5_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][5]*g20*g01;
    real G6_0_1_1_2_4_6_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][6]*g20*g11;
    real G6_0_1_1_2_4_7_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][7]*g20*g21;
    real G6_0_1_1_2_4_8_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g20*g01;
    real G6_0_1_1_2_4_8_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g20*g11;
    real G6_0_1_1_2_4_8_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][8]*g20*g21;
    real G6_0_1_1_2_4_9_0 = det*c1*c0*w[0][1]*w[0][4]*w[1][9]*g20*g01;
    real G6_0_1_1_2_4_10_1 = det*c1*c0*w[0][1]*w[0][4]*w[1][10]*g20*g11;
    real G6_0_1_1_2_4_11_2 = det*c1*c0*w[0][1]*w[0][4]*w[1][11]*g20*g21;
    real G6_0_1_1_2_5_0_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g20*g01;
    real G6_0_1_1_2_5_0_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g20*g11;
    real G6_0_1_1_2_5_0_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][0]*g20*g21;
    real G6_0_1_1_2_5_1_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][1]*g20*g01;
    real G6_0_1_1_2_5_2_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][2]*g20*g11;
    real G6_0_1_1_2_5_3_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][3]*g20*g21;
    real G6_0_1_1_2_5_4_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g20*g01;
    real G6_0_1_1_2_5_4_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g20*g11;
    real G6_0_1_1_2_5_4_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][4]*g20*g21;
    real G6_0_1_1_2_5_5_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][5]*g20*g01;
    real G6_0_1_1_2_5_6_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][6]*g20*g11;
    real G6_0_1_1_2_5_7_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][7]*g20*g21;
    real G6_0_1_1_2_5_8_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g20*g01;
    real G6_0_1_1_2_5_8_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g20*g11;
    real G6_0_1_1_2_5_8_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][8]*g20*g21;
    real G6_0_1_1_2_5_9_0 = det*c1*c0*w[0][1]*w[0][5]*w[1][9]*g20*g01;
    real G6_0_1_1_2_5_10_1 = det*c1*c0*w[0][1]*w[0][5]*w[1][10]*g20*g11;
    real G6_0_1_1_2_5_11_2 = det*c1*c0*w[0][1]*w[0][5]*w[1][11]*g20*g21;
    real G6_0_1_1_2_6_0_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g20*g01;
    real G6_0_1_1_2_6_0_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g20*g11;
    real G6_0_1_1_2_6_0_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][0]*g20*g21;
    real G6_0_1_1_2_6_1_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][1]*g20*g01;
    real G6_0_1_1_2_6_2_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][2]*g20*g11;
    real G6_0_1_1_2_6_3_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][3]*g20*g21;
    real G6_0_1_1_2_6_4_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g20*g01;
    real G6_0_1_1_2_6_4_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g20*g11;
    real G6_0_1_1_2_6_4_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][4]*g20*g21;
    real G6_0_1_1_2_6_5_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][5]*g20*g01;
    real G6_0_1_1_2_6_6_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][6]*g20*g11;
    real G6_0_1_1_2_6_7_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][7]*g20*g21;
    real G6_0_1_1_2_6_8_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g20*g01;
    real G6_0_1_1_2_6_8_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g20*g11;
    real G6_0_1_1_2_6_8_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][8]*g20*g21;
    real G6_0_1_1_2_6_9_0 = det*c1*c0*w[0][1]*w[0][6]*w[1][9]*g20*g01;
    real G6_0_1_1_2_6_10_1 = det*c1*c0*w[0][1]*w[0][6]*w[1][10]*g20*g11;
    real G6_0_1_1_2_6_11_2 = det*c1*c0*w[0][1]*w[0][6]*w[1][11]*g20*g21;
    real G6_0_1_1_2_7_0_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g20*g01;
    real G6_0_1_1_2_7_0_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g20*g11;
    real G6_0_1_1_2_7_0_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][0]*g20*g21;
    real G6_0_1_1_2_7_1_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][1]*g20*g01;
    real G6_0_1_1_2_7_2_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][2]*g20*g11;
    real G6_0_1_1_2_7_3_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][3]*g20*g21;
    real G6_0_1_1_2_7_4_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g20*g01;
    real G6_0_1_1_2_7_4_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g20*g11;
    real G6_0_1_1_2_7_4_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][4]*g20*g21;
    real G6_0_1_1_2_7_5_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][5]*g20*g01;
    real G6_0_1_1_2_7_6_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][6]*g20*g11;
    real G6_0_1_1_2_7_7_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][7]*g20*g21;
    real G6_0_1_1_2_7_8_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g20*g01;
    real G6_0_1_1_2_7_8_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g20*g11;
    real G6_0_1_1_2_7_8_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][8]*g20*g21;
    real G6_0_1_1_2_7_9_0 = det*c1*c0*w[0][1]*w[0][7]*w[1][9]*g20*g01;
    real G6_0_1_1_2_7_10_1 = det*c1*c0*w[0][1]*w[0][7]*w[1][10]*g20*g11;
    real G6_0_1_1_2_7_11_2 = det*c1*c0*w[0][1]*w[0][7]*w[1][11]*g20*g21;
    real G6_0_1_2_0_4_0_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g00*g01;
    real G6_0_1_2_0_4_0_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g00*g11;
    real G6_0_1_2_0_4_0_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g00*g21;
    real G6_0_1_2_0_4_1_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][1]*g00*g01;
    real G6_0_1_2_0_4_2_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][2]*g00*g11;
    real G6_0_1_2_0_4_3_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][3]*g00*g21;
    real G6_0_1_2_0_4_4_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g00*g01;
    real G6_0_1_2_0_4_4_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g00*g11;
    real G6_0_1_2_0_4_4_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g00*g21;
    real G6_0_1_2_0_4_5_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][5]*g00*g01;
    real G6_0_1_2_0_4_6_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][6]*g00*g11;
    real G6_0_1_2_0_4_7_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][7]*g00*g21;
    real G6_0_1_2_0_4_8_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g00*g01;
    real G6_0_1_2_0_4_8_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g00*g11;
    real G6_0_1_2_0_4_8_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g00*g21;
    real G6_0_1_2_0_4_9_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][9]*g00*g01;
    real G6_0_1_2_0_4_10_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][10]*g00*g11;
    real G6_0_1_2_0_4_11_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][11]*g00*g21;
    real G6_0_1_2_0_5_0_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g00*g01;
    real G6_0_1_2_0_5_0_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g00*g11;
    real G6_0_1_2_0_5_0_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g00*g21;
    real G6_0_1_2_0_5_1_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][1]*g00*g01;
    real G6_0_1_2_0_5_2_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][2]*g00*g11;
    real G6_0_1_2_0_5_3_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][3]*g00*g21;
    real G6_0_1_2_0_5_4_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g00*g01;
    real G6_0_1_2_0_5_4_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g00*g11;
    real G6_0_1_2_0_5_4_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g00*g21;
    real G6_0_1_2_0_5_5_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][5]*g00*g01;
    real G6_0_1_2_0_5_6_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][6]*g00*g11;
    real G6_0_1_2_0_5_7_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][7]*g00*g21;
    real G6_0_1_2_0_5_8_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g00*g01;
    real G6_0_1_2_0_5_8_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g00*g11;
    real G6_0_1_2_0_5_8_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g00*g21;
    real G6_0_1_2_0_5_9_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][9]*g00*g01;
    real G6_0_1_2_0_5_10_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][10]*g00*g11;
    real G6_0_1_2_0_5_11_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][11]*g00*g21;
    real G6_0_1_2_0_6_0_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g00*g01;
    real G6_0_1_2_0_6_0_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g00*g11;
    real G6_0_1_2_0_6_0_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g00*g21;
    real G6_0_1_2_0_6_1_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][1]*g00*g01;
    real G6_0_1_2_0_6_2_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][2]*g00*g11;
    real G6_0_1_2_0_6_3_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][3]*g00*g21;
    real G6_0_1_2_0_6_4_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g00*g01;
    real G6_0_1_2_0_6_4_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g00*g11;
    real G6_0_1_2_0_6_4_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g00*g21;
    real G6_0_1_2_0_6_5_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][5]*g00*g01;
    real G6_0_1_2_0_6_6_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][6]*g00*g11;
    real G6_0_1_2_0_6_7_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][7]*g00*g21;
    real G6_0_1_2_0_6_8_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g00*g01;
    real G6_0_1_2_0_6_8_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g00*g11;
    real G6_0_1_2_0_6_8_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g00*g21;
    real G6_0_1_2_0_6_9_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][9]*g00*g01;
    real G6_0_1_2_0_6_10_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][10]*g00*g11;
    real G6_0_1_2_0_6_11_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][11]*g00*g21;
    real G6_0_1_2_0_7_0_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g00*g01;
    real G6_0_1_2_0_7_0_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g00*g11;
    real G6_0_1_2_0_7_0_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g00*g21;
    real G6_0_1_2_0_7_1_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][1]*g00*g01;
    real G6_0_1_2_0_7_2_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][2]*g00*g11;
    real G6_0_1_2_0_7_3_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][3]*g00*g21;
    real G6_0_1_2_0_7_4_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g00*g01;
    real G6_0_1_2_0_7_4_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g00*g11;
    real G6_0_1_2_0_7_4_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g00*g21;
    real G6_0_1_2_0_7_5_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][5]*g00*g01;
    real G6_0_1_2_0_7_6_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][6]*g00*g11;
    real G6_0_1_2_0_7_7_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][7]*g00*g21;
    real G6_0_1_2_0_7_8_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g00*g01;
    real G6_0_1_2_0_7_8_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g00*g11;
    real G6_0_1_2_0_7_8_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g00*g21;
    real G6_0_1_2_0_7_9_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][9]*g00*g01;
    real G6_0_1_2_0_7_10_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][10]*g00*g11;
    real G6_0_1_2_0_7_11_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][11]*g00*g21;
    real G6_0_1_2_1_4_0_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g10*g01;
    real G6_0_1_2_1_4_0_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g10*g11;
    real G6_0_1_2_1_4_0_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g10*g21;
    real G6_0_1_2_1_4_1_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][1]*g10*g01;
    real G6_0_1_2_1_4_2_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][2]*g10*g11;
    real G6_0_1_2_1_4_3_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][3]*g10*g21;
    real G6_0_1_2_1_4_4_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g10*g01;
    real G6_0_1_2_1_4_4_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g10*g11;
    real G6_0_1_2_1_4_4_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g10*g21;
    real G6_0_1_2_1_4_5_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][5]*g10*g01;
    real G6_0_1_2_1_4_6_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][6]*g10*g11;
    real G6_0_1_2_1_4_7_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][7]*g10*g21;
    real G6_0_1_2_1_4_8_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g10*g01;
    real G6_0_1_2_1_4_8_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g10*g11;
    real G6_0_1_2_1_4_8_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g10*g21;
    real G6_0_1_2_1_4_9_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][9]*g10*g01;
    real G6_0_1_2_1_4_10_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][10]*g10*g11;
    real G6_0_1_2_1_4_11_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][11]*g10*g21;
    real G6_0_1_2_1_5_0_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g10*g01;
    real G6_0_1_2_1_5_0_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g10*g11;
    real G6_0_1_2_1_5_0_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g10*g21;
    real G6_0_1_2_1_5_1_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][1]*g10*g01;
    real G6_0_1_2_1_5_2_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][2]*g10*g11;
    real G6_0_1_2_1_5_3_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][3]*g10*g21;
    real G6_0_1_2_1_5_4_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g10*g01;
    real G6_0_1_2_1_5_4_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g10*g11;
    real G6_0_1_2_1_5_4_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g10*g21;
    real G6_0_1_2_1_5_5_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][5]*g10*g01;
    real G6_0_1_2_1_5_6_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][6]*g10*g11;
    real G6_0_1_2_1_5_7_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][7]*g10*g21;
    real G6_0_1_2_1_5_8_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g10*g01;
    real G6_0_1_2_1_5_8_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g10*g11;
    real G6_0_1_2_1_5_8_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g10*g21;
    real G6_0_1_2_1_5_9_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][9]*g10*g01;
    real G6_0_1_2_1_5_10_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][10]*g10*g11;
    real G6_0_1_2_1_5_11_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][11]*g10*g21;
    real G6_0_1_2_1_6_0_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g10*g01;
    real G6_0_1_2_1_6_0_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g10*g11;
    real G6_0_1_2_1_6_0_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g10*g21;
    real G6_0_1_2_1_6_1_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][1]*g10*g01;
    real G6_0_1_2_1_6_2_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][2]*g10*g11;
    real G6_0_1_2_1_6_3_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][3]*g10*g21;
    real G6_0_1_2_1_6_4_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g10*g01;
    real G6_0_1_2_1_6_4_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g10*g11;
    real G6_0_1_2_1_6_4_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g10*g21;
    real G6_0_1_2_1_6_5_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][5]*g10*g01;
    real G6_0_1_2_1_6_6_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][6]*g10*g11;
    real G6_0_1_2_1_6_7_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][7]*g10*g21;
    real G6_0_1_2_1_6_8_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g10*g01;
    real G6_0_1_2_1_6_8_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g10*g11;
    real G6_0_1_2_1_6_8_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g10*g21;
    real G6_0_1_2_1_6_9_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][9]*g10*g01;
    real G6_0_1_2_1_6_10_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][10]*g10*g11;
    real G6_0_1_2_1_6_11_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][11]*g10*g21;
    real G6_0_1_2_1_7_0_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g10*g01;
    real G6_0_1_2_1_7_0_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g10*g11;
    real G6_0_1_2_1_7_0_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g10*g21;
    real G6_0_1_2_1_7_1_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][1]*g10*g01;
    real G6_0_1_2_1_7_2_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][2]*g10*g11;
    real G6_0_1_2_1_7_3_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][3]*g10*g21;
    real G6_0_1_2_1_7_4_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g10*g01;
    real G6_0_1_2_1_7_4_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g10*g11;
    real G6_0_1_2_1_7_4_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g10*g21;
    real G6_0_1_2_1_7_5_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][5]*g10*g01;
    real G6_0_1_2_1_7_6_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][6]*g10*g11;
    real G6_0_1_2_1_7_7_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][7]*g10*g21;
    real G6_0_1_2_1_7_8_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g10*g01;
    real G6_0_1_2_1_7_8_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g10*g11;
    real G6_0_1_2_1_7_8_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g10*g21;
    real G6_0_1_2_1_7_9_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][9]*g10*g01;
    real G6_0_1_2_1_7_10_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][10]*g10*g11;
    real G6_0_1_2_1_7_11_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][11]*g10*g21;
    real G6_0_1_2_2_4_0_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g20*g01;
    real G6_0_1_2_2_4_0_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g20*g11;
    real G6_0_1_2_2_4_0_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][0]*g20*g21;
    real G6_0_1_2_2_4_1_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][1]*g20*g01;
    real G6_0_1_2_2_4_2_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][2]*g20*g11;
    real G6_0_1_2_2_4_3_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][3]*g20*g21;
    real G6_0_1_2_2_4_4_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g20*g01;
    real G6_0_1_2_2_4_4_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g20*g11;
    real G6_0_1_2_2_4_4_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][4]*g20*g21;
    real G6_0_1_2_2_4_5_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][5]*g20*g01;
    real G6_0_1_2_2_4_6_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][6]*g20*g11;
    real G6_0_1_2_2_4_7_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][7]*g20*g21;
    real G6_0_1_2_2_4_8_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g20*g01;
    real G6_0_1_2_2_4_8_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g20*g11;
    real G6_0_1_2_2_4_8_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][8]*g20*g21;
    real G6_0_1_2_2_4_9_0 = det*c1*c0*w[0][2]*w[0][4]*w[1][9]*g20*g01;
    real G6_0_1_2_2_4_10_1 = det*c1*c0*w[0][2]*w[0][4]*w[1][10]*g20*g11;
    real G6_0_1_2_2_4_11_2 = det*c1*c0*w[0][2]*w[0][4]*w[1][11]*g20*g21;
    real G6_0_1_2_2_5_0_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g20*g01;
    real G6_0_1_2_2_5_0_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g20*g11;
    real G6_0_1_2_2_5_0_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][0]*g20*g21;
    real G6_0_1_2_2_5_1_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][1]*g20*g01;
    real G6_0_1_2_2_5_2_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][2]*g20*g11;
    real G6_0_1_2_2_5_3_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][3]*g20*g21;
    real G6_0_1_2_2_5_4_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g20*g01;
    real G6_0_1_2_2_5_4_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g20*g11;
    real G6_0_1_2_2_5_4_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][4]*g20*g21;
    real G6_0_1_2_2_5_5_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][5]*g20*g01;
    real G6_0_1_2_2_5_6_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][6]*g20*g11;
    real G6_0_1_2_2_5_7_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][7]*g20*g21;
    real G6_0_1_2_2_5_8_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g20*g01;
    real G6_0_1_2_2_5_8_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g20*g11;
    real G6_0_1_2_2_5_8_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][8]*g20*g21;
    real G6_0_1_2_2_5_9_0 = det*c1*c0*w[0][2]*w[0][5]*w[1][9]*g20*g01;
    real G6_0_1_2_2_5_10_1 = det*c1*c0*w[0][2]*w[0][5]*w[1][10]*g20*g11;
    real G6_0_1_2_2_5_11_2 = det*c1*c0*w[0][2]*w[0][5]*w[1][11]*g20*g21;
    real G6_0_1_2_2_6_0_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g20*g01;
    real G6_0_1_2_2_6_0_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g20*g11;
    real G6_0_1_2_2_6_0_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][0]*g20*g21;
    real G6_0_1_2_2_6_1_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][1]*g20*g01;
    real G6_0_1_2_2_6_2_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][2]*g20*g11;
    real G6_0_1_2_2_6_3_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][3]*g20*g21;
    real G6_0_1_2_2_6_4_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g20*g01;
    real G6_0_1_2_2_6_4_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g20*g11;
    real G6_0_1_2_2_6_4_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][4]*g20*g21;
    real G6_0_1_2_2_6_5_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][5]*g20*g01;
    real G6_0_1_2_2_6_6_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][6]*g20*g11;
    real G6_0_1_2_2_6_7_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][7]*g20*g21;
    real G6_0_1_2_2_6_8_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g20*g01;
    real G6_0_1_2_2_6_8_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g20*g11;
    real G6_0_1_2_2_6_8_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][8]*g20*g21;
    real G6_0_1_2_2_6_9_0 = det*c1*c0*w[0][2]*w[0][6]*w[1][9]*g20*g01;
    real G6_0_1_2_2_6_10_1 = det*c1*c0*w[0][2]*w[0][6]*w[1][10]*g20*g11;
    real G6_0_1_2_2_6_11_2 = det*c1*c0*w[0][2]*w[0][6]*w[1][11]*g20*g21;
    real G6_0_1_2_2_7_0_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g20*g01;
    real G6_0_1_2_2_7_0_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g20*g11;
    real G6_0_1_2_2_7_0_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][0]*g20*g21;
    real G6_0_1_2_2_7_1_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][1]*g20*g01;
    real G6_0_1_2_2_7_2_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][2]*g20*g11;
    real G6_0_1_2_2_7_3_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][3]*g20*g21;
    real G6_0_1_2_2_7_4_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g20*g01;
    real G6_0_1_2_2_7_4_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g20*g11;
    real G6_0_1_2_2_7_4_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][4]*g20*g21;
    real G6_0_1_2_2_7_5_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][5]*g20*g01;
    real G6_0_1_2_2_7_6_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][6]*g20*g11;
    real G6_0_1_2_2_7_7_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][7]*g20*g21;
    real G6_0_1_2_2_7_8_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g20*g01;
    real G6_0_1_2_2_7_8_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g20*g11;
    real G6_0_1_2_2_7_8_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][8]*g20*g21;
    real G6_0_1_2_2_7_9_0 = det*c1*c0*w[0][2]*w[0][7]*w[1][9]*g20*g01;
    real G6_0_1_2_2_7_10_1 = det*c1*c0*w[0][2]*w[0][7]*w[1][10]*g20*g11;
    real G6_0_1_2_2_7_11_2 = det*c1*c0*w[0][2]*w[0][7]*w[1][11]*g20*g21;
    real G6_0_1_3_0_4_0_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g00*g01;
    real G6_0_1_3_0_4_0_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g00*g11;
    real G6_0_1_3_0_4_0_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g00*g21;
    real G6_0_1_3_0_4_1_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][1]*g00*g01;
    real G6_0_1_3_0_4_2_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][2]*g00*g11;
    real G6_0_1_3_0_4_3_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][3]*g00*g21;
    real G6_0_1_3_0_4_4_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g00*g01;
    real G6_0_1_3_0_4_4_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g00*g11;
    real G6_0_1_3_0_4_4_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g00*g21;
    real G6_0_1_3_0_4_5_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][5]*g00*g01;
    real G6_0_1_3_0_4_6_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][6]*g00*g11;
    real G6_0_1_3_0_4_7_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][7]*g00*g21;
    real G6_0_1_3_0_4_8_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g00*g01;
    real G6_0_1_3_0_4_8_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g00*g11;
    real G6_0_1_3_0_4_8_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g00*g21;
    real G6_0_1_3_0_4_9_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][9]*g00*g01;
    real G6_0_1_3_0_4_10_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][10]*g00*g11;
    real G6_0_1_3_0_4_11_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][11]*g00*g21;
    real G6_0_1_3_0_5_0_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g00*g01;
    real G6_0_1_3_0_5_0_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g00*g11;
    real G6_0_1_3_0_5_0_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g00*g21;
    real G6_0_1_3_0_5_1_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][1]*g00*g01;
    real G6_0_1_3_0_5_2_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][2]*g00*g11;
    real G6_0_1_3_0_5_3_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][3]*g00*g21;
    real G6_0_1_3_0_5_4_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g00*g01;
    real G6_0_1_3_0_5_4_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g00*g11;
    real G6_0_1_3_0_5_4_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g00*g21;
    real G6_0_1_3_0_5_5_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][5]*g00*g01;
    real G6_0_1_3_0_5_6_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][6]*g00*g11;
    real G6_0_1_3_0_5_7_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][7]*g00*g21;
    real G6_0_1_3_0_5_8_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g00*g01;
    real G6_0_1_3_0_5_8_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g00*g11;
    real G6_0_1_3_0_5_8_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g00*g21;
    real G6_0_1_3_0_5_9_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][9]*g00*g01;
    real G6_0_1_3_0_5_10_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][10]*g00*g11;
    real G6_0_1_3_0_5_11_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][11]*g00*g21;
    real G6_0_1_3_0_6_0_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g00*g01;
    real G6_0_1_3_0_6_0_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g00*g11;
    real G6_0_1_3_0_6_0_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g00*g21;
    real G6_0_1_3_0_6_1_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][1]*g00*g01;
    real G6_0_1_3_0_6_2_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][2]*g00*g11;
    real G6_0_1_3_0_6_3_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][3]*g00*g21;
    real G6_0_1_3_0_6_4_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g00*g01;
    real G6_0_1_3_0_6_4_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g00*g11;
    real G6_0_1_3_0_6_4_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g00*g21;
    real G6_0_1_3_0_6_5_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][5]*g00*g01;
    real G6_0_1_3_0_6_6_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][6]*g00*g11;
    real G6_0_1_3_0_6_7_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][7]*g00*g21;
    real G6_0_1_3_0_6_8_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g00*g01;
    real G6_0_1_3_0_6_8_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g00*g11;
    real G6_0_1_3_0_6_8_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g00*g21;
    real G6_0_1_3_0_6_9_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][9]*g00*g01;
    real G6_0_1_3_0_6_10_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][10]*g00*g11;
    real G6_0_1_3_0_6_11_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][11]*g00*g21;
    real G6_0_1_3_0_7_0_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g00*g01;
    real G6_0_1_3_0_7_0_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g00*g11;
    real G6_0_1_3_0_7_0_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g00*g21;
    real G6_0_1_3_0_7_1_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][1]*g00*g01;
    real G6_0_1_3_0_7_2_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][2]*g00*g11;
    real G6_0_1_3_0_7_3_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][3]*g00*g21;
    real G6_0_1_3_0_7_4_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g00*g01;
    real G6_0_1_3_0_7_4_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g00*g11;
    real G6_0_1_3_0_7_4_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g00*g21;
    real G6_0_1_3_0_7_5_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][5]*g00*g01;
    real G6_0_1_3_0_7_6_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][6]*g00*g11;
    real G6_0_1_3_0_7_7_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][7]*g00*g21;
    real G6_0_1_3_0_7_8_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g00*g01;
    real G6_0_1_3_0_7_8_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g00*g11;
    real G6_0_1_3_0_7_8_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g00*g21;
    real G6_0_1_3_0_7_9_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][9]*g00*g01;
    real G6_0_1_3_0_7_10_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][10]*g00*g11;
    real G6_0_1_3_0_7_11_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][11]*g00*g21;
    real G6_0_1_3_1_4_0_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g10*g01;
    real G6_0_1_3_1_4_0_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g10*g11;
    real G6_0_1_3_1_4_0_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g10*g21;
    real G6_0_1_3_1_4_1_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][1]*g10*g01;
    real G6_0_1_3_1_4_2_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][2]*g10*g11;
    real G6_0_1_3_1_4_3_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][3]*g10*g21;
    real G6_0_1_3_1_4_4_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g10*g01;
    real G6_0_1_3_1_4_4_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g10*g11;
    real G6_0_1_3_1_4_4_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g10*g21;
    real G6_0_1_3_1_4_5_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][5]*g10*g01;
    real G6_0_1_3_1_4_6_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][6]*g10*g11;
    real G6_0_1_3_1_4_7_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][7]*g10*g21;
    real G6_0_1_3_1_4_8_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g10*g01;
    real G6_0_1_3_1_4_8_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g10*g11;
    real G6_0_1_3_1_4_8_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g10*g21;
    real G6_0_1_3_1_4_9_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][9]*g10*g01;
    real G6_0_1_3_1_4_10_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][10]*g10*g11;
    real G6_0_1_3_1_4_11_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][11]*g10*g21;
    real G6_0_1_3_1_5_0_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g10*g01;
    real G6_0_1_3_1_5_0_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g10*g11;
    real G6_0_1_3_1_5_0_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g10*g21;
    real G6_0_1_3_1_5_1_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][1]*g10*g01;
    real G6_0_1_3_1_5_2_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][2]*g10*g11;
    real G6_0_1_3_1_5_3_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][3]*g10*g21;
    real G6_0_1_3_1_5_4_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g10*g01;
    real G6_0_1_3_1_5_4_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g10*g11;
    real G6_0_1_3_1_5_4_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g10*g21;
    real G6_0_1_3_1_5_5_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][5]*g10*g01;
    real G6_0_1_3_1_5_6_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][6]*g10*g11;
    real G6_0_1_3_1_5_7_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][7]*g10*g21;
    real G6_0_1_3_1_5_8_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g10*g01;
    real G6_0_1_3_1_5_8_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g10*g11;
    real G6_0_1_3_1_5_8_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g10*g21;
    real G6_0_1_3_1_5_9_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][9]*g10*g01;
    real G6_0_1_3_1_5_10_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][10]*g10*g11;
    real G6_0_1_3_1_5_11_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][11]*g10*g21;
    real G6_0_1_3_1_6_0_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g10*g01;
    real G6_0_1_3_1_6_0_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g10*g11;
    real G6_0_1_3_1_6_0_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g10*g21;
    real G6_0_1_3_1_6_1_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][1]*g10*g01;
    real G6_0_1_3_1_6_2_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][2]*g10*g11;
    real G6_0_1_3_1_6_3_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][3]*g10*g21;
    real G6_0_1_3_1_6_4_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g10*g01;
    real G6_0_1_3_1_6_4_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g10*g11;
    real G6_0_1_3_1_6_4_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g10*g21;
    real G6_0_1_3_1_6_5_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][5]*g10*g01;
    real G6_0_1_3_1_6_6_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][6]*g10*g11;
    real G6_0_1_3_1_6_7_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][7]*g10*g21;
    real G6_0_1_3_1_6_8_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g10*g01;
    real G6_0_1_3_1_6_8_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g10*g11;
    real G6_0_1_3_1_6_8_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g10*g21;
    real G6_0_1_3_1_6_9_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][9]*g10*g01;
    real G6_0_1_3_1_6_10_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][10]*g10*g11;
    real G6_0_1_3_1_6_11_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][11]*g10*g21;
    real G6_0_1_3_1_7_0_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g10*g01;
    real G6_0_1_3_1_7_0_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g10*g11;
    real G6_0_1_3_1_7_0_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g10*g21;
    real G6_0_1_3_1_7_1_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][1]*g10*g01;
    real G6_0_1_3_1_7_2_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][2]*g10*g11;
    real G6_0_1_3_1_7_3_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][3]*g10*g21;
    real G6_0_1_3_1_7_4_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g10*g01;
    real G6_0_1_3_1_7_4_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g10*g11;
    real G6_0_1_3_1_7_4_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g10*g21;
    real G6_0_1_3_1_7_5_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][5]*g10*g01;
    real G6_0_1_3_1_7_6_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][6]*g10*g11;
    real G6_0_1_3_1_7_7_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][7]*g10*g21;
    real G6_0_1_3_1_7_8_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g10*g01;
    real G6_0_1_3_1_7_8_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g10*g11;
    real G6_0_1_3_1_7_8_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g10*g21;
    real G6_0_1_3_1_7_9_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][9]*g10*g01;
    real G6_0_1_3_1_7_10_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][10]*g10*g11;
    real G6_0_1_3_1_7_11_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][11]*g10*g21;
    real G6_0_1_3_2_4_0_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g20*g01;
    real G6_0_1_3_2_4_0_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g20*g11;
    real G6_0_1_3_2_4_0_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][0]*g20*g21;
    real G6_0_1_3_2_4_1_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][1]*g20*g01;
    real G6_0_1_3_2_4_2_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][2]*g20*g11;
    real G6_0_1_3_2_4_3_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][3]*g20*g21;
    real G6_0_1_3_2_4_4_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g20*g01;
    real G6_0_1_3_2_4_4_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g20*g11;
    real G6_0_1_3_2_4_4_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][4]*g20*g21;
    real G6_0_1_3_2_4_5_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][5]*g20*g01;
    real G6_0_1_3_2_4_6_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][6]*g20*g11;
    real G6_0_1_3_2_4_7_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][7]*g20*g21;
    real G6_0_1_3_2_4_8_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g20*g01;
    real G6_0_1_3_2_4_8_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g20*g11;
    real G6_0_1_3_2_4_8_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][8]*g20*g21;
    real G6_0_1_3_2_4_9_0 = det*c1*c0*w[0][3]*w[0][4]*w[1][9]*g20*g01;
    real G6_0_1_3_2_4_10_1 = det*c1*c0*w[0][3]*w[0][4]*w[1][10]*g20*g11;
    real G6_0_1_3_2_4_11_2 = det*c1*c0*w[0][3]*w[0][4]*w[1][11]*g20*g21;
    real G6_0_1_3_2_5_0_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g20*g01;
    real G6_0_1_3_2_5_0_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g20*g11;
    real G6_0_1_3_2_5_0_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][0]*g20*g21;
    real G6_0_1_3_2_5_1_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][1]*g20*g01;
    real G6_0_1_3_2_5_2_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][2]*g20*g11;
    real G6_0_1_3_2_5_3_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][3]*g20*g21;
    real G6_0_1_3_2_5_4_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g20*g01;
    real G6_0_1_3_2_5_4_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g20*g11;
    real G6_0_1_3_2_5_4_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][4]*g20*g21;
    real G6_0_1_3_2_5_5_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][5]*g20*g01;
    real G6_0_1_3_2_5_6_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][6]*g20*g11;
    real G6_0_1_3_2_5_7_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][7]*g20*g21;
    real G6_0_1_3_2_5_8_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g20*g01;
    real G6_0_1_3_2_5_8_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g20*g11;
    real G6_0_1_3_2_5_8_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][8]*g20*g21;
    real G6_0_1_3_2_5_9_0 = det*c1*c0*w[0][3]*w[0][5]*w[1][9]*g20*g01;
    real G6_0_1_3_2_5_10_1 = det*c1*c0*w[0][3]*w[0][5]*w[1][10]*g20*g11;
    real G6_0_1_3_2_5_11_2 = det*c1*c0*w[0][3]*w[0][5]*w[1][11]*g20*g21;
    real G6_0_1_3_2_6_0_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g20*g01;
    real G6_0_1_3_2_6_0_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g20*g11;
    real G6_0_1_3_2_6_0_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][0]*g20*g21;
    real G6_0_1_3_2_6_1_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][1]*g20*g01;
    real G6_0_1_3_2_6_2_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][2]*g20*g11;
    real G6_0_1_3_2_6_3_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][3]*g20*g21;
    real G6_0_1_3_2_6_4_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g20*g01;
    real G6_0_1_3_2_6_4_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g20*g11;
    real G6_0_1_3_2_6_4_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][4]*g20*g21;
    real G6_0_1_3_2_6_5_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][5]*g20*g01;
    real G6_0_1_3_2_6_6_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][6]*g20*g11;
    real G6_0_1_3_2_6_7_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][7]*g20*g21;
    real G6_0_1_3_2_6_8_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g20*g01;
    real G6_0_1_3_2_6_8_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g20*g11;
    real G6_0_1_3_2_6_8_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][8]*g20*g21;
    real G6_0_1_3_2_6_9_0 = det*c1*c0*w[0][3]*w[0][6]*w[1][9]*g20*g01;
    real G6_0_1_3_2_6_10_1 = det*c1*c0*w[0][3]*w[0][6]*w[1][10]*g20*g11;
    real G6_0_1_3_2_6_11_2 = det*c1*c0*w[0][3]*w[0][6]*w[1][11]*g20*g21;
    real G6_0_1_3_2_7_0_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g20*g01;
    real G6_0_1_3_2_7_0_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g20*g11;
    real G6_0_1_3_2_7_0_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][0]*g20*g21;
    real G6_0_1_3_2_7_1_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][1]*g20*g01;
    real G6_0_1_3_2_7_2_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][2]*g20*g11;
    real G6_0_1_3_2_7_3_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][3]*g20*g21;
    real G6_0_1_3_2_7_4_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g20*g01;
    real G6_0_1_3_2_7_4_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g20*g11;
    real G6_0_1_3_2_7_4_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][4]*g20*g21;
    real G6_0_1_3_2_7_5_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][5]*g20*g01;
    real G6_0_1_3_2_7_6_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][6]*g20*g11;
    real G6_0_1_3_2_7_7_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][7]*g20*g21;
    real G6_0_1_3_2_7_8_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g20*g01;
    real G6_0_1_3_2_7_8_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g20*g11;
    real G6_0_1_3_2_7_8_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][8]*g20*g21;
    real G6_0_1_3_2_7_9_0 = det*c1*c0*w[0][3]*w[0][7]*w[1][9]*g20*g01;
    real G6_0_1_3_2_7_10_1 = det*c1*c0*w[0][3]*w[0][7]*w[1][10]*g20*g11;
    real G6_0_1_3_2_7_11_2 = det*c1*c0*w[0][3]*w[0][7]*w[1][11]*g20*g21;
    real G6_0_2_0_0_8_0_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g00*g02;
    real G6_0_2_0_0_8_0_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g00*g12;
    real G6_0_2_0_0_8_0_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g00*g22;
    real G6_0_2_0_0_8_1_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][1]*g00*g02;
    real G6_0_2_0_0_8_2_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][2]*g00*g12;
    real G6_0_2_0_0_8_3_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][3]*g00*g22;
    real G6_0_2_0_0_8_4_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g00*g02;
    real G6_0_2_0_0_8_4_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g00*g12;
    real G6_0_2_0_0_8_4_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g00*g22;
    real G6_0_2_0_0_8_5_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][5]*g00*g02;
    real G6_0_2_0_0_8_6_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][6]*g00*g12;
    real G6_0_2_0_0_8_7_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][7]*g00*g22;
    real G6_0_2_0_0_8_8_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g00*g02;
    real G6_0_2_0_0_8_8_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g00*g12;
    real G6_0_2_0_0_8_8_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g00*g22;
    real G6_0_2_0_0_8_9_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][9]*g00*g02;
    real G6_0_2_0_0_8_10_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][10]*g00*g12;
    real G6_0_2_0_0_8_11_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][11]*g00*g22;
    real G6_0_2_0_0_9_0_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g00*g02;
    real G6_0_2_0_0_9_0_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g00*g12;
    real G6_0_2_0_0_9_0_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g00*g22;
    real G6_0_2_0_0_9_1_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][1]*g00*g02;
    real G6_0_2_0_0_9_2_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][2]*g00*g12;
    real G6_0_2_0_0_9_3_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][3]*g00*g22;
    real G6_0_2_0_0_9_4_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g00*g02;
    real G6_0_2_0_0_9_4_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g00*g12;
    real G6_0_2_0_0_9_4_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g00*g22;
    real G6_0_2_0_0_9_5_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][5]*g00*g02;
    real G6_0_2_0_0_9_6_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][6]*g00*g12;
    real G6_0_2_0_0_9_7_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][7]*g00*g22;
    real G6_0_2_0_0_9_8_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g00*g02;
    real G6_0_2_0_0_9_8_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g00*g12;
    real G6_0_2_0_0_9_8_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g00*g22;
    real G6_0_2_0_0_9_9_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][9]*g00*g02;
    real G6_0_2_0_0_9_10_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][10]*g00*g12;
    real G6_0_2_0_0_9_11_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][11]*g00*g22;
    real G6_0_2_0_0_10_0_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g00*g02;
    real G6_0_2_0_0_10_0_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g00*g12;
    real G6_0_2_0_0_10_0_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g00*g22;
    real G6_0_2_0_0_10_1_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][1]*g00*g02;
    real G6_0_2_0_0_10_2_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][2]*g00*g12;
    real G6_0_2_0_0_10_3_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][3]*g00*g22;
    real G6_0_2_0_0_10_4_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g00*g02;
    real G6_0_2_0_0_10_4_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g00*g12;
    real G6_0_2_0_0_10_4_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g00*g22;
    real G6_0_2_0_0_10_5_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][5]*g00*g02;
    real G6_0_2_0_0_10_6_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][6]*g00*g12;
    real G6_0_2_0_0_10_7_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][7]*g00*g22;
    real G6_0_2_0_0_10_8_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g00*g02;
    real G6_0_2_0_0_10_8_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g00*g12;
    real G6_0_2_0_0_10_8_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g00*g22;
    real G6_0_2_0_0_10_9_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][9]*g00*g02;
    real G6_0_2_0_0_10_10_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][10]*g00*g12;
    real G6_0_2_0_0_10_11_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][11]*g00*g22;
    real G6_0_2_0_0_11_0_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g00*g02;
    real G6_0_2_0_0_11_0_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g00*g12;
    real G6_0_2_0_0_11_0_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g00*g22;
    real G6_0_2_0_0_11_1_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][1]*g00*g02;
    real G6_0_2_0_0_11_2_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][2]*g00*g12;
    real G6_0_2_0_0_11_3_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][3]*g00*g22;
    real G6_0_2_0_0_11_4_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g00*g02;
    real G6_0_2_0_0_11_4_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g00*g12;
    real G6_0_2_0_0_11_4_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g00*g22;
    real G6_0_2_0_0_11_5_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][5]*g00*g02;
    real G6_0_2_0_0_11_6_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][6]*g00*g12;
    real G6_0_2_0_0_11_7_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][7]*g00*g22;
    real G6_0_2_0_0_11_8_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g00*g02;
    real G6_0_2_0_0_11_8_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g00*g12;
    real G6_0_2_0_0_11_8_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g00*g22;
    real G6_0_2_0_0_11_9_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][9]*g00*g02;
    real G6_0_2_0_0_11_10_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][10]*g00*g12;
    real G6_0_2_0_0_11_11_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][11]*g00*g22;
    real G6_0_2_0_1_8_0_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g10*g02;
    real G6_0_2_0_1_8_0_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g10*g12;
    real G6_0_2_0_1_8_0_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g10*g22;
    real G6_0_2_0_1_8_1_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][1]*g10*g02;
    real G6_0_2_0_1_8_2_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][2]*g10*g12;
    real G6_0_2_0_1_8_3_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][3]*g10*g22;
    real G6_0_2_0_1_8_4_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g10*g02;
    real G6_0_2_0_1_8_4_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g10*g12;
    real G6_0_2_0_1_8_4_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g10*g22;
    real G6_0_2_0_1_8_5_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][5]*g10*g02;
    real G6_0_2_0_1_8_6_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][6]*g10*g12;
    real G6_0_2_0_1_8_7_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][7]*g10*g22;
    real G6_0_2_0_1_8_8_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g10*g02;
    real G6_0_2_0_1_8_8_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g10*g12;
    real G6_0_2_0_1_8_8_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g10*g22;
    real G6_0_2_0_1_8_9_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][9]*g10*g02;
    real G6_0_2_0_1_8_10_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][10]*g10*g12;
    real G6_0_2_0_1_8_11_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][11]*g10*g22;
    real G6_0_2_0_1_9_0_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g10*g02;
    real G6_0_2_0_1_9_0_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g10*g12;
    real G6_0_2_0_1_9_0_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g10*g22;
    real G6_0_2_0_1_9_1_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][1]*g10*g02;
    real G6_0_2_0_1_9_2_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][2]*g10*g12;
    real G6_0_2_0_1_9_3_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][3]*g10*g22;
    real G6_0_2_0_1_9_4_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g10*g02;
    real G6_0_2_0_1_9_4_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g10*g12;
    real G6_0_2_0_1_9_4_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g10*g22;
    real G6_0_2_0_1_9_5_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][5]*g10*g02;
    real G6_0_2_0_1_9_6_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][6]*g10*g12;
    real G6_0_2_0_1_9_7_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][7]*g10*g22;
    real G6_0_2_0_1_9_8_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g10*g02;
    real G6_0_2_0_1_9_8_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g10*g12;
    real G6_0_2_0_1_9_8_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g10*g22;
    real G6_0_2_0_1_9_9_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][9]*g10*g02;
    real G6_0_2_0_1_9_10_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][10]*g10*g12;
    real G6_0_2_0_1_9_11_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][11]*g10*g22;
    real G6_0_2_0_1_10_0_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g10*g02;
    real G6_0_2_0_1_10_0_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g10*g12;
    real G6_0_2_0_1_10_0_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g10*g22;
    real G6_0_2_0_1_10_1_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][1]*g10*g02;
    real G6_0_2_0_1_10_2_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][2]*g10*g12;
    real G6_0_2_0_1_10_3_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][3]*g10*g22;
    real G6_0_2_0_1_10_4_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g10*g02;
    real G6_0_2_0_1_10_4_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g10*g12;
    real G6_0_2_0_1_10_4_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g10*g22;
    real G6_0_2_0_1_10_5_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][5]*g10*g02;
    real G6_0_2_0_1_10_6_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][6]*g10*g12;
    real G6_0_2_0_1_10_7_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][7]*g10*g22;
    real G6_0_2_0_1_10_8_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g10*g02;
    real G6_0_2_0_1_10_8_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g10*g12;
    real G6_0_2_0_1_10_8_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g10*g22;
    real G6_0_2_0_1_10_9_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][9]*g10*g02;
    real G6_0_2_0_1_10_10_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][10]*g10*g12;
    real G6_0_2_0_1_10_11_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][11]*g10*g22;
    real G6_0_2_0_1_11_0_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g10*g02;
    real G6_0_2_0_1_11_0_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g10*g12;
    real G6_0_2_0_1_11_0_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g10*g22;
    real G6_0_2_0_1_11_1_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][1]*g10*g02;
    real G6_0_2_0_1_11_2_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][2]*g10*g12;
    real G6_0_2_0_1_11_3_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][3]*g10*g22;
    real G6_0_2_0_1_11_4_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g10*g02;
    real G6_0_2_0_1_11_4_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g10*g12;
    real G6_0_2_0_1_11_4_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g10*g22;
    real G6_0_2_0_1_11_5_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][5]*g10*g02;
    real G6_0_2_0_1_11_6_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][6]*g10*g12;
    real G6_0_2_0_1_11_7_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][7]*g10*g22;
    real G6_0_2_0_1_11_8_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g10*g02;
    real G6_0_2_0_1_11_8_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g10*g12;
    real G6_0_2_0_1_11_8_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g10*g22;
    real G6_0_2_0_1_11_9_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][9]*g10*g02;
    real G6_0_2_0_1_11_10_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][10]*g10*g12;
    real G6_0_2_0_1_11_11_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][11]*g10*g22;
    real G6_0_2_0_2_8_0_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g20*g02;
    real G6_0_2_0_2_8_0_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g20*g12;
    real G6_0_2_0_2_8_0_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][0]*g20*g22;
    real G6_0_2_0_2_8_1_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][1]*g20*g02;
    real G6_0_2_0_2_8_2_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][2]*g20*g12;
    real G6_0_2_0_2_8_3_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][3]*g20*g22;
    real G6_0_2_0_2_8_4_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g20*g02;
    real G6_0_2_0_2_8_4_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g20*g12;
    real G6_0_2_0_2_8_4_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][4]*g20*g22;
    real G6_0_2_0_2_8_5_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][5]*g20*g02;
    real G6_0_2_0_2_8_6_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][6]*g20*g12;
    real G6_0_2_0_2_8_7_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][7]*g20*g22;
    real G6_0_2_0_2_8_8_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g20*g02;
    real G6_0_2_0_2_8_8_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g20*g12;
    real G6_0_2_0_2_8_8_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][8]*g20*g22;
    real G6_0_2_0_2_8_9_0 = det*c1*c0*w[0][0]*w[0][8]*w[1][9]*g20*g02;
    real G6_0_2_0_2_8_10_1 = det*c1*c0*w[0][0]*w[0][8]*w[1][10]*g20*g12;
    real G6_0_2_0_2_8_11_2 = det*c1*c0*w[0][0]*w[0][8]*w[1][11]*g20*g22;
    real G6_0_2_0_2_9_0_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g20*g02;
    real G6_0_2_0_2_9_0_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g20*g12;
    real G6_0_2_0_2_9_0_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][0]*g20*g22;
    real G6_0_2_0_2_9_1_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][1]*g20*g02;
    real G6_0_2_0_2_9_2_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][2]*g20*g12;
    real G6_0_2_0_2_9_3_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][3]*g20*g22;
    real G6_0_2_0_2_9_4_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g20*g02;
    real G6_0_2_0_2_9_4_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g20*g12;
    real G6_0_2_0_2_9_4_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][4]*g20*g22;
    real G6_0_2_0_2_9_5_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][5]*g20*g02;
    real G6_0_2_0_2_9_6_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][6]*g20*g12;
    real G6_0_2_0_2_9_7_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][7]*g20*g22;
    real G6_0_2_0_2_9_8_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g20*g02;
    real G6_0_2_0_2_9_8_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g20*g12;
    real G6_0_2_0_2_9_8_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][8]*g20*g22;
    real G6_0_2_0_2_9_9_0 = det*c1*c0*w[0][0]*w[0][9]*w[1][9]*g20*g02;
    real G6_0_2_0_2_9_10_1 = det*c1*c0*w[0][0]*w[0][9]*w[1][10]*g20*g12;
    real G6_0_2_0_2_9_11_2 = det*c1*c0*w[0][0]*w[0][9]*w[1][11]*g20*g22;
    real G6_0_2_0_2_10_0_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g20*g02;
    real G6_0_2_0_2_10_0_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g20*g12;
    real G6_0_2_0_2_10_0_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][0]*g20*g22;
    real G6_0_2_0_2_10_1_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][1]*g20*g02;
    real G6_0_2_0_2_10_2_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][2]*g20*g12;
    real G6_0_2_0_2_10_3_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][3]*g20*g22;
    real G6_0_2_0_2_10_4_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g20*g02;
    real G6_0_2_0_2_10_4_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g20*g12;
    real G6_0_2_0_2_10_4_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][4]*g20*g22;
    real G6_0_2_0_2_10_5_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][5]*g20*g02;
    real G6_0_2_0_2_10_6_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][6]*g20*g12;
    real G6_0_2_0_2_10_7_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][7]*g20*g22;
    real G6_0_2_0_2_10_8_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g20*g02;
    real G6_0_2_0_2_10_8_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g20*g12;
    real G6_0_2_0_2_10_8_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][8]*g20*g22;
    real G6_0_2_0_2_10_9_0 = det*c1*c0*w[0][0]*w[0][10]*w[1][9]*g20*g02;
    real G6_0_2_0_2_10_10_1 = det*c1*c0*w[0][0]*w[0][10]*w[1][10]*g20*g12;
    real G6_0_2_0_2_10_11_2 = det*c1*c0*w[0][0]*w[0][10]*w[1][11]*g20*g22;
    real G6_0_2_0_2_11_0_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g20*g02;
    real G6_0_2_0_2_11_0_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g20*g12;
    real G6_0_2_0_2_11_0_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][0]*g20*g22;
    real G6_0_2_0_2_11_1_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][1]*g20*g02;
    real G6_0_2_0_2_11_2_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][2]*g20*g12;
    real G6_0_2_0_2_11_3_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][3]*g20*g22;
    real G6_0_2_0_2_11_4_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g20*g02;
    real G6_0_2_0_2_11_4_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g20*g12;
    real G6_0_2_0_2_11_4_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][4]*g20*g22;
    real G6_0_2_0_2_11_5_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][5]*g20*g02;
    real G6_0_2_0_2_11_6_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][6]*g20*g12;
    real G6_0_2_0_2_11_7_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][7]*g20*g22;
    real G6_0_2_0_2_11_8_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g20*g02;
    real G6_0_2_0_2_11_8_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g20*g12;
    real G6_0_2_0_2_11_8_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][8]*g20*g22;
    real G6_0_2_0_2_11_9_0 = det*c1*c0*w[0][0]*w[0][11]*w[1][9]*g20*g02;
    real G6_0_2_0_2_11_10_1 = det*c1*c0*w[0][0]*w[0][11]*w[1][10]*g20*g12;
    real G6_0_2_0_2_11_11_2 = det*c1*c0*w[0][0]*w[0][11]*w[1][11]*g20*g22;
    real G6_0_2_1_0_8_0_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g00*g02;
    real G6_0_2_1_0_8_0_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g00*g12;
    real G6_0_2_1_0_8_0_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g00*g22;
    real G6_0_2_1_0_8_1_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][1]*g00*g02;
    real G6_0_2_1_0_8_2_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][2]*g00*g12;
    real G6_0_2_1_0_8_3_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][3]*g00*g22;
    real G6_0_2_1_0_8_4_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g00*g02;
    real G6_0_2_1_0_8_4_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g00*g12;
    real G6_0_2_1_0_8_4_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g00*g22;
    real G6_0_2_1_0_8_5_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][5]*g00*g02;
    real G6_0_2_1_0_8_6_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][6]*g00*g12;
    real G6_0_2_1_0_8_7_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][7]*g00*g22;
    real G6_0_2_1_0_8_8_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g00*g02;
    real G6_0_2_1_0_8_8_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g00*g12;
    real G6_0_2_1_0_8_8_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g00*g22;
    real G6_0_2_1_0_8_9_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][9]*g00*g02;
    real G6_0_2_1_0_8_10_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][10]*g00*g12;
    real G6_0_2_1_0_8_11_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][11]*g00*g22;
    real G6_0_2_1_0_9_0_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g00*g02;
    real G6_0_2_1_0_9_0_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g00*g12;
    real G6_0_2_1_0_9_0_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g00*g22;
    real G6_0_2_1_0_9_1_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][1]*g00*g02;
    real G6_0_2_1_0_9_2_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][2]*g00*g12;
    real G6_0_2_1_0_9_3_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][3]*g00*g22;
    real G6_0_2_1_0_9_4_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g00*g02;
    real G6_0_2_1_0_9_4_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g00*g12;
    real G6_0_2_1_0_9_4_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g00*g22;
    real G6_0_2_1_0_9_5_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][5]*g00*g02;
    real G6_0_2_1_0_9_6_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][6]*g00*g12;
    real G6_0_2_1_0_9_7_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][7]*g00*g22;
    real G6_0_2_1_0_9_8_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g00*g02;
    real G6_0_2_1_0_9_8_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g00*g12;
    real G6_0_2_1_0_9_8_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g00*g22;
    real G6_0_2_1_0_9_9_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][9]*g00*g02;
    real G6_0_2_1_0_9_10_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][10]*g00*g12;
    real G6_0_2_1_0_9_11_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][11]*g00*g22;
    real G6_0_2_1_0_10_0_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g00*g02;
    real G6_0_2_1_0_10_0_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g00*g12;
    real G6_0_2_1_0_10_0_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g00*g22;
    real G6_0_2_1_0_10_1_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][1]*g00*g02;
    real G6_0_2_1_0_10_2_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][2]*g00*g12;
    real G6_0_2_1_0_10_3_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][3]*g00*g22;
    real G6_0_2_1_0_10_4_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g00*g02;
    real G6_0_2_1_0_10_4_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g00*g12;
    real G6_0_2_1_0_10_4_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g00*g22;
    real G6_0_2_1_0_10_5_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][5]*g00*g02;
    real G6_0_2_1_0_10_6_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][6]*g00*g12;
    real G6_0_2_1_0_10_7_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][7]*g00*g22;
    real G6_0_2_1_0_10_8_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g00*g02;
    real G6_0_2_1_0_10_8_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g00*g12;
    real G6_0_2_1_0_10_8_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g00*g22;
    real G6_0_2_1_0_10_9_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][9]*g00*g02;
    real G6_0_2_1_0_10_10_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][10]*g00*g12;
    real G6_0_2_1_0_10_11_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][11]*g00*g22;
    real G6_0_2_1_0_11_0_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g00*g02;
    real G6_0_2_1_0_11_0_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g00*g12;
    real G6_0_2_1_0_11_0_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g00*g22;
    real G6_0_2_1_0_11_1_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][1]*g00*g02;
    real G6_0_2_1_0_11_2_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][2]*g00*g12;
    real G6_0_2_1_0_11_3_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][3]*g00*g22;
    real G6_0_2_1_0_11_4_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g00*g02;
    real G6_0_2_1_0_11_4_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g00*g12;
    real G6_0_2_1_0_11_4_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g00*g22;
    real G6_0_2_1_0_11_5_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][5]*g00*g02;
    real G6_0_2_1_0_11_6_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][6]*g00*g12;
    real G6_0_2_1_0_11_7_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][7]*g00*g22;
    real G6_0_2_1_0_11_8_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g00*g02;
    real G6_0_2_1_0_11_8_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g00*g12;
    real G6_0_2_1_0_11_8_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g00*g22;
    real G6_0_2_1_0_11_9_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][9]*g00*g02;
    real G6_0_2_1_0_11_10_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][10]*g00*g12;
    real G6_0_2_1_0_11_11_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][11]*g00*g22;
    real G6_0_2_1_1_8_0_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g10*g02;
    real G6_0_2_1_1_8_0_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g10*g12;
    real G6_0_2_1_1_8_0_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g10*g22;
    real G6_0_2_1_1_8_1_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][1]*g10*g02;
    real G6_0_2_1_1_8_2_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][2]*g10*g12;
    real G6_0_2_1_1_8_3_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][3]*g10*g22;
    real G6_0_2_1_1_8_4_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g10*g02;
    real G6_0_2_1_1_8_4_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g10*g12;
    real G6_0_2_1_1_8_4_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g10*g22;
    real G6_0_2_1_1_8_5_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][5]*g10*g02;
    real G6_0_2_1_1_8_6_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][6]*g10*g12;
    real G6_0_2_1_1_8_7_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][7]*g10*g22;
    real G6_0_2_1_1_8_8_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g10*g02;
    real G6_0_2_1_1_8_8_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g10*g12;
    real G6_0_2_1_1_8_8_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g10*g22;
    real G6_0_2_1_1_8_9_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][9]*g10*g02;
    real G6_0_2_1_1_8_10_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][10]*g10*g12;
    real G6_0_2_1_1_8_11_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][11]*g10*g22;
    real G6_0_2_1_1_9_0_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g10*g02;
    real G6_0_2_1_1_9_0_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g10*g12;
    real G6_0_2_1_1_9_0_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g10*g22;
    real G6_0_2_1_1_9_1_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][1]*g10*g02;
    real G6_0_2_1_1_9_2_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][2]*g10*g12;
    real G6_0_2_1_1_9_3_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][3]*g10*g22;
    real G6_0_2_1_1_9_4_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g10*g02;
    real G6_0_2_1_1_9_4_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g10*g12;
    real G6_0_2_1_1_9_4_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g10*g22;
    real G6_0_2_1_1_9_5_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][5]*g10*g02;
    real G6_0_2_1_1_9_6_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][6]*g10*g12;
    real G6_0_2_1_1_9_7_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][7]*g10*g22;
    real G6_0_2_1_1_9_8_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g10*g02;
    real G6_0_2_1_1_9_8_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g10*g12;
    real G6_0_2_1_1_9_8_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g10*g22;
    real G6_0_2_1_1_9_9_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][9]*g10*g02;
    real G6_0_2_1_1_9_10_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][10]*g10*g12;
    real G6_0_2_1_1_9_11_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][11]*g10*g22;
    real G6_0_2_1_1_10_0_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g10*g02;
    real G6_0_2_1_1_10_0_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g10*g12;
    real G6_0_2_1_1_10_0_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g10*g22;
    real G6_0_2_1_1_10_1_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][1]*g10*g02;
    real G6_0_2_1_1_10_2_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][2]*g10*g12;
    real G6_0_2_1_1_10_3_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][3]*g10*g22;
    real G6_0_2_1_1_10_4_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g10*g02;
    real G6_0_2_1_1_10_4_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g10*g12;
    real G6_0_2_1_1_10_4_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g10*g22;
    real G6_0_2_1_1_10_5_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][5]*g10*g02;
    real G6_0_2_1_1_10_6_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][6]*g10*g12;
    real G6_0_2_1_1_10_7_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][7]*g10*g22;
    real G6_0_2_1_1_10_8_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g10*g02;
    real G6_0_2_1_1_10_8_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g10*g12;
    real G6_0_2_1_1_10_8_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g10*g22;
    real G6_0_2_1_1_10_9_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][9]*g10*g02;
    real G6_0_2_1_1_10_10_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][10]*g10*g12;
    real G6_0_2_1_1_10_11_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][11]*g10*g22;
    real G6_0_2_1_1_11_0_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g10*g02;
    real G6_0_2_1_1_11_0_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g10*g12;
    real G6_0_2_1_1_11_0_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g10*g22;
    real G6_0_2_1_1_11_1_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][1]*g10*g02;
    real G6_0_2_1_1_11_2_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][2]*g10*g12;
    real G6_0_2_1_1_11_3_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][3]*g10*g22;
    real G6_0_2_1_1_11_4_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g10*g02;
    real G6_0_2_1_1_11_4_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g10*g12;
    real G6_0_2_1_1_11_4_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g10*g22;
    real G6_0_2_1_1_11_5_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][5]*g10*g02;
    real G6_0_2_1_1_11_6_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][6]*g10*g12;
    real G6_0_2_1_1_11_7_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][7]*g10*g22;
    real G6_0_2_1_1_11_8_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g10*g02;
    real G6_0_2_1_1_11_8_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g10*g12;
    real G6_0_2_1_1_11_8_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g10*g22;
    real G6_0_2_1_1_11_9_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][9]*g10*g02;
    real G6_0_2_1_1_11_10_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][10]*g10*g12;
    real G6_0_2_1_1_11_11_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][11]*g10*g22;
    real G6_0_2_1_2_8_0_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g20*g02;
    real G6_0_2_1_2_8_0_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g20*g12;
    real G6_0_2_1_2_8_0_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][0]*g20*g22;
    real G6_0_2_1_2_8_1_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][1]*g20*g02;
    real G6_0_2_1_2_8_2_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][2]*g20*g12;
    real G6_0_2_1_2_8_3_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][3]*g20*g22;
    real G6_0_2_1_2_8_4_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g20*g02;
    real G6_0_2_1_2_8_4_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g20*g12;
    real G6_0_2_1_2_8_4_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][4]*g20*g22;
    real G6_0_2_1_2_8_5_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][5]*g20*g02;
    real G6_0_2_1_2_8_6_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][6]*g20*g12;
    real G6_0_2_1_2_8_7_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][7]*g20*g22;
    real G6_0_2_1_2_8_8_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g20*g02;
    real G6_0_2_1_2_8_8_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g20*g12;
    real G6_0_2_1_2_8_8_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][8]*g20*g22;
    real G6_0_2_1_2_8_9_0 = det*c1*c0*w[0][1]*w[0][8]*w[1][9]*g20*g02;
    real G6_0_2_1_2_8_10_1 = det*c1*c0*w[0][1]*w[0][8]*w[1][10]*g20*g12;
    real G6_0_2_1_2_8_11_2 = det*c1*c0*w[0][1]*w[0][8]*w[1][11]*g20*g22;
    real G6_0_2_1_2_9_0_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g20*g02;
    real G6_0_2_1_2_9_0_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g20*g12;
    real G6_0_2_1_2_9_0_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][0]*g20*g22;
    real G6_0_2_1_2_9_1_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][1]*g20*g02;
    real G6_0_2_1_2_9_2_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][2]*g20*g12;
    real G6_0_2_1_2_9_3_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][3]*g20*g22;
    real G6_0_2_1_2_9_4_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g20*g02;
    real G6_0_2_1_2_9_4_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g20*g12;
    real G6_0_2_1_2_9_4_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][4]*g20*g22;
    real G6_0_2_1_2_9_5_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][5]*g20*g02;
    real G6_0_2_1_2_9_6_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][6]*g20*g12;
    real G6_0_2_1_2_9_7_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][7]*g20*g22;
    real G6_0_2_1_2_9_8_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g20*g02;
    real G6_0_2_1_2_9_8_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g20*g12;
    real G6_0_2_1_2_9_8_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][8]*g20*g22;
    real G6_0_2_1_2_9_9_0 = det*c1*c0*w[0][1]*w[0][9]*w[1][9]*g20*g02;
    real G6_0_2_1_2_9_10_1 = det*c1*c0*w[0][1]*w[0][9]*w[1][10]*g20*g12;
    real G6_0_2_1_2_9_11_2 = det*c1*c0*w[0][1]*w[0][9]*w[1][11]*g20*g22;
    real G6_0_2_1_2_10_0_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g20*g02;
    real G6_0_2_1_2_10_0_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g20*g12;
    real G6_0_2_1_2_10_0_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][0]*g20*g22;
    real G6_0_2_1_2_10_1_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][1]*g20*g02;
    real G6_0_2_1_2_10_2_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][2]*g20*g12;
    real G6_0_2_1_2_10_3_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][3]*g20*g22;
    real G6_0_2_1_2_10_4_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g20*g02;
    real G6_0_2_1_2_10_4_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g20*g12;
    real G6_0_2_1_2_10_4_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][4]*g20*g22;
    real G6_0_2_1_2_10_5_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][5]*g20*g02;
    real G6_0_2_1_2_10_6_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][6]*g20*g12;
    real G6_0_2_1_2_10_7_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][7]*g20*g22;
    real G6_0_2_1_2_10_8_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g20*g02;
    real G6_0_2_1_2_10_8_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g20*g12;
    real G6_0_2_1_2_10_8_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][8]*g20*g22;
    real G6_0_2_1_2_10_9_0 = det*c1*c0*w[0][1]*w[0][10]*w[1][9]*g20*g02;
    real G6_0_2_1_2_10_10_1 = det*c1*c0*w[0][1]*w[0][10]*w[1][10]*g20*g12;
    real G6_0_2_1_2_10_11_2 = det*c1*c0*w[0][1]*w[0][10]*w[1][11]*g20*g22;
    real G6_0_2_1_2_11_0_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g20*g02;
    real G6_0_2_1_2_11_0_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g20*g12;
    real G6_0_2_1_2_11_0_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][0]*g20*g22;
    real G6_0_2_1_2_11_1_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][1]*g20*g02;
    real G6_0_2_1_2_11_2_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][2]*g20*g12;
    real G6_0_2_1_2_11_3_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][3]*g20*g22;
    real G6_0_2_1_2_11_4_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g20*g02;
    real G6_0_2_1_2_11_4_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g20*g12;
    real G6_0_2_1_2_11_4_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][4]*g20*g22;
    real G6_0_2_1_2_11_5_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][5]*g20*g02;
    real G6_0_2_1_2_11_6_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][6]*g20*g12;
    real G6_0_2_1_2_11_7_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][7]*g20*g22;
    real G6_0_2_1_2_11_8_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g20*g02;
    real G6_0_2_1_2_11_8_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g20*g12;
    real G6_0_2_1_2_11_8_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][8]*g20*g22;
    real G6_0_2_1_2_11_9_0 = det*c1*c0*w[0][1]*w[0][11]*w[1][9]*g20*g02;
    real G6_0_2_1_2_11_10_1 = det*c1*c0*w[0][1]*w[0][11]*w[1][10]*g20*g12;
    real G6_0_2_1_2_11_11_2 = det*c1*c0*w[0][1]*w[0][11]*w[1][11]*g20*g22;
    real G6_0_2_2_0_8_0_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g00*g02;
    real G6_0_2_2_0_8_0_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g00*g12;
    real G6_0_2_2_0_8_0_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g00*g22;
    real G6_0_2_2_0_8_1_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][1]*g00*g02;
    real G6_0_2_2_0_8_2_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][2]*g00*g12;
    real G6_0_2_2_0_8_3_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][3]*g00*g22;
    real G6_0_2_2_0_8_4_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g00*g02;
    real G6_0_2_2_0_8_4_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g00*g12;
    real G6_0_2_2_0_8_4_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g00*g22;
    real G6_0_2_2_0_8_5_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][5]*g00*g02;
    real G6_0_2_2_0_8_6_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][6]*g00*g12;
    real G6_0_2_2_0_8_7_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][7]*g00*g22;
    real G6_0_2_2_0_8_8_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g00*g02;
    real G6_0_2_2_0_8_8_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g00*g12;
    real G6_0_2_2_0_8_8_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g00*g22;
    real G6_0_2_2_0_8_9_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][9]*g00*g02;
    real G6_0_2_2_0_8_10_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][10]*g00*g12;
    real G6_0_2_2_0_8_11_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][11]*g00*g22;
    real G6_0_2_2_0_9_0_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g00*g02;
    real G6_0_2_2_0_9_0_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g00*g12;
    real G6_0_2_2_0_9_0_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g00*g22;
    real G6_0_2_2_0_9_1_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][1]*g00*g02;
    real G6_0_2_2_0_9_2_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][2]*g00*g12;
    real G6_0_2_2_0_9_3_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][3]*g00*g22;
    real G6_0_2_2_0_9_4_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g00*g02;
    real G6_0_2_2_0_9_4_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g00*g12;
    real G6_0_2_2_0_9_4_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g00*g22;
    real G6_0_2_2_0_9_5_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][5]*g00*g02;
    real G6_0_2_2_0_9_6_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][6]*g00*g12;
    real G6_0_2_2_0_9_7_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][7]*g00*g22;
    real G6_0_2_2_0_9_8_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g00*g02;
    real G6_0_2_2_0_9_8_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g00*g12;
    real G6_0_2_2_0_9_8_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g00*g22;
    real G6_0_2_2_0_9_9_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][9]*g00*g02;
    real G6_0_2_2_0_9_10_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][10]*g00*g12;
    real G6_0_2_2_0_9_11_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][11]*g00*g22;
    real G6_0_2_2_0_10_0_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g00*g02;
    real G6_0_2_2_0_10_0_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g00*g12;
    real G6_0_2_2_0_10_0_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g00*g22;
    real G6_0_2_2_0_10_1_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][1]*g00*g02;
    real G6_0_2_2_0_10_2_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][2]*g00*g12;
    real G6_0_2_2_0_10_3_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][3]*g00*g22;
    real G6_0_2_2_0_10_4_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g00*g02;
    real G6_0_2_2_0_10_4_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g00*g12;
    real G6_0_2_2_0_10_4_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g00*g22;
    real G6_0_2_2_0_10_5_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][5]*g00*g02;
    real G6_0_2_2_0_10_6_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][6]*g00*g12;
    real G6_0_2_2_0_10_7_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][7]*g00*g22;
    real G6_0_2_2_0_10_8_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g00*g02;
    real G6_0_2_2_0_10_8_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g00*g12;
    real G6_0_2_2_0_10_8_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g00*g22;
    real G6_0_2_2_0_10_9_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][9]*g00*g02;
    real G6_0_2_2_0_10_10_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][10]*g00*g12;
    real G6_0_2_2_0_10_11_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][11]*g00*g22;
    real G6_0_2_2_0_11_0_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g00*g02;
    real G6_0_2_2_0_11_0_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g00*g12;
    real G6_0_2_2_0_11_0_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g00*g22;
    real G6_0_2_2_0_11_1_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][1]*g00*g02;
    real G6_0_2_2_0_11_2_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][2]*g00*g12;
    real G6_0_2_2_0_11_3_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][3]*g00*g22;
    real G6_0_2_2_0_11_4_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g00*g02;
    real G6_0_2_2_0_11_4_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g00*g12;
    real G6_0_2_2_0_11_4_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g00*g22;
    real G6_0_2_2_0_11_5_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][5]*g00*g02;
    real G6_0_2_2_0_11_6_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][6]*g00*g12;
    real G6_0_2_2_0_11_7_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][7]*g00*g22;
    real G6_0_2_2_0_11_8_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g00*g02;
    real G6_0_2_2_0_11_8_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g00*g12;
    real G6_0_2_2_0_11_8_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g00*g22;
    real G6_0_2_2_0_11_9_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][9]*g00*g02;
    real G6_0_2_2_0_11_10_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][10]*g00*g12;
    real G6_0_2_2_0_11_11_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][11]*g00*g22;
    real G6_0_2_2_1_8_0_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g10*g02;
    real G6_0_2_2_1_8_0_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g10*g12;
    real G6_0_2_2_1_8_0_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g10*g22;
    real G6_0_2_2_1_8_1_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][1]*g10*g02;
    real G6_0_2_2_1_8_2_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][2]*g10*g12;
    real G6_0_2_2_1_8_3_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][3]*g10*g22;
    real G6_0_2_2_1_8_4_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g10*g02;
    real G6_0_2_2_1_8_4_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g10*g12;
    real G6_0_2_2_1_8_4_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g10*g22;
    real G6_0_2_2_1_8_5_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][5]*g10*g02;
    real G6_0_2_2_1_8_6_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][6]*g10*g12;
    real G6_0_2_2_1_8_7_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][7]*g10*g22;
    real G6_0_2_2_1_8_8_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g10*g02;
    real G6_0_2_2_1_8_8_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g10*g12;
    real G6_0_2_2_1_8_8_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g10*g22;
    real G6_0_2_2_1_8_9_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][9]*g10*g02;
    real G6_0_2_2_1_8_10_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][10]*g10*g12;
    real G6_0_2_2_1_8_11_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][11]*g10*g22;
    real G6_0_2_2_1_9_0_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g10*g02;
    real G6_0_2_2_1_9_0_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g10*g12;
    real G6_0_2_2_1_9_0_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g10*g22;
    real G6_0_2_2_1_9_1_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][1]*g10*g02;
    real G6_0_2_2_1_9_2_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][2]*g10*g12;
    real G6_0_2_2_1_9_3_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][3]*g10*g22;
    real G6_0_2_2_1_9_4_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g10*g02;
    real G6_0_2_2_1_9_4_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g10*g12;
    real G6_0_2_2_1_9_4_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g10*g22;
    real G6_0_2_2_1_9_5_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][5]*g10*g02;
    real G6_0_2_2_1_9_6_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][6]*g10*g12;
    real G6_0_2_2_1_9_7_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][7]*g10*g22;
    real G6_0_2_2_1_9_8_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g10*g02;
    real G6_0_2_2_1_9_8_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g10*g12;
    real G6_0_2_2_1_9_8_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g10*g22;
    real G6_0_2_2_1_9_9_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][9]*g10*g02;
    real G6_0_2_2_1_9_10_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][10]*g10*g12;
    real G6_0_2_2_1_9_11_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][11]*g10*g22;
    real G6_0_2_2_1_10_0_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g10*g02;
    real G6_0_2_2_1_10_0_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g10*g12;
    real G6_0_2_2_1_10_0_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g10*g22;
    real G6_0_2_2_1_10_1_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][1]*g10*g02;
    real G6_0_2_2_1_10_2_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][2]*g10*g12;
    real G6_0_2_2_1_10_3_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][3]*g10*g22;
    real G6_0_2_2_1_10_4_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g10*g02;
    real G6_0_2_2_1_10_4_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g10*g12;
    real G6_0_2_2_1_10_4_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g10*g22;
    real G6_0_2_2_1_10_5_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][5]*g10*g02;
    real G6_0_2_2_1_10_6_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][6]*g10*g12;
    real G6_0_2_2_1_10_7_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][7]*g10*g22;
    real G6_0_2_2_1_10_8_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g10*g02;
    real G6_0_2_2_1_10_8_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g10*g12;
    real G6_0_2_2_1_10_8_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g10*g22;
    real G6_0_2_2_1_10_9_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][9]*g10*g02;
    real G6_0_2_2_1_10_10_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][10]*g10*g12;
    real G6_0_2_2_1_10_11_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][11]*g10*g22;
    real G6_0_2_2_1_11_0_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g10*g02;
    real G6_0_2_2_1_11_0_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g10*g12;
    real G6_0_2_2_1_11_0_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g10*g22;
    real G6_0_2_2_1_11_1_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][1]*g10*g02;
    real G6_0_2_2_1_11_2_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][2]*g10*g12;
    real G6_0_2_2_1_11_3_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][3]*g10*g22;
    real G6_0_2_2_1_11_4_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g10*g02;
    real G6_0_2_2_1_11_4_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g10*g12;
    real G6_0_2_2_1_11_4_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g10*g22;
    real G6_0_2_2_1_11_5_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][5]*g10*g02;
    real G6_0_2_2_1_11_6_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][6]*g10*g12;
    real G6_0_2_2_1_11_7_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][7]*g10*g22;
    real G6_0_2_2_1_11_8_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g10*g02;
    real G6_0_2_2_1_11_8_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g10*g12;
    real G6_0_2_2_1_11_8_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g10*g22;
    real G6_0_2_2_1_11_9_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][9]*g10*g02;
    real G6_0_2_2_1_11_10_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][10]*g10*g12;
    real G6_0_2_2_1_11_11_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][11]*g10*g22;
    real G6_0_2_2_2_8_0_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g20*g02;
    real G6_0_2_2_2_8_0_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g20*g12;
    real G6_0_2_2_2_8_0_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][0]*g20*g22;
    real G6_0_2_2_2_8_1_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][1]*g20*g02;
    real G6_0_2_2_2_8_2_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][2]*g20*g12;
    real G6_0_2_2_2_8_3_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][3]*g20*g22;
    real G6_0_2_2_2_8_4_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g20*g02;
    real G6_0_2_2_2_8_4_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g20*g12;
    real G6_0_2_2_2_8_4_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][4]*g20*g22;
    real G6_0_2_2_2_8_5_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][5]*g20*g02;
    real G6_0_2_2_2_8_6_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][6]*g20*g12;
    real G6_0_2_2_2_8_7_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][7]*g20*g22;
    real G6_0_2_2_2_8_8_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g20*g02;
    real G6_0_2_2_2_8_8_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g20*g12;
    real G6_0_2_2_2_8_8_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][8]*g20*g22;
    real G6_0_2_2_2_8_9_0 = det*c1*c0*w[0][2]*w[0][8]*w[1][9]*g20*g02;
    real G6_0_2_2_2_8_10_1 = det*c1*c0*w[0][2]*w[0][8]*w[1][10]*g20*g12;
    real G6_0_2_2_2_8_11_2 = det*c1*c0*w[0][2]*w[0][8]*w[1][11]*g20*g22;
    real G6_0_2_2_2_9_0_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g20*g02;
    real G6_0_2_2_2_9_0_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g20*g12;
    real G6_0_2_2_2_9_0_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][0]*g20*g22;
    real G6_0_2_2_2_9_1_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][1]*g20*g02;
    real G6_0_2_2_2_9_2_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][2]*g20*g12;
    real G6_0_2_2_2_9_3_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][3]*g20*g22;
    real G6_0_2_2_2_9_4_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g20*g02;
    real G6_0_2_2_2_9_4_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g20*g12;
    real G6_0_2_2_2_9_4_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][4]*g20*g22;
    real G6_0_2_2_2_9_5_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][5]*g20*g02;
    real G6_0_2_2_2_9_6_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][6]*g20*g12;
    real G6_0_2_2_2_9_7_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][7]*g20*g22;
    real G6_0_2_2_2_9_8_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g20*g02;
    real G6_0_2_2_2_9_8_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g20*g12;
    real G6_0_2_2_2_9_8_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][8]*g20*g22;
    real G6_0_2_2_2_9_9_0 = det*c1*c0*w[0][2]*w[0][9]*w[1][9]*g20*g02;
    real G6_0_2_2_2_9_10_1 = det*c1*c0*w[0][2]*w[0][9]*w[1][10]*g20*g12;
    real G6_0_2_2_2_9_11_2 = det*c1*c0*w[0][2]*w[0][9]*w[1][11]*g20*g22;
    real G6_0_2_2_2_10_0_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g20*g02;
    real G6_0_2_2_2_10_0_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g20*g12;
    real G6_0_2_2_2_10_0_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][0]*g20*g22;
    real G6_0_2_2_2_10_1_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][1]*g20*g02;
    real G6_0_2_2_2_10_2_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][2]*g20*g12;
    real G6_0_2_2_2_10_3_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][3]*g20*g22;
    real G6_0_2_2_2_10_4_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g20*g02;
    real G6_0_2_2_2_10_4_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g20*g12;
    real G6_0_2_2_2_10_4_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][4]*g20*g22;
    real G6_0_2_2_2_10_5_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][5]*g20*g02;
    real G6_0_2_2_2_10_6_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][6]*g20*g12;
    real G6_0_2_2_2_10_7_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][7]*g20*g22;
    real G6_0_2_2_2_10_8_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g20*g02;
    real G6_0_2_2_2_10_8_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g20*g12;
    real G6_0_2_2_2_10_8_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][8]*g20*g22;
    real G6_0_2_2_2_10_9_0 = det*c1*c0*w[0][2]*w[0][10]*w[1][9]*g20*g02;
    real G6_0_2_2_2_10_10_1 = det*c1*c0*w[0][2]*w[0][10]*w[1][10]*g20*g12;
    real G6_0_2_2_2_10_11_2 = det*c1*c0*w[0][2]*w[0][10]*w[1][11]*g20*g22;
    real G6_0_2_2_2_11_0_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g20*g02;
    real G6_0_2_2_2_11_0_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g20*g12;
    real G6_0_2_2_2_11_0_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][0]*g20*g22;
    real G6_0_2_2_2_11_1_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][1]*g20*g02;
    real G6_0_2_2_2_11_2_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][2]*g20*g12;
    real G6_0_2_2_2_11_3_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][3]*g20*g22;
    real G6_0_2_2_2_11_4_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g20*g02;
    real G6_0_2_2_2_11_4_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g20*g12;
    real G6_0_2_2_2_11_4_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][4]*g20*g22;
    real G6_0_2_2_2_11_5_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][5]*g20*g02;
    real G6_0_2_2_2_11_6_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][6]*g20*g12;
    real G6_0_2_2_2_11_7_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][7]*g20*g22;
    real G6_0_2_2_2_11_8_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g20*g02;
    real G6_0_2_2_2_11_8_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g20*g12;
    real G6_0_2_2_2_11_8_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][8]*g20*g22;
    real G6_0_2_2_2_11_9_0 = det*c1*c0*w[0][2]*w[0][11]*w[1][9]*g20*g02;
    real G6_0_2_2_2_11_10_1 = det*c1*c0*w[0][2]*w[0][11]*w[1][10]*g20*g12;
    real G6_0_2_2_2_11_11_2 = det*c1*c0*w[0][2]*w[0][11]*w[1][11]*g20*g22;
    real G6_0_2_3_0_8_0_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g00*g02;
    real G6_0_2_3_0_8_0_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g00*g12;
    real G6_0_2_3_0_8_0_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g00*g22;
    real G6_0_2_3_0_8_1_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][1]*g00*g02;
    real G6_0_2_3_0_8_2_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][2]*g00*g12;
    real G6_0_2_3_0_8_3_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][3]*g00*g22;
    real G6_0_2_3_0_8_4_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g00*g02;
    real G6_0_2_3_0_8_4_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g00*g12;
    real G6_0_2_3_0_8_4_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g00*g22;
    real G6_0_2_3_0_8_5_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][5]*g00*g02;
    real G6_0_2_3_0_8_6_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][6]*g00*g12;
    real G6_0_2_3_0_8_7_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][7]*g00*g22;
    real G6_0_2_3_0_8_8_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g00*g02;
    real G6_0_2_3_0_8_8_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g00*g12;
    real G6_0_2_3_0_8_8_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g00*g22;
    real G6_0_2_3_0_8_9_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][9]*g00*g02;
    real G6_0_2_3_0_8_10_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][10]*g00*g12;
    real G6_0_2_3_0_8_11_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][11]*g00*g22;
    real G6_0_2_3_0_9_0_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g00*g02;
    real G6_0_2_3_0_9_0_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g00*g12;
    real G6_0_2_3_0_9_0_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g00*g22;
    real G6_0_2_3_0_9_1_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][1]*g00*g02;
    real G6_0_2_3_0_9_2_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][2]*g00*g12;
    real G6_0_2_3_0_9_3_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][3]*g00*g22;
    real G6_0_2_3_0_9_4_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g00*g02;
    real G6_0_2_3_0_9_4_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g00*g12;
    real G6_0_2_3_0_9_4_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g00*g22;
    real G6_0_2_3_0_9_5_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][5]*g00*g02;
    real G6_0_2_3_0_9_6_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][6]*g00*g12;
    real G6_0_2_3_0_9_7_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][7]*g00*g22;
    real G6_0_2_3_0_9_8_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g00*g02;
    real G6_0_2_3_0_9_8_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g00*g12;
    real G6_0_2_3_0_9_8_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g00*g22;
    real G6_0_2_3_0_9_9_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][9]*g00*g02;
    real G6_0_2_3_0_9_10_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][10]*g00*g12;
    real G6_0_2_3_0_9_11_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][11]*g00*g22;
    real G6_0_2_3_0_10_0_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g00*g02;
    real G6_0_2_3_0_10_0_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g00*g12;
    real G6_0_2_3_0_10_0_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g00*g22;
    real G6_0_2_3_0_10_1_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][1]*g00*g02;
    real G6_0_2_3_0_10_2_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][2]*g00*g12;
    real G6_0_2_3_0_10_3_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][3]*g00*g22;
    real G6_0_2_3_0_10_4_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g00*g02;
    real G6_0_2_3_0_10_4_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g00*g12;
    real G6_0_2_3_0_10_4_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g00*g22;
    real G6_0_2_3_0_10_5_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][5]*g00*g02;
    real G6_0_2_3_0_10_6_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][6]*g00*g12;
    real G6_0_2_3_0_10_7_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][7]*g00*g22;
    real G6_0_2_3_0_10_8_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g00*g02;
    real G6_0_2_3_0_10_8_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g00*g12;
    real G6_0_2_3_0_10_8_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g00*g22;
    real G6_0_2_3_0_10_9_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][9]*g00*g02;
    real G6_0_2_3_0_10_10_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][10]*g00*g12;
    real G6_0_2_3_0_10_11_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][11]*g00*g22;
    real G6_0_2_3_0_11_0_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g00*g02;
    real G6_0_2_3_0_11_0_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g00*g12;
    real G6_0_2_3_0_11_0_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g00*g22;
    real G6_0_2_3_0_11_1_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][1]*g00*g02;
    real G6_0_2_3_0_11_2_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][2]*g00*g12;
    real G6_0_2_3_0_11_3_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][3]*g00*g22;
    real G6_0_2_3_0_11_4_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g00*g02;
    real G6_0_2_3_0_11_4_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g00*g12;
    real G6_0_2_3_0_11_4_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g00*g22;
    real G6_0_2_3_0_11_5_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][5]*g00*g02;
    real G6_0_2_3_0_11_6_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][6]*g00*g12;
    real G6_0_2_3_0_11_7_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][7]*g00*g22;
    real G6_0_2_3_0_11_8_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g00*g02;
    real G6_0_2_3_0_11_8_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g00*g12;
    real G6_0_2_3_0_11_8_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g00*g22;
    real G6_0_2_3_0_11_9_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][9]*g00*g02;
    real G6_0_2_3_0_11_10_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][10]*g00*g12;
    real G6_0_2_3_0_11_11_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][11]*g00*g22;
    real G6_0_2_3_1_8_0_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g10*g02;
    real G6_0_2_3_1_8_0_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g10*g12;
    real G6_0_2_3_1_8_0_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g10*g22;
    real G6_0_2_3_1_8_1_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][1]*g10*g02;
    real G6_0_2_3_1_8_2_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][2]*g10*g12;
    real G6_0_2_3_1_8_3_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][3]*g10*g22;
    real G6_0_2_3_1_8_4_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g10*g02;
    real G6_0_2_3_1_8_4_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g10*g12;
    real G6_0_2_3_1_8_4_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g10*g22;
    real G6_0_2_3_1_8_5_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][5]*g10*g02;
    real G6_0_2_3_1_8_6_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][6]*g10*g12;
    real G6_0_2_3_1_8_7_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][7]*g10*g22;
    real G6_0_2_3_1_8_8_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g10*g02;
    real G6_0_2_3_1_8_8_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g10*g12;
    real G6_0_2_3_1_8_8_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g10*g22;
    real G6_0_2_3_1_8_9_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][9]*g10*g02;
    real G6_0_2_3_1_8_10_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][10]*g10*g12;
    real G6_0_2_3_1_8_11_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][11]*g10*g22;
    real G6_0_2_3_1_9_0_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g10*g02;
    real G6_0_2_3_1_9_0_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g10*g12;
    real G6_0_2_3_1_9_0_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g10*g22;
    real G6_0_2_3_1_9_1_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][1]*g10*g02;
    real G6_0_2_3_1_9_2_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][2]*g10*g12;
    real G6_0_2_3_1_9_3_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][3]*g10*g22;
    real G6_0_2_3_1_9_4_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g10*g02;
    real G6_0_2_3_1_9_4_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g10*g12;
    real G6_0_2_3_1_9_4_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g10*g22;
    real G6_0_2_3_1_9_5_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][5]*g10*g02;
    real G6_0_2_3_1_9_6_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][6]*g10*g12;
    real G6_0_2_3_1_9_7_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][7]*g10*g22;
    real G6_0_2_3_1_9_8_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g10*g02;
    real G6_0_2_3_1_9_8_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g10*g12;
    real G6_0_2_3_1_9_8_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g10*g22;
    real G6_0_2_3_1_9_9_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][9]*g10*g02;
    real G6_0_2_3_1_9_10_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][10]*g10*g12;
    real G6_0_2_3_1_9_11_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][11]*g10*g22;
    real G6_0_2_3_1_10_0_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g10*g02;
    real G6_0_2_3_1_10_0_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g10*g12;
    real G6_0_2_3_1_10_0_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g10*g22;
    real G6_0_2_3_1_10_1_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][1]*g10*g02;
    real G6_0_2_3_1_10_2_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][2]*g10*g12;
    real G6_0_2_3_1_10_3_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][3]*g10*g22;
    real G6_0_2_3_1_10_4_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g10*g02;
    real G6_0_2_3_1_10_4_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g10*g12;
    real G6_0_2_3_1_10_4_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g10*g22;
    real G6_0_2_3_1_10_5_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][5]*g10*g02;
    real G6_0_2_3_1_10_6_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][6]*g10*g12;
    real G6_0_2_3_1_10_7_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][7]*g10*g22;
    real G6_0_2_3_1_10_8_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g10*g02;
    real G6_0_2_3_1_10_8_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g10*g12;
    real G6_0_2_3_1_10_8_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g10*g22;
    real G6_0_2_3_1_10_9_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][9]*g10*g02;
    real G6_0_2_3_1_10_10_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][10]*g10*g12;
    real G6_0_2_3_1_10_11_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][11]*g10*g22;
    real G6_0_2_3_1_11_0_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g10*g02;
    real G6_0_2_3_1_11_0_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g10*g12;
    real G6_0_2_3_1_11_0_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g10*g22;
    real G6_0_2_3_1_11_1_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][1]*g10*g02;
    real G6_0_2_3_1_11_2_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][2]*g10*g12;
    real G6_0_2_3_1_11_3_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][3]*g10*g22;
    real G6_0_2_3_1_11_4_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g10*g02;
    real G6_0_2_3_1_11_4_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g10*g12;
    real G6_0_2_3_1_11_4_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g10*g22;
    real G6_0_2_3_1_11_5_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][5]*g10*g02;
    real G6_0_2_3_1_11_6_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][6]*g10*g12;
    real G6_0_2_3_1_11_7_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][7]*g10*g22;
    real G6_0_2_3_1_11_8_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g10*g02;
    real G6_0_2_3_1_11_8_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g10*g12;
    real G6_0_2_3_1_11_8_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g10*g22;
    real G6_0_2_3_1_11_9_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][9]*g10*g02;
    real G6_0_2_3_1_11_10_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][10]*g10*g12;
    real G6_0_2_3_1_11_11_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][11]*g10*g22;
    real G6_0_2_3_2_8_0_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g20*g02;
    real G6_0_2_3_2_8_0_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g20*g12;
    real G6_0_2_3_2_8_0_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][0]*g20*g22;
    real G6_0_2_3_2_8_1_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][1]*g20*g02;
    real G6_0_2_3_2_8_2_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][2]*g20*g12;
    real G6_0_2_3_2_8_3_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][3]*g20*g22;
    real G6_0_2_3_2_8_4_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g20*g02;
    real G6_0_2_3_2_8_4_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g20*g12;
    real G6_0_2_3_2_8_4_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][4]*g20*g22;
    real G6_0_2_3_2_8_5_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][5]*g20*g02;
    real G6_0_2_3_2_8_6_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][6]*g20*g12;
    real G6_0_2_3_2_8_7_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][7]*g20*g22;
    real G6_0_2_3_2_8_8_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g20*g02;
    real G6_0_2_3_2_8_8_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g20*g12;
    real G6_0_2_3_2_8_8_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][8]*g20*g22;
    real G6_0_2_3_2_8_9_0 = det*c1*c0*w[0][3]*w[0][8]*w[1][9]*g20*g02;
    real G6_0_2_3_2_8_10_1 = det*c1*c0*w[0][3]*w[0][8]*w[1][10]*g20*g12;
    real G6_0_2_3_2_8_11_2 = det*c1*c0*w[0][3]*w[0][8]*w[1][11]*g20*g22;
    real G6_0_2_3_2_9_0_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g20*g02;
    real G6_0_2_3_2_9_0_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g20*g12;
    real G6_0_2_3_2_9_0_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][0]*g20*g22;
    real G6_0_2_3_2_9_1_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][1]*g20*g02;
    real G6_0_2_3_2_9_2_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][2]*g20*g12;
    real G6_0_2_3_2_9_3_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][3]*g20*g22;
    real G6_0_2_3_2_9_4_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g20*g02;
    real G6_0_2_3_2_9_4_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g20*g12;
    real G6_0_2_3_2_9_4_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][4]*g20*g22;
    real G6_0_2_3_2_9_5_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][5]*g20*g02;
    real G6_0_2_3_2_9_6_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][6]*g20*g12;
    real G6_0_2_3_2_9_7_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][7]*g20*g22;
    real G6_0_2_3_2_9_8_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g20*g02;
    real G6_0_2_3_2_9_8_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g20*g12;
    real G6_0_2_3_2_9_8_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][8]*g20*g22;
    real G6_0_2_3_2_9_9_0 = det*c1*c0*w[0][3]*w[0][9]*w[1][9]*g20*g02;
    real G6_0_2_3_2_9_10_1 = det*c1*c0*w[0][3]*w[0][9]*w[1][10]*g20*g12;
    real G6_0_2_3_2_9_11_2 = det*c1*c0*w[0][3]*w[0][9]*w[1][11]*g20*g22;
    real G6_0_2_3_2_10_0_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g20*g02;
    real G6_0_2_3_2_10_0_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g20*g12;
    real G6_0_2_3_2_10_0_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][0]*g20*g22;
    real G6_0_2_3_2_10_1_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][1]*g20*g02;
    real G6_0_2_3_2_10_2_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][2]*g20*g12;
    real G6_0_2_3_2_10_3_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][3]*g20*g22;
    real G6_0_2_3_2_10_4_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g20*g02;
    real G6_0_2_3_2_10_4_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g20*g12;
    real G6_0_2_3_2_10_4_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][4]*g20*g22;
    real G6_0_2_3_2_10_5_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][5]*g20*g02;
    real G6_0_2_3_2_10_6_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][6]*g20*g12;
    real G6_0_2_3_2_10_7_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][7]*g20*g22;
    real G6_0_2_3_2_10_8_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g20*g02;
    real G6_0_2_3_2_10_8_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g20*g12;
    real G6_0_2_3_2_10_8_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][8]*g20*g22;
    real G6_0_2_3_2_10_9_0 = det*c1*c0*w[0][3]*w[0][10]*w[1][9]*g20*g02;
    real G6_0_2_3_2_10_10_1 = det*c1*c0*w[0][3]*w[0][10]*w[1][10]*g20*g12;
    real G6_0_2_3_2_10_11_2 = det*c1*c0*w[0][3]*w[0][10]*w[1][11]*g20*g22;
    real G6_0_2_3_2_11_0_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g20*g02;
    real G6_0_2_3_2_11_0_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g20*g12;
    real G6_0_2_3_2_11_0_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][0]*g20*g22;
    real G6_0_2_3_2_11_1_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][1]*g20*g02;
    real G6_0_2_3_2_11_2_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][2]*g20*g12;
    real G6_0_2_3_2_11_3_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][3]*g20*g22;
    real G6_0_2_3_2_11_4_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g20*g02;
    real G6_0_2_3_2_11_4_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g20*g12;
    real G6_0_2_3_2_11_4_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][4]*g20*g22;
    real G6_0_2_3_2_11_5_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][5]*g20*g02;
    real G6_0_2_3_2_11_6_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][6]*g20*g12;
    real G6_0_2_3_2_11_7_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][7]*g20*g22;
    real G6_0_2_3_2_11_8_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g20*g02;
    real G6_0_2_3_2_11_8_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g20*g12;
    real G6_0_2_3_2_11_8_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][8]*g20*g22;
    real G6_0_2_3_2_11_9_0 = det*c1*c0*w[0][3]*w[0][11]*w[1][9]*g20*g02;
    real G6_0_2_3_2_11_10_1 = det*c1*c0*w[0][3]*w[0][11]*w[1][10]*g20*g12;
    real G6_0_2_3_2_11_11_2 = det*c1*c0*w[0][3]*w[0][11]*w[1][11]*g20*g22;
    real G6_1_0_4_0_0_0_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g01*g00;
    real G6_1_0_4_0_0_0_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g01*g10;
    real G6_1_0_4_0_0_0_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g01*g20;
    real G6_1_0_4_0_0_1_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][1]*g01*g00;
    real G6_1_0_4_0_0_2_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][2]*g01*g10;
    real G6_1_0_4_0_0_3_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][3]*g01*g20;
    real G6_1_0_4_0_0_4_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g01*g00;
    real G6_1_0_4_0_0_4_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g01*g10;
    real G6_1_0_4_0_0_4_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g01*g20;
    real G6_1_0_4_0_0_5_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][5]*g01*g00;
    real G6_1_0_4_0_0_6_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][6]*g01*g10;
    real G6_1_0_4_0_0_7_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][7]*g01*g20;
    real G6_1_0_4_0_0_8_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g01*g00;
    real G6_1_0_4_0_0_8_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g01*g10;
    real G6_1_0_4_0_0_8_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g01*g20;
    real G6_1_0_4_0_0_9_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][9]*g01*g00;
    real G6_1_0_4_0_0_10_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][10]*g01*g10;
    real G6_1_0_4_0_0_11_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][11]*g01*g20;
    real G6_1_0_4_0_1_0_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g01*g00;
    real G6_1_0_4_0_1_0_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g01*g10;
    real G6_1_0_4_0_1_0_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g01*g20;
    real G6_1_0_4_0_1_1_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][1]*g01*g00;
    real G6_1_0_4_0_1_2_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][2]*g01*g10;
    real G6_1_0_4_0_1_3_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][3]*g01*g20;
    real G6_1_0_4_0_1_4_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g01*g00;
    real G6_1_0_4_0_1_4_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g01*g10;
    real G6_1_0_4_0_1_4_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g01*g20;
    real G6_1_0_4_0_1_5_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][5]*g01*g00;
    real G6_1_0_4_0_1_6_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][6]*g01*g10;
    real G6_1_0_4_0_1_7_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][7]*g01*g20;
    real G6_1_0_4_0_1_8_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g01*g00;
    real G6_1_0_4_0_1_8_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g01*g10;
    real G6_1_0_4_0_1_8_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g01*g20;
    real G6_1_0_4_0_1_9_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][9]*g01*g00;
    real G6_1_0_4_0_1_10_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][10]*g01*g10;
    real G6_1_0_4_0_1_11_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][11]*g01*g20;
    real G6_1_0_4_0_2_0_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g01*g00;
    real G6_1_0_4_0_2_0_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g01*g10;
    real G6_1_0_4_0_2_0_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g01*g20;
    real G6_1_0_4_0_2_1_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][1]*g01*g00;
    real G6_1_0_4_0_2_2_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][2]*g01*g10;
    real G6_1_0_4_0_2_3_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][3]*g01*g20;
    real G6_1_0_4_0_2_4_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g01*g00;
    real G6_1_0_4_0_2_4_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g01*g10;
    real G6_1_0_4_0_2_4_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g01*g20;
    real G6_1_0_4_0_2_5_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][5]*g01*g00;
    real G6_1_0_4_0_2_6_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][6]*g01*g10;
    real G6_1_0_4_0_2_7_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][7]*g01*g20;
    real G6_1_0_4_0_2_8_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g01*g00;
    real G6_1_0_4_0_2_8_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g01*g10;
    real G6_1_0_4_0_2_8_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g01*g20;
    real G6_1_0_4_0_2_9_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][9]*g01*g00;
    real G6_1_0_4_0_2_10_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][10]*g01*g10;
    real G6_1_0_4_0_2_11_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][11]*g01*g20;
    real G6_1_0_4_0_3_0_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g01*g00;
    real G6_1_0_4_0_3_0_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g01*g10;
    real G6_1_0_4_0_3_0_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g01*g20;
    real G6_1_0_4_0_3_1_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][1]*g01*g00;
    real G6_1_0_4_0_3_2_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][2]*g01*g10;
    real G6_1_0_4_0_3_3_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][3]*g01*g20;
    real G6_1_0_4_0_3_4_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g01*g00;
    real G6_1_0_4_0_3_4_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g01*g10;
    real G6_1_0_4_0_3_4_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g01*g20;
    real G6_1_0_4_0_3_5_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][5]*g01*g00;
    real G6_1_0_4_0_3_6_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][6]*g01*g10;
    real G6_1_0_4_0_3_7_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][7]*g01*g20;
    real G6_1_0_4_0_3_8_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g01*g00;
    real G6_1_0_4_0_3_8_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g01*g10;
    real G6_1_0_4_0_3_8_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g01*g20;
    real G6_1_0_4_0_3_9_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][9]*g01*g00;
    real G6_1_0_4_0_3_10_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][10]*g01*g10;
    real G6_1_0_4_0_3_11_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][11]*g01*g20;
    real G6_1_0_4_1_0_0_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g11*g00;
    real G6_1_0_4_1_0_0_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g11*g10;
    real G6_1_0_4_1_0_0_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g11*g20;
    real G6_1_0_4_1_0_1_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][1]*g11*g00;
    real G6_1_0_4_1_0_2_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][2]*g11*g10;
    real G6_1_0_4_1_0_3_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][3]*g11*g20;
    real G6_1_0_4_1_0_4_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g11*g00;
    real G6_1_0_4_1_0_4_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g11*g10;
    real G6_1_0_4_1_0_4_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g11*g20;
    real G6_1_0_4_1_0_5_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][5]*g11*g00;
    real G6_1_0_4_1_0_6_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][6]*g11*g10;
    real G6_1_0_4_1_0_7_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][7]*g11*g20;
    real G6_1_0_4_1_0_8_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g11*g00;
    real G6_1_0_4_1_0_8_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g11*g10;
    real G6_1_0_4_1_0_8_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g11*g20;
    real G6_1_0_4_1_0_9_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][9]*g11*g00;
    real G6_1_0_4_1_0_10_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][10]*g11*g10;
    real G6_1_0_4_1_0_11_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][11]*g11*g20;
    real G6_1_0_4_1_1_0_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g11*g00;
    real G6_1_0_4_1_1_0_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g11*g10;
    real G6_1_0_4_1_1_0_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g11*g20;
    real G6_1_0_4_1_1_1_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][1]*g11*g00;
    real G6_1_0_4_1_1_2_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][2]*g11*g10;
    real G6_1_0_4_1_1_3_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][3]*g11*g20;
    real G6_1_0_4_1_1_4_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g11*g00;
    real G6_1_0_4_1_1_4_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g11*g10;
    real G6_1_0_4_1_1_4_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g11*g20;
    real G6_1_0_4_1_1_5_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][5]*g11*g00;
    real G6_1_0_4_1_1_6_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][6]*g11*g10;
    real G6_1_0_4_1_1_7_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][7]*g11*g20;
    real G6_1_0_4_1_1_8_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g11*g00;
    real G6_1_0_4_1_1_8_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g11*g10;
    real G6_1_0_4_1_1_8_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g11*g20;
    real G6_1_0_4_1_1_9_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][9]*g11*g00;
    real G6_1_0_4_1_1_10_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][10]*g11*g10;
    real G6_1_0_4_1_1_11_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][11]*g11*g20;
    real G6_1_0_4_1_2_0_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g11*g00;
    real G6_1_0_4_1_2_0_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g11*g10;
    real G6_1_0_4_1_2_0_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g11*g20;
    real G6_1_0_4_1_2_1_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][1]*g11*g00;
    real G6_1_0_4_1_2_2_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][2]*g11*g10;
    real G6_1_0_4_1_2_3_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][3]*g11*g20;
    real G6_1_0_4_1_2_4_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g11*g00;
    real G6_1_0_4_1_2_4_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g11*g10;
    real G6_1_0_4_1_2_4_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g11*g20;
    real G6_1_0_4_1_2_5_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][5]*g11*g00;
    real G6_1_0_4_1_2_6_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][6]*g11*g10;
    real G6_1_0_4_1_2_7_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][7]*g11*g20;
    real G6_1_0_4_1_2_8_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g11*g00;
    real G6_1_0_4_1_2_8_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g11*g10;
    real G6_1_0_4_1_2_8_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g11*g20;
    real G6_1_0_4_1_2_9_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][9]*g11*g00;
    real G6_1_0_4_1_2_10_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][10]*g11*g10;
    real G6_1_0_4_1_2_11_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][11]*g11*g20;
    real G6_1_0_4_1_3_0_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g11*g00;
    real G6_1_0_4_1_3_0_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g11*g10;
    real G6_1_0_4_1_3_0_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g11*g20;
    real G6_1_0_4_1_3_1_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][1]*g11*g00;
    real G6_1_0_4_1_3_2_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][2]*g11*g10;
    real G6_1_0_4_1_3_3_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][3]*g11*g20;
    real G6_1_0_4_1_3_4_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g11*g00;
    real G6_1_0_4_1_3_4_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g11*g10;
    real G6_1_0_4_1_3_4_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g11*g20;
    real G6_1_0_4_1_3_5_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][5]*g11*g00;
    real G6_1_0_4_1_3_6_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][6]*g11*g10;
    real G6_1_0_4_1_3_7_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][7]*g11*g20;
    real G6_1_0_4_1_3_8_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g11*g00;
    real G6_1_0_4_1_3_8_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g11*g10;
    real G6_1_0_4_1_3_8_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g11*g20;
    real G6_1_0_4_1_3_9_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][9]*g11*g00;
    real G6_1_0_4_1_3_10_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][10]*g11*g10;
    real G6_1_0_4_1_3_11_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][11]*g11*g20;
    real G6_1_0_4_2_0_0_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g21*g00;
    real G6_1_0_4_2_0_0_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g21*g10;
    real G6_1_0_4_2_0_0_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][0]*g21*g20;
    real G6_1_0_4_2_0_1_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][1]*g21*g00;
    real G6_1_0_4_2_0_2_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][2]*g21*g10;
    real G6_1_0_4_2_0_3_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][3]*g21*g20;
    real G6_1_0_4_2_0_4_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g21*g00;
    real G6_1_0_4_2_0_4_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g21*g10;
    real G6_1_0_4_2_0_4_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][4]*g21*g20;
    real G6_1_0_4_2_0_5_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][5]*g21*g00;
    real G6_1_0_4_2_0_6_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][6]*g21*g10;
    real G6_1_0_4_2_0_7_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][7]*g21*g20;
    real G6_1_0_4_2_0_8_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g21*g00;
    real G6_1_0_4_2_0_8_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g21*g10;
    real G6_1_0_4_2_0_8_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][8]*g21*g20;
    real G6_1_0_4_2_0_9_0 = det*c1*c0*w[0][4]*w[0][0]*w[1][9]*g21*g00;
    real G6_1_0_4_2_0_10_1 = det*c1*c0*w[0][4]*w[0][0]*w[1][10]*g21*g10;
    real G6_1_0_4_2_0_11_2 = det*c1*c0*w[0][4]*w[0][0]*w[1][11]*g21*g20;
    real G6_1_0_4_2_1_0_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g21*g00;
    real G6_1_0_4_2_1_0_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g21*g10;
    real G6_1_0_4_2_1_0_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][0]*g21*g20;
    real G6_1_0_4_2_1_1_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][1]*g21*g00;
    real G6_1_0_4_2_1_2_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][2]*g21*g10;
    real G6_1_0_4_2_1_3_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][3]*g21*g20;
    real G6_1_0_4_2_1_4_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g21*g00;
    real G6_1_0_4_2_1_4_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g21*g10;
    real G6_1_0_4_2_1_4_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][4]*g21*g20;
    real G6_1_0_4_2_1_5_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][5]*g21*g00;
    real G6_1_0_4_2_1_6_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][6]*g21*g10;
    real G6_1_0_4_2_1_7_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][7]*g21*g20;
    real G6_1_0_4_2_1_8_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g21*g00;
    real G6_1_0_4_2_1_8_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g21*g10;
    real G6_1_0_4_2_1_8_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][8]*g21*g20;
    real G6_1_0_4_2_1_9_0 = det*c1*c0*w[0][4]*w[0][1]*w[1][9]*g21*g00;
    real G6_1_0_4_2_1_10_1 = det*c1*c0*w[0][4]*w[0][1]*w[1][10]*g21*g10;
    real G6_1_0_4_2_1_11_2 = det*c1*c0*w[0][4]*w[0][1]*w[1][11]*g21*g20;
    real G6_1_0_4_2_2_0_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g21*g00;
    real G6_1_0_4_2_2_0_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g21*g10;
    real G6_1_0_4_2_2_0_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][0]*g21*g20;
    real G6_1_0_4_2_2_1_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][1]*g21*g00;
    real G6_1_0_4_2_2_2_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][2]*g21*g10;
    real G6_1_0_4_2_2_3_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][3]*g21*g20;
    real G6_1_0_4_2_2_4_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g21*g00;
    real G6_1_0_4_2_2_4_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g21*g10;
    real G6_1_0_4_2_2_4_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][4]*g21*g20;
    real G6_1_0_4_2_2_5_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][5]*g21*g00;
    real G6_1_0_4_2_2_6_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][6]*g21*g10;
    real G6_1_0_4_2_2_7_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][7]*g21*g20;
    real G6_1_0_4_2_2_8_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g21*g00;
    real G6_1_0_4_2_2_8_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g21*g10;
    real G6_1_0_4_2_2_8_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][8]*g21*g20;
    real G6_1_0_4_2_2_9_0 = det*c1*c0*w[0][4]*w[0][2]*w[1][9]*g21*g00;
    real G6_1_0_4_2_2_10_1 = det*c1*c0*w[0][4]*w[0][2]*w[1][10]*g21*g10;
    real G6_1_0_4_2_2_11_2 = det*c1*c0*w[0][4]*w[0][2]*w[1][11]*g21*g20;
    real G6_1_0_4_2_3_0_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g21*g00;
    real G6_1_0_4_2_3_0_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g21*g10;
    real G6_1_0_4_2_3_0_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][0]*g21*g20;
    real G6_1_0_4_2_3_1_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][1]*g21*g00;
    real G6_1_0_4_2_3_2_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][2]*g21*g10;
    real G6_1_0_4_2_3_3_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][3]*g21*g20;
    real G6_1_0_4_2_3_4_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g21*g00;
    real G6_1_0_4_2_3_4_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g21*g10;
    real G6_1_0_4_2_3_4_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][4]*g21*g20;
    real G6_1_0_4_2_3_5_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][5]*g21*g00;
    real G6_1_0_4_2_3_6_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][6]*g21*g10;
    real G6_1_0_4_2_3_7_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][7]*g21*g20;
    real G6_1_0_4_2_3_8_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g21*g00;
    real G6_1_0_4_2_3_8_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g21*g10;
    real G6_1_0_4_2_3_8_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][8]*g21*g20;
    real G6_1_0_4_2_3_9_0 = det*c1*c0*w[0][4]*w[0][3]*w[1][9]*g21*g00;
    real G6_1_0_4_2_3_10_1 = det*c1*c0*w[0][4]*w[0][3]*w[1][10]*g21*g10;
    real G6_1_0_4_2_3_11_2 = det*c1*c0*w[0][4]*w[0][3]*w[1][11]*g21*g20;
    real G6_1_0_5_0_0_0_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g01*g00;
    real G6_1_0_5_0_0_0_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g01*g10;
    real G6_1_0_5_0_0_0_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g01*g20;
    real G6_1_0_5_0_0_1_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][1]*g01*g00;
    real G6_1_0_5_0_0_2_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][2]*g01*g10;
    real G6_1_0_5_0_0_3_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][3]*g01*g20;
    real G6_1_0_5_0_0_4_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g01*g00;
    real G6_1_0_5_0_0_4_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g01*g10;
    real G6_1_0_5_0_0_4_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g01*g20;
    real G6_1_0_5_0_0_5_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][5]*g01*g00;
    real G6_1_0_5_0_0_6_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][6]*g01*g10;
    real G6_1_0_5_0_0_7_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][7]*g01*g20;
    real G6_1_0_5_0_0_8_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g01*g00;
    real G6_1_0_5_0_0_8_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g01*g10;
    real G6_1_0_5_0_0_8_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g01*g20;
    real G6_1_0_5_0_0_9_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][9]*g01*g00;
    real G6_1_0_5_0_0_10_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][10]*g01*g10;
    real G6_1_0_5_0_0_11_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][11]*g01*g20;
    real G6_1_0_5_0_1_0_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g01*g00;
    real G6_1_0_5_0_1_0_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g01*g10;
    real G6_1_0_5_0_1_0_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g01*g20;
    real G6_1_0_5_0_1_1_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][1]*g01*g00;
    real G6_1_0_5_0_1_2_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][2]*g01*g10;
    real G6_1_0_5_0_1_3_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][3]*g01*g20;
    real G6_1_0_5_0_1_4_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g01*g00;
    real G6_1_0_5_0_1_4_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g01*g10;
    real G6_1_0_5_0_1_4_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g01*g20;
    real G6_1_0_5_0_1_5_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][5]*g01*g00;
    real G6_1_0_5_0_1_6_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][6]*g01*g10;
    real G6_1_0_5_0_1_7_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][7]*g01*g20;
    real G6_1_0_5_0_1_8_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g01*g00;
    real G6_1_0_5_0_1_8_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g01*g10;
    real G6_1_0_5_0_1_8_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g01*g20;
    real G6_1_0_5_0_1_9_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][9]*g01*g00;
    real G6_1_0_5_0_1_10_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][10]*g01*g10;
    real G6_1_0_5_0_1_11_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][11]*g01*g20;
    real G6_1_0_5_0_2_0_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g01*g00;
    real G6_1_0_5_0_2_0_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g01*g10;
    real G6_1_0_5_0_2_0_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g01*g20;
    real G6_1_0_5_0_2_1_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][1]*g01*g00;
    real G6_1_0_5_0_2_2_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][2]*g01*g10;
    real G6_1_0_5_0_2_3_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][3]*g01*g20;
    real G6_1_0_5_0_2_4_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g01*g00;
    real G6_1_0_5_0_2_4_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g01*g10;
    real G6_1_0_5_0_2_4_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g01*g20;
    real G6_1_0_5_0_2_5_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][5]*g01*g00;
    real G6_1_0_5_0_2_6_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][6]*g01*g10;
    real G6_1_0_5_0_2_7_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][7]*g01*g20;
    real G6_1_0_5_0_2_8_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g01*g00;
    real G6_1_0_5_0_2_8_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g01*g10;
    real G6_1_0_5_0_2_8_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g01*g20;
    real G6_1_0_5_0_2_9_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][9]*g01*g00;
    real G6_1_0_5_0_2_10_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][10]*g01*g10;
    real G6_1_0_5_0_2_11_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][11]*g01*g20;
    real G6_1_0_5_0_3_0_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g01*g00;
    real G6_1_0_5_0_3_0_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g01*g10;
    real G6_1_0_5_0_3_0_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g01*g20;
    real G6_1_0_5_0_3_1_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][1]*g01*g00;
    real G6_1_0_5_0_3_2_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][2]*g01*g10;
    real G6_1_0_5_0_3_3_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][3]*g01*g20;
    real G6_1_0_5_0_3_4_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g01*g00;
    real G6_1_0_5_0_3_4_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g01*g10;
    real G6_1_0_5_0_3_4_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g01*g20;
    real G6_1_0_5_0_3_5_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][5]*g01*g00;
    real G6_1_0_5_0_3_6_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][6]*g01*g10;
    real G6_1_0_5_0_3_7_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][7]*g01*g20;
    real G6_1_0_5_0_3_8_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g01*g00;
    real G6_1_0_5_0_3_8_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g01*g10;
    real G6_1_0_5_0_3_8_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g01*g20;
    real G6_1_0_5_0_3_9_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][9]*g01*g00;
    real G6_1_0_5_0_3_10_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][10]*g01*g10;
    real G6_1_0_5_0_3_11_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][11]*g01*g20;
    real G6_1_0_5_1_0_0_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g11*g00;
    real G6_1_0_5_1_0_0_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g11*g10;
    real G6_1_0_5_1_0_0_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g11*g20;
    real G6_1_0_5_1_0_1_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][1]*g11*g00;
    real G6_1_0_5_1_0_2_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][2]*g11*g10;
    real G6_1_0_5_1_0_3_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][3]*g11*g20;
    real G6_1_0_5_1_0_4_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g11*g00;
    real G6_1_0_5_1_0_4_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g11*g10;
    real G6_1_0_5_1_0_4_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g11*g20;
    real G6_1_0_5_1_0_5_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][5]*g11*g00;
    real G6_1_0_5_1_0_6_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][6]*g11*g10;
    real G6_1_0_5_1_0_7_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][7]*g11*g20;
    real G6_1_0_5_1_0_8_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g11*g00;
    real G6_1_0_5_1_0_8_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g11*g10;
    real G6_1_0_5_1_0_8_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g11*g20;
    real G6_1_0_5_1_0_9_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][9]*g11*g00;
    real G6_1_0_5_1_0_10_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][10]*g11*g10;
    real G6_1_0_5_1_0_11_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][11]*g11*g20;
    real G6_1_0_5_1_1_0_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g11*g00;
    real G6_1_0_5_1_1_0_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g11*g10;
    real G6_1_0_5_1_1_0_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g11*g20;
    real G6_1_0_5_1_1_1_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][1]*g11*g00;
    real G6_1_0_5_1_1_2_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][2]*g11*g10;
    real G6_1_0_5_1_1_3_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][3]*g11*g20;
    real G6_1_0_5_1_1_4_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g11*g00;
    real G6_1_0_5_1_1_4_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g11*g10;
    real G6_1_0_5_1_1_4_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g11*g20;
    real G6_1_0_5_1_1_5_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][5]*g11*g00;
    real G6_1_0_5_1_1_6_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][6]*g11*g10;
    real G6_1_0_5_1_1_7_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][7]*g11*g20;
    real G6_1_0_5_1_1_8_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g11*g00;
    real G6_1_0_5_1_1_8_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g11*g10;
    real G6_1_0_5_1_1_8_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g11*g20;
    real G6_1_0_5_1_1_9_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][9]*g11*g00;
    real G6_1_0_5_1_1_10_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][10]*g11*g10;
    real G6_1_0_5_1_1_11_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][11]*g11*g20;
    real G6_1_0_5_1_2_0_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g11*g00;
    real G6_1_0_5_1_2_0_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g11*g10;
    real G6_1_0_5_1_2_0_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g11*g20;
    real G6_1_0_5_1_2_1_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][1]*g11*g00;
    real G6_1_0_5_1_2_2_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][2]*g11*g10;
    real G6_1_0_5_1_2_3_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][3]*g11*g20;
    real G6_1_0_5_1_2_4_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g11*g00;
    real G6_1_0_5_1_2_4_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g11*g10;
    real G6_1_0_5_1_2_4_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g11*g20;
    real G6_1_0_5_1_2_5_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][5]*g11*g00;
    real G6_1_0_5_1_2_6_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][6]*g11*g10;
    real G6_1_0_5_1_2_7_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][7]*g11*g20;
    real G6_1_0_5_1_2_8_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g11*g00;
    real G6_1_0_5_1_2_8_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g11*g10;
    real G6_1_0_5_1_2_8_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g11*g20;
    real G6_1_0_5_1_2_9_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][9]*g11*g00;
    real G6_1_0_5_1_2_10_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][10]*g11*g10;
    real G6_1_0_5_1_2_11_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][11]*g11*g20;
    real G6_1_0_5_1_3_0_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g11*g00;
    real G6_1_0_5_1_3_0_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g11*g10;
    real G6_1_0_5_1_3_0_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g11*g20;
    real G6_1_0_5_1_3_1_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][1]*g11*g00;
    real G6_1_0_5_1_3_2_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][2]*g11*g10;
    real G6_1_0_5_1_3_3_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][3]*g11*g20;
    real G6_1_0_5_1_3_4_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g11*g00;
    real G6_1_0_5_1_3_4_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g11*g10;
    real G6_1_0_5_1_3_4_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g11*g20;
    real G6_1_0_5_1_3_5_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][5]*g11*g00;
    real G6_1_0_5_1_3_6_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][6]*g11*g10;
    real G6_1_0_5_1_3_7_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][7]*g11*g20;
    real G6_1_0_5_1_3_8_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g11*g00;
    real G6_1_0_5_1_3_8_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g11*g10;
    real G6_1_0_5_1_3_8_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g11*g20;
    real G6_1_0_5_1_3_9_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][9]*g11*g00;
    real G6_1_0_5_1_3_10_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][10]*g11*g10;
    real G6_1_0_5_1_3_11_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][11]*g11*g20;
    real G6_1_0_5_2_0_0_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g21*g00;
    real G6_1_0_5_2_0_0_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g21*g10;
    real G6_1_0_5_2_0_0_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][0]*g21*g20;
    real G6_1_0_5_2_0_1_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][1]*g21*g00;
    real G6_1_0_5_2_0_2_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][2]*g21*g10;
    real G6_1_0_5_2_0_3_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][3]*g21*g20;
    real G6_1_0_5_2_0_4_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g21*g00;
    real G6_1_0_5_2_0_4_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g21*g10;
    real G6_1_0_5_2_0_4_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][4]*g21*g20;
    real G6_1_0_5_2_0_5_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][5]*g21*g00;
    real G6_1_0_5_2_0_6_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][6]*g21*g10;
    real G6_1_0_5_2_0_7_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][7]*g21*g20;
    real G6_1_0_5_2_0_8_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g21*g00;
    real G6_1_0_5_2_0_8_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g21*g10;
    real G6_1_0_5_2_0_8_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][8]*g21*g20;
    real G6_1_0_5_2_0_9_0 = det*c1*c0*w[0][5]*w[0][0]*w[1][9]*g21*g00;
    real G6_1_0_5_2_0_10_1 = det*c1*c0*w[0][5]*w[0][0]*w[1][10]*g21*g10;
    real G6_1_0_5_2_0_11_2 = det*c1*c0*w[0][5]*w[0][0]*w[1][11]*g21*g20;
    real G6_1_0_5_2_1_0_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g21*g00;
    real G6_1_0_5_2_1_0_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g21*g10;
    real G6_1_0_5_2_1_0_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][0]*g21*g20;
    real G6_1_0_5_2_1_1_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][1]*g21*g00;
    real G6_1_0_5_2_1_2_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][2]*g21*g10;
    real G6_1_0_5_2_1_3_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][3]*g21*g20;
    real G6_1_0_5_2_1_4_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g21*g00;
    real G6_1_0_5_2_1_4_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g21*g10;
    real G6_1_0_5_2_1_4_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][4]*g21*g20;
    real G6_1_0_5_2_1_5_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][5]*g21*g00;
    real G6_1_0_5_2_1_6_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][6]*g21*g10;
    real G6_1_0_5_2_1_7_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][7]*g21*g20;
    real G6_1_0_5_2_1_8_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g21*g00;
    real G6_1_0_5_2_1_8_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g21*g10;
    real G6_1_0_5_2_1_8_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][8]*g21*g20;
    real G6_1_0_5_2_1_9_0 = det*c1*c0*w[0][5]*w[0][1]*w[1][9]*g21*g00;
    real G6_1_0_5_2_1_10_1 = det*c1*c0*w[0][5]*w[0][1]*w[1][10]*g21*g10;
    real G6_1_0_5_2_1_11_2 = det*c1*c0*w[0][5]*w[0][1]*w[1][11]*g21*g20;
    real G6_1_0_5_2_2_0_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g21*g00;
    real G6_1_0_5_2_2_0_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g21*g10;
    real G6_1_0_5_2_2_0_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][0]*g21*g20;
    real G6_1_0_5_2_2_1_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][1]*g21*g00;
    real G6_1_0_5_2_2_2_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][2]*g21*g10;
    real G6_1_0_5_2_2_3_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][3]*g21*g20;
    real G6_1_0_5_2_2_4_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g21*g00;
    real G6_1_0_5_2_2_4_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g21*g10;
    real G6_1_0_5_2_2_4_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][4]*g21*g20;
    real G6_1_0_5_2_2_5_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][5]*g21*g00;
    real G6_1_0_5_2_2_6_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][6]*g21*g10;
    real G6_1_0_5_2_2_7_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][7]*g21*g20;
    real G6_1_0_5_2_2_8_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g21*g00;
    real G6_1_0_5_2_2_8_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g21*g10;
    real G6_1_0_5_2_2_8_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][8]*g21*g20;
    real G6_1_0_5_2_2_9_0 = det*c1*c0*w[0][5]*w[0][2]*w[1][9]*g21*g00;
    real G6_1_0_5_2_2_10_1 = det*c1*c0*w[0][5]*w[0][2]*w[1][10]*g21*g10;
    real G6_1_0_5_2_2_11_2 = det*c1*c0*w[0][5]*w[0][2]*w[1][11]*g21*g20;
    real G6_1_0_5_2_3_0_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g21*g00;
    real G6_1_0_5_2_3_0_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g21*g10;
    real G6_1_0_5_2_3_0_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][0]*g21*g20;
    real G6_1_0_5_2_3_1_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][1]*g21*g00;
    real G6_1_0_5_2_3_2_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][2]*g21*g10;
    real G6_1_0_5_2_3_3_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][3]*g21*g20;
    real G6_1_0_5_2_3_4_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g21*g00;
    real G6_1_0_5_2_3_4_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g21*g10;
    real G6_1_0_5_2_3_4_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][4]*g21*g20;
    real G6_1_0_5_2_3_5_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][5]*g21*g00;
    real G6_1_0_5_2_3_6_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][6]*g21*g10;
    real G6_1_0_5_2_3_7_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][7]*g21*g20;
    real G6_1_0_5_2_3_8_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g21*g00;
    real G6_1_0_5_2_3_8_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g21*g10;
    real G6_1_0_5_2_3_8_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][8]*g21*g20;
    real G6_1_0_5_2_3_9_0 = det*c1*c0*w[0][5]*w[0][3]*w[1][9]*g21*g00;
    real G6_1_0_5_2_3_10_1 = det*c1*c0*w[0][5]*w[0][3]*w[1][10]*g21*g10;
    real G6_1_0_5_2_3_11_2 = det*c1*c0*w[0][5]*w[0][3]*w[1][11]*g21*g20;
    real G6_1_0_6_0_0_0_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g01*g00;
    real G6_1_0_6_0_0_0_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g01*g10;
    real G6_1_0_6_0_0_0_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g01*g20;
    real G6_1_0_6_0_0_1_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][1]*g01*g00;
    real G6_1_0_6_0_0_2_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][2]*g01*g10;
    real G6_1_0_6_0_0_3_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][3]*g01*g20;
    real G6_1_0_6_0_0_4_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g01*g00;
    real G6_1_0_6_0_0_4_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g01*g10;
    real G6_1_0_6_0_0_4_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g01*g20;
    real G6_1_0_6_0_0_5_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][5]*g01*g00;
    real G6_1_0_6_0_0_6_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][6]*g01*g10;
    real G6_1_0_6_0_0_7_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][7]*g01*g20;
    real G6_1_0_6_0_0_8_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g01*g00;
    real G6_1_0_6_0_0_8_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g01*g10;
    real G6_1_0_6_0_0_8_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g01*g20;
    real G6_1_0_6_0_0_9_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][9]*g01*g00;
    real G6_1_0_6_0_0_10_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][10]*g01*g10;
    real G6_1_0_6_0_0_11_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][11]*g01*g20;
    real G6_1_0_6_0_1_0_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g01*g00;
    real G6_1_0_6_0_1_0_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g01*g10;
    real G6_1_0_6_0_1_0_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g01*g20;
    real G6_1_0_6_0_1_1_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][1]*g01*g00;
    real G6_1_0_6_0_1_2_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][2]*g01*g10;
    real G6_1_0_6_0_1_3_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][3]*g01*g20;
    real G6_1_0_6_0_1_4_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g01*g00;
    real G6_1_0_6_0_1_4_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g01*g10;
    real G6_1_0_6_0_1_4_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g01*g20;
    real G6_1_0_6_0_1_5_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][5]*g01*g00;
    real G6_1_0_6_0_1_6_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][6]*g01*g10;
    real G6_1_0_6_0_1_7_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][7]*g01*g20;
    real G6_1_0_6_0_1_8_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g01*g00;
    real G6_1_0_6_0_1_8_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g01*g10;
    real G6_1_0_6_0_1_8_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g01*g20;
    real G6_1_0_6_0_1_9_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][9]*g01*g00;
    real G6_1_0_6_0_1_10_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][10]*g01*g10;
    real G6_1_0_6_0_1_11_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][11]*g01*g20;
    real G6_1_0_6_0_2_0_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g01*g00;
    real G6_1_0_6_0_2_0_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g01*g10;
    real G6_1_0_6_0_2_0_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g01*g20;
    real G6_1_0_6_0_2_1_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][1]*g01*g00;
    real G6_1_0_6_0_2_2_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][2]*g01*g10;
    real G6_1_0_6_0_2_3_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][3]*g01*g20;
    real G6_1_0_6_0_2_4_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g01*g00;
    real G6_1_0_6_0_2_4_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g01*g10;
    real G6_1_0_6_0_2_4_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g01*g20;
    real G6_1_0_6_0_2_5_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][5]*g01*g00;
    real G6_1_0_6_0_2_6_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][6]*g01*g10;
    real G6_1_0_6_0_2_7_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][7]*g01*g20;
    real G6_1_0_6_0_2_8_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g01*g00;
    real G6_1_0_6_0_2_8_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g01*g10;
    real G6_1_0_6_0_2_8_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g01*g20;
    real G6_1_0_6_0_2_9_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][9]*g01*g00;
    real G6_1_0_6_0_2_10_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][10]*g01*g10;
    real G6_1_0_6_0_2_11_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][11]*g01*g20;
    real G6_1_0_6_0_3_0_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g01*g00;
    real G6_1_0_6_0_3_0_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g01*g10;
    real G6_1_0_6_0_3_0_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g01*g20;
    real G6_1_0_6_0_3_1_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][1]*g01*g00;
    real G6_1_0_6_0_3_2_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][2]*g01*g10;
    real G6_1_0_6_0_3_3_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][3]*g01*g20;
    real G6_1_0_6_0_3_4_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g01*g00;
    real G6_1_0_6_0_3_4_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g01*g10;
    real G6_1_0_6_0_3_4_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g01*g20;
    real G6_1_0_6_0_3_5_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][5]*g01*g00;
    real G6_1_0_6_0_3_6_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][6]*g01*g10;
    real G6_1_0_6_0_3_7_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][7]*g01*g20;
    real G6_1_0_6_0_3_8_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g01*g00;
    real G6_1_0_6_0_3_8_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g01*g10;
    real G6_1_0_6_0_3_8_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g01*g20;
    real G6_1_0_6_0_3_9_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][9]*g01*g00;
    real G6_1_0_6_0_3_10_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][10]*g01*g10;
    real G6_1_0_6_0_3_11_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][11]*g01*g20;
    real G6_1_0_6_1_0_0_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g11*g00;
    real G6_1_0_6_1_0_0_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g11*g10;
    real G6_1_0_6_1_0_0_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g11*g20;
    real G6_1_0_6_1_0_1_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][1]*g11*g00;
    real G6_1_0_6_1_0_2_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][2]*g11*g10;
    real G6_1_0_6_1_0_3_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][3]*g11*g20;
    real G6_1_0_6_1_0_4_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g11*g00;
    real G6_1_0_6_1_0_4_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g11*g10;
    real G6_1_0_6_1_0_4_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g11*g20;
    real G6_1_0_6_1_0_5_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][5]*g11*g00;
    real G6_1_0_6_1_0_6_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][6]*g11*g10;
    real G6_1_0_6_1_0_7_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][7]*g11*g20;
    real G6_1_0_6_1_0_8_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g11*g00;
    real G6_1_0_6_1_0_8_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g11*g10;
    real G6_1_0_6_1_0_8_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g11*g20;
    real G6_1_0_6_1_0_9_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][9]*g11*g00;
    real G6_1_0_6_1_0_10_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][10]*g11*g10;
    real G6_1_0_6_1_0_11_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][11]*g11*g20;
    real G6_1_0_6_1_1_0_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g11*g00;
    real G6_1_0_6_1_1_0_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g11*g10;
    real G6_1_0_6_1_1_0_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g11*g20;
    real G6_1_0_6_1_1_1_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][1]*g11*g00;
    real G6_1_0_6_1_1_2_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][2]*g11*g10;
    real G6_1_0_6_1_1_3_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][3]*g11*g20;
    real G6_1_0_6_1_1_4_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g11*g00;
    real G6_1_0_6_1_1_4_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g11*g10;
    real G6_1_0_6_1_1_4_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g11*g20;
    real G6_1_0_6_1_1_5_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][5]*g11*g00;
    real G6_1_0_6_1_1_6_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][6]*g11*g10;
    real G6_1_0_6_1_1_7_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][7]*g11*g20;
    real G6_1_0_6_1_1_8_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g11*g00;
    real G6_1_0_6_1_1_8_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g11*g10;
    real G6_1_0_6_1_1_8_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g11*g20;
    real G6_1_0_6_1_1_9_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][9]*g11*g00;
    real G6_1_0_6_1_1_10_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][10]*g11*g10;
    real G6_1_0_6_1_1_11_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][11]*g11*g20;
    real G6_1_0_6_1_2_0_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g11*g00;
    real G6_1_0_6_1_2_0_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g11*g10;
    real G6_1_0_6_1_2_0_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g11*g20;
    real G6_1_0_6_1_2_1_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][1]*g11*g00;
    real G6_1_0_6_1_2_2_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][2]*g11*g10;
    real G6_1_0_6_1_2_3_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][3]*g11*g20;
    real G6_1_0_6_1_2_4_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g11*g00;
    real G6_1_0_6_1_2_4_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g11*g10;
    real G6_1_0_6_1_2_4_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g11*g20;
    real G6_1_0_6_1_2_5_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][5]*g11*g00;
    real G6_1_0_6_1_2_6_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][6]*g11*g10;
    real G6_1_0_6_1_2_7_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][7]*g11*g20;
    real G6_1_0_6_1_2_8_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g11*g00;
    real G6_1_0_6_1_2_8_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g11*g10;
    real G6_1_0_6_1_2_8_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g11*g20;
    real G6_1_0_6_1_2_9_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][9]*g11*g00;
    real G6_1_0_6_1_2_10_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][10]*g11*g10;
    real G6_1_0_6_1_2_11_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][11]*g11*g20;
    real G6_1_0_6_1_3_0_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g11*g00;
    real G6_1_0_6_1_3_0_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g11*g10;
    real G6_1_0_6_1_3_0_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g11*g20;
    real G6_1_0_6_1_3_1_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][1]*g11*g00;
    real G6_1_0_6_1_3_2_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][2]*g11*g10;
    real G6_1_0_6_1_3_3_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][3]*g11*g20;
    real G6_1_0_6_1_3_4_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g11*g00;
    real G6_1_0_6_1_3_4_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g11*g10;
    real G6_1_0_6_1_3_4_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g11*g20;
    real G6_1_0_6_1_3_5_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][5]*g11*g00;
    real G6_1_0_6_1_3_6_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][6]*g11*g10;
    real G6_1_0_6_1_3_7_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][7]*g11*g20;
    real G6_1_0_6_1_3_8_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g11*g00;
    real G6_1_0_6_1_3_8_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g11*g10;
    real G6_1_0_6_1_3_8_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g11*g20;
    real G6_1_0_6_1_3_9_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][9]*g11*g00;
    real G6_1_0_6_1_3_10_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][10]*g11*g10;
    real G6_1_0_6_1_3_11_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][11]*g11*g20;
    real G6_1_0_6_2_0_0_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g21*g00;
    real G6_1_0_6_2_0_0_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g21*g10;
    real G6_1_0_6_2_0_0_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][0]*g21*g20;
    real G6_1_0_6_2_0_1_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][1]*g21*g00;
    real G6_1_0_6_2_0_2_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][2]*g21*g10;
    real G6_1_0_6_2_0_3_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][3]*g21*g20;
    real G6_1_0_6_2_0_4_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g21*g00;
    real G6_1_0_6_2_0_4_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g21*g10;
    real G6_1_0_6_2_0_4_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][4]*g21*g20;
    real G6_1_0_6_2_0_5_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][5]*g21*g00;
    real G6_1_0_6_2_0_6_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][6]*g21*g10;
    real G6_1_0_6_2_0_7_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][7]*g21*g20;
    real G6_1_0_6_2_0_8_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g21*g00;
    real G6_1_0_6_2_0_8_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g21*g10;
    real G6_1_0_6_2_0_8_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][8]*g21*g20;
    real G6_1_0_6_2_0_9_0 = det*c1*c0*w[0][6]*w[0][0]*w[1][9]*g21*g00;
    real G6_1_0_6_2_0_10_1 = det*c1*c0*w[0][6]*w[0][0]*w[1][10]*g21*g10;
    real G6_1_0_6_2_0_11_2 = det*c1*c0*w[0][6]*w[0][0]*w[1][11]*g21*g20;
    real G6_1_0_6_2_1_0_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g21*g00;
    real G6_1_0_6_2_1_0_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g21*g10;
    real G6_1_0_6_2_1_0_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][0]*g21*g20;
    real G6_1_0_6_2_1_1_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][1]*g21*g00;
    real G6_1_0_6_2_1_2_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][2]*g21*g10;
    real G6_1_0_6_2_1_3_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][3]*g21*g20;
    real G6_1_0_6_2_1_4_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g21*g00;
    real G6_1_0_6_2_1_4_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g21*g10;
    real G6_1_0_6_2_1_4_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][4]*g21*g20;
    real G6_1_0_6_2_1_5_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][5]*g21*g00;
    real G6_1_0_6_2_1_6_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][6]*g21*g10;
    real G6_1_0_6_2_1_7_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][7]*g21*g20;
    real G6_1_0_6_2_1_8_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g21*g00;
    real G6_1_0_6_2_1_8_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g21*g10;
    real G6_1_0_6_2_1_8_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][8]*g21*g20;
    real G6_1_0_6_2_1_9_0 = det*c1*c0*w[0][6]*w[0][1]*w[1][9]*g21*g00;
    real G6_1_0_6_2_1_10_1 = det*c1*c0*w[0][6]*w[0][1]*w[1][10]*g21*g10;
    real G6_1_0_6_2_1_11_2 = det*c1*c0*w[0][6]*w[0][1]*w[1][11]*g21*g20;
    real G6_1_0_6_2_2_0_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g21*g00;
    real G6_1_0_6_2_2_0_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g21*g10;
    real G6_1_0_6_2_2_0_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][0]*g21*g20;
    real G6_1_0_6_2_2_1_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][1]*g21*g00;
    real G6_1_0_6_2_2_2_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][2]*g21*g10;
    real G6_1_0_6_2_2_3_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][3]*g21*g20;
    real G6_1_0_6_2_2_4_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g21*g00;
    real G6_1_0_6_2_2_4_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g21*g10;
    real G6_1_0_6_2_2_4_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][4]*g21*g20;
    real G6_1_0_6_2_2_5_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][5]*g21*g00;
    real G6_1_0_6_2_2_6_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][6]*g21*g10;
    real G6_1_0_6_2_2_7_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][7]*g21*g20;
    real G6_1_0_6_2_2_8_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g21*g00;
    real G6_1_0_6_2_2_8_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g21*g10;
    real G6_1_0_6_2_2_8_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][8]*g21*g20;
    real G6_1_0_6_2_2_9_0 = det*c1*c0*w[0][6]*w[0][2]*w[1][9]*g21*g00;
    real G6_1_0_6_2_2_10_1 = det*c1*c0*w[0][6]*w[0][2]*w[1][10]*g21*g10;
    real G6_1_0_6_2_2_11_2 = det*c1*c0*w[0][6]*w[0][2]*w[1][11]*g21*g20;
    real G6_1_0_6_2_3_0_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g21*g00;
    real G6_1_0_6_2_3_0_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g21*g10;
    real G6_1_0_6_2_3_0_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][0]*g21*g20;
    real G6_1_0_6_2_3_1_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][1]*g21*g00;
    real G6_1_0_6_2_3_2_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][2]*g21*g10;
    real G6_1_0_6_2_3_3_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][3]*g21*g20;
    real G6_1_0_6_2_3_4_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g21*g00;
    real G6_1_0_6_2_3_4_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g21*g10;
    real G6_1_0_6_2_3_4_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][4]*g21*g20;
    real G6_1_0_6_2_3_5_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][5]*g21*g00;
    real G6_1_0_6_2_3_6_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][6]*g21*g10;
    real G6_1_0_6_2_3_7_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][7]*g21*g20;
    real G6_1_0_6_2_3_8_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g21*g00;
    real G6_1_0_6_2_3_8_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g21*g10;
    real G6_1_0_6_2_3_8_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][8]*g21*g20;
    real G6_1_0_6_2_3_9_0 = det*c1*c0*w[0][6]*w[0][3]*w[1][9]*g21*g00;
    real G6_1_0_6_2_3_10_1 = det*c1*c0*w[0][6]*w[0][3]*w[1][10]*g21*g10;
    real G6_1_0_6_2_3_11_2 = det*c1*c0*w[0][6]*w[0][3]*w[1][11]*g21*g20;
    real G6_1_0_7_0_0_0_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g01*g00;
    real G6_1_0_7_0_0_0_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g01*g10;
    real G6_1_0_7_0_0_0_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g01*g20;
    real G6_1_0_7_0_0_1_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][1]*g01*g00;
    real G6_1_0_7_0_0_2_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][2]*g01*g10;
    real G6_1_0_7_0_0_3_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][3]*g01*g20;
    real G6_1_0_7_0_0_4_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g01*g00;
    real G6_1_0_7_0_0_4_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g01*g10;
    real G6_1_0_7_0_0_4_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g01*g20;
    real G6_1_0_7_0_0_5_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][5]*g01*g00;
    real G6_1_0_7_0_0_6_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][6]*g01*g10;
    real G6_1_0_7_0_0_7_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][7]*g01*g20;
    real G6_1_0_7_0_0_8_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g01*g00;
    real G6_1_0_7_0_0_8_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g01*g10;
    real G6_1_0_7_0_0_8_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g01*g20;
    real G6_1_0_7_0_0_9_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][9]*g01*g00;
    real G6_1_0_7_0_0_10_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][10]*g01*g10;
    real G6_1_0_7_0_0_11_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][11]*g01*g20;
    real G6_1_0_7_0_1_0_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g01*g00;
    real G6_1_0_7_0_1_0_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g01*g10;
    real G6_1_0_7_0_1_0_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g01*g20;
    real G6_1_0_7_0_1_1_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][1]*g01*g00;
    real G6_1_0_7_0_1_2_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][2]*g01*g10;
    real G6_1_0_7_0_1_3_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][3]*g01*g20;
    real G6_1_0_7_0_1_4_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g01*g00;
    real G6_1_0_7_0_1_4_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g01*g10;
    real G6_1_0_7_0_1_4_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g01*g20;
    real G6_1_0_7_0_1_5_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][5]*g01*g00;
    real G6_1_0_7_0_1_6_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][6]*g01*g10;
    real G6_1_0_7_0_1_7_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][7]*g01*g20;
    real G6_1_0_7_0_1_8_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g01*g00;
    real G6_1_0_7_0_1_8_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g01*g10;
    real G6_1_0_7_0_1_8_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g01*g20;
    real G6_1_0_7_0_1_9_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][9]*g01*g00;
    real G6_1_0_7_0_1_10_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][10]*g01*g10;
    real G6_1_0_7_0_1_11_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][11]*g01*g20;
    real G6_1_0_7_0_2_0_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g01*g00;
    real G6_1_0_7_0_2_0_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g01*g10;
    real G6_1_0_7_0_2_0_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g01*g20;
    real G6_1_0_7_0_2_1_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][1]*g01*g00;
    real G6_1_0_7_0_2_2_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][2]*g01*g10;
    real G6_1_0_7_0_2_3_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][3]*g01*g20;
    real G6_1_0_7_0_2_4_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g01*g00;
    real G6_1_0_7_0_2_4_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g01*g10;
    real G6_1_0_7_0_2_4_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g01*g20;
    real G6_1_0_7_0_2_5_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][5]*g01*g00;
    real G6_1_0_7_0_2_6_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][6]*g01*g10;
    real G6_1_0_7_0_2_7_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][7]*g01*g20;
    real G6_1_0_7_0_2_8_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g01*g00;
    real G6_1_0_7_0_2_8_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g01*g10;
    real G6_1_0_7_0_2_8_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g01*g20;
    real G6_1_0_7_0_2_9_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][9]*g01*g00;
    real G6_1_0_7_0_2_10_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][10]*g01*g10;
    real G6_1_0_7_0_2_11_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][11]*g01*g20;
    real G6_1_0_7_0_3_0_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g01*g00;
    real G6_1_0_7_0_3_0_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g01*g10;
    real G6_1_0_7_0_3_0_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g01*g20;
    real G6_1_0_7_0_3_1_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][1]*g01*g00;
    real G6_1_0_7_0_3_2_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][2]*g01*g10;
    real G6_1_0_7_0_3_3_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][3]*g01*g20;
    real G6_1_0_7_0_3_4_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g01*g00;
    real G6_1_0_7_0_3_4_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g01*g10;
    real G6_1_0_7_0_3_4_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g01*g20;
    real G6_1_0_7_0_3_5_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][5]*g01*g00;
    real G6_1_0_7_0_3_6_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][6]*g01*g10;
    real G6_1_0_7_0_3_7_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][7]*g01*g20;
    real G6_1_0_7_0_3_8_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g01*g00;
    real G6_1_0_7_0_3_8_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g01*g10;
    real G6_1_0_7_0_3_8_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g01*g20;
    real G6_1_0_7_0_3_9_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][9]*g01*g00;
    real G6_1_0_7_0_3_10_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][10]*g01*g10;
    real G6_1_0_7_0_3_11_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][11]*g01*g20;
    real G6_1_0_7_1_0_0_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g11*g00;
    real G6_1_0_7_1_0_0_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g11*g10;
    real G6_1_0_7_1_0_0_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g11*g20;
    real G6_1_0_7_1_0_1_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][1]*g11*g00;
    real G6_1_0_7_1_0_2_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][2]*g11*g10;
    real G6_1_0_7_1_0_3_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][3]*g11*g20;
    real G6_1_0_7_1_0_4_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g11*g00;
    real G6_1_0_7_1_0_4_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g11*g10;
    real G6_1_0_7_1_0_4_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g11*g20;
    real G6_1_0_7_1_0_5_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][5]*g11*g00;
    real G6_1_0_7_1_0_6_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][6]*g11*g10;
    real G6_1_0_7_1_0_7_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][7]*g11*g20;
    real G6_1_0_7_1_0_8_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g11*g00;
    real G6_1_0_7_1_0_8_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g11*g10;
    real G6_1_0_7_1_0_8_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g11*g20;
    real G6_1_0_7_1_0_9_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][9]*g11*g00;
    real G6_1_0_7_1_0_10_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][10]*g11*g10;
    real G6_1_0_7_1_0_11_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][11]*g11*g20;
    real G6_1_0_7_1_1_0_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g11*g00;
    real G6_1_0_7_1_1_0_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g11*g10;
    real G6_1_0_7_1_1_0_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g11*g20;
    real G6_1_0_7_1_1_1_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][1]*g11*g00;
    real G6_1_0_7_1_1_2_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][2]*g11*g10;
    real G6_1_0_7_1_1_3_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][3]*g11*g20;
    real G6_1_0_7_1_1_4_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g11*g00;
    real G6_1_0_7_1_1_4_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g11*g10;
    real G6_1_0_7_1_1_4_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g11*g20;
    real G6_1_0_7_1_1_5_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][5]*g11*g00;
    real G6_1_0_7_1_1_6_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][6]*g11*g10;
    real G6_1_0_7_1_1_7_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][7]*g11*g20;
    real G6_1_0_7_1_1_8_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g11*g00;
    real G6_1_0_7_1_1_8_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g11*g10;
    real G6_1_0_7_1_1_8_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g11*g20;
    real G6_1_0_7_1_1_9_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][9]*g11*g00;
    real G6_1_0_7_1_1_10_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][10]*g11*g10;
    real G6_1_0_7_1_1_11_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][11]*g11*g20;
    real G6_1_0_7_1_2_0_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g11*g00;
    real G6_1_0_7_1_2_0_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g11*g10;
    real G6_1_0_7_1_2_0_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g11*g20;
    real G6_1_0_7_1_2_1_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][1]*g11*g00;
    real G6_1_0_7_1_2_2_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][2]*g11*g10;
    real G6_1_0_7_1_2_3_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][3]*g11*g20;
    real G6_1_0_7_1_2_4_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g11*g00;
    real G6_1_0_7_1_2_4_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g11*g10;
    real G6_1_0_7_1_2_4_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g11*g20;
    real G6_1_0_7_1_2_5_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][5]*g11*g00;
    real G6_1_0_7_1_2_6_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][6]*g11*g10;
    real G6_1_0_7_1_2_7_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][7]*g11*g20;
    real G6_1_0_7_1_2_8_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g11*g00;
    real G6_1_0_7_1_2_8_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g11*g10;
    real G6_1_0_7_1_2_8_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g11*g20;
    real G6_1_0_7_1_2_9_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][9]*g11*g00;
    real G6_1_0_7_1_2_10_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][10]*g11*g10;
    real G6_1_0_7_1_2_11_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][11]*g11*g20;
    real G6_1_0_7_1_3_0_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g11*g00;
    real G6_1_0_7_1_3_0_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g11*g10;
    real G6_1_0_7_1_3_0_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g11*g20;
    real G6_1_0_7_1_3_1_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][1]*g11*g00;
    real G6_1_0_7_1_3_2_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][2]*g11*g10;
    real G6_1_0_7_1_3_3_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][3]*g11*g20;
    real G6_1_0_7_1_3_4_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g11*g00;
    real G6_1_0_7_1_3_4_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g11*g10;
    real G6_1_0_7_1_3_4_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g11*g20;
    real G6_1_0_7_1_3_5_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][5]*g11*g00;
    real G6_1_0_7_1_3_6_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][6]*g11*g10;
    real G6_1_0_7_1_3_7_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][7]*g11*g20;
    real G6_1_0_7_1_3_8_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g11*g00;
    real G6_1_0_7_1_3_8_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g11*g10;
    real G6_1_0_7_1_3_8_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g11*g20;
    real G6_1_0_7_1_3_9_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][9]*g11*g00;
    real G6_1_0_7_1_3_10_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][10]*g11*g10;
    real G6_1_0_7_1_3_11_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][11]*g11*g20;
    real G6_1_0_7_2_0_0_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g21*g00;
    real G6_1_0_7_2_0_0_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g21*g10;
    real G6_1_0_7_2_0_0_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][0]*g21*g20;
    real G6_1_0_7_2_0_1_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][1]*g21*g00;
    real G6_1_0_7_2_0_2_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][2]*g21*g10;
    real G6_1_0_7_2_0_3_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][3]*g21*g20;
    real G6_1_0_7_2_0_4_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g21*g00;
    real G6_1_0_7_2_0_4_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g21*g10;
    real G6_1_0_7_2_0_4_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][4]*g21*g20;
    real G6_1_0_7_2_0_5_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][5]*g21*g00;
    real G6_1_0_7_2_0_6_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][6]*g21*g10;
    real G6_1_0_7_2_0_7_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][7]*g21*g20;
    real G6_1_0_7_2_0_8_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g21*g00;
    real G6_1_0_7_2_0_8_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g21*g10;
    real G6_1_0_7_2_0_8_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][8]*g21*g20;
    real G6_1_0_7_2_0_9_0 = det*c1*c0*w[0][7]*w[0][0]*w[1][9]*g21*g00;
    real G6_1_0_7_2_0_10_1 = det*c1*c0*w[0][7]*w[0][0]*w[1][10]*g21*g10;
    real G6_1_0_7_2_0_11_2 = det*c1*c0*w[0][7]*w[0][0]*w[1][11]*g21*g20;
    real G6_1_0_7_2_1_0_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g21*g00;
    real G6_1_0_7_2_1_0_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g21*g10;
    real G6_1_0_7_2_1_0_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][0]*g21*g20;
    real G6_1_0_7_2_1_1_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][1]*g21*g00;
    real G6_1_0_7_2_1_2_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][2]*g21*g10;
    real G6_1_0_7_2_1_3_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][3]*g21*g20;
    real G6_1_0_7_2_1_4_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g21*g00;
    real G6_1_0_7_2_1_4_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g21*g10;
    real G6_1_0_7_2_1_4_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][4]*g21*g20;
    real G6_1_0_7_2_1_5_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][5]*g21*g00;
    real G6_1_0_7_2_1_6_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][6]*g21*g10;
    real G6_1_0_7_2_1_7_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][7]*g21*g20;
    real G6_1_0_7_2_1_8_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g21*g00;
    real G6_1_0_7_2_1_8_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g21*g10;
    real G6_1_0_7_2_1_8_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][8]*g21*g20;
    real G6_1_0_7_2_1_9_0 = det*c1*c0*w[0][7]*w[0][1]*w[1][9]*g21*g00;
    real G6_1_0_7_2_1_10_1 = det*c1*c0*w[0][7]*w[0][1]*w[1][10]*g21*g10;
    real G6_1_0_7_2_1_11_2 = det*c1*c0*w[0][7]*w[0][1]*w[1][11]*g21*g20;
    real G6_1_0_7_2_2_0_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g21*g00;
    real G6_1_0_7_2_2_0_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g21*g10;
    real G6_1_0_7_2_2_0_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][0]*g21*g20;
    real G6_1_0_7_2_2_1_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][1]*g21*g00;
    real G6_1_0_7_2_2_2_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][2]*g21*g10;
    real G6_1_0_7_2_2_3_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][3]*g21*g20;
    real G6_1_0_7_2_2_4_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g21*g00;
    real G6_1_0_7_2_2_4_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g21*g10;
    real G6_1_0_7_2_2_4_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][4]*g21*g20;
    real G6_1_0_7_2_2_5_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][5]*g21*g00;
    real G6_1_0_7_2_2_6_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][6]*g21*g10;
    real G6_1_0_7_2_2_7_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][7]*g21*g20;
    real G6_1_0_7_2_2_8_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g21*g00;
    real G6_1_0_7_2_2_8_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g21*g10;
    real G6_1_0_7_2_2_8_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][8]*g21*g20;
    real G6_1_0_7_2_2_9_0 = det*c1*c0*w[0][7]*w[0][2]*w[1][9]*g21*g00;
    real G6_1_0_7_2_2_10_1 = det*c1*c0*w[0][7]*w[0][2]*w[1][10]*g21*g10;
    real G6_1_0_7_2_2_11_2 = det*c1*c0*w[0][7]*w[0][2]*w[1][11]*g21*g20;
    real G6_1_0_7_2_3_0_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g21*g00;
    real G6_1_0_7_2_3_0_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g21*g10;
    real G6_1_0_7_2_3_0_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][0]*g21*g20;
    real G6_1_0_7_2_3_1_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][1]*g21*g00;
    real G6_1_0_7_2_3_2_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][2]*g21*g10;
    real G6_1_0_7_2_3_3_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][3]*g21*g20;
    real G6_1_0_7_2_3_4_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g21*g00;
    real G6_1_0_7_2_3_4_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g21*g10;
    real G6_1_0_7_2_3_4_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][4]*g21*g20;
    real G6_1_0_7_2_3_5_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][5]*g21*g00;
    real G6_1_0_7_2_3_6_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][6]*g21*g10;
    real G6_1_0_7_2_3_7_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][7]*g21*g20;
    real G6_1_0_7_2_3_8_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g21*g00;
    real G6_1_0_7_2_3_8_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g21*g10;
    real G6_1_0_7_2_3_8_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][8]*g21*g20;
    real G6_1_0_7_2_3_9_0 = det*c1*c0*w[0][7]*w[0][3]*w[1][9]*g21*g00;
    real G6_1_0_7_2_3_10_1 = det*c1*c0*w[0][7]*w[0][3]*w[1][10]*g21*g10;
    real G6_1_0_7_2_3_11_2 = det*c1*c0*w[0][7]*w[0][3]*w[1][11]*g21*g20;
    real G6_1_1_4_0_4_0_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g01*g01;
    real G6_1_1_4_0_4_0_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g01*g11;
    real G6_1_1_4_0_4_0_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g01*g21;
    real G6_1_1_4_0_4_1_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][1]*g01*g01;
    real G6_1_1_4_0_4_2_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][2]*g01*g11;
    real G6_1_1_4_0_4_3_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][3]*g01*g21;
    real G6_1_1_4_0_4_4_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g01*g01;
    real G6_1_1_4_0_4_4_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g01*g11;
    real G6_1_1_4_0_4_4_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g01*g21;
    real G6_1_1_4_0_4_5_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][5]*g01*g01;
    real G6_1_1_4_0_4_6_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][6]*g01*g11;
    real G6_1_1_4_0_4_7_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][7]*g01*g21;
    real G6_1_1_4_0_4_8_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g01*g01;
    real G6_1_1_4_0_4_8_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g01*g11;
    real G6_1_1_4_0_4_8_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g01*g21;
    real G6_1_1_4_0_4_9_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][9]*g01*g01;
    real G6_1_1_4_0_4_10_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][10]*g01*g11;
    real G6_1_1_4_0_4_11_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][11]*g01*g21;
    real G6_1_1_4_0_5_0_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g01*g01;
    real G6_1_1_4_0_5_0_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g01*g11;
    real G6_1_1_4_0_5_0_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g01*g21;
    real G6_1_1_4_0_5_1_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][1]*g01*g01;
    real G6_1_1_4_0_5_2_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][2]*g01*g11;
    real G6_1_1_4_0_5_3_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][3]*g01*g21;
    real G6_1_1_4_0_5_4_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g01*g01;
    real G6_1_1_4_0_5_4_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g01*g11;
    real G6_1_1_4_0_5_4_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g01*g21;
    real G6_1_1_4_0_5_5_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][5]*g01*g01;
    real G6_1_1_4_0_5_6_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][6]*g01*g11;
    real G6_1_1_4_0_5_7_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][7]*g01*g21;
    real G6_1_1_4_0_5_8_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g01*g01;
    real G6_1_1_4_0_5_8_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g01*g11;
    real G6_1_1_4_0_5_8_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g01*g21;
    real G6_1_1_4_0_5_9_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][9]*g01*g01;
    real G6_1_1_4_0_5_10_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][10]*g01*g11;
    real G6_1_1_4_0_5_11_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][11]*g01*g21;
    real G6_1_1_4_0_6_0_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g01*g01;
    real G6_1_1_4_0_6_0_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g01*g11;
    real G6_1_1_4_0_6_0_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g01*g21;
    real G6_1_1_4_0_6_1_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][1]*g01*g01;
    real G6_1_1_4_0_6_2_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][2]*g01*g11;
    real G6_1_1_4_0_6_3_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][3]*g01*g21;
    real G6_1_1_4_0_6_4_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g01*g01;
    real G6_1_1_4_0_6_4_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g01*g11;
    real G6_1_1_4_0_6_4_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g01*g21;
    real G6_1_1_4_0_6_5_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][5]*g01*g01;
    real G6_1_1_4_0_6_6_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][6]*g01*g11;
    real G6_1_1_4_0_6_7_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][7]*g01*g21;
    real G6_1_1_4_0_6_8_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g01*g01;
    real G6_1_1_4_0_6_8_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g01*g11;
    real G6_1_1_4_0_6_8_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g01*g21;
    real G6_1_1_4_0_6_9_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][9]*g01*g01;
    real G6_1_1_4_0_6_10_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][10]*g01*g11;
    real G6_1_1_4_0_6_11_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][11]*g01*g21;
    real G6_1_1_4_0_7_0_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g01*g01;
    real G6_1_1_4_0_7_0_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g01*g11;
    real G6_1_1_4_0_7_0_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g01*g21;
    real G6_1_1_4_0_7_1_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][1]*g01*g01;
    real G6_1_1_4_0_7_2_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][2]*g01*g11;
    real G6_1_1_4_0_7_3_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][3]*g01*g21;
    real G6_1_1_4_0_7_4_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g01*g01;
    real G6_1_1_4_0_7_4_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g01*g11;
    real G6_1_1_4_0_7_4_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g01*g21;
    real G6_1_1_4_0_7_5_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][5]*g01*g01;
    real G6_1_1_4_0_7_6_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][6]*g01*g11;
    real G6_1_1_4_0_7_7_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][7]*g01*g21;
    real G6_1_1_4_0_7_8_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g01*g01;
    real G6_1_1_4_0_7_8_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g01*g11;
    real G6_1_1_4_0_7_8_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g01*g21;
    real G6_1_1_4_0_7_9_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][9]*g01*g01;
    real G6_1_1_4_0_7_10_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][10]*g01*g11;
    real G6_1_1_4_0_7_11_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][11]*g01*g21;
    real G6_1_1_4_1_4_0_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g11*g01;
    real G6_1_1_4_1_4_0_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g11*g11;
    real G6_1_1_4_1_4_0_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g11*g21;
    real G6_1_1_4_1_4_1_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][1]*g11*g01;
    real G6_1_1_4_1_4_2_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][2]*g11*g11;
    real G6_1_1_4_1_4_3_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][3]*g11*g21;
    real G6_1_1_4_1_4_4_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g11*g01;
    real G6_1_1_4_1_4_4_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g11*g11;
    real G6_1_1_4_1_4_4_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g11*g21;
    real G6_1_1_4_1_4_5_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][5]*g11*g01;
    real G6_1_1_4_1_4_6_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][6]*g11*g11;
    real G6_1_1_4_1_4_7_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][7]*g11*g21;
    real G6_1_1_4_1_4_8_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g11*g01;
    real G6_1_1_4_1_4_8_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g11*g11;
    real G6_1_1_4_1_4_8_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g11*g21;
    real G6_1_1_4_1_4_9_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][9]*g11*g01;
    real G6_1_1_4_1_4_10_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][10]*g11*g11;
    real G6_1_1_4_1_4_11_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][11]*g11*g21;
    real G6_1_1_4_1_5_0_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g11*g01;
    real G6_1_1_4_1_5_0_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g11*g11;
    real G6_1_1_4_1_5_0_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g11*g21;
    real G6_1_1_4_1_5_1_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][1]*g11*g01;
    real G6_1_1_4_1_5_2_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][2]*g11*g11;
    real G6_1_1_4_1_5_3_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][3]*g11*g21;
    real G6_1_1_4_1_5_4_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g11*g01;
    real G6_1_1_4_1_5_4_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g11*g11;
    real G6_1_1_4_1_5_4_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g11*g21;
    real G6_1_1_4_1_5_5_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][5]*g11*g01;
    real G6_1_1_4_1_5_6_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][6]*g11*g11;
    real G6_1_1_4_1_5_7_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][7]*g11*g21;
    real G6_1_1_4_1_5_8_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g11*g01;
    real G6_1_1_4_1_5_8_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g11*g11;
    real G6_1_1_4_1_5_8_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g11*g21;
    real G6_1_1_4_1_5_9_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][9]*g11*g01;
    real G6_1_1_4_1_5_10_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][10]*g11*g11;
    real G6_1_1_4_1_5_11_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][11]*g11*g21;
    real G6_1_1_4_1_6_0_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g11*g01;
    real G6_1_1_4_1_6_0_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g11*g11;
    real G6_1_1_4_1_6_0_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g11*g21;
    real G6_1_1_4_1_6_1_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][1]*g11*g01;
    real G6_1_1_4_1_6_2_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][2]*g11*g11;
    real G6_1_1_4_1_6_3_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][3]*g11*g21;
    real G6_1_1_4_1_6_4_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g11*g01;
    real G6_1_1_4_1_6_4_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g11*g11;
    real G6_1_1_4_1_6_4_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g11*g21;
    real G6_1_1_4_1_6_5_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][5]*g11*g01;
    real G6_1_1_4_1_6_6_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][6]*g11*g11;
    real G6_1_1_4_1_6_7_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][7]*g11*g21;
    real G6_1_1_4_1_6_8_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g11*g01;
    real G6_1_1_4_1_6_8_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g11*g11;
    real G6_1_1_4_1_6_8_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g11*g21;
    real G6_1_1_4_1_6_9_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][9]*g11*g01;
    real G6_1_1_4_1_6_10_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][10]*g11*g11;
    real G6_1_1_4_1_6_11_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][11]*g11*g21;
    real G6_1_1_4_1_7_0_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g11*g01;
    real G6_1_1_4_1_7_0_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g11*g11;
    real G6_1_1_4_1_7_0_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g11*g21;
    real G6_1_1_4_1_7_1_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][1]*g11*g01;
    real G6_1_1_4_1_7_2_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][2]*g11*g11;
    real G6_1_1_4_1_7_3_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][3]*g11*g21;
    real G6_1_1_4_1_7_4_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g11*g01;
    real G6_1_1_4_1_7_4_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g11*g11;
    real G6_1_1_4_1_7_4_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g11*g21;
    real G6_1_1_4_1_7_5_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][5]*g11*g01;
    real G6_1_1_4_1_7_6_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][6]*g11*g11;
    real G6_1_1_4_1_7_7_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][7]*g11*g21;
    real G6_1_1_4_1_7_8_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g11*g01;
    real G6_1_1_4_1_7_8_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g11*g11;
    real G6_1_1_4_1_7_8_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g11*g21;
    real G6_1_1_4_1_7_9_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][9]*g11*g01;
    real G6_1_1_4_1_7_10_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][10]*g11*g11;
    real G6_1_1_4_1_7_11_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][11]*g11*g21;
    real G6_1_1_4_2_4_0_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g21*g01;
    real G6_1_1_4_2_4_0_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g21*g11;
    real G6_1_1_4_2_4_0_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][0]*g21*g21;
    real G6_1_1_4_2_4_1_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][1]*g21*g01;
    real G6_1_1_4_2_4_2_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][2]*g21*g11;
    real G6_1_1_4_2_4_3_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][3]*g21*g21;
    real G6_1_1_4_2_4_4_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g21*g01;
    real G6_1_1_4_2_4_4_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g21*g11;
    real G6_1_1_4_2_4_4_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][4]*g21*g21;
    real G6_1_1_4_2_4_5_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][5]*g21*g01;
    real G6_1_1_4_2_4_6_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][6]*g21*g11;
    real G6_1_1_4_2_4_7_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][7]*g21*g21;
    real G6_1_1_4_2_4_8_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g21*g01;
    real G6_1_1_4_2_4_8_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g21*g11;
    real G6_1_1_4_2_4_8_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][8]*g21*g21;
    real G6_1_1_4_2_4_9_0 = det*c1*c0*w[0][4]*w[0][4]*w[1][9]*g21*g01;
    real G6_1_1_4_2_4_10_1 = det*c1*c0*w[0][4]*w[0][4]*w[1][10]*g21*g11;
    real G6_1_1_4_2_4_11_2 = det*c1*c0*w[0][4]*w[0][4]*w[1][11]*g21*g21;
    real G6_1_1_4_2_5_0_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g21*g01;
    real G6_1_1_4_2_5_0_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g21*g11;
    real G6_1_1_4_2_5_0_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][0]*g21*g21;
    real G6_1_1_4_2_5_1_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][1]*g21*g01;
    real G6_1_1_4_2_5_2_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][2]*g21*g11;
    real G6_1_1_4_2_5_3_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][3]*g21*g21;
    real G6_1_1_4_2_5_4_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g21*g01;
    real G6_1_1_4_2_5_4_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g21*g11;
    real G6_1_1_4_2_5_4_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][4]*g21*g21;
    real G6_1_1_4_2_5_5_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][5]*g21*g01;
    real G6_1_1_4_2_5_6_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][6]*g21*g11;
    real G6_1_1_4_2_5_7_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][7]*g21*g21;
    real G6_1_1_4_2_5_8_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g21*g01;
    real G6_1_1_4_2_5_8_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g21*g11;
    real G6_1_1_4_2_5_8_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][8]*g21*g21;
    real G6_1_1_4_2_5_9_0 = det*c1*c0*w[0][4]*w[0][5]*w[1][9]*g21*g01;
    real G6_1_1_4_2_5_10_1 = det*c1*c0*w[0][4]*w[0][5]*w[1][10]*g21*g11;
    real G6_1_1_4_2_5_11_2 = det*c1*c0*w[0][4]*w[0][5]*w[1][11]*g21*g21;
    real G6_1_1_4_2_6_0_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g21*g01;
    real G6_1_1_4_2_6_0_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g21*g11;
    real G6_1_1_4_2_6_0_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][0]*g21*g21;
    real G6_1_1_4_2_6_1_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][1]*g21*g01;
    real G6_1_1_4_2_6_2_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][2]*g21*g11;
    real G6_1_1_4_2_6_3_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][3]*g21*g21;
    real G6_1_1_4_2_6_4_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g21*g01;
    real G6_1_1_4_2_6_4_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g21*g11;
    real G6_1_1_4_2_6_4_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][4]*g21*g21;
    real G6_1_1_4_2_6_5_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][5]*g21*g01;
    real G6_1_1_4_2_6_6_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][6]*g21*g11;
    real G6_1_1_4_2_6_7_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][7]*g21*g21;
    real G6_1_1_4_2_6_8_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g21*g01;
    real G6_1_1_4_2_6_8_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g21*g11;
    real G6_1_1_4_2_6_8_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][8]*g21*g21;
    real G6_1_1_4_2_6_9_0 = det*c1*c0*w[0][4]*w[0][6]*w[1][9]*g21*g01;
    real G6_1_1_4_2_6_10_1 = det*c1*c0*w[0][4]*w[0][6]*w[1][10]*g21*g11;
    real G6_1_1_4_2_6_11_2 = det*c1*c0*w[0][4]*w[0][6]*w[1][11]*g21*g21;
    real G6_1_1_4_2_7_0_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g21*g01;
    real G6_1_1_4_2_7_0_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g21*g11;
    real G6_1_1_4_2_7_0_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][0]*g21*g21;
    real G6_1_1_4_2_7_1_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][1]*g21*g01;
    real G6_1_1_4_2_7_2_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][2]*g21*g11;
    real G6_1_1_4_2_7_3_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][3]*g21*g21;
    real G6_1_1_4_2_7_4_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g21*g01;
    real G6_1_1_4_2_7_4_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g21*g11;
    real G6_1_1_4_2_7_4_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][4]*g21*g21;
    real G6_1_1_4_2_7_5_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][5]*g21*g01;
    real G6_1_1_4_2_7_6_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][6]*g21*g11;
    real G6_1_1_4_2_7_7_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][7]*g21*g21;
    real G6_1_1_4_2_7_8_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g21*g01;
    real G6_1_1_4_2_7_8_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g21*g11;
    real G6_1_1_4_2_7_8_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][8]*g21*g21;
    real G6_1_1_4_2_7_9_0 = det*c1*c0*w[0][4]*w[0][7]*w[1][9]*g21*g01;
    real G6_1_1_4_2_7_10_1 = det*c1*c0*w[0][4]*w[0][7]*w[1][10]*g21*g11;
    real G6_1_1_4_2_7_11_2 = det*c1*c0*w[0][4]*w[0][7]*w[1][11]*g21*g21;
    real G6_1_1_5_0_4_0_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g01*g01;
    real G6_1_1_5_0_4_0_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g01*g11;
    real G6_1_1_5_0_4_0_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g01*g21;
    real G6_1_1_5_0_4_1_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][1]*g01*g01;
    real G6_1_1_5_0_4_2_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][2]*g01*g11;
    real G6_1_1_5_0_4_3_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][3]*g01*g21;
    real G6_1_1_5_0_4_4_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g01*g01;
    real G6_1_1_5_0_4_4_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g01*g11;
    real G6_1_1_5_0_4_4_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g01*g21;
    real G6_1_1_5_0_4_5_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][5]*g01*g01;
    real G6_1_1_5_0_4_6_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][6]*g01*g11;
    real G6_1_1_5_0_4_7_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][7]*g01*g21;
    real G6_1_1_5_0_4_8_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g01*g01;
    real G6_1_1_5_0_4_8_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g01*g11;
    real G6_1_1_5_0_4_8_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g01*g21;
    real G6_1_1_5_0_4_9_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][9]*g01*g01;
    real G6_1_1_5_0_4_10_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][10]*g01*g11;
    real G6_1_1_5_0_4_11_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][11]*g01*g21;
    real G6_1_1_5_0_5_0_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g01*g01;
    real G6_1_1_5_0_5_0_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g01*g11;
    real G6_1_1_5_0_5_0_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g01*g21;
    real G6_1_1_5_0_5_1_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][1]*g01*g01;
    real G6_1_1_5_0_5_2_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][2]*g01*g11;
    real G6_1_1_5_0_5_3_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][3]*g01*g21;
    real G6_1_1_5_0_5_4_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g01*g01;
    real G6_1_1_5_0_5_4_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g01*g11;
    real G6_1_1_5_0_5_4_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g01*g21;
    real G6_1_1_5_0_5_5_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][5]*g01*g01;
    real G6_1_1_5_0_5_6_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][6]*g01*g11;
    real G6_1_1_5_0_5_7_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][7]*g01*g21;
    real G6_1_1_5_0_5_8_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g01*g01;
    real G6_1_1_5_0_5_8_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g01*g11;
    real G6_1_1_5_0_5_8_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g01*g21;
    real G6_1_1_5_0_5_9_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][9]*g01*g01;
    real G6_1_1_5_0_5_10_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][10]*g01*g11;
    real G6_1_1_5_0_5_11_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][11]*g01*g21;
    real G6_1_1_5_0_6_0_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g01*g01;
    real G6_1_1_5_0_6_0_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g01*g11;
    real G6_1_1_5_0_6_0_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g01*g21;
    real G6_1_1_5_0_6_1_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][1]*g01*g01;
    real G6_1_1_5_0_6_2_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][2]*g01*g11;
    real G6_1_1_5_0_6_3_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][3]*g01*g21;
    real G6_1_1_5_0_6_4_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g01*g01;
    real G6_1_1_5_0_6_4_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g01*g11;
    real G6_1_1_5_0_6_4_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g01*g21;
    real G6_1_1_5_0_6_5_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][5]*g01*g01;
    real G6_1_1_5_0_6_6_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][6]*g01*g11;
    real G6_1_1_5_0_6_7_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][7]*g01*g21;
    real G6_1_1_5_0_6_8_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g01*g01;
    real G6_1_1_5_0_6_8_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g01*g11;
    real G6_1_1_5_0_6_8_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g01*g21;
    real G6_1_1_5_0_6_9_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][9]*g01*g01;
    real G6_1_1_5_0_6_10_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][10]*g01*g11;
    real G6_1_1_5_0_6_11_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][11]*g01*g21;
    real G6_1_1_5_0_7_0_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g01*g01;
    real G6_1_1_5_0_7_0_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g01*g11;
    real G6_1_1_5_0_7_0_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g01*g21;
    real G6_1_1_5_0_7_1_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][1]*g01*g01;
    real G6_1_1_5_0_7_2_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][2]*g01*g11;
    real G6_1_1_5_0_7_3_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][3]*g01*g21;
    real G6_1_1_5_0_7_4_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g01*g01;
    real G6_1_1_5_0_7_4_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g01*g11;
    real G6_1_1_5_0_7_4_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g01*g21;
    real G6_1_1_5_0_7_5_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][5]*g01*g01;
    real G6_1_1_5_0_7_6_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][6]*g01*g11;
    real G6_1_1_5_0_7_7_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][7]*g01*g21;
    real G6_1_1_5_0_7_8_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g01*g01;
    real G6_1_1_5_0_7_8_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g01*g11;
    real G6_1_1_5_0_7_8_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g01*g21;
    real G6_1_1_5_0_7_9_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][9]*g01*g01;
    real G6_1_1_5_0_7_10_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][10]*g01*g11;
    real G6_1_1_5_0_7_11_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][11]*g01*g21;
    real G6_1_1_5_1_4_0_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g11*g01;
    real G6_1_1_5_1_4_0_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g11*g11;
    real G6_1_1_5_1_4_0_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g11*g21;
    real G6_1_1_5_1_4_1_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][1]*g11*g01;
    real G6_1_1_5_1_4_2_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][2]*g11*g11;
    real G6_1_1_5_1_4_3_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][3]*g11*g21;
    real G6_1_1_5_1_4_4_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g11*g01;
    real G6_1_1_5_1_4_4_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g11*g11;
    real G6_1_1_5_1_4_4_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g11*g21;
    real G6_1_1_5_1_4_5_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][5]*g11*g01;
    real G6_1_1_5_1_4_6_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][6]*g11*g11;
    real G6_1_1_5_1_4_7_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][7]*g11*g21;
    real G6_1_1_5_1_4_8_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g11*g01;
    real G6_1_1_5_1_4_8_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g11*g11;
    real G6_1_1_5_1_4_8_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g11*g21;
    real G6_1_1_5_1_4_9_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][9]*g11*g01;
    real G6_1_1_5_1_4_10_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][10]*g11*g11;
    real G6_1_1_5_1_4_11_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][11]*g11*g21;
    real G6_1_1_5_1_5_0_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g11*g01;
    real G6_1_1_5_1_5_0_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g11*g11;
    real G6_1_1_5_1_5_0_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g11*g21;
    real G6_1_1_5_1_5_1_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][1]*g11*g01;
    real G6_1_1_5_1_5_2_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][2]*g11*g11;
    real G6_1_1_5_1_5_3_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][3]*g11*g21;
    real G6_1_1_5_1_5_4_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g11*g01;
    real G6_1_1_5_1_5_4_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g11*g11;
    real G6_1_1_5_1_5_4_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g11*g21;
    real G6_1_1_5_1_5_5_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][5]*g11*g01;
    real G6_1_1_5_1_5_6_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][6]*g11*g11;
    real G6_1_1_5_1_5_7_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][7]*g11*g21;
    real G6_1_1_5_1_5_8_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g11*g01;
    real G6_1_1_5_1_5_8_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g11*g11;
    real G6_1_1_5_1_5_8_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g11*g21;
    real G6_1_1_5_1_5_9_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][9]*g11*g01;
    real G6_1_1_5_1_5_10_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][10]*g11*g11;
    real G6_1_1_5_1_5_11_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][11]*g11*g21;
    real G6_1_1_5_1_6_0_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g11*g01;
    real G6_1_1_5_1_6_0_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g11*g11;
    real G6_1_1_5_1_6_0_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g11*g21;
    real G6_1_1_5_1_6_1_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][1]*g11*g01;
    real G6_1_1_5_1_6_2_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][2]*g11*g11;
    real G6_1_1_5_1_6_3_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][3]*g11*g21;
    real G6_1_1_5_1_6_4_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g11*g01;
    real G6_1_1_5_1_6_4_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g11*g11;
    real G6_1_1_5_1_6_4_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g11*g21;
    real G6_1_1_5_1_6_5_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][5]*g11*g01;
    real G6_1_1_5_1_6_6_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][6]*g11*g11;
    real G6_1_1_5_1_6_7_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][7]*g11*g21;
    real G6_1_1_5_1_6_8_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g11*g01;
    real G6_1_1_5_1_6_8_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g11*g11;
    real G6_1_1_5_1_6_8_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g11*g21;
    real G6_1_1_5_1_6_9_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][9]*g11*g01;
    real G6_1_1_5_1_6_10_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][10]*g11*g11;
    real G6_1_1_5_1_6_11_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][11]*g11*g21;
    real G6_1_1_5_1_7_0_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g11*g01;
    real G6_1_1_5_1_7_0_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g11*g11;
    real G6_1_1_5_1_7_0_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g11*g21;
    real G6_1_1_5_1_7_1_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][1]*g11*g01;
    real G6_1_1_5_1_7_2_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][2]*g11*g11;
    real G6_1_1_5_1_7_3_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][3]*g11*g21;
    real G6_1_1_5_1_7_4_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g11*g01;
    real G6_1_1_5_1_7_4_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g11*g11;
    real G6_1_1_5_1_7_4_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g11*g21;
    real G6_1_1_5_1_7_5_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][5]*g11*g01;
    real G6_1_1_5_1_7_6_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][6]*g11*g11;
    real G6_1_1_5_1_7_7_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][7]*g11*g21;
    real G6_1_1_5_1_7_8_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g11*g01;
    real G6_1_1_5_1_7_8_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g11*g11;
    real G6_1_1_5_1_7_8_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g11*g21;
    real G6_1_1_5_1_7_9_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][9]*g11*g01;
    real G6_1_1_5_1_7_10_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][10]*g11*g11;
    real G6_1_1_5_1_7_11_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][11]*g11*g21;
    real G6_1_1_5_2_4_0_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g21*g01;
    real G6_1_1_5_2_4_0_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g21*g11;
    real G6_1_1_5_2_4_0_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][0]*g21*g21;
    real G6_1_1_5_2_4_1_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][1]*g21*g01;
    real G6_1_1_5_2_4_2_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][2]*g21*g11;
    real G6_1_1_5_2_4_3_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][3]*g21*g21;
    real G6_1_1_5_2_4_4_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g21*g01;
    real G6_1_1_5_2_4_4_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g21*g11;
    real G6_1_1_5_2_4_4_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][4]*g21*g21;
    real G6_1_1_5_2_4_5_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][5]*g21*g01;
    real G6_1_1_5_2_4_6_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][6]*g21*g11;
    real G6_1_1_5_2_4_7_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][7]*g21*g21;
    real G6_1_1_5_2_4_8_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g21*g01;
    real G6_1_1_5_2_4_8_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g21*g11;
    real G6_1_1_5_2_4_8_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][8]*g21*g21;
    real G6_1_1_5_2_4_9_0 = det*c1*c0*w[0][5]*w[0][4]*w[1][9]*g21*g01;
    real G6_1_1_5_2_4_10_1 = det*c1*c0*w[0][5]*w[0][4]*w[1][10]*g21*g11;
    real G6_1_1_5_2_4_11_2 = det*c1*c0*w[0][5]*w[0][4]*w[1][11]*g21*g21;
    real G6_1_1_5_2_5_0_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g21*g01;
    real G6_1_1_5_2_5_0_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g21*g11;
    real G6_1_1_5_2_5_0_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][0]*g21*g21;
    real G6_1_1_5_2_5_1_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][1]*g21*g01;
    real G6_1_1_5_2_5_2_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][2]*g21*g11;
    real G6_1_1_5_2_5_3_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][3]*g21*g21;
    real G6_1_1_5_2_5_4_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g21*g01;
    real G6_1_1_5_2_5_4_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g21*g11;
    real G6_1_1_5_2_5_4_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][4]*g21*g21;
    real G6_1_1_5_2_5_5_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][5]*g21*g01;
    real G6_1_1_5_2_5_6_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][6]*g21*g11;
    real G6_1_1_5_2_5_7_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][7]*g21*g21;
    real G6_1_1_5_2_5_8_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g21*g01;
    real G6_1_1_5_2_5_8_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g21*g11;
    real G6_1_1_5_2_5_8_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][8]*g21*g21;
    real G6_1_1_5_2_5_9_0 = det*c1*c0*w[0][5]*w[0][5]*w[1][9]*g21*g01;
    real G6_1_1_5_2_5_10_1 = det*c1*c0*w[0][5]*w[0][5]*w[1][10]*g21*g11;
    real G6_1_1_5_2_5_11_2 = det*c1*c0*w[0][5]*w[0][5]*w[1][11]*g21*g21;
    real G6_1_1_5_2_6_0_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g21*g01;
    real G6_1_1_5_2_6_0_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g21*g11;
    real G6_1_1_5_2_6_0_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][0]*g21*g21;
    real G6_1_1_5_2_6_1_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][1]*g21*g01;
    real G6_1_1_5_2_6_2_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][2]*g21*g11;
    real G6_1_1_5_2_6_3_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][3]*g21*g21;
    real G6_1_1_5_2_6_4_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g21*g01;
    real G6_1_1_5_2_6_4_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g21*g11;
    real G6_1_1_5_2_6_4_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][4]*g21*g21;
    real G6_1_1_5_2_6_5_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][5]*g21*g01;
    real G6_1_1_5_2_6_6_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][6]*g21*g11;
    real G6_1_1_5_2_6_7_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][7]*g21*g21;
    real G6_1_1_5_2_6_8_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g21*g01;
    real G6_1_1_5_2_6_8_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g21*g11;
    real G6_1_1_5_2_6_8_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][8]*g21*g21;
    real G6_1_1_5_2_6_9_0 = det*c1*c0*w[0][5]*w[0][6]*w[1][9]*g21*g01;
    real G6_1_1_5_2_6_10_1 = det*c1*c0*w[0][5]*w[0][6]*w[1][10]*g21*g11;
    real G6_1_1_5_2_6_11_2 = det*c1*c0*w[0][5]*w[0][6]*w[1][11]*g21*g21;
    real G6_1_1_5_2_7_0_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g21*g01;
    real G6_1_1_5_2_7_0_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g21*g11;
    real G6_1_1_5_2_7_0_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][0]*g21*g21;
    real G6_1_1_5_2_7_1_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][1]*g21*g01;
    real G6_1_1_5_2_7_2_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][2]*g21*g11;
    real G6_1_1_5_2_7_3_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][3]*g21*g21;
    real G6_1_1_5_2_7_4_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g21*g01;
    real G6_1_1_5_2_7_4_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g21*g11;
    real G6_1_1_5_2_7_4_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][4]*g21*g21;
    real G6_1_1_5_2_7_5_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][5]*g21*g01;
    real G6_1_1_5_2_7_6_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][6]*g21*g11;
    real G6_1_1_5_2_7_7_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][7]*g21*g21;
    real G6_1_1_5_2_7_8_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g21*g01;
    real G6_1_1_5_2_7_8_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g21*g11;
    real G6_1_1_5_2_7_8_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][8]*g21*g21;
    real G6_1_1_5_2_7_9_0 = det*c1*c0*w[0][5]*w[0][7]*w[1][9]*g21*g01;
    real G6_1_1_5_2_7_10_1 = det*c1*c0*w[0][5]*w[0][7]*w[1][10]*g21*g11;
    real G6_1_1_5_2_7_11_2 = det*c1*c0*w[0][5]*w[0][7]*w[1][11]*g21*g21;
    real G6_1_1_6_0_4_0_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g01*g01;
    real G6_1_1_6_0_4_0_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g01*g11;
    real G6_1_1_6_0_4_0_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g01*g21;
    real G6_1_1_6_0_4_1_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][1]*g01*g01;
    real G6_1_1_6_0_4_2_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][2]*g01*g11;
    real G6_1_1_6_0_4_3_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][3]*g01*g21;
    real G6_1_1_6_0_4_4_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g01*g01;
    real G6_1_1_6_0_4_4_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g01*g11;
    real G6_1_1_6_0_4_4_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g01*g21;
    real G6_1_1_6_0_4_5_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][5]*g01*g01;
    real G6_1_1_6_0_4_6_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][6]*g01*g11;
    real G6_1_1_6_0_4_7_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][7]*g01*g21;
    real G6_1_1_6_0_4_8_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g01*g01;
    real G6_1_1_6_0_4_8_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g01*g11;
    real G6_1_1_6_0_4_8_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g01*g21;
    real G6_1_1_6_0_4_9_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][9]*g01*g01;
    real G6_1_1_6_0_4_10_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][10]*g01*g11;
    real G6_1_1_6_0_4_11_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][11]*g01*g21;
    real G6_1_1_6_0_5_0_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g01*g01;
    real G6_1_1_6_0_5_0_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g01*g11;
    real G6_1_1_6_0_5_0_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g01*g21;
    real G6_1_1_6_0_5_1_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][1]*g01*g01;
    real G6_1_1_6_0_5_2_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][2]*g01*g11;
    real G6_1_1_6_0_5_3_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][3]*g01*g21;
    real G6_1_1_6_0_5_4_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g01*g01;
    real G6_1_1_6_0_5_4_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g01*g11;
    real G6_1_1_6_0_5_4_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g01*g21;
    real G6_1_1_6_0_5_5_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][5]*g01*g01;
    real G6_1_1_6_0_5_6_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][6]*g01*g11;
    real G6_1_1_6_0_5_7_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][7]*g01*g21;
    real G6_1_1_6_0_5_8_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g01*g01;
    real G6_1_1_6_0_5_8_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g01*g11;
    real G6_1_1_6_0_5_8_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g01*g21;
    real G6_1_1_6_0_5_9_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][9]*g01*g01;
    real G6_1_1_6_0_5_10_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][10]*g01*g11;
    real G6_1_1_6_0_5_11_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][11]*g01*g21;
    real G6_1_1_6_0_6_0_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g01*g01;
    real G6_1_1_6_0_6_0_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g01*g11;
    real G6_1_1_6_0_6_0_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g01*g21;
    real G6_1_1_6_0_6_1_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][1]*g01*g01;
    real G6_1_1_6_0_6_2_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][2]*g01*g11;
    real G6_1_1_6_0_6_3_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][3]*g01*g21;
    real G6_1_1_6_0_6_4_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g01*g01;
    real G6_1_1_6_0_6_4_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g01*g11;
    real G6_1_1_6_0_6_4_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g01*g21;
    real G6_1_1_6_0_6_5_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][5]*g01*g01;
    real G6_1_1_6_0_6_6_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][6]*g01*g11;
    real G6_1_1_6_0_6_7_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][7]*g01*g21;
    real G6_1_1_6_0_6_8_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g01*g01;
    real G6_1_1_6_0_6_8_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g01*g11;
    real G6_1_1_6_0_6_8_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g01*g21;
    real G6_1_1_6_0_6_9_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][9]*g01*g01;
    real G6_1_1_6_0_6_10_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][10]*g01*g11;
    real G6_1_1_6_0_6_11_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][11]*g01*g21;
    real G6_1_1_6_0_7_0_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g01*g01;
    real G6_1_1_6_0_7_0_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g01*g11;
    real G6_1_1_6_0_7_0_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g01*g21;
    real G6_1_1_6_0_7_1_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][1]*g01*g01;
    real G6_1_1_6_0_7_2_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][2]*g01*g11;
    real G6_1_1_6_0_7_3_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][3]*g01*g21;
    real G6_1_1_6_0_7_4_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g01*g01;
    real G6_1_1_6_0_7_4_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g01*g11;
    real G6_1_1_6_0_7_4_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g01*g21;
    real G6_1_1_6_0_7_5_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][5]*g01*g01;
    real G6_1_1_6_0_7_6_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][6]*g01*g11;
    real G6_1_1_6_0_7_7_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][7]*g01*g21;
    real G6_1_1_6_0_7_8_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g01*g01;
    real G6_1_1_6_0_7_8_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g01*g11;
    real G6_1_1_6_0_7_8_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g01*g21;
    real G6_1_1_6_0_7_9_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][9]*g01*g01;
    real G6_1_1_6_0_7_10_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][10]*g01*g11;
    real G6_1_1_6_0_7_11_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][11]*g01*g21;
    real G6_1_1_6_1_4_0_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g11*g01;
    real G6_1_1_6_1_4_0_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g11*g11;
    real G6_1_1_6_1_4_0_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g11*g21;
    real G6_1_1_6_1_4_1_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][1]*g11*g01;
    real G6_1_1_6_1_4_2_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][2]*g11*g11;
    real G6_1_1_6_1_4_3_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][3]*g11*g21;
    real G6_1_1_6_1_4_4_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g11*g01;
    real G6_1_1_6_1_4_4_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g11*g11;
    real G6_1_1_6_1_4_4_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g11*g21;
    real G6_1_1_6_1_4_5_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][5]*g11*g01;
    real G6_1_1_6_1_4_6_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][6]*g11*g11;
    real G6_1_1_6_1_4_7_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][7]*g11*g21;
    real G6_1_1_6_1_4_8_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g11*g01;
    real G6_1_1_6_1_4_8_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g11*g11;
    real G6_1_1_6_1_4_8_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g11*g21;
    real G6_1_1_6_1_4_9_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][9]*g11*g01;
    real G6_1_1_6_1_4_10_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][10]*g11*g11;
    real G6_1_1_6_1_4_11_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][11]*g11*g21;
    real G6_1_1_6_1_5_0_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g11*g01;
    real G6_1_1_6_1_5_0_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g11*g11;
    real G6_1_1_6_1_5_0_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g11*g21;
    real G6_1_1_6_1_5_1_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][1]*g11*g01;
    real G6_1_1_6_1_5_2_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][2]*g11*g11;
    real G6_1_1_6_1_5_3_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][3]*g11*g21;
    real G6_1_1_6_1_5_4_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g11*g01;
    real G6_1_1_6_1_5_4_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g11*g11;
    real G6_1_1_6_1_5_4_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g11*g21;
    real G6_1_1_6_1_5_5_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][5]*g11*g01;
    real G6_1_1_6_1_5_6_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][6]*g11*g11;
    real G6_1_1_6_1_5_7_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][7]*g11*g21;
    real G6_1_1_6_1_5_8_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g11*g01;
    real G6_1_1_6_1_5_8_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g11*g11;
    real G6_1_1_6_1_5_8_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g11*g21;
    real G6_1_1_6_1_5_9_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][9]*g11*g01;
    real G6_1_1_6_1_5_10_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][10]*g11*g11;
    real G6_1_1_6_1_5_11_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][11]*g11*g21;
    real G6_1_1_6_1_6_0_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g11*g01;
    real G6_1_1_6_1_6_0_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g11*g11;
    real G6_1_1_6_1_6_0_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g11*g21;
    real G6_1_1_6_1_6_1_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][1]*g11*g01;
    real G6_1_1_6_1_6_2_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][2]*g11*g11;
    real G6_1_1_6_1_6_3_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][3]*g11*g21;
    real G6_1_1_6_1_6_4_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g11*g01;
    real G6_1_1_6_1_6_4_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g11*g11;
    real G6_1_1_6_1_6_4_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g11*g21;
    real G6_1_1_6_1_6_5_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][5]*g11*g01;
    real G6_1_1_6_1_6_6_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][6]*g11*g11;
    real G6_1_1_6_1_6_7_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][7]*g11*g21;
    real G6_1_1_6_1_6_8_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g11*g01;
    real G6_1_1_6_1_6_8_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g11*g11;
    real G6_1_1_6_1_6_8_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g11*g21;
    real G6_1_1_6_1_6_9_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][9]*g11*g01;
    real G6_1_1_6_1_6_10_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][10]*g11*g11;
    real G6_1_1_6_1_6_11_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][11]*g11*g21;
    real G6_1_1_6_1_7_0_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g11*g01;
    real G6_1_1_6_1_7_0_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g11*g11;
    real G6_1_1_6_1_7_0_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g11*g21;
    real G6_1_1_6_1_7_1_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][1]*g11*g01;
    real G6_1_1_6_1_7_2_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][2]*g11*g11;
    real G6_1_1_6_1_7_3_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][3]*g11*g21;
    real G6_1_1_6_1_7_4_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g11*g01;
    real G6_1_1_6_1_7_4_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g11*g11;
    real G6_1_1_6_1_7_4_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g11*g21;
    real G6_1_1_6_1_7_5_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][5]*g11*g01;
    real G6_1_1_6_1_7_6_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][6]*g11*g11;
    real G6_1_1_6_1_7_7_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][7]*g11*g21;
    real G6_1_1_6_1_7_8_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g11*g01;
    real G6_1_1_6_1_7_8_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g11*g11;
    real G6_1_1_6_1_7_8_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g11*g21;
    real G6_1_1_6_1_7_9_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][9]*g11*g01;
    real G6_1_1_6_1_7_10_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][10]*g11*g11;
    real G6_1_1_6_1_7_11_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][11]*g11*g21;
    real G6_1_1_6_2_4_0_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g21*g01;
    real G6_1_1_6_2_4_0_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g21*g11;
    real G6_1_1_6_2_4_0_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][0]*g21*g21;
    real G6_1_1_6_2_4_1_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][1]*g21*g01;
    real G6_1_1_6_2_4_2_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][2]*g21*g11;
    real G6_1_1_6_2_4_3_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][3]*g21*g21;
    real G6_1_1_6_2_4_4_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g21*g01;
    real G6_1_1_6_2_4_4_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g21*g11;
    real G6_1_1_6_2_4_4_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][4]*g21*g21;
    real G6_1_1_6_2_4_5_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][5]*g21*g01;
    real G6_1_1_6_2_4_6_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][6]*g21*g11;
    real G6_1_1_6_2_4_7_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][7]*g21*g21;
    real G6_1_1_6_2_4_8_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g21*g01;
    real G6_1_1_6_2_4_8_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g21*g11;
    real G6_1_1_6_2_4_8_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][8]*g21*g21;
    real G6_1_1_6_2_4_9_0 = det*c1*c0*w[0][6]*w[0][4]*w[1][9]*g21*g01;
    real G6_1_1_6_2_4_10_1 = det*c1*c0*w[0][6]*w[0][4]*w[1][10]*g21*g11;
    real G6_1_1_6_2_4_11_2 = det*c1*c0*w[0][6]*w[0][4]*w[1][11]*g21*g21;
    real G6_1_1_6_2_5_0_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g21*g01;
    real G6_1_1_6_2_5_0_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g21*g11;
    real G6_1_1_6_2_5_0_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][0]*g21*g21;
    real G6_1_1_6_2_5_1_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][1]*g21*g01;
    real G6_1_1_6_2_5_2_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][2]*g21*g11;
    real G6_1_1_6_2_5_3_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][3]*g21*g21;
    real G6_1_1_6_2_5_4_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g21*g01;
    real G6_1_1_6_2_5_4_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g21*g11;
    real G6_1_1_6_2_5_4_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][4]*g21*g21;
    real G6_1_1_6_2_5_5_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][5]*g21*g01;
    real G6_1_1_6_2_5_6_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][6]*g21*g11;
    real G6_1_1_6_2_5_7_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][7]*g21*g21;
    real G6_1_1_6_2_5_8_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g21*g01;
    real G6_1_1_6_2_5_8_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g21*g11;
    real G6_1_1_6_2_5_8_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][8]*g21*g21;
    real G6_1_1_6_2_5_9_0 = det*c1*c0*w[0][6]*w[0][5]*w[1][9]*g21*g01;
    real G6_1_1_6_2_5_10_1 = det*c1*c0*w[0][6]*w[0][5]*w[1][10]*g21*g11;
    real G6_1_1_6_2_5_11_2 = det*c1*c0*w[0][6]*w[0][5]*w[1][11]*g21*g21;
    real G6_1_1_6_2_6_0_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g21*g01;
    real G6_1_1_6_2_6_0_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g21*g11;
    real G6_1_1_6_2_6_0_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][0]*g21*g21;
    real G6_1_1_6_2_6_1_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][1]*g21*g01;
    real G6_1_1_6_2_6_2_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][2]*g21*g11;
    real G6_1_1_6_2_6_3_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][3]*g21*g21;
    real G6_1_1_6_2_6_4_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g21*g01;
    real G6_1_1_6_2_6_4_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g21*g11;
    real G6_1_1_6_2_6_4_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][4]*g21*g21;
    real G6_1_1_6_2_6_5_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][5]*g21*g01;
    real G6_1_1_6_2_6_6_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][6]*g21*g11;
    real G6_1_1_6_2_6_7_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][7]*g21*g21;
    real G6_1_1_6_2_6_8_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g21*g01;
    real G6_1_1_6_2_6_8_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g21*g11;
    real G6_1_1_6_2_6_8_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][8]*g21*g21;
    real G6_1_1_6_2_6_9_0 = det*c1*c0*w[0][6]*w[0][6]*w[1][9]*g21*g01;
    real G6_1_1_6_2_6_10_1 = det*c1*c0*w[0][6]*w[0][6]*w[1][10]*g21*g11;
    real G6_1_1_6_2_6_11_2 = det*c1*c0*w[0][6]*w[0][6]*w[1][11]*g21*g21;
    real G6_1_1_6_2_7_0_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g21*g01;
    real G6_1_1_6_2_7_0_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g21*g11;
    real G6_1_1_6_2_7_0_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][0]*g21*g21;
    real G6_1_1_6_2_7_1_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][1]*g21*g01;
    real G6_1_1_6_2_7_2_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][2]*g21*g11;
    real G6_1_1_6_2_7_3_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][3]*g21*g21;
    real G6_1_1_6_2_7_4_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g21*g01;
    real G6_1_1_6_2_7_4_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g21*g11;
    real G6_1_1_6_2_7_4_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][4]*g21*g21;
    real G6_1_1_6_2_7_5_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][5]*g21*g01;
    real G6_1_1_6_2_7_6_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][6]*g21*g11;
    real G6_1_1_6_2_7_7_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][7]*g21*g21;
    real G6_1_1_6_2_7_8_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g21*g01;
    real G6_1_1_6_2_7_8_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g21*g11;
    real G6_1_1_6_2_7_8_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][8]*g21*g21;
    real G6_1_1_6_2_7_9_0 = det*c1*c0*w[0][6]*w[0][7]*w[1][9]*g21*g01;
    real G6_1_1_6_2_7_10_1 = det*c1*c0*w[0][6]*w[0][7]*w[1][10]*g21*g11;
    real G6_1_1_6_2_7_11_2 = det*c1*c0*w[0][6]*w[0][7]*w[1][11]*g21*g21;
    real G6_1_1_7_0_4_0_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g01*g01;
    real G6_1_1_7_0_4_0_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g01*g11;
    real G6_1_1_7_0_4_0_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g01*g21;
    real G6_1_1_7_0_4_1_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][1]*g01*g01;
    real G6_1_1_7_0_4_2_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][2]*g01*g11;
    real G6_1_1_7_0_4_3_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][3]*g01*g21;
    real G6_1_1_7_0_4_4_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g01*g01;
    real G6_1_1_7_0_4_4_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g01*g11;
    real G6_1_1_7_0_4_4_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g01*g21;
    real G6_1_1_7_0_4_5_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][5]*g01*g01;
    real G6_1_1_7_0_4_6_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][6]*g01*g11;
    real G6_1_1_7_0_4_7_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][7]*g01*g21;
    real G6_1_1_7_0_4_8_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g01*g01;
    real G6_1_1_7_0_4_8_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g01*g11;
    real G6_1_1_7_0_4_8_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g01*g21;
    real G6_1_1_7_0_4_9_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][9]*g01*g01;
    real G6_1_1_7_0_4_10_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][10]*g01*g11;
    real G6_1_1_7_0_4_11_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][11]*g01*g21;
    real G6_1_1_7_0_5_0_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g01*g01;
    real G6_1_1_7_0_5_0_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g01*g11;
    real G6_1_1_7_0_5_0_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g01*g21;
    real G6_1_1_7_0_5_1_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][1]*g01*g01;
    real G6_1_1_7_0_5_2_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][2]*g01*g11;
    real G6_1_1_7_0_5_3_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][3]*g01*g21;
    real G6_1_1_7_0_5_4_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g01*g01;
    real G6_1_1_7_0_5_4_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g01*g11;
    real G6_1_1_7_0_5_4_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g01*g21;
    real G6_1_1_7_0_5_5_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][5]*g01*g01;
    real G6_1_1_7_0_5_6_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][6]*g01*g11;
    real G6_1_1_7_0_5_7_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][7]*g01*g21;
    real G6_1_1_7_0_5_8_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g01*g01;
    real G6_1_1_7_0_5_8_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g01*g11;
    real G6_1_1_7_0_5_8_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g01*g21;
    real G6_1_1_7_0_5_9_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][9]*g01*g01;
    real G6_1_1_7_0_5_10_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][10]*g01*g11;
    real G6_1_1_7_0_5_11_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][11]*g01*g21;
    real G6_1_1_7_0_6_0_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g01*g01;
    real G6_1_1_7_0_6_0_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g01*g11;
    real G6_1_1_7_0_6_0_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g01*g21;
    real G6_1_1_7_0_6_1_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][1]*g01*g01;
    real G6_1_1_7_0_6_2_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][2]*g01*g11;
    real G6_1_1_7_0_6_3_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][3]*g01*g21;
    real G6_1_1_7_0_6_4_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g01*g01;
    real G6_1_1_7_0_6_4_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g01*g11;
    real G6_1_1_7_0_6_4_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g01*g21;
    real G6_1_1_7_0_6_5_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][5]*g01*g01;
    real G6_1_1_7_0_6_6_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][6]*g01*g11;
    real G6_1_1_7_0_6_7_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][7]*g01*g21;
    real G6_1_1_7_0_6_8_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g01*g01;
    real G6_1_1_7_0_6_8_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g01*g11;
    real G6_1_1_7_0_6_8_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g01*g21;
    real G6_1_1_7_0_6_9_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][9]*g01*g01;
    real G6_1_1_7_0_6_10_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][10]*g01*g11;
    real G6_1_1_7_0_6_11_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][11]*g01*g21;
    real G6_1_1_7_0_7_0_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g01*g01;
    real G6_1_1_7_0_7_0_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g01*g11;
    real G6_1_1_7_0_7_0_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g01*g21;
    real G6_1_1_7_0_7_1_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][1]*g01*g01;
    real G6_1_1_7_0_7_2_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][2]*g01*g11;
    real G6_1_1_7_0_7_3_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][3]*g01*g21;
    real G6_1_1_7_0_7_4_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g01*g01;
    real G6_1_1_7_0_7_4_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g01*g11;
    real G6_1_1_7_0_7_4_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g01*g21;
    real G6_1_1_7_0_7_5_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][5]*g01*g01;
    real G6_1_1_7_0_7_6_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][6]*g01*g11;
    real G6_1_1_7_0_7_7_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][7]*g01*g21;
    real G6_1_1_7_0_7_8_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g01*g01;
    real G6_1_1_7_0_7_8_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g01*g11;
    real G6_1_1_7_0_7_8_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g01*g21;
    real G6_1_1_7_0_7_9_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][9]*g01*g01;
    real G6_1_1_7_0_7_10_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][10]*g01*g11;
    real G6_1_1_7_0_7_11_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][11]*g01*g21;
    real G6_1_1_7_1_4_0_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g11*g01;
    real G6_1_1_7_1_4_0_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g11*g11;
    real G6_1_1_7_1_4_0_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g11*g21;
    real G6_1_1_7_1_4_1_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][1]*g11*g01;
    real G6_1_1_7_1_4_2_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][2]*g11*g11;
    real G6_1_1_7_1_4_3_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][3]*g11*g21;
    real G6_1_1_7_1_4_4_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g11*g01;
    real G6_1_1_7_1_4_4_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g11*g11;
    real G6_1_1_7_1_4_4_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g11*g21;
    real G6_1_1_7_1_4_5_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][5]*g11*g01;
    real G6_1_1_7_1_4_6_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][6]*g11*g11;
    real G6_1_1_7_1_4_7_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][7]*g11*g21;
    real G6_1_1_7_1_4_8_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g11*g01;
    real G6_1_1_7_1_4_8_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g11*g11;
    real G6_1_1_7_1_4_8_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g11*g21;
    real G6_1_1_7_1_4_9_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][9]*g11*g01;
    real G6_1_1_7_1_4_10_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][10]*g11*g11;
    real G6_1_1_7_1_4_11_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][11]*g11*g21;
    real G6_1_1_7_1_5_0_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g11*g01;
    real G6_1_1_7_1_5_0_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g11*g11;
    real G6_1_1_7_1_5_0_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g11*g21;
    real G6_1_1_7_1_5_1_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][1]*g11*g01;
    real G6_1_1_7_1_5_2_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][2]*g11*g11;
    real G6_1_1_7_1_5_3_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][3]*g11*g21;
    real G6_1_1_7_1_5_4_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g11*g01;
    real G6_1_1_7_1_5_4_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g11*g11;
    real G6_1_1_7_1_5_4_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g11*g21;
    real G6_1_1_7_1_5_5_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][5]*g11*g01;
    real G6_1_1_7_1_5_6_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][6]*g11*g11;
    real G6_1_1_7_1_5_7_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][7]*g11*g21;
    real G6_1_1_7_1_5_8_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g11*g01;
    real G6_1_1_7_1_5_8_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g11*g11;
    real G6_1_1_7_1_5_8_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g11*g21;
    real G6_1_1_7_1_5_9_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][9]*g11*g01;
    real G6_1_1_7_1_5_10_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][10]*g11*g11;
    real G6_1_1_7_1_5_11_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][11]*g11*g21;
    real G6_1_1_7_1_6_0_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g11*g01;
    real G6_1_1_7_1_6_0_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g11*g11;
    real G6_1_1_7_1_6_0_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g11*g21;
    real G6_1_1_7_1_6_1_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][1]*g11*g01;
    real G6_1_1_7_1_6_2_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][2]*g11*g11;
    real G6_1_1_7_1_6_3_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][3]*g11*g21;
    real G6_1_1_7_1_6_4_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g11*g01;
    real G6_1_1_7_1_6_4_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g11*g11;
    real G6_1_1_7_1_6_4_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g11*g21;
    real G6_1_1_7_1_6_5_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][5]*g11*g01;
    real G6_1_1_7_1_6_6_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][6]*g11*g11;
    real G6_1_1_7_1_6_7_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][7]*g11*g21;
    real G6_1_1_7_1_6_8_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g11*g01;
    real G6_1_1_7_1_6_8_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g11*g11;
    real G6_1_1_7_1_6_8_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g11*g21;
    real G6_1_1_7_1_6_9_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][9]*g11*g01;
    real G6_1_1_7_1_6_10_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][10]*g11*g11;
    real G6_1_1_7_1_6_11_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][11]*g11*g21;
    real G6_1_1_7_1_7_0_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g11*g01;
    real G6_1_1_7_1_7_0_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g11*g11;
    real G6_1_1_7_1_7_0_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g11*g21;
    real G6_1_1_7_1_7_1_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][1]*g11*g01;
    real G6_1_1_7_1_7_2_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][2]*g11*g11;
    real G6_1_1_7_1_7_3_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][3]*g11*g21;
    real G6_1_1_7_1_7_4_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g11*g01;
    real G6_1_1_7_1_7_4_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g11*g11;
    real G6_1_1_7_1_7_4_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g11*g21;
    real G6_1_1_7_1_7_5_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][5]*g11*g01;
    real G6_1_1_7_1_7_6_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][6]*g11*g11;
    real G6_1_1_7_1_7_7_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][7]*g11*g21;
    real G6_1_1_7_1_7_8_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g11*g01;
    real G6_1_1_7_1_7_8_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g11*g11;
    real G6_1_1_7_1_7_8_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g11*g21;
    real G6_1_1_7_1_7_9_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][9]*g11*g01;
    real G6_1_1_7_1_7_10_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][10]*g11*g11;
    real G6_1_1_7_1_7_11_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][11]*g11*g21;
    real G6_1_1_7_2_4_0_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g21*g01;
    real G6_1_1_7_2_4_0_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g21*g11;
    real G6_1_1_7_2_4_0_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][0]*g21*g21;
    real G6_1_1_7_2_4_1_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][1]*g21*g01;
    real G6_1_1_7_2_4_2_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][2]*g21*g11;
    real G6_1_1_7_2_4_3_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][3]*g21*g21;
    real G6_1_1_7_2_4_4_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g21*g01;
    real G6_1_1_7_2_4_4_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g21*g11;
    real G6_1_1_7_2_4_4_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][4]*g21*g21;
    real G6_1_1_7_2_4_5_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][5]*g21*g01;
    real G6_1_1_7_2_4_6_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][6]*g21*g11;
    real G6_1_1_7_2_4_7_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][7]*g21*g21;
    real G6_1_1_7_2_4_8_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g21*g01;
    real G6_1_1_7_2_4_8_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g21*g11;
    real G6_1_1_7_2_4_8_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][8]*g21*g21;
    real G6_1_1_7_2_4_9_0 = det*c1*c0*w[0][7]*w[0][4]*w[1][9]*g21*g01;
    real G6_1_1_7_2_4_10_1 = det*c1*c0*w[0][7]*w[0][4]*w[1][10]*g21*g11;
    real G6_1_1_7_2_4_11_2 = det*c1*c0*w[0][7]*w[0][4]*w[1][11]*g21*g21;
    real G6_1_1_7_2_5_0_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g21*g01;
    real G6_1_1_7_2_5_0_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g21*g11;
    real G6_1_1_7_2_5_0_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][0]*g21*g21;
    real G6_1_1_7_2_5_1_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][1]*g21*g01;
    real G6_1_1_7_2_5_2_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][2]*g21*g11;
    real G6_1_1_7_2_5_3_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][3]*g21*g21;
    real G6_1_1_7_2_5_4_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g21*g01;
    real G6_1_1_7_2_5_4_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g21*g11;
    real G6_1_1_7_2_5_4_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][4]*g21*g21;
    real G6_1_1_7_2_5_5_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][5]*g21*g01;
    real G6_1_1_7_2_5_6_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][6]*g21*g11;
    real G6_1_1_7_2_5_7_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][7]*g21*g21;
    real G6_1_1_7_2_5_8_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g21*g01;
    real G6_1_1_7_2_5_8_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g21*g11;
    real G6_1_1_7_2_5_8_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][8]*g21*g21;
    real G6_1_1_7_2_5_9_0 = det*c1*c0*w[0][7]*w[0][5]*w[1][9]*g21*g01;
    real G6_1_1_7_2_5_10_1 = det*c1*c0*w[0][7]*w[0][5]*w[1][10]*g21*g11;
    real G6_1_1_7_2_5_11_2 = det*c1*c0*w[0][7]*w[0][5]*w[1][11]*g21*g21;
    real G6_1_1_7_2_6_0_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g21*g01;
    real G6_1_1_7_2_6_0_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g21*g11;
    real G6_1_1_7_2_6_0_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][0]*g21*g21;
    real G6_1_1_7_2_6_1_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][1]*g21*g01;
    real G6_1_1_7_2_6_2_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][2]*g21*g11;
    real G6_1_1_7_2_6_3_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][3]*g21*g21;
    real G6_1_1_7_2_6_4_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g21*g01;
    real G6_1_1_7_2_6_4_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g21*g11;
    real G6_1_1_7_2_6_4_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][4]*g21*g21;
    real G6_1_1_7_2_6_5_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][5]*g21*g01;
    real G6_1_1_7_2_6_6_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][6]*g21*g11;
    real G6_1_1_7_2_6_7_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][7]*g21*g21;
    real G6_1_1_7_2_6_8_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g21*g01;
    real G6_1_1_7_2_6_8_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g21*g11;
    real G6_1_1_7_2_6_8_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][8]*g21*g21;
    real G6_1_1_7_2_6_9_0 = det*c1*c0*w[0][7]*w[0][6]*w[1][9]*g21*g01;
    real G6_1_1_7_2_6_10_1 = det*c1*c0*w[0][7]*w[0][6]*w[1][10]*g21*g11;
    real G6_1_1_7_2_6_11_2 = det*c1*c0*w[0][7]*w[0][6]*w[1][11]*g21*g21;
    real G6_1_1_7_2_7_0_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g21*g01;
    real G6_1_1_7_2_7_0_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g21*g11;
    real G6_1_1_7_2_7_0_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][0]*g21*g21;
    real G6_1_1_7_2_7_1_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][1]*g21*g01;
    real G6_1_1_7_2_7_2_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][2]*g21*g11;
    real G6_1_1_7_2_7_3_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][3]*g21*g21;
    real G6_1_1_7_2_7_4_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g21*g01;
    real G6_1_1_7_2_7_4_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g21*g11;
    real G6_1_1_7_2_7_4_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][4]*g21*g21;
    real G6_1_1_7_2_7_5_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][5]*g21*g01;
    real G6_1_1_7_2_7_6_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][6]*g21*g11;
    real G6_1_1_7_2_7_7_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][7]*g21*g21;
    real G6_1_1_7_2_7_8_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g21*g01;
    real G6_1_1_7_2_7_8_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g21*g11;
    real G6_1_1_7_2_7_8_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][8]*g21*g21;
    real G6_1_1_7_2_7_9_0 = det*c1*c0*w[0][7]*w[0][7]*w[1][9]*g21*g01;
    real G6_1_1_7_2_7_10_1 = det*c1*c0*w[0][7]*w[0][7]*w[1][10]*g21*g11;
    real G6_1_1_7_2_7_11_2 = det*c1*c0*w[0][7]*w[0][7]*w[1][11]*g21*g21;
    real G6_1_2_4_0_8_0_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g01*g02;
    real G6_1_2_4_0_8_0_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g01*g12;
    real G6_1_2_4_0_8_0_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g01*g22;
    real G6_1_2_4_0_8_1_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][1]*g01*g02;
    real G6_1_2_4_0_8_2_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][2]*g01*g12;
    real G6_1_2_4_0_8_3_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][3]*g01*g22;
    real G6_1_2_4_0_8_4_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g01*g02;
    real G6_1_2_4_0_8_4_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g01*g12;
    real G6_1_2_4_0_8_4_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g01*g22;
    real G6_1_2_4_0_8_5_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][5]*g01*g02;
    real G6_1_2_4_0_8_6_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][6]*g01*g12;
    real G6_1_2_4_0_8_7_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][7]*g01*g22;
    real G6_1_2_4_0_8_8_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g01*g02;
    real G6_1_2_4_0_8_8_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g01*g12;
    real G6_1_2_4_0_8_8_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g01*g22;
    real G6_1_2_4_0_8_9_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][9]*g01*g02;
    real G6_1_2_4_0_8_10_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][10]*g01*g12;
    real G6_1_2_4_0_8_11_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][11]*g01*g22;
    real G6_1_2_4_0_9_0_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g01*g02;
    real G6_1_2_4_0_9_0_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g01*g12;
    real G6_1_2_4_0_9_0_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g01*g22;
    real G6_1_2_4_0_9_1_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][1]*g01*g02;
    real G6_1_2_4_0_9_2_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][2]*g01*g12;
    real G6_1_2_4_0_9_3_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][3]*g01*g22;
    real G6_1_2_4_0_9_4_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g01*g02;
    real G6_1_2_4_0_9_4_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g01*g12;
    real G6_1_2_4_0_9_4_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g01*g22;
    real G6_1_2_4_0_9_5_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][5]*g01*g02;
    real G6_1_2_4_0_9_6_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][6]*g01*g12;
    real G6_1_2_4_0_9_7_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][7]*g01*g22;
    real G6_1_2_4_0_9_8_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g01*g02;
    real G6_1_2_4_0_9_8_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g01*g12;
    real G6_1_2_4_0_9_8_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g01*g22;
    real G6_1_2_4_0_9_9_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][9]*g01*g02;
    real G6_1_2_4_0_9_10_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][10]*g01*g12;
    real G6_1_2_4_0_9_11_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][11]*g01*g22;
    real G6_1_2_4_0_10_0_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g01*g02;
    real G6_1_2_4_0_10_0_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g01*g12;
    real G6_1_2_4_0_10_0_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g01*g22;
    real G6_1_2_4_0_10_1_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][1]*g01*g02;
    real G6_1_2_4_0_10_2_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][2]*g01*g12;
    real G6_1_2_4_0_10_3_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][3]*g01*g22;
    real G6_1_2_4_0_10_4_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g01*g02;
    real G6_1_2_4_0_10_4_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g01*g12;
    real G6_1_2_4_0_10_4_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g01*g22;
    real G6_1_2_4_0_10_5_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][5]*g01*g02;
    real G6_1_2_4_0_10_6_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][6]*g01*g12;
    real G6_1_2_4_0_10_7_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][7]*g01*g22;
    real G6_1_2_4_0_10_8_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g01*g02;
    real G6_1_2_4_0_10_8_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g01*g12;
    real G6_1_2_4_0_10_8_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g01*g22;
    real G6_1_2_4_0_10_9_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][9]*g01*g02;
    real G6_1_2_4_0_10_10_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][10]*g01*g12;
    real G6_1_2_4_0_10_11_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][11]*g01*g22;
    real G6_1_2_4_0_11_0_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g01*g02;
    real G6_1_2_4_0_11_0_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g01*g12;
    real G6_1_2_4_0_11_0_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g01*g22;
    real G6_1_2_4_0_11_1_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][1]*g01*g02;
    real G6_1_2_4_0_11_2_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][2]*g01*g12;
    real G6_1_2_4_0_11_3_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][3]*g01*g22;
    real G6_1_2_4_0_11_4_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g01*g02;
    real G6_1_2_4_0_11_4_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g01*g12;
    real G6_1_2_4_0_11_4_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g01*g22;
    real G6_1_2_4_0_11_5_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][5]*g01*g02;
    real G6_1_2_4_0_11_6_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][6]*g01*g12;
    real G6_1_2_4_0_11_7_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][7]*g01*g22;
    real G6_1_2_4_0_11_8_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g01*g02;
    real G6_1_2_4_0_11_8_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g01*g12;
    real G6_1_2_4_0_11_8_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g01*g22;
    real G6_1_2_4_0_11_9_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][9]*g01*g02;
    real G6_1_2_4_0_11_10_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][10]*g01*g12;
    real G6_1_2_4_0_11_11_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][11]*g01*g22;
    real G6_1_2_4_1_8_0_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g11*g02;
    real G6_1_2_4_1_8_0_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g11*g12;
    real G6_1_2_4_1_8_0_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g11*g22;
    real G6_1_2_4_1_8_1_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][1]*g11*g02;
    real G6_1_2_4_1_8_2_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][2]*g11*g12;
    real G6_1_2_4_1_8_3_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][3]*g11*g22;
    real G6_1_2_4_1_8_4_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g11*g02;
    real G6_1_2_4_1_8_4_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g11*g12;
    real G6_1_2_4_1_8_4_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g11*g22;
    real G6_1_2_4_1_8_5_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][5]*g11*g02;
    real G6_1_2_4_1_8_6_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][6]*g11*g12;
    real G6_1_2_4_1_8_7_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][7]*g11*g22;
    real G6_1_2_4_1_8_8_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g11*g02;
    real G6_1_2_4_1_8_8_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g11*g12;
    real G6_1_2_4_1_8_8_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g11*g22;
    real G6_1_2_4_1_8_9_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][9]*g11*g02;
    real G6_1_2_4_1_8_10_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][10]*g11*g12;
    real G6_1_2_4_1_8_11_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][11]*g11*g22;
    real G6_1_2_4_1_9_0_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g11*g02;
    real G6_1_2_4_1_9_0_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g11*g12;
    real G6_1_2_4_1_9_0_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g11*g22;
    real G6_1_2_4_1_9_1_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][1]*g11*g02;
    real G6_1_2_4_1_9_2_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][2]*g11*g12;
    real G6_1_2_4_1_9_3_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][3]*g11*g22;
    real G6_1_2_4_1_9_4_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g11*g02;
    real G6_1_2_4_1_9_4_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g11*g12;
    real G6_1_2_4_1_9_4_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g11*g22;
    real G6_1_2_4_1_9_5_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][5]*g11*g02;
    real G6_1_2_4_1_9_6_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][6]*g11*g12;
    real G6_1_2_4_1_9_7_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][7]*g11*g22;
    real G6_1_2_4_1_9_8_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g11*g02;
    real G6_1_2_4_1_9_8_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g11*g12;
    real G6_1_2_4_1_9_8_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g11*g22;
    real G6_1_2_4_1_9_9_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][9]*g11*g02;
    real G6_1_2_4_1_9_10_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][10]*g11*g12;
    real G6_1_2_4_1_9_11_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][11]*g11*g22;
    real G6_1_2_4_1_10_0_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g11*g02;
    real G6_1_2_4_1_10_0_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g11*g12;
    real G6_1_2_4_1_10_0_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g11*g22;
    real G6_1_2_4_1_10_1_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][1]*g11*g02;
    real G6_1_2_4_1_10_2_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][2]*g11*g12;
    real G6_1_2_4_1_10_3_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][3]*g11*g22;
    real G6_1_2_4_1_10_4_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g11*g02;
    real G6_1_2_4_1_10_4_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g11*g12;
    real G6_1_2_4_1_10_4_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g11*g22;
    real G6_1_2_4_1_10_5_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][5]*g11*g02;
    real G6_1_2_4_1_10_6_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][6]*g11*g12;
    real G6_1_2_4_1_10_7_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][7]*g11*g22;
    real G6_1_2_4_1_10_8_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g11*g02;
    real G6_1_2_4_1_10_8_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g11*g12;
    real G6_1_2_4_1_10_8_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g11*g22;
    real G6_1_2_4_1_10_9_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][9]*g11*g02;
    real G6_1_2_4_1_10_10_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][10]*g11*g12;
    real G6_1_2_4_1_10_11_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][11]*g11*g22;
    real G6_1_2_4_1_11_0_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g11*g02;
    real G6_1_2_4_1_11_0_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g11*g12;
    real G6_1_2_4_1_11_0_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g11*g22;
    real G6_1_2_4_1_11_1_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][1]*g11*g02;
    real G6_1_2_4_1_11_2_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][2]*g11*g12;
    real G6_1_2_4_1_11_3_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][3]*g11*g22;
    real G6_1_2_4_1_11_4_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g11*g02;
    real G6_1_2_4_1_11_4_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g11*g12;
    real G6_1_2_4_1_11_4_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g11*g22;
    real G6_1_2_4_1_11_5_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][5]*g11*g02;
    real G6_1_2_4_1_11_6_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][6]*g11*g12;
    real G6_1_2_4_1_11_7_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][7]*g11*g22;
    real G6_1_2_4_1_11_8_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g11*g02;
    real G6_1_2_4_1_11_8_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g11*g12;
    real G6_1_2_4_1_11_8_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g11*g22;
    real G6_1_2_4_1_11_9_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][9]*g11*g02;
    real G6_1_2_4_1_11_10_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][10]*g11*g12;
    real G6_1_2_4_1_11_11_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][11]*g11*g22;
    real G6_1_2_4_2_8_0_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g21*g02;
    real G6_1_2_4_2_8_0_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g21*g12;
    real G6_1_2_4_2_8_0_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][0]*g21*g22;
    real G6_1_2_4_2_8_1_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][1]*g21*g02;
    real G6_1_2_4_2_8_2_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][2]*g21*g12;
    real G6_1_2_4_2_8_3_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][3]*g21*g22;
    real G6_1_2_4_2_8_4_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g21*g02;
    real G6_1_2_4_2_8_4_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g21*g12;
    real G6_1_2_4_2_8_4_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][4]*g21*g22;
    real G6_1_2_4_2_8_5_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][5]*g21*g02;
    real G6_1_2_4_2_8_6_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][6]*g21*g12;
    real G6_1_2_4_2_8_7_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][7]*g21*g22;
    real G6_1_2_4_2_8_8_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g21*g02;
    real G6_1_2_4_2_8_8_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g21*g12;
    real G6_1_2_4_2_8_8_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][8]*g21*g22;
    real G6_1_2_4_2_8_9_0 = det*c1*c0*w[0][4]*w[0][8]*w[1][9]*g21*g02;
    real G6_1_2_4_2_8_10_1 = det*c1*c0*w[0][4]*w[0][8]*w[1][10]*g21*g12;
    real G6_1_2_4_2_8_11_2 = det*c1*c0*w[0][4]*w[0][8]*w[1][11]*g21*g22;
    real G6_1_2_4_2_9_0_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g21*g02;
    real G6_1_2_4_2_9_0_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g21*g12;
    real G6_1_2_4_2_9_0_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][0]*g21*g22;
    real G6_1_2_4_2_9_1_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][1]*g21*g02;
    real G6_1_2_4_2_9_2_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][2]*g21*g12;
    real G6_1_2_4_2_9_3_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][3]*g21*g22;
    real G6_1_2_4_2_9_4_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g21*g02;
    real G6_1_2_4_2_9_4_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g21*g12;
    real G6_1_2_4_2_9_4_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][4]*g21*g22;
    real G6_1_2_4_2_9_5_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][5]*g21*g02;
    real G6_1_2_4_2_9_6_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][6]*g21*g12;
    real G6_1_2_4_2_9_7_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][7]*g21*g22;
    real G6_1_2_4_2_9_8_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g21*g02;
    real G6_1_2_4_2_9_8_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g21*g12;
    real G6_1_2_4_2_9_8_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][8]*g21*g22;
    real G6_1_2_4_2_9_9_0 = det*c1*c0*w[0][4]*w[0][9]*w[1][9]*g21*g02;
    real G6_1_2_4_2_9_10_1 = det*c1*c0*w[0][4]*w[0][9]*w[1][10]*g21*g12;
    real G6_1_2_4_2_9_11_2 = det*c1*c0*w[0][4]*w[0][9]*w[1][11]*g21*g22;
    real G6_1_2_4_2_10_0_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g21*g02;
    real G6_1_2_4_2_10_0_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g21*g12;
    real G6_1_2_4_2_10_0_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][0]*g21*g22;
    real G6_1_2_4_2_10_1_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][1]*g21*g02;
    real G6_1_2_4_2_10_2_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][2]*g21*g12;
    real G6_1_2_4_2_10_3_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][3]*g21*g22;
    real G6_1_2_4_2_10_4_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g21*g02;
    real G6_1_2_4_2_10_4_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g21*g12;
    real G6_1_2_4_2_10_4_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][4]*g21*g22;
    real G6_1_2_4_2_10_5_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][5]*g21*g02;
    real G6_1_2_4_2_10_6_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][6]*g21*g12;
    real G6_1_2_4_2_10_7_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][7]*g21*g22;
    real G6_1_2_4_2_10_8_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g21*g02;
    real G6_1_2_4_2_10_8_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g21*g12;
    real G6_1_2_4_2_10_8_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][8]*g21*g22;
    real G6_1_2_4_2_10_9_0 = det*c1*c0*w[0][4]*w[0][10]*w[1][9]*g21*g02;
    real G6_1_2_4_2_10_10_1 = det*c1*c0*w[0][4]*w[0][10]*w[1][10]*g21*g12;
    real G6_1_2_4_2_10_11_2 = det*c1*c0*w[0][4]*w[0][10]*w[1][11]*g21*g22;
    real G6_1_2_4_2_11_0_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g21*g02;
    real G6_1_2_4_2_11_0_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g21*g12;
    real G6_1_2_4_2_11_0_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][0]*g21*g22;
    real G6_1_2_4_2_11_1_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][1]*g21*g02;
    real G6_1_2_4_2_11_2_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][2]*g21*g12;
    real G6_1_2_4_2_11_3_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][3]*g21*g22;
    real G6_1_2_4_2_11_4_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g21*g02;
    real G6_1_2_4_2_11_4_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g21*g12;
    real G6_1_2_4_2_11_4_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][4]*g21*g22;
    real G6_1_2_4_2_11_5_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][5]*g21*g02;
    real G6_1_2_4_2_11_6_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][6]*g21*g12;
    real G6_1_2_4_2_11_7_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][7]*g21*g22;
    real G6_1_2_4_2_11_8_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g21*g02;
    real G6_1_2_4_2_11_8_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g21*g12;
    real G6_1_2_4_2_11_8_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][8]*g21*g22;
    real G6_1_2_4_2_11_9_0 = det*c1*c0*w[0][4]*w[0][11]*w[1][9]*g21*g02;
    real G6_1_2_4_2_11_10_1 = det*c1*c0*w[0][4]*w[0][11]*w[1][10]*g21*g12;
    real G6_1_2_4_2_11_11_2 = det*c1*c0*w[0][4]*w[0][11]*w[1][11]*g21*g22;
    real G6_1_2_5_0_8_0_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g01*g02;
    real G6_1_2_5_0_8_0_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g01*g12;
    real G6_1_2_5_0_8_0_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g01*g22;
    real G6_1_2_5_0_8_1_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][1]*g01*g02;
    real G6_1_2_5_0_8_2_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][2]*g01*g12;
    real G6_1_2_5_0_8_3_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][3]*g01*g22;
    real G6_1_2_5_0_8_4_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g01*g02;
    real G6_1_2_5_0_8_4_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g01*g12;
    real G6_1_2_5_0_8_4_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g01*g22;
    real G6_1_2_5_0_8_5_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][5]*g01*g02;
    real G6_1_2_5_0_8_6_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][6]*g01*g12;
    real G6_1_2_5_0_8_7_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][7]*g01*g22;
    real G6_1_2_5_0_8_8_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g01*g02;
    real G6_1_2_5_0_8_8_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g01*g12;
    real G6_1_2_5_0_8_8_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g01*g22;
    real G6_1_2_5_0_8_9_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][9]*g01*g02;
    real G6_1_2_5_0_8_10_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][10]*g01*g12;
    real G6_1_2_5_0_8_11_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][11]*g01*g22;
    real G6_1_2_5_0_9_0_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g01*g02;
    real G6_1_2_5_0_9_0_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g01*g12;
    real G6_1_2_5_0_9_0_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g01*g22;
    real G6_1_2_5_0_9_1_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][1]*g01*g02;
    real G6_1_2_5_0_9_2_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][2]*g01*g12;
    real G6_1_2_5_0_9_3_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][3]*g01*g22;
    real G6_1_2_5_0_9_4_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g01*g02;
    real G6_1_2_5_0_9_4_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g01*g12;
    real G6_1_2_5_0_9_4_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g01*g22;
    real G6_1_2_5_0_9_5_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][5]*g01*g02;
    real G6_1_2_5_0_9_6_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][6]*g01*g12;
    real G6_1_2_5_0_9_7_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][7]*g01*g22;
    real G6_1_2_5_0_9_8_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g01*g02;
    real G6_1_2_5_0_9_8_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g01*g12;
    real G6_1_2_5_0_9_8_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g01*g22;
    real G6_1_2_5_0_9_9_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][9]*g01*g02;
    real G6_1_2_5_0_9_10_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][10]*g01*g12;
    real G6_1_2_5_0_9_11_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][11]*g01*g22;
    real G6_1_2_5_0_10_0_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g01*g02;
    real G6_1_2_5_0_10_0_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g01*g12;
    real G6_1_2_5_0_10_0_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g01*g22;
    real G6_1_2_5_0_10_1_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][1]*g01*g02;
    real G6_1_2_5_0_10_2_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][2]*g01*g12;
    real G6_1_2_5_0_10_3_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][3]*g01*g22;
    real G6_1_2_5_0_10_4_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g01*g02;
    real G6_1_2_5_0_10_4_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g01*g12;
    real G6_1_2_5_0_10_4_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g01*g22;
    real G6_1_2_5_0_10_5_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][5]*g01*g02;
    real G6_1_2_5_0_10_6_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][6]*g01*g12;
    real G6_1_2_5_0_10_7_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][7]*g01*g22;
    real G6_1_2_5_0_10_8_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g01*g02;
    real G6_1_2_5_0_10_8_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g01*g12;
    real G6_1_2_5_0_10_8_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g01*g22;
    real G6_1_2_5_0_10_9_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][9]*g01*g02;
    real G6_1_2_5_0_10_10_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][10]*g01*g12;
    real G6_1_2_5_0_10_11_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][11]*g01*g22;
    real G6_1_2_5_0_11_0_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g01*g02;
    real G6_1_2_5_0_11_0_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g01*g12;
    real G6_1_2_5_0_11_0_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g01*g22;
    real G6_1_2_5_0_11_1_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][1]*g01*g02;
    real G6_1_2_5_0_11_2_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][2]*g01*g12;
    real G6_1_2_5_0_11_3_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][3]*g01*g22;
    real G6_1_2_5_0_11_4_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g01*g02;
    real G6_1_2_5_0_11_4_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g01*g12;
    real G6_1_2_5_0_11_4_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g01*g22;
    real G6_1_2_5_0_11_5_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][5]*g01*g02;
    real G6_1_2_5_0_11_6_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][6]*g01*g12;
    real G6_1_2_5_0_11_7_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][7]*g01*g22;
    real G6_1_2_5_0_11_8_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g01*g02;
    real G6_1_2_5_0_11_8_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g01*g12;
    real G6_1_2_5_0_11_8_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g01*g22;
    real G6_1_2_5_0_11_9_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][9]*g01*g02;
    real G6_1_2_5_0_11_10_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][10]*g01*g12;
    real G6_1_2_5_0_11_11_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][11]*g01*g22;
    real G6_1_2_5_1_8_0_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g11*g02;
    real G6_1_2_5_1_8_0_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g11*g12;
    real G6_1_2_5_1_8_0_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g11*g22;
    real G6_1_2_5_1_8_1_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][1]*g11*g02;
    real G6_1_2_5_1_8_2_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][2]*g11*g12;
    real G6_1_2_5_1_8_3_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][3]*g11*g22;
    real G6_1_2_5_1_8_4_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g11*g02;
    real G6_1_2_5_1_8_4_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g11*g12;
    real G6_1_2_5_1_8_4_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g11*g22;
    real G6_1_2_5_1_8_5_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][5]*g11*g02;
    real G6_1_2_5_1_8_6_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][6]*g11*g12;
    real G6_1_2_5_1_8_7_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][7]*g11*g22;
    real G6_1_2_5_1_8_8_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g11*g02;
    real G6_1_2_5_1_8_8_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g11*g12;
    real G6_1_2_5_1_8_8_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g11*g22;
    real G6_1_2_5_1_8_9_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][9]*g11*g02;
    real G6_1_2_5_1_8_10_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][10]*g11*g12;
    real G6_1_2_5_1_8_11_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][11]*g11*g22;
    real G6_1_2_5_1_9_0_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g11*g02;
    real G6_1_2_5_1_9_0_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g11*g12;
    real G6_1_2_5_1_9_0_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g11*g22;
    real G6_1_2_5_1_9_1_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][1]*g11*g02;
    real G6_1_2_5_1_9_2_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][2]*g11*g12;
    real G6_1_2_5_1_9_3_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][3]*g11*g22;
    real G6_1_2_5_1_9_4_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g11*g02;
    real G6_1_2_5_1_9_4_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g11*g12;
    real G6_1_2_5_1_9_4_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g11*g22;
    real G6_1_2_5_1_9_5_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][5]*g11*g02;
    real G6_1_2_5_1_9_6_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][6]*g11*g12;
    real G6_1_2_5_1_9_7_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][7]*g11*g22;
    real G6_1_2_5_1_9_8_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g11*g02;
    real G6_1_2_5_1_9_8_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g11*g12;
    real G6_1_2_5_1_9_8_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g11*g22;
    real G6_1_2_5_1_9_9_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][9]*g11*g02;
    real G6_1_2_5_1_9_10_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][10]*g11*g12;
    real G6_1_2_5_1_9_11_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][11]*g11*g22;
    real G6_1_2_5_1_10_0_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g11*g02;
    real G6_1_2_5_1_10_0_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g11*g12;
    real G6_1_2_5_1_10_0_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g11*g22;
    real G6_1_2_5_1_10_1_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][1]*g11*g02;
    real G6_1_2_5_1_10_2_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][2]*g11*g12;
    real G6_1_2_5_1_10_3_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][3]*g11*g22;
    real G6_1_2_5_1_10_4_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g11*g02;
    real G6_1_2_5_1_10_4_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g11*g12;
    real G6_1_2_5_1_10_4_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g11*g22;
    real G6_1_2_5_1_10_5_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][5]*g11*g02;
    real G6_1_2_5_1_10_6_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][6]*g11*g12;
    real G6_1_2_5_1_10_7_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][7]*g11*g22;
    real G6_1_2_5_1_10_8_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g11*g02;
    real G6_1_2_5_1_10_8_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g11*g12;
    real G6_1_2_5_1_10_8_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g11*g22;
    real G6_1_2_5_1_10_9_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][9]*g11*g02;
    real G6_1_2_5_1_10_10_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][10]*g11*g12;
    real G6_1_2_5_1_10_11_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][11]*g11*g22;
    real G6_1_2_5_1_11_0_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g11*g02;
    real G6_1_2_5_1_11_0_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g11*g12;
    real G6_1_2_5_1_11_0_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g11*g22;
    real G6_1_2_5_1_11_1_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][1]*g11*g02;
    real G6_1_2_5_1_11_2_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][2]*g11*g12;
    real G6_1_2_5_1_11_3_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][3]*g11*g22;
    real G6_1_2_5_1_11_4_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g11*g02;
    real G6_1_2_5_1_11_4_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g11*g12;
    real G6_1_2_5_1_11_4_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g11*g22;
    real G6_1_2_5_1_11_5_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][5]*g11*g02;
    real G6_1_2_5_1_11_6_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][6]*g11*g12;
    real G6_1_2_5_1_11_7_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][7]*g11*g22;
    real G6_1_2_5_1_11_8_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g11*g02;
    real G6_1_2_5_1_11_8_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g11*g12;
    real G6_1_2_5_1_11_8_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g11*g22;
    real G6_1_2_5_1_11_9_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][9]*g11*g02;
    real G6_1_2_5_1_11_10_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][10]*g11*g12;
    real G6_1_2_5_1_11_11_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][11]*g11*g22;
    real G6_1_2_5_2_8_0_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g21*g02;
    real G6_1_2_5_2_8_0_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g21*g12;
    real G6_1_2_5_2_8_0_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][0]*g21*g22;
    real G6_1_2_5_2_8_1_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][1]*g21*g02;
    real G6_1_2_5_2_8_2_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][2]*g21*g12;
    real G6_1_2_5_2_8_3_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][3]*g21*g22;
    real G6_1_2_5_2_8_4_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g21*g02;
    real G6_1_2_5_2_8_4_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g21*g12;
    real G6_1_2_5_2_8_4_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][4]*g21*g22;
    real G6_1_2_5_2_8_5_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][5]*g21*g02;
    real G6_1_2_5_2_8_6_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][6]*g21*g12;
    real G6_1_2_5_2_8_7_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][7]*g21*g22;
    real G6_1_2_5_2_8_8_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g21*g02;
    real G6_1_2_5_2_8_8_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g21*g12;
    real G6_1_2_5_2_8_8_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][8]*g21*g22;
    real G6_1_2_5_2_8_9_0 = det*c1*c0*w[0][5]*w[0][8]*w[1][9]*g21*g02;
    real G6_1_2_5_2_8_10_1 = det*c1*c0*w[0][5]*w[0][8]*w[1][10]*g21*g12;
    real G6_1_2_5_2_8_11_2 = det*c1*c0*w[0][5]*w[0][8]*w[1][11]*g21*g22;
    real G6_1_2_5_2_9_0_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g21*g02;
    real G6_1_2_5_2_9_0_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g21*g12;
    real G6_1_2_5_2_9_0_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][0]*g21*g22;
    real G6_1_2_5_2_9_1_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][1]*g21*g02;
    real G6_1_2_5_2_9_2_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][2]*g21*g12;
    real G6_1_2_5_2_9_3_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][3]*g21*g22;
    real G6_1_2_5_2_9_4_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g21*g02;
    real G6_1_2_5_2_9_4_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g21*g12;
    real G6_1_2_5_2_9_4_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][4]*g21*g22;
    real G6_1_2_5_2_9_5_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][5]*g21*g02;
    real G6_1_2_5_2_9_6_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][6]*g21*g12;
    real G6_1_2_5_2_9_7_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][7]*g21*g22;
    real G6_1_2_5_2_9_8_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g21*g02;
    real G6_1_2_5_2_9_8_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g21*g12;
    real G6_1_2_5_2_9_8_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][8]*g21*g22;
    real G6_1_2_5_2_9_9_0 = det*c1*c0*w[0][5]*w[0][9]*w[1][9]*g21*g02;
    real G6_1_2_5_2_9_10_1 = det*c1*c0*w[0][5]*w[0][9]*w[1][10]*g21*g12;
    real G6_1_2_5_2_9_11_2 = det*c1*c0*w[0][5]*w[0][9]*w[1][11]*g21*g22;
    real G6_1_2_5_2_10_0_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g21*g02;
    real G6_1_2_5_2_10_0_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g21*g12;
    real G6_1_2_5_2_10_0_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][0]*g21*g22;
    real G6_1_2_5_2_10_1_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][1]*g21*g02;
    real G6_1_2_5_2_10_2_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][2]*g21*g12;
    real G6_1_2_5_2_10_3_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][3]*g21*g22;
    real G6_1_2_5_2_10_4_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g21*g02;
    real G6_1_2_5_2_10_4_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g21*g12;
    real G6_1_2_5_2_10_4_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][4]*g21*g22;
    real G6_1_2_5_2_10_5_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][5]*g21*g02;
    real G6_1_2_5_2_10_6_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][6]*g21*g12;
    real G6_1_2_5_2_10_7_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][7]*g21*g22;
    real G6_1_2_5_2_10_8_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g21*g02;
    real G6_1_2_5_2_10_8_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g21*g12;
    real G6_1_2_5_2_10_8_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][8]*g21*g22;
    real G6_1_2_5_2_10_9_0 = det*c1*c0*w[0][5]*w[0][10]*w[1][9]*g21*g02;
    real G6_1_2_5_2_10_10_1 = det*c1*c0*w[0][5]*w[0][10]*w[1][10]*g21*g12;
    real G6_1_2_5_2_10_11_2 = det*c1*c0*w[0][5]*w[0][10]*w[1][11]*g21*g22;
    real G6_1_2_5_2_11_0_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g21*g02;
    real G6_1_2_5_2_11_0_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g21*g12;
    real G6_1_2_5_2_11_0_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][0]*g21*g22;
    real G6_1_2_5_2_11_1_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][1]*g21*g02;
    real G6_1_2_5_2_11_2_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][2]*g21*g12;
    real G6_1_2_5_2_11_3_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][3]*g21*g22;
    real G6_1_2_5_2_11_4_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g21*g02;
    real G6_1_2_5_2_11_4_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g21*g12;
    real G6_1_2_5_2_11_4_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][4]*g21*g22;
    real G6_1_2_5_2_11_5_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][5]*g21*g02;
    real G6_1_2_5_2_11_6_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][6]*g21*g12;
    real G6_1_2_5_2_11_7_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][7]*g21*g22;
    real G6_1_2_5_2_11_8_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g21*g02;
    real G6_1_2_5_2_11_8_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g21*g12;
    real G6_1_2_5_2_11_8_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][8]*g21*g22;
    real G6_1_2_5_2_11_9_0 = det*c1*c0*w[0][5]*w[0][11]*w[1][9]*g21*g02;
    real G6_1_2_5_2_11_10_1 = det*c1*c0*w[0][5]*w[0][11]*w[1][10]*g21*g12;
    real G6_1_2_5_2_11_11_2 = det*c1*c0*w[0][5]*w[0][11]*w[1][11]*g21*g22;
    real G6_1_2_6_0_8_0_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g01*g02;
    real G6_1_2_6_0_8_0_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g01*g12;
    real G6_1_2_6_0_8_0_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g01*g22;
    real G6_1_2_6_0_8_1_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][1]*g01*g02;
    real G6_1_2_6_0_8_2_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][2]*g01*g12;
    real G6_1_2_6_0_8_3_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][3]*g01*g22;
    real G6_1_2_6_0_8_4_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g01*g02;
    real G6_1_2_6_0_8_4_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g01*g12;
    real G6_1_2_6_0_8_4_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g01*g22;
    real G6_1_2_6_0_8_5_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][5]*g01*g02;
    real G6_1_2_6_0_8_6_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][6]*g01*g12;
    real G6_1_2_6_0_8_7_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][7]*g01*g22;
    real G6_1_2_6_0_8_8_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g01*g02;
    real G6_1_2_6_0_8_8_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g01*g12;
    real G6_1_2_6_0_8_8_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g01*g22;
    real G6_1_2_6_0_8_9_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][9]*g01*g02;
    real G6_1_2_6_0_8_10_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][10]*g01*g12;
    real G6_1_2_6_0_8_11_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][11]*g01*g22;
    real G6_1_2_6_0_9_0_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g01*g02;
    real G6_1_2_6_0_9_0_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g01*g12;
    real G6_1_2_6_0_9_0_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g01*g22;
    real G6_1_2_6_0_9_1_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][1]*g01*g02;
    real G6_1_2_6_0_9_2_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][2]*g01*g12;
    real G6_1_2_6_0_9_3_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][3]*g01*g22;
    real G6_1_2_6_0_9_4_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g01*g02;
    real G6_1_2_6_0_9_4_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g01*g12;
    real G6_1_2_6_0_9_4_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g01*g22;
    real G6_1_2_6_0_9_5_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][5]*g01*g02;
    real G6_1_2_6_0_9_6_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][6]*g01*g12;
    real G6_1_2_6_0_9_7_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][7]*g01*g22;
    real G6_1_2_6_0_9_8_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g01*g02;
    real G6_1_2_6_0_9_8_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g01*g12;
    real G6_1_2_6_0_9_8_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g01*g22;
    real G6_1_2_6_0_9_9_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][9]*g01*g02;
    real G6_1_2_6_0_9_10_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][10]*g01*g12;
    real G6_1_2_6_0_9_11_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][11]*g01*g22;
    real G6_1_2_6_0_10_0_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g01*g02;
    real G6_1_2_6_0_10_0_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g01*g12;
    real G6_1_2_6_0_10_0_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g01*g22;
    real G6_1_2_6_0_10_1_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][1]*g01*g02;
    real G6_1_2_6_0_10_2_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][2]*g01*g12;
    real G6_1_2_6_0_10_3_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][3]*g01*g22;
    real G6_1_2_6_0_10_4_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g01*g02;
    real G6_1_2_6_0_10_4_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g01*g12;
    real G6_1_2_6_0_10_4_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g01*g22;
    real G6_1_2_6_0_10_5_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][5]*g01*g02;
    real G6_1_2_6_0_10_6_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][6]*g01*g12;
    real G6_1_2_6_0_10_7_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][7]*g01*g22;
    real G6_1_2_6_0_10_8_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g01*g02;
    real G6_1_2_6_0_10_8_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g01*g12;
    real G6_1_2_6_0_10_8_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g01*g22;
    real G6_1_2_6_0_10_9_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][9]*g01*g02;
    real G6_1_2_6_0_10_10_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][10]*g01*g12;
    real G6_1_2_6_0_10_11_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][11]*g01*g22;
    real G6_1_2_6_0_11_0_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g01*g02;
    real G6_1_2_6_0_11_0_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g01*g12;
    real G6_1_2_6_0_11_0_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g01*g22;
    real G6_1_2_6_0_11_1_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][1]*g01*g02;
    real G6_1_2_6_0_11_2_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][2]*g01*g12;
    real G6_1_2_6_0_11_3_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][3]*g01*g22;
    real G6_1_2_6_0_11_4_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g01*g02;
    real G6_1_2_6_0_11_4_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g01*g12;
    real G6_1_2_6_0_11_4_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g01*g22;
    real G6_1_2_6_0_11_5_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][5]*g01*g02;
    real G6_1_2_6_0_11_6_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][6]*g01*g12;
    real G6_1_2_6_0_11_7_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][7]*g01*g22;
    real G6_1_2_6_0_11_8_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g01*g02;
    real G6_1_2_6_0_11_8_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g01*g12;
    real G6_1_2_6_0_11_8_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g01*g22;
    real G6_1_2_6_0_11_9_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][9]*g01*g02;
    real G6_1_2_6_0_11_10_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][10]*g01*g12;
    real G6_1_2_6_0_11_11_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][11]*g01*g22;
    real G6_1_2_6_1_8_0_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g11*g02;
    real G6_1_2_6_1_8_0_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g11*g12;
    real G6_1_2_6_1_8_0_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g11*g22;
    real G6_1_2_6_1_8_1_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][1]*g11*g02;
    real G6_1_2_6_1_8_2_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][2]*g11*g12;
    real G6_1_2_6_1_8_3_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][3]*g11*g22;
    real G6_1_2_6_1_8_4_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g11*g02;
    real G6_1_2_6_1_8_4_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g11*g12;
    real G6_1_2_6_1_8_4_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g11*g22;
    real G6_1_2_6_1_8_5_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][5]*g11*g02;
    real G6_1_2_6_1_8_6_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][6]*g11*g12;
    real G6_1_2_6_1_8_7_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][7]*g11*g22;
    real G6_1_2_6_1_8_8_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g11*g02;
    real G6_1_2_6_1_8_8_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g11*g12;
    real G6_1_2_6_1_8_8_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g11*g22;
    real G6_1_2_6_1_8_9_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][9]*g11*g02;
    real G6_1_2_6_1_8_10_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][10]*g11*g12;
    real G6_1_2_6_1_8_11_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][11]*g11*g22;
    real G6_1_2_6_1_9_0_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g11*g02;
    real G6_1_2_6_1_9_0_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g11*g12;
    real G6_1_2_6_1_9_0_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g11*g22;
    real G6_1_2_6_1_9_1_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][1]*g11*g02;
    real G6_1_2_6_1_9_2_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][2]*g11*g12;
    real G6_1_2_6_1_9_3_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][3]*g11*g22;
    real G6_1_2_6_1_9_4_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g11*g02;
    real G6_1_2_6_1_9_4_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g11*g12;
    real G6_1_2_6_1_9_4_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g11*g22;
    real G6_1_2_6_1_9_5_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][5]*g11*g02;
    real G6_1_2_6_1_9_6_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][6]*g11*g12;
    real G6_1_2_6_1_9_7_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][7]*g11*g22;
    real G6_1_2_6_1_9_8_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g11*g02;
    real G6_1_2_6_1_9_8_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g11*g12;
    real G6_1_2_6_1_9_8_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g11*g22;
    real G6_1_2_6_1_9_9_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][9]*g11*g02;
    real G6_1_2_6_1_9_10_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][10]*g11*g12;
    real G6_1_2_6_1_9_11_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][11]*g11*g22;
    real G6_1_2_6_1_10_0_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g11*g02;
    real G6_1_2_6_1_10_0_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g11*g12;
    real G6_1_2_6_1_10_0_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g11*g22;
    real G6_1_2_6_1_10_1_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][1]*g11*g02;
    real G6_1_2_6_1_10_2_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][2]*g11*g12;
    real G6_1_2_6_1_10_3_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][3]*g11*g22;
    real G6_1_2_6_1_10_4_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g11*g02;
    real G6_1_2_6_1_10_4_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g11*g12;
    real G6_1_2_6_1_10_4_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g11*g22;
    real G6_1_2_6_1_10_5_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][5]*g11*g02;
    real G6_1_2_6_1_10_6_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][6]*g11*g12;
    real G6_1_2_6_1_10_7_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][7]*g11*g22;
    real G6_1_2_6_1_10_8_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g11*g02;
    real G6_1_2_6_1_10_8_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g11*g12;
    real G6_1_2_6_1_10_8_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g11*g22;
    real G6_1_2_6_1_10_9_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][9]*g11*g02;
    real G6_1_2_6_1_10_10_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][10]*g11*g12;
    real G6_1_2_6_1_10_11_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][11]*g11*g22;
    real G6_1_2_6_1_11_0_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g11*g02;
    real G6_1_2_6_1_11_0_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g11*g12;
    real G6_1_2_6_1_11_0_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g11*g22;
    real G6_1_2_6_1_11_1_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][1]*g11*g02;
    real G6_1_2_6_1_11_2_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][2]*g11*g12;
    real G6_1_2_6_1_11_3_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][3]*g11*g22;
    real G6_1_2_6_1_11_4_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g11*g02;
    real G6_1_2_6_1_11_4_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g11*g12;
    real G6_1_2_6_1_11_4_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g11*g22;
    real G6_1_2_6_1_11_5_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][5]*g11*g02;
    real G6_1_2_6_1_11_6_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][6]*g11*g12;
    real G6_1_2_6_1_11_7_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][7]*g11*g22;
    real G6_1_2_6_1_11_8_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g11*g02;
    real G6_1_2_6_1_11_8_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g11*g12;
    real G6_1_2_6_1_11_8_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g11*g22;
    real G6_1_2_6_1_11_9_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][9]*g11*g02;
    real G6_1_2_6_1_11_10_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][10]*g11*g12;
    real G6_1_2_6_1_11_11_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][11]*g11*g22;
    real G6_1_2_6_2_8_0_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g21*g02;
    real G6_1_2_6_2_8_0_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g21*g12;
    real G6_1_2_6_2_8_0_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][0]*g21*g22;
    real G6_1_2_6_2_8_1_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][1]*g21*g02;
    real G6_1_2_6_2_8_2_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][2]*g21*g12;
    real G6_1_2_6_2_8_3_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][3]*g21*g22;
    real G6_1_2_6_2_8_4_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g21*g02;
    real G6_1_2_6_2_8_4_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g21*g12;
    real G6_1_2_6_2_8_4_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][4]*g21*g22;
    real G6_1_2_6_2_8_5_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][5]*g21*g02;
    real G6_1_2_6_2_8_6_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][6]*g21*g12;
    real G6_1_2_6_2_8_7_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][7]*g21*g22;
    real G6_1_2_6_2_8_8_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g21*g02;
    real G6_1_2_6_2_8_8_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g21*g12;
    real G6_1_2_6_2_8_8_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][8]*g21*g22;
    real G6_1_2_6_2_8_9_0 = det*c1*c0*w[0][6]*w[0][8]*w[1][9]*g21*g02;
    real G6_1_2_6_2_8_10_1 = det*c1*c0*w[0][6]*w[0][8]*w[1][10]*g21*g12;
    real G6_1_2_6_2_8_11_2 = det*c1*c0*w[0][6]*w[0][8]*w[1][11]*g21*g22;
    real G6_1_2_6_2_9_0_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g21*g02;
    real G6_1_2_6_2_9_0_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g21*g12;
    real G6_1_2_6_2_9_0_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][0]*g21*g22;
    real G6_1_2_6_2_9_1_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][1]*g21*g02;
    real G6_1_2_6_2_9_2_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][2]*g21*g12;
    real G6_1_2_6_2_9_3_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][3]*g21*g22;
    real G6_1_2_6_2_9_4_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g21*g02;
    real G6_1_2_6_2_9_4_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g21*g12;
    real G6_1_2_6_2_9_4_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][4]*g21*g22;
    real G6_1_2_6_2_9_5_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][5]*g21*g02;
    real G6_1_2_6_2_9_6_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][6]*g21*g12;
    real G6_1_2_6_2_9_7_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][7]*g21*g22;
    real G6_1_2_6_2_9_8_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g21*g02;
    real G6_1_2_6_2_9_8_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g21*g12;
    real G6_1_2_6_2_9_8_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][8]*g21*g22;
    real G6_1_2_6_2_9_9_0 = det*c1*c0*w[0][6]*w[0][9]*w[1][9]*g21*g02;
    real G6_1_2_6_2_9_10_1 = det*c1*c0*w[0][6]*w[0][9]*w[1][10]*g21*g12;
    real G6_1_2_6_2_9_11_2 = det*c1*c0*w[0][6]*w[0][9]*w[1][11]*g21*g22;
    real G6_1_2_6_2_10_0_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g21*g02;
    real G6_1_2_6_2_10_0_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g21*g12;
    real G6_1_2_6_2_10_0_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][0]*g21*g22;
    real G6_1_2_6_2_10_1_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][1]*g21*g02;
    real G6_1_2_6_2_10_2_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][2]*g21*g12;
    real G6_1_2_6_2_10_3_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][3]*g21*g22;
    real G6_1_2_6_2_10_4_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g21*g02;
    real G6_1_2_6_2_10_4_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g21*g12;
    real G6_1_2_6_2_10_4_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][4]*g21*g22;
    real G6_1_2_6_2_10_5_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][5]*g21*g02;
    real G6_1_2_6_2_10_6_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][6]*g21*g12;
    real G6_1_2_6_2_10_7_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][7]*g21*g22;
    real G6_1_2_6_2_10_8_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g21*g02;
    real G6_1_2_6_2_10_8_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g21*g12;
    real G6_1_2_6_2_10_8_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][8]*g21*g22;
    real G6_1_2_6_2_10_9_0 = det*c1*c0*w[0][6]*w[0][10]*w[1][9]*g21*g02;
    real G6_1_2_6_2_10_10_1 = det*c1*c0*w[0][6]*w[0][10]*w[1][10]*g21*g12;
    real G6_1_2_6_2_10_11_2 = det*c1*c0*w[0][6]*w[0][10]*w[1][11]*g21*g22;
    real G6_1_2_6_2_11_0_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g21*g02;
    real G6_1_2_6_2_11_0_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g21*g12;
    real G6_1_2_6_2_11_0_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][0]*g21*g22;
    real G6_1_2_6_2_11_1_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][1]*g21*g02;
    real G6_1_2_6_2_11_2_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][2]*g21*g12;
    real G6_1_2_6_2_11_3_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][3]*g21*g22;
    real G6_1_2_6_2_11_4_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g21*g02;
    real G6_1_2_6_2_11_4_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g21*g12;
    real G6_1_2_6_2_11_4_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][4]*g21*g22;
    real G6_1_2_6_2_11_5_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][5]*g21*g02;
    real G6_1_2_6_2_11_6_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][6]*g21*g12;
    real G6_1_2_6_2_11_7_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][7]*g21*g22;
    real G6_1_2_6_2_11_8_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g21*g02;
    real G6_1_2_6_2_11_8_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g21*g12;
    real G6_1_2_6_2_11_8_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][8]*g21*g22;
    real G6_1_2_6_2_11_9_0 = det*c1*c0*w[0][6]*w[0][11]*w[1][9]*g21*g02;
    real G6_1_2_6_2_11_10_1 = det*c1*c0*w[0][6]*w[0][11]*w[1][10]*g21*g12;
    real G6_1_2_6_2_11_11_2 = det*c1*c0*w[0][6]*w[0][11]*w[1][11]*g21*g22;
    real G6_1_2_7_0_8_0_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g01*g02;
    real G6_1_2_7_0_8_0_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g01*g12;
    real G6_1_2_7_0_8_0_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g01*g22;
    real G6_1_2_7_0_8_1_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][1]*g01*g02;
    real G6_1_2_7_0_8_2_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][2]*g01*g12;
    real G6_1_2_7_0_8_3_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][3]*g01*g22;
    real G6_1_2_7_0_8_4_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g01*g02;
    real G6_1_2_7_0_8_4_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g01*g12;
    real G6_1_2_7_0_8_4_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g01*g22;
    real G6_1_2_7_0_8_5_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][5]*g01*g02;
    real G6_1_2_7_0_8_6_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][6]*g01*g12;
    real G6_1_2_7_0_8_7_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][7]*g01*g22;
    real G6_1_2_7_0_8_8_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g01*g02;
    real G6_1_2_7_0_8_8_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g01*g12;
    real G6_1_2_7_0_8_8_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g01*g22;
    real G6_1_2_7_0_8_9_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][9]*g01*g02;
    real G6_1_2_7_0_8_10_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][10]*g01*g12;
    real G6_1_2_7_0_8_11_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][11]*g01*g22;
    real G6_1_2_7_0_9_0_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g01*g02;
    real G6_1_2_7_0_9_0_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g01*g12;
    real G6_1_2_7_0_9_0_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g01*g22;
    real G6_1_2_7_0_9_1_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][1]*g01*g02;
    real G6_1_2_7_0_9_2_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][2]*g01*g12;
    real G6_1_2_7_0_9_3_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][3]*g01*g22;
    real G6_1_2_7_0_9_4_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g01*g02;
    real G6_1_2_7_0_9_4_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g01*g12;
    real G6_1_2_7_0_9_4_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g01*g22;
    real G6_1_2_7_0_9_5_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][5]*g01*g02;
    real G6_1_2_7_0_9_6_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][6]*g01*g12;
    real G6_1_2_7_0_9_7_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][7]*g01*g22;
    real G6_1_2_7_0_9_8_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g01*g02;
    real G6_1_2_7_0_9_8_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g01*g12;
    real G6_1_2_7_0_9_8_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g01*g22;
    real G6_1_2_7_0_9_9_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][9]*g01*g02;
    real G6_1_2_7_0_9_10_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][10]*g01*g12;
    real G6_1_2_7_0_9_11_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][11]*g01*g22;
    real G6_1_2_7_0_10_0_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g01*g02;
    real G6_1_2_7_0_10_0_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g01*g12;
    real G6_1_2_7_0_10_0_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g01*g22;
    real G6_1_2_7_0_10_1_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][1]*g01*g02;
    real G6_1_2_7_0_10_2_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][2]*g01*g12;
    real G6_1_2_7_0_10_3_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][3]*g01*g22;
    real G6_1_2_7_0_10_4_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g01*g02;
    real G6_1_2_7_0_10_4_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g01*g12;
    real G6_1_2_7_0_10_4_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g01*g22;
    real G6_1_2_7_0_10_5_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][5]*g01*g02;
    real G6_1_2_7_0_10_6_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][6]*g01*g12;
    real G6_1_2_7_0_10_7_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][7]*g01*g22;
    real G6_1_2_7_0_10_8_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g01*g02;
    real G6_1_2_7_0_10_8_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g01*g12;
    real G6_1_2_7_0_10_8_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g01*g22;
    real G6_1_2_7_0_10_9_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][9]*g01*g02;
    real G6_1_2_7_0_10_10_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][10]*g01*g12;
    real G6_1_2_7_0_10_11_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][11]*g01*g22;
    real G6_1_2_7_0_11_0_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g01*g02;
    real G6_1_2_7_0_11_0_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g01*g12;
    real G6_1_2_7_0_11_0_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g01*g22;
    real G6_1_2_7_0_11_1_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][1]*g01*g02;
    real G6_1_2_7_0_11_2_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][2]*g01*g12;
    real G6_1_2_7_0_11_3_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][3]*g01*g22;
    real G6_1_2_7_0_11_4_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g01*g02;
    real G6_1_2_7_0_11_4_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g01*g12;
    real G6_1_2_7_0_11_4_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g01*g22;
    real G6_1_2_7_0_11_5_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][5]*g01*g02;
    real G6_1_2_7_0_11_6_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][6]*g01*g12;
    real G6_1_2_7_0_11_7_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][7]*g01*g22;
    real G6_1_2_7_0_11_8_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g01*g02;
    real G6_1_2_7_0_11_8_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g01*g12;
    real G6_1_2_7_0_11_8_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g01*g22;
    real G6_1_2_7_0_11_9_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][9]*g01*g02;
    real G6_1_2_7_0_11_10_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][10]*g01*g12;
    real G6_1_2_7_0_11_11_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][11]*g01*g22;
    real G6_1_2_7_1_8_0_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g11*g02;
    real G6_1_2_7_1_8_0_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g11*g12;
    real G6_1_2_7_1_8_0_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g11*g22;
    real G6_1_2_7_1_8_1_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][1]*g11*g02;
    real G6_1_2_7_1_8_2_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][2]*g11*g12;
    real G6_1_2_7_1_8_3_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][3]*g11*g22;
    real G6_1_2_7_1_8_4_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g11*g02;
    real G6_1_2_7_1_8_4_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g11*g12;
    real G6_1_2_7_1_8_4_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g11*g22;
    real G6_1_2_7_1_8_5_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][5]*g11*g02;
    real G6_1_2_7_1_8_6_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][6]*g11*g12;
    real G6_1_2_7_1_8_7_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][7]*g11*g22;
    real G6_1_2_7_1_8_8_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g11*g02;
    real G6_1_2_7_1_8_8_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g11*g12;
    real G6_1_2_7_1_8_8_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g11*g22;
    real G6_1_2_7_1_8_9_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][9]*g11*g02;
    real G6_1_2_7_1_8_10_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][10]*g11*g12;
    real G6_1_2_7_1_8_11_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][11]*g11*g22;
    real G6_1_2_7_1_9_0_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g11*g02;
    real G6_1_2_7_1_9_0_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g11*g12;
    real G6_1_2_7_1_9_0_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g11*g22;
    real G6_1_2_7_1_9_1_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][1]*g11*g02;
    real G6_1_2_7_1_9_2_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][2]*g11*g12;
    real G6_1_2_7_1_9_3_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][3]*g11*g22;
    real G6_1_2_7_1_9_4_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g11*g02;
    real G6_1_2_7_1_9_4_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g11*g12;
    real G6_1_2_7_1_9_4_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g11*g22;
    real G6_1_2_7_1_9_5_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][5]*g11*g02;
    real G6_1_2_7_1_9_6_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][6]*g11*g12;
    real G6_1_2_7_1_9_7_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][7]*g11*g22;
    real G6_1_2_7_1_9_8_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g11*g02;
    real G6_1_2_7_1_9_8_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g11*g12;
    real G6_1_2_7_1_9_8_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g11*g22;
    real G6_1_2_7_1_9_9_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][9]*g11*g02;
    real G6_1_2_7_1_9_10_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][10]*g11*g12;
    real G6_1_2_7_1_9_11_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][11]*g11*g22;
    real G6_1_2_7_1_10_0_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g11*g02;
    real G6_1_2_7_1_10_0_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g11*g12;
    real G6_1_2_7_1_10_0_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g11*g22;
    real G6_1_2_7_1_10_1_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][1]*g11*g02;
    real G6_1_2_7_1_10_2_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][2]*g11*g12;
    real G6_1_2_7_1_10_3_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][3]*g11*g22;
    real G6_1_2_7_1_10_4_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g11*g02;
    real G6_1_2_7_1_10_4_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g11*g12;
    real G6_1_2_7_1_10_4_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g11*g22;
    real G6_1_2_7_1_10_5_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][5]*g11*g02;
    real G6_1_2_7_1_10_6_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][6]*g11*g12;
    real G6_1_2_7_1_10_7_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][7]*g11*g22;
    real G6_1_2_7_1_10_8_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g11*g02;
    real G6_1_2_7_1_10_8_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g11*g12;
    real G6_1_2_7_1_10_8_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g11*g22;
    real G6_1_2_7_1_10_9_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][9]*g11*g02;
    real G6_1_2_7_1_10_10_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][10]*g11*g12;
    real G6_1_2_7_1_10_11_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][11]*g11*g22;
    real G6_1_2_7_1_11_0_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g11*g02;
    real G6_1_2_7_1_11_0_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g11*g12;
    real G6_1_2_7_1_11_0_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g11*g22;
    real G6_1_2_7_1_11_1_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][1]*g11*g02;
    real G6_1_2_7_1_11_2_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][2]*g11*g12;
    real G6_1_2_7_1_11_3_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][3]*g11*g22;
    real G6_1_2_7_1_11_4_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g11*g02;
    real G6_1_2_7_1_11_4_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g11*g12;
    real G6_1_2_7_1_11_4_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g11*g22;
    real G6_1_2_7_1_11_5_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][5]*g11*g02;
    real G6_1_2_7_1_11_6_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][6]*g11*g12;
    real G6_1_2_7_1_11_7_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][7]*g11*g22;
    real G6_1_2_7_1_11_8_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g11*g02;
    real G6_1_2_7_1_11_8_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g11*g12;
    real G6_1_2_7_1_11_8_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g11*g22;
    real G6_1_2_7_1_11_9_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][9]*g11*g02;
    real G6_1_2_7_1_11_10_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][10]*g11*g12;
    real G6_1_2_7_1_11_11_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][11]*g11*g22;
    real G6_1_2_7_2_8_0_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g21*g02;
    real G6_1_2_7_2_8_0_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g21*g12;
    real G6_1_2_7_2_8_0_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][0]*g21*g22;
    real G6_1_2_7_2_8_1_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][1]*g21*g02;
    real G6_1_2_7_2_8_2_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][2]*g21*g12;
    real G6_1_2_7_2_8_3_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][3]*g21*g22;
    real G6_1_2_7_2_8_4_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g21*g02;
    real G6_1_2_7_2_8_4_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g21*g12;
    real G6_1_2_7_2_8_4_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][4]*g21*g22;
    real G6_1_2_7_2_8_5_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][5]*g21*g02;
    real G6_1_2_7_2_8_6_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][6]*g21*g12;
    real G6_1_2_7_2_8_7_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][7]*g21*g22;
    real G6_1_2_7_2_8_8_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g21*g02;
    real G6_1_2_7_2_8_8_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g21*g12;
    real G6_1_2_7_2_8_8_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][8]*g21*g22;
    real G6_1_2_7_2_8_9_0 = det*c1*c0*w[0][7]*w[0][8]*w[1][9]*g21*g02;
    real G6_1_2_7_2_8_10_1 = det*c1*c0*w[0][7]*w[0][8]*w[1][10]*g21*g12;
    real G6_1_2_7_2_8_11_2 = det*c1*c0*w[0][7]*w[0][8]*w[1][11]*g21*g22;
    real G6_1_2_7_2_9_0_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g21*g02;
    real G6_1_2_7_2_9_0_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g21*g12;
    real G6_1_2_7_2_9_0_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][0]*g21*g22;
    real G6_1_2_7_2_9_1_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][1]*g21*g02;
    real G6_1_2_7_2_9_2_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][2]*g21*g12;
    real G6_1_2_7_2_9_3_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][3]*g21*g22;
    real G6_1_2_7_2_9_4_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g21*g02;
    real G6_1_2_7_2_9_4_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g21*g12;
    real G6_1_2_7_2_9_4_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][4]*g21*g22;
    real G6_1_2_7_2_9_5_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][5]*g21*g02;
    real G6_1_2_7_2_9_6_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][6]*g21*g12;
    real G6_1_2_7_2_9_7_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][7]*g21*g22;
    real G6_1_2_7_2_9_8_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g21*g02;
    real G6_1_2_7_2_9_8_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g21*g12;
    real G6_1_2_7_2_9_8_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][8]*g21*g22;
    real G6_1_2_7_2_9_9_0 = det*c1*c0*w[0][7]*w[0][9]*w[1][9]*g21*g02;
    real G6_1_2_7_2_9_10_1 = det*c1*c0*w[0][7]*w[0][9]*w[1][10]*g21*g12;
    real G6_1_2_7_2_9_11_2 = det*c1*c0*w[0][7]*w[0][9]*w[1][11]*g21*g22;
    real G6_1_2_7_2_10_0_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g21*g02;
    real G6_1_2_7_2_10_0_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g21*g12;
    real G6_1_2_7_2_10_0_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][0]*g21*g22;
    real G6_1_2_7_2_10_1_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][1]*g21*g02;
    real G6_1_2_7_2_10_2_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][2]*g21*g12;
    real G6_1_2_7_2_10_3_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][3]*g21*g22;
    real G6_1_2_7_2_10_4_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g21*g02;
    real G6_1_2_7_2_10_4_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g21*g12;
    real G6_1_2_7_2_10_4_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][4]*g21*g22;
    real G6_1_2_7_2_10_5_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][5]*g21*g02;
    real G6_1_2_7_2_10_6_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][6]*g21*g12;
    real G6_1_2_7_2_10_7_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][7]*g21*g22;
    real G6_1_2_7_2_10_8_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g21*g02;
    real G6_1_2_7_2_10_8_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g21*g12;
    real G6_1_2_7_2_10_8_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][8]*g21*g22;
    real G6_1_2_7_2_10_9_0 = det*c1*c0*w[0][7]*w[0][10]*w[1][9]*g21*g02;
    real G6_1_2_7_2_10_10_1 = det*c1*c0*w[0][7]*w[0][10]*w[1][10]*g21*g12;
    real G6_1_2_7_2_10_11_2 = det*c1*c0*w[0][7]*w[0][10]*w[1][11]*g21*g22;
    real G6_1_2_7_2_11_0_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g21*g02;
    real G6_1_2_7_2_11_0_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g21*g12;
    real G6_1_2_7_2_11_0_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][0]*g21*g22;
    real G6_1_2_7_2_11_1_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][1]*g21*g02;
    real G6_1_2_7_2_11_2_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][2]*g21*g12;
    real G6_1_2_7_2_11_3_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][3]*g21*g22;
    real G6_1_2_7_2_11_4_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g21*g02;
    real G6_1_2_7_2_11_4_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g21*g12;
    real G6_1_2_7_2_11_4_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][4]*g21*g22;
    real G6_1_2_7_2_11_5_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][5]*g21*g02;
    real G6_1_2_7_2_11_6_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][6]*g21*g12;
    real G6_1_2_7_2_11_7_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][7]*g21*g22;
    real G6_1_2_7_2_11_8_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g21*g02;
    real G6_1_2_7_2_11_8_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g21*g12;
    real G6_1_2_7_2_11_8_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][8]*g21*g22;
    real G6_1_2_7_2_11_9_0 = det*c1*c0*w[0][7]*w[0][11]*w[1][9]*g21*g02;
    real G6_1_2_7_2_11_10_1 = det*c1*c0*w[0][7]*w[0][11]*w[1][10]*g21*g12;
    real G6_1_2_7_2_11_11_2 = det*c1*c0*w[0][7]*w[0][11]*w[1][11]*g21*g22;
    real G6_2_0_8_0_0_0_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g02*g00;
    real G6_2_0_8_0_0_0_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g02*g10;
    real G6_2_0_8_0_0_0_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g02*g20;
    real G6_2_0_8_0_0_1_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][1]*g02*g00;
    real G6_2_0_8_0_0_2_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][2]*g02*g10;
    real G6_2_0_8_0_0_3_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][3]*g02*g20;
    real G6_2_0_8_0_0_4_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g02*g00;
    real G6_2_0_8_0_0_4_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g02*g10;
    real G6_2_0_8_0_0_4_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g02*g20;
    real G6_2_0_8_0_0_5_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][5]*g02*g00;
    real G6_2_0_8_0_0_6_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][6]*g02*g10;
    real G6_2_0_8_0_0_7_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][7]*g02*g20;
    real G6_2_0_8_0_0_8_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g02*g00;
    real G6_2_0_8_0_0_8_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g02*g10;
    real G6_2_0_8_0_0_8_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g02*g20;
    real G6_2_0_8_0_0_9_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][9]*g02*g00;
    real G6_2_0_8_0_0_10_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][10]*g02*g10;
    real G6_2_0_8_0_0_11_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][11]*g02*g20;
    real G6_2_0_8_0_1_0_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g02*g00;
    real G6_2_0_8_0_1_0_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g02*g10;
    real G6_2_0_8_0_1_0_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g02*g20;
    real G6_2_0_8_0_1_1_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][1]*g02*g00;
    real G6_2_0_8_0_1_2_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][2]*g02*g10;
    real G6_2_0_8_0_1_3_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][3]*g02*g20;
    real G6_2_0_8_0_1_4_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g02*g00;
    real G6_2_0_8_0_1_4_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g02*g10;
    real G6_2_0_8_0_1_4_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g02*g20;
    real G6_2_0_8_0_1_5_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][5]*g02*g00;
    real G6_2_0_8_0_1_6_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][6]*g02*g10;
    real G6_2_0_8_0_1_7_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][7]*g02*g20;
    real G6_2_0_8_0_1_8_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g02*g00;
    real G6_2_0_8_0_1_8_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g02*g10;
    real G6_2_0_8_0_1_8_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g02*g20;
    real G6_2_0_8_0_1_9_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][9]*g02*g00;
    real G6_2_0_8_0_1_10_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][10]*g02*g10;
    real G6_2_0_8_0_1_11_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][11]*g02*g20;
    real G6_2_0_8_0_2_0_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g02*g00;
    real G6_2_0_8_0_2_0_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g02*g10;
    real G6_2_0_8_0_2_0_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g02*g20;
    real G6_2_0_8_0_2_1_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][1]*g02*g00;
    real G6_2_0_8_0_2_2_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][2]*g02*g10;
    real G6_2_0_8_0_2_3_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][3]*g02*g20;
    real G6_2_0_8_0_2_4_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g02*g00;
    real G6_2_0_8_0_2_4_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g02*g10;
    real G6_2_0_8_0_2_4_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g02*g20;
    real G6_2_0_8_0_2_5_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][5]*g02*g00;
    real G6_2_0_8_0_2_6_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][6]*g02*g10;
    real G6_2_0_8_0_2_7_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][7]*g02*g20;
    real G6_2_0_8_0_2_8_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g02*g00;
    real G6_2_0_8_0_2_8_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g02*g10;
    real G6_2_0_8_0_2_8_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g02*g20;
    real G6_2_0_8_0_2_9_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][9]*g02*g00;
    real G6_2_0_8_0_2_10_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][10]*g02*g10;
    real G6_2_0_8_0_2_11_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][11]*g02*g20;
    real G6_2_0_8_0_3_0_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g02*g00;
    real G6_2_0_8_0_3_0_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g02*g10;
    real G6_2_0_8_0_3_0_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g02*g20;
    real G6_2_0_8_0_3_1_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][1]*g02*g00;
    real G6_2_0_8_0_3_2_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][2]*g02*g10;
    real G6_2_0_8_0_3_3_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][3]*g02*g20;
    real G6_2_0_8_0_3_4_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g02*g00;
    real G6_2_0_8_0_3_4_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g02*g10;
    real G6_2_0_8_0_3_4_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g02*g20;
    real G6_2_0_8_0_3_5_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][5]*g02*g00;
    real G6_2_0_8_0_3_6_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][6]*g02*g10;
    real G6_2_0_8_0_3_7_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][7]*g02*g20;
    real G6_2_0_8_0_3_8_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g02*g00;
    real G6_2_0_8_0_3_8_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g02*g10;
    real G6_2_0_8_0_3_8_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g02*g20;
    real G6_2_0_8_0_3_9_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][9]*g02*g00;
    real G6_2_0_8_0_3_10_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][10]*g02*g10;
    real G6_2_0_8_0_3_11_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][11]*g02*g20;
    real G6_2_0_8_1_0_0_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g12*g00;
    real G6_2_0_8_1_0_0_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g12*g10;
    real G6_2_0_8_1_0_0_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g12*g20;
    real G6_2_0_8_1_0_1_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][1]*g12*g00;
    real G6_2_0_8_1_0_2_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][2]*g12*g10;
    real G6_2_0_8_1_0_3_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][3]*g12*g20;
    real G6_2_0_8_1_0_4_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g12*g00;
    real G6_2_0_8_1_0_4_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g12*g10;
    real G6_2_0_8_1_0_4_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g12*g20;
    real G6_2_0_8_1_0_5_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][5]*g12*g00;
    real G6_2_0_8_1_0_6_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][6]*g12*g10;
    real G6_2_0_8_1_0_7_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][7]*g12*g20;
    real G6_2_0_8_1_0_8_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g12*g00;
    real G6_2_0_8_1_0_8_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g12*g10;
    real G6_2_0_8_1_0_8_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g12*g20;
    real G6_2_0_8_1_0_9_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][9]*g12*g00;
    real G6_2_0_8_1_0_10_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][10]*g12*g10;
    real G6_2_0_8_1_0_11_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][11]*g12*g20;
    real G6_2_0_8_1_1_0_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g12*g00;
    real G6_2_0_8_1_1_0_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g12*g10;
    real G6_2_0_8_1_1_0_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g12*g20;
    real G6_2_0_8_1_1_1_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][1]*g12*g00;
    real G6_2_0_8_1_1_2_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][2]*g12*g10;
    real G6_2_0_8_1_1_3_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][3]*g12*g20;
    real G6_2_0_8_1_1_4_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g12*g00;
    real G6_2_0_8_1_1_4_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g12*g10;
    real G6_2_0_8_1_1_4_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g12*g20;
    real G6_2_0_8_1_1_5_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][5]*g12*g00;
    real G6_2_0_8_1_1_6_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][6]*g12*g10;
    real G6_2_0_8_1_1_7_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][7]*g12*g20;
    real G6_2_0_8_1_1_8_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g12*g00;
    real G6_2_0_8_1_1_8_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g12*g10;
    real G6_2_0_8_1_1_8_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g12*g20;
    real G6_2_0_8_1_1_9_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][9]*g12*g00;
    real G6_2_0_8_1_1_10_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][10]*g12*g10;
    real G6_2_0_8_1_1_11_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][11]*g12*g20;
    real G6_2_0_8_1_2_0_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g12*g00;
    real G6_2_0_8_1_2_0_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g12*g10;
    real G6_2_0_8_1_2_0_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g12*g20;
    real G6_2_0_8_1_2_1_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][1]*g12*g00;
    real G6_2_0_8_1_2_2_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][2]*g12*g10;
    real G6_2_0_8_1_2_3_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][3]*g12*g20;
    real G6_2_0_8_1_2_4_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g12*g00;
    real G6_2_0_8_1_2_4_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g12*g10;
    real G6_2_0_8_1_2_4_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g12*g20;
    real G6_2_0_8_1_2_5_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][5]*g12*g00;
    real G6_2_0_8_1_2_6_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][6]*g12*g10;
    real G6_2_0_8_1_2_7_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][7]*g12*g20;
    real G6_2_0_8_1_2_8_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g12*g00;
    real G6_2_0_8_1_2_8_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g12*g10;
    real G6_2_0_8_1_2_8_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g12*g20;
    real G6_2_0_8_1_2_9_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][9]*g12*g00;
    real G6_2_0_8_1_2_10_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][10]*g12*g10;
    real G6_2_0_8_1_2_11_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][11]*g12*g20;
    real G6_2_0_8_1_3_0_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g12*g00;
    real G6_2_0_8_1_3_0_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g12*g10;
    real G6_2_0_8_1_3_0_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g12*g20;
    real G6_2_0_8_1_3_1_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][1]*g12*g00;
    real G6_2_0_8_1_3_2_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][2]*g12*g10;
    real G6_2_0_8_1_3_3_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][3]*g12*g20;
    real G6_2_0_8_1_3_4_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g12*g00;
    real G6_2_0_8_1_3_4_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g12*g10;
    real G6_2_0_8_1_3_4_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g12*g20;
    real G6_2_0_8_1_3_5_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][5]*g12*g00;
    real G6_2_0_8_1_3_6_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][6]*g12*g10;
    real G6_2_0_8_1_3_7_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][7]*g12*g20;
    real G6_2_0_8_1_3_8_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g12*g00;
    real G6_2_0_8_1_3_8_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g12*g10;
    real G6_2_0_8_1_3_8_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g12*g20;
    real G6_2_0_8_1_3_9_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][9]*g12*g00;
    real G6_2_0_8_1_3_10_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][10]*g12*g10;
    real G6_2_0_8_1_3_11_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][11]*g12*g20;
    real G6_2_0_8_2_0_0_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g22*g00;
    real G6_2_0_8_2_0_0_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g22*g10;
    real G6_2_0_8_2_0_0_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][0]*g22*g20;
    real G6_2_0_8_2_0_1_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][1]*g22*g00;
    real G6_2_0_8_2_0_2_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][2]*g22*g10;
    real G6_2_0_8_2_0_3_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][3]*g22*g20;
    real G6_2_0_8_2_0_4_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g22*g00;
    real G6_2_0_8_2_0_4_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g22*g10;
    real G6_2_0_8_2_0_4_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][4]*g22*g20;
    real G6_2_0_8_2_0_5_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][5]*g22*g00;
    real G6_2_0_8_2_0_6_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][6]*g22*g10;
    real G6_2_0_8_2_0_7_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][7]*g22*g20;
    real G6_2_0_8_2_0_8_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g22*g00;
    real G6_2_0_8_2_0_8_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g22*g10;
    real G6_2_0_8_2_0_8_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][8]*g22*g20;
    real G6_2_0_8_2_0_9_0 = det*c1*c0*w[0][8]*w[0][0]*w[1][9]*g22*g00;
    real G6_2_0_8_2_0_10_1 = det*c1*c0*w[0][8]*w[0][0]*w[1][10]*g22*g10;
    real G6_2_0_8_2_0_11_2 = det*c1*c0*w[0][8]*w[0][0]*w[1][11]*g22*g20;
    real G6_2_0_8_2_1_0_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g22*g00;
    real G6_2_0_8_2_1_0_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g22*g10;
    real G6_2_0_8_2_1_0_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][0]*g22*g20;
    real G6_2_0_8_2_1_1_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][1]*g22*g00;
    real G6_2_0_8_2_1_2_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][2]*g22*g10;
    real G6_2_0_8_2_1_3_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][3]*g22*g20;
    real G6_2_0_8_2_1_4_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g22*g00;
    real G6_2_0_8_2_1_4_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g22*g10;
    real G6_2_0_8_2_1_4_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][4]*g22*g20;
    real G6_2_0_8_2_1_5_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][5]*g22*g00;
    real G6_2_0_8_2_1_6_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][6]*g22*g10;
    real G6_2_0_8_2_1_7_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][7]*g22*g20;
    real G6_2_0_8_2_1_8_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g22*g00;
    real G6_2_0_8_2_1_8_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g22*g10;
    real G6_2_0_8_2_1_8_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][8]*g22*g20;
    real G6_2_0_8_2_1_9_0 = det*c1*c0*w[0][8]*w[0][1]*w[1][9]*g22*g00;
    real G6_2_0_8_2_1_10_1 = det*c1*c0*w[0][8]*w[0][1]*w[1][10]*g22*g10;
    real G6_2_0_8_2_1_11_2 = det*c1*c0*w[0][8]*w[0][1]*w[1][11]*g22*g20;
    real G6_2_0_8_2_2_0_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g22*g00;
    real G6_2_0_8_2_2_0_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g22*g10;
    real G6_2_0_8_2_2_0_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][0]*g22*g20;
    real G6_2_0_8_2_2_1_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][1]*g22*g00;
    real G6_2_0_8_2_2_2_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][2]*g22*g10;
    real G6_2_0_8_2_2_3_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][3]*g22*g20;
    real G6_2_0_8_2_2_4_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g22*g00;
    real G6_2_0_8_2_2_4_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g22*g10;
    real G6_2_0_8_2_2_4_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][4]*g22*g20;
    real G6_2_0_8_2_2_5_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][5]*g22*g00;
    real G6_2_0_8_2_2_6_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][6]*g22*g10;
    real G6_2_0_8_2_2_7_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][7]*g22*g20;
    real G6_2_0_8_2_2_8_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g22*g00;
    real G6_2_0_8_2_2_8_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g22*g10;
    real G6_2_0_8_2_2_8_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][8]*g22*g20;
    real G6_2_0_8_2_2_9_0 = det*c1*c0*w[0][8]*w[0][2]*w[1][9]*g22*g00;
    real G6_2_0_8_2_2_10_1 = det*c1*c0*w[0][8]*w[0][2]*w[1][10]*g22*g10;
    real G6_2_0_8_2_2_11_2 = det*c1*c0*w[0][8]*w[0][2]*w[1][11]*g22*g20;
    real G6_2_0_8_2_3_0_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g22*g00;
    real G6_2_0_8_2_3_0_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g22*g10;
    real G6_2_0_8_2_3_0_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][0]*g22*g20;
    real G6_2_0_8_2_3_1_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][1]*g22*g00;
    real G6_2_0_8_2_3_2_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][2]*g22*g10;
    real G6_2_0_8_2_3_3_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][3]*g22*g20;
    real G6_2_0_8_2_3_4_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g22*g00;
    real G6_2_0_8_2_3_4_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g22*g10;
    real G6_2_0_8_2_3_4_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][4]*g22*g20;
    real G6_2_0_8_2_3_5_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][5]*g22*g00;
    real G6_2_0_8_2_3_6_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][6]*g22*g10;
    real G6_2_0_8_2_3_7_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][7]*g22*g20;
    real G6_2_0_8_2_3_8_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g22*g00;
    real G6_2_0_8_2_3_8_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g22*g10;
    real G6_2_0_8_2_3_8_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][8]*g22*g20;
    real G6_2_0_8_2_3_9_0 = det*c1*c0*w[0][8]*w[0][3]*w[1][9]*g22*g00;
    real G6_2_0_8_2_3_10_1 = det*c1*c0*w[0][8]*w[0][3]*w[1][10]*g22*g10;
    real G6_2_0_8_2_3_11_2 = det*c1*c0*w[0][8]*w[0][3]*w[1][11]*g22*g20;
    real G6_2_0_9_0_0_0_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g02*g00;
    real G6_2_0_9_0_0_0_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g02*g10;
    real G6_2_0_9_0_0_0_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g02*g20;
    real G6_2_0_9_0_0_1_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][1]*g02*g00;
    real G6_2_0_9_0_0_2_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][2]*g02*g10;
    real G6_2_0_9_0_0_3_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][3]*g02*g20;
    real G6_2_0_9_0_0_4_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g02*g00;
    real G6_2_0_9_0_0_4_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g02*g10;
    real G6_2_0_9_0_0_4_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g02*g20;
    real G6_2_0_9_0_0_5_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][5]*g02*g00;
    real G6_2_0_9_0_0_6_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][6]*g02*g10;
    real G6_2_0_9_0_0_7_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][7]*g02*g20;
    real G6_2_0_9_0_0_8_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g02*g00;
    real G6_2_0_9_0_0_8_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g02*g10;
    real G6_2_0_9_0_0_8_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g02*g20;
    real G6_2_0_9_0_0_9_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][9]*g02*g00;
    real G6_2_0_9_0_0_10_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][10]*g02*g10;
    real G6_2_0_9_0_0_11_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][11]*g02*g20;
    real G6_2_0_9_0_1_0_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g02*g00;
    real G6_2_0_9_0_1_0_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g02*g10;
    real G6_2_0_9_0_1_0_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g02*g20;
    real G6_2_0_9_0_1_1_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][1]*g02*g00;
    real G6_2_0_9_0_1_2_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][2]*g02*g10;
    real G6_2_0_9_0_1_3_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][3]*g02*g20;
    real G6_2_0_9_0_1_4_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g02*g00;
    real G6_2_0_9_0_1_4_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g02*g10;
    real G6_2_0_9_0_1_4_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g02*g20;
    real G6_2_0_9_0_1_5_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][5]*g02*g00;
    real G6_2_0_9_0_1_6_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][6]*g02*g10;
    real G6_2_0_9_0_1_7_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][7]*g02*g20;
    real G6_2_0_9_0_1_8_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g02*g00;
    real G6_2_0_9_0_1_8_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g02*g10;
    real G6_2_0_9_0_1_8_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g02*g20;
    real G6_2_0_9_0_1_9_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][9]*g02*g00;
    real G6_2_0_9_0_1_10_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][10]*g02*g10;
    real G6_2_0_9_0_1_11_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][11]*g02*g20;
    real G6_2_0_9_0_2_0_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g02*g00;
    real G6_2_0_9_0_2_0_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g02*g10;
    real G6_2_0_9_0_2_0_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g02*g20;
    real G6_2_0_9_0_2_1_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][1]*g02*g00;
    real G6_2_0_9_0_2_2_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][2]*g02*g10;
    real G6_2_0_9_0_2_3_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][3]*g02*g20;
    real G6_2_0_9_0_2_4_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g02*g00;
    real G6_2_0_9_0_2_4_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g02*g10;
    real G6_2_0_9_0_2_4_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g02*g20;
    real G6_2_0_9_0_2_5_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][5]*g02*g00;
    real G6_2_0_9_0_2_6_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][6]*g02*g10;
    real G6_2_0_9_0_2_7_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][7]*g02*g20;
    real G6_2_0_9_0_2_8_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g02*g00;
    real G6_2_0_9_0_2_8_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g02*g10;
    real G6_2_0_9_0_2_8_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g02*g20;
    real G6_2_0_9_0_2_9_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][9]*g02*g00;
    real G6_2_0_9_0_2_10_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][10]*g02*g10;
    real G6_2_0_9_0_2_11_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][11]*g02*g20;
    real G6_2_0_9_0_3_0_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g02*g00;
    real G6_2_0_9_0_3_0_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g02*g10;
    real G6_2_0_9_0_3_0_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g02*g20;
    real G6_2_0_9_0_3_1_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][1]*g02*g00;
    real G6_2_0_9_0_3_2_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][2]*g02*g10;
    real G6_2_0_9_0_3_3_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][3]*g02*g20;
    real G6_2_0_9_0_3_4_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g02*g00;
    real G6_2_0_9_0_3_4_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g02*g10;
    real G6_2_0_9_0_3_4_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g02*g20;
    real G6_2_0_9_0_3_5_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][5]*g02*g00;
    real G6_2_0_9_0_3_6_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][6]*g02*g10;
    real G6_2_0_9_0_3_7_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][7]*g02*g20;
    real G6_2_0_9_0_3_8_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g02*g00;
    real G6_2_0_9_0_3_8_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g02*g10;
    real G6_2_0_9_0_3_8_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g02*g20;
    real G6_2_0_9_0_3_9_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][9]*g02*g00;
    real G6_2_0_9_0_3_10_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][10]*g02*g10;
    real G6_2_0_9_0_3_11_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][11]*g02*g20;
    real G6_2_0_9_1_0_0_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g12*g00;
    real G6_2_0_9_1_0_0_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g12*g10;
    real G6_2_0_9_1_0_0_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g12*g20;
    real G6_2_0_9_1_0_1_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][1]*g12*g00;
    real G6_2_0_9_1_0_2_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][2]*g12*g10;
    real G6_2_0_9_1_0_3_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][3]*g12*g20;
    real G6_2_0_9_1_0_4_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g12*g00;
    real G6_2_0_9_1_0_4_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g12*g10;
    real G6_2_0_9_1_0_4_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g12*g20;
    real G6_2_0_9_1_0_5_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][5]*g12*g00;
    real G6_2_0_9_1_0_6_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][6]*g12*g10;
    real G6_2_0_9_1_0_7_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][7]*g12*g20;
    real G6_2_0_9_1_0_8_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g12*g00;
    real G6_2_0_9_1_0_8_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g12*g10;
    real G6_2_0_9_1_0_8_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g12*g20;
    real G6_2_0_9_1_0_9_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][9]*g12*g00;
    real G6_2_0_9_1_0_10_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][10]*g12*g10;
    real G6_2_0_9_1_0_11_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][11]*g12*g20;
    real G6_2_0_9_1_1_0_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g12*g00;
    real G6_2_0_9_1_1_0_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g12*g10;
    real G6_2_0_9_1_1_0_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g12*g20;
    real G6_2_0_9_1_1_1_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][1]*g12*g00;
    real G6_2_0_9_1_1_2_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][2]*g12*g10;
    real G6_2_0_9_1_1_3_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][3]*g12*g20;
    real G6_2_0_9_1_1_4_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g12*g00;
    real G6_2_0_9_1_1_4_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g12*g10;
    real G6_2_0_9_1_1_4_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g12*g20;
    real G6_2_0_9_1_1_5_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][5]*g12*g00;
    real G6_2_0_9_1_1_6_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][6]*g12*g10;
    real G6_2_0_9_1_1_7_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][7]*g12*g20;
    real G6_2_0_9_1_1_8_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g12*g00;
    real G6_2_0_9_1_1_8_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g12*g10;
    real G6_2_0_9_1_1_8_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g12*g20;
    real G6_2_0_9_1_1_9_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][9]*g12*g00;
    real G6_2_0_9_1_1_10_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][10]*g12*g10;
    real G6_2_0_9_1_1_11_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][11]*g12*g20;
    real G6_2_0_9_1_2_0_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g12*g00;
    real G6_2_0_9_1_2_0_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g12*g10;
    real G6_2_0_9_1_2_0_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g12*g20;
    real G6_2_0_9_1_2_1_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][1]*g12*g00;
    real G6_2_0_9_1_2_2_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][2]*g12*g10;
    real G6_2_0_9_1_2_3_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][3]*g12*g20;
    real G6_2_0_9_1_2_4_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g12*g00;
    real G6_2_0_9_1_2_4_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g12*g10;
    real G6_2_0_9_1_2_4_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g12*g20;
    real G6_2_0_9_1_2_5_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][5]*g12*g00;
    real G6_2_0_9_1_2_6_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][6]*g12*g10;
    real G6_2_0_9_1_2_7_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][7]*g12*g20;
    real G6_2_0_9_1_2_8_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g12*g00;
    real G6_2_0_9_1_2_8_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g12*g10;
    real G6_2_0_9_1_2_8_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g12*g20;
    real G6_2_0_9_1_2_9_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][9]*g12*g00;
    real G6_2_0_9_1_2_10_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][10]*g12*g10;
    real G6_2_0_9_1_2_11_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][11]*g12*g20;
    real G6_2_0_9_1_3_0_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g12*g00;
    real G6_2_0_9_1_3_0_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g12*g10;
    real G6_2_0_9_1_3_0_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g12*g20;
    real G6_2_0_9_1_3_1_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][1]*g12*g00;
    real G6_2_0_9_1_3_2_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][2]*g12*g10;
    real G6_2_0_9_1_3_3_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][3]*g12*g20;
    real G6_2_0_9_1_3_4_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g12*g00;
    real G6_2_0_9_1_3_4_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g12*g10;
    real G6_2_0_9_1_3_4_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g12*g20;
    real G6_2_0_9_1_3_5_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][5]*g12*g00;
    real G6_2_0_9_1_3_6_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][6]*g12*g10;
    real G6_2_0_9_1_3_7_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][7]*g12*g20;
    real G6_2_0_9_1_3_8_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g12*g00;
    real G6_2_0_9_1_3_8_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g12*g10;
    real G6_2_0_9_1_3_8_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g12*g20;
    real G6_2_0_9_1_3_9_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][9]*g12*g00;
    real G6_2_0_9_1_3_10_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][10]*g12*g10;
    real G6_2_0_9_1_3_11_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][11]*g12*g20;
    real G6_2_0_9_2_0_0_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g22*g00;
    real G6_2_0_9_2_0_0_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g22*g10;
    real G6_2_0_9_2_0_0_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][0]*g22*g20;
    real G6_2_0_9_2_0_1_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][1]*g22*g00;
    real G6_2_0_9_2_0_2_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][2]*g22*g10;
    real G6_2_0_9_2_0_3_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][3]*g22*g20;
    real G6_2_0_9_2_0_4_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g22*g00;
    real G6_2_0_9_2_0_4_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g22*g10;
    real G6_2_0_9_2_0_4_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][4]*g22*g20;
    real G6_2_0_9_2_0_5_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][5]*g22*g00;
    real G6_2_0_9_2_0_6_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][6]*g22*g10;
    real G6_2_0_9_2_0_7_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][7]*g22*g20;
    real G6_2_0_9_2_0_8_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g22*g00;
    real G6_2_0_9_2_0_8_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g22*g10;
    real G6_2_0_9_2_0_8_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][8]*g22*g20;
    real G6_2_0_9_2_0_9_0 = det*c1*c0*w[0][9]*w[0][0]*w[1][9]*g22*g00;
    real G6_2_0_9_2_0_10_1 = det*c1*c0*w[0][9]*w[0][0]*w[1][10]*g22*g10;
    real G6_2_0_9_2_0_11_2 = det*c1*c0*w[0][9]*w[0][0]*w[1][11]*g22*g20;
    real G6_2_0_9_2_1_0_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g22*g00;
    real G6_2_0_9_2_1_0_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g22*g10;
    real G6_2_0_9_2_1_0_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][0]*g22*g20;
    real G6_2_0_9_2_1_1_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][1]*g22*g00;
    real G6_2_0_9_2_1_2_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][2]*g22*g10;
    real G6_2_0_9_2_1_3_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][3]*g22*g20;
    real G6_2_0_9_2_1_4_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g22*g00;
    real G6_2_0_9_2_1_4_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g22*g10;
    real G6_2_0_9_2_1_4_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][4]*g22*g20;
    real G6_2_0_9_2_1_5_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][5]*g22*g00;
    real G6_2_0_9_2_1_6_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][6]*g22*g10;
    real G6_2_0_9_2_1_7_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][7]*g22*g20;
    real G6_2_0_9_2_1_8_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g22*g00;
    real G6_2_0_9_2_1_8_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g22*g10;
    real G6_2_0_9_2_1_8_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][8]*g22*g20;
    real G6_2_0_9_2_1_9_0 = det*c1*c0*w[0][9]*w[0][1]*w[1][9]*g22*g00;
    real G6_2_0_9_2_1_10_1 = det*c1*c0*w[0][9]*w[0][1]*w[1][10]*g22*g10;
    real G6_2_0_9_2_1_11_2 = det*c1*c0*w[0][9]*w[0][1]*w[1][11]*g22*g20;
    real G6_2_0_9_2_2_0_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g22*g00;
    real G6_2_0_9_2_2_0_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g22*g10;
    real G6_2_0_9_2_2_0_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][0]*g22*g20;
    real G6_2_0_9_2_2_1_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][1]*g22*g00;
    real G6_2_0_9_2_2_2_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][2]*g22*g10;
    real G6_2_0_9_2_2_3_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][3]*g22*g20;
    real G6_2_0_9_2_2_4_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g22*g00;
    real G6_2_0_9_2_2_4_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g22*g10;
    real G6_2_0_9_2_2_4_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][4]*g22*g20;
    real G6_2_0_9_2_2_5_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][5]*g22*g00;
    real G6_2_0_9_2_2_6_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][6]*g22*g10;
    real G6_2_0_9_2_2_7_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][7]*g22*g20;
    real G6_2_0_9_2_2_8_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g22*g00;
    real G6_2_0_9_2_2_8_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g22*g10;
    real G6_2_0_9_2_2_8_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][8]*g22*g20;
    real G6_2_0_9_2_2_9_0 = det*c1*c0*w[0][9]*w[0][2]*w[1][9]*g22*g00;
    real G6_2_0_9_2_2_10_1 = det*c1*c0*w[0][9]*w[0][2]*w[1][10]*g22*g10;
    real G6_2_0_9_2_2_11_2 = det*c1*c0*w[0][9]*w[0][2]*w[1][11]*g22*g20;
    real G6_2_0_9_2_3_0_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g22*g00;
    real G6_2_0_9_2_3_0_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g22*g10;
    real G6_2_0_9_2_3_0_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][0]*g22*g20;
    real G6_2_0_9_2_3_1_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][1]*g22*g00;
    real G6_2_0_9_2_3_2_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][2]*g22*g10;
    real G6_2_0_9_2_3_3_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][3]*g22*g20;
    real G6_2_0_9_2_3_4_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g22*g00;
    real G6_2_0_9_2_3_4_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g22*g10;
    real G6_2_0_9_2_3_4_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][4]*g22*g20;
    real G6_2_0_9_2_3_5_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][5]*g22*g00;
    real G6_2_0_9_2_3_6_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][6]*g22*g10;
    real G6_2_0_9_2_3_7_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][7]*g22*g20;
    real G6_2_0_9_2_3_8_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g22*g00;
    real G6_2_0_9_2_3_8_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g22*g10;
    real G6_2_0_9_2_3_8_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][8]*g22*g20;
    real G6_2_0_9_2_3_9_0 = det*c1*c0*w[0][9]*w[0][3]*w[1][9]*g22*g00;
    real G6_2_0_9_2_3_10_1 = det*c1*c0*w[0][9]*w[0][3]*w[1][10]*g22*g10;
    real G6_2_0_9_2_3_11_2 = det*c1*c0*w[0][9]*w[0][3]*w[1][11]*g22*g20;
    real G6_2_0_10_0_0_0_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g02*g00;
    real G6_2_0_10_0_0_0_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g02*g10;
    real G6_2_0_10_0_0_0_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g02*g20;
    real G6_2_0_10_0_0_1_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][1]*g02*g00;
    real G6_2_0_10_0_0_2_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][2]*g02*g10;
    real G6_2_0_10_0_0_3_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][3]*g02*g20;
    real G6_2_0_10_0_0_4_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g02*g00;
    real G6_2_0_10_0_0_4_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g02*g10;
    real G6_2_0_10_0_0_4_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g02*g20;
    real G6_2_0_10_0_0_5_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][5]*g02*g00;
    real G6_2_0_10_0_0_6_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][6]*g02*g10;
    real G6_2_0_10_0_0_7_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][7]*g02*g20;
    real G6_2_0_10_0_0_8_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g02*g00;
    real G6_2_0_10_0_0_8_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g02*g10;
    real G6_2_0_10_0_0_8_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g02*g20;
    real G6_2_0_10_0_0_9_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][9]*g02*g00;
    real G6_2_0_10_0_0_10_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][10]*g02*g10;
    real G6_2_0_10_0_0_11_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][11]*g02*g20;
    real G6_2_0_10_0_1_0_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g02*g00;
    real G6_2_0_10_0_1_0_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g02*g10;
    real G6_2_0_10_0_1_0_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g02*g20;
    real G6_2_0_10_0_1_1_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][1]*g02*g00;
    real G6_2_0_10_0_1_2_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][2]*g02*g10;
    real G6_2_0_10_0_1_3_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][3]*g02*g20;
    real G6_2_0_10_0_1_4_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g02*g00;
    real G6_2_0_10_0_1_4_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g02*g10;
    real G6_2_0_10_0_1_4_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g02*g20;
    real G6_2_0_10_0_1_5_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][5]*g02*g00;
    real G6_2_0_10_0_1_6_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][6]*g02*g10;
    real G6_2_0_10_0_1_7_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][7]*g02*g20;
    real G6_2_0_10_0_1_8_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g02*g00;
    real G6_2_0_10_0_1_8_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g02*g10;
    real G6_2_0_10_0_1_8_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g02*g20;
    real G6_2_0_10_0_1_9_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][9]*g02*g00;
    real G6_2_0_10_0_1_10_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][10]*g02*g10;
    real G6_2_0_10_0_1_11_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][11]*g02*g20;
    real G6_2_0_10_0_2_0_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g02*g00;
    real G6_2_0_10_0_2_0_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g02*g10;
    real G6_2_0_10_0_2_0_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g02*g20;
    real G6_2_0_10_0_2_1_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][1]*g02*g00;
    real G6_2_0_10_0_2_2_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][2]*g02*g10;
    real G6_2_0_10_0_2_3_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][3]*g02*g20;
    real G6_2_0_10_0_2_4_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g02*g00;
    real G6_2_0_10_0_2_4_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g02*g10;
    real G6_2_0_10_0_2_4_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g02*g20;
    real G6_2_0_10_0_2_5_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][5]*g02*g00;
    real G6_2_0_10_0_2_6_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][6]*g02*g10;
    real G6_2_0_10_0_2_7_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][7]*g02*g20;
    real G6_2_0_10_0_2_8_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g02*g00;
    real G6_2_0_10_0_2_8_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g02*g10;
    real G6_2_0_10_0_2_8_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g02*g20;
    real G6_2_0_10_0_2_9_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][9]*g02*g00;
    real G6_2_0_10_0_2_10_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][10]*g02*g10;
    real G6_2_0_10_0_2_11_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][11]*g02*g20;
    real G6_2_0_10_0_3_0_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g02*g00;
    real G6_2_0_10_0_3_0_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g02*g10;
    real G6_2_0_10_0_3_0_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g02*g20;
    real G6_2_0_10_0_3_1_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][1]*g02*g00;
    real G6_2_0_10_0_3_2_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][2]*g02*g10;
    real G6_2_0_10_0_3_3_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][3]*g02*g20;
    real G6_2_0_10_0_3_4_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g02*g00;
    real G6_2_0_10_0_3_4_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g02*g10;
    real G6_2_0_10_0_3_4_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g02*g20;
    real G6_2_0_10_0_3_5_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][5]*g02*g00;
    real G6_2_0_10_0_3_6_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][6]*g02*g10;
    real G6_2_0_10_0_3_7_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][7]*g02*g20;
    real G6_2_0_10_0_3_8_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g02*g00;
    real G6_2_0_10_0_3_8_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g02*g10;
    real G6_2_0_10_0_3_8_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g02*g20;
    real G6_2_0_10_0_3_9_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][9]*g02*g00;
    real G6_2_0_10_0_3_10_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][10]*g02*g10;
    real G6_2_0_10_0_3_11_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][11]*g02*g20;
    real G6_2_0_10_1_0_0_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g12*g00;
    real G6_2_0_10_1_0_0_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g12*g10;
    real G6_2_0_10_1_0_0_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g12*g20;
    real G6_2_0_10_1_0_1_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][1]*g12*g00;
    real G6_2_0_10_1_0_2_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][2]*g12*g10;
    real G6_2_0_10_1_0_3_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][3]*g12*g20;
    real G6_2_0_10_1_0_4_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g12*g00;
    real G6_2_0_10_1_0_4_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g12*g10;
    real G6_2_0_10_1_0_4_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g12*g20;
    real G6_2_0_10_1_0_5_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][5]*g12*g00;
    real G6_2_0_10_1_0_6_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][6]*g12*g10;
    real G6_2_0_10_1_0_7_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][7]*g12*g20;
    real G6_2_0_10_1_0_8_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g12*g00;
    real G6_2_0_10_1_0_8_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g12*g10;
    real G6_2_0_10_1_0_8_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g12*g20;
    real G6_2_0_10_1_0_9_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][9]*g12*g00;
    real G6_2_0_10_1_0_10_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][10]*g12*g10;
    real G6_2_0_10_1_0_11_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][11]*g12*g20;
    real G6_2_0_10_1_1_0_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g12*g00;
    real G6_2_0_10_1_1_0_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g12*g10;
    real G6_2_0_10_1_1_0_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g12*g20;
    real G6_2_0_10_1_1_1_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][1]*g12*g00;
    real G6_2_0_10_1_1_2_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][2]*g12*g10;
    real G6_2_0_10_1_1_3_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][3]*g12*g20;
    real G6_2_0_10_1_1_4_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g12*g00;
    real G6_2_0_10_1_1_4_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g12*g10;
    real G6_2_0_10_1_1_4_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g12*g20;
    real G6_2_0_10_1_1_5_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][5]*g12*g00;
    real G6_2_0_10_1_1_6_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][6]*g12*g10;
    real G6_2_0_10_1_1_7_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][7]*g12*g20;
    real G6_2_0_10_1_1_8_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g12*g00;
    real G6_2_0_10_1_1_8_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g12*g10;
    real G6_2_0_10_1_1_8_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g12*g20;
    real G6_2_0_10_1_1_9_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][9]*g12*g00;
    real G6_2_0_10_1_1_10_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][10]*g12*g10;
    real G6_2_0_10_1_1_11_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][11]*g12*g20;
    real G6_2_0_10_1_2_0_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g12*g00;
    real G6_2_0_10_1_2_0_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g12*g10;
    real G6_2_0_10_1_2_0_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g12*g20;
    real G6_2_0_10_1_2_1_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][1]*g12*g00;
    real G6_2_0_10_1_2_2_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][2]*g12*g10;
    real G6_2_0_10_1_2_3_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][3]*g12*g20;
    real G6_2_0_10_1_2_4_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g12*g00;
    real G6_2_0_10_1_2_4_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g12*g10;
    real G6_2_0_10_1_2_4_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g12*g20;
    real G6_2_0_10_1_2_5_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][5]*g12*g00;
    real G6_2_0_10_1_2_6_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][6]*g12*g10;
    real G6_2_0_10_1_2_7_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][7]*g12*g20;
    real G6_2_0_10_1_2_8_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g12*g00;
    real G6_2_0_10_1_2_8_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g12*g10;
    real G6_2_0_10_1_2_8_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g12*g20;
    real G6_2_0_10_1_2_9_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][9]*g12*g00;
    real G6_2_0_10_1_2_10_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][10]*g12*g10;
    real G6_2_0_10_1_2_11_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][11]*g12*g20;
    real G6_2_0_10_1_3_0_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g12*g00;
    real G6_2_0_10_1_3_0_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g12*g10;
    real G6_2_0_10_1_3_0_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g12*g20;
    real G6_2_0_10_1_3_1_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][1]*g12*g00;
    real G6_2_0_10_1_3_2_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][2]*g12*g10;
    real G6_2_0_10_1_3_3_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][3]*g12*g20;
    real G6_2_0_10_1_3_4_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g12*g00;
    real G6_2_0_10_1_3_4_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g12*g10;
    real G6_2_0_10_1_3_4_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g12*g20;
    real G6_2_0_10_1_3_5_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][5]*g12*g00;
    real G6_2_0_10_1_3_6_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][6]*g12*g10;
    real G6_2_0_10_1_3_7_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][7]*g12*g20;
    real G6_2_0_10_1_3_8_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g12*g00;
    real G6_2_0_10_1_3_8_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g12*g10;
    real G6_2_0_10_1_3_8_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g12*g20;
    real G6_2_0_10_1_3_9_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][9]*g12*g00;
    real G6_2_0_10_1_3_10_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][10]*g12*g10;
    real G6_2_0_10_1_3_11_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][11]*g12*g20;
    real G6_2_0_10_2_0_0_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g22*g00;
    real G6_2_0_10_2_0_0_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g22*g10;
    real G6_2_0_10_2_0_0_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][0]*g22*g20;
    real G6_2_0_10_2_0_1_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][1]*g22*g00;
    real G6_2_0_10_2_0_2_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][2]*g22*g10;
    real G6_2_0_10_2_0_3_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][3]*g22*g20;
    real G6_2_0_10_2_0_4_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g22*g00;
    real G6_2_0_10_2_0_4_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g22*g10;
    real G6_2_0_10_2_0_4_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][4]*g22*g20;
    real G6_2_0_10_2_0_5_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][5]*g22*g00;
    real G6_2_0_10_2_0_6_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][6]*g22*g10;
    real G6_2_0_10_2_0_7_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][7]*g22*g20;
    real G6_2_0_10_2_0_8_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g22*g00;
    real G6_2_0_10_2_0_8_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g22*g10;
    real G6_2_0_10_2_0_8_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][8]*g22*g20;
    real G6_2_0_10_2_0_9_0 = det*c1*c0*w[0][10]*w[0][0]*w[1][9]*g22*g00;
    real G6_2_0_10_2_0_10_1 = det*c1*c0*w[0][10]*w[0][0]*w[1][10]*g22*g10;
    real G6_2_0_10_2_0_11_2 = det*c1*c0*w[0][10]*w[0][0]*w[1][11]*g22*g20;
    real G6_2_0_10_2_1_0_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g22*g00;
    real G6_2_0_10_2_1_0_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g22*g10;
    real G6_2_0_10_2_1_0_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][0]*g22*g20;
    real G6_2_0_10_2_1_1_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][1]*g22*g00;
    real G6_2_0_10_2_1_2_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][2]*g22*g10;
    real G6_2_0_10_2_1_3_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][3]*g22*g20;
    real G6_2_0_10_2_1_4_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g22*g00;
    real G6_2_0_10_2_1_4_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g22*g10;
    real G6_2_0_10_2_1_4_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][4]*g22*g20;
    real G6_2_0_10_2_1_5_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][5]*g22*g00;
    real G6_2_0_10_2_1_6_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][6]*g22*g10;
    real G6_2_0_10_2_1_7_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][7]*g22*g20;
    real G6_2_0_10_2_1_8_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g22*g00;
    real G6_2_0_10_2_1_8_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g22*g10;
    real G6_2_0_10_2_1_8_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][8]*g22*g20;
    real G6_2_0_10_2_1_9_0 = det*c1*c0*w[0][10]*w[0][1]*w[1][9]*g22*g00;
    real G6_2_0_10_2_1_10_1 = det*c1*c0*w[0][10]*w[0][1]*w[1][10]*g22*g10;
    real G6_2_0_10_2_1_11_2 = det*c1*c0*w[0][10]*w[0][1]*w[1][11]*g22*g20;
    real G6_2_0_10_2_2_0_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g22*g00;
    real G6_2_0_10_2_2_0_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g22*g10;
    real G6_2_0_10_2_2_0_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][0]*g22*g20;
    real G6_2_0_10_2_2_1_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][1]*g22*g00;
    real G6_2_0_10_2_2_2_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][2]*g22*g10;
    real G6_2_0_10_2_2_3_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][3]*g22*g20;
    real G6_2_0_10_2_2_4_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g22*g00;
    real G6_2_0_10_2_2_4_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g22*g10;
    real G6_2_0_10_2_2_4_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][4]*g22*g20;
    real G6_2_0_10_2_2_5_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][5]*g22*g00;
    real G6_2_0_10_2_2_6_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][6]*g22*g10;
    real G6_2_0_10_2_2_7_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][7]*g22*g20;
    real G6_2_0_10_2_2_8_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g22*g00;
    real G6_2_0_10_2_2_8_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g22*g10;
    real G6_2_0_10_2_2_8_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][8]*g22*g20;
    real G6_2_0_10_2_2_9_0 = det*c1*c0*w[0][10]*w[0][2]*w[1][9]*g22*g00;
    real G6_2_0_10_2_2_10_1 = det*c1*c0*w[0][10]*w[0][2]*w[1][10]*g22*g10;
    real G6_2_0_10_2_2_11_2 = det*c1*c0*w[0][10]*w[0][2]*w[1][11]*g22*g20;
    real G6_2_0_10_2_3_0_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g22*g00;
    real G6_2_0_10_2_3_0_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g22*g10;
    real G6_2_0_10_2_3_0_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][0]*g22*g20;
    real G6_2_0_10_2_3_1_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][1]*g22*g00;
    real G6_2_0_10_2_3_2_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][2]*g22*g10;
    real G6_2_0_10_2_3_3_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][3]*g22*g20;
    real G6_2_0_10_2_3_4_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g22*g00;
    real G6_2_0_10_2_3_4_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g22*g10;
    real G6_2_0_10_2_3_4_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][4]*g22*g20;
    real G6_2_0_10_2_3_5_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][5]*g22*g00;
    real G6_2_0_10_2_3_6_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][6]*g22*g10;
    real G6_2_0_10_2_3_7_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][7]*g22*g20;
    real G6_2_0_10_2_3_8_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g22*g00;
    real G6_2_0_10_2_3_8_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g22*g10;
    real G6_2_0_10_2_3_8_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][8]*g22*g20;
    real G6_2_0_10_2_3_9_0 = det*c1*c0*w[0][10]*w[0][3]*w[1][9]*g22*g00;
    real G6_2_0_10_2_3_10_1 = det*c1*c0*w[0][10]*w[0][3]*w[1][10]*g22*g10;
    real G6_2_0_10_2_3_11_2 = det*c1*c0*w[0][10]*w[0][3]*w[1][11]*g22*g20;
    real G6_2_0_11_0_0_0_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g02*g00;
    real G6_2_0_11_0_0_0_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g02*g10;
    real G6_2_0_11_0_0_0_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g02*g20;
    real G6_2_0_11_0_0_1_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][1]*g02*g00;
    real G6_2_0_11_0_0_2_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][2]*g02*g10;
    real G6_2_0_11_0_0_3_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][3]*g02*g20;
    real G6_2_0_11_0_0_4_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g02*g00;
    real G6_2_0_11_0_0_4_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g02*g10;
    real G6_2_0_11_0_0_4_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g02*g20;
    real G6_2_0_11_0_0_5_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][5]*g02*g00;
    real G6_2_0_11_0_0_6_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][6]*g02*g10;
    real G6_2_0_11_0_0_7_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][7]*g02*g20;
    real G6_2_0_11_0_0_8_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g02*g00;
    real G6_2_0_11_0_0_8_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g02*g10;
    real G6_2_0_11_0_0_8_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g02*g20;
    real G6_2_0_11_0_0_9_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][9]*g02*g00;
    real G6_2_0_11_0_0_10_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][10]*g02*g10;
    real G6_2_0_11_0_0_11_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][11]*g02*g20;
    real G6_2_0_11_0_1_0_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g02*g00;
    real G6_2_0_11_0_1_0_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g02*g10;
    real G6_2_0_11_0_1_0_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g02*g20;
    real G6_2_0_11_0_1_1_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][1]*g02*g00;
    real G6_2_0_11_0_1_2_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][2]*g02*g10;
    real G6_2_0_11_0_1_3_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][3]*g02*g20;
    real G6_2_0_11_0_1_4_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g02*g00;
    real G6_2_0_11_0_1_4_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g02*g10;
    real G6_2_0_11_0_1_4_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g02*g20;
    real G6_2_0_11_0_1_5_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][5]*g02*g00;
    real G6_2_0_11_0_1_6_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][6]*g02*g10;
    real G6_2_0_11_0_1_7_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][7]*g02*g20;
    real G6_2_0_11_0_1_8_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g02*g00;
    real G6_2_0_11_0_1_8_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g02*g10;
    real G6_2_0_11_0_1_8_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g02*g20;
    real G6_2_0_11_0_1_9_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][9]*g02*g00;
    real G6_2_0_11_0_1_10_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][10]*g02*g10;
    real G6_2_0_11_0_1_11_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][11]*g02*g20;
    real G6_2_0_11_0_2_0_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g02*g00;
    real G6_2_0_11_0_2_0_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g02*g10;
    real G6_2_0_11_0_2_0_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g02*g20;
    real G6_2_0_11_0_2_1_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][1]*g02*g00;
    real G6_2_0_11_0_2_2_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][2]*g02*g10;
    real G6_2_0_11_0_2_3_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][3]*g02*g20;
    real G6_2_0_11_0_2_4_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g02*g00;
    real G6_2_0_11_0_2_4_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g02*g10;
    real G6_2_0_11_0_2_4_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g02*g20;
    real G6_2_0_11_0_2_5_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][5]*g02*g00;
    real G6_2_0_11_0_2_6_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][6]*g02*g10;
    real G6_2_0_11_0_2_7_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][7]*g02*g20;
    real G6_2_0_11_0_2_8_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g02*g00;
    real G6_2_0_11_0_2_8_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g02*g10;
    real G6_2_0_11_0_2_8_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g02*g20;
    real G6_2_0_11_0_2_9_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][9]*g02*g00;
    real G6_2_0_11_0_2_10_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][10]*g02*g10;
    real G6_2_0_11_0_2_11_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][11]*g02*g20;
    real G6_2_0_11_0_3_0_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g02*g00;
    real G6_2_0_11_0_3_0_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g02*g10;
    real G6_2_0_11_0_3_0_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g02*g20;
    real G6_2_0_11_0_3_1_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][1]*g02*g00;
    real G6_2_0_11_0_3_2_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][2]*g02*g10;
    real G6_2_0_11_0_3_3_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][3]*g02*g20;
    real G6_2_0_11_0_3_4_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g02*g00;
    real G6_2_0_11_0_3_4_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g02*g10;
    real G6_2_0_11_0_3_4_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g02*g20;
    real G6_2_0_11_0_3_5_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][5]*g02*g00;
    real G6_2_0_11_0_3_6_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][6]*g02*g10;
    real G6_2_0_11_0_3_7_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][7]*g02*g20;
    real G6_2_0_11_0_3_8_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g02*g00;
    real G6_2_0_11_0_3_8_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g02*g10;
    real G6_2_0_11_0_3_8_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g02*g20;
    real G6_2_0_11_0_3_9_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][9]*g02*g00;
    real G6_2_0_11_0_3_10_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][10]*g02*g10;
    real G6_2_0_11_0_3_11_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][11]*g02*g20;
    real G6_2_0_11_1_0_0_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g12*g00;
    real G6_2_0_11_1_0_0_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g12*g10;
    real G6_2_0_11_1_0_0_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g12*g20;
    real G6_2_0_11_1_0_1_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][1]*g12*g00;
    real G6_2_0_11_1_0_2_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][2]*g12*g10;
    real G6_2_0_11_1_0_3_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][3]*g12*g20;
    real G6_2_0_11_1_0_4_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g12*g00;
    real G6_2_0_11_1_0_4_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g12*g10;
    real G6_2_0_11_1_0_4_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g12*g20;
    real G6_2_0_11_1_0_5_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][5]*g12*g00;
    real G6_2_0_11_1_0_6_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][6]*g12*g10;
    real G6_2_0_11_1_0_7_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][7]*g12*g20;
    real G6_2_0_11_1_0_8_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g12*g00;
    real G6_2_0_11_1_0_8_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g12*g10;
    real G6_2_0_11_1_0_8_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g12*g20;
    real G6_2_0_11_1_0_9_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][9]*g12*g00;
    real G6_2_0_11_1_0_10_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][10]*g12*g10;
    real G6_2_0_11_1_0_11_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][11]*g12*g20;
    real G6_2_0_11_1_1_0_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g12*g00;
    real G6_2_0_11_1_1_0_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g12*g10;
    real G6_2_0_11_1_1_0_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g12*g20;
    real G6_2_0_11_1_1_1_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][1]*g12*g00;
    real G6_2_0_11_1_1_2_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][2]*g12*g10;
    real G6_2_0_11_1_1_3_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][3]*g12*g20;
    real G6_2_0_11_1_1_4_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g12*g00;
    real G6_2_0_11_1_1_4_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g12*g10;
    real G6_2_0_11_1_1_4_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g12*g20;
    real G6_2_0_11_1_1_5_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][5]*g12*g00;
    real G6_2_0_11_1_1_6_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][6]*g12*g10;
    real G6_2_0_11_1_1_7_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][7]*g12*g20;
    real G6_2_0_11_1_1_8_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g12*g00;
    real G6_2_0_11_1_1_8_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g12*g10;
    real G6_2_0_11_1_1_8_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g12*g20;
    real G6_2_0_11_1_1_9_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][9]*g12*g00;
    real G6_2_0_11_1_1_10_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][10]*g12*g10;
    real G6_2_0_11_1_1_11_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][11]*g12*g20;
    real G6_2_0_11_1_2_0_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g12*g00;
    real G6_2_0_11_1_2_0_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g12*g10;
    real G6_2_0_11_1_2_0_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g12*g20;
    real G6_2_0_11_1_2_1_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][1]*g12*g00;
    real G6_2_0_11_1_2_2_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][2]*g12*g10;
    real G6_2_0_11_1_2_3_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][3]*g12*g20;
    real G6_2_0_11_1_2_4_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g12*g00;
    real G6_2_0_11_1_2_4_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g12*g10;
    real G6_2_0_11_1_2_4_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g12*g20;
    real G6_2_0_11_1_2_5_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][5]*g12*g00;
    real G6_2_0_11_1_2_6_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][6]*g12*g10;
    real G6_2_0_11_1_2_7_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][7]*g12*g20;
    real G6_2_0_11_1_2_8_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g12*g00;
    real G6_2_0_11_1_2_8_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g12*g10;
    real G6_2_0_11_1_2_8_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g12*g20;
    real G6_2_0_11_1_2_9_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][9]*g12*g00;
    real G6_2_0_11_1_2_10_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][10]*g12*g10;
    real G6_2_0_11_1_2_11_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][11]*g12*g20;
    real G6_2_0_11_1_3_0_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g12*g00;
    real G6_2_0_11_1_3_0_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g12*g10;
    real G6_2_0_11_1_3_0_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g12*g20;
    real G6_2_0_11_1_3_1_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][1]*g12*g00;
    real G6_2_0_11_1_3_2_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][2]*g12*g10;
    real G6_2_0_11_1_3_3_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][3]*g12*g20;
    real G6_2_0_11_1_3_4_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g12*g00;
    real G6_2_0_11_1_3_4_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g12*g10;
    real G6_2_0_11_1_3_4_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g12*g20;
    real G6_2_0_11_1_3_5_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][5]*g12*g00;
    real G6_2_0_11_1_3_6_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][6]*g12*g10;
    real G6_2_0_11_1_3_7_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][7]*g12*g20;
    real G6_2_0_11_1_3_8_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g12*g00;
    real G6_2_0_11_1_3_8_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g12*g10;
    real G6_2_0_11_1_3_8_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g12*g20;
    real G6_2_0_11_1_3_9_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][9]*g12*g00;
    real G6_2_0_11_1_3_10_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][10]*g12*g10;
    real G6_2_0_11_1_3_11_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][11]*g12*g20;
    real G6_2_0_11_2_0_0_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g22*g00;
    real G6_2_0_11_2_0_0_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g22*g10;
    real G6_2_0_11_2_0_0_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][0]*g22*g20;
    real G6_2_0_11_2_0_1_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][1]*g22*g00;
    real G6_2_0_11_2_0_2_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][2]*g22*g10;
    real G6_2_0_11_2_0_3_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][3]*g22*g20;
    real G6_2_0_11_2_0_4_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g22*g00;
    real G6_2_0_11_2_0_4_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g22*g10;
    real G6_2_0_11_2_0_4_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][4]*g22*g20;
    real G6_2_0_11_2_0_5_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][5]*g22*g00;
    real G6_2_0_11_2_0_6_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][6]*g22*g10;
    real G6_2_0_11_2_0_7_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][7]*g22*g20;
    real G6_2_0_11_2_0_8_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g22*g00;
    real G6_2_0_11_2_0_8_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g22*g10;
    real G6_2_0_11_2_0_8_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][8]*g22*g20;
    real G6_2_0_11_2_0_9_0 = det*c1*c0*w[0][11]*w[0][0]*w[1][9]*g22*g00;
    real G6_2_0_11_2_0_10_1 = det*c1*c0*w[0][11]*w[0][0]*w[1][10]*g22*g10;
    real G6_2_0_11_2_0_11_2 = det*c1*c0*w[0][11]*w[0][0]*w[1][11]*g22*g20;
    real G6_2_0_11_2_1_0_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g22*g00;
    real G6_2_0_11_2_1_0_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g22*g10;
    real G6_2_0_11_2_1_0_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][0]*g22*g20;
    real G6_2_0_11_2_1_1_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][1]*g22*g00;
    real G6_2_0_11_2_1_2_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][2]*g22*g10;
    real G6_2_0_11_2_1_3_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][3]*g22*g20;
    real G6_2_0_11_2_1_4_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g22*g00;
    real G6_2_0_11_2_1_4_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g22*g10;
    real G6_2_0_11_2_1_4_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][4]*g22*g20;
    real G6_2_0_11_2_1_5_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][5]*g22*g00;
    real G6_2_0_11_2_1_6_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][6]*g22*g10;
    real G6_2_0_11_2_1_7_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][7]*g22*g20;
    real G6_2_0_11_2_1_8_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g22*g00;
    real G6_2_0_11_2_1_8_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g22*g10;
    real G6_2_0_11_2_1_8_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][8]*g22*g20;
    real G6_2_0_11_2_1_9_0 = det*c1*c0*w[0][11]*w[0][1]*w[1][9]*g22*g00;
    real G6_2_0_11_2_1_10_1 = det*c1*c0*w[0][11]*w[0][1]*w[1][10]*g22*g10;
    real G6_2_0_11_2_1_11_2 = det*c1*c0*w[0][11]*w[0][1]*w[1][11]*g22*g20;
    real G6_2_0_11_2_2_0_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g22*g00;
    real G6_2_0_11_2_2_0_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g22*g10;
    real G6_2_0_11_2_2_0_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][0]*g22*g20;
    real G6_2_0_11_2_2_1_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][1]*g22*g00;
    real G6_2_0_11_2_2_2_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][2]*g22*g10;
    real G6_2_0_11_2_2_3_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][3]*g22*g20;
    real G6_2_0_11_2_2_4_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g22*g00;
    real G6_2_0_11_2_2_4_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g22*g10;
    real G6_2_0_11_2_2_4_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][4]*g22*g20;
    real G6_2_0_11_2_2_5_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][5]*g22*g00;
    real G6_2_0_11_2_2_6_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][6]*g22*g10;
    real G6_2_0_11_2_2_7_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][7]*g22*g20;
    real G6_2_0_11_2_2_8_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g22*g00;
    real G6_2_0_11_2_2_8_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g22*g10;
    real G6_2_0_11_2_2_8_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][8]*g22*g20;
    real G6_2_0_11_2_2_9_0 = det*c1*c0*w[0][11]*w[0][2]*w[1][9]*g22*g00;
    real G6_2_0_11_2_2_10_1 = det*c1*c0*w[0][11]*w[0][2]*w[1][10]*g22*g10;
    real G6_2_0_11_2_2_11_2 = det*c1*c0*w[0][11]*w[0][2]*w[1][11]*g22*g20;
    real G6_2_0_11_2_3_0_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g22*g00;
    real G6_2_0_11_2_3_0_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g22*g10;
    real G6_2_0_11_2_3_0_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][0]*g22*g20;
    real G6_2_0_11_2_3_1_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][1]*g22*g00;
    real G6_2_0_11_2_3_2_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][2]*g22*g10;
    real G6_2_0_11_2_3_3_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][3]*g22*g20;
    real G6_2_0_11_2_3_4_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g22*g00;
    real G6_2_0_11_2_3_4_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g22*g10;
    real G6_2_0_11_2_3_4_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][4]*g22*g20;
    real G6_2_0_11_2_3_5_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][5]*g22*g00;
    real G6_2_0_11_2_3_6_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][6]*g22*g10;
    real G6_2_0_11_2_3_7_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][7]*g22*g20;
    real G6_2_0_11_2_3_8_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g22*g00;
    real G6_2_0_11_2_3_8_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g22*g10;
    real G6_2_0_11_2_3_8_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][8]*g22*g20;
    real G6_2_0_11_2_3_9_0 = det*c1*c0*w[0][11]*w[0][3]*w[1][9]*g22*g00;
    real G6_2_0_11_2_3_10_1 = det*c1*c0*w[0][11]*w[0][3]*w[1][10]*g22*g10;
    real G6_2_0_11_2_3_11_2 = det*c1*c0*w[0][11]*w[0][3]*w[1][11]*g22*g20;
    real G6_2_1_8_0_4_0_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g02*g01;
    real G6_2_1_8_0_4_0_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g02*g11;
    real G6_2_1_8_0_4_0_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g02*g21;
    real G6_2_1_8_0_4_1_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][1]*g02*g01;
    real G6_2_1_8_0_4_2_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][2]*g02*g11;
    real G6_2_1_8_0_4_3_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][3]*g02*g21;
    real G6_2_1_8_0_4_4_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g02*g01;
    real G6_2_1_8_0_4_4_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g02*g11;
    real G6_2_1_8_0_4_4_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g02*g21;
    real G6_2_1_8_0_4_5_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][5]*g02*g01;
    real G6_2_1_8_0_4_6_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][6]*g02*g11;
    real G6_2_1_8_0_4_7_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][7]*g02*g21;
    real G6_2_1_8_0_4_8_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g02*g01;
    real G6_2_1_8_0_4_8_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g02*g11;
    real G6_2_1_8_0_4_8_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g02*g21;
    real G6_2_1_8_0_4_9_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][9]*g02*g01;
    real G6_2_1_8_0_4_10_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][10]*g02*g11;
    real G6_2_1_8_0_4_11_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][11]*g02*g21;
    real G6_2_1_8_0_5_0_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g02*g01;
    real G6_2_1_8_0_5_0_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g02*g11;
    real G6_2_1_8_0_5_0_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g02*g21;
    real G6_2_1_8_0_5_1_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][1]*g02*g01;
    real G6_2_1_8_0_5_2_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][2]*g02*g11;
    real G6_2_1_8_0_5_3_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][3]*g02*g21;
    real G6_2_1_8_0_5_4_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g02*g01;
    real G6_2_1_8_0_5_4_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g02*g11;
    real G6_2_1_8_0_5_4_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g02*g21;
    real G6_2_1_8_0_5_5_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][5]*g02*g01;
    real G6_2_1_8_0_5_6_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][6]*g02*g11;
    real G6_2_1_8_0_5_7_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][7]*g02*g21;
    real G6_2_1_8_0_5_8_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g02*g01;
    real G6_2_1_8_0_5_8_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g02*g11;
    real G6_2_1_8_0_5_8_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g02*g21;
    real G6_2_1_8_0_5_9_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][9]*g02*g01;
    real G6_2_1_8_0_5_10_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][10]*g02*g11;
    real G6_2_1_8_0_5_11_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][11]*g02*g21;
    real G6_2_1_8_0_6_0_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g02*g01;
    real G6_2_1_8_0_6_0_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g02*g11;
    real G6_2_1_8_0_6_0_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g02*g21;
    real G6_2_1_8_0_6_1_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][1]*g02*g01;
    real G6_2_1_8_0_6_2_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][2]*g02*g11;
    real G6_2_1_8_0_6_3_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][3]*g02*g21;
    real G6_2_1_8_0_6_4_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g02*g01;
    real G6_2_1_8_0_6_4_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g02*g11;
    real G6_2_1_8_0_6_4_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g02*g21;
    real G6_2_1_8_0_6_5_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][5]*g02*g01;
    real G6_2_1_8_0_6_6_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][6]*g02*g11;
    real G6_2_1_8_0_6_7_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][7]*g02*g21;
    real G6_2_1_8_0_6_8_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g02*g01;
    real G6_2_1_8_0_6_8_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g02*g11;
    real G6_2_1_8_0_6_8_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g02*g21;
    real G6_2_1_8_0_6_9_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][9]*g02*g01;
    real G6_2_1_8_0_6_10_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][10]*g02*g11;
    real G6_2_1_8_0_6_11_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][11]*g02*g21;
    real G6_2_1_8_0_7_0_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g02*g01;
    real G6_2_1_8_0_7_0_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g02*g11;
    real G6_2_1_8_0_7_0_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g02*g21;
    real G6_2_1_8_0_7_1_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][1]*g02*g01;
    real G6_2_1_8_0_7_2_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][2]*g02*g11;
    real G6_2_1_8_0_7_3_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][3]*g02*g21;
    real G6_2_1_8_0_7_4_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g02*g01;
    real G6_2_1_8_0_7_4_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g02*g11;
    real G6_2_1_8_0_7_4_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g02*g21;
    real G6_2_1_8_0_7_5_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][5]*g02*g01;
    real G6_2_1_8_0_7_6_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][6]*g02*g11;
    real G6_2_1_8_0_7_7_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][7]*g02*g21;
    real G6_2_1_8_0_7_8_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g02*g01;
    real G6_2_1_8_0_7_8_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g02*g11;
    real G6_2_1_8_0_7_8_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g02*g21;
    real G6_2_1_8_0_7_9_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][9]*g02*g01;
    real G6_2_1_8_0_7_10_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][10]*g02*g11;
    real G6_2_1_8_0_7_11_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][11]*g02*g21;
    real G6_2_1_8_1_4_0_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g12*g01;
    real G6_2_1_8_1_4_0_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g12*g11;
    real G6_2_1_8_1_4_0_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g12*g21;
    real G6_2_1_8_1_4_1_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][1]*g12*g01;
    real G6_2_1_8_1_4_2_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][2]*g12*g11;
    real G6_2_1_8_1_4_3_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][3]*g12*g21;
    real G6_2_1_8_1_4_4_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g12*g01;
    real G6_2_1_8_1_4_4_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g12*g11;
    real G6_2_1_8_1_4_4_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g12*g21;
    real G6_2_1_8_1_4_5_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][5]*g12*g01;
    real G6_2_1_8_1_4_6_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][6]*g12*g11;
    real G6_2_1_8_1_4_7_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][7]*g12*g21;
    real G6_2_1_8_1_4_8_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g12*g01;
    real G6_2_1_8_1_4_8_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g12*g11;
    real G6_2_1_8_1_4_8_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g12*g21;
    real G6_2_1_8_1_4_9_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][9]*g12*g01;
    real G6_2_1_8_1_4_10_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][10]*g12*g11;
    real G6_2_1_8_1_4_11_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][11]*g12*g21;
    real G6_2_1_8_1_5_0_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g12*g01;
    real G6_2_1_8_1_5_0_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g12*g11;
    real G6_2_1_8_1_5_0_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g12*g21;
    real G6_2_1_8_1_5_1_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][1]*g12*g01;
    real G6_2_1_8_1_5_2_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][2]*g12*g11;
    real G6_2_1_8_1_5_3_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][3]*g12*g21;
    real G6_2_1_8_1_5_4_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g12*g01;
    real G6_2_1_8_1_5_4_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g12*g11;
    real G6_2_1_8_1_5_4_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g12*g21;
    real G6_2_1_8_1_5_5_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][5]*g12*g01;
    real G6_2_1_8_1_5_6_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][6]*g12*g11;
    real G6_2_1_8_1_5_7_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][7]*g12*g21;
    real G6_2_1_8_1_5_8_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g12*g01;
    real G6_2_1_8_1_5_8_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g12*g11;
    real G6_2_1_8_1_5_8_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g12*g21;
    real G6_2_1_8_1_5_9_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][9]*g12*g01;
    real G6_2_1_8_1_5_10_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][10]*g12*g11;
    real G6_2_1_8_1_5_11_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][11]*g12*g21;
    real G6_2_1_8_1_6_0_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g12*g01;
    real G6_2_1_8_1_6_0_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g12*g11;
    real G6_2_1_8_1_6_0_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g12*g21;
    real G6_2_1_8_1_6_1_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][1]*g12*g01;
    real G6_2_1_8_1_6_2_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][2]*g12*g11;
    real G6_2_1_8_1_6_3_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][3]*g12*g21;
    real G6_2_1_8_1_6_4_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g12*g01;
    real G6_2_1_8_1_6_4_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g12*g11;
    real G6_2_1_8_1_6_4_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g12*g21;
    real G6_2_1_8_1_6_5_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][5]*g12*g01;
    real G6_2_1_8_1_6_6_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][6]*g12*g11;
    real G6_2_1_8_1_6_7_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][7]*g12*g21;
    real G6_2_1_8_1_6_8_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g12*g01;
    real G6_2_1_8_1_6_8_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g12*g11;
    real G6_2_1_8_1_6_8_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g12*g21;
    real G6_2_1_8_1_6_9_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][9]*g12*g01;
    real G6_2_1_8_1_6_10_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][10]*g12*g11;
    real G6_2_1_8_1_6_11_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][11]*g12*g21;
    real G6_2_1_8_1_7_0_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g12*g01;
    real G6_2_1_8_1_7_0_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g12*g11;
    real G6_2_1_8_1_7_0_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g12*g21;
    real G6_2_1_8_1_7_1_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][1]*g12*g01;
    real G6_2_1_8_1_7_2_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][2]*g12*g11;
    real G6_2_1_8_1_7_3_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][3]*g12*g21;
    real G6_2_1_8_1_7_4_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g12*g01;
    real G6_2_1_8_1_7_4_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g12*g11;
    real G6_2_1_8_1_7_4_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g12*g21;
    real G6_2_1_8_1_7_5_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][5]*g12*g01;
    real G6_2_1_8_1_7_6_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][6]*g12*g11;
    real G6_2_1_8_1_7_7_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][7]*g12*g21;
    real G6_2_1_8_1_7_8_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g12*g01;
    real G6_2_1_8_1_7_8_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g12*g11;
    real G6_2_1_8_1_7_8_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g12*g21;
    real G6_2_1_8_1_7_9_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][9]*g12*g01;
    real G6_2_1_8_1_7_10_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][10]*g12*g11;
    real G6_2_1_8_1_7_11_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][11]*g12*g21;
    real G6_2_1_8_2_4_0_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g22*g01;
    real G6_2_1_8_2_4_0_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g22*g11;
    real G6_2_1_8_2_4_0_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][0]*g22*g21;
    real G6_2_1_8_2_4_1_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][1]*g22*g01;
    real G6_2_1_8_2_4_2_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][2]*g22*g11;
    real G6_2_1_8_2_4_3_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][3]*g22*g21;
    real G6_2_1_8_2_4_4_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g22*g01;
    real G6_2_1_8_2_4_4_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g22*g11;
    real G6_2_1_8_2_4_4_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][4]*g22*g21;
    real G6_2_1_8_2_4_5_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][5]*g22*g01;
    real G6_2_1_8_2_4_6_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][6]*g22*g11;
    real G6_2_1_8_2_4_7_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][7]*g22*g21;
    real G6_2_1_8_2_4_8_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g22*g01;
    real G6_2_1_8_2_4_8_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g22*g11;
    real G6_2_1_8_2_4_8_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][8]*g22*g21;
    real G6_2_1_8_2_4_9_0 = det*c1*c0*w[0][8]*w[0][4]*w[1][9]*g22*g01;
    real G6_2_1_8_2_4_10_1 = det*c1*c0*w[0][8]*w[0][4]*w[1][10]*g22*g11;
    real G6_2_1_8_2_4_11_2 = det*c1*c0*w[0][8]*w[0][4]*w[1][11]*g22*g21;
    real G6_2_1_8_2_5_0_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g22*g01;
    real G6_2_1_8_2_5_0_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g22*g11;
    real G6_2_1_8_2_5_0_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][0]*g22*g21;
    real G6_2_1_8_2_5_1_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][1]*g22*g01;
    real G6_2_1_8_2_5_2_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][2]*g22*g11;
    real G6_2_1_8_2_5_3_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][3]*g22*g21;
    real G6_2_1_8_2_5_4_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g22*g01;
    real G6_2_1_8_2_5_4_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g22*g11;
    real G6_2_1_8_2_5_4_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][4]*g22*g21;
    real G6_2_1_8_2_5_5_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][5]*g22*g01;
    real G6_2_1_8_2_5_6_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][6]*g22*g11;
    real G6_2_1_8_2_5_7_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][7]*g22*g21;
    real G6_2_1_8_2_5_8_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g22*g01;
    real G6_2_1_8_2_5_8_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g22*g11;
    real G6_2_1_8_2_5_8_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][8]*g22*g21;
    real G6_2_1_8_2_5_9_0 = det*c1*c0*w[0][8]*w[0][5]*w[1][9]*g22*g01;
    real G6_2_1_8_2_5_10_1 = det*c1*c0*w[0][8]*w[0][5]*w[1][10]*g22*g11;
    real G6_2_1_8_2_5_11_2 = det*c1*c0*w[0][8]*w[0][5]*w[1][11]*g22*g21;
    real G6_2_1_8_2_6_0_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g22*g01;
    real G6_2_1_8_2_6_0_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g22*g11;
    real G6_2_1_8_2_6_0_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][0]*g22*g21;
    real G6_2_1_8_2_6_1_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][1]*g22*g01;
    real G6_2_1_8_2_6_2_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][2]*g22*g11;
    real G6_2_1_8_2_6_3_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][3]*g22*g21;
    real G6_2_1_8_2_6_4_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g22*g01;
    real G6_2_1_8_2_6_4_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g22*g11;
    real G6_2_1_8_2_6_4_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][4]*g22*g21;
    real G6_2_1_8_2_6_5_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][5]*g22*g01;
    real G6_2_1_8_2_6_6_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][6]*g22*g11;
    real G6_2_1_8_2_6_7_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][7]*g22*g21;
    real G6_2_1_8_2_6_8_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g22*g01;
    real G6_2_1_8_2_6_8_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g22*g11;
    real G6_2_1_8_2_6_8_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][8]*g22*g21;
    real G6_2_1_8_2_6_9_0 = det*c1*c0*w[0][8]*w[0][6]*w[1][9]*g22*g01;
    real G6_2_1_8_2_6_10_1 = det*c1*c0*w[0][8]*w[0][6]*w[1][10]*g22*g11;
    real G6_2_1_8_2_6_11_2 = det*c1*c0*w[0][8]*w[0][6]*w[1][11]*g22*g21;
    real G6_2_1_8_2_7_0_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g22*g01;
    real G6_2_1_8_2_7_0_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g22*g11;
    real G6_2_1_8_2_7_0_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][0]*g22*g21;
    real G6_2_1_8_2_7_1_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][1]*g22*g01;
    real G6_2_1_8_2_7_2_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][2]*g22*g11;
    real G6_2_1_8_2_7_3_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][3]*g22*g21;
    real G6_2_1_8_2_7_4_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g22*g01;
    real G6_2_1_8_2_7_4_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g22*g11;
    real G6_2_1_8_2_7_4_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][4]*g22*g21;
    real G6_2_1_8_2_7_5_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][5]*g22*g01;
    real G6_2_1_8_2_7_6_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][6]*g22*g11;
    real G6_2_1_8_2_7_7_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][7]*g22*g21;
    real G6_2_1_8_2_7_8_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g22*g01;
    real G6_2_1_8_2_7_8_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g22*g11;
    real G6_2_1_8_2_7_8_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][8]*g22*g21;
    real G6_2_1_8_2_7_9_0 = det*c1*c0*w[0][8]*w[0][7]*w[1][9]*g22*g01;
    real G6_2_1_8_2_7_10_1 = det*c1*c0*w[0][8]*w[0][7]*w[1][10]*g22*g11;
    real G6_2_1_8_2_7_11_2 = det*c1*c0*w[0][8]*w[0][7]*w[1][11]*g22*g21;
    real G6_2_1_9_0_4_0_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g02*g01;
    real G6_2_1_9_0_4_0_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g02*g11;
    real G6_2_1_9_0_4_0_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g02*g21;
    real G6_2_1_9_0_4_1_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][1]*g02*g01;
    real G6_2_1_9_0_4_2_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][2]*g02*g11;
    real G6_2_1_9_0_4_3_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][3]*g02*g21;
    real G6_2_1_9_0_4_4_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g02*g01;
    real G6_2_1_9_0_4_4_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g02*g11;
    real G6_2_1_9_0_4_4_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g02*g21;
    real G6_2_1_9_0_4_5_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][5]*g02*g01;
    real G6_2_1_9_0_4_6_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][6]*g02*g11;
    real G6_2_1_9_0_4_7_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][7]*g02*g21;
    real G6_2_1_9_0_4_8_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g02*g01;
    real G6_2_1_9_0_4_8_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g02*g11;
    real G6_2_1_9_0_4_8_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g02*g21;
    real G6_2_1_9_0_4_9_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][9]*g02*g01;
    real G6_2_1_9_0_4_10_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][10]*g02*g11;
    real G6_2_1_9_0_4_11_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][11]*g02*g21;
    real G6_2_1_9_0_5_0_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g02*g01;
    real G6_2_1_9_0_5_0_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g02*g11;
    real G6_2_1_9_0_5_0_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g02*g21;
    real G6_2_1_9_0_5_1_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][1]*g02*g01;
    real G6_2_1_9_0_5_2_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][2]*g02*g11;
    real G6_2_1_9_0_5_3_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][3]*g02*g21;
    real G6_2_1_9_0_5_4_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g02*g01;
    real G6_2_1_9_0_5_4_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g02*g11;
    real G6_2_1_9_0_5_4_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g02*g21;
    real G6_2_1_9_0_5_5_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][5]*g02*g01;
    real G6_2_1_9_0_5_6_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][6]*g02*g11;
    real G6_2_1_9_0_5_7_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][7]*g02*g21;
    real G6_2_1_9_0_5_8_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g02*g01;
    real G6_2_1_9_0_5_8_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g02*g11;
    real G6_2_1_9_0_5_8_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g02*g21;
    real G6_2_1_9_0_5_9_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][9]*g02*g01;
    real G6_2_1_9_0_5_10_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][10]*g02*g11;
    real G6_2_1_9_0_5_11_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][11]*g02*g21;
    real G6_2_1_9_0_6_0_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g02*g01;
    real G6_2_1_9_0_6_0_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g02*g11;
    real G6_2_1_9_0_6_0_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g02*g21;
    real G6_2_1_9_0_6_1_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][1]*g02*g01;
    real G6_2_1_9_0_6_2_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][2]*g02*g11;
    real G6_2_1_9_0_6_3_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][3]*g02*g21;
    real G6_2_1_9_0_6_4_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g02*g01;
    real G6_2_1_9_0_6_4_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g02*g11;
    real G6_2_1_9_0_6_4_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g02*g21;
    real G6_2_1_9_0_6_5_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][5]*g02*g01;
    real G6_2_1_9_0_6_6_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][6]*g02*g11;
    real G6_2_1_9_0_6_7_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][7]*g02*g21;
    real G6_2_1_9_0_6_8_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g02*g01;
    real G6_2_1_9_0_6_8_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g02*g11;
    real G6_2_1_9_0_6_8_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g02*g21;
    real G6_2_1_9_0_6_9_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][9]*g02*g01;
    real G6_2_1_9_0_6_10_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][10]*g02*g11;
    real G6_2_1_9_0_6_11_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][11]*g02*g21;
    real G6_2_1_9_0_7_0_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g02*g01;
    real G6_2_1_9_0_7_0_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g02*g11;
    real G6_2_1_9_0_7_0_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g02*g21;
    real G6_2_1_9_0_7_1_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][1]*g02*g01;
    real G6_2_1_9_0_7_2_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][2]*g02*g11;
    real G6_2_1_9_0_7_3_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][3]*g02*g21;
    real G6_2_1_9_0_7_4_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g02*g01;
    real G6_2_1_9_0_7_4_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g02*g11;
    real G6_2_1_9_0_7_4_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g02*g21;
    real G6_2_1_9_0_7_5_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][5]*g02*g01;
    real G6_2_1_9_0_7_6_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][6]*g02*g11;
    real G6_2_1_9_0_7_7_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][7]*g02*g21;
    real G6_2_1_9_0_7_8_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g02*g01;
    real G6_2_1_9_0_7_8_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g02*g11;
    real G6_2_1_9_0_7_8_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g02*g21;
    real G6_2_1_9_0_7_9_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][9]*g02*g01;
    real G6_2_1_9_0_7_10_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][10]*g02*g11;
    real G6_2_1_9_0_7_11_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][11]*g02*g21;
    real G6_2_1_9_1_4_0_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g12*g01;
    real G6_2_1_9_1_4_0_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g12*g11;
    real G6_2_1_9_1_4_0_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g12*g21;
    real G6_2_1_9_1_4_1_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][1]*g12*g01;
    real G6_2_1_9_1_4_2_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][2]*g12*g11;
    real G6_2_1_9_1_4_3_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][3]*g12*g21;
    real G6_2_1_9_1_4_4_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g12*g01;
    real G6_2_1_9_1_4_4_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g12*g11;
    real G6_2_1_9_1_4_4_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g12*g21;
    real G6_2_1_9_1_4_5_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][5]*g12*g01;
    real G6_2_1_9_1_4_6_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][6]*g12*g11;
    real G6_2_1_9_1_4_7_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][7]*g12*g21;
    real G6_2_1_9_1_4_8_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g12*g01;
    real G6_2_1_9_1_4_8_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g12*g11;
    real G6_2_1_9_1_4_8_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g12*g21;
    real G6_2_1_9_1_4_9_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][9]*g12*g01;
    real G6_2_1_9_1_4_10_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][10]*g12*g11;
    real G6_2_1_9_1_4_11_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][11]*g12*g21;
    real G6_2_1_9_1_5_0_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g12*g01;
    real G6_2_1_9_1_5_0_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g12*g11;
    real G6_2_1_9_1_5_0_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g12*g21;
    real G6_2_1_9_1_5_1_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][1]*g12*g01;
    real G6_2_1_9_1_5_2_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][2]*g12*g11;
    real G6_2_1_9_1_5_3_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][3]*g12*g21;
    real G6_2_1_9_1_5_4_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g12*g01;
    real G6_2_1_9_1_5_4_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g12*g11;
    real G6_2_1_9_1_5_4_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g12*g21;
    real G6_2_1_9_1_5_5_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][5]*g12*g01;
    real G6_2_1_9_1_5_6_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][6]*g12*g11;
    real G6_2_1_9_1_5_7_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][7]*g12*g21;
    real G6_2_1_9_1_5_8_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g12*g01;
    real G6_2_1_9_1_5_8_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g12*g11;
    real G6_2_1_9_1_5_8_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g12*g21;
    real G6_2_1_9_1_5_9_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][9]*g12*g01;
    real G6_2_1_9_1_5_10_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][10]*g12*g11;
    real G6_2_1_9_1_5_11_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][11]*g12*g21;
    real G6_2_1_9_1_6_0_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g12*g01;
    real G6_2_1_9_1_6_0_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g12*g11;
    real G6_2_1_9_1_6_0_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g12*g21;
    real G6_2_1_9_1_6_1_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][1]*g12*g01;
    real G6_2_1_9_1_6_2_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][2]*g12*g11;
    real G6_2_1_9_1_6_3_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][3]*g12*g21;
    real G6_2_1_9_1_6_4_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g12*g01;
    real G6_2_1_9_1_6_4_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g12*g11;
    real G6_2_1_9_1_6_4_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g12*g21;
    real G6_2_1_9_1_6_5_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][5]*g12*g01;
    real G6_2_1_9_1_6_6_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][6]*g12*g11;
    real G6_2_1_9_1_6_7_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][7]*g12*g21;
    real G6_2_1_9_1_6_8_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g12*g01;
    real G6_2_1_9_1_6_8_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g12*g11;
    real G6_2_1_9_1_6_8_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g12*g21;
    real G6_2_1_9_1_6_9_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][9]*g12*g01;
    real G6_2_1_9_1_6_10_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][10]*g12*g11;
    real G6_2_1_9_1_6_11_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][11]*g12*g21;
    real G6_2_1_9_1_7_0_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g12*g01;
    real G6_2_1_9_1_7_0_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g12*g11;
    real G6_2_1_9_1_7_0_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g12*g21;
    real G6_2_1_9_1_7_1_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][1]*g12*g01;
    real G6_2_1_9_1_7_2_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][2]*g12*g11;
    real G6_2_1_9_1_7_3_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][3]*g12*g21;
    real G6_2_1_9_1_7_4_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g12*g01;
    real G6_2_1_9_1_7_4_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g12*g11;
    real G6_2_1_9_1_7_4_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g12*g21;
    real G6_2_1_9_1_7_5_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][5]*g12*g01;
    real G6_2_1_9_1_7_6_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][6]*g12*g11;
    real G6_2_1_9_1_7_7_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][7]*g12*g21;
    real G6_2_1_9_1_7_8_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g12*g01;
    real G6_2_1_9_1_7_8_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g12*g11;
    real G6_2_1_9_1_7_8_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g12*g21;
    real G6_2_1_9_1_7_9_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][9]*g12*g01;
    real G6_2_1_9_1_7_10_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][10]*g12*g11;
    real G6_2_1_9_1_7_11_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][11]*g12*g21;
    real G6_2_1_9_2_4_0_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g22*g01;
    real G6_2_1_9_2_4_0_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g22*g11;
    real G6_2_1_9_2_4_0_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][0]*g22*g21;
    real G6_2_1_9_2_4_1_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][1]*g22*g01;
    real G6_2_1_9_2_4_2_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][2]*g22*g11;
    real G6_2_1_9_2_4_3_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][3]*g22*g21;
    real G6_2_1_9_2_4_4_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g22*g01;
    real G6_2_1_9_2_4_4_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g22*g11;
    real G6_2_1_9_2_4_4_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][4]*g22*g21;
    real G6_2_1_9_2_4_5_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][5]*g22*g01;
    real G6_2_1_9_2_4_6_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][6]*g22*g11;
    real G6_2_1_9_2_4_7_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][7]*g22*g21;
    real G6_2_1_9_2_4_8_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g22*g01;
    real G6_2_1_9_2_4_8_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g22*g11;
    real G6_2_1_9_2_4_8_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][8]*g22*g21;
    real G6_2_1_9_2_4_9_0 = det*c1*c0*w[0][9]*w[0][4]*w[1][9]*g22*g01;
    real G6_2_1_9_2_4_10_1 = det*c1*c0*w[0][9]*w[0][4]*w[1][10]*g22*g11;
    real G6_2_1_9_2_4_11_2 = det*c1*c0*w[0][9]*w[0][4]*w[1][11]*g22*g21;
    real G6_2_1_9_2_5_0_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g22*g01;
    real G6_2_1_9_2_5_0_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g22*g11;
    real G6_2_1_9_2_5_0_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][0]*g22*g21;
    real G6_2_1_9_2_5_1_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][1]*g22*g01;
    real G6_2_1_9_2_5_2_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][2]*g22*g11;
    real G6_2_1_9_2_5_3_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][3]*g22*g21;
    real G6_2_1_9_2_5_4_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g22*g01;
    real G6_2_1_9_2_5_4_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g22*g11;
    real G6_2_1_9_2_5_4_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][4]*g22*g21;
    real G6_2_1_9_2_5_5_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][5]*g22*g01;
    real G6_2_1_9_2_5_6_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][6]*g22*g11;
    real G6_2_1_9_2_5_7_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][7]*g22*g21;
    real G6_2_1_9_2_5_8_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g22*g01;
    real G6_2_1_9_2_5_8_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g22*g11;
    real G6_2_1_9_2_5_8_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][8]*g22*g21;
    real G6_2_1_9_2_5_9_0 = det*c1*c0*w[0][9]*w[0][5]*w[1][9]*g22*g01;
    real G6_2_1_9_2_5_10_1 = det*c1*c0*w[0][9]*w[0][5]*w[1][10]*g22*g11;
    real G6_2_1_9_2_5_11_2 = det*c1*c0*w[0][9]*w[0][5]*w[1][11]*g22*g21;
    real G6_2_1_9_2_6_0_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g22*g01;
    real G6_2_1_9_2_6_0_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g22*g11;
    real G6_2_1_9_2_6_0_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][0]*g22*g21;
    real G6_2_1_9_2_6_1_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][1]*g22*g01;
    real G6_2_1_9_2_6_2_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][2]*g22*g11;
    real G6_2_1_9_2_6_3_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][3]*g22*g21;
    real G6_2_1_9_2_6_4_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g22*g01;
    real G6_2_1_9_2_6_4_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g22*g11;
    real G6_2_1_9_2_6_4_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][4]*g22*g21;
    real G6_2_1_9_2_6_5_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][5]*g22*g01;
    real G6_2_1_9_2_6_6_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][6]*g22*g11;
    real G6_2_1_9_2_6_7_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][7]*g22*g21;
    real G6_2_1_9_2_6_8_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g22*g01;
    real G6_2_1_9_2_6_8_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g22*g11;
    real G6_2_1_9_2_6_8_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][8]*g22*g21;
    real G6_2_1_9_2_6_9_0 = det*c1*c0*w[0][9]*w[0][6]*w[1][9]*g22*g01;
    real G6_2_1_9_2_6_10_1 = det*c1*c0*w[0][9]*w[0][6]*w[1][10]*g22*g11;
    real G6_2_1_9_2_6_11_2 = det*c1*c0*w[0][9]*w[0][6]*w[1][11]*g22*g21;
    real G6_2_1_9_2_7_0_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g22*g01;
    real G6_2_1_9_2_7_0_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g22*g11;
    real G6_2_1_9_2_7_0_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][0]*g22*g21;
    real G6_2_1_9_2_7_1_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][1]*g22*g01;
    real G6_2_1_9_2_7_2_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][2]*g22*g11;
    real G6_2_1_9_2_7_3_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][3]*g22*g21;
    real G6_2_1_9_2_7_4_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g22*g01;
    real G6_2_1_9_2_7_4_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g22*g11;
    real G6_2_1_9_2_7_4_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][4]*g22*g21;
    real G6_2_1_9_2_7_5_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][5]*g22*g01;
    real G6_2_1_9_2_7_6_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][6]*g22*g11;
    real G6_2_1_9_2_7_7_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][7]*g22*g21;
    real G6_2_1_9_2_7_8_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g22*g01;
    real G6_2_1_9_2_7_8_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g22*g11;
    real G6_2_1_9_2_7_8_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][8]*g22*g21;
    real G6_2_1_9_2_7_9_0 = det*c1*c0*w[0][9]*w[0][7]*w[1][9]*g22*g01;
    real G6_2_1_9_2_7_10_1 = det*c1*c0*w[0][9]*w[0][7]*w[1][10]*g22*g11;
    real G6_2_1_9_2_7_11_2 = det*c1*c0*w[0][9]*w[0][7]*w[1][11]*g22*g21;
    real G6_2_1_10_0_4_0_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g02*g01;
    real G6_2_1_10_0_4_0_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g02*g11;
    real G6_2_1_10_0_4_0_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g02*g21;
    real G6_2_1_10_0_4_1_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][1]*g02*g01;
    real G6_2_1_10_0_4_2_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][2]*g02*g11;
    real G6_2_1_10_0_4_3_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][3]*g02*g21;
    real G6_2_1_10_0_4_4_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g02*g01;
    real G6_2_1_10_0_4_4_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g02*g11;
    real G6_2_1_10_0_4_4_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g02*g21;
    real G6_2_1_10_0_4_5_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][5]*g02*g01;
    real G6_2_1_10_0_4_6_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][6]*g02*g11;
    real G6_2_1_10_0_4_7_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][7]*g02*g21;
    real G6_2_1_10_0_4_8_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g02*g01;
    real G6_2_1_10_0_4_8_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g02*g11;
    real G6_2_1_10_0_4_8_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g02*g21;
    real G6_2_1_10_0_4_9_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][9]*g02*g01;
    real G6_2_1_10_0_4_10_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][10]*g02*g11;
    real G6_2_1_10_0_4_11_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][11]*g02*g21;
    real G6_2_1_10_0_5_0_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g02*g01;
    real G6_2_1_10_0_5_0_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g02*g11;
    real G6_2_1_10_0_5_0_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g02*g21;
    real G6_2_1_10_0_5_1_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][1]*g02*g01;
    real G6_2_1_10_0_5_2_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][2]*g02*g11;
    real G6_2_1_10_0_5_3_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][3]*g02*g21;
    real G6_2_1_10_0_5_4_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g02*g01;
    real G6_2_1_10_0_5_4_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g02*g11;
    real G6_2_1_10_0_5_4_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g02*g21;
    real G6_2_1_10_0_5_5_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][5]*g02*g01;
    real G6_2_1_10_0_5_6_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][6]*g02*g11;
    real G6_2_1_10_0_5_7_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][7]*g02*g21;
    real G6_2_1_10_0_5_8_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g02*g01;
    real G6_2_1_10_0_5_8_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g02*g11;
    real G6_2_1_10_0_5_8_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g02*g21;
    real G6_2_1_10_0_5_9_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][9]*g02*g01;
    real G6_2_1_10_0_5_10_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][10]*g02*g11;
    real G6_2_1_10_0_5_11_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][11]*g02*g21;
    real G6_2_1_10_0_6_0_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g02*g01;
    real G6_2_1_10_0_6_0_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g02*g11;
    real G6_2_1_10_0_6_0_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g02*g21;
    real G6_2_1_10_0_6_1_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][1]*g02*g01;
    real G6_2_1_10_0_6_2_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][2]*g02*g11;
    real G6_2_1_10_0_6_3_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][3]*g02*g21;
    real G6_2_1_10_0_6_4_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g02*g01;
    real G6_2_1_10_0_6_4_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g02*g11;
    real G6_2_1_10_0_6_4_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g02*g21;
    real G6_2_1_10_0_6_5_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][5]*g02*g01;
    real G6_2_1_10_0_6_6_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][6]*g02*g11;
    real G6_2_1_10_0_6_7_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][7]*g02*g21;
    real G6_2_1_10_0_6_8_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g02*g01;
    real G6_2_1_10_0_6_8_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g02*g11;
    real G6_2_1_10_0_6_8_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g02*g21;
    real G6_2_1_10_0_6_9_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][9]*g02*g01;
    real G6_2_1_10_0_6_10_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][10]*g02*g11;
    real G6_2_1_10_0_6_11_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][11]*g02*g21;
    real G6_2_1_10_0_7_0_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g02*g01;
    real G6_2_1_10_0_7_0_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g02*g11;
    real G6_2_1_10_0_7_0_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g02*g21;
    real G6_2_1_10_0_7_1_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][1]*g02*g01;
    real G6_2_1_10_0_7_2_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][2]*g02*g11;
    real G6_2_1_10_0_7_3_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][3]*g02*g21;
    real G6_2_1_10_0_7_4_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g02*g01;
    real G6_2_1_10_0_7_4_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g02*g11;
    real G6_2_1_10_0_7_4_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g02*g21;
    real G6_2_1_10_0_7_5_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][5]*g02*g01;
    real G6_2_1_10_0_7_6_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][6]*g02*g11;
    real G6_2_1_10_0_7_7_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][7]*g02*g21;
    real G6_2_1_10_0_7_8_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g02*g01;
    real G6_2_1_10_0_7_8_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g02*g11;
    real G6_2_1_10_0_7_8_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g02*g21;
    real G6_2_1_10_0_7_9_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][9]*g02*g01;
    real G6_2_1_10_0_7_10_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][10]*g02*g11;
    real G6_2_1_10_0_7_11_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][11]*g02*g21;
    real G6_2_1_10_1_4_0_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g12*g01;
    real G6_2_1_10_1_4_0_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g12*g11;
    real G6_2_1_10_1_4_0_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g12*g21;
    real G6_2_1_10_1_4_1_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][1]*g12*g01;
    real G6_2_1_10_1_4_2_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][2]*g12*g11;
    real G6_2_1_10_1_4_3_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][3]*g12*g21;
    real G6_2_1_10_1_4_4_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g12*g01;
    real G6_2_1_10_1_4_4_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g12*g11;
    real G6_2_1_10_1_4_4_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g12*g21;
    real G6_2_1_10_1_4_5_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][5]*g12*g01;
    real G6_2_1_10_1_4_6_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][6]*g12*g11;
    real G6_2_1_10_1_4_7_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][7]*g12*g21;
    real G6_2_1_10_1_4_8_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g12*g01;
    real G6_2_1_10_1_4_8_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g12*g11;
    real G6_2_1_10_1_4_8_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g12*g21;
    real G6_2_1_10_1_4_9_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][9]*g12*g01;
    real G6_2_1_10_1_4_10_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][10]*g12*g11;
    real G6_2_1_10_1_4_11_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][11]*g12*g21;
    real G6_2_1_10_1_5_0_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g12*g01;
    real G6_2_1_10_1_5_0_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g12*g11;
    real G6_2_1_10_1_5_0_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g12*g21;
    real G6_2_1_10_1_5_1_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][1]*g12*g01;
    real G6_2_1_10_1_5_2_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][2]*g12*g11;
    real G6_2_1_10_1_5_3_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][3]*g12*g21;
    real G6_2_1_10_1_5_4_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g12*g01;
    real G6_2_1_10_1_5_4_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g12*g11;
    real G6_2_1_10_1_5_4_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g12*g21;
    real G6_2_1_10_1_5_5_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][5]*g12*g01;
    real G6_2_1_10_1_5_6_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][6]*g12*g11;
    real G6_2_1_10_1_5_7_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][7]*g12*g21;
    real G6_2_1_10_1_5_8_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g12*g01;
    real G6_2_1_10_1_5_8_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g12*g11;
    real G6_2_1_10_1_5_8_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g12*g21;
    real G6_2_1_10_1_5_9_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][9]*g12*g01;
    real G6_2_1_10_1_5_10_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][10]*g12*g11;
    real G6_2_1_10_1_5_11_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][11]*g12*g21;
    real G6_2_1_10_1_6_0_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g12*g01;
    real G6_2_1_10_1_6_0_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g12*g11;
    real G6_2_1_10_1_6_0_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g12*g21;
    real G6_2_1_10_1_6_1_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][1]*g12*g01;
    real G6_2_1_10_1_6_2_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][2]*g12*g11;
    real G6_2_1_10_1_6_3_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][3]*g12*g21;
    real G6_2_1_10_1_6_4_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g12*g01;
    real G6_2_1_10_1_6_4_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g12*g11;
    real G6_2_1_10_1_6_4_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g12*g21;
    real G6_2_1_10_1_6_5_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][5]*g12*g01;
    real G6_2_1_10_1_6_6_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][6]*g12*g11;
    real G6_2_1_10_1_6_7_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][7]*g12*g21;
    real G6_2_1_10_1_6_8_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g12*g01;
    real G6_2_1_10_1_6_8_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g12*g11;
    real G6_2_1_10_1_6_8_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g12*g21;
    real G6_2_1_10_1_6_9_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][9]*g12*g01;
    real G6_2_1_10_1_6_10_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][10]*g12*g11;
    real G6_2_1_10_1_6_11_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][11]*g12*g21;
    real G6_2_1_10_1_7_0_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g12*g01;
    real G6_2_1_10_1_7_0_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g12*g11;
    real G6_2_1_10_1_7_0_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g12*g21;
    real G6_2_1_10_1_7_1_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][1]*g12*g01;
    real G6_2_1_10_1_7_2_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][2]*g12*g11;
    real G6_2_1_10_1_7_3_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][3]*g12*g21;
    real G6_2_1_10_1_7_4_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g12*g01;
    real G6_2_1_10_1_7_4_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g12*g11;
    real G6_2_1_10_1_7_4_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g12*g21;
    real G6_2_1_10_1_7_5_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][5]*g12*g01;
    real G6_2_1_10_1_7_6_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][6]*g12*g11;
    real G6_2_1_10_1_7_7_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][7]*g12*g21;
    real G6_2_1_10_1_7_8_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g12*g01;
    real G6_2_1_10_1_7_8_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g12*g11;
    real G6_2_1_10_1_7_8_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g12*g21;
    real G6_2_1_10_1_7_9_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][9]*g12*g01;
    real G6_2_1_10_1_7_10_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][10]*g12*g11;
    real G6_2_1_10_1_7_11_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][11]*g12*g21;
    real G6_2_1_10_2_4_0_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g22*g01;
    real G6_2_1_10_2_4_0_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g22*g11;
    real G6_2_1_10_2_4_0_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][0]*g22*g21;
    real G6_2_1_10_2_4_1_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][1]*g22*g01;
    real G6_2_1_10_2_4_2_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][2]*g22*g11;
    real G6_2_1_10_2_4_3_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][3]*g22*g21;
    real G6_2_1_10_2_4_4_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g22*g01;
    real G6_2_1_10_2_4_4_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g22*g11;
    real G6_2_1_10_2_4_4_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][4]*g22*g21;
    real G6_2_1_10_2_4_5_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][5]*g22*g01;
    real G6_2_1_10_2_4_6_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][6]*g22*g11;
    real G6_2_1_10_2_4_7_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][7]*g22*g21;
    real G6_2_1_10_2_4_8_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g22*g01;
    real G6_2_1_10_2_4_8_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g22*g11;
    real G6_2_1_10_2_4_8_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][8]*g22*g21;
    real G6_2_1_10_2_4_9_0 = det*c1*c0*w[0][10]*w[0][4]*w[1][9]*g22*g01;
    real G6_2_1_10_2_4_10_1 = det*c1*c0*w[0][10]*w[0][4]*w[1][10]*g22*g11;
    real G6_2_1_10_2_4_11_2 = det*c1*c0*w[0][10]*w[0][4]*w[1][11]*g22*g21;
    real G6_2_1_10_2_5_0_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g22*g01;
    real G6_2_1_10_2_5_0_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g22*g11;
    real G6_2_1_10_2_5_0_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][0]*g22*g21;
    real G6_2_1_10_2_5_1_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][1]*g22*g01;
    real G6_2_1_10_2_5_2_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][2]*g22*g11;
    real G6_2_1_10_2_5_3_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][3]*g22*g21;
    real G6_2_1_10_2_5_4_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g22*g01;
    real G6_2_1_10_2_5_4_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g22*g11;
    real G6_2_1_10_2_5_4_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][4]*g22*g21;
    real G6_2_1_10_2_5_5_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][5]*g22*g01;
    real G6_2_1_10_2_5_6_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][6]*g22*g11;
    real G6_2_1_10_2_5_7_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][7]*g22*g21;
    real G6_2_1_10_2_5_8_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g22*g01;
    real G6_2_1_10_2_5_8_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g22*g11;
    real G6_2_1_10_2_5_8_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][8]*g22*g21;
    real G6_2_1_10_2_5_9_0 = det*c1*c0*w[0][10]*w[0][5]*w[1][9]*g22*g01;
    real G6_2_1_10_2_5_10_1 = det*c1*c0*w[0][10]*w[0][5]*w[1][10]*g22*g11;
    real G6_2_1_10_2_5_11_2 = det*c1*c0*w[0][10]*w[0][5]*w[1][11]*g22*g21;
    real G6_2_1_10_2_6_0_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g22*g01;
    real G6_2_1_10_2_6_0_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g22*g11;
    real G6_2_1_10_2_6_0_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][0]*g22*g21;
    real G6_2_1_10_2_6_1_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][1]*g22*g01;
    real G6_2_1_10_2_6_2_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][2]*g22*g11;
    real G6_2_1_10_2_6_3_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][3]*g22*g21;
    real G6_2_1_10_2_6_4_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g22*g01;
    real G6_2_1_10_2_6_4_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g22*g11;
    real G6_2_1_10_2_6_4_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][4]*g22*g21;
    real G6_2_1_10_2_6_5_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][5]*g22*g01;
    real G6_2_1_10_2_6_6_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][6]*g22*g11;
    real G6_2_1_10_2_6_7_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][7]*g22*g21;
    real G6_2_1_10_2_6_8_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g22*g01;
    real G6_2_1_10_2_6_8_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g22*g11;
    real G6_2_1_10_2_6_8_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][8]*g22*g21;
    real G6_2_1_10_2_6_9_0 = det*c1*c0*w[0][10]*w[0][6]*w[1][9]*g22*g01;
    real G6_2_1_10_2_6_10_1 = det*c1*c0*w[0][10]*w[0][6]*w[1][10]*g22*g11;
    real G6_2_1_10_2_6_11_2 = det*c1*c0*w[0][10]*w[0][6]*w[1][11]*g22*g21;
    real G6_2_1_10_2_7_0_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g22*g01;
    real G6_2_1_10_2_7_0_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g22*g11;
    real G6_2_1_10_2_7_0_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][0]*g22*g21;
    real G6_2_1_10_2_7_1_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][1]*g22*g01;
    real G6_2_1_10_2_7_2_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][2]*g22*g11;
    real G6_2_1_10_2_7_3_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][3]*g22*g21;
    real G6_2_1_10_2_7_4_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g22*g01;
    real G6_2_1_10_2_7_4_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g22*g11;
    real G6_2_1_10_2_7_4_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][4]*g22*g21;
    real G6_2_1_10_2_7_5_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][5]*g22*g01;
    real G6_2_1_10_2_7_6_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][6]*g22*g11;
    real G6_2_1_10_2_7_7_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][7]*g22*g21;
    real G6_2_1_10_2_7_8_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g22*g01;
    real G6_2_1_10_2_7_8_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g22*g11;
    real G6_2_1_10_2_7_8_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][8]*g22*g21;
    real G6_2_1_10_2_7_9_0 = det*c1*c0*w[0][10]*w[0][7]*w[1][9]*g22*g01;
    real G6_2_1_10_2_7_10_1 = det*c1*c0*w[0][10]*w[0][7]*w[1][10]*g22*g11;
    real G6_2_1_10_2_7_11_2 = det*c1*c0*w[0][10]*w[0][7]*w[1][11]*g22*g21;
    real G6_2_1_11_0_4_0_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g02*g01;
    real G6_2_1_11_0_4_0_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g02*g11;
    real G6_2_1_11_0_4_0_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g02*g21;
    real G6_2_1_11_0_4_1_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][1]*g02*g01;
    real G6_2_1_11_0_4_2_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][2]*g02*g11;
    real G6_2_1_11_0_4_3_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][3]*g02*g21;
    real G6_2_1_11_0_4_4_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g02*g01;
    real G6_2_1_11_0_4_4_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g02*g11;
    real G6_2_1_11_0_4_4_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g02*g21;
    real G6_2_1_11_0_4_5_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][5]*g02*g01;
    real G6_2_1_11_0_4_6_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][6]*g02*g11;
    real G6_2_1_11_0_4_7_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][7]*g02*g21;
    real G6_2_1_11_0_4_8_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g02*g01;
    real G6_2_1_11_0_4_8_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g02*g11;
    real G6_2_1_11_0_4_8_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g02*g21;
    real G6_2_1_11_0_4_9_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][9]*g02*g01;
    real G6_2_1_11_0_4_10_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][10]*g02*g11;
    real G6_2_1_11_0_4_11_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][11]*g02*g21;
    real G6_2_1_11_0_5_0_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g02*g01;
    real G6_2_1_11_0_5_0_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g02*g11;
    real G6_2_1_11_0_5_0_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g02*g21;
    real G6_2_1_11_0_5_1_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][1]*g02*g01;
    real G6_2_1_11_0_5_2_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][2]*g02*g11;
    real G6_2_1_11_0_5_3_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][3]*g02*g21;
    real G6_2_1_11_0_5_4_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g02*g01;
    real G6_2_1_11_0_5_4_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g02*g11;
    real G6_2_1_11_0_5_4_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g02*g21;
    real G6_2_1_11_0_5_5_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][5]*g02*g01;
    real G6_2_1_11_0_5_6_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][6]*g02*g11;
    real G6_2_1_11_0_5_7_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][7]*g02*g21;
    real G6_2_1_11_0_5_8_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g02*g01;
    real G6_2_1_11_0_5_8_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g02*g11;
    real G6_2_1_11_0_5_8_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g02*g21;
    real G6_2_1_11_0_5_9_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][9]*g02*g01;
    real G6_2_1_11_0_5_10_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][10]*g02*g11;
    real G6_2_1_11_0_5_11_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][11]*g02*g21;
    real G6_2_1_11_0_6_0_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g02*g01;
    real G6_2_1_11_0_6_0_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g02*g11;
    real G6_2_1_11_0_6_0_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g02*g21;
    real G6_2_1_11_0_6_1_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][1]*g02*g01;
    real G6_2_1_11_0_6_2_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][2]*g02*g11;
    real G6_2_1_11_0_6_3_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][3]*g02*g21;
    real G6_2_1_11_0_6_4_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g02*g01;
    real G6_2_1_11_0_6_4_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g02*g11;
    real G6_2_1_11_0_6_4_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g02*g21;
    real G6_2_1_11_0_6_5_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][5]*g02*g01;
    real G6_2_1_11_0_6_6_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][6]*g02*g11;
    real G6_2_1_11_0_6_7_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][7]*g02*g21;
    real G6_2_1_11_0_6_8_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g02*g01;
    real G6_2_1_11_0_6_8_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g02*g11;
    real G6_2_1_11_0_6_8_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g02*g21;
    real G6_2_1_11_0_6_9_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][9]*g02*g01;
    real G6_2_1_11_0_6_10_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][10]*g02*g11;
    real G6_2_1_11_0_6_11_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][11]*g02*g21;
    real G6_2_1_11_0_7_0_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g02*g01;
    real G6_2_1_11_0_7_0_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g02*g11;
    real G6_2_1_11_0_7_0_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g02*g21;
    real G6_2_1_11_0_7_1_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][1]*g02*g01;
    real G6_2_1_11_0_7_2_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][2]*g02*g11;
    real G6_2_1_11_0_7_3_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][3]*g02*g21;
    real G6_2_1_11_0_7_4_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g02*g01;
    real G6_2_1_11_0_7_4_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g02*g11;
    real G6_2_1_11_0_7_4_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g02*g21;
    real G6_2_1_11_0_7_5_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][5]*g02*g01;
    real G6_2_1_11_0_7_6_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][6]*g02*g11;
    real G6_2_1_11_0_7_7_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][7]*g02*g21;
    real G6_2_1_11_0_7_8_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g02*g01;
    real G6_2_1_11_0_7_8_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g02*g11;
    real G6_2_1_11_0_7_8_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g02*g21;
    real G6_2_1_11_0_7_9_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][9]*g02*g01;
    real G6_2_1_11_0_7_10_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][10]*g02*g11;
    real G6_2_1_11_0_7_11_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][11]*g02*g21;
    real G6_2_1_11_1_4_0_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g12*g01;
    real G6_2_1_11_1_4_0_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g12*g11;
    real G6_2_1_11_1_4_0_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g12*g21;
    real G6_2_1_11_1_4_1_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][1]*g12*g01;
    real G6_2_1_11_1_4_2_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][2]*g12*g11;
    real G6_2_1_11_1_4_3_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][3]*g12*g21;
    real G6_2_1_11_1_4_4_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g12*g01;
    real G6_2_1_11_1_4_4_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g12*g11;
    real G6_2_1_11_1_4_4_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g12*g21;
    real G6_2_1_11_1_4_5_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][5]*g12*g01;
    real G6_2_1_11_1_4_6_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][6]*g12*g11;
    real G6_2_1_11_1_4_7_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][7]*g12*g21;
    real G6_2_1_11_1_4_8_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g12*g01;
    real G6_2_1_11_1_4_8_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g12*g11;
    real G6_2_1_11_1_4_8_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g12*g21;
    real G6_2_1_11_1_4_9_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][9]*g12*g01;
    real G6_2_1_11_1_4_10_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][10]*g12*g11;
    real G6_2_1_11_1_4_11_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][11]*g12*g21;
    real G6_2_1_11_1_5_0_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g12*g01;
    real G6_2_1_11_1_5_0_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g12*g11;
    real G6_2_1_11_1_5_0_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g12*g21;
    real G6_2_1_11_1_5_1_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][1]*g12*g01;
    real G6_2_1_11_1_5_2_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][2]*g12*g11;
    real G6_2_1_11_1_5_3_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][3]*g12*g21;
    real G6_2_1_11_1_5_4_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g12*g01;
    real G6_2_1_11_1_5_4_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g12*g11;
    real G6_2_1_11_1_5_4_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g12*g21;
    real G6_2_1_11_1_5_5_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][5]*g12*g01;
    real G6_2_1_11_1_5_6_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][6]*g12*g11;
    real G6_2_1_11_1_5_7_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][7]*g12*g21;
    real G6_2_1_11_1_5_8_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g12*g01;
    real G6_2_1_11_1_5_8_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g12*g11;
    real G6_2_1_11_1_5_8_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g12*g21;
    real G6_2_1_11_1_5_9_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][9]*g12*g01;
    real G6_2_1_11_1_5_10_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][10]*g12*g11;
    real G6_2_1_11_1_5_11_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][11]*g12*g21;
    real G6_2_1_11_1_6_0_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g12*g01;
    real G6_2_1_11_1_6_0_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g12*g11;
    real G6_2_1_11_1_6_0_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g12*g21;
    real G6_2_1_11_1_6_1_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][1]*g12*g01;
    real G6_2_1_11_1_6_2_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][2]*g12*g11;
    real G6_2_1_11_1_6_3_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][3]*g12*g21;
    real G6_2_1_11_1_6_4_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g12*g01;
    real G6_2_1_11_1_6_4_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g12*g11;
    real G6_2_1_11_1_6_4_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g12*g21;
    real G6_2_1_11_1_6_5_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][5]*g12*g01;
    real G6_2_1_11_1_6_6_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][6]*g12*g11;
    real G6_2_1_11_1_6_7_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][7]*g12*g21;
    real G6_2_1_11_1_6_8_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g12*g01;
    real G6_2_1_11_1_6_8_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g12*g11;
    real G6_2_1_11_1_6_8_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g12*g21;
    real G6_2_1_11_1_6_9_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][9]*g12*g01;
    real G6_2_1_11_1_6_10_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][10]*g12*g11;
    real G6_2_1_11_1_6_11_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][11]*g12*g21;
    real G6_2_1_11_1_7_0_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g12*g01;
    real G6_2_1_11_1_7_0_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g12*g11;
    real G6_2_1_11_1_7_0_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g12*g21;
    real G6_2_1_11_1_7_1_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][1]*g12*g01;
    real G6_2_1_11_1_7_2_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][2]*g12*g11;
    real G6_2_1_11_1_7_3_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][3]*g12*g21;
    real G6_2_1_11_1_7_4_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g12*g01;
    real G6_2_1_11_1_7_4_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g12*g11;
    real G6_2_1_11_1_7_4_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g12*g21;
    real G6_2_1_11_1_7_5_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][5]*g12*g01;
    real G6_2_1_11_1_7_6_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][6]*g12*g11;
    real G6_2_1_11_1_7_7_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][7]*g12*g21;
    real G6_2_1_11_1_7_8_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g12*g01;
    real G6_2_1_11_1_7_8_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g12*g11;
    real G6_2_1_11_1_7_8_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g12*g21;
    real G6_2_1_11_1_7_9_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][9]*g12*g01;
    real G6_2_1_11_1_7_10_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][10]*g12*g11;
    real G6_2_1_11_1_7_11_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][11]*g12*g21;
    real G6_2_1_11_2_4_0_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g22*g01;
    real G6_2_1_11_2_4_0_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g22*g11;
    real G6_2_1_11_2_4_0_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][0]*g22*g21;
    real G6_2_1_11_2_4_1_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][1]*g22*g01;
    real G6_2_1_11_2_4_2_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][2]*g22*g11;
    real G6_2_1_11_2_4_3_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][3]*g22*g21;
    real G6_2_1_11_2_4_4_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g22*g01;
    real G6_2_1_11_2_4_4_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g22*g11;
    real G6_2_1_11_2_4_4_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][4]*g22*g21;
    real G6_2_1_11_2_4_5_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][5]*g22*g01;
    real G6_2_1_11_2_4_6_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][6]*g22*g11;
    real G6_2_1_11_2_4_7_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][7]*g22*g21;
    real G6_2_1_11_2_4_8_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g22*g01;
    real G6_2_1_11_2_4_8_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g22*g11;
    real G6_2_1_11_2_4_8_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][8]*g22*g21;
    real G6_2_1_11_2_4_9_0 = det*c1*c0*w[0][11]*w[0][4]*w[1][9]*g22*g01;
    real G6_2_1_11_2_4_10_1 = det*c1*c0*w[0][11]*w[0][4]*w[1][10]*g22*g11;
    real G6_2_1_11_2_4_11_2 = det*c1*c0*w[0][11]*w[0][4]*w[1][11]*g22*g21;
    real G6_2_1_11_2_5_0_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g22*g01;
    real G6_2_1_11_2_5_0_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g22*g11;
    real G6_2_1_11_2_5_0_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][0]*g22*g21;
    real G6_2_1_11_2_5_1_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][1]*g22*g01;
    real G6_2_1_11_2_5_2_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][2]*g22*g11;
    real G6_2_1_11_2_5_3_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][3]*g22*g21;
    real G6_2_1_11_2_5_4_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g22*g01;
    real G6_2_1_11_2_5_4_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g22*g11;
    real G6_2_1_11_2_5_4_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][4]*g22*g21;
    real G6_2_1_11_2_5_5_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][5]*g22*g01;
    real G6_2_1_11_2_5_6_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][6]*g22*g11;
    real G6_2_1_11_2_5_7_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][7]*g22*g21;
    real G6_2_1_11_2_5_8_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g22*g01;
    real G6_2_1_11_2_5_8_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g22*g11;
    real G6_2_1_11_2_5_8_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][8]*g22*g21;
    real G6_2_1_11_2_5_9_0 = det*c1*c0*w[0][11]*w[0][5]*w[1][9]*g22*g01;
    real G6_2_1_11_2_5_10_1 = det*c1*c0*w[0][11]*w[0][5]*w[1][10]*g22*g11;
    real G6_2_1_11_2_5_11_2 = det*c1*c0*w[0][11]*w[0][5]*w[1][11]*g22*g21;
    real G6_2_1_11_2_6_0_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g22*g01;
    real G6_2_1_11_2_6_0_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g22*g11;
    real G6_2_1_11_2_6_0_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][0]*g22*g21;
    real G6_2_1_11_2_6_1_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][1]*g22*g01;
    real G6_2_1_11_2_6_2_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][2]*g22*g11;
    real G6_2_1_11_2_6_3_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][3]*g22*g21;
    real G6_2_1_11_2_6_4_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g22*g01;
    real G6_2_1_11_2_6_4_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g22*g11;
    real G6_2_1_11_2_6_4_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][4]*g22*g21;
    real G6_2_1_11_2_6_5_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][5]*g22*g01;
    real G6_2_1_11_2_6_6_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][6]*g22*g11;
    real G6_2_1_11_2_6_7_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][7]*g22*g21;
    real G6_2_1_11_2_6_8_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g22*g01;
    real G6_2_1_11_2_6_8_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g22*g11;
    real G6_2_1_11_2_6_8_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][8]*g22*g21;
    real G6_2_1_11_2_6_9_0 = det*c1*c0*w[0][11]*w[0][6]*w[1][9]*g22*g01;
    real G6_2_1_11_2_6_10_1 = det*c1*c0*w[0][11]*w[0][6]*w[1][10]*g22*g11;
    real G6_2_1_11_2_6_11_2 = det*c1*c0*w[0][11]*w[0][6]*w[1][11]*g22*g21;
    real G6_2_1_11_2_7_0_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g22*g01;
    real G6_2_1_11_2_7_0_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g22*g11;
    real G6_2_1_11_2_7_0_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][0]*g22*g21;
    real G6_2_1_11_2_7_1_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][1]*g22*g01;
    real G6_2_1_11_2_7_2_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][2]*g22*g11;
    real G6_2_1_11_2_7_3_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][3]*g22*g21;
    real G6_2_1_11_2_7_4_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g22*g01;
    real G6_2_1_11_2_7_4_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g22*g11;
    real G6_2_1_11_2_7_4_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][4]*g22*g21;
    real G6_2_1_11_2_7_5_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][5]*g22*g01;
    real G6_2_1_11_2_7_6_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][6]*g22*g11;
    real G6_2_1_11_2_7_7_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][7]*g22*g21;
    real G6_2_1_11_2_7_8_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g22*g01;
    real G6_2_1_11_2_7_8_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g22*g11;
    real G6_2_1_11_2_7_8_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][8]*g22*g21;
    real G6_2_1_11_2_7_9_0 = det*c1*c0*w[0][11]*w[0][7]*w[1][9]*g22*g01;
    real G6_2_1_11_2_7_10_1 = det*c1*c0*w[0][11]*w[0][7]*w[1][10]*g22*g11;
    real G6_2_1_11_2_7_11_2 = det*c1*c0*w[0][11]*w[0][7]*w[1][11]*g22*g21;
    real G6_2_2_8_0_8_0_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g02*g02;
    real G6_2_2_8_0_8_0_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g02*g12;
    real G6_2_2_8_0_8_0_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g02*g22;
    real G6_2_2_8_0_8_1_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][1]*g02*g02;
    real G6_2_2_8_0_8_2_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][2]*g02*g12;
    real G6_2_2_8_0_8_3_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][3]*g02*g22;
    real G6_2_2_8_0_8_4_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g02*g02;
    real G6_2_2_8_0_8_4_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g02*g12;
    real G6_2_2_8_0_8_4_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g02*g22;
    real G6_2_2_8_0_8_5_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][5]*g02*g02;
    real G6_2_2_8_0_8_6_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][6]*g02*g12;
    real G6_2_2_8_0_8_7_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][7]*g02*g22;
    real G6_2_2_8_0_8_8_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g02*g02;
    real G6_2_2_8_0_8_8_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g02*g12;
    real G6_2_2_8_0_8_8_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g02*g22;
    real G6_2_2_8_0_8_9_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][9]*g02*g02;
    real G6_2_2_8_0_8_10_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][10]*g02*g12;
    real G6_2_2_8_0_8_11_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][11]*g02*g22;
    real G6_2_2_8_0_9_0_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g02*g02;
    real G6_2_2_8_0_9_0_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g02*g12;
    real G6_2_2_8_0_9_0_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g02*g22;
    real G6_2_2_8_0_9_1_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][1]*g02*g02;
    real G6_2_2_8_0_9_2_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][2]*g02*g12;
    real G6_2_2_8_0_9_3_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][3]*g02*g22;
    real G6_2_2_8_0_9_4_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g02*g02;
    real G6_2_2_8_0_9_4_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g02*g12;
    real G6_2_2_8_0_9_4_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g02*g22;
    real G6_2_2_8_0_9_5_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][5]*g02*g02;
    real G6_2_2_8_0_9_6_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][6]*g02*g12;
    real G6_2_2_8_0_9_7_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][7]*g02*g22;
    real G6_2_2_8_0_9_8_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g02*g02;
    real G6_2_2_8_0_9_8_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g02*g12;
    real G6_2_2_8_0_9_8_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g02*g22;
    real G6_2_2_8_0_9_9_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][9]*g02*g02;
    real G6_2_2_8_0_9_10_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][10]*g02*g12;
    real G6_2_2_8_0_9_11_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][11]*g02*g22;
    real G6_2_2_8_0_10_0_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g02*g02;
    real G6_2_2_8_0_10_0_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g02*g12;
    real G6_2_2_8_0_10_0_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g02*g22;
    real G6_2_2_8_0_10_1_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][1]*g02*g02;
    real G6_2_2_8_0_10_2_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][2]*g02*g12;
    real G6_2_2_8_0_10_3_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][3]*g02*g22;
    real G6_2_2_8_0_10_4_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g02*g02;
    real G6_2_2_8_0_10_4_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g02*g12;
    real G6_2_2_8_0_10_4_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g02*g22;
    real G6_2_2_8_0_10_5_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][5]*g02*g02;
    real G6_2_2_8_0_10_6_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][6]*g02*g12;
    real G6_2_2_8_0_10_7_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][7]*g02*g22;
    real G6_2_2_8_0_10_8_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g02*g02;
    real G6_2_2_8_0_10_8_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g02*g12;
    real G6_2_2_8_0_10_8_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g02*g22;
    real G6_2_2_8_0_10_9_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][9]*g02*g02;
    real G6_2_2_8_0_10_10_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][10]*g02*g12;
    real G6_2_2_8_0_10_11_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][11]*g02*g22;
    real G6_2_2_8_0_11_0_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g02*g02;
    real G6_2_2_8_0_11_0_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g02*g12;
    real G6_2_2_8_0_11_0_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g02*g22;
    real G6_2_2_8_0_11_1_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][1]*g02*g02;
    real G6_2_2_8_0_11_2_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][2]*g02*g12;
    real G6_2_2_8_0_11_3_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][3]*g02*g22;
    real G6_2_2_8_0_11_4_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g02*g02;
    real G6_2_2_8_0_11_4_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g02*g12;
    real G6_2_2_8_0_11_4_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g02*g22;
    real G6_2_2_8_0_11_5_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][5]*g02*g02;
    real G6_2_2_8_0_11_6_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][6]*g02*g12;
    real G6_2_2_8_0_11_7_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][7]*g02*g22;
    real G6_2_2_8_0_11_8_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g02*g02;
    real G6_2_2_8_0_11_8_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g02*g12;
    real G6_2_2_8_0_11_8_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g02*g22;
    real G6_2_2_8_0_11_9_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][9]*g02*g02;
    real G6_2_2_8_0_11_10_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][10]*g02*g12;
    real G6_2_2_8_0_11_11_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][11]*g02*g22;
    real G6_2_2_8_1_8_0_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g12*g02;
    real G6_2_2_8_1_8_0_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g12*g12;
    real G6_2_2_8_1_8_0_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g12*g22;
    real G6_2_2_8_1_8_1_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][1]*g12*g02;
    real G6_2_2_8_1_8_2_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][2]*g12*g12;
    real G6_2_2_8_1_8_3_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][3]*g12*g22;
    real G6_2_2_8_1_8_4_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g12*g02;
    real G6_2_2_8_1_8_4_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g12*g12;
    real G6_2_2_8_1_8_4_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g12*g22;
    real G6_2_2_8_1_8_5_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][5]*g12*g02;
    real G6_2_2_8_1_8_6_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][6]*g12*g12;
    real G6_2_2_8_1_8_7_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][7]*g12*g22;
    real G6_2_2_8_1_8_8_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g12*g02;
    real G6_2_2_8_1_8_8_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g12*g12;
    real G6_2_2_8_1_8_8_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g12*g22;
    real G6_2_2_8_1_8_9_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][9]*g12*g02;
    real G6_2_2_8_1_8_10_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][10]*g12*g12;
    real G6_2_2_8_1_8_11_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][11]*g12*g22;
    real G6_2_2_8_1_9_0_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g12*g02;
    real G6_2_2_8_1_9_0_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g12*g12;
    real G6_2_2_8_1_9_0_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g12*g22;
    real G6_2_2_8_1_9_1_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][1]*g12*g02;
    real G6_2_2_8_1_9_2_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][2]*g12*g12;
    real G6_2_2_8_1_9_3_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][3]*g12*g22;
    real G6_2_2_8_1_9_4_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g12*g02;
    real G6_2_2_8_1_9_4_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g12*g12;
    real G6_2_2_8_1_9_4_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g12*g22;
    real G6_2_2_8_1_9_5_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][5]*g12*g02;
    real G6_2_2_8_1_9_6_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][6]*g12*g12;
    real G6_2_2_8_1_9_7_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][7]*g12*g22;
    real G6_2_2_8_1_9_8_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g12*g02;
    real G6_2_2_8_1_9_8_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g12*g12;
    real G6_2_2_8_1_9_8_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g12*g22;
    real G6_2_2_8_1_9_9_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][9]*g12*g02;
    real G6_2_2_8_1_9_10_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][10]*g12*g12;
    real G6_2_2_8_1_9_11_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][11]*g12*g22;
    real G6_2_2_8_1_10_0_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g12*g02;
    real G6_2_2_8_1_10_0_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g12*g12;
    real G6_2_2_8_1_10_0_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g12*g22;
    real G6_2_2_8_1_10_1_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][1]*g12*g02;
    real G6_2_2_8_1_10_2_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][2]*g12*g12;
    real G6_2_2_8_1_10_3_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][3]*g12*g22;
    real G6_2_2_8_1_10_4_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g12*g02;
    real G6_2_2_8_1_10_4_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g12*g12;
    real G6_2_2_8_1_10_4_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g12*g22;
    real G6_2_2_8_1_10_5_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][5]*g12*g02;
    real G6_2_2_8_1_10_6_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][6]*g12*g12;
    real G6_2_2_8_1_10_7_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][7]*g12*g22;
    real G6_2_2_8_1_10_8_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g12*g02;
    real G6_2_2_8_1_10_8_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g12*g12;
    real G6_2_2_8_1_10_8_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g12*g22;
    real G6_2_2_8_1_10_9_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][9]*g12*g02;
    real G6_2_2_8_1_10_10_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][10]*g12*g12;
    real G6_2_2_8_1_10_11_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][11]*g12*g22;
    real G6_2_2_8_1_11_0_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g12*g02;
    real G6_2_2_8_1_11_0_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g12*g12;
    real G6_2_2_8_1_11_0_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g12*g22;
    real G6_2_2_8_1_11_1_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][1]*g12*g02;
    real G6_2_2_8_1_11_2_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][2]*g12*g12;
    real G6_2_2_8_1_11_3_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][3]*g12*g22;
    real G6_2_2_8_1_11_4_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g12*g02;
    real G6_2_2_8_1_11_4_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g12*g12;
    real G6_2_2_8_1_11_4_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g12*g22;
    real G6_2_2_8_1_11_5_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][5]*g12*g02;
    real G6_2_2_8_1_11_6_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][6]*g12*g12;
    real G6_2_2_8_1_11_7_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][7]*g12*g22;
    real G6_2_2_8_1_11_8_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g12*g02;
    real G6_2_2_8_1_11_8_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g12*g12;
    real G6_2_2_8_1_11_8_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g12*g22;
    real G6_2_2_8_1_11_9_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][9]*g12*g02;
    real G6_2_2_8_1_11_10_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][10]*g12*g12;
    real G6_2_2_8_1_11_11_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][11]*g12*g22;
    real G6_2_2_8_2_8_0_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g22*g02;
    real G6_2_2_8_2_8_0_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g22*g12;
    real G6_2_2_8_2_8_0_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][0]*g22*g22;
    real G6_2_2_8_2_8_1_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][1]*g22*g02;
    real G6_2_2_8_2_8_2_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][2]*g22*g12;
    real G6_2_2_8_2_8_3_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][3]*g22*g22;
    real G6_2_2_8_2_8_4_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g22*g02;
    real G6_2_2_8_2_8_4_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g22*g12;
    real G6_2_2_8_2_8_4_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][4]*g22*g22;
    real G6_2_2_8_2_8_5_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][5]*g22*g02;
    real G6_2_2_8_2_8_6_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][6]*g22*g12;
    real G6_2_2_8_2_8_7_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][7]*g22*g22;
    real G6_2_2_8_2_8_8_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g22*g02;
    real G6_2_2_8_2_8_8_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g22*g12;
    real G6_2_2_8_2_8_8_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][8]*g22*g22;
    real G6_2_2_8_2_8_9_0 = det*c1*c0*w[0][8]*w[0][8]*w[1][9]*g22*g02;
    real G6_2_2_8_2_8_10_1 = det*c1*c0*w[0][8]*w[0][8]*w[1][10]*g22*g12;
    real G6_2_2_8_2_8_11_2 = det*c1*c0*w[0][8]*w[0][8]*w[1][11]*g22*g22;
    real G6_2_2_8_2_9_0_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g22*g02;
    real G6_2_2_8_2_9_0_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g22*g12;
    real G6_2_2_8_2_9_0_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][0]*g22*g22;
    real G6_2_2_8_2_9_1_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][1]*g22*g02;
    real G6_2_2_8_2_9_2_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][2]*g22*g12;
    real G6_2_2_8_2_9_3_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][3]*g22*g22;
    real G6_2_2_8_2_9_4_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g22*g02;
    real G6_2_2_8_2_9_4_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g22*g12;
    real G6_2_2_8_2_9_4_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][4]*g22*g22;
    real G6_2_2_8_2_9_5_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][5]*g22*g02;
    real G6_2_2_8_2_9_6_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][6]*g22*g12;
    real G6_2_2_8_2_9_7_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][7]*g22*g22;
    real G6_2_2_8_2_9_8_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g22*g02;
    real G6_2_2_8_2_9_8_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g22*g12;
    real G6_2_2_8_2_9_8_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][8]*g22*g22;
    real G6_2_2_8_2_9_9_0 = det*c1*c0*w[0][8]*w[0][9]*w[1][9]*g22*g02;
    real G6_2_2_8_2_9_10_1 = det*c1*c0*w[0][8]*w[0][9]*w[1][10]*g22*g12;
    real G6_2_2_8_2_9_11_2 = det*c1*c0*w[0][8]*w[0][9]*w[1][11]*g22*g22;
    real G6_2_2_8_2_10_0_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g22*g02;
    real G6_2_2_8_2_10_0_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g22*g12;
    real G6_2_2_8_2_10_0_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][0]*g22*g22;
    real G6_2_2_8_2_10_1_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][1]*g22*g02;
    real G6_2_2_8_2_10_2_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][2]*g22*g12;
    real G6_2_2_8_2_10_3_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][3]*g22*g22;
    real G6_2_2_8_2_10_4_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g22*g02;
    real G6_2_2_8_2_10_4_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g22*g12;
    real G6_2_2_8_2_10_4_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][4]*g22*g22;
    real G6_2_2_8_2_10_5_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][5]*g22*g02;
    real G6_2_2_8_2_10_6_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][6]*g22*g12;
    real G6_2_2_8_2_10_7_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][7]*g22*g22;
    real G6_2_2_8_2_10_8_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g22*g02;
    real G6_2_2_8_2_10_8_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g22*g12;
    real G6_2_2_8_2_10_8_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][8]*g22*g22;
    real G6_2_2_8_2_10_9_0 = det*c1*c0*w[0][8]*w[0][10]*w[1][9]*g22*g02;
    real G6_2_2_8_2_10_10_1 = det*c1*c0*w[0][8]*w[0][10]*w[1][10]*g22*g12;
    real G6_2_2_8_2_10_11_2 = det*c1*c0*w[0][8]*w[0][10]*w[1][11]*g22*g22;
    real G6_2_2_8_2_11_0_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g22*g02;
    real G6_2_2_8_2_11_0_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g22*g12;
    real G6_2_2_8_2_11_0_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][0]*g22*g22;
    real G6_2_2_8_2_11_1_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][1]*g22*g02;
    real G6_2_2_8_2_11_2_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][2]*g22*g12;
    real G6_2_2_8_2_11_3_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][3]*g22*g22;
    real G6_2_2_8_2_11_4_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g22*g02;
    real G6_2_2_8_2_11_4_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g22*g12;
    real G6_2_2_8_2_11_4_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][4]*g22*g22;
    real G6_2_2_8_2_11_5_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][5]*g22*g02;
    real G6_2_2_8_2_11_6_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][6]*g22*g12;
    real G6_2_2_8_2_11_7_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][7]*g22*g22;
    real G6_2_2_8_2_11_8_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g22*g02;
    real G6_2_2_8_2_11_8_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g22*g12;
    real G6_2_2_8_2_11_8_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][8]*g22*g22;
    real G6_2_2_8_2_11_9_0 = det*c1*c0*w[0][8]*w[0][11]*w[1][9]*g22*g02;
    real G6_2_2_8_2_11_10_1 = det*c1*c0*w[0][8]*w[0][11]*w[1][10]*g22*g12;
    real G6_2_2_8_2_11_11_2 = det*c1*c0*w[0][8]*w[0][11]*w[1][11]*g22*g22;
    real G6_2_2_9_0_8_0_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g02*g02;
    real G6_2_2_9_0_8_0_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g02*g12;
    real G6_2_2_9_0_8_0_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g02*g22;
    real G6_2_2_9_0_8_1_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][1]*g02*g02;
    real G6_2_2_9_0_8_2_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][2]*g02*g12;
    real G6_2_2_9_0_8_3_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][3]*g02*g22;
    real G6_2_2_9_0_8_4_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g02*g02;
    real G6_2_2_9_0_8_4_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g02*g12;
    real G6_2_2_9_0_8_4_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g02*g22;
    real G6_2_2_9_0_8_5_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][5]*g02*g02;
    real G6_2_2_9_0_8_6_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][6]*g02*g12;
    real G6_2_2_9_0_8_7_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][7]*g02*g22;
    real G6_2_2_9_0_8_8_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g02*g02;
    real G6_2_2_9_0_8_8_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g02*g12;
    real G6_2_2_9_0_8_8_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g02*g22;
    real G6_2_2_9_0_8_9_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][9]*g02*g02;
    real G6_2_2_9_0_8_10_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][10]*g02*g12;
    real G6_2_2_9_0_8_11_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][11]*g02*g22;
    real G6_2_2_9_0_9_0_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g02*g02;
    real G6_2_2_9_0_9_0_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g02*g12;
    real G6_2_2_9_0_9_0_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g02*g22;
    real G6_2_2_9_0_9_1_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][1]*g02*g02;
    real G6_2_2_9_0_9_2_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][2]*g02*g12;
    real G6_2_2_9_0_9_3_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][3]*g02*g22;
    real G6_2_2_9_0_9_4_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g02*g02;
    real G6_2_2_9_0_9_4_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g02*g12;
    real G6_2_2_9_0_9_4_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g02*g22;
    real G6_2_2_9_0_9_5_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][5]*g02*g02;
    real G6_2_2_9_0_9_6_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][6]*g02*g12;
    real G6_2_2_9_0_9_7_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][7]*g02*g22;
    real G6_2_2_9_0_9_8_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g02*g02;
    real G6_2_2_9_0_9_8_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g02*g12;
    real G6_2_2_9_0_9_8_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g02*g22;
    real G6_2_2_9_0_9_9_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][9]*g02*g02;
    real G6_2_2_9_0_9_10_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][10]*g02*g12;
    real G6_2_2_9_0_9_11_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][11]*g02*g22;
    real G6_2_2_9_0_10_0_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g02*g02;
    real G6_2_2_9_0_10_0_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g02*g12;
    real G6_2_2_9_0_10_0_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g02*g22;
    real G6_2_2_9_0_10_1_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][1]*g02*g02;
    real G6_2_2_9_0_10_2_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][2]*g02*g12;
    real G6_2_2_9_0_10_3_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][3]*g02*g22;
    real G6_2_2_9_0_10_4_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g02*g02;
    real G6_2_2_9_0_10_4_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g02*g12;
    real G6_2_2_9_0_10_4_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g02*g22;
    real G6_2_2_9_0_10_5_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][5]*g02*g02;
    real G6_2_2_9_0_10_6_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][6]*g02*g12;
    real G6_2_2_9_0_10_7_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][7]*g02*g22;
    real G6_2_2_9_0_10_8_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g02*g02;
    real G6_2_2_9_0_10_8_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g02*g12;
    real G6_2_2_9_0_10_8_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g02*g22;
    real G6_2_2_9_0_10_9_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][9]*g02*g02;
    real G6_2_2_9_0_10_10_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][10]*g02*g12;
    real G6_2_2_9_0_10_11_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][11]*g02*g22;
    real G6_2_2_9_0_11_0_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g02*g02;
    real G6_2_2_9_0_11_0_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g02*g12;
    real G6_2_2_9_0_11_0_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g02*g22;
    real G6_2_2_9_0_11_1_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][1]*g02*g02;
    real G6_2_2_9_0_11_2_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][2]*g02*g12;
    real G6_2_2_9_0_11_3_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][3]*g02*g22;
    real G6_2_2_9_0_11_4_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g02*g02;
    real G6_2_2_9_0_11_4_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g02*g12;
    real G6_2_2_9_0_11_4_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g02*g22;
    real G6_2_2_9_0_11_5_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][5]*g02*g02;
    real G6_2_2_9_0_11_6_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][6]*g02*g12;
    real G6_2_2_9_0_11_7_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][7]*g02*g22;
    real G6_2_2_9_0_11_8_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g02*g02;
    real G6_2_2_9_0_11_8_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g02*g12;
    real G6_2_2_9_0_11_8_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g02*g22;
    real G6_2_2_9_0_11_9_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][9]*g02*g02;
    real G6_2_2_9_0_11_10_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][10]*g02*g12;
    real G6_2_2_9_0_11_11_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][11]*g02*g22;
    real G6_2_2_9_1_8_0_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g12*g02;
    real G6_2_2_9_1_8_0_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g12*g12;
    real G6_2_2_9_1_8_0_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g12*g22;
    real G6_2_2_9_1_8_1_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][1]*g12*g02;
    real G6_2_2_9_1_8_2_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][2]*g12*g12;
    real G6_2_2_9_1_8_3_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][3]*g12*g22;
    real G6_2_2_9_1_8_4_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g12*g02;
    real G6_2_2_9_1_8_4_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g12*g12;
    real G6_2_2_9_1_8_4_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g12*g22;
    real G6_2_2_9_1_8_5_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][5]*g12*g02;
    real G6_2_2_9_1_8_6_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][6]*g12*g12;
    real G6_2_2_9_1_8_7_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][7]*g12*g22;
    real G6_2_2_9_1_8_8_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g12*g02;
    real G6_2_2_9_1_8_8_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g12*g12;
    real G6_2_2_9_1_8_8_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g12*g22;
    real G6_2_2_9_1_8_9_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][9]*g12*g02;
    real G6_2_2_9_1_8_10_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][10]*g12*g12;
    real G6_2_2_9_1_8_11_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][11]*g12*g22;
    real G6_2_2_9_1_9_0_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g12*g02;
    real G6_2_2_9_1_9_0_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g12*g12;
    real G6_2_2_9_1_9_0_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g12*g22;
    real G6_2_2_9_1_9_1_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][1]*g12*g02;
    real G6_2_2_9_1_9_2_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][2]*g12*g12;
    real G6_2_2_9_1_9_3_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][3]*g12*g22;
    real G6_2_2_9_1_9_4_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g12*g02;
    real G6_2_2_9_1_9_4_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g12*g12;
    real G6_2_2_9_1_9_4_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g12*g22;
    real G6_2_2_9_1_9_5_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][5]*g12*g02;
    real G6_2_2_9_1_9_6_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][6]*g12*g12;
    real G6_2_2_9_1_9_7_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][7]*g12*g22;
    real G6_2_2_9_1_9_8_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g12*g02;
    real G6_2_2_9_1_9_8_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g12*g12;
    real G6_2_2_9_1_9_8_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g12*g22;
    real G6_2_2_9_1_9_9_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][9]*g12*g02;
    real G6_2_2_9_1_9_10_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][10]*g12*g12;
    real G6_2_2_9_1_9_11_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][11]*g12*g22;
    real G6_2_2_9_1_10_0_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g12*g02;
    real G6_2_2_9_1_10_0_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g12*g12;
    real G6_2_2_9_1_10_0_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g12*g22;
    real G6_2_2_9_1_10_1_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][1]*g12*g02;
    real G6_2_2_9_1_10_2_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][2]*g12*g12;
    real G6_2_2_9_1_10_3_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][3]*g12*g22;
    real G6_2_2_9_1_10_4_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g12*g02;
    real G6_2_2_9_1_10_4_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g12*g12;
    real G6_2_2_9_1_10_4_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g12*g22;
    real G6_2_2_9_1_10_5_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][5]*g12*g02;
    real G6_2_2_9_1_10_6_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][6]*g12*g12;
    real G6_2_2_9_1_10_7_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][7]*g12*g22;
    real G6_2_2_9_1_10_8_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g12*g02;
    real G6_2_2_9_1_10_8_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g12*g12;
    real G6_2_2_9_1_10_8_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g12*g22;
    real G6_2_2_9_1_10_9_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][9]*g12*g02;
    real G6_2_2_9_1_10_10_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][10]*g12*g12;
    real G6_2_2_9_1_10_11_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][11]*g12*g22;
    real G6_2_2_9_1_11_0_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g12*g02;
    real G6_2_2_9_1_11_0_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g12*g12;
    real G6_2_2_9_1_11_0_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g12*g22;
    real G6_2_2_9_1_11_1_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][1]*g12*g02;
    real G6_2_2_9_1_11_2_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][2]*g12*g12;
    real G6_2_2_9_1_11_3_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][3]*g12*g22;
    real G6_2_2_9_1_11_4_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g12*g02;
    real G6_2_2_9_1_11_4_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g12*g12;
    real G6_2_2_9_1_11_4_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g12*g22;
    real G6_2_2_9_1_11_5_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][5]*g12*g02;
    real G6_2_2_9_1_11_6_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][6]*g12*g12;
    real G6_2_2_9_1_11_7_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][7]*g12*g22;
    real G6_2_2_9_1_11_8_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g12*g02;
    real G6_2_2_9_1_11_8_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g12*g12;
    real G6_2_2_9_1_11_8_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g12*g22;
    real G6_2_2_9_1_11_9_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][9]*g12*g02;
    real G6_2_2_9_1_11_10_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][10]*g12*g12;
    real G6_2_2_9_1_11_11_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][11]*g12*g22;
    real G6_2_2_9_2_8_0_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g22*g02;
    real G6_2_2_9_2_8_0_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g22*g12;
    real G6_2_2_9_2_8_0_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][0]*g22*g22;
    real G6_2_2_9_2_8_1_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][1]*g22*g02;
    real G6_2_2_9_2_8_2_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][2]*g22*g12;
    real G6_2_2_9_2_8_3_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][3]*g22*g22;
    real G6_2_2_9_2_8_4_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g22*g02;
    real G6_2_2_9_2_8_4_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g22*g12;
    real G6_2_2_9_2_8_4_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][4]*g22*g22;
    real G6_2_2_9_2_8_5_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][5]*g22*g02;
    real G6_2_2_9_2_8_6_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][6]*g22*g12;
    real G6_2_2_9_2_8_7_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][7]*g22*g22;
    real G6_2_2_9_2_8_8_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g22*g02;
    real G6_2_2_9_2_8_8_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g22*g12;
    real G6_2_2_9_2_8_8_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][8]*g22*g22;
    real G6_2_2_9_2_8_9_0 = det*c1*c0*w[0][9]*w[0][8]*w[1][9]*g22*g02;
    real G6_2_2_9_2_8_10_1 = det*c1*c0*w[0][9]*w[0][8]*w[1][10]*g22*g12;
    real G6_2_2_9_2_8_11_2 = det*c1*c0*w[0][9]*w[0][8]*w[1][11]*g22*g22;
    real G6_2_2_9_2_9_0_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g22*g02;
    real G6_2_2_9_2_9_0_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g22*g12;
    real G6_2_2_9_2_9_0_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][0]*g22*g22;
    real G6_2_2_9_2_9_1_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][1]*g22*g02;
    real G6_2_2_9_2_9_2_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][2]*g22*g12;
    real G6_2_2_9_2_9_3_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][3]*g22*g22;
    real G6_2_2_9_2_9_4_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g22*g02;
    real G6_2_2_9_2_9_4_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g22*g12;
    real G6_2_2_9_2_9_4_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][4]*g22*g22;
    real G6_2_2_9_2_9_5_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][5]*g22*g02;
    real G6_2_2_9_2_9_6_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][6]*g22*g12;
    real G6_2_2_9_2_9_7_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][7]*g22*g22;
    real G6_2_2_9_2_9_8_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g22*g02;
    real G6_2_2_9_2_9_8_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g22*g12;
    real G6_2_2_9_2_9_8_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][8]*g22*g22;
    real G6_2_2_9_2_9_9_0 = det*c1*c0*w[0][9]*w[0][9]*w[1][9]*g22*g02;
    real G6_2_2_9_2_9_10_1 = det*c1*c0*w[0][9]*w[0][9]*w[1][10]*g22*g12;
    real G6_2_2_9_2_9_11_2 = det*c1*c0*w[0][9]*w[0][9]*w[1][11]*g22*g22;
    real G6_2_2_9_2_10_0_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g22*g02;
    real G6_2_2_9_2_10_0_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g22*g12;
    real G6_2_2_9_2_10_0_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][0]*g22*g22;
    real G6_2_2_9_2_10_1_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][1]*g22*g02;
    real G6_2_2_9_2_10_2_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][2]*g22*g12;
    real G6_2_2_9_2_10_3_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][3]*g22*g22;
    real G6_2_2_9_2_10_4_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g22*g02;
    real G6_2_2_9_2_10_4_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g22*g12;
    real G6_2_2_9_2_10_4_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][4]*g22*g22;
    real G6_2_2_9_2_10_5_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][5]*g22*g02;
    real G6_2_2_9_2_10_6_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][6]*g22*g12;
    real G6_2_2_9_2_10_7_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][7]*g22*g22;
    real G6_2_2_9_2_10_8_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g22*g02;
    real G6_2_2_9_2_10_8_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g22*g12;
    real G6_2_2_9_2_10_8_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][8]*g22*g22;
    real G6_2_2_9_2_10_9_0 = det*c1*c0*w[0][9]*w[0][10]*w[1][9]*g22*g02;
    real G6_2_2_9_2_10_10_1 = det*c1*c0*w[0][9]*w[0][10]*w[1][10]*g22*g12;
    real G6_2_2_9_2_10_11_2 = det*c1*c0*w[0][9]*w[0][10]*w[1][11]*g22*g22;
    real G6_2_2_9_2_11_0_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g22*g02;
    real G6_2_2_9_2_11_0_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g22*g12;
    real G6_2_2_9_2_11_0_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][0]*g22*g22;
    real G6_2_2_9_2_11_1_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][1]*g22*g02;
    real G6_2_2_9_2_11_2_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][2]*g22*g12;
    real G6_2_2_9_2_11_3_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][3]*g22*g22;
    real G6_2_2_9_2_11_4_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g22*g02;
    real G6_2_2_9_2_11_4_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g22*g12;
    real G6_2_2_9_2_11_4_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][4]*g22*g22;
    real G6_2_2_9_2_11_5_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][5]*g22*g02;
    real G6_2_2_9_2_11_6_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][6]*g22*g12;
    real G6_2_2_9_2_11_7_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][7]*g22*g22;
    real G6_2_2_9_2_11_8_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g22*g02;
    real G6_2_2_9_2_11_8_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g22*g12;
    real G6_2_2_9_2_11_8_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][8]*g22*g22;
    real G6_2_2_9_2_11_9_0 = det*c1*c0*w[0][9]*w[0][11]*w[1][9]*g22*g02;
    real G6_2_2_9_2_11_10_1 = det*c1*c0*w[0][9]*w[0][11]*w[1][10]*g22*g12;
    real G6_2_2_9_2_11_11_2 = det*c1*c0*w[0][9]*w[0][11]*w[1][11]*g22*g22;
    real G6_2_2_10_0_8_0_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g02*g02;
    real G6_2_2_10_0_8_0_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g02*g12;
    real G6_2_2_10_0_8_0_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g02*g22;
    real G6_2_2_10_0_8_1_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][1]*g02*g02;
    real G6_2_2_10_0_8_2_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][2]*g02*g12;
    real G6_2_2_10_0_8_3_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][3]*g02*g22;
    real G6_2_2_10_0_8_4_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g02*g02;
    real G6_2_2_10_0_8_4_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g02*g12;
    real G6_2_2_10_0_8_4_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g02*g22;
    real G6_2_2_10_0_8_5_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][5]*g02*g02;
    real G6_2_2_10_0_8_6_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][6]*g02*g12;
    real G6_2_2_10_0_8_7_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][7]*g02*g22;
    real G6_2_2_10_0_8_8_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g02*g02;
    real G6_2_2_10_0_8_8_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g02*g12;
    real G6_2_2_10_0_8_8_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g02*g22;
    real G6_2_2_10_0_8_9_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][9]*g02*g02;
    real G6_2_2_10_0_8_10_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][10]*g02*g12;
    real G6_2_2_10_0_8_11_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][11]*g02*g22;
    real G6_2_2_10_0_9_0_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g02*g02;
    real G6_2_2_10_0_9_0_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g02*g12;
    real G6_2_2_10_0_9_0_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g02*g22;
    real G6_2_2_10_0_9_1_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][1]*g02*g02;
    real G6_2_2_10_0_9_2_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][2]*g02*g12;
    real G6_2_2_10_0_9_3_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][3]*g02*g22;
    real G6_2_2_10_0_9_4_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g02*g02;
    real G6_2_2_10_0_9_4_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g02*g12;
    real G6_2_2_10_0_9_4_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g02*g22;
    real G6_2_2_10_0_9_5_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][5]*g02*g02;
    real G6_2_2_10_0_9_6_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][6]*g02*g12;
    real G6_2_2_10_0_9_7_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][7]*g02*g22;
    real G6_2_2_10_0_9_8_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g02*g02;
    real G6_2_2_10_0_9_8_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g02*g12;
    real G6_2_2_10_0_9_8_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g02*g22;
    real G6_2_2_10_0_9_9_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][9]*g02*g02;
    real G6_2_2_10_0_9_10_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][10]*g02*g12;
    real G6_2_2_10_0_9_11_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][11]*g02*g22;
    real G6_2_2_10_0_10_0_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g02*g02;
    real G6_2_2_10_0_10_0_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g02*g12;
    real G6_2_2_10_0_10_0_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g02*g22;
    real G6_2_2_10_0_10_1_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][1]*g02*g02;
    real G6_2_2_10_0_10_2_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][2]*g02*g12;
    real G6_2_2_10_0_10_3_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][3]*g02*g22;
    real G6_2_2_10_0_10_4_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g02*g02;
    real G6_2_2_10_0_10_4_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g02*g12;
    real G6_2_2_10_0_10_4_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g02*g22;
    real G6_2_2_10_0_10_5_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][5]*g02*g02;
    real G6_2_2_10_0_10_6_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][6]*g02*g12;
    real G6_2_2_10_0_10_7_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][7]*g02*g22;
    real G6_2_2_10_0_10_8_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g02*g02;
    real G6_2_2_10_0_10_8_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g02*g12;
    real G6_2_2_10_0_10_8_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g02*g22;
    real G6_2_2_10_0_10_9_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][9]*g02*g02;
    real G6_2_2_10_0_10_10_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][10]*g02*g12;
    real G6_2_2_10_0_10_11_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][11]*g02*g22;
    real G6_2_2_10_0_11_0_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g02*g02;
    real G6_2_2_10_0_11_0_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g02*g12;
    real G6_2_2_10_0_11_0_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g02*g22;
    real G6_2_2_10_0_11_1_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][1]*g02*g02;
    real G6_2_2_10_0_11_2_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][2]*g02*g12;
    real G6_2_2_10_0_11_3_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][3]*g02*g22;
    real G6_2_2_10_0_11_4_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g02*g02;
    real G6_2_2_10_0_11_4_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g02*g12;
    real G6_2_2_10_0_11_4_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g02*g22;
    real G6_2_2_10_0_11_5_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][5]*g02*g02;
    real G6_2_2_10_0_11_6_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][6]*g02*g12;
    real G6_2_2_10_0_11_7_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][7]*g02*g22;
    real G6_2_2_10_0_11_8_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g02*g02;
    real G6_2_2_10_0_11_8_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g02*g12;
    real G6_2_2_10_0_11_8_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g02*g22;
    real G6_2_2_10_0_11_9_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][9]*g02*g02;
    real G6_2_2_10_0_11_10_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][10]*g02*g12;
    real G6_2_2_10_0_11_11_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][11]*g02*g22;
    real G6_2_2_10_1_8_0_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g12*g02;
    real G6_2_2_10_1_8_0_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g12*g12;
    real G6_2_2_10_1_8_0_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g12*g22;
    real G6_2_2_10_1_8_1_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][1]*g12*g02;
    real G6_2_2_10_1_8_2_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][2]*g12*g12;
    real G6_2_2_10_1_8_3_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][3]*g12*g22;
    real G6_2_2_10_1_8_4_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g12*g02;
    real G6_2_2_10_1_8_4_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g12*g12;
    real G6_2_2_10_1_8_4_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g12*g22;
    real G6_2_2_10_1_8_5_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][5]*g12*g02;
    real G6_2_2_10_1_8_6_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][6]*g12*g12;
    real G6_2_2_10_1_8_7_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][7]*g12*g22;
    real G6_2_2_10_1_8_8_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g12*g02;
    real G6_2_2_10_1_8_8_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g12*g12;
    real G6_2_2_10_1_8_8_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g12*g22;
    real G6_2_2_10_1_8_9_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][9]*g12*g02;
    real G6_2_2_10_1_8_10_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][10]*g12*g12;
    real G6_2_2_10_1_8_11_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][11]*g12*g22;
    real G6_2_2_10_1_9_0_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g12*g02;
    real G6_2_2_10_1_9_0_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g12*g12;
    real G6_2_2_10_1_9_0_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g12*g22;
    real G6_2_2_10_1_9_1_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][1]*g12*g02;
    real G6_2_2_10_1_9_2_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][2]*g12*g12;
    real G6_2_2_10_1_9_3_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][3]*g12*g22;
    real G6_2_2_10_1_9_4_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g12*g02;
    real G6_2_2_10_1_9_4_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g12*g12;
    real G6_2_2_10_1_9_4_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g12*g22;
    real G6_2_2_10_1_9_5_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][5]*g12*g02;
    real G6_2_2_10_1_9_6_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][6]*g12*g12;
    real G6_2_2_10_1_9_7_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][7]*g12*g22;
    real G6_2_2_10_1_9_8_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g12*g02;
    real G6_2_2_10_1_9_8_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g12*g12;
    real G6_2_2_10_1_9_8_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g12*g22;
    real G6_2_2_10_1_9_9_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][9]*g12*g02;
    real G6_2_2_10_1_9_10_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][10]*g12*g12;
    real G6_2_2_10_1_9_11_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][11]*g12*g22;
    real G6_2_2_10_1_10_0_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g12*g02;
    real G6_2_2_10_1_10_0_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g12*g12;
    real G6_2_2_10_1_10_0_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g12*g22;
    real G6_2_2_10_1_10_1_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][1]*g12*g02;
    real G6_2_2_10_1_10_2_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][2]*g12*g12;
    real G6_2_2_10_1_10_3_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][3]*g12*g22;
    real G6_2_2_10_1_10_4_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g12*g02;
    real G6_2_2_10_1_10_4_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g12*g12;
    real G6_2_2_10_1_10_4_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g12*g22;
    real G6_2_2_10_1_10_5_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][5]*g12*g02;
    real G6_2_2_10_1_10_6_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][6]*g12*g12;
    real G6_2_2_10_1_10_7_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][7]*g12*g22;
    real G6_2_2_10_1_10_8_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g12*g02;
    real G6_2_2_10_1_10_8_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g12*g12;
    real G6_2_2_10_1_10_8_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g12*g22;
    real G6_2_2_10_1_10_9_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][9]*g12*g02;
    real G6_2_2_10_1_10_10_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][10]*g12*g12;
    real G6_2_2_10_1_10_11_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][11]*g12*g22;
    real G6_2_2_10_1_11_0_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g12*g02;
    real G6_2_2_10_1_11_0_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g12*g12;
    real G6_2_2_10_1_11_0_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g12*g22;
    real G6_2_2_10_1_11_1_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][1]*g12*g02;
    real G6_2_2_10_1_11_2_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][2]*g12*g12;
    real G6_2_2_10_1_11_3_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][3]*g12*g22;
    real G6_2_2_10_1_11_4_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g12*g02;
    real G6_2_2_10_1_11_4_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g12*g12;
    real G6_2_2_10_1_11_4_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g12*g22;
    real G6_2_2_10_1_11_5_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][5]*g12*g02;
    real G6_2_2_10_1_11_6_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][6]*g12*g12;
    real G6_2_2_10_1_11_7_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][7]*g12*g22;
    real G6_2_2_10_1_11_8_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g12*g02;
    real G6_2_2_10_1_11_8_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g12*g12;
    real G6_2_2_10_1_11_8_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g12*g22;
    real G6_2_2_10_1_11_9_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][9]*g12*g02;
    real G6_2_2_10_1_11_10_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][10]*g12*g12;
    real G6_2_2_10_1_11_11_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][11]*g12*g22;
    real G6_2_2_10_2_8_0_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g22*g02;
    real G6_2_2_10_2_8_0_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g22*g12;
    real G6_2_2_10_2_8_0_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][0]*g22*g22;
    real G6_2_2_10_2_8_1_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][1]*g22*g02;
    real G6_2_2_10_2_8_2_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][2]*g22*g12;
    real G6_2_2_10_2_8_3_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][3]*g22*g22;
    real G6_2_2_10_2_8_4_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g22*g02;
    real G6_2_2_10_2_8_4_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g22*g12;
    real G6_2_2_10_2_8_4_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][4]*g22*g22;
    real G6_2_2_10_2_8_5_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][5]*g22*g02;
    real G6_2_2_10_2_8_6_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][6]*g22*g12;
    real G6_2_2_10_2_8_7_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][7]*g22*g22;
    real G6_2_2_10_2_8_8_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g22*g02;
    real G6_2_2_10_2_8_8_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g22*g12;
    real G6_2_2_10_2_8_8_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][8]*g22*g22;
    real G6_2_2_10_2_8_9_0 = det*c1*c0*w[0][10]*w[0][8]*w[1][9]*g22*g02;
    real G6_2_2_10_2_8_10_1 = det*c1*c0*w[0][10]*w[0][8]*w[1][10]*g22*g12;
    real G6_2_2_10_2_8_11_2 = det*c1*c0*w[0][10]*w[0][8]*w[1][11]*g22*g22;
    real G6_2_2_10_2_9_0_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g22*g02;
    real G6_2_2_10_2_9_0_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g22*g12;
    real G6_2_2_10_2_9_0_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][0]*g22*g22;
    real G6_2_2_10_2_9_1_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][1]*g22*g02;
    real G6_2_2_10_2_9_2_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][2]*g22*g12;
    real G6_2_2_10_2_9_3_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][3]*g22*g22;
    real G6_2_2_10_2_9_4_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g22*g02;
    real G6_2_2_10_2_9_4_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g22*g12;
    real G6_2_2_10_2_9_4_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][4]*g22*g22;
    real G6_2_2_10_2_9_5_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][5]*g22*g02;
    real G6_2_2_10_2_9_6_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][6]*g22*g12;
    real G6_2_2_10_2_9_7_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][7]*g22*g22;
    real G6_2_2_10_2_9_8_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g22*g02;
    real G6_2_2_10_2_9_8_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g22*g12;
    real G6_2_2_10_2_9_8_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][8]*g22*g22;
    real G6_2_2_10_2_9_9_0 = det*c1*c0*w[0][10]*w[0][9]*w[1][9]*g22*g02;
    real G6_2_2_10_2_9_10_1 = det*c1*c0*w[0][10]*w[0][9]*w[1][10]*g22*g12;
    real G6_2_2_10_2_9_11_2 = det*c1*c0*w[0][10]*w[0][9]*w[1][11]*g22*g22;
    real G6_2_2_10_2_10_0_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g22*g02;
    real G6_2_2_10_2_10_0_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g22*g12;
    real G6_2_2_10_2_10_0_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][0]*g22*g22;
    real G6_2_2_10_2_10_1_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][1]*g22*g02;
    real G6_2_2_10_2_10_2_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][2]*g22*g12;
    real G6_2_2_10_2_10_3_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][3]*g22*g22;
    real G6_2_2_10_2_10_4_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g22*g02;
    real G6_2_2_10_2_10_4_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g22*g12;
    real G6_2_2_10_2_10_4_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][4]*g22*g22;
    real G6_2_2_10_2_10_5_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][5]*g22*g02;
    real G6_2_2_10_2_10_6_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][6]*g22*g12;
    real G6_2_2_10_2_10_7_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][7]*g22*g22;
    real G6_2_2_10_2_10_8_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g22*g02;
    real G6_2_2_10_2_10_8_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g22*g12;
    real G6_2_2_10_2_10_8_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][8]*g22*g22;
    real G6_2_2_10_2_10_9_0 = det*c1*c0*w[0][10]*w[0][10]*w[1][9]*g22*g02;
    real G6_2_2_10_2_10_10_1 = det*c1*c0*w[0][10]*w[0][10]*w[1][10]*g22*g12;
    real G6_2_2_10_2_10_11_2 = det*c1*c0*w[0][10]*w[0][10]*w[1][11]*g22*g22;
    real G6_2_2_10_2_11_0_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g22*g02;
    real G6_2_2_10_2_11_0_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g22*g12;
    real G6_2_2_10_2_11_0_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][0]*g22*g22;
    real G6_2_2_10_2_11_1_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][1]*g22*g02;
    real G6_2_2_10_2_11_2_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][2]*g22*g12;
    real G6_2_2_10_2_11_3_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][3]*g22*g22;
    real G6_2_2_10_2_11_4_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g22*g02;
    real G6_2_2_10_2_11_4_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g22*g12;
    real G6_2_2_10_2_11_4_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][4]*g22*g22;
    real G6_2_2_10_2_11_5_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][5]*g22*g02;
    real G6_2_2_10_2_11_6_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][6]*g22*g12;
    real G6_2_2_10_2_11_7_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][7]*g22*g22;
    real G6_2_2_10_2_11_8_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g22*g02;
    real G6_2_2_10_2_11_8_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g22*g12;
    real G6_2_2_10_2_11_8_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][8]*g22*g22;
    real G6_2_2_10_2_11_9_0 = det*c1*c0*w[0][10]*w[0][11]*w[1][9]*g22*g02;
    real G6_2_2_10_2_11_10_1 = det*c1*c0*w[0][10]*w[0][11]*w[1][10]*g22*g12;
    real G6_2_2_10_2_11_11_2 = det*c1*c0*w[0][10]*w[0][11]*w[1][11]*g22*g22;
    real G6_2_2_11_0_8_0_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g02*g02;
    real G6_2_2_11_0_8_0_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g02*g12;
    real G6_2_2_11_0_8_0_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g02*g22;
    real G6_2_2_11_0_8_1_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][1]*g02*g02;
    real G6_2_2_11_0_8_2_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][2]*g02*g12;
    real G6_2_2_11_0_8_3_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][3]*g02*g22;
    real G6_2_2_11_0_8_4_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g02*g02;
    real G6_2_2_11_0_8_4_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g02*g12;
    real G6_2_2_11_0_8_4_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g02*g22;
    real G6_2_2_11_0_8_5_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][5]*g02*g02;
    real G6_2_2_11_0_8_6_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][6]*g02*g12;
    real G6_2_2_11_0_8_7_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][7]*g02*g22;
    real G6_2_2_11_0_8_8_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g02*g02;
    real G6_2_2_11_0_8_8_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g02*g12;
    real G6_2_2_11_0_8_8_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g02*g22;
    real G6_2_2_11_0_8_9_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][9]*g02*g02;
    real G6_2_2_11_0_8_10_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][10]*g02*g12;
    real G6_2_2_11_0_8_11_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][11]*g02*g22;
    real G6_2_2_11_0_9_0_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g02*g02;
    real G6_2_2_11_0_9_0_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g02*g12;
    real G6_2_2_11_0_9_0_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g02*g22;
    real G6_2_2_11_0_9_1_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][1]*g02*g02;
    real G6_2_2_11_0_9_2_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][2]*g02*g12;
    real G6_2_2_11_0_9_3_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][3]*g02*g22;
    real G6_2_2_11_0_9_4_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g02*g02;
    real G6_2_2_11_0_9_4_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g02*g12;
    real G6_2_2_11_0_9_4_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g02*g22;
    real G6_2_2_11_0_9_5_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][5]*g02*g02;
    real G6_2_2_11_0_9_6_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][6]*g02*g12;
    real G6_2_2_11_0_9_7_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][7]*g02*g22;
    real G6_2_2_11_0_9_8_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g02*g02;
    real G6_2_2_11_0_9_8_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g02*g12;
    real G6_2_2_11_0_9_8_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g02*g22;
    real G6_2_2_11_0_9_9_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][9]*g02*g02;
    real G6_2_2_11_0_9_10_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][10]*g02*g12;
    real G6_2_2_11_0_9_11_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][11]*g02*g22;
    real G6_2_2_11_0_10_0_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g02*g02;
    real G6_2_2_11_0_10_0_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g02*g12;
    real G6_2_2_11_0_10_0_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g02*g22;
    real G6_2_2_11_0_10_1_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][1]*g02*g02;
    real G6_2_2_11_0_10_2_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][2]*g02*g12;
    real G6_2_2_11_0_10_3_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][3]*g02*g22;
    real G6_2_2_11_0_10_4_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g02*g02;
    real G6_2_2_11_0_10_4_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g02*g12;
    real G6_2_2_11_0_10_4_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g02*g22;
    real G6_2_2_11_0_10_5_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][5]*g02*g02;
    real G6_2_2_11_0_10_6_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][6]*g02*g12;
    real G6_2_2_11_0_10_7_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][7]*g02*g22;
    real G6_2_2_11_0_10_8_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g02*g02;
    real G6_2_2_11_0_10_8_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g02*g12;
    real G6_2_2_11_0_10_8_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g02*g22;
    real G6_2_2_11_0_10_9_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][9]*g02*g02;
    real G6_2_2_11_0_10_10_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][10]*g02*g12;
    real G6_2_2_11_0_10_11_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][11]*g02*g22;
    real G6_2_2_11_0_11_0_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g02*g02;
    real G6_2_2_11_0_11_0_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g02*g12;
    real G6_2_2_11_0_11_0_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g02*g22;
    real G6_2_2_11_0_11_1_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][1]*g02*g02;
    real G6_2_2_11_0_11_2_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][2]*g02*g12;
    real G6_2_2_11_0_11_3_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][3]*g02*g22;
    real G6_2_2_11_0_11_4_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g02*g02;
    real G6_2_2_11_0_11_4_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g02*g12;
    real G6_2_2_11_0_11_4_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g02*g22;
    real G6_2_2_11_0_11_5_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][5]*g02*g02;
    real G6_2_2_11_0_11_6_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][6]*g02*g12;
    real G6_2_2_11_0_11_7_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][7]*g02*g22;
    real G6_2_2_11_0_11_8_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g02*g02;
    real G6_2_2_11_0_11_8_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g02*g12;
    real G6_2_2_11_0_11_8_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g02*g22;
    real G6_2_2_11_0_11_9_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][9]*g02*g02;
    real G6_2_2_11_0_11_10_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][10]*g02*g12;
    real G6_2_2_11_0_11_11_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][11]*g02*g22;
    real G6_2_2_11_1_8_0_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g12*g02;
    real G6_2_2_11_1_8_0_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g12*g12;
    real G6_2_2_11_1_8_0_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g12*g22;
    real G6_2_2_11_1_8_1_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][1]*g12*g02;
    real G6_2_2_11_1_8_2_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][2]*g12*g12;
    real G6_2_2_11_1_8_3_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][3]*g12*g22;
    real G6_2_2_11_1_8_4_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g12*g02;
    real G6_2_2_11_1_8_4_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g12*g12;
    real G6_2_2_11_1_8_4_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g12*g22;
    real G6_2_2_11_1_8_5_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][5]*g12*g02;
    real G6_2_2_11_1_8_6_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][6]*g12*g12;
    real G6_2_2_11_1_8_7_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][7]*g12*g22;
    real G6_2_2_11_1_8_8_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g12*g02;
    real G6_2_2_11_1_8_8_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g12*g12;
    real G6_2_2_11_1_8_8_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g12*g22;
    real G6_2_2_11_1_8_9_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][9]*g12*g02;
    real G6_2_2_11_1_8_10_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][10]*g12*g12;
    real G6_2_2_11_1_8_11_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][11]*g12*g22;
    real G6_2_2_11_1_9_0_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g12*g02;
    real G6_2_2_11_1_9_0_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g12*g12;
    real G6_2_2_11_1_9_0_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g12*g22;
    real G6_2_2_11_1_9_1_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][1]*g12*g02;
    real G6_2_2_11_1_9_2_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][2]*g12*g12;
    real G6_2_2_11_1_9_3_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][3]*g12*g22;
    real G6_2_2_11_1_9_4_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g12*g02;
    real G6_2_2_11_1_9_4_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g12*g12;
    real G6_2_2_11_1_9_4_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g12*g22;
    real G6_2_2_11_1_9_5_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][5]*g12*g02;
    real G6_2_2_11_1_9_6_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][6]*g12*g12;
    real G6_2_2_11_1_9_7_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][7]*g12*g22;
    real G6_2_2_11_1_9_8_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g12*g02;
    real G6_2_2_11_1_9_8_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g12*g12;
    real G6_2_2_11_1_9_8_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g12*g22;
    real G6_2_2_11_1_9_9_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][9]*g12*g02;
    real G6_2_2_11_1_9_10_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][10]*g12*g12;
    real G6_2_2_11_1_9_11_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][11]*g12*g22;
    real G6_2_2_11_1_10_0_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g12*g02;
    real G6_2_2_11_1_10_0_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g12*g12;
    real G6_2_2_11_1_10_0_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g12*g22;
    real G6_2_2_11_1_10_1_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][1]*g12*g02;
    real G6_2_2_11_1_10_2_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][2]*g12*g12;
    real G6_2_2_11_1_10_3_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][3]*g12*g22;
    real G6_2_2_11_1_10_4_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g12*g02;
    real G6_2_2_11_1_10_4_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g12*g12;
    real G6_2_2_11_1_10_4_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g12*g22;
    real G6_2_2_11_1_10_5_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][5]*g12*g02;
    real G6_2_2_11_1_10_6_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][6]*g12*g12;
    real G6_2_2_11_1_10_7_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][7]*g12*g22;
    real G6_2_2_11_1_10_8_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g12*g02;
    real G6_2_2_11_1_10_8_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g12*g12;
    real G6_2_2_11_1_10_8_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g12*g22;
    real G6_2_2_11_1_10_9_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][9]*g12*g02;
    real G6_2_2_11_1_10_10_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][10]*g12*g12;
    real G6_2_2_11_1_10_11_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][11]*g12*g22;
    real G6_2_2_11_1_11_0_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g12*g02;
    real G6_2_2_11_1_11_0_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g12*g12;
    real G6_2_2_11_1_11_0_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g12*g22;
    real G6_2_2_11_1_11_1_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][1]*g12*g02;
    real G6_2_2_11_1_11_2_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][2]*g12*g12;
    real G6_2_2_11_1_11_3_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][3]*g12*g22;
    real G6_2_2_11_1_11_4_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g12*g02;
    real G6_2_2_11_1_11_4_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g12*g12;
    real G6_2_2_11_1_11_4_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g12*g22;
    real G6_2_2_11_1_11_5_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][5]*g12*g02;
    real G6_2_2_11_1_11_6_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][6]*g12*g12;
    real G6_2_2_11_1_11_7_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][7]*g12*g22;
    real G6_2_2_11_1_11_8_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g12*g02;
    real G6_2_2_11_1_11_8_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g12*g12;
    real G6_2_2_11_1_11_8_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g12*g22;
    real G6_2_2_11_1_11_9_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][9]*g12*g02;
    real G6_2_2_11_1_11_10_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][10]*g12*g12;
    real G6_2_2_11_1_11_11_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][11]*g12*g22;
    real G6_2_2_11_2_8_0_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g22*g02;
    real G6_2_2_11_2_8_0_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g22*g12;
    real G6_2_2_11_2_8_0_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][0]*g22*g22;
    real G6_2_2_11_2_8_1_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][1]*g22*g02;
    real G6_2_2_11_2_8_2_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][2]*g22*g12;
    real G6_2_2_11_2_8_3_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][3]*g22*g22;
    real G6_2_2_11_2_8_4_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g22*g02;
    real G6_2_2_11_2_8_4_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g22*g12;
    real G6_2_2_11_2_8_4_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][4]*g22*g22;
    real G6_2_2_11_2_8_5_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][5]*g22*g02;
    real G6_2_2_11_2_8_6_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][6]*g22*g12;
    real G6_2_2_11_2_8_7_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][7]*g22*g22;
    real G6_2_2_11_2_8_8_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g22*g02;
    real G6_2_2_11_2_8_8_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g22*g12;
    real G6_2_2_11_2_8_8_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][8]*g22*g22;
    real G6_2_2_11_2_8_9_0 = det*c1*c0*w[0][11]*w[0][8]*w[1][9]*g22*g02;
    real G6_2_2_11_2_8_10_1 = det*c1*c0*w[0][11]*w[0][8]*w[1][10]*g22*g12;
    real G6_2_2_11_2_8_11_2 = det*c1*c0*w[0][11]*w[0][8]*w[1][11]*g22*g22;
    real G6_2_2_11_2_9_0_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g22*g02;
    real G6_2_2_11_2_9_0_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g22*g12;
    real G6_2_2_11_2_9_0_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][0]*g22*g22;
    real G6_2_2_11_2_9_1_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][1]*g22*g02;
    real G6_2_2_11_2_9_2_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][2]*g22*g12;
    real G6_2_2_11_2_9_3_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][3]*g22*g22;
    real G6_2_2_11_2_9_4_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g22*g02;
    real G6_2_2_11_2_9_4_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g22*g12;
    real G6_2_2_11_2_9_4_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][4]*g22*g22;
    real G6_2_2_11_2_9_5_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][5]*g22*g02;
    real G6_2_2_11_2_9_6_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][6]*g22*g12;
    real G6_2_2_11_2_9_7_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][7]*g22*g22;
    real G6_2_2_11_2_9_8_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g22*g02;
    real G6_2_2_11_2_9_8_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g22*g12;
    real G6_2_2_11_2_9_8_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][8]*g22*g22;
    real G6_2_2_11_2_9_9_0 = det*c1*c0*w[0][11]*w[0][9]*w[1][9]*g22*g02;
    real G6_2_2_11_2_9_10_1 = det*c1*c0*w[0][11]*w[0][9]*w[1][10]*g22*g12;
    real G6_2_2_11_2_9_11_2 = det*c1*c0*w[0][11]*w[0][9]*w[1][11]*g22*g22;
    real G6_2_2_11_2_10_0_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g22*g02;
    real G6_2_2_11_2_10_0_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g22*g12;
    real G6_2_2_11_2_10_0_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][0]*g22*g22;
    real G6_2_2_11_2_10_1_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][1]*g22*g02;
    real G6_2_2_11_2_10_2_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][2]*g22*g12;
    real G6_2_2_11_2_10_3_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][3]*g22*g22;
    real G6_2_2_11_2_10_4_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g22*g02;
    real G6_2_2_11_2_10_4_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g22*g12;
    real G6_2_2_11_2_10_4_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][4]*g22*g22;
    real G6_2_2_11_2_10_5_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][5]*g22*g02;
    real G6_2_2_11_2_10_6_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][6]*g22*g12;
    real G6_2_2_11_2_10_7_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][7]*g22*g22;
    real G6_2_2_11_2_10_8_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g22*g02;
    real G6_2_2_11_2_10_8_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g22*g12;
    real G6_2_2_11_2_10_8_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][8]*g22*g22;
    real G6_2_2_11_2_10_9_0 = det*c1*c0*w[0][11]*w[0][10]*w[1][9]*g22*g02;
    real G6_2_2_11_2_10_10_1 = det*c1*c0*w[0][11]*w[0][10]*w[1][10]*g22*g12;
    real G6_2_2_11_2_10_11_2 = det*c1*c0*w[0][11]*w[0][10]*w[1][11]*g22*g22;
    real G6_2_2_11_2_11_0_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g22*g02;
    real G6_2_2_11_2_11_0_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g22*g12;
    real G6_2_2_11_2_11_0_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][0]*g22*g22;
    real G6_2_2_11_2_11_1_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][1]*g22*g02;
    real G6_2_2_11_2_11_2_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][2]*g22*g12;
    real G6_2_2_11_2_11_3_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][3]*g22*g22;
    real G6_2_2_11_2_11_4_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g22*g02;
    real G6_2_2_11_2_11_4_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g22*g12;
    real G6_2_2_11_2_11_4_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][4]*g22*g22;
    real G6_2_2_11_2_11_5_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][5]*g22*g02;
    real G6_2_2_11_2_11_6_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][6]*g22*g12;
    real G6_2_2_11_2_11_7_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][7]*g22*g22;
    real G6_2_2_11_2_11_8_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g22*g02;
    real G6_2_2_11_2_11_8_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g22*g12;
    real G6_2_2_11_2_11_8_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][8]*g22*g22;
    real G6_2_2_11_2_11_9_0 = det*c1*c0*w[0][11]*w[0][11]*w[1][9]*g22*g02;
    real G6_2_2_11_2_11_10_1 = det*c1*c0*w[0][11]*w[0][11]*w[1][10]*g22*g12;
    real G6_2_2_11_2_11_11_2 = det*c1*c0*w[0][11]*w[0][11]*w[1][11]*g22*g22;
    real G7_0_0_0_0_0_0 = det*c1*c0*w[0][0]*w[3][0]*g00*g00;
    real G7_0_0_0_0_0_1 = det*c1*c0*w[0][0]*w[3][0]*g00*g10;
    real G7_0_0_0_0_0_2 = det*c1*c0*w[0][0]*w[3][0]*g00*g20;
    real G7_0_0_0_0_1_0 = det*c1*c0*w[0][0]*w[3][1]*g00*g00;
    real G7_0_0_0_0_2_1 = det*c1*c0*w[0][0]*w[3][2]*g00*g10;
    real G7_0_0_0_0_3_2 = det*c1*c0*w[0][0]*w[3][3]*g00*g20;
    real G7_0_0_0_1_0_0 = det*c1*c0*w[0][0]*w[3][0]*g10*g00;
    real G7_0_0_0_1_0_1 = det*c1*c0*w[0][0]*w[3][0]*g10*g10;
    real G7_0_0_0_1_0_2 = det*c1*c0*w[0][0]*w[3][0]*g10*g20;
    real G7_0_0_0_1_1_0 = det*c1*c0*w[0][0]*w[3][1]*g10*g00;
    real G7_0_0_0_1_2_1 = det*c1*c0*w[0][0]*w[3][2]*g10*g10;
    real G7_0_0_0_1_3_2 = det*c1*c0*w[0][0]*w[3][3]*g10*g20;
    real G7_0_0_0_2_0_0 = det*c1*c0*w[0][0]*w[3][0]*g20*g00;
    real G7_0_0_0_2_0_1 = det*c1*c0*w[0][0]*w[3][0]*g20*g10;
    real G7_0_0_0_2_0_2 = det*c1*c0*w[0][0]*w[3][0]*g20*g20;
    real G7_0_0_0_2_1_0 = det*c1*c0*w[0][0]*w[3][1]*g20*g00;
    real G7_0_0_0_2_2_1 = det*c1*c0*w[0][0]*w[3][2]*g20*g10;
    real G7_0_0_0_2_3_2 = det*c1*c0*w[0][0]*w[3][3]*g20*g20;
    real G7_0_0_1_0_0_0 = det*c1*c0*w[0][1]*w[3][0]*g00*g00;
    real G7_0_0_1_0_0_1 = det*c1*c0*w[0][1]*w[3][0]*g00*g10;
    real G7_0_0_1_0_0_2 = det*c1*c0*w[0][1]*w[3][0]*g00*g20;
    real G7_0_0_1_0_1_0 = det*c1*c0*w[0][1]*w[3][1]*g00*g00;
    real G7_0_0_1_0_2_1 = det*c1*c0*w[0][1]*w[3][2]*g00*g10;
    real G7_0_0_1_0_3_2 = det*c1*c0*w[0][1]*w[3][3]*g00*g20;
    real G7_0_0_1_1_0_0 = det*c1*c0*w[0][1]*w[3][0]*g10*g00;
    real G7_0_0_1_1_0_1 = det*c1*c0*w[0][1]*w[3][0]*g10*g10;
    real G7_0_0_1_1_0_2 = det*c1*c0*w[0][1]*w[3][0]*g10*g20;
    real G7_0_0_1_1_1_0 = det*c1*c0*w[0][1]*w[3][1]*g10*g00;
    real G7_0_0_1_1_2_1 = det*c1*c0*w[0][1]*w[3][2]*g10*g10;
    real G7_0_0_1_1_3_2 = det*c1*c0*w[0][1]*w[3][3]*g10*g20;
    real G7_0_0_1_2_0_0 = det*c1*c0*w[0][1]*w[3][0]*g20*g00;
    real G7_0_0_1_2_0_1 = det*c1*c0*w[0][1]*w[3][0]*g20*g10;
    real G7_0_0_1_2_0_2 = det*c1*c0*w[0][1]*w[3][0]*g20*g20;
    real G7_0_0_1_2_1_0 = det*c1*c0*w[0][1]*w[3][1]*g20*g00;
    real G7_0_0_1_2_2_1 = det*c1*c0*w[0][1]*w[3][2]*g20*g10;
    real G7_0_0_1_2_3_2 = det*c1*c0*w[0][1]*w[3][3]*g20*g20;
    real G7_0_0_2_0_0_0 = det*c1*c0*w[0][2]*w[3][0]*g00*g00;
    real G7_0_0_2_0_0_1 = det*c1*c0*w[0][2]*w[3][0]*g00*g10;
    real G7_0_0_2_0_0_2 = det*c1*c0*w[0][2]*w[3][0]*g00*g20;
    real G7_0_0_2_0_1_0 = det*c1*c0*w[0][2]*w[3][1]*g00*g00;
    real G7_0_0_2_0_2_1 = det*c1*c0*w[0][2]*w[3][2]*g00*g10;
    real G7_0_0_2_0_3_2 = det*c1*c0*w[0][2]*w[3][3]*g00*g20;
    real G7_0_0_2_1_0_0 = det*c1*c0*w[0][2]*w[3][0]*g10*g00;
    real G7_0_0_2_1_0_1 = det*c1*c0*w[0][2]*w[3][0]*g10*g10;
    real G7_0_0_2_1_0_2 = det*c1*c0*w[0][2]*w[3][0]*g10*g20;
    real G7_0_0_2_1_1_0 = det*c1*c0*w[0][2]*w[3][1]*g10*g00;
    real G7_0_0_2_1_2_1 = det*c1*c0*w[0][2]*w[3][2]*g10*g10;
    real G7_0_0_2_1_3_2 = det*c1*c0*w[0][2]*w[3][3]*g10*g20;
    real G7_0_0_2_2_0_0 = det*c1*c0*w[0][2]*w[3][0]*g20*g00;
    real G7_0_0_2_2_0_1 = det*c1*c0*w[0][2]*w[3][0]*g20*g10;
    real G7_0_0_2_2_0_2 = det*c1*c0*w[0][2]*w[3][0]*g20*g20;
    real G7_0_0_2_2_1_0 = det*c1*c0*w[0][2]*w[3][1]*g20*g00;
    real G7_0_0_2_2_2_1 = det*c1*c0*w[0][2]*w[3][2]*g20*g10;
    real G7_0_0_2_2_3_2 = det*c1*c0*w[0][2]*w[3][3]*g20*g20;
    real G7_0_0_3_0_0_0 = det*c1*c0*w[0][3]*w[3][0]*g00*g00;
    real G7_0_0_3_0_0_1 = det*c1*c0*w[0][3]*w[3][0]*g00*g10;
    real G7_0_0_3_0_0_2 = det*c1*c0*w[0][3]*w[3][0]*g00*g20;
    real G7_0_0_3_0_1_0 = det*c1*c0*w[0][3]*w[3][1]*g00*g00;
    real G7_0_0_3_0_2_1 = det*c1*c0*w[0][3]*w[3][2]*g00*g10;
    real G7_0_0_3_0_3_2 = det*c1*c0*w[0][3]*w[3][3]*g00*g20;
    real G7_0_0_3_1_0_0 = det*c1*c0*w[0][3]*w[3][0]*g10*g00;
    real G7_0_0_3_1_0_1 = det*c1*c0*w[0][3]*w[3][0]*g10*g10;
    real G7_0_0_3_1_0_2 = det*c1*c0*w[0][3]*w[3][0]*g10*g20;
    real G7_0_0_3_1_1_0 = det*c1*c0*w[0][3]*w[3][1]*g10*g00;
    real G7_0_0_3_1_2_1 = det*c1*c0*w[0][3]*w[3][2]*g10*g10;
    real G7_0_0_3_1_3_2 = det*c1*c0*w[0][3]*w[3][3]*g10*g20;
    real G7_0_0_3_2_0_0 = det*c1*c0*w[0][3]*w[3][0]*g20*g00;
    real G7_0_0_3_2_0_1 = det*c1*c0*w[0][3]*w[3][0]*g20*g10;
    real G7_0_0_3_2_0_2 = det*c1*c0*w[0][3]*w[3][0]*g20*g20;
    real G7_0_0_3_2_1_0 = det*c1*c0*w[0][3]*w[3][1]*g20*g00;
    real G7_0_0_3_2_2_1 = det*c1*c0*w[0][3]*w[3][2]*g20*g10;
    real G7_0_0_3_2_3_2 = det*c1*c0*w[0][3]*w[3][3]*g20*g20;
    real G7_0_1_4_0_0_0 = det*c1*c0*w[0][4]*w[3][0]*g01*g00;
    real G7_0_1_4_0_0_1 = det*c1*c0*w[0][4]*w[3][0]*g01*g10;
    real G7_0_1_4_0_0_2 = det*c1*c0*w[0][4]*w[3][0]*g01*g20;
    real G7_0_1_4_0_1_0 = det*c1*c0*w[0][4]*w[3][1]*g01*g00;
    real G7_0_1_4_0_2_1 = det*c1*c0*w[0][4]*w[3][2]*g01*g10;
    real G7_0_1_4_0_3_2 = det*c1*c0*w[0][4]*w[3][3]*g01*g20;
    real G7_0_1_4_1_0_0 = det*c1*c0*w[0][4]*w[3][0]*g11*g00;
    real G7_0_1_4_1_0_1 = det*c1*c0*w[0][4]*w[3][0]*g11*g10;
    real G7_0_1_4_1_0_2 = det*c1*c0*w[0][4]*w[3][0]*g11*g20;
    real G7_0_1_4_1_1_0 = det*c1*c0*w[0][4]*w[3][1]*g11*g00;
    real G7_0_1_4_1_2_1 = det*c1*c0*w[0][4]*w[3][2]*g11*g10;
    real G7_0_1_4_1_3_2 = det*c1*c0*w[0][4]*w[3][3]*g11*g20;
    real G7_0_1_4_2_0_0 = det*c1*c0*w[0][4]*w[3][0]*g21*g00;
    real G7_0_1_4_2_0_1 = det*c1*c0*w[0][4]*w[3][0]*g21*g10;
    real G7_0_1_4_2_0_2 = det*c1*c0*w[0][4]*w[3][0]*g21*g20;
    real G7_0_1_4_2_1_0 = det*c1*c0*w[0][4]*w[3][1]*g21*g00;
    real G7_0_1_4_2_2_1 = det*c1*c0*w[0][4]*w[3][2]*g21*g10;
    real G7_0_1_4_2_3_2 = det*c1*c0*w[0][4]*w[3][3]*g21*g20;
    real G7_0_1_5_0_0_0 = det*c1*c0*w[0][5]*w[3][0]*g01*g00;
    real G7_0_1_5_0_0_1 = det*c1*c0*w[0][5]*w[3][0]*g01*g10;
    real G7_0_1_5_0_0_2 = det*c1*c0*w[0][5]*w[3][0]*g01*g20;
    real G7_0_1_5_0_1_0 = det*c1*c0*w[0][5]*w[3][1]*g01*g00;
    real G7_0_1_5_0_2_1 = det*c1*c0*w[0][5]*w[3][2]*g01*g10;
    real G7_0_1_5_0_3_2 = det*c1*c0*w[0][5]*w[3][3]*g01*g20;
    real G7_0_1_5_1_0_0 = det*c1*c0*w[0][5]*w[3][0]*g11*g00;
    real G7_0_1_5_1_0_1 = det*c1*c0*w[0][5]*w[3][0]*g11*g10;
    real G7_0_1_5_1_0_2 = det*c1*c0*w[0][5]*w[3][0]*g11*g20;
    real G7_0_1_5_1_1_0 = det*c1*c0*w[0][5]*w[3][1]*g11*g00;
    real G7_0_1_5_1_2_1 = det*c1*c0*w[0][5]*w[3][2]*g11*g10;
    real G7_0_1_5_1_3_2 = det*c1*c0*w[0][5]*w[3][3]*g11*g20;
    real G7_0_1_5_2_0_0 = det*c1*c0*w[0][5]*w[3][0]*g21*g00;
    real G7_0_1_5_2_0_1 = det*c1*c0*w[0][5]*w[3][0]*g21*g10;
    real G7_0_1_5_2_0_2 = det*c1*c0*w[0][5]*w[3][0]*g21*g20;
    real G7_0_1_5_2_1_0 = det*c1*c0*w[0][5]*w[3][1]*g21*g00;
    real G7_0_1_5_2_2_1 = det*c1*c0*w[0][5]*w[3][2]*g21*g10;
    real G7_0_1_5_2_3_2 = det*c1*c0*w[0][5]*w[3][3]*g21*g20;
    real G7_0_1_6_0_0_0 = det*c1*c0*w[0][6]*w[3][0]*g01*g00;
    real G7_0_1_6_0_0_1 = det*c1*c0*w[0][6]*w[3][0]*g01*g10;
    real G7_0_1_6_0_0_2 = det*c1*c0*w[0][6]*w[3][0]*g01*g20;
    real G7_0_1_6_0_1_0 = det*c1*c0*w[0][6]*w[3][1]*g01*g00;
    real G7_0_1_6_0_2_1 = det*c1*c0*w[0][6]*w[3][2]*g01*g10;
    real G7_0_1_6_0_3_2 = det*c1*c0*w[0][6]*w[3][3]*g01*g20;
    real G7_0_1_6_1_0_0 = det*c1*c0*w[0][6]*w[3][0]*g11*g00;
    real G7_0_1_6_1_0_1 = det*c1*c0*w[0][6]*w[3][0]*g11*g10;
    real G7_0_1_6_1_0_2 = det*c1*c0*w[0][6]*w[3][0]*g11*g20;
    real G7_0_1_6_1_1_0 = det*c1*c0*w[0][6]*w[3][1]*g11*g00;
    real G7_0_1_6_1_2_1 = det*c1*c0*w[0][6]*w[3][2]*g11*g10;
    real G7_0_1_6_1_3_2 = det*c1*c0*w[0][6]*w[3][3]*g11*g20;
    real G7_0_1_6_2_0_0 = det*c1*c0*w[0][6]*w[3][0]*g21*g00;
    real G7_0_1_6_2_0_1 = det*c1*c0*w[0][6]*w[3][0]*g21*g10;
    real G7_0_1_6_2_0_2 = det*c1*c0*w[0][6]*w[3][0]*g21*g20;
    real G7_0_1_6_2_1_0 = det*c1*c0*w[0][6]*w[3][1]*g21*g00;
    real G7_0_1_6_2_2_1 = det*c1*c0*w[0][6]*w[3][2]*g21*g10;
    real G7_0_1_6_2_3_2 = det*c1*c0*w[0][6]*w[3][3]*g21*g20;
    real G7_0_1_7_0_0_0 = det*c1*c0*w[0][7]*w[3][0]*g01*g00;
    real G7_0_1_7_0_0_1 = det*c1*c0*w[0][7]*w[3][0]*g01*g10;
    real G7_0_1_7_0_0_2 = det*c1*c0*w[0][7]*w[3][0]*g01*g20;
    real G7_0_1_7_0_1_0 = det*c1*c0*w[0][7]*w[3][1]*g01*g00;
    real G7_0_1_7_0_2_1 = det*c1*c0*w[0][7]*w[3][2]*g01*g10;
    real G7_0_1_7_0_3_2 = det*c1*c0*w[0][7]*w[3][3]*g01*g20;
    real G7_0_1_7_1_0_0 = det*c1*c0*w[0][7]*w[3][0]*g11*g00;
    real G7_0_1_7_1_0_1 = det*c1*c0*w[0][7]*w[3][0]*g11*g10;
    real G7_0_1_7_1_0_2 = det*c1*c0*w[0][7]*w[3][0]*g11*g20;
    real G7_0_1_7_1_1_0 = det*c1*c0*w[0][7]*w[3][1]*g11*g00;
    real G7_0_1_7_1_2_1 = det*c1*c0*w[0][7]*w[3][2]*g11*g10;
    real G7_0_1_7_1_3_2 = det*c1*c0*w[0][7]*w[3][3]*g11*g20;
    real G7_0_1_7_2_0_0 = det*c1*c0*w[0][7]*w[3][0]*g21*g00;
    real G7_0_1_7_2_0_1 = det*c1*c0*w[0][7]*w[3][0]*g21*g10;
    real G7_0_1_7_2_0_2 = det*c1*c0*w[0][7]*w[3][0]*g21*g20;
    real G7_0_1_7_2_1_0 = det*c1*c0*w[0][7]*w[3][1]*g21*g00;
    real G7_0_1_7_2_2_1 = det*c1*c0*w[0][7]*w[3][2]*g21*g10;
    real G7_0_1_7_2_3_2 = det*c1*c0*w[0][7]*w[3][3]*g21*g20;
    real G7_0_2_8_0_0_0 = det*c1*c0*w[0][8]*w[3][0]*g02*g00;
    real G7_0_2_8_0_0_1 = det*c1*c0*w[0][8]*w[3][0]*g02*g10;
    real G7_0_2_8_0_0_2 = det*c1*c0*w[0][8]*w[3][0]*g02*g20;
    real G7_0_2_8_0_1_0 = det*c1*c0*w[0][8]*w[3][1]*g02*g00;
    real G7_0_2_8_0_2_1 = det*c1*c0*w[0][8]*w[3][2]*g02*g10;
    real G7_0_2_8_0_3_2 = det*c1*c0*w[0][8]*w[3][3]*g02*g20;
    real G7_0_2_8_1_0_0 = det*c1*c0*w[0][8]*w[3][0]*g12*g00;
    real G7_0_2_8_1_0_1 = det*c1*c0*w[0][8]*w[3][0]*g12*g10;
    real G7_0_2_8_1_0_2 = det*c1*c0*w[0][8]*w[3][0]*g12*g20;
    real G7_0_2_8_1_1_0 = det*c1*c0*w[0][8]*w[3][1]*g12*g00;
    real G7_0_2_8_1_2_1 = det*c1*c0*w[0][8]*w[3][2]*g12*g10;
    real G7_0_2_8_1_3_2 = det*c1*c0*w[0][8]*w[3][3]*g12*g20;
    real G7_0_2_8_2_0_0 = det*c1*c0*w[0][8]*w[3][0]*g22*g00;
    real G7_0_2_8_2_0_1 = det*c1*c0*w[0][8]*w[3][0]*g22*g10;
    real G7_0_2_8_2_0_2 = det*c1*c0*w[0][8]*w[3][0]*g22*g20;
    real G7_0_2_8_2_1_0 = det*c1*c0*w[0][8]*w[3][1]*g22*g00;
    real G7_0_2_8_2_2_1 = det*c1*c0*w[0][8]*w[3][2]*g22*g10;
    real G7_0_2_8_2_3_2 = det*c1*c0*w[0][8]*w[3][3]*g22*g20;
    real G7_0_2_9_0_0_0 = det*c1*c0*w[0][9]*w[3][0]*g02*g00;
    real G7_0_2_9_0_0_1 = det*c1*c0*w[0][9]*w[3][0]*g02*g10;
    real G7_0_2_9_0_0_2 = det*c1*c0*w[0][9]*w[3][0]*g02*g20;
    real G7_0_2_9_0_1_0 = det*c1*c0*w[0][9]*w[3][1]*g02*g00;
    real G7_0_2_9_0_2_1 = det*c1*c0*w[0][9]*w[3][2]*g02*g10;
    real G7_0_2_9_0_3_2 = det*c1*c0*w[0][9]*w[3][3]*g02*g20;
    real G7_0_2_9_1_0_0 = det*c1*c0*w[0][9]*w[3][0]*g12*g00;
    real G7_0_2_9_1_0_1 = det*c1*c0*w[0][9]*w[3][0]*g12*g10;
    real G7_0_2_9_1_0_2 = det*c1*c0*w[0][9]*w[3][0]*g12*g20;
    real G7_0_2_9_1_1_0 = det*c1*c0*w[0][9]*w[3][1]*g12*g00;
    real G7_0_2_9_1_2_1 = det*c1*c0*w[0][9]*w[3][2]*g12*g10;
    real G7_0_2_9_1_3_2 = det*c1*c0*w[0][9]*w[3][3]*g12*g20;
    real G7_0_2_9_2_0_0 = det*c1*c0*w[0][9]*w[3][0]*g22*g00;
    real G7_0_2_9_2_0_1 = det*c1*c0*w[0][9]*w[3][0]*g22*g10;
    real G7_0_2_9_2_0_2 = det*c1*c0*w[0][9]*w[3][0]*g22*g20;
    real G7_0_2_9_2_1_0 = det*c1*c0*w[0][9]*w[3][1]*g22*g00;
    real G7_0_2_9_2_2_1 = det*c1*c0*w[0][9]*w[3][2]*g22*g10;
    real G7_0_2_9_2_3_2 = det*c1*c0*w[0][9]*w[3][3]*g22*g20;
    real G7_0_2_10_0_0_0 = det*c1*c0*w[0][10]*w[3][0]*g02*g00;
    real G7_0_2_10_0_0_1 = det*c1*c0*w[0][10]*w[3][0]*g02*g10;
    real G7_0_2_10_0_0_2 = det*c1*c0*w[0][10]*w[3][0]*g02*g20;
    real G7_0_2_10_0_1_0 = det*c1*c0*w[0][10]*w[3][1]*g02*g00;
    real G7_0_2_10_0_2_1 = det*c1*c0*w[0][10]*w[3][2]*g02*g10;
    real G7_0_2_10_0_3_2 = det*c1*c0*w[0][10]*w[3][3]*g02*g20;
    real G7_0_2_10_1_0_0 = det*c1*c0*w[0][10]*w[3][0]*g12*g00;
    real G7_0_2_10_1_0_1 = det*c1*c0*w[0][10]*w[3][0]*g12*g10;
    real G7_0_2_10_1_0_2 = det*c1*c0*w[0][10]*w[3][0]*g12*g20;
    real G7_0_2_10_1_1_0 = det*c1*c0*w[0][10]*w[3][1]*g12*g00;
    real G7_0_2_10_1_2_1 = det*c1*c0*w[0][10]*w[3][2]*g12*g10;
    real G7_0_2_10_1_3_2 = det*c1*c0*w[0][10]*w[3][3]*g12*g20;
    real G7_0_2_10_2_0_0 = det*c1*c0*w[0][10]*w[3][0]*g22*g00;
    real G7_0_2_10_2_0_1 = det*c1*c0*w[0][10]*w[3][0]*g22*g10;
    real G7_0_2_10_2_0_2 = det*c1*c0*w[0][10]*w[3][0]*g22*g20;
    real G7_0_2_10_2_1_0 = det*c1*c0*w[0][10]*w[3][1]*g22*g00;
    real G7_0_2_10_2_2_1 = det*c1*c0*w[0][10]*w[3][2]*g22*g10;
    real G7_0_2_10_2_3_2 = det*c1*c0*w[0][10]*w[3][3]*g22*g20;
    real G7_0_2_11_0_0_0 = det*c1*c0*w[0][11]*w[3][0]*g02*g00;
    real G7_0_2_11_0_0_1 = det*c1*c0*w[0][11]*w[3][0]*g02*g10;
    real G7_0_2_11_0_0_2 = det*c1*c0*w[0][11]*w[3][0]*g02*g20;
    real G7_0_2_11_0_1_0 = det*c1*c0*w[0][11]*w[3][1]*g02*g00;
    real G7_0_2_11_0_2_1 = det*c1*c0*w[0][11]*w[3][2]*g02*g10;
    real G7_0_2_11_0_3_2 = det*c1*c0*w[0][11]*w[3][3]*g02*g20;
    real G7_0_2_11_1_0_0 = det*c1*c0*w[0][11]*w[3][0]*g12*g00;
    real G7_0_2_11_1_0_1 = det*c1*c0*w[0][11]*w[3][0]*g12*g10;
    real G7_0_2_11_1_0_2 = det*c1*c0*w[0][11]*w[3][0]*g12*g20;
    real G7_0_2_11_1_1_0 = det*c1*c0*w[0][11]*w[3][1]*g12*g00;
    real G7_0_2_11_1_2_1 = det*c1*c0*w[0][11]*w[3][2]*g12*g10;
    real G7_0_2_11_1_3_2 = det*c1*c0*w[0][11]*w[3][3]*g12*g20;
    real G7_0_2_11_2_0_0 = det*c1*c0*w[0][11]*w[3][0]*g22*g00;
    real G7_0_2_11_2_0_1 = det*c1*c0*w[0][11]*w[3][0]*g22*g10;
    real G7_0_2_11_2_0_2 = det*c1*c0*w[0][11]*w[3][0]*g22*g20;
    real G7_0_2_11_2_1_0 = det*c1*c0*w[0][11]*w[3][1]*g22*g00;
    real G7_0_2_11_2_2_1 = det*c1*c0*w[0][11]*w[3][2]*g22*g10;
    real G7_0_2_11_2_3_2 = det*c1*c0*w[0][11]*w[3][3]*g22*g20;
    real G7_1_0_0_0_0_0 = det*c1*c0*w[0][0]*w[3][0]*g00*g01;
    real G7_1_0_0_0_0_1 = det*c1*c0*w[0][0]*w[3][0]*g00*g11;
    real G7_1_0_0_0_0_2 = det*c1*c0*w[0][0]*w[3][0]*g00*g21;
    real G7_1_0_0_0_1_0 = det*c1*c0*w[0][0]*w[3][1]*g00*g01;
    real G7_1_0_0_0_2_1 = det*c1*c0*w[0][0]*w[3][2]*g00*g11;
    real G7_1_0_0_0_3_2 = det*c1*c0*w[0][0]*w[3][3]*g00*g21;
    real G7_1_0_0_1_0_0 = det*c1*c0*w[0][0]*w[3][0]*g10*g01;
    real G7_1_0_0_1_0_1 = det*c1*c0*w[0][0]*w[3][0]*g10*g11;
    real G7_1_0_0_1_0_2 = det*c1*c0*w[0][0]*w[3][0]*g10*g21;
    real G7_1_0_0_1_1_0 = det*c1*c0*w[0][0]*w[3][1]*g10*g01;
    real G7_1_0_0_1_2_1 = det*c1*c0*w[0][0]*w[3][2]*g10*g11;
    real G7_1_0_0_1_3_2 = det*c1*c0*w[0][0]*w[3][3]*g10*g21;
    real G7_1_0_0_2_0_0 = det*c1*c0*w[0][0]*w[3][0]*g20*g01;
    real G7_1_0_0_2_0_1 = det*c1*c0*w[0][0]*w[3][0]*g20*g11;
    real G7_1_0_0_2_0_2 = det*c1*c0*w[0][0]*w[3][0]*g20*g21;
    real G7_1_0_0_2_1_0 = det*c1*c0*w[0][0]*w[3][1]*g20*g01;
    real G7_1_0_0_2_2_1 = det*c1*c0*w[0][0]*w[3][2]*g20*g11;
    real G7_1_0_0_2_3_2 = det*c1*c0*w[0][0]*w[3][3]*g20*g21;
    real G7_1_0_1_0_0_0 = det*c1*c0*w[0][1]*w[3][0]*g00*g01;
    real G7_1_0_1_0_0_1 = det*c1*c0*w[0][1]*w[3][0]*g00*g11;
    real G7_1_0_1_0_0_2 = det*c1*c0*w[0][1]*w[3][0]*g00*g21;
    real G7_1_0_1_0_1_0 = det*c1*c0*w[0][1]*w[3][1]*g00*g01;
    real G7_1_0_1_0_2_1 = det*c1*c0*w[0][1]*w[3][2]*g00*g11;
    real G7_1_0_1_0_3_2 = det*c1*c0*w[0][1]*w[3][3]*g00*g21;
    real G7_1_0_1_1_0_0 = det*c1*c0*w[0][1]*w[3][0]*g10*g01;
    real G7_1_0_1_1_0_1 = det*c1*c0*w[0][1]*w[3][0]*g10*g11;
    real G7_1_0_1_1_0_2 = det*c1*c0*w[0][1]*w[3][0]*g10*g21;
    real G7_1_0_1_1_1_0 = det*c1*c0*w[0][1]*w[3][1]*g10*g01;
    real G7_1_0_1_1_2_1 = det*c1*c0*w[0][1]*w[3][2]*g10*g11;
    real G7_1_0_1_1_3_2 = det*c1*c0*w[0][1]*w[3][3]*g10*g21;
    real G7_1_0_1_2_0_0 = det*c1*c0*w[0][1]*w[3][0]*g20*g01;
    real G7_1_0_1_2_0_1 = det*c1*c0*w[0][1]*w[3][0]*g20*g11;
    real G7_1_0_1_2_0_2 = det*c1*c0*w[0][1]*w[3][0]*g20*g21;
    real G7_1_0_1_2_1_0 = det*c1*c0*w[0][1]*w[3][1]*g20*g01;
    real G7_1_0_1_2_2_1 = det*c1*c0*w[0][1]*w[3][2]*g20*g11;
    real G7_1_0_1_2_3_2 = det*c1*c0*w[0][1]*w[3][3]*g20*g21;
    real G7_1_0_2_0_0_0 = det*c1*c0*w[0][2]*w[3][0]*g00*g01;
    real G7_1_0_2_0_0_1 = det*c1*c0*w[0][2]*w[3][0]*g00*g11;
    real G7_1_0_2_0_0_2 = det*c1*c0*w[0][2]*w[3][0]*g00*g21;
    real G7_1_0_2_0_1_0 = det*c1*c0*w[0][2]*w[3][1]*g00*g01;
    real G7_1_0_2_0_2_1 = det*c1*c0*w[0][2]*w[3][2]*g00*g11;
    real G7_1_0_2_0_3_2 = det*c1*c0*w[0][2]*w[3][3]*g00*g21;
    real G7_1_0_2_1_0_0 = det*c1*c0*w[0][2]*w[3][0]*g10*g01;
    real G7_1_0_2_1_0_1 = det*c1*c0*w[0][2]*w[3][0]*g10*g11;
    real G7_1_0_2_1_0_2 = det*c1*c0*w[0][2]*w[3][0]*g10*g21;
    real G7_1_0_2_1_1_0 = det*c1*c0*w[0][2]*w[3][1]*g10*g01;
    real G7_1_0_2_1_2_1 = det*c1*c0*w[0][2]*w[3][2]*g10*g11;
    real G7_1_0_2_1_3_2 = det*c1*c0*w[0][2]*w[3][3]*g10*g21;
    real G7_1_0_2_2_0_0 = det*c1*c0*w[0][2]*w[3][0]*g20*g01;
    real G7_1_0_2_2_0_1 = det*c1*c0*w[0][2]*w[3][0]*g20*g11;
    real G7_1_0_2_2_0_2 = det*c1*c0*w[0][2]*w[3][0]*g20*g21;
    real G7_1_0_2_2_1_0 = det*c1*c0*w[0][2]*w[3][1]*g20*g01;
    real G7_1_0_2_2_2_1 = det*c1*c0*w[0][2]*w[3][2]*g20*g11;
    real G7_1_0_2_2_3_2 = det*c1*c0*w[0][2]*w[3][3]*g20*g21;
    real G7_1_0_3_0_0_0 = det*c1*c0*w[0][3]*w[3][0]*g00*g01;
    real G7_1_0_3_0_0_1 = det*c1*c0*w[0][3]*w[3][0]*g00*g11;
    real G7_1_0_3_0_0_2 = det*c1*c0*w[0][3]*w[3][0]*g00*g21;
    real G7_1_0_3_0_1_0 = det*c1*c0*w[0][3]*w[3][1]*g00*g01;
    real G7_1_0_3_0_2_1 = det*c1*c0*w[0][3]*w[3][2]*g00*g11;
    real G7_1_0_3_0_3_2 = det*c1*c0*w[0][3]*w[3][3]*g00*g21;
    real G7_1_0_3_1_0_0 = det*c1*c0*w[0][3]*w[3][0]*g10*g01;
    real G7_1_0_3_1_0_1 = det*c1*c0*w[0][3]*w[3][0]*g10*g11;
    real G7_1_0_3_1_0_2 = det*c1*c0*w[0][3]*w[3][0]*g10*g21;
    real G7_1_0_3_1_1_0 = det*c1*c0*w[0][3]*w[3][1]*g10*g01;
    real G7_1_0_3_1_2_1 = det*c1*c0*w[0][3]*w[3][2]*g10*g11;
    real G7_1_0_3_1_3_2 = det*c1*c0*w[0][3]*w[3][3]*g10*g21;
    real G7_1_0_3_2_0_0 = det*c1*c0*w[0][3]*w[3][0]*g20*g01;
    real G7_1_0_3_2_0_1 = det*c1*c0*w[0][3]*w[3][0]*g20*g11;
    real G7_1_0_3_2_0_2 = det*c1*c0*w[0][3]*w[3][0]*g20*g21;
    real G7_1_0_3_2_1_0 = det*c1*c0*w[0][3]*w[3][1]*g20*g01;
    real G7_1_0_3_2_2_1 = det*c1*c0*w[0][3]*w[3][2]*g20*g11;
    real G7_1_0_3_2_3_2 = det*c1*c0*w[0][3]*w[3][3]*g20*g21;
    real G7_1_1_4_0_0_0 = det*c1*c0*w[0][4]*w[3][0]*g01*g01;
    real G7_1_1_4_0_0_1 = det*c1*c0*w[0][4]*w[3][0]*g01*g11;
    real G7_1_1_4_0_0_2 = det*c1*c0*w[0][4]*w[3][0]*g01*g21;
    real G7_1_1_4_0_1_0 = det*c1*c0*w[0][4]*w[3][1]*g01*g01;
    real G7_1_1_4_0_2_1 = det*c1*c0*w[0][4]*w[3][2]*g01*g11;
    real G7_1_1_4_0_3_2 = det*c1*c0*w[0][4]*w[3][3]*g01*g21;
    real G7_1_1_4_1_0_0 = det*c1*c0*w[0][4]*w[3][0]*g11*g01;
    real G7_1_1_4_1_0_1 = det*c1*c0*w[0][4]*w[3][0]*g11*g11;
    real G7_1_1_4_1_0_2 = det*c1*c0*w[0][4]*w[3][0]*g11*g21;
    real G7_1_1_4_1_1_0 = det*c1*c0*w[0][4]*w[3][1]*g11*g01;
    real G7_1_1_4_1_2_1 = det*c1*c0*w[0][4]*w[3][2]*g11*g11;
    real G7_1_1_4_1_3_2 = det*c1*c0*w[0][4]*w[3][3]*g11*g21;
    real G7_1_1_4_2_0_0 = det*c1*c0*w[0][4]*w[3][0]*g21*g01;
    real G7_1_1_4_2_0_1 = det*c1*c0*w[0][4]*w[3][0]*g21*g11;
    real G7_1_1_4_2_0_2 = det*c1*c0*w[0][4]*w[3][0]*g21*g21;
    real G7_1_1_4_2_1_0 = det*c1*c0*w[0][4]*w[3][1]*g21*g01;
    real G7_1_1_4_2_2_1 = det*c1*c0*w[0][4]*w[3][2]*g21*g11;
    real G7_1_1_4_2_3_2 = det*c1*c0*w[0][4]*w[3][3]*g21*g21;
    real G7_1_1_5_0_0_0 = det*c1*c0*w[0][5]*w[3][0]*g01*g01;
    real G7_1_1_5_0_0_1 = det*c1*c0*w[0][5]*w[3][0]*g01*g11;
    real G7_1_1_5_0_0_2 = det*c1*c0*w[0][5]*w[3][0]*g01*g21;
    real G7_1_1_5_0_1_0 = det*c1*c0*w[0][5]*w[3][1]*g01*g01;
    real G7_1_1_5_0_2_1 = det*c1*c0*w[0][5]*w[3][2]*g01*g11;
    real G7_1_1_5_0_3_2 = det*c1*c0*w[0][5]*w[3][3]*g01*g21;
    real G7_1_1_5_1_0_0 = det*c1*c0*w[0][5]*w[3][0]*g11*g01;
    real G7_1_1_5_1_0_1 = det*c1*c0*w[0][5]*w[3][0]*g11*g11;
    real G7_1_1_5_1_0_2 = det*c1*c0*w[0][5]*w[3][0]*g11*g21;
    real G7_1_1_5_1_1_0 = det*c1*c0*w[0][5]*w[3][1]*g11*g01;
    real G7_1_1_5_1_2_1 = det*c1*c0*w[0][5]*w[3][2]*g11*g11;
    real G7_1_1_5_1_3_2 = det*c1*c0*w[0][5]*w[3][3]*g11*g21;
    real G7_1_1_5_2_0_0 = det*c1*c0*w[0][5]*w[3][0]*g21*g01;
    real G7_1_1_5_2_0_1 = det*c1*c0*w[0][5]*w[3][0]*g21*g11;
    real G7_1_1_5_2_0_2 = det*c1*c0*w[0][5]*w[3][0]*g21*g21;
    real G7_1_1_5_2_1_0 = det*c1*c0*w[0][5]*w[3][1]*g21*g01;
    real G7_1_1_5_2_2_1 = det*c1*c0*w[0][5]*w[3][2]*g21*g11;
    real G7_1_1_5_2_3_2 = det*c1*c0*w[0][5]*w[3][3]*g21*g21;
    real G7_1_1_6_0_0_0 = det*c1*c0*w[0][6]*w[3][0]*g01*g01;
    real G7_1_1_6_0_0_1 = det*c1*c0*w[0][6]*w[3][0]*g01*g11;
    real G7_1_1_6_0_0_2 = det*c1*c0*w[0][6]*w[3][0]*g01*g21;
    real G7_1_1_6_0_1_0 = det*c1*c0*w[0][6]*w[3][1]*g01*g01;
    real G7_1_1_6_0_2_1 = det*c1*c0*w[0][6]*w[3][2]*g01*g11;
    real G7_1_1_6_0_3_2 = det*c1*c0*w[0][6]*w[3][3]*g01*g21;
    real G7_1_1_6_1_0_0 = det*c1*c0*w[0][6]*w[3][0]*g11*g01;
    real G7_1_1_6_1_0_1 = det*c1*c0*w[0][6]*w[3][0]*g11*g11;
    real G7_1_1_6_1_0_2 = det*c1*c0*w[0][6]*w[3][0]*g11*g21;
    real G7_1_1_6_1_1_0 = det*c1*c0*w[0][6]*w[3][1]*g11*g01;
    real G7_1_1_6_1_2_1 = det*c1*c0*w[0][6]*w[3][2]*g11*g11;
    real G7_1_1_6_1_3_2 = det*c1*c0*w[0][6]*w[3][3]*g11*g21;
    real G7_1_1_6_2_0_0 = det*c1*c0*w[0][6]*w[3][0]*g21*g01;
    real G7_1_1_6_2_0_1 = det*c1*c0*w[0][6]*w[3][0]*g21*g11;
    real G7_1_1_6_2_0_2 = det*c1*c0*w[0][6]*w[3][0]*g21*g21;
    real G7_1_1_6_2_1_0 = det*c1*c0*w[0][6]*w[3][1]*g21*g01;
    real G7_1_1_6_2_2_1 = det*c1*c0*w[0][6]*w[3][2]*g21*g11;
    real G7_1_1_6_2_3_2 = det*c1*c0*w[0][6]*w[3][3]*g21*g21;
    real G7_1_1_7_0_0_0 = det*c1*c0*w[0][7]*w[3][0]*g01*g01;
    real G7_1_1_7_0_0_1 = det*c1*c0*w[0][7]*w[3][0]*g01*g11;
    real G7_1_1_7_0_0_2 = det*c1*c0*w[0][7]*w[3][0]*g01*g21;
    real G7_1_1_7_0_1_0 = det*c1*c0*w[0][7]*w[3][1]*g01*g01;
    real G7_1_1_7_0_2_1 = det*c1*c0*w[0][7]*w[3][2]*g01*g11;
    real G7_1_1_7_0_3_2 = det*c1*c0*w[0][7]*w[3][3]*g01*g21;
    real G7_1_1_7_1_0_0 = det*c1*c0*w[0][7]*w[3][0]*g11*g01;
    real G7_1_1_7_1_0_1 = det*c1*c0*w[0][7]*w[3][0]*g11*g11;
    real G7_1_1_7_1_0_2 = det*c1*c0*w[0][7]*w[3][0]*g11*g21;
    real G7_1_1_7_1_1_0 = det*c1*c0*w[0][7]*w[3][1]*g11*g01;
    real G7_1_1_7_1_2_1 = det*c1*c0*w[0][7]*w[3][2]*g11*g11;
    real G7_1_1_7_1_3_2 = det*c1*c0*w[0][7]*w[3][3]*g11*g21;
    real G7_1_1_7_2_0_0 = det*c1*c0*w[0][7]*w[3][0]*g21*g01;
    real G7_1_1_7_2_0_1 = det*c1*c0*w[0][7]*w[3][0]*g21*g11;
    real G7_1_1_7_2_0_2 = det*c1*c0*w[0][7]*w[3][0]*g21*g21;
    real G7_1_1_7_2_1_0 = det*c1*c0*w[0][7]*w[3][1]*g21*g01;
    real G7_1_1_7_2_2_1 = det*c1*c0*w[0][7]*w[3][2]*g21*g11;
    real G7_1_1_7_2_3_2 = det*c1*c0*w[0][7]*w[3][3]*g21*g21;
    real G7_1_2_8_0_0_0 = det*c1*c0*w[0][8]*w[3][0]*g02*g01;
    real G7_1_2_8_0_0_1 = det*c1*c0*w[0][8]*w[3][0]*g02*g11;
    real G7_1_2_8_0_0_2 = det*c1*c0*w[0][8]*w[3][0]*g02*g21;
    real G7_1_2_8_0_1_0 = det*c1*c0*w[0][8]*w[3][1]*g02*g01;
    real G7_1_2_8_0_2_1 = det*c1*c0*w[0][8]*w[3][2]*g02*g11;
    real G7_1_2_8_0_3_2 = det*c1*c0*w[0][8]*w[3][3]*g02*g21;
    real G7_1_2_8_1_0_0 = det*c1*c0*w[0][8]*w[3][0]*g12*g01;
    real G7_1_2_8_1_0_1 = det*c1*c0*w[0][8]*w[3][0]*g12*g11;
    real G7_1_2_8_1_0_2 = det*c1*c0*w[0][8]*w[3][0]*g12*g21;
    real G7_1_2_8_1_1_0 = det*c1*c0*w[0][8]*w[3][1]*g12*g01;
    real G7_1_2_8_1_2_1 = det*c1*c0*w[0][8]*w[3][2]*g12*g11;
    real G7_1_2_8_1_3_2 = det*c1*c0*w[0][8]*w[3][3]*g12*g21;
    real G7_1_2_8_2_0_0 = det*c1*c0*w[0][8]*w[3][0]*g22*g01;
    real G7_1_2_8_2_0_1 = det*c1*c0*w[0][8]*w[3][0]*g22*g11;
    real G7_1_2_8_2_0_2 = det*c1*c0*w[0][8]*w[3][0]*g22*g21;
    real G7_1_2_8_2_1_0 = det*c1*c0*w[0][8]*w[3][1]*g22*g01;
    real G7_1_2_8_2_2_1 = det*c1*c0*w[0][8]*w[3][2]*g22*g11;
    real G7_1_2_8_2_3_2 = det*c1*c0*w[0][8]*w[3][3]*g22*g21;
    real G7_1_2_9_0_0_0 = det*c1*c0*w[0][9]*w[3][0]*g02*g01;
    real G7_1_2_9_0_0_1 = det*c1*c0*w[0][9]*w[3][0]*g02*g11;
    real G7_1_2_9_0_0_2 = det*c1*c0*w[0][9]*w[3][0]*g02*g21;
    real G7_1_2_9_0_1_0 = det*c1*c0*w[0][9]*w[3][1]*g02*g01;
    real G7_1_2_9_0_2_1 = det*c1*c0*w[0][9]*w[3][2]*g02*g11;
    real G7_1_2_9_0_3_2 = det*c1*c0*w[0][9]*w[3][3]*g02*g21;
    real G7_1_2_9_1_0_0 = det*c1*c0*w[0][9]*w[3][0]*g12*g01;
    real G7_1_2_9_1_0_1 = det*c1*c0*w[0][9]*w[3][0]*g12*g11;
    real G7_1_2_9_1_0_2 = det*c1*c0*w[0][9]*w[3][0]*g12*g21;
    real G7_1_2_9_1_1_0 = det*c1*c0*w[0][9]*w[3][1]*g12*g01;
    real G7_1_2_9_1_2_1 = det*c1*c0*w[0][9]*w[3][2]*g12*g11;
    real G7_1_2_9_1_3_2 = det*c1*c0*w[0][9]*w[3][3]*g12*g21;
    real G7_1_2_9_2_0_0 = det*c1*c0*w[0][9]*w[3][0]*g22*g01;
    real G7_1_2_9_2_0_1 = det*c1*c0*w[0][9]*w[3][0]*g22*g11;
    real G7_1_2_9_2_0_2 = det*c1*c0*w[0][9]*w[3][0]*g22*g21;
    real G7_1_2_9_2_1_0 = det*c1*c0*w[0][9]*w[3][1]*g22*g01;
    real G7_1_2_9_2_2_1 = det*c1*c0*w[0][9]*w[3][2]*g22*g11;
    real G7_1_2_9_2_3_2 = det*c1*c0*w[0][9]*w[3][3]*g22*g21;
    real G7_1_2_10_0_0_0 = det*c1*c0*w[0][10]*w[3][0]*g02*g01;
    real G7_1_2_10_0_0_1 = det*c1*c0*w[0][10]*w[3][0]*g02*g11;
    real G7_1_2_10_0_0_2 = det*c1*c0*w[0][10]*w[3][0]*g02*g21;
    real G7_1_2_10_0_1_0 = det*c1*c0*w[0][10]*w[3][1]*g02*g01;
    real G7_1_2_10_0_2_1 = det*c1*c0*w[0][10]*w[3][2]*g02*g11;
    real G7_1_2_10_0_3_2 = det*c1*c0*w[0][10]*w[3][3]*g02*g21;
    real G7_1_2_10_1_0_0 = det*c1*c0*w[0][10]*w[3][0]*g12*g01;
    real G7_1_2_10_1_0_1 = det*c1*c0*w[0][10]*w[3][0]*g12*g11;
    real G7_1_2_10_1_0_2 = det*c1*c0*w[0][10]*w[3][0]*g12*g21;
    real G7_1_2_10_1_1_0 = det*c1*c0*w[0][10]*w[3][1]*g12*g01;
    real G7_1_2_10_1_2_1 = det*c1*c0*w[0][10]*w[3][2]*g12*g11;
    real G7_1_2_10_1_3_2 = det*c1*c0*w[0][10]*w[3][3]*g12*g21;
    real G7_1_2_10_2_0_0 = det*c1*c0*w[0][10]*w[3][0]*g22*g01;
    real G7_1_2_10_2_0_1 = det*c1*c0*w[0][10]*w[3][0]*g22*g11;
    real G7_1_2_10_2_0_2 = det*c1*c0*w[0][10]*w[3][0]*g22*g21;
    real G7_1_2_10_2_1_0 = det*c1*c0*w[0][10]*w[3][1]*g22*g01;
    real G7_1_2_10_2_2_1 = det*c1*c0*w[0][10]*w[3][2]*g22*g11;
    real G7_1_2_10_2_3_2 = det*c1*c0*w[0][10]*w[3][3]*g22*g21;
    real G7_1_2_11_0_0_0 = det*c1*c0*w[0][11]*w[3][0]*g02*g01;
    real G7_1_2_11_0_0_1 = det*c1*c0*w[0][11]*w[3][0]*g02*g11;
    real G7_1_2_11_0_0_2 = det*c1*c0*w[0][11]*w[3][0]*g02*g21;
    real G7_1_2_11_0_1_0 = det*c1*c0*w[0][11]*w[3][1]*g02*g01;
    real G7_1_2_11_0_2_1 = det*c1*c0*w[0][11]*w[3][2]*g02*g11;
    real G7_1_2_11_0_3_2 = det*c1*c0*w[0][11]*w[3][3]*g02*g21;
    real G7_1_2_11_1_0_0 = det*c1*c0*w[0][11]*w[3][0]*g12*g01;
    real G7_1_2_11_1_0_1 = det*c1*c0*w[0][11]*w[3][0]*g12*g11;
    real G7_1_2_11_1_0_2 = det*c1*c0*w[0][11]*w[3][0]*g12*g21;
    real G7_1_2_11_1_1_0 = det*c1*c0*w[0][11]*w[3][1]*g12*g01;
    real G7_1_2_11_1_2_1 = det*c1*c0*w[0][11]*w[3][2]*g12*g11;
    real G7_1_2_11_1_3_2 = det*c1*c0*w[0][11]*w[3][3]*g12*g21;
    real G7_1_2_11_2_0_0 = det*c1*c0*w[0][11]*w[3][0]*g22*g01;
    real G7_1_2_11_2_0_1 = det*c1*c0*w[0][11]*w[3][0]*g22*g11;
    real G7_1_2_11_2_0_2 = det*c1*c0*w[0][11]*w[3][0]*g22*g21;
    real G7_1_2_11_2_1_0 = det*c1*c0*w[0][11]*w[3][1]*g22*g01;
    real G7_1_2_11_2_2_1 = det*c1*c0*w[0][11]*w[3][2]*g22*g11;
    real G7_1_2_11_2_3_2 = det*c1*c0*w[0][11]*w[3][3]*g22*g21;
    real G7_2_0_0_0_0_0 = det*c1*c0*w[0][0]*w[3][0]*g00*g02;
    real G7_2_0_0_0_0_1 = det*c1*c0*w[0][0]*w[3][0]*g00*g12;
    real G7_2_0_0_0_0_2 = det*c1*c0*w[0][0]*w[3][0]*g00*g22;
    real G7_2_0_0_0_1_0 = det*c1*c0*w[0][0]*w[3][1]*g00*g02;
    real G7_2_0_0_0_2_1 = det*c1*c0*w[0][0]*w[3][2]*g00*g12;
    real G7_2_0_0_0_3_2 = det*c1*c0*w[0][0]*w[3][3]*g00*g22;
    real G7_2_0_0_1_0_0 = det*c1*c0*w[0][0]*w[3][0]*g10*g02;
    real G7_2_0_0_1_0_1 = det*c1*c0*w[0][0]*w[3][0]*g10*g12;
    real G7_2_0_0_1_0_2 = det*c1*c0*w[0][0]*w[3][0]*g10*g22;
    real G7_2_0_0_1_1_0 = det*c1*c0*w[0][0]*w[3][1]*g10*g02;
    real G7_2_0_0_1_2_1 = det*c1*c0*w[0][0]*w[3][2]*g10*g12;
    real G7_2_0_0_1_3_2 = det*c1*c0*w[0][0]*w[3][3]*g10*g22;
    real G7_2_0_0_2_0_0 = det*c1*c0*w[0][0]*w[3][0]*g20*g02;
    real G7_2_0_0_2_0_1 = det*c1*c0*w[0][0]*w[3][0]*g20*g12;
    real G7_2_0_0_2_0_2 = det*c1*c0*w[0][0]*w[3][0]*g20*g22;
    real G7_2_0_0_2_1_0 = det*c1*c0*w[0][0]*w[3][1]*g20*g02;
    real G7_2_0_0_2_2_1 = det*c1*c0*w[0][0]*w[3][2]*g20*g12;
    real G7_2_0_0_2_3_2 = det*c1*c0*w[0][0]*w[3][3]*g20*g22;
    real G7_2_0_1_0_0_0 = det*c1*c0*w[0][1]*w[3][0]*g00*g02;
    real G7_2_0_1_0_0_1 = det*c1*c0*w[0][1]*w[3][0]*g00*g12;
    real G7_2_0_1_0_0_2 = det*c1*c0*w[0][1]*w[3][0]*g00*g22;
    real G7_2_0_1_0_1_0 = det*c1*c0*w[0][1]*w[3][1]*g00*g02;
    real G7_2_0_1_0_2_1 = det*c1*c0*w[0][1]*w[3][2]*g00*g12;
    real G7_2_0_1_0_3_2 = det*c1*c0*w[0][1]*w[3][3]*g00*g22;
    real G7_2_0_1_1_0_0 = det*c1*c0*w[0][1]*w[3][0]*g10*g02;
    real G7_2_0_1_1_0_1 = det*c1*c0*w[0][1]*w[3][0]*g10*g12;
    real G7_2_0_1_1_0_2 = det*c1*c0*w[0][1]*w[3][0]*g10*g22;
    real G7_2_0_1_1_1_0 = det*c1*c0*w[0][1]*w[3][1]*g10*g02;
    real G7_2_0_1_1_2_1 = det*c1*c0*w[0][1]*w[3][2]*g10*g12;
    real G7_2_0_1_1_3_2 = det*c1*c0*w[0][1]*w[3][3]*g10*g22;
    real G7_2_0_1_2_0_0 = det*c1*c0*w[0][1]*w[3][0]*g20*g02;
    real G7_2_0_1_2_0_1 = det*c1*c0*w[0][1]*w[3][0]*g20*g12;
    real G7_2_0_1_2_0_2 = det*c1*c0*w[0][1]*w[3][0]*g20*g22;
    real G7_2_0_1_2_1_0 = det*c1*c0*w[0][1]*w[3][1]*g20*g02;
    real G7_2_0_1_2_2_1 = det*c1*c0*w[0][1]*w[3][2]*g20*g12;
    real G7_2_0_1_2_3_2 = det*c1*c0*w[0][1]*w[3][3]*g20*g22;
    real G7_2_0_2_0_0_0 = det*c1*c0*w[0][2]*w[3][0]*g00*g02;
    real G7_2_0_2_0_0_1 = det*c1*c0*w[0][2]*w[3][0]*g00*g12;
    real G7_2_0_2_0_0_2 = det*c1*c0*w[0][2]*w[3][0]*g00*g22;
    real G7_2_0_2_0_1_0 = det*c1*c0*w[0][2]*w[3][1]*g00*g02;
    real G7_2_0_2_0_2_1 = det*c1*c0*w[0][2]*w[3][2]*g00*g12;
    real G7_2_0_2_0_3_2 = det*c1*c0*w[0][2]*w[3][3]*g00*g22;
    real G7_2_0_2_1_0_0 = det*c1*c0*w[0][2]*w[3][0]*g10*g02;
    real G7_2_0_2_1_0_1 = det*c1*c0*w[0][2]*w[3][0]*g10*g12;
    real G7_2_0_2_1_0_2 = det*c1*c0*w[0][2]*w[3][0]*g10*g22;
    real G7_2_0_2_1_1_0 = det*c1*c0*w[0][2]*w[3][1]*g10*g02;
    real G7_2_0_2_1_2_1 = det*c1*c0*w[0][2]*w[3][2]*g10*g12;
    real G7_2_0_2_1_3_2 = det*c1*c0*w[0][2]*w[3][3]*g10*g22;
    real G7_2_0_2_2_0_0 = det*c1*c0*w[0][2]*w[3][0]*g20*g02;
    real G7_2_0_2_2_0_1 = det*c1*c0*w[0][2]*w[3][0]*g20*g12;
    real G7_2_0_2_2_0_2 = det*c1*c0*w[0][2]*w[3][0]*g20*g22;
    real G7_2_0_2_2_1_0 = det*c1*c0*w[0][2]*w[3][1]*g20*g02;
    real G7_2_0_2_2_2_1 = det*c1*c0*w[0][2]*w[3][2]*g20*g12;
    real G7_2_0_2_2_3_2 = det*c1*c0*w[0][2]*w[3][3]*g20*g22;
    real G7_2_0_3_0_0_0 = det*c1*c0*w[0][3]*w[3][0]*g00*g02;
    real G7_2_0_3_0_0_1 = det*c1*c0*w[0][3]*w[3][0]*g00*g12;
    real G7_2_0_3_0_0_2 = det*c1*c0*w[0][3]*w[3][0]*g00*g22;
    real G7_2_0_3_0_1_0 = det*c1*c0*w[0][3]*w[3][1]*g00*g02;
    real G7_2_0_3_0_2_1 = det*c1*c0*w[0][3]*w[3][2]*g00*g12;
    real G7_2_0_3_0_3_2 = det*c1*c0*w[0][3]*w[3][3]*g00*g22;
    real G7_2_0_3_1_0_0 = det*c1*c0*w[0][3]*w[3][0]*g10*g02;
    real G7_2_0_3_1_0_1 = det*c1*c0*w[0][3]*w[3][0]*g10*g12;
    real G7_2_0_3_1_0_2 = det*c1*c0*w[0][3]*w[3][0]*g10*g22;
    real G7_2_0_3_1_1_0 = det*c1*c0*w[0][3]*w[3][1]*g10*g02;
    real G7_2_0_3_1_2_1 = det*c1*c0*w[0][3]*w[3][2]*g10*g12;
    real G7_2_0_3_1_3_2 = det*c1*c0*w[0][3]*w[3][3]*g10*g22;
    real G7_2_0_3_2_0_0 = det*c1*c0*w[0][3]*w[3][0]*g20*g02;
    real G7_2_0_3_2_0_1 = det*c1*c0*w[0][3]*w[3][0]*g20*g12;
    real G7_2_0_3_2_0_2 = det*c1*c0*w[0][3]*w[3][0]*g20*g22;
    real G7_2_0_3_2_1_0 = det*c1*c0*w[0][3]*w[3][1]*g20*g02;
    real G7_2_0_3_2_2_1 = det*c1*c0*w[0][3]*w[3][2]*g20*g12;
    real G7_2_0_3_2_3_2 = det*c1*c0*w[0][3]*w[3][3]*g20*g22;
    real G7_2_1_4_0_0_0 = det*c1*c0*w[0][4]*w[3][0]*g01*g02;
    real G7_2_1_4_0_0_1 = det*c1*c0*w[0][4]*w[3][0]*g01*g12;
    real G7_2_1_4_0_0_2 = det*c1*c0*w[0][4]*w[3][0]*g01*g22;
    real G7_2_1_4_0_1_0 = det*c1*c0*w[0][4]*w[3][1]*g01*g02;
    real G7_2_1_4_0_2_1 = det*c1*c0*w[0][4]*w[3][2]*g01*g12;
    real G7_2_1_4_0_3_2 = det*c1*c0*w[0][4]*w[3][3]*g01*g22;
    real G7_2_1_4_1_0_0 = det*c1*c0*w[0][4]*w[3][0]*g11*g02;
    real G7_2_1_4_1_0_1 = det*c1*c0*w[0][4]*w[3][0]*g11*g12;
    real G7_2_1_4_1_0_2 = det*c1*c0*w[0][4]*w[3][0]*g11*g22;
    real G7_2_1_4_1_1_0 = det*c1*c0*w[0][4]*w[3][1]*g11*g02;
    real G7_2_1_4_1_2_1 = det*c1*c0*w[0][4]*w[3][2]*g11*g12;
    real G7_2_1_4_1_3_2 = det*c1*c0*w[0][4]*w[3][3]*g11*g22;
    real G7_2_1_4_2_0_0 = det*c1*c0*w[0][4]*w[3][0]*g21*g02;
    real G7_2_1_4_2_0_1 = det*c1*c0*w[0][4]*w[3][0]*g21*g12;
    real G7_2_1_4_2_0_2 = det*c1*c0*w[0][4]*w[3][0]*g21*g22;
    real G7_2_1_4_2_1_0 = det*c1*c0*w[0][4]*w[3][1]*g21*g02;
    real G7_2_1_4_2_2_1 = det*c1*c0*w[0][4]*w[3][2]*g21*g12;
    real G7_2_1_4_2_3_2 = det*c1*c0*w[0][4]*w[3][3]*g21*g22;
    real G7_2_1_5_0_0_0 = det*c1*c0*w[0][5]*w[3][0]*g01*g02;
    real G7_2_1_5_0_0_1 = det*c1*c0*w[0][5]*w[3][0]*g01*g12;
    real G7_2_1_5_0_0_2 = det*c1*c0*w[0][5]*w[3][0]*g01*g22;
    real G7_2_1_5_0_1_0 = det*c1*c0*w[0][5]*w[3][1]*g01*g02;
    real G7_2_1_5_0_2_1 = det*c1*c0*w[0][5]*w[3][2]*g01*g12;
    real G7_2_1_5_0_3_2 = det*c1*c0*w[0][5]*w[3][3]*g01*g22;
    real G7_2_1_5_1_0_0 = det*c1*c0*w[0][5]*w[3][0]*g11*g02;
    real G7_2_1_5_1_0_1 = det*c1*c0*w[0][5]*w[3][0]*g11*g12;
    real G7_2_1_5_1_0_2 = det*c1*c0*w[0][5]*w[3][0]*g11*g22;
    real G7_2_1_5_1_1_0 = det*c1*c0*w[0][5]*w[3][1]*g11*g02;
    real G7_2_1_5_1_2_1 = det*c1*c0*w[0][5]*w[3][2]*g11*g12;
    real G7_2_1_5_1_3_2 = det*c1*c0*w[0][5]*w[3][3]*g11*g22;
    real G7_2_1_5_2_0_0 = det*c1*c0*w[0][5]*w[3][0]*g21*g02;
    real G7_2_1_5_2_0_1 = det*c1*c0*w[0][5]*w[3][0]*g21*g12;
    real G7_2_1_5_2_0_2 = det*c1*c0*w[0][5]*w[3][0]*g21*g22;
    real G7_2_1_5_2_1_0 = det*c1*c0*w[0][5]*w[3][1]*g21*g02;
    real G7_2_1_5_2_2_1 = det*c1*c0*w[0][5]*w[3][2]*g21*g12;
    real G7_2_1_5_2_3_2 = det*c1*c0*w[0][5]*w[3][3]*g21*g22;
    real G7_2_1_6_0_0_0 = det*c1*c0*w[0][6]*w[3][0]*g01*g02;
    real G7_2_1_6_0_0_1 = det*c1*c0*w[0][6]*w[3][0]*g01*g12;
    real G7_2_1_6_0_0_2 = det*c1*c0*w[0][6]*w[3][0]*g01*g22;
    real G7_2_1_6_0_1_0 = det*c1*c0*w[0][6]*w[3][1]*g01*g02;
    real G7_2_1_6_0_2_1 = det*c1*c0*w[0][6]*w[3][2]*g01*g12;
    real G7_2_1_6_0_3_2 = det*c1*c0*w[0][6]*w[3][3]*g01*g22;
    real G7_2_1_6_1_0_0 = det*c1*c0*w[0][6]*w[3][0]*g11*g02;
    real G7_2_1_6_1_0_1 = det*c1*c0*w[0][6]*w[3][0]*g11*g12;
    real G7_2_1_6_1_0_2 = det*c1*c0*w[0][6]*w[3][0]*g11*g22;
    real G7_2_1_6_1_1_0 = det*c1*c0*w[0][6]*w[3][1]*g11*g02;
    real G7_2_1_6_1_2_1 = det*c1*c0*w[0][6]*w[3][2]*g11*g12;
    real G7_2_1_6_1_3_2 = det*c1*c0*w[0][6]*w[3][3]*g11*g22;
    real G7_2_1_6_2_0_0 = det*c1*c0*w[0][6]*w[3][0]*g21*g02;
    real G7_2_1_6_2_0_1 = det*c1*c0*w[0][6]*w[3][0]*g21*g12;
    real G7_2_1_6_2_0_2 = det*c1*c0*w[0][6]*w[3][0]*g21*g22;
    real G7_2_1_6_2_1_0 = det*c1*c0*w[0][6]*w[3][1]*g21*g02;
    real G7_2_1_6_2_2_1 = det*c1*c0*w[0][6]*w[3][2]*g21*g12;
    real G7_2_1_6_2_3_2 = det*c1*c0*w[0][6]*w[3][3]*g21*g22;
    real G7_2_1_7_0_0_0 = det*c1*c0*w[0][7]*w[3][0]*g01*g02;
    real G7_2_1_7_0_0_1 = det*c1*c0*w[0][7]*w[3][0]*g01*g12;
    real G7_2_1_7_0_0_2 = det*c1*c0*w[0][7]*w[3][0]*g01*g22;
    real G7_2_1_7_0_1_0 = det*c1*c0*w[0][7]*w[3][1]*g01*g02;
    real G7_2_1_7_0_2_1 = det*c1*c0*w[0][7]*w[3][2]*g01*g12;
    real G7_2_1_7_0_3_2 = det*c1*c0*w[0][7]*w[3][3]*g01*g22;
    real G7_2_1_7_1_0_0 = det*c1*c0*w[0][7]*w[3][0]*g11*g02;
    real G7_2_1_7_1_0_1 = det*c1*c0*w[0][7]*w[3][0]*g11*g12;
    real G7_2_1_7_1_0_2 = det*c1*c0*w[0][7]*w[3][0]*g11*g22;
    real G7_2_1_7_1_1_0 = det*c1*c0*w[0][7]*w[3][1]*g11*g02;
    real G7_2_1_7_1_2_1 = det*c1*c0*w[0][7]*w[3][2]*g11*g12;
    real G7_2_1_7_1_3_2 = det*c1*c0*w[0][7]*w[3][3]*g11*g22;
    real G7_2_1_7_2_0_0 = det*c1*c0*w[0][7]*w[3][0]*g21*g02;
    real G7_2_1_7_2_0_1 = det*c1*c0*w[0][7]*w[3][0]*g21*g12;
    real G7_2_1_7_2_0_2 = det*c1*c0*w[0][7]*w[3][0]*g21*g22;
    real G7_2_1_7_2_1_0 = det*c1*c0*w[0][7]*w[3][1]*g21*g02;
    real G7_2_1_7_2_2_1 = det*c1*c0*w[0][7]*w[3][2]*g21*g12;
    real G7_2_1_7_2_3_2 = det*c1*c0*w[0][7]*w[3][3]*g21*g22;
    real G7_2_2_8_0_0_0 = det*c1*c0*w[0][8]*w[3][0]*g02*g02;
    real G7_2_2_8_0_0_1 = det*c1*c0*w[0][8]*w[3][0]*g02*g12;
    real G7_2_2_8_0_0_2 = det*c1*c0*w[0][8]*w[3][0]*g02*g22;
    real G7_2_2_8_0_1_0 = det*c1*c0*w[0][8]*w[3][1]*g02*g02;
    real G7_2_2_8_0_2_1 = det*c1*c0*w[0][8]*w[3][2]*g02*g12;
    real G7_2_2_8_0_3_2 = det*c1*c0*w[0][8]*w[3][3]*g02*g22;
    real G7_2_2_8_1_0_0 = det*c1*c0*w[0][8]*w[3][0]*g12*g02;
    real G7_2_2_8_1_0_1 = det*c1*c0*w[0][8]*w[3][0]*g12*g12;
    real G7_2_2_8_1_0_2 = det*c1*c0*w[0][8]*w[3][0]*g12*g22;
    real G7_2_2_8_1_1_0 = det*c1*c0*w[0][8]*w[3][1]*g12*g02;
    real G7_2_2_8_1_2_1 = det*c1*c0*w[0][8]*w[3][2]*g12*g12;
    real G7_2_2_8_1_3_2 = det*c1*c0*w[0][8]*w[3][3]*g12*g22;
    real G7_2_2_8_2_0_0 = det*c1*c0*w[0][8]*w[3][0]*g22*g02;
    real G7_2_2_8_2_0_1 = det*c1*c0*w[0][8]*w[3][0]*g22*g12;
    real G7_2_2_8_2_0_2 = det*c1*c0*w[0][8]*w[3][0]*g22*g22;
    real G7_2_2_8_2_1_0 = det*c1*c0*w[0][8]*w[3][1]*g22*g02;
    real G7_2_2_8_2_2_1 = det*c1*c0*w[0][8]*w[3][2]*g22*g12;
    real G7_2_2_8_2_3_2 = det*c1*c0*w[0][8]*w[3][3]*g22*g22;
    real G7_2_2_9_0_0_0 = det*c1*c0*w[0][9]*w[3][0]*g02*g02;
    real G7_2_2_9_0_0_1 = det*c1*c0*w[0][9]*w[3][0]*g02*g12;
    real G7_2_2_9_0_0_2 = det*c1*c0*w[0][9]*w[3][0]*g02*g22;
    real G7_2_2_9_0_1_0 = det*c1*c0*w[0][9]*w[3][1]*g02*g02;
    real G7_2_2_9_0_2_1 = det*c1*c0*w[0][9]*w[3][2]*g02*g12;
    real G7_2_2_9_0_3_2 = det*c1*c0*w[0][9]*w[3][3]*g02*g22;
    real G7_2_2_9_1_0_0 = det*c1*c0*w[0][9]*w[3][0]*g12*g02;
    real G7_2_2_9_1_0_1 = det*c1*c0*w[0][9]*w[3][0]*g12*g12;
    real G7_2_2_9_1_0_2 = det*c1*c0*w[0][9]*w[3][0]*g12*g22;
    real G7_2_2_9_1_1_0 = det*c1*c0*w[0][9]*w[3][1]*g12*g02;
    real G7_2_2_9_1_2_1 = det*c1*c0*w[0][9]*w[3][2]*g12*g12;
    real G7_2_2_9_1_3_2 = det*c1*c0*w[0][9]*w[3][3]*g12*g22;
    real G7_2_2_9_2_0_0 = det*c1*c0*w[0][9]*w[3][0]*g22*g02;
    real G7_2_2_9_2_0_1 = det*c1*c0*w[0][9]*w[3][0]*g22*g12;
    real G7_2_2_9_2_0_2 = det*c1*c0*w[0][9]*w[3][0]*g22*g22;
    real G7_2_2_9_2_1_0 = det*c1*c0*w[0][9]*w[3][1]*g22*g02;
    real G7_2_2_9_2_2_1 = det*c1*c0*w[0][9]*w[3][2]*g22*g12;
    real G7_2_2_9_2_3_2 = det*c1*c0*w[0][9]*w[3][3]*g22*g22;
    real G7_2_2_10_0_0_0 = det*c1*c0*w[0][10]*w[3][0]*g02*g02;
    real G7_2_2_10_0_0_1 = det*c1*c0*w[0][10]*w[3][0]*g02*g12;
    real G7_2_2_10_0_0_2 = det*c1*c0*w[0][10]*w[3][0]*g02*g22;
    real G7_2_2_10_0_1_0 = det*c1*c0*w[0][10]*w[3][1]*g02*g02;
    real G7_2_2_10_0_2_1 = det*c1*c0*w[0][10]*w[3][2]*g02*g12;
    real G7_2_2_10_0_3_2 = det*c1*c0*w[0][10]*w[3][3]*g02*g22;
    real G7_2_2_10_1_0_0 = det*c1*c0*w[0][10]*w[3][0]*g12*g02;
    real G7_2_2_10_1_0_1 = det*c1*c0*w[0][10]*w[3][0]*g12*g12;
    real G7_2_2_10_1_0_2 = det*c1*c0*w[0][10]*w[3][0]*g12*g22;
    real G7_2_2_10_1_1_0 = det*c1*c0*w[0][10]*w[3][1]*g12*g02;
    real G7_2_2_10_1_2_1 = det*c1*c0*w[0][10]*w[3][2]*g12*g12;
    real G7_2_2_10_1_3_2 = det*c1*c0*w[0][10]*w[3][3]*g12*g22;
    real G7_2_2_10_2_0_0 = det*c1*c0*w[0][10]*w[3][0]*g22*g02;
    real G7_2_2_10_2_0_1 = det*c1*c0*w[0][10]*w[3][0]*g22*g12;
    real G7_2_2_10_2_0_2 = det*c1*c0*w[0][10]*w[3][0]*g22*g22;
    real G7_2_2_10_2_1_0 = det*c1*c0*w[0][10]*w[3][1]*g22*g02;
    real G7_2_2_10_2_2_1 = det*c1*c0*w[0][10]*w[3][2]*g22*g12;
    real G7_2_2_10_2_3_2 = det*c1*c0*w[0][10]*w[3][3]*g22*g22;
    real G7_2_2_11_0_0_0 = det*c1*c0*w[0][11]*w[3][0]*g02*g02;
    real G7_2_2_11_0_0_1 = det*c1*c0*w[0][11]*w[3][0]*g02*g12;
    real G7_2_2_11_0_0_2 = det*c1*c0*w[0][11]*w[3][0]*g02*g22;
    real G7_2_2_11_0_1_0 = det*c1*c0*w[0][11]*w[3][1]*g02*g02;
    real G7_2_2_11_0_2_1 = det*c1*c0*w[0][11]*w[3][2]*g02*g12;
    real G7_2_2_11_0_3_2 = det*c1*c0*w[0][11]*w[3][3]*g02*g22;
    real G7_2_2_11_1_0_0 = det*c1*c0*w[0][11]*w[3][0]*g12*g02;
    real G7_2_2_11_1_0_1 = det*c1*c0*w[0][11]*w[3][0]*g12*g12;
    real G7_2_2_11_1_0_2 = det*c1*c0*w[0][11]*w[3][0]*g12*g22;
    real G7_2_2_11_1_1_0 = det*c1*c0*w[0][11]*w[3][1]*g12*g02;
    real G7_2_2_11_1_2_1 = det*c1*c0*w[0][11]*w[3][2]*g12*g12;
    real G7_2_2_11_1_3_2 = det*c1*c0*w[0][11]*w[3][3]*g12*g22;
    real G7_2_2_11_2_0_0 = det*c1*c0*w[0][11]*w[3][0]*g22*g02;
    real G7_2_2_11_2_0_1 = det*c1*c0*w[0][11]*w[3][0]*g22*g12;
    real G7_2_2_11_2_0_2 = det*c1*c0*w[0][11]*w[3][0]*g22*g22;
    real G7_2_2_11_2_1_0 = det*c1*c0*w[0][11]*w[3][1]*g22*g02;
    real G7_2_2_11_2_2_1 = det*c1*c0*w[0][11]*w[3][2]*g22*g12;
    real G7_2_2_11_2_3_2 = det*c1*c0*w[0][11]*w[3][3]*g22*g22;
    real G8_0_0_0_0_0 = det*c2*w[1][0]*g00*g00;
    real G8_0_0_0_0_1 = det*c2*w[1][0]*g00*g10;
    real G8_0_0_0_0_2 = det*c2*w[1][0]*g00*g20;
    real G8_0_0_0_1_0 = det*c2*w[1][1]*g00*g00;
    real G8_0_0_0_2_1 = det*c2*w[1][2]*g00*g10;
    real G8_0_0_0_3_2 = det*c2*w[1][3]*g00*g20;
    real G8_0_0_1_0_0 = det*c2*w[1][0]*g10*g00;
    real G8_0_0_1_0_1 = det*c2*w[1][0]*g10*g10;
    real G8_0_0_1_0_2 = det*c2*w[1][0]*g10*g20;
    real G8_0_0_1_1_0 = det*c2*w[1][1]*g10*g00;
    real G8_0_0_1_2_1 = det*c2*w[1][2]*g10*g10;
    real G8_0_0_1_3_2 = det*c2*w[1][3]*g10*g20;
    real G8_0_0_2_0_0 = det*c2*w[1][0]*g20*g00;
    real G8_0_0_2_0_1 = det*c2*w[1][0]*g20*g10;
    real G8_0_0_2_0_2 = det*c2*w[1][0]*g20*g20;
    real G8_0_0_2_1_0 = det*c2*w[1][1]*g20*g00;
    real G8_0_0_2_2_1 = det*c2*w[1][2]*g20*g10;
    real G8_0_0_2_3_2 = det*c2*w[1][3]*g20*g20;
    real G8_0_1_0_4_0 = det*c2*w[1][4]*g00*g01;
    real G8_0_1_0_4_1 = det*c2*w[1][4]*g00*g11;
    real G8_0_1_0_4_2 = det*c2*w[1][4]*g00*g21;
    real G8_0_1_0_5_0 = det*c2*w[1][5]*g00*g01;
    real G8_0_1_0_6_1 = det*c2*w[1][6]*g00*g11;
    real G8_0_1_0_7_2 = det*c2*w[1][7]*g00*g21;
    real G8_0_1_1_4_0 = det*c2*w[1][4]*g10*g01;
    real G8_0_1_1_4_1 = det*c2*w[1][4]*g10*g11;
    real G8_0_1_1_4_2 = det*c2*w[1][4]*g10*g21;
    real G8_0_1_1_5_0 = det*c2*w[1][5]*g10*g01;
    real G8_0_1_1_6_1 = det*c2*w[1][6]*g10*g11;
    real G8_0_1_1_7_2 = det*c2*w[1][7]*g10*g21;
    real G8_0_1_2_4_0 = det*c2*w[1][4]*g20*g01;
    real G8_0_1_2_4_1 = det*c2*w[1][4]*g20*g11;
    real G8_0_1_2_4_2 = det*c2*w[1][4]*g20*g21;
    real G8_0_1_2_5_0 = det*c2*w[1][5]*g20*g01;
    real G8_0_1_2_6_1 = det*c2*w[1][6]*g20*g11;
    real G8_0_1_2_7_2 = det*c2*w[1][7]*g20*g21;
    real G8_0_2_0_8_0 = det*c2*w[1][8]*g00*g02;
    real G8_0_2_0_8_1 = det*c2*w[1][8]*g00*g12;
    real G8_0_2_0_8_2 = det*c2*w[1][8]*g00*g22;
    real G8_0_2_0_9_0 = det*c2*w[1][9]*g00*g02;
    real G8_0_2_0_10_1 = det*c2*w[1][10]*g00*g12;
    real G8_0_2_0_11_2 = det*c2*w[1][11]*g00*g22;
    real G8_0_2_1_8_0 = det*c2*w[1][8]*g10*g02;
    real G8_0_2_1_8_1 = det*c2*w[1][8]*g10*g12;
    real G8_0_2_1_8_2 = det*c2*w[1][8]*g10*g22;
    real G8_0_2_1_9_0 = det*c2*w[1][9]*g10*g02;
    real G8_0_2_1_10_1 = det*c2*w[1][10]*g10*g12;
    real G8_0_2_1_11_2 = det*c2*w[1][11]*g10*g22;
    real G8_0_2_2_8_0 = det*c2*w[1][8]*g20*g02;
    real G8_0_2_2_8_1 = det*c2*w[1][8]*g20*g12;
    real G8_0_2_2_8_2 = det*c2*w[1][8]*g20*g22;
    real G8_0_2_2_9_0 = det*c2*w[1][9]*g20*g02;
    real G8_0_2_2_10_1 = det*c2*w[1][10]*g20*g12;
    real G8_0_2_2_11_2 = det*c2*w[1][11]*g20*g22;
    real G8_1_0_0_0_0 = det*c2*w[1][0]*g01*g00;
    real G8_1_0_0_0_1 = det*c2*w[1][0]*g01*g10;
    real G8_1_0_0_0_2 = det*c2*w[1][0]*g01*g20;
    real G8_1_0_0_1_0 = det*c2*w[1][1]*g01*g00;
    real G8_1_0_0_2_1 = det*c2*w[1][2]*g01*g10;
    real G8_1_0_0_3_2 = det*c2*w[1][3]*g01*g20;
    real G8_1_0_1_0_0 = det*c2*w[1][0]*g11*g00;
    real G8_1_0_1_0_1 = det*c2*w[1][0]*g11*g10;
    real G8_1_0_1_0_2 = det*c2*w[1][0]*g11*g20;
    real G8_1_0_1_1_0 = det*c2*w[1][1]*g11*g00;
    real G8_1_0_1_2_1 = det*c2*w[1][2]*g11*g10;
    real G8_1_0_1_3_2 = det*c2*w[1][3]*g11*g20;
    real G8_1_0_2_0_0 = det*c2*w[1][0]*g21*g00;
    real G8_1_0_2_0_1 = det*c2*w[1][0]*g21*g10;
    real G8_1_0_2_0_2 = det*c2*w[1][0]*g21*g20;
    real G8_1_0_2_1_0 = det*c2*w[1][1]*g21*g00;
    real G8_1_0_2_2_1 = det*c2*w[1][2]*g21*g10;
    real G8_1_0_2_3_2 = det*c2*w[1][3]*g21*g20;
    real G8_1_1_0_4_0 = det*c2*w[1][4]*g01*g01;
    real G8_1_1_0_4_1 = det*c2*w[1][4]*g01*g11;
    real G8_1_1_0_4_2 = det*c2*w[1][4]*g01*g21;
    real G8_1_1_0_5_0 = det*c2*w[1][5]*g01*g01;
    real G8_1_1_0_6_1 = det*c2*w[1][6]*g01*g11;
    real G8_1_1_0_7_2 = det*c2*w[1][7]*g01*g21;
    real G8_1_1_1_4_0 = det*c2*w[1][4]*g11*g01;
    real G8_1_1_1_4_1 = det*c2*w[1][4]*g11*g11;
    real G8_1_1_1_4_2 = det*c2*w[1][4]*g11*g21;
    real G8_1_1_1_5_0 = det*c2*w[1][5]*g11*g01;
    real G8_1_1_1_6_1 = det*c2*w[1][6]*g11*g11;
    real G8_1_1_1_7_2 = det*c2*w[1][7]*g11*g21;
    real G8_1_1_2_4_0 = det*c2*w[1][4]*g21*g01;
    real G8_1_1_2_4_1 = det*c2*w[1][4]*g21*g11;
    real G8_1_1_2_4_2 = det*c2*w[1][4]*g21*g21;
    real G8_1_1_2_5_0 = det*c2*w[1][5]*g21*g01;
    real G8_1_1_2_6_1 = det*c2*w[1][6]*g21*g11;
    real G8_1_1_2_7_2 = det*c2*w[1][7]*g21*g21;
    real G8_1_2_0_8_0 = det*c2*w[1][8]*g01*g02;
    real G8_1_2_0_8_1 = det*c2*w[1][8]*g01*g12;
    real G8_1_2_0_8_2 = det*c2*w[1][8]*g01*g22;
    real G8_1_2_0_9_0 = det*c2*w[1][9]*g01*g02;
    real G8_1_2_0_10_1 = det*c2*w[1][10]*g01*g12;
    real G8_1_2_0_11_2 = det*c2*w[1][11]*g01*g22;
    real G8_1_2_1_8_0 = det*c2*w[1][8]*g11*g02;
    real G8_1_2_1_8_1 = det*c2*w[1][8]*g11*g12;
    real G8_1_2_1_8_2 = det*c2*w[1][8]*g11*g22;
    real G8_1_2_1_9_0 = det*c2*w[1][9]*g11*g02;
    real G8_1_2_1_10_1 = det*c2*w[1][10]*g11*g12;
    real G8_1_2_1_11_2 = det*c2*w[1][11]*g11*g22;
    real G8_1_2_2_8_0 = det*c2*w[1][8]*g21*g02;
    real G8_1_2_2_8_1 = det*c2*w[1][8]*g21*g12;
    real G8_1_2_2_8_2 = det*c2*w[1][8]*g21*g22;
    real G8_1_2_2_9_0 = det*c2*w[1][9]*g21*g02;
    real G8_1_2_2_10_1 = det*c2*w[1][10]*g21*g12;
    real G8_1_2_2_11_2 = det*c2*w[1][11]*g21*g22;
    real G8_2_0_0_0_0 = det*c2*w[1][0]*g02*g00;
    real G8_2_0_0_0_1 = det*c2*w[1][0]*g02*g10;
    real G8_2_0_0_0_2 = det*c2*w[1][0]*g02*g20;
    real G8_2_0_0_1_0 = det*c2*w[1][1]*g02*g00;
    real G8_2_0_0_2_1 = det*c2*w[1][2]*g02*g10;
    real G8_2_0_0_3_2 = det*c2*w[1][3]*g02*g20;
    real G8_2_0_1_0_0 = det*c2*w[1][0]*g12*g00;
    real G8_2_0_1_0_1 = det*c2*w[1][0]*g12*g10;
    real G8_2_0_1_0_2 = det*c2*w[1][0]*g12*g20;
    real G8_2_0_1_1_0 = det*c2*w[1][1]*g12*g00;
    real G8_2_0_1_2_1 = det*c2*w[1][2]*g12*g10;
    real G8_2_0_1_3_2 = det*c2*w[1][3]*g12*g20;
    real G8_2_0_2_0_0 = det*c2*w[1][0]*g22*g00;
    real G8_2_0_2_0_1 = det*c2*w[1][0]*g22*g10;
    real G8_2_0_2_0_2 = det*c2*w[1][0]*g22*g20;
    real G8_2_0_2_1_0 = det*c2*w[1][1]*g22*g00;
    real G8_2_0_2_2_1 = det*c2*w[1][2]*g22*g10;
    real G8_2_0_2_3_2 = det*c2*w[1][3]*g22*g20;
    real G8_2_1_0_4_0 = det*c2*w[1][4]*g02*g01;
    real G8_2_1_0_4_1 = det*c2*w[1][4]*g02*g11;
    real G8_2_1_0_4_2 = det*c2*w[1][4]*g02*g21;
    real G8_2_1_0_5_0 = det*c2*w[1][5]*g02*g01;
    real G8_2_1_0_6_1 = det*c2*w[1][6]*g02*g11;
    real G8_2_1_0_7_2 = det*c2*w[1][7]*g02*g21;
    real G8_2_1_1_4_0 = det*c2*w[1][4]*g12*g01;
    real G8_2_1_1_4_1 = det*c2*w[1][4]*g12*g11;
    real G8_2_1_1_4_2 = det*c2*w[1][4]*g12*g21;
    real G8_2_1_1_5_0 = det*c2*w[1][5]*g12*g01;
    real G8_2_1_1_6_1 = det*c2*w[1][6]*g12*g11;
    real G8_2_1_1_7_2 = det*c2*w[1][7]*g12*g21;
    real G8_2_1_2_4_0 = det*c2*w[1][4]*g22*g01;
    real G8_2_1_2_4_1 = det*c2*w[1][4]*g22*g11;
    real G8_2_1_2_4_2 = det*c2*w[1][4]*g22*g21;
    real G8_2_1_2_5_0 = det*c2*w[1][5]*g22*g01;
    real G8_2_1_2_6_1 = det*c2*w[1][6]*g22*g11;
    real G8_2_1_2_7_2 = det*c2*w[1][7]*g22*g21;
    real G8_2_2_0_8_0 = det*c2*w[1][8]*g02*g02;
    real G8_2_2_0_8_1 = det*c2*w[1][8]*g02*g12;
    real G8_2_2_0_8_2 = det*c2*w[1][8]*g02*g22;
    real G8_2_2_0_9_0 = det*c2*w[1][9]*g02*g02;
    real G8_2_2_0_10_1 = det*c2*w[1][10]*g02*g12;
    real G8_2_2_0_11_2 = det*c2*w[1][11]*g02*g22;
    real G8_2_2_1_8_0 = det*c2*w[1][8]*g12*g02;
    real G8_2_2_1_8_1 = det*c2*w[1][8]*g12*g12;
    real G8_2_2_1_8_2 = det*c2*w[1][8]*g12*g22;
    real G8_2_2_1_9_0 = det*c2*w[1][9]*g12*g02;
    real G8_2_2_1_10_1 = det*c2*w[1][10]*g12*g12;
    real G8_2_2_1_11_2 = det*c2*w[1][11]*g12*g22;
    real G8_2_2_2_8_0 = det*c2*w[1][8]*g22*g02;
    real G8_2_2_2_8_1 = det*c2*w[1][8]*g22*g12;
    real G8_2_2_2_8_2 = det*c2*w[1][8]*g22*g22;
    real G8_2_2_2_9_0 = det*c2*w[1][9]*g22*g02;
    real G8_2_2_2_10_1 = det*c2*w[1][10]*g22*g12;
    real G8_2_2_2_11_2 = det*c2*w[1][11]*g22*g22;

    // Compute element tensor
    block[0] = 1.666666666666662e-02*G0_0 + 8.333333333333311e-03*G0_1 + 8.333333333333312e-03*G0_2 + 8.333333333333314e-03*G0_3 + 1.666666666666662e-02*G1_0 + 8.333333333333311e-03*G1_1 + 8.333333333333312e-03*G1_2 + 8.333333333333314e-03*G1_3 - 4.166666666666661e-02*G2_0_0_0 - 4.166666666666661e-02*G2_0_0_1 - 4.166666666666661e-02*G2_0_0_2 - 4.166666666666661e-02*G2_0_0_3 - 4.166666666666662e-02*G2_0_1_0 - 4.166666666666662e-02*G2_0_1_1 - 4.166666666666662e-02*G2_0_1_2 - 4.166666666666662e-02*G2_0_1_3 - 4.166666666666661e-02*G2_0_2_0 - 4.166666666666661e-02*G2_0_2_1 - 4.166666666666661e-02*G2_0_2_2 - 4.166666666666661e-02*G2_0_2_3 - 1.666666666666662e-02*G3_0_0_0_0 - 8.333333333333309e-03*G3_0_0_0_1 - 8.333333333333309e-03*G3_0_0_0_2 - 8.333333333333312e-03*G3_0_0_0_3 - 1.666666666666662e-02*G3_0_0_1_0 - 8.333333333333311e-03*G3_0_0_1_1 - 8.333333333333312e-03*G3_0_0_1_2 - 8.333333333333314e-03*G3_0_0_1_3 - 1.666666666666662e-02*G3_0_0_2_0 - 8.333333333333309e-03*G3_0_0_2_1 - 8.333333333333311e-03*G3_0_0_2_2 - 8.333333333333314e-03*G3_0_0_2_3 - 8.333333333333309e-03*G3_0_1_0_0 - 1.666666666666661e-02*G3_0_1_0_1 - 8.333333333333309e-03*G3_0_1_0_2 - 8.333333333333311e-03*G3_0_1_0_3 - 8.333333333333311e-03*G3_0_1_1_0 - 1.666666666666662e-02*G3_0_1_1_1 - 8.333333333333309e-03*G3_0_1_1_2 - 8.333333333333311e-03*G3_0_1_1_3 - 8.333333333333309e-03*G3_0_1_2_0 - 1.666666666666661e-02*G3_0_1_2_1 - 8.333333333333309e-03*G3_0_1_2_2 - 8.333333333333311e-03*G3_0_1_2_3 - 8.333333333333309e-03*G3_0_2_0_0 - 8.333333333333309e-03*G3_0_2_0_1 - 1.666666666666662e-02*G3_0_2_0_2 - 8.333333333333311e-03*G3_0_2_0_3 - 8.333333333333312e-03*G3_0_2_1_0 - 8.333333333333309e-03*G3_0_2_1_1 - 1.666666666666662e-02*G3_0_2_1_2 - 8.333333333333312e-03*G3_0_2_1_3 - 8.333333333333311e-03*G3_0_2_2_0 - 8.333333333333309e-03*G3_0_2_2_1 - 1.666666666666662e-02*G3_0_2_2_2 - 8.333333333333311e-03*G3_0_2_2_3 - 8.333333333333312e-03*G3_0_3_0_0 - 8.333333333333311e-03*G3_0_3_0_1 - 8.333333333333311e-03*G3_0_3_0_2 - 1.666666666666662e-02*G3_0_3_0_3 - 8.333333333333314e-03*G3_0_3_1_0 - 8.333333333333311e-03*G3_0_3_1_1 - 8.333333333333312e-03*G3_0_3_1_2 - 1.666666666666662e-02*G3_0_3_1_3 - 8.333333333333314e-03*G3_0_3_2_0 - 8.333333333333311e-03*G3_0_3_2_1 - 8.333333333333311e-03*G3_0_3_2_2 - 1.666666666666662e-02*G3_0_3_2_3 - 1.666666666666662e-02*G3_1_4_0_0 - 8.333333333333307e-03*G3_1_4_0_1 - 8.333333333333307e-03*G3_1_4_0_2 - 8.333333333333312e-03*G3_1_4_0_3 - 1.666666666666662e-02*G3_1_4_1_0 - 8.333333333333309e-03*G3_1_4_1_1 - 8.333333333333309e-03*G3_1_4_1_2 - 8.333333333333314e-03*G3_1_4_1_3 - 1.666666666666662e-02*G3_1_4_2_0 - 8.333333333333307e-03*G3_1_4_2_1 - 8.333333333333307e-03*G3_1_4_2_2 - 8.333333333333314e-03*G3_1_4_2_3 - 8.333333333333311e-03*G3_1_5_0_0 - 1.666666666666662e-02*G3_1_5_0_1 - 8.333333333333311e-03*G3_1_5_0_2 - 8.333333333333312e-03*G3_1_5_0_3 - 8.333333333333311e-03*G3_1_5_1_0 - 1.666666666666662e-02*G3_1_5_1_1 - 8.333333333333312e-03*G3_1_5_1_2 - 8.333333333333314e-03*G3_1_5_1_3 - 8.333333333333311e-03*G3_1_5_2_0 - 1.666666666666662e-02*G3_1_5_2_1 - 8.333333333333311e-03*G3_1_5_2_2 - 8.333333333333312e-03*G3_1_5_2_3 - 8.333333333333309e-03*G3_1_6_0_0 - 8.333333333333309e-03*G3_1_6_0_1 - 1.666666666666662e-02*G3_1_6_0_2 - 8.333333333333311e-03*G3_1_6_0_3 - 8.333333333333312e-03*G3_1_6_1_0 - 8.333333333333309e-03*G3_1_6_1_1 - 1.666666666666662e-02*G3_1_6_1_2 - 8.333333333333312e-03*G3_1_6_1_3 - 8.333333333333311e-03*G3_1_6_2_0 - 8.333333333333309e-03*G3_1_6_2_1 - 1.666666666666662e-02*G3_1_6_2_2 - 8.333333333333311e-03*G3_1_6_2_3 - 8.333333333333312e-03*G3_1_7_0_0 - 8.333333333333311e-03*G3_1_7_0_1 - 8.333333333333311e-03*G3_1_7_0_2 - 1.666666666666662e-02*G3_1_7_0_3 - 8.333333333333314e-03*G3_1_7_1_0 - 8.333333333333311e-03*G3_1_7_1_1 - 8.333333333333312e-03*G3_1_7_1_2 - 1.666666666666662e-02*G3_1_7_1_3 - 8.333333333333314e-03*G3_1_7_2_0 - 8.333333333333311e-03*G3_1_7_2_1 - 8.333333333333311e-03*G3_1_7_2_2 - 1.666666666666662e-02*G3_1_7_2_3 - 1.666666666666662e-02*G3_2_8_0_0 - 8.333333333333307e-03*G3_2_8_0_1 - 8.333333333333307e-03*G3_2_8_0_2 - 8.333333333333312e-03*G3_2_8_0_3 - 1.666666666666662e-02*G3_2_8_1_0 - 8.333333333333309e-03*G3_2_8_1_1 - 8.333333333333309e-03*G3_2_8_1_2 - 8.333333333333314e-03*G3_2_8_1_3 - 1.666666666666662e-02*G3_2_8_2_0 - 8.333333333333307e-03*G3_2_8_2_1 - 8.333333333333307e-03*G3_2_8_2_2 - 8.333333333333314e-03*G3_2_8_2_3 - 8.333333333333311e-03*G3_2_9_0_0 - 1.666666666666662e-02*G3_2_9_0_1 - 8.333333333333311e-03*G3_2_9_0_2 - 8.333333333333312e-03*G3_2_9_0_3 - 8.333333333333311e-03*G3_2_9_1_0 - 1.666666666666662e-02*G3_2_9_1_1 - 8.333333333333312e-03*G3_2_9_1_2 - 8.333333333333314e-03*G3_2_9_1_3 - 8.333333333333311e-03*G3_2_9_2_0 - 1.666666666666662e-02*G3_2_9_2_1 - 8.333333333333311e-03*G3_2_9_2_2 - 8.333333333333312e-03*G3_2_9_2_3 - 8.333333333333309e-03*G3_2_10_0_0 - 8.333333333333309e-03*G3_2_10_0_1 - 1.666666666666662e-02*G3_2_10_0_2 - 8.333333333333311e-03*G3_2_10_0_3 - 8.333333333333312e-03*G3_2_10_1_0 - 8.333333333333309e-03*G3_2_10_1_1 - 1.666666666666662e-02*G3_2_10_1_2 - 8.333333333333312e-03*G3_2_10_1_3 - 8.333333333333311e-03*G3_2_10_2_0 - 8.333333333333309e-03*G3_2_10_2_1 - 1.666666666666662e-02*G3_2_10_2_2 - 8.333333333333311e-03*G3_2_10_2_3 - 8.333333333333312e-03*G3_2_11_0_0 - 8.333333333333311e-03*G3_2_11_0_1 - 8.333333333333311e-03*G3_2_11_0_2 - 1.666666666666662e-02*G3_2_11_0_3 - 8.333333333333314e-03*G3_2_11_1_0 - 8.333333333333311e-03*G3_2_11_1_1 - 8.333333333333312e-03*G3_2_11_1_2 - 1.666666666666662e-02*G3_2_11_1_3 - 8.333333333333314e-03*G3_2_11_2_0 - 8.333333333333311e-03*G3_2_11_2_1 - 8.333333333333311e-03*G3_2_11_2_2 - 1.666666666666662e-02*G3_2_11_2_3 - 8.333333333333320e-02*G4_0_0_0 - 8.333333333333322e-02*G4_0_0_1 - 8.333333333333320e-02*G4_0_0_2 + 8.333333333333320e-02*G4_0_1_0 + 8.333333333333322e-02*G4_0_2_1 + 8.333333333333322e-02*G4_0_3_2 - 8.333333333333322e-02*G4_1_0_0 - 8.333333333333323e-02*G4_1_0_1 - 8.333333333333322e-02*G4_1_0_2 + 8.333333333333322e-02*G4_1_1_0 + 8.333333333333323e-02*G4_1_2_1 + 8.333333333333323e-02*G4_1_3_2 - 8.333333333333320e-02*G4_2_0_0 - 8.333333333333322e-02*G4_2_0_1 - 8.333333333333320e-02*G4_2_0_2 + 8.333333333333320e-02*G4_2_1_0 + 8.333333333333322e-02*G4_2_2_1 + 8.333333333333322e-02*G4_2_3_2 + 8.333333333333309e-03*G5_0_0_0_0 + 8.333333333333311e-03*G5_0_0_0_1 + 8.333333333333311e-03*G5_0_0_0_2 - 8.333333333333309e-03*G5_0_0_1_0 - 8.333333333333311e-03*G5_0_0_2_1 - 8.333333333333311e-03*G5_0_0_3_2 + 4.166666666666654e-03*G5_0_1_0_0 + 4.166666666666655e-03*G5_0_1_0_1 + 4.166666666666654e-03*G5_0_1_0_2 - 4.166666666666654e-03*G5_0_1_1_0 - 4.166666666666655e-03*G5_0_1_2_1 - 4.166666666666655e-03*G5_0_1_3_2 + 4.166666666666654e-03*G5_0_2_0_0 + 4.166666666666656e-03*G5_0_2_0_1 + 4.166666666666655e-03*G5_0_2_0_2 - 4.166666666666654e-03*G5_0_2_1_0 - 4.166666666666656e-03*G5_0_2_2_1 - 4.166666666666656e-03*G5_0_2_3_2 + 4.166666666666656e-03*G5_0_3_0_0 + 4.166666666666657e-03*G5_0_3_0_1 + 4.166666666666657e-03*G5_0_3_0_2 - 4.166666666666656e-03*G5_0_3_1_0 - 4.166666666666657e-03*G5_0_3_2_1 - 4.166666666666657e-03*G5_0_3_3_2 + 8.333333333333309e-03*G5_1_4_0_0 + 8.333333333333311e-03*G5_1_4_0_1 + 8.333333333333311e-03*G5_1_4_0_2 - 8.333333333333309e-03*G5_1_4_1_0 - 8.333333333333311e-03*G5_1_4_2_1 - 8.333333333333311e-03*G5_1_4_3_2 + 4.166666666666655e-03*G5_1_5_0_0 + 4.166666666666655e-03*G5_1_5_0_1 + 4.166666666666655e-03*G5_1_5_0_2 - 4.166666666666655e-03*G5_1_5_1_0 - 4.166666666666655e-03*G5_1_5_2_1 - 4.166666666666655e-03*G5_1_5_3_2 + 4.166666666666654e-03*G5_1_6_0_0 + 4.166666666666656e-03*G5_1_6_0_1 + 4.166666666666655e-03*G5_1_6_0_2 - 4.166666666666654e-03*G5_1_6_1_0 - 4.166666666666656e-03*G5_1_6_2_1 - 4.166666666666656e-03*G5_1_6_3_2 + 4.166666666666656e-03*G5_1_7_0_0 + 4.166666666666657e-03*G5_1_7_0_1 + 4.166666666666657e-03*G5_1_7_0_2 - 4.166666666666656e-03*G5_1_7_1_0 - 4.166666666666657e-03*G5_1_7_2_1 - 4.166666666666657e-03*G5_1_7_3_2 + 8.333333333333309e-03*G5_2_8_0_0 + 8.333333333333311e-03*G5_2_8_0_1 + 8.333333333333311e-03*G5_2_8_0_2 - 8.333333333333309e-03*G5_2_8_1_0 - 8.333333333333311e-03*G5_2_8_2_1 - 8.333333333333311e-03*G5_2_8_3_2 + 4.166666666666655e-03*G5_2_9_0_0 + 4.166666666666655e-03*G5_2_9_0_1 + 4.166666666666655e-03*G5_2_9_0_2 - 4.166666666666655e-03*G5_2_9_1_0 - 4.166666666666655e-03*G5_2_9_2_1 - 4.166666666666655e-03*G5_2_9_3_2 + 4.166666666666654e-03*G5_2_10_0_0 + 4.166666666666656e-03*G5_2_10_0_1 + 4.166666666666655e-03*G5_2_10_0_2 - 4.166666666666654e-03*G5_2_10_1_0 - 4.166666666666656e-03*G5_2_10_2_1 - 4.166666666666656e-03*G5_2_10_3_2 + 4.166666666666656e-03*G5_2_11_0_0 + 4.166666666666657e-03*G5_2_11_0_1 + 4.166666666666657e-03*G5_2_11_0_2 - 4.166666666666656e-03*G5_2_11_1_0 - 4.166666666666657e-03*G5_2_11_2_1 - 4.166666666666657e-03*G5_2_11_3_2 - 8.333333333333309e-03*G6_0_0_0_0_0_0_0 - 8.333333333333309e-03*G6_0_0_0_0_0_0_1 - 8.333333333333309e-03*G6_0_0_0_0_0_0_2 + 8.333333333333309e-03*G6_0_0_0_0_0_1_0 + 8.333333333333309e-03*G6_0_0_0_0_0_2_1 + 8.333333333333309e-03*G6_0_0_0_0_0_3_2 - 4.166666666666654e-03*G6_0_0_0_0_1_0_0 - 4.166666666666654e-03*G6_0_0_0_0_1_0_1 - 4.166666666666654e-03*G6_0_0_0_0_1_0_2 + 4.166666666666654e-03*G6_0_0_0_0_1_1_0 + 4.166666666666654e-03*G6_0_0_0_0_1_2_1 + 4.166666666666654e-03*G6_0_0_0_0_1_3_2 - 4.166666666666654e-03*G6_0_0_0_0_2_0_0 - 4.166666666666654e-03*G6_0_0_0_0_2_0_1 - 4.166666666666654e-03*G6_0_0_0_0_2_0_2 + 4.166666666666654e-03*G6_0_0_0_0_2_1_0 + 4.166666666666654e-03*G6_0_0_0_0_2_2_1 + 4.166666666666654e-03*G6_0_0_0_0_2_3_2 - 4.166666666666656e-03*G6_0_0_0_0_3_0_0 - 4.166666666666656e-03*G6_0_0_0_0_3_0_1 - 4.166666666666656e-03*G6_0_0_0_0_3_0_2 + 4.166666666666656e-03*G6_0_0_0_0_3_1_0 + 4.166666666666656e-03*G6_0_0_0_0_3_2_1 + 4.166666666666656e-03*G6_0_0_0_0_3_3_2 - 8.333333333333309e-03*G6_0_0_0_1_0_0_0 - 8.333333333333311e-03*G6_0_0_0_1_0_0_1 - 8.333333333333311e-03*G6_0_0_0_1_0_0_2 + 8.333333333333309e-03*G6_0_0_0_1_0_1_0 + 8.333333333333311e-03*G6_0_0_0_1_0_2_1 + 8.333333333333311e-03*G6_0_0_0_1_0_3_2 - 4.166666666666654e-03*G6_0_0_0_1_1_0_0 - 4.166666666666655e-03*G6_0_0_0_1_1_0_1 - 4.166666666666654e-03*G6_0_0_0_1_1_0_2 + 4.166666666666654e-03*G6_0_0_0_1_1_1_0 + 4.166666666666655e-03*G6_0_0_0_1_1_2_1 + 4.166666666666655e-03*G6_0_0_0_1_1_3_2 - 4.166666666666654e-03*G6_0_0_0_1_2_0_0 - 4.166666666666656e-03*G6_0_0_0_1_2_0_1 - 4.166666666666655e-03*G6_0_0_0_1_2_0_2 + 4.166666666666654e-03*G6_0_0_0_1_2_1_0 + 4.166666666666656e-03*G6_0_0_0_1_2_2_1 + 4.166666666666656e-03*G6_0_0_0_1_2_3_2 - 4.166666666666656e-03*G6_0_0_0_1_3_0_0 - 4.166666666666657e-03*G6_0_0_0_1_3_0_1 - 4.166666666666657e-03*G6_0_0_0_1_3_0_2 + 4.166666666666656e-03*G6_0_0_0_1_3_1_0 + 4.166666666666657e-03*G6_0_0_0_1_3_2_1 + 4.166666666666657e-03*G6_0_0_0_1_3_3_2 - 8.333333333333309e-03*G6_0_0_0_2_0_0_0 - 8.333333333333311e-03*G6_0_0_0_2_0_0_1 - 8.333333333333311e-03*G6_0_0_0_2_0_0_2 + 8.333333333333309e-03*G6_0_0_0_2_0_1_0 + 8.333333333333311e-03*G6_0_0_0_2_0_2_1 + 8.333333333333311e-03*G6_0_0_0_2_0_3_2 - 4.166666666666654e-03*G6_0_0_0_2_1_0_0 - 4.166666666666654e-03*G6_0_0_0_2_1_0_1 - 4.166666666666654e-03*G6_0_0_0_2_1_0_2 + 4.166666666666654e-03*G6_0_0_0_2_1_1_0 + 4.166666666666654e-03*G6_0_0_0_2_1_2_1 + 4.166666666666654e-03*G6_0_0_0_2_1_3_2 - 4.166666666666654e-03*G6_0_0_0_2_2_0_0 - 4.166666666666655e-03*G6_0_0_0_2_2_0_1 - 4.166666666666654e-03*G6_0_0_0_2_2_0_2 + 4.166666666666654e-03*G6_0_0_0_2_2_1_0 + 4.166666666666655e-03*G6_0_0_0_2_2_2_1 + 4.166666666666655e-03*G6_0_0_0_2_2_3_2 - 4.166666666666656e-03*G6_0_0_0_2_3_0_0 - 4.166666666666657e-03*G6_0_0_0_2_3_0_1 - 4.166666666666657e-03*G6_0_0_0_2_3_0_2 + 4.166666666666656e-03*G6_0_0_0_2_3_1_0 + 4.166666666666657e-03*G6_0_0_0_2_3_2_1 + 4.166666666666657e-03*G6_0_0_0_2_3_3_2 - 4.166666666666654e-03*G6_0_0_1_0_0_0_0 - 4.166666666666654e-03*G6_0_0_1_0_0_0_1 - 4.166666666666654e-03*G6_0_0_1_0_0_0_2 + 4.166666666666654e-03*G6_0_0_1_0_0_1_0 + 4.166666666666654e-03*G6_0_0_1_0_0_2_1 + 4.166666666666654e-03*G6_0_0_1_0_0_3_2 - 8.333333333333307e-03*G6_0_0_1_0_1_0_0 - 8.333333333333307e-03*G6_0_0_1_0_1_0_1 - 8.333333333333305e-03*G6_0_0_1_0_1_0_2 + 8.333333333333307e-03*G6_0_0_1_0_1_1_0 + 8.333333333333307e-03*G6_0_0_1_0_1_2_1 + 8.333333333333307e-03*G6_0_0_1_0_1_3_2 - 4.166666666666654e-03*G6_0_0_1_0_2_0_0 - 4.166666666666654e-03*G6_0_0_1_0_2_0_1 - 4.166666666666653e-03*G6_0_0_1_0_2_0_2 + 4.166666666666654e-03*G6_0_0_1_0_2_1_0 + 4.166666666666654e-03*G6_0_0_1_0_2_2_1 + 4.166666666666654e-03*G6_0_0_1_0_2_3_2 - 4.166666666666654e-03*G6_0_0_1_0_3_0_0 - 4.166666666666655e-03*G6_0_0_1_0_3_0_1 - 4.166666666666655e-03*G6_0_0_1_0_3_0_2 + 4.166666666666654e-03*G6_0_0_1_0_3_1_0 + 4.166666666666655e-03*G6_0_0_1_0_3_2_1 + 4.166666666666655e-03*G6_0_0_1_0_3_3_2 - 4.166666666666654e-03*G6_0_0_1_1_0_0_0 - 4.166666666666655e-03*G6_0_0_1_1_0_0_1 - 4.166666666666654e-03*G6_0_0_1_1_0_0_2 + 4.166666666666654e-03*G6_0_0_1_1_0_1_0 + 4.166666666666655e-03*G6_0_0_1_1_0_2_1 + 4.166666666666655e-03*G6_0_0_1_1_0_3_2 - 8.333333333333307e-03*G6_0_0_1_1_1_0_0 - 8.333333333333309e-03*G6_0_0_1_1_1_0_1 - 8.333333333333307e-03*G6_0_0_1_1_1_0_2 + 8.333333333333307e-03*G6_0_0_1_1_1_1_0 + 8.333333333333309e-03*G6_0_0_1_1_1_2_1 + 8.333333333333309e-03*G6_0_0_1_1_1_3_2 - 4.166666666666654e-03*G6_0_0_1_1_2_0_0 - 4.166666666666654e-03*G6_0_0_1_1_2_0_1 - 4.166666666666654e-03*G6_0_0_1_1_2_0_2 + 4.166666666666654e-03*G6_0_0_1_1_2_1_0 + 4.166666666666654e-03*G6_0_0_1_1_2_2_1 + 4.166666666666654e-03*G6_0_0_1_1_2_3_2 - 4.166666666666655e-03*G6_0_0_1_1_3_0_0 - 4.166666666666655e-03*G6_0_0_1_1_3_0_1 - 4.166666666666655e-03*G6_0_0_1_1_3_0_2 + 4.166666666666655e-03*G6_0_0_1_1_3_1_0 + 4.166666666666655e-03*G6_0_0_1_1_3_2_1 + 4.166666666666655e-03*G6_0_0_1_1_3_3_2 - 4.166666666666654e-03*G6_0_0_1_2_0_0_0 - 4.166666666666654e-03*G6_0_0_1_2_0_0_1 - 4.166666666666654e-03*G6_0_0_1_2_0_0_2 + 4.166666666666654e-03*G6_0_0_1_2_0_1_0 + 4.166666666666654e-03*G6_0_0_1_2_0_2_1 + 4.166666666666654e-03*G6_0_0_1_2_0_3_2 - 8.333333333333307e-03*G6_0_0_1_2_1_0_0 - 8.333333333333307e-03*G6_0_0_1_2_1_0_1 - 8.333333333333305e-03*G6_0_0_1_2_1_0_2 + 8.333333333333307e-03*G6_0_0_1_2_1_1_0 + 8.333333333333307e-03*G6_0_0_1_2_1_2_1 + 8.333333333333307e-03*G6_0_0_1_2_1_3_2 - 4.166666666666654e-03*G6_0_0_1_2_2_0_0 - 4.166666666666654e-03*G6_0_0_1_2_2_0_1 - 4.166666666666653e-03*G6_0_0_1_2_2_0_2 + 4.166666666666654e-03*G6_0_0_1_2_2_1_0 + 4.166666666666654e-03*G6_0_0_1_2_2_2_1 + 4.166666666666654e-03*G6_0_0_1_2_2_3_2 - 4.166666666666655e-03*G6_0_0_1_2_3_0_0 - 4.166666666666655e-03*G6_0_0_1_2_3_0_1 - 4.166666666666655e-03*G6_0_0_1_2_3_0_2 + 4.166666666666655e-03*G6_0_0_1_2_3_1_0 + 4.166666666666655e-03*G6_0_0_1_2_3_2_1 + 4.166666666666655e-03*G6_0_0_1_2_3_3_2 - 4.166666666666654e-03*G6_0_0_2_0_0_0_0 - 4.166666666666654e-03*G6_0_0_2_0_0_0_1 - 4.166666666666654e-03*G6_0_0_2_0_0_0_2 + 4.166666666666654e-03*G6_0_0_2_0_0_1_0 + 4.166666666666654e-03*G6_0_0_2_0_0_2_1 + 4.166666666666654e-03*G6_0_0_2_0_0_3_2 - 4.166666666666654e-03*G6_0_0_2_0_1_0_0 - 4.166666666666654e-03*G6_0_0_2_0_1_0_1 - 4.166666666666653e-03*G6_0_0_2_0_1_0_2 + 4.166666666666654e-03*G6_0_0_2_0_1_1_0 + 4.166666666666654e-03*G6_0_0_2_0_1_2_1 + 4.166666666666654e-03*G6_0_0_2_0_1_3_2 - 8.333333333333309e-03*G6_0_0_2_0_2_0_0 - 8.333333333333309e-03*G6_0_0_2_0_2_0_1 - 8.333333333333309e-03*G6_0_0_2_0_2_0_2 + 8.333333333333309e-03*G6_0_0_2_0_2_1_0 + 8.333333333333309e-03*G6_0_0_2_0_2_2_1 + 8.333333333333309e-03*G6_0_0_2_0_2_3_2 - 4.166666666666654e-03*G6_0_0_2_0_3_0_0 - 4.166666666666655e-03*G6_0_0_2_0_3_0_1 - 4.166666666666654e-03*G6_0_0_2_0_3_0_2 + 4.166666666666654e-03*G6_0_0_2_0_3_1_0 + 4.166666666666655e-03*G6_0_0_2_0_3_2_1 + 4.166666666666655e-03*G6_0_0_2_0_3_3_2 - 4.166666666666654e-03*G6_0_0_2_1_0_0_0 - 4.166666666666656e-03*G6_0_0_2_1_0_0_1 - 4.166666666666655e-03*G6_0_0_2_1_0_0_2 + 4.166666666666654e-03*G6_0_0_2_1_0_1_0 + 4.166666666666656e-03*G6_0_0_2_1_0_2_1 + 4.166666666666656e-03*G6_0_0_2_1_0_3_2 - 4.166666666666654e-03*G6_0_0_2_1_1_0_0 - 4.166666666666654e-03*G6_0_0_2_1_1_0_1 - 4.166666666666654e-03*G6_0_0_2_1_1_0_2 + 4.166666666666654e-03*G6_0_0_2_1_1_1_0 + 4.166666666666654e-03*G6_0_0_2_1_1_2_1 + 4.166666666666654e-03*G6_0_0_2_1_1_3_2 - 8.333333333333311e-03*G6_0_0_2_1_2_0_0 - 8.333333333333311e-03*G6_0_0_2_1_2_0_1 - 8.333333333333311e-03*G6_0_0_2_1_2_0_2 + 8.333333333333311e-03*G6_0_0_2_1_2_1_0 + 8.333333333333311e-03*G6_0_0_2_1_2_2_1 + 8.333333333333311e-03*G6_0_0_2_1_2_3_2 - 4.166666666666655e-03*G6_0_0_2_1_3_0_0 - 4.166666666666656e-03*G6_0_0_2_1_3_0_1 - 4.166666666666655e-03*G6_0_0_2_1_3_0_2 + 4.166666666666655e-03*G6_0_0_2_1_3_1_0 + 4.166666666666656e-03*G6_0_0_2_1_3_2_1 + 4.166666666666656e-03*G6_0_0_2_1_3_3_2 - 4.166666666666654e-03*G6_0_0_2_2_0_0_0 - 4.166666666666655e-03*G6_0_0_2_2_0_0_1 - 4.166666666666654e-03*G6_0_0_2_2_0_0_2 + 4.166666666666654e-03*G6_0_0_2_2_0_1_0 + 4.166666666666655e-03*G6_0_0_2_2_0_2_1 + 4.166666666666655e-03*G6_0_0_2_2_0_3_2 - 4.166666666666654e-03*G6_0_0_2_2_1_0_0 - 4.166666666666654e-03*G6_0_0_2_2_1_0_1 - 4.166666666666653e-03*G6_0_0_2_2_1_0_2 + 4.166666666666654e-03*G6_0_0_2_2_1_1_0 + 4.166666666666654e-03*G6_0_0_2_2_1_2_1 + 4.166666666666654e-03*G6_0_0_2_2_1_3_2 - 8.333333333333309e-03*G6_0_0_2_2_2_0_0 - 8.333333333333309e-03*G6_0_0_2_2_2_0_1 - 8.333333333333309e-03*G6_0_0_2_2_2_0_2 + 8.333333333333309e-03*G6_0_0_2_2_2_1_0 + 8.333333333333309e-03*G6_0_0_2_2_2_2_1 + 8.333333333333309e-03*G6_0_0_2_2_2_3_2 - 4.166666666666654e-03*G6_0_0_2_2_3_0_0 - 4.166666666666655e-03*G6_0_0_2_2_3_0_1 - 4.166666666666654e-03*G6_0_0_2_2_3_0_2 + 4.166666666666654e-03*G6_0_0_2_2_3_1_0 + 4.166666666666655e-03*G6_0_0_2_2_3_2_1 + 4.166666666666655e-03*G6_0_0_2_2_3_3_2 - 4.166666666666656e-03*G6_0_0_3_0_0_0_0 - 4.166666666666656e-03*G6_0_0_3_0_0_0_1 - 4.166666666666656e-03*G6_0_0_3_0_0_0_2 + 4.166666666666656e-03*G6_0_0_3_0_0_1_0 + 4.166666666666656e-03*G6_0_0_3_0_0_2_1 + 4.166666666666656e-03*G6_0_0_3_0_0_3_2 - 4.166666666666654e-03*G6_0_0_3_0_1_0_0 - 4.166666666666655e-03*G6_0_0_3_0_1_0_1 - 4.166666666666654e-03*G6_0_0_3_0_1_0_2 + 4.166666666666654e-03*G6_0_0_3_0_1_1_0 + 4.166666666666655e-03*G6_0_0_3_0_1_2_1 + 4.166666666666655e-03*G6_0_0_3_0_1_3_2 - 4.166666666666655e-03*G6_0_0_3_0_2_0_0 - 4.166666666666655e-03*G6_0_0_3_0_2_0_1 - 4.166666666666654e-03*G6_0_0_3_0_2_0_2 + 4.166666666666655e-03*G6_0_0_3_0_2_1_0 + 4.166666666666655e-03*G6_0_0_3_0_2_2_1 + 4.166666666666655e-03*G6_0_0_3_0_2_3_2 - 8.333333333333309e-03*G6_0_0_3_0_3_0_0 - 8.333333333333311e-03*G6_0_0_3_0_3_0_1 - 8.333333333333309e-03*G6_0_0_3_0_3_0_2 + 8.333333333333309e-03*G6_0_0_3_0_3_1_0 + 8.333333333333311e-03*G6_0_0_3_0_3_2_1 + 8.333333333333311e-03*G6_0_0_3_0_3_3_2 - 4.166666666666656e-03*G6_0_0_3_1_0_0_0 - 4.166666666666657e-03*G6_0_0_3_1_0_0_1 - 4.166666666666657e-03*G6_0_0_3_1_0_0_2 + 4.166666666666656e-03*G6_0_0_3_1_0_1_0 + 4.166666666666657e-03*G6_0_0_3_1_0_2_1 + 4.166666666666657e-03*G6_0_0_3_1_0_3_2 - 4.166666666666655e-03*G6_0_0_3_1_1_0_0 - 4.166666666666655e-03*G6_0_0_3_1_1_0_1 - 4.166666666666655e-03*G6_0_0_3_1_1_0_2 + 4.166666666666655e-03*G6_0_0_3_1_1_1_0 + 4.166666666666655e-03*G6_0_0_3_1_1_2_1 + 4.166666666666655e-03*G6_0_0_3_1_1_3_2 - 4.166666666666655e-03*G6_0_0_3_1_2_0_0 - 4.166666666666656e-03*G6_0_0_3_1_2_0_1 - 4.166666666666655e-03*G6_0_0_3_1_2_0_2 + 4.166666666666655e-03*G6_0_0_3_1_2_1_0 + 4.166666666666656e-03*G6_0_0_3_1_2_2_1 + 4.166666666666656e-03*G6_0_0_3_1_2_3_2 - 8.333333333333311e-03*G6_0_0_3_1_3_0_0 - 8.333333333333311e-03*G6_0_0_3_1_3_0_1 - 8.333333333333311e-03*G6_0_0_3_1_3_0_2 + 8.333333333333311e-03*G6_0_0_3_1_3_1_0 + 8.333333333333311e-03*G6_0_0_3_1_3_2_1 + 8.333333333333311e-03*G6_0_0_3_1_3_3_2 - 4.166666666666656e-03*G6_0_0_3_2_0_0_0 - 4.166666666666657e-03*G6_0_0_3_2_0_0_1 - 4.166666666666657e-03*G6_0_0_3_2_0_0_2 + 4.166666666666656e-03*G6_0_0_3_2_0_1_0 + 4.166666666666657e-03*G6_0_0_3_2_0_2_1 + 4.166666666666657e-03*G6_0_0_3_2_0_3_2 - 4.166666666666655e-03*G6_0_0_3_2_1_0_0 - 4.166666666666655e-03*G6_0_0_3_2_1_0_1 - 4.166666666666655e-03*G6_0_0_3_2_1_0_2 + 4.166666666666655e-03*G6_0_0_3_2_1_1_0 + 4.166666666666655e-03*G6_0_0_3_2_1_2_1 + 4.166666666666655e-03*G6_0_0_3_2_1_3_2 - 4.166666666666655e-03*G6_0_0_3_2_2_0_0 - 4.166666666666655e-03*G6_0_0_3_2_2_0_1 - 4.166666666666654e-03*G6_0_0_3_2_2_0_2 + 4.166666666666655e-03*G6_0_0_3_2_2_1_0 + 4.166666666666655e-03*G6_0_0_3_2_2_2_1 + 4.166666666666655e-03*G6_0_0_3_2_2_3_2 - 8.333333333333309e-03*G6_0_0_3_2_3_0_0 - 8.333333333333311e-03*G6_0_0_3_2_3_0_1 - 8.333333333333309e-03*G6_0_0_3_2_3_0_2 + 8.333333333333309e-03*G6_0_0_3_2_3_1_0 + 8.333333333333311e-03*G6_0_0_3_2_3_2_1 + 8.333333333333311e-03*G6_0_0_3_2_3_3_2 - 8.333333333333309e-03*G6_0_1_0_0_4_0_0 - 8.333333333333309e-03*G6_0_1_0_0_4_0_1 - 8.333333333333309e-03*G6_0_1_0_0_4_0_2 + 8.333333333333309e-03*G6_0_1_0_0_4_1_0 + 8.333333333333309e-03*G6_0_1_0_0_4_2_1 + 8.333333333333309e-03*G6_0_1_0_0_4_3_2 - 4.166666666666654e-03*G6_0_1_0_0_5_0_0 - 4.166666666666655e-03*G6_0_1_0_0_5_0_1 - 4.166666666666654e-03*G6_0_1_0_0_5_0_2 + 4.166666666666654e-03*G6_0_1_0_0_5_1_0 + 4.166666666666655e-03*G6_0_1_0_0_5_2_1 + 4.166666666666655e-03*G6_0_1_0_0_5_3_2 - 4.166666666666654e-03*G6_0_1_0_0_6_0_0 - 4.166666666666654e-03*G6_0_1_0_0_6_0_1 - 4.166666666666654e-03*G6_0_1_0_0_6_0_2 + 4.166666666666654e-03*G6_0_1_0_0_6_1_0 + 4.166666666666654e-03*G6_0_1_0_0_6_2_1 + 4.166666666666654e-03*G6_0_1_0_0_6_3_2 - 4.166666666666656e-03*G6_0_1_0_0_7_0_0 - 4.166666666666656e-03*G6_0_1_0_0_7_0_1 - 4.166666666666656e-03*G6_0_1_0_0_7_0_2 + 4.166666666666656e-03*G6_0_1_0_0_7_1_0 + 4.166666666666656e-03*G6_0_1_0_0_7_2_1 + 4.166666666666656e-03*G6_0_1_0_0_7_3_2 - 8.333333333333309e-03*G6_0_1_0_1_4_0_0 - 8.333333333333311e-03*G6_0_1_0_1_4_0_1 - 8.333333333333311e-03*G6_0_1_0_1_4_0_2 + 8.333333333333309e-03*G6_0_1_0_1_4_1_0 + 8.333333333333311e-03*G6_0_1_0_1_4_2_1 + 8.333333333333311e-03*G6_0_1_0_1_4_3_2 - 4.166666666666655e-03*G6_0_1_0_1_5_0_0 - 4.166666666666655e-03*G6_0_1_0_1_5_0_1 - 4.166666666666655e-03*G6_0_1_0_1_5_0_2 + 4.166666666666655e-03*G6_0_1_0_1_5_1_0 + 4.166666666666655e-03*G6_0_1_0_1_5_2_1 + 4.166666666666655e-03*G6_0_1_0_1_5_3_2 - 4.166666666666654e-03*G6_0_1_0_1_6_0_0 - 4.166666666666656e-03*G6_0_1_0_1_6_0_1 - 4.166666666666655e-03*G6_0_1_0_1_6_0_2 + 4.166666666666654e-03*G6_0_1_0_1_6_1_0 + 4.166666666666656e-03*G6_0_1_0_1_6_2_1 + 4.166666666666656e-03*G6_0_1_0_1_6_3_2 - 4.166666666666656e-03*G6_0_1_0_1_7_0_0 - 4.166666666666657e-03*G6_0_1_0_1_7_0_1 - 4.166666666666657e-03*G6_0_1_0_1_7_0_2 + 4.166666666666656e-03*G6_0_1_0_1_7_1_0 + 4.166666666666657e-03*G6_0_1_0_1_7_2_1 + 4.166666666666657e-03*G6_0_1_0_1_7_3_2 - 8.333333333333309e-03*G6_0_1_0_2_4_0_0 - 8.333333333333311e-03*G6_0_1_0_2_4_0_1 - 8.333333333333311e-03*G6_0_1_0_2_4_0_2 + 8.333333333333309e-03*G6_0_1_0_2_4_1_0 + 8.333333333333311e-03*G6_0_1_0_2_4_2_1 + 8.333333333333311e-03*G6_0_1_0_2_4_3_2 - 4.166666666666655e-03*G6_0_1_0_2_5_0_0 - 4.166666666666655e-03*G6_0_1_0_2_5_0_1 - 4.166666666666654e-03*G6_0_1_0_2_5_0_2 + 4.166666666666655e-03*G6_0_1_0_2_5_1_0 + 4.166666666666655e-03*G6_0_1_0_2_5_2_1 + 4.166666666666655e-03*G6_0_1_0_2_5_3_2 - 4.166666666666654e-03*G6_0_1_0_2_6_0_0 - 4.166666666666655e-03*G6_0_1_0_2_6_0_1 - 4.166666666666654e-03*G6_0_1_0_2_6_0_2 + 4.166666666666654e-03*G6_0_1_0_2_6_1_0 + 4.166666666666655e-03*G6_0_1_0_2_6_2_1 + 4.166666666666655e-03*G6_0_1_0_2_6_3_2 - 4.166666666666656e-03*G6_0_1_0_2_7_0_0 - 4.166666666666657e-03*G6_0_1_0_2_7_0_1 - 4.166666666666657e-03*G6_0_1_0_2_7_0_2 + 4.166666666666656e-03*G6_0_1_0_2_7_1_0 + 4.166666666666657e-03*G6_0_1_0_2_7_2_1 + 4.166666666666657e-03*G6_0_1_0_2_7_3_2 - 4.166666666666654e-03*G6_0_1_1_0_4_0_0 - 4.166666666666654e-03*G6_0_1_1_0_4_0_1 - 4.166666666666653e-03*G6_0_1_1_0_4_0_2 + 4.166666666666654e-03*G6_0_1_1_0_4_1_0 + 4.166666666666654e-03*G6_0_1_1_0_4_2_1 + 4.166666666666654e-03*G6_0_1_1_0_4_3_2 - 8.333333333333307e-03*G6_0_1_1_0_5_0_0 - 8.333333333333309e-03*G6_0_1_1_0_5_0_1 - 8.333333333333307e-03*G6_0_1_1_0_5_0_2 + 8.333333333333307e-03*G6_0_1_1_0_5_1_0 + 8.333333333333309e-03*G6_0_1_1_0_5_2_1 + 8.333333333333309e-03*G6_0_1_1_0_5_3_2 - 4.166666666666654e-03*G6_0_1_1_0_6_0_0 - 4.166666666666654e-03*G6_0_1_1_0_6_0_1 - 4.166666666666653e-03*G6_0_1_1_0_6_0_2 + 4.166666666666654e-03*G6_0_1_1_0_6_1_0 + 4.166666666666654e-03*G6_0_1_1_0_6_2_1 + 4.166666666666654e-03*G6_0_1_1_0_6_3_2 - 4.166666666666654e-03*G6_0_1_1_0_7_0_0 - 4.166666666666655e-03*G6_0_1_1_0_7_0_1 - 4.166666666666655e-03*G6_0_1_1_0_7_0_2 + 4.166666666666654e-03*G6_0_1_1_0_7_1_0 + 4.166666666666655e-03*G6_0_1_1_0_7_2_1 + 4.166666666666655e-03*G6_0_1_1_0_7_3_2 - 4.166666666666654e-03*G6_0_1_1_1_4_0_0 - 4.166666666666654e-03*G6_0_1_1_1_4_0_1 - 4.166666666666654e-03*G6_0_1_1_1_4_0_2 + 4.166666666666654e-03*G6_0_1_1_1_4_1_0 + 4.166666666666654e-03*G6_0_1_1_1_4_2_1 + 4.166666666666654e-03*G6_0_1_1_1_4_3_2 - 8.333333333333309e-03*G6_0_1_1_1_5_0_0 - 8.333333333333309e-03*G6_0_1_1_1_5_0_1 - 8.333333333333307e-03*G6_0_1_1_1_5_0_2 + 8.333333333333309e-03*G6_0_1_1_1_5_1_0 + 8.333333333333309e-03*G6_0_1_1_1_5_2_1 + 8.333333333333309e-03*G6_0_1_1_1_5_3_2 - 4.166666666666654e-03*G6_0_1_1_1_6_0_0 - 4.166666666666654e-03*G6_0_1_1_1_6_0_1 - 4.166666666666654e-03*G6_0_1_1_1_6_0_2 + 4.166666666666654e-03*G6_0_1_1_1_6_1_0 + 4.166666666666654e-03*G6_0_1_1_1_6_2_1 + 4.166666666666654e-03*G6_0_1_1_1_6_3_2 - 4.166666666666655e-03*G6_0_1_1_1_7_0_0 - 4.166666666666655e-03*G6_0_1_1_1_7_0_1 - 4.166666666666655e-03*G6_0_1_1_1_7_0_2 + 4.166666666666655e-03*G6_0_1_1_1_7_1_0 + 4.166666666666655e-03*G6_0_1_1_1_7_2_1 + 4.166666666666655e-03*G6_0_1_1_1_7_3_2 - 4.166666666666654e-03*G6_0_1_1_2_4_0_0 - 4.166666666666654e-03*G6_0_1_1_2_4_0_1 - 4.166666666666654e-03*G6_0_1_1_2_4_0_2 + 4.166666666666654e-03*G6_0_1_1_2_4_1_0 + 4.166666666666654e-03*G6_0_1_1_2_4_2_1 + 4.166666666666654e-03*G6_0_1_1_2_4_3_2 - 8.333333333333307e-03*G6_0_1_1_2_5_0_0 - 8.333333333333309e-03*G6_0_1_1_2_5_0_1 - 8.333333333333307e-03*G6_0_1_1_2_5_0_2 + 8.333333333333307e-03*G6_0_1_1_2_5_1_0 + 8.333333333333309e-03*G6_0_1_1_2_5_2_1 + 8.333333333333309e-03*G6_0_1_1_2_5_3_2 - 4.166666666666654e-03*G6_0_1_1_2_6_0_0 - 4.166666666666654e-03*G6_0_1_1_2_6_0_1 - 4.166666666666653e-03*G6_0_1_1_2_6_0_2 + 4.166666666666654e-03*G6_0_1_1_2_6_1_0 + 4.166666666666654e-03*G6_0_1_1_2_6_2_1 + 4.166666666666654e-03*G6_0_1_1_2_6_3_2 - 4.166666666666655e-03*G6_0_1_1_2_7_0_0 - 4.166666666666655e-03*G6_0_1_1_2_7_0_1 - 4.166666666666655e-03*G6_0_1_1_2_7_0_2 + 4.166666666666655e-03*G6_0_1_1_2_7_1_0 + 4.166666666666655e-03*G6_0_1_1_2_7_2_1 + 4.166666666666655e-03*G6_0_1_1_2_7_3_2 - 4.166666666666653e-03*G6_0_1_2_0_4_0_0 - 4.166666666666654e-03*G6_0_1_2_0_4_0_1 - 4.166666666666653e-03*G6_0_1_2_0_4_0_2 + 4.166666666666653e-03*G6_0_1_2_0_4_1_0 + 4.166666666666654e-03*G6_0_1_2_0_4_2_1 + 4.166666666666654e-03*G6_0_1_2_0_4_3_2 - 4.166666666666654e-03*G6_0_1_2_0_5_0_0 - 4.166666666666655e-03*G6_0_1_2_0_5_0_1 - 4.166666666666654e-03*G6_0_1_2_0_5_0_2 + 4.166666666666654e-03*G6_0_1_2_0_5_1_0 + 4.166666666666655e-03*G6_0_1_2_0_5_2_1 + 4.166666666666655e-03*G6_0_1_2_0_5_3_2 - 8.333333333333309e-03*G6_0_1_2_0_6_0_0 - 8.333333333333309e-03*G6_0_1_2_0_6_0_1 - 8.333333333333309e-03*G6_0_1_2_0_6_0_2 + 8.333333333333309e-03*G6_0_1_2_0_6_1_0 + 8.333333333333309e-03*G6_0_1_2_0_6_2_1 + 8.333333333333309e-03*G6_0_1_2_0_6_3_2 - 4.166666666666654e-03*G6_0_1_2_0_7_0_0 - 4.166666666666655e-03*G6_0_1_2_0_7_0_1 - 4.166666666666654e-03*G6_0_1_2_0_7_0_2 + 4.166666666666654e-03*G6_0_1_2_0_7_1_0 + 4.166666666666655e-03*G6_0_1_2_0_7_2_1 + 4.166666666666655e-03*G6_0_1_2_0_7_3_2 - 4.166666666666654e-03*G6_0_1_2_1_4_0_0 - 4.166666666666654e-03*G6_0_1_2_1_4_0_1 - 4.166666666666654e-03*G6_0_1_2_1_4_0_2 + 4.166666666666654e-03*G6_0_1_2_1_4_1_0 + 4.166666666666654e-03*G6_0_1_2_1_4_2_1 + 4.166666666666654e-03*G6_0_1_2_1_4_3_2 - 4.166666666666655e-03*G6_0_1_2_1_5_0_0 - 4.166666666666656e-03*G6_0_1_2_1_5_0_1 - 4.166666666666654e-03*G6_0_1_2_1_5_0_2 + 4.166666666666655e-03*G6_0_1_2_1_5_1_0 + 4.166666666666656e-03*G6_0_1_2_1_5_2_1 + 4.166666666666656e-03*G6_0_1_2_1_5_3_2 - 8.333333333333311e-03*G6_0_1_2_1_6_0_0 - 8.333333333333311e-03*G6_0_1_2_1_6_0_1 - 8.333333333333311e-03*G6_0_1_2_1_6_0_2 + 8.333333333333311e-03*G6_0_1_2_1_6_1_0 + 8.333333333333311e-03*G6_0_1_2_1_6_2_1 + 8.333333333333311e-03*G6_0_1_2_1_6_3_2 - 4.166666666666655e-03*G6_0_1_2_1_7_0_0 - 4.166666666666656e-03*G6_0_1_2_1_7_0_1 - 4.166666666666655e-03*G6_0_1_2_1_7_0_2 + 4.166666666666655e-03*G6_0_1_2_1_7_1_0 + 4.166666666666656e-03*G6_0_1_2_1_7_2_1 + 4.166666666666656e-03*G6_0_1_2_1_7_3_2 - 4.166666666666653e-03*G6_0_1_2_2_4_0_0 - 4.166666666666654e-03*G6_0_1_2_2_4_0_1 - 4.166666666666654e-03*G6_0_1_2_2_4_0_2 + 4.166666666666653e-03*G6_0_1_2_2_4_1_0 + 4.166666666666654e-03*G6_0_1_2_2_4_2_1 + 4.166666666666654e-03*G6_0_1_2_2_4_3_2 - 4.166666666666654e-03*G6_0_1_2_2_5_0_0 - 4.166666666666654e-03*G6_0_1_2_2_5_0_1 - 4.166666666666654e-03*G6_0_1_2_2_5_0_2 + 4.166666666666654e-03*G6_0_1_2_2_5_1_0 + 4.166666666666654e-03*G6_0_1_2_2_5_2_1 + 4.166666666666654e-03*G6_0_1_2_2_5_3_2 - 8.333333333333309e-03*G6_0_1_2_2_6_0_0 - 8.333333333333309e-03*G6_0_1_2_2_6_0_1 - 8.333333333333309e-03*G6_0_1_2_2_6_0_2 + 8.333333333333309e-03*G6_0_1_2_2_6_1_0 + 8.333333333333309e-03*G6_0_1_2_2_6_2_1 + 8.333333333333309e-03*G6_0_1_2_2_6_3_2 - 4.166666666666654e-03*G6_0_1_2_2_7_0_0 - 4.166666666666655e-03*G6_0_1_2_2_7_0_1 - 4.166666666666654e-03*G6_0_1_2_2_7_0_2 + 4.166666666666654e-03*G6_0_1_2_2_7_1_0 + 4.166666666666655e-03*G6_0_1_2_2_7_2_1 + 4.166666666666655e-03*G6_0_1_2_2_7_3_2 - 4.166666666666655e-03*G6_0_1_3_0_4_0_0 - 4.166666666666656e-03*G6_0_1_3_0_4_0_1 - 4.166666666666655e-03*G6_0_1_3_0_4_0_2 + 4.166666666666655e-03*G6_0_1_3_0_4_1_0 + 4.166666666666656e-03*G6_0_1_3_0_4_2_1 + 4.166666666666656e-03*G6_0_1_3_0_4_3_2 - 4.166666666666655e-03*G6_0_1_3_0_5_0_0 - 4.166666666666656e-03*G6_0_1_3_0_5_0_1 - 4.166666666666656e-03*G6_0_1_3_0_5_0_2 + 4.166666666666655e-03*G6_0_1_3_0_5_1_0 + 4.166666666666656e-03*G6_0_1_3_0_5_2_1 + 4.166666666666656e-03*G6_0_1_3_0_5_3_2 - 4.166666666666655e-03*G6_0_1_3_0_6_0_0 - 4.166666666666655e-03*G6_0_1_3_0_6_0_1 - 4.166666666666654e-03*G6_0_1_3_0_6_0_2 + 4.166666666666655e-03*G6_0_1_3_0_6_1_0 + 4.166666666666655e-03*G6_0_1_3_0_6_2_1 + 4.166666666666655e-03*G6_0_1_3_0_6_3_2 - 8.333333333333309e-03*G6_0_1_3_0_7_0_0 - 8.333333333333311e-03*G6_0_1_3_0_7_0_1 - 8.333333333333309e-03*G6_0_1_3_0_7_0_2 + 8.333333333333309e-03*G6_0_1_3_0_7_1_0 + 8.333333333333311e-03*G6_0_1_3_0_7_2_1 + 8.333333333333311e-03*G6_0_1_3_0_7_3_2 - 4.166666666666656e-03*G6_0_1_3_1_4_0_0 - 4.166666666666657e-03*G6_0_1_3_1_4_0_1 - 4.166666666666657e-03*G6_0_1_3_1_4_0_2 + 4.166666666666656e-03*G6_0_1_3_1_4_1_0 + 4.166666666666657e-03*G6_0_1_3_1_4_2_1 + 4.166666666666657e-03*G6_0_1_3_1_4_3_2 - 4.166666666666656e-03*G6_0_1_3_1_5_0_0 - 4.166666666666657e-03*G6_0_1_3_1_5_0_1 - 4.166666666666656e-03*G6_0_1_3_1_5_0_2 + 4.166666666666656e-03*G6_0_1_3_1_5_1_0 + 4.166666666666657e-03*G6_0_1_3_1_5_2_1 + 4.166666666666657e-03*G6_0_1_3_1_5_3_2 - 4.166666666666655e-03*G6_0_1_3_1_6_0_0 - 4.166666666666656e-03*G6_0_1_3_1_6_0_1 - 4.166666666666655e-03*G6_0_1_3_1_6_0_2 + 4.166666666666655e-03*G6_0_1_3_1_6_1_0 + 4.166666666666656e-03*G6_0_1_3_1_6_2_1 + 4.166666666666656e-03*G6_0_1_3_1_6_3_2 - 8.333333333333311e-03*G6_0_1_3_1_7_0_0 - 8.333333333333311e-03*G6_0_1_3_1_7_0_1 - 8.333333333333311e-03*G6_0_1_3_1_7_0_2 + 8.333333333333311e-03*G6_0_1_3_1_7_1_0 + 8.333333333333311e-03*G6_0_1_3_1_7_2_1 + 8.333333333333311e-03*G6_0_1_3_1_7_3_2 - 4.166666666666655e-03*G6_0_1_3_2_4_0_0 - 4.166666666666657e-03*G6_0_1_3_2_4_0_1 - 4.166666666666656e-03*G6_0_1_3_2_4_0_2 + 4.166666666666655e-03*G6_0_1_3_2_4_1_0 + 4.166666666666657e-03*G6_0_1_3_2_4_2_1 + 4.166666666666657e-03*G6_0_1_3_2_4_3_2 - 4.166666666666656e-03*G6_0_1_3_2_5_0_0 - 4.166666666666656e-03*G6_0_1_3_2_5_0_1 - 4.166666666666656e-03*G6_0_1_3_2_5_0_2 + 4.166666666666656e-03*G6_0_1_3_2_5_1_0 + 4.166666666666656e-03*G6_0_1_3_2_5_2_1 + 4.166666666666656e-03*G6_0_1_3_2_5_3_2 - 4.166666666666655e-03*G6_0_1_3_2_6_0_0 - 4.166666666666655e-03*G6_0_1_3_2_6_0_1 - 4.166666666666654e-03*G6_0_1_3_2_6_0_2 + 4.166666666666655e-03*G6_0_1_3_2_6_1_0 + 4.166666666666655e-03*G6_0_1_3_2_6_2_1 + 4.166666666666655e-03*G6_0_1_3_2_6_3_2 - 8.333333333333309e-03*G6_0_1_3_2_7_0_0 - 8.333333333333311e-03*G6_0_1_3_2_7_0_1 - 8.333333333333309e-03*G6_0_1_3_2_7_0_2 + 8.333333333333309e-03*G6_0_1_3_2_7_1_0 + 8.333333333333311e-03*G6_0_1_3_2_7_2_1 + 8.333333333333311e-03*G6_0_1_3_2_7_3_2 - 8.333333333333309e-03*G6_0_2_0_0_8_0_0 - 8.333333333333309e-03*G6_0_2_0_0_8_0_1 - 8.333333333333309e-03*G6_0_2_0_0_8_0_2 + 8.333333333333309e-03*G6_0_2_0_0_8_1_0 + 8.333333333333309e-03*G6_0_2_0_0_8_2_1 + 8.333333333333309e-03*G6_0_2_0_0_8_3_2 - 4.166666666666654e-03*G6_0_2_0_0_9_0_0 - 4.166666666666655e-03*G6_0_2_0_0_9_0_1 - 4.166666666666654e-03*G6_0_2_0_0_9_0_2 + 4.166666666666654e-03*G6_0_2_0_0_9_1_0 + 4.166666666666655e-03*G6_0_2_0_0_9_2_1 + 4.166666666666655e-03*G6_0_2_0_0_9_3_2 - 4.166666666666654e-03*G6_0_2_0_0_10_0_0 - 4.166666666666654e-03*G6_0_2_0_0_10_0_1 - 4.166666666666654e-03*G6_0_2_0_0_10_0_2 + 4.166666666666654e-03*G6_0_2_0_0_10_1_0 + 4.166666666666654e-03*G6_0_2_0_0_10_2_1 + 4.166666666666654e-03*G6_0_2_0_0_10_3_2 - 4.166666666666656e-03*G6_0_2_0_0_11_0_0 - 4.166666666666656e-03*G6_0_2_0_0_11_0_1 - 4.166666666666656e-03*G6_0_2_0_0_11_0_2 + 4.166666666666656e-03*G6_0_2_0_0_11_1_0 + 4.166666666666656e-03*G6_0_2_0_0_11_2_1 + 4.166666666666656e-03*G6_0_2_0_0_11_3_2 - 8.333333333333309e-03*G6_0_2_0_1_8_0_0 - 8.333333333333311e-03*G6_0_2_0_1_8_0_1 - 8.333333333333311e-03*G6_0_2_0_1_8_0_2 + 8.333333333333309e-03*G6_0_2_0_1_8_1_0 + 8.333333333333311e-03*G6_0_2_0_1_8_2_1 + 8.333333333333311e-03*G6_0_2_0_1_8_3_2 - 4.166666666666655e-03*G6_0_2_0_1_9_0_0 - 4.166666666666655e-03*G6_0_2_0_1_9_0_1 - 4.166666666666655e-03*G6_0_2_0_1_9_0_2 + 4.166666666666655e-03*G6_0_2_0_1_9_1_0 + 4.166666666666655e-03*G6_0_2_0_1_9_2_1 + 4.166666666666655e-03*G6_0_2_0_1_9_3_2 - 4.166666666666654e-03*G6_0_2_0_1_10_0_0 - 4.166666666666656e-03*G6_0_2_0_1_10_0_1 - 4.166666666666655e-03*G6_0_2_0_1_10_0_2 + 4.166666666666654e-03*G6_0_2_0_1_10_1_0 + 4.166666666666656e-03*G6_0_2_0_1_10_2_1 + 4.166666666666656e-03*G6_0_2_0_1_10_3_2 - 4.166666666666656e-03*G6_0_2_0_1_11_0_0 - 4.166666666666657e-03*G6_0_2_0_1_11_0_1 - 4.166666666666657e-03*G6_0_2_0_1_11_0_2 + 4.166666666666656e-03*G6_0_2_0_1_11_1_0 + 4.166666666666657e-03*G6_0_2_0_1_11_2_1 + 4.166666666666657e-03*G6_0_2_0_1_11_3_2 - 8.333333333333309e-03*G6_0_2_0_2_8_0_0 - 8.333333333333311e-03*G6_0_2_0_2_8_0_1 - 8.333333333333311e-03*G6_0_2_0_2_8_0_2 + 8.333333333333309e-03*G6_0_2_0_2_8_1_0 + 8.333333333333311e-03*G6_0_2_0_2_8_2_1 + 8.333333333333311e-03*G6_0_2_0_2_8_3_2 - 4.166666666666655e-03*G6_0_2_0_2_9_0_0 - 4.166666666666655e-03*G6_0_2_0_2_9_0_1 - 4.166666666666654e-03*G6_0_2_0_2_9_0_2 + 4.166666666666655e-03*G6_0_2_0_2_9_1_0 + 4.166666666666655e-03*G6_0_2_0_2_9_2_1 + 4.166666666666655e-03*G6_0_2_0_2_9_3_2 - 4.166666666666654e-03*G6_0_2_0_2_10_0_0 - 4.166666666666655e-03*G6_0_2_0_2_10_0_1 - 4.166666666666654e-03*G6_0_2_0_2_10_0_2 + 4.166666666666654e-03*G6_0_2_0_2_10_1_0 + 4.166666666666655e-03*G6_0_2_0_2_10_2_1 + 4.166666666666655e-03*G6_0_2_0_2_10_3_2 - 4.166666666666656e-03*G6_0_2_0_2_11_0_0 - 4.166666666666657e-03*G6_0_2_0_2_11_0_1 - 4.166666666666657e-03*G6_0_2_0_2_11_0_2 + 4.166666666666656e-03*G6_0_2_0_2_11_1_0 + 4.166666666666657e-03*G6_0_2_0_2_11_2_1 + 4.166666666666657e-03*G6_0_2_0_2_11_3_2 - 4.166666666666654e-03*G6_0_2_1_0_8_0_0 - 4.166666666666654e-03*G6_0_2_1_0_8_0_1 - 4.166666666666653e-03*G6_0_2_1_0_8_0_2 + 4.166666666666654e-03*G6_0_2_1_0_8_1_0 + 4.166666666666654e-03*G6_0_2_1_0_8_2_1 + 4.166666666666654e-03*G6_0_2_1_0_8_3_2 - 8.333333333333307e-03*G6_0_2_1_0_9_0_0 - 8.333333333333309e-03*G6_0_2_1_0_9_0_1 - 8.333333333333307e-03*G6_0_2_1_0_9_0_2 + 8.333333333333307e-03*G6_0_2_1_0_9_1_0 + 8.333333333333309e-03*G6_0_2_1_0_9_2_1 + 8.333333333333309e-03*G6_0_2_1_0_9_3_2 - 4.166666666666654e-03*G6_0_2_1_0_10_0_0 - 4.166666666666654e-03*G6_0_2_1_0_10_0_1 - 4.166666666666653e-03*G6_0_2_1_0_10_0_2 + 4.166666666666654e-03*G6_0_2_1_0_10_1_0 + 4.166666666666654e-03*G6_0_2_1_0_10_2_1 + 4.166666666666654e-03*G6_0_2_1_0_10_3_2 - 4.166666666666654e-03*G6_0_2_1_0_11_0_0 - 4.166666666666655e-03*G6_0_2_1_0_11_0_1 - 4.166666666666655e-03*G6_0_2_1_0_11_0_2 + 4.166666666666654e-03*G6_0_2_1_0_11_1_0 + 4.166666666666655e-03*G6_0_2_1_0_11_2_1 + 4.166666666666655e-03*G6_0_2_1_0_11_3_2 - 4.166666666666654e-03*G6_0_2_1_1_8_0_0 - 4.166666666666654e-03*G6_0_2_1_1_8_0_1 - 4.166666666666654e-03*G6_0_2_1_1_8_0_2 + 4.166666666666654e-03*G6_0_2_1_1_8_1_0 + 4.166666666666654e-03*G6_0_2_1_1_8_2_1 + 4.166666666666654e-03*G6_0_2_1_1_8_3_2 - 8.333333333333309e-03*G6_0_2_1_1_9_0_0 - 8.333333333333309e-03*G6_0_2_1_1_9_0_1 - 8.333333333333307e-03*G6_0_2_1_1_9_0_2 + 8.333333333333309e-03*G6_0_2_1_1_9_1_0 + 8.333333333333309e-03*G6_0_2_1_1_9_2_1 + 8.333333333333309e-03*G6_0_2_1_1_9_3_2 - 4.166666666666654e-03*G6_0_2_1_1_10_0_0 - 4.166666666666654e-03*G6_0_2_1_1_10_0_1 - 4.166666666666654e-03*G6_0_2_1_1_10_0_2 + 4.166666666666654e-03*G6_0_2_1_1_10_1_0 + 4.166666666666654e-03*G6_0_2_1_1_10_2_1 + 4.166666666666654e-03*G6_0_2_1_1_10_3_2 - 4.166666666666655e-03*G6_0_2_1_1_11_0_0 - 4.166666666666655e-03*G6_0_2_1_1_11_0_1 - 4.166666666666655e-03*G6_0_2_1_1_11_0_2 + 4.166666666666655e-03*G6_0_2_1_1_11_1_0 + 4.166666666666655e-03*G6_0_2_1_1_11_2_1 + 4.166666666666655e-03*G6_0_2_1_1_11_3_2 - 4.166666666666654e-03*G6_0_2_1_2_8_0_0 - 4.166666666666654e-03*G6_0_2_1_2_8_0_1 - 4.166666666666654e-03*G6_0_2_1_2_8_0_2 + 4.166666666666654e-03*G6_0_2_1_2_8_1_0 + 4.166666666666654e-03*G6_0_2_1_2_8_2_1 + 4.166666666666654e-03*G6_0_2_1_2_8_3_2 - 8.333333333333307e-03*G6_0_2_1_2_9_0_0 - 8.333333333333309e-03*G6_0_2_1_2_9_0_1 - 8.333333333333307e-03*G6_0_2_1_2_9_0_2 + 8.333333333333307e-03*G6_0_2_1_2_9_1_0 + 8.333333333333309e-03*G6_0_2_1_2_9_2_1 + 8.333333333333309e-03*G6_0_2_1_2_9_3_2 - 4.166666666666654e-03*G6_0_2_1_2_10_0_0 - 4.166666666666654e-03*G6_0_2_1_2_10_0_1 - 4.166666666666653e-03*G6_0_2_1_2_10_0_2 + 4.166666666666654e-03*G6_0_2_1_2_10_1_0 + 4.166666666666654e-03*G6_0_2_1_2_10_2_1 + 4.166666666666654e-03*G6_0_2_1_2_10_3_2 - 4.166666666666655e-03*G6_0_2_1_2_11_0_0 - 4.166666666666655e-03*G6_0_2_1_2_11_0_1 - 4.166666666666655e-03*G6_0_2_1_2_11_0_2 + 4.166666666666655e-03*G6_0_2_1_2_11_1_0 + 4.166666666666655e-03*G6_0_2_1_2_11_2_1 + 4.166666666666655e-03*G6_0_2_1_2_11_3_2 - 4.166666666666653e-03*G6_0_2_2_0_8_0_0 - 4.166666666666654e-03*G6_0_2_2_0_8_0_1 - 4.166666666666653e-03*G6_0_2_2_0_8_0_2 + 4.166666666666653e-03*G6_0_2_2_0_8_1_0 + 4.166666666666654e-03*G6_0_2_2_0_8_2_1 + 4.166666666666654e-03*G6_0_2_2_0_8_3_2 - 4.166666666666654e-03*G6_0_2_2_0_9_0_0 - 4.166666666666655e-03*G6_0_2_2_0_9_0_1 - 4.166666666666654e-03*G6_0_2_2_0_9_0_2 + 4.166666666666654e-03*G6_0_2_2_0_9_1_0 + 4.166666666666655e-03*G6_0_2_2_0_9_2_1 + 4.166666666666655e-03*G6_0_2_2_0_9_3_2 - 8.333333333333309e-03*G6_0_2_2_0_10_0_0 - 8.333333333333309e-03*G6_0_2_2_0_10_0_1 - 8.333333333333309e-03*G6_0_2_2_0_10_0_2 + 8.333333333333309e-03*G6_0_2_2_0_10_1_0 + 8.333333333333309e-03*G6_0_2_2_0_10_2_1 + 8.333333333333309e-03*G6_0_2_2_0_10_3_2 - 4.166666666666654e-03*G6_0_2_2_0_11_0_0 - 4.166666666666655e-03*G6_0_2_2_0_11_0_1 - 4.166666666666654e-03*G6_0_2_2_0_11_0_2 + 4.166666666666654e-03*G6_0_2_2_0_11_1_0 + 4.166666666666655e-03*G6_0_2_2_0_11_2_1 + 4.166666666666655e-03*G6_0_2_2_0_11_3_2 - 4.166666666666654e-03*G6_0_2_2_1_8_0_0 - 4.166666666666654e-03*G6_0_2_2_1_8_0_1 - 4.166666666666654e-03*G6_0_2_2_1_8_0_2 + 4.166666666666654e-03*G6_0_2_2_1_8_1_0 + 4.166666666666654e-03*G6_0_2_2_1_8_2_1 + 4.166666666666654e-03*G6_0_2_2_1_8_3_2 - 4.166666666666655e-03*G6_0_2_2_1_9_0_0 - 4.166666666666656e-03*G6_0_2_2_1_9_0_1 - 4.166666666666654e-03*G6_0_2_2_1_9_0_2 + 4.166666666666655e-03*G6_0_2_2_1_9_1_0 + 4.166666666666656e-03*G6_0_2_2_1_9_2_1 + 4.166666666666656e-03*G6_0_2_2_1_9_3_2 - 8.333333333333311e-03*G6_0_2_2_1_10_0_0 - 8.333333333333311e-03*G6_0_2_2_1_10_0_1 - 8.333333333333311e-03*G6_0_2_2_1_10_0_2 + 8.333333333333311e-03*G6_0_2_2_1_10_1_0 + 8.333333333333311e-03*G6_0_2_2_1_10_2_1 + 8.333333333333311e-03*G6_0_2_2_1_10_3_2 - 4.166666666666655e-03*G6_0_2_2_1_11_0_0 - 4.166666666666656e-03*G6_0_2_2_1_11_0_1 - 4.166666666666655e-03*G6_0_2_2_1_11_0_2 + 4.166666666666655e-03*G6_0_2_2_1_11_1_0 + 4.166666666666656e-03*G6_0_2_2_1_11_2_1 + 4.166666666666656e-03*G6_0_2_2_1_11_3_2 - 4.166666666666653e-03*G6_0_2_2_2_8_0_0 - 4.166666666666654e-03*G6_0_2_2_2_8_0_1 - 4.166666666666654e-03*G6_0_2_2_2_8_0_2 + 4.166666666666653e-03*G6_0_2_2_2_8_1_0 + 4.166666666666654e-03*G6_0_2_2_2_8_2_1 + 4.166666666666654e-03*G6_0_2_2_2_8_3_2 - 4.166666666666654e-03*G6_0_2_2_2_9_0_0 - 4.166666666666654e-03*G6_0_2_2_2_9_0_1 - 4.166666666666654e-03*G6_0_2_2_2_9_0_2 + 4.166666666666654e-03*G6_0_2_2_2_9_1_0 + 4.166666666666654e-03*G6_0_2_2_2_9_2_1 + 4.166666666666654e-03*G6_0_2_2_2_9_3_2 - 8.333333333333309e-03*G6_0_2_2_2_10_0_0 - 8.333333333333309e-03*G6_0_2_2_2_10_0_1 - 8.333333333333309e-03*G6_0_2_2_2_10_0_2 + 8.333333333333309e-03*G6_0_2_2_2_10_1_0 + 8.333333333333309e-03*G6_0_2_2_2_10_2_1 + 8.333333333333309e-03*G6_0_2_2_2_10_3_2 - 4.166666666666654e-03*G6_0_2_2_2_11_0_0 - 4.166666666666655e-03*G6_0_2_2_2_11_0_1 - 4.166666666666654e-03*G6_0_2_2_2_11_0_2 + 4.166666666666654e-03*G6_0_2_2_2_11_1_0 + 4.166666666666655e-03*G6_0_2_2_2_11_2_1 + 4.166666666666655e-03*G6_0_2_2_2_11_3_2 - 4.166666666666655e-03*G6_0_2_3_0_8_0_0 - 4.166666666666656e-03*G6_0_2_3_0_8_0_1 - 4.166666666666655e-03*G6_0_2_3_0_8_0_2 + 4.166666666666655e-03*G6_0_2_3_0_8_1_0 + 4.166666666666656e-03*G6_0_2_3_0_8_2_1 + 4.166666666666656e-03*G6_0_2_3_0_8_3_2 - 4.166666666666655e-03*G6_0_2_3_0_9_0_0 - 4.166666666666656e-03*G6_0_2_3_0_9_0_1 - 4.166666666666656e-03*G6_0_2_3_0_9_0_2 + 4.166666666666655e-03*G6_0_2_3_0_9_1_0 + 4.166666666666656e-03*G6_0_2_3_0_9_2_1 + 4.166666666666656e-03*G6_0_2_3_0_9_3_2 - 4.166666666666655e-03*G6_0_2_3_0_10_0_0 - 4.166666666666655e-03*G6_0_2_3_0_10_0_1 - 4.166666666666654e-03*G6_0_2_3_0_10_0_2 + 4.166666666666655e-03*G6_0_2_3_0_10_1_0 + 4.166666666666655e-03*G6_0_2_3_0_10_2_1 + 4.166666666666655e-03*G6_0_2_3_0_10_3_2 - 8.333333333333309e-03*G6_0_2_3_0_11_0_0 - 8.333333333333311e-03*G6_0_2_3_0_11_0_1 - 8.333333333333309e-03*G6_0_2_3_0_11_0_2 + 8.333333333333309e-03*G6_0_2_3_0_11_1_0 + 8.333333333333311e-03*G6_0_2_3_0_11_2_1 + 8.333333333333311e-03*G6_0_2_3_0_11_3_2 - 4.166666666666656e-03*G6_0_2_3_1_8_0_0 - 4.166666666666657e-03*G6_0_2_3_1_8_0_1 - 4.166666666666657e-03*G6_0_2_3_1_8_0_2 + 4.166666666666656e-03*G6_0_2_3_1_8_1_0 + 4.166666666666657e-03*G6_0_2_3_1_8_2_1 + 4.166666666666657e-03*G6_0_2_3_1_8_3_2 - 4.166666666666656e-03*G6_0_2_3_1_9_0_0 - 4.166666666666657e-03*G6_0_2_3_1_9_0_1 - 4.166666666666656e-03*G6_0_2_3_1_9_0_2 + 4.166666666666656e-03*G6_0_2_3_1_9_1_0 + 4.166666666666657e-03*G6_0_2_3_1_9_2_1 + 4.166666666666657e-03*G6_0_2_3_1_9_3_2 - 4.166666666666655e-03*G6_0_2_3_1_10_0_0 - 4.166666666666656e-03*G6_0_2_3_1_10_0_1 - 4.166666666666655e-03*G6_0_2_3_1_10_0_2 + 4.166666666666655e-03*G6_0_2_3_1_10_1_0 + 4.166666666666656e-03*G6_0_2_3_1_10_2_1 + 4.166666666666656e-03*G6_0_2_3_1_10_3_2 - 8.333333333333311e-03*G6_0_2_3_1_11_0_0 - 8.333333333333311e-03*G6_0_2_3_1_11_0_1 - 8.333333333333311e-03*G6_0_2_3_1_11_0_2 + 8.333333333333311e-03*G6_0_2_3_1_11_1_0 + 8.333333333333311e-03*G6_0_2_3_1_11_2_1 + 8.333333333333311e-03*G6_0_2_3_1_11_3_2 - 4.166666666666655e-03*G6_0_2_3_2_8_0_0 - 4.166666666666657e-03*G6_0_2_3_2_8_0_1 - 4.166666666666656e-03*G6_0_2_3_2_8_0_2 + 4.166666666666655e-03*G6_0_2_3_2_8_1_0 + 4.166666666666657e-03*G6_0_2_3_2_8_2_1 + 4.166666666666657e-03*G6_0_2_3_2_8_3_2 - 4.166666666666656e-03*G6_0_2_3_2_9_0_0 - 4.166666666666656e-03*G6_0_2_3_2_9_0_1 - 4.166666666666656e-03*G6_0_2_3_2_9_0_2 + 4.166666666666656e-03*G6_0_2_3_2_9_1_0 + 4.166666666666656e-03*G6_0_2_3_2_9_2_1 + 4.166666666666656e-03*G6_0_2_3_2_9_3_2 - 4.166666666666655e-03*G6_0_2_3_2_10_0_0 - 4.166666666666655e-03*G6_0_2_3_2_10_0_1 - 4.166666666666654e-03*G6_0_2_3_2_10_0_2 + 4.166666666666655e-03*G6_0_2_3_2_10_1_0 + 4.166666666666655e-03*G6_0_2_3_2_10_2_1 + 4.166666666666655e-03*G6_0_2_3_2_10_3_2 - 8.333333333333309e-03*G6_0_2_3_2_11_0_0 - 8.333333333333311e-03*G6_0_2_3_2_11_0_1 - 8.333333333333309e-03*G6_0_2_3_2_11_0_2 + 8.333333333333309e-03*G6_0_2_3_2_11_1_0 + 8.333333333333311e-03*G6_0_2_3_2_11_2_1 + 8.333333333333311e-03*G6_0_2_3_2_11_3_2 - 8.333333333333309e-03*G6_1_0_4_0_0_0_0 - 8.333333333333309e-03*G6_1_0_4_0_0_0_1 - 8.333333333333309e-03*G6_1_0_4_0_0_0_2 + 8.333333333333309e-03*G6_1_0_4_0_0_1_0 + 8.333333333333309e-03*G6_1_0_4_0_0_2_1 + 8.333333333333309e-03*G6_1_0_4_0_0_3_2 - 4.166666666666654e-03*G6_1_0_4_0_1_0_0 - 4.166666666666654e-03*G6_1_0_4_0_1_0_1 - 4.166666666666653e-03*G6_1_0_4_0_1_0_2 + 4.166666666666654e-03*G6_1_0_4_0_1_1_0 + 4.166666666666654e-03*G6_1_0_4_0_1_2_1 + 4.166666666666654e-03*G6_1_0_4_0_1_3_2 - 4.166666666666653e-03*G6_1_0_4_0_2_0_0 - 4.166666666666654e-03*G6_1_0_4_0_2_0_1 - 4.166666666666654e-03*G6_1_0_4_0_2_0_2 + 4.166666666666653e-03*G6_1_0_4_0_2_1_0 + 4.166666666666654e-03*G6_1_0_4_0_2_2_1 + 4.166666666666654e-03*G6_1_0_4_0_2_3_2 - 4.166666666666654e-03*G6_1_0_4_0_3_0_0 - 4.166666666666656e-03*G6_1_0_4_0_3_0_1 - 4.166666666666654e-03*G6_1_0_4_0_3_0_2 + 4.166666666666654e-03*G6_1_0_4_0_3_1_0 + 4.166666666666656e-03*G6_1_0_4_0_3_2_1 + 4.166666666666656e-03*G6_1_0_4_0_3_3_2 - 8.333333333333309e-03*G6_1_0_4_1_0_0_0 - 8.333333333333311e-03*G6_1_0_4_1_0_0_1 - 8.333333333333311e-03*G6_1_0_4_1_0_0_2 + 8.333333333333309e-03*G6_1_0_4_1_0_1_0 + 8.333333333333311e-03*G6_1_0_4_1_0_2_1 + 8.333333333333311e-03*G6_1_0_4_1_0_3_2 - 4.166666666666654e-03*G6_1_0_4_1_1_0_0 - 4.166666666666654e-03*G6_1_0_4_1_1_0_1 - 4.166666666666654e-03*G6_1_0_4_1_1_0_2 + 4.166666666666654e-03*G6_1_0_4_1_1_1_0 + 4.166666666666654e-03*G6_1_0_4_1_1_2_1 + 4.166666666666654e-03*G6_1_0_4_1_1_3_2 - 4.166666666666654e-03*G6_1_0_4_1_2_0_0 - 4.166666666666654e-03*G6_1_0_4_1_2_0_1 - 4.166666666666654e-03*G6_1_0_4_1_2_0_2 + 4.166666666666654e-03*G6_1_0_4_1_2_1_0 + 4.166666666666654e-03*G6_1_0_4_1_2_2_1 + 4.166666666666654e-03*G6_1_0_4_1_2_3_2 - 4.166666666666656e-03*G6_1_0_4_1_3_0_0 - 4.166666666666657e-03*G6_1_0_4_1_3_0_1 - 4.166666666666657e-03*G6_1_0_4_1_3_0_2 + 4.166666666666656e-03*G6_1_0_4_1_3_1_0 + 4.166666666666657e-03*G6_1_0_4_1_3_2_1 + 4.166666666666657e-03*G6_1_0_4_1_3_3_2 - 8.333333333333309e-03*G6_1_0_4_2_0_0_0 - 8.333333333333311e-03*G6_1_0_4_2_0_0_1 - 8.333333333333311e-03*G6_1_0_4_2_0_0_2 + 8.333333333333309e-03*G6_1_0_4_2_0_1_0 + 8.333333333333311e-03*G6_1_0_4_2_0_2_1 + 8.333333333333311e-03*G6_1_0_4_2_0_3_2 - 4.166666666666654e-03*G6_1_0_4_2_1_0_0 - 4.166666666666654e-03*G6_1_0_4_2_1_0_1 - 4.166666666666654e-03*G6_1_0_4_2_1_0_2 + 4.166666666666654e-03*G6_1_0_4_2_1_1_0 + 4.166666666666654e-03*G6_1_0_4_2_1_2_1 + 4.166666666666654e-03*G6_1_0_4_2_1_3_2 - 4.166666666666654e-03*G6_1_0_4_2_2_0_0 - 4.166666666666654e-03*G6_1_0_4_2_2_0_1 - 4.166666666666654e-03*G6_1_0_4_2_2_0_2 + 4.166666666666654e-03*G6_1_0_4_2_2_1_0 + 4.166666666666654e-03*G6_1_0_4_2_2_2_1 + 4.166666666666654e-03*G6_1_0_4_2_2_3_2 - 4.166666666666654e-03*G6_1_0_4_2_3_0_0 - 4.166666666666657e-03*G6_1_0_4_2_3_0_1 - 4.166666666666656e-03*G6_1_0_4_2_3_0_2 + 4.166666666666654e-03*G6_1_0_4_2_3_1_0 + 4.166666666666657e-03*G6_1_0_4_2_3_2_1 + 4.166666666666657e-03*G6_1_0_4_2_3_3_2 - 4.166666666666654e-03*G6_1_0_5_0_0_0_0 - 4.166666666666655e-03*G6_1_0_5_0_0_0_1 - 4.166666666666654e-03*G6_1_0_5_0_0_0_2 + 4.166666666666654e-03*G6_1_0_5_0_0_1_0 + 4.166666666666655e-03*G6_1_0_5_0_0_2_1 + 4.166666666666655e-03*G6_1_0_5_0_0_3_2 - 8.333333333333307e-03*G6_1_0_5_0_1_0_0 - 8.333333333333309e-03*G6_1_0_5_0_1_0_1 - 8.333333333333307e-03*G6_1_0_5_0_1_0_2 + 8.333333333333307e-03*G6_1_0_5_0_1_1_0 + 8.333333333333309e-03*G6_1_0_5_0_1_2_1 + 8.333333333333309e-03*G6_1_0_5_0_1_3_2 - 4.166666666666654e-03*G6_1_0_5_0_2_0_0 - 4.166666666666655e-03*G6_1_0_5_0_2_0_1 - 4.166666666666654e-03*G6_1_0_5_0_2_0_2 + 4.166666666666654e-03*G6_1_0_5_0_2_1_0 + 4.166666666666655e-03*G6_1_0_5_0_2_2_1 + 4.166666666666655e-03*G6_1_0_5_0_2_3_2 - 4.166666666666655e-03*G6_1_0_5_0_3_0_0 - 4.166666666666656e-03*G6_1_0_5_0_3_0_1 - 4.166666666666656e-03*G6_1_0_5_0_3_0_2 + 4.166666666666655e-03*G6_1_0_5_0_3_1_0 + 4.166666666666656e-03*G6_1_0_5_0_3_2_1 + 4.166666666666656e-03*G6_1_0_5_0_3_3_2 - 4.166666666666655e-03*G6_1_0_5_1_0_0_0 - 4.166666666666655e-03*G6_1_0_5_1_0_0_1 - 4.166666666666655e-03*G6_1_0_5_1_0_0_2 + 4.166666666666655e-03*G6_1_0_5_1_0_1_0 + 4.166666666666655e-03*G6_1_0_5_1_0_2_1 + 4.166666666666655e-03*G6_1_0_5_1_0_3_2 - 8.333333333333309e-03*G6_1_0_5_1_1_0_0 - 8.333333333333309e-03*G6_1_0_5_1_1_0_1 - 8.333333333333307e-03*G6_1_0_5_1_1_0_2 + 8.333333333333309e-03*G6_1_0_5_1_1_1_0 + 8.333333333333309e-03*G6_1_0_5_1_1_2_1 + 8.333333333333309e-03*G6_1_0_5_1_1_3_2 - 4.166666666666655e-03*G6_1_0_5_1_2_0_0 - 4.166666666666656e-03*G6_1_0_5_1_2_0_1 - 4.166666666666654e-03*G6_1_0_5_1_2_0_2 + 4.166666666666655e-03*G6_1_0_5_1_2_1_0 + 4.166666666666656e-03*G6_1_0_5_1_2_2_1 + 4.166666666666656e-03*G6_1_0_5_1_2_3_2 - 4.166666666666656e-03*G6_1_0_5_1_3_0_0 - 4.166666666666657e-03*G6_1_0_5_1_3_0_1 - 4.166666666666656e-03*G6_1_0_5_1_3_0_2 + 4.166666666666656e-03*G6_1_0_5_1_3_1_0 + 4.166666666666657e-03*G6_1_0_5_1_3_2_1 + 4.166666666666657e-03*G6_1_0_5_1_3_3_2 - 4.166666666666655e-03*G6_1_0_5_2_0_0_0 - 4.166666666666655e-03*G6_1_0_5_2_0_0_1 - 4.166666666666654e-03*G6_1_0_5_2_0_0_2 + 4.166666666666655e-03*G6_1_0_5_2_0_1_0 + 4.166666666666655e-03*G6_1_0_5_2_0_2_1 + 4.166666666666655e-03*G6_1_0_5_2_0_3_2 - 8.333333333333307e-03*G6_1_0_5_2_1_0_0 - 8.333333333333309e-03*G6_1_0_5_2_1_0_1 - 8.333333333333307e-03*G6_1_0_5_2_1_0_2 + 8.333333333333307e-03*G6_1_0_5_2_1_1_0 + 8.333333333333309e-03*G6_1_0_5_2_1_2_1 + 8.333333333333309e-03*G6_1_0_5_2_1_3_2 - 4.166666666666654e-03*G6_1_0_5_2_2_0_0 - 4.166666666666655e-03*G6_1_0_5_2_2_0_1 - 4.166666666666654e-03*G6_1_0_5_2_2_0_2 + 4.166666666666654e-03*G6_1_0_5_2_2_1_0 + 4.166666666666655e-03*G6_1_0_5_2_2_2_1 + 4.166666666666655e-03*G6_1_0_5_2_2_3_2 - 4.166666666666656e-03*G6_1_0_5_2_3_0_0 - 4.166666666666656e-03*G6_1_0_5_2_3_0_1 - 4.166666666666656e-03*G6_1_0_5_2_3_0_2 + 4.166666666666656e-03*G6_1_0_5_2_3_1_0 + 4.166666666666656e-03*G6_1_0_5_2_3_2_1 + 4.166666666666656e-03*G6_1_0_5_2_3_3_2 - 4.166666666666654e-03*G6_1_0_6_0_0_0_0 - 4.166666666666654e-03*G6_1_0_6_0_0_0_1 - 4.166666666666654e-03*G6_1_0_6_0_0_0_2 + 4.166666666666654e-03*G6_1_0_6_0_0_1_0 + 4.166666666666654e-03*G6_1_0_6_0_0_2_1 + 4.166666666666654e-03*G6_1_0_6_0_0_3_2 - 4.166666666666654e-03*G6_1_0_6_0_1_0_0 - 4.166666666666654e-03*G6_1_0_6_0_1_0_1 - 4.166666666666653e-03*G6_1_0_6_0_1_0_2 + 4.166666666666654e-03*G6_1_0_6_0_1_1_0 + 4.166666666666654e-03*G6_1_0_6_0_1_2_1 + 4.166666666666654e-03*G6_1_0_6_0_1_3_2 - 8.333333333333309e-03*G6_1_0_6_0_2_0_0 - 8.333333333333309e-03*G6_1_0_6_0_2_0_1 - 8.333333333333309e-03*G6_1_0_6_0_2_0_2 + 8.333333333333309e-03*G6_1_0_6_0_2_1_0 + 8.333333333333309e-03*G6_1_0_6_0_2_2_1 + 8.333333333333309e-03*G6_1_0_6_0_2_3_2 - 4.166666666666654e-03*G6_1_0_6_0_3_0_0 - 4.166666666666655e-03*G6_1_0_6_0_3_0_1 - 4.166666666666654e-03*G6_1_0_6_0_3_0_2 + 4.166666666666654e-03*G6_1_0_6_0_3_1_0 + 4.166666666666655e-03*G6_1_0_6_0_3_2_1 + 4.166666666666655e-03*G6_1_0_6_0_3_3_2 - 4.166666666666654e-03*G6_1_0_6_1_0_0_0 - 4.166666666666656e-03*G6_1_0_6_1_0_0_1 - 4.166666666666655e-03*G6_1_0_6_1_0_0_2 + 4.166666666666654e-03*G6_1_0_6_1_0_1_0 + 4.166666666666656e-03*G6_1_0_6_1_0_2_1 + 4.166666666666656e-03*G6_1_0_6_1_0_3_2 - 4.166666666666654e-03*G6_1_0_6_1_1_0_0 - 4.166666666666654e-03*G6_1_0_6_1_1_0_1 - 4.166666666666654e-03*G6_1_0_6_1_1_0_2 + 4.166666666666654e-03*G6_1_0_6_1_1_1_0 + 4.166666666666654e-03*G6_1_0_6_1_1_2_1 + 4.166666666666654e-03*G6_1_0_6_1_1_3_2 - 8.333333333333311e-03*G6_1_0_6_1_2_0_0 - 8.333333333333311e-03*G6_1_0_6_1_2_0_1 - 8.333333333333311e-03*G6_1_0_6_1_2_0_2 + 8.333333333333311e-03*G6_1_0_6_1_2_1_0 + 8.333333333333311e-03*G6_1_0_6_1_2_2_1 + 8.333333333333311e-03*G6_1_0_6_1_2_3_2 - 4.166666666666655e-03*G6_1_0_6_1_3_0_0 - 4.166666666666656e-03*G6_1_0_6_1_3_0_1 - 4.166666666666655e-03*G6_1_0_6_1_3_0_2 + 4.166666666666655e-03*G6_1_0_6_1_3_1_0 + 4.166666666666656e-03*G6_1_0_6_1_3_2_1 + 4.166666666666656e-03*G6_1_0_6_1_3_3_2 - 4.166666666666654e-03*G6_1_0_6_2_0_0_0 - 4.166666666666655e-03*G6_1_0_6_2_0_0_1 - 4.166666666666654e-03*G6_1_0_6_2_0_0_2 + 4.166666666666654e-03*G6_1_0_6_2_0_1_0 + 4.166666666666655e-03*G6_1_0_6_2_0_2_1 + 4.166666666666655e-03*G6_1_0_6_2_0_3_2 - 4.166666666666654e-03*G6_1_0_6_2_1_0_0 - 4.166666666666654e-03*G6_1_0_6_2_1_0_1 - 4.166666666666653e-03*G6_1_0_6_2_1_0_2 + 4.166666666666654e-03*G6_1_0_6_2_1_1_0 + 4.166666666666654e-03*G6_1_0_6_2_1_2_1 + 4.166666666666654e-03*G6_1_0_6_2_1_3_2 - 8.333333333333309e-03*G6_1_0_6_2_2_0_0 - 8.333333333333309e-03*G6_1_0_6_2_2_0_1 - 8.333333333333309e-03*G6_1_0_6_2_2_0_2 + 8.333333333333309e-03*G6_1_0_6_2_2_1_0 + 8.333333333333309e-03*G6_1_0_6_2_2_2_1 + 8.333333333333309e-03*G6_1_0_6_2_2_3_2 - 4.166666666666654e-03*G6_1_0_6_2_3_0_0 - 4.166666666666655e-03*G6_1_0_6_2_3_0_1 - 4.166666666666654e-03*G6_1_0_6_2_3_0_2 + 4.166666666666654e-03*G6_1_0_6_2_3_1_0 + 4.166666666666655e-03*G6_1_0_6_2_3_2_1 + 4.166666666666655e-03*G6_1_0_6_2_3_3_2 - 4.166666666666656e-03*G6_1_0_7_0_0_0_0 - 4.166666666666656e-03*G6_1_0_7_0_0_0_1 - 4.166666666666656e-03*G6_1_0_7_0_0_0_2 + 4.166666666666656e-03*G6_1_0_7_0_0_1_0 + 4.166666666666656e-03*G6_1_0_7_0_0_2_1 + 4.166666666666656e-03*G6_1_0_7_0_0_3_2 - 4.166666666666654e-03*G6_1_0_7_0_1_0_0 - 4.166666666666655e-03*G6_1_0_7_0_1_0_1 - 4.166666666666654e-03*G6_1_0_7_0_1_0_2 + 4.166666666666654e-03*G6_1_0_7_0_1_1_0 + 4.166666666666655e-03*G6_1_0_7_0_1_2_1 + 4.166666666666655e-03*G6_1_0_7_0_1_3_2 - 4.166666666666655e-03*G6_1_0_7_0_2_0_0 - 4.166666666666655e-03*G6_1_0_7_0_2_0_1 - 4.166666666666654e-03*G6_1_0_7_0_2_0_2 + 4.166666666666655e-03*G6_1_0_7_0_2_1_0 + 4.166666666666655e-03*G6_1_0_7_0_2_2_1 + 4.166666666666655e-03*G6_1_0_7_0_2_3_2 - 8.333333333333309e-03*G6_1_0_7_0_3_0_0 - 8.333333333333311e-03*G6_1_0_7_0_3_0_1 - 8.333333333333309e-03*G6_1_0_7_0_3_0_2 + 8.333333333333309e-03*G6_1_0_7_0_3_1_0 + 8.333333333333311e-03*G6_1_0_7_0_3_2_1 + 8.333333333333311e-03*G6_1_0_7_0_3_3_2 - 4.166666666666656e-03*G6_1_0_7_1_0_0_0 - 4.166666666666657e-03*G6_1_0_7_1_0_0_1 - 4.166666666666657e-03*G6_1_0_7_1_0_0_2 + 4.166666666666656e-03*G6_1_0_7_1_0_1_0 + 4.166666666666657e-03*G6_1_0_7_1_0_2_1 + 4.166666666666657e-03*G6_1_0_7_1_0_3_2 - 4.166666666666655e-03*G6_1_0_7_1_1_0_0 - 4.166666666666655e-03*G6_1_0_7_1_1_0_1 - 4.166666666666655e-03*G6_1_0_7_1_1_0_2 + 4.166666666666655e-03*G6_1_0_7_1_1_1_0 + 4.166666666666655e-03*G6_1_0_7_1_1_2_1 + 4.166666666666655e-03*G6_1_0_7_1_1_3_2 - 4.166666666666655e-03*G6_1_0_7_1_2_0_0 - 4.166666666666656e-03*G6_1_0_7_1_2_0_1 - 4.166666666666655e-03*G6_1_0_7_1_2_0_2 + 4.166666666666655e-03*G6_1_0_7_1_2_1_0 + 4.166666666666656e-03*G6_1_0_7_1_2_2_1 + 4.166666666666656e-03*G6_1_0_7_1_2_3_2 - 8.333333333333311e-03*G6_1_0_7_1_3_0_0 - 8.333333333333311e-03*G6_1_0_7_1_3_0_1 - 8.333333333333311e-03*G6_1_0_7_1_3_0_2 + 8.333333333333311e-03*G6_1_0_7_1_3_1_0 + 8.333333333333311e-03*G6_1_0_7_1_3_2_1 + 8.333333333333311e-03*G6_1_0_7_1_3_3_2 - 4.166666666666656e-03*G6_1_0_7_2_0_0_0 - 4.166666666666657e-03*G6_1_0_7_2_0_0_1 - 4.166666666666657e-03*G6_1_0_7_2_0_0_2 + 4.166666666666656e-03*G6_1_0_7_2_0_1_0 + 4.166666666666657e-03*G6_1_0_7_2_0_2_1 + 4.166666666666657e-03*G6_1_0_7_2_0_3_2 - 4.166666666666655e-03*G6_1_0_7_2_1_0_0 - 4.166666666666655e-03*G6_1_0_7_2_1_0_1 - 4.166666666666655e-03*G6_1_0_7_2_1_0_2 + 4.166666666666655e-03*G6_1_0_7_2_1_1_0 + 4.166666666666655e-03*G6_1_0_7_2_1_2_1 + 4.166666666666655e-03*G6_1_0_7_2_1_3_2 - 4.166666666666655e-03*G6_1_0_7_2_2_0_0 - 4.166666666666655e-03*G6_1_0_7_2_2_0_1 - 4.166666666666654e-03*G6_1_0_7_2_2_0_2 + 4.166666666666655e-03*G6_1_0_7_2_2_1_0 + 4.166666666666655e-03*G6_1_0_7_2_2_2_1 + 4.166666666666655e-03*G6_1_0_7_2_2_3_2 - 8.333333333333309e-03*G6_1_0_7_2_3_0_0 - 8.333333333333311e-03*G6_1_0_7_2_3_0_1 - 8.333333333333309e-03*G6_1_0_7_2_3_0_2 + 8.333333333333309e-03*G6_1_0_7_2_3_1_0 + 8.333333333333311e-03*G6_1_0_7_2_3_2_1 + 8.333333333333311e-03*G6_1_0_7_2_3_3_2 - 8.333333333333309e-03*G6_1_1_4_0_4_0_0 - 8.333333333333309e-03*G6_1_1_4_0_4_0_1 - 8.333333333333309e-03*G6_1_1_4_0_4_0_2 + 8.333333333333309e-03*G6_1_1_4_0_4_1_0 + 8.333333333333309e-03*G6_1_1_4_0_4_2_1 + 8.333333333333309e-03*G6_1_1_4_0_4_3_2 - 4.166666666666654e-03*G6_1_1_4_0_5_0_0 - 4.166666666666654e-03*G6_1_1_4_0_5_0_1 - 4.166666666666654e-03*G6_1_1_4_0_5_0_2 + 4.166666666666654e-03*G6_1_1_4_0_5_1_0 + 4.166666666666654e-03*G6_1_1_4_0_5_2_1 + 4.166666666666654e-03*G6_1_1_4_0_5_3_2 - 4.166666666666653e-03*G6_1_1_4_0_6_0_0 - 4.166666666666654e-03*G6_1_1_4_0_6_0_1 - 4.166666666666654e-03*G6_1_1_4_0_6_0_2 + 4.166666666666653e-03*G6_1_1_4_0_6_1_0 + 4.166666666666654e-03*G6_1_1_4_0_6_2_1 + 4.166666666666654e-03*G6_1_1_4_0_6_3_2 - 4.166666666666654e-03*G6_1_1_4_0_7_0_0 - 4.166666666666656e-03*G6_1_1_4_0_7_0_1 - 4.166666666666654e-03*G6_1_1_4_0_7_0_2 + 4.166666666666654e-03*G6_1_1_4_0_7_1_0 + 4.166666666666656e-03*G6_1_1_4_0_7_2_1 + 4.166666666666656e-03*G6_1_1_4_0_7_3_2 - 8.333333333333309e-03*G6_1_1_4_1_4_0_0 - 8.333333333333311e-03*G6_1_1_4_1_4_0_1 - 8.333333333333311e-03*G6_1_1_4_1_4_0_2 + 8.333333333333309e-03*G6_1_1_4_1_4_1_0 + 8.333333333333311e-03*G6_1_1_4_1_4_2_1 + 8.333333333333311e-03*G6_1_1_4_1_4_3_2 - 4.166666666666654e-03*G6_1_1_4_1_5_0_0 - 4.166666666666654e-03*G6_1_1_4_1_5_0_1 - 4.166666666666654e-03*G6_1_1_4_1_5_0_2 + 4.166666666666654e-03*G6_1_1_4_1_5_1_0 + 4.166666666666654e-03*G6_1_1_4_1_5_2_1 + 4.166666666666654e-03*G6_1_1_4_1_5_3_2 - 4.166666666666654e-03*G6_1_1_4_1_6_0_0 - 4.166666666666654e-03*G6_1_1_4_1_6_0_1 - 4.166666666666654e-03*G6_1_1_4_1_6_0_2 + 4.166666666666654e-03*G6_1_1_4_1_6_1_0 + 4.166666666666654e-03*G6_1_1_4_1_6_2_1 + 4.166666666666654e-03*G6_1_1_4_1_6_3_2 - 4.166666666666656e-03*G6_1_1_4_1_7_0_0 - 4.166666666666657e-03*G6_1_1_4_1_7_0_1 - 4.166666666666657e-03*G6_1_1_4_1_7_0_2 + 4.166666666666656e-03*G6_1_1_4_1_7_1_0 + 4.166666666666657e-03*G6_1_1_4_1_7_2_1 + 4.166666666666657e-03*G6_1_1_4_1_7_3_2 - 8.333333333333309e-03*G6_1_1_4_2_4_0_0 - 8.333333333333311e-03*G6_1_1_4_2_4_0_1 - 8.333333333333311e-03*G6_1_1_4_2_4_0_2 + 8.333333333333309e-03*G6_1_1_4_2_4_1_0 + 8.333333333333311e-03*G6_1_1_4_2_4_2_1 + 8.333333333333311e-03*G6_1_1_4_2_4_3_2 - 4.166666666666654e-03*G6_1_1_4_2_5_0_0 - 4.166666666666654e-03*G6_1_1_4_2_5_0_1 - 4.166666666666654e-03*G6_1_1_4_2_5_0_2 + 4.166666666666654e-03*G6_1_1_4_2_5_1_0 + 4.166666666666654e-03*G6_1_1_4_2_5_2_1 + 4.166666666666654e-03*G6_1_1_4_2_5_3_2 - 4.166666666666654e-03*G6_1_1_4_2_6_0_0 - 4.166666666666654e-03*G6_1_1_4_2_6_0_1 - 4.166666666666654e-03*G6_1_1_4_2_6_0_2 + 4.166666666666654e-03*G6_1_1_4_2_6_1_0 + 4.166666666666654e-03*G6_1_1_4_2_6_2_1 + 4.166666666666654e-03*G6_1_1_4_2_6_3_2 - 4.166666666666654e-03*G6_1_1_4_2_7_0_0 - 4.166666666666657e-03*G6_1_1_4_2_7_0_1 - 4.166666666666656e-03*G6_1_1_4_2_7_0_2 + 4.166666666666654e-03*G6_1_1_4_2_7_1_0 + 4.166666666666657e-03*G6_1_1_4_2_7_2_1 + 4.166666666666657e-03*G6_1_1_4_2_7_3_2 - 4.166666666666654e-03*G6_1_1_5_0_4_0_0 - 4.166666666666654e-03*G6_1_1_5_0_4_0_1 - 4.166666666666654e-03*G6_1_1_5_0_4_0_2 + 4.166666666666654e-03*G6_1_1_5_0_4_1_0 + 4.166666666666654e-03*G6_1_1_5_0_4_2_1 + 4.166666666666654e-03*G6_1_1_5_0_4_3_2 - 8.333333333333307e-03*G6_1_1_5_0_5_0_0 - 8.333333333333309e-03*G6_1_1_5_0_5_0_1 - 8.333333333333307e-03*G6_1_1_5_0_5_0_2 + 8.333333333333307e-03*G6_1_1_5_0_5_1_0 + 8.333333333333309e-03*G6_1_1_5_0_5_2_1 + 8.333333333333309e-03*G6_1_1_5_0_5_3_2 - 4.166666666666654e-03*G6_1_1_5_0_6_0_0 - 4.166666666666655e-03*G6_1_1_5_0_6_0_1 - 4.166666666666654e-03*G6_1_1_5_0_6_0_2 + 4.166666666666654e-03*G6_1_1_5_0_6_1_0 + 4.166666666666655e-03*G6_1_1_5_0_6_2_1 + 4.166666666666655e-03*G6_1_1_5_0_6_3_2 - 4.166666666666655e-03*G6_1_1_5_0_7_0_0 - 4.166666666666656e-03*G6_1_1_5_0_7_0_1 - 4.166666666666656e-03*G6_1_1_5_0_7_0_2 + 4.166666666666655e-03*G6_1_1_5_0_7_1_0 + 4.166666666666656e-03*G6_1_1_5_0_7_2_1 + 4.166666666666656e-03*G6_1_1_5_0_7_3_2 - 4.166666666666654e-03*G6_1_1_5_1_4_0_0 - 4.166666666666654e-03*G6_1_1_5_1_4_0_1 - 4.166666666666654e-03*G6_1_1_5_1_4_0_2 + 4.166666666666654e-03*G6_1_1_5_1_4_1_0 + 4.166666666666654e-03*G6_1_1_5_1_4_2_1 + 4.166666666666654e-03*G6_1_1_5_1_4_3_2 - 8.333333333333309e-03*G6_1_1_5_1_5_0_0 - 8.333333333333309e-03*G6_1_1_5_1_5_0_1 - 8.333333333333307e-03*G6_1_1_5_1_5_0_2 + 8.333333333333309e-03*G6_1_1_5_1_5_1_0 + 8.333333333333309e-03*G6_1_1_5_1_5_2_1 + 8.333333333333309e-03*G6_1_1_5_1_5_3_2 - 4.166666666666655e-03*G6_1_1_5_1_6_0_0 - 4.166666666666656e-03*G6_1_1_5_1_6_0_1 - 4.166666666666654e-03*G6_1_1_5_1_6_0_2 + 4.166666666666655e-03*G6_1_1_5_1_6_1_0 + 4.166666666666656e-03*G6_1_1_5_1_6_2_1 + 4.166666666666656e-03*G6_1_1_5_1_6_3_2 - 4.166666666666656e-03*G6_1_1_5_1_7_0_0 - 4.166666666666657e-03*G6_1_1_5_1_7_0_1 - 4.166666666666656e-03*G6_1_1_5_1_7_0_2 + 4.166666666666656e-03*G6_1_1_5_1_7_1_0 + 4.166666666666657e-03*G6_1_1_5_1_7_2_1 + 4.166666666666657e-03*G6_1_1_5_1_7_3_2 - 4.166666666666654e-03*G6_1_1_5_2_4_0_0 - 4.166666666666654e-03*G6_1_1_5_2_4_0_1 - 4.166666666666654e-03*G6_1_1_5_2_4_0_2 + 4.166666666666654e-03*G6_1_1_5_2_4_1_0 + 4.166666666666654e-03*G6_1_1_5_2_4_2_1 + 4.166666666666654e-03*G6_1_1_5_2_4_3_2 - 8.333333333333307e-03*G6_1_1_5_2_5_0_0 - 8.333333333333309e-03*G6_1_1_5_2_5_0_1 - 8.333333333333307e-03*G6_1_1_5_2_5_0_2 + 8.333333333333307e-03*G6_1_1_5_2_5_1_0 + 8.333333333333309e-03*G6_1_1_5_2_5_2_1 + 8.333333333333309e-03*G6_1_1_5_2_5_3_2 - 4.166666666666654e-03*G6_1_1_5_2_6_0_0 - 4.166666666666655e-03*G6_1_1_5_2_6_0_1 - 4.166666666666654e-03*G6_1_1_5_2_6_0_2 + 4.166666666666654e-03*G6_1_1_5_2_6_1_0 + 4.166666666666655e-03*G6_1_1_5_2_6_2_1 + 4.166666666666655e-03*G6_1_1_5_2_6_3_2 - 4.166666666666656e-03*G6_1_1_5_2_7_0_0 - 4.166666666666656e-03*G6_1_1_5_2_7_0_1 - 4.166666666666656e-03*G6_1_1_5_2_7_0_2 + 4.166666666666656e-03*G6_1_1_5_2_7_1_0 + 4.166666666666656e-03*G6_1_1_5_2_7_2_1 + 4.166666666666656e-03*G6_1_1_5_2_7_3_2 - 4.166666666666653e-03*G6_1_1_6_0_4_0_0 - 4.166666666666654e-03*G6_1_1_6_0_4_0_1 - 4.166666666666653e-03*G6_1_1_6_0_4_0_2 + 4.166666666666653e-03*G6_1_1_6_0_4_1_0 + 4.166666666666654e-03*G6_1_1_6_0_4_2_1 + 4.166666666666654e-03*G6_1_1_6_0_4_3_2 - 4.166666666666654e-03*G6_1_1_6_0_5_0_0 - 4.166666666666655e-03*G6_1_1_6_0_5_0_1 - 4.166666666666654e-03*G6_1_1_6_0_5_0_2 + 4.166666666666654e-03*G6_1_1_6_0_5_1_0 + 4.166666666666655e-03*G6_1_1_6_0_5_2_1 + 4.166666666666655e-03*G6_1_1_6_0_5_3_2 - 8.333333333333309e-03*G6_1_1_6_0_6_0_0 - 8.333333333333309e-03*G6_1_1_6_0_6_0_1 - 8.333333333333309e-03*G6_1_1_6_0_6_0_2 + 8.333333333333309e-03*G6_1_1_6_0_6_1_0 + 8.333333333333309e-03*G6_1_1_6_0_6_2_1 + 8.333333333333309e-03*G6_1_1_6_0_6_3_2 - 4.166666666666654e-03*G6_1_1_6_0_7_0_0 - 4.166666666666655e-03*G6_1_1_6_0_7_0_1 - 4.166666666666654e-03*G6_1_1_6_0_7_0_2 + 4.166666666666654e-03*G6_1_1_6_0_7_1_0 + 4.166666666666655e-03*G6_1_1_6_0_7_2_1 + 4.166666666666655e-03*G6_1_1_6_0_7_3_2 - 4.166666666666654e-03*G6_1_1_6_1_4_0_0 - 4.166666666666654e-03*G6_1_1_6_1_4_0_1 - 4.166666666666654e-03*G6_1_1_6_1_4_0_2 + 4.166666666666654e-03*G6_1_1_6_1_4_1_0 + 4.166666666666654e-03*G6_1_1_6_1_4_2_1 + 4.166666666666654e-03*G6_1_1_6_1_4_3_2 - 4.166666666666655e-03*G6_1_1_6_1_5_0_0 - 4.166666666666656e-03*G6_1_1_6_1_5_0_1 - 4.166666666666654e-03*G6_1_1_6_1_5_0_2 + 4.166666666666655e-03*G6_1_1_6_1_5_1_0 + 4.166666666666656e-03*G6_1_1_6_1_5_2_1 + 4.166666666666656e-03*G6_1_1_6_1_5_3_2 - 8.333333333333311e-03*G6_1_1_6_1_6_0_0 - 8.333333333333311e-03*G6_1_1_6_1_6_0_1 - 8.333333333333311e-03*G6_1_1_6_1_6_0_2 + 8.333333333333311e-03*G6_1_1_6_1_6_1_0 + 8.333333333333311e-03*G6_1_1_6_1_6_2_1 + 8.333333333333311e-03*G6_1_1_6_1_6_3_2 - 4.166666666666655e-03*G6_1_1_6_1_7_0_0 - 4.166666666666656e-03*G6_1_1_6_1_7_0_1 - 4.166666666666655e-03*G6_1_1_6_1_7_0_2 + 4.166666666666655e-03*G6_1_1_6_1_7_1_0 + 4.166666666666656e-03*G6_1_1_6_1_7_2_1 + 4.166666666666656e-03*G6_1_1_6_1_7_3_2 - 4.166666666666653e-03*G6_1_1_6_2_4_0_0 - 4.166666666666654e-03*G6_1_1_6_2_4_0_1 - 4.166666666666654e-03*G6_1_1_6_2_4_0_2 + 4.166666666666653e-03*G6_1_1_6_2_4_1_0 + 4.166666666666654e-03*G6_1_1_6_2_4_2_1 + 4.166666666666654e-03*G6_1_1_6_2_4_3_2 - 4.166666666666654e-03*G6_1_1_6_2_5_0_0 - 4.166666666666654e-03*G6_1_1_6_2_5_0_1 - 4.166666666666654e-03*G6_1_1_6_2_5_0_2 + 4.166666666666654e-03*G6_1_1_6_2_5_1_0 + 4.166666666666654e-03*G6_1_1_6_2_5_2_1 + 4.166666666666654e-03*G6_1_1_6_2_5_3_2 - 8.333333333333309e-03*G6_1_1_6_2_6_0_0 - 8.333333333333309e-03*G6_1_1_6_2_6_0_1 - 8.333333333333309e-03*G6_1_1_6_2_6_0_2 + 8.333333333333309e-03*G6_1_1_6_2_6_1_0 + 8.333333333333309e-03*G6_1_1_6_2_6_2_1 + 8.333333333333309e-03*G6_1_1_6_2_6_3_2 - 4.166666666666654e-03*G6_1_1_6_2_7_0_0 - 4.166666666666655e-03*G6_1_1_6_2_7_0_1 - 4.166666666666654e-03*G6_1_1_6_2_7_0_2 + 4.166666666666654e-03*G6_1_1_6_2_7_1_0 + 4.166666666666655e-03*G6_1_1_6_2_7_2_1 + 4.166666666666655e-03*G6_1_1_6_2_7_3_2 - 4.166666666666655e-03*G6_1_1_7_0_4_0_0 - 4.166666666666656e-03*G6_1_1_7_0_4_0_1 - 4.166666666666655e-03*G6_1_1_7_0_4_0_2 + 4.166666666666655e-03*G6_1_1_7_0_4_1_0 + 4.166666666666656e-03*G6_1_1_7_0_4_2_1 + 4.166666666666656e-03*G6_1_1_7_0_4_3_2 - 4.166666666666655e-03*G6_1_1_7_0_5_0_0 - 4.166666666666656e-03*G6_1_1_7_0_5_0_1 - 4.166666666666656e-03*G6_1_1_7_0_5_0_2 + 4.166666666666655e-03*G6_1_1_7_0_5_1_0 + 4.166666666666656e-03*G6_1_1_7_0_5_2_1 + 4.166666666666656e-03*G6_1_1_7_0_5_3_2 - 4.166666666666655e-03*G6_1_1_7_0_6_0_0 - 4.166666666666655e-03*G6_1_1_7_0_6_0_1 - 4.166666666666654e-03*G6_1_1_7_0_6_0_2 + 4.166666666666655e-03*G6_1_1_7_0_6_1_0 + 4.166666666666655e-03*G6_1_1_7_0_6_2_1 + 4.166666666666655e-03*G6_1_1_7_0_6_3_2 - 8.333333333333309e-03*G6_1_1_7_0_7_0_0 - 8.333333333333311e-03*G6_1_1_7_0_7_0_1 - 8.333333333333309e-03*G6_1_1_7_0_7_0_2 + 8.333333333333309e-03*G6_1_1_7_0_7_1_0 + 8.333333333333311e-03*G6_1_1_7_0_7_2_1 + 8.333333333333311e-03*G6_1_1_7_0_7_3_2 - 4.166666666666656e-03*G6_1_1_7_1_4_0_0 - 4.166666666666657e-03*G6_1_1_7_1_4_0_1 - 4.166666666666657e-03*G6_1_1_7_1_4_0_2 + 4.166666666666656e-03*G6_1_1_7_1_4_1_0 + 4.166666666666657e-03*G6_1_1_7_1_4_2_1 + 4.166666666666657e-03*G6_1_1_7_1_4_3_2 - 4.166666666666656e-03*G6_1_1_7_1_5_0_0 - 4.166666666666657e-03*G6_1_1_7_1_5_0_1 - 4.166666666666656e-03*G6_1_1_7_1_5_0_2 + 4.166666666666656e-03*G6_1_1_7_1_5_1_0 + 4.166666666666657e-03*G6_1_1_7_1_5_2_1 + 4.166666666666657e-03*G6_1_1_7_1_5_3_2 - 4.166666666666655e-03*G6_1_1_7_1_6_0_0 - 4.166666666666656e-03*G6_1_1_7_1_6_0_1 - 4.166666666666655e-03*G6_1_1_7_1_6_0_2 + 4.166666666666655e-03*G6_1_1_7_1_6_1_0 + 4.166666666666656e-03*G6_1_1_7_1_6_2_1 + 4.166666666666656e-03*G6_1_1_7_1_6_3_2 - 8.333333333333311e-03*G6_1_1_7_1_7_0_0 - 8.333333333333311e-03*G6_1_1_7_1_7_0_1 - 8.333333333333311e-03*G6_1_1_7_1_7_0_2 + 8.333333333333311e-03*G6_1_1_7_1_7_1_0 + 8.333333333333311e-03*G6_1_1_7_1_7_2_1 + 8.333333333333311e-03*G6_1_1_7_1_7_3_2 - 4.166666666666655e-03*G6_1_1_7_2_4_0_0 - 4.166666666666657e-03*G6_1_1_7_2_4_0_1 - 4.166666666666656e-03*G6_1_1_7_2_4_0_2 + 4.166666666666655e-03*G6_1_1_7_2_4_1_0 + 4.166666666666657e-03*G6_1_1_7_2_4_2_1 + 4.166666666666657e-03*G6_1_1_7_2_4_3_2 - 4.166666666666656e-03*G6_1_1_7_2_5_0_0 - 4.166666666666656e-03*G6_1_1_7_2_5_0_1 - 4.166666666666656e-03*G6_1_1_7_2_5_0_2 + 4.166666666666656e-03*G6_1_1_7_2_5_1_0 + 4.166666666666656e-03*G6_1_1_7_2_5_2_1 + 4.166666666666656e-03*G6_1_1_7_2_5_3_2 - 4.166666666666655e-03*G6_1_1_7_2_6_0_0 - 4.166666666666655e-03*G6_1_1_7_2_6_0_1 - 4.166666666666654e-03*G6_1_1_7_2_6_0_2 + 4.166666666666655e-03*G6_1_1_7_2_6_1_0 + 4.166666666666655e-03*G6_1_1_7_2_6_2_1 + 4.166666666666655e-03*G6_1_1_7_2_6_3_2 - 8.333333333333309e-03*G6_1_1_7_2_7_0_0 - 8.333333333333311e-03*G6_1_1_7_2_7_0_1 - 8.333333333333309e-03*G6_1_1_7_2_7_0_2 + 8.333333333333309e-03*G6_1_1_7_2_7_1_0 + 8.333333333333311e-03*G6_1_1_7_2_7_2_1 + 8.333333333333311e-03*G6_1_1_7_2_7_3_2 - 8.333333333333309e-03*G6_1_2_4_0_8_0_0 - 8.333333333333309e-03*G6_1_2_4_0_8_0_1 - 8.333333333333309e-03*G6_1_2_4_0_8_0_2 + 8.333333333333309e-03*G6_1_2_4_0_8_1_0 + 8.333333333333309e-03*G6_1_2_4_0_8_2_1 + 8.333333333333309e-03*G6_1_2_4_0_8_3_2 - 4.166666666666654e-03*G6_1_2_4_0_9_0_0 - 4.166666666666654e-03*G6_1_2_4_0_9_0_1 - 4.166666666666654e-03*G6_1_2_4_0_9_0_2 + 4.166666666666654e-03*G6_1_2_4_0_9_1_0 + 4.166666666666654e-03*G6_1_2_4_0_9_2_1 + 4.166666666666654e-03*G6_1_2_4_0_9_3_2 - 4.166666666666653e-03*G6_1_2_4_0_10_0_0 - 4.166666666666654e-03*G6_1_2_4_0_10_0_1 - 4.166666666666654e-03*G6_1_2_4_0_10_0_2 + 4.166666666666653e-03*G6_1_2_4_0_10_1_0 + 4.166666666666654e-03*G6_1_2_4_0_10_2_1 + 4.166666666666654e-03*G6_1_2_4_0_10_3_2 - 4.166666666666654e-03*G6_1_2_4_0_11_0_0 - 4.166666666666656e-03*G6_1_2_4_0_11_0_1 - 4.166666666666654e-03*G6_1_2_4_0_11_0_2 + 4.166666666666654e-03*G6_1_2_4_0_11_1_0 + 4.166666666666656e-03*G6_1_2_4_0_11_2_1 + 4.166666666666656e-03*G6_1_2_4_0_11_3_2 - 8.333333333333309e-03*G6_1_2_4_1_8_0_0 - 8.333333333333311e-03*G6_1_2_4_1_8_0_1 - 8.333333333333311e-03*G6_1_2_4_1_8_0_2 + 8.333333333333309e-03*G6_1_2_4_1_8_1_0 + 8.333333333333311e-03*G6_1_2_4_1_8_2_1 + 8.333333333333311e-03*G6_1_2_4_1_8_3_2 - 4.166666666666654e-03*G6_1_2_4_1_9_0_0 - 4.166666666666654e-03*G6_1_2_4_1_9_0_1 - 4.166666666666654e-03*G6_1_2_4_1_9_0_2 + 4.166666666666654e-03*G6_1_2_4_1_9_1_0 + 4.166666666666654e-03*G6_1_2_4_1_9_2_1 + 4.166666666666654e-03*G6_1_2_4_1_9_3_2 - 4.166666666666654e-03*G6_1_2_4_1_10_0_0 - 4.166666666666654e-03*G6_1_2_4_1_10_0_1 - 4.166666666666654e-03*G6_1_2_4_1_10_0_2 + 4.166666666666654e-03*G6_1_2_4_1_10_1_0 + 4.166666666666654e-03*G6_1_2_4_1_10_2_1 + 4.166666666666654e-03*G6_1_2_4_1_10_3_2 - 4.166666666666656e-03*G6_1_2_4_1_11_0_0 - 4.166666666666657e-03*G6_1_2_4_1_11_0_1 - 4.166666666666657e-03*G6_1_2_4_1_11_0_2 + 4.166666666666656e-03*G6_1_2_4_1_11_1_0 + 4.166666666666657e-03*G6_1_2_4_1_11_2_1 + 4.166666666666657e-03*G6_1_2_4_1_11_3_2 - 8.333333333333309e-03*G6_1_2_4_2_8_0_0 - 8.333333333333311e-03*G6_1_2_4_2_8_0_1 - 8.333333333333311e-03*G6_1_2_4_2_8_0_2 + 8.333333333333309e-03*G6_1_2_4_2_8_1_0 + 8.333333333333311e-03*G6_1_2_4_2_8_2_1 + 8.333333333333311e-03*G6_1_2_4_2_8_3_2 - 4.166666666666654e-03*G6_1_2_4_2_9_0_0 - 4.166666666666654e-03*G6_1_2_4_2_9_0_1 - 4.166666666666654e-03*G6_1_2_4_2_9_0_2 + 4.166666666666654e-03*G6_1_2_4_2_9_1_0 + 4.166666666666654e-03*G6_1_2_4_2_9_2_1 + 4.166666666666654e-03*G6_1_2_4_2_9_3_2 - 4.166666666666654e-03*G6_1_2_4_2_10_0_0 - 4.166666666666654e-03*G6_1_2_4_2_10_0_1 - 4.166666666666654e-03*G6_1_2_4_2_10_0_2 + 4.166666666666654e-03*G6_1_2_4_2_10_1_0 + 4.166666666666654e-03*G6_1_2_4_2_10_2_1 + 4.166666666666654e-03*G6_1_2_4_2_10_3_2 - 4.166666666666654e-03*G6_1_2_4_2_11_0_0 - 4.166666666666657e-03*G6_1_2_4_2_11_0_1 - 4.166666666666656e-03*G6_1_2_4_2_11_0_2 + 4.166666666666654e-03*G6_1_2_4_2_11_1_0 + 4.166666666666657e-03*G6_1_2_4_2_11_2_1 + 4.166666666666657e-03*G6_1_2_4_2_11_3_2 - 4.166666666666654e-03*G6_1_2_5_0_8_0_0 - 4.166666666666654e-03*G6_1_2_5_0_8_0_1 - 4.166666666666654e-03*G6_1_2_5_0_8_0_2 + 4.166666666666654e-03*G6_1_2_5_0_8_1_0 + 4.166666666666654e-03*G6_1_2_5_0_8_2_1 + 4.166666666666654e-03*G6_1_2_5_0_8_3_2 - 8.333333333333307e-03*G6_1_2_5_0_9_0_0 - 8.333333333333309e-03*G6_1_2_5_0_9_0_1 - 8.333333333333307e-03*G6_1_2_5_0_9_0_2 + 8.333333333333307e-03*G6_1_2_5_0_9_1_0 + 8.333333333333309e-03*G6_1_2_5_0_9_2_1 + 8.333333333333309e-03*G6_1_2_5_0_9_3_2 - 4.166666666666654e-03*G6_1_2_5_0_10_0_0 - 4.166666666666655e-03*G6_1_2_5_0_10_0_1 - 4.166666666666654e-03*G6_1_2_5_0_10_0_2 + 4.166666666666654e-03*G6_1_2_5_0_10_1_0 + 4.166666666666655e-03*G6_1_2_5_0_10_2_1 + 4.166666666666655e-03*G6_1_2_5_0_10_3_2 - 4.166666666666655e-03*G6_1_2_5_0_11_0_0 - 4.166666666666656e-03*G6_1_2_5_0_11_0_1 - 4.166666666666656e-03*G6_1_2_5_0_11_0_2 + 4.166666666666655e-03*G6_1_2_5_0_11_1_0 + 4.166666666666656e-03*G6_1_2_5_0_11_2_1 + 4.166666666666656e-03*G6_1_2_5_0_11_3_2 - 4.166666666666654e-03*G6_1_2_5_1_8_0_0 - 4.166666666666654e-03*G6_1_2_5_1_8_0_1 - 4.166666666666654e-03*G6_1_2_5_1_8_0_2 + 4.166666666666654e-03*G6_1_2_5_1_8_1_0 + 4.166666666666654e-03*G6_1_2_5_1_8_2_1 + 4.166666666666654e-03*G6_1_2_5_1_8_3_2 - 8.333333333333309e-03*G6_1_2_5_1_9_0_0 - 8.333333333333309e-03*G6_1_2_5_1_9_0_1 - 8.333333333333307e-03*G6_1_2_5_1_9_0_2 + 8.333333333333309e-03*G6_1_2_5_1_9_1_0 + 8.333333333333309e-03*G6_1_2_5_1_9_2_1 + 8.333333333333309e-03*G6_1_2_5_1_9_3_2 - 4.166666666666655e-03*G6_1_2_5_1_10_0_0 - 4.166666666666656e-03*G6_1_2_5_1_10_0_1 - 4.166666666666654e-03*G6_1_2_5_1_10_0_2 + 4.166666666666655e-03*G6_1_2_5_1_10_1_0 + 4.166666666666656e-03*G6_1_2_5_1_10_2_1 + 4.166666666666656e-03*G6_1_2_5_1_10_3_2 - 4.166666666666656e-03*G6_1_2_5_1_11_0_0 - 4.166666666666657e-03*G6_1_2_5_1_11_0_1 - 4.166666666666656e-03*G6_1_2_5_1_11_0_2 + 4.166666666666656e-03*G6_1_2_5_1_11_1_0 + 4.166666666666657e-03*G6_1_2_5_1_11_2_1 + 4.166666666666657e-03*G6_1_2_5_1_11_3_2 - 4.166666666666654e-03*G6_1_2_5_2_8_0_0 - 4.166666666666654e-03*G6_1_2_5_2_8_0_1 - 4.166666666666654e-03*G6_1_2_5_2_8_0_2 + 4.166666666666654e-03*G6_1_2_5_2_8_1_0 + 4.166666666666654e-03*G6_1_2_5_2_8_2_1 + 4.166666666666654e-03*G6_1_2_5_2_8_3_2 - 8.333333333333307e-03*G6_1_2_5_2_9_0_0 - 8.333333333333309e-03*G6_1_2_5_2_9_0_1 - 8.333333333333307e-03*G6_1_2_5_2_9_0_2 + 8.333333333333307e-03*G6_1_2_5_2_9_1_0 + 8.333333333333309e-03*G6_1_2_5_2_9_2_1 + 8.333333333333309e-03*G6_1_2_5_2_9_3_2 - 4.166666666666654e-03*G6_1_2_5_2_10_0_0 - 4.166666666666655e-03*G6_1_2_5_2_10_0_1 - 4.166666666666654e-03*G6_1_2_5_2_10_0_2 + 4.166666666666654e-03*G6_1_2_5_2_10_1_0 + 4.166666666666655e-03*G6_1_2_5_2_10_2_1 + 4.166666666666655e-03*G6_1_2_5_2_10_3_2 - 4.166666666666656e-03*G6_1_2_5_2_11_0_0 - 4.166666666666656e-03*G6_1_2_5_2_11_0_1 - 4.166666666666656e-03*G6_1_2_5_2_11_0_2 + 4.166666666666656e-03*G6_1_2_5_2_11_1_0 + 4.166666666666656e-03*G6_1_2_5_2_11_2_1 + 4.166666666666656e-03*G6_1_2_5_2_11_3_2 - 4.166666666666653e-03*G6_1_2_6_0_8_0_0 - 4.166666666666654e-03*G6_1_2_6_0_8_0_1 - 4.166666666666653e-03*G6_1_2_6_0_8_0_2 + 4.166666666666653e-03*G6_1_2_6_0_8_1_0 + 4.166666666666654e-03*G6_1_2_6_0_8_2_1 + 4.166666666666654e-03*G6_1_2_6_0_8_3_2 - 4.166666666666654e-03*G6_1_2_6_0_9_0_0 - 4.166666666666655e-03*G6_1_2_6_0_9_0_1 - 4.166666666666654e-03*G6_1_2_6_0_9_0_2 + 4.166666666666654e-03*G6_1_2_6_0_9_1_0 + 4.166666666666655e-03*G6_1_2_6_0_9_2_1 + 4.166666666666655e-03*G6_1_2_6_0_9_3_2 - 8.333333333333309e-03*G6_1_2_6_0_10_0_0 - 8.333333333333309e-03*G6_1_2_6_0_10_0_1 - 8.333333333333309e-03*G6_1_2_6_0_10_0_2 + 8.333333333333309e-03*G6_1_2_6_0_10_1_0 + 8.333333333333309e-03*G6_1_2_6_0_10_2_1 + 8.333333333333309e-03*G6_1_2_6_0_10_3_2 - 4.166666666666654e-03*G6_1_2_6_0_11_0_0 - 4.166666666666655e-03*G6_1_2_6_0_11_0_1 - 4.166666666666654e-03*G6_1_2_6_0_11_0_2 + 4.166666666666654e-03*G6_1_2_6_0_11_1_0 + 4.166666666666655e-03*G6_1_2_6_0_11_2_1 + 4.166666666666655e-03*G6_1_2_6_0_11_3_2 - 4.166666666666654e-03*G6_1_2_6_1_8_0_0 - 4.166666666666654e-03*G6_1_2_6_1_8_0_1 - 4.166666666666654e-03*G6_1_2_6_1_8_0_2 + 4.166666666666654e-03*G6_1_2_6_1_8_1_0 + 4.166666666666654e-03*G6_1_2_6_1_8_2_1 + 4.166666666666654e-03*G6_1_2_6_1_8_3_2 - 4.166666666666655e-03*G6_1_2_6_1_9_0_0 - 4.166666666666656e-03*G6_1_2_6_1_9_0_1 - 4.166666666666654e-03*G6_1_2_6_1_9_0_2 + 4.166666666666655e-03*G6_1_2_6_1_9_1_0 + 4.166666666666656e-03*G6_1_2_6_1_9_2_1 + 4.166666666666656e-03*G6_1_2_6_1_9_3_2 - 8.333333333333311e-03*G6_1_2_6_1_10_0_0 - 8.333333333333311e-03*G6_1_2_6_1_10_0_1 - 8.333333333333311e-03*G6_1_2_6_1_10_0_2 + 8.333333333333311e-03*G6_1_2_6_1_10_1_0 + 8.333333333333311e-03*G6_1_2_6_1_10_2_1 + 8.333333333333311e-03*G6_1_2_6_1_10_3_2 - 4.166666666666655e-03*G6_1_2_6_1_11_0_0 - 4.166666666666656e-03*G6_1_2_6_1_11_0_1 - 4.166666666666655e-03*G6_1_2_6_1_11_0_2 + 4.166666666666655e-03*G6_1_2_6_1_11_1_0 + 4.166666666666656e-03*G6_1_2_6_1_11_2_1 + 4.166666666666656e-03*G6_1_2_6_1_11_3_2 - 4.166666666666653e-03*G6_1_2_6_2_8_0_0 - 4.166666666666654e-03*G6_1_2_6_2_8_0_1 - 4.166666666666654e-03*G6_1_2_6_2_8_0_2 + 4.166666666666653e-03*G6_1_2_6_2_8_1_0 + 4.166666666666654e-03*G6_1_2_6_2_8_2_1 + 4.166666666666654e-03*G6_1_2_6_2_8_3_2 - 4.166666666666654e-03*G6_1_2_6_2_9_0_0 - 4.166666666666654e-03*G6_1_2_6_2_9_0_1 - 4.166666666666654e-03*G6_1_2_6_2_9_0_2 + 4.166666666666654e-03*G6_1_2_6_2_9_1_0 + 4.166666666666654e-03*G6_1_2_6_2_9_2_1 + 4.166666666666654e-03*G6_1_2_6_2_9_3_2 - 8.333333333333309e-03*G6_1_2_6_2_10_0_0 - 8.333333333333309e-03*G6_1_2_6_2_10_0_1 - 8.333333333333309e-03*G6_1_2_6_2_10_0_2 + 8.333333333333309e-03*G6_1_2_6_2_10_1_0 + 8.333333333333309e-03*G6_1_2_6_2_10_2_1 + 8.333333333333309e-03*G6_1_2_6_2_10_3_2 - 4.166666666666654e-03*G6_1_2_6_2_11_0_0 - 4.166666666666655e-03*G6_1_2_6_2_11_0_1 - 4.166666666666654e-03*G6_1_2_6_2_11_0_2 + 4.166666666666654e-03*G6_1_2_6_2_11_1_0 + 4.166666666666655e-03*G6_1_2_6_2_11_2_1 + 4.166666666666655e-03*G6_1_2_6_2_11_3_2 - 4.166666666666655e-03*G6_1_2_7_0_8_0_0 - 4.166666666666656e-03*G6_1_2_7_0_8_0_1 - 4.166666666666655e-03*G6_1_2_7_0_8_0_2 + 4.166666666666655e-03*G6_1_2_7_0_8_1_0 + 4.166666666666656e-03*G6_1_2_7_0_8_2_1 + 4.166666666666656e-03*G6_1_2_7_0_8_3_2 - 4.166666666666655e-03*G6_1_2_7_0_9_0_0 - 4.166666666666656e-03*G6_1_2_7_0_9_0_1 - 4.166666666666656e-03*G6_1_2_7_0_9_0_2 + 4.166666666666655e-03*G6_1_2_7_0_9_1_0 + 4.166666666666656e-03*G6_1_2_7_0_9_2_1 + 4.166666666666656e-03*G6_1_2_7_0_9_3_2 - 4.166666666666655e-03*G6_1_2_7_0_10_0_0 - 4.166666666666655e-03*G6_1_2_7_0_10_0_1 - 4.166666666666654e-03*G6_1_2_7_0_10_0_2 + 4.166666666666655e-03*G6_1_2_7_0_10_1_0 + 4.166666666666655e-03*G6_1_2_7_0_10_2_1 + 4.166666666666655e-03*G6_1_2_7_0_10_3_2 - 8.333333333333309e-03*G6_1_2_7_0_11_0_0 - 8.333333333333311e-03*G6_1_2_7_0_11_0_1 - 8.333333333333309e-03*G6_1_2_7_0_11_0_2 + 8.333333333333309e-03*G6_1_2_7_0_11_1_0 + 8.333333333333311e-03*G6_1_2_7_0_11_2_1 + 8.333333333333311e-03*G6_1_2_7_0_11_3_2 - 4.166666666666656e-03*G6_1_2_7_1_8_0_0 - 4.166666666666657e-03*G6_1_2_7_1_8_0_1 - 4.166666666666657e-03*G6_1_2_7_1_8_0_2 + 4.166666666666656e-03*G6_1_2_7_1_8_1_0 + 4.166666666666657e-03*G6_1_2_7_1_8_2_1 + 4.166666666666657e-03*G6_1_2_7_1_8_3_2 - 4.166666666666656e-03*G6_1_2_7_1_9_0_0 - 4.166666666666657e-03*G6_1_2_7_1_9_0_1 - 4.166666666666656e-03*G6_1_2_7_1_9_0_2 + 4.166666666666656e-03*G6_1_2_7_1_9_1_0 + 4.166666666666657e-03*G6_1_2_7_1_9_2_1 + 4.166666666666657e-03*G6_1_2_7_1_9_3_2 - 4.166666666666655e-03*G6_1_2_7_1_10_0_0 - 4.166666666666656e-03*G6_1_2_7_1_10_0_1 - 4.166666666666655e-03*G6_1_2_7_1_10_0_2 + 4.166666666666655e-03*G6_1_2_7_1_10_1_0 + 4.166666666666656e-03*G6_1_2_7_1_10_2_1 + 4.166666666666656e-03*G6_1_2_7_1_10_3_2 - 8.333333333333311e-03*G6_1_2_7_1_11_0_0 - 8.333333333333311e-03*G6_1_2_7_1_11_0_1 - 8.333333333333311e-03*G6_1_2_7_1_11_0_2 + 8.333333333333311e-03*G6_1_2_7_1_11_1_0 + 8.333333333333311e-03*G6_1_2_7_1_11_2_1 + 8.333333333333311e-03*G6_1_2_7_1_11_3_2 - 4.166666666666655e-03*G6_1_2_7_2_8_0_0 - 4.166666666666657e-03*G6_1_2_7_2_8_0_1 - 4.166666666666656e-03*G6_1_2_7_2_8_0_2 + 4.166666666666655e-03*G6_1_2_7_2_8_1_0 + 4.166666666666657e-03*G6_1_2_7_2_8_2_1 + 4.166666666666657e-03*G6_1_2_7_2_8_3_2 - 4.166666666666656e-03*G6_1_2_7_2_9_0_0 - 4.166666666666656e-03*G6_1_2_7_2_9_0_1 - 4.166666666666656e-03*G6_1_2_7_2_9_0_2 + 4.166666666666656e-03*G6_1_2_7_2_9_1_0 + 4.166666666666656e-03*G6_1_2_7_2_9_2_1 + 4.166666666666656e-03*G6_1_2_7_2_9_3_2 - 4.166666666666655e-03*G6_1_2_7_2_10_0_0 - 4.166666666666655e-03*G6_1_2_7_2_10_0_1 - 4.166666666666654e-03*G6_1_2_7_2_10_0_2 + 4.166666666666655e-03*G6_1_2_7_2_10_1_0 + 4.166666666666655e-03*G6_1_2_7_2_10_2_1 + 4.166666666666655e-03*G6_1_2_7_2_10_3_2 - 8.333333333333309e-03*G6_1_2_7_2_11_0_0 - 8.333333333333311e-03*G6_1_2_7_2_11_0_1 - 8.333333333333309e-03*G6_1_2_7_2_11_0_2 + 8.333333333333309e-03*G6_1_2_7_2_11_1_0 + 8.333333333333311e-03*G6_1_2_7_2_11_2_1 + 8.333333333333311e-03*G6_1_2_7_2_11_3_2 - 8.333333333333309e-03*G6_2_0_8_0_0_0_0 - 8.333333333333309e-03*G6_2_0_8_0_0_0_1 - 8.333333333333309e-03*G6_2_0_8_0_0_0_2 + 8.333333333333309e-03*G6_2_0_8_0_0_1_0 + 8.333333333333309e-03*G6_2_0_8_0_0_2_1 + 8.333333333333309e-03*G6_2_0_8_0_0_3_2 - 4.166666666666654e-03*G6_2_0_8_0_1_0_0 - 4.166666666666654e-03*G6_2_0_8_0_1_0_1 - 4.166666666666653e-03*G6_2_0_8_0_1_0_2 + 4.166666666666654e-03*G6_2_0_8_0_1_1_0 + 4.166666666666654e-03*G6_2_0_8_0_1_2_1 + 4.166666666666654e-03*G6_2_0_8_0_1_3_2 - 4.166666666666653e-03*G6_2_0_8_0_2_0_0 - 4.166666666666654e-03*G6_2_0_8_0_2_0_1 - 4.166666666666654e-03*G6_2_0_8_0_2_0_2 + 4.166666666666653e-03*G6_2_0_8_0_2_1_0 + 4.166666666666654e-03*G6_2_0_8_0_2_2_1 + 4.166666666666654e-03*G6_2_0_8_0_2_3_2 - 4.166666666666654e-03*G6_2_0_8_0_3_0_0 - 4.166666666666656e-03*G6_2_0_8_0_3_0_1 - 4.166666666666654e-03*G6_2_0_8_0_3_0_2 + 4.166666666666654e-03*G6_2_0_8_0_3_1_0 + 4.166666666666656e-03*G6_2_0_8_0_3_2_1 + 4.166666666666656e-03*G6_2_0_8_0_3_3_2 - 8.333333333333309e-03*G6_2_0_8_1_0_0_0 - 8.333333333333311e-03*G6_2_0_8_1_0_0_1 - 8.333333333333311e-03*G6_2_0_8_1_0_0_2 + 8.333333333333309e-03*G6_2_0_8_1_0_1_0 + 8.333333333333311e-03*G6_2_0_8_1_0_2_1 + 8.333333333333311e-03*G6_2_0_8_1_0_3_2 - 4.166666666666654e-03*G6_2_0_8_1_1_0_0 - 4.166666666666654e-03*G6_2_0_8_1_1_0_1 - 4.166666666666654e-03*G6_2_0_8_1_1_0_2 + 4.166666666666654e-03*G6_2_0_8_1_1_1_0 + 4.166666666666654e-03*G6_2_0_8_1_1_2_1 + 4.166666666666654e-03*G6_2_0_8_1_1_3_2 - 4.166666666666654e-03*G6_2_0_8_1_2_0_0 - 4.166666666666654e-03*G6_2_0_8_1_2_0_1 - 4.166666666666654e-03*G6_2_0_8_1_2_0_2 + 4.166666666666654e-03*G6_2_0_8_1_2_1_0 + 4.166666666666654e-03*G6_2_0_8_1_2_2_1 + 4.166666666666654e-03*G6_2_0_8_1_2_3_2 - 4.166666666666656e-03*G6_2_0_8_1_3_0_0 - 4.166666666666657e-03*G6_2_0_8_1_3_0_1 - 4.166666666666657e-03*G6_2_0_8_1_3_0_2 + 4.166666666666656e-03*G6_2_0_8_1_3_1_0 + 4.166666666666657e-03*G6_2_0_8_1_3_2_1 + 4.166666666666657e-03*G6_2_0_8_1_3_3_2 - 8.333333333333309e-03*G6_2_0_8_2_0_0_0 - 8.333333333333311e-03*G6_2_0_8_2_0_0_1 - 8.333333333333311e-03*G6_2_0_8_2_0_0_2 + 8.333333333333309e-03*G6_2_0_8_2_0_1_0 + 8.333333333333311e-03*G6_2_0_8_2_0_2_1 + 8.333333333333311e-03*G6_2_0_8_2_0_3_2 - 4.166666666666654e-03*G6_2_0_8_2_1_0_0 - 4.166666666666654e-03*G6_2_0_8_2_1_0_1 - 4.166666666666654e-03*G6_2_0_8_2_1_0_2 + 4.166666666666654e-03*G6_2_0_8_2_1_1_0 + 4.166666666666654e-03*G6_2_0_8_2_1_2_1 + 4.166666666666654e-03*G6_2_0_8_2_1_3_2 - 4.166666666666654e-03*G6_2_0_8_2_2_0_0 - 4.166666666666654e-03*G6_2_0_8_2_2_0_1 - 4.166666666666654e-03*G6_2_0_8_2_2_0_2 + 4.166666666666654e-03*G6_2_0_8_2_2_1_0 + 4.166666666666654e-03*G6_2_0_8_2_2_2_1 + 4.166666666666654e-03*G6_2_0_8_2_2_3_2 - 4.166666666666654e-03*G6_2_0_8_2_3_0_0 - 4.166666666666657e-03*G6_2_0_8_2_3_0_1 - 4.166666666666656e-03*G6_2_0_8_2_3_0_2 + 4.166666666666654e-03*G6_2_0_8_2_3_1_0 + 4.166666666666657e-03*G6_2_0_8_2_3_2_1 + 4.166666666666657e-03*G6_2_0_8_2_3_3_2 - 4.166666666666654e-03*G6_2_0_9_0_0_0_0 - 4.166666666666655e-03*G6_2_0_9_0_0_0_1 - 4.166666666666654e-03*G6_2_0_9_0_0_0_2 + 4.166666666666654e-03*G6_2_0_9_0_0_1_0 + 4.166666666666655e-03*G6_2_0_9_0_0_2_1 + 4.166666666666655e-03*G6_2_0_9_0_0_3_2 - 8.333333333333307e-03*G6_2_0_9_0_1_0_0 - 8.333333333333309e-03*G6_2_0_9_0_1_0_1 - 8.333333333333307e-03*G6_2_0_9_0_1_0_2 + 8.333333333333307e-03*G6_2_0_9_0_1_1_0 + 8.333333333333309e-03*G6_2_0_9_0_1_2_1 + 8.333333333333309e-03*G6_2_0_9_0_1_3_2 - 4.166666666666654e-03*G6_2_0_9_0_2_0_0 - 4.166666666666655e-03*G6_2_0_9_0_2_0_1 - 4.166666666666654e-03*G6_2_0_9_0_2_0_2 + 4.166666666666654e-03*G6_2_0_9_0_2_1_0 + 4.166666666666655e-03*G6_2_0_9_0_2_2_1 + 4.166666666666655e-03*G6_2_0_9_0_2_3_2 - 4.166666666666655e-03*G6_2_0_9_0_3_0_0 - 4.166666666666656e-03*G6_2_0_9_0_3_0_1 - 4.166666666666656e-03*G6_2_0_9_0_3_0_2 + 4.166666666666655e-03*G6_2_0_9_0_3_1_0 + 4.166666666666656e-03*G6_2_0_9_0_3_2_1 + 4.166666666666656e-03*G6_2_0_9_0_3_3_2 - 4.166666666666655e-03*G6_2_0_9_1_0_0_0 - 4.166666666666655e-03*G6_2_0_9_1_0_0_1 - 4.166666666666655e-03*G6_2_0_9_1_0_0_2 + 4.166666666666655e-03*G6_2_0_9_1_0_1_0 + 4.166666666666655e-03*G6_2_0_9_1_0_2_1 + 4.166666666666655e-03*G6_2_0_9_1_0_3_2 - 8.333333333333309e-03*G6_2_0_9_1_1_0_0 - 8.333333333333309e-03*G6_2_0_9_1_1_0_1 - 8.333333333333307e-03*G6_2_0_9_1_1_0_2 + 8.333333333333309e-03*G6_2_0_9_1_1_1_0 + 8.333333333333309e-03*G6_2_0_9_1_1_2_1 + 8.333333333333309e-03*G6_2_0_9_1_1_3_2 - 4.166666666666655e-03*G6_2_0_9_1_2_0_0 - 4.166666666666656e-03*G6_2_0_9_1_2_0_1 - 4.166666666666654e-03*G6_2_0_9_1_2_0_2 + 4.166666666666655e-03*G6_2_0_9_1_2_1_0 + 4.166666666666656e-03*G6_2_0_9_1_2_2_1 + 4.166666666666656e-03*G6_2_0_9_1_2_3_2 - 4.166666666666656e-03*G6_2_0_9_1_3_0_0 - 4.166666666666657e-03*G6_2_0_9_1_3_0_1 - 4.166666666666656e-03*G6_2_0_9_1_3_0_2 + 4.166666666666656e-03*G6_2_0_9_1_3_1_0 + 4.166666666666657e-03*G6_2_0_9_1_3_2_1 + 4.166666666666657e-03*G6_2_0_9_1_3_3_2 - 4.166666666666655e-03*G6_2_0_9_2_0_0_0 - 4.166666666666655e-03*G6_2_0_9_2_0_0_1 - 4.166666666666654e-03*G6_2_0_9_2_0_0_2 + 4.166666666666655e-03*G6_2_0_9_2_0_1_0 + 4.166666666666655e-03*G6_2_0_9_2_0_2_1 + 4.166666666666655e-03*G6_2_0_9_2_0_3_2 - 8.333333333333307e-03*G6_2_0_9_2_1_0_0 - 8.333333333333309e-03*G6_2_0_9_2_1_0_1 - 8.333333333333307e-03*G6_2_0_9_2_1_0_2 + 8.333333333333307e-03*G6_2_0_9_2_1_1_0 + 8.333333333333309e-03*G6_2_0_9_2_1_2_1 + 8.333333333333309e-03*G6_2_0_9_2_1_3_2 - 4.166666666666654e-03*G6_2_0_9_2_2_0_0 - 4.166666666666655e-03*G6_2_0_9_2_2_0_1 - 4.166666666666654e-03*G6_2_0_9_2_2_0_2 + 4.166666666666654e-03*G6_2_0_9_2_2_1_0 + 4.166666666666655e-03*G6_2_0_9_2_2_2_1 + 4.166666666666655e-03*G6_2_0_9_2_2_3_2 - 4.166666666666656e-03*G6_2_0_9_2_3_0_0 - 4.166666666666656e-03*G6_2_0_9_2_3_0_1 - 4.166666666666656e-03*G6_2_0_9_2_3_0_2 + 4.166666666666656e-03*G6_2_0_9_2_3_1_0 + 4.166666666666656e-03*G6_2_0_9_2_3_2_1 + 4.166666666666656e-03*G6_2_0_9_2_3_3_2 - 4.166666666666654e-03*G6_2_0_10_0_0_0_0 - 4.166666666666654e-03*G6_2_0_10_0_0_0_1 - 4.166666666666654e-03*G6_2_0_10_0_0_0_2 + 4.166666666666654e-03*G6_2_0_10_0_0_1_0 + 4.166666666666654e-03*G6_2_0_10_0_0_2_1 + 4.166666666666654e-03*G6_2_0_10_0_0_3_2 - 4.166666666666654e-03*G6_2_0_10_0_1_0_0 - 4.166666666666654e-03*G6_2_0_10_0_1_0_1 - 4.166666666666653e-03*G6_2_0_10_0_1_0_2 + 4.166666666666654e-03*G6_2_0_10_0_1_1_0 + 4.166666666666654e-03*G6_2_0_10_0_1_2_1 + 4.166666666666654e-03*G6_2_0_10_0_1_3_2 - 8.333333333333309e-03*G6_2_0_10_0_2_0_0 - 8.333333333333309e-03*G6_2_0_10_0_2_0_1 - 8.333333333333309e-03*G6_2_0_10_0_2_0_2 + 8.333333333333309e-03*G6_2_0_10_0_2_1_0 + 8.333333333333309e-03*G6_2_0_10_0_2_2_1 + 8.333333333333309e-03*G6_2_0_10_0_2_3_2 - 4.166666666666654e-03*G6_2_0_10_0_3_0_0 - 4.166666666666655e-03*G6_2_0_10_0_3_0_1 - 4.166666666666654e-03*G6_2_0_10_0_3_0_2 + 4.166666666666654e-03*G6_2_0_10_0_3_1_0 + 4.166666666666655e-03*G6_2_0_10_0_3_2_1 + 4.166666666666655e-03*G6_2_0_10_0_3_3_2 - 4.166666666666654e-03*G6_2_0_10_1_0_0_0 - 4.166666666666656e-03*G6_2_0_10_1_0_0_1 - 4.166666666666655e-03*G6_2_0_10_1_0_0_2 + 4.166666666666654e-03*G6_2_0_10_1_0_1_0 + 4.166666666666656e-03*G6_2_0_10_1_0_2_1 + 4.166666666666656e-03*G6_2_0_10_1_0_3_2 - 4.166666666666654e-03*G6_2_0_10_1_1_0_0 - 4.166666666666654e-03*G6_2_0_10_1_1_0_1 - 4.166666666666654e-03*G6_2_0_10_1_1_0_2 + 4.166666666666654e-03*G6_2_0_10_1_1_1_0 + 4.166666666666654e-03*G6_2_0_10_1_1_2_1 + 4.166666666666654e-03*G6_2_0_10_1_1_3_2 - 8.333333333333311e-03*G6_2_0_10_1_2_0_0 - 8.333333333333311e-03*G6_2_0_10_1_2_0_1 - 8.333333333333311e-03*G6_2_0_10_1_2_0_2 + 8.333333333333311e-03*G6_2_0_10_1_2_1_0 + 8.333333333333311e-03*G6_2_0_10_1_2_2_1 + 8.333333333333311e-03*G6_2_0_10_1_2_3_2 - 4.166666666666655e-03*G6_2_0_10_1_3_0_0 - 4.166666666666656e-03*G6_2_0_10_1_3_0_1 - 4.166666666666655e-03*G6_2_0_10_1_3_0_2 + 4.166666666666655e-03*G6_2_0_10_1_3_1_0 + 4.166666666666656e-03*G6_2_0_10_1_3_2_1 + 4.166666666666656e-03*G6_2_0_10_1_3_3_2 - 4.166666666666654e-03*G6_2_0_10_2_0_0_0 - 4.166666666666655e-03*G6_2_0_10_2_0_0_1 - 4.166666666666654e-03*G6_2_0_10_2_0_0_2 + 4.166666666666654e-03*G6_2_0_10_2_0_1_0 + 4.166666666666655e-03*G6_2_0_10_2_0_2_1 + 4.166666666666655e-03*G6_2_0_10_2_0_3_2 - 4.166666666666654e-03*G6_2_0_10_2_1_0_0 - 4.166666666666654e-03*G6_2_0_10_2_1_0_1 - 4.166666666666653e-03*G6_2_0_10_2_1_0_2 + 4.166666666666654e-03*G6_2_0_10_2_1_1_0 + 4.166666666666654e-03*G6_2_0_10_2_1_2_1 + 4.166666666666654e-03*G6_2_0_10_2_1_3_2 - 8.333333333333309e-03*G6_2_0_10_2_2_0_0 - 8.333333333333309e-03*G6_2_0_10_2_2_0_1 - 8.333333333333309e-03*G6_2_0_10_2_2_0_2 + 8.333333333333309e-03*G6_2_0_10_2_2_1_0 + 8.333333333333309e-03*G6_2_0_10_2_2_2_1 + 8.333333333333309e-03*G6_2_0_10_2_2_3_2 - 4.166666666666654e-03*G6_2_0_10_2_3_0_0 - 4.166666666666655e-03*G6_2_0_10_2_3_0_1 - 4.166666666666654e-03*G6_2_0_10_2_3_0_2 + 4.166666666666654e-03*G6_2_0_10_2_3_1_0 + 4.166666666666655e-03*G6_2_0_10_2_3_2_1 + 4.166666666666655e-03*G6_2_0_10_2_3_3_2 - 4.166666666666656e-03*G6_2_0_11_0_0_0_0 - 4.166666666666656e-03*G6_2_0_11_0_0_0_1 - 4.166666666666656e-03*G6_2_0_11_0_0_0_2 + 4.166666666666656e-03*G6_2_0_11_0_0_1_0 + 4.166666666666656e-03*G6_2_0_11_0_0_2_1 + 4.166666666666656e-03*G6_2_0_11_0_0_3_2 - 4.166666666666654e-03*G6_2_0_11_0_1_0_0 - 4.166666666666655e-03*G6_2_0_11_0_1_0_1 - 4.166666666666654e-03*G6_2_0_11_0_1_0_2 + 4.166666666666654e-03*G6_2_0_11_0_1_1_0 + 4.166666666666655e-03*G6_2_0_11_0_1_2_1 + 4.166666666666655e-03*G6_2_0_11_0_1_3_2 - 4.166666666666655e-03*G6_2_0_11_0_2_0_0 - 4.166666666666655e-03*G6_2_0_11_0_2_0_1 - 4.166666666666654e-03*G6_2_0_11_0_2_0_2 + 4.166666666666655e-03*G6_2_0_11_0_2_1_0 + 4.166666666666655e-03*G6_2_0_11_0_2_2_1 + 4.166666666666655e-03*G6_2_0_11_0_2_3_2 - 8.333333333333309e-03*G6_2_0_11_0_3_0_0 - 8.333333333333311e-03*G6_2_0_11_0_3_0_1 - 8.333333333333309e-03*G6_2_0_11_0_3_0_2 + 8.333333333333309e-03*G6_2_0_11_0_3_1_0 + 8.333333333333311e-03*G6_2_0_11_0_3_2_1 + 8.333333333333311e-03*G6_2_0_11_0_3_3_2 - 4.166666666666656e-03*G6_2_0_11_1_0_0_0 - 4.166666666666657e-03*G6_2_0_11_1_0_0_1 - 4.166666666666657e-03*G6_2_0_11_1_0_0_2 + 4.166666666666656e-03*G6_2_0_11_1_0_1_0 + 4.166666666666657e-03*G6_2_0_11_1_0_2_1 + 4.166666666666657e-03*G6_2_0_11_1_0_3_2 - 4.166666666666655e-03*G6_2_0_11_1_1_0_0 - 4.166666666666655e-03*G6_2_0_11_1_1_0_1 - 4.166666666666655e-03*G6_2_0_11_1_1_0_2 + 4.166666666666655e-03*G6_2_0_11_1_1_1_0 + 4.166666666666655e-03*G6_2_0_11_1_1_2_1 + 4.166666666666655e-03*G6_2_0_11_1_1_3_2 - 4.166666666666655e-03*G6_2_0_11_1_2_0_0 - 4.166666666666656e-03*G6_2_0_11_1_2_0_1 - 4.166666666666655e-03*G6_2_0_11_1_2_0_2 + 4.166666666666655e-03*G6_2_0_11_1_2_1_0 + 4.166666666666656e-03*G6_2_0_11_1_2_2_1 + 4.166666666666656e-03*G6_2_0_11_1_2_3_2 - 8.333333333333311e-03*G6_2_0_11_1_3_0_0 - 8.333333333333311e-03*G6_2_0_11_1_3_0_1 - 8.333333333333311e-03*G6_2_0_11_1_3_0_2 + 8.333333333333311e-03*G6_2_0_11_1_3_1_0 + 8.333333333333311e-03*G6_2_0_11_1_3_2_1 + 8.333333333333311e-03*G6_2_0_11_1_3_3_2 - 4.166666666666656e-03*G6_2_0_11_2_0_0_0 - 4.166666666666657e-03*G6_2_0_11_2_0_0_1 - 4.166666666666657e-03*G6_2_0_11_2_0_0_2 + 4.166666666666656e-03*G6_2_0_11_2_0_1_0 + 4.166666666666657e-03*G6_2_0_11_2_0_2_1 + 4.166666666666657e-03*G6_2_0_11_2_0_3_2 - 4.166666666666655e-03*G6_2_0_11_2_1_0_0 - 4.166666666666655e-03*G6_2_0_11_2_1_0_1 - 4.166666666666655e-03*G6_2_0_11_2_1_0_2 + 4.166666666666655e-03*G6_2_0_11_2_1_1_0 + 4.166666666666655e-03*G6_2_0_11_2_1_2_1 + 4.166666666666655e-03*G6_2_0_11_2_1_3_2 - 4.166666666666655e-03*G6_2_0_11_2_2_0_0 - 4.166666666666655e-03*G6_2_0_11_2_2_0_1 - 4.166666666666654e-03*G6_2_0_11_2_2_0_2 + 4.166666666666655e-03*G6_2_0_11_2_2_1_0 + 4.166666666666655e-03*G6_2_0_11_2_2_2_1 + 4.166666666666655e-03*G6_2_0_11_2_2_3_2 - 8.333333333333309e-03*G6_2_0_11_2_3_0_0 - 8.333333333333311e-03*G6_2_0_11_2_3_0_1 - 8.333333333333309e-03*G6_2_0_11_2_3_0_2 + 8.333333333333309e-03*G6_2_0_11_2_3_1_0 + 8.333333333333311e-03*G6_2_0_11_2_3_2_1 + 8.333333333333311e-03*G6_2_0_11_2_3_3_2 - 8.333333333333309e-03*G6_2_1_8_0_4_0_0 - 8.333333333333309e-03*G6_2_1_8_0_4_0_1 - 8.333333333333309e-03*G6_2_1_8_0_4_0_2 + 8.333333333333309e-03*G6_2_1_8_0_4_1_0 + 8.333333333333309e-03*G6_2_1_8_0_4_2_1 + 8.333333333333309e-03*G6_2_1_8_0_4_3_2 - 4.166666666666654e-03*G6_2_1_8_0_5_0_0 - 4.166666666666654e-03*G6_2_1_8_0_5_0_1 - 4.166666666666654e-03*G6_2_1_8_0_5_0_2 + 4.166666666666654e-03*G6_2_1_8_0_5_1_0 + 4.166666666666654e-03*G6_2_1_8_0_5_2_1 + 4.166666666666654e-03*G6_2_1_8_0_5_3_2 - 4.166666666666653e-03*G6_2_1_8_0_6_0_0 - 4.166666666666654e-03*G6_2_1_8_0_6_0_1 - 4.166666666666654e-03*G6_2_1_8_0_6_0_2 + 4.166666666666653e-03*G6_2_1_8_0_6_1_0 + 4.166666666666654e-03*G6_2_1_8_0_6_2_1 + 4.166666666666654e-03*G6_2_1_8_0_6_3_2 - 4.166666666666654e-03*G6_2_1_8_0_7_0_0 - 4.166666666666656e-03*G6_2_1_8_0_7_0_1 - 4.166666666666654e-03*G6_2_1_8_0_7_0_2 + 4.166666666666654e-03*G6_2_1_8_0_7_1_0 + 4.166666666666656e-03*G6_2_1_8_0_7_2_1 + 4.166666666666656e-03*G6_2_1_8_0_7_3_2 - 8.333333333333309e-03*G6_2_1_8_1_4_0_0 - 8.333333333333311e-03*G6_2_1_8_1_4_0_1 - 8.333333333333311e-03*G6_2_1_8_1_4_0_2 + 8.333333333333309e-03*G6_2_1_8_1_4_1_0 + 8.333333333333311e-03*G6_2_1_8_1_4_2_1 + 8.333333333333311e-03*G6_2_1_8_1_4_3_2 - 4.166666666666654e-03*G6_2_1_8_1_5_0_0 - 4.166666666666654e-03*G6_2_1_8_1_5_0_1 - 4.166666666666654e-03*G6_2_1_8_1_5_0_2 + 4.166666666666654e-03*G6_2_1_8_1_5_1_0 + 4.166666666666654e-03*G6_2_1_8_1_5_2_1 + 4.166666666666654e-03*G6_2_1_8_1_5_3_2 - 4.166666666666654e-03*G6_2_1_8_1_6_0_0 - 4.166666666666654e-03*G6_2_1_8_1_6_0_1 - 4.166666666666654e-03*G6_2_1_8_1_6_0_2 + 4.166666666666654e-03*G6_2_1_8_1_6_1_0 + 4.166666666666654e-03*G6_2_1_8_1_6_2_1 + 4.166666666666654e-03*G6_2_1_8_1_6_3_2 - 4.166666666666656e-03*G6_2_1_8_1_7_0_0 - 4.166666666666657e-03*G6_2_1_8_1_7_0_1 - 4.166666666666657e-03*G6_2_1_8_1_7_0_2 + 4.166666666666656e-03*G6_2_1_8_1_7_1_0 + 4.166666666666657e-03*G6_2_1_8_1_7_2_1 + 4.166666666666657e-03*G6_2_1_8_1_7_3_2 - 8.333333333333309e-03*G6_2_1_8_2_4_0_0 - 8.333333333333311e-03*G6_2_1_8_2_4_0_1 - 8.333333333333311e-03*G6_2_1_8_2_4_0_2 + 8.333333333333309e-03*G6_2_1_8_2_4_1_0 + 8.333333333333311e-03*G6_2_1_8_2_4_2_1 + 8.333333333333311e-03*G6_2_1_8_2_4_3_2 - 4.166666666666654e-03*G6_2_1_8_2_5_0_0 - 4.166666666666654e-03*G6_2_1_8_2_5_0_1 - 4.166666666666654e-03*G6_2_1_8_2_5_0_2 + 4.166666666666654e-03*G6_2_1_8_2_5_1_0 + 4.166666666666654e-03*G6_2_1_8_2_5_2_1 + 4.166666666666654e-03*G6_2_1_8_2_5_3_2 - 4.166666666666654e-03*G6_2_1_8_2_6_0_0 - 4.166666666666654e-03*G6_2_1_8_2_6_0_1 - 4.166666666666654e-03*G6_2_1_8_2_6_0_2 + 4.166666666666654e-03*G6_2_1_8_2_6_1_0 + 4.166666666666654e-03*G6_2_1_8_2_6_2_1 + 4.166666666666654e-03*G6_2_1_8_2_6_3_2 - 4.166666666666654e-03*G6_2_1_8_2_7_0_0 - 4.166666666666657e-03*G6_2_1_8_2_7_0_1 - 4.166666666666656e-03*G6_2_1_8_2_7_0_2 + 4.166666666666654e-03*G6_2_1_8_2_7_1_0 + 4.166666666666657e-03*G6_2_1_8_2_7_2_1 + 4.166666666666657e-03*G6_2_1_8_2_7_3_2 - 4.166666666666654e-03*G6_2_1_9_0_4_0_0 - 4.166666666666654e-03*G6_2_1_9_0_4_0_1 - 4.166666666666654e-03*G6_2_1_9_0_4_0_2 + 4.166666666666654e-03*G6_2_1_9_0_4_1_0 + 4.166666666666654e-03*G6_2_1_9_0_4_2_1 + 4.166666666666654e-03*G6_2_1_9_0_4_3_2 - 8.333333333333307e-03*G6_2_1_9_0_5_0_0 - 8.333333333333309e-03*G6_2_1_9_0_5_0_1 - 8.333333333333307e-03*G6_2_1_9_0_5_0_2 + 8.333333333333307e-03*G6_2_1_9_0_5_1_0 + 8.333333333333309e-03*G6_2_1_9_0_5_2_1 + 8.333333333333309e-03*G6_2_1_9_0_5_3_2 - 4.166666666666654e-03*G6_2_1_9_0_6_0_0 - 4.166666666666655e-03*G6_2_1_9_0_6_0_1 - 4.166666666666654e-03*G6_2_1_9_0_6_0_2 + 4.166666666666654e-03*G6_2_1_9_0_6_1_0 + 4.166666666666655e-03*G6_2_1_9_0_6_2_1 + 4.166666666666655e-03*G6_2_1_9_0_6_3_2 - 4.166666666666655e-03*G6_2_1_9_0_7_0_0 - 4.166666666666656e-03*G6_2_1_9_0_7_0_1 - 4.166666666666656e-03*G6_2_1_9_0_7_0_2 + 4.166666666666655e-03*G6_2_1_9_0_7_1_0 + 4.166666666666656e-03*G6_2_1_9_0_7_2_1 + 4.166666666666656e-03*G6_2_1_9_0_7_3_2 - 4.166666666666654e-03*G6_2_1_9_1_4_0_0 - 4.166666666666654e-03*G6_2_1_9_1_4_0_1 - 4.166666666666654e-03*G6_2_1_9_1_4_0_2 + 4.166666666666654e-03*G6_2_1_9_1_4_1_0 + 4.166666666666654e-03*G6_2_1_9_1_4_2_1 + 4.166666666666654e-03*G6_2_1_9_1_4_3_2 - 8.333333333333309e-03*G6_2_1_9_1_5_0_0 - 8.333333333333309e-03*G6_2_1_9_1_5_0_1 - 8.333333333333307e-03*G6_2_1_9_1_5_0_2 + 8.333333333333309e-03*G6_2_1_9_1_5_1_0 + 8.333333333333309e-03*G6_2_1_9_1_5_2_1 + 8.333333333333309e-03*G6_2_1_9_1_5_3_2 - 4.166666666666655e-03*G6_2_1_9_1_6_0_0 - 4.166666666666656e-03*G6_2_1_9_1_6_0_1 - 4.166666666666654e-03*G6_2_1_9_1_6_0_2 + 4.166666666666655e-03*G6_2_1_9_1_6_1_0 + 4.166666666666656e-03*G6_2_1_9_1_6_2_1 + 4.166666666666656e-03*G6_2_1_9_1_6_3_2 - 4.166666666666656e-03*G6_2_1_9_1_7_0_0 - 4.166666666666657e-03*G6_2_1_9_1_7_0_1 - 4.166666666666656e-03*G6_2_1_9_1_7_0_2 + 4.166666666666656e-03*G6_2_1_9_1_7_1_0 + 4.166666666666657e-03*G6_2_1_9_1_7_2_1 + 4.166666666666657e-03*G6_2_1_9_1_7_3_2 - 4.166666666666654e-03*G6_2_1_9_2_4_0_0 - 4.166666666666654e-03*G6_2_1_9_2_4_0_1 - 4.166666666666654e-03*G6_2_1_9_2_4_0_2 + 4.166666666666654e-03*G6_2_1_9_2_4_1_0 + 4.166666666666654e-03*G6_2_1_9_2_4_2_1 + 4.166666666666654e-03*G6_2_1_9_2_4_3_2 - 8.333333333333307e-03*G6_2_1_9_2_5_0_0 - 8.333333333333309e-03*G6_2_1_9_2_5_0_1 - 8.333333333333307e-03*G6_2_1_9_2_5_0_2 + 8.333333333333307e-03*G6_2_1_9_2_5_1_0 + 8.333333333333309e-03*G6_2_1_9_2_5_2_1 + 8.333333333333309e-03*G6_2_1_9_2_5_3_2 - 4.166666666666654e-03*G6_2_1_9_2_6_0_0 - 4.166666666666655e-03*G6_2_1_9_2_6_0_1 - 4.166666666666654e-03*G6_2_1_9_2_6_0_2 + 4.166666666666654e-03*G6_2_1_9_2_6_1_0 + 4.166666666666655e-03*G6_2_1_9_2_6_2_1 + 4.166666666666655e-03*G6_2_1_9_2_6_3_2 - 4.166666666666656e-03*G6_2_1_9_2_7_0_0 - 4.166666666666656e-03*G6_2_1_9_2_7_0_1 - 4.166666666666656e-03*G6_2_1_9_2_7_0_2 + 4.166666666666656e-03*G6_2_1_9_2_7_1_0 + 4.166666666666656e-03*G6_2_1_9_2_7_2_1 + 4.166666666666656e-03*G6_2_1_9_2_7_3_2 - 4.166666666666653e-03*G6_2_1_10_0_4_0_0 - 4.166666666666654e-03*G6_2_1_10_0_4_0_1 - 4.166666666666653e-03*G6_2_1_10_0_4_0_2 + 4.166666666666653e-03*G6_2_1_10_0_4_1_0 + 4.166666666666654e-03*G6_2_1_10_0_4_2_1 + 4.166666666666654e-03*G6_2_1_10_0_4_3_2 - 4.166666666666654e-03*G6_2_1_10_0_5_0_0 - 4.166666666666655e-03*G6_2_1_10_0_5_0_1 - 4.166666666666654e-03*G6_2_1_10_0_5_0_2 + 4.166666666666654e-03*G6_2_1_10_0_5_1_0 + 4.166666666666655e-03*G6_2_1_10_0_5_2_1 + 4.166666666666655e-03*G6_2_1_10_0_5_3_2 - 8.333333333333309e-03*G6_2_1_10_0_6_0_0 - 8.333333333333309e-03*G6_2_1_10_0_6_0_1 - 8.333333333333309e-03*G6_2_1_10_0_6_0_2 + 8.333333333333309e-03*G6_2_1_10_0_6_1_0 + 8.333333333333309e-03*G6_2_1_10_0_6_2_1 + 8.333333333333309e-03*G6_2_1_10_0_6_3_2 - 4.166666666666654e-03*G6_2_1_10_0_7_0_0 - 4.166666666666655e-03*G6_2_1_10_0_7_0_1 - 4.166666666666654e-03*G6_2_1_10_0_7_0_2 + 4.166666666666654e-03*G6_2_1_10_0_7_1_0 + 4.166666666666655e-03*G6_2_1_10_0_7_2_1 + 4.166666666666655e-03*G6_2_1_10_0_7_3_2 - 4.166666666666654e-03*G6_2_1_10_1_4_0_0 - 4.166666666666654e-03*G6_2_1_10_1_4_0_1 - 4.166666666666654e-03*G6_2_1_10_1_4_0_2 + 4.166666666666654e-03*G6_2_1_10_1_4_1_0 + 4.166666666666654e-03*G6_2_1_10_1_4_2_1 + 4.166666666666654e-03*G6_2_1_10_1_4_3_2 - 4.166666666666655e-03*G6_2_1_10_1_5_0_0 - 4.166666666666656e-03*G6_2_1_10_1_5_0_1 - 4.166666666666654e-03*G6_2_1_10_1_5_0_2 + 4.166666666666655e-03*G6_2_1_10_1_5_1_0 + 4.166666666666656e-03*G6_2_1_10_1_5_2_1 + 4.166666666666656e-03*G6_2_1_10_1_5_3_2 - 8.333333333333311e-03*G6_2_1_10_1_6_0_0 - 8.333333333333311e-03*G6_2_1_10_1_6_0_1 - 8.333333333333311e-03*G6_2_1_10_1_6_0_2 + 8.333333333333311e-03*G6_2_1_10_1_6_1_0 + 8.333333333333311e-03*G6_2_1_10_1_6_2_1 + 8.333333333333311e-03*G6_2_1_10_1_6_3_2 - 4.166666666666655e-03*G6_2_1_10_1_7_0_0 - 4.166666666666656e-03*G6_2_1_10_1_7_0_1 - 4.166666666666655e-03*G6_2_1_10_1_7_0_2 + 4.166666666666655e-03*G6_2_1_10_1_7_1_0 + 4.166666666666656e-03*G6_2_1_10_1_7_2_1 + 4.166666666666656e-03*G6_2_1_10_1_7_3_2 - 4.166666666666653e-03*G6_2_1_10_2_4_0_0 - 4.166666666666654e-03*G6_2_1_10_2_4_0_1 - 4.166666666666654e-03*G6_2_1_10_2_4_0_2 + 4.166666666666653e-03*G6_2_1_10_2_4_1_0 + 4.166666666666654e-03*G6_2_1_10_2_4_2_1 + 4.166666666666654e-03*G6_2_1_10_2_4_3_2 - 4.166666666666654e-03*G6_2_1_10_2_5_0_0 - 4.166666666666654e-03*G6_2_1_10_2_5_0_1 - 4.166666666666654e-03*G6_2_1_10_2_5_0_2 + 4.166666666666654e-03*G6_2_1_10_2_5_1_0 + 4.166666666666654e-03*G6_2_1_10_2_5_2_1 + 4.166666666666654e-03*G6_2_1_10_2_5_3_2 - 8.333333333333309e-03*G6_2_1_10_2_6_0_0 - 8.333333333333309e-03*G6_2_1_10_2_6_0_1 - 8.333333333333309e-03*G6_2_1_10_2_6_0_2 + 8.333333333333309e-03*G6_2_1_10_2_6_1_0 + 8.333333333333309e-03*G6_2_1_10_2_6_2_1 + 8.333333333333309e-03*G6_2_1_10_2_6_3_2 - 4.166666666666654e-03*G6_2_1_10_2_7_0_0 - 4.166666666666655e-03*G6_2_1_10_2_7_0_1 - 4.166666666666654e-03*G6_2_1_10_2_7_0_2 + 4.166666666666654e-03*G6_2_1_10_2_7_1_0 + 4.166666666666655e-03*G6_2_1_10_2_7_2_1 + 4.166666666666655e-03*G6_2_1_10_2_7_3_2 - 4.166666666666655e-03*G6_2_1_11_0_4_0_0 - 4.166666666666656e-03*G6_2_1_11_0_4_0_1 - 4.166666666666655e-03*G6_2_1_11_0_4_0_2 + 4.166666666666655e-03*G6_2_1_11_0_4_1_0 + 4.166666666666656e-03*G6_2_1_11_0_4_2_1 + 4.166666666666656e-03*G6_2_1_11_0_4_3_2 - 4.166666666666655e-03*G6_2_1_11_0_5_0_0 - 4.166666666666656e-03*G6_2_1_11_0_5_0_1 - 4.166666666666656e-03*G6_2_1_11_0_5_0_2 + 4.166666666666655e-03*G6_2_1_11_0_5_1_0 + 4.166666666666656e-03*G6_2_1_11_0_5_2_1 + 4.166666666666656e-03*G6_2_1_11_0_5_3_2 - 4.166666666666655e-03*G6_2_1_11_0_6_0_0 - 4.166666666666655e-03*G6_2_1_11_0_6_0_1 - 4.166666666666654e-03*G6_2_1_11_0_6_0_2 + 4.166666666666655e-03*G6_2_1_11_0_6_1_0 + 4.166666666666655e-03*G6_2_1_11_0_6_2_1 + 4.166666666666655e-03*G6_2_1_11_0_6_3_2 - 8.333333333333309e-03*G6_2_1_11_0_7_0_0 - 8.333333333333311e-03*G6_2_1_11_0_7_0_1 - 8.333333333333309e-03*G6_2_1_11_0_7_0_2 + 8.333333333333309e-03*G6_2_1_11_0_7_1_0 + 8.333333333333311e-03*G6_2_1_11_0_7_2_1 + 8.333333333333311e-03*G6_2_1_11_0_7_3_2 - 4.166666666666656e-03*G6_2_1_11_1_4_0_0 - 4.166666666666657e-03*G6_2_1_11_1_4_0_1 - 4.166666666666657e-03*G6_2_1_11_1_4_0_2 + 4.166666666666656e-03*G6_2_1_11_1_4_1_0 + 4.166666666666657e-03*G6_2_1_11_1_4_2_1 + 4.166666666666657e-03*G6_2_1_11_1_4_3_2 - 4.166666666666656e-03*G6_2_1_11_1_5_0_0 - 4.166666666666657e-03*G6_2_1_11_1_5_0_1 - 4.166666666666656e-03*G6_2_1_11_1_5_0_2 + 4.166666666666656e-03*G6_2_1_11_1_5_1_0 + 4.166666666666657e-03*G6_2_1_11_1_5_2_1 + 4.166666666666657e-03*G6_2_1_11_1_5_3_2 - 4.166666666666655e-03*G6_2_1_11_1_6_0_0 - 4.166666666666656e-03*G6_2_1_11_1_6_0_1 - 4.166666666666655e-03*G6_2_1_11_1_6_0_2 + 4.166666666666655e-03*G6_2_1_11_1_6_1_0 + 4.166666666666656e-03*G6_2_1_11_1_6_2_1 + 4.166666666666656e-03*G6_2_1_11_1_6_3_2 - 8.333333333333311e-03*G6_2_1_11_1_7_0_0 - 8.333333333333311e-03*G6_2_1_11_1_7_0_1 - 8.333333333333311e-03*G6_2_1_11_1_7_0_2 + 8.333333333333311e-03*G6_2_1_11_1_7_1_0 + 8.333333333333311e-03*G6_2_1_11_1_7_2_1 + 8.333333333333311e-03*G6_2_1_11_1_7_3_2 - 4.166666666666655e-03*G6_2_1_11_2_4_0_0 - 4.166666666666657e-03*G6_2_1_11_2_4_0_1 - 4.166666666666656e-03*G6_2_1_11_2_4_0_2 + 4.166666666666655e-03*G6_2_1_11_2_4_1_0 + 4.166666666666657e-03*G6_2_1_11_2_4_2_1 + 4.166666666666657e-03*G6_2_1_11_2_4_3_2 - 4.166666666666656e-03*G6_2_1_11_2_5_0_0 - 4.166666666666656e-03*G6_2_1_11_2_5_0_1 - 4.166666666666656e-03*G6_2_1_11_2_5_0_2 + 4.166666666666656e-03*G6_2_1_11_2_5_1_0 + 4.166666666666656e-03*G6_2_1_11_2_5_2_1 + 4.166666666666656e-03*G6_2_1_11_2_5_3_2 - 4.166666666666655e-03*G6_2_1_11_2_6_0_0 - 4.166666666666655e-03*G6_2_1_11_2_6_0_1 - 4.166666666666654e-03*G6_2_1_11_2_6_0_2 + 4.166666666666655e-03*G6_2_1_11_2_6_1_0 + 4.166666666666655e-03*G6_2_1_11_2_6_2_1 + 4.166666666666655e-03*G6_2_1_11_2_6_3_2 - 8.333333333333309e-03*G6_2_1_11_2_7_0_0 - 8.333333333333311e-03*G6_2_1_11_2_7_0_1 - 8.333333333333309e-03*G6_2_1_11_2_7_0_2 + 8.333333333333309e-03*G6_2_1_11_2_7_1_0 + 8.333333333333311e-03*G6_2_1_11_2_7_2_1 + 8.333333333333311e-03*G6_2_1_11_2_7_3_2 - 8.333333333333309e-03*G6_2_2_8_0_8_0_0 - 8.333333333333309e-03*G6_2_2_8_0_8_0_1 - 8.333333333333309e-03*G6_2_2_8_0_8_0_2 + 8.333333333333309e-03*G6_2_2_8_0_8_1_0 + 8.333333333333309e-03*G6_2_2_8_0_8_2_1 + 8.333333333333309e-03*G6_2_2_8_0_8_3_2 - 4.166666666666654e-03*G6_2_2_8_0_9_0_0 - 4.166666666666654e-03*G6_2_2_8_0_9_0_1 - 4.166666666666654e-03*G6_2_2_8_0_9_0_2 + 4.166666666666654e-03*G6_2_2_8_0_9_1_0 + 4.166666666666654e-03*G6_2_2_8_0_9_2_1 + 4.166666666666654e-03*G6_2_2_8_0_9_3_2 - 4.166666666666653e-03*G6_2_2_8_0_10_0_0 - 4.166666666666654e-03*G6_2_2_8_0_10_0_1 - 4.166666666666654e-03*G6_2_2_8_0_10_0_2 + 4.166666666666653e-03*G6_2_2_8_0_10_1_0 + 4.166666666666654e-03*G6_2_2_8_0_10_2_1 + 4.166666666666654e-03*G6_2_2_8_0_10_3_2 - 4.166666666666654e-03*G6_2_2_8_0_11_0_0 - 4.166666666666656e-03*G6_2_2_8_0_11_0_1 - 4.166666666666654e-03*G6_2_2_8_0_11_0_2 + 4.166666666666654e-03*G6_2_2_8_0_11_1_0 + 4.166666666666656e-03*G6_2_2_8_0_11_2_1 + 4.166666666666656e-03*G6_2_2_8_0_11_3_2 - 8.333333333333309e-03*G6_2_2_8_1_8_0_0 - 8.333333333333311e-03*G6_2_2_8_1_8_0_1 - 8.333333333333311e-03*G6_2_2_8_1_8_0_2 + 8.333333333333309e-03*G6_2_2_8_1_8_1_0 + 8.333333333333311e-03*G6_2_2_8_1_8_2_1 + 8.333333333333311e-03*G6_2_2_8_1_8_3_2 - 4.166666666666654e-03*G6_2_2_8_1_9_0_0 - 4.166666666666654e-03*G6_2_2_8_1_9_0_1 - 4.166666666666654e-03*G6_2_2_8_1_9_0_2 + 4.166666666666654e-03*G6_2_2_8_1_9_1_0 + 4.166666666666654e-03*G6_2_2_8_1_9_2_1 + 4.166666666666654e-03*G6_2_2_8_1_9_3_2 - 4.166666666666654e-03*G6_2_2_8_1_10_0_0 - 4.166666666666654e-03*G6_2_2_8_1_10_0_1 - 4.166666666666654e-03*G6_2_2_8_1_10_0_2 + 4.166666666666654e-03*G6_2_2_8_1_10_1_0 + 4.166666666666654e-03*G6_2_2_8_1_10_2_1 + 4.166666666666654e-03*G6_2_2_8_1_10_3_2 - 4.166666666666656e-03*G6_2_2_8_1_11_0_0 - 4.166666666666657e-03*G6_2_2_8_1_11_0_1 - 4.166666666666657e-03*G6_2_2_8_1_11_0_2 + 4.166666666666656e-03*G6_2_2_8_1_11_1_0 + 4.166666666666657e-03*G6_2_2_8_1_11_2_1 + 4.166666666666657e-03*G6_2_2_8_1_11_3_2 - 8.333333333333309e-03*G6_2_2_8_2_8_0_0 - 8.333333333333311e-03*G6_2_2_8_2_8_0_1 - 8.333333333333311e-03*G6_2_2_8_2_8_0_2 + 8.333333333333309e-03*G6_2_2_8_2_8_1_0 + 8.333333333333311e-03*G6_2_2_8_2_8_2_1 + 8.333333333333311e-03*G6_2_2_8_2_8_3_2 - 4.166666666666654e-03*G6_2_2_8_2_9_0_0 - 4.166666666666654e-03*G6_2_2_8_2_9_0_1 - 4.166666666666654e-03*G6_2_2_8_2_9_0_2 + 4.166666666666654e-03*G6_2_2_8_2_9_1_0 + 4.166666666666654e-03*G6_2_2_8_2_9_2_1 + 4.166666666666654e-03*G6_2_2_8_2_9_3_2 - 4.166666666666654e-03*G6_2_2_8_2_10_0_0 - 4.166666666666654e-03*G6_2_2_8_2_10_0_1 - 4.166666666666654e-03*G6_2_2_8_2_10_0_2 + 4.166666666666654e-03*G6_2_2_8_2_10_1_0 + 4.166666666666654e-03*G6_2_2_8_2_10_2_1 + 4.166666666666654e-03*G6_2_2_8_2_10_3_2 - 4.166666666666654e-03*G6_2_2_8_2_11_0_0 - 4.166666666666657e-03*G6_2_2_8_2_11_0_1 - 4.166666666666656e-03*G6_2_2_8_2_11_0_2 + 4.166666666666654e-03*G6_2_2_8_2_11_1_0 + 4.166666666666657e-03*G6_2_2_8_2_11_2_1 + 4.166666666666657e-03*G6_2_2_8_2_11_3_2 - 4.166666666666654e-03*G6_2_2_9_0_8_0_0 - 4.166666666666654e-03*G6_2_2_9_0_8_0_1 - 4.166666666666654e-03*G6_2_2_9_0_8_0_2 + 4.166666666666654e-03*G6_2_2_9_0_8_1_0 + 4.166666666666654e-03*G6_2_2_9_0_8_2_1 + 4.166666666666654e-03*G6_2_2_9_0_8_3_2 - 8.333333333333307e-03*G6_2_2_9_0_9_0_0 - 8.333333333333309e-03*G6_2_2_9_0_9_0_1 - 8.333333333333307e-03*G6_2_2_9_0_9_0_2 + 8.333333333333307e-03*G6_2_2_9_0_9_1_0 + 8.333333333333309e-03*G6_2_2_9_0_9_2_1 + 8.333333333333309e-03*G6_2_2_9_0_9_3_2 - 4.166666666666654e-03*G6_2_2_9_0_10_0_0 - 4.166666666666655e-03*G6_2_2_9_0_10_0_1 - 4.166666666666654e-03*G6_2_2_9_0_10_0_2 + 4.166666666666654e-03*G6_2_2_9_0_10_1_0 + 4.166666666666655e-03*G6_2_2_9_0_10_2_1 + 4.166666666666655e-03*G6_2_2_9_0_10_3_2 - 4.166666666666655e-03*G6_2_2_9_0_11_0_0 - 4.166666666666656e-03*G6_2_2_9_0_11_0_1 - 4.166666666666656e-03*G6_2_2_9_0_11_0_2 + 4.166666666666655e-03*G6_2_2_9_0_11_1_0 + 4.166666666666656e-03*G6_2_2_9_0_11_2_1 + 4.166666666666656e-03*G6_2_2_9_0_11_3_2 - 4.166666666666654e-03*G6_2_2_9_1_8_0_0 - 4.166666666666654e-03*G6_2_2_9_1_8_0_1 - 4.166666666666654e-03*G6_2_2_9_1_8_0_2 + 4.166666666666654e-03*G6_2_2_9_1_8_1_0 + 4.166666666666654e-03*G6_2_2_9_1_8_2_1 + 4.166666666666654e-03*G6_2_2_9_1_8_3_2 - 8.333333333333309e-03*G6_2_2_9_1_9_0_0 - 8.333333333333309e-03*G6_2_2_9_1_9_0_1 - 8.333333333333307e-03*G6_2_2_9_1_9_0_2 + 8.333333333333309e-03*G6_2_2_9_1_9_1_0 + 8.333333333333309e-03*G6_2_2_9_1_9_2_1 + 8.333333333333309e-03*G6_2_2_9_1_9_3_2 - 4.166666666666655e-03*G6_2_2_9_1_10_0_0 - 4.166666666666656e-03*G6_2_2_9_1_10_0_1 - 4.166666666666654e-03*G6_2_2_9_1_10_0_2 + 4.166666666666655e-03*G6_2_2_9_1_10_1_0 + 4.166666666666656e-03*G6_2_2_9_1_10_2_1 + 4.166666666666656e-03*G6_2_2_9_1_10_3_2 - 4.166666666666656e-03*G6_2_2_9_1_11_0_0 - 4.166666666666657e-03*G6_2_2_9_1_11_0_1 - 4.166666666666656e-03*G6_2_2_9_1_11_0_2 + 4.166666666666656e-03*G6_2_2_9_1_11_1_0 + 4.166666666666657e-03*G6_2_2_9_1_11_2_1 + 4.166666666666657e-03*G6_2_2_9_1_11_3_2 - 4.166666666666654e-03*G6_2_2_9_2_8_0_0 - 4.166666666666654e-03*G6_2_2_9_2_8_0_1 - 4.166666666666654e-03*G6_2_2_9_2_8_0_2 + 4.166666666666654e-03*G6_2_2_9_2_8_1_0 + 4.166666666666654e-03*G6_2_2_9_2_8_2_1 + 4.166666666666654e-03*G6_2_2_9_2_8_3_2 - 8.333333333333307e-03*G6_2_2_9_2_9_0_0 - 8.333333333333309e-03*G6_2_2_9_2_9_0_1 - 8.333333333333307e-03*G6_2_2_9_2_9_0_2 + 8.333333333333307e-03*G6_2_2_9_2_9_1_0 + 8.333333333333309e-03*G6_2_2_9_2_9_2_1 + 8.333333333333309e-03*G6_2_2_9_2_9_3_2 - 4.166666666666654e-03*G6_2_2_9_2_10_0_0 - 4.166666666666655e-03*G6_2_2_9_2_10_0_1 - 4.166666666666654e-03*G6_2_2_9_2_10_0_2 + 4.166666666666654e-03*G6_2_2_9_2_10_1_0 + 4.166666666666655e-03*G6_2_2_9_2_10_2_1 + 4.166666666666655e-03*G6_2_2_9_2_10_3_2 - 4.166666666666656e-03*G6_2_2_9_2_11_0_0 - 4.166666666666656e-03*G6_2_2_9_2_11_0_1 - 4.166666666666656e-03*G6_2_2_9_2_11_0_2 + 4.166666666666656e-03*G6_2_2_9_2_11_1_0 + 4.166666666666656e-03*G6_2_2_9_2_11_2_1 + 4.166666666666656e-03*G6_2_2_9_2_11_3_2 - 4.166666666666653e-03*G6_2_2_10_0_8_0_0 - 4.166666666666654e-03*G6_2_2_10_0_8_0_1 - 4.166666666666653e-03*G6_2_2_10_0_8_0_2 + 4.166666666666653e-03*G6_2_2_10_0_8_1_0 + 4.166666666666654e-03*G6_2_2_10_0_8_2_1 + 4.166666666666654e-03*G6_2_2_10_0_8_3_2 - 4.166666666666654e-03*G6_2_2_10_0_9_0_0 - 4.166666666666655e-03*G6_2_2_10_0_9_0_1 - 4.166666666666654e-03*G6_2_2_10_0_9_0_2 + 4.166666666666654e-03*G6_2_2_10_0_9_1_0 + 4.166666666666655e-03*G6_2_2_10_0_9_2_1 + 4.166666666666655e-03*G6_2_2_10_0_9_3_2 - 8.333333333333309e-03*G6_2_2_10_0_10_0_0 - 8.333333333333309e-03*G6_2_2_10_0_10_0_1 - 8.333333333333309e-03*G6_2_2_10_0_10_0_2 + 8.333333333333309e-03*G6_2_2_10_0_10_1_0 + 8.333333333333309e-03*G6_2_2_10_0_10_2_1 + 8.333333333333309e-03*G6_2_2_10_0_10_3_2 - 4.166666666666654e-03*G6_2_2_10_0_11_0_0 - 4.166666666666655e-03*G6_2_2_10_0_11_0_1 - 4.166666666666654e-03*G6_2_2_10_0_11_0_2 + 4.166666666666654e-03*G6_2_2_10_0_11_1_0 + 4.166666666666655e-03*G6_2_2_10_0_11_2_1 + 4.166666666666655e-03*G6_2_2_10_0_11_3_2 - 4.166666666666654e-03*G6_2_2_10_1_8_0_0 - 4.166666666666654e-03*G6_2_2_10_1_8_0_1 - 4.166666666666654e-03*G6_2_2_10_1_8_0_2 + 4.166666666666654e-03*G6_2_2_10_1_8_1_0 + 4.166666666666654e-03*G6_2_2_10_1_8_2_1 + 4.166666666666654e-03*G6_2_2_10_1_8_3_2 - 4.166666666666655e-03*G6_2_2_10_1_9_0_0 - 4.166666666666656e-03*G6_2_2_10_1_9_0_1 - 4.166666666666654e-03*G6_2_2_10_1_9_0_2 + 4.166666666666655e-03*G6_2_2_10_1_9_1_0 + 4.166666666666656e-03*G6_2_2_10_1_9_2_1 + 4.166666666666656e-03*G6_2_2_10_1_9_3_2 - 8.333333333333311e-03*G6_2_2_10_1_10_0_0 - 8.333333333333311e-03*G6_2_2_10_1_10_0_1 - 8.333333333333311e-03*G6_2_2_10_1_10_0_2 + 8.333333333333311e-03*G6_2_2_10_1_10_1_0 + 8.333333333333311e-03*G6_2_2_10_1_10_2_1 + 8.333333333333311e-03*G6_2_2_10_1_10_3_2 - 4.166666666666655e-03*G6_2_2_10_1_11_0_0 - 4.166666666666656e-03*G6_2_2_10_1_11_0_1 - 4.166666666666655e-03*G6_2_2_10_1_11_0_2 + 4.166666666666655e-03*G6_2_2_10_1_11_1_0 + 4.166666666666656e-03*G6_2_2_10_1_11_2_1 + 4.166666666666656e-03*G6_2_2_10_1_11_3_2 - 4.166666666666653e-03*G6_2_2_10_2_8_0_0 - 4.166666666666654e-03*G6_2_2_10_2_8_0_1 - 4.166666666666654e-03*G6_2_2_10_2_8_0_2 + 4.166666666666653e-03*G6_2_2_10_2_8_1_0 + 4.166666666666654e-03*G6_2_2_10_2_8_2_1 + 4.166666666666654e-03*G6_2_2_10_2_8_3_2 - 4.166666666666654e-03*G6_2_2_10_2_9_0_0 - 4.166666666666654e-03*G6_2_2_10_2_9_0_1 - 4.166666666666654e-03*G6_2_2_10_2_9_0_2 + 4.166666666666654e-03*G6_2_2_10_2_9_1_0 + 4.166666666666654e-03*G6_2_2_10_2_9_2_1 + 4.166666666666654e-03*G6_2_2_10_2_9_3_2 - 8.333333333333309e-03*G6_2_2_10_2_10_0_0 - 8.333333333333309e-03*G6_2_2_10_2_10_0_1 - 8.333333333333309e-03*G6_2_2_10_2_10_0_2 + 8.333333333333309e-03*G6_2_2_10_2_10_1_0 + 8.333333333333309e-03*G6_2_2_10_2_10_2_1 + 8.333333333333309e-03*G6_2_2_10_2_10_3_2 - 4.166666666666654e-03*G6_2_2_10_2_11_0_0 - 4.166666666666655e-03*G6_2_2_10_2_11_0_1 - 4.166666666666654e-03*G6_2_2_10_2_11_0_2 + 4.166666666666654e-03*G6_2_2_10_2_11_1_0 + 4.166666666666655e-03*G6_2_2_10_2_11_2_1 + 4.166666666666655e-03*G6_2_2_10_2_11_3_2 - 4.166666666666655e-03*G6_2_2_11_0_8_0_0 - 4.166666666666656e-03*G6_2_2_11_0_8_0_1 - 4.166666666666655e-03*G6_2_2_11_0_8_0_2 + 4.166666666666655e-03*G6_2_2_11_0_8_1_0 + 4.166666666666656e-03*G6_2_2_11_0_8_2_1 + 4.166666666666656e-03*G6_2_2_11_0_8_3_2 - 4.166666666666655e-03*G6_2_2_11_0_9_0_0 - 4.166666666666656e-03*G6_2_2_11_0_9_0_1 - 4.166666666666656e-03*G6_2_2_11_0_9_0_2 + 4.166666666666655e-03*G6_2_2_11_0_9_1_0 + 4.166666666666656e-03*G6_2_2_11_0_9_2_1 + 4.166666666666656e-03*G6_2_2_11_0_9_3_2 - 4.166666666666655e-03*G6_2_2_11_0_10_0_0 - 4.166666666666655e-03*G6_2_2_11_0_10_0_1 - 4.166666666666654e-03*G6_2_2_11_0_10_0_2 + 4.166666666666655e-03*G6_2_2_11_0_10_1_0 + 4.166666666666655e-03*G6_2_2_11_0_10_2_1 + 4.166666666666655e-03*G6_2_2_11_0_10_3_2 - 8.333333333333309e-03*G6_2_2_11_0_11_0_0 - 8.333333333333311e-03*G6_2_2_11_0_11_0_1 - 8.333333333333309e-03*G6_2_2_11_0_11_0_2 + 8.333333333333309e-03*G6_2_2_11_0_11_1_0 + 8.333333333333311e-03*G6_2_2_11_0_11_2_1 + 8.333333333333311e-03*G6_2_2_11_0_11_3_2 - 4.166666666666656e-03*G6_2_2_11_1_8_0_0 - 4.166666666666657e-03*G6_2_2_11_1_8_0_1 - 4.166666666666657e-03*G6_2_2_11_1_8_0_2 + 4.166666666666656e-03*G6_2_2_11_1_8_1_0 + 4.166666666666657e-03*G6_2_2_11_1_8_2_1 + 4.166666666666657e-03*G6_2_2_11_1_8_3_2 - 4.166666666666656e-03*G6_2_2_11_1_9_0_0 - 4.166666666666657e-03*G6_2_2_11_1_9_0_1 - 4.166666666666656e-03*G6_2_2_11_1_9_0_2 + 4.166666666666656e-03*G6_2_2_11_1_9_1_0 + 4.166666666666657e-03*G6_2_2_11_1_9_2_1 + 4.166666666666657e-03*G6_2_2_11_1_9_3_2 - 4.166666666666655e-03*G6_2_2_11_1_10_0_0 - 4.166666666666656e-03*G6_2_2_11_1_10_0_1 - 4.166666666666655e-03*G6_2_2_11_1_10_0_2 + 4.166666666666655e-03*G6_2_2_11_1_10_1_0 + 4.166666666666656e-03*G6_2_2_11_1_10_2_1 + 4.166666666666656e-03*G6_2_2_11_1_10_3_2 - 8.333333333333311e-03*G6_2_2_11_1_11_0_0 - 8.333333333333311e-03*G6_2_2_11_1_11_0_1 - 8.333333333333311e-03*G6_2_2_11_1_11_0_2 + 8.333333333333311e-03*G6_2_2_11_1_11_1_0 + 8.333333333333311e-03*G6_2_2_11_1_11_2_1 + 8.333333333333311e-03*G6_2_2_11_1_11_3_2 - 4.166666666666655e-03*G6_2_2_11_2_8_0_0 - 4.166666666666657e-03*G6_2_2_11_2_8_0_1 - 4.166666666666656e-03*G6_2_2_11_2_8_0_2 + 4.166666666666655e-03*G6_2_2_11_2_8_1_0 + 4.166666666666657e-03*G6_2_2_11_2_8_2_1 + 4.166666666666657e-03*G6_2_2_11_2_8_3_2 - 4.166666666666656e-03*G6_2_2_11_2_9_0_0 - 4.166666666666656e-03*G6_2_2_11_2_9_0_1 - 4.166666666666656e-03*G6_2_2_11_2_9_0_2 + 4.166666666666656e-03*G6_2_2_11_2_9_1_0 + 4.166666666666656e-03*G6_2_2_11_2_9_2_1 + 4.166666666666656e-03*G6_2_2_11_2_9_3_2 - 4.166666666666655e-03*G6_2_2_11_2_10_0_0 - 4.166666666666655e-03*G6_2_2_11_2_10_0_1 - 4.166666666666654e-03*G6_2_2_11_2_10_0_2 + 4.166666666666655e-03*G6_2_2_11_2_10_1_0 + 4.166666666666655e-03*G6_2_2_11_2_10_2_1 + 4.166666666666655e-03*G6_2_2_11_2_10_3_2 - 8.333333333333309e-03*G6_2_2_11_2_11_0_0 - 8.333333333333311e-03*G6_2_2_11_2_11_0_1 - 8.333333333333309e-03*G6_2_2_11_2_11_0_2 + 8.333333333333309e-03*G6_2_2_11_2_11_1_0 + 8.333333333333311e-03*G6_2_2_11_2_11_2_1 + 8.333333333333311e-03*G6_2_2_11_2_11_3_2 - 4.166666666666661e-02*G7_0_0_0_0_0_0 - 4.166666666666662e-02*G7_0_0_0_0_0_1 - 4.166666666666662e-02*G7_0_0_0_0_0_2 + 4.166666666666661e-02*G7_0_0_0_0_1_0 + 4.166666666666662e-02*G7_0_0_0_0_2_1 + 4.166666666666662e-02*G7_0_0_0_0_3_2 - 4.166666666666662e-02*G7_0_0_0_1_0_0 - 4.166666666666662e-02*G7_0_0_0_1_0_1 - 4.166666666666662e-02*G7_0_0_0_1_0_2 + 4.166666666666662e-02*G7_0_0_0_1_1_0 + 4.166666666666662e-02*G7_0_0_0_1_2_1 + 4.166666666666662e-02*G7_0_0_0_1_3_2 - 4.166666666666661e-02*G7_0_0_0_2_0_0 - 4.166666666666662e-02*G7_0_0_0_2_0_1 - 4.166666666666662e-02*G7_0_0_0_2_0_2 + 4.166666666666661e-02*G7_0_0_0_2_1_0 + 4.166666666666662e-02*G7_0_0_0_2_2_1 + 4.166666666666662e-02*G7_0_0_0_2_3_2 - 4.166666666666659e-02*G7_0_0_1_0_0_0 - 4.166666666666660e-02*G7_0_0_1_0_0_1 - 4.166666666666660e-02*G7_0_0_1_0_0_2 + 4.166666666666659e-02*G7_0_0_1_0_1_0 + 4.166666666666660e-02*G7_0_0_1_0_2_1 + 4.166666666666660e-02*G7_0_0_1_0_3_2 - 4.166666666666660e-02*G7_0_0_1_1_0_0 - 4.166666666666661e-02*G7_0_0_1_1_0_1 - 4.166666666666661e-02*G7_0_0_1_1_0_2 + 4.166666666666660e-02*G7_0_0_1_1_1_0 + 4.166666666666661e-02*G7_0_0_1_1_2_1 + 4.166666666666661e-02*G7_0_0_1_1_3_2 - 4.166666666666659e-02*G7_0_0_1_2_0_0 - 4.166666666666660e-02*G7_0_0_1_2_0_1 - 4.166666666666660e-02*G7_0_0_1_2_0_2 + 4.166666666666659e-02*G7_0_0_1_2_1_0 + 4.166666666666660e-02*G7_0_0_1_2_2_1 + 4.166666666666660e-02*G7_0_0_1_2_3_2 - 4.166666666666660e-02*G7_0_0_2_0_0_0 - 4.166666666666661e-02*G7_0_0_2_0_0_1 - 4.166666666666661e-02*G7_0_0_2_0_0_2 + 4.166666666666660e-02*G7_0_0_2_0_1_0 + 4.166666666666661e-02*G7_0_0_2_0_2_1 + 4.166666666666661e-02*G7_0_0_2_0_3_2 - 4.166666666666661e-02*G7_0_0_2_1_0_0 - 4.166666666666662e-02*G7_0_0_2_1_0_1 - 4.166666666666662e-02*G7_0_0_2_1_0_2 + 4.166666666666661e-02*G7_0_0_2_1_1_0 + 4.166666666666662e-02*G7_0_0_2_1_2_1 + 4.166666666666662e-02*G7_0_0_2_1_3_2 - 4.166666666666660e-02*G7_0_0_2_2_0_0 - 4.166666666666661e-02*G7_0_0_2_2_0_1 - 4.166666666666661e-02*G7_0_0_2_2_0_2 + 4.166666666666660e-02*G7_0_0_2_2_1_0 + 4.166666666666661e-02*G7_0_0_2_2_2_1 + 4.166666666666661e-02*G7_0_0_2_2_3_2 - 4.166666666666660e-02*G7_0_0_3_0_0_0 - 4.166666666666661e-02*G7_0_0_3_0_0_1 - 4.166666666666661e-02*G7_0_0_3_0_0_2 + 4.166666666666660e-02*G7_0_0_3_0_1_0 + 4.166666666666661e-02*G7_0_0_3_0_2_1 + 4.166666666666661e-02*G7_0_0_3_0_3_2 - 4.166666666666661e-02*G7_0_0_3_1_0_0 - 4.166666666666662e-02*G7_0_0_3_1_0_1 - 4.166666666666662e-02*G7_0_0_3_1_0_2 + 4.166666666666661e-02*G7_0_0_3_1_1_0 + 4.166666666666662e-02*G7_0_0_3_1_2_1 + 4.166666666666662e-02*G7_0_0_3_1_3_2 - 4.166666666666660e-02*G7_0_0_3_2_0_0 - 4.166666666666661e-02*G7_0_0_3_2_0_1 - 4.166666666666661e-02*G7_0_0_3_2_0_2 + 4.166666666666660e-02*G7_0_0_3_2_1_0 + 4.166666666666661e-02*G7_0_0_3_2_2_1 + 4.166666666666661e-02*G7_0_0_3_2_3_2 - 4.166666666666660e-02*G7_0_1_4_0_0_0 - 4.166666666666661e-02*G7_0_1_4_0_0_1 - 4.166666666666661e-02*G7_0_1_4_0_0_2 + 4.166666666666660e-02*G7_0_1_4_0_1_0 + 4.166666666666661e-02*G7_0_1_4_0_2_1 + 4.166666666666661e-02*G7_0_1_4_0_3_2 - 4.166666666666661e-02*G7_0_1_4_1_0_0 - 4.166666666666662e-02*G7_0_1_4_1_0_1 - 4.166666666666662e-02*G7_0_1_4_1_0_2 + 4.166666666666661e-02*G7_0_1_4_1_1_0 + 4.166666666666662e-02*G7_0_1_4_1_2_1 + 4.166666666666662e-02*G7_0_1_4_1_3_2 - 4.166666666666660e-02*G7_0_1_4_2_0_0 - 4.166666666666661e-02*G7_0_1_4_2_0_1 - 4.166666666666661e-02*G7_0_1_4_2_0_2 + 4.166666666666660e-02*G7_0_1_4_2_1_0 + 4.166666666666661e-02*G7_0_1_4_2_2_1 + 4.166666666666661e-02*G7_0_1_4_2_3_2 - 4.166666666666660e-02*G7_0_1_5_0_0_0 - 4.166666666666661e-02*G7_0_1_5_0_0_1 - 4.166666666666661e-02*G7_0_1_5_0_0_2 + 4.166666666666660e-02*G7_0_1_5_0_1_0 + 4.166666666666661e-02*G7_0_1_5_0_2_1 + 4.166666666666661e-02*G7_0_1_5_0_3_2 - 4.166666666666661e-02*G7_0_1_5_1_0_0 - 4.166666666666662e-02*G7_0_1_5_1_0_1 - 4.166666666666662e-02*G7_0_1_5_1_0_2 + 4.166666666666661e-02*G7_0_1_5_1_1_0 + 4.166666666666662e-02*G7_0_1_5_1_2_1 + 4.166666666666662e-02*G7_0_1_5_1_3_2 - 4.166666666666660e-02*G7_0_1_5_2_0_0 - 4.166666666666661e-02*G7_0_1_5_2_0_1 - 4.166666666666661e-02*G7_0_1_5_2_0_2 + 4.166666666666660e-02*G7_0_1_5_2_1_0 + 4.166666666666661e-02*G7_0_1_5_2_2_1 + 4.166666666666661e-02*G7_0_1_5_2_3_2 - 4.166666666666660e-02*G7_0_1_6_0_0_0 - 4.166666666666661e-02*G7_0_1_6_0_0_1 - 4.166666666666661e-02*G7_0_1_6_0_0_2 + 4.166666666666660e-02*G7_0_1_6_0_1_0 + 4.166666666666661e-02*G7_0_1_6_0_2_1 + 4.166666666666661e-02*G7_0_1_6_0_3_2 - 4.166666666666661e-02*G7_0_1_6_1_0_0 - 4.166666666666662e-02*G7_0_1_6_1_0_1 - 4.166666666666662e-02*G7_0_1_6_1_0_2 + 4.166666666666661e-02*G7_0_1_6_1_1_0 + 4.166666666666662e-02*G7_0_1_6_1_2_1 + 4.166666666666662e-02*G7_0_1_6_1_3_2 - 4.166666666666660e-02*G7_0_1_6_2_0_0 - 4.166666666666661e-02*G7_0_1_6_2_0_1 - 4.166666666666661e-02*G7_0_1_6_2_0_2 + 4.166666666666660e-02*G7_0_1_6_2_1_0 + 4.166666666666661e-02*G7_0_1_6_2_2_1 + 4.166666666666661e-02*G7_0_1_6_2_3_2 - 4.166666666666660e-02*G7_0_1_7_0_0_0 - 4.166666666666661e-02*G7_0_1_7_0_0_1 - 4.166666666666661e-02*G7_0_1_7_0_0_2 + 4.166666666666660e-02*G7_0_1_7_0_1_0 + 4.166666666666661e-02*G7_0_1_7_0_2_1 + 4.166666666666661e-02*G7_0_1_7_0_3_2 - 4.166666666666661e-02*G7_0_1_7_1_0_0 - 4.166666666666662e-02*G7_0_1_7_1_0_1 - 4.166666666666662e-02*G7_0_1_7_1_0_2 + 4.166666666666661e-02*G7_0_1_7_1_1_0 + 4.166666666666662e-02*G7_0_1_7_1_2_1 + 4.166666666666662e-02*G7_0_1_7_1_3_2 - 4.166666666666660e-02*G7_0_1_7_2_0_0 - 4.166666666666661e-02*G7_0_1_7_2_0_1 - 4.166666666666661e-02*G7_0_1_7_2_0_2 + 4.166666666666660e-02*G7_0_1_7_2_1_0 + 4.166666666666661e-02*G7_0_1_7_2_2_1 + 4.166666666666661e-02*G7_0_1_7_2_3_2 - 4.166666666666660e-02*G7_0_2_8_0_0_0 - 4.166666666666661e-02*G7_0_2_8_0_0_1 - 4.166666666666661e-02*G7_0_2_8_0_0_2 + 4.166666666666660e-02*G7_0_2_8_0_1_0 + 4.166666666666661e-02*G7_0_2_8_0_2_1 + 4.166666666666661e-02*G7_0_2_8_0_3_2 - 4.166666666666661e-02*G7_0_2_8_1_0_0 - 4.166666666666662e-02*G7_0_2_8_1_0_1 - 4.166666666666662e-02*G7_0_2_8_1_0_2 + 4.166666666666661e-02*G7_0_2_8_1_1_0 + 4.166666666666662e-02*G7_0_2_8_1_2_1 + 4.166666666666662e-02*G7_0_2_8_1_3_2 - 4.166666666666660e-02*G7_0_2_8_2_0_0 - 4.166666666666661e-02*G7_0_2_8_2_0_1 - 4.166666666666661e-02*G7_0_2_8_2_0_2 + 4.166666666666660e-02*G7_0_2_8_2_1_0 + 4.166666666666661e-02*G7_0_2_8_2_2_1 + 4.166666666666661e-02*G7_0_2_8_2_3_2 - 4.166666666666660e-02*G7_0_2_9_0_0_0 - 4.166666666666661e-02*G7_0_2_9_0_0_1 - 4.166666666666661e-02*G7_0_2_9_0_0_2 + 4.166666666666660e-02*G7_0_2_9_0_1_0 + 4.166666666666661e-02*G7_0_2_9_0_2_1 + 4.166666666666661e-02*G7_0_2_9_0_3_2 - 4.166666666666661e-02*G7_0_2_9_1_0_0 - 4.166666666666662e-02*G7_0_2_9_1_0_1 - 4.166666666666662e-02*G7_0_2_9_1_0_2 + 4.166666666666661e-02*G7_0_2_9_1_1_0 + 4.166666666666662e-02*G7_0_2_9_1_2_1 + 4.166666666666662e-02*G7_0_2_9_1_3_2 - 4.166666666666660e-02*G7_0_2_9_2_0_0 - 4.166666666666661e-02*G7_0_2_9_2_0_1 - 4.166666666666661e-02*G7_0_2_9_2_0_2 + 4.166666666666660e-02*G7_0_2_9_2_1_0 + 4.166666666666661e-02*G7_0_2_9_2_2_1 + 4.166666666666661e-02*G7_0_2_9_2_3_2 - 4.166666666666660e-02*G7_0_2_10_0_0_0 - 4.166666666666661e-02*G7_0_2_10_0_0_1 - 4.166666666666661e-02*G7_0_2_10_0_0_2 + 4.166666666666660e-02*G7_0_2_10_0_1_0 + 4.166666666666661e-02*G7_0_2_10_0_2_1 + 4.166666666666661e-02*G7_0_2_10_0_3_2 - 4.166666666666661e-02*G7_0_2_10_1_0_0 - 4.166666666666662e-02*G7_0_2_10_1_0_1 - 4.166666666666662e-02*G7_0_2_10_1_0_2 + 4.166666666666661e-02*G7_0_2_10_1_1_0 + 4.166666666666662e-02*G7_0_2_10_1_2_1 + 4.166666666666662e-02*G7_0_2_10_1_3_2 - 4.166666666666660e-02*G7_0_2_10_2_0_0 - 4.166666666666661e-02*G7_0_2_10_2_0_1 - 4.166666666666661e-02*G7_0_2_10_2_0_2 + 4.166666666666660e-02*G7_0_2_10_2_1_0 + 4.166666666666661e-02*G7_0_2_10_2_2_1 + 4.166666666666661e-02*G7_0_2_10_2_3_2 - 4.166666666666660e-02*G7_0_2_11_0_0_0 - 4.166666666666661e-02*G7_0_2_11_0_0_1 - 4.166666666666661e-02*G7_0_2_11_0_0_2 + 4.166666666666660e-02*G7_0_2_11_0_1_0 + 4.166666666666661e-02*G7_0_2_11_0_2_1 + 4.166666666666661e-02*G7_0_2_11_0_3_2 - 4.166666666666661e-02*G7_0_2_11_1_0_0 - 4.166666666666662e-02*G7_0_2_11_1_0_1 - 4.166666666666662e-02*G7_0_2_11_1_0_2 + 4.166666666666661e-02*G7_0_2_11_1_1_0 + 4.166666666666662e-02*G7_0_2_11_1_2_1 + 4.166666666666662e-02*G7_0_2_11_1_3_2 - 4.166666666666660e-02*G7_0_2_11_2_0_0 - 4.166666666666661e-02*G7_0_2_11_2_0_1 - 4.166666666666661e-02*G7_0_2_11_2_0_2 + 4.166666666666660e-02*G7_0_2_11_2_1_0 + 4.166666666666661e-02*G7_0_2_11_2_2_1 + 4.166666666666661e-02*G7_0_2_11_2_3_2 - 8.333333333333320e-02*G8_0_0_0_0_0 - 8.333333333333322e-02*G8_0_0_0_0_1 - 8.333333333333320e-02*G8_0_0_0_0_2 + 8.333333333333320e-02*G8_0_0_0_1_0 + 8.333333333333322e-02*G8_0_0_0_2_1 + 8.333333333333322e-02*G8_0_0_0_3_2 - 8.333333333333322e-02*G8_0_0_1_0_0 - 8.333333333333323e-02*G8_0_0_1_0_1 - 8.333333333333322e-02*G8_0_0_1_0_2 + 8.333333333333322e-02*G8_0_0_1_1_0 + 8.333333333333323e-02*G8_0_0_1_2_1 + 8.333333333333323e-02*G8_0_0_1_3_2 - 8.333333333333320e-02*G8_0_0_2_0_0 - 8.333333333333322e-02*G8_0_0_2_0_1 - 8.333333333333320e-02*G8_0_0_2_0_2 + 8.333333333333320e-02*G8_0_0_2_1_0 + 8.333333333333322e-02*G8_0_0_2_2_1 + 8.333333333333322e-02*G8_0_0_2_3_2 - 8.333333333333320e-02*G8_0_1_0_4_0 - 8.333333333333322e-02*G8_0_1_0_4_1 - 8.333333333333322e-02*G8_0_1_0_4_2 + 8.333333333333320e-02*G8_0_1_0_5_0 + 8.333333333333322e-02*G8_0_1_0_6_1 + 8.333333333333322e-02*G8_0_1_0_7_2 - 8.333333333333322e-02*G8_0_1_1_4_0 - 8.333333333333323e-02*G8_0_1_1_4_1 - 8.333333333333323e-02*G8_0_1_1_4_2 + 8.333333333333322e-02*G8_0_1_1_5_0 + 8.333333333333323e-02*G8_0_1_1_6_1 + 8.333333333333323e-02*G8_0_1_1_7_2 - 8.333333333333320e-02*G8_0_1_2_4_0 - 8.333333333333322e-02*G8_0_1_2_4_1 - 8.333333333333322e-02*G8_0_1_2_4_2 + 8.333333333333320e-02*G8_0_1_2_5_0 + 8.333333333333322e-02*G8_0_1_2_6_1 + 8.333333333333322e-02*G8_0_1_2_7_2 - 8.333333333333320e-02*G8_0_2_0_8_0 - 8.333333333333322e-02*G8_0_2_0_8_1 - 8.333333333333322e-02*G8_0_2_0_8_2 + 8.333333333333320e-02*G8_0_2_0_9_0 + 8.333333333333322e-02*G8_0_2_0_10_1 + 8.333333333333322e-02*G8_0_2_0_11_2 - 8.333333333333322e-02*G8_0_2_1_8_0 - 8.333333333333323e-02*G8_0_2_1_8_1 - 8.333333333333323e-02*G8_0_2_1_8_2 + 8.333333333333322e-02*G8_0_2_1_9_0 + 8.333333333333323e-02*G8_0_2_1_10_1 + 8.333333333333323e-02*G8_0_2_1_11_2 - 8.333333333333320e-02*G8_0_2_2_8_0 - 8.333333333333322e-02*G8_0_2_2_8_1 - 8.333333333333322e-02*G8_0_2_2_8_2 + 8.333333333333320e-02*G8_0_2_2_9_0 + 8.333333333333322e-02*G8_0_2_2_10_1 + 8.333333333333322e-02*G8_0_2_2_11_2;
    block[1] = 8.333333333333311e-03*G0_0 + 1.666666666666662e-02*G0_1 + 8.333333333333309e-03*G0_2 + 8.333333333333311e-03*G0_3 + 8.333333333333311e-03*G1_0 + 1.666666666666662e-02*G1_1 + 8.333333333333309e-03*G1_2 + 8.333333333333311e-03*G1_3 + 4.166666666666661e-02*G2_0_0_0 + 4.166666666666661e-02*G2_0_0_1 + 4.166666666666661e-02*G2_0_0_2 + 4.166666666666661e-02*G2_0_0_3 + 1.666666666666662e-02*G3_0_0_0_0 + 8.333333333333309e-03*G3_0_0_0_1 + 8.333333333333309e-03*G3_0_0_0_2 + 8.333333333333312e-03*G3_0_0_0_3 + 8.333333333333309e-03*G3_0_1_0_0 + 1.666666666666661e-02*G3_0_1_0_1 + 8.333333333333309e-03*G3_0_1_0_2 + 8.333333333333311e-03*G3_0_1_0_3 + 8.333333333333309e-03*G3_0_2_0_0 + 8.333333333333309e-03*G3_0_2_0_1 + 1.666666666666662e-02*G3_0_2_0_2 + 8.333333333333311e-03*G3_0_2_0_3 + 8.333333333333312e-03*G3_0_3_0_0 + 8.333333333333311e-03*G3_0_3_0_1 + 8.333333333333311e-03*G3_0_3_0_2 + 1.666666666666662e-02*G3_0_3_0_3 + 1.666666666666662e-02*G3_1_4_0_0 + 8.333333333333307e-03*G3_1_4_0_1 + 8.333333333333307e-03*G3_1_4_0_2 + 8.333333333333312e-03*G3_1_4_0_3 + 8.333333333333311e-03*G3_1_5_0_0 + 1.666666666666662e-02*G3_1_5_0_1 + 8.333333333333311e-03*G3_1_5_0_2 + 8.333333333333312e-03*G3_1_5_0_3 + 8.333333333333309e-03*G3_1_6_0_0 + 8.333333333333309e-03*G3_1_6_0_1 + 1.666666666666662e-02*G3_1_6_0_2 + 8.333333333333311e-03*G3_1_6_0_3 + 8.333333333333312e-03*G3_1_7_0_0 + 8.333333333333311e-03*G3_1_7_0_1 + 8.333333333333311e-03*G3_1_7_0_2 + 1.666666666666662e-02*G3_1_7_0_3 + 1.666666666666662e-02*G3_2_8_0_0 + 8.333333333333307e-03*G3_2_8_0_1 + 8.333333333333307e-03*G3_2_8_0_2 + 8.333333333333312e-03*G3_2_8_0_3 + 8.333333333333311e-03*G3_2_9_0_0 + 1.666666666666662e-02*G3_2_9_0_1 + 8.333333333333311e-03*G3_2_9_0_2 + 8.333333333333312e-03*G3_2_9_0_3 + 8.333333333333309e-03*G3_2_10_0_0 + 8.333333333333309e-03*G3_2_10_0_1 + 1.666666666666662e-02*G3_2_10_0_2 + 8.333333333333311e-03*G3_2_10_0_3 + 8.333333333333312e-03*G3_2_11_0_0 + 8.333333333333311e-03*G3_2_11_0_1 + 8.333333333333311e-03*G3_2_11_0_2 + 1.666666666666662e-02*G3_2_11_0_3 + 8.333333333333320e-02*G4_0_0_0 + 8.333333333333322e-02*G4_0_0_1 + 8.333333333333320e-02*G4_0_0_2 - 8.333333333333320e-02*G4_0_1_0 - 8.333333333333322e-02*G4_0_2_1 - 8.333333333333322e-02*G4_0_3_2 + 4.166666666666654e-03*G5_0_0_0_0 + 4.166666666666655e-03*G5_0_0_0_1 + 4.166666666666654e-03*G5_0_0_0_2 - 4.166666666666654e-03*G5_0_0_1_0 - 4.166666666666655e-03*G5_0_0_2_1 - 4.166666666666655e-03*G5_0_0_3_2 + 8.333333333333307e-03*G5_0_1_0_0 + 8.333333333333309e-03*G5_0_1_0_1 + 8.333333333333307e-03*G5_0_1_0_2 - 8.333333333333307e-03*G5_0_1_1_0 - 8.333333333333309e-03*G5_0_1_2_1 - 8.333333333333309e-03*G5_0_1_3_2 + 4.166666666666654e-03*G5_0_2_0_0 + 4.166666666666654e-03*G5_0_2_0_1 + 4.166666666666654e-03*G5_0_2_0_2 - 4.166666666666654e-03*G5_0_2_1_0 - 4.166666666666654e-03*G5_0_2_2_1 - 4.166666666666654e-03*G5_0_2_3_2 + 4.166666666666655e-03*G5_0_3_0_0 + 4.166666666666655e-03*G5_0_3_0_1 + 4.166666666666655e-03*G5_0_3_0_2 - 4.166666666666655e-03*G5_0_3_1_0 - 4.166666666666655e-03*G5_0_3_2_1 - 4.166666666666655e-03*G5_0_3_3_2 + 4.166666666666654e-03*G5_1_4_0_0 + 4.166666666666654e-03*G5_1_4_0_1 + 4.166666666666654e-03*G5_1_4_0_2 - 4.166666666666654e-03*G5_1_4_1_0 - 4.166666666666654e-03*G5_1_4_2_1 - 4.166666666666654e-03*G5_1_4_3_2 + 8.333333333333309e-03*G5_1_5_0_0 + 8.333333333333309e-03*G5_1_5_0_1 + 8.333333333333307e-03*G5_1_5_0_2 - 8.333333333333309e-03*G5_1_5_1_0 - 8.333333333333309e-03*G5_1_5_2_1 - 8.333333333333309e-03*G5_1_5_3_2 + 4.166666666666654e-03*G5_1_6_0_0 + 4.166666666666654e-03*G5_1_6_0_1 + 4.166666666666654e-03*G5_1_6_0_2 - 4.166666666666654e-03*G5_1_6_1_0 - 4.166666666666654e-03*G5_1_6_2_1 - 4.166666666666654e-03*G5_1_6_3_2 + 4.166666666666655e-03*G5_1_7_0_0 + 4.166666666666655e-03*G5_1_7_0_1 + 4.166666666666655e-03*G5_1_7_0_2 - 4.166666666666655e-03*G5_1_7_1_0 - 4.166666666666655e-03*G5_1_7_2_1 - 4.166666666666655e-03*G5_1_7_3_2 + 4.166666666666654e-03*G5_2_8_0_0 + 4.166666666666654e-03*G5_2_8_0_1 + 4.166666666666654e-03*G5_2_8_0_2 - 4.166666666666654e-03*G5_2_8_1_0 - 4.166666666666654e-03*G5_2_8_2_1 - 4.166666666666654e-03*G5_2_8_3_2 + 8.333333333333309e-03*G5_2_9_0_0 + 8.333333333333309e-03*G5_2_9_0_1 + 8.333333333333307e-03*G5_2_9_0_2 - 8.333333333333309e-03*G5_2_9_1_0 - 8.333333333333309e-03*G5_2_9_2_1 - 8.333333333333309e-03*G5_2_9_3_2 + 4.166666666666654e-03*G5_2_10_0_0 + 4.166666666666654e-03*G5_2_10_0_1 + 4.166666666666654e-03*G5_2_10_0_2 - 4.166666666666654e-03*G5_2_10_1_0 - 4.166666666666654e-03*G5_2_10_2_1 - 4.166666666666654e-03*G5_2_10_3_2 + 4.166666666666655e-03*G5_2_11_0_0 + 4.166666666666655e-03*G5_2_11_0_1 + 4.166666666666655e-03*G5_2_11_0_2 - 4.166666666666655e-03*G5_2_11_1_0 - 4.166666666666655e-03*G5_2_11_2_1 - 4.166666666666655e-03*G5_2_11_3_2 + 8.333333333333309e-03*G6_0_0_0_0_0_0_0 + 8.333333333333309e-03*G6_0_0_0_0_0_0_1 + 8.333333333333309e-03*G6_0_0_0_0_0_0_2 - 8.333333333333309e-03*G6_0_0_0_0_0_1_0 - 8.333333333333309e-03*G6_0_0_0_0_0_2_1 - 8.333333333333309e-03*G6_0_0_0_0_0_3_2 + 4.166666666666654e-03*G6_0_0_0_0_1_0_0 + 4.166666666666654e-03*G6_0_0_0_0_1_0_1 + 4.166666666666654e-03*G6_0_0_0_0_1_0_2 - 4.166666666666654e-03*G6_0_0_0_0_1_1_0 - 4.166666666666654e-03*G6_0_0_0_0_1_2_1 - 4.166666666666654e-03*G6_0_0_0_0_1_3_2 + 4.166666666666654e-03*G6_0_0_0_0_2_0_0 + 4.166666666666654e-03*G6_0_0_0_0_2_0_1 + 4.166666666666654e-03*G6_0_0_0_0_2_0_2 - 4.166666666666654e-03*G6_0_0_0_0_2_1_0 - 4.166666666666654e-03*G6_0_0_0_0_2_2_1 - 4.166666666666654e-03*G6_0_0_0_0_2_3_2 + 4.166666666666656e-03*G6_0_0_0_0_3_0_0 + 4.166666666666656e-03*G6_0_0_0_0_3_0_1 + 4.166666666666656e-03*G6_0_0_0_0_3_0_2 - 4.166666666666656e-03*G6_0_0_0_0_3_1_0 - 4.166666666666656e-03*G6_0_0_0_0_3_2_1 - 4.166666666666656e-03*G6_0_0_0_0_3_3_2 + 4.166666666666654e-03*G6_0_0_1_0_0_0_0 + 4.166666666666654e-03*G6_0_0_1_0_0_0_1 + 4.166666666666654e-03*G6_0_0_1_0_0_0_2 - 4.166666666666654e-03*G6_0_0_1_0_0_1_0 - 4.166666666666654e-03*G6_0_0_1_0_0_2_1 - 4.166666666666654e-03*G6_0_0_1_0_0_3_2 + 8.333333333333307e-03*G6_0_0_1_0_1_0_0 + 8.333333333333307e-03*G6_0_0_1_0_1_0_1 + 8.333333333333305e-03*G6_0_0_1_0_1_0_2 - 8.333333333333307e-03*G6_0_0_1_0_1_1_0 - 8.333333333333307e-03*G6_0_0_1_0_1_2_1 - 8.333333333333307e-03*G6_0_0_1_0_1_3_2 + 4.166666666666654e-03*G6_0_0_1_0_2_0_0 + 4.166666666666654e-03*G6_0_0_1_0_2_0_1 + 4.166666666666653e-03*G6_0_0_1_0_2_0_2 - 4.166666666666654e-03*G6_0_0_1_0_2_1_0 - 4.166666666666654e-03*G6_0_0_1_0_2_2_1 - 4.166666666666654e-03*G6_0_0_1_0_2_3_2 + 4.166666666666654e-03*G6_0_0_1_0_3_0_0 + 4.166666666666655e-03*G6_0_0_1_0_3_0_1 + 4.166666666666655e-03*G6_0_0_1_0_3_0_2 - 4.166666666666654e-03*G6_0_0_1_0_3_1_0 - 4.166666666666655e-03*G6_0_0_1_0_3_2_1 - 4.166666666666655e-03*G6_0_0_1_0_3_3_2 + 4.166666666666654e-03*G6_0_0_2_0_0_0_0 + 4.166666666666654e-03*G6_0_0_2_0_0_0_1 + 4.166666666666654e-03*G6_0_0_2_0_0_0_2 - 4.166666666666654e-03*G6_0_0_2_0_0_1_0 - 4.166666666666654e-03*G6_0_0_2_0_0_2_1 - 4.166666666666654e-03*G6_0_0_2_0_0_3_2 + 4.166666666666654e-03*G6_0_0_2_0_1_0_0 + 4.166666666666654e-03*G6_0_0_2_0_1_0_1 + 4.166666666666653e-03*G6_0_0_2_0_1_0_2 - 4.166666666666654e-03*G6_0_0_2_0_1_1_0 - 4.166666666666654e-03*G6_0_0_2_0_1_2_1 - 4.166666666666654e-03*G6_0_0_2_0_1_3_2 + 8.333333333333309e-03*G6_0_0_2_0_2_0_0 + 8.333333333333309e-03*G6_0_0_2_0_2_0_1 + 8.333333333333309e-03*G6_0_0_2_0_2_0_2 - 8.333333333333309e-03*G6_0_0_2_0_2_1_0 - 8.333333333333309e-03*G6_0_0_2_0_2_2_1 - 8.333333333333309e-03*G6_0_0_2_0_2_3_2 + 4.166666666666654e-03*G6_0_0_2_0_3_0_0 + 4.166666666666655e-03*G6_0_0_2_0_3_0_1 + 4.166666666666654e-03*G6_0_0_2_0_3_0_2 - 4.166666666666654e-03*G6_0_0_2_0_3_1_0 - 4.166666666666655e-03*G6_0_0_2_0_3_2_1 - 4.166666666666655e-03*G6_0_0_2_0_3_3_2 + 4.166666666666656e-03*G6_0_0_3_0_0_0_0 + 4.166666666666656e-03*G6_0_0_3_0_0_0_1 + 4.166666666666656e-03*G6_0_0_3_0_0_0_2 - 4.166666666666656e-03*G6_0_0_3_0_0_1_0 - 4.166666666666656e-03*G6_0_0_3_0_0_2_1 - 4.166666666666656e-03*G6_0_0_3_0_0_3_2 + 4.166666666666654e-03*G6_0_0_3_0_1_0_0 + 4.166666666666655e-03*G6_0_0_3_0_1_0_1 + 4.166666666666654e-03*G6_0_0_3_0_1_0_2 - 4.166666666666654e-03*G6_0_0_3_0_1_1_0 - 4.166666666666655e-03*G6_0_0_3_0_1_2_1 - 4.166666666666655e-03*G6_0_0_3_0_1_3_2 + 4.166666666666655e-03*G6_0_0_3_0_2_0_0 + 4.166666666666655e-03*G6_0_0_3_0_2_0_1 + 4.166666666666654e-03*G6_0_0_3_0_2_0_2 - 4.166666666666655e-03*G6_0_0_3_0_2_1_0 - 4.166666666666655e-03*G6_0_0_3_0_2_2_1 - 4.166666666666655e-03*G6_0_0_3_0_2_3_2 + 8.333333333333309e-03*G6_0_0_3_0_3_0_0 + 8.333333333333311e-03*G6_0_0_3_0_3_0_1 + 8.333333333333309e-03*G6_0_0_3_0_3_0_2 - 8.333333333333309e-03*G6_0_0_3_0_3_1_0 - 8.333333333333311e-03*G6_0_0_3_0_3_2_1 - 8.333333333333311e-03*G6_0_0_3_0_3_3_2 + 8.333333333333309e-03*G6_0_1_0_0_4_0_0 + 8.333333333333309e-03*G6_0_1_0_0_4_0_1 + 8.333333333333309e-03*G6_0_1_0_0_4_0_2 - 8.333333333333309e-03*G6_0_1_0_0_4_1_0 - 8.333333333333309e-03*G6_0_1_0_0_4_2_1 - 8.333333333333309e-03*G6_0_1_0_0_4_3_2 + 4.166666666666654e-03*G6_0_1_0_0_5_0_0 + 4.166666666666655e-03*G6_0_1_0_0_5_0_1 + 4.166666666666654e-03*G6_0_1_0_0_5_0_2 - 4.166666666666654e-03*G6_0_1_0_0_5_1_0 - 4.166666666666655e-03*G6_0_1_0_0_5_2_1 - 4.166666666666655e-03*G6_0_1_0_0_5_3_2 + 4.166666666666654e-03*G6_0_1_0_0_6_0_0 + 4.166666666666654e-03*G6_0_1_0_0_6_0_1 + 4.166666666666654e-03*G6_0_1_0_0_6_0_2 - 4.166666666666654e-03*G6_0_1_0_0_6_1_0 - 4.166666666666654e-03*G6_0_1_0_0_6_2_1 - 4.166666666666654e-03*G6_0_1_0_0_6_3_2 + 4.166666666666656e-03*G6_0_1_0_0_7_0_0 + 4.166666666666656e-03*G6_0_1_0_0_7_0_1 + 4.166666666666656e-03*G6_0_1_0_0_7_0_2 - 4.166666666666656e-03*G6_0_1_0_0_7_1_0 - 4.166666666666656e-03*G6_0_1_0_0_7_2_1 - 4.166666666666656e-03*G6_0_1_0_0_7_3_2 + 4.166666666666654e-03*G6_0_1_1_0_4_0_0 + 4.166666666666654e-03*G6_0_1_1_0_4_0_1 + 4.166666666666653e-03*G6_0_1_1_0_4_0_2 - 4.166666666666654e-03*G6_0_1_1_0_4_1_0 - 4.166666666666654e-03*G6_0_1_1_0_4_2_1 - 4.166666666666654e-03*G6_0_1_1_0_4_3_2 + 8.333333333333307e-03*G6_0_1_1_0_5_0_0 + 8.333333333333309e-03*G6_0_1_1_0_5_0_1 + 8.333333333333307e-03*G6_0_1_1_0_5_0_2 - 8.333333333333307e-03*G6_0_1_1_0_5_1_0 - 8.333333333333309e-03*G6_0_1_1_0_5_2_1 - 8.333333333333309e-03*G6_0_1_1_0_5_3_2 + 4.166666666666654e-03*G6_0_1_1_0_6_0_0 + 4.166666666666654e-03*G6_0_1_1_0_6_0_1 + 4.166666666666653e-03*G6_0_1_1_0_6_0_2 - 4.166666666666654e-03*G6_0_1_1_0_6_1_0 - 4.166666666666654e-03*G6_0_1_1_0_6_2_1 - 4.166666666666654e-03*G6_0_1_1_0_6_3_2 + 4.166666666666654e-03*G6_0_1_1_0_7_0_0 + 4.166666666666655e-03*G6_0_1_1_0_7_0_1 + 4.166666666666655e-03*G6_0_1_1_0_7_0_2 - 4.166666666666654e-03*G6_0_1_1_0_7_1_0 - 4.166666666666655e-03*G6_0_1_1_0_7_2_1 - 4.166666666666655e-03*G6_0_1_1_0_7_3_2 + 4.166666666666653e-03*G6_0_1_2_0_4_0_0 + 4.166666666666654e-03*G6_0_1_2_0_4_0_1 + 4.166666666666653e-03*G6_0_1_2_0_4_0_2 - 4.166666666666653e-03*G6_0_1_2_0_4_1_0 - 4.166666666666654e-03*G6_0_1_2_0_4_2_1 - 4.166666666666654e-03*G6_0_1_2_0_4_3_2 + 4.166666666666654e-03*G6_0_1_2_0_5_0_0 + 4.166666666666655e-03*G6_0_1_2_0_5_0_1 + 4.166666666666654e-03*G6_0_1_2_0_5_0_2 - 4.166666666666654e-03*G6_0_1_2_0_5_1_0 - 4.166666666666655e-03*G6_0_1_2_0_5_2_1 - 4.166666666666655e-03*G6_0_1_2_0_5_3_2 + 8.333333333333309e-03*G6_0_1_2_0_6_0_0 + 8.333333333333309e-03*G6_0_1_2_0_6_0_1 + 8.333333333333309e-03*G6_0_1_2_0_6_0_2 - 8.333333333333309e-03*G6_0_1_2_0_6_1_0 - 8.333333333333309e-03*G6_0_1_2_0_6_2_1 - 8.333333333333309e-03*G6_0_1_2_0_6_3_2 + 4.166666666666654e-03*G6_0_1_2_0_7_0_0 + 4.166666666666655e-03*G6_0_1_2_0_7_0_1 + 4.166666666666654e-03*G6_0_1_2_0_7_0_2 - 4.166666666666654e-03*G6_0_1_2_0_7_1_0 - 4.166666666666655e-03*G6_0_1_2_0_7_2_1 - 4.166666666666655e-03*G6_0_1_2_0_7_3_2 + 4.166666666666655e-03*G6_0_1_3_0_4_0_0 + 4.166666666666656e-03*G6_0_1_3_0_4_0_1 + 4.166666666666655e-03*G6_0_1_3_0_4_0_2 - 4.166666666666655e-03*G6_0_1_3_0_4_1_0 - 4.166666666666656e-03*G6_0_1_3_0_4_2_1 - 4.166666666666656e-03*G6_0_1_3_0_4_3_2 + 4.166666666666655e-03*G6_0_1_3_0_5_0_0 + 4.166666666666656e-03*G6_0_1_3_0_5_0_1 + 4.166666666666656e-03*G6_0_1_3_0_5_0_2 - 4.166666666666655e-03*G6_0_1_3_0_5_1_0 - 4.166666666666656e-03*G6_0_1_3_0_5_2_1 - 4.166666666666656e-03*G6_0_1_3_0_5_3_2 + 4.166666666666655e-03*G6_0_1_3_0_6_0_0 + 4.166666666666655e-03*G6_0_1_3_0_6_0_1 + 4.166666666666654e-03*G6_0_1_3_0_6_0_2 - 4.166666666666655e-03*G6_0_1_3_0_6_1_0 - 4.166666666666655e-03*G6_0_1_3_0_6_2_1 - 4.166666666666655e-03*G6_0_1_3_0_6_3_2 + 8.333333333333309e-03*G6_0_1_3_0_7_0_0 + 8.333333333333311e-03*G6_0_1_3_0_7_0_1 + 8.333333333333309e-03*G6_0_1_3_0_7_0_2 - 8.333333333333309e-03*G6_0_1_3_0_7_1_0 - 8.333333333333311e-03*G6_0_1_3_0_7_2_1 - 8.333333333333311e-03*G6_0_1_3_0_7_3_2 + 8.333333333333309e-03*G6_0_2_0_0_8_0_0 + 8.333333333333309e-03*G6_0_2_0_0_8_0_1 + 8.333333333333309e-03*G6_0_2_0_0_8_0_2 - 8.333333333333309e-03*G6_0_2_0_0_8_1_0 - 8.333333333333309e-03*G6_0_2_0_0_8_2_1 - 8.333333333333309e-03*G6_0_2_0_0_8_3_2 + 4.166666666666654e-03*G6_0_2_0_0_9_0_0 + 4.166666666666655e-03*G6_0_2_0_0_9_0_1 + 4.166666666666654e-03*G6_0_2_0_0_9_0_2 - 4.166666666666654e-03*G6_0_2_0_0_9_1_0 - 4.166666666666655e-03*G6_0_2_0_0_9_2_1 - 4.166666666666655e-03*G6_0_2_0_0_9_3_2 + 4.166666666666654e-03*G6_0_2_0_0_10_0_0 + 4.166666666666654e-03*G6_0_2_0_0_10_0_1 + 4.166666666666654e-03*G6_0_2_0_0_10_0_2 - 4.166666666666654e-03*G6_0_2_0_0_10_1_0 - 4.166666666666654e-03*G6_0_2_0_0_10_2_1 - 4.166666666666654e-03*G6_0_2_0_0_10_3_2 + 4.166666666666656e-03*G6_0_2_0_0_11_0_0 + 4.166666666666656e-03*G6_0_2_0_0_11_0_1 + 4.166666666666656e-03*G6_0_2_0_0_11_0_2 - 4.166666666666656e-03*G6_0_2_0_0_11_1_0 - 4.166666666666656e-03*G6_0_2_0_0_11_2_1 - 4.166666666666656e-03*G6_0_2_0_0_11_3_2 + 4.166666666666654e-03*G6_0_2_1_0_8_0_0 + 4.166666666666654e-03*G6_0_2_1_0_8_0_1 + 4.166666666666653e-03*G6_0_2_1_0_8_0_2 - 4.166666666666654e-03*G6_0_2_1_0_8_1_0 - 4.166666666666654e-03*G6_0_2_1_0_8_2_1 - 4.166666666666654e-03*G6_0_2_1_0_8_3_2 + 8.333333333333307e-03*G6_0_2_1_0_9_0_0 + 8.333333333333309e-03*G6_0_2_1_0_9_0_1 + 8.333333333333307e-03*G6_0_2_1_0_9_0_2 - 8.333333333333307e-03*G6_0_2_1_0_9_1_0 - 8.333333333333309e-03*G6_0_2_1_0_9_2_1 - 8.333333333333309e-03*G6_0_2_1_0_9_3_2 + 4.166666666666654e-03*G6_0_2_1_0_10_0_0 + 4.166666666666654e-03*G6_0_2_1_0_10_0_1 + 4.166666666666653e-03*G6_0_2_1_0_10_0_2 - 4.166666666666654e-03*G6_0_2_1_0_10_1_0 - 4.166666666666654e-03*G6_0_2_1_0_10_2_1 - 4.166666666666654e-03*G6_0_2_1_0_10_3_2 + 4.166666666666654e-03*G6_0_2_1_0_11_0_0 + 4.166666666666655e-03*G6_0_2_1_0_11_0_1 + 4.166666666666655e-03*G6_0_2_1_0_11_0_2 - 4.166666666666654e-03*G6_0_2_1_0_11_1_0 - 4.166666666666655e-03*G6_0_2_1_0_11_2_1 - 4.166666666666655e-03*G6_0_2_1_0_11_3_2 + 4.166666666666653e-03*G6_0_2_2_0_8_0_0 + 4.166666666666654e-03*G6_0_2_2_0_8_0_1 + 4.166666666666653e-03*G6_0_2_2_0_8_0_2 - 4.166666666666653e-03*G6_0_2_2_0_8_1_0 - 4.166666666666654e-03*G6_0_2_2_0_8_2_1 - 4.166666666666654e-03*G6_0_2_2_0_8_3_2 + 4.166666666666654e-03*G6_0_2_2_0_9_0_0 + 4.166666666666655e-03*G6_0_2_2_0_9_0_1 + 4.166666666666654e-03*G6_0_2_2_0_9_0_2 - 4.166666666666654e-03*G6_0_2_2_0_9_1_0 - 4.166666666666655e-03*G6_0_2_2_0_9_2_1 - 4.166666666666655e-03*G6_0_2_2_0_9_3_2 + 8.333333333333309e-03*G6_0_2_2_0_10_0_0 + 8.333333333333309e-03*G6_0_2_2_0_10_0_1 + 8.333333333333309e-03*G6_0_2_2_0_10_0_2 - 8.333333333333309e-03*G6_0_2_2_0_10_1_0 - 8.333333333333309e-03*G6_0_2_2_0_10_2_1 - 8.333333333333309e-03*G6_0_2_2_0_10_3_2 + 4.166666666666654e-03*G6_0_2_2_0_11_0_0 + 4.166666666666655e-03*G6_0_2_2_0_11_0_1 + 4.166666666666654e-03*G6_0_2_2_0_11_0_2 - 4.166666666666654e-03*G6_0_2_2_0_11_1_0 - 4.166666666666655e-03*G6_0_2_2_0_11_2_1 - 4.166666666666655e-03*G6_0_2_2_0_11_3_2 + 4.166666666666655e-03*G6_0_2_3_0_8_0_0 + 4.166666666666656e-03*G6_0_2_3_0_8_0_1 + 4.166666666666655e-03*G6_0_2_3_0_8_0_2 - 4.166666666666655e-03*G6_0_2_3_0_8_1_0 - 4.166666666666656e-03*G6_0_2_3_0_8_2_1 - 4.166666666666656e-03*G6_0_2_3_0_8_3_2 + 4.166666666666655e-03*G6_0_2_3_0_9_0_0 + 4.166666666666656e-03*G6_0_2_3_0_9_0_1 + 4.166666666666656e-03*G6_0_2_3_0_9_0_2 - 4.166666666666655e-03*G6_0_2_3_0_9_1_0 - 4.166666666666656e-03*G6_0_2_3_0_9_2_1 - 4.166666666666656e-03*G6_0_2_3_0_9_3_2 + 4.166666666666655e-03*G6_0_2_3_0_10_0_0 + 4.166666666666655e-03*G6_0_2_3_0_10_0_1 + 4.166666666666654e-03*G6_0_2_3_0_10_0_2 - 4.166666666666655e-03*G6_0_2_3_0_10_1_0 - 4.166666666666655e-03*G6_0_2_3_0_10_2_1 - 4.166666666666655e-03*G6_0_2_3_0_10_3_2 + 8.333333333333309e-03*G6_0_2_3_0_11_0_0 + 8.333333333333311e-03*G6_0_2_3_0_11_0_1 + 8.333333333333309e-03*G6_0_2_3_0_11_0_2 - 8.333333333333309e-03*G6_0_2_3_0_11_1_0 - 8.333333333333311e-03*G6_0_2_3_0_11_2_1 - 8.333333333333311e-03*G6_0_2_3_0_11_3_2 + 8.333333333333309e-03*G6_1_0_4_0_0_0_0 + 8.333333333333309e-03*G6_1_0_4_0_0_0_1 + 8.333333333333309e-03*G6_1_0_4_0_0_0_2 - 8.333333333333309e-03*G6_1_0_4_0_0_1_0 - 8.333333333333309e-03*G6_1_0_4_0_0_2_1 - 8.333333333333309e-03*G6_1_0_4_0_0_3_2 + 4.166666666666654e-03*G6_1_0_4_0_1_0_0 + 4.166666666666654e-03*G6_1_0_4_0_1_0_1 + 4.166666666666653e-03*G6_1_0_4_0_1_0_2 - 4.166666666666654e-03*G6_1_0_4_0_1_1_0 - 4.166666666666654e-03*G6_1_0_4_0_1_2_1 - 4.166666666666654e-03*G6_1_0_4_0_1_3_2 + 4.166666666666653e-03*G6_1_0_4_0_2_0_0 + 4.166666666666654e-03*G6_1_0_4_0_2_0_1 + 4.166666666666654e-03*G6_1_0_4_0_2_0_2 - 4.166666666666653e-03*G6_1_0_4_0_2_1_0 - 4.166666666666654e-03*G6_1_0_4_0_2_2_1 - 4.166666666666654e-03*G6_1_0_4_0_2_3_2 + 4.166666666666654e-03*G6_1_0_4_0_3_0_0 + 4.166666666666656e-03*G6_1_0_4_0_3_0_1 + 4.166666666666654e-03*G6_1_0_4_0_3_0_2 - 4.166666666666654e-03*G6_1_0_4_0_3_1_0 - 4.166666666666656e-03*G6_1_0_4_0_3_2_1 - 4.166666666666656e-03*G6_1_0_4_0_3_3_2 + 4.166666666666654e-03*G6_1_0_5_0_0_0_0 + 4.166666666666655e-03*G6_1_0_5_0_0_0_1 + 4.166666666666654e-03*G6_1_0_5_0_0_0_2 - 4.166666666666654e-03*G6_1_0_5_0_0_1_0 - 4.166666666666655e-03*G6_1_0_5_0_0_2_1 - 4.166666666666655e-03*G6_1_0_5_0_0_3_2 + 8.333333333333307e-03*G6_1_0_5_0_1_0_0 + 8.333333333333309e-03*G6_1_0_5_0_1_0_1 + 8.333333333333307e-03*G6_1_0_5_0_1_0_2 - 8.333333333333307e-03*G6_1_0_5_0_1_1_0 - 8.333333333333309e-03*G6_1_0_5_0_1_2_1 - 8.333333333333309e-03*G6_1_0_5_0_1_3_2 + 4.166666666666654e-03*G6_1_0_5_0_2_0_0 + 4.166666666666655e-03*G6_1_0_5_0_2_0_1 + 4.166666666666654e-03*G6_1_0_5_0_2_0_2 - 4.166666666666654e-03*G6_1_0_5_0_2_1_0 - 4.166666666666655e-03*G6_1_0_5_0_2_2_1 - 4.166666666666655e-03*G6_1_0_5_0_2_3_2 + 4.166666666666655e-03*G6_1_0_5_0_3_0_0 + 4.166666666666656e-03*G6_1_0_5_0_3_0_1 + 4.166666666666656e-03*G6_1_0_5_0_3_0_2 - 4.166666666666655e-03*G6_1_0_5_0_3_1_0 - 4.166666666666656e-03*G6_1_0_5_0_3_2_1 - 4.166666666666656e-03*G6_1_0_5_0_3_3_2 + 4.166666666666654e-03*G6_1_0_6_0_0_0_0 + 4.166666666666654e-03*G6_1_0_6_0_0_0_1 + 4.166666666666654e-03*G6_1_0_6_0_0_0_2 - 4.166666666666654e-03*G6_1_0_6_0_0_1_0 - 4.166666666666654e-03*G6_1_0_6_0_0_2_1 - 4.166666666666654e-03*G6_1_0_6_0_0_3_2 + 4.166666666666654e-03*G6_1_0_6_0_1_0_0 + 4.166666666666654e-03*G6_1_0_6_0_1_0_1 + 4.166666666666653e-03*G6_1_0_6_0_1_0_2 - 4.166666666666654e-03*G6_1_0_6_0_1_1_0 - 4.166666666666654e-03*G6_1_0_6_0_1_2_1 - 4.166666666666654e-03*G6_1_0_6_0_1_3_2 + 8.333333333333309e-03*G6_1_0_6_0_2_0_0 + 8.333333333333309e-03*G6_1_0_6_0_2_0_1 + 8.333333333333309e-03*G6_1_0_6_0_2_0_2 - 8.333333333333309e-03*G6_1_0_6_0_2_1_0 - 8.333333333333309e-03*G6_1_0_6_0_2_2_1 - 8.333333333333309e-03*G6_1_0_6_0_2_3_2 + 4.166666666666654e-03*G6_1_0_6_0_3_0_0 + 4.166666666666655e-03*G6_1_0_6_0_3_0_1 + 4.166666666666654e-03*G6_1_0_6_0_3_0_2 - 4.166666666666654e-03*G6_1_0_6_0_3_1_0 - 4.166666666666655e-03*G6_1_0_6_0_3_2_1 - 4.166666666666655e-03*G6_1_0_6_0_3_3_2 + 4.166666666666656e-03*G6_1_0_7_0_0_0_0 + 4.166666666666656e-03*G6_1_0_7_0_0_0_1 + 4.166666666666656e-03*G6_1_0_7_0_0_0_2 - 4.166666666666656e-03*G6_1_0_7_0_0_1_0 - 4.166666666666656e-03*G6_1_0_7_0_0_2_1 - 4.166666666666656e-03*G6_1_0_7_0_0_3_2 + 4.166666666666654e-03*G6_1_0_7_0_1_0_0 + 4.166666666666655e-03*G6_1_0_7_0_1_0_1 + 4.166666666666654e-03*G6_1_0_7_0_1_0_2 - 4.166666666666654e-03*G6_1_0_7_0_1_1_0 - 4.166666666666655e-03*G6_1_0_7_0_1_2_1 - 4.166666666666655e-03*G6_1_0_7_0_1_3_2 + 4.166666666666655e-03*G6_1_0_7_0_2_0_0 + 4.166666666666655e-03*G6_1_0_7_0_2_0_1 + 4.166666666666654e-03*G6_1_0_7_0_2_0_2 - 4.166666666666655e-03*G6_1_0_7_0_2_1_0 - 4.166666666666655e-03*G6_1_0_7_0_2_2_1 - 4.166666666666655e-03*G6_1_0_7_0_2_3_2 + 8.333333333333309e-03*G6_1_0_7_0_3_0_0 + 8.333333333333311e-03*G6_1_0_7_0_3_0_1 + 8.333333333333309e-03*G6_1_0_7_0_3_0_2 - 8.333333333333309e-03*G6_1_0_7_0_3_1_0 - 8.333333333333311e-03*G6_1_0_7_0_3_2_1 - 8.333333333333311e-03*G6_1_0_7_0_3_3_2 + 8.333333333333309e-03*G6_1_1_4_0_4_0_0 + 8.333333333333309e-03*G6_1_1_4_0_4_0_1 + 8.333333333333309e-03*G6_1_1_4_0_4_0_2 - 8.333333333333309e-03*G6_1_1_4_0_4_1_0 - 8.333333333333309e-03*G6_1_1_4_0_4_2_1 - 8.333333333333309e-03*G6_1_1_4_0_4_3_2 + 4.166666666666654e-03*G6_1_1_4_0_5_0_0 + 4.166666666666654e-03*G6_1_1_4_0_5_0_1 + 4.166666666666654e-03*G6_1_1_4_0_5_0_2 - 4.166666666666654e-03*G6_1_1_4_0_5_1_0 - 4.166666666666654e-03*G6_1_1_4_0_5_2_1 - 4.166666666666654e-03*G6_1_1_4_0_5_3_2 + 4.166666666666653e-03*G6_1_1_4_0_6_0_0 + 4.166666666666654e-03*G6_1_1_4_0_6_0_1 + 4.166666666666654e-03*G6_1_1_4_0_6_0_2 - 4.166666666666653e-03*G6_1_1_4_0_6_1_0 - 4.166666666666654e-03*G6_1_1_4_0_6_2_1 - 4.166666666666654e-03*G6_1_1_4_0_6_3_2 + 4.166666666666654e-03*G6_1_1_4_0_7_0_0 + 4.166666666666656e-03*G6_1_1_4_0_7_0_1 + 4.166666666666654e-03*G6_1_1_4_0_7_0_2 - 4.166666666666654e-03*G6_1_1_4_0_7_1_0 - 4.166666666666656e-03*G6_1_1_4_0_7_2_1 - 4.166666666666656e-03*G6_1_1_4_0_7_3_2 + 4.166666666666654e-03*G6_1_1_5_0_4_0_0 + 4.166666666666654e-03*G6_1_1_5_0_4_0_1 + 4.166666666666654e-03*G6_1_1_5_0_4_0_2 - 4.166666666666654e-03*G6_1_1_5_0_4_1_0 - 4.166666666666654e-03*G6_1_1_5_0_4_2_1 - 4.166666666666654e-03*G6_1_1_5_0_4_3_2 + 8.333333333333307e-03*G6_1_1_5_0_5_0_0 + 8.333333333333309e-03*G6_1_1_5_0_5_0_1 + 8.333333333333307e-03*G6_1_1_5_0_5_0_2 - 8.333333333333307e-03*G6_1_1_5_0_5_1_0 - 8.333333333333309e-03*G6_1_1_5_0_5_2_1 - 8.333333333333309e-03*G6_1_1_5_0_5_3_2 + 4.166666666666654e-03*G6_1_1_5_0_6_0_0 + 4.166666666666655e-03*G6_1_1_5_0_6_0_1 + 4.166666666666654e-03*G6_1_1_5_0_6_0_2 - 4.166666666666654e-03*G6_1_1_5_0_6_1_0 - 4.166666666666655e-03*G6_1_1_5_0_6_2_1 - 4.166666666666655e-03*G6_1_1_5_0_6_3_2 + 4.166666666666655e-03*G6_1_1_5_0_7_0_0 + 4.166666666666656e-03*G6_1_1_5_0_7_0_1 + 4.166666666666656e-03*G6_1_1_5_0_7_0_2 - 4.166666666666655e-03*G6_1_1_5_0_7_1_0 - 4.166666666666656e-03*G6_1_1_5_0_7_2_1 - 4.166666666666656e-03*G6_1_1_5_0_7_3_2 + 4.166666666666653e-03*G6_1_1_6_0_4_0_0 + 4.166666666666654e-03*G6_1_1_6_0_4_0_1 + 4.166666666666653e-03*G6_1_1_6_0_4_0_2 - 4.166666666666653e-03*G6_1_1_6_0_4_1_0 - 4.166666666666654e-03*G6_1_1_6_0_4_2_1 - 4.166666666666654e-03*G6_1_1_6_0_4_3_2 + 4.166666666666654e-03*G6_1_1_6_0_5_0_0 + 4.166666666666655e-03*G6_1_1_6_0_5_0_1 + 4.166666666666654e-03*G6_1_1_6_0_5_0_2 - 4.166666666666654e-03*G6_1_1_6_0_5_1_0 - 4.166666666666655e-03*G6_1_1_6_0_5_2_1 - 4.166666666666655e-03*G6_1_1_6_0_5_3_2 + 8.333333333333309e-03*G6_1_1_6_0_6_0_0 + 8.333333333333309e-03*G6_1_1_6_0_6_0_1 + 8.333333333333309e-03*G6_1_1_6_0_6_0_2 - 8.333333333333309e-03*G6_1_1_6_0_6_1_0 - 8.333333333333309e-03*G6_1_1_6_0_6_2_1 - 8.333333333333309e-03*G6_1_1_6_0_6_3_2 + 4.166666666666654e-03*G6_1_1_6_0_7_0_0 + 4.166666666666655e-03*G6_1_1_6_0_7_0_1 + 4.166666666666654e-03*G6_1_1_6_0_7_0_2 - 4.166666666666654e-03*G6_1_1_6_0_7_1_0 - 4.166666666666655e-03*G6_1_1_6_0_7_2_1 - 4.166666666666655e-03*G6_1_1_6_0_7_3_2 + 4.166666666666655e-03*G6_1_1_7_0_4_0_0 + 4.166666666666656e-03*G6_1_1_7_0_4_0_1 + 4.166666666666655e-03*G6_1_1_7_0_4_0_2 - 4.166666666666655e-03*G6_1_1_7_0_4_1_0 - 4.166666666666656e-03*G6_1_1_7_0_4_2_1 - 4.166666666666656e-03*G6_1_1_7_0_4_3_2 + 4.166666666666655e-03*G6_1_1_7_0_5_0_0 + 4.166666666666656e-03*G6_1_1_7_0_5_0_1 + 4.166666666666656e-03*G6_1_1_7_0_5_0_2 - 4.166666666666655e-03*G6_1_1_7_0_5_1_0 - 4.166666666666656e-03*G6_1_1_7_0_5_2_1 - 4.166666666666656e-03*G6_1_1_7_0_5_3_2 + 4.166666666666655e-03*G6_1_1_7_0_6_0_0 + 4.166666666666655e-03*G6_1_1_7_0_6_0_1 + 4.166666666666654e-03*G6_1_1_7_0_6_0_2 - 4.166666666666655e-03*G6_1_1_7_0_6_1_0 - 4.166666666666655e-03*G6_1_1_7_0_6_2_1 - 4.166666666666655e-03*G6_1_1_7_0_6_3_2 + 8.333333333333309e-03*G6_1_1_7_0_7_0_0 + 8.333333333333311e-03*G6_1_1_7_0_7_0_1 + 8.333333333333309e-03*G6_1_1_7_0_7_0_2 - 8.333333333333309e-03*G6_1_1_7_0_7_1_0 - 8.333333333333311e-03*G6_1_1_7_0_7_2_1 - 8.333333333333311e-03*G6_1_1_7_0_7_3_2 + 8.333333333333309e-03*G6_1_2_4_0_8_0_0 + 8.333333333333309e-03*G6_1_2_4_0_8_0_1 + 8.333333333333309e-03*G6_1_2_4_0_8_0_2 - 8.333333333333309e-03*G6_1_2_4_0_8_1_0 - 8.333333333333309e-03*G6_1_2_4_0_8_2_1 - 8.333333333333309e-03*G6_1_2_4_0_8_3_2 + 4.166666666666654e-03*G6_1_2_4_0_9_0_0 + 4.166666666666654e-03*G6_1_2_4_0_9_0_1 + 4.166666666666654e-03*G6_1_2_4_0_9_0_2 - 4.166666666666654e-03*G6_1_2_4_0_9_1_0 - 4.166666666666654e-03*G6_1_2_4_0_9_2_1 - 4.166666666666654e-03*G6_1_2_4_0_9_3_2 + 4.166666666666653e-03*G6_1_2_4_0_10_0_0 + 4.166666666666654e-03*G6_1_2_4_0_10_0_1 + 4.166666666666654e-03*G6_1_2_4_0_10_0_2 - 4.166666666666653e-03*G6_1_2_4_0_10_1_0 - 4.166666666666654e-03*G6_1_2_4_0_10_2_1 - 4.166666666666654e-03*G6_1_2_4_0_10_3_2 + 4.166666666666654e-03*G6_1_2_4_0_11_0_0 + 4.166666666666656e-03*G6_1_2_4_0_11_0_1 + 4.166666666666654e-03*G6_1_2_4_0_11_0_2 - 4.166666666666654e-03*G6_1_2_4_0_11_1_0 - 4.166666666666656e-03*G6_1_2_4_0_11_2_1 - 4.166666666666656e-03*G6_1_2_4_0_11_3_2 + 4.166666666666654e-03*G6_1_2_5_0_8_0_0 + 4.166666666666654e-03*G6_1_2_5_0_8_0_1 + 4.166666666666654e-03*G6_1_2_5_0_8_0_2 - 4.166666666666654e-03*G6_1_2_5_0_8_1_0 - 4.166666666666654e-03*G6_1_2_5_0_8_2_1 - 4.166666666666654e-03*G6_1_2_5_0_8_3_2 + 8.333333333333307e-03*G6_1_2_5_0_9_0_0 + 8.333333333333309e-03*G6_1_2_5_0_9_0_1 + 8.333333333333307e-03*G6_1_2_5_0_9_0_2 - 8.333333333333307e-03*G6_1_2_5_0_9_1_0 - 8.333333333333309e-03*G6_1_2_5_0_9_2_1 - 8.333333333333309e-03*G6_1_2_5_0_9_3_2 + 4.166666666666654e-03*G6_1_2_5_0_10_0_0 + 4.166666666666655e-03*G6_1_2_5_0_10_0_1 + 4.166666666666654e-03*G6_1_2_5_0_10_0_2 - 4.166666666666654e-03*G6_1_2_5_0_10_1_0 - 4.166666666666655e-03*G6_1_2_5_0_10_2_1 - 4.166666666666655e-03*G6_1_2_5_0_10_3_2 + 4.166666666666655e-03*G6_1_2_5_0_11_0_0 + 4.166666666666656e-03*G6_1_2_5_0_11_0_1 + 4.166666666666656e-03*G6_1_2_5_0_11_0_2 - 4.166666666666655e-03*G6_1_2_5_0_11_1_0 - 4.166666666666656e-03*G6_1_2_5_0_11_2_1 - 4.166666666666656e-03*G6_1_2_5_0_11_3_2 + 4.166666666666653e-03*G6_1_2_6_0_8_0_0 + 4.166666666666654e-03*G6_1_2_6_0_8_0_1 + 4.166666666666653e-03*G6_1_2_6_0_8_0_2 - 4.166666666666653e-03*G6_1_2_6_0_8_1_0 - 4.166666666666654e-03*G6_1_2_6_0_8_2_1 - 4.166666666666654e-03*G6_1_2_6_0_8_3_2 + 4.166666666666654e-03*G6_1_2_6_0_9_0_0 + 4.166666666666655e-03*G6_1_2_6_0_9_0_1 + 4.166666666666654e-03*G6_1_2_6_0_9_0_2 - 4.166666666666654e-03*G6_1_2_6_0_9_1_0 - 4.166666666666655e-03*G6_1_2_6_0_9_2_1 - 4.166666666666655e-03*G6_1_2_6_0_9_3_2 + 8.333333333333309e-03*G6_1_2_6_0_10_0_0 + 8.333333333333309e-03*G6_1_2_6_0_10_0_1 + 8.333333333333309e-03*G6_1_2_6_0_10_0_2 - 8.333333333333309e-03*G6_1_2_6_0_10_1_0 - 8.333333333333309e-03*G6_1_2_6_0_10_2_1 - 8.333333333333309e-03*G6_1_2_6_0_10_3_2 + 4.166666666666654e-03*G6_1_2_6_0_11_0_0 + 4.166666666666655e-03*G6_1_2_6_0_11_0_1 + 4.166666666666654e-03*G6_1_2_6_0_11_0_2 - 4.166666666666654e-03*G6_1_2_6_0_11_1_0 - 4.166666666666655e-03*G6_1_2_6_0_11_2_1 - 4.166666666666655e-03*G6_1_2_6_0_11_3_2 + 4.166666666666655e-03*G6_1_2_7_0_8_0_0 + 4.166666666666656e-03*G6_1_2_7_0_8_0_1 + 4.166666666666655e-03*G6_1_2_7_0_8_0_2 - 4.166666666666655e-03*G6_1_2_7_0_8_1_0 - 4.166666666666656e-03*G6_1_2_7_0_8_2_1 - 4.166666666666656e-03*G6_1_2_7_0_8_3_2 + 4.166666666666655e-03*G6_1_2_7_0_9_0_0 + 4.166666666666656e-03*G6_1_2_7_0_9_0_1 + 4.166666666666656e-03*G6_1_2_7_0_9_0_2 - 4.166666666666655e-03*G6_1_2_7_0_9_1_0 - 4.166666666666656e-03*G6_1_2_7_0_9_2_1 - 4.166666666666656e-03*G6_1_2_7_0_9_3_2 + 4.166666666666655e-03*G6_1_2_7_0_10_0_0 + 4.166666666666655e-03*G6_1_2_7_0_10_0_1 + 4.166666666666654e-03*G6_1_2_7_0_10_0_2 - 4.166666666666655e-03*G6_1_2_7_0_10_1_0 - 4.166666666666655e-03*G6_1_2_7_0_10_2_1 - 4.166666666666655e-03*G6_1_2_7_0_10_3_2 + 8.333333333333309e-03*G6_1_2_7_0_11_0_0 + 8.333333333333311e-03*G6_1_2_7_0_11_0_1 + 8.333333333333309e-03*G6_1_2_7_0_11_0_2 - 8.333333333333309e-03*G6_1_2_7_0_11_1_0 - 8.333333333333311e-03*G6_1_2_7_0_11_2_1 - 8.333333333333311e-03*G6_1_2_7_0_11_3_2 + 8.333333333333309e-03*G6_2_0_8_0_0_0_0 + 8.333333333333309e-03*G6_2_0_8_0_0_0_1 + 8.333333333333309e-03*G6_2_0_8_0_0_0_2 - 8.333333333333309e-03*G6_2_0_8_0_0_1_0 - 8.333333333333309e-03*G6_2_0_8_0_0_2_1 - 8.333333333333309e-03*G6_2_0_8_0_0_3_2 + 4.166666666666654e-03*G6_2_0_8_0_1_0_0 + 4.166666666666654e-03*G6_2_0_8_0_1_0_1 + 4.166666666666653e-03*G6_2_0_8_0_1_0_2 - 4.166666666666654e-03*G6_2_0_8_0_1_1_0 - 4.166666666666654e-03*G6_2_0_8_0_1_2_1 - 4.166666666666654e-03*G6_2_0_8_0_1_3_2 + 4.166666666666653e-03*G6_2_0_8_0_2_0_0 + 4.166666666666654e-03*G6_2_0_8_0_2_0_1 + 4.166666666666654e-03*G6_2_0_8_0_2_0_2 - 4.166666666666653e-03*G6_2_0_8_0_2_1_0 - 4.166666666666654e-03*G6_2_0_8_0_2_2_1 - 4.166666666666654e-03*G6_2_0_8_0_2_3_2 + 4.166666666666654e-03*G6_2_0_8_0_3_0_0 + 4.166666666666656e-03*G6_2_0_8_0_3_0_1 + 4.166666666666654e-03*G6_2_0_8_0_3_0_2 - 4.166666666666654e-03*G6_2_0_8_0_3_1_0 - 4.166666666666656e-03*G6_2_0_8_0_3_2_1 - 4.166666666666656e-03*G6_2_0_8_0_3_3_2 + 4.166666666666654e-03*G6_2_0_9_0_0_0_0 + 4.166666666666655e-03*G6_2_0_9_0_0_0_1 + 4.166666666666654e-03*G6_2_0_9_0_0_0_2 - 4.166666666666654e-03*G6_2_0_9_0_0_1_0 - 4.166666666666655e-03*G6_2_0_9_0_0_2_1 - 4.166666666666655e-03*G6_2_0_9_0_0_3_2 + 8.333333333333307e-03*G6_2_0_9_0_1_0_0 + 8.333333333333309e-03*G6_2_0_9_0_1_0_1 + 8.333333333333307e-03*G6_2_0_9_0_1_0_2 - 8.333333333333307e-03*G6_2_0_9_0_1_1_0 - 8.333333333333309e-03*G6_2_0_9_0_1_2_1 - 8.333333333333309e-03*G6_2_0_9_0_1_3_2 + 4.166666666666654e-03*G6_2_0_9_0_2_0_0 + 4.166666666666655e-03*G6_2_0_9_0_2_0_1 + 4.166666666666654e-03*G6_2_0_9_0_2_0_2 - 4.166666666666654e-03*G6_2_0_9_0_2_1_0 - 4.166666666666655e-03*G6_2_0_9_0_2_2_1 - 4.166666666666655e-03*G6_2_0_9_0_2_3_2 + 4.166666666666655e-03*G6_2_0_9_0_3_0_0 + 4.166666666666656e-03*G6_2_0_9_0_3_0_1 + 4.166666666666656e-03*G6_2_0_9_0_3_0_2 - 4.166666666666655e-03*G6_2_0_9_0_3_1_0 - 4.166666666666656e-03*G6_2_0_9_0_3_2_1 - 4.166666666666656e-03*G6_2_0_9_0_3_3_2 + 4.166666666666654e-03*G6_2_0_10_0_0_0_0 + 4.166666666666654e-03*G6_2_0_10_0_0_0_1 + 4.166666666666654e-03*G6_2_0_10_0_0_0_2 - 4.166666666666654e-03*G6_2_0_10_0_0_1_0 - 4.166666666666654e-03*G6_2_0_10_0_0_2_1 - 4.166666666666654e-03*G6_2_0_10_0_0_3_2 + 4.166666666666654e-03*G6_2_0_10_0_1_0_0 + 4.166666666666654e-03*G6_2_0_10_0_1_0_1 + 4.166666666666653e-03*G6_2_0_10_0_1_0_2 - 4.166666666666654e-03*G6_2_0_10_0_1_1_0 - 4.166666666666654e-03*G6_2_0_10_0_1_2_1 - 4.166666666666654e-03*G6_2_0_10_0_1_3_2 + 8.333333333333309e-03*G6_2_0_10_0_2_0_0 + 8.333333333333309e-03*G6_2_0_10_0_2_0_1 + 8.333333333333309e-03*G6_2_0_10_0_2_0_2 - 8.333333333333309e-03*G6_2_0_10_0_2_1_0 - 8.333333333333309e-03*G6_2_0_10_0_2_2_1 - 8.333333333333309e-03*G6_2_0_10_0_2_3_2 + 4.166666666666654e-03*G6_2_0_10_0_3_0_0 + 4.166666666666655e-03*G6_2_0_10_0_3_0_1 + 4.166666666666654e-03*G6_2_0_10_0_3_0_2 - 4.166666666666654e-03*G6_2_0_10_0_3_1_0 - 4.166666666666655e-03*G6_2_0_10_0_3_2_1 - 4.166666666666655e-03*G6_2_0_10_0_3_3_2 + 4.166666666666656e-03*G6_2_0_11_0_0_0_0 + 4.166666666666656e-03*G6_2_0_11_0_0_0_1 + 4.166666666666656e-03*G6_2_0_11_0_0_0_2 - 4.166666666666656e-03*G6_2_0_11_0_0_1_0 - 4.166666666666656e-03*G6_2_0_11_0_0_2_1 - 4.166666666666656e-03*G6_2_0_11_0_0_3_2 + 4.166666666666654e-03*G6_2_0_11_0_1_0_0 + 4.166666666666655e-03*G6_2_0_11_0_1_0_1 + 4.166666666666654e-03*G6_2_0_11_0_1_0_2 - 4.166666666666654e-03*G6_2_0_11_0_1_1_0 - 4.166666666666655e-03*G6_2_0_11_0_1_2_1 - 4.166666666666655e-03*G6_2_0_11_0_1_3_2 + 4.166666666666655e-03*G6_2_0_11_0_2_0_0 + 4.166666666666655e-03*G6_2_0_11_0_2_0_1 + 4.166666666666654e-03*G6_2_0_11_0_2_0_2 - 4.166666666666655e-03*G6_2_0_11_0_2_1_0 - 4.166666666666655e-03*G6_2_0_11_0_2_2_1 - 4.166666666666655e-03*G6_2_0_11_0_2_3_2 + 8.333333333333309e-03*G6_2_0_11_0_3_0_0 + 8.333333333333311e-03*G6_2_0_11_0_3_0_1 + 8.333333333333309e-03*G6_2_0_11_0_3_0_2 - 8.333333333333309e-03*G6_2_0_11_0_3_1_0 - 8.333333333333311e-03*G6_2_0_11_0_3_2_1 - 8.333333333333311e-03*G6_2_0_11_0_3_3_2 + 8.333333333333309e-03*G6_2_1_8_0_4_0_0 + 8.333333333333309e-03*G6_2_1_8_0_4_0_1 + 8.333333333333309e-03*G6_2_1_8_0_4_0_2 - 8.333333333333309e-03*G6_2_1_8_0_4_1_0 - 8.333333333333309e-03*G6_2_1_8_0_4_2_1 - 8.333333333333309e-03*G6_2_1_8_0_4_3_2 + 4.166666666666654e-03*G6_2_1_8_0_5_0_0 + 4.166666666666654e-03*G6_2_1_8_0_5_0_1 + 4.166666666666654e-03*G6_2_1_8_0_5_0_2 - 4.166666666666654e-03*G6_2_1_8_0_5_1_0 - 4.166666666666654e-03*G6_2_1_8_0_5_2_1 - 4.166666666666654e-03*G6_2_1_8_0_5_3_2 + 4.166666666666653e-03*G6_2_1_8_0_6_0_0 + 4.166666666666654e-03*G6_2_1_8_0_6_0_1 + 4.166666666666654e-03*G6_2_1_8_0_6_0_2 - 4.166666666666653e-03*G6_2_1_8_0_6_1_0 - 4.166666666666654e-03*G6_2_1_8_0_6_2_1 - 4.166666666666654e-03*G6_2_1_8_0_6_3_2 + 4.166666666666654e-03*G6_2_1_8_0_7_0_0 + 4.166666666666656e-03*G6_2_1_8_0_7_0_1 + 4.166666666666654e-03*G6_2_1_8_0_7_0_2 - 4.166666666666654e-03*G6_2_1_8_0_7_1_0 - 4.166666666666656e-03*G6_2_1_8_0_7_2_1 - 4.166666666666656e-03*G6_2_1_8_0_7_3_2 + 4.166666666666654e-03*G6_2_1_9_0_4_0_0 + 4.166666666666654e-03*G6_2_1_9_0_4_0_1 + 4.166666666666654e-03*G6_2_1_9_0_4_0_2 - 4.166666666666654e-03*G6_2_1_9_0_4_1_0 - 4.166666666666654e-03*G6_2_1_9_0_4_2_1 - 4.166666666666654e-03*G6_2_1_9_0_4_3_2 + 8.333333333333307e-03*G6_2_1_9_0_5_0_0 + 8.333333333333309e-03*G6_2_1_9_0_5_0_1 + 8.333333333333307e-03*G6_2_1_9_0_5_0_2 - 8.333333333333307e-03*G6_2_1_9_0_5_1_0 - 8.333333333333309e-03*G6_2_1_9_0_5_2_1 - 8.333333333333309e-03*G6_2_1_9_0_5_3_2 + 4.166666666666654e-03*G6_2_1_9_0_6_0_0 + 4.166666666666655e-03*G6_2_1_9_0_6_0_1 + 4.166666666666654e-03*G6_2_1_9_0_6_0_2 - 4.166666666666654e-03*G6_2_1_9_0_6_1_0 - 4.166666666666655e-03*G6_2_1_9_0_6_2_1 - 4.166666666666655e-03*G6_2_1_9_0_6_3_2 + 4.166666666666655e-03*G6_2_1_9_0_7_0_0 + 4.166666666666656e-03*G6_2_1_9_0_7_0_1 + 4.166666666666656e-03*G6_2_1_9_0_7_0_2 - 4.166666666666655e-03*G6_2_1_9_0_7_1_0 - 4.166666666666656e-03*G6_2_1_9_0_7_2_1 - 4.166666666666656e-03*G6_2_1_9_0_7_3_2 + 4.166666666666653e-03*G6_2_1_10_0_4_0_0 + 4.166666666666654e-03*G6_2_1_10_0_4_0_1 + 4.166666666666653e-03*G6_2_1_10_0_4_0_2 - 4.166666666666653e-03*G6_2_1_10_0_4_1_0 - 4.166666666666654e-03*G6_2_1_10_0_4_2_1 - 4.166666666666654e-03*G6_2_1_10_0_4_3_2 + 4.166666666666654e-03*G6_2_1_10_0_5_0_0 + 4.166666666666655e-03*G6_2_1_10_0_5_0_1 + 4.166666666666654e-03*G6_2_1_10_0_5_0_2 - 4.166666666666654e-03*G6_2_1_10_0_5_1_0 - 4.166666666666655e-03*G6_2_1_10_0_5_2_1 - 4.166666666666655e-03*G6_2_1_10_0_5_3_2 + 8.333333333333309e-03*G6_2_1_10_0_6_0_0 + 8.333333333333309e-03*G6_2_1_10_0_6_0_1 + 8.333333333333309e-03*G6_2_1_10_0_6_0_2 - 8.333333333333309e-03*G6_2_1_10_0_6_1_0 - 8.333333333333309e-03*G6_2_1_10_0_6_2_1 - 8.333333333333309e-03*G6_2_1_10_0_6_3_2 + 4.166666666666654e-03*G6_2_1_10_0_7_0_0 + 4.166666666666655e-03*G6_2_1_10_0_7_0_1 + 4.166666666666654e-03*G6_2_1_10_0_7_0_2 - 4.166666666666654e-03*G6_2_1_10_0_7_1_0 - 4.166666666666655e-03*G6_2_1_10_0_7_2_1 - 4.166666666666655e-03*G6_2_1_10_0_7_3_2 + 4.166666666666655e-03*G6_2_1_11_0_4_0_0 + 4.166666666666656e-03*G6_2_1_11_0_4_0_1 + 4.166666666666655e-03*G6_2_1_11_0_4_0_2 - 4.166666666666655e-03*G6_2_1_11_0_4_1_0 - 4.166666666666656e-03*G6_2_1_11_0_4_2_1 - 4.166666666666656e-03*G6_2_1_11_0_4_3_2 + 4.166666666666655e-03*G6_2_1_11_0_5_0_0 + 4.166666666666656e-03*G6_2_1_11_0_5_0_1 + 4.166666666666656e-03*G6_2_1_11_0_5_0_2 - 4.166666666666655e-03*G6_2_1_11_0_5_1_0 - 4.166666666666656e-03*G6_2_1_11_0_5_2_1 - 4.166666666666656e-03*G6_2_1_11_0_5_3_2 + 4.166666666666655e-03*G6_2_1_11_0_6_0_0 + 4.166666666666655e-03*G6_2_1_11_0_6_0_1 + 4.166666666666654e-03*G6_2_1_11_0_6_0_2 - 4.166666666666655e-03*G6_2_1_11_0_6_1_0 - 4.166666666666655e-03*G6_2_1_11_0_6_2_1 - 4.166666666666655e-03*G6_2_1_11_0_6_3_2 + 8.333333333333309e-03*G6_2_1_11_0_7_0_0 + 8.333333333333311e-03*G6_2_1_11_0_7_0_1 + 8.333333333333309e-03*G6_2_1_11_0_7_0_2 - 8.333333333333309e-03*G6_2_1_11_0_7_1_0 - 8.333333333333311e-03*G6_2_1_11_0_7_2_1 - 8.333333333333311e-03*G6_2_1_11_0_7_3_2 + 8.333333333333309e-03*G6_2_2_8_0_8_0_0 + 8.333333333333309e-03*G6_2_2_8_0_8_0_1 + 8.333333333333309e-03*G6_2_2_8_0_8_0_2 - 8.333333333333309e-03*G6_2_2_8_0_8_1_0 - 8.333333333333309e-03*G6_2_2_8_0_8_2_1 - 8.333333333333309e-03*G6_2_2_8_0_8_3_2 + 4.166666666666654e-03*G6_2_2_8_0_9_0_0 + 4.166666666666654e-03*G6_2_2_8_0_9_0_1 + 4.166666666666654e-03*G6_2_2_8_0_9_0_2 - 4.166666666666654e-03*G6_2_2_8_0_9_1_0 - 4.166666666666654e-03*G6_2_2_8_0_9_2_1 - 4.166666666666654e-03*G6_2_2_8_0_9_3_2 + 4.166666666666653e-03*G6_2_2_8_0_10_0_0 + 4.166666666666654e-03*G6_2_2_8_0_10_0_1 + 4.166666666666654e-03*G6_2_2_8_0_10_0_2 - 4.166666666666653e-03*G6_2_2_8_0_10_1_0 - 4.166666666666654e-03*G6_2_2_8_0_10_2_1 - 4.166666666666654e-03*G6_2_2_8_0_10_3_2 + 4.166666666666654e-03*G6_2_2_8_0_11_0_0 + 4.166666666666656e-03*G6_2_2_8_0_11_0_1 + 4.166666666666654e-03*G6_2_2_8_0_11_0_2 - 4.166666666666654e-03*G6_2_2_8_0_11_1_0 - 4.166666666666656e-03*G6_2_2_8_0_11_2_1 - 4.166666666666656e-03*G6_2_2_8_0_11_3_2 + 4.166666666666654e-03*G6_2_2_9_0_8_0_0 + 4.166666666666654e-03*G6_2_2_9_0_8_0_1 + 4.166666666666654e-03*G6_2_2_9_0_8_0_2 - 4.166666666666654e-03*G6_2_2_9_0_8_1_0 - 4.166666666666654e-03*G6_2_2_9_0_8_2_1 - 4.166666666666654e-03*G6_2_2_9_0_8_3_2 + 8.333333333333307e-03*G6_2_2_9_0_9_0_0 + 8.333333333333309e-03*G6_2_2_9_0_9_0_1 + 8.333333333333307e-03*G6_2_2_9_0_9_0_2 - 8.333333333333307e-03*G6_2_2_9_0_9_1_0 - 8.333333333333309e-03*G6_2_2_9_0_9_2_1 - 8.333333333333309e-03*G6_2_2_9_0_9_3_2 + 4.166666666666654e-03*G6_2_2_9_0_10_0_0 + 4.166666666666655e-03*G6_2_2_9_0_10_0_1 + 4.166666666666654e-03*G6_2_2_9_0_10_0_2 - 4.166666666666654e-03*G6_2_2_9_0_10_1_0 - 4.166666666666655e-03*G6_2_2_9_0_10_2_1 - 4.166666666666655e-03*G6_2_2_9_0_10_3_2 + 4.166666666666655e-03*G6_2_2_9_0_11_0_0 + 4.166666666666656e-03*G6_2_2_9_0_11_0_1 + 4.166666666666656e-03*G6_2_2_9_0_11_0_2 - 4.166666666666655e-03*G6_2_2_9_0_11_1_0 - 4.166666666666656e-03*G6_2_2_9_0_11_2_1 - 4.166666666666656e-03*G6_2_2_9_0_11_3_2 + 4.166666666666653e-03*G6_2_2_10_0_8_0_0 + 4.166666666666654e-03*G6_2_2_10_0_8_0_1 + 4.166666666666653e-03*G6_2_2_10_0_8_0_2 - 4.166666666666653e-03*G6_2_2_10_0_8_1_0 - 4.166666666666654e-03*G6_2_2_10_0_8_2_1 - 4.166666666666654e-03*G6_2_2_10_0_8_3_2 + 4.166666666666654e-03*G6_2_2_10_0_9_0_0 + 4.166666666666655e-03*G6_2_2_10_0_9_0_1 + 4.166666666666654e-03*G6_2_2_10_0_9_0_2 - 4.166666666666654e-03*G6_2_2_10_0_9_1_0 - 4.166666666666655e-03*G6_2_2_10_0_9_2_1 - 4.166666666666655e-03*G6_2_2_10_0_9_3_2 + 8.333333333333309e-03*G6_2_2_10_0_10_0_0 + 8.333333333333309e-03*G6_2_2_10_0_10_0_1 + 8.333333333333309e-03*G6_2_2_10_0_10_0_2 - 8.333333333333309e-03*G6_2_2_10_0_10_1_0 - 8.333333333333309e-03*G6_2_2_10_0_10_2_1 - 8.333333333333309e-03*G6_2_2_10_0_10_3_2 + 4.166666666666654e-03*G6_2_2_10_0_11_0_0 + 4.166666666666655e-03*G6_2_2_10_0_11_0_1 + 4.166666666666654e-03*G6_2_2_10_0_11_0_2 - 4.166666666666654e-03*G6_2_2_10_0_11_1_0 - 4.166666666666655e-03*G6_2_2_10_0_11_2_1 - 4.166666666666655e-03*G6_2_2_10_0_11_3_2 + 4.166666666666655e-03*G6_2_2_11_0_8_0_0 + 4.166666666666656e-03*G6_2_2_11_0_8_0_1 + 4.166666666666655e-03*G6_2_2_11_0_8_0_2 - 4.166666666666655e-03*G6_2_2_11_0_8_1_0 - 4.166666666666656e-03*G6_2_2_11_0_8_2_1 - 4.166666666666656e-03*G6_2_2_11_0_8_3_2 + 4.166666666666655e-03*G6_2_2_11_0_9_0_0 + 4.166666666666656e-03*G6_2_2_11_0_9_0_1 + 4.166666666666656e-03*G6_2_2_11_0_9_0_2 - 4.166666666666655e-03*G6_2_2_11_0_9_1_0 - 4.166666666666656e-03*G6_2_2_11_0_9_2_1 - 4.166666666666656e-03*G6_2_2_11_0_9_3_2 + 4.166666666666655e-03*G6_2_2_11_0_10_0_0 + 4.166666666666655e-03*G6_2_2_11_0_10_0_1 + 4.166666666666654e-03*G6_2_2_11_0_10_0_2 - 4.166666666666655e-03*G6_2_2_11_0_10_1_0 - 4.166666666666655e-03*G6_2_2_11_0_10_2_1 - 4.166666666666655e-03*G6_2_2_11_0_10_3_2 + 8.333333333333309e-03*G6_2_2_11_0_11_0_0 + 8.333333333333311e-03*G6_2_2_11_0_11_0_1 + 8.333333333333309e-03*G6_2_2_11_0_11_0_2 - 8.333333333333309e-03*G6_2_2_11_0_11_1_0 - 8.333333333333311e-03*G6_2_2_11_0_11_2_1 - 8.333333333333311e-03*G6_2_2_11_0_11_3_2 + 4.166666666666661e-02*G7_0_0_0_0_0_0 + 4.166666666666662e-02*G7_0_0_0_0_0_1 + 4.166666666666662e-02*G7_0_0_0_0_0_2 - 4.166666666666661e-02*G7_0_0_0_0_1_0 - 4.166666666666662e-02*G7_0_0_0_0_2_1 - 4.166666666666662e-02*G7_0_0_0_0_3_2 + 4.166666666666659e-02*G7_0_0_1_0_0_0 + 4.166666666666660e-02*G7_0_0_1_0_0_1 + 4.166666666666660e-02*G7_0_0_1_0_0_2 - 4.166666666666659e-02*G7_0_0_1_0_1_0 - 4.166666666666660e-02*G7_0_0_1_0_2_1 - 4.166666666666660e-02*G7_0_0_1_0_3_2 + 4.166666666666660e-02*G7_0_0_2_0_0_0 + 4.166666666666661e-02*G7_0_0_2_0_0_1 + 4.166666666666661e-02*G7_0_0_2_0_0_2 - 4.166666666666660e-02*G7_0_0_2_0_1_0 - 4.166666666666661e-02*G7_0_0_2_0_2_1 - 4.166666666666661e-02*G7_0_0_2_0_3_2 + 4.166666666666660e-02*G7_0_0_3_0_0_0 + 4.166666666666661e-02*G7_0_0_3_0_0_1 + 4.166666666666661e-02*G7_0_0_3_0_0_2 - 4.166666666666660e-02*G7_0_0_3_0_1_0 - 4.166666666666661e-02*G7_0_0_3_0_2_1 - 4.166666666666661e-02*G7_0_0_3_0_3_2 + 4.166666666666660e-02*G7_0_1_4_0_0_0 + 4.166666666666661e-02*G7_0_1_4_0_0_1 + 4.166666666666661e-02*G7_0_1_4_0_0_2 - 4.166666666666660e-02*G7_0_1_4_0_1_0 - 4.166666666666661e-02*G7_0_1_4_0_2_1 - 4.166666666666661e-02*G7_0_1_4_0_3_2 + 4.166666666666660e-02*G7_0_1_5_0_0_0 + 4.166666666666661e-02*G7_0_1_5_0_0_1 + 4.166666666666661e-02*G7_0_1_5_0_0_2 - 4.166666666666660e-02*G7_0_1_5_0_1_0 - 4.166666666666661e-02*G7_0_1_5_0_2_1 - 4.166666666666661e-02*G7_0_1_5_0_3_2 + 4.166666666666660e-02*G7_0_1_6_0_0_0 + 4.166666666666661e-02*G7_0_1_6_0_0_1 + 4.166666666666661e-02*G7_0_1_6_0_0_2 - 4.166666666666660e-02*G7_0_1_6_0_1_0 - 4.166666666666661e-02*G7_0_1_6_0_2_1 - 4.166666666666661e-02*G7_0_1_6_0_3_2 + 4.166666666666660e-02*G7_0_1_7_0_0_0 + 4.166666666666661e-02*G7_0_1_7_0_0_1 + 4.166666666666661e-02*G7_0_1_7_0_0_2 - 4.166666666666660e-02*G7_0_1_7_0_1_0 - 4.166666666666661e-02*G7_0_1_7_0_2_1 - 4.166666666666661e-02*G7_0_1_7_0_3_2 + 4.166666666666660e-02*G7_0_2_8_0_0_0 + 4.166666666666661e-02*G7_0_2_8_0_0_1 + 4.166666666666661e-02*G7_0_2_8_0_0_2 - 4.166666666666660e-02*G7_0_2_8_0_1_0 - 4.166666666666661e-02*G7_0_2_8_0_2_1 - 4.166666666666661e-02*G7_0_2_8_0_3_2 + 4.166666666666660e-02*G7_0_2_9_0_0_0 + 4.166666666666661e-02*G7_0_2_9_0_0_1 + 4.166666666666661e-02*G7_0_2_9_0_0_2 - 4.166666666666660e-02*G7_0_2_9_0_1_0 - 4.166666666666661e-02*G7_0_2_9_0_2_1 - 4.166666666666661e-02*G7_0_2_9_0_3_2 + 4.166666666666660e-02*G7_0_2_10_0_0_0 + 4.166666666666661e-02*G7_0_2_10_0_0_1 + 4.166666666666661e-02*G7_0_2_10_0_0_2 - 4.166666666666660e-02*G7_0_2_10_0_1_0 - 4.166666666666661e-02*G7_0_2_10_0_2_1 - 4.166666666666661e-02*G7_0_2_10_0_3_2 + 4.166666666666660e-02*G7_0_2_11_0_0_0 + 4.166666666666661e-02*G7_0_2_11_0_0_1 + 4.166666666666661e-02*G7_0_2_11_0_0_2 - 4.166666666666660e-02*G7_0_2_11_0_1_0 - 4.166666666666661e-02*G7_0_2_11_0_2_1 - 4.166666666666661e-02*G7_0_2_11_0_3_2 + 8.333333333333320e-02*G8_0_0_0_0_0 + 8.333333333333322e-02*G8_0_0_0_0_1 + 8.333333333333320e-02*G8_0_0_0_0_2 - 8.333333333333320e-02*G8_0_0_0_1_0 - 8.333333333333322e-02*G8_0_0_0_2_1 - 8.333333333333322e-02*G8_0_0_0_3_2 + 8.333333333333320e-02*G8_0_1_0_4_0 + 8.333333333333322e-02*G8_0_1_0_4_1 + 8.333333333333322e-02*G8_0_1_0_4_2 - 8.333333333333320e-02*G8_0_1_0_5_0 - 8.333333333333322e-02*G8_0_1_0_6_1 - 8.333333333333322e-02*G8_0_1_0_7_2 + 8.333333333333320e-02*G8_0_2_0_8_0 + 8.333333333333322e-02*G8_0_2_0_8_1 + 8.333333333333322e-02*G8_0_2_0_8_2 - 8.333333333333320e-02*G8_0_2_0_9_0 - 8.333333333333322e-02*G8_0_2_0_10_1 - 8.333333333333322e-02*G8_0_2_0_11_2;
    block[2] = 8.333333333333312e-03*G0_0 + 8.333333333333309e-03*G0_1 + 1.666666666666662e-02*G0_2 + 8.333333333333312e-03*G0_3 + 8.333333333333312e-03*G1_0 + 8.333333333333309e-03*G1_1 + 1.666666666666662e-02*G1_2 + 8.333333333333312e-03*G1_3 + 4.166666666666662e-02*G2_0_1_0 + 4.166666666666662e-02*G2_0_1_1 + 4.166666666666662e-02*G2_0_1_2 + 4.166666666666662e-02*G2_0_1_3 + 1.666666666666662e-02*G3_0_0_1_0 + 8.333333333333311e-03*G3_0_0_1_1 + 8.333333333333312e-03*G3_0_0_1_2 + 8.333333333333314e-03*G3_0_0_1_3 + 8.333333333333311e-03*G3_0_1_1_0 + 1.666666666666662e-02*G3_0_1_1_1 + 8.333333333333309e-03*G3_0_1_1_2 + 8.333333333333311e-03*G3_0_1_1_3 + 8.333333333333312e-03*G3_0_2_1_0 + 8.333333333333309e-03*G3_0_2_1_1 + 1.666666666666662e-02*G3_0_2_1_2 + 8.333333333333312e-03*G3_0_2_1_3 + 8.333333333333314e-03*G3_0_3_1_0 + 8.333333333333311e-03*G3_0_3_1_1 + 8.333333333333312e-03*G3_0_3_1_2 + 1.666666666666662e-02*G3_0_3_1_3 + 1.666666666666662e-02*G3_1_4_1_0 + 8.333333333333309e-03*G3_1_4_1_1 + 8.333333333333309e-03*G3_1_4_1_2 + 8.333333333333314e-03*G3_1_4_1_3 + 8.333333333333311e-03*G3_1_5_1_0 + 1.666666666666662e-02*G3_1_5_1_1 + 8.333333333333312e-03*G3_1_5_1_2 + 8.333333333333314e-03*G3_1_5_1_3 + 8.333333333333312e-03*G3_1_6_1_0 + 8.333333333333309e-03*G3_1_6_1_1 + 1.666666666666662e-02*G3_1_6_1_2 + 8.333333333333312e-03*G3_1_6_1_3 + 8.333333333333314e-03*G3_1_7_1_0 + 8.333333333333311e-03*G3_1_7_1_1 + 8.333333333333312e-03*G3_1_7_1_2 + 1.666666666666662e-02*G3_1_7_1_3 + 1.666666666666662e-02*G3_2_8_1_0 + 8.333333333333309e-03*G3_2_8_1_1 + 8.333333333333309e-03*G3_2_8_1_2 + 8.333333333333314e-03*G3_2_8_1_3 + 8.333333333333311e-03*G3_2_9_1_0 + 1.666666666666662e-02*G3_2_9_1_1 + 8.333333333333312e-03*G3_2_9_1_2 + 8.333333333333314e-03*G3_2_9_1_3 + 8.333333333333312e-03*G3_2_10_1_0 + 8.333333333333309e-03*G3_2_10_1_1 + 1.666666666666662e-02*G3_2_10_1_2 + 8.333333333333312e-03*G3_2_10_1_3 + 8.333333333333314e-03*G3_2_11_1_0 + 8.333333333333311e-03*G3_2_11_1_1 + 8.333333333333312e-03*G3_2_11_1_2 + 1.666666666666662e-02*G3_2_11_1_3 + 8.333333333333322e-02*G4_1_0_0 + 8.333333333333323e-02*G4_1_0_1 + 8.333333333333322e-02*G4_1_0_2 - 8.333333333333322e-02*G4_1_1_0 - 8.333333333333323e-02*G4_1_2_1 - 8.333333333333323e-02*G4_1_3_2 + 4.166666666666654e-03*G5_0_0_0_0 + 4.166666666666656e-03*G5_0_0_0_1 + 4.166666666666655e-03*G5_0_0_0_2 - 4.166666666666654e-03*G5_0_0_1_0 - 4.166666666666656e-03*G5_0_0_2_1 - 4.166666666666656e-03*G5_0_0_3_2 + 4.166666666666654e-03*G5_0_1_0_0 + 4.166666666666654e-03*G5_0_1_0_1 + 4.166666666666654e-03*G5_0_1_0_2 - 4.166666666666654e-03*G5_0_1_1_0 - 4.166666666666654e-03*G5_0_1_2_1 - 4.166666666666654e-03*G5_0_1_3_2 + 8.333333333333311e-03*G5_0_2_0_0 + 8.333333333333311e-03*G5_0_2_0_1 + 8.333333333333311e-03*G5_0_2_0_2 - 8.333333333333311e-03*G5_0_2_1_0 - 8.333333333333311e-03*G5_0_2_2_1 - 8.333333333333311e-03*G5_0_2_3_2 + 4.166666666666655e-03*G5_0_3_0_0 + 4.166666666666656e-03*G5_0_3_0_1 + 4.166666666666655e-03*G5_0_3_0_2 - 4.166666666666655e-03*G5_0_3_1_0 - 4.166666666666656e-03*G5_0_3_2_1 - 4.166666666666656e-03*G5_0_3_3_2 + 4.166666666666654e-03*G5_1_4_0_0 + 4.166666666666654e-03*G5_1_4_0_1 + 4.166666666666654e-03*G5_1_4_0_2 - 4.166666666666654e-03*G5_1_4_1_0 - 4.166666666666654e-03*G5_1_4_2_1 - 4.166666666666654e-03*G5_1_4_3_2 + 4.166666666666655e-03*G5_1_5_0_0 + 4.166666666666656e-03*G5_1_5_0_1 + 4.166666666666654e-03*G5_1_5_0_2 - 4.166666666666655e-03*G5_1_5_1_0 - 4.166666666666656e-03*G5_1_5_2_1 - 4.166666666666656e-03*G5_1_5_3_2 + 8.333333333333311e-03*G5_1_6_0_0 + 8.333333333333311e-03*G5_1_6_0_1 + 8.333333333333311e-03*G5_1_6_0_2 - 8.333333333333311e-03*G5_1_6_1_0 - 8.333333333333311e-03*G5_1_6_2_1 - 8.333333333333311e-03*G5_1_6_3_2 + 4.166666666666655e-03*G5_1_7_0_0 + 4.166666666666656e-03*G5_1_7_0_1 + 4.166666666666655e-03*G5_1_7_0_2 - 4.166666666666655e-03*G5_1_7_1_0 - 4.166666666666656e-03*G5_1_7_2_1 - 4.166666666666656e-03*G5_1_7_3_2 + 4.166666666666654e-03*G5_2_8_0_0 + 4.166666666666654e-03*G5_2_8_0_1 + 4.166666666666654e-03*G5_2_8_0_2 - 4.166666666666654e-03*G5_2_8_1_0 - 4.166666666666654e-03*G5_2_8_2_1 - 4.166666666666654e-03*G5_2_8_3_2 + 4.166666666666655e-03*G5_2_9_0_0 + 4.166666666666656e-03*G5_2_9_0_1 + 4.166666666666654e-03*G5_2_9_0_2 - 4.166666666666655e-03*G5_2_9_1_0 - 4.166666666666656e-03*G5_2_9_2_1 - 4.166666666666656e-03*G5_2_9_3_2 + 8.333333333333311e-03*G5_2_10_0_0 + 8.333333333333311e-03*G5_2_10_0_1 + 8.333333333333311e-03*G5_2_10_0_2 - 8.333333333333311e-03*G5_2_10_1_0 - 8.333333333333311e-03*G5_2_10_2_1 - 8.333333333333311e-03*G5_2_10_3_2 + 4.166666666666655e-03*G5_2_11_0_0 + 4.166666666666656e-03*G5_2_11_0_1 + 4.166666666666655e-03*G5_2_11_0_2 - 4.166666666666655e-03*G5_2_11_1_0 - 4.166666666666656e-03*G5_2_11_2_1 - 4.166666666666656e-03*G5_2_11_3_2 + 8.333333333333309e-03*G6_0_0_0_1_0_0_0 + 8.333333333333311e-03*G6_0_0_0_1_0_0_1 + 8.333333333333311e-03*G6_0_0_0_1_0_0_2 - 8.333333333333309e-03*G6_0_0_0_1_0_1_0 - 8.333333333333311e-03*G6_0_0_0_1_0_2_1 - 8.333333333333311e-03*G6_0_0_0_1_0_3_2 + 4.166666666666654e-03*G6_0_0_0_1_1_0_0 + 4.166666666666655e-03*G6_0_0_0_1_1_0_1 + 4.166666666666654e-03*G6_0_0_0_1_1_0_2 - 4.166666666666654e-03*G6_0_0_0_1_1_1_0 - 4.166666666666655e-03*G6_0_0_0_1_1_2_1 - 4.166666666666655e-03*G6_0_0_0_1_1_3_2 + 4.166666666666654e-03*G6_0_0_0_1_2_0_0 + 4.166666666666656e-03*G6_0_0_0_1_2_0_1 + 4.166666666666655e-03*G6_0_0_0_1_2_0_2 - 4.166666666666654e-03*G6_0_0_0_1_2_1_0 - 4.166666666666656e-03*G6_0_0_0_1_2_2_1 - 4.166666666666656e-03*G6_0_0_0_1_2_3_2 + 4.166666666666656e-03*G6_0_0_0_1_3_0_0 + 4.166666666666657e-03*G6_0_0_0_1_3_0_1 + 4.166666666666657e-03*G6_0_0_0_1_3_0_2 - 4.166666666666656e-03*G6_0_0_0_1_3_1_0 - 4.166666666666657e-03*G6_0_0_0_1_3_2_1 - 4.166666666666657e-03*G6_0_0_0_1_3_3_2 + 4.166666666666654e-03*G6_0_0_1_1_0_0_0 + 4.166666666666655e-03*G6_0_0_1_1_0_0_1 + 4.166666666666654e-03*G6_0_0_1_1_0_0_2 - 4.166666666666654e-03*G6_0_0_1_1_0_1_0 - 4.166666666666655e-03*G6_0_0_1_1_0_2_1 - 4.166666666666655e-03*G6_0_0_1_1_0_3_2 + 8.333333333333307e-03*G6_0_0_1_1_1_0_0 + 8.333333333333309e-03*G6_0_0_1_1_1_0_1 + 8.333333333333307e-03*G6_0_0_1_1_1_0_2 - 8.333333333333307e-03*G6_0_0_1_1_1_1_0 - 8.333333333333309e-03*G6_0_0_1_1_1_2_1 - 8.333333333333309e-03*G6_0_0_1_1_1_3_2 + 4.166666666666654e-03*G6_0_0_1_1_2_0_0 + 4.166666666666654e-03*G6_0_0_1_1_2_0_1 + 4.166666666666654e-03*G6_0_0_1_1_2_0_2 - 4.166666666666654e-03*G6_0_0_1_1_2_1_0 - 4.166666666666654e-03*G6_0_0_1_1_2_2_1 - 4.166666666666654e-03*G6_0_0_1_1_2_3_2 + 4.166666666666655e-03*G6_0_0_1_1_3_0_0 + 4.166666666666655e-03*G6_0_0_1_1_3_0_1 + 4.166666666666655e-03*G6_0_0_1_1_3_0_2 - 4.166666666666655e-03*G6_0_0_1_1_3_1_0 - 4.166666666666655e-03*G6_0_0_1_1_3_2_1 - 4.166666666666655e-03*G6_0_0_1_1_3_3_2 + 4.166666666666654e-03*G6_0_0_2_1_0_0_0 + 4.166666666666656e-03*G6_0_0_2_1_0_0_1 + 4.166666666666655e-03*G6_0_0_2_1_0_0_2 - 4.166666666666654e-03*G6_0_0_2_1_0_1_0 - 4.166666666666656e-03*G6_0_0_2_1_0_2_1 - 4.166666666666656e-03*G6_0_0_2_1_0_3_2 + 4.166666666666654e-03*G6_0_0_2_1_1_0_0 + 4.166666666666654e-03*G6_0_0_2_1_1_0_1 + 4.166666666666654e-03*G6_0_0_2_1_1_0_2 - 4.166666666666654e-03*G6_0_0_2_1_1_1_0 - 4.166666666666654e-03*G6_0_0_2_1_1_2_1 - 4.166666666666654e-03*G6_0_0_2_1_1_3_2 + 8.333333333333311e-03*G6_0_0_2_1_2_0_0 + 8.333333333333311e-03*G6_0_0_2_1_2_0_1 + 8.333333333333311e-03*G6_0_0_2_1_2_0_2 - 8.333333333333311e-03*G6_0_0_2_1_2_1_0 - 8.333333333333311e-03*G6_0_0_2_1_2_2_1 - 8.333333333333311e-03*G6_0_0_2_1_2_3_2 + 4.166666666666655e-03*G6_0_0_2_1_3_0_0 + 4.166666666666656e-03*G6_0_0_2_1_3_0_1 + 4.166666666666655e-03*G6_0_0_2_1_3_0_2 - 4.166666666666655e-03*G6_0_0_2_1_3_1_0 - 4.166666666666656e-03*G6_0_0_2_1_3_2_1 - 4.166666666666656e-03*G6_0_0_2_1_3_3_2 + 4.166666666666656e-03*G6_0_0_3_1_0_0_0 + 4.166666666666657e-03*G6_0_0_3_1_0_0_1 + 4.166666666666657e-03*G6_0_0_3_1_0_0_2 - 4.166666666666656e-03*G6_0_0_3_1_0_1_0 - 4.166666666666657e-03*G6_0_0_3_1_0_2_1 - 4.166666666666657e-03*G6_0_0_3_1_0_3_2 + 4.166666666666655e-03*G6_0_0_3_1_1_0_0 + 4.166666666666655e-03*G6_0_0_3_1_1_0_1 + 4.166666666666655e-03*G6_0_0_3_1_1_0_2 - 4.166666666666655e-03*G6_0_0_3_1_1_1_0 - 4.166666666666655e-03*G6_0_0_3_1_1_2_1 - 4.166666666666655e-03*G6_0_0_3_1_1_3_2 + 4.166666666666655e-03*G6_0_0_3_1_2_0_0 + 4.166666666666656e-03*G6_0_0_3_1_2_0_1 + 4.166666666666655e-03*G6_0_0_3_1_2_0_2 - 4.166666666666655e-03*G6_0_0_3_1_2_1_0 - 4.166666666666656e-03*G6_0_0_3_1_2_2_1 - 4.166666666666656e-03*G6_0_0_3_1_2_3_2 + 8.333333333333311e-03*G6_0_0_3_1_3_0_0 + 8.333333333333311e-03*G6_0_0_3_1_3_0_1 + 8.333333333333311e-03*G6_0_0_3_1_3_0_2 - 8.333333333333311e-03*G6_0_0_3_1_3_1_0 - 8.333333333333311e-03*G6_0_0_3_1_3_2_1 - 8.333333333333311e-03*G6_0_0_3_1_3_3_2 + 8.333333333333309e-03*G6_0_1_0_1_4_0_0 + 8.333333333333311e-03*G6_0_1_0_1_4_0_1 + 8.333333333333311e-03*G6_0_1_0_1_4_0_2 - 8.333333333333309e-03*G6_0_1_0_1_4_1_0 - 8.333333333333311e-03*G6_0_1_0_1_4_2_1 - 8.333333333333311e-03*G6_0_1_0_1_4_3_2 + 4.166666666666655e-03*G6_0_1_0_1_5_0_0 + 4.166666666666655e-03*G6_0_1_0_1_5_0_1 + 4.166666666666655e-03*G6_0_1_0_1_5_0_2 - 4.166666666666655e-03*G6_0_1_0_1_5_1_0 - 4.166666666666655e-03*G6_0_1_0_1_5_2_1 - 4.166666666666655e-03*G6_0_1_0_1_5_3_2 + 4.166666666666654e-03*G6_0_1_0_1_6_0_0 + 4.166666666666656e-03*G6_0_1_0_1_6_0_1 + 4.166666666666655e-03*G6_0_1_0_1_6_0_2 - 4.166666666666654e-03*G6_0_1_0_1_6_1_0 - 4.166666666666656e-03*G6_0_1_0_1_6_2_1 - 4.166666666666656e-03*G6_0_1_0_1_6_3_2 + 4.166666666666656e-03*G6_0_1_0_1_7_0_0 + 4.166666666666657e-03*G6_0_1_0_1_7_0_1 + 4.166666666666657e-03*G6_0_1_0_1_7_0_2 - 4.166666666666656e-03*G6_0_1_0_1_7_1_0 - 4.166666666666657e-03*G6_0_1_0_1_7_2_1 - 4.166666666666657e-03*G6_0_1_0_1_7_3_2 + 4.166666666666654e-03*G6_0_1_1_1_4_0_0 + 4.166666666666654e-03*G6_0_1_1_1_4_0_1 + 4.166666666666654e-03*G6_0_1_1_1_4_0_2 - 4.166666666666654e-03*G6_0_1_1_1_4_1_0 - 4.166666666666654e-03*G6_0_1_1_1_4_2_1 - 4.166666666666654e-03*G6_0_1_1_1_4_3_2 + 8.333333333333309e-03*G6_0_1_1_1_5_0_0 + 8.333333333333309e-03*G6_0_1_1_1_5_0_1 + 8.333333333333307e-03*G6_0_1_1_1_5_0_2 - 8.333333333333309e-03*G6_0_1_1_1_5_1_0 - 8.333333333333309e-03*G6_0_1_1_1_5_2_1 - 8.333333333333309e-03*G6_0_1_1_1_5_3_2 + 4.166666666666654e-03*G6_0_1_1_1_6_0_0 + 4.166666666666654e-03*G6_0_1_1_1_6_0_1 + 4.166666666666654e-03*G6_0_1_1_1_6_0_2 - 4.166666666666654e-03*G6_0_1_1_1_6_1_0 - 4.166666666666654e-03*G6_0_1_1_1_6_2_1 - 4.166666666666654e-03*G6_0_1_1_1_6_3_2 + 4.166666666666655e-03*G6_0_1_1_1_7_0_0 + 4.166666666666655e-03*G6_0_1_1_1_7_0_1 + 4.166666666666655e-03*G6_0_1_1_1_7_0_2 - 4.166666666666655e-03*G6_0_1_1_1_7_1_0 - 4.166666666666655e-03*G6_0_1_1_1_7_2_1 - 4.166666666666655e-03*G6_0_1_1_1_7_3_2 + 4.166666666666654e-03*G6_0_1_2_1_4_0_0 + 4.166666666666654e-03*G6_0_1_2_1_4_0_1 + 4.166666666666654e-03*G6_0_1_2_1_4_0_2 - 4.166666666666654e-03*G6_0_1_2_1_4_1_0 - 4.166666666666654e-03*G6_0_1_2_1_4_2_1 - 4.166666666666654e-03*G6_0_1_2_1_4_3_2 + 4.166666666666655e-03*G6_0_1_2_1_5_0_0 + 4.166666666666656e-03*G6_0_1_2_1_5_0_1 + 4.166666666666654e-03*G6_0_1_2_1_5_0_2 - 4.166666666666655e-03*G6_0_1_2_1_5_1_0 - 4.166666666666656e-03*G6_0_1_2_1_5_2_1 - 4.166666666666656e-03*G6_0_1_2_1_5_3_2 + 8.333333333333311e-03*G6_0_1_2_1_6_0_0 + 8.333333333333311e-03*G6_0_1_2_1_6_0_1 + 8.333333333333311e-03*G6_0_1_2_1_6_0_2 - 8.333333333333311e-03*G6_0_1_2_1_6_1_0 - 8.333333333333311e-03*G6_0_1_2_1_6_2_1 - 8.333333333333311e-03*G6_0_1_2_1_6_3_2 + 4.166666666666655e-03*G6_0_1_2_1_7_0_0 + 4.166666666666656e-03*G6_0_1_2_1_7_0_1 + 4.166666666666655e-03*G6_0_1_2_1_7_0_2 - 4.166666666666655e-03*G6_0_1_2_1_7_1_0 - 4.166666666666656e-03*G6_0_1_2_1_7_2_1 - 4.166666666666656e-03*G6_0_1_2_1_7_3_2 + 4.166666666666656e-03*G6_0_1_3_1_4_0_0 + 4.166666666666657e-03*G6_0_1_3_1_4_0_1 + 4.166666666666657e-03*G6_0_1_3_1_4_0_2 - 4.166666666666656e-03*G6_0_1_3_1_4_1_0 - 4.166666666666657e-03*G6_0_1_3_1_4_2_1 - 4.166666666666657e-03*G6_0_1_3_1_4_3_2 + 4.166666666666656e-03*G6_0_1_3_1_5_0_0 + 4.166666666666657e-03*G6_0_1_3_1_5_0_1 + 4.166666666666656e-03*G6_0_1_3_1_5_0_2 - 4.166666666666656e-03*G6_0_1_3_1_5_1_0 - 4.166666666666657e-03*G6_0_1_3_1_5_2_1 - 4.166666666666657e-03*G6_0_1_3_1_5_3_2 + 4.166666666666655e-03*G6_0_1_3_1_6_0_0 + 4.166666666666656e-03*G6_0_1_3_1_6_0_1 + 4.166666666666655e-03*G6_0_1_3_1_6_0_2 - 4.166666666666655e-03*G6_0_1_3_1_6_1_0 - 4.166666666666656e-03*G6_0_1_3_1_6_2_1 - 4.166666666666656e-03*G6_0_1_3_1_6_3_2 + 8.333333333333311e-03*G6_0_1_3_1_7_0_0 + 8.333333333333311e-03*G6_0_1_3_1_7_0_1 + 8.333333333333311e-03*G6_0_1_3_1_7_0_2 - 8.333333333333311e-03*G6_0_1_3_1_7_1_0 - 8.333333333333311e-03*G6_0_1_3_1_7_2_1 - 8.333333333333311e-03*G6_0_1_3_1_7_3_2 + 8.333333333333309e-03*G6_0_2_0_1_8_0_0 + 8.333333333333311e-03*G6_0_2_0_1_8_0_1 + 8.333333333333311e-03*G6_0_2_0_1_8_0_2 - 8.333333333333309e-03*G6_0_2_0_1_8_1_0 - 8.333333333333311e-03*G6_0_2_0_1_8_2_1 - 8.333333333333311e-03*G6_0_2_0_1_8_3_2 + 4.166666666666655e-03*G6_0_2_0_1_9_0_0 + 4.166666666666655e-03*G6_0_2_0_1_9_0_1 + 4.166666666666655e-03*G6_0_2_0_1_9_0_2 - 4.166666666666655e-03*G6_0_2_0_1_9_1_0 - 4.166666666666655e-03*G6_0_2_0_1_9_2_1 - 4.166666666666655e-03*G6_0_2_0_1_9_3_2 + 4.166666666666654e-03*G6_0_2_0_1_10_0_0 + 4.166666666666656e-03*G6_0_2_0_1_10_0_1 + 4.166666666666655e-03*G6_0_2_0_1_10_0_2 - 4.166666666666654e-03*G6_0_2_0_1_10_1_0 - 4.166666666666656e-03*G6_0_2_0_1_10_2_1 - 4.166666666666656e-03*G6_0_2_0_1_10_3_2 + 4.166666666666656e-03*G6_0_2_0_1_11_0_0 + 4.166666666666657e-03*G6_0_2_0_1_11_0_1 + 4.166666666666657e-03*G6_0_2_0_1_11_0_2 - 4.166666666666656e-03*G6_0_2_0_1_11_1_0 - 4.166666666666657e-03*G6_0_2_0_1_11_2_1 - 4.166666666666657e-03*G6_0_2_0_1_11_3_2 + 4.166666666666654e-03*G6_0_2_1_1_8_0_0 + 4.166666666666654e-03*G6_0_2_1_1_8_0_1 + 4.166666666666654e-03*G6_0_2_1_1_8_0_2 - 4.166666666666654e-03*G6_0_2_1_1_8_1_0 - 4.166666666666654e-03*G6_0_2_1_1_8_2_1 - 4.166666666666654e-03*G6_0_2_1_1_8_3_2 + 8.333333333333309e-03*G6_0_2_1_1_9_0_0 + 8.333333333333309e-03*G6_0_2_1_1_9_0_1 + 8.333333333333307e-03*G6_0_2_1_1_9_0_2 - 8.333333333333309e-03*G6_0_2_1_1_9_1_0 - 8.333333333333309e-03*G6_0_2_1_1_9_2_1 - 8.333333333333309e-03*G6_0_2_1_1_9_3_2 + 4.166666666666654e-03*G6_0_2_1_1_10_0_0 + 4.166666666666654e-03*G6_0_2_1_1_10_0_1 + 4.166666666666654e-03*G6_0_2_1_1_10_0_2 - 4.166666666666654e-03*G6_0_2_1_1_10_1_0 - 4.166666666666654e-03*G6_0_2_1_1_10_2_1 - 4.166666666666654e-03*G6_0_2_1_1_10_3_2 + 4.166666666666655e-03*G6_0_2_1_1_11_0_0 + 4.166666666666655e-03*G6_0_2_1_1_11_0_1 + 4.166666666666655e-03*G6_0_2_1_1_11_0_2 - 4.166666666666655e-03*G6_0_2_1_1_11_1_0 - 4.166666666666655e-03*G6_0_2_1_1_11_2_1 - 4.166666666666655e-03*G6_0_2_1_1_11_3_2 + 4.166666666666654e-03*G6_0_2_2_1_8_0_0 + 4.166666666666654e-03*G6_0_2_2_1_8_0_1 + 4.166666666666654e-03*G6_0_2_2_1_8_0_2 - 4.166666666666654e-03*G6_0_2_2_1_8_1_0 - 4.166666666666654e-03*G6_0_2_2_1_8_2_1 - 4.166666666666654e-03*G6_0_2_2_1_8_3_2 + 4.166666666666655e-03*G6_0_2_2_1_9_0_0 + 4.166666666666656e-03*G6_0_2_2_1_9_0_1 + 4.166666666666654e-03*G6_0_2_2_1_9_0_2 - 4.166666666666655e-03*G6_0_2_2_1_9_1_0 - 4.166666666666656e-03*G6_0_2_2_1_9_2_1 - 4.166666666666656e-03*G6_0_2_2_1_9_3_2 + 8.333333333333311e-03*G6_0_2_2_1_10_0_0 + 8.333333333333311e-03*G6_0_2_2_1_10_0_1 + 8.333333333333311e-03*G6_0_2_2_1_10_0_2 - 8.333333333333311e-03*G6_0_2_2_1_10_1_0 - 8.333333333333311e-03*G6_0_2_2_1_10_2_1 - 8.333333333333311e-03*G6_0_2_2_1_10_3_2 + 4.166666666666655e-03*G6_0_2_2_1_11_0_0 + 4.166666666666656e-03*G6_0_2_2_1_11_0_1 + 4.166666666666655e-03*G6_0_2_2_1_11_0_2 - 4.166666666666655e-03*G6_0_2_2_1_11_1_0 - 4.166666666666656e-03*G6_0_2_2_1_11_2_1 - 4.166666666666656e-03*G6_0_2_2_1_11_3_2 + 4.166666666666656e-03*G6_0_2_3_1_8_0_0 + 4.166666666666657e-03*G6_0_2_3_1_8_0_1 + 4.166666666666657e-03*G6_0_2_3_1_8_0_2 - 4.166666666666656e-03*G6_0_2_3_1_8_1_0 - 4.166666666666657e-03*G6_0_2_3_1_8_2_1 - 4.166666666666657e-03*G6_0_2_3_1_8_3_2 + 4.166666666666656e-03*G6_0_2_3_1_9_0_0 + 4.166666666666657e-03*G6_0_2_3_1_9_0_1 + 4.166666666666656e-03*G6_0_2_3_1_9_0_2 - 4.166666666666656e-03*G6_0_2_3_1_9_1_0 - 4.166666666666657e-03*G6_0_2_3_1_9_2_1 - 4.166666666666657e-03*G6_0_2_3_1_9_3_2 + 4.166666666666655e-03*G6_0_2_3_1_10_0_0 + 4.166666666666656e-03*G6_0_2_3_1_10_0_1 + 4.166666666666655e-03*G6_0_2_3_1_10_0_2 - 4.166666666666655e-03*G6_0_2_3_1_10_1_0 - 4.166666666666656e-03*G6_0_2_3_1_10_2_1 - 4.166666666666656e-03*G6_0_2_3_1_10_3_2 + 8.333333333333311e-03*G6_0_2_3_1_11_0_0 + 8.333333333333311e-03*G6_0_2_3_1_11_0_1 + 8.333333333333311e-03*G6_0_2_3_1_11_0_2 - 8.333333333333311e-03*G6_0_2_3_1_11_1_0 - 8.333333333333311e-03*G6_0_2_3_1_11_2_1 - 8.333333333333311e-03*G6_0_2_3_1_11_3_2 + 8.333333333333309e-03*G6_1_0_4_1_0_0_0 + 8.333333333333311e-03*G6_1_0_4_1_0_0_1 + 8.333333333333311e-03*G6_1_0_4_1_0_0_2 - 8.333333333333309e-03*G6_1_0_4_1_0_1_0 - 8.333333333333311e-03*G6_1_0_4_1_0_2_1 - 8.333333333333311e-03*G6_1_0_4_1_0_3_2 + 4.166666666666654e-03*G6_1_0_4_1_1_0_0 + 4.166666666666654e-03*G6_1_0_4_1_1_0_1 + 4.166666666666654e-03*G6_1_0_4_1_1_0_2 - 4.166666666666654e-03*G6_1_0_4_1_1_1_0 - 4.166666666666654e-03*G6_1_0_4_1_1_2_1 - 4.166666666666654e-03*G6_1_0_4_1_1_3_2 + 4.166666666666654e-03*G6_1_0_4_1_2_0_0 + 4.166666666666654e-03*G6_1_0_4_1_2_0_1 + 4.166666666666654e-03*G6_1_0_4_1_2_0_2 - 4.166666666666654e-03*G6_1_0_4_1_2_1_0 - 4.166666666666654e-03*G6_1_0_4_1_2_2_1 - 4.166666666666654e-03*G6_1_0_4_1_2_3_2 + 4.166666666666656e-03*G6_1_0_4_1_3_0_0 + 4.166666666666657e-03*G6_1_0_4_1_3_0_1 + 4.166666666666657e-03*G6_1_0_4_1_3_0_2 - 4.166666666666656e-03*G6_1_0_4_1_3_1_0 - 4.166666666666657e-03*G6_1_0_4_1_3_2_1 - 4.166666666666657e-03*G6_1_0_4_1_3_3_2 + 4.166666666666655e-03*G6_1_0_5_1_0_0_0 + 4.166666666666655e-03*G6_1_0_5_1_0_0_1 + 4.166666666666655e-03*G6_1_0_5_1_0_0_2 - 4.166666666666655e-03*G6_1_0_5_1_0_1_0 - 4.166666666666655e-03*G6_1_0_5_1_0_2_1 - 4.166666666666655e-03*G6_1_0_5_1_0_3_2 + 8.333333333333309e-03*G6_1_0_5_1_1_0_0 + 8.333333333333309e-03*G6_1_0_5_1_1_0_1 + 8.333333333333307e-03*G6_1_0_5_1_1_0_2 - 8.333333333333309e-03*G6_1_0_5_1_1_1_0 - 8.333333333333309e-03*G6_1_0_5_1_1_2_1 - 8.333333333333309e-03*G6_1_0_5_1_1_3_2 + 4.166666666666655e-03*G6_1_0_5_1_2_0_0 + 4.166666666666656e-03*G6_1_0_5_1_2_0_1 + 4.166666666666654e-03*G6_1_0_5_1_2_0_2 - 4.166666666666655e-03*G6_1_0_5_1_2_1_0 - 4.166666666666656e-03*G6_1_0_5_1_2_2_1 - 4.166666666666656e-03*G6_1_0_5_1_2_3_2 + 4.166666666666656e-03*G6_1_0_5_1_3_0_0 + 4.166666666666657e-03*G6_1_0_5_1_3_0_1 + 4.166666666666656e-03*G6_1_0_5_1_3_0_2 - 4.166666666666656e-03*G6_1_0_5_1_3_1_0 - 4.166666666666657e-03*G6_1_0_5_1_3_2_1 - 4.166666666666657e-03*G6_1_0_5_1_3_3_2 + 4.166666666666654e-03*G6_1_0_6_1_0_0_0 + 4.166666666666656e-03*G6_1_0_6_1_0_0_1 + 4.166666666666655e-03*G6_1_0_6_1_0_0_2 - 4.166666666666654e-03*G6_1_0_6_1_0_1_0 - 4.166666666666656e-03*G6_1_0_6_1_0_2_1 - 4.166666666666656e-03*G6_1_0_6_1_0_3_2 + 4.166666666666654e-03*G6_1_0_6_1_1_0_0 + 4.166666666666654e-03*G6_1_0_6_1_1_0_1 + 4.166666666666654e-03*G6_1_0_6_1_1_0_2 - 4.166666666666654e-03*G6_1_0_6_1_1_1_0 - 4.166666666666654e-03*G6_1_0_6_1_1_2_1 - 4.166666666666654e-03*G6_1_0_6_1_1_3_2 + 8.333333333333311e-03*G6_1_0_6_1_2_0_0 + 8.333333333333311e-03*G6_1_0_6_1_2_0_1 + 8.333333333333311e-03*G6_1_0_6_1_2_0_2 - 8.333333333333311e-03*G6_1_0_6_1_2_1_0 - 8.333333333333311e-03*G6_1_0_6_1_2_2_1 - 8.333333333333311e-03*G6_1_0_6_1_2_3_2 + 4.166666666666655e-03*G6_1_0_6_1_3_0_0 + 4.166666666666656e-03*G6_1_0_6_1_3_0_1 + 4.166666666666655e-03*G6_1_0_6_1_3_0_2 - 4.166666666666655e-03*G6_1_0_6_1_3_1_0 - 4.166666666666656e-03*G6_1_0_6_1_3_2_1 - 4.166666666666656e-03*G6_1_0_6_1_3_3_2 + 4.166666666666656e-03*G6_1_0_7_1_0_0_0 + 4.166666666666657e-03*G6_1_0_7_1_0_0_1 + 4.166666666666657e-03*G6_1_0_7_1_0_0_2 - 4.166666666666656e-03*G6_1_0_7_1_0_1_0 - 4.166666666666657e-03*G6_1_0_7_1_0_2_1 - 4.166666666666657e-03*G6_1_0_7_1_0_3_2 + 4.166666666666655e-03*G6_1_0_7_1_1_0_0 + 4.166666666666655e-03*G6_1_0_7_1_1_0_1 + 4.166666666666655e-03*G6_1_0_7_1_1_0_2 - 4.166666666666655e-03*G6_1_0_7_1_1_1_0 - 4.166666666666655e-03*G6_1_0_7_1_1_2_1 - 4.166666666666655e-03*G6_1_0_7_1_1_3_2 + 4.166666666666655e-03*G6_1_0_7_1_2_0_0 + 4.166666666666656e-03*G6_1_0_7_1_2_0_1 + 4.166666666666655e-03*G6_1_0_7_1_2_0_2 - 4.166666666666655e-03*G6_1_0_7_1_2_1_0 - 4.166666666666656e-03*G6_1_0_7_1_2_2_1 - 4.166666666666656e-03*G6_1_0_7_1_2_3_2 + 8.333333333333311e-03*G6_1_0_7_1_3_0_0 + 8.333333333333311e-03*G6_1_0_7_1_3_0_1 + 8.333333333333311e-03*G6_1_0_7_1_3_0_2 - 8.333333333333311e-03*G6_1_0_7_1_3_1_0 - 8.333333333333311e-03*G6_1_0_7_1_3_2_1 - 8.333333333333311e-03*G6_1_0_7_1_3_3_2 + 8.333333333333309e-03*G6_1_1_4_1_4_0_0 + 8.333333333333311e-03*G6_1_1_4_1_4_0_1 + 8.333333333333311e-03*G6_1_1_4_1_4_0_2 - 8.333333333333309e-03*G6_1_1_4_1_4_1_0 - 8.333333333333311e-03*G6_1_1_4_1_4_2_1 - 8.333333333333311e-03*G6_1_1_4_1_4_3_2 + 4.166666666666654e-03*G6_1_1_4_1_5_0_0 + 4.166666666666654e-03*G6_1_1_4_1_5_0_1 + 4.166666666666654e-03*G6_1_1_4_1_5_0_2 - 4.166666666666654e-03*G6_1_1_4_1_5_1_0 - 4.166666666666654e-03*G6_1_1_4_1_5_2_1 - 4.166666666666654e-03*G6_1_1_4_1_5_3_2 + 4.166666666666654e-03*G6_1_1_4_1_6_0_0 + 4.166666666666654e-03*G6_1_1_4_1_6_0_1 + 4.166666666666654e-03*G6_1_1_4_1_6_0_2 - 4.166666666666654e-03*G6_1_1_4_1_6_1_0 - 4.166666666666654e-03*G6_1_1_4_1_6_2_1 - 4.166666666666654e-03*G6_1_1_4_1_6_3_2 + 4.166666666666656e-03*G6_1_1_4_1_7_0_0 + 4.166666666666657e-03*G6_1_1_4_1_7_0_1 + 4.166666666666657e-03*G6_1_1_4_1_7_0_2 - 4.166666666666656e-03*G6_1_1_4_1_7_1_0 - 4.166666666666657e-03*G6_1_1_4_1_7_2_1 - 4.166666666666657e-03*G6_1_1_4_1_7_3_2 + 4.166666666666654e-03*G6_1_1_5_1_4_0_0 + 4.166666666666654e-03*G6_1_1_5_1_4_0_1 + 4.166666666666654e-03*G6_1_1_5_1_4_0_2 - 4.166666666666654e-03*G6_1_1_5_1_4_1_0 - 4.166666666666654e-03*G6_1_1_5_1_4_2_1 - 4.166666666666654e-03*G6_1_1_5_1_4_3_2 + 8.333333333333309e-03*G6_1_1_5_1_5_0_0 + 8.333333333333309e-03*G6_1_1_5_1_5_0_1 + 8.333333333333307e-03*G6_1_1_5_1_5_0_2 - 8.333333333333309e-03*G6_1_1_5_1_5_1_0 - 8.333333333333309e-03*G6_1_1_5_1_5_2_1 - 8.333333333333309e-03*G6_1_1_5_1_5_3_2 + 4.166666666666655e-03*G6_1_1_5_1_6_0_0 + 4.166666666666656e-03*G6_1_1_5_1_6_0_1 + 4.166666666666654e-03*G6_1_1_5_1_6_0_2 - 4.166666666666655e-03*G6_1_1_5_1_6_1_0 - 4.166666666666656e-03*G6_1_1_5_1_6_2_1 - 4.166666666666656e-03*G6_1_1_5_1_6_3_2 + 4.166666666666656e-03*G6_1_1_5_1_7_0_0 + 4.166666666666657e-03*G6_1_1_5_1_7_0_1 + 4.166666666666656e-03*G6_1_1_5_1_7_0_2 - 4.166666666666656e-03*G6_1_1_5_1_7_1_0 - 4.166666666666657e-03*G6_1_1_5_1_7_2_1 - 4.166666666666657e-03*G6_1_1_5_1_7_3_2 + 4.166666666666654e-03*G6_1_1_6_1_4_0_0 + 4.166666666666654e-03*G6_1_1_6_1_4_0_1 + 4.166666666666654e-03*G6_1_1_6_1_4_0_2 - 4.166666666666654e-03*G6_1_1_6_1_4_1_0 - 4.166666666666654e-03*G6_1_1_6_1_4_2_1 - 4.166666666666654e-03*G6_1_1_6_1_4_3_2 + 4.166666666666655e-03*G6_1_1_6_1_5_0_0 + 4.166666666666656e-03*G6_1_1_6_1_5_0_1 + 4.166666666666654e-03*G6_1_1_6_1_5_0_2 - 4.166666666666655e-03*G6_1_1_6_1_5_1_0 - 4.166666666666656e-03*G6_1_1_6_1_5_2_1 - 4.166666666666656e-03*G6_1_1_6_1_5_3_2 + 8.333333333333311e-03*G6_1_1_6_1_6_0_0 + 8.333333333333311e-03*G6_1_1_6_1_6_0_1 + 8.333333333333311e-03*G6_1_1_6_1_6_0_2 - 8.333333333333311e-03*G6_1_1_6_1_6_1_0 - 8.333333333333311e-03*G6_1_1_6_1_6_2_1 - 8.333333333333311e-03*G6_1_1_6_1_6_3_2 + 4.166666666666655e-03*G6_1_1_6_1_7_0_0 + 4.166666666666656e-03*G6_1_1_6_1_7_0_1 + 4.166666666666655e-03*G6_1_1_6_1_7_0_2 - 4.166666666666655e-03*G6_1_1_6_1_7_1_0 - 4.166666666666656e-03*G6_1_1_6_1_7_2_1 - 4.166666666666656e-03*G6_1_1_6_1_7_3_2 + 4.166666666666656e-03*G6_1_1_7_1_4_0_0 + 4.166666666666657e-03*G6_1_1_7_1_4_0_1 + 4.166666666666657e-03*G6_1_1_7_1_4_0_2 - 4.166666666666656e-03*G6_1_1_7_1_4_1_0 - 4.166666666666657e-03*G6_1_1_7_1_4_2_1 - 4.166666666666657e-03*G6_1_1_7_1_4_3_2 + 4.166666666666656e-03*G6_1_1_7_1_5_0_0 + 4.166666666666657e-03*G6_1_1_7_1_5_0_1 + 4.166666666666656e-03*G6_1_1_7_1_5_0_2 - 4.166666666666656e-03*G6_1_1_7_1_5_1_0 - 4.166666666666657e-03*G6_1_1_7_1_5_2_1 - 4.166666666666657e-03*G6_1_1_7_1_5_3_2 + 4.166666666666655e-03*G6_1_1_7_1_6_0_0 + 4.166666666666656e-03*G6_1_1_7_1_6_0_1 + 4.166666666666655e-03*G6_1_1_7_1_6_0_2 - 4.166666666666655e-03*G6_1_1_7_1_6_1_0 - 4.166666666666656e-03*G6_1_1_7_1_6_2_1 - 4.166666666666656e-03*G6_1_1_7_1_6_3_2 + 8.333333333333311e-03*G6_1_1_7_1_7_0_0 + 8.333333333333311e-03*G6_1_1_7_1_7_0_1 + 8.333333333333311e-03*G6_1_1_7_1_7_0_2 - 8.333333333333311e-03*G6_1_1_7_1_7_1_0 - 8.333333333333311e-03*G6_1_1_7_1_7_2_1 - 8.333333333333311e-03*G6_1_1_7_1_7_3_2 + 8.333333333333309e-03*G6_1_2_4_1_8_0_0 + 8.333333333333311e-03*G6_1_2_4_1_8_0_1 + 8.333333333333311e-03*G6_1_2_4_1_8_0_2 - 8.333333333333309e-03*G6_1_2_4_1_8_1_0 - 8.333333333333311e-03*G6_1_2_4_1_8_2_1 - 8.333333333333311e-03*G6_1_2_4_1_8_3_2 + 4.166666666666654e-03*G6_1_2_4_1_9_0_0 + 4.166666666666654e-03*G6_1_2_4_1_9_0_1 + 4.166666666666654e-03*G6_1_2_4_1_9_0_2 - 4.166666666666654e-03*G6_1_2_4_1_9_1_0 - 4.166666666666654e-03*G6_1_2_4_1_9_2_1 - 4.166666666666654e-03*G6_1_2_4_1_9_3_2 + 4.166666666666654e-03*G6_1_2_4_1_10_0_0 + 4.166666666666654e-03*G6_1_2_4_1_10_0_1 + 4.166666666666654e-03*G6_1_2_4_1_10_0_2 - 4.166666666666654e-03*G6_1_2_4_1_10_1_0 - 4.166666666666654e-03*G6_1_2_4_1_10_2_1 - 4.166666666666654e-03*G6_1_2_4_1_10_3_2 + 4.166666666666656e-03*G6_1_2_4_1_11_0_0 + 4.166666666666657e-03*G6_1_2_4_1_11_0_1 + 4.166666666666657e-03*G6_1_2_4_1_11_0_2 - 4.166666666666656e-03*G6_1_2_4_1_11_1_0 - 4.166666666666657e-03*G6_1_2_4_1_11_2_1 - 4.166666666666657e-03*G6_1_2_4_1_11_3_2 + 4.166666666666654e-03*G6_1_2_5_1_8_0_0 + 4.166666666666654e-03*G6_1_2_5_1_8_0_1 + 4.166666666666654e-03*G6_1_2_5_1_8_0_2 - 4.166666666666654e-03*G6_1_2_5_1_8_1_0 - 4.166666666666654e-03*G6_1_2_5_1_8_2_1 - 4.166666666666654e-03*G6_1_2_5_1_8_3_2 + 8.333333333333309e-03*G6_1_2_5_1_9_0_0 + 8.333333333333309e-03*G6_1_2_5_1_9_0_1 + 8.333333333333307e-03*G6_1_2_5_1_9_0_2 - 8.333333333333309e-03*G6_1_2_5_1_9_1_0 - 8.333333333333309e-03*G6_1_2_5_1_9_2_1 - 8.333333333333309e-03*G6_1_2_5_1_9_3_2 + 4.166666666666655e-03*G6_1_2_5_1_10_0_0 + 4.166666666666656e-03*G6_1_2_5_1_10_0_1 + 4.166666666666654e-03*G6_1_2_5_1_10_0_2 - 4.166666666666655e-03*G6_1_2_5_1_10_1_0 - 4.166666666666656e-03*G6_1_2_5_1_10_2_1 - 4.166666666666656e-03*G6_1_2_5_1_10_3_2 + 4.166666666666656e-03*G6_1_2_5_1_11_0_0 + 4.166666666666657e-03*G6_1_2_5_1_11_0_1 + 4.166666666666656e-03*G6_1_2_5_1_11_0_2 - 4.166666666666656e-03*G6_1_2_5_1_11_1_0 - 4.166666666666657e-03*G6_1_2_5_1_11_2_1 - 4.166666666666657e-03*G6_1_2_5_1_11_3_2 + 4.166666666666654e-03*G6_1_2_6_1_8_0_0 + 4.166666666666654e-03*G6_1_2_6_1_8_0_1 + 4.166666666666654e-03*G6_1_2_6_1_8_0_2 - 4.166666666666654e-03*G6_1_2_6_1_8_1_0 - 4.166666666666654e-03*G6_1_2_6_1_8_2_1 - 4.166666666666654e-03*G6_1_2_6_1_8_3_2 + 4.166666666666655e-03*G6_1_2_6_1_9_0_0 + 4.166666666666656e-03*G6_1_2_6_1_9_0_1 + 4.166666666666654e-03*G6_1_2_6_1_9_0_2 - 4.166666666666655e-03*G6_1_2_6_1_9_1_0 - 4.166666666666656e-03*G6_1_2_6_1_9_2_1 - 4.166666666666656e-03*G6_1_2_6_1_9_3_2 + 8.333333333333311e-03*G6_1_2_6_1_10_0_0 + 8.333333333333311e-03*G6_1_2_6_1_10_0_1 + 8.333333333333311e-03*G6_1_2_6_1_10_0_2 - 8.333333333333311e-03*G6_1_2_6_1_10_1_0 - 8.333333333333311e-03*G6_1_2_6_1_10_2_1 - 8.333333333333311e-03*G6_1_2_6_1_10_3_2 + 4.166666666666655e-03*G6_1_2_6_1_11_0_0 + 4.166666666666656e-03*G6_1_2_6_1_11_0_1 + 4.166666666666655e-03*G6_1_2_6_1_11_0_2 - 4.166666666666655e-03*G6_1_2_6_1_11_1_0 - 4.166666666666656e-03*G6_1_2_6_1_11_2_1 - 4.166666666666656e-03*G6_1_2_6_1_11_3_2 + 4.166666666666656e-03*G6_1_2_7_1_8_0_0 + 4.166666666666657e-03*G6_1_2_7_1_8_0_1 + 4.166666666666657e-03*G6_1_2_7_1_8_0_2 - 4.166666666666656e-03*G6_1_2_7_1_8_1_0 - 4.166666666666657e-03*G6_1_2_7_1_8_2_1 - 4.166666666666657e-03*G6_1_2_7_1_8_3_2 + 4.166666666666656e-03*G6_1_2_7_1_9_0_0 + 4.166666666666657e-03*G6_1_2_7_1_9_0_1 + 4.166666666666656e-03*G6_1_2_7_1_9_0_2 - 4.166666666666656e-03*G6_1_2_7_1_9_1_0 - 4.166666666666657e-03*G6_1_2_7_1_9_2_1 - 4.166666666666657e-03*G6_1_2_7_1_9_3_2 + 4.166666666666655e-03*G6_1_2_7_1_10_0_0 + 4.166666666666656e-03*G6_1_2_7_1_10_0_1 + 4.166666666666655e-03*G6_1_2_7_1_10_0_2 - 4.166666666666655e-03*G6_1_2_7_1_10_1_0 - 4.166666666666656e-03*G6_1_2_7_1_10_2_1 - 4.166666666666656e-03*G6_1_2_7_1_10_3_2 + 8.333333333333311e-03*G6_1_2_7_1_11_0_0 + 8.333333333333311e-03*G6_1_2_7_1_11_0_1 + 8.333333333333311e-03*G6_1_2_7_1_11_0_2 - 8.333333333333311e-03*G6_1_2_7_1_11_1_0 - 8.333333333333311e-03*G6_1_2_7_1_11_2_1 - 8.333333333333311e-03*G6_1_2_7_1_11_3_2 + 8.333333333333309e-03*G6_2_0_8_1_0_0_0 + 8.333333333333311e-03*G6_2_0_8_1_0_0_1 + 8.333333333333311e-03*G6_2_0_8_1_0_0_2 - 8.333333333333309e-03*G6_2_0_8_1_0_1_0 - 8.333333333333311e-03*G6_2_0_8_1_0_2_1 - 8.333333333333311e-03*G6_2_0_8_1_0_3_2 + 4.166666666666654e-03*G6_2_0_8_1_1_0_0 + 4.166666666666654e-03*G6_2_0_8_1_1_0_1 + 4.166666666666654e-03*G6_2_0_8_1_1_0_2 - 4.166666666666654e-03*G6_2_0_8_1_1_1_0 - 4.166666666666654e-03*G6_2_0_8_1_1_2_1 - 4.166666666666654e-03*G6_2_0_8_1_1_3_2 + 4.166666666666654e-03*G6_2_0_8_1_2_0_0 + 4.166666666666654e-03*G6_2_0_8_1_2_0_1 + 4.166666666666654e-03*G6_2_0_8_1_2_0_2 - 4.166666666666654e-03*G6_2_0_8_1_2_1_0 - 4.166666666666654e-03*G6_2_0_8_1_2_2_1 - 4.166666666666654e-03*G6_2_0_8_1_2_3_2 + 4.166666666666656e-03*G6_2_0_8_1_3_0_0 + 4.166666666666657e-03*G6_2_0_8_1_3_0_1 + 4.166666666666657e-03*G6_2_0_8_1_3_0_2 - 4.166666666666656e-03*G6_2_0_8_1_3_1_0 - 4.166666666666657e-03*G6_2_0_8_1_3_2_1 - 4.166666666666657e-03*G6_2_0_8_1_3_3_2 + 4.166666666666655e-03*G6_2_0_9_1_0_0_0 + 4.166666666666655e-03*G6_2_0_9_1_0_0_1 + 4.166666666666655e-03*G6_2_0_9_1_0_0_2 - 4.166666666666655e-03*G6_2_0_9_1_0_1_0 - 4.166666666666655e-03*G6_2_0_9_1_0_2_1 - 4.166666666666655e-03*G6_2_0_9_1_0_3_2 + 8.333333333333309e-03*G6_2_0_9_1_1_0_0 + 8.333333333333309e-03*G6_2_0_9_1_1_0_1 + 8.333333333333307e-03*G6_2_0_9_1_1_0_2 - 8.333333333333309e-03*G6_2_0_9_1_1_1_0 - 8.333333333333309e-03*G6_2_0_9_1_1_2_1 - 8.333333333333309e-03*G6_2_0_9_1_1_3_2 + 4.166666666666655e-03*G6_2_0_9_1_2_0_0 + 4.166666666666656e-03*G6_2_0_9_1_2_0_1 + 4.166666666666654e-03*G6_2_0_9_1_2_0_2 - 4.166666666666655e-03*G6_2_0_9_1_2_1_0 - 4.166666666666656e-03*G6_2_0_9_1_2_2_1 - 4.166666666666656e-03*G6_2_0_9_1_2_3_2 + 4.166666666666656e-03*G6_2_0_9_1_3_0_0 + 4.166666666666657e-03*G6_2_0_9_1_3_0_1 + 4.166666666666656e-03*G6_2_0_9_1_3_0_2 - 4.166666666666656e-03*G6_2_0_9_1_3_1_0 - 4.166666666666657e-03*G6_2_0_9_1_3_2_1 - 4.166666666666657e-03*G6_2_0_9_1_3_3_2 + 4.166666666666654e-03*G6_2_0_10_1_0_0_0 + 4.166666666666656e-03*G6_2_0_10_1_0_0_1 + 4.166666666666655e-03*G6_2_0_10_1_0_0_2 - 4.166666666666654e-03*G6_2_0_10_1_0_1_0 - 4.166666666666656e-03*G6_2_0_10_1_0_2_1 - 4.166666666666656e-03*G6_2_0_10_1_0_3_2 + 4.166666666666654e-03*G6_2_0_10_1_1_0_0 + 4.166666666666654e-03*G6_2_0_10_1_1_0_1 + 4.166666666666654e-03*G6_2_0_10_1_1_0_2 - 4.166666666666654e-03*G6_2_0_10_1_1_1_0 - 4.166666666666654e-03*G6_2_0_10_1_1_2_1 - 4.166666666666654e-03*G6_2_0_10_1_1_3_2 + 8.333333333333311e-03*G6_2_0_10_1_2_0_0 + 8.333333333333311e-03*G6_2_0_10_1_2_0_1 + 8.333333333333311e-03*G6_2_0_10_1_2_0_2 - 8.333333333333311e-03*G6_2_0_10_1_2_1_0 - 8.333333333333311e-03*G6_2_0_10_1_2_2_1 - 8.333333333333311e-03*G6_2_0_10_1_2_3_2 + 4.166666666666655e-03*G6_2_0_10_1_3_0_0 + 4.166666666666656e-03*G6_2_0_10_1_3_0_1 + 4.166666666666655e-03*G6_2_0_10_1_3_0_2 - 4.166666666666655e-03*G6_2_0_10_1_3_1_0 - 4.166666666666656e-03*G6_2_0_10_1_3_2_1 - 4.166666666666656e-03*G6_2_0_10_1_3_3_2 + 4.166666666666656e-03*G6_2_0_11_1_0_0_0 + 4.166666666666657e-03*G6_2_0_11_1_0_0_1 + 4.166666666666657e-03*G6_2_0_11_1_0_0_2 - 4.166666666666656e-03*G6_2_0_11_1_0_1_0 - 4.166666666666657e-03*G6_2_0_11_1_0_2_1 - 4.166666666666657e-03*G6_2_0_11_1_0_3_2 + 4.166666666666655e-03*G6_2_0_11_1_1_0_0 + 4.166666666666655e-03*G6_2_0_11_1_1_0_1 + 4.166666666666655e-03*G6_2_0_11_1_1_0_2 - 4.166666666666655e-03*G6_2_0_11_1_1_1_0 - 4.166666666666655e-03*G6_2_0_11_1_1_2_1 - 4.166666666666655e-03*G6_2_0_11_1_1_3_2 + 4.166666666666655e-03*G6_2_0_11_1_2_0_0 + 4.166666666666656e-03*G6_2_0_11_1_2_0_1 + 4.166666666666655e-03*G6_2_0_11_1_2_0_2 - 4.166666666666655e-03*G6_2_0_11_1_2_1_0 - 4.166666666666656e-03*G6_2_0_11_1_2_2_1 - 4.166666666666656e-03*G6_2_0_11_1_2_3_2 + 8.333333333333311e-03*G6_2_0_11_1_3_0_0 + 8.333333333333311e-03*G6_2_0_11_1_3_0_1 + 8.333333333333311e-03*G6_2_0_11_1_3_0_2 - 8.333333333333311e-03*G6_2_0_11_1_3_1_0 - 8.333333333333311e-03*G6_2_0_11_1_3_2_1 - 8.333333333333311e-03*G6_2_0_11_1_3_3_2 + 8.333333333333309e-03*G6_2_1_8_1_4_0_0 + 8.333333333333311e-03*G6_2_1_8_1_4_0_1 + 8.333333333333311e-03*G6_2_1_8_1_4_0_2 - 8.333333333333309e-03*G6_2_1_8_1_4_1_0 - 8.333333333333311e-03*G6_2_1_8_1_4_2_1 - 8.333333333333311e-03*G6_2_1_8_1_4_3_2 + 4.166666666666654e-03*G6_2_1_8_1_5_0_0 + 4.166666666666654e-03*G6_2_1_8_1_5_0_1 + 4.166666666666654e-03*G6_2_1_8_1_5_0_2 - 4.166666666666654e-03*G6_2_1_8_1_5_1_0 - 4.166666666666654e-03*G6_2_1_8_1_5_2_1 - 4.166666666666654e-03*G6_2_1_8_1_5_3_2 + 4.166666666666654e-03*G6_2_1_8_1_6_0_0 + 4.166666666666654e-03*G6_2_1_8_1_6_0_1 + 4.166666666666654e-03*G6_2_1_8_1_6_0_2 - 4.166666666666654e-03*G6_2_1_8_1_6_1_0 - 4.166666666666654e-03*G6_2_1_8_1_6_2_1 - 4.166666666666654e-03*G6_2_1_8_1_6_3_2 + 4.166666666666656e-03*G6_2_1_8_1_7_0_0 + 4.166666666666657e-03*G6_2_1_8_1_7_0_1 + 4.166666666666657e-03*G6_2_1_8_1_7_0_2 - 4.166666666666656e-03*G6_2_1_8_1_7_1_0 - 4.166666666666657e-03*G6_2_1_8_1_7_2_1 - 4.166666666666657e-03*G6_2_1_8_1_7_3_2 + 4.166666666666654e-03*G6_2_1_9_1_4_0_0 + 4.166666666666654e-03*G6_2_1_9_1_4_0_1 + 4.166666666666654e-03*G6_2_1_9_1_4_0_2 - 4.166666666666654e-03*G6_2_1_9_1_4_1_0 - 4.166666666666654e-03*G6_2_1_9_1_4_2_1 - 4.166666666666654e-03*G6_2_1_9_1_4_3_2 + 8.333333333333309e-03*G6_2_1_9_1_5_0_0 + 8.333333333333309e-03*G6_2_1_9_1_5_0_1 + 8.333333333333307e-03*G6_2_1_9_1_5_0_2 - 8.333333333333309e-03*G6_2_1_9_1_5_1_0 - 8.333333333333309e-03*G6_2_1_9_1_5_2_1 - 8.333333333333309e-03*G6_2_1_9_1_5_3_2 + 4.166666666666655e-03*G6_2_1_9_1_6_0_0 + 4.166666666666656e-03*G6_2_1_9_1_6_0_1 + 4.166666666666654e-03*G6_2_1_9_1_6_0_2 - 4.166666666666655e-03*G6_2_1_9_1_6_1_0 - 4.166666666666656e-03*G6_2_1_9_1_6_2_1 - 4.166666666666656e-03*G6_2_1_9_1_6_3_2 + 4.166666666666656e-03*G6_2_1_9_1_7_0_0 + 4.166666666666657e-03*G6_2_1_9_1_7_0_1 + 4.166666666666656e-03*G6_2_1_9_1_7_0_2 - 4.166666666666656e-03*G6_2_1_9_1_7_1_0 - 4.166666666666657e-03*G6_2_1_9_1_7_2_1 - 4.166666666666657e-03*G6_2_1_9_1_7_3_2 + 4.166666666666654e-03*G6_2_1_10_1_4_0_0 + 4.166666666666654e-03*G6_2_1_10_1_4_0_1 + 4.166666666666654e-03*G6_2_1_10_1_4_0_2 - 4.166666666666654e-03*G6_2_1_10_1_4_1_0 - 4.166666666666654e-03*G6_2_1_10_1_4_2_1 - 4.166666666666654e-03*G6_2_1_10_1_4_3_2 + 4.166666666666655e-03*G6_2_1_10_1_5_0_0 + 4.166666666666656e-03*G6_2_1_10_1_5_0_1 + 4.166666666666654e-03*G6_2_1_10_1_5_0_2 - 4.166666666666655e-03*G6_2_1_10_1_5_1_0 - 4.166666666666656e-03*G6_2_1_10_1_5_2_1 - 4.166666666666656e-03*G6_2_1_10_1_5_3_2 + 8.333333333333311e-03*G6_2_1_10_1_6_0_0 + 8.333333333333311e-03*G6_2_1_10_1_6_0_1 + 8.333333333333311e-03*G6_2_1_10_1_6_0_2 - 8.333333333333311e-03*G6_2_1_10_1_6_1_0 - 8.333333333333311e-03*G6_2_1_10_1_6_2_1 - 8.333333333333311e-03*G6_2_1_10_1_6_3_2 + 4.166666666666655e-03*G6_2_1_10_1_7_0_0 + 4.166666666666656e-03*G6_2_1_10_1_7_0_1 + 4.166666666666655e-03*G6_2_1_10_1_7_0_2 - 4.166666666666655e-03*G6_2_1_10_1_7_1_0 - 4.166666666666656e-03*G6_2_1_10_1_7_2_1 - 4.166666666666656e-03*G6_2_1_10_1_7_3_2 + 4.166666666666656e-03*G6_2_1_11_1_4_0_0 + 4.166666666666657e-03*G6_2_1_11_1_4_0_1 + 4.166666666666657e-03*G6_2_1_11_1_4_0_2 - 4.166666666666656e-03*G6_2_1_11_1_4_1_0 - 4.166666666666657e-03*G6_2_1_11_1_4_2_1 - 4.166666666666657e-03*G6_2_1_11_1_4_3_2 + 4.166666666666656e-03*G6_2_1_11_1_5_0_0 + 4.166666666666657e-03*G6_2_1_11_1_5_0_1 + 4.166666666666656e-03*G6_2_1_11_1_5_0_2 - 4.166666666666656e-03*G6_2_1_11_1_5_1_0 - 4.166666666666657e-03*G6_2_1_11_1_5_2_1 - 4.166666666666657e-03*G6_2_1_11_1_5_3_2 + 4.166666666666655e-03*G6_2_1_11_1_6_0_0 + 4.166666666666656e-03*G6_2_1_11_1_6_0_1 + 4.166666666666655e-03*G6_2_1_11_1_6_0_2 - 4.166666666666655e-03*G6_2_1_11_1_6_1_0 - 4.166666666666656e-03*G6_2_1_11_1_6_2_1 - 4.166666666666656e-03*G6_2_1_11_1_6_3_2 + 8.333333333333311e-03*G6_2_1_11_1_7_0_0 + 8.333333333333311e-03*G6_2_1_11_1_7_0_1 + 8.333333333333311e-03*G6_2_1_11_1_7_0_2 - 8.333333333333311e-03*G6_2_1_11_1_7_1_0 - 8.333333333333311e-03*G6_2_1_11_1_7_2_1 - 8.333333333333311e-03*G6_2_1_11_1_7_3_2 + 8.333333333333309e-03*G6_2_2_8_1_8_0_0 + 8.333333333333311e-03*G6_2_2_8_1_8_0_1 + 8.333333333333311e-03*G6_2_2_8_1_8_0_2 - 8.333333333333309e-03*G6_2_2_8_1_8_1_0 - 8.333333333333311e-03*G6_2_2_8_1_8_2_1 - 8.333333333333311e-03*G6_2_2_8_1_8_3_2 + 4.166666666666654e-03*G6_2_2_8_1_9_0_0 + 4.166666666666654e-03*G6_2_2_8_1_9_0_1 + 4.166666666666654e-03*G6_2_2_8_1_9_0_2 - 4.166666666666654e-03*G6_2_2_8_1_9_1_0 - 4.166666666666654e-03*G6_2_2_8_1_9_2_1 - 4.166666666666654e-03*G6_2_2_8_1_9_3_2 + 4.166666666666654e-03*G6_2_2_8_1_10_0_0 + 4.166666666666654e-03*G6_2_2_8_1_10_0_1 + 4.166666666666654e-03*G6_2_2_8_1_10_0_2 - 4.166666666666654e-03*G6_2_2_8_1_10_1_0 - 4.166666666666654e-03*G6_2_2_8_1_10_2_1 - 4.166666666666654e-03*G6_2_2_8_1_10_3_2 + 4.166666666666656e-03*G6_2_2_8_1_11_0_0 + 4.166666666666657e-03*G6_2_2_8_1_11_0_1 + 4.166666666666657e-03*G6_2_2_8_1_11_0_2 - 4.166666666666656e-03*G6_2_2_8_1_11_1_0 - 4.166666666666657e-03*G6_2_2_8_1_11_2_1 - 4.166666666666657e-03*G6_2_2_8_1_11_3_2 + 4.166666666666654e-03*G6_2_2_9_1_8_0_0 + 4.166666666666654e-03*G6_2_2_9_1_8_0_1 + 4.166666666666654e-03*G6_2_2_9_1_8_0_2 - 4.166666666666654e-03*G6_2_2_9_1_8_1_0 - 4.166666666666654e-03*G6_2_2_9_1_8_2_1 - 4.166666666666654e-03*G6_2_2_9_1_8_3_2 + 8.333333333333309e-03*G6_2_2_9_1_9_0_0 + 8.333333333333309e-03*G6_2_2_9_1_9_0_1 + 8.333333333333307e-03*G6_2_2_9_1_9_0_2 - 8.333333333333309e-03*G6_2_2_9_1_9_1_0 - 8.333333333333309e-03*G6_2_2_9_1_9_2_1 - 8.333333333333309e-03*G6_2_2_9_1_9_3_2 + 4.166666666666655e-03*G6_2_2_9_1_10_0_0 + 4.166666666666656e-03*G6_2_2_9_1_10_0_1 + 4.166666666666654e-03*G6_2_2_9_1_10_0_2 - 4.166666666666655e-03*G6_2_2_9_1_10_1_0 - 4.166666666666656e-03*G6_2_2_9_1_10_2_1 - 4.166666666666656e-03*G6_2_2_9_1_10_3_2 + 4.166666666666656e-03*G6_2_2_9_1_11_0_0 + 4.166666666666657e-03*G6_2_2_9_1_11_0_1 + 4.166666666666656e-03*G6_2_2_9_1_11_0_2 - 4.166666666666656e-03*G6_2_2_9_1_11_1_0 - 4.166666666666657e-03*G6_2_2_9_1_11_2_1 - 4.166666666666657e-03*G6_2_2_9_1_11_3_2 + 4.166666666666654e-03*G6_2_2_10_1_8_0_0 + 4.166666666666654e-03*G6_2_2_10_1_8_0_1 + 4.166666666666654e-03*G6_2_2_10_1_8_0_2 - 4.166666666666654e-03*G6_2_2_10_1_8_1_0 - 4.166666666666654e-03*G6_2_2_10_1_8_2_1 - 4.166666666666654e-03*G6_2_2_10_1_8_3_2 + 4.166666666666655e-03*G6_2_2_10_1_9_0_0 + 4.166666666666656e-03*G6_2_2_10_1_9_0_1 + 4.166666666666654e-03*G6_2_2_10_1_9_0_2 - 4.166666666666655e-03*G6_2_2_10_1_9_1_0 - 4.166666666666656e-03*G6_2_2_10_1_9_2_1 - 4.166666666666656e-03*G6_2_2_10_1_9_3_2 + 8.333333333333311e-03*G6_2_2_10_1_10_0_0 + 8.333333333333311e-03*G6_2_2_10_1_10_0_1 + 8.333333333333311e-03*G6_2_2_10_1_10_0_2 - 8.333333333333311e-03*G6_2_2_10_1_10_1_0 - 8.333333333333311e-03*G6_2_2_10_1_10_2_1 - 8.333333333333311e-03*G6_2_2_10_1_10_3_2 + 4.166666666666655e-03*G6_2_2_10_1_11_0_0 + 4.166666666666656e-03*G6_2_2_10_1_11_0_1 + 4.166666666666655e-03*G6_2_2_10_1_11_0_2 - 4.166666666666655e-03*G6_2_2_10_1_11_1_0 - 4.166666666666656e-03*G6_2_2_10_1_11_2_1 - 4.166666666666656e-03*G6_2_2_10_1_11_3_2 + 4.166666666666656e-03*G6_2_2_11_1_8_0_0 + 4.166666666666657e-03*G6_2_2_11_1_8_0_1 + 4.166666666666657e-03*G6_2_2_11_1_8_0_2 - 4.166666666666656e-03*G6_2_2_11_1_8_1_0 - 4.166666666666657e-03*G6_2_2_11_1_8_2_1 - 4.166666666666657e-03*G6_2_2_11_1_8_3_2 + 4.166666666666656e-03*G6_2_2_11_1_9_0_0 + 4.166666666666657e-03*G6_2_2_11_1_9_0_1 + 4.166666666666656e-03*G6_2_2_11_1_9_0_2 - 4.166666666666656e-03*G6_2_2_11_1_9_1_0 - 4.166666666666657e-03*G6_2_2_11_1_9_2_1 - 4.166666666666657e-03*G6_2_2_11_1_9_3_2 + 4.166666666666655e-03*G6_2_2_11_1_10_0_0 + 4.166666666666656e-03*G6_2_2_11_1_10_0_1 + 4.166666666666655e-03*G6_2_2_11_1_10_0_2 - 4.166666666666655e-03*G6_2_2_11_1_10_1_0 - 4.166666666666656e-03*G6_2_2_11_1_10_2_1 - 4.166666666666656e-03*G6_2_2_11_1_10_3_2 + 8.333333333333311e-03*G6_2_2_11_1_11_0_0 + 8.333333333333311e-03*G6_2_2_11_1_11_0_1 + 8.333333333333311e-03*G6_2_2_11_1_11_0_2 - 8.333333333333311e-03*G6_2_2_11_1_11_1_0 - 8.333333333333311e-03*G6_2_2_11_1_11_2_1 - 8.333333333333311e-03*G6_2_2_11_1_11_3_2 + 4.166666666666662e-02*G7_0_0_0_1_0_0 + 4.166666666666662e-02*G7_0_0_0_1_0_1 + 4.166666666666662e-02*G7_0_0_0_1_0_2 - 4.166666666666662e-02*G7_0_0_0_1_1_0 - 4.166666666666662e-02*G7_0_0_0_1_2_1 - 4.166666666666662e-02*G7_0_0_0_1_3_2 + 4.166666666666660e-02*G7_0_0_1_1_0_0 + 4.166666666666661e-02*G7_0_0_1_1_0_1 + 4.166666666666661e-02*G7_0_0_1_1_0_2 - 4.166666666666660e-02*G7_0_0_1_1_1_0 - 4.166666666666661e-02*G7_0_0_1_1_2_1 - 4.166666666666661e-02*G7_0_0_1_1_3_2 + 4.166666666666661e-02*G7_0_0_2_1_0_0 + 4.166666666666662e-02*G7_0_0_2_1_0_1 + 4.166666666666662e-02*G7_0_0_2_1_0_2 - 4.166666666666661e-02*G7_0_0_2_1_1_0 - 4.166666666666662e-02*G7_0_0_2_1_2_1 - 4.166666666666662e-02*G7_0_0_2_1_3_2 + 4.166666666666661e-02*G7_0_0_3_1_0_0 + 4.166666666666662e-02*G7_0_0_3_1_0_1 + 4.166666666666662e-02*G7_0_0_3_1_0_2 - 4.166666666666661e-02*G7_0_0_3_1_1_0 - 4.166666666666662e-02*G7_0_0_3_1_2_1 - 4.166666666666662e-02*G7_0_0_3_1_3_2 + 4.166666666666661e-02*G7_0_1_4_1_0_0 + 4.166666666666662e-02*G7_0_1_4_1_0_1 + 4.166666666666662e-02*G7_0_1_4_1_0_2 - 4.166666666666661e-02*G7_0_1_4_1_1_0 - 4.166666666666662e-02*G7_0_1_4_1_2_1 - 4.166666666666662e-02*G7_0_1_4_1_3_2 + 4.166666666666661e-02*G7_0_1_5_1_0_0 + 4.166666666666662e-02*G7_0_1_5_1_0_1 + 4.166666666666662e-02*G7_0_1_5_1_0_2 - 4.166666666666661e-02*G7_0_1_5_1_1_0 - 4.166666666666662e-02*G7_0_1_5_1_2_1 - 4.166666666666662e-02*G7_0_1_5_1_3_2 + 4.166666666666661e-02*G7_0_1_6_1_0_0 + 4.166666666666662e-02*G7_0_1_6_1_0_1 + 4.166666666666662e-02*G7_0_1_6_1_0_2 - 4.166666666666661e-02*G7_0_1_6_1_1_0 - 4.166666666666662e-02*G7_0_1_6_1_2_1 - 4.166666666666662e-02*G7_0_1_6_1_3_2 + 4.166666666666661e-02*G7_0_1_7_1_0_0 + 4.166666666666662e-02*G7_0_1_7_1_0_1 + 4.166666666666662e-02*G7_0_1_7_1_0_2 - 4.166666666666661e-02*G7_0_1_7_1_1_0 - 4.166666666666662e-02*G7_0_1_7_1_2_1 - 4.166666666666662e-02*G7_0_1_7_1_3_2 + 4.166666666666661e-02*G7_0_2_8_1_0_0 + 4.166666666666662e-02*G7_0_2_8_1_0_1 + 4.166666666666662e-02*G7_0_2_8_1_0_2 - 4.166666666666661e-02*G7_0_2_8_1_1_0 - 4.166666666666662e-02*G7_0_2_8_1_2_1 - 4.166666666666662e-02*G7_0_2_8_1_3_2 + 4.166666666666661e-02*G7_0_2_9_1_0_0 + 4.166666666666662e-02*G7_0_2_9_1_0_1 + 4.166666666666662e-02*G7_0_2_9_1_0_2 - 4.166666666666661e-02*G7_0_2_9_1_1_0 - 4.166666666666662e-02*G7_0_2_9_1_2_1 - 4.166666666666662e-02*G7_0_2_9_1_3_2 + 4.166666666666661e-02*G7_0_2_10_1_0_0 + 4.166666666666662e-02*G7_0_2_10_1_0_1 + 4.166666666666662e-02*G7_0_2_10_1_0_2 - 4.166666666666661e-02*G7_0_2_10_1_1_0 - 4.166666666666662e-02*G7_0_2_10_1_2_1 - 4.166666666666662e-02*G7_0_2_10_1_3_2 + 4.166666666666661e-02*G7_0_2_11_1_0_0 + 4.166666666666662e-02*G7_0_2_11_1_0_1 + 4.166666666666662e-02*G7_0_2_11_1_0_2 - 4.166666666666661e-02*G7_0_2_11_1_1_0 - 4.166666666666662e-02*G7_0_2_11_1_2_1 - 4.166666666666662e-02*G7_0_2_11_1_3_2 + 8.333333333333322e-02*G8_0_0_1_0_0 + 8.333333333333323e-02*G8_0_0_1_0_1 + 8.333333333333322e-02*G8_0_0_1_0_2 - 8.333333333333322e-02*G8_0_0_1_1_0 - 8.333333333333323e-02*G8_0_0_1_2_1 - 8.333333333333323e-02*G8_0_0_1_3_2 + 8.333333333333322e-02*G8_0_1_1_4_0 + 8.333333333333323e-02*G8_0_1_1_4_1 + 8.333333333333323e-02*G8_0_1_1_4_2 - 8.333333333333322e-02*G8_0_1_1_5_0 - 8.333333333333323e-02*G8_0_1_1_6_1 - 8.333333333333323e-02*G8_0_1_1_7_2 + 8.333333333333322e-02*G8_0_2_1_8_0 + 8.333333333333323e-02*G8_0_2_1_8_1 + 8.333333333333323e-02*G8_0_2_1_8_2 - 8.333333333333322e-02*G8_0_2_1_9_0 - 8.333333333333323e-02*G8_0_2_1_10_1 - 8.333333333333323e-02*G8_0_2_1_11_2;
    block[3] = 8.333333333333314e-03*G0_0 + 8.333333333333311e-03*G0_1 + 8.333333333333312e-03*G0_2 + 1.666666666666662e-02*G0_3 + 8.333333333333314e-03*G1_0 + 8.333333333333311e-03*G1_1 + 8.333333333333312e-03*G1_2 + 1.666666666666662e-02*G1_3 + 4.166666666666662e-02*G2_0_2_0 + 4.166666666666662e-02*G2_0_2_1 + 4.166666666666662e-02*G2_0_2_2 + 4.166666666666662e-02*G2_0_2_3 + 1.666666666666662e-02*G3_0_0_2_0 + 8.333333333333311e-03*G3_0_0_2_1 + 8.333333333333312e-03*G3_0_0_2_2 + 8.333333333333314e-03*G3_0_0_2_3 + 8.333333333333311e-03*G3_0_1_2_0 + 1.666666666666662e-02*G3_0_1_2_1 + 8.333333333333309e-03*G3_0_1_2_2 + 8.333333333333311e-03*G3_0_1_2_3 + 8.333333333333312e-03*G3_0_2_2_0 + 8.333333333333309e-03*G3_0_2_2_1 + 1.666666666666662e-02*G3_0_2_2_2 + 8.333333333333312e-03*G3_0_2_2_3 + 8.333333333333314e-03*G3_0_3_2_0 + 8.333333333333311e-03*G3_0_3_2_1 + 8.333333333333312e-03*G3_0_3_2_2 + 1.666666666666662e-02*G3_0_3_2_3 + 1.666666666666662e-02*G3_1_4_2_0 + 8.333333333333309e-03*G3_1_4_2_1 + 8.333333333333309e-03*G3_1_4_2_2 + 8.333333333333314e-03*G3_1_4_2_3 + 8.333333333333311e-03*G3_1_5_2_0 + 1.666666666666662e-02*G3_1_5_2_1 + 8.333333333333312e-03*G3_1_5_2_2 + 8.333333333333314e-03*G3_1_5_2_3 + 8.333333333333312e-03*G3_1_6_2_0 + 8.333333333333309e-03*G3_1_6_2_1 + 1.666666666666662e-02*G3_1_6_2_2 + 8.333333333333312e-03*G3_1_6_2_3 + 8.333333333333314e-03*G3_1_7_2_0 + 8.333333333333311e-03*G3_1_7_2_1 + 8.333333333333312e-03*G3_1_7_2_2 + 1.666666666666662e-02*G3_1_7_2_3 + 1.666666666666662e-02*G3_2_8_2_0 + 8.333333333333309e-03*G3_2_8_2_1 + 8.333333333333309e-03*G3_2_8_2_2 + 8.333333333333314e-03*G3_2_8_2_3 + 8.333333333333311e-03*G3_2_9_2_0 + 1.666666666666662e-02*G3_2_9_2_1 + 8.333333333333312e-03*G3_2_9_2_2 + 8.333333333333314e-03*G3_2_9_2_3 + 8.333333333333312e-03*G3_2_10_2_0 + 8.333333333333309e-03*G3_2_10_2_1 + 1.666666666666662e-02*G3_2_10_2_2 + 8.333333333333312e-03*G3_2_10_2_3 + 8.333333333333314e-03*G3_2_11_2_0 + 8.333333333333311e-03*G3_2_11_2_1 + 8.333333333333312e-03*G3_2_11_2_2 + 1.666666666666662e-02*G3_2_11_2_3 + 8.333333333333322e-02*G4_2_0_0 + 8.333333333333323e-02*G4_2_0_1 + 8.333333333333322e-02*G4_2_0_2 - 8.333333333333322e-02*G4_2_1_0 - 8.333333333333323e-02*G4_2_2_1 - 8.333333333333323e-02*G4_2_3_2 + 4.166666666666656e-03*G5_0_0_0_0 + 4.166666666666657e-03*G5_0_0_0_1 + 4.166666666666657e-03*G5_0_0_0_2 - 4.166666666666656e-03*G5_0_0_1_0 - 4.166666666666657e-03*G5_0_0_2_1 - 4.166666666666657e-03*G5_0_0_3_2 + 4.166666666666655e-03*G5_0_1_0_0 + 4.166666666666655e-03*G5_0_1_0_1 + 4.166666666666655e-03*G5_0_1_0_2 - 4.166666666666655e-03*G5_0_1_1_0 - 4.166666666666655e-03*G5_0_1_2_1 - 4.166666666666655e-03*G5_0_1_3_2 + 4.166666666666655e-03*G5_0_2_0_0 + 4.166666666666656e-03*G5_0_2_0_1 + 4.166666666666655e-03*G5_0_2_0_2 - 4.166666666666655e-03*G5_0_2_1_0 - 4.166666666666656e-03*G5_0_2_2_1 - 4.166666666666656e-03*G5_0_2_3_2 + 8.333333333333311e-03*G5_0_3_0_0 + 8.333333333333311e-03*G5_0_3_0_1 + 8.333333333333311e-03*G5_0_3_0_2 - 8.333333333333311e-03*G5_0_3_1_0 - 8.333333333333311e-03*G5_0_3_2_1 - 8.333333333333311e-03*G5_0_3_3_2 + 4.166666666666656e-03*G5_1_4_0_0 + 4.166666666666657e-03*G5_1_4_0_1 + 4.166666666666657e-03*G5_1_4_0_2 - 4.166666666666656e-03*G5_1_4_1_0 - 4.166666666666657e-03*G5_1_4_2_1 - 4.166666666666657e-03*G5_1_4_3_2 + 4.166666666666656e-03*G5_1_5_0_0 + 4.166666666666657e-03*G5_1_5_0_1 + 4.166666666666656e-03*G5_1_5_0_2 - 4.166666666666656e-03*G5_1_5_1_0 - 4.166666666666657e-03*G5_1_5_2_1 - 4.166666666666657e-03*G5_1_5_3_2 + 4.166666666666655e-03*G5_1_6_0_0 + 4.166666666666656e-03*G5_1_6_0_1 + 4.166666666666655e-03*G5_1_6_0_2 - 4.166666666666655e-03*G5_1_6_1_0 - 4.166666666666656e-03*G5_1_6_2_1 - 4.166666666666656e-03*G5_1_6_3_2 + 8.333333333333311e-03*G5_1_7_0_0 + 8.333333333333311e-03*G5_1_7_0_1 + 8.333333333333311e-03*G5_1_7_0_2 - 8.333333333333311e-03*G5_1_7_1_0 - 8.333333333333311e-03*G5_1_7_2_1 - 8.333333333333311e-03*G5_1_7_3_2 + 4.166666666666656e-03*G5_2_8_0_0 + 4.166666666666657e-03*G5_2_8_0_1 + 4.166666666666657e-03*G5_2_8_0_2 - 4.166666666666656e-03*G5_2_8_1_0 - 4.166666666666657e-03*G5_2_8_2_1 - 4.166666666666657e-03*G5_2_8_3_2 + 4.166666666666656e-03*G5_2_9_0_0 + 4.166666666666657e-03*G5_2_9_0_1 + 4.166666666666656e-03*G5_2_9_0_2 - 4.166666666666656e-03*G5_2_9_1_0 - 4.166666666666657e-03*G5_2_9_2_1 - 4.166666666666657e-03*G5_2_9_3_2 + 4.166666666666655e-03*G5_2_10_0_0 + 4.166666666666656e-03*G5_2_10_0_1 + 4.166666666666655e-03*G5_2_10_0_2 - 4.166666666666655e-03*G5_2_10_1_0 - 4.166666666666656e-03*G5_2_10_2_1 - 4.166666666666656e-03*G5_2_10_3_2 + 8.333333333333311e-03*G5_2_11_0_0 + 8.333333333333311e-03*G5_2_11_0_1 + 8.333333333333311e-03*G5_2_11_0_2 - 8.333333333333311e-03*G5_2_11_1_0 - 8.333333333333311e-03*G5_2_11_2_1 - 8.333333333333311e-03*G5_2_11_3_2 + 8.333333333333309e-03*G6_0_0_0_2_0_0_0 + 8.333333333333311e-03*G6_0_0_0_2_0_0_1 + 8.333333333333311e-03*G6_0_0_0_2_0_0_2 - 8.333333333333309e-03*G6_0_0_0_2_0_1_0 - 8.333333333333311e-03*G6_0_0_0_2_0_2_1 - 8.333333333333311e-03*G6_0_0_0_2_0_3_2 + 4.166666666666654e-03*G6_0_0_0_2_1_0_0 + 4.166666666666655e-03*G6_0_0_0_2_1_0_1 + 4.166666666666654e-03*G6_0_0_0_2_1_0_2 - 4.166666666666654e-03*G6_0_0_0_2_1_1_0 - 4.166666666666655e-03*G6_0_0_0_2_1_2_1 - 4.166666666666655e-03*G6_0_0_0_2_1_3_2 + 4.166666666666654e-03*G6_0_0_0_2_2_0_0 + 4.166666666666656e-03*G6_0_0_0_2_2_0_1 + 4.166666666666655e-03*G6_0_0_0_2_2_0_2 - 4.166666666666654e-03*G6_0_0_0_2_2_1_0 - 4.166666666666656e-03*G6_0_0_0_2_2_2_1 - 4.166666666666656e-03*G6_0_0_0_2_2_3_2 + 4.166666666666656e-03*G6_0_0_0_2_3_0_0 + 4.166666666666657e-03*G6_0_0_0_2_3_0_1 + 4.166666666666657e-03*G6_0_0_0_2_3_0_2 - 4.166666666666656e-03*G6_0_0_0_2_3_1_0 - 4.166666666666657e-03*G6_0_0_0_2_3_2_1 - 4.166666666666657e-03*G6_0_0_0_2_3_3_2 + 4.166666666666654e-03*G6_0_0_1_2_0_0_0 + 4.166666666666655e-03*G6_0_0_1_2_0_0_1 + 4.166666666666654e-03*G6_0_0_1_2_0_0_2 - 4.166666666666654e-03*G6_0_0_1_2_0_1_0 - 4.166666666666655e-03*G6_0_0_1_2_0_2_1 - 4.166666666666655e-03*G6_0_0_1_2_0_3_2 + 8.333333333333307e-03*G6_0_0_1_2_1_0_0 + 8.333333333333309e-03*G6_0_0_1_2_1_0_1 + 8.333333333333307e-03*G6_0_0_1_2_1_0_2 - 8.333333333333307e-03*G6_0_0_1_2_1_1_0 - 8.333333333333309e-03*G6_0_0_1_2_1_2_1 - 8.333333333333309e-03*G6_0_0_1_2_1_3_2 + 4.166666666666654e-03*G6_0_0_1_2_2_0_0 + 4.166666666666654e-03*G6_0_0_1_2_2_0_1 + 4.166666666666654e-03*G6_0_0_1_2_2_0_2 - 4.166666666666654e-03*G6_0_0_1_2_2_1_0 - 4.166666666666654e-03*G6_0_0_1_2_2_2_1 - 4.166666666666654e-03*G6_0_0_1_2_2_3_2 + 4.166666666666655e-03*G6_0_0_1_2_3_0_0 + 4.166666666666655e-03*G6_0_0_1_2_3_0_1 + 4.166666666666655e-03*G6_0_0_1_2_3_0_2 - 4.166666666666655e-03*G6_0_0_1_2_3_1_0 - 4.166666666666655e-03*G6_0_0_1_2_3_2_1 - 4.166666666666655e-03*G6_0_0_1_2_3_3_2 + 4.166666666666654e-03*G6_0_0_2_2_0_0_0 + 4.166666666666656e-03*G6_0_0_2_2_0_0_1 + 4.166666666666655e-03*G6_0_0_2_2_0_0_2 - 4.166666666666654e-03*G6_0_0_2_2_0_1_0 - 4.166666666666656e-03*G6_0_0_2_2_0_2_1 - 4.166666666666656e-03*G6_0_0_2_2_0_3_2 + 4.166666666666654e-03*G6_0_0_2_2_1_0_0 + 4.166666666666654e-03*G6_0_0_2_2_1_0_1 + 4.166666666666654e-03*G6_0_0_2_2_1_0_2 - 4.166666666666654e-03*G6_0_0_2_2_1_1_0 - 4.166666666666654e-03*G6_0_0_2_2_1_2_1 - 4.166666666666654e-03*G6_0_0_2_2_1_3_2 + 8.333333333333311e-03*G6_0_0_2_2_2_0_0 + 8.333333333333311e-03*G6_0_0_2_2_2_0_1 + 8.333333333333311e-03*G6_0_0_2_2_2_0_2 - 8.333333333333311e-03*G6_0_0_2_2_2_1_0 - 8.333333333333311e-03*G6_0_0_2_2_2_2_1 - 8.333333333333311e-03*G6_0_0_2_2_2_3_2 + 4.166666666666655e-03*G6_0_0_2_2_3_0_0 + 4.166666666666656e-03*G6_0_0_2_2_3_0_1 + 4.166666666666655e-03*G6_0_0_2_2_3_0_2 - 4.166666666666655e-03*G6_0_0_2_2_3_1_0 - 4.166666666666656e-03*G6_0_0_2_2_3_2_1 - 4.166666666666656e-03*G6_0_0_2_2_3_3_2 + 4.166666666666656e-03*G6_0_0_3_2_0_0_0 + 4.166666666666657e-03*G6_0_0_3_2_0_0_1 + 4.166666666666657e-03*G6_0_0_3_2_0_0_2 - 4.166666666666656e-03*G6_0_0_3_2_0_1_0 - 4.166666666666657e-03*G6_0_0_3_2_0_2_1 - 4.166666666666657e-03*G6_0_0_3_2_0_3_2 + 4.166666666666655e-03*G6_0_0_3_2_1_0_0 + 4.166666666666655e-03*G6_0_0_3_2_1_0_1 + 4.166666666666655e-03*G6_0_0_3_2_1_0_2 - 4.166666666666655e-03*G6_0_0_3_2_1_1_0 - 4.166666666666655e-03*G6_0_0_3_2_1_2_1 - 4.166666666666655e-03*G6_0_0_3_2_1_3_2 + 4.166666666666655e-03*G6_0_0_3_2_2_0_0 + 4.166666666666656e-03*G6_0_0_3_2_2_0_1 + 4.166666666666655e-03*G6_0_0_3_2_2_0_2 - 4.166666666666655e-03*G6_0_0_3_2_2_1_0 - 4.166666666666656e-03*G6_0_0_3_2_2_2_1 - 4.166666666666656e-03*G6_0_0_3_2_2_3_2 + 8.333333333333311e-03*G6_0_0_3_2_3_0_0 + 8.333333333333311e-03*G6_0_0_3_2_3_0_1 + 8.333333333333311e-03*G6_0_0_3_2_3_0_2 - 8.333333333333311e-03*G6_0_0_3_2_3_1_0 - 8.333333333333311e-03*G6_0_0_3_2_3_2_1 - 8.333333333333311e-03*G6_0_0_3_2_3_3_2 + 8.333333333333309e-03*G6_0_1_0_2_4_0_0 + 8.333333333333311e-03*G6_0_1_0_2_4_0_1 + 8.333333333333311e-03*G6_0_1_0_2_4_0_2 - 8.333333333333309e-03*G6_0_1_0_2_4_1_0 - 8.333333333333311e-03*G6_0_1_0_2_4_2_1 - 8.333333333333311e-03*G6_0_1_0_2_4_3_2 + 4.166666666666655e-03*G6_0_1_0_2_5_0_0 + 4.166666666666655e-03*G6_0_1_0_2_5_0_1 + 4.166666666666655e-03*G6_0_1_0_2_5_0_2 - 4.166666666666655e-03*G6_0_1_0_2_5_1_0 - 4.166666666666655e-03*G6_0_1_0_2_5_2_1 - 4.166666666666655e-03*G6_0_1_0_2_5_3_2 + 4.166666666666654e-03*G6_0_1_0_2_6_0_0 + 4.166666666666656e-03*G6_0_1_0_2_6_0_1 + 4.166666666666655e-03*G6_0_1_0_2_6_0_2 - 4.166666666666654e-03*G6_0_1_0_2_6_1_0 - 4.166666666666656e-03*G6_0_1_0_2_6_2_1 - 4.166666666666656e-03*G6_0_1_0_2_6_3_2 + 4.166666666666656e-03*G6_0_1_0_2_7_0_0 + 4.166666666666657e-03*G6_0_1_0_2_7_0_1 + 4.166666666666657e-03*G6_0_1_0_2_7_0_2 - 4.166666666666656e-03*G6_0_1_0_2_7_1_0 - 4.166666666666657e-03*G6_0_1_0_2_7_2_1 - 4.166666666666657e-03*G6_0_1_0_2_7_3_2 + 4.166666666666654e-03*G6_0_1_1_2_4_0_0 + 4.166666666666654e-03*G6_0_1_1_2_4_0_1 + 4.166666666666654e-03*G6_0_1_1_2_4_0_2 - 4.166666666666654e-03*G6_0_1_1_2_4_1_0 - 4.166666666666654e-03*G6_0_1_1_2_4_2_1 - 4.166666666666654e-03*G6_0_1_1_2_4_3_2 + 8.333333333333309e-03*G6_0_1_1_2_5_0_0 + 8.333333333333309e-03*G6_0_1_1_2_5_0_1 + 8.333333333333307e-03*G6_0_1_1_2_5_0_2 - 8.333333333333309e-03*G6_0_1_1_2_5_1_0 - 8.333333333333309e-03*G6_0_1_1_2_5_2_1 - 8.333333333333309e-03*G6_0_1_1_2_5_3_2 + 4.166666666666654e-03*G6_0_1_1_2_6_0_0 + 4.166666666666654e-03*G6_0_1_1_2_6_0_1 + 4.166666666666654e-03*G6_0_1_1_2_6_0_2 - 4.166666666666654e-03*G6_0_1_1_2_6_1_0 - 4.166666666666654e-03*G6_0_1_1_2_6_2_1 - 4.166666666666654e-03*G6_0_1_1_2_6_3_2 + 4.166666666666655e-03*G6_0_1_1_2_7_0_0 + 4.166666666666655e-03*G6_0_1_1_2_7_0_1 + 4.166666666666655e-03*G6_0_1_1_2_7_0_2 - 4.166666666666655e-03*G6_0_1_1_2_7_1_0 - 4.166666666666655e-03*G6_0_1_1_2_7_2_1 - 4.166666666666655e-03*G6_0_1_1_2_7_3_2 + 4.166666666666654e-03*G6_0_1_2_2_4_0_0 + 4.166666666666654e-03*G6_0_1_2_2_4_0_1 + 4.166666666666654e-03*G6_0_1_2_2_4_0_2 - 4.166666666666654e-03*G6_0_1_2_2_4_1_0 - 4.166666666666654e-03*G6_0_1_2_2_4_2_1 - 4.166666666666654e-03*G6_0_1_2_2_4_3_2 + 4.166666666666655e-03*G6_0_1_2_2_5_0_0 + 4.166666666666656e-03*G6_0_1_2_2_5_0_1 + 4.166666666666654e-03*G6_0_1_2_2_5_0_2 - 4.166666666666655e-03*G6_0_1_2_2_5_1_0 - 4.166666666666656e-03*G6_0_1_2_2_5_2_1 - 4.166666666666656e-03*G6_0_1_2_2_5_3_2 + 8.333333333333311e-03*G6_0_1_2_2_6_0_0 + 8.333333333333311e-03*G6_0_1_2_2_6_0_1 + 8.333333333333311e-03*G6_0_1_2_2_6_0_2 - 8.333333333333311e-03*G6_0_1_2_2_6_1_0 - 8.333333333333311e-03*G6_0_1_2_2_6_2_1 - 8.333333333333311e-03*G6_0_1_2_2_6_3_2 + 4.166666666666655e-03*G6_0_1_2_2_7_0_0 + 4.166666666666656e-03*G6_0_1_2_2_7_0_1 + 4.166666666666655e-03*G6_0_1_2_2_7_0_2 - 4.166666666666655e-03*G6_0_1_2_2_7_1_0 - 4.166666666666656e-03*G6_0_1_2_2_7_2_1 - 4.166666666666656e-03*G6_0_1_2_2_7_3_2 + 4.166666666666656e-03*G6_0_1_3_2_4_0_0 + 4.166666666666657e-03*G6_0_1_3_2_4_0_1 + 4.166666666666657e-03*G6_0_1_3_2_4_0_2 - 4.166666666666656e-03*G6_0_1_3_2_4_1_0 - 4.166666666666657e-03*G6_0_1_3_2_4_2_1 - 4.166666666666657e-03*G6_0_1_3_2_4_3_2 + 4.166666666666656e-03*G6_0_1_3_2_5_0_0 + 4.166666666666657e-03*G6_0_1_3_2_5_0_1 + 4.166666666666656e-03*G6_0_1_3_2_5_0_2 - 4.166666666666656e-03*G6_0_1_3_2_5_1_0 - 4.166666666666657e-03*G6_0_1_3_2_5_2_1 - 4.166666666666657e-03*G6_0_1_3_2_5_3_2 + 4.166666666666655e-03*G6_0_1_3_2_6_0_0 + 4.166666666666656e-03*G6_0_1_3_2_6_0_1 + 4.166666666666655e-03*G6_0_1_3_2_6_0_2 - 4.166666666666655e-03*G6_0_1_3_2_6_1_0 - 4.166666666666656e-03*G6_0_1_3_2_6_2_1 - 4.166666666666656e-03*G6_0_1_3_2_6_3_2 + 8.333333333333311e-03*G6_0_1_3_2_7_0_0 + 8.333333333333311e-03*G6_0_1_3_2_7_0_1 + 8.333333333333311e-03*G6_0_1_3_2_7_0_2 - 8.333333333333311e-03*G6_0_1_3_2_7_1_0 - 8.333333333333311e-03*G6_0_1_3_2_7_2_1 - 8.333333333333311e-03*G6_0_1_3_2_7_3_2 + 8.333333333333309e-03*G6_0_2_0_2_8_0_0 + 8.333333333333311e-03*G6_0_2_0_2_8_0_1 + 8.333333333333311e-03*G6_0_2_0_2_8_0_2 - 8.333333333333309e-03*G6_0_2_0_2_8_1_0 - 8.333333333333311e-03*G6_0_2_0_2_8_2_1 - 8.333333333333311e-03*G6_0_2_0_2_8_3_2 + 4.166666666666655e-03*G6_0_2_0_2_9_0_0 + 4.166666666666655e-03*G6_0_2_0_2_9_0_1 + 4.166666666666655e-03*G6_0_2_0_2_9_0_2 - 4.166666666666655e-03*G6_0_2_0_2_9_1_0 - 4.166666666666655e-03*G6_0_2_0_2_9_2_1 - 4.166666666666655e-03*G6_0_2_0_2_9_3_2 + 4.166666666666654e-03*G6_0_2_0_2_10_0_0 + 4.166666666666656e-03*G6_0_2_0_2_10_0_1 + 4.166666666666655e-03*G6_0_2_0_2_10_0_2 - 4.166666666666654e-03*G6_0_2_0_2_10_1_0 - 4.166666666666656e-03*G6_0_2_0_2_10_2_1 - 4.166666666666656e-03*G6_0_2_0_2_10_3_2 + 4.166666666666656e-03*G6_0_2_0_2_11_0_0 + 4.166666666666657e-03*G6_0_2_0_2_11_0_1 + 4.166666666666657e-03*G6_0_2_0_2_11_0_2 - 4.166666666666656e-03*G6_0_2_0_2_11_1_0 - 4.166666666666657e-03*G6_0_2_0_2_11_2_1 - 4.166666666666657e-03*G6_0_2_0_2_11_3_2 + 4.166666666666654e-03*G6_0_2_1_2_8_0_0 + 4.166666666666654e-03*G6_0_2_1_2_8_0_1 + 4.166666666666654e-03*G6_0_2_1_2_8_0_2 - 4.166666666666654e-03*G6_0_2_1_2_8_1_0 - 4.166666666666654e-03*G6_0_2_1_2_8_2_1 - 4.166666666666654e-03*G6_0_2_1_2_8_3_2 + 8.333333333333309e-03*G6_0_2_1_2_9_0_0 + 8.333333333333309e-03*G6_0_2_1_2_9_0_1 + 8.333333333333307e-03*G6_0_2_1_2_9_0_2 - 8.333333333333309e-03*G6_0_2_1_2_9_1_0 - 8.333333333333309e-03*G6_0_2_1_2_9_2_1 - 8.333333333333309e-03*G6_0_2_1_2_9_3_2 + 4.166666666666654e-03*G6_0_2_1_2_10_0_0 + 4.166666666666654e-03*G6_0_2_1_2_10_0_1 + 4.166666666666654e-03*G6_0_2_1_2_10_0_2 - 4.166666666666654e-03*G6_0_2_1_2_10_1_0 - 4.166666666666654e-03*G6_0_2_1_2_10_2_1 - 4.166666666666654e-03*G6_0_2_1_2_10_3_2 + 4.166666666666655e-03*G6_0_2_1_2_11_0_0 + 4.166666666666655e-03*G6_0_2_1_2_11_0_1 + 4.166666666666655e-03*G6_0_2_1_2_11_0_2 - 4.166666666666655e-03*G6_0_2_1_2_11_1_0 - 4.166666666666655e-03*G6_0_2_1_2_11_2_1 - 4.166666666666655e-03*G6_0_2_1_2_11_3_2 + 4.166666666666654e-03*G6_0_2_2_2_8_0_0 + 4.166666666666654e-03*G6_0_2_2_2_8_0_1 + 4.166666666666654e-03*G6_0_2_2_2_8_0_2 - 4.166666666666654e-03*G6_0_2_2_2_8_1_0 - 4.166666666666654e-03*G6_0_2_2_2_8_2_1 - 4.166666666666654e-03*G6_0_2_2_2_8_3_2 + 4.166666666666655e-03*G6_0_2_2_2_9_0_0 + 4.166666666666656e-03*G6_0_2_2_2_9_0_1 + 4.166666666666654e-03*G6_0_2_2_2_9_0_2 - 4.166666666666655e-03*G6_0_2_2_2_9_1_0 - 4.166666666666656e-03*G6_0_2_2_2_9_2_1 - 4.166666666666656e-03*G6_0_2_2_2_9_3_2 + 8.333333333333311e-03*G6_0_2_2_2_10_0_0 + 8.333333333333311e-03*G6_0_2_2_2_10_0_1 + 8.333333333333311e-03*G6_0_2_2_2_10_0_2 - 8.333333333333311e-03*G6_0_2_2_2_10_1_0 - 8.333333333333311e-03*G6_0_2_2_2_10_2_1 - 8.333333333333311e-03*G6_0_2_2_2_10_3_2 + 4.166666666666655e-03*G6_0_2_2_2_11_0_0 + 4.166666666666656e-03*G6_0_2_2_2_11_0_1 + 4.166666666666655e-03*G6_0_2_2_2_11_0_2 - 4.166666666666655e-03*G6_0_2_2_2_11_1_0 - 4.166666666666656e-03*G6_0_2_2_2_11_2_1 - 4.166666666666656e-03*G6_0_2_2_2_11_3_2 + 4.166666666666656e-03*G6_0_2_3_2_8_0_0 + 4.166666666666657e-03*G6_0_2_3_2_8_0_1 + 4.166666666666657e-03*G6_0_2_3_2_8_0_2 - 4.166666666666656e-03*G6_0_2_3_2_8_1_0 - 4.166666666666657e-03*G6_0_2_3_2_8_2_1 - 4.166666666666657e-03*G6_0_2_3_2_8_3_2 + 4.166666666666656e-03*G6_0_2_3_2_9_0_0 + 4.166666666666657e-03*G6_0_2_3_2_9_0_1 + 4.166666666666656e-03*G6_0_2_3_2_9_0_2 - 4.166666666666656e-03*G6_0_2_3_2_9_1_0 - 4.166666666666657e-03*G6_0_2_3_2_9_2_1 - 4.166666666666657e-03*G6_0_2_3_2_9_3_2 + 4.166666666666655e-03*G6_0_2_3_2_10_0_0 + 4.166666666666656e-03*G6_0_2_3_2_10_0_1 + 4.166666666666655e-03*G6_0_2_3_2_10_0_2 - 4.166666666666655e-03*G6_0_2_3_2_10_1_0 - 4.166666666666656e-03*G6_0_2_3_2_10_2_1 - 4.166666666666656e-03*G6_0_2_3_2_10_3_2 + 8.333333333333311e-03*G6_0_2_3_2_11_0_0 + 8.333333333333311e-03*G6_0_2_3_2_11_0_1 + 8.333333333333311e-03*G6_0_2_3_2_11_0_2 - 8.333333333333311e-03*G6_0_2_3_2_11_1_0 - 8.333333333333311e-03*G6_0_2_3_2_11_2_1 - 8.333333333333311e-03*G6_0_2_3_2_11_3_2 + 8.333333333333309e-03*G6_1_0_4_2_0_0_0 + 8.333333333333311e-03*G6_1_0_4_2_0_0_1 + 8.333333333333311e-03*G6_1_0_4_2_0_0_2 - 8.333333333333309e-03*G6_1_0_4_2_0_1_0 - 8.333333333333311e-03*G6_1_0_4_2_0_2_1 - 8.333333333333311e-03*G6_1_0_4_2_0_3_2 + 4.166666666666654e-03*G6_1_0_4_2_1_0_0 + 4.166666666666654e-03*G6_1_0_4_2_1_0_1 + 4.166666666666654e-03*G6_1_0_4_2_1_0_2 - 4.166666666666654e-03*G6_1_0_4_2_1_1_0 - 4.166666666666654e-03*G6_1_0_4_2_1_2_1 - 4.166666666666654e-03*G6_1_0_4_2_1_3_2 + 4.166666666666654e-03*G6_1_0_4_2_2_0_0 + 4.166666666666654e-03*G6_1_0_4_2_2_0_1 + 4.166666666666654e-03*G6_1_0_4_2_2_0_2 - 4.166666666666654e-03*G6_1_0_4_2_2_1_0 - 4.166666666666654e-03*G6_1_0_4_2_2_2_1 - 4.166666666666654e-03*G6_1_0_4_2_2_3_2 + 4.166666666666656e-03*G6_1_0_4_2_3_0_0 + 4.166666666666657e-03*G6_1_0_4_2_3_0_1 + 4.166666666666657e-03*G6_1_0_4_2_3_0_2 - 4.166666666666656e-03*G6_1_0_4_2_3_1_0 - 4.166666666666657e-03*G6_1_0_4_2_3_2_1 - 4.166666666666657e-03*G6_1_0_4_2_3_3_2 + 4.166666666666655e-03*G6_1_0_5_2_0_0_0 + 4.166666666666655e-03*G6_1_0_5_2_0_0_1 + 4.166666666666655e-03*G6_1_0_5_2_0_0_2 - 4.166666666666655e-03*G6_1_0_5_2_0_1_0 - 4.166666666666655e-03*G6_1_0_5_2_0_2_1 - 4.166666666666655e-03*G6_1_0_5_2_0_3_2 + 8.333333333333309e-03*G6_1_0_5_2_1_0_0 + 8.333333333333309e-03*G6_1_0_5_2_1_0_1 + 8.333333333333307e-03*G6_1_0_5_2_1_0_2 - 8.333333333333309e-03*G6_1_0_5_2_1_1_0 - 8.333333333333309e-03*G6_1_0_5_2_1_2_1 - 8.333333333333309e-03*G6_1_0_5_2_1_3_2 + 4.166666666666655e-03*G6_1_0_5_2_2_0_0 + 4.166666666666656e-03*G6_1_0_5_2_2_0_1 + 4.166666666666654e-03*G6_1_0_5_2_2_0_2 - 4.166666666666655e-03*G6_1_0_5_2_2_1_0 - 4.166666666666656e-03*G6_1_0_5_2_2_2_1 - 4.166666666666656e-03*G6_1_0_5_2_2_3_2 + 4.166666666666656e-03*G6_1_0_5_2_3_0_0 + 4.166666666666657e-03*G6_1_0_5_2_3_0_1 + 4.166666666666656e-03*G6_1_0_5_2_3_0_2 - 4.166666666666656e-03*G6_1_0_5_2_3_1_0 - 4.166666666666657e-03*G6_1_0_5_2_3_2_1 - 4.166666666666657e-03*G6_1_0_5_2_3_3_2 + 4.166666666666654e-03*G6_1_0_6_2_0_0_0 + 4.166666666666656e-03*G6_1_0_6_2_0_0_1 + 4.166666666666655e-03*G6_1_0_6_2_0_0_2 - 4.166666666666654e-03*G6_1_0_6_2_0_1_0 - 4.166666666666656e-03*G6_1_0_6_2_0_2_1 - 4.166666666666656e-03*G6_1_0_6_2_0_3_2 + 4.166666666666654e-03*G6_1_0_6_2_1_0_0 + 4.166666666666654e-03*G6_1_0_6_2_1_0_1 + 4.166666666666654e-03*G6_1_0_6_2_1_0_2 - 4.166666666666654e-03*G6_1_0_6_2_1_1_0 - 4.166666666666654e-03*G6_1_0_6_2_1_2_1 - 4.166666666666654e-03*G6_1_0_6_2_1_3_2 + 8.333333333333311e-03*G6_1_0_6_2_2_0_0 + 8.333333333333311e-03*G6_1_0_6_2_2_0_1 + 8.333333333333311e-03*G6_1_0_6_2_2_0_2 - 8.333333333333311e-03*G6_1_0_6_2_2_1_0 - 8.333333333333311e-03*G6_1_0_6_2_2_2_1 - 8.333333333333311e-03*G6_1_0_6_2_2_3_2 + 4.166666666666655e-03*G6_1_0_6_2_3_0_0 + 4.166666666666656e-03*G6_1_0_6_2_3_0_1 + 4.166666666666655e-03*G6_1_0_6_2_3_0_2 - 4.166666666666655e-03*G6_1_0_6_2_3_1_0 - 4.166666666666656e-03*G6_1_0_6_2_3_2_1 - 4.166666666666656e-03*G6_1_0_6_2_3_3_2 + 4.166666666666656e-03*G6_1_0_7_2_0_0_0 + 4.166666666666657e-03*G6_1_0_7_2_0_0_1 + 4.166666666666657e-03*G6_1_0_7_2_0_0_2 - 4.166666666666656e-03*G6_1_0_7_2_0_1_0 - 4.166666666666657e-03*G6_1_0_7_2_0_2_1 - 4.166666666666657e-03*G6_1_0_7_2_0_3_2 + 4.166666666666655e-03*G6_1_0_7_2_1_0_0 + 4.166666666666655e-03*G6_1_0_7_2_1_0_1 + 4.166666666666655e-03*G6_1_0_7_2_1_0_2 - 4.166666666666655e-03*G6_1_0_7_2_1_1_0 - 4.166666666666655e-03*G6_1_0_7_2_1_2_1 - 4.166666666666655e-03*G6_1_0_7_2_1_3_2 + 4.166666666666655e-03*G6_1_0_7_2_2_0_0 + 4.166666666666656e-03*G6_1_0_7_2_2_0_1 + 4.166666666666655e-03*G6_1_0_7_2_2_0_2 - 4.166666666666655e-03*G6_1_0_7_2_2_1_0 - 4.166666666666656e-03*G6_1_0_7_2_2_2_1 - 4.166666666666656e-03*G6_1_0_7_2_2_3_2 + 8.333333333333311e-03*G6_1_0_7_2_3_0_0 + 8.333333333333311e-03*G6_1_0_7_2_3_0_1 + 8.333333333333311e-03*G6_1_0_7_2_3_0_2 - 8.333333333333311e-03*G6_1_0_7_2_3_1_0 - 8.333333333333311e-03*G6_1_0_7_2_3_2_1 - 8.333333333333311e-03*G6_1_0_7_2_3_3_2 + 8.333333333333309e-03*G6_1_1_4_2_4_0_0 + 8.333333333333311e-03*G6_1_1_4_2_4_0_1 + 8.333333333333311e-03*G6_1_1_4_2_4_0_2 - 8.333333333333309e-03*G6_1_1_4_2_4_1_0 - 8.333333333333311e-03*G6_1_1_4_2_4_2_1 - 8.333333333333311e-03*G6_1_1_4_2_4_3_2 + 4.166666666666654e-03*G6_1_1_4_2_5_0_0 + 4.166666666666654e-03*G6_1_1_4_2_5_0_1 + 4.166666666666654e-03*G6_1_1_4_2_5_0_2 - 4.166666666666654e-03*G6_1_1_4_2_5_1_0 - 4.166666666666654e-03*G6_1_1_4_2_5_2_1 - 4.166666666666654e-03*G6_1_1_4_2_5_3_2 + 4.166666666666654e-03*G6_1_1_4_2_6_0_0 + 4.166666666666654e-03*G6_1_1_4_2_6_0_1 + 4.166666666666654e-03*G6_1_1_4_2_6_0_2 - 4.166666666666654e-03*G6_1_1_4_2_6_1_0 - 4.166666666666654e-03*G6_1_1_4_2_6_2_1 - 4.166666666666654e-03*G6_1_1_4_2_6_3_2 + 4.166666666666656e-03*G6_1_1_4_2_7_0_0 + 4.166666666666657e-03*G6_1_1_4_2_7_0_1 + 4.166666666666657e-03*G6_1_1_4_2_7_0_2 - 4.166666666666656e-03*G6_1_1_4_2_7_1_0 - 4.166666666666657e-03*G6_1_1_4_2_7_2_1 - 4.166666666666657e-03*G6_1_1_4_2_7_3_2 + 4.166666666666654e-03*G6_1_1_5_2_4_0_0 + 4.166666666666654e-03*G6_1_1_5_2_4_0_1 + 4.166666666666654e-03*G6_1_1_5_2_4_0_2 - 4.166666666666654e-03*G6_1_1_5_2_4_1_0 - 4.166666666666654e-03*G6_1_1_5_2_4_2_1 - 4.166666666666654e-03*G6_1_1_5_2_4_3_2 + 8.333333333333309e-03*G6_1_1_5_2_5_0_0 + 8.333333333333309e-03*G6_1_1_5_2_5_0_1 + 8.333333333333307e-03*G6_1_1_5_2_5_0_2 - 8.333333333333309e-03*G6_1_1_5_2_5_1_0 - 8.333333333333309e-03*G6_1_1_5_2_5_2_1 - 8.333333333333309e-03*G6_1_1_5_2_5_3_2 + 4.166666666666655e-03*G6_1_1_5_2_6_0_0 + 4.166666666666656e-03*G6_1_1_5_2_6_0_1 + 4.166666666666654e-03*G6_1_1_5_2_6_0_2 - 4.166666666666655e-03*G6_1_1_5_2_6_1_0 - 4.166666666666656e-03*G6_1_1_5_2_6_2_1 - 4.166666666666656e-03*G6_1_1_5_2_6_3_2 + 4.166666666666656e-03*G6_1_1_5_2_7_0_0 + 4.166666666666657e-03*G6_1_1_5_2_7_0_1 + 4.166666666666656e-03*G6_1_1_5_2_7_0_2 - 4.166666666666656e-03*G6_1_1_5_2_7_1_0 - 4.166666666666657e-03*G6_1_1_5_2_7_2_1 - 4.166666666666657e-03*G6_1_1_5_2_7_3_2 + 4.166666666666654e-03*G6_1_1_6_2_4_0_0 + 4.166666666666654e-03*G6_1_1_6_2_4_0_1 + 4.166666666666654e-03*G6_1_1_6_2_4_0_2 - 4.166666666666654e-03*G6_1_1_6_2_4_1_0 - 4.166666666666654e-03*G6_1_1_6_2_4_2_1 - 4.166666666666654e-03*G6_1_1_6_2_4_3_2 + 4.166666666666655e-03*G6_1_1_6_2_5_0_0 + 4.166666666666656e-03*G6_1_1_6_2_5_0_1 + 4.166666666666654e-03*G6_1_1_6_2_5_0_2 - 4.166666666666655e-03*G6_1_1_6_2_5_1_0 - 4.166666666666656e-03*G6_1_1_6_2_5_2_1 - 4.166666666666656e-03*G6_1_1_6_2_5_3_2 + 8.333333333333311e-03*G6_1_1_6_2_6_0_0 + 8.333333333333311e-03*G6_1_1_6_2_6_0_1 + 8.333333333333311e-03*G6_1_1_6_2_6_0_2 - 8.333333333333311e-03*G6_1_1_6_2_6_1_0 - 8.333333333333311e-03*G6_1_1_6_2_6_2_1 - 8.333333333333311e-03*G6_1_1_6_2_6_3_2 + 4.166666666666655e-03*G6_1_1_6_2_7_0_0 + 4.166666666666656e-03*G6_1_1_6_2_7_0_1 + 4.166666666666655e-03*G6_1_1_6_2_7_0_2 - 4.166666666666655e-03*G6_1_1_6_2_7_1_0 - 4.166666666666656e-03*G6_1_1_6_2_7_2_1 - 4.166666666666656e-03*G6_1_1_6_2_7_3_2 + 4.166666666666656e-03*G6_1_1_7_2_4_0_0 + 4.166666666666657e-03*G6_1_1_7_2_4_0_1 + 4.166666666666657e-03*G6_1_1_7_2_4_0_2 - 4.166666666666656e-03*G6_1_1_7_2_4_1_0 - 4.166666666666657e-03*G6_1_1_7_2_4_2_1 - 4.166666666666657e-03*G6_1_1_7_2_4_3_2 + 4.166666666666656e-03*G6_1_1_7_2_5_0_0 + 4.166666666666657e-03*G6_1_1_7_2_5_0_1 + 4.166666666666656e-03*G6_1_1_7_2_5_0_2 - 4.166666666666656e-03*G6_1_1_7_2_5_1_0 - 4.166666666666657e-03*G6_1_1_7_2_5_2_1 - 4.166666666666657e-03*G6_1_1_7_2_5_3_2 + 4.166666666666655e-03*G6_1_1_7_2_6_0_0 + 4.166666666666656e-03*G6_1_1_7_2_6_0_1 + 4.166666666666655e-03*G6_1_1_7_2_6_0_2 - 4.166666666666655e-03*G6_1_1_7_2_6_1_0 - 4.166666666666656e-03*G6_1_1_7_2_6_2_1 - 4.166666666666656e-03*G6_1_1_7_2_6_3_2 + 8.333333333333311e-03*G6_1_1_7_2_7_0_0 + 8.333333333333311e-03*G6_1_1_7_2_7_0_1 + 8.333333333333311e-03*G6_1_1_7_2_7_0_2 - 8.333333333333311e-03*G6_1_1_7_2_7_1_0 - 8.333333333333311e-03*G6_1_1_7_2_7_2_1 - 8.333333333333311e-03*G6_1_1_7_2_7_3_2 + 8.333333333333309e-03*G6_1_2_4_2_8_0_0 + 8.333333333333311e-03*G6_1_2_4_2_8_0_1 + 8.333333333333311e-03*G6_1_2_4_2_8_0_2 - 8.333333333333309e-03*G6_1_2_4_2_8_1_0 - 8.333333333333311e-03*G6_1_2_4_2_8_2_1 - 8.333333333333311e-03*G6_1_2_4_2_8_3_2 + 4.166666666666654e-03*G6_1_2_4_2_9_0_0 + 4.166666666666654e-03*G6_1_2_4_2_9_0_1 + 4.166666666666654e-03*G6_1_2_4_2_9_0_2 - 4.166666666666654e-03*G6_1_2_4_2_9_1_0 - 4.166666666666654e-03*G6_1_2_4_2_9_2_1 - 4.166666666666654e-03*G6_1_2_4_2_9_3_2 + 4.166666666666654e-03*G6_1_2_4_2_10_0_0 + 4.166666666666654e-03*G6_1_2_4_2_10_0_1 + 4.166666666666654e-03*G6_1_2_4_2_10_0_2 - 4.166666666666654e-03*G6_1_2_4_2_10_1_0 - 4.166666666666654e-03*G6_1_2_4_2_10_2_1 - 4.166666666666654e-03*G6_1_2_4_2_10_3_2 + 4.166666666666656e-03*G6_1_2_4_2_11_0_0 + 4.166666666666657e-03*G6_1_2_4_2_11_0_1 + 4.166666666666657e-03*G6_1_2_4_2_11_0_2 - 4.166666666666656e-03*G6_1_2_4_2_11_1_0 - 4.166666666666657e-03*G6_1_2_4_2_11_2_1 - 4.166666666666657e-03*G6_1_2_4_2_11_3_2 + 4.166666666666654e-03*G6_1_2_5_2_8_0_0 + 4.166666666666654e-03*G6_1_2_5_2_8_0_1 + 4.166666666666654e-03*G6_1_2_5_2_8_0_2 - 4.166666666666654e-03*G6_1_2_5_2_8_1_0 - 4.166666666666654e-03*G6_1_2_5_2_8_2_1 - 4.166666666666654e-03*G6_1_2_5_2_8_3_2 + 8.333333333333309e-03*G6_1_2_5_2_9_0_0 + 8.333333333333309e-03*G6_1_2_5_2_9_0_1 + 8.333333333333307e-03*G6_1_2_5_2_9_0_2 - 8.333333333333309e-03*G6_1_2_5_2_9_1_0 - 8.333333333333309e-03*G6_1_2_5_2_9_2_1 - 8.333333333333309e-03*G6_1_2_5_2_9_3_2 + 4.166666666666655e-03*G6_1_2_5_2_10_0_0 + 4.166666666666656e-03*G6_1_2_5_2_10_0_1 + 4.166666666666654e-03*G6_1_2_5_2_10_0_2 - 4.166666666666655e-03*G6_1_2_5_2_10_1_0 - 4.166666666666656e-03*G6_1_2_5_2_10_2_1 - 4.166666666666656e-03*G6_1_2_5_2_10_3_2 + 4.166666666666656e-03*G6_1_2_5_2_11_0_0 + 4.166666666666657e-03*G6_1_2_5_2_11_0_1 + 4.166666666666656e-03*G6_1_2_5_2_11_0_2 - 4.166666666666656e-03*G6_1_2_5_2_11_1_0 - 4.166666666666657e-03*G6_1_2_5_2_11_2_1 - 4.166666666666657e-03*G6_1_2_5_2_11_3_2 + 4.166666666666654e-03*G6_1_2_6_2_8_0_0 + 4.166666666666654e-03*G6_1_2_6_2_8_0_1 + 4.166666666666654e-03*G6_1_2_6_2_8_0_2 - 4.166666666666654e-03*G6_1_2_6_2_8_1_0 - 4.166666666666654e-03*G6_1_2_6_2_8_2_1 - 4.166666666666654e-03*G6_1_2_6_2_8_3_2 + 4.166666666666655e-03*G6_1_2_6_2_9_0_0 + 4.166666666666656e-03*G6_1_2_6_2_9_0_1 + 4.166666666666654e-03*G6_1_2_6_2_9_0_2 - 4.166666666666655e-03*G6_1_2_6_2_9_1_0 - 4.166666666666656e-03*G6_1_2_6_2_9_2_1 - 4.166666666666656e-03*G6_1_2_6_2_9_3_2 + 8.333333333333311e-03*G6_1_2_6_2_10_0_0 + 8.333333333333311e-03*G6_1_2_6_2_10_0_1 + 8.333333333333311e-03*G6_1_2_6_2_10_0_2 - 8.333333333333311e-03*G6_1_2_6_2_10_1_0 - 8.333333333333311e-03*G6_1_2_6_2_10_2_1 - 8.333333333333311e-03*G6_1_2_6_2_10_3_2 + 4.166666666666655e-03*G6_1_2_6_2_11_0_0 + 4.166666666666656e-03*G6_1_2_6_2_11_0_1 + 4.166666666666655e-03*G6_1_2_6_2_11_0_2 - 4.166666666666655e-03*G6_1_2_6_2_11_1_0 - 4.166666666666656e-03*G6_1_2_6_2_11_2_1 - 4.166666666666656e-03*G6_1_2_6_2_11_3_2 + 4.166666666666656e-03*G6_1_2_7_2_8_0_0 + 4.166666666666657e-03*G6_1_2_7_2_8_0_1 + 4.166666666666657e-03*G6_1_2_7_2_8_0_2 - 4.166666666666656e-03*G6_1_2_7_2_8_1_0 - 4.166666666666657e-03*G6_1_2_7_2_8_2_1 - 4.166666666666657e-03*G6_1_2_7_2_8_3_2 + 4.166666666666656e-03*G6_1_2_7_2_9_0_0 + 4.166666666666657e-03*G6_1_2_7_2_9_0_1 + 4.166666666666656e-03*G6_1_2_7_2_9_0_2 - 4.166666666666656e-03*G6_1_2_7_2_9_1_0 - 4.166666666666657e-03*G6_1_2_7_2_9_2_1 - 4.166666666666657e-03*G6_1_2_7_2_9_3_2 + 4.166666666666655e-03*G6_1_2_7_2_10_0_0 + 4.166666666666656e-03*G6_1_2_7_2_10_0_1 + 4.166666666666655e-03*G6_1_2_7_2_10_0_2 - 4.166666666666655e-03*G6_1_2_7_2_10_1_0 - 4.166666666666656e-03*G6_1_2_7_2_10_2_1 - 4.166666666666656e-03*G6_1_2_7_2_10_3_2 + 8.333333333333311e-03*G6_1_2_7_2_11_0_0 + 8.333333333333311e-03*G6_1_2_7_2_11_0_1 + 8.333333333333311e-03*G6_1_2_7_2_11_0_2 - 8.333333333333311e-03*G6_1_2_7_2_11_1_0 - 8.333333333333311e-03*G6_1_2_7_2_11_2_1 - 8.333333333333311e-03*G6_1_2_7_2_11_3_2 + 8.333333333333309e-03*G6_2_0_8_2_0_0_0 + 8.333333333333311e-03*G6_2_0_8_2_0_0_1 + 8.333333333333311e-03*G6_2_0_8_2_0_0_2 - 8.333333333333309e-03*G6_2_0_8_2_0_1_0 - 8.333333333333311e-03*G6_2_0_8_2_0_2_1 - 8.333333333333311e-03*G6_2_0_8_2_0_3_2 + 4.166666666666654e-03*G6_2_0_8_2_1_0_0 + 4.166666666666654e-03*G6_2_0_8_2_1_0_1 + 4.166666666666654e-03*G6_2_0_8_2_1_0_2 - 4.166666666666654e-03*G6_2_0_8_2_1_1_0 - 4.166666666666654e-03*G6_2_0_8_2_1_2_1 - 4.166666666666654e-03*G6_2_0_8_2_1_3_2 + 4.166666666666654e-03*G6_2_0_8_2_2_0_0 + 4.166666666666654e-03*G6_2_0_8_2_2_0_1 + 4.166666666666654e-03*G6_2_0_8_2_2_0_2 - 4.166666666666654e-03*G6_2_0_8_2_2_1_0 - 4.166666666666654e-03*G6_2_0_8_2_2_2_1 - 4.166666666666654e-03*G6_2_0_8_2_2_3_2 + 4.166666666666656e-03*G6_2_0_8_2_3_0_0 + 4.166666666666657e-03*G6_2_0_8_2_3_0_1 + 4.166666666666657e-03*G6_2_0_8_2_3_0_2 - 4.166666666666656e-03*G6_2_0_8_2_3_1_0 - 4.166666666666657e-03*G6_2_0_8_2_3_2_1 - 4.166666666666657e-03*G6_2_0_8_2_3_3_2 + 4.166666666666655e-03*G6_2_0_9_2_0_0_0 + 4.166666666666655e-03*G6_2_0_9_2_0_0_1 + 4.166666666666655e-03*G6_2_0_9_2_0_0_2 - 4.166666666666655e-03*G6_2_0_9_2_0_1_0 - 4.166666666666655e-03*G6_2_0_9_2_0_2_1 - 4.166666666666655e-03*G6_2_0_9_2_0_3_2 + 8.333333333333309e-03*G6_2_0_9_2_1_0_0 + 8.333333333333309e-03*G6_2_0_9_2_1_0_1 + 8.333333333333307e-03*G6_2_0_9_2_1_0_2 - 8.333333333333309e-03*G6_2_0_9_2_1_1_0 - 8.333333333333309e-03*G6_2_0_9_2_1_2_1 - 8.333333333333309e-03*G6_2_0_9_2_1_3_2 + 4.166666666666655e-03*G6_2_0_9_2_2_0_0 + 4.166666666666656e-03*G6_2_0_9_2_2_0_1 + 4.166666666666654e-03*G6_2_0_9_2_2_0_2 - 4.166666666666655e-03*G6_2_0_9_2_2_1_0 - 4.166666666666656e-03*G6_2_0_9_2_2_2_1 - 4.166666666666656e-03*G6_2_0_9_2_2_3_2 + 4.166666666666656e-03*G6_2_0_9_2_3_0_0 + 4.166666666666657e-03*G6_2_0_9_2_3_0_1 + 4.166666666666656e-03*G6_2_0_9_2_3_0_2 - 4.166666666666656e-03*G6_2_0_9_2_3_1_0 - 4.166666666666657e-03*G6_2_0_9_2_3_2_1 - 4.166666666666657e-03*G6_2_0_9_2_3_3_2 + 4.166666666666654e-03*G6_2_0_10_2_0_0_0 + 4.166666666666656e-03*G6_2_0_10_2_0_0_1 + 4.166666666666655e-03*G6_2_0_10_2_0_0_2 - 4.166666666666654e-03*G6_2_0_10_2_0_1_0 - 4.166666666666656e-03*G6_2_0_10_2_0_2_1 - 4.166666666666656e-03*G6_2_0_10_2_0_3_2 + 4.166666666666654e-03*G6_2_0_10_2_1_0_0 + 4.166666666666654e-03*G6_2_0_10_2_1_0_1 + 4.166666666666654e-03*G6_2_0_10_2_1_0_2 - 4.166666666666654e-03*G6_2_0_10_2_1_1_0 - 4.166666666666654e-03*G6_2_0_10_2_1_2_1 - 4.166666666666654e-03*G6_2_0_10_2_1_3_2 + 8.333333333333311e-03*G6_2_0_10_2_2_0_0 + 8.333333333333311e-03*G6_2_0_10_2_2_0_1 + 8.333333333333311e-03*G6_2_0_10_2_2_0_2 - 8.333333333333311e-03*G6_2_0_10_2_2_1_0 - 8.333333333333311e-03*G6_2_0_10_2_2_2_1 - 8.333333333333311e-03*G6_2_0_10_2_2_3_2 + 4.166666666666655e-03*G6_2_0_10_2_3_0_0 + 4.166666666666656e-03*G6_2_0_10_2_3_0_1 + 4.166666666666655e-03*G6_2_0_10_2_3_0_2 - 4.166666666666655e-03*G6_2_0_10_2_3_1_0 - 4.166666666666656e-03*G6_2_0_10_2_3_2_1 - 4.166666666666656e-03*G6_2_0_10_2_3_3_2 + 4.166666666666656e-03*G6_2_0_11_2_0_0_0 + 4.166666666666657e-03*G6_2_0_11_2_0_0_1 + 4.166666666666657e-03*G6_2_0_11_2_0_0_2 - 4.166666666666656e-03*G6_2_0_11_2_0_1_0 - 4.166666666666657e-03*G6_2_0_11_2_0_2_1 - 4.166666666666657e-03*G6_2_0_11_2_0_3_2 + 4.166666666666655e-03*G6_2_0_11_2_1_0_0 + 4.166666666666655e-03*G6_2_0_11_2_1_0_1 + 4.166666666666655e-03*G6_2_0_11_2_1_0_2 - 4.166666666666655e-03*G6_2_0_11_2_1_1_0 - 4.166666666666655e-03*G6_2_0_11_2_1_2_1 - 4.166666666666655e-03*G6_2_0_11_2_1_3_2 + 4.166666666666655e-03*G6_2_0_11_2_2_0_0 + 4.166666666666656e-03*G6_2_0_11_2_2_0_1 + 4.166666666666655e-03*G6_2_0_11_2_2_0_2 - 4.166666666666655e-03*G6_2_0_11_2_2_1_0 - 4.166666666666656e-03*G6_2_0_11_2_2_2_1 - 4.166666666666656e-03*G6_2_0_11_2_2_3_2 + 8.333333333333311e-03*G6_2_0_11_2_3_0_0 + 8.333333333333311e-03*G6_2_0_11_2_3_0_1 + 8.333333333333311e-03*G6_2_0_11_2_3_0_2 - 8.333333333333311e-03*G6_2_0_11_2_3_1_0 - 8.333333333333311e-03*G6_2_0_11_2_3_2_1 - 8.333333333333311e-03*G6_2_0_11_2_3_3_2 + 8.333333333333309e-03*G6_2_1_8_2_4_0_0 + 8.333333333333311e-03*G6_2_1_8_2_4_0_1 + 8.333333333333311e-03*G6_2_1_8_2_4_0_2 - 8.333333333333309e-03*G6_2_1_8_2_4_1_0 - 8.333333333333311e-03*G6_2_1_8_2_4_2_1 - 8.333333333333311e-03*G6_2_1_8_2_4_3_2 + 4.166666666666654e-03*G6_2_1_8_2_5_0_0 + 4.166666666666654e-03*G6_2_1_8_2_5_0_1 + 4.166666666666654e-03*G6_2_1_8_2_5_0_2 - 4.166666666666654e-03*G6_2_1_8_2_5_1_0 - 4.166666666666654e-03*G6_2_1_8_2_5_2_1 - 4.166666666666654e-03*G6_2_1_8_2_5_3_2 + 4.166666666666654e-03*G6_2_1_8_2_6_0_0 + 4.166666666666654e-03*G6_2_1_8_2_6_0_1 + 4.166666666666654e-03*G6_2_1_8_2_6_0_2 - 4.166666666666654e-03*G6_2_1_8_2_6_1_0 - 4.166666666666654e-03*G6_2_1_8_2_6_2_1 - 4.166666666666654e-03*G6_2_1_8_2_6_3_2 + 4.166666666666656e-03*G6_2_1_8_2_7_0_0 + 4.166666666666657e-03*G6_2_1_8_2_7_0_1 + 4.166666666666657e-03*G6_2_1_8_2_7_0_2 - 4.166666666666656e-03*G6_2_1_8_2_7_1_0 - 4.166666666666657e-03*G6_2_1_8_2_7_2_1 - 4.166666666666657e-03*G6_2_1_8_2_7_3_2 + 4.166666666666654e-03*G6_2_1_9_2_4_0_0 + 4.166666666666654e-03*G6_2_1_9_2_4_0_1 + 4.166666666666654e-03*G6_2_1_9_2_4_0_2 - 4.166666666666654e-03*G6_2_1_9_2_4_1_0 - 4.166666666666654e-03*G6_2_1_9_2_4_2_1 - 4.166666666666654e-03*G6_2_1_9_2_4_3_2 + 8.333333333333309e-03*G6_2_1_9_2_5_0_0 + 8.333333333333309e-03*G6_2_1_9_2_5_0_1 + 8.333333333333307e-03*G6_2_1_9_2_5_0_2 - 8.333333333333309e-03*G6_2_1_9_2_5_1_0 - 8.333333333333309e-03*G6_2_1_9_2_5_2_1 - 8.333333333333309e-03*G6_2_1_9_2_5_3_2 + 4.166666666666655e-03*G6_2_1_9_2_6_0_0 + 4.166666666666656e-03*G6_2_1_9_2_6_0_1 + 4.166666666666654e-03*G6_2_1_9_2_6_0_2 - 4.166666666666655e-03*G6_2_1_9_2_6_1_0 - 4.166666666666656e-03*G6_2_1_9_2_6_2_1 - 4.166666666666656e-03*G6_2_1_9_2_6_3_2 + 4.166666666666656e-03*G6_2_1_9_2_7_0_0 + 4.166666666666657e-03*G6_2_1_9_2_7_0_1 + 4.166666666666656e-03*G6_2_1_9_2_7_0_2 - 4.166666666666656e-03*G6_2_1_9_2_7_1_0 - 4.166666666666657e-03*G6_2_1_9_2_7_2_1 - 4.166666666666657e-03*G6_2_1_9_2_7_3_2 + 4.166666666666654e-03*G6_2_1_10_2_4_0_0 + 4.166666666666654e-03*G6_2_1_10_2_4_0_1 + 4.166666666666654e-03*G6_2_1_10_2_4_0_2 - 4.166666666666654e-03*G6_2_1_10_2_4_1_0 - 4.166666666666654e-03*G6_2_1_10_2_4_2_1 - 4.166666666666654e-03*G6_2_1_10_2_4_3_2 + 4.166666666666655e-03*G6_2_1_10_2_5_0_0 + 4.166666666666656e-03*G6_2_1_10_2_5_0_1 + 4.166666666666654e-03*G6_2_1_10_2_5_0_2 - 4.166666666666655e-03*G6_2_1_10_2_5_1_0 - 4.166666666666656e-03*G6_2_1_10_2_5_2_1 - 4.166666666666656e-03*G6_2_1_10_2_5_3_2 + 8.333333333333311e-03*G6_2_1_10_2_6_0_0 + 8.333333333333311e-03*G6_2_1_10_2_6_0_1 + 8.333333333333311e-03*G6_2_1_10_2_6_0_2 - 8.333333333333311e-03*G6_2_1_10_2_6_1_0 - 8.333333333333311e-03*G6_2_1_10_2_6_2_1 - 8.333333333333311e-03*G6_2_1_10_2_6_3_2 + 4.166666666666655e-03*G6_2_1_10_2_7_0_0 + 4.166666666666656e-03*G6_2_1_10_2_7_0_1 + 4.166666666666655e-03*G6_2_1_10_2_7_0_2 - 4.166666666666655e-03*G6_2_1_10_2_7_1_0 - 4.166666666666656e-03*G6_2_1_10_2_7_2_1 - 4.166666666666656e-03*G6_2_1_10_2_7_3_2 + 4.166666666666656e-03*G6_2_1_11_2_4_0_0 + 4.166666666666657e-03*G6_2_1_11_2_4_0_1 + 4.166666666666657e-03*G6_2_1_11_2_4_0_2 - 4.166666666666656e-03*G6_2_1_11_2_4_1_0 - 4.166666666666657e-03*G6_2_1_11_2_4_2_1 - 4.166666666666657e-03*G6_2_1_11_2_4_3_2 + 4.166666666666656e-03*G6_2_1_11_2_5_0_0 + 4.166666666666657e-03*G6_2_1_11_2_5_0_1 + 4.166666666666656e-03*G6_2_1_11_2_5_0_2 - 4.166666666666656e-03*G6_2_1_11_2_5_1_0 - 4.166666666666657e-03*G6_2_1_11_2_5_2_1 - 4.166666666666657e-03*G6_2_1_11_2_5_3_2 + 4.166666666666655e-03*G6_2_1_11_2_6_0_0 + 4.166666666666656e-03*G6_2_1_11_2_6_0_1 + 4.166666666666655e-03*G6_2_1_11_2_6_0_2 - 4.166666666666655e-03*G6_2_1_11_2_6_1_0 - 4.166666666666656e-03*G6_2_1_11_2_6_2_1 - 4.166666666666656e-03*G6_2_1_11_2_6_3_2 + 8.333333333333311e-03*G6_2_1_11_2_7_0_0 + 8.333333333333311e-03*G6_2_1_11_2_7_0_1 + 8.333333333333311e-03*G6_2_1_11_2_7_0_2 - 8.333333333333311e-03*G6_2_1_11_2_7_1_0 - 8.333333333333311e-03*G6_2_1_11_2_7_2_1 - 8.333333333333311e-03*G6_2_1_11_2_7_3_2 + 8.333333333333309e-03*G6_2_2_8_2_8_0_0 + 8.333333333333311e-03*G6_2_2_8_2_8_0_1 + 8.333333333333311e-03*G6_2_2_8_2_8_0_2 - 8.333333333333309e-03*G6_2_2_8_2_8_1_0 - 8.333333333333311e-03*G6_2_2_8_2_8_2_1 - 8.333333333333311e-03*G6_2_2_8_2_8_3_2 + 4.166666666666654e-03*G6_2_2_8_2_9_0_0 + 4.166666666666654e-03*G6_2_2_8_2_9_0_1 + 4.166666666666654e-03*G6_2_2_8_2_9_0_2 - 4.166666666666654e-03*G6_2_2_8_2_9_1_0 - 4.166666666666654e-03*G6_2_2_8_2_9_2_1 - 4.166666666666654e-03*G6_2_2_8_2_9_3_2 + 4.166666666666654e-03*G6_2_2_8_2_10_0_0 + 4.166666666666654e-03*G6_2_2_8_2_10_0_1 + 4.166666666666654e-03*G6_2_2_8_2_10_0_2 - 4.166666666666654e-03*G6_2_2_8_2_10_1_0 - 4.166666666666654e-03*G6_2_2_8_2_10_2_1 - 4.166666666666654e-03*G6_2_2_8_2_10_3_2 + 4.166666666666656e-03*G6_2_2_8_2_11_0_0 + 4.166666666666657e-03*G6_2_2_8_2_11_0_1 + 4.166666666666657e-03*G6_2_2_8_2_11_0_2 - 4.166666666666656e-03*G6_2_2_8_2_11_1_0 - 4.166666666666657e-03*G6_2_2_8_2_11_2_1 - 4.166666666666657e-03*G6_2_2_8_2_11_3_2 + 4.166666666666654e-03*G6_2_2_9_2_8_0_0 + 4.166666666666654e-03*G6_2_2_9_2_8_0_1 + 4.166666666666654e-03*G6_2_2_9_2_8_0_2 - 4.166666666666654e-03*G6_2_2_9_2_8_1_0 - 4.166666666666654e-03*G6_2_2_9_2_8_2_1 - 4.166666666666654e-03*G6_2_2_9_2_8_3_2 + 8.333333333333309e-03*G6_2_2_9_2_9_0_0 + 8.333333333333309e-03*G6_2_2_9_2_9_0_1 + 8.333333333333307e-03*G6_2_2_9_2_9_0_2 - 8.333333333333309e-03*G6_2_2_9_2_9_1_0 - 8.333333333333309e-03*G6_2_2_9_2_9_2_1 - 8.333333333333309e-03*G6_2_2_9_2_9_3_2 + 4.166666666666655e-03*G6_2_2_9_2_10_0_0 + 4.166666666666656e-03*G6_2_2_9_2_10_0_1 + 4.166666666666654e-03*G6_2_2_9_2_10_0_2 - 4.166666666666655e-03*G6_2_2_9_2_10_1_0 - 4.166666666666656e-03*G6_2_2_9_2_10_2_1 - 4.166666666666656e-03*G6_2_2_9_2_10_3_2 + 4.166666666666656e-03*G6_2_2_9_2_11_0_0 + 4.166666666666657e-03*G6_2_2_9_2_11_0_1 + 4.166666666666656e-03*G6_2_2_9_2_11_0_2 - 4.166666666666656e-03*G6_2_2_9_2_11_1_0 - 4.166666666666657e-03*G6_2_2_9_2_11_2_1 - 4.166666666666657e-03*G6_2_2_9_2_11_3_2 + 4.166666666666654e-03*G6_2_2_10_2_8_0_0 + 4.166666666666654e-03*G6_2_2_10_2_8_0_1 + 4.166666666666654e-03*G6_2_2_10_2_8_0_2 - 4.166666666666654e-03*G6_2_2_10_2_8_1_0 - 4.166666666666654e-03*G6_2_2_10_2_8_2_1 - 4.166666666666654e-03*G6_2_2_10_2_8_3_2 + 4.166666666666655e-03*G6_2_2_10_2_9_0_0 + 4.166666666666656e-03*G6_2_2_10_2_9_0_1 + 4.166666666666654e-03*G6_2_2_10_2_9_0_2 - 4.166666666666655e-03*G6_2_2_10_2_9_1_0 - 4.166666666666656e-03*G6_2_2_10_2_9_2_1 - 4.166666666666656e-03*G6_2_2_10_2_9_3_2 + 8.333333333333311e-03*G6_2_2_10_2_10_0_0 + 8.333333333333311e-03*G6_2_2_10_2_10_0_1 + 8.333333333333311e-03*G6_2_2_10_2_10_0_2 - 8.333333333333311e-03*G6_2_2_10_2_10_1_0 - 8.333333333333311e-03*G6_2_2_10_2_10_2_1 - 8.333333333333311e-03*G6_2_2_10_2_10_3_2 + 4.166666666666655e-03*G6_2_2_10_2_11_0_0 + 4.166666666666656e-03*G6_2_2_10_2_11_0_1 + 4.166666666666655e-03*G6_2_2_10_2_11_0_2 - 4.166666666666655e-03*G6_2_2_10_2_11_1_0 - 4.166666666666656e-03*G6_2_2_10_2_11_2_1 - 4.166666666666656e-03*G6_2_2_10_2_11_3_2 + 4.166666666666656e-03*G6_2_2_11_2_8_0_0 + 4.166666666666657e-03*G6_2_2_11_2_8_0_1 + 4.166666666666657e-03*G6_2_2_11_2_8_0_2 - 4.166666666666656e-03*G6_2_2_11_2_8_1_0 - 4.166666666666657e-03*G6_2_2_11_2_8_2_1 - 4.166666666666657e-03*G6_2_2_11_2_8_3_2 + 4.166666666666656e-03*G6_2_2_11_2_9_0_0 + 4.166666666666657e-03*G6_2_2_11_2_9_0_1 + 4.166666666666656e-03*G6_2_2_11_2_9_0_2 - 4.166666666666656e-03*G6_2_2_11_2_9_1_0 - 4.166666666666657e-03*G6_2_2_11_2_9_2_1 - 4.166666666666657e-03*G6_2_2_11_2_9_3_2 + 4.166666666666655e-03*G6_2_2_11_2_10_0_0 + 4.166666666666656e-03*G6_2_2_11_2_10_0_1 + 4.166666666666655e-03*G6_2_2_11_2_10_0_2 - 4.166666666666655e-03*G6_2_2_11_2_10_1_0 - 4.166666666666656e-03*G6_2_2_11_2_10_2_1 - 4.166666666666656e-03*G6_2_2_11_2_10_3_2 + 8.333333333333311e-03*G6_2_2_11_2_11_0_0 + 8.333333333333311e-03*G6_2_2_11_2_11_0_1 + 8.333333333333311e-03*G6_2_2_11_2_11_0_2 - 8.333333333333311e-03*G6_2_2_11_2_11_1_0 - 8.333333333333311e-03*G6_2_2_11_2_11_2_1 - 8.333333333333311e-03*G6_2_2_11_2_11_3_2 + 4.166666666666662e-02*G7_0_0_0_2_0_0 + 4.166666666666662e-02*G7_0_0_0_2_0_1 + 4.166666666666662e-02*G7_0_0_0_2_0_2 - 4.166666666666662e-02*G7_0_0_0_2_1_0 - 4.166666666666662e-02*G7_0_0_0_2_2_1 - 4.166666666666662e-02*G7_0_0_0_2_3_2 + 4.166666666666660e-02*G7_0_0_1_2_0_0 + 4.166666666666661e-02*G7_0_0_1_2_0_1 + 4.166666666666661e-02*G7_0_0_1_2_0_2 - 4.166666666666660e-02*G7_0_0_1_2_1_0 - 4.166666666666661e-02*G7_0_0_1_2_2_1 - 4.166666666666661e-02*G7_0_0_1_2_3_2 + 4.166666666666661e-02*G7_0_0_2_2_0_0 + 4.166666666666662e-02*G7_0_0_2_2_0_1 + 4.166666666666662e-02*G7_0_0_2_2_0_2 - 4.166666666666661e-02*G7_0_0_2_2_1_0 - 4.166666666666662e-02*G7_0_0_2_2_2_1 - 4.166666666666662e-02*G7_0_0_2_2_3_2 + 4.166666666666661e-02*G7_0_0_3_2_0_0 + 4.166666666666662e-02*G7_0_0_3_2_0_1 + 4.166666666666662e-02*G7_0_0_3_2_0_2 - 4.166666666666661e-02*G7_0_0_3_2_1_0 - 4.166666666666662e-02*G7_0_0_3_2_2_1 - 4.166666666666662e-02*G7_0_0_3_2_3_2 + 4.166666666666661e-02*G7_0_1_4_2_0_0 + 4.166666666666662e-02*G7_0_1_4_2_0_1 + 4.166666666666662e-02*G7_0_1_4_2_0_2 - 4.166666666666661e-02*G7_0_1_4_2_1_0 - 4.166666666666662e-02*G7_0_1_4_2_2_1 - 4.166666666666662e-02*G7_0_1_4_2_3_2 + 4.166666666666661e-02*G7_0_1_5_2_0_0 + 4.166666666666662e-02*G7_0_1_5_2_0_1 + 4.166666666666662e-02*G7_0_1_5_2_0_2 - 4.166666666666661e-02*G7_0_1_5_2_1_0 - 4.166666666666662e-02*G7_0_1_5_2_2_1 - 4.166666666666662e-02*G7_0_1_5_2_3_2 + 4.166666666666661e-02*G7_0_1_6_2_0_0 + 4.166666666666662e-02*G7_0_1_6_2_0_1 + 4.166666666666662e-02*G7_0_1_6_2_0_2 - 4.166666666666661e-02*G7_0_1_6_2_1_0 - 4.166666666666662e-02*G7_0_1_6_2_2_1 - 4.166666666666662e-02*G7_0_1_6_2_3_2 + 4.166666666666661e-02*G7_0_1_7_2_0_0 + 4.166666666666662e-02*G7_0_1_7_2_0_1 + 4.166666666666662e-02*G7_0_1_7_2_0_2 - 4.166666666666661e-02*G7_0_1_7_2_1_0 - 4.166666666666662e-02*G7_0_1_7_2_2_1 - 4.166666666666662e-02*G7_0_1_7_2_3_2 + 4.166666666666661e-02*G7_0_2_8_2_0_0 + 4.166666666666662e-02*G7_0_2_8_2_0_1 + 4.166666666666662e-02*G7_0_2_8_2_0_2 - 4.166666666666661e-02*G7_0_2_8_2_1_0 - 4.166666666666662e-02*G7_0_2_8_2_2_1 - 4.166666666666662e-02*G7_0_2_8_2_3_2 + 4.166666666666661e-02*G7_0_2_9_2_0_0 + 4.166666666666662e-02*G7_0_2_9_2_0_1 + 4.166666666666662e-02*G7_0_2_9_2_0_2 - 4.166666666666661e-02*G7_0_2_9_2_1_0 - 4.166666666666662e-02*G7_0_2_9_2_2_1 - 4.166666666666662e-02*G7_0_2_9_2_3_2 + 4.166666666666661e-02*G7_0_2_10_2_0_0 + 4.166666666666662e-02*G7_0_2_10_2_0_1 + 4.166666666666662e-02*G7_0_2_10_2_0_2 - 4.166666666666661e-02*G7_0_2_10_2_1_0 - 4.166666666666662e-02*G7_0_2_10_2_2_1 - 4.166666666666662e-02*G7_0_2_10_2_3_2 + 4.166666666666661e-02*G7_0_2_11_2_0_0 + 4.166666666666662e-02*G7_0_2_11_2_0_1 + 4.166666666666662e-02*G7_0_2_11_2_0_2 - 4.166666666666661e-02*G7_0_2_11_2_1_0 - 4.166666666666662e-02*G7_0_2_11_2_2_1 - 4.166666666666662e-02*G7_0_2_11_2_3_2 + 8.333333333333322e-02*G8_0_0_2_0_0 + 8.333333333333323e-02*G8_0_0_2_0_1 + 8.333333333333322e-02*G8_0_0_2_0_2 - 8.333333333333322e-02*G8_0_0_2_1_0 - 8.333333333333323e-02*G8_0_0_2_2_1 - 8.333333333333323e-02*G8_0_0_2_3_2 + 8.333333333333322e-02*G8_0_1_2_4_0 + 8.333333333333323e-02*G8_0_1_2_4_1 + 8.333333333333323e-02*G8_0_1_2_4_2 - 8.333333333333322e-02*G8_0_1_2_5_0 - 8.333333333333323e-02*G8_0_1_2_6_1 - 8.333333333333323e-02*G8_0_1_2_7_2 + 8.333333333333322e-02*G8_0_2_2_8_0 + 8.333333333333323e-02*G8_0_2_2_8_1 + 8.333333333333323e-02*G8_0_2_2_8_2 - 8.333333333333322e-02*G8_0_2_2_9_0 - 8.333333333333323e-02*G8_0_2_2_10_1 - 8.333333333333323e-02*G8_0_2_2_11_2;
    block[4] = 1.666666666666662e-02*G0_4 + 8.333333333333309e-03*G0_5 + 8.333333333333309e-03*G0_6 + 8.333333333333314e-03*G0_7 + 1.666666666666662e-02*G1_4 + 8.333333333333309e-03*G1_5 + 8.333333333333309e-03*G1_6 + 8.333333333333314e-03*G1_7 - 4.166666666666661e-02*G2_1_0_0 - 4.166666666666661e-02*G2_1_0_1 - 4.166666666666661e-02*G2_1_0_2 - 4.166666666666661e-02*G2_1_0_3 - 4.166666666666662e-02*G2_1_1_0 - 4.166666666666662e-02*G2_1_1_1 - 4.166666666666662e-02*G2_1_1_2 - 4.166666666666662e-02*G2_1_1_3 - 4.166666666666662e-02*G2_1_2_0 - 4.166666666666662e-02*G2_1_2_1 - 4.166666666666662e-02*G2_1_2_2 - 4.166666666666662e-02*G2_1_2_3 - 1.666666666666662e-02*G3_0_0_0_4 - 8.333333333333311e-03*G3_0_0_0_5 - 8.333333333333309e-03*G3_0_0_0_6 - 8.333333333333312e-03*G3_0_0_0_7 - 1.666666666666662e-02*G3_0_0_1_4 - 8.333333333333311e-03*G3_0_0_1_5 - 8.333333333333312e-03*G3_0_0_1_6 - 8.333333333333314e-03*G3_0_0_1_7 - 1.666666666666662e-02*G3_0_0_2_4 - 8.333333333333312e-03*G3_0_0_2_5 - 8.333333333333312e-03*G3_0_0_2_6 - 8.333333333333316e-03*G3_0_0_2_7 - 8.333333333333307e-03*G3_0_1_0_4 - 1.666666666666662e-02*G3_0_1_0_5 - 8.333333333333309e-03*G3_0_1_0_6 - 8.333333333333311e-03*G3_0_1_0_7 - 8.333333333333309e-03*G3_0_1_1_4 - 1.666666666666662e-02*G3_0_1_1_5 - 8.333333333333309e-03*G3_0_1_1_6 - 8.333333333333311e-03*G3_0_1_1_7 - 8.333333333333309e-03*G3_0_1_2_4 - 1.666666666666662e-02*G3_0_1_2_5 - 8.333333333333311e-03*G3_0_1_2_6 - 8.333333333333312e-03*G3_0_1_2_7 - 8.333333333333307e-03*G3_0_2_0_4 - 8.333333333333311e-03*G3_0_2_0_5 - 1.666666666666662e-02*G3_0_2_0_6 - 8.333333333333311e-03*G3_0_2_0_7 - 8.333333333333307e-03*G3_0_2_1_4 - 8.333333333333312e-03*G3_0_2_1_5 - 1.666666666666662e-02*G3_0_2_1_6 - 8.333333333333312e-03*G3_0_2_1_7 - 8.333333333333309e-03*G3_0_2_2_4 - 8.333333333333312e-03*G3_0_2_2_5 - 1.666666666666662e-02*G3_0_2_2_6 - 8.333333333333314e-03*G3_0_2_2_7 - 8.333333333333312e-03*G3_0_3_0_4 - 8.333333333333312e-03*G3_0_3_0_5 - 8.333333333333311e-03*G3_0_3_0_6 - 1.666666666666662e-02*G3_0_3_0_7 - 8.333333333333314e-03*G3_0_3_1_4 - 8.333333333333314e-03*G3_0_3_1_5 - 8.333333333333312e-03*G3_0_3_1_6 - 1.666666666666662e-02*G3_0_3_1_7 - 8.333333333333314e-03*G3_0_3_2_4 - 8.333333333333314e-03*G3_0_3_2_5 - 8.333333333333314e-03*G3_0_3_2_6 - 1.666666666666662e-02*G3_0_3_2_7 - 1.666666666666662e-02*G3_1_4_0_4 - 8.333333333333309e-03*G3_1_4_0_5 - 8.333333333333307e-03*G3_1_4_0_6 - 8.333333333333312e-03*G3_1_4_0_7 - 1.666666666666662e-02*G3_1_4_1_4 - 8.333333333333309e-03*G3_1_4_1_5 - 8.333333333333309e-03*G3_1_4_1_6 - 8.333333333333314e-03*G3_1_4_1_7 - 1.666666666666662e-02*G3_1_4_2_4 - 8.333333333333311e-03*G3_1_4_2_5 - 8.333333333333309e-03*G3_1_4_2_6 - 8.333333333333314e-03*G3_1_4_2_7 - 8.333333333333309e-03*G3_1_5_0_4 - 1.666666666666662e-02*G3_1_5_0_5 - 8.333333333333311e-03*G3_1_5_0_6 - 8.333333333333312e-03*G3_1_5_0_7 - 8.333333333333309e-03*G3_1_5_1_4 - 1.666666666666662e-02*G3_1_5_1_5 - 8.333333333333312e-03*G3_1_5_1_6 - 8.333333333333314e-03*G3_1_5_1_7 - 8.333333333333311e-03*G3_1_5_2_4 - 1.666666666666662e-02*G3_1_5_2_5 - 8.333333333333312e-03*G3_1_5_2_6 - 8.333333333333314e-03*G3_1_5_2_7 - 8.333333333333307e-03*G3_1_6_0_4 - 8.333333333333311e-03*G3_1_6_0_5 - 1.666666666666662e-02*G3_1_6_0_6 - 8.333333333333311e-03*G3_1_6_0_7 - 8.333333333333307e-03*G3_1_6_1_4 - 8.333333333333312e-03*G3_1_6_1_5 - 1.666666666666662e-02*G3_1_6_1_6 - 8.333333333333312e-03*G3_1_6_1_7 - 8.333333333333309e-03*G3_1_6_2_4 - 8.333333333333312e-03*G3_1_6_2_5 - 1.666666666666662e-02*G3_1_6_2_6 - 8.333333333333314e-03*G3_1_6_2_7 - 8.333333333333312e-03*G3_1_7_0_4 - 8.333333333333312e-03*G3_1_7_0_5 - 8.333333333333311e-03*G3_1_7_0_6 - 1.666666666666662e-02*G3_1_7_0_7 - 8.333333333333314e-03*G3_1_7_1_4 - 8.333333333333314e-03*G3_1_7_1_5 - 8.333333333333312e-03*G3_1_7_1_6 - 1.666666666666662e-02*G3_1_7_1_7 - 8.333333333333314e-03*G3_1_7_2_4 - 8.333333333333314e-03*G3_1_7_2_5 - 8.333333333333314e-03*G3_1_7_2_6 - 1.666666666666662e-02*G3_1_7_2_7 - 1.666666666666662e-02*G3_2_8_0_4 - 8.333333333333309e-03*G3_2_8_0_5 - 8.333333333333307e-03*G3_2_8_0_6 - 8.333333333333312e-03*G3_2_8_0_7 - 1.666666666666662e-02*G3_2_8_1_4 - 8.333333333333309e-03*G3_2_8_1_5 - 8.333333333333309e-03*G3_2_8_1_6 - 8.333333333333314e-03*G3_2_8_1_7 - 1.666666666666662e-02*G3_2_8_2_4 - 8.333333333333311e-03*G3_2_8_2_5 - 8.333333333333309e-03*G3_2_8_2_6 - 8.333333333333314e-03*G3_2_8_2_7 - 8.333333333333309e-03*G3_2_9_0_4 - 1.666666666666662e-02*G3_2_9_0_5 - 8.333333333333311e-03*G3_2_9_0_6 - 8.333333333333312e-03*G3_2_9_0_7 - 8.333333333333309e-03*G3_2_9_1_4 - 1.666666666666662e-02*G3_2_9_1_5 - 8.333333333333312e-03*G3_2_9_1_6 - 8.333333333333314e-03*G3_2_9_1_7 - 8.333333333333311e-03*G3_2_9_2_4 - 1.666666666666662e-02*G3_2_9_2_5 - 8.333333333333312e-03*G3_2_9_2_6 - 8.333333333333314e-03*G3_2_9_2_7 - 8.333333333333307e-03*G3_2_10_0_4 - 8.333333333333311e-03*G3_2_10_0_5 - 1.666666666666662e-02*G3_2_10_0_6 - 8.333333333333311e-03*G3_2_10_0_7 - 8.333333333333307e-03*G3_2_10_1_4 - 8.333333333333312e-03*G3_2_10_1_5 - 1.666666666666662e-02*G3_2_10_1_6 - 8.333333333333312e-03*G3_2_10_1_7 - 8.333333333333309e-03*G3_2_10_2_4 - 8.333333333333312e-03*G3_2_10_2_5 - 1.666666666666662e-02*G3_2_10_2_6 - 8.333333333333314e-03*G3_2_10_2_7 - 8.333333333333312e-03*G3_2_11_0_4 - 8.333333333333312e-03*G3_2_11_0_5 - 8.333333333333311e-03*G3_2_11_0_6 - 1.666666666666662e-02*G3_2_11_0_7 - 8.333333333333314e-03*G3_2_11_1_4 - 8.333333333333314e-03*G3_2_11_1_5 - 8.333333333333312e-03*G3_2_11_1_6 - 1.666666666666662e-02*G3_2_11_1_7 - 8.333333333333314e-03*G3_2_11_2_4 - 8.333333333333314e-03*G3_2_11_2_5 - 8.333333333333314e-03*G3_2_11_2_6 - 1.666666666666662e-02*G3_2_11_2_7 - 8.333333333333320e-02*G4_0_4_0 - 8.333333333333322e-02*G4_0_4_1 - 8.333333333333322e-02*G4_0_4_2 + 8.333333333333320e-02*G4_0_5_0 + 8.333333333333322e-02*G4_0_6_1 + 8.333333333333322e-02*G4_0_7_2 - 8.333333333333322e-02*G4_1_4_0 - 8.333333333333323e-02*G4_1_4_1 - 8.333333333333323e-02*G4_1_4_2 + 8.333333333333322e-02*G4_1_5_0 + 8.333333333333323e-02*G4_1_6_1 + 8.333333333333323e-02*G4_1_7_2 - 8.333333333333322e-02*G4_2_4_0 - 8.333333333333323e-02*G4_2_4_1 - 8.333333333333323e-02*G4_2_4_2 + 8.333333333333322e-02*G4_2_5_0 + 8.333333333333323e-02*G4_2_6_1 + 8.333333333333323e-02*G4_2_7_2 + 8.333333333333309e-03*G5_0_0_4_0 + 8.333333333333311e-03*G5_0_0_4_1 + 8.333333333333312e-03*G5_0_0_4_2 - 8.333333333333309e-03*G5_0_0_5_0 - 8.333333333333311e-03*G5_0_0_6_1 - 8.333333333333311e-03*G5_0_0_7_2 + 4.166666666666654e-03*G5_0_1_4_0 + 4.166666666666654e-03*G5_0_1_4_1 + 4.166666666666654e-03*G5_0_1_4_2 - 4.166666666666654e-03*G5_0_1_5_0 - 4.166666666666654e-03*G5_0_1_6_1 - 4.166666666666654e-03*G5_0_1_7_2 + 4.166666666666654e-03*G5_0_2_4_0 + 4.166666666666654e-03*G5_0_2_4_1 + 4.166666666666654e-03*G5_0_2_4_2 - 4.166666666666654e-03*G5_0_2_5_0 - 4.166666666666654e-03*G5_0_2_6_1 - 4.166666666666654e-03*G5_0_2_7_2 + 4.166666666666656e-03*G5_0_3_4_0 + 4.166666666666657e-03*G5_0_3_4_1 + 4.166666666666657e-03*G5_0_3_4_2 - 4.166666666666656e-03*G5_0_3_5_0 - 4.166666666666657e-03*G5_0_3_6_1 - 4.166666666666657e-03*G5_0_3_7_2 + 8.333333333333309e-03*G5_1_4_4_0 + 8.333333333333311e-03*G5_1_4_4_1 + 8.333333333333312e-03*G5_1_4_4_2 - 8.333333333333309e-03*G5_1_4_5_0 - 8.333333333333311e-03*G5_1_4_6_1 - 8.333333333333311e-03*G5_1_4_7_2 + 4.166666666666654e-03*G5_1_5_4_0 + 4.166666666666654e-03*G5_1_5_4_1 + 4.166666666666655e-03*G5_1_5_4_2 - 4.166666666666654e-03*G5_1_5_5_0 - 4.166666666666654e-03*G5_1_5_6_1 - 4.166666666666654e-03*G5_1_5_7_2 + 4.166666666666654e-03*G5_1_6_4_0 + 4.166666666666654e-03*G5_1_6_4_1 + 4.166666666666654e-03*G5_1_6_4_2 - 4.166666666666654e-03*G5_1_6_5_0 - 4.166666666666654e-03*G5_1_6_6_1 - 4.166666666666654e-03*G5_1_6_7_2 + 4.166666666666656e-03*G5_1_7_4_0 + 4.166666666666657e-03*G5_1_7_4_1 + 4.166666666666657e-03*G5_1_7_4_2 - 4.166666666666656e-03*G5_1_7_5_0 - 4.166666666666657e-03*G5_1_7_6_1 - 4.166666666666657e-03*G5_1_7_7_2 + 8.333333333333309e-03*G5_2_8_4_0 + 8.333333333333311e-03*G5_2_8_4_1 + 8.333333333333312e-03*G5_2_8_4_2 - 8.333333333333309e-03*G5_2_8_5_0 - 8.333333333333311e-03*G5_2_8_6_1 - 8.333333333333311e-03*G5_2_8_7_2 + 4.166666666666654e-03*G5_2_9_4_0 + 4.166666666666654e-03*G5_2_9_4_1 + 4.166666666666655e-03*G5_2_9_4_2 - 4.166666666666654e-03*G5_2_9_5_0 - 4.166666666666654e-03*G5_2_9_6_1 - 4.166666666666654e-03*G5_2_9_7_2 + 4.166666666666654e-03*G5_2_10_4_0 + 4.166666666666654e-03*G5_2_10_4_1 + 4.166666666666654e-03*G5_2_10_4_2 - 4.166666666666654e-03*G5_2_10_5_0 - 4.166666666666654e-03*G5_2_10_6_1 - 4.166666666666654e-03*G5_2_10_7_2 + 4.166666666666656e-03*G5_2_11_4_0 + 4.166666666666657e-03*G5_2_11_4_1 + 4.166666666666657e-03*G5_2_11_4_2 - 4.166666666666656e-03*G5_2_11_5_0 - 4.166666666666657e-03*G5_2_11_6_1 - 4.166666666666657e-03*G5_2_11_7_2 - 8.333333333333309e-03*G6_0_0_0_0_0_4_0 - 8.333333333333309e-03*G6_0_0_0_0_0_4_1 - 8.333333333333312e-03*G6_0_0_0_0_0_4_2 + 8.333333333333309e-03*G6_0_0_0_0_0_5_0 + 8.333333333333309e-03*G6_0_0_0_0_0_6_1 + 8.333333333333309e-03*G6_0_0_0_0_0_7_2 - 4.166666666666654e-03*G6_0_0_0_0_1_4_0 - 4.166666666666654e-03*G6_0_0_0_0_1_4_1 - 4.166666666666655e-03*G6_0_0_0_0_1_4_2 + 4.166666666666654e-03*G6_0_0_0_0_1_5_0 + 4.166666666666654e-03*G6_0_0_0_0_1_6_1 + 4.166666666666654e-03*G6_0_0_0_0_1_7_2 - 4.166666666666654e-03*G6_0_0_0_0_2_4_0 - 4.166666666666654e-03*G6_0_0_0_0_2_4_1 - 4.166666666666656e-03*G6_0_0_0_0_2_4_2 + 4.166666666666654e-03*G6_0_0_0_0_2_5_0 + 4.166666666666654e-03*G6_0_0_0_0_2_6_1 + 4.166666666666654e-03*G6_0_0_0_0_2_7_2 - 4.166666666666656e-03*G6_0_0_0_0_3_4_0 - 4.166666666666656e-03*G6_0_0_0_0_3_4_1 - 4.166666666666657e-03*G6_0_0_0_0_3_4_2 + 4.166666666666656e-03*G6_0_0_0_0_3_5_0 + 4.166666666666656e-03*G6_0_0_0_0_3_6_1 + 4.166666666666656e-03*G6_0_0_0_0_3_7_2 - 8.333333333333309e-03*G6_0_0_0_1_0_4_0 - 8.333333333333311e-03*G6_0_0_0_1_0_4_1 - 8.333333333333312e-03*G6_0_0_0_1_0_4_2 + 8.333333333333309e-03*G6_0_0_0_1_0_5_0 + 8.333333333333311e-03*G6_0_0_0_1_0_6_1 + 8.333333333333311e-03*G6_0_0_0_1_0_7_2 - 4.166666666666654e-03*G6_0_0_0_1_1_4_0 - 4.166666666666655e-03*G6_0_0_0_1_1_4_1 - 4.166666666666655e-03*G6_0_0_0_1_1_4_2 + 4.166666666666654e-03*G6_0_0_0_1_1_5_0 + 4.166666666666655e-03*G6_0_0_0_1_1_6_1 + 4.166666666666655e-03*G6_0_0_0_1_1_7_2 - 4.166666666666654e-03*G6_0_0_0_1_2_4_0 - 4.166666666666656e-03*G6_0_0_0_1_2_4_1 - 4.166666666666656e-03*G6_0_0_0_1_2_4_2 + 4.166666666666654e-03*G6_0_0_0_1_2_5_0 + 4.166666666666656e-03*G6_0_0_0_1_2_6_1 + 4.166666666666656e-03*G6_0_0_0_1_2_7_2 - 4.166666666666656e-03*G6_0_0_0_1_3_4_0 - 4.166666666666657e-03*G6_0_0_0_1_3_4_1 - 4.166666666666658e-03*G6_0_0_0_1_3_4_2 + 4.166666666666656e-03*G6_0_0_0_1_3_5_0 + 4.166666666666657e-03*G6_0_0_0_1_3_6_1 + 4.166666666666657e-03*G6_0_0_0_1_3_7_2 - 8.333333333333311e-03*G6_0_0_0_2_0_4_0 - 8.333333333333312e-03*G6_0_0_0_2_0_4_1 - 8.333333333333314e-03*G6_0_0_0_2_0_4_2 + 8.333333333333311e-03*G6_0_0_0_2_0_5_0 + 8.333333333333312e-03*G6_0_0_0_2_0_6_1 + 8.333333333333312e-03*G6_0_0_0_2_0_7_2 - 4.166666666666654e-03*G6_0_0_0_2_1_4_0 - 4.166666666666655e-03*G6_0_0_0_2_1_4_1 - 4.166666666666656e-03*G6_0_0_0_2_1_4_2 + 4.166666666666654e-03*G6_0_0_0_2_1_5_0 + 4.166666666666655e-03*G6_0_0_0_2_1_6_1 + 4.166666666666655e-03*G6_0_0_0_2_1_7_2 - 4.166666666666655e-03*G6_0_0_0_2_2_4_0 - 4.166666666666656e-03*G6_0_0_0_2_2_4_1 - 4.166666666666656e-03*G6_0_0_0_2_2_4_2 + 4.166666666666655e-03*G6_0_0_0_2_2_5_0 + 4.166666666666656e-03*G6_0_0_0_2_2_6_1 + 4.166666666666656e-03*G6_0_0_0_2_2_7_2 - 4.166666666666657e-03*G6_0_0_0_2_3_4_0 - 4.166666666666658e-03*G6_0_0_0_2_3_4_1 - 4.166666666666659e-03*G6_0_0_0_2_3_4_2 + 4.166666666666657e-03*G6_0_0_0_2_3_5_0 + 4.166666666666658e-03*G6_0_0_0_2_3_6_1 + 4.166666666666658e-03*G6_0_0_0_2_3_7_2 - 4.166666666666654e-03*G6_0_0_1_0_0_4_0 - 4.166666666666654e-03*G6_0_0_1_0_0_4_1 - 4.166666666666655e-03*G6_0_0_1_0_0_4_2 + 4.166666666666654e-03*G6_0_0_1_0_0_5_0 + 4.166666666666654e-03*G6_0_0_1_0_0_6_1 + 4.166666666666654e-03*G6_0_0_1_0_0_7_2 - 8.333333333333307e-03*G6_0_0_1_0_1_4_0 - 8.333333333333307e-03*G6_0_0_1_0_1_4_1 - 8.333333333333307e-03*G6_0_0_1_0_1_4_2 + 8.333333333333307e-03*G6_0_0_1_0_1_5_0 + 8.333333333333307e-03*G6_0_0_1_0_1_6_1 + 8.333333333333307e-03*G6_0_0_1_0_1_7_2 - 4.166666666666654e-03*G6_0_0_1_0_2_4_0 - 4.166666666666654e-03*G6_0_0_1_0_2_4_1 - 4.166666666666654e-03*G6_0_0_1_0_2_4_2 + 4.166666666666654e-03*G6_0_0_1_0_2_5_0 + 4.166666666666654e-03*G6_0_0_1_0_2_6_1 + 4.166666666666654e-03*G6_0_0_1_0_2_7_2 - 4.166666666666654e-03*G6_0_0_1_0_3_4_0 - 4.166666666666655e-03*G6_0_0_1_0_3_4_1 - 4.166666666666655e-03*G6_0_0_1_0_3_4_2 + 4.166666666666654e-03*G6_0_0_1_0_3_5_0 + 4.166666666666655e-03*G6_0_0_1_0_3_6_1 + 4.166666666666655e-03*G6_0_0_1_0_3_7_2 - 4.166666666666654e-03*G6_0_0_1_1_0_4_0 - 4.166666666666655e-03*G6_0_0_1_1_0_4_1 - 4.166666666666655e-03*G6_0_0_1_1_0_4_2 + 4.166666666666654e-03*G6_0_0_1_1_0_5_0 + 4.166666666666655e-03*G6_0_0_1_1_0_6_1 + 4.166666666666655e-03*G6_0_0_1_1_0_7_2 - 8.333333333333307e-03*G6_0_0_1_1_1_4_0 - 8.333333333333309e-03*G6_0_0_1_1_1_4_1 - 8.333333333333309e-03*G6_0_0_1_1_1_4_2 + 8.333333333333307e-03*G6_0_0_1_1_1_5_0 + 8.333333333333309e-03*G6_0_0_1_1_1_6_1 + 8.333333333333309e-03*G6_0_0_1_1_1_7_2 - 4.166666666666654e-03*G6_0_0_1_1_2_4_0 - 4.166666666666654e-03*G6_0_0_1_1_2_4_1 - 4.166666666666655e-03*G6_0_0_1_1_2_4_2 + 4.166666666666654e-03*G6_0_0_1_1_2_5_0 + 4.166666666666654e-03*G6_0_0_1_1_2_6_1 + 4.166666666666654e-03*G6_0_0_1_1_2_7_2 - 4.166666666666655e-03*G6_0_0_1_1_3_4_0 - 4.166666666666655e-03*G6_0_0_1_1_3_4_1 - 4.166666666666656e-03*G6_0_0_1_1_3_4_2 + 4.166666666666655e-03*G6_0_0_1_1_3_5_0 + 4.166666666666655e-03*G6_0_0_1_1_3_6_1 + 4.166666666666655e-03*G6_0_0_1_1_3_7_2 - 4.166666666666654e-03*G6_0_0_1_2_0_4_0 - 4.166666666666655e-03*G6_0_0_1_2_0_4_1 - 4.166666666666656e-03*G6_0_0_1_2_0_4_2 + 4.166666666666654e-03*G6_0_0_1_2_0_5_0 + 4.166666666666655e-03*G6_0_0_1_2_0_6_1 + 4.166666666666655e-03*G6_0_0_1_2_0_7_2 - 8.333333333333307e-03*G6_0_0_1_2_1_4_0 - 8.333333333333309e-03*G6_0_0_1_2_1_4_1 - 8.333333333333309e-03*G6_0_0_1_2_1_4_2 + 8.333333333333307e-03*G6_0_0_1_2_1_5_0 + 8.333333333333309e-03*G6_0_0_1_2_1_6_1 + 8.333333333333309e-03*G6_0_0_1_2_1_7_2 - 4.166666666666654e-03*G6_0_0_1_2_2_4_0 - 4.166666666666655e-03*G6_0_0_1_2_2_4_1 - 4.166666666666655e-03*G6_0_0_1_2_2_4_2 + 4.166666666666654e-03*G6_0_0_1_2_2_5_0 + 4.166666666666655e-03*G6_0_0_1_2_2_6_1 + 4.166666666666655e-03*G6_0_0_1_2_2_7_2 - 4.166666666666655e-03*G6_0_0_1_2_3_4_0 - 4.166666666666656e-03*G6_0_0_1_2_3_4_1 - 4.166666666666656e-03*G6_0_0_1_2_3_4_2 + 4.166666666666655e-03*G6_0_0_1_2_3_5_0 + 4.166666666666656e-03*G6_0_0_1_2_3_6_1 + 4.166666666666656e-03*G6_0_0_1_2_3_7_2 - 4.166666666666654e-03*G6_0_0_2_0_0_4_0 - 4.166666666666654e-03*G6_0_0_2_0_0_4_1 - 4.166666666666655e-03*G6_0_0_2_0_0_4_2 + 4.166666666666654e-03*G6_0_0_2_0_0_5_0 + 4.166666666666654e-03*G6_0_0_2_0_0_6_1 + 4.166666666666654e-03*G6_0_0_2_0_0_7_2 - 4.166666666666654e-03*G6_0_0_2_0_1_4_0 - 4.166666666666654e-03*G6_0_0_2_0_1_4_1 - 4.166666666666654e-03*G6_0_0_2_0_1_4_2 + 4.166666666666654e-03*G6_0_0_2_0_1_5_0 + 4.166666666666654e-03*G6_0_0_2_0_1_6_1 + 4.166666666666654e-03*G6_0_0_2_0_1_7_2 - 8.333333333333309e-03*G6_0_0_2_0_2_4_0 - 8.333333333333309e-03*G6_0_0_2_0_2_4_1 - 8.333333333333311e-03*G6_0_0_2_0_2_4_2 + 8.333333333333309e-03*G6_0_0_2_0_2_5_0 + 8.333333333333309e-03*G6_0_0_2_0_2_6_1 + 8.333333333333309e-03*G6_0_0_2_0_2_7_2 - 4.166666666666654e-03*G6_0_0_2_0_3_4_0 - 4.166666666666655e-03*G6_0_0_2_0_3_4_1 - 4.166666666666655e-03*G6_0_0_2_0_3_4_2 + 4.166666666666654e-03*G6_0_0_2_0_3_5_0 + 4.166666666666655e-03*G6_0_0_2_0_3_6_1 + 4.166666666666655e-03*G6_0_0_2_0_3_7_2 - 4.166666666666654e-03*G6_0_0_2_1_0_4_0 - 4.166666666666656e-03*G6_0_0_2_1_0_4_1 - 4.166666666666656e-03*G6_0_0_2_1_0_4_2 + 4.166666666666654e-03*G6_0_0_2_1_0_5_0 + 4.166666666666656e-03*G6_0_0_2_1_0_6_1 + 4.166666666666656e-03*G6_0_0_2_1_0_7_2 - 4.166666666666654e-03*G6_0_0_2_1_1_4_0 - 4.166666666666654e-03*G6_0_0_2_1_1_4_1 - 4.166666666666654e-03*G6_0_0_2_1_1_4_2 + 4.166666666666654e-03*G6_0_0_2_1_1_5_0 + 4.166666666666654e-03*G6_0_0_2_1_1_6_1 + 4.166666666666654e-03*G6_0_0_2_1_1_7_2 - 8.333333333333311e-03*G6_0_0_2_1_2_4_0 - 8.333333333333311e-03*G6_0_0_2_1_2_4_1 - 8.333333333333312e-03*G6_0_0_2_1_2_4_2 + 8.333333333333311e-03*G6_0_0_2_1_2_5_0 + 8.333333333333311e-03*G6_0_0_2_1_2_6_1 + 8.333333333333311e-03*G6_0_0_2_1_2_7_2 - 4.166666666666655e-03*G6_0_0_2_1_3_4_0 - 4.166666666666656e-03*G6_0_0_2_1_3_4_1 - 4.166666666666657e-03*G6_0_0_2_1_3_4_2 + 4.166666666666655e-03*G6_0_0_2_1_3_5_0 + 4.166666666666656e-03*G6_0_0_2_1_3_6_1 + 4.166666666666656e-03*G6_0_0_2_1_3_7_2 - 4.166666666666655e-03*G6_0_0_2_2_0_4_0 - 4.166666666666656e-03*G6_0_0_2_2_0_4_1 - 4.166666666666656e-03*G6_0_0_2_2_0_4_2 + 4.166666666666655e-03*G6_0_0_2_2_0_5_0 + 4.166666666666656e-03*G6_0_0_2_2_0_6_1 + 4.166666666666656e-03*G6_0_0_2_2_0_7_2 - 4.166666666666654e-03*G6_0_0_2_2_1_4_0 - 4.166666666666654e-03*G6_0_0_2_2_1_4_1 - 4.166666666666655e-03*G6_0_0_2_2_1_4_2 + 4.166666666666654e-03*G6_0_0_2_2_1_5_0 + 4.166666666666654e-03*G6_0_0_2_2_1_6_1 + 4.166666666666654e-03*G6_0_0_2_2_1_7_2 - 8.333333333333311e-03*G6_0_0_2_2_2_4_0 - 8.333333333333312e-03*G6_0_0_2_2_2_4_1 - 8.333333333333312e-03*G6_0_0_2_2_2_4_2 + 8.333333333333311e-03*G6_0_0_2_2_2_5_0 + 8.333333333333312e-03*G6_0_0_2_2_2_6_1 + 8.333333333333312e-03*G6_0_0_2_2_2_7_2 - 4.166666666666655e-03*G6_0_0_2_2_3_4_0 - 4.166666666666657e-03*G6_0_0_2_2_3_4_1 - 4.166666666666657e-03*G6_0_0_2_2_3_4_2 + 4.166666666666655e-03*G6_0_0_2_2_3_5_0 + 4.166666666666657e-03*G6_0_0_2_2_3_6_1 + 4.166666666666657e-03*G6_0_0_2_2_3_7_2 - 4.166666666666656e-03*G6_0_0_3_0_0_4_0 - 4.166666666666656e-03*G6_0_0_3_0_0_4_1 - 4.166666666666657e-03*G6_0_0_3_0_0_4_2 + 4.166666666666656e-03*G6_0_0_3_0_0_5_0 + 4.166666666666656e-03*G6_0_0_3_0_0_6_1 + 4.166666666666656e-03*G6_0_0_3_0_0_7_2 - 4.166666666666654e-03*G6_0_0_3_0_1_4_0 - 4.166666666666655e-03*G6_0_0_3_0_1_4_1 - 4.166666666666655e-03*G6_0_0_3_0_1_4_2 + 4.166666666666654e-03*G6_0_0_3_0_1_5_0 + 4.166666666666655e-03*G6_0_0_3_0_1_6_1 + 4.166666666666655e-03*G6_0_0_3_0_1_7_2 - 4.166666666666655e-03*G6_0_0_3_0_2_4_0 - 4.166666666666655e-03*G6_0_0_3_0_2_4_1 - 4.166666666666655e-03*G6_0_0_3_0_2_4_2 + 4.166666666666655e-03*G6_0_0_3_0_2_5_0 + 4.166666666666655e-03*G6_0_0_3_0_2_6_1 + 4.166666666666655e-03*G6_0_0_3_0_2_7_2 - 8.333333333333309e-03*G6_0_0_3_0_3_4_0 - 8.333333333333311e-03*G6_0_0_3_0_3_4_1 - 8.333333333333311e-03*G6_0_0_3_0_3_4_2 + 8.333333333333309e-03*G6_0_0_3_0_3_5_0 + 8.333333333333311e-03*G6_0_0_3_0_3_6_1 + 8.333333333333311e-03*G6_0_0_3_0_3_7_2 - 4.166666666666656e-03*G6_0_0_3_1_0_4_0 - 4.166666666666657e-03*G6_0_0_3_1_0_4_1 - 4.166666666666658e-03*G6_0_0_3_1_0_4_2 + 4.166666666666656e-03*G6_0_0_3_1_0_5_0 + 4.166666666666657e-03*G6_0_0_3_1_0_6_1 + 4.166666666666657e-03*G6_0_0_3_1_0_7_2 - 4.166666666666655e-03*G6_0_0_3_1_1_4_0 - 4.166666666666655e-03*G6_0_0_3_1_1_4_1 - 4.166666666666656e-03*G6_0_0_3_1_1_4_2 + 4.166666666666655e-03*G6_0_0_3_1_1_5_0 + 4.166666666666655e-03*G6_0_0_3_1_1_6_1 + 4.166666666666655e-03*G6_0_0_3_1_1_7_2 - 4.166666666666655e-03*G6_0_0_3_1_2_4_0 - 4.166666666666656e-03*G6_0_0_3_1_2_4_1 - 4.166666666666657e-03*G6_0_0_3_1_2_4_2 + 4.166666666666655e-03*G6_0_0_3_1_2_5_0 + 4.166666666666656e-03*G6_0_0_3_1_2_6_1 + 4.166666666666656e-03*G6_0_0_3_1_2_7_2 - 8.333333333333311e-03*G6_0_0_3_1_3_4_0 - 8.333333333333311e-03*G6_0_0_3_1_3_4_1 - 8.333333333333312e-03*G6_0_0_3_1_3_4_2 + 8.333333333333311e-03*G6_0_0_3_1_3_5_0 + 8.333333333333311e-03*G6_0_0_3_1_3_6_1 + 8.333333333333311e-03*G6_0_0_3_1_3_7_2 - 4.166666666666657e-03*G6_0_0_3_2_0_4_0 - 4.166666666666658e-03*G6_0_0_3_2_0_4_1 - 4.166666666666659e-03*G6_0_0_3_2_0_4_2 + 4.166666666666657e-03*G6_0_0_3_2_0_5_0 + 4.166666666666658e-03*G6_0_0_3_2_0_6_1 + 4.166666666666658e-03*G6_0_0_3_2_0_7_2 - 4.166666666666655e-03*G6_0_0_3_2_1_4_0 - 4.166666666666656e-03*G6_0_0_3_2_1_4_1 - 4.166666666666656e-03*G6_0_0_3_2_1_4_2 + 4.166666666666655e-03*G6_0_0_3_2_1_5_0 + 4.166666666666656e-03*G6_0_0_3_2_1_6_1 + 4.166666666666656e-03*G6_0_0_3_2_1_7_2 - 4.166666666666655e-03*G6_0_0_3_2_2_4_0 - 4.166666666666657e-03*G6_0_0_3_2_2_4_1 - 4.166666666666657e-03*G6_0_0_3_2_2_4_2 + 4.166666666666655e-03*G6_0_0_3_2_2_5_0 + 4.166666666666657e-03*G6_0_0_3_2_2_6_1 + 4.166666666666657e-03*G6_0_0_3_2_2_7_2 - 8.333333333333311e-03*G6_0_0_3_2_3_4_0 - 8.333333333333312e-03*G6_0_0_3_2_3_4_1 - 8.333333333333312e-03*G6_0_0_3_2_3_4_2 + 8.333333333333311e-03*G6_0_0_3_2_3_5_0 + 8.333333333333312e-03*G6_0_0_3_2_3_6_1 + 8.333333333333312e-03*G6_0_0_3_2_3_7_2 - 8.333333333333309e-03*G6_0_1_0_0_4_4_0 - 8.333333333333309e-03*G6_0_1_0_0_4_4_1 - 8.333333333333311e-03*G6_0_1_0_0_4_4_2 + 8.333333333333309e-03*G6_0_1_0_0_4_5_0 + 8.333333333333309e-03*G6_0_1_0_0_4_6_1 + 8.333333333333309e-03*G6_0_1_0_0_4_7_2 - 4.166666666666654e-03*G6_0_1_0_0_5_4_0 - 4.166666666666655e-03*G6_0_1_0_0_5_4_1 - 4.166666666666655e-03*G6_0_1_0_0_5_4_2 + 4.166666666666654e-03*G6_0_1_0_0_5_5_0 + 4.166666666666655e-03*G6_0_1_0_0_5_6_1 + 4.166666666666655e-03*G6_0_1_0_0_5_7_2 - 4.166666666666654e-03*G6_0_1_0_0_6_4_0 - 4.166666666666654e-03*G6_0_1_0_0_6_4_1 - 4.166666666666656e-03*G6_0_1_0_0_6_4_2 + 4.166666666666654e-03*G6_0_1_0_0_6_5_0 + 4.166666666666654e-03*G6_0_1_0_0_6_6_1 + 4.166666666666654e-03*G6_0_1_0_0_6_7_2 - 4.166666666666656e-03*G6_0_1_0_0_7_4_0 - 4.166666666666656e-03*G6_0_1_0_0_7_4_1 - 4.166666666666657e-03*G6_0_1_0_0_7_4_2 + 4.166666666666656e-03*G6_0_1_0_0_7_5_0 + 4.166666666666656e-03*G6_0_1_0_0_7_6_1 + 4.166666666666656e-03*G6_0_1_0_0_7_7_2 - 8.333333333333309e-03*G6_0_1_0_1_4_4_0 - 8.333333333333311e-03*G6_0_1_0_1_4_4_1 - 8.333333333333312e-03*G6_0_1_0_1_4_4_2 + 8.333333333333309e-03*G6_0_1_0_1_4_5_0 + 8.333333333333311e-03*G6_0_1_0_1_4_6_1 + 8.333333333333311e-03*G6_0_1_0_1_4_7_2 - 4.166666666666655e-03*G6_0_1_0_1_5_4_0 - 4.166666666666655e-03*G6_0_1_0_1_5_4_1 - 4.166666666666656e-03*G6_0_1_0_1_5_4_2 + 4.166666666666655e-03*G6_0_1_0_1_5_5_0 + 4.166666666666655e-03*G6_0_1_0_1_5_6_1 + 4.166666666666655e-03*G6_0_1_0_1_5_7_2 - 4.166666666666654e-03*G6_0_1_0_1_6_4_0 - 4.166666666666656e-03*G6_0_1_0_1_6_4_1 - 4.166666666666656e-03*G6_0_1_0_1_6_4_2 + 4.166666666666654e-03*G6_0_1_0_1_6_5_0 + 4.166666666666656e-03*G6_0_1_0_1_6_6_1 + 4.166666666666656e-03*G6_0_1_0_1_6_7_2 - 4.166666666666656e-03*G6_0_1_0_1_7_4_0 - 4.166666666666657e-03*G6_0_1_0_1_7_4_1 - 4.166666666666658e-03*G6_0_1_0_1_7_4_2 + 4.166666666666656e-03*G6_0_1_0_1_7_5_0 + 4.166666666666657e-03*G6_0_1_0_1_7_6_1 + 4.166666666666657e-03*G6_0_1_0_1_7_7_2 - 8.333333333333311e-03*G6_0_1_0_2_4_4_0 - 8.333333333333312e-03*G6_0_1_0_2_4_4_1 - 8.333333333333314e-03*G6_0_1_0_2_4_4_2 + 8.333333333333311e-03*G6_0_1_0_2_4_5_0 + 8.333333333333312e-03*G6_0_1_0_2_4_6_1 + 8.333333333333312e-03*G6_0_1_0_2_4_7_2 - 4.166666666666655e-03*G6_0_1_0_2_5_4_0 - 4.166666666666656e-03*G6_0_1_0_2_5_4_1 - 4.166666666666657e-03*G6_0_1_0_2_5_4_2 + 4.166666666666655e-03*G6_0_1_0_2_5_5_0 + 4.166666666666656e-03*G6_0_1_0_2_5_6_1 + 4.166666666666656e-03*G6_0_1_0_2_5_7_2 - 4.166666666666655e-03*G6_0_1_0_2_6_4_0 - 4.166666666666656e-03*G6_0_1_0_2_6_4_1 - 4.166666666666656e-03*G6_0_1_0_2_6_4_2 + 4.166666666666655e-03*G6_0_1_0_2_6_5_0 + 4.166666666666656e-03*G6_0_1_0_2_6_6_1 + 4.166666666666656e-03*G6_0_1_0_2_6_7_2 - 4.166666666666657e-03*G6_0_1_0_2_7_4_0 - 4.166666666666658e-03*G6_0_1_0_2_7_4_1 - 4.166666666666659e-03*G6_0_1_0_2_7_4_2 + 4.166666666666657e-03*G6_0_1_0_2_7_5_0 + 4.166666666666658e-03*G6_0_1_0_2_7_6_1 + 4.166666666666658e-03*G6_0_1_0_2_7_7_2 - 4.166666666666654e-03*G6_0_1_1_0_4_4_0 - 4.166666666666654e-03*G6_0_1_1_0_4_4_1 - 4.166666666666654e-03*G6_0_1_1_0_4_4_2 + 4.166666666666654e-03*G6_0_1_1_0_4_5_0 + 4.166666666666654e-03*G6_0_1_1_0_4_6_1 + 4.166666666666654e-03*G6_0_1_1_0_4_7_2 - 8.333333333333307e-03*G6_0_1_1_0_5_4_0 - 8.333333333333309e-03*G6_0_1_1_0_5_4_1 - 8.333333333333309e-03*G6_0_1_1_0_5_4_2 + 8.333333333333307e-03*G6_0_1_1_0_5_5_0 + 8.333333333333309e-03*G6_0_1_1_0_5_6_1 + 8.333333333333309e-03*G6_0_1_1_0_5_7_2 - 4.166666666666654e-03*G6_0_1_1_0_6_4_0 - 4.166666666666654e-03*G6_0_1_1_0_6_4_1 - 4.166666666666654e-03*G6_0_1_1_0_6_4_2 + 4.166666666666654e-03*G6_0_1_1_0_6_5_0 + 4.166666666666654e-03*G6_0_1_1_0_6_6_1 + 4.166666666666654e-03*G6_0_1_1_0_6_7_2 - 4.166666666666654e-03*G6_0_1_1_0_7_4_0 - 4.166666666666655e-03*G6_0_1_1_0_7_4_1 - 4.166666666666655e-03*G6_0_1_1_0_7_4_2 + 4.166666666666654e-03*G6_0_1_1_0_7_5_0 + 4.166666666666655e-03*G6_0_1_1_0_7_6_1 + 4.166666666666655e-03*G6_0_1_1_0_7_7_2 - 4.166666666666654e-03*G6_0_1_1_1_4_4_0 - 4.166666666666654e-03*G6_0_1_1_1_4_4_1 - 4.166666666666654e-03*G6_0_1_1_1_4_4_2 + 4.166666666666654e-03*G6_0_1_1_1_4_5_0 + 4.166666666666654e-03*G6_0_1_1_1_4_6_1 + 4.166666666666654e-03*G6_0_1_1_1_4_7_2 - 8.333333333333309e-03*G6_0_1_1_1_5_4_0 - 8.333333333333309e-03*G6_0_1_1_1_5_4_1 - 8.333333333333309e-03*G6_0_1_1_1_5_4_2 + 8.333333333333309e-03*G6_0_1_1_1_5_5_0 + 8.333333333333309e-03*G6_0_1_1_1_5_6_1 + 8.333333333333309e-03*G6_0_1_1_1_5_7_2 - 4.166666666666654e-03*G6_0_1_1_1_6_4_0 - 4.166666666666654e-03*G6_0_1_1_1_6_4_1 - 4.166666666666655e-03*G6_0_1_1_1_6_4_2 + 4.166666666666654e-03*G6_0_1_1_1_6_5_0 + 4.166666666666654e-03*G6_0_1_1_1_6_6_1 + 4.166666666666654e-03*G6_0_1_1_1_6_7_2 - 4.166666666666655e-03*G6_0_1_1_1_7_4_0 - 4.166666666666655e-03*G6_0_1_1_1_7_4_1 - 4.166666666666656e-03*G6_0_1_1_1_7_4_2 + 4.166666666666655e-03*G6_0_1_1_1_7_5_0 + 4.166666666666655e-03*G6_0_1_1_1_7_6_1 + 4.166666666666655e-03*G6_0_1_1_1_7_7_2 - 4.166666666666654e-03*G6_0_1_1_2_4_4_0 - 4.166666666666654e-03*G6_0_1_1_2_4_4_1 - 4.166666666666655e-03*G6_0_1_1_2_4_4_2 + 4.166666666666654e-03*G6_0_1_1_2_4_5_0 + 4.166666666666654e-03*G6_0_1_1_2_4_6_1 + 4.166666666666654e-03*G6_0_1_1_2_4_7_2 - 8.333333333333309e-03*G6_0_1_1_2_5_4_0 - 8.333333333333309e-03*G6_0_1_1_2_5_4_1 - 8.333333333333309e-03*G6_0_1_1_2_5_4_2 + 8.333333333333309e-03*G6_0_1_1_2_5_5_0 + 8.333333333333309e-03*G6_0_1_1_2_5_6_1 + 8.333333333333309e-03*G6_0_1_1_2_5_7_2 - 4.166666666666654e-03*G6_0_1_1_2_6_4_0 - 4.166666666666655e-03*G6_0_1_1_2_6_4_1 - 4.166666666666655e-03*G6_0_1_1_2_6_4_2 + 4.166666666666654e-03*G6_0_1_1_2_6_5_0 + 4.166666666666655e-03*G6_0_1_1_2_6_6_1 + 4.166666666666655e-03*G6_0_1_1_2_6_7_2 - 4.166666666666655e-03*G6_0_1_1_2_7_4_0 - 4.166666666666656e-03*G6_0_1_1_2_7_4_1 - 4.166666666666656e-03*G6_0_1_1_2_7_4_2 + 4.166666666666655e-03*G6_0_1_1_2_7_5_0 + 4.166666666666656e-03*G6_0_1_1_2_7_6_1 + 4.166666666666656e-03*G6_0_1_1_2_7_7_2 - 4.166666666666653e-03*G6_0_1_2_0_4_4_0 - 4.166666666666654e-03*G6_0_1_2_0_4_4_1 - 4.166666666666654e-03*G6_0_1_2_0_4_4_2 + 4.166666666666653e-03*G6_0_1_2_0_4_5_0 + 4.166666666666654e-03*G6_0_1_2_0_4_6_1 + 4.166666666666654e-03*G6_0_1_2_0_4_7_2 - 4.166666666666654e-03*G6_0_1_2_0_5_4_0 - 4.166666666666655e-03*G6_0_1_2_0_5_4_1 - 4.166666666666655e-03*G6_0_1_2_0_5_4_2 + 4.166666666666654e-03*G6_0_1_2_0_5_5_0 + 4.166666666666655e-03*G6_0_1_2_0_5_6_1 + 4.166666666666655e-03*G6_0_1_2_0_5_7_2 - 8.333333333333309e-03*G6_0_1_2_0_6_4_0 - 8.333333333333309e-03*G6_0_1_2_0_6_4_1 - 8.333333333333311e-03*G6_0_1_2_0_6_4_2 + 8.333333333333309e-03*G6_0_1_2_0_6_5_0 + 8.333333333333309e-03*G6_0_1_2_0_6_6_1 + 8.333333333333309e-03*G6_0_1_2_0_6_7_2 - 4.166666666666654e-03*G6_0_1_2_0_7_4_0 - 4.166666666666655e-03*G6_0_1_2_0_7_4_1 - 4.166666666666655e-03*G6_0_1_2_0_7_4_2 + 4.166666666666654e-03*G6_0_1_2_0_7_5_0 + 4.166666666666655e-03*G6_0_1_2_0_7_6_1 + 4.166666666666655e-03*G6_0_1_2_0_7_7_2 - 4.166666666666654e-03*G6_0_1_2_1_4_4_0 - 4.166666666666654e-03*G6_0_1_2_1_4_4_1 - 4.166666666666654e-03*G6_0_1_2_1_4_4_2 + 4.166666666666654e-03*G6_0_1_2_1_4_5_0 + 4.166666666666654e-03*G6_0_1_2_1_4_6_1 + 4.166666666666654e-03*G6_0_1_2_1_4_7_2 - 4.166666666666655e-03*G6_0_1_2_1_5_4_0 - 4.166666666666656e-03*G6_0_1_2_1_5_4_1 - 4.166666666666656e-03*G6_0_1_2_1_5_4_2 + 4.166666666666655e-03*G6_0_1_2_1_5_5_0 + 4.166666666666656e-03*G6_0_1_2_1_5_6_1 + 4.166666666666656e-03*G6_0_1_2_1_5_7_2 - 8.333333333333311e-03*G6_0_1_2_1_6_4_0 - 8.333333333333311e-03*G6_0_1_2_1_6_4_1 - 8.333333333333312e-03*G6_0_1_2_1_6_4_2 + 8.333333333333311e-03*G6_0_1_2_1_6_5_0 + 8.333333333333311e-03*G6_0_1_2_1_6_6_1 + 8.333333333333311e-03*G6_0_1_2_1_6_7_2 - 4.166666666666655e-03*G6_0_1_2_1_7_4_0 - 4.166666666666656e-03*G6_0_1_2_1_7_4_1 - 4.166666666666657e-03*G6_0_1_2_1_7_4_2 + 4.166666666666655e-03*G6_0_1_2_1_7_5_0 + 4.166666666666656e-03*G6_0_1_2_1_7_6_1 + 4.166666666666656e-03*G6_0_1_2_1_7_7_2 - 4.166666666666654e-03*G6_0_1_2_2_4_4_0 - 4.166666666666654e-03*G6_0_1_2_2_4_4_1 - 4.166666666666654e-03*G6_0_1_2_2_4_4_2 + 4.166666666666654e-03*G6_0_1_2_2_4_5_0 + 4.166666666666654e-03*G6_0_1_2_2_4_6_1 + 4.166666666666654e-03*G6_0_1_2_2_4_7_2 - 4.166666666666655e-03*G6_0_1_2_2_5_4_0 - 4.166666666666656e-03*G6_0_1_2_2_5_4_1 - 4.166666666666656e-03*G6_0_1_2_2_5_4_2 + 4.166666666666655e-03*G6_0_1_2_2_5_5_0 + 4.166666666666656e-03*G6_0_1_2_2_5_6_1 + 4.166666666666656e-03*G6_0_1_2_2_5_7_2 - 8.333333333333311e-03*G6_0_1_2_2_6_4_0 - 8.333333333333312e-03*G6_0_1_2_2_6_4_1 - 8.333333333333312e-03*G6_0_1_2_2_6_4_2 + 8.333333333333311e-03*G6_0_1_2_2_6_5_0 + 8.333333333333312e-03*G6_0_1_2_2_6_6_1 + 8.333333333333312e-03*G6_0_1_2_2_6_7_2 - 4.166666666666655e-03*G6_0_1_2_2_7_4_0 - 4.166666666666657e-03*G6_0_1_2_2_7_4_1 - 4.166666666666657e-03*G6_0_1_2_2_7_4_2 + 4.166666666666655e-03*G6_0_1_2_2_7_5_0 + 4.166666666666657e-03*G6_0_1_2_2_7_6_1 + 4.166666666666657e-03*G6_0_1_2_2_7_7_2 - 4.166666666666655e-03*G6_0_1_3_0_4_4_0 - 4.166666666666656e-03*G6_0_1_3_0_4_4_1 - 4.166666666666657e-03*G6_0_1_3_0_4_4_2 + 4.166666666666655e-03*G6_0_1_3_0_4_5_0 + 4.166666666666656e-03*G6_0_1_3_0_4_6_1 + 4.166666666666656e-03*G6_0_1_3_0_4_7_2 - 4.166666666666655e-03*G6_0_1_3_0_5_4_0 - 4.166666666666656e-03*G6_0_1_3_0_5_4_1 - 4.166666666666656e-03*G6_0_1_3_0_5_4_2 + 4.166666666666655e-03*G6_0_1_3_0_5_5_0 + 4.166666666666656e-03*G6_0_1_3_0_5_6_1 + 4.166666666666656e-03*G6_0_1_3_0_5_7_2 - 4.166666666666655e-03*G6_0_1_3_0_6_4_0 - 4.166666666666655e-03*G6_0_1_3_0_6_4_1 - 4.166666666666655e-03*G6_0_1_3_0_6_4_2 + 4.166666666666655e-03*G6_0_1_3_0_6_5_0 + 4.166666666666655e-03*G6_0_1_3_0_6_6_1 + 4.166666666666655e-03*G6_0_1_3_0_6_7_2 - 8.333333333333309e-03*G6_0_1_3_0_7_4_0 - 8.333333333333311e-03*G6_0_1_3_0_7_4_1 - 8.333333333333311e-03*G6_0_1_3_0_7_4_2 + 8.333333333333309e-03*G6_0_1_3_0_7_5_0 + 8.333333333333311e-03*G6_0_1_3_0_7_6_1 + 8.333333333333311e-03*G6_0_1_3_0_7_7_2 - 4.166666666666656e-03*G6_0_1_3_1_4_4_0 - 4.166666666666657e-03*G6_0_1_3_1_4_4_1 - 4.166666666666657e-03*G6_0_1_3_1_4_4_2 + 4.166666666666656e-03*G6_0_1_3_1_4_5_0 + 4.166666666666657e-03*G6_0_1_3_1_4_6_1 + 4.166666666666657e-03*G6_0_1_3_1_4_7_2 - 4.166666666666656e-03*G6_0_1_3_1_5_4_0 - 4.166666666666657e-03*G6_0_1_3_1_5_4_1 - 4.166666666666657e-03*G6_0_1_3_1_5_4_2 + 4.166666666666656e-03*G6_0_1_3_1_5_5_0 + 4.166666666666657e-03*G6_0_1_3_1_5_6_1 + 4.166666666666657e-03*G6_0_1_3_1_5_7_2 - 4.166666666666655e-03*G6_0_1_3_1_6_4_0 - 4.166666666666656e-03*G6_0_1_3_1_6_4_1 - 4.166666666666657e-03*G6_0_1_3_1_6_4_2 + 4.166666666666655e-03*G6_0_1_3_1_6_5_0 + 4.166666666666656e-03*G6_0_1_3_1_6_6_1 + 4.166666666666656e-03*G6_0_1_3_1_6_7_2 - 8.333333333333311e-03*G6_0_1_3_1_7_4_0 - 8.333333333333311e-03*G6_0_1_3_1_7_4_1 - 8.333333333333312e-03*G6_0_1_3_1_7_4_2 + 8.333333333333311e-03*G6_0_1_3_1_7_5_0 + 8.333333333333311e-03*G6_0_1_3_1_7_6_1 + 8.333333333333311e-03*G6_0_1_3_1_7_7_2 - 4.166666666666657e-03*G6_0_1_3_2_4_4_0 - 4.166666666666657e-03*G6_0_1_3_2_4_4_1 - 4.166666666666658e-03*G6_0_1_3_2_4_4_2 + 4.166666666666657e-03*G6_0_1_3_2_4_5_0 + 4.166666666666657e-03*G6_0_1_3_2_4_6_1 + 4.166666666666657e-03*G6_0_1_3_2_4_7_2 - 4.166666666666656e-03*G6_0_1_3_2_5_4_0 - 4.166666666666657e-03*G6_0_1_3_2_5_4_1 - 4.166666666666657e-03*G6_0_1_3_2_5_4_2 + 4.166666666666656e-03*G6_0_1_3_2_5_5_0 + 4.166666666666657e-03*G6_0_1_3_2_5_6_1 + 4.166666666666657e-03*G6_0_1_3_2_5_7_2 - 4.166666666666655e-03*G6_0_1_3_2_6_4_0 - 4.166666666666657e-03*G6_0_1_3_2_6_4_1 - 4.166666666666657e-03*G6_0_1_3_2_6_4_2 + 4.166666666666655e-03*G6_0_1_3_2_6_5_0 + 4.166666666666657e-03*G6_0_1_3_2_6_6_1 + 4.166666666666657e-03*G6_0_1_3_2_6_7_2 - 8.333333333333311e-03*G6_0_1_3_2_7_4_0 - 8.333333333333312e-03*G6_0_1_3_2_7_4_1 - 8.333333333333312e-03*G6_0_1_3_2_7_4_2 + 8.333333333333311e-03*G6_0_1_3_2_7_5_0 + 8.333333333333312e-03*G6_0_1_3_2_7_6_1 + 8.333333333333312e-03*G6_0_1_3_2_7_7_2 - 8.333333333333309e-03*G6_0_2_0_0_8_4_0 - 8.333333333333309e-03*G6_0_2_0_0_8_4_1 - 8.333333333333311e-03*G6_0_2_0_0_8_4_2 + 8.333333333333309e-03*G6_0_2_0_0_8_5_0 + 8.333333333333309e-03*G6_0_2_0_0_8_6_1 + 8.333333333333309e-03*G6_0_2_0_0_8_7_2 - 4.166666666666654e-03*G6_0_2_0_0_9_4_0 - 4.166666666666655e-03*G6_0_2_0_0_9_4_1 - 4.166666666666655e-03*G6_0_2_0_0_9_4_2 + 4.166666666666654e-03*G6_0_2_0_0_9_5_0 + 4.166666666666655e-03*G6_0_2_0_0_9_6_1 + 4.166666666666655e-03*G6_0_2_0_0_9_7_2 - 4.166666666666654e-03*G6_0_2_0_0_10_4_0 - 4.166666666666654e-03*G6_0_2_0_0_10_4_1 - 4.166666666666656e-03*G6_0_2_0_0_10_4_2 + 4.166666666666654e-03*G6_0_2_0_0_10_5_0 + 4.166666666666654e-03*G6_0_2_0_0_10_6_1 + 4.166666666666654e-03*G6_0_2_0_0_10_7_2 - 4.166666666666656e-03*G6_0_2_0_0_11_4_0 - 4.166666666666656e-03*G6_0_2_0_0_11_4_1 - 4.166666666666657e-03*G6_0_2_0_0_11_4_2 + 4.166666666666656e-03*G6_0_2_0_0_11_5_0 + 4.166666666666656e-03*G6_0_2_0_0_11_6_1 + 4.166666666666656e-03*G6_0_2_0_0_11_7_2 - 8.333333333333309e-03*G6_0_2_0_1_8_4_0 - 8.333333333333311e-03*G6_0_2_0_1_8_4_1 - 8.333333333333312e-03*G6_0_2_0_1_8_4_2 + 8.333333333333309e-03*G6_0_2_0_1_8_5_0 + 8.333333333333311e-03*G6_0_2_0_1_8_6_1 + 8.333333333333311e-03*G6_0_2_0_1_8_7_2 - 4.166666666666655e-03*G6_0_2_0_1_9_4_0 - 4.166666666666655e-03*G6_0_2_0_1_9_4_1 - 4.166666666666656e-03*G6_0_2_0_1_9_4_2 + 4.166666666666655e-03*G6_0_2_0_1_9_5_0 + 4.166666666666655e-03*G6_0_2_0_1_9_6_1 + 4.166666666666655e-03*G6_0_2_0_1_9_7_2 - 4.166666666666654e-03*G6_0_2_0_1_10_4_0 - 4.166666666666656e-03*G6_0_2_0_1_10_4_1 - 4.166666666666656e-03*G6_0_2_0_1_10_4_2 + 4.166666666666654e-03*G6_0_2_0_1_10_5_0 + 4.166666666666656e-03*G6_0_2_0_1_10_6_1 + 4.166666666666656e-03*G6_0_2_0_1_10_7_2 - 4.166666666666656e-03*G6_0_2_0_1_11_4_0 - 4.166666666666657e-03*G6_0_2_0_1_11_4_1 - 4.166666666666658e-03*G6_0_2_0_1_11_4_2 + 4.166666666666656e-03*G6_0_2_0_1_11_5_0 + 4.166666666666657e-03*G6_0_2_0_1_11_6_1 + 4.166666666666657e-03*G6_0_2_0_1_11_7_2 - 8.333333333333311e-03*G6_0_2_0_2_8_4_0 - 8.333333333333312e-03*G6_0_2_0_2_8_4_1 - 8.333333333333314e-03*G6_0_2_0_2_8_4_2 + 8.333333333333311e-03*G6_0_2_0_2_8_5_0 + 8.333333333333312e-03*G6_0_2_0_2_8_6_1 + 8.333333333333312e-03*G6_0_2_0_2_8_7_2 - 4.166666666666655e-03*G6_0_2_0_2_9_4_0 - 4.166666666666656e-03*G6_0_2_0_2_9_4_1 - 4.166666666666657e-03*G6_0_2_0_2_9_4_2 + 4.166666666666655e-03*G6_0_2_0_2_9_5_0 + 4.166666666666656e-03*G6_0_2_0_2_9_6_1 + 4.166666666666656e-03*G6_0_2_0_2_9_7_2 - 4.166666666666655e-03*G6_0_2_0_2_10_4_0 - 4.166666666666656e-03*G6_0_2_0_2_10_4_1 - 4.166666666666656e-03*G6_0_2_0_2_10_4_2 + 4.166666666666655e-03*G6_0_2_0_2_10_5_0 + 4.166666666666656e-03*G6_0_2_0_2_10_6_1 + 4.166666666666656e-03*G6_0_2_0_2_10_7_2 - 4.166666666666657e-03*G6_0_2_0_2_11_4_0 - 4.166666666666658e-03*G6_0_2_0_2_11_4_1 - 4.166666666666659e-03*G6_0_2_0_2_11_4_2 + 4.166666666666657e-03*G6_0_2_0_2_11_5_0 + 4.166666666666658e-03*G6_0_2_0_2_11_6_1 + 4.166666666666658e-03*G6_0_2_0_2_11_7_2 - 4.166666666666654e-03*G6_0_2_1_0_8_4_0 - 4.166666666666654e-03*G6_0_2_1_0_8_4_1 - 4.166666666666654e-03*G6_0_2_1_0_8_4_2 + 4.166666666666654e-03*G6_0_2_1_0_8_5_0 + 4.166666666666654e-03*G6_0_2_1_0_8_6_1 + 4.166666666666654e-03*G6_0_2_1_0_8_7_2 - 8.333333333333307e-03*G6_0_2_1_0_9_4_0 - 8.333333333333309e-03*G6_0_2_1_0_9_4_1 - 8.333333333333309e-03*G6_0_2_1_0_9_4_2 + 8.333333333333307e-03*G6_0_2_1_0_9_5_0 + 8.333333333333309e-03*G6_0_2_1_0_9_6_1 + 8.333333333333309e-03*G6_0_2_1_0_9_7_2 - 4.166666666666654e-03*G6_0_2_1_0_10_4_0 - 4.166666666666654e-03*G6_0_2_1_0_10_4_1 - 4.166666666666654e-03*G6_0_2_1_0_10_4_2 + 4.166666666666654e-03*G6_0_2_1_0_10_5_0 + 4.166666666666654e-03*G6_0_2_1_0_10_6_1 + 4.166666666666654e-03*G6_0_2_1_0_10_7_2 - 4.166666666666654e-03*G6_0_2_1_0_11_4_0 - 4.166666666666655e-03*G6_0_2_1_0_11_4_1 - 4.166666666666655e-03*G6_0_2_1_0_11_4_2 + 4.166666666666654e-03*G6_0_2_1_0_11_5_0 + 4.166666666666655e-03*G6_0_2_1_0_11_6_1 + 4.166666666666655e-03*G6_0_2_1_0_11_7_2 - 4.166666666666654e-03*G6_0_2_1_1_8_4_0 - 4.166666666666654e-03*G6_0_2_1_1_8_4_1 - 4.166666666666654e-03*G6_0_2_1_1_8_4_2 + 4.166666666666654e-03*G6_0_2_1_1_8_5_0 + 4.166666666666654e-03*G6_0_2_1_1_8_6_1 + 4.166666666666654e-03*G6_0_2_1_1_8_7_2 - 8.333333333333309e-03*G6_0_2_1_1_9_4_0 - 8.333333333333309e-03*G6_0_2_1_1_9_4_1 - 8.333333333333309e-03*G6_0_2_1_1_9_4_2 + 8.333333333333309e-03*G6_0_2_1_1_9_5_0 + 8.333333333333309e-03*G6_0_2_1_1_9_6_1 + 8.333333333333309e-03*G6_0_2_1_1_9_7_2 - 4.166666666666654e-03*G6_0_2_1_1_10_4_0 - 4.166666666666654e-03*G6_0_2_1_1_10_4_1 - 4.166666666666655e-03*G6_0_2_1_1_10_4_2 + 4.166666666666654e-03*G6_0_2_1_1_10_5_0 + 4.166666666666654e-03*G6_0_2_1_1_10_6_1 + 4.166666666666654e-03*G6_0_2_1_1_10_7_2 - 4.166666666666655e-03*G6_0_2_1_1_11_4_0 - 4.166666666666655e-03*G6_0_2_1_1_11_4_1 - 4.166666666666656e-03*G6_0_2_1_1_11_4_2 + 4.166666666666655e-03*G6_0_2_1_1_11_5_0 + 4.166666666666655e-03*G6_0_2_1_1_11_6_1 + 4.166666666666655e-03*G6_0_2_1_1_11_7_2 - 4.166666666666654e-03*G6_0_2_1_2_8_4_0 - 4.166666666666654e-03*G6_0_2_1_2_8_4_1 - 4.166666666666655e-03*G6_0_2_1_2_8_4_2 + 4.166666666666654e-03*G6_0_2_1_2_8_5_0 + 4.166666666666654e-03*G6_0_2_1_2_8_6_1 + 4.166666666666654e-03*G6_0_2_1_2_8_7_2 - 8.333333333333309e-03*G6_0_2_1_2_9_4_0 - 8.333333333333309e-03*G6_0_2_1_2_9_4_1 - 8.333333333333309e-03*G6_0_2_1_2_9_4_2 + 8.333333333333309e-03*G6_0_2_1_2_9_5_0 + 8.333333333333309e-03*G6_0_2_1_2_9_6_1 + 8.333333333333309e-03*G6_0_2_1_2_9_7_2 - 4.166666666666654e-03*G6_0_2_1_2_10_4_0 - 4.166666666666655e-03*G6_0_2_1_2_10_4_1 - 4.166666666666655e-03*G6_0_2_1_2_10_4_2 + 4.166666666666654e-03*G6_0_2_1_2_10_5_0 + 4.166666666666655e-03*G6_0_2_1_2_10_6_1 + 4.166666666666655e-03*G6_0_2_1_2_10_7_2 - 4.166666666666655e-03*G6_0_2_1_2_11_4_0 - 4.166666666666656e-03*G6_0_2_1_2_11_4_1 - 4.166666666666656e-03*G6_0_2_1_2_11_4_2 + 4.166666666666655e-03*G6_0_2_1_2_11_5_0 + 4.166666666666656e-03*G6_0_2_1_2_11_6_1 + 4.166666666666656e-03*G6_0_2_1_2_11_7_2 - 4.166666666666653e-03*G6_0_2_2_0_8_4_0 - 4.166666666666654e-03*G6_0_2_2_0_8_4_1 - 4.166666666666654e-03*G6_0_2_2_0_8_4_2 + 4.166666666666653e-03*G6_0_2_2_0_8_5_0 + 4.166666666666654e-03*G6_0_2_2_0_8_6_1 + 4.166666666666654e-03*G6_0_2_2_0_8_7_2 - 4.166666666666654e-03*G6_0_2_2_0_9_4_0 - 4.166666666666655e-03*G6_0_2_2_0_9_4_1 - 4.166666666666655e-03*G6_0_2_2_0_9_4_2 + 4.166666666666654e-03*G6_0_2_2_0_9_5_0 + 4.166666666666655e-03*G6_0_2_2_0_9_6_1 + 4.166666666666655e-03*G6_0_2_2_0_9_7_2 - 8.333333333333309e-03*G6_0_2_2_0_10_4_0 - 8.333333333333309e-03*G6_0_2_2_0_10_4_1 - 8.333333333333311e-03*G6_0_2_2_0_10_4_2 + 8.333333333333309e-03*G6_0_2_2_0_10_5_0 + 8.333333333333309e-03*G6_0_2_2_0_10_6_1 + 8.333333333333309e-03*G6_0_2_2_0_10_7_2 - 4.166666666666654e-03*G6_0_2_2_0_11_4_0 - 4.166666666666655e-03*G6_0_2_2_0_11_4_1 - 4.166666666666655e-03*G6_0_2_2_0_11_4_2 + 4.166666666666654e-03*G6_0_2_2_0_11_5_0 + 4.166666666666655e-03*G6_0_2_2_0_11_6_1 + 4.166666666666655e-03*G6_0_2_2_0_11_7_2 - 4.166666666666654e-03*G6_0_2_2_1_8_4_0 - 4.166666666666654e-03*G6_0_2_2_1_8_4_1 - 4.166666666666654e-03*G6_0_2_2_1_8_4_2 + 4.166666666666654e-03*G6_0_2_2_1_8_5_0 + 4.166666666666654e-03*G6_0_2_2_1_8_6_1 + 4.166666666666654e-03*G6_0_2_2_1_8_7_2 - 4.166666666666655e-03*G6_0_2_2_1_9_4_0 - 4.166666666666656e-03*G6_0_2_2_1_9_4_1 - 4.166666666666656e-03*G6_0_2_2_1_9_4_2 + 4.166666666666655e-03*G6_0_2_2_1_9_5_0 + 4.166666666666656e-03*G6_0_2_2_1_9_6_1 + 4.166666666666656e-03*G6_0_2_2_1_9_7_2 - 8.333333333333311e-03*G6_0_2_2_1_10_4_0 - 8.333333333333311e-03*G6_0_2_2_1_10_4_1 - 8.333333333333312e-03*G6_0_2_2_1_10_4_2 + 8.333333333333311e-03*G6_0_2_2_1_10_5_0 + 8.333333333333311e-03*G6_0_2_2_1_10_6_1 + 8.333333333333311e-03*G6_0_2_2_1_10_7_2 - 4.166666666666655e-03*G6_0_2_2_1_11_4_0 - 4.166666666666656e-03*G6_0_2_2_1_11_4_1 - 4.166666666666657e-03*G6_0_2_2_1_11_4_2 + 4.166666666666655e-03*G6_0_2_2_1_11_5_0 + 4.166666666666656e-03*G6_0_2_2_1_11_6_1 + 4.166666666666656e-03*G6_0_2_2_1_11_7_2 - 4.166666666666654e-03*G6_0_2_2_2_8_4_0 - 4.166666666666654e-03*G6_0_2_2_2_8_4_1 - 4.166666666666654e-03*G6_0_2_2_2_8_4_2 + 4.166666666666654e-03*G6_0_2_2_2_8_5_0 + 4.166666666666654e-03*G6_0_2_2_2_8_6_1 + 4.166666666666654e-03*G6_0_2_2_2_8_7_2 - 4.166666666666655e-03*G6_0_2_2_2_9_4_0 - 4.166666666666656e-03*G6_0_2_2_2_9_4_1 - 4.166666666666656e-03*G6_0_2_2_2_9_4_2 + 4.166666666666655e-03*G6_0_2_2_2_9_5_0 + 4.166666666666656e-03*G6_0_2_2_2_9_6_1 + 4.166666666666656e-03*G6_0_2_2_2_9_7_2 - 8.333333333333311e-03*G6_0_2_2_2_10_4_0 - 8.333333333333312e-03*G6_0_2_2_2_10_4_1 - 8.333333333333312e-03*G6_0_2_2_2_10_4_2 + 8.333333333333311e-03*G6_0_2_2_2_10_5_0 + 8.333333333333312e-03*G6_0_2_2_2_10_6_1 + 8.333333333333312e-03*G6_0_2_2_2_10_7_2 - 4.166666666666655e-03*G6_0_2_2_2_11_4_0 - 4.166666666666657e-03*G6_0_2_2_2_11_4_1 - 4.166666666666657e-03*G6_0_2_2_2_11_4_2 + 4.166666666666655e-03*G6_0_2_2_2_11_5_0 + 4.166666666666657e-03*G6_0_2_2_2_11_6_1 + 4.166666666666657e-03*G6_0_2_2_2_11_7_2 - 4.166666666666655e-03*G6_0_2_3_0_8_4_0 - 4.166666666666656e-03*G6_0_2_3_0_8_4_1 - 4.166666666666657e-03*G6_0_2_3_0_8_4_2 + 4.166666666666655e-03*G6_0_2_3_0_8_5_0 + 4.166666666666656e-03*G6_0_2_3_0_8_6_1 + 4.166666666666656e-03*G6_0_2_3_0_8_7_2 - 4.166666666666655e-03*G6_0_2_3_0_9_4_0 - 4.166666666666656e-03*G6_0_2_3_0_9_4_1 - 4.166666666666656e-03*G6_0_2_3_0_9_4_2 + 4.166666666666655e-03*G6_0_2_3_0_9_5_0 + 4.166666666666656e-03*G6_0_2_3_0_9_6_1 + 4.166666666666656e-03*G6_0_2_3_0_9_7_2 - 4.166666666666655e-03*G6_0_2_3_0_10_4_0 - 4.166666666666655e-03*G6_0_2_3_0_10_4_1 - 4.166666666666655e-03*G6_0_2_3_0_10_4_2 + 4.166666666666655e-03*G6_0_2_3_0_10_5_0 + 4.166666666666655e-03*G6_0_2_3_0_10_6_1 + 4.166666666666655e-03*G6_0_2_3_0_10_7_2 - 8.333333333333309e-03*G6_0_2_3_0_11_4_0 - 8.333333333333311e-03*G6_0_2_3_0_11_4_1 - 8.333333333333311e-03*G6_0_2_3_0_11_4_2 + 8.333333333333309e-03*G6_0_2_3_0_11_5_0 + 8.333333333333311e-03*G6_0_2_3_0_11_6_1 + 8.333333333333311e-03*G6_0_2_3_0_11_7_2 - 4.166666666666656e-03*G6_0_2_3_1_8_4_0 - 4.166666666666657e-03*G6_0_2_3_1_8_4_1 - 4.166666666666657e-03*G6_0_2_3_1_8_4_2 + 4.166666666666656e-03*G6_0_2_3_1_8_5_0 + 4.166666666666657e-03*G6_0_2_3_1_8_6_1 + 4.166666666666657e-03*G6_0_2_3_1_8_7_2 - 4.166666666666656e-03*G6_0_2_3_1_9_4_0 - 4.166666666666657e-03*G6_0_2_3_1_9_4_1 - 4.166666666666657e-03*G6_0_2_3_1_9_4_2 + 4.166666666666656e-03*G6_0_2_3_1_9_5_0 + 4.166666666666657e-03*G6_0_2_3_1_9_6_1 + 4.166666666666657e-03*G6_0_2_3_1_9_7_2 - 4.166666666666655e-03*G6_0_2_3_1_10_4_0 - 4.166666666666656e-03*G6_0_2_3_1_10_4_1 - 4.166666666666657e-03*G6_0_2_3_1_10_4_2 + 4.166666666666655e-03*G6_0_2_3_1_10_5_0 + 4.166666666666656e-03*G6_0_2_3_1_10_6_1 + 4.166666666666656e-03*G6_0_2_3_1_10_7_2 - 8.333333333333311e-03*G6_0_2_3_1_11_4_0 - 8.333333333333311e-03*G6_0_2_3_1_11_4_1 - 8.333333333333312e-03*G6_0_2_3_1_11_4_2 + 8.333333333333311e-03*G6_0_2_3_1_11_5_0 + 8.333333333333311e-03*G6_0_2_3_1_11_6_1 + 8.333333333333311e-03*G6_0_2_3_1_11_7_2 - 4.166666666666657e-03*G6_0_2_3_2_8_4_0 - 4.166666666666657e-03*G6_0_2_3_2_8_4_1 - 4.166666666666658e-03*G6_0_2_3_2_8_4_2 + 4.166666666666657e-03*G6_0_2_3_2_8_5_0 + 4.166666666666657e-03*G6_0_2_3_2_8_6_1 + 4.166666666666657e-03*G6_0_2_3_2_8_7_2 - 4.166666666666656e-03*G6_0_2_3_2_9_4_0 - 4.166666666666657e-03*G6_0_2_3_2_9_4_1 - 4.166666666666657e-03*G6_0_2_3_2_9_4_2 + 4.166666666666656e-03*G6_0_2_3_2_9_5_0 + 4.166666666666657e-03*G6_0_2_3_2_9_6_1 + 4.166666666666657e-03*G6_0_2_3_2_9_7_2 - 4.166666666666655e-03*G6_0_2_3_2_10_4_0 - 4.166666666666657e-03*G6_0_2_3_2_10_4_1 - 4.166666666666657e-03*G6_0_2_3_2_10_4_2 + 4.166666666666655e-03*G6_0_2_3_2_10_5_0 + 4.166666666666657e-03*G6_0_2_3_2_10_6_1 + 4.166666666666657e-03*G6_0_2_3_2_10_7_2 - 8.333333333333311e-03*G6_0_2_3_2_11_4_0 - 8.333333333333312e-03*G6_0_2_3_2_11_4_1 - 8.333333333333312e-03*G6_0_2_3_2_11_4_2 + 8.333333333333311e-03*G6_0_2_3_2_11_5_0 + 8.333333333333312e-03*G6_0_2_3_2_11_6_1 + 8.333333333333312e-03*G6_0_2_3_2_11_7_2 - 8.333333333333309e-03*G6_1_0_4_0_0_4_0 - 8.333333333333309e-03*G6_1_0_4_0_0_4_1 - 8.333333333333311e-03*G6_1_0_4_0_0_4_2 + 8.333333333333309e-03*G6_1_0_4_0_0_5_0 + 8.333333333333309e-03*G6_1_0_4_0_0_6_1 + 8.333333333333309e-03*G6_1_0_4_0_0_7_2 - 4.166666666666654e-03*G6_1_0_4_0_1_4_0 - 4.166666666666654e-03*G6_1_0_4_0_1_4_1 - 4.166666666666654e-03*G6_1_0_4_0_1_4_2 + 4.166666666666654e-03*G6_1_0_4_0_1_5_0 + 4.166666666666654e-03*G6_1_0_4_0_1_6_1 + 4.166666666666654e-03*G6_1_0_4_0_1_7_2 - 4.166666666666653e-03*G6_1_0_4_0_2_4_0 - 4.166666666666654e-03*G6_1_0_4_0_2_4_1 - 4.166666666666654e-03*G6_1_0_4_0_2_4_2 + 4.166666666666653e-03*G6_1_0_4_0_2_5_0 + 4.166666666666654e-03*G6_1_0_4_0_2_6_1 + 4.166666666666654e-03*G6_1_0_4_0_2_7_2 - 4.166666666666654e-03*G6_1_0_4_0_3_4_0 - 4.166666666666656e-03*G6_1_0_4_0_3_4_1 - 4.166666666666657e-03*G6_1_0_4_0_3_4_2 + 4.166666666666654e-03*G6_1_0_4_0_3_5_0 + 4.166666666666656e-03*G6_1_0_4_0_3_6_1 + 4.166666666666656e-03*G6_1_0_4_0_3_7_2 - 8.333333333333309e-03*G6_1_0_4_1_0_4_0 - 8.333333333333311e-03*G6_1_0_4_1_0_4_1 - 8.333333333333312e-03*G6_1_0_4_1_0_4_2 + 8.333333333333309e-03*G6_1_0_4_1_0_5_0 + 8.333333333333311e-03*G6_1_0_4_1_0_6_1 + 8.333333333333311e-03*G6_1_0_4_1_0_7_2 - 4.166666666666654e-03*G6_1_0_4_1_1_4_0 - 4.166666666666654e-03*G6_1_0_4_1_1_4_1 - 4.166666666666654e-03*G6_1_0_4_1_1_4_2 + 4.166666666666654e-03*G6_1_0_4_1_1_5_0 + 4.166666666666654e-03*G6_1_0_4_1_1_6_1 + 4.166666666666654e-03*G6_1_0_4_1_1_7_2 - 4.166666666666654e-03*G6_1_0_4_1_2_4_0 - 4.166666666666654e-03*G6_1_0_4_1_2_4_1 - 4.166666666666654e-03*G6_1_0_4_1_2_4_2 + 4.166666666666654e-03*G6_1_0_4_1_2_5_0 + 4.166666666666654e-03*G6_1_0_4_1_2_6_1 + 4.166666666666654e-03*G6_1_0_4_1_2_7_2 - 4.166666666666656e-03*G6_1_0_4_1_3_4_0 - 4.166666666666657e-03*G6_1_0_4_1_3_4_1 - 4.166666666666657e-03*G6_1_0_4_1_3_4_2 + 4.166666666666656e-03*G6_1_0_4_1_3_5_0 + 4.166666666666657e-03*G6_1_0_4_1_3_6_1 + 4.166666666666657e-03*G6_1_0_4_1_3_7_2 - 8.333333333333311e-03*G6_1_0_4_2_0_4_0 - 8.333333333333312e-03*G6_1_0_4_2_0_4_1 - 8.333333333333314e-03*G6_1_0_4_2_0_4_2 + 8.333333333333311e-03*G6_1_0_4_2_0_5_0 + 8.333333333333312e-03*G6_1_0_4_2_0_6_1 + 8.333333333333312e-03*G6_1_0_4_2_0_7_2 - 4.166666666666654e-03*G6_1_0_4_2_1_4_0 - 4.166666666666654e-03*G6_1_0_4_2_1_4_1 - 4.166666666666655e-03*G6_1_0_4_2_1_4_2 + 4.166666666666654e-03*G6_1_0_4_2_1_5_0 + 4.166666666666654e-03*G6_1_0_4_2_1_6_1 + 4.166666666666654e-03*G6_1_0_4_2_1_7_2 - 4.166666666666654e-03*G6_1_0_4_2_2_4_0 - 4.166666666666654e-03*G6_1_0_4_2_2_4_1 - 4.166666666666654e-03*G6_1_0_4_2_2_4_2 + 4.166666666666654e-03*G6_1_0_4_2_2_5_0 + 4.166666666666654e-03*G6_1_0_4_2_2_6_1 + 4.166666666666654e-03*G6_1_0_4_2_2_7_2 - 4.166666666666657e-03*G6_1_0_4_2_3_4_0 - 4.166666666666657e-03*G6_1_0_4_2_3_4_1 - 4.166666666666658e-03*G6_1_0_4_2_3_4_2 + 4.166666666666657e-03*G6_1_0_4_2_3_5_0 + 4.166666666666657e-03*G6_1_0_4_2_3_6_1 + 4.166666666666657e-03*G6_1_0_4_2_3_7_2 - 4.166666666666654e-03*G6_1_0_5_0_0_4_0 - 4.166666666666655e-03*G6_1_0_5_0_0_4_1 - 4.166666666666655e-03*G6_1_0_5_0_0_4_2 + 4.166666666666654e-03*G6_1_0_5_0_0_5_0 + 4.166666666666655e-03*G6_1_0_5_0_0_6_1 + 4.166666666666655e-03*G6_1_0_5_0_0_7_2 - 8.333333333333307e-03*G6_1_0_5_0_1_4_0 - 8.333333333333309e-03*G6_1_0_5_0_1_4_1 - 8.333333333333309e-03*G6_1_0_5_0_1_4_2 + 8.333333333333307e-03*G6_1_0_5_0_1_5_0 + 8.333333333333309e-03*G6_1_0_5_0_1_6_1 + 8.333333333333309e-03*G6_1_0_5_0_1_7_2 - 4.166666666666654e-03*G6_1_0_5_0_2_4_0 - 4.166666666666655e-03*G6_1_0_5_0_2_4_1 - 4.166666666666655e-03*G6_1_0_5_0_2_4_2 + 4.166666666666654e-03*G6_1_0_5_0_2_5_0 + 4.166666666666655e-03*G6_1_0_5_0_2_6_1 + 4.166666666666655e-03*G6_1_0_5_0_2_7_2 - 4.166666666666655e-03*G6_1_0_5_0_3_4_0 - 4.166666666666656e-03*G6_1_0_5_0_3_4_1 - 4.166666666666656e-03*G6_1_0_5_0_3_4_2 + 4.166666666666655e-03*G6_1_0_5_0_3_5_0 + 4.166666666666656e-03*G6_1_0_5_0_3_6_1 + 4.166666666666656e-03*G6_1_0_5_0_3_7_2 - 4.166666666666655e-03*G6_1_0_5_1_0_4_0 - 4.166666666666655e-03*G6_1_0_5_1_0_4_1 - 4.166666666666656e-03*G6_1_0_5_1_0_4_2 + 4.166666666666655e-03*G6_1_0_5_1_0_5_0 + 4.166666666666655e-03*G6_1_0_5_1_0_6_1 + 4.166666666666655e-03*G6_1_0_5_1_0_7_2 - 8.333333333333309e-03*G6_1_0_5_1_1_4_0 - 8.333333333333309e-03*G6_1_0_5_1_1_4_1 - 8.333333333333309e-03*G6_1_0_5_1_1_4_2 + 8.333333333333309e-03*G6_1_0_5_1_1_5_0 + 8.333333333333309e-03*G6_1_0_5_1_1_6_1 + 8.333333333333309e-03*G6_1_0_5_1_1_7_2 - 4.166666666666655e-03*G6_1_0_5_1_2_4_0 - 4.166666666666656e-03*G6_1_0_5_1_2_4_1 - 4.166666666666656e-03*G6_1_0_5_1_2_4_2 + 4.166666666666655e-03*G6_1_0_5_1_2_5_0 + 4.166666666666656e-03*G6_1_0_5_1_2_6_1 + 4.166666666666656e-03*G6_1_0_5_1_2_7_2 - 4.166666666666656e-03*G6_1_0_5_1_3_4_0 - 4.166666666666657e-03*G6_1_0_5_1_3_4_1 - 4.166666666666657e-03*G6_1_0_5_1_3_4_2 + 4.166666666666656e-03*G6_1_0_5_1_3_5_0 + 4.166666666666657e-03*G6_1_0_5_1_3_6_1 + 4.166666666666657e-03*G6_1_0_5_1_3_7_2 - 4.166666666666655e-03*G6_1_0_5_2_0_4_0 - 4.166666666666656e-03*G6_1_0_5_2_0_4_1 - 4.166666666666657e-03*G6_1_0_5_2_0_4_2 + 4.166666666666655e-03*G6_1_0_5_2_0_5_0 + 4.166666666666656e-03*G6_1_0_5_2_0_6_1 + 4.166666666666656e-03*G6_1_0_5_2_0_7_2 - 8.333333333333309e-03*G6_1_0_5_2_1_4_0 - 8.333333333333309e-03*G6_1_0_5_2_1_4_1 - 8.333333333333309e-03*G6_1_0_5_2_1_4_2 + 8.333333333333309e-03*G6_1_0_5_2_1_5_0 + 8.333333333333309e-03*G6_1_0_5_2_1_6_1 + 8.333333333333309e-03*G6_1_0_5_2_1_7_2 - 4.166666666666655e-03*G6_1_0_5_2_2_4_0 - 4.166666666666656e-03*G6_1_0_5_2_2_4_1 - 4.166666666666656e-03*G6_1_0_5_2_2_4_2 + 4.166666666666655e-03*G6_1_0_5_2_2_5_0 + 4.166666666666656e-03*G6_1_0_5_2_2_6_1 + 4.166666666666656e-03*G6_1_0_5_2_2_7_2 - 4.166666666666656e-03*G6_1_0_5_2_3_4_0 - 4.166666666666657e-03*G6_1_0_5_2_3_4_1 - 4.166666666666657e-03*G6_1_0_5_2_3_4_2 + 4.166666666666656e-03*G6_1_0_5_2_3_5_0 + 4.166666666666657e-03*G6_1_0_5_2_3_6_1 + 4.166666666666657e-03*G6_1_0_5_2_3_7_2 - 4.166666666666654e-03*G6_1_0_6_0_0_4_0 - 4.166666666666654e-03*G6_1_0_6_0_0_4_1 - 4.166666666666655e-03*G6_1_0_6_0_0_4_2 + 4.166666666666654e-03*G6_1_0_6_0_0_5_0 + 4.166666666666654e-03*G6_1_0_6_0_0_6_1 + 4.166666666666654e-03*G6_1_0_6_0_0_7_2 - 4.166666666666654e-03*G6_1_0_6_0_1_4_0 - 4.166666666666654e-03*G6_1_0_6_0_1_4_1 - 4.166666666666654e-03*G6_1_0_6_0_1_4_2 + 4.166666666666654e-03*G6_1_0_6_0_1_5_0 + 4.166666666666654e-03*G6_1_0_6_0_1_6_1 + 4.166666666666654e-03*G6_1_0_6_0_1_7_2 - 8.333333333333309e-03*G6_1_0_6_0_2_4_0 - 8.333333333333309e-03*G6_1_0_6_0_2_4_1 - 8.333333333333311e-03*G6_1_0_6_0_2_4_2 + 8.333333333333309e-03*G6_1_0_6_0_2_5_0 + 8.333333333333309e-03*G6_1_0_6_0_2_6_1 + 8.333333333333309e-03*G6_1_0_6_0_2_7_2 - 4.166666666666654e-03*G6_1_0_6_0_3_4_0 - 4.166666666666655e-03*G6_1_0_6_0_3_4_1 - 4.166666666666655e-03*G6_1_0_6_0_3_4_2 + 4.166666666666654e-03*G6_1_0_6_0_3_5_0 + 4.166666666666655e-03*G6_1_0_6_0_3_6_1 + 4.166666666666655e-03*G6_1_0_6_0_3_7_2 - 4.166666666666654e-03*G6_1_0_6_1_0_4_0 - 4.166666666666656e-03*G6_1_0_6_1_0_4_1 - 4.166666666666656e-03*G6_1_0_6_1_0_4_2 + 4.166666666666654e-03*G6_1_0_6_1_0_5_0 + 4.166666666666656e-03*G6_1_0_6_1_0_6_1 + 4.166666666666656e-03*G6_1_0_6_1_0_7_2 - 4.166666666666654e-03*G6_1_0_6_1_1_4_0 - 4.166666666666654e-03*G6_1_0_6_1_1_4_1 - 4.166666666666654e-03*G6_1_0_6_1_1_4_2 + 4.166666666666654e-03*G6_1_0_6_1_1_5_0 + 4.166666666666654e-03*G6_1_0_6_1_1_6_1 + 4.166666666666654e-03*G6_1_0_6_1_1_7_2 - 8.333333333333311e-03*G6_1_0_6_1_2_4_0 - 8.333333333333311e-03*G6_1_0_6_1_2_4_1 - 8.333333333333312e-03*G6_1_0_6_1_2_4_2 + 8.333333333333311e-03*G6_1_0_6_1_2_5_0 + 8.333333333333311e-03*G6_1_0_6_1_2_6_1 + 8.333333333333311e-03*G6_1_0_6_1_2_7_2 - 4.166666666666655e-03*G6_1_0_6_1_3_4_0 - 4.166666666666656e-03*G6_1_0_6_1_3_4_1 - 4.166666666666657e-03*G6_1_0_6_1_3_4_2 + 4.166666666666655e-03*G6_1_0_6_1_3_5_0 + 4.166666666666656e-03*G6_1_0_6_1_3_6_1 + 4.166666666666656e-03*G6_1_0_6_1_3_7_2 - 4.166666666666655e-03*G6_1_0_6_2_0_4_0 - 4.166666666666656e-03*G6_1_0_6_2_0_4_1 - 4.166666666666656e-03*G6_1_0_6_2_0_4_2 + 4.166666666666655e-03*G6_1_0_6_2_0_5_0 + 4.166666666666656e-03*G6_1_0_6_2_0_6_1 + 4.166666666666656e-03*G6_1_0_6_2_0_7_2 - 4.166666666666654e-03*G6_1_0_6_2_1_4_0 - 4.166666666666654e-03*G6_1_0_6_2_1_4_1 - 4.166666666666655e-03*G6_1_0_6_2_1_4_2 + 4.166666666666654e-03*G6_1_0_6_2_1_5_0 + 4.166666666666654e-03*G6_1_0_6_2_1_6_1 + 4.166666666666654e-03*G6_1_0_6_2_1_7_2 - 8.333333333333311e-03*G6_1_0_6_2_2_4_0 - 8.333333333333312e-03*G6_1_0_6_2_2_4_1 - 8.333333333333312e-03*G6_1_0_6_2_2_4_2 + 8.333333333333311e-03*G6_1_0_6_2_2_5_0 + 8.333333333333312e-03*G6_1_0_6_2_2_6_1 + 8.333333333333312e-03*G6_1_0_6_2_2_7_2 - 4.166666666666655e-03*G6_1_0_6_2_3_4_0 - 4.166666666666657e-03*G6_1_0_6_2_3_4_1 - 4.166666666666657e-03*G6_1_0_6_2_3_4_2 + 4.166666666666655e-03*G6_1_0_6_2_3_5_0 + 4.166666666666657e-03*G6_1_0_6_2_3_6_1 + 4.166666666666657e-03*G6_1_0_6_2_3_7_2 - 4.166666666666656e-03*G6_1_0_7_0_0_4_0 - 4.166666666666656e-03*G6_1_0_7_0_0_4_1 - 4.166666666666657e-03*G6_1_0_7_0_0_4_2 + 4.166666666666656e-03*G6_1_0_7_0_0_5_0 + 4.166666666666656e-03*G6_1_0_7_0_0_6_1 + 4.166666666666656e-03*G6_1_0_7_0_0_7_2 - 4.166666666666654e-03*G6_1_0_7_0_1_4_0 - 4.166666666666655e-03*G6_1_0_7_0_1_4_1 - 4.166666666666655e-03*G6_1_0_7_0_1_4_2 + 4.166666666666654e-03*G6_1_0_7_0_1_5_0 + 4.166666666666655e-03*G6_1_0_7_0_1_6_1 + 4.166666666666655e-03*G6_1_0_7_0_1_7_2 - 4.166666666666655e-03*G6_1_0_7_0_2_4_0 - 4.166666666666655e-03*G6_1_0_7_0_2_4_1 - 4.166666666666655e-03*G6_1_0_7_0_2_4_2 + 4.166666666666655e-03*G6_1_0_7_0_2_5_0 + 4.166666666666655e-03*G6_1_0_7_0_2_6_1 + 4.166666666666655e-03*G6_1_0_7_0_2_7_2 - 8.333333333333309e-03*G6_1_0_7_0_3_4_0 - 8.333333333333311e-03*G6_1_0_7_0_3_4_1 - 8.333333333333311e-03*G6_1_0_7_0_3_4_2 + 8.333333333333309e-03*G6_1_0_7_0_3_5_0 + 8.333333333333311e-03*G6_1_0_7_0_3_6_1 + 8.333333333333311e-03*G6_1_0_7_0_3_7_2 - 4.166666666666656e-03*G6_1_0_7_1_0_4_0 - 4.166666666666657e-03*G6_1_0_7_1_0_4_1 - 4.166666666666658e-03*G6_1_0_7_1_0_4_2 + 4.166666666666656e-03*G6_1_0_7_1_0_5_0 + 4.166666666666657e-03*G6_1_0_7_1_0_6_1 + 4.166666666666657e-03*G6_1_0_7_1_0_7_2 - 4.166666666666655e-03*G6_1_0_7_1_1_4_0 - 4.166666666666655e-03*G6_1_0_7_1_1_4_1 - 4.166666666666656e-03*G6_1_0_7_1_1_4_2 + 4.166666666666655e-03*G6_1_0_7_1_1_5_0 + 4.166666666666655e-03*G6_1_0_7_1_1_6_1 + 4.166666666666655e-03*G6_1_0_7_1_1_7_2 - 4.166666666666655e-03*G6_1_0_7_1_2_4_0 - 4.166666666666656e-03*G6_1_0_7_1_2_4_1 - 4.166666666666657e-03*G6_1_0_7_1_2_4_2 + 4.166666666666655e-03*G6_1_0_7_1_2_5_0 + 4.166666666666656e-03*G6_1_0_7_1_2_6_1 + 4.166666666666656e-03*G6_1_0_7_1_2_7_2 - 8.333333333333311e-03*G6_1_0_7_1_3_4_0 - 8.333333333333311e-03*G6_1_0_7_1_3_4_1 - 8.333333333333312e-03*G6_1_0_7_1_3_4_2 + 8.333333333333311e-03*G6_1_0_7_1_3_5_0 + 8.333333333333311e-03*G6_1_0_7_1_3_6_1 + 8.333333333333311e-03*G6_1_0_7_1_3_7_2 - 4.166666666666657e-03*G6_1_0_7_2_0_4_0 - 4.166666666666658e-03*G6_1_0_7_2_0_4_1 - 4.166666666666659e-03*G6_1_0_7_2_0_4_2 + 4.166666666666657e-03*G6_1_0_7_2_0_5_0 + 4.166666666666658e-03*G6_1_0_7_2_0_6_1 + 4.166666666666658e-03*G6_1_0_7_2_0_7_2 - 4.166666666666655e-03*G6_1_0_7_2_1_4_0 - 4.166666666666656e-03*G6_1_0_7_2_1_4_1 - 4.166666666666656e-03*G6_1_0_7_2_1_4_2 + 4.166666666666655e-03*G6_1_0_7_2_1_5_0 + 4.166666666666656e-03*G6_1_0_7_2_1_6_1 + 4.166666666666656e-03*G6_1_0_7_2_1_7_2 - 4.166666666666655e-03*G6_1_0_7_2_2_4_0 - 4.166666666666657e-03*G6_1_0_7_2_2_4_1 - 4.166666666666657e-03*G6_1_0_7_2_2_4_2 + 4.166666666666655e-03*G6_1_0_7_2_2_5_0 + 4.166666666666657e-03*G6_1_0_7_2_2_6_1 + 4.166666666666657e-03*G6_1_0_7_2_2_7_2 - 8.333333333333311e-03*G6_1_0_7_2_3_4_0 - 8.333333333333312e-03*G6_1_0_7_2_3_4_1 - 8.333333333333312e-03*G6_1_0_7_2_3_4_2 + 8.333333333333311e-03*G6_1_0_7_2_3_5_0 + 8.333333333333312e-03*G6_1_0_7_2_3_6_1 + 8.333333333333312e-03*G6_1_0_7_2_3_7_2 - 8.333333333333309e-03*G6_1_1_4_0_4_4_0 - 8.333333333333309e-03*G6_1_1_4_0_4_4_1 - 8.333333333333311e-03*G6_1_1_4_0_4_4_2 + 8.333333333333309e-03*G6_1_1_4_0_4_5_0 + 8.333333333333309e-03*G6_1_1_4_0_4_6_1 + 8.333333333333309e-03*G6_1_1_4_0_4_7_2 - 4.166666666666654e-03*G6_1_1_4_0_5_4_0 - 4.166666666666654e-03*G6_1_1_4_0_5_4_1 - 4.166666666666654e-03*G6_1_1_4_0_5_4_2 + 4.166666666666654e-03*G6_1_1_4_0_5_5_0 + 4.166666666666654e-03*G6_1_1_4_0_5_6_1 + 4.166666666666654e-03*G6_1_1_4_0_5_7_2 - 4.166666666666653e-03*G6_1_1_4_0_6_4_0 - 4.166666666666654e-03*G6_1_1_4_0_6_4_1 - 4.166666666666654e-03*G6_1_1_4_0_6_4_2 + 4.166666666666653e-03*G6_1_1_4_0_6_5_0 + 4.166666666666654e-03*G6_1_1_4_0_6_6_1 + 4.166666666666654e-03*G6_1_1_4_0_6_7_2 - 4.166666666666654e-03*G6_1_1_4_0_7_4_0 - 4.166666666666656e-03*G6_1_1_4_0_7_4_1 - 4.166666666666657e-03*G6_1_1_4_0_7_4_2 + 4.166666666666654e-03*G6_1_1_4_0_7_5_0 + 4.166666666666656e-03*G6_1_1_4_0_7_6_1 + 4.166666666666656e-03*G6_1_1_4_0_7_7_2 - 8.333333333333309e-03*G6_1_1_4_1_4_4_0 - 8.333333333333311e-03*G6_1_1_4_1_4_4_1 - 8.333333333333312e-03*G6_1_1_4_1_4_4_2 + 8.333333333333309e-03*G6_1_1_4_1_4_5_0 + 8.333333333333311e-03*G6_1_1_4_1_4_6_1 + 8.333333333333311e-03*G6_1_1_4_1_4_7_2 - 4.166666666666654e-03*G6_1_1_4_1_5_4_0 - 4.166666666666654e-03*G6_1_1_4_1_5_4_1 - 4.166666666666655e-03*G6_1_1_4_1_5_4_2 + 4.166666666666654e-03*G6_1_1_4_1_5_5_0 + 4.166666666666654e-03*G6_1_1_4_1_5_6_1 + 4.166666666666654e-03*G6_1_1_4_1_5_7_2 - 4.166666666666654e-03*G6_1_1_4_1_6_4_0 - 4.166666666666654e-03*G6_1_1_4_1_6_4_1 - 4.166666666666654e-03*G6_1_1_4_1_6_4_2 + 4.166666666666654e-03*G6_1_1_4_1_6_5_0 + 4.166666666666654e-03*G6_1_1_4_1_6_6_1 + 4.166666666666654e-03*G6_1_1_4_1_6_7_2 - 4.166666666666656e-03*G6_1_1_4_1_7_4_0 - 4.166666666666657e-03*G6_1_1_4_1_7_4_1 - 4.166666666666657e-03*G6_1_1_4_1_7_4_2 + 4.166666666666656e-03*G6_1_1_4_1_7_5_0 + 4.166666666666657e-03*G6_1_1_4_1_7_6_1 + 4.166666666666657e-03*G6_1_1_4_1_7_7_2 - 8.333333333333311e-03*G6_1_1_4_2_4_4_0 - 8.333333333333312e-03*G6_1_1_4_2_4_4_1 - 8.333333333333314e-03*G6_1_1_4_2_4_4_2 + 8.333333333333311e-03*G6_1_1_4_2_4_5_0 + 8.333333333333312e-03*G6_1_1_4_2_4_6_1 + 8.333333333333312e-03*G6_1_1_4_2_4_7_2 - 4.166666666666654e-03*G6_1_1_4_2_5_4_0 - 4.166666666666655e-03*G6_1_1_4_2_5_4_1 - 4.166666666666655e-03*G6_1_1_4_2_5_4_2 + 4.166666666666654e-03*G6_1_1_4_2_5_5_0 + 4.166666666666655e-03*G6_1_1_4_2_5_6_1 + 4.166666666666655e-03*G6_1_1_4_2_5_7_2 - 4.166666666666654e-03*G6_1_1_4_2_6_4_0 - 4.166666666666654e-03*G6_1_1_4_2_6_4_1 - 4.166666666666654e-03*G6_1_1_4_2_6_4_2 + 4.166666666666654e-03*G6_1_1_4_2_6_5_0 + 4.166666666666654e-03*G6_1_1_4_2_6_6_1 + 4.166666666666654e-03*G6_1_1_4_2_6_7_2 - 4.166666666666657e-03*G6_1_1_4_2_7_4_0 - 4.166666666666657e-03*G6_1_1_4_2_7_4_1 - 4.166666666666658e-03*G6_1_1_4_2_7_4_2 + 4.166666666666657e-03*G6_1_1_4_2_7_5_0 + 4.166666666666657e-03*G6_1_1_4_2_7_6_1 + 4.166666666666657e-03*G6_1_1_4_2_7_7_2 - 4.166666666666654e-03*G6_1_1_5_0_4_4_0 - 4.166666666666654e-03*G6_1_1_5_0_4_4_1 - 4.166666666666654e-03*G6_1_1_5_0_4_4_2 + 4.166666666666654e-03*G6_1_1_5_0_4_5_0 + 4.166666666666654e-03*G6_1_1_5_0_4_6_1 + 4.166666666666654e-03*G6_1_1_5_0_4_7_2 - 8.333333333333307e-03*G6_1_1_5_0_5_4_0 - 8.333333333333309e-03*G6_1_1_5_0_5_4_1 - 8.333333333333309e-03*G6_1_1_5_0_5_4_2 + 8.333333333333307e-03*G6_1_1_5_0_5_5_0 + 8.333333333333309e-03*G6_1_1_5_0_5_6_1 + 8.333333333333309e-03*G6_1_1_5_0_5_7_2 - 4.166666666666654e-03*G6_1_1_5_0_6_4_0 - 4.166666666666655e-03*G6_1_1_5_0_6_4_1 - 4.166666666666655e-03*G6_1_1_5_0_6_4_2 + 4.166666666666654e-03*G6_1_1_5_0_6_5_0 + 4.166666666666655e-03*G6_1_1_5_0_6_6_1 + 4.166666666666655e-03*G6_1_1_5_0_6_7_2 - 4.166666666666655e-03*G6_1_1_5_0_7_4_0 - 4.166666666666656e-03*G6_1_1_5_0_7_4_1 - 4.166666666666656e-03*G6_1_1_5_0_7_4_2 + 4.166666666666655e-03*G6_1_1_5_0_7_5_0 + 4.166666666666656e-03*G6_1_1_5_0_7_6_1 + 4.166666666666656e-03*G6_1_1_5_0_7_7_2 - 4.166666666666654e-03*G6_1_1_5_1_4_4_0 - 4.166666666666654e-03*G6_1_1_5_1_4_4_1 - 4.166666666666655e-03*G6_1_1_5_1_4_4_2 + 4.166666666666654e-03*G6_1_1_5_1_4_5_0 + 4.166666666666654e-03*G6_1_1_5_1_4_6_1 + 4.166666666666654e-03*G6_1_1_5_1_4_7_2 - 8.333333333333309e-03*G6_1_1_5_1_5_4_0 - 8.333333333333309e-03*G6_1_1_5_1_5_4_1 - 8.333333333333309e-03*G6_1_1_5_1_5_4_2 + 8.333333333333309e-03*G6_1_1_5_1_5_5_0 + 8.333333333333309e-03*G6_1_1_5_1_5_6_1 + 8.333333333333309e-03*G6_1_1_5_1_5_7_2 - 4.166666666666655e-03*G6_1_1_5_1_6_4_0 - 4.166666666666656e-03*G6_1_1_5_1_6_4_1 - 4.166666666666656e-03*G6_1_1_5_1_6_4_2 + 4.166666666666655e-03*G6_1_1_5_1_6_5_0 + 4.166666666666656e-03*G6_1_1_5_1_6_6_1 + 4.166666666666656e-03*G6_1_1_5_1_6_7_2 - 4.166666666666656e-03*G6_1_1_5_1_7_4_0 - 4.166666666666657e-03*G6_1_1_5_1_7_4_1 - 4.166666666666657e-03*G6_1_1_5_1_7_4_2 + 4.166666666666656e-03*G6_1_1_5_1_7_5_0 + 4.166666666666657e-03*G6_1_1_5_1_7_6_1 + 4.166666666666657e-03*G6_1_1_5_1_7_7_2 - 4.166666666666654e-03*G6_1_1_5_2_4_4_0 - 4.166666666666655e-03*G6_1_1_5_2_4_4_1 - 4.166666666666655e-03*G6_1_1_5_2_4_4_2 + 4.166666666666654e-03*G6_1_1_5_2_4_5_0 + 4.166666666666655e-03*G6_1_1_5_2_4_6_1 + 4.166666666666655e-03*G6_1_1_5_2_4_7_2 - 8.333333333333309e-03*G6_1_1_5_2_5_4_0 - 8.333333333333309e-03*G6_1_1_5_2_5_4_1 - 8.333333333333309e-03*G6_1_1_5_2_5_4_2 + 8.333333333333309e-03*G6_1_1_5_2_5_5_0 + 8.333333333333309e-03*G6_1_1_5_2_5_6_1 + 8.333333333333309e-03*G6_1_1_5_2_5_7_2 - 4.166666666666655e-03*G6_1_1_5_2_6_4_0 - 4.166666666666656e-03*G6_1_1_5_2_6_4_1 - 4.166666666666656e-03*G6_1_1_5_2_6_4_2 + 4.166666666666655e-03*G6_1_1_5_2_6_5_0 + 4.166666666666656e-03*G6_1_1_5_2_6_6_1 + 4.166666666666656e-03*G6_1_1_5_2_6_7_2 - 4.166666666666656e-03*G6_1_1_5_2_7_4_0 - 4.166666666666657e-03*G6_1_1_5_2_7_4_1 - 4.166666666666657e-03*G6_1_1_5_2_7_4_2 + 4.166666666666656e-03*G6_1_1_5_2_7_5_0 + 4.166666666666657e-03*G6_1_1_5_2_7_6_1 + 4.166666666666657e-03*G6_1_1_5_2_7_7_2 - 4.166666666666653e-03*G6_1_1_6_0_4_4_0 - 4.166666666666654e-03*G6_1_1_6_0_4_4_1 - 4.166666666666654e-03*G6_1_1_6_0_4_4_2 + 4.166666666666653e-03*G6_1_1_6_0_4_5_0 + 4.166666666666654e-03*G6_1_1_6_0_4_6_1 + 4.166666666666654e-03*G6_1_1_6_0_4_7_2 - 4.166666666666654e-03*G6_1_1_6_0_5_4_0 - 4.166666666666655e-03*G6_1_1_6_0_5_4_1 - 4.166666666666655e-03*G6_1_1_6_0_5_4_2 + 4.166666666666654e-03*G6_1_1_6_0_5_5_0 + 4.166666666666655e-03*G6_1_1_6_0_5_6_1 + 4.166666666666655e-03*G6_1_1_6_0_5_7_2 - 8.333333333333309e-03*G6_1_1_6_0_6_4_0 - 8.333333333333309e-03*G6_1_1_6_0_6_4_1 - 8.333333333333311e-03*G6_1_1_6_0_6_4_2 + 8.333333333333309e-03*G6_1_1_6_0_6_5_0 + 8.333333333333309e-03*G6_1_1_6_0_6_6_1 + 8.333333333333309e-03*G6_1_1_6_0_6_7_2 - 4.166666666666654e-03*G6_1_1_6_0_7_4_0 - 4.166666666666655e-03*G6_1_1_6_0_7_4_1 - 4.166666666666655e-03*G6_1_1_6_0_7_4_2 + 4.166666666666654e-03*G6_1_1_6_0_7_5_0 + 4.166666666666655e-03*G6_1_1_6_0_7_6_1 + 4.166666666666655e-03*G6_1_1_6_0_7_7_2 - 4.166666666666654e-03*G6_1_1_6_1_4_4_0 - 4.166666666666654e-03*G6_1_1_6_1_4_4_1 - 4.166666666666654e-03*G6_1_1_6_1_4_4_2 + 4.166666666666654e-03*G6_1_1_6_1_4_5_0 + 4.166666666666654e-03*G6_1_1_6_1_4_6_1 + 4.166666666666654e-03*G6_1_1_6_1_4_7_2 - 4.166666666666655e-03*G6_1_1_6_1_5_4_0 - 4.166666666666656e-03*G6_1_1_6_1_5_4_1 - 4.166666666666656e-03*G6_1_1_6_1_5_4_2 + 4.166666666666655e-03*G6_1_1_6_1_5_5_0 + 4.166666666666656e-03*G6_1_1_6_1_5_6_1 + 4.166666666666656e-03*G6_1_1_6_1_5_7_2 - 8.333333333333311e-03*G6_1_1_6_1_6_4_0 - 8.333333333333311e-03*G6_1_1_6_1_6_4_1 - 8.333333333333312e-03*G6_1_1_6_1_6_4_2 + 8.333333333333311e-03*G6_1_1_6_1_6_5_0 + 8.333333333333311e-03*G6_1_1_6_1_6_6_1 + 8.333333333333311e-03*G6_1_1_6_1_6_7_2 - 4.166666666666655e-03*G6_1_1_6_1_7_4_0 - 4.166666666666656e-03*G6_1_1_6_1_7_4_1 - 4.166666666666657e-03*G6_1_1_6_1_7_4_2 + 4.166666666666655e-03*G6_1_1_6_1_7_5_0 + 4.166666666666656e-03*G6_1_1_6_1_7_6_1 + 4.166666666666656e-03*G6_1_1_6_1_7_7_2 - 4.166666666666654e-03*G6_1_1_6_2_4_4_0 - 4.166666666666654e-03*G6_1_1_6_2_4_4_1 - 4.166666666666654e-03*G6_1_1_6_2_4_4_2 + 4.166666666666654e-03*G6_1_1_6_2_4_5_0 + 4.166666666666654e-03*G6_1_1_6_2_4_6_1 + 4.166666666666654e-03*G6_1_1_6_2_4_7_2 - 4.166666666666655e-03*G6_1_1_6_2_5_4_0 - 4.166666666666656e-03*G6_1_1_6_2_5_4_1 - 4.166666666666656e-03*G6_1_1_6_2_5_4_2 + 4.166666666666655e-03*G6_1_1_6_2_5_5_0 + 4.166666666666656e-03*G6_1_1_6_2_5_6_1 + 4.166666666666656e-03*G6_1_1_6_2_5_7_2 - 8.333333333333311e-03*G6_1_1_6_2_6_4_0 - 8.333333333333312e-03*G6_1_1_6_2_6_4_1 - 8.333333333333312e-03*G6_1_1_6_2_6_4_2 + 8.333333333333311e-03*G6_1_1_6_2_6_5_0 + 8.333333333333312e-03*G6_1_1_6_2_6_6_1 + 8.333333333333312e-03*G6_1_1_6_2_6_7_2 - 4.166666666666655e-03*G6_1_1_6_2_7_4_0 - 4.166666666666657e-03*G6_1_1_6_2_7_4_1 - 4.166666666666657e-03*G6_1_1_6_2_7_4_2 + 4.166666666666655e-03*G6_1_1_6_2_7_5_0 + 4.166666666666657e-03*G6_1_1_6_2_7_6_1 + 4.166666666666657e-03*G6_1_1_6_2_7_7_2 - 4.166666666666655e-03*G6_1_1_7_0_4_4_0 - 4.166666666666656e-03*G6_1_1_7_0_4_4_1 - 4.166666666666657e-03*G6_1_1_7_0_4_4_2 + 4.166666666666655e-03*G6_1_1_7_0_4_5_0 + 4.166666666666656e-03*G6_1_1_7_0_4_6_1 + 4.166666666666656e-03*G6_1_1_7_0_4_7_2 - 4.166666666666655e-03*G6_1_1_7_0_5_4_0 - 4.166666666666656e-03*G6_1_1_7_0_5_4_1 - 4.166666666666656e-03*G6_1_1_7_0_5_4_2 + 4.166666666666655e-03*G6_1_1_7_0_5_5_0 + 4.166666666666656e-03*G6_1_1_7_0_5_6_1 + 4.166666666666656e-03*G6_1_1_7_0_5_7_2 - 4.166666666666655e-03*G6_1_1_7_0_6_4_0 - 4.166666666666655e-03*G6_1_1_7_0_6_4_1 - 4.166666666666655e-03*G6_1_1_7_0_6_4_2 + 4.166666666666655e-03*G6_1_1_7_0_6_5_0 + 4.166666666666655e-03*G6_1_1_7_0_6_6_1 + 4.166666666666655e-03*G6_1_1_7_0_6_7_2 - 8.333333333333309e-03*G6_1_1_7_0_7_4_0 - 8.333333333333311e-03*G6_1_1_7_0_7_4_1 - 8.333333333333311e-03*G6_1_1_7_0_7_4_2 + 8.333333333333309e-03*G6_1_1_7_0_7_5_0 + 8.333333333333311e-03*G6_1_1_7_0_7_6_1 + 8.333333333333311e-03*G6_1_1_7_0_7_7_2 - 4.166666666666656e-03*G6_1_1_7_1_4_4_0 - 4.166666666666657e-03*G6_1_1_7_1_4_4_1 - 4.166666666666657e-03*G6_1_1_7_1_4_4_2 + 4.166666666666656e-03*G6_1_1_7_1_4_5_0 + 4.166666666666657e-03*G6_1_1_7_1_4_6_1 + 4.166666666666657e-03*G6_1_1_7_1_4_7_2 - 4.166666666666656e-03*G6_1_1_7_1_5_4_0 - 4.166666666666657e-03*G6_1_1_7_1_5_4_1 - 4.166666666666657e-03*G6_1_1_7_1_5_4_2 + 4.166666666666656e-03*G6_1_1_7_1_5_5_0 + 4.166666666666657e-03*G6_1_1_7_1_5_6_1 + 4.166666666666657e-03*G6_1_1_7_1_5_7_2 - 4.166666666666655e-03*G6_1_1_7_1_6_4_0 - 4.166666666666656e-03*G6_1_1_7_1_6_4_1 - 4.166666666666657e-03*G6_1_1_7_1_6_4_2 + 4.166666666666655e-03*G6_1_1_7_1_6_5_0 + 4.166666666666656e-03*G6_1_1_7_1_6_6_1 + 4.166666666666656e-03*G6_1_1_7_1_6_7_2 - 8.333333333333311e-03*G6_1_1_7_1_7_4_0 - 8.333333333333311e-03*G6_1_1_7_1_7_4_1 - 8.333333333333312e-03*G6_1_1_7_1_7_4_2 + 8.333333333333311e-03*G6_1_1_7_1_7_5_0 + 8.333333333333311e-03*G6_1_1_7_1_7_6_1 + 8.333333333333311e-03*G6_1_1_7_1_7_7_2 - 4.166666666666657e-03*G6_1_1_7_2_4_4_0 - 4.166666666666657e-03*G6_1_1_7_2_4_4_1 - 4.166666666666658e-03*G6_1_1_7_2_4_4_2 + 4.166666666666657e-03*G6_1_1_7_2_4_5_0 + 4.166666666666657e-03*G6_1_1_7_2_4_6_1 + 4.166666666666657e-03*G6_1_1_7_2_4_7_2 - 4.166666666666656e-03*G6_1_1_7_2_5_4_0 - 4.166666666666657e-03*G6_1_1_7_2_5_4_1 - 4.166666666666657e-03*G6_1_1_7_2_5_4_2 + 4.166666666666656e-03*G6_1_1_7_2_5_5_0 + 4.166666666666657e-03*G6_1_1_7_2_5_6_1 + 4.166666666666657e-03*G6_1_1_7_2_5_7_2 - 4.166666666666655e-03*G6_1_1_7_2_6_4_0 - 4.166666666666657e-03*G6_1_1_7_2_6_4_1 - 4.166666666666657e-03*G6_1_1_7_2_6_4_2 + 4.166666666666655e-03*G6_1_1_7_2_6_5_0 + 4.166666666666657e-03*G6_1_1_7_2_6_6_1 + 4.166666666666657e-03*G6_1_1_7_2_6_7_2 - 8.333333333333311e-03*G6_1_1_7_2_7_4_0 - 8.333333333333312e-03*G6_1_1_7_2_7_4_1 - 8.333333333333312e-03*G6_1_1_7_2_7_4_2 + 8.333333333333311e-03*G6_1_1_7_2_7_5_0 + 8.333333333333312e-03*G6_1_1_7_2_7_6_1 + 8.333333333333312e-03*G6_1_1_7_2_7_7_2 - 8.333333333333309e-03*G6_1_2_4_0_8_4_0 - 8.333333333333309e-03*G6_1_2_4_0_8_4_1 - 8.333333333333311e-03*G6_1_2_4_0_8_4_2 + 8.333333333333309e-03*G6_1_2_4_0_8_5_0 + 8.333333333333309e-03*G6_1_2_4_0_8_6_1 + 8.333333333333309e-03*G6_1_2_4_0_8_7_2 - 4.166666666666654e-03*G6_1_2_4_0_9_4_0 - 4.166666666666654e-03*G6_1_2_4_0_9_4_1 - 4.166666666666654e-03*G6_1_2_4_0_9_4_2 + 4.166666666666654e-03*G6_1_2_4_0_9_5_0 + 4.166666666666654e-03*G6_1_2_4_0_9_6_1 + 4.166666666666654e-03*G6_1_2_4_0_9_7_2 - 4.166666666666653e-03*G6_1_2_4_0_10_4_0 - 4.166666666666654e-03*G6_1_2_4_0_10_4_1 - 4.166666666666654e-03*G6_1_2_4_0_10_4_2 + 4.166666666666653e-03*G6_1_2_4_0_10_5_0 + 4.166666666666654e-03*G6_1_2_4_0_10_6_1 + 4.166666666666654e-03*G6_1_2_4_0_10_7_2 - 4.166666666666654e-03*G6_1_2_4_0_11_4_0 - 4.166666666666656e-03*G6_1_2_4_0_11_4_1 - 4.166666666666657e-03*G6_1_2_4_0_11_4_2 + 4.166666666666654e-03*G6_1_2_4_0_11_5_0 + 4.166666666666656e-03*G6_1_2_4_0_11_6_1 + 4.166666666666656e-03*G6_1_2_4_0_11_7_2 - 8.333333333333309e-03*G6_1_2_4_1_8_4_0 - 8.333333333333311e-03*G6_1_2_4_1_8_4_1 - 8.333333333333312e-03*G6_1_2_4_1_8_4_2 + 8.333333333333309e-03*G6_1_2_4_1_8_5_0 + 8.333333333333311e-03*G6_1_2_4_1_8_6_1 + 8.333333333333311e-03*G6_1_2_4_1_8_7_2 - 4.166666666666654e-03*G6_1_2_4_1_9_4_0 - 4.166666666666654e-03*G6_1_2_4_1_9_4_1 - 4.166666666666655e-03*G6_1_2_4_1_9_4_2 + 4.166666666666654e-03*G6_1_2_4_1_9_5_0 + 4.166666666666654e-03*G6_1_2_4_1_9_6_1 + 4.166666666666654e-03*G6_1_2_4_1_9_7_2 - 4.166666666666654e-03*G6_1_2_4_1_10_4_0 - 4.166666666666654e-03*G6_1_2_4_1_10_4_1 - 4.166666666666654e-03*G6_1_2_4_1_10_4_2 + 4.166666666666654e-03*G6_1_2_4_1_10_5_0 + 4.166666666666654e-03*G6_1_2_4_1_10_6_1 + 4.166666666666654e-03*G6_1_2_4_1_10_7_2 - 4.166666666666656e-03*G6_1_2_4_1_11_4_0 - 4.166666666666657e-03*G6_1_2_4_1_11_4_1 - 4.166666666666657e-03*G6_1_2_4_1_11_4_2 + 4.166666666666656e-03*G6_1_2_4_1_11_5_0 + 4.166666666666657e-03*G6_1_2_4_1_11_6_1 + 4.166666666666657e-03*G6_1_2_4_1_11_7_2 - 8.333333333333311e-03*G6_1_2_4_2_8_4_0 - 8.333333333333312e-03*G6_1_2_4_2_8_4_1 - 8.333333333333314e-03*G6_1_2_4_2_8_4_2 + 8.333333333333311e-03*G6_1_2_4_2_8_5_0 + 8.333333333333312e-03*G6_1_2_4_2_8_6_1 + 8.333333333333312e-03*G6_1_2_4_2_8_7_2 - 4.166666666666654e-03*G6_1_2_4_2_9_4_0 - 4.166666666666655e-03*G6_1_2_4_2_9_4_1 - 4.166666666666655e-03*G6_1_2_4_2_9_4_2 + 4.166666666666654e-03*G6_1_2_4_2_9_5_0 + 4.166666666666655e-03*G6_1_2_4_2_9_6_1 + 4.166666666666655e-03*G6_1_2_4_2_9_7_2 - 4.166666666666654e-03*G6_1_2_4_2_10_4_0 - 4.166666666666654e-03*G6_1_2_4_2_10_4_1 - 4.166666666666654e-03*G6_1_2_4_2_10_4_2 + 4.166666666666654e-03*G6_1_2_4_2_10_5_0 + 4.166666666666654e-03*G6_1_2_4_2_10_6_1 + 4.166666666666654e-03*G6_1_2_4_2_10_7_2 - 4.166666666666657e-03*G6_1_2_4_2_11_4_0 - 4.166666666666657e-03*G6_1_2_4_2_11_4_1 - 4.166666666666658e-03*G6_1_2_4_2_11_4_2 + 4.166666666666657e-03*G6_1_2_4_2_11_5_0 + 4.166666666666657e-03*G6_1_2_4_2_11_6_1 + 4.166666666666657e-03*G6_1_2_4_2_11_7_2 - 4.166666666666654e-03*G6_1_2_5_0_8_4_0 - 4.166666666666654e-03*G6_1_2_5_0_8_4_1 - 4.166666666666654e-03*G6_1_2_5_0_8_4_2 + 4.166666666666654e-03*G6_1_2_5_0_8_5_0 + 4.166666666666654e-03*G6_1_2_5_0_8_6_1 + 4.166666666666654e-03*G6_1_2_5_0_8_7_2 - 8.333333333333307e-03*G6_1_2_5_0_9_4_0 - 8.333333333333309e-03*G6_1_2_5_0_9_4_1 - 8.333333333333309e-03*G6_1_2_5_0_9_4_2 + 8.333333333333307e-03*G6_1_2_5_0_9_5_0 + 8.333333333333309e-03*G6_1_2_5_0_9_6_1 + 8.333333333333309e-03*G6_1_2_5_0_9_7_2 - 4.166666666666654e-03*G6_1_2_5_0_10_4_0 - 4.166666666666655e-03*G6_1_2_5_0_10_4_1 - 4.166666666666655e-03*G6_1_2_5_0_10_4_2 + 4.166666666666654e-03*G6_1_2_5_0_10_5_0 + 4.166666666666655e-03*G6_1_2_5_0_10_6_1 + 4.166666666666655e-03*G6_1_2_5_0_10_7_2 - 4.166666666666655e-03*G6_1_2_5_0_11_4_0 - 4.166666666666656e-03*G6_1_2_5_0_11_4_1 - 4.166666666666656e-03*G6_1_2_5_0_11_4_2 + 4.166666666666655e-03*G6_1_2_5_0_11_5_0 + 4.166666666666656e-03*G6_1_2_5_0_11_6_1 + 4.166666666666656e-03*G6_1_2_5_0_11_7_2 - 4.166666666666654e-03*G6_1_2_5_1_8_4_0 - 4.166666666666654e-03*G6_1_2_5_1_8_4_1 - 4.166666666666655e-03*G6_1_2_5_1_8_4_2 + 4.166666666666654e-03*G6_1_2_5_1_8_5_0 + 4.166666666666654e-03*G6_1_2_5_1_8_6_1 + 4.166666666666654e-03*G6_1_2_5_1_8_7_2 - 8.333333333333309e-03*G6_1_2_5_1_9_4_0 - 8.333333333333309e-03*G6_1_2_5_1_9_4_1 - 8.333333333333309e-03*G6_1_2_5_1_9_4_2 + 8.333333333333309e-03*G6_1_2_5_1_9_5_0 + 8.333333333333309e-03*G6_1_2_5_1_9_6_1 + 8.333333333333309e-03*G6_1_2_5_1_9_7_2 - 4.166666666666655e-03*G6_1_2_5_1_10_4_0 - 4.166666666666656e-03*G6_1_2_5_1_10_4_1 - 4.166666666666656e-03*G6_1_2_5_1_10_4_2 + 4.166666666666655e-03*G6_1_2_5_1_10_5_0 + 4.166666666666656e-03*G6_1_2_5_1_10_6_1 + 4.166666666666656e-03*G6_1_2_5_1_10_7_2 - 4.166666666666656e-03*G6_1_2_5_1_11_4_0 - 4.166666666666657e-03*G6_1_2_5_1_11_4_1 - 4.166666666666657e-03*G6_1_2_5_1_11_4_2 + 4.166666666666656e-03*G6_1_2_5_1_11_5_0 + 4.166666666666657e-03*G6_1_2_5_1_11_6_1 + 4.166666666666657e-03*G6_1_2_5_1_11_7_2 - 4.166666666666654e-03*G6_1_2_5_2_8_4_0 - 4.166666666666655e-03*G6_1_2_5_2_8_4_1 - 4.166666666666655e-03*G6_1_2_5_2_8_4_2 + 4.166666666666654e-03*G6_1_2_5_2_8_5_0 + 4.166666666666655e-03*G6_1_2_5_2_8_6_1 + 4.166666666666655e-03*G6_1_2_5_2_8_7_2 - 8.333333333333309e-03*G6_1_2_5_2_9_4_0 - 8.333333333333309e-03*G6_1_2_5_2_9_4_1 - 8.333333333333309e-03*G6_1_2_5_2_9_4_2 + 8.333333333333309e-03*G6_1_2_5_2_9_5_0 + 8.333333333333309e-03*G6_1_2_5_2_9_6_1 + 8.333333333333309e-03*G6_1_2_5_2_9_7_2 - 4.166666666666655e-03*G6_1_2_5_2_10_4_0 - 4.166666666666656e-03*G6_1_2_5_2_10_4_1 - 4.166666666666656e-03*G6_1_2_5_2_10_4_2 + 4.166666666666655e-03*G6_1_2_5_2_10_5_0 + 4.166666666666656e-03*G6_1_2_5_2_10_6_1 + 4.166666666666656e-03*G6_1_2_5_2_10_7_2 - 4.166666666666656e-03*G6_1_2_5_2_11_4_0 - 4.166666666666657e-03*G6_1_2_5_2_11_4_1 - 4.166666666666657e-03*G6_1_2_5_2_11_4_2 + 4.166666666666656e-03*G6_1_2_5_2_11_5_0 + 4.166666666666657e-03*G6_1_2_5_2_11_6_1 + 4.166666666666657e-03*G6_1_2_5_2_11_7_2 - 4.166666666666653e-03*G6_1_2_6_0_8_4_0 - 4.166666666666654e-03*G6_1_2_6_0_8_4_1 - 4.166666666666654e-03*G6_1_2_6_0_8_4_2 + 4.166666666666653e-03*G6_1_2_6_0_8_5_0 + 4.166666666666654e-03*G6_1_2_6_0_8_6_1 + 4.166666666666654e-03*G6_1_2_6_0_8_7_2 - 4.166666666666654e-03*G6_1_2_6_0_9_4_0 - 4.166666666666655e-03*G6_1_2_6_0_9_4_1 - 4.166666666666655e-03*G6_1_2_6_0_9_4_2 + 4.166666666666654e-03*G6_1_2_6_0_9_5_0 + 4.166666666666655e-03*G6_1_2_6_0_9_6_1 + 4.166666666666655e-03*G6_1_2_6_0_9_7_2 - 8.333333333333309e-03*G6_1_2_6_0_10_4_0 - 8.333333333333309e-03*G6_1_2_6_0_10_4_1 - 8.333333333333311e-03*G6_1_2_6_0_10_4_2 + 8.333333333333309e-03*G6_1_2_6_0_10_5_0 + 8.333333333333309e-03*G6_1_2_6_0_10_6_1 + 8.333333333333309e-03*G6_1_2_6_0_10_7_2 - 4.166666666666654e-03*G6_1_2_6_0_11_4_0 - 4.166666666666655e-03*G6_1_2_6_0_11_4_1 - 4.166666666666655e-03*G6_1_2_6_0_11_4_2 + 4.166666666666654e-03*G6_1_2_6_0_11_5_0 + 4.166666666666655e-03*G6_1_2_6_0_11_6_1 + 4.166666666666655e-03*G6_1_2_6_0_11_7_2 - 4.166666666666654e-03*G6_1_2_6_1_8_4_0 - 4.166666666666654e-03*G6_1_2_6_1_8_4_1 - 4.166666666666654e-03*G6_1_2_6_1_8_4_2 + 4.166666666666654e-03*G6_1_2_6_1_8_5_0 + 4.166666666666654e-03*G6_1_2_6_1_8_6_1 + 4.166666666666654e-03*G6_1_2_6_1_8_7_2 - 4.166666666666655e-03*G6_1_2_6_1_9_4_0 - 4.166666666666656e-03*G6_1_2_6_1_9_4_1 - 4.166666666666656e-03*G6_1_2_6_1_9_4_2 + 4.166666666666655e-03*G6_1_2_6_1_9_5_0 + 4.166666666666656e-03*G6_1_2_6_1_9_6_1 + 4.166666666666656e-03*G6_1_2_6_1_9_7_2 - 8.333333333333311e-03*G6_1_2_6_1_10_4_0 - 8.333333333333311e-03*G6_1_2_6_1_10_4_1 - 8.333333333333312e-03*G6_1_2_6_1_10_4_2 + 8.333333333333311e-03*G6_1_2_6_1_10_5_0 + 8.333333333333311e-03*G6_1_2_6_1_10_6_1 + 8.333333333333311e-03*G6_1_2_6_1_10_7_2 - 4.166666666666655e-03*G6_1_2_6_1_11_4_0 - 4.166666666666656e-03*G6_1_2_6_1_11_4_1 - 4.166666666666657e-03*G6_1_2_6_1_11_4_2 + 4.166666666666655e-03*G6_1_2_6_1_11_5_0 + 4.166666666666656e-03*G6_1_2_6_1_11_6_1 + 4.166666666666656e-03*G6_1_2_6_1_11_7_2 - 4.166666666666654e-03*G6_1_2_6_2_8_4_0 - 4.166666666666654e-03*G6_1_2_6_2_8_4_1 - 4.166666666666654e-03*G6_1_2_6_2_8_4_2 + 4.166666666666654e-03*G6_1_2_6_2_8_5_0 + 4.166666666666654e-03*G6_1_2_6_2_8_6_1 + 4.166666666666654e-03*G6_1_2_6_2_8_7_2 - 4.166666666666655e-03*G6_1_2_6_2_9_4_0 - 4.166666666666656e-03*G6_1_2_6_2_9_4_1 - 4.166666666666656e-03*G6_1_2_6_2_9_4_2 + 4.166666666666655e-03*G6_1_2_6_2_9_5_0 + 4.166666666666656e-03*G6_1_2_6_2_9_6_1 + 4.166666666666656e-03*G6_1_2_6_2_9_7_2 - 8.333333333333311e-03*G6_1_2_6_2_10_4_0 - 8.333333333333312e-03*G6_1_2_6_2_10_4_1 - 8.333333333333312e-03*G6_1_2_6_2_10_4_2 + 8.333333333333311e-03*G6_1_2_6_2_10_5_0 + 8.333333333333312e-03*G6_1_2_6_2_10_6_1 + 8.333333333333312e-03*G6_1_2_6_2_10_7_2 - 4.166666666666655e-03*G6_1_2_6_2_11_4_0 - 4.166666666666657e-03*G6_1_2_6_2_11_4_1 - 4.166666666666657e-03*G6_1_2_6_2_11_4_2 + 4.166666666666655e-03*G6_1_2_6_2_11_5_0 + 4.166666666666657e-03*G6_1_2_6_2_11_6_1 + 4.166666666666657e-03*G6_1_2_6_2_11_7_2 - 4.166666666666655e-03*G6_1_2_7_0_8_4_0 - 4.166666666666656e-03*G6_1_2_7_0_8_4_1 - 4.166666666666657e-03*G6_1_2_7_0_8_4_2 + 4.166666666666655e-03*G6_1_2_7_0_8_5_0 + 4.166666666666656e-03*G6_1_2_7_0_8_6_1 + 4.166666666666656e-03*G6_1_2_7_0_8_7_2 - 4.166666666666655e-03*G6_1_2_7_0_9_4_0 - 4.166666666666656e-03*G6_1_2_7_0_9_4_1 - 4.166666666666656e-03*G6_1_2_7_0_9_4_2 + 4.166666666666655e-03*G6_1_2_7_0_9_5_0 + 4.166666666666656e-03*G6_1_2_7_0_9_6_1 + 4.166666666666656e-03*G6_1_2_7_0_9_7_2 - 4.166666666666655e-03*G6_1_2_7_0_10_4_0 - 4.166666666666655e-03*G6_1_2_7_0_10_4_1 - 4.166666666666655e-03*G6_1_2_7_0_10_4_2 + 4.166666666666655e-03*G6_1_2_7_0_10_5_0 + 4.166666666666655e-03*G6_1_2_7_0_10_6_1 + 4.166666666666655e-03*G6_1_2_7_0_10_7_2 - 8.333333333333309e-03*G6_1_2_7_0_11_4_0 - 8.333333333333311e-03*G6_1_2_7_0_11_4_1 - 8.333333333333311e-03*G6_1_2_7_0_11_4_2 + 8.333333333333309e-03*G6_1_2_7_0_11_5_0 + 8.333333333333311e-03*G6_1_2_7_0_11_6_1 + 8.333333333333311e-03*G6_1_2_7_0_11_7_2 - 4.166666666666656e-03*G6_1_2_7_1_8_4_0 - 4.166666666666657e-03*G6_1_2_7_1_8_4_1 - 4.166666666666657e-03*G6_1_2_7_1_8_4_2 + 4.166666666666656e-03*G6_1_2_7_1_8_5_0 + 4.166666666666657e-03*G6_1_2_7_1_8_6_1 + 4.166666666666657e-03*G6_1_2_7_1_8_7_2 - 4.166666666666656e-03*G6_1_2_7_1_9_4_0 - 4.166666666666657e-03*G6_1_2_7_1_9_4_1 - 4.166666666666657e-03*G6_1_2_7_1_9_4_2 + 4.166666666666656e-03*G6_1_2_7_1_9_5_0 + 4.166666666666657e-03*G6_1_2_7_1_9_6_1 + 4.166666666666657e-03*G6_1_2_7_1_9_7_2 - 4.166666666666655e-03*G6_1_2_7_1_10_4_0 - 4.166666666666656e-03*G6_1_2_7_1_10_4_1 - 4.166666666666657e-03*G6_1_2_7_1_10_4_2 + 4.166666666666655e-03*G6_1_2_7_1_10_5_0 + 4.166666666666656e-03*G6_1_2_7_1_10_6_1 + 4.166666666666656e-03*G6_1_2_7_1_10_7_2 - 8.333333333333311e-03*G6_1_2_7_1_11_4_0 - 8.333333333333311e-03*G6_1_2_7_1_11_4_1 - 8.333333333333312e-03*G6_1_2_7_1_11_4_2 + 8.333333333333311e-03*G6_1_2_7_1_11_5_0 + 8.333333333333311e-03*G6_1_2_7_1_11_6_1 + 8.333333333333311e-03*G6_1_2_7_1_11_7_2 - 4.166666666666657e-03*G6_1_2_7_2_8_4_0 - 4.166666666666657e-03*G6_1_2_7_2_8_4_1 - 4.166666666666658e-03*G6_1_2_7_2_8_4_2 + 4.166666666666657e-03*G6_1_2_7_2_8_5_0 + 4.166666666666657e-03*G6_1_2_7_2_8_6_1 + 4.166666666666657e-03*G6_1_2_7_2_8_7_2 - 4.166666666666656e-03*G6_1_2_7_2_9_4_0 - 4.166666666666657e-03*G6_1_2_7_2_9_4_1 - 4.166666666666657e-03*G6_1_2_7_2_9_4_2 + 4.166666666666656e-03*G6_1_2_7_2_9_5_0 + 4.166666666666657e-03*G6_1_2_7_2_9_6_1 + 4.166666666666657e-03*G6_1_2_7_2_9_7_2 - 4.166666666666655e-03*G6_1_2_7_2_10_4_0 - 4.166666666666657e-03*G6_1_2_7_2_10_4_1 - 4.166666666666657e-03*G6_1_2_7_2_10_4_2 + 4.166666666666655e-03*G6_1_2_7_2_10_5_0 + 4.166666666666657e-03*G6_1_2_7_2_10_6_1 + 4.166666666666657e-03*G6_1_2_7_2_10_7_2 - 8.333333333333311e-03*G6_1_2_7_2_11_4_0 - 8.333333333333312e-03*G6_1_2_7_2_11_4_1 - 8.333333333333312e-03*G6_1_2_7_2_11_4_2 + 8.333333333333311e-03*G6_1_2_7_2_11_5_0 + 8.333333333333312e-03*G6_1_2_7_2_11_6_1 + 8.333333333333312e-03*G6_1_2_7_2_11_7_2 - 8.333333333333309e-03*G6_2_0_8_0_0_4_0 - 8.333333333333309e-03*G6_2_0_8_0_0_4_1 - 8.333333333333311e-03*G6_2_0_8_0_0_4_2 + 8.333333333333309e-03*G6_2_0_8_0_0_5_0 + 8.333333333333309e-03*G6_2_0_8_0_0_6_1 + 8.333333333333309e-03*G6_2_0_8_0_0_7_2 - 4.166666666666654e-03*G6_2_0_8_0_1_4_0 - 4.166666666666654e-03*G6_2_0_8_0_1_4_1 - 4.166666666666654e-03*G6_2_0_8_0_1_4_2 + 4.166666666666654e-03*G6_2_0_8_0_1_5_0 + 4.166666666666654e-03*G6_2_0_8_0_1_6_1 + 4.166666666666654e-03*G6_2_0_8_0_1_7_2 - 4.166666666666653e-03*G6_2_0_8_0_2_4_0 - 4.166666666666654e-03*G6_2_0_8_0_2_4_1 - 4.166666666666654e-03*G6_2_0_8_0_2_4_2 + 4.166666666666653e-03*G6_2_0_8_0_2_5_0 + 4.166666666666654e-03*G6_2_0_8_0_2_6_1 + 4.166666666666654e-03*G6_2_0_8_0_2_7_2 - 4.166666666666654e-03*G6_2_0_8_0_3_4_0 - 4.166666666666656e-03*G6_2_0_8_0_3_4_1 - 4.166666666666657e-03*G6_2_0_8_0_3_4_2 + 4.166666666666654e-03*G6_2_0_8_0_3_5_0 + 4.166666666666656e-03*G6_2_0_8_0_3_6_1 + 4.166666666666656e-03*G6_2_0_8_0_3_7_2 - 8.333333333333309e-03*G6_2_0_8_1_0_4_0 - 8.333333333333311e-03*G6_2_0_8_1_0_4_1 - 8.333333333333312e-03*G6_2_0_8_1_0_4_2 + 8.333333333333309e-03*G6_2_0_8_1_0_5_0 + 8.333333333333311e-03*G6_2_0_8_1_0_6_1 + 8.333333333333311e-03*G6_2_0_8_1_0_7_2 - 4.166666666666654e-03*G6_2_0_8_1_1_4_0 - 4.166666666666654e-03*G6_2_0_8_1_1_4_1 - 4.166666666666654e-03*G6_2_0_8_1_1_4_2 + 4.166666666666654e-03*G6_2_0_8_1_1_5_0 + 4.166666666666654e-03*G6_2_0_8_1_1_6_1 + 4.166666666666654e-03*G6_2_0_8_1_1_7_2 - 4.166666666666654e-03*G6_2_0_8_1_2_4_0 - 4.166666666666654e-03*G6_2_0_8_1_2_4_1 - 4.166666666666654e-03*G6_2_0_8_1_2_4_2 + 4.166666666666654e-03*G6_2_0_8_1_2_5_0 + 4.166666666666654e-03*G6_2_0_8_1_2_6_1 + 4.166666666666654e-03*G6_2_0_8_1_2_7_2 - 4.166666666666656e-03*G6_2_0_8_1_3_4_0 - 4.166666666666657e-03*G6_2_0_8_1_3_4_1 - 4.166666666666657e-03*G6_2_0_8_1_3_4_2 + 4.166666666666656e-03*G6_2_0_8_1_3_5_0 + 4.166666666666657e-03*G6_2_0_8_1_3_6_1 + 4.166666666666657e-03*G6_2_0_8_1_3_7_2 - 8.333333333333311e-03*G6_2_0_8_2_0_4_0 - 8.333333333333312e-03*G6_2_0_8_2_0_4_1 - 8.333333333333314e-03*G6_2_0_8_2_0_4_2 + 8.333333333333311e-03*G6_2_0_8_2_0_5_0 + 8.333333333333312e-03*G6_2_0_8_2_0_6_1 + 8.333333333333312e-03*G6_2_0_8_2_0_7_2 - 4.166666666666654e-03*G6_2_0_8_2_1_4_0 - 4.166666666666654e-03*G6_2_0_8_2_1_4_1 - 4.166666666666655e-03*G6_2_0_8_2_1_4_2 + 4.166666666666654e-03*G6_2_0_8_2_1_5_0 + 4.166666666666654e-03*G6_2_0_8_2_1_6_1 + 4.166666666666654e-03*G6_2_0_8_2_1_7_2 - 4.166666666666654e-03*G6_2_0_8_2_2_4_0 - 4.166666666666654e-03*G6_2_0_8_2_2_4_1 - 4.166666666666654e-03*G6_2_0_8_2_2_4_2 + 4.166666666666654e-03*G6_2_0_8_2_2_5_0 + 4.166666666666654e-03*G6_2_0_8_2_2_6_1 + 4.166666666666654e-03*G6_2_0_8_2_2_7_2 - 4.166666666666657e-03*G6_2_0_8_2_3_4_0 - 4.166666666666657e-03*G6_2_0_8_2_3_4_1 - 4.166666666666658e-03*G6_2_0_8_2_3_4_2 + 4.166666666666657e-03*G6_2_0_8_2_3_5_0 + 4.166666666666657e-03*G6_2_0_8_2_3_6_1 + 4.166666666666657e-03*G6_2_0_8_2_3_7_2 - 4.166666666666654e-03*G6_2_0_9_0_0_4_0 - 4.166666666666655e-03*G6_2_0_9_0_0_4_1 - 4.166666666666655e-03*G6_2_0_9_0_0_4_2 + 4.166666666666654e-03*G6_2_0_9_0_0_5_0 + 4.166666666666655e-03*G6_2_0_9_0_0_6_1 + 4.166666666666655e-03*G6_2_0_9_0_0_7_2 - 8.333333333333307e-03*G6_2_0_9_0_1_4_0 - 8.333333333333309e-03*G6_2_0_9_0_1_4_1 - 8.333333333333309e-03*G6_2_0_9_0_1_4_2 + 8.333333333333307e-03*G6_2_0_9_0_1_5_0 + 8.333333333333309e-03*G6_2_0_9_0_1_6_1 + 8.333333333333309e-03*G6_2_0_9_0_1_7_2 - 4.166666666666654e-03*G6_2_0_9_0_2_4_0 - 4.166666666666655e-03*G6_2_0_9_0_2_4_1 - 4.166666666666655e-03*G6_2_0_9_0_2_4_2 + 4.166666666666654e-03*G6_2_0_9_0_2_5_0 + 4.166666666666655e-03*G6_2_0_9_0_2_6_1 + 4.166666666666655e-03*G6_2_0_9_0_2_7_2 - 4.166666666666655e-03*G6_2_0_9_0_3_4_0 - 4.166666666666656e-03*G6_2_0_9_0_3_4_1 - 4.166666666666656e-03*G6_2_0_9_0_3_4_2 + 4.166666666666655e-03*G6_2_0_9_0_3_5_0 + 4.166666666666656e-03*G6_2_0_9_0_3_6_1 + 4.166666666666656e-03*G6_2_0_9_0_3_7_2 - 4.166666666666655e-03*G6_2_0_9_1_0_4_0 - 4.166666666666655e-03*G6_2_0_9_1_0_4_1 - 4.166666666666656e-03*G6_2_0_9_1_0_4_2 + 4.166666666666655e-03*G6_2_0_9_1_0_5_0 + 4.166666666666655e-03*G6_2_0_9_1_0_6_1 + 4.166666666666655e-03*G6_2_0_9_1_0_7_2 - 8.333333333333309e-03*G6_2_0_9_1_1_4_0 - 8.333333333333309e-03*G6_2_0_9_1_1_4_1 - 8.333333333333309e-03*G6_2_0_9_1_1_4_2 + 8.333333333333309e-03*G6_2_0_9_1_1_5_0 + 8.333333333333309e-03*G6_2_0_9_1_1_6_1 + 8.333333333333309e-03*G6_2_0_9_1_1_7_2 - 4.166666666666655e-03*G6_2_0_9_1_2_4_0 - 4.166666666666656e-03*G6_2_0_9_1_2_4_1 - 4.166666666666656e-03*G6_2_0_9_1_2_4_2 + 4.166666666666655e-03*G6_2_0_9_1_2_5_0 + 4.166666666666656e-03*G6_2_0_9_1_2_6_1 + 4.166666666666656e-03*G6_2_0_9_1_2_7_2 - 4.166666666666656e-03*G6_2_0_9_1_3_4_0 - 4.166666666666657e-03*G6_2_0_9_1_3_4_1 - 4.166666666666657e-03*G6_2_0_9_1_3_4_2 + 4.166666666666656e-03*G6_2_0_9_1_3_5_0 + 4.166666666666657e-03*G6_2_0_9_1_3_6_1 + 4.166666666666657e-03*G6_2_0_9_1_3_7_2 - 4.166666666666655e-03*G6_2_0_9_2_0_4_0 - 4.166666666666656e-03*G6_2_0_9_2_0_4_1 - 4.166666666666657e-03*G6_2_0_9_2_0_4_2 + 4.166666666666655e-03*G6_2_0_9_2_0_5_0 + 4.166666666666656e-03*G6_2_0_9_2_0_6_1 + 4.166666666666656e-03*G6_2_0_9_2_0_7_2 - 8.333333333333309e-03*G6_2_0_9_2_1_4_0 - 8.333333333333309e-03*G6_2_0_9_2_1_4_1 - 8.333333333333309e-03*G6_2_0_9_2_1_4_2 + 8.333333333333309e-03*G6_2_0_9_2_1_5_0 + 8.333333333333309e-03*G6_2_0_9_2_1_6_1 + 8.333333333333309e-03*G6_2_0_9_2_1_7_2 - 4.166666666666655e-03*G6_2_0_9_2_2_4_0 - 4.166666666666656e-03*G6_2_0_9_2_2_4_1 - 4.166666666666656e-03*G6_2_0_9_2_2_4_2 + 4.166666666666655e-03*G6_2_0_9_2_2_5_0 + 4.166666666666656e-03*G6_2_0_9_2_2_6_1 + 4.166666666666656e-03*G6_2_0_9_2_2_7_2 - 4.166666666666656e-03*G6_2_0_9_2_3_4_0 - 4.166666666666657e-03*G6_2_0_9_2_3_4_1 - 4.166666666666657e-03*G6_2_0_9_2_3_4_2 + 4.166666666666656e-03*G6_2_0_9_2_3_5_0 + 4.166666666666657e-03*G6_2_0_9_2_3_6_1 + 4.166666666666657e-03*G6_2_0_9_2_3_7_2 - 4.166666666666654e-03*G6_2_0_10_0_0_4_0 - 4.166666666666654e-03*G6_2_0_10_0_0_4_1 - 4.166666666666655e-03*G6_2_0_10_0_0_4_2 + 4.166666666666654e-03*G6_2_0_10_0_0_5_0 + 4.166666666666654e-03*G6_2_0_10_0_0_6_1 + 4.166666666666654e-03*G6_2_0_10_0_0_7_2 - 4.166666666666654e-03*G6_2_0_10_0_1_4_0 - 4.166666666666654e-03*G6_2_0_10_0_1_4_1 - 4.166666666666654e-03*G6_2_0_10_0_1_4_2 + 4.166666666666654e-03*G6_2_0_10_0_1_5_0 + 4.166666666666654e-03*G6_2_0_10_0_1_6_1 + 4.166666666666654e-03*G6_2_0_10_0_1_7_2 - 8.333333333333309e-03*G6_2_0_10_0_2_4_0 - 8.333333333333309e-03*G6_2_0_10_0_2_4_1 - 8.333333333333311e-03*G6_2_0_10_0_2_4_2 + 8.333333333333309e-03*G6_2_0_10_0_2_5_0 + 8.333333333333309e-03*G6_2_0_10_0_2_6_1 + 8.333333333333309e-03*G6_2_0_10_0_2_7_2 - 4.166666666666654e-03*G6_2_0_10_0_3_4_0 - 4.166666666666655e-03*G6_2_0_10_0_3_4_1 - 4.166666666666655e-03*G6_2_0_10_0_3_4_2 + 4.166666666666654e-03*G6_2_0_10_0_3_5_0 + 4.166666666666655e-03*G6_2_0_10_0_3_6_1 + 4.166666666666655e-03*G6_2_0_10_0_3_7_2 - 4.166666666666654e-03*G6_2_0_10_1_0_4_0 - 4.166666666666656e-03*G6_2_0_10_1_0_4_1 - 4.166666666666656e-03*G6_2_0_10_1_0_4_2 + 4.166666666666654e-03*G6_2_0_10_1_0_5_0 + 4.166666666666656e-03*G6_2_0_10_1_0_6_1 + 4.166666666666656e-03*G6_2_0_10_1_0_7_2 - 4.166666666666654e-03*G6_2_0_10_1_1_4_0 - 4.166666666666654e-03*G6_2_0_10_1_1_4_1 - 4.166666666666654e-03*G6_2_0_10_1_1_4_2 + 4.166666666666654e-03*G6_2_0_10_1_1_5_0 + 4.166666666666654e-03*G6_2_0_10_1_1_6_1 + 4.166666666666654e-03*G6_2_0_10_1_1_7_2 - 8.333333333333311e-03*G6_2_0_10_1_2_4_0 - 8.333333333333311e-03*G6_2_0_10_1_2_4_1 - 8.333333333333312e-03*G6_2_0_10_1_2_4_2 + 8.333333333333311e-03*G6_2_0_10_1_2_5_0 + 8.333333333333311e-03*G6_2_0_10_1_2_6_1 + 8.333333333333311e-03*G6_2_0_10_1_2_7_2 - 4.166666666666655e-03*G6_2_0_10_1_3_4_0 - 4.166666666666656e-03*G6_2_0_10_1_3_4_1 - 4.166666666666657e-03*G6_2_0_10_1_3_4_2 + 4.166666666666655e-03*G6_2_0_10_1_3_5_0 + 4.166666666666656e-03*G6_2_0_10_1_3_6_1 + 4.166666666666656e-03*G6_2_0_10_1_3_7_2 - 4.166666666666655e-03*G6_2_0_10_2_0_4_0 - 4.166666666666656e-03*G6_2_0_10_2_0_4_1 - 4.166666666666656e-03*G6_2_0_10_2_0_4_2 + 4.166666666666655e-03*G6_2_0_10_2_0_5_0 + 4.166666666666656e-03*G6_2_0_10_2_0_6_1 + 4.166666666666656e-03*G6_2_0_10_2_0_7_2 - 4.166666666666654e-03*G6_2_0_10_2_1_4_0 - 4.166666666666654e-03*G6_2_0_10_2_1_4_1 - 4.166666666666655e-03*G6_2_0_10_2_1_4_2 + 4.166666666666654e-03*G6_2_0_10_2_1_5_0 + 4.166666666666654e-03*G6_2_0_10_2_1_6_1 + 4.166666666666654e-03*G6_2_0_10_2_1_7_2 - 8.333333333333311e-03*G6_2_0_10_2_2_4_0 - 8.333333333333312e-03*G6_2_0_10_2_2_4_1 - 8.333333333333312e-03*G6_2_0_10_2_2_4_2 + 8.333333333333311e-03*G6_2_0_10_2_2_5_0 + 8.333333333333312e-03*G6_2_0_10_2_2_6_1 + 8.333333333333312e-03*G6_2_0_10_2_2_7_2 - 4.166666666666655e-03*G6_2_0_10_2_3_4_0 - 4.166666666666657e-03*G6_2_0_10_2_3_4_1 - 4.166666666666657e-03*G6_2_0_10_2_3_4_2 + 4.166666666666655e-03*G6_2_0_10_2_3_5_0 + 4.166666666666657e-03*G6_2_0_10_2_3_6_1 + 4.166666666666657e-03*G6_2_0_10_2_3_7_2 - 4.166666666666656e-03*G6_2_0_11_0_0_4_0 - 4.166666666666656e-03*G6_2_0_11_0_0_4_1 - 4.166666666666657e-03*G6_2_0_11_0_0_4_2 + 4.166666666666656e-03*G6_2_0_11_0_0_5_0 + 4.166666666666656e-03*G6_2_0_11_0_0_6_1 + 4.166666666666656e-03*G6_2_0_11_0_0_7_2 - 4.166666666666654e-03*G6_2_0_11_0_1_4_0 - 4.166666666666655e-03*G6_2_0_11_0_1_4_1 - 4.166666666666655e-03*G6_2_0_11_0_1_4_2 + 4.166666666666654e-03*G6_2_0_11_0_1_5_0 + 4.166666666666655e-03*G6_2_0_11_0_1_6_1 + 4.166666666666655e-03*G6_2_0_11_0_1_7_2 - 4.166666666666655e-03*G6_2_0_11_0_2_4_0 - 4.166666666666655e-03*G6_2_0_11_0_2_4_1 - 4.166666666666655e-03*G6_2_0_11_0_2_4_2 + 4.166666666666655e-03*G6_2_0_11_0_2_5_0 + 4.166666666666655e-03*G6_2_0_11_0_2_6_1 + 4.166666666666655e-03*G6_2_0_11_0_2_7_2 - 8.333333333333309e-03*G6_2_0_11_0_3_4_0 - 8.333333333333311e-03*G6_2_0_11_0_3_4_1 - 8.333333333333311e-03*G6_2_0_11_0_3_4_2 + 8.333333333333309e-03*G6_2_0_11_0_3_5_0 + 8.333333333333311e-03*G6_2_0_11_0_3_6_1 + 8.333333333333311e-03*G6_2_0_11_0_3_7_2 - 4.166666666666656e-03*G6_2_0_11_1_0_4_0 - 4.166666666666657e-03*G6_2_0_11_1_0_4_1 - 4.166666666666658e-03*G6_2_0_11_1_0_4_2 + 4.166666666666656e-03*G6_2_0_11_1_0_5_0 + 4.166666666666657e-03*G6_2_0_11_1_0_6_1 + 4.166666666666657e-03*G6_2_0_11_1_0_7_2 - 4.166666666666655e-03*G6_2_0_11_1_1_4_0 - 4.166666666666655e-03*G6_2_0_11_1_1_4_1 - 4.166666666666656e-03*G6_2_0_11_1_1_4_2 + 4.166666666666655e-03*G6_2_0_11_1_1_5_0 + 4.166666666666655e-03*G6_2_0_11_1_1_6_1 + 4.166666666666655e-03*G6_2_0_11_1_1_7_2 - 4.166666666666655e-03*G6_2_0_11_1_2_4_0 - 4.166666666666656e-03*G6_2_0_11_1_2_4_1 - 4.166666666666657e-03*G6_2_0_11_1_2_4_2 + 4.166666666666655e-03*G6_2_0_11_1_2_5_0 + 4.166666666666656e-03*G6_2_0_11_1_2_6_1 + 4.166666666666656e-03*G6_2_0_11_1_2_7_2 - 8.333333333333311e-03*G6_2_0_11_1_3_4_0 - 8.333333333333311e-03*G6_2_0_11_1_3_4_1 - 8.333333333333312e-03*G6_2_0_11_1_3_4_2 + 8.333333333333311e-03*G6_2_0_11_1_3_5_0 + 8.333333333333311e-03*G6_2_0_11_1_3_6_1 + 8.333333333333311e-03*G6_2_0_11_1_3_7_2 - 4.166666666666657e-03*G6_2_0_11_2_0_4_0 - 4.166666666666658e-03*G6_2_0_11_2_0_4_1 - 4.166666666666659e-03*G6_2_0_11_2_0_4_2 + 4.166666666666657e-03*G6_2_0_11_2_0_5_0 + 4.166666666666658e-03*G6_2_0_11_2_0_6_1 + 4.166666666666658e-03*G6_2_0_11_2_0_7_2 - 4.166666666666655e-03*G6_2_0_11_2_1_4_0 - 4.166666666666656e-03*G6_2_0_11_2_1_4_1 - 4.166666666666656e-03*G6_2_0_11_2_1_4_2 + 4.166666666666655e-03*G6_2_0_11_2_1_5_0 + 4.166666666666656e-03*G6_2_0_11_2_1_6_1 + 4.166666666666656e-03*G6_2_0_11_2_1_7_2 - 4.166666666666655e-03*G6_2_0_11_2_2_4_0 - 4.166666666666657e-03*G6_2_0_11_2_2_4_1 - 4.166666666666657e-03*G6_2_0_11_2_2_4_2 + 4.166666666666655e-03*G6_2_0_11_2_2_5_0 + 4.166666666666657e-03*G6_2_0_11_2_2_6_1 + 4.166666666666657e-03*G6_2_0_11_2_2_7_2 - 8.333333333333311e-03*G6_2_0_11_2_3_4_0 - 8.333333333333312e-03*G6_2_0_11_2_3_4_1 - 8.333333333333312e-03*G6_2_0_11_2_3_4_2 + 8.333333333333311e-03*G6_2_0_11_2_3_5_0 + 8.333333333333312e-03*G6_2_0_11_2_3_6_1 + 8.333333333333312e-03*G6_2_0_11_2_3_7_2 - 8.333333333333309e-03*G6_2_1_8_0_4_4_0 - 8.333333333333309e-03*G6_2_1_8_0_4_4_1 - 8.333333333333311e-03*G6_2_1_8_0_4_4_2 + 8.333333333333309e-03*G6_2_1_8_0_4_5_0 + 8.333333333333309e-03*G6_2_1_8_0_4_6_1 + 8.333333333333309e-03*G6_2_1_8_0_4_7_2 - 4.166666666666654e-03*G6_2_1_8_0_5_4_0 - 4.166666666666654e-03*G6_2_1_8_0_5_4_1 - 4.166666666666654e-03*G6_2_1_8_0_5_4_2 + 4.166666666666654e-03*G6_2_1_8_0_5_5_0 + 4.166666666666654e-03*G6_2_1_8_0_5_6_1 + 4.166666666666654e-03*G6_2_1_8_0_5_7_2 - 4.166666666666653e-03*G6_2_1_8_0_6_4_0 - 4.166666666666654e-03*G6_2_1_8_0_6_4_1 - 4.166666666666654e-03*G6_2_1_8_0_6_4_2 + 4.166666666666653e-03*G6_2_1_8_0_6_5_0 + 4.166666666666654e-03*G6_2_1_8_0_6_6_1 + 4.166666666666654e-03*G6_2_1_8_0_6_7_2 - 4.166666666666654e-03*G6_2_1_8_0_7_4_0 - 4.166666666666656e-03*G6_2_1_8_0_7_4_1 - 4.166666666666657e-03*G6_2_1_8_0_7_4_2 + 4.166666666666654e-03*G6_2_1_8_0_7_5_0 + 4.166666666666656e-03*G6_2_1_8_0_7_6_1 + 4.166666666666656e-03*G6_2_1_8_0_7_7_2 - 8.333333333333309e-03*G6_2_1_8_1_4_4_0 - 8.333333333333311e-03*G6_2_1_8_1_4_4_1 - 8.333333333333312e-03*G6_2_1_8_1_4_4_2 + 8.333333333333309e-03*G6_2_1_8_1_4_5_0 + 8.333333333333311e-03*G6_2_1_8_1_4_6_1 + 8.333333333333311e-03*G6_2_1_8_1_4_7_2 - 4.166666666666654e-03*G6_2_1_8_1_5_4_0 - 4.166666666666654e-03*G6_2_1_8_1_5_4_1 - 4.166666666666655e-03*G6_2_1_8_1_5_4_2 + 4.166666666666654e-03*G6_2_1_8_1_5_5_0 + 4.166666666666654e-03*G6_2_1_8_1_5_6_1 + 4.166666666666654e-03*G6_2_1_8_1_5_7_2 - 4.166666666666654e-03*G6_2_1_8_1_6_4_0 - 4.166666666666654e-03*G6_2_1_8_1_6_4_1 - 4.166666666666654e-03*G6_2_1_8_1_6_4_2 + 4.166666666666654e-03*G6_2_1_8_1_6_5_0 + 4.166666666666654e-03*G6_2_1_8_1_6_6_1 + 4.166666666666654e-03*G6_2_1_8_1_6_7_2 - 4.166666666666656e-03*G6_2_1_8_1_7_4_0 - 4.166666666666657e-03*G6_2_1_8_1_7_4_1 - 4.166666666666657e-03*G6_2_1_8_1_7_4_2 + 4.166666666666656e-03*G6_2_1_8_1_7_5_0 + 4.166666666666657e-03*G6_2_1_8_1_7_6_1 + 4.166666666666657e-03*G6_2_1_8_1_7_7_2 - 8.333333333333311e-03*G6_2_1_8_2_4_4_0 - 8.333333333333312e-03*G6_2_1_8_2_4_4_1 - 8.333333333333314e-03*G6_2_1_8_2_4_4_2 + 8.333333333333311e-03*G6_2_1_8_2_4_5_0 + 8.333333333333312e-03*G6_2_1_8_2_4_6_1 + 8.333333333333312e-03*G6_2_1_8_2_4_7_2 - 4.166666666666654e-03*G6_2_1_8_2_5_4_0 - 4.166666666666655e-03*G6_2_1_8_2_5_4_1 - 4.166666666666655e-03*G6_2_1_8_2_5_4_2 + 4.166666666666654e-03*G6_2_1_8_2_5_5_0 + 4.166666666666655e-03*G6_2_1_8_2_5_6_1 + 4.166666666666655e-03*G6_2_1_8_2_5_7_2 - 4.166666666666654e-03*G6_2_1_8_2_6_4_0 - 4.166666666666654e-03*G6_2_1_8_2_6_4_1 - 4.166666666666654e-03*G6_2_1_8_2_6_4_2 + 4.166666666666654e-03*G6_2_1_8_2_6_5_0 + 4.166666666666654e-03*G6_2_1_8_2_6_6_1 + 4.166666666666654e-03*G6_2_1_8_2_6_7_2 - 4.166666666666657e-03*G6_2_1_8_2_7_4_0 - 4.166666666666657e-03*G6_2_1_8_2_7_4_1 - 4.166666666666658e-03*G6_2_1_8_2_7_4_2 + 4.166666666666657e-03*G6_2_1_8_2_7_5_0 + 4.166666666666657e-03*G6_2_1_8_2_7_6_1 + 4.166666666666657e-03*G6_2_1_8_2_7_7_2 - 4.166666666666654e-03*G6_2_1_9_0_4_4_0 - 4.166666666666654e-03*G6_2_1_9_0_4_4_1 - 4.166666666666654e-03*G6_2_1_9_0_4_4_2 + 4.166666666666654e-03*G6_2_1_9_0_4_5_0 + 4.166666666666654e-03*G6_2_1_9_0_4_6_1 + 4.166666666666654e-03*G6_2_1_9_0_4_7_2 - 8.333333333333307e-03*G6_2_1_9_0_5_4_0 - 8.333333333333309e-03*G6_2_1_9_0_5_4_1 - 8.333333333333309e-03*G6_2_1_9_0_5_4_2 + 8.333333333333307e-03*G6_2_1_9_0_5_5_0 + 8.333333333333309e-03*G6_2_1_9_0_5_6_1 + 8.333333333333309e-03*G6_2_1_9_0_5_7_2 - 4.166666666666654e-03*G6_2_1_9_0_6_4_0 - 4.166666666666655e-03*G6_2_1_9_0_6_4_1 - 4.166666666666655e-03*G6_2_1_9_0_6_4_2 + 4.166666666666654e-03*G6_2_1_9_0_6_5_0 + 4.166666666666655e-03*G6_2_1_9_0_6_6_1 + 4.166666666666655e-03*G6_2_1_9_0_6_7_2 - 4.166666666666655e-03*G6_2_1_9_0_7_4_0 - 4.166666666666656e-03*G6_2_1_9_0_7_4_1 - 4.166666666666656e-03*G6_2_1_9_0_7_4_2 + 4.166666666666655e-03*G6_2_1_9_0_7_5_0 + 4.166666666666656e-03*G6_2_1_9_0_7_6_1 + 4.166666666666656e-03*G6_2_1_9_0_7_7_2 - 4.166666666666654e-03*G6_2_1_9_1_4_4_0 - 4.166666666666654e-03*G6_2_1_9_1_4_4_1 - 4.166666666666655e-03*G6_2_1_9_1_4_4_2 + 4.166666666666654e-03*G6_2_1_9_1_4_5_0 + 4.166666666666654e-03*G6_2_1_9_1_4_6_1 + 4.166666666666654e-03*G6_2_1_9_1_4_7_2 - 8.333333333333309e-03*G6_2_1_9_1_5_4_0 - 8.333333333333309e-03*G6_2_1_9_1_5_4_1 - 8.333333333333309e-03*G6_2_1_9_1_5_4_2 + 8.333333333333309e-03*G6_2_1_9_1_5_5_0 + 8.333333333333309e-03*G6_2_1_9_1_5_6_1 + 8.333333333333309e-03*G6_2_1_9_1_5_7_2 - 4.166666666666655e-03*G6_2_1_9_1_6_4_0 - 4.166666666666656e-03*G6_2_1_9_1_6_4_1 - 4.166666666666656e-03*G6_2_1_9_1_6_4_2 + 4.166666666666655e-03*G6_2_1_9_1_6_5_0 + 4.166666666666656e-03*G6_2_1_9_1_6_6_1 + 4.166666666666656e-03*G6_2_1_9_1_6_7_2 - 4.166666666666656e-03*G6_2_1_9_1_7_4_0 - 4.166666666666657e-03*G6_2_1_9_1_7_4_1 - 4.166666666666657e-03*G6_2_1_9_1_7_4_2 + 4.166666666666656e-03*G6_2_1_9_1_7_5_0 + 4.166666666666657e-03*G6_2_1_9_1_7_6_1 + 4.166666666666657e-03*G6_2_1_9_1_7_7_2 - 4.166666666666654e-03*G6_2_1_9_2_4_4_0 - 4.166666666666655e-03*G6_2_1_9_2_4_4_1 - 4.166666666666655e-03*G6_2_1_9_2_4_4_2 + 4.166666666666654e-03*G6_2_1_9_2_4_5_0 + 4.166666666666655e-03*G6_2_1_9_2_4_6_1 + 4.166666666666655e-03*G6_2_1_9_2_4_7_2 - 8.333333333333309e-03*G6_2_1_9_2_5_4_0 - 8.333333333333309e-03*G6_2_1_9_2_5_4_1 - 8.333333333333309e-03*G6_2_1_9_2_5_4_2 + 8.333333333333309e-03*G6_2_1_9_2_5_5_0 + 8.333333333333309e-03*G6_2_1_9_2_5_6_1 + 8.333333333333309e-03*G6_2_1_9_2_5_7_2 - 4.166666666666655e-03*G6_2_1_9_2_6_4_0 - 4.166666666666656e-03*G6_2_1_9_2_6_4_1 - 4.166666666666656e-03*G6_2_1_9_2_6_4_2 + 4.166666666666655e-03*G6_2_1_9_2_6_5_0 + 4.166666666666656e-03*G6_2_1_9_2_6_6_1 + 4.166666666666656e-03*G6_2_1_9_2_6_7_2 - 4.166666666666656e-03*G6_2_1_9_2_7_4_0 - 4.166666666666657e-03*G6_2_1_9_2_7_4_1 - 4.166666666666657e-03*G6_2_1_9_2_7_4_2 + 4.166666666666656e-03*G6_2_1_9_2_7_5_0 + 4.166666666666657e-03*G6_2_1_9_2_7_6_1 + 4.166666666666657e-03*G6_2_1_9_2_7_7_2 - 4.166666666666653e-03*G6_2_1_10_0_4_4_0 - 4.166666666666654e-03*G6_2_1_10_0_4_4_1 - 4.166666666666654e-03*G6_2_1_10_0_4_4_2 + 4.166666666666653e-03*G6_2_1_10_0_4_5_0 + 4.166666666666654e-03*G6_2_1_10_0_4_6_1 + 4.166666666666654e-03*G6_2_1_10_0_4_7_2 - 4.166666666666654e-03*G6_2_1_10_0_5_4_0 - 4.166666666666655e-03*G6_2_1_10_0_5_4_1 - 4.166666666666655e-03*G6_2_1_10_0_5_4_2 + 4.166666666666654e-03*G6_2_1_10_0_5_5_0 + 4.166666666666655e-03*G6_2_1_10_0_5_6_1 + 4.166666666666655e-03*G6_2_1_10_0_5_7_2 - 8.333333333333309e-03*G6_2_1_10_0_6_4_0 - 8.333333333333309e-03*G6_2_1_10_0_6_4_1 - 8.333333333333311e-03*G6_2_1_10_0_6_4_2 + 8.333333333333309e-03*G6_2_1_10_0_6_5_0 + 8.333333333333309e-03*G6_2_1_10_0_6_6_1 + 8.333333333333309e-03*G6_2_1_10_0_6_7_2 - 4.166666666666654e-03*G6_2_1_10_0_7_4_0 - 4.166666666666655e-03*G6_2_1_10_0_7_4_1 - 4.166666666666655e-03*G6_2_1_10_0_7_4_2 + 4.166666666666654e-03*G6_2_1_10_0_7_5_0 + 4.166666666666655e-03*G6_2_1_10_0_7_6_1 + 4.166666666666655e-03*G6_2_1_10_0_7_7_2 - 4.166666666666654e-03*G6_2_1_10_1_4_4_0 - 4.166666666666654e-03*G6_2_1_10_1_4_4_1 - 4.166666666666654e-03*G6_2_1_10_1_4_4_2 + 4.166666666666654e-03*G6_2_1_10_1_4_5_0 + 4.166666666666654e-03*G6_2_1_10_1_4_6_1 + 4.166666666666654e-03*G6_2_1_10_1_4_7_2 - 4.166666666666655e-03*G6_2_1_10_1_5_4_0 - 4.166666666666656e-03*G6_2_1_10_1_5_4_1 - 4.166666666666656e-03*G6_2_1_10_1_5_4_2 + 4.166666666666655e-03*G6_2_1_10_1_5_5_0 + 4.166666666666656e-03*G6_2_1_10_1_5_6_1 + 4.166666666666656e-03*G6_2_1_10_1_5_7_2 - 8.333333333333311e-03*G6_2_1_10_1_6_4_0 - 8.333333333333311e-03*G6_2_1_10_1_6_4_1 - 8.333333333333312e-03*G6_2_1_10_1_6_4_2 + 8.333333333333311e-03*G6_2_1_10_1_6_5_0 + 8.333333333333311e-03*G6_2_1_10_1_6_6_1 + 8.333333333333311e-03*G6_2_1_10_1_6_7_2 - 4.166666666666655e-03*G6_2_1_10_1_7_4_0 - 4.166666666666656e-03*G6_2_1_10_1_7_4_1 - 4.166666666666657e-03*G6_2_1_10_1_7_4_2 + 4.166666666666655e-03*G6_2_1_10_1_7_5_0 + 4.166666666666656e-03*G6_2_1_10_1_7_6_1 + 4.166666666666656e-03*G6_2_1_10_1_7_7_2 - 4.166666666666654e-03*G6_2_1_10_2_4_4_0 - 4.166666666666654e-03*G6_2_1_10_2_4_4_1 - 4.166666666666654e-03*G6_2_1_10_2_4_4_2 + 4.166666666666654e-03*G6_2_1_10_2_4_5_0 + 4.166666666666654e-03*G6_2_1_10_2_4_6_1 + 4.166666666666654e-03*G6_2_1_10_2_4_7_2 - 4.166666666666655e-03*G6_2_1_10_2_5_4_0 - 4.166666666666656e-03*G6_2_1_10_2_5_4_1 - 4.166666666666656e-03*G6_2_1_10_2_5_4_2 + 4.166666666666655e-03*G6_2_1_10_2_5_5_0 + 4.166666666666656e-03*G6_2_1_10_2_5_6_1 + 4.166666666666656e-03*G6_2_1_10_2_5_7_2 - 8.333333333333311e-03*G6_2_1_10_2_6_4_0 - 8.333333333333312e-03*G6_2_1_10_2_6_4_1 - 8.333333333333312e-03*G6_2_1_10_2_6_4_2 + 8.333333333333311e-03*G6_2_1_10_2_6_5_0 + 8.333333333333312e-03*G6_2_1_10_2_6_6_1 + 8.333333333333312e-03*G6_2_1_10_2_6_7_2 - 4.166666666666655e-03*G6_2_1_10_2_7_4_0 - 4.166666666666657e-03*G6_2_1_10_2_7_4_1 - 4.166666666666657e-03*G6_2_1_10_2_7_4_2 + 4.166666666666655e-03*G6_2_1_10_2_7_5_0 + 4.166666666666657e-03*G6_2_1_10_2_7_6_1 + 4.166666666666657e-03*G6_2_1_10_2_7_7_2 - 4.166666666666655e-03*G6_2_1_11_0_4_4_0 - 4.166666666666656e-03*G6_2_1_11_0_4_4_1 - 4.166666666666657e-03*G6_2_1_11_0_4_4_2 + 4.166666666666655e-03*G6_2_1_11_0_4_5_0 + 4.166666666666656e-03*G6_2_1_11_0_4_6_1 + 4.166666666666656e-03*G6_2_1_11_0_4_7_2 - 4.166666666666655e-03*G6_2_1_11_0_5_4_0 - 4.166666666666656e-03*G6_2_1_11_0_5_4_1 - 4.166666666666656e-03*G6_2_1_11_0_5_4_2 + 4.166666666666655e-03*G6_2_1_11_0_5_5_0 + 4.166666666666656e-03*G6_2_1_11_0_5_6_1 + 4.166666666666656e-03*G6_2_1_11_0_5_7_2 - 4.166666666666655e-03*G6_2_1_11_0_6_4_0 - 4.166666666666655e-03*G6_2_1_11_0_6_4_1 - 4.166666666666655e-03*G6_2_1_11_0_6_4_2 + 4.166666666666655e-03*G6_2_1_11_0_6_5_0 + 4.166666666666655e-03*G6_2_1_11_0_6_6_1 + 4.166666666666655e-03*G6_2_1_11_0_6_7_2 - 8.333333333333309e-03*G6_2_1_11_0_7_4_0 - 8.333333333333311e-03*G6_2_1_11_0_7_4_1 - 8.333333333333311e-03*G6_2_1_11_0_7_4_2 + 8.333333333333309e-03*G6_2_1_11_0_7_5_0 + 8.333333333333311e-03*G6_2_1_11_0_7_6_1 + 8.333333333333311e-03*G6_2_1_11_0_7_7_2 - 4.166666666666656e-03*G6_2_1_11_1_4_4_0 - 4.166666666666657e-03*G6_2_1_11_1_4_4_1 - 4.166666666666657e-03*G6_2_1_11_1_4_4_2 + 4.166666666666656e-03*G6_2_1_11_1_4_5_0 + 4.166666666666657e-03*G6_2_1_11_1_4_6_1 + 4.166666666666657e-03*G6_2_1_11_1_4_7_2 - 4.166666666666656e-03*G6_2_1_11_1_5_4_0 - 4.166666666666657e-03*G6_2_1_11_1_5_4_1 - 4.166666666666657e-03*G6_2_1_11_1_5_4_2 + 4.166666666666656e-03*G6_2_1_11_1_5_5_0 + 4.166666666666657e-03*G6_2_1_11_1_5_6_1 + 4.166666666666657e-03*G6_2_1_11_1_5_7_2 - 4.166666666666655e-03*G6_2_1_11_1_6_4_0 - 4.166666666666656e-03*G6_2_1_11_1_6_4_1 - 4.166666666666657e-03*G6_2_1_11_1_6_4_2 + 4.166666666666655e-03*G6_2_1_11_1_6_5_0 + 4.166666666666656e-03*G6_2_1_11_1_6_6_1 + 4.166666666666656e-03*G6_2_1_11_1_6_7_2 - 8.333333333333311e-03*G6_2_1_11_1_7_4_0 - 8.333333333333311e-03*G6_2_1_11_1_7_4_1 - 8.333333333333312e-03*G6_2_1_11_1_7_4_2 + 8.333333333333311e-03*G6_2_1_11_1_7_5_0 + 8.333333333333311e-03*G6_2_1_11_1_7_6_1 + 8.333333333333311e-03*G6_2_1_11_1_7_7_2 - 4.166666666666657e-03*G6_2_1_11_2_4_4_0 - 4.166666666666657e-03*G6_2_1_11_2_4_4_1 - 4.166666666666658e-03*G6_2_1_11_2_4_4_2 + 4.166666666666657e-03*G6_2_1_11_2_4_5_0 + 4.166666666666657e-03*G6_2_1_11_2_4_6_1 + 4.166666666666657e-03*G6_2_1_11_2_4_7_2 - 4.166666666666656e-03*G6_2_1_11_2_5_4_0 - 4.166666666666657e-03*G6_2_1_11_2_5_4_1 - 4.166666666666657e-03*G6_2_1_11_2_5_4_2 + 4.166666666666656e-03*G6_2_1_11_2_5_5_0 + 4.166666666666657e-03*G6_2_1_11_2_5_6_1 + 4.166666666666657e-03*G6_2_1_11_2_5_7_2 - 4.166666666666655e-03*G6_2_1_11_2_6_4_0 - 4.166666666666657e-03*G6_2_1_11_2_6_4_1 - 4.166666666666657e-03*G6_2_1_11_2_6_4_2 + 4.166666666666655e-03*G6_2_1_11_2_6_5_0 + 4.166666666666657e-03*G6_2_1_11_2_6_6_1 + 4.166666666666657e-03*G6_2_1_11_2_6_7_2 - 8.333333333333311e-03*G6_2_1_11_2_7_4_0 - 8.333333333333312e-03*G6_2_1_11_2_7_4_1 - 8.333333333333312e-03*G6_2_1_11_2_7_4_2 + 8.333333333333311e-03*G6_2_1_11_2_7_5_0 + 8.333333333333312e-03*G6_2_1_11_2_7_6_1 + 8.333333333333312e-03*G6_2_1_11_2_7_7_2 - 8.333333333333309e-03*G6_2_2_8_0_8_4_0 - 8.333333333333309e-03*G6_2_2_8_0_8_4_1 - 8.333333333333311e-03*G6_2_2_8_0_8_4_2 + 8.333333333333309e-03*G6_2_2_8_0_8_5_0 + 8.333333333333309e-03*G6_2_2_8_0_8_6_1 + 8.333333333333309e-03*G6_2_2_8_0_8_7_2 - 4.166666666666654e-03*G6_2_2_8_0_9_4_0 - 4.166666666666654e-03*G6_2_2_8_0_9_4_1 - 4.166666666666654e-03*G6_2_2_8_0_9_4_2 + 4.166666666666654e-03*G6_2_2_8_0_9_5_0 + 4.166666666666654e-03*G6_2_2_8_0_9_6_1 + 4.166666666666654e-03*G6_2_2_8_0_9_7_2 - 4.166666666666653e-03*G6_2_2_8_0_10_4_0 - 4.166666666666654e-03*G6_2_2_8_0_10_4_1 - 4.166666666666654e-03*G6_2_2_8_0_10_4_2 + 4.166666666666653e-03*G6_2_2_8_0_10_5_0 + 4.166666666666654e-03*G6_2_2_8_0_10_6_1 + 4.166666666666654e-03*G6_2_2_8_0_10_7_2 - 4.166666666666654e-03*G6_2_2_8_0_11_4_0 - 4.166666666666656e-03*G6_2_2_8_0_11_4_1 - 4.166666666666657e-03*G6_2_2_8_0_11_4_2 + 4.166666666666654e-03*G6_2_2_8_0_11_5_0 + 4.166666666666656e-03*G6_2_2_8_0_11_6_1 + 4.166666666666656e-03*G6_2_2_8_0_11_7_2 - 8.333333333333309e-03*G6_2_2_8_1_8_4_0 - 8.333333333333311e-03*G6_2_2_8_1_8_4_1 - 8.333333333333312e-03*G6_2_2_8_1_8_4_2 + 8.333333333333309e-03*G6_2_2_8_1_8_5_0 + 8.333333333333311e-03*G6_2_2_8_1_8_6_1 + 8.333333333333311e-03*G6_2_2_8_1_8_7_2 - 4.166666666666654e-03*G6_2_2_8_1_9_4_0 - 4.166666666666654e-03*G6_2_2_8_1_9_4_1 - 4.166666666666655e-03*G6_2_2_8_1_9_4_2 + 4.166666666666654e-03*G6_2_2_8_1_9_5_0 + 4.166666666666654e-03*G6_2_2_8_1_9_6_1 + 4.166666666666654e-03*G6_2_2_8_1_9_7_2 - 4.166666666666654e-03*G6_2_2_8_1_10_4_0 - 4.166666666666654e-03*G6_2_2_8_1_10_4_1 - 4.166666666666654e-03*G6_2_2_8_1_10_4_2 + 4.166666666666654e-03*G6_2_2_8_1_10_5_0 + 4.166666666666654e-03*G6_2_2_8_1_10_6_1 + 4.166666666666654e-03*G6_2_2_8_1_10_7_2 - 4.166666666666656e-03*G6_2_2_8_1_11_4_0 - 4.166666666666657e-03*G6_2_2_8_1_11_4_1 - 4.166666666666657e-03*G6_2_2_8_1_11_4_2 + 4.166666666666656e-03*G6_2_2_8_1_11_5_0 + 4.166666666666657e-03*G6_2_2_8_1_11_6_1 + 4.166666666666657e-03*G6_2_2_8_1_11_7_2 - 8.333333333333311e-03*G6_2_2_8_2_8_4_0 - 8.333333333333312e-03*G6_2_2_8_2_8_4_1 - 8.333333333333314e-03*G6_2_2_8_2_8_4_2 + 8.333333333333311e-03*G6_2_2_8_2_8_5_0 + 8.333333333333312e-03*G6_2_2_8_2_8_6_1 + 8.333333333333312e-03*G6_2_2_8_2_8_7_2 - 4.166666666666654e-03*G6_2_2_8_2_9_4_0 - 4.166666666666655e-03*G6_2_2_8_2_9_4_1 - 4.166666666666655e-03*G6_2_2_8_2_9_4_2 + 4.166666666666654e-03*G6_2_2_8_2_9_5_0 + 4.166666666666655e-03*G6_2_2_8_2_9_6_1 + 4.166666666666655e-03*G6_2_2_8_2_9_7_2 - 4.166666666666654e-03*G6_2_2_8_2_10_4_0 - 4.166666666666654e-03*G6_2_2_8_2_10_4_1 - 4.166666666666654e-03*G6_2_2_8_2_10_4_2 + 4.166666666666654e-03*G6_2_2_8_2_10_5_0 + 4.166666666666654e-03*G6_2_2_8_2_10_6_1 + 4.166666666666654e-03*G6_2_2_8_2_10_7_2 - 4.166666666666657e-03*G6_2_2_8_2_11_4_0 - 4.166666666666657e-03*G6_2_2_8_2_11_4_1 - 4.166666666666658e-03*G6_2_2_8_2_11_4_2 + 4.166666666666657e-03*G6_2_2_8_2_11_5_0 + 4.166666666666657e-03*G6_2_2_8_2_11_6_1 + 4.166666666666657e-03*G6_2_2_8_2_11_7_2 - 4.166666666666654e-03*G6_2_2_9_0_8_4_0 - 4.166666666666654e-03*G6_2_2_9_0_8_4_1 - 4.166666666666654e-03*G6_2_2_9_0_8_4_2 + 4.166666666666654e-03*G6_2_2_9_0_8_5_0 + 4.166666666666654e-03*G6_2_2_9_0_8_6_1 + 4.166666666666654e-03*G6_2_2_9_0_8_7_2 - 8.333333333333307e-03*G6_2_2_9_0_9_4_0 - 8.333333333333309e-03*G6_2_2_9_0_9_4_1 - 8.333333333333309e-03*G6_2_2_9_0_9_4_2 + 8.333333333333307e-03*G6_2_2_9_0_9_5_0 + 8.333333333333309e-03*G6_2_2_9_0_9_6_1 + 8.333333333333309e-03*G6_2_2_9_0_9_7_2 - 4.166666666666654e-03*G6_2_2_9_0_10_4_0 - 4.166666666666655e-03*G6_2_2_9_0_10_4_1 - 4.166666666666655e-03*G6_2_2_9_0_10_4_2 + 4.166666666666654e-03*G6_2_2_9_0_10_5_0 + 4.166666666666655e-03*G6_2_2_9_0_10_6_1 + 4.166666666666655e-03*G6_2_2_9_0_10_7_2 - 4.166666666666655e-03*G6_2_2_9_0_11_4_0 - 4.166666666666656e-03*G6_2_2_9_0_11_4_1 - 4.166666666666656e-03*G6_2_2_9_0_11_4_2 + 4.166666666666655e-03*G6_2_2_9_0_11_5_0 + 4.166666666666656e-03*G6_2_2_9_0_11_6_1 + 4.166666666666656e-03*G6_2_2_9_0_11_7_2 - 4.166666666666654e-03*G6_2_2_9_1_8_4_0 - 4.166666666666654e-03*G6_2_2_9_1_8_4_1 - 4.166666666666655e-03*G6_2_2_9_1_8_4_2 + 4.166666666666654e-03*G6_2_2_9_1_8_5_0 + 4.166666666666654e-03*G6_2_2_9_1_8_6_1 + 4.166666666666654e-03*G6_2_2_9_1_8_7_2 - 8.333333333333309e-03*G6_2_2_9_1_9_4_0 - 8.333333333333309e-03*G6_2_2_9_1_9_4_1 - 8.333333333333309e-03*G6_2_2_9_1_9_4_2 + 8.333333333333309e-03*G6_2_2_9_1_9_5_0 + 8.333333333333309e-03*G6_2_2_9_1_9_6_1 + 8.333333333333309e-03*G6_2_2_9_1_9_7_2 - 4.166666666666655e-03*G6_2_2_9_1_10_4_0 - 4.166666666666656e-03*G6_2_2_9_1_10_4_1 - 4.166666666666656e-03*G6_2_2_9_1_10_4_2 + 4.166666666666655e-03*G6_2_2_9_1_10_5_0 + 4.166666666666656e-03*G6_2_2_9_1_10_6_1 + 4.166666666666656e-03*G6_2_2_9_1_10_7_2 - 4.166666666666656e-03*G6_2_2_9_1_11_4_0 - 4.166666666666657e-03*G6_2_2_9_1_11_4_1 - 4.166666666666657e-03*G6_2_2_9_1_11_4_2 + 4.166666666666656e-03*G6_2_2_9_1_11_5_0 + 4.166666666666657e-03*G6_2_2_9_1_11_6_1 + 4.166666666666657e-03*G6_2_2_9_1_11_7_2 - 4.166666666666654e-03*G6_2_2_9_2_8_4_0 - 4.166666666666655e-03*G6_2_2_9_2_8_4_1 - 4.166666666666655e-03*G6_2_2_9_2_8_4_2 + 4.166666666666654e-03*G6_2_2_9_2_8_5_0 + 4.166666666666655e-03*G6_2_2_9_2_8_6_1 + 4.166666666666655e-03*G6_2_2_9_2_8_7_2 - 8.333333333333309e-03*G6_2_2_9_2_9_4_0 - 8.333333333333309e-03*G6_2_2_9_2_9_4_1 - 8.333333333333309e-03*G6_2_2_9_2_9_4_2 + 8.333333333333309e-03*G6_2_2_9_2_9_5_0 + 8.333333333333309e-03*G6_2_2_9_2_9_6_1 + 8.333333333333309e-03*G6_2_2_9_2_9_7_2 - 4.166666666666655e-03*G6_2_2_9_2_10_4_0 - 4.166666666666656e-03*G6_2_2_9_2_10_4_1 - 4.166666666666656e-03*G6_2_2_9_2_10_4_2 + 4.166666666666655e-03*G6_2_2_9_2_10_5_0 + 4.166666666666656e-03*G6_2_2_9_2_10_6_1 + 4.166666666666656e-03*G6_2_2_9_2_10_7_2 - 4.166666666666656e-03*G6_2_2_9_2_11_4_0 - 4.166666666666657e-03*G6_2_2_9_2_11_4_1 - 4.166666666666657e-03*G6_2_2_9_2_11_4_2 + 4.166666666666656e-03*G6_2_2_9_2_11_5_0 + 4.166666666666657e-03*G6_2_2_9_2_11_6_1 + 4.166666666666657e-03*G6_2_2_9_2_11_7_2 - 4.166666666666653e-03*G6_2_2_10_0_8_4_0 - 4.166666666666654e-03*G6_2_2_10_0_8_4_1 - 4.166666666666654e-03*G6_2_2_10_0_8_4_2 + 4.166666666666653e-03*G6_2_2_10_0_8_5_0 + 4.166666666666654e-03*G6_2_2_10_0_8_6_1 + 4.166666666666654e-03*G6_2_2_10_0_8_7_2 - 4.166666666666654e-03*G6_2_2_10_0_9_4_0 - 4.166666666666655e-03*G6_2_2_10_0_9_4_1 - 4.166666666666655e-03*G6_2_2_10_0_9_4_2 + 4.166666666666654e-03*G6_2_2_10_0_9_5_0 + 4.166666666666655e-03*G6_2_2_10_0_9_6_1 + 4.166666666666655e-03*G6_2_2_10_0_9_7_2 - 8.333333333333309e-03*G6_2_2_10_0_10_4_0 - 8.333333333333309e-03*G6_2_2_10_0_10_4_1 - 8.333333333333311e-03*G6_2_2_10_0_10_4_2 + 8.333333333333309e-03*G6_2_2_10_0_10_5_0 + 8.333333333333309e-03*G6_2_2_10_0_10_6_1 + 8.333333333333309e-03*G6_2_2_10_0_10_7_2 - 4.166666666666654e-03*G6_2_2_10_0_11_4_0 - 4.166666666666655e-03*G6_2_2_10_0_11_4_1 - 4.166666666666655e-03*G6_2_2_10_0_11_4_2 + 4.166666666666654e-03*G6_2_2_10_0_11_5_0 + 4.166666666666655e-03*G6_2_2_10_0_11_6_1 + 4.166666666666655e-03*G6_2_2_10_0_11_7_2 - 4.166666666666654e-03*G6_2_2_10_1_8_4_0 - 4.166666666666654e-03*G6_2_2_10_1_8_4_1 - 4.166666666666654e-03*G6_2_2_10_1_8_4_2 + 4.166666666666654e-03*G6_2_2_10_1_8_5_0 + 4.166666666666654e-03*G6_2_2_10_1_8_6_1 + 4.166666666666654e-03*G6_2_2_10_1_8_7_2 - 4.166666666666655e-03*G6_2_2_10_1_9_4_0 - 4.166666666666656e-03*G6_2_2_10_1_9_4_1 - 4.166666666666656e-03*G6_2_2_10_1_9_4_2 + 4.166666666666655e-03*G6_2_2_10_1_9_5_0 + 4.166666666666656e-03*G6_2_2_10_1_9_6_1 + 4.166666666666656e-03*G6_2_2_10_1_9_7_2 - 8.333333333333311e-03*G6_2_2_10_1_10_4_0 - 8.333333333333311e-03*G6_2_2_10_1_10_4_1 - 8.333333333333312e-03*G6_2_2_10_1_10_4_2 + 8.333333333333311e-03*G6_2_2_10_1_10_5_0 + 8.333333333333311e-03*G6_2_2_10_1_10_6_1 + 8.333333333333311e-03*G6_2_2_10_1_10_7_2 - 4.166666666666655e-03*G6_2_2_10_1_11_4_0 - 4.166666666666656e-03*G6_2_2_10_1_11_4_1 - 4.166666666666657e-03*G6_2_2_10_1_11_4_2 + 4.166666666666655e-03*G6_2_2_10_1_11_5_0 + 4.166666666666656e-03*G6_2_2_10_1_11_6_1 + 4.166666666666656e-03*G6_2_2_10_1_11_7_2 - 4.166666666666654e-03*G6_2_2_10_2_8_4_0 - 4.166666666666654e-03*G6_2_2_10_2_8_4_1 - 4.166666666666654e-03*G6_2_2_10_2_8_4_2 + 4.166666666666654e-03*G6_2_2_10_2_8_5_0 + 4.166666666666654e-03*G6_2_2_10_2_8_6_1 + 4.166666666666654e-03*G6_2_2_10_2_8_7_2 - 4.166666666666655e-03*G6_2_2_10_2_9_4_0 - 4.166666666666656e-03*G6_2_2_10_2_9_4_1 - 4.166666666666656e-03*G6_2_2_10_2_9_4_2 + 4.166666666666655e-03*G6_2_2_10_2_9_5_0 + 4.166666666666656e-03*G6_2_2_10_2_9_6_1 + 4.166666666666656e-03*G6_2_2_10_2_9_7_2 - 8.333333333333311e-03*G6_2_2_10_2_10_4_0 - 8.333333333333312e-03*G6_2_2_10_2_10_4_1 - 8.333333333333312e-03*G6_2_2_10_2_10_4_2 + 8.333333333333311e-03*G6_2_2_10_2_10_5_0 + 8.333333333333312e-03*G6_2_2_10_2_10_6_1 + 8.333333333333312e-03*G6_2_2_10_2_10_7_2 - 4.166666666666655e-03*G6_2_2_10_2_11_4_0 - 4.166666666666657e-03*G6_2_2_10_2_11_4_1 - 4.166666666666657e-03*G6_2_2_10_2_11_4_2 + 4.166666666666655e-03*G6_2_2_10_2_11_5_0 + 4.166666666666657e-03*G6_2_2_10_2_11_6_1 + 4.166666666666657e-03*G6_2_2_10_2_11_7_2 - 4.166666666666655e-03*G6_2_2_11_0_8_4_0 - 4.166666666666656e-03*G6_2_2_11_0_8_4_1 - 4.166666666666657e-03*G6_2_2_11_0_8_4_2 + 4.166666666666655e-03*G6_2_2_11_0_8_5_0 + 4.166666666666656e-03*G6_2_2_11_0_8_6_1 + 4.166666666666656e-03*G6_2_2_11_0_8_7_2 - 4.166666666666655e-03*G6_2_2_11_0_9_4_0 - 4.166666666666656e-03*G6_2_2_11_0_9_4_1 - 4.166666666666656e-03*G6_2_2_11_0_9_4_2 + 4.166666666666655e-03*G6_2_2_11_0_9_5_0 + 4.166666666666656e-03*G6_2_2_11_0_9_6_1 + 4.166666666666656e-03*G6_2_2_11_0_9_7_2 - 4.166666666666655e-03*G6_2_2_11_0_10_4_0 - 4.166666666666655e-03*G6_2_2_11_0_10_4_1 - 4.166666666666655e-03*G6_2_2_11_0_10_4_2 + 4.166666666666655e-03*G6_2_2_11_0_10_5_0 + 4.166666666666655e-03*G6_2_2_11_0_10_6_1 + 4.166666666666655e-03*G6_2_2_11_0_10_7_2 - 8.333333333333309e-03*G6_2_2_11_0_11_4_0 - 8.333333333333311e-03*G6_2_2_11_0_11_4_1 - 8.333333333333311e-03*G6_2_2_11_0_11_4_2 + 8.333333333333309e-03*G6_2_2_11_0_11_5_0 + 8.333333333333311e-03*G6_2_2_11_0_11_6_1 + 8.333333333333311e-03*G6_2_2_11_0_11_7_2 - 4.166666666666656e-03*G6_2_2_11_1_8_4_0 - 4.166666666666657e-03*G6_2_2_11_1_8_4_1 - 4.166666666666657e-03*G6_2_2_11_1_8_4_2 + 4.166666666666656e-03*G6_2_2_11_1_8_5_0 + 4.166666666666657e-03*G6_2_2_11_1_8_6_1 + 4.166666666666657e-03*G6_2_2_11_1_8_7_2 - 4.166666666666656e-03*G6_2_2_11_1_9_4_0 - 4.166666666666657e-03*G6_2_2_11_1_9_4_1 - 4.166666666666657e-03*G6_2_2_11_1_9_4_2 + 4.166666666666656e-03*G6_2_2_11_1_9_5_0 + 4.166666666666657e-03*G6_2_2_11_1_9_6_1 + 4.166666666666657e-03*G6_2_2_11_1_9_7_2 - 4.166666666666655e-03*G6_2_2_11_1_10_4_0 - 4.166666666666656e-03*G6_2_2_11_1_10_4_1 - 4.166666666666657e-03*G6_2_2_11_1_10_4_2 + 4.166666666666655e-03*G6_2_2_11_1_10_5_0 + 4.166666666666656e-03*G6_2_2_11_1_10_6_1 + 4.166666666666656e-03*G6_2_2_11_1_10_7_2 - 8.333333333333311e-03*G6_2_2_11_1_11_4_0 - 8.333333333333311e-03*G6_2_2_11_1_11_4_1 - 8.333333333333312e-03*G6_2_2_11_1_11_4_2 + 8.333333333333311e-03*G6_2_2_11_1_11_5_0 + 8.333333333333311e-03*G6_2_2_11_1_11_6_1 + 8.333333333333311e-03*G6_2_2_11_1_11_7_2 - 4.166666666666657e-03*G6_2_2_11_2_8_4_0 - 4.166666666666657e-03*G6_2_2_11_2_8_4_1 - 4.166666666666658e-03*G6_2_2_11_2_8_4_2 + 4.166666666666657e-03*G6_2_2_11_2_8_5_0 + 4.166666666666657e-03*G6_2_2_11_2_8_6_1 + 4.166666666666657e-03*G6_2_2_11_2_8_7_2 - 4.166666666666656e-03*G6_2_2_11_2_9_4_0 - 4.166666666666657e-03*G6_2_2_11_2_9_4_1 - 4.166666666666657e-03*G6_2_2_11_2_9_4_2 + 4.166666666666656e-03*G6_2_2_11_2_9_5_0 + 4.166666666666657e-03*G6_2_2_11_2_9_6_1 + 4.166666666666657e-03*G6_2_2_11_2_9_7_2 - 4.166666666666655e-03*G6_2_2_11_2_10_4_0 - 4.166666666666657e-03*G6_2_2_11_2_10_4_1 - 4.166666666666657e-03*G6_2_2_11_2_10_4_2 + 4.166666666666655e-03*G6_2_2_11_2_10_5_0 + 4.166666666666657e-03*G6_2_2_11_2_10_6_1 + 4.166666666666657e-03*G6_2_2_11_2_10_7_2 - 8.333333333333311e-03*G6_2_2_11_2_11_4_0 - 8.333333333333312e-03*G6_2_2_11_2_11_4_1 - 8.333333333333312e-03*G6_2_2_11_2_11_4_2 + 8.333333333333311e-03*G6_2_2_11_2_11_5_0 + 8.333333333333312e-03*G6_2_2_11_2_11_6_1 + 8.333333333333312e-03*G6_2_2_11_2_11_7_2 - 4.166666666666661e-02*G7_1_0_0_0_0_0 - 4.166666666666662e-02*G7_1_0_0_0_0_1 - 4.166666666666662e-02*G7_1_0_0_0_0_2 + 4.166666666666661e-02*G7_1_0_0_0_1_0 + 4.166666666666662e-02*G7_1_0_0_0_2_1 + 4.166666666666662e-02*G7_1_0_0_0_3_2 - 4.166666666666662e-02*G7_1_0_0_1_0_0 - 4.166666666666662e-02*G7_1_0_0_1_0_1 - 4.166666666666662e-02*G7_1_0_0_1_0_2 + 4.166666666666662e-02*G7_1_0_0_1_1_0 + 4.166666666666662e-02*G7_1_0_0_1_2_1 + 4.166666666666662e-02*G7_1_0_0_1_3_2 - 4.166666666666662e-02*G7_1_0_0_2_0_0 - 4.166666666666662e-02*G7_1_0_0_2_0_1 - 4.166666666666662e-02*G7_1_0_0_2_0_2 + 4.166666666666662e-02*G7_1_0_0_2_1_0 + 4.166666666666662e-02*G7_1_0_0_2_2_1 + 4.166666666666662e-02*G7_1_0_0_2_3_2 - 4.166666666666659e-02*G7_1_0_1_0_0_0 - 4.166666666666660e-02*G7_1_0_1_0_0_1 - 4.166666666666660e-02*G7_1_0_1_0_0_2 + 4.166666666666659e-02*G7_1_0_1_0_1_0 + 4.166666666666660e-02*G7_1_0_1_0_2_1 + 4.166666666666660e-02*G7_1_0_1_0_3_2 - 4.166666666666660e-02*G7_1_0_1_1_0_0 - 4.166666666666661e-02*G7_1_0_1_1_0_1 - 4.166666666666661e-02*G7_1_0_1_1_0_2 + 4.166666666666660e-02*G7_1_0_1_1_1_0 + 4.166666666666661e-02*G7_1_0_1_1_2_1 + 4.166666666666661e-02*G7_1_0_1_1_3_2 - 4.166666666666660e-02*G7_1_0_1_2_0_0 - 4.166666666666661e-02*G7_1_0_1_2_0_1 - 4.166666666666661e-02*G7_1_0_1_2_0_2 + 4.166666666666660e-02*G7_1_0_1_2_1_0 + 4.166666666666661e-02*G7_1_0_1_2_2_1 + 4.166666666666661e-02*G7_1_0_1_2_3_2 - 4.166666666666660e-02*G7_1_0_2_0_0_0 - 4.166666666666661e-02*G7_1_0_2_0_0_1 - 4.166666666666661e-02*G7_1_0_2_0_0_2 + 4.166666666666660e-02*G7_1_0_2_0_1_0 + 4.166666666666661e-02*G7_1_0_2_0_2_1 + 4.166666666666661e-02*G7_1_0_2_0_3_2 - 4.166666666666661e-02*G7_1_0_2_1_0_0 - 4.166666666666662e-02*G7_1_0_2_1_0_1 - 4.166666666666662e-02*G7_1_0_2_1_0_2 + 4.166666666666661e-02*G7_1_0_2_1_1_0 + 4.166666666666662e-02*G7_1_0_2_1_2_1 + 4.166666666666662e-02*G7_1_0_2_1_3_2 - 4.166666666666661e-02*G7_1_0_2_2_0_0 - 4.166666666666662e-02*G7_1_0_2_2_0_1 - 4.166666666666662e-02*G7_1_0_2_2_0_2 + 4.166666666666661e-02*G7_1_0_2_2_1_0 + 4.166666666666662e-02*G7_1_0_2_2_2_1 + 4.166666666666662e-02*G7_1_0_2_2_3_2 - 4.166666666666660e-02*G7_1_0_3_0_0_0 - 4.166666666666661e-02*G7_1_0_3_0_0_1 - 4.166666666666661e-02*G7_1_0_3_0_0_2 + 4.166666666666660e-02*G7_1_0_3_0_1_0 + 4.166666666666661e-02*G7_1_0_3_0_2_1 + 4.166666666666661e-02*G7_1_0_3_0_3_2 - 4.166666666666661e-02*G7_1_0_3_1_0_0 - 4.166666666666662e-02*G7_1_0_3_1_0_1 - 4.166666666666662e-02*G7_1_0_3_1_0_2 + 4.166666666666661e-02*G7_1_0_3_1_1_0 + 4.166666666666662e-02*G7_1_0_3_1_2_1 + 4.166666666666662e-02*G7_1_0_3_1_3_2 - 4.166666666666661e-02*G7_1_0_3_2_0_0 - 4.166666666666662e-02*G7_1_0_3_2_0_1 - 4.166666666666662e-02*G7_1_0_3_2_0_2 + 4.166666666666661e-02*G7_1_0_3_2_1_0 + 4.166666666666662e-02*G7_1_0_3_2_2_1 + 4.166666666666662e-02*G7_1_0_3_2_3_2 - 4.166666666666660e-02*G7_1_1_4_0_0_0 - 4.166666666666661e-02*G7_1_1_4_0_0_1 - 4.166666666666661e-02*G7_1_1_4_0_0_2 + 4.166666666666660e-02*G7_1_1_4_0_1_0 + 4.166666666666661e-02*G7_1_1_4_0_2_1 + 4.166666666666661e-02*G7_1_1_4_0_3_2 - 4.166666666666661e-02*G7_1_1_4_1_0_0 - 4.166666666666662e-02*G7_1_1_4_1_0_1 - 4.166666666666662e-02*G7_1_1_4_1_0_2 + 4.166666666666661e-02*G7_1_1_4_1_1_0 + 4.166666666666662e-02*G7_1_1_4_1_2_1 + 4.166666666666662e-02*G7_1_1_4_1_3_2 - 4.166666666666661e-02*G7_1_1_4_2_0_0 - 4.166666666666662e-02*G7_1_1_4_2_0_1 - 4.166666666666662e-02*G7_1_1_4_2_0_2 + 4.166666666666661e-02*G7_1_1_4_2_1_0 + 4.166666666666662e-02*G7_1_1_4_2_2_1 + 4.166666666666662e-02*G7_1_1_4_2_3_2 - 4.166666666666660e-02*G7_1_1_5_0_0_0 - 4.166666666666661e-02*G7_1_1_5_0_0_1 - 4.166666666666661e-02*G7_1_1_5_0_0_2 + 4.166666666666660e-02*G7_1_1_5_0_1_0 + 4.166666666666661e-02*G7_1_1_5_0_2_1 + 4.166666666666661e-02*G7_1_1_5_0_3_2 - 4.166666666666661e-02*G7_1_1_5_1_0_0 - 4.166666666666662e-02*G7_1_1_5_1_0_1 - 4.166666666666662e-02*G7_1_1_5_1_0_2 + 4.166666666666661e-02*G7_1_1_5_1_1_0 + 4.166666666666662e-02*G7_1_1_5_1_2_1 + 4.166666666666662e-02*G7_1_1_5_1_3_2 - 4.166666666666661e-02*G7_1_1_5_2_0_0 - 4.166666666666662e-02*G7_1_1_5_2_0_1 - 4.166666666666662e-02*G7_1_1_5_2_0_2 + 4.166666666666661e-02*G7_1_1_5_2_1_0 + 4.166666666666662e-02*G7_1_1_5_2_2_1 + 4.166666666666662e-02*G7_1_1_5_2_3_2 - 4.166666666666660e-02*G7_1_1_6_0_0_0 - 4.166666666666661e-02*G7_1_1_6_0_0_1 - 4.166666666666661e-02*G7_1_1_6_0_0_2 + 4.166666666666660e-02*G7_1_1_6_0_1_0 + 4.166666666666661e-02*G7_1_1_6_0_2_1 + 4.166666666666661e-02*G7_1_1_6_0_3_2 - 4.166666666666661e-02*G7_1_1_6_1_0_0 - 4.166666666666662e-02*G7_1_1_6_1_0_1 - 4.166666666666662e-02*G7_1_1_6_1_0_2 + 4.166666666666661e-02*G7_1_1_6_1_1_0 + 4.166666666666662e-02*G7_1_1_6_1_2_1 + 4.166666666666662e-02*G7_1_1_6_1_3_2 - 4.166666666666661e-02*G7_1_1_6_2_0_0 - 4.166666666666662e-02*G7_1_1_6_2_0_1 - 4.166666666666662e-02*G7_1_1_6_2_0_2 + 4.166666666666661e-02*G7_1_1_6_2_1_0 + 4.166666666666662e-02*G7_1_1_6_2_2_1 + 4.166666666666662e-02*G7_1_1_6_2_3_2 - 4.166666666666660e-02*G7_1_1_7_0_0_0 - 4.166666666666661e-02*G7_1_1_7_0_0_1 - 4.166666666666661e-02*G7_1_1_7_0_0_2 + 4.166666666666660e-02*G7_1_1_7_0_1_0 + 4.166666666666661e-02*G7_1_1_7_0_2_1 + 4.166666666666661e-02*G7_1_1_7_0_3_2 - 4.166666666666661e-02*G7_1_1_7_1_0_0 - 4.166666666666662e-02*G7_1_1_7_1_0_1 - 4.166666666666662e-02*G7_1_1_7_1_0_2 + 4.166666666666661e-02*G7_1_1_7_1_1_0 + 4.166666666666662e-02*G7_1_1_7_1_2_1 + 4.166666666666662e-02*G7_1_1_7_1_3_2 - 4.166666666666661e-02*G7_1_1_7_2_0_0 - 4.166666666666662e-02*G7_1_1_7_2_0_1 - 4.166666666666662e-02*G7_1_1_7_2_0_2 + 4.166666666666661e-02*G7_1_1_7_2_1_0 + 4.166666666666662e-02*G7_1_1_7_2_2_1 + 4.166666666666662e-02*G7_1_1_7_2_3_2 - 4.166666666666660e-02*G7_1_2_8_0_0_0 - 4.166666666666661e-02*G7_1_2_8_0_0_1 - 4.166666666666661e-02*G7_1_2_8_0_0_2 + 4.166666666666660e-02*G7_1_2_8_0_1_0 + 4.166666666666661e-02*G7_1_2_8_0_2_1 + 4.166666666666661e-02*G7_1_2_8_0_3_2 - 4.166666666666661e-02*G7_1_2_8_1_0_0 - 4.166666666666662e-02*G7_1_2_8_1_0_1 - 4.166666666666662e-02*G7_1_2_8_1_0_2 + 4.166666666666661e-02*G7_1_2_8_1_1_0 + 4.166666666666662e-02*G7_1_2_8_1_2_1 + 4.166666666666662e-02*G7_1_2_8_1_3_2 - 4.166666666666661e-02*G7_1_2_8_2_0_0 - 4.166666666666662e-02*G7_1_2_8_2_0_1 - 4.166666666666662e-02*G7_1_2_8_2_0_2 + 4.166666666666661e-02*G7_1_2_8_2_1_0 + 4.166666666666662e-02*G7_1_2_8_2_2_1 + 4.166666666666662e-02*G7_1_2_8_2_3_2 - 4.166666666666660e-02*G7_1_2_9_0_0_0 - 4.166666666666661e-02*G7_1_2_9_0_0_1 - 4.166666666666661e-02*G7_1_2_9_0_0_2 + 4.166666666666660e-02*G7_1_2_9_0_1_0 + 4.166666666666661e-02*G7_1_2_9_0_2_1 + 4.166666666666661e-02*G7_1_2_9_0_3_2 - 4.166666666666661e-02*G7_1_2_9_1_0_0 - 4.166666666666662e-02*G7_1_2_9_1_0_1 - 4.166666666666662e-02*G7_1_2_9_1_0_2 + 4.166666666666661e-02*G7_1_2_9_1_1_0 + 4.166666666666662e-02*G7_1_2_9_1_2_1 + 4.166666666666662e-02*G7_1_2_9_1_3_2 - 4.166666666666661e-02*G7_1_2_9_2_0_0 - 4.166666666666662e-02*G7_1_2_9_2_0_1 - 4.166666666666662e-02*G7_1_2_9_2_0_2 + 4.166666666666661e-02*G7_1_2_9_2_1_0 + 4.166666666666662e-02*G7_1_2_9_2_2_1 + 4.166666666666662e-02*G7_1_2_9_2_3_2 - 4.166666666666660e-02*G7_1_2_10_0_0_0 - 4.166666666666661e-02*G7_1_2_10_0_0_1 - 4.166666666666661e-02*G7_1_2_10_0_0_2 + 4.166666666666660e-02*G7_1_2_10_0_1_0 + 4.166666666666661e-02*G7_1_2_10_0_2_1 + 4.166666666666661e-02*G7_1_2_10_0_3_2 - 4.166666666666661e-02*G7_1_2_10_1_0_0 - 4.166666666666662e-02*G7_1_2_10_1_0_1 - 4.166666666666662e-02*G7_1_2_10_1_0_2 + 4.166666666666661e-02*G7_1_2_10_1_1_0 + 4.166666666666662e-02*G7_1_2_10_1_2_1 + 4.166666666666662e-02*G7_1_2_10_1_3_2 - 4.166666666666661e-02*G7_1_2_10_2_0_0 - 4.166666666666662e-02*G7_1_2_10_2_0_1 - 4.166666666666662e-02*G7_1_2_10_2_0_2 + 4.166666666666661e-02*G7_1_2_10_2_1_0 + 4.166666666666662e-02*G7_1_2_10_2_2_1 + 4.166666666666662e-02*G7_1_2_10_2_3_2 - 4.166666666666660e-02*G7_1_2_11_0_0_0 - 4.166666666666661e-02*G7_1_2_11_0_0_1 - 4.166666666666661e-02*G7_1_2_11_0_0_2 + 4.166666666666660e-02*G7_1_2_11_0_1_0 + 4.166666666666661e-02*G7_1_2_11_0_2_1 + 4.166666666666661e-02*G7_1_2_11_0_3_2 - 4.166666666666661e-02*G7_1_2_11_1_0_0 - 4.166666666666662e-02*G7_1_2_11_1_0_1 - 4.166666666666662e-02*G7_1_2_11_1_0_2 + 4.166666666666661e-02*G7_1_2_11_1_1_0 + 4.166666666666662e-02*G7_1_2_11_1_2_1 + 4.166666666666662e-02*G7_1_2_11_1_3_2 - 4.166666666666661e-02*G7_1_2_11_2_0_0 - 4.166666666666662e-02*G7_1_2_11_2_0_1 - 4.166666666666662e-02*G7_1_2_11_2_0_2 + 4.166666666666661e-02*G7_1_2_11_2_1_0 + 4.166666666666662e-02*G7_1_2_11_2_2_1 + 4.166666666666662e-02*G7_1_2_11_2_3_2 - 8.333333333333320e-02*G8_1_0_0_0_0 - 8.333333333333322e-02*G8_1_0_0_0_1 - 8.333333333333320e-02*G8_1_0_0_0_2 + 8.333333333333320e-02*G8_1_0_0_1_0 + 8.333333333333322e-02*G8_1_0_0_2_1 + 8.333333333333322e-02*G8_1_0_0_3_2 - 8.333333333333322e-02*G8_1_0_1_0_0 - 8.333333333333323e-02*G8_1_0_1_0_1 - 8.333333333333322e-02*G8_1_0_1_0_2 + 8.333333333333322e-02*G8_1_0_1_1_0 + 8.333333333333323e-02*G8_1_0_1_2_1 + 8.333333333333323e-02*G8_1_0_1_3_2 - 8.333333333333322e-02*G8_1_0_2_0_0 - 8.333333333333323e-02*G8_1_0_2_0_1 - 8.333333333333322e-02*G8_1_0_2_0_2 + 8.333333333333322e-02*G8_1_0_2_1_0 + 8.333333333333323e-02*G8_1_0_2_2_1 + 8.333333333333323e-02*G8_1_0_2_3_2 - 8.333333333333320e-02*G8_1_1_0_4_0 - 8.333333333333322e-02*G8_1_1_0_4_1 - 8.333333333333322e-02*G8_1_1_0_4_2 + 8.333333333333320e-02*G8_1_1_0_5_0 + 8.333333333333322e-02*G8_1_1_0_6_1 + 8.333333333333322e-02*G8_1_1_0_7_2 - 8.333333333333322e-02*G8_1_1_1_4_0 - 8.333333333333323e-02*G8_1_1_1_4_1 - 8.333333333333323e-02*G8_1_1_1_4_2 + 8.333333333333322e-02*G8_1_1_1_5_0 + 8.333333333333323e-02*G8_1_1_1_6_1 + 8.333333333333323e-02*G8_1_1_1_7_2 - 8.333333333333322e-02*G8_1_1_2_4_0 - 8.333333333333323e-02*G8_1_1_2_4_1 - 8.333333333333323e-02*G8_1_1_2_4_2 + 8.333333333333322e-02*G8_1_1_2_5_0 + 8.333333333333323e-02*G8_1_1_2_6_1 + 8.333333333333323e-02*G8_1_1_2_7_2 - 8.333333333333320e-02*G8_1_2_0_8_0 - 8.333333333333322e-02*G8_1_2_0_8_1 - 8.333333333333322e-02*G8_1_2_0_8_2 + 8.333333333333320e-02*G8_1_2_0_9_0 + 8.333333333333322e-02*G8_1_2_0_10_1 + 8.333333333333322e-02*G8_1_2_0_11_2 - 8.333333333333322e-02*G8_1_2_1_8_0 - 8.333333333333323e-02*G8_1_2_1_8_1 - 8.333333333333323e-02*G8_1_2_1_8_2 + 8.333333333333322e-02*G8_1_2_1_9_0 + 8.333333333333323e-02*G8_1_2_1_10_1 + 8.333333333333323e-02*G8_1_2_1_11_2 - 8.333333333333322e-02*G8_1_2_2_8_0 - 8.333333333333323e-02*G8_1_2_2_8_1 - 8.333333333333323e-02*G8_1_2_2_8_2 + 8.333333333333322e-02*G8_1_2_2_9_0 + 8.333333333333323e-02*G8_1_2_2_10_1 + 8.333333333333323e-02*G8_1_2_2_11_2;
    block[5] = 8.333333333333309e-03*G0_4 + 1.666666666666662e-02*G0_5 + 8.333333333333312e-03*G0_6 + 8.333333333333314e-03*G0_7 + 8.333333333333309e-03*G1_4 + 1.666666666666662e-02*G1_5 + 8.333333333333312e-03*G1_6 + 8.333333333333314e-03*G1_7 + 4.166666666666661e-02*G2_1_0_0 + 4.166666666666661e-02*G2_1_0_1 + 4.166666666666661e-02*G2_1_0_2 + 4.166666666666661e-02*G2_1_0_3 + 1.666666666666662e-02*G3_0_0_0_4 + 8.333333333333311e-03*G3_0_0_0_5 + 8.333333333333309e-03*G3_0_0_0_6 + 8.333333333333312e-03*G3_0_0_0_7 + 8.333333333333307e-03*G3_0_1_0_4 + 1.666666666666662e-02*G3_0_1_0_5 + 8.333333333333309e-03*G3_0_1_0_6 + 8.333333333333311e-03*G3_0_1_0_7 + 8.333333333333307e-03*G3_0_2_0_4 + 8.333333333333311e-03*G3_0_2_0_5 + 1.666666666666662e-02*G3_0_2_0_6 + 8.333333333333311e-03*G3_0_2_0_7 + 8.333333333333312e-03*G3_0_3_0_4 + 8.333333333333312e-03*G3_0_3_0_5 + 8.333333333333311e-03*G3_0_3_0_6 + 1.666666666666662e-02*G3_0_3_0_7 + 1.666666666666662e-02*G3_1_4_0_4 + 8.333333333333309e-03*G3_1_4_0_5 + 8.333333333333307e-03*G3_1_4_0_6 + 8.333333333333312e-03*G3_1_4_0_7 + 8.333333333333309e-03*G3_1_5_0_4 + 1.666666666666662e-02*G3_1_5_0_5 + 8.333333333333311e-03*G3_1_5_0_6 + 8.333333333333312e-03*G3_1_5_0_7 + 8.333333333333307e-03*G3_1_6_0_4 + 8.333333333333311e-03*G3_1_6_0_5 + 1.666666666666662e-02*G3_1_6_0_6 + 8.333333333333311e-03*G3_1_6_0_7 + 8.333333333333312e-03*G3_1_7_0_4 + 8.333333333333312e-03*G3_1_7_0_5 + 8.333333333333311e-03*G3_1_7_0_6 + 1.666666666666662e-02*G3_1_7_0_7 + 1.666666666666662e-02*G3_2_8_0_4 + 8.333333333333309e-03*G3_2_8_0_5 + 8.333333333333307e-03*G3_2_8_0_6 + 8.333333333333312e-03*G3_2_8_0_7 + 8.333333333333309e-03*G3_2_9_0_4 + 1.666666666666662e-02*G3_2_9_0_5 + 8.333333333333311e-03*G3_2_9_0_6 + 8.333333333333312e-03*G3_2_9_0_7 + 8.333333333333307e-03*G3_2_10_0_4 + 8.333333333333311e-03*G3_2_10_0_5 + 1.666666666666662e-02*G3_2_10_0_6 + 8.333333333333311e-03*G3_2_10_0_7 + 8.333333333333312e-03*G3_2_11_0_4 + 8.333333333333312e-03*G3_2_11_0_5 + 8.333333333333311e-03*G3_2_11_0_6 + 1.666666666666662e-02*G3_2_11_0_7 + 8.333333333333320e-02*G4_0_4_0 + 8.333333333333322e-02*G4_0_4_1 + 8.333333333333322e-02*G4_0_4_2 - 8.333333333333320e-02*G4_0_5_0 - 8.333333333333322e-02*G4_0_6_1 - 8.333333333333322e-02*G4_0_7_2 + 4.166666666666655e-03*G5_0_0_4_0 + 4.166666666666655e-03*G5_0_0_4_1 + 4.166666666666656e-03*G5_0_0_4_2 - 4.166666666666655e-03*G5_0_0_5_0 - 4.166666666666655e-03*G5_0_0_6_1 - 4.166666666666655e-03*G5_0_0_7_2 + 8.333333333333309e-03*G5_0_1_4_0 + 8.333333333333309e-03*G5_0_1_4_1 + 8.333333333333309e-03*G5_0_1_4_2 - 8.333333333333309e-03*G5_0_1_5_0 - 8.333333333333309e-03*G5_0_1_6_1 - 8.333333333333309e-03*G5_0_1_7_2 + 4.166666666666655e-03*G5_0_2_4_0 + 4.166666666666656e-03*G5_0_2_4_1 + 4.166666666666656e-03*G5_0_2_4_2 - 4.166666666666655e-03*G5_0_2_5_0 - 4.166666666666656e-03*G5_0_2_6_1 - 4.166666666666656e-03*G5_0_2_7_2 + 4.166666666666656e-03*G5_0_3_4_0 + 4.166666666666657e-03*G5_0_3_4_1 + 4.166666666666657e-03*G5_0_3_4_2 - 4.166666666666656e-03*G5_0_3_5_0 - 4.166666666666657e-03*G5_0_3_6_1 - 4.166666666666657e-03*G5_0_3_7_2 + 4.166666666666654e-03*G5_1_4_4_0 + 4.166666666666654e-03*G5_1_4_4_1 + 4.166666666666655e-03*G5_1_4_4_2 - 4.166666666666654e-03*G5_1_4_5_0 - 4.166666666666654e-03*G5_1_4_6_1 - 4.166666666666654e-03*G5_1_4_7_2 + 8.333333333333309e-03*G5_1_5_4_0 + 8.333333333333309e-03*G5_1_5_4_1 + 8.333333333333309e-03*G5_1_5_4_2 - 8.333333333333309e-03*G5_1_5_5_0 - 8.333333333333309e-03*G5_1_5_6_1 - 8.333333333333309e-03*G5_1_5_7_2 + 4.166666666666655e-03*G5_1_6_4_0 + 4.166666666666656e-03*G5_1_6_4_1 + 4.166666666666656e-03*G5_1_6_4_2 - 4.166666666666655e-03*G5_1_6_5_0 - 4.166666666666656e-03*G5_1_6_6_1 - 4.166666666666656e-03*G5_1_6_7_2 + 4.166666666666656e-03*G5_1_7_4_0 + 4.166666666666657e-03*G5_1_7_4_1 + 4.166666666666657e-03*G5_1_7_4_2 - 4.166666666666656e-03*G5_1_7_5_0 - 4.166666666666657e-03*G5_1_7_6_1 - 4.166666666666657e-03*G5_1_7_7_2 + 4.166666666666654e-03*G5_2_8_4_0 + 4.166666666666654e-03*G5_2_8_4_1 + 4.166666666666655e-03*G5_2_8_4_2 - 4.166666666666654e-03*G5_2_8_5_0 - 4.166666666666654e-03*G5_2_8_6_1 - 4.166666666666654e-03*G5_2_8_7_2 + 8.333333333333309e-03*G5_2_9_4_0 + 8.333333333333309e-03*G5_2_9_4_1 + 8.333333333333309e-03*G5_2_9_4_2 - 8.333333333333309e-03*G5_2_9_5_0 - 8.333333333333309e-03*G5_2_9_6_1 - 8.333333333333309e-03*G5_2_9_7_2 + 4.166666666666655e-03*G5_2_10_4_0 + 4.166666666666656e-03*G5_2_10_4_1 + 4.166666666666656e-03*G5_2_10_4_2 - 4.166666666666655e-03*G5_2_10_5_0 - 4.166666666666656e-03*G5_2_10_6_1 - 4.166666666666656e-03*G5_2_10_7_2 + 4.166666666666656e-03*G5_2_11_4_0 + 4.166666666666657e-03*G5_2_11_4_1 + 4.166666666666657e-03*G5_2_11_4_2 - 4.166666666666656e-03*G5_2_11_5_0 - 4.166666666666657e-03*G5_2_11_6_1 - 4.166666666666657e-03*G5_2_11_7_2 + 8.333333333333309e-03*G6_0_0_0_0_0_4_0 + 8.333333333333309e-03*G6_0_0_0_0_0_4_1 + 8.333333333333312e-03*G6_0_0_0_0_0_4_2 - 8.333333333333309e-03*G6_0_0_0_0_0_5_0 - 8.333333333333309e-03*G6_0_0_0_0_0_6_1 - 8.333333333333309e-03*G6_0_0_0_0_0_7_2 + 4.166666666666654e-03*G6_0_0_0_0_1_4_0 + 4.166666666666654e-03*G6_0_0_0_0_1_4_1 + 4.166666666666655e-03*G6_0_0_0_0_1_4_2 - 4.166666666666654e-03*G6_0_0_0_0_1_5_0 - 4.166666666666654e-03*G6_0_0_0_0_1_6_1 - 4.166666666666654e-03*G6_0_0_0_0_1_7_2 + 4.166666666666654e-03*G6_0_0_0_0_2_4_0 + 4.166666666666654e-03*G6_0_0_0_0_2_4_1 + 4.166666666666656e-03*G6_0_0_0_0_2_4_2 - 4.166666666666654e-03*G6_0_0_0_0_2_5_0 - 4.166666666666654e-03*G6_0_0_0_0_2_6_1 - 4.166666666666654e-03*G6_0_0_0_0_2_7_2 + 4.166666666666656e-03*G6_0_0_0_0_3_4_0 + 4.166666666666656e-03*G6_0_0_0_0_3_4_1 + 4.166666666666657e-03*G6_0_0_0_0_3_4_2 - 4.166666666666656e-03*G6_0_0_0_0_3_5_0 - 4.166666666666656e-03*G6_0_0_0_0_3_6_1 - 4.166666666666656e-03*G6_0_0_0_0_3_7_2 + 4.166666666666654e-03*G6_0_0_1_0_0_4_0 + 4.166666666666654e-03*G6_0_0_1_0_0_4_1 + 4.166666666666655e-03*G6_0_0_1_0_0_4_2 - 4.166666666666654e-03*G6_0_0_1_0_0_5_0 - 4.166666666666654e-03*G6_0_0_1_0_0_6_1 - 4.166666666666654e-03*G6_0_0_1_0_0_7_2 + 8.333333333333307e-03*G6_0_0_1_0_1_4_0 + 8.333333333333307e-03*G6_0_0_1_0_1_4_1 + 8.333333333333307e-03*G6_0_0_1_0_1_4_2 - 8.333333333333307e-03*G6_0_0_1_0_1_5_0 - 8.333333333333307e-03*G6_0_0_1_0_1_6_1 - 8.333333333333307e-03*G6_0_0_1_0_1_7_2 + 4.166666666666654e-03*G6_0_0_1_0_2_4_0 + 4.166666666666654e-03*G6_0_0_1_0_2_4_1 + 4.166666666666654e-03*G6_0_0_1_0_2_4_2 - 4.166666666666654e-03*G6_0_0_1_0_2_5_0 - 4.166666666666654e-03*G6_0_0_1_0_2_6_1 - 4.166666666666654e-03*G6_0_0_1_0_2_7_2 + 4.166666666666654e-03*G6_0_0_1_0_3_4_0 + 4.166666666666655e-03*G6_0_0_1_0_3_4_1 + 4.166666666666655e-03*G6_0_0_1_0_3_4_2 - 4.166666666666654e-03*G6_0_0_1_0_3_5_0 - 4.166666666666655e-03*G6_0_0_1_0_3_6_1 - 4.166666666666655e-03*G6_0_0_1_0_3_7_2 + 4.166666666666654e-03*G6_0_0_2_0_0_4_0 + 4.166666666666654e-03*G6_0_0_2_0_0_4_1 + 4.166666666666655e-03*G6_0_0_2_0_0_4_2 - 4.166666666666654e-03*G6_0_0_2_0_0_5_0 - 4.166666666666654e-03*G6_0_0_2_0_0_6_1 - 4.166666666666654e-03*G6_0_0_2_0_0_7_2 + 4.166666666666654e-03*G6_0_0_2_0_1_4_0 + 4.166666666666654e-03*G6_0_0_2_0_1_4_1 + 4.166666666666654e-03*G6_0_0_2_0_1_4_2 - 4.166666666666654e-03*G6_0_0_2_0_1_5_0 - 4.166666666666654e-03*G6_0_0_2_0_1_6_1 - 4.166666666666654e-03*G6_0_0_2_0_1_7_2 + 8.333333333333309e-03*G6_0_0_2_0_2_4_0 + 8.333333333333309e-03*G6_0_0_2_0_2_4_1 + 8.333333333333311e-03*G6_0_0_2_0_2_4_2 - 8.333333333333309e-03*G6_0_0_2_0_2_5_0 - 8.333333333333309e-03*G6_0_0_2_0_2_6_1 - 8.333333333333309e-03*G6_0_0_2_0_2_7_2 + 4.166666666666654e-03*G6_0_0_2_0_3_4_0 + 4.166666666666655e-03*G6_0_0_2_0_3_4_1 + 4.166666666666655e-03*G6_0_0_2_0_3_4_2 - 4.166666666666654e-03*G6_0_0_2_0_3_5_0 - 4.166666666666655e-03*G6_0_0_2_0_3_6_1 - 4.166666666666655e-03*G6_0_0_2_0_3_7_2 + 4.166666666666656e-03*G6_0_0_3_0_0_4_0 + 4.166666666666656e-03*G6_0_0_3_0_0_4_1 + 4.166666666666657e-03*G6_0_0_3_0_0_4_2 - 4.166666666666656e-03*G6_0_0_3_0_0_5_0 - 4.166666666666656e-03*G6_0_0_3_0_0_6_1 - 4.166666666666656e-03*G6_0_0_3_0_0_7_2 + 4.166666666666654e-03*G6_0_0_3_0_1_4_0 + 4.166666666666655e-03*G6_0_0_3_0_1_4_1 + 4.166666666666655e-03*G6_0_0_3_0_1_4_2 - 4.166666666666654e-03*G6_0_0_3_0_1_5_0 - 4.166666666666655e-03*G6_0_0_3_0_1_6_1 - 4.166666666666655e-03*G6_0_0_3_0_1_7_2 + 4.166666666666655e-03*G6_0_0_3_0_2_4_0 + 4.166666666666655e-03*G6_0_0_3_0_2_4_1 + 4.166666666666655e-03*G6_0_0_3_0_2_4_2 - 4.166666666666655e-03*G6_0_0_3_0_2_5_0 - 4.166666666666655e-03*G6_0_0_3_0_2_6_1 - 4.166666666666655e-03*G6_0_0_3_0_2_7_2 + 8.333333333333309e-03*G6_0_0_3_0_3_4_0 + 8.333333333333311e-03*G6_0_0_3_0_3_4_1 + 8.333333333333311e-03*G6_0_0_3_0_3_4_2 - 8.333333333333309e-03*G6_0_0_3_0_3_5_0 - 8.333333333333311e-03*G6_0_0_3_0_3_6_1 - 8.333333333333311e-03*G6_0_0_3_0_3_7_2 + 8.333333333333309e-03*G6_0_1_0_0_4_4_0 + 8.333333333333309e-03*G6_0_1_0_0_4_4_1 + 8.333333333333311e-03*G6_0_1_0_0_4_4_2 - 8.333333333333309e-03*G6_0_1_0_0_4_5_0 - 8.333333333333309e-03*G6_0_1_0_0_4_6_1 - 8.333333333333309e-03*G6_0_1_0_0_4_7_2 + 4.166666666666654e-03*G6_0_1_0_0_5_4_0 + 4.166666666666655e-03*G6_0_1_0_0_5_4_1 + 4.166666666666655e-03*G6_0_1_0_0_5_4_2 - 4.166666666666654e-03*G6_0_1_0_0_5_5_0 - 4.166666666666655e-03*G6_0_1_0_0_5_6_1 - 4.166666666666655e-03*G6_0_1_0_0_5_7_2 + 4.166666666666654e-03*G6_0_1_0_0_6_4_0 + 4.166666666666654e-03*G6_0_1_0_0_6_4_1 + 4.166666666666656e-03*G6_0_1_0_0_6_4_2 - 4.166666666666654e-03*G6_0_1_0_0_6_5_0 - 4.166666666666654e-03*G6_0_1_0_0_6_6_1 - 4.166666666666654e-03*G6_0_1_0_0_6_7_2 + 4.166666666666656e-03*G6_0_1_0_0_7_4_0 + 4.166666666666656e-03*G6_0_1_0_0_7_4_1 + 4.166666666666657e-03*G6_0_1_0_0_7_4_2 - 4.166666666666656e-03*G6_0_1_0_0_7_5_0 - 4.166666666666656e-03*G6_0_1_0_0_7_6_1 - 4.166666666666656e-03*G6_0_1_0_0_7_7_2 + 4.166666666666654e-03*G6_0_1_1_0_4_4_0 + 4.166666666666654e-03*G6_0_1_1_0_4_4_1 + 4.166666666666654e-03*G6_0_1_1_0_4_4_2 - 4.166666666666654e-03*G6_0_1_1_0_4_5_0 - 4.166666666666654e-03*G6_0_1_1_0_4_6_1 - 4.166666666666654e-03*G6_0_1_1_0_4_7_2 + 8.333333333333307e-03*G6_0_1_1_0_5_4_0 + 8.333333333333309e-03*G6_0_1_1_0_5_4_1 + 8.333333333333309e-03*G6_0_1_1_0_5_4_2 - 8.333333333333307e-03*G6_0_1_1_0_5_5_0 - 8.333333333333309e-03*G6_0_1_1_0_5_6_1 - 8.333333333333309e-03*G6_0_1_1_0_5_7_2 + 4.166666666666654e-03*G6_0_1_1_0_6_4_0 + 4.166666666666654e-03*G6_0_1_1_0_6_4_1 + 4.166666666666654e-03*G6_0_1_1_0_6_4_2 - 4.166666666666654e-03*G6_0_1_1_0_6_5_0 - 4.166666666666654e-03*G6_0_1_1_0_6_6_1 - 4.166666666666654e-03*G6_0_1_1_0_6_7_2 + 4.166666666666654e-03*G6_0_1_1_0_7_4_0 + 4.166666666666655e-03*G6_0_1_1_0_7_4_1 + 4.166666666666655e-03*G6_0_1_1_0_7_4_2 - 4.166666666666654e-03*G6_0_1_1_0_7_5_0 - 4.166666666666655e-03*G6_0_1_1_0_7_6_1 - 4.166666666666655e-03*G6_0_1_1_0_7_7_2 + 4.166666666666653e-03*G6_0_1_2_0_4_4_0 + 4.166666666666654e-03*G6_0_1_2_0_4_4_1 + 4.166666666666654e-03*G6_0_1_2_0_4_4_2 - 4.166666666666653e-03*G6_0_1_2_0_4_5_0 - 4.166666666666654e-03*G6_0_1_2_0_4_6_1 - 4.166666666666654e-03*G6_0_1_2_0_4_7_2 + 4.166666666666654e-03*G6_0_1_2_0_5_4_0 + 4.166666666666655e-03*G6_0_1_2_0_5_4_1 + 4.166666666666655e-03*G6_0_1_2_0_5_4_2 - 4.166666666666654e-03*G6_0_1_2_0_5_5_0 - 4.166666666666655e-03*G6_0_1_2_0_5_6_1 - 4.166666666666655e-03*G6_0_1_2_0_5_7_2 + 8.333333333333309e-03*G6_0_1_2_0_6_4_0 + 8.333333333333309e-03*G6_0_1_2_0_6_4_1 + 8.333333333333311e-03*G6_0_1_2_0_6_4_2 - 8.333333333333309e-03*G6_0_1_2_0_6_5_0 - 8.333333333333309e-03*G6_0_1_2_0_6_6_1 - 8.333333333333309e-03*G6_0_1_2_0_6_7_2 + 4.166666666666654e-03*G6_0_1_2_0_7_4_0 + 4.166666666666655e-03*G6_0_1_2_0_7_4_1 + 4.166666666666655e-03*G6_0_1_2_0_7_4_2 - 4.166666666666654e-03*G6_0_1_2_0_7_5_0 - 4.166666666666655e-03*G6_0_1_2_0_7_6_1 - 4.166666666666655e-03*G6_0_1_2_0_7_7_2 + 4.166666666666655e-03*G6_0_1_3_0_4_4_0 + 4.166666666666656e-03*G6_0_1_3_0_4_4_1 + 4.166666666666657e-03*G6_0_1_3_0_4_4_2 - 4.166666666666655e-03*G6_0_1_3_0_4_5_0 - 4.166666666666656e-03*G6_0_1_3_0_4_6_1 - 4.166666666666656e-03*G6_0_1_3_0_4_7_2 + 4.166666666666655e-03*G6_0_1_3_0_5_4_0 + 4.166666666666656e-03*G6_0_1_3_0_5_4_1 + 4.166666666666656e-03*G6_0_1_3_0_5_4_2 - 4.166666666666655e-03*G6_0_1_3_0_5_5_0 - 4.166666666666656e-03*G6_0_1_3_0_5_6_1 - 4.166666666666656e-03*G6_0_1_3_0_5_7_2 + 4.166666666666655e-03*G6_0_1_3_0_6_4_0 + 4.166666666666655e-03*G6_0_1_3_0_6_4_1 + 4.166666666666655e-03*G6_0_1_3_0_6_4_2 - 4.166666666666655e-03*G6_0_1_3_0_6_5_0 - 4.166666666666655e-03*G6_0_1_3_0_6_6_1 - 4.166666666666655e-03*G6_0_1_3_0_6_7_2 + 8.333333333333309e-03*G6_0_1_3_0_7_4_0 + 8.333333333333311e-03*G6_0_1_3_0_7_4_1 + 8.333333333333311e-03*G6_0_1_3_0_7_4_2 - 8.333333333333309e-03*G6_0_1_3_0_7_5_0 - 8.333333333333311e-03*G6_0_1_3_0_7_6_1 - 8.333333333333311e-03*G6_0_1_3_0_7_7_2 + 8.333333333333309e-03*G6_0_2_0_0_8_4_0 + 8.333333333333309e-03*G6_0_2_0_0_8_4_1 + 8.333333333333311e-03*G6_0_2_0_0_8_4_2 - 8.333333333333309e-03*G6_0_2_0_0_8_5_0 - 8.333333333333309e-03*G6_0_2_0_0_8_6_1 - 8.333333333333309e-03*G6_0_2_0_0_8_7_2 + 4.166666666666654e-03*G6_0_2_0_0_9_4_0 + 4.166666666666655e-03*G6_0_2_0_0_9_4_1 + 4.166666666666655e-03*G6_0_2_0_0_9_4_2 - 4.166666666666654e-03*G6_0_2_0_0_9_5_0 - 4.166666666666655e-03*G6_0_2_0_0_9_6_1 - 4.166666666666655e-03*G6_0_2_0_0_9_7_2 + 4.166666666666654e-03*G6_0_2_0_0_10_4_0 + 4.166666666666654e-03*G6_0_2_0_0_10_4_1 + 4.166666666666656e-03*G6_0_2_0_0_10_4_2 - 4.166666666666654e-03*G6_0_2_0_0_10_5_0 - 4.166666666666654e-03*G6_0_2_0_0_10_6_1 - 4.166666666666654e-03*G6_0_2_0_0_10_7_2 + 4.166666666666656e-03*G6_0_2_0_0_11_4_0 + 4.166666666666656e-03*G6_0_2_0_0_11_4_1 + 4.166666666666657e-03*G6_0_2_0_0_11_4_2 - 4.166666666666656e-03*G6_0_2_0_0_11_5_0 - 4.166666666666656e-03*G6_0_2_0_0_11_6_1 - 4.166666666666656e-03*G6_0_2_0_0_11_7_2 + 4.166666666666654e-03*G6_0_2_1_0_8_4_0 + 4.166666666666654e-03*G6_0_2_1_0_8_4_1 + 4.166666666666654e-03*G6_0_2_1_0_8_4_2 - 4.166666666666654e-03*G6_0_2_1_0_8_5_0 - 4.166666666666654e-03*G6_0_2_1_0_8_6_1 - 4.166666666666654e-03*G6_0_2_1_0_8_7_2 + 8.333333333333307e-03*G6_0_2_1_0_9_4_0 + 8.333333333333309e-03*G6_0_2_1_0_9_4_1 + 8.333333333333309e-03*G6_0_2_1_0_9_4_2 - 8.333333333333307e-03*G6_0_2_1_0_9_5_0 - 8.333333333333309e-03*G6_0_2_1_0_9_6_1 - 8.333333333333309e-03*G6_0_2_1_0_9_7_2 + 4.166666666666654e-03*G6_0_2_1_0_10_4_0 + 4.166666666666654e-03*G6_0_2_1_0_10_4_1 + 4.166666666666654e-03*G6_0_2_1_0_10_4_2 - 4.166666666666654e-03*G6_0_2_1_0_10_5_0 - 4.166666666666654e-03*G6_0_2_1_0_10_6_1 - 4.166666666666654e-03*G6_0_2_1_0_10_7_2 + 4.166666666666654e-03*G6_0_2_1_0_11_4_0 + 4.166666666666655e-03*G6_0_2_1_0_11_4_1 + 4.166666666666655e-03*G6_0_2_1_0_11_4_2 - 4.166666666666654e-03*G6_0_2_1_0_11_5_0 - 4.166666666666655e-03*G6_0_2_1_0_11_6_1 - 4.166666666666655e-03*G6_0_2_1_0_11_7_2 + 4.166666666666653e-03*G6_0_2_2_0_8_4_0 + 4.166666666666654e-03*G6_0_2_2_0_8_4_1 + 4.166666666666654e-03*G6_0_2_2_0_8_4_2 - 4.166666666666653e-03*G6_0_2_2_0_8_5_0 - 4.166666666666654e-03*G6_0_2_2_0_8_6_1 - 4.166666666666654e-03*G6_0_2_2_0_8_7_2 + 4.166666666666654e-03*G6_0_2_2_0_9_4_0 + 4.166666666666655e-03*G6_0_2_2_0_9_4_1 + 4.166666666666655e-03*G6_0_2_2_0_9_4_2 - 4.166666666666654e-03*G6_0_2_2_0_9_5_0 - 4.166666666666655e-03*G6_0_2_2_0_9_6_1 - 4.166666666666655e-03*G6_0_2_2_0_9_7_2 + 8.333333333333309e-03*G6_0_2_2_0_10_4_0 + 8.333333333333309e-03*G6_0_2_2_0_10_4_1 + 8.333333333333311e-03*G6_0_2_2_0_10_4_2 - 8.333333333333309e-03*G6_0_2_2_0_10_5_0 - 8.333333333333309e-03*G6_0_2_2_0_10_6_1 - 8.333333333333309e-03*G6_0_2_2_0_10_7_2 + 4.166666666666654e-03*G6_0_2_2_0_11_4_0 + 4.166666666666655e-03*G6_0_2_2_0_11_4_1 + 4.166666666666655e-03*G6_0_2_2_0_11_4_2 - 4.166666666666654e-03*G6_0_2_2_0_11_5_0 - 4.166666666666655e-03*G6_0_2_2_0_11_6_1 - 4.166666666666655e-03*G6_0_2_2_0_11_7_2 + 4.166666666666655e-03*G6_0_2_3_0_8_4_0 + 4.166666666666656e-03*G6_0_2_3_0_8_4_1 + 4.166666666666657e-03*G6_0_2_3_0_8_4_2 - 4.166666666666655e-03*G6_0_2_3_0_8_5_0 - 4.166666666666656e-03*G6_0_2_3_0_8_6_1 - 4.166666666666656e-03*G6_0_2_3_0_8_7_2 + 4.166666666666655e-03*G6_0_2_3_0_9_4_0 + 4.166666666666656e-03*G6_0_2_3_0_9_4_1 + 4.166666666666656e-03*G6_0_2_3_0_9_4_2 - 4.166666666666655e-03*G6_0_2_3_0_9_5_0 - 4.166666666666656e-03*G6_0_2_3_0_9_6_1 - 4.166666666666656e-03*G6_0_2_3_0_9_7_2 + 4.166666666666655e-03*G6_0_2_3_0_10_4_0 + 4.166666666666655e-03*G6_0_2_3_0_10_4_1 + 4.166666666666655e-03*G6_0_2_3_0_10_4_2 - 4.166666666666655e-03*G6_0_2_3_0_10_5_0 - 4.166666666666655e-03*G6_0_2_3_0_10_6_1 - 4.166666666666655e-03*G6_0_2_3_0_10_7_2 + 8.333333333333309e-03*G6_0_2_3_0_11_4_0 + 8.333333333333311e-03*G6_0_2_3_0_11_4_1 + 8.333333333333311e-03*G6_0_2_3_0_11_4_2 - 8.333333333333309e-03*G6_0_2_3_0_11_5_0 - 8.333333333333311e-03*G6_0_2_3_0_11_6_1 - 8.333333333333311e-03*G6_0_2_3_0_11_7_2 + 8.333333333333309e-03*G6_1_0_4_0_0_4_0 + 8.333333333333309e-03*G6_1_0_4_0_0_4_1 + 8.333333333333311e-03*G6_1_0_4_0_0_4_2 - 8.333333333333309e-03*G6_1_0_4_0_0_5_0 - 8.333333333333309e-03*G6_1_0_4_0_0_6_1 - 8.333333333333309e-03*G6_1_0_4_0_0_7_2 + 4.166666666666654e-03*G6_1_0_4_0_1_4_0 + 4.166666666666654e-03*G6_1_0_4_0_1_4_1 + 4.166666666666654e-03*G6_1_0_4_0_1_4_2 - 4.166666666666654e-03*G6_1_0_4_0_1_5_0 - 4.166666666666654e-03*G6_1_0_4_0_1_6_1 - 4.166666666666654e-03*G6_1_0_4_0_1_7_2 + 4.166666666666653e-03*G6_1_0_4_0_2_4_0 + 4.166666666666654e-03*G6_1_0_4_0_2_4_1 + 4.166666666666654e-03*G6_1_0_4_0_2_4_2 - 4.166666666666653e-03*G6_1_0_4_0_2_5_0 - 4.166666666666654e-03*G6_1_0_4_0_2_6_1 - 4.166666666666654e-03*G6_1_0_4_0_2_7_2 + 4.166666666666654e-03*G6_1_0_4_0_3_4_0 + 4.166666666666656e-03*G6_1_0_4_0_3_4_1 + 4.166666666666657e-03*G6_1_0_4_0_3_4_2 - 4.166666666666654e-03*G6_1_0_4_0_3_5_0 - 4.166666666666656e-03*G6_1_0_4_0_3_6_1 - 4.166666666666656e-03*G6_1_0_4_0_3_7_2 + 4.166666666666654e-03*G6_1_0_5_0_0_4_0 + 4.166666666666655e-03*G6_1_0_5_0_0_4_1 + 4.166666666666655e-03*G6_1_0_5_0_0_4_2 - 4.166666666666654e-03*G6_1_0_5_0_0_5_0 - 4.166666666666655e-03*G6_1_0_5_0_0_6_1 - 4.166666666666655e-03*G6_1_0_5_0_0_7_2 + 8.333333333333307e-03*G6_1_0_5_0_1_4_0 + 8.333333333333309e-03*G6_1_0_5_0_1_4_1 + 8.333333333333309e-03*G6_1_0_5_0_1_4_2 - 8.333333333333307e-03*G6_1_0_5_0_1_5_0 - 8.333333333333309e-03*G6_1_0_5_0_1_6_1 - 8.333333333333309e-03*G6_1_0_5_0_1_7_2 + 4.166666666666654e-03*G6_1_0_5_0_2_4_0 + 4.166666666666655e-03*G6_1_0_5_0_2_4_1 + 4.166666666666655e-03*G6_1_0_5_0_2_4_2 - 4.166666666666654e-03*G6_1_0_5_0_2_5_0 - 4.166666666666655e-03*G6_1_0_5_0_2_6_1 - 4.166666666666655e-03*G6_1_0_5_0_2_7_2 + 4.166666666666655e-03*G6_1_0_5_0_3_4_0 + 4.166666666666656e-03*G6_1_0_5_0_3_4_1 + 4.166666666666656e-03*G6_1_0_5_0_3_4_2 - 4.166666666666655e-03*G6_1_0_5_0_3_5_0 - 4.166666666666656e-03*G6_1_0_5_0_3_6_1 - 4.166666666666656e-03*G6_1_0_5_0_3_7_2 + 4.166666666666654e-03*G6_1_0_6_0_0_4_0 + 4.166666666666654e-03*G6_1_0_6_0_0_4_1 + 4.166666666666655e-03*G6_1_0_6_0_0_4_2 - 4.166666666666654e-03*G6_1_0_6_0_0_5_0 - 4.166666666666654e-03*G6_1_0_6_0_0_6_1 - 4.166666666666654e-03*G6_1_0_6_0_0_7_2 + 4.166666666666654e-03*G6_1_0_6_0_1_4_0 + 4.166666666666654e-03*G6_1_0_6_0_1_4_1 + 4.166666666666654e-03*G6_1_0_6_0_1_4_2 - 4.166666666666654e-03*G6_1_0_6_0_1_5_0 - 4.166666666666654e-03*G6_1_0_6_0_1_6_1 - 4.166666666666654e-03*G6_1_0_6_0_1_7_2 + 8.333333333333309e-03*G6_1_0_6_0_2_4_0 + 8.333333333333309e-03*G6_1_0_6_0_2_4_1 + 8.333333333333311e-03*G6_1_0_6_0_2_4_2 - 8.333333333333309e-03*G6_1_0_6_0_2_5_0 - 8.333333333333309e-03*G6_1_0_6_0_2_6_1 - 8.333333333333309e-03*G6_1_0_6_0_2_7_2 + 4.166666666666654e-03*G6_1_0_6_0_3_4_0 + 4.166666666666655e-03*G6_1_0_6_0_3_4_1 + 4.166666666666655e-03*G6_1_0_6_0_3_4_2 - 4.166666666666654e-03*G6_1_0_6_0_3_5_0 - 4.166666666666655e-03*G6_1_0_6_0_3_6_1 - 4.166666666666655e-03*G6_1_0_6_0_3_7_2 + 4.166666666666656e-03*G6_1_0_7_0_0_4_0 + 4.166666666666656e-03*G6_1_0_7_0_0_4_1 + 4.166666666666657e-03*G6_1_0_7_0_0_4_2 - 4.166666666666656e-03*G6_1_0_7_0_0_5_0 - 4.166666666666656e-03*G6_1_0_7_0_0_6_1 - 4.166666666666656e-03*G6_1_0_7_0_0_7_2 + 4.166666666666654e-03*G6_1_0_7_0_1_4_0 + 4.166666666666655e-03*G6_1_0_7_0_1_4_1 + 4.166666666666655e-03*G6_1_0_7_0_1_4_2 - 4.166666666666654e-03*G6_1_0_7_0_1_5_0 - 4.166666666666655e-03*G6_1_0_7_0_1_6_1 - 4.166666666666655e-03*G6_1_0_7_0_1_7_2 + 4.166666666666655e-03*G6_1_0_7_0_2_4_0 + 4.166666666666655e-03*G6_1_0_7_0_2_4_1 + 4.166666666666655e-03*G6_1_0_7_0_2_4_2 - 4.166666666666655e-03*G6_1_0_7_0_2_5_0 - 4.166666666666655e-03*G6_1_0_7_0_2_6_1 - 4.166666666666655e-03*G6_1_0_7_0_2_7_2 + 8.333333333333309e-03*G6_1_0_7_0_3_4_0 + 8.333333333333311e-03*G6_1_0_7_0_3_4_1 + 8.333333333333311e-03*G6_1_0_7_0_3_4_2 - 8.333333333333309e-03*G6_1_0_7_0_3_5_0 - 8.333333333333311e-03*G6_1_0_7_0_3_6_1 - 8.333333333333311e-03*G6_1_0_7_0_3_7_2 + 8.333333333333309e-03*G6_1_1_4_0_4_4_0 + 8.333333333333309e-03*G6_1_1_4_0_4_4_1 + 8.333333333333311e-03*G6_1_1_4_0_4_4_2 - 8.333333333333309e-03*G6_1_1_4_0_4_5_0 - 8.333333333333309e-03*G6_1_1_4_0_4_6_1 - 8.333333333333309e-03*G6_1_1_4_0_4_7_2 + 4.166666666666654e-03*G6_1_1_4_0_5_4_0 + 4.166666666666654e-03*G6_1_1_4_0_5_4_1 + 4.166666666666654e-03*G6_1_1_4_0_5_4_2 - 4.166666666666654e-03*G6_1_1_4_0_5_5_0 - 4.166666666666654e-03*G6_1_1_4_0_5_6_1 - 4.166666666666654e-03*G6_1_1_4_0_5_7_2 + 4.166666666666653e-03*G6_1_1_4_0_6_4_0 + 4.166666666666654e-03*G6_1_1_4_0_6_4_1 + 4.166666666666654e-03*G6_1_1_4_0_6_4_2 - 4.166666666666653e-03*G6_1_1_4_0_6_5_0 - 4.166666666666654e-03*G6_1_1_4_0_6_6_1 - 4.166666666666654e-03*G6_1_1_4_0_6_7_2 + 4.166666666666654e-03*G6_1_1_4_0_7_4_0 + 4.166666666666656e-03*G6_1_1_4_0_7_4_1 + 4.166666666666657e-03*G6_1_1_4_0_7_4_2 - 4.166666666666654e-03*G6_1_1_4_0_7_5_0 - 4.166666666666656e-03*G6_1_1_4_0_7_6_1 - 4.166666666666656e-03*G6_1_1_4_0_7_7_2 + 4.166666666666654e-03*G6_1_1_5_0_4_4_0 + 4.166666666666654e-03*G6_1_1_5_0_4_4_1 + 4.166666666666654e-03*G6_1_1_5_0_4_4_2 - 4.166666666666654e-03*G6_1_1_5_0_4_5_0 - 4.166666666666654e-03*G6_1_1_5_0_4_6_1 - 4.166666666666654e-03*G6_1_1_5_0_4_7_2 + 8.333333333333307e-03*G6_1_1_5_0_5_4_0 + 8.333333333333309e-03*G6_1_1_5_0_5_4_1 + 8.333333333333309e-03*G6_1_1_5_0_5_4_2 - 8.333333333333307e-03*G6_1_1_5_0_5_5_0 - 8.333333333333309e-03*G6_1_1_5_0_5_6_1 - 8.333333333333309e-03*G6_1_1_5_0_5_7_2 + 4.166666666666654e-03*G6_1_1_5_0_6_4_0 + 4.166666666666655e-03*G6_1_1_5_0_6_4_1 + 4.166666666666655e-03*G6_1_1_5_0_6_4_2 - 4.166666666666654e-03*G6_1_1_5_0_6_5_0 - 4.166666666666655e-03*G6_1_1_5_0_6_6_1 - 4.166666666666655e-03*G6_1_1_5_0_6_7_2 + 4.166666666666655e-03*G6_1_1_5_0_7_4_0 + 4.166666666666656e-03*G6_1_1_5_0_7_4_1 + 4.166666666666656e-03*G6_1_1_5_0_7_4_2 - 4.166666666666655e-03*G6_1_1_5_0_7_5_0 - 4.166666666666656e-03*G6_1_1_5_0_7_6_1 - 4.166666666666656e-03*G6_1_1_5_0_7_7_2 + 4.166666666666653e-03*G6_1_1_6_0_4_4_0 + 4.166666666666654e-03*G6_1_1_6_0_4_4_1 + 4.166666666666654e-03*G6_1_1_6_0_4_4_2 - 4.166666666666653e-03*G6_1_1_6_0_4_5_0 - 4.166666666666654e-03*G6_1_1_6_0_4_6_1 - 4.166666666666654e-03*G6_1_1_6_0_4_7_2 + 4.166666666666654e-03*G6_1_1_6_0_5_4_0 + 4.166666666666655e-03*G6_1_1_6_0_5_4_1 + 4.166666666666655e-03*G6_1_1_6_0_5_4_2 - 4.166666666666654e-03*G6_1_1_6_0_5_5_0 - 4.166666666666655e-03*G6_1_1_6_0_5_6_1 - 4.166666666666655e-03*G6_1_1_6_0_5_7_2 + 8.333333333333309e-03*G6_1_1_6_0_6_4_0 + 8.333333333333309e-03*G6_1_1_6_0_6_4_1 + 8.333333333333311e-03*G6_1_1_6_0_6_4_2 - 8.333333333333309e-03*G6_1_1_6_0_6_5_0 - 8.333333333333309e-03*G6_1_1_6_0_6_6_1 - 8.333333333333309e-03*G6_1_1_6_0_6_7_2 + 4.166666666666654e-03*G6_1_1_6_0_7_4_0 + 4.166666666666655e-03*G6_1_1_6_0_7_4_1 + 4.166666666666655e-03*G6_1_1_6_0_7_4_2 - 4.166666666666654e-03*G6_1_1_6_0_7_5_0 - 4.166666666666655e-03*G6_1_1_6_0_7_6_1 - 4.166666666666655e-03*G6_1_1_6_0_7_7_2 + 4.166666666666655e-03*G6_1_1_7_0_4_4_0 + 4.166666666666656e-03*G6_1_1_7_0_4_4_1 + 4.166666666666657e-03*G6_1_1_7_0_4_4_2 - 4.166666666666655e-03*G6_1_1_7_0_4_5_0 - 4.166666666666656e-03*G6_1_1_7_0_4_6_1 - 4.166666666666656e-03*G6_1_1_7_0_4_7_2 + 4.166666666666655e-03*G6_1_1_7_0_5_4_0 + 4.166666666666656e-03*G6_1_1_7_0_5_4_1 + 4.166666666666656e-03*G6_1_1_7_0_5_4_2 - 4.166666666666655e-03*G6_1_1_7_0_5_5_0 - 4.166666666666656e-03*G6_1_1_7_0_5_6_1 - 4.166666666666656e-03*G6_1_1_7_0_5_7_2 + 4.166666666666655e-03*G6_1_1_7_0_6_4_0 + 4.166666666666655e-03*G6_1_1_7_0_6_4_1 + 4.166666666666655e-03*G6_1_1_7_0_6_4_2 - 4.166666666666655e-03*G6_1_1_7_0_6_5_0 - 4.166666666666655e-03*G6_1_1_7_0_6_6_1 - 4.166666666666655e-03*G6_1_1_7_0_6_7_2 + 8.333333333333309e-03*G6_1_1_7_0_7_4_0 + 8.333333333333311e-03*G6_1_1_7_0_7_4_1 + 8.333333333333311e-03*G6_1_1_7_0_7_4_2 - 8.333333333333309e-03*G6_1_1_7_0_7_5_0 - 8.333333333333311e-03*G6_1_1_7_0_7_6_1 - 8.333333333333311e-03*G6_1_1_7_0_7_7_2 + 8.333333333333309e-03*G6_1_2_4_0_8_4_0 + 8.333333333333309e-03*G6_1_2_4_0_8_4_1 + 8.333333333333311e-03*G6_1_2_4_0_8_4_2 - 8.333333333333309e-03*G6_1_2_4_0_8_5_0 - 8.333333333333309e-03*G6_1_2_4_0_8_6_1 - 8.333333333333309e-03*G6_1_2_4_0_8_7_2 + 4.166666666666654e-03*G6_1_2_4_0_9_4_0 + 4.166666666666654e-03*G6_1_2_4_0_9_4_1 + 4.166666666666654e-03*G6_1_2_4_0_9_4_2 - 4.166666666666654e-03*G6_1_2_4_0_9_5_0 - 4.166666666666654e-03*G6_1_2_4_0_9_6_1 - 4.166666666666654e-03*G6_1_2_4_0_9_7_2 + 4.166666666666653e-03*G6_1_2_4_0_10_4_0 + 4.166666666666654e-03*G6_1_2_4_0_10_4_1 + 4.166666666666654e-03*G6_1_2_4_0_10_4_2 - 4.166666666666653e-03*G6_1_2_4_0_10_5_0 - 4.166666666666654e-03*G6_1_2_4_0_10_6_1 - 4.166666666666654e-03*G6_1_2_4_0_10_7_2 + 4.166666666666654e-03*G6_1_2_4_0_11_4_0 + 4.166666666666656e-03*G6_1_2_4_0_11_4_1 + 4.166666666666657e-03*G6_1_2_4_0_11_4_2 - 4.166666666666654e-03*G6_1_2_4_0_11_5_0 - 4.166666666666656e-03*G6_1_2_4_0_11_6_1 - 4.166666666666656e-03*G6_1_2_4_0_11_7_2 + 4.166666666666654e-03*G6_1_2_5_0_8_4_0 + 4.166666666666654e-03*G6_1_2_5_0_8_4_1 + 4.166666666666654e-03*G6_1_2_5_0_8_4_2 - 4.166666666666654e-03*G6_1_2_5_0_8_5_0 - 4.166666666666654e-03*G6_1_2_5_0_8_6_1 - 4.166666666666654e-03*G6_1_2_5_0_8_7_2 + 8.333333333333307e-03*G6_1_2_5_0_9_4_0 + 8.333333333333309e-03*G6_1_2_5_0_9_4_1 + 8.333333333333309e-03*G6_1_2_5_0_9_4_2 - 8.333333333333307e-03*G6_1_2_5_0_9_5_0 - 8.333333333333309e-03*G6_1_2_5_0_9_6_1 - 8.333333333333309e-03*G6_1_2_5_0_9_7_2 + 4.166666666666654e-03*G6_1_2_5_0_10_4_0 + 4.166666666666655e-03*G6_1_2_5_0_10_4_1 + 4.166666666666655e-03*G6_1_2_5_0_10_4_2 - 4.166666666666654e-03*G6_1_2_5_0_10_5_0 - 4.166666666666655e-03*G6_1_2_5_0_10_6_1 - 4.166666666666655e-03*G6_1_2_5_0_10_7_2 + 4.166666666666655e-03*G6_1_2_5_0_11_4_0 + 4.166666666666656e-03*G6_1_2_5_0_11_4_1 + 4.166666666666656e-03*G6_1_2_5_0_11_4_2 - 4.166666666666655e-03*G6_1_2_5_0_11_5_0 - 4.166666666666656e-03*G6_1_2_5_0_11_6_1 - 4.166666666666656e-03*G6_1_2_5_0_11_7_2 + 4.166666666666653e-03*G6_1_2_6_0_8_4_0 + 4.166666666666654e-03*G6_1_2_6_0_8_4_1 + 4.166666666666654e-03*G6_1_2_6_0_8_4_2 - 4.166666666666653e-03*G6_1_2_6_0_8_5_0 - 4.166666666666654e-03*G6_1_2_6_0_8_6_1 - 4.166666666666654e-03*G6_1_2_6_0_8_7_2 + 4.166666666666654e-03*G6_1_2_6_0_9_4_0 + 4.166666666666655e-03*G6_1_2_6_0_9_4_1 + 4.166666666666655e-03*G6_1_2_6_0_9_4_2 - 4.166666666666654e-03*G6_1_2_6_0_9_5_0 - 4.166666666666655e-03*G6_1_2_6_0_9_6_1 - 4.166666666666655e-03*G6_1_2_6_0_9_7_2 + 8.333333333333309e-03*G6_1_2_6_0_10_4_0 + 8.333333333333309e-03*G6_1_2_6_0_10_4_1 + 8.333333333333311e-03*G6_1_2_6_0_10_4_2 - 8.333333333333309e-03*G6_1_2_6_0_10_5_0 - 8.333333333333309e-03*G6_1_2_6_0_10_6_1 - 8.333333333333309e-03*G6_1_2_6_0_10_7_2 + 4.166666666666654e-03*G6_1_2_6_0_11_4_0 + 4.166666666666655e-03*G6_1_2_6_0_11_4_1 + 4.166666666666655e-03*G6_1_2_6_0_11_4_2 - 4.166666666666654e-03*G6_1_2_6_0_11_5_0 - 4.166666666666655e-03*G6_1_2_6_0_11_6_1 - 4.166666666666655e-03*G6_1_2_6_0_11_7_2 + 4.166666666666655e-03*G6_1_2_7_0_8_4_0 + 4.166666666666656e-03*G6_1_2_7_0_8_4_1 + 4.166666666666657e-03*G6_1_2_7_0_8_4_2 - 4.166666666666655e-03*G6_1_2_7_0_8_5_0 - 4.166666666666656e-03*G6_1_2_7_0_8_6_1 - 4.166666666666656e-03*G6_1_2_7_0_8_7_2 + 4.166666666666655e-03*G6_1_2_7_0_9_4_0 + 4.166666666666656e-03*G6_1_2_7_0_9_4_1 + 4.166666666666656e-03*G6_1_2_7_0_9_4_2 - 4.166666666666655e-03*G6_1_2_7_0_9_5_0 - 4.166666666666656e-03*G6_1_2_7_0_9_6_1 - 4.166666666666656e-03*G6_1_2_7_0_9_7_2 + 4.166666666666655e-03*G6_1_2_7_0_10_4_0 + 4.166666666666655e-03*G6_1_2_7_0_10_4_1 + 4.166666666666655e-03*G6_1_2_7_0_10_4_2 - 4.166666666666655e-03*G6_1_2_7_0_10_5_0 - 4.166666666666655e-03*G6_1_2_7_0_10_6_1 - 4.166666666666655e-03*G6_1_2_7_0_10_7_2 + 8.333333333333309e-03*G6_1_2_7_0_11_4_0 + 8.333333333333311e-03*G6_1_2_7_0_11_4_1 + 8.333333333333311e-03*G6_1_2_7_0_11_4_2 - 8.333333333333309e-03*G6_1_2_7_0_11_5_0 - 8.333333333333311e-03*G6_1_2_7_0_11_6_1 - 8.333333333333311e-03*G6_1_2_7_0_11_7_2 + 8.333333333333309e-03*G6_2_0_8_0_0_4_0 + 8.333333333333309e-03*G6_2_0_8_0_0_4_1 + 8.333333333333311e-03*G6_2_0_8_0_0_4_2 - 8.333333333333309e-03*G6_2_0_8_0_0_5_0 - 8.333333333333309e-03*G6_2_0_8_0_0_6_1 - 8.333333333333309e-03*G6_2_0_8_0_0_7_2 + 4.166666666666654e-03*G6_2_0_8_0_1_4_0 + 4.166666666666654e-03*G6_2_0_8_0_1_4_1 + 4.166666666666654e-03*G6_2_0_8_0_1_4_2 - 4.166666666666654e-03*G6_2_0_8_0_1_5_0 - 4.166666666666654e-03*G6_2_0_8_0_1_6_1 - 4.166666666666654e-03*G6_2_0_8_0_1_7_2 + 4.166666666666653e-03*G6_2_0_8_0_2_4_0 + 4.166666666666654e-03*G6_2_0_8_0_2_4_1 + 4.166666666666654e-03*G6_2_0_8_0_2_4_2 - 4.166666666666653e-03*G6_2_0_8_0_2_5_0 - 4.166666666666654e-03*G6_2_0_8_0_2_6_1 - 4.166666666666654e-03*G6_2_0_8_0_2_7_2 + 4.166666666666654e-03*G6_2_0_8_0_3_4_0 + 4.166666666666656e-03*G6_2_0_8_0_3_4_1 + 4.166666666666657e-03*G6_2_0_8_0_3_4_2 - 4.166666666666654e-03*G6_2_0_8_0_3_5_0 - 4.166666666666656e-03*G6_2_0_8_0_3_6_1 - 4.166666666666656e-03*G6_2_0_8_0_3_7_2 + 4.166666666666654e-03*G6_2_0_9_0_0_4_0 + 4.166666666666655e-03*G6_2_0_9_0_0_4_1 + 4.166666666666655e-03*G6_2_0_9_0_0_4_2 - 4.166666666666654e-03*G6_2_0_9_0_0_5_0 - 4.166666666666655e-03*G6_2_0_9_0_0_6_1 - 4.166666666666655e-03*G6_2_0_9_0_0_7_2 + 8.333333333333307e-03*G6_2_0_9_0_1_4_0 + 8.333333333333309e-03*G6_2_0_9_0_1_4_1 + 8.333333333333309e-03*G6_2_0_9_0_1_4_2 - 8.333333333333307e-03*G6_2_0_9_0_1_5_0 - 8.333333333333309e-03*G6_2_0_9_0_1_6_1 - 8.333333333333309e-03*G6_2_0_9_0_1_7_2 + 4.166666666666654e-03*G6_2_0_9_0_2_4_0 + 4.166666666666655e-03*G6_2_0_9_0_2_4_1 + 4.166666666666655e-03*G6_2_0_9_0_2_4_2 - 4.166666666666654e-03*G6_2_0_9_0_2_5_0 - 4.166666666666655e-03*G6_2_0_9_0_2_6_1 - 4.166666666666655e-03*G6_2_0_9_0_2_7_2 + 4.166666666666655e-03*G6_2_0_9_0_3_4_0 + 4.166666666666656e-03*G6_2_0_9_0_3_4_1 + 4.166666666666656e-03*G6_2_0_9_0_3_4_2 - 4.166666666666655e-03*G6_2_0_9_0_3_5_0 - 4.166666666666656e-03*G6_2_0_9_0_3_6_1 - 4.166666666666656e-03*G6_2_0_9_0_3_7_2 + 4.166666666666654e-03*G6_2_0_10_0_0_4_0 + 4.166666666666654e-03*G6_2_0_10_0_0_4_1 + 4.166666666666655e-03*G6_2_0_10_0_0_4_2 - 4.166666666666654e-03*G6_2_0_10_0_0_5_0 - 4.166666666666654e-03*G6_2_0_10_0_0_6_1 - 4.166666666666654e-03*G6_2_0_10_0_0_7_2 + 4.166666666666654e-03*G6_2_0_10_0_1_4_0 + 4.166666666666654e-03*G6_2_0_10_0_1_4_1 + 4.166666666666654e-03*G6_2_0_10_0_1_4_2 - 4.166666666666654e-03*G6_2_0_10_0_1_5_0 - 4.166666666666654e-03*G6_2_0_10_0_1_6_1 - 4.166666666666654e-03*G6_2_0_10_0_1_7_2 + 8.333333333333309e-03*G6_2_0_10_0_2_4_0 + 8.333333333333309e-03*G6_2_0_10_0_2_4_1 + 8.333333333333311e-03*G6_2_0_10_0_2_4_2 - 8.333333333333309e-03*G6_2_0_10_0_2_5_0 - 8.333333333333309e-03*G6_2_0_10_0_2_6_1 - 8.333333333333309e-03*G6_2_0_10_0_2_7_2 + 4.166666666666654e-03*G6_2_0_10_0_3_4_0 + 4.166666666666655e-03*G6_2_0_10_0_3_4_1 + 4.166666666666655e-03*G6_2_0_10_0_3_4_2 - 4.166666666666654e-03*G6_2_0_10_0_3_5_0 - 4.166666666666655e-03*G6_2_0_10_0_3_6_1 - 4.166666666666655e-03*G6_2_0_10_0_3_7_2 + 4.166666666666656e-03*G6_2_0_11_0_0_4_0 + 4.166666666666656e-03*G6_2_0_11_0_0_4_1 + 4.166666666666657e-03*G6_2_0_11_0_0_4_2 - 4.166666666666656e-03*G6_2_0_11_0_0_5_0 - 4.166666666666656e-03*G6_2_0_11_0_0_6_1 - 4.166666666666656e-03*G6_2_0_11_0_0_7_2 + 4.166666666666654e-03*G6_2_0_11_0_1_4_0 + 4.166666666666655e-03*G6_2_0_11_0_1_4_1 + 4.166666666666655e-03*G6_2_0_11_0_1_4_2 - 4.166666666666654e-03*G6_2_0_11_0_1_5_0 - 4.166666666666655e-03*G6_2_0_11_0_1_6_1 - 4.166666666666655e-03*G6_2_0_11_0_1_7_2 + 4.166666666666655e-03*G6_2_0_11_0_2_4_0 + 4.166666666666655e-03*G6_2_0_11_0_2_4_1 + 4.166666666666655e-03*G6_2_0_11_0_2_4_2 - 4.166666666666655e-03*G6_2_0_11_0_2_5_0 - 4.166666666666655e-03*G6_2_0_11_0_2_6_1 - 4.166666666666655e-03*G6_2_0_11_0_2_7_2 + 8.333333333333309e-03*G6_2_0_11_0_3_4_0 + 8.333333333333311e-03*G6_2_0_11_0_3_4_1 + 8.333333333333311e-03*G6_2_0_11_0_3_4_2 - 8.333333333333309e-03*G6_2_0_11_0_3_5_0 - 8.333333333333311e-03*G6_2_0_11_0_3_6_1 - 8.333333333333311e-03*G6_2_0_11_0_3_7_2 + 8.333333333333309e-03*G6_2_1_8_0_4_4_0 + 8.333333333333309e-03*G6_2_1_8_0_4_4_1 + 8.333333333333311e-03*G6_2_1_8_0_4_4_2 - 8.333333333333309e-03*G6_2_1_8_0_4_5_0 - 8.333333333333309e-03*G6_2_1_8_0_4_6_1 - 8.333333333333309e-03*G6_2_1_8_0_4_7_2 + 4.166666666666654e-03*G6_2_1_8_0_5_4_0 + 4.166666666666654e-03*G6_2_1_8_0_5_4_1 + 4.166666666666654e-03*G6_2_1_8_0_5_4_2 - 4.166666666666654e-03*G6_2_1_8_0_5_5_0 - 4.166666666666654e-03*G6_2_1_8_0_5_6_1 - 4.166666666666654e-03*G6_2_1_8_0_5_7_2 + 4.166666666666653e-03*G6_2_1_8_0_6_4_0 + 4.166666666666654e-03*G6_2_1_8_0_6_4_1 + 4.166666666666654e-03*G6_2_1_8_0_6_4_2 - 4.166666666666653e-03*G6_2_1_8_0_6_5_0 - 4.166666666666654e-03*G6_2_1_8_0_6_6_1 - 4.166666666666654e-03*G6_2_1_8_0_6_7_2 + 4.166666666666654e-03*G6_2_1_8_0_7_4_0 + 4.166666666666656e-03*G6_2_1_8_0_7_4_1 + 4.166666666666657e-03*G6_2_1_8_0_7_4_2 - 4.166666666666654e-03*G6_2_1_8_0_7_5_0 - 4.166666666666656e-03*G6_2_1_8_0_7_6_1 - 4.166666666666656e-03*G6_2_1_8_0_7_7_2 + 4.166666666666654e-03*G6_2_1_9_0_4_4_0 + 4.166666666666654e-03*G6_2_1_9_0_4_4_1 + 4.166666666666654e-03*G6_2_1_9_0_4_4_2 - 4.166666666666654e-03*G6_2_1_9_0_4_5_0 - 4.166666666666654e-03*G6_2_1_9_0_4_6_1 - 4.166666666666654e-03*G6_2_1_9_0_4_7_2 + 8.333333333333307e-03*G6_2_1_9_0_5_4_0 + 8.333333333333309e-03*G6_2_1_9_0_5_4_1 + 8.333333333333309e-03*G6_2_1_9_0_5_4_2 - 8.333333333333307e-03*G6_2_1_9_0_5_5_0 - 8.333333333333309e-03*G6_2_1_9_0_5_6_1 - 8.333333333333309e-03*G6_2_1_9_0_5_7_2 + 4.166666666666654e-03*G6_2_1_9_0_6_4_0 + 4.166666666666655e-03*G6_2_1_9_0_6_4_1 + 4.166666666666655e-03*G6_2_1_9_0_6_4_2 - 4.166666666666654e-03*G6_2_1_9_0_6_5_0 - 4.166666666666655e-03*G6_2_1_9_0_6_6_1 - 4.166666666666655e-03*G6_2_1_9_0_6_7_2 + 4.166666666666655e-03*G6_2_1_9_0_7_4_0 + 4.166666666666656e-03*G6_2_1_9_0_7_4_1 + 4.166666666666656e-03*G6_2_1_9_0_7_4_2 - 4.166666666666655e-03*G6_2_1_9_0_7_5_0 - 4.166666666666656e-03*G6_2_1_9_0_7_6_1 - 4.166666666666656e-03*G6_2_1_9_0_7_7_2 + 4.166666666666653e-03*G6_2_1_10_0_4_4_0 + 4.166666666666654e-03*G6_2_1_10_0_4_4_1 + 4.166666666666654e-03*G6_2_1_10_0_4_4_2 - 4.166666666666653e-03*G6_2_1_10_0_4_5_0 - 4.166666666666654e-03*G6_2_1_10_0_4_6_1 - 4.166666666666654e-03*G6_2_1_10_0_4_7_2 + 4.166666666666654e-03*G6_2_1_10_0_5_4_0 + 4.166666666666655e-03*G6_2_1_10_0_5_4_1 + 4.166666666666655e-03*G6_2_1_10_0_5_4_2 - 4.166666666666654e-03*G6_2_1_10_0_5_5_0 - 4.166666666666655e-03*G6_2_1_10_0_5_6_1 - 4.166666666666655e-03*G6_2_1_10_0_5_7_2 + 8.333333333333309e-03*G6_2_1_10_0_6_4_0 + 8.333333333333309e-03*G6_2_1_10_0_6_4_1 + 8.333333333333311e-03*G6_2_1_10_0_6_4_2 - 8.333333333333309e-03*G6_2_1_10_0_6_5_0 - 8.333333333333309e-03*G6_2_1_10_0_6_6_1 - 8.333333333333309e-03*G6_2_1_10_0_6_7_2 + 4.166666666666654e-03*G6_2_1_10_0_7_4_0 + 4.166666666666655e-03*G6_2_1_10_0_7_4_1 + 4.166666666666655e-03*G6_2_1_10_0_7_4_2 - 4.166666666666654e-03*G6_2_1_10_0_7_5_0 - 4.166666666666655e-03*G6_2_1_10_0_7_6_1 - 4.166666666666655e-03*G6_2_1_10_0_7_7_2 + 4.166666666666655e-03*G6_2_1_11_0_4_4_0 + 4.166666666666656e-03*G6_2_1_11_0_4_4_1 + 4.166666666666657e-03*G6_2_1_11_0_4_4_2 - 4.166666666666655e-03*G6_2_1_11_0_4_5_0 - 4.166666666666656e-03*G6_2_1_11_0_4_6_1 - 4.166666666666656e-03*G6_2_1_11_0_4_7_2 + 4.166666666666655e-03*G6_2_1_11_0_5_4_0 + 4.166666666666656e-03*G6_2_1_11_0_5_4_1 + 4.166666666666656e-03*G6_2_1_11_0_5_4_2 - 4.166666666666655e-03*G6_2_1_11_0_5_5_0 - 4.166666666666656e-03*G6_2_1_11_0_5_6_1 - 4.166666666666656e-03*G6_2_1_11_0_5_7_2 + 4.166666666666655e-03*G6_2_1_11_0_6_4_0 + 4.166666666666655e-03*G6_2_1_11_0_6_4_1 + 4.166666666666655e-03*G6_2_1_11_0_6_4_2 - 4.166666666666655e-03*G6_2_1_11_0_6_5_0 - 4.166666666666655e-03*G6_2_1_11_0_6_6_1 - 4.166666666666655e-03*G6_2_1_11_0_6_7_2 + 8.333333333333309e-03*G6_2_1_11_0_7_4_0 + 8.333333333333311e-03*G6_2_1_11_0_7_4_1 + 8.333333333333311e-03*G6_2_1_11_0_7_4_2 - 8.333333333333309e-03*G6_2_1_11_0_7_5_0 - 8.333333333333311e-03*G6_2_1_11_0_7_6_1 - 8.333333333333311e-03*G6_2_1_11_0_7_7_2 + 8.333333333333309e-03*G6_2_2_8_0_8_4_0 + 8.333333333333309e-03*G6_2_2_8_0_8_4_1 + 8.333333333333311e-03*G6_2_2_8_0_8_4_2 - 8.333333333333309e-03*G6_2_2_8_0_8_5_0 - 8.333333333333309e-03*G6_2_2_8_0_8_6_1 - 8.333333333333309e-03*G6_2_2_8_0_8_7_2 + 4.166666666666654e-03*G6_2_2_8_0_9_4_0 + 4.166666666666654e-03*G6_2_2_8_0_9_4_1 + 4.166666666666654e-03*G6_2_2_8_0_9_4_2 - 4.166666666666654e-03*G6_2_2_8_0_9_5_0 - 4.166666666666654e-03*G6_2_2_8_0_9_6_1 - 4.166666666666654e-03*G6_2_2_8_0_9_7_2 + 4.166666666666653e-03*G6_2_2_8_0_10_4_0 + 4.166666666666654e-03*G6_2_2_8_0_10_4_1 + 4.166666666666654e-03*G6_2_2_8_0_10_4_2 - 4.166666666666653e-03*G6_2_2_8_0_10_5_0 - 4.166666666666654e-03*G6_2_2_8_0_10_6_1 - 4.166666666666654e-03*G6_2_2_8_0_10_7_2 + 4.166666666666654e-03*G6_2_2_8_0_11_4_0 + 4.166666666666656e-03*G6_2_2_8_0_11_4_1 + 4.166666666666657e-03*G6_2_2_8_0_11_4_2 - 4.166666666666654e-03*G6_2_2_8_0_11_5_0 - 4.166666666666656e-03*G6_2_2_8_0_11_6_1 - 4.166666666666656e-03*G6_2_2_8_0_11_7_2 + 4.166666666666654e-03*G6_2_2_9_0_8_4_0 + 4.166666666666654e-03*G6_2_2_9_0_8_4_1 + 4.166666666666654e-03*G6_2_2_9_0_8_4_2 - 4.166666666666654e-03*G6_2_2_9_0_8_5_0 - 4.166666666666654e-03*G6_2_2_9_0_8_6_1 - 4.166666666666654e-03*G6_2_2_9_0_8_7_2 + 8.333333333333307e-03*G6_2_2_9_0_9_4_0 + 8.333333333333309e-03*G6_2_2_9_0_9_4_1 + 8.333333333333309e-03*G6_2_2_9_0_9_4_2 - 8.333333333333307e-03*G6_2_2_9_0_9_5_0 - 8.333333333333309e-03*G6_2_2_9_0_9_6_1 - 8.333333333333309e-03*G6_2_2_9_0_9_7_2 + 4.166666666666654e-03*G6_2_2_9_0_10_4_0 + 4.166666666666655e-03*G6_2_2_9_0_10_4_1 + 4.166666666666655e-03*G6_2_2_9_0_10_4_2 - 4.166666666666654e-03*G6_2_2_9_0_10_5_0 - 4.166666666666655e-03*G6_2_2_9_0_10_6_1 - 4.166666666666655e-03*G6_2_2_9_0_10_7_2 + 4.166666666666655e-03*G6_2_2_9_0_11_4_0 + 4.166666666666656e-03*G6_2_2_9_0_11_4_1 + 4.166666666666656e-03*G6_2_2_9_0_11_4_2 - 4.166666666666655e-03*G6_2_2_9_0_11_5_0 - 4.166666666666656e-03*G6_2_2_9_0_11_6_1 - 4.166666666666656e-03*G6_2_2_9_0_11_7_2 + 4.166666666666653e-03*G6_2_2_10_0_8_4_0 + 4.166666666666654e-03*G6_2_2_10_0_8_4_1 + 4.166666666666654e-03*G6_2_2_10_0_8_4_2 - 4.166666666666653e-03*G6_2_2_10_0_8_5_0 - 4.166666666666654e-03*G6_2_2_10_0_8_6_1 - 4.166666666666654e-03*G6_2_2_10_0_8_7_2 + 4.166666666666654e-03*G6_2_2_10_0_9_4_0 + 4.166666666666655e-03*G6_2_2_10_0_9_4_1 + 4.166666666666655e-03*G6_2_2_10_0_9_4_2 - 4.166666666666654e-03*G6_2_2_10_0_9_5_0 - 4.166666666666655e-03*G6_2_2_10_0_9_6_1 - 4.166666666666655e-03*G6_2_2_10_0_9_7_2 + 8.333333333333309e-03*G6_2_2_10_0_10_4_0 + 8.333333333333309e-03*G6_2_2_10_0_10_4_1 + 8.333333333333311e-03*G6_2_2_10_0_10_4_2 - 8.333333333333309e-03*G6_2_2_10_0_10_5_0 - 8.333333333333309e-03*G6_2_2_10_0_10_6_1 - 8.333333333333309e-03*G6_2_2_10_0_10_7_2 + 4.166666666666654e-03*G6_2_2_10_0_11_4_0 + 4.166666666666655e-03*G6_2_2_10_0_11_4_1 + 4.166666666666655e-03*G6_2_2_10_0_11_4_2 - 4.166666666666654e-03*G6_2_2_10_0_11_5_0 - 4.166666666666655e-03*G6_2_2_10_0_11_6_1 - 4.166666666666655e-03*G6_2_2_10_0_11_7_2 + 4.166666666666655e-03*G6_2_2_11_0_8_4_0 + 4.166666666666656e-03*G6_2_2_11_0_8_4_1 + 4.166666666666657e-03*G6_2_2_11_0_8_4_2 - 4.166666666666655e-03*G6_2_2_11_0_8_5_0 - 4.166666666666656e-03*G6_2_2_11_0_8_6_1 - 4.166666666666656e-03*G6_2_2_11_0_8_7_2 + 4.166666666666655e-03*G6_2_2_11_0_9_4_0 + 4.166666666666656e-03*G6_2_2_11_0_9_4_1 + 4.166666666666656e-03*G6_2_2_11_0_9_4_2 - 4.166666666666655e-03*G6_2_2_11_0_9_5_0 - 4.166666666666656e-03*G6_2_2_11_0_9_6_1 - 4.166666666666656e-03*G6_2_2_11_0_9_7_2 + 4.166666666666655e-03*G6_2_2_11_0_10_4_0 + 4.166666666666655e-03*G6_2_2_11_0_10_4_1 + 4.166666666666655e-03*G6_2_2_11_0_10_4_2 - 4.166666666666655e-03*G6_2_2_11_0_10_5_0 - 4.166666666666655e-03*G6_2_2_11_0_10_6_1 - 4.166666666666655e-03*G6_2_2_11_0_10_7_2 + 8.333333333333309e-03*G6_2_2_11_0_11_4_0 + 8.333333333333311e-03*G6_2_2_11_0_11_4_1 + 8.333333333333311e-03*G6_2_2_11_0_11_4_2 - 8.333333333333309e-03*G6_2_2_11_0_11_5_0 - 8.333333333333311e-03*G6_2_2_11_0_11_6_1 - 8.333333333333311e-03*G6_2_2_11_0_11_7_2 + 4.166666666666661e-02*G7_1_0_0_0_0_0 + 4.166666666666662e-02*G7_1_0_0_0_0_1 + 4.166666666666662e-02*G7_1_0_0_0_0_2 - 4.166666666666661e-02*G7_1_0_0_0_1_0 - 4.166666666666662e-02*G7_1_0_0_0_2_1 - 4.166666666666662e-02*G7_1_0_0_0_3_2 + 4.166666666666659e-02*G7_1_0_1_0_0_0 + 4.166666666666660e-02*G7_1_0_1_0_0_1 + 4.166666666666660e-02*G7_1_0_1_0_0_2 - 4.166666666666659e-02*G7_1_0_1_0_1_0 - 4.166666666666660e-02*G7_1_0_1_0_2_1 - 4.166666666666660e-02*G7_1_0_1_0_3_2 + 4.166666666666660e-02*G7_1_0_2_0_0_0 + 4.166666666666661e-02*G7_1_0_2_0_0_1 + 4.166666666666661e-02*G7_1_0_2_0_0_2 - 4.166666666666660e-02*G7_1_0_2_0_1_0 - 4.166666666666661e-02*G7_1_0_2_0_2_1 - 4.166666666666661e-02*G7_1_0_2_0_3_2 + 4.166666666666660e-02*G7_1_0_3_0_0_0 + 4.166666666666661e-02*G7_1_0_3_0_0_1 + 4.166666666666661e-02*G7_1_0_3_0_0_2 - 4.166666666666660e-02*G7_1_0_3_0_1_0 - 4.166666666666661e-02*G7_1_0_3_0_2_1 - 4.166666666666661e-02*G7_1_0_3_0_3_2 + 4.166666666666660e-02*G7_1_1_4_0_0_0 + 4.166666666666661e-02*G7_1_1_4_0_0_1 + 4.166666666666661e-02*G7_1_1_4_0_0_2 - 4.166666666666660e-02*G7_1_1_4_0_1_0 - 4.166666666666661e-02*G7_1_1_4_0_2_1 - 4.166666666666661e-02*G7_1_1_4_0_3_2 + 4.166666666666660e-02*G7_1_1_5_0_0_0 + 4.166666666666661e-02*G7_1_1_5_0_0_1 + 4.166666666666661e-02*G7_1_1_5_0_0_2 - 4.166666666666660e-02*G7_1_1_5_0_1_0 - 4.166666666666661e-02*G7_1_1_5_0_2_1 - 4.166666666666661e-02*G7_1_1_5_0_3_2 + 4.166666666666660e-02*G7_1_1_6_0_0_0 + 4.166666666666661e-02*G7_1_1_6_0_0_1 + 4.166666666666661e-02*G7_1_1_6_0_0_2 - 4.166666666666660e-02*G7_1_1_6_0_1_0 - 4.166666666666661e-02*G7_1_1_6_0_2_1 - 4.166666666666661e-02*G7_1_1_6_0_3_2 + 4.166666666666660e-02*G7_1_1_7_0_0_0 + 4.166666666666661e-02*G7_1_1_7_0_0_1 + 4.166666666666661e-02*G7_1_1_7_0_0_2 - 4.166666666666660e-02*G7_1_1_7_0_1_0 - 4.166666666666661e-02*G7_1_1_7_0_2_1 - 4.166666666666661e-02*G7_1_1_7_0_3_2 + 4.166666666666660e-02*G7_1_2_8_0_0_0 + 4.166666666666661e-02*G7_1_2_8_0_0_1 + 4.166666666666661e-02*G7_1_2_8_0_0_2 - 4.166666666666660e-02*G7_1_2_8_0_1_0 - 4.166666666666661e-02*G7_1_2_8_0_2_1 - 4.166666666666661e-02*G7_1_2_8_0_3_2 + 4.166666666666660e-02*G7_1_2_9_0_0_0 + 4.166666666666661e-02*G7_1_2_9_0_0_1 + 4.166666666666661e-02*G7_1_2_9_0_0_2 - 4.166666666666660e-02*G7_1_2_9_0_1_0 - 4.166666666666661e-02*G7_1_2_9_0_2_1 - 4.166666666666661e-02*G7_1_2_9_0_3_2 + 4.166666666666660e-02*G7_1_2_10_0_0_0 + 4.166666666666661e-02*G7_1_2_10_0_0_1 + 4.166666666666661e-02*G7_1_2_10_0_0_2 - 4.166666666666660e-02*G7_1_2_10_0_1_0 - 4.166666666666661e-02*G7_1_2_10_0_2_1 - 4.166666666666661e-02*G7_1_2_10_0_3_2 + 4.166666666666660e-02*G7_1_2_11_0_0_0 + 4.166666666666661e-02*G7_1_2_11_0_0_1 + 4.166666666666661e-02*G7_1_2_11_0_0_2 - 4.166666666666660e-02*G7_1_2_11_0_1_0 - 4.166666666666661e-02*G7_1_2_11_0_2_1 - 4.166666666666661e-02*G7_1_2_11_0_3_2 + 8.333333333333320e-02*G8_1_0_0_0_0 + 8.333333333333322e-02*G8_1_0_0_0_1 + 8.333333333333320e-02*G8_1_0_0_0_2 - 8.333333333333320e-02*G8_1_0_0_1_0 - 8.333333333333322e-02*G8_1_0_0_2_1 - 8.333333333333322e-02*G8_1_0_0_3_2 + 8.333333333333320e-02*G8_1_1_0_4_0 + 8.333333333333322e-02*G8_1_1_0_4_1 + 8.333333333333322e-02*G8_1_1_0_4_2 - 8.333333333333320e-02*G8_1_1_0_5_0 - 8.333333333333322e-02*G8_1_1_0_6_1 - 8.333333333333322e-02*G8_1_1_0_7_2 + 8.333333333333320e-02*G8_1_2_0_8_0 + 8.333333333333322e-02*G8_1_2_0_8_1 + 8.333333333333322e-02*G8_1_2_0_8_2 - 8.333333333333320e-02*G8_1_2_0_9_0 - 8.333333333333322e-02*G8_1_2_0_10_1 - 8.333333333333322e-02*G8_1_2_0_11_2;
    block[6] = 8.333333333333307e-03*G0_4 + 8.333333333333312e-03*G0_5 + 1.666666666666662e-02*G0_6 + 8.333333333333312e-03*G0_7 + 8.333333333333307e-03*G1_4 + 8.333333333333312e-03*G1_5 + 1.666666666666662e-02*G1_6 + 8.333333333333312e-03*G1_7 + 4.166666666666662e-02*G2_1_1_0 + 4.166666666666662e-02*G2_1_1_1 + 4.166666666666662e-02*G2_1_1_2 + 4.166666666666662e-02*G2_1_1_3 + 1.666666666666662e-02*G3_0_0_1_4 + 8.333333333333311e-03*G3_0_0_1_5 + 8.333333333333312e-03*G3_0_0_1_6 + 8.333333333333314e-03*G3_0_0_1_7 + 8.333333333333309e-03*G3_0_1_1_4 + 1.666666666666662e-02*G3_0_1_1_5 + 8.333333333333309e-03*G3_0_1_1_6 + 8.333333333333311e-03*G3_0_1_1_7 + 8.333333333333307e-03*G3_0_2_1_4 + 8.333333333333312e-03*G3_0_2_1_5 + 1.666666666666662e-02*G3_0_2_1_6 + 8.333333333333312e-03*G3_0_2_1_7 + 8.333333333333314e-03*G3_0_3_1_4 + 8.333333333333314e-03*G3_0_3_1_5 + 8.333333333333312e-03*G3_0_3_1_6 + 1.666666666666662e-02*G3_0_3_1_7 + 1.666666666666662e-02*G3_1_4_1_4 + 8.333333333333309e-03*G3_1_4_1_5 + 8.333333333333309e-03*G3_1_4_1_6 + 8.333333333333314e-03*G3_1_4_1_7 + 8.333333333333309e-03*G3_1_5_1_4 + 1.666666666666662e-02*G3_1_5_1_5 + 8.333333333333312e-03*G3_1_5_1_6 + 8.333333333333314e-03*G3_1_5_1_7 + 8.333333333333307e-03*G3_1_6_1_4 + 8.333333333333312e-03*G3_1_6_1_5 + 1.666666666666662e-02*G3_1_6_1_6 + 8.333333333333312e-03*G3_1_6_1_7 + 8.333333333333314e-03*G3_1_7_1_4 + 8.333333333333314e-03*G3_1_7_1_5 + 8.333333333333312e-03*G3_1_7_1_6 + 1.666666666666662e-02*G3_1_7_1_7 + 1.666666666666662e-02*G3_2_8_1_4 + 8.333333333333309e-03*G3_2_8_1_5 + 8.333333333333309e-03*G3_2_8_1_6 + 8.333333333333314e-03*G3_2_8_1_7 + 8.333333333333309e-03*G3_2_9_1_4 + 1.666666666666662e-02*G3_2_9_1_5 + 8.333333333333312e-03*G3_2_9_1_6 + 8.333333333333314e-03*G3_2_9_1_7 + 8.333333333333307e-03*G3_2_10_1_4 + 8.333333333333312e-03*G3_2_10_1_5 + 1.666666666666662e-02*G3_2_10_1_6 + 8.333333333333312e-03*G3_2_10_1_7 + 8.333333333333314e-03*G3_2_11_1_4 + 8.333333333333314e-03*G3_2_11_1_5 + 8.333333333333312e-03*G3_2_11_1_6 + 1.666666666666662e-02*G3_2_11_1_7 + 8.333333333333322e-02*G4_1_4_0 + 8.333333333333323e-02*G4_1_4_1 + 8.333333333333323e-02*G4_1_4_2 - 8.333333333333322e-02*G4_1_5_0 - 8.333333333333323e-02*G4_1_6_1 - 8.333333333333323e-02*G4_1_7_2 + 4.166666666666654e-03*G5_0_0_4_0 + 4.166666666666656e-03*G5_0_0_4_1 + 4.166666666666656e-03*G5_0_0_4_2 - 4.166666666666654e-03*G5_0_0_5_0 - 4.166666666666656e-03*G5_0_0_6_1 - 4.166666666666656e-03*G5_0_0_7_2 + 4.166666666666654e-03*G5_0_1_4_0 + 4.166666666666654e-03*G5_0_1_4_1 + 4.166666666666654e-03*G5_0_1_4_2 - 4.166666666666654e-03*G5_0_1_5_0 - 4.166666666666654e-03*G5_0_1_6_1 - 4.166666666666654e-03*G5_0_1_7_2 + 8.333333333333311e-03*G5_0_2_4_0 + 8.333333333333311e-03*G5_0_2_4_1 + 8.333333333333312e-03*G5_0_2_4_2 - 8.333333333333311e-03*G5_0_2_5_0 - 8.333333333333311e-03*G5_0_2_6_1 - 8.333333333333311e-03*G5_0_2_7_2 + 4.166666666666655e-03*G5_0_3_4_0 + 4.166666666666656e-03*G5_0_3_4_1 + 4.166666666666657e-03*G5_0_3_4_2 - 4.166666666666655e-03*G5_0_3_5_0 - 4.166666666666656e-03*G5_0_3_6_1 - 4.166666666666656e-03*G5_0_3_7_2 + 4.166666666666654e-03*G5_1_4_4_0 + 4.166666666666654e-03*G5_1_4_4_1 + 4.166666666666654e-03*G5_1_4_4_2 - 4.166666666666654e-03*G5_1_4_5_0 - 4.166666666666654e-03*G5_1_4_6_1 - 4.166666666666654e-03*G5_1_4_7_2 + 4.166666666666655e-03*G5_1_5_4_0 + 4.166666666666656e-03*G5_1_5_4_1 + 4.166666666666656e-03*G5_1_5_4_2 - 4.166666666666655e-03*G5_1_5_5_0 - 4.166666666666656e-03*G5_1_5_6_1 - 4.166666666666656e-03*G5_1_5_7_2 + 8.333333333333311e-03*G5_1_6_4_0 + 8.333333333333311e-03*G5_1_6_4_1 + 8.333333333333312e-03*G5_1_6_4_2 - 8.333333333333311e-03*G5_1_6_5_0 - 8.333333333333311e-03*G5_1_6_6_1 - 8.333333333333311e-03*G5_1_6_7_2 + 4.166666666666655e-03*G5_1_7_4_0 + 4.166666666666656e-03*G5_1_7_4_1 + 4.166666666666657e-03*G5_1_7_4_2 - 4.166666666666655e-03*G5_1_7_5_0 - 4.166666666666656e-03*G5_1_7_6_1 - 4.166666666666656e-03*G5_1_7_7_2 + 4.166666666666654e-03*G5_2_8_4_0 + 4.166666666666654e-03*G5_2_8_4_1 + 4.166666666666654e-03*G5_2_8_4_2 - 4.166666666666654e-03*G5_2_8_5_0 - 4.166666666666654e-03*G5_2_8_6_1 - 4.166666666666654e-03*G5_2_8_7_2 + 4.166666666666655e-03*G5_2_9_4_0 + 4.166666666666656e-03*G5_2_9_4_1 + 4.166666666666656e-03*G5_2_9_4_2 - 4.166666666666655e-03*G5_2_9_5_0 - 4.166666666666656e-03*G5_2_9_6_1 - 4.166666666666656e-03*G5_2_9_7_2 + 8.333333333333311e-03*G5_2_10_4_0 + 8.333333333333311e-03*G5_2_10_4_1 + 8.333333333333312e-03*G5_2_10_4_2 - 8.333333333333311e-03*G5_2_10_5_0 - 8.333333333333311e-03*G5_2_10_6_1 - 8.333333333333311e-03*G5_2_10_7_2 + 4.166666666666655e-03*G5_2_11_4_0 + 4.166666666666656e-03*G5_2_11_4_1 + 4.166666666666657e-03*G5_2_11_4_2 - 4.166666666666655e-03*G5_2_11_5_0 - 4.166666666666656e-03*G5_2_11_6_1 - 4.166666666666656e-03*G5_2_11_7_2 + 8.333333333333309e-03*G6_0_0_0_1_0_4_0 + 8.333333333333311e-03*G6_0_0_0_1_0_4_1 + 8.333333333333312e-03*G6_0_0_0_1_0_4_2 - 8.333333333333309e-03*G6_0_0_0_1_0_5_0 - 8.333333333333311e-03*G6_0_0_0_1_0_6_1 - 8.333333333333311e-03*G6_0_0_0_1_0_7_2 + 4.166666666666654e-03*G6_0_0_0_1_1_4_0 + 4.166666666666655e-03*G6_0_0_0_1_1_4_1 + 4.166666666666655e-03*G6_0_0_0_1_1_4_2 - 4.166666666666654e-03*G6_0_0_0_1_1_5_0 - 4.166666666666655e-03*G6_0_0_0_1_1_6_1 - 4.166666666666655e-03*G6_0_0_0_1_1_7_2 + 4.166666666666654e-03*G6_0_0_0_1_2_4_0 + 4.166666666666656e-03*G6_0_0_0_1_2_4_1 + 4.166666666666656e-03*G6_0_0_0_1_2_4_2 - 4.166666666666654e-03*G6_0_0_0_1_2_5_0 - 4.166666666666656e-03*G6_0_0_0_1_2_6_1 - 4.166666666666656e-03*G6_0_0_0_1_2_7_2 + 4.166666666666656e-03*G6_0_0_0_1_3_4_0 + 4.166666666666657e-03*G6_0_0_0_1_3_4_1 + 4.166666666666658e-03*G6_0_0_0_1_3_4_2 - 4.166666666666656e-03*G6_0_0_0_1_3_5_0 - 4.166666666666657e-03*G6_0_0_0_1_3_6_1 - 4.166666666666657e-03*G6_0_0_0_1_3_7_2 + 4.166666666666654e-03*G6_0_0_1_1_0_4_0 + 4.166666666666655e-03*G6_0_0_1_1_0_4_1 + 4.166666666666655e-03*G6_0_0_1_1_0_4_2 - 4.166666666666654e-03*G6_0_0_1_1_0_5_0 - 4.166666666666655e-03*G6_0_0_1_1_0_6_1 - 4.166666666666655e-03*G6_0_0_1_1_0_7_2 + 8.333333333333307e-03*G6_0_0_1_1_1_4_0 + 8.333333333333309e-03*G6_0_0_1_1_1_4_1 + 8.333333333333309e-03*G6_0_0_1_1_1_4_2 - 8.333333333333307e-03*G6_0_0_1_1_1_5_0 - 8.333333333333309e-03*G6_0_0_1_1_1_6_1 - 8.333333333333309e-03*G6_0_0_1_1_1_7_2 + 4.166666666666654e-03*G6_0_0_1_1_2_4_0 + 4.166666666666654e-03*G6_0_0_1_1_2_4_1 + 4.166666666666655e-03*G6_0_0_1_1_2_4_2 - 4.166666666666654e-03*G6_0_0_1_1_2_5_0 - 4.166666666666654e-03*G6_0_0_1_1_2_6_1 - 4.166666666666654e-03*G6_0_0_1_1_2_7_2 + 4.166666666666655e-03*G6_0_0_1_1_3_4_0 + 4.166666666666655e-03*G6_0_0_1_1_3_4_1 + 4.166666666666656e-03*G6_0_0_1_1_3_4_2 - 4.166666666666655e-03*G6_0_0_1_1_3_5_0 - 4.166666666666655e-03*G6_0_0_1_1_3_6_1 - 4.166666666666655e-03*G6_0_0_1_1_3_7_2 + 4.166666666666654e-03*G6_0_0_2_1_0_4_0 + 4.166666666666656e-03*G6_0_0_2_1_0_4_1 + 4.166666666666656e-03*G6_0_0_2_1_0_4_2 - 4.166666666666654e-03*G6_0_0_2_1_0_5_0 - 4.166666666666656e-03*G6_0_0_2_1_0_6_1 - 4.166666666666656e-03*G6_0_0_2_1_0_7_2 + 4.166666666666654e-03*G6_0_0_2_1_1_4_0 + 4.166666666666654e-03*G6_0_0_2_1_1_4_1 + 4.166666666666654e-03*G6_0_0_2_1_1_4_2 - 4.166666666666654e-03*G6_0_0_2_1_1_5_0 - 4.166666666666654e-03*G6_0_0_2_1_1_6_1 - 4.166666666666654e-03*G6_0_0_2_1_1_7_2 + 8.333333333333311e-03*G6_0_0_2_1_2_4_0 + 8.333333333333311e-03*G6_0_0_2_1_2_4_1 + 8.333333333333312e-03*G6_0_0_2_1_2_4_2 - 8.333333333333311e-03*G6_0_0_2_1_2_5_0 - 8.333333333333311e-03*G6_0_0_2_1_2_6_1 - 8.333333333333311e-03*G6_0_0_2_1_2_7_2 + 4.166666666666655e-03*G6_0_0_2_1_3_4_0 + 4.166666666666656e-03*G6_0_0_2_1_3_4_1 + 4.166666666666657e-03*G6_0_0_2_1_3_4_2 - 4.166666666666655e-03*G6_0_0_2_1_3_5_0 - 4.166666666666656e-03*G6_0_0_2_1_3_6_1 - 4.166666666666656e-03*G6_0_0_2_1_3_7_2 + 4.166666666666656e-03*G6_0_0_3_1_0_4_0 + 4.166666666666657e-03*G6_0_0_3_1_0_4_1 + 4.166666666666658e-03*G6_0_0_3_1_0_4_2 - 4.166666666666656e-03*G6_0_0_3_1_0_5_0 - 4.166666666666657e-03*G6_0_0_3_1_0_6_1 - 4.166666666666657e-03*G6_0_0_3_1_0_7_2 + 4.166666666666655e-03*G6_0_0_3_1_1_4_0 + 4.166666666666655e-03*G6_0_0_3_1_1_4_1 + 4.166666666666656e-03*G6_0_0_3_1_1_4_2 - 4.166666666666655e-03*G6_0_0_3_1_1_5_0 - 4.166666666666655e-03*G6_0_0_3_1_1_6_1 - 4.166666666666655e-03*G6_0_0_3_1_1_7_2 + 4.166666666666655e-03*G6_0_0_3_1_2_4_0 + 4.166666666666656e-03*G6_0_0_3_1_2_4_1 + 4.166666666666657e-03*G6_0_0_3_1_2_4_2 - 4.166666666666655e-03*G6_0_0_3_1_2_5_0 - 4.166666666666656e-03*G6_0_0_3_1_2_6_1 - 4.166666666666656e-03*G6_0_0_3_1_2_7_2 + 8.333333333333311e-03*G6_0_0_3_1_3_4_0 + 8.333333333333311e-03*G6_0_0_3_1_3_4_1 + 8.333333333333312e-03*G6_0_0_3_1_3_4_2 - 8.333333333333311e-03*G6_0_0_3_1_3_5_0 - 8.333333333333311e-03*G6_0_0_3_1_3_6_1 - 8.333333333333311e-03*G6_0_0_3_1_3_7_2 + 8.333333333333309e-03*G6_0_1_0_1_4_4_0 + 8.333333333333311e-03*G6_0_1_0_1_4_4_1 + 8.333333333333312e-03*G6_0_1_0_1_4_4_2 - 8.333333333333309e-03*G6_0_1_0_1_4_5_0 - 8.333333333333311e-03*G6_0_1_0_1_4_6_1 - 8.333333333333311e-03*G6_0_1_0_1_4_7_2 + 4.166666666666655e-03*G6_0_1_0_1_5_4_0 + 4.166666666666655e-03*G6_0_1_0_1_5_4_1 + 4.166666666666656e-03*G6_0_1_0_1_5_4_2 - 4.166666666666655e-03*G6_0_1_0_1_5_5_0 - 4.166666666666655e-03*G6_0_1_0_1_5_6_1 - 4.166666666666655e-03*G6_0_1_0_1_5_7_2 + 4.166666666666654e-03*G6_0_1_0_1_6_4_0 + 4.166666666666656e-03*G6_0_1_0_1_6_4_1 + 4.166666666666656e-03*G6_0_1_0_1_6_4_2 - 4.166666666666654e-03*G6_0_1_0_1_6_5_0 - 4.166666666666656e-03*G6_0_1_0_1_6_6_1 - 4.166666666666656e-03*G6_0_1_0_1_6_7_2 + 4.166666666666656e-03*G6_0_1_0_1_7_4_0 + 4.166666666666657e-03*G6_0_1_0_1_7_4_1 + 4.166666666666658e-03*G6_0_1_0_1_7_4_2 - 4.166666666666656e-03*G6_0_1_0_1_7_5_0 - 4.166666666666657e-03*G6_0_1_0_1_7_6_1 - 4.166666666666657e-03*G6_0_1_0_1_7_7_2 + 4.166666666666654e-03*G6_0_1_1_1_4_4_0 + 4.166666666666654e-03*G6_0_1_1_1_4_4_1 + 4.166666666666654e-03*G6_0_1_1_1_4_4_2 - 4.166666666666654e-03*G6_0_1_1_1_4_5_0 - 4.166666666666654e-03*G6_0_1_1_1_4_6_1 - 4.166666666666654e-03*G6_0_1_1_1_4_7_2 + 8.333333333333309e-03*G6_0_1_1_1_5_4_0 + 8.333333333333309e-03*G6_0_1_1_1_5_4_1 + 8.333333333333309e-03*G6_0_1_1_1_5_4_2 - 8.333333333333309e-03*G6_0_1_1_1_5_5_0 - 8.333333333333309e-03*G6_0_1_1_1_5_6_1 - 8.333333333333309e-03*G6_0_1_1_1_5_7_2 + 4.166666666666654e-03*G6_0_1_1_1_6_4_0 + 4.166666666666654e-03*G6_0_1_1_1_6_4_1 + 4.166666666666655e-03*G6_0_1_1_1_6_4_2 - 4.166666666666654e-03*G6_0_1_1_1_6_5_0 - 4.166666666666654e-03*G6_0_1_1_1_6_6_1 - 4.166666666666654e-03*G6_0_1_1_1_6_7_2 + 4.166666666666655e-03*G6_0_1_1_1_7_4_0 + 4.166666666666655e-03*G6_0_1_1_1_7_4_1 + 4.166666666666656e-03*G6_0_1_1_1_7_4_2 - 4.166666666666655e-03*G6_0_1_1_1_7_5_0 - 4.166666666666655e-03*G6_0_1_1_1_7_6_1 - 4.166666666666655e-03*G6_0_1_1_1_7_7_2 + 4.166666666666654e-03*G6_0_1_2_1_4_4_0 + 4.166666666666654e-03*G6_0_1_2_1_4_4_1 + 4.166666666666654e-03*G6_0_1_2_1_4_4_2 - 4.166666666666654e-03*G6_0_1_2_1_4_5_0 - 4.166666666666654e-03*G6_0_1_2_1_4_6_1 - 4.166666666666654e-03*G6_0_1_2_1_4_7_2 + 4.166666666666655e-03*G6_0_1_2_1_5_4_0 + 4.166666666666656e-03*G6_0_1_2_1_5_4_1 + 4.166666666666656e-03*G6_0_1_2_1_5_4_2 - 4.166666666666655e-03*G6_0_1_2_1_5_5_0 - 4.166666666666656e-03*G6_0_1_2_1_5_6_1 - 4.166666666666656e-03*G6_0_1_2_1_5_7_2 + 8.333333333333311e-03*G6_0_1_2_1_6_4_0 + 8.333333333333311e-03*G6_0_1_2_1_6_4_1 + 8.333333333333312e-03*G6_0_1_2_1_6_4_2 - 8.333333333333311e-03*G6_0_1_2_1_6_5_0 - 8.333333333333311e-03*G6_0_1_2_1_6_6_1 - 8.333333333333311e-03*G6_0_1_2_1_6_7_2 + 4.166666666666655e-03*G6_0_1_2_1_7_4_0 + 4.166666666666656e-03*G6_0_1_2_1_7_4_1 + 4.166666666666657e-03*G6_0_1_2_1_7_4_2 - 4.166666666666655e-03*G6_0_1_2_1_7_5_0 - 4.166666666666656e-03*G6_0_1_2_1_7_6_1 - 4.166666666666656e-03*G6_0_1_2_1_7_7_2 + 4.166666666666656e-03*G6_0_1_3_1_4_4_0 + 4.166666666666657e-03*G6_0_1_3_1_4_4_1 + 4.166666666666657e-03*G6_0_1_3_1_4_4_2 - 4.166666666666656e-03*G6_0_1_3_1_4_5_0 - 4.166666666666657e-03*G6_0_1_3_1_4_6_1 - 4.166666666666657e-03*G6_0_1_3_1_4_7_2 + 4.166666666666656e-03*G6_0_1_3_1_5_4_0 + 4.166666666666657e-03*G6_0_1_3_1_5_4_1 + 4.166666666666657e-03*G6_0_1_3_1_5_4_2 - 4.166666666666656e-03*G6_0_1_3_1_5_5_0 - 4.166666666666657e-03*G6_0_1_3_1_5_6_1 - 4.166666666666657e-03*G6_0_1_3_1_5_7_2 + 4.166666666666655e-03*G6_0_1_3_1_6_4_0 + 4.166666666666656e-03*G6_0_1_3_1_6_4_1 + 4.166666666666657e-03*G6_0_1_3_1_6_4_2 - 4.166666666666655e-03*G6_0_1_3_1_6_5_0 - 4.166666666666656e-03*G6_0_1_3_1_6_6_1 - 4.166666666666656e-03*G6_0_1_3_1_6_7_2 + 8.333333333333311e-03*G6_0_1_3_1_7_4_0 + 8.333333333333311e-03*G6_0_1_3_1_7_4_1 + 8.333333333333312e-03*G6_0_1_3_1_7_4_2 - 8.333333333333311e-03*G6_0_1_3_1_7_5_0 - 8.333333333333311e-03*G6_0_1_3_1_7_6_1 - 8.333333333333311e-03*G6_0_1_3_1_7_7_2 + 8.333333333333309e-03*G6_0_2_0_1_8_4_0 + 8.333333333333311e-03*G6_0_2_0_1_8_4_1 + 8.333333333333312e-03*G6_0_2_0_1_8_4_2 - 8.333333333333309e-03*G6_0_2_0_1_8_5_0 - 8.333333333333311e-03*G6_0_2_0_1_8_6_1 - 8.333333333333311e-03*G6_0_2_0_1_8_7_2 + 4.166666666666655e-03*G6_0_2_0_1_9_4_0 + 4.166666666666655e-03*G6_0_2_0_1_9_4_1 + 4.166666666666656e-03*G6_0_2_0_1_9_4_2 - 4.166666666666655e-03*G6_0_2_0_1_9_5_0 - 4.166666666666655e-03*G6_0_2_0_1_9_6_1 - 4.166666666666655e-03*G6_0_2_0_1_9_7_2 + 4.166666666666654e-03*G6_0_2_0_1_10_4_0 + 4.166666666666656e-03*G6_0_2_0_1_10_4_1 + 4.166666666666656e-03*G6_0_2_0_1_10_4_2 - 4.166666666666654e-03*G6_0_2_0_1_10_5_0 - 4.166666666666656e-03*G6_0_2_0_1_10_6_1 - 4.166666666666656e-03*G6_0_2_0_1_10_7_2 + 4.166666666666656e-03*G6_0_2_0_1_11_4_0 + 4.166666666666657e-03*G6_0_2_0_1_11_4_1 + 4.166666666666658e-03*G6_0_2_0_1_11_4_2 - 4.166666666666656e-03*G6_0_2_0_1_11_5_0 - 4.166666666666657e-03*G6_0_2_0_1_11_6_1 - 4.166666666666657e-03*G6_0_2_0_1_11_7_2 + 4.166666666666654e-03*G6_0_2_1_1_8_4_0 + 4.166666666666654e-03*G6_0_2_1_1_8_4_1 + 4.166666666666654e-03*G6_0_2_1_1_8_4_2 - 4.166666666666654e-03*G6_0_2_1_1_8_5_0 - 4.166666666666654e-03*G6_0_2_1_1_8_6_1 - 4.166666666666654e-03*G6_0_2_1_1_8_7_2 + 8.333333333333309e-03*G6_0_2_1_1_9_4_0 + 8.333333333333309e-03*G6_0_2_1_1_9_4_1 + 8.333333333333309e-03*G6_0_2_1_1_9_4_2 - 8.333333333333309e-03*G6_0_2_1_1_9_5_0 - 8.333333333333309e-03*G6_0_2_1_1_9_6_1 - 8.333333333333309e-03*G6_0_2_1_1_9_7_2 + 4.166666666666654e-03*G6_0_2_1_1_10_4_0 + 4.166666666666654e-03*G6_0_2_1_1_10_4_1 + 4.166666666666655e-03*G6_0_2_1_1_10_4_2 - 4.166666666666654e-03*G6_0_2_1_1_10_5_0 - 4.166666666666654e-03*G6_0_2_1_1_10_6_1 - 4.166666666666654e-03*G6_0_2_1_1_10_7_2 + 4.166666666666655e-03*G6_0_2_1_1_11_4_0 + 4.166666666666655e-03*G6_0_2_1_1_11_4_1 + 4.166666666666656e-03*G6_0_2_1_1_11_4_2 - 4.166666666666655e-03*G6_0_2_1_1_11_5_0 - 4.166666666666655e-03*G6_0_2_1_1_11_6_1 - 4.166666666666655e-03*G6_0_2_1_1_11_7_2 + 4.166666666666654e-03*G6_0_2_2_1_8_4_0 + 4.166666666666654e-03*G6_0_2_2_1_8_4_1 + 4.166666666666654e-03*G6_0_2_2_1_8_4_2 - 4.166666666666654e-03*G6_0_2_2_1_8_5_0 - 4.166666666666654e-03*G6_0_2_2_1_8_6_1 - 4.166666666666654e-03*G6_0_2_2_1_8_7_2 + 4.166666666666655e-03*G6_0_2_2_1_9_4_0 + 4.166666666666656e-03*G6_0_2_2_1_9_4_1 + 4.166666666666656e-03*G6_0_2_2_1_9_4_2 - 4.166666666666655e-03*G6_0_2_2_1_9_5_0 - 4.166666666666656e-03*G6_0_2_2_1_9_6_1 - 4.166666666666656e-03*G6_0_2_2_1_9_7_2 + 8.333333333333311e-03*G6_0_2_2_1_10_4_0 + 8.333333333333311e-03*G6_0_2_2_1_10_4_1 + 8.333333333333312e-03*G6_0_2_2_1_10_4_2 - 8.333333333333311e-03*G6_0_2_2_1_10_5_0 - 8.333333333333311e-03*G6_0_2_2_1_10_6_1 - 8.333333333333311e-03*G6_0_2_2_1_10_7_2 + 4.166666666666655e-03*G6_0_2_2_1_11_4_0 + 4.166666666666656e-03*G6_0_2_2_1_11_4_1 + 4.166666666666657e-03*G6_0_2_2_1_11_4_2 - 4.166666666666655e-03*G6_0_2_2_1_11_5_0 - 4.166666666666656e-03*G6_0_2_2_1_11_6_1 - 4.166666666666656e-03*G6_0_2_2_1_11_7_2 + 4.166666666666656e-03*G6_0_2_3_1_8_4_0 + 4.166666666666657e-03*G6_0_2_3_1_8_4_1 + 4.166666666666657e-03*G6_0_2_3_1_8_4_2 - 4.166666666666656e-03*G6_0_2_3_1_8_5_0 - 4.166666666666657e-03*G6_0_2_3_1_8_6_1 - 4.166666666666657e-03*G6_0_2_3_1_8_7_2 + 4.166666666666656e-03*G6_0_2_3_1_9_4_0 + 4.166666666666657e-03*G6_0_2_3_1_9_4_1 + 4.166666666666657e-03*G6_0_2_3_1_9_4_2 - 4.166666666666656e-03*G6_0_2_3_1_9_5_0 - 4.166666666666657e-03*G6_0_2_3_1_9_6_1 - 4.166666666666657e-03*G6_0_2_3_1_9_7_2 + 4.166666666666655e-03*G6_0_2_3_1_10_4_0 + 4.166666666666656e-03*G6_0_2_3_1_10_4_1 + 4.166666666666657e-03*G6_0_2_3_1_10_4_2 - 4.166666666666655e-03*G6_0_2_3_1_10_5_0 - 4.166666666666656e-03*G6_0_2_3_1_10_6_1 - 4.166666666666656e-03*G6_0_2_3_1_10_7_2 + 8.333333333333311e-03*G6_0_2_3_1_11_4_0 + 8.333333333333311e-03*G6_0_2_3_1_11_4_1 + 8.333333333333312e-03*G6_0_2_3_1_11_4_2 - 8.333333333333311e-03*G6_0_2_3_1_11_5_0 - 8.333333333333311e-03*G6_0_2_3_1_11_6_1 - 8.333333333333311e-03*G6_0_2_3_1_11_7_2 + 8.333333333333309e-03*G6_1_0_4_1_0_4_0 + 8.333333333333311e-03*G6_1_0_4_1_0_4_1 + 8.333333333333312e-03*G6_1_0_4_1_0_4_2 - 8.333333333333309e-03*G6_1_0_4_1_0_5_0 - 8.333333333333311e-03*G6_1_0_4_1_0_6_1 - 8.333333333333311e-03*G6_1_0_4_1_0_7_2 + 4.166666666666654e-03*G6_1_0_4_1_1_4_0 + 4.166666666666654e-03*G6_1_0_4_1_1_4_1 + 4.166666666666654e-03*G6_1_0_4_1_1_4_2 - 4.166666666666654e-03*G6_1_0_4_1_1_5_0 - 4.166666666666654e-03*G6_1_0_4_1_1_6_1 - 4.166666666666654e-03*G6_1_0_4_1_1_7_2 + 4.166666666666654e-03*G6_1_0_4_1_2_4_0 + 4.166666666666654e-03*G6_1_0_4_1_2_4_1 + 4.166666666666654e-03*G6_1_0_4_1_2_4_2 - 4.166666666666654e-03*G6_1_0_4_1_2_5_0 - 4.166666666666654e-03*G6_1_0_4_1_2_6_1 - 4.166666666666654e-03*G6_1_0_4_1_2_7_2 + 4.166666666666656e-03*G6_1_0_4_1_3_4_0 + 4.166666666666657e-03*G6_1_0_4_1_3_4_1 + 4.166666666666657e-03*G6_1_0_4_1_3_4_2 - 4.166666666666656e-03*G6_1_0_4_1_3_5_0 - 4.166666666666657e-03*G6_1_0_4_1_3_6_1 - 4.166666666666657e-03*G6_1_0_4_1_3_7_2 + 4.166666666666655e-03*G6_1_0_5_1_0_4_0 + 4.166666666666655e-03*G6_1_0_5_1_0_4_1 + 4.166666666666656e-03*G6_1_0_5_1_0_4_2 - 4.166666666666655e-03*G6_1_0_5_1_0_5_0 - 4.166666666666655e-03*G6_1_0_5_1_0_6_1 - 4.166666666666655e-03*G6_1_0_5_1_0_7_2 + 8.333333333333309e-03*G6_1_0_5_1_1_4_0 + 8.333333333333309e-03*G6_1_0_5_1_1_4_1 + 8.333333333333309e-03*G6_1_0_5_1_1_4_2 - 8.333333333333309e-03*G6_1_0_5_1_1_5_0 - 8.333333333333309e-03*G6_1_0_5_1_1_6_1 - 8.333333333333309e-03*G6_1_0_5_1_1_7_2 + 4.166666666666655e-03*G6_1_0_5_1_2_4_0 + 4.166666666666656e-03*G6_1_0_5_1_2_4_1 + 4.166666666666656e-03*G6_1_0_5_1_2_4_2 - 4.166666666666655e-03*G6_1_0_5_1_2_5_0 - 4.166666666666656e-03*G6_1_0_5_1_2_6_1 - 4.166666666666656e-03*G6_1_0_5_1_2_7_2 + 4.166666666666656e-03*G6_1_0_5_1_3_4_0 + 4.166666666666657e-03*G6_1_0_5_1_3_4_1 + 4.166666666666657e-03*G6_1_0_5_1_3_4_2 - 4.166666666666656e-03*G6_1_0_5_1_3_5_0 - 4.166666666666657e-03*G6_1_0_5_1_3_6_1 - 4.166666666666657e-03*G6_1_0_5_1_3_7_2 + 4.166666666666654e-03*G6_1_0_6_1_0_4_0 + 4.166666666666656e-03*G6_1_0_6_1_0_4_1 + 4.166666666666656e-03*G6_1_0_6_1_0_4_2 - 4.166666666666654e-03*G6_1_0_6_1_0_5_0 - 4.166666666666656e-03*G6_1_0_6_1_0_6_1 - 4.166666666666656e-03*G6_1_0_6_1_0_7_2 + 4.166666666666654e-03*G6_1_0_6_1_1_4_0 + 4.166666666666654e-03*G6_1_0_6_1_1_4_1 + 4.166666666666654e-03*G6_1_0_6_1_1_4_2 - 4.166666666666654e-03*G6_1_0_6_1_1_5_0 - 4.166666666666654e-03*G6_1_0_6_1_1_6_1 - 4.166666666666654e-03*G6_1_0_6_1_1_7_2 + 8.333333333333311e-03*G6_1_0_6_1_2_4_0 + 8.333333333333311e-03*G6_1_0_6_1_2_4_1 + 8.333333333333312e-03*G6_1_0_6_1_2_4_2 - 8.333333333333311e-03*G6_1_0_6_1_2_5_0 - 8.333333333333311e-03*G6_1_0_6_1_2_6_1 - 8.333333333333311e-03*G6_1_0_6_1_2_7_2 + 4.166666666666655e-03*G6_1_0_6_1_3_4_0 + 4.166666666666656e-03*G6_1_0_6_1_3_4_1 + 4.166666666666657e-03*G6_1_0_6_1_3_4_2 - 4.166666666666655e-03*G6_1_0_6_1_3_5_0 - 4.166666666666656e-03*G6_1_0_6_1_3_6_1 - 4.166666666666656e-03*G6_1_0_6_1_3_7_2 + 4.166666666666656e-03*G6_1_0_7_1_0_4_0 + 4.166666666666657e-03*G6_1_0_7_1_0_4_1 + 4.166666666666658e-03*G6_1_0_7_1_0_4_2 - 4.166666666666656e-03*G6_1_0_7_1_0_5_0 - 4.166666666666657e-03*G6_1_0_7_1_0_6_1 - 4.166666666666657e-03*G6_1_0_7_1_0_7_2 + 4.166666666666655e-03*G6_1_0_7_1_1_4_0 + 4.166666666666655e-03*G6_1_0_7_1_1_4_1 + 4.166666666666656e-03*G6_1_0_7_1_1_4_2 - 4.166666666666655e-03*G6_1_0_7_1_1_5_0 - 4.166666666666655e-03*G6_1_0_7_1_1_6_1 - 4.166666666666655e-03*G6_1_0_7_1_1_7_2 + 4.166666666666655e-03*G6_1_0_7_1_2_4_0 + 4.166666666666656e-03*G6_1_0_7_1_2_4_1 + 4.166666666666657e-03*G6_1_0_7_1_2_4_2 - 4.166666666666655e-03*G6_1_0_7_1_2_5_0 - 4.166666666666656e-03*G6_1_0_7_1_2_6_1 - 4.166666666666656e-03*G6_1_0_7_1_2_7_2 + 8.333333333333311e-03*G6_1_0_7_1_3_4_0 + 8.333333333333311e-03*G6_1_0_7_1_3_4_1 + 8.333333333333312e-03*G6_1_0_7_1_3_4_2 - 8.333333333333311e-03*G6_1_0_7_1_3_5_0 - 8.333333333333311e-03*G6_1_0_7_1_3_6_1 - 8.333333333333311e-03*G6_1_0_7_1_3_7_2 + 8.333333333333309e-03*G6_1_1_4_1_4_4_0 + 8.333333333333311e-03*G6_1_1_4_1_4_4_1 + 8.333333333333312e-03*G6_1_1_4_1_4_4_2 - 8.333333333333309e-03*G6_1_1_4_1_4_5_0 - 8.333333333333311e-03*G6_1_1_4_1_4_6_1 - 8.333333333333311e-03*G6_1_1_4_1_4_7_2 + 4.166666666666654e-03*G6_1_1_4_1_5_4_0 + 4.166666666666654e-03*G6_1_1_4_1_5_4_1 + 4.166666666666655e-03*G6_1_1_4_1_5_4_2 - 4.166666666666654e-03*G6_1_1_4_1_5_5_0 - 4.166666666666654e-03*G6_1_1_4_1_5_6_1 - 4.166666666666654e-03*G6_1_1_4_1_5_7_2 + 4.166666666666654e-03*G6_1_1_4_1_6_4_0 + 4.166666666666654e-03*G6_1_1_4_1_6_4_1 + 4.166666666666654e-03*G6_1_1_4_1_6_4_2 - 4.166666666666654e-03*G6_1_1_4_1_6_5_0 - 4.166666666666654e-03*G6_1_1_4_1_6_6_1 - 4.166666666666654e-03*G6_1_1_4_1_6_7_2 + 4.166666666666656e-03*G6_1_1_4_1_7_4_0 + 4.166666666666657e-03*G6_1_1_4_1_7_4_1 + 4.166666666666657e-03*G6_1_1_4_1_7_4_2 - 4.166666666666656e-03*G6_1_1_4_1_7_5_0 - 4.166666666666657e-03*G6_1_1_4_1_7_6_1 - 4.166666666666657e-03*G6_1_1_4_1_7_7_2 + 4.166666666666654e-03*G6_1_1_5_1_4_4_0 + 4.166666666666654e-03*G6_1_1_5_1_4_4_1 + 4.166666666666655e-03*G6_1_1_5_1_4_4_2 - 4.166666666666654e-03*G6_1_1_5_1_4_5_0 - 4.166666666666654e-03*G6_1_1_5_1_4_6_1 - 4.166666666666654e-03*G6_1_1_5_1_4_7_2 + 8.333333333333309e-03*G6_1_1_5_1_5_4_0 + 8.333333333333309e-03*G6_1_1_5_1_5_4_1 + 8.333333333333309e-03*G6_1_1_5_1_5_4_2 - 8.333333333333309e-03*G6_1_1_5_1_5_5_0 - 8.333333333333309e-03*G6_1_1_5_1_5_6_1 - 8.333333333333309e-03*G6_1_1_5_1_5_7_2 + 4.166666666666655e-03*G6_1_1_5_1_6_4_0 + 4.166666666666656e-03*G6_1_1_5_1_6_4_1 + 4.166666666666656e-03*G6_1_1_5_1_6_4_2 - 4.166666666666655e-03*G6_1_1_5_1_6_5_0 - 4.166666666666656e-03*G6_1_1_5_1_6_6_1 - 4.166666666666656e-03*G6_1_1_5_1_6_7_2 + 4.166666666666656e-03*G6_1_1_5_1_7_4_0 + 4.166666666666657e-03*G6_1_1_5_1_7_4_1 + 4.166666666666657e-03*G6_1_1_5_1_7_4_2 - 4.166666666666656e-03*G6_1_1_5_1_7_5_0 - 4.166666666666657e-03*G6_1_1_5_1_7_6_1 - 4.166666666666657e-03*G6_1_1_5_1_7_7_2 + 4.166666666666654e-03*G6_1_1_6_1_4_4_0 + 4.166666666666654e-03*G6_1_1_6_1_4_4_1 + 4.166666666666654e-03*G6_1_1_6_1_4_4_2 - 4.166666666666654e-03*G6_1_1_6_1_4_5_0 - 4.166666666666654e-03*G6_1_1_6_1_4_6_1 - 4.166666666666654e-03*G6_1_1_6_1_4_7_2 + 4.166666666666655e-03*G6_1_1_6_1_5_4_0 + 4.166666666666656e-03*G6_1_1_6_1_5_4_1 + 4.166666666666656e-03*G6_1_1_6_1_5_4_2 - 4.166666666666655e-03*G6_1_1_6_1_5_5_0 - 4.166666666666656e-03*G6_1_1_6_1_5_6_1 - 4.166666666666656e-03*G6_1_1_6_1_5_7_2 + 8.333333333333311e-03*G6_1_1_6_1_6_4_0 + 8.333333333333311e-03*G6_1_1_6_1_6_4_1 + 8.333333333333312e-03*G6_1_1_6_1_6_4_2 - 8.333333333333311e-03*G6_1_1_6_1_6_5_0 - 8.333333333333311e-03*G6_1_1_6_1_6_6_1 - 8.333333333333311e-03*G6_1_1_6_1_6_7_2 + 4.166666666666655e-03*G6_1_1_6_1_7_4_0 + 4.166666666666656e-03*G6_1_1_6_1_7_4_1 + 4.166666666666657e-03*G6_1_1_6_1_7_4_2 - 4.166666666666655e-03*G6_1_1_6_1_7_5_0 - 4.166666666666656e-03*G6_1_1_6_1_7_6_1 - 4.166666666666656e-03*G6_1_1_6_1_7_7_2 + 4.166666666666656e-03*G6_1_1_7_1_4_4_0 + 4.166666666666657e-03*G6_1_1_7_1_4_4_1 + 4.166666666666657e-03*G6_1_1_7_1_4_4_2 - 4.166666666666656e-03*G6_1_1_7_1_4_5_0 - 4.166666666666657e-03*G6_1_1_7_1_4_6_1 - 4.166666666666657e-03*G6_1_1_7_1_4_7_2 + 4.166666666666656e-03*G6_1_1_7_1_5_4_0 + 4.166666666666657e-03*G6_1_1_7_1_5_4_1 + 4.166666666666657e-03*G6_1_1_7_1_5_4_2 - 4.166666666666656e-03*G6_1_1_7_1_5_5_0 - 4.166666666666657e-03*G6_1_1_7_1_5_6_1 - 4.166666666666657e-03*G6_1_1_7_1_5_7_2 + 4.166666666666655e-03*G6_1_1_7_1_6_4_0 + 4.166666666666656e-03*G6_1_1_7_1_6_4_1 + 4.166666666666657e-03*G6_1_1_7_1_6_4_2 - 4.166666666666655e-03*G6_1_1_7_1_6_5_0 - 4.166666666666656e-03*G6_1_1_7_1_6_6_1 - 4.166666666666656e-03*G6_1_1_7_1_6_7_2 + 8.333333333333311e-03*G6_1_1_7_1_7_4_0 + 8.333333333333311e-03*G6_1_1_7_1_7_4_1 + 8.333333333333312e-03*G6_1_1_7_1_7_4_2 - 8.333333333333311e-03*G6_1_1_7_1_7_5_0 - 8.333333333333311e-03*G6_1_1_7_1_7_6_1 - 8.333333333333311e-03*G6_1_1_7_1_7_7_2 + 8.333333333333309e-03*G6_1_2_4_1_8_4_0 + 8.333333333333311e-03*G6_1_2_4_1_8_4_1 + 8.333333333333312e-03*G6_1_2_4_1_8_4_2 - 8.333333333333309e-03*G6_1_2_4_1_8_5_0 - 8.333333333333311e-03*G6_1_2_4_1_8_6_1 - 8.333333333333311e-03*G6_1_2_4_1_8_7_2 + 4.166666666666654e-03*G6_1_2_4_1_9_4_0 + 4.166666666666654e-03*G6_1_2_4_1_9_4_1 + 4.166666666666655e-03*G6_1_2_4_1_9_4_2 - 4.166666666666654e-03*G6_1_2_4_1_9_5_0 - 4.166666666666654e-03*G6_1_2_4_1_9_6_1 - 4.166666666666654e-03*G6_1_2_4_1_9_7_2 + 4.166666666666654e-03*G6_1_2_4_1_10_4_0 + 4.166666666666654e-03*G6_1_2_4_1_10_4_1 + 4.166666666666654e-03*G6_1_2_4_1_10_4_2 - 4.166666666666654e-03*G6_1_2_4_1_10_5_0 - 4.166666666666654e-03*G6_1_2_4_1_10_6_1 - 4.166666666666654e-03*G6_1_2_4_1_10_7_2 + 4.166666666666656e-03*G6_1_2_4_1_11_4_0 + 4.166666666666657e-03*G6_1_2_4_1_11_4_1 + 4.166666666666657e-03*G6_1_2_4_1_11_4_2 - 4.166666666666656e-03*G6_1_2_4_1_11_5_0 - 4.166666666666657e-03*G6_1_2_4_1_11_6_1 - 4.166666666666657e-03*G6_1_2_4_1_11_7_2 + 4.166666666666654e-03*G6_1_2_5_1_8_4_0 + 4.166666666666654e-03*G6_1_2_5_1_8_4_1 + 4.166666666666655e-03*G6_1_2_5_1_8_4_2 - 4.166666666666654e-03*G6_1_2_5_1_8_5_0 - 4.166666666666654e-03*G6_1_2_5_1_8_6_1 - 4.166666666666654e-03*G6_1_2_5_1_8_7_2 + 8.333333333333309e-03*G6_1_2_5_1_9_4_0 + 8.333333333333309e-03*G6_1_2_5_1_9_4_1 + 8.333333333333309e-03*G6_1_2_5_1_9_4_2 - 8.333333333333309e-03*G6_1_2_5_1_9_5_0 - 8.333333333333309e-03*G6_1_2_5_1_9_6_1 - 8.333333333333309e-03*G6_1_2_5_1_9_7_2 + 4.166666666666655e-03*G6_1_2_5_1_10_4_0 + 4.166666666666656e-03*G6_1_2_5_1_10_4_1 + 4.166666666666656e-03*G6_1_2_5_1_10_4_2 - 4.166666666666655e-03*G6_1_2_5_1_10_5_0 - 4.166666666666656e-03*G6_1_2_5_1_10_6_1 - 4.166666666666656e-03*G6_1_2_5_1_10_7_2 + 4.166666666666656e-03*G6_1_2_5_1_11_4_0 + 4.166666666666657e-03*G6_1_2_5_1_11_4_1 + 4.166666666666657e-03*G6_1_2_5_1_11_4_2 - 4.166666666666656e-03*G6_1_2_5_1_11_5_0 - 4.166666666666657e-03*G6_1_2_5_1_11_6_1 - 4.166666666666657e-03*G6_1_2_5_1_11_7_2 + 4.166666666666654e-03*G6_1_2_6_1_8_4_0 + 4.166666666666654e-03*G6_1_2_6_1_8_4_1 + 4.166666666666654e-03*G6_1_2_6_1_8_4_2 - 4.166666666666654e-03*G6_1_2_6_1_8_5_0 - 4.166666666666654e-03*G6_1_2_6_1_8_6_1 - 4.166666666666654e-03*G6_1_2_6_1_8_7_2 + 4.166666666666655e-03*G6_1_2_6_1_9_4_0 + 4.166666666666656e-03*G6_1_2_6_1_9_4_1 + 4.166666666666656e-03*G6_1_2_6_1_9_4_2 - 4.166666666666655e-03*G6_1_2_6_1_9_5_0 - 4.166666666666656e-03*G6_1_2_6_1_9_6_1 - 4.166666666666656e-03*G6_1_2_6_1_9_7_2 + 8.333333333333311e-03*G6_1_2_6_1_10_4_0 + 8.333333333333311e-03*G6_1_2_6_1_10_4_1 + 8.333333333333312e-03*G6_1_2_6_1_10_4_2 - 8.333333333333311e-03*G6_1_2_6_1_10_5_0 - 8.333333333333311e-03*G6_1_2_6_1_10_6_1 - 8.333333333333311e-03*G6_1_2_6_1_10_7_2 + 4.166666666666655e-03*G6_1_2_6_1_11_4_0 + 4.166666666666656e-03*G6_1_2_6_1_11_4_1 + 4.166666666666657e-03*G6_1_2_6_1_11_4_2 - 4.166666666666655e-03*G6_1_2_6_1_11_5_0 - 4.166666666666656e-03*G6_1_2_6_1_11_6_1 - 4.166666666666656e-03*G6_1_2_6_1_11_7_2 + 4.166666666666656e-03*G6_1_2_7_1_8_4_0 + 4.166666666666657e-03*G6_1_2_7_1_8_4_1 + 4.166666666666657e-03*G6_1_2_7_1_8_4_2 - 4.166666666666656e-03*G6_1_2_7_1_8_5_0 - 4.166666666666657e-03*G6_1_2_7_1_8_6_1 - 4.166666666666657e-03*G6_1_2_7_1_8_7_2 + 4.166666666666656e-03*G6_1_2_7_1_9_4_0 + 4.166666666666657e-03*G6_1_2_7_1_9_4_1 + 4.166666666666657e-03*G6_1_2_7_1_9_4_2 - 4.166666666666656e-03*G6_1_2_7_1_9_5_0 - 4.166666666666657e-03*G6_1_2_7_1_9_6_1 - 4.166666666666657e-03*G6_1_2_7_1_9_7_2 + 4.166666666666655e-03*G6_1_2_7_1_10_4_0 + 4.166666666666656e-03*G6_1_2_7_1_10_4_1 + 4.166666666666657e-03*G6_1_2_7_1_10_4_2 - 4.166666666666655e-03*G6_1_2_7_1_10_5_0 - 4.166666666666656e-03*G6_1_2_7_1_10_6_1 - 4.166666666666656e-03*G6_1_2_7_1_10_7_2 + 8.333333333333311e-03*G6_1_2_7_1_11_4_0 + 8.333333333333311e-03*G6_1_2_7_1_11_4_1 + 8.333333333333312e-03*G6_1_2_7_1_11_4_2 - 8.333333333333311e-03*G6_1_2_7_1_11_5_0 - 8.333333333333311e-03*G6_1_2_7_1_11_6_1 - 8.333333333333311e-03*G6_1_2_7_1_11_7_2 + 8.333333333333309e-03*G6_2_0_8_1_0_4_0 + 8.333333333333311e-03*G6_2_0_8_1_0_4_1 + 8.333333333333312e-03*G6_2_0_8_1_0_4_2 - 8.333333333333309e-03*G6_2_0_8_1_0_5_0 - 8.333333333333311e-03*G6_2_0_8_1_0_6_1 - 8.333333333333311e-03*G6_2_0_8_1_0_7_2 + 4.166666666666654e-03*G6_2_0_8_1_1_4_0 + 4.166666666666654e-03*G6_2_0_8_1_1_4_1 + 4.166666666666654e-03*G6_2_0_8_1_1_4_2 - 4.166666666666654e-03*G6_2_0_8_1_1_5_0 - 4.166666666666654e-03*G6_2_0_8_1_1_6_1 - 4.166666666666654e-03*G6_2_0_8_1_1_7_2 + 4.166666666666654e-03*G6_2_0_8_1_2_4_0 + 4.166666666666654e-03*G6_2_0_8_1_2_4_1 + 4.166666666666654e-03*G6_2_0_8_1_2_4_2 - 4.166666666666654e-03*G6_2_0_8_1_2_5_0 - 4.166666666666654e-03*G6_2_0_8_1_2_6_1 - 4.166666666666654e-03*G6_2_0_8_1_2_7_2 + 4.166666666666656e-03*G6_2_0_8_1_3_4_0 + 4.166666666666657e-03*G6_2_0_8_1_3_4_1 + 4.166666666666657e-03*G6_2_0_8_1_3_4_2 - 4.166666666666656e-03*G6_2_0_8_1_3_5_0 - 4.166666666666657e-03*G6_2_0_8_1_3_6_1 - 4.166666666666657e-03*G6_2_0_8_1_3_7_2 + 4.166666666666655e-03*G6_2_0_9_1_0_4_0 + 4.166666666666655e-03*G6_2_0_9_1_0_4_1 + 4.166666666666656e-03*G6_2_0_9_1_0_4_2 - 4.166666666666655e-03*G6_2_0_9_1_0_5_0 - 4.166666666666655e-03*G6_2_0_9_1_0_6_1 - 4.166666666666655e-03*G6_2_0_9_1_0_7_2 + 8.333333333333309e-03*G6_2_0_9_1_1_4_0 + 8.333333333333309e-03*G6_2_0_9_1_1_4_1 + 8.333333333333309e-03*G6_2_0_9_1_1_4_2 - 8.333333333333309e-03*G6_2_0_9_1_1_5_0 - 8.333333333333309e-03*G6_2_0_9_1_1_6_1 - 8.333333333333309e-03*G6_2_0_9_1_1_7_2 + 4.166666666666655e-03*G6_2_0_9_1_2_4_0 + 4.166666666666656e-03*G6_2_0_9_1_2_4_1 + 4.166666666666656e-03*G6_2_0_9_1_2_4_2 - 4.166666666666655e-03*G6_2_0_9_1_2_5_0 - 4.166666666666656e-03*G6_2_0_9_1_2_6_1 - 4.166666666666656e-03*G6_2_0_9_1_2_7_2 + 4.166666666666656e-03*G6_2_0_9_1_3_4_0 + 4.166666666666657e-03*G6_2_0_9_1_3_4_1 + 4.166666666666657e-03*G6_2_0_9_1_3_4_2 - 4.166666666666656e-03*G6_2_0_9_1_3_5_0 - 4.166666666666657e-03*G6_2_0_9_1_3_6_1 - 4.166666666666657e-03*G6_2_0_9_1_3_7_2 + 4.166666666666654e-03*G6_2_0_10_1_0_4_0 + 4.166666666666656e-03*G6_2_0_10_1_0_4_1 + 4.166666666666656e-03*G6_2_0_10_1_0_4_2 - 4.166666666666654e-03*G6_2_0_10_1_0_5_0 - 4.166666666666656e-03*G6_2_0_10_1_0_6_1 - 4.166666666666656e-03*G6_2_0_10_1_0_7_2 + 4.166666666666654e-03*G6_2_0_10_1_1_4_0 + 4.166666666666654e-03*G6_2_0_10_1_1_4_1 + 4.166666666666654e-03*G6_2_0_10_1_1_4_2 - 4.166666666666654e-03*G6_2_0_10_1_1_5_0 - 4.166666666666654e-03*G6_2_0_10_1_1_6_1 - 4.166666666666654e-03*G6_2_0_10_1_1_7_2 + 8.333333333333311e-03*G6_2_0_10_1_2_4_0 + 8.333333333333311e-03*G6_2_0_10_1_2_4_1 + 8.333333333333312e-03*G6_2_0_10_1_2_4_2 - 8.333333333333311e-03*G6_2_0_10_1_2_5_0 - 8.333333333333311e-03*G6_2_0_10_1_2_6_1 - 8.333333333333311e-03*G6_2_0_10_1_2_7_2 + 4.166666666666655e-03*G6_2_0_10_1_3_4_0 + 4.166666666666656e-03*G6_2_0_10_1_3_4_1 + 4.166666666666657e-03*G6_2_0_10_1_3_4_2 - 4.166666666666655e-03*G6_2_0_10_1_3_5_0 - 4.166666666666656e-03*G6_2_0_10_1_3_6_1 - 4.166666666666656e-03*G6_2_0_10_1_3_7_2 + 4.166666666666656e-03*G6_2_0_11_1_0_4_0 + 4.166666666666657e-03*G6_2_0_11_1_0_4_1 + 4.166666666666658e-03*G6_2_0_11_1_0_4_2 - 4.166666666666656e-03*G6_2_0_11_1_0_5_0 - 4.166666666666657e-03*G6_2_0_11_1_0_6_1 - 4.166666666666657e-03*G6_2_0_11_1_0_7_2 + 4.166666666666655e-03*G6_2_0_11_1_1_4_0 + 4.166666666666655e-03*G6_2_0_11_1_1_4_1 + 4.166666666666656e-03*G6_2_0_11_1_1_4_2 - 4.166666666666655e-03*G6_2_0_11_1_1_5_0 - 4.166666666666655e-03*G6_2_0_11_1_1_6_1 - 4.166666666666655e-03*G6_2_0_11_1_1_7_2 + 4.166666666666655e-03*G6_2_0_11_1_2_4_0 + 4.166666666666656e-03*G6_2_0_11_1_2_4_1 + 4.166666666666657e-03*G6_2_0_11_1_2_4_2 - 4.166666666666655e-03*G6_2_0_11_1_2_5_0 - 4.166666666666656e-03*G6_2_0_11_1_2_6_1 - 4.166666666666656e-03*G6_2_0_11_1_2_7_2 + 8.333333333333311e-03*G6_2_0_11_1_3_4_0 + 8.333333333333311e-03*G6_2_0_11_1_3_4_1 + 8.333333333333312e-03*G6_2_0_11_1_3_4_2 - 8.333333333333311e-03*G6_2_0_11_1_3_5_0 - 8.333333333333311e-03*G6_2_0_11_1_3_6_1 - 8.333333333333311e-03*G6_2_0_11_1_3_7_2 + 8.333333333333309e-03*G6_2_1_8_1_4_4_0 + 8.333333333333311e-03*G6_2_1_8_1_4_4_1 + 8.333333333333312e-03*G6_2_1_8_1_4_4_2 - 8.333333333333309e-03*G6_2_1_8_1_4_5_0 - 8.333333333333311e-03*G6_2_1_8_1_4_6_1 - 8.333333333333311e-03*G6_2_1_8_1_4_7_2 + 4.166666666666654e-03*G6_2_1_8_1_5_4_0 + 4.166666666666654e-03*G6_2_1_8_1_5_4_1 + 4.166666666666655e-03*G6_2_1_8_1_5_4_2 - 4.166666666666654e-03*G6_2_1_8_1_5_5_0 - 4.166666666666654e-03*G6_2_1_8_1_5_6_1 - 4.166666666666654e-03*G6_2_1_8_1_5_7_2 + 4.166666666666654e-03*G6_2_1_8_1_6_4_0 + 4.166666666666654e-03*G6_2_1_8_1_6_4_1 + 4.166666666666654e-03*G6_2_1_8_1_6_4_2 - 4.166666666666654e-03*G6_2_1_8_1_6_5_0 - 4.166666666666654e-03*G6_2_1_8_1_6_6_1 - 4.166666666666654e-03*G6_2_1_8_1_6_7_2 + 4.166666666666656e-03*G6_2_1_8_1_7_4_0 + 4.166666666666657e-03*G6_2_1_8_1_7_4_1 + 4.166666666666657e-03*G6_2_1_8_1_7_4_2 - 4.166666666666656e-03*G6_2_1_8_1_7_5_0 - 4.166666666666657e-03*G6_2_1_8_1_7_6_1 - 4.166666666666657e-03*G6_2_1_8_1_7_7_2 + 4.166666666666654e-03*G6_2_1_9_1_4_4_0 + 4.166666666666654e-03*G6_2_1_9_1_4_4_1 + 4.166666666666655e-03*G6_2_1_9_1_4_4_2 - 4.166666666666654e-03*G6_2_1_9_1_4_5_0 - 4.166666666666654e-03*G6_2_1_9_1_4_6_1 - 4.166666666666654e-03*G6_2_1_9_1_4_7_2 + 8.333333333333309e-03*G6_2_1_9_1_5_4_0 + 8.333333333333309e-03*G6_2_1_9_1_5_4_1 + 8.333333333333309e-03*G6_2_1_9_1_5_4_2 - 8.333333333333309e-03*G6_2_1_9_1_5_5_0 - 8.333333333333309e-03*G6_2_1_9_1_5_6_1 - 8.333333333333309e-03*G6_2_1_9_1_5_7_2 + 4.166666666666655e-03*G6_2_1_9_1_6_4_0 + 4.166666666666656e-03*G6_2_1_9_1_6_4_1 + 4.166666666666656e-03*G6_2_1_9_1_6_4_2 - 4.166666666666655e-03*G6_2_1_9_1_6_5_0 - 4.166666666666656e-03*G6_2_1_9_1_6_6_1 - 4.166666666666656e-03*G6_2_1_9_1_6_7_2 + 4.166666666666656e-03*G6_2_1_9_1_7_4_0 + 4.166666666666657e-03*G6_2_1_9_1_7_4_1 + 4.166666666666657e-03*G6_2_1_9_1_7_4_2 - 4.166666666666656e-03*G6_2_1_9_1_7_5_0 - 4.166666666666657e-03*G6_2_1_9_1_7_6_1 - 4.166666666666657e-03*G6_2_1_9_1_7_7_2 + 4.166666666666654e-03*G6_2_1_10_1_4_4_0 + 4.166666666666654e-03*G6_2_1_10_1_4_4_1 + 4.166666666666654e-03*G6_2_1_10_1_4_4_2 - 4.166666666666654e-03*G6_2_1_10_1_4_5_0 - 4.166666666666654e-03*G6_2_1_10_1_4_6_1 - 4.166666666666654e-03*G6_2_1_10_1_4_7_2 + 4.166666666666655e-03*G6_2_1_10_1_5_4_0 + 4.166666666666656e-03*G6_2_1_10_1_5_4_1 + 4.166666666666656e-03*G6_2_1_10_1_5_4_2 - 4.166666666666655e-03*G6_2_1_10_1_5_5_0 - 4.166666666666656e-03*G6_2_1_10_1_5_6_1 - 4.166666666666656e-03*G6_2_1_10_1_5_7_2 + 8.333333333333311e-03*G6_2_1_10_1_6_4_0 + 8.333333333333311e-03*G6_2_1_10_1_6_4_1 + 8.333333333333312e-03*G6_2_1_10_1_6_4_2 - 8.333333333333311e-03*G6_2_1_10_1_6_5_0 - 8.333333333333311e-03*G6_2_1_10_1_6_6_1 - 8.333333333333311e-03*G6_2_1_10_1_6_7_2 + 4.166666666666655e-03*G6_2_1_10_1_7_4_0 + 4.166666666666656e-03*G6_2_1_10_1_7_4_1 + 4.166666666666657e-03*G6_2_1_10_1_7_4_2 - 4.166666666666655e-03*G6_2_1_10_1_7_5_0 - 4.166666666666656e-03*G6_2_1_10_1_7_6_1 - 4.166666666666656e-03*G6_2_1_10_1_7_7_2 + 4.166666666666656e-03*G6_2_1_11_1_4_4_0 + 4.166666666666657e-03*G6_2_1_11_1_4_4_1 + 4.166666666666657e-03*G6_2_1_11_1_4_4_2 - 4.166666666666656e-03*G6_2_1_11_1_4_5_0 - 4.166666666666657e-03*G6_2_1_11_1_4_6_1 - 4.166666666666657e-03*G6_2_1_11_1_4_7_2 + 4.166666666666656e-03*G6_2_1_11_1_5_4_0 + 4.166666666666657e-03*G6_2_1_11_1_5_4_1 + 4.166666666666657e-03*G6_2_1_11_1_5_4_2 - 4.166666666666656e-03*G6_2_1_11_1_5_5_0 - 4.166666666666657e-03*G6_2_1_11_1_5_6_1 - 4.166666666666657e-03*G6_2_1_11_1_5_7_2 + 4.166666666666655e-03*G6_2_1_11_1_6_4_0 + 4.166666666666656e-03*G6_2_1_11_1_6_4_1 + 4.166666666666657e-03*G6_2_1_11_1_6_4_2 - 4.166666666666655e-03*G6_2_1_11_1_6_5_0 - 4.166666666666656e-03*G6_2_1_11_1_6_6_1 - 4.166666666666656e-03*G6_2_1_11_1_6_7_2 + 8.333333333333311e-03*G6_2_1_11_1_7_4_0 + 8.333333333333311e-03*G6_2_1_11_1_7_4_1 + 8.333333333333312e-03*G6_2_1_11_1_7_4_2 - 8.333333333333311e-03*G6_2_1_11_1_7_5_0 - 8.333333333333311e-03*G6_2_1_11_1_7_6_1 - 8.333333333333311e-03*G6_2_1_11_1_7_7_2 + 8.333333333333309e-03*G6_2_2_8_1_8_4_0 + 8.333333333333311e-03*G6_2_2_8_1_8_4_1 + 8.333333333333312e-03*G6_2_2_8_1_8_4_2 - 8.333333333333309e-03*G6_2_2_8_1_8_5_0 - 8.333333333333311e-03*G6_2_2_8_1_8_6_1 - 8.333333333333311e-03*G6_2_2_8_1_8_7_2 + 4.166666666666654e-03*G6_2_2_8_1_9_4_0 + 4.166666666666654e-03*G6_2_2_8_1_9_4_1 + 4.166666666666655e-03*G6_2_2_8_1_9_4_2 - 4.166666666666654e-03*G6_2_2_8_1_9_5_0 - 4.166666666666654e-03*G6_2_2_8_1_9_6_1 - 4.166666666666654e-03*G6_2_2_8_1_9_7_2 + 4.166666666666654e-03*G6_2_2_8_1_10_4_0 + 4.166666666666654e-03*G6_2_2_8_1_10_4_1 + 4.166666666666654e-03*G6_2_2_8_1_10_4_2 - 4.166666666666654e-03*G6_2_2_8_1_10_5_0 - 4.166666666666654e-03*G6_2_2_8_1_10_6_1 - 4.166666666666654e-03*G6_2_2_8_1_10_7_2 + 4.166666666666656e-03*G6_2_2_8_1_11_4_0 + 4.166666666666657e-03*G6_2_2_8_1_11_4_1 + 4.166666666666657e-03*G6_2_2_8_1_11_4_2 - 4.166666666666656e-03*G6_2_2_8_1_11_5_0 - 4.166666666666657e-03*G6_2_2_8_1_11_6_1 - 4.166666666666657e-03*G6_2_2_8_1_11_7_2 + 4.166666666666654e-03*G6_2_2_9_1_8_4_0 + 4.166666666666654e-03*G6_2_2_9_1_8_4_1 + 4.166666666666655e-03*G6_2_2_9_1_8_4_2 - 4.166666666666654e-03*G6_2_2_9_1_8_5_0 - 4.166666666666654e-03*G6_2_2_9_1_8_6_1 - 4.166666666666654e-03*G6_2_2_9_1_8_7_2 + 8.333333333333309e-03*G6_2_2_9_1_9_4_0 + 8.333333333333309e-03*G6_2_2_9_1_9_4_1 + 8.333333333333309e-03*G6_2_2_9_1_9_4_2 - 8.333333333333309e-03*G6_2_2_9_1_9_5_0 - 8.333333333333309e-03*G6_2_2_9_1_9_6_1 - 8.333333333333309e-03*G6_2_2_9_1_9_7_2 + 4.166666666666655e-03*G6_2_2_9_1_10_4_0 + 4.166666666666656e-03*G6_2_2_9_1_10_4_1 + 4.166666666666656e-03*G6_2_2_9_1_10_4_2 - 4.166666666666655e-03*G6_2_2_9_1_10_5_0 - 4.166666666666656e-03*G6_2_2_9_1_10_6_1 - 4.166666666666656e-03*G6_2_2_9_1_10_7_2 + 4.166666666666656e-03*G6_2_2_9_1_11_4_0 + 4.166666666666657e-03*G6_2_2_9_1_11_4_1 + 4.166666666666657e-03*G6_2_2_9_1_11_4_2 - 4.166666666666656e-03*G6_2_2_9_1_11_5_0 - 4.166666666666657e-03*G6_2_2_9_1_11_6_1 - 4.166666666666657e-03*G6_2_2_9_1_11_7_2 + 4.166666666666654e-03*G6_2_2_10_1_8_4_0 + 4.166666666666654e-03*G6_2_2_10_1_8_4_1 + 4.166666666666654e-03*G6_2_2_10_1_8_4_2 - 4.166666666666654e-03*G6_2_2_10_1_8_5_0 - 4.166666666666654e-03*G6_2_2_10_1_8_6_1 - 4.166666666666654e-03*G6_2_2_10_1_8_7_2 + 4.166666666666655e-03*G6_2_2_10_1_9_4_0 + 4.166666666666656e-03*G6_2_2_10_1_9_4_1 + 4.166666666666656e-03*G6_2_2_10_1_9_4_2 - 4.166666666666655e-03*G6_2_2_10_1_9_5_0 - 4.166666666666656e-03*G6_2_2_10_1_9_6_1 - 4.166666666666656e-03*G6_2_2_10_1_9_7_2 + 8.333333333333311e-03*G6_2_2_10_1_10_4_0 + 8.333333333333311e-03*G6_2_2_10_1_10_4_1 + 8.333333333333312e-03*G6_2_2_10_1_10_4_2 - 8.333333333333311e-03*G6_2_2_10_1_10_5_0 - 8.333333333333311e-03*G6_2_2_10_1_10_6_1 - 8.333333333333311e-03*G6_2_2_10_1_10_7_2 + 4.166666666666655e-03*G6_2_2_10_1_11_4_0 + 4.166666666666656e-03*G6_2_2_10_1_11_4_1 + 4.166666666666657e-03*G6_2_2_10_1_11_4_2 - 4.166666666666655e-03*G6_2_2_10_1_11_5_0 - 4.166666666666656e-03*G6_2_2_10_1_11_6_1 - 4.166666666666656e-03*G6_2_2_10_1_11_7_2 + 4.166666666666656e-03*G6_2_2_11_1_8_4_0 + 4.166666666666657e-03*G6_2_2_11_1_8_4_1 + 4.166666666666657e-03*G6_2_2_11_1_8_4_2 - 4.166666666666656e-03*G6_2_2_11_1_8_5_0 - 4.166666666666657e-03*G6_2_2_11_1_8_6_1 - 4.166666666666657e-03*G6_2_2_11_1_8_7_2 + 4.166666666666656e-03*G6_2_2_11_1_9_4_0 + 4.166666666666657e-03*G6_2_2_11_1_9_4_1 + 4.166666666666657e-03*G6_2_2_11_1_9_4_2 - 4.166666666666656e-03*G6_2_2_11_1_9_5_0 - 4.166666666666657e-03*G6_2_2_11_1_9_6_1 - 4.166666666666657e-03*G6_2_2_11_1_9_7_2 + 4.166666666666655e-03*G6_2_2_11_1_10_4_0 + 4.166666666666656e-03*G6_2_2_11_1_10_4_1 + 4.166666666666657e-03*G6_2_2_11_1_10_4_2 - 4.166666666666655e-03*G6_2_2_11_1_10_5_0 - 4.166666666666656e-03*G6_2_2_11_1_10_6_1 - 4.166666666666656e-03*G6_2_2_11_1_10_7_2 + 8.333333333333311e-03*G6_2_2_11_1_11_4_0 + 8.333333333333311e-03*G6_2_2_11_1_11_4_1 + 8.333333333333312e-03*G6_2_2_11_1_11_4_2 - 8.333333333333311e-03*G6_2_2_11_1_11_5_0 - 8.333333333333311e-03*G6_2_2_11_1_11_6_1 - 8.333333333333311e-03*G6_2_2_11_1_11_7_2 + 4.166666666666662e-02*G7_1_0_0_1_0_0 + 4.166666666666662e-02*G7_1_0_0_1_0_1 + 4.166666666666662e-02*G7_1_0_0_1_0_2 - 4.166666666666662e-02*G7_1_0_0_1_1_0 - 4.166666666666662e-02*G7_1_0_0_1_2_1 - 4.166666666666662e-02*G7_1_0_0_1_3_2 + 4.166666666666660e-02*G7_1_0_1_1_0_0 + 4.166666666666661e-02*G7_1_0_1_1_0_1 + 4.166666666666661e-02*G7_1_0_1_1_0_2 - 4.166666666666660e-02*G7_1_0_1_1_1_0 - 4.166666666666661e-02*G7_1_0_1_1_2_1 - 4.166666666666661e-02*G7_1_0_1_1_3_2 + 4.166666666666661e-02*G7_1_0_2_1_0_0 + 4.166666666666662e-02*G7_1_0_2_1_0_1 + 4.166666666666662e-02*G7_1_0_2_1_0_2 - 4.166666666666661e-02*G7_1_0_2_1_1_0 - 4.166666666666662e-02*G7_1_0_2_1_2_1 - 4.166666666666662e-02*G7_1_0_2_1_3_2 + 4.166666666666661e-02*G7_1_0_3_1_0_0 + 4.166666666666662e-02*G7_1_0_3_1_0_1 + 4.166666666666662e-02*G7_1_0_3_1_0_2 - 4.166666666666661e-02*G7_1_0_3_1_1_0 - 4.166666666666662e-02*G7_1_0_3_1_2_1 - 4.166666666666662e-02*G7_1_0_3_1_3_2 + 4.166666666666661e-02*G7_1_1_4_1_0_0 + 4.166666666666662e-02*G7_1_1_4_1_0_1 + 4.166666666666662e-02*G7_1_1_4_1_0_2 - 4.166666666666661e-02*G7_1_1_4_1_1_0 - 4.166666666666662e-02*G7_1_1_4_1_2_1 - 4.166666666666662e-02*G7_1_1_4_1_3_2 + 4.166666666666661e-02*G7_1_1_5_1_0_0 + 4.166666666666662e-02*G7_1_1_5_1_0_1 + 4.166666666666662e-02*G7_1_1_5_1_0_2 - 4.166666666666661e-02*G7_1_1_5_1_1_0 - 4.166666666666662e-02*G7_1_1_5_1_2_1 - 4.166666666666662e-02*G7_1_1_5_1_3_2 + 4.166666666666661e-02*G7_1_1_6_1_0_0 + 4.166666666666662e-02*G7_1_1_6_1_0_1 + 4.166666666666662e-02*G7_1_1_6_1_0_2 - 4.166666666666661e-02*G7_1_1_6_1_1_0 - 4.166666666666662e-02*G7_1_1_6_1_2_1 - 4.166666666666662e-02*G7_1_1_6_1_3_2 + 4.166666666666661e-02*G7_1_1_7_1_0_0 + 4.166666666666662e-02*G7_1_1_7_1_0_1 + 4.166666666666662e-02*G7_1_1_7_1_0_2 - 4.166666666666661e-02*G7_1_1_7_1_1_0 - 4.166666666666662e-02*G7_1_1_7_1_2_1 - 4.166666666666662e-02*G7_1_1_7_1_3_2 + 4.166666666666661e-02*G7_1_2_8_1_0_0 + 4.166666666666662e-02*G7_1_2_8_1_0_1 + 4.166666666666662e-02*G7_1_2_8_1_0_2 - 4.166666666666661e-02*G7_1_2_8_1_1_0 - 4.166666666666662e-02*G7_1_2_8_1_2_1 - 4.166666666666662e-02*G7_1_2_8_1_3_2 + 4.166666666666661e-02*G7_1_2_9_1_0_0 + 4.166666666666662e-02*G7_1_2_9_1_0_1 + 4.166666666666662e-02*G7_1_2_9_1_0_2 - 4.166666666666661e-02*G7_1_2_9_1_1_0 - 4.166666666666662e-02*G7_1_2_9_1_2_1 - 4.166666666666662e-02*G7_1_2_9_1_3_2 + 4.166666666666661e-02*G7_1_2_10_1_0_0 + 4.166666666666662e-02*G7_1_2_10_1_0_1 + 4.166666666666662e-02*G7_1_2_10_1_0_2 - 4.166666666666661e-02*G7_1_2_10_1_1_0 - 4.166666666666662e-02*G7_1_2_10_1_2_1 - 4.166666666666662e-02*G7_1_2_10_1_3_2 + 4.166666666666661e-02*G7_1_2_11_1_0_0 + 4.166666666666662e-02*G7_1_2_11_1_0_1 + 4.166666666666662e-02*G7_1_2_11_1_0_2 - 4.166666666666661e-02*G7_1_2_11_1_1_0 - 4.166666666666662e-02*G7_1_2_11_1_2_1 - 4.166666666666662e-02*G7_1_2_11_1_3_2 + 8.333333333333322e-02*G8_1_0_1_0_0 + 8.333333333333323e-02*G8_1_0_1_0_1 + 8.333333333333322e-02*G8_1_0_1_0_2 - 8.333333333333322e-02*G8_1_0_1_1_0 - 8.333333333333323e-02*G8_1_0_1_2_1 - 8.333333333333323e-02*G8_1_0_1_3_2 + 8.333333333333322e-02*G8_1_1_1_4_0 + 8.333333333333323e-02*G8_1_1_1_4_1 + 8.333333333333323e-02*G8_1_1_1_4_2 - 8.333333333333322e-02*G8_1_1_1_5_0 - 8.333333333333323e-02*G8_1_1_1_6_1 - 8.333333333333323e-02*G8_1_1_1_7_2 + 8.333333333333322e-02*G8_1_2_1_8_0 + 8.333333333333323e-02*G8_1_2_1_8_1 + 8.333333333333323e-02*G8_1_2_1_8_2 - 8.333333333333322e-02*G8_1_2_1_9_0 - 8.333333333333323e-02*G8_1_2_1_10_1 - 8.333333333333323e-02*G8_1_2_1_11_2;
    block[7] = 8.333333333333314e-03*G0_4 + 8.333333333333314e-03*G0_5 + 8.333333333333312e-03*G0_6 + 1.666666666666662e-02*G0_7 + 8.333333333333314e-03*G1_4 + 8.333333333333314e-03*G1_5 + 8.333333333333312e-03*G1_6 + 1.666666666666662e-02*G1_7 + 4.166666666666662e-02*G2_1_2_0 + 4.166666666666662e-02*G2_1_2_1 + 4.166666666666662e-02*G2_1_2_2 + 4.166666666666662e-02*G2_1_2_3 + 1.666666666666662e-02*G3_0_0_2_4 + 8.333333333333311e-03*G3_0_0_2_5 + 8.333333333333312e-03*G3_0_0_2_6 + 8.333333333333314e-03*G3_0_0_2_7 + 8.333333333333309e-03*G3_0_1_2_4 + 1.666666666666662e-02*G3_0_1_2_5 + 8.333333333333309e-03*G3_0_1_2_6 + 8.333333333333311e-03*G3_0_1_2_7 + 8.333333333333307e-03*G3_0_2_2_4 + 8.333333333333312e-03*G3_0_2_2_5 + 1.666666666666662e-02*G3_0_2_2_6 + 8.333333333333312e-03*G3_0_2_2_7 + 8.333333333333314e-03*G3_0_3_2_4 + 8.333333333333314e-03*G3_0_3_2_5 + 8.333333333333312e-03*G3_0_3_2_6 + 1.666666666666662e-02*G3_0_3_2_7 + 1.666666666666662e-02*G3_1_4_2_4 + 8.333333333333309e-03*G3_1_4_2_5 + 8.333333333333309e-03*G3_1_4_2_6 + 8.333333333333314e-03*G3_1_4_2_7 + 8.333333333333309e-03*G3_1_5_2_4 + 1.666666666666662e-02*G3_1_5_2_5 + 8.333333333333312e-03*G3_1_5_2_6 + 8.333333333333314e-03*G3_1_5_2_7 + 8.333333333333307e-03*G3_1_6_2_4 + 8.333333333333312e-03*G3_1_6_2_5 + 1.666666666666662e-02*G3_1_6_2_6 + 8.333333333333312e-03*G3_1_6_2_7 + 8.333333333333314e-03*G3_1_7_2_4 + 8.333333333333314e-03*G3_1_7_2_5 + 8.333333333333312e-03*G3_1_7_2_6 + 1.666666666666662e-02*G3_1_7_2_7 + 1.666666666666662e-02*G3_2_8_2_4 + 8.333333333333309e-03*G3_2_8_2_5 + 8.333333333333309e-03*G3_2_8_2_6 + 8.333333333333314e-03*G3_2_8_2_7 + 8.333333333333309e-03*G3_2_9_2_4 + 1.666666666666662e-02*G3_2_9_2_5 + 8.333333333333312e-03*G3_2_9_2_6 + 8.333333333333314e-03*G3_2_9_2_7 + 8.333333333333307e-03*G3_2_10_2_4 + 8.333333333333312e-03*G3_2_10_2_5 + 1.666666666666662e-02*G3_2_10_2_6 + 8.333333333333312e-03*G3_2_10_2_7 + 8.333333333333314e-03*G3_2_11_2_4 + 8.333333333333314e-03*G3_2_11_2_5 + 8.333333333333312e-03*G3_2_11_2_6 + 1.666666666666662e-02*G3_2_11_2_7 + 8.333333333333322e-02*G4_2_4_0 + 8.333333333333323e-02*G4_2_4_1 + 8.333333333333323e-02*G4_2_4_2 - 8.333333333333322e-02*G4_2_5_0 - 8.333333333333323e-02*G4_2_6_1 - 8.333333333333323e-02*G4_2_7_2 + 4.166666666666656e-03*G5_0_0_4_0 + 4.166666666666657e-03*G5_0_0_4_1 + 4.166666666666658e-03*G5_0_0_4_2 - 4.166666666666656e-03*G5_0_0_5_0 - 4.166666666666657e-03*G5_0_0_6_1 - 4.166666666666657e-03*G5_0_0_7_2 + 4.166666666666655e-03*G5_0_1_4_0 + 4.166666666666655e-03*G5_0_1_4_1 + 4.166666666666656e-03*G5_0_1_4_2 - 4.166666666666655e-03*G5_0_1_5_0 - 4.166666666666655e-03*G5_0_1_6_1 - 4.166666666666655e-03*G5_0_1_7_2 + 4.166666666666655e-03*G5_0_2_4_0 + 4.166666666666656e-03*G5_0_2_4_1 + 4.166666666666657e-03*G5_0_2_4_2 - 4.166666666666655e-03*G5_0_2_5_0 - 4.166666666666656e-03*G5_0_2_6_1 - 4.166666666666656e-03*G5_0_2_7_2 + 8.333333333333311e-03*G5_0_3_4_0 + 8.333333333333311e-03*G5_0_3_4_1 + 8.333333333333312e-03*G5_0_3_4_2 - 8.333333333333311e-03*G5_0_3_5_0 - 8.333333333333311e-03*G5_0_3_6_1 - 8.333333333333311e-03*G5_0_3_7_2 + 4.166666666666656e-03*G5_1_4_4_0 + 4.166666666666657e-03*G5_1_4_4_1 + 4.166666666666657e-03*G5_1_4_4_2 - 4.166666666666656e-03*G5_1_4_5_0 - 4.166666666666657e-03*G5_1_4_6_1 - 4.166666666666657e-03*G5_1_4_7_2 + 4.166666666666656e-03*G5_1_5_4_0 + 4.166666666666657e-03*G5_1_5_4_1 + 4.166666666666657e-03*G5_1_5_4_2 - 4.166666666666656e-03*G5_1_5_5_0 - 4.166666666666657e-03*G5_1_5_6_1 - 4.166666666666657e-03*G5_1_5_7_2 + 4.166666666666655e-03*G5_1_6_4_0 + 4.166666666666656e-03*G5_1_6_4_1 + 4.166666666666657e-03*G5_1_6_4_2 - 4.166666666666655e-03*G5_1_6_5_0 - 4.166666666666656e-03*G5_1_6_6_1 - 4.166666666666656e-03*G5_1_6_7_2 + 8.333333333333311e-03*G5_1_7_4_0 + 8.333333333333311e-03*G5_1_7_4_1 + 8.333333333333312e-03*G5_1_7_4_2 - 8.333333333333311e-03*G5_1_7_5_0 - 8.333333333333311e-03*G5_1_7_6_1 - 8.333333333333311e-03*G5_1_7_7_2 + 4.166666666666656e-03*G5_2_8_4_0 + 4.166666666666657e-03*G5_2_8_4_1 + 4.166666666666657e-03*G5_2_8_4_2 - 4.166666666666656e-03*G5_2_8_5_0 - 4.166666666666657e-03*G5_2_8_6_1 - 4.166666666666657e-03*G5_2_8_7_2 + 4.166666666666656e-03*G5_2_9_4_0 + 4.166666666666657e-03*G5_2_9_4_1 + 4.166666666666657e-03*G5_2_9_4_2 - 4.166666666666656e-03*G5_2_9_5_0 - 4.166666666666657e-03*G5_2_9_6_1 - 4.166666666666657e-03*G5_2_9_7_2 + 4.166666666666655e-03*G5_2_10_4_0 + 4.166666666666656e-03*G5_2_10_4_1 + 4.166666666666657e-03*G5_2_10_4_2 - 4.166666666666655e-03*G5_2_10_5_0 - 4.166666666666656e-03*G5_2_10_6_1 - 4.166666666666656e-03*G5_2_10_7_2 + 8.333333333333311e-03*G5_2_11_4_0 + 8.333333333333311e-03*G5_2_11_4_1 + 8.333333333333312e-03*G5_2_11_4_2 - 8.333333333333311e-03*G5_2_11_5_0 - 8.333333333333311e-03*G5_2_11_6_1 - 8.333333333333311e-03*G5_2_11_7_2 + 8.333333333333309e-03*G6_0_0_0_2_0_4_0 + 8.333333333333311e-03*G6_0_0_0_2_0_4_1 + 8.333333333333312e-03*G6_0_0_0_2_0_4_2 - 8.333333333333309e-03*G6_0_0_0_2_0_5_0 - 8.333333333333311e-03*G6_0_0_0_2_0_6_1 - 8.333333333333311e-03*G6_0_0_0_2_0_7_2 + 4.166666666666654e-03*G6_0_0_0_2_1_4_0 + 4.166666666666655e-03*G6_0_0_0_2_1_4_1 + 4.166666666666655e-03*G6_0_0_0_2_1_4_2 - 4.166666666666654e-03*G6_0_0_0_2_1_5_0 - 4.166666666666655e-03*G6_0_0_0_2_1_6_1 - 4.166666666666655e-03*G6_0_0_0_2_1_7_2 + 4.166666666666654e-03*G6_0_0_0_2_2_4_0 + 4.166666666666656e-03*G6_0_0_0_2_2_4_1 + 4.166666666666656e-03*G6_0_0_0_2_2_4_2 - 4.166666666666654e-03*G6_0_0_0_2_2_5_0 - 4.166666666666656e-03*G6_0_0_0_2_2_6_1 - 4.166666666666656e-03*G6_0_0_0_2_2_7_2 + 4.166666666666656e-03*G6_0_0_0_2_3_4_0 + 4.166666666666657e-03*G6_0_0_0_2_3_4_1 + 4.166666666666658e-03*G6_0_0_0_2_3_4_2 - 4.166666666666656e-03*G6_0_0_0_2_3_5_0 - 4.166666666666657e-03*G6_0_0_0_2_3_6_1 - 4.166666666666657e-03*G6_0_0_0_2_3_7_2 + 4.166666666666654e-03*G6_0_0_1_2_0_4_0 + 4.166666666666655e-03*G6_0_0_1_2_0_4_1 + 4.166666666666655e-03*G6_0_0_1_2_0_4_2 - 4.166666666666654e-03*G6_0_0_1_2_0_5_0 - 4.166666666666655e-03*G6_0_0_1_2_0_6_1 - 4.166666666666655e-03*G6_0_0_1_2_0_7_2 + 8.333333333333307e-03*G6_0_0_1_2_1_4_0 + 8.333333333333309e-03*G6_0_0_1_2_1_4_1 + 8.333333333333309e-03*G6_0_0_1_2_1_4_2 - 8.333333333333307e-03*G6_0_0_1_2_1_5_0 - 8.333333333333309e-03*G6_0_0_1_2_1_6_1 - 8.333333333333309e-03*G6_0_0_1_2_1_7_2 + 4.166666666666654e-03*G6_0_0_1_2_2_4_0 + 4.166666666666654e-03*G6_0_0_1_2_2_4_1 + 4.166666666666655e-03*G6_0_0_1_2_2_4_2 - 4.166666666666654e-03*G6_0_0_1_2_2_5_0 - 4.166666666666654e-03*G6_0_0_1_2_2_6_1 - 4.166666666666654e-03*G6_0_0_1_2_2_7_2 + 4.166666666666655e-03*G6_0_0_1_2_3_4_0 + 4.166666666666655e-03*G6_0_0_1_2_3_4_1 + 4.166666666666656e-03*G6_0_0_1_2_3_4_2 - 4.166666666666655e-03*G6_0_0_1_2_3_5_0 - 4.166666666666655e-03*G6_0_0_1_2_3_6_1 - 4.166666666666655e-03*G6_0_0_1_2_3_7_2 + 4.166666666666654e-03*G6_0_0_2_2_0_4_0 + 4.166666666666656e-03*G6_0_0_2_2_0_4_1 + 4.166666666666656e-03*G6_0_0_2_2_0_4_2 - 4.166666666666654e-03*G6_0_0_2_2_0_5_0 - 4.166666666666656e-03*G6_0_0_2_2_0_6_1 - 4.166666666666656e-03*G6_0_0_2_2_0_7_2 + 4.166666666666654e-03*G6_0_0_2_2_1_4_0 + 4.166666666666654e-03*G6_0_0_2_2_1_4_1 + 4.166666666666654e-03*G6_0_0_2_2_1_4_2 - 4.166666666666654e-03*G6_0_0_2_2_1_5_0 - 4.166666666666654e-03*G6_0_0_2_2_1_6_1 - 4.166666666666654e-03*G6_0_0_2_2_1_7_2 + 8.333333333333311e-03*G6_0_0_2_2_2_4_0 + 8.333333333333311e-03*G6_0_0_2_2_2_4_1 + 8.333333333333312e-03*G6_0_0_2_2_2_4_2 - 8.333333333333311e-03*G6_0_0_2_2_2_5_0 - 8.333333333333311e-03*G6_0_0_2_2_2_6_1 - 8.333333333333311e-03*G6_0_0_2_2_2_7_2 + 4.166666666666655e-03*G6_0_0_2_2_3_4_0 + 4.166666666666656e-03*G6_0_0_2_2_3_4_1 + 4.166666666666657e-03*G6_0_0_2_2_3_4_2 - 4.166666666666655e-03*G6_0_0_2_2_3_5_0 - 4.166666666666656e-03*G6_0_0_2_2_3_6_1 - 4.166666666666656e-03*G6_0_0_2_2_3_7_2 + 4.166666666666656e-03*G6_0_0_3_2_0_4_0 + 4.166666666666657e-03*G6_0_0_3_2_0_4_1 + 4.166666666666658e-03*G6_0_0_3_2_0_4_2 - 4.166666666666656e-03*G6_0_0_3_2_0_5_0 - 4.166666666666657e-03*G6_0_0_3_2_0_6_1 - 4.166666666666657e-03*G6_0_0_3_2_0_7_2 + 4.166666666666655e-03*G6_0_0_3_2_1_4_0 + 4.166666666666655e-03*G6_0_0_3_2_1_4_1 + 4.166666666666656e-03*G6_0_0_3_2_1_4_2 - 4.166666666666655e-03*G6_0_0_3_2_1_5_0 - 4.166666666666655e-03*G6_0_0_3_2_1_6_1 - 4.166666666666655e-03*G6_0_0_3_2_1_7_2 + 4.166666666666655e-03*G6_0_0_3_2_2_4_0 + 4.166666666666656e-03*G6_0_0_3_2_2_4_1 + 4.166666666666657e-03*G6_0_0_3_2_2_4_2 - 4.166666666666655e-03*G6_0_0_3_2_2_5_0 - 4.166666666666656e-03*G6_0_0_3_2_2_6_1 - 4.166666666666656e-03*G6_0_0_3_2_2_7_2 + 8.333333333333311e-03*G6_0_0_3_2_3_4_0 + 8.333333333333311e-03*G6_0_0_3_2_3_4_1 + 8.333333333333312e-03*G6_0_0_3_2_3_4_2 - 8.333333333333311e-03*G6_0_0_3_2_3_5_0 - 8.333333333333311e-03*G6_0_0_3_2_3_6_1 - 8.333333333333311e-03*G6_0_0_3_2_3_7_2 + 8.333333333333309e-03*G6_0_1_0_2_4_4_0 + 8.333333333333311e-03*G6_0_1_0_2_4_4_1 + 8.333333333333312e-03*G6_0_1_0_2_4_4_2 - 8.333333333333309e-03*G6_0_1_0_2_4_5_0 - 8.333333333333311e-03*G6_0_1_0_2_4_6_1 - 8.333333333333311e-03*G6_0_1_0_2_4_7_2 + 4.166666666666655e-03*G6_0_1_0_2_5_4_0 + 4.166666666666655e-03*G6_0_1_0_2_5_4_1 + 4.166666666666656e-03*G6_0_1_0_2_5_4_2 - 4.166666666666655e-03*G6_0_1_0_2_5_5_0 - 4.166666666666655e-03*G6_0_1_0_2_5_6_1 - 4.166666666666655e-03*G6_0_1_0_2_5_7_2 + 4.166666666666654e-03*G6_0_1_0_2_6_4_0 + 4.166666666666656e-03*G6_0_1_0_2_6_4_1 + 4.166666666666656e-03*G6_0_1_0_2_6_4_2 - 4.166666666666654e-03*G6_0_1_0_2_6_5_0 - 4.166666666666656e-03*G6_0_1_0_2_6_6_1 - 4.166666666666656e-03*G6_0_1_0_2_6_7_2 + 4.166666666666656e-03*G6_0_1_0_2_7_4_0 + 4.166666666666657e-03*G6_0_1_0_2_7_4_1 + 4.166666666666658e-03*G6_0_1_0_2_7_4_2 - 4.166666666666656e-03*G6_0_1_0_2_7_5_0 - 4.166666666666657e-03*G6_0_1_0_2_7_6_1 - 4.166666666666657e-03*G6_0_1_0_2_7_7_2 + 4.166666666666654e-03*G6_0_1_1_2_4_4_0 + 4.166666666666654e-03*G6_0_1_1_2_4_4_1 + 4.166666666666654e-03*G6_0_1_1_2_4_4_2 - 4.166666666666654e-03*G6_0_1_1_2_4_5_0 - 4.166666666666654e-03*G6_0_1_1_2_4_6_1 - 4.166666666666654e-03*G6_0_1_1_2_4_7_2 + 8.333333333333309e-03*G6_0_1_1_2_5_4_0 + 8.333333333333309e-03*G6_0_1_1_2_5_4_1 + 8.333333333333309e-03*G6_0_1_1_2_5_4_2 - 8.333333333333309e-03*G6_0_1_1_2_5_5_0 - 8.333333333333309e-03*G6_0_1_1_2_5_6_1 - 8.333333333333309e-03*G6_0_1_1_2_5_7_2 + 4.166666666666654e-03*G6_0_1_1_2_6_4_0 + 4.166666666666654e-03*G6_0_1_1_2_6_4_1 + 4.166666666666655e-03*G6_0_1_1_2_6_4_2 - 4.166666666666654e-03*G6_0_1_1_2_6_5_0 - 4.166666666666654e-03*G6_0_1_1_2_6_6_1 - 4.166666666666654e-03*G6_0_1_1_2_6_7_2 + 4.166666666666655e-03*G6_0_1_1_2_7_4_0 + 4.166666666666655e-03*G6_0_1_1_2_7_4_1 + 4.166666666666656e-03*G6_0_1_1_2_7_4_2 - 4.166666666666655e-03*G6_0_1_1_2_7_5_0 - 4.166666666666655e-03*G6_0_1_1_2_7_6_1 - 4.166666666666655e-03*G6_0_1_1_2_7_7_2 + 4.166666666666654e-03*G6_0_1_2_2_4_4_0 + 4.166666666666654e-03*G6_0_1_2_2_4_4_1 + 4.166666666666654e-03*G6_0_1_2_2_4_4_2 - 4.166666666666654e-03*G6_0_1_2_2_4_5_0 - 4.166666666666654e-03*G6_0_1_2_2_4_6_1 - 4.166666666666654e-03*G6_0_1_2_2_4_7_2 + 4.166666666666655e-03*G6_0_1_2_2_5_4_0 + 4.166666666666656e-03*G6_0_1_2_2_5_4_1 + 4.166666666666656e-03*G6_0_1_2_2_5_4_2 - 4.166666666666655e-03*G6_0_1_2_2_5_5_0 - 4.166666666666656e-03*G6_0_1_2_2_5_6_1 - 4.166666666666656e-03*G6_0_1_2_2_5_7_2 + 8.333333333333311e-03*G6_0_1_2_2_6_4_0 + 8.333333333333311e-03*G6_0_1_2_2_6_4_1 + 8.333333333333312e-03*G6_0_1_2_2_6_4_2 - 8.333333333333311e-03*G6_0_1_2_2_6_5_0 - 8.333333333333311e-03*G6_0_1_2_2_6_6_1 - 8.333333333333311e-03*G6_0_1_2_2_6_7_2 + 4.166666666666655e-03*G6_0_1_2_2_7_4_0 + 4.166666666666656e-03*G6_0_1_2_2_7_4_1 + 4.166666666666657e-03*G6_0_1_2_2_7_4_2 - 4.166666666666655e-03*G6_0_1_2_2_7_5_0 - 4.166666666666656e-03*G6_0_1_2_2_7_6_1 - 4.166666666666656e-03*G6_0_1_2_2_7_7_2 + 4.166666666666656e-03*G6_0_1_3_2_4_4_0 + 4.166666666666657e-03*G6_0_1_3_2_4_4_1 + 4.166666666666657e-03*G6_0_1_3_2_4_4_2 - 4.166666666666656e-03*G6_0_1_3_2_4_5_0 - 4.166666666666657e-03*G6_0_1_3_2_4_6_1 - 4.166666666666657e-03*G6_0_1_3_2_4_7_2 + 4.166666666666656e-03*G6_0_1_3_2_5_4_0 + 4.166666666666657e-03*G6_0_1_3_2_5_4_1 + 4.166666666666657e-03*G6_0_1_3_2_5_4_2 - 4.166666666666656e-03*G6_0_1_3_2_5_5_0 - 4.166666666666657e-03*G6_0_1_3_2_5_6_1 - 4.166666666666657e-03*G6_0_1_3_2_5_7_2 + 4.166666666666655e-03*G6_0_1_3_2_6_4_0 + 4.166666666666656e-03*G6_0_1_3_2_6_4_1 + 4.166666666666657e-03*G6_0_1_3_2_6_4_2 - 4.166666666666655e-03*G6_0_1_3_2_6_5_0 - 4.166666666666656e-03*G6_0_1_3_2_6_6_1 - 4.166666666666656e-03*G6_0_1_3_2_6_7_2 + 8.333333333333311e-03*G6_0_1_3_2_7_4_0 + 8.333333333333311e-03*G6_0_1_3_2_7_4_1 + 8.333333333333312e-03*G6_0_1_3_2_7_4_2 - 8.333333333333311e-03*G6_0_1_3_2_7_5_0 - 8.333333333333311e-03*G6_0_1_3_2_7_6_1 - 8.333333333333311e-03*G6_0_1_3_2_7_7_2 + 8.333333333333309e-03*G6_0_2_0_2_8_4_0 + 8.333333333333311e-03*G6_0_2_0_2_8_4_1 + 8.333333333333312e-03*G6_0_2_0_2_8_4_2 - 8.333333333333309e-03*G6_0_2_0_2_8_5_0 - 8.333333333333311e-03*G6_0_2_0_2_8_6_1 - 8.333333333333311e-03*G6_0_2_0_2_8_7_2 + 4.166666666666655e-03*G6_0_2_0_2_9_4_0 + 4.166666666666655e-03*G6_0_2_0_2_9_4_1 + 4.166666666666656e-03*G6_0_2_0_2_9_4_2 - 4.166666666666655e-03*G6_0_2_0_2_9_5_0 - 4.166666666666655e-03*G6_0_2_0_2_9_6_1 - 4.166666666666655e-03*G6_0_2_0_2_9_7_2 + 4.166666666666654e-03*G6_0_2_0_2_10_4_0 + 4.166666666666656e-03*G6_0_2_0_2_10_4_1 + 4.166666666666656e-03*G6_0_2_0_2_10_4_2 - 4.166666666666654e-03*G6_0_2_0_2_10_5_0 - 4.166666666666656e-03*G6_0_2_0_2_10_6_1 - 4.166666666666656e-03*G6_0_2_0_2_10_7_2 + 4.166666666666656e-03*G6_0_2_0_2_11_4_0 + 4.166666666666657e-03*G6_0_2_0_2_11_4_1 + 4.166666666666658e-03*G6_0_2_0_2_11_4_2 - 4.166666666666656e-03*G6_0_2_0_2_11_5_0 - 4.166666666666657e-03*G6_0_2_0_2_11_6_1 - 4.166666666666657e-03*G6_0_2_0_2_11_7_2 + 4.166666666666654e-03*G6_0_2_1_2_8_4_0 + 4.166666666666654e-03*G6_0_2_1_2_8_4_1 + 4.166666666666654e-03*G6_0_2_1_2_8_4_2 - 4.166666666666654e-03*G6_0_2_1_2_8_5_0 - 4.166666666666654e-03*G6_0_2_1_2_8_6_1 - 4.166666666666654e-03*G6_0_2_1_2_8_7_2 + 8.333333333333309e-03*G6_0_2_1_2_9_4_0 + 8.333333333333309e-03*G6_0_2_1_2_9_4_1 + 8.333333333333309e-03*G6_0_2_1_2_9_4_2 - 8.333333333333309e-03*G6_0_2_1_2_9_5_0 - 8.333333333333309e-03*G6_0_2_1_2_9_6_1 - 8.333333333333309e-03*G6_0_2_1_2_9_7_2 + 4.166666666666654e-03*G6_0_2_1_2_10_4_0 + 4.166666666666654e-03*G6_0_2_1_2_10_4_1 + 4.166666666666655e-03*G6_0_2_1_2_10_4_2 - 4.166666666666654e-03*G6_0_2_1_2_10_5_0 - 4.166666666666654e-03*G6_0_2_1_2_10_6_1 - 4.166666666666654e-03*G6_0_2_1_2_10_7_2 + 4.166666666666655e-03*G6_0_2_1_2_11_4_0 + 4.166666666666655e-03*G6_0_2_1_2_11_4_1 + 4.166666666666656e-03*G6_0_2_1_2_11_4_2 - 4.166666666666655e-03*G6_0_2_1_2_11_5_0 - 4.166666666666655e-03*G6_0_2_1_2_11_6_1 - 4.166666666666655e-03*G6_0_2_1_2_11_7_2 + 4.166666666666654e-03*G6_0_2_2_2_8_4_0 + 4.166666666666654e-03*G6_0_2_2_2_8_4_1 + 4.166666666666654e-03*G6_0_2_2_2_8_4_2 - 4.166666666666654e-03*G6_0_2_2_2_8_5_0 - 4.166666666666654e-03*G6_0_2_2_2_8_6_1 - 4.166666666666654e-03*G6_0_2_2_2_8_7_2 + 4.166666666666655e-03*G6_0_2_2_2_9_4_0 + 4.166666666666656e-03*G6_0_2_2_2_9_4_1 + 4.166666666666656e-03*G6_0_2_2_2_9_4_2 - 4.166666666666655e-03*G6_0_2_2_2_9_5_0 - 4.166666666666656e-03*G6_0_2_2_2_9_6_1 - 4.166666666666656e-03*G6_0_2_2_2_9_7_2 + 8.333333333333311e-03*G6_0_2_2_2_10_4_0 + 8.333333333333311e-03*G6_0_2_2_2_10_4_1 + 8.333333333333312e-03*G6_0_2_2_2_10_4_2 - 8.333333333333311e-03*G6_0_2_2_2_10_5_0 - 8.333333333333311e-03*G6_0_2_2_2_10_6_1 - 8.333333333333311e-03*G6_0_2_2_2_10_7_2 + 4.166666666666655e-03*G6_0_2_2_2_11_4_0 + 4.166666666666656e-03*G6_0_2_2_2_11_4_1 + 4.166666666666657e-03*G6_0_2_2_2_11_4_2 - 4.166666666666655e-03*G6_0_2_2_2_11_5_0 - 4.166666666666656e-03*G6_0_2_2_2_11_6_1 - 4.166666666666656e-03*G6_0_2_2_2_11_7_2 + 4.166666666666656e-03*G6_0_2_3_2_8_4_0 + 4.166666666666657e-03*G6_0_2_3_2_8_4_1 + 4.166666666666657e-03*G6_0_2_3_2_8_4_2 - 4.166666666666656e-03*G6_0_2_3_2_8_5_0 - 4.166666666666657e-03*G6_0_2_3_2_8_6_1 - 4.166666666666657e-03*G6_0_2_3_2_8_7_2 + 4.166666666666656e-03*G6_0_2_3_2_9_4_0 + 4.166666666666657e-03*G6_0_2_3_2_9_4_1 + 4.166666666666657e-03*G6_0_2_3_2_9_4_2 - 4.166666666666656e-03*G6_0_2_3_2_9_5_0 - 4.166666666666657e-03*G6_0_2_3_2_9_6_1 - 4.166666666666657e-03*G6_0_2_3_2_9_7_2 + 4.166666666666655e-03*G6_0_2_3_2_10_4_0 + 4.166666666666656e-03*G6_0_2_3_2_10_4_1 + 4.166666666666657e-03*G6_0_2_3_2_10_4_2 - 4.166666666666655e-03*G6_0_2_3_2_10_5_0 - 4.166666666666656e-03*G6_0_2_3_2_10_6_1 - 4.166666666666656e-03*G6_0_2_3_2_10_7_2 + 8.333333333333311e-03*G6_0_2_3_2_11_4_0 + 8.333333333333311e-03*G6_0_2_3_2_11_4_1 + 8.333333333333312e-03*G6_0_2_3_2_11_4_2 - 8.333333333333311e-03*G6_0_2_3_2_11_5_0 - 8.333333333333311e-03*G6_0_2_3_2_11_6_1 - 8.333333333333311e-03*G6_0_2_3_2_11_7_2 + 8.333333333333309e-03*G6_1_0_4_2_0_4_0 + 8.333333333333311e-03*G6_1_0_4_2_0_4_1 + 8.333333333333312e-03*G6_1_0_4_2_0_4_2 - 8.333333333333309e-03*G6_1_0_4_2_0_5_0 - 8.333333333333311e-03*G6_1_0_4_2_0_6_1 - 8.333333333333311e-03*G6_1_0_4_2_0_7_2 + 4.166666666666654e-03*G6_1_0_4_2_1_4_0 + 4.166666666666654e-03*G6_1_0_4_2_1_4_1 + 4.166666666666654e-03*G6_1_0_4_2_1_4_2 - 4.166666666666654e-03*G6_1_0_4_2_1_5_0 - 4.166666666666654e-03*G6_1_0_4_2_1_6_1 - 4.166666666666654e-03*G6_1_0_4_2_1_7_2 + 4.166666666666654e-03*G6_1_0_4_2_2_4_0 + 4.166666666666654e-03*G6_1_0_4_2_2_4_1 + 4.166666666666654e-03*G6_1_0_4_2_2_4_2 - 4.166666666666654e-03*G6_1_0_4_2_2_5_0 - 4.166666666666654e-03*G6_1_0_4_2_2_6_1 - 4.166666666666654e-03*G6_1_0_4_2_2_7_2 + 4.166666666666656e-03*G6_1_0_4_2_3_4_0 + 4.166666666666657e-03*G6_1_0_4_2_3_4_1 + 4.166666666666657e-03*G6_1_0_4_2_3_4_2 - 4.166666666666656e-03*G6_1_0_4_2_3_5_0 - 4.166666666666657e-03*G6_1_0_4_2_3_6_1 - 4.166666666666657e-03*G6_1_0_4_2_3_7_2 + 4.166666666666655e-03*G6_1_0_5_2_0_4_0 + 4.166666666666655e-03*G6_1_0_5_2_0_4_1 + 4.166666666666656e-03*G6_1_0_5_2_0_4_2 - 4.166666666666655e-03*G6_1_0_5_2_0_5_0 - 4.166666666666655e-03*G6_1_0_5_2_0_6_1 - 4.166666666666655e-03*G6_1_0_5_2_0_7_2 + 8.333333333333309e-03*G6_1_0_5_2_1_4_0 + 8.333333333333309e-03*G6_1_0_5_2_1_4_1 + 8.333333333333309e-03*G6_1_0_5_2_1_4_2 - 8.333333333333309e-03*G6_1_0_5_2_1_5_0 - 8.333333333333309e-03*G6_1_0_5_2_1_6_1 - 8.333333333333309e-03*G6_1_0_5_2_1_7_2 + 4.166666666666655e-03*G6_1_0_5_2_2_4_0 + 4.166666666666656e-03*G6_1_0_5_2_2_4_1 + 4.166666666666656e-03*G6_1_0_5_2_2_4_2 - 4.166666666666655e-03*G6_1_0_5_2_2_5_0 - 4.166666666666656e-03*G6_1_0_5_2_2_6_1 - 4.166666666666656e-03*G6_1_0_5_2_2_7_2 + 4.166666666666656e-03*G6_1_0_5_2_3_4_0 + 4.166666666666657e-03*G6_1_0_5_2_3_4_1 + 4.166666666666657e-03*G6_1_0_5_2_3_4_2 - 4.166666666666656e-03*G6_1_0_5_2_3_5_0 - 4.166666666666657e-03*G6_1_0_5_2_3_6_1 - 4.166666666666657e-03*G6_1_0_5_2_3_7_2 + 4.166666666666654e-03*G6_1_0_6_2_0_4_0 + 4.166666666666656e-03*G6_1_0_6_2_0_4_1 + 4.166666666666656e-03*G6_1_0_6_2_0_4_2 - 4.166666666666654e-03*G6_1_0_6_2_0_5_0 - 4.166666666666656e-03*G6_1_0_6_2_0_6_1 - 4.166666666666656e-03*G6_1_0_6_2_0_7_2 + 4.166666666666654e-03*G6_1_0_6_2_1_4_0 + 4.166666666666654e-03*G6_1_0_6_2_1_4_1 + 4.166666666666654e-03*G6_1_0_6_2_1_4_2 - 4.166666666666654e-03*G6_1_0_6_2_1_5_0 - 4.166666666666654e-03*G6_1_0_6_2_1_6_1 - 4.166666666666654e-03*G6_1_0_6_2_1_7_2 + 8.333333333333311e-03*G6_1_0_6_2_2_4_0 + 8.333333333333311e-03*G6_1_0_6_2_2_4_1 + 8.333333333333312e-03*G6_1_0_6_2_2_4_2 - 8.333333333333311e-03*G6_1_0_6_2_2_5_0 - 8.333333333333311e-03*G6_1_0_6_2_2_6_1 - 8.333333333333311e-03*G6_1_0_6_2_2_7_2 + 4.166666666666655e-03*G6_1_0_6_2_3_4_0 + 4.166666666666656e-03*G6_1_0_6_2_3_4_1 + 4.166666666666657e-03*G6_1_0_6_2_3_4_2 - 4.166666666666655e-03*G6_1_0_6_2_3_5_0 - 4.166666666666656e-03*G6_1_0_6_2_3_6_1 - 4.166666666666656e-03*G6_1_0_6_2_3_7_2 + 4.166666666666656e-03*G6_1_0_7_2_0_4_0 + 4.166666666666657e-03*G6_1_0_7_2_0_4_1 + 4.166666666666658e-03*G6_1_0_7_2_0_4_2 - 4.166666666666656e-03*G6_1_0_7_2_0_5_0 - 4.166666666666657e-03*G6_1_0_7_2_0_6_1 - 4.166666666666657e-03*G6_1_0_7_2_0_7_2 + 4.166666666666655e-03*G6_1_0_7_2_1_4_0 + 4.166666666666655e-03*G6_1_0_7_2_1_4_1 + 4.166666666666656e-03*G6_1_0_7_2_1_4_2 - 4.166666666666655e-03*G6_1_0_7_2_1_5_0 - 4.166666666666655e-03*G6_1_0_7_2_1_6_1 - 4.166666666666655e-03*G6_1_0_7_2_1_7_2 + 4.166666666666655e-03*G6_1_0_7_2_2_4_0 + 4.166666666666656e-03*G6_1_0_7_2_2_4_1 + 4.166666666666657e-03*G6_1_0_7_2_2_4_2 - 4.166666666666655e-03*G6_1_0_7_2_2_5_0 - 4.166666666666656e-03*G6_1_0_7_2_2_6_1 - 4.166666666666656e-03*G6_1_0_7_2_2_7_2 + 8.333333333333311e-03*G6_1_0_7_2_3_4_0 + 8.333333333333311e-03*G6_1_0_7_2_3_4_1 + 8.333333333333312e-03*G6_1_0_7_2_3_4_2 - 8.333333333333311e-03*G6_1_0_7_2_3_5_0 - 8.333333333333311e-03*G6_1_0_7_2_3_6_1 - 8.333333333333311e-03*G6_1_0_7_2_3_7_2 + 8.333333333333309e-03*G6_1_1_4_2_4_4_0 + 8.333333333333311e-03*G6_1_1_4_2_4_4_1 + 8.333333333333312e-03*G6_1_1_4_2_4_4_2 - 8.333333333333309e-03*G6_1_1_4_2_4_5_0 - 8.333333333333311e-03*G6_1_1_4_2_4_6_1 - 8.333333333333311e-03*G6_1_1_4_2_4_7_2 + 4.166666666666654e-03*G6_1_1_4_2_5_4_0 + 4.166666666666654e-03*G6_1_1_4_2_5_4_1 + 4.166666666666655e-03*G6_1_1_4_2_5_4_2 - 4.166666666666654e-03*G6_1_1_4_2_5_5_0 - 4.166666666666654e-03*G6_1_1_4_2_5_6_1 - 4.166666666666654e-03*G6_1_1_4_2_5_7_2 + 4.166666666666654e-03*G6_1_1_4_2_6_4_0 + 4.166666666666654e-03*G6_1_1_4_2_6_4_1 + 4.166666666666654e-03*G6_1_1_4_2_6_4_2 - 4.166666666666654e-03*G6_1_1_4_2_6_5_0 - 4.166666666666654e-03*G6_1_1_4_2_6_6_1 - 4.166666666666654e-03*G6_1_1_4_2_6_7_2 + 4.166666666666656e-03*G6_1_1_4_2_7_4_0 + 4.166666666666657e-03*G6_1_1_4_2_7_4_1 + 4.166666666666657e-03*G6_1_1_4_2_7_4_2 - 4.166666666666656e-03*G6_1_1_4_2_7_5_0 - 4.166666666666657e-03*G6_1_1_4_2_7_6_1 - 4.166666666666657e-03*G6_1_1_4_2_7_7_2 + 4.166666666666654e-03*G6_1_1_5_2_4_4_0 + 4.166666666666654e-03*G6_1_1_5_2_4_4_1 + 4.166666666666655e-03*G6_1_1_5_2_4_4_2 - 4.166666666666654e-03*G6_1_1_5_2_4_5_0 - 4.166666666666654e-03*G6_1_1_5_2_4_6_1 - 4.166666666666654e-03*G6_1_1_5_2_4_7_2 + 8.333333333333309e-03*G6_1_1_5_2_5_4_0 + 8.333333333333309e-03*G6_1_1_5_2_5_4_1 + 8.333333333333309e-03*G6_1_1_5_2_5_4_2 - 8.333333333333309e-03*G6_1_1_5_2_5_5_0 - 8.333333333333309e-03*G6_1_1_5_2_5_6_1 - 8.333333333333309e-03*G6_1_1_5_2_5_7_2 + 4.166666666666655e-03*G6_1_1_5_2_6_4_0 + 4.166666666666656e-03*G6_1_1_5_2_6_4_1 + 4.166666666666656e-03*G6_1_1_5_2_6_4_2 - 4.166666666666655e-03*G6_1_1_5_2_6_5_0 - 4.166666666666656e-03*G6_1_1_5_2_6_6_1 - 4.166666666666656e-03*G6_1_1_5_2_6_7_2 + 4.166666666666656e-03*G6_1_1_5_2_7_4_0 + 4.166666666666657e-03*G6_1_1_5_2_7_4_1 + 4.166666666666657e-03*G6_1_1_5_2_7_4_2 - 4.166666666666656e-03*G6_1_1_5_2_7_5_0 - 4.166666666666657e-03*G6_1_1_5_2_7_6_1 - 4.166666666666657e-03*G6_1_1_5_2_7_7_2 + 4.166666666666654e-03*G6_1_1_6_2_4_4_0 + 4.166666666666654e-03*G6_1_1_6_2_4_4_1 + 4.166666666666654e-03*G6_1_1_6_2_4_4_2 - 4.166666666666654e-03*G6_1_1_6_2_4_5_0 - 4.166666666666654e-03*G6_1_1_6_2_4_6_1 - 4.166666666666654e-03*G6_1_1_6_2_4_7_2 + 4.166666666666655e-03*G6_1_1_6_2_5_4_0 + 4.166666666666656e-03*G6_1_1_6_2_5_4_1 + 4.166666666666656e-03*G6_1_1_6_2_5_4_2 - 4.166666666666655e-03*G6_1_1_6_2_5_5_0 - 4.166666666666656e-03*G6_1_1_6_2_5_6_1 - 4.166666666666656e-03*G6_1_1_6_2_5_7_2 + 8.333333333333311e-03*G6_1_1_6_2_6_4_0 + 8.333333333333311e-03*G6_1_1_6_2_6_4_1 + 8.333333333333312e-03*G6_1_1_6_2_6_4_2 - 8.333333333333311e-03*G6_1_1_6_2_6_5_0 - 8.333333333333311e-03*G6_1_1_6_2_6_6_1 - 8.333333333333311e-03*G6_1_1_6_2_6_7_2 + 4.166666666666655e-03*G6_1_1_6_2_7_4_0 + 4.166666666666656e-03*G6_1_1_6_2_7_4_1 + 4.166666666666657e-03*G6_1_1_6_2_7_4_2 - 4.166666666666655e-03*G6_1_1_6_2_7_5_0 - 4.166666666666656e-03*G6_1_1_6_2_7_6_1 - 4.166666666666656e-03*G6_1_1_6_2_7_7_2 + 4.166666666666656e-03*G6_1_1_7_2_4_4_0 + 4.166666666666657e-03*G6_1_1_7_2_4_4_1 + 4.166666666666657e-03*G6_1_1_7_2_4_4_2 - 4.166666666666656e-03*G6_1_1_7_2_4_5_0 - 4.166666666666657e-03*G6_1_1_7_2_4_6_1 - 4.166666666666657e-03*G6_1_1_7_2_4_7_2 + 4.166666666666656e-03*G6_1_1_7_2_5_4_0 + 4.166666666666657e-03*G6_1_1_7_2_5_4_1 + 4.166666666666657e-03*G6_1_1_7_2_5_4_2 - 4.166666666666656e-03*G6_1_1_7_2_5_5_0 - 4.166666666666657e-03*G6_1_1_7_2_5_6_1 - 4.166666666666657e-03*G6_1_1_7_2_5_7_2 + 4.166666666666655e-03*G6_1_1_7_2_6_4_0 + 4.166666666666656e-03*G6_1_1_7_2_6_4_1 + 4.166666666666657e-03*G6_1_1_7_2_6_4_2 - 4.166666666666655e-03*G6_1_1_7_2_6_5_0 - 4.166666666666656e-03*G6_1_1_7_2_6_6_1 - 4.166666666666656e-03*G6_1_1_7_2_6_7_2 + 8.333333333333311e-03*G6_1_1_7_2_7_4_0 + 8.333333333333311e-03*G6_1_1_7_2_7_4_1 + 8.333333333333312e-03*G6_1_1_7_2_7_4_2 - 8.333333333333311e-03*G6_1_1_7_2_7_5_0 - 8.333333333333311e-03*G6_1_1_7_2_7_6_1 - 8.333333333333311e-03*G6_1_1_7_2_7_7_2 + 8.333333333333309e-03*G6_1_2_4_2_8_4_0 + 8.333333333333311e-03*G6_1_2_4_2_8_4_1 + 8.333333333333312e-03*G6_1_2_4_2_8_4_2 - 8.333333333333309e-03*G6_1_2_4_2_8_5_0 - 8.333333333333311e-03*G6_1_2_4_2_8_6_1 - 8.333333333333311e-03*G6_1_2_4_2_8_7_2 + 4.166666666666654e-03*G6_1_2_4_2_9_4_0 + 4.166666666666654e-03*G6_1_2_4_2_9_4_1 + 4.166666666666655e-03*G6_1_2_4_2_9_4_2 - 4.166666666666654e-03*G6_1_2_4_2_9_5_0 - 4.166666666666654e-03*G6_1_2_4_2_9_6_1 - 4.166666666666654e-03*G6_1_2_4_2_9_7_2 + 4.166666666666654e-03*G6_1_2_4_2_10_4_0 + 4.166666666666654e-03*G6_1_2_4_2_10_4_1 + 4.166666666666654e-03*G6_1_2_4_2_10_4_2 - 4.166666666666654e-03*G6_1_2_4_2_10_5_0 - 4.166666666666654e-03*G6_1_2_4_2_10_6_1 - 4.166666666666654e-03*G6_1_2_4_2_10_7_2 + 4.166666666666656e-03*G6_1_2_4_2_11_4_0 + 4.166666666666657e-03*G6_1_2_4_2_11_4_1 + 4.166666666666657e-03*G6_1_2_4_2_11_4_2 - 4.166666666666656e-03*G6_1_2_4_2_11_5_0 - 4.166666666666657e-03*G6_1_2_4_2_11_6_1 - 4.166666666666657e-03*G6_1_2_4_2_11_7_2 + 4.166666666666654e-03*G6_1_2_5_2_8_4_0 + 4.166666666666654e-03*G6_1_2_5_2_8_4_1 + 4.166666666666655e-03*G6_1_2_5_2_8_4_2 - 4.166666666666654e-03*G6_1_2_5_2_8_5_0 - 4.166666666666654e-03*G6_1_2_5_2_8_6_1 - 4.166666666666654e-03*G6_1_2_5_2_8_7_2 + 8.333333333333309e-03*G6_1_2_5_2_9_4_0 + 8.333333333333309e-03*G6_1_2_5_2_9_4_1 + 8.333333333333309e-03*G6_1_2_5_2_9_4_2 - 8.333333333333309e-03*G6_1_2_5_2_9_5_0 - 8.333333333333309e-03*G6_1_2_5_2_9_6_1 - 8.333333333333309e-03*G6_1_2_5_2_9_7_2 + 4.166666666666655e-03*G6_1_2_5_2_10_4_0 + 4.166666666666656e-03*G6_1_2_5_2_10_4_1 + 4.166666666666656e-03*G6_1_2_5_2_10_4_2 - 4.166666666666655e-03*G6_1_2_5_2_10_5_0 - 4.166666666666656e-03*G6_1_2_5_2_10_6_1 - 4.166666666666656e-03*G6_1_2_5_2_10_7_2 + 4.166666666666656e-03*G6_1_2_5_2_11_4_0 + 4.166666666666657e-03*G6_1_2_5_2_11_4_1 + 4.166666666666657e-03*G6_1_2_5_2_11_4_2 - 4.166666666666656e-03*G6_1_2_5_2_11_5_0 - 4.166666666666657e-03*G6_1_2_5_2_11_6_1 - 4.166666666666657e-03*G6_1_2_5_2_11_7_2 + 4.166666666666654e-03*G6_1_2_6_2_8_4_0 + 4.166666666666654e-03*G6_1_2_6_2_8_4_1 + 4.166666666666654e-03*G6_1_2_6_2_8_4_2 - 4.166666666666654e-03*G6_1_2_6_2_8_5_0 - 4.166666666666654e-03*G6_1_2_6_2_8_6_1 - 4.166666666666654e-03*G6_1_2_6_2_8_7_2 + 4.166666666666655e-03*G6_1_2_6_2_9_4_0 + 4.166666666666656e-03*G6_1_2_6_2_9_4_1 + 4.166666666666656e-03*G6_1_2_6_2_9_4_2 - 4.166666666666655e-03*G6_1_2_6_2_9_5_0 - 4.166666666666656e-03*G6_1_2_6_2_9_6_1 - 4.166666666666656e-03*G6_1_2_6_2_9_7_2 + 8.333333333333311e-03*G6_1_2_6_2_10_4_0 + 8.333333333333311e-03*G6_1_2_6_2_10_4_1 + 8.333333333333312e-03*G6_1_2_6_2_10_4_2 - 8.333333333333311e-03*G6_1_2_6_2_10_5_0 - 8.333333333333311e-03*G6_1_2_6_2_10_6_1 - 8.333333333333311e-03*G6_1_2_6_2_10_7_2 + 4.166666666666655e-03*G6_1_2_6_2_11_4_0 + 4.166666666666656e-03*G6_1_2_6_2_11_4_1 + 4.166666666666657e-03*G6_1_2_6_2_11_4_2 - 4.166666666666655e-03*G6_1_2_6_2_11_5_0 - 4.166666666666656e-03*G6_1_2_6_2_11_6_1 - 4.166666666666656e-03*G6_1_2_6_2_11_7_2 + 4.166666666666656e-03*G6_1_2_7_2_8_4_0 + 4.166666666666657e-03*G6_1_2_7_2_8_4_1 + 4.166666666666657e-03*G6_1_2_7_2_8_4_2 - 4.166666666666656e-03*G6_1_2_7_2_8_5_0 - 4.166666666666657e-03*G6_1_2_7_2_8_6_1 - 4.166666666666657e-03*G6_1_2_7_2_8_7_2 + 4.166666666666656e-03*G6_1_2_7_2_9_4_0 + 4.166666666666657e-03*G6_1_2_7_2_9_4_1 + 4.166666666666657e-03*G6_1_2_7_2_9_4_2 - 4.166666666666656e-03*G6_1_2_7_2_9_5_0 - 4.166666666666657e-03*G6_1_2_7_2_9_6_1 - 4.166666666666657e-03*G6_1_2_7_2_9_7_2 + 4.166666666666655e-03*G6_1_2_7_2_10_4_0 + 4.166666666666656e-03*G6_1_2_7_2_10_4_1 + 4.166666666666657e-03*G6_1_2_7_2_10_4_2 - 4.166666666666655e-03*G6_1_2_7_2_10_5_0 - 4.166666666666656e-03*G6_1_2_7_2_10_6_1 - 4.166666666666656e-03*G6_1_2_7_2_10_7_2 + 8.333333333333311e-03*G6_1_2_7_2_11_4_0 + 8.333333333333311e-03*G6_1_2_7_2_11_4_1 + 8.333333333333312e-03*G6_1_2_7_2_11_4_2 - 8.333333333333311e-03*G6_1_2_7_2_11_5_0 - 8.333333333333311e-03*G6_1_2_7_2_11_6_1 - 8.333333333333311e-03*G6_1_2_7_2_11_7_2 + 8.333333333333309e-03*G6_2_0_8_2_0_4_0 + 8.333333333333311e-03*G6_2_0_8_2_0_4_1 + 8.333333333333312e-03*G6_2_0_8_2_0_4_2 - 8.333333333333309e-03*G6_2_0_8_2_0_5_0 - 8.333333333333311e-03*G6_2_0_8_2_0_6_1 - 8.333333333333311e-03*G6_2_0_8_2_0_7_2 + 4.166666666666654e-03*G6_2_0_8_2_1_4_0 + 4.166666666666654e-03*G6_2_0_8_2_1_4_1 + 4.166666666666654e-03*G6_2_0_8_2_1_4_2 - 4.166666666666654e-03*G6_2_0_8_2_1_5_0 - 4.166666666666654e-03*G6_2_0_8_2_1_6_1 - 4.166666666666654e-03*G6_2_0_8_2_1_7_2 + 4.166666666666654e-03*G6_2_0_8_2_2_4_0 + 4.166666666666654e-03*G6_2_0_8_2_2_4_1 + 4.166666666666654e-03*G6_2_0_8_2_2_4_2 - 4.166666666666654e-03*G6_2_0_8_2_2_5_0 - 4.166666666666654e-03*G6_2_0_8_2_2_6_1 - 4.166666666666654e-03*G6_2_0_8_2_2_7_2 + 4.166666666666656e-03*G6_2_0_8_2_3_4_0 + 4.166666666666657e-03*G6_2_0_8_2_3_4_1 + 4.166666666666657e-03*G6_2_0_8_2_3_4_2 - 4.166666666666656e-03*G6_2_0_8_2_3_5_0 - 4.166666666666657e-03*G6_2_0_8_2_3_6_1 - 4.166666666666657e-03*G6_2_0_8_2_3_7_2 + 4.166666666666655e-03*G6_2_0_9_2_0_4_0 + 4.166666666666655e-03*G6_2_0_9_2_0_4_1 + 4.166666666666656e-03*G6_2_0_9_2_0_4_2 - 4.166666666666655e-03*G6_2_0_9_2_0_5_0 - 4.166666666666655e-03*G6_2_0_9_2_0_6_1 - 4.166666666666655e-03*G6_2_0_9_2_0_7_2 + 8.333333333333309e-03*G6_2_0_9_2_1_4_0 + 8.333333333333309e-03*G6_2_0_9_2_1_4_1 + 8.333333333333309e-03*G6_2_0_9_2_1_4_2 - 8.333333333333309e-03*G6_2_0_9_2_1_5_0 - 8.333333333333309e-03*G6_2_0_9_2_1_6_1 - 8.333333333333309e-03*G6_2_0_9_2_1_7_2 + 4.166666666666655e-03*G6_2_0_9_2_2_4_0 + 4.166666666666656e-03*G6_2_0_9_2_2_4_1 + 4.166666666666656e-03*G6_2_0_9_2_2_4_2 - 4.166666666666655e-03*G6_2_0_9_2_2_5_0 - 4.166666666666656e-03*G6_2_0_9_2_2_6_1 - 4.166666666666656e-03*G6_2_0_9_2_2_7_2 + 4.166666666666656e-03*G6_2_0_9_2_3_4_0 + 4.166666666666657e-03*G6_2_0_9_2_3_4_1 + 4.166666666666657e-03*G6_2_0_9_2_3_4_2 - 4.166666666666656e-03*G6_2_0_9_2_3_5_0 - 4.166666666666657e-03*G6_2_0_9_2_3_6_1 - 4.166666666666657e-03*G6_2_0_9_2_3_7_2 + 4.166666666666654e-03*G6_2_0_10_2_0_4_0 + 4.166666666666656e-03*G6_2_0_10_2_0_4_1 + 4.166666666666656e-03*G6_2_0_10_2_0_4_2 - 4.166666666666654e-03*G6_2_0_10_2_0_5_0 - 4.166666666666656e-03*G6_2_0_10_2_0_6_1 - 4.166666666666656e-03*G6_2_0_10_2_0_7_2 + 4.166666666666654e-03*G6_2_0_10_2_1_4_0 + 4.166666666666654e-03*G6_2_0_10_2_1_4_1 + 4.166666666666654e-03*G6_2_0_10_2_1_4_2 - 4.166666666666654e-03*G6_2_0_10_2_1_5_0 - 4.166666666666654e-03*G6_2_0_10_2_1_6_1 - 4.166666666666654e-03*G6_2_0_10_2_1_7_2 + 8.333333333333311e-03*G6_2_0_10_2_2_4_0 + 8.333333333333311e-03*G6_2_0_10_2_2_4_1 + 8.333333333333312e-03*G6_2_0_10_2_2_4_2 - 8.333333333333311e-03*G6_2_0_10_2_2_5_0 - 8.333333333333311e-03*G6_2_0_10_2_2_6_1 - 8.333333333333311e-03*G6_2_0_10_2_2_7_2 + 4.166666666666655e-03*G6_2_0_10_2_3_4_0 + 4.166666666666656e-03*G6_2_0_10_2_3_4_1 + 4.166666666666657e-03*G6_2_0_10_2_3_4_2 - 4.166666666666655e-03*G6_2_0_10_2_3_5_0 - 4.166666666666656e-03*G6_2_0_10_2_3_6_1 - 4.166666666666656e-03*G6_2_0_10_2_3_7_2 + 4.166666666666656e-03*G6_2_0_11_2_0_4_0 + 4.166666666666657e-03*G6_2_0_11_2_0_4_1 + 4.166666666666658e-03*G6_2_0_11_2_0_4_2 - 4.166666666666656e-03*G6_2_0_11_2_0_5_0 - 4.166666666666657e-03*G6_2_0_11_2_0_6_1 - 4.166666666666657e-03*G6_2_0_11_2_0_7_2 + 4.166666666666655e-03*G6_2_0_11_2_1_4_0 + 4.166666666666655e-03*G6_2_0_11_2_1_4_1 + 4.166666666666656e-03*G6_2_0_11_2_1_4_2 - 4.166666666666655e-03*G6_2_0_11_2_1_5_0 - 4.166666666666655e-03*G6_2_0_11_2_1_6_1 - 4.166666666666655e-03*G6_2_0_11_2_1_7_2 + 4.166666666666655e-03*G6_2_0_11_2_2_4_0 + 4.166666666666656e-03*G6_2_0_11_2_2_4_1 + 4.166666666666657e-03*G6_2_0_11_2_2_4_2 - 4.166666666666655e-03*G6_2_0_11_2_2_5_0 - 4.166666666666656e-03*G6_2_0_11_2_2_6_1 - 4.166666666666656e-03*G6_2_0_11_2_2_7_2 + 8.333333333333311e-03*G6_2_0_11_2_3_4_0 + 8.333333333333311e-03*G6_2_0_11_2_3_4_1 + 8.333333333333312e-03*G6_2_0_11_2_3_4_2 - 8.333333333333311e-03*G6_2_0_11_2_3_5_0 - 8.333333333333311e-03*G6_2_0_11_2_3_6_1 - 8.333333333333311e-03*G6_2_0_11_2_3_7_2 + 8.333333333333309e-03*G6_2_1_8_2_4_4_0 + 8.333333333333311e-03*G6_2_1_8_2_4_4_1 + 8.333333333333312e-03*G6_2_1_8_2_4_4_2 - 8.333333333333309e-03*G6_2_1_8_2_4_5_0 - 8.333333333333311e-03*G6_2_1_8_2_4_6_1 - 8.333333333333311e-03*G6_2_1_8_2_4_7_2 + 4.166666666666654e-03*G6_2_1_8_2_5_4_0 + 4.166666666666654e-03*G6_2_1_8_2_5_4_1 + 4.166666666666655e-03*G6_2_1_8_2_5_4_2 - 4.166666666666654e-03*G6_2_1_8_2_5_5_0 - 4.166666666666654e-03*G6_2_1_8_2_5_6_1 - 4.166666666666654e-03*G6_2_1_8_2_5_7_2 + 4.166666666666654e-03*G6_2_1_8_2_6_4_0 + 4.166666666666654e-03*G6_2_1_8_2_6_4_1 + 4.166666666666654e-03*G6_2_1_8_2_6_4_2 - 4.166666666666654e-03*G6_2_1_8_2_6_5_0 - 4.166666666666654e-03*G6_2_1_8_2_6_6_1 - 4.166666666666654e-03*G6_2_1_8_2_6_7_2 + 4.166666666666656e-03*G6_2_1_8_2_7_4_0 + 4.166666666666657e-03*G6_2_1_8_2_7_4_1 + 4.166666666666657e-03*G6_2_1_8_2_7_4_2 - 4.166666666666656e-03*G6_2_1_8_2_7_5_0 - 4.166666666666657e-03*G6_2_1_8_2_7_6_1 - 4.166666666666657e-03*G6_2_1_8_2_7_7_2 + 4.166666666666654e-03*G6_2_1_9_2_4_4_0 + 4.166666666666654e-03*G6_2_1_9_2_4_4_1 + 4.166666666666655e-03*G6_2_1_9_2_4_4_2 - 4.166666666666654e-03*G6_2_1_9_2_4_5_0 - 4.166666666666654e-03*G6_2_1_9_2_4_6_1 - 4.166666666666654e-03*G6_2_1_9_2_4_7_2 + 8.333333333333309e-03*G6_2_1_9_2_5_4_0 + 8.333333333333309e-03*G6_2_1_9_2_5_4_1 + 8.333333333333309e-03*G6_2_1_9_2_5_4_2 - 8.333333333333309e-03*G6_2_1_9_2_5_5_0 - 8.333333333333309e-03*G6_2_1_9_2_5_6_1 - 8.333333333333309e-03*G6_2_1_9_2_5_7_2 + 4.166666666666655e-03*G6_2_1_9_2_6_4_0 + 4.166666666666656e-03*G6_2_1_9_2_6_4_1 + 4.166666666666656e-03*G6_2_1_9_2_6_4_2 - 4.166666666666655e-03*G6_2_1_9_2_6_5_0 - 4.166666666666656e-03*G6_2_1_9_2_6_6_1 - 4.166666666666656e-03*G6_2_1_9_2_6_7_2 + 4.166666666666656e-03*G6_2_1_9_2_7_4_0 + 4.166666666666657e-03*G6_2_1_9_2_7_4_1 + 4.166666666666657e-03*G6_2_1_9_2_7_4_2 - 4.166666666666656e-03*G6_2_1_9_2_7_5_0 - 4.166666666666657e-03*G6_2_1_9_2_7_6_1 - 4.166666666666657e-03*G6_2_1_9_2_7_7_2 + 4.166666666666654e-03*G6_2_1_10_2_4_4_0 + 4.166666666666654e-03*G6_2_1_10_2_4_4_1 + 4.166666666666654e-03*G6_2_1_10_2_4_4_2 - 4.166666666666654e-03*G6_2_1_10_2_4_5_0 - 4.166666666666654e-03*G6_2_1_10_2_4_6_1 - 4.166666666666654e-03*G6_2_1_10_2_4_7_2 + 4.166666666666655e-03*G6_2_1_10_2_5_4_0 + 4.166666666666656e-03*G6_2_1_10_2_5_4_1 + 4.166666666666656e-03*G6_2_1_10_2_5_4_2 - 4.166666666666655e-03*G6_2_1_10_2_5_5_0 - 4.166666666666656e-03*G6_2_1_10_2_5_6_1 - 4.166666666666656e-03*G6_2_1_10_2_5_7_2 + 8.333333333333311e-03*G6_2_1_10_2_6_4_0 + 8.333333333333311e-03*G6_2_1_10_2_6_4_1 + 8.333333333333312e-03*G6_2_1_10_2_6_4_2 - 8.333333333333311e-03*G6_2_1_10_2_6_5_0 - 8.333333333333311e-03*G6_2_1_10_2_6_6_1 - 8.333333333333311e-03*G6_2_1_10_2_6_7_2 + 4.166666666666655e-03*G6_2_1_10_2_7_4_0 + 4.166666666666656e-03*G6_2_1_10_2_7_4_1 + 4.166666666666657e-03*G6_2_1_10_2_7_4_2 - 4.166666666666655e-03*G6_2_1_10_2_7_5_0 - 4.166666666666656e-03*G6_2_1_10_2_7_6_1 - 4.166666666666656e-03*G6_2_1_10_2_7_7_2 + 4.166666666666656e-03*G6_2_1_11_2_4_4_0 + 4.166666666666657e-03*G6_2_1_11_2_4_4_1 + 4.166666666666657e-03*G6_2_1_11_2_4_4_2 - 4.166666666666656e-03*G6_2_1_11_2_4_5_0 - 4.166666666666657e-03*G6_2_1_11_2_4_6_1 - 4.166666666666657e-03*G6_2_1_11_2_4_7_2 + 4.166666666666656e-03*G6_2_1_11_2_5_4_0 + 4.166666666666657e-03*G6_2_1_11_2_5_4_1 + 4.166666666666657e-03*G6_2_1_11_2_5_4_2 - 4.166666666666656e-03*G6_2_1_11_2_5_5_0 - 4.166666666666657e-03*G6_2_1_11_2_5_6_1 - 4.166666666666657e-03*G6_2_1_11_2_5_7_2 + 4.166666666666655e-03*G6_2_1_11_2_6_4_0 + 4.166666666666656e-03*G6_2_1_11_2_6_4_1 + 4.166666666666657e-03*G6_2_1_11_2_6_4_2 - 4.166666666666655e-03*G6_2_1_11_2_6_5_0 - 4.166666666666656e-03*G6_2_1_11_2_6_6_1 - 4.166666666666656e-03*G6_2_1_11_2_6_7_2 + 8.333333333333311e-03*G6_2_1_11_2_7_4_0 + 8.333333333333311e-03*G6_2_1_11_2_7_4_1 + 8.333333333333312e-03*G6_2_1_11_2_7_4_2 - 8.333333333333311e-03*G6_2_1_11_2_7_5_0 - 8.333333333333311e-03*G6_2_1_11_2_7_6_1 - 8.333333333333311e-03*G6_2_1_11_2_7_7_2 + 8.333333333333309e-03*G6_2_2_8_2_8_4_0 + 8.333333333333311e-03*G6_2_2_8_2_8_4_1 + 8.333333333333312e-03*G6_2_2_8_2_8_4_2 - 8.333333333333309e-03*G6_2_2_8_2_8_5_0 - 8.333333333333311e-03*G6_2_2_8_2_8_6_1 - 8.333333333333311e-03*G6_2_2_8_2_8_7_2 + 4.166666666666654e-03*G6_2_2_8_2_9_4_0 + 4.166666666666654e-03*G6_2_2_8_2_9_4_1 + 4.166666666666655e-03*G6_2_2_8_2_9_4_2 - 4.166666666666654e-03*G6_2_2_8_2_9_5_0 - 4.166666666666654e-03*G6_2_2_8_2_9_6_1 - 4.166666666666654e-03*G6_2_2_8_2_9_7_2 + 4.166666666666654e-03*G6_2_2_8_2_10_4_0 + 4.166666666666654e-03*G6_2_2_8_2_10_4_1 + 4.166666666666654e-03*G6_2_2_8_2_10_4_2 - 4.166666666666654e-03*G6_2_2_8_2_10_5_0 - 4.166666666666654e-03*G6_2_2_8_2_10_6_1 - 4.166666666666654e-03*G6_2_2_8_2_10_7_2 + 4.166666666666656e-03*G6_2_2_8_2_11_4_0 + 4.166666666666657e-03*G6_2_2_8_2_11_4_1 + 4.166666666666657e-03*G6_2_2_8_2_11_4_2 - 4.166666666666656e-03*G6_2_2_8_2_11_5_0 - 4.166666666666657e-03*G6_2_2_8_2_11_6_1 - 4.166666666666657e-03*G6_2_2_8_2_11_7_2 + 4.166666666666654e-03*G6_2_2_9_2_8_4_0 + 4.166666666666654e-03*G6_2_2_9_2_8_4_1 + 4.166666666666655e-03*G6_2_2_9_2_8_4_2 - 4.166666666666654e-03*G6_2_2_9_2_8_5_0 - 4.166666666666654e-03*G6_2_2_9_2_8_6_1 - 4.166666666666654e-03*G6_2_2_9_2_8_7_2 + 8.333333333333309e-03*G6_2_2_9_2_9_4_0 + 8.333333333333309e-03*G6_2_2_9_2_9_4_1 + 8.333333333333309e-03*G6_2_2_9_2_9_4_2 - 8.333333333333309e-03*G6_2_2_9_2_9_5_0 - 8.333333333333309e-03*G6_2_2_9_2_9_6_1 - 8.333333333333309e-03*G6_2_2_9_2_9_7_2 + 4.166666666666655e-03*G6_2_2_9_2_10_4_0 + 4.166666666666656e-03*G6_2_2_9_2_10_4_1 + 4.166666666666656e-03*G6_2_2_9_2_10_4_2 - 4.166666666666655e-03*G6_2_2_9_2_10_5_0 - 4.166666666666656e-03*G6_2_2_9_2_10_6_1 - 4.166666666666656e-03*G6_2_2_9_2_10_7_2 + 4.166666666666656e-03*G6_2_2_9_2_11_4_0 + 4.166666666666657e-03*G6_2_2_9_2_11_4_1 + 4.166666666666657e-03*G6_2_2_9_2_11_4_2 - 4.166666666666656e-03*G6_2_2_9_2_11_5_0 - 4.166666666666657e-03*G6_2_2_9_2_11_6_1 - 4.166666666666657e-03*G6_2_2_9_2_11_7_2 + 4.166666666666654e-03*G6_2_2_10_2_8_4_0 + 4.166666666666654e-03*G6_2_2_10_2_8_4_1 + 4.166666666666654e-03*G6_2_2_10_2_8_4_2 - 4.166666666666654e-03*G6_2_2_10_2_8_5_0 - 4.166666666666654e-03*G6_2_2_10_2_8_6_1 - 4.166666666666654e-03*G6_2_2_10_2_8_7_2 + 4.166666666666655e-03*G6_2_2_10_2_9_4_0 + 4.166666666666656e-03*G6_2_2_10_2_9_4_1 + 4.166666666666656e-03*G6_2_2_10_2_9_4_2 - 4.166666666666655e-03*G6_2_2_10_2_9_5_0 - 4.166666666666656e-03*G6_2_2_10_2_9_6_1 - 4.166666666666656e-03*G6_2_2_10_2_9_7_2 + 8.333333333333311e-03*G6_2_2_10_2_10_4_0 + 8.333333333333311e-03*G6_2_2_10_2_10_4_1 + 8.333333333333312e-03*G6_2_2_10_2_10_4_2 - 8.333333333333311e-03*G6_2_2_10_2_10_5_0 - 8.333333333333311e-03*G6_2_2_10_2_10_6_1 - 8.333333333333311e-03*G6_2_2_10_2_10_7_2 + 4.166666666666655e-03*G6_2_2_10_2_11_4_0 + 4.166666666666656e-03*G6_2_2_10_2_11_4_1 + 4.166666666666657e-03*G6_2_2_10_2_11_4_2 - 4.166666666666655e-03*G6_2_2_10_2_11_5_0 - 4.166666666666656e-03*G6_2_2_10_2_11_6_1 - 4.166666666666656e-03*G6_2_2_10_2_11_7_2 + 4.166666666666656e-03*G6_2_2_11_2_8_4_0 + 4.166666666666657e-03*G6_2_2_11_2_8_4_1 + 4.166666666666657e-03*G6_2_2_11_2_8_4_2 - 4.166666666666656e-03*G6_2_2_11_2_8_5_0 - 4.166666666666657e-03*G6_2_2_11_2_8_6_1 - 4.166666666666657e-03*G6_2_2_11_2_8_7_2 + 4.166666666666656e-03*G6_2_2_11_2_9_4_0 + 4.166666666666657e-03*G6_2_2_11_2_9_4_1 + 4.166666666666657e-03*G6_2_2_11_2_9_4_2 - 4.166666666666656e-03*G6_2_2_11_2_9_5_0 - 4.166666666666657e-03*G6_2_2_11_2_9_6_1 - 4.166666666666657e-03*G6_2_2_11_2_9_7_2 + 4.166666666666655e-03*G6_2_2_11_2_10_4_0 + 4.166666666666656e-03*G6_2_2_11_2_10_4_1 + 4.166666666666657e-03*G6_2_2_11_2_10_4_2 - 4.166666666666655e-03*G6_2_2_11_2_10_5_0 - 4.166666666666656e-03*G6_2_2_11_2_10_6_1 - 4.166666666666656e-03*G6_2_2_11_2_10_7_2 + 8.333333333333311e-03*G6_2_2_11_2_11_4_0 + 8.333333333333311e-03*G6_2_2_11_2_11_4_1 + 8.333333333333312e-03*G6_2_2_11_2_11_4_2 - 8.333333333333311e-03*G6_2_2_11_2_11_5_0 - 8.333333333333311e-03*G6_2_2_11_2_11_6_1 - 8.333333333333311e-03*G6_2_2_11_2_11_7_2 + 4.166666666666662e-02*G7_1_0_0_2_0_0 + 4.166666666666662e-02*G7_1_0_0_2_0_1 + 4.166666666666662e-02*G7_1_0_0_2_0_2 - 4.166666666666662e-02*G7_1_0_0_2_1_0 - 4.166666666666662e-02*G7_1_0_0_2_2_1 - 4.166666666666662e-02*G7_1_0_0_2_3_2 + 4.166666666666660e-02*G7_1_0_1_2_0_0 + 4.166666666666661e-02*G7_1_0_1_2_0_1 + 4.166666666666661e-02*G7_1_0_1_2_0_2 - 4.166666666666660e-02*G7_1_0_1_2_1_0 - 4.166666666666661e-02*G7_1_0_1_2_2_1 - 4.166666666666661e-02*G7_1_0_1_2_3_2 + 4.166666666666661e-02*G7_1_0_2_2_0_0 + 4.166666666666662e-02*G7_1_0_2_2_0_1 + 4.166666666666662e-02*G7_1_0_2_2_0_2 - 4.166666666666661e-02*G7_1_0_2_2_1_0 - 4.166666666666662e-02*G7_1_0_2_2_2_1 - 4.166666666666662e-02*G7_1_0_2_2_3_2 + 4.166666666666661e-02*G7_1_0_3_2_0_0 + 4.166666666666662e-02*G7_1_0_3_2_0_1 + 4.166666666666662e-02*G7_1_0_3_2_0_2 - 4.166666666666661e-02*G7_1_0_3_2_1_0 - 4.166666666666662e-02*G7_1_0_3_2_2_1 - 4.166666666666662e-02*G7_1_0_3_2_3_2 + 4.166666666666661e-02*G7_1_1_4_2_0_0 + 4.166666666666662e-02*G7_1_1_4_2_0_1 + 4.166666666666662e-02*G7_1_1_4_2_0_2 - 4.166666666666661e-02*G7_1_1_4_2_1_0 - 4.166666666666662e-02*G7_1_1_4_2_2_1 - 4.166666666666662e-02*G7_1_1_4_2_3_2 + 4.166666666666661e-02*G7_1_1_5_2_0_0 + 4.166666666666662e-02*G7_1_1_5_2_0_1 + 4.166666666666662e-02*G7_1_1_5_2_0_2 - 4.166666666666661e-02*G7_1_1_5_2_1_0 - 4.166666666666662e-02*G7_1_1_5_2_2_1 - 4.166666666666662e-02*G7_1_1_5_2_3_2 + 4.166666666666661e-02*G7_1_1_6_2_0_0 + 4.166666666666662e-02*G7_1_1_6_2_0_1 + 4.166666666666662e-02*G7_1_1_6_2_0_2 - 4.166666666666661e-02*G7_1_1_6_2_1_0 - 4.166666666666662e-02*G7_1_1_6_2_2_1 - 4.166666666666662e-02*G7_1_1_6_2_3_2 + 4.166666666666661e-02*G7_1_1_7_2_0_0 + 4.166666666666662e-02*G7_1_1_7_2_0_1 + 4.166666666666662e-02*G7_1_1_7_2_0_2 - 4.166666666666661e-02*G7_1_1_7_2_1_0 - 4.166666666666662e-02*G7_1_1_7_2_2_1 - 4.166666666666662e-02*G7_1_1_7_2_3_2 + 4.166666666666661e-02*G7_1_2_8_2_0_0 + 4.166666666666662e-02*G7_1_2_8_2_0_1 + 4.166666666666662e-02*G7_1_2_8_2_0_2 - 4.166666666666661e-02*G7_1_2_8_2_1_0 - 4.166666666666662e-02*G7_1_2_8_2_2_1 - 4.166666666666662e-02*G7_1_2_8_2_3_2 + 4.166666666666661e-02*G7_1_2_9_2_0_0 + 4.166666666666662e-02*G7_1_2_9_2_0_1 + 4.166666666666662e-02*G7_1_2_9_2_0_2 - 4.166666666666661e-02*G7_1_2_9_2_1_0 - 4.166666666666662e-02*G7_1_2_9_2_2_1 - 4.166666666666662e-02*G7_1_2_9_2_3_2 + 4.166666666666661e-02*G7_1_2_10_2_0_0 + 4.166666666666662e-02*G7_1_2_10_2_0_1 + 4.166666666666662e-02*G7_1_2_10_2_0_2 - 4.166666666666661e-02*G7_1_2_10_2_1_0 - 4.166666666666662e-02*G7_1_2_10_2_2_1 - 4.166666666666662e-02*G7_1_2_10_2_3_2 + 4.166666666666661e-02*G7_1_2_11_2_0_0 + 4.166666666666662e-02*G7_1_2_11_2_0_1 + 4.166666666666662e-02*G7_1_2_11_2_0_2 - 4.166666666666661e-02*G7_1_2_11_2_1_0 - 4.166666666666662e-02*G7_1_2_11_2_2_1 - 4.166666666666662e-02*G7_1_2_11_2_3_2 + 8.333333333333322e-02*G8_1_0_2_0_0 + 8.333333333333323e-02*G8_1_0_2_0_1 + 8.333333333333322e-02*G8_1_0_2_0_2 - 8.333333333333322e-02*G8_1_0_2_1_0 - 8.333333333333323e-02*G8_1_0_2_2_1 - 8.333333333333323e-02*G8_1_0_2_3_2 + 8.333333333333322e-02*G8_1_1_2_4_0 + 8.333333333333323e-02*G8_1_1_2_4_1 + 8.333333333333323e-02*G8_1_1_2_4_2 - 8.333333333333322e-02*G8_1_1_2_5_0 - 8.333333333333323e-02*G8_1_1_2_6_1 - 8.333333333333323e-02*G8_1_1_2_7_2 + 8.333333333333322e-02*G8_1_2_2_8_0 + 8.333333333333323e-02*G8_1_2_2_8_1 + 8.333333333333323e-02*G8_1_2_2_8_2 - 8.333333333333322e-02*G8_1_2_2_9_0 - 8.333333333333323e-02*G8_1_2_2_10_1 - 8.333333333333323e-02*G8_1_2_2_11_2;
    block[8] = 1.666666666666662e-02*G0_8 + 8.333333333333309e-03*G0_9 + 8.333333333333309e-03*G0_10 + 8.333333333333314e-03*G0_11 + 1.666666666666662e-02*G1_8 + 8.333333333333309e-03*G1_9 + 8.333333333333309e-03*G1_10 + 8.333333333333314e-03*G1_11 - 4.166666666666661e-02*G2_2_0_0 - 4.166666666666661e-02*G2_2_0_1 - 4.166666666666661e-02*G2_2_0_2 - 4.166666666666661e-02*G2_2_0_3 - 4.166666666666662e-02*G2_2_1_0 - 4.166666666666662e-02*G2_2_1_1 - 4.166666666666662e-02*G2_2_1_2 - 4.166666666666662e-02*G2_2_1_3 - 4.166666666666662e-02*G2_2_2_0 - 4.166666666666662e-02*G2_2_2_1 - 4.166666666666662e-02*G2_2_2_2 - 4.166666666666662e-02*G2_2_2_3 - 1.666666666666662e-02*G3_0_0_0_8 - 8.333333333333311e-03*G3_0_0_0_9 - 8.333333333333309e-03*G3_0_0_0_10 - 8.333333333333312e-03*G3_0_0_0_11 - 1.666666666666662e-02*G3_0_0_1_8 - 8.333333333333311e-03*G3_0_0_1_9 - 8.333333333333312e-03*G3_0_0_1_10 - 8.333333333333314e-03*G3_0_0_1_11 - 1.666666666666662e-02*G3_0_0_2_8 - 8.333333333333312e-03*G3_0_0_2_9 - 8.333333333333312e-03*G3_0_0_2_10 - 8.333333333333316e-03*G3_0_0_2_11 - 8.333333333333307e-03*G3_0_1_0_8 - 1.666666666666662e-02*G3_0_1_0_9 - 8.333333333333309e-03*G3_0_1_0_10 - 8.333333333333311e-03*G3_0_1_0_11 - 8.333333333333309e-03*G3_0_1_1_8 - 1.666666666666662e-02*G3_0_1_1_9 - 8.333333333333309e-03*G3_0_1_1_10 - 8.333333333333311e-03*G3_0_1_1_11 - 8.333333333333309e-03*G3_0_1_2_8 - 1.666666666666662e-02*G3_0_1_2_9 - 8.333333333333311e-03*G3_0_1_2_10 - 8.333333333333312e-03*G3_0_1_2_11 - 8.333333333333307e-03*G3_0_2_0_8 - 8.333333333333311e-03*G3_0_2_0_9 - 1.666666666666662e-02*G3_0_2_0_10 - 8.333333333333311e-03*G3_0_2_0_11 - 8.333333333333307e-03*G3_0_2_1_8 - 8.333333333333312e-03*G3_0_2_1_9 - 1.666666666666662e-02*G3_0_2_1_10 - 8.333333333333312e-03*G3_0_2_1_11 - 8.333333333333309e-03*G3_0_2_2_8 - 8.333333333333312e-03*G3_0_2_2_9 - 1.666666666666662e-02*G3_0_2_2_10 - 8.333333333333314e-03*G3_0_2_2_11 - 8.333333333333312e-03*G3_0_3_0_8 - 8.333333333333312e-03*G3_0_3_0_9 - 8.333333333333311e-03*G3_0_3_0_10 - 1.666666666666662e-02*G3_0_3_0_11 - 8.333333333333314e-03*G3_0_3_1_8 - 8.333333333333314e-03*G3_0_3_1_9 - 8.333333333333312e-03*G3_0_3_1_10 - 1.666666666666662e-02*G3_0_3_1_11 - 8.333333333333314e-03*G3_0_3_2_8 - 8.333333333333314e-03*G3_0_3_2_9 - 8.333333333333314e-03*G3_0_3_2_10 - 1.666666666666662e-02*G3_0_3_2_11 - 1.666666666666662e-02*G3_1_4_0_8 - 8.333333333333309e-03*G3_1_4_0_9 - 8.333333333333307e-03*G3_1_4_0_10 - 8.333333333333312e-03*G3_1_4_0_11 - 1.666666666666662e-02*G3_1_4_1_8 - 8.333333333333309e-03*G3_1_4_1_9 - 8.333333333333309e-03*G3_1_4_1_10 - 8.333333333333314e-03*G3_1_4_1_11 - 1.666666666666662e-02*G3_1_4_2_8 - 8.333333333333311e-03*G3_1_4_2_9 - 8.333333333333309e-03*G3_1_4_2_10 - 8.333333333333314e-03*G3_1_4_2_11 - 8.333333333333309e-03*G3_1_5_0_8 - 1.666666666666662e-02*G3_1_5_0_9 - 8.333333333333311e-03*G3_1_5_0_10 - 8.333333333333312e-03*G3_1_5_0_11 - 8.333333333333309e-03*G3_1_5_1_8 - 1.666666666666662e-02*G3_1_5_1_9 - 8.333333333333312e-03*G3_1_5_1_10 - 8.333333333333314e-03*G3_1_5_1_11 - 8.333333333333311e-03*G3_1_5_2_8 - 1.666666666666662e-02*G3_1_5_2_9 - 8.333333333333312e-03*G3_1_5_2_10 - 8.333333333333314e-03*G3_1_5_2_11 - 8.333333333333307e-03*G3_1_6_0_8 - 8.333333333333311e-03*G3_1_6_0_9 - 1.666666666666662e-02*G3_1_6_0_10 - 8.333333333333311e-03*G3_1_6_0_11 - 8.333333333333307e-03*G3_1_6_1_8 - 8.333333333333312e-03*G3_1_6_1_9 - 1.666666666666662e-02*G3_1_6_1_10 - 8.333333333333312e-03*G3_1_6_1_11 - 8.333333333333309e-03*G3_1_6_2_8 - 8.333333333333312e-03*G3_1_6_2_9 - 1.666666666666662e-02*G3_1_6_2_10 - 8.333333333333314e-03*G3_1_6_2_11 - 8.333333333333312e-03*G3_1_7_0_8 - 8.333333333333312e-03*G3_1_7_0_9 - 8.333333333333311e-03*G3_1_7_0_10 - 1.666666666666662e-02*G3_1_7_0_11 - 8.333333333333314e-03*G3_1_7_1_8 - 8.333333333333314e-03*G3_1_7_1_9 - 8.333333333333312e-03*G3_1_7_1_10 - 1.666666666666662e-02*G3_1_7_1_11 - 8.333333333333314e-03*G3_1_7_2_8 - 8.333333333333314e-03*G3_1_7_2_9 - 8.333333333333314e-03*G3_1_7_2_10 - 1.666666666666662e-02*G3_1_7_2_11 - 1.666666666666662e-02*G3_2_8_0_8 - 8.333333333333309e-03*G3_2_8_0_9 - 8.333333333333307e-03*G3_2_8_0_10 - 8.333333333333312e-03*G3_2_8_0_11 - 1.666666666666662e-02*G3_2_8_1_8 - 8.333333333333309e-03*G3_2_8_1_9 - 8.333333333333309e-03*G3_2_8_1_10 - 8.333333333333314e-03*G3_2_8_1_11 - 1.666666666666662e-02*G3_2_8_2_8 - 8.333333333333311e-03*G3_2_8_2_9 - 8.333333333333309e-03*G3_2_8_2_10 - 8.333333333333314e-03*G3_2_8_2_11 - 8.333333333333309e-03*G3_2_9_0_8 - 1.666666666666662e-02*G3_2_9_0_9 - 8.333333333333311e-03*G3_2_9_0_10 - 8.333333333333312e-03*G3_2_9_0_11 - 8.333333333333309e-03*G3_2_9_1_8 - 1.666666666666662e-02*G3_2_9_1_9 - 8.333333333333312e-03*G3_2_9_1_10 - 8.333333333333314e-03*G3_2_9_1_11 - 8.333333333333311e-03*G3_2_9_2_8 - 1.666666666666662e-02*G3_2_9_2_9 - 8.333333333333312e-03*G3_2_9_2_10 - 8.333333333333314e-03*G3_2_9_2_11 - 8.333333333333307e-03*G3_2_10_0_8 - 8.333333333333311e-03*G3_2_10_0_9 - 1.666666666666662e-02*G3_2_10_0_10 - 8.333333333333311e-03*G3_2_10_0_11 - 8.333333333333307e-03*G3_2_10_1_8 - 8.333333333333312e-03*G3_2_10_1_9 - 1.666666666666662e-02*G3_2_10_1_10 - 8.333333333333312e-03*G3_2_10_1_11 - 8.333333333333309e-03*G3_2_10_2_8 - 8.333333333333312e-03*G3_2_10_2_9 - 1.666666666666662e-02*G3_2_10_2_10 - 8.333333333333314e-03*G3_2_10_2_11 - 8.333333333333312e-03*G3_2_11_0_8 - 8.333333333333312e-03*G3_2_11_0_9 - 8.333333333333311e-03*G3_2_11_0_10 - 1.666666666666662e-02*G3_2_11_0_11 - 8.333333333333314e-03*G3_2_11_1_8 - 8.333333333333314e-03*G3_2_11_1_9 - 8.333333333333312e-03*G3_2_11_1_10 - 1.666666666666662e-02*G3_2_11_1_11 - 8.333333333333314e-03*G3_2_11_2_8 - 8.333333333333314e-03*G3_2_11_2_9 - 8.333333333333314e-03*G3_2_11_2_10 - 1.666666666666662e-02*G3_2_11_2_11 - 8.333333333333320e-02*G4_0_8_0 - 8.333333333333322e-02*G4_0_8_1 - 8.333333333333322e-02*G4_0_8_2 + 8.333333333333320e-02*G4_0_9_0 + 8.333333333333322e-02*G4_0_10_1 + 8.333333333333322e-02*G4_0_11_2 - 8.333333333333322e-02*G4_1_8_0 - 8.333333333333323e-02*G4_1_8_1 - 8.333333333333323e-02*G4_1_8_2 + 8.333333333333322e-02*G4_1_9_0 + 8.333333333333323e-02*G4_1_10_1 + 8.333333333333323e-02*G4_1_11_2 - 8.333333333333322e-02*G4_2_8_0 - 8.333333333333323e-02*G4_2_8_1 - 8.333333333333323e-02*G4_2_8_2 + 8.333333333333322e-02*G4_2_9_0 + 8.333333333333323e-02*G4_2_10_1 + 8.333333333333323e-02*G4_2_11_2 + 8.333333333333309e-03*G5_0_0_8_0 + 8.333333333333311e-03*G5_0_0_8_1 + 8.333333333333312e-03*G5_0_0_8_2 - 8.333333333333309e-03*G5_0_0_9_0 - 8.333333333333311e-03*G5_0_0_10_1 - 8.333333333333311e-03*G5_0_0_11_2 + 4.166666666666654e-03*G5_0_1_8_0 + 4.166666666666654e-03*G5_0_1_8_1 + 4.166666666666654e-03*G5_0_1_8_2 - 4.166666666666654e-03*G5_0_1_9_0 - 4.166666666666654e-03*G5_0_1_10_1 - 4.166666666666654e-03*G5_0_1_11_2 + 4.166666666666654e-03*G5_0_2_8_0 + 4.166666666666654e-03*G5_0_2_8_1 + 4.166666666666654e-03*G5_0_2_8_2 - 4.166666666666654e-03*G5_0_2_9_0 - 4.166666666666654e-03*G5_0_2_10_1 - 4.166666666666654e-03*G5_0_2_11_2 + 4.166666666666656e-03*G5_0_3_8_0 + 4.166666666666657e-03*G5_0_3_8_1 + 4.166666666666657e-03*G5_0_3_8_2 - 4.166666666666656e-03*G5_0_3_9_0 - 4.166666666666657e-03*G5_0_3_10_1 - 4.166666666666657e-03*G5_0_3_11_2 + 8.333333333333309e-03*G5_1_4_8_0 + 8.333333333333311e-03*G5_1_4_8_1 + 8.333333333333312e-03*G5_1_4_8_2 - 8.333333333333309e-03*G5_1_4_9_0 - 8.333333333333311e-03*G5_1_4_10_1 - 8.333333333333311e-03*G5_1_4_11_2 + 4.166666666666654e-03*G5_1_5_8_0 + 4.166666666666654e-03*G5_1_5_8_1 + 4.166666666666655e-03*G5_1_5_8_2 - 4.166666666666654e-03*G5_1_5_9_0 - 4.166666666666654e-03*G5_1_5_10_1 - 4.166666666666654e-03*G5_1_5_11_2 + 4.166666666666654e-03*G5_1_6_8_0 + 4.166666666666654e-03*G5_1_6_8_1 + 4.166666666666654e-03*G5_1_6_8_2 - 4.166666666666654e-03*G5_1_6_9_0 - 4.166666666666654e-03*G5_1_6_10_1 - 4.166666666666654e-03*G5_1_6_11_2 + 4.166666666666656e-03*G5_1_7_8_0 + 4.166666666666657e-03*G5_1_7_8_1 + 4.166666666666657e-03*G5_1_7_8_2 - 4.166666666666656e-03*G5_1_7_9_0 - 4.166666666666657e-03*G5_1_7_10_1 - 4.166666666666657e-03*G5_1_7_11_2 + 8.333333333333309e-03*G5_2_8_8_0 + 8.333333333333311e-03*G5_2_8_8_1 + 8.333333333333312e-03*G5_2_8_8_2 - 8.333333333333309e-03*G5_2_8_9_0 - 8.333333333333311e-03*G5_2_8_10_1 - 8.333333333333311e-03*G5_2_8_11_2 + 4.166666666666654e-03*G5_2_9_8_0 + 4.166666666666654e-03*G5_2_9_8_1 + 4.166666666666655e-03*G5_2_9_8_2 - 4.166666666666654e-03*G5_2_9_9_0 - 4.166666666666654e-03*G5_2_9_10_1 - 4.166666666666654e-03*G5_2_9_11_2 + 4.166666666666654e-03*G5_2_10_8_0 + 4.166666666666654e-03*G5_2_10_8_1 + 4.166666666666654e-03*G5_2_10_8_2 - 4.166666666666654e-03*G5_2_10_9_0 - 4.166666666666654e-03*G5_2_10_10_1 - 4.166666666666654e-03*G5_2_10_11_2 + 4.166666666666656e-03*G5_2_11_8_0 + 4.166666666666657e-03*G5_2_11_8_1 + 4.166666666666657e-03*G5_2_11_8_2 - 4.166666666666656e-03*G5_2_11_9_0 - 4.166666666666657e-03*G5_2_11_10_1 - 4.166666666666657e-03*G5_2_11_11_2 - 8.333333333333309e-03*G6_0_0_0_0_0_8_0 - 8.333333333333309e-03*G6_0_0_0_0_0_8_1 - 8.333333333333312e-03*G6_0_0_0_0_0_8_2 + 8.333333333333309e-03*G6_0_0_0_0_0_9_0 + 8.333333333333309e-03*G6_0_0_0_0_0_10_1 + 8.333333333333309e-03*G6_0_0_0_0_0_11_2 - 4.166666666666654e-03*G6_0_0_0_0_1_8_0 - 4.166666666666654e-03*G6_0_0_0_0_1_8_1 - 4.166666666666655e-03*G6_0_0_0_0_1_8_2 + 4.166666666666654e-03*G6_0_0_0_0_1_9_0 + 4.166666666666654e-03*G6_0_0_0_0_1_10_1 + 4.166666666666654e-03*G6_0_0_0_0_1_11_2 - 4.166666666666654e-03*G6_0_0_0_0_2_8_0 - 4.166666666666654e-03*G6_0_0_0_0_2_8_1 - 4.166666666666656e-03*G6_0_0_0_0_2_8_2 + 4.166666666666654e-03*G6_0_0_0_0_2_9_0 + 4.166666666666654e-03*G6_0_0_0_0_2_10_1 + 4.166666666666654e-03*G6_0_0_0_0_2_11_2 - 4.166666666666656e-03*G6_0_0_0_0_3_8_0 - 4.166666666666656e-03*G6_0_0_0_0_3_8_1 - 4.166666666666657e-03*G6_0_0_0_0_3_8_2 + 4.166666666666656e-03*G6_0_0_0_0_3_9_0 + 4.166666666666656e-03*G6_0_0_0_0_3_10_1 + 4.166666666666656e-03*G6_0_0_0_0_3_11_2 - 8.333333333333309e-03*G6_0_0_0_1_0_8_0 - 8.333333333333311e-03*G6_0_0_0_1_0_8_1 - 8.333333333333312e-03*G6_0_0_0_1_0_8_2 + 8.333333333333309e-03*G6_0_0_0_1_0_9_0 + 8.333333333333311e-03*G6_0_0_0_1_0_10_1 + 8.333333333333311e-03*G6_0_0_0_1_0_11_2 - 4.166666666666654e-03*G6_0_0_0_1_1_8_0 - 4.166666666666655e-03*G6_0_0_0_1_1_8_1 - 4.166666666666655e-03*G6_0_0_0_1_1_8_2 + 4.166666666666654e-03*G6_0_0_0_1_1_9_0 + 4.166666666666655e-03*G6_0_0_0_1_1_10_1 + 4.166666666666655e-03*G6_0_0_0_1_1_11_2 - 4.166666666666654e-03*G6_0_0_0_1_2_8_0 - 4.166666666666656e-03*G6_0_0_0_1_2_8_1 - 4.166666666666656e-03*G6_0_0_0_1_2_8_2 + 4.166666666666654e-03*G6_0_0_0_1_2_9_0 + 4.166666666666656e-03*G6_0_0_0_1_2_10_1 + 4.166666666666656e-03*G6_0_0_0_1_2_11_2 - 4.166666666666656e-03*G6_0_0_0_1_3_8_0 - 4.166666666666657e-03*G6_0_0_0_1_3_8_1 - 4.166666666666658e-03*G6_0_0_0_1_3_8_2 + 4.166666666666656e-03*G6_0_0_0_1_3_9_0 + 4.166666666666657e-03*G6_0_0_0_1_3_10_1 + 4.166666666666657e-03*G6_0_0_0_1_3_11_2 - 8.333333333333311e-03*G6_0_0_0_2_0_8_0 - 8.333333333333312e-03*G6_0_0_0_2_0_8_1 - 8.333333333333314e-03*G6_0_0_0_2_0_8_2 + 8.333333333333311e-03*G6_0_0_0_2_0_9_0 + 8.333333333333312e-03*G6_0_0_0_2_0_10_1 + 8.333333333333312e-03*G6_0_0_0_2_0_11_2 - 4.166666666666654e-03*G6_0_0_0_2_1_8_0 - 4.166666666666655e-03*G6_0_0_0_2_1_8_1 - 4.166666666666656e-03*G6_0_0_0_2_1_8_2 + 4.166666666666654e-03*G6_0_0_0_2_1_9_0 + 4.166666666666655e-03*G6_0_0_0_2_1_10_1 + 4.166666666666655e-03*G6_0_0_0_2_1_11_2 - 4.166666666666655e-03*G6_0_0_0_2_2_8_0 - 4.166666666666656e-03*G6_0_0_0_2_2_8_1 - 4.166666666666656e-03*G6_0_0_0_2_2_8_2 + 4.166666666666655e-03*G6_0_0_0_2_2_9_0 + 4.166666666666656e-03*G6_0_0_0_2_2_10_1 + 4.166666666666656e-03*G6_0_0_0_2_2_11_2 - 4.166666666666657e-03*G6_0_0_0_2_3_8_0 - 4.166666666666658e-03*G6_0_0_0_2_3_8_1 - 4.166666666666659e-03*G6_0_0_0_2_3_8_2 + 4.166666666666657e-03*G6_0_0_0_2_3_9_0 + 4.166666666666658e-03*G6_0_0_0_2_3_10_1 + 4.166666666666658e-03*G6_0_0_0_2_3_11_2 - 4.166666666666654e-03*G6_0_0_1_0_0_8_0 - 4.166666666666654e-03*G6_0_0_1_0_0_8_1 - 4.166666666666655e-03*G6_0_0_1_0_0_8_2 + 4.166666666666654e-03*G6_0_0_1_0_0_9_0 + 4.166666666666654e-03*G6_0_0_1_0_0_10_1 + 4.166666666666654e-03*G6_0_0_1_0_0_11_2 - 8.333333333333307e-03*G6_0_0_1_0_1_8_0 - 8.333333333333307e-03*G6_0_0_1_0_1_8_1 - 8.333333333333307e-03*G6_0_0_1_0_1_8_2 + 8.333333333333307e-03*G6_0_0_1_0_1_9_0 + 8.333333333333307e-03*G6_0_0_1_0_1_10_1 + 8.333333333333307e-03*G6_0_0_1_0_1_11_2 - 4.166666666666654e-03*G6_0_0_1_0_2_8_0 - 4.166666666666654e-03*G6_0_0_1_0_2_8_1 - 4.166666666666654e-03*G6_0_0_1_0_2_8_2 + 4.166666666666654e-03*G6_0_0_1_0_2_9_0 + 4.166666666666654e-03*G6_0_0_1_0_2_10_1 + 4.166666666666654e-03*G6_0_0_1_0_2_11_2 - 4.166666666666654e-03*G6_0_0_1_0_3_8_0 - 4.166666666666655e-03*G6_0_0_1_0_3_8_1 - 4.166666666666655e-03*G6_0_0_1_0_3_8_2 + 4.166666666666654e-03*G6_0_0_1_0_3_9_0 + 4.166666666666655e-03*G6_0_0_1_0_3_10_1 + 4.166666666666655e-03*G6_0_0_1_0_3_11_2 - 4.166666666666654e-03*G6_0_0_1_1_0_8_0 - 4.166666666666655e-03*G6_0_0_1_1_0_8_1 - 4.166666666666655e-03*G6_0_0_1_1_0_8_2 + 4.166666666666654e-03*G6_0_0_1_1_0_9_0 + 4.166666666666655e-03*G6_0_0_1_1_0_10_1 + 4.166666666666655e-03*G6_0_0_1_1_0_11_2 - 8.333333333333307e-03*G6_0_0_1_1_1_8_0 - 8.333333333333309e-03*G6_0_0_1_1_1_8_1 - 8.333333333333309e-03*G6_0_0_1_1_1_8_2 + 8.333333333333307e-03*G6_0_0_1_1_1_9_0 + 8.333333333333309e-03*G6_0_0_1_1_1_10_1 + 8.333333333333309e-03*G6_0_0_1_1_1_11_2 - 4.166666666666654e-03*G6_0_0_1_1_2_8_0 - 4.166666666666654e-03*G6_0_0_1_1_2_8_1 - 4.166666666666655e-03*G6_0_0_1_1_2_8_2 + 4.166666666666654e-03*G6_0_0_1_1_2_9_0 + 4.166666666666654e-03*G6_0_0_1_1_2_10_1 + 4.166666666666654e-03*G6_0_0_1_1_2_11_2 - 4.166666666666655e-03*G6_0_0_1_1_3_8_0 - 4.166666666666655e-03*G6_0_0_1_1_3_8_1 - 4.166666666666656e-03*G6_0_0_1_1_3_8_2 + 4.166666666666655e-03*G6_0_0_1_1_3_9_0 + 4.166666666666655e-03*G6_0_0_1_1_3_10_1 + 4.166666666666655e-03*G6_0_0_1_1_3_11_2 - 4.166666666666654e-03*G6_0_0_1_2_0_8_0 - 4.166666666666655e-03*G6_0_0_1_2_0_8_1 - 4.166666666666656e-03*G6_0_0_1_2_0_8_2 + 4.166666666666654e-03*G6_0_0_1_2_0_9_0 + 4.166666666666655e-03*G6_0_0_1_2_0_10_1 + 4.166666666666655e-03*G6_0_0_1_2_0_11_2 - 8.333333333333307e-03*G6_0_0_1_2_1_8_0 - 8.333333333333309e-03*G6_0_0_1_2_1_8_1 - 8.333333333333309e-03*G6_0_0_1_2_1_8_2 + 8.333333333333307e-03*G6_0_0_1_2_1_9_0 + 8.333333333333309e-03*G6_0_0_1_2_1_10_1 + 8.333333333333309e-03*G6_0_0_1_2_1_11_2 - 4.166666666666654e-03*G6_0_0_1_2_2_8_0 - 4.166666666666655e-03*G6_0_0_1_2_2_8_1 - 4.166666666666655e-03*G6_0_0_1_2_2_8_2 + 4.166666666666654e-03*G6_0_0_1_2_2_9_0 + 4.166666666666655e-03*G6_0_0_1_2_2_10_1 + 4.166666666666655e-03*G6_0_0_1_2_2_11_2 - 4.166666666666655e-03*G6_0_0_1_2_3_8_0 - 4.166666666666656e-03*G6_0_0_1_2_3_8_1 - 4.166666666666656e-03*G6_0_0_1_2_3_8_2 + 4.166666666666655e-03*G6_0_0_1_2_3_9_0 + 4.166666666666656e-03*G6_0_0_1_2_3_10_1 + 4.166666666666656e-03*G6_0_0_1_2_3_11_2 - 4.166666666666654e-03*G6_0_0_2_0_0_8_0 - 4.166666666666654e-03*G6_0_0_2_0_0_8_1 - 4.166666666666655e-03*G6_0_0_2_0_0_8_2 + 4.166666666666654e-03*G6_0_0_2_0_0_9_0 + 4.166666666666654e-03*G6_0_0_2_0_0_10_1 + 4.166666666666654e-03*G6_0_0_2_0_0_11_2 - 4.166666666666654e-03*G6_0_0_2_0_1_8_0 - 4.166666666666654e-03*G6_0_0_2_0_1_8_1 - 4.166666666666654e-03*G6_0_0_2_0_1_8_2 + 4.166666666666654e-03*G6_0_0_2_0_1_9_0 + 4.166666666666654e-03*G6_0_0_2_0_1_10_1 + 4.166666666666654e-03*G6_0_0_2_0_1_11_2 - 8.333333333333309e-03*G6_0_0_2_0_2_8_0 - 8.333333333333309e-03*G6_0_0_2_0_2_8_1 - 8.333333333333311e-03*G6_0_0_2_0_2_8_2 + 8.333333333333309e-03*G6_0_0_2_0_2_9_0 + 8.333333333333309e-03*G6_0_0_2_0_2_10_1 + 8.333333333333309e-03*G6_0_0_2_0_2_11_2 - 4.166666666666654e-03*G6_0_0_2_0_3_8_0 - 4.166666666666655e-03*G6_0_0_2_0_3_8_1 - 4.166666666666655e-03*G6_0_0_2_0_3_8_2 + 4.166666666666654e-03*G6_0_0_2_0_3_9_0 + 4.166666666666655e-03*G6_0_0_2_0_3_10_1 + 4.166666666666655e-03*G6_0_0_2_0_3_11_2 - 4.166666666666654e-03*G6_0_0_2_1_0_8_0 - 4.166666666666656e-03*G6_0_0_2_1_0_8_1 - 4.166666666666656e-03*G6_0_0_2_1_0_8_2 + 4.166666666666654e-03*G6_0_0_2_1_0_9_0 + 4.166666666666656e-03*G6_0_0_2_1_0_10_1 + 4.166666666666656e-03*G6_0_0_2_1_0_11_2 - 4.166666666666654e-03*G6_0_0_2_1_1_8_0 - 4.166666666666654e-03*G6_0_0_2_1_1_8_1 - 4.166666666666654e-03*G6_0_0_2_1_1_8_2 + 4.166666666666654e-03*G6_0_0_2_1_1_9_0 + 4.166666666666654e-03*G6_0_0_2_1_1_10_1 + 4.166666666666654e-03*G6_0_0_2_1_1_11_2 - 8.333333333333311e-03*G6_0_0_2_1_2_8_0 - 8.333333333333311e-03*G6_0_0_2_1_2_8_1 - 8.333333333333312e-03*G6_0_0_2_1_2_8_2 + 8.333333333333311e-03*G6_0_0_2_1_2_9_0 + 8.333333333333311e-03*G6_0_0_2_1_2_10_1 + 8.333333333333311e-03*G6_0_0_2_1_2_11_2 - 4.166666666666655e-03*G6_0_0_2_1_3_8_0 - 4.166666666666656e-03*G6_0_0_2_1_3_8_1 - 4.166666666666657e-03*G6_0_0_2_1_3_8_2 + 4.166666666666655e-03*G6_0_0_2_1_3_9_0 + 4.166666666666656e-03*G6_0_0_2_1_3_10_1 + 4.166666666666656e-03*G6_0_0_2_1_3_11_2 - 4.166666666666655e-03*G6_0_0_2_2_0_8_0 - 4.166666666666656e-03*G6_0_0_2_2_0_8_1 - 4.166666666666656e-03*G6_0_0_2_2_0_8_2 + 4.166666666666655e-03*G6_0_0_2_2_0_9_0 + 4.166666666666656e-03*G6_0_0_2_2_0_10_1 + 4.166666666666656e-03*G6_0_0_2_2_0_11_2 - 4.166666666666654e-03*G6_0_0_2_2_1_8_0 - 4.166666666666654e-03*G6_0_0_2_2_1_8_1 - 4.166666666666655e-03*G6_0_0_2_2_1_8_2 + 4.166666666666654e-03*G6_0_0_2_2_1_9_0 + 4.166666666666654e-03*G6_0_0_2_2_1_10_1 + 4.166666666666654e-03*G6_0_0_2_2_1_11_2 - 8.333333333333311e-03*G6_0_0_2_2_2_8_0 - 8.333333333333312e-03*G6_0_0_2_2_2_8_1 - 8.333333333333312e-03*G6_0_0_2_2_2_8_2 + 8.333333333333311e-03*G6_0_0_2_2_2_9_0 + 8.333333333333312e-03*G6_0_0_2_2_2_10_1 + 8.333333333333312e-03*G6_0_0_2_2_2_11_2 - 4.166666666666655e-03*G6_0_0_2_2_3_8_0 - 4.166666666666657e-03*G6_0_0_2_2_3_8_1 - 4.166666666666657e-03*G6_0_0_2_2_3_8_2 + 4.166666666666655e-03*G6_0_0_2_2_3_9_0 + 4.166666666666657e-03*G6_0_0_2_2_3_10_1 + 4.166666666666657e-03*G6_0_0_2_2_3_11_2 - 4.166666666666656e-03*G6_0_0_3_0_0_8_0 - 4.166666666666656e-03*G6_0_0_3_0_0_8_1 - 4.166666666666657e-03*G6_0_0_3_0_0_8_2 + 4.166666666666656e-03*G6_0_0_3_0_0_9_0 + 4.166666666666656e-03*G6_0_0_3_0_0_10_1 + 4.166666666666656e-03*G6_0_0_3_0_0_11_2 - 4.166666666666654e-03*G6_0_0_3_0_1_8_0 - 4.166666666666655e-03*G6_0_0_3_0_1_8_1 - 4.166666666666655e-03*G6_0_0_3_0_1_8_2 + 4.166666666666654e-03*G6_0_0_3_0_1_9_0 + 4.166666666666655e-03*G6_0_0_3_0_1_10_1 + 4.166666666666655e-03*G6_0_0_3_0_1_11_2 - 4.166666666666655e-03*G6_0_0_3_0_2_8_0 - 4.166666666666655e-03*G6_0_0_3_0_2_8_1 - 4.166666666666655e-03*G6_0_0_3_0_2_8_2 + 4.166666666666655e-03*G6_0_0_3_0_2_9_0 + 4.166666666666655e-03*G6_0_0_3_0_2_10_1 + 4.166666666666655e-03*G6_0_0_3_0_2_11_2 - 8.333333333333309e-03*G6_0_0_3_0_3_8_0 - 8.333333333333311e-03*G6_0_0_3_0_3_8_1 - 8.333333333333311e-03*G6_0_0_3_0_3_8_2 + 8.333333333333309e-03*G6_0_0_3_0_3_9_0 + 8.333333333333311e-03*G6_0_0_3_0_3_10_1 + 8.333333333333311e-03*G6_0_0_3_0_3_11_2 - 4.166666666666656e-03*G6_0_0_3_1_0_8_0 - 4.166666666666657e-03*G6_0_0_3_1_0_8_1 - 4.166666666666658e-03*G6_0_0_3_1_0_8_2 + 4.166666666666656e-03*G6_0_0_3_1_0_9_0 + 4.166666666666657e-03*G6_0_0_3_1_0_10_1 + 4.166666666666657e-03*G6_0_0_3_1_0_11_2 - 4.166666666666655e-03*G6_0_0_3_1_1_8_0 - 4.166666666666655e-03*G6_0_0_3_1_1_8_1 - 4.166666666666656e-03*G6_0_0_3_1_1_8_2 + 4.166666666666655e-03*G6_0_0_3_1_1_9_0 + 4.166666666666655e-03*G6_0_0_3_1_1_10_1 + 4.166666666666655e-03*G6_0_0_3_1_1_11_2 - 4.166666666666655e-03*G6_0_0_3_1_2_8_0 - 4.166666666666656e-03*G6_0_0_3_1_2_8_1 - 4.166666666666657e-03*G6_0_0_3_1_2_8_2 + 4.166666666666655e-03*G6_0_0_3_1_2_9_0 + 4.166666666666656e-03*G6_0_0_3_1_2_10_1 + 4.166666666666656e-03*G6_0_0_3_1_2_11_2 - 8.333333333333311e-03*G6_0_0_3_1_3_8_0 - 8.333333333333311e-03*G6_0_0_3_1_3_8_1 - 8.333333333333312e-03*G6_0_0_3_1_3_8_2 + 8.333333333333311e-03*G6_0_0_3_1_3_9_0 + 8.333333333333311e-03*G6_0_0_3_1_3_10_1 + 8.333333333333311e-03*G6_0_0_3_1_3_11_2 - 4.166666666666657e-03*G6_0_0_3_2_0_8_0 - 4.166666666666658e-03*G6_0_0_3_2_0_8_1 - 4.166666666666659e-03*G6_0_0_3_2_0_8_2 + 4.166666666666657e-03*G6_0_0_3_2_0_9_0 + 4.166666666666658e-03*G6_0_0_3_2_0_10_1 + 4.166666666666658e-03*G6_0_0_3_2_0_11_2 - 4.166666666666655e-03*G6_0_0_3_2_1_8_0 - 4.166666666666656e-03*G6_0_0_3_2_1_8_1 - 4.166666666666656e-03*G6_0_0_3_2_1_8_2 + 4.166666666666655e-03*G6_0_0_3_2_1_9_0 + 4.166666666666656e-03*G6_0_0_3_2_1_10_1 + 4.166666666666656e-03*G6_0_0_3_2_1_11_2 - 4.166666666666655e-03*G6_0_0_3_2_2_8_0 - 4.166666666666657e-03*G6_0_0_3_2_2_8_1 - 4.166666666666657e-03*G6_0_0_3_2_2_8_2 + 4.166666666666655e-03*G6_0_0_3_2_2_9_0 + 4.166666666666657e-03*G6_0_0_3_2_2_10_1 + 4.166666666666657e-03*G6_0_0_3_2_2_11_2 - 8.333333333333311e-03*G6_0_0_3_2_3_8_0 - 8.333333333333312e-03*G6_0_0_3_2_3_8_1 - 8.333333333333312e-03*G6_0_0_3_2_3_8_2 + 8.333333333333311e-03*G6_0_0_3_2_3_9_0 + 8.333333333333312e-03*G6_0_0_3_2_3_10_1 + 8.333333333333312e-03*G6_0_0_3_2_3_11_2 - 8.333333333333309e-03*G6_0_1_0_0_4_8_0 - 8.333333333333309e-03*G6_0_1_0_0_4_8_1 - 8.333333333333311e-03*G6_0_1_0_0_4_8_2 + 8.333333333333309e-03*G6_0_1_0_0_4_9_0 + 8.333333333333309e-03*G6_0_1_0_0_4_10_1 + 8.333333333333309e-03*G6_0_1_0_0_4_11_2 - 4.166666666666654e-03*G6_0_1_0_0_5_8_0 - 4.166666666666655e-03*G6_0_1_0_0_5_8_1 - 4.166666666666655e-03*G6_0_1_0_0_5_8_2 + 4.166666666666654e-03*G6_0_1_0_0_5_9_0 + 4.166666666666655e-03*G6_0_1_0_0_5_10_1 + 4.166666666666655e-03*G6_0_1_0_0_5_11_2 - 4.166666666666654e-03*G6_0_1_0_0_6_8_0 - 4.166666666666654e-03*G6_0_1_0_0_6_8_1 - 4.166666666666656e-03*G6_0_1_0_0_6_8_2 + 4.166666666666654e-03*G6_0_1_0_0_6_9_0 + 4.166666666666654e-03*G6_0_1_0_0_6_10_1 + 4.166666666666654e-03*G6_0_1_0_0_6_11_2 - 4.166666666666656e-03*G6_0_1_0_0_7_8_0 - 4.166666666666656e-03*G6_0_1_0_0_7_8_1 - 4.166666666666657e-03*G6_0_1_0_0_7_8_2 + 4.166666666666656e-03*G6_0_1_0_0_7_9_0 + 4.166666666666656e-03*G6_0_1_0_0_7_10_1 + 4.166666666666656e-03*G6_0_1_0_0_7_11_2 - 8.333333333333309e-03*G6_0_1_0_1_4_8_0 - 8.333333333333311e-03*G6_0_1_0_1_4_8_1 - 8.333333333333312e-03*G6_0_1_0_1_4_8_2 + 8.333333333333309e-03*G6_0_1_0_1_4_9_0 + 8.333333333333311e-03*G6_0_1_0_1_4_10_1 + 8.333333333333311e-03*G6_0_1_0_1_4_11_2 - 4.166666666666655e-03*G6_0_1_0_1_5_8_0 - 4.166666666666655e-03*G6_0_1_0_1_5_8_1 - 4.166666666666656e-03*G6_0_1_0_1_5_8_2 + 4.166666666666655e-03*G6_0_1_0_1_5_9_0 + 4.166666666666655e-03*G6_0_1_0_1_5_10_1 + 4.166666666666655e-03*G6_0_1_0_1_5_11_2 - 4.166666666666654e-03*G6_0_1_0_1_6_8_0 - 4.166666666666656e-03*G6_0_1_0_1_6_8_1 - 4.166666666666656e-03*G6_0_1_0_1_6_8_2 + 4.166666666666654e-03*G6_0_1_0_1_6_9_0 + 4.166666666666656e-03*G6_0_1_0_1_6_10_1 + 4.166666666666656e-03*G6_0_1_0_1_6_11_2 - 4.166666666666656e-03*G6_0_1_0_1_7_8_0 - 4.166666666666657e-03*G6_0_1_0_1_7_8_1 - 4.166666666666658e-03*G6_0_1_0_1_7_8_2 + 4.166666666666656e-03*G6_0_1_0_1_7_9_0 + 4.166666666666657e-03*G6_0_1_0_1_7_10_1 + 4.166666666666657e-03*G6_0_1_0_1_7_11_2 - 8.333333333333311e-03*G6_0_1_0_2_4_8_0 - 8.333333333333312e-03*G6_0_1_0_2_4_8_1 - 8.333333333333314e-03*G6_0_1_0_2_4_8_2 + 8.333333333333311e-03*G6_0_1_0_2_4_9_0 + 8.333333333333312e-03*G6_0_1_0_2_4_10_1 + 8.333333333333312e-03*G6_0_1_0_2_4_11_2 - 4.166666666666655e-03*G6_0_1_0_2_5_8_0 - 4.166666666666656e-03*G6_0_1_0_2_5_8_1 - 4.166666666666657e-03*G6_0_1_0_2_5_8_2 + 4.166666666666655e-03*G6_0_1_0_2_5_9_0 + 4.166666666666656e-03*G6_0_1_0_2_5_10_1 + 4.166666666666656e-03*G6_0_1_0_2_5_11_2 - 4.166666666666655e-03*G6_0_1_0_2_6_8_0 - 4.166666666666656e-03*G6_0_1_0_2_6_8_1 - 4.166666666666656e-03*G6_0_1_0_2_6_8_2 + 4.166666666666655e-03*G6_0_1_0_2_6_9_0 + 4.166666666666656e-03*G6_0_1_0_2_6_10_1 + 4.166666666666656e-03*G6_0_1_0_2_6_11_2 - 4.166666666666657e-03*G6_0_1_0_2_7_8_0 - 4.166666666666658e-03*G6_0_1_0_2_7_8_1 - 4.166666666666659e-03*G6_0_1_0_2_7_8_2 + 4.166666666666657e-03*G6_0_1_0_2_7_9_0 + 4.166666666666658e-03*G6_0_1_0_2_7_10_1 + 4.166666666666658e-03*G6_0_1_0_2_7_11_2 - 4.166666666666654e-03*G6_0_1_1_0_4_8_0 - 4.166666666666654e-03*G6_0_1_1_0_4_8_1 - 4.166666666666654e-03*G6_0_1_1_0_4_8_2 + 4.166666666666654e-03*G6_0_1_1_0_4_9_0 + 4.166666666666654e-03*G6_0_1_1_0_4_10_1 + 4.166666666666654e-03*G6_0_1_1_0_4_11_2 - 8.333333333333307e-03*G6_0_1_1_0_5_8_0 - 8.333333333333309e-03*G6_0_1_1_0_5_8_1 - 8.333333333333309e-03*G6_0_1_1_0_5_8_2 + 8.333333333333307e-03*G6_0_1_1_0_5_9_0 + 8.333333333333309e-03*G6_0_1_1_0_5_10_1 + 8.333333333333309e-03*G6_0_1_1_0_5_11_2 - 4.166666666666654e-03*G6_0_1_1_0_6_8_0 - 4.166666666666654e-03*G6_0_1_1_0_6_8_1 - 4.166666666666654e-03*G6_0_1_1_0_6_8_2 + 4.166666666666654e-03*G6_0_1_1_0_6_9_0 + 4.166666666666654e-03*G6_0_1_1_0_6_10_1 + 4.166666666666654e-03*G6_0_1_1_0_6_11_2 - 4.166666666666654e-03*G6_0_1_1_0_7_8_0 - 4.166666666666655e-03*G6_0_1_1_0_7_8_1 - 4.166666666666655e-03*G6_0_1_1_0_7_8_2 + 4.166666666666654e-03*G6_0_1_1_0_7_9_0 + 4.166666666666655e-03*G6_0_1_1_0_7_10_1 + 4.166666666666655e-03*G6_0_1_1_0_7_11_2 - 4.166666666666654e-03*G6_0_1_1_1_4_8_0 - 4.166666666666654e-03*G6_0_1_1_1_4_8_1 - 4.166666666666654e-03*G6_0_1_1_1_4_8_2 + 4.166666666666654e-03*G6_0_1_1_1_4_9_0 + 4.166666666666654e-03*G6_0_1_1_1_4_10_1 + 4.166666666666654e-03*G6_0_1_1_1_4_11_2 - 8.333333333333309e-03*G6_0_1_1_1_5_8_0 - 8.333333333333309e-03*G6_0_1_1_1_5_8_1 - 8.333333333333309e-03*G6_0_1_1_1_5_8_2 + 8.333333333333309e-03*G6_0_1_1_1_5_9_0 + 8.333333333333309e-03*G6_0_1_1_1_5_10_1 + 8.333333333333309e-03*G6_0_1_1_1_5_11_2 - 4.166666666666654e-03*G6_0_1_1_1_6_8_0 - 4.166666666666654e-03*G6_0_1_1_1_6_8_1 - 4.166666666666655e-03*G6_0_1_1_1_6_8_2 + 4.166666666666654e-03*G6_0_1_1_1_6_9_0 + 4.166666666666654e-03*G6_0_1_1_1_6_10_1 + 4.166666666666654e-03*G6_0_1_1_1_6_11_2 - 4.166666666666655e-03*G6_0_1_1_1_7_8_0 - 4.166666666666655e-03*G6_0_1_1_1_7_8_1 - 4.166666666666656e-03*G6_0_1_1_1_7_8_2 + 4.166666666666655e-03*G6_0_1_1_1_7_9_0 + 4.166666666666655e-03*G6_0_1_1_1_7_10_1 + 4.166666666666655e-03*G6_0_1_1_1_7_11_2 - 4.166666666666654e-03*G6_0_1_1_2_4_8_0 - 4.166666666666654e-03*G6_0_1_1_2_4_8_1 - 4.166666666666655e-03*G6_0_1_1_2_4_8_2 + 4.166666666666654e-03*G6_0_1_1_2_4_9_0 + 4.166666666666654e-03*G6_0_1_1_2_4_10_1 + 4.166666666666654e-03*G6_0_1_1_2_4_11_2 - 8.333333333333309e-03*G6_0_1_1_2_5_8_0 - 8.333333333333309e-03*G6_0_1_1_2_5_8_1 - 8.333333333333309e-03*G6_0_1_1_2_5_8_2 + 8.333333333333309e-03*G6_0_1_1_2_5_9_0 + 8.333333333333309e-03*G6_0_1_1_2_5_10_1 + 8.333333333333309e-03*G6_0_1_1_2_5_11_2 - 4.166666666666654e-03*G6_0_1_1_2_6_8_0 - 4.166666666666655e-03*G6_0_1_1_2_6_8_1 - 4.166666666666655e-03*G6_0_1_1_2_6_8_2 + 4.166666666666654e-03*G6_0_1_1_2_6_9_0 + 4.166666666666655e-03*G6_0_1_1_2_6_10_1 + 4.166666666666655e-03*G6_0_1_1_2_6_11_2 - 4.166666666666655e-03*G6_0_1_1_2_7_8_0 - 4.166666666666656e-03*G6_0_1_1_2_7_8_1 - 4.166666666666656e-03*G6_0_1_1_2_7_8_2 + 4.166666666666655e-03*G6_0_1_1_2_7_9_0 + 4.166666666666656e-03*G6_0_1_1_2_7_10_1 + 4.166666666666656e-03*G6_0_1_1_2_7_11_2 - 4.166666666666653e-03*G6_0_1_2_0_4_8_0 - 4.166666666666654e-03*G6_0_1_2_0_4_8_1 - 4.166666666666654e-03*G6_0_1_2_0_4_8_2 + 4.166666666666653e-03*G6_0_1_2_0_4_9_0 + 4.166666666666654e-03*G6_0_1_2_0_4_10_1 + 4.166666666666654e-03*G6_0_1_2_0_4_11_2 - 4.166666666666654e-03*G6_0_1_2_0_5_8_0 - 4.166666666666655e-03*G6_0_1_2_0_5_8_1 - 4.166666666666655e-03*G6_0_1_2_0_5_8_2 + 4.166666666666654e-03*G6_0_1_2_0_5_9_0 + 4.166666666666655e-03*G6_0_1_2_0_5_10_1 + 4.166666666666655e-03*G6_0_1_2_0_5_11_2 - 8.333333333333309e-03*G6_0_1_2_0_6_8_0 - 8.333333333333309e-03*G6_0_1_2_0_6_8_1 - 8.333333333333311e-03*G6_0_1_2_0_6_8_2 + 8.333333333333309e-03*G6_0_1_2_0_6_9_0 + 8.333333333333309e-03*G6_0_1_2_0_6_10_1 + 8.333333333333309e-03*G6_0_1_2_0_6_11_2 - 4.166666666666654e-03*G6_0_1_2_0_7_8_0 - 4.166666666666655e-03*G6_0_1_2_0_7_8_1 - 4.166666666666655e-03*G6_0_1_2_0_7_8_2 + 4.166666666666654e-03*G6_0_1_2_0_7_9_0 + 4.166666666666655e-03*G6_0_1_2_0_7_10_1 + 4.166666666666655e-03*G6_0_1_2_0_7_11_2 - 4.166666666666654e-03*G6_0_1_2_1_4_8_0 - 4.166666666666654e-03*G6_0_1_2_1_4_8_1 - 4.166666666666654e-03*G6_0_1_2_1_4_8_2 + 4.166666666666654e-03*G6_0_1_2_1_4_9_0 + 4.166666666666654e-03*G6_0_1_2_1_4_10_1 + 4.166666666666654e-03*G6_0_1_2_1_4_11_2 - 4.166666666666655e-03*G6_0_1_2_1_5_8_0 - 4.166666666666656e-03*G6_0_1_2_1_5_8_1 - 4.166666666666656e-03*G6_0_1_2_1_5_8_2 + 4.166666666666655e-03*G6_0_1_2_1_5_9_0 + 4.166666666666656e-03*G6_0_1_2_1_5_10_1 + 4.166666666666656e-03*G6_0_1_2_1_5_11_2 - 8.333333333333311e-03*G6_0_1_2_1_6_8_0 - 8.333333333333311e-03*G6_0_1_2_1_6_8_1 - 8.333333333333312e-03*G6_0_1_2_1_6_8_2 + 8.333333333333311e-03*G6_0_1_2_1_6_9_0 + 8.333333333333311e-03*G6_0_1_2_1_6_10_1 + 8.333333333333311e-03*G6_0_1_2_1_6_11_2 - 4.166666666666655e-03*G6_0_1_2_1_7_8_0 - 4.166666666666656e-03*G6_0_1_2_1_7_8_1 - 4.166666666666657e-03*G6_0_1_2_1_7_8_2 + 4.166666666666655e-03*G6_0_1_2_1_7_9_0 + 4.166666666666656e-03*G6_0_1_2_1_7_10_1 + 4.166666666666656e-03*G6_0_1_2_1_7_11_2 - 4.166666666666654e-03*G6_0_1_2_2_4_8_0 - 4.166666666666654e-03*G6_0_1_2_2_4_8_1 - 4.166666666666654e-03*G6_0_1_2_2_4_8_2 + 4.166666666666654e-03*G6_0_1_2_2_4_9_0 + 4.166666666666654e-03*G6_0_1_2_2_4_10_1 + 4.166666666666654e-03*G6_0_1_2_2_4_11_2 - 4.166666666666655e-03*G6_0_1_2_2_5_8_0 - 4.166666666666656e-03*G6_0_1_2_2_5_8_1 - 4.166666666666656e-03*G6_0_1_2_2_5_8_2 + 4.166666666666655e-03*G6_0_1_2_2_5_9_0 + 4.166666666666656e-03*G6_0_1_2_2_5_10_1 + 4.166666666666656e-03*G6_0_1_2_2_5_11_2 - 8.333333333333311e-03*G6_0_1_2_2_6_8_0 - 8.333333333333312e-03*G6_0_1_2_2_6_8_1 - 8.333333333333312e-03*G6_0_1_2_2_6_8_2 + 8.333333333333311e-03*G6_0_1_2_2_6_9_0 + 8.333333333333312e-03*G6_0_1_2_2_6_10_1 + 8.333333333333312e-03*G6_0_1_2_2_6_11_2 - 4.166666666666655e-03*G6_0_1_2_2_7_8_0 - 4.166666666666657e-03*G6_0_1_2_2_7_8_1 - 4.166666666666657e-03*G6_0_1_2_2_7_8_2 + 4.166666666666655e-03*G6_0_1_2_2_7_9_0 + 4.166666666666657e-03*G6_0_1_2_2_7_10_1 + 4.166666666666657e-03*G6_0_1_2_2_7_11_2 - 4.166666666666655e-03*G6_0_1_3_0_4_8_0 - 4.166666666666656e-03*G6_0_1_3_0_4_8_1 - 4.166666666666657e-03*G6_0_1_3_0_4_8_2 + 4.166666666666655e-03*G6_0_1_3_0_4_9_0 + 4.166666666666656e-03*G6_0_1_3_0_4_10_1 + 4.166666666666656e-03*G6_0_1_3_0_4_11_2 - 4.166666666666655e-03*G6_0_1_3_0_5_8_0 - 4.166666666666656e-03*G6_0_1_3_0_5_8_1 - 4.166666666666656e-03*G6_0_1_3_0_5_8_2 + 4.166666666666655e-03*G6_0_1_3_0_5_9_0 + 4.166666666666656e-03*G6_0_1_3_0_5_10_1 + 4.166666666666656e-03*G6_0_1_3_0_5_11_2 - 4.166666666666655e-03*G6_0_1_3_0_6_8_0 - 4.166666666666655e-03*G6_0_1_3_0_6_8_1 - 4.166666666666655e-03*G6_0_1_3_0_6_8_2 + 4.166666666666655e-03*G6_0_1_3_0_6_9_0 + 4.166666666666655e-03*G6_0_1_3_0_6_10_1 + 4.166666666666655e-03*G6_0_1_3_0_6_11_2 - 8.333333333333309e-03*G6_0_1_3_0_7_8_0 - 8.333333333333311e-03*G6_0_1_3_0_7_8_1 - 8.333333333333311e-03*G6_0_1_3_0_7_8_2 + 8.333333333333309e-03*G6_0_1_3_0_7_9_0 + 8.333333333333311e-03*G6_0_1_3_0_7_10_1 + 8.333333333333311e-03*G6_0_1_3_0_7_11_2 - 4.166666666666656e-03*G6_0_1_3_1_4_8_0 - 4.166666666666657e-03*G6_0_1_3_1_4_8_1 - 4.166666666666657e-03*G6_0_1_3_1_4_8_2 + 4.166666666666656e-03*G6_0_1_3_1_4_9_0 + 4.166666666666657e-03*G6_0_1_3_1_4_10_1 + 4.166666666666657e-03*G6_0_1_3_1_4_11_2 - 4.166666666666656e-03*G6_0_1_3_1_5_8_0 - 4.166666666666657e-03*G6_0_1_3_1_5_8_1 - 4.166666666666657e-03*G6_0_1_3_1_5_8_2 + 4.166666666666656e-03*G6_0_1_3_1_5_9_0 + 4.166666666666657e-03*G6_0_1_3_1_5_10_1 + 4.166666666666657e-03*G6_0_1_3_1_5_11_2 - 4.166666666666655e-03*G6_0_1_3_1_6_8_0 - 4.166666666666656e-03*G6_0_1_3_1_6_8_1 - 4.166666666666657e-03*G6_0_1_3_1_6_8_2 + 4.166666666666655e-03*G6_0_1_3_1_6_9_0 + 4.166666666666656e-03*G6_0_1_3_1_6_10_1 + 4.166666666666656e-03*G6_0_1_3_1_6_11_2 - 8.333333333333311e-03*G6_0_1_3_1_7_8_0 - 8.333333333333311e-03*G6_0_1_3_1_7_8_1 - 8.333333333333312e-03*G6_0_1_3_1_7_8_2 + 8.333333333333311e-03*G6_0_1_3_1_7_9_0 + 8.333333333333311e-03*G6_0_1_3_1_7_10_1 + 8.333333333333311e-03*G6_0_1_3_1_7_11_2 - 4.166666666666657e-03*G6_0_1_3_2_4_8_0 - 4.166666666666657e-03*G6_0_1_3_2_4_8_1 - 4.166666666666658e-03*G6_0_1_3_2_4_8_2 + 4.166666666666657e-03*G6_0_1_3_2_4_9_0 + 4.166666666666657e-03*G6_0_1_3_2_4_10_1 + 4.166666666666657e-03*G6_0_1_3_2_4_11_2 - 4.166666666666656e-03*G6_0_1_3_2_5_8_0 - 4.166666666666657e-03*G6_0_1_3_2_5_8_1 - 4.166666666666657e-03*G6_0_1_3_2_5_8_2 + 4.166666666666656e-03*G6_0_1_3_2_5_9_0 + 4.166666666666657e-03*G6_0_1_3_2_5_10_1 + 4.166666666666657e-03*G6_0_1_3_2_5_11_2 - 4.166666666666655e-03*G6_0_1_3_2_6_8_0 - 4.166666666666657e-03*G6_0_1_3_2_6_8_1 - 4.166666666666657e-03*G6_0_1_3_2_6_8_2 + 4.166666666666655e-03*G6_0_1_3_2_6_9_0 + 4.166666666666657e-03*G6_0_1_3_2_6_10_1 + 4.166666666666657e-03*G6_0_1_3_2_6_11_2 - 8.333333333333311e-03*G6_0_1_3_2_7_8_0 - 8.333333333333312e-03*G6_0_1_3_2_7_8_1 - 8.333333333333312e-03*G6_0_1_3_2_7_8_2 + 8.333333333333311e-03*G6_0_1_3_2_7_9_0 + 8.333333333333312e-03*G6_0_1_3_2_7_10_1 + 8.333333333333312e-03*G6_0_1_3_2_7_11_2 - 8.333333333333309e-03*G6_0_2_0_0_8_8_0 - 8.333333333333309e-03*G6_0_2_0_0_8_8_1 - 8.333333333333311e-03*G6_0_2_0_0_8_8_2 + 8.333333333333309e-03*G6_0_2_0_0_8_9_0 + 8.333333333333309e-03*G6_0_2_0_0_8_10_1 + 8.333333333333309e-03*G6_0_2_0_0_8_11_2 - 4.166666666666654e-03*G6_0_2_0_0_9_8_0 - 4.166666666666655e-03*G6_0_2_0_0_9_8_1 - 4.166666666666655e-03*G6_0_2_0_0_9_8_2 + 4.166666666666654e-03*G6_0_2_0_0_9_9_0 + 4.166666666666655e-03*G6_0_2_0_0_9_10_1 + 4.166666666666655e-03*G6_0_2_0_0_9_11_2 - 4.166666666666654e-03*G6_0_2_0_0_10_8_0 - 4.166666666666654e-03*G6_0_2_0_0_10_8_1 - 4.166666666666656e-03*G6_0_2_0_0_10_8_2 + 4.166666666666654e-03*G6_0_2_0_0_10_9_0 + 4.166666666666654e-03*G6_0_2_0_0_10_10_1 + 4.166666666666654e-03*G6_0_2_0_0_10_11_2 - 4.166666666666656e-03*G6_0_2_0_0_11_8_0 - 4.166666666666656e-03*G6_0_2_0_0_11_8_1 - 4.166666666666657e-03*G6_0_2_0_0_11_8_2 + 4.166666666666656e-03*G6_0_2_0_0_11_9_0 + 4.166666666666656e-03*G6_0_2_0_0_11_10_1 + 4.166666666666656e-03*G6_0_2_0_0_11_11_2 - 8.333333333333309e-03*G6_0_2_0_1_8_8_0 - 8.333333333333311e-03*G6_0_2_0_1_8_8_1 - 8.333333333333312e-03*G6_0_2_0_1_8_8_2 + 8.333333333333309e-03*G6_0_2_0_1_8_9_0 + 8.333333333333311e-03*G6_0_2_0_1_8_10_1 + 8.333333333333311e-03*G6_0_2_0_1_8_11_2 - 4.166666666666655e-03*G6_0_2_0_1_9_8_0 - 4.166666666666655e-03*G6_0_2_0_1_9_8_1 - 4.166666666666656e-03*G6_0_2_0_1_9_8_2 + 4.166666666666655e-03*G6_0_2_0_1_9_9_0 + 4.166666666666655e-03*G6_0_2_0_1_9_10_1 + 4.166666666666655e-03*G6_0_2_0_1_9_11_2 - 4.166666666666654e-03*G6_0_2_0_1_10_8_0 - 4.166666666666656e-03*G6_0_2_0_1_10_8_1 - 4.166666666666656e-03*G6_0_2_0_1_10_8_2 + 4.166666666666654e-03*G6_0_2_0_1_10_9_0 + 4.166666666666656e-03*G6_0_2_0_1_10_10_1 + 4.166666666666656e-03*G6_0_2_0_1_10_11_2 - 4.166666666666656e-03*G6_0_2_0_1_11_8_0 - 4.166666666666657e-03*G6_0_2_0_1_11_8_1 - 4.166666666666658e-03*G6_0_2_0_1_11_8_2 + 4.166666666666656e-03*G6_0_2_0_1_11_9_0 + 4.166666666666657e-03*G6_0_2_0_1_11_10_1 + 4.166666666666657e-03*G6_0_2_0_1_11_11_2 - 8.333333333333311e-03*G6_0_2_0_2_8_8_0 - 8.333333333333312e-03*G6_0_2_0_2_8_8_1 - 8.333333333333314e-03*G6_0_2_0_2_8_8_2 + 8.333333333333311e-03*G6_0_2_0_2_8_9_0 + 8.333333333333312e-03*G6_0_2_0_2_8_10_1 + 8.333333333333312e-03*G6_0_2_0_2_8_11_2 - 4.166666666666655e-03*G6_0_2_0_2_9_8_0 - 4.166666666666656e-03*G6_0_2_0_2_9_8_1 - 4.166666666666657e-03*G6_0_2_0_2_9_8_2 + 4.166666666666655e-03*G6_0_2_0_2_9_9_0 + 4.166666666666656e-03*G6_0_2_0_2_9_10_1 + 4.166666666666656e-03*G6_0_2_0_2_9_11_2 - 4.166666666666655e-03*G6_0_2_0_2_10_8_0 - 4.166666666666656e-03*G6_0_2_0_2_10_8_1 - 4.166666666666656e-03*G6_0_2_0_2_10_8_2 + 4.166666666666655e-03*G6_0_2_0_2_10_9_0 + 4.166666666666656e-03*G6_0_2_0_2_10_10_1 + 4.166666666666656e-03*G6_0_2_0_2_10_11_2 - 4.166666666666657e-03*G6_0_2_0_2_11_8_0 - 4.166666666666658e-03*G6_0_2_0_2_11_8_1 - 4.166666666666659e-03*G6_0_2_0_2_11_8_2 + 4.166666666666657e-03*G6_0_2_0_2_11_9_0 + 4.166666666666658e-03*G6_0_2_0_2_11_10_1 + 4.166666666666658e-03*G6_0_2_0_2_11_11_2 - 4.166666666666654e-03*G6_0_2_1_0_8_8_0 - 4.166666666666654e-03*G6_0_2_1_0_8_8_1 - 4.166666666666654e-03*G6_0_2_1_0_8_8_2 + 4.166666666666654e-03*G6_0_2_1_0_8_9_0 + 4.166666666666654e-03*G6_0_2_1_0_8_10_1 + 4.166666666666654e-03*G6_0_2_1_0_8_11_2 - 8.333333333333307e-03*G6_0_2_1_0_9_8_0 - 8.333333333333309e-03*G6_0_2_1_0_9_8_1 - 8.333333333333309e-03*G6_0_2_1_0_9_8_2 + 8.333333333333307e-03*G6_0_2_1_0_9_9_0 + 8.333333333333309e-03*G6_0_2_1_0_9_10_1 + 8.333333333333309e-03*G6_0_2_1_0_9_11_2 - 4.166666666666654e-03*G6_0_2_1_0_10_8_0 - 4.166666666666654e-03*G6_0_2_1_0_10_8_1 - 4.166666666666654e-03*G6_0_2_1_0_10_8_2 + 4.166666666666654e-03*G6_0_2_1_0_10_9_0 + 4.166666666666654e-03*G6_0_2_1_0_10_10_1 + 4.166666666666654e-03*G6_0_2_1_0_10_11_2 - 4.166666666666654e-03*G6_0_2_1_0_11_8_0 - 4.166666666666655e-03*G6_0_2_1_0_11_8_1 - 4.166666666666655e-03*G6_0_2_1_0_11_8_2 + 4.166666666666654e-03*G6_0_2_1_0_11_9_0 + 4.166666666666655e-03*G6_0_2_1_0_11_10_1 + 4.166666666666655e-03*G6_0_2_1_0_11_11_2 - 4.166666666666654e-03*G6_0_2_1_1_8_8_0 - 4.166666666666654e-03*G6_0_2_1_1_8_8_1 - 4.166666666666654e-03*G6_0_2_1_1_8_8_2 + 4.166666666666654e-03*G6_0_2_1_1_8_9_0 + 4.166666666666654e-03*G6_0_2_1_1_8_10_1 + 4.166666666666654e-03*G6_0_2_1_1_8_11_2 - 8.333333333333309e-03*G6_0_2_1_1_9_8_0 - 8.333333333333309e-03*G6_0_2_1_1_9_8_1 - 8.333333333333309e-03*G6_0_2_1_1_9_8_2 + 8.333333333333309e-03*G6_0_2_1_1_9_9_0 + 8.333333333333309e-03*G6_0_2_1_1_9_10_1 + 8.333333333333309e-03*G6_0_2_1_1_9_11_2 - 4.166666666666654e-03*G6_0_2_1_1_10_8_0 - 4.166666666666654e-03*G6_0_2_1_1_10_8_1 - 4.166666666666655e-03*G6_0_2_1_1_10_8_2 + 4.166666666666654e-03*G6_0_2_1_1_10_9_0 + 4.166666666666654e-03*G6_0_2_1_1_10_10_1 + 4.166666666666654e-03*G6_0_2_1_1_10_11_2 - 4.166666666666655e-03*G6_0_2_1_1_11_8_0 - 4.166666666666655e-03*G6_0_2_1_1_11_8_1 - 4.166666666666656e-03*G6_0_2_1_1_11_8_2 + 4.166666666666655e-03*G6_0_2_1_1_11_9_0 + 4.166666666666655e-03*G6_0_2_1_1_11_10_1 + 4.166666666666655e-03*G6_0_2_1_1_11_11_2 - 4.166666666666654e-03*G6_0_2_1_2_8_8_0 - 4.166666666666654e-03*G6_0_2_1_2_8_8_1 - 4.166666666666655e-03*G6_0_2_1_2_8_8_2 + 4.166666666666654e-03*G6_0_2_1_2_8_9_0 + 4.166666666666654e-03*G6_0_2_1_2_8_10_1 + 4.166666666666654e-03*G6_0_2_1_2_8_11_2 - 8.333333333333309e-03*G6_0_2_1_2_9_8_0 - 8.333333333333309e-03*G6_0_2_1_2_9_8_1 - 8.333333333333309e-03*G6_0_2_1_2_9_8_2 + 8.333333333333309e-03*G6_0_2_1_2_9_9_0 + 8.333333333333309e-03*G6_0_2_1_2_9_10_1 + 8.333333333333309e-03*G6_0_2_1_2_9_11_2 - 4.166666666666654e-03*G6_0_2_1_2_10_8_0 - 4.166666666666655e-03*G6_0_2_1_2_10_8_1 - 4.166666666666655e-03*G6_0_2_1_2_10_8_2 + 4.166666666666654e-03*G6_0_2_1_2_10_9_0 + 4.166666666666655e-03*G6_0_2_1_2_10_10_1 + 4.166666666666655e-03*G6_0_2_1_2_10_11_2 - 4.166666666666655e-03*G6_0_2_1_2_11_8_0 - 4.166666666666656e-03*G6_0_2_1_2_11_8_1 - 4.166666666666656e-03*G6_0_2_1_2_11_8_2 + 4.166666666666655e-03*G6_0_2_1_2_11_9_0 + 4.166666666666656e-03*G6_0_2_1_2_11_10_1 + 4.166666666666656e-03*G6_0_2_1_2_11_11_2 - 4.166666666666653e-03*G6_0_2_2_0_8_8_0 - 4.166666666666654e-03*G6_0_2_2_0_8_8_1 - 4.166666666666654e-03*G6_0_2_2_0_8_8_2 + 4.166666666666653e-03*G6_0_2_2_0_8_9_0 + 4.166666666666654e-03*G6_0_2_2_0_8_10_1 + 4.166666666666654e-03*G6_0_2_2_0_8_11_2 - 4.166666666666654e-03*G6_0_2_2_0_9_8_0 - 4.166666666666655e-03*G6_0_2_2_0_9_8_1 - 4.166666666666655e-03*G6_0_2_2_0_9_8_2 + 4.166666666666654e-03*G6_0_2_2_0_9_9_0 + 4.166666666666655e-03*G6_0_2_2_0_9_10_1 + 4.166666666666655e-03*G6_0_2_2_0_9_11_2 - 8.333333333333309e-03*G6_0_2_2_0_10_8_0 - 8.333333333333309e-03*G6_0_2_2_0_10_8_1 - 8.333333333333311e-03*G6_0_2_2_0_10_8_2 + 8.333333333333309e-03*G6_0_2_2_0_10_9_0 + 8.333333333333309e-03*G6_0_2_2_0_10_10_1 + 8.333333333333309e-03*G6_0_2_2_0_10_11_2 - 4.166666666666654e-03*G6_0_2_2_0_11_8_0 - 4.166666666666655e-03*G6_0_2_2_0_11_8_1 - 4.166666666666655e-03*G6_0_2_2_0_11_8_2 + 4.166666666666654e-03*G6_0_2_2_0_11_9_0 + 4.166666666666655e-03*G6_0_2_2_0_11_10_1 + 4.166666666666655e-03*G6_0_2_2_0_11_11_2 - 4.166666666666654e-03*G6_0_2_2_1_8_8_0 - 4.166666666666654e-03*G6_0_2_2_1_8_8_1 - 4.166666666666654e-03*G6_0_2_2_1_8_8_2 + 4.166666666666654e-03*G6_0_2_2_1_8_9_0 + 4.166666666666654e-03*G6_0_2_2_1_8_10_1 + 4.166666666666654e-03*G6_0_2_2_1_8_11_2 - 4.166666666666655e-03*G6_0_2_2_1_9_8_0 - 4.166666666666656e-03*G6_0_2_2_1_9_8_1 - 4.166666666666656e-03*G6_0_2_2_1_9_8_2 + 4.166666666666655e-03*G6_0_2_2_1_9_9_0 + 4.166666666666656e-03*G6_0_2_2_1_9_10_1 + 4.166666666666656e-03*G6_0_2_2_1_9_11_2 - 8.333333333333311e-03*G6_0_2_2_1_10_8_0 - 8.333333333333311e-03*G6_0_2_2_1_10_8_1 - 8.333333333333312e-03*G6_0_2_2_1_10_8_2 + 8.333333333333311e-03*G6_0_2_2_1_10_9_0 + 8.333333333333311e-03*G6_0_2_2_1_10_10_1 + 8.333333333333311e-03*G6_0_2_2_1_10_11_2 - 4.166666666666655e-03*G6_0_2_2_1_11_8_0 - 4.166666666666656e-03*G6_0_2_2_1_11_8_1 - 4.166666666666657e-03*G6_0_2_2_1_11_8_2 + 4.166666666666655e-03*G6_0_2_2_1_11_9_0 + 4.166666666666656e-03*G6_0_2_2_1_11_10_1 + 4.166666666666656e-03*G6_0_2_2_1_11_11_2 - 4.166666666666654e-03*G6_0_2_2_2_8_8_0 - 4.166666666666654e-03*G6_0_2_2_2_8_8_1 - 4.166666666666654e-03*G6_0_2_2_2_8_8_2 + 4.166666666666654e-03*G6_0_2_2_2_8_9_0 + 4.166666666666654e-03*G6_0_2_2_2_8_10_1 + 4.166666666666654e-03*G6_0_2_2_2_8_11_2 - 4.166666666666655e-03*G6_0_2_2_2_9_8_0 - 4.166666666666656e-03*G6_0_2_2_2_9_8_1 - 4.166666666666656e-03*G6_0_2_2_2_9_8_2 + 4.166666666666655e-03*G6_0_2_2_2_9_9_0 + 4.166666666666656e-03*G6_0_2_2_2_9_10_1 + 4.166666666666656e-03*G6_0_2_2_2_9_11_2 - 8.333333333333311e-03*G6_0_2_2_2_10_8_0 - 8.333333333333312e-03*G6_0_2_2_2_10_8_1 - 8.333333333333312e-03*G6_0_2_2_2_10_8_2 + 8.333333333333311e-03*G6_0_2_2_2_10_9_0 + 8.333333333333312e-03*G6_0_2_2_2_10_10_1 + 8.333333333333312e-03*G6_0_2_2_2_10_11_2 - 4.166666666666655e-03*G6_0_2_2_2_11_8_0 - 4.166666666666657e-03*G6_0_2_2_2_11_8_1 - 4.166666666666657e-03*G6_0_2_2_2_11_8_2 + 4.166666666666655e-03*G6_0_2_2_2_11_9_0 + 4.166666666666657e-03*G6_0_2_2_2_11_10_1 + 4.166666666666657e-03*G6_0_2_2_2_11_11_2 - 4.166666666666655e-03*G6_0_2_3_0_8_8_0 - 4.166666666666656e-03*G6_0_2_3_0_8_8_1 - 4.166666666666657e-03*G6_0_2_3_0_8_8_2 + 4.166666666666655e-03*G6_0_2_3_0_8_9_0 + 4.166666666666656e-03*G6_0_2_3_0_8_10_1 + 4.166666666666656e-03*G6_0_2_3_0_8_11_2 - 4.166666666666655e-03*G6_0_2_3_0_9_8_0 - 4.166666666666656e-03*G6_0_2_3_0_9_8_1 - 4.166666666666656e-03*G6_0_2_3_0_9_8_2 + 4.166666666666655e-03*G6_0_2_3_0_9_9_0 + 4.166666666666656e-03*G6_0_2_3_0_9_10_1 + 4.166666666666656e-03*G6_0_2_3_0_9_11_2 - 4.166666666666655e-03*G6_0_2_3_0_10_8_0 - 4.166666666666655e-03*G6_0_2_3_0_10_8_1 - 4.166666666666655e-03*G6_0_2_3_0_10_8_2 + 4.166666666666655e-03*G6_0_2_3_0_10_9_0 + 4.166666666666655e-03*G6_0_2_3_0_10_10_1 + 4.166666666666655e-03*G6_0_2_3_0_10_11_2 - 8.333333333333309e-03*G6_0_2_3_0_11_8_0 - 8.333333333333311e-03*G6_0_2_3_0_11_8_1 - 8.333333333333311e-03*G6_0_2_3_0_11_8_2 + 8.333333333333309e-03*G6_0_2_3_0_11_9_0 + 8.333333333333311e-03*G6_0_2_3_0_11_10_1 + 8.333333333333311e-03*G6_0_2_3_0_11_11_2 - 4.166666666666656e-03*G6_0_2_3_1_8_8_0 - 4.166666666666657e-03*G6_0_2_3_1_8_8_1 - 4.166666666666657e-03*G6_0_2_3_1_8_8_2 + 4.166666666666656e-03*G6_0_2_3_1_8_9_0 + 4.166666666666657e-03*G6_0_2_3_1_8_10_1 + 4.166666666666657e-03*G6_0_2_3_1_8_11_2 - 4.166666666666656e-03*G6_0_2_3_1_9_8_0 - 4.166666666666657e-03*G6_0_2_3_1_9_8_1 - 4.166666666666657e-03*G6_0_2_3_1_9_8_2 + 4.166666666666656e-03*G6_0_2_3_1_9_9_0 + 4.166666666666657e-03*G6_0_2_3_1_9_10_1 + 4.166666666666657e-03*G6_0_2_3_1_9_11_2 - 4.166666666666655e-03*G6_0_2_3_1_10_8_0 - 4.166666666666656e-03*G6_0_2_3_1_10_8_1 - 4.166666666666657e-03*G6_0_2_3_1_10_8_2 + 4.166666666666655e-03*G6_0_2_3_1_10_9_0 + 4.166666666666656e-03*G6_0_2_3_1_10_10_1 + 4.166666666666656e-03*G6_0_2_3_1_10_11_2 - 8.333333333333311e-03*G6_0_2_3_1_11_8_0 - 8.333333333333311e-03*G6_0_2_3_1_11_8_1 - 8.333333333333312e-03*G6_0_2_3_1_11_8_2 + 8.333333333333311e-03*G6_0_2_3_1_11_9_0 + 8.333333333333311e-03*G6_0_2_3_1_11_10_1 + 8.333333333333311e-03*G6_0_2_3_1_11_11_2 - 4.166666666666657e-03*G6_0_2_3_2_8_8_0 - 4.166666666666657e-03*G6_0_2_3_2_8_8_1 - 4.166666666666658e-03*G6_0_2_3_2_8_8_2 + 4.166666666666657e-03*G6_0_2_3_2_8_9_0 + 4.166666666666657e-03*G6_0_2_3_2_8_10_1 + 4.166666666666657e-03*G6_0_2_3_2_8_11_2 - 4.166666666666656e-03*G6_0_2_3_2_9_8_0 - 4.166666666666657e-03*G6_0_2_3_2_9_8_1 - 4.166666666666657e-03*G6_0_2_3_2_9_8_2 + 4.166666666666656e-03*G6_0_2_3_2_9_9_0 + 4.166666666666657e-03*G6_0_2_3_2_9_10_1 + 4.166666666666657e-03*G6_0_2_3_2_9_11_2 - 4.166666666666655e-03*G6_0_2_3_2_10_8_0 - 4.166666666666657e-03*G6_0_2_3_2_10_8_1 - 4.166666666666657e-03*G6_0_2_3_2_10_8_2 + 4.166666666666655e-03*G6_0_2_3_2_10_9_0 + 4.166666666666657e-03*G6_0_2_3_2_10_10_1 + 4.166666666666657e-03*G6_0_2_3_2_10_11_2 - 8.333333333333311e-03*G6_0_2_3_2_11_8_0 - 8.333333333333312e-03*G6_0_2_3_2_11_8_1 - 8.333333333333312e-03*G6_0_2_3_2_11_8_2 + 8.333333333333311e-03*G6_0_2_3_2_11_9_0 + 8.333333333333312e-03*G6_0_2_3_2_11_10_1 + 8.333333333333312e-03*G6_0_2_3_2_11_11_2 - 8.333333333333309e-03*G6_1_0_4_0_0_8_0 - 8.333333333333309e-03*G6_1_0_4_0_0_8_1 - 8.333333333333311e-03*G6_1_0_4_0_0_8_2 + 8.333333333333309e-03*G6_1_0_4_0_0_9_0 + 8.333333333333309e-03*G6_1_0_4_0_0_10_1 + 8.333333333333309e-03*G6_1_0_4_0_0_11_2 - 4.166666666666654e-03*G6_1_0_4_0_1_8_0 - 4.166666666666654e-03*G6_1_0_4_0_1_8_1 - 4.166666666666654e-03*G6_1_0_4_0_1_8_2 + 4.166666666666654e-03*G6_1_0_4_0_1_9_0 + 4.166666666666654e-03*G6_1_0_4_0_1_10_1 + 4.166666666666654e-03*G6_1_0_4_0_1_11_2 - 4.166666666666653e-03*G6_1_0_4_0_2_8_0 - 4.166666666666654e-03*G6_1_0_4_0_2_8_1 - 4.166666666666654e-03*G6_1_0_4_0_2_8_2 + 4.166666666666653e-03*G6_1_0_4_0_2_9_0 + 4.166666666666654e-03*G6_1_0_4_0_2_10_1 + 4.166666666666654e-03*G6_1_0_4_0_2_11_2 - 4.166666666666654e-03*G6_1_0_4_0_3_8_0 - 4.166666666666656e-03*G6_1_0_4_0_3_8_1 - 4.166666666666657e-03*G6_1_0_4_0_3_8_2 + 4.166666666666654e-03*G6_1_0_4_0_3_9_0 + 4.166666666666656e-03*G6_1_0_4_0_3_10_1 + 4.166666666666656e-03*G6_1_0_4_0_3_11_2 - 8.333333333333309e-03*G6_1_0_4_1_0_8_0 - 8.333333333333311e-03*G6_1_0_4_1_0_8_1 - 8.333333333333312e-03*G6_1_0_4_1_0_8_2 + 8.333333333333309e-03*G6_1_0_4_1_0_9_0 + 8.333333333333311e-03*G6_1_0_4_1_0_10_1 + 8.333333333333311e-03*G6_1_0_4_1_0_11_2 - 4.166666666666654e-03*G6_1_0_4_1_1_8_0 - 4.166666666666654e-03*G6_1_0_4_1_1_8_1 - 4.166666666666654e-03*G6_1_0_4_1_1_8_2 + 4.166666666666654e-03*G6_1_0_4_1_1_9_0 + 4.166666666666654e-03*G6_1_0_4_1_1_10_1 + 4.166666666666654e-03*G6_1_0_4_1_1_11_2 - 4.166666666666654e-03*G6_1_0_4_1_2_8_0 - 4.166666666666654e-03*G6_1_0_4_1_2_8_1 - 4.166666666666654e-03*G6_1_0_4_1_2_8_2 + 4.166666666666654e-03*G6_1_0_4_1_2_9_0 + 4.166666666666654e-03*G6_1_0_4_1_2_10_1 + 4.166666666666654e-03*G6_1_0_4_1_2_11_2 - 4.166666666666656e-03*G6_1_0_4_1_3_8_0 - 4.166666666666657e-03*G6_1_0_4_1_3_8_1 - 4.166666666666657e-03*G6_1_0_4_1_3_8_2 + 4.166666666666656e-03*G6_1_0_4_1_3_9_0 + 4.166666666666657e-03*G6_1_0_4_1_3_10_1 + 4.166666666666657e-03*G6_1_0_4_1_3_11_2 - 8.333333333333311e-03*G6_1_0_4_2_0_8_0 - 8.333333333333312e-03*G6_1_0_4_2_0_8_1 - 8.333333333333314e-03*G6_1_0_4_2_0_8_2 + 8.333333333333311e-03*G6_1_0_4_2_0_9_0 + 8.333333333333312e-03*G6_1_0_4_2_0_10_1 + 8.333333333333312e-03*G6_1_0_4_2_0_11_2 - 4.166666666666654e-03*G6_1_0_4_2_1_8_0 - 4.166666666666654e-03*G6_1_0_4_2_1_8_1 - 4.166666666666655e-03*G6_1_0_4_2_1_8_2 + 4.166666666666654e-03*G6_1_0_4_2_1_9_0 + 4.166666666666654e-03*G6_1_0_4_2_1_10_1 + 4.166666666666654e-03*G6_1_0_4_2_1_11_2 - 4.166666666666654e-03*G6_1_0_4_2_2_8_0 - 4.166666666666654e-03*G6_1_0_4_2_2_8_1 - 4.166666666666654e-03*G6_1_0_4_2_2_8_2 + 4.166666666666654e-03*G6_1_0_4_2_2_9_0 + 4.166666666666654e-03*G6_1_0_4_2_2_10_1 + 4.166666666666654e-03*G6_1_0_4_2_2_11_2 - 4.166666666666657e-03*G6_1_0_4_2_3_8_0 - 4.166666666666657e-03*G6_1_0_4_2_3_8_1 - 4.166666666666658e-03*G6_1_0_4_2_3_8_2 + 4.166666666666657e-03*G6_1_0_4_2_3_9_0 + 4.166666666666657e-03*G6_1_0_4_2_3_10_1 + 4.166666666666657e-03*G6_1_0_4_2_3_11_2 - 4.166666666666654e-03*G6_1_0_5_0_0_8_0 - 4.166666666666655e-03*G6_1_0_5_0_0_8_1 - 4.166666666666655e-03*G6_1_0_5_0_0_8_2 + 4.166666666666654e-03*G6_1_0_5_0_0_9_0 + 4.166666666666655e-03*G6_1_0_5_0_0_10_1 + 4.166666666666655e-03*G6_1_0_5_0_0_11_2 - 8.333333333333307e-03*G6_1_0_5_0_1_8_0 - 8.333333333333309e-03*G6_1_0_5_0_1_8_1 - 8.333333333333309e-03*G6_1_0_5_0_1_8_2 + 8.333333333333307e-03*G6_1_0_5_0_1_9_0 + 8.333333333333309e-03*G6_1_0_5_0_1_10_1 + 8.333333333333309e-03*G6_1_0_5_0_1_11_2 - 4.166666666666654e-03*G6_1_0_5_0_2_8_0 - 4.166666666666655e-03*G6_1_0_5_0_2_8_1 - 4.166666666666655e-03*G6_1_0_5_0_2_8_2 + 4.166666666666654e-03*G6_1_0_5_0_2_9_0 + 4.166666666666655e-03*G6_1_0_5_0_2_10_1 + 4.166666666666655e-03*G6_1_0_5_0_2_11_2 - 4.166666666666655e-03*G6_1_0_5_0_3_8_0 - 4.166666666666656e-03*G6_1_0_5_0_3_8_1 - 4.166666666666656e-03*G6_1_0_5_0_3_8_2 + 4.166666666666655e-03*G6_1_0_5_0_3_9_0 + 4.166666666666656e-03*G6_1_0_5_0_3_10_1 + 4.166666666666656e-03*G6_1_0_5_0_3_11_2 - 4.166666666666655e-03*G6_1_0_5_1_0_8_0 - 4.166666666666655e-03*G6_1_0_5_1_0_8_1 - 4.166666666666656e-03*G6_1_0_5_1_0_8_2 + 4.166666666666655e-03*G6_1_0_5_1_0_9_0 + 4.166666666666655e-03*G6_1_0_5_1_0_10_1 + 4.166666666666655e-03*G6_1_0_5_1_0_11_2 - 8.333333333333309e-03*G6_1_0_5_1_1_8_0 - 8.333333333333309e-03*G6_1_0_5_1_1_8_1 - 8.333333333333309e-03*G6_1_0_5_1_1_8_2 + 8.333333333333309e-03*G6_1_0_5_1_1_9_0 + 8.333333333333309e-03*G6_1_0_5_1_1_10_1 + 8.333333333333309e-03*G6_1_0_5_1_1_11_2 - 4.166666666666655e-03*G6_1_0_5_1_2_8_0 - 4.166666666666656e-03*G6_1_0_5_1_2_8_1 - 4.166666666666656e-03*G6_1_0_5_1_2_8_2 + 4.166666666666655e-03*G6_1_0_5_1_2_9_0 + 4.166666666666656e-03*G6_1_0_5_1_2_10_1 + 4.166666666666656e-03*G6_1_0_5_1_2_11_2 - 4.166666666666656e-03*G6_1_0_5_1_3_8_0 - 4.166666666666657e-03*G6_1_0_5_1_3_8_1 - 4.166666666666657e-03*G6_1_0_5_1_3_8_2 + 4.166666666666656e-03*G6_1_0_5_1_3_9_0 + 4.166666666666657e-03*G6_1_0_5_1_3_10_1 + 4.166666666666657e-03*G6_1_0_5_1_3_11_2 - 4.166666666666655e-03*G6_1_0_5_2_0_8_0 - 4.166666666666656e-03*G6_1_0_5_2_0_8_1 - 4.166666666666657e-03*G6_1_0_5_2_0_8_2 + 4.166666666666655e-03*G6_1_0_5_2_0_9_0 + 4.166666666666656e-03*G6_1_0_5_2_0_10_1 + 4.166666666666656e-03*G6_1_0_5_2_0_11_2 - 8.333333333333309e-03*G6_1_0_5_2_1_8_0 - 8.333333333333309e-03*G6_1_0_5_2_1_8_1 - 8.333333333333309e-03*G6_1_0_5_2_1_8_2 + 8.333333333333309e-03*G6_1_0_5_2_1_9_0 + 8.333333333333309e-03*G6_1_0_5_2_1_10_1 + 8.333333333333309e-03*G6_1_0_5_2_1_11_2 - 4.166666666666655e-03*G6_1_0_5_2_2_8_0 - 4.166666666666656e-03*G6_1_0_5_2_2_8_1 - 4.166666666666656e-03*G6_1_0_5_2_2_8_2 + 4.166666666666655e-03*G6_1_0_5_2_2_9_0 + 4.166666666666656e-03*G6_1_0_5_2_2_10_1 + 4.166666666666656e-03*G6_1_0_5_2_2_11_2 - 4.166666666666656e-03*G6_1_0_5_2_3_8_0 - 4.166666666666657e-03*G6_1_0_5_2_3_8_1 - 4.166666666666657e-03*G6_1_0_5_2_3_8_2 + 4.166666666666656e-03*G6_1_0_5_2_3_9_0 + 4.166666666666657e-03*G6_1_0_5_2_3_10_1 + 4.166666666666657e-03*G6_1_0_5_2_3_11_2 - 4.166666666666654e-03*G6_1_0_6_0_0_8_0 - 4.166666666666654e-03*G6_1_0_6_0_0_8_1 - 4.166666666666655e-03*G6_1_0_6_0_0_8_2 + 4.166666666666654e-03*G6_1_0_6_0_0_9_0 + 4.166666666666654e-03*G6_1_0_6_0_0_10_1 + 4.166666666666654e-03*G6_1_0_6_0_0_11_2 - 4.166666666666654e-03*G6_1_0_6_0_1_8_0 - 4.166666666666654e-03*G6_1_0_6_0_1_8_1 - 4.166666666666654e-03*G6_1_0_6_0_1_8_2 + 4.166666666666654e-03*G6_1_0_6_0_1_9_0 + 4.166666666666654e-03*G6_1_0_6_0_1_10_1 + 4.166666666666654e-03*G6_1_0_6_0_1_11_2 - 8.333333333333309e-03*G6_1_0_6_0_2_8_0 - 8.333333333333309e-03*G6_1_0_6_0_2_8_1 - 8.333333333333311e-03*G6_1_0_6_0_2_8_2 + 8.333333333333309e-03*G6_1_0_6_0_2_9_0 + 8.333333333333309e-03*G6_1_0_6_0_2_10_1 + 8.333333333333309e-03*G6_1_0_6_0_2_11_2 - 4.166666666666654e-03*G6_1_0_6_0_3_8_0 - 4.166666666666655e-03*G6_1_0_6_0_3_8_1 - 4.166666666666655e-03*G6_1_0_6_0_3_8_2 + 4.166666666666654e-03*G6_1_0_6_0_3_9_0 + 4.166666666666655e-03*G6_1_0_6_0_3_10_1 + 4.166666666666655e-03*G6_1_0_6_0_3_11_2 - 4.166666666666654e-03*G6_1_0_6_1_0_8_0 - 4.166666666666656e-03*G6_1_0_6_1_0_8_1 - 4.166666666666656e-03*G6_1_0_6_1_0_8_2 + 4.166666666666654e-03*G6_1_0_6_1_0_9_0 + 4.166666666666656e-03*G6_1_0_6_1_0_10_1 + 4.166666666666656e-03*G6_1_0_6_1_0_11_2 - 4.166666666666654e-03*G6_1_0_6_1_1_8_0 - 4.166666666666654e-03*G6_1_0_6_1_1_8_1 - 4.166666666666654e-03*G6_1_0_6_1_1_8_2 + 4.166666666666654e-03*G6_1_0_6_1_1_9_0 + 4.166666666666654e-03*G6_1_0_6_1_1_10_1 + 4.166666666666654e-03*G6_1_0_6_1_1_11_2 - 8.333333333333311e-03*G6_1_0_6_1_2_8_0 - 8.333333333333311e-03*G6_1_0_6_1_2_8_1 - 8.333333333333312e-03*G6_1_0_6_1_2_8_2 + 8.333333333333311e-03*G6_1_0_6_1_2_9_0 + 8.333333333333311e-03*G6_1_0_6_1_2_10_1 + 8.333333333333311e-03*G6_1_0_6_1_2_11_2 - 4.166666666666655e-03*G6_1_0_6_1_3_8_0 - 4.166666666666656e-03*G6_1_0_6_1_3_8_1 - 4.166666666666657e-03*G6_1_0_6_1_3_8_2 + 4.166666666666655e-03*G6_1_0_6_1_3_9_0 + 4.166666666666656e-03*G6_1_0_6_1_3_10_1 + 4.166666666666656e-03*G6_1_0_6_1_3_11_2 - 4.166666666666655e-03*G6_1_0_6_2_0_8_0 - 4.166666666666656e-03*G6_1_0_6_2_0_8_1 - 4.166666666666656e-03*G6_1_0_6_2_0_8_2 + 4.166666666666655e-03*G6_1_0_6_2_0_9_0 + 4.166666666666656e-03*G6_1_0_6_2_0_10_1 + 4.166666666666656e-03*G6_1_0_6_2_0_11_2 - 4.166666666666654e-03*G6_1_0_6_2_1_8_0 - 4.166666666666654e-03*G6_1_0_6_2_1_8_1 - 4.166666666666655e-03*G6_1_0_6_2_1_8_2 + 4.166666666666654e-03*G6_1_0_6_2_1_9_0 + 4.166666666666654e-03*G6_1_0_6_2_1_10_1 + 4.166666666666654e-03*G6_1_0_6_2_1_11_2 - 8.333333333333311e-03*G6_1_0_6_2_2_8_0 - 8.333333333333312e-03*G6_1_0_6_2_2_8_1 - 8.333333333333312e-03*G6_1_0_6_2_2_8_2 + 8.333333333333311e-03*G6_1_0_6_2_2_9_0 + 8.333333333333312e-03*G6_1_0_6_2_2_10_1 + 8.333333333333312e-03*G6_1_0_6_2_2_11_2 - 4.166666666666655e-03*G6_1_0_6_2_3_8_0 - 4.166666666666657e-03*G6_1_0_6_2_3_8_1 - 4.166666666666657e-03*G6_1_0_6_2_3_8_2 + 4.166666666666655e-03*G6_1_0_6_2_3_9_0 + 4.166666666666657e-03*G6_1_0_6_2_3_10_1 + 4.166666666666657e-03*G6_1_0_6_2_3_11_2 - 4.166666666666656e-03*G6_1_0_7_0_0_8_0 - 4.166666666666656e-03*G6_1_0_7_0_0_8_1 - 4.166666666666657e-03*G6_1_0_7_0_0_8_2 + 4.166666666666656e-03*G6_1_0_7_0_0_9_0 + 4.166666666666656e-03*G6_1_0_7_0_0_10_1 + 4.166666666666656e-03*G6_1_0_7_0_0_11_2 - 4.166666666666654e-03*G6_1_0_7_0_1_8_0 - 4.166666666666655e-03*G6_1_0_7_0_1_8_1 - 4.166666666666655e-03*G6_1_0_7_0_1_8_2 + 4.166666666666654e-03*G6_1_0_7_0_1_9_0 + 4.166666666666655e-03*G6_1_0_7_0_1_10_1 + 4.166666666666655e-03*G6_1_0_7_0_1_11_2 - 4.166666666666655e-03*G6_1_0_7_0_2_8_0 - 4.166666666666655e-03*G6_1_0_7_0_2_8_1 - 4.166666666666655e-03*G6_1_0_7_0_2_8_2 + 4.166666666666655e-03*G6_1_0_7_0_2_9_0 + 4.166666666666655e-03*G6_1_0_7_0_2_10_1 + 4.166666666666655e-03*G6_1_0_7_0_2_11_2 - 8.333333333333309e-03*G6_1_0_7_0_3_8_0 - 8.333333333333311e-03*G6_1_0_7_0_3_8_1 - 8.333333333333311e-03*G6_1_0_7_0_3_8_2 + 8.333333333333309e-03*G6_1_0_7_0_3_9_0 + 8.333333333333311e-03*G6_1_0_7_0_3_10_1 + 8.333333333333311e-03*G6_1_0_7_0_3_11_2 - 4.166666666666656e-03*G6_1_0_7_1_0_8_0 - 4.166666666666657e-03*G6_1_0_7_1_0_8_1 - 4.166666666666658e-03*G6_1_0_7_1_0_8_2 + 4.166666666666656e-03*G6_1_0_7_1_0_9_0 + 4.166666666666657e-03*G6_1_0_7_1_0_10_1 + 4.166666666666657e-03*G6_1_0_7_1_0_11_2 - 4.166666666666655e-03*G6_1_0_7_1_1_8_0 - 4.166666666666655e-03*G6_1_0_7_1_1_8_1 - 4.166666666666656e-03*G6_1_0_7_1_1_8_2 + 4.166666666666655e-03*G6_1_0_7_1_1_9_0 + 4.166666666666655e-03*G6_1_0_7_1_1_10_1 + 4.166666666666655e-03*G6_1_0_7_1_1_11_2 - 4.166666666666655e-03*G6_1_0_7_1_2_8_0 - 4.166666666666656e-03*G6_1_0_7_1_2_8_1 - 4.166666666666657e-03*G6_1_0_7_1_2_8_2 + 4.166666666666655e-03*G6_1_0_7_1_2_9_0 + 4.166666666666656e-03*G6_1_0_7_1_2_10_1 + 4.166666666666656e-03*G6_1_0_7_1_2_11_2 - 8.333333333333311e-03*G6_1_0_7_1_3_8_0 - 8.333333333333311e-03*G6_1_0_7_1_3_8_1 - 8.333333333333312e-03*G6_1_0_7_1_3_8_2 + 8.333333333333311e-03*G6_1_0_7_1_3_9_0 + 8.333333333333311e-03*G6_1_0_7_1_3_10_1 + 8.333333333333311e-03*G6_1_0_7_1_3_11_2 - 4.166666666666657e-03*G6_1_0_7_2_0_8_0 - 4.166666666666658e-03*G6_1_0_7_2_0_8_1 - 4.166666666666659e-03*G6_1_0_7_2_0_8_2 + 4.166666666666657e-03*G6_1_0_7_2_0_9_0 + 4.166666666666658e-03*G6_1_0_7_2_0_10_1 + 4.166666666666658e-03*G6_1_0_7_2_0_11_2 - 4.166666666666655e-03*G6_1_0_7_2_1_8_0 - 4.166666666666656e-03*G6_1_0_7_2_1_8_1 - 4.166666666666656e-03*G6_1_0_7_2_1_8_2 + 4.166666666666655e-03*G6_1_0_7_2_1_9_0 + 4.166666666666656e-03*G6_1_0_7_2_1_10_1 + 4.166666666666656e-03*G6_1_0_7_2_1_11_2 - 4.166666666666655e-03*G6_1_0_7_2_2_8_0 - 4.166666666666657e-03*G6_1_0_7_2_2_8_1 - 4.166666666666657e-03*G6_1_0_7_2_2_8_2 + 4.166666666666655e-03*G6_1_0_7_2_2_9_0 + 4.166666666666657e-03*G6_1_0_7_2_2_10_1 + 4.166666666666657e-03*G6_1_0_7_2_2_11_2 - 8.333333333333311e-03*G6_1_0_7_2_3_8_0 - 8.333333333333312e-03*G6_1_0_7_2_3_8_1 - 8.333333333333312e-03*G6_1_0_7_2_3_8_2 + 8.333333333333311e-03*G6_1_0_7_2_3_9_0 + 8.333333333333312e-03*G6_1_0_7_2_3_10_1 + 8.333333333333312e-03*G6_1_0_7_2_3_11_2 - 8.333333333333309e-03*G6_1_1_4_0_4_8_0 - 8.333333333333309e-03*G6_1_1_4_0_4_8_1 - 8.333333333333311e-03*G6_1_1_4_0_4_8_2 + 8.333333333333309e-03*G6_1_1_4_0_4_9_0 + 8.333333333333309e-03*G6_1_1_4_0_4_10_1 + 8.333333333333309e-03*G6_1_1_4_0_4_11_2 - 4.166666666666654e-03*G6_1_1_4_0_5_8_0 - 4.166666666666654e-03*G6_1_1_4_0_5_8_1 - 4.166666666666654e-03*G6_1_1_4_0_5_8_2 + 4.166666666666654e-03*G6_1_1_4_0_5_9_0 + 4.166666666666654e-03*G6_1_1_4_0_5_10_1 + 4.166666666666654e-03*G6_1_1_4_0_5_11_2 - 4.166666666666653e-03*G6_1_1_4_0_6_8_0 - 4.166666666666654e-03*G6_1_1_4_0_6_8_1 - 4.166666666666654e-03*G6_1_1_4_0_6_8_2 + 4.166666666666653e-03*G6_1_1_4_0_6_9_0 + 4.166666666666654e-03*G6_1_1_4_0_6_10_1 + 4.166666666666654e-03*G6_1_1_4_0_6_11_2 - 4.166666666666654e-03*G6_1_1_4_0_7_8_0 - 4.166666666666656e-03*G6_1_1_4_0_7_8_1 - 4.166666666666657e-03*G6_1_1_4_0_7_8_2 + 4.166666666666654e-03*G6_1_1_4_0_7_9_0 + 4.166666666666656e-03*G6_1_1_4_0_7_10_1 + 4.166666666666656e-03*G6_1_1_4_0_7_11_2 - 8.333333333333309e-03*G6_1_1_4_1_4_8_0 - 8.333333333333311e-03*G6_1_1_4_1_4_8_1 - 8.333333333333312e-03*G6_1_1_4_1_4_8_2 + 8.333333333333309e-03*G6_1_1_4_1_4_9_0 + 8.333333333333311e-03*G6_1_1_4_1_4_10_1 + 8.333333333333311e-03*G6_1_1_4_1_4_11_2 - 4.166666666666654e-03*G6_1_1_4_1_5_8_0 - 4.166666666666654e-03*G6_1_1_4_1_5_8_1 - 4.166666666666655e-03*G6_1_1_4_1_5_8_2 + 4.166666666666654e-03*G6_1_1_4_1_5_9_0 + 4.166666666666654e-03*G6_1_1_4_1_5_10_1 + 4.166666666666654e-03*G6_1_1_4_1_5_11_2 - 4.166666666666654e-03*G6_1_1_4_1_6_8_0 - 4.166666666666654e-03*G6_1_1_4_1_6_8_1 - 4.166666666666654e-03*G6_1_1_4_1_6_8_2 + 4.166666666666654e-03*G6_1_1_4_1_6_9_0 + 4.166666666666654e-03*G6_1_1_4_1_6_10_1 + 4.166666666666654e-03*G6_1_1_4_1_6_11_2 - 4.166666666666656e-03*G6_1_1_4_1_7_8_0 - 4.166666666666657e-03*G6_1_1_4_1_7_8_1 - 4.166666666666657e-03*G6_1_1_4_1_7_8_2 + 4.166666666666656e-03*G6_1_1_4_1_7_9_0 + 4.166666666666657e-03*G6_1_1_4_1_7_10_1 + 4.166666666666657e-03*G6_1_1_4_1_7_11_2 - 8.333333333333311e-03*G6_1_1_4_2_4_8_0 - 8.333333333333312e-03*G6_1_1_4_2_4_8_1 - 8.333333333333314e-03*G6_1_1_4_2_4_8_2 + 8.333333333333311e-03*G6_1_1_4_2_4_9_0 + 8.333333333333312e-03*G6_1_1_4_2_4_10_1 + 8.333333333333312e-03*G6_1_1_4_2_4_11_2 - 4.166666666666654e-03*G6_1_1_4_2_5_8_0 - 4.166666666666655e-03*G6_1_1_4_2_5_8_1 - 4.166666666666655e-03*G6_1_1_4_2_5_8_2 + 4.166666666666654e-03*G6_1_1_4_2_5_9_0 + 4.166666666666655e-03*G6_1_1_4_2_5_10_1 + 4.166666666666655e-03*G6_1_1_4_2_5_11_2 - 4.166666666666654e-03*G6_1_1_4_2_6_8_0 - 4.166666666666654e-03*G6_1_1_4_2_6_8_1 - 4.166666666666654e-03*G6_1_1_4_2_6_8_2 + 4.166666666666654e-03*G6_1_1_4_2_6_9_0 + 4.166666666666654e-03*G6_1_1_4_2_6_10_1 + 4.166666666666654e-03*G6_1_1_4_2_6_11_2 - 4.166666666666657e-03*G6_1_1_4_2_7_8_0 - 4.166666666666657e-03*G6_1_1_4_2_7_8_1 - 4.166666666666658e-03*G6_1_1_4_2_7_8_2 + 4.166666666666657e-03*G6_1_1_4_2_7_9_0 + 4.166666666666657e-03*G6_1_1_4_2_7_10_1 + 4.166666666666657e-03*G6_1_1_4_2_7_11_2 - 4.166666666666654e-03*G6_1_1_5_0_4_8_0 - 4.166666666666654e-03*G6_1_1_5_0_4_8_1 - 4.166666666666654e-03*G6_1_1_5_0_4_8_2 + 4.166666666666654e-03*G6_1_1_5_0_4_9_0 + 4.166666666666654e-03*G6_1_1_5_0_4_10_1 + 4.166666666666654e-03*G6_1_1_5_0_4_11_2 - 8.333333333333307e-03*G6_1_1_5_0_5_8_0 - 8.333333333333309e-03*G6_1_1_5_0_5_8_1 - 8.333333333333309e-03*G6_1_1_5_0_5_8_2 + 8.333333333333307e-03*G6_1_1_5_0_5_9_0 + 8.333333333333309e-03*G6_1_1_5_0_5_10_1 + 8.333333333333309e-03*G6_1_1_5_0_5_11_2 - 4.166666666666654e-03*G6_1_1_5_0_6_8_0 - 4.166666666666655e-03*G6_1_1_5_0_6_8_1 - 4.166666666666655e-03*G6_1_1_5_0_6_8_2 + 4.166666666666654e-03*G6_1_1_5_0_6_9_0 + 4.166666666666655e-03*G6_1_1_5_0_6_10_1 + 4.166666666666655e-03*G6_1_1_5_0_6_11_2 - 4.166666666666655e-03*G6_1_1_5_0_7_8_0 - 4.166666666666656e-03*G6_1_1_5_0_7_8_1 - 4.166666666666656e-03*G6_1_1_5_0_7_8_2 + 4.166666666666655e-03*G6_1_1_5_0_7_9_0 + 4.166666666666656e-03*G6_1_1_5_0_7_10_1 + 4.166666666666656e-03*G6_1_1_5_0_7_11_2 - 4.166666666666654e-03*G6_1_1_5_1_4_8_0 - 4.166666666666654e-03*G6_1_1_5_1_4_8_1 - 4.166666666666655e-03*G6_1_1_5_1_4_8_2 + 4.166666666666654e-03*G6_1_1_5_1_4_9_0 + 4.166666666666654e-03*G6_1_1_5_1_4_10_1 + 4.166666666666654e-03*G6_1_1_5_1_4_11_2 - 8.333333333333309e-03*G6_1_1_5_1_5_8_0 - 8.333333333333309e-03*G6_1_1_5_1_5_8_1 - 8.333333333333309e-03*G6_1_1_5_1_5_8_2 + 8.333333333333309e-03*G6_1_1_5_1_5_9_0 + 8.333333333333309e-03*G6_1_1_5_1_5_10_1 + 8.333333333333309e-03*G6_1_1_5_1_5_11_2 - 4.166666666666655e-03*G6_1_1_5_1_6_8_0 - 4.166666666666656e-03*G6_1_1_5_1_6_8_1 - 4.166666666666656e-03*G6_1_1_5_1_6_8_2 + 4.166666666666655e-03*G6_1_1_5_1_6_9_0 + 4.166666666666656e-03*G6_1_1_5_1_6_10_1 + 4.166666666666656e-03*G6_1_1_5_1_6_11_2 - 4.166666666666656e-03*G6_1_1_5_1_7_8_0 - 4.166666666666657e-03*G6_1_1_5_1_7_8_1 - 4.166666666666657e-03*G6_1_1_5_1_7_8_2 + 4.166666666666656e-03*G6_1_1_5_1_7_9_0 + 4.166666666666657e-03*G6_1_1_5_1_7_10_1 + 4.166666666666657e-03*G6_1_1_5_1_7_11_2 - 4.166666666666654e-03*G6_1_1_5_2_4_8_0 - 4.166666666666655e-03*G6_1_1_5_2_4_8_1 - 4.166666666666655e-03*G6_1_1_5_2_4_8_2 + 4.166666666666654e-03*G6_1_1_5_2_4_9_0 + 4.166666666666655e-03*G6_1_1_5_2_4_10_1 + 4.166666666666655e-03*G6_1_1_5_2_4_11_2 - 8.333333333333309e-03*G6_1_1_5_2_5_8_0 - 8.333333333333309e-03*G6_1_1_5_2_5_8_1 - 8.333333333333309e-03*G6_1_1_5_2_5_8_2 + 8.333333333333309e-03*G6_1_1_5_2_5_9_0 + 8.333333333333309e-03*G6_1_1_5_2_5_10_1 + 8.333333333333309e-03*G6_1_1_5_2_5_11_2 - 4.166666666666655e-03*G6_1_1_5_2_6_8_0 - 4.166666666666656e-03*G6_1_1_5_2_6_8_1 - 4.166666666666656e-03*G6_1_1_5_2_6_8_2 + 4.166666666666655e-03*G6_1_1_5_2_6_9_0 + 4.166666666666656e-03*G6_1_1_5_2_6_10_1 + 4.166666666666656e-03*G6_1_1_5_2_6_11_2 - 4.166666666666656e-03*G6_1_1_5_2_7_8_0 - 4.166666666666657e-03*G6_1_1_5_2_7_8_1 - 4.166666666666657e-03*G6_1_1_5_2_7_8_2 + 4.166666666666656e-03*G6_1_1_5_2_7_9_0 + 4.166666666666657e-03*G6_1_1_5_2_7_10_1 + 4.166666666666657e-03*G6_1_1_5_2_7_11_2 - 4.166666666666653e-03*G6_1_1_6_0_4_8_0 - 4.166666666666654e-03*G6_1_1_6_0_4_8_1 - 4.166666666666654e-03*G6_1_1_6_0_4_8_2 + 4.166666666666653e-03*G6_1_1_6_0_4_9_0 + 4.166666666666654e-03*G6_1_1_6_0_4_10_1 + 4.166666666666654e-03*G6_1_1_6_0_4_11_2 - 4.166666666666654e-03*G6_1_1_6_0_5_8_0 - 4.166666666666655e-03*G6_1_1_6_0_5_8_1 - 4.166666666666655e-03*G6_1_1_6_0_5_8_2 + 4.166666666666654e-03*G6_1_1_6_0_5_9_0 + 4.166666666666655e-03*G6_1_1_6_0_5_10_1 + 4.166666666666655e-03*G6_1_1_6_0_5_11_2 - 8.333333333333309e-03*G6_1_1_6_0_6_8_0 - 8.333333333333309e-03*G6_1_1_6_0_6_8_1 - 8.333333333333311e-03*G6_1_1_6_0_6_8_2 + 8.333333333333309e-03*G6_1_1_6_0_6_9_0 + 8.333333333333309e-03*G6_1_1_6_0_6_10_1 + 8.333333333333309e-03*G6_1_1_6_0_6_11_2 - 4.166666666666654e-03*G6_1_1_6_0_7_8_0 - 4.166666666666655e-03*G6_1_1_6_0_7_8_1 - 4.166666666666655e-03*G6_1_1_6_0_7_8_2 + 4.166666666666654e-03*G6_1_1_6_0_7_9_0 + 4.166666666666655e-03*G6_1_1_6_0_7_10_1 + 4.166666666666655e-03*G6_1_1_6_0_7_11_2 - 4.166666666666654e-03*G6_1_1_6_1_4_8_0 - 4.166666666666654e-03*G6_1_1_6_1_4_8_1 - 4.166666666666654e-03*G6_1_1_6_1_4_8_2 + 4.166666666666654e-03*G6_1_1_6_1_4_9_0 + 4.166666666666654e-03*G6_1_1_6_1_4_10_1 + 4.166666666666654e-03*G6_1_1_6_1_4_11_2 - 4.166666666666655e-03*G6_1_1_6_1_5_8_0 - 4.166666666666656e-03*G6_1_1_6_1_5_8_1 - 4.166666666666656e-03*G6_1_1_6_1_5_8_2 + 4.166666666666655e-03*G6_1_1_6_1_5_9_0 + 4.166666666666656e-03*G6_1_1_6_1_5_10_1 + 4.166666666666656e-03*G6_1_1_6_1_5_11_2 - 8.333333333333311e-03*G6_1_1_6_1_6_8_0 - 8.333333333333311e-03*G6_1_1_6_1_6_8_1 - 8.333333333333312e-03*G6_1_1_6_1_6_8_2 + 8.333333333333311e-03*G6_1_1_6_1_6_9_0 + 8.333333333333311e-03*G6_1_1_6_1_6_10_1 + 8.333333333333311e-03*G6_1_1_6_1_6_11_2 - 4.166666666666655e-03*G6_1_1_6_1_7_8_0 - 4.166666666666656e-03*G6_1_1_6_1_7_8_1 - 4.166666666666657e-03*G6_1_1_6_1_7_8_2 + 4.166666666666655e-03*G6_1_1_6_1_7_9_0 + 4.166666666666656e-03*G6_1_1_6_1_7_10_1 + 4.166666666666656e-03*G6_1_1_6_1_7_11_2 - 4.166666666666654e-03*G6_1_1_6_2_4_8_0 - 4.166666666666654e-03*G6_1_1_6_2_4_8_1 - 4.166666666666654e-03*G6_1_1_6_2_4_8_2 + 4.166666666666654e-03*G6_1_1_6_2_4_9_0 + 4.166666666666654e-03*G6_1_1_6_2_4_10_1 + 4.166666666666654e-03*G6_1_1_6_2_4_11_2 - 4.166666666666655e-03*G6_1_1_6_2_5_8_0 - 4.166666666666656e-03*G6_1_1_6_2_5_8_1 - 4.166666666666656e-03*G6_1_1_6_2_5_8_2 + 4.166666666666655e-03*G6_1_1_6_2_5_9_0 + 4.166666666666656e-03*G6_1_1_6_2_5_10_1 + 4.166666666666656e-03*G6_1_1_6_2_5_11_2 - 8.333333333333311e-03*G6_1_1_6_2_6_8_0 - 8.333333333333312e-03*G6_1_1_6_2_6_8_1 - 8.333333333333312e-03*G6_1_1_6_2_6_8_2 + 8.333333333333311e-03*G6_1_1_6_2_6_9_0 + 8.333333333333312e-03*G6_1_1_6_2_6_10_1 + 8.333333333333312e-03*G6_1_1_6_2_6_11_2 - 4.166666666666655e-03*G6_1_1_6_2_7_8_0 - 4.166666666666657e-03*G6_1_1_6_2_7_8_1 - 4.166666666666657e-03*G6_1_1_6_2_7_8_2 + 4.166666666666655e-03*G6_1_1_6_2_7_9_0 + 4.166666666666657e-03*G6_1_1_6_2_7_10_1 + 4.166666666666657e-03*G6_1_1_6_2_7_11_2 - 4.166666666666655e-03*G6_1_1_7_0_4_8_0 - 4.166666666666656e-03*G6_1_1_7_0_4_8_1 - 4.166666666666657e-03*G6_1_1_7_0_4_8_2 + 4.166666666666655e-03*G6_1_1_7_0_4_9_0 + 4.166666666666656e-03*G6_1_1_7_0_4_10_1 + 4.166666666666656e-03*G6_1_1_7_0_4_11_2 - 4.166666666666655e-03*G6_1_1_7_0_5_8_0 - 4.166666666666656e-03*G6_1_1_7_0_5_8_1 - 4.166666666666656e-03*G6_1_1_7_0_5_8_2 + 4.166666666666655e-03*G6_1_1_7_0_5_9_0 + 4.166666666666656e-03*G6_1_1_7_0_5_10_1 + 4.166666666666656e-03*G6_1_1_7_0_5_11_2 - 4.166666666666655e-03*G6_1_1_7_0_6_8_0 - 4.166666666666655e-03*G6_1_1_7_0_6_8_1 - 4.166666666666655e-03*G6_1_1_7_0_6_8_2 + 4.166666666666655e-03*G6_1_1_7_0_6_9_0 + 4.166666666666655e-03*G6_1_1_7_0_6_10_1 + 4.166666666666655e-03*G6_1_1_7_0_6_11_2 - 8.333333333333309e-03*G6_1_1_7_0_7_8_0 - 8.333333333333311e-03*G6_1_1_7_0_7_8_1 - 8.333333333333311e-03*G6_1_1_7_0_7_8_2 + 8.333333333333309e-03*G6_1_1_7_0_7_9_0 + 8.333333333333311e-03*G6_1_1_7_0_7_10_1 + 8.333333333333311e-03*G6_1_1_7_0_7_11_2 - 4.166666666666656e-03*G6_1_1_7_1_4_8_0 - 4.166666666666657e-03*G6_1_1_7_1_4_8_1 - 4.166666666666657e-03*G6_1_1_7_1_4_8_2 + 4.166666666666656e-03*G6_1_1_7_1_4_9_0 + 4.166666666666657e-03*G6_1_1_7_1_4_10_1 + 4.166666666666657e-03*G6_1_1_7_1_4_11_2 - 4.166666666666656e-03*G6_1_1_7_1_5_8_0 - 4.166666666666657e-03*G6_1_1_7_1_5_8_1 - 4.166666666666657e-03*G6_1_1_7_1_5_8_2 + 4.166666666666656e-03*G6_1_1_7_1_5_9_0 + 4.166666666666657e-03*G6_1_1_7_1_5_10_1 + 4.166666666666657e-03*G6_1_1_7_1_5_11_2 - 4.166666666666655e-03*G6_1_1_7_1_6_8_0 - 4.166666666666656e-03*G6_1_1_7_1_6_8_1 - 4.166666666666657e-03*G6_1_1_7_1_6_8_2 + 4.166666666666655e-03*G6_1_1_7_1_6_9_0 + 4.166666666666656e-03*G6_1_1_7_1_6_10_1 + 4.166666666666656e-03*G6_1_1_7_1_6_11_2 - 8.333333333333311e-03*G6_1_1_7_1_7_8_0 - 8.333333333333311e-03*G6_1_1_7_1_7_8_1 - 8.333333333333312e-03*G6_1_1_7_1_7_8_2 + 8.333333333333311e-03*G6_1_1_7_1_7_9_0 + 8.333333333333311e-03*G6_1_1_7_1_7_10_1 + 8.333333333333311e-03*G6_1_1_7_1_7_11_2 - 4.166666666666657e-03*G6_1_1_7_2_4_8_0 - 4.166666666666657e-03*G6_1_1_7_2_4_8_1 - 4.166666666666658e-03*G6_1_1_7_2_4_8_2 + 4.166666666666657e-03*G6_1_1_7_2_4_9_0 + 4.166666666666657e-03*G6_1_1_7_2_4_10_1 + 4.166666666666657e-03*G6_1_1_7_2_4_11_2 - 4.166666666666656e-03*G6_1_1_7_2_5_8_0 - 4.166666666666657e-03*G6_1_1_7_2_5_8_1 - 4.166666666666657e-03*G6_1_1_7_2_5_8_2 + 4.166666666666656e-03*G6_1_1_7_2_5_9_0 + 4.166666666666657e-03*G6_1_1_7_2_5_10_1 + 4.166666666666657e-03*G6_1_1_7_2_5_11_2 - 4.166666666666655e-03*G6_1_1_7_2_6_8_0 - 4.166666666666657e-03*G6_1_1_7_2_6_8_1 - 4.166666666666657e-03*G6_1_1_7_2_6_8_2 + 4.166666666666655e-03*G6_1_1_7_2_6_9_0 + 4.166666666666657e-03*G6_1_1_7_2_6_10_1 + 4.166666666666657e-03*G6_1_1_7_2_6_11_2 - 8.333333333333311e-03*G6_1_1_7_2_7_8_0 - 8.333333333333312e-03*G6_1_1_7_2_7_8_1 - 8.333333333333312e-03*G6_1_1_7_2_7_8_2 + 8.333333333333311e-03*G6_1_1_7_2_7_9_0 + 8.333333333333312e-03*G6_1_1_7_2_7_10_1 + 8.333333333333312e-03*G6_1_1_7_2_7_11_2 - 8.333333333333309e-03*G6_1_2_4_0_8_8_0 - 8.333333333333309e-03*G6_1_2_4_0_8_8_1 - 8.333333333333311e-03*G6_1_2_4_0_8_8_2 + 8.333333333333309e-03*G6_1_2_4_0_8_9_0 + 8.333333333333309e-03*G6_1_2_4_0_8_10_1 + 8.333333333333309e-03*G6_1_2_4_0_8_11_2 - 4.166666666666654e-03*G6_1_2_4_0_9_8_0 - 4.166666666666654e-03*G6_1_2_4_0_9_8_1 - 4.166666666666654e-03*G6_1_2_4_0_9_8_2 + 4.166666666666654e-03*G6_1_2_4_0_9_9_0 + 4.166666666666654e-03*G6_1_2_4_0_9_10_1 + 4.166666666666654e-03*G6_1_2_4_0_9_11_2 - 4.166666666666653e-03*G6_1_2_4_0_10_8_0 - 4.166666666666654e-03*G6_1_2_4_0_10_8_1 - 4.166666666666654e-03*G6_1_2_4_0_10_8_2 + 4.166666666666653e-03*G6_1_2_4_0_10_9_0 + 4.166666666666654e-03*G6_1_2_4_0_10_10_1 + 4.166666666666654e-03*G6_1_2_4_0_10_11_2 - 4.166666666666654e-03*G6_1_2_4_0_11_8_0 - 4.166666666666656e-03*G6_1_2_4_0_11_8_1 - 4.166666666666657e-03*G6_1_2_4_0_11_8_2 + 4.166666666666654e-03*G6_1_2_4_0_11_9_0 + 4.166666666666656e-03*G6_1_2_4_0_11_10_1 + 4.166666666666656e-03*G6_1_2_4_0_11_11_2 - 8.333333333333309e-03*G6_1_2_4_1_8_8_0 - 8.333333333333311e-03*G6_1_2_4_1_8_8_1 - 8.333333333333312e-03*G6_1_2_4_1_8_8_2 + 8.333333333333309e-03*G6_1_2_4_1_8_9_0 + 8.333333333333311e-03*G6_1_2_4_1_8_10_1 + 8.333333333333311e-03*G6_1_2_4_1_8_11_2 - 4.166666666666654e-03*G6_1_2_4_1_9_8_0 - 4.166666666666654e-03*G6_1_2_4_1_9_8_1 - 4.166666666666655e-03*G6_1_2_4_1_9_8_2 + 4.166666666666654e-03*G6_1_2_4_1_9_9_0 + 4.166666666666654e-03*G6_1_2_4_1_9_10_1 + 4.166666666666654e-03*G6_1_2_4_1_9_11_2 - 4.166666666666654e-03*G6_1_2_4_1_10_8_0 - 4.166666666666654e-03*G6_1_2_4_1_10_8_1 - 4.166666666666654e-03*G6_1_2_4_1_10_8_2 + 4.166666666666654e-03*G6_1_2_4_1_10_9_0 + 4.166666666666654e-03*G6_1_2_4_1_10_10_1 + 4.166666666666654e-03*G6_1_2_4_1_10_11_2 - 4.166666666666656e-03*G6_1_2_4_1_11_8_0 - 4.166666666666657e-03*G6_1_2_4_1_11_8_1 - 4.166666666666657e-03*G6_1_2_4_1_11_8_2 + 4.166666666666656e-03*G6_1_2_4_1_11_9_0 + 4.166666666666657e-03*G6_1_2_4_1_11_10_1 + 4.166666666666657e-03*G6_1_2_4_1_11_11_2 - 8.333333333333311e-03*G6_1_2_4_2_8_8_0 - 8.333333333333312e-03*G6_1_2_4_2_8_8_1 - 8.333333333333314e-03*G6_1_2_4_2_8_8_2 + 8.333333333333311e-03*G6_1_2_4_2_8_9_0 + 8.333333333333312e-03*G6_1_2_4_2_8_10_1 + 8.333333333333312e-03*G6_1_2_4_2_8_11_2 - 4.166666666666654e-03*G6_1_2_4_2_9_8_0 - 4.166666666666655e-03*G6_1_2_4_2_9_8_1 - 4.166666666666655e-03*G6_1_2_4_2_9_8_2 + 4.166666666666654e-03*G6_1_2_4_2_9_9_0 + 4.166666666666655e-03*G6_1_2_4_2_9_10_1 + 4.166666666666655e-03*G6_1_2_4_2_9_11_2 - 4.166666666666654e-03*G6_1_2_4_2_10_8_0 - 4.166666666666654e-03*G6_1_2_4_2_10_8_1 - 4.166666666666654e-03*G6_1_2_4_2_10_8_2 + 4.166666666666654e-03*G6_1_2_4_2_10_9_0 + 4.166666666666654e-03*G6_1_2_4_2_10_10_1 + 4.166666666666654e-03*G6_1_2_4_2_10_11_2 - 4.166666666666657e-03*G6_1_2_4_2_11_8_0 - 4.166666666666657e-03*G6_1_2_4_2_11_8_1 - 4.166666666666658e-03*G6_1_2_4_2_11_8_2 + 4.166666666666657e-03*G6_1_2_4_2_11_9_0 + 4.166666666666657e-03*G6_1_2_4_2_11_10_1 + 4.166666666666657e-03*G6_1_2_4_2_11_11_2 - 4.166666666666654e-03*G6_1_2_5_0_8_8_0 - 4.166666666666654e-03*G6_1_2_5_0_8_8_1 - 4.166666666666654e-03*G6_1_2_5_0_8_8_2 + 4.166666666666654e-03*G6_1_2_5_0_8_9_0 + 4.166666666666654e-03*G6_1_2_5_0_8_10_1 + 4.166666666666654e-03*G6_1_2_5_0_8_11_2 - 8.333333333333307e-03*G6_1_2_5_0_9_8_0 - 8.333333333333309e-03*G6_1_2_5_0_9_8_1 - 8.333333333333309e-03*G6_1_2_5_0_9_8_2 + 8.333333333333307e-03*G6_1_2_5_0_9_9_0 + 8.333333333333309e-03*G6_1_2_5_0_9_10_1 + 8.333333333333309e-03*G6_1_2_5_0_9_11_2 - 4.166666666666654e-03*G6_1_2_5_0_10_8_0 - 4.166666666666655e-03*G6_1_2_5_0_10_8_1 - 4.166666666666655e-03*G6_1_2_5_0_10_8_2 + 4.166666666666654e-03*G6_1_2_5_0_10_9_0 + 4.166666666666655e-03*G6_1_2_5_0_10_10_1 + 4.166666666666655e-03*G6_1_2_5_0_10_11_2 - 4.166666666666655e-03*G6_1_2_5_0_11_8_0 - 4.166666666666656e-03*G6_1_2_5_0_11_8_1 - 4.166666666666656e-03*G6_1_2_5_0_11_8_2 + 4.166666666666655e-03*G6_1_2_5_0_11_9_0 + 4.166666666666656e-03*G6_1_2_5_0_11_10_1 + 4.166666666666656e-03*G6_1_2_5_0_11_11_2 - 4.166666666666654e-03*G6_1_2_5_1_8_8_0 - 4.166666666666654e-03*G6_1_2_5_1_8_8_1 - 4.166666666666655e-03*G6_1_2_5_1_8_8_2 + 4.166666666666654e-03*G6_1_2_5_1_8_9_0 + 4.166666666666654e-03*G6_1_2_5_1_8_10_1 + 4.166666666666654e-03*G6_1_2_5_1_8_11_2 - 8.333333333333309e-03*G6_1_2_5_1_9_8_0 - 8.333333333333309e-03*G6_1_2_5_1_9_8_1 - 8.333333333333309e-03*G6_1_2_5_1_9_8_2 + 8.333333333333309e-03*G6_1_2_5_1_9_9_0 + 8.333333333333309e-03*G6_1_2_5_1_9_10_1 + 8.333333333333309e-03*G6_1_2_5_1_9_11_2 - 4.166666666666655e-03*G6_1_2_5_1_10_8_0 - 4.166666666666656e-03*G6_1_2_5_1_10_8_1 - 4.166666666666656e-03*G6_1_2_5_1_10_8_2 + 4.166666666666655e-03*G6_1_2_5_1_10_9_0 + 4.166666666666656e-03*G6_1_2_5_1_10_10_1 + 4.166666666666656e-03*G6_1_2_5_1_10_11_2 - 4.166666666666656e-03*G6_1_2_5_1_11_8_0 - 4.166666666666657e-03*G6_1_2_5_1_11_8_1 - 4.166666666666657e-03*G6_1_2_5_1_11_8_2 + 4.166666666666656e-03*G6_1_2_5_1_11_9_0 + 4.166666666666657e-03*G6_1_2_5_1_11_10_1 + 4.166666666666657e-03*G6_1_2_5_1_11_11_2 - 4.166666666666654e-03*G6_1_2_5_2_8_8_0 - 4.166666666666655e-03*G6_1_2_5_2_8_8_1 - 4.166666666666655e-03*G6_1_2_5_2_8_8_2 + 4.166666666666654e-03*G6_1_2_5_2_8_9_0 + 4.166666666666655e-03*G6_1_2_5_2_8_10_1 + 4.166666666666655e-03*G6_1_2_5_2_8_11_2 - 8.333333333333309e-03*G6_1_2_5_2_9_8_0 - 8.333333333333309e-03*G6_1_2_5_2_9_8_1 - 8.333333333333309e-03*G6_1_2_5_2_9_8_2 + 8.333333333333309e-03*G6_1_2_5_2_9_9_0 + 8.333333333333309e-03*G6_1_2_5_2_9_10_1 + 8.333333333333309e-03*G6_1_2_5_2_9_11_2 - 4.166666666666655e-03*G6_1_2_5_2_10_8_0 - 4.166666666666656e-03*G6_1_2_5_2_10_8_1 - 4.166666666666656e-03*G6_1_2_5_2_10_8_2 + 4.166666666666655e-03*G6_1_2_5_2_10_9_0 + 4.166666666666656e-03*G6_1_2_5_2_10_10_1 + 4.166666666666656e-03*G6_1_2_5_2_10_11_2 - 4.166666666666656e-03*G6_1_2_5_2_11_8_0 - 4.166666666666657e-03*G6_1_2_5_2_11_8_1 - 4.166666666666657e-03*G6_1_2_5_2_11_8_2 + 4.166666666666656e-03*G6_1_2_5_2_11_9_0 + 4.166666666666657e-03*G6_1_2_5_2_11_10_1 + 4.166666666666657e-03*G6_1_2_5_2_11_11_2 - 4.166666666666653e-03*G6_1_2_6_0_8_8_0 - 4.166666666666654e-03*G6_1_2_6_0_8_8_1 - 4.166666666666654e-03*G6_1_2_6_0_8_8_2 + 4.166666666666653e-03*G6_1_2_6_0_8_9_0 + 4.166666666666654e-03*G6_1_2_6_0_8_10_1 + 4.166666666666654e-03*G6_1_2_6_0_8_11_2 - 4.166666666666654e-03*G6_1_2_6_0_9_8_0 - 4.166666666666655e-03*G6_1_2_6_0_9_8_1 - 4.166666666666655e-03*G6_1_2_6_0_9_8_2 + 4.166666666666654e-03*G6_1_2_6_0_9_9_0 + 4.166666666666655e-03*G6_1_2_6_0_9_10_1 + 4.166666666666655e-03*G6_1_2_6_0_9_11_2 - 8.333333333333309e-03*G6_1_2_6_0_10_8_0 - 8.333333333333309e-03*G6_1_2_6_0_10_8_1 - 8.333333333333311e-03*G6_1_2_6_0_10_8_2 + 8.333333333333309e-03*G6_1_2_6_0_10_9_0 + 8.333333333333309e-03*G6_1_2_6_0_10_10_1 + 8.333333333333309e-03*G6_1_2_6_0_10_11_2 - 4.166666666666654e-03*G6_1_2_6_0_11_8_0 - 4.166666666666655e-03*G6_1_2_6_0_11_8_1 - 4.166666666666655e-03*G6_1_2_6_0_11_8_2 + 4.166666666666654e-03*G6_1_2_6_0_11_9_0 + 4.166666666666655e-03*G6_1_2_6_0_11_10_1 + 4.166666666666655e-03*G6_1_2_6_0_11_11_2 - 4.166666666666654e-03*G6_1_2_6_1_8_8_0 - 4.166666666666654e-03*G6_1_2_6_1_8_8_1 - 4.166666666666654e-03*G6_1_2_6_1_8_8_2 + 4.166666666666654e-03*G6_1_2_6_1_8_9_0 + 4.166666666666654e-03*G6_1_2_6_1_8_10_1 + 4.166666666666654e-03*G6_1_2_6_1_8_11_2 - 4.166666666666655e-03*G6_1_2_6_1_9_8_0 - 4.166666666666656e-03*G6_1_2_6_1_9_8_1 - 4.166666666666656e-03*G6_1_2_6_1_9_8_2 + 4.166666666666655e-03*G6_1_2_6_1_9_9_0 + 4.166666666666656e-03*G6_1_2_6_1_9_10_1 + 4.166666666666656e-03*G6_1_2_6_1_9_11_2 - 8.333333333333311e-03*G6_1_2_6_1_10_8_0 - 8.333333333333311e-03*G6_1_2_6_1_10_8_1 - 8.333333333333312e-03*G6_1_2_6_1_10_8_2 + 8.333333333333311e-03*G6_1_2_6_1_10_9_0 + 8.333333333333311e-03*G6_1_2_6_1_10_10_1 + 8.333333333333311e-03*G6_1_2_6_1_10_11_2 - 4.166666666666655e-03*G6_1_2_6_1_11_8_0 - 4.166666666666656e-03*G6_1_2_6_1_11_8_1 - 4.166666666666657e-03*G6_1_2_6_1_11_8_2 + 4.166666666666655e-03*G6_1_2_6_1_11_9_0 + 4.166666666666656e-03*G6_1_2_6_1_11_10_1 + 4.166666666666656e-03*G6_1_2_6_1_11_11_2 - 4.166666666666654e-03*G6_1_2_6_2_8_8_0 - 4.166666666666654e-03*G6_1_2_6_2_8_8_1 - 4.166666666666654e-03*G6_1_2_6_2_8_8_2 + 4.166666666666654e-03*G6_1_2_6_2_8_9_0 + 4.166666666666654e-03*G6_1_2_6_2_8_10_1 + 4.166666666666654e-03*G6_1_2_6_2_8_11_2 - 4.166666666666655e-03*G6_1_2_6_2_9_8_0 - 4.166666666666656e-03*G6_1_2_6_2_9_8_1 - 4.166666666666656e-03*G6_1_2_6_2_9_8_2 + 4.166666666666655e-03*G6_1_2_6_2_9_9_0 + 4.166666666666656e-03*G6_1_2_6_2_9_10_1 + 4.166666666666656e-03*G6_1_2_6_2_9_11_2 - 8.333333333333311e-03*G6_1_2_6_2_10_8_0 - 8.333333333333312e-03*G6_1_2_6_2_10_8_1 - 8.333333333333312e-03*G6_1_2_6_2_10_8_2 + 8.333333333333311e-03*G6_1_2_6_2_10_9_0 + 8.333333333333312e-03*G6_1_2_6_2_10_10_1 + 8.333333333333312e-03*G6_1_2_6_2_10_11_2 - 4.166666666666655e-03*G6_1_2_6_2_11_8_0 - 4.166666666666657e-03*G6_1_2_6_2_11_8_1 - 4.166666666666657e-03*G6_1_2_6_2_11_8_2 + 4.166666666666655e-03*G6_1_2_6_2_11_9_0 + 4.166666666666657e-03*G6_1_2_6_2_11_10_1 + 4.166666666666657e-03*G6_1_2_6_2_11_11_2 - 4.166666666666655e-03*G6_1_2_7_0_8_8_0 - 4.166666666666656e-03*G6_1_2_7_0_8_8_1 - 4.166666666666657e-03*G6_1_2_7_0_8_8_2 + 4.166666666666655e-03*G6_1_2_7_0_8_9_0 + 4.166666666666656e-03*G6_1_2_7_0_8_10_1 + 4.166666666666656e-03*G6_1_2_7_0_8_11_2 - 4.166666666666655e-03*G6_1_2_7_0_9_8_0 - 4.166666666666656e-03*G6_1_2_7_0_9_8_1 - 4.166666666666656e-03*G6_1_2_7_0_9_8_2 + 4.166666666666655e-03*G6_1_2_7_0_9_9_0 + 4.166666666666656e-03*G6_1_2_7_0_9_10_1 + 4.166666666666656e-03*G6_1_2_7_0_9_11_2 - 4.166666666666655e-03*G6_1_2_7_0_10_8_0 - 4.166666666666655e-03*G6_1_2_7_0_10_8_1 - 4.166666666666655e-03*G6_1_2_7_0_10_8_2 + 4.166666666666655e-03*G6_1_2_7_0_10_9_0 + 4.166666666666655e-03*G6_1_2_7_0_10_10_1 + 4.166666666666655e-03*G6_1_2_7_0_10_11_2 - 8.333333333333309e-03*G6_1_2_7_0_11_8_0 - 8.333333333333311e-03*G6_1_2_7_0_11_8_1 - 8.333333333333311e-03*G6_1_2_7_0_11_8_2 + 8.333333333333309e-03*G6_1_2_7_0_11_9_0 + 8.333333333333311e-03*G6_1_2_7_0_11_10_1 + 8.333333333333311e-03*G6_1_2_7_0_11_11_2 - 4.166666666666656e-03*G6_1_2_7_1_8_8_0 - 4.166666666666657e-03*G6_1_2_7_1_8_8_1 - 4.166666666666657e-03*G6_1_2_7_1_8_8_2 + 4.166666666666656e-03*G6_1_2_7_1_8_9_0 + 4.166666666666657e-03*G6_1_2_7_1_8_10_1 + 4.166666666666657e-03*G6_1_2_7_1_8_11_2 - 4.166666666666656e-03*G6_1_2_7_1_9_8_0 - 4.166666666666657e-03*G6_1_2_7_1_9_8_1 - 4.166666666666657e-03*G6_1_2_7_1_9_8_2 + 4.166666666666656e-03*G6_1_2_7_1_9_9_0 + 4.166666666666657e-03*G6_1_2_7_1_9_10_1 + 4.166666666666657e-03*G6_1_2_7_1_9_11_2 - 4.166666666666655e-03*G6_1_2_7_1_10_8_0 - 4.166666666666656e-03*G6_1_2_7_1_10_8_1 - 4.166666666666657e-03*G6_1_2_7_1_10_8_2 + 4.166666666666655e-03*G6_1_2_7_1_10_9_0 + 4.166666666666656e-03*G6_1_2_7_1_10_10_1 + 4.166666666666656e-03*G6_1_2_7_1_10_11_2 - 8.333333333333311e-03*G6_1_2_7_1_11_8_0 - 8.333333333333311e-03*G6_1_2_7_1_11_8_1 - 8.333333333333312e-03*G6_1_2_7_1_11_8_2 + 8.333333333333311e-03*G6_1_2_7_1_11_9_0 + 8.333333333333311e-03*G6_1_2_7_1_11_10_1 + 8.333333333333311e-03*G6_1_2_7_1_11_11_2 - 4.166666666666657e-03*G6_1_2_7_2_8_8_0 - 4.166666666666657e-03*G6_1_2_7_2_8_8_1 - 4.166666666666658e-03*G6_1_2_7_2_8_8_2 + 4.166666666666657e-03*G6_1_2_7_2_8_9_0 + 4.166666666666657e-03*G6_1_2_7_2_8_10_1 + 4.166666666666657e-03*G6_1_2_7_2_8_11_2 - 4.166666666666656e-03*G6_1_2_7_2_9_8_0 - 4.166666666666657e-03*G6_1_2_7_2_9_8_1 - 4.166666666666657e-03*G6_1_2_7_2_9_8_2 + 4.166666666666656e-03*G6_1_2_7_2_9_9_0 + 4.166666666666657e-03*G6_1_2_7_2_9_10_1 + 4.166666666666657e-03*G6_1_2_7_2_9_11_2 - 4.166666666666655e-03*G6_1_2_7_2_10_8_0 - 4.166666666666657e-03*G6_1_2_7_2_10_8_1 - 4.166666666666657e-03*G6_1_2_7_2_10_8_2 + 4.166666666666655e-03*G6_1_2_7_2_10_9_0 + 4.166666666666657e-03*G6_1_2_7_2_10_10_1 + 4.166666666666657e-03*G6_1_2_7_2_10_11_2 - 8.333333333333311e-03*G6_1_2_7_2_11_8_0 - 8.333333333333312e-03*G6_1_2_7_2_11_8_1 - 8.333333333333312e-03*G6_1_2_7_2_11_8_2 + 8.333333333333311e-03*G6_1_2_7_2_11_9_0 + 8.333333333333312e-03*G6_1_2_7_2_11_10_1 + 8.333333333333312e-03*G6_1_2_7_2_11_11_2 - 8.333333333333309e-03*G6_2_0_8_0_0_8_0 - 8.333333333333309e-03*G6_2_0_8_0_0_8_1 - 8.333333333333311e-03*G6_2_0_8_0_0_8_2 + 8.333333333333309e-03*G6_2_0_8_0_0_9_0 + 8.333333333333309e-03*G6_2_0_8_0_0_10_1 + 8.333333333333309e-03*G6_2_0_8_0_0_11_2 - 4.166666666666654e-03*G6_2_0_8_0_1_8_0 - 4.166666666666654e-03*G6_2_0_8_0_1_8_1 - 4.166666666666654e-03*G6_2_0_8_0_1_8_2 + 4.166666666666654e-03*G6_2_0_8_0_1_9_0 + 4.166666666666654e-03*G6_2_0_8_0_1_10_1 + 4.166666666666654e-03*G6_2_0_8_0_1_11_2 - 4.166666666666653e-03*G6_2_0_8_0_2_8_0 - 4.166666666666654e-03*G6_2_0_8_0_2_8_1 - 4.166666666666654e-03*G6_2_0_8_0_2_8_2 + 4.166666666666653e-03*G6_2_0_8_0_2_9_0 + 4.166666666666654e-03*G6_2_0_8_0_2_10_1 + 4.166666666666654e-03*G6_2_0_8_0_2_11_2 - 4.166666666666654e-03*G6_2_0_8_0_3_8_0 - 4.166666666666656e-03*G6_2_0_8_0_3_8_1 - 4.166666666666657e-03*G6_2_0_8_0_3_8_2 + 4.166666666666654e-03*G6_2_0_8_0_3_9_0 + 4.166666666666656e-03*G6_2_0_8_0_3_10_1 + 4.166666666666656e-03*G6_2_0_8_0_3_11_2 - 8.333333333333309e-03*G6_2_0_8_1_0_8_0 - 8.333333333333311e-03*G6_2_0_8_1_0_8_1 - 8.333333333333312e-03*G6_2_0_8_1_0_8_2 + 8.333333333333309e-03*G6_2_0_8_1_0_9_0 + 8.333333333333311e-03*G6_2_0_8_1_0_10_1 + 8.333333333333311e-03*G6_2_0_8_1_0_11_2 - 4.166666666666654e-03*G6_2_0_8_1_1_8_0 - 4.166666666666654e-03*G6_2_0_8_1_1_8_1 - 4.166666666666654e-03*G6_2_0_8_1_1_8_2 + 4.166666666666654e-03*G6_2_0_8_1_1_9_0 + 4.166666666666654e-03*G6_2_0_8_1_1_10_1 + 4.166666666666654e-03*G6_2_0_8_1_1_11_2 - 4.166666666666654e-03*G6_2_0_8_1_2_8_0 - 4.166666666666654e-03*G6_2_0_8_1_2_8_1 - 4.166666666666654e-03*G6_2_0_8_1_2_8_2 + 4.166666666666654e-03*G6_2_0_8_1_2_9_0 + 4.166666666666654e-03*G6_2_0_8_1_2_10_1 + 4.166666666666654e-03*G6_2_0_8_1_2_11_2 - 4.166666666666656e-03*G6_2_0_8_1_3_8_0 - 4.166666666666657e-03*G6_2_0_8_1_3_8_1 - 4.166666666666657e-03*G6_2_0_8_1_3_8_2 + 4.166666666666656e-03*G6_2_0_8_1_3_9_0 + 4.166666666666657e-03*G6_2_0_8_1_3_10_1 + 4.166666666666657e-03*G6_2_0_8_1_3_11_2 - 8.333333333333311e-03*G6_2_0_8_2_0_8_0 - 8.333333333333312e-03*G6_2_0_8_2_0_8_1 - 8.333333333333314e-03*G6_2_0_8_2_0_8_2 + 8.333333333333311e-03*G6_2_0_8_2_0_9_0 + 8.333333333333312e-03*G6_2_0_8_2_0_10_1 + 8.333333333333312e-03*G6_2_0_8_2_0_11_2 - 4.166666666666654e-03*G6_2_0_8_2_1_8_0 - 4.166666666666654e-03*G6_2_0_8_2_1_8_1 - 4.166666666666655e-03*G6_2_0_8_2_1_8_2 + 4.166666666666654e-03*G6_2_0_8_2_1_9_0 + 4.166666666666654e-03*G6_2_0_8_2_1_10_1 + 4.166666666666654e-03*G6_2_0_8_2_1_11_2 - 4.166666666666654e-03*G6_2_0_8_2_2_8_0 - 4.166666666666654e-03*G6_2_0_8_2_2_8_1 - 4.166666666666654e-03*G6_2_0_8_2_2_8_2 + 4.166666666666654e-03*G6_2_0_8_2_2_9_0 + 4.166666666666654e-03*G6_2_0_8_2_2_10_1 + 4.166666666666654e-03*G6_2_0_8_2_2_11_2 - 4.166666666666657e-03*G6_2_0_8_2_3_8_0 - 4.166666666666657e-03*G6_2_0_8_2_3_8_1 - 4.166666666666658e-03*G6_2_0_8_2_3_8_2 + 4.166666666666657e-03*G6_2_0_8_2_3_9_0 + 4.166666666666657e-03*G6_2_0_8_2_3_10_1 + 4.166666666666657e-03*G6_2_0_8_2_3_11_2 - 4.166666666666654e-03*G6_2_0_9_0_0_8_0 - 4.166666666666655e-03*G6_2_0_9_0_0_8_1 - 4.166666666666655e-03*G6_2_0_9_0_0_8_2 + 4.166666666666654e-03*G6_2_0_9_0_0_9_0 + 4.166666666666655e-03*G6_2_0_9_0_0_10_1 + 4.166666666666655e-03*G6_2_0_9_0_0_11_2 - 8.333333333333307e-03*G6_2_0_9_0_1_8_0 - 8.333333333333309e-03*G6_2_0_9_0_1_8_1 - 8.333333333333309e-03*G6_2_0_9_0_1_8_2 + 8.333333333333307e-03*G6_2_0_9_0_1_9_0 + 8.333333333333309e-03*G6_2_0_9_0_1_10_1 + 8.333333333333309e-03*G6_2_0_9_0_1_11_2 - 4.166666666666654e-03*G6_2_0_9_0_2_8_0 - 4.166666666666655e-03*G6_2_0_9_0_2_8_1 - 4.166666666666655e-03*G6_2_0_9_0_2_8_2 + 4.166666666666654e-03*G6_2_0_9_0_2_9_0 + 4.166666666666655e-03*G6_2_0_9_0_2_10_1 + 4.166666666666655e-03*G6_2_0_9_0_2_11_2 - 4.166666666666655e-03*G6_2_0_9_0_3_8_0 - 4.166666666666656e-03*G6_2_0_9_0_3_8_1 - 4.166666666666656e-03*G6_2_0_9_0_3_8_2 + 4.166666666666655e-03*G6_2_0_9_0_3_9_0 + 4.166666666666656e-03*G6_2_0_9_0_3_10_1 + 4.166666666666656e-03*G6_2_0_9_0_3_11_2 - 4.166666666666655e-03*G6_2_0_9_1_0_8_0 - 4.166666666666655e-03*G6_2_0_9_1_0_8_1 - 4.166666666666656e-03*G6_2_0_9_1_0_8_2 + 4.166666666666655e-03*G6_2_0_9_1_0_9_0 + 4.166666666666655e-03*G6_2_0_9_1_0_10_1 + 4.166666666666655e-03*G6_2_0_9_1_0_11_2 - 8.333333333333309e-03*G6_2_0_9_1_1_8_0 - 8.333333333333309e-03*G6_2_0_9_1_1_8_1 - 8.333333333333309e-03*G6_2_0_9_1_1_8_2 + 8.333333333333309e-03*G6_2_0_9_1_1_9_0 + 8.333333333333309e-03*G6_2_0_9_1_1_10_1 + 8.333333333333309e-03*G6_2_0_9_1_1_11_2 - 4.166666666666655e-03*G6_2_0_9_1_2_8_0 - 4.166666666666656e-03*G6_2_0_9_1_2_8_1 - 4.166666666666656e-03*G6_2_0_9_1_2_8_2 + 4.166666666666655e-03*G6_2_0_9_1_2_9_0 + 4.166666666666656e-03*G6_2_0_9_1_2_10_1 + 4.166666666666656e-03*G6_2_0_9_1_2_11_2 - 4.166666666666656e-03*G6_2_0_9_1_3_8_0 - 4.166666666666657e-03*G6_2_0_9_1_3_8_1 - 4.166666666666657e-03*G6_2_0_9_1_3_8_2 + 4.166666666666656e-03*G6_2_0_9_1_3_9_0 + 4.166666666666657e-03*G6_2_0_9_1_3_10_1 + 4.166666666666657e-03*G6_2_0_9_1_3_11_2 - 4.166666666666655e-03*G6_2_0_9_2_0_8_0 - 4.166666666666656e-03*G6_2_0_9_2_0_8_1 - 4.166666666666657e-03*G6_2_0_9_2_0_8_2 + 4.166666666666655e-03*G6_2_0_9_2_0_9_0 + 4.166666666666656e-03*G6_2_0_9_2_0_10_1 + 4.166666666666656e-03*G6_2_0_9_2_0_11_2 - 8.333333333333309e-03*G6_2_0_9_2_1_8_0 - 8.333333333333309e-03*G6_2_0_9_2_1_8_1 - 8.333333333333309e-03*G6_2_0_9_2_1_8_2 + 8.333333333333309e-03*G6_2_0_9_2_1_9_0 + 8.333333333333309e-03*G6_2_0_9_2_1_10_1 + 8.333333333333309e-03*G6_2_0_9_2_1_11_2 - 4.166666666666655e-03*G6_2_0_9_2_2_8_0 - 4.166666666666656e-03*G6_2_0_9_2_2_8_1 - 4.166666666666656e-03*G6_2_0_9_2_2_8_2 + 4.166666666666655e-03*G6_2_0_9_2_2_9_0 + 4.166666666666656e-03*G6_2_0_9_2_2_10_1 + 4.166666666666656e-03*G6_2_0_9_2_2_11_2 - 4.166666666666656e-03*G6_2_0_9_2_3_8_0 - 4.166666666666657e-03*G6_2_0_9_2_3_8_1 - 4.166666666666657e-03*G6_2_0_9_2_3_8_2 + 4.166666666666656e-03*G6_2_0_9_2_3_9_0 + 4.166666666666657e-03*G6_2_0_9_2_3_10_1 + 4.166666666666657e-03*G6_2_0_9_2_3_11_2 - 4.166666666666654e-03*G6_2_0_10_0_0_8_0 - 4.166666666666654e-03*G6_2_0_10_0_0_8_1 - 4.166666666666655e-03*G6_2_0_10_0_0_8_2 + 4.166666666666654e-03*G6_2_0_10_0_0_9_0 + 4.166666666666654e-03*G6_2_0_10_0_0_10_1 + 4.166666666666654e-03*G6_2_0_10_0_0_11_2 - 4.166666666666654e-03*G6_2_0_10_0_1_8_0 - 4.166666666666654e-03*G6_2_0_10_0_1_8_1 - 4.166666666666654e-03*G6_2_0_10_0_1_8_2 + 4.166666666666654e-03*G6_2_0_10_0_1_9_0 + 4.166666666666654e-03*G6_2_0_10_0_1_10_1 + 4.166666666666654e-03*G6_2_0_10_0_1_11_2 - 8.333333333333309e-03*G6_2_0_10_0_2_8_0 - 8.333333333333309e-03*G6_2_0_10_0_2_8_1 - 8.333333333333311e-03*G6_2_0_10_0_2_8_2 + 8.333333333333309e-03*G6_2_0_10_0_2_9_0 + 8.333333333333309e-03*G6_2_0_10_0_2_10_1 + 8.333333333333309e-03*G6_2_0_10_0_2_11_2 - 4.166666666666654e-03*G6_2_0_10_0_3_8_0 - 4.166666666666655e-03*G6_2_0_10_0_3_8_1 - 4.166666666666655e-03*G6_2_0_10_0_3_8_2 + 4.166666666666654e-03*G6_2_0_10_0_3_9_0 + 4.166666666666655e-03*G6_2_0_10_0_3_10_1 + 4.166666666666655e-03*G6_2_0_10_0_3_11_2 - 4.166666666666654e-03*G6_2_0_10_1_0_8_0 - 4.166666666666656e-03*G6_2_0_10_1_0_8_1 - 4.166666666666656e-03*G6_2_0_10_1_0_8_2 + 4.166666666666654e-03*G6_2_0_10_1_0_9_0 + 4.166666666666656e-03*G6_2_0_10_1_0_10_1 + 4.166666666666656e-03*G6_2_0_10_1_0_11_2 - 4.166666666666654e-03*G6_2_0_10_1_1_8_0 - 4.166666666666654e-03*G6_2_0_10_1_1_8_1 - 4.166666666666654e-03*G6_2_0_10_1_1_8_2 + 4.166666666666654e-03*G6_2_0_10_1_1_9_0 + 4.166666666666654e-03*G6_2_0_10_1_1_10_1 + 4.166666666666654e-03*G6_2_0_10_1_1_11_2 - 8.333333333333311e-03*G6_2_0_10_1_2_8_0 - 8.333333333333311e-03*G6_2_0_10_1_2_8_1 - 8.333333333333312e-03*G6_2_0_10_1_2_8_2 + 8.333333333333311e-03*G6_2_0_10_1_2_9_0 + 8.333333333333311e-03*G6_2_0_10_1_2_10_1 + 8.333333333333311e-03*G6_2_0_10_1_2_11_2 - 4.166666666666655e-03*G6_2_0_10_1_3_8_0 - 4.166666666666656e-03*G6_2_0_10_1_3_8_1 - 4.166666666666657e-03*G6_2_0_10_1_3_8_2 + 4.166666666666655e-03*G6_2_0_10_1_3_9_0 + 4.166666666666656e-03*G6_2_0_10_1_3_10_1 + 4.166666666666656e-03*G6_2_0_10_1_3_11_2 - 4.166666666666655e-03*G6_2_0_10_2_0_8_0 - 4.166666666666656e-03*G6_2_0_10_2_0_8_1 - 4.166666666666656e-03*G6_2_0_10_2_0_8_2 + 4.166666666666655e-03*G6_2_0_10_2_0_9_0 + 4.166666666666656e-03*G6_2_0_10_2_0_10_1 + 4.166666666666656e-03*G6_2_0_10_2_0_11_2 - 4.166666666666654e-03*G6_2_0_10_2_1_8_0 - 4.166666666666654e-03*G6_2_0_10_2_1_8_1 - 4.166666666666655e-03*G6_2_0_10_2_1_8_2 + 4.166666666666654e-03*G6_2_0_10_2_1_9_0 + 4.166666666666654e-03*G6_2_0_10_2_1_10_1 + 4.166666666666654e-03*G6_2_0_10_2_1_11_2 - 8.333333333333311e-03*G6_2_0_10_2_2_8_0 - 8.333333333333312e-03*G6_2_0_10_2_2_8_1 - 8.333333333333312e-03*G6_2_0_10_2_2_8_2 + 8.333333333333311e-03*G6_2_0_10_2_2_9_0 + 8.333333333333312e-03*G6_2_0_10_2_2_10_1 + 8.333333333333312e-03*G6_2_0_10_2_2_11_2 - 4.166666666666655e-03*G6_2_0_10_2_3_8_0 - 4.166666666666657e-03*G6_2_0_10_2_3_8_1 - 4.166666666666657e-03*G6_2_0_10_2_3_8_2 + 4.166666666666655e-03*G6_2_0_10_2_3_9_0 + 4.166666666666657e-03*G6_2_0_10_2_3_10_1 + 4.166666666666657e-03*G6_2_0_10_2_3_11_2 - 4.166666666666656e-03*G6_2_0_11_0_0_8_0 - 4.166666666666656e-03*G6_2_0_11_0_0_8_1 - 4.166666666666657e-03*G6_2_0_11_0_0_8_2 + 4.166666666666656e-03*G6_2_0_11_0_0_9_0 + 4.166666666666656e-03*G6_2_0_11_0_0_10_1 + 4.166666666666656e-03*G6_2_0_11_0_0_11_2 - 4.166666666666654e-03*G6_2_0_11_0_1_8_0 - 4.166666666666655e-03*G6_2_0_11_0_1_8_1 - 4.166666666666655e-03*G6_2_0_11_0_1_8_2 + 4.166666666666654e-03*G6_2_0_11_0_1_9_0 + 4.166666666666655e-03*G6_2_0_11_0_1_10_1 + 4.166666666666655e-03*G6_2_0_11_0_1_11_2 - 4.166666666666655e-03*G6_2_0_11_0_2_8_0 - 4.166666666666655e-03*G6_2_0_11_0_2_8_1 - 4.166666666666655e-03*G6_2_0_11_0_2_8_2 + 4.166666666666655e-03*G6_2_0_11_0_2_9_0 + 4.166666666666655e-03*G6_2_0_11_0_2_10_1 + 4.166666666666655e-03*G6_2_0_11_0_2_11_2 - 8.333333333333309e-03*G6_2_0_11_0_3_8_0 - 8.333333333333311e-03*G6_2_0_11_0_3_8_1 - 8.333333333333311e-03*G6_2_0_11_0_3_8_2 + 8.333333333333309e-03*G6_2_0_11_0_3_9_0 + 8.333333333333311e-03*G6_2_0_11_0_3_10_1 + 8.333333333333311e-03*G6_2_0_11_0_3_11_2 - 4.166666666666656e-03*G6_2_0_11_1_0_8_0 - 4.166666666666657e-03*G6_2_0_11_1_0_8_1 - 4.166666666666658e-03*G6_2_0_11_1_0_8_2 + 4.166666666666656e-03*G6_2_0_11_1_0_9_0 + 4.166666666666657e-03*G6_2_0_11_1_0_10_1 + 4.166666666666657e-03*G6_2_0_11_1_0_11_2 - 4.166666666666655e-03*G6_2_0_11_1_1_8_0 - 4.166666666666655e-03*G6_2_0_11_1_1_8_1 - 4.166666666666656e-03*G6_2_0_11_1_1_8_2 + 4.166666666666655e-03*G6_2_0_11_1_1_9_0 + 4.166666666666655e-03*G6_2_0_11_1_1_10_1 + 4.166666666666655e-03*G6_2_0_11_1_1_11_2 - 4.166666666666655e-03*G6_2_0_11_1_2_8_0 - 4.166666666666656e-03*G6_2_0_11_1_2_8_1 - 4.166666666666657e-03*G6_2_0_11_1_2_8_2 + 4.166666666666655e-03*G6_2_0_11_1_2_9_0 + 4.166666666666656e-03*G6_2_0_11_1_2_10_1 + 4.166666666666656e-03*G6_2_0_11_1_2_11_2 - 8.333333333333311e-03*G6_2_0_11_1_3_8_0 - 8.333333333333311e-03*G6_2_0_11_1_3_8_1 - 8.333333333333312e-03*G6_2_0_11_1_3_8_2 + 8.333333333333311e-03*G6_2_0_11_1_3_9_0 + 8.333333333333311e-03*G6_2_0_11_1_3_10_1 + 8.333333333333311e-03*G6_2_0_11_1_3_11_2 - 4.166666666666657e-03*G6_2_0_11_2_0_8_0 - 4.166666666666658e-03*G6_2_0_11_2_0_8_1 - 4.166666666666659e-03*G6_2_0_11_2_0_8_2 + 4.166666666666657e-03*G6_2_0_11_2_0_9_0 + 4.166666666666658e-03*G6_2_0_11_2_0_10_1 + 4.166666666666658e-03*G6_2_0_11_2_0_11_2 - 4.166666666666655e-03*G6_2_0_11_2_1_8_0 - 4.166666666666656e-03*G6_2_0_11_2_1_8_1 - 4.166666666666656e-03*G6_2_0_11_2_1_8_2 + 4.166666666666655e-03*G6_2_0_11_2_1_9_0 + 4.166666666666656e-03*G6_2_0_11_2_1_10_1 + 4.166666666666656e-03*G6_2_0_11_2_1_11_2 - 4.166666666666655e-03*G6_2_0_11_2_2_8_0 - 4.166666666666657e-03*G6_2_0_11_2_2_8_1 - 4.166666666666657e-03*G6_2_0_11_2_2_8_2 + 4.166666666666655e-03*G6_2_0_11_2_2_9_0 + 4.166666666666657e-03*G6_2_0_11_2_2_10_1 + 4.166666666666657e-03*G6_2_0_11_2_2_11_2 - 8.333333333333311e-03*G6_2_0_11_2_3_8_0 - 8.333333333333312e-03*G6_2_0_11_2_3_8_1 - 8.333333333333312e-03*G6_2_0_11_2_3_8_2 + 8.333333333333311e-03*G6_2_0_11_2_3_9_0 + 8.333333333333312e-03*G6_2_0_11_2_3_10_1 + 8.333333333333312e-03*G6_2_0_11_2_3_11_2 - 8.333333333333309e-03*G6_2_1_8_0_4_8_0 - 8.333333333333309e-03*G6_2_1_8_0_4_8_1 - 8.333333333333311e-03*G6_2_1_8_0_4_8_2 + 8.333333333333309e-03*G6_2_1_8_0_4_9_0 + 8.333333333333309e-03*G6_2_1_8_0_4_10_1 + 8.333333333333309e-03*G6_2_1_8_0_4_11_2 - 4.166666666666654e-03*G6_2_1_8_0_5_8_0 - 4.166666666666654e-03*G6_2_1_8_0_5_8_1 - 4.166666666666654e-03*G6_2_1_8_0_5_8_2 + 4.166666666666654e-03*G6_2_1_8_0_5_9_0 + 4.166666666666654e-03*G6_2_1_8_0_5_10_1 + 4.166666666666654e-03*G6_2_1_8_0_5_11_2 - 4.166666666666653e-03*G6_2_1_8_0_6_8_0 - 4.166666666666654e-03*G6_2_1_8_0_6_8_1 - 4.166666666666654e-03*G6_2_1_8_0_6_8_2 + 4.166666666666653e-03*G6_2_1_8_0_6_9_0 + 4.166666666666654e-03*G6_2_1_8_0_6_10_1 + 4.166666666666654e-03*G6_2_1_8_0_6_11_2 - 4.166666666666654e-03*G6_2_1_8_0_7_8_0 - 4.166666666666656e-03*G6_2_1_8_0_7_8_1 - 4.166666666666657e-03*G6_2_1_8_0_7_8_2 + 4.166666666666654e-03*G6_2_1_8_0_7_9_0 + 4.166666666666656e-03*G6_2_1_8_0_7_10_1 + 4.166666666666656e-03*G6_2_1_8_0_7_11_2 - 8.333333333333309e-03*G6_2_1_8_1_4_8_0 - 8.333333333333311e-03*G6_2_1_8_1_4_8_1 - 8.333333333333312e-03*G6_2_1_8_1_4_8_2 + 8.333333333333309e-03*G6_2_1_8_1_4_9_0 + 8.333333333333311e-03*G6_2_1_8_1_4_10_1 + 8.333333333333311e-03*G6_2_1_8_1_4_11_2 - 4.166666666666654e-03*G6_2_1_8_1_5_8_0 - 4.166666666666654e-03*G6_2_1_8_1_5_8_1 - 4.166666666666655e-03*G6_2_1_8_1_5_8_2 + 4.166666666666654e-03*G6_2_1_8_1_5_9_0 + 4.166666666666654e-03*G6_2_1_8_1_5_10_1 + 4.166666666666654e-03*G6_2_1_8_1_5_11_2 - 4.166666666666654e-03*G6_2_1_8_1_6_8_0 - 4.166666666666654e-03*G6_2_1_8_1_6_8_1 - 4.166666666666654e-03*G6_2_1_8_1_6_8_2 + 4.166666666666654e-03*G6_2_1_8_1_6_9_0 + 4.166666666666654e-03*G6_2_1_8_1_6_10_1 + 4.166666666666654e-03*G6_2_1_8_1_6_11_2 - 4.166666666666656e-03*G6_2_1_8_1_7_8_0 - 4.166666666666657e-03*G6_2_1_8_1_7_8_1 - 4.166666666666657e-03*G6_2_1_8_1_7_8_2 + 4.166666666666656e-03*G6_2_1_8_1_7_9_0 + 4.166666666666657e-03*G6_2_1_8_1_7_10_1 + 4.166666666666657e-03*G6_2_1_8_1_7_11_2 - 8.333333333333311e-03*G6_2_1_8_2_4_8_0 - 8.333333333333312e-03*G6_2_1_8_2_4_8_1 - 8.333333333333314e-03*G6_2_1_8_2_4_8_2 + 8.333333333333311e-03*G6_2_1_8_2_4_9_0 + 8.333333333333312e-03*G6_2_1_8_2_4_10_1 + 8.333333333333312e-03*G6_2_1_8_2_4_11_2 - 4.166666666666654e-03*G6_2_1_8_2_5_8_0 - 4.166666666666655e-03*G6_2_1_8_2_5_8_1 - 4.166666666666655e-03*G6_2_1_8_2_5_8_2 + 4.166666666666654e-03*G6_2_1_8_2_5_9_0 + 4.166666666666655e-03*G6_2_1_8_2_5_10_1 + 4.166666666666655e-03*G6_2_1_8_2_5_11_2 - 4.166666666666654e-03*G6_2_1_8_2_6_8_0 - 4.166666666666654e-03*G6_2_1_8_2_6_8_1 - 4.166666666666654e-03*G6_2_1_8_2_6_8_2 + 4.166666666666654e-03*G6_2_1_8_2_6_9_0 + 4.166666666666654e-03*G6_2_1_8_2_6_10_1 + 4.166666666666654e-03*G6_2_1_8_2_6_11_2 - 4.166666666666657e-03*G6_2_1_8_2_7_8_0 - 4.166666666666657e-03*G6_2_1_8_2_7_8_1 - 4.166666666666658e-03*G6_2_1_8_2_7_8_2 + 4.166666666666657e-03*G6_2_1_8_2_7_9_0 + 4.166666666666657e-03*G6_2_1_8_2_7_10_1 + 4.166666666666657e-03*G6_2_1_8_2_7_11_2 - 4.166666666666654e-03*G6_2_1_9_0_4_8_0 - 4.166666666666654e-03*G6_2_1_9_0_4_8_1 - 4.166666666666654e-03*G6_2_1_9_0_4_8_2 + 4.166666666666654e-03*G6_2_1_9_0_4_9_0 + 4.166666666666654e-03*G6_2_1_9_0_4_10_1 + 4.166666666666654e-03*G6_2_1_9_0_4_11_2 - 8.333333333333307e-03*G6_2_1_9_0_5_8_0 - 8.333333333333309e-03*G6_2_1_9_0_5_8_1 - 8.333333333333309e-03*G6_2_1_9_0_5_8_2 + 8.333333333333307e-03*G6_2_1_9_0_5_9_0 + 8.333333333333309e-03*G6_2_1_9_0_5_10_1 + 8.333333333333309e-03*G6_2_1_9_0_5_11_2 - 4.166666666666654e-03*G6_2_1_9_0_6_8_0 - 4.166666666666655e-03*G6_2_1_9_0_6_8_1 - 4.166666666666655e-03*G6_2_1_9_0_6_8_2 + 4.166666666666654e-03*G6_2_1_9_0_6_9_0 + 4.166666666666655e-03*G6_2_1_9_0_6_10_1 + 4.166666666666655e-03*G6_2_1_9_0_6_11_2 - 4.166666666666655e-03*G6_2_1_9_0_7_8_0 - 4.166666666666656e-03*G6_2_1_9_0_7_8_1 - 4.166666666666656e-03*G6_2_1_9_0_7_8_2 + 4.166666666666655e-03*G6_2_1_9_0_7_9_0 + 4.166666666666656e-03*G6_2_1_9_0_7_10_1 + 4.166666666666656e-03*G6_2_1_9_0_7_11_2 - 4.166666666666654e-03*G6_2_1_9_1_4_8_0 - 4.166666666666654e-03*G6_2_1_9_1_4_8_1 - 4.166666666666655e-03*G6_2_1_9_1_4_8_2 + 4.166666666666654e-03*G6_2_1_9_1_4_9_0 + 4.166666666666654e-03*G6_2_1_9_1_4_10_1 + 4.166666666666654e-03*G6_2_1_9_1_4_11_2 - 8.333333333333309e-03*G6_2_1_9_1_5_8_0 - 8.333333333333309e-03*G6_2_1_9_1_5_8_1 - 8.333333333333309e-03*G6_2_1_9_1_5_8_2 + 8.333333333333309e-03*G6_2_1_9_1_5_9_0 + 8.333333333333309e-03*G6_2_1_9_1_5_10_1 + 8.333333333333309e-03*G6_2_1_9_1_5_11_2 - 4.166666666666655e-03*G6_2_1_9_1_6_8_0 - 4.166666666666656e-03*G6_2_1_9_1_6_8_1 - 4.166666666666656e-03*G6_2_1_9_1_6_8_2 + 4.166666666666655e-03*G6_2_1_9_1_6_9_0 + 4.166666666666656e-03*G6_2_1_9_1_6_10_1 + 4.166666666666656e-03*G6_2_1_9_1_6_11_2 - 4.166666666666656e-03*G6_2_1_9_1_7_8_0 - 4.166666666666657e-03*G6_2_1_9_1_7_8_1 - 4.166666666666657e-03*G6_2_1_9_1_7_8_2 + 4.166666666666656e-03*G6_2_1_9_1_7_9_0 + 4.166666666666657e-03*G6_2_1_9_1_7_10_1 + 4.166666666666657e-03*G6_2_1_9_1_7_11_2 - 4.166666666666654e-03*G6_2_1_9_2_4_8_0 - 4.166666666666655e-03*G6_2_1_9_2_4_8_1 - 4.166666666666655e-03*G6_2_1_9_2_4_8_2 + 4.166666666666654e-03*G6_2_1_9_2_4_9_0 + 4.166666666666655e-03*G6_2_1_9_2_4_10_1 + 4.166666666666655e-03*G6_2_1_9_2_4_11_2 - 8.333333333333309e-03*G6_2_1_9_2_5_8_0 - 8.333333333333309e-03*G6_2_1_9_2_5_8_1 - 8.333333333333309e-03*G6_2_1_9_2_5_8_2 + 8.333333333333309e-03*G6_2_1_9_2_5_9_0 + 8.333333333333309e-03*G6_2_1_9_2_5_10_1 + 8.333333333333309e-03*G6_2_1_9_2_5_11_2 - 4.166666666666655e-03*G6_2_1_9_2_6_8_0 - 4.166666666666656e-03*G6_2_1_9_2_6_8_1 - 4.166666666666656e-03*G6_2_1_9_2_6_8_2 + 4.166666666666655e-03*G6_2_1_9_2_6_9_0 + 4.166666666666656e-03*G6_2_1_9_2_6_10_1 + 4.166666666666656e-03*G6_2_1_9_2_6_11_2 - 4.166666666666656e-03*G6_2_1_9_2_7_8_0 - 4.166666666666657e-03*G6_2_1_9_2_7_8_1 - 4.166666666666657e-03*G6_2_1_9_2_7_8_2 + 4.166666666666656e-03*G6_2_1_9_2_7_9_0 + 4.166666666666657e-03*G6_2_1_9_2_7_10_1 + 4.166666666666657e-03*G6_2_1_9_2_7_11_2 - 4.166666666666653e-03*G6_2_1_10_0_4_8_0 - 4.166666666666654e-03*G6_2_1_10_0_4_8_1 - 4.166666666666654e-03*G6_2_1_10_0_4_8_2 + 4.166666666666653e-03*G6_2_1_10_0_4_9_0 + 4.166666666666654e-03*G6_2_1_10_0_4_10_1 + 4.166666666666654e-03*G6_2_1_10_0_4_11_2 - 4.166666666666654e-03*G6_2_1_10_0_5_8_0 - 4.166666666666655e-03*G6_2_1_10_0_5_8_1 - 4.166666666666655e-03*G6_2_1_10_0_5_8_2 + 4.166666666666654e-03*G6_2_1_10_0_5_9_0 + 4.166666666666655e-03*G6_2_1_10_0_5_10_1 + 4.166666666666655e-03*G6_2_1_10_0_5_11_2 - 8.333333333333309e-03*G6_2_1_10_0_6_8_0 - 8.333333333333309e-03*G6_2_1_10_0_6_8_1 - 8.333333333333311e-03*G6_2_1_10_0_6_8_2 + 8.333333333333309e-03*G6_2_1_10_0_6_9_0 + 8.333333333333309e-03*G6_2_1_10_0_6_10_1 + 8.333333333333309e-03*G6_2_1_10_0_6_11_2 - 4.166666666666654e-03*G6_2_1_10_0_7_8_0 - 4.166666666666655e-03*G6_2_1_10_0_7_8_1 - 4.166666666666655e-03*G6_2_1_10_0_7_8_2 + 4.166666666666654e-03*G6_2_1_10_0_7_9_0 + 4.166666666666655e-03*G6_2_1_10_0_7_10_1 + 4.166666666666655e-03*G6_2_1_10_0_7_11_2 - 4.166666666666654e-03*G6_2_1_10_1_4_8_0 - 4.166666666666654e-03*G6_2_1_10_1_4_8_1 - 4.166666666666654e-03*G6_2_1_10_1_4_8_2 + 4.166666666666654e-03*G6_2_1_10_1_4_9_0 + 4.166666666666654e-03*G6_2_1_10_1_4_10_1 + 4.166666666666654e-03*G6_2_1_10_1_4_11_2 - 4.166666666666655e-03*G6_2_1_10_1_5_8_0 - 4.166666666666656e-03*G6_2_1_10_1_5_8_1 - 4.166666666666656e-03*G6_2_1_10_1_5_8_2 + 4.166666666666655e-03*G6_2_1_10_1_5_9_0 + 4.166666666666656e-03*G6_2_1_10_1_5_10_1 + 4.166666666666656e-03*G6_2_1_10_1_5_11_2 - 8.333333333333311e-03*G6_2_1_10_1_6_8_0 - 8.333333333333311e-03*G6_2_1_10_1_6_8_1 - 8.333333333333312e-03*G6_2_1_10_1_6_8_2 + 8.333333333333311e-03*G6_2_1_10_1_6_9_0 + 8.333333333333311e-03*G6_2_1_10_1_6_10_1 + 8.333333333333311e-03*G6_2_1_10_1_6_11_2 - 4.166666666666655e-03*G6_2_1_10_1_7_8_0 - 4.166666666666656e-03*G6_2_1_10_1_7_8_1 - 4.166666666666657e-03*G6_2_1_10_1_7_8_2 + 4.166666666666655e-03*G6_2_1_10_1_7_9_0 + 4.166666666666656e-03*G6_2_1_10_1_7_10_1 + 4.166666666666656e-03*G6_2_1_10_1_7_11_2 - 4.166666666666654e-03*G6_2_1_10_2_4_8_0 - 4.166666666666654e-03*G6_2_1_10_2_4_8_1 - 4.166666666666654e-03*G6_2_1_10_2_4_8_2 + 4.166666666666654e-03*G6_2_1_10_2_4_9_0 + 4.166666666666654e-03*G6_2_1_10_2_4_10_1 + 4.166666666666654e-03*G6_2_1_10_2_4_11_2 - 4.166666666666655e-03*G6_2_1_10_2_5_8_0 - 4.166666666666656e-03*G6_2_1_10_2_5_8_1 - 4.166666666666656e-03*G6_2_1_10_2_5_8_2 + 4.166666666666655e-03*G6_2_1_10_2_5_9_0 + 4.166666666666656e-03*G6_2_1_10_2_5_10_1 + 4.166666666666656e-03*G6_2_1_10_2_5_11_2 - 8.333333333333311e-03*G6_2_1_10_2_6_8_0 - 8.333333333333312e-03*G6_2_1_10_2_6_8_1 - 8.333333333333312e-03*G6_2_1_10_2_6_8_2 + 8.333333333333311e-03*G6_2_1_10_2_6_9_0 + 8.333333333333312e-03*G6_2_1_10_2_6_10_1 + 8.333333333333312e-03*G6_2_1_10_2_6_11_2 - 4.166666666666655e-03*G6_2_1_10_2_7_8_0 - 4.166666666666657e-03*G6_2_1_10_2_7_8_1 - 4.166666666666657e-03*G6_2_1_10_2_7_8_2 + 4.166666666666655e-03*G6_2_1_10_2_7_9_0 + 4.166666666666657e-03*G6_2_1_10_2_7_10_1 + 4.166666666666657e-03*G6_2_1_10_2_7_11_2 - 4.166666666666655e-03*G6_2_1_11_0_4_8_0 - 4.166666666666656e-03*G6_2_1_11_0_4_8_1 - 4.166666666666657e-03*G6_2_1_11_0_4_8_2 + 4.166666666666655e-03*G6_2_1_11_0_4_9_0 + 4.166666666666656e-03*G6_2_1_11_0_4_10_1 + 4.166666666666656e-03*G6_2_1_11_0_4_11_2 - 4.166666666666655e-03*G6_2_1_11_0_5_8_0 - 4.166666666666656e-03*G6_2_1_11_0_5_8_1 - 4.166666666666656e-03*G6_2_1_11_0_5_8_2 + 4.166666666666655e-03*G6_2_1_11_0_5_9_0 + 4.166666666666656e-03*G6_2_1_11_0_5_10_1 + 4.166666666666656e-03*G6_2_1_11_0_5_11_2 - 4.166666666666655e-03*G6_2_1_11_0_6_8_0 - 4.166666666666655e-03*G6_2_1_11_0_6_8_1 - 4.166666666666655e-03*G6_2_1_11_0_6_8_2 + 4.166666666666655e-03*G6_2_1_11_0_6_9_0 + 4.166666666666655e-03*G6_2_1_11_0_6_10_1 + 4.166666666666655e-03*G6_2_1_11_0_6_11_2 - 8.333333333333309e-03*G6_2_1_11_0_7_8_0 - 8.333333333333311e-03*G6_2_1_11_0_7_8_1 - 8.333333333333311e-03*G6_2_1_11_0_7_8_2 + 8.333333333333309e-03*G6_2_1_11_0_7_9_0 + 8.333333333333311e-03*G6_2_1_11_0_7_10_1 + 8.333333333333311e-03*G6_2_1_11_0_7_11_2 - 4.166666666666656e-03*G6_2_1_11_1_4_8_0 - 4.166666666666657e-03*G6_2_1_11_1_4_8_1 - 4.166666666666657e-03*G6_2_1_11_1_4_8_2 + 4.166666666666656e-03*G6_2_1_11_1_4_9_0 + 4.166666666666657e-03*G6_2_1_11_1_4_10_1 + 4.166666666666657e-03*G6_2_1_11_1_4_11_2 - 4.166666666666656e-03*G6_2_1_11_1_5_8_0 - 4.166666666666657e-03*G6_2_1_11_1_5_8_1 - 4.166666666666657e-03*G6_2_1_11_1_5_8_2 + 4.166666666666656e-03*G6_2_1_11_1_5_9_0 + 4.166666666666657e-03*G6_2_1_11_1_5_10_1 + 4.166666666666657e-03*G6_2_1_11_1_5_11_2 - 4.166666666666655e-03*G6_2_1_11_1_6_8_0 - 4.166666666666656e-03*G6_2_1_11_1_6_8_1 - 4.166666666666657e-03*G6_2_1_11_1_6_8_2 + 4.166666666666655e-03*G6_2_1_11_1_6_9_0 + 4.166666666666656e-03*G6_2_1_11_1_6_10_1 + 4.166666666666656e-03*G6_2_1_11_1_6_11_2 - 8.333333333333311e-03*G6_2_1_11_1_7_8_0 - 8.333333333333311e-03*G6_2_1_11_1_7_8_1 - 8.333333333333312e-03*G6_2_1_11_1_7_8_2 + 8.333333333333311e-03*G6_2_1_11_1_7_9_0 + 8.333333333333311e-03*G6_2_1_11_1_7_10_1 + 8.333333333333311e-03*G6_2_1_11_1_7_11_2 - 4.166666666666657e-03*G6_2_1_11_2_4_8_0 - 4.166666666666657e-03*G6_2_1_11_2_4_8_1 - 4.166666666666658e-03*G6_2_1_11_2_4_8_2 + 4.166666666666657e-03*G6_2_1_11_2_4_9_0 + 4.166666666666657e-03*G6_2_1_11_2_4_10_1 + 4.166666666666657e-03*G6_2_1_11_2_4_11_2 - 4.166666666666656e-03*G6_2_1_11_2_5_8_0 - 4.166666666666657e-03*G6_2_1_11_2_5_8_1 - 4.166666666666657e-03*G6_2_1_11_2_5_8_2 + 4.166666666666656e-03*G6_2_1_11_2_5_9_0 + 4.166666666666657e-03*G6_2_1_11_2_5_10_1 + 4.166666666666657e-03*G6_2_1_11_2_5_11_2 - 4.166666666666655e-03*G6_2_1_11_2_6_8_0 - 4.166666666666657e-03*G6_2_1_11_2_6_8_1 - 4.166666666666657e-03*G6_2_1_11_2_6_8_2 + 4.166666666666655e-03*G6_2_1_11_2_6_9_0 + 4.166666666666657e-03*G6_2_1_11_2_6_10_1 + 4.166666666666657e-03*G6_2_1_11_2_6_11_2 - 8.333333333333311e-03*G6_2_1_11_2_7_8_0 - 8.333333333333312e-03*G6_2_1_11_2_7_8_1 - 8.333333333333312e-03*G6_2_1_11_2_7_8_2 + 8.333333333333311e-03*G6_2_1_11_2_7_9_0 + 8.333333333333312e-03*G6_2_1_11_2_7_10_1 + 8.333333333333312e-03*G6_2_1_11_2_7_11_2 - 8.333333333333309e-03*G6_2_2_8_0_8_8_0 - 8.333333333333309e-03*G6_2_2_8_0_8_8_1 - 8.333333333333311e-03*G6_2_2_8_0_8_8_2 + 8.333333333333309e-03*G6_2_2_8_0_8_9_0 + 8.333333333333309e-03*G6_2_2_8_0_8_10_1 + 8.333333333333309e-03*G6_2_2_8_0_8_11_2 - 4.166666666666654e-03*G6_2_2_8_0_9_8_0 - 4.166666666666654e-03*G6_2_2_8_0_9_8_1 - 4.166666666666654e-03*G6_2_2_8_0_9_8_2 + 4.166666666666654e-03*G6_2_2_8_0_9_9_0 + 4.166666666666654e-03*G6_2_2_8_0_9_10_1 + 4.166666666666654e-03*G6_2_2_8_0_9_11_2 - 4.166666666666653e-03*G6_2_2_8_0_10_8_0 - 4.166666666666654e-03*G6_2_2_8_0_10_8_1 - 4.166666666666654e-03*G6_2_2_8_0_10_8_2 + 4.166666666666653e-03*G6_2_2_8_0_10_9_0 + 4.166666666666654e-03*G6_2_2_8_0_10_10_1 + 4.166666666666654e-03*G6_2_2_8_0_10_11_2 - 4.166666666666654e-03*G6_2_2_8_0_11_8_0 - 4.166666666666656e-03*G6_2_2_8_0_11_8_1 - 4.166666666666657e-03*G6_2_2_8_0_11_8_2 + 4.166666666666654e-03*G6_2_2_8_0_11_9_0 + 4.166666666666656e-03*G6_2_2_8_0_11_10_1 + 4.166666666666656e-03*G6_2_2_8_0_11_11_2 - 8.333333333333309e-03*G6_2_2_8_1_8_8_0 - 8.333333333333311e-03*G6_2_2_8_1_8_8_1 - 8.333333333333312e-03*G6_2_2_8_1_8_8_2 + 8.333333333333309e-03*G6_2_2_8_1_8_9_0 + 8.333333333333311e-03*G6_2_2_8_1_8_10_1 + 8.333333333333311e-03*G6_2_2_8_1_8_11_2 - 4.166666666666654e-03*G6_2_2_8_1_9_8_0 - 4.166666666666654e-03*G6_2_2_8_1_9_8_1 - 4.166666666666655e-03*G6_2_2_8_1_9_8_2 + 4.166666666666654e-03*G6_2_2_8_1_9_9_0 + 4.166666666666654e-03*G6_2_2_8_1_9_10_1 + 4.166666666666654e-03*G6_2_2_8_1_9_11_2 - 4.166666666666654e-03*G6_2_2_8_1_10_8_0 - 4.166666666666654e-03*G6_2_2_8_1_10_8_1 - 4.166666666666654e-03*G6_2_2_8_1_10_8_2 + 4.166666666666654e-03*G6_2_2_8_1_10_9_0 + 4.166666666666654e-03*G6_2_2_8_1_10_10_1 + 4.166666666666654e-03*G6_2_2_8_1_10_11_2 - 4.166666666666656e-03*G6_2_2_8_1_11_8_0 - 4.166666666666657e-03*G6_2_2_8_1_11_8_1 - 4.166666666666657e-03*G6_2_2_8_1_11_8_2 + 4.166666666666656e-03*G6_2_2_8_1_11_9_0 + 4.166666666666657e-03*G6_2_2_8_1_11_10_1 + 4.166666666666657e-03*G6_2_2_8_1_11_11_2 - 8.333333333333311e-03*G6_2_2_8_2_8_8_0 - 8.333333333333312e-03*G6_2_2_8_2_8_8_1 - 8.333333333333314e-03*G6_2_2_8_2_8_8_2 + 8.333333333333311e-03*G6_2_2_8_2_8_9_0 + 8.333333333333312e-03*G6_2_2_8_2_8_10_1 + 8.333333333333312e-03*G6_2_2_8_2_8_11_2 - 4.166666666666654e-03*G6_2_2_8_2_9_8_0 - 4.166666666666655e-03*G6_2_2_8_2_9_8_1 - 4.166666666666655e-03*G6_2_2_8_2_9_8_2 + 4.166666666666654e-03*G6_2_2_8_2_9_9_0 + 4.166666666666655e-03*G6_2_2_8_2_9_10_1 + 4.166666666666655e-03*G6_2_2_8_2_9_11_2 - 4.166666666666654e-03*G6_2_2_8_2_10_8_0 - 4.166666666666654e-03*G6_2_2_8_2_10_8_1 - 4.166666666666654e-03*G6_2_2_8_2_10_8_2 + 4.166666666666654e-03*G6_2_2_8_2_10_9_0 + 4.166666666666654e-03*G6_2_2_8_2_10_10_1 + 4.166666666666654e-03*G6_2_2_8_2_10_11_2 - 4.166666666666657e-03*G6_2_2_8_2_11_8_0 - 4.166666666666657e-03*G6_2_2_8_2_11_8_1 - 4.166666666666658e-03*G6_2_2_8_2_11_8_2 + 4.166666666666657e-03*G6_2_2_8_2_11_9_0 + 4.166666666666657e-03*G6_2_2_8_2_11_10_1 + 4.166666666666657e-03*G6_2_2_8_2_11_11_2 - 4.166666666666654e-03*G6_2_2_9_0_8_8_0 - 4.166666666666654e-03*G6_2_2_9_0_8_8_1 - 4.166666666666654e-03*G6_2_2_9_0_8_8_2 + 4.166666666666654e-03*G6_2_2_9_0_8_9_0 + 4.166666666666654e-03*G6_2_2_9_0_8_10_1 + 4.166666666666654e-03*G6_2_2_9_0_8_11_2 - 8.333333333333307e-03*G6_2_2_9_0_9_8_0 - 8.333333333333309e-03*G6_2_2_9_0_9_8_1 - 8.333333333333309e-03*G6_2_2_9_0_9_8_2 + 8.333333333333307e-03*G6_2_2_9_0_9_9_0 + 8.333333333333309e-03*G6_2_2_9_0_9_10_1 + 8.333333333333309e-03*G6_2_2_9_0_9_11_2 - 4.166666666666654e-03*G6_2_2_9_0_10_8_0 - 4.166666666666655e-03*G6_2_2_9_0_10_8_1 - 4.166666666666655e-03*G6_2_2_9_0_10_8_2 + 4.166666666666654e-03*G6_2_2_9_0_10_9_0 + 4.166666666666655e-03*G6_2_2_9_0_10_10_1 + 4.166666666666655e-03*G6_2_2_9_0_10_11_2 - 4.166666666666655e-03*G6_2_2_9_0_11_8_0 - 4.166666666666656e-03*G6_2_2_9_0_11_8_1 - 4.166666666666656e-03*G6_2_2_9_0_11_8_2 + 4.166666666666655e-03*G6_2_2_9_0_11_9_0 + 4.166666666666656e-03*G6_2_2_9_0_11_10_1 + 4.166666666666656e-03*G6_2_2_9_0_11_11_2 - 4.166666666666654e-03*G6_2_2_9_1_8_8_0 - 4.166666666666654e-03*G6_2_2_9_1_8_8_1 - 4.166666666666655e-03*G6_2_2_9_1_8_8_2 + 4.166666666666654e-03*G6_2_2_9_1_8_9_0 + 4.166666666666654e-03*G6_2_2_9_1_8_10_1 + 4.166666666666654e-03*G6_2_2_9_1_8_11_2 - 8.333333333333309e-03*G6_2_2_9_1_9_8_0 - 8.333333333333309e-03*G6_2_2_9_1_9_8_1 - 8.333333333333309e-03*G6_2_2_9_1_9_8_2 + 8.333333333333309e-03*G6_2_2_9_1_9_9_0 + 8.333333333333309e-03*G6_2_2_9_1_9_10_1 + 8.333333333333309e-03*G6_2_2_9_1_9_11_2 - 4.166666666666655e-03*G6_2_2_9_1_10_8_0 - 4.166666666666656e-03*G6_2_2_9_1_10_8_1 - 4.166666666666656e-03*G6_2_2_9_1_10_8_2 + 4.166666666666655e-03*G6_2_2_9_1_10_9_0 + 4.166666666666656e-03*G6_2_2_9_1_10_10_1 + 4.166666666666656e-03*G6_2_2_9_1_10_11_2 - 4.166666666666656e-03*G6_2_2_9_1_11_8_0 - 4.166666666666657e-03*G6_2_2_9_1_11_8_1 - 4.166666666666657e-03*G6_2_2_9_1_11_8_2 + 4.166666666666656e-03*G6_2_2_9_1_11_9_0 + 4.166666666666657e-03*G6_2_2_9_1_11_10_1 + 4.166666666666657e-03*G6_2_2_9_1_11_11_2 - 4.166666666666654e-03*G6_2_2_9_2_8_8_0 - 4.166666666666655e-03*G6_2_2_9_2_8_8_1 - 4.166666666666655e-03*G6_2_2_9_2_8_8_2 + 4.166666666666654e-03*G6_2_2_9_2_8_9_0 + 4.166666666666655e-03*G6_2_2_9_2_8_10_1 + 4.166666666666655e-03*G6_2_2_9_2_8_11_2 - 8.333333333333309e-03*G6_2_2_9_2_9_8_0 - 8.333333333333309e-03*G6_2_2_9_2_9_8_1 - 8.333333333333309e-03*G6_2_2_9_2_9_8_2 + 8.333333333333309e-03*G6_2_2_9_2_9_9_0 + 8.333333333333309e-03*G6_2_2_9_2_9_10_1 + 8.333333333333309e-03*G6_2_2_9_2_9_11_2 - 4.166666666666655e-03*G6_2_2_9_2_10_8_0 - 4.166666666666656e-03*G6_2_2_9_2_10_8_1 - 4.166666666666656e-03*G6_2_2_9_2_10_8_2 + 4.166666666666655e-03*G6_2_2_9_2_10_9_0 + 4.166666666666656e-03*G6_2_2_9_2_10_10_1 + 4.166666666666656e-03*G6_2_2_9_2_10_11_2 - 4.166666666666656e-03*G6_2_2_9_2_11_8_0 - 4.166666666666657e-03*G6_2_2_9_2_11_8_1 - 4.166666666666657e-03*G6_2_2_9_2_11_8_2 + 4.166666666666656e-03*G6_2_2_9_2_11_9_0 + 4.166666666666657e-03*G6_2_2_9_2_11_10_1 + 4.166666666666657e-03*G6_2_2_9_2_11_11_2 - 4.166666666666653e-03*G6_2_2_10_0_8_8_0 - 4.166666666666654e-03*G6_2_2_10_0_8_8_1 - 4.166666666666654e-03*G6_2_2_10_0_8_8_2 + 4.166666666666653e-03*G6_2_2_10_0_8_9_0 + 4.166666666666654e-03*G6_2_2_10_0_8_10_1 + 4.166666666666654e-03*G6_2_2_10_0_8_11_2 - 4.166666666666654e-03*G6_2_2_10_0_9_8_0 - 4.166666666666655e-03*G6_2_2_10_0_9_8_1 - 4.166666666666655e-03*G6_2_2_10_0_9_8_2 + 4.166666666666654e-03*G6_2_2_10_0_9_9_0 + 4.166666666666655e-03*G6_2_2_10_0_9_10_1 + 4.166666666666655e-03*G6_2_2_10_0_9_11_2 - 8.333333333333309e-03*G6_2_2_10_0_10_8_0 - 8.333333333333309e-03*G6_2_2_10_0_10_8_1 - 8.333333333333311e-03*G6_2_2_10_0_10_8_2 + 8.333333333333309e-03*G6_2_2_10_0_10_9_0 + 8.333333333333309e-03*G6_2_2_10_0_10_10_1 + 8.333333333333309e-03*G6_2_2_10_0_10_11_2 - 4.166666666666654e-03*G6_2_2_10_0_11_8_0 - 4.166666666666655e-03*G6_2_2_10_0_11_8_1 - 4.166666666666655e-03*G6_2_2_10_0_11_8_2 + 4.166666666666654e-03*G6_2_2_10_0_11_9_0 + 4.166666666666655e-03*G6_2_2_10_0_11_10_1 + 4.166666666666655e-03*G6_2_2_10_0_11_11_2 - 4.166666666666654e-03*G6_2_2_10_1_8_8_0 - 4.166666666666654e-03*G6_2_2_10_1_8_8_1 - 4.166666666666654e-03*G6_2_2_10_1_8_8_2 + 4.166666666666654e-03*G6_2_2_10_1_8_9_0 + 4.166666666666654e-03*G6_2_2_10_1_8_10_1 + 4.166666666666654e-03*G6_2_2_10_1_8_11_2 - 4.166666666666655e-03*G6_2_2_10_1_9_8_0 - 4.166666666666656e-03*G6_2_2_10_1_9_8_1 - 4.166666666666656e-03*G6_2_2_10_1_9_8_2 + 4.166666666666655e-03*G6_2_2_10_1_9_9_0 + 4.166666666666656e-03*G6_2_2_10_1_9_10_1 + 4.166666666666656e-03*G6_2_2_10_1_9_11_2 - 8.333333333333311e-03*G6_2_2_10_1_10_8_0 - 8.333333333333311e-03*G6_2_2_10_1_10_8_1 - 8.333333333333312e-03*G6_2_2_10_1_10_8_2 + 8.333333333333311e-03*G6_2_2_10_1_10_9_0 + 8.333333333333311e-03*G6_2_2_10_1_10_10_1 + 8.333333333333311e-03*G6_2_2_10_1_10_11_2 - 4.166666666666655e-03*G6_2_2_10_1_11_8_0 - 4.166666666666656e-03*G6_2_2_10_1_11_8_1 - 4.166666666666657e-03*G6_2_2_10_1_11_8_2 + 4.166666666666655e-03*G6_2_2_10_1_11_9_0 + 4.166666666666656e-03*G6_2_2_10_1_11_10_1 + 4.166666666666656e-03*G6_2_2_10_1_11_11_2 - 4.166666666666654e-03*G6_2_2_10_2_8_8_0 - 4.166666666666654e-03*G6_2_2_10_2_8_8_1 - 4.166666666666654e-03*G6_2_2_10_2_8_8_2 + 4.166666666666654e-03*G6_2_2_10_2_8_9_0 + 4.166666666666654e-03*G6_2_2_10_2_8_10_1 + 4.166666666666654e-03*G6_2_2_10_2_8_11_2 - 4.166666666666655e-03*G6_2_2_10_2_9_8_0 - 4.166666666666656e-03*G6_2_2_10_2_9_8_1 - 4.166666666666656e-03*G6_2_2_10_2_9_8_2 + 4.166666666666655e-03*G6_2_2_10_2_9_9_0 + 4.166666666666656e-03*G6_2_2_10_2_9_10_1 + 4.166666666666656e-03*G6_2_2_10_2_9_11_2 - 8.333333333333311e-03*G6_2_2_10_2_10_8_0 - 8.333333333333312e-03*G6_2_2_10_2_10_8_1 - 8.333333333333312e-03*G6_2_2_10_2_10_8_2 + 8.333333333333311e-03*G6_2_2_10_2_10_9_0 + 8.333333333333312e-03*G6_2_2_10_2_10_10_1 + 8.333333333333312e-03*G6_2_2_10_2_10_11_2 - 4.166666666666655e-03*G6_2_2_10_2_11_8_0 - 4.166666666666657e-03*G6_2_2_10_2_11_8_1 - 4.166666666666657e-03*G6_2_2_10_2_11_8_2 + 4.166666666666655e-03*G6_2_2_10_2_11_9_0 + 4.166666666666657e-03*G6_2_2_10_2_11_10_1 + 4.166666666666657e-03*G6_2_2_10_2_11_11_2 - 4.166666666666655e-03*G6_2_2_11_0_8_8_0 - 4.166666666666656e-03*G6_2_2_11_0_8_8_1 - 4.166666666666657e-03*G6_2_2_11_0_8_8_2 + 4.166666666666655e-03*G6_2_2_11_0_8_9_0 + 4.166666666666656e-03*G6_2_2_11_0_8_10_1 + 4.166666666666656e-03*G6_2_2_11_0_8_11_2 - 4.166666666666655e-03*G6_2_2_11_0_9_8_0 - 4.166666666666656e-03*G6_2_2_11_0_9_8_1 - 4.166666666666656e-03*G6_2_2_11_0_9_8_2 + 4.166666666666655e-03*G6_2_2_11_0_9_9_0 + 4.166666666666656e-03*G6_2_2_11_0_9_10_1 + 4.166666666666656e-03*G6_2_2_11_0_9_11_2 - 4.166666666666655e-03*G6_2_2_11_0_10_8_0 - 4.166666666666655e-03*G6_2_2_11_0_10_8_1 - 4.166666666666655e-03*G6_2_2_11_0_10_8_2 + 4.166666666666655e-03*G6_2_2_11_0_10_9_0 + 4.166666666666655e-03*G6_2_2_11_0_10_10_1 + 4.166666666666655e-03*G6_2_2_11_0_10_11_2 - 8.333333333333309e-03*G6_2_2_11_0_11_8_0 - 8.333333333333311e-03*G6_2_2_11_0_11_8_1 - 8.333333333333311e-03*G6_2_2_11_0_11_8_2 + 8.333333333333309e-03*G6_2_2_11_0_11_9_0 + 8.333333333333311e-03*G6_2_2_11_0_11_10_1 + 8.333333333333311e-03*G6_2_2_11_0_11_11_2 - 4.166666666666656e-03*G6_2_2_11_1_8_8_0 - 4.166666666666657e-03*G6_2_2_11_1_8_8_1 - 4.166666666666657e-03*G6_2_2_11_1_8_8_2 + 4.166666666666656e-03*G6_2_2_11_1_8_9_0 + 4.166666666666657e-03*G6_2_2_11_1_8_10_1 + 4.166666666666657e-03*G6_2_2_11_1_8_11_2 - 4.166666666666656e-03*G6_2_2_11_1_9_8_0 - 4.166666666666657e-03*G6_2_2_11_1_9_8_1 - 4.166666666666657e-03*G6_2_2_11_1_9_8_2 + 4.166666666666656e-03*G6_2_2_11_1_9_9_0 + 4.166666666666657e-03*G6_2_2_11_1_9_10_1 + 4.166666666666657e-03*G6_2_2_11_1_9_11_2 - 4.166666666666655e-03*G6_2_2_11_1_10_8_0 - 4.166666666666656e-03*G6_2_2_11_1_10_8_1 - 4.166666666666657e-03*G6_2_2_11_1_10_8_2 + 4.166666666666655e-03*G6_2_2_11_1_10_9_0 + 4.166666666666656e-03*G6_2_2_11_1_10_10_1 + 4.166666666666656e-03*G6_2_2_11_1_10_11_2 - 8.333333333333311e-03*G6_2_2_11_1_11_8_0 - 8.333333333333311e-03*G6_2_2_11_1_11_8_1 - 8.333333333333312e-03*G6_2_2_11_1_11_8_2 + 8.333333333333311e-03*G6_2_2_11_1_11_9_0 + 8.333333333333311e-03*G6_2_2_11_1_11_10_1 + 8.333333333333311e-03*G6_2_2_11_1_11_11_2 - 4.166666666666657e-03*G6_2_2_11_2_8_8_0 - 4.166666666666657e-03*G6_2_2_11_2_8_8_1 - 4.166666666666658e-03*G6_2_2_11_2_8_8_2 + 4.166666666666657e-03*G6_2_2_11_2_8_9_0 + 4.166666666666657e-03*G6_2_2_11_2_8_10_1 + 4.166666666666657e-03*G6_2_2_11_2_8_11_2 - 4.166666666666656e-03*G6_2_2_11_2_9_8_0 - 4.166666666666657e-03*G6_2_2_11_2_9_8_1 - 4.166666666666657e-03*G6_2_2_11_2_9_8_2 + 4.166666666666656e-03*G6_2_2_11_2_9_9_0 + 4.166666666666657e-03*G6_2_2_11_2_9_10_1 + 4.166666666666657e-03*G6_2_2_11_2_9_11_2 - 4.166666666666655e-03*G6_2_2_11_2_10_8_0 - 4.166666666666657e-03*G6_2_2_11_2_10_8_1 - 4.166666666666657e-03*G6_2_2_11_2_10_8_2 + 4.166666666666655e-03*G6_2_2_11_2_10_9_0 + 4.166666666666657e-03*G6_2_2_11_2_10_10_1 + 4.166666666666657e-03*G6_2_2_11_2_10_11_2 - 8.333333333333311e-03*G6_2_2_11_2_11_8_0 - 8.333333333333312e-03*G6_2_2_11_2_11_8_1 - 8.333333333333312e-03*G6_2_2_11_2_11_8_2 + 8.333333333333311e-03*G6_2_2_11_2_11_9_0 + 8.333333333333312e-03*G6_2_2_11_2_11_10_1 + 8.333333333333312e-03*G6_2_2_11_2_11_11_2 - 4.166666666666661e-02*G7_2_0_0_0_0_0 - 4.166666666666662e-02*G7_2_0_0_0_0_1 - 4.166666666666662e-02*G7_2_0_0_0_0_2 + 4.166666666666661e-02*G7_2_0_0_0_1_0 + 4.166666666666662e-02*G7_2_0_0_0_2_1 + 4.166666666666662e-02*G7_2_0_0_0_3_2 - 4.166666666666662e-02*G7_2_0_0_1_0_0 - 4.166666666666662e-02*G7_2_0_0_1_0_1 - 4.166666666666662e-02*G7_2_0_0_1_0_2 + 4.166666666666662e-02*G7_2_0_0_1_1_0 + 4.166666666666662e-02*G7_2_0_0_1_2_1 + 4.166666666666662e-02*G7_2_0_0_1_3_2 - 4.166666666666662e-02*G7_2_0_0_2_0_0 - 4.166666666666662e-02*G7_2_0_0_2_0_1 - 4.166666666666662e-02*G7_2_0_0_2_0_2 + 4.166666666666662e-02*G7_2_0_0_2_1_0 + 4.166666666666662e-02*G7_2_0_0_2_2_1 + 4.166666666666662e-02*G7_2_0_0_2_3_2 - 4.166666666666659e-02*G7_2_0_1_0_0_0 - 4.166666666666660e-02*G7_2_0_1_0_0_1 - 4.166666666666660e-02*G7_2_0_1_0_0_2 + 4.166666666666659e-02*G7_2_0_1_0_1_0 + 4.166666666666660e-02*G7_2_0_1_0_2_1 + 4.166666666666660e-02*G7_2_0_1_0_3_2 - 4.166666666666660e-02*G7_2_0_1_1_0_0 - 4.166666666666661e-02*G7_2_0_1_1_0_1 - 4.166666666666661e-02*G7_2_0_1_1_0_2 + 4.166666666666660e-02*G7_2_0_1_1_1_0 + 4.166666666666661e-02*G7_2_0_1_1_2_1 + 4.166666666666661e-02*G7_2_0_1_1_3_2 - 4.166666666666660e-02*G7_2_0_1_2_0_0 - 4.166666666666661e-02*G7_2_0_1_2_0_1 - 4.166666666666661e-02*G7_2_0_1_2_0_2 + 4.166666666666660e-02*G7_2_0_1_2_1_0 + 4.166666666666661e-02*G7_2_0_1_2_2_1 + 4.166666666666661e-02*G7_2_0_1_2_3_2 - 4.166666666666660e-02*G7_2_0_2_0_0_0 - 4.166666666666661e-02*G7_2_0_2_0_0_1 - 4.166666666666661e-02*G7_2_0_2_0_0_2 + 4.166666666666660e-02*G7_2_0_2_0_1_0 + 4.166666666666661e-02*G7_2_0_2_0_2_1 + 4.166666666666661e-02*G7_2_0_2_0_3_2 - 4.166666666666661e-02*G7_2_0_2_1_0_0 - 4.166666666666662e-02*G7_2_0_2_1_0_1 - 4.166666666666662e-02*G7_2_0_2_1_0_2 + 4.166666666666661e-02*G7_2_0_2_1_1_0 + 4.166666666666662e-02*G7_2_0_2_1_2_1 + 4.166666666666662e-02*G7_2_0_2_1_3_2 - 4.166666666666661e-02*G7_2_0_2_2_0_0 - 4.166666666666662e-02*G7_2_0_2_2_0_1 - 4.166666666666662e-02*G7_2_0_2_2_0_2 + 4.166666666666661e-02*G7_2_0_2_2_1_0 + 4.166666666666662e-02*G7_2_0_2_2_2_1 + 4.166666666666662e-02*G7_2_0_2_2_3_2 - 4.166666666666660e-02*G7_2_0_3_0_0_0 - 4.166666666666661e-02*G7_2_0_3_0_0_1 - 4.166666666666661e-02*G7_2_0_3_0_0_2 + 4.166666666666660e-02*G7_2_0_3_0_1_0 + 4.166666666666661e-02*G7_2_0_3_0_2_1 + 4.166666666666661e-02*G7_2_0_3_0_3_2 - 4.166666666666661e-02*G7_2_0_3_1_0_0 - 4.166666666666662e-02*G7_2_0_3_1_0_1 - 4.166666666666662e-02*G7_2_0_3_1_0_2 + 4.166666666666661e-02*G7_2_0_3_1_1_0 + 4.166666666666662e-02*G7_2_0_3_1_2_1 + 4.166666666666662e-02*G7_2_0_3_1_3_2 - 4.166666666666661e-02*G7_2_0_3_2_0_0 - 4.166666666666662e-02*G7_2_0_3_2_0_1 - 4.166666666666662e-02*G7_2_0_3_2_0_2 + 4.166666666666661e-02*G7_2_0_3_2_1_0 + 4.166666666666662e-02*G7_2_0_3_2_2_1 + 4.166666666666662e-02*G7_2_0_3_2_3_2 - 4.166666666666660e-02*G7_2_1_4_0_0_0 - 4.166666666666661e-02*G7_2_1_4_0_0_1 - 4.166666666666661e-02*G7_2_1_4_0_0_2 + 4.166666666666660e-02*G7_2_1_4_0_1_0 + 4.166666666666661e-02*G7_2_1_4_0_2_1 + 4.166666666666661e-02*G7_2_1_4_0_3_2 - 4.166666666666661e-02*G7_2_1_4_1_0_0 - 4.166666666666662e-02*G7_2_1_4_1_0_1 - 4.166666666666662e-02*G7_2_1_4_1_0_2 + 4.166666666666661e-02*G7_2_1_4_1_1_0 + 4.166666666666662e-02*G7_2_1_4_1_2_1 + 4.166666666666662e-02*G7_2_1_4_1_3_2 - 4.166666666666661e-02*G7_2_1_4_2_0_0 - 4.166666666666662e-02*G7_2_1_4_2_0_1 - 4.166666666666662e-02*G7_2_1_4_2_0_2 + 4.166666666666661e-02*G7_2_1_4_2_1_0 + 4.166666666666662e-02*G7_2_1_4_2_2_1 + 4.166666666666662e-02*G7_2_1_4_2_3_2 - 4.166666666666660e-02*G7_2_1_5_0_0_0 - 4.166666666666661e-02*G7_2_1_5_0_0_1 - 4.166666666666661e-02*G7_2_1_5_0_0_2 + 4.166666666666660e-02*G7_2_1_5_0_1_0 + 4.166666666666661e-02*G7_2_1_5_0_2_1 + 4.166666666666661e-02*G7_2_1_5_0_3_2 - 4.166666666666661e-02*G7_2_1_5_1_0_0 - 4.166666666666662e-02*G7_2_1_5_1_0_1 - 4.166666666666662e-02*G7_2_1_5_1_0_2 + 4.166666666666661e-02*G7_2_1_5_1_1_0 + 4.166666666666662e-02*G7_2_1_5_1_2_1 + 4.166666666666662e-02*G7_2_1_5_1_3_2 - 4.166666666666661e-02*G7_2_1_5_2_0_0 - 4.166666666666662e-02*G7_2_1_5_2_0_1 - 4.166666666666662e-02*G7_2_1_5_2_0_2 + 4.166666666666661e-02*G7_2_1_5_2_1_0 + 4.166666666666662e-02*G7_2_1_5_2_2_1 + 4.166666666666662e-02*G7_2_1_5_2_3_2 - 4.166666666666660e-02*G7_2_1_6_0_0_0 - 4.166666666666661e-02*G7_2_1_6_0_0_1 - 4.166666666666661e-02*G7_2_1_6_0_0_2 + 4.166666666666660e-02*G7_2_1_6_0_1_0 + 4.166666666666661e-02*G7_2_1_6_0_2_1 + 4.166666666666661e-02*G7_2_1_6_0_3_2 - 4.166666666666661e-02*G7_2_1_6_1_0_0 - 4.166666666666662e-02*G7_2_1_6_1_0_1 - 4.166666666666662e-02*G7_2_1_6_1_0_2 + 4.166666666666661e-02*G7_2_1_6_1_1_0 + 4.166666666666662e-02*G7_2_1_6_1_2_1 + 4.166666666666662e-02*G7_2_1_6_1_3_2 - 4.166666666666661e-02*G7_2_1_6_2_0_0 - 4.166666666666662e-02*G7_2_1_6_2_0_1 - 4.166666666666662e-02*G7_2_1_6_2_0_2 + 4.166666666666661e-02*G7_2_1_6_2_1_0 + 4.166666666666662e-02*G7_2_1_6_2_2_1 + 4.166666666666662e-02*G7_2_1_6_2_3_2 - 4.166666666666660e-02*G7_2_1_7_0_0_0 - 4.166666666666661e-02*G7_2_1_7_0_0_1 - 4.166666666666661e-02*G7_2_1_7_0_0_2 + 4.166666666666660e-02*G7_2_1_7_0_1_0 + 4.166666666666661e-02*G7_2_1_7_0_2_1 + 4.166666666666661e-02*G7_2_1_7_0_3_2 - 4.166666666666661e-02*G7_2_1_7_1_0_0 - 4.166666666666662e-02*G7_2_1_7_1_0_1 - 4.166666666666662e-02*G7_2_1_7_1_0_2 + 4.166666666666661e-02*G7_2_1_7_1_1_0 + 4.166666666666662e-02*G7_2_1_7_1_2_1 + 4.166666666666662e-02*G7_2_1_7_1_3_2 - 4.166666666666661e-02*G7_2_1_7_2_0_0 - 4.166666666666662e-02*G7_2_1_7_2_0_1 - 4.166666666666662e-02*G7_2_1_7_2_0_2 + 4.166666666666661e-02*G7_2_1_7_2_1_0 + 4.166666666666662e-02*G7_2_1_7_2_2_1 + 4.166666666666662e-02*G7_2_1_7_2_3_2 - 4.166666666666660e-02*G7_2_2_8_0_0_0 - 4.166666666666661e-02*G7_2_2_8_0_0_1 - 4.166666666666661e-02*G7_2_2_8_0_0_2 + 4.166666666666660e-02*G7_2_2_8_0_1_0 + 4.166666666666661e-02*G7_2_2_8_0_2_1 + 4.166666666666661e-02*G7_2_2_8_0_3_2 - 4.166666666666661e-02*G7_2_2_8_1_0_0 - 4.166666666666662e-02*G7_2_2_8_1_0_1 - 4.166666666666662e-02*G7_2_2_8_1_0_2 + 4.166666666666661e-02*G7_2_2_8_1_1_0 + 4.166666666666662e-02*G7_2_2_8_1_2_1 + 4.166666666666662e-02*G7_2_2_8_1_3_2 - 4.166666666666661e-02*G7_2_2_8_2_0_0 - 4.166666666666662e-02*G7_2_2_8_2_0_1 - 4.166666666666662e-02*G7_2_2_8_2_0_2 + 4.166666666666661e-02*G7_2_2_8_2_1_0 + 4.166666666666662e-02*G7_2_2_8_2_2_1 + 4.166666666666662e-02*G7_2_2_8_2_3_2 - 4.166666666666660e-02*G7_2_2_9_0_0_0 - 4.166666666666661e-02*G7_2_2_9_0_0_1 - 4.166666666666661e-02*G7_2_2_9_0_0_2 + 4.166666666666660e-02*G7_2_2_9_0_1_0 + 4.166666666666661e-02*G7_2_2_9_0_2_1 + 4.166666666666661e-02*G7_2_2_9_0_3_2 - 4.166666666666661e-02*G7_2_2_9_1_0_0 - 4.166666666666662e-02*G7_2_2_9_1_0_1 - 4.166666666666662e-02*G7_2_2_9_1_0_2 + 4.166666666666661e-02*G7_2_2_9_1_1_0 + 4.166666666666662e-02*G7_2_2_9_1_2_1 + 4.166666666666662e-02*G7_2_2_9_1_3_2 - 4.166666666666661e-02*G7_2_2_9_2_0_0 - 4.166666666666662e-02*G7_2_2_9_2_0_1 - 4.166666666666662e-02*G7_2_2_9_2_0_2 + 4.166666666666661e-02*G7_2_2_9_2_1_0 + 4.166666666666662e-02*G7_2_2_9_2_2_1 + 4.166666666666662e-02*G7_2_2_9_2_3_2 - 4.166666666666660e-02*G7_2_2_10_0_0_0 - 4.166666666666661e-02*G7_2_2_10_0_0_1 - 4.166666666666661e-02*G7_2_2_10_0_0_2 + 4.166666666666660e-02*G7_2_2_10_0_1_0 + 4.166666666666661e-02*G7_2_2_10_0_2_1 + 4.166666666666661e-02*G7_2_2_10_0_3_2 - 4.166666666666661e-02*G7_2_2_10_1_0_0 - 4.166666666666662e-02*G7_2_2_10_1_0_1 - 4.166666666666662e-02*G7_2_2_10_1_0_2 + 4.166666666666661e-02*G7_2_2_10_1_1_0 + 4.166666666666662e-02*G7_2_2_10_1_2_1 + 4.166666666666662e-02*G7_2_2_10_1_3_2 - 4.166666666666661e-02*G7_2_2_10_2_0_0 - 4.166666666666662e-02*G7_2_2_10_2_0_1 - 4.166666666666662e-02*G7_2_2_10_2_0_2 + 4.166666666666661e-02*G7_2_2_10_2_1_0 + 4.166666666666662e-02*G7_2_2_10_2_2_1 + 4.166666666666662e-02*G7_2_2_10_2_3_2 - 4.166666666666660e-02*G7_2_2_11_0_0_0 - 4.166666666666661e-02*G7_2_2_11_0_0_1 - 4.166666666666661e-02*G7_2_2_11_0_0_2 + 4.166666666666660e-02*G7_2_2_11_0_1_0 + 4.166666666666661e-02*G7_2_2_11_0_2_1 + 4.166666666666661e-02*G7_2_2_11_0_3_2 - 4.166666666666661e-02*G7_2_2_11_1_0_0 - 4.166666666666662e-02*G7_2_2_11_1_0_1 - 4.166666666666662e-02*G7_2_2_11_1_0_2 + 4.166666666666661e-02*G7_2_2_11_1_1_0 + 4.166666666666662e-02*G7_2_2_11_1_2_1 + 4.166666666666662e-02*G7_2_2_11_1_3_2 - 4.166666666666661e-02*G7_2_2_11_2_0_0 - 4.166666666666662e-02*G7_2_2_11_2_0_1 - 4.166666666666662e-02*G7_2_2_11_2_0_2 + 4.166666666666661e-02*G7_2_2_11_2_1_0 + 4.166666666666662e-02*G7_2_2_11_2_2_1 + 4.166666666666662e-02*G7_2_2_11_2_3_2 - 8.333333333333320e-02*G8_2_0_0_0_0 - 8.333333333333322e-02*G8_2_0_0_0_1 - 8.333333333333320e-02*G8_2_0_0_0_2 + 8.333333333333320e-02*G8_2_0_0_1_0 + 8.333333333333322e-02*G8_2_0_0_2_1 + 8.333333333333322e-02*G8_2_0_0_3_2 - 8.333333333333322e-02*G8_2_0_1_0_0 - 8.333333333333323e-02*G8_2_0_1_0_1 - 8.333333333333322e-02*G8_2_0_1_0_2 + 8.333333333333322e-02*G8_2_0_1_1_0 + 8.333333333333323e-02*G8_2_0_1_2_1 + 8.333333333333323e-02*G8_2_0_1_3_2 - 8.333333333333322e-02*G8_2_0_2_0_0 - 8.333333333333323e-02*G8_2_0_2_0_1 - 8.333333333333322e-02*G8_2_0_2_0_2 + 8.333333333333322e-02*G8_2_0_2_1_0 + 8.333333333333323e-02*G8_2_0_2_2_1 + 8.333333333333323e-02*G8_2_0_2_3_2 - 8.333333333333320e-02*G8_2_1_0_4_0 - 8.333333333333322e-02*G8_2_1_0_4_1 - 8.333333333333322e-02*G8_2_1_0_4_2 + 8.333333333333320e-02*G8_2_1_0_5_0 + 8.333333333333322e-02*G8_2_1_0_6_1 + 8.333333333333322e-02*G8_2_1_0_7_2 - 8.333333333333322e-02*G8_2_1_1_4_0 - 8.333333333333323e-02*G8_2_1_1_4_1 - 8.333333333333323e-02*G8_2_1_1_4_2 + 8.333333333333322e-02*G8_2_1_1_5_0 + 8.333333333333323e-02*G8_2_1_1_6_1 + 8.333333333333323e-02*G8_2_1_1_7_2 - 8.333333333333322e-02*G8_2_1_2_4_0 - 8.333333333333323e-02*G8_2_1_2_4_1 - 8.333333333333323e-02*G8_2_1_2_4_2 + 8.333333333333322e-02*G8_2_1_2_5_0 + 8.333333333333323e-02*G8_2_1_2_6_1 + 8.333333333333323e-02*G8_2_1_2_7_2 - 8.333333333333320e-02*G8_2_2_0_8_0 - 8.333333333333322e-02*G8_2_2_0_8_1 - 8.333333333333322e-02*G8_2_2_0_8_2 + 8.333333333333320e-02*G8_2_2_0_9_0 + 8.333333333333322e-02*G8_2_2_0_10_1 + 8.333333333333322e-02*G8_2_2_0_11_2 - 8.333333333333322e-02*G8_2_2_1_8_0 - 8.333333333333323e-02*G8_2_2_1_8_1 - 8.333333333333323e-02*G8_2_2_1_8_2 + 8.333333333333322e-02*G8_2_2_1_9_0 + 8.333333333333323e-02*G8_2_2_1_10_1 + 8.333333333333323e-02*G8_2_2_1_11_2 - 8.333333333333322e-02*G8_2_2_2_8_0 - 8.333333333333323e-02*G8_2_2_2_8_1 - 8.333333333333323e-02*G8_2_2_2_8_2 + 8.333333333333322e-02*G8_2_2_2_9_0 + 8.333333333333323e-02*G8_2_2_2_10_1 + 8.333333333333323e-02*G8_2_2_2_11_2;
    block[9] = 8.333333333333309e-03*G0_8 + 1.666666666666662e-02*G0_9 + 8.333333333333312e-03*G0_10 + 8.333333333333314e-03*G0_11 + 8.333333333333309e-03*G1_8 + 1.666666666666662e-02*G1_9 + 8.333333333333312e-03*G1_10 + 8.333333333333314e-03*G1_11 + 4.166666666666661e-02*G2_2_0_0 + 4.166666666666661e-02*G2_2_0_1 + 4.166666666666661e-02*G2_2_0_2 + 4.166666666666661e-02*G2_2_0_3 + 1.666666666666662e-02*G3_0_0_0_8 + 8.333333333333311e-03*G3_0_0_0_9 + 8.333333333333309e-03*G3_0_0_0_10 + 8.333333333333312e-03*G3_0_0_0_11 + 8.333333333333307e-03*G3_0_1_0_8 + 1.666666666666662e-02*G3_0_1_0_9 + 8.333333333333309e-03*G3_0_1_0_10 + 8.333333333333311e-03*G3_0_1_0_11 + 8.333333333333307e-03*G3_0_2_0_8 + 8.333333333333311e-03*G3_0_2_0_9 + 1.666666666666662e-02*G3_0_2_0_10 + 8.333333333333311e-03*G3_0_2_0_11 + 8.333333333333312e-03*G3_0_3_0_8 + 8.333333333333312e-03*G3_0_3_0_9 + 8.333333333333311e-03*G3_0_3_0_10 + 1.666666666666662e-02*G3_0_3_0_11 + 1.666666666666662e-02*G3_1_4_0_8 + 8.333333333333309e-03*G3_1_4_0_9 + 8.333333333333307e-03*G3_1_4_0_10 + 8.333333333333312e-03*G3_1_4_0_11 + 8.333333333333309e-03*G3_1_5_0_8 + 1.666666666666662e-02*G3_1_5_0_9 + 8.333333333333311e-03*G3_1_5_0_10 + 8.333333333333312e-03*G3_1_5_0_11 + 8.333333333333307e-03*G3_1_6_0_8 + 8.333333333333311e-03*G3_1_6_0_9 + 1.666666666666662e-02*G3_1_6_0_10 + 8.333333333333311e-03*G3_1_6_0_11 + 8.333333333333312e-03*G3_1_7_0_8 + 8.333333333333312e-03*G3_1_7_0_9 + 8.333333333333311e-03*G3_1_7_0_10 + 1.666666666666662e-02*G3_1_7_0_11 + 1.666666666666662e-02*G3_2_8_0_8 + 8.333333333333309e-03*G3_2_8_0_9 + 8.333333333333307e-03*G3_2_8_0_10 + 8.333333333333312e-03*G3_2_8_0_11 + 8.333333333333309e-03*G3_2_9_0_8 + 1.666666666666662e-02*G3_2_9_0_9 + 8.333333333333311e-03*G3_2_9_0_10 + 8.333333333333312e-03*G3_2_9_0_11 + 8.333333333333307e-03*G3_2_10_0_8 + 8.333333333333311e-03*G3_2_10_0_9 + 1.666666666666662e-02*G3_2_10_0_10 + 8.333333333333311e-03*G3_2_10_0_11 + 8.333333333333312e-03*G3_2_11_0_8 + 8.333333333333312e-03*G3_2_11_0_9 + 8.333333333333311e-03*G3_2_11_0_10 + 1.666666666666662e-02*G3_2_11_0_11 + 8.333333333333320e-02*G4_0_8_0 + 8.333333333333322e-02*G4_0_8_1 + 8.333333333333322e-02*G4_0_8_2 - 8.333333333333320e-02*G4_0_9_0 - 8.333333333333322e-02*G4_0_10_1 - 8.333333333333322e-02*G4_0_11_2 + 4.166666666666655e-03*G5_0_0_8_0 + 4.166666666666655e-03*G5_0_0_8_1 + 4.166666666666656e-03*G5_0_0_8_2 - 4.166666666666655e-03*G5_0_0_9_0 - 4.166666666666655e-03*G5_0_0_10_1 - 4.166666666666655e-03*G5_0_0_11_2 + 8.333333333333309e-03*G5_0_1_8_0 + 8.333333333333309e-03*G5_0_1_8_1 + 8.333333333333309e-03*G5_0_1_8_2 - 8.333333333333309e-03*G5_0_1_9_0 - 8.333333333333309e-03*G5_0_1_10_1 - 8.333333333333309e-03*G5_0_1_11_2 + 4.166666666666655e-03*G5_0_2_8_0 + 4.166666666666656e-03*G5_0_2_8_1 + 4.166666666666656e-03*G5_0_2_8_2 - 4.166666666666655e-03*G5_0_2_9_0 - 4.166666666666656e-03*G5_0_2_10_1 - 4.166666666666656e-03*G5_0_2_11_2 + 4.166666666666656e-03*G5_0_3_8_0 + 4.166666666666657e-03*G5_0_3_8_1 + 4.166666666666657e-03*G5_0_3_8_2 - 4.166666666666656e-03*G5_0_3_9_0 - 4.166666666666657e-03*G5_0_3_10_1 - 4.166666666666657e-03*G5_0_3_11_2 + 4.166666666666654e-03*G5_1_4_8_0 + 4.166666666666654e-03*G5_1_4_8_1 + 4.166666666666655e-03*G5_1_4_8_2 - 4.166666666666654e-03*G5_1_4_9_0 - 4.166666666666654e-03*G5_1_4_10_1 - 4.166666666666654e-03*G5_1_4_11_2 + 8.333333333333309e-03*G5_1_5_8_0 + 8.333333333333309e-03*G5_1_5_8_1 + 8.333333333333309e-03*G5_1_5_8_2 - 8.333333333333309e-03*G5_1_5_9_0 - 8.333333333333309e-03*G5_1_5_10_1 - 8.333333333333309e-03*G5_1_5_11_2 + 4.166666666666655e-03*G5_1_6_8_0 + 4.166666666666656e-03*G5_1_6_8_1 + 4.166666666666656e-03*G5_1_6_8_2 - 4.166666666666655e-03*G5_1_6_9_0 - 4.166666666666656e-03*G5_1_6_10_1 - 4.166666666666656e-03*G5_1_6_11_2 + 4.166666666666656e-03*G5_1_7_8_0 + 4.166666666666657e-03*G5_1_7_8_1 + 4.166666666666657e-03*G5_1_7_8_2 - 4.166666666666656e-03*G5_1_7_9_0 - 4.166666666666657e-03*G5_1_7_10_1 - 4.166666666666657e-03*G5_1_7_11_2 + 4.166666666666654e-03*G5_2_8_8_0 + 4.166666666666654e-03*G5_2_8_8_1 + 4.166666666666655e-03*G5_2_8_8_2 - 4.166666666666654e-03*G5_2_8_9_0 - 4.166666666666654e-03*G5_2_8_10_1 - 4.166666666666654e-03*G5_2_8_11_2 + 8.333333333333309e-03*G5_2_9_8_0 + 8.333333333333309e-03*G5_2_9_8_1 + 8.333333333333309e-03*G5_2_9_8_2 - 8.333333333333309e-03*G5_2_9_9_0 - 8.333333333333309e-03*G5_2_9_10_1 - 8.333333333333309e-03*G5_2_9_11_2 + 4.166666666666655e-03*G5_2_10_8_0 + 4.166666666666656e-03*G5_2_10_8_1 + 4.166666666666656e-03*G5_2_10_8_2 - 4.166666666666655e-03*G5_2_10_9_0 - 4.166666666666656e-03*G5_2_10_10_1 - 4.166666666666656e-03*G5_2_10_11_2 + 4.166666666666656e-03*G5_2_11_8_0 + 4.166666666666657e-03*G5_2_11_8_1 + 4.166666666666657e-03*G5_2_11_8_2 - 4.166666666666656e-03*G5_2_11_9_0 - 4.166666666666657e-03*G5_2_11_10_1 - 4.166666666666657e-03*G5_2_11_11_2 + 8.333333333333309e-03*G6_0_0_0_0_0_8_0 + 8.333333333333309e-03*G6_0_0_0_0_0_8_1 + 8.333333333333312e-03*G6_0_0_0_0_0_8_2 - 8.333333333333309e-03*G6_0_0_0_0_0_9_0 - 8.333333333333309e-03*G6_0_0_0_0_0_10_1 - 8.333333333333309e-03*G6_0_0_0_0_0_11_2 + 4.166666666666654e-03*G6_0_0_0_0_1_8_0 + 4.166666666666654e-03*G6_0_0_0_0_1_8_1 + 4.166666666666655e-03*G6_0_0_0_0_1_8_2 - 4.166666666666654e-03*G6_0_0_0_0_1_9_0 - 4.166666666666654e-03*G6_0_0_0_0_1_10_1 - 4.166666666666654e-03*G6_0_0_0_0_1_11_2 + 4.166666666666654e-03*G6_0_0_0_0_2_8_0 + 4.166666666666654e-03*G6_0_0_0_0_2_8_1 + 4.166666666666656e-03*G6_0_0_0_0_2_8_2 - 4.166666666666654e-03*G6_0_0_0_0_2_9_0 - 4.166666666666654e-03*G6_0_0_0_0_2_10_1 - 4.166666666666654e-03*G6_0_0_0_0_2_11_2 + 4.166666666666656e-03*G6_0_0_0_0_3_8_0 + 4.166666666666656e-03*G6_0_0_0_0_3_8_1 + 4.166666666666657e-03*G6_0_0_0_0_3_8_2 - 4.166666666666656e-03*G6_0_0_0_0_3_9_0 - 4.166666666666656e-03*G6_0_0_0_0_3_10_1 - 4.166666666666656e-03*G6_0_0_0_0_3_11_2 + 4.166666666666654e-03*G6_0_0_1_0_0_8_0 + 4.166666666666654e-03*G6_0_0_1_0_0_8_1 + 4.166666666666655e-03*G6_0_0_1_0_0_8_2 - 4.166666666666654e-03*G6_0_0_1_0_0_9_0 - 4.166666666666654e-03*G6_0_0_1_0_0_10_1 - 4.166666666666654e-03*G6_0_0_1_0_0_11_2 + 8.333333333333307e-03*G6_0_0_1_0_1_8_0 + 8.333333333333307e-03*G6_0_0_1_0_1_8_1 + 8.333333333333307e-03*G6_0_0_1_0_1_8_2 - 8.333333333333307e-03*G6_0_0_1_0_1_9_0 - 8.333333333333307e-03*G6_0_0_1_0_1_10_1 - 8.333333333333307e-03*G6_0_0_1_0_1_11_2 + 4.166666666666654e-03*G6_0_0_1_0_2_8_0 + 4.166666666666654e-03*G6_0_0_1_0_2_8_1 + 4.166666666666654e-03*G6_0_0_1_0_2_8_2 - 4.166666666666654e-03*G6_0_0_1_0_2_9_0 - 4.166666666666654e-03*G6_0_0_1_0_2_10_1 - 4.166666666666654e-03*G6_0_0_1_0_2_11_2 + 4.166666666666654e-03*G6_0_0_1_0_3_8_0 + 4.166666666666655e-03*G6_0_0_1_0_3_8_1 + 4.166666666666655e-03*G6_0_0_1_0_3_8_2 - 4.166666666666654e-03*G6_0_0_1_0_3_9_0 - 4.166666666666655e-03*G6_0_0_1_0_3_10_1 - 4.166666666666655e-03*G6_0_0_1_0_3_11_2 + 4.166666666666654e-03*G6_0_0_2_0_0_8_0 + 4.166666666666654e-03*G6_0_0_2_0_0_8_1 + 4.166666666666655e-03*G6_0_0_2_0_0_8_2 - 4.166666666666654e-03*G6_0_0_2_0_0_9_0 - 4.166666666666654e-03*G6_0_0_2_0_0_10_1 - 4.166666666666654e-03*G6_0_0_2_0_0_11_2 + 4.166666666666654e-03*G6_0_0_2_0_1_8_0 + 4.166666666666654e-03*G6_0_0_2_0_1_8_1 + 4.166666666666654e-03*G6_0_0_2_0_1_8_2 - 4.166666666666654e-03*G6_0_0_2_0_1_9_0 - 4.166666666666654e-03*G6_0_0_2_0_1_10_1 - 4.166666666666654e-03*G6_0_0_2_0_1_11_2 + 8.333333333333309e-03*G6_0_0_2_0_2_8_0 + 8.333333333333309e-03*G6_0_0_2_0_2_8_1 + 8.333333333333311e-03*G6_0_0_2_0_2_8_2 - 8.333333333333309e-03*G6_0_0_2_0_2_9_0 - 8.333333333333309e-03*G6_0_0_2_0_2_10_1 - 8.333333333333309e-03*G6_0_0_2_0_2_11_2 + 4.166666666666654e-03*G6_0_0_2_0_3_8_0 + 4.166666666666655e-03*G6_0_0_2_0_3_8_1 + 4.166666666666655e-03*G6_0_0_2_0_3_8_2 - 4.166666666666654e-03*G6_0_0_2_0_3_9_0 - 4.166666666666655e-03*G6_0_0_2_0_3_10_1 - 4.166666666666655e-03*G6_0_0_2_0_3_11_2 + 4.166666666666656e-03*G6_0_0_3_0_0_8_0 + 4.166666666666656e-03*G6_0_0_3_0_0_8_1 + 4.166666666666657e-03*G6_0_0_3_0_0_8_2 - 4.166666666666656e-03*G6_0_0_3_0_0_9_0 - 4.166666666666656e-03*G6_0_0_3_0_0_10_1 - 4.166666666666656e-03*G6_0_0_3_0_0_11_2 + 4.166666666666654e-03*G6_0_0_3_0_1_8_0 + 4.166666666666655e-03*G6_0_0_3_0_1_8_1 + 4.166666666666655e-03*G6_0_0_3_0_1_8_2 - 4.166666666666654e-03*G6_0_0_3_0_1_9_0 - 4.166666666666655e-03*G6_0_0_3_0_1_10_1 - 4.166666666666655e-03*G6_0_0_3_0_1_11_2 + 4.166666666666655e-03*G6_0_0_3_0_2_8_0 + 4.166666666666655e-03*G6_0_0_3_0_2_8_1 + 4.166666666666655e-03*G6_0_0_3_0_2_8_2 - 4.166666666666655e-03*G6_0_0_3_0_2_9_0 - 4.166666666666655e-03*G6_0_0_3_0_2_10_1 - 4.166666666666655e-03*G6_0_0_3_0_2_11_2 + 8.333333333333309e-03*G6_0_0_3_0_3_8_0 + 8.333333333333311e-03*G6_0_0_3_0_3_8_1 + 8.333333333333311e-03*G6_0_0_3_0_3_8_2 - 8.333333333333309e-03*G6_0_0_3_0_3_9_0 - 8.333333333333311e-03*G6_0_0_3_0_3_10_1 - 8.333333333333311e-03*G6_0_0_3_0_3_11_2 + 8.333333333333309e-03*G6_0_1_0_0_4_8_0 + 8.333333333333309e-03*G6_0_1_0_0_4_8_1 + 8.333333333333311e-03*G6_0_1_0_0_4_8_2 - 8.333333333333309e-03*G6_0_1_0_0_4_9_0 - 8.333333333333309e-03*G6_0_1_0_0_4_10_1 - 8.333333333333309e-03*G6_0_1_0_0_4_11_2 + 4.166666666666654e-03*G6_0_1_0_0_5_8_0 + 4.166666666666655e-03*G6_0_1_0_0_5_8_1 + 4.166666666666655e-03*G6_0_1_0_0_5_8_2 - 4.166666666666654e-03*G6_0_1_0_0_5_9_0 - 4.166666666666655e-03*G6_0_1_0_0_5_10_1 - 4.166666666666655e-03*G6_0_1_0_0_5_11_2 + 4.166666666666654e-03*G6_0_1_0_0_6_8_0 + 4.166666666666654e-03*G6_0_1_0_0_6_8_1 + 4.166666666666656e-03*G6_0_1_0_0_6_8_2 - 4.166666666666654e-03*G6_0_1_0_0_6_9_0 - 4.166666666666654e-03*G6_0_1_0_0_6_10_1 - 4.166666666666654e-03*G6_0_1_0_0_6_11_2 + 4.166666666666656e-03*G6_0_1_0_0_7_8_0 + 4.166666666666656e-03*G6_0_1_0_0_7_8_1 + 4.166666666666657e-03*G6_0_1_0_0_7_8_2 - 4.166666666666656e-03*G6_0_1_0_0_7_9_0 - 4.166666666666656e-03*G6_0_1_0_0_7_10_1 - 4.166666666666656e-03*G6_0_1_0_0_7_11_2 + 4.166666666666654e-03*G6_0_1_1_0_4_8_0 + 4.166666666666654e-03*G6_0_1_1_0_4_8_1 + 4.166666666666654e-03*G6_0_1_1_0_4_8_2 - 4.166666666666654e-03*G6_0_1_1_0_4_9_0 - 4.166666666666654e-03*G6_0_1_1_0_4_10_1 - 4.166666666666654e-03*G6_0_1_1_0_4_11_2 + 8.333333333333307e-03*G6_0_1_1_0_5_8_0 + 8.333333333333309e-03*G6_0_1_1_0_5_8_1 + 8.333333333333309e-03*G6_0_1_1_0_5_8_2 - 8.333333333333307e-03*G6_0_1_1_0_5_9_0 - 8.333333333333309e-03*G6_0_1_1_0_5_10_1 - 8.333333333333309e-03*G6_0_1_1_0_5_11_2 + 4.166666666666654e-03*G6_0_1_1_0_6_8_0 + 4.166666666666654e-03*G6_0_1_1_0_6_8_1 + 4.166666666666654e-03*G6_0_1_1_0_6_8_2 - 4.166666666666654e-03*G6_0_1_1_0_6_9_0 - 4.166666666666654e-03*G6_0_1_1_0_6_10_1 - 4.166666666666654e-03*G6_0_1_1_0_6_11_2 + 4.166666666666654e-03*G6_0_1_1_0_7_8_0 + 4.166666666666655e-03*G6_0_1_1_0_7_8_1 + 4.166666666666655e-03*G6_0_1_1_0_7_8_2 - 4.166666666666654e-03*G6_0_1_1_0_7_9_0 - 4.166666666666655e-03*G6_0_1_1_0_7_10_1 - 4.166666666666655e-03*G6_0_1_1_0_7_11_2 + 4.166666666666653e-03*G6_0_1_2_0_4_8_0 + 4.166666666666654e-03*G6_0_1_2_0_4_8_1 + 4.166666666666654e-03*G6_0_1_2_0_4_8_2 - 4.166666666666653e-03*G6_0_1_2_0_4_9_0 - 4.166666666666654e-03*G6_0_1_2_0_4_10_1 - 4.166666666666654e-03*G6_0_1_2_0_4_11_2 + 4.166666666666654e-03*G6_0_1_2_0_5_8_0 + 4.166666666666655e-03*G6_0_1_2_0_5_8_1 + 4.166666666666655e-03*G6_0_1_2_0_5_8_2 - 4.166666666666654e-03*G6_0_1_2_0_5_9_0 - 4.166666666666655e-03*G6_0_1_2_0_5_10_1 - 4.166666666666655e-03*G6_0_1_2_0_5_11_2 + 8.333333333333309e-03*G6_0_1_2_0_6_8_0 + 8.333333333333309e-03*G6_0_1_2_0_6_8_1 + 8.333333333333311e-03*G6_0_1_2_0_6_8_2 - 8.333333333333309e-03*G6_0_1_2_0_6_9_0 - 8.333333333333309e-03*G6_0_1_2_0_6_10_1 - 8.333333333333309e-03*G6_0_1_2_0_6_11_2 + 4.166666666666654e-03*G6_0_1_2_0_7_8_0 + 4.166666666666655e-03*G6_0_1_2_0_7_8_1 + 4.166666666666655e-03*G6_0_1_2_0_7_8_2 - 4.166666666666654e-03*G6_0_1_2_0_7_9_0 - 4.166666666666655e-03*G6_0_1_2_0_7_10_1 - 4.166666666666655e-03*G6_0_1_2_0_7_11_2 + 4.166666666666655e-03*G6_0_1_3_0_4_8_0 + 4.166666666666656e-03*G6_0_1_3_0_4_8_1 + 4.166666666666657e-03*G6_0_1_3_0_4_8_2 - 4.166666666666655e-03*G6_0_1_3_0_4_9_0 - 4.166666666666656e-03*G6_0_1_3_0_4_10_1 - 4.166666666666656e-03*G6_0_1_3_0_4_11_2 + 4.166666666666655e-03*G6_0_1_3_0_5_8_0 + 4.166666666666656e-03*G6_0_1_3_0_5_8_1 + 4.166666666666656e-03*G6_0_1_3_0_5_8_2 - 4.166666666666655e-03*G6_0_1_3_0_5_9_0 - 4.166666666666656e-03*G6_0_1_3_0_5_10_1 - 4.166666666666656e-03*G6_0_1_3_0_5_11_2 + 4.166666666666655e-03*G6_0_1_3_0_6_8_0 + 4.166666666666655e-03*G6_0_1_3_0_6_8_1 + 4.166666666666655e-03*G6_0_1_3_0_6_8_2 - 4.166666666666655e-03*G6_0_1_3_0_6_9_0 - 4.166666666666655e-03*G6_0_1_3_0_6_10_1 - 4.166666666666655e-03*G6_0_1_3_0_6_11_2 + 8.333333333333309e-03*G6_0_1_3_0_7_8_0 + 8.333333333333311e-03*G6_0_1_3_0_7_8_1 + 8.333333333333311e-03*G6_0_1_3_0_7_8_2 - 8.333333333333309e-03*G6_0_1_3_0_7_9_0 - 8.333333333333311e-03*G6_0_1_3_0_7_10_1 - 8.333333333333311e-03*G6_0_1_3_0_7_11_2 + 8.333333333333309e-03*G6_0_2_0_0_8_8_0 + 8.333333333333309e-03*G6_0_2_0_0_8_8_1 + 8.333333333333311e-03*G6_0_2_0_0_8_8_2 - 8.333333333333309e-03*G6_0_2_0_0_8_9_0 - 8.333333333333309e-03*G6_0_2_0_0_8_10_1 - 8.333333333333309e-03*G6_0_2_0_0_8_11_2 + 4.166666666666654e-03*G6_0_2_0_0_9_8_0 + 4.166666666666655e-03*G6_0_2_0_0_9_8_1 + 4.166666666666655e-03*G6_0_2_0_0_9_8_2 - 4.166666666666654e-03*G6_0_2_0_0_9_9_0 - 4.166666666666655e-03*G6_0_2_0_0_9_10_1 - 4.166666666666655e-03*G6_0_2_0_0_9_11_2 + 4.166666666666654e-03*G6_0_2_0_0_10_8_0 + 4.166666666666654e-03*G6_0_2_0_0_10_8_1 + 4.166666666666656e-03*G6_0_2_0_0_10_8_2 - 4.166666666666654e-03*G6_0_2_0_0_10_9_0 - 4.166666666666654e-03*G6_0_2_0_0_10_10_1 - 4.166666666666654e-03*G6_0_2_0_0_10_11_2 + 4.166666666666656e-03*G6_0_2_0_0_11_8_0 + 4.166666666666656e-03*G6_0_2_0_0_11_8_1 + 4.166666666666657e-03*G6_0_2_0_0_11_8_2 - 4.166666666666656e-03*G6_0_2_0_0_11_9_0 - 4.166666666666656e-03*G6_0_2_0_0_11_10_1 - 4.166666666666656e-03*G6_0_2_0_0_11_11_2 + 4.166666666666654e-03*G6_0_2_1_0_8_8_0 + 4.166666666666654e-03*G6_0_2_1_0_8_8_1 + 4.166666666666654e-03*G6_0_2_1_0_8_8_2 - 4.166666666666654e-03*G6_0_2_1_0_8_9_0 - 4.166666666666654e-03*G6_0_2_1_0_8_10_1 - 4.166666666666654e-03*G6_0_2_1_0_8_11_2 + 8.333333333333307e-03*G6_0_2_1_0_9_8_0 + 8.333333333333309e-03*G6_0_2_1_0_9_8_1 + 8.333333333333309e-03*G6_0_2_1_0_9_8_2 - 8.333333333333307e-03*G6_0_2_1_0_9_9_0 - 8.333333333333309e-03*G6_0_2_1_0_9_10_1 - 8.333333333333309e-03*G6_0_2_1_0_9_11_2 + 4.166666666666654e-03*G6_0_2_1_0_10_8_0 + 4.166666666666654e-03*G6_0_2_1_0_10_8_1 + 4.166666666666654e-03*G6_0_2_1_0_10_8_2 - 4.166666666666654e-03*G6_0_2_1_0_10_9_0 - 4.166666666666654e-03*G6_0_2_1_0_10_10_1 - 4.166666666666654e-03*G6_0_2_1_0_10_11_2 + 4.166666666666654e-03*G6_0_2_1_0_11_8_0 + 4.166666666666655e-03*G6_0_2_1_0_11_8_1 + 4.166666666666655e-03*G6_0_2_1_0_11_8_2 - 4.166666666666654e-03*G6_0_2_1_0_11_9_0 - 4.166666666666655e-03*G6_0_2_1_0_11_10_1 - 4.166666666666655e-03*G6_0_2_1_0_11_11_2 + 4.166666666666653e-03*G6_0_2_2_0_8_8_0 + 4.166666666666654e-03*G6_0_2_2_0_8_8_1 + 4.166666666666654e-03*G6_0_2_2_0_8_8_2 - 4.166666666666653e-03*G6_0_2_2_0_8_9_0 - 4.166666666666654e-03*G6_0_2_2_0_8_10_1 - 4.166666666666654e-03*G6_0_2_2_0_8_11_2 + 4.166666666666654e-03*G6_0_2_2_0_9_8_0 + 4.166666666666655e-03*G6_0_2_2_0_9_8_1 + 4.166666666666655e-03*G6_0_2_2_0_9_8_2 - 4.166666666666654e-03*G6_0_2_2_0_9_9_0 - 4.166666666666655e-03*G6_0_2_2_0_9_10_1 - 4.166666666666655e-03*G6_0_2_2_0_9_11_2 + 8.333333333333309e-03*G6_0_2_2_0_10_8_0 + 8.333333333333309e-03*G6_0_2_2_0_10_8_1 + 8.333333333333311e-03*G6_0_2_2_0_10_8_2 - 8.333333333333309e-03*G6_0_2_2_0_10_9_0 - 8.333333333333309e-03*G6_0_2_2_0_10_10_1 - 8.333333333333309e-03*G6_0_2_2_0_10_11_2 + 4.166666666666654e-03*G6_0_2_2_0_11_8_0 + 4.166666666666655e-03*G6_0_2_2_0_11_8_1 + 4.166666666666655e-03*G6_0_2_2_0_11_8_2 - 4.166666666666654e-03*G6_0_2_2_0_11_9_0 - 4.166666666666655e-03*G6_0_2_2_0_11_10_1 - 4.166666666666655e-03*G6_0_2_2_0_11_11_2 + 4.166666666666655e-03*G6_0_2_3_0_8_8_0 + 4.166666666666656e-03*G6_0_2_3_0_8_8_1 + 4.166666666666657e-03*G6_0_2_3_0_8_8_2 - 4.166666666666655e-03*G6_0_2_3_0_8_9_0 - 4.166666666666656e-03*G6_0_2_3_0_8_10_1 - 4.166666666666656e-03*G6_0_2_3_0_8_11_2 + 4.166666666666655e-03*G6_0_2_3_0_9_8_0 + 4.166666666666656e-03*G6_0_2_3_0_9_8_1 + 4.166666666666656e-03*G6_0_2_3_0_9_8_2 - 4.166666666666655e-03*G6_0_2_3_0_9_9_0 - 4.166666666666656e-03*G6_0_2_3_0_9_10_1 - 4.166666666666656e-03*G6_0_2_3_0_9_11_2 + 4.166666666666655e-03*G6_0_2_3_0_10_8_0 + 4.166666666666655e-03*G6_0_2_3_0_10_8_1 + 4.166666666666655e-03*G6_0_2_3_0_10_8_2 - 4.166666666666655e-03*G6_0_2_3_0_10_9_0 - 4.166666666666655e-03*G6_0_2_3_0_10_10_1 - 4.166666666666655e-03*G6_0_2_3_0_10_11_2 + 8.333333333333309e-03*G6_0_2_3_0_11_8_0 + 8.333333333333311e-03*G6_0_2_3_0_11_8_1 + 8.333333333333311e-03*G6_0_2_3_0_11_8_2 - 8.333333333333309e-03*G6_0_2_3_0_11_9_0 - 8.333333333333311e-03*G6_0_2_3_0_11_10_1 - 8.333333333333311e-03*G6_0_2_3_0_11_11_2 + 8.333333333333309e-03*G6_1_0_4_0_0_8_0 + 8.333333333333309e-03*G6_1_0_4_0_0_8_1 + 8.333333333333311e-03*G6_1_0_4_0_0_8_2 - 8.333333333333309e-03*G6_1_0_4_0_0_9_0 - 8.333333333333309e-03*G6_1_0_4_0_0_10_1 - 8.333333333333309e-03*G6_1_0_4_0_0_11_2 + 4.166666666666654e-03*G6_1_0_4_0_1_8_0 + 4.166666666666654e-03*G6_1_0_4_0_1_8_1 + 4.166666666666654e-03*G6_1_0_4_0_1_8_2 - 4.166666666666654e-03*G6_1_0_4_0_1_9_0 - 4.166666666666654e-03*G6_1_0_4_0_1_10_1 - 4.166666666666654e-03*G6_1_0_4_0_1_11_2 + 4.166666666666653e-03*G6_1_0_4_0_2_8_0 + 4.166666666666654e-03*G6_1_0_4_0_2_8_1 + 4.166666666666654e-03*G6_1_0_4_0_2_8_2 - 4.166666666666653e-03*G6_1_0_4_0_2_9_0 - 4.166666666666654e-03*G6_1_0_4_0_2_10_1 - 4.166666666666654e-03*G6_1_0_4_0_2_11_2 + 4.166666666666654e-03*G6_1_0_4_0_3_8_0 + 4.166666666666656e-03*G6_1_0_4_0_3_8_1 + 4.166666666666657e-03*G6_1_0_4_0_3_8_2 - 4.166666666666654e-03*G6_1_0_4_0_3_9_0 - 4.166666666666656e-03*G6_1_0_4_0_3_10_1 - 4.166666666666656e-03*G6_1_0_4_0_3_11_2 + 4.166666666666654e-03*G6_1_0_5_0_0_8_0 + 4.166666666666655e-03*G6_1_0_5_0_0_8_1 + 4.166666666666655e-03*G6_1_0_5_0_0_8_2 - 4.166666666666654e-03*G6_1_0_5_0_0_9_0 - 4.166666666666655e-03*G6_1_0_5_0_0_10_1 - 4.166666666666655e-03*G6_1_0_5_0_0_11_2 + 8.333333333333307e-03*G6_1_0_5_0_1_8_0 + 8.333333333333309e-03*G6_1_0_5_0_1_8_1 + 8.333333333333309e-03*G6_1_0_5_0_1_8_2 - 8.333333333333307e-03*G6_1_0_5_0_1_9_0 - 8.333333333333309e-03*G6_1_0_5_0_1_10_1 - 8.333333333333309e-03*G6_1_0_5_0_1_11_2 + 4.166666666666654e-03*G6_1_0_5_0_2_8_0 + 4.166666666666655e-03*G6_1_0_5_0_2_8_1 + 4.166666666666655e-03*G6_1_0_5_0_2_8_2 - 4.166666666666654e-03*G6_1_0_5_0_2_9_0 - 4.166666666666655e-03*G6_1_0_5_0_2_10_1 - 4.166666666666655e-03*G6_1_0_5_0_2_11_2 + 4.166666666666655e-03*G6_1_0_5_0_3_8_0 + 4.166666666666656e-03*G6_1_0_5_0_3_8_1 + 4.166666666666656e-03*G6_1_0_5_0_3_8_2 - 4.166666666666655e-03*G6_1_0_5_0_3_9_0 - 4.166666666666656e-03*G6_1_0_5_0_3_10_1 - 4.166666666666656e-03*G6_1_0_5_0_3_11_2 + 4.166666666666654e-03*G6_1_0_6_0_0_8_0 + 4.166666666666654e-03*G6_1_0_6_0_0_8_1 + 4.166666666666655e-03*G6_1_0_6_0_0_8_2 - 4.166666666666654e-03*G6_1_0_6_0_0_9_0 - 4.166666666666654e-03*G6_1_0_6_0_0_10_1 - 4.166666666666654e-03*G6_1_0_6_0_0_11_2 + 4.166666666666654e-03*G6_1_0_6_0_1_8_0 + 4.166666666666654e-03*G6_1_0_6_0_1_8_1 + 4.166666666666654e-03*G6_1_0_6_0_1_8_2 - 4.166666666666654e-03*G6_1_0_6_0_1_9_0 - 4.166666666666654e-03*G6_1_0_6_0_1_10_1 - 4.166666666666654e-03*G6_1_0_6_0_1_11_2 + 8.333333333333309e-03*G6_1_0_6_0_2_8_0 + 8.333333333333309e-03*G6_1_0_6_0_2_8_1 + 8.333333333333311e-03*G6_1_0_6_0_2_8_2 - 8.333333333333309e-03*G6_1_0_6_0_2_9_0 - 8.333333333333309e-03*G6_1_0_6_0_2_10_1 - 8.333333333333309e-03*G6_1_0_6_0_2_11_2 + 4.166666666666654e-03*G6_1_0_6_0_3_8_0 + 4.166666666666655e-03*G6_1_0_6_0_3_8_1 + 4.166666666666655e-03*G6_1_0_6_0_3_8_2 - 4.166666666666654e-03*G6_1_0_6_0_3_9_0 - 4.166666666666655e-03*G6_1_0_6_0_3_10_1 - 4.166666666666655e-03*G6_1_0_6_0_3_11_2 + 4.166666666666656e-03*G6_1_0_7_0_0_8_0 + 4.166666666666656e-03*G6_1_0_7_0_0_8_1 + 4.166666666666657e-03*G6_1_0_7_0_0_8_2 - 4.166666666666656e-03*G6_1_0_7_0_0_9_0 - 4.166666666666656e-03*G6_1_0_7_0_0_10_1 - 4.166666666666656e-03*G6_1_0_7_0_0_11_2 + 4.166666666666654e-03*G6_1_0_7_0_1_8_0 + 4.166666666666655e-03*G6_1_0_7_0_1_8_1 + 4.166666666666655e-03*G6_1_0_7_0_1_8_2 - 4.166666666666654e-03*G6_1_0_7_0_1_9_0 - 4.166666666666655e-03*G6_1_0_7_0_1_10_1 - 4.166666666666655e-03*G6_1_0_7_0_1_11_2 + 4.166666666666655e-03*G6_1_0_7_0_2_8_0 + 4.166666666666655e-03*G6_1_0_7_0_2_8_1 + 4.166666666666655e-03*G6_1_0_7_0_2_8_2 - 4.166666666666655e-03*G6_1_0_7_0_2_9_0 - 4.166666666666655e-03*G6_1_0_7_0_2_10_1 - 4.166666666666655e-03*G6_1_0_7_0_2_11_2 + 8.333333333333309e-03*G6_1_0_7_0_3_8_0 + 8.333333333333311e-03*G6_1_0_7_0_3_8_1 + 8.333333333333311e-03*G6_1_0_7_0_3_8_2 - 8.333333333333309e-03*G6_1_0_7_0_3_9_0 - 8.333333333333311e-03*G6_1_0_7_0_3_10_1 - 8.333333333333311e-03*G6_1_0_7_0_3_11_2 + 8.333333333333309e-03*G6_1_1_4_0_4_8_0 + 8.333333333333309e-03*G6_1_1_4_0_4_8_1 + 8.333333333333311e-03*G6_1_1_4_0_4_8_2 - 8.333333333333309e-03*G6_1_1_4_0_4_9_0 - 8.333333333333309e-03*G6_1_1_4_0_4_10_1 - 8.333333333333309e-03*G6_1_1_4_0_4_11_2 + 4.166666666666654e-03*G6_1_1_4_0_5_8_0 + 4.166666666666654e-03*G6_1_1_4_0_5_8_1 + 4.166666666666654e-03*G6_1_1_4_0_5_8_2 - 4.166666666666654e-03*G6_1_1_4_0_5_9_0 - 4.166666666666654e-03*G6_1_1_4_0_5_10_1 - 4.166666666666654e-03*G6_1_1_4_0_5_11_2 + 4.166666666666653e-03*G6_1_1_4_0_6_8_0 + 4.166666666666654e-03*G6_1_1_4_0_6_8_1 + 4.166666666666654e-03*G6_1_1_4_0_6_8_2 - 4.166666666666653e-03*G6_1_1_4_0_6_9_0 - 4.166666666666654e-03*G6_1_1_4_0_6_10_1 - 4.166666666666654e-03*G6_1_1_4_0_6_11_2 + 4.166666666666654e-03*G6_1_1_4_0_7_8_0 + 4.166666666666656e-03*G6_1_1_4_0_7_8_1 + 4.166666666666657e-03*G6_1_1_4_0_7_8_2 - 4.166666666666654e-03*G6_1_1_4_0_7_9_0 - 4.166666666666656e-03*G6_1_1_4_0_7_10_1 - 4.166666666666656e-03*G6_1_1_4_0_7_11_2 + 4.166666666666654e-03*G6_1_1_5_0_4_8_0 + 4.166666666666654e-03*G6_1_1_5_0_4_8_1 + 4.166666666666654e-03*G6_1_1_5_0_4_8_2 - 4.166666666666654e-03*G6_1_1_5_0_4_9_0 - 4.166666666666654e-03*G6_1_1_5_0_4_10_1 - 4.166666666666654e-03*G6_1_1_5_0_4_11_2 + 8.333333333333307e-03*G6_1_1_5_0_5_8_0 + 8.333333333333309e-03*G6_1_1_5_0_5_8_1 + 8.333333333333309e-03*G6_1_1_5_0_5_8_2 - 8.333333333333307e-03*G6_1_1_5_0_5_9_0 - 8.333333333333309e-03*G6_1_1_5_0_5_10_1 - 8.333333333333309e-03*G6_1_1_5_0_5_11_2 + 4.166666666666654e-03*G6_1_1_5_0_6_8_0 + 4.166666666666655e-03*G6_1_1_5_0_6_8_1 + 4.166666666666655e-03*G6_1_1_5_0_6_8_2 - 4.166666666666654e-03*G6_1_1_5_0_6_9_0 - 4.166666666666655e-03*G6_1_1_5_0_6_10_1 - 4.166666666666655e-03*G6_1_1_5_0_6_11_2 + 4.166666666666655e-03*G6_1_1_5_0_7_8_0 + 4.166666666666656e-03*G6_1_1_5_0_7_8_1 + 4.166666666666656e-03*G6_1_1_5_0_7_8_2 - 4.166666666666655e-03*G6_1_1_5_0_7_9_0 - 4.166666666666656e-03*G6_1_1_5_0_7_10_1 - 4.166666666666656e-03*G6_1_1_5_0_7_11_2 + 4.166666666666653e-03*G6_1_1_6_0_4_8_0 + 4.166666666666654e-03*G6_1_1_6_0_4_8_1 + 4.166666666666654e-03*G6_1_1_6_0_4_8_2 - 4.166666666666653e-03*G6_1_1_6_0_4_9_0 - 4.166666666666654e-03*G6_1_1_6_0_4_10_1 - 4.166666666666654e-03*G6_1_1_6_0_4_11_2 + 4.166666666666654e-03*G6_1_1_6_0_5_8_0 + 4.166666666666655e-03*G6_1_1_6_0_5_8_1 + 4.166666666666655e-03*G6_1_1_6_0_5_8_2 - 4.166666666666654e-03*G6_1_1_6_0_5_9_0 - 4.166666666666655e-03*G6_1_1_6_0_5_10_1 - 4.166666666666655e-03*G6_1_1_6_0_5_11_2 + 8.333333333333309e-03*G6_1_1_6_0_6_8_0 + 8.333333333333309e-03*G6_1_1_6_0_6_8_1 + 8.333333333333311e-03*G6_1_1_6_0_6_8_2 - 8.333333333333309e-03*G6_1_1_6_0_6_9_0 - 8.333333333333309e-03*G6_1_1_6_0_6_10_1 - 8.333333333333309e-03*G6_1_1_6_0_6_11_2 + 4.166666666666654e-03*G6_1_1_6_0_7_8_0 + 4.166666666666655e-03*G6_1_1_6_0_7_8_1 + 4.166666666666655e-03*G6_1_1_6_0_7_8_2 - 4.166666666666654e-03*G6_1_1_6_0_7_9_0 - 4.166666666666655e-03*G6_1_1_6_0_7_10_1 - 4.166666666666655e-03*G6_1_1_6_0_7_11_2 + 4.166666666666655e-03*G6_1_1_7_0_4_8_0 + 4.166666666666656e-03*G6_1_1_7_0_4_8_1 + 4.166666666666657e-03*G6_1_1_7_0_4_8_2 - 4.166666666666655e-03*G6_1_1_7_0_4_9_0 - 4.166666666666656e-03*G6_1_1_7_0_4_10_1 - 4.166666666666656e-03*G6_1_1_7_0_4_11_2 + 4.166666666666655e-03*G6_1_1_7_0_5_8_0 + 4.166666666666656e-03*G6_1_1_7_0_5_8_1 + 4.166666666666656e-03*G6_1_1_7_0_5_8_2 - 4.166666666666655e-03*G6_1_1_7_0_5_9_0 - 4.166666666666656e-03*G6_1_1_7_0_5_10_1 - 4.166666666666656e-03*G6_1_1_7_0_5_11_2 + 4.166666666666655e-03*G6_1_1_7_0_6_8_0 + 4.166666666666655e-03*G6_1_1_7_0_6_8_1 + 4.166666666666655e-03*G6_1_1_7_0_6_8_2 - 4.166666666666655e-03*G6_1_1_7_0_6_9_0 - 4.166666666666655e-03*G6_1_1_7_0_6_10_1 - 4.166666666666655e-03*G6_1_1_7_0_6_11_2 + 8.333333333333309e-03*G6_1_1_7_0_7_8_0 + 8.333333333333311e-03*G6_1_1_7_0_7_8_1 + 8.333333333333311e-03*G6_1_1_7_0_7_8_2 - 8.333333333333309e-03*G6_1_1_7_0_7_9_0 - 8.333333333333311e-03*G6_1_1_7_0_7_10_1 - 8.333333333333311e-03*G6_1_1_7_0_7_11_2 + 8.333333333333309e-03*G6_1_2_4_0_8_8_0 + 8.333333333333309e-03*G6_1_2_4_0_8_8_1 + 8.333333333333311e-03*G6_1_2_4_0_8_8_2 - 8.333333333333309e-03*G6_1_2_4_0_8_9_0 - 8.333333333333309e-03*G6_1_2_4_0_8_10_1 - 8.333333333333309e-03*G6_1_2_4_0_8_11_2 + 4.166666666666654e-03*G6_1_2_4_0_9_8_0 + 4.166666666666654e-03*G6_1_2_4_0_9_8_1 + 4.166666666666654e-03*G6_1_2_4_0_9_8_2 - 4.166666666666654e-03*G6_1_2_4_0_9_9_0 - 4.166666666666654e-03*G6_1_2_4_0_9_10_1 - 4.166666666666654e-03*G6_1_2_4_0_9_11_2 + 4.166666666666653e-03*G6_1_2_4_0_10_8_0 + 4.166666666666654e-03*G6_1_2_4_0_10_8_1 + 4.166666666666654e-03*G6_1_2_4_0_10_8_2 - 4.166666666666653e-03*G6_1_2_4_0_10_9_0 - 4.166666666666654e-03*G6_1_2_4_0_10_10_1 - 4.166666666666654e-03*G6_1_2_4_0_10_11_2 + 4.166666666666654e-03*G6_1_2_4_0_11_8_0 + 4.166666666666656e-03*G6_1_2_4_0_11_8_1 + 4.166666666666657e-03*G6_1_2_4_0_11_8_2 - 4.166666666666654e-03*G6_1_2_4_0_11_9_0 - 4.166666666666656e-03*G6_1_2_4_0_11_10_1 - 4.166666666666656e-03*G6_1_2_4_0_11_11_2 + 4.166666666666654e-03*G6_1_2_5_0_8_8_0 + 4.166666666666654e-03*G6_1_2_5_0_8_8_1 + 4.166666666666654e-03*G6_1_2_5_0_8_8_2 - 4.166666666666654e-03*G6_1_2_5_0_8_9_0 - 4.166666666666654e-03*G6_1_2_5_0_8_10_1 - 4.166666666666654e-03*G6_1_2_5_0_8_11_2 + 8.333333333333307e-03*G6_1_2_5_0_9_8_0 + 8.333333333333309e-03*G6_1_2_5_0_9_8_1 + 8.333333333333309e-03*G6_1_2_5_0_9_8_2 - 8.333333333333307e-03*G6_1_2_5_0_9_9_0 - 8.333333333333309e-03*G6_1_2_5_0_9_10_1 - 8.333333333333309e-03*G6_1_2_5_0_9_11_2 + 4.166666666666654e-03*G6_1_2_5_0_10_8_0 + 4.166666666666655e-03*G6_1_2_5_0_10_8_1 + 4.166666666666655e-03*G6_1_2_5_0_10_8_2 - 4.166666666666654e-03*G6_1_2_5_0_10_9_0 - 4.166666666666655e-03*G6_1_2_5_0_10_10_1 - 4.166666666666655e-03*G6_1_2_5_0_10_11_2 + 4.166666666666655e-03*G6_1_2_5_0_11_8_0 + 4.166666666666656e-03*G6_1_2_5_0_11_8_1 + 4.166666666666656e-03*G6_1_2_5_0_11_8_2 - 4.166666666666655e-03*G6_1_2_5_0_11_9_0 - 4.166666666666656e-03*G6_1_2_5_0_11_10_1 - 4.166666666666656e-03*G6_1_2_5_0_11_11_2 + 4.166666666666653e-03*G6_1_2_6_0_8_8_0 + 4.166666666666654e-03*G6_1_2_6_0_8_8_1 + 4.166666666666654e-03*G6_1_2_6_0_8_8_2 - 4.166666666666653e-03*G6_1_2_6_0_8_9_0 - 4.166666666666654e-03*G6_1_2_6_0_8_10_1 - 4.166666666666654e-03*G6_1_2_6_0_8_11_2 + 4.166666666666654e-03*G6_1_2_6_0_9_8_0 + 4.166666666666655e-03*G6_1_2_6_0_9_8_1 + 4.166666666666655e-03*G6_1_2_6_0_9_8_2 - 4.166666666666654e-03*G6_1_2_6_0_9_9_0 - 4.166666666666655e-03*G6_1_2_6_0_9_10_1 - 4.166666666666655e-03*G6_1_2_6_0_9_11_2 + 8.333333333333309e-03*G6_1_2_6_0_10_8_0 + 8.333333333333309e-03*G6_1_2_6_0_10_8_1 + 8.333333333333311e-03*G6_1_2_6_0_10_8_2 - 8.333333333333309e-03*G6_1_2_6_0_10_9_0 - 8.333333333333309e-03*G6_1_2_6_0_10_10_1 - 8.333333333333309e-03*G6_1_2_6_0_10_11_2 + 4.166666666666654e-03*G6_1_2_6_0_11_8_0 + 4.166666666666655e-03*G6_1_2_6_0_11_8_1 + 4.166666666666655e-03*G6_1_2_6_0_11_8_2 - 4.166666666666654e-03*G6_1_2_6_0_11_9_0 - 4.166666666666655e-03*G6_1_2_6_0_11_10_1 - 4.166666666666655e-03*G6_1_2_6_0_11_11_2 + 4.166666666666655e-03*G6_1_2_7_0_8_8_0 + 4.166666666666656e-03*G6_1_2_7_0_8_8_1 + 4.166666666666657e-03*G6_1_2_7_0_8_8_2 - 4.166666666666655e-03*G6_1_2_7_0_8_9_0 - 4.166666666666656e-03*G6_1_2_7_0_8_10_1 - 4.166666666666656e-03*G6_1_2_7_0_8_11_2 + 4.166666666666655e-03*G6_1_2_7_0_9_8_0 + 4.166666666666656e-03*G6_1_2_7_0_9_8_1 + 4.166666666666656e-03*G6_1_2_7_0_9_8_2 - 4.166666666666655e-03*G6_1_2_7_0_9_9_0 - 4.166666666666656e-03*G6_1_2_7_0_9_10_1 - 4.166666666666656e-03*G6_1_2_7_0_9_11_2 + 4.166666666666655e-03*G6_1_2_7_0_10_8_0 + 4.166666666666655e-03*G6_1_2_7_0_10_8_1 + 4.166666666666655e-03*G6_1_2_7_0_10_8_2 - 4.166666666666655e-03*G6_1_2_7_0_10_9_0 - 4.166666666666655e-03*G6_1_2_7_0_10_10_1 - 4.166666666666655e-03*G6_1_2_7_0_10_11_2 + 8.333333333333309e-03*G6_1_2_7_0_11_8_0 + 8.333333333333311e-03*G6_1_2_7_0_11_8_1 + 8.333333333333311e-03*G6_1_2_7_0_11_8_2 - 8.333333333333309e-03*G6_1_2_7_0_11_9_0 - 8.333333333333311e-03*G6_1_2_7_0_11_10_1 - 8.333333333333311e-03*G6_1_2_7_0_11_11_2 + 8.333333333333309e-03*G6_2_0_8_0_0_8_0 + 8.333333333333309e-03*G6_2_0_8_0_0_8_1 + 8.333333333333311e-03*G6_2_0_8_0_0_8_2 - 8.333333333333309e-03*G6_2_0_8_0_0_9_0 - 8.333333333333309e-03*G6_2_0_8_0_0_10_1 - 8.333333333333309e-03*G6_2_0_8_0_0_11_2 + 4.166666666666654e-03*G6_2_0_8_0_1_8_0 + 4.166666666666654e-03*G6_2_0_8_0_1_8_1 + 4.166666666666654e-03*G6_2_0_8_0_1_8_2 - 4.166666666666654e-03*G6_2_0_8_0_1_9_0 - 4.166666666666654e-03*G6_2_0_8_0_1_10_1 - 4.166666666666654e-03*G6_2_0_8_0_1_11_2 + 4.166666666666653e-03*G6_2_0_8_0_2_8_0 + 4.166666666666654e-03*G6_2_0_8_0_2_8_1 + 4.166666666666654e-03*G6_2_0_8_0_2_8_2 - 4.166666666666653e-03*G6_2_0_8_0_2_9_0 - 4.166666666666654e-03*G6_2_0_8_0_2_10_1 - 4.166666666666654e-03*G6_2_0_8_0_2_11_2 + 4.166666666666654e-03*G6_2_0_8_0_3_8_0 + 4.166666666666656e-03*G6_2_0_8_0_3_8_1 + 4.166666666666657e-03*G6_2_0_8_0_3_8_2 - 4.166666666666654e-03*G6_2_0_8_0_3_9_0 - 4.166666666666656e-03*G6_2_0_8_0_3_10_1 - 4.166666666666656e-03*G6_2_0_8_0_3_11_2 + 4.166666666666654e-03*G6_2_0_9_0_0_8_0 + 4.166666666666655e-03*G6_2_0_9_0_0_8_1 + 4.166666666666655e-03*G6_2_0_9_0_0_8_2 - 4.166666666666654e-03*G6_2_0_9_0_0_9_0 - 4.166666666666655e-03*G6_2_0_9_0_0_10_1 - 4.166666666666655e-03*G6_2_0_9_0_0_11_2 + 8.333333333333307e-03*G6_2_0_9_0_1_8_0 + 8.333333333333309e-03*G6_2_0_9_0_1_8_1 + 8.333333333333309e-03*G6_2_0_9_0_1_8_2 - 8.333333333333307e-03*G6_2_0_9_0_1_9_0 - 8.333333333333309e-03*G6_2_0_9_0_1_10_1 - 8.333333333333309e-03*G6_2_0_9_0_1_11_2 + 4.166666666666654e-03*G6_2_0_9_0_2_8_0 + 4.166666666666655e-03*G6_2_0_9_0_2_8_1 + 4.166666666666655e-03*G6_2_0_9_0_2_8_2 - 4.166666666666654e-03*G6_2_0_9_0_2_9_0 - 4.166666666666655e-03*G6_2_0_9_0_2_10_1 - 4.166666666666655e-03*G6_2_0_9_0_2_11_2 + 4.166666666666655e-03*G6_2_0_9_0_3_8_0 + 4.166666666666656e-03*G6_2_0_9_0_3_8_1 + 4.166666666666656e-03*G6_2_0_9_0_3_8_2 - 4.166666666666655e-03*G6_2_0_9_0_3_9_0 - 4.166666666666656e-03*G6_2_0_9_0_3_10_1 - 4.166666666666656e-03*G6_2_0_9_0_3_11_2 + 4.166666666666654e-03*G6_2_0_10_0_0_8_0 + 4.166666666666654e-03*G6_2_0_10_0_0_8_1 + 4.166666666666655e-03*G6_2_0_10_0_0_8_2 - 4.166666666666654e-03*G6_2_0_10_0_0_9_0 - 4.166666666666654e-03*G6_2_0_10_0_0_10_1 - 4.166666666666654e-03*G6_2_0_10_0_0_11_2 + 4.166666666666654e-03*G6_2_0_10_0_1_8_0 + 4.166666666666654e-03*G6_2_0_10_0_1_8_1 + 4.166666666666654e-03*G6_2_0_10_0_1_8_2 - 4.166666666666654e-03*G6_2_0_10_0_1_9_0 - 4.166666666666654e-03*G6_2_0_10_0_1_10_1 - 4.166666666666654e-03*G6_2_0_10_0_1_11_2 + 8.333333333333309e-03*G6_2_0_10_0_2_8_0 + 8.333333333333309e-03*G6_2_0_10_0_2_8_1 + 8.333333333333311e-03*G6_2_0_10_0_2_8_2 - 8.333333333333309e-03*G6_2_0_10_0_2_9_0 - 8.333333333333309e-03*G6_2_0_10_0_2_10_1 - 8.333333333333309e-03*G6_2_0_10_0_2_11_2 + 4.166666666666654e-03*G6_2_0_10_0_3_8_0 + 4.166666666666655e-03*G6_2_0_10_0_3_8_1 + 4.166666666666655e-03*G6_2_0_10_0_3_8_2 - 4.166666666666654e-03*G6_2_0_10_0_3_9_0 - 4.166666666666655e-03*G6_2_0_10_0_3_10_1 - 4.166666666666655e-03*G6_2_0_10_0_3_11_2 + 4.166666666666656e-03*G6_2_0_11_0_0_8_0 + 4.166666666666656e-03*G6_2_0_11_0_0_8_1 + 4.166666666666657e-03*G6_2_0_11_0_0_8_2 - 4.166666666666656e-03*G6_2_0_11_0_0_9_0 - 4.166666666666656e-03*G6_2_0_11_0_0_10_1 - 4.166666666666656e-03*G6_2_0_11_0_0_11_2 + 4.166666666666654e-03*G6_2_0_11_0_1_8_0 + 4.166666666666655e-03*G6_2_0_11_0_1_8_1 + 4.166666666666655e-03*G6_2_0_11_0_1_8_2 - 4.166666666666654e-03*G6_2_0_11_0_1_9_0 - 4.166666666666655e-03*G6_2_0_11_0_1_10_1 - 4.166666666666655e-03*G6_2_0_11_0_1_11_2 + 4.166666666666655e-03*G6_2_0_11_0_2_8_0 + 4.166666666666655e-03*G6_2_0_11_0_2_8_1 + 4.166666666666655e-03*G6_2_0_11_0_2_8_2 - 4.166666666666655e-03*G6_2_0_11_0_2_9_0 - 4.166666666666655e-03*G6_2_0_11_0_2_10_1 - 4.166666666666655e-03*G6_2_0_11_0_2_11_2 + 8.333333333333309e-03*G6_2_0_11_0_3_8_0 + 8.333333333333311e-03*G6_2_0_11_0_3_8_1 + 8.333333333333311e-03*G6_2_0_11_0_3_8_2 - 8.333333333333309e-03*G6_2_0_11_0_3_9_0 - 8.333333333333311e-03*G6_2_0_11_0_3_10_1 - 8.333333333333311e-03*G6_2_0_11_0_3_11_2 + 8.333333333333309e-03*G6_2_1_8_0_4_8_0 + 8.333333333333309e-03*G6_2_1_8_0_4_8_1 + 8.333333333333311e-03*G6_2_1_8_0_4_8_2 - 8.333333333333309e-03*G6_2_1_8_0_4_9_0 - 8.333333333333309e-03*G6_2_1_8_0_4_10_1 - 8.333333333333309e-03*G6_2_1_8_0_4_11_2 + 4.166666666666654e-03*G6_2_1_8_0_5_8_0 + 4.166666666666654e-03*G6_2_1_8_0_5_8_1 + 4.166666666666654e-03*G6_2_1_8_0_5_8_2 - 4.166666666666654e-03*G6_2_1_8_0_5_9_0 - 4.166666666666654e-03*G6_2_1_8_0_5_10_1 - 4.166666666666654e-03*G6_2_1_8_0_5_11_2 + 4.166666666666653e-03*G6_2_1_8_0_6_8_0 + 4.166666666666654e-03*G6_2_1_8_0_6_8_1 + 4.166666666666654e-03*G6_2_1_8_0_6_8_2 - 4.166666666666653e-03*G6_2_1_8_0_6_9_0 - 4.166666666666654e-03*G6_2_1_8_0_6_10_1 - 4.166666666666654e-03*G6_2_1_8_0_6_11_2 + 4.166666666666654e-03*G6_2_1_8_0_7_8_0 + 4.166666666666656e-03*G6_2_1_8_0_7_8_1 + 4.166666666666657e-03*G6_2_1_8_0_7_8_2 - 4.166666666666654e-03*G6_2_1_8_0_7_9_0 - 4.166666666666656e-03*G6_2_1_8_0_7_10_1 - 4.166666666666656e-03*G6_2_1_8_0_7_11_2 + 4.166666666666654e-03*G6_2_1_9_0_4_8_0 + 4.166666666666654e-03*G6_2_1_9_0_4_8_1 + 4.166666666666654e-03*G6_2_1_9_0_4_8_2 - 4.166666666666654e-03*G6_2_1_9_0_4_9_0 - 4.166666666666654e-03*G6_2_1_9_0_4_10_1 - 4.166666666666654e-03*G6_2_1_9_0_4_11_2 + 8.333333333333307e-03*G6_2_1_9_0_5_8_0 + 8.333333333333309e-03*G6_2_1_9_0_5_8_1 + 8.333333333333309e-03*G6_2_1_9_0_5_8_2 - 8.333333333333307e-03*G6_2_1_9_0_5_9_0 - 8.333333333333309e-03*G6_2_1_9_0_5_10_1 - 8.333333333333309e-03*G6_2_1_9_0_5_11_2 + 4.166666666666654e-03*G6_2_1_9_0_6_8_0 + 4.166666666666655e-03*G6_2_1_9_0_6_8_1 + 4.166666666666655e-03*G6_2_1_9_0_6_8_2 - 4.166666666666654e-03*G6_2_1_9_0_6_9_0 - 4.166666666666655e-03*G6_2_1_9_0_6_10_1 - 4.166666666666655e-03*G6_2_1_9_0_6_11_2 + 4.166666666666655e-03*G6_2_1_9_0_7_8_0 + 4.166666666666656e-03*G6_2_1_9_0_7_8_1 + 4.166666666666656e-03*G6_2_1_9_0_7_8_2 - 4.166666666666655e-03*G6_2_1_9_0_7_9_0 - 4.166666666666656e-03*G6_2_1_9_0_7_10_1 - 4.166666666666656e-03*G6_2_1_9_0_7_11_2 + 4.166666666666653e-03*G6_2_1_10_0_4_8_0 + 4.166666666666654e-03*G6_2_1_10_0_4_8_1 + 4.166666666666654e-03*G6_2_1_10_0_4_8_2 - 4.166666666666653e-03*G6_2_1_10_0_4_9_0 - 4.166666666666654e-03*G6_2_1_10_0_4_10_1 - 4.166666666666654e-03*G6_2_1_10_0_4_11_2 + 4.166666666666654e-03*G6_2_1_10_0_5_8_0 + 4.166666666666655e-03*G6_2_1_10_0_5_8_1 + 4.166666666666655e-03*G6_2_1_10_0_5_8_2 - 4.166666666666654e-03*G6_2_1_10_0_5_9_0 - 4.166666666666655e-03*G6_2_1_10_0_5_10_1 - 4.166666666666655e-03*G6_2_1_10_0_5_11_2 + 8.333333333333309e-03*G6_2_1_10_0_6_8_0 + 8.333333333333309e-03*G6_2_1_10_0_6_8_1 + 8.333333333333311e-03*G6_2_1_10_0_6_8_2 - 8.333333333333309e-03*G6_2_1_10_0_6_9_0 - 8.333333333333309e-03*G6_2_1_10_0_6_10_1 - 8.333333333333309e-03*G6_2_1_10_0_6_11_2 + 4.166666666666654e-03*G6_2_1_10_0_7_8_0 + 4.166666666666655e-03*G6_2_1_10_0_7_8_1 + 4.166666666666655e-03*G6_2_1_10_0_7_8_2 - 4.166666666666654e-03*G6_2_1_10_0_7_9_0 - 4.166666666666655e-03*G6_2_1_10_0_7_10_1 - 4.166666666666655e-03*G6_2_1_10_0_7_11_2 + 4.166666666666655e-03*G6_2_1_11_0_4_8_0 + 4.166666666666656e-03*G6_2_1_11_0_4_8_1 + 4.166666666666657e-03*G6_2_1_11_0_4_8_2 - 4.166666666666655e-03*G6_2_1_11_0_4_9_0 - 4.166666666666656e-03*G6_2_1_11_0_4_10_1 - 4.166666666666656e-03*G6_2_1_11_0_4_11_2 + 4.166666666666655e-03*G6_2_1_11_0_5_8_0 + 4.166666666666656e-03*G6_2_1_11_0_5_8_1 + 4.166666666666656e-03*G6_2_1_11_0_5_8_2 - 4.166666666666655e-03*G6_2_1_11_0_5_9_0 - 4.166666666666656e-03*G6_2_1_11_0_5_10_1 - 4.166666666666656e-03*G6_2_1_11_0_5_11_2 + 4.166666666666655e-03*G6_2_1_11_0_6_8_0 + 4.166666666666655e-03*G6_2_1_11_0_6_8_1 + 4.166666666666655e-03*G6_2_1_11_0_6_8_2 - 4.166666666666655e-03*G6_2_1_11_0_6_9_0 - 4.166666666666655e-03*G6_2_1_11_0_6_10_1 - 4.166666666666655e-03*G6_2_1_11_0_6_11_2 + 8.333333333333309e-03*G6_2_1_11_0_7_8_0 + 8.333333333333311e-03*G6_2_1_11_0_7_8_1 + 8.333333333333311e-03*G6_2_1_11_0_7_8_2 - 8.333333333333309e-03*G6_2_1_11_0_7_9_0 - 8.333333333333311e-03*G6_2_1_11_0_7_10_1 - 8.333333333333311e-03*G6_2_1_11_0_7_11_2 + 8.333333333333309e-03*G6_2_2_8_0_8_8_0 + 8.333333333333309e-03*G6_2_2_8_0_8_8_1 + 8.333333333333311e-03*G6_2_2_8_0_8_8_2 - 8.333333333333309e-03*G6_2_2_8_0_8_9_0 - 8.333333333333309e-03*G6_2_2_8_0_8_10_1 - 8.333333333333309e-03*G6_2_2_8_0_8_11_2 + 4.166666666666654e-03*G6_2_2_8_0_9_8_0 + 4.166666666666654e-03*G6_2_2_8_0_9_8_1 + 4.166666666666654e-03*G6_2_2_8_0_9_8_2 - 4.166666666666654e-03*G6_2_2_8_0_9_9_0 - 4.166666666666654e-03*G6_2_2_8_0_9_10_1 - 4.166666666666654e-03*G6_2_2_8_0_9_11_2 + 4.166666666666653e-03*G6_2_2_8_0_10_8_0 + 4.166666666666654e-03*G6_2_2_8_0_10_8_1 + 4.166666666666654e-03*G6_2_2_8_0_10_8_2 - 4.166666666666653e-03*G6_2_2_8_0_10_9_0 - 4.166666666666654e-03*G6_2_2_8_0_10_10_1 - 4.166666666666654e-03*G6_2_2_8_0_10_11_2 + 4.166666666666654e-03*G6_2_2_8_0_11_8_0 + 4.166666666666656e-03*G6_2_2_8_0_11_8_1 + 4.166666666666657e-03*G6_2_2_8_0_11_8_2 - 4.166666666666654e-03*G6_2_2_8_0_11_9_0 - 4.166666666666656e-03*G6_2_2_8_0_11_10_1 - 4.166666666666656e-03*G6_2_2_8_0_11_11_2 + 4.166666666666654e-03*G6_2_2_9_0_8_8_0 + 4.166666666666654e-03*G6_2_2_9_0_8_8_1 + 4.166666666666654e-03*G6_2_2_9_0_8_8_2 - 4.166666666666654e-03*G6_2_2_9_0_8_9_0 - 4.166666666666654e-03*G6_2_2_9_0_8_10_1 - 4.166666666666654e-03*G6_2_2_9_0_8_11_2 + 8.333333333333307e-03*G6_2_2_9_0_9_8_0 + 8.333333333333309e-03*G6_2_2_9_0_9_8_1 + 8.333333333333309e-03*G6_2_2_9_0_9_8_2 - 8.333333333333307e-03*G6_2_2_9_0_9_9_0 - 8.333333333333309e-03*G6_2_2_9_0_9_10_1 - 8.333333333333309e-03*G6_2_2_9_0_9_11_2 + 4.166666666666654e-03*G6_2_2_9_0_10_8_0 + 4.166666666666655e-03*G6_2_2_9_0_10_8_1 + 4.166666666666655e-03*G6_2_2_9_0_10_8_2 - 4.166666666666654e-03*G6_2_2_9_0_10_9_0 - 4.166666666666655e-03*G6_2_2_9_0_10_10_1 - 4.166666666666655e-03*G6_2_2_9_0_10_11_2 + 4.166666666666655e-03*G6_2_2_9_0_11_8_0 + 4.166666666666656e-03*G6_2_2_9_0_11_8_1 + 4.166666666666656e-03*G6_2_2_9_0_11_8_2 - 4.166666666666655e-03*G6_2_2_9_0_11_9_0 - 4.166666666666656e-03*G6_2_2_9_0_11_10_1 - 4.166666666666656e-03*G6_2_2_9_0_11_11_2 + 4.166666666666653e-03*G6_2_2_10_0_8_8_0 + 4.166666666666654e-03*G6_2_2_10_0_8_8_1 + 4.166666666666654e-03*G6_2_2_10_0_8_8_2 - 4.166666666666653e-03*G6_2_2_10_0_8_9_0 - 4.166666666666654e-03*G6_2_2_10_0_8_10_1 - 4.166666666666654e-03*G6_2_2_10_0_8_11_2 + 4.166666666666654e-03*G6_2_2_10_0_9_8_0 + 4.166666666666655e-03*G6_2_2_10_0_9_8_1 + 4.166666666666655e-03*G6_2_2_10_0_9_8_2 - 4.166666666666654e-03*G6_2_2_10_0_9_9_0 - 4.166666666666655e-03*G6_2_2_10_0_9_10_1 - 4.166666666666655e-03*G6_2_2_10_0_9_11_2 + 8.333333333333309e-03*G6_2_2_10_0_10_8_0 + 8.333333333333309e-03*G6_2_2_10_0_10_8_1 + 8.333333333333311e-03*G6_2_2_10_0_10_8_2 - 8.333333333333309e-03*G6_2_2_10_0_10_9_0 - 8.333333333333309e-03*G6_2_2_10_0_10_10_1 - 8.333333333333309e-03*G6_2_2_10_0_10_11_2 + 4.166666666666654e-03*G6_2_2_10_0_11_8_0 + 4.166666666666655e-03*G6_2_2_10_0_11_8_1 + 4.166666666666655e-03*G6_2_2_10_0_11_8_2 - 4.166666666666654e-03*G6_2_2_10_0_11_9_0 - 4.166666666666655e-03*G6_2_2_10_0_11_10_1 - 4.166666666666655e-03*G6_2_2_10_0_11_11_2 + 4.166666666666655e-03*G6_2_2_11_0_8_8_0 + 4.166666666666656e-03*G6_2_2_11_0_8_8_1 + 4.166666666666657e-03*G6_2_2_11_0_8_8_2 - 4.166666666666655e-03*G6_2_2_11_0_8_9_0 - 4.166666666666656e-03*G6_2_2_11_0_8_10_1 - 4.166666666666656e-03*G6_2_2_11_0_8_11_2 + 4.166666666666655e-03*G6_2_2_11_0_9_8_0 + 4.166666666666656e-03*G6_2_2_11_0_9_8_1 + 4.166666666666656e-03*G6_2_2_11_0_9_8_2 - 4.166666666666655e-03*G6_2_2_11_0_9_9_0 - 4.166666666666656e-03*G6_2_2_11_0_9_10_1 - 4.166666666666656e-03*G6_2_2_11_0_9_11_2 + 4.166666666666655e-03*G6_2_2_11_0_10_8_0 + 4.166666666666655e-03*G6_2_2_11_0_10_8_1 + 4.166666666666655e-03*G6_2_2_11_0_10_8_2 - 4.166666666666655e-03*G6_2_2_11_0_10_9_0 - 4.166666666666655e-03*G6_2_2_11_0_10_10_1 - 4.166666666666655e-03*G6_2_2_11_0_10_11_2 + 8.333333333333309e-03*G6_2_2_11_0_11_8_0 + 8.333333333333311e-03*G6_2_2_11_0_11_8_1 + 8.333333333333311e-03*G6_2_2_11_0_11_8_2 - 8.333333333333309e-03*G6_2_2_11_0_11_9_0 - 8.333333333333311e-03*G6_2_2_11_0_11_10_1 - 8.333333333333311e-03*G6_2_2_11_0_11_11_2 + 4.166666666666661e-02*G7_2_0_0_0_0_0 + 4.166666666666662e-02*G7_2_0_0_0_0_1 + 4.166666666666662e-02*G7_2_0_0_0_0_2 - 4.166666666666661e-02*G7_2_0_0_0_1_0 - 4.166666666666662e-02*G7_2_0_0_0_2_1 - 4.166666666666662e-02*G7_2_0_0_0_3_2 + 4.166666666666659e-02*G7_2_0_1_0_0_0 + 4.166666666666660e-02*G7_2_0_1_0_0_1 + 4.166666666666660e-02*G7_2_0_1_0_0_2 - 4.166666666666659e-02*G7_2_0_1_0_1_0 - 4.166666666666660e-02*G7_2_0_1_0_2_1 - 4.166666666666660e-02*G7_2_0_1_0_3_2 + 4.166666666666660e-02*G7_2_0_2_0_0_0 + 4.166666666666661e-02*G7_2_0_2_0_0_1 + 4.166666666666661e-02*G7_2_0_2_0_0_2 - 4.166666666666660e-02*G7_2_0_2_0_1_0 - 4.166666666666661e-02*G7_2_0_2_0_2_1 - 4.166666666666661e-02*G7_2_0_2_0_3_2 + 4.166666666666660e-02*G7_2_0_3_0_0_0 + 4.166666666666661e-02*G7_2_0_3_0_0_1 + 4.166666666666661e-02*G7_2_0_3_0_0_2 - 4.166666666666660e-02*G7_2_0_3_0_1_0 - 4.166666666666661e-02*G7_2_0_3_0_2_1 - 4.166666666666661e-02*G7_2_0_3_0_3_2 + 4.166666666666660e-02*G7_2_1_4_0_0_0 + 4.166666666666661e-02*G7_2_1_4_0_0_1 + 4.166666666666661e-02*G7_2_1_4_0_0_2 - 4.166666666666660e-02*G7_2_1_4_0_1_0 - 4.166666666666661e-02*G7_2_1_4_0_2_1 - 4.166666666666661e-02*G7_2_1_4_0_3_2 + 4.166666666666660e-02*G7_2_1_5_0_0_0 + 4.166666666666661e-02*G7_2_1_5_0_0_1 + 4.166666666666661e-02*G7_2_1_5_0_0_2 - 4.166666666666660e-02*G7_2_1_5_0_1_0 - 4.166666666666661e-02*G7_2_1_5_0_2_1 - 4.166666666666661e-02*G7_2_1_5_0_3_2 + 4.166666666666660e-02*G7_2_1_6_0_0_0 + 4.166666666666661e-02*G7_2_1_6_0_0_1 + 4.166666666666661e-02*G7_2_1_6_0_0_2 - 4.166666666666660e-02*G7_2_1_6_0_1_0 - 4.166666666666661e-02*G7_2_1_6_0_2_1 - 4.166666666666661e-02*G7_2_1_6_0_3_2 + 4.166666666666660e-02*G7_2_1_7_0_0_0 + 4.166666666666661e-02*G7_2_1_7_0_0_1 + 4.166666666666661e-02*G7_2_1_7_0_0_2 - 4.166666666666660e-02*G7_2_1_7_0_1_0 - 4.166666666666661e-02*G7_2_1_7_0_2_1 - 4.166666666666661e-02*G7_2_1_7_0_3_2 + 4.166666666666660e-02*G7_2_2_8_0_0_0 + 4.166666666666661e-02*G7_2_2_8_0_0_1 + 4.166666666666661e-02*G7_2_2_8_0_0_2 - 4.166666666666660e-02*G7_2_2_8_0_1_0 - 4.166666666666661e-02*G7_2_2_8_0_2_1 - 4.166666666666661e-02*G7_2_2_8_0_3_2 + 4.166666666666660e-02*G7_2_2_9_0_0_0 + 4.166666666666661e-02*G7_2_2_9_0_0_1 + 4.166666666666661e-02*G7_2_2_9_0_0_2 - 4.166666666666660e-02*G7_2_2_9_0_1_0 - 4.166666666666661e-02*G7_2_2_9_0_2_1 - 4.166666666666661e-02*G7_2_2_9_0_3_2 + 4.166666666666660e-02*G7_2_2_10_0_0_0 + 4.166666666666661e-02*G7_2_2_10_0_0_1 + 4.166666666666661e-02*G7_2_2_10_0_0_2 - 4.166666666666660e-02*G7_2_2_10_0_1_0 - 4.166666666666661e-02*G7_2_2_10_0_2_1 - 4.166666666666661e-02*G7_2_2_10_0_3_2 + 4.166666666666660e-02*G7_2_2_11_0_0_0 + 4.166666666666661e-02*G7_2_2_11_0_0_1 + 4.166666666666661e-02*G7_2_2_11_0_0_2 - 4.166666666666660e-02*G7_2_2_11_0_1_0 - 4.166666666666661e-02*G7_2_2_11_0_2_1 - 4.166666666666661e-02*G7_2_2_11_0_3_2 + 8.333333333333320e-02*G8_2_0_0_0_0 + 8.333333333333322e-02*G8_2_0_0_0_1 + 8.333333333333320e-02*G8_2_0_0_0_2 - 8.333333333333320e-02*G8_2_0_0_1_0 - 8.333333333333322e-02*G8_2_0_0_2_1 - 8.333333333333322e-02*G8_2_0_0_3_2 + 8.333333333333320e-02*G8_2_1_0_4_0 + 8.333333333333322e-02*G8_2_1_0_4_1 + 8.333333333333322e-02*G8_2_1_0_4_2 - 8.333333333333320e-02*G8_2_1_0_5_0 - 8.333333333333322e-02*G8_2_1_0_6_1 - 8.333333333333322e-02*G8_2_1_0_7_2 + 8.333333333333320e-02*G8_2_2_0_8_0 + 8.333333333333322e-02*G8_2_2_0_8_1 + 8.333333333333322e-02*G8_2_2_0_8_2 - 8.333333333333320e-02*G8_2_2_0_9_0 - 8.333333333333322e-02*G8_2_2_0_10_1 - 8.333333333333322e-02*G8_2_2_0_11_2;
    block[10] = 8.333333333333307e-03*G0_8 + 8.333333333333312e-03*G0_9 + 1.666666666666662e-02*G0_10 + 8.333333333333312e-03*G0_11 + 8.333333333333307e-03*G1_8 + 8.333333333333312e-03*G1_9 + 1.666666666666662e-02*G1_10 + 8.333333333333312e-03*G1_11 + 4.166666666666662e-02*G2_2_1_0 + 4.166666666666662e-02*G2_2_1_1 + 4.166666666666662e-02*G2_2_1_2 + 4.166666666666662e-02*G2_2_1_3 + 1.666666666666662e-02*G3_0_0_1_8 + 8.333333333333311e-03*G3_0_0_1_9 + 8.333333333333312e-03*G3_0_0_1_10 + 8.333333333333314e-03*G3_0_0_1_11 + 8.333333333333309e-03*G3_0_1_1_8 + 1.666666666666662e-02*G3_0_1_1_9 + 8.333333333333309e-03*G3_0_1_1_10 + 8.333333333333311e-03*G3_0_1_1_11 + 8.333333333333307e-03*G3_0_2_1_8 + 8.333333333333312e-03*G3_0_2_1_9 + 1.666666666666662e-02*G3_0_2_1_10 + 8.333333333333312e-03*G3_0_2_1_11 + 8.333333333333314e-03*G3_0_3_1_8 + 8.333333333333314e-03*G3_0_3_1_9 + 8.333333333333312e-03*G3_0_3_1_10 + 1.666666666666662e-02*G3_0_3_1_11 + 1.666666666666662e-02*G3_1_4_1_8 + 8.333333333333309e-03*G3_1_4_1_9 + 8.333333333333309e-03*G3_1_4_1_10 + 8.333333333333314e-03*G3_1_4_1_11 + 8.333333333333309e-03*G3_1_5_1_8 + 1.666666666666662e-02*G3_1_5_1_9 + 8.333333333333312e-03*G3_1_5_1_10 + 8.333333333333314e-03*G3_1_5_1_11 + 8.333333333333307e-03*G3_1_6_1_8 + 8.333333333333312e-03*G3_1_6_1_9 + 1.666666666666662e-02*G3_1_6_1_10 + 8.333333333333312e-03*G3_1_6_1_11 + 8.333333333333314e-03*G3_1_7_1_8 + 8.333333333333314e-03*G3_1_7_1_9 + 8.333333333333312e-03*G3_1_7_1_10 + 1.666666666666662e-02*G3_1_7_1_11 + 1.666666666666662e-02*G3_2_8_1_8 + 8.333333333333309e-03*G3_2_8_1_9 + 8.333333333333309e-03*G3_2_8_1_10 + 8.333333333333314e-03*G3_2_8_1_11 + 8.333333333333309e-03*G3_2_9_1_8 + 1.666666666666662e-02*G3_2_9_1_9 + 8.333333333333312e-03*G3_2_9_1_10 + 8.333333333333314e-03*G3_2_9_1_11 + 8.333333333333307e-03*G3_2_10_1_8 + 8.333333333333312e-03*G3_2_10_1_9 + 1.666666666666662e-02*G3_2_10_1_10 + 8.333333333333312e-03*G3_2_10_1_11 + 8.333333333333314e-03*G3_2_11_1_8 + 8.333333333333314e-03*G3_2_11_1_9 + 8.333333333333312e-03*G3_2_11_1_10 + 1.666666666666662e-02*G3_2_11_1_11 + 8.333333333333322e-02*G4_1_8_0 + 8.333333333333323e-02*G4_1_8_1 + 8.333333333333323e-02*G4_1_8_2 - 8.333333333333322e-02*G4_1_9_0 - 8.333333333333323e-02*G4_1_10_1 - 8.333333333333323e-02*G4_1_11_2 + 4.166666666666654e-03*G5_0_0_8_0 + 4.166666666666656e-03*G5_0_0_8_1 + 4.166666666666656e-03*G5_0_0_8_2 - 4.166666666666654e-03*G5_0_0_9_0 - 4.166666666666656e-03*G5_0_0_10_1 - 4.166666666666656e-03*G5_0_0_11_2 + 4.166666666666654e-03*G5_0_1_8_0 + 4.166666666666654e-03*G5_0_1_8_1 + 4.166666666666654e-03*G5_0_1_8_2 - 4.166666666666654e-03*G5_0_1_9_0 - 4.166666666666654e-03*G5_0_1_10_1 - 4.166666666666654e-03*G5_0_1_11_2 + 8.333333333333311e-03*G5_0_2_8_0 + 8.333333333333311e-03*G5_0_2_8_1 + 8.333333333333312e-03*G5_0_2_8_2 - 8.333333333333311e-03*G5_0_2_9_0 - 8.333333333333311e-03*G5_0_2_10_1 - 8.333333333333311e-03*G5_0_2_11_2 + 4.166666666666655e-03*G5_0_3_8_0 + 4.166666666666656e-03*G5_0_3_8_1 + 4.166666666666657e-03*G5_0_3_8_2 - 4.166666666666655e-03*G5_0_3_9_0 - 4.166666666666656e-03*G5_0_3_10_1 - 4.166666666666656e-03*G5_0_3_11_2 + 4.166666666666654e-03*G5_1_4_8_0 + 4.166666666666654e-03*G5_1_4_8_1 + 4.166666666666654e-03*G5_1_4_8_2 - 4.166666666666654e-03*G5_1_4_9_0 - 4.166666666666654e-03*G5_1_4_10_1 - 4.166666666666654e-03*G5_1_4_11_2 + 4.166666666666655e-03*G5_1_5_8_0 + 4.166666666666656e-03*G5_1_5_8_1 + 4.166666666666656e-03*G5_1_5_8_2 - 4.166666666666655e-03*G5_1_5_9_0 - 4.166666666666656e-03*G5_1_5_10_1 - 4.166666666666656e-03*G5_1_5_11_2 + 8.333333333333311e-03*G5_1_6_8_0 + 8.333333333333311e-03*G5_1_6_8_1 + 8.333333333333312e-03*G5_1_6_8_2 - 8.333333333333311e-03*G5_1_6_9_0 - 8.333333333333311e-03*G5_1_6_10_1 - 8.333333333333311e-03*G5_1_6_11_2 + 4.166666666666655e-03*G5_1_7_8_0 + 4.166666666666656e-03*G5_1_7_8_1 + 4.166666666666657e-03*G5_1_7_8_2 - 4.166666666666655e-03*G5_1_7_9_0 - 4.166666666666656e-03*G5_1_7_10_1 - 4.166666666666656e-03*G5_1_7_11_2 + 4.166666666666654e-03*G5_2_8_8_0 + 4.166666666666654e-03*G5_2_8_8_1 + 4.166666666666654e-03*G5_2_8_8_2 - 4.166666666666654e-03*G5_2_8_9_0 - 4.166666666666654e-03*G5_2_8_10_1 - 4.166666666666654e-03*G5_2_8_11_2 + 4.166666666666655e-03*G5_2_9_8_0 + 4.166666666666656e-03*G5_2_9_8_1 + 4.166666666666656e-03*G5_2_9_8_2 - 4.166666666666655e-03*G5_2_9_9_0 - 4.166666666666656e-03*G5_2_9_10_1 - 4.166666666666656e-03*G5_2_9_11_2 + 8.333333333333311e-03*G5_2_10_8_0 + 8.333333333333311e-03*G5_2_10_8_1 + 8.333333333333312e-03*G5_2_10_8_2 - 8.333333333333311e-03*G5_2_10_9_0 - 8.333333333333311e-03*G5_2_10_10_1 - 8.333333333333311e-03*G5_2_10_11_2 + 4.166666666666655e-03*G5_2_11_8_0 + 4.166666666666656e-03*G5_2_11_8_1 + 4.166666666666657e-03*G5_2_11_8_2 - 4.166666666666655e-03*G5_2_11_9_0 - 4.166666666666656e-03*G5_2_11_10_1 - 4.166666666666656e-03*G5_2_11_11_2 + 8.333333333333309e-03*G6_0_0_0_1_0_8_0 + 8.333333333333311e-03*G6_0_0_0_1_0_8_1 + 8.333333333333312e-03*G6_0_0_0_1_0_8_2 - 8.333333333333309e-03*G6_0_0_0_1_0_9_0 - 8.333333333333311e-03*G6_0_0_0_1_0_10_1 - 8.333333333333311e-03*G6_0_0_0_1_0_11_2 + 4.166666666666654e-03*G6_0_0_0_1_1_8_0 + 4.166666666666655e-03*G6_0_0_0_1_1_8_1 + 4.166666666666655e-03*G6_0_0_0_1_1_8_2 - 4.166666666666654e-03*G6_0_0_0_1_1_9_0 - 4.166666666666655e-03*G6_0_0_0_1_1_10_1 - 4.166666666666655e-03*G6_0_0_0_1_1_11_2 + 4.166666666666654e-03*G6_0_0_0_1_2_8_0 + 4.166666666666656e-03*G6_0_0_0_1_2_8_1 + 4.166666666666656e-03*G6_0_0_0_1_2_8_2 - 4.166666666666654e-03*G6_0_0_0_1_2_9_0 - 4.166666666666656e-03*G6_0_0_0_1_2_10_1 - 4.166666666666656e-03*G6_0_0_0_1_2_11_2 + 4.166666666666656e-03*G6_0_0_0_1_3_8_0 + 4.166666666666657e-03*G6_0_0_0_1_3_8_1 + 4.166666666666658e-03*G6_0_0_0_1_3_8_2 - 4.166666666666656e-03*G6_0_0_0_1_3_9_0 - 4.166666666666657e-03*G6_0_0_0_1_3_10_1 - 4.166666666666657e-03*G6_0_0_0_1_3_11_2 + 4.166666666666654e-03*G6_0_0_1_1_0_8_0 + 4.166666666666655e-03*G6_0_0_1_1_0_8_1 + 4.166666666666655e-03*G6_0_0_1_1_0_8_2 - 4.166666666666654e-03*G6_0_0_1_1_0_9_0 - 4.166666666666655e-03*G6_0_0_1_1_0_10_1 - 4.166666666666655e-03*G6_0_0_1_1_0_11_2 + 8.333333333333307e-03*G6_0_0_1_1_1_8_0 + 8.333333333333309e-03*G6_0_0_1_1_1_8_1 + 8.333333333333309e-03*G6_0_0_1_1_1_8_2 - 8.333333333333307e-03*G6_0_0_1_1_1_9_0 - 8.333333333333309e-03*G6_0_0_1_1_1_10_1 - 8.333333333333309e-03*G6_0_0_1_1_1_11_2 + 4.166666666666654e-03*G6_0_0_1_1_2_8_0 + 4.166666666666654e-03*G6_0_0_1_1_2_8_1 + 4.166666666666655e-03*G6_0_0_1_1_2_8_2 - 4.166666666666654e-03*G6_0_0_1_1_2_9_0 - 4.166666666666654e-03*G6_0_0_1_1_2_10_1 - 4.166666666666654e-03*G6_0_0_1_1_2_11_2 + 4.166666666666655e-03*G6_0_0_1_1_3_8_0 + 4.166666666666655e-03*G6_0_0_1_1_3_8_1 + 4.166666666666656e-03*G6_0_0_1_1_3_8_2 - 4.166666666666655e-03*G6_0_0_1_1_3_9_0 - 4.166666666666655e-03*G6_0_0_1_1_3_10_1 - 4.166666666666655e-03*G6_0_0_1_1_3_11_2 + 4.166666666666654e-03*G6_0_0_2_1_0_8_0 + 4.166666666666656e-03*G6_0_0_2_1_0_8_1 + 4.166666666666656e-03*G6_0_0_2_1_0_8_2 - 4.166666666666654e-03*G6_0_0_2_1_0_9_0 - 4.166666666666656e-03*G6_0_0_2_1_0_10_1 - 4.166666666666656e-03*G6_0_0_2_1_0_11_2 + 4.166666666666654e-03*G6_0_0_2_1_1_8_0 + 4.166666666666654e-03*G6_0_0_2_1_1_8_1 + 4.166666666666654e-03*G6_0_0_2_1_1_8_2 - 4.166666666666654e-03*G6_0_0_2_1_1_9_0 - 4.166666666666654e-03*G6_0_0_2_1_1_10_1 - 4.166666666666654e-03*G6_0_0_2_1_1_11_2 + 8.333333333333311e-03*G6_0_0_2_1_2_8_0 + 8.333333333333311e-03*G6_0_0_2_1_2_8_1 + 8.333333333333312e-03*G6_0_0_2_1_2_8_2 - 8.333333333333311e-03*G6_0_0_2_1_2_9_0 - 8.333333333333311e-03*G6_0_0_2_1_2_10_1 - 8.333333333333311e-03*G6_0_0_2_1_2_11_2 + 4.166666666666655e-03*G6_0_0_2_1_3_8_0 + 4.166666666666656e-03*G6_0_0_2_1_3_8_1 + 4.166666666666657e-03*G6_0_0_2_1_3_8_2 - 4.166666666666655e-03*G6_0_0_2_1_3_9_0 - 4.166666666666656e-03*G6_0_0_2_1_3_10_1 - 4.166666666666656e-03*G6_0_0_2_1_3_11_2 + 4.166666666666656e-03*G6_0_0_3_1_0_8_0 + 4.166666666666657e-03*G6_0_0_3_1_0_8_1 + 4.166666666666658e-03*G6_0_0_3_1_0_8_2 - 4.166666666666656e-03*G6_0_0_3_1_0_9_0 - 4.166666666666657e-03*G6_0_0_3_1_0_10_1 - 4.166666666666657e-03*G6_0_0_3_1_0_11_2 + 4.166666666666655e-03*G6_0_0_3_1_1_8_0 + 4.166666666666655e-03*G6_0_0_3_1_1_8_1 + 4.166666666666656e-03*G6_0_0_3_1_1_8_2 - 4.166666666666655e-03*G6_0_0_3_1_1_9_0 - 4.166666666666655e-03*G6_0_0_3_1_1_10_1 - 4.166666666666655e-03*G6_0_0_3_1_1_11_2 + 4.166666666666655e-03*G6_0_0_3_1_2_8_0 + 4.166666666666656e-03*G6_0_0_3_1_2_8_1 + 4.166666666666657e-03*G6_0_0_3_1_2_8_2 - 4.166666666666655e-03*G6_0_0_3_1_2_9_0 - 4.166666666666656e-03*G6_0_0_3_1_2_10_1 - 4.166666666666656e-03*G6_0_0_3_1_2_11_2 + 8.333333333333311e-03*G6_0_0_3_1_3_8_0 + 8.333333333333311e-03*G6_0_0_3_1_3_8_1 + 8.333333333333312e-03*G6_0_0_3_1_3_8_2 - 8.333333333333311e-03*G6_0_0_3_1_3_9_0 - 8.333333333333311e-03*G6_0_0_3_1_3_10_1 - 8.333333333333311e-03*G6_0_0_3_1_3_11_2 + 8.333333333333309e-03*G6_0_1_0_1_4_8_0 + 8.333333333333311e-03*G6_0_1_0_1_4_8_1 + 8.333333333333312e-03*G6_0_1_0_1_4_8_2 - 8.333333333333309e-03*G6_0_1_0_1_4_9_0 - 8.333333333333311e-03*G6_0_1_0_1_4_10_1 - 8.333333333333311e-03*G6_0_1_0_1_4_11_2 + 4.166666666666655e-03*G6_0_1_0_1_5_8_0 + 4.166666666666655e-03*G6_0_1_0_1_5_8_1 + 4.166666666666656e-03*G6_0_1_0_1_5_8_2 - 4.166666666666655e-03*G6_0_1_0_1_5_9_0 - 4.166666666666655e-03*G6_0_1_0_1_5_10_1 - 4.166666666666655e-03*G6_0_1_0_1_5_11_2 + 4.166666666666654e-03*G6_0_1_0_1_6_8_0 + 4.166666666666656e-03*G6_0_1_0_1_6_8_1 + 4.166666666666656e-03*G6_0_1_0_1_6_8_2 - 4.166666666666654e-03*G6_0_1_0_1_6_9_0 - 4.166666666666656e-03*G6_0_1_0_1_6_10_1 - 4.166666666666656e-03*G6_0_1_0_1_6_11_2 + 4.166666666666656e-03*G6_0_1_0_1_7_8_0 + 4.166666666666657e-03*G6_0_1_0_1_7_8_1 + 4.166666666666658e-03*G6_0_1_0_1_7_8_2 - 4.166666666666656e-03*G6_0_1_0_1_7_9_0 - 4.166666666666657e-03*G6_0_1_0_1_7_10_1 - 4.166666666666657e-03*G6_0_1_0_1_7_11_2 + 4.166666666666654e-03*G6_0_1_1_1_4_8_0 + 4.166666666666654e-03*G6_0_1_1_1_4_8_1 + 4.166666666666654e-03*G6_0_1_1_1_4_8_2 - 4.166666666666654e-03*G6_0_1_1_1_4_9_0 - 4.166666666666654e-03*G6_0_1_1_1_4_10_1 - 4.166666666666654e-03*G6_0_1_1_1_4_11_2 + 8.333333333333309e-03*G6_0_1_1_1_5_8_0 + 8.333333333333309e-03*G6_0_1_1_1_5_8_1 + 8.333333333333309e-03*G6_0_1_1_1_5_8_2 - 8.333333333333309e-03*G6_0_1_1_1_5_9_0 - 8.333333333333309e-03*G6_0_1_1_1_5_10_1 - 8.333333333333309e-03*G6_0_1_1_1_5_11_2 + 4.166666666666654e-03*G6_0_1_1_1_6_8_0 + 4.166666666666654e-03*G6_0_1_1_1_6_8_1 + 4.166666666666655e-03*G6_0_1_1_1_6_8_2 - 4.166666666666654e-03*G6_0_1_1_1_6_9_0 - 4.166666666666654e-03*G6_0_1_1_1_6_10_1 - 4.166666666666654e-03*G6_0_1_1_1_6_11_2 + 4.166666666666655e-03*G6_0_1_1_1_7_8_0 + 4.166666666666655e-03*G6_0_1_1_1_7_8_1 + 4.166666666666656e-03*G6_0_1_1_1_7_8_2 - 4.166666666666655e-03*G6_0_1_1_1_7_9_0 - 4.166666666666655e-03*G6_0_1_1_1_7_10_1 - 4.166666666666655e-03*G6_0_1_1_1_7_11_2 + 4.166666666666654e-03*G6_0_1_2_1_4_8_0 + 4.166666666666654e-03*G6_0_1_2_1_4_8_1 + 4.166666666666654e-03*G6_0_1_2_1_4_8_2 - 4.166666666666654e-03*G6_0_1_2_1_4_9_0 - 4.166666666666654e-03*G6_0_1_2_1_4_10_1 - 4.166666666666654e-03*G6_0_1_2_1_4_11_2 + 4.166666666666655e-03*G6_0_1_2_1_5_8_0 + 4.166666666666656e-03*G6_0_1_2_1_5_8_1 + 4.166666666666656e-03*G6_0_1_2_1_5_8_2 - 4.166666666666655e-03*G6_0_1_2_1_5_9_0 - 4.166666666666656e-03*G6_0_1_2_1_5_10_1 - 4.166666666666656e-03*G6_0_1_2_1_5_11_2 + 8.333333333333311e-03*G6_0_1_2_1_6_8_0 + 8.333333333333311e-03*G6_0_1_2_1_6_8_1 + 8.333333333333312e-03*G6_0_1_2_1_6_8_2 - 8.333333333333311e-03*G6_0_1_2_1_6_9_0 - 8.333333333333311e-03*G6_0_1_2_1_6_10_1 - 8.333333333333311e-03*G6_0_1_2_1_6_11_2 + 4.166666666666655e-03*G6_0_1_2_1_7_8_0 + 4.166666666666656e-03*G6_0_1_2_1_7_8_1 + 4.166666666666657e-03*G6_0_1_2_1_7_8_2 - 4.166666666666655e-03*G6_0_1_2_1_7_9_0 - 4.166666666666656e-03*G6_0_1_2_1_7_10_1 - 4.166666666666656e-03*G6_0_1_2_1_7_11_2 + 4.166666666666656e-03*G6_0_1_3_1_4_8_0 + 4.166666666666657e-03*G6_0_1_3_1_4_8_1 + 4.166666666666657e-03*G6_0_1_3_1_4_8_2 - 4.166666666666656e-03*G6_0_1_3_1_4_9_0 - 4.166666666666657e-03*G6_0_1_3_1_4_10_1 - 4.166666666666657e-03*G6_0_1_3_1_4_11_2 + 4.166666666666656e-03*G6_0_1_3_1_5_8_0 + 4.166666666666657e-03*G6_0_1_3_1_5_8_1 + 4.166666666666657e-03*G6_0_1_3_1_5_8_2 - 4.166666666666656e-03*G6_0_1_3_1_5_9_0 - 4.166666666666657e-03*G6_0_1_3_1_5_10_1 - 4.166666666666657e-03*G6_0_1_3_1_5_11_2 + 4.166666666666655e-03*G6_0_1_3_1_6_8_0 + 4.166666666666656e-03*G6_0_1_3_1_6_8_1 + 4.166666666666657e-03*G6_0_1_3_1_6_8_2 - 4.166666666666655e-03*G6_0_1_3_1_6_9_0 - 4.166666666666656e-03*G6_0_1_3_1_6_10_1 - 4.166666666666656e-03*G6_0_1_3_1_6_11_2 + 8.333333333333311e-03*G6_0_1_3_1_7_8_0 + 8.333333333333311e-03*G6_0_1_3_1_7_8_1 + 8.333333333333312e-03*G6_0_1_3_1_7_8_2 - 8.333333333333311e-03*G6_0_1_3_1_7_9_0 - 8.333333333333311e-03*G6_0_1_3_1_7_10_1 - 8.333333333333311e-03*G6_0_1_3_1_7_11_2 + 8.333333333333309e-03*G6_0_2_0_1_8_8_0 + 8.333333333333311e-03*G6_0_2_0_1_8_8_1 + 8.333333333333312e-03*G6_0_2_0_1_8_8_2 - 8.333333333333309e-03*G6_0_2_0_1_8_9_0 - 8.333333333333311e-03*G6_0_2_0_1_8_10_1 - 8.333333333333311e-03*G6_0_2_0_1_8_11_2 + 4.166666666666655e-03*G6_0_2_0_1_9_8_0 + 4.166666666666655e-03*G6_0_2_0_1_9_8_1 + 4.166666666666656e-03*G6_0_2_0_1_9_8_2 - 4.166666666666655e-03*G6_0_2_0_1_9_9_0 - 4.166666666666655e-03*G6_0_2_0_1_9_10_1 - 4.166666666666655e-03*G6_0_2_0_1_9_11_2 + 4.166666666666654e-03*G6_0_2_0_1_10_8_0 + 4.166666666666656e-03*G6_0_2_0_1_10_8_1 + 4.166666666666656e-03*G6_0_2_0_1_10_8_2 - 4.166666666666654e-03*G6_0_2_0_1_10_9_0 - 4.166666666666656e-03*G6_0_2_0_1_10_10_1 - 4.166666666666656e-03*G6_0_2_0_1_10_11_2 + 4.166666666666656e-03*G6_0_2_0_1_11_8_0 + 4.166666666666657e-03*G6_0_2_0_1_11_8_1 + 4.166666666666658e-03*G6_0_2_0_1_11_8_2 - 4.166666666666656e-03*G6_0_2_0_1_11_9_0 - 4.166666666666657e-03*G6_0_2_0_1_11_10_1 - 4.166666666666657e-03*G6_0_2_0_1_11_11_2 + 4.166666666666654e-03*G6_0_2_1_1_8_8_0 + 4.166666666666654e-03*G6_0_2_1_1_8_8_1 + 4.166666666666654e-03*G6_0_2_1_1_8_8_2 - 4.166666666666654e-03*G6_0_2_1_1_8_9_0 - 4.166666666666654e-03*G6_0_2_1_1_8_10_1 - 4.166666666666654e-03*G6_0_2_1_1_8_11_2 + 8.333333333333309e-03*G6_0_2_1_1_9_8_0 + 8.333333333333309e-03*G6_0_2_1_1_9_8_1 + 8.333333333333309e-03*G6_0_2_1_1_9_8_2 - 8.333333333333309e-03*G6_0_2_1_1_9_9_0 - 8.333333333333309e-03*G6_0_2_1_1_9_10_1 - 8.333333333333309e-03*G6_0_2_1_1_9_11_2 + 4.166666666666654e-03*G6_0_2_1_1_10_8_0 + 4.166666666666654e-03*G6_0_2_1_1_10_8_1 + 4.166666666666655e-03*G6_0_2_1_1_10_8_2 - 4.166666666666654e-03*G6_0_2_1_1_10_9_0 - 4.166666666666654e-03*G6_0_2_1_1_10_10_1 - 4.166666666666654e-03*G6_0_2_1_1_10_11_2 + 4.166666666666655e-03*G6_0_2_1_1_11_8_0 + 4.166666666666655e-03*G6_0_2_1_1_11_8_1 + 4.166666666666656e-03*G6_0_2_1_1_11_8_2 - 4.166666666666655e-03*G6_0_2_1_1_11_9_0 - 4.166666666666655e-03*G6_0_2_1_1_11_10_1 - 4.166666666666655e-03*G6_0_2_1_1_11_11_2 + 4.166666666666654e-03*G6_0_2_2_1_8_8_0 + 4.166666666666654e-03*G6_0_2_2_1_8_8_1 + 4.166666666666654e-03*G6_0_2_2_1_8_8_2 - 4.166666666666654e-03*G6_0_2_2_1_8_9_0 - 4.166666666666654e-03*G6_0_2_2_1_8_10_1 - 4.166666666666654e-03*G6_0_2_2_1_8_11_2 + 4.166666666666655e-03*G6_0_2_2_1_9_8_0 + 4.166666666666656e-03*G6_0_2_2_1_9_8_1 + 4.166666666666656e-03*G6_0_2_2_1_9_8_2 - 4.166666666666655e-03*G6_0_2_2_1_9_9_0 - 4.166666666666656e-03*G6_0_2_2_1_9_10_1 - 4.166666666666656e-03*G6_0_2_2_1_9_11_2 + 8.333333333333311e-03*G6_0_2_2_1_10_8_0 + 8.333333333333311e-03*G6_0_2_2_1_10_8_1 + 8.333333333333312e-03*G6_0_2_2_1_10_8_2 - 8.333333333333311e-03*G6_0_2_2_1_10_9_0 - 8.333333333333311e-03*G6_0_2_2_1_10_10_1 - 8.333333333333311e-03*G6_0_2_2_1_10_11_2 + 4.166666666666655e-03*G6_0_2_2_1_11_8_0 + 4.166666666666656e-03*G6_0_2_2_1_11_8_1 + 4.166666666666657e-03*G6_0_2_2_1_11_8_2 - 4.166666666666655e-03*G6_0_2_2_1_11_9_0 - 4.166666666666656e-03*G6_0_2_2_1_11_10_1 - 4.166666666666656e-03*G6_0_2_2_1_11_11_2 + 4.166666666666656e-03*G6_0_2_3_1_8_8_0 + 4.166666666666657e-03*G6_0_2_3_1_8_8_1 + 4.166666666666657e-03*G6_0_2_3_1_8_8_2 - 4.166666666666656e-03*G6_0_2_3_1_8_9_0 - 4.166666666666657e-03*G6_0_2_3_1_8_10_1 - 4.166666666666657e-03*G6_0_2_3_1_8_11_2 + 4.166666666666656e-03*G6_0_2_3_1_9_8_0 + 4.166666666666657e-03*G6_0_2_3_1_9_8_1 + 4.166666666666657e-03*G6_0_2_3_1_9_8_2 - 4.166666666666656e-03*G6_0_2_3_1_9_9_0 - 4.166666666666657e-03*G6_0_2_3_1_9_10_1 - 4.166666666666657e-03*G6_0_2_3_1_9_11_2 + 4.166666666666655e-03*G6_0_2_3_1_10_8_0 + 4.166666666666656e-03*G6_0_2_3_1_10_8_1 + 4.166666666666657e-03*G6_0_2_3_1_10_8_2 - 4.166666666666655e-03*G6_0_2_3_1_10_9_0 - 4.166666666666656e-03*G6_0_2_3_1_10_10_1 - 4.166666666666656e-03*G6_0_2_3_1_10_11_2 + 8.333333333333311e-03*G6_0_2_3_1_11_8_0 + 8.333333333333311e-03*G6_0_2_3_1_11_8_1 + 8.333333333333312e-03*G6_0_2_3_1_11_8_2 - 8.333333333333311e-03*G6_0_2_3_1_11_9_0 - 8.333333333333311e-03*G6_0_2_3_1_11_10_1 - 8.333333333333311e-03*G6_0_2_3_1_11_11_2 + 8.333333333333309e-03*G6_1_0_4_1_0_8_0 + 8.333333333333311e-03*G6_1_0_4_1_0_8_1 + 8.333333333333312e-03*G6_1_0_4_1_0_8_2 - 8.333333333333309e-03*G6_1_0_4_1_0_9_0 - 8.333333333333311e-03*G6_1_0_4_1_0_10_1 - 8.333333333333311e-03*G6_1_0_4_1_0_11_2 + 4.166666666666654e-03*G6_1_0_4_1_1_8_0 + 4.166666666666654e-03*G6_1_0_4_1_1_8_1 + 4.166666666666654e-03*G6_1_0_4_1_1_8_2 - 4.166666666666654e-03*G6_1_0_4_1_1_9_0 - 4.166666666666654e-03*G6_1_0_4_1_1_10_1 - 4.166666666666654e-03*G6_1_0_4_1_1_11_2 + 4.166666666666654e-03*G6_1_0_4_1_2_8_0 + 4.166666666666654e-03*G6_1_0_4_1_2_8_1 + 4.166666666666654e-03*G6_1_0_4_1_2_8_2 - 4.166666666666654e-03*G6_1_0_4_1_2_9_0 - 4.166666666666654e-03*G6_1_0_4_1_2_10_1 - 4.166666666666654e-03*G6_1_0_4_1_2_11_2 + 4.166666666666656e-03*G6_1_0_4_1_3_8_0 + 4.166666666666657e-03*G6_1_0_4_1_3_8_1 + 4.166666666666657e-03*G6_1_0_4_1_3_8_2 - 4.166666666666656e-03*G6_1_0_4_1_3_9_0 - 4.166666666666657e-03*G6_1_0_4_1_3_10_1 - 4.166666666666657e-03*G6_1_0_4_1_3_11_2 + 4.166666666666655e-03*G6_1_0_5_1_0_8_0 + 4.166666666666655e-03*G6_1_0_5_1_0_8_1 + 4.166666666666656e-03*G6_1_0_5_1_0_8_2 - 4.166666666666655e-03*G6_1_0_5_1_0_9_0 - 4.166666666666655e-03*G6_1_0_5_1_0_10_1 - 4.166666666666655e-03*G6_1_0_5_1_0_11_2 + 8.333333333333309e-03*G6_1_0_5_1_1_8_0 + 8.333333333333309e-03*G6_1_0_5_1_1_8_1 + 8.333333333333309e-03*G6_1_0_5_1_1_8_2 - 8.333333333333309e-03*G6_1_0_5_1_1_9_0 - 8.333333333333309e-03*G6_1_0_5_1_1_10_1 - 8.333333333333309e-03*G6_1_0_5_1_1_11_2 + 4.166666666666655e-03*G6_1_0_5_1_2_8_0 + 4.166666666666656e-03*G6_1_0_5_1_2_8_1 + 4.166666666666656e-03*G6_1_0_5_1_2_8_2 - 4.166666666666655e-03*G6_1_0_5_1_2_9_0 - 4.166666666666656e-03*G6_1_0_5_1_2_10_1 - 4.166666666666656e-03*G6_1_0_5_1_2_11_2 + 4.166666666666656e-03*G6_1_0_5_1_3_8_0 + 4.166666666666657e-03*G6_1_0_5_1_3_8_1 + 4.166666666666657e-03*G6_1_0_5_1_3_8_2 - 4.166666666666656e-03*G6_1_0_5_1_3_9_0 - 4.166666666666657e-03*G6_1_0_5_1_3_10_1 - 4.166666666666657e-03*G6_1_0_5_1_3_11_2 + 4.166666666666654e-03*G6_1_0_6_1_0_8_0 + 4.166666666666656e-03*G6_1_0_6_1_0_8_1 + 4.166666666666656e-03*G6_1_0_6_1_0_8_2 - 4.166666666666654e-03*G6_1_0_6_1_0_9_0 - 4.166666666666656e-03*G6_1_0_6_1_0_10_1 - 4.166666666666656e-03*G6_1_0_6_1_0_11_2 + 4.166666666666654e-03*G6_1_0_6_1_1_8_0 + 4.166666666666654e-03*G6_1_0_6_1_1_8_1 + 4.166666666666654e-03*G6_1_0_6_1_1_8_2 - 4.166666666666654e-03*G6_1_0_6_1_1_9_0 - 4.166666666666654e-03*G6_1_0_6_1_1_10_1 - 4.166666666666654e-03*G6_1_0_6_1_1_11_2 + 8.333333333333311e-03*G6_1_0_6_1_2_8_0 + 8.333333333333311e-03*G6_1_0_6_1_2_8_1 + 8.333333333333312e-03*G6_1_0_6_1_2_8_2 - 8.333333333333311e-03*G6_1_0_6_1_2_9_0 - 8.333333333333311e-03*G6_1_0_6_1_2_10_1 - 8.333333333333311e-03*G6_1_0_6_1_2_11_2 + 4.166666666666655e-03*G6_1_0_6_1_3_8_0 + 4.166666666666656e-03*G6_1_0_6_1_3_8_1 + 4.166666666666657e-03*G6_1_0_6_1_3_8_2 - 4.166666666666655e-03*G6_1_0_6_1_3_9_0 - 4.166666666666656e-03*G6_1_0_6_1_3_10_1 - 4.166666666666656e-03*G6_1_0_6_1_3_11_2 + 4.166666666666656e-03*G6_1_0_7_1_0_8_0 + 4.166666666666657e-03*G6_1_0_7_1_0_8_1 + 4.166666666666658e-03*G6_1_0_7_1_0_8_2 - 4.166666666666656e-03*G6_1_0_7_1_0_9_0 - 4.166666666666657e-03*G6_1_0_7_1_0_10_1 - 4.166666666666657e-03*G6_1_0_7_1_0_11_2 + 4.166666666666655e-03*G6_1_0_7_1_1_8_0 + 4.166666666666655e-03*G6_1_0_7_1_1_8_1 + 4.166666666666656e-03*G6_1_0_7_1_1_8_2 - 4.166666666666655e-03*G6_1_0_7_1_1_9_0 - 4.166666666666655e-03*G6_1_0_7_1_1_10_1 - 4.166666666666655e-03*G6_1_0_7_1_1_11_2 + 4.166666666666655e-03*G6_1_0_7_1_2_8_0 + 4.166666666666656e-03*G6_1_0_7_1_2_8_1 + 4.166666666666657e-03*G6_1_0_7_1_2_8_2 - 4.166666666666655e-03*G6_1_0_7_1_2_9_0 - 4.166666666666656e-03*G6_1_0_7_1_2_10_1 - 4.166666666666656e-03*G6_1_0_7_1_2_11_2 + 8.333333333333311e-03*G6_1_0_7_1_3_8_0 + 8.333333333333311e-03*G6_1_0_7_1_3_8_1 + 8.333333333333312e-03*G6_1_0_7_1_3_8_2 - 8.333333333333311e-03*G6_1_0_7_1_3_9_0 - 8.333333333333311e-03*G6_1_0_7_1_3_10_1 - 8.333333333333311e-03*G6_1_0_7_1_3_11_2 + 8.333333333333309e-03*G6_1_1_4_1_4_8_0 + 8.333333333333311e-03*G6_1_1_4_1_4_8_1 + 8.333333333333312e-03*G6_1_1_4_1_4_8_2 - 8.333333333333309e-03*G6_1_1_4_1_4_9_0 - 8.333333333333311e-03*G6_1_1_4_1_4_10_1 - 8.333333333333311e-03*G6_1_1_4_1_4_11_2 + 4.166666666666654e-03*G6_1_1_4_1_5_8_0 + 4.166666666666654e-03*G6_1_1_4_1_5_8_1 + 4.166666666666655e-03*G6_1_1_4_1_5_8_2 - 4.166666666666654e-03*G6_1_1_4_1_5_9_0 - 4.166666666666654e-03*G6_1_1_4_1_5_10_1 - 4.166666666666654e-03*G6_1_1_4_1_5_11_2 + 4.166666666666654e-03*G6_1_1_4_1_6_8_0 + 4.166666666666654e-03*G6_1_1_4_1_6_8_1 + 4.166666666666654e-03*G6_1_1_4_1_6_8_2 - 4.166666666666654e-03*G6_1_1_4_1_6_9_0 - 4.166666666666654e-03*G6_1_1_4_1_6_10_1 - 4.166666666666654e-03*G6_1_1_4_1_6_11_2 + 4.166666666666656e-03*G6_1_1_4_1_7_8_0 + 4.166666666666657e-03*G6_1_1_4_1_7_8_1 + 4.166666666666657e-03*G6_1_1_4_1_7_8_2 - 4.166666666666656e-03*G6_1_1_4_1_7_9_0 - 4.166666666666657e-03*G6_1_1_4_1_7_10_1 - 4.166666666666657e-03*G6_1_1_4_1_7_11_2 + 4.166666666666654e-03*G6_1_1_5_1_4_8_0 + 4.166666666666654e-03*G6_1_1_5_1_4_8_1 + 4.166666666666655e-03*G6_1_1_5_1_4_8_2 - 4.166666666666654e-03*G6_1_1_5_1_4_9_0 - 4.166666666666654e-03*G6_1_1_5_1_4_10_1 - 4.166666666666654e-03*G6_1_1_5_1_4_11_2 + 8.333333333333309e-03*G6_1_1_5_1_5_8_0 + 8.333333333333309e-03*G6_1_1_5_1_5_8_1 + 8.333333333333309e-03*G6_1_1_5_1_5_8_2 - 8.333333333333309e-03*G6_1_1_5_1_5_9_0 - 8.333333333333309e-03*G6_1_1_5_1_5_10_1 - 8.333333333333309e-03*G6_1_1_5_1_5_11_2 + 4.166666666666655e-03*G6_1_1_5_1_6_8_0 + 4.166666666666656e-03*G6_1_1_5_1_6_8_1 + 4.166666666666656e-03*G6_1_1_5_1_6_8_2 - 4.166666666666655e-03*G6_1_1_5_1_6_9_0 - 4.166666666666656e-03*G6_1_1_5_1_6_10_1 - 4.166666666666656e-03*G6_1_1_5_1_6_11_2 + 4.166666666666656e-03*G6_1_1_5_1_7_8_0 + 4.166666666666657e-03*G6_1_1_5_1_7_8_1 + 4.166666666666657e-03*G6_1_1_5_1_7_8_2 - 4.166666666666656e-03*G6_1_1_5_1_7_9_0 - 4.166666666666657e-03*G6_1_1_5_1_7_10_1 - 4.166666666666657e-03*G6_1_1_5_1_7_11_2 + 4.166666666666654e-03*G6_1_1_6_1_4_8_0 + 4.166666666666654e-03*G6_1_1_6_1_4_8_1 + 4.166666666666654e-03*G6_1_1_6_1_4_8_2 - 4.166666666666654e-03*G6_1_1_6_1_4_9_0 - 4.166666666666654e-03*G6_1_1_6_1_4_10_1 - 4.166666666666654e-03*G6_1_1_6_1_4_11_2 + 4.166666666666655e-03*G6_1_1_6_1_5_8_0 + 4.166666666666656e-03*G6_1_1_6_1_5_8_1 + 4.166666666666656e-03*G6_1_1_6_1_5_8_2 - 4.166666666666655e-03*G6_1_1_6_1_5_9_0 - 4.166666666666656e-03*G6_1_1_6_1_5_10_1 - 4.166666666666656e-03*G6_1_1_6_1_5_11_2 + 8.333333333333311e-03*G6_1_1_6_1_6_8_0 + 8.333333333333311e-03*G6_1_1_6_1_6_8_1 + 8.333333333333312e-03*G6_1_1_6_1_6_8_2 - 8.333333333333311e-03*G6_1_1_6_1_6_9_0 - 8.333333333333311e-03*G6_1_1_6_1_6_10_1 - 8.333333333333311e-03*G6_1_1_6_1_6_11_2 + 4.166666666666655e-03*G6_1_1_6_1_7_8_0 + 4.166666666666656e-03*G6_1_1_6_1_7_8_1 + 4.166666666666657e-03*G6_1_1_6_1_7_8_2 - 4.166666666666655e-03*G6_1_1_6_1_7_9_0 - 4.166666666666656e-03*G6_1_1_6_1_7_10_1 - 4.166666666666656e-03*G6_1_1_6_1_7_11_2 + 4.166666666666656e-03*G6_1_1_7_1_4_8_0 + 4.166666666666657e-03*G6_1_1_7_1_4_8_1 + 4.166666666666657e-03*G6_1_1_7_1_4_8_2 - 4.166666666666656e-03*G6_1_1_7_1_4_9_0 - 4.166666666666657e-03*G6_1_1_7_1_4_10_1 - 4.166666666666657e-03*G6_1_1_7_1_4_11_2 + 4.166666666666656e-03*G6_1_1_7_1_5_8_0 + 4.166666666666657e-03*G6_1_1_7_1_5_8_1 + 4.166666666666657e-03*G6_1_1_7_1_5_8_2 - 4.166666666666656e-03*G6_1_1_7_1_5_9_0 - 4.166666666666657e-03*G6_1_1_7_1_5_10_1 - 4.166666666666657e-03*G6_1_1_7_1_5_11_2 + 4.166666666666655e-03*G6_1_1_7_1_6_8_0 + 4.166666666666656e-03*G6_1_1_7_1_6_8_1 + 4.166666666666657e-03*G6_1_1_7_1_6_8_2 - 4.166666666666655e-03*G6_1_1_7_1_6_9_0 - 4.166666666666656e-03*G6_1_1_7_1_6_10_1 - 4.166666666666656e-03*G6_1_1_7_1_6_11_2 + 8.333333333333311e-03*G6_1_1_7_1_7_8_0 + 8.333333333333311e-03*G6_1_1_7_1_7_8_1 + 8.333333333333312e-03*G6_1_1_7_1_7_8_2 - 8.333333333333311e-03*G6_1_1_7_1_7_9_0 - 8.333333333333311e-03*G6_1_1_7_1_7_10_1 - 8.333333333333311e-03*G6_1_1_7_1_7_11_2 + 8.333333333333309e-03*G6_1_2_4_1_8_8_0 + 8.333333333333311e-03*G6_1_2_4_1_8_8_1 + 8.333333333333312e-03*G6_1_2_4_1_8_8_2 - 8.333333333333309e-03*G6_1_2_4_1_8_9_0 - 8.333333333333311e-03*G6_1_2_4_1_8_10_1 - 8.333333333333311e-03*G6_1_2_4_1_8_11_2 + 4.166666666666654e-03*G6_1_2_4_1_9_8_0 + 4.166666666666654e-03*G6_1_2_4_1_9_8_1 + 4.166666666666655e-03*G6_1_2_4_1_9_8_2 - 4.166666666666654e-03*G6_1_2_4_1_9_9_0 - 4.166666666666654e-03*G6_1_2_4_1_9_10_1 - 4.166666666666654e-03*G6_1_2_4_1_9_11_2 + 4.166666666666654e-03*G6_1_2_4_1_10_8_0 + 4.166666666666654e-03*G6_1_2_4_1_10_8_1 + 4.166666666666654e-03*G6_1_2_4_1_10_8_2 - 4.166666666666654e-03*G6_1_2_4_1_10_9_0 - 4.166666666666654e-03*G6_1_2_4_1_10_10_1 - 4.166666666666654e-03*G6_1_2_4_1_10_11_2 + 4.166666666666656e-03*G6_1_2_4_1_11_8_0 + 4.166666666666657e-03*G6_1_2_4_1_11_8_1 + 4.166666666666657e-03*G6_1_2_4_1_11_8_2 - 4.166666666666656e-03*G6_1_2_4_1_11_9_0 - 4.166666666666657e-03*G6_1_2_4_1_11_10_1 - 4.166666666666657e-03*G6_1_2_4_1_11_11_2 + 4.166666666666654e-03*G6_1_2_5_1_8_8_0 + 4.166666666666654e-03*G6_1_2_5_1_8_8_1 + 4.166666666666655e-03*G6_1_2_5_1_8_8_2 - 4.166666666666654e-03*G6_1_2_5_1_8_9_0 - 4.166666666666654e-03*G6_1_2_5_1_8_10_1 - 4.166666666666654e-03*G6_1_2_5_1_8_11_2 + 8.333333333333309e-03*G6_1_2_5_1_9_8_0 + 8.333333333333309e-03*G6_1_2_5_1_9_8_1 + 8.333333333333309e-03*G6_1_2_5_1_9_8_2 - 8.333333333333309e-03*G6_1_2_5_1_9_9_0 - 8.333333333333309e-03*G6_1_2_5_1_9_10_1 - 8.333333333333309e-03*G6_1_2_5_1_9_11_2 + 4.166666666666655e-03*G6_1_2_5_1_10_8_0 + 4.166666666666656e-03*G6_1_2_5_1_10_8_1 + 4.166666666666656e-03*G6_1_2_5_1_10_8_2 - 4.166666666666655e-03*G6_1_2_5_1_10_9_0 - 4.166666666666656e-03*G6_1_2_5_1_10_10_1 - 4.166666666666656e-03*G6_1_2_5_1_10_11_2 + 4.166666666666656e-03*G6_1_2_5_1_11_8_0 + 4.166666666666657e-03*G6_1_2_5_1_11_8_1 + 4.166666666666657e-03*G6_1_2_5_1_11_8_2 - 4.166666666666656e-03*G6_1_2_5_1_11_9_0 - 4.166666666666657e-03*G6_1_2_5_1_11_10_1 - 4.166666666666657e-03*G6_1_2_5_1_11_11_2 + 4.166666666666654e-03*G6_1_2_6_1_8_8_0 + 4.166666666666654e-03*G6_1_2_6_1_8_8_1 + 4.166666666666654e-03*G6_1_2_6_1_8_8_2 - 4.166666666666654e-03*G6_1_2_6_1_8_9_0 - 4.166666666666654e-03*G6_1_2_6_1_8_10_1 - 4.166666666666654e-03*G6_1_2_6_1_8_11_2 + 4.166666666666655e-03*G6_1_2_6_1_9_8_0 + 4.166666666666656e-03*G6_1_2_6_1_9_8_1 + 4.166666666666656e-03*G6_1_2_6_1_9_8_2 - 4.166666666666655e-03*G6_1_2_6_1_9_9_0 - 4.166666666666656e-03*G6_1_2_6_1_9_10_1 - 4.166666666666656e-03*G6_1_2_6_1_9_11_2 + 8.333333333333311e-03*G6_1_2_6_1_10_8_0 + 8.333333333333311e-03*G6_1_2_6_1_10_8_1 + 8.333333333333312e-03*G6_1_2_6_1_10_8_2 - 8.333333333333311e-03*G6_1_2_6_1_10_9_0 - 8.333333333333311e-03*G6_1_2_6_1_10_10_1 - 8.333333333333311e-03*G6_1_2_6_1_10_11_2 + 4.166666666666655e-03*G6_1_2_6_1_11_8_0 + 4.166666666666656e-03*G6_1_2_6_1_11_8_1 + 4.166666666666657e-03*G6_1_2_6_1_11_8_2 - 4.166666666666655e-03*G6_1_2_6_1_11_9_0 - 4.166666666666656e-03*G6_1_2_6_1_11_10_1 - 4.166666666666656e-03*G6_1_2_6_1_11_11_2 + 4.166666666666656e-03*G6_1_2_7_1_8_8_0 + 4.166666666666657e-03*G6_1_2_7_1_8_8_1 + 4.166666666666657e-03*G6_1_2_7_1_8_8_2 - 4.166666666666656e-03*G6_1_2_7_1_8_9_0 - 4.166666666666657e-03*G6_1_2_7_1_8_10_1 - 4.166666666666657e-03*G6_1_2_7_1_8_11_2 + 4.166666666666656e-03*G6_1_2_7_1_9_8_0 + 4.166666666666657e-03*G6_1_2_7_1_9_8_1 + 4.166666666666657e-03*G6_1_2_7_1_9_8_2 - 4.166666666666656e-03*G6_1_2_7_1_9_9_0 - 4.166666666666657e-03*G6_1_2_7_1_9_10_1 - 4.166666666666657e-03*G6_1_2_7_1_9_11_2 + 4.166666666666655e-03*G6_1_2_7_1_10_8_0 + 4.166666666666656e-03*G6_1_2_7_1_10_8_1 + 4.166666666666657e-03*G6_1_2_7_1_10_8_2 - 4.166666666666655e-03*G6_1_2_7_1_10_9_0 - 4.166666666666656e-03*G6_1_2_7_1_10_10_1 - 4.166666666666656e-03*G6_1_2_7_1_10_11_2 + 8.333333333333311e-03*G6_1_2_7_1_11_8_0 + 8.333333333333311e-03*G6_1_2_7_1_11_8_1 + 8.333333333333312e-03*G6_1_2_7_1_11_8_2 - 8.333333333333311e-03*G6_1_2_7_1_11_9_0 - 8.333333333333311e-03*G6_1_2_7_1_11_10_1 - 8.333333333333311e-03*G6_1_2_7_1_11_11_2 + 8.333333333333309e-03*G6_2_0_8_1_0_8_0 + 8.333333333333311e-03*G6_2_0_8_1_0_8_1 + 8.333333333333312e-03*G6_2_0_8_1_0_8_2 - 8.333333333333309e-03*G6_2_0_8_1_0_9_0 - 8.333333333333311e-03*G6_2_0_8_1_0_10_1 - 8.333333333333311e-03*G6_2_0_8_1_0_11_2 + 4.166666666666654e-03*G6_2_0_8_1_1_8_0 + 4.166666666666654e-03*G6_2_0_8_1_1_8_1 + 4.166666666666654e-03*G6_2_0_8_1_1_8_2 - 4.166666666666654e-03*G6_2_0_8_1_1_9_0 - 4.166666666666654e-03*G6_2_0_8_1_1_10_1 - 4.166666666666654e-03*G6_2_0_8_1_1_11_2 + 4.166666666666654e-03*G6_2_0_8_1_2_8_0 + 4.166666666666654e-03*G6_2_0_8_1_2_8_1 + 4.166666666666654e-03*G6_2_0_8_1_2_8_2 - 4.166666666666654e-03*G6_2_0_8_1_2_9_0 - 4.166666666666654e-03*G6_2_0_8_1_2_10_1 - 4.166666666666654e-03*G6_2_0_8_1_2_11_2 + 4.166666666666656e-03*G6_2_0_8_1_3_8_0 + 4.166666666666657e-03*G6_2_0_8_1_3_8_1 + 4.166666666666657e-03*G6_2_0_8_1_3_8_2 - 4.166666666666656e-03*G6_2_0_8_1_3_9_0 - 4.166666666666657e-03*G6_2_0_8_1_3_10_1 - 4.166666666666657e-03*G6_2_0_8_1_3_11_2 + 4.166666666666655e-03*G6_2_0_9_1_0_8_0 + 4.166666666666655e-03*G6_2_0_9_1_0_8_1 + 4.166666666666656e-03*G6_2_0_9_1_0_8_2 - 4.166666666666655e-03*G6_2_0_9_1_0_9_0 - 4.166666666666655e-03*G6_2_0_9_1_0_10_1 - 4.166666666666655e-03*G6_2_0_9_1_0_11_2 + 8.333333333333309e-03*G6_2_0_9_1_1_8_0 + 8.333333333333309e-03*G6_2_0_9_1_1_8_1 + 8.333333333333309e-03*G6_2_0_9_1_1_8_2 - 8.333333333333309e-03*G6_2_0_9_1_1_9_0 - 8.333333333333309e-03*G6_2_0_9_1_1_10_1 - 8.333333333333309e-03*G6_2_0_9_1_1_11_2 + 4.166666666666655e-03*G6_2_0_9_1_2_8_0 + 4.166666666666656e-03*G6_2_0_9_1_2_8_1 + 4.166666666666656e-03*G6_2_0_9_1_2_8_2 - 4.166666666666655e-03*G6_2_0_9_1_2_9_0 - 4.166666666666656e-03*G6_2_0_9_1_2_10_1 - 4.166666666666656e-03*G6_2_0_9_1_2_11_2 + 4.166666666666656e-03*G6_2_0_9_1_3_8_0 + 4.166666666666657e-03*G6_2_0_9_1_3_8_1 + 4.166666666666657e-03*G6_2_0_9_1_3_8_2 - 4.166666666666656e-03*G6_2_0_9_1_3_9_0 - 4.166666666666657e-03*G6_2_0_9_1_3_10_1 - 4.166666666666657e-03*G6_2_0_9_1_3_11_2 + 4.166666666666654e-03*G6_2_0_10_1_0_8_0 + 4.166666666666656e-03*G6_2_0_10_1_0_8_1 + 4.166666666666656e-03*G6_2_0_10_1_0_8_2 - 4.166666666666654e-03*G6_2_0_10_1_0_9_0 - 4.166666666666656e-03*G6_2_0_10_1_0_10_1 - 4.166666666666656e-03*G6_2_0_10_1_0_11_2 + 4.166666666666654e-03*G6_2_0_10_1_1_8_0 + 4.166666666666654e-03*G6_2_0_10_1_1_8_1 + 4.166666666666654e-03*G6_2_0_10_1_1_8_2 - 4.166666666666654e-03*G6_2_0_10_1_1_9_0 - 4.166666666666654e-03*G6_2_0_10_1_1_10_1 - 4.166666666666654e-03*G6_2_0_10_1_1_11_2 + 8.333333333333311e-03*G6_2_0_10_1_2_8_0 + 8.333333333333311e-03*G6_2_0_10_1_2_8_1 + 8.333333333333312e-03*G6_2_0_10_1_2_8_2 - 8.333333333333311e-03*G6_2_0_10_1_2_9_0 - 8.333333333333311e-03*G6_2_0_10_1_2_10_1 - 8.333333333333311e-03*G6_2_0_10_1_2_11_2 + 4.166666666666655e-03*G6_2_0_10_1_3_8_0 + 4.166666666666656e-03*G6_2_0_10_1_3_8_1 + 4.166666666666657e-03*G6_2_0_10_1_3_8_2 - 4.166666666666655e-03*G6_2_0_10_1_3_9_0 - 4.166666666666656e-03*G6_2_0_10_1_3_10_1 - 4.166666666666656e-03*G6_2_0_10_1_3_11_2 + 4.166666666666656e-03*G6_2_0_11_1_0_8_0 + 4.166666666666657e-03*G6_2_0_11_1_0_8_1 + 4.166666666666658e-03*G6_2_0_11_1_0_8_2 - 4.166666666666656e-03*G6_2_0_11_1_0_9_0 - 4.166666666666657e-03*G6_2_0_11_1_0_10_1 - 4.166666666666657e-03*G6_2_0_11_1_0_11_2 + 4.166666666666655e-03*G6_2_0_11_1_1_8_0 + 4.166666666666655e-03*G6_2_0_11_1_1_8_1 + 4.166666666666656e-03*G6_2_0_11_1_1_8_2 - 4.166666666666655e-03*G6_2_0_11_1_1_9_0 - 4.166666666666655e-03*G6_2_0_11_1_1_10_1 - 4.166666666666655e-03*G6_2_0_11_1_1_11_2 + 4.166666666666655e-03*G6_2_0_11_1_2_8_0 + 4.166666666666656e-03*G6_2_0_11_1_2_8_1 + 4.166666666666657e-03*G6_2_0_11_1_2_8_2 - 4.166666666666655e-03*G6_2_0_11_1_2_9_0 - 4.166666666666656e-03*G6_2_0_11_1_2_10_1 - 4.166666666666656e-03*G6_2_0_11_1_2_11_2 + 8.333333333333311e-03*G6_2_0_11_1_3_8_0 + 8.333333333333311e-03*G6_2_0_11_1_3_8_1 + 8.333333333333312e-03*G6_2_0_11_1_3_8_2 - 8.333333333333311e-03*G6_2_0_11_1_3_9_0 - 8.333333333333311e-03*G6_2_0_11_1_3_10_1 - 8.333333333333311e-03*G6_2_0_11_1_3_11_2 + 8.333333333333309e-03*G6_2_1_8_1_4_8_0 + 8.333333333333311e-03*G6_2_1_8_1_4_8_1 + 8.333333333333312e-03*G6_2_1_8_1_4_8_2 - 8.333333333333309e-03*G6_2_1_8_1_4_9_0 - 8.333333333333311e-03*G6_2_1_8_1_4_10_1 - 8.333333333333311e-03*G6_2_1_8_1_4_11_2 + 4.166666666666654e-03*G6_2_1_8_1_5_8_0 + 4.166666666666654e-03*G6_2_1_8_1_5_8_1 + 4.166666666666655e-03*G6_2_1_8_1_5_8_2 - 4.166666666666654e-03*G6_2_1_8_1_5_9_0 - 4.166666666666654e-03*G6_2_1_8_1_5_10_1 - 4.166666666666654e-03*G6_2_1_8_1_5_11_2 + 4.166666666666654e-03*G6_2_1_8_1_6_8_0 + 4.166666666666654e-03*G6_2_1_8_1_6_8_1 + 4.166666666666654e-03*G6_2_1_8_1_6_8_2 - 4.166666666666654e-03*G6_2_1_8_1_6_9_0 - 4.166666666666654e-03*G6_2_1_8_1_6_10_1 - 4.166666666666654e-03*G6_2_1_8_1_6_11_2 + 4.166666666666656e-03*G6_2_1_8_1_7_8_0 + 4.166666666666657e-03*G6_2_1_8_1_7_8_1 + 4.166666666666657e-03*G6_2_1_8_1_7_8_2 - 4.166666666666656e-03*G6_2_1_8_1_7_9_0 - 4.166666666666657e-03*G6_2_1_8_1_7_10_1 - 4.166666666666657e-03*G6_2_1_8_1_7_11_2 + 4.166666666666654e-03*G6_2_1_9_1_4_8_0 + 4.166666666666654e-03*G6_2_1_9_1_4_8_1 + 4.166666666666655e-03*G6_2_1_9_1_4_8_2 - 4.166666666666654e-03*G6_2_1_9_1_4_9_0 - 4.166666666666654e-03*G6_2_1_9_1_4_10_1 - 4.166666666666654e-03*G6_2_1_9_1_4_11_2 + 8.333333333333309e-03*G6_2_1_9_1_5_8_0 + 8.333333333333309e-03*G6_2_1_9_1_5_8_1 + 8.333333333333309e-03*G6_2_1_9_1_5_8_2 - 8.333333333333309e-03*G6_2_1_9_1_5_9_0 - 8.333333333333309e-03*G6_2_1_9_1_5_10_1 - 8.333333333333309e-03*G6_2_1_9_1_5_11_2 + 4.166666666666655e-03*G6_2_1_9_1_6_8_0 + 4.166666666666656e-03*G6_2_1_9_1_6_8_1 + 4.166666666666656e-03*G6_2_1_9_1_6_8_2 - 4.166666666666655e-03*G6_2_1_9_1_6_9_0 - 4.166666666666656e-03*G6_2_1_9_1_6_10_1 - 4.166666666666656e-03*G6_2_1_9_1_6_11_2 + 4.166666666666656e-03*G6_2_1_9_1_7_8_0 + 4.166666666666657e-03*G6_2_1_9_1_7_8_1 + 4.166666666666657e-03*G6_2_1_9_1_7_8_2 - 4.166666666666656e-03*G6_2_1_9_1_7_9_0 - 4.166666666666657e-03*G6_2_1_9_1_7_10_1 - 4.166666666666657e-03*G6_2_1_9_1_7_11_2 + 4.166666666666654e-03*G6_2_1_10_1_4_8_0 + 4.166666666666654e-03*G6_2_1_10_1_4_8_1 + 4.166666666666654e-03*G6_2_1_10_1_4_8_2 - 4.166666666666654e-03*G6_2_1_10_1_4_9_0 - 4.166666666666654e-03*G6_2_1_10_1_4_10_1 - 4.166666666666654e-03*G6_2_1_10_1_4_11_2 + 4.166666666666655e-03*G6_2_1_10_1_5_8_0 + 4.166666666666656e-03*G6_2_1_10_1_5_8_1 + 4.166666666666656e-03*G6_2_1_10_1_5_8_2 - 4.166666666666655e-03*G6_2_1_10_1_5_9_0 - 4.166666666666656e-03*G6_2_1_10_1_5_10_1 - 4.166666666666656e-03*G6_2_1_10_1_5_11_2 + 8.333333333333311e-03*G6_2_1_10_1_6_8_0 + 8.333333333333311e-03*G6_2_1_10_1_6_8_1 + 8.333333333333312e-03*G6_2_1_10_1_6_8_2 - 8.333333333333311e-03*G6_2_1_10_1_6_9_0 - 8.333333333333311e-03*G6_2_1_10_1_6_10_1 - 8.333333333333311e-03*G6_2_1_10_1_6_11_2 + 4.166666666666655e-03*G6_2_1_10_1_7_8_0 + 4.166666666666656e-03*G6_2_1_10_1_7_8_1 + 4.166666666666657e-03*G6_2_1_10_1_7_8_2 - 4.166666666666655e-03*G6_2_1_10_1_7_9_0 - 4.166666666666656e-03*G6_2_1_10_1_7_10_1 - 4.166666666666656e-03*G6_2_1_10_1_7_11_2 + 4.166666666666656e-03*G6_2_1_11_1_4_8_0 + 4.166666666666657e-03*G6_2_1_11_1_4_8_1 + 4.166666666666657e-03*G6_2_1_11_1_4_8_2 - 4.166666666666656e-03*G6_2_1_11_1_4_9_0 - 4.166666666666657e-03*G6_2_1_11_1_4_10_1 - 4.166666666666657e-03*G6_2_1_11_1_4_11_2 + 4.166666666666656e-03*G6_2_1_11_1_5_8_0 + 4.166666666666657e-03*G6_2_1_11_1_5_8_1 + 4.166666666666657e-03*G6_2_1_11_1_5_8_2 - 4.166666666666656e-03*G6_2_1_11_1_5_9_0 - 4.166666666666657e-03*G6_2_1_11_1_5_10_1 - 4.166666666666657e-03*G6_2_1_11_1_5_11_2 + 4.166666666666655e-03*G6_2_1_11_1_6_8_0 + 4.166666666666656e-03*G6_2_1_11_1_6_8_1 + 4.166666666666657e-03*G6_2_1_11_1_6_8_2 - 4.166666666666655e-03*G6_2_1_11_1_6_9_0 - 4.166666666666656e-03*G6_2_1_11_1_6_10_1 - 4.166666666666656e-03*G6_2_1_11_1_6_11_2 + 8.333333333333311e-03*G6_2_1_11_1_7_8_0 + 8.333333333333311e-03*G6_2_1_11_1_7_8_1 + 8.333333333333312e-03*G6_2_1_11_1_7_8_2 - 8.333333333333311e-03*G6_2_1_11_1_7_9_0 - 8.333333333333311e-03*G6_2_1_11_1_7_10_1 - 8.333333333333311e-03*G6_2_1_11_1_7_11_2 + 8.333333333333309e-03*G6_2_2_8_1_8_8_0 + 8.333333333333311e-03*G6_2_2_8_1_8_8_1 + 8.333333333333312e-03*G6_2_2_8_1_8_8_2 - 8.333333333333309e-03*G6_2_2_8_1_8_9_0 - 8.333333333333311e-03*G6_2_2_8_1_8_10_1 - 8.333333333333311e-03*G6_2_2_8_1_8_11_2 + 4.166666666666654e-03*G6_2_2_8_1_9_8_0 + 4.166666666666654e-03*G6_2_2_8_1_9_8_1 + 4.166666666666655e-03*G6_2_2_8_1_9_8_2 - 4.166666666666654e-03*G6_2_2_8_1_9_9_0 - 4.166666666666654e-03*G6_2_2_8_1_9_10_1 - 4.166666666666654e-03*G6_2_2_8_1_9_11_2 + 4.166666666666654e-03*G6_2_2_8_1_10_8_0 + 4.166666666666654e-03*G6_2_2_8_1_10_8_1 + 4.166666666666654e-03*G6_2_2_8_1_10_8_2 - 4.166666666666654e-03*G6_2_2_8_1_10_9_0 - 4.166666666666654e-03*G6_2_2_8_1_10_10_1 - 4.166666666666654e-03*G6_2_2_8_1_10_11_2 + 4.166666666666656e-03*G6_2_2_8_1_11_8_0 + 4.166666666666657e-03*G6_2_2_8_1_11_8_1 + 4.166666666666657e-03*G6_2_2_8_1_11_8_2 - 4.166666666666656e-03*G6_2_2_8_1_11_9_0 - 4.166666666666657e-03*G6_2_2_8_1_11_10_1 - 4.166666666666657e-03*G6_2_2_8_1_11_11_2 + 4.166666666666654e-03*G6_2_2_9_1_8_8_0 + 4.166666666666654e-03*G6_2_2_9_1_8_8_1 + 4.166666666666655e-03*G6_2_2_9_1_8_8_2 - 4.166666666666654e-03*G6_2_2_9_1_8_9_0 - 4.166666666666654e-03*G6_2_2_9_1_8_10_1 - 4.166666666666654e-03*G6_2_2_9_1_8_11_2 + 8.333333333333309e-03*G6_2_2_9_1_9_8_0 + 8.333333333333309e-03*G6_2_2_9_1_9_8_1 + 8.333333333333309e-03*G6_2_2_9_1_9_8_2 - 8.333333333333309e-03*G6_2_2_9_1_9_9_0 - 8.333333333333309e-03*G6_2_2_9_1_9_10_1 - 8.333333333333309e-03*G6_2_2_9_1_9_11_2 + 4.166666666666655e-03*G6_2_2_9_1_10_8_0 + 4.166666666666656e-03*G6_2_2_9_1_10_8_1 + 4.166666666666656e-03*G6_2_2_9_1_10_8_2 - 4.166666666666655e-03*G6_2_2_9_1_10_9_0 - 4.166666666666656e-03*G6_2_2_9_1_10_10_1 - 4.166666666666656e-03*G6_2_2_9_1_10_11_2 + 4.166666666666656e-03*G6_2_2_9_1_11_8_0 + 4.166666666666657e-03*G6_2_2_9_1_11_8_1 + 4.166666666666657e-03*G6_2_2_9_1_11_8_2 - 4.166666666666656e-03*G6_2_2_9_1_11_9_0 - 4.166666666666657e-03*G6_2_2_9_1_11_10_1 - 4.166666666666657e-03*G6_2_2_9_1_11_11_2 + 4.166666666666654e-03*G6_2_2_10_1_8_8_0 + 4.166666666666654e-03*G6_2_2_10_1_8_8_1 + 4.166666666666654e-03*G6_2_2_10_1_8_8_2 - 4.166666666666654e-03*G6_2_2_10_1_8_9_0 - 4.166666666666654e-03*G6_2_2_10_1_8_10_1 - 4.166666666666654e-03*G6_2_2_10_1_8_11_2 + 4.166666666666655e-03*G6_2_2_10_1_9_8_0 + 4.166666666666656e-03*G6_2_2_10_1_9_8_1 + 4.166666666666656e-03*G6_2_2_10_1_9_8_2 - 4.166666666666655e-03*G6_2_2_10_1_9_9_0 - 4.166666666666656e-03*G6_2_2_10_1_9_10_1 - 4.166666666666656e-03*G6_2_2_10_1_9_11_2 + 8.333333333333311e-03*G6_2_2_10_1_10_8_0 + 8.333333333333311e-03*G6_2_2_10_1_10_8_1 + 8.333333333333312e-03*G6_2_2_10_1_10_8_2 - 8.333333333333311e-03*G6_2_2_10_1_10_9_0 - 8.333333333333311e-03*G6_2_2_10_1_10_10_1 - 8.333333333333311e-03*G6_2_2_10_1_10_11_2 + 4.166666666666655e-03*G6_2_2_10_1_11_8_0 + 4.166666666666656e-03*G6_2_2_10_1_11_8_1 + 4.166666666666657e-03*G6_2_2_10_1_11_8_2 - 4.166666666666655e-03*G6_2_2_10_1_11_9_0 - 4.166666666666656e-03*G6_2_2_10_1_11_10_1 - 4.166666666666656e-03*G6_2_2_10_1_11_11_2 + 4.166666666666656e-03*G6_2_2_11_1_8_8_0 + 4.166666666666657e-03*G6_2_2_11_1_8_8_1 + 4.166666666666657e-03*G6_2_2_11_1_8_8_2 - 4.166666666666656e-03*G6_2_2_11_1_8_9_0 - 4.166666666666657e-03*G6_2_2_11_1_8_10_1 - 4.166666666666657e-03*G6_2_2_11_1_8_11_2 + 4.166666666666656e-03*G6_2_2_11_1_9_8_0 + 4.166666666666657e-03*G6_2_2_11_1_9_8_1 + 4.166666666666657e-03*G6_2_2_11_1_9_8_2 - 4.166666666666656e-03*G6_2_2_11_1_9_9_0 - 4.166666666666657e-03*G6_2_2_11_1_9_10_1 - 4.166666666666657e-03*G6_2_2_11_1_9_11_2 + 4.166666666666655e-03*G6_2_2_11_1_10_8_0 + 4.166666666666656e-03*G6_2_2_11_1_10_8_1 + 4.166666666666657e-03*G6_2_2_11_1_10_8_2 - 4.166666666666655e-03*G6_2_2_11_1_10_9_0 - 4.166666666666656e-03*G6_2_2_11_1_10_10_1 - 4.166666666666656e-03*G6_2_2_11_1_10_11_2 + 8.333333333333311e-03*G6_2_2_11_1_11_8_0 + 8.333333333333311e-03*G6_2_2_11_1_11_8_1 + 8.333333333333312e-03*G6_2_2_11_1_11_8_2 - 8.333333333333311e-03*G6_2_2_11_1_11_9_0 - 8.333333333333311e-03*G6_2_2_11_1_11_10_1 - 8.333333333333311e-03*G6_2_2_11_1_11_11_2 + 4.166666666666662e-02*G7_2_0_0_1_0_0 + 4.166666666666662e-02*G7_2_0_0_1_0_1 + 4.166666666666662e-02*G7_2_0_0_1_0_2 - 4.166666666666662e-02*G7_2_0_0_1_1_0 - 4.166666666666662e-02*G7_2_0_0_1_2_1 - 4.166666666666662e-02*G7_2_0_0_1_3_2 + 4.166666666666660e-02*G7_2_0_1_1_0_0 + 4.166666666666661e-02*G7_2_0_1_1_0_1 + 4.166666666666661e-02*G7_2_0_1_1_0_2 - 4.166666666666660e-02*G7_2_0_1_1_1_0 - 4.166666666666661e-02*G7_2_0_1_1_2_1 - 4.166666666666661e-02*G7_2_0_1_1_3_2 + 4.166666666666661e-02*G7_2_0_2_1_0_0 + 4.166666666666662e-02*G7_2_0_2_1_0_1 + 4.166666666666662e-02*G7_2_0_2_1_0_2 - 4.166666666666661e-02*G7_2_0_2_1_1_0 - 4.166666666666662e-02*G7_2_0_2_1_2_1 - 4.166666666666662e-02*G7_2_0_2_1_3_2 + 4.166666666666661e-02*G7_2_0_3_1_0_0 + 4.166666666666662e-02*G7_2_0_3_1_0_1 + 4.166666666666662e-02*G7_2_0_3_1_0_2 - 4.166666666666661e-02*G7_2_0_3_1_1_0 - 4.166666666666662e-02*G7_2_0_3_1_2_1 - 4.166666666666662e-02*G7_2_0_3_1_3_2 + 4.166666666666661e-02*G7_2_1_4_1_0_0 + 4.166666666666662e-02*G7_2_1_4_1_0_1 + 4.166666666666662e-02*G7_2_1_4_1_0_2 - 4.166666666666661e-02*G7_2_1_4_1_1_0 - 4.166666666666662e-02*G7_2_1_4_1_2_1 - 4.166666666666662e-02*G7_2_1_4_1_3_2 + 4.166666666666661e-02*G7_2_1_5_1_0_0 + 4.166666666666662e-02*G7_2_1_5_1_0_1 + 4.166666666666662e-02*G7_2_1_5_1_0_2 - 4.166666666666661e-02*G7_2_1_5_1_1_0 - 4.166666666666662e-02*G7_2_1_5_1_2_1 - 4.166666666666662e-02*G7_2_1_5_1_3_2 + 4.166666666666661e-02*G7_2_1_6_1_0_0 + 4.166666666666662e-02*G7_2_1_6_1_0_1 + 4.166666666666662e-02*G7_2_1_6_1_0_2 - 4.166666666666661e-02*G7_2_1_6_1_1_0 - 4.166666666666662e-02*G7_2_1_6_1_2_1 - 4.166666666666662e-02*G7_2_1_6_1_3_2 + 4.166666666666661e-02*G7_2_1_7_1_0_0 + 4.166666666666662e-02*G7_2_1_7_1_0_1 + 4.166666666666662e-02*G7_2_1_7_1_0_2 - 4.166666666666661e-02*G7_2_1_7_1_1_0 - 4.166666666666662e-02*G7_2_1_7_1_2_1 - 4.166666666666662e-02*G7_2_1_7_1_3_2 + 4.166666666666661e-02*G7_2_2_8_1_0_0 + 4.166666666666662e-02*G7_2_2_8_1_0_1 + 4.166666666666662e-02*G7_2_2_8_1_0_2 - 4.166666666666661e-02*G7_2_2_8_1_1_0 - 4.166666666666662e-02*G7_2_2_8_1_2_1 - 4.166666666666662e-02*G7_2_2_8_1_3_2 + 4.166666666666661e-02*G7_2_2_9_1_0_0 + 4.166666666666662e-02*G7_2_2_9_1_0_1 + 4.166666666666662e-02*G7_2_2_9_1_0_2 - 4.166666666666661e-02*G7_2_2_9_1_1_0 - 4.166666666666662e-02*G7_2_2_9_1_2_1 - 4.166666666666662e-02*G7_2_2_9_1_3_2 + 4.166666666666661e-02*G7_2_2_10_1_0_0 + 4.166666666666662e-02*G7_2_2_10_1_0_1 + 4.166666666666662e-02*G7_2_2_10_1_0_2 - 4.166666666666661e-02*G7_2_2_10_1_1_0 - 4.166666666666662e-02*G7_2_2_10_1_2_1 - 4.166666666666662e-02*G7_2_2_10_1_3_2 + 4.166666666666661e-02*G7_2_2_11_1_0_0 + 4.166666666666662e-02*G7_2_2_11_1_0_1 + 4.166666666666662e-02*G7_2_2_11_1_0_2 - 4.166666666666661e-02*G7_2_2_11_1_1_0 - 4.166666666666662e-02*G7_2_2_11_1_2_1 - 4.166666666666662e-02*G7_2_2_11_1_3_2 + 8.333333333333322e-02*G8_2_0_1_0_0 + 8.333333333333323e-02*G8_2_0_1_0_1 + 8.333333333333322e-02*G8_2_0_1_0_2 - 8.333333333333322e-02*G8_2_0_1_1_0 - 8.333333333333323e-02*G8_2_0_1_2_1 - 8.333333333333323e-02*G8_2_0_1_3_2 + 8.333333333333322e-02*G8_2_1_1_4_0 + 8.333333333333323e-02*G8_2_1_1_4_1 + 8.333333333333323e-02*G8_2_1_1_4_2 - 8.333333333333322e-02*G8_2_1_1_5_0 - 8.333333333333323e-02*G8_2_1_1_6_1 - 8.333333333333323e-02*G8_2_1_1_7_2 + 8.333333333333322e-02*G8_2_2_1_8_0 + 8.333333333333323e-02*G8_2_2_1_8_1 + 8.333333333333323e-02*G8_2_2_1_8_2 - 8.333333333333322e-02*G8_2_2_1_9_0 - 8.333333333333323e-02*G8_2_2_1_10_1 - 8.333333333333323e-02*G8_2_2_1_11_2;
    block[11] = 8.333333333333314e-03*G0_8 + 8.333333333333314e-03*G0_9 + 8.333333333333312e-03*G0_10 + 1.666666666666662e-02*G0_11 + 8.333333333333314e-03*G1_8 + 8.333333333333314e-03*G1_9 + 8.333333333333312e-03*G1_10 + 1.666666666666662e-02*G1_11 + 4.166666666666662e-02*G2_2_2_0 + 4.166666666666662e-02*G2_2_2_1 + 4.166666666666662e-02*G2_2_2_2 + 4.166666666666662e-02*G2_2_2_3 + 1.666666666666662e-02*G3_0_0_2_8 + 8.333333333333311e-03*G3_0_0_2_9 + 8.333333333333312e-03*G3_0_0_2_10 + 8.333333333333314e-03*G3_0_0_2_11 + 8.333333333333309e-03*G3_0_1_2_8 + 1.666666666666662e-02*G3_0_1_2_9 + 8.333333333333309e-03*G3_0_1_2_10 + 8.333333333333311e-03*G3_0_1_2_11 + 8.333333333333307e-03*G3_0_2_2_8 + 8.333333333333312e-03*G3_0_2_2_9 + 1.666666666666662e-02*G3_0_2_2_10 + 8.333333333333312e-03*G3_0_2_2_11 + 8.333333333333314e-03*G3_0_3_2_8 + 8.333333333333314e-03*G3_0_3_2_9 + 8.333333333333312e-03*G3_0_3_2_10 + 1.666666666666662e-02*G3_0_3_2_11 + 1.666666666666662e-02*G3_1_4_2_8 + 8.333333333333309e-03*G3_1_4_2_9 + 8.333333333333309e-03*G3_1_4_2_10 + 8.333333333333314e-03*G3_1_4_2_11 + 8.333333333333309e-03*G3_1_5_2_8 + 1.666666666666662e-02*G3_1_5_2_9 + 8.333333333333312e-03*G3_1_5_2_10 + 8.333333333333314e-03*G3_1_5_2_11 + 8.333333333333307e-03*G3_1_6_2_8 + 8.333333333333312e-03*G3_1_6_2_9 + 1.666666666666662e-02*G3_1_6_2_10 + 8.333333333333312e-03*G3_1_6_2_11 + 8.333333333333314e-03*G3_1_7_2_8 + 8.333333333333314e-03*G3_1_7_2_9 + 8.333333333333312e-03*G3_1_7_2_10 + 1.666666666666662e-02*G3_1_7_2_11 + 1.666666666666662e-02*G3_2_8_2_8 + 8.333333333333309e-03*G3_2_8_2_9 + 8.333333333333309e-03*G3_2_8_2_10 + 8.333333333333314e-03*G3_2_8_2_11 + 8.333333333333309e-03*G3_2_9_2_8 + 1.666666666666662e-02*G3_2_9_2_9 + 8.333333333333312e-03*G3_2_9_2_10 + 8.333333333333314e-03*G3_2_9_2_11 + 8.333333333333307e-03*G3_2_10_2_8 + 8.333333333333312e-03*G3_2_10_2_9 + 1.666666666666662e-02*G3_2_10_2_10 + 8.333333333333312e-03*G3_2_10_2_11 + 8.333333333333314e-03*G3_2_11_2_8 + 8.333333333333314e-03*G3_2_11_2_9 + 8.333333333333312e-03*G3_2_11_2_10 + 1.666666666666662e-02*G3_2_11_2_11 + 8.333333333333322e-02*G4_2_8_0 + 8.333333333333323e-02*G4_2_8_1 + 8.333333333333323e-02*G4_2_8_2 - 8.333333333333322e-02*G4_2_9_0 - 8.333333333333323e-02*G4_2_10_1 - 8.333333333333323e-02*G4_2_11_2 + 4.166666666666656e-03*G5_0_0_8_0 + 4.166666666666657e-03*G5_0_0_8_1 + 4.166666666666658e-03*G5_0_0_8_2 - 4.166666666666656e-03*G5_0_0_9_0 - 4.166666666666657e-03*G5_0_0_10_1 - 4.166666666666657e-03*G5_0_0_11_2 + 4.166666666666655e-03*G5_0_1_8_0 + 4.166666666666655e-03*G5_0_1_8_1 + 4.166666666666656e-03*G5_0_1_8_2 - 4.166666666666655e-03*G5_0_1_9_0 - 4.166666666666655e-03*G5_0_1_10_1 - 4.166666666666655e-03*G5_0_1_11_2 + 4.166666666666655e-03*G5_0_2_8_0 + 4.166666666666656e-03*G5_0_2_8_1 + 4.166666666666657e-03*G5_0_2_8_2 - 4.166666666666655e-03*G5_0_2_9_0 - 4.166666666666656e-03*G5_0_2_10_1 - 4.166666666666656e-03*G5_0_2_11_2 + 8.333333333333311e-03*G5_0_3_8_0 + 8.333333333333311e-03*G5_0_3_8_1 + 8.333333333333312e-03*G5_0_3_8_2 - 8.333333333333311e-03*G5_0_3_9_0 - 8.333333333333311e-03*G5_0_3_10_1 - 8.333333333333311e-03*G5_0_3_11_2 + 4.166666666666656e-03*G5_1_4_8_0 + 4.166666666666657e-03*G5_1_4_8_1 + 4.166666666666657e-03*G5_1_4_8_2 - 4.166666666666656e-03*G5_1_4_9_0 - 4.166666666666657e-03*G5_1_4_10_1 - 4.166666666666657e-03*G5_1_4_11_2 + 4.166666666666656e-03*G5_1_5_8_0 + 4.166666666666657e-03*G5_1_5_8_1 + 4.166666666666657e-03*G5_1_5_8_2 - 4.166666666666656e-03*G5_1_5_9_0 - 4.166666666666657e-03*G5_1_5_10_1 - 4.166666666666657e-03*G5_1_5_11_2 + 4.166666666666655e-03*G5_1_6_8_0 + 4.166666666666656e-03*G5_1_6_8_1 + 4.166666666666657e-03*G5_1_6_8_2 - 4.166666666666655e-03*G5_1_6_9_0 - 4.166666666666656e-03*G5_1_6_10_1 - 4.166666666666656e-03*G5_1_6_11_2 + 8.333333333333311e-03*G5_1_7_8_0 + 8.333333333333311e-03*G5_1_7_8_1 + 8.333333333333312e-03*G5_1_7_8_2 - 8.333333333333311e-03*G5_1_7_9_0 - 8.333333333333311e-03*G5_1_7_10_1 - 8.333333333333311e-03*G5_1_7_11_2 + 4.166666666666656e-03*G5_2_8_8_0 + 4.166666666666657e-03*G5_2_8_8_1 + 4.166666666666657e-03*G5_2_8_8_2 - 4.166666666666656e-03*G5_2_8_9_0 - 4.166666666666657e-03*G5_2_8_10_1 - 4.166666666666657e-03*G5_2_8_11_2 + 4.166666666666656e-03*G5_2_9_8_0 + 4.166666666666657e-03*G5_2_9_8_1 + 4.166666666666657e-03*G5_2_9_8_2 - 4.166666666666656e-03*G5_2_9_9_0 - 4.166666666666657e-03*G5_2_9_10_1 - 4.166666666666657e-03*G5_2_9_11_2 + 4.166666666666655e-03*G5_2_10_8_0 + 4.166666666666656e-03*G5_2_10_8_1 + 4.166666666666657e-03*G5_2_10_8_2 - 4.166666666666655e-03*G5_2_10_9_0 - 4.166666666666656e-03*G5_2_10_10_1 - 4.166666666666656e-03*G5_2_10_11_2 + 8.333333333333311e-03*G5_2_11_8_0 + 8.333333333333311e-03*G5_2_11_8_1 + 8.333333333333312e-03*G5_2_11_8_2 - 8.333333333333311e-03*G5_2_11_9_0 - 8.333333333333311e-03*G5_2_11_10_1 - 8.333333333333311e-03*G5_2_11_11_2 + 8.333333333333309e-03*G6_0_0_0_2_0_8_0 + 8.333333333333311e-03*G6_0_0_0_2_0_8_1 + 8.333333333333312e-03*G6_0_0_0_2_0_8_2 - 8.333333333333309e-03*G6_0_0_0_2_0_9_0 - 8.333333333333311e-03*G6_0_0_0_2_0_10_1 - 8.333333333333311e-03*G6_0_0_0_2_0_11_2 + 4.166666666666654e-03*G6_0_0_0_2_1_8_0 + 4.166666666666655e-03*G6_0_0_0_2_1_8_1 + 4.166666666666655e-03*G6_0_0_0_2_1_8_2 - 4.166666666666654e-03*G6_0_0_0_2_1_9_0 - 4.166666666666655e-03*G6_0_0_0_2_1_10_1 - 4.166666666666655e-03*G6_0_0_0_2_1_11_2 + 4.166666666666654e-03*G6_0_0_0_2_2_8_0 + 4.166666666666656e-03*G6_0_0_0_2_2_8_1 + 4.166666666666656e-03*G6_0_0_0_2_2_8_2 - 4.166666666666654e-03*G6_0_0_0_2_2_9_0 - 4.166666666666656e-03*G6_0_0_0_2_2_10_1 - 4.166666666666656e-03*G6_0_0_0_2_2_11_2 + 4.166666666666656e-03*G6_0_0_0_2_3_8_0 + 4.166666666666657e-03*G6_0_0_0_2_3_8_1 + 4.166666666666658e-03*G6_0_0_0_2_3_8_2 - 4.166666666666656e-03*G6_0_0_0_2_3_9_0 - 4.166666666666657e-03*G6_0_0_0_2_3_10_1 - 4.166666666666657e-03*G6_0_0_0_2_3_11_2 + 4.166666666666654e-03*G6_0_0_1_2_0_8_0 + 4.166666666666655e-03*G6_0_0_1_2_0_8_1 + 4.166666666666655e-03*G6_0_0_1_2_0_8_2 - 4.166666666666654e-03*G6_0_0_1_2_0_9_0 - 4.166666666666655e-03*G6_0_0_1_2_0_10_1 - 4.166666666666655e-03*G6_0_0_1_2_0_11_2 + 8.333333333333307e-03*G6_0_0_1_2_1_8_0 + 8.333333333333309e-03*G6_0_0_1_2_1_8_1 + 8.333333333333309e-03*G6_0_0_1_2_1_8_2 - 8.333333333333307e-03*G6_0_0_1_2_1_9_0 - 8.333333333333309e-03*G6_0_0_1_2_1_10_1 - 8.333333333333309e-03*G6_0_0_1_2_1_11_2 + 4.166666666666654e-03*G6_0_0_1_2_2_8_0 + 4.166666666666654e-03*G6_0_0_1_2_2_8_1 + 4.166666666666655e-03*G6_0_0_1_2_2_8_2 - 4.166666666666654e-03*G6_0_0_1_2_2_9_0 - 4.166666666666654e-03*G6_0_0_1_2_2_10_1 - 4.166666666666654e-03*G6_0_0_1_2_2_11_2 + 4.166666666666655e-03*G6_0_0_1_2_3_8_0 + 4.166666666666655e-03*G6_0_0_1_2_3_8_1 + 4.166666666666656e-03*G6_0_0_1_2_3_8_2 - 4.166666666666655e-03*G6_0_0_1_2_3_9_0 - 4.166666666666655e-03*G6_0_0_1_2_3_10_1 - 4.166666666666655e-03*G6_0_0_1_2_3_11_2 + 4.166666666666654e-03*G6_0_0_2_2_0_8_0 + 4.166666666666656e-03*G6_0_0_2_2_0_8_1 + 4.166666666666656e-03*G6_0_0_2_2_0_8_2 - 4.166666666666654e-03*G6_0_0_2_2_0_9_0 - 4.166666666666656e-03*G6_0_0_2_2_0_10_1 - 4.166666666666656e-03*G6_0_0_2_2_0_11_2 + 4.166666666666654e-03*G6_0_0_2_2_1_8_0 + 4.166666666666654e-03*G6_0_0_2_2_1_8_1 + 4.166666666666654e-03*G6_0_0_2_2_1_8_2 - 4.166666666666654e-03*G6_0_0_2_2_1_9_0 - 4.166666666666654e-03*G6_0_0_2_2_1_10_1 - 4.166666666666654e-03*G6_0_0_2_2_1_11_2 + 8.333333333333311e-03*G6_0_0_2_2_2_8_0 + 8.333333333333311e-03*G6_0_0_2_2_2_8_1 + 8.333333333333312e-03*G6_0_0_2_2_2_8_2 - 8.333333333333311e-03*G6_0_0_2_2_2_9_0 - 8.333333333333311e-03*G6_0_0_2_2_2_10_1 - 8.333333333333311e-03*G6_0_0_2_2_2_11_2 + 4.166666666666655e-03*G6_0_0_2_2_3_8_0 + 4.166666666666656e-03*G6_0_0_2_2_3_8_1 + 4.166666666666657e-03*G6_0_0_2_2_3_8_2 - 4.166666666666655e-03*G6_0_0_2_2_3_9_0 - 4.166666666666656e-03*G6_0_0_2_2_3_10_1 - 4.166666666666656e-03*G6_0_0_2_2_3_11_2 + 4.166666666666656e-03*G6_0_0_3_2_0_8_0 + 4.166666666666657e-03*G6_0_0_3_2_0_8_1 + 4.166666666666658e-03*G6_0_0_3_2_0_8_2 - 4.166666666666656e-03*G6_0_0_3_2_0_9_0 - 4.166666666666657e-03*G6_0_0_3_2_0_10_1 - 4.166666666666657e-03*G6_0_0_3_2_0_11_2 + 4.166666666666655e-03*G6_0_0_3_2_1_8_0 + 4.166666666666655e-03*G6_0_0_3_2_1_8_1 + 4.166666666666656e-03*G6_0_0_3_2_1_8_2 - 4.166666666666655e-03*G6_0_0_3_2_1_9_0 - 4.166666666666655e-03*G6_0_0_3_2_1_10_1 - 4.166666666666655e-03*G6_0_0_3_2_1_11_2 + 4.166666666666655e-03*G6_0_0_3_2_2_8_0 + 4.166666666666656e-03*G6_0_0_3_2_2_8_1 + 4.166666666666657e-03*G6_0_0_3_2_2_8_2 - 4.166666666666655e-03*G6_0_0_3_2_2_9_0 - 4.166666666666656e-03*G6_0_0_3_2_2_10_1 - 4.166666666666656e-03*G6_0_0_3_2_2_11_2 + 8.333333333333311e-03*G6_0_0_3_2_3_8_0 + 8.333333333333311e-03*G6_0_0_3_2_3_8_1 + 8.333333333333312e-03*G6_0_0_3_2_3_8_2 - 8.333333333333311e-03*G6_0_0_3_2_3_9_0 - 8.333333333333311e-03*G6_0_0_3_2_3_10_1 - 8.333333333333311e-03*G6_0_0_3_2_3_11_2 + 8.333333333333309e-03*G6_0_1_0_2_4_8_0 + 8.333333333333311e-03*G6_0_1_0_2_4_8_1 + 8.333333333333312e-03*G6_0_1_0_2_4_8_2 - 8.333333333333309e-03*G6_0_1_0_2_4_9_0 - 8.333333333333311e-03*G6_0_1_0_2_4_10_1 - 8.333333333333311e-03*G6_0_1_0_2_4_11_2 + 4.166666666666655e-03*G6_0_1_0_2_5_8_0 + 4.166666666666655e-03*G6_0_1_0_2_5_8_1 + 4.166666666666656e-03*G6_0_1_0_2_5_8_2 - 4.166666666666655e-03*G6_0_1_0_2_5_9_0 - 4.166666666666655e-03*G6_0_1_0_2_5_10_1 - 4.166666666666655e-03*G6_0_1_0_2_5_11_2 + 4.166666666666654e-03*G6_0_1_0_2_6_8_0 + 4.166666666666656e-03*G6_0_1_0_2_6_8_1 + 4.166666666666656e-03*G6_0_1_0_2_6_8_2 - 4.166666666666654e-03*G6_0_1_0_2_6_9_0 - 4.166666666666656e-03*G6_0_1_0_2_6_10_1 - 4.166666666666656e-03*G6_0_1_0_2_6_11_2 + 4.166666666666656e-03*G6_0_1_0_2_7_8_0 + 4.166666666666657e-03*G6_0_1_0_2_7_8_1 + 4.166666666666658e-03*G6_0_1_0_2_7_8_2 - 4.166666666666656e-03*G6_0_1_0_2_7_9_0 - 4.166666666666657e-03*G6_0_1_0_2_7_10_1 - 4.166666666666657e-03*G6_0_1_0_2_7_11_2 + 4.166666666666654e-03*G6_0_1_1_2_4_8_0 + 4.166666666666654e-03*G6_0_1_1_2_4_8_1 + 4.166666666666654e-03*G6_0_1_1_2_4_8_2 - 4.166666666666654e-03*G6_0_1_1_2_4_9_0 - 4.166666666666654e-03*G6_0_1_1_2_4_10_1 - 4.166666666666654e-03*G6_0_1_1_2_4_11_2 + 8.333333333333309e-03*G6_0_1_1_2_5_8_0 + 8.333333333333309e-03*G6_0_1_1_2_5_8_1 + 8.333333333333309e-03*G6_0_1_1_2_5_8_2 - 8.333333333333309e-03*G6_0_1_1_2_5_9_0 - 8.333333333333309e-03*G6_0_1_1_2_5_10_1 - 8.333333333333309e-03*G6_0_1_1_2_5_11_2 + 4.166666666666654e-03*G6_0_1_1_2_6_8_0 + 4.166666666666654e-03*G6_0_1_1_2_6_8_1 + 4.166666666666655e-03*G6_0_1_1_2_6_8_2 - 4.166666666666654e-03*G6_0_1_1_2_6_9_0 - 4.166666666666654e-03*G6_0_1_1_2_6_10_1 - 4.166666666666654e-03*G6_0_1_1_2_6_11_2 + 4.166666666666655e-03*G6_0_1_1_2_7_8_0 + 4.166666666666655e-03*G6_0_1_1_2_7_8_1 + 4.166666666666656e-03*G6_0_1_1_2_7_8_2 - 4.166666666666655e-03*G6_0_1_1_2_7_9_0 - 4.166666666666655e-03*G6_0_1_1_2_7_10_1 - 4.166666666666655e-03*G6_0_1_1_2_7_11_2 + 4.166666666666654e-03*G6_0_1_2_2_4_8_0 + 4.166666666666654e-03*G6_0_1_2_2_4_8_1 + 4.166666666666654e-03*G6_0_1_2_2_4_8_2 - 4.166666666666654e-03*G6_0_1_2_2_4_9_0 - 4.166666666666654e-03*G6_0_1_2_2_4_10_1 - 4.166666666666654e-03*G6_0_1_2_2_4_11_2 + 4.166666666666655e-03*G6_0_1_2_2_5_8_0 + 4.166666666666656e-03*G6_0_1_2_2_5_8_1 + 4.166666666666656e-03*G6_0_1_2_2_5_8_2 - 4.166666666666655e-03*G6_0_1_2_2_5_9_0 - 4.166666666666656e-03*G6_0_1_2_2_5_10_1 - 4.166666666666656e-03*G6_0_1_2_2_5_11_2 + 8.333333333333311e-03*G6_0_1_2_2_6_8_0 + 8.333333333333311e-03*G6_0_1_2_2_6_8_1 + 8.333333333333312e-03*G6_0_1_2_2_6_8_2 - 8.333333333333311e-03*G6_0_1_2_2_6_9_0 - 8.333333333333311e-03*G6_0_1_2_2_6_10_1 - 8.333333333333311e-03*G6_0_1_2_2_6_11_2 + 4.166666666666655e-03*G6_0_1_2_2_7_8_0 + 4.166666666666656e-03*G6_0_1_2_2_7_8_1 + 4.166666666666657e-03*G6_0_1_2_2_7_8_2 - 4.166666666666655e-03*G6_0_1_2_2_7_9_0 - 4.166666666666656e-03*G6_0_1_2_2_7_10_1 - 4.166666666666656e-03*G6_0_1_2_2_7_11_2 + 4.166666666666656e-03*G6_0_1_3_2_4_8_0 + 4.166666666666657e-03*G6_0_1_3_2_4_8_1 + 4.166666666666657e-03*G6_0_1_3_2_4_8_2 - 4.166666666666656e-03*G6_0_1_3_2_4_9_0 - 4.166666666666657e-03*G6_0_1_3_2_4_10_1 - 4.166666666666657e-03*G6_0_1_3_2_4_11_2 + 4.166666666666656e-03*G6_0_1_3_2_5_8_0 + 4.166666666666657e-03*G6_0_1_3_2_5_8_1 + 4.166666666666657e-03*G6_0_1_3_2_5_8_2 - 4.166666666666656e-03*G6_0_1_3_2_5_9_0 - 4.166666666666657e-03*G6_0_1_3_2_5_10_1 - 4.166666666666657e-03*G6_0_1_3_2_5_11_2 + 4.166666666666655e-03*G6_0_1_3_2_6_8_0 + 4.166666666666656e-03*G6_0_1_3_2_6_8_1 + 4.166666666666657e-03*G6_0_1_3_2_6_8_2 - 4.166666666666655e-03*G6_0_1_3_2_6_9_0 - 4.166666666666656e-03*G6_0_1_3_2_6_10_1 - 4.166666666666656e-03*G6_0_1_3_2_6_11_2 + 8.333333333333311e-03*G6_0_1_3_2_7_8_0 + 8.333333333333311e-03*G6_0_1_3_2_7_8_1 + 8.333333333333312e-03*G6_0_1_3_2_7_8_2 - 8.333333333333311e-03*G6_0_1_3_2_7_9_0 - 8.333333333333311e-03*G6_0_1_3_2_7_10_1 - 8.333333333333311e-03*G6_0_1_3_2_7_11_2 + 8.333333333333309e-03*G6_0_2_0_2_8_8_0 + 8.333333333333311e-03*G6_0_2_0_2_8_8_1 + 8.333333333333312e-03*G6_0_2_0_2_8_8_2 - 8.333333333333309e-03*G6_0_2_0_2_8_9_0 - 8.333333333333311e-03*G6_0_2_0_2_8_10_1 - 8.333333333333311e-03*G6_0_2_0_2_8_11_2 + 4.166666666666655e-03*G6_0_2_0_2_9_8_0 + 4.166666666666655e-03*G6_0_2_0_2_9_8_1 + 4.166666666666656e-03*G6_0_2_0_2_9_8_2 - 4.166666666666655e-03*G6_0_2_0_2_9_9_0 - 4.166666666666655e-03*G6_0_2_0_2_9_10_1 - 4.166666666666655e-03*G6_0_2_0_2_9_11_2 + 4.166666666666654e-03*G6_0_2_0_2_10_8_0 + 4.166666666666656e-03*G6_0_2_0_2_10_8_1 + 4.166666666666656e-03*G6_0_2_0_2_10_8_2 - 4.166666666666654e-03*G6_0_2_0_2_10_9_0 - 4.166666666666656e-03*G6_0_2_0_2_10_10_1 - 4.166666666666656e-03*G6_0_2_0_2_10_11_2 + 4.166666666666656e-03*G6_0_2_0_2_11_8_0 + 4.166666666666657e-03*G6_0_2_0_2_11_8_1 + 4.166666666666658e-03*G6_0_2_0_2_11_8_2 - 4.166666666666656e-03*G6_0_2_0_2_11_9_0 - 4.166666666666657e-03*G6_0_2_0_2_11_10_1 - 4.166666666666657e-03*G6_0_2_0_2_11_11_2 + 4.166666666666654e-03*G6_0_2_1_2_8_8_0 + 4.166666666666654e-03*G6_0_2_1_2_8_8_1 + 4.166666666666654e-03*G6_0_2_1_2_8_8_2 - 4.166666666666654e-03*G6_0_2_1_2_8_9_0 - 4.166666666666654e-03*G6_0_2_1_2_8_10_1 - 4.166666666666654e-03*G6_0_2_1_2_8_11_2 + 8.333333333333309e-03*G6_0_2_1_2_9_8_0 + 8.333333333333309e-03*G6_0_2_1_2_9_8_1 + 8.333333333333309e-03*G6_0_2_1_2_9_8_2 - 8.333333333333309e-03*G6_0_2_1_2_9_9_0 - 8.333333333333309e-03*G6_0_2_1_2_9_10_1 - 8.333333333333309e-03*G6_0_2_1_2_9_11_2 + 4.166666666666654e-03*G6_0_2_1_2_10_8_0 + 4.166666666666654e-03*G6_0_2_1_2_10_8_1 + 4.166666666666655e-03*G6_0_2_1_2_10_8_2 - 4.166666666666654e-03*G6_0_2_1_2_10_9_0 - 4.166666666666654e-03*G6_0_2_1_2_10_10_1 - 4.166666666666654e-03*G6_0_2_1_2_10_11_2 + 4.166666666666655e-03*G6_0_2_1_2_11_8_0 + 4.166666666666655e-03*G6_0_2_1_2_11_8_1 + 4.166666666666656e-03*G6_0_2_1_2_11_8_2 - 4.166666666666655e-03*G6_0_2_1_2_11_9_0 - 4.166666666666655e-03*G6_0_2_1_2_11_10_1 - 4.166666666666655e-03*G6_0_2_1_2_11_11_2 + 4.166666666666654e-03*G6_0_2_2_2_8_8_0 + 4.166666666666654e-03*G6_0_2_2_2_8_8_1 + 4.166666666666654e-03*G6_0_2_2_2_8_8_2 - 4.166666666666654e-03*G6_0_2_2_2_8_9_0 - 4.166666666666654e-03*G6_0_2_2_2_8_10_1 - 4.166666666666654e-03*G6_0_2_2_2_8_11_2 + 4.166666666666655e-03*G6_0_2_2_2_9_8_0 + 4.166666666666656e-03*G6_0_2_2_2_9_8_1 + 4.166666666666656e-03*G6_0_2_2_2_9_8_2 - 4.166666666666655e-03*G6_0_2_2_2_9_9_0 - 4.166666666666656e-03*G6_0_2_2_2_9_10_1 - 4.166666666666656e-03*G6_0_2_2_2_9_11_2 + 8.333333333333311e-03*G6_0_2_2_2_10_8_0 + 8.333333333333311e-03*G6_0_2_2_2_10_8_1 + 8.333333333333312e-03*G6_0_2_2_2_10_8_2 - 8.333333333333311e-03*G6_0_2_2_2_10_9_0 - 8.333333333333311e-03*G6_0_2_2_2_10_10_1 - 8.333333333333311e-03*G6_0_2_2_2_10_11_2 + 4.166666666666655e-03*G6_0_2_2_2_11_8_0 + 4.166666666666656e-03*G6_0_2_2_2_11_8_1 + 4.166666666666657e-03*G6_0_2_2_2_11_8_2 - 4.166666666666655e-03*G6_0_2_2_2_11_9_0 - 4.166666666666656e-03*G6_0_2_2_2_11_10_1 - 4.166666666666656e-03*G6_0_2_2_2_11_11_2 + 4.166666666666656e-03*G6_0_2_3_2_8_8_0 + 4.166666666666657e-03*G6_0_2_3_2_8_8_1 + 4.166666666666657e-03*G6_0_2_3_2_8_8_2 - 4.166666666666656e-03*G6_0_2_3_2_8_9_0 - 4.166666666666657e-03*G6_0_2_3_2_8_10_1 - 4.166666666666657e-03*G6_0_2_3_2_8_11_2 + 4.166666666666656e-03*G6_0_2_3_2_9_8_0 + 4.166666666666657e-03*G6_0_2_3_2_9_8_1 + 4.166666666666657e-03*G6_0_2_3_2_9_8_2 - 4.166666666666656e-03*G6_0_2_3_2_9_9_0 - 4.166666666666657e-03*G6_0_2_3_2_9_10_1 - 4.166666666666657e-03*G6_0_2_3_2_9_11_2 + 4.166666666666655e-03*G6_0_2_3_2_10_8_0 + 4.166666666666656e-03*G6_0_2_3_2_10_8_1 + 4.166666666666657e-03*G6_0_2_3_2_10_8_2 - 4.166666666666655e-03*G6_0_2_3_2_10_9_0 - 4.166666666666656e-03*G6_0_2_3_2_10_10_1 - 4.166666666666656e-03*G6_0_2_3_2_10_11_2 + 8.333333333333311e-03*G6_0_2_3_2_11_8_0 + 8.333333333333311e-03*G6_0_2_3_2_11_8_1 + 8.333333333333312e-03*G6_0_2_3_2_11_8_2 - 8.333333333333311e-03*G6_0_2_3_2_11_9_0 - 8.333333333333311e-03*G6_0_2_3_2_11_10_1 - 8.333333333333311e-03*G6_0_2_3_2_11_11_2 + 8.333333333333309e-03*G6_1_0_4_2_0_8_0 + 8.333333333333311e-03*G6_1_0_4_2_0_8_1 + 8.333333333333312e-03*G6_1_0_4_2_0_8_2 - 8.333333333333309e-03*G6_1_0_4_2_0_9_0 - 8.333333333333311e-03*G6_1_0_4_2_0_10_1 - 8.333333333333311e-03*G6_1_0_4_2_0_11_2 + 4.166666666666654e-03*G6_1_0_4_2_1_8_0 + 4.166666666666654e-03*G6_1_0_4_2_1_8_1 + 4.166666666666654e-03*G6_1_0_4_2_1_8_2 - 4.166666666666654e-03*G6_1_0_4_2_1_9_0 - 4.166666666666654e-03*G6_1_0_4_2_1_10_1 - 4.166666666666654e-03*G6_1_0_4_2_1_11_2 + 4.166666666666654e-03*G6_1_0_4_2_2_8_0 + 4.166666666666654e-03*G6_1_0_4_2_2_8_1 + 4.166666666666654e-03*G6_1_0_4_2_2_8_2 - 4.166666666666654e-03*G6_1_0_4_2_2_9_0 - 4.166666666666654e-03*G6_1_0_4_2_2_10_1 - 4.166666666666654e-03*G6_1_0_4_2_2_11_2 + 4.166666666666656e-03*G6_1_0_4_2_3_8_0 + 4.166666666666657e-03*G6_1_0_4_2_3_8_1 + 4.166666666666657e-03*G6_1_0_4_2_3_8_2 - 4.166666666666656e-03*G6_1_0_4_2_3_9_0 - 4.166666666666657e-03*G6_1_0_4_2_3_10_1 - 4.166666666666657e-03*G6_1_0_4_2_3_11_2 + 4.166666666666655e-03*G6_1_0_5_2_0_8_0 + 4.166666666666655e-03*G6_1_0_5_2_0_8_1 + 4.166666666666656e-03*G6_1_0_5_2_0_8_2 - 4.166666666666655e-03*G6_1_0_5_2_0_9_0 - 4.166666666666655e-03*G6_1_0_5_2_0_10_1 - 4.166666666666655e-03*G6_1_0_5_2_0_11_2 + 8.333333333333309e-03*G6_1_0_5_2_1_8_0 + 8.333333333333309e-03*G6_1_0_5_2_1_8_1 + 8.333333333333309e-03*G6_1_0_5_2_1_8_2 - 8.333333333333309e-03*G6_1_0_5_2_1_9_0 - 8.333333333333309e-03*G6_1_0_5_2_1_10_1 - 8.333333333333309e-03*G6_1_0_5_2_1_11_2 + 4.166666666666655e-03*G6_1_0_5_2_2_8_0 + 4.166666666666656e-03*G6_1_0_5_2_2_8_1 + 4.166666666666656e-03*G6_1_0_5_2_2_8_2 - 4.166666666666655e-03*G6_1_0_5_2_2_9_0 - 4.166666666666656e-03*G6_1_0_5_2_2_10_1 - 4.166666666666656e-03*G6_1_0_5_2_2_11_2 + 4.166666666666656e-03*G6_1_0_5_2_3_8_0 + 4.166666666666657e-03*G6_1_0_5_2_3_8_1 + 4.166666666666657e-03*G6_1_0_5_2_3_8_2 - 4.166666666666656e-03*G6_1_0_5_2_3_9_0 - 4.166666666666657e-03*G6_1_0_5_2_3_10_1 - 4.166666666666657e-03*G6_1_0_5_2_3_11_2 + 4.166666666666654e-03*G6_1_0_6_2_0_8_0 + 4.166666666666656e-03*G6_1_0_6_2_0_8_1 + 4.166666666666656e-03*G6_1_0_6_2_0_8_2 - 4.166666666666654e-03*G6_1_0_6_2_0_9_0 - 4.166666666666656e-03*G6_1_0_6_2_0_10_1 - 4.166666666666656e-03*G6_1_0_6_2_0_11_2 + 4.166666666666654e-03*G6_1_0_6_2_1_8_0 + 4.166666666666654e-03*G6_1_0_6_2_1_8_1 + 4.166666666666654e-03*G6_1_0_6_2_1_8_2 - 4.166666666666654e-03*G6_1_0_6_2_1_9_0 - 4.166666666666654e-03*G6_1_0_6_2_1_10_1 - 4.166666666666654e-03*G6_1_0_6_2_1_11_2 + 8.333333333333311e-03*G6_1_0_6_2_2_8_0 + 8.333333333333311e-03*G6_1_0_6_2_2_8_1 + 8.333333333333312e-03*G6_1_0_6_2_2_8_2 - 8.333333333333311e-03*G6_1_0_6_2_2_9_0 - 8.333333333333311e-03*G6_1_0_6_2_2_10_1 - 8.333333333333311e-03*G6_1_0_6_2_2_11_2 + 4.166666666666655e-03*G6_1_0_6_2_3_8_0 + 4.166666666666656e-03*G6_1_0_6_2_3_8_1 + 4.166666666666657e-03*G6_1_0_6_2_3_8_2 - 4.166666666666655e-03*G6_1_0_6_2_3_9_0 - 4.166666666666656e-03*G6_1_0_6_2_3_10_1 - 4.166666666666656e-03*G6_1_0_6_2_3_11_2 + 4.166666666666656e-03*G6_1_0_7_2_0_8_0 + 4.166666666666657e-03*G6_1_0_7_2_0_8_1 + 4.166666666666658e-03*G6_1_0_7_2_0_8_2 - 4.166666666666656e-03*G6_1_0_7_2_0_9_0 - 4.166666666666657e-03*G6_1_0_7_2_0_10_1 - 4.166666666666657e-03*G6_1_0_7_2_0_11_2 + 4.166666666666655e-03*G6_1_0_7_2_1_8_0 + 4.166666666666655e-03*G6_1_0_7_2_1_8_1 + 4.166666666666656e-03*G6_1_0_7_2_1_8_2 - 4.166666666666655e-03*G6_1_0_7_2_1_9_0 - 4.166666666666655e-03*G6_1_0_7_2_1_10_1 - 4.166666666666655e-03*G6_1_0_7_2_1_11_2 + 4.166666666666655e-03*G6_1_0_7_2_2_8_0 + 4.166666666666656e-03*G6_1_0_7_2_2_8_1 + 4.166666666666657e-03*G6_1_0_7_2_2_8_2 - 4.166666666666655e-03*G6_1_0_7_2_2_9_0 - 4.166666666666656e-03*G6_1_0_7_2_2_10_1 - 4.166666666666656e-03*G6_1_0_7_2_2_11_2 + 8.333333333333311e-03*G6_1_0_7_2_3_8_0 + 8.333333333333311e-03*G6_1_0_7_2_3_8_1 + 8.333333333333312e-03*G6_1_0_7_2_3_8_2 - 8.333333333333311e-03*G6_1_0_7_2_3_9_0 - 8.333333333333311e-03*G6_1_0_7_2_3_10_1 - 8.333333333333311e-03*G6_1_0_7_2_3_11_2 + 8.333333333333309e-03*G6_1_1_4_2_4_8_0 + 8.333333333333311e-03*G6_1_1_4_2_4_8_1 + 8.333333333333312e-03*G6_1_1_4_2_4_8_2 - 8.333333333333309e-03*G6_1_1_4_2_4_9_0 - 8.333333333333311e-03*G6_1_1_4_2_4_10_1 - 8.333333333333311e-03*G6_1_1_4_2_4_11_2 + 4.166666666666654e-03*G6_1_1_4_2_5_8_0 + 4.166666666666654e-03*G6_1_1_4_2_5_8_1 + 4.166666666666655e-03*G6_1_1_4_2_5_8_2 - 4.166666666666654e-03*G6_1_1_4_2_5_9_0 - 4.166666666666654e-03*G6_1_1_4_2_5_10_1 - 4.166666666666654e-03*G6_1_1_4_2_5_11_2 + 4.166666666666654e-03*G6_1_1_4_2_6_8_0 + 4.166666666666654e-03*G6_1_1_4_2_6_8_1 + 4.166666666666654e-03*G6_1_1_4_2_6_8_2 - 4.166666666666654e-03*G6_1_1_4_2_6_9_0 - 4.166666666666654e-03*G6_1_1_4_2_6_10_1 - 4.166666666666654e-03*G6_1_1_4_2_6_11_2 + 4.166666666666656e-03*G6_1_1_4_2_7_8_0 + 4.166666666666657e-03*G6_1_1_4_2_7_8_1 + 4.166666666666657e-03*G6_1_1_4_2_7_8_2 - 4.166666666666656e-03*G6_1_1_4_2_7_9_0 - 4.166666666666657e-03*G6_1_1_4_2_7_10_1 - 4.166666666666657e-03*G6_1_1_4_2_7_11_2 + 4.166666666666654e-03*G6_1_1_5_2_4_8_0 + 4.166666666666654e-03*G6_1_1_5_2_4_8_1 + 4.166666666666655e-03*G6_1_1_5_2_4_8_2 - 4.166666666666654e-03*G6_1_1_5_2_4_9_0 - 4.166666666666654e-03*G6_1_1_5_2_4_10_1 - 4.166666666666654e-03*G6_1_1_5_2_4_11_2 + 8.333333333333309e-03*G6_1_1_5_2_5_8_0 + 8.333333333333309e-03*G6_1_1_5_2_5_8_1 + 8.333333333333309e-03*G6_1_1_5_2_5_8_2 - 8.333333333333309e-03*G6_1_1_5_2_5_9_0 - 8.333333333333309e-03*G6_1_1_5_2_5_10_1 - 8.333333333333309e-03*G6_1_1_5_2_5_11_2 + 4.166666666666655e-03*G6_1_1_5_2_6_8_0 + 4.166666666666656e-03*G6_1_1_5_2_6_8_1 + 4.166666666666656e-03*G6_1_1_5_2_6_8_2 - 4.166666666666655e-03*G6_1_1_5_2_6_9_0 - 4.166666666666656e-03*G6_1_1_5_2_6_10_1 - 4.166666666666656e-03*G6_1_1_5_2_6_11_2 + 4.166666666666656e-03*G6_1_1_5_2_7_8_0 + 4.166666666666657e-03*G6_1_1_5_2_7_8_1 + 4.166666666666657e-03*G6_1_1_5_2_7_8_2 - 4.166666666666656e-03*G6_1_1_5_2_7_9_0 - 4.166666666666657e-03*G6_1_1_5_2_7_10_1 - 4.166666666666657e-03*G6_1_1_5_2_7_11_2 + 4.166666666666654e-03*G6_1_1_6_2_4_8_0 + 4.166666666666654e-03*G6_1_1_6_2_4_8_1 + 4.166666666666654e-03*G6_1_1_6_2_4_8_2 - 4.166666666666654e-03*G6_1_1_6_2_4_9_0 - 4.166666666666654e-03*G6_1_1_6_2_4_10_1 - 4.166666666666654e-03*G6_1_1_6_2_4_11_2 + 4.166666666666655e-03*G6_1_1_6_2_5_8_0 + 4.166666666666656e-03*G6_1_1_6_2_5_8_1 + 4.166666666666656e-03*G6_1_1_6_2_5_8_2 - 4.166666666666655e-03*G6_1_1_6_2_5_9_0 - 4.166666666666656e-03*G6_1_1_6_2_5_10_1 - 4.166666666666656e-03*G6_1_1_6_2_5_11_2 + 8.333333333333311e-03*G6_1_1_6_2_6_8_0 + 8.333333333333311e-03*G6_1_1_6_2_6_8_1 + 8.333333333333312e-03*G6_1_1_6_2_6_8_2 - 8.333333333333311e-03*G6_1_1_6_2_6_9_0 - 8.333333333333311e-03*G6_1_1_6_2_6_10_1 - 8.333333333333311e-03*G6_1_1_6_2_6_11_2 + 4.166666666666655e-03*G6_1_1_6_2_7_8_0 + 4.166666666666656e-03*G6_1_1_6_2_7_8_1 + 4.166666666666657e-03*G6_1_1_6_2_7_8_2 - 4.166666666666655e-03*G6_1_1_6_2_7_9_0 - 4.166666666666656e-03*G6_1_1_6_2_7_10_1 - 4.166666666666656e-03*G6_1_1_6_2_7_11_2 + 4.166666666666656e-03*G6_1_1_7_2_4_8_0 + 4.166666666666657e-03*G6_1_1_7_2_4_8_1 + 4.166666666666657e-03*G6_1_1_7_2_4_8_2 - 4.166666666666656e-03*G6_1_1_7_2_4_9_0 - 4.166666666666657e-03*G6_1_1_7_2_4_10_1 - 4.166666666666657e-03*G6_1_1_7_2_4_11_2 + 4.166666666666656e-03*G6_1_1_7_2_5_8_0 + 4.166666666666657e-03*G6_1_1_7_2_5_8_1 + 4.166666666666657e-03*G6_1_1_7_2_5_8_2 - 4.166666666666656e-03*G6_1_1_7_2_5_9_0 - 4.166666666666657e-03*G6_1_1_7_2_5_10_1 - 4.166666666666657e-03*G6_1_1_7_2_5_11_2 + 4.166666666666655e-03*G6_1_1_7_2_6_8_0 + 4.166666666666656e-03*G6_1_1_7_2_6_8_1 + 4.166666666666657e-03*G6_1_1_7_2_6_8_2 - 4.166666666666655e-03*G6_1_1_7_2_6_9_0 - 4.166666666666656e-03*G6_1_1_7_2_6_10_1 - 4.166666666666656e-03*G6_1_1_7_2_6_11_2 + 8.333333333333311e-03*G6_1_1_7_2_7_8_0 + 8.333333333333311e-03*G6_1_1_7_2_7_8_1 + 8.333333333333312e-03*G6_1_1_7_2_7_8_2 - 8.333333333333311e-03*G6_1_1_7_2_7_9_0 - 8.333333333333311e-03*G6_1_1_7_2_7_10_1 - 8.333333333333311e-03*G6_1_1_7_2_7_11_2 + 8.333333333333309e-03*G6_1_2_4_2_8_8_0 + 8.333333333333311e-03*G6_1_2_4_2_8_8_1 + 8.333333333333312e-03*G6_1_2_4_2_8_8_2 - 8.333333333333309e-03*G6_1_2_4_2_8_9_0 - 8.333333333333311e-03*G6_1_2_4_2_8_10_1 - 8.333333333333311e-03*G6_1_2_4_2_8_11_2 + 4.166666666666654e-03*G6_1_2_4_2_9_8_0 + 4.166666666666654e-03*G6_1_2_4_2_9_8_1 + 4.166666666666655e-03*G6_1_2_4_2_9_8_2 - 4.166666666666654e-03*G6_1_2_4_2_9_9_0 - 4.166666666666654e-03*G6_1_2_4_2_9_10_1 - 4.166666666666654e-03*G6_1_2_4_2_9_11_2 + 4.166666666666654e-03*G6_1_2_4_2_10_8_0 + 4.166666666666654e-03*G6_1_2_4_2_10_8_1 + 4.166666666666654e-03*G6_1_2_4_2_10_8_2 - 4.166666666666654e-03*G6_1_2_4_2_10_9_0 - 4.166666666666654e-03*G6_1_2_4_2_10_10_1 - 4.166666666666654e-03*G6_1_2_4_2_10_11_2 + 4.166666666666656e-03*G6_1_2_4_2_11_8_0 + 4.166666666666657e-03*G6_1_2_4_2_11_8_1 + 4.166666666666657e-03*G6_1_2_4_2_11_8_2 - 4.166666666666656e-03*G6_1_2_4_2_11_9_0 - 4.166666666666657e-03*G6_1_2_4_2_11_10_1 - 4.166666666666657e-03*G6_1_2_4_2_11_11_2 + 4.166666666666654e-03*G6_1_2_5_2_8_8_0 + 4.166666666666654e-03*G6_1_2_5_2_8_8_1 + 4.166666666666655e-03*G6_1_2_5_2_8_8_2 - 4.166666666666654e-03*G6_1_2_5_2_8_9_0 - 4.166666666666654e-03*G6_1_2_5_2_8_10_1 - 4.166666666666654e-03*G6_1_2_5_2_8_11_2 + 8.333333333333309e-03*G6_1_2_5_2_9_8_0 + 8.333333333333309e-03*G6_1_2_5_2_9_8_1 + 8.333333333333309e-03*G6_1_2_5_2_9_8_2 - 8.333333333333309e-03*G6_1_2_5_2_9_9_0 - 8.333333333333309e-03*G6_1_2_5_2_9_10_1 - 8.333333333333309e-03*G6_1_2_5_2_9_11_2 + 4.166666666666655e-03*G6_1_2_5_2_10_8_0 + 4.166666666666656e-03*G6_1_2_5_2_10_8_1 + 4.166666666666656e-03*G6_1_2_5_2_10_8_2 - 4.166666666666655e-03*G6_1_2_5_2_10_9_0 - 4.166666666666656e-03*G6_1_2_5_2_10_10_1 - 4.166666666666656e-03*G6_1_2_5_2_10_11_2 + 4.166666666666656e-03*G6_1_2_5_2_11_8_0 + 4.166666666666657e-03*G6_1_2_5_2_11_8_1 + 4.166666666666657e-03*G6_1_2_5_2_11_8_2 - 4.166666666666656e-03*G6_1_2_5_2_11_9_0 - 4.166666666666657e-03*G6_1_2_5_2_11_10_1 - 4.166666666666657e-03*G6_1_2_5_2_11_11_2 + 4.166666666666654e-03*G6_1_2_6_2_8_8_0 + 4.166666666666654e-03*G6_1_2_6_2_8_8_1 + 4.166666666666654e-03*G6_1_2_6_2_8_8_2 - 4.166666666666654e-03*G6_1_2_6_2_8_9_0 - 4.166666666666654e-03*G6_1_2_6_2_8_10_1 - 4.166666666666654e-03*G6_1_2_6_2_8_11_2 + 4.166666666666655e-03*G6_1_2_6_2_9_8_0 + 4.166666666666656e-03*G6_1_2_6_2_9_8_1 + 4.166666666666656e-03*G6_1_2_6_2_9_8_2 - 4.166666666666655e-03*G6_1_2_6_2_9_9_0 - 4.166666666666656e-03*G6_1_2_6_2_9_10_1 - 4.166666666666656e-03*G6_1_2_6_2_9_11_2 + 8.333333333333311e-03*G6_1_2_6_2_10_8_0 + 8.333333333333311e-03*G6_1_2_6_2_10_8_1 + 8.333333333333312e-03*G6_1_2_6_2_10_8_2 - 8.333333333333311e-03*G6_1_2_6_2_10_9_0 - 8.333333333333311e-03*G6_1_2_6_2_10_10_1 - 8.333333333333311e-03*G6_1_2_6_2_10_11_2 + 4.166666666666655e-03*G6_1_2_6_2_11_8_0 + 4.166666666666656e-03*G6_1_2_6_2_11_8_1 + 4.166666666666657e-03*G6_1_2_6_2_11_8_2 - 4.166666666666655e-03*G6_1_2_6_2_11_9_0 - 4.166666666666656e-03*G6_1_2_6_2_11_10_1 - 4.166666666666656e-03*G6_1_2_6_2_11_11_2 + 4.166666666666656e-03*G6_1_2_7_2_8_8_0 + 4.166666666666657e-03*G6_1_2_7_2_8_8_1 + 4.166666666666657e-03*G6_1_2_7_2_8_8_2 - 4.166666666666656e-03*G6_1_2_7_2_8_9_0 - 4.166666666666657e-03*G6_1_2_7_2_8_10_1 - 4.166666666666657e-03*G6_1_2_7_2_8_11_2 + 4.166666666666656e-03*G6_1_2_7_2_9_8_0 + 4.166666666666657e-03*G6_1_2_7_2_9_8_1 + 4.166666666666657e-03*G6_1_2_7_2_9_8_2 - 4.166666666666656e-03*G6_1_2_7_2_9_9_0 - 4.166666666666657e-03*G6_1_2_7_2_9_10_1 - 4.166666666666657e-03*G6_1_2_7_2_9_11_2 + 4.166666666666655e-03*G6_1_2_7_2_10_8_0 + 4.166666666666656e-03*G6_1_2_7_2_10_8_1 + 4.166666666666657e-03*G6_1_2_7_2_10_8_2 - 4.166666666666655e-03*G6_1_2_7_2_10_9_0 - 4.166666666666656e-03*G6_1_2_7_2_10_10_1 - 4.166666666666656e-03*G6_1_2_7_2_10_11_2 + 8.333333333333311e-03*G6_1_2_7_2_11_8_0 + 8.333333333333311e-03*G6_1_2_7_2_11_8_1 + 8.333333333333312e-03*G6_1_2_7_2_11_8_2 - 8.333333333333311e-03*G6_1_2_7_2_11_9_0 - 8.333333333333311e-03*G6_1_2_7_2_11_10_1 - 8.333333333333311e-03*G6_1_2_7_2_11_11_2 + 8.333333333333309e-03*G6_2_0_8_2_0_8_0 + 8.333333333333311e-03*G6_2_0_8_2_0_8_1 + 8.333333333333312e-03*G6_2_0_8_2_0_8_2 - 8.333333333333309e-03*G6_2_0_8_2_0_9_0 - 8.333333333333311e-03*G6_2_0_8_2_0_10_1 - 8.333333333333311e-03*G6_2_0_8_2_0_11_2 + 4.166666666666654e-03*G6_2_0_8_2_1_8_0 + 4.166666666666654e-03*G6_2_0_8_2_1_8_1 + 4.166666666666654e-03*G6_2_0_8_2_1_8_2 - 4.166666666666654e-03*G6_2_0_8_2_1_9_0 - 4.166666666666654e-03*G6_2_0_8_2_1_10_1 - 4.166666666666654e-03*G6_2_0_8_2_1_11_2 + 4.166666666666654e-03*G6_2_0_8_2_2_8_0 + 4.166666666666654e-03*G6_2_0_8_2_2_8_1 + 4.166666666666654e-03*G6_2_0_8_2_2_8_2 - 4.166666666666654e-03*G6_2_0_8_2_2_9_0 - 4.166666666666654e-03*G6_2_0_8_2_2_10_1 - 4.166666666666654e-03*G6_2_0_8_2_2_11_2 + 4.166666666666656e-03*G6_2_0_8_2_3_8_0 + 4.166666666666657e-03*G6_2_0_8_2_3_8_1 + 4.166666666666657e-03*G6_2_0_8_2_3_8_2 - 4.166666666666656e-03*G6_2_0_8_2_3_9_0 - 4.166666666666657e-03*G6_2_0_8_2_3_10_1 - 4.166666666666657e-03*G6_2_0_8_2_3_11_2 + 4.166666666666655e-03*G6_2_0_9_2_0_8_0 + 4.166666666666655e-03*G6_2_0_9_2_0_8_1 + 4.166666666666656e-03*G6_2_0_9_2_0_8_2 - 4.166666666666655e-03*G6_2_0_9_2_0_9_0 - 4.166666666666655e-03*G6_2_0_9_2_0_10_1 - 4.166666666666655e-03*G6_2_0_9_2_0_11_2 + 8.333333333333309e-03*G6_2_0_9_2_1_8_0 + 8.333333333333309e-03*G6_2_0_9_2_1_8_1 + 8.333333333333309e-03*G6_2_0_9_2_1_8_2 - 8.333333333333309e-03*G6_2_0_9_2_1_9_0 - 8.333333333333309e-03*G6_2_0_9_2_1_10_1 - 8.333333333333309e-03*G6_2_0_9_2_1_11_2 + 4.166666666666655e-03*G6_2_0_9_2_2_8_0 + 4.166666666666656e-03*G6_2_0_9_2_2_8_1 + 4.166666666666656e-03*G6_2_0_9_2_2_8_2 - 4.166666666666655e-03*G6_2_0_9_2_2_9_0 - 4.166666666666656e-03*G6_2_0_9_2_2_10_1 - 4.166666666666656e-03*G6_2_0_9_2_2_11_2 + 4.166666666666656e-03*G6_2_0_9_2_3_8_0 + 4.166666666666657e-03*G6_2_0_9_2_3_8_1 + 4.166666666666657e-03*G6_2_0_9_2_3_8_2 - 4.166666666666656e-03*G6_2_0_9_2_3_9_0 - 4.166666666666657e-03*G6_2_0_9_2_3_10_1 - 4.166666666666657e-03*G6_2_0_9_2_3_11_2 + 4.166666666666654e-03*G6_2_0_10_2_0_8_0 + 4.166666666666656e-03*G6_2_0_10_2_0_8_1 + 4.166666666666656e-03*G6_2_0_10_2_0_8_2 - 4.166666666666654e-03*G6_2_0_10_2_0_9_0 - 4.166666666666656e-03*G6_2_0_10_2_0_10_1 - 4.166666666666656e-03*G6_2_0_10_2_0_11_2 + 4.166666666666654e-03*G6_2_0_10_2_1_8_0 + 4.166666666666654e-03*G6_2_0_10_2_1_8_1 + 4.166666666666654e-03*G6_2_0_10_2_1_8_2 - 4.166666666666654e-03*G6_2_0_10_2_1_9_0 - 4.166666666666654e-03*G6_2_0_10_2_1_10_1 - 4.166666666666654e-03*G6_2_0_10_2_1_11_2 + 8.333333333333311e-03*G6_2_0_10_2_2_8_0 + 8.333333333333311e-03*G6_2_0_10_2_2_8_1 + 8.333333333333312e-03*G6_2_0_10_2_2_8_2 - 8.333333333333311e-03*G6_2_0_10_2_2_9_0 - 8.333333333333311e-03*G6_2_0_10_2_2_10_1 - 8.333333333333311e-03*G6_2_0_10_2_2_11_2 + 4.166666666666655e-03*G6_2_0_10_2_3_8_0 + 4.166666666666656e-03*G6_2_0_10_2_3_8_1 + 4.166666666666657e-03*G6_2_0_10_2_3_8_2 - 4.166666666666655e-03*G6_2_0_10_2_3_9_0 - 4.166666666666656e-03*G6_2_0_10_2_3_10_1 - 4.166666666666656e-03*G6_2_0_10_2_3_11_2 + 4.166666666666656e-03*G6_2_0_11_2_0_8_0 + 4.166666666666657e-03*G6_2_0_11_2_0_8_1 + 4.166666666666658e-03*G6_2_0_11_2_0_8_2 - 4.166666666666656e-03*G6_2_0_11_2_0_9_0 - 4.166666666666657e-03*G6_2_0_11_2_0_10_1 - 4.166666666666657e-03*G6_2_0_11_2_0_11_2 + 4.166666666666655e-03*G6_2_0_11_2_1_8_0 + 4.166666666666655e-03*G6_2_0_11_2_1_8_1 + 4.166666666666656e-03*G6_2_0_11_2_1_8_2 - 4.166666666666655e-03*G6_2_0_11_2_1_9_0 - 4.166666666666655e-03*G6_2_0_11_2_1_10_1 - 4.166666666666655e-03*G6_2_0_11_2_1_11_2 + 4.166666666666655e-03*G6_2_0_11_2_2_8_0 + 4.166666666666656e-03*G6_2_0_11_2_2_8_1 + 4.166666666666657e-03*G6_2_0_11_2_2_8_2 - 4.166666666666655e-03*G6_2_0_11_2_2_9_0 - 4.166666666666656e-03*G6_2_0_11_2_2_10_1 - 4.166666666666656e-03*G6_2_0_11_2_2_11_2 + 8.333333333333311e-03*G6_2_0_11_2_3_8_0 + 8.333333333333311e-03*G6_2_0_11_2_3_8_1 + 8.333333333333312e-03*G6_2_0_11_2_3_8_2 - 8.333333333333311e-03*G6_2_0_11_2_3_9_0 - 8.333333333333311e-03*G6_2_0_11_2_3_10_1 - 8.333333333333311e-03*G6_2_0_11_2_3_11_2 + 8.333333333333309e-03*G6_2_1_8_2_4_8_0 + 8.333333333333311e-03*G6_2_1_8_2_4_8_1 + 8.333333333333312e-03*G6_2_1_8_2_4_8_2 - 8.333333333333309e-03*G6_2_1_8_2_4_9_0 - 8.333333333333311e-03*G6_2_1_8_2_4_10_1 - 8.333333333333311e-03*G6_2_1_8_2_4_11_2 + 4.166666666666654e-03*G6_2_1_8_2_5_8_0 + 4.166666666666654e-03*G6_2_1_8_2_5_8_1 + 4.166666666666655e-03*G6_2_1_8_2_5_8_2 - 4.166666666666654e-03*G6_2_1_8_2_5_9_0 - 4.166666666666654e-03*G6_2_1_8_2_5_10_1 - 4.166666666666654e-03*G6_2_1_8_2_5_11_2 + 4.166666666666654e-03*G6_2_1_8_2_6_8_0 + 4.166666666666654e-03*G6_2_1_8_2_6_8_1 + 4.166666666666654e-03*G6_2_1_8_2_6_8_2 - 4.166666666666654e-03*G6_2_1_8_2_6_9_0 - 4.166666666666654e-03*G6_2_1_8_2_6_10_1 - 4.166666666666654e-03*G6_2_1_8_2_6_11_2 + 4.166666666666656e-03*G6_2_1_8_2_7_8_0 + 4.166666666666657e-03*G6_2_1_8_2_7_8_1 + 4.166666666666657e-03*G6_2_1_8_2_7_8_2 - 4.166666666666656e-03*G6_2_1_8_2_7_9_0 - 4.166666666666657e-03*G6_2_1_8_2_7_10_1 - 4.166666666666657e-03*G6_2_1_8_2_7_11_2 + 4.166666666666654e-03*G6_2_1_9_2_4_8_0 + 4.166666666666654e-03*G6_2_1_9_2_4_8_1 + 4.166666666666655e-03*G6_2_1_9_2_4_8_2 - 4.166666666666654e-03*G6_2_1_9_2_4_9_0 - 4.166666666666654e-03*G6_2_1_9_2_4_10_1 - 4.166666666666654e-03*G6_2_1_9_2_4_11_2 + 8.333333333333309e-03*G6_2_1_9_2_5_8_0 + 8.333333333333309e-03*G6_2_1_9_2_5_8_1 + 8.333333333333309e-03*G6_2_1_9_2_5_8_2 - 8.333333333333309e-03*G6_2_1_9_2_5_9_0 - 8.333333333333309e-03*G6_2_1_9_2_5_10_1 - 8.333333333333309e-03*G6_2_1_9_2_5_11_2 + 4.166666666666655e-03*G6_2_1_9_2_6_8_0 + 4.166666666666656e-03*G6_2_1_9_2_6_8_1 + 4.166666666666656e-03*G6_2_1_9_2_6_8_2 - 4.166666666666655e-03*G6_2_1_9_2_6_9_0 - 4.166666666666656e-03*G6_2_1_9_2_6_10_1 - 4.166666666666656e-03*G6_2_1_9_2_6_11_2 + 4.166666666666656e-03*G6_2_1_9_2_7_8_0 + 4.166666666666657e-03*G6_2_1_9_2_7_8_1 + 4.166666666666657e-03*G6_2_1_9_2_7_8_2 - 4.166666666666656e-03*G6_2_1_9_2_7_9_0 - 4.166666666666657e-03*G6_2_1_9_2_7_10_1 - 4.166666666666657e-03*G6_2_1_9_2_7_11_2 + 4.166666666666654e-03*G6_2_1_10_2_4_8_0 + 4.166666666666654e-03*G6_2_1_10_2_4_8_1 + 4.166666666666654e-03*G6_2_1_10_2_4_8_2 - 4.166666666666654e-03*G6_2_1_10_2_4_9_0 - 4.166666666666654e-03*G6_2_1_10_2_4_10_1 - 4.166666666666654e-03*G6_2_1_10_2_4_11_2 + 4.166666666666655e-03*G6_2_1_10_2_5_8_0 + 4.166666666666656e-03*G6_2_1_10_2_5_8_1 + 4.166666666666656e-03*G6_2_1_10_2_5_8_2 - 4.166666666666655e-03*G6_2_1_10_2_5_9_0 - 4.166666666666656e-03*G6_2_1_10_2_5_10_1 - 4.166666666666656e-03*G6_2_1_10_2_5_11_2 + 8.333333333333311e-03*G6_2_1_10_2_6_8_0 + 8.333333333333311e-03*G6_2_1_10_2_6_8_1 + 8.333333333333312e-03*G6_2_1_10_2_6_8_2 - 8.333333333333311e-03*G6_2_1_10_2_6_9_0 - 8.333333333333311e-03*G6_2_1_10_2_6_10_1 - 8.333333333333311e-03*G6_2_1_10_2_6_11_2 + 4.166666666666655e-03*G6_2_1_10_2_7_8_0 + 4.166666666666656e-03*G6_2_1_10_2_7_8_1 + 4.166666666666657e-03*G6_2_1_10_2_7_8_2 - 4.166666666666655e-03*G6_2_1_10_2_7_9_0 - 4.166666666666656e-03*G6_2_1_10_2_7_10_1 - 4.166666666666656e-03*G6_2_1_10_2_7_11_2 + 4.166666666666656e-03*G6_2_1_11_2_4_8_0 + 4.166666666666657e-03*G6_2_1_11_2_4_8_1 + 4.166666666666657e-03*G6_2_1_11_2_4_8_2 - 4.166666666666656e-03*G6_2_1_11_2_4_9_0 - 4.166666666666657e-03*G6_2_1_11_2_4_10_1 - 4.166666666666657e-03*G6_2_1_11_2_4_11_2 + 4.166666666666656e-03*G6_2_1_11_2_5_8_0 + 4.166666666666657e-03*G6_2_1_11_2_5_8_1 + 4.166666666666657e-03*G6_2_1_11_2_5_8_2 - 4.166666666666656e-03*G6_2_1_11_2_5_9_0 - 4.166666666666657e-03*G6_2_1_11_2_5_10_1 - 4.166666666666657e-03*G6_2_1_11_2_5_11_2 + 4.166666666666655e-03*G6_2_1_11_2_6_8_0 + 4.166666666666656e-03*G6_2_1_11_2_6_8_1 + 4.166666666666657e-03*G6_2_1_11_2_6_8_2 - 4.166666666666655e-03*G6_2_1_11_2_6_9_0 - 4.166666666666656e-03*G6_2_1_11_2_6_10_1 - 4.166666666666656e-03*G6_2_1_11_2_6_11_2 + 8.333333333333311e-03*G6_2_1_11_2_7_8_0 + 8.333333333333311e-03*G6_2_1_11_2_7_8_1 + 8.333333333333312e-03*G6_2_1_11_2_7_8_2 - 8.333333333333311e-03*G6_2_1_11_2_7_9_0 - 8.333333333333311e-03*G6_2_1_11_2_7_10_1 - 8.333333333333311e-03*G6_2_1_11_2_7_11_2 + 8.333333333333309e-03*G6_2_2_8_2_8_8_0 + 8.333333333333311e-03*G6_2_2_8_2_8_8_1 + 8.333333333333312e-03*G6_2_2_8_2_8_8_2 - 8.333333333333309e-03*G6_2_2_8_2_8_9_0 - 8.333333333333311e-03*G6_2_2_8_2_8_10_1 - 8.333333333333311e-03*G6_2_2_8_2_8_11_2 + 4.166666666666654e-03*G6_2_2_8_2_9_8_0 + 4.166666666666654e-03*G6_2_2_8_2_9_8_1 + 4.166666666666655e-03*G6_2_2_8_2_9_8_2 - 4.166666666666654e-03*G6_2_2_8_2_9_9_0 - 4.166666666666654e-03*G6_2_2_8_2_9_10_1 - 4.166666666666654e-03*G6_2_2_8_2_9_11_2 + 4.166666666666654e-03*G6_2_2_8_2_10_8_0 + 4.166666666666654e-03*G6_2_2_8_2_10_8_1 + 4.166666666666654e-03*G6_2_2_8_2_10_8_2 - 4.166666666666654e-03*G6_2_2_8_2_10_9_0 - 4.166666666666654e-03*G6_2_2_8_2_10_10_1 - 4.166666666666654e-03*G6_2_2_8_2_10_11_2 + 4.166666666666656e-03*G6_2_2_8_2_11_8_0 + 4.166666666666657e-03*G6_2_2_8_2_11_8_1 + 4.166666666666657e-03*G6_2_2_8_2_11_8_2 - 4.166666666666656e-03*G6_2_2_8_2_11_9_0 - 4.166666666666657e-03*G6_2_2_8_2_11_10_1 - 4.166666666666657e-03*G6_2_2_8_2_11_11_2 + 4.166666666666654e-03*G6_2_2_9_2_8_8_0 + 4.166666666666654e-03*G6_2_2_9_2_8_8_1 + 4.166666666666655e-03*G6_2_2_9_2_8_8_2 - 4.166666666666654e-03*G6_2_2_9_2_8_9_0 - 4.166666666666654e-03*G6_2_2_9_2_8_10_1 - 4.166666666666654e-03*G6_2_2_9_2_8_11_2 + 8.333333333333309e-03*G6_2_2_9_2_9_8_0 + 8.333333333333309e-03*G6_2_2_9_2_9_8_1 + 8.333333333333309e-03*G6_2_2_9_2_9_8_2 - 8.333333333333309e-03*G6_2_2_9_2_9_9_0 - 8.333333333333309e-03*G6_2_2_9_2_9_10_1 - 8.333333333333309e-03*G6_2_2_9_2_9_11_2 + 4.166666666666655e-03*G6_2_2_9_2_10_8_0 + 4.166666666666656e-03*G6_2_2_9_2_10_8_1 + 4.166666666666656e-03*G6_2_2_9_2_10_8_2 - 4.166666666666655e-03*G6_2_2_9_2_10_9_0 - 4.166666666666656e-03*G6_2_2_9_2_10_10_1 - 4.166666666666656e-03*G6_2_2_9_2_10_11_2 + 4.166666666666656e-03*G6_2_2_9_2_11_8_0 + 4.166666666666657e-03*G6_2_2_9_2_11_8_1 + 4.166666666666657e-03*G6_2_2_9_2_11_8_2 - 4.166666666666656e-03*G6_2_2_9_2_11_9_0 - 4.166666666666657e-03*G6_2_2_9_2_11_10_1 - 4.166666666666657e-03*G6_2_2_9_2_11_11_2 + 4.166666666666654e-03*G6_2_2_10_2_8_8_0 + 4.166666666666654e-03*G6_2_2_10_2_8_8_1 + 4.166666666666654e-03*G6_2_2_10_2_8_8_2 - 4.166666666666654e-03*G6_2_2_10_2_8_9_0 - 4.166666666666654e-03*G6_2_2_10_2_8_10_1 - 4.166666666666654e-03*G6_2_2_10_2_8_11_2 + 4.166666666666655e-03*G6_2_2_10_2_9_8_0 + 4.166666666666656e-03*G6_2_2_10_2_9_8_1 + 4.166666666666656e-03*G6_2_2_10_2_9_8_2 - 4.166666666666655e-03*G6_2_2_10_2_9_9_0 - 4.166666666666656e-03*G6_2_2_10_2_9_10_1 - 4.166666666666656e-03*G6_2_2_10_2_9_11_2 + 8.333333333333311e-03*G6_2_2_10_2_10_8_0 + 8.333333333333311e-03*G6_2_2_10_2_10_8_1 + 8.333333333333312e-03*G6_2_2_10_2_10_8_2 - 8.333333333333311e-03*G6_2_2_10_2_10_9_0 - 8.333333333333311e-03*G6_2_2_10_2_10_10_1 - 8.333333333333311e-03*G6_2_2_10_2_10_11_2 + 4.166666666666655e-03*G6_2_2_10_2_11_8_0 + 4.166666666666656e-03*G6_2_2_10_2_11_8_1 + 4.166666666666657e-03*G6_2_2_10_2_11_8_2 - 4.166666666666655e-03*G6_2_2_10_2_11_9_0 - 4.166666666666656e-03*G6_2_2_10_2_11_10_1 - 4.166666666666656e-03*G6_2_2_10_2_11_11_2 + 4.166666666666656e-03*G6_2_2_11_2_8_8_0 + 4.166666666666657e-03*G6_2_2_11_2_8_8_1 + 4.166666666666657e-03*G6_2_2_11_2_8_8_2 - 4.166666666666656e-03*G6_2_2_11_2_8_9_0 - 4.166666666666657e-03*G6_2_2_11_2_8_10_1 - 4.166666666666657e-03*G6_2_2_11_2_8_11_2 + 4.166666666666656e-03*G6_2_2_11_2_9_8_0 + 4.166666666666657e-03*G6_2_2_11_2_9_8_1 + 4.166666666666657e-03*G6_2_2_11_2_9_8_2 - 4.166666666666656e-03*G6_2_2_11_2_9_9_0 - 4.166666666666657e-03*G6_2_2_11_2_9_10_1 - 4.166666666666657e-03*G6_2_2_11_2_9_11_2 + 4.166666666666655e-03*G6_2_2_11_2_10_8_0 + 4.166666666666656e-03*G6_2_2_11_2_10_8_1 + 4.166666666666657e-03*G6_2_2_11_2_10_8_2 - 4.166666666666655e-03*G6_2_2_11_2_10_9_0 - 4.166666666666656e-03*G6_2_2_11_2_10_10_1 - 4.166666666666656e-03*G6_2_2_11_2_10_11_2 + 8.333333333333311e-03*G6_2_2_11_2_11_8_0 + 8.333333333333311e-03*G6_2_2_11_2_11_8_1 + 8.333333333333312e-03*G6_2_2_11_2_11_8_2 - 8.333333333333311e-03*G6_2_2_11_2_11_9_0 - 8.333333333333311e-03*G6_2_2_11_2_11_10_1 - 8.333333333333311e-03*G6_2_2_11_2_11_11_2 + 4.166666666666662e-02*G7_2_0_0_2_0_0 + 4.166666666666662e-02*G7_2_0_0_2_0_1 + 4.166666666666662e-02*G7_2_0_0_2_0_2 - 4.166666666666662e-02*G7_2_0_0_2_1_0 - 4.166666666666662e-02*G7_2_0_0_2_2_1 - 4.166666666666662e-02*G7_2_0_0_2_3_2 + 4.166666666666660e-02*G7_2_0_1_2_0_0 + 4.166666666666661e-02*G7_2_0_1_2_0_1 + 4.166666666666661e-02*G7_2_0_1_2_0_2 - 4.166666666666660e-02*G7_2_0_1_2_1_0 - 4.166666666666661e-02*G7_2_0_1_2_2_1 - 4.166666666666661e-02*G7_2_0_1_2_3_2 + 4.166666666666661e-02*G7_2_0_2_2_0_0 + 4.166666666666662e-02*G7_2_0_2_2_0_1 + 4.166666666666662e-02*G7_2_0_2_2_0_2 - 4.166666666666661e-02*G7_2_0_2_2_1_0 - 4.166666666666662e-02*G7_2_0_2_2_2_1 - 4.166666666666662e-02*G7_2_0_2_2_3_2 + 4.166666666666661e-02*G7_2_0_3_2_0_0 + 4.166666666666662e-02*G7_2_0_3_2_0_1 + 4.166666666666662e-02*G7_2_0_3_2_0_2 - 4.166666666666661e-02*G7_2_0_3_2_1_0 - 4.166666666666662e-02*G7_2_0_3_2_2_1 - 4.166666666666662e-02*G7_2_0_3_2_3_2 + 4.166666666666661e-02*G7_2_1_4_2_0_0 + 4.166666666666662e-02*G7_2_1_4_2_0_1 + 4.166666666666662e-02*G7_2_1_4_2_0_2 - 4.166666666666661e-02*G7_2_1_4_2_1_0 - 4.166666666666662e-02*G7_2_1_4_2_2_1 - 4.166666666666662e-02*G7_2_1_4_2_3_2 + 4.166666666666661e-02*G7_2_1_5_2_0_0 + 4.166666666666662e-02*G7_2_1_5_2_0_1 + 4.166666666666662e-02*G7_2_1_5_2_0_2 - 4.166666666666661e-02*G7_2_1_5_2_1_0 - 4.166666666666662e-02*G7_2_1_5_2_2_1 - 4.166666666666662e-02*G7_2_1_5_2_3_2 + 4.166666666666661e-02*G7_2_1_6_2_0_0 + 4.166666666666662e-02*G7_2_1_6_2_0_1 + 4.166666666666662e-02*G7_2_1_6_2_0_2 - 4.166666666666661e-02*G7_2_1_6_2_1_0 - 4.166666666666662e-02*G7_2_1_6_2_2_1 - 4.166666666666662e-02*G7_2_1_6_2_3_2 + 4.166666666666661e-02*G7_2_1_7_2_0_0 + 4.166666666666662e-02*G7_2_1_7_2_0_1 + 4.166666666666662e-02*G7_2_1_7_2_0_2 - 4.166666666666661e-02*G7_2_1_7_2_1_0 - 4.166666666666662e-02*G7_2_1_7_2_2_1 - 4.166666666666662e-02*G7_2_1_7_2_3_2 + 4.166666666666661e-02*G7_2_2_8_2_0_0 + 4.166666666666662e-02*G7_2_2_8_2_0_1 + 4.166666666666662e-02*G7_2_2_8_2_0_2 - 4.166666666666661e-02*G7_2_2_8_2_1_0 - 4.166666666666662e-02*G7_2_2_8_2_2_1 - 4.166666666666662e-02*G7_2_2_8_2_3_2 + 4.166666666666661e-02*G7_2_2_9_2_0_0 + 4.166666666666662e-02*G7_2_2_9_2_0_1 + 4.166666666666662e-02*G7_2_2_9_2_0_2 - 4.166666666666661e-02*G7_2_2_9_2_1_0 - 4.166666666666662e-02*G7_2_2_9_2_2_1 - 4.166666666666662e-02*G7_2_2_9_2_3_2 + 4.166666666666661e-02*G7_2_2_10_2_0_0 + 4.166666666666662e-02*G7_2_2_10_2_0_1 + 4.166666666666662e-02*G7_2_2_10_2_0_2 - 4.166666666666661e-02*G7_2_2_10_2_1_0 - 4.166666666666662e-02*G7_2_2_10_2_2_1 - 4.166666666666662e-02*G7_2_2_10_2_3_2 + 4.166666666666661e-02*G7_2_2_11_2_0_0 + 4.166666666666662e-02*G7_2_2_11_2_0_1 + 4.166666666666662e-02*G7_2_2_11_2_0_2 - 4.166666666666661e-02*G7_2_2_11_2_1_0 - 4.166666666666662e-02*G7_2_2_11_2_2_1 - 4.166666666666662e-02*G7_2_2_11_2_3_2 + 8.333333333333322e-02*G8_2_0_2_0_0 + 8.333333333333323e-02*G8_2_0_2_0_1 + 8.333333333333322e-02*G8_2_0_2_0_2 - 8.333333333333322e-02*G8_2_0_2_1_0 - 8.333333333333323e-02*G8_2_0_2_2_1 - 8.333333333333323e-02*G8_2_0_2_3_2 + 8.333333333333322e-02*G8_2_1_2_4_0 + 8.333333333333323e-02*G8_2_1_2_4_1 + 8.333333333333323e-02*G8_2_1_2_4_2 - 8.333333333333322e-02*G8_2_1_2_5_0 - 8.333333333333323e-02*G8_2_1_2_6_1 - 8.333333333333323e-02*G8_2_1_2_7_2 + 8.333333333333322e-02*G8_2_2_2_8_0 + 8.333333333333323e-02*G8_2_2_2_8_1 + 8.333333333333323e-02*G8_2_2_2_8_2 - 8.333333333333322e-02*G8_2_2_2_9_0 - 8.333333333333323e-02*G8_2_2_2_10_1 - 8.333333333333323e-02*G8_2_2_2_11_2;

    return true;
  }
        
private:

  const real& c0;  const real& c1;  const real& c2;

};

} }

#endif
